/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AMDGPU target                          *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 127;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AMDGPUInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AMDGPUInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AMDGPUInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AMDGPUInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(6),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s64,
  GILLT_p1s64,
  GILLT_p2s32,
  GILLT_p3s32,
  GILLT_p4s64,
  GILLT_p5s32,
  GILLT_p6s32,
  GILLT_s1,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s16,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v3s32,
  GILLT_v3s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v5s32,
  GILLT_v6s32,
  GILLT_v7s32,
  GILLT_v8s16,
  GILLT_v8s32,
  GILLT_v8s64,
  GILLT_v9s32,
  GILLT_v10s32,
  GILLT_v11s32,
  GILLT_v12s32,
  GILLT_v16s16,
  GILLT_v16s32,
  GILLT_v16s64,
  GILLT_v32s16,
  GILLT_v32s32,
};
const static size_t NumTypeObjects = 34;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 64),
  LLT::pointer(1, 64),
  LLT::pointer(2, 32),
  LLT::pointer(3, 32),
  LLT::pointer(4, 64),
  LLT::pointer(5, 32),
  LLT::pointer(6, 32),
  LLT::scalar(1),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 16),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(3), 32),
  LLT::vector(ElementCount::getFixed(3), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(5), 32),
  LLT::vector(ElementCount::getFixed(6), 32),
  LLT::vector(ElementCount::getFixed(7), 32),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 32),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(9), 32),
  LLT::vector(ElementCount::getFixed(10), 32),
  LLT::vector(ElementCount::getFixed(11), 32),
  LLT::vector(ElementCount::getFixed(12), 32),
  LLT::vector(ElementCount::getFixed(16), 16),
  LLT::vector(ElementCount::getFixed(16), 32),
  LLT::vector(ElementCount::getFixed(16), 64),
  LLT::vector(ElementCount::getFixed(32), 16),
  LLT::vector(ElementCount::getFixed(32), 32),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_FalsePredicateBit = 112,
  Feature_isGFX6Bit = 50,
  Feature_isGFX6GFX7Bit = 8,
  Feature_isGFX6GFX7GFX10Bit = 110,
  Feature_isGFX7OnlyBit = 84,
  Feature_isGFX7GFX8GFX9Bit = 45,
  Feature_isGFX6GFX7GFX8GFX9Bit = 66,
  Feature_isGFX6GFX7GFX8GFX9GFX10Bit = 123,
  Feature_isNotGFX12PlusBit = 19,
  Feature_isGFX8GFX9GFX10GFX11Bit = 21,
  Feature_isGFX7PlusBit = 13,
  Feature_isGFX8PlusBit = 4,
  Feature_isGFX8OnlyBit = 22,
  Feature_isGFX9PlusBit = 0,
  Feature_isNotGFX9PlusBit = 56,
  Feature_isGFX90APlusBit = 38,
  Feature_isNotGFX90APlusBit = 23,
  Feature_isGFX908orGFX90ABit = 39,
  Feature_isGFX940PlusBit = 40,
  Feature_isNotGFX940PlusBit = 51,
  Feature_HasGFX950InstsBit = 28,
  Feature_isGFX8GFX9Bit = 15,
  Feature_isGFX10OnlyBit = 62,
  Feature_isGFX10PlusBit = 5,
  Feature_isGFX9GFX10Bit = 57,
  Feature_isGFX11OnlyBit = 63,
  Feature_isGFX11PlusBit = 1,
  Feature_isGFX12OnlyBit = 64,
  Feature_isGFX12PlusBit = 3,
  Feature_HasMinimum3Maximum3F32Bit = 20,
  Feature_HasMinimum3Maximum3F16Bit = 25,
  Feature_HasMinimum3Maximum3PKF16Bit = 32,
  Feature_HasFlatAddressSpaceBit = 86,
  Feature_HasFlatBufferGlobalAtomicFaddF64InstBit = 102,
  Feature_HasAtomicFMinFMaxF32GlobalInstsBit = 96,
  Feature_HasAtomicFMinFMaxF64GlobalInstsBit = 101,
  Feature_HasAtomicFMinFMaxF32FlatInstsBit = 92,
  Feature_HasAtomicFMinFMaxF64FlatInstsBit = 93,
  Feature_HasLdsAtomicAddF64Bit = 126,
  Feature_HasFlatGlobalInstsBit = 87,
  Feature_HasFlatScratchInstsBit = 90,
  Feature_HasD16LoadStoreBit = 95,
  Feature_HasFlatScratchSVSModeBit = 91,
  Feature_HasGFX10_BEncodingBit = 49,
  Feature_HasUnpackedD16VMemBit = 106,
  Feature_HasPackedD16VMemBit = 107,
  Feature_HasUnrestrictedSOffsetBit = 105,
  Feature_D16PreservesUnusedBitsBit = 88,
  Feature_LDSRequiresM0InitBit = 119,
  Feature_NotLDSRequiresM0InitBit = 120,
  Feature_HasExportInstsBit = 7,
  Feature_HasLDSFPAtomicAddF32Bit = 125,
  Feature_HasAddNoCarryInstsBit = 65,
  Feature_NotHasAddNoCarryInstsBit = 117,
  Feature_HasXNACKEnabledBit = 83,
  Feature_Has16BitInstsBit = 9,
  Feature_NotHasTrue16BitInstsBit = 10,
  Feature_UseRealTrue16InstsBit = 11,
  Feature_UseFakeTrue16InstsBit = 12,
  Feature_HasVOP3PInstsBit = 77,
  Feature_HasMed3_16Bit = 118,
  Feature_HasMinMaxDenormModesBit = 111,
  Feature_NotHasMinMaxDenormModesBit = 113,
  Feature_HasSDWABit = 61,
  Feature_HasPackedFP32OpsBit = 43,
  Feature_HasImageInstsBit = 6,
  Feature_HasIntClampBit = 71,
  Feature_HasMadMixInstsBit = 78,
  Feature_HasScalarStoresBit = 46,
  Feature_has16BankLDSBit = 52,
  Feature_has32BankLDSBit = 24,
  Feature_HasFmaMixInstsBit = 80,
  Feature_HasDLInstsBit = 16,
  Feature_HasFmacF64InstBit = 116,
  Feature_HasDot1InstsBit = 36,
  Feature_HasDot2InstsBit = 33,
  Feature_HasDot3InstsBit = 70,
  Feature_HasDot4InstsBit = 69,
  Feature_HasDot5InstsBit = 67,
  Feature_HasDot6InstsBit = 68,
  Feature_HasDot7InstsBit = 35,
  Feature_HasDot8InstsBit = 81,
  Feature_HasDot9InstsBit = 29,
  Feature_HasDot10InstsBit = 34,
  Feature_HasDot11InstsBit = 82,
  Feature_HasGetWaveIdInstBit = 48,
  Feature_HasMAIInstsBit = 37,
  Feature_HasSMemRealTimeBit = 47,
  Feature_HasSMemTimeInstBit = 44,
  Feature_HasShaderCyclesRegisterBit = 85,
  Feature_HasShaderCyclesHiLoRegistersBit = 55,
  Feature_HasFP8InstsBit = 42,
  Feature_HasFP8ConversionInstsBit = 59,
  Feature_HasMadMacF32InstsBit = 17,
  Feature_HasFmaLegacy32Bit = 18,
  Feature_HasAtomicDsPkAdd16InstsBit = 124,
  Feature_HasAtomicFlatPkAdd16InstsBit = 104,
  Feature_HasAtomicFaddRtnInstsBit = 99,
  Feature_HasAtomicFaddNoRtnInstsBit = 97,
  Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit = 98,
  Feature_HasAtomicBufferGlobalPkAddF16InstsBit = 100,
  Feature_HasFlatAtomicFaddF32InstBit = 103,
  Feature_EnableFlatScratchBit = 89,
  Feature_DisableFlatScratchBit = 108,
  Feature_HasUnalignedAccessModeBit = 121,
  Feature_HasMADIntraFwdBugBit = 73,
  Feature_HasNotMADIntraFwdBugBit = 72,
  Feature_HasSALUFloatInstsBit = 2,
  Feature_NotHasSALUFloatInstsBit = 109,
  Feature_HasPseudoScalarTransBit = 30,
  Feature_HasBitOp3InstsBit = 75,
  Feature_HasPrngInstBit = 14,
  Feature_HasFP6BF6ConversionScaleInstsBit = 26,
  Feature_HasF16BF16ToFP6BF6ConversionScaleInstsBit = 27,
  Feature_HasCvtPkF16F32InstBit = 74,
  Feature_HasF32ToF16BF16ConversionSRInstsBit = 76,
  Feature_HasGDSBit = 122,
  Feature_HasCvtFP8VOP1BugBit = 58,
  Feature_HasNoCvtFP8VOP1BugBit = 60,
  Feature_HasAtomicCSubNoRtnInstsBit = 94,
  Feature_HasXF32InstsBit = 41,
  Feature_HasAshrPkInstsBit = 31,
  Feature_FP16DenormalsBit = 115,
  Feature_FP64DenormalsBit = 114,
  Feature_NoFP32DenormalsBit = 79,
  Feature_isWave32Bit = 53,
  Feature_isWave64Bit = 54,
};

PredicateBitset AMDGPUInstructionSelector::
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (false)
    Features.set(Feature_FalsePredicateBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS)
    Features.set(Feature_isGFX6Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS)
    Features.set(Feature_isGFX6GFX7Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX6GFX7GFX10Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS)
    Features.set(Feature_isGFX7OnlyBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX7GFX8GFX9Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX6GFX7GFX8GFX9Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX6GFX7GFX8GFX9GFX10Bit);
  if (Subtarget->getGeneration() <= AMDGPUSubtarget::GFX11)
    Features.set(Feature_isNotGFX12PlusBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX11)
    Features.set(Feature_isGFX8GFX9GFX10GFX11Bit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::SEA_ISLANDS)
    Features.set(Feature_isGFX7PlusBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::VOLCANIC_ISLANDS)
    Features.set(Feature_isGFX8PlusBit);
  if (Subtarget->getGeneration() ==AMDGPUSubtarget::VOLCANIC_ISLANDS)
    Features.set(Feature_isGFX8OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX9PlusBit);
  if (Subtarget->getGeneration() < AMDGPUSubtarget::GFX9)
    Features.set(Feature_isNotGFX9PlusBit);
  if (Subtarget->hasGFX90AInsts())
    Features.set(Feature_isGFX90APlusBit);
  if (!Subtarget->hasGFX90AInsts())
    Features.set(Feature_isNotGFX90APlusBit);
  if (Subtarget->hasMAIInsts() && !Subtarget->hasGFX940Insts())
    Features.set(Feature_isGFX908orGFX90ABit);
  if (Subtarget->hasGFX940Insts())
    Features.set(Feature_isGFX940PlusBit);
  if (!Subtarget->hasGFX940Insts())
    Features.set(Feature_isNotGFX940PlusBit);
  if (Subtarget->hasGFX950Insts())
    Features.set(Feature_HasGFX950InstsBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX8GFX9Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX10OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX10PlusBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX9 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX9GFX10Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX11)
    Features.set(Feature_isGFX11OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX11)
    Features.set(Feature_isGFX11PlusBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX12)
    Features.set(Feature_isGFX12OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX12)
    Features.set(Feature_isGFX12PlusBit);
  if (Subtarget->hasMinimum3Maximum3F32())
    Features.set(Feature_HasMinimum3Maximum3F32Bit);
  if (Subtarget->hasMinimum3Maximum3F16())
    Features.set(Feature_HasMinimum3Maximum3F16Bit);
  if (Subtarget->hasMinimum3Maximum3PKF16())
    Features.set(Feature_HasMinimum3Maximum3PKF16Bit);
  if (Subtarget->hasFlatAddressSpace())
    Features.set(Feature_HasFlatAddressSpaceBit);
  if (Subtarget->hasFlatBufferGlobalAtomicFaddF64Inst())
    Features.set(Feature_HasFlatBufferGlobalAtomicFaddF64InstBit);
  if (Subtarget->hasAtomicFMinFMaxF32GlobalInsts())
    Features.set(Feature_HasAtomicFMinFMaxF32GlobalInstsBit);
  if (Subtarget->hasAtomicFMinFMaxF64GlobalInsts())
    Features.set(Feature_HasAtomicFMinFMaxF64GlobalInstsBit);
  if (Subtarget->hasAtomicFMinFMaxF32FlatInsts())
    Features.set(Feature_HasAtomicFMinFMaxF32FlatInstsBit);
  if (Subtarget->hasAtomicFMinFMaxF64FlatInsts())
    Features.set(Feature_HasAtomicFMinFMaxF64FlatInstsBit);
  if (Subtarget->hasLdsAtomicAddF64())
    Features.set(Feature_HasLdsAtomicAddF64Bit);
  if (Subtarget->hasFlatGlobalInsts())
    Features.set(Feature_HasFlatGlobalInstsBit);
  if (Subtarget->hasFlatScratchInsts())
    Features.set(Feature_HasFlatScratchInstsBit);
  if (Subtarget->hasD16LoadStore())
    Features.set(Feature_HasD16LoadStoreBit);
  if (Subtarget->hasFlatScratchSVSMode())
    Features.set(Feature_HasFlatScratchSVSModeBit);
  if (Subtarget->hasGFX10_BEncoding())
    Features.set(Feature_HasGFX10_BEncodingBit);
  if (Subtarget->hasUnpackedD16VMem())
    Features.set(Feature_HasUnpackedD16VMemBit);
  if (!Subtarget->hasUnpackedD16VMem())
    Features.set(Feature_HasPackedD16VMemBit);
  if (!Subtarget->hasRestrictedSOffset())
    Features.set(Feature_HasUnrestrictedSOffsetBit);
  if (Subtarget->d16PreservesUnusedBits())
    Features.set(Feature_D16PreservesUnusedBitsBit);
  if (Subtarget->ldsRequiresM0Init())
    Features.set(Feature_LDSRequiresM0InitBit);
  if (!Subtarget->ldsRequiresM0Init())
    Features.set(Feature_NotLDSRequiresM0InitBit);
  if (Subtarget->hasExportInsts())
    Features.set(Feature_HasExportInstsBit);
  if (Subtarget->hasLDSFPAtomicAddF32())
    Features.set(Feature_HasLDSFPAtomicAddF32Bit);
  if (Subtarget->hasAddNoCarry())
    Features.set(Feature_HasAddNoCarryInstsBit);
  if (!Subtarget->hasAddNoCarry())
    Features.set(Feature_NotHasAddNoCarryInstsBit);
  if (Subtarget->isXNACKEnabled())
    Features.set(Feature_HasXNACKEnabledBit);
  if (Subtarget->has16BitInsts())
    Features.set(Feature_Has16BitInstsBit);
  if (!Subtarget->hasTrue16BitInsts())
    Features.set(Feature_NotHasTrue16BitInstsBit);
  if (Subtarget->useRealTrue16Insts())
    Features.set(Feature_UseRealTrue16InstsBit);
  if (Subtarget->hasTrue16BitInsts() && !Subtarget->useRealTrue16Insts())
    Features.set(Feature_UseFakeTrue16InstsBit);
  if (Subtarget->hasVOP3PInsts())
    Features.set(Feature_HasVOP3PInstsBit);
  if (Subtarget->hasMed3_16())
    Features.set(Feature_HasMed3_16Bit);
  if (Subtarget->supportsMinMaxDenormModes())
    Features.set(Feature_HasMinMaxDenormModesBit);
  if (!Subtarget->supportsMinMaxDenormModes())
    Features.set(Feature_NotHasMinMaxDenormModesBit);
  if (Subtarget->hasSDWA())
    Features.set(Feature_HasSDWABit);
  if (Subtarget->hasPackedFP32Ops())
    Features.set(Feature_HasPackedFP32OpsBit);
  if (Subtarget->hasImageInsts())
    Features.set(Feature_HasImageInstsBit);
  if (Subtarget->hasIntClamp())
    Features.set(Feature_HasIntClampBit);
  if (Subtarget->hasMadMixInsts())
    Features.set(Feature_HasMadMixInstsBit);
  if (Subtarget->hasScalarStores())
    Features.set(Feature_HasScalarStoresBit);
  if (Subtarget->getLDSBankCount() == 16)
    Features.set(Feature_has16BankLDSBit);
  if (Subtarget->getLDSBankCount() == 32)
    Features.set(Feature_has32BankLDSBit);
  if (Subtarget->hasFmaMixInsts())
    Features.set(Feature_HasFmaMixInstsBit);
  if (Subtarget->hasDLInsts())
    Features.set(Feature_HasDLInstsBit);
  if (Subtarget->hasFmacF64Inst())
    Features.set(Feature_HasFmacF64InstBit);
  if (Subtarget->hasDot1Insts())
    Features.set(Feature_HasDot1InstsBit);
  if (Subtarget->hasDot2Insts())
    Features.set(Feature_HasDot2InstsBit);
  if (Subtarget->hasDot3Insts())
    Features.set(Feature_HasDot3InstsBit);
  if (Subtarget->hasDot4Insts())
    Features.set(Feature_HasDot4InstsBit);
  if (Subtarget->hasDot5Insts())
    Features.set(Feature_HasDot5InstsBit);
  if (Subtarget->hasDot6Insts())
    Features.set(Feature_HasDot6InstsBit);
  if (Subtarget->hasDot7Insts())
    Features.set(Feature_HasDot7InstsBit);
  if (Subtarget->hasDot8Insts())
    Features.set(Feature_HasDot8InstsBit);
  if (Subtarget->hasDot9Insts())
    Features.set(Feature_HasDot9InstsBit);
  if (Subtarget->hasDot10Insts())
    Features.set(Feature_HasDot10InstsBit);
  if (Subtarget->hasDot11Insts())
    Features.set(Feature_HasDot11InstsBit);
  if (Subtarget->hasGetWaveIdInst())
    Features.set(Feature_HasGetWaveIdInstBit);
  if (Subtarget->hasMAIInsts())
    Features.set(Feature_HasMAIInstsBit);
  if (Subtarget->hasSMemRealTime())
    Features.set(Feature_HasSMemRealTimeBit);
  if (Subtarget->hasSMemTimeInst())
    Features.set(Feature_HasSMemTimeInstBit);
  if (Subtarget->hasShaderCyclesRegister())
    Features.set(Feature_HasShaderCyclesRegisterBit);
  if (Subtarget->hasShaderCyclesHiLoRegisters())
    Features.set(Feature_HasShaderCyclesHiLoRegistersBit);
  if (Subtarget->hasFP8Insts())
    Features.set(Feature_HasFP8InstsBit);
  if (Subtarget->hasFP8ConversionInsts())
    Features.set(Feature_HasFP8ConversionInstsBit);
  if (Subtarget->hasMadMacF32Insts())
    Features.set(Feature_HasMadMacF32InstsBit);
  if (Subtarget->hasGFX10_3Insts())
    Features.set(Feature_HasFmaLegacy32Bit);
  if (Subtarget->hasAtomicDsPkAdd16Insts())
    Features.set(Feature_HasAtomicDsPkAdd16InstsBit);
  if (Subtarget->hasAtomicFlatPkAdd16Insts())
    Features.set(Feature_HasAtomicFlatPkAdd16InstsBit);
  if (Subtarget->hasAtomicFaddRtnInsts())
    Features.set(Feature_HasAtomicFaddRtnInstsBit);
  if (Subtarget->hasAtomicFaddNoRtnInsts())
    Features.set(Feature_HasAtomicFaddNoRtnInstsBit);
  if (Subtarget->hasAtomicBufferGlobalPkAddF16NoRtnInsts() || Subtarget->hasAtomicBufferGlobalPkAddF16Insts())
    Features.set(Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit);
  if (Subtarget->hasAtomicBufferGlobalPkAddF16Insts())
    Features.set(Feature_HasAtomicBufferGlobalPkAddF16InstsBit);
  if (Subtarget->hasFlatAtomicFaddF32Inst())
    Features.set(Feature_HasFlatAtomicFaddF32InstBit);
  if (Subtarget->enableFlatScratch())
    Features.set(Feature_EnableFlatScratchBit);
  if (!Subtarget->enableFlatScratch())
    Features.set(Feature_DisableFlatScratchBit);
  if (Subtarget->hasUnalignedAccessMode())
    Features.set(Feature_HasUnalignedAccessModeBit);
  if (Subtarget->hasMADIntraFwdBug())
    Features.set(Feature_HasMADIntraFwdBugBit);
  if (!Subtarget->hasMADIntraFwdBug())
    Features.set(Feature_HasNotMADIntraFwdBugBit);
  if (Subtarget->hasSALUFloatInsts())
    Features.set(Feature_HasSALUFloatInstsBit);
  if (!Subtarget->hasSALUFloatInsts())
    Features.set(Feature_NotHasSALUFloatInstsBit);
  if (Subtarget->hasPseudoScalarTrans())
    Features.set(Feature_HasPseudoScalarTransBit);
  if (Subtarget->hasBitOp3Insts())
    Features.set(Feature_HasBitOp3InstsBit);
  if (Subtarget->hasPrngInst())
    Features.set(Feature_HasPrngInstBit);
  if (Subtarget->hasFP6BF6ConversionScaleInsts())
    Features.set(Feature_HasFP6BF6ConversionScaleInstsBit);
  if (Subtarget->hasF16BF16ToFP6BF6ConversionScaleInsts())
    Features.set(Feature_HasF16BF16ToFP6BF6ConversionScaleInstsBit);
  if (Subtarget->hasCvtPkF16F32Inst())
    Features.set(Feature_HasCvtPkF16F32InstBit);
  if (Subtarget->hasF32ToF16BF16ConversionSRInsts())
    Features.set(Feature_HasF32ToF16BF16ConversionSRInstsBit);
  if (Subtarget->hasGDS())
    Features.set(Feature_HasGDSBit);
  if (Subtarget->hasCvtFP8VOP1Bug())
    Features.set(Feature_HasCvtFP8VOP1BugBit);
  if (!Subtarget->hasCvtFP8VOP1Bug())
    Features.set(Feature_HasNoCvtFP8VOP1BugBit);
  if (Subtarget->hasAtomicCSubNoRtnInsts())
    Features.set(Feature_HasAtomicCSubNoRtnInstsBit);
  if (Subtarget->hasXF32Insts())
    Features.set(Feature_HasXF32InstsBit);
  if (Subtarget->hasAshrPkInsts())
    Features.set(Feature_HasAshrPkInstsBit);
  if (Subtarget->isWave32())
    Features.set(Feature_isWave32Bit);
  if (Subtarget->isWave64())
    Features.set(Feature_isWave64Bit);
  return Features;
}

void AMDGPUInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AMDGPUSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AMDGPUInstructionSelector::
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (MF->getInfo<SIMachineFunctionInfo>()->getMode().FP64FP16Denormals != DenormalMode::getPreserveSign())
    Features.set(Feature_FP16DenormalsBit);
  if (MF->getInfo<SIMachineFunctionInfo>()->getMode().FP64FP16Denormals != DenormalMode::getPreserveSign())
    Features.set(Feature_FP64DenormalsBit);
  if (MF->getInfo<SIMachineFunctionInfo>()->getMode().FP32Denormals == DenormalMode::getPreserveSign())
    Features.set(Feature_NoFP32DenormalsBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_DisableFlatScratch,
  GIFBS_Has16BitInsts,
  GIFBS_HasAddNoCarryInsts,
  GIFBS_HasAshrPkInsts,
  GIFBS_HasAtomicBufferGlobalPkAddF16Insts,
  GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts,
  GIFBS_HasAtomicCSubNoRtnInsts,
  GIFBS_HasAtomicFMinFMaxF32GlobalInsts,
  GIFBS_HasAtomicFMinFMaxF64GlobalInsts,
  GIFBS_HasAtomicFaddNoRtnInsts,
  GIFBS_HasAtomicFaddRtnInsts,
  GIFBS_HasAtomicFlatPkAdd16Insts,
  GIFBS_HasBitOp3Insts,
  GIFBS_HasCvtPkF16F32Inst,
  GIFBS_HasD16LoadStore,
  GIFBS_HasDLInsts,
  GIFBS_HasDot10Insts,
  GIFBS_HasDot1Insts,
  GIFBS_HasDot2Insts,
  GIFBS_HasDot3Insts,
  GIFBS_HasDot4Insts,
  GIFBS_HasDot5Insts,
  GIFBS_HasDot6Insts,
  GIFBS_HasDot7Insts,
  GIFBS_HasDot8Insts,
  GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts,
  GIFBS_HasF32ToF16BF16ConversionSRInsts,
  GIFBS_HasFP6BF6ConversionScaleInsts,
  GIFBS_HasFP8Insts,
  GIFBS_HasFlatAddressSpace,
  GIFBS_HasFlatAtomicFaddF32Inst,
  GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst,
  GIFBS_HasFlatGlobalInsts,
  GIFBS_HasFmaLegacy32,
  GIFBS_HasFmaMixInsts,
  GIFBS_HasFmacF64Inst,
  GIFBS_HasGDS,
  GIFBS_HasGFX10_BEncoding,
  GIFBS_HasGFX950Insts,
  GIFBS_HasGetWaveIdInst,
  GIFBS_HasIntClamp,
  GIFBS_HasLdsAtomicAddF64,
  GIFBS_HasMAIInsts,
  GIFBS_HasMadMacF32Insts,
  GIFBS_HasMinMaxDenormModes,
  GIFBS_HasMinimum3Maximum3F32,
  GIFBS_HasMinimum3Maximum3PKF16,
  GIFBS_HasPackedD16VMem,
  GIFBS_HasPackedFP32Ops,
  GIFBS_HasPrngInst,
  GIFBS_HasPseudoScalarTrans,
  GIFBS_HasSALUFloatInsts,
  GIFBS_HasSMemRealTime,
  GIFBS_HasSMemTimeInst,
  GIFBS_HasShaderCyclesHiLoRegisters,
  GIFBS_HasShaderCyclesRegister,
  GIFBS_HasUnpackedD16VMem,
  GIFBS_HasUnrestrictedSOffset,
  GIFBS_HasVOP3PInsts,
  GIFBS_HasXF32Insts,
  GIFBS_HasXNACKEnabled,
  GIFBS_LDSRequiresM0Init,
  GIFBS_NotHasAddNoCarryInsts,
  GIFBS_NotHasTrue16BitInsts,
  GIFBS_NotLDSRequiresM0Init,
  GIFBS_UseFakeTrue16Insts,
  GIFBS_UseRealTrue16Insts,
  GIFBS_isGFX10Only,
  GIFBS_isGFX10Plus,
  GIFBS_isGFX11Only,
  GIFBS_isGFX11Plus,
  GIFBS_isGFX12Only,
  GIFBS_isGFX12Plus,
  GIFBS_isGFX6,
  GIFBS_isGFX6GFX7,
  GIFBS_isGFX6GFX7GFX8GFX9,
  GIFBS_isGFX7GFX8GFX9,
  GIFBS_isGFX7Only,
  GIFBS_isGFX7Plus,
  GIFBS_isGFX8GFX9,
  GIFBS_isGFX8GFX9GFX10GFX11,
  GIFBS_isGFX8Plus,
  GIFBS_isGFX908orGFX90A,
  GIFBS_isGFX90APlus,
  GIFBS_isGFX940Plus,
  GIFBS_isGFX9GFX10,
  GIFBS_isGFX9Plus,
  GIFBS_isNotGFX12Plus,
  GIFBS_isNotGFX90APlus,
  GIFBS_isNotGFX940Plus,
  GIFBS_isNotGFX9Plus,
  GIFBS_isWave32,
  GIFBS_isWave64,
  GIFBS_DisableFlatScratch_HasD16LoadStore,
  GIFBS_DisableFlatScratch_HasUnrestrictedSOffset,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts,
  GIFBS_FP16Denormals_NotHasMinMaxDenormModes,
  GIFBS_FalsePredicate_NotHasMinMaxDenormModes,
  GIFBS_Has16BitInsts_HasIntClamp,
  GIFBS_Has16BitInsts_NotHasTrue16BitInsts,
  GIFBS_Has16BitInsts_UseFakeTrue16Insts,
  GIFBS_Has16BitInsts_UseRealTrue16Insts,
  GIFBS_Has16BitInsts_isGFX6GFX7GFX8GFX9,
  GIFBS_Has16BitInsts_isGFX8GFX9,
  GIFBS_Has16BitInsts_isGFX8Only,
  GIFBS_Has16BitInsts_isNotGFX90APlus,
  GIFBS_HasAddNoCarryInsts_HasIntClamp,
  GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus,
  GIFBS_HasAtomicDsPkAdd16Insts_HasGDS,
  GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init,
  GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init,
  GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace,
  GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts,
  GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts,
  GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace,
  GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts,
  GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset,
  GIFBS_HasCvtFP8VOP1Bug_HasFP8ConversionInsts,
  GIFBS_HasDot11Insts_isGFX12Plus,
  GIFBS_HasDot9Insts_NotHasTrue16BitInsts,
  GIFBS_HasDot9Insts_UseFakeTrue16Insts,
  GIFBS_HasDot9Insts_UseRealTrue16Insts,
  GIFBS_HasExportInsts_isGFX12Plus,
  GIFBS_HasFP8ConversionInsts_HasSDWA,
  GIFBS_HasFP8ConversionInsts_isGFX12Plus,
  GIFBS_HasFP8ConversionInsts_isGFX940Plus,
  GIFBS_HasFP8ConversionInsts_isGFX9Plus,
  GIFBS_HasFP8Insts_isGFX90APlus,
  GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts,
  GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts,
  GIFBS_HasFlatAddressSpace_isGFX12Plus,
  GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset,
  GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts,
  GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts,
  GIFBS_HasFlatGlobalInsts_isGFX12Plus,
  GIFBS_HasFmaMixInsts_NotHasTrue16BitInsts,
  GIFBS_HasFmaMixInsts_UseFakeTrue16Insts,
  GIFBS_HasFmaMixInsts_UseRealTrue16Insts,
  GIFBS_HasGDS_HasLDSFPAtomicAddF32,
  GIFBS_HasGDS_isGFX11Plus,
  GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10,
  GIFBS_HasGFX950Insts_isGFX90APlus,
  GIFBS_HasImageInsts_isGFX12Plus,
  GIFBS_HasLDSFPAtomicAddF32_LDSRequiresM0Init,
  GIFBS_HasLDSFPAtomicAddF32_NotLDSRequiresM0Init,
  GIFBS_HasMADIntraFwdBug_isGFX11Only,
  GIFBS_HasMAIInsts_isGFX90APlus,
  GIFBS_HasMadMacF32Insts_NoFP32Denormals,
  GIFBS_HasMadMixInsts_NoFP32Denormals,
  GIFBS_HasMed3_16_NotHasTrue16BitInsts,
  GIFBS_HasMed3_16_UseFakeTrue16Insts,
  GIFBS_HasMed3_16_UseRealTrue16Insts,
  GIFBS_HasMinMaxDenormModes_isGFX12Plus,
  GIFBS_HasMinMaxDenormModes_isNotGFX12Plus,
  GIFBS_HasNotMADIntraFwdBug_isGFX9Plus,
  GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset,
  GIFBS_HasScalarStores_isGFX8Plus,
  GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init,
  GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init,
  GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts,
  GIFBS_HasVOP3PInsts_UseFakeTrue16Insts,
  GIFBS_HasVOP3PInsts_UseRealTrue16Insts,
  GIFBS_HasXF32Insts_isGFX90APlus,
  GIFBS_HasXNACKEnabled_isGFX7Only,
  GIFBS_HasXNACKEnabled_isGFX9Plus,
  GIFBS_HasXNACKEnabled_isNotGFX9Plus,
  GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10,
  GIFBS_LDSRequiresM0Init_isGFX7Plus,
  GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init,
  GIFBS_NotHasTrue16BitInsts_isGFX10Plus,
  GIFBS_NotHasTrue16BitInsts_isGFX12Plus,
  GIFBS_NotHasTrue16BitInsts_isGFX8Plus,
  GIFBS_NotHasTrue16BitInsts_isGFX9Plus,
  GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts,
  GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts,
  GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10,
  GIFBS_NotLDSRequiresM0Init_isGFX7Plus,
  GIFBS_UseFakeTrue16Insts_isGFX10Plus,
  GIFBS_UseFakeTrue16Insts_isGFX12Plus,
  GIFBS_UseFakeTrue16Insts_isGFX8Plus,
  GIFBS_UseFakeTrue16Insts_isGFX9Plus,
  GIFBS_UseRealTrue16Insts_isGFX10Plus,
  GIFBS_UseRealTrue16Insts_isGFX12Plus,
  GIFBS_UseRealTrue16Insts_isGFX8Plus,
  GIFBS_UseRealTrue16Insts_isGFX9Plus,
  GIFBS_has16BankLDS_isNotGFX90APlus,
  GIFBS_has32BankLDS_isNotGFX90APlus,
  GIFBS_isGFX11Only_isWave32,
  GIFBS_isGFX11Only_isWave64,
  GIFBS_isGFX12Plus_isWave32,
  GIFBS_isGFX12Plus_isWave64,
  GIFBS_isGFX90APlus_isGFX908orGFX90A,
  GIFBS_isGFX90APlus_isGFX940Plus,
  GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts,
  GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts,
  GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset,
  GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts,
  GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isGFX12Plus,
  GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isNotGFX12Plus,
  GIFBS_Has16BitInsts_HasMinMaxDenormModes_NotHasTrue16BitInsts,
  GIFBS_Has16BitInsts_HasMinMaxDenormModes_UseFakeTrue16Insts,
  GIFBS_Has16BitInsts_HasMinMaxDenormModes_UseRealTrue16Insts,
  GIFBS_Has16BitInsts_NotHasTrue16BitInsts_isGFX10Plus,
  GIFBS_Has16BitInsts_has32BankLDS_isNotGFX90APlus,
  GIFBS_HasFP8ConversionInsts_HasNoCvtFP8VOP1Bug_HasSDWA,
  GIFBS_HasMadMacF32Insts_NoFP32Denormals_isGFX6GFX7GFX10,
  GIFBS_HasMadMixInsts_NoFP32Denormals_NotHasTrue16BitInsts,
  GIFBS_HasMadMixInsts_NoFP32Denormals_UseFakeTrue16Insts,
  GIFBS_HasMadMixInsts_NoFP32Denormals_UseRealTrue16Insts,
  GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts_HasFlatScratchSVSMode,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts,
  GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_NotHasTrue16BitInsts,
  GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_UseFakeTrue16Insts,
  GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_UseRealTrue16Insts,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_DisableFlatScratchBit, },
  {Feature_Has16BitInstsBit, },
  {Feature_HasAddNoCarryInstsBit, },
  {Feature_HasAshrPkInstsBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16InstsBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit, },
  {Feature_HasAtomicCSubNoRtnInstsBit, },
  {Feature_HasAtomicFMinFMaxF32GlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF64GlobalInstsBit, },
  {Feature_HasAtomicFaddNoRtnInstsBit, },
  {Feature_HasAtomicFaddRtnInstsBit, },
  {Feature_HasAtomicFlatPkAdd16InstsBit, },
  {Feature_HasBitOp3InstsBit, },
  {Feature_HasCvtPkF16F32InstBit, },
  {Feature_HasD16LoadStoreBit, },
  {Feature_HasDLInstsBit, },
  {Feature_HasDot10InstsBit, },
  {Feature_HasDot1InstsBit, },
  {Feature_HasDot2InstsBit, },
  {Feature_HasDot3InstsBit, },
  {Feature_HasDot4InstsBit, },
  {Feature_HasDot5InstsBit, },
  {Feature_HasDot6InstsBit, },
  {Feature_HasDot7InstsBit, },
  {Feature_HasDot8InstsBit, },
  {Feature_HasF16BF16ToFP6BF6ConversionScaleInstsBit, },
  {Feature_HasF32ToF16BF16ConversionSRInstsBit, },
  {Feature_HasFP6BF6ConversionScaleInstsBit, },
  {Feature_HasFP8InstsBit, },
  {Feature_HasFlatAddressSpaceBit, },
  {Feature_HasFlatAtomicFaddF32InstBit, },
  {Feature_HasFlatBufferGlobalAtomicFaddF64InstBit, },
  {Feature_HasFlatGlobalInstsBit, },
  {Feature_HasFmaLegacy32Bit, },
  {Feature_HasFmaMixInstsBit, },
  {Feature_HasFmacF64InstBit, },
  {Feature_HasGDSBit, },
  {Feature_HasGFX10_BEncodingBit, },
  {Feature_HasGFX950InstsBit, },
  {Feature_HasGetWaveIdInstBit, },
  {Feature_HasIntClampBit, },
  {Feature_HasLdsAtomicAddF64Bit, },
  {Feature_HasMAIInstsBit, },
  {Feature_HasMadMacF32InstsBit, },
  {Feature_HasMinMaxDenormModesBit, },
  {Feature_HasMinimum3Maximum3F32Bit, },
  {Feature_HasMinimum3Maximum3PKF16Bit, },
  {Feature_HasPackedD16VMemBit, },
  {Feature_HasPackedFP32OpsBit, },
  {Feature_HasPrngInstBit, },
  {Feature_HasPseudoScalarTransBit, },
  {Feature_HasSALUFloatInstsBit, },
  {Feature_HasSMemRealTimeBit, },
  {Feature_HasSMemTimeInstBit, },
  {Feature_HasShaderCyclesHiLoRegistersBit, },
  {Feature_HasShaderCyclesRegisterBit, },
  {Feature_HasUnpackedD16VMemBit, },
  {Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasVOP3PInstsBit, },
  {Feature_HasXF32InstsBit, },
  {Feature_HasXNACKEnabledBit, },
  {Feature_LDSRequiresM0InitBit, },
  {Feature_NotHasAddNoCarryInstsBit, },
  {Feature_NotHasTrue16BitInstsBit, },
  {Feature_NotLDSRequiresM0InitBit, },
  {Feature_UseFakeTrue16InstsBit, },
  {Feature_UseRealTrue16InstsBit, },
  {Feature_isGFX10OnlyBit, },
  {Feature_isGFX10PlusBit, },
  {Feature_isGFX11OnlyBit, },
  {Feature_isGFX11PlusBit, },
  {Feature_isGFX12OnlyBit, },
  {Feature_isGFX12PlusBit, },
  {Feature_isGFX6Bit, },
  {Feature_isGFX6GFX7Bit, },
  {Feature_isGFX6GFX7GFX8GFX9Bit, },
  {Feature_isGFX7GFX8GFX9Bit, },
  {Feature_isGFX7OnlyBit, },
  {Feature_isGFX7PlusBit, },
  {Feature_isGFX8GFX9Bit, },
  {Feature_isGFX8GFX9GFX10GFX11Bit, },
  {Feature_isGFX8PlusBit, },
  {Feature_isGFX908orGFX90ABit, },
  {Feature_isGFX90APlusBit, },
  {Feature_isGFX940PlusBit, },
  {Feature_isGFX9GFX10Bit, },
  {Feature_isGFX9PlusBit, },
  {Feature_isNotGFX12PlusBit, },
  {Feature_isNotGFX90APlusBit, },
  {Feature_isNotGFX940PlusBit, },
  {Feature_isNotGFX9PlusBit, },
  {Feature_isWave32Bit, },
  {Feature_isWave64Bit, },
  {Feature_DisableFlatScratchBit, Feature_HasD16LoadStoreBit, },
  {Feature_DisableFlatScratchBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, },
  {Feature_FP16DenormalsBit, Feature_NotHasMinMaxDenormModesBit, },
  {Feature_FalsePredicateBit, Feature_NotHasMinMaxDenormModesBit, },
  {Feature_Has16BitInstsBit, Feature_HasIntClampBit, },
  {Feature_Has16BitInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_Has16BitInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_isGFX6GFX7GFX8GFX9Bit, },
  {Feature_Has16BitInstsBit, Feature_isGFX8GFX9Bit, },
  {Feature_Has16BitInstsBit, Feature_isGFX8OnlyBit, },
  {Feature_Has16BitInstsBit, Feature_isNotGFX90APlusBit, },
  {Feature_HasAddNoCarryInstsBit, Feature_HasIntClampBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16InstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicCSubNoRtnInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasAtomicDsPkAdd16InstsBit, Feature_HasGDSBit, },
  {Feature_HasAtomicDsPkAdd16InstsBit, Feature_LDSRequiresM0InitBit, },
  {Feature_HasAtomicDsPkAdd16InstsBit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_HasAtomicFMinFMaxF32FlatInstsBit, Feature_HasFlatAddressSpaceBit, },
  {Feature_HasAtomicFMinFMaxF32FlatInstsBit, Feature_HasFlatGlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF32GlobalInstsBit, Feature_HasFlatGlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF32GlobalInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicFMinFMaxF64FlatInstsBit, Feature_HasFlatAddressSpaceBit, },
  {Feature_HasAtomicFMinFMaxF64GlobalInstsBit, Feature_HasFlatGlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF64GlobalInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicFaddNoRtnInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicFaddRtnInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasCvtFP8VOP1BugBit, Feature_HasFP8ConversionInstsBit, },
  {Feature_HasDot11InstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasDot9InstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasDot9InstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasDot9InstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_HasExportInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_HasSDWABit, },
  {Feature_HasFP8ConversionInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_isGFX940PlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_isGFX9PlusBit, },
  {Feature_HasFP8InstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasFlatAddressSpaceBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasFlatAddressSpaceBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasFlatAddressSpaceBit, Feature_isGFX12PlusBit, },
  {Feature_HasFlatBufferGlobalAtomicFaddF64InstBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasFlatGlobalInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasFlatGlobalInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasFlatGlobalInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasFmaMixInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasFmaMixInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasFmaMixInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_HasGDSBit, Feature_HasLDSFPAtomicAddF32Bit, },
  {Feature_HasGDSBit, Feature_isGFX11PlusBit, },
  {Feature_HasGDSBit, Feature_isGFX6GFX7GFX8GFX9GFX10Bit, },
  {Feature_HasGFX950InstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasImageInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasLDSFPAtomicAddF32Bit, Feature_LDSRequiresM0InitBit, },
  {Feature_HasLDSFPAtomicAddF32Bit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_HasMADIntraFwdBugBit, Feature_isGFX11OnlyBit, },
  {Feature_HasMAIInstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasMadMacF32InstsBit, Feature_NoFP32DenormalsBit, },
  {Feature_HasMadMixInstsBit, Feature_NoFP32DenormalsBit, },
  {Feature_HasMed3_16Bit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasMed3_16Bit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasMed3_16Bit, Feature_UseRealTrue16InstsBit, },
  {Feature_HasMinMaxDenormModesBit, Feature_isGFX12PlusBit, },
  {Feature_HasMinMaxDenormModesBit, Feature_isNotGFX12PlusBit, },
  {Feature_HasNotMADIntraFwdBugBit, Feature_isGFX9PlusBit, },
  {Feature_HasPackedD16VMemBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasScalarStoresBit, Feature_isGFX8PlusBit, },
  {Feature_HasUnalignedAccessModeBit, Feature_LDSRequiresM0InitBit, },
  {Feature_HasUnalignedAccessModeBit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_HasVOP3PInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasVOP3PInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasVOP3PInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_HasXF32InstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasXNACKEnabledBit, Feature_isGFX7OnlyBit, },
  {Feature_HasXNACKEnabledBit, Feature_isGFX9PlusBit, },
  {Feature_HasXNACKEnabledBit, Feature_isNotGFX9PlusBit, },
  {Feature_LDSRequiresM0InitBit, Feature_isGFX6GFX7GFX8GFX9GFX10Bit, },
  {Feature_LDSRequiresM0InitBit, Feature_isGFX7PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX10PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX12PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX8PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX9PlusBit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_UseRealTrue16InstsBit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_isGFX6GFX7GFX8GFX9GFX10Bit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_isGFX7PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX10PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX12PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX8PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX9PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX10PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX12PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX8PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX9PlusBit, },
  {Feature_has16BankLDSBit, Feature_isNotGFX90APlusBit, },
  {Feature_has32BankLDSBit, Feature_isNotGFX90APlusBit, },
  {Feature_isGFX11OnlyBit, Feature_isWave32Bit, },
  {Feature_isGFX11OnlyBit, Feature_isWave64Bit, },
  {Feature_isGFX12PlusBit, Feature_isWave32Bit, },
  {Feature_isGFX12PlusBit, Feature_isWave64Bit, },
  {Feature_isGFX90APlusBit, Feature_isGFX908orGFX90ABit, },
  {Feature_isGFX90APlusBit, Feature_isGFX940PlusBit, },
  {Feature_D16PreservesUnusedBitsBit, Feature_HasFlatAddressSpaceBit, Feature_UseRealTrue16InstsBit, },
  {Feature_D16PreservesUnusedBitsBit, Feature_HasFlatGlobalInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_DisableFlatScratchBit, Feature_HasD16LoadStoreBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_EnableFlatScratchBit, Feature_HasD16LoadStoreBit, Feature_HasFlatScratchInstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_FP64DenormalsBit, Feature_NotHasMinMaxDenormModesBit, Feature_isGFX12PlusBit, },
  {Feature_FP64DenormalsBit, Feature_NotHasMinMaxDenormModesBit, Feature_isNotGFX12PlusBit, },
  {Feature_Has16BitInstsBit, Feature_HasMinMaxDenormModesBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_Has16BitInstsBit, Feature_HasMinMaxDenormModesBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_HasMinMaxDenormModesBit, Feature_UseRealTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_NotHasTrue16BitInstsBit, Feature_isGFX10PlusBit, },
  {Feature_Has16BitInstsBit, Feature_has32BankLDSBit, Feature_isNotGFX90APlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_HasNoCvtFP8VOP1BugBit, Feature_HasSDWABit, },
  {Feature_HasMadMacF32InstsBit, Feature_NoFP32DenormalsBit, Feature_isGFX6GFX7GFX10Bit, },
  {Feature_HasMadMixInstsBit, Feature_NoFP32DenormalsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasMadMixInstsBit, Feature_NoFP32DenormalsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasMadMixInstsBit, Feature_NoFP32DenormalsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasD16LoadStoreBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, Feature_UseRealTrue16InstsBit, },
  {Feature_FP16DenormalsBit, Feature_Has16BitInstsBit, Feature_NotHasMinMaxDenormModesBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_FP16DenormalsBit, Feature_Has16BitInstsBit, Feature_NotHasMinMaxDenormModesBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_FP16DenormalsBit, Feature_Has16BitInstsBit, Feature_NotHasMinMaxDenormModesBit, Feature_UseRealTrue16InstsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_buf_soffset,
  GICP_gi_ds_128bit_8byte_aligned,
  GICP_gi_ds_1addr_1offset,
  GICP_gi_ds_64bit_4byte_aligned,
  GICP_gi_flat_offset,
  GICP_gi_flat_scratch_offset,
  GICP_gi_flat_scratch_saddr,
  GICP_gi_flat_scratch_svaddr,
  GICP_gi_global_offset,
  GICP_gi_global_saddr,
  GICP_gi_mubuf_addr64,
  GICP_gi_mubuf_offset,
  GICP_gi_mubuf_scratch_offen,
  GICP_gi_mubuf_scratch_offset,
  GICP_gi_smrd_buffer_imm,
  GICP_gi_smrd_buffer_imm32,
  GICP_gi_smrd_buffer_sgpr_imm,
  GICP_gi_smrd_imm,
  GICP_gi_smrd_imm32,
  GICP_gi_smrd_sgpr,
  GICP_gi_smrd_sgpr_imm,
  GICP_gi_swmmacindex16,
  GICP_gi_swmmacindex8,
  GICP_gi_vcsrc,
  GICP_gi_vinterpmods,
  GICP_gi_vinterpmods_hi,
  GICP_gi_vop3_mad_mix_mods,
  GICP_gi_vop3_mad_mix_mods_ext,
  GICP_gi_vop3_no_mods,
  GICP_gi_vop3mods,
  GICP_gi_vop3mods0,
  GICP_gi_vop3modsnoncanonicalizing,
  GICP_gi_vop3omods,
  GICP_gi_vop3opsel,
  GICP_gi_vop3opselmods,
  GICP_gi_vop3pmods,
  GICP_gi_vop3pmodsdot,
  GICP_gi_vop3pmodsneg,
  GICP_gi_vsrc0,
  GICP_gi_wmmamods,
  GICP_gi_wmmamodsf16Neg,
  GICP_gi_wmmamodsf16NegAbs,
  GICP_gi_wmmaopselvop3pmods,
  GICP_gi_wmmavisrc,
};
// See constructor for table contents

AMDGPUInstructionSelector::ComplexMatcherMemFn
AMDGPUInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AMDGPUInstructionSelector::selectBUFSOffset, // gi_buf_soffset
  &AMDGPUInstructionSelector::selectDS128Bit8ByteAligned, // gi_ds_128bit_8byte_aligned
  &AMDGPUInstructionSelector::selectDS1Addr1Offset, // gi_ds_1addr_1offset
  &AMDGPUInstructionSelector::selectDS64Bit4ByteAligned, // gi_ds_64bit_4byte_aligned
  &AMDGPUInstructionSelector::selectFlatOffset, // gi_flat_offset
  &AMDGPUInstructionSelector::selectScratchOffset, // gi_flat_scratch_offset
  &AMDGPUInstructionSelector::selectScratchSAddr, // gi_flat_scratch_saddr
  &AMDGPUInstructionSelector::selectScratchSVAddr, // gi_flat_scratch_svaddr
  &AMDGPUInstructionSelector::selectGlobalOffset, // gi_global_offset
  &AMDGPUInstructionSelector::selectGlobalSAddr, // gi_global_saddr
  &AMDGPUInstructionSelector::selectMUBUFAddr64, // gi_mubuf_addr64
  &AMDGPUInstructionSelector::selectMUBUFOffset, // gi_mubuf_offset
  &AMDGPUInstructionSelector::selectMUBUFScratchOffen, // gi_mubuf_scratch_offen
  &AMDGPUInstructionSelector::selectMUBUFScratchOffset, // gi_mubuf_scratch_offset
  &AMDGPUInstructionSelector::selectSMRDBufferImm, // gi_smrd_buffer_imm
  &AMDGPUInstructionSelector::selectSMRDBufferImm32, // gi_smrd_buffer_imm32
  &AMDGPUInstructionSelector::selectSMRDBufferSgprImm, // gi_smrd_buffer_sgpr_imm
  &AMDGPUInstructionSelector::selectSmrdImm, // gi_smrd_imm
  &AMDGPUInstructionSelector::selectSmrdImm32, // gi_smrd_imm32
  &AMDGPUInstructionSelector::selectSmrdSgpr, // gi_smrd_sgpr
  &AMDGPUInstructionSelector::selectSmrdSgprImm, // gi_smrd_sgpr_imm
  &AMDGPUInstructionSelector::selectSWMMACIndex16, // gi_swmmacindex16
  &AMDGPUInstructionSelector::selectSWMMACIndex8, // gi_swmmacindex8
  &AMDGPUInstructionSelector::selectVCSRC, // gi_vcsrc
  &AMDGPUInstructionSelector::selectVINTERPMods, // gi_vinterpmods
  &AMDGPUInstructionSelector::selectVINTERPModsHi, // gi_vinterpmods_hi
  &AMDGPUInstructionSelector::selectVOP3PMadMixMods, // gi_vop3_mad_mix_mods
  &AMDGPUInstructionSelector::selectVOP3PMadMixModsExt, // gi_vop3_mad_mix_mods_ext
  &AMDGPUInstructionSelector::selectVOP3NoMods, // gi_vop3_no_mods
  &AMDGPUInstructionSelector::selectVOP3Mods, // gi_vop3mods
  &AMDGPUInstructionSelector::selectVOP3Mods0, // gi_vop3mods0
  &AMDGPUInstructionSelector::selectVOP3ModsNonCanonicalizing, // gi_vop3modsnoncanonicalizing
  &AMDGPUInstructionSelector::selectVOP3OMods, // gi_vop3omods
  &AMDGPUInstructionSelector::selectVOP3OpSelMods, // gi_vop3opsel
  &AMDGPUInstructionSelector::selectVOP3OpSelMods, // gi_vop3opselmods
  &AMDGPUInstructionSelector::selectVOP3PMods, // gi_vop3pmods
  &AMDGPUInstructionSelector::selectVOP3PModsDOT, // gi_vop3pmodsdot
  &AMDGPUInstructionSelector::selectVOP3PModsNeg, // gi_vop3pmodsneg
  &AMDGPUInstructionSelector::selectVSRC0, // gi_vsrc0
  &AMDGPUInstructionSelector::selectWMMAModsF32NegAbs, // gi_wmmamods
  &AMDGPUInstructionSelector::selectWMMAModsF16Neg, // gi_wmmamodsf16Neg
  &AMDGPUInstructionSelector::selectWMMAModsF16NegAbs, // gi_wmmamodsf16NegAbs
  &AMDGPUInstructionSelector::selectWMMAOpSelVOP3PMods, // gi_wmmaopselvop3pmods
  &AMDGPUInstructionSelector::selectWMMAVISrc, // gi_wmmavisrc
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_aligned_smrd_load = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_anonymous_13755,
  GICXXPred_MI_Predicate_anonymous_13758,
  GICXXPred_MI_Predicate_anonymous_13759,
  GICXXPred_MI_Predicate_anonymous_13760,
  GICXXPred_MI_Predicate_anonymous_13761,
  GICXXPred_MI_Predicate_anonymous_13762,
  GICXXPred_MI_Predicate_anonymous_13765,
  GICXXPred_MI_Predicate_anonymous_13766,
  GICXXPred_MI_Predicate_anonymous_13767,
  GICXXPred_MI_Predicate_anonymous_13768,
  GICXXPred_MI_Predicate_anonymous_13769,
  GICXXPred_MI_Predicate_anonymous_13770,
  GICXXPred_MI_Predicate_anonymous_13771,
  GICXXPred_MI_Predicate_anonymous_13772,
  GICXXPred_MI_Predicate_anonymous_13773,
  GICXXPred_MI_Predicate_anonymous_13774,
  GICXXPred_MI_Predicate_anonymous_13775,
  GICXXPred_MI_Predicate_anonymous_13776,
  GICXXPred_MI_Predicate_anonymous_13777,
  GICXXPred_MI_Predicate_anonymous_13778,
  GICXXPred_MI_Predicate_anonymous_13779,
  GICXXPred_MI_Predicate_anonymous_13780,
  GICXXPred_MI_Predicate_anonymous_13781,
  GICXXPred_MI_Predicate_anonymous_13782,
  GICXXPred_MI_Predicate_anonymous_13783,
  GICXXPred_MI_Predicate_anonymous_13784,
  GICXXPred_MI_Predicate_anonymous_13785,
  GICXXPred_MI_Predicate_anonymous_13786,
  GICXXPred_MI_Predicate_anonymous_13787,
  GICXXPred_MI_Predicate_anonymous_13788,
  GICXXPred_MI_Predicate_anonymous_13789,
  GICXXPred_MI_Predicate_anonymous_13790,
  GICXXPred_MI_Predicate_anonymous_13791,
  GICXXPred_MI_Predicate_anonymous_13792,
  GICXXPred_MI_Predicate_anonymous_13793,
  GICXXPred_MI_Predicate_anonymous_13794,
  GICXXPred_MI_Predicate_anonymous_13795,
  GICXXPred_MI_Predicate_anonymous_13796,
  GICXXPred_MI_Predicate_anonymous_13797,
  GICXXPred_MI_Predicate_anonymous_13798,
  GICXXPred_MI_Predicate_anonymous_13799,
  GICXXPred_MI_Predicate_anonymous_13800,
  GICXXPred_MI_Predicate_anonymous_13801,
  GICXXPred_MI_Predicate_anonymous_13802,
  GICXXPred_MI_Predicate_anonymous_13803,
  GICXXPred_MI_Predicate_anonymous_13804,
  GICXXPred_MI_Predicate_anonymous_13805,
  GICXXPred_MI_Predicate_anonymous_13806,
  GICXXPred_MI_Predicate_anonymous_13813,
  GICXXPred_MI_Predicate_anonymous_13825,
  GICXXPred_MI_Predicate_anonymous_18365,
  GICXXPred_MI_Predicate_anonymous_19283,
  GICXXPred_MI_Predicate_anonymous_19285,
  GICXXPred_MI_Predicate_anonymous_19678,
  GICXXPred_MI_Predicate_anonymous_19680,
  GICXXPred_MI_Predicate_anonymous_19682,
  GICXXPred_MI_Predicate_anonymous_19684,
  GICXXPred_MI_Predicate_anonymous_19686,
  GICXXPred_MI_Predicate_anonymous_19690,
  GICXXPred_MI_Predicate_anonymous_19692,
  GICXXPred_MI_Predicate_anonymous_19694,
  GICXXPred_MI_Predicate_anonymous_19696,
  GICXXPred_MI_Predicate_anonymous_19698,
  GICXXPred_MI_Predicate_anonymous_19933,
  GICXXPred_MI_Predicate_anonymous_19935,
  GICXXPred_MI_Predicate_anonymous_20176,
  GICXXPred_MI_Predicate_anonymous_20186,
  GICXXPred_MI_Predicate_anonymous_20189,
  GICXXPred_MI_Predicate_anonymous_20351,
  GICXXPred_MI_Predicate_anonymous_20808,
  GICXXPred_MI_Predicate_anonymous_20811,
  GICXXPred_MI_Predicate_anonymous_20814,
  GICXXPred_MI_Predicate_anonymous_20816,
  GICXXPred_MI_Predicate_anonymous_20819,
  GICXXPred_MI_Predicate_anonymous_20821,
  GICXXPred_MI_Predicate_anonymous_20824,
  GICXXPred_MI_Predicate_anonymous_20827,
  GICXXPred_MI_Predicate_anonymous_20831,
  GICXXPred_MI_Predicate_anonymous_20843,
  GICXXPred_MI_Predicate_anonymous_21254,
  GICXXPred_MI_Predicate_anonymous_21527,
  GICXXPred_MI_Predicate_anonymous_21530,
  GICXXPred_MI_Predicate_anonymous_21532,
  GICXXPred_MI_Predicate_anonymous_21534,
  GICXXPred_MI_Predicate_anonymous_21536,
  GICXXPred_MI_Predicate_anonymous_21538,
  GICXXPred_MI_Predicate_anonymous_21540,
  GICXXPred_MI_Predicate_anonymous_23242,
  GICXXPred_MI_Predicate_anonymous_23244,
  GICXXPred_MI_Predicate_anonymous_23248,
  GICXXPred_MI_Predicate_anonymous_23250,
  GICXXPred_MI_Predicate_anonymous_23252,
  GICXXPred_MI_Predicate_anonymous_23254,
  GICXXPred_MI_Predicate_anonymous_23258,
  GICXXPred_MI_Predicate_anonymous_23260,
  GICXXPred_MI_Predicate_anonymous_23262,
  GICXXPred_MI_Predicate_anonymous_23264,
  GICXXPred_MI_Predicate_anonymous_23266,
  GICXXPred_MI_Predicate_anonymous_23268,
  GICXXPred_MI_Predicate_anonymous_23270,
  GICXXPred_MI_Predicate_anonymous_23272,
  GICXXPred_MI_Predicate_anonymous_23276,
  GICXXPred_MI_Predicate_anonymous_23278,
  GICXXPred_MI_Predicate_anonymous_23280,
  GICXXPred_MI_Predicate_anonymous_23282,
  GICXXPred_MI_Predicate_anonymous_23286,
  GICXXPred_MI_Predicate_anonymous_23288,
  GICXXPred_MI_Predicate_anonymous_23292,
  GICXXPred_MI_Predicate_anonymous_23294,
  GICXXPred_MI_Predicate_anonymous_23296,
  GICXXPred_MI_Predicate_anonymous_23298,
  GICXXPred_MI_Predicate_anonymous_23302,
  GICXXPred_MI_Predicate_anonymous_23304,
  GICXXPred_MI_Predicate_anonymous_23306,
  GICXXPred_MI_Predicate_anonymous_23308,
  GICXXPred_MI_Predicate_anonymous_23310,
  GICXXPred_MI_Predicate_anonymous_23312,
  GICXXPred_MI_Predicate_anonymous_23314,
  GICXXPred_MI_Predicate_anonymous_23316,
  GICXXPred_MI_Predicate_anonymous_23320,
  GICXXPred_MI_Predicate_anonymous_23322,
  GICXXPred_MI_Predicate_anonymous_23324,
  GICXXPred_MI_Predicate_anonymous_23326,
  GICXXPred_MI_Predicate_anonymous_23330,
  GICXXPred_MI_Predicate_anonymous_23332,
  GICXXPred_MI_Predicate_anonymous_23334,
  GICXXPred_MI_Predicate_anonymous_23336,
  GICXXPred_MI_Predicate_anonymous_23338,
  GICXXPred_MI_Predicate_anonymous_23340,
  GICXXPred_MI_Predicate_anonymous_23344,
  GICXXPred_MI_Predicate_anonymous_23346,
  GICXXPred_MI_Predicate_anonymous_23348,
  GICXXPred_MI_Predicate_anonymous_23350,
  GICXXPred_MI_Predicate_anonymous_23352,
  GICXXPred_MI_Predicate_anonymous_23354,
  GICXXPred_MI_Predicate_anonymous_23358,
  GICXXPred_MI_Predicate_anonymous_23360,
  GICXXPred_MI_Predicate_anonymous_23364,
  GICXXPred_MI_Predicate_anonymous_23366,
  GICXXPred_MI_Predicate_anonymous_23368,
  GICXXPred_MI_Predicate_anonymous_23370,
  GICXXPred_MI_Predicate_anonymous_23390,
  GICXXPred_MI_Predicate_anonymous_23392,
  GICXXPred_MI_Predicate_anonymous_23426,
  GICXXPred_MI_Predicate_anonymous_23428,
  GICXXPred_MI_Predicate_anonymous_23448,
  GICXXPred_MI_Predicate_anonymous_23450,
  GICXXPred_MI_Predicate_anonymous_23488,
  GICXXPred_MI_Predicate_anonymous_23490,
  GICXXPred_MI_Predicate_anonymous_23494,
  GICXXPred_MI_Predicate_anonymous_23496,
  GICXXPred_MI_Predicate_anonymous_23498,
  GICXXPred_MI_Predicate_anonymous_23500,
  GICXXPred_MI_Predicate_anonymous_23502,
  GICXXPred_MI_Predicate_anonymous_23504,
  GICXXPred_MI_Predicate_anonymous_23506,
  GICXXPred_MI_Predicate_anonymous_23508,
  GICXXPred_MI_Predicate_anonymous_23512,
  GICXXPred_MI_Predicate_anonymous_23514,
  GICXXPred_MI_Predicate_anonymous_23516,
  GICXXPred_MI_Predicate_anonymous_23518,
  GICXXPred_MI_Predicate_anonymous_23522,
  GICXXPred_MI_Predicate_anonymous_23524,
  GICXXPred_MI_Predicate_anonymous_23526,
  GICXXPred_MI_Predicate_anonymous_23528,
  GICXXPred_MI_Predicate_anonymous_23530,
  GICXXPred_MI_Predicate_anonymous_23532,
  GICXXPred_MI_Predicate_anonymous_23536,
  GICXXPred_MI_Predicate_anonymous_23538,
  GICXXPred_MI_Predicate_anonymous_23540,
  GICXXPred_MI_Predicate_anonymous_23542,
  GICXXPred_MI_Predicate_anonymous_23544,
  GICXXPred_MI_Predicate_anonymous_23546,
  GICXXPred_MI_Predicate_anonymous_23548,
  GICXXPred_MI_Predicate_anonymous_23550,
  GICXXPred_MI_Predicate_anonymous_23552,
  GICXXPred_MI_Predicate_anonymous_23554,
  GICXXPred_MI_Predicate_anonymous_23558,
  GICXXPred_MI_Predicate_anonymous_23560,
  GICXXPred_MI_Predicate_anonymous_23562,
  GICXXPred_MI_Predicate_anonymous_23564,
  GICXXPred_MI_Predicate_anonymous_23566,
  GICXXPred_MI_Predicate_anonymous_23568,
  GICXXPred_MI_Predicate_anonymous_23570,
  GICXXPred_MI_Predicate_anonymous_23572,
  GICXXPred_MI_Predicate_anonymous_34225,
  GICXXPred_MI_Predicate_anonymous_34532,
  GICXXPred_MI_Predicate_anonymous_34534,
  GICXXPred_MI_Predicate_anonymous_34580,
  GICXXPred_MI_Predicate_anonymous_34593,
  GICXXPred_MI_Predicate_anonymous_34594,
  GICXXPred_MI_Predicate_anonymous_34597,
  GICXXPred_MI_Predicate_anonymous_34600,
  GICXXPred_MI_Predicate_anonymous_34603,
  GICXXPred_MI_Predicate_anonymous_34607,
  GICXXPred_MI_Predicate_anonymous_34610,
  GICXXPred_MI_Predicate_anonymous_34613,
  GICXXPred_MI_Predicate_anonymous_34615,
  GICXXPred_MI_Predicate_anonymous_34616,
  GICXXPred_MI_Predicate_anonymous_34625,
  GICXXPred_MI_Predicate_anonymous_34627,
  GICXXPred_MI_Predicate_anonymous_34635,
  GICXXPred_MI_Predicate_anonymous_34640,
  GICXXPred_MI_Predicate_anonymous_34644,
  GICXXPred_MI_Predicate_anonymous_34648,
  GICXXPred_MI_Predicate_anonymous_34805,
  GICXXPred_MI_Predicate_anonymous_34808,
  GICXXPred_MI_Predicate_anonymous_34813,
  GICXXPred_MI_Predicate_anonymous_34817,
  GICXXPred_MI_Predicate_anonymous_34884,
  GICXXPred_MI_Predicate_anonymous_34886,
  GICXXPred_MI_Predicate_anonymous_34946,
  GICXXPred_MI_Predicate_anonymous_34974,
  GICXXPred_MI_Predicate_anonymous_34976,
  GICXXPred_MI_Predicate_anonymous_35005,
  GICXXPred_MI_Predicate_anonymous_35007,
  GICXXPred_MI_Predicate_anonymous_35009,
  GICXXPred_MI_Predicate_anonymous_35011,
  GICXXPred_MI_Predicate_anonymous_35013,
  GICXXPred_MI_Predicate_bf16_fpround,
  GICXXPred_MI_Predicate_csh_mask_16,
  GICXXPred_MI_Predicate_csh_mask_32,
  GICXXPred_MI_Predicate_csh_mask_64,
  GICXXPred_MI_Predicate_fmaxnum_like_nnan,
  GICXXPred_MI_Predicate_fminnum_like_nnan,
  GICXXPred_MI_Predicate_is_canonicalized,
  GICXXPred_MI_Predicate_load_align_less_than_4_local,
  GICXXPred_MI_Predicate_load_align_less_than_4_local_m0,
  GICXXPred_MI_Predicate_shl1_add,
  GICXXPred_MI_Predicate_shl2_add,
  GICXXPred_MI_Predicate_shl3_add,
  GICXXPred_MI_Predicate_shl4_add,
  GICXXPred_MI_Predicate_shl_0_to_4,
  GICXXPred_MI_Predicate_smrd_extloadi8,
  GICXXPred_MI_Predicate_smrd_extloadi16,
  GICXXPred_MI_Predicate_smrd_load,
  GICXXPred_MI_Predicate_smrd_prefetch,
  GICXXPred_MI_Predicate_smrd_sextloadi8,
  GICXXPred_MI_Predicate_smrd_sextloadi16,
  GICXXPred_MI_Predicate_smrd_zextloadi8,
  GICXXPred_MI_Predicate_smrd_zextloadi16,
  GICXXPred_MI_Predicate_store_align_less_than_4_local,
  GICXXPred_MI_Predicate_store_align_less_than_4_local_m0,
};
bool AMDGPUInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_aligned_smrd_load: {
    
      auto &Ld = cast<GLoad>(MI);
      TypeSize Size = Ld.getMMO().getSize().getValue();
      return Size <= 4 || Ld.getMMO().getAlign().value() >= Size;
      
    llvm_unreachable("aligned_smrd_load should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_13755: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13758: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13759: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13760: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13761: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13762: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13765: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13766: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13767: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13768: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13769: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13770: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13771: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13772: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13773: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13774: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13775: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13776: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13777: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13778: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13779: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13780: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13781: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13782: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13783: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13784: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13785: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13786: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13787: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13788: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13789: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13790: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13791: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13792: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13793: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13794: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13795: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13796: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13797: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13798: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13799: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13800: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13801: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13802: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13803: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13804: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13805: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13806: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13813: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13825: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_18365: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19283: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19285: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19678: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19680: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19682: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19684: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19686: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19690: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19692: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19694: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19696: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19698: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19933: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19935: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20176: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20186: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20189: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20351: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20808: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20808 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20811: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20811 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20814: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20814 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20816: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20816 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20819: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20819 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20821: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20821 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20824: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20824 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20827: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20827 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20831: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20831 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20843: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20843 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_21254: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_21254 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_21527: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21530: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21532: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21534: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21536: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21538: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21540: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_23242: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23244: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23248: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23250: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23252: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23254: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23258: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23260: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23262: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23264: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23266: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23268: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23270: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23272: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23276: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23278: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23280: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23282: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23286: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23288: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23292: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23294: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23296: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23298: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23302: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23304: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23306: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23308: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23310: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23312: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23314: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23316: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23320: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23322: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23324: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23326: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23330: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23332: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23334: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23336: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23338: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23340: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23344: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23346: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23348: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23350: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23352: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23354: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23358: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23360: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23364: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23366: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23368: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23370: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23390: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23392: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23426: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23428: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23448: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23450: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23488: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23490: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23494: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23496: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23498: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23500: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23502: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23504: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23506: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23508: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23512: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23514: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23516: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23518: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23522: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23524: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23526: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23528: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23530: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23532: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23536: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23538: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23540: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23542: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23544: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23546: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23548: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23550: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23552: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23554: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23558: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23560: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23562: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23564: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23566: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23568: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23570: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23572: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_34225: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34532: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34534: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34580: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34593: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34594: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34597: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34600: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34603: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34607: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34610: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34613: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34615: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34616: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34625: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34627: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34635: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34640: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34644: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34648: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34805: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34808: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34813: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34817: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34884: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34886: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34946: {
    
        const SITargetLowering *TLI = static_cast<const SITargetLowering *>(
          MF.getSubtarget().getTargetLowering());
    
        return TLI->isCanonicalized(MI.getOperand(1).getReg(), MF) &&
          TLI->isCanonicalized(MI.getOperand(2).getReg(), MF);
      
    llvm_unreachable("anonymous_34946 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_34974: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34976: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_35005: {
    
        const SITargetLowering *TLI = static_cast<const SITargetLowering *>(
          MF.getSubtarget().getTargetLowering());
    
        return TLI->isCanonicalized(MI.getOperand(1).getReg(), MF);
      
    llvm_unreachable("anonymous_35005 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_35007: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_35009: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_35011: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_35013: {
    return true;
  }
  case GICXXPred_MI_Predicate_bf16_fpround: {
    return false;
  }
  case GICXXPred_MI_Predicate_csh_mask_16: {
     return isUnneededShiftMask(MI, 4); 
  }
  case GICXXPred_MI_Predicate_csh_mask_32: {
     return isUnneededShiftMask(MI, 5); 
  }
  case GICXXPred_MI_Predicate_csh_mask_64: {
     return isUnneededShiftMask(MI, 6); 
  }
  case GICXXPred_MI_Predicate_fmaxnum_like_nnan: {
    
        return isKnownNeverNaN(MI.getOperand(0).getReg(), MRI);
      
  }
  case GICXXPred_MI_Predicate_fminnum_like_nnan: {
    
        return isKnownNeverNaN(MI.getOperand(0).getReg(), MRI);
      
  }
  case GICXXPred_MI_Predicate_is_canonicalized: {
    
        const SITargetLowering *TLI = static_cast<const SITargetLowering *>(
            MF.getSubtarget().getTargetLowering());
        const MachineOperand &Dst = MI.getOperand(0);
        assert(Dst.isDef());
        return TLI->isCanonicalized(Dst.getReg(), MF);
       
    llvm_unreachable("is_canonicalized should have returned");
  }
  case GICXXPred_MI_Predicate_load_align_less_than_4_local: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  case GICXXPred_MI_Predicate_load_align_less_than_4_local_m0: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  case GICXXPred_MI_Predicate_shl1_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl2_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl3_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl4_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl_0_to_4: {
    
        int64_t Imm = 0;
        if (!mi_match(MI.getOperand(2).getReg(), MRI, m_ICst(Imm)) &&
            !mi_match(MI.getOperand(2).getReg(), MRI, m_Copy(m_ICst(Imm))))
          return false;
        return (uint64_t)Imm <= 4;
      
    llvm_unreachable("shl_0_to_4 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_extloadi8: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_extloadi8 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_extloadi16: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_extloadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_load: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_load should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_prefetch: {
    
        return isInstrUniform(MI);
      
  }
  case GICXXPred_MI_Predicate_smrd_sextloadi8: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_sextloadi8 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_sextloadi16: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_sextloadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_zextloadi8: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_zextloadi8 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_zextloadi16: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_zextloadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_store_align_less_than_4_local: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  case GICXXPred_MI_Predicate_store_align_less_than_4_local_m0: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_IMMZeroBasedBitfieldMask = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_MFMALdScaleModifierOp,
  GICXXPred_I64_Predicate_NegSubInlineConst32,
  GICXXPred_I64_Predicate_NegSubInlineIntConst16,
  GICXXPred_I64_Predicate_SIMM16bit,
  GICXXPred_I64_Predicate_ShiftAmt32Imm,
  GICXXPred_I64_Predicate_SupportedRoundMode,
  GICXXPred_I64_Predicate_i32imm_one,
  GICXXPred_I64_Predicate_i32imm_zero,
  GICXXPred_I64_Predicate_i64imm_32bit,
};
bool AMDGPUInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_IMMZeroBasedBitfieldMask: {
    
      return isMask_32(Imm);
    
  }
  case GICXXPred_I64_Predicate_MFMALdScaleModifierOp: {
    
      return isUInt<2>(Imm);
    
  }
  case GICXXPred_I64_Predicate_NegSubInlineConst32: {
    
      return Imm < -16 && Imm >= -64;
    
  }
  case GICXXPred_I64_Predicate_NegSubInlineIntConst16: {
    
      return Imm < -16 && Imm >= -64;
    
  }
  case GICXXPred_I64_Predicate_SIMM16bit: {
    return isInt<16>(Imm) || isUInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_ShiftAmt32Imm: {
    
      return Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_SupportedRoundMode: {
    
      return Imm == (int)RoundingMode::TowardZero ||
             Imm == (int)RoundingMode::NearestTiesToEven ||
             Imm == (int)RoundingMode::TowardPositive ||
             Imm == (int)RoundingMode::TowardNegative;
    
  }
  case GICXXPred_I64_Predicate_i32imm_one: {
    
      return Imm == 1;
    
  }
  case GICXXPred_I64_Predicate_i32imm_zero: {
    
      return Imm == 0;
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_InlineImmFP32 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_InlineImmFP64,
  GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64,
  GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64,
};
bool AMDGPUInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_InlineImmFP32: {
    
      return isInlineImmediate(Imm);
    
  }
  case GICXXPred_APFloat_Predicate_InlineImmFP64: {
    
      return isInlineImmediate(Imm);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64: {
    
        if (!Imm.isNegative())
          return false;
        int Exp = Imm.getExactLog2Abs();
        // Prefer leaving the FP inline immediates as they are.
        // 0.5, 1.0, 2.0, 4.0
    
        // For f64 ldexp is always better than materializing a 64-bit
        // constant.
        return Exp != INT_MIN && (Exp < -1 || Exp > 2);
      
    llvm_unreachable("fpimm_neg_pow2_prefer_ldexp_f64 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64: {
    
        if (Imm.isNegative())
          return false;
    
        int Exp = Imm.getExactLog2Abs();
        // Prefer leaving the FP inline immediates as they are.
        // 0.5, 1.0, 2.0, 4.0
    
        // For f64 ldexp is always better than materializing a 64-bit
        // constant.
        return Exp != INT_MIN && (Exp < -1 || Exp > 2);
      
    llvm_unreachable("fpimm_pos_pow2_prefer_ldexp_f64 should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_InlineImm64 = GICXXPred_Invalid + 1,
};
bool AMDGPUInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_InlineImm64: {
    
      return isInlineImmediate(Imm);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AMDGPUInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderBitcastFPImm32,
  GICR_renderBitcastFPImm64,
  GICR_renderDstSelToOpSel3XFormXForm,
  GICR_renderDstSelToOpSelXForm,
  GICR_renderExtractCPol,
  GICR_renderExtractCpolSetGLC,
  GICR_renderExtractSWZ,
  GICR_renderFPPow2ToExponent,
  GICR_renderFrameIndex,
  GICR_renderNegateImm,
  GICR_renderOpSelTImm,
  GICR_renderPopcntImm,
  GICR_renderRoundMode,
  GICR_renderScaledMAIIntrinsicOperand,
  GICR_renderSrcAndDstSelToOpSelXForm_0_0,
  GICR_renderSrcAndDstSelToOpSelXForm_0_1,
  GICR_renderSrcAndDstSelToOpSelXForm_1_0,
  GICR_renderSrcAndDstSelToOpSelXForm_1_1,
  GICR_renderSrcAndDstSelToOpSelXForm_2_0,
  GICR_renderSrcSelToOpSelXForm,
  GICR_renderTruncTImm,
  GICR_renderZextBoolTImm,
};
AMDGPUInstructionSelector::CustomRendererFn
AMDGPUInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AMDGPUInstructionSelector::renderBitcastFPImm32,
  &AMDGPUInstructionSelector::renderBitcastFPImm64,
  &AMDGPUInstructionSelector::renderDstSelToOpSel3XFormXForm,
  &AMDGPUInstructionSelector::renderDstSelToOpSelXForm,
  &AMDGPUInstructionSelector::renderExtractCPol,
  &AMDGPUInstructionSelector::renderExtractCpolSetGLC,
  &AMDGPUInstructionSelector::renderExtractSWZ,
  &AMDGPUInstructionSelector::renderFPPow2ToExponent,
  &AMDGPUInstructionSelector::renderFrameIndex,
  &AMDGPUInstructionSelector::renderNegateImm,
  &AMDGPUInstructionSelector::renderOpSelTImm,
  &AMDGPUInstructionSelector::renderPopcntImm,
  &AMDGPUInstructionSelector::renderRoundMode,
  &AMDGPUInstructionSelector::renderScaledMAIIntrinsicOperand,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_0_0,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_0_1,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_1_0,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_1_1,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_2_0,
  &AMDGPUInstructionSelector::renderSrcSelToOpSelXForm,
  &AMDGPUInstructionSelector::renderTruncTImm,
  &AMDGPUInstructionSelector::renderZextBoolTImm,
};

bool AMDGPUInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AMDGPUInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AMDGPUInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AMDGPUInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(3740), /*)*//*default:*//*Label 167*/ GIMT_Encode4(773911),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(14758),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(38000),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(38623), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 3*/ GIMT_Encode4(38969),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 4*/ GIMT_Encode4(40370),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 5*/ GIMT_Encode4(55882), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     74 */ /*TargetOpcode::G_FRAME_INDEX*//*Label 6*/ GIMT_Encode4(60574), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 7*/ GIMT_Encode4(60629), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 8*/ GIMT_Encode4(65655), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    138 */ /*TargetOpcode::G_INTRINSIC_FPTRUNC_ROUND*//*Label 9*/ GIMT_Encode4(71252),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(71447), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 11*/ GIMT_Encode4(71775),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 12*/ GIMT_Encode4(72103),
     /*    166 */ /*TargetOpcode::G_READSTEADYCOUNTER*//*Label 13*/ GIMT_Encode4(72243),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 14*/ GIMT_Encode4(72301),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 15*/ GIMT_Encode4(139793),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 16*/ GIMT_Encode4(146859), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 17*/ GIMT_Encode4(153840), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 18*/ GIMT_Encode4(187745),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 19*/ GIMT_Encode4(188871),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 20*/ GIMT_Encode4(191083),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 21*/ GIMT_Encode4(193595),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 22*/ GIMT_Encode4(196107), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 23*/ GIMT_Encode4(198619),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 24*/ GIMT_Encode4(201131),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 25*/ GIMT_Encode4(203643),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 26*/ GIMT_Encode4(206155),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 27*/ GIMT_Encode4(208667),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 28*/ GIMT_Encode4(211179),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 29*/ GIMT_Encode4(213691), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 30*/ GIMT_Encode4(215902),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 31*/ GIMT_Encode4(218548),
     /*    270 */ /*TargetOpcode::G_ATOMICRMW_UINC_WRAP*//*Label 32*/ GIMT_Encode4(221194),
     /*    274 */ /*TargetOpcode::G_ATOMICRMW_UDEC_WRAP*//*Label 33*/ GIMT_Encode4(223706), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 34*/ GIMT_Encode4(226218),
     /*    290 */ /*TargetOpcode::G_PREFETCH*//*Label 35*/ GIMT_Encode4(226237), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 36*/ GIMT_Encode4(226673),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 37*/ GIMT_Encode4(243880),
     /*    314 */ /*TargetOpcode::G_INTRINSIC_CONVERGENT*//*Label 38*/ GIMT_Encode4(248591),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_CONVERGENT_W_SIDE_EFFECTS*//*Label 39*/ GIMT_Encode4(273559),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 40*/ GIMT_Encode4(274810),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 41*/ GIMT_Encode4(275373),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 42*/ GIMT_Encode4(275613),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 43*/ GIMT_Encode4(276339), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 44*/ GIMT_Encode4(276621), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(277424),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(280627),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(282163),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(283325), GIMT_Encode4(0),
     /*    374 */ /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(284487),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(284749), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(284826),
     /*    390 */ /*TargetOpcode::G_FCMP*//*Label 52*/ GIMT_Encode4(286418), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 53*/ GIMT_Encode4(290581), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 54*/ GIMT_Encode4(290925),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 55*/ GIMT_Encode4(291034),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 56*/ GIMT_Encode4(291143),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 57*/ GIMT_Encode4(291531),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 58*/ GIMT_Encode4(291857),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 59*/ GIMT_Encode4(292245), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 60*/ GIMT_Encode4(292571),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 61*/ GIMT_Encode4(293929),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 62*/ GIMT_Encode4(294293),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 63*/ GIMT_Encode4(295679),
     /*    526 */ /*TargetOpcode::G_FMAD*//*Label 64*/ GIMT_Encode4(297548), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FPOW*//*Label 65*/ GIMT_Encode4(298494), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    550 */ /*TargetOpcode::G_FEXP2*//*Label 66*/ GIMT_Encode4(298612), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    562 */ /*TargetOpcode::G_FLOG2*//*Label 67*/ GIMT_Encode4(298835), GIMT_Encode4(0),
     /*    570 */ /*TargetOpcode::G_FLDEXP*//*Label 68*/ GIMT_Encode4(299058), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 69*/ GIMT_Encode4(299421),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 70*/ GIMT_Encode4(301284),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 71*/ GIMT_Encode4(301684),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 72*/ GIMT_Encode4(302620),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 73*/ GIMT_Encode4(303346),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 74*/ GIMT_Encode4(304072),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 75*/ GIMT_Encode4(304805), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 76*/ GIMT_Encode4(305538),
     /*    618 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 77*/ GIMT_Encode4(306339),
     /*    622 */ /*TargetOpcode::G_IS_FPCLASS*//*Label 78*/ GIMT_Encode4(306702),
     /*    626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 79*/ GIMT_Encode4(307033),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 80*/ GIMT_Encode4(308501),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 81*/ GIMT_Encode4(380280),
     /*    638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 82*/ GIMT_Encode4(452059),
     /*    642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 83*/ GIMT_Encode4(523838),
     /*    646 */ /*TargetOpcode::G_FMINIMUM*//*Label 84*/ GIMT_Encode4(595617),
     /*    650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 85*/ GIMT_Encode4(597744), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    666 */ /*TargetOpcode::G_GET_FPMODE*//*Label 86*/ GIMT_Encode4(599871), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    678 */ /*TargetOpcode::G_PTR_ADD*//*Label 87*/ GIMT_Encode4(599995), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 88*/ GIMT_Encode4(600072),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 89*/ GIMT_Encode4(606436),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 90*/ GIMT_Encode4(612962),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 91*/ GIMT_Encode4(619326),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 92*/ GIMT_Encode4(625690), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 93*/ GIMT_Encode4(625827), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_CTTZ_ZERO_UNDEF*//*Label 94*/ GIMT_Encode4(625861), GIMT_Encode4(0),
     /*    770 */ /*TargetOpcode::G_CTLZ_ZERO_UNDEF*//*Label 95*/ GIMT_Encode4(625960),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 96*/ GIMT_Encode4(626062),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 97*/ GIMT_Encode4(626277),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 98*/ GIMT_Encode4(628026),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 99*/ GIMT_Encode4(628274), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 100*/ GIMT_Encode4(628602),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 101*/ GIMT_Encode4(628894), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 102*/ GIMT_Encode4(629408),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 103*/ GIMT_Encode4(630370),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 104*/ GIMT_Encode4(630734), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 105*/ GIMT_Encode4(632002), GIMT_Encode4(0),
     /*    902 */ /*TargetOpcode::G_STRICT_FLDEXP*//*Label 106*/ GIMT_Encode4(633048), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14458 */ /*AMDGPU::G_AMDGPU_ATOMIC_CMPXCHG*//*Label 107*/ GIMT_Encode4(633411),
     /*  14462 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_ADD*//*Label 108*/ GIMT_Encode4(635715),
     /*  14466 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_AND*//*Label 109*/ GIMT_Encode4(638099),
     /*  14470 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_CMPSWAP*//*Label 110*/ GIMT_Encode4(640483),
     /*  14474 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_COND_SUB_U32*//*Label 111*/ GIMT_Encode4(644777),
     /*  14478 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_DEC*//*Label 112*/ GIMT_Encode4(645394),
     /*  14482 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_FADD*//*Label 113*/ GIMT_Encode4(647778),
     /*  14486 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_FMAX*//*Label 114*/ GIMT_Encode4(651420),
     /*  14490 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_FMIN*//*Label 115*/ GIMT_Encode4(655036),
     /*  14494 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_INC*//*Label 116*/ GIMT_Encode4(658652),
     /*  14498 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_OR*//*Label 117*/ GIMT_Encode4(661036),
     /*  14502 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SMAX*//*Label 118*/ GIMT_Encode4(663420),
     /*  14506 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SMIN*//*Label 119*/ GIMT_Encode4(665804),
     /*  14510 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SUB*//*Label 120*/ GIMT_Encode4(668188),
     /*  14514 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SWAP*//*Label 121*/ GIMT_Encode4(670572),
     /*  14518 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_UMAX*//*Label 122*/ GIMT_Encode4(674116),
     /*  14522 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_UMIN*//*Label 123*/ GIMT_Encode4(676500),
     /*  14526 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_XOR*//*Label 124*/ GIMT_Encode4(678884),
     /*  14530 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD*//*Label 125*/ GIMT_Encode4(681268),
     /*  14534 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_FORMAT*//*Label 126*/ GIMT_Encode4(696640),
     /*  14538 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_FORMAT_D16*//*Label 127*/ GIMT_Encode4(701548),
     /*  14542 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_FORMAT_TFE*//*Label 128*/ GIMT_Encode4(709293),
     /*  14546 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SBYTE*//*Label 129*/ GIMT_Encode4(711813),
     /*  14550 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SBYTE_TFE*//*Label 130*/ GIMT_Encode4(712419),
     /*  14554 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SSHORT*//*Label 131*/ GIMT_Encode4(713025),
     /*  14558 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SSHORT_TFE*//*Label 132*/ GIMT_Encode4(713631),
     /*  14562 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_TFE*//*Label 133*/ GIMT_Encode4(714237),
     /*  14566 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_UBYTE*//*Label 134*/ GIMT_Encode4(716757),
     /*  14570 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_UBYTE_TFE*//*Label 135*/ GIMT_Encode4(717363),
     /*  14574 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_USHORT*//*Label 136*/ GIMT_Encode4(717969),
     /*  14578 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_USHORT_TFE*//*Label 137*/ GIMT_Encode4(718575),
     /*  14582 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE*//*Label 138*/ GIMT_Encode4(719181),
     /*  14586 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE_BYTE*//*Label 139*/ GIMT_Encode4(734489),
     /*  14590 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE_FORMAT*//*Label 140*/ GIMT_Encode4(735091),
     /*  14594 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE_FORMAT_D16*//*Label 141*/ GIMT_Encode4(740579),
     /*  14598 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE_SHORT*//*Label 142*/ GIMT_Encode4(746844), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14614 */ /*AMDGPU::G_AMDGPU_CLAMP*//*Label 143*/ GIMT_Encode4(747446), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14626 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE0*//*Label 144*/ GIMT_Encode4(748385),
     /*  14630 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE1*//*Label 145*/ GIMT_Encode4(748430),
     /*  14634 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE2*//*Label 146*/ GIMT_Encode4(748475),
     /*  14638 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE3*//*Label 147*/ GIMT_Encode4(748520),
     /*  14642 */ /*AMDGPU::G_AMDGPU_CVT_PK_I16_I32*//*Label 148*/ GIMT_Encode4(748565),
     /*  14646 */ /*AMDGPU::G_AMDGPU_FFBH_U32*//*Label 149*/ GIMT_Encode4(748595),
     /*  14650 */ /*AMDGPU::G_AMDGPU_FFBL_B32*//*Label 150*/ GIMT_Encode4(748697),
     /*  14654 */ /*AMDGPU::G_AMDGPU_FMAX_LEGACY*//*Label 151*/ GIMT_Encode4(748796),
     /*  14658 */ /*AMDGPU::G_AMDGPU_FMED3*//*Label 152*/ GIMT_Encode4(748869),
     /*  14662 */ /*AMDGPU::G_AMDGPU_FMIN_LEGACY*//*Label 153*/ GIMT_Encode4(749229), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14694 */ /*AMDGPU::G_AMDGPU_RCP_IFLAG*//*Label 154*/ GIMT_Encode4(749302), GIMT_Encode4(0),
     /*  14702 */ /*AMDGPU::G_AMDGPU_SMED3*//*Label 155*/ GIMT_Encode4(749352),
     /*  14706 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD*//*Label 156*/ GIMT_Encode4(749658),
     /*  14710 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_SBYTE*//*Label 157*/ GIMT_Encode4(751960),
     /*  14714 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_SSHORT*//*Label 158*/ GIMT_Encode4(752098),
     /*  14718 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_UBYTE*//*Label 159*/ GIMT_Encode4(752236),
     /*  14722 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_USHORT*//*Label 160*/ GIMT_Encode4(752374),
     /*  14726 */ /*AMDGPU::G_AMDGPU_S_BUFFER_PREFETCH*//*Label 161*/ GIMT_Encode4(752512), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14738 */ /*AMDGPU::G_AMDGPU_TBUFFER_LOAD_FORMAT*//*Label 162*/ GIMT_Encode4(752619),
     /*  14742 */ /*AMDGPU::G_AMDGPU_TBUFFER_LOAD_FORMAT_D16*//*Label 163*/ GIMT_Encode4(758103),
     /*  14746 */ /*AMDGPU::G_AMDGPU_TBUFFER_STORE_FORMAT*//*Label 164*/ GIMT_Encode4(763532),
     /*  14750 */ /*AMDGPU::G_AMDGPU_TBUFFER_STORE_FORMAT_D16*//*Label 165*/ GIMT_Encode4(769000),
     /*  14754 */ /*AMDGPU::G_AMDGPU_UMED3*//*Label 166*/ GIMT_Encode4(773605),
     /*  14758 */ // Label 0: @14758
     /*  14758 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 173*/ GIMT_Encode4(37999),
     /*  14769 */ /*GILLT_s1*//*Label 168*/ GIMT_Encode4(14789),
     /*  14773 */ /*GILLT_s16*//*Label 169*/ GIMT_Encode4(14908),
     /*  14777 */ /*GILLT_s32*//*Label 170*/ GIMT_Encode4(15899),
     /*  14781 */ /*GILLT_s64*//*Label 171*/ GIMT_Encode4(37258),
     /*  14785 */ /*GILLT_v2s16*//*Label 172*/ GIMT_Encode4(37729),
     /*  14789 */ // Label 168: @14789
     /*  14789 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(14907),
     /*  14794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  14797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  14800 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(14828), // Rule ID 7412 //
     /*  14805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  14808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  14812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  14816 */     // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
     /*  14816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B64),
     /*  14819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  14821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  14823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  14826 */     GIR_RootConstrainSelectedInstOperands,
     /*  14827 */     // GIR_Coverage, 7412,
     /*  14827 */     GIR_EraseRootFromParent_Done,
     /*  14828 */   // Label 175: @14828
     /*  14828 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(14856), // Rule ID 7419 //
     /*  14833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  14836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  14840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  14844 */     // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
     /*  14844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B32),
     /*  14847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  14849 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  14851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  14854 */     GIR_RootConstrainSelectedInstOperands,
     /*  14855 */     // GIR_Coverage, 7419,
     /*  14855 */     GIR_EraseRootFromParent_Done,
     /*  14856 */   // Label 176: @14856
     /*  14856 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(14881), // Rule ID 7410 //
     /*  14861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  14864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  14868 */     // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  14868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
     /*  14873 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  14879 */     GIR_RootConstrainSelectedInstOperands,
     /*  14880 */     // GIR_Coverage, 7410,
     /*  14880 */     GIR_Done,
     /*  14881 */   // Label 177: @14881
     /*  14881 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(14906), // Rule ID 7417 //
     /*  14886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  14889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  14893 */     // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  14893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /*  14898 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  14904 */     GIR_RootConstrainSelectedInstOperands,
     /*  14905 */     // GIR_Coverage, 7417,
     /*  14905 */     GIR_Done,
     /*  14906 */   // Label 178: @14906
     /*  14906 */   GIM_Reject,
     /*  14907 */ // Label 174: @14907
     /*  14907 */ GIM_Reject,
     /*  14908 */ // Label 169: @14908
     /*  14908 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(15898),
     /*  14913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  14916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  14919 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(14971), // Rule ID 7021 //
     /*  14924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  14928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  14936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  14948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14952 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34225),
     /*  14956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14958 */     // (add:{ *:[i16] } (trunc:{ *:[i16] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34225>>), i16:{ *:[i16] }:$val)  =>  (V_BCNT_U32_B32_e64:{ *:[i16] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i16] }:$val)
     /*  14958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  14961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  14963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // popcnt
     /*  14967 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  14969 */     GIR_RootConstrainSelectedInstOperands,
     /*  14970 */     // GIR_Coverage, 7021,
     /*  14970 */     GIR_EraseRootFromParent_Done,
     /*  14971 */   // Label 180: @14971
     /*  14971 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(15023), // Rule ID 11146 //
     /*  14976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  14980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  14988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  15000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  15004 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34225),
     /*  15008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15010 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$val, (trunc:{ *:[i16] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34225>>))  =>  (V_BCNT_U32_B32_e64:{ *:[i16] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i16] }:$val)
     /*  15010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  15013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // popcnt
     /*  15019 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  15021 */     GIR_RootConstrainSelectedInstOperands,
     /*  15022 */     // GIR_Coverage, 11146,
     /*  15022 */     GIR_EraseRootFromParent_Done,
     /*  15023 */   // Label 181: @15023
     /*  15023 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(15066), // Rule ID 2531 //
     /*  15028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /*  15031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /*  15047 */     // MIs[1] Operand 1
     /*  15047 */     // No operand predicates
     /*  15047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15049 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_U16_e64:{ *:[i16] } VSrc_b16:{ *:[i16] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1))
     /*  15049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /*  15052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15054 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  15056 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  15061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15064 */     GIR_RootConstrainSelectedInstOperands,
     /*  15065 */     // GIR_Coverage, 2531,
     /*  15065 */     GIR_EraseRootFromParent_Done,
     /*  15066 */   // Label 182: @15066
     /*  15066 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(15118), // Rule ID 2667 //
     /*  15071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /*  15074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /*  15090 */     // MIs[1] Operand 1
     /*  15090 */     // No operand predicates
     /*  15090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15092 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_NC_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1), 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  15092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_e64),
     /*  15095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15100 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  15102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15105 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  15110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15116 */     GIR_RootConstrainSelectedInstOperands,
     /*  15117 */     // GIR_Coverage, 2667,
     /*  15117 */     GIR_EraseRootFromParent_Done,
     /*  15118 */   // Label 183: @15118
     /*  15118 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(15170), // Rule ID 2670 //
     /*  15123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  15126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  15130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /*  15142 */     // MIs[1] Operand 1
     /*  15142 */     // No operand predicates
     /*  15142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15144 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_NC_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, (NegateImm:{ *:[i16 bf16 f16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1), 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  15144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_t16_e64),
     /*  15147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15152 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  15154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15157 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  15162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15168 */     GIR_RootConstrainSelectedInstOperands,
     /*  15169 */     // GIR_Coverage, 2670,
     /*  15169 */     GIR_EraseRootFromParent_Done,
     /*  15170 */   // Label 184: @15170
     /*  15170 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(15222), // Rule ID 2673 //
     /*  15175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  15178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /*  15194 */     // MIs[1] Operand 1
     /*  15194 */     // No operand predicates
     /*  15194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15196 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_NC_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1), 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  15196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_fake16_e64),
     /*  15199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15204 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  15206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15209 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  15214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15220 */     GIR_RootConstrainSelectedInstOperands,
     /*  15221 */     // GIR_Coverage, 2673,
     /*  15221 */     GIR_EraseRootFromParent_Done,
     /*  15222 */   // Label 185: @15222
     /*  15222 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(15272), // Rule ID 2571 //
     /*  15227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX6GFX7GFX8GFX9),
     /*  15230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15252 */     // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
     /*  15255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15265 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  15267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15270 */     GIR_RootConstrainSelectedInstOperands,
     /*  15271 */     // GIR_Coverage, 2571,
     /*  15271 */     GIR_EraseRootFromParent_Done,
     /*  15272 */   // Label 186: @15272
     /*  15272 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(15334), // Rule ID 2572 //
     /*  15277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  15280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  15284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15302 */     // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_gfx9_t16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_t16_e64),
     /*  15305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15324 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  15326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15332 */     GIR_RootConstrainSelectedInstOperands,
     /*  15333 */     // GIR_Coverage, 2572,
     /*  15333 */     GIR_EraseRootFromParent_Done,
     /*  15334 */   // Label 187: @15334
     /*  15334 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(15396), // Rule ID 2573 //
     /*  15339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  15342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15364 */     // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_gfx9_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_fake16_e64),
     /*  15367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15386 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  15388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15394 */     GIR_RootConstrainSelectedInstOperands,
     /*  15395 */     // GIR_Coverage, 2573,
     /*  15395 */     GIR_EraseRootFromParent_Done,
     /*  15396 */   // Label 188: @15396
     /*  15396 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(15458), // Rule ID 2574 //
     /*  15401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts_isGFX10Plus),
     /*  15404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15426 */     // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_gfx9_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_e64),
     /*  15429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15448 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  15450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15456 */     GIR_RootConstrainSelectedInstOperands,
     /*  15457 */     // GIR_Coverage, 2574,
     /*  15457 */     GIR_EraseRootFromParent_Done,
     /*  15458 */   // Label 189: @15458
     /*  15458 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(15508), // Rule ID 8482 //
     /*  15463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX6GFX7GFX8GFX9),
     /*  15466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15488 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
     /*  15491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15501 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  15503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15506 */     GIR_RootConstrainSelectedInstOperands,
     /*  15507 */     // GIR_Coverage, 8482,
     /*  15507 */     GIR_EraseRootFromParent_Done,
     /*  15508 */   // Label 190: @15508
     /*  15508 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(15570), // Rule ID 8483 //
     /*  15513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  15516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  15520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15538 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_gfx9_t16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_t16_e64),
     /*  15541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15560 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  15562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15568 */     GIR_RootConstrainSelectedInstOperands,
     /*  15569 */     // GIR_Coverage, 8483,
     /*  15569 */     GIR_EraseRootFromParent_Done,
     /*  15570 */   // Label 191: @15570
     /*  15570 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(15632), // Rule ID 8484 //
     /*  15575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  15578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15600 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_gfx9_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_fake16_e64),
     /*  15603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15622 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  15624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15630 */     GIR_RootConstrainSelectedInstOperands,
     /*  15631 */     // GIR_Coverage, 8484,
     /*  15631 */     GIR_EraseRootFromParent_Done,
     /*  15632 */   // Label 192: @15632
     /*  15632 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(15694), // Rule ID 8485 //
     /*  15637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts_isGFX10Plus),
     /*  15640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15662 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_gfx9_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_e64),
     /*  15665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15684 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  15686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15692 */     GIR_RootConstrainSelectedInstOperands,
     /*  15693 */     // GIR_Coverage, 8485,
     /*  15693 */     GIR_EraseRootFromParent_Done,
     /*  15694 */   // Label 193: @15694
     /*  15694 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(15753), // Rule ID 1066 //
     /*  15699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /*  15702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15720 */     // (add:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  15720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_e64),
     /*  15723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  15730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  15735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  15740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  15745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15751 */     GIR_RootConstrainSelectedInstOperands,
     /*  15752 */     // GIR_Coverage, 1066,
     /*  15752 */     GIR_EraseRootFromParent_Done,
     /*  15753 */   // Label 194: @15753
     /*  15753 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(15812), // Rule ID 1067 //
     /*  15758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX10Plus),
     /*  15761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  15765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15779 */     // (add:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  15779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_t16_e64),
     /*  15782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  15789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  15794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  15799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  15804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15810 */     GIR_RootConstrainSelectedInstOperands,
     /*  15811 */     // GIR_Coverage, 1067,
     /*  15811 */     GIR_EraseRootFromParent_Done,
     /*  15812 */   // Label 195: @15812
     /*  15812 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(15871), // Rule ID 1068 //
     /*  15817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX10Plus),
     /*  15820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15838 */     // (add:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  15838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_fake16_e64),
     /*  15841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  15848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  15853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  15858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  15863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15869 */     GIR_RootConstrainSelectedInstOperands,
     /*  15870 */     // GIR_Coverage, 1068,
     /*  15870 */     GIR_EraseRootFromParent_Done,
     /*  15871 */   // Label 196: @15871
     /*  15871 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(15897), // Rule ID 909 //
     /*  15876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9),
     /*  15879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15883 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_ADD_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  15883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
     /*  15886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15888 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  15890 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15895 */     GIR_RootConstrainSelectedInstOperands,
     /*  15896 */     // GIR_Coverage, 909,
     /*  15896 */     GIR_EraseRootFromParent_Done,
     /*  15897 */   // Label 197: @15897
     /*  15897 */   GIM_Reject,
     /*  15898 */ // Label 179: @15898
     /*  15898 */ GIM_Reject,
     /*  15899 */ // Label 170: @15899
     /*  15899 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(37257),
     /*  15904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15910 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(16409), // Rule ID 8591 //
     /*  15915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  15918 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  15920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15932 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  15935 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  15940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15944 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  15948 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  15950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  15962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  15966 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  15970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  15974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15978 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  15982 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  15986 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  15990 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  15994 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  15998 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  16002 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  16006 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  16008 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16012 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16016 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  16019 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16024 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  16028 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  16032 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  16034 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  16038 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16042 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  16046 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  16050 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  16054 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16058 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  16062 */     // MIs[7] src0
     /*  16062 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16067 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  16071 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  16082 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  16086 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16090 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  16094 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  16098 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  16102 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16106 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  16110 */     // MIs[9] src1
     /*  16110 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16115 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  16119 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  16130 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  16134 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16138 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  16142 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  16146 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  16148 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  16152 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16156 */     GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
     /*  16159 */     GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16164 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  16168 */     GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
     /*  16172 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  16174 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  16178 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16182 */     GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
     /*  16186 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  16190 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
     /*  16194 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16198 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  16202 */     // MIs[13] src0
     /*  16202 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16207 */     GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
     /*  16211 */     GIM_CheckConstantInt, /*MI*/12, /*Op*/2, GIMT_Encode8(255),
     /*  16222 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
     /*  16226 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16230 */     GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
     /*  16234 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  16238 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
     /*  16242 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16246 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  16250 */     // MIs[15] src1
     /*  16250 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16255 */     GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
     /*  16259 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  16270 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
     /*  16274 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16278 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  16282 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  16286 */     GIM_CheckHasOneUse, /*MI*/16,
     /*  16288 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  16292 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16296 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  16299 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16304 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  16308 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  16312 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  16314 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  16318 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16322 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  16326 */     // MIs[18] src0
     /*  16326 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16331 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  16342 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  16346 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16350 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  16354 */     // MIs[19] src1
     /*  16354 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16359 */     GIM_CheckConstantInt, /*MI*/19, /*Op*/2, GIMT_Encode8(255),
     /*  16370 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  16372 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  16372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  16375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  16377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  16384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  16391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/2, // src2
     /*  16398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16407 */     GIR_RootConstrainSelectedInstOperands,
     /*  16408 */     // GIR_Coverage, 8591,
     /*  16408 */     GIR_EraseRootFromParent_Done,
     /*  16409 */   // Label 199: @16409
     /*  16409 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(16908), // Rule ID 8590 //
     /*  16414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  16417 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  16419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  16423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16431 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  16434 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16443 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  16447 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  16449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16465 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  16469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  16473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16477 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  16481 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  16485 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  16489 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  16493 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16497 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  16501 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  16505 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  16507 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16511 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16515 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  16518 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16523 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  16527 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  16531 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  16533 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  16537 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16541 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  16545 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  16549 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  16553 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16557 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  16561 */     // MIs[7] src0
     /*  16561 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16566 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  16570 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  16581 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  16585 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16589 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  16593 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  16597 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  16601 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16605 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  16609 */     // MIs[9] src1
     /*  16609 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16614 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  16618 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  16629 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  16633 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16637 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  16641 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  16645 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  16647 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  16651 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16655 */     GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
     /*  16658 */     GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16663 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  16667 */     GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
     /*  16671 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  16673 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  16677 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16681 */     GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
     /*  16685 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  16689 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
     /*  16693 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16697 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  16701 */     // MIs[13] src0
     /*  16701 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16706 */     GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
     /*  16710 */     GIM_CheckConstantInt, /*MI*/12, /*Op*/2, GIMT_Encode8(255),
     /*  16721 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
     /*  16725 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16729 */     GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
     /*  16733 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  16737 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
     /*  16741 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16745 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  16749 */     // MIs[15] src1
     /*  16749 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16754 */     GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
     /*  16758 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  16769 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
     /*  16773 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16777 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  16781 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  16785 */     GIM_CheckHasOneUse, /*MI*/16,
     /*  16787 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/2, // MIs[17]
     /*  16791 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16795 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  16798 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16803 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  16807 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  16811 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  16813 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  16817 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16821 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  16825 */     // MIs[18] src0
     /*  16825 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16830 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  16841 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  16845 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16849 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  16853 */     // MIs[19] src1
     /*  16853 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16858 */     GIM_CheckConstantInt, /*MI*/19, /*Op*/2, GIMT_Encode8(255),
     /*  16869 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  16871 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  16871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  16874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  16876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  16883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  16890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/1, // src2
     /*  16897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16906 */     GIR_RootConstrainSelectedInstOperands,
     /*  16907 */     // GIR_Coverage, 8590,
     /*  16907 */     GIR_EraseRootFromParent_Done,
     /*  16908 */   // Label 200: @16908
     /*  16908 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(17407), // Rule ID 8589 //
     /*  16913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  16916 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  16918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  16922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16930 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  16933 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16942 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  16946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  16948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16964 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  16968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  16972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16976 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  16980 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  16984 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  16988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  16992 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16996 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  17000 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  17004 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  17006 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17010 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17014 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  17017 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17022 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  17026 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  17030 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  17032 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  17036 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17040 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  17044 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  17048 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  17052 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17056 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  17060 */     // MIs[7] src0
     /*  17060 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17065 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  17069 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  17080 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  17084 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17088 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  17092 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  17096 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  17100 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17104 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  17108 */     // MIs[9] src1
     /*  17108 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17113 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  17117 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  17128 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  17132 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17136 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  17140 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  17144 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  17146 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  17150 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17154 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  17158 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  17162 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  17164 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  17168 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17172 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  17175 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17180 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  17184 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  17188 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  17190 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  17194 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17198 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  17202 */     // MIs[13] src0
     /*  17202 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17207 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  17218 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  17222 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17226 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  17230 */     // MIs[14] src1
     /*  17230 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17235 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  17246 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
     /*  17250 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17254 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  17257 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17262 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  17266 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  17270 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  17272 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  17276 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17280 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  17284 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  17288 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  17292 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17296 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  17300 */     // MIs[17] src0
     /*  17300 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17305 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
     /*  17309 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  17320 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  17324 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17328 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  17332 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  17336 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  17340 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17344 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  17348 */     // MIs[19] src1
     /*  17348 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17353 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
     /*  17357 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  17368 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  17370 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  17370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  17373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  17375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  17382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  17389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
     /*  17396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17405 */     GIR_RootConstrainSelectedInstOperands,
     /*  17406 */     // GIR_Coverage, 8589,
     /*  17406 */     GIR_EraseRootFromParent_Done,
     /*  17407 */   // Label 201: @17407
     /*  17407 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(17906), // Rule ID 8588 //
     /*  17412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  17415 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  17417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  17421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17429 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  17432 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17441 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  17445 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  17447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  17459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17463 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  17467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  17471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17475 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  17479 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  17483 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  17487 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  17491 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17495 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  17499 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  17503 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  17505 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17509 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17513 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  17516 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17521 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  17525 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  17529 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  17531 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  17535 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17539 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  17543 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  17547 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  17551 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17555 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  17559 */     // MIs[7] src0
     /*  17559 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17564 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  17568 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  17579 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  17583 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17587 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  17591 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  17595 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  17599 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17603 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  17607 */     // MIs[9] src1
     /*  17607 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17612 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  17616 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  17627 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  17631 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17635 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  17639 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  17643 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  17645 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  17649 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17653 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  17657 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  17661 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  17663 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  17667 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17671 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  17674 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17679 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  17683 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  17687 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  17689 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  17693 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17697 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  17701 */     // MIs[13] src0
     /*  17701 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17706 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  17717 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  17721 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17725 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  17729 */     // MIs[14] src1
     /*  17729 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17734 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  17745 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
     /*  17749 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17753 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  17756 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17761 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  17765 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  17769 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  17771 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  17775 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17779 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  17783 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  17787 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  17791 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17795 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  17799 */     // MIs[17] src0
     /*  17799 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17804 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
     /*  17808 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  17819 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  17823 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17827 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  17831 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  17835 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  17839 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17843 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  17847 */     // MIs[19] src1
     /*  17847 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17852 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
     /*  17856 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  17867 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  17869 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  17869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  17872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  17874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  17881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  17888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
     /*  17895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17904 */     GIR_RootConstrainSelectedInstOperands,
     /*  17905 */     // GIR_Coverage, 8588,
     /*  17905 */     GIR_EraseRootFromParent_Done,
     /*  17906 */   // Label 202: @17906
     /*  17906 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(18405), // Rule ID 8587 //
     /*  17911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  17914 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  17916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  17920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17928 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  17931 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17940 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  17944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  17946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  17958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17962 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  17966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  17970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17974 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  17978 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  17982 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  17986 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  17990 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17994 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  17998 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18002 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  18004 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18008 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18012 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  18016 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  18020 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  18022 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  18026 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18030 */     GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
     /*  18033 */     GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18038 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  18042 */     GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
     /*  18046 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  18048 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  18052 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18056 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  18060 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  18064 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  18068 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18072 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  18076 */     // MIs[8] src0
     /*  18076 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18081 */     GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
     /*  18085 */     GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(255),
     /*  18096 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
     /*  18100 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18104 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  18108 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  18112 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  18116 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18120 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  18124 */     // MIs[10] src1
     /*  18124 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18129 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  18133 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  18144 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
     /*  18148 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18152 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  18156 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  18160 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  18162 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  18166 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18170 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  18173 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18178 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  18182 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  18186 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  18188 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  18192 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18196 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  18200 */     // MIs[13] src0
     /*  18200 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18205 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  18216 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  18220 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18224 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  18228 */     // MIs[14] src1
     /*  18228 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18233 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  18244 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  18248 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18252 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  18255 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18260 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  18264 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  18268 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  18270 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  18274 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18278 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  18282 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  18286 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  18290 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18294 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  18298 */     // MIs[17] src0
     /*  18298 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18303 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  18307 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  18318 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  18322 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18326 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  18330 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  18334 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  18338 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18342 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  18346 */     // MIs[19] src1
     /*  18346 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18351 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  18355 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  18366 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  18368 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  18368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  18371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  18373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  18380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  18387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
     /*  18394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18403 */     GIR_RootConstrainSelectedInstOperands,
     /*  18404 */     // GIR_Coverage, 8587,
     /*  18404 */     GIR_EraseRootFromParent_Done,
     /*  18405 */   // Label 203: @18405
     /*  18405 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(18904), // Rule ID 8586 //
     /*  18410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  18413 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  18415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  18419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18427 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  18430 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18439 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  18443 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  18445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18461 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  18465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  18469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18473 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18477 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18481 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  18485 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  18489 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18493 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  18497 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18501 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  18503 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18507 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18511 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  18515 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  18519 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  18521 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  18525 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18529 */     GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
     /*  18532 */     GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18537 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  18541 */     GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
     /*  18545 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  18547 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  18551 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18555 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  18559 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  18563 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  18567 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18571 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  18575 */     // MIs[8] src0
     /*  18575 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18580 */     GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
     /*  18584 */     GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(255),
     /*  18595 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
     /*  18599 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18603 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  18607 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  18611 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  18615 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18619 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  18623 */     // MIs[10] src1
     /*  18623 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18628 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  18632 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  18643 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
     /*  18647 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18651 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  18655 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  18659 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  18661 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  18665 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18669 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  18672 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18677 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  18681 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  18685 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  18687 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  18691 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18695 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  18699 */     // MIs[13] src0
     /*  18699 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18704 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  18715 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  18719 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18723 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  18727 */     // MIs[14] src1
     /*  18727 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18732 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  18743 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  18747 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18751 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  18754 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18759 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  18763 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  18767 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  18769 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  18773 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18777 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  18781 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  18785 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  18789 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18793 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  18797 */     // MIs[17] src0
     /*  18797 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18802 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  18806 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  18817 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  18821 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18825 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  18829 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  18833 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  18837 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18841 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  18845 */     // MIs[19] src1
     /*  18845 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18850 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  18854 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  18865 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  18867 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  18867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  18870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  18872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  18879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  18886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
     /*  18893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18902 */     GIR_RootConstrainSelectedInstOperands,
     /*  18903 */     // GIR_Coverage, 8586,
     /*  18903 */     GIR_EraseRootFromParent_Done,
     /*  18904 */   // Label 204: @18904
     /*  18904 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(19403), // Rule ID 8585 //
     /*  18909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  18912 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  18914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  18918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18926 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  18929 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18938 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  18942 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  18944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18960 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  18964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  18968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18980 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  18984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  18988 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18992 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  18996 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19000 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  19002 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19006 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19010 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  19014 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  19018 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  19020 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  19024 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19028 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  19032 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  19036 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  19038 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  19042 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19046 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  19049 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19054 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  19058 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  19062 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  19064 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  19068 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19072 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  19076 */     // MIs[8] src0
     /*  19076 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19081 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  19092 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
     /*  19096 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19100 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  19104 */     // MIs[9] src1
     /*  19104 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19109 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  19120 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
     /*  19124 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19128 */     GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
     /*  19131 */     GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19136 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  19140 */     GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
     /*  19144 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  19146 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
     /*  19150 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19154 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  19158 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  19162 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  19166 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19170 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  19174 */     // MIs[12] src0
     /*  19174 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19179 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  19183 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  19194 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
     /*  19198 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19202 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  19206 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  19210 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  19214 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19218 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  19222 */     // MIs[14] src1
     /*  19222 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19227 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  19231 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  19242 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  19246 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19250 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  19253 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19258 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  19262 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  19266 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  19268 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  19272 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19276 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  19280 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  19284 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  19288 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19292 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  19296 */     // MIs[17] src0
     /*  19296 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19301 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  19305 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  19316 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  19320 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19324 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  19328 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  19332 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  19336 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19340 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  19344 */     // MIs[19] src1
     /*  19344 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19349 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  19353 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  19364 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  19366 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  19366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  19369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  19371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  19378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  19385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // src2
     /*  19392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19401 */     GIR_RootConstrainSelectedInstOperands,
     /*  19402 */     // GIR_Coverage, 8585,
     /*  19402 */     GIR_EraseRootFromParent_Done,
     /*  19403 */   // Label 205: @19403
     /*  19403 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(19902), // Rule ID 8584 //
     /*  19408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  19411 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  19413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  19417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19425 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  19428 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19437 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  19441 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  19443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19459 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  19467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19471 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19475 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19479 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  19483 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19487 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19491 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19495 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19499 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  19501 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19505 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19509 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  19513 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  19517 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  19519 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  19523 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19527 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  19531 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  19535 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  19537 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  19541 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19545 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  19548 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19553 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  19557 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  19561 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  19563 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  19567 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19571 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  19575 */     // MIs[8] src0
     /*  19575 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19580 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  19591 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
     /*  19595 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19599 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  19603 */     // MIs[9] src1
     /*  19603 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19608 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  19619 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
     /*  19623 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19627 */     GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
     /*  19630 */     GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19635 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  19639 */     GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
     /*  19643 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  19645 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
     /*  19649 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19653 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  19657 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  19661 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  19665 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19669 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  19673 */     // MIs[12] src0
     /*  19673 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19678 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  19682 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  19693 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
     /*  19697 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19701 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  19705 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  19709 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  19713 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19717 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  19721 */     // MIs[14] src1
     /*  19721 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19726 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  19730 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  19741 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  19745 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19749 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  19752 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19757 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  19761 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  19765 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  19767 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  19771 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19775 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  19779 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  19783 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  19787 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19791 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  19795 */     // MIs[17] src0
     /*  19795 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19800 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  19804 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  19815 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  19819 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19823 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  19827 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  19831 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  19835 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19839 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  19843 */     // MIs[19] src1
     /*  19843 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19848 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  19852 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  19863 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  19865 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  19865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  19868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  19870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  19877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  19884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src2
     /*  19891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19900 */     GIR_RootConstrainSelectedInstOperands,
     /*  19901 */     // GIR_Coverage, 8584,
     /*  19901 */     GIR_EraseRootFromParent_Done,
     /*  19902 */   // Label 206: @19902
     /*  19902 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(20401), // Rule ID 8583 //
     /*  19907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  19910 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  19912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  19916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19932 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  19934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19942 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  19945 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19954 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  19958 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  19960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19968 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19972 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19976 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19980 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19984 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19988 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19992 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  19996 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  20007 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  20011 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20015 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  20019 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  20023 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  20027 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20031 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  20035 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  20039 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  20043 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  20054 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  20058 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20062 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  20066 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  20070 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  20072 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  20076 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20080 */     GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
     /*  20083 */     GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20088 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  20092 */     GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
     /*  20096 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  20098 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  20102 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20106 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  20110 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  20114 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  20118 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20122 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  20126 */     // MIs[10] src0
     /*  20126 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20131 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  20135 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  20146 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
     /*  20150 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20154 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  20158 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  20162 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  20166 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20170 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  20174 */     // MIs[12] src1
     /*  20174 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20179 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  20183 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  20194 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
     /*  20198 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20202 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  20206 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  20210 */     GIM_CheckHasOneUse, /*MI*/13,
     /*  20212 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  20216 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20220 */     GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
     /*  20223 */     GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20228 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  20232 */     GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
     /*  20236 */     GIM_CheckHasOneUse, /*MI*/14,
     /*  20238 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
     /*  20242 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20246 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  20250 */     // MIs[15] src0
     /*  20250 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20255 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  20266 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
     /*  20270 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20274 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  20278 */     // MIs[16] src1
     /*  20278 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20283 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  20294 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  20298 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20302 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  20305 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20310 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  20314 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  20318 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  20320 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  20324 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20328 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  20332 */     // MIs[18] src0
     /*  20332 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20337 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  20341 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  20345 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20349 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  20353 */     // MIs[19] src1
     /*  20353 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20358 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  20362 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  20364 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  20364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  20367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  20369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  20376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  20383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/2, // src2
     /*  20390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20399 */     GIR_RootConstrainSelectedInstOperands,
     /*  20400 */     // GIR_Coverage, 8583,
     /*  20400 */     GIR_EraseRootFromParent_Done,
     /*  20401 */   // Label 207: @20401
     /*  20401 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(20900), // Rule ID 8582 //
     /*  20406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  20409 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  20411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  20415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  20433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20441 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  20444 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20453 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  20457 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  20459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  20463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20467 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20471 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20475 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20479 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20483 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20487 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20491 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  20495 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  20506 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  20510 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20514 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  20518 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  20522 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  20526 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20530 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  20534 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  20538 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  20542 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  20553 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  20557 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20561 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  20565 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  20569 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  20571 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  20575 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20579 */     GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
     /*  20582 */     GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20587 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  20591 */     GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
     /*  20595 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  20597 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  20601 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20605 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  20609 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  20613 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  20617 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20621 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  20625 */     // MIs[10] src0
     /*  20625 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20630 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  20634 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  20645 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
     /*  20649 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20653 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  20657 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  20661 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  20665 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20669 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  20673 */     // MIs[12] src1
     /*  20673 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20678 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  20682 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  20693 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
     /*  20697 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20701 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  20705 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  20709 */     GIM_CheckHasOneUse, /*MI*/13,
     /*  20711 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/2, // MIs[14]
     /*  20715 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20719 */     GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
     /*  20722 */     GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20727 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  20731 */     GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
     /*  20735 */     GIM_CheckHasOneUse, /*MI*/14,
     /*  20737 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
     /*  20741 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20745 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  20749 */     // MIs[15] src0
     /*  20749 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20754 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  20765 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
     /*  20769 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20773 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  20777 */     // MIs[16] src1
     /*  20777 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20782 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  20793 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  20797 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20801 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  20804 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20809 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  20813 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  20817 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  20819 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  20823 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20827 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  20831 */     // MIs[18] src0
     /*  20831 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20836 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  20840 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  20844 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20848 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  20852 */     // MIs[19] src1
     /*  20852 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20857 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  20861 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  20863 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  20863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  20866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  20868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  20875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  20882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/1, // src2
     /*  20889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20898 */     GIR_RootConstrainSelectedInstOperands,
     /*  20899 */     // GIR_Coverage, 8582,
     /*  20899 */     GIR_EraseRootFromParent_Done,
     /*  20900 */   // Label 208: @20900
     /*  20900 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(21399), // Rule ID 8581 //
     /*  20905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  20908 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  20910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  20914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20930 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  20932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20940 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  20943 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20952 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  20956 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  20958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  20962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20970 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20974 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20978 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20982 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20986 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20990 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  20994 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  21005 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  21009 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21013 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  21017 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  21021 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  21025 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21029 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  21033 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  21037 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  21041 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  21052 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  21056 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21060 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  21064 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  21068 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  21070 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  21074 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21078 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  21082 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  21086 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  21088 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  21092 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21096 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  21099 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21104 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  21108 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  21112 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  21114 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  21118 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21122 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  21126 */     // MIs[10] src0
     /*  21126 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21131 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  21142 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  21146 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21150 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  21154 */     // MIs[11] src1
     /*  21154 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21159 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  21170 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
     /*  21174 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21178 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  21181 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21186 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  21190 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  21194 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  21196 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  21200 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21204 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  21208 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  21212 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  21216 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21220 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  21224 */     // MIs[14] src0
     /*  21224 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21229 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  21233 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  21244 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  21248 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21252 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  21256 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  21260 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  21264 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21268 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  21272 */     // MIs[16] src1
     /*  21272 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21277 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
     /*  21281 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  21292 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  21296 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21300 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  21303 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21308 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  21312 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  21316 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  21318 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  21322 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21326 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  21330 */     // MIs[18] src0
     /*  21330 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21335 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  21339 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  21343 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21347 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  21351 */     // MIs[19] src1
     /*  21351 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21356 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  21360 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  21362 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  21362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  21365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  21367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  21374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  21381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
     /*  21388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21397 */     GIR_RootConstrainSelectedInstOperands,
     /*  21398 */     // GIR_Coverage, 8581,
     /*  21398 */     GIR_EraseRootFromParent_Done,
     /*  21399 */   // Label 209: @21399
     /*  21399 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(21898), // Rule ID 8580 //
     /*  21404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  21407 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  21409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  21413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21429 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  21431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21439 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  21442 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21447 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21451 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  21455 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  21457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21465 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21469 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21473 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21477 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21481 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  21485 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  21489 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  21493 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  21504 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  21508 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21512 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  21516 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  21520 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  21524 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21528 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  21532 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  21536 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  21540 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  21551 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  21555 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21559 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  21563 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  21567 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  21569 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  21573 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21577 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  21581 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  21585 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  21587 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  21591 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21595 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  21598 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21603 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  21607 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  21611 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  21613 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  21617 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21621 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  21625 */     // MIs[10] src0
     /*  21625 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21630 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  21641 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  21645 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21649 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  21653 */     // MIs[11] src1
     /*  21653 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21658 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  21669 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
     /*  21673 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21677 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  21680 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21685 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  21689 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  21693 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  21695 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  21699 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21703 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  21707 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  21711 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  21715 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21719 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  21723 */     // MIs[14] src0
     /*  21723 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21728 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  21732 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  21743 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  21747 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21751 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  21755 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  21759 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  21763 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21767 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  21771 */     // MIs[16] src1
     /*  21771 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21776 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
     /*  21780 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  21791 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  21795 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21799 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  21802 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21807 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  21811 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  21815 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  21817 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  21821 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21825 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  21829 */     // MIs[18] src0
     /*  21829 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21834 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  21838 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  21842 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21846 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  21850 */     // MIs[19] src1
     /*  21850 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21855 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  21859 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  21861 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  21861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  21864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  21866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  21873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  21880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
     /*  21887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21896 */     GIR_RootConstrainSelectedInstOperands,
     /*  21897 */     // GIR_Coverage, 8580,
     /*  21897 */     GIR_EraseRootFromParent_Done,
     /*  21898 */   // Label 210: @21898
     /*  21898 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(22397), // Rule ID 8579 //
     /*  21903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  21906 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  21908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  21912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21928 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  21930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21946 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  21948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  21952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21956 */     GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
     /*  21959 */     GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21964 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21968 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  21972 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  21974 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  21978 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21982 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  21986 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  21990 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  21994 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21998 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  22002 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  22006 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  22010 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(255),
     /*  22021 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
     /*  22025 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22029 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  22033 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  22037 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  22041 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22045 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  22049 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  22053 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
     /*  22057 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  22068 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
     /*  22072 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22076 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  22080 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  22084 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  22086 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  22090 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22094 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  22097 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22102 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  22106 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  22110 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  22112 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  22116 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22120 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  22124 */     // MIs[10] src0
     /*  22124 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22129 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  22140 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  22144 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22148 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  22152 */     // MIs[11] src1
     /*  22152 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22157 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  22168 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  22172 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22176 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  22179 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22184 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  22188 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  22192 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  22194 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  22198 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22202 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  22206 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  22210 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  22214 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22218 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  22222 */     // MIs[14] src0
     /*  22222 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22227 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  22231 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  22242 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  22246 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22250 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  22254 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  22258 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  22262 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22266 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  22270 */     // MIs[16] src1
     /*  22270 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22275 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  22279 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  22290 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  22294 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22298 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  22301 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22306 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  22310 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  22314 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  22316 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  22320 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22324 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  22328 */     // MIs[18] src0
     /*  22328 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22333 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  22337 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  22341 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22345 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  22349 */     // MIs[19] src1
     /*  22349 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22354 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  22358 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  22360 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  22360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  22363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  22365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  22372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
     /*  22379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
     /*  22386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22395 */     GIR_RootConstrainSelectedInstOperands,
     /*  22396 */     // GIR_Coverage, 8579,
     /*  22396 */     GIR_EraseRootFromParent_Done,
     /*  22397 */   // Label 211: @22397
     /*  22397 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(22896), // Rule ID 8578 //
     /*  22402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  22405 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  22407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  22411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22427 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  22429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  22441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  22445 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  22447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  22451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22455 */     GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
     /*  22458 */     GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22463 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22467 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  22471 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  22473 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  22477 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22481 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  22485 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  22489 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  22493 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22497 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  22501 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  22505 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  22509 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(255),
     /*  22520 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
     /*  22524 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22528 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  22532 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  22536 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  22540 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22544 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  22548 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  22552 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
     /*  22556 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  22567 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
     /*  22571 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22575 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  22579 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  22583 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  22585 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  22589 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22593 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  22596 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22601 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  22605 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  22609 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  22611 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  22615 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22619 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  22623 */     // MIs[10] src0
     /*  22623 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22628 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  22639 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  22643 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22647 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  22651 */     // MIs[11] src1
     /*  22651 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22656 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  22667 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  22671 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22675 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  22678 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22683 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  22687 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  22691 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  22693 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  22697 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22701 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  22705 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  22709 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  22713 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22717 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  22721 */     // MIs[14] src0
     /*  22721 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22726 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  22730 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  22741 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  22745 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22749 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  22753 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  22757 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  22761 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22765 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  22769 */     // MIs[16] src1
     /*  22769 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22774 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  22778 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  22789 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  22793 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22797 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  22800 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22805 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  22809 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  22813 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  22815 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  22819 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22823 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  22827 */     // MIs[18] src0
     /*  22827 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22832 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  22836 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  22840 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22844 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  22848 */     // MIs[19] src1
     /*  22848 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22853 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  22857 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  22859 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  22859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  22862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  22864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  22871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
     /*  22878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
     /*  22885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22894 */     GIR_RootConstrainSelectedInstOperands,
     /*  22895 */     // GIR_Coverage, 8578,
     /*  22895 */     GIR_EraseRootFromParent_Done,
     /*  22896 */   // Label 212: @22896
     /*  22896 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(23395), // Rule ID 8577 //
     /*  22901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  22904 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  22906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  22910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22926 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  22928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  22940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  22944 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  22946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  22950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22962 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  22964 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22968 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22972 */     GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
     /*  22975 */     GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22980 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  22984 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  22988 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  22990 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22994 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22998 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  23002 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  23006 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  23017 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
     /*  23021 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23025 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  23029 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  23033 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  23044 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
     /*  23048 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23052 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  23055 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23060 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  23064 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  23068 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  23070 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  23074 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23078 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  23082 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  23086 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  23090 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23094 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  23098 */     // MIs[9] src0
     /*  23098 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23103 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
     /*  23107 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  23118 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
     /*  23122 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23126 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  23130 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  23134 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  23138 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23142 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  23146 */     // MIs[11] src1
     /*  23146 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23151 */     GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
     /*  23155 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  23166 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  23170 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23174 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  23177 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23182 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  23186 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  23190 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  23192 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  23196 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23200 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  23204 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  23208 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  23212 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23216 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  23220 */     // MIs[14] src0
     /*  23220 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23225 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  23229 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  23240 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  23244 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23248 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  23252 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  23256 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  23260 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23264 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  23268 */     // MIs[16] src1
     /*  23268 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23273 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  23277 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  23288 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  23292 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23296 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  23299 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23304 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  23308 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  23312 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  23314 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  23318 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23322 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  23326 */     // MIs[18] src0
     /*  23326 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23331 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  23335 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  23339 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23343 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  23347 */     // MIs[19] src1
     /*  23347 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23352 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  23356 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  23358 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  23358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  23361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  23363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  23370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  23377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  23384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23393 */     GIR_RootConstrainSelectedInstOperands,
     /*  23394 */     // GIR_Coverage, 8577,
     /*  23394 */     GIR_EraseRootFromParent_Done,
     /*  23395 */   // Label 213: @23395
     /*  23395 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(23894), // Rule ID 2762 //
     /*  23400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  23403 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  23405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  23409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  23417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  23421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  23425 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  23427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  23435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  23439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  23443 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  23445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  23453 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  23457 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  23461 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  23463 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23467 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23471 */     GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
     /*  23474 */     GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23479 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  23483 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  23487 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  23489 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23493 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23497 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  23501 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  23505 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  23516 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
     /*  23520 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23524 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  23528 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  23532 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  23543 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
     /*  23547 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23551 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  23554 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23559 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  23563 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  23567 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  23569 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  23573 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23577 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  23581 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  23585 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  23589 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23593 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  23597 */     // MIs[9] src0
     /*  23597 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23602 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
     /*  23606 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  23617 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
     /*  23621 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23625 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  23629 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  23633 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  23637 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23641 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  23645 */     // MIs[11] src1
     /*  23645 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23650 */     GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
     /*  23654 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  23665 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  23669 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23673 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  23676 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23681 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  23685 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  23689 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  23691 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  23695 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23699 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  23703 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  23707 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  23711 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23715 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  23719 */     // MIs[14] src0
     /*  23719 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23724 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  23728 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  23739 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  23743 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23747 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  23751 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  23755 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  23759 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23763 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  23767 */     // MIs[16] src1
     /*  23767 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23772 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  23776 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  23787 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  23791 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23795 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  23798 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23803 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  23807 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  23811 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  23813 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  23817 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23821 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  23825 */     // MIs[18] src0
     /*  23825 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23830 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  23834 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  23838 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23842 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  23846 */     // MIs[19] src1
     /*  23846 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23851 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  23855 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  23857 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  23857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  23860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  23862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  23869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  23876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  23883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23892 */     GIR_RootConstrainSelectedInstOperands,
     /*  23893 */     // GIR_Coverage, 2762,
     /*  23893 */     GIR_EraseRootFromParent_Done,
     /*  23894 */   // Label 214: @23894
     /*  23894 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(24369), // Rule ID 9871 //
     /*  23899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  23902 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  23904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  23908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23916 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23919 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  23924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  23928 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  23932 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  23934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  23942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  23946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  23950 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  23954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  23958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  23962 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  23966 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  23970 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  23974 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  23978 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  23982 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  23986 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  23990 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  23992 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  23996 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24000 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  24003 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24008 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  24012 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  24016 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  24018 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  24022 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24026 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  24030 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  24034 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24038 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  24042 */     // MIs[7] src0
     /*  24042 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24047 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  24051 */     // MIs[6] Operand 2
     /*  24051 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  24062 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  24066 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24070 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  24074 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  24078 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24082 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  24086 */     // MIs[9] src1
     /*  24086 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24091 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  24095 */     // MIs[8] Operand 2
     /*  24095 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  24106 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  24110 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24114 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  24118 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  24122 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  24124 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  24128 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24132 */     GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
     /*  24135 */     GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24140 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  24144 */     GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
     /*  24148 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  24150 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  24154 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24158 */     GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
     /*  24162 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
     /*  24166 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24170 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  24174 */     // MIs[13] src0
     /*  24174 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24179 */     GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
     /*  24183 */     // MIs[12] Operand 2
     /*  24183 */     GIM_CheckLiteralInt, /*MI*/12, /*Op*/2, GIMT_Encode8(8),
     /*  24194 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
     /*  24198 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24202 */     GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
     /*  24206 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
     /*  24210 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24214 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  24218 */     // MIs[15] src1
     /*  24218 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24223 */     GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
     /*  24227 */     // MIs[14] Operand 2
     /*  24227 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  24238 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
     /*  24242 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24246 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  24250 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  24254 */     GIM_CheckHasOneUse, /*MI*/16,
     /*  24256 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  24260 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24264 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  24267 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24272 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  24276 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  24280 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  24282 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  24286 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24290 */     // MIs[18] src0
     /*  24290 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24295 */     // MIs[18] Operand 2
     /*  24295 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  24306 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  24310 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24314 */     // MIs[19] src1
     /*  24314 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24319 */     // MIs[19] Operand 2
     /*  24319 */     GIM_CheckLiteralInt, /*MI*/19, /*Op*/2, GIMT_Encode8(8),
     /*  24330 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  24332 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  24332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  24335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  24337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  24344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  24351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/2, // src2
     /*  24358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24367 */     GIR_RootConstrainSelectedInstOperands,
     /*  24368 */     // GIR_Coverage, 9871,
     /*  24368 */     GIR_EraseRootFromParent_Done,
     /*  24369 */   // Label 215: @24369
     /*  24369 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(24844), // Rule ID 9870 //
     /*  24374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  24377 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  24379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  24383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24391 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24394 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  24403 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  24407 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  24409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  24417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  24421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  24425 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  24429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  24433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  24437 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  24441 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  24445 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  24449 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  24453 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24457 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  24461 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  24465 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  24467 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  24471 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24475 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  24478 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24483 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  24487 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  24491 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  24493 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  24497 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24501 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  24505 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  24509 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24513 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  24517 */     // MIs[7] src0
     /*  24517 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24522 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  24526 */     // MIs[6] Operand 2
     /*  24526 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  24537 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  24541 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24545 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  24549 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  24553 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24557 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  24561 */     // MIs[9] src1
     /*  24561 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24566 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  24570 */     // MIs[8] Operand 2
     /*  24570 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  24581 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  24585 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24589 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  24593 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  24597 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  24599 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  24603 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24607 */     GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
     /*  24610 */     GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24615 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  24619 */     GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
     /*  24623 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  24625 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  24629 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24633 */     GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
     /*  24637 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
     /*  24641 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24645 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  24649 */     // MIs[13] src0
     /*  24649 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24654 */     GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
     /*  24658 */     // MIs[12] Operand 2
     /*  24658 */     GIM_CheckLiteralInt, /*MI*/12, /*Op*/2, GIMT_Encode8(8),
     /*  24669 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
     /*  24673 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24677 */     GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
     /*  24681 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
     /*  24685 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24689 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  24693 */     // MIs[15] src1
     /*  24693 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24698 */     GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
     /*  24702 */     // MIs[14] Operand 2
     /*  24702 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  24713 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
     /*  24717 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24721 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  24725 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  24729 */     GIM_CheckHasOneUse, /*MI*/16,
     /*  24731 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/2, // MIs[17]
     /*  24735 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24739 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  24742 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24747 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  24751 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  24755 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  24757 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  24761 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24765 */     // MIs[18] src0
     /*  24765 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24770 */     // MIs[18] Operand 2
     /*  24770 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  24781 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  24785 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24789 */     // MIs[19] src1
     /*  24789 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24794 */     // MIs[19] Operand 2
     /*  24794 */     GIM_CheckLiteralInt, /*MI*/19, /*Op*/2, GIMT_Encode8(8),
     /*  24805 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  24807 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  24807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  24810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  24812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  24819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  24826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/1, // src2
     /*  24833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24842 */     GIR_RootConstrainSelectedInstOperands,
     /*  24843 */     // GIR_Coverage, 9870,
     /*  24843 */     GIR_EraseRootFromParent_Done,
     /*  24844 */   // Label 216: @24844
     /*  24844 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(25319), // Rule ID 9869 //
     /*  24849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  24852 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  24854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  24858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24866 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24869 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  24878 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  24882 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  24884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  24892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  24896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  24900 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  24904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  24908 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  24912 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  24916 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  24920 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  24924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  24928 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24932 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  24936 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  24940 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  24942 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  24946 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24950 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  24953 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24958 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  24962 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  24966 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  24968 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  24972 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24976 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  24980 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  24984 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24988 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  24992 */     // MIs[7] src0
     /*  24992 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24997 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  25001 */     // MIs[6] Operand 2
     /*  25001 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  25012 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  25016 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25020 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  25024 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  25028 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25032 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  25036 */     // MIs[9] src1
     /*  25036 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25041 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  25045 */     // MIs[8] Operand 2
     /*  25045 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  25056 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  25060 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25064 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  25068 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  25072 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  25074 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  25078 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25082 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  25086 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  25090 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  25092 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  25096 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25100 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  25103 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25108 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  25112 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  25116 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  25118 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  25122 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25126 */     // MIs[13] src0
     /*  25126 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25131 */     // MIs[13] Operand 2
     /*  25131 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  25142 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  25146 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25150 */     // MIs[14] src1
     /*  25150 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25155 */     // MIs[14] Operand 2
     /*  25155 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  25166 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
     /*  25170 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25174 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  25177 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25182 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  25186 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  25190 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  25192 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  25196 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25200 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  25204 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  25208 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25212 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  25216 */     // MIs[17] src0
     /*  25216 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25221 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
     /*  25225 */     // MIs[16] Operand 2
     /*  25225 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  25236 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  25240 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25244 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  25248 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  25252 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25256 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  25260 */     // MIs[19] src1
     /*  25260 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25265 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
     /*  25269 */     // MIs[18] Operand 2
     /*  25269 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  25280 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  25282 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  25282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  25285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  25287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  25294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  25301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
     /*  25308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25317 */     GIR_RootConstrainSelectedInstOperands,
     /*  25318 */     // GIR_Coverage, 9869,
     /*  25318 */     GIR_EraseRootFromParent_Done,
     /*  25319 */   // Label 217: @25319
     /*  25319 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(25794), // Rule ID 9868 //
     /*  25324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  25327 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  25329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  25333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25341 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  25344 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  25353 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  25357 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  25359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  25367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  25371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  25375 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  25379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  25383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  25387 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  25391 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  25395 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  25399 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  25403 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25407 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  25411 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  25415 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  25417 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  25421 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25425 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  25428 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25433 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  25437 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  25441 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  25443 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  25447 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25451 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  25455 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  25459 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25463 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  25467 */     // MIs[7] src0
     /*  25467 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25472 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  25476 */     // MIs[6] Operand 2
     /*  25476 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  25487 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  25491 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25495 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  25499 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  25503 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25507 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  25511 */     // MIs[9] src1
     /*  25511 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25516 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  25520 */     // MIs[8] Operand 2
     /*  25520 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  25531 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  25535 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25539 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  25543 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  25547 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  25549 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  25553 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25557 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  25561 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  25565 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  25567 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  25571 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25575 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  25578 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25583 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  25587 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  25591 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  25593 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  25597 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25601 */     // MIs[13] src0
     /*  25601 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25606 */     // MIs[13] Operand 2
     /*  25606 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  25617 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  25621 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25625 */     // MIs[14] src1
     /*  25625 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25630 */     // MIs[14] Operand 2
     /*  25630 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  25641 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
     /*  25645 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25649 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  25652 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25657 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  25661 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  25665 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  25667 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  25671 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25675 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  25679 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  25683 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25687 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  25691 */     // MIs[17] src0
     /*  25691 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25696 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
     /*  25700 */     // MIs[16] Operand 2
     /*  25700 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  25711 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  25715 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25719 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  25723 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  25727 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25731 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  25735 */     // MIs[19] src1
     /*  25735 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25740 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
     /*  25744 */     // MIs[18] Operand 2
     /*  25744 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  25755 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  25757 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  25757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  25760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  25762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  25769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  25776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
     /*  25783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25792 */     GIR_RootConstrainSelectedInstOperands,
     /*  25793 */     // GIR_Coverage, 9868,
     /*  25793 */     GIR_EraseRootFromParent_Done,
     /*  25794 */   // Label 218: @25794
     /*  25794 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(26269), // Rule ID 9867 //
     /*  25799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  25802 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  25804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  25808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25816 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  25819 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  25828 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  25832 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  25834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  25842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  25846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  25850 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  25854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  25858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  25862 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  25866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  25870 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  25874 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  25878 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25882 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  25886 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  25890 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  25892 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  25896 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25900 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  25904 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  25908 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  25910 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25914 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25918 */     GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
     /*  25921 */     GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25926 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  25930 */     GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
     /*  25934 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  25936 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  25940 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25944 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  25948 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  25952 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25956 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  25960 */     // MIs[8] src0
     /*  25960 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25965 */     GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
     /*  25969 */     // MIs[7] Operand 2
     /*  25969 */     GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(8),
     /*  25980 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
     /*  25984 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25988 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  25992 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  25996 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26000 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  26004 */     // MIs[10] src1
     /*  26004 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26009 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  26013 */     // MIs[9] Operand 2
     /*  26013 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  26024 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
     /*  26028 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26032 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  26036 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  26040 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  26042 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  26046 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26050 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  26053 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26058 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  26062 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  26066 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  26068 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  26072 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26076 */     // MIs[13] src0
     /*  26076 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26081 */     // MIs[13] Operand 2
     /*  26081 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  26092 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  26096 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26100 */     // MIs[14] src1
     /*  26100 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26105 */     // MIs[14] Operand 2
     /*  26105 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  26116 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  26120 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26124 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  26127 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26132 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  26136 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  26140 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  26142 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  26146 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26150 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  26154 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  26158 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26162 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  26166 */     // MIs[17] src0
     /*  26166 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26171 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  26175 */     // MIs[16] Operand 2
     /*  26175 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  26186 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  26190 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26194 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  26198 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  26202 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26206 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  26210 */     // MIs[19] src1
     /*  26210 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26215 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  26219 */     // MIs[18] Operand 2
     /*  26219 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  26230 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  26232 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  26232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  26235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  26237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  26244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  26251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
     /*  26258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26267 */     GIR_RootConstrainSelectedInstOperands,
     /*  26268 */     // GIR_Coverage, 9867,
     /*  26268 */     GIR_EraseRootFromParent_Done,
     /*  26269 */   // Label 219: @26269
     /*  26269 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(26744), // Rule ID 9866 //
     /*  26274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  26277 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  26279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  26283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26291 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  26294 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26303 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  26307 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  26309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  26317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  26321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26325 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  26329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  26333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  26337 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  26341 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  26345 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  26349 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  26353 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26357 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  26361 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  26365 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  26367 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  26371 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26375 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  26379 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  26383 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  26385 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26389 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26393 */     GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
     /*  26396 */     GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26401 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  26405 */     GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
     /*  26409 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  26411 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  26415 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26419 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  26423 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  26427 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26431 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  26435 */     // MIs[8] src0
     /*  26435 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26440 */     GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
     /*  26444 */     // MIs[7] Operand 2
     /*  26444 */     GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(8),
     /*  26455 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
     /*  26459 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26463 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  26467 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  26471 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26475 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  26479 */     // MIs[10] src1
     /*  26479 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26484 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  26488 */     // MIs[9] Operand 2
     /*  26488 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  26499 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
     /*  26503 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26507 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  26511 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  26515 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  26517 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  26521 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26525 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  26528 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26533 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  26537 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  26541 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  26543 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  26547 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26551 */     // MIs[13] src0
     /*  26551 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26556 */     // MIs[13] Operand 2
     /*  26556 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  26567 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  26571 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26575 */     // MIs[14] src1
     /*  26575 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26580 */     // MIs[14] Operand 2
     /*  26580 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  26591 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  26595 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26599 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  26602 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26607 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  26611 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  26615 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  26617 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  26621 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26625 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  26629 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  26633 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26637 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  26641 */     // MIs[17] src0
     /*  26641 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26646 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  26650 */     // MIs[16] Operand 2
     /*  26650 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  26661 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  26665 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26669 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  26673 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  26677 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26681 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  26685 */     // MIs[19] src1
     /*  26685 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26690 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  26694 */     // MIs[18] Operand 2
     /*  26694 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  26705 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  26707 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  26707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  26710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  26712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  26719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  26726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
     /*  26733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26742 */     GIR_RootConstrainSelectedInstOperands,
     /*  26743 */     // GIR_Coverage, 9866,
     /*  26743 */     GIR_EraseRootFromParent_Done,
     /*  26744 */   // Label 220: @26744
     /*  26744 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(27219), // Rule ID 9865 //
     /*  26749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  26752 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  26754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  26758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26766 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  26769 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26778 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  26782 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  26784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  26792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  26796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26800 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  26804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  26808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  26812 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  26816 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  26820 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  26824 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  26828 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26832 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  26836 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  26840 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  26842 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  26846 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26850 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  26854 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  26858 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  26860 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26864 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26868 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  26872 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  26876 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  26878 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  26882 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26886 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  26889 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26894 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  26898 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  26902 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  26904 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  26908 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26912 */     // MIs[8] src0
     /*  26912 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26917 */     // MIs[8] Operand 2
     /*  26917 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  26928 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
     /*  26932 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26936 */     // MIs[9] src1
     /*  26936 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26941 */     // MIs[9] Operand 2
     /*  26941 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  26952 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
     /*  26956 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26960 */     GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
     /*  26963 */     GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26968 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  26972 */     GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
     /*  26976 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  26978 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
     /*  26982 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26986 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  26990 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  26994 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26998 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  27002 */     // MIs[12] src0
     /*  27002 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27007 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  27011 */     // MIs[11] Operand 2
     /*  27011 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  27022 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
     /*  27026 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27030 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  27034 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  27038 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27042 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  27046 */     // MIs[14] src1
     /*  27046 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27051 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  27055 */     // MIs[13] Operand 2
     /*  27055 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  27066 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  27070 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27074 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  27077 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27082 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  27086 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  27090 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  27092 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  27096 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27100 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  27104 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  27108 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27112 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  27116 */     // MIs[17] src0
     /*  27116 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27121 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  27125 */     // MIs[16] Operand 2
     /*  27125 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  27136 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  27140 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27144 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  27148 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  27152 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27156 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  27160 */     // MIs[19] src1
     /*  27160 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27165 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  27169 */     // MIs[18] Operand 2
     /*  27169 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  27180 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  27182 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  27182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  27185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  27187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  27194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  27201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // src2
     /*  27208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27217 */     GIR_RootConstrainSelectedInstOperands,
     /*  27218 */     // GIR_Coverage, 9865,
     /*  27218 */     GIR_EraseRootFromParent_Done,
     /*  27219 */   // Label 221: @27219
     /*  27219 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(27694), // Rule ID 9864 //
     /*  27224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  27227 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  27229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  27233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27241 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27244 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27253 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  27257 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  27259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  27267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  27271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27275 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  27279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  27283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  27287 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  27291 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  27295 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  27299 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  27303 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27307 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  27311 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  27315 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  27317 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  27321 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27325 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  27329 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  27333 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  27335 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27339 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27343 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  27347 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  27351 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  27353 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  27357 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27361 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  27364 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27369 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  27373 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  27377 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  27379 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  27383 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27387 */     // MIs[8] src0
     /*  27387 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27392 */     // MIs[8] Operand 2
     /*  27392 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  27403 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
     /*  27407 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27411 */     // MIs[9] src1
     /*  27411 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27416 */     // MIs[9] Operand 2
     /*  27416 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  27427 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
     /*  27431 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27435 */     GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
     /*  27438 */     GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27443 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  27447 */     GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
     /*  27451 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  27453 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
     /*  27457 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27461 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  27465 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  27469 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27473 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  27477 */     // MIs[12] src0
     /*  27477 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27482 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  27486 */     // MIs[11] Operand 2
     /*  27486 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  27497 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
     /*  27501 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27505 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  27509 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  27513 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27517 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  27521 */     // MIs[14] src1
     /*  27521 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27526 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  27530 */     // MIs[13] Operand 2
     /*  27530 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  27541 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  27545 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27549 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  27552 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27557 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  27561 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  27565 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  27567 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  27571 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27575 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  27579 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  27583 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27587 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  27591 */     // MIs[17] src0
     /*  27591 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27596 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  27600 */     // MIs[16] Operand 2
     /*  27600 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  27611 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  27615 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27619 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  27623 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  27627 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27631 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  27635 */     // MIs[19] src1
     /*  27635 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27640 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  27644 */     // MIs[18] Operand 2
     /*  27644 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  27655 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  27657 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  27657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  27660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  27662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  27669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  27676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src2
     /*  27683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27692 */     GIR_RootConstrainSelectedInstOperands,
     /*  27693 */     // GIR_Coverage, 9864,
     /*  27693 */     GIR_EraseRootFromParent_Done,
     /*  27694 */   // Label 222: @27694
     /*  27694 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(28169), // Rule ID 9863 //
     /*  27699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  27702 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  27704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  27708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27724 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  27726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27734 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27737 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27746 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  27750 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  27752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  27764 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  27768 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27772 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  27776 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  27780 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  27784 */     // MIs[3] Operand 2
     /*  27784 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
     /*  27795 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  27799 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27803 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  27807 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27811 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27815 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  27819 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  27823 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  27827 */     // MIs[5] Operand 2
     /*  27827 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  27838 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  27842 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27846 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  27850 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  27854 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  27856 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  27860 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27864 */     GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
     /*  27867 */     GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27872 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  27876 */     GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
     /*  27880 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  27882 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  27886 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27890 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  27894 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  27898 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27902 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  27906 */     // MIs[10] src0
     /*  27906 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  27911 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  27915 */     // MIs[9] Operand 2
     /*  27915 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  27926 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
     /*  27930 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27934 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  27938 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  27942 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27946 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  27950 */     // MIs[12] src1
     /*  27950 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  27955 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  27959 */     // MIs[11] Operand 2
     /*  27959 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  27970 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
     /*  27974 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27978 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  27982 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  27986 */     GIM_CheckHasOneUse, /*MI*/13,
     /*  27988 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  27992 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27996 */     GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
     /*  27999 */     GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28004 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  28008 */     GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
     /*  28012 */     GIM_CheckHasOneUse, /*MI*/14,
     /*  28014 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
     /*  28018 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28022 */     // MIs[15] src0
     /*  28022 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28027 */     // MIs[15] Operand 2
     /*  28027 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  28038 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
     /*  28042 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28046 */     // MIs[16] src1
     /*  28046 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28051 */     // MIs[16] Operand 2
     /*  28051 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  28062 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  28066 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28070 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  28073 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28078 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  28082 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  28086 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  28088 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  28092 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  28096 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  28100 */     // MIs[18] src0
     /*  28100 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28105 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  28109 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  28113 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  28117 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  28121 */     // MIs[19] src1
     /*  28121 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28126 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  28130 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  28132 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  28132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  28135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  28137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  28144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  28151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/2, // src2
     /*  28158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28167 */     GIR_RootConstrainSelectedInstOperands,
     /*  28168 */     // GIR_Coverage, 9863,
     /*  28168 */     GIR_EraseRootFromParent_Done,
     /*  28169 */   // Label 223: @28169
     /*  28169 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(28644), // Rule ID 9862 //
     /*  28174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  28177 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  28179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  28183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  28195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  28199 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  28201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28209 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28212 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  28221 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  28225 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  28227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28235 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  28239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  28243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28247 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  28251 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  28255 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  28259 */     // MIs[3] Operand 2
     /*  28259 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
     /*  28270 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  28274 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28278 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  28282 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28286 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28290 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  28294 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  28298 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  28302 */     // MIs[5] Operand 2
     /*  28302 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  28313 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  28317 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28321 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  28325 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  28329 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  28331 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  28335 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28339 */     GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
     /*  28342 */     GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28347 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  28351 */     GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
     /*  28355 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  28357 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  28361 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28365 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  28369 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  28373 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28377 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  28381 */     // MIs[10] src0
     /*  28381 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28386 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  28390 */     // MIs[9] Operand 2
     /*  28390 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  28401 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
     /*  28405 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28409 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  28413 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  28417 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28421 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  28425 */     // MIs[12] src1
     /*  28425 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28430 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  28434 */     // MIs[11] Operand 2
     /*  28434 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  28445 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
     /*  28449 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28453 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  28457 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  28461 */     GIM_CheckHasOneUse, /*MI*/13,
     /*  28463 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/2, // MIs[14]
     /*  28467 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28471 */     GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
     /*  28474 */     GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28479 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  28483 */     GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
     /*  28487 */     GIM_CheckHasOneUse, /*MI*/14,
     /*  28489 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
     /*  28493 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28497 */     // MIs[15] src0
     /*  28497 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28502 */     // MIs[15] Operand 2
     /*  28502 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  28513 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
     /*  28517 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28521 */     // MIs[16] src1
     /*  28521 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28526 */     // MIs[16] Operand 2
     /*  28526 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  28537 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  28541 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28545 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  28548 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28553 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  28557 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  28561 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  28563 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  28567 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  28571 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  28575 */     // MIs[18] src0
     /*  28575 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28580 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  28584 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  28588 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  28592 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  28596 */     // MIs[19] src1
     /*  28596 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28601 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  28605 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  28607 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  28607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  28610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  28612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  28619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  28626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/1, // src2
     /*  28633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28642 */     GIR_RootConstrainSelectedInstOperands,
     /*  28643 */     // GIR_Coverage, 9862,
     /*  28643 */     GIR_EraseRootFromParent_Done,
     /*  28644 */   // Label 224: @28644
     /*  28644 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(29119), // Rule ID 9861 //
     /*  28649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  28652 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  28654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  28658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  28670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  28674 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  28676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28684 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28687 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  28696 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  28700 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  28702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28710 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  28714 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  28718 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28722 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  28726 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  28730 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  28734 */     // MIs[3] Operand 2
     /*  28734 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
     /*  28745 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  28749 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28753 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  28757 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28761 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28765 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  28769 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  28773 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  28777 */     // MIs[5] Operand 2
     /*  28777 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  28788 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  28792 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28796 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  28800 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  28804 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  28806 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  28810 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28814 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  28818 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  28822 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  28824 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  28828 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28832 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  28835 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28840 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  28844 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  28848 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  28850 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  28854 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28858 */     // MIs[10] src0
     /*  28858 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28863 */     // MIs[10] Operand 2
     /*  28863 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  28874 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  28878 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28882 */     // MIs[11] src1
     /*  28882 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28887 */     // MIs[11] Operand 2
     /*  28887 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  28898 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
     /*  28902 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28906 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  28909 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28914 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  28918 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  28922 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  28924 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  28928 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28932 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  28936 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  28940 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28944 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  28948 */     // MIs[14] src0
     /*  28948 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28953 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  28957 */     // MIs[13] Operand 2
     /*  28957 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  28968 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  28972 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28976 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  28980 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  28984 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28988 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  28992 */     // MIs[16] src1
     /*  28992 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28997 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
     /*  29001 */     // MIs[15] Operand 2
     /*  29001 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  29012 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  29016 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29020 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  29023 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29028 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  29032 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  29036 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  29038 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  29042 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29046 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  29050 */     // MIs[18] src0
     /*  29050 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  29055 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  29059 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  29063 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29067 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  29071 */     // MIs[19] src1
     /*  29071 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  29076 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  29080 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  29082 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  29082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  29085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  29087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  29094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  29101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
     /*  29108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29117 */     GIR_RootConstrainSelectedInstOperands,
     /*  29118 */     // GIR_Coverage, 9861,
     /*  29118 */     GIR_EraseRootFromParent_Done,
     /*  29119 */   // Label 225: @29119
     /*  29119 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(29594), // Rule ID 9860 //
     /*  29124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  29127 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  29129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  29133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  29145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  29149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  29151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29159 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  29162 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  29171 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  29175 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  29177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29185 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  29189 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  29193 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29197 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  29201 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  29205 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  29209 */     // MIs[3] Operand 2
     /*  29209 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
     /*  29220 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  29224 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29228 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  29232 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29236 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29240 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  29244 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  29248 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  29252 */     // MIs[5] Operand 2
     /*  29252 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  29263 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  29267 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29271 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  29275 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  29279 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  29281 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  29285 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29289 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  29293 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  29297 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  29299 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  29303 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29307 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  29310 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29315 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  29319 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  29323 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  29325 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  29329 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29333 */     // MIs[10] src0
     /*  29333 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  29338 */     // MIs[10] Operand 2
     /*  29338 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  29349 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  29353 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29357 */     // MIs[11] src1
     /*  29357 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  29362 */     // MIs[11] Operand 2
     /*  29362 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  29373 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
     /*  29377 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29381 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  29384 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29389 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  29393 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  29397 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  29399 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  29403 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29407 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  29411 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  29415 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29419 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  29423 */     // MIs[14] src0
     /*  29423 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  29428 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  29432 */     // MIs[13] Operand 2
     /*  29432 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  29443 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  29447 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29451 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  29455 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  29459 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29463 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  29467 */     // MIs[16] src1
     /*  29467 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  29472 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
     /*  29476 */     // MIs[15] Operand 2
     /*  29476 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  29487 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  29491 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29495 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  29498 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29503 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  29507 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  29511 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  29513 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  29517 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29521 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  29525 */     // MIs[18] src0
     /*  29525 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  29530 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  29534 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  29538 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29542 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  29546 */     // MIs[19] src1
     /*  29546 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  29551 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  29555 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  29557 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  29557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  29560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  29562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  29569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  29576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
     /*  29583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29592 */     GIR_RootConstrainSelectedInstOperands,
     /*  29593 */     // GIR_Coverage, 9860,
     /*  29593 */     GIR_EraseRootFromParent_Done,
     /*  29594 */   // Label 226: @29594
     /*  29594 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(30069), // Rule ID 9859 //
     /*  29599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  29602 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  29604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  29608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  29620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  29624 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  29626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  29638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  29642 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  29644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29652 */     GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
     /*  29655 */     GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29660 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  29664 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  29668 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  29670 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  29674 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29678 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  29682 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  29686 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29690 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  29694 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  29698 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  29702 */     // MIs[4] Operand 2
     /*  29702 */     GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  29713 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
     /*  29717 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29721 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  29725 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  29729 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29733 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  29737 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  29741 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
     /*  29745 */     // MIs[6] Operand 2
     /*  29745 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  29756 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
     /*  29760 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29764 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  29768 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  29772 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  29774 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  29778 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29782 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  29785 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29790 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  29794 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  29798 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  29800 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  29804 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29808 */     // MIs[10] src0
     /*  29808 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  29813 */     // MIs[10] Operand 2
     /*  29813 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  29824 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  29828 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29832 */     // MIs[11] src1
     /*  29832 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  29837 */     // MIs[11] Operand 2
     /*  29837 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  29848 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  29852 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29856 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  29859 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29864 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  29868 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  29872 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  29874 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  29878 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29882 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  29886 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  29890 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29894 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  29898 */     // MIs[14] src0
     /*  29898 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  29903 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  29907 */     // MIs[13] Operand 2
     /*  29907 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  29918 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  29922 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29926 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  29930 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  29934 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29938 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  29942 */     // MIs[16] src1
     /*  29942 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  29947 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  29951 */     // MIs[15] Operand 2
     /*  29951 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  29962 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  29966 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29970 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  29973 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29978 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  29982 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  29986 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  29988 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  29992 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29996 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  30000 */     // MIs[18] src0
     /*  30000 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30005 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  30009 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  30013 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30017 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  30021 */     // MIs[19] src1
     /*  30021 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  30026 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  30030 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  30032 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  30032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  30035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  30037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  30044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
     /*  30051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
     /*  30058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30067 */     GIR_RootConstrainSelectedInstOperands,
     /*  30068 */     // GIR_Coverage, 9859,
     /*  30068 */     GIR_EraseRootFromParent_Done,
     /*  30069 */   // Label 227: @30069
     /*  30069 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(30544), // Rule ID 9858 //
     /*  30074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  30077 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  30079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  30083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  30095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  30099 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  30101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  30113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  30117 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  30119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30127 */     GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
     /*  30130 */     GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30135 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  30139 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  30143 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  30145 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  30149 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30153 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  30157 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  30161 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30165 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  30169 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  30173 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  30177 */     // MIs[4] Operand 2
     /*  30177 */     GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  30188 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
     /*  30192 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30196 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  30200 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  30204 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30208 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  30212 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  30216 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
     /*  30220 */     // MIs[6] Operand 2
     /*  30220 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  30231 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
     /*  30235 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30239 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  30243 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  30247 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  30249 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  30253 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30257 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  30260 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30265 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  30269 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  30273 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  30275 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  30279 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30283 */     // MIs[10] src0
     /*  30283 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30288 */     // MIs[10] Operand 2
     /*  30288 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  30299 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  30303 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30307 */     // MIs[11] src1
     /*  30307 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  30312 */     // MIs[11] Operand 2
     /*  30312 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  30323 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  30327 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30331 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  30334 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30339 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  30343 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  30347 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  30349 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  30353 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30357 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  30361 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  30365 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30369 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  30373 */     // MIs[14] src0
     /*  30373 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30378 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  30382 */     // MIs[13] Operand 2
     /*  30382 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  30393 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  30397 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30401 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  30405 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  30409 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30413 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  30417 */     // MIs[16] src1
     /*  30417 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  30422 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  30426 */     // MIs[15] Operand 2
     /*  30426 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  30437 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  30441 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30445 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  30448 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30453 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  30457 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  30461 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  30463 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  30467 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30471 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  30475 */     // MIs[18] src0
     /*  30475 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30480 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  30484 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  30488 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30492 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  30496 */     // MIs[19] src1
     /*  30496 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  30501 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  30505 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  30507 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  30507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  30510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  30512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  30519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
     /*  30526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
     /*  30533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30542 */     GIR_RootConstrainSelectedInstOperands,
     /*  30543 */     // GIR_Coverage, 9858,
     /*  30543 */     GIR_EraseRootFromParent_Done,
     /*  30544 */   // Label 228: @30544
     /*  30544 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(31019), // Rule ID 9857 //
     /*  30549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  30552 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  30554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  30558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  30570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  30574 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  30576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  30588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  30592 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  30594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  30606 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  30610 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  30612 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  30616 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30620 */     GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
     /*  30623 */     GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30628 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  30632 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  30636 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  30638 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  30642 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30646 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  30650 */     // MIs[5] Operand 2
     /*  30650 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  30661 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
     /*  30665 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30669 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  30673 */     // MIs[6] Operand 2
     /*  30673 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  30684 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
     /*  30688 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30692 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  30695 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30700 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  30704 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  30708 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  30710 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  30714 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30718 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  30722 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  30726 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30730 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  30734 */     // MIs[9] src0
     /*  30734 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30739 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
     /*  30743 */     // MIs[8] Operand 2
     /*  30743 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  30754 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
     /*  30758 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30762 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  30766 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  30770 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30774 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  30778 */     // MIs[11] src1
     /*  30778 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  30783 */     GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
     /*  30787 */     // MIs[10] Operand 2
     /*  30787 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  30798 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  30802 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30806 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  30809 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30814 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  30818 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  30822 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  30824 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  30828 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30832 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  30836 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  30840 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30844 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  30848 */     // MIs[14] src0
     /*  30848 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30853 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  30857 */     // MIs[13] Operand 2
     /*  30857 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  30868 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  30872 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30876 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  30880 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  30884 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30888 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  30892 */     // MIs[16] src1
     /*  30892 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  30897 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  30901 */     // MIs[15] Operand 2
     /*  30901 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  30912 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  30916 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30920 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  30923 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30928 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  30932 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  30936 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  30938 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  30942 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30946 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  30950 */     // MIs[18] src0
     /*  30950 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30955 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  30959 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  30963 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30967 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  30971 */     // MIs[19] src1
     /*  30971 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  30976 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  30980 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  30982 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  30982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  30985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  30987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  30994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  31001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  31008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31017 */     GIR_RootConstrainSelectedInstOperands,
     /*  31018 */     // GIR_Coverage, 9857,
     /*  31018 */     GIR_EraseRootFromParent_Done,
     /*  31019 */   // Label 229: @31019
     /*  31019 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(31494), // Rule ID 2778 //
     /*  31024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  31027 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  31029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  31033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  31045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  31049 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  31051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  31063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  31067 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  31069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31077 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  31081 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  31085 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  31087 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  31091 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31095 */     GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
     /*  31098 */     GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  31103 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  31107 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  31111 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  31113 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31117 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31121 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  31125 */     // MIs[5] Operand 2
     /*  31125 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  31136 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
     /*  31140 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31144 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  31148 */     // MIs[6] Operand 2
     /*  31148 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  31159 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
     /*  31163 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31167 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  31170 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  31175 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  31179 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  31183 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  31185 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  31189 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31193 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  31197 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  31201 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31205 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  31209 */     // MIs[9] src0
     /*  31209 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  31214 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
     /*  31218 */     // MIs[8] Operand 2
     /*  31218 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  31229 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
     /*  31233 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31237 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  31241 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  31245 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31249 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  31253 */     // MIs[11] src1
     /*  31253 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  31258 */     GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
     /*  31262 */     // MIs[10] Operand 2
     /*  31262 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  31273 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  31277 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31281 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  31284 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  31289 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  31293 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  31297 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  31299 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  31303 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31307 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  31311 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  31315 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31319 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  31323 */     // MIs[14] src0
     /*  31323 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  31328 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  31332 */     // MIs[13] Operand 2
     /*  31332 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  31343 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  31347 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31351 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  31355 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  31359 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31363 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  31367 */     // MIs[16] src1
     /*  31367 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  31372 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  31376 */     // MIs[15] Operand 2
     /*  31376 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  31387 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  31391 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31395 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  31398 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  31403 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  31407 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  31411 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  31413 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  31417 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  31421 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  31425 */     // MIs[18] src0
     /*  31425 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  31430 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  31434 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  31438 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  31442 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  31446 */     // MIs[19] src1
     /*  31446 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  31451 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  31455 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  31457 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  31457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  31460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  31462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  31469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  31476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  31483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31492 */     GIR_RootConstrainSelectedInstOperands,
     /*  31493 */     // GIR_Coverage, 2778,
     /*  31493 */     GIR_EraseRootFromParent_Done,
     /*  31494 */   // Label 230: @31494
     /*  31494 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(31717), // Rule ID 8514 //
     /*  31499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  31502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  31506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31514 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31517 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  31526 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  31530 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  31532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  31544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  31548 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  31559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  31563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31567 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  31571 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  31575 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  31586 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  31590 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31594 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  31598 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  31602 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  31604 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  31608 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31612 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  31615 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31620 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  31624 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  31628 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  31630 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31634 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31638 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  31642 */     // MIs[6] src0
     /*  31642 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31647 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  31651 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  31655 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31659 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  31663 */     // MIs[7] src1
     /*  31663 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31668 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  31672 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  31674 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  31674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /*  31677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  31679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  31686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  31693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // src2
     /*  31700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31715 */     GIR_RootConstrainSelectedInstOperands,
     /*  31716 */     // GIR_Coverage, 8514,
     /*  31716 */     GIR_EraseRootFromParent_Done,
     /*  31717 */   // Label 231: @31717
     /*  31717 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(31940), // Rule ID 8515 //
     /*  31722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  31725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  31729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31737 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31740 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  31749 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  31753 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  31755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  31767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  31771 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  31782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  31786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  31794 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  31798 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  31809 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  31813 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31817 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  31821 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  31825 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  31827 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31831 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31835 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  31838 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31843 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  31847 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  31851 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  31853 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31857 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31861 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  31865 */     // MIs[6] src0
     /*  31865 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31870 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  31874 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  31878 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31882 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  31886 */     // MIs[7] src1
     /*  31886 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31891 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  31895 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  31897 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  31897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /*  31900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  31902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  31909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  31916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src2
     /*  31923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31938 */     GIR_RootConstrainSelectedInstOperands,
     /*  31939 */     // GIR_Coverage, 8515,
     /*  31939 */     GIR_EraseRootFromParent_Done,
     /*  31940 */   // Label 232: @31940
     /*  31940 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(32163), // Rule ID 2754 //
     /*  31945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  31948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  31952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  31964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  31968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  31970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31978 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31981 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  31990 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  31994 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  31996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  32000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  32004 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32008 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  32012 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  32016 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
     /*  32020 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  32024 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32028 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32032 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  32036 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32040 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32044 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32047 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  32052 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32056 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32060 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32062 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32066 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32070 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  32074 */     // MIs[6] src0
     /*  32074 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32079 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(65535),
     /*  32090 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32094 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32098 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  32102 */     // MIs[7] src1
     /*  32102 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  32107 */     GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(65535),
     /*  32118 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32120 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /*  32123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  32132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  32139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  32146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32161 */     GIR_RootConstrainSelectedInstOperands,
     /*  32162 */     // GIR_Coverage, 2754,
     /*  32162 */     GIR_EraseRootFromParent_Done,
     /*  32163 */   // Label 233: @32163
     /*  32163 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(32386), // Rule ID 8513 //
     /*  32168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  32171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  32175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  32183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  32187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  32191 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  32193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32201 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32204 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  32209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  32213 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  32217 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  32219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  32223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  32227 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32231 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  32235 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  32239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
     /*  32243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  32247 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32251 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32255 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  32259 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32263 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32267 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32270 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  32275 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32279 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32283 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32285 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32289 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32293 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  32297 */     // MIs[6] src0
     /*  32297 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32302 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(65535),
     /*  32313 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32317 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32321 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  32325 */     // MIs[7] src1
     /*  32325 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  32330 */     GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(65535),
     /*  32341 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32343 */     // (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /*  32346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  32355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  32362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  32369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32384 */     GIR_RootConstrainSelectedInstOperands,
     /*  32385 */     // GIR_Coverage, 8513,
     /*  32385 */     GIR_EraseRootFromParent_Done,
     /*  32386 */   // Label 234: @32386
     /*  32386 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(32601), // Rule ID 8546 //
     /*  32391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  32394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  32398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32406 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  32409 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  32418 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  32422 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  32424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  32436 */     // MIs[2] Operand 2
     /*  32436 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  32447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  32451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32459 */     // MIs[3] Operand 2
     /*  32459 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*  32470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  32474 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  32478 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32482 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32486 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  32488 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  32492 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32496 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32499 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32504 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32508 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32512 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32514 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32518 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32522 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  32526 */     // MIs[6] src0
     /*  32526 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  32531 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  32535 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32539 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32543 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  32547 */     // MIs[7] src1
     /*  32547 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32552 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  32556 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32558 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /*  32561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  32570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  32577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // src2
     /*  32584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32599 */     GIR_RootConstrainSelectedInstOperands,
     /*  32600 */     // GIR_Coverage, 8546,
     /*  32600 */     GIR_EraseRootFromParent_Done,
     /*  32601 */   // Label 235: @32601
     /*  32601 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(32816), // Rule ID 8547 //
     /*  32606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  32609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  32613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32621 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  32624 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  32633 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  32637 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  32639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  32651 */     // MIs[2] Operand 2
     /*  32651 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  32662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  32666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32674 */     // MIs[3] Operand 2
     /*  32674 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*  32685 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  32689 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  32693 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32697 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32701 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  32703 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  32707 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32711 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32714 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32719 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32723 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32727 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32729 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32733 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32737 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  32741 */     // MIs[6] src0
     /*  32741 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  32746 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  32750 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32754 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32758 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  32762 */     // MIs[7] src1
     /*  32762 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32767 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  32771 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32773 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /*  32776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  32785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  32792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src2
     /*  32799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32814 */     GIR_RootConstrainSelectedInstOperands,
     /*  32815 */     // GIR_Coverage, 8547,
     /*  32815 */     GIR_EraseRootFromParent_Done,
     /*  32816 */   // Label 236: @32816
     /*  32816 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(33031), // Rule ID 2758 //
     /*  32821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  32824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  32828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  32836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  32840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  32844 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  32846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32854 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32857 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  32866 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  32870 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  32872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  32876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32880 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32884 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  32888 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  32892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
     /*  32896 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32900 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32904 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32908 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  32912 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32916 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32920 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32923 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32928 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32932 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32936 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32938 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32942 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32946 */     // MIs[6] src0
     /*  32946 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32951 */     // MIs[6] Operand 2
     /*  32951 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(16),
     /*  32962 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32966 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32970 */     // MIs[7] src1
     /*  32970 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  32975 */     // MIs[7] Operand 2
     /*  32975 */     GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(16),
     /*  32986 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32988 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /*  32991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  33000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  33003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  33007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  33010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  33014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33029 */     GIR_RootConstrainSelectedInstOperands,
     /*  33030 */     // GIR_Coverage, 2758,
     /*  33030 */     GIR_EraseRootFromParent_Done,
     /*  33031 */   // Label 237: @33031
     /*  33031 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(33246), // Rule ID 8545 //
     /*  33036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  33039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  33051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33059 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33069 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33072 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  33077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33081 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  33085 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  33087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  33091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  33095 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  33099 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  33103 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  33107 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
     /*  33111 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  33115 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  33119 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  33123 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  33127 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33131 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33135 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  33138 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  33143 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  33147 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  33151 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  33153 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33157 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  33161 */     // MIs[6] src0
     /*  33161 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33166 */     // MIs[6] Operand 2
     /*  33166 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(16),
     /*  33177 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  33181 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  33185 */     // MIs[7] src1
     /*  33185 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  33190 */     // MIs[7] Operand 2
     /*  33190 */     GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(16),
     /*  33201 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  33203 */     // (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /*  33206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  33211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  33215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  33218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  33222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  33225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  33229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33244 */     GIR_RootConstrainSelectedInstOperands,
     /*  33245 */     // GIR_Coverage, 8545,
     /*  33245 */     GIR_EraseRootFromParent_Done,
     /*  33246 */   // Label 238: @33246
     /*  33246 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(33299), // Rule ID 7562 //
     /*  33251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33271 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  33275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  33279 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13776),
     /*  33283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33285 */     // (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] })<<P:Predicate_anonymous_13776>>  =>  (S_BFM_B32:{ *:[i32] } ?:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  33285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BFM_B32),
     /*  33288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  33290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /*  33294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33297 */     GIR_RootConstrainSelectedInstOperands,
     /*  33298 */     // GIR_Coverage, 7562,
     /*  33298 */     GIR_EraseRootFromParent_Done,
     /*  33299 */   // Label 239: @33299
     /*  33299 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(33352), // Rule ID 7564 //
     /*  33304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33324 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  33328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  33332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19684),
     /*  33336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33338 */     // (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] })<<P:Predicate_anonymous_19684>>  =>  (V_BFM_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  33338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFM_B32_e64),
     /*  33341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /*  33347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33350 */     GIR_RootConstrainSelectedInstOperands,
     /*  33351 */     // GIR_Coverage, 7564,
     /*  33351 */     GIR_EraseRootFromParent_Done,
     /*  33352 */   // Label 240: @33352
     /*  33352 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(33462), // Rule ID 7373 //
     /*  33357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*  33369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33377 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  33381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  33391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33395 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  33399 */     // MIs[2] Operand 1
     /*  33399 */     GIM_CheckCmpPredicate, /*MI*/2, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /*  33404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  33408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  33412 */     // MIs[3] src0
     /*  33412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33417 */     // MIs[3] src1
     /*  33417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/3,
     /*  33422 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/3, // MIs[4]
     /*  33426 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  33430 */     // MIs[4] src1
     /*  33430 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/3,
     /*  33435 */     // MIs[4] src0
     /*  33435 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33440 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  33442 */     // (add:{ *:[i32] } (select:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGT:{ *:[Other] }), (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (sub:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_select_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  33445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  33451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // src1
     /*  33455 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  33457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33460 */     GIR_RootConstrainSelectedInstOperands,
     /*  33461 */     // GIR_Coverage, 7373,
     /*  33461 */     GIR_EraseRootFromParent_Done,
     /*  33462 */   // Label 241: @33462
     /*  33462 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(33572), // Rule ID 11187 //
     /*  33467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*  33479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33487 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  33491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  33501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33505 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  33509 */     // MIs[2] Operand 1
     /*  33509 */     GIM_CheckCmpPredicate, /*MI*/2, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /*  33514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  33518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  33522 */     // MIs[3] src0
     /*  33522 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33527 */     // MIs[3] src1
     /*  33527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/3,
     /*  33532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/3, // MIs[4]
     /*  33536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  33540 */     // MIs[4] src1
     /*  33540 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/3,
     /*  33545 */     // MIs[4] src0
     /*  33545 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33550 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  33552 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (select:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGT:{ *:[Other] }), (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (sub:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_select_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  33555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  33561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // src1
     /*  33565 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  33567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33570 */     GIR_RootConstrainSelectedInstOperands,
     /*  33571 */     // GIR_Coverage, 11187,
     /*  33571 */     GIR_EraseRootFromParent_Done,
     /*  33572 */   // Label 242: @33572
     /*  33572 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(33665), // Rule ID 2590 //
     /*  33577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33600 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33602 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*  33606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  33618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33622 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*  33626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  33630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33634 */     // MIs[3] Operand 1
     /*  33634 */     // No operand predicates
     /*  33634 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /*  33638 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:1:z
     /*  33642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20808),
     /*  33646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  33648 */     // (add:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:1:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20809>>, i32:{ *:[i32] }:$src2:$pred:1:z)<<P:1:Predicate_anonymous_20808>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  33648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
     /*  33651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  33661 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  33663 */     GIR_RootConstrainSelectedInstOperands,
     /*  33664 */     // GIR_Coverage, 2590,
     /*  33664 */     GIR_EraseRootFromParent_Done,
     /*  33665 */   // Label 243: @33665
     /*  33665 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(33758), // Rule ID 8487 //
     /*  33670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33677 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:1:z
     /*  33681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33699 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*  33703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  33715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33719 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*  33723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  33727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33731 */     // MIs[3] Operand 1
     /*  33731 */     // No operand predicates
     /*  33731 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /*  33735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20808),
     /*  33739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  33741 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:1:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:1:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20809>>)<<P:1:Predicate_anonymous_20808>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  33741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
     /*  33744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  33754 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  33756 */     GIR_RootConstrainSelectedInstOperands,
     /*  33757 */     // GIR_Coverage, 8487,
     /*  33757 */     GIR_EraseRootFromParent_Done,
     /*  33758 */   // Label 244: @33758
     /*  33758 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(33813), // Rule ID 7313 //
     /*  33763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33775 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33778 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  33783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33787 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  33791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33793 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2)  =>  (V_MAD_I32_I24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_I32_I24_e64),
     /*  33796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  33802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  33806 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  33808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33811 */     GIR_RootConstrainSelectedInstOperands,
     /*  33812 */     // GIR_Coverage, 7313,
     /*  33812 */     GIR_EraseRootFromParent_Done,
     /*  33813 */   // Label 245: @33813
     /*  33813 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(33868), // Rule ID 7315 //
     /*  33818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33830 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33833 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  33838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33842 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  33846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33848 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2)  =>  (V_MAD_U32_U24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U32_U24_e64),
     /*  33851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  33857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  33861 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  33863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33866 */     GIR_RootConstrainSelectedInstOperands,
     /*  33867 */     // GIR_Coverage, 7315,
     /*  33867 */     GIR_EraseRootFromParent_Done,
     /*  33868 */   // Label 246: @33868
     /*  33868 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(33933), // Rule ID 82 //
     /*  33873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33903 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  33907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33911 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl1_add),
     /*  33915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33917 */     // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 1:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl1_add>>  =>  (S_LSHL1_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  33917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL1_ADD_U32),
     /*  33920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  33922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33926 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  33931 */     GIR_RootConstrainSelectedInstOperands,
     /*  33932 */     // GIR_Coverage, 82,
     /*  33932 */     GIR_EraseRootFromParent_Done,
     /*  33933 */   // Label 247: @33933
     /*  33933 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(33998), // Rule ID 83 //
     /*  33938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33961 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33968 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*  33972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl2_add),
     /*  33980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33982 */     // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 2:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl2_add>>  =>  (S_LSHL2_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  33982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL2_ADD_U32),
     /*  33985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  33987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  33996 */     GIR_RootConstrainSelectedInstOperands,
     /*  33997 */     // GIR_Coverage, 83,
     /*  33997 */     GIR_EraseRootFromParent_Done,
     /*  33998 */   // Label 248: @33998
     /*  33998 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(34063), // Rule ID 84 //
     /*  34003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34033 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*  34037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl3_add),
     /*  34045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34047 */     // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 3:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl3_add>>  =>  (S_LSHL3_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL3_ADD_U32),
     /*  34050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34056 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34061 */     GIR_RootConstrainSelectedInstOperands,
     /*  34062 */     // GIR_Coverage, 84,
     /*  34062 */     GIR_EraseRootFromParent_Done,
     /*  34063 */   // Label 249: @34063
     /*  34063 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(34128), // Rule ID 85 //
     /*  34068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34091 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34098 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 4,
     /*  34102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl4_add),
     /*  34110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34112 */     // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 4:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl4_add>>  =>  (S_LSHL4_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL4_ADD_U32),
     /*  34115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34121 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34126 */     GIR_RootConstrainSelectedInstOperands,
     /*  34127 */     // GIR_Coverage, 85,
     /*  34127 */     GIR_EraseRootFromParent_Done,
     /*  34128 */   // Label 250: @34128
     /*  34128 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(34211), // Rule ID 7372 //
     /*  34133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34153 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34179 */     // MIs[3] src0
     /*  34179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34184 */     // MIs[3] src1
     /*  34184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34191 */     // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  34200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /*  34204 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  34206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34209 */     GIR_RootConstrainSelectedInstOperands,
     /*  34210 */     // GIR_Coverage, 7372,
     /*  34210 */     GIR_EraseRootFromParent_Done,
     /*  34211 */   // Label 251: @34211
     /*  34211 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(34294), // Rule ID 11180 //
     /*  34216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34236 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34262 */     // MIs[3] src1
     /*  34262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34267 */     // MIs[3] src0
     /*  34267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34274 */     // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  34283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /*  34287 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  34289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34292 */     GIR_RootConstrainSelectedInstOperands,
     /*  34293 */     // GIR_Coverage, 11180,
     /*  34293 */     GIR_EraseRootFromParent_Done,
     /*  34294 */   // Label 252: @34294
     /*  34294 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(34377), // Rule ID 11181 //
     /*  34299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34319 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34345 */     // MIs[3] src0
     /*  34345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34350 */     // MIs[3] src1
     /*  34350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34357 */     // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  34366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  34370 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  34372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34375 */     GIR_RootConstrainSelectedInstOperands,
     /*  34376 */     // GIR_Coverage, 11181,
     /*  34376 */     GIR_EraseRootFromParent_Done,
     /*  34377 */   // Label 253: @34377
     /*  34377 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(34460), // Rule ID 11182 //
     /*  34382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34402 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34428 */     // MIs[3] src1
     /*  34428 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34433 */     // MIs[3] src0
     /*  34433 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34440 */     // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  34449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  34453 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  34455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34458 */     GIR_RootConstrainSelectedInstOperands,
     /*  34459 */     // GIR_Coverage, 11182,
     /*  34459 */     GIR_EraseRootFromParent_Done,
     /*  34460 */   // Label 254: @34460
     /*  34460 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(34525), // Rule ID 8404 //
     /*  34465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34499 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  34503 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl1_add),
     /*  34507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34509 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 1:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl1_add>>  =>  (S_LSHL1_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL1_ADD_U32),
     /*  34512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34518 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34523 */     GIR_RootConstrainSelectedInstOperands,
     /*  34524 */     // GIR_Coverage, 8404,
     /*  34524 */     GIR_EraseRootFromParent_Done,
     /*  34525 */   // Label 255: @34525
     /*  34525 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(34590), // Rule ID 8405 //
     /*  34530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34557 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34564 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*  34568 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl2_add),
     /*  34572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34574 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 2:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl2_add>>  =>  (S_LSHL2_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL2_ADD_U32),
     /*  34577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34583 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34588 */     GIR_RootConstrainSelectedInstOperands,
     /*  34589 */     // GIR_Coverage, 8405,
     /*  34589 */     GIR_EraseRootFromParent_Done,
     /*  34590 */   // Label 256: @34590
     /*  34590 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(34655), // Rule ID 8406 //
     /*  34595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34622 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34629 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*  34633 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl3_add),
     /*  34637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34639 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 3:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl3_add>>  =>  (S_LSHL3_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL3_ADD_U32),
     /*  34642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34653 */     GIR_RootConstrainSelectedInstOperands,
     /*  34654 */     // GIR_Coverage, 8406,
     /*  34654 */     GIR_EraseRootFromParent_Done,
     /*  34655 */   // Label 257: @34655
     /*  34655 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(34720), // Rule ID 8407 //
     /*  34660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34687 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34694 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 4,
     /*  34698 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl4_add),
     /*  34702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34704 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 4:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl4_add>>  =>  (S_LSHL4_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL4_ADD_U32),
     /*  34707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34718 */     GIR_RootConstrainSelectedInstOperands,
     /*  34719 */     // GIR_Coverage, 8407,
     /*  34719 */     GIR_EraseRootFromParent_Done,
     /*  34720 */   // Label 258: @34720
     /*  34720 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(34775), // Rule ID 11147 //
     /*  34725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34737 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34740 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  34745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34749 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  34753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34755 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_I32_I24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_I32_I24_e64),
     /*  34758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  34764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  34768 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34773 */     GIR_RootConstrainSelectedInstOperands,
     /*  34774 */     // GIR_Coverage, 11147,
     /*  34774 */     GIR_EraseRootFromParent_Done,
     /*  34775 */   // Label 259: @34775
     /*  34775 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(34830), // Rule ID 11149 //
     /*  34780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34792 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34795 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  34800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34804 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  34808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34810 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_U32_U24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U32_U24_e64),
     /*  34813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  34819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  34823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34828 */     GIR_RootConstrainSelectedInstOperands,
     /*  34829 */     // GIR_Coverage, 11149,
     /*  34829 */     GIR_EraseRootFromParent_Done,
     /*  34830 */   // Label 260: @34830
     /*  34830 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(34913), // Rule ID 11183 //
     /*  34835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34855 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34881 */     // MIs[3] src0
     /*  34881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34886 */     // MIs[3] src1
     /*  34886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34891 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34893 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  34902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /*  34906 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34911 */     GIR_RootConstrainSelectedInstOperands,
     /*  34912 */     // GIR_Coverage, 11183,
     /*  34912 */     GIR_EraseRootFromParent_Done,
     /*  34913 */   // Label 261: @34913
     /*  34913 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(34996), // Rule ID 11184 //
     /*  34918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34938 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34964 */     // MIs[3] src1
     /*  34964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34969 */     // MIs[3] src0
     /*  34969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34976 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  34985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /*  34989 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34994 */     GIR_RootConstrainSelectedInstOperands,
     /*  34995 */     // GIR_Coverage, 11184,
     /*  34995 */     GIR_EraseRootFromParent_Done,
     /*  34996 */   // Label 262: @34996
     /*  34996 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(35079), // Rule ID 11185 //
     /*  35001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  35013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35021 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  35031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  35035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  35039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  35043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  35047 */     // MIs[3] src0
     /*  35047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35052 */     // MIs[3] src1
     /*  35052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35057 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  35059 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  35059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  35062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  35064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  35068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  35072 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  35074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35077 */     GIR_RootConstrainSelectedInstOperands,
     /*  35078 */     // GIR_Coverage, 11185,
     /*  35078 */     GIR_EraseRootFromParent_Done,
     /*  35079 */   // Label 263: @35079
     /*  35079 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(35162), // Rule ID 11186 //
     /*  35084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  35096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35104 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  35114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  35118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  35122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  35126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  35130 */     // MIs[3] src1
     /*  35130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35135 */     // MIs[3] src0
     /*  35135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  35142 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  35142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  35145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  35147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  35151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  35155 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  35157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35160 */     GIR_RootConstrainSelectedInstOperands,
     /*  35161 */     // GIR_Coverage, 11186,
     /*  35161 */     GIR_EraseRootFromParent_Done,
     /*  35162 */   // Label 264: @35162
     /*  35162 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(35327), // Rule ID 8497 //
     /*  35167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  35170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35174 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:11:z
     /*  35178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35198 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35200 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*  35204 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*  35208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20843),
     /*  35212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35214 */     // (add:{ *:[i32] } VGPR_32:{ *:[i32] }:$src2:$pred:11:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:11:x, i32:{ *:[i32] }:$src1:$pred:11:y)<<P:Predicate_anonymous_20844>>)<<P:11:Predicate_anonymous_20843>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35214 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35217 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35221 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35228 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35231 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35235 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35240 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  35244 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35247 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35250 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35253 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35258 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35263 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35268 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  35278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35288 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35296 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  35299 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  35302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35309 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  35316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35326 */     // GIR_Coverage, 8497,
     /*  35326 */     GIR_EraseRootFromParent_Done,
     /*  35327 */   // Label 265: @35327
     /*  35327 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(35492), // Rule ID 8501 //
     /*  35332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  35335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35339 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:14:z
     /*  35343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35363 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35365 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*  35369 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*  35373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20843),
     /*  35377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35379 */     // (add:{ *:[i32] } VGPR_32:{ *:[i32] }:$src2:$pred:14:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:14:x, i32:{ *:[i32] }:$src1:$pred:14:y)<<P:Predicate_anonymous_20844>>)<<P:14:Predicate_anonymous_20843>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35379 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35382 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35386 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35393 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35396 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35400 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35405 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  35409 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35412 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35415 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35418 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35423 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35428 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  35443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35457 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35461 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  35464 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  35467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35474 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  35481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35491 */     // GIR_Coverage, 8501,
     /*  35491 */     GIR_EraseRootFromParent_Done,
     /*  35492 */   // Label 266: @35492
     /*  35492 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(35557), // Rule ID 2593 //
     /*  35497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  35500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  35512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35520 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35522 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*  35526 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*  35530 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:3:z
     /*  35534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20814),
     /*  35538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35540 */     // (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:3:x, i32:{ *:[i32] }:$src1:$pred:3:y)<<P:Predicate_anonymous_20812>>, i32:{ *:[i32] }:$src2:$pred:3:z)<<P:3:Predicate_anonymous_20814>>  =>  (V_ADD3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  35540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD3_U32_e64),
     /*  35543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  35545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35553 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  35555 */     GIR_RootConstrainSelectedInstOperands,
     /*  35556 */     // GIR_Coverage, 2593,
     /*  35556 */     GIR_EraseRootFromParent_Done,
     /*  35557 */   // Label 267: @35557
     /*  35557 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(35722), // Rule ID 2612 //
     /*  35562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  35565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35585 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35587 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*  35591 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*  35595 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:11:z
     /*  35599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35603 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20843),
     /*  35607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35609 */     // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:11:x, i32:{ *:[i32] }:$src1:$pred:11:y)<<P:Predicate_anonymous_20844>>, VGPR_32:{ *:[i32] }:$src2:$pred:11:z)<<P:11:Predicate_anonymous_20843>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35609 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35612 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35616 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35623 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35626 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35630 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  35639 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35642 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35645 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35658 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  35673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35683 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35691 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  35694 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  35697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35704 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  35711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35721 */     // GIR_Coverage, 2612,
     /*  35721 */     GIR_EraseRootFromParent_Done,
     /*  35722 */   // Label 268: @35722
     /*  35722 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(35887), // Rule ID 2617 //
     /*  35727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  35730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35750 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35752 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*  35756 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*  35760 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:14:z
     /*  35764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20843),
     /*  35772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35774 */     // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:14:x, i32:{ *:[i32] }:$src1:$pred:14:y)<<P:Predicate_anonymous_20844>>, VGPR_32:{ *:[i32] }:$src2:$pred:14:z)<<P:14:Predicate_anonymous_20843>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35774 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35777 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35781 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35788 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35791 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35795 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35800 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  35804 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35807 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35810 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35813 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35818 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35823 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35828 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  35838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35856 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  35859 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  35862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35869 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  35876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35886 */     // GIR_Coverage, 2617,
     /*  35886 */     GIR_EraseRootFromParent_Done,
     /*  35887 */   // Label 269: @35887
     /*  35887 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(36048), // Rule ID 2611 //
     /*  35892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  35895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35915 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35917 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*  35921 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*  35925 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:10:z
     /*  35929 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20843),
     /*  35933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35935 */     // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:10:x, i32:{ *:[i32] }:$src1:$pred:10:y)<<P:Predicate_anonymous_20844>>, i32:{ *:[i32] }:$src2:$pred:10:z)<<P:10:Predicate_anonymous_20843>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35935 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35938 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35942 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35949 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35952 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35956 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35961 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  35965 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35968 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35971 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  35979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  35984 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  35989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  35999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  36009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36017 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  36020 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36030 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  36037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  36047 */     // GIR_Coverage, 2611,
     /*  36047 */     GIR_EraseRootFromParent_Done,
     /*  36048 */   // Label 270: @36048
     /*  36048 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(36209), // Rule ID 2616 //
     /*  36053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  36056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36078 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*  36082 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*  36086 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:13:z
     /*  36090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20843),
     /*  36094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36096 */     // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:13:x, i32:{ *:[i32] }:$src1:$pred:13:y)<<P:Predicate_anonymous_20844>>, i32:{ *:[i32] }:$src2:$pred:13:z)<<P:13:Predicate_anonymous_20843>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  36096 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  36099 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36103 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36110 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  36117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36122 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  36126 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  36129 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  36132 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  36135 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  36140 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  36145 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  36150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  36153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  36160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  36170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36178 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  36181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36191 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  36198 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36203 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  36208 */     // GIR_Coverage, 2616,
     /*  36208 */     GIR_EraseRootFromParent_Done,
     /*  36209 */   // Label 271: @36209
     /*  36209 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(36274), // Rule ID 2589 //
     /*  36214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36237 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36239 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*  36243 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*  36247 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:1:z
     /*  36251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20808),
     /*  36255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36257 */     // (add:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, i32:{ *:[i32] }:$src1:$pred:1:y)<<P:Predicate_anonymous_20809>>, i32:{ *:[i32] }:$src2:$pred:1:z)<<P:1:Predicate_anonymous_20808>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
     /*  36260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36270 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  36272 */     GIR_RootConstrainSelectedInstOperands,
     /*  36273 */     // GIR_Coverage, 2589,
     /*  36273 */     GIR_EraseRootFromParent_Done,
     /*  36274 */   // Label 272: @36274
     /*  36274 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(36339), // Rule ID 2599 //
     /*  36279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36302 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36304 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*  36308 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*  36312 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:8:z
     /*  36316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20827),
     /*  36320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36322 */     // (add:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:8:x, i32:{ *:[i32] }:$src1:$pred:8:y)<<P:Predicate_anonymous_20828>>, i32:{ *:[i32] }:$src2:$pred:8:z)<<P:8:Predicate_anonymous_20827>>  =>  (V_XAD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XAD_U32_e64),
     /*  36325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36335 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  36337 */     GIR_RootConstrainSelectedInstOperands,
     /*  36338 */     // GIR_Coverage, 2599,
     /*  36338 */     GIR_EraseRootFromParent_Done,
     /*  36339 */   // Label 273: @36339
     /*  36339 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(36379), // Rule ID 7019 //
     /*  36344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  36356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36360 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34225),
     /*  36364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36366 */     // (add:{ *:[i32] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34225>>, i32:{ *:[i32] }:$val)  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i32] }:$val)
     /*  36366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  36369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // popcnt
     /*  36375 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  36377 */     GIR_RootConstrainSelectedInstOperands,
     /*  36378 */     // GIR_Coverage, 7019,
     /*  36378 */     GIR_EraseRootFromParent_Done,
     /*  36379 */   // Label 274: @36379
     /*  36379 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(36444), // Rule ID 8488 //
     /*  36384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36391 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:3:z
     /*  36395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36413 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*  36417 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*  36421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20814),
     /*  36425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36427 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:3:z, (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:3:x, i32:{ *:[i32] }:$src1:$pred:3:y)<<P:Predicate_anonymous_20812>>)<<P:3:Predicate_anonymous_20814>>  =>  (V_ADD3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD3_U32_e64),
     /*  36430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36440 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  36442 */     GIR_RootConstrainSelectedInstOperands,
     /*  36443 */     // GIR_Coverage, 8488,
     /*  36443 */     GIR_EraseRootFromParent_Done,
     /*  36444 */   // Label 275: @36444
     /*  36444 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(36605), // Rule ID 8496 //
     /*  36449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  36452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36456 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:10:z
     /*  36460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36476 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36478 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*  36482 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*  36486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20843),
     /*  36490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36492 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:10:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:10:x, i32:{ *:[i32] }:$src1:$pred:10:y)<<P:Predicate_anonymous_20844>>)<<P:10:Predicate_anonymous_20843>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  36492 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  36495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36506 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  36513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36518 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  36522 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  36525 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  36528 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  36531 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  36536 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  36541 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  36546 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  36549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  36556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  36566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36574 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  36577 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36587 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  36594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  36604 */     // GIR_Coverage, 8496,
     /*  36604 */     GIR_EraseRootFromParent_Done,
     /*  36605 */   // Label 276: @36605
     /*  36605 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(36766), // Rule ID 8500 //
     /*  36610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  36613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36617 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:13:z
     /*  36621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36637 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36639 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*  36643 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*  36647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20843),
     /*  36651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36653 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:13:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:13:x, i32:{ *:[i32] }:$src1:$pred:13:y)<<P:Predicate_anonymous_20844>>)<<P:13:Predicate_anonymous_20843>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  36653 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  36656 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36660 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36667 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36670 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  36674 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  36683 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  36686 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  36689 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  36692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  36697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  36702 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  36707 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  36710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  36717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  36727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36735 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  36738 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36748 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  36755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  36765 */     // GIR_Coverage, 8500,
     /*  36765 */     GIR_EraseRootFromParent_Done,
     /*  36766 */   // Label 277: @36766
     /*  36766 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(36831), // Rule ID 8486 //
     /*  36771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36778 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:1:z
     /*  36782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36800 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*  36804 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*  36808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20808),
     /*  36812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36814 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:1:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, i32:{ *:[i32] }:$src1:$pred:1:y)<<P:Predicate_anonymous_20809>>)<<P:1:Predicate_anonymous_20808>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
     /*  36817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36827 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  36829 */     GIR_RootConstrainSelectedInstOperands,
     /*  36830 */     // GIR_Coverage, 8486,
     /*  36830 */     GIR_EraseRootFromParent_Done,
     /*  36831 */   // Label 278: @36831
     /*  36831 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(36896), // Rule ID 8493 //
     /*  36836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36843 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:8:z
     /*  36847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36863 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36865 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*  36869 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*  36873 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20827),
     /*  36877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36879 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:8:z, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:8:x, i32:{ *:[i32] }:$src1:$pred:8:y)<<P:Predicate_anonymous_20828>>)<<P:8:Predicate_anonymous_20827>>  =>  (V_XAD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XAD_U32_e64),
     /*  36882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  36894 */     GIR_RootConstrainSelectedInstOperands,
     /*  36895 */     // GIR_Coverage, 8493,
     /*  36895 */     GIR_EraseRootFromParent_Done,
     /*  36896 */   // Label 279: @36896
     /*  36896 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(36936), // Rule ID 11145 //
     /*  36901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  36913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36917 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34225),
     /*  36921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36923 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$val, (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34225>>)  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i32] }:$val)
     /*  36923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  36926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // popcnt
     /*  36932 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36934 */     GIR_RootConstrainSelectedInstOperands,
     /*  36935 */     // GIR_Coverage, 11145,
     /*  36935 */     GIR_EraseRootFromParent_Done,
     /*  36936 */   // Label 280: @36936
     /*  36936 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(36980), // Rule ID 7557 //
     /*  36941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  36945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineConst32),
     /*  36957 */     // MIs[1] Operand 1
     /*  36957 */     // No operand predicates
     /*  36957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13776),
     /*  36961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36963 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>><<X:NegateImm>>:$src1)<<P:Predicate_anonymous_13776>>  =>  (S_SUB_I32:{ *:[i32] }:{ *:[i1] } SReg_32:{ *:[i32] }:$src0, (NegateImm:{ *:[i1 i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>>:$src1))
     /*  36963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_I32),
     /*  36966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  36968 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  36970 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  36975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  36978 */     GIR_RootConstrainSelectedInstOperands,
     /*  36979 */     // GIR_Coverage, 7557,
     /*  36979 */     GIR_EraseRootFromParent_Done,
     /*  36980 */   // Label 281: @36980
     /*  36980 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(37027), // Rule ID 7558 //
     /*  36985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
     /*  36988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineConst32),
     /*  37004 */     // MIs[1] Operand 1
     /*  37004 */     // No operand predicates
     /*  37004 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19684),
     /*  37008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37010 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>><<X:NegateImm>>:$src1)<<P:Predicate_anonymous_19684>>  =>  (V_SUB_U32_e64:{ *:[i32] } VS_32:{ *:[i32] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>>:$src1))
     /*  37010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e64),
     /*  37013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37015 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  37017 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  37022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37025 */     GIR_RootConstrainSelectedInstOperands,
     /*  37026 */     // GIR_Coverage, 7558,
     /*  37026 */     GIR_EraseRootFromParent_Done,
     /*  37027 */   // Label 282: @37027
     /*  37027 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(37082), // Rule ID 7559 //
     /*  37032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasAddNoCarryInsts),
     /*  37035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineConst32),
     /*  37051 */     // MIs[1] Operand 1
     /*  37051 */     // No operand predicates
     /*  37051 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19684),
     /*  37055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37057 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>><<X:NegateImm>>:$src1)<<P:Predicate_anonymous_19684>>  =>  (V_SUB_CO_U32_e64:{ *:[i32] }:{ *:[i1] } VS_32:{ *:[i32] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>>:$src1))
     /*  37057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e64),
     /*  37063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37065 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37070 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  37072 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  37077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37080 */     GIR_RootConstrainSelectedInstOperands,
     /*  37081 */     // GIR_Coverage, 7559,
     /*  37081 */     GIR_EraseRootFromParent_Done,
     /*  37082 */   // Label 283: @37082
     /*  37082 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(37116), // Rule ID 43 //
     /*  37087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  37091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  37095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  37099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13776),
     /*  37103 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13776>>  =>  (S_ADD_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  37103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_I32),
     /*  37108 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  37114 */     GIR_RootConstrainSelectedInstOperands,
     /*  37115 */     // GIR_Coverage, 43,
     /*  37115 */     GIR_Done,
     /*  37116 */   // Label 284: @37116
     /*  37116 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(37146), // Rule ID 2492 //
     /*  37121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
     /*  37124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19684),
     /*  37132 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19684>>  =>  (V_ADD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
     /*  37132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U32_e64),
     /*  37135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37137 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  37139 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37144 */     GIR_RootConstrainSelectedInstOperands,
     /*  37145 */     // GIR_Coverage, 2492,
     /*  37145 */     GIR_EraseRootFromParent_Done,
     /*  37146 */   // Label 285: @37146
     /*  37146 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(37184), // Rule ID 2494 //
     /*  37151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7GFX8GFX9),
     /*  37154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19684),
     /*  37162 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19684>>  =>  (V_ADD_CO_U32_e64:{ *:[i32] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
     /*  37162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_CO_U32_e64),
     /*  37168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37170 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37175 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  37177 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37182 */     GIR_RootConstrainSelectedInstOperands,
     /*  37183 */     // GIR_Coverage, 2494,
     /*  37183 */     GIR_EraseRootFromParent_Done,
     /*  37184 */   // Label 286: @37184
     /*  37184 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(37220), // Rule ID 817 //
     /*  37189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  37201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37207 */     // (add:{ *:[i32] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  37207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  37210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  37216 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37218 */     GIR_RootConstrainSelectedInstOperands,
     /*  37219 */     // GIR_Coverage, 817,
     /*  37219 */     GIR_EraseRootFromParent_Done,
     /*  37220 */   // Label 287: @37220
     /*  37220 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(37256), // Rule ID 8419 //
     /*  37225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  37237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37243 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src1, (ctpop:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  37243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  37246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  37252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37254 */     GIR_RootConstrainSelectedInstOperands,
     /*  37255 */     // GIR_Coverage, 8419,
     /*  37255 */     GIR_EraseRootFromParent_Done,
     /*  37256 */   // Label 288: @37256
     /*  37256 */   GIM_Reject,
     /*  37257 */ // Label 198: @37257
     /*  37257 */ GIM_Reject,
     /*  37258 */ // Label 171: @37258
     /*  37258 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(37728),
     /*  37263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  37266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37269 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(37335), // Rule ID 2614 //
     /*  37274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  37277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37289 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  37292 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  37297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37301 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  37305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37307 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i64:{ *:[i64] }:$src2)  =>  (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /*  37307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  37313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37315 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  37324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  37328 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  37330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37333 */     GIR_RootConstrainSelectedInstOperands,
     /*  37334 */     // GIR_Coverage, 2614,
     /*  37334 */     GIR_EraseRootFromParent_Done,
     /*  37335 */   // Label 290: @37335
     /*  37335 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(37401), // Rule ID 2619 //
     /*  37340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  37343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37355 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  37358 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  37363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37367 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  37371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37373 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i64:{ *:[i64] }:$src2)  =>  (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /*  37373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  37379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37381 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  37390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  37394 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  37396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37399 */     GIR_RootConstrainSelectedInstOperands,
     /*  37400 */     // GIR_Coverage, 2619,
     /*  37400 */     GIR_EraseRootFromParent_Done,
     /*  37401 */   // Label 291: @37401
     /*  37401 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(37467), // Rule ID 8498 //
     /*  37406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  37409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37421 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  37424 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  37429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37433 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  37437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37439 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src2, (intrinsic_wo_chain:{ *:[i64] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /*  37439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  37445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37447 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  37456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  37460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  37462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37465 */     GIR_RootConstrainSelectedInstOperands,
     /*  37466 */     // GIR_Coverage, 8498,
     /*  37466 */     GIR_EraseRootFromParent_Done,
     /*  37467 */   // Label 292: @37467
     /*  37467 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(37533), // Rule ID 8502 //
     /*  37472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  37475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37487 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  37490 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  37495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37499 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  37503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37505 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src2, (intrinsic_wo_chain:{ *:[i64] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /*  37505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  37511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37513 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  37522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  37526 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  37528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37531 */     GIR_RootConstrainSelectedInstOperands,
     /*  37532 */     // GIR_Coverage, 8502,
     /*  37532 */     GIR_EraseRootFromParent_Done,
     /*  37533 */   // Label 293: @37533
     /*  37533 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(37602), // Rule ID 2601 //
     /*  37538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /*  37541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  37553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37561 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  37563 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*  37567 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*  37571 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl_0_to_4),
     /*  37575 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:9:z
     /*  37579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20831),
     /*  37583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37585 */     // (add:{ *:[i64] } (shl:{ *:[i64] } i64:{ *:[i64] }:$src0:$pred:9:x, i32:{ *:[i32] }:$src1:$pred:9:y)<<P:Predicate_shl_0_to_4>><<P:Predicate_anonymous_20832>>, i64:{ *:[i64] }:$src2:$pred:9:z)<<P:9:Predicate_anonymous_20831>>  =>  (V_LSHL_ADD_U64_e64:{ *:[i64] } VSrc_b64:{ *:[i64] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b64:{ *:[i64] }:$src2)
     /*  37585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U64_e64),
     /*  37588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  37594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  37598 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  37600 */     GIR_RootConstrainSelectedInstOperands,
     /*  37601 */     // GIR_Coverage, 2601,
     /*  37601 */     GIR_EraseRootFromParent_Done,
     /*  37602 */   // Label 294: @37602
     /*  37602 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(37671), // Rule ID 8494 //
     /*  37607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /*  37610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37614 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:9:z
     /*  37618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  37626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37634 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  37636 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*  37640 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*  37644 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl_0_to_4),
     /*  37648 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20831),
     /*  37652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37654 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src2:$pred:9:z, (shl:{ *:[i64] } i64:{ *:[i64] }:$src0:$pred:9:x, i32:{ *:[i32] }:$src1:$pred:9:y)<<P:Predicate_shl_0_to_4>><<P:Predicate_anonymous_20832>>)<<P:9:Predicate_anonymous_20831>>  =>  (V_LSHL_ADD_U64_e64:{ *:[i64] } VSrc_b64:{ *:[i64] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b64:{ *:[i64] }:$src2)
     /*  37654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U64_e64),
     /*  37657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  37663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  37667 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  37669 */     GIR_RootConstrainSelectedInstOperands,
     /*  37670 */     // GIR_Coverage, 8494,
     /*  37670 */     GIR_EraseRootFromParent_Done,
     /*  37671 */   // Label 295: @37671
     /*  37671 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(37701), // Rule ID 1338 //
     /*  37676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37680 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19684),
     /*  37684 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_19684>>  =>  (V_ADD_U64_PSEUDO:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  37684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U64_PSEUDO),
     /*  37689 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::VCC), GIMT_Encode2(RegState::Dead),
     /*  37695 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  37699 */     GIR_RootConstrainSelectedInstOperands,
     /*  37700 */     // GIR_Coverage, 1338,
     /*  37700 */     GIR_Done,
     /*  37701 */   // Label 296: @37701
     /*  37701 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(37727), // Rule ID 1340 //
     /*  37706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  37710 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13776),
     /*  37714 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13776>>  =>  (S_ADD_U64_PSEUDO:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  37714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_U64_PSEUDO),
     /*  37719 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  37725 */     GIR_RootConstrainSelectedInstOperands,
     /*  37726 */     // GIR_Coverage, 1340,
     /*  37726 */     GIR_Done,
     /*  37727 */   // Label 297: @37727
     /*  37727 */   GIM_Reject,
     /*  37728 */ // Label 289: @37728
     /*  37728 */ GIM_Reject,
     /*  37729 */ // Label 172: @37729
     /*  37729 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(37998),
     /*  37734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  37737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  37740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37744 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(37840), // Rule ID 8469 //
     /*  37749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  37761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  37765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37788 */     // (add:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (mul:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_PK_MAD_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2i16:{ *:[v2i16] }:$src2)
     /*  37788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAD_U16),
     /*  37791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /*  37798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /*  37803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_modifiers
     /*  37808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /*  37813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /*  37818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /*  37823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37838 */     GIR_RootConstrainSelectedInstOperands,
     /*  37839 */     // GIR_Coverage, 8469,
     /*  37839 */     GIR_EraseRootFromParent_Done,
     /*  37840 */   // Label 299: @37840
     /*  37840 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(37936), // Rule ID 1087 //
     /*  37845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  37857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  37861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37884 */     // (add:{ *:[v2i16] } (mul:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers)), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_MAD_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2i16:{ *:[v2i16] }:$src2)
     /*  37884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAD_U16),
     /*  37887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  37894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  37899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  37904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  37909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  37914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  37919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37934 */     GIR_RootConstrainSelectedInstOperands,
     /*  37935 */     // GIR_Coverage, 1087,
     /*  37935 */     GIR_EraseRootFromParent_Done,
     /*  37936 */   // Label 300: @37936
     /*  37936 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(37997), // Rule ID 1098 //
     /*  37941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37955 */     // (add:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /*  37955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_U16),
     /*  37958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  37965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  37970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  37975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  37980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37995 */     GIR_RootConstrainSelectedInstOperands,
     /*  37996 */     // GIR_Coverage, 1098,
     /*  37996 */     GIR_EraseRootFromParent_Done,
     /*  37997 */   // Label 301: @37997
     /*  37997 */   GIM_Reject,
     /*  37998 */ // Label 298: @37998
     /*  37998 */ GIM_Reject,
     /*  37999 */ // Label 173: @37999
     /*  37999 */ GIM_Reject,
     /*  38000 */ // Label 1: @38000
     /*  38000 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 307*/ GIMT_Encode4(38622),
     /*  38011 */ /*GILLT_s1*//*Label 302*/ GIMT_Encode4(38031),
     /*  38015 */ /*GILLT_s16*//*Label 303*/ GIMT_Encode4(38150),
     /*  38019 */ /*GILLT_s32*//*Label 304*/ GIMT_Encode4(38366),
     /*  38023 */ /*GILLT_s64*//*Label 305*/ GIMT_Encode4(38481),
     /*  38027 */ /*GILLT_v2s16*//*Label 306*/ GIMT_Encode4(38550),
     /*  38031 */ // Label 302: @38031
     /*  38031 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(38149),
     /*  38036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  38039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  38042 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(38070), // Rule ID 7413 //
     /*  38047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  38050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  38054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  38058 */     // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
     /*  38058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B64),
     /*  38061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  38063 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  38065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  38068 */     GIR_RootConstrainSelectedInstOperands,
     /*  38069 */     // GIR_Coverage, 7413,
     /*  38069 */     GIR_EraseRootFromParent_Done,
     /*  38070 */   // Label 309: @38070
     /*  38070 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(38098), // Rule ID 7420 //
     /*  38075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  38078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  38086 */     // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
     /*  38086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B32),
     /*  38089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  38091 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  38093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  38096 */     GIR_RootConstrainSelectedInstOperands,
     /*  38097 */     // GIR_Coverage, 7420,
     /*  38097 */     GIR_EraseRootFromParent_Done,
     /*  38098 */   // Label 310: @38098
     /*  38098 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(38123), // Rule ID 7411 //
     /*  38103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  38106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  38110 */     // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  38110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
     /*  38115 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  38121 */     GIR_RootConstrainSelectedInstOperands,
     /*  38122 */     // GIR_Coverage, 7411,
     /*  38122 */     GIR_Done,
     /*  38123 */   // Label 311: @38123
     /*  38123 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(38148), // Rule ID 7418 //
     /*  38128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  38131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38135 */     // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  38135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /*  38140 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  38146 */     GIR_RootConstrainSelectedInstOperands,
     /*  38147 */     // GIR_Coverage, 7418,
     /*  38147 */     GIR_Done,
     /*  38148 */   // Label 312: @38148
     /*  38148 */   GIM_Reject,
     /*  38149 */ // Label 308: @38149
     /*  38149 */ GIM_Reject,
     /*  38150 */ // Label 303: @38150
     /*  38150 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(38365),
     /*  38155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  38158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  38161 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(38220), // Rule ID 1069 //
     /*  38166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /*  38169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38187 */     // (sub:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  38187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_e64),
     /*  38190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38218 */     GIR_RootConstrainSelectedInstOperands,
     /*  38219 */     // GIR_Coverage, 1069,
     /*  38219 */     GIR_EraseRootFromParent_Done,
     /*  38220 */   // Label 314: @38220
     /*  38220 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(38279), // Rule ID 1070 //
     /*  38225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX10Plus),
     /*  38228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  38232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38246 */     // (sub:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  38246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_t16_e64),
     /*  38249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38277 */     GIR_RootConstrainSelectedInstOperands,
     /*  38278 */     // GIR_Coverage, 1070,
     /*  38278 */     GIR_EraseRootFromParent_Done,
     /*  38279 */   // Label 315: @38279
     /*  38279 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(38338), // Rule ID 1071 //
     /*  38284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX10Plus),
     /*  38287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38305 */     // (sub:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  38305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_fake16_e64),
     /*  38308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38336 */     GIR_RootConstrainSelectedInstOperands,
     /*  38337 */     // GIR_Coverage, 1071,
     /*  38337 */     GIR_EraseRootFromParent_Done,
     /*  38338 */   // Label 316: @38338
     /*  38338 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(38364), // Rule ID 910 //
     /*  38343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9),
     /*  38346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38350 */     // (sub:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_SUB_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  38350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /*  38353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38355 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  38357 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38362 */     GIR_RootConstrainSelectedInstOperands,
     /*  38363 */     // GIR_Coverage, 910,
     /*  38363 */     GIR_EraseRootFromParent_Done,
     /*  38364 */   // Label 317: @38364
     /*  38364 */   GIM_Reject,
     /*  38365 */ // Label 313: @38365
     /*  38365 */ GIM_Reject,
     /*  38366 */ // Label 304: @38366
     /*  38366 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(38480),
     /*  38371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  38374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  38377 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(38411), // Rule ID 44 //
     /*  38382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38394 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13777),
     /*  38398 */     // (sub:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13777>>  =>  (S_SUB_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  38398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_I32),
     /*  38403 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  38409 */     GIR_RootConstrainSelectedInstOperands,
     /*  38410 */     // GIR_Coverage, 44,
     /*  38410 */     GIR_Done,
     /*  38411 */   // Label 319: @38411
     /*  38411 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(38441), // Rule ID 2493 //
     /*  38416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
     /*  38419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38423 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19686),
     /*  38427 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19686>>  =>  (V_SUB_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
     /*  38427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e64),
     /*  38430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38432 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  38434 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38439 */     GIR_RootConstrainSelectedInstOperands,
     /*  38440 */     // GIR_Coverage, 2493,
     /*  38440 */     GIR_EraseRootFromParent_Done,
     /*  38441 */   // Label 320: @38441
     /*  38441 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(38479), // Rule ID 2495 //
     /*  38446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7GFX8GFX9),
     /*  38449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38453 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19686),
     /*  38457 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19686>>  =>  (V_SUB_CO_U32_e64:{ *:[i32] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
     /*  38457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  38460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e64),
     /*  38463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38465 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  38470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  38472 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38477 */     GIR_RootConstrainSelectedInstOperands,
     /*  38478 */     // GIR_Coverage, 2495,
     /*  38478 */     GIR_EraseRootFromParent_Done,
     /*  38479 */   // Label 321: @38479
     /*  38479 */   GIM_Reject,
     /*  38480 */ // Label 318: @38480
     /*  38480 */ GIM_Reject,
     /*  38481 */ // Label 305: @38481
     /*  38481 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(38549),
     /*  38486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  38489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  38492 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(38522), // Rule ID 1339 //
     /*  38497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  38501 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19686),
     /*  38505 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_19686>>  =>  (V_SUB_U64_PSEUDO:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  38505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U64_PSEUDO),
     /*  38510 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::VCC), GIMT_Encode2(RegState::Dead),
     /*  38516 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  38520 */     GIR_RootConstrainSelectedInstOperands,
     /*  38521 */     // GIR_Coverage, 1339,
     /*  38521 */     GIR_Done,
     /*  38522 */   // Label 323: @38522
     /*  38522 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(38548), // Rule ID 1341 //
     /*  38527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  38531 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13777),
     /*  38535 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13777>>  =>  (S_SUB_U64_PSEUDO:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  38535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_U64_PSEUDO),
     /*  38540 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  38546 */     GIR_RootConstrainSelectedInstOperands,
     /*  38547 */     // GIR_Coverage, 1341,
     /*  38547 */     GIR_Done,
     /*  38548 */   // Label 324: @38548
     /*  38548 */   GIM_Reject,
     /*  38549 */ // Label 322: @38549
     /*  38549 */ GIM_Reject,
     /*  38550 */ // Label 306: @38550
     /*  38550 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(38621), // Rule ID 1106 //
     /*  38555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  38558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  38561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38565 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  38572 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  38579 */   // (sub:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_SUB_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /*  38579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_SUB_I16),
     /*  38582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38619 */   GIR_RootConstrainSelectedInstOperands,
     /*  38620 */   // GIR_Coverage, 1106,
     /*  38620 */   GIR_EraseRootFromParent_Done,
     /*  38621 */ // Label 325: @38621
     /*  38621 */ GIM_Reject,
     /*  38622 */ // Label 307: @38622
     /*  38622 */ GIM_Reject,
     /*  38623 */ // Label 2: @38623
     /*  38623 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 330*/ GIMT_Encode4(38968),
     /*  38634 */ /*GILLT_s16*//*Label 326*/ GIMT_Encode4(38650),
     /*  38638 */ /*GILLT_s32*//*Label 327*/ GIMT_Encode4(38765),
     /*  38642 */ /*GILLT_s64*//*Label 328*/ GIMT_Encode4(38866),
     /*  38646 */ /*GILLT_v2s16*//*Label 329*/ GIMT_Encode4(38896),
     /*  38650 */ // Label 326: @38650
     /*  38650 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(38764),
     /*  38655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  38658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  38661 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(38717), // Rule ID 877 //
     /*  38666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  38669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  38673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38687 */     // (mul:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_LO_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  38687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_t16_e64),
     /*  38690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38715 */     GIR_RootConstrainSelectedInstOperands,
     /*  38716 */     // GIR_Coverage, 877,
     /*  38716 */     GIR_EraseRootFromParent_Done,
     /*  38717 */   // Label 332: @38717
     /*  38717 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(38740), // Rule ID 876 //
     /*  38722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /*  38725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38729 */     // (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MUL_LO_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  38729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_e64),
     /*  38734 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  38738 */     GIR_RootConstrainSelectedInstOperands,
     /*  38739 */     // GIR_Coverage, 876,
     /*  38739 */     GIR_Done,
     /*  38740 */   // Label 333: @38740
     /*  38740 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(38763), // Rule ID 878 //
     /*  38745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  38748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38752 */     // (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MUL_LO_U16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  38752 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_fake16_e64),
     /*  38757 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  38761 */     GIR_RootConstrainSelectedInstOperands,
     /*  38762 */     // GIR_Coverage, 878,
     /*  38762 */     GIR_Done,
     /*  38763 */   // Label 334: @38763
     /*  38763 */   GIM_Reject,
     /*  38764 */ // Label 331: @38764
     /*  38764 */ GIM_Reject,
     /*  38765 */ // Label 327: @38765
     /*  38765 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(38865),
     /*  38770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  38773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  38776 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(38796), // Rule ID 81 //
     /*  38781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38785 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13784),
     /*  38789 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13784>>  =>  (S_MUL_I32:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  38789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_I32),
     /*  38794 */     GIR_RootConstrainSelectedInstOperands,
     /*  38795 */     // GIR_Coverage, 81,
     /*  38795 */     GIR_Done,
     /*  38796 */   // Label 336: @38796
     /*  38796 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(38830), // Rule ID 938 //
     /*  38801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20176),
     /*  38809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  38816 */     // (mul:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_20176>>  =>  (V_MUL_LO_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  38816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U32_e64),
     /*  38819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38826 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38828 */     GIR_RootConstrainSelectedInstOperands,
     /*  38829 */     // GIR_Coverage, 938,
     /*  38829 */     GIR_EraseRootFromParent_Done,
     /*  38830 */   // Label 337: @38830
     /*  38830 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(38864), // Rule ID 8459 //
     /*  38835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20176),
     /*  38843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  38850 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))<<P:Predicate_anonymous_20176>>  =>  (V_MUL_LO_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  38850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U32_e64),
     /*  38853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38860 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38862 */     GIR_RootConstrainSelectedInstOperands,
     /*  38863 */     // GIR_Coverage, 8459,
     /*  38863 */     GIR_EraseRootFromParent_Done,
     /*  38864 */   // Label 338: @38864
     /*  38864 */   GIM_Reject,
     /*  38865 */ // Label 335: @38865
     /*  38865 */ GIM_Reject,
     /*  38866 */ // Label 328: @38866
     /*  38866 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(38895), // Rule ID 51 //
     /*  38871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  38874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  38877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  38880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  38884 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13784),
     /*  38888 */   // (mul:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13784>>  =>  (S_MUL_U64:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  38888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_U64),
     /*  38893 */   GIR_RootConstrainSelectedInstOperands,
     /*  38894 */   // GIR_Coverage, 51,
     /*  38894 */   GIR_Done,
     /*  38895 */ // Label 339: @38895
     /*  38895 */ GIM_Reject,
     /*  38896 */ // Label 329: @38896
     /*  38896 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(38967), // Rule ID 1099 //
     /*  38901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  38904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  38907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38911 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  38918 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  38925 */   // (mul:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_LO_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /*  38925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_LO_U16),
     /*  38928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38965 */   GIR_RootConstrainSelectedInstOperands,
     /*  38966 */   // GIR_Coverage, 1099,
     /*  38966 */   GIR_EraseRootFromParent_Done,
     /*  38967 */ // Label 340: @38967
     /*  38967 */ GIM_Reject,
     /*  38968 */ // Label 330: @38968
     /*  38968 */ GIM_Reject,
     /*  38969 */ // Label 3: @38969
     /*  38969 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(17), /*)*//*default:*//*Label 348*/ GIMT_Encode4(40369),
     /*  38980 */ /*GILLT_s1*//*Label 341*/ GIMT_Encode4(39020),
     /*  38984 */ /*GILLT_s16*//*Label 342*/ GIMT_Encode4(39083),
     /*  38988 */ /*GILLT_s32*//*Label 343*/ GIMT_Encode4(39323),
     /*  38992 */ /*GILLT_s64*//*Label 344*/ GIMT_Encode4(39847),
     /*  38996 */ /*GILLT_v2s16*//*Label 345*/ GIMT_Encode4(39972),
     /*  39000 */ /*GILLT_v2s32*//*Label 346*/ GIMT_Encode4(40123), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  39016 */ /*GILLT_v4s16*//*Label 347*/ GIMT_Encode4(40246),
     /*  39020 */ // Label 341: @39020
     /*  39020 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(39082),
     /*  39025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  39028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  39031 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(39056), // Rule ID 7407 //
     /*  39036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  39039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  39043 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_AND_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  39043 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B64),
     /*  39048 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  39054 */     GIR_RootConstrainSelectedInstOperands,
     /*  39055 */     // GIR_Coverage, 7407,
     /*  39055 */     GIR_Done,
     /*  39056 */   // Label 350: @39056
     /*  39056 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(39081), // Rule ID 7414 //
     /*  39061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  39064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39068 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_AND_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  39068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /*  39073 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  39079 */     GIR_RootConstrainSelectedInstOperands,
     /*  39080 */     // GIR_Coverage, 7414,
     /*  39080 */     GIR_Done,
     /*  39081 */   // Label 351: @39081
     /*  39081 */   GIM_Reject,
     /*  39082 */ // Label 349: @39082
     /*  39082 */ GIM_Reject,
     /*  39083 */ // Label 342: @39083
     /*  39083 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(39322),
     /*  39088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  39091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  39094 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(39145), // Rule ID 8471 //
     /*  39099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  39115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  39119 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13785),
     /*  39127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39129 */     // (and:{ *:[i16] } (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }), i16:{ *:[i16] }:$src0)<<P:Predicate_anonymous_13785>>  =>  (S_ANDN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
     /*  39129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  39132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39134 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  39136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39143 */     GIR_RootConstrainSelectedInstOperands,
     /*  39144 */     // GIR_Coverage, 8471,
     /*  39144 */     GIR_EraseRootFromParent_Done,
     /*  39145 */   // Label 353: @39145
     /*  39145 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(39196), // Rule ID 1883 //
     /*  39150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  39166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  39170 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13785),
     /*  39178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39180 */     // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }))<<P:Predicate_anonymous_13785>>  =>  (S_ANDN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
     /*  39180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  39183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39185 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  39187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39194 */     GIR_RootConstrainSelectedInstOperands,
     /*  39195 */     // GIR_Coverage, 1883,
     /*  39195 */     GIR_EraseRootFromParent_Done,
     /*  39196 */   // Label 354: @39196
     /*  39196 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(39219), // Rule ID 2522 //
     /*  39201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  39204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39208 */     // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_AND_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  39208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  39213 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  39217 */     GIR_RootConstrainSelectedInstOperands,
     /*  39218 */     // GIR_Coverage, 2522,
     /*  39218 */     GIR_Done,
     /*  39219 */   // Label 355: @39219
     /*  39219 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(39242), // Rule ID 2525 //
     /*  39224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  39227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39231 */     // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_AND_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  39231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  39236 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  39240 */     GIR_RootConstrainSelectedInstOperands,
     /*  39241 */     // GIR_Coverage, 2525,
     /*  39241 */     GIR_Done,
     /*  39242 */   // Label 356: @39242
     /*  39242 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(39298), // Rule ID 903 //
     /*  39247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  39250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  39254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  39261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  39268 */     // (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_AND_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  39268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B16_t16_e64),
     /*  39271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  39278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  39283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  39288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  39293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39296 */     GIR_RootConstrainSelectedInstOperands,
     /*  39297 */     // GIR_Coverage, 903,
     /*  39297 */     GIR_EraseRootFromParent_Done,
     /*  39298 */   // Label 357: @39298
     /*  39298 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(39321), // Rule ID 904 //
     /*  39303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  39306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39310 */     // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_AND_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  39310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B16_fake16_e64),
     /*  39315 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  39319 */     GIR_RootConstrainSelectedInstOperands,
     /*  39320 */     // GIR_Coverage, 904,
     /*  39320 */     GIR_Done,
     /*  39321 */   // Label 358: @39321
     /*  39321 */   GIM_Reject,
     /*  39322 */ // Label 352: @39322
     /*  39322 */ GIM_Reject,
     /*  39323 */ // Label 343: @39323
     /*  39323 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(39846),
     /*  39328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  39331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  39334 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(39409), // Rule ID 11188 //
     /*  39339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  39351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39359 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  39361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  39369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  39377 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  39379 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  39383 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39387 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19694),
     /*  39391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39393 */     // (and:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_add_oneuse>>, i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_19694>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
     /*  39393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39398 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  39400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
     /*  39407 */     GIR_RootConstrainSelectedInstOperands,
     /*  39408 */     // GIR_Coverage, 11188,
     /*  39408 */     GIR_EraseRootFromParent_Done,
     /*  39409 */   // Label 360: @39409
     /*  39409 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(39484), // Rule ID 11189 //
     /*  39414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39434 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  39436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  39444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  39452 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  39454 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  39458 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39462 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19694),
     /*  39466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39468 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_xor_oneuse>>, i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_19694>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
     /*  39468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39473 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  39475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
     /*  39482 */     GIR_RootConstrainSelectedInstOperands,
     /*  39483 */     // GIR_Coverage, 11189,
     /*  39483 */     GIR_EraseRootFromParent_Done,
     /*  39484 */   // Label 361: @39484
     /*  39484 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(39559), // Rule ID 7566 //
     /*  39489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  39501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39509 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  39511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  39519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  39527 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  39529 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  39533 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39537 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19694),
     /*  39541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39543 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_add_oneuse>>)<<P:Predicate_anonymous_19694>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
     /*  39543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39548 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
     /*  39557 */     GIR_RootConstrainSelectedInstOperands,
     /*  39558 */     // GIR_Coverage, 7566,
     /*  39558 */     GIR_EraseRootFromParent_Done,
     /*  39559 */   // Label 362: @39559
     /*  39559 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(39634), // Rule ID 7567 //
     /*  39564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39584 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  39586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  39594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  39602 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  39604 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  39608 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19694),
     /*  39616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39618 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_xor_oneuse>>)<<P:Predicate_anonymous_19694>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
     /*  39618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
     /*  39632 */     GIR_RootConstrainSelectedInstOperands,
     /*  39633 */     // GIR_Coverage, 7567,
     /*  39633 */     GIR_EraseRootFromParent_Done,
     /*  39634 */   // Label 363: @39634
     /*  39634 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(39685), // Rule ID 8400 //
     /*  39639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39659 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39663 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13785),
     /*  39667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39669 */     // (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }), i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13785>>  =>  (S_ANDN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  39669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  39672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39674 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  39676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39683 */     GIR_RootConstrainSelectedInstOperands,
     /*  39684 */     // GIR_Coverage, 8400,
     /*  39684 */     GIR_EraseRootFromParent_Done,
     /*  39685 */   // Label 364: @39685
     /*  39685 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(39736), // Rule ID 64 //
     /*  39690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39710 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13785),
     /*  39718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39720 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }))<<P:Predicate_anonymous_13785>>  =>  (S_ANDN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  39720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  39723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39725 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  39727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39734 */     GIR_RootConstrainSelectedInstOperands,
     /*  39735 */     // GIR_Coverage, 64,
     /*  39735 */     GIR_EraseRootFromParent_Done,
     /*  39736 */   // Label 365: @39736
     /*  39736 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(39799), // Rule ID 7565 //
     /*  39741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  39753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  39765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39769 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_IMMZeroBasedBitfieldMask),
     /*  39773 */     // MIs[2] Operand 1
     /*  39773 */     // No operand predicates
     /*  39773 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19694),
     /*  39777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39779 */     // (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$rshift), (imm:{ *:[i32] })<<P:Predicate_IMMZeroBasedBitfieldMask>>:$mask)<<P:Predicate_anonymous_19694>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, ?:{ *:[i32] }:$rshift, (IMMPopCount:{ *:[i32] } ?:{ *:[i32] }:$mask))
     /*  39779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  39788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rshift
     /*  39792 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderPopcntImm), // mask
     /*  39797 */     GIR_RootConstrainSelectedInstOperands,
     /*  39798 */     // GIR_Coverage, 7565,
     /*  39798 */     GIR_EraseRootFromParent_Done,
     /*  39799 */   // Label 366: @39799
     /*  39799 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(39825), // Rule ID 52 //
     /*  39804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13785),
     /*  39812 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13785>>  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  39812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /*  39817 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  39823 */     GIR_RootConstrainSelectedInstOperands,
     /*  39824 */     // GIR_Coverage, 52,
     /*  39824 */     GIR_Done,
     /*  39825 */   // Label 367: @39825
     /*  39825 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(39845), // Rule ID 814 //
     /*  39830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39834 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_AND_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  39834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  39839 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  39843 */     GIR_RootConstrainSelectedInstOperands,
     /*  39844 */     // GIR_Coverage, 814,
     /*  39844 */     GIR_Done,
     /*  39845 */   // Label 368: @39845
     /*  39845 */   GIM_Reject,
     /*  39846 */ // Label 359: @39846
     /*  39846 */ GIM_Reject,
     /*  39847 */ // Label 344: @39847
     /*  39847 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(39971),
     /*  39852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  39855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  39858 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13785),
     /*  39862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  39866 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(39909), // Rule ID 8401 //
     /*  39871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39887 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39893 */     // (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }), i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13785>>  =>  (S_ANDN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  39893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  39896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39898 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  39900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39907 */     GIR_RootConstrainSelectedInstOperands,
     /*  39908 */     // GIR_Coverage, 8401,
     /*  39908 */     GIR_EraseRootFromParent_Done,
     /*  39909 */   // Label 370: @39909
     /*  39909 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(39952), // Rule ID 65 //
     /*  39914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39930 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39936 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$src0, (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }))<<P:Predicate_anonymous_13785>>  =>  (S_ANDN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  39936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  39939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39941 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  39943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39950 */     GIR_RootConstrainSelectedInstOperands,
     /*  39951 */     // GIR_Coverage, 65,
     /*  39951 */     GIR_EraseRootFromParent_Done,
     /*  39952 */   // Label 371: @39952
     /*  39952 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(39970), // Rule ID 53 //
     /*  39957 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13785>>  =>  (S_AND_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  39957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B64),
     /*  39962 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  39968 */     GIR_RootConstrainSelectedInstOperands,
     /*  39969 */     // GIR_Coverage, 53,
     /*  39969 */     GIR_Done,
     /*  39970 */   // Label 372: @39970
     /*  39970 */   GIM_Reject,
     /*  39971 */ // Label 369: @39971
     /*  39971 */ GIM_Reject,
     /*  39972 */ // Label 345: @39972
     /*  39972 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(40122),
     /*  39977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  39980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  39983 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(40042), // Rule ID 8472 //
     /*  39988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  40004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  40008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40012 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40018 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40020 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13785),
     /*  40024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40026 */     // (and:{ *:[v2i16] } (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }), v2i16:{ *:[v2i16] }:$src0)<<P:Predicate_anonymous_13785>>  =>  (S_ANDN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
     /*  40026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  40029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40031 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  40033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40040 */     GIR_RootConstrainSelectedInstOperands,
     /*  40041 */     // GIR_Coverage, 8472,
     /*  40041 */     GIR_EraseRootFromParent_Done,
     /*  40042 */   // Label 374: @40042
     /*  40042 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(40101), // Rule ID 1884 //
     /*  40047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  40051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  40063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  40067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40071 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40077 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40079 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13785),
     /*  40083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40085 */     // (and:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }))<<P:Predicate_anonymous_13785>>  =>  (S_ANDN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
     /*  40085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  40088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40090 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  40092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40099 */     GIR_RootConstrainSelectedInstOperands,
     /*  40100 */     // GIR_Coverage, 1884,
     /*  40100 */     GIR_EraseRootFromParent_Done,
     /*  40101 */   // Label 375: @40101
     /*  40101 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(40121), // Rule ID 2528 //
     /*  40106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40110 */     // (and:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1)  =>  (V_AND_B32_e64:{ *:[v2i16] } VSrc_b32:{ *:[v2i16] }:$src0, VSrc_b32:{ *:[v2i16] }:$src1)
     /*  40110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  40115 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  40119 */     GIR_RootConstrainSelectedInstOperands,
     /*  40120 */     // GIR_Coverage, 2528,
     /*  40120 */     GIR_Done,
     /*  40121 */   // Label 376: @40121
     /*  40121 */   GIM_Reject,
     /*  40122 */ // Label 373: @40122
     /*  40122 */ GIM_Reject,
     /*  40123 */ // Label 346: @40123
     /*  40123 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(40245),
     /*  40128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40134 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13785),
     /*  40138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  40142 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(40193), // Rule ID 8474 //
     /*  40147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40167 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40177 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }), v2i32:{ *:[v2i32] }:$src0)<<P:Predicate_anonymous_13785>>  =>  (S_ANDN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
     /*  40177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  40180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40182 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  40184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40191 */     GIR_RootConstrainSelectedInstOperands,
     /*  40192 */     // GIR_Coverage, 8474,
     /*  40192 */     GIR_EraseRootFromParent_Done,
     /*  40193 */   // Label 378: @40193
     /*  40193 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(40244), // Rule ID 1886 //
     /*  40198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40218 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40228 */     // (and:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src0, (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }))<<P:Predicate_anonymous_13785>>  =>  (S_ANDN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
     /*  40228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  40231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40233 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  40235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40242 */     GIR_RootConstrainSelectedInstOperands,
     /*  40243 */     // GIR_Coverage, 1886,
     /*  40243 */     GIR_EraseRootFromParent_Done,
     /*  40244 */   // Label 379: @40244
     /*  40244 */   GIM_Reject,
     /*  40245 */ // Label 377: @40245
     /*  40245 */ GIM_Reject,
     /*  40246 */ // Label 347: @40246
     /*  40246 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(40368),
     /*  40251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  40254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40257 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13785),
     /*  40261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  40265 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(40316), // Rule ID 8473 //
     /*  40270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  40282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40290 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40296 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40300 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }), v4i16:{ *:[v4i16] }:$src0)<<P:Predicate_anonymous_13785>>  =>  (S_ANDN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
     /*  40300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  40303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40305 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  40307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40314 */     GIR_RootConstrainSelectedInstOperands,
     /*  40315 */     // GIR_Coverage, 8473,
     /*  40315 */     GIR_EraseRootFromParent_Done,
     /*  40316 */   // Label 381: @40316
     /*  40316 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(40367), // Rule ID 1885 //
     /*  40321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  40333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40341 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40347 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40351 */     // (and:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src0, (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }))<<P:Predicate_anonymous_13785>>  =>  (S_ANDN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
     /*  40351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  40354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40356 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  40358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40365 */     GIR_RootConstrainSelectedInstOperands,
     /*  40366 */     // GIR_Coverage, 1885,
     /*  40366 */     GIR_EraseRootFromParent_Done,
     /*  40367 */   // Label 382: @40367
     /*  40367 */   GIM_Reject,
     /*  40368 */ // Label 380: @40368
     /*  40368 */ GIM_Reject,
     /*  40369 */ // Label 348: @40369
     /*  40369 */ GIM_Reject,
     /*  40370 */ // Label 4: @40370
     /*  40370 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(17), /*)*//*default:*//*Label 390*/ GIMT_Encode4(55881),
     /*  40381 */ /*GILLT_s1*//*Label 383*/ GIMT_Encode4(40421),
     /*  40385 */ /*GILLT_s16*//*Label 384*/ GIMT_Encode4(40484),
     /*  40389 */ /*GILLT_s32*//*Label 385*/ GIMT_Encode4(40724),
     /*  40393 */ /*GILLT_s64*//*Label 386*/ GIMT_Encode4(46295),
     /*  40397 */ /*GILLT_v2s16*//*Label 387*/ GIMT_Encode4(55484),
     /*  40401 */ /*GILLT_v2s32*//*Label 388*/ GIMT_Encode4(55635), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  40417 */ /*GILLT_v4s16*//*Label 389*/ GIMT_Encode4(55758),
     /*  40421 */ // Label 383: @40421
     /*  40421 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(40483),
     /*  40426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  40429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  40432 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(40457), // Rule ID 7408 //
     /*  40437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  40440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  40444 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_OR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  40444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B64),
     /*  40449 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  40455 */     GIR_RootConstrainSelectedInstOperands,
     /*  40456 */     // GIR_Coverage, 7408,
     /*  40456 */     GIR_Done,
     /*  40457 */   // Label 392: @40457
     /*  40457 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(40482), // Rule ID 7415 //
     /*  40462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  40465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  40469 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_OR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  40469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /*  40474 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  40480 */     GIR_RootConstrainSelectedInstOperands,
     /*  40481 */     // GIR_Coverage, 7415,
     /*  40481 */     GIR_Done,
     /*  40482 */   // Label 393: @40482
     /*  40482 */   GIM_Reject,
     /*  40483 */ // Label 391: @40483
     /*  40483 */ GIM_Reject,
     /*  40484 */ // Label 384: @40484
     /*  40484 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(40723),
     /*  40489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  40492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  40495 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(40546), // Rule ID 8475 //
     /*  40500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  40504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  40516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  40520 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  40524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13786),
     /*  40528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40530 */     // (or:{ *:[i16] } (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }), i16:{ *:[i16] }:$src0)<<P:Predicate_anonymous_13786>>  =>  (S_ORN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
     /*  40530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  40533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40535 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  40537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40544 */     GIR_RootConstrainSelectedInstOperands,
     /*  40545 */     // GIR_Coverage, 8475,
     /*  40545 */     GIR_EraseRootFromParent_Done,
     /*  40546 */   // Label 395: @40546
     /*  40546 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(40597), // Rule ID 1887 //
     /*  40551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  40555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  40567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  40571 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  40575 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13786),
     /*  40579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40581 */     // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }))<<P:Predicate_anonymous_13786>>  =>  (S_ORN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
     /*  40581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  40584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  40588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40595 */     GIR_RootConstrainSelectedInstOperands,
     /*  40596 */     // GIR_Coverage, 1887,
     /*  40596 */     GIR_EraseRootFromParent_Done,
     /*  40597 */   // Label 396: @40597
     /*  40597 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(40620), // Rule ID 2523 //
     /*  40602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  40605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40609 */     // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_OR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  40609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /*  40614 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  40618 */     GIR_RootConstrainSelectedInstOperands,
     /*  40619 */     // GIR_Coverage, 2523,
     /*  40619 */     GIR_Done,
     /*  40620 */   // Label 397: @40620
     /*  40620 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(40643), // Rule ID 2526 //
     /*  40625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  40628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40632 */     // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_OR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  40632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /*  40637 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  40641 */     GIR_RootConstrainSelectedInstOperands,
     /*  40642 */     // GIR_Coverage, 2526,
     /*  40642 */     GIR_Done,
     /*  40643 */   // Label 398: @40643
     /*  40643 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(40699), // Rule ID 905 //
     /*  40648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  40651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  40655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  40662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  40669 */     // (or:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_OR_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  40669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B16_t16_e64),
     /*  40672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  40674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  40679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  40684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  40689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  40694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40697 */     GIR_RootConstrainSelectedInstOperands,
     /*  40698 */     // GIR_Coverage, 905,
     /*  40698 */     GIR_EraseRootFromParent_Done,
     /*  40699 */   // Label 399: @40699
     /*  40699 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(40722), // Rule ID 906 //
     /*  40704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  40707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40711 */     // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_OR_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  40711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B16_fake16_e64),
     /*  40716 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  40720 */     GIR_RootConstrainSelectedInstOperands,
     /*  40721 */     // GIR_Coverage, 906,
     /*  40721 */     GIR_Done,
     /*  40722 */   // Label 400: @40722
     /*  40722 */   GIM_Reject,
     /*  40723 */ // Label 394: @40723
     /*  40723 */ GIM_Reject,
     /*  40724 */ // Label 385: @40724
     /*  40724 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(46294),
     /*  40729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  40732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  40735 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(40916), // Rule ID 8505 //
     /*  40740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /*  40743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  40759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  40763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  40771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  40779 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  40783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  40791 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40795 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  40799 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-128),
     /*  40803 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 127,
     /*  40807 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  40818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  40822 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  40826 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  40830 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  40834 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  40838 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  40842 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  40846 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  40850 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  40854 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40858 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  40862 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  40866 */     // MIs[6] src2
     /*  40866 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40871 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, uint8_t(-128),
     /*  40875 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/3, 127,
     /*  40879 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  40883 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40885 */     // (or:{ *:[i32] } (and:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] }), 255:{ *:[i32] }), (shl:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] }), 8:{ *:[i32] }))  =>  (V_ASHR_PK_I8_I32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  40885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_I8_I32_e64),
     /*  40888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  40890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  40897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  40904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  40911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40914 */     GIR_RootConstrainSelectedInstOperands,
     /*  40915 */     // GIR_Coverage, 8505,
     /*  40915 */     GIR_EraseRootFromParent_Done,
     /*  40916 */   // Label 402: @40916
     /*  40916 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(41097), // Rule ID 2699 //
     /*  40921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /*  40924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  40936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  40940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  40944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  40952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  40960 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  40964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  40972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  40980 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-128),
     /*  40984 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 127,
     /*  40988 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  40992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  40996 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41000 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  41004 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  41008 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  41012 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  41016 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  41020 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  41024 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  41028 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  41032 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  41036 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  41040 */     // MIs[6] src2
     /*  41040 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41045 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, uint8_t(-128),
     /*  41049 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/3, 127,
     /*  41053 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(255),
     /*  41064 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41066 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] }), 8:{ *:[i32] }), (and:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] }), 255:{ *:[i32] }))  =>  (V_ASHR_PK_I8_I32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  41066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_I8_I32_e64),
     /*  41069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src0
     /*  41078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  41085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  41092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41095 */     GIR_RootConstrainSelectedInstOperands,
     /*  41096 */     // GIR_Coverage, 2699,
     /*  41096 */     GIR_EraseRootFromParent_Done,
     /*  41097 */   // Label 403: @41097
     /*  41097 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(41265), // Rule ID 8506 //
     /*  41102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /*  41105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  41117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41125 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  41129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  41137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41145 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  41149 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/3, GIMT_Encode8(255),
     /*  41160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  41168 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  41172 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  41176 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41180 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  41184 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  41188 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  41192 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  41196 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  41200 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  41204 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  41208 */     // MIs[5] src2
     /*  41208 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  41213 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /*  41217 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/3, GIMT_Encode8(255),
     /*  41228 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*  41232 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  41234 */     // (or:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] }), (shl:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] }), 8:{ *:[i32] }))  =>  (V_ASHR_PK_U8_I32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  41234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_U8_I32_e64),
     /*  41237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  41246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src1
     /*  41253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*  41260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41263 */     GIR_RootConstrainSelectedInstOperands,
     /*  41264 */     // GIR_Coverage, 8506,
     /*  41264 */     GIR_EraseRootFromParent_Done,
     /*  41265 */   // Label 404: @41265
     /*  41265 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(41433), // Rule ID 2700 //
     /*  41270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /*  41273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  41285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  41301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41309 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  41313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  41321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  41325 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  41329 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*  41333 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/3, GIMT_Encode8(255),
     /*  41344 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  41348 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  41352 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  41356 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  41360 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  41364 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  41368 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  41372 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  41376 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  41380 */     // MIs[5] src2
     /*  41380 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41385 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /*  41389 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/3, GIMT_Encode8(255),
     /*  41400 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  41402 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] }), 8:{ *:[i32] }), (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] }))  =>  (V_ASHR_PK_U8_I32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  41402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_U8_I32_e64),
     /*  41405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  41414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  41421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  41428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41431 */     GIR_RootConstrainSelectedInstOperands,
     /*  41432 */     // GIR_Coverage, 2700,
     /*  41432 */     GIR_EraseRootFromParent_Done,
     /*  41433 */   // Label 405: @41433
     /*  41433 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(41580), // Rule ID 11157 //
     /*  41438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41442 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41458 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41474 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  41478 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41486 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  41490 */     // MIs[3] x
     /*  41490 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  41499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41501 */     // (or:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  41501 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  41504 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41508 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41513 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  41517 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41522 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  41525 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41529 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41534 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // y
     /*  41538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  41546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  41559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  41567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  41575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  41578 */     GIR_RootConstrainSelectedInstOperands,
     /*  41579 */     // GIR_Coverage, 11157,
     /*  41579 */     GIR_EraseRootFromParent_Done,
     /*  41580 */   // Label 406: @41580
     /*  41580 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(41727), // Rule ID 11156 //
     /*  41585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41589 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41605 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41621 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  41625 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41633 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  41637 */     // MIs[3] x
     /*  41637 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  41646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41648 */     // (or:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  41648 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  41651 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41655 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41660 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  41664 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  41672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41681 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, // y
     /*  41685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  41693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41702 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  41706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  41714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  41722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  41725 */     GIR_RootConstrainSelectedInstOperands,
     /*  41726 */     // GIR_Coverage, 11156,
     /*  41726 */     GIR_EraseRootFromParent_Done,
     /*  41727 */   // Label 407: @41727
     /*  41727 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(41874), // Rule ID 11155 //
     /*  41732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41736 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41752 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41768 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  41772 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41780 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  41784 */     // MIs[3] x
     /*  41784 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  41793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41795 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  41795 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  41798 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41802 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41807 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  41811 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41816 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  41819 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41823 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41828 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // y
     /*  41832 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  41840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  41853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  41861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  41869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  41872 */     GIR_RootConstrainSelectedInstOperands,
     /*  41873 */     // GIR_Coverage, 11155,
     /*  41873 */     GIR_EraseRootFromParent_Done,
     /*  41874 */   // Label 408: @41874
     /*  41874 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(42021), // Rule ID 11154 //
     /*  41879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41883 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41899 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41915 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  41919 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41927 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  41931 */     // MIs[3] x
     /*  41931 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  41940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41942 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })), (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  41942 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  41945 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41949 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41954 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  41958 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41963 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  41966 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41970 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41975 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, // y
     /*  41979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  41987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  42000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  42019 */     GIR_RootConstrainSelectedInstOperands,
     /*  42020 */     // GIR_Coverage, 11154,
     /*  42020 */     GIR_EraseRootFromParent_Done,
     /*  42021 */   // Label 409: @42021
     /*  42021 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(42168), // Rule ID 11151 //
     /*  42026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42030 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42046 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42062 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42070 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  42074 */     // MIs[3] x
     /*  42074 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42079 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  42083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  42087 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42089 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x), (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  42089 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42092 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42096 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42101 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  42105 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42110 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42122 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  42126 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  42147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  42166 */     GIR_RootConstrainSelectedInstOperands,
     /*  42167 */     // GIR_Coverage, 11151,
     /*  42167 */     GIR_EraseRootFromParent_Done,
     /*  42168 */   // Label 410: @42168
     /*  42168 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(42315), // Rule ID 11153 //
     /*  42173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42177 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42193 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42209 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42217 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  42221 */     // MIs[3] x
     /*  42221 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  42226 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  42230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  42234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42236 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y), (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  42236 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42239 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42243 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42248 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  42252 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42257 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42260 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42264 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42269 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42273 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  42294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  42313 */     GIR_RootConstrainSelectedInstOperands,
     /*  42314 */     // GIR_Coverage, 11153,
     /*  42314 */     GIR_EraseRootFromParent_Done,
     /*  42315 */   // Label 411: @42315
     /*  42315 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(42462), // Rule ID 7317 //
     /*  42320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42324 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42340 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42356 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42364 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  42368 */     // MIs[3] x
     /*  42368 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42373 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  42377 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  42381 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42383 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x), (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  42383 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42386 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42390 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42395 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  42399 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42404 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42407 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42411 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42416 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  42420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42437 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  42441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  42460 */     GIR_RootConstrainSelectedInstOperands,
     /*  42461 */     // GIR_Coverage, 7317,
     /*  42461 */     GIR_EraseRootFromParent_Done,
     /*  42462 */   // Label 412: @42462
     /*  42462 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(42609), // Rule ID 11152 //
     /*  42467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42471 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42487 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42503 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42511 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  42515 */     // MIs[3] x
     /*  42515 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  42520 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  42524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  42528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42530 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  42530 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42533 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42537 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42542 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  42546 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42551 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42554 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42558 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42563 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42567 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  42588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  42607 */     GIR_RootConstrainSelectedInstOperands,
     /*  42608 */     // GIR_Coverage, 11152,
     /*  42608 */     GIR_EraseRootFromParent_Done,
     /*  42609 */   // Label 413: @42609
     /*  42609 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(42702), // Rule ID 2596 //
     /*  42614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  42617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42637 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42639 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*  42643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42659 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*  42663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42671 */     // MIs[3] Operand 1
     /*  42671 */     // No operand predicates
     /*  42671 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /*  42675 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:5:z
     /*  42679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20819),
     /*  42683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42685 */     // (or:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:5:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20809>>, i32:{ *:[i32] }:$src2:$pred:5:z)<<P:5:Predicate_anonymous_20819>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  42685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  42688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  42694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  42698 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  42700 */     GIR_RootConstrainSelectedInstOperands,
     /*  42701 */     // GIR_Coverage, 2596,
     /*  42701 */     GIR_EraseRootFromParent_Done,
     /*  42702 */   // Label 414: @42702
     /*  42702 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(42795), // Rule ID 8490 //
     /*  42707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  42710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42714 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:5:z
     /*  42718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42734 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42736 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*  42740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42756 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*  42760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42768 */     // MIs[3] Operand 1
     /*  42768 */     // No operand predicates
     /*  42768 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /*  42772 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20819),
     /*  42776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42778 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:5:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:5:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20809>>)<<P:5:Predicate_anonymous_20819>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  42778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  42781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  42787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  42791 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  42793 */     GIR_RootConstrainSelectedInstOperands,
     /*  42794 */     // GIR_Coverage, 8490,
     /*  42794 */     GIR_EraseRootFromParent_Done,
     /*  42795 */   // Label 415: @42795
     /*  42795 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(42980), // Rule ID 11202 //
     /*  42800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42804 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42820 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42836 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42844 */     // MIs[3] x
     /*  42844 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42849 */     // MIs[3] z
     /*  42849 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  42854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  42858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42860 */     // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  42860 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  42863 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42867 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42872 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42876 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42881 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  42884 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42888 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42893 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  42897 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42902 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42905 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42909 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42914 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42918 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42923 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42926 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42930 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42935 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  42939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  42951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42956 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42959 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  42962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  42975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  42978 */     GIR_RootConstrainSelectedInstOperands,
     /*  42979 */     // GIR_Coverage, 11202,
     /*  42979 */     GIR_EraseRootFromParent_Done,
     /*  42980 */   // Label 416: @42980
     /*  42980 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(43165), // Rule ID 11203 //
     /*  42985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42989 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43005 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43021 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43029 */     // MIs[3] z
     /*  43029 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43034 */     // MIs[3] x
     /*  43034 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  43043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43045 */     // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43045 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43048 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43052 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43057 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43061 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43066 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43069 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43073 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43078 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  43082 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43087 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43090 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43094 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43099 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43103 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43108 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43111 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43115 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43120 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  43124 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43141 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43144 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43163 */     GIR_RootConstrainSelectedInstOperands,
     /*  43164 */     // GIR_Coverage, 11203,
     /*  43164 */     GIR_EraseRootFromParent_Done,
     /*  43165 */   // Label 417: @43165
     /*  43165 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(43350), // Rule ID 11204 //
     /*  43170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43174 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43190 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43206 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43214 */     // MIs[3] x
     /*  43214 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43219 */     // MIs[3] z
     /*  43219 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  43228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43230 */     // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43230 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43233 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43237 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43242 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43246 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43251 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43254 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43258 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43263 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  43267 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43272 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43275 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43279 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43284 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43288 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43293 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43296 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43300 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43305 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
     /*  43309 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43326 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43329 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43348 */     GIR_RootConstrainSelectedInstOperands,
     /*  43349 */     // GIR_Coverage, 11204,
     /*  43349 */     GIR_EraseRootFromParent_Done,
     /*  43350 */   // Label 418: @43350
     /*  43350 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(43535), // Rule ID 11205 //
     /*  43355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43359 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43375 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43391 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43399 */     // MIs[3] z
     /*  43399 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43404 */     // MIs[3] x
     /*  43404 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43409 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  43413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43415 */     // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43415 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43418 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43422 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43427 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43431 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43436 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43439 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43443 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43448 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  43452 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43457 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43460 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43464 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43469 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43473 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43490 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
     /*  43494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43511 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43514 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43533 */     GIR_RootConstrainSelectedInstOperands,
     /*  43534 */     // GIR_Coverage, 11205,
     /*  43534 */     GIR_EraseRootFromParent_Done,
     /*  43535 */   // Label 419: @43535
     /*  43535 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(43720), // Rule ID 11198 //
     /*  43540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43544 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43560 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43576 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43584 */     // MIs[3] x
     /*  43584 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43589 */     // MIs[3] z
     /*  43589 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  43598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43600 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43600 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43603 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43607 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43612 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43616 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43621 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43624 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43628 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43633 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  43637 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43642 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43645 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43649 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43654 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43658 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  43679 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43696 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43699 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43718 */     GIR_RootConstrainSelectedInstOperands,
     /*  43719 */     // GIR_Coverage, 11198,
     /*  43719 */     GIR_EraseRootFromParent_Done,
     /*  43720 */   // Label 420: @43720
     /*  43720 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(43905), // Rule ID 11199 //
     /*  43725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43729 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43745 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43761 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43769 */     // MIs[3] z
     /*  43769 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43774 */     // MIs[3] x
     /*  43774 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  43783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43785 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43785 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43788 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43792 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43797 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43801 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43806 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43809 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43813 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43818 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  43822 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43827 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43830 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43834 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43839 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43843 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43848 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43851 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43855 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43860 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  43864 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43881 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43884 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43903 */     GIR_RootConstrainSelectedInstOperands,
     /*  43904 */     // GIR_Coverage, 11199,
     /*  43904 */     GIR_EraseRootFromParent_Done,
     /*  43905 */   // Label 421: @43905
     /*  43905 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(44090), // Rule ID 11200 //
     /*  43910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43914 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43930 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43946 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43954 */     // MIs[3] x
     /*  43954 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43959 */     // MIs[3] z
     /*  43959 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  43968 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43970 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43970 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43973 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43977 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43982 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43986 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43991 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43994 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43998 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44003 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  44007 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44012 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44015 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44019 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44024 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  44028 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44033 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44036 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44040 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44045 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
     /*  44049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44066 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44069 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44088 */     GIR_RootConstrainSelectedInstOperands,
     /*  44089 */     // GIR_Coverage, 11200,
     /*  44089 */     GIR_EraseRootFromParent_Done,
     /*  44090 */   // Label 422: @44090
     /*  44090 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(44275), // Rule ID 11201 //
     /*  44095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44099 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44115 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44131 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  44135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44139 */     // MIs[3] z
     /*  44139 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44144 */     // MIs[3] x
     /*  44144 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  44149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  44153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44155 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44155 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44158 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44162 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44167 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  44171 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44176 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44179 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44183 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44188 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  44192 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44197 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44200 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44204 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44209 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  44213 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44218 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44221 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44225 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44230 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
     /*  44234 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44251 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44254 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44273 */     GIR_RootConstrainSelectedInstOperands,
     /*  44274 */     // GIR_Coverage, 11201,
     /*  44274 */     GIR_EraseRootFromParent_Done,
     /*  44275 */   // Label 423: @44275
     /*  44275 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(44460), // Rule ID 11192 //
     /*  44280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44284 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44300 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44316 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44324 */     // MIs[3] x
     /*  44324 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  44329 */     // MIs[3] z
     /*  44329 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  44334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  44338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44340 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44340 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44343 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44347 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44352 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44356 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44361 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44364 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44368 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44373 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  44377 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44382 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44385 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44389 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44394 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44398 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44403 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44406 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44410 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44415 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  44419 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44436 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44439 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44458 */     GIR_RootConstrainSelectedInstOperands,
     /*  44459 */     // GIR_Coverage, 11192,
     /*  44459 */     GIR_EraseRootFromParent_Done,
     /*  44460 */   // Label 424: @44460
     /*  44460 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(44645), // Rule ID 11193 //
     /*  44465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44469 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44485 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44501 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44509 */     // MIs[3] z
     /*  44509 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  44514 */     // MIs[3] x
     /*  44514 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  44519 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  44523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44525 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44525 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44528 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44532 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44537 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44541 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44546 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44549 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44553 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44558 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  44562 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44567 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44570 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44574 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44579 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44583 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44600 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  44604 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44621 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44643 */     GIR_RootConstrainSelectedInstOperands,
     /*  44644 */     // GIR_Coverage, 11193,
     /*  44644 */     GIR_EraseRootFromParent_Done,
     /*  44645 */   // Label 425: @44645
     /*  44645 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(44830), // Rule ID 11196 //
     /*  44650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44654 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44670 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44686 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44694 */     // MIs[3] x
     /*  44694 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  44699 */     // MIs[3] z
     /*  44699 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  44704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  44708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44710 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44710 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44713 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44717 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44722 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44726 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44731 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44734 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44738 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44743 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  44747 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44752 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44755 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44759 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44764 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44768 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44785 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  44789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44806 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44828 */     GIR_RootConstrainSelectedInstOperands,
     /*  44829 */     // GIR_Coverage, 11196,
     /*  44829 */     GIR_EraseRootFromParent_Done,
     /*  44830 */   // Label 426: @44830
     /*  44830 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(45015), // Rule ID 11197 //
     /*  44835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44839 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44855 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44871 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44879 */     // MIs[3] z
     /*  44879 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  44884 */     // MIs[3] x
     /*  44884 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  44889 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  44893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44895 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44895 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44898 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44902 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44907 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44911 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44916 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44919 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44923 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44928 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  44932 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44937 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44940 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44944 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44949 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44953 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44958 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44961 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44965 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44970 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  44974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44991 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44994 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45013 */     GIR_RootConstrainSelectedInstOperands,
     /*  45014 */     // GIR_Coverage, 11197,
     /*  45014 */     GIR_EraseRootFromParent_Done,
     /*  45015 */   // Label 427: @45015
     /*  45015 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(45200), // Rule ID 7569 //
     /*  45020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45024 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45040 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  45052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  45056 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45064 */     // MIs[3] x
     /*  45064 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45069 */     // MIs[3] z
     /*  45069 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  45078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45080 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  45080 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  45083 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45087 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45092 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45096 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45101 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  45104 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45108 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45113 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  45117 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  45125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45134 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45138 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45143 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  45146 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45150 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45155 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  45159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  45167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  45171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45179 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  45182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45198 */     GIR_RootConstrainSelectedInstOperands,
     /*  45199 */     // GIR_Coverage, 7569,
     /*  45199 */     GIR_EraseRootFromParent_Done,
     /*  45200 */   // Label 428: @45200
     /*  45200 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(45385), // Rule ID 11191 //
     /*  45205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45209 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45225 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  45237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  45241 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45249 */     // MIs[3] z
     /*  45249 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45254 */     // MIs[3] x
     /*  45254 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  45263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45265 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  45265 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  45268 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45272 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45277 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45281 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45286 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  45289 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45293 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45298 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  45302 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45307 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  45310 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45314 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45319 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45323 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  45331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45340 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  45344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  45352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  45356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  45367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45383 */     GIR_RootConstrainSelectedInstOperands,
     /*  45384 */     // GIR_Coverage, 11191,
     /*  45384 */     GIR_EraseRootFromParent_Done,
     /*  45385 */   // Label 429: @45385
     /*  45385 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(45570), // Rule ID 11194 //
     /*  45390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45394 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45410 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  45422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  45426 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45434 */     // MIs[3] x
     /*  45434 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45439 */     // MIs[3] z
     /*  45439 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  45448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45450 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  45450 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  45453 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45457 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45462 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45466 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45471 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  45474 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45478 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45483 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  45487 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45492 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  45495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45504 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45508 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45513 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  45516 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45520 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  45529 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  45537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  45541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45546 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45549 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  45552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45568 */     GIR_RootConstrainSelectedInstOperands,
     /*  45569 */     // GIR_Coverage, 11194,
     /*  45569 */     GIR_EraseRootFromParent_Done,
     /*  45570 */   // Label 430: @45570
     /*  45570 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(45755), // Rule ID 11195 //
     /*  45575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45579 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45595 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  45607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  45611 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45619 */     // MIs[3] z
     /*  45619 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45624 */     // MIs[3] x
     /*  45624 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45629 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  45633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45635 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)))<<P:Predicate_anonymous_19696>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  45635 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  45638 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45642 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45647 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45651 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45656 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  45659 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45663 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45668 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  45672 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45677 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  45680 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45684 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45689 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45693 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  45701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45710 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  45714 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  45722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  45726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45731 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45734 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  45737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45753 */     GIR_RootConstrainSelectedInstOperands,
     /*  45754 */     // GIR_Coverage, 11195,
     /*  45754 */     GIR_EraseRootFromParent_Done,
     /*  45755 */   // Label 431: @45755
     /*  45755 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(45806), // Rule ID 8402 //
     /*  45760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  45764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45780 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  45784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13786),
     /*  45788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45790 */     // (or:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }), i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13786>>  =>  (S_ORN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  45790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  45793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  45795 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  45797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  45804 */     GIR_RootConstrainSelectedInstOperands,
     /*  45805 */     // GIR_Coverage, 8402,
     /*  45805 */     GIR_EraseRootFromParent_Done,
     /*  45806 */   // Label 432: @45806
     /*  45806 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(45857), // Rule ID 66 //
     /*  45811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  45815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45831 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  45835 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13786),
     /*  45839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45841 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src0, (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }))<<P:Predicate_anonymous_13786>>  =>  (S_ORN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  45841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  45844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  45846 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  45848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  45855 */     GIR_RootConstrainSelectedInstOperands,
     /*  45856 */     // GIR_Coverage, 66,
     /*  45856 */     GIR_EraseRootFromParent_Done,
     /*  45857 */   // Label 433: @45857
     /*  45857 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(45922), // Rule ID 2597 //
     /*  45862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  45865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45885 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  45887 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*  45891 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*  45895 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:6:z
     /*  45899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20821),
     /*  45903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45905 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:6:x, i32:{ *:[i32] }:$src1:$pred:6:y)<<P:Predicate_anonymous_20822>>, i32:{ *:[i32] }:$src2:$pred:6:z)<<P:6:Predicate_anonymous_20821>>  =>  (V_AND_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  45905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_OR_B32_e64),
     /*  45908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  45914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  45918 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  45920 */     GIR_RootConstrainSelectedInstOperands,
     /*  45921 */     // GIR_Coverage, 2597,
     /*  45921 */     GIR_EraseRootFromParent_Done,
     /*  45922 */   // Label 434: @45922
     /*  45922 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(45987), // Rule ID 2598 //
     /*  45927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  45930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45950 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  45952 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*  45956 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*  45960 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:7:z
     /*  45964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20824),
     /*  45968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45970 */     // (or:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:7:x, i32:{ *:[i32] }:$src1:$pred:7:y)<<P:Predicate_anonymous_20825>>, i32:{ *:[i32] }:$src2:$pred:7:z)<<P:7:Predicate_anonymous_20824>>  =>  (V_OR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  45970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR3_B32_e64),
     /*  45973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  45979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  45983 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  45985 */     GIR_RootConstrainSelectedInstOperands,
     /*  45986 */     // GIR_Coverage, 2598,
     /*  45986 */     GIR_EraseRootFromParent_Done,
     /*  45987 */   // Label 435: @45987
     /*  45987 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(46052), // Rule ID 2595 //
     /*  45992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  45995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  46007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  46011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  46015 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  46017 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*  46021 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*  46025 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:5:z
     /*  46029 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20819),
     /*  46033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46035 */     // (or:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, i32:{ *:[i32] }:$src1:$pred:5:y)<<P:Predicate_anonymous_20809>>, i32:{ *:[i32] }:$src2:$pred:5:z)<<P:5:Predicate_anonymous_20819>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  46035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  46038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  46040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  46044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  46048 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46050 */     GIR_RootConstrainSelectedInstOperands,
     /*  46051 */     // GIR_Coverage, 2595,
     /*  46051 */     GIR_EraseRootFromParent_Done,
     /*  46052 */   // Label 436: @46052
     /*  46052 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(46117), // Rule ID 8491 //
     /*  46057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  46060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46064 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:6:z
     /*  46068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  46080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  46084 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  46086 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*  46090 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*  46094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20821),
     /*  46098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46100 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:6:z, (and:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:6:x, i32:{ *:[i32] }:$src1:$pred:6:y)<<P:Predicate_anonymous_20822>>)<<P:6:Predicate_anonymous_20821>>  =>  (V_AND_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  46100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_OR_B32_e64),
     /*  46103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  46105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  46109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  46113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  46115 */     GIR_RootConstrainSelectedInstOperands,
     /*  46116 */     // GIR_Coverage, 8491,
     /*  46116 */     GIR_EraseRootFromParent_Done,
     /*  46117 */   // Label 437: @46117
     /*  46117 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(46182), // Rule ID 8492 //
     /*  46122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  46125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46129 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:7:z
     /*  46133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  46145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  46149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  46151 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*  46155 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*  46159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20824),
     /*  46163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46165 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:7:z, (or:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:7:x, i32:{ *:[i32] }:$src1:$pred:7:y)<<P:Predicate_anonymous_20825>>)<<P:7:Predicate_anonymous_20824>>  =>  (V_OR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  46165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR3_B32_e64),
     /*  46168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  46170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  46174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  46178 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  46180 */     GIR_RootConstrainSelectedInstOperands,
     /*  46181 */     // GIR_Coverage, 8492,
     /*  46181 */     GIR_EraseRootFromParent_Done,
     /*  46182 */   // Label 438: @46182
     /*  46182 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(46247), // Rule ID 8489 //
     /*  46187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  46190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46194 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:5:z
     /*  46198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  46206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  46210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  46214 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  46216 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*  46220 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*  46224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20819),
     /*  46228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46230 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:5:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, i32:{ *:[i32] }:$src1:$pred:5:y)<<P:Predicate_anonymous_20809>>)<<P:5:Predicate_anonymous_20819>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  46230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  46233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  46235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  46239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  46243 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  46245 */     GIR_RootConstrainSelectedInstOperands,
     /*  46246 */     // GIR_Coverage, 8489,
     /*  46246 */     GIR_EraseRootFromParent_Done,
     /*  46247 */   // Label 439: @46247
     /*  46247 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(46273), // Rule ID 54 //
     /*  46252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  46256 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13786),
     /*  46260 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13786>>  =>  (S_OR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  46260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /*  46265 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  46271 */     GIR_RootConstrainSelectedInstOperands,
     /*  46272 */     // GIR_Coverage, 54,
     /*  46272 */     GIR_Done,
     /*  46273 */   // Label 440: @46273
     /*  46273 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(46293), // Rule ID 815 //
     /*  46278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46282 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_OR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  46282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /*  46287 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  46291 */     GIR_RootConstrainSelectedInstOperands,
     /*  46292 */     // GIR_Coverage, 815,
     /*  46292 */     GIR_Done,
     /*  46293 */   // Label 441: @46293
     /*  46293 */   GIM_Reject,
     /*  46294 */ // Label 401: @46294
     /*  46294 */ GIM_Reject,
     /*  46295 */ // Label 386: @46295
     /*  46295 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(55483),
     /*  46300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  46303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  46306 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(46621), // Rule ID 11165 //
     /*  46311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46315 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  46327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  46331 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  46343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  46347 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  46351 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46359 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46363 */     // MIs[3] x
     /*  46363 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  46368 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  46372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46374 */     // (or:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  46374 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  46377 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46381 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46386 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  46392 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46397 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46402 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  46405 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46409 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46414 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  46420 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46425 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46430 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  46433 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46437 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46442 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  46448 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46453 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46458 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  46461 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  46465 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46470 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  46473 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  46476 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  46479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  46481 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  46484 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46488 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46493 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  46499 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46504 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46509 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46512 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46516 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46521 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  46527 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46532 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46537 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  46540 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46544 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46549 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  46555 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46560 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  46568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  46572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46577 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46580 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  46583 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  46586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  46591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46596 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  46599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  46602 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  46605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46620 */     // GIR_Coverage, 11165,
     /*  46620 */     GIR_EraseRootFromParent_Done,
     /*  46621 */   // Label 443: @46621
     /*  46621 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(46936), // Rule ID 11164 //
     /*  46626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46630 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  46642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  46646 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  46658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  46662 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  46666 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46674 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  46678 */     // MIs[3] x
     /*  46678 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  46683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  46687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46689 */     // (or:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  46689 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  46692 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46696 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46701 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  46707 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46712 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46717 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  46720 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46724 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46729 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  46735 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46740 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46745 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  46748 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46752 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46757 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  46763 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46768 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46773 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  46776 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  46780 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46785 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  46788 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  46791 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  46794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  46796 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  46799 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46803 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46808 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  46814 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46819 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46824 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46827 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46831 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46836 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  46842 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46847 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  46855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46864 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  46870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  46883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  46887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46895 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  46898 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  46901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  46906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46911 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  46914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  46917 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  46920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46935 */     // GIR_Coverage, 11164,
     /*  46935 */     GIR_EraseRootFromParent_Done,
     /*  46936 */   // Label 444: @46936
     /*  46936 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(47251), // Rule ID 11163 //
     /*  46941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46945 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  46957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  46961 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  46973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  46977 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  46981 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46989 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46993 */     // MIs[3] x
     /*  46993 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  46998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  47002 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47004 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  47004 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  47007 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47011 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47016 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  47022 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47027 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47032 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  47035 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47039 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47044 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  47050 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47055 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47060 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  47063 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47067 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47072 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  47078 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47083 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47088 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  47091 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47095 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47100 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  47103 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  47106 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  47109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  47111 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47114 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47118 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47123 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  47129 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47134 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47139 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47142 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47146 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47151 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  47157 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47162 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47167 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  47170 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47174 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47179 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  47185 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47190 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  47198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47207 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47210 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47213 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  47216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  47221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47226 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  47229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  47232 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  47235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47250 */     // GIR_Coverage, 11163,
     /*  47250 */     GIR_EraseRootFromParent_Done,
     /*  47251 */   // Label 445: @47251
     /*  47251 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(47566), // Rule ID 11162 //
     /*  47256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47260 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  47272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  47276 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  47288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  47292 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  47296 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47304 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  47308 */     // MIs[3] x
     /*  47308 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  47313 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  47317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47319 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })), (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  47319 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  47322 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47326 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47331 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  47337 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47342 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47347 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  47350 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47354 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47359 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  47365 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47370 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47375 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  47378 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47382 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47387 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  47393 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47398 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47403 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  47406 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47410 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47415 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  47418 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  47421 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  47424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  47426 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47429 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47433 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47438 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  47444 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47449 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47454 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47457 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47461 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47466 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  47472 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47477 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  47485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47494 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  47500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  47513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47525 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47528 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  47531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  47536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47541 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  47544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  47547 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  47550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47565 */     // GIR_Coverage, 11162,
     /*  47565 */     GIR_EraseRootFromParent_Done,
     /*  47566 */   // Label 446: @47566
     /*  47566 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(47881), // Rule ID 11159 //
     /*  47571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47575 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  47587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  47591 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  47603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  47607 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47615 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47619 */     // MIs[3] x
     /*  47619 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  47624 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  47628 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  47632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47634 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x), (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  47634 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  47637 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47641 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47646 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  47652 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47657 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47662 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  47665 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47669 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47674 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  47680 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47685 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47690 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  47693 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47697 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47702 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  47708 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47713 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47718 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  47721 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47725 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47730 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  47733 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  47736 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  47739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  47741 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47744 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47748 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47753 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  47759 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47764 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47769 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47772 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47776 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47781 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  47787 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47792 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  47800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47809 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  47815 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47820 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  47828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47837 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47840 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47843 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  47846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  47851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47856 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  47859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  47862 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  47865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47880 */     // GIR_Coverage, 11159,
     /*  47880 */     GIR_EraseRootFromParent_Done,
     /*  47881 */   // Label 447: @47881
     /*  47881 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(48196), // Rule ID 11161 //
     /*  47886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47890 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  47902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  47906 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  47918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  47922 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47930 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47934 */     // MIs[3] x
     /*  47934 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  47939 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  47943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  47947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47949 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y), (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  47949 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  47952 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47956 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47961 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  47967 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47972 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47977 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  47980 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47984 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47989 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  47995 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48000 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48005 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  48008 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48012 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48017 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  48023 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48028 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48033 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  48036 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48040 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48045 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  48048 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  48051 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  48054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  48056 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  48059 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48063 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48068 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  48074 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48079 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48084 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  48087 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48091 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48096 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  48102 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48107 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48112 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48115 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48119 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48124 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  48130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48135 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  48143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48152 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48155 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  48158 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  48161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  48166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48171 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  48174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  48177 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  48180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48195 */     // GIR_Coverage, 11161,
     /*  48195 */     GIR_EraseRootFromParent_Done,
     /*  48196 */   // Label 448: @48196
     /*  48196 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(48511), // Rule ID 7319 //
     /*  48201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48205 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48221 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  48233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48237 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48245 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48249 */     // MIs[3] x
     /*  48249 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  48254 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  48258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  48262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48264 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x), (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  48264 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  48267 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48271 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48276 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  48282 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48287 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48292 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  48295 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48299 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48304 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  48310 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48315 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48320 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  48323 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48327 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48332 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  48338 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48343 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48348 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  48351 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48355 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48360 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  48363 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  48366 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  48369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  48371 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  48374 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48378 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48383 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  48389 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48394 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48399 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  48402 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48406 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48411 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  48417 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48422 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48427 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48430 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48434 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48439 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  48445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  48458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48467 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48470 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  48473 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  48476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  48481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48486 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  48489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  48492 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  48495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48510 */     // GIR_Coverage, 7319,
     /*  48510 */     GIR_EraseRootFromParent_Done,
     /*  48511 */   // Label 449: @48511
     /*  48511 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(48826), // Rule ID 11160 //
     /*  48516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48520 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48536 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  48548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48552 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48560 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48564 */     // MIs[3] x
     /*  48564 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  48569 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  48573 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  48577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48579 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  48579 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  48582 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48586 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48591 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  48597 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48602 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48607 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  48610 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48614 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48619 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  48625 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48630 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48635 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  48638 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48642 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48647 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  48653 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48658 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48663 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  48666 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48670 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48675 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  48678 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  48681 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  48684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  48686 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  48689 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48693 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48698 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  48704 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48709 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48714 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  48717 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48721 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48726 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  48732 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48737 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48742 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48745 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48749 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48754 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  48760 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48765 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  48773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48782 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48785 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  48788 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  48791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  48796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48801 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  48804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  48807 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  48810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48825 */     // GIR_Coverage, 11160,
     /*  48825 */     GIR_EraseRootFromParent_Done,
     /*  48826 */   // Label 450: @48826
     /*  48826 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(49234), // Rule ID 11217 //
     /*  48831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48835 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48851 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  48859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  48863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48867 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  48871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48875 */     // MIs[3] x
     /*  48875 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  48880 */     // MIs[3] z
     /*  48880 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  48885 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  48889 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48891 */     // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  48891 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  48894 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48898 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48903 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  48909 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48914 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48919 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  48922 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48926 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48931 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  48937 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48942 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48947 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  48950 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48954 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48959 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  48965 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48970 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48975 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  48978 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48982 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48987 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  48993 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48998 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49003 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  49006 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49010 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49015 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  49018 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  49021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  49023 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  49026 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49030 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49035 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  49038 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  49041 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  49044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  49046 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  49049 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49053 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49058 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49064 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49069 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49074 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  49077 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49081 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49086 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  49092 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49097 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49102 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  49105 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49109 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49114 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49120 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49125 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49130 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  49133 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49137 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49142 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  49148 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49153 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49158 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  49161 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49165 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49170 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  49173 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  49176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  49178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  49181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49190 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  49193 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  49196 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  49199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  49204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  49209 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  49212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  49215 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  49218 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49233 */     // GIR_Coverage, 11217,
     /*  49233 */     GIR_EraseRootFromParent_Done,
     /*  49234 */   // Label 451: @49234
     /*  49234 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(49642), // Rule ID 11218 //
     /*  49239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49243 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  49255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49259 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  49267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  49271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49275 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  49279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49283 */     // MIs[3] z
     /*  49283 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  49288 */     // MIs[3] x
     /*  49288 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  49293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  49297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49299 */     // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  49299 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  49302 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49306 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49311 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  49317 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49322 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49327 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  49330 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49334 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49339 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  49345 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49350 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49355 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  49358 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49362 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49367 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  49373 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49378 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49383 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  49386 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49390 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49395 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  49401 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49406 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49411 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  49414 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49418 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49423 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  49426 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  49429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  49431 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  49434 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49438 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49443 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  49446 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  49449 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  49452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  49454 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  49457 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49461 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49466 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49472 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49477 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49482 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  49485 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49489 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49494 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  49500 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49505 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49510 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  49513 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49517 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49522 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49528 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49533 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  49541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49550 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  49556 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49561 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  49569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49578 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  49581 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  49584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  49586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  49589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49598 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  49601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  49604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  49607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  49612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  49617 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  49620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  49623 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  49626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49641 */     // GIR_Coverage, 11218,
     /*  49641 */     GIR_EraseRootFromParent_Done,
     /*  49642 */   // Label 452: @49642
     /*  49642 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(50050), // Rule ID 11219 //
     /*  49647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49651 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  49663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49667 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  49675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  49679 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49683 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  49687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49691 */     // MIs[3] x
     /*  49691 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  49696 */     // MIs[3] z
     /*  49696 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  49701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  49705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49707 */     // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  49707 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  49710 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49714 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49719 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  49725 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49730 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49735 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  49738 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49742 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49747 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  49753 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49758 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49763 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  49766 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49770 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49775 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  49781 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49786 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49791 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  49794 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49798 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49803 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  49809 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49814 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49819 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  49822 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49826 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49831 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  49834 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  49837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  49839 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  49842 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49846 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49851 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  49854 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  49857 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  49860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  49862 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  49865 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49869 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49874 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49880 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49885 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49890 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  49893 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49897 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49902 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  49908 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49913 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49918 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  49921 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49925 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49930 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49936 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49941 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49946 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  49949 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49953 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49958 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  49964 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49969 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49974 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  49977 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49981 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49986 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  49989 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  49992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  49994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  49997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50006 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  50009 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  50012 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  50015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  50020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50025 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  50028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  50031 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  50034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50049 */     // GIR_Coverage, 11219,
     /*  50049 */     GIR_EraseRootFromParent_Done,
     /*  50050 */   // Label 453: @50050
     /*  50050 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(50458), // Rule ID 11220 //
     /*  50055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50059 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50075 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  50079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  50083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50091 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  50095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50099 */     // MIs[3] z
     /*  50099 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  50104 */     // MIs[3] x
     /*  50104 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  50109 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  50113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50115 */     // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  50115 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  50118 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50122 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50127 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50133 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50138 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50143 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  50146 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50150 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50155 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  50161 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50166 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50171 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  50174 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50178 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50183 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50189 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50194 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50199 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  50202 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50206 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50211 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  50217 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50222 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50227 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  50230 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  50234 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50239 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  50242 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  50245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  50247 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  50250 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50254 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50259 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  50262 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  50265 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  50268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  50270 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  50273 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50277 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50282 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50288 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50293 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50298 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  50301 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50305 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50310 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  50316 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50321 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50326 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  50329 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50333 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50338 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50344 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50349 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50354 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  50357 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50361 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50366 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  50372 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50377 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50382 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  50385 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  50389 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50394 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  50397 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  50400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  50402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  50405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50414 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  50417 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  50420 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  50423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  50428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50433 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  50436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  50439 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  50442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50457 */     // GIR_Coverage, 11220,
     /*  50457 */     GIR_EraseRootFromParent_Done,
     /*  50458 */   // Label 454: @50458
     /*  50458 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(50866), // Rule ID 11213 //
     /*  50463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50467 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50483 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  50491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50499 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  50503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50507 */     // MIs[3] x
     /*  50507 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  50512 */     // MIs[3] z
     /*  50512 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  50517 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  50521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50523 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  50523 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  50526 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50530 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50535 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50541 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50546 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50551 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  50554 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50558 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50563 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  50569 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50574 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50579 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  50582 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50586 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50591 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50597 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50602 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50607 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  50610 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50614 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50619 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  50625 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50630 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50635 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  50638 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  50642 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50647 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  50650 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  50653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  50655 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  50658 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50662 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50667 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  50670 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  50673 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  50676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  50678 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  50681 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50685 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50690 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50696 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50701 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50706 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  50709 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50713 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50718 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  50724 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50729 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50734 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  50737 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50741 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50746 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50752 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50757 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50762 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  50765 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50769 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50774 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  50780 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50785 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  50793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  50797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50802 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  50805 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  50808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  50810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  50813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  50825 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  50828 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  50831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  50836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50841 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  50844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  50847 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  50850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50865 */     // GIR_Coverage, 11213,
     /*  50865 */     GIR_EraseRootFromParent_Done,
     /*  50866 */   // Label 455: @50866
     /*  50866 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(51274), // Rule ID 11214 //
     /*  50871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50875 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50891 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  50899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50907 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  50911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50915 */     // MIs[3] z
     /*  50915 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  50920 */     // MIs[3] x
     /*  50920 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  50925 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  50929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50931 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  50931 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  50934 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50938 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50943 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50949 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50954 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50959 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  50962 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50966 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50971 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  50977 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50982 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50987 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  50990 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50994 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50999 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51005 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51010 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51015 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  51018 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51022 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51027 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  51033 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51038 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51043 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  51046 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51050 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51055 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  51058 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  51061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  51063 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  51066 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51070 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51075 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  51078 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  51081 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  51084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  51086 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  51089 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51093 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51098 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51104 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51109 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51114 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  51117 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51121 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51126 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  51132 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51137 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51142 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  51145 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51149 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51154 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51160 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51165 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51170 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  51173 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51177 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51182 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  51188 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51193 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51198 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  51201 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51205 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51210 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  51213 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  51216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  51221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51230 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  51233 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  51236 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  51239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  51244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51249 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  51252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  51255 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  51258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51273 */     // GIR_Coverage, 11214,
     /*  51273 */     GIR_EraseRootFromParent_Done,
     /*  51274 */   // Label 456: @51274
     /*  51274 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(51682), // Rule ID 11215 //
     /*  51279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51283 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51299 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  51307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51315 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  51319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51323 */     // MIs[3] x
     /*  51323 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  51328 */     // MIs[3] z
     /*  51328 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  51333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  51337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51339 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  51339 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  51342 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51346 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51351 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51357 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51362 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51367 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  51370 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51374 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51379 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  51385 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51390 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51395 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  51398 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51402 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51407 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51413 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51418 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51423 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  51426 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51430 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51435 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  51441 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51446 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51451 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  51454 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51458 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51463 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  51466 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  51469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  51471 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  51474 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51478 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51483 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  51486 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  51489 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  51492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  51494 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  51497 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51501 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51506 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51512 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51517 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51522 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  51525 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51529 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51534 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  51540 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51545 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51550 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  51553 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51557 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51562 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51568 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51573 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51578 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  51581 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51585 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51590 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  51596 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51601 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51606 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  51609 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51613 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51618 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  51621 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  51624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  51629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51638 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  51641 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  51644 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  51647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  51652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51657 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  51660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  51663 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  51666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51681 */     // GIR_Coverage, 11215,
     /*  51681 */     GIR_EraseRootFromParent_Done,
     /*  51682 */   // Label 457: @51682
     /*  51682 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(52090), // Rule ID 11216 //
     /*  51687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51691 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51707 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  51715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51723 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  51727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51731 */     // MIs[3] z
     /*  51731 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  51736 */     // MIs[3] x
     /*  51736 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  51741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  51745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51747 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  51747 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  51750 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51754 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51759 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51765 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51770 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51775 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  51778 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51782 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51787 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  51793 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51798 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51803 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  51806 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51810 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51815 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51821 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51826 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51831 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  51834 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51838 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51843 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  51849 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51854 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51859 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  51862 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51866 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51871 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  51874 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  51877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  51879 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  51882 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51886 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51891 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  51894 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  51897 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  51900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  51902 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  51905 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51909 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51914 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51920 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51925 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51930 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  51933 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51937 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51942 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  51948 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51953 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51958 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  51961 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51965 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51970 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51976 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51981 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51986 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  51989 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51993 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51998 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  52004 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52009 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  52017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52026 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  52029 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  52032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  52034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  52037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52046 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  52049 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  52052 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  52055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  52060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52065 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  52068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  52071 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  52074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52089 */     // GIR_Coverage, 11216,
     /*  52089 */     GIR_EraseRootFromParent_Done,
     /*  52090 */   // Label 458: @52090
     /*  52090 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(52498), // Rule ID 11207 //
     /*  52095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52099 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52115 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52131 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  52135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  52139 */     // MIs[3] x
     /*  52139 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  52144 */     // MIs[3] z
     /*  52144 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  52149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  52153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52155 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  52155 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  52158 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52162 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52167 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52173 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52178 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52183 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  52186 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52190 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52195 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  52201 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52206 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52211 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  52214 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52218 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52223 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52229 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52234 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52239 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  52242 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52246 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52251 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  52257 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52262 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52267 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  52270 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52274 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52279 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  52282 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  52285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  52287 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  52290 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52294 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52299 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  52302 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  52305 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  52308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  52310 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  52313 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52317 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52322 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  52328 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52333 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52338 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  52341 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52345 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52350 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  52356 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52361 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52366 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  52369 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52373 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52378 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  52384 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52389 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52394 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  52397 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52401 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52406 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  52412 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52417 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  52425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52434 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  52437 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  52440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  52442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  52445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52454 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  52457 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  52460 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  52463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  52468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52473 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  52476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  52479 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  52482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52497 */     // GIR_Coverage, 11207,
     /*  52497 */     GIR_EraseRootFromParent_Done,
     /*  52498 */   // Label 459: @52498
     /*  52498 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(52906), // Rule ID 11208 //
     /*  52503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52507 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52523 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52539 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  52543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  52547 */     // MIs[3] z
     /*  52547 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  52552 */     // MIs[3] x
     /*  52552 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  52557 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  52561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52563 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  52563 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  52566 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52570 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52575 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52581 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52586 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52591 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  52594 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52598 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52603 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  52609 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52614 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52619 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  52622 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52626 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52631 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52637 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52642 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52647 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  52650 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52654 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52659 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  52665 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52670 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52675 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  52678 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52682 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52687 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  52690 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  52693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  52695 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  52698 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52702 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52707 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  52710 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  52713 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  52716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  52718 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  52721 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52725 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52730 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  52736 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52741 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52746 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  52749 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52753 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52758 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  52764 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52769 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52774 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  52777 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52781 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52786 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  52792 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52797 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52802 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  52805 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52809 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52814 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  52820 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52825 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52830 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  52833 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52837 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52842 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  52845 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  52848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  52850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  52853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52862 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  52865 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  52868 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  52871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  52876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52881 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  52884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  52887 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  52890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52905 */     // GIR_Coverage, 11208,
     /*  52905 */     GIR_EraseRootFromParent_Done,
     /*  52906 */   // Label 460: @52906
     /*  52906 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(53314), // Rule ID 11211 //
     /*  52911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52915 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52931 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52947 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  52951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  52955 */     // MIs[3] x
     /*  52955 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  52960 */     // MIs[3] z
     /*  52960 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  52965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  52969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52971 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  52971 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  52974 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52978 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52983 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52989 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52994 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52999 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  53002 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53006 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53011 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  53017 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53022 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53027 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  53030 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53034 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53039 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53045 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53050 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53055 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  53058 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53062 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53067 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  53073 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53078 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53083 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  53086 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53090 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53095 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  53098 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  53101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  53103 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  53106 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53110 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53115 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  53118 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  53121 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  53124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  53126 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  53129 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53133 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53138 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53144 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53149 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53154 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  53157 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53161 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53166 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  53172 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53177 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53182 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  53185 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53189 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53194 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53200 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53205 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53210 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  53213 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53217 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53222 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  53228 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53233 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53238 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  53241 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53245 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53250 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  53253 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  53256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  53261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53270 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53273 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  53276 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  53279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  53284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53289 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  53292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  53295 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  53298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53313 */     // GIR_Coverage, 11211,
     /*  53313 */     GIR_EraseRootFromParent_Done,
     /*  53314 */   // Label 461: @53314
     /*  53314 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(53722), // Rule ID 11212 //
     /*  53319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53323 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53339 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53351 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53355 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  53359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53363 */     // MIs[3] z
     /*  53363 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  53368 */     // MIs[3] x
     /*  53368 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  53373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  53377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53379 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  53379 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  53382 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53386 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53391 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53397 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53402 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53407 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  53410 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53414 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53419 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  53425 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53430 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53435 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  53438 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53442 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53447 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53453 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53458 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53463 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  53466 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53470 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53475 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  53481 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53486 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53491 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  53494 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53498 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53503 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  53506 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  53509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  53511 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  53514 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53518 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53523 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  53526 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  53529 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  53532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  53534 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  53537 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53541 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53546 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53552 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53557 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53562 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  53565 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53569 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53574 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  53580 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53585 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53590 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  53593 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53597 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53602 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53608 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53613 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53618 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  53621 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53625 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53630 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  53636 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53641 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  53649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53658 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  53661 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  53664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  53669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53678 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53681 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  53684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  53687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  53692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53697 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  53700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  53703 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  53706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53721 */     // GIR_Coverage, 11212,
     /*  53721 */     GIR_EraseRootFromParent_Done,
     /*  53722 */   // Label 462: @53722
     /*  53722 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(54130), // Rule ID 7570 //
     /*  53727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53731 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53747 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53763 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53771 */     // MIs[3] x
     /*  53771 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  53776 */     // MIs[3] z
     /*  53776 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  53781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  53785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53787 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  53787 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  53790 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53794 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53799 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53805 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53810 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53815 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  53818 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53822 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53827 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  53833 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53838 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53843 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  53846 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53850 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53855 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53861 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53866 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53871 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  53874 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53878 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53883 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  53889 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53894 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53899 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  53902 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53906 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53911 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  53914 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  53917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  53919 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  53922 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53926 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53931 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  53934 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  53937 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  53940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  53942 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  53945 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53949 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53954 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53960 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53965 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53970 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  53973 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53977 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53982 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  53988 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53993 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53998 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  54001 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54005 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54010 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54016 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54021 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54026 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  54029 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54033 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54038 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  54044 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54049 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54054 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  54057 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54061 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54066 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  54069 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  54072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  54077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54086 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54089 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  54092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  54095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  54100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54105 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  54108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  54111 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  54114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54129 */     // GIR_Coverage, 7570,
     /*  54129 */     GIR_EraseRootFromParent_Done,
     /*  54130 */   // Label 463: @54130
     /*  54130 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(54538), // Rule ID 11206 //
     /*  54135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54139 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54155 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  54159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54171 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54179 */     // MIs[3] z
     /*  54179 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  54184 */     // MIs[3] x
     /*  54184 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  54189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  54193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54195 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  54195 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  54198 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54202 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54207 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54213 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54218 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54223 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  54226 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54230 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54235 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  54241 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54246 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54251 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  54254 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54258 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54263 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54269 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54274 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54279 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  54282 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54286 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54291 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  54297 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54302 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54307 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  54310 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54314 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54319 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  54322 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  54325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  54327 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  54330 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54334 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54339 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  54342 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  54345 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  54348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  54350 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  54353 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54357 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54362 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54368 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54373 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54378 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  54381 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54385 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54390 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  54396 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54401 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54406 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  54409 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54413 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54418 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54424 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54429 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54434 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  54437 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54441 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54446 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  54452 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54457 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54462 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  54465 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54469 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54474 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  54477 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  54480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  54485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54494 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54497 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  54500 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  54503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  54508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54513 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  54516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  54519 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  54522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54537 */     // GIR_Coverage, 11206,
     /*  54537 */     GIR_EraseRootFromParent_Done,
     /*  54538 */   // Label 464: @54538
     /*  54538 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(54946), // Rule ID 11209 //
     /*  54543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54547 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54563 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  54567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54579 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54587 */     // MIs[3] x
     /*  54587 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  54592 */     // MIs[3] z
     /*  54592 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  54597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  54601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54603 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  54603 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  54606 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54610 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54615 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54621 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54626 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54631 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  54634 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54638 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54643 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  54649 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54654 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54659 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  54662 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54666 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54671 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54677 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54682 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54687 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  54690 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54694 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54699 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  54705 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54710 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54715 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  54718 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54722 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54727 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  54730 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  54733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  54735 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  54738 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54742 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54747 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  54750 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  54753 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  54756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  54758 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  54761 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54765 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54770 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54776 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54781 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54786 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  54789 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54793 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54798 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  54804 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54809 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54814 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  54817 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54821 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54826 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54832 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54837 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54842 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  54845 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54849 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54854 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  54860 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54865 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54870 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  54873 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54877 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54882 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  54885 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  54888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  54893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54902 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54905 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  54908 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  54911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  54916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54921 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  54924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  54927 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  54930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54945 */     // GIR_Coverage, 11209,
     /*  54945 */     GIR_EraseRootFromParent_Done,
     /*  54946 */   // Label 465: @54946
     /*  54946 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(55354), // Rule ID 11210 //
     /*  54951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54955 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54971 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  54975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54987 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54995 */     // MIs[3] z
     /*  54995 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  55000 */     // MIs[3] x
     /*  55000 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  55005 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19696),
     /*  55009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55011 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)))<<P:Predicate_anonymous_19696>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  55011 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  55014 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55018 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55023 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  55029 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55034 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55039 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  55042 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55046 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55051 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  55057 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55062 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55067 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  55070 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55074 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55079 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  55085 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55090 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55095 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  55098 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55102 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55107 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  55113 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55118 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55123 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  55126 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  55130 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55135 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  55138 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  55141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  55143 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  55146 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  55150 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55155 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  55158 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  55161 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  55164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  55166 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  55169 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55173 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55178 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  55184 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55189 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55194 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  55197 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55201 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55206 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  55212 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55217 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55222 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  55225 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55229 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55234 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  55240 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55245 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55250 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  55253 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55257 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55262 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  55268 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55273 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  55281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  55285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55290 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  55293 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  55296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  55298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  55301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  55305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55310 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  55313 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  55316 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  55319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  55324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55329 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  55332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  55335 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  55338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55353 */     // GIR_Coverage, 11210,
     /*  55353 */     GIR_EraseRootFromParent_Done,
     /*  55354 */   // Label 466: @55354
     /*  55354 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(55405), // Rule ID 8403 //
     /*  55359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55379 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55383 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13786),
     /*  55387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55389 */     // (or:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }), i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13786>>  =>  (S_ORN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  55389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55394 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  55396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55403 */     GIR_RootConstrainSelectedInstOperands,
     /*  55404 */     // GIR_Coverage, 8403,
     /*  55404 */     GIR_EraseRootFromParent_Done,
     /*  55405 */   // Label 467: @55405
     /*  55405 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(55456), // Rule ID 67 //
     /*  55410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13786),
     /*  55438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55440 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$src0, (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }))<<P:Predicate_anonymous_13786>>  =>  (S_ORN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  55440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55445 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  55447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55454 */     GIR_RootConstrainSelectedInstOperands,
     /*  55455 */     // GIR_Coverage, 67,
     /*  55455 */     GIR_EraseRootFromParent_Done,
     /*  55456 */   // Label 468: @55456
     /*  55456 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(55482), // Rule ID 55 //
     /*  55461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13786),
     /*  55469 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13786>>  =>  (S_OR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  55469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B64),
     /*  55474 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  55480 */     GIR_RootConstrainSelectedInstOperands,
     /*  55481 */     // GIR_Coverage, 55,
     /*  55481 */     GIR_Done,
     /*  55482 */   // Label 469: @55482
     /*  55482 */   GIM_Reject,
     /*  55483 */ // Label 442: @55483
     /*  55483 */ GIM_Reject,
     /*  55484 */ // Label 387: @55484
     /*  55484 */ GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(55634),
     /*  55489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  55492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  55495 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(55554), // Rule ID 8476 //
     /*  55500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  55504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  55516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  55520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55524 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55530 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55532 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13786),
     /*  55536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55538 */     // (or:{ *:[v2i16] } (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }), v2i16:{ *:[v2i16] }:$src0)<<P:Predicate_anonymous_13786>>  =>  (S_ORN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
     /*  55538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  55541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55543 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  55545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55552 */     GIR_RootConstrainSelectedInstOperands,
     /*  55553 */     // GIR_Coverage, 8476,
     /*  55553 */     GIR_EraseRootFromParent_Done,
     /*  55554 */   // Label 471: @55554
     /*  55554 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(55613), // Rule ID 1888 //
     /*  55559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  55563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  55575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  55579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55583 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55589 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13786),
     /*  55595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55597 */     // (or:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }))<<P:Predicate_anonymous_13786>>  =>  (S_ORN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
     /*  55597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  55600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55602 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  55604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55611 */     GIR_RootConstrainSelectedInstOperands,
     /*  55612 */     // GIR_Coverage, 1888,
     /*  55612 */     GIR_EraseRootFromParent_Done,
     /*  55613 */   // Label 472: @55613
     /*  55613 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(55633), // Rule ID 2529 //
     /*  55618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55622 */     // (or:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1)  =>  (V_OR_B32_e64:{ *:[v2i16] } VSrc_b32:{ *:[v2i16] }:$src0, VSrc_b32:{ *:[v2i16] }:$src1)
     /*  55622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /*  55627 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  55631 */     GIR_RootConstrainSelectedInstOperands,
     /*  55632 */     // GIR_Coverage, 2529,
     /*  55632 */     GIR_Done,
     /*  55633 */   // Label 473: @55633
     /*  55633 */   GIM_Reject,
     /*  55634 */ // Label 470: @55634
     /*  55634 */ GIM_Reject,
     /*  55635 */ // Label 388: @55635
     /*  55635 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(55757),
     /*  55640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55646 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13786),
     /*  55650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55654 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(55705), // Rule ID 8478 //
     /*  55659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55679 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55689 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }), v2i32:{ *:[v2i32] }:$src0)<<P:Predicate_anonymous_13786>>  =>  (S_ORN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
     /*  55689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55694 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  55696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55703 */     GIR_RootConstrainSelectedInstOperands,
     /*  55704 */     // GIR_Coverage, 8478,
     /*  55704 */     GIR_EraseRootFromParent_Done,
     /*  55705 */   // Label 475: @55705
     /*  55705 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(55756), // Rule ID 1890 //
     /*  55710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55730 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55736 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55740 */     // (or:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src0, (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }))<<P:Predicate_anonymous_13786>>  =>  (S_ORN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
     /*  55740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55745 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  55747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55754 */     GIR_RootConstrainSelectedInstOperands,
     /*  55755 */     // GIR_Coverage, 1890,
     /*  55755 */     GIR_EraseRootFromParent_Done,
     /*  55756 */   // Label 476: @55756
     /*  55756 */   GIM_Reject,
     /*  55757 */ // Label 474: @55757
     /*  55757 */ GIM_Reject,
     /*  55758 */ // Label 389: @55758
     /*  55758 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(55880),
     /*  55763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55769 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13786),
     /*  55773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55777 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(55828), // Rule ID 8477 //
     /*  55782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55802 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55812 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }), v4i16:{ *:[v4i16] }:$src0)<<P:Predicate_anonymous_13786>>  =>  (S_ORN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
     /*  55812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55817 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  55819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55826 */     GIR_RootConstrainSelectedInstOperands,
     /*  55827 */     // GIR_Coverage, 8477,
     /*  55827 */     GIR_EraseRootFromParent_Done,
     /*  55828 */   // Label 478: @55828
     /*  55828 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(55879), // Rule ID 1889 //
     /*  55833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55853 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55859 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55863 */     // (or:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src0, (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }))<<P:Predicate_anonymous_13786>>  =>  (S_ORN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
     /*  55863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55868 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  55870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55877 */     GIR_RootConstrainSelectedInstOperands,
     /*  55878 */     // GIR_Coverage, 1889,
     /*  55878 */     GIR_EraseRootFromParent_Done,
     /*  55879 */   // Label 479: @55879
     /*  55879 */   GIM_Reject,
     /*  55880 */ // Label 477: @55880
     /*  55880 */ GIM_Reject,
     /*  55881 */ // Label 390: @55881
     /*  55881 */ GIM_Reject,
     /*  55882 */ // Label 5: @55882
     /*  55882 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 485*/ GIMT_Encode4(60573),
     /*  55893 */ /*GILLT_s1*//*Label 480*/ GIMT_Encode4(55913),
     /*  55897 */ /*GILLT_s16*//*Label 481*/ GIMT_Encode4(55976),
     /*  55901 */ /*GILLT_s32*//*Label 482*/ GIMT_Encode4(56114),
     /*  55905 */ /*GILLT_s64*//*Label 483*/ GIMT_Encode4(57913),
     /*  55909 */ /*GILLT_v2s16*//*Label 484*/ GIMT_Encode4(60546),
     /*  55913 */ // Label 480: @55913
     /*  55913 */ GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(55975),
     /*  55918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  55921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  55924 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(55949), // Rule ID 7409 //
     /*  55929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  55932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55936 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  55936 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
     /*  55941 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  55947 */     GIR_RootConstrainSelectedInstOperands,
     /*  55948 */     // GIR_Coverage, 7409,
     /*  55948 */     GIR_Done,
     /*  55949 */   // Label 487: @55949
     /*  55949 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(55974), // Rule ID 7416 //
     /*  55954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  55957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  55961 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  55961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /*  55966 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  55972 */     GIR_RootConstrainSelectedInstOperands,
     /*  55973 */     // GIR_Coverage, 7416,
     /*  55973 */     GIR_Done,
     /*  55974 */   // Label 488: @55974
     /*  55974 */   GIM_Reject,
     /*  55975 */ // Label 486: @55975
     /*  55975 */ GIM_Reject,
     /*  55976 */ // Label 481: @55976
     /*  55976 */ GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(56113),
     /*  55981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  55984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  55987 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(56010), // Rule ID 2524 //
     /*  55992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  55995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55999 */     // (xor:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_XOR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  55999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  56004 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  56008 */     GIR_RootConstrainSelectedInstOperands,
     /*  56009 */     // GIR_Coverage, 2524,
     /*  56009 */     GIR_Done,
     /*  56010 */   // Label 490: @56010
     /*  56010 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(56033), // Rule ID 2527 //
     /*  56015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  56018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56022 */     // (xor:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_XOR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  56022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  56027 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  56031 */     GIR_RootConstrainSelectedInstOperands,
     /*  56032 */     // GIR_Coverage, 2527,
     /*  56032 */     GIR_Done,
     /*  56033 */   // Label 491: @56033
     /*  56033 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(56089), // Rule ID 907 //
     /*  56038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  56041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  56045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  56052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  56059 */     // (xor:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_XOR_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  56059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B16_t16_e64),
     /*  56062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  56069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  56074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  56079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  56084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56087 */     GIR_RootConstrainSelectedInstOperands,
     /*  56088 */     // GIR_Coverage, 907,
     /*  56088 */     GIR_EraseRootFromParent_Done,
     /*  56089 */   // Label 492: @56089
     /*  56089 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(56112), // Rule ID 908 //
     /*  56094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  56097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56101 */     // (xor:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_XOR_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  56101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B16_fake16_e64),
     /*  56106 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  56110 */     GIR_RootConstrainSelectedInstOperands,
     /*  56111 */     // GIR_Coverage, 908,
     /*  56111 */     GIR_Done,
     /*  56112 */   // Label 493: @56112
     /*  56112 */   GIM_Reject,
     /*  56113 */ // Label 489: @56113
     /*  56113 */ GIM_Reject,
     /*  56114 */ // Label 482: @56114
     /*  56114 */ GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(57912),
     /*  56119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  56122 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(56180), // Rule ID 60 //
     /*  56127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  56134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  56152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  56156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13755),
     /*  56160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56162 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_and_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_13755>>  =>  (S_NAND_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  56162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NAND_B32),
     /*  56165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  56167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  56175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  56178 */     GIR_RootConstrainSelectedInstOperands,
     /*  56179 */     // GIR_Coverage, 60,
     /*  56179 */     GIR_EraseRootFromParent_Done,
     /*  56180 */   // Label 495: @56180
     /*  56180 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(56238), // Rule ID 62 //
     /*  56185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  56192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  56210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  56214 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13755),
     /*  56218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56220 */     // (xor:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_or_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_13755>>  =>  (S_NOR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  56220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOR_B32),
     /*  56223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  56225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  56233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  56236 */     GIR_RootConstrainSelectedInstOperands,
     /*  56237 */     // GIR_Coverage, 62,
     /*  56237 */     GIR_EraseRootFromParent_Done,
     /*  56238 */   // Label 496: @56238
     /*  56238 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(56296), // Rule ID 58 //
     /*  56243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  56250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56266 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  56268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  56272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13755),
     /*  56276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56278 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_xor_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_13755>>  =>  (S_XNOR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  56278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XNOR_B32),
     /*  56281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  56283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  56291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  56294 */     GIR_RootConstrainSelectedInstOperands,
     /*  56295 */     // GIR_Coverage, 58,
     /*  56295 */     GIR_EraseRootFromParent_Done,
     /*  56296 */   // Label 497: @56296
     /*  56296 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(56354), // Rule ID 2511 //
     /*  56301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  56304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56327 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  56329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  56333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19933),
     /*  56337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56339 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_xor_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_19933>>  =>  (V_XNOR_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
     /*  56339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  56342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  56352 */     GIR_RootConstrainSelectedInstOperands,
     /*  56353 */     // GIR_Coverage, 2511,
     /*  56353 */     GIR_EraseRootFromParent_Done,
     /*  56354 */   // Label 498: @56354
     /*  56354 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(56410), // Rule ID 2512 //
     /*  56359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  56362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56365 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  56367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56387 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19935),
     /*  56395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56397 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }), i32:{ *:[i32] }:$src1)<<P:Predicate_xor_oneuse>><<P:Predicate_anonymous_19935>>  =>  (V_XNOR_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
     /*  56397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  56400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56406 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  56408 */     GIR_RootConstrainSelectedInstOperands,
     /*  56409 */     // GIR_Coverage, 2512,
     /*  56409 */     GIR_EraseRootFromParent_Done,
     /*  56410 */   // Label 499: @56410
     /*  56410 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(56466), // Rule ID 8479 //
     /*  56415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  56418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56421 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  56423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56443 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56447 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19935),
     /*  56451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56453 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }))<<P:Predicate_xor_oneuse>><<P:Predicate_anonymous_19935>>  =>  (V_XNOR_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
     /*  56453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  56456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56462 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  56464 */     GIR_RootConstrainSelectedInstOperands,
     /*  56465 */     // GIR_Coverage, 8479,
     /*  56465 */     GIR_EraseRootFromParent_Done,
     /*  56466 */   // Label 500: @56466
     /*  56466 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(56597), // Rule ID 11171 //
     /*  56471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56475 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56491 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  56507 */     // MIs[0] z
     /*  56507 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  56512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  56516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56518 */     // (xor:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19698>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  56518 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  56521 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56525 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56530 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  56534 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56539 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  56542 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56546 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56551 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  56555 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  56563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  56576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  56584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  56592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  56595 */     GIR_RootConstrainSelectedInstOperands,
     /*  56596 */     // GIR_Coverage, 11171,
     /*  56596 */     GIR_EraseRootFromParent_Done,
     /*  56597 */   // Label 501: @56597
     /*  56597 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(56728), // Rule ID 11172 //
     /*  56602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56606 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56622 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  56638 */     // MIs[0] z
     /*  56638 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  56643 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  56647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56649 */     // (xor:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y), i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19698>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  56649 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  56652 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56656 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56661 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  56665 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56670 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  56673 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56677 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56682 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  56686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  56694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  56707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  56715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  56723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  56726 */     GIR_RootConstrainSelectedInstOperands,
     /*  56727 */     // GIR_Coverage, 11172,
     /*  56727 */     GIR_EraseRootFromParent_Done,
     /*  56728 */   // Label 502: @56728
     /*  56728 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(56859), // Rule ID 11169 //
     /*  56733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56737 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56753 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  56769 */     // MIs[0] z
     /*  56769 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  56774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  56778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56780 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z)), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19698>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  56780 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  56783 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56787 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56792 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  56796 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56801 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  56804 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56808 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56813 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  56817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  56825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56834 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  56838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  56846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  56854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  56857 */     GIR_RootConstrainSelectedInstOperands,
     /*  56858 */     // GIR_Coverage, 11169,
     /*  56858 */     GIR_EraseRootFromParent_Done,
     /*  56859 */   // Label 503: @56859
     /*  56859 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(56990), // Rule ID 11170 //
     /*  56864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56868 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56884 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  56900 */     // MIs[0] z
     /*  56900 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  56905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  56909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56911 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y)), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19698>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  56911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  56914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56923 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  56927 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  56935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56944 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  56948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  56956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56965 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  56969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  56977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  56985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  56988 */     GIR_RootConstrainSelectedInstOperands,
     /*  56989 */     // GIR_Coverage, 11170,
     /*  56989 */     GIR_EraseRootFromParent_Done,
     /*  56990 */   // Label 504: @56990
     /*  56990 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(57120), // Rule ID 11168 //
     /*  56995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57002 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57018 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  57030 */     // MIs[2] z
     /*  57030 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  57039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57041 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y), i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19698>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  57041 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  57044 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57048 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57053 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
     /*  57057 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  57065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57074 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  57078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  57086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  57099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  57107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  57115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57118 */     GIR_RootConstrainSelectedInstOperands,
     /*  57119 */     // GIR_Coverage, 11168,
     /*  57119 */     GIR_EraseRootFromParent_Done,
     /*  57120 */   // Label 505: @57120
     /*  57120 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(57250), // Rule ID 11167 //
     /*  57125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57132 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57148 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57160 */     // MIs[2] z
     /*  57160 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57165 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  57169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57171 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19698>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  57171 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  57174 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57178 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57183 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
     /*  57187 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57192 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  57195 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57199 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57204 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  57208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  57216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  57229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  57237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  57245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57248 */     GIR_RootConstrainSelectedInstOperands,
     /*  57249 */     // GIR_Coverage, 11167,
     /*  57249 */     GIR_EraseRootFromParent_Done,
     /*  57250 */   // Label 506: @57250
     /*  57250 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(57380), // Rule ID 11166 //
     /*  57255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57262 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57278 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  57290 */     // MIs[2] z
     /*  57290 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57295 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  57299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57301 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y)))<<P:Predicate_anonymous_19698>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  57301 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  57304 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57308 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57313 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
     /*  57317 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57322 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  57325 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57329 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57334 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  57338 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  57346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57355 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  57359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  57367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  57375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57378 */     GIR_RootConstrainSelectedInstOperands,
     /*  57379 */     // GIR_Coverage, 11166,
     /*  57379 */     GIR_EraseRootFromParent_Done,
     /*  57380 */   // Label 507: @57380
     /*  57380 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(57510), // Rule ID 7320 //
     /*  57385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57392 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57408 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57420 */     // MIs[2] z
     /*  57420 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  57429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57431 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z)))<<P:Predicate_anonymous_19698>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  57431 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  57434 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57438 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57443 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
     /*  57447 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57452 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  57455 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57459 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57464 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  57468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  57476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  57489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  57497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  57505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57508 */     GIR_RootConstrainSelectedInstOperands,
     /*  57509 */     // GIR_Coverage, 7320,
     /*  57509 */     GIR_EraseRootFromParent_Done,
     /*  57510 */   // Label 508: @57510
     /*  57510 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(57542), // Rule ID 0 //
     /*  57515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  57522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  57526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13755),
     /*  57530 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] })<<P:Predicate_anonymous_13755>>  =>  (S_NOT_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
     /*  57530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B32),
     /*  57533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  57535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  57537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  57540 */     GIR_RootConstrainSelectedInstOperands,
     /*  57541 */     // GIR_Coverage, 0,
     /*  57541 */     GIR_EraseRootFromParent_Done,
     /*  57542 */   // Label 509: @57542
     /*  57542 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(57571), // Rule ID 7421 //
     /*  57547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  57558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  57562 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] })<<P:Predicate_anonymous_19698>>  =>  (V_NOT_B32_e32:{ *:[i32] } ?:{ *:[i32] }:$src0)
     /*  57562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_NOT_B32_e32),
     /*  57565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57567 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  57569 */     GIR_RootConstrainSelectedInstOperands,
     /*  57570 */     // GIR_Coverage, 7421,
     /*  57570 */     GIR_EraseRootFromParent_Done,
     /*  57571 */   // Label 510: @57571
     /*  57571 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(57639), // Rule ID 2648 //
     /*  57576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /*  57579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  57604 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*  57608 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*  57612 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:16:z
     /*  57616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21254),
     /*  57620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57622 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:16:x, i32:{ *:[i32] }:$src1:$pred:16:y)<<P:Predicate_anonymous_20828>>, i32:{ *:[i32] }:$src2:$pred:16:z)<<P:16:Predicate_anonymous_21254>>  =>  (V_XOR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  57622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR3_B32_e64),
     /*  57625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  57635 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  57637 */     GIR_RootConstrainSelectedInstOperands,
     /*  57638 */     // GIR_Coverage, 2648,
     /*  57638 */     GIR_EraseRootFromParent_Done,
     /*  57639 */   // Label 511: @57639
     /*  57639 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(57707), // Rule ID 8504 //
     /*  57644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /*  57647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57654 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:16:z
     /*  57658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57674 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  57676 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*  57680 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*  57684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21254),
     /*  57688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57690 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:16:z, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:16:x, i32:{ *:[i32] }:$src1:$pred:16:y)<<P:Predicate_anonymous_20828>>)<<P:16:Predicate_anonymous_21254>>  =>  (V_XOR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  57690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR3_B32_e64),
     /*  57693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  57703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  57705 */     GIR_RootConstrainSelectedInstOperands,
     /*  57706 */     // GIR_Coverage, 8504,
     /*  57706 */     GIR_EraseRootFromParent_Done,
     /*  57707 */   // Label 512: @57707
     /*  57707 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(57736), // Rule ID 56 //
     /*  57712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  57719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13787),
     /*  57723 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13787>>  =>  (S_XOR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /*  57728 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  57734 */     GIR_RootConstrainSelectedInstOperands,
     /*  57735 */     // GIR_Coverage, 56,
     /*  57735 */     GIR_Done,
     /*  57736 */   // Label 513: @57736
     /*  57736 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(57786), // Rule ID 8436 //
     /*  57741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  57744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57767 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57773 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }), i32:{ *:[i32] }:$src1)  =>  (V_XNOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  57776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57782 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  57784 */     GIR_RootConstrainSelectedInstOperands,
     /*  57785 */     // GIR_Coverage, 8436,
     /*  57785 */     GIR_EraseRootFromParent_Done,
     /*  57786 */   // Label 514: @57786
     /*  57786 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(57838), // Rule ID 911 //
     /*  57791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  57794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57817 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  57821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57823 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), -1:{ *:[i32] })  =>  (V_XNOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  57826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  57836 */     GIR_RootConstrainSelectedInstOperands,
     /*  57837 */     // GIR_Coverage, 911,
     /*  57837 */     GIR_EraseRootFromParent_Done,
     /*  57838 */   // Label 515: @57838
     /*  57838 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(57888), // Rule ID 8437 //
     /*  57843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  57846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57869 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57875 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }))  =>  (V_XNOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  57878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57884 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  57886 */     GIR_RootConstrainSelectedInstOperands,
     /*  57887 */     // GIR_Coverage, 8437,
     /*  57887 */     GIR_EraseRootFromParent_Done,
     /*  57888 */   // Label 516: @57888
     /*  57888 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(57911), // Rule ID 816 //
     /*  57893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57900 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_XOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  57905 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  57909 */     GIR_RootConstrainSelectedInstOperands,
     /*  57910 */     // GIR_Coverage, 816,
     /*  57910 */     GIR_Done,
     /*  57911 */   // Label 517: @57911
     /*  57911 */   GIM_Reject,
     /*  57912 */ // Label 494: @57912
     /*  57912 */ GIM_Reject,
     /*  57913 */ // Label 483: @57913
     /*  57913 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(60545),
     /*  57918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  57921 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(57979), // Rule ID 61 //
     /*  57926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  57933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  57945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  57949 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  57951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  57955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13755),
     /*  57959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57961 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_and_oneuse>>, -1:{ *:[i64] })<<P:Predicate_anonymous_13755>>  =>  (S_NAND_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  57961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NAND_B64),
     /*  57964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  57966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  57974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  57977 */     GIR_RootConstrainSelectedInstOperands,
     /*  57978 */     // GIR_Coverage, 61,
     /*  57978 */     GIR_EraseRootFromParent_Done,
     /*  57979 */   // Label 519: @57979
     /*  57979 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(58037), // Rule ID 63 //
     /*  57984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  57991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58007 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  58009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  58013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13755),
     /*  58017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58019 */     // (xor:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_or_oneuse>>, -1:{ *:[i64] })<<P:Predicate_anonymous_13755>>  =>  (S_NOR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  58019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOR_B64),
     /*  58022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  58024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  58028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  58032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  58035 */     GIR_RootConstrainSelectedInstOperands,
     /*  58036 */     // GIR_Coverage, 63,
     /*  58036 */     GIR_EraseRootFromParent_Done,
     /*  58037 */   // Label 520: @58037
     /*  58037 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(58095), // Rule ID 59 //
     /*  58042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  58049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  58067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  58071 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13755),
     /*  58075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58077 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_xor_oneuse>>, -1:{ *:[i64] })<<P:Predicate_anonymous_13755>>  =>  (S_XNOR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  58077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XNOR_B64),
     /*  58080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  58082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  58086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  58090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  58093 */     GIR_RootConstrainSelectedInstOperands,
     /*  58094 */     // GIR_Coverage, 59,
     /*  58094 */     GIR_EraseRootFromParent_Done,
     /*  58095 */   // Label 521: @58095
     /*  58095 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(58394), // Rule ID 11178 //
     /*  58100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58104 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58120 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58136 */     // MIs[0] z
     /*  58136 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  58141 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  58145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58147 */     // (xor:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19698>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  58147 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  58150 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58154 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58159 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  58165 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58170 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58175 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  58178 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58182 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58187 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  58193 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58198 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58203 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  58206 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58210 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58215 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  58221 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58226 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58231 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  58234 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58238 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58243 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  58246 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  58249 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  58252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  58254 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  58257 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58261 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58266 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  58272 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58277 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58282 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  58285 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58289 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58294 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  58300 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58305 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58310 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  58313 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58317 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58322 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  58328 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58333 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  58341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58350 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58353 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  58356 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  58359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  58364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58369 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  58372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  58375 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  58378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58393 */     // GIR_Coverage, 11178,
     /*  58393 */     GIR_EraseRootFromParent_Done,
     /*  58394 */   // Label 522: @58394
     /*  58394 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(58693), // Rule ID 11179 //
     /*  58399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58403 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58419 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58435 */     // MIs[0] z
     /*  58435 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  58444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58446 */     // (xor:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y), i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19698>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  58446 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  58449 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58453 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58458 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  58464 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58469 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58474 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  58477 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58481 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58486 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  58492 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58497 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58502 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  58505 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58509 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58514 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  58520 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58525 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58530 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  58533 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58537 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58542 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  58545 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  58548 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  58551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  58553 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  58556 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58560 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58565 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  58571 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58576 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58581 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  58584 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58588 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58593 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  58599 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58604 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58609 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  58612 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58616 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58621 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  58627 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  58640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58649 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58652 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  58655 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  58658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  58663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58668 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  58671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  58674 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  58677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58692 */     // GIR_Coverage, 11179,
     /*  58692 */     GIR_EraseRootFromParent_Done,
     /*  58693 */   // Label 523: @58693
     /*  58693 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(58992), // Rule ID 11176 //
     /*  58698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58702 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58718 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58734 */     // MIs[0] z
     /*  58734 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  58739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  58743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58745 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z)), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19698>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  58745 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  58748 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58752 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58757 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  58763 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58768 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58773 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  58776 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58780 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58785 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  58791 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58796 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58801 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  58804 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58808 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58813 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  58819 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58824 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58829 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  58832 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58836 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58841 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  58844 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  58847 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  58850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  58852 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  58855 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58859 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58864 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  58870 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58875 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58880 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  58883 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58887 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58892 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  58898 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58903 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58908 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  58911 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58915 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58920 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  58926 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58931 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  58939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58948 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58951 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  58954 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  58957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  58962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58967 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  58970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  58973 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  58976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58991 */     // GIR_Coverage, 11176,
     /*  58991 */     GIR_EraseRootFromParent_Done,
     /*  58992 */   // Label 524: @58992
     /*  58992 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(59291), // Rule ID 11177 //
     /*  58997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59001 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59017 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59033 */     // MIs[0] z
     /*  59033 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  59038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  59042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59044 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y)), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19698>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  59044 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  59047 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59051 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59056 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  59062 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59067 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59072 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  59075 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59079 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59084 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  59090 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59095 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59100 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  59103 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59107 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59112 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  59118 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59123 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59128 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  59131 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59135 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59140 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  59143 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  59146 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  59149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  59151 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  59154 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59158 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59163 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  59169 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59174 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59179 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  59182 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59186 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59191 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  59197 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59202 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59207 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  59210 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59214 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59219 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  59225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59230 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  59238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59247 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  59250 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  59253 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  59256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  59261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59266 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  59269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  59272 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  59275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59290 */     // GIR_Coverage, 11177,
     /*  59290 */     GIR_EraseRootFromParent_Done,
     /*  59291 */   // Label 525: @59291
     /*  59291 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(59589), // Rule ID 11175 //
     /*  59296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  59299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59303 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59319 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59331 */     // MIs[2] z
     /*  59331 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  59336 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  59340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59342 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y), i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19698>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  59342 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  59345 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59349 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59354 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  59360 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59365 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59370 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  59373 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59377 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59382 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  59388 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59393 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59398 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  59401 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59405 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59410 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  59416 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59421 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59426 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  59429 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59433 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59438 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  59441 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  59444 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  59447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  59449 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  59452 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59456 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59461 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  59467 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59472 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59477 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  59480 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59484 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59489 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  59495 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59500 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59505 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  59508 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59512 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59517 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  59523 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59528 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  59536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59545 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  59548 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  59551 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  59554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  59559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59564 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  59567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  59570 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  59573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59588 */     // GIR_Coverage, 11175,
     /*  59588 */     GIR_EraseRootFromParent_Done,
     /*  59589 */   // Label 526: @59589
     /*  59589 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(59887), // Rule ID 11174 //
     /*  59594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  59597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59601 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59617 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59629 */     // MIs[2] z
     /*  59629 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  59634 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  59638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59640 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19698>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  59640 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  59643 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59647 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59652 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  59658 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59663 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59668 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  59671 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59675 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59680 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  59686 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59691 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59696 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  59699 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59703 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59708 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  59714 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59719 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59724 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  59727 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59731 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59736 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  59739 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  59742 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  59745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  59747 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  59750 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59754 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59759 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  59765 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59770 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59775 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  59778 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59782 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59787 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  59793 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59798 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59803 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  59806 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59810 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59815 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  59821 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59826 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  59834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59843 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  59846 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  59849 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  59852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  59857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59862 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  59865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  59868 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  59871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59886 */     // GIR_Coverage, 11174,
     /*  59886 */     GIR_EraseRootFromParent_Done,
     /*  59887 */   // Label 527: @59887
     /*  59887 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(60185), // Rule ID 11173 //
     /*  59892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  59895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59899 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59915 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59927 */     // MIs[2] z
     /*  59927 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  59932 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  59936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59938 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y)))<<P:Predicate_anonymous_19698>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  59938 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  59941 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59945 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59950 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  59956 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59961 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59966 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  59969 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59973 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59978 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  59984 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59989 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59994 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  59997 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60001 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60006 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  60012 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60017 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60022 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  60025 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  60029 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60034 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  60037 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  60040 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  60043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  60045 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  60048 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60052 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60057 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  60063 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60068 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60073 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  60076 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60080 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60085 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  60091 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60096 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60113 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  60119 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60124 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  60132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  60136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60141 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60144 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  60147 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  60150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  60155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60160 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  60163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  60166 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  60169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60184 */     // GIR_Coverage, 11173,
     /*  60184 */     GIR_EraseRootFromParent_Done,
     /*  60185 */   // Label 528: @60185
     /*  60185 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(60483), // Rule ID 7321 //
     /*  60190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  60193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60197 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60213 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60225 */     // MIs[2] z
     /*  60225 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  60230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19698),
     /*  60234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60236 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z)))<<P:Predicate_anonymous_19698>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  60236 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  60239 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60243 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60248 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  60254 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60259 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60264 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  60267 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60271 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60276 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  60282 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60287 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60292 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  60295 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60299 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60304 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  60310 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60315 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60320 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  60323 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  60327 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60332 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  60335 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  60338 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  60341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  60343 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  60346 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60350 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60355 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  60361 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60366 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60371 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  60374 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60378 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60383 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  60389 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60394 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60411 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  60417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60422 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  60430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  60434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60439 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60442 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  60445 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  60448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  60453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60458 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  60461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  60464 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  60467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60482 */     // GIR_Coverage, 7321,
     /*  60482 */     GIR_EraseRootFromParent_Done,
     /*  60483 */   // Label 529: @60483
     /*  60483 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(60515), // Rule ID 1 //
     /*  60488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  60491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  60495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  60499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13755),
     /*  60503 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$src0, -1:{ *:[i64] })<<P:Predicate_anonymous_13755>>  =>  (S_NOT_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0)
     /*  60503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B64),
     /*  60506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  60508 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  60510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  60513 */     GIR_RootConstrainSelectedInstOperands,
     /*  60514 */     // GIR_Coverage, 1,
     /*  60514 */     GIR_EraseRootFromParent_Done,
     /*  60515 */   // Label 530: @60515
     /*  60515 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(60544), // Rule ID 57 //
     /*  60520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  60523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  60527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13787),
     /*  60531 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13787>>  =>  (S_XOR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  60531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
     /*  60536 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  60542 */     GIR_RootConstrainSelectedInstOperands,
     /*  60543 */     // GIR_Coverage, 57,
     /*  60543 */     GIR_Done,
     /*  60544 */   // Label 531: @60544
     /*  60544 */   GIM_Reject,
     /*  60545 */ // Label 518: @60545
     /*  60545 */ GIM_Reject,
     /*  60546 */ // Label 484: @60546
     /*  60546 */ GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(60572), // Rule ID 2530 //
     /*  60551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  60554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  60557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60561 */   // (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1)  =>  (V_XOR_B32_e64:{ *:[v2i16] } VSrc_b32:{ *:[v2i16] }:$src0, VSrc_b32:{ *:[v2i16] }:$src1)
     /*  60561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  60566 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  60570 */   GIR_RootConstrainSelectedInstOperands,
     /*  60571 */   // GIR_Coverage, 2530,
     /*  60571 */   GIR_Done,
     /*  60572 */ // Label 532: @60572
     /*  60572 */ GIM_Reject,
     /*  60573 */ // Label 485: @60573
     /*  60573 */ GIM_Reject,
     /*  60574 */ // Label 6: @60574
     /*  60574 */ GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(60603), // Rule ID 7273 //
     /*  60579 */   // MIs[0] DstI[vdst]
     /*  60579 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /*  60583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60587 */   // MIs[0] Operand 1
     /*  60587 */   // No operand predicates
     /*  60587 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34607),
     /*  60591 */   // (frameindex:{ *:[i32] })<<P:Predicate_anonymous_34607>>:$fi  =>  (V_MOV_B32_e32:{ *:[i32] } (frameindex_to_targetframeindex:{ *:[i32] } ?:{ *:[i32] }:$fi))
     /*  60591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /*  60594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  60596 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  60601 */   GIR_RootConstrainSelectedInstOperands,
     /*  60602 */   // GIR_Coverage, 7273,
     /*  60602 */   GIR_EraseRootFromParent_Done,
     /*  60603 */ // Label 533: @60603
     /*  60603 */ GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(60628), // Rule ID 7274 //
     /*  60608 */   // MIs[0] DstI[sdst]
     /*  60608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /*  60612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  60616 */   // MIs[0] Operand 1
     /*  60616 */   // No operand predicates
     /*  60616 */   // (frameindex:{ *:[i32] }):$fi  =>  (S_MOV_B32:{ *:[i32] } (frameindex_to_targetframeindex:{ *:[i32] } ?:{ *:[i32] }:$fi))
     /*  60616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  60619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  60621 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  60626 */   GIR_RootConstrainSelectedInstOperands,
     /*  60627 */   // GIR_Coverage, 7274,
     /*  60627 */   GIR_EraseRootFromParent_Done,
     /*  60628 */ // Label 534: @60628
     /*  60628 */ GIM_Reject,
     /*  60629 */ // Label 7: @60629
     /*  60629 */ GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(65654),
     /*  60634 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  60637 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /*  60640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  60643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60646 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(62612),
     /*  60651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60655 */     GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(60778), // Rule ID 2740 //
     /*  60660 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_NotHasTrue16BitInsts),
     /*  60663 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60667 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  60671 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  60675 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60679 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  60683 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60687 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60691 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  60695 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  60699 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  60703 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  60707 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  60709 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60716 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60723 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60730 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  60730 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  60733 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  60735 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  60740 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  60745 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  60750 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  60755 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  60760 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  60765 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60768 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  60770 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60773 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60776 */       GIR_RootConstrainSelectedInstOperands,
     /*  60777 */       // GIR_Coverage, 2740,
     /*  60777 */       GIR_EraseRootFromParent_Done,
     /*  60778 */     // Label 537: @60778
     /*  60778 */     GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(60901), // Rule ID 2742 //
     /*  60783 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseFakeTrue16Insts),
     /*  60786 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60790 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  60794 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  60798 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60802 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  60806 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60810 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60814 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  60818 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  60822 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  60826 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  60830 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  60832 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60839 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60846 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60853 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  60853 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  60856 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  60858 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  60863 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  60868 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  60873 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  60878 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  60883 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  60888 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60891 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  60893 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60896 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60899 */       GIR_RootConstrainSelectedInstOperands,
     /*  60900 */       // GIR_Coverage, 2742,
     /*  60900 */       GIR_EraseRootFromParent_Done,
     /*  60901 */     // Label 538: @60901
     /*  60901 */     GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(61079), // Rule ID 2745 //
     /*  60906 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseRealTrue16Insts),
     /*  60909 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60913 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  60917 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  60921 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60925 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  60929 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60933 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60937 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  60941 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  60945 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  60949 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  60953 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  60955 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60962 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60969 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60976 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, ?:{ *:[f16] }:$elt0, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), hi16:{ *:[i32] }))
     /*  60976 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  60979 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  60983 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60988 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  60990 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  60993 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  60997 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61002 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // elt0
     /*  61006 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  61009 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61012 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  61015 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  61020 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61025 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61030 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  61033 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61035 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61040 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61045 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61050 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61055 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61060 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61065 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61068 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61071 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61074 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61077 */       GIR_RootConstrainSelectedInstOperands,
     /*  61078 */       // GIR_Coverage, 2745,
     /*  61078 */       GIR_EraseRootFromParent_Done,
     /*  61079 */     // Label 539: @61079
     /*  61079 */     GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(61202), // Rule ID 2724 //
     /*  61084 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_NotHasTrue16BitInsts),
     /*  61087 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61091 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  61095 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  61099 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61103 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61107 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61111 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61115 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  61119 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  61123 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  61127 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  61131 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61133 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61140 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61147 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61154 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  61154 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  61157 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61159 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61164 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61169 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61174 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61179 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61184 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61189 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61192 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  61194 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61197 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61200 */       GIR_RootConstrainSelectedInstOperands,
     /*  61201 */       // GIR_Coverage, 2724,
     /*  61201 */       GIR_EraseRootFromParent_Done,
     /*  61202 */     // Label 540: @61202
     /*  61202 */     GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(61380), // Rule ID 2727 //
     /*  61207 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseRealTrue16Insts),
     /*  61210 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61214 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  61218 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  61222 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61226 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61230 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61234 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61238 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  61242 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  61246 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  61250 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  61254 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61256 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61263 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61270 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61277 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, ?:{ *:[f16] }:$elt0, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), hi16:{ *:[i32] }))
     /*  61277 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  61280 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61284 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61289 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  61291 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  61294 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  61298 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61303 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // elt0
     /*  61307 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  61310 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61313 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  61316 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  61321 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61326 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61331 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  61334 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61336 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61341 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61346 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61351 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61356 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61361 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61366 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61369 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61372 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61375 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61378 */       GIR_RootConstrainSelectedInstOperands,
     /*  61379 */       // GIR_Coverage, 2727,
     /*  61379 */       GIR_EraseRootFromParent_Done,
     /*  61380 */     // Label 541: @61380
     /*  61380 */     GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(61503), // Rule ID 2731 //
     /*  61385 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseFakeTrue16Insts),
     /*  61388 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61392 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  61396 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  61400 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61404 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61408 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61412 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61416 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  61420 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  61424 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  61428 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  61432 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61434 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61441 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61448 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61455 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  61455 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  61458 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61460 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61465 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61470 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61475 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61480 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61485 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61490 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61493 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  61495 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61498 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61501 */       GIR_RootConstrainSelectedInstOperands,
     /*  61502 */       // GIR_Coverage, 2731,
     /*  61502 */       GIR_EraseRootFromParent_Done,
     /*  61503 */     // Label 542: @61503
     /*  61503 */     GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(61669), // Rule ID 2743 //
     /*  61508 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseRealTrue16Insts),
     /*  61511 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61515 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61519 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61523 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61527 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  61531 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61535 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  61539 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  61543 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61545 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61552 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61559 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61566 */       // (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))), f16:{ *:[f16] }:$elt1)  =>  (V_FMA_MIXLO_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), lo16:{ *:[i32] }, ?:{ *:[f16] }:$elt1, hi16:{ *:[i32] }))
     /*  61566 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  61569 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61573 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61578 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  61580 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  61583 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  61587 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61592 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61595 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  61598 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // elt1
     /*  61602 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  61605 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  61610 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61615 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61620 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
     /*  61623 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61625 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61630 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61635 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61640 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61645 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61650 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61655 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61658 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61661 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61664 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61667 */       GIR_RootConstrainSelectedInstOperands,
     /*  61668 */       // GIR_Coverage, 2743,
     /*  61668 */       GIR_EraseRootFromParent_Done,
     /*  61669 */     // Label 543: @61669
     /*  61669 */     GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(61835), // Rule ID 2725 //
     /*  61674 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseRealTrue16Insts),
     /*  61677 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61681 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61685 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61689 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61693 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  61697 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61701 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  61705 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  61709 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61711 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61718 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61725 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61732 */       // (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))), f16:{ *:[f16] }:$elt1)  =>  (V_MAD_MIXLO_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), lo16:{ *:[i32] }, ?:{ *:[f16] }:$elt1, hi16:{ *:[i32] }))
     /*  61732 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  61735 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61739 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61744 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  61746 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  61749 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  61753 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61758 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61761 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  61764 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // elt1
     /*  61768 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  61771 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  61776 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61781 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61786 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
     /*  61789 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61791 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61796 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61801 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61806 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61811 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61816 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61821 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61824 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61827 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61830 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61833 */       GIR_RootConstrainSelectedInstOperands,
     /*  61834 */       // GIR_Coverage, 2725,
     /*  61834 */       GIR_EraseRootFromParent_Done,
     /*  61835 */     // Label 544: @61835
     /*  61835 */     GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(61946), // Rule ID 2739 //
     /*  61840 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_NotHasTrue16BitInsts),
     /*  61843 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61847 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61851 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61855 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61859 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  61863 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61867 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  61871 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  61875 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61877 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61884 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61891 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61898 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  61898 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  61901 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61903 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61908 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61913 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61918 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61923 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61928 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61933 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61936 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  61938 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61941 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61944 */       GIR_RootConstrainSelectedInstOperands,
     /*  61945 */       // GIR_Coverage, 2739,
     /*  61945 */       GIR_EraseRootFromParent_Done,
     /*  61946 */     // Label 545: @61946
     /*  61946 */     GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(62057), // Rule ID 2741 //
     /*  61951 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseFakeTrue16Insts),
     /*  61954 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61958 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61962 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61966 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61970 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  61974 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61978 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  61982 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  61986 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61988 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61995 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62002 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62009 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  62009 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  62012 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62014 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62019 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62024 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62029 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62034 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62039 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62044 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62047 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  62049 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62052 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62055 */       GIR_RootConstrainSelectedInstOperands,
     /*  62056 */       // GIR_Coverage, 2741,
     /*  62056 */       GIR_EraseRootFromParent_Done,
     /*  62057 */     // Label 546: @62057
     /*  62057 */     GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(62223), // Rule ID 2744 //
     /*  62062 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseRealTrue16Insts),
     /*  62065 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62069 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  62073 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62077 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62081 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  62085 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62089 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62093 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  62097 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62099 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62106 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62113 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62120 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, ?:{ *:[f16] }:$elt0, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), hi16:{ *:[i32] }))
     /*  62120 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  62123 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62127 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62132 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  62134 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  62137 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  62141 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62146 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // elt0
     /*  62150 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  62153 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  62156 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  62159 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62164 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  62169 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  62174 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  62177 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62179 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62184 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62189 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62194 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62199 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62204 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62209 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62212 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62215 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62218 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62221 */       GIR_RootConstrainSelectedInstOperands,
     /*  62222 */       // GIR_Coverage, 2744,
     /*  62222 */       GIR_EraseRootFromParent_Done,
     /*  62223 */     // Label 547: @62223
     /*  62223 */     GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(62334), // Rule ID 2723 //
     /*  62228 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_NotHasTrue16BitInsts),
     /*  62231 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62235 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  62239 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62243 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62247 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  62251 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62255 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62259 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  62263 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62265 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62272 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62279 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62286 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  62286 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  62289 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62291 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62296 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62301 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62306 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62311 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62316 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62321 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62324 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  62326 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62329 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62332 */       GIR_RootConstrainSelectedInstOperands,
     /*  62333 */       // GIR_Coverage, 2723,
     /*  62333 */       GIR_EraseRootFromParent_Done,
     /*  62334 */     // Label 548: @62334
     /*  62334 */     GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(62500), // Rule ID 2726 //
     /*  62339 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseRealTrue16Insts),
     /*  62342 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62346 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  62350 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62354 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62358 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  62362 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62366 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62370 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  62374 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62376 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62383 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62390 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62397 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, ?:{ *:[f16] }:$elt0, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), hi16:{ *:[i32] }))
     /*  62397 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  62400 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62404 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62409 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  62411 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  62414 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  62418 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62423 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // elt0
     /*  62427 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  62430 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  62433 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  62436 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62441 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  62446 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  62451 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  62454 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62456 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62461 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62466 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62471 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62476 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62481 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62486 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62489 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62492 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62495 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62498 */       GIR_RootConstrainSelectedInstOperands,
     /*  62499 */       // GIR_Coverage, 2726,
     /*  62499 */       GIR_EraseRootFromParent_Done,
     /*  62500 */     // Label 549: @62500
     /*  62500 */     GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(62611), // Rule ID 2730 //
     /*  62505 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseFakeTrue16Insts),
     /*  62508 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62512 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  62516 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62520 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62524 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  62528 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62532 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62536 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  62540 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62542 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62549 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62556 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62563 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  62563 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  62566 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62568 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62573 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62578 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62583 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62588 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62593 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62598 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62601 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  62603 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62606 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62609 */       GIR_RootConstrainSelectedInstOperands,
     /*  62610 */       // GIR_Coverage, 2730,
     /*  62610 */       GIR_EraseRootFromParent_Done,
     /*  62611 */     // Label 550: @62611
     /*  62611 */     GIM_Reject,
     /*  62612 */   // Label 536: @62612
     /*  62612 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(62926),
     /*  62617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34886),
     /*  62621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62625 */     GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(62775), // Rule ID 7536 //
     /*  62630 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  62633 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62637 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  62641 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  62645 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62649 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62653 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62657 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62661 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62665 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  62669 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  62673 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62678 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  62682 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62686 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  62690 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s16,
     /*  62694 */       GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  62698 */       GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62702 */       GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  62706 */       GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  62710 */       GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62714 */       GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  62718 */       GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  62722 */       GIM_CheckRegBankForClass, /*MI*/6, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62727 */       GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  62731 */       GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  62733 */       // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] }))))<<P:Predicate_anonymous_34886>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
     /*  62733 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  62736 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  62740 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62745 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
     /*  62755 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62757 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  62760 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62762 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // b
     /*  62766 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
     /*  62770 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62773 */       GIR_RootConstrainSelectedInstOperands,
     /*  62774 */       // GIR_Coverage, 7536,
     /*  62774 */       GIR_EraseRootFromParent_Done,
     /*  62775 */     // Label 552: @62775
     /*  62775 */     GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(62925), // Rule ID 7537 //
     /*  62780 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  62783 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62787 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  62791 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  62795 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62799 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62803 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62807 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62811 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62815 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  62819 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  62823 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62828 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  62832 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62836 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  62840 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s16,
     /*  62844 */       GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  62848 */       GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62852 */       GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  62856 */       GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  62860 */       GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62864 */       GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  62868 */       GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  62872 */       GIM_CheckRegBankForClass, /*MI*/6, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62877 */       GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  62881 */       GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  62883 */       // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] }))))<<P:Predicate_anonymous_34886>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
     /*  62883 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  62886 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  62890 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62895 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
     /*  62905 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62907 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  62910 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62912 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // b
     /*  62916 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
     /*  62920 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62923 */       GIR_RootConstrainSelectedInstOperands,
     /*  62924 */       // GIR_Coverage, 7537,
     /*  62924 */       GIR_EraseRootFromParent_Done,
     /*  62925 */     // Label 553: @62925
     /*  62925 */     GIM_Reject,
     /*  62926 */   // Label 551: @62926
     /*  62926 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(63037), // Rule ID 7517 //
     /*  62931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  62934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  62938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62966 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  62968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  62973 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  62977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  62981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62985 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  62989 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  62993 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62997 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  63001 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  63005 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  63007 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  63012 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  63016 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34884),
     /*  63020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63022 */     // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src0, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>), (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src1, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>))<<P:Predicate_anonymous_34884>>  =>  (S_PACK_HH_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i32] }:$src0, SReg_32:{ *:[i32] }:$src1)
     /*  63022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_HH_B32_B16),
     /*  63025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  63027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  63031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  63035 */     GIR_RootConstrainSelectedInstOperands,
     /*  63036 */     // GIR_Coverage, 7517,
     /*  63036 */     GIR_EraseRootFromParent_Done,
     /*  63037 */   // Label 554: @63037
     /*  63037 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(63216),
     /*  63042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34946),
     /*  63046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63050 */     GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(63105), // Rule ID 7538 //
     /*  63055 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /*  63058 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63065 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63072 */       // (build_vector:{ *:[v2f16] } (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_anonymous_34946>>  =>  (V_PACK_B32_F16_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, VGPR_32:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, VGPR_32:{ *:[f16] }:$src1)
     /*  63072 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PACK_B32_F16_e64),
     /*  63075 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63077 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /*  63082 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63087 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /*  63092 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63097 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63100 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63103 */       GIR_RootConstrainSelectedInstOperands,
     /*  63104 */       // GIR_Coverage, 7538,
     /*  63104 */       GIR_EraseRootFromParent_Done,
     /*  63105 */     // Label 556: @63105
     /*  63105 */     GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(63160), // Rule ID 7539 //
     /*  63110 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /*  63113 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63120 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63127 */       // (build_vector:{ *:[v2f16] } (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_anonymous_34946>>  =>  (V_PACK_B32_F16_t16_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, VGPR_32:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, VGPR_32:{ *:[f16] }:$src1)
     /*  63127 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PACK_B32_F16_t16_e64),
     /*  63130 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63132 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /*  63137 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63142 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /*  63147 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63152 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63155 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63158 */       GIR_RootConstrainSelectedInstOperands,
     /*  63159 */       // GIR_Coverage, 7539,
     /*  63159 */       GIR_EraseRootFromParent_Done,
     /*  63160 */     // Label 557: @63160
     /*  63160 */     GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(63215), // Rule ID 7540 //
     /*  63165 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /*  63168 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63175 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63182 */       // (build_vector:{ *:[v2f16] } (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_anonymous_34946>>  =>  (V_PACK_B32_F16_fake16_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, VGPR_32:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, VGPR_32:{ *:[f16] }:$src1)
     /*  63182 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PACK_B32_F16_fake16_e64),
     /*  63185 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63187 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /*  63192 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63197 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /*  63202 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63207 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63210 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63213 */       GIR_RootConstrainSelectedInstOperands,
     /*  63214 */       // GIR_Coverage, 7540,
     /*  63214 */       GIR_EraseRootFromParent_Done,
     /*  63215 */     // Label 558: @63215
     /*  63215 */     GIM_Reject,
     /*  63216 */   // Label 555: @63216
     /*  63216 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(63499),
     /*  63221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63225 */     GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(63306), // Rule ID 2623 //
     /*  63230 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtPkF16F32Inst),
     /*  63233 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63237 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  63241 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63245 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63249 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  63253 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63257 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63259 */       GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63266 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63273 */       // (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers)), (fpround:{ *:[f16] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_CVT_PK_F16_F32_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1)
     /*  63273 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F16_F32_e64),
     /*  63276 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63278 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  63283 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63288 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  63293 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63298 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63301 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63304 */       GIR_RootConstrainSelectedInstOperands,
     /*  63305 */       // GIR_Coverage, 2623,
     /*  63305 */       GIR_EraseRootFromParent_Done,
     /*  63306 */     // Label 560: @63306
     /*  63306 */     GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(63402), // Rule ID 2721 //
     /*  63311 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /*  63314 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63318 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  63322 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63326 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63330 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /*  63334 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63338 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  63342 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63344 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  63351 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  63358 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  63358 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  63361 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63363 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  63368 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63373 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  63378 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63383 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63386 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63389 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63392 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  63394 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63397 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63400 */       GIR_RootConstrainSelectedInstOperands,
     /*  63401 */       // GIR_Coverage, 2721,
     /*  63401 */       GIR_EraseRootFromParent_Done,
     /*  63402 */     // Label 561: @63402
     /*  63402 */     GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(63498), // Rule ID 2737 //
     /*  63407 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /*  63410 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63414 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  63418 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63422 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63426 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /*  63430 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63434 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  63438 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63440 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  63447 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  63454 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  63454 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  63457 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63459 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  63464 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63469 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  63474 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63479 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63482 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63485 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63488 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  63490 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63493 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63496 */       GIR_RootConstrainSelectedInstOperands,
     /*  63497 */       // GIR_Coverage, 2737,
     /*  63497 */       GIR_EraseRootFromParent_Done,
     /*  63498 */     // Label 562: @63498
     /*  63498 */     GIM_Reject,
     /*  63499 */   // Label 559: @63499
     /*  63499 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(64041),
     /*  63504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34886),
     /*  63508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63512 */     GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(63638), // Rule ID 7525 //
     /*  63517 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  63520 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63524 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63528 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63532 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63536 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63540 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63544 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  63548 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63553 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  63557 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63561 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63565 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63569 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63573 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63577 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  63581 */       GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  63585 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63590 */       GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  63594 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63596 */       // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] })))<<P:Predicate_anonymous_34886>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
     /*  63596 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  63599 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  63603 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63608 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
     /*  63618 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  63620 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  63623 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63625 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // b
     /*  63629 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
     /*  63633 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63636 */       GIR_RootConstrainSelectedInstOperands,
     /*  63637 */       // GIR_Coverage, 7525,
     /*  63637 */       GIR_EraseRootFromParent_Done,
     /*  63638 */     // Label 564: @63638
     /*  63638 */     GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(63764), // Rule ID 7527 //
     /*  63643 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  63646 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63650 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63654 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63658 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63662 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63666 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63670 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  63674 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63679 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  63683 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63687 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63691 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63695 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63699 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63703 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  63707 */       GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  63711 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63716 */       GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  63720 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63722 */       // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] })))<<P:Predicate_anonymous_34886>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
     /*  63722 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  63725 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  63729 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63734 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
     /*  63744 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  63746 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  63749 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63751 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // b
     /*  63755 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
     /*  63759 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63762 */       GIR_RootConstrainSelectedInstOperands,
     /*  63763 */       // GIR_Coverage, 7527,
     /*  63763 */       GIR_EraseRootFromParent_Done,
     /*  63764 */     // Label 565: @63764
     /*  63764 */     GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(63843), // Rule ID 7534 //
     /*  63769 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  63772 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63776 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  63780 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  63784 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63788 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63792 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63796 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63800 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63804 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63808 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  63812 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63817 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  63821 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63825 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  63827 */       // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34886>>  =>  (V_ALIGNBIT_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$b, VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })
     /*  63827 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /*  63830 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63832 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  63834 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
     /*  63838 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  63841 */       GIR_RootConstrainSelectedInstOperands,
     /*  63842 */       // GIR_Coverage, 7534,
     /*  63842 */       GIR_EraseRootFromParent_Done,
     /*  63843 */     // Label 566: @63843
     /*  63843 */     GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(63937), // Rule ID 7535 //
     /*  63848 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  63851 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63855 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  63859 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  63863 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63867 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63871 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63875 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63879 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63883 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63887 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  63891 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63896 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  63900 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63904 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  63906 */       // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34886>>  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[v2f16] } 0:{ *:[i32] }, VGPR_32:{ *:[f16] }:$b, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$a, 0:{ *:[i32] }, 16:{ *:[i16] }, 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  63906 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /*  63909 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63911 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63914 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  63916 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63919 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
     /*  63923 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63926 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  63929 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63932 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63935 */       GIR_RootConstrainSelectedInstOperands,
     /*  63936 */       // GIR_Coverage, 7535,
     /*  63936 */       GIR_EraseRootFromParent_Done,
     /*  63937 */     // Label 567: @63937
     /*  63937 */     GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(64040), // Rule ID 7533 //
     /*  63942 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  63945 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63949 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63953 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  63957 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  63961 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63965 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63969 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63973 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63977 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63981 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63985 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  63989 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63994 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  63998 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  64000 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$a, (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] }))))<<P:Predicate_anonymous_34886>>  =>  (V_BFI_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), VGPR_32:{ *:[f16] }:$a, VGPR_32:{ *:[i32] }:$b)
     /*  64000 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  64003 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  64007 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64012 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /*  64022 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  64024 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  64027 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64029 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64032 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  64034 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // b
     /*  64038 */       GIR_RootConstrainSelectedInstOperands,
     /*  64039 */       // GIR_Coverage, 7533,
     /*  64039 */       GIR_EraseRootFromParent_Done,
     /*  64040 */     // Label 568: @64040
     /*  64040 */     GIM_Reject,
     /*  64041 */   // Label 563: @64041
     /*  64041 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(64115), // Rule ID 7516 //
     /*  64046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  64049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64085 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  64087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64092 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64096 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34884),
     /*  64100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64102 */     // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src1, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>))<<P:Predicate_anonymous_34884>>  =>  (S_PACK_LH_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i32] }:$src1)
     /*  64102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_LH_B32_B16),
     /*  64105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64107 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  64109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  64113 */     GIR_RootConstrainSelectedInstOperands,
     /*  64114 */     // GIR_Coverage, 7516,
     /*  64114 */     GIR_EraseRootFromParent_Done,
     /*  64115 */   // Label 569: @64115
     /*  64115 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(64274),
     /*  64120 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34886),
     /*  64124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64132 */     GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(64195), // Rule ID 7523 //
     /*  64137 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  64140 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64144 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64148 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64152 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64156 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64160 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64164 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64168 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64173 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64177 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64179 */       // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34886>>  =>  (V_ALIGNBIT_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$b, VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })
     /*  64179 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /*  64182 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64184 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  64186 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
     /*  64190 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64193 */       GIR_RootConstrainSelectedInstOperands,
     /*  64194 */       // GIR_Coverage, 7523,
     /*  64194 */       GIR_EraseRootFromParent_Done,
     /*  64195 */     // Label 571: @64195
     /*  64195 */     GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(64273), // Rule ID 7524 //
     /*  64200 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  64203 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64207 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64211 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64215 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64219 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64223 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64227 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64231 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64236 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64240 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64242 */       // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34886>>  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[v2i16] } 0:{ *:[i32] }, VGPR_32:{ *:[i16] }:$b, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$a, 0:{ *:[i32] }, 16:{ *:[i16] }, 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  64242 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /*  64245 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64247 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64250 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  64252 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64255 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
     /*  64259 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64262 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64265 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64268 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64271 */       GIR_RootConstrainSelectedInstOperands,
     /*  64272 */       // GIR_Coverage, 7524,
     /*  64272 */       GIR_EraseRootFromParent_Done,
     /*  64273 */     // Label 572: @64273
     /*  64273 */     GIM_Reject,
     /*  64274 */   // Label 570: @64274
     /*  64274 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(64344), // Rule ID 7541 //
     /*  64279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  64282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64314 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  64316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64321 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64331 */     // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src0, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>), SReg_32:{ *:[i16] }:$src1)  =>  (S_PACK_HL_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i32] }:$src0, SReg_32:{ *:[i16] }:$src1)
     /*  64331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_HL_B32_B16),
     /*  64334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  64340 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64342 */     GIR_RootConstrainSelectedInstOperands,
     /*  64343 */     // GIR_Coverage, 7541,
     /*  64343 */     GIR_EraseRootFromParent_Done,
     /*  64344 */   // Label 573: @64344
     /*  64344 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(64443), // Rule ID 7522 //
     /*  64349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  64352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64393 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34886),
     /*  64401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64403 */     // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$a, (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] })))<<P:Predicate_anonymous_34886>>  =>  (V_BFI_B32_e64:{ *:[v2i16] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), VGPR_32:{ *:[i16] }:$a, VGPR_32:{ *:[i32] }:$b)
     /*  64403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  64406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  64410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64415 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /*  64425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  64427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  64430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64435 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  64437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // b
     /*  64441 */     GIR_RootConstrainSelectedInstOperands,
     /*  64442 */     // GIR_Coverage, 7522,
     /*  64442 */     GIR_EraseRootFromParent_Done,
     /*  64443 */   // Label 574: @64443
     /*  64443 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(64479), // Rule ID 7496 //
     /*  64448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  64456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64460 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34884),
     /*  64464 */     // (build_vector:{ *:[v2i16] } 0:{ *:[i16] }, SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34884>>  =>  (S_LSHL_B32:{ *:[v2i16] }:{ *:[i1] } SReg_32:{ *:[i16] }:$src1, 16:{ *:[i16] })
     /*  64464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64469 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64477 */     GIR_RootConstrainSelectedInstOperands,
     /*  64478 */     // GIR_Coverage, 7496,
     /*  64478 */     GIR_EraseRootFromParent_Done,
     /*  64479 */   // Label 575: @64479
     /*  64479 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(64512), // Rule ID 7497 //
     /*  64484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  64492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34886),
     /*  64500 */     // (build_vector:{ *:[v2i16] } 0:{ *:[i16] }, VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34886>>  =>  (V_LSHLREV_B32_e64:{ *:[v2i16] } 16:{ *:[i16] }, VGPR_32:{ *:[i16] }:$src1)
     /*  64500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /*  64503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64510 */     GIR_RootConstrainSelectedInstOperands,
     /*  64511 */     // GIR_Coverage, 7497,
     /*  64511 */     GIR_EraseRootFromParent_Done,
     /*  64512 */   // Label 576: @64512
     /*  64512 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(64572), // Rule ID 7498 //
     /*  64517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34884),
     /*  64533 */     // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src1, 0:{ *:[i16] })<<P:Predicate_anonymous_34884>>  =>  (S_AND_B32:{ *:[v2i16] }:{ *:[i1] } (S_MOV_B32:{ *:[i1] } 65535:{ *:[i32] }), SReg_32:{ *:[i16] }:$src1)
     /*  64533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  64536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  64540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64545 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /*  64555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  64557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /*  64560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64565 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  64567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64570 */     GIR_RootConstrainSelectedInstOperands,
     /*  64571 */     // GIR_Coverage, 7498,
     /*  64571 */     GIR_EraseRootFromParent_Done,
     /*  64572 */   // Label 577: @64572
     /*  64572 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(64629), // Rule ID 7499 //
     /*  64577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34886),
     /*  64593 */     // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src1, 0:{ *:[i16] })<<P:Predicate_anonymous_34886>>  =>  (V_AND_B32_e64:{ *:[v2i16] } (V_MOV_B32_e32:{ *:[i32] } 65535:{ *:[i32] }), VGPR_32:{ *:[i16] }:$src1)
     /*  64593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  64596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /*  64600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64605 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /*  64615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  64617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  64620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64625 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  64627 */     GIR_RootConstrainSelectedInstOperands,
     /*  64628 */     // GIR_Coverage, 7499,
     /*  64628 */     GIR_EraseRootFromParent_Done,
     /*  64629 */   // Label 578: @64629
     /*  64629 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(64674), // Rule ID 7504 //
     /*  64634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  64637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64653 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34884),
     /*  64657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64659 */     // (build_vector:{ *:[v2i16] } (undef:{ *:[i16] }), SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34884>>  =>  (S_LSHL_B32:{ *:[v2i16] }:{ *:[i1] } SReg_32:{ *:[i16] }:$src1, 16:{ *:[i32] })
     /*  64659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64664 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64672 */     GIR_RootConstrainSelectedInstOperands,
     /*  64673 */     // GIR_Coverage, 7504,
     /*  64673 */     GIR_EraseRootFromParent_Done,
     /*  64674 */   // Label 579: @64674
     /*  64674 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(64713), // Rule ID 7505 //
     /*  64679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34886),
     /*  64699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64701 */     // (build_vector:{ *:[v2i16] } (undef:{ *:[i16] }), VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34886>>  =>  (V_LSHLREV_B32_e64:{ *:[v2i16] } 16:{ *:[i32] }, VGPR_32:{ *:[i16] }:$src1)
     /*  64701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /*  64704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64709 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64711 */     GIR_RootConstrainSelectedInstOperands,
     /*  64712 */     // GIR_Coverage, 7505,
     /*  64712 */     GIR_EraseRootFromParent_Done,
     /*  64713 */   // Label 580: @64713
     /*  64713 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(64830),
     /*  64718 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34884),
     /*  64722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64730 */     GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(64763), // Rule ID 7507 //
     /*  64735 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  64738 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64742 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64746 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64748 */       // (build_vector:{ *:[v2i16] } (undef:{ *:[i16] }), SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34884>>  =>  (S_LSHL_B32:{ *:[v2i16] }:{ *:[i1] } SReg_32:{ *:[i16] }:$src1, 16:{ *:[i32] })
     /*  64748 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64751 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64753 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64755 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64758 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64761 */       GIR_RootConstrainSelectedInstOperands,
     /*  64762 */       // GIR_Coverage, 7507,
     /*  64762 */       GIR_EraseRootFromParent_Done,
     /*  64763 */     // Label 582: @64763
     /*  64763 */     GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(64796), // Rule ID 7510 //
     /*  64768 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  64771 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64775 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64779 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64781 */       // (build_vector:{ *:[v2f16] } (undef:{ *:[f16] }), SReg_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34884>>  =>  (S_LSHL_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src1, 16:{ *:[i32] })
     /*  64781 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64784 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64786 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64788 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64791 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64794 */       GIR_RootConstrainSelectedInstOperands,
     /*  64795 */       // GIR_Coverage, 7510,
     /*  64795 */       GIR_EraseRootFromParent_Done,
     /*  64796 */     // Label 583: @64796
     /*  64796 */     GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(64829), // Rule ID 7512 //
     /*  64801 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  64804 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64808 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64812 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64814 */       // (build_vector:{ *:[v2f16] } (undef:{ *:[f16] }), SReg_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34884>>  =>  (S_LSHL_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src1, 16:{ *:[i32] })
     /*  64814 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64817 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64819 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64821 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64824 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64827 */       GIR_RootConstrainSelectedInstOperands,
     /*  64828 */       // GIR_Coverage, 7512,
     /*  64828 */       GIR_EraseRootFromParent_Done,
     /*  64829 */     // Label 584: @64829
     /*  64829 */     GIM_Reject,
     /*  64830 */   // Label 581: @64830
     /*  64830 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(64869), // Rule ID 7513 //
     /*  64835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34886),
     /*  64855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64857 */     // (build_vector:{ *:[v2f16] } (undef:{ *:[f16] }), VGPR_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34886>>  =>  (V_LSHLREV_B32_e64:{ *:[v2f16] } 16:{ *:[i32] }, VGPR_32:{ *:[f16] }:$src1)
     /*  64857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /*  64860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64867 */     GIR_RootConstrainSelectedInstOperands,
     /*  64868 */     // GIR_Coverage, 7513,
     /*  64868 */     GIR_EraseRootFromParent_Done,
     /*  64869 */   // Label 585: @64869
     /*  64869 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(64909), // Rule ID 7502 //
     /*  64874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34884),
     /*  64894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64896 */     // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, (undef:{ *:[i16] }))<<P:Predicate_anonymous_34884>>  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i32] })
     /*  64896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64901 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  64903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64908 */     // GIR_Coverage, 7502,
     /*  64908 */     GIR_EraseRootFromParent_Done,
     /*  64909 */   // Label 586: @64909
     /*  64909 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(64989),
     /*  64914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34886),
     /*  64918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64926 */     GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(64957), // Rule ID 7503 //
     /*  64931 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  64934 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64938 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64942 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64944 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, (undef:{ *:[i16] }))<<P:Predicate_anonymous_34886>>  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i32] })
     /*  64944 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64947 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64949 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  64951 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64956 */       // GIR_Coverage, 7503,
     /*  64956 */       GIR_EraseRootFromParent_Done,
     /*  64957 */     // Label 588: @64957
     /*  64957 */     GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(64988), // Rule ID 7506 //
     /*  64962 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  64965 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64969 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64973 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64975 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, (undef:{ *:[i16] }))<<P:Predicate_anonymous_34886>>  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i32] })
     /*  64975 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64978 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64980 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  64982 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64987 */       // GIR_Coverage, 7506,
     /*  64987 */       GIR_EraseRootFromParent_Done,
     /*  64988 */     // Label 589: @64988
     /*  64988 */     GIM_Reject,
     /*  64989 */   // Label 587: @64989
     /*  64989 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(65029), // Rule ID 7508 //
     /*  64994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  65010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34884),
     /*  65014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65016 */     // (build_vector:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, (undef:{ *:[f16] }))<<P:Predicate_anonymous_34884>>  =>  (COPY_TO_REGCLASS:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, SReg_32:{ *:[i32] })
     /*  65016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65028 */     // GIR_Coverage, 7508,
     /*  65028 */     GIR_EraseRootFromParent_Done,
     /*  65029 */   // Label 590: @65029
     /*  65029 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(65253),
     /*  65034 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34886),
     /*  65038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65046 */     GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(65077), // Rule ID 7509 //
     /*  65051 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  65054 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65058 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  65062 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65064 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, (undef:{ *:[f16] }))<<P:Predicate_anonymous_34886>>  =>  (COPY_TO_REGCLASS:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, VGPR_32:{ *:[i32] })
     /*  65064 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65067 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65069 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65071 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65076 */       // GIR_Coverage, 7509,
     /*  65076 */       GIR_EraseRootFromParent_Done,
     /*  65077 */     // Label 592: @65077
     /*  65077 */     GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(65108), // Rule ID 7511 //
     /*  65082 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  65085 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65089 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  65093 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65095 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, (undef:{ *:[f16] }))<<P:Predicate_anonymous_34886>>  =>  (COPY_TO_REGCLASS:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, VGPR_32:{ *:[i32] })
     /*  65095 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65098 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65100 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65102 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65107 */       // GIR_Coverage, 7511,
     /*  65107 */       GIR_EraseRootFromParent_Done,
     /*  65108 */     // Label 593: @65108
     /*  65108 */     GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(65180), // Rule ID 7514 //
     /*  65113 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  65116 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65120 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34886>>  =>  (V_LSHL_OR_B32_e64:{ *:[v2i16] } ?:{ *:[i16] }:$src1, 16:{ *:[i32] }, (V_AND_B32_e64:{ *:[i32] } (V_MOV_B32_e32:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src0))
     /*  65120 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  65123 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /*  65127 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65132 */       GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(65535),
     /*  65142 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  65144 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  65147 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  65151 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65156 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65159 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src0
     /*  65163 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65165 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  65168 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65170 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  65172 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  65175 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65178 */       GIR_RootConstrainSelectedInstOperands,
     /*  65179 */       // GIR_Coverage, 7514,
     /*  65179 */       GIR_EraseRootFromParent_Done,
     /*  65180 */     // Label 594: @65180
     /*  65180 */     GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(65252), // Rule ID 7515 //
     /*  65185 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  65188 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65192 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34886>>  =>  (V_LSHL_OR_B32_e64:{ *:[v2i16] } ?:{ *:[i16] }:$src1, 16:{ *:[i32] }, (V_AND_B32_e64:{ *:[i32] } (V_MOV_B32_e32:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src0))
     /*  65192 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  65195 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /*  65199 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65204 */       GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(65535),
     /*  65214 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  65216 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  65219 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  65223 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65228 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65231 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src0
     /*  65235 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65237 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  65240 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65242 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  65244 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  65247 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65250 */       GIR_RootConstrainSelectedInstOperands,
     /*  65251 */       // GIR_Coverage, 7515,
     /*  65251 */       GIR_EraseRootFromParent_Done,
     /*  65252 */     // Label 595: @65252
     /*  65252 */     GIM_Reject,
     /*  65253 */   // Label 591: @65253
     /*  65253 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(65284), // Rule ID 7518 //
     /*  65258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  65261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65273 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34884),
     /*  65277 */     // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34884>>  =>  (S_PACK_LL_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i16] }:$src1)
     /*  65277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_LL_B32_B16),
     /*  65282 */     GIR_RootConstrainSelectedInstOperands,
     /*  65283 */     // GIR_Coverage, 7518,
     /*  65283 */     GIR_Done,
     /*  65284 */   // Label 596: @65284
     /*  65284 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(65453),
     /*  65289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34886),
     /*  65293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65297 */     GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(65351), // Rule ID 7519 //
     /*  65302 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  65305 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65309 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65313 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$a, VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34886>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$b, VGPR_32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
     /*  65313 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  65316 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  65320 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65325 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
     /*  65335 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65337 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  65340 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65342 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65344 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65346 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65349 */       GIR_RootConstrainSelectedInstOperands,
     /*  65350 */       // GIR_Coverage, 7519,
     /*  65350 */       GIR_EraseRootFromParent_Done,
     /*  65351 */     // Label 598: @65351
     /*  65351 */     GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(65398), // Rule ID 7520 //
     /*  65356 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseRealTrue16Insts),
     /*  65359 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65363 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65367 */       // (build_vector:{ *:[v2i16] } VGPR_16:{ *:[i16] }:$a, VGPR_16:{ *:[i16] }:$b)<<P:Predicate_anonymous_34886>>  =>  (REG_SEQUENCE:{ *:[v2i16] } VGPR_32:{ *:[i32] }, VGPR_16:{ *:[i16] }:$a, lo16:{ *:[i32] }, VGPR_16:{ *:[i16] }:$b, hi16:{ *:[i32] })
     /*  65367 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  65370 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65372 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65374 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  65377 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65379 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  65382 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65387 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65392 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65397 */       // GIR_Coverage, 7520,
     /*  65397 */       GIR_EraseRootFromParent_Done,
     /*  65398 */     // Label 599: @65398
     /*  65398 */     GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(65452), // Rule ID 7526 //
     /*  65403 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  65406 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65410 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65414 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$a, VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34886>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$b, VGPR_32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
     /*  65414 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  65417 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  65421 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65426 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
     /*  65436 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65438 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  65441 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65443 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65445 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65447 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65450 */       GIR_RootConstrainSelectedInstOperands,
     /*  65451 */       // GIR_Coverage, 7526,
     /*  65451 */       GIR_EraseRootFromParent_Done,
     /*  65452 */     // Label 600: @65452
     /*  65452 */     GIM_Reject,
     /*  65453 */   // Label 597: @65453
     /*  65453 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(65484), // Rule ID 7528 //
     /*  65458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  65461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65473 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34884),
     /*  65477 */     // (build_vector:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, SReg_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34884>>  =>  (S_PACK_LL_B32_B16:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, SReg_32:{ *:[f16] }:$src1)
     /*  65477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_LL_B32_B16),
     /*  65482 */     GIR_RootConstrainSelectedInstOperands,
     /*  65483 */     // GIR_Coverage, 7528,
     /*  65483 */     GIR_Done,
     /*  65484 */   // Label 601: @65484
     /*  65484 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(65653),
     /*  65489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34886),
     /*  65493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65497 */     GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(65551), // Rule ID 7529 //
     /*  65502 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  65505 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65509 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65513 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$a, VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34886>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$b, VGPR_32:{ *:[f16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
     /*  65513 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  65516 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  65520 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65525 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
     /*  65535 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65537 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  65540 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65542 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65544 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65546 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65549 */       GIR_RootConstrainSelectedInstOperands,
     /*  65550 */       // GIR_Coverage, 7529,
     /*  65550 */       GIR_EraseRootFromParent_Done,
     /*  65551 */     // Label 603: @65551
     /*  65551 */     GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(65605), // Rule ID 7530 //
     /*  65556 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  65559 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65563 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65567 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$a, VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34886>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$b, VGPR_32:{ *:[f16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
     /*  65567 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  65570 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  65574 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65579 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
     /*  65589 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65591 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  65594 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65596 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65598 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65600 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65603 */       GIR_RootConstrainSelectedInstOperands,
     /*  65604 */       // GIR_Coverage, 7530,
     /*  65604 */       GIR_EraseRootFromParent_Done,
     /*  65605 */     // Label 604: @65605
     /*  65605 */     GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(65652), // Rule ID 7531 //
     /*  65610 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseRealTrue16Insts),
     /*  65613 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65617 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65621 */       // (build_vector:{ *:[v2f16] } VGPR_16:{ *:[f16] }:$a, VGPR_16:{ *:[f16] }:$b)<<P:Predicate_anonymous_34886>>  =>  (REG_SEQUENCE:{ *:[v2f16] } VGPR_32:{ *:[i32] }, VGPR_16:{ *:[f16] }:$a, lo16:{ *:[i32] }, VGPR_16:{ *:[f16] }:$b, hi16:{ *:[i32] })
     /*  65621 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  65624 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65626 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65628 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  65631 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65633 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  65636 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65641 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65646 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65651 */       // GIR_Coverage, 7531,
     /*  65651 */       GIR_EraseRootFromParent_Done,
     /*  65652 */     // Label 605: @65652
     /*  65652 */     GIM_Reject,
     /*  65653 */   // Label 602: @65653
     /*  65653 */   GIM_Reject,
     /*  65654 */ // Label 535: @65654
     /*  65654 */ GIM_Reject,
     /*  65655 */ // Label 8: @65655
     /*  65655 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(34), /*)*//*default:*//*Label 632*/ GIMT_Encode4(71251),
     /*  65666 */ /*GILLT_s16*//*Label 606*/ GIMT_Encode4(65770),
     /*  65670 */ /*GILLT_s32*//*Label 607*/ GIMT_Encode4(65884),
     /*  65674 */ /*GILLT_s64*//*Label 608*/ GIMT_Encode4(66117),
     /*  65678 */ /*GILLT_v2s16*//*Label 609*/ GIMT_Encode4(66408),
     /*  65682 */ /*GILLT_v2s32*//*Label 610*/ GIMT_Encode4(66583),
     /*  65686 */ /*GILLT_v2s64*//*Label 611*/ GIMT_Encode4(66903),
     /*  65690 */ /*GILLT_v3s32*//*Label 612*/ GIMT_Encode4(67194),
     /*  65694 */ /*GILLT_v3s64*//*Label 613*/ GIMT_Encode4(67248),
     /*  65698 */ /*GILLT_v4s16*//*Label 614*/ GIMT_Encode4(67423),
     /*  65702 */ /*GILLT_v4s32*//*Label 615*/ GIMT_Encode4(67714),
     /*  65706 */ /*GILLT_v4s64*//*Label 616*/ GIMT_Encode4(68005),
     /*  65710 */ /*GILLT_v5s32*//*Label 617*/ GIMT_Encode4(68296),
     /*  65714 */ /*GILLT_v6s32*//*Label 618*/ GIMT_Encode4(68410),
     /*  65718 */ /*GILLT_v7s32*//*Label 619*/ GIMT_Encode4(68643),
     /*  65722 */ /*GILLT_v8s16*//*Label 620*/ GIMT_Encode4(68757),
     /*  65726 */ /*GILLT_v8s32*//*Label 621*/ GIMT_Encode4(69106),
     /*  65730 */ /*GILLT_v8s64*//*Label 622*/ GIMT_Encode4(69455),
     /*  65734 */ /*GILLT_v9s32*//*Label 623*/ GIMT_Encode4(69630),
     /*  65738 */ /*GILLT_v10s32*//*Label 624*/ GIMT_Encode4(69744),
     /*  65742 */ /*GILLT_v11s32*//*Label 625*/ GIMT_Encode4(69858),
     /*  65746 */ /*GILLT_v12s32*//*Label 626*/ GIMT_Encode4(69972),
     /*  65750 */ /*GILLT_v16s16*//*Label 627*/ GIMT_Encode4(70086),
     /*  65754 */ /*GILLT_v16s32*//*Label 628*/ GIMT_Encode4(70435),
     /*  65758 */ /*GILLT_v16s64*//*Label 629*/ GIMT_Encode4(70726),
     /*  65762 */ /*GILLT_v32s16*//*Label 630*/ GIMT_Encode4(70901),
     /*  65766 */ /*GILLT_v32s32*//*Label 631*/ GIMT_Encode4(71076),
     /*  65770 */ // Label 606: @65770
     /*  65770 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(65883),
     /*  65775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  65778 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(65804), // Rule ID 7027 //
     /*  65783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65791 */     // (bitconvert:{ *:[i16] } VGPR_32:{ *:[f16] }:$src0)  =>  VGPR_32:{ *:[i16] }:$src0
     /*  65791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65794 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65796 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65803 */     // GIR_Coverage, 7027,
     /*  65803 */     GIR_EraseRootFromParent_Done,
     /*  65804 */   // Label 634: @65804
     /*  65804 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(65830), // Rule ID 7028 //
     /*  65809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65817 */     // (bitconvert:{ *:[f16] } VGPR_32:{ *:[i16] }:$src0)  =>  VGPR_32:{ *:[f16] }:$src0
     /*  65817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65820 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65822 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65829 */     // GIR_Coverage, 7028,
     /*  65829 */     GIR_EraseRootFromParent_Done,
     /*  65830 */   // Label 635: @65830
     /*  65830 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(65856), // Rule ID 7029 //
     /*  65835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65843 */     // (bitconvert:{ *:[i16] } SReg_32:{ *:[f16] }:$src0)  =>  SReg_32:{ *:[i16] }:$src0
     /*  65843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65846 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65855 */     // GIR_Coverage, 7029,
     /*  65855 */     GIR_EraseRootFromParent_Done,
     /*  65856 */   // Label 636: @65856
     /*  65856 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(65882), // Rule ID 7030 //
     /*  65861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65869 */     // (bitconvert:{ *:[f16] } SReg_32:{ *:[i16] }:$src0)  =>  SReg_32:{ *:[f16] }:$src0
     /*  65869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65872 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65874 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65881 */     // GIR_Coverage, 7030,
     /*  65881 */     GIR_EraseRootFromParent_Done,
     /*  65882 */   // Label 637: @65882
     /*  65882 */   GIM_Reject,
     /*  65883 */ // Label 633: @65883
     /*  65883 */ GIM_Reject,
     /*  65884 */ // Label 607: @65884
     /*  65884 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(65913), // Rule ID 7031 //
     /*  65889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  65892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65900 */   // (bitconvert:{ *:[i32] } VGPR_32:{ *:[f32] }:$src0)  =>  VGPR_32:{ *:[i32] }:$src0
     /*  65900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65903 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65905 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65912 */   // GIR_Coverage, 7031,
     /*  65912 */   GIR_EraseRootFromParent_Done,
     /*  65913 */ // Label 638: @65913
     /*  65913 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(65942), // Rule ID 7032 //
     /*  65918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  65921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65929 */   // (bitconvert:{ *:[f32] } VGPR_32:{ *:[i32] }:$src0)  =>  VGPR_32:{ *:[f32] }:$src0
     /*  65929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65932 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65934 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65936 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65941 */   // GIR_Coverage, 7032,
     /*  65941 */   GIR_EraseRootFromParent_Done,
     /*  65942 */ // Label 639: @65942
     /*  65942 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(65971), // Rule ID 7033 //
     /*  65947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  65950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65958 */   // (bitconvert:{ *:[i32] } SReg_32:{ *:[f32] }:$src0)  =>  SReg_32:{ *:[i32] }:$src0
     /*  65958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65961 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65963 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65970 */   // GIR_Coverage, 7033,
     /*  65970 */   GIR_EraseRootFromParent_Done,
     /*  65971 */ // Label 640: @65971
     /*  65971 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(66000), // Rule ID 7034 //
     /*  65976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  65979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65987 */   // (bitconvert:{ *:[f32] } SReg_32:{ *:[i32] }:$src0)  =>  SReg_32:{ *:[f32] }:$src0
     /*  65987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65990 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65992 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65994 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65999 */   // GIR_Coverage, 7034,
     /*  65999 */   GIR_EraseRootFromParent_Done,
     /*  66000 */ // Label 641: @66000
     /*  66000 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(66029), // Rule ID 7036 //
     /*  66005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66016 */   // (bitconvert:{ *:[i32] } SReg_32:{ *:[v2i16] }:$src0)  =>  SReg_32:{ *:[i32] }:$src0
     /*  66016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66019 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66021 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66023 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66028 */   // GIR_Coverage, 7036,
     /*  66028 */   GIR_EraseRootFromParent_Done,
     /*  66029 */ // Label 642: @66029
     /*  66029 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(66058), // Rule ID 7038 //
     /*  66034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66045 */   // (bitconvert:{ *:[i32] } SReg_32:{ *:[v2f16] }:$src0)  =>  SReg_32:{ *:[i32] }:$src0
     /*  66045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66048 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66050 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66052 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66057 */   // GIR_Coverage, 7038,
     /*  66057 */   GIR_EraseRootFromParent_Done,
     /*  66058 */ // Label 643: @66058
     /*  66058 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(66087), // Rule ID 7042 //
     /*  66063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66074 */   // (bitconvert:{ *:[f32] } SReg_32:{ *:[v2f16] }:$src0)  =>  SReg_32:{ *:[f32] }:$src0
     /*  66074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66077 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66086 */   // GIR_Coverage, 7042,
     /*  66086 */   GIR_EraseRootFromParent_Done,
     /*  66087 */ // Label 644: @66087
     /*  66087 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(66116), // Rule ID 7044 //
     /*  66092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66103 */   // (bitconvert:{ *:[f32] } SReg_32:{ *:[v2i16] }:$src0)  =>  SReg_32:{ *:[f32] }:$src0
     /*  66103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66106 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66108 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66115 */   // GIR_Coverage, 7044,
     /*  66115 */   GIR_EraseRootFromParent_Done,
     /*  66116 */ // Label 645: @66116
     /*  66116 */ GIM_Reject,
     /*  66117 */ // Label 608: @66117
     /*  66117 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(66146), // Rule ID 7045 //
     /*  66122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66133 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66136 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66138 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66145 */   // GIR_Coverage, 7045,
     /*  66145 */   GIR_EraseRootFromParent_Done,
     /*  66146 */ // Label 646: @66146
     /*  66146 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(66175), // Rule ID 7046 //
     /*  66151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66162 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66165 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66167 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66174 */   // GIR_Coverage, 7046,
     /*  66174 */   GIR_EraseRootFromParent_Done,
     /*  66175 */ // Label 647: @66175
     /*  66175 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(66204), // Rule ID 7049 //
     /*  66180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66191 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66194 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66196 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66198 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66203 */   // GIR_Coverage, 7049,
     /*  66203 */   GIR_EraseRootFromParent_Done,
     /*  66204 */ // Label 648: @66204
     /*  66204 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(66233), // Rule ID 7051 //
     /*  66209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66220 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66223 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66225 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66232 */   // GIR_Coverage, 7051,
     /*  66232 */   GIR_EraseRootFromParent_Done,
     /*  66233 */ // Label 649: @66233
     /*  66233 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(66262), // Rule ID 7053 //
     /*  66238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66249 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66252 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66254 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66261 */   // GIR_Coverage, 7053,
     /*  66261 */   GIR_EraseRootFromParent_Done,
     /*  66262 */ // Label 650: @66262
     /*  66262 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(66291), // Rule ID 7055 //
     /*  66267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66278 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66281 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66285 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66290 */   // GIR_Coverage, 7055,
     /*  66290 */   GIR_EraseRootFromParent_Done,
     /*  66291 */ // Label 651: @66291
     /*  66291 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(66320), // Rule ID 7070 //
     /*  66296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66307 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66310 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66312 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66314 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66319 */   // GIR_Coverage, 7070,
     /*  66319 */   GIR_EraseRootFromParent_Done,
     /*  66320 */ // Label 652: @66320
     /*  66320 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(66349), // Rule ID 7071 //
     /*  66325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66336 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66339 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66341 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66343 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66348 */   // GIR_Coverage, 7071,
     /*  66348 */   GIR_EraseRootFromParent_Done,
     /*  66349 */ // Label 653: @66349
     /*  66349 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(66378), // Rule ID 7074 //
     /*  66354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66365 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66368 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66370 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66372 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66377 */   // GIR_Coverage, 7074,
     /*  66377 */   GIR_EraseRootFromParent_Done,
     /*  66378 */ // Label 654: @66378
     /*  66378 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(66407), // Rule ID 7075 //
     /*  66383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66394 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66397 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66399 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66406 */   // GIR_Coverage, 7075,
     /*  66406 */   GIR_EraseRootFromParent_Done,
     /*  66407 */ // Label 655: @66407
     /*  66407 */ GIM_Reject,
     /*  66408 */ // Label 609: @66408
     /*  66408 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(66437), // Rule ID 7035 //
     /*  66413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66424 */   // (bitconvert:{ *:[v2i16] } SReg_32:{ *:[i32] }:$src0)  =>  SReg_32:{ *:[v2i16] }:$src0
     /*  66424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66427 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66429 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66436 */   // GIR_Coverage, 7035,
     /*  66436 */   GIR_EraseRootFromParent_Done,
     /*  66437 */ // Label 656: @66437
     /*  66437 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(66466), // Rule ID 7037 //
     /*  66442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66453 */   // (bitconvert:{ *:[v2f16] } SReg_32:{ *:[i32] }:$src0)  =>  SReg_32:{ *:[v2f16] }:$src0
     /*  66453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66456 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66458 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66460 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66465 */   // GIR_Coverage, 7037,
     /*  66465 */   GIR_EraseRootFromParent_Done,
     /*  66466 */ // Label 657: @66466
     /*  66466 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(66495), // Rule ID 7039 //
     /*  66471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66482 */   // (bitconvert:{ *:[v2i16] } SReg_32:{ *:[v2f16] }:$src0)  =>  SReg_32:{ *:[v2i16] }:$src0
     /*  66482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66485 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66487 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66489 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66494 */   // GIR_Coverage, 7039,
     /*  66494 */   GIR_EraseRootFromParent_Done,
     /*  66495 */ // Label 658: @66495
     /*  66495 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(66524), // Rule ID 7040 //
     /*  66500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66511 */   // (bitconvert:{ *:[v2f16] } SReg_32:{ *:[v2i16] }:$src0)  =>  SReg_32:{ *:[v2f16] }:$src0
     /*  66511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66514 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66516 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66518 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66523 */   // GIR_Coverage, 7040,
     /*  66523 */   GIR_EraseRootFromParent_Done,
     /*  66524 */ // Label 659: @66524
     /*  66524 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(66553), // Rule ID 7041 //
     /*  66529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66540 */   // (bitconvert:{ *:[v2f16] } SReg_32:{ *:[f32] }:$src0)  =>  SReg_32:{ *:[v2f16] }:$src0
     /*  66540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66543 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66545 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66552 */   // GIR_Coverage, 7041,
     /*  66552 */   GIR_EraseRootFromParent_Done,
     /*  66553 */ // Label 660: @66553
     /*  66553 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(66582), // Rule ID 7043 //
     /*  66558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66569 */   // (bitconvert:{ *:[v2i16] } SReg_32:{ *:[f32] }:$src0)  =>  SReg_32:{ *:[v2i16] }:$src0
     /*  66569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66572 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66574 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66581 */   // GIR_Coverage, 7043,
     /*  66581 */   GIR_EraseRootFromParent_Done,
     /*  66582 */ // Label 661: @66582
     /*  66582 */ GIM_Reject,
     /*  66583 */ // Label 610: @66583
     /*  66583 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(66612), // Rule ID 7047 //
     /*  66588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66599 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66602 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66604 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66606 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66611 */   // GIR_Coverage, 7047,
     /*  66611 */   GIR_EraseRootFromParent_Done,
     /*  66612 */ // Label 662: @66612
     /*  66612 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(66641), // Rule ID 7048 //
     /*  66617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66628 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  66628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66631 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66633 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66640 */   // GIR_Coverage, 7048,
     /*  66640 */   GIR_EraseRootFromParent_Done,
     /*  66641 */ // Label 663: @66641
     /*  66641 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(66670), // Rule ID 7050 //
     /*  66646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66657 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66669 */   // GIR_Coverage, 7050,
     /*  66669 */   GIR_EraseRootFromParent_Done,
     /*  66670 */ // Label 664: @66670
     /*  66670 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(66699), // Rule ID 7052 //
     /*  66675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66686 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  66686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66689 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66691 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66698 */   // GIR_Coverage, 7052,
     /*  66698 */   GIR_EraseRootFromParent_Done,
     /*  66699 */ // Label 665: @66699
     /*  66699 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(66728), // Rule ID 7054 //
     /*  66704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66715 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  66715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66718 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66722 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66727 */   // GIR_Coverage, 7054,
     /*  66727 */   GIR_EraseRootFromParent_Done,
     /*  66728 */ // Label 666: @66728
     /*  66728 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(66757), // Rule ID 7056 //
     /*  66733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66744 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66747 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66749 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66756 */   // GIR_Coverage, 7056,
     /*  66756 */   GIR_EraseRootFromParent_Done,
     /*  66757 */ // Label 667: @66757
     /*  66757 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(66786), // Rule ID 7059 //
     /*  66762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66773 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66776 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66778 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66785 */   // GIR_Coverage, 7059,
     /*  66785 */   GIR_EraseRootFromParent_Done,
     /*  66786 */ // Label 668: @66786
     /*  66786 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(66815), // Rule ID 7061 //
     /*  66791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66802 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66805 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66807 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66814 */   // GIR_Coverage, 7061,
     /*  66814 */   GIR_EraseRootFromParent_Done,
     /*  66815 */ // Label 669: @66815
     /*  66815 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(66844), // Rule ID 7062 //
     /*  66820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66831 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66834 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66836 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66838 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66843 */   // GIR_Coverage, 7062,
     /*  66843 */   GIR_EraseRootFromParent_Done,
     /*  66844 */ // Label 670: @66844
     /*  66844 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(66873), // Rule ID 7064 //
     /*  66849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66860 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  66860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66863 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66865 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66872 */   // GIR_Coverage, 7064,
     /*  66872 */   GIR_EraseRootFromParent_Done,
     /*  66873 */ // Label 671: @66873
     /*  66873 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(66902), // Rule ID 7066 //
     /*  66878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66889 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  66889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66892 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66894 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66896 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66901 */   // GIR_Coverage, 7066,
     /*  66901 */   GIR_EraseRootFromParent_Done,
     /*  66902 */ // Label 672: @66902
     /*  66902 */ GIM_Reject,
     /*  66903 */ // Label 611: @66903
     /*  66903 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(66932), // Rule ID 7080 //
     /*  66908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  66915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  66919 */   // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v4i32] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
     /*  66919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66922 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66924 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  66931 */   // GIR_Coverage, 7080,
     /*  66931 */   GIR_EraseRootFromParent_Done,
     /*  66932 */ // Label 673: @66932
     /*  66932 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(66961), // Rule ID 7082 //
     /*  66937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  66944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  66948 */   // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
     /*  66948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66951 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66953 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  66960 */   // GIR_Coverage, 7082,
     /*  66960 */   GIR_EraseRootFromParent_Done,
     /*  66961 */ // Label 674: @66961
     /*  66961 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(66990), // Rule ID 7083 //
     /*  66966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  66973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  66977 */   // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
     /*  66977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66980 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66982 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66984 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  66989 */   // GIR_Coverage, 7083,
     /*  66989 */   GIR_EraseRootFromParent_Done,
     /*  66990 */ // Label 675: @66990
     /*  66990 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(67019), // Rule ID 7086 //
     /*  66995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67006 */   // (bitconvert:{ *:[v2i64] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v2i64] }:$src0
     /*  67006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67009 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67011 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67013 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67018 */   // GIR_Coverage, 7086,
     /*  67018 */   GIR_EraseRootFromParent_Done,
     /*  67019 */ // Label 676: @67019
     /*  67019 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(67048), // Rule ID 7087 //
     /*  67024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67035 */   // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v2i64] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
     /*  67035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67038 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67040 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67047 */   // GIR_Coverage, 7087,
     /*  67047 */   GIR_EraseRootFromParent_Done,
     /*  67048 */ // Label 677: @67048
     /*  67048 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(67077), // Rule ID 7089 //
     /*  67053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67064 */   // (bitconvert:{ *:[v2i64] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v2i64] }:$src0
     /*  67064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67067 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67069 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67076 */   // GIR_Coverage, 7089,
     /*  67076 */   GIR_EraseRootFromParent_Done,
     /*  67077 */ // Label 678: @67077
     /*  67077 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(67106), // Rule ID 7106 //
     /*  67082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67093 */   // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
     /*  67093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67096 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67100 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67105 */   // GIR_Coverage, 7106,
     /*  67105 */   GIR_EraseRootFromParent_Done,
     /*  67106 */ // Label 679: @67106
     /*  67106 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(67135), // Rule ID 7107 //
     /*  67111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67122 */   // (bitconvert:{ *:[v2f64] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v2f64] }:$src0
     /*  67122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67134 */   // GIR_Coverage, 7107,
     /*  67134 */   GIR_EraseRootFromParent_Done,
     /*  67135 */ // Label 680: @67135
     /*  67135 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(67164), // Rule ID 7108 //
     /*  67140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67151 */   // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
     /*  67151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67154 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67156 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67163 */   // GIR_Coverage, 7108,
     /*  67163 */   GIR_EraseRootFromParent_Done,
     /*  67164 */ // Label 681: @67164
     /*  67164 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(67193), // Rule ID 7109 //
     /*  67169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67180 */   // (bitconvert:{ *:[v2f64] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v2f64] }:$src0
     /*  67180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67192 */   // GIR_Coverage, 7109,
     /*  67192 */   GIR_EraseRootFromParent_Done,
     /*  67193 */ // Label 682: @67193
     /*  67193 */ GIM_Reject,
     /*  67194 */ // Label 612: @67194
     /*  67194 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(67247),
     /*  67199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s32,
     /*  67202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
     /*  67206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
     /*  67210 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(67228), // Rule ID 7078 //
     /*  67215 */     // (bitconvert:{ *:[v3i32] } SGPR_96:{ *:[v3f32] }:$src0)  =>  SGPR_96:{ *:[v3i32] }:$src0
     /*  67215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67218 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
     /*  67227 */     // GIR_Coverage, 7078,
     /*  67227 */     GIR_EraseRootFromParent_Done,
     /*  67228 */   // Label 684: @67228
     /*  67228 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(67246), // Rule ID 7079 //
     /*  67233 */     // (bitconvert:{ *:[v3f32] } SGPR_96:{ *:[v3i32] }:$src0)  =>  SGPR_96:{ *:[v3f32] }:$src0
     /*  67233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67236 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67238 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
     /*  67245 */     // GIR_Coverage, 7079,
     /*  67245 */     GIR_EraseRootFromParent_Done,
     /*  67246 */   // Label 685: @67246
     /*  67246 */   GIM_Reject,
     /*  67247 */ // Label 683: @67247
     /*  67247 */ GIM_Reject,
     /*  67248 */ // Label 613: @67248
     /*  67248 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(67277), // Rule ID 7118 //
     /*  67253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  67256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67264 */   // (bitconvert:{ *:[v3i64] } VReg_192:{ *:[v3f64] }:$src0)  =>  VReg_192:{ *:[v3i64] }:$src0
     /*  67264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67267 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67276 */   // GIR_Coverage, 7118,
     /*  67276 */   GIR_EraseRootFromParent_Done,
     /*  67277 */ // Label 686: @67277
     /*  67277 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(67306), // Rule ID 7119 //
     /*  67282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  67285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67293 */   // (bitconvert:{ *:[v3f64] } VReg_192:{ *:[v3i64] }:$src0)  =>  VReg_192:{ *:[v3f64] }:$src0
     /*  67293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67296 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67298 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67305 */   // GIR_Coverage, 7119,
     /*  67305 */   GIR_EraseRootFromParent_Done,
     /*  67306 */ // Label 687: @67306
     /*  67306 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(67335), // Rule ID 7120 //
     /*  67311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  67314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67322 */   // (bitconvert:{ *:[v3i64] } VReg_192:{ *:[v6i32] }:$src0)  =>  VReg_192:{ *:[v3i64] }:$src0
     /*  67322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67325 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67334 */   // GIR_Coverage, 7120,
     /*  67334 */   GIR_EraseRootFromParent_Done,
     /*  67335 */ // Label 688: @67335
     /*  67335 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(67364), // Rule ID 7121 //
     /*  67340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  67343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67351 */   // (bitconvert:{ *:[v3i64] } VReg_192:{ *:[v6f32] }:$src0)  =>  VReg_192:{ *:[v3i64] }:$src0
     /*  67351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67354 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67356 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67358 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67363 */   // GIR_Coverage, 7121,
     /*  67363 */   GIR_EraseRootFromParent_Done,
     /*  67364 */ // Label 689: @67364
     /*  67364 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(67393), // Rule ID 7122 //
     /*  67369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  67372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67380 */   // (bitconvert:{ *:[v3f64] } VReg_192:{ *:[v6i32] }:$src0)  =>  VReg_192:{ *:[v3f64] }:$src0
     /*  67380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67383 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67385 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67392 */   // GIR_Coverage, 7122,
     /*  67392 */   GIR_EraseRootFromParent_Done,
     /*  67393 */ // Label 690: @67393
     /*  67393 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(67422), // Rule ID 7123 //
     /*  67398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  67401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67409 */   // (bitconvert:{ *:[v3f64] } VReg_192:{ *:[v6f32] }:$src0)  =>  VReg_192:{ *:[v3f64] }:$src0
     /*  67409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67412 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67414 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67421 */   // GIR_Coverage, 7123,
     /*  67421 */   GIR_EraseRootFromParent_Done,
     /*  67422 */ // Label 691: @67422
     /*  67422 */ GIM_Reject,
     /*  67423 */ // Label 614: @67423
     /*  67423 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(67452), // Rule ID 7057 //
     /*  67428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67439 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  67439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67442 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67444 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67446 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67451 */   // GIR_Coverage, 7057,
     /*  67451 */   GIR_EraseRootFromParent_Done,
     /*  67452 */ // Label 692: @67452
     /*  67452 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(67481), // Rule ID 7058 //
     /*  67457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67468 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  67468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67471 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67473 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67480 */   // GIR_Coverage, 7058,
     /*  67480 */   GIR_EraseRootFromParent_Done,
     /*  67481 */ // Label 693: @67481
     /*  67481 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(67510), // Rule ID 7060 //
     /*  67486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  67489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67497 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  67497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67500 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67502 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67504 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67509 */   // GIR_Coverage, 7060,
     /*  67509 */   GIR_EraseRootFromParent_Done,
     /*  67510 */ // Label 694: @67510
     /*  67510 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(67539), // Rule ID 7063 //
     /*  67515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  67518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67526 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  67526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67529 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67531 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67538 */   // GIR_Coverage, 7063,
     /*  67538 */   GIR_EraseRootFromParent_Done,
     /*  67539 */ // Label 695: @67539
     /*  67539 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(67568), // Rule ID 7065 //
     /*  67544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  67547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67555 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  67555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67558 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67560 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67562 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67567 */   // GIR_Coverage, 7065,
     /*  67567 */   GIR_EraseRootFromParent_Done,
     /*  67568 */ // Label 696: @67568
     /*  67568 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(67597), // Rule ID 7067 //
     /*  67573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  67576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67584 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  67584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67587 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67589 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67591 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67596 */   // GIR_Coverage, 7067,
     /*  67596 */   GIR_EraseRootFromParent_Done,
     /*  67597 */ // Label 697: @67597
     /*  67597 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(67626), // Rule ID 7068 //
     /*  67602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  67605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67613 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  67613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67616 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67618 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67620 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67625 */   // GIR_Coverage, 7068,
     /*  67625 */   GIR_EraseRootFromParent_Done,
     /*  67626 */ // Label 698: @67626
     /*  67626 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(67655), // Rule ID 7069 //
     /*  67631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  67634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67642 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  67642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67645 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67647 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67649 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67654 */   // GIR_Coverage, 7069,
     /*  67654 */   GIR_EraseRootFromParent_Done,
     /*  67655 */ // Label 699: @67655
     /*  67655 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(67684), // Rule ID 7072 //
     /*  67660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  67663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67671 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  67671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67674 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67676 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67678 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67683 */   // GIR_Coverage, 7072,
     /*  67683 */   GIR_EraseRootFromParent_Done,
     /*  67684 */ // Label 700: @67684
     /*  67684 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(67713), // Rule ID 7073 //
     /*  67689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  67692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67700 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  67700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67703 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67712 */   // GIR_Coverage, 7073,
     /*  67712 */   GIR_EraseRootFromParent_Done,
     /*  67713 */ // Label 701: @67713
     /*  67713 */ GIM_Reject,
     /*  67714 */ // Label 615: @67714
     /*  67714 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(67743), // Rule ID 7076 //
     /*  67719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67730 */   // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
     /*  67730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67733 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67735 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67737 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67742 */   // GIR_Coverage, 7076,
     /*  67742 */   GIR_EraseRootFromParent_Done,
     /*  67743 */ // Label 702: @67743
     /*  67743 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(67772), // Rule ID 7077 //
     /*  67748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67759 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  67759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67762 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67764 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67766 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67771 */   // GIR_Coverage, 7077,
     /*  67771 */   GIR_EraseRootFromParent_Done,
     /*  67772 */ // Label 703: @67772
     /*  67772 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(67801), // Rule ID 7081 //
     /*  67777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67788 */   // (bitconvert:{ *:[v4i32] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v4i32] }:$src0
     /*  67788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67791 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67793 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67795 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67800 */   // GIR_Coverage, 7081,
     /*  67800 */   GIR_EraseRootFromParent_Done,
     /*  67801 */ // Label 704: @67801
     /*  67801 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(67830), // Rule ID 7084 //
     /*  67806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67817 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  67817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67820 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67829 */   // GIR_Coverage, 7084,
     /*  67829 */   GIR_EraseRootFromParent_Done,
     /*  67830 */ // Label 705: @67830
     /*  67830 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(67859), // Rule ID 7085 //
     /*  67835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67846 */   // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
     /*  67846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67849 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67851 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67858 */   // GIR_Coverage, 7085,
     /*  67858 */   GIR_EraseRootFromParent_Done,
     /*  67859 */ // Label 706: @67859
     /*  67859 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(67888), // Rule ID 7088 //
     /*  67864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67875 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v2i64] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  67875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67878 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67880 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67882 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67887 */   // GIR_Coverage, 7088,
     /*  67887 */   GIR_EraseRootFromParent_Done,
     /*  67888 */ // Label 707: @67888
     /*  67888 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(67917), // Rule ID 7091 //
     /*  67893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67904 */   // (bitconvert:{ *:[v4i32] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v4i32] }:$src0
     /*  67904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67907 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67909 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67911 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67916 */   // GIR_Coverage, 7091,
     /*  67916 */   GIR_EraseRootFromParent_Done,
     /*  67917 */ // Label 708: @67917
     /*  67917 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(67946), // Rule ID 7094 //
     /*  67922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67933 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  67933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67936 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67938 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67940 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67945 */   // GIR_Coverage, 7094,
     /*  67945 */   GIR_EraseRootFromParent_Done,
     /*  67946 */ // Label 709: @67946
     /*  67946 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(67975), // Rule ID 7095 //
     /*  67951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67962 */   // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
     /*  67962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67965 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67967 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67969 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67974 */   // GIR_Coverage, 7095,
     /*  67974 */   GIR_EraseRootFromParent_Done,
     /*  67975 */ // Label 710: @67975
     /*  67975 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(68004), // Rule ID 7098 //
     /*  67980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67991 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v8i16] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  67991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67994 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67996 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67998 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68003 */   // GIR_Coverage, 7098,
     /*  68003 */   GIR_EraseRootFromParent_Done,
     /*  68004 */ // Label 711: @68004
     /*  68004 */ GIM_Reject,
     /*  68005 */ // Label 616: @68005
     /*  68005 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(68034), // Rule ID 7136 //
     /*  68010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  68013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68021 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  68021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68024 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68026 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68028 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68033 */   // GIR_Coverage, 7136,
     /*  68033 */   GIR_EraseRootFromParent_Done,
     /*  68034 */ // Label 712: @68034
     /*  68034 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(68063), // Rule ID 7137 //
     /*  68039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  68042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68050 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  68050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68053 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68055 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68057 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68062 */   // GIR_Coverage, 7137,
     /*  68062 */   GIR_EraseRootFromParent_Done,
     /*  68063 */ // Label 713: @68063
     /*  68063 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(68092), // Rule ID 7138 //
     /*  68068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  68071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68079 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  68079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68082 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68084 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68091 */   // GIR_Coverage, 7138,
     /*  68091 */   GIR_EraseRootFromParent_Done,
     /*  68092 */ // Label 714: @68092
     /*  68092 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(68121), // Rule ID 7139 //
     /*  68097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  68100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68108 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  68108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68111 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68113 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68120 */   // GIR_Coverage, 7139,
     /*  68120 */   GIR_EraseRootFromParent_Done,
     /*  68121 */ // Label 715: @68121
     /*  68121 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(68150), // Rule ID 7140 //
     /*  68126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  68129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68137 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  68137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68140 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68142 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68144 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68149 */   // GIR_Coverage, 7140,
     /*  68149 */   GIR_EraseRootFromParent_Done,
     /*  68150 */ // Label 716: @68150
     /*  68150 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(68179), // Rule ID 7141 //
     /*  68155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  68158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68166 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  68166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68169 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68171 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68178 */   // GIR_Coverage, 7141,
     /*  68178 */   GIR_EraseRootFromParent_Done,
     /*  68179 */ // Label 717: @68179
     /*  68179 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(68208), // Rule ID 7162 //
     /*  68184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  68187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68195 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  68195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68198 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68207 */   // GIR_Coverage, 7162,
     /*  68207 */   GIR_EraseRootFromParent_Done,
     /*  68208 */ // Label 718: @68208
     /*  68208 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(68237), // Rule ID 7163 //
     /*  68213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  68216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68224 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  68224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68227 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68229 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68236 */   // GIR_Coverage, 7163,
     /*  68236 */   GIR_EraseRootFromParent_Done,
     /*  68237 */ // Label 719: @68237
     /*  68237 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(68266), // Rule ID 7164 //
     /*  68242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  68245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68253 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  68253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68256 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68258 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68265 */   // GIR_Coverage, 7164,
     /*  68265 */   GIR_EraseRootFromParent_Done,
     /*  68266 */ // Label 720: @68266
     /*  68266 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(68295), // Rule ID 7165 //
     /*  68271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  68274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68282 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  68282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68285 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68287 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68289 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  68294 */   // GIR_Coverage, 7165,
     /*  68294 */   GIR_EraseRootFromParent_Done,
     /*  68295 */ // Label 721: @68295
     /*  68295 */ GIM_Reject,
     /*  68296 */ // Label 617: @68296
     /*  68296 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(68409),
     /*  68301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v5s32,
     /*  68304 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(68330), // Rule ID 7110 //
     /*  68309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  68313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  68317 */     // (bitconvert:{ *:[v5i32] } SReg_160:{ *:[v5f32] }:$src0)  =>  SReg_160:{ *:[v5i32] }:$src0
     /*  68317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68320 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68322 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  68329 */     // GIR_Coverage, 7110,
     /*  68329 */     GIR_EraseRootFromParent_Done,
     /*  68330 */   // Label 723: @68330
     /*  68330 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(68356), // Rule ID 7111 //
     /*  68335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  68339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  68343 */     // (bitconvert:{ *:[v5f32] } SReg_160:{ *:[v5i32] }:$src0)  =>  SReg_160:{ *:[v5f32] }:$src0
     /*  68343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68346 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68348 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  68355 */     // GIR_Coverage, 7111,
     /*  68355 */     GIR_EraseRootFromParent_Done,
     /*  68356 */   // Label 724: @68356
     /*  68356 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(68382), // Rule ID 7112 //
     /*  68361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  68365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  68369 */     // (bitconvert:{ *:[v5i32] } VReg_160:{ *:[v5f32] }:$src0)  =>  VReg_160:{ *:[v5i32] }:$src0
     /*  68369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68372 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68374 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  68381 */     // GIR_Coverage, 7112,
     /*  68381 */     GIR_EraseRootFromParent_Done,
     /*  68382 */   // Label 725: @68382
     /*  68382 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(68408), // Rule ID 7113 //
     /*  68387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  68391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  68395 */     // (bitconvert:{ *:[v5f32] } VReg_160:{ *:[v5i32] }:$src0)  =>  VReg_160:{ *:[v5f32] }:$src0
     /*  68395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68398 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68400 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  68407 */     // GIR_Coverage, 7113,
     /*  68407 */     GIR_EraseRootFromParent_Done,
     /*  68408 */   // Label 726: @68408
     /*  68408 */   GIM_Reject,
     /*  68409 */ // Label 722: @68409
     /*  68409 */ GIM_Reject,
     /*  68410 */ // Label 618: @68410
     /*  68410 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(68439), // Rule ID 7114 //
     /*  68415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  68418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68426 */   // (bitconvert:{ *:[v6i32] } SReg_192:{ *:[v6f32] }:$src0)  =>  SReg_192:{ *:[v6i32] }:$src0
     /*  68426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68429 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68431 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68433 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68438 */   // GIR_Coverage, 7114,
     /*  68438 */   GIR_EraseRootFromParent_Done,
     /*  68439 */ // Label 727: @68439
     /*  68439 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(68468), // Rule ID 7115 //
     /*  68444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  68447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68455 */   // (bitconvert:{ *:[v6f32] } SReg_192:{ *:[v6i32] }:$src0)  =>  SReg_192:{ *:[v6f32] }:$src0
     /*  68455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68458 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68460 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68462 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68467 */   // GIR_Coverage, 7115,
     /*  68467 */   GIR_EraseRootFromParent_Done,
     /*  68468 */ // Label 728: @68468
     /*  68468 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(68497), // Rule ID 7116 //
     /*  68473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  68476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68484 */   // (bitconvert:{ *:[v6i32] } VReg_192:{ *:[v6f32] }:$src0)  =>  VReg_192:{ *:[v6i32] }:$src0
     /*  68484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68487 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68489 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68496 */   // GIR_Coverage, 7116,
     /*  68496 */   GIR_EraseRootFromParent_Done,
     /*  68497 */ // Label 729: @68497
     /*  68497 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(68526), // Rule ID 7117 //
     /*  68502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  68505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68513 */   // (bitconvert:{ *:[v6f32] } VReg_192:{ *:[v6i32] }:$src0)  =>  VReg_192:{ *:[v6f32] }:$src0
     /*  68513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68516 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68518 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68525 */   // GIR_Coverage, 7117,
     /*  68525 */   GIR_EraseRootFromParent_Done,
     /*  68526 */ // Label 730: @68526
     /*  68526 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(68555), // Rule ID 7124 //
     /*  68531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  68534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68542 */   // (bitconvert:{ *:[v6i32] } VReg_192:{ *:[v3i64] }:$src0)  =>  VReg_192:{ *:[v6i32] }:$src0
     /*  68542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68554 */   // GIR_Coverage, 7124,
     /*  68554 */   GIR_EraseRootFromParent_Done,
     /*  68555 */ // Label 731: @68555
     /*  68555 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(68584), // Rule ID 7125 //
     /*  68560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  68563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68571 */   // (bitconvert:{ *:[v6f32] } VReg_192:{ *:[v3i64] }:$src0)  =>  VReg_192:{ *:[v6f32] }:$src0
     /*  68571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68574 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68576 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68583 */   // GIR_Coverage, 7125,
     /*  68583 */   GIR_EraseRootFromParent_Done,
     /*  68584 */ // Label 732: @68584
     /*  68584 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(68613), // Rule ID 7126 //
     /*  68589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  68592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68600 */   // (bitconvert:{ *:[v6i32] } VReg_192:{ *:[v3f64] }:$src0)  =>  VReg_192:{ *:[v6i32] }:$src0
     /*  68600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68603 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68605 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68607 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68612 */   // GIR_Coverage, 7126,
     /*  68612 */   GIR_EraseRootFromParent_Done,
     /*  68613 */ // Label 733: @68613
     /*  68613 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(68642), // Rule ID 7127 //
     /*  68618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  68621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68629 */   // (bitconvert:{ *:[v6f32] } VReg_192:{ *:[v3f64] }:$src0)  =>  VReg_192:{ *:[v6f32] }:$src0
     /*  68629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68632 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68634 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68641 */   // GIR_Coverage, 7127,
     /*  68641 */   GIR_EraseRootFromParent_Done,
     /*  68642 */ // Label 734: @68642
     /*  68642 */ GIM_Reject,
     /*  68643 */ // Label 619: @68643
     /*  68643 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(68756),
     /*  68648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v7s32,
     /*  68651 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(68677), // Rule ID 7128 //
     /*  68656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  68660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  68664 */     // (bitconvert:{ *:[v7i32] } SReg_224:{ *:[v7f32] }:$src0)  =>  SReg_224:{ *:[v7i32] }:$src0
     /*  68664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68667 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  68676 */     // GIR_Coverage, 7128,
     /*  68676 */     GIR_EraseRootFromParent_Done,
     /*  68677 */   // Label 736: @68677
     /*  68677 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(68703), // Rule ID 7129 //
     /*  68682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  68686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  68690 */     // (bitconvert:{ *:[v7f32] } SReg_224:{ *:[v7i32] }:$src0)  =>  SReg_224:{ *:[v7f32] }:$src0
     /*  68690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68693 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  68702 */     // GIR_Coverage, 7129,
     /*  68702 */     GIR_EraseRootFromParent_Done,
     /*  68703 */   // Label 737: @68703
     /*  68703 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(68729), // Rule ID 7130 //
     /*  68708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  68712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  68716 */     // (bitconvert:{ *:[v7i32] } VReg_224:{ *:[v7f32] }:$src0)  =>  VReg_224:{ *:[v7i32] }:$src0
     /*  68716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68719 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68721 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  68728 */     // GIR_Coverage, 7130,
     /*  68728 */     GIR_EraseRootFromParent_Done,
     /*  68729 */   // Label 738: @68729
     /*  68729 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(68755), // Rule ID 7131 //
     /*  68734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  68738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  68742 */     // (bitconvert:{ *:[v7f32] } VReg_224:{ *:[v7i32] }:$src0)  =>  VReg_224:{ *:[v7f32] }:$src0
     /*  68742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68745 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68747 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  68754 */     // GIR_Coverage, 7131,
     /*  68754 */     GIR_EraseRootFromParent_Done,
     /*  68755 */   // Label 739: @68755
     /*  68755 */   GIM_Reject,
     /*  68756 */ // Label 735: @68756
     /*  68756 */ GIM_Reject,
     /*  68757 */ // Label 620: @68757
     /*  68757 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(68786), // Rule ID 7090 //
     /*  68762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68773 */   // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v4i32] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
     /*  68773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68776 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68778 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68785 */   // GIR_Coverage, 7090,
     /*  68785 */   GIR_EraseRootFromParent_Done,
     /*  68786 */ // Label 740: @68786
     /*  68786 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(68815), // Rule ID 7092 //
     /*  68791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68802 */   // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
     /*  68802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68805 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68807 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68814 */   // GIR_Coverage, 7092,
     /*  68814 */   GIR_EraseRootFromParent_Done,
     /*  68815 */ // Label 741: @68815
     /*  68815 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(68844), // Rule ID 7093 //
     /*  68820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68831 */   // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
     /*  68831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68834 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68836 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68838 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68843 */   // GIR_Coverage, 7093,
     /*  68843 */   GIR_EraseRootFromParent_Done,
     /*  68844 */ // Label 742: @68844
     /*  68844 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(68873), // Rule ID 7096 //
     /*  68849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68860 */   // (bitconvert:{ *:[v8i16] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v8i16] }:$src0
     /*  68860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68863 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68865 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68872 */   // GIR_Coverage, 7096,
     /*  68872 */   GIR_EraseRootFromParent_Done,
     /*  68873 */ // Label 743: @68873
     /*  68873 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(68902), // Rule ID 7097 //
     /*  68878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68889 */   // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v8i16] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
     /*  68889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68892 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68894 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68896 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68901 */   // GIR_Coverage, 7097,
     /*  68901 */   GIR_EraseRootFromParent_Done,
     /*  68902 */ // Label 744: @68902
     /*  68902 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(68931), // Rule ID 7099 //
     /*  68907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68918 */   // (bitconvert:{ *:[v8i16] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v8i16] }:$src0
     /*  68918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68930 */   // GIR_Coverage, 7099,
     /*  68930 */   GIR_EraseRootFromParent_Done,
     /*  68931 */ // Label 745: @68931
     /*  68931 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(68960), // Rule ID 7100 //
     /*  68936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68947 */   // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
     /*  68947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68950 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68952 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68954 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68959 */   // GIR_Coverage, 7100,
     /*  68959 */   GIR_EraseRootFromParent_Done,
     /*  68960 */ // Label 746: @68960
     /*  68960 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(68989), // Rule ID 7101 //
     /*  68965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  68968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68976 */   // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
     /*  68976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68979 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68981 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68983 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68988 */   // GIR_Coverage, 7101,
     /*  68988 */   GIR_EraseRootFromParent_Done,
     /*  68989 */ // Label 747: @68989
     /*  68989 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(69018), // Rule ID 7102 //
     /*  68994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  68997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69005 */   // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v2f64] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
     /*  69005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69008 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69010 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69012 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69017 */   // GIR_Coverage, 7102,
     /*  69017 */   GIR_EraseRootFromParent_Done,
     /*  69018 */ // Label 748: @69018
     /*  69018 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(69047), // Rule ID 7103 //
     /*  69023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  69026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69034 */   // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
     /*  69034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69037 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69039 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69046 */   // GIR_Coverage, 7103,
     /*  69046 */   GIR_EraseRootFromParent_Done,
     /*  69047 */ // Label 749: @69047
     /*  69047 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(69076), // Rule ID 7104 //
     /*  69052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  69055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69063 */   // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v2f64] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
     /*  69063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69066 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69068 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69075 */   // GIR_Coverage, 7104,
     /*  69075 */   GIR_EraseRootFromParent_Done,
     /*  69076 */ // Label 750: @69076
     /*  69076 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(69105), // Rule ID 7105 //
     /*  69081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69092 */   // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
     /*  69092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69095 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69097 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69104 */   // GIR_Coverage, 7105,
     /*  69104 */   GIR_EraseRootFromParent_Done,
     /*  69105 */ // Label 751: @69105
     /*  69105 */ GIM_Reject,
     /*  69106 */ // Label 621: @69106
     /*  69106 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(69135), // Rule ID 7132 //
     /*  69111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69122 */   // (bitconvert:{ *:[v8i32] } SReg_256:{ *:[v8f32] }:$src0)  =>  SReg_256:{ *:[v8i32] }:$src0
     /*  69122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69134 */   // GIR_Coverage, 7132,
     /*  69134 */   GIR_EraseRootFromParent_Done,
     /*  69135 */ // Label 752: @69135
     /*  69135 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(69164), // Rule ID 7133 //
     /*  69140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69151 */   // (bitconvert:{ *:[v8f32] } SReg_256:{ *:[v8i32] }:$src0)  =>  SReg_256:{ *:[v8f32] }:$src0
     /*  69151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69154 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69156 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69163 */   // GIR_Coverage, 7133,
     /*  69163 */   GIR_EraseRootFromParent_Done,
     /*  69164 */ // Label 753: @69164
     /*  69164 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(69193), // Rule ID 7134 //
     /*  69169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69180 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  69180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69192 */   // GIR_Coverage, 7134,
     /*  69192 */   GIR_EraseRootFromParent_Done,
     /*  69193 */ // Label 754: @69193
     /*  69193 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(69222), // Rule ID 7135 //
     /*  69198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69209 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  69209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69212 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69214 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69221 */   // GIR_Coverage, 7135,
     /*  69221 */   GIR_EraseRootFromParent_Done,
     /*  69222 */ // Label 755: @69222
     /*  69222 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(69251), // Rule ID 7142 //
     /*  69227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  69230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69238 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  69238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69241 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69243 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69250 */   // GIR_Coverage, 7142,
     /*  69250 */   GIR_EraseRootFromParent_Done,
     /*  69251 */ // Label 756: @69251
     /*  69251 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(69280), // Rule ID 7143 //
     /*  69256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  69259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69267 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  69267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69270 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69272 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69274 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69279 */   // GIR_Coverage, 7143,
     /*  69279 */   GIR_EraseRootFromParent_Done,
     /*  69280 */ // Label 757: @69280
     /*  69280 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(69309), // Rule ID 7144 //
     /*  69285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  69288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69296 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  69296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69299 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69301 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69308 */   // GIR_Coverage, 7144,
     /*  69308 */   GIR_EraseRootFromParent_Done,
     /*  69309 */ // Label 758: @69309
     /*  69309 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(69338), // Rule ID 7145 //
     /*  69314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  69317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69325 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  69325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69328 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69330 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69337 */   // GIR_Coverage, 7145,
     /*  69337 */   GIR_EraseRootFromParent_Done,
     /*  69338 */ // Label 759: @69338
     /*  69338 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(69367), // Rule ID 7154 //
     /*  69343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69354 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  69354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69357 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69359 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69366 */   // GIR_Coverage, 7154,
     /*  69366 */   GIR_EraseRootFromParent_Done,
     /*  69367 */ // Label 760: @69367
     /*  69367 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(69396), // Rule ID 7155 //
     /*  69372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69383 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  69383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69386 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69388 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69390 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69395 */   // GIR_Coverage, 7155,
     /*  69395 */   GIR_EraseRootFromParent_Done,
     /*  69396 */ // Label 761: @69396
     /*  69396 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(69425), // Rule ID 7156 //
     /*  69401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69412 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  69412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69415 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69424 */   // GIR_Coverage, 7156,
     /*  69424 */   GIR_EraseRootFromParent_Done,
     /*  69425 */ // Label 762: @69425
     /*  69425 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(69454), // Rule ID 7157 //
     /*  69430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69441 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  69441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69444 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69446 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69448 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69453 */   // GIR_Coverage, 7157,
     /*  69453 */   GIR_EraseRootFromParent_Done,
     /*  69454 */ // Label 763: @69454
     /*  69454 */ GIM_Reject,
     /*  69455 */ // Label 622: @69455
     /*  69455 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(69484), // Rule ID 7194 //
     /*  69460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  69463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69471 */   // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
     /*  69471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69474 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69476 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69478 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69483 */   // GIR_Coverage, 7194,
     /*  69483 */   GIR_EraseRootFromParent_Done,
     /*  69484 */ // Label 764: @69484
     /*  69484 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(69513), // Rule ID 7195 //
     /*  69489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  69492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69500 */   // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
     /*  69500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69503 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69505 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69507 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69512 */   // GIR_Coverage, 7195,
     /*  69512 */   GIR_EraseRootFromParent_Done,
     /*  69513 */ // Label 765: @69513
     /*  69513 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(69542), // Rule ID 7196 //
     /*  69518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  69521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69529 */   // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
     /*  69529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69532 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69534 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69536 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69541 */   // GIR_Coverage, 7196,
     /*  69541 */   GIR_EraseRootFromParent_Done,
     /*  69542 */ // Label 766: @69542
     /*  69542 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(69571), // Rule ID 7197 //
     /*  69547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  69550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69558 */   // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
     /*  69558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69561 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69563 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69570 */   // GIR_Coverage, 7197,
     /*  69570 */   GIR_EraseRootFromParent_Done,
     /*  69571 */ // Label 767: @69571
     /*  69571 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(69600), // Rule ID 7200 //
     /*  69576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  69579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69587 */   // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
     /*  69587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69590 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69592 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69599 */   // GIR_Coverage, 7200,
     /*  69599 */   GIR_EraseRootFromParent_Done,
     /*  69600 */ // Label 768: @69600
     /*  69600 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(69629), // Rule ID 7201 //
     /*  69605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  69608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69616 */   // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
     /*  69616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69619 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69621 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69623 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  69628 */   // GIR_Coverage, 7201,
     /*  69628 */   GIR_EraseRootFromParent_Done,
     /*  69629 */ // Label 769: @69629
     /*  69629 */ GIM_Reject,
     /*  69630 */ // Label 623: @69630
     /*  69630 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(69743),
     /*  69635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v9s32,
     /*  69638 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(69664), // Rule ID 7166 //
     /*  69643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  69647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  69651 */     // (bitconvert:{ *:[v9i32] } SReg_288:{ *:[v9f32] }:$src0)  =>  SReg_288:{ *:[v9i32] }:$src0
     /*  69651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69654 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69656 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  69663 */     // GIR_Coverage, 7166,
     /*  69663 */     GIR_EraseRootFromParent_Done,
     /*  69664 */   // Label 771: @69664
     /*  69664 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(69690), // Rule ID 7167 //
     /*  69669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  69673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  69677 */     // (bitconvert:{ *:[v9f32] } SReg_288:{ *:[v9i32] }:$src0)  =>  SReg_288:{ *:[v9f32] }:$src0
     /*  69677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69680 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69682 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  69689 */     // GIR_Coverage, 7167,
     /*  69689 */     GIR_EraseRootFromParent_Done,
     /*  69690 */   // Label 772: @69690
     /*  69690 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(69716), // Rule ID 7168 //
     /*  69695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  69699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  69703 */     // (bitconvert:{ *:[v9i32] } VReg_288:{ *:[v9f32] }:$src0)  =>  VReg_288:{ *:[v9i32] }:$src0
     /*  69703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69706 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69708 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  69715 */     // GIR_Coverage, 7168,
     /*  69715 */     GIR_EraseRootFromParent_Done,
     /*  69716 */   // Label 773: @69716
     /*  69716 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(69742), // Rule ID 7169 //
     /*  69721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  69725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  69729 */     // (bitconvert:{ *:[v9f32] } VReg_288:{ *:[v9i32] }:$src0)  =>  VReg_288:{ *:[v9f32] }:$src0
     /*  69729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69732 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69734 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  69741 */     // GIR_Coverage, 7169,
     /*  69741 */     GIR_EraseRootFromParent_Done,
     /*  69742 */   // Label 774: @69742
     /*  69742 */   GIM_Reject,
     /*  69743 */ // Label 770: @69743
     /*  69743 */ GIM_Reject,
     /*  69744 */ // Label 624: @69744
     /*  69744 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(69857),
     /*  69749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v10s32,
     /*  69752 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(69778), // Rule ID 7170 //
     /*  69757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  69761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  69765 */     // (bitconvert:{ *:[v10i32] } SReg_320:{ *:[v10f32] }:$src0)  =>  SReg_320:{ *:[v10i32] }:$src0
     /*  69765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69768 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69770 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  69777 */     // GIR_Coverage, 7170,
     /*  69777 */     GIR_EraseRootFromParent_Done,
     /*  69778 */   // Label 776: @69778
     /*  69778 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(69804), // Rule ID 7171 //
     /*  69783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  69787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  69791 */     // (bitconvert:{ *:[v10f32] } SReg_320:{ *:[v10i32] }:$src0)  =>  SReg_320:{ *:[v10f32] }:$src0
     /*  69791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69794 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69796 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  69803 */     // GIR_Coverage, 7171,
     /*  69803 */     GIR_EraseRootFromParent_Done,
     /*  69804 */   // Label 777: @69804
     /*  69804 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(69830), // Rule ID 7172 //
     /*  69809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  69813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  69817 */     // (bitconvert:{ *:[v10i32] } VReg_320:{ *:[v10f32] }:$src0)  =>  VReg_320:{ *:[v10i32] }:$src0
     /*  69817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69820 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69822 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  69829 */     // GIR_Coverage, 7172,
     /*  69829 */     GIR_EraseRootFromParent_Done,
     /*  69830 */   // Label 778: @69830
     /*  69830 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(69856), // Rule ID 7173 //
     /*  69835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  69839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  69843 */     // (bitconvert:{ *:[v10f32] } VReg_320:{ *:[v10i32] }:$src0)  =>  VReg_320:{ *:[v10f32] }:$src0
     /*  69843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69846 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  69855 */     // GIR_Coverage, 7173,
     /*  69855 */     GIR_EraseRootFromParent_Done,
     /*  69856 */   // Label 779: @69856
     /*  69856 */   GIM_Reject,
     /*  69857 */ // Label 775: @69857
     /*  69857 */ GIM_Reject,
     /*  69858 */ // Label 625: @69858
     /*  69858 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(69971),
     /*  69863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v11s32,
     /*  69866 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(69892), // Rule ID 7174 //
     /*  69871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  69875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  69879 */     // (bitconvert:{ *:[v11i32] } SReg_352:{ *:[v11f32] }:$src0)  =>  SReg_352:{ *:[v11i32] }:$src0
     /*  69879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69882 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69884 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69886 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  69891 */     // GIR_Coverage, 7174,
     /*  69891 */     GIR_EraseRootFromParent_Done,
     /*  69892 */   // Label 781: @69892
     /*  69892 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(69918), // Rule ID 7175 //
     /*  69897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  69901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  69905 */     // (bitconvert:{ *:[v11f32] } SReg_352:{ *:[v11i32] }:$src0)  =>  SReg_352:{ *:[v11f32] }:$src0
     /*  69905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69908 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69910 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  69917 */     // GIR_Coverage, 7175,
     /*  69917 */     GIR_EraseRootFromParent_Done,
     /*  69918 */   // Label 782: @69918
     /*  69918 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(69944), // Rule ID 7176 //
     /*  69923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  69927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  69931 */     // (bitconvert:{ *:[v11i32] } VReg_352:{ *:[v11f32] }:$src0)  =>  VReg_352:{ *:[v11i32] }:$src0
     /*  69931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69934 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69936 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  69943 */     // GIR_Coverage, 7176,
     /*  69943 */     GIR_EraseRootFromParent_Done,
     /*  69944 */   // Label 783: @69944
     /*  69944 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(69970), // Rule ID 7177 //
     /*  69949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  69953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  69957 */     // (bitconvert:{ *:[v11f32] } VReg_352:{ *:[v11i32] }:$src0)  =>  VReg_352:{ *:[v11f32] }:$src0
     /*  69957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69960 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69962 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  69969 */     // GIR_Coverage, 7177,
     /*  69969 */     GIR_EraseRootFromParent_Done,
     /*  69970 */   // Label 784: @69970
     /*  69970 */   GIM_Reject,
     /*  69971 */ // Label 780: @69971
     /*  69971 */ GIM_Reject,
     /*  69972 */ // Label 626: @69972
     /*  69972 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(70085),
     /*  69977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v12s32,
     /*  69980 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(70006), // Rule ID 7178 //
     /*  69985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  69989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  69993 */     // (bitconvert:{ *:[v12i32] } SReg_384:{ *:[v12f32] }:$src0)  =>  SReg_384:{ *:[v12i32] }:$src0
     /*  69993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69996 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69998 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  70005 */     // GIR_Coverage, 7178,
     /*  70005 */     GIR_EraseRootFromParent_Done,
     /*  70006 */   // Label 786: @70006
     /*  70006 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(70032), // Rule ID 7179 //
     /*  70011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  70015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  70019 */     // (bitconvert:{ *:[v12f32] } SReg_384:{ *:[v12i32] }:$src0)  =>  SReg_384:{ *:[v12f32] }:$src0
     /*  70019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70022 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70024 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  70031 */     // GIR_Coverage, 7179,
     /*  70031 */     GIR_EraseRootFromParent_Done,
     /*  70032 */   // Label 787: @70032
     /*  70032 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(70058), // Rule ID 7180 //
     /*  70037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  70041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  70045 */     // (bitconvert:{ *:[v12i32] } VReg_384:{ *:[v12f32] }:$src0)  =>  VReg_384:{ *:[v12i32] }:$src0
     /*  70045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70048 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  70057 */     // GIR_Coverage, 7180,
     /*  70057 */     GIR_EraseRootFromParent_Done,
     /*  70058 */   // Label 788: @70058
     /*  70058 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(70084), // Rule ID 7181 //
     /*  70063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  70067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  70071 */     // (bitconvert:{ *:[v12f32] } VReg_384:{ *:[v12i32] }:$src0)  =>  VReg_384:{ *:[v12f32] }:$src0
     /*  70071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70074 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70076 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  70083 */     // GIR_Coverage, 7181,
     /*  70083 */     GIR_EraseRootFromParent_Done,
     /*  70084 */   // Label 789: @70084
     /*  70084 */   GIM_Reject,
     /*  70085 */ // Label 785: @70085
     /*  70085 */ GIM_Reject,
     /*  70086 */ // Label 627: @70086
     /*  70086 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(70115), // Rule ID 7146 //
     /*  70091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  70094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70102 */   // (bitconvert:{ *:[v16i16] } SReg_256:{ *:[v16f16] }:$src0)  =>  SReg_256:{ *:[v16i16] }:$src0
     /*  70102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70105 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70107 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70114 */   // GIR_Coverage, 7146,
     /*  70114 */   GIR_EraseRootFromParent_Done,
     /*  70115 */ // Label 790: @70115
     /*  70115 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(70144), // Rule ID 7147 //
     /*  70120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  70123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70131 */   // (bitconvert:{ *:[v16f16] } SReg_256:{ *:[v16i16] }:$src0)  =>  SReg_256:{ *:[v16f16] }:$src0
     /*  70131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70134 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70136 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70143 */   // GIR_Coverage, 7147,
     /*  70143 */   GIR_EraseRootFromParent_Done,
     /*  70144 */ // Label 791: @70144
     /*  70144 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(70173), // Rule ID 7148 //
     /*  70149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  70152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70160 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  70160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70163 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70165 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70172 */   // GIR_Coverage, 7148,
     /*  70172 */   GIR_EraseRootFromParent_Done,
     /*  70173 */ // Label 792: @70173
     /*  70173 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(70202), // Rule ID 7149 //
     /*  70178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  70181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70189 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  70189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70192 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70194 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70196 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70201 */   // GIR_Coverage, 7149,
     /*  70201 */   GIR_EraseRootFromParent_Done,
     /*  70202 */ // Label 793: @70202
     /*  70202 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(70231), // Rule ID 7150 //
     /*  70207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  70210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70218 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  70218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70221 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70223 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70230 */   // GIR_Coverage, 7150,
     /*  70230 */   GIR_EraseRootFromParent_Done,
     /*  70231 */ // Label 794: @70231
     /*  70231 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(70260), // Rule ID 7151 //
     /*  70236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  70239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70247 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  70247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70250 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70252 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70254 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70259 */   // GIR_Coverage, 7151,
     /*  70259 */   GIR_EraseRootFromParent_Done,
     /*  70260 */ // Label 795: @70260
     /*  70260 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(70289), // Rule ID 7152 //
     /*  70265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  70268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70276 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  70276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70279 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70288 */   // GIR_Coverage, 7152,
     /*  70288 */   GIR_EraseRootFromParent_Done,
     /*  70289 */ // Label 796: @70289
     /*  70289 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(70318), // Rule ID 7153 //
     /*  70294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  70297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70305 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  70305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70308 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70310 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70312 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70317 */   // GIR_Coverage, 7153,
     /*  70317 */   GIR_EraseRootFromParent_Done,
     /*  70318 */ // Label 797: @70318
     /*  70318 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(70347), // Rule ID 7158 //
     /*  70323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  70326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70334 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  70334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70337 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70339 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70341 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70346 */   // GIR_Coverage, 7158,
     /*  70346 */   GIR_EraseRootFromParent_Done,
     /*  70347 */ // Label 798: @70347
     /*  70347 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(70376), // Rule ID 7159 //
     /*  70352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  70355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70363 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  70363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70366 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70368 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70375 */   // GIR_Coverage, 7159,
     /*  70375 */   GIR_EraseRootFromParent_Done,
     /*  70376 */ // Label 799: @70376
     /*  70376 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(70405), // Rule ID 7160 //
     /*  70381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  70384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70392 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  70392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70395 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70397 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70404 */   // GIR_Coverage, 7160,
     /*  70404 */   GIR_EraseRootFromParent_Done,
     /*  70405 */ // Label 800: @70405
     /*  70405 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(70434), // Rule ID 7161 //
     /*  70410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  70413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70421 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  70421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70424 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70426 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70433 */   // GIR_Coverage, 7161,
     /*  70433 */   GIR_EraseRootFromParent_Done,
     /*  70434 */ // Label 801: @70434
     /*  70434 */ GIM_Reject,
     /*  70435 */ // Label 628: @70435
     /*  70435 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(70464), // Rule ID 7186 //
     /*  70440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  70443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70451 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  70451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70463 */   // GIR_Coverage, 7186,
     /*  70463 */   GIR_EraseRootFromParent_Done,
     /*  70464 */ // Label 802: @70464
     /*  70464 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(70493), // Rule ID 7187 //
     /*  70469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  70472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70480 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  70480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70483 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70492 */   // GIR_Coverage, 7187,
     /*  70492 */   GIR_EraseRootFromParent_Done,
     /*  70493 */ // Label 803: @70493
     /*  70493 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(70522), // Rule ID 7190 //
     /*  70498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  70501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70509 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  70509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70512 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70521 */   // GIR_Coverage, 7190,
     /*  70521 */   GIR_EraseRootFromParent_Done,
     /*  70522 */ // Label 804: @70522
     /*  70522 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(70551), // Rule ID 7191 //
     /*  70527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  70530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70538 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  70538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70541 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70543 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70545 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70550 */   // GIR_Coverage, 7191,
     /*  70550 */   GIR_EraseRootFromParent_Done,
     /*  70551 */ // Label 805: @70551
     /*  70551 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(70580), // Rule ID 7192 //
     /*  70556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  70559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70567 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  70567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70570 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70574 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70579 */   // GIR_Coverage, 7192,
     /*  70579 */   GIR_EraseRootFromParent_Done,
     /*  70580 */ // Label 806: @70580
     /*  70580 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(70609), // Rule ID 7193 //
     /*  70585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  70588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70596 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  70596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70599 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70608 */   // GIR_Coverage, 7193,
     /*  70608 */   GIR_EraseRootFromParent_Done,
     /*  70609 */ // Label 807: @70609
     /*  70609 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(70638), // Rule ID 7198 //
     /*  70614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  70617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70625 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  70625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70637 */   // GIR_Coverage, 7198,
     /*  70637 */   GIR_EraseRootFromParent_Done,
     /*  70638 */ // Label 808: @70638
     /*  70638 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(70667), // Rule ID 7199 //
     /*  70643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  70646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70654 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  70654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70657 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70659 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70661 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70666 */   // GIR_Coverage, 7199,
     /*  70666 */   GIR_EraseRootFromParent_Done,
     /*  70667 */ // Label 809: @70667
     /*  70667 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(70696), // Rule ID 7202 //
     /*  70672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  70675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70683 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  70683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70686 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70688 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70695 */   // GIR_Coverage, 7202,
     /*  70695 */   GIR_EraseRootFromParent_Done,
     /*  70696 */ // Label 810: @70696
     /*  70696 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(70725), // Rule ID 7203 //
     /*  70701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  70704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70712 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  70712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70715 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70717 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70724 */   // GIR_Coverage, 7203,
     /*  70724 */   GIR_EraseRootFromParent_Done,
     /*  70725 */ // Label 811: @70725
     /*  70725 */ GIM_Reject,
     /*  70726 */ // Label 629: @70726
     /*  70726 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(70755), // Rule ID 7206 //
     /*  70731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  70734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70742 */   // (bitconvert:{ *:[v16i64] } VReg_1024:{ *:[v16f64] }:$src0)  =>  VReg_1024:{ *:[v16i64] }:$src0
     /*  70742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70754 */   // GIR_Coverage, 7206,
     /*  70754 */   GIR_EraseRootFromParent_Done,
     /*  70755 */ // Label 812: @70755
     /*  70755 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(70784), // Rule ID 7207 //
     /*  70760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  70763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70771 */   // (bitconvert:{ *:[v16f64] } VReg_1024:{ *:[v16i64] }:$src0)  =>  VReg_1024:{ *:[v16f64] }:$src0
     /*  70771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70774 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70776 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70783 */   // GIR_Coverage, 7207,
     /*  70783 */   GIR_EraseRootFromParent_Done,
     /*  70784 */ // Label 813: @70784
     /*  70784 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(70813), // Rule ID 7208 //
     /*  70789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  70792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70800 */   // (bitconvert:{ *:[v16i64] } VReg_1024:{ *:[v32i32] }:$src0)  =>  VReg_1024:{ *:[v16i64] }:$src0
     /*  70800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70812 */   // GIR_Coverage, 7208,
     /*  70812 */   GIR_EraseRootFromParent_Done,
     /*  70813 */ // Label 814: @70813
     /*  70813 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(70842), // Rule ID 7210 //
     /*  70818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  70821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70829 */   // (bitconvert:{ *:[v16f64] } VReg_1024:{ *:[v32f32] }:$src0)  =>  VReg_1024:{ *:[v16f64] }:$src0
     /*  70829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70832 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70834 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70836 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70841 */   // GIR_Coverage, 7210,
     /*  70841 */   GIR_EraseRootFromParent_Done,
     /*  70842 */ // Label 815: @70842
     /*  70842 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(70871), // Rule ID 7212 //
     /*  70847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  70850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70858 */   // (bitconvert:{ *:[v16i64] } VReg_1024:{ *:[v32f32] }:$src0)  =>  VReg_1024:{ *:[v16i64] }:$src0
     /*  70858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70861 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70863 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70865 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70870 */   // GIR_Coverage, 7212,
     /*  70870 */   GIR_EraseRootFromParent_Done,
     /*  70871 */ // Label 816: @70871
     /*  70871 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(70900), // Rule ID 7214 //
     /*  70876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  70879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70887 */   // (bitconvert:{ *:[v16f64] } VReg_1024:{ *:[v32i32] }:$src0)  =>  VReg_1024:{ *:[v16f64] }:$src0
     /*  70887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70890 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70892 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  70899 */   // GIR_Coverage, 7214,
     /*  70899 */   GIR_EraseRootFromParent_Done,
     /*  70900 */ // Label 817: @70900
     /*  70900 */ GIM_Reject,
     /*  70901 */ // Label 630: @70901
     /*  70901 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(70930), // Rule ID 7182 //
     /*  70906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  70909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70917 */   // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
     /*  70917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70920 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70922 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70924 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70929 */   // GIR_Coverage, 7182,
     /*  70929 */   GIR_EraseRootFromParent_Done,
     /*  70930 */ // Label 818: @70930
     /*  70930 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(70959), // Rule ID 7183 //
     /*  70935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  70938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70946 */   // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
     /*  70946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70949 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70953 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70958 */   // GIR_Coverage, 7183,
     /*  70958 */   GIR_EraseRootFromParent_Done,
     /*  70959 */ // Label 819: @70959
     /*  70959 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(70988), // Rule ID 7184 //
     /*  70964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  70967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70975 */   // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
     /*  70975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70978 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70980 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  70987 */   // GIR_Coverage, 7184,
     /*  70987 */   GIR_EraseRootFromParent_Done,
     /*  70988 */ // Label 820: @70988
     /*  70988 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(71017), // Rule ID 7185 //
     /*  70993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  70996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71004 */   // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
     /*  71004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71007 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71016 */   // GIR_Coverage, 7185,
     /*  71016 */   GIR_EraseRootFromParent_Done,
     /*  71017 */ // Label 821: @71017
     /*  71017 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(71046), // Rule ID 7188 //
     /*  71022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71033 */   // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
     /*  71033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71036 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71045 */   // GIR_Coverage, 7188,
     /*  71045 */   GIR_EraseRootFromParent_Done,
     /*  71046 */ // Label 822: @71046
     /*  71046 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(71075), // Rule ID 7189 //
     /*  71051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71062 */   // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
     /*  71062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71074 */   // GIR_Coverage, 7189,
     /*  71074 */   GIR_EraseRootFromParent_Done,
     /*  71075 */ // Label 823: @71075
     /*  71075 */ GIM_Reject,
     /*  71076 */ // Label 631: @71076
     /*  71076 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(71105), // Rule ID 7204 //
     /*  71081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  71084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71092 */   // (bitconvert:{ *:[v32i32] } VReg_1024:{ *:[v32f32] }:$src0)  =>  VReg_1024:{ *:[v32i32] }:$src0
     /*  71092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71095 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71097 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71104 */   // GIR_Coverage, 7204,
     /*  71104 */   GIR_EraseRootFromParent_Done,
     /*  71105 */ // Label 824: @71105
     /*  71105 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(71134), // Rule ID 7205 //
     /*  71110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  71113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71121 */   // (bitconvert:{ *:[v32f32] } VReg_1024:{ *:[v32i32] }:$src0)  =>  VReg_1024:{ *:[v32f32] }:$src0
     /*  71121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71133 */   // GIR_Coverage, 7205,
     /*  71133 */   GIR_EraseRootFromParent_Done,
     /*  71134 */ // Label 825: @71134
     /*  71134 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(71163), // Rule ID 7209 //
     /*  71139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  71142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71150 */   // (bitconvert:{ *:[v32i32] } VReg_1024:{ *:[v16i64] }:$src0)  =>  VReg_1024:{ *:[v32i32] }:$src0
     /*  71150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71153 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71155 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71157 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71162 */   // GIR_Coverage, 7209,
     /*  71162 */   GIR_EraseRootFromParent_Done,
     /*  71163 */ // Label 826: @71163
     /*  71163 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(71192), // Rule ID 7211 //
     /*  71168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  71171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71179 */   // (bitconvert:{ *:[v32f32] } VReg_1024:{ *:[v16f64] }:$src0)  =>  VReg_1024:{ *:[v32f32] }:$src0
     /*  71179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71182 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71184 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71191 */   // GIR_Coverage, 7211,
     /*  71191 */   GIR_EraseRootFromParent_Done,
     /*  71192 */ // Label 827: @71192
     /*  71192 */ GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(71221), // Rule ID 7213 //
     /*  71197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  71200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71208 */   // (bitconvert:{ *:[v32i32] } VReg_1024:{ *:[v16f64] }:$src0)  =>  VReg_1024:{ *:[v32i32] }:$src0
     /*  71208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71211 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71213 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71215 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71220 */   // GIR_Coverage, 7213,
     /*  71220 */   GIR_EraseRootFromParent_Done,
     /*  71221 */ // Label 828: @71221
     /*  71221 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(71250), // Rule ID 7215 //
     /*  71226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  71229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71237 */   // (bitconvert:{ *:[v32f32] } VReg_1024:{ *:[v16i64] }:$src0)  =>  VReg_1024:{ *:[v32f32] }:$src0
     /*  71237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71240 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71242 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71244 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  71249 */   // GIR_Coverage, 7215,
     /*  71249 */   GIR_EraseRootFromParent_Done,
     /*  71250 */ // Label 829: @71250
     /*  71250 */ GIM_Reject,
     /*  71251 */ // Label 632: @71251
     /*  71251 */ GIM_Reject,
     /*  71252 */ // Label 9: @71252
     /*  71252 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 832*/ GIMT_Encode4(71446),
     /*  71263 */ /*GILLT_s16*//*Label 830*/ GIMT_Encode4(71271),
     /*  71267 */ /*GILLT_s32*//*Label 831*/ GIMT_Encode4(71410),
     /*  71271 */ // Label 830: @71271
     /*  71271 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(71409),
     /*  71276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  71279 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(71338), // Rule ID 6936 //
     /*  71284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  71287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  71291 */     // MIs[0] round
     /*  71291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  71294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
     /*  71299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  71306 */     // (fptrunc_round:{ *:[f16] } (VOP3OpSelMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F16_F32_PSEUDO_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
     /*  71306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F16_F32_PSEUDO_t16_e64),
     /*  71309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71330 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
     /*  71336 */     GIR_RootConstrainSelectedInstOperands,
     /*  71337 */     // GIR_Coverage, 6936,
     /*  71337 */     GIR_EraseRootFromParent_Done,
     /*  71338 */   // Label 834: @71338
     /*  71338 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(71373), // Rule ID 6934 //
     /*  71343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  71346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71350 */     // MIs[0] round
     /*  71350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  71353 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
     /*  71358 */     // (fptrunc_round:{ *:[f16] } f32:{ *:[f32] }:$src0, (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F16_F32_PSEUDO:{ *:[f16] } ?:{ *:[f32] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
     /*  71358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F16_F32_PSEUDO),
     /*  71361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71365 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
     /*  71371 */     GIR_RootConstrainSelectedInstOperands,
     /*  71372 */     // GIR_Coverage, 6934,
     /*  71372 */     GIR_EraseRootFromParent_Done,
     /*  71373 */   // Label 835: @71373
     /*  71373 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(71408), // Rule ID 6935 //
     /*  71378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  71381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71385 */     // MIs[0] round
     /*  71385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  71388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
     /*  71393 */     // (fptrunc_round:{ *:[f16] } f32:{ *:[f32] }:$src0, (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F16_F32_PSEUDO_fake16_e32:{ *:[f16] } ?:{ *:[f32] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
     /*  71393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F16_F32_PSEUDO_fake16_e32),
     /*  71396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71398 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71400 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
     /*  71406 */     GIR_RootConstrainSelectedInstOperands,
     /*  71407 */     // GIR_Coverage, 6935,
     /*  71407 */     GIR_EraseRootFromParent_Done,
     /*  71408 */   // Label 836: @71408
     /*  71408 */   GIM_Reject,
     /*  71409 */ // Label 833: @71409
     /*  71409 */ GIM_Reject,
     /*  71410 */ // Label 831: @71410
     /*  71410 */ GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(71445), // Rule ID 6937 //
     /*  71415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  71418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71422 */   // MIs[0] round
     /*  71422 */   GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  71425 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
     /*  71430 */   // (fptrunc_round:{ *:[f32] } f64:{ *:[f64] }:$src0, (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F32_F64_PSEUDO:{ *:[f32] } ?:{ *:[f64] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
     /*  71430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F32_F64_PSEUDO),
     /*  71433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71435 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71437 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
     /*  71443 */   GIR_RootConstrainSelectedInstOperands,
     /*  71444 */   // GIR_Coverage, 6937,
     /*  71444 */   GIR_EraseRootFromParent_Done,
     /*  71445 */ // Label 837: @71445
     /*  71445 */ GIM_Reject,
     /*  71446 */ // Label 832: @71446
     /*  71446 */ GIM_Reject,
     /*  71447 */ // Label 10: @71447
     /*  71447 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 841*/ GIMT_Encode4(71774),
     /*  71458 */ /*GILLT_s16*//*Label 838*/ GIMT_Encode4(71470),
     /*  71462 */ /*GILLT_s32*//*Label 839*/ GIMT_Encode4(71644),
     /*  71466 */ /*GILLT_s64*//*Label 840*/ GIMT_Encode4(71724),
     /*  71470 */ // Label 838: @71470
     /*  71470 */ GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(71643),
     /*  71475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  71478 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(71505), // Rule ID 39 //
     /*  71483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /*  71486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  71490 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13773),
     /*  71494 */     // (ftrunc:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13773>>  =>  (S_TRUNC_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
     /*  71494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_TRUNC_F16),
     /*  71499 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /*  71503 */     GIR_RootConstrainSelectedInstOperands,
     /*  71504 */     // GIR_Coverage, 39,
     /*  71504 */     GIR_Done,
     /*  71505 */   // Label 843: @71505
     /*  71505 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(71551), // Rule ID 771 //
     /*  71510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /*  71513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  71524 */     // (ftrunc:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  71524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F16_e64),
     /*  71527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  71544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  71549 */     GIR_RootConstrainSelectedInstOperands,
     /*  71550 */     // GIR_Coverage, 771,
     /*  71550 */     GIR_EraseRootFromParent_Done,
     /*  71551 */   // Label 844: @71551
     /*  71551 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(71597), // Rule ID 773 //
     /*  71556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  71559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  71570 */     // (ftrunc:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  71570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F16_fake16_e64),
     /*  71573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  71590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  71595 */     GIR_RootConstrainSelectedInstOperands,
     /*  71596 */     // GIR_Coverage, 773,
     /*  71596 */     GIR_EraseRootFromParent_Done,
     /*  71597 */   // Label 845: @71597
     /*  71597 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(71642), // Rule ID 772 //
     /*  71602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  71605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  71609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  71616 */     // (ftrunc:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_TRUNC_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /*  71616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F16_t16_e64),
     /*  71619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71640 */     GIR_RootConstrainSelectedInstOperands,
     /*  71641 */     // GIR_Coverage, 772,
     /*  71641 */     GIR_EraseRootFromParent_Done,
     /*  71642 */   // Label 846: @71642
     /*  71642 */   GIM_Reject,
     /*  71643 */ // Label 842: @71643
     /*  71643 */ GIM_Reject,
     /*  71644 */ // Label 839: @71644
     /*  71644 */ GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(71723),
     /*  71649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  71652 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(71679), // Rule ID 34 //
     /*  71657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /*  71660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  71664 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13773),
     /*  71668 */     // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13773>>  =>  (S_TRUNC_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
     /*  71668 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_TRUNC_F32),
     /*  71673 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /*  71677 */     GIR_RootConstrainSelectedInstOperands,
     /*  71678 */     // GIR_Coverage, 34,
     /*  71678 */     GIR_Done,
     /*  71679 */   // Label 848: @71679
     /*  71679 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(71722), // Rule ID 657 //
     /*  71684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  71695 */     // (ftrunc:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  71695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F32_e64),
     /*  71698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  71715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  71720 */     GIR_RootConstrainSelectedInstOperands,
     /*  71721 */     // GIR_Coverage, 657,
     /*  71721 */     GIR_EraseRootFromParent_Done,
     /*  71722 */   // Label 849: @71722
     /*  71722 */   GIM_Reject,
     /*  71723 */ // Label 847: @71723
     /*  71723 */ GIM_Reject,
     /*  71724 */ // Label 840: @71724
     /*  71724 */ GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(71773), // Rule ID 701 //
     /*  71729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
     /*  71732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  71735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  71739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  71746 */   // (ftrunc:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  71746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F64_e64),
     /*  71749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  71766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  71771 */   GIR_RootConstrainSelectedInstOperands,
     /*  71772 */   // GIR_Coverage, 701,
     /*  71772 */   GIR_EraseRootFromParent_Done,
     /*  71773 */ // Label 850: @71773
     /*  71773 */ GIM_Reject,
     /*  71774 */ // Label 841: @71774
     /*  71774 */ GIM_Reject,
     /*  71775 */ // Label 11: @71775
     /*  71775 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 854*/ GIMT_Encode4(72102),
     /*  71786 */ /*GILLT_s16*//*Label 851*/ GIMT_Encode4(71798),
     /*  71790 */ /*GILLT_s32*//*Label 852*/ GIMT_Encode4(71972),
     /*  71794 */ /*GILLT_s64*//*Label 853*/ GIMT_Encode4(72052),
     /*  71798 */ // Label 851: @71798
     /*  71798 */ GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(71971),
     /*  71803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  71806 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(71833), // Rule ID 40 //
     /*  71811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /*  71814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  71818 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13774),
     /*  71822 */     // (froundeven:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13774>>  =>  (S_RNDNE_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
     /*  71822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_RNDNE_F16),
     /*  71827 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /*  71831 */     GIR_RootConstrainSelectedInstOperands,
     /*  71832 */     // GIR_Coverage, 40,
     /*  71832 */     GIR_Done,
     /*  71833 */   // Label 856: @71833
     /*  71833 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(71879), // Rule ID 774 //
     /*  71838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /*  71841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  71852 */     // (froundeven:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  71852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F16_e64),
     /*  71855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  71872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  71877 */     GIR_RootConstrainSelectedInstOperands,
     /*  71878 */     // GIR_Coverage, 774,
     /*  71878 */     GIR_EraseRootFromParent_Done,
     /*  71879 */   // Label 857: @71879
     /*  71879 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(71925), // Rule ID 776 //
     /*  71884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  71887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  71891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  71898 */     // (froundeven:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  71898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F16_fake16_e64),
     /*  71901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  71918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  71923 */     GIR_RootConstrainSelectedInstOperands,
     /*  71924 */     // GIR_Coverage, 776,
     /*  71924 */     GIR_EraseRootFromParent_Done,
     /*  71925 */   // Label 858: @71925
     /*  71925 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(71970), // Rule ID 775 //
     /*  71930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  71933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  71937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  71944 */     // (froundeven:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_RNDNE_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /*  71944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F16_t16_e64),
     /*  71947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  71949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  71954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  71959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  71968 */     GIR_RootConstrainSelectedInstOperands,
     /*  71969 */     // GIR_Coverage, 775,
     /*  71969 */     GIR_EraseRootFromParent_Done,
     /*  71970 */   // Label 859: @71970
     /*  71970 */   GIM_Reject,
     /*  71971 */ // Label 855: @71971
     /*  71971 */ GIM_Reject,
     /*  71972 */ // Label 852: @71972
     /*  71972 */ GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(72051),
     /*  71977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  71980 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(72007), // Rule ID 35 //
     /*  71985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /*  71988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  71992 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13774),
     /*  71996 */     // (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13774>>  =>  (S_RNDNE_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
     /*  71996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_RNDNE_F32),
     /*  72001 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /*  72005 */     GIR_RootConstrainSelectedInstOperands,
     /*  72006 */     // GIR_Coverage, 35,
     /*  72006 */     GIR_Done,
     /*  72007 */   // Label 861: @72007
     /*  72007 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(72050), // Rule ID 659 //
     /*  72012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  72016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  72023 */     // (froundeven:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  72023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F32_e64),
     /*  72026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  72028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  72033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  72038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  72043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  72048 */     GIR_RootConstrainSelectedInstOperands,
     /*  72049 */     // GIR_Coverage, 659,
     /*  72049 */     GIR_EraseRootFromParent_Done,
     /*  72050 */   // Label 862: @72050
     /*  72050 */   GIM_Reject,
     /*  72051 */ // Label 860: @72051
     /*  72051 */ GIM_Reject,
     /*  72052 */ // Label 853: @72052
     /*  72052 */ GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(72101), // Rule ID 703 //
     /*  72057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
     /*  72060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  72063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  72067 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  72074 */   // (froundeven:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  72074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F64_e64),
     /*  72077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  72079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  72084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  72089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  72094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  72099 */   GIR_RootConstrainSelectedInstOperands,
     /*  72100 */   // GIR_Coverage, 703,
     /*  72100 */   GIR_EraseRootFromParent_Done,
     /*  72101 */ // Label 863: @72101
     /*  72101 */ GIM_Reject,
     /*  72102 */ // Label 854: @72102
     /*  72102 */ GIM_Reject,
     /*  72103 */ // Label 12: @72103
     /*  72103 */ GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(72242),
     /*  72108 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72111 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(72136), // Rule ID 1342 //
     /*  72116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShaderCyclesHiLoRegisters),
     /*  72119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  72123 */     // (readcyclecounter:{ *:[i64] })  =>  (GET_SHADERCYCLESHILO:{ *:[i64] }:{ *:[i1] })
     /*  72123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::GET_SHADERCYCLESHILO),
     /*  72128 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  72134 */     GIR_RootConstrainSelectedInstOperands,
     /*  72135 */     // GIR_Coverage, 1342,
     /*  72135 */     GIR_Done,
     /*  72136 */   // Label 865: @72136
     /*  72136 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(72155), // Rule ID 3525 //
     /*  72141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemTimeInst),
     /*  72144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72148 */     // (readcyclecounter:{ *:[i64] })  =>  (S_MEMTIME:{ *:[i64] })
     /*  72148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMTIME),
     /*  72153 */     GIR_RootConstrainSelectedInstOperands,
     /*  72154 */     // GIR_Coverage, 3525,
     /*  72154 */     GIR_Done,
     /*  72155 */   // Label 866: @72155
     /*  72155 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(72241), // Rule ID 3526 //
     /*  72160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShaderCyclesRegister),
     /*  72163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  72167 */     // (readcyclecounter:{ *:[i64] })  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (S_GETREG_B32:{ *:[i1] } 38941:{ *:[i32] }), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /*  72167 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  72170 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  72174 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72179 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /*  72182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  72184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  72187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
     /*  72191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72196 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(38941),
     /*  72206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  72208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  72211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  72216 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  72219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  72222 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  72225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  72230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  72235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  72240 */     // GIR_Coverage, 3526,
     /*  72240 */     GIR_EraseRootFromParent_Done,
     /*  72241 */   // Label 867: @72241
     /*  72241 */   GIM_Reject,
     /*  72242 */ // Label 864: @72242
     /*  72242 */ GIM_Reject,
     /*  72243 */ // Label 13: @72243
     /*  72243 */ GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(72300),
     /*  72248 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72251 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(72270), // Rule ID 3527 //
     /*  72256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemRealTime),
     /*  72259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72263 */     // (readsteadycounter:{ *:[i64] })  =>  (S_MEMREALTIME:{ *:[i64] })
     /*  72263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMREALTIME),
     /*  72268 */     GIR_RootConstrainSelectedInstOperands,
     /*  72269 */     // GIR_Coverage, 3527,
     /*  72269 */     GIR_Done,
     /*  72270 */   // Label 869: @72270
     /*  72270 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(72299), // Rule ID 3528 //
     /*  72275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  72278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  72282 */     // (readsteadycounter:{ *:[i64] })  =>  (S_SENDMSG_RTN_B64:{ *:[i64] } 131:{ *:[i32] })
     /*  72282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG_RTN_B64),
     /*  72285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72287 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
     /*  72297 */     GIR_RootConstrainSelectedInstOperands,
     /*  72298 */     // GIR_Coverage, 3528,
     /*  72298 */     GIR_EraseRootFromParent_Done,
     /*  72299 */   // Label 870: @72299
     /*  72299 */   GIM_Reject,
     /*  72300 */ // Label 868: @72300
     /*  72300 */ GIM_Reject,
     /*  72301 */ // Label 14: @72301
     /*  72301 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(33), /*)*//*default:*//*Label 895*/ GIMT_Encode4(139792),
     /*  72312 */ /*GILLT_p0s64*//*Label 871*/ GIMT_Encode4(72444),
     /*  72316 */ /*GILLT_p1s64*//*Label 872*/ GIMT_Encode4(74348),
     /*  72320 */ /*GILLT_p2s32*//*Label 873*/ GIMT_Encode4(76252),
     /*  72324 */ /*GILLT_p3s32*//*Label 874*/ GIMT_Encode4(77879),
     /*  72328 */ /*GILLT_p4s64*//*Label 875*/ GIMT_Encode4(79506),
     /*  72332 */ /*GILLT_p5s32*//*Label 876*/ GIMT_Encode4(81410),
     /*  72336 */ /*GILLT_p6s32*//*Label 877*/ GIMT_Encode4(83037),
     /*  72340 */ /*GILLT_s1*//*Label 878*/ GIMT_Encode4(84664),
     /*  72344 */ /*GILLT_s16*//*Label 879*/ GIMT_Encode4(85264),
     /*  72348 */ /*GILLT_s32*//*Label 880*/ GIMT_Encode4(90509),
     /*  72352 */ /*GILLT_s64*//*Label 881*/ GIMT_Encode4(98537),
     /*  72356 */ /*GILLT_v2s16*//*Label 882*/ GIMT_Encode4(103927),
     /*  72360 */ /*GILLT_v2s32*//*Label 883*/ GIMT_Encode4(107171),
     /*  72364 */ /*GILLT_v2s64*//*Label 884*/ GIMT_Encode4(111219),
     /*  72368 */ /*GILLT_v3s32*//*Label 885*/ GIMT_Encode4(115017), GIMT_Encode4(0),
     /*  72376 */ /*GILLT_v4s16*//*Label 886*/ GIMT_Encode4(118236),
     /*  72380 */ /*GILLT_v4s32*//*Label 887*/ GIMT_Encode4(122034),
     /*  72384 */ /*GILLT_v4s64*//*Label 888*/ GIMT_Encode4(126082), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  72400 */ /*GILLT_v8s16*//*Label 889*/ GIMT_Encode4(127734),
     /*  72404 */ /*GILLT_v8s32*//*Label 890*/ GIMT_Encode4(131532),
     /*  72408 */ /*GILLT_v8s64*//*Label 891*/ GIMT_Encode4(133184), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  72428 */ /*GILLT_v16s16*//*Label 892*/ GIMT_Encode4(134836),
     /*  72432 */ /*GILLT_v16s32*//*Label 893*/ GIMT_Encode4(136488), GIMT_Encode4(0),
     /*  72440 */ /*GILLT_v32s16*//*Label 894*/ GIMT_Encode4(138140),
     /*  72444 */ // Label 871: @72444
     /*  72444 */ GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(74347),
     /*  72449 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72452 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(72516), // Rule ID 8353 //
     /*  72457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  72460 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  72480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  72487 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  72487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  72490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  72502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  72507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72514 */     GIR_RootConstrainSelectedInstOperands,
     /*  72515 */     // GIR_Coverage, 8353,
     /*  72515 */     GIR_EraseRootFromParent_Done,
     /*  72516 */   // Label 897: @72516
     /*  72516 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(72576), // Rule ID 8358 //
     /*  72521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  72524 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  72547 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  72547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  72550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  72562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  72567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72574 */     GIR_RootConstrainSelectedInstOperands,
     /*  72575 */     // GIR_Coverage, 8358,
     /*  72575 */     GIR_EraseRootFromParent_Done,
     /*  72576 */   // Label 898: @72576
     /*  72576 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(72636), // Rule ID 8364 //
     /*  72581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  72584 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72596 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  72607 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  72607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  72610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  72622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  72627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72634 */     GIR_RootConstrainSelectedInstOperands,
     /*  72635 */     // GIR_Coverage, 8364,
     /*  72635 */     GIR_EraseRootFromParent_Done,
     /*  72636 */   // Label 899: @72636
     /*  72636 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(72695), // Rule ID 8349 //
     /*  72641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  72644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72660 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  72664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  72671 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  72671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  72674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  72686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72693 */     GIR_RootConstrainSelectedInstOperands,
     /*  72694 */     // GIR_Coverage, 8349,
     /*  72694 */     GIR_EraseRootFromParent_Done,
     /*  72695 */   // Label 900: @72695
     /*  72695 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(72754), // Rule ID 8350 //
     /*  72700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  72703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  72723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  72730 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  72730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  72733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  72745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72752 */     GIR_RootConstrainSelectedInstOperands,
     /*  72753 */     // GIR_Coverage, 8350,
     /*  72753 */     GIR_EraseRootFromParent_Done,
     /*  72754 */   // Label 901: @72754
     /*  72754 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(72813), // Rule ID 8351 //
     /*  72759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  72762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72778 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  72782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  72789 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  72789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  72792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  72804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72811 */     GIR_RootConstrainSelectedInstOperands,
     /*  72812 */     // GIR_Coverage, 8351,
     /*  72812 */     GIR_EraseRootFromParent_Done,
     /*  72813 */   // Label 902: @72813
     /*  72813 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(72875), // Rule ID 8352 //
     /*  72818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  72821 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72833 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  72841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  72848 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  72848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  72851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  72863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72873 */     GIR_RootConstrainSelectedInstOperands,
     /*  72874 */     // GIR_Coverage, 8352,
     /*  72874 */     GIR_EraseRootFromParent_Done,
     /*  72875 */   // Label 903: @72875
     /*  72875 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(72930), // Rule ID 8355 //
     /*  72880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  72883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72895 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  72906 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  72906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  72909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  72921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72928 */     GIR_RootConstrainSelectedInstOperands,
     /*  72929 */     // GIR_Coverage, 8355,
     /*  72929 */     GIR_EraseRootFromParent_Done,
     /*  72930 */   // Label 904: @72930
     /*  72930 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(72985), // Rule ID 8356 //
     /*  72935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  72938 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  72946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  72950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  72954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  72961 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  72961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /*  72964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  72966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  72971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  72976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  72983 */     GIR_RootConstrainSelectedInstOperands,
     /*  72984 */     // GIR_Coverage, 8356,
     /*  72984 */     GIR_EraseRootFromParent_Done,
     /*  72985 */   // Label 905: @72985
     /*  72985 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(73043), // Rule ID 8357 //
     /*  72990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  72993 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73005 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  73016 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  73016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  73019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  73031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73041 */     GIR_RootConstrainSelectedInstOperands,
     /*  73042 */     // GIR_Coverage, 8357,
     /*  73042 */     GIR_EraseRootFromParent_Done,
     /*  73043 */   // Label 906: @73043
     /*  73043 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(73108), // Rule ID 8076 //
     /*  73048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /*  73051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73055 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  73060 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  73065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73073 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /*  73077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  73084 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  73084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  73087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  73094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73106 */     GIR_RootConstrainSelectedInstOperands,
     /*  73107 */     // GIR_Coverage, 8076,
     /*  73107 */     GIR_EraseRootFromParent_Done,
     /*  73108 */   // Label 907: @73108
     /*  73108 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(73168), // Rule ID 8008 //
     /*  73113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  73116 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73120 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  73125 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  73129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  73144 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  73144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  73147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  73154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73166 */     GIR_RootConstrainSelectedInstOperands,
     /*  73167 */     // GIR_Coverage, 8008,
     /*  73167 */     GIR_EraseRootFromParent_Done,
     /*  73168 */   // Label 908: @73168
     /*  73168 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(73220), // Rule ID 8360 //
     /*  73173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73185 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  73196 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  73196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  73199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73218 */     GIR_RootConstrainSelectedInstOperands,
     /*  73219 */     // GIR_Coverage, 8360,
     /*  73219 */     GIR_EraseRootFromParent_Done,
     /*  73220 */   // Label 909: @73220
     /*  73220 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(73275), // Rule ID 8361 //
     /*  73225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  73228 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73240 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  73251 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  73251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  73254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73273 */     GIR_RootConstrainSelectedInstOperands,
     /*  73274 */     // GIR_Coverage, 8361,
     /*  73274 */     GIR_EraseRootFromParent_Done,
     /*  73275 */   // Label 910: @73275
     /*  73275 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(73330), // Rule ID 8362 //
     /*  73280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  73283 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73295 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  73306 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  73306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  73309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  73321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73328 */     GIR_RootConstrainSelectedInstOperands,
     /*  73329 */     // GIR_Coverage, 8362,
     /*  73329 */     GIR_EraseRootFromParent_Done,
     /*  73330 */   // Label 911: @73330
     /*  73330 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(73388), // Rule ID 8363 //
     /*  73335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  73338 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  73361 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  73361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  73364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  73371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  73376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73386 */     GIR_RootConstrainSelectedInstOperands,
     /*  73387 */     // GIR_Coverage, 8363,
     /*  73387 */     GIR_EraseRootFromParent_Done,
     /*  73388 */   // Label 912: @73388
     /*  73388 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(73449), // Rule ID 8077 //
     /*  73393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /*  73396 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  73401 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  73406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /*  73418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  73425 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  73425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  73428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  73435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73447 */     GIR_RootConstrainSelectedInstOperands,
     /*  73448 */     // GIR_Coverage, 8077,
     /*  73448 */     GIR_EraseRootFromParent_Done,
     /*  73449 */   // Label 913: @73449
     /*  73449 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(73505), // Rule ID 8009 //
     /*  73454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  73457 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  73462 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  73466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  73481 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  73481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  73484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  73491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73503 */     GIR_RootConstrainSelectedInstOperands,
     /*  73504 */     // GIR_Coverage, 8009,
     /*  73504 */     GIR_EraseRootFromParent_Done,
     /*  73505 */   // Label 914: @73505
     /*  73505 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(73556), // Rule ID 8354 //
     /*  73510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  73513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73521 */     // MIs[0] sbase
     /*  73521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  73525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  73529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73533 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  73537 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  73537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  73540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73542 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  73544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73554 */     GIR_RootConstrainSelectedInstOperands,
     /*  73555 */     // GIR_Coverage, 8354,
     /*  73555 */     GIR_EraseRootFromParent_Done,
     /*  73556 */   // Label 915: @73556
     /*  73556 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(73603), // Rule ID 8359 //
     /*  73561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  73564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73572 */     // MIs[0] sbase
     /*  73572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  73576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  73580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73584 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  73584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  73587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73589 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  73591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73601 */     GIR_RootConstrainSelectedInstOperands,
     /*  73602 */     // GIR_Coverage, 8359,
     /*  73602 */     GIR_EraseRootFromParent_Done,
     /*  73603 */   // Label 916: @73603
     /*  73603 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(73647), // Rule ID 8365 //
     /*  73608 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  73616 */     // MIs[0] sbase
     /*  73616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  73620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  73624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  73628 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  73628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  73631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  73633 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  73635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73645 */     GIR_RootConstrainSelectedInstOperands,
     /*  73646 */     // GIR_Coverage, 8365,
     /*  73646 */     GIR_EraseRootFromParent_Done,
     /*  73647 */   // Label 917: @73647
     /*  73647 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(73704), // Rule ID 4329 //
     /*  73652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  73655 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  73660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  73675 */     // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  73675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /*  73678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  73685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  73690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  73695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73702 */     GIR_RootConstrainSelectedInstOperands,
     /*  73703 */     // GIR_Coverage, 4329,
     /*  73703 */     GIR_EraseRootFromParent_Done,
     /*  73704 */   // Label 918: @73704
     /*  73704 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(73756), // Rule ID 4328 //
     /*  73709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  73712 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  73717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  73732 */     // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  73732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /*  73735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  73742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73754 */     GIR_RootConstrainSelectedInstOperands,
     /*  73755 */     // GIR_Coverage, 4328,
     /*  73755 */     GIR_EraseRootFromParent_Done,
     /*  73756 */   // Label 919: @73756
     /*  73756 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(73808), // Rule ID 4327 //
     /*  73761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  73764 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  73769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  73784 */     // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  73784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /*  73787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  73794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  73799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73806 */     GIR_RootConstrainSelectedInstOperands,
     /*  73807 */     // GIR_Coverage, 4327,
     /*  73807 */     GIR_EraseRootFromParent_Done,
     /*  73808 */   // Label 920: @73808
     /*  73808 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(73875), // Rule ID 4551 //
     /*  73813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  73816 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  73823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  73838 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  73838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /*  73841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  73843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  73848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  73853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  73858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  73863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73873 */     GIR_RootConstrainSelectedInstOperands,
     /*  73874 */     // GIR_Coverage, 4551,
     /*  73874 */     GIR_EraseRootFromParent_Done,
     /*  73875 */   // Label 921: @73875
     /*  73875 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(73939), // Rule ID 4553 //
     /*  73880 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  73887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  73902 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  73902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /*  73905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  73907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  73912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  73917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  73922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  73927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73937 */     GIR_RootConstrainSelectedInstOperands,
     /*  73938 */     // GIR_Coverage, 4553,
     /*  73938 */     GIR_EraseRootFromParent_Done,
     /*  73939 */   // Label 922: @73939
     /*  73939 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(74000), // Rule ID 7952 //
     /*  73944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /*  73947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73951 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  73956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  73960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  73964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  73971 */     // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  73971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /*  73974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  73976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  73981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  73986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  73991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  73998 */     GIR_RootConstrainSelectedInstOperands,
     /*  73999 */     // GIR_Coverage, 7952,
     /*  73999 */     GIR_EraseRootFromParent_Done,
     /*  74000 */   // Label 923: @74000
     /*  74000 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(74062), // Rule ID 4550 //
     /*  74005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  74008 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  74015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  74030 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  74030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /*  74033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  74035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  74040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  74050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74060 */     GIR_RootConstrainSelectedInstOperands,
     /*  74061 */     // GIR_Coverage, 4550,
     /*  74061 */     GIR_EraseRootFromParent_Done,
     /*  74062 */   // Label 924: @74062
     /*  74062 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(74121), // Rule ID 4552 //
     /*  74067 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  74074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  74089 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  74089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /*  74092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  74094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  74099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  74109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74119 */     GIR_RootConstrainSelectedInstOperands,
     /*  74120 */     // GIR_Coverage, 4552,
     /*  74120 */     GIR_EraseRootFromParent_Done,
     /*  74121 */   // Label 925: @74121
     /*  74121 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(74178), // Rule ID 7954 //
     /*  74126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  74129 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  74134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  74149 */     // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  74149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /*  74152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  74159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  74164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  74169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74176 */     GIR_RootConstrainSelectedInstOperands,
     /*  74177 */     // GIR_Coverage, 7954,
     /*  74177 */     GIR_EraseRootFromParent_Done,
     /*  74178 */   // Label 926: @74178
     /*  74178 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(74237), // Rule ID 3916 //
     /*  74183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  74186 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  74193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  74208 */     // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  74208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /*  74211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  74218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  74223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  74228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74235 */     GIR_RootConstrainSelectedInstOperands,
     /*  74236 */     // GIR_Coverage, 3916,
     /*  74236 */     GIR_EraseRootFromParent_Done,
     /*  74237 */   // Label 927: @74237
     /*  74237 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(74291), // Rule ID 3915 //
     /*  74242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  74245 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  74252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  74267 */     // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  74267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /*  74270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  74277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  74282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74289 */     GIR_RootConstrainSelectedInstOperands,
     /*  74290 */     // GIR_Coverage, 3915,
     /*  74290 */     GIR_EraseRootFromParent_Done,
     /*  74291 */   // Label 928: @74291
     /*  74291 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(74346), // Rule ID 3641 //
     /*  74296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  74299 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  74307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  74322 */     // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  74322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /*  74325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  74332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  74337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74344 */     GIR_RootConstrainSelectedInstOperands,
     /*  74345 */     // GIR_Coverage, 3641,
     /*  74345 */     GIR_EraseRootFromParent_Done,
     /*  74346 */   // Label 929: @74346
     /*  74346 */   GIM_Reject,
     /*  74347 */ // Label 896: @74347
     /*  74347 */ GIM_Reject,
     /*  74348 */ // Label 872: @74348
     /*  74348 */ GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(76251),
     /*  74353 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74356 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(74420), // Rule ID 8370 //
     /*  74361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  74364 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74376 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  74384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  74391 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  74391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  74394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  74411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74418 */     GIR_RootConstrainSelectedInstOperands,
     /*  74419 */     // GIR_Coverage, 8370,
     /*  74419 */     GIR_EraseRootFromParent_Done,
     /*  74420 */   // Label 931: @74420
     /*  74420 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(74480), // Rule ID 8375 //
     /*  74425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  74428 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  74451 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  74451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  74454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  74471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74478 */     GIR_RootConstrainSelectedInstOperands,
     /*  74479 */     // GIR_Coverage, 8375,
     /*  74479 */     GIR_EraseRootFromParent_Done,
     /*  74480 */   // Label 932: @74480
     /*  74480 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(74540), // Rule ID 8381 //
     /*  74485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  74488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74500 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  74511 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  74511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  74514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  74531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74538 */     GIR_RootConstrainSelectedInstOperands,
     /*  74539 */     // GIR_Coverage, 8381,
     /*  74539 */     GIR_EraseRootFromParent_Done,
     /*  74540 */   // Label 933: @74540
     /*  74540 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(74599), // Rule ID 8366 //
     /*  74545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  74548 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  74568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  74575 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  74575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  74578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  74590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74597 */     GIR_RootConstrainSelectedInstOperands,
     /*  74598 */     // GIR_Coverage, 8366,
     /*  74598 */     GIR_EraseRootFromParent_Done,
     /*  74599 */   // Label 934: @74599
     /*  74599 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(74658), // Rule ID 8367 //
     /*  74604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  74607 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74623 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  74627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  74634 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  74634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  74637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  74649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74656 */     GIR_RootConstrainSelectedInstOperands,
     /*  74657 */     // GIR_Coverage, 8367,
     /*  74657 */     GIR_EraseRootFromParent_Done,
     /*  74658 */   // Label 935: @74658
     /*  74658 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(74717), // Rule ID 8368 //
     /*  74663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  74666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74682 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  74686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  74693 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  74693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  74696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74715 */     GIR_RootConstrainSelectedInstOperands,
     /*  74716 */     // GIR_Coverage, 8368,
     /*  74716 */     GIR_EraseRootFromParent_Done,
     /*  74717 */   // Label 936: @74717
     /*  74717 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(74779), // Rule ID 8369 //
     /*  74722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  74725 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74737 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  74745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  74752 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  74752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  74755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74777 */     GIR_RootConstrainSelectedInstOperands,
     /*  74778 */     // GIR_Coverage, 8369,
     /*  74778 */     GIR_EraseRootFromParent_Done,
     /*  74779 */   // Label 937: @74779
     /*  74779 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(74834), // Rule ID 8372 //
     /*  74784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  74787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  74810 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  74810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  74813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  74825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74832 */     GIR_RootConstrainSelectedInstOperands,
     /*  74833 */     // GIR_Coverage, 8372,
     /*  74833 */     GIR_EraseRootFromParent_Done,
     /*  74834 */   // Label 938: @74834
     /*  74834 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(74889), // Rule ID 8373 //
     /*  74839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  74842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  74865 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  74865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /*  74868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74887 */     GIR_RootConstrainSelectedInstOperands,
     /*  74888 */     // GIR_Coverage, 8373,
     /*  74888 */     GIR_EraseRootFromParent_Done,
     /*  74889 */   // Label 939: @74889
     /*  74889 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(74947), // Rule ID 8374 //
     /*  74894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  74897 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  74905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74909 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  74913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  74920 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  74920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  74923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  74925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  74930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  74935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  74945 */     GIR_RootConstrainSelectedInstOperands,
     /*  74946 */     // GIR_Coverage, 8374,
     /*  74946 */     GIR_EraseRootFromParent_Done,
     /*  74947 */   // Label 940: @74947
     /*  74947 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(75012), // Rule ID 8080 //
     /*  74952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /*  74955 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74959 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  74964 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  74969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  74973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  74977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /*  74981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  74988 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  74988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  74991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  74998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75010 */     GIR_RootConstrainSelectedInstOperands,
     /*  75011 */     // GIR_Coverage, 8080,
     /*  75011 */     GIR_EraseRootFromParent_Done,
     /*  75012 */   // Label 941: @75012
     /*  75012 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(75072), // Rule ID 8012 //
     /*  75017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  75020 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75024 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  75029 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  75033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  75048 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  75048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  75051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  75058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75070 */     GIR_RootConstrainSelectedInstOperands,
     /*  75071 */     // GIR_Coverage, 8012,
     /*  75071 */     GIR_EraseRootFromParent_Done,
     /*  75072 */   // Label 942: @75072
     /*  75072 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(75124), // Rule ID 8377 //
     /*  75077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  75100 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  75100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  75103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  75110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75122 */     GIR_RootConstrainSelectedInstOperands,
     /*  75123 */     // GIR_Coverage, 8377,
     /*  75123 */     GIR_EraseRootFromParent_Done,
     /*  75124 */   // Label 943: @75124
     /*  75124 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(75179), // Rule ID 8378 //
     /*  75129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  75132 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75144 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  75155 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  75155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  75158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  75165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75177 */     GIR_RootConstrainSelectedInstOperands,
     /*  75178 */     // GIR_Coverage, 8378,
     /*  75178 */     GIR_EraseRootFromParent_Done,
     /*  75179 */   // Label 944: @75179
     /*  75179 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(75234), // Rule ID 8379 //
     /*  75184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  75187 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75199 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  75210 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  75210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  75213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  75220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  75225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75232 */     GIR_RootConstrainSelectedInstOperands,
     /*  75233 */     // GIR_Coverage, 8379,
     /*  75233 */     GIR_EraseRootFromParent_Done,
     /*  75234 */   // Label 945: @75234
     /*  75234 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(75292), // Rule ID 8380 //
     /*  75239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  75242 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  75265 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  75265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  75268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  75275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  75280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75290 */     GIR_RootConstrainSelectedInstOperands,
     /*  75291 */     // GIR_Coverage, 8380,
     /*  75291 */     GIR_EraseRootFromParent_Done,
     /*  75292 */   // Label 946: @75292
     /*  75292 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(75353), // Rule ID 8081 //
     /*  75297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /*  75300 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  75305 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  75310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75318 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /*  75322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  75329 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  75329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  75332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  75339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75351 */     GIR_RootConstrainSelectedInstOperands,
     /*  75352 */     // GIR_Coverage, 8081,
     /*  75352 */     GIR_EraseRootFromParent_Done,
     /*  75353 */   // Label 947: @75353
     /*  75353 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(75409), // Rule ID 8013 //
     /*  75358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  75361 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  75366 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  75370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  75385 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  75385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  75388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  75395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75407 */     GIR_RootConstrainSelectedInstOperands,
     /*  75408 */     // GIR_Coverage, 8013,
     /*  75408 */     GIR_EraseRootFromParent_Done,
     /*  75409 */   // Label 948: @75409
     /*  75409 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(75460), // Rule ID 8371 //
     /*  75414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  75417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75425 */     // MIs[0] sbase
     /*  75425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  75429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  75433 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  75441 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  75441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  75444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75446 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  75448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75458 */     GIR_RootConstrainSelectedInstOperands,
     /*  75459 */     // GIR_Coverage, 8371,
     /*  75459 */     GIR_EraseRootFromParent_Done,
     /*  75460 */   // Label 949: @75460
     /*  75460 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(75507), // Rule ID 8376 //
     /*  75465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  75468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75476 */     // MIs[0] sbase
     /*  75476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  75480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  75484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75488 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  75488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  75491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75493 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  75495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75505 */     GIR_RootConstrainSelectedInstOperands,
     /*  75506 */     // GIR_Coverage, 8376,
     /*  75506 */     GIR_EraseRootFromParent_Done,
     /*  75507 */   // Label 950: @75507
     /*  75507 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(75551), // Rule ID 8382 //
     /*  75512 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75520 */     // MIs[0] sbase
     /*  75520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  75524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  75528 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  75532 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  75532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  75535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75537 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  75539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75549 */     GIR_RootConstrainSelectedInstOperands,
     /*  75550 */     // GIR_Coverage, 8382,
     /*  75550 */     GIR_EraseRootFromParent_Done,
     /*  75551 */   // Label 951: @75551
     /*  75551 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(75608), // Rule ID 4335 //
     /*  75556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  75559 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  75564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  75579 */     // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  75579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /*  75582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  75589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  75594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  75599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75606 */     GIR_RootConstrainSelectedInstOperands,
     /*  75607 */     // GIR_Coverage, 4335,
     /*  75607 */     GIR_EraseRootFromParent_Done,
     /*  75608 */   // Label 952: @75608
     /*  75608 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(75660), // Rule ID 4334 //
     /*  75613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  75616 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  75621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  75636 */     // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  75636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /*  75639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  75646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75658 */     GIR_RootConstrainSelectedInstOperands,
     /*  75659 */     // GIR_Coverage, 4334,
     /*  75659 */     GIR_EraseRootFromParent_Done,
     /*  75660 */   // Label 953: @75660
     /*  75660 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(75712), // Rule ID 4333 //
     /*  75665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  75668 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  75673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  75688 */     // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  75688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /*  75691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  75698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  75703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75710 */     GIR_RootConstrainSelectedInstOperands,
     /*  75711 */     // GIR_Coverage, 4333,
     /*  75711 */     GIR_EraseRootFromParent_Done,
     /*  75712 */   // Label 954: @75712
     /*  75712 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(75779), // Rule ID 4555 //
     /*  75717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  75720 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  75727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  75742 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  75742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /*  75745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  75747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  75752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  75757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  75762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  75767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75777 */     GIR_RootConstrainSelectedInstOperands,
     /*  75778 */     // GIR_Coverage, 4555,
     /*  75778 */     GIR_EraseRootFromParent_Done,
     /*  75779 */   // Label 955: @75779
     /*  75779 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(75843), // Rule ID 4557 //
     /*  75784 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  75791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  75806 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  75806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /*  75809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  75811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  75816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  75821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  75826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  75831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75841 */     GIR_RootConstrainSelectedInstOperands,
     /*  75842 */     // GIR_Coverage, 4557,
     /*  75842 */     GIR_EraseRootFromParent_Done,
     /*  75843 */   // Label 956: @75843
     /*  75843 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(75904), // Rule ID 7956 //
     /*  75848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /*  75851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75855 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  75860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  75875 */     // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  75875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /*  75878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  75885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  75890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  75895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75902 */     GIR_RootConstrainSelectedInstOperands,
     /*  75903 */     // GIR_Coverage, 7956,
     /*  75903 */     GIR_EraseRootFromParent_Done,
     /*  75904 */   // Label 957: @75904
     /*  75904 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(75966), // Rule ID 4554 //
     /*  75909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  75912 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  75919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  75934 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  75934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /*  75937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  75939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  75944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  75949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  75954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75964 */     GIR_RootConstrainSelectedInstOperands,
     /*  75965 */     // GIR_Coverage, 4554,
     /*  75965 */     GIR_EraseRootFromParent_Done,
     /*  75966 */   // Label 958: @75966
     /*  75966 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(76025), // Rule ID 4556 //
     /*  75971 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  75978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  75982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  75993 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  75993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /*  75996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  75998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  76003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  76013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76023 */     GIR_RootConstrainSelectedInstOperands,
     /*  76024 */     // GIR_Coverage, 4556,
     /*  76024 */     GIR_EraseRootFromParent_Done,
     /*  76025 */   // Label 959: @76025
     /*  76025 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(76082), // Rule ID 7958 //
     /*  76030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  76033 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  76038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  76053 */     // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  76053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /*  76056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  76058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  76063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  76068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  76073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76080 */     GIR_RootConstrainSelectedInstOperands,
     /*  76081 */     // GIR_Coverage, 7958,
     /*  76081 */     GIR_EraseRootFromParent_Done,
     /*  76082 */   // Label 960: @76082
     /*  76082 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(76141), // Rule ID 3920 //
     /*  76087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  76090 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  76097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  76112 */     // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /*  76115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  76117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  76122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  76127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  76132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76139 */     GIR_RootConstrainSelectedInstOperands,
     /*  76140 */     // GIR_Coverage, 3920,
     /*  76140 */     GIR_EraseRootFromParent_Done,
     /*  76141 */   // Label 961: @76141
     /*  76141 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(76195), // Rule ID 3919 //
     /*  76146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  76149 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  76156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  76171 */     // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  76171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /*  76174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  76176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  76181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76193 */     GIR_RootConstrainSelectedInstOperands,
     /*  76194 */     // GIR_Coverage, 3919,
     /*  76194 */     GIR_EraseRootFromParent_Done,
     /*  76195 */   // Label 962: @76195
     /*  76195 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(76250), // Rule ID 3643 //
     /*  76200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  76203 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  76211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  76226 */     // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  76226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /*  76229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  76231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  76236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76248 */     GIR_RootConstrainSelectedInstOperands,
     /*  76249 */     // GIR_Coverage, 3643,
     /*  76249 */     GIR_EraseRootFromParent_Done,
     /*  76250 */   // Label 963: @76250
     /*  76250 */   GIM_Reject,
     /*  76251 */ // Label 930: @76251
     /*  76251 */ GIM_Reject,
     /*  76252 */ // Label 873: @76252
     /*  76252 */ GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(77878),
     /*  76257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76260 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(76324), // Rule ID 2978 //
     /*  76265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  76268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76280 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  76295 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  76298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  76315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76322 */     GIR_RootConstrainSelectedInstOperands,
     /*  76323 */     // GIR_Coverage, 2978,
     /*  76323 */     GIR_EraseRootFromParent_Done,
     /*  76324 */   // Label 965: @76324
     /*  76324 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(76384), // Rule ID 2984 //
     /*  76329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  76332 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76344 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  76355 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  76358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  76375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76382 */     GIR_RootConstrainSelectedInstOperands,
     /*  76383 */     // GIR_Coverage, 2984,
     /*  76383 */     GIR_EraseRootFromParent_Done,
     /*  76384 */   // Label 966: @76384
     /*  76384 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(76443), // Rule ID 2974 //
     /*  76389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  76392 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  76419 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  76422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76441 */     GIR_RootConstrainSelectedInstOperands,
     /*  76442 */     // GIR_Coverage, 2974,
     /*  76442 */     GIR_EraseRootFromParent_Done,
     /*  76443 */   // Label 967: @76443
     /*  76443 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(76502), // Rule ID 2975 //
     /*  76448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  76451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76467 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  76478 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  76481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76500 */     GIR_RootConstrainSelectedInstOperands,
     /*  76501 */     // GIR_Coverage, 2975,
     /*  76501 */     GIR_EraseRootFromParent_Done,
     /*  76502 */   // Label 968: @76502
     /*  76502 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(76561), // Rule ID 2976 //
     /*  76507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  76510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  76537 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  76537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  76540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76559 */     GIR_RootConstrainSelectedInstOperands,
     /*  76560 */     // GIR_Coverage, 2976,
     /*  76560 */     GIR_EraseRootFromParent_Done,
     /*  76561 */   // Label 969: @76561
     /*  76561 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(76623), // Rule ID 2977 //
     /*  76566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  76569 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  76596 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  76596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  76599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76621 */     GIR_RootConstrainSelectedInstOperands,
     /*  76622 */     // GIR_Coverage, 2977,
     /*  76622 */     GIR_EraseRootFromParent_Done,
     /*  76623 */   // Label 970: @76623
     /*  76623 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(76675), // Rule ID 2980 //
     /*  76628 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  76651 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  76654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76673 */     GIR_RootConstrainSelectedInstOperands,
     /*  76674 */     // GIR_Coverage, 2980,
     /*  76674 */     GIR_EraseRootFromParent_Done,
     /*  76675 */   // Label 971: @76675
     /*  76675 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(76730), // Rule ID 2981 //
     /*  76680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  76683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  76706 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  76709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76728 */     GIR_RootConstrainSelectedInstOperands,
     /*  76729 */     // GIR_Coverage, 2981,
     /*  76729 */     GIR_EraseRootFromParent_Done,
     /*  76730 */   // Label 972: @76730
     /*  76730 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(76785), // Rule ID 2982 //
     /*  76735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  76738 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  76761 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  76761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  76764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76783 */     GIR_RootConstrainSelectedInstOperands,
     /*  76784 */     // GIR_Coverage, 2982,
     /*  76784 */     GIR_EraseRootFromParent_Done,
     /*  76785 */   // Label 973: @76785
     /*  76785 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(76843), // Rule ID 2983 //
     /*  76790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  76793 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  76816 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  76816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  76819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76841 */     GIR_RootConstrainSelectedInstOperands,
     /*  76842 */     // GIR_Coverage, 2983,
     /*  76842 */     GIR_EraseRootFromParent_Done,
     /*  76843 */   // Label 974: @76843
     /*  76843 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(76894), // Rule ID 2979 //
     /*  76848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  76851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76859 */     // MIs[0] sbase
     /*  76859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  76863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  76867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76875 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  76875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  76878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76880 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  76882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76892 */     GIR_RootConstrainSelectedInstOperands,
     /*  76893 */     // GIR_Coverage, 2979,
     /*  76893 */     GIR_EraseRootFromParent_Done,
     /*  76894 */   // Label 975: @76894
     /*  76894 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(76938), // Rule ID 2985 //
     /*  76899 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  76907 */     // MIs[0] sbase
     /*  76907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  76911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  76915 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76919 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  76919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  76922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76924 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  76926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76936 */     GIR_RootConstrainSelectedInstOperands,
     /*  76937 */     // GIR_Coverage, 2985,
     /*  76937 */     GIR_EraseRootFromParent_Done,
     /*  76938 */   // Label 976: @76938
     /*  76938 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(76998), // Rule ID 6495 //
     /*  76943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  76946 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  76951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  76955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  76966 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  76966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  76969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  76971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  76976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  76986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76996 */     GIR_RootConstrainSelectedInstOperands,
     /*  76997 */     // GIR_Coverage, 6495,
     /*  76997 */     GIR_EraseRootFromParent_Done,
     /*  76998 */   // Label 977: @76998
     /*  76998 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(77058), // Rule ID 6497 //
     /*  77003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  77006 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  77026 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  77026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  77029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77056 */     GIR_RootConstrainSelectedInstOperands,
     /*  77057 */     // GIR_Coverage, 6497,
     /*  77057 */     GIR_EraseRootFromParent_Done,
     /*  77058 */   // Label 978: @77058
     /*  77058 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(77115), // Rule ID 4269 //
     /*  77063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  77066 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  77086 */     // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  77086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  77089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  77096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  77101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77113 */     GIR_RootConstrainSelectedInstOperands,
     /*  77114 */     // GIR_Coverage, 4269,
     /*  77114 */     GIR_EraseRootFromParent_Done,
     /*  77115 */   // Label 979: @77115
     /*  77115 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(77167), // Rule ID 4268 //
     /*  77120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  77123 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  77143 */     // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  77143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  77146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  77153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77165 */     GIR_RootConstrainSelectedInstOperands,
     /*  77166 */     // GIR_Coverage, 4268,
     /*  77166 */     GIR_EraseRootFromParent_Done,
     /*  77167 */   // Label 980: @77167
     /*  77167 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(77219), // Rule ID 4267 //
     /*  77172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  77175 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  77195 */     // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  77195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  77198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  77205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77217 */     GIR_RootConstrainSelectedInstOperands,
     /*  77218 */     // GIR_Coverage, 4267,
     /*  77218 */     GIR_EraseRootFromParent_Done,
     /*  77219 */   // Label 981: @77219
     /*  77219 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(77286), // Rule ID 4511 //
     /*  77224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  77227 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  77249 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  77249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  77252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  77259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  77269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  77274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77284 */     GIR_RootConstrainSelectedInstOperands,
     /*  77285 */     // GIR_Coverage, 4511,
     /*  77285 */     GIR_EraseRootFromParent_Done,
     /*  77286 */   // Label 982: @77286
     /*  77286 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(77350), // Rule ID 4513 //
     /*  77291 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  77313 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  77313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  77316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  77323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  77333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  77338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77348 */     GIR_RootConstrainSelectedInstOperands,
     /*  77349 */     // GIR_Coverage, 4513,
     /*  77349 */     GIR_EraseRootFromParent_Done,
     /*  77350 */   // Label 983: @77350
     /*  77350 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(77415), // Rule ID 6494 //
     /*  77355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  77358 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  77378 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  77378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  77381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  77388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  77398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  77403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77413 */     GIR_RootConstrainSelectedInstOperands,
     /*  77414 */     // GIR_Coverage, 6494,
     /*  77414 */     GIR_EraseRootFromParent_Done,
     /*  77415 */   // Label 984: @77415
     /*  77415 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(77480), // Rule ID 6496 //
     /*  77420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  77423 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  77443 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  77443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  77446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  77453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  77463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  77468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77478 */     GIR_RootConstrainSelectedInstOperands,
     /*  77479 */     // GIR_Coverage, 6496,
     /*  77479 */     GIR_EraseRootFromParent_Done,
     /*  77480 */   // Label 985: @77480
     /*  77480 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(77542), // Rule ID 4510 //
     /*  77485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  77488 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  77510 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  77510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  77513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77540 */     GIR_RootConstrainSelectedInstOperands,
     /*  77541 */     // GIR_Coverage, 4510,
     /*  77541 */     GIR_EraseRootFromParent_Done,
     /*  77542 */   // Label 986: @77542
     /*  77542 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(77601), // Rule ID 4512 //
     /*  77547 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  77569 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  77569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  77572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77599 */     GIR_RootConstrainSelectedInstOperands,
     /*  77600 */     // GIR_Coverage, 4512,
     /*  77600 */     GIR_EraseRootFromParent_Done,
     /*  77601 */   // Label 987: @77601
     /*  77601 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(77657), // Rule ID 7826 //
     /*  77606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  77609 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77613 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  77618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  77633 */     // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  77633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  77636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  77643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77655 */     GIR_RootConstrainSelectedInstOperands,
     /*  77656 */     // GIR_Coverage, 7826,
     /*  77656 */     GIR_EraseRootFromParent_Done,
     /*  77657 */   // Label 988: @77657
     /*  77657 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(77709), // Rule ID 7827 //
     /*  77662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  77665 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  77670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  77685 */     // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  77685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  77688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  77695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77707 */     GIR_RootConstrainSelectedInstOperands,
     /*  77708 */     // GIR_Coverage, 7827,
     /*  77708 */     GIR_EraseRootFromParent_Done,
     /*  77709 */   // Label 989: @77709
     /*  77709 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(77768), // Rule ID 3876 //
     /*  77714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  77717 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  77739 */     // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  77739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  77742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  77749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  77754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77766 */     GIR_RootConstrainSelectedInstOperands,
     /*  77767 */     // GIR_Coverage, 3876,
     /*  77767 */     GIR_EraseRootFromParent_Done,
     /*  77768 */   // Label 990: @77768
     /*  77768 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(77822), // Rule ID 3875 //
     /*  77773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  77776 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  77798 */     // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  77798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  77801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  77808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77820 */     GIR_RootConstrainSelectedInstOperands,
     /*  77821 */     // GIR_Coverage, 3875,
     /*  77821 */     GIR_EraseRootFromParent_Done,
     /*  77822 */   // Label 991: @77822
     /*  77822 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(77877), // Rule ID 3620 //
     /*  77827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  77830 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  77842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  77853 */     // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  77853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  77856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  77863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77875 */     GIR_RootConstrainSelectedInstOperands,
     /*  77876 */     // GIR_Coverage, 3620,
     /*  77876 */     GIR_EraseRootFromParent_Done,
     /*  77877 */   // Label 992: @77877
     /*  77877 */   GIM_Reject,
     /*  77878 */ // Label 964: @77878
     /*  77878 */ GIM_Reject,
     /*  77879 */ // Label 874: @77879
     /*  77879 */ GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(79505),
     /*  77884 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77887 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(77951), // Rule ID 2990 //
     /*  77892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  77895 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  77903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77907 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  77911 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  77915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  77922 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  77922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  77925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  77927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  77932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77949 */     GIR_RootConstrainSelectedInstOperands,
     /*  77950 */     // GIR_Coverage, 2990,
     /*  77950 */     GIR_EraseRootFromParent_Done,
     /*  77951 */   // Label 994: @77951
     /*  77951 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(78011), // Rule ID 2996 //
     /*  77956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  77959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  77967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  77975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  77982 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  77982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  77985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  77987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  77992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  78002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78009 */     GIR_RootConstrainSelectedInstOperands,
     /*  78010 */     // GIR_Coverage, 2996,
     /*  78010 */     GIR_EraseRootFromParent_Done,
     /*  78011 */   // Label 995: @78011
     /*  78011 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(78070), // Rule ID 2986 //
     /*  78016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  78019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  78046 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  78049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78068 */     GIR_RootConstrainSelectedInstOperands,
     /*  78069 */     // GIR_Coverage, 2986,
     /*  78069 */     GIR_EraseRootFromParent_Done,
     /*  78070 */   // Label 996: @78070
     /*  78070 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(78129), // Rule ID 2987 //
     /*  78075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  78078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  78105 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  78108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78127 */     GIR_RootConstrainSelectedInstOperands,
     /*  78128 */     // GIR_Coverage, 2987,
     /*  78128 */     GIR_EraseRootFromParent_Done,
     /*  78129 */   // Label 997: @78129
     /*  78129 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(78188), // Rule ID 2988 //
     /*  78134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  78137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78153 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78164 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  78164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  78167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78186 */     GIR_RootConstrainSelectedInstOperands,
     /*  78187 */     // GIR_Coverage, 2988,
     /*  78187 */     GIR_EraseRootFromParent_Done,
     /*  78188 */   // Label 998: @78188
     /*  78188 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(78250), // Rule ID 2989 //
     /*  78193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  78196 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78212 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78223 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  78223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  78226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78248 */     GIR_RootConstrainSelectedInstOperands,
     /*  78249 */     // GIR_Coverage, 2989,
     /*  78249 */     GIR_EraseRootFromParent_Done,
     /*  78250 */   // Label 999: @78250
     /*  78250 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(78302), // Rule ID 2992 //
     /*  78255 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78267 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  78278 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  78281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78300 */     GIR_RootConstrainSelectedInstOperands,
     /*  78301 */     // GIR_Coverage, 2992,
     /*  78301 */     GIR_EraseRootFromParent_Done,
     /*  78302 */   // Label 1000: @78302
     /*  78302 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(78357), // Rule ID 2993 //
     /*  78307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  78310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  78333 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  78336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78355 */     GIR_RootConstrainSelectedInstOperands,
     /*  78356 */     // GIR_Coverage, 2993,
     /*  78356 */     GIR_EraseRootFromParent_Done,
     /*  78357 */   // Label 1001: @78357
     /*  78357 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(78412), // Rule ID 2994 //
     /*  78362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  78365 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78377 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78388 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  78388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  78391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78410 */     GIR_RootConstrainSelectedInstOperands,
     /*  78411 */     // GIR_Coverage, 2994,
     /*  78411 */     GIR_EraseRootFromParent_Done,
     /*  78412 */   // Label 1002: @78412
     /*  78412 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(78470), // Rule ID 2995 //
     /*  78417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  78420 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78432 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78443 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  78443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  78446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78468 */     GIR_RootConstrainSelectedInstOperands,
     /*  78469 */     // GIR_Coverage, 2995,
     /*  78469 */     GIR_EraseRootFromParent_Done,
     /*  78470 */   // Label 1003: @78470
     /*  78470 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(78521), // Rule ID 2991 //
     /*  78475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  78478 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78486 */     // MIs[0] sbase
     /*  78486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  78490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  78494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78498 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78502 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  78502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  78505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78507 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  78509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78519 */     GIR_RootConstrainSelectedInstOperands,
     /*  78520 */     // GIR_Coverage, 2991,
     /*  78520 */     GIR_EraseRootFromParent_Done,
     /*  78521 */   // Label 1004: @78521
     /*  78521 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(78565), // Rule ID 2997 //
     /*  78526 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  78534 */     // MIs[0] sbase
     /*  78534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  78538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  78542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78546 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  78546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  78549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78551 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  78553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78563 */     GIR_RootConstrainSelectedInstOperands,
     /*  78564 */     // GIR_Coverage, 2997,
     /*  78564 */     GIR_EraseRootFromParent_Done,
     /*  78565 */   // Label 1005: @78565
     /*  78565 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(78625), // Rule ID 6499 //
     /*  78570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  78573 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  78578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  78593 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  78593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  78596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  78598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  78603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  78613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78623 */     GIR_RootConstrainSelectedInstOperands,
     /*  78624 */     // GIR_Coverage, 6499,
     /*  78624 */     GIR_EraseRootFromParent_Done,
     /*  78625 */   // Label 1006: @78625
     /*  78625 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(78685), // Rule ID 6501 //
     /*  78630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  78633 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  78638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  78653 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  78653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  78656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  78658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  78663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  78673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78683 */     GIR_RootConstrainSelectedInstOperands,
     /*  78684 */     // GIR_Coverage, 6501,
     /*  78684 */     GIR_EraseRootFromParent_Done,
     /*  78685 */   // Label 1007: @78685
     /*  78685 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(78742), // Rule ID 4275 //
     /*  78690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  78693 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  78698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  78713 */     // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  78716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  78718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  78723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  78728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  78733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78740 */     GIR_RootConstrainSelectedInstOperands,
     /*  78741 */     // GIR_Coverage, 4275,
     /*  78741 */     GIR_EraseRootFromParent_Done,
     /*  78742 */   // Label 1008: @78742
     /*  78742 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(78794), // Rule ID 4274 //
     /*  78747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  78750 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  78755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  78770 */     // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  78770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  78773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  78775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  78780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78792 */     GIR_RootConstrainSelectedInstOperands,
     /*  78793 */     // GIR_Coverage, 4274,
     /*  78793 */     GIR_EraseRootFromParent_Done,
     /*  78794 */   // Label 1009: @78794
     /*  78794 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(78846), // Rule ID 4273 //
     /*  78799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  78802 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  78807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  78822 */     // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  78822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  78825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  78827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  78832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78844 */     GIR_RootConstrainSelectedInstOperands,
     /*  78845 */     // GIR_Coverage, 4273,
     /*  78845 */     GIR_EraseRootFromParent_Done,
     /*  78846 */   // Label 1010: @78846
     /*  78846 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(78913), // Rule ID 4515 //
     /*  78851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  78854 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  78861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  78876 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  78876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  78879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  78881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  78886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  78891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  78896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  78901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78911 */     GIR_RootConstrainSelectedInstOperands,
     /*  78912 */     // GIR_Coverage, 4515,
     /*  78912 */     GIR_EraseRootFromParent_Done,
     /*  78913 */   // Label 1011: @78913
     /*  78913 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(78977), // Rule ID 4517 //
     /*  78918 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  78925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  78940 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  78940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  78943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  78945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  78950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  78955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  78960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  78965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78975 */     GIR_RootConstrainSelectedInstOperands,
     /*  78976 */     // GIR_Coverage, 4517,
     /*  78976 */     GIR_EraseRootFromParent_Done,
     /*  78977 */   // Label 1012: @78977
     /*  78977 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(79042), // Rule ID 6498 //
     /*  78982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  78985 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  78990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  78994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  79005 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  79005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  79008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  79015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  79025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  79030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79040 */     GIR_RootConstrainSelectedInstOperands,
     /*  79041 */     // GIR_Coverage, 6498,
     /*  79041 */     GIR_EraseRootFromParent_Done,
     /*  79042 */   // Label 1013: @79042
     /*  79042 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(79107), // Rule ID 6500 //
     /*  79047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  79050 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  79055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  79070 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  79070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  79073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  79080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  79090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  79095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79105 */     GIR_RootConstrainSelectedInstOperands,
     /*  79106 */     // GIR_Coverage, 6500,
     /*  79106 */     GIR_EraseRootFromParent_Done,
     /*  79107 */   // Label 1014: @79107
     /*  79107 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(79169), // Rule ID 4514 //
     /*  79112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  79115 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  79137 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  79137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  79140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79167 */     GIR_RootConstrainSelectedInstOperands,
     /*  79168 */     // GIR_Coverage, 4514,
     /*  79168 */     GIR_EraseRootFromParent_Done,
     /*  79169 */   // Label 1015: @79169
     /*  79169 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(79228), // Rule ID 4516 //
     /*  79174 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  79196 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  79196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  79199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79226 */     GIR_RootConstrainSelectedInstOperands,
     /*  79227 */     // GIR_Coverage, 4516,
     /*  79227 */     GIR_EraseRootFromParent_Done,
     /*  79228 */   // Label 1016: @79228
     /*  79228 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(79284), // Rule ID 7828 //
     /*  79233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  79236 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79240 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  79245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  79260 */     // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  79260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  79263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  79270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79282 */     GIR_RootConstrainSelectedInstOperands,
     /*  79283 */     // GIR_Coverage, 7828,
     /*  79283 */     GIR_EraseRootFromParent_Done,
     /*  79284 */   // Label 1017: @79284
     /*  79284 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(79336), // Rule ID 7829 //
     /*  79289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  79292 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  79297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  79312 */     // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  79312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  79315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  79322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79334 */     GIR_RootConstrainSelectedInstOperands,
     /*  79335 */     // GIR_Coverage, 7829,
     /*  79335 */     GIR_EraseRootFromParent_Done,
     /*  79336 */   // Label 1018: @79336
     /*  79336 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(79395), // Rule ID 3880 //
     /*  79341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  79344 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  79366 */     // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  79369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  79376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  79381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79393 */     GIR_RootConstrainSelectedInstOperands,
     /*  79394 */     // GIR_Coverage, 3880,
     /*  79394 */     GIR_EraseRootFromParent_Done,
     /*  79395 */   // Label 1019: @79395
     /*  79395 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(79449), // Rule ID 3879 //
     /*  79400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  79403 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  79425 */     // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  79425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  79428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  79435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79447 */     GIR_RootConstrainSelectedInstOperands,
     /*  79448 */     // GIR_Coverage, 3879,
     /*  79448 */     GIR_EraseRootFromParent_Done,
     /*  79449 */   // Label 1020: @79449
     /*  79449 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(79504), // Rule ID 3622 //
     /*  79454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  79457 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  79469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  79480 */     // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  79480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  79483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  79490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79502 */     GIR_RootConstrainSelectedInstOperands,
     /*  79503 */     // GIR_Coverage, 3622,
     /*  79503 */     GIR_EraseRootFromParent_Done,
     /*  79504 */   // Label 1021: @79504
     /*  79504 */   GIM_Reject,
     /*  79505 */ // Label 993: @79505
     /*  79505 */ GIM_Reject,
     /*  79506 */ // Label 875: @79506
     /*  79506 */ GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(81409),
     /*  79511 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79514 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(79578), // Rule ID 8387 //
     /*  79519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  79522 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79538 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  79542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  79549 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  79552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79576 */     GIR_RootConstrainSelectedInstOperands,
     /*  79577 */     // GIR_Coverage, 8387,
     /*  79577 */     GIR_EraseRootFromParent_Done,
     /*  79578 */   // Label 1023: @79578
     /*  79578 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(79638), // Rule ID 8392 //
     /*  79583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  79586 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79598 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  79609 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  79612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79636 */     GIR_RootConstrainSelectedInstOperands,
     /*  79637 */     // GIR_Coverage, 8392,
     /*  79637 */     GIR_EraseRootFromParent_Done,
     /*  79638 */   // Label 1024: @79638
     /*  79638 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(79698), // Rule ID 8398 //
     /*  79643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  79646 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  79669 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  79672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79696 */     GIR_RootConstrainSelectedInstOperands,
     /*  79697 */     // GIR_Coverage, 8398,
     /*  79697 */     GIR_EraseRootFromParent_Done,
     /*  79698 */   // Label 1025: @79698
     /*  79698 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(79757), // Rule ID 8383 //
     /*  79703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  79706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79718 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79722 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  79726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  79733 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  79736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79755 */     GIR_RootConstrainSelectedInstOperands,
     /*  79756 */     // GIR_Coverage, 8383,
     /*  79756 */     GIR_EraseRootFromParent_Done,
     /*  79757 */   // Label 1026: @79757
     /*  79757 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(79816), // Rule ID 8384 //
     /*  79762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  79765 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79777 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  79785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  79792 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  79795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79814 */     GIR_RootConstrainSelectedInstOperands,
     /*  79815 */     // GIR_Coverage, 8384,
     /*  79815 */     GIR_EraseRootFromParent_Done,
     /*  79816 */   // Label 1027: @79816
     /*  79816 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(79875), // Rule ID 8385 //
     /*  79821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  79824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79836 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79840 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  79844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  79851 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  79851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  79854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79873 */     GIR_RootConstrainSelectedInstOperands,
     /*  79874 */     // GIR_Coverage, 8385,
     /*  79874 */     GIR_EraseRootFromParent_Done,
     /*  79875 */   // Label 1028: @79875
     /*  79875 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(79937), // Rule ID 8386 //
     /*  79880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  79883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79895 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  79903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  79910 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  79910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  79913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79935 */     GIR_RootConstrainSelectedInstOperands,
     /*  79936 */     // GIR_Coverage, 8386,
     /*  79936 */     GIR_EraseRootFromParent_Done,
     /*  79937 */   // Label 1029: @79937
     /*  79937 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(79992), // Rule ID 8389 //
     /*  79942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  79945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  79968 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  79971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79990 */     GIR_RootConstrainSelectedInstOperands,
     /*  79991 */     // GIR_Coverage, 8389,
     /*  79991 */     GIR_EraseRootFromParent_Done,
     /*  79992 */   // Label 1030: @79992
     /*  79992 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(80047), // Rule ID 8390 //
     /*  79997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  80000 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80012 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80023 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  80023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /*  80026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80045 */     GIR_RootConstrainSelectedInstOperands,
     /*  80046 */     // GIR_Coverage, 8390,
     /*  80046 */     GIR_EraseRootFromParent_Done,
     /*  80047 */   // Label 1031: @80047
     /*  80047 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(80105), // Rule ID 8391 //
     /*  80052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  80055 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80067 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80078 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  80081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80103 */     GIR_RootConstrainSelectedInstOperands,
     /*  80104 */     // GIR_Coverage, 8391,
     /*  80104 */     GIR_EraseRootFromParent_Done,
     /*  80105 */   // Label 1032: @80105
     /*  80105 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(80170), // Rule ID 8084 //
     /*  80110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /*  80113 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80117 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  80122 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  80127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80135 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /*  80139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  80146 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  80146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  80149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  80156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80168 */     GIR_RootConstrainSelectedInstOperands,
     /*  80169 */     // GIR_Coverage, 8084,
     /*  80169 */     GIR_EraseRootFromParent_Done,
     /*  80170 */   // Label 1033: @80170
     /*  80170 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(80230), // Rule ID 8016 //
     /*  80175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  80178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80182 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  80187 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  80191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  80206 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  80206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  80209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  80216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80228 */     GIR_RootConstrainSelectedInstOperands,
     /*  80229 */     // GIR_Coverage, 8016,
     /*  80229 */     GIR_EraseRootFromParent_Done,
     /*  80230 */   // Label 1034: @80230
     /*  80230 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(80282), // Rule ID 8394 //
     /*  80235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80247 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  80258 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  80258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  80261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80280 */     GIR_RootConstrainSelectedInstOperands,
     /*  80281 */     // GIR_Coverage, 8394,
     /*  80281 */     GIR_EraseRootFromParent_Done,
     /*  80282 */   // Label 1035: @80282
     /*  80282 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(80337), // Rule ID 8395 //
     /*  80287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  80290 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80302 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  80313 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  80313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  80316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80335 */     GIR_RootConstrainSelectedInstOperands,
     /*  80336 */     // GIR_Coverage, 8395,
     /*  80336 */     GIR_EraseRootFromParent_Done,
     /*  80337 */   // Label 1036: @80337
     /*  80337 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(80392), // Rule ID 8396 //
     /*  80342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  80345 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80357 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80368 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  80368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  80371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80390 */     GIR_RootConstrainSelectedInstOperands,
     /*  80391 */     // GIR_Coverage, 8396,
     /*  80391 */     GIR_EraseRootFromParent_Done,
     /*  80392 */   // Label 1037: @80392
     /*  80392 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(80450), // Rule ID 8397 //
     /*  80397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  80400 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80412 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80423 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  80426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80448 */     GIR_RootConstrainSelectedInstOperands,
     /*  80449 */     // GIR_Coverage, 8397,
     /*  80449 */     GIR_EraseRootFromParent_Done,
     /*  80450 */   // Label 1038: @80450
     /*  80450 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(80511), // Rule ID 8085 //
     /*  80455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /*  80458 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  80463 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  80468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /*  80480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  80487 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  80487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  80490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  80497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80509 */     GIR_RootConstrainSelectedInstOperands,
     /*  80510 */     // GIR_Coverage, 8085,
     /*  80510 */     GIR_EraseRootFromParent_Done,
     /*  80511 */   // Label 1039: @80511
     /*  80511 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(80567), // Rule ID 8017 //
     /*  80516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  80519 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  80524 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  80528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  80543 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  80543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  80546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  80553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80565 */     GIR_RootConstrainSelectedInstOperands,
     /*  80566 */     // GIR_Coverage, 8017,
     /*  80566 */     GIR_EraseRootFromParent_Done,
     /*  80567 */   // Label 1040: @80567
     /*  80567 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(80618), // Rule ID 8388 //
     /*  80572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  80575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80583 */     // MIs[0] sbase
     /*  80583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  80587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  80591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80595 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  80599 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  80602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80604 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  80606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80616 */     GIR_RootConstrainSelectedInstOperands,
     /*  80617 */     // GIR_Coverage, 8388,
     /*  80617 */     GIR_EraseRootFromParent_Done,
     /*  80618 */   // Label 1041: @80618
     /*  80618 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(80665), // Rule ID 8393 //
     /*  80623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  80626 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80634 */     // MIs[0] sbase
     /*  80634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  80638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  80642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80646 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  80649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80651 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  80653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80663 */     GIR_RootConstrainSelectedInstOperands,
     /*  80664 */     // GIR_Coverage, 8393,
     /*  80664 */     GIR_EraseRootFromParent_Done,
     /*  80665 */   // Label 1042: @80665
     /*  80665 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(80709), // Rule ID 8399 //
     /*  80670 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  80678 */     // MIs[0] sbase
     /*  80678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  80682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  80686 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80690 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  80693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80695 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  80697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80707 */     GIR_RootConstrainSelectedInstOperands,
     /*  80708 */     // GIR_Coverage, 8399,
     /*  80708 */     GIR_EraseRootFromParent_Done,
     /*  80709 */   // Label 1043: @80709
     /*  80709 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(80766), // Rule ID 4341 //
     /*  80714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  80717 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  80722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  80737 */     // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  80737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /*  80740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  80747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  80752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  80757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80764 */     GIR_RootConstrainSelectedInstOperands,
     /*  80765 */     // GIR_Coverage, 4341,
     /*  80765 */     GIR_EraseRootFromParent_Done,
     /*  80766 */   // Label 1044: @80766
     /*  80766 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(80818), // Rule ID 4340 //
     /*  80771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  80774 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  80779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  80794 */     // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  80794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /*  80797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  80804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80816 */     GIR_RootConstrainSelectedInstOperands,
     /*  80817 */     // GIR_Coverage, 4340,
     /*  80817 */     GIR_EraseRootFromParent_Done,
     /*  80818 */   // Label 1045: @80818
     /*  80818 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(80870), // Rule ID 4339 //
     /*  80823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  80826 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  80831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  80846 */     // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  80846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /*  80849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  80856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80868 */     GIR_RootConstrainSelectedInstOperands,
     /*  80869 */     // GIR_Coverage, 4339,
     /*  80869 */     GIR_EraseRootFromParent_Done,
     /*  80870 */   // Label 1046: @80870
     /*  80870 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(80937), // Rule ID 4559 //
     /*  80875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  80878 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  80885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  80900 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  80900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /*  80903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  80905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  80910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  80915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  80920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  80925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80935 */     GIR_RootConstrainSelectedInstOperands,
     /*  80936 */     // GIR_Coverage, 4559,
     /*  80936 */     GIR_EraseRootFromParent_Done,
     /*  80937 */   // Label 1047: @80937
     /*  80937 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(81001), // Rule ID 4561 //
     /*  80942 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  80949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  80953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  80964 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  80964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /*  80967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  80969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  80974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  80979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  80984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  80989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80999 */     GIR_RootConstrainSelectedInstOperands,
     /*  81000 */     // GIR_Coverage, 4561,
     /*  81000 */     GIR_EraseRootFromParent_Done,
     /*  81001 */   // Label 1048: @81001
     /*  81001 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(81062), // Rule ID 7960 //
     /*  81006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /*  81009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81013 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  81018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  81033 */     // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  81033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /*  81036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  81043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  81048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  81053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81060 */     GIR_RootConstrainSelectedInstOperands,
     /*  81061 */     // GIR_Coverage, 7960,
     /*  81061 */     GIR_EraseRootFromParent_Done,
     /*  81062 */   // Label 1049: @81062
     /*  81062 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(81124), // Rule ID 4558 //
     /*  81067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  81070 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  81092 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  81092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /*  81095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  81097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  81102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81122 */     GIR_RootConstrainSelectedInstOperands,
     /*  81123 */     // GIR_Coverage, 4558,
     /*  81123 */     GIR_EraseRootFromParent_Done,
     /*  81124 */   // Label 1050: @81124
     /*  81124 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(81183), // Rule ID 4560 //
     /*  81129 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  81151 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  81151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /*  81154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  81156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  81161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81181 */     GIR_RootConstrainSelectedInstOperands,
     /*  81182 */     // GIR_Coverage, 4560,
     /*  81182 */     GIR_EraseRootFromParent_Done,
     /*  81183 */   // Label 1051: @81183
     /*  81183 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(81240), // Rule ID 7962 //
     /*  81188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  81191 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  81196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  81211 */     // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  81211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /*  81214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  81221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  81226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  81231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81238 */     GIR_RootConstrainSelectedInstOperands,
     /*  81239 */     // GIR_Coverage, 7962,
     /*  81239 */     GIR_EraseRootFromParent_Done,
     /*  81240 */   // Label 1052: @81240
     /*  81240 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(81299), // Rule ID 3924 //
     /*  81245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  81248 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  81270 */     // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /*  81273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  81280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  81285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81297 */     GIR_RootConstrainSelectedInstOperands,
     /*  81298 */     // GIR_Coverage, 3924,
     /*  81298 */     GIR_EraseRootFromParent_Done,
     /*  81299 */   // Label 1053: @81299
     /*  81299 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(81353), // Rule ID 3923 //
     /*  81304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  81307 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  81329 */     // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  81329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /*  81332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  81339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81351 */     GIR_RootConstrainSelectedInstOperands,
     /*  81352 */     // GIR_Coverage, 3923,
     /*  81352 */     GIR_EraseRootFromParent_Done,
     /*  81353 */   // Label 1054: @81353
     /*  81353 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(81408), // Rule ID 3645 //
     /*  81358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  81361 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  81373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  81384 */     // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  81384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /*  81387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  81394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81406 */     GIR_RootConstrainSelectedInstOperands,
     /*  81407 */     // GIR_Coverage, 3645,
     /*  81407 */     GIR_EraseRootFromParent_Done,
     /*  81408 */   // Label 1055: @81408
     /*  81408 */   GIM_Reject,
     /*  81409 */ // Label 1022: @81409
     /*  81409 */ GIM_Reject,
     /*  81410 */ // Label 876: @81410
     /*  81410 */ GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(83036),
     /*  81415 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81418 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(81482), // Rule ID 3002 //
     /*  81423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  81426 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81438 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81442 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  81453 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  81456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81480 */     GIR_RootConstrainSelectedInstOperands,
     /*  81481 */     // GIR_Coverage, 3002,
     /*  81481 */     GIR_EraseRootFromParent_Done,
     /*  81482 */   // Label 1057: @81482
     /*  81482 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(81542), // Rule ID 3008 //
     /*  81487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  81490 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81502 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  81513 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  81516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81540 */     GIR_RootConstrainSelectedInstOperands,
     /*  81541 */     // GIR_Coverage, 3008,
     /*  81541 */     GIR_EraseRootFromParent_Done,
     /*  81542 */   // Label 1058: @81542
     /*  81542 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(81601), // Rule ID 2998 //
     /*  81547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  81550 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81562 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  81577 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  81580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81599 */     GIR_RootConstrainSelectedInstOperands,
     /*  81600 */     // GIR_Coverage, 2998,
     /*  81600 */     GIR_EraseRootFromParent_Done,
     /*  81601 */   // Label 1059: @81601
     /*  81601 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(81660), // Rule ID 2999 //
     /*  81606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  81609 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81625 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  81636 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  81639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81658 */     GIR_RootConstrainSelectedInstOperands,
     /*  81659 */     // GIR_Coverage, 2999,
     /*  81659 */     GIR_EraseRootFromParent_Done,
     /*  81660 */   // Label 1060: @81660
     /*  81660 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(81719), // Rule ID 3000 //
     /*  81665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  81668 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81680 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  81695 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  81695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  81698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81717 */     GIR_RootConstrainSelectedInstOperands,
     /*  81718 */     // GIR_Coverage, 3000,
     /*  81718 */     GIR_EraseRootFromParent_Done,
     /*  81719 */   // Label 1061: @81719
     /*  81719 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(81781), // Rule ID 3001 //
     /*  81724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  81727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81743 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  81754 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  81754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  81757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81779 */     GIR_RootConstrainSelectedInstOperands,
     /*  81780 */     // GIR_Coverage, 3001,
     /*  81780 */     GIR_EraseRootFromParent_Done,
     /*  81781 */   // Label 1062: @81781
     /*  81781 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(81833), // Rule ID 3004 //
     /*  81786 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81798 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  81809 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  81812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81831 */     GIR_RootConstrainSelectedInstOperands,
     /*  81832 */     // GIR_Coverage, 3004,
     /*  81832 */     GIR_EraseRootFromParent_Done,
     /*  81833 */   // Label 1063: @81833
     /*  81833 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(81888), // Rule ID 3005 //
     /*  81838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  81841 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81853 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  81864 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  81867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81886 */     GIR_RootConstrainSelectedInstOperands,
     /*  81887 */     // GIR_Coverage, 3005,
     /*  81887 */     GIR_EraseRootFromParent_Done,
     /*  81888 */   // Label 1064: @81888
     /*  81888 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(81943), // Rule ID 3006 //
     /*  81893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  81896 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  81919 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  81919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  81922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81941 */     GIR_RootConstrainSelectedInstOperands,
     /*  81942 */     // GIR_Coverage, 3006,
     /*  81942 */     GIR_EraseRootFromParent_Done,
     /*  81943 */   // Label 1065: @81943
     /*  81943 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(82001), // Rule ID 3007 //
     /*  81948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  81951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  81974 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  81974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  81977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81999 */     GIR_RootConstrainSelectedInstOperands,
     /*  82000 */     // GIR_Coverage, 3007,
     /*  82000 */     GIR_EraseRootFromParent_Done,
     /*  82001 */   // Label 1066: @82001
     /*  82001 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(82052), // Rule ID 3003 //
     /*  82006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  82009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  82017 */     // MIs[0] sbase
     /*  82017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  82021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  82025 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  82029 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  82033 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  82033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  82036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  82038 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  82040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82050 */     GIR_RootConstrainSelectedInstOperands,
     /*  82051 */     // GIR_Coverage, 3003,
     /*  82051 */     GIR_EraseRootFromParent_Done,
     /*  82052 */   // Label 1067: @82052
     /*  82052 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(82096), // Rule ID 3009 //
     /*  82057 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  82065 */     // MIs[0] sbase
     /*  82065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  82069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  82073 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  82077 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  82077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  82080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  82082 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  82084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82094 */     GIR_RootConstrainSelectedInstOperands,
     /*  82095 */     // GIR_Coverage, 3009,
     /*  82095 */     GIR_EraseRootFromParent_Done,
     /*  82096 */   // Label 1068: @82096
     /*  82096 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(82156), // Rule ID 6503 //
     /*  82101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  82104 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82113 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  82124 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  82124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  82127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82154 */     GIR_RootConstrainSelectedInstOperands,
     /*  82155 */     // GIR_Coverage, 6503,
     /*  82155 */     GIR_EraseRootFromParent_Done,
     /*  82156 */   // Label 1069: @82156
     /*  82156 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(82216), // Rule ID 6505 //
     /*  82161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  82164 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  82184 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  82184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  82187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82214 */     GIR_RootConstrainSelectedInstOperands,
     /*  82215 */     // GIR_Coverage, 6505,
     /*  82215 */     GIR_EraseRootFromParent_Done,
     /*  82216 */   // Label 1070: @82216
     /*  82216 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(82273), // Rule ID 4281 //
     /*  82221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  82224 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  82244 */     // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  82244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  82247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  82254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  82259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82271 */     GIR_RootConstrainSelectedInstOperands,
     /*  82272 */     // GIR_Coverage, 4281,
     /*  82272 */     GIR_EraseRootFromParent_Done,
     /*  82273 */   // Label 1071: @82273
     /*  82273 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(82325), // Rule ID 4280 //
     /*  82278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  82281 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  82301 */     // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  82301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  82304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  82311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  82316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82323 */     GIR_RootConstrainSelectedInstOperands,
     /*  82324 */     // GIR_Coverage, 4280,
     /*  82324 */     GIR_EraseRootFromParent_Done,
     /*  82325 */   // Label 1072: @82325
     /*  82325 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(82377), // Rule ID 4279 //
     /*  82330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  82333 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  82353 */     // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  82353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  82356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  82363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  82368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82375 */     GIR_RootConstrainSelectedInstOperands,
     /*  82376 */     // GIR_Coverage, 4279,
     /*  82376 */     GIR_EraseRootFromParent_Done,
     /*  82377 */   // Label 1073: @82377
     /*  82377 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(82444), // Rule ID 4519 //
     /*  82382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  82385 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  82407 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  82407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  82410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  82417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  82427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  82432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82442 */     GIR_RootConstrainSelectedInstOperands,
     /*  82443 */     // GIR_Coverage, 4519,
     /*  82443 */     GIR_EraseRootFromParent_Done,
     /*  82444 */   // Label 1074: @82444
     /*  82444 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(82508), // Rule ID 4521 //
     /*  82449 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  82471 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  82471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  82474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  82481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  82491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  82496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82506 */     GIR_RootConstrainSelectedInstOperands,
     /*  82507 */     // GIR_Coverage, 4521,
     /*  82507 */     GIR_EraseRootFromParent_Done,
     /*  82508 */   // Label 1075: @82508
     /*  82508 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(82573), // Rule ID 6502 //
     /*  82513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  82516 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  82536 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  82536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  82539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  82546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  82556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  82561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82571 */     GIR_RootConstrainSelectedInstOperands,
     /*  82572 */     // GIR_Coverage, 6502,
     /*  82572 */     GIR_EraseRootFromParent_Done,
     /*  82573 */   // Label 1076: @82573
     /*  82573 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(82638), // Rule ID 6504 //
     /*  82578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  82581 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  82601 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  82601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  82604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  82611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  82621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  82626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82636 */     GIR_RootConstrainSelectedInstOperands,
     /*  82637 */     // GIR_Coverage, 6504,
     /*  82637 */     GIR_EraseRootFromParent_Done,
     /*  82638 */   // Label 1077: @82638
     /*  82638 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(82700), // Rule ID 4518 //
     /*  82643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  82646 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  82668 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  82668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  82671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82698 */     GIR_RootConstrainSelectedInstOperands,
     /*  82699 */     // GIR_Coverage, 4518,
     /*  82699 */     GIR_EraseRootFromParent_Done,
     /*  82700 */   // Label 1078: @82700
     /*  82700 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(82759), // Rule ID 4520 //
     /*  82705 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  82727 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  82727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  82730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82757 */     GIR_RootConstrainSelectedInstOperands,
     /*  82758 */     // GIR_Coverage, 4520,
     /*  82758 */     GIR_EraseRootFromParent_Done,
     /*  82759 */   // Label 1079: @82759
     /*  82759 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(82815), // Rule ID 7830 //
     /*  82764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  82767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82771 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  82776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  82791 */     // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  82791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  82794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  82801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  82806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82813 */     GIR_RootConstrainSelectedInstOperands,
     /*  82814 */     // GIR_Coverage, 7830,
     /*  82814 */     GIR_EraseRootFromParent_Done,
     /*  82815 */   // Label 1080: @82815
     /*  82815 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(82867), // Rule ID 7831 //
     /*  82820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  82823 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  82828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  82843 */     // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  82843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  82846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  82853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  82858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82865 */     GIR_RootConstrainSelectedInstOperands,
     /*  82866 */     // GIR_Coverage, 7831,
     /*  82866 */     GIR_EraseRootFromParent_Done,
     /*  82867 */   // Label 1081: @82867
     /*  82867 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(82926), // Rule ID 3884 //
     /*  82872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  82875 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  82897 */     // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  82897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  82900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  82907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  82912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82924 */     GIR_RootConstrainSelectedInstOperands,
     /*  82925 */     // GIR_Coverage, 3884,
     /*  82925 */     GIR_EraseRootFromParent_Done,
     /*  82926 */   // Label 1082: @82926
     /*  82926 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(82980), // Rule ID 3883 //
     /*  82931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  82934 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  82956 */     // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  82956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  82959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  82966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  82971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82978 */     GIR_RootConstrainSelectedInstOperands,
     /*  82979 */     // GIR_Coverage, 3883,
     /*  82979 */     GIR_EraseRootFromParent_Done,
     /*  82980 */   // Label 1083: @82980
     /*  82980 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(83035), // Rule ID 3624 //
     /*  82985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  82988 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  83000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  83011 */     // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  83011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  83014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  83016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  83021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83033 */     GIR_RootConstrainSelectedInstOperands,
     /*  83034 */     // GIR_Coverage, 3624,
     /*  83034 */     GIR_EraseRootFromParent_Done,
     /*  83035 */   // Label 1084: @83035
     /*  83035 */   GIM_Reject,
     /*  83036 */ // Label 1056: @83036
     /*  83036 */ GIM_Reject,
     /*  83037 */ // Label 877: @83037
     /*  83037 */ GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(84663),
     /*  83042 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83045 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(83109), // Rule ID 3014 //
     /*  83050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  83053 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83069 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  83080 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  83083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  83100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83107 */     GIR_RootConstrainSelectedInstOperands,
     /*  83108 */     // GIR_Coverage, 3014,
     /*  83108 */     GIR_EraseRootFromParent_Done,
     /*  83109 */   // Label 1086: @83109
     /*  83109 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(83169), // Rule ID 3020 //
     /*  83114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  83117 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  83140 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  83143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  83160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83167 */     GIR_RootConstrainSelectedInstOperands,
     /*  83168 */     // GIR_Coverage, 3020,
     /*  83168 */     GIR_EraseRootFromParent_Done,
     /*  83169 */   // Label 1087: @83169
     /*  83169 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(83228), // Rule ID 3010 //
     /*  83174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  83177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  83204 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  83207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83226 */     GIR_RootConstrainSelectedInstOperands,
     /*  83227 */     // GIR_Coverage, 3010,
     /*  83227 */     GIR_EraseRootFromParent_Done,
     /*  83228 */   // Label 1088: @83228
     /*  83228 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(83287), // Rule ID 3011 //
     /*  83233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  83236 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83248 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83252 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  83263 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  83266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83285 */     GIR_RootConstrainSelectedInstOperands,
     /*  83286 */     // GIR_Coverage, 3011,
     /*  83286 */     GIR_EraseRootFromParent_Done,
     /*  83287 */   // Label 1089: @83287
     /*  83287 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(83346), // Rule ID 3012 //
     /*  83292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  83295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83307 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83311 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83322 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  83322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  83325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83344 */     GIR_RootConstrainSelectedInstOperands,
     /*  83345 */     // GIR_Coverage, 3012,
     /*  83345 */     GIR_EraseRootFromParent_Done,
     /*  83346 */   // Label 1090: @83346
     /*  83346 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(83408), // Rule ID 3013 //
     /*  83351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  83354 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83366 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83381 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  83381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  83384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83406 */     GIR_RootConstrainSelectedInstOperands,
     /*  83407 */     // GIR_Coverage, 3013,
     /*  83407 */     GIR_EraseRootFromParent_Done,
     /*  83408 */   // Label 1091: @83408
     /*  83408 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(83460), // Rule ID 3016 //
     /*  83413 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  83436 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  83439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83458 */     GIR_RootConstrainSelectedInstOperands,
     /*  83459 */     // GIR_Coverage, 3016,
     /*  83459 */     GIR_EraseRootFromParent_Done,
     /*  83460 */   // Label 1092: @83460
     /*  83460 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(83515), // Rule ID 3017 //
     /*  83465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  83468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83480 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  83491 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  83494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83513 */     GIR_RootConstrainSelectedInstOperands,
     /*  83514 */     // GIR_Coverage, 3017,
     /*  83514 */     GIR_EraseRootFromParent_Done,
     /*  83515 */   // Label 1093: @83515
     /*  83515 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(83570), // Rule ID 3018 //
     /*  83520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  83523 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83535 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83546 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  83546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  83549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83568 */     GIR_RootConstrainSelectedInstOperands,
     /*  83569 */     // GIR_Coverage, 3018,
     /*  83569 */     GIR_EraseRootFromParent_Done,
     /*  83570 */   // Label 1094: @83570
     /*  83570 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(83628), // Rule ID 3019 //
     /*  83575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  83578 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83590 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83601 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  83601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  83604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83626 */     GIR_RootConstrainSelectedInstOperands,
     /*  83627 */     // GIR_Coverage, 3019,
     /*  83627 */     GIR_EraseRootFromParent_Done,
     /*  83628 */   // Label 1095: @83628
     /*  83628 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(83679), // Rule ID 3015 //
     /*  83633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  83636 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83644 */     // MIs[0] sbase
     /*  83644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  83648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  83652 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83660 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  83660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  83663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83665 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  83667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83677 */     GIR_RootConstrainSelectedInstOperands,
     /*  83678 */     // GIR_Coverage, 3015,
     /*  83678 */     GIR_EraseRootFromParent_Done,
     /*  83679 */   // Label 1096: @83679
     /*  83679 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(83723), // Rule ID 3021 //
     /*  83684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  83692 */     // MIs[0] sbase
     /*  83692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  83696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  83700 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83704 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  83704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  83707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83709 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  83711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83721 */     GIR_RootConstrainSelectedInstOperands,
     /*  83722 */     // GIR_Coverage, 3021,
     /*  83722 */     GIR_EraseRootFromParent_Done,
     /*  83723 */   // Label 1097: @83723
     /*  83723 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(83783), // Rule ID 6507 //
     /*  83728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  83731 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  83736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  83740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  83751 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  83751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  83754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  83756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  83761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  83771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83781 */     GIR_RootConstrainSelectedInstOperands,
     /*  83782 */     // GIR_Coverage, 6507,
     /*  83782 */     GIR_EraseRootFromParent_Done,
     /*  83783 */   // Label 1098: @83783
     /*  83783 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(83843), // Rule ID 6509 //
     /*  83788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  83791 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  83796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  83800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  83811 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  83811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  83814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  83816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  83821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  83831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83841 */     GIR_RootConstrainSelectedInstOperands,
     /*  83842 */     // GIR_Coverage, 6509,
     /*  83842 */     GIR_EraseRootFromParent_Done,
     /*  83843 */   // Label 1099: @83843
     /*  83843 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(83900), // Rule ID 4287 //
     /*  83848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  83851 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  83856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  83860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  83871 */     // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  83874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  83876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  83881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  83886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  83891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83898 */     GIR_RootConstrainSelectedInstOperands,
     /*  83899 */     // GIR_Coverage, 4287,
     /*  83899 */     GIR_EraseRootFromParent_Done,
     /*  83900 */   // Label 1100: @83900
     /*  83900 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(83952), // Rule ID 4286 //
     /*  83905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  83908 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  83913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  83917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  83928 */     // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  83928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  83931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  83933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  83938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83950 */     GIR_RootConstrainSelectedInstOperands,
     /*  83951 */     // GIR_Coverage, 4286,
     /*  83951 */     GIR_EraseRootFromParent_Done,
     /*  83952 */   // Label 1101: @83952
     /*  83952 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(84004), // Rule ID 4285 //
     /*  83957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  83960 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  83965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  83969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  83980 */     // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  83980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  83983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  83985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  83990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84002 */     GIR_RootConstrainSelectedInstOperands,
     /*  84003 */     // GIR_Coverage, 4285,
     /*  84003 */     GIR_EraseRootFromParent_Done,
     /*  84004 */   // Label 1102: @84004
     /*  84004 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(84071), // Rule ID 4523 //
     /*  84009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  84012 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  84034 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  84034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  84037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  84044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  84054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  84059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84069 */     GIR_RootConstrainSelectedInstOperands,
     /*  84070 */     // GIR_Coverage, 4523,
     /*  84070 */     GIR_EraseRootFromParent_Done,
     /*  84071 */   // Label 1103: @84071
     /*  84071 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(84135), // Rule ID 4525 //
     /*  84076 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  84098 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  84098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  84101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  84108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  84118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  84123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84133 */     GIR_RootConstrainSelectedInstOperands,
     /*  84134 */     // GIR_Coverage, 4525,
     /*  84134 */     GIR_EraseRootFromParent_Done,
     /*  84135 */   // Label 1104: @84135
     /*  84135 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(84200), // Rule ID 6506 //
     /*  84140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  84143 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  84148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  84163 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  84163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  84166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  84173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  84183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  84188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84198 */     GIR_RootConstrainSelectedInstOperands,
     /*  84199 */     // GIR_Coverage, 6506,
     /*  84199 */     GIR_EraseRootFromParent_Done,
     /*  84200 */   // Label 1105: @84200
     /*  84200 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(84265), // Rule ID 6508 //
     /*  84205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  84208 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  84213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  84228 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  84228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  84231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  84238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  84248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  84253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84263 */     GIR_RootConstrainSelectedInstOperands,
     /*  84264 */     // GIR_Coverage, 6508,
     /*  84264 */     GIR_EraseRootFromParent_Done,
     /*  84265 */   // Label 1106: @84265
     /*  84265 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(84327), // Rule ID 4522 //
     /*  84270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  84273 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  84295 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  84295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  84298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  84310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84325 */     GIR_RootConstrainSelectedInstOperands,
     /*  84326 */     // GIR_Coverage, 4522,
     /*  84326 */     GIR_EraseRootFromParent_Done,
     /*  84327 */   // Label 1107: @84327
     /*  84327 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(84386), // Rule ID 4524 //
     /*  84332 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  84354 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  84354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  84357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  84369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84384 */     GIR_RootConstrainSelectedInstOperands,
     /*  84385 */     // GIR_Coverage, 4524,
     /*  84385 */     GIR_EraseRootFromParent_Done,
     /*  84386 */   // Label 1108: @84386
     /*  84386 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(84442), // Rule ID 7832 //
     /*  84391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  84394 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84398 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  84403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  84418 */     // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  84418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  84421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  84428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84440 */     GIR_RootConstrainSelectedInstOperands,
     /*  84441 */     // GIR_Coverage, 7832,
     /*  84441 */     GIR_EraseRootFromParent_Done,
     /*  84442 */   // Label 1109: @84442
     /*  84442 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(84494), // Rule ID 7833 //
     /*  84447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  84450 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  84455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  84470 */     // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  84470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  84473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  84480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84492 */     GIR_RootConstrainSelectedInstOperands,
     /*  84493 */     // GIR_Coverage, 7833,
     /*  84493 */     GIR_EraseRootFromParent_Done,
     /*  84494 */   // Label 1110: @84494
     /*  84494 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(84553), // Rule ID 3888 //
     /*  84499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  84502 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  84524 */     // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  84524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  84527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  84534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  84539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84551 */     GIR_RootConstrainSelectedInstOperands,
     /*  84552 */     // GIR_Coverage, 3888,
     /*  84552 */     GIR_EraseRootFromParent_Done,
     /*  84553 */   // Label 1111: @84553
     /*  84553 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(84607), // Rule ID 3887 //
     /*  84558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  84561 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  84583 */     // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  84583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  84586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  84593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84605 */     GIR_RootConstrainSelectedInstOperands,
     /*  84606 */     // GIR_Coverage, 3887,
     /*  84606 */     GIR_EraseRootFromParent_Done,
     /*  84607 */   // Label 1112: @84607
     /*  84607 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(84662), // Rule ID 3626 //
     /*  84612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  84615 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  84627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  84638 */     // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  84638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  84641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  84648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84660 */     GIR_RootConstrainSelectedInstOperands,
     /*  84661 */     // GIR_Coverage, 3626,
     /*  84661 */     GIR_EraseRootFromParent_Done,
     /*  84662 */   // Label 1113: @84662
     /*  84662 */   GIM_Reject,
     /*  84663 */ // Label 1085: @84663
     /*  84663 */ GIM_Reject,
     /*  84664 */ // Label 878: @84664
     /*  84664 */ GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(85263),
     /*  84669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84672 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84676 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  84680 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(84736), // Rule ID 3094 //
     /*  84685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  84688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  84692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  84700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  84707 */     // (ld:{ *:[i1] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  84707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  84710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  84712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  84717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  84722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84734 */     GIR_RootConstrainSelectedInstOperands,
     /*  84735 */     // GIR_Coverage, 3094,
     /*  84735 */     GIR_EraseRootFromParent_Done,
     /*  84736 */   // Label 1115: @84736
     /*  84736 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(84788), // Rule ID 3100 //
     /*  84741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  84744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  84748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  84759 */     // (ld:{ *:[i1] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  84759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  84762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  84764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  84769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  84774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84786 */     GIR_RootConstrainSelectedInstOperands,
     /*  84787 */     // GIR_Coverage, 3100,
     /*  84787 */     GIR_EraseRootFromParent_Done,
     /*  84788 */   // Label 1116: @84788
     /*  84788 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(84839), // Rule ID 3090 //
     /*  84793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  84796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  84800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  84808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  84815 */     // (ld:{ *:[i1] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  84815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  84818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  84820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  84825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84837 */     GIR_RootConstrainSelectedInstOperands,
     /*  84838 */     // GIR_Coverage, 3090,
     /*  84838 */     GIR_EraseRootFromParent_Done,
     /*  84839 */   // Label 1117: @84839
     /*  84839 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(84890), // Rule ID 3091 //
     /*  84844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  84847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  84851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  84859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  84866 */     // (ld:{ *:[i1] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  84866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  84869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  84871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  84876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84888 */     GIR_RootConstrainSelectedInstOperands,
     /*  84889 */     // GIR_Coverage, 3091,
     /*  84889 */     GIR_EraseRootFromParent_Done,
     /*  84890 */   // Label 1118: @84890
     /*  84890 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(84941), // Rule ID 3092 //
     /*  84895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  84898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  84902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  84910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  84917 */     // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  84917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  84920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  84922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  84927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  84932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84939 */     GIR_RootConstrainSelectedInstOperands,
     /*  84940 */     // GIR_Coverage, 3092,
     /*  84940 */     GIR_EraseRootFromParent_Done,
     /*  84941 */   // Label 1119: @84941
     /*  84941 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(84995), // Rule ID 3093 //
     /*  84946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  84949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  84953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  84961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  84968 */     // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  84968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  84971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  84973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  84978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  84983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84993 */     GIR_RootConstrainSelectedInstOperands,
     /*  84994 */     // GIR_Coverage, 3093,
     /*  84994 */     GIR_EraseRootFromParent_Done,
     /*  84995 */   // Label 1120: @84995
     /*  84995 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(85039), // Rule ID 3096 //
     /*  85000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  85015 */     // (ld:{ *:[i1] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  85018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  85030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85037 */     GIR_RootConstrainSelectedInstOperands,
     /*  85038 */     // GIR_Coverage, 3096,
     /*  85038 */     GIR_EraseRootFromParent_Done,
     /*  85039 */   // Label 1121: @85039
     /*  85039 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(85086), // Rule ID 3097 //
     /*  85044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  85047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  85062 */     // (ld:{ *:[i1] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  85065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  85077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85084 */     GIR_RootConstrainSelectedInstOperands,
     /*  85085 */     // GIR_Coverage, 3097,
     /*  85085 */     GIR_EraseRootFromParent_Done,
     /*  85086 */   // Label 1122: @85086
     /*  85086 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(85133), // Rule ID 3098 //
     /*  85091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  85094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  85109 */     // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  85109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  85112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85131 */     GIR_RootConstrainSelectedInstOperands,
     /*  85132 */     // GIR_Coverage, 3098,
     /*  85132 */     GIR_EraseRootFromParent_Done,
     /*  85133 */   // Label 1123: @85133
     /*  85133 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(85183), // Rule ID 3099 //
     /*  85138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  85141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  85156 */     // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  85156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  85159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85181 */     GIR_RootConstrainSelectedInstOperands,
     /*  85182 */     // GIR_Coverage, 3099,
     /*  85182 */     GIR_EraseRootFromParent_Done,
     /*  85183 */   // Label 1124: @85183
     /*  85183 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(85226), // Rule ID 3095 //
     /*  85188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  85191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85195 */     // MIs[0] sbase
     /*  85195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  85199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  85203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  85207 */     // (ld:{ *:[i1] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  85207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  85210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85212 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  85214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85224 */     GIR_RootConstrainSelectedInstOperands,
     /*  85225 */     // GIR_Coverage, 3095,
     /*  85225 */     GIR_EraseRootFromParent_Done,
     /*  85226 */   // Label 1125: @85226
     /*  85226 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(85262), // Rule ID 3101 //
     /*  85231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  85235 */     // MIs[0] sbase
     /*  85235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  85239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  85243 */     // (ld:{ *:[i1] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  85243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  85246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85248 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  85250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85260 */     GIR_RootConstrainSelectedInstOperands,
     /*  85261 */     // GIR_Coverage, 3101,
     /*  85261 */     GIR_EraseRootFromParent_Done,
     /*  85262 */   // Label 1126: @85262
     /*  85262 */   GIM_Reject,
     /*  85263 */ // Label 1114: @85263
     /*  85263 */ GIM_Reject,
     /*  85264 */ // Label 879: @85264
     /*  85264 */ GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(85338), // Rule ID 6455 //
     /*  85269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  85272 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85275 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85279 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85286 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85295 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85299 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  85306 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  85306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  85309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  85311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  85316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85336 */   GIR_RootConstrainSelectedInstOperands,
     /*  85337 */   // GIR_Coverage, 6455,
     /*  85337 */   GIR_EraseRootFromParent_Done,
     /*  85338 */ // Label 1127: @85338
     /*  85338 */ GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(85412), // Rule ID 6457 //
     /*  85343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  85346 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85349 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85353 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85360 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85369 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85373 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  85380 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  85380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  85383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  85385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  85390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85406 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85410 */   GIR_RootConstrainSelectedInstOperands,
     /*  85411 */   // GIR_Coverage, 6457,
     /*  85411 */   GIR_EraseRootFromParent_Done,
     /*  85412 */ // Label 1128: @85412
     /*  85412 */ GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(85475), // Rule ID 6475 //
     /*  85417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  85420 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85423 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85436 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  85443 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  85443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  85446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  85448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  85453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85473 */   GIR_RootConstrainSelectedInstOperands,
     /*  85474 */   // GIR_Coverage, 6475,
     /*  85474 */   GIR_EraseRootFromParent_Done,
     /*  85475 */ // Label 1129: @85475
     /*  85475 */ GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(85538), // Rule ID 6477 //
     /*  85480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  85483 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85486 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85495 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85499 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  85506 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  85506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  85509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  85511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  85516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85532 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85536 */   GIR_RootConstrainSelectedInstOperands,
     /*  85537 */   // GIR_Coverage, 6477,
     /*  85537 */   GIR_EraseRootFromParent_Done,
     /*  85538 */ // Label 1130: @85538
     /*  85538 */ GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(85609), // Rule ID 3571 //
     /*  85543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /*  85546 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85549 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85553 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85560 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  85569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85573 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  85580 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_SVS_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_SVS_t16),
     /*  85583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  85585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  85590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  85595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85603 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85607 */   GIR_RootConstrainSelectedInstOperands,
     /*  85608 */   // GIR_Coverage, 3571,
     /*  85608 */   GIR_EraseRootFromParent_Done,
     /*  85609 */ // Label 1131: @85609
     /*  85609 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(85680), // Rule ID 4200 //
     /*  85614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /*  85617 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85620 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85624 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85631 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85640 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85644 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  85651 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /*  85654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  85656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  85661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  85666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85674 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85678 */   GIR_RootConstrainSelectedInstOperands,
     /*  85679 */   // GIR_Coverage, 4200,
     /*  85679 */   GIR_EraseRootFromParent_Done,
     /*  85680 */ // Label 1132: @85680
     /*  85680 */ GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(85751), // Rule ID 4215 //
     /*  85685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /*  85688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85691 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85695 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85702 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85711 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  85722 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /*  85725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  85727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  85732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  85737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85745 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85749 */   GIR_RootConstrainSelectedInstOperands,
     /*  85750 */   // GIR_Coverage, 4215,
     /*  85750 */   GIR_EraseRootFromParent_Done,
     /*  85751 */ // Label 1133: @85751
     /*  85751 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(85811), // Rule ID 4209 //
     /*  85756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /*  85759 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85762 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85771 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85775 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  85782 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
     /*  85785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  85787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  85792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  85797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85805 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85809 */   GIR_RootConstrainSelectedInstOperands,
     /*  85810 */   // GIR_Coverage, 4209,
     /*  85810 */   GIR_EraseRootFromParent_Done,
     /*  85811 */ // Label 1134: @85811
     /*  85811 */ GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(85871), // Rule ID 4224 //
     /*  85816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /*  85819 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85822 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85831 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85835 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  85842 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
     /*  85845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  85847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  85852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  85857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85865 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85869 */   GIR_RootConstrainSelectedInstOperands,
     /*  85870 */   // GIR_Coverage, 4224,
     /*  85870 */   GIR_EraseRootFromParent_Done,
     /*  85871 */ // Label 1135: @85871
     /*  85871 */ GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(85931), // Rule ID 4239 //
     /*  85876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /*  85879 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85882 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  85891 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85895 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  85902 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_SHORT_D16_SVS_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SHORT_D16_SVS_t16),
     /*  85905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  85907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  85912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  85917 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85925 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85929 */   GIR_RootConstrainSelectedInstOperands,
     /*  85930 */   // GIR_Coverage, 4239,
     /*  85930 */   GIR_EraseRootFromParent_Done,
     /*  85931 */ // Label 1136: @85931
     /*  85931 */ GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(85997), // Rule ID 3570 //
     /*  85936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /*  85939 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85942 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85946 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  85953 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  85962 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85966 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  85973 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_SADDR_t16),
     /*  85976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  85978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  85983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  85988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85991 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85995 */   GIR_RootConstrainSelectedInstOperands,
     /*  85996 */   // GIR_Coverage, 3570,
     /*  85996 */   GIR_EraseRootFromParent_Done,
     /*  85997 */ // Label 1137: @85997
     /*  85997 */ GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(86063), // Rule ID 4199 //
     /*  86002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /*  86005 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86008 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86012 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86019 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86028 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86032 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  86039 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  86039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /*  86042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  86049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86057 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86061 */   GIR_RootConstrainSelectedInstOperands,
     /*  86062 */   // GIR_Coverage, 4199,
     /*  86062 */   GIR_EraseRootFromParent_Done,
     /*  86063 */ // Label 1138: @86063
     /*  86063 */ GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(86129), // Rule ID 4214 //
     /*  86068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /*  86071 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86074 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86078 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86085 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86094 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86098 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  86105 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  86105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /*  86108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  86115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86123 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86127 */   GIR_RootConstrainSelectedInstOperands,
     /*  86128 */   // GIR_Coverage, 4214,
     /*  86128 */   GIR_EraseRootFromParent_Done,
     /*  86129 */ // Label 1139: @86129
     /*  86129 */ GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(86184), // Rule ID 4208 //
     /*  86134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /*  86137 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86140 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86149 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86153 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  86160 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  86160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
     /*  86163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  86170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86178 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86182 */   GIR_RootConstrainSelectedInstOperands,
     /*  86183 */   // GIR_Coverage, 4208,
     /*  86183 */   GIR_EraseRootFromParent_Done,
     /*  86184 */ // Label 1140: @86184
     /*  86184 */ GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(86239), // Rule ID 4223 //
     /*  86189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /*  86192 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86195 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86204 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86208 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  86215 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  86215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
     /*  86218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  86225 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86237 */   GIR_RootConstrainSelectedInstOperands,
     /*  86238 */   // GIR_Coverage, 4223,
     /*  86238 */   GIR_EraseRootFromParent_Done,
     /*  86239 */ // Label 1141: @86239
     /*  86239 */ GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(86294), // Rule ID 4238 //
     /*  86244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /*  86247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86250 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  86259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86263 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  86270 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_SHORT_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SHORT_D16_SADDR_t16),
     /*  86273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  86280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86288 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86292 */   GIR_RootConstrainSelectedInstOperands,
     /*  86293 */   // GIR_Coverage, 4238,
     /*  86293 */   GIR_EraseRootFromParent_Done,
     /*  86294 */ // Label 1142: @86294
     /*  86294 */ GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(86360), // Rule ID 3569 //
     /*  86299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /*  86302 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86305 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86309 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86316 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  86325 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86329 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  86336 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_t16),
     /*  86339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86358 */   GIR_RootConstrainSelectedInstOperands,
     /*  86359 */   // GIR_Coverage, 3569,
     /*  86359 */   GIR_EraseRootFromParent_Done,
     /*  86360 */ // Label 1143: @86360
     /*  86360 */ GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(86426), // Rule ID 4198 //
     /*  86365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /*  86368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86371 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86375 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86382 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  86402 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  86402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /*  86405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86420 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86424 */   GIR_RootConstrainSelectedInstOperands,
     /*  86425 */   // GIR_Coverage, 4198,
     /*  86425 */   GIR_EraseRootFromParent_Done,
     /*  86426 */ // Label 1144: @86426
     /*  86426 */ GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(86492), // Rule ID 4213 //
     /*  86431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /*  86434 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86437 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86441 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86448 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86457 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86461 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  86468 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  86468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /*  86471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86486 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86490 */   GIR_RootConstrainSelectedInstOperands,
     /*  86491 */   // GIR_Coverage, 4213,
     /*  86491 */   GIR_EraseRootFromParent_Done,
     /*  86492 */ // Label 1145: @86492
     /*  86492 */ GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(86547), // Rule ID 4207 //
     /*  86497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /*  86500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86503 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86512 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86516 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  86523 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  86523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
     /*  86526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86533 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86541 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86545 */   GIR_RootConstrainSelectedInstOperands,
     /*  86546 */   // GIR_Coverage, 4207,
     /*  86546 */   GIR_EraseRootFromParent_Done,
     /*  86547 */ // Label 1146: @86547
     /*  86547 */ GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(86602), // Rule ID 4222 //
     /*  86552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /*  86555 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86558 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86567 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86571 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  86578 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  86578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
     /*  86581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86600 */   GIR_RootConstrainSelectedInstOperands,
     /*  86601 */   // GIR_Coverage, 4222,
     /*  86601 */   GIR_EraseRootFromParent_Done,
     /*  86602 */ // Label 1147: @86602
     /*  86602 */ GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(86657), // Rule ID 4237 //
     /*  86607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /*  86610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86613 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  86622 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86626 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  86633 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_SHORT_D16_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SHORT_D16_t16),
     /*  86636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86655 */   GIR_RootConstrainSelectedInstOperands,
     /*  86656 */   // GIR_Coverage, 4237,
     /*  86656 */   GIR_EraseRootFromParent_Done,
     /*  86657 */ // Label 1148: @86657
     /*  86657 */ GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(86734), // Rule ID 4451 //
     /*  86662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  86665 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86668 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86675 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  86682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86686 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86690 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  86697 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  86697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /*  86700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  86702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  86707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  86712 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  86717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  86722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86728 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86732 */   GIR_RootConstrainSelectedInstOperands,
     /*  86733 */   // GIR_Coverage, 4451,
     /*  86733 */   GIR_EraseRootFromParent_Done,
     /*  86734 */ // Label 1149: @86734
     /*  86734 */ GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(86808), // Rule ID 4453 //
     /*  86739 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86742 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86749 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  86756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86760 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86764 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  86771 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  86771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /*  86774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  86776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  86781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  86786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  86791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  86796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86806 */   GIR_RootConstrainSelectedInstOperands,
     /*  86807 */   // GIR_Coverage, 4453,
     /*  86807 */   GIR_EraseRootFromParent_Done,
     /*  86808 */ // Label 1150: @86808
     /*  86808 */ GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(86885), // Rule ID 4455 //
     /*  86813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  86816 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  86826 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  86833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86837 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86841 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  86848 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  86848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /*  86851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  86853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  86858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  86863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  86868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  86873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86883 */   GIR_RootConstrainSelectedInstOperands,
     /*  86884 */   // GIR_Coverage, 4455,
     /*  86884 */   GIR_EraseRootFromParent_Done,
     /*  86885 */ // Label 1151: @86885
     /*  86885 */ GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(86959), // Rule ID 4457 //
     /*  86890 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86893 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  86900 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  86907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86911 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86915 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  86922 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  86922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /*  86925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  86927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  86932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  86937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  86942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  86947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86953 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86957 */   GIR_RootConstrainSelectedInstOperands,
     /*  86958 */   // GIR_Coverage, 4457,
     /*  86958 */   GIR_EraseRootFromParent_Done,
     /*  86959 */ // Label 1152: @86959
     /*  86959 */ GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(87038), // Rule ID 6454 //
     /*  86964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  86967 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86970 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86974 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86981 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86990 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86994 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  87001 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  87001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /*  87004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87032 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87036 */   GIR_RootConstrainSelectedInstOperands,
     /*  87037 */   // GIR_Coverage, 6454,
     /*  87037 */   GIR_EraseRootFromParent_Done,
     /*  87038 */ // Label 1153: @87038
     /*  87038 */ GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(87117), // Rule ID 6456 //
     /*  87043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  87046 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87049 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87053 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87060 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87069 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  87080 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  87080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /*  87083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87111 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87115 */   GIR_RootConstrainSelectedInstOperands,
     /*  87116 */   // GIR_Coverage, 6456,
     /*  87116 */   GIR_EraseRootFromParent_Done,
     /*  87117 */ // Label 1154: @87117
     /*  87117 */ GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(87185), // Rule ID 6474 //
     /*  87122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  87125 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87128 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87137 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87141 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  87148 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  87148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
     /*  87151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87183 */   GIR_RootConstrainSelectedInstOperands,
     /*  87184 */   // GIR_Coverage, 6474,
     /*  87184 */   GIR_EraseRootFromParent_Done,
     /*  87185 */ // Label 1155: @87185
     /*  87185 */ GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(87253), // Rule ID 6476 //
     /*  87190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  87193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87196 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  87216 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  87216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
     /*  87219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87247 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87251 */   GIR_RootConstrainSelectedInstOperands,
     /*  87252 */   // GIR_Coverage, 6476,
     /*  87252 */   GIR_EraseRootFromParent_Done,
     /*  87253 */ // Label 1156: @87253
     /*  87253 */ GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(87325), // Rule ID 4450 //
     /*  87258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  87261 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87264 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87271 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87282 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87286 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87293 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  87296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87319 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87323 */   GIR_RootConstrainSelectedInstOperands,
     /*  87324 */   // GIR_Coverage, 4450,
     /*  87324 */   GIR_EraseRootFromParent_Done,
     /*  87325 */ // Label 1157: @87325
     /*  87325 */ GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(87394), // Rule ID 4452 //
     /*  87330 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87333 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87340 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87351 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87355 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87362 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  87365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87388 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87392 */   GIR_RootConstrainSelectedInstOperands,
     /*  87393 */   // GIR_Coverage, 4452,
     /*  87393 */   GIR_EraseRootFromParent_Done,
     /*  87394 */ // Label 1158: @87394
     /*  87394 */ GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(87466), // Rule ID 4454 //
     /*  87399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  87402 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87405 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  87412 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87423 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87427 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87434 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  87437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87460 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87464 */   GIR_RootConstrainSelectedInstOperands,
     /*  87465 */   // GIR_Coverage, 4454,
     /*  87465 */   GIR_EraseRootFromParent_Done,
     /*  87466 */ // Label 1159: @87466
     /*  87466 */ GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(87535), // Rule ID 4456 //
     /*  87471 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  87481 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87492 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87496 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87503 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  87506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87529 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87533 */   GIR_RootConstrainSelectedInstOperands,
     /*  87534 */   // GIR_Coverage, 4456,
     /*  87534 */   GIR_EraseRootFromParent_Done,
     /*  87535 */ // Label 1160: @87535
     /*  87535 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(87610), // Rule ID 6424 //
     /*  87540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  87543 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87546 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87550 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87557 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87567 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87571 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87578 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  87578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  87581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87604 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87608 */   GIR_RootConstrainSelectedInstOperands,
     /*  87609 */   // GIR_Coverage, 6424,
     /*  87609 */   GIR_EraseRootFromParent_Done,
     /*  87610 */ // Label 1161: @87610
     /*  87610 */ GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(87685), // Rule ID 6425 //
     /*  87615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  87618 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87621 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87625 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87632 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87642 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87646 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87653 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  87653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  87656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87679 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87683 */   GIR_RootConstrainSelectedInstOperands,
     /*  87684 */   // GIR_Coverage, 6425,
     /*  87684 */   GIR_EraseRootFromParent_Done,
     /*  87685 */ // Label 1162: @87685
     /*  87685 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(87761), // Rule ID 6430 //
     /*  87690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  87693 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87696 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87707 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87718 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87722 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87729 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  87729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  87732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87759 */   GIR_RootConstrainSelectedInstOperands,
     /*  87760 */   // GIR_Coverage, 6430,
     /*  87760 */   GIR_EraseRootFromParent_Done,
     /*  87761 */ // Label 1163: @87761
     /*  87761 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(87837), // Rule ID 6431 //
     /*  87766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  87769 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87772 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87776 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87783 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87798 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87805 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  87805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  87808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87835 */   GIR_RootConstrainSelectedInstOperands,
     /*  87836 */   // GIR_Coverage, 6431,
     /*  87836 */   GIR_EraseRootFromParent_Done,
     /*  87837 */ // Label 1164: @87837
     /*  87837 */ GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(87902), // Rule ID 6434 //
     /*  87842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  87845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87848 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87859 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87863 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87870 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  87870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  87873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87896 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87900 */   GIR_RootConstrainSelectedInstOperands,
     /*  87901 */   // GIR_Coverage, 6434,
     /*  87901 */   GIR_EraseRootFromParent_Done,
     /*  87902 */ // Label 1165: @87902
     /*  87902 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(87967), // Rule ID 6435 //
     /*  87907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  87910 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87913 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87924 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87928 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87935 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  87935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  87938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87965 */   GIR_RootConstrainSelectedInstOperands,
     /*  87966 */   // GIR_Coverage, 6435,
     /*  87966 */   GIR_EraseRootFromParent_Done,
     /*  87967 */ // Label 1166: @87967
     /*  87967 */ GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(88029), // Rule ID 7834 //
     /*  87972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  87975 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87978 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  87985 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  87990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87998 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88005 */   // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8_glue>><<P:Predicate_atomic_load_8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /*  88008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88023 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88027 */   GIR_RootConstrainSelectedInstOperands,
     /*  88028 */   // GIR_Coverage, 7834,
     /*  88028 */   GIR_EraseRootFromParent_Done,
     /*  88029 */ // Label 1167: @88029
     /*  88029 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(88091), // Rule ID 7835 //
     /*  88034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /*  88037 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88040 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88047 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88056 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88060 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88067 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  88070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88085 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88089 */   GIR_RootConstrainSelectedInstOperands,
     /*  88090 */   // GIR_Coverage, 7835,
     /*  88090 */   GIR_EraseRootFromParent_Done,
     /*  88091 */ // Label 1168: @88091
     /*  88091 */ GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(88153), // Rule ID 7836 //
     /*  88096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /*  88099 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88102 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88109 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88118 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88122 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88129 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  88132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88134 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88147 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88151 */   GIR_RootConstrainSelectedInstOperands,
     /*  88152 */   // GIR_Coverage, 7836,
     /*  88152 */   GIR_EraseRootFromParent_Done,
     /*  88153 */ // Label 1169: @88153
     /*  88153 */ GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(88215), // Rule ID 7837 //
     /*  88158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /*  88161 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88164 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88171 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  88180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88184 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88191 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_local>>  =>  (DS_READ_U8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_t16),
     /*  88194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88213 */   GIR_RootConstrainSelectedInstOperands,
     /*  88214 */   // GIR_Coverage, 7837,
     /*  88214 */   GIR_EraseRootFromParent_Done,
     /*  88215 */ // Label 1170: @88215
     /*  88215 */ GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(88277), // Rule ID 7852 //
     /*  88220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  88223 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88226 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  88233 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88242 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88246 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88253 */   // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16_glue>><<P:Predicate_atomic_load_16_local_m0>>  =>  (DS_READ_U16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /*  88256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88271 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88275 */   GIR_RootConstrainSelectedInstOperands,
     /*  88276 */   // GIR_Coverage, 7852,
     /*  88276 */   GIR_EraseRootFromParent_Done,
     /*  88277 */ // Label 1171: @88277
     /*  88277 */ GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(88339), // Rule ID 7853 //
     /*  88282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /*  88285 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  88295 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88304 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88308 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88315 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  88318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88333 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88337 */   GIR_RootConstrainSelectedInstOperands,
     /*  88338 */   // GIR_Coverage, 7853,
     /*  88338 */   GIR_EraseRootFromParent_Done,
     /*  88339 */ // Label 1172: @88339
     /*  88339 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(88401), // Rule ID 7854 //
     /*  88344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /*  88347 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88350 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  88357 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88366 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88370 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88377 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  88380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88387 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88395 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88399 */   GIR_RootConstrainSelectedInstOperands,
     /*  88400 */   // GIR_Coverage, 7854,
     /*  88400 */   GIR_EraseRootFromParent_Done,
     /*  88401 */ // Label 1173: @88401
     /*  88401 */ GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(88463), // Rule ID 7855 //
     /*  88406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /*  88409 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88412 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  88419 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  88428 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88432 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88439 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_local>>  =>  (DS_READ_U16_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_t16),
     /*  88442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88457 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88461 */   GIR_RootConstrainSelectedInstOperands,
     /*  88462 */   // GIR_Coverage, 7855,
     /*  88462 */   GIR_EraseRootFromParent_Done,
     /*  88463 */ // Label 1174: @88463
     /*  88463 */ GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(88529), // Rule ID 7806 //
     /*  88468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  88471 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88474 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88478 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88485 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88494 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88498 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88505 */   // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_extload_glue>><<P:Predicate_extloadi8_glue>><<P:Predicate_extloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /*  88508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88510 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88523 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88527 */   GIR_RootConstrainSelectedInstOperands,
     /*  88528 */   // GIR_Coverage, 7806,
     /*  88528 */   GIR_EraseRootFromParent_Done,
     /*  88529 */ // Label 1175: @88529
     /*  88529 */ GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(88595), // Rule ID 7807 //
     /*  88534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /*  88537 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88540 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88544 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88551 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88560 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88564 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88571 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  88574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88593 */   GIR_RootConstrainSelectedInstOperands,
     /*  88594 */   // GIR_Coverage, 7807,
     /*  88594 */   GIR_EraseRootFromParent_Done,
     /*  88595 */ // Label 1176: @88595
     /*  88595 */ GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(88661), // Rule ID 7808 //
     /*  88600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /*  88603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88606 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88617 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88626 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88630 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88637 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  88640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88655 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88659 */   GIR_RootConstrainSelectedInstOperands,
     /*  88660 */   // GIR_Coverage, 7808,
     /*  88660 */   GIR_EraseRootFromParent_Done,
     /*  88661 */ // Label 1177: @88661
     /*  88661 */ GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(88727), // Rule ID 7809 //
     /*  88666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /*  88669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88672 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88676 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88683 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  88692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88696 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88703 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_t16),
     /*  88706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88725 */   GIR_RootConstrainSelectedInstOperands,
     /*  88726 */   // GIR_Coverage, 7809,
     /*  88726 */   GIR_EraseRootFromParent_Done,
     /*  88727 */ // Label 1178: @88727
     /*  88727 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(88786), // Rule ID 7814 //
     /*  88732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  88735 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88738 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88742 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88751 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88755 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88762 */   // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_U16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /*  88765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88780 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88784 */   GIR_RootConstrainSelectedInstOperands,
     /*  88785 */   // GIR_Coverage, 7814,
     /*  88785 */   GIR_EraseRootFromParent_Done,
     /*  88786 */ // Label 1179: @88786
     /*  88786 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(88841), // Rule ID 7815 //
     /*  88791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /*  88794 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88797 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88806 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88810 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88817 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  88820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88835 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88839 */   GIR_RootConstrainSelectedInstOperands,
     /*  88840 */   // GIR_Coverage, 7815,
     /*  88840 */   GIR_EraseRootFromParent_Done,
     /*  88841 */ // Label 1180: @88841
     /*  88841 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(88896), // Rule ID 7816 //
     /*  88846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /*  88849 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88852 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88861 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88865 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88872 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  88875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88890 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88894 */   GIR_RootConstrainSelectedInstOperands,
     /*  88895 */   // GIR_Coverage, 7816,
     /*  88895 */   GIR_EraseRootFromParent_Done,
     /*  88896 */ // Label 1181: @88896
     /*  88896 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(88951), // Rule ID 7817 //
     /*  88901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /*  88904 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88907 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  88916 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88920 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88927 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_U16_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_t16),
     /*  88930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88945 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88949 */   GIR_RootConstrainSelectedInstOperands,
     /*  88950 */   // GIR_Coverage, 7817,
     /*  88950 */   GIR_EraseRootFromParent_Done,
     /*  88951 */ // Label 1182: @88951
     /*  88951 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(89020), // Rule ID 3800 //
     /*  88956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  88959 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88962 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88969 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  88976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88980 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88984 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  88991 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  88991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /*  88994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89018 */   GIR_RootConstrainSelectedInstOperands,
     /*  89019 */   // GIR_Coverage, 3800,
     /*  89019 */   GIR_EraseRootFromParent_Done,
     /*  89020 */ // Label 1183: @89020
     /*  89020 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(89089), // Rule ID 3808 //
     /*  89025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  89028 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  89031 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  89038 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89049 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89053 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89060 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /*  89063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89065 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89083 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89087 */   GIR_RootConstrainSelectedInstOperands,
     /*  89088 */   // GIR_Coverage, 3808,
     /*  89088 */   GIR_EraseRootFromParent_Done,
     /*  89089 */ // Label 1184: @89089
     /*  89089 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(89162), // Rule ID 3548 //
     /*  89094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /*  89097 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89100 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89104 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89111 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  89122 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89126 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89133 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_D16_SADDR_t16),
     /*  89136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89156 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89160 */   GIR_RootConstrainSelectedInstOperands,
     /*  89161 */   // GIR_Coverage, 3548,
     /*  89161 */   GIR_EraseRootFromParent_Done,
     /*  89162 */ // Label 1185: @89162
     /*  89162 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(89235), // Rule ID 3830 //
     /*  89167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /*  89170 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89173 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89177 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89184 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89195 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89199 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89206 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /*  89209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89229 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89233 */   GIR_RootConstrainSelectedInstOperands,
     /*  89234 */   // GIR_Coverage, 3830,
     /*  89234 */   GIR_EraseRootFromParent_Done,
     /*  89235 */ // Label 1186: @89235
     /*  89235 */ GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(89308), // Rule ID 3842 //
     /*  89240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /*  89243 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89246 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89250 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89257 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89272 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89279 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /*  89282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89294 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89306 */   GIR_RootConstrainSelectedInstOperands,
     /*  89307 */   // GIR_Coverage, 3842,
     /*  89307 */   GIR_EraseRootFromParent_Done,
     /*  89308 */ // Label 1187: @89308
     /*  89308 */ GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(89370), // Rule ID 3840 //
     /*  89313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /*  89316 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89319 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89330 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89334 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89341 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /*  89344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89356 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89364 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89368 */   GIR_RootConstrainSelectedInstOperands,
     /*  89369 */   // GIR_Coverage, 3840,
     /*  89369 */   GIR_EraseRootFromParent_Done,
     /*  89370 */ // Label 1188: @89370
     /*  89370 */ GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(89432), // Rule ID 3852 //
     /*  89375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /*  89378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89381 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89392 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89396 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89403 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /*  89406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89426 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89430 */   GIR_RootConstrainSelectedInstOperands,
     /*  89431 */   // GIR_Coverage, 3852,
     /*  89431 */   GIR_EraseRootFromParent_Done,
     /*  89432 */ // Label 1189: @89432
     /*  89432 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(89494), // Rule ID 3858 //
     /*  89437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /*  89440 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89443 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  89454 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89458 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  89465 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_SHORT_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SHORT_D16_SADDR_t16),
     /*  89468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  89480 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89488 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89492 */   GIR_RootConstrainSelectedInstOperands,
     /*  89493 */   // GIR_Coverage, 3858,
     /*  89493 */   GIR_EraseRootFromParent_Done,
     /*  89494 */ // Label 1190: @89494
     /*  89494 */ GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(89558), // Rule ID 3799 //
     /*  89499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  89502 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  89505 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89512 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89523 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89527 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  89534 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  89534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /*  89537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89552 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89556 */   GIR_RootConstrainSelectedInstOperands,
     /*  89557 */   // GIR_Coverage, 3799,
     /*  89557 */   GIR_EraseRootFromParent_Done,
     /*  89558 */ // Label 1191: @89558
     /*  89558 */ GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(89622), // Rule ID 3807 //
     /*  89563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  89566 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  89569 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  89576 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89587 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89591 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  89598 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  89598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /*  89601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89616 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89620 */   GIR_RootConstrainSelectedInstOperands,
     /*  89621 */   // GIR_Coverage, 3807,
     /*  89621 */   GIR_EraseRootFromParent_Done,
     /*  89622 */ // Label 1192: @89622
     /*  89622 */ GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(89690), // Rule ID 3547 //
     /*  89627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /*  89630 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89633 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89637 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89644 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  89655 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89659 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  89666 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_D16_t16),
     /*  89669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89688 */   GIR_RootConstrainSelectedInstOperands,
     /*  89689 */   // GIR_Coverage, 3547,
     /*  89689 */   GIR_EraseRootFromParent_Done,
     /*  89690 */ // Label 1193: @89690
     /*  89690 */ GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(89758), // Rule ID 3829 //
     /*  89695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /*  89698 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89701 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89705 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89712 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89723 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89727 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  89734 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  89734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /*  89737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89752 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89756 */   GIR_RootConstrainSelectedInstOperands,
     /*  89757 */   // GIR_Coverage, 3829,
     /*  89757 */   GIR_EraseRootFromParent_Done,
     /*  89758 */ // Label 1194: @89758
     /*  89758 */ GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(89826), // Rule ID 3841 //
     /*  89763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /*  89766 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89769 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89773 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89780 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89791 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89795 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  89802 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  89802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /*  89805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89820 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89824 */   GIR_RootConstrainSelectedInstOperands,
     /*  89825 */   // GIR_Coverage, 3841,
     /*  89825 */   GIR_EraseRootFromParent_Done,
     /*  89826 */ // Label 1195: @89826
     /*  89826 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(89883), // Rule ID 3839 //
     /*  89831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /*  89834 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89837 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  89859 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  89859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /*  89862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89881 */   GIR_RootConstrainSelectedInstOperands,
     /*  89882 */   // GIR_Coverage, 3839,
     /*  89882 */   GIR_EraseRootFromParent_Done,
     /*  89883 */ // Label 1196: @89883
     /*  89883 */ GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(89940), // Rule ID 3851 //
     /*  89888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /*  89891 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89894 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89905 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89909 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  89916 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  89916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /*  89919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89938 */   GIR_RootConstrainSelectedInstOperands,
     /*  89939 */   // GIR_Coverage, 3851,
     /*  89939 */   GIR_EraseRootFromParent_Done,
     /*  89940 */ // Label 1197: @89940
     /*  89940 */ GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(89997), // Rule ID 3857 //
     /*  89945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /*  89948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89951 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  89958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  89962 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89966 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  89973 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_SHORT_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SHORT_D16_t16),
     /*  89976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89991 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89995 */   GIR_RootConstrainSelectedInstOperands,
     /*  89996 */   // GIR_Coverage, 3857,
     /*  89996 */   GIR_EraseRootFromParent_Done,
     /*  89997 */ // Label 1198: @89997
     /*  89997 */ GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(90062), // Rule ID 3573 //
     /*  90002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  90005 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  90008 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90015 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90027 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90031 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90038 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /*  90041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90056 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90060 */   GIR_RootConstrainSelectedInstOperands,
     /*  90061 */   // GIR_Coverage, 3573,
     /*  90061 */   GIR_EraseRootFromParent_Done,
     /*  90062 */ // Label 1199: @90062
     /*  90062 */ GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(90127), // Rule ID 3577 //
     /*  90067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  90070 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  90073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  90080 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90092 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90096 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90103 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /*  90106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90121 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90125 */   GIR_RootConstrainSelectedInstOperands,
     /*  90126 */   // GIR_Coverage, 3577,
     /*  90126 */   GIR_EraseRootFromParent_Done,
     /*  90127 */ // Label 1200: @90127
     /*  90127 */ GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(90196), // Rule ID 3590 //
     /*  90132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /*  90135 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90138 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90142 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90149 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90161 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90165 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90172 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /*  90175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90194 */   GIR_RootConstrainSelectedInstOperands,
     /*  90195 */   // GIR_Coverage, 3590,
     /*  90195 */   GIR_EraseRootFromParent_Done,
     /*  90196 */ // Label 1201: @90196
     /*  90196 */ GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(90265), // Rule ID 3596 //
     /*  90201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /*  90204 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90207 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90211 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90218 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90230 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90234 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90241 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /*  90244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90259 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90263 */   GIR_RootConstrainSelectedInstOperands,
     /*  90264 */   // GIR_Coverage, 3596,
     /*  90264 */   GIR_EraseRootFromParent_Done,
     /*  90265 */ // Label 1202: @90265
     /*  90265 */ GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(90334), // Rule ID 3602 //
     /*  90270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /*  90273 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90276 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90280 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90287 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  90299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90303 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90310 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE_D16_t16),
     /*  90313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90315 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90332 */   GIR_RootConstrainSelectedInstOperands,
     /*  90333 */   // GIR_Coverage, 3602,
     /*  90333 */   GIR_EraseRootFromParent_Done,
     /*  90334 */ // Label 1203: @90334
     /*  90334 */ GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(90392), // Rule ID 3593 //
     /*  90339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /*  90342 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90345 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90357 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90361 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90368 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /*  90371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90378 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90390 */   GIR_RootConstrainSelectedInstOperands,
     /*  90391 */   // GIR_Coverage, 3593,
     /*  90391 */   GIR_EraseRootFromParent_Done,
     /*  90392 */ // Label 1204: @90392
     /*  90392 */ GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(90450), // Rule ID 3599 //
     /*  90397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /*  90400 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90403 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90426 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /*  90429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90444 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90448 */   GIR_RootConstrainSelectedInstOperands,
     /*  90449 */   // GIR_Coverage, 3599,
     /*  90449 */   GIR_EraseRootFromParent_Done,
     /*  90450 */ // Label 1205: @90450
     /*  90450 */ GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(90508), // Rule ID 3605 //
     /*  90455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /*  90458 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90461 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  90473 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90477 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  90484 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_SHORT_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SHORT_D16_t16),
     /*  90487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90502 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90506 */   GIR_RootConstrainSelectedInstOperands,
     /*  90507 */   // GIR_Coverage, 3605,
     /*  90507 */   GIR_EraseRootFromParent_Done,
     /*  90508 */ // Label 1206: @90508
     /*  90508 */ GIM_Reject,
     /*  90509 */ // Label 880: @90509
     /*  90509 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(90576), // Rule ID 2889 //
     /*  90514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  90517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90520 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  90528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90532 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  90536 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  90540 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  90547 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  90550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  90552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  90557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  90562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  90567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90570 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90574 */   GIR_RootConstrainSelectedInstOperands,
     /*  90575 */   // GIR_Coverage, 2889,
     /*  90575 */   GIR_EraseRootFromParent_Done,
     /*  90576 */ // Label 1207: @90576
     /*  90576 */ GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(90643), // Rule ID 2942 //
     /*  90581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  90584 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90587 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  90595 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90599 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  90603 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  90607 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  90614 */   // (ld:{ *:[f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  90617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  90619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  90624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  90629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  90634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90637 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90641 */   GIR_RootConstrainSelectedInstOperands,
     /*  90642 */   // GIR_Coverage, 2942,
     /*  90642 */   GIR_EraseRootFromParent_Done,
     /*  90643 */ // Label 1208: @90643
     /*  90643 */ GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(90713), // Rule ID 2898 //
     /*  90648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  90651 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90654 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90658 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  90669 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90673 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
     /*  90677 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  90684 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
     /*  90687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  90689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  90694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  90699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  90704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90711 */   GIR_RootConstrainSelectedInstOperands,
     /*  90712 */   // GIR_Coverage, 2898,
     /*  90712 */   GIR_EraseRootFromParent_Done,
     /*  90713 */ // Label 1209: @90713
     /*  90713 */ GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(90783), // Rule ID 2913 //
     /*  90718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  90721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90724 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90728 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  90735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  90739 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90743 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
     /*  90747 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  90754 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
     /*  90757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  90759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  90764 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  90769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  90774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90777 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90781 */   GIR_RootConstrainSelectedInstOperands,
     /*  90782 */   // GIR_Coverage, 2913,
     /*  90782 */   GIR_EraseRootFromParent_Done,
     /*  90783 */ // Label 1210: @90783
     /*  90783 */ GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(90846), // Rule ID 2936 //
     /*  90788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  90791 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90794 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  90802 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90806 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  90810 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  90817 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  90820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  90822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  90827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  90832 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  90837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90840 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90844 */   GIR_RootConstrainSelectedInstOperands,
     /*  90845 */   // GIR_Coverage, 2936,
     /*  90845 */   GIR_EraseRootFromParent_Done,
     /*  90846 */ // Label 1211: @90846
     /*  90846 */ GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(90909), // Rule ID 2948 //
     /*  90851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  90854 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90857 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  90865 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90869 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  90873 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  90880 */   // (ld:{ *:[f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  90883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  90885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  90890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  90895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  90900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90907 */   GIR_RootConstrainSelectedInstOperands,
     /*  90908 */   // GIR_Coverage, 2948,
     /*  90908 */   GIR_EraseRootFromParent_Done,
     /*  90909 */ // Label 1212: @90909
     /*  90909 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(90971), // Rule ID 2885 //
     /*  90914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  90917 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90920 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  90928 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90932 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  90936 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  90940 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  90947 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  90950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  90952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  90957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90965 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90969 */   GIR_RootConstrainSelectedInstOperands,
     /*  90970 */   // GIR_Coverage, 2885,
     /*  90970 */   GIR_EraseRootFromParent_Done,
     /*  90971 */ // Label 1213: @90971
     /*  90971 */ GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(91033), // Rule ID 2886 //
     /*  90976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  90979 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90982 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  90990 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90994 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  90998 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91002 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  91009 */   // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  91012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91027 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91031 */   GIR_RootConstrainSelectedInstOperands,
     /*  91032 */   // GIR_Coverage, 2886,
     /*  91032 */   GIR_EraseRootFromParent_Done,
     /*  91033 */ // Label 1214: @91033
     /*  91033 */ GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(91095), // Rule ID 2887 //
     /*  91038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  91041 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91044 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91052 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91056 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91060 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91064 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91071 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  91071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  91074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91076 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91089 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91093 */   GIR_RootConstrainSelectedInstOperands,
     /*  91094 */   // GIR_Coverage, 2887,
     /*  91094 */   GIR_EraseRootFromParent_Done,
     /*  91095 */ // Label 1215: @91095
     /*  91095 */ GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(91160), // Rule ID 2888 //
     /*  91100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  91103 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91106 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91114 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91118 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91122 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91126 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91133 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  91133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  91136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91154 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91158 */   GIR_RootConstrainSelectedInstOperands,
     /*  91159 */   // GIR_Coverage, 2888,
     /*  91159 */   GIR_EraseRootFromParent_Done,
     /*  91160 */ // Label 1216: @91160
     /*  91160 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(91222), // Rule ID 2938 //
     /*  91165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  91168 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91171 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91179 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91183 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91187 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91191 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  91198 */   // (ld:{ *:[f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  91201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91216 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91220 */   GIR_RootConstrainSelectedInstOperands,
     /*  91221 */   // GIR_Coverage, 2938,
     /*  91221 */   GIR_EraseRootFromParent_Done,
     /*  91222 */ // Label 1217: @91222
     /*  91222 */ GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(91284), // Rule ID 2939 //
     /*  91227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  91230 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91233 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91241 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91245 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91249 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91253 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  91260 */   // (ld:{ *:[f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  91263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91278 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91282 */   GIR_RootConstrainSelectedInstOperands,
     /*  91283 */   // GIR_Coverage, 2939,
     /*  91283 */   GIR_EraseRootFromParent_Done,
     /*  91284 */ // Label 1218: @91284
     /*  91284 */ GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(91346), // Rule ID 2940 //
     /*  91289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  91292 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91295 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91303 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91307 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91311 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91315 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91322 */   // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  91322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  91325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91332 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91340 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91344 */   GIR_RootConstrainSelectedInstOperands,
     /*  91345 */   // GIR_Coverage, 2940,
     /*  91345 */   GIR_EraseRootFromParent_Done,
     /*  91346 */ // Label 1219: @91346
     /*  91346 */ GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(91411), // Rule ID 2941 //
     /*  91351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  91354 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91357 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91369 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91373 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  91377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91384 */   // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  91384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  91387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91405 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91409 */   GIR_RootConstrainSelectedInstOperands,
     /*  91410 */   // GIR_Coverage, 2941,
     /*  91410 */   GIR_EraseRootFromParent_Done,
     /*  91411 */ // Label 1220: @91411
     /*  91411 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(91476), // Rule ID 2896 //
     /*  91416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  91419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91422 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91426 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91441 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
     /*  91445 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  91452 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
     /*  91455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91470 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91474 */   GIR_RootConstrainSelectedInstOperands,
     /*  91475 */   // GIR_Coverage, 2896,
     /*  91475 */   GIR_EraseRootFromParent_Done,
     /*  91476 */ // Label 1221: @91476
     /*  91476 */ GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(91544), // Rule ID 2897 //
     /*  91481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  91484 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91487 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91491 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91502 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91506 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
     /*  91510 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91517 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  91517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
     /*  91520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91538 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91542 */   GIR_RootConstrainSelectedInstOperands,
     /*  91543 */   // GIR_Coverage, 2897,
     /*  91543 */   GIR_EraseRootFromParent_Done,
     /*  91544 */ // Label 1222: @91544
     /*  91544 */ GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(91609), // Rule ID 2911 //
     /*  91549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  91552 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91555 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91559 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  91566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91574 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
     /*  91578 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  91585 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
     /*  91588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91603 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91607 */   GIR_RootConstrainSelectedInstOperands,
     /*  91608 */   // GIR_Coverage, 2911,
     /*  91608 */   GIR_EraseRootFromParent_Done,
     /*  91609 */ // Label 1223: @91609
     /*  91609 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(91677), // Rule ID 2912 //
     /*  91614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  91617 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91620 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91624 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  91631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91635 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91639 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
     /*  91643 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91650 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  91650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
     /*  91653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91671 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91675 */   GIR_RootConstrainSelectedInstOperands,
     /*  91676 */   // GIR_Coverage, 2912,
     /*  91676 */   GIR_EraseRootFromParent_Done,
     /*  91677 */ // Label 1224: @91677
     /*  91677 */ GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(91732), // Rule ID 2932 //
     /*  91682 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91685 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91693 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91697 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91701 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  91708 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  91711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91726 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91730 */   GIR_RootConstrainSelectedInstOperands,
     /*  91731 */   // GIR_Coverage, 2932,
     /*  91731 */   GIR_EraseRootFromParent_Done,
     /*  91732 */ // Label 1225: @91732
     /*  91732 */ GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(91790), // Rule ID 2933 //
     /*  91737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  91740 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91743 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91751 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91755 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91759 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  91766 */   // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  91769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91784 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91788 */   GIR_RootConstrainSelectedInstOperands,
     /*  91789 */   // GIR_Coverage, 2933,
     /*  91789 */   GIR_EraseRootFromParent_Done,
     /*  91790 */ // Label 1226: @91790
     /*  91790 */ GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(91848), // Rule ID 2934 //
     /*  91795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  91798 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91801 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91809 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91813 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91817 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91824 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  91824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  91827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91842 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91846 */   GIR_RootConstrainSelectedInstOperands,
     /*  91847 */   // GIR_Coverage, 2934,
     /*  91847 */   GIR_EraseRootFromParent_Done,
     /*  91848 */ // Label 1227: @91848
     /*  91848 */ GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(91909), // Rule ID 2935 //
     /*  91853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  91856 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91859 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91867 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91871 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  91882 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  91882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  91885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91907 */   GIR_RootConstrainSelectedInstOperands,
     /*  91908 */   // GIR_Coverage, 2935,
     /*  91908 */   GIR_EraseRootFromParent_Done,
     /*  91909 */ // Label 1228: @91909
     /*  91909 */ GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(91964), // Rule ID 2944 //
     /*  91914 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91917 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91925 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91929 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91933 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  91940 */   // (ld:{ *:[f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  91943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  91945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  91950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91958 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91962 */   GIR_RootConstrainSelectedInstOperands,
     /*  91963 */   // GIR_Coverage, 2944,
     /*  91963 */   GIR_EraseRootFromParent_Done,
     /*  91964 */ // Label 1229: @91964
     /*  91964 */ GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(92022), // Rule ID 2945 //
     /*  91969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  91972 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91975 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  91983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91987 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  91991 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  91998 */   // (ld:{ *:[f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  91998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  92001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92003 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  92008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92016 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92020 */   GIR_RootConstrainSelectedInstOperands,
     /*  92021 */   // GIR_Coverage, 2945,
     /*  92021 */   GIR_EraseRootFromParent_Done,
     /*  92022 */ // Label 1230: @92022
     /*  92022 */ GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(92080), // Rule ID 2946 //
     /*  92027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  92030 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92033 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92041 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92045 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92049 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  92056 */   // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  92056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  92059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  92066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92074 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92078 */   GIR_RootConstrainSelectedInstOperands,
     /*  92079 */   // GIR_Coverage, 2946,
     /*  92079 */   GIR_EraseRootFromParent_Done,
     /*  92080 */ // Label 1231: @92080
     /*  92080 */ GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(92141), // Rule ID 2947 //
     /*  92085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  92088 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92091 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92103 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92107 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  92114 */   // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  92117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  92124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92135 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92139 */   GIR_RootConstrainSelectedInstOperands,
     /*  92140 */   // GIR_Coverage, 2947,
     /*  92140 */   GIR_EraseRootFromParent_Done,
     /*  92141 */ // Label 1232: @92141
     /*  92141 */ GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(92195), // Rule ID 2890 //
     /*  92146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  92149 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92152 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92160 */   // MIs[0] sbase
     /*  92160 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  92168 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92172 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  92176 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  92179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92181 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  92183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92189 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92193 */   GIR_RootConstrainSelectedInstOperands,
     /*  92194 */   // GIR_Coverage, 2890,
     /*  92194 */   GIR_EraseRootFromParent_Done,
     /*  92195 */ // Label 1233: @92195
     /*  92195 */ GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(92249), // Rule ID 2943 //
     /*  92200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  92203 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92206 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92214 */   // MIs[0] sbase
     /*  92214 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  92222 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92226 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  92230 */   // (ld:{ *:[f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  92233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92235 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  92237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92243 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92247 */   GIR_RootConstrainSelectedInstOperands,
     /*  92248 */   // GIR_Coverage, 2943,
     /*  92248 */   GIR_EraseRootFromParent_Done,
     /*  92249 */ // Label 1234: @92249
     /*  92249 */ GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(92306), // Rule ID 2899 //
     /*  92254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  92257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92260 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92264 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  92271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92275 */   // MIs[0] sbase
     /*  92275 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  92283 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
     /*  92287 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
     /*  92290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92292 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  92294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92300 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92304 */   GIR_RootConstrainSelectedInstOperands,
     /*  92305 */   // GIR_Coverage, 2899,
     /*  92305 */   GIR_EraseRootFromParent_Done,
     /*  92306 */ // Label 1235: @92306
     /*  92306 */ GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(92363), // Rule ID 2914 //
     /*  92311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  92314 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92317 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92321 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  92328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92332 */   // MIs[0] sbase
     /*  92332 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  92340 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
     /*  92344 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
     /*  92347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92349 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  92351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92361 */   GIR_RootConstrainSelectedInstOperands,
     /*  92362 */   // GIR_Coverage, 2914,
     /*  92362 */   GIR_EraseRootFromParent_Done,
     /*  92363 */ // Label 1236: @92363
     /*  92363 */ GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(92410), // Rule ID 2937 //
     /*  92368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92371 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92379 */   // MIs[0] sbase
     /*  92379 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  92387 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92391 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  92394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92396 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  92398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92408 */   GIR_RootConstrainSelectedInstOperands,
     /*  92409 */   // GIR_Coverage, 2937,
     /*  92409 */   GIR_EraseRootFromParent_Done,
     /*  92410 */ // Label 1237: @92410
     /*  92410 */ GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(92457), // Rule ID 2949 //
     /*  92415 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92418 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  92426 */   // MIs[0] sbase
     /*  92426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  92430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  92434 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  92438 */   // (ld:{ *:[f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  92438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  92441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  92443 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  92445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92451 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92455 */   GIR_RootConstrainSelectedInstOperands,
     /*  92456 */   // GIR_Coverage, 2949,
     /*  92456 */   GIR_EraseRootFromParent_Done,
     /*  92457 */ // Label 1238: @92457
     /*  92457 */ GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(92531), // Rule ID 6443 //
     /*  92462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  92465 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92468 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92472 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  92479 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  92484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92488 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92492 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  92499 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  92499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  92502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  92504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  92509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92525 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92529 */   GIR_RootConstrainSelectedInstOperands,
     /*  92530 */   // GIR_Coverage, 6443,
     /*  92530 */   GIR_EraseRootFromParent_Done,
     /*  92531 */ // Label 1239: @92531
     /*  92531 */ GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(92605), // Rule ID 6445 //
     /*  92536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  92539 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92542 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92546 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  92553 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  92558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92562 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92566 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  92573 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  92573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  92576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  92578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  92583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92599 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92603 */   GIR_RootConstrainSelectedInstOperands,
     /*  92604 */   // GIR_Coverage, 6445,
     /*  92604 */   GIR_EraseRootFromParent_Done,
     /*  92605 */ // Label 1240: @92605
     /*  92605 */ GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(92679), // Rule ID 6467 //
     /*  92610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  92613 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92616 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92620 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  92627 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  92632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92640 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  92647 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  92647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  92650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  92652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  92657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92673 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92677 */   GIR_RootConstrainSelectedInstOperands,
     /*  92678 */   // GIR_Coverage, 6467,
     /*  92678 */   GIR_EraseRootFromParent_Done,
     /*  92679 */ // Label 1241: @92679
     /*  92679 */ GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(92753), // Rule ID 6469 //
     /*  92684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  92687 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92690 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92694 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  92701 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  92706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92710 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92714 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  92721 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  92721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  92724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  92726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  92731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92747 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92751 */   GIR_RootConstrainSelectedInstOperands,
     /*  92752 */   // GIR_Coverage, 6469,
     /*  92752 */   GIR_EraseRootFromParent_Done,
     /*  92753 */ // Label 1242: @92753
     /*  92753 */ GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(92816), // Rule ID 6479 //
     /*  92758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  92761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92764 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  92769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92773 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92777 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  92784 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  92784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  92787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  92789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  92794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92810 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92814 */   GIR_RootConstrainSelectedInstOperands,
     /*  92815 */   // GIR_Coverage, 6479,
     /*  92815 */   GIR_EraseRootFromParent_Done,
     /*  92816 */ // Label 1243: @92816
     /*  92816 */ GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(92879), // Rule ID 6481 //
     /*  92821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  92824 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92827 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  92832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92836 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92840 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  92847 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  92847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  92850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  92852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  92857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92873 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92877 */   GIR_RootConstrainSelectedInstOperands,
     /*  92878 */   // GIR_Coverage, 6481,
     /*  92878 */   GIR_EraseRootFromParent_Done,
     /*  92879 */ // Label 1244: @92879
     /*  92879 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(92942), // Rule ID 6483 //
     /*  92884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  92887 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92890 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  92895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92899 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92903 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  92910 */   // (ld:{ *:[f32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[f32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  92910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  92913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  92915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  92920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92936 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92940 */   GIR_RootConstrainSelectedInstOperands,
     /*  92941 */   // GIR_Coverage, 6483,
     /*  92941 */   GIR_EraseRootFromParent_Done,
     /*  92942 */ // Label 1245: @92942
     /*  92942 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(93005), // Rule ID 6485 //
     /*  92947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  92950 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92953 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  92958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92962 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92966 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  92973 */   // (ld:{ *:[f32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[f32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  92973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  92976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  92978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  92983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  92988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92999 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93003 */   GIR_RootConstrainSelectedInstOperands,
     /*  93004 */   // GIR_Coverage, 6485,
     /*  93004 */   GIR_EraseRootFromParent_Done,
     /*  93005 */ // Label 1246: @93005
     /*  93005 */ GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(93076), // Rule ID 3559 //
     /*  93010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  93013 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93016 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93020 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93027 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93036 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93040 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  93047 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  93047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /*  93050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  93062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93070 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93074 */   GIR_RootConstrainSelectedInstOperands,
     /*  93075 */   // GIR_Coverage, 3559,
     /*  93075 */   GIR_EraseRootFromParent_Done,
     /*  93076 */ // Label 1247: @93076
     /*  93076 */ GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(93147), // Rule ID 4191 //
     /*  93081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  93084 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93087 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93091 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  93098 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93107 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93111 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  93118 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  93118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
     /*  93121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  93133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93145 */   GIR_RootConstrainSelectedInstOperands,
     /*  93146 */   // GIR_Coverage, 4191,
     /*  93146 */   GIR_EraseRootFromParent_Done,
     /*  93147 */ // Label 1248: @93147
     /*  93147 */ GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(93207), // Rule ID 4245 //
     /*  93152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  93155 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93158 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93167 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93171 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  93178 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  93178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  93181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93188 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  93193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93201 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93205 */   GIR_RootConstrainSelectedInstOperands,
     /*  93206 */   // GIR_Coverage, 4245,
     /*  93206 */   GIR_EraseRootFromParent_Done,
     /*  93207 */ // Label 1249: @93207
     /*  93207 */ GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(93267), // Rule ID 4251 //
     /*  93212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  93215 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93218 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93231 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  93238 */   // (ld:{ *:[f32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  93238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  93241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  93253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93261 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93265 */   GIR_RootConstrainSelectedInstOperands,
     /*  93266 */   // GIR_Coverage, 4251,
     /*  93266 */   GIR_EraseRootFromParent_Done,
     /*  93267 */ // Label 1250: @93267
     /*  93267 */ GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(93333), // Rule ID 3558 //
     /*  93272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93275 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93278 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93282 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93289 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93298 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93302 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  93309 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  93309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /*  93312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  93319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93327 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93331 */   GIR_RootConstrainSelectedInstOperands,
     /*  93332 */   // GIR_Coverage, 3558,
     /*  93332 */   GIR_EraseRootFromParent_Done,
     /*  93333 */ // Label 1251: @93333
     /*  93333 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(93399), // Rule ID 4190 //
     /*  93338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93341 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93344 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93348 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  93355 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93368 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  93375 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  93375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
     /*  93378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  93385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93393 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93397 */   GIR_RootConstrainSelectedInstOperands,
     /*  93398 */   // GIR_Coverage, 4190,
     /*  93398 */   GIR_EraseRootFromParent_Done,
     /*  93399 */ // Label 1252: @93399
     /*  93399 */ GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(93454), // Rule ID 4244 //
     /*  93404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93407 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93410 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93419 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93423 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  93430 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  93430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  93433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  93440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93448 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93452 */   GIR_RootConstrainSelectedInstOperands,
     /*  93453 */   // GIR_Coverage, 4244,
     /*  93453 */   GIR_EraseRootFromParent_Done,
     /*  93454 */ // Label 1253: @93454
     /*  93454 */ GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(93509), // Rule ID 4250 //
     /*  93459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93462 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93465 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93474 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93478 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  93485 */   // (ld:{ *:[f32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[f32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  93485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  93488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  93495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93503 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93507 */   GIR_RootConstrainSelectedInstOperands,
     /*  93508 */   // GIR_Coverage, 4250,
     /*  93508 */   GIR_EraseRootFromParent_Done,
     /*  93509 */ // Label 1254: @93509
     /*  93509 */ GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(93575), // Rule ID 3557 //
     /*  93514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93520 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93524 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93531 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93540 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93544 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  93551 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /*  93554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93569 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93573 */   GIR_RootConstrainSelectedInstOperands,
     /*  93574 */   // GIR_Coverage, 3557,
     /*  93574 */   GIR_EraseRootFromParent_Done,
     /*  93575 */ // Label 1255: @93575
     /*  93575 */ GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(93641), // Rule ID 4189 //
     /*  93580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93583 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93586 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93590 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  93597 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93606 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93610 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  93617 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
     /*  93620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93622 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93627 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93635 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93639 */   GIR_RootConstrainSelectedInstOperands,
     /*  93640 */   // GIR_Coverage, 4189,
     /*  93640 */   GIR_EraseRootFromParent_Done,
     /*  93641 */ // Label 1256: @93641
     /*  93641 */ GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(93696), // Rule ID 4243 //
     /*  93646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93649 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93652 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93661 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93665 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  93672 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  93675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93677 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93690 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93694 */   GIR_RootConstrainSelectedInstOperands,
     /*  93695 */   // GIR_Coverage, 4243,
     /*  93695 */   GIR_EraseRootFromParent_Done,
     /*  93696 */ // Label 1257: @93696
     /*  93696 */ GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(93751), // Rule ID 4249 //
     /*  93701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  93704 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93707 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  93712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93716 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93720 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  93727 */   // (ld:{ *:[f32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  93730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93745 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93749 */   GIR_RootConstrainSelectedInstOperands,
     /*  93750 */   // GIR_Coverage, 4249,
     /*  93750 */   GIR_EraseRootFromParent_Done,
     /*  93751 */ // Label 1258: @93751
     /*  93751 */ GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(93828), // Rule ID 4433 //
     /*  93756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  93759 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  93762 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93769 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93780 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93784 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  93791 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  93791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /*  93794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  93796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  93801 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  93806 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  93811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  93816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93822 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93826 */   GIR_RootConstrainSelectedInstOperands,
     /*  93827 */   // GIR_Coverage, 4433,
     /*  93827 */   GIR_EraseRootFromParent_Done,
     /*  93828 */ // Label 1259: @93828
     /*  93828 */ GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(93902), // Rule ID 4437 //
     /*  93833 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  93836 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93843 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93854 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93858 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  93865 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  93865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /*  93868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  93870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  93875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  93880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  93885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  93890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93896 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93900 */   GIR_RootConstrainSelectedInstOperands,
     /*  93901 */   // GIR_Coverage, 4437,
     /*  93901 */   GIR_EraseRootFromParent_Done,
     /*  93902 */ // Label 1260: @93902
     /*  93902 */ GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(93979), // Rule ID 4443 //
     /*  93907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  93910 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  93913 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  93920 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93931 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93935 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  93942 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  93942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /*  93945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  93947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  93952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  93957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  93962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  93967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93973 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93977 */   GIR_RootConstrainSelectedInstOperands,
     /*  93978 */   // GIR_Coverage, 4443,
     /*  93978 */   GIR_EraseRootFromParent_Done,
     /*  93979 */ // Label 1261: @93979
     /*  93979 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(94053), // Rule ID 4445 //
     /*  93984 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  93987 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  93994 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94005 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94009 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94016 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /*  94019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94047 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94051 */   GIR_RootConstrainSelectedInstOperands,
     /*  94052 */   // GIR_Coverage, 4445,
     /*  94052 */   GIR_EraseRootFromParent_Done,
     /*  94053 */ // Label 1262: @94053
     /*  94053 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(94130), // Rule ID 6412 //
     /*  94058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /*  94061 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  94064 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  94071 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94082 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94086 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94093 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  94093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  94096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94124 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94128 */   GIR_RootConstrainSelectedInstOperands,
     /*  94129 */   // GIR_Coverage, 6412,
     /*  94129 */   GIR_EraseRootFromParent_Done,
     /*  94130 */ // Label 1263: @94130
     /*  94130 */ GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(94211), // Rule ID 4459 //
     /*  94135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  94138 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94141 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94145 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  94152 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94163 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94167 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94174 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /*  94177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94209 */   GIR_RootConstrainSelectedInstOperands,
     /*  94210 */   // GIR_Coverage, 4459,
     /*  94210 */   GIR_EraseRootFromParent_Done,
     /*  94211 */ // Label 1264: @94211
     /*  94211 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(94289), // Rule ID 4461 //
     /*  94216 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94219 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94223 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  94230 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94241 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94245 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94252 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /*  94255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94283 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94287 */   GIR_RootConstrainSelectedInstOperands,
     /*  94288 */   // GIR_Coverage, 4461,
     /*  94288 */   GIR_EraseRootFromParent_Done,
     /*  94289 */ // Label 1265: @94289
     /*  94289 */ GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(94370), // Rule ID 4479 //
     /*  94294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  94297 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94300 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94304 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  94311 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94322 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94326 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94333 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /*  94336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94348 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94364 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94368 */   GIR_RootConstrainSelectedInstOperands,
     /*  94369 */   // GIR_Coverage, 4479,
     /*  94369 */   GIR_EraseRootFromParent_Done,
     /*  94370 */ // Label 1266: @94370
     /*  94370 */ GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(94448), // Rule ID 4481 //
     /*  94375 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94378 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94382 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  94389 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94400 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94404 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94411 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /*  94414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94446 */   GIR_RootConstrainSelectedInstOperands,
     /*  94447 */   // GIR_Coverage, 4481,
     /*  94447 */   GIR_EraseRootFromParent_Done,
     /*  94448 */ // Label 1267: @94448
     /*  94448 */ GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(94528), // Rule ID 6415 //
     /*  94453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /*  94456 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94459 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94463 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  94470 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94480 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94491 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  94491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /*  94494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94522 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94526 */   GIR_RootConstrainSelectedInstOperands,
     /*  94527 */   // GIR_Coverage, 6415,
     /*  94527 */   GIR_EraseRootFromParent_Done,
     /*  94528 */ // Label 1268: @94528
     /*  94528 */ GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(94608), // Rule ID 6418 //
     /*  94533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /*  94536 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94539 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94543 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  94550 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94560 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94564 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94571 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_constant>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  94571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /*  94574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94602 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94606 */   GIR_RootConstrainSelectedInstOperands,
     /*  94607 */   // GIR_Coverage, 6418,
     /*  94607 */   GIR_EraseRootFromParent_Done,
     /*  94608 */ // Label 1269: @94608
     /*  94608 */ GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(94687), // Rule ID 6442 //
     /*  94613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  94616 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94619 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94623 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  94630 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  94635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94639 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94643 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  94650 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  94650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /*  94653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94665 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94681 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94685 */   GIR_RootConstrainSelectedInstOperands,
     /*  94686 */   // GIR_Coverage, 6442,
     /*  94686 */   GIR_EraseRootFromParent_Done,
     /*  94687 */ // Label 1270: @94687
     /*  94687 */ GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(94766), // Rule ID 6444 //
     /*  94692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  94695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94698 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94702 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  94709 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  94714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94718 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94722 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  94729 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  94729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /*  94732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94760 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94764 */   GIR_RootConstrainSelectedInstOperands,
     /*  94765 */   // GIR_Coverage, 6444,
     /*  94765 */   GIR_EraseRootFromParent_Done,
     /*  94766 */ // Label 1271: @94766
     /*  94766 */ GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(94845), // Rule ID 6466 //
     /*  94771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  94774 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94777 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94781 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  94788 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  94793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94797 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94801 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  94808 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  94808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
     /*  94811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94839 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94843 */   GIR_RootConstrainSelectedInstOperands,
     /*  94844 */   // GIR_Coverage, 6466,
     /*  94844 */   GIR_EraseRootFromParent_Done,
     /*  94845 */ // Label 1272: @94845
     /*  94845 */ GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(94924), // Rule ID 6468 //
     /*  94850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  94853 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94856 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94860 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  94867 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  94872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94876 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94880 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  94887 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  94887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
     /*  94890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94918 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94922 */   GIR_RootConstrainSelectedInstOperands,
     /*  94923 */   // GIR_Coverage, 6468,
     /*  94923 */   GIR_EraseRootFromParent_Done,
     /*  94924 */ // Label 1273: @94924
     /*  94924 */ GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(94994), // Rule ID 4495 //
     /*  94929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  94932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94935 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94946 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94950 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  94957 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  94957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  94960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  94962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  94967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  94972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  94977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  94982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94988 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94992 */   GIR_RootConstrainSelectedInstOperands,
     /*  94993 */   // GIR_Coverage, 4495,
     /*  94993 */   GIR_EraseRootFromParent_Done,
     /*  94994 */ // Label 1274: @94994
     /*  94994 */ GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(95061), // Rule ID 4497 //
     /*  94999 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95002 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95013 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95017 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  95024 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  95027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95055 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95059 */   GIR_RootConstrainSelectedInstOperands,
     /*  95060 */   // GIR_Coverage, 4497,
     /*  95060 */   GIR_EraseRootFromParent_Done,
     /*  95061 */ // Label 1275: @95061
     /*  95061 */ GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(95131), // Rule ID 4499 //
     /*  95066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  95069 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95072 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95083 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95087 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  95094 */   // (ld:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  95097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95125 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95129 */   GIR_RootConstrainSelectedInstOperands,
     /*  95130 */   // GIR_Coverage, 4499,
     /*  95130 */   GIR_EraseRootFromParent_Done,
     /*  95131 */ // Label 1276: @95131
     /*  95131 */ GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(95198), // Rule ID 4501 //
     /*  95136 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95139 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95154 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  95161 */   // (ld:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  95164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95196 */   GIR_RootConstrainSelectedInstOperands,
     /*  95197 */   // GIR_Coverage, 4501,
     /*  95197 */   GIR_EraseRootFromParent_Done,
     /*  95198 */ // Label 1277: @95198
     /*  95198 */ GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(95266), // Rule ID 6478 //
     /*  95203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  95206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95209 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  95214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95218 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95222 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  95229 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  95229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  95232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95234 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95260 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95264 */   GIR_RootConstrainSelectedInstOperands,
     /*  95265 */   // GIR_Coverage, 6478,
     /*  95265 */   GIR_EraseRootFromParent_Done,
     /*  95266 */ // Label 1278: @95266
     /*  95266 */ GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(95334), // Rule ID 6480 //
     /*  95271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  95274 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95277 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  95282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95286 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95290 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  95297 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  95297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  95300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95332 */   GIR_RootConstrainSelectedInstOperands,
     /*  95333 */   // GIR_Coverage, 6480,
     /*  95333 */   GIR_EraseRootFromParent_Done,
     /*  95334 */ // Label 1279: @95334
     /*  95334 */ GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(95402), // Rule ID 6482 //
     /*  95339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  95342 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95345 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  95350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95354 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95358 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  95365 */   // (ld:{ *:[f32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  95365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  95368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95396 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95400 */   GIR_RootConstrainSelectedInstOperands,
     /*  95401 */   // GIR_Coverage, 6482,
     /*  95401 */   GIR_EraseRootFromParent_Done,
     /*  95402 */ // Label 1280: @95402
     /*  95402 */ GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(95470), // Rule ID 6484 //
     /*  95407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  95410 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95413 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  95418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95422 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95426 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  95433 */   // (ld:{ *:[f32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  95433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  95436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  95443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  95453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  95458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95468 */   GIR_RootConstrainSelectedInstOperands,
     /*  95469 */   // GIR_Coverage, 6484,
     /*  95469 */   GIR_EraseRootFromParent_Done,
     /*  95470 */ // Label 1281: @95470
     /*  95470 */ GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(95542), // Rule ID 4432 //
     /*  95475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  95478 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  95481 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95488 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95503 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  95510 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  95513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  95530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95536 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95540 */   GIR_RootConstrainSelectedInstOperands,
     /*  95541 */   // GIR_Coverage, 4432,
     /*  95541 */   GIR_EraseRootFromParent_Done,
     /*  95542 */ // Label 1282: @95542
     /*  95542 */ GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(95611), // Rule ID 4436 //
     /*  95547 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  95550 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95557 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95568 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95572 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  95579 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  95582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  95599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95605 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95609 */   GIR_RootConstrainSelectedInstOperands,
     /*  95610 */   // GIR_Coverage, 4436,
     /*  95610 */   GIR_EraseRootFromParent_Done,
     /*  95611 */ // Label 1283: @95611
     /*  95611 */ GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(95683), // Rule ID 4442 //
     /*  95616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  95619 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  95622 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95629 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95640 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95644 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  95651 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  95654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  95671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95681 */   GIR_RootConstrainSelectedInstOperands,
     /*  95682 */   // GIR_Coverage, 4442,
     /*  95682 */   GIR_EraseRootFromParent_Done,
     /*  95683 */ // Label 1284: @95683
     /*  95683 */ GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(95752), // Rule ID 4444 //
     /*  95688 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  95691 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95698 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95709 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95713 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  95720 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  95723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  95740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95746 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95750 */   GIR_RootConstrainSelectedInstOperands,
     /*  95751 */   // GIR_Coverage, 4444,
     /*  95751 */   GIR_EraseRootFromParent_Done,
     /*  95752 */ // Label 1285: @95752
     /*  95752 */ GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(95828), // Rule ID 4458 //
     /*  95757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  95760 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95763 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95767 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95774 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95785 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95789 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  95796 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  95799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95801 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95806 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  95816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95822 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95826 */   GIR_RootConstrainSelectedInstOperands,
     /*  95827 */   // GIR_Coverage, 4458,
     /*  95827 */   GIR_EraseRootFromParent_Done,
     /*  95828 */ // Label 1286: @95828
     /*  95828 */ GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(95901), // Rule ID 4460 //
     /*  95833 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95836 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95840 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95847 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95858 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95862 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  95869 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  95872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  95889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95895 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95899 */   GIR_RootConstrainSelectedInstOperands,
     /*  95900 */   // GIR_Coverage, 4460,
     /*  95900 */   GIR_EraseRootFromParent_Done,
     /*  95901 */ // Label 1287: @95901
     /*  95901 */ GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(95977), // Rule ID 4478 //
     /*  95906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  95909 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95912 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95916 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95923 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  95930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  95934 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95938 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  95945 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  95945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  95948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  95950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  95955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  95965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95971 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95975 */   GIR_RootConstrainSelectedInstOperands,
     /*  95976 */   // GIR_Coverage, 4478,
     /*  95976 */   GIR_EraseRootFromParent_Done,
     /*  95977 */ // Label 1288: @95977
     /*  95977 */ GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(96050), // Rule ID 4480 //
     /*  95982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95985 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95989 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95996 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  96003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96007 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96011 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  96018 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  96018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  96021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96044 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96048 */   GIR_RootConstrainSelectedInstOperands,
     /*  96049 */   // GIR_Coverage, 4480,
     /*  96049 */   GIR_EraseRootFromParent_Done,
     /*  96050 */ // Label 1289: @96050
     /*  96050 */ GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(96115), // Rule ID 4494 //
     /*  96055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  96058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96061 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  96068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96072 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96076 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  96083 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  96083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  96086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96113 */   GIR_RootConstrainSelectedInstOperands,
     /*  96114 */   // GIR_Coverage, 4494,
     /*  96114 */   GIR_EraseRootFromParent_Done,
     /*  96115 */ // Label 1290: @96115
     /*  96115 */ GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(96177), // Rule ID 4496 //
     /*  96120 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96123 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  96130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96134 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96138 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  96145 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  96145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  96148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96171 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96175 */   GIR_RootConstrainSelectedInstOperands,
     /*  96176 */   // GIR_Coverage, 4496,
     /*  96176 */   GIR_EraseRootFromParent_Done,
     /*  96177 */ // Label 1291: @96177
     /*  96177 */ GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(96242), // Rule ID 4498 //
     /*  96182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  96185 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96188 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  96195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96199 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96203 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  96210 */   // (ld:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  96210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  96213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96225 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96240 */   GIR_RootConstrainSelectedInstOperands,
     /*  96241 */   // GIR_Coverage, 4498,
     /*  96241 */   GIR_EraseRootFromParent_Done,
     /*  96242 */ // Label 1292: @96242
     /*  96242 */ GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(96304), // Rule ID 4500 //
     /*  96247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96250 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  96257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  96272 */   // (ld:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  96272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  96275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96302 */   GIR_RootConstrainSelectedInstOperands,
     /*  96303 */   // GIR_Coverage, 4500,
     /*  96303 */   GIR_EraseRootFromParent_Done,
     /*  96304 */ // Label 1293: @96304
     /*  96304 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(96366), // Rule ID 7838 //
     /*  96309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  96312 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96315 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96322 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96342 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8_glue>><<P:Predicate_atomic_load_8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /*  96345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96360 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96364 */   GIR_RootConstrainSelectedInstOperands,
     /*  96365 */   // GIR_Coverage, 7838,
     /*  96365 */   GIR_EraseRootFromParent_Done,
     /*  96366 */ // Label 1294: @96366
     /*  96366 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(96428), // Rule ID 7839 //
     /*  96371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  96374 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96384 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96393 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96397 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96404 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  96407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96426 */   GIR_RootConstrainSelectedInstOperands,
     /*  96427 */   // GIR_Coverage, 7839,
     /*  96427 */   GIR_EraseRootFromParent_Done,
     /*  96428 */ // Label 1295: @96428
     /*  96428 */ GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(96490), // Rule ID 7856 //
     /*  96433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  96436 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96439 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96446 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96455 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96459 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96466 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16_glue>><<P:Predicate_atomic_load_16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /*  96469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96484 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96488 */   GIR_RootConstrainSelectedInstOperands,
     /*  96489 */   // GIR_Coverage, 7856,
     /*  96489 */   GIR_EraseRootFromParent_Done,
     /*  96490 */ // Label 1296: @96490
     /*  96490 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(96552), // Rule ID 7857 //
     /*  96495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  96498 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96501 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96508 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96517 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96521 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96528 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  96531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96533 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96546 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96550 */   GIR_RootConstrainSelectedInstOperands,
     /*  96551 */   // GIR_Coverage, 7857,
     /*  96551 */   GIR_EraseRootFromParent_Done,
     /*  96552 */ // Label 1297: @96552
     /*  96552 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(96614), // Rule ID 7862 //
     /*  96557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  96560 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96563 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96570 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96579 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96583 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96590 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32_glue>><<P:Predicate_atomic_load_32_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  96593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96600 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96612 */   GIR_RootConstrainSelectedInstOperands,
     /*  96613 */   // GIR_Coverage, 7862,
     /*  96613 */   GIR_EraseRootFromParent_Done,
     /*  96614 */ // Label 1298: @96614
     /*  96614 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(96676), // Rule ID 7863 //
     /*  96619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  96622 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96625 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96632 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96641 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96645 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96652 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  96655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96670 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96674 */   GIR_RootConstrainSelectedInstOperands,
     /*  96675 */   // GIR_Coverage, 7863,
     /*  96675 */   GIR_EraseRootFromParent_Done,
     /*  96676 */ // Label 1299: @96676
     /*  96676 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(96742), // Rule ID 7793 //
     /*  96681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  96684 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96687 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96691 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96698 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96707 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96711 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96718 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_extload_glue>><<P:Predicate_extloadi8_glue>><<P:Predicate_extloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /*  96721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96728 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96736 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96740 */   GIR_RootConstrainSelectedInstOperands,
     /*  96741 */   // GIR_Coverage, 7793,
     /*  96741 */   GIR_EraseRootFromParent_Done,
     /*  96742 */ // Label 1300: @96742
     /*  96742 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(96808), // Rule ID 7794 //
     /*  96747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  96750 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96753 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96757 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96764 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96773 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96777 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96784 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  96787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96806 */   GIR_RootConstrainSelectedInstOperands,
     /*  96807 */   // GIR_Coverage, 7794,
     /*  96807 */   GIR_EraseRootFromParent_Done,
     /*  96808 */ // Label 1301: @96808
     /*  96808 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(96874), // Rule ID 7801 //
     /*  96813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  96816 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96819 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96823 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96830 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96839 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96843 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96850 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_extload_glue>><<P:Predicate_extloadi16_glue>><<P:Predicate_extloadi16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /*  96853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96868 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96872 */   GIR_RootConstrainSelectedInstOperands,
     /*  96873 */   // GIR_Coverage, 7801,
     /*  96873 */   GIR_EraseRootFromParent_Done,
     /*  96874 */ // Label 1302: @96874
     /*  96874 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(96940), // Rule ID 7802 //
     /*  96879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  96882 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96885 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96889 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96896 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96905 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96909 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96916 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  96919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96938 */   GIR_RootConstrainSelectedInstOperands,
     /*  96939 */   // GIR_Coverage, 7802,
     /*  96939 */   GIR_EraseRootFromParent_Done,
     /*  96940 */ // Label 1303: @96940
     /*  96940 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(96999), // Rule ID 7818 //
     /*  96945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  96948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96951 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96955 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  96960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96964 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96968 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  96975 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  96975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  96978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  96985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96993 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96997 */   GIR_RootConstrainSelectedInstOperands,
     /*  96998 */   // GIR_Coverage, 7818,
     /*  96998 */   GIR_EraseRootFromParent_Done,
     /*  96999 */ // Label 1304: @96999
     /*  96999 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(97058), // Rule ID 7820 //
     /*  97004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  97007 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97010 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97014 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  97019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97023 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97027 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  97034 */   // (AMDGPUld_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  97034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  97037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  97044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97052 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97056 */   GIR_RootConstrainSelectedInstOperands,
     /*  97057 */   // GIR_Coverage, 7820,
     /*  97057 */   GIR_EraseRootFromParent_Done,
     /*  97058 */ // Label 1305: @97058
     /*  97058 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(97113), // Rule ID 7819 //
     /*  97063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  97066 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97069 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  97074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97078 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97082 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  97089 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  97089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  97092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  97099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97107 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97111 */   GIR_RootConstrainSelectedInstOperands,
     /*  97112 */   // GIR_Coverage, 7819,
     /*  97112 */   GIR_EraseRootFromParent_Done,
     /*  97113 */ // Label 1306: @97113
     /*  97113 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(97168), // Rule ID 7821 //
     /*  97118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  97121 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97124 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  97129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97137 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  97144 */   // (ld:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  97144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  97147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  97154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97162 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97166 */   GIR_RootConstrainSelectedInstOperands,
     /*  97167 */   // GIR_Coverage, 7821,
     /*  97167 */   GIR_EraseRootFromParent_Done,
     /*  97168 */ // Label 1307: @97168
     /*  97168 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(97237), // Rule ID 3544 //
     /*  97173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97176 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97179 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97186 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97197 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97201 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97208 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /*  97211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97231 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97235 */   GIR_RootConstrainSelectedInstOperands,
     /*  97236 */   // GIR_Coverage, 3544,
     /*  97236 */   GIR_EraseRootFromParent_Done,
     /*  97237 */ // Label 1308: @97237
     /*  97237 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(97306), // Rule ID 3806 //
     /*  97242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97245 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97255 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97266 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97270 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97277 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /*  97280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97300 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97304 */   GIR_RootConstrainSelectedInstOperands,
     /*  97305 */   // GIR_Coverage, 3806,
     /*  97305 */   GIR_EraseRootFromParent_Done,
     /*  97306 */ // Label 1309: @97306
     /*  97306 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(97375), // Rule ID 3954 //
     /*  97311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97314 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97317 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97324 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97335 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97339 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97346 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  97349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97356 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97361 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97369 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97373 */   GIR_RootConstrainSelectedInstOperands,
     /*  97374 */   // GIR_Coverage, 3954,
     /*  97374 */   GIR_EraseRootFromParent_Done,
     /*  97375 */ // Label 1310: @97375
     /*  97375 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(97448), // Rule ID 3818 //
     /*  97380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97383 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97386 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97390 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97397 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97408 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97412 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97419 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /*  97422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97434 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97446 */   GIR_RootConstrainSelectedInstOperands,
     /*  97447 */   // GIR_Coverage, 3818,
     /*  97447 */   GIR_EraseRootFromParent_Done,
     /*  97448 */ // Label 1311: @97448
     /*  97448 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(97521), // Rule ID 3824 //
     /*  97453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97456 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97459 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97463 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97470 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97481 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97485 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97492 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /*  97495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97515 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97519 */   GIR_RootConstrainSelectedInstOperands,
     /*  97520 */   // GIR_Coverage, 3824,
     /*  97520 */   GIR_EraseRootFromParent_Done,
     /*  97521 */ // Label 1312: @97521
     /*  97521 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(97583), // Rule ID 3862 //
     /*  97526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97529 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97532 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97547 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97554 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  97557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97581 */   GIR_RootConstrainSelectedInstOperands,
     /*  97582 */   // GIR_Coverage, 3862,
     /*  97582 */   GIR_EraseRootFromParent_Done,
     /*  97583 */ // Label 1313: @97583
     /*  97583 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(97645), // Rule ID 3864 //
     /*  97588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97591 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97594 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97605 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97609 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  97616 */   // (ld:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[f32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  97616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  97619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  97631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  97636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97639 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97643 */   GIR_RootConstrainSelectedInstOperands,
     /*  97644 */   // GIR_Coverage, 3864,
     /*  97644 */   GIR_EraseRootFromParent_Done,
     /*  97645 */ // Label 1314: @97645
     /*  97645 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(97709), // Rule ID 3543 //
     /*  97650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97653 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97656 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97663 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97674 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97678 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  97685 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  97685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /*  97688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  97695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97703 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97707 */   GIR_RootConstrainSelectedInstOperands,
     /*  97708 */   // GIR_Coverage, 3543,
     /*  97708 */   GIR_EraseRootFromParent_Done,
     /*  97709 */ // Label 1315: @97709
     /*  97709 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(97773), // Rule ID 3805 //
     /*  97714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97717 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97720 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97727 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  97749 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  97749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /*  97752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  97759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97771 */   GIR_RootConstrainSelectedInstOperands,
     /*  97772 */   // GIR_Coverage, 3805,
     /*  97772 */   GIR_EraseRootFromParent_Done,
     /*  97773 */ // Label 1316: @97773
     /*  97773 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(97837), // Rule ID 3953 //
     /*  97778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97781 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97784 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97791 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97802 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97806 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  97813 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  97813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  97816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  97823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97835 */   GIR_RootConstrainSelectedInstOperands,
     /*  97836 */   // GIR_Coverage, 3953,
     /*  97836 */   GIR_EraseRootFromParent_Done,
     /*  97837 */ // Label 1317: @97837
     /*  97837 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(97905), // Rule ID 3817 //
     /*  97842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97848 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97852 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97859 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97874 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  97881 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  97881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /*  97884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  97891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97899 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97903 */   GIR_RootConstrainSelectedInstOperands,
     /*  97904 */   // GIR_Coverage, 3817,
     /*  97904 */   GIR_EraseRootFromParent_Done,
     /*  97905 */ // Label 1318: @97905
     /*  97905 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(97973), // Rule ID 3823 //
     /*  97910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97913 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97916 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97920 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97927 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97938 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97942 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  97949 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  97949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /*  97952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97954 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  97959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97971 */   GIR_RootConstrainSelectedInstOperands,
     /*  97972 */   // GIR_Coverage, 3823,
     /*  97972 */   GIR_EraseRootFromParent_Done,
     /*  97973 */ // Label 1319: @97973
     /*  97973 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(98030), // Rule ID 3861 //
     /*  97978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  97981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97984 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97995 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97999 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  98006 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  98009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98024 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98028 */   GIR_RootConstrainSelectedInstOperands,
     /*  98029 */   // GIR_Coverage, 3861,
     /*  98029 */   GIR_EraseRootFromParent_Done,
     /*  98030 */ // Label 1320: @98030
     /*  98030 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(98087), // Rule ID 3863 //
     /*  98035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  98038 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98041 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98052 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98056 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  98063 */   // (ld:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  98066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98068 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98073 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98081 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98085 */   GIR_RootConstrainSelectedInstOperands,
     /*  98086 */   // GIR_Coverage, 3863,
     /*  98086 */   GIR_EraseRootFromParent_Done,
     /*  98087 */ // Label 1321: @98087
     /*  98087 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(98152), // Rule ID 3572 //
     /*  98092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98095 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  98098 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98105 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98117 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98121 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98128 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /*  98131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98146 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98150 */   GIR_RootConstrainSelectedInstOperands,
     /*  98151 */   // GIR_Coverage, 3572,
     /*  98151 */   GIR_EraseRootFromParent_Done,
     /*  98152 */ // Label 1322: @98152
     /*  98152 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(98217), // Rule ID 3576 //
     /*  98157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98160 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  98163 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98170 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98193 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /*  98196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98215 */   GIR_RootConstrainSelectedInstOperands,
     /*  98216 */   // GIR_Coverage, 3576,
     /*  98216 */   GIR_EraseRootFromParent_Done,
     /*  98217 */ // Label 1323: @98217
     /*  98217 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(98282), // Rule ID 3608 //
     /*  98222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98225 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  98228 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98235 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98247 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98251 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98258 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  98261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98276 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98280 */   GIR_RootConstrainSelectedInstOperands,
     /*  98281 */   // GIR_Coverage, 3608,
     /*  98281 */   GIR_EraseRootFromParent_Done,
     /*  98282 */ // Label 1324: @98282
     /*  98282 */ GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(98351), // Rule ID 3580 //
     /*  98287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98290 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98293 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98297 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98304 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98316 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98320 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98327 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /*  98330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98332 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98345 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98349 */   GIR_RootConstrainSelectedInstOperands,
     /*  98350 */   // GIR_Coverage, 3580,
     /*  98350 */   GIR_EraseRootFromParent_Done,
     /*  98351 */ // Label 1325: @98351
     /*  98351 */ GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(98420), // Rule ID 3585 //
     /*  98356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98359 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98362 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98366 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98373 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98385 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98389 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98396 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /*  98399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98414 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98418 */   GIR_RootConstrainSelectedInstOperands,
     /*  98419 */   // GIR_Coverage, 3585,
     /*  98419 */   GIR_EraseRootFromParent_Done,
     /*  98420 */ // Label 1326: @98420
     /*  98420 */ GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(98478), // Rule ID 3612 //
     /*  98425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98431 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98443 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98447 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98454 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  98457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98472 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98476 */   GIR_RootConstrainSelectedInstOperands,
     /*  98477 */   // GIR_Coverage, 3612,
     /*  98477 */   GIR_EraseRootFromParent_Done,
     /*  98478 */ // Label 1327: @98478
     /*  98478 */ GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(98536), // Rule ID 3614 //
     /*  98483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  98486 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98489 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98501 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98505 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  98512 */   // (ld:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  98512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  98515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  98517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  98522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98530 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98534 */   GIR_RootConstrainSelectedInstOperands,
     /*  98535 */   // GIR_Coverage, 3614,
     /*  98535 */   GIR_EraseRootFromParent_Done,
     /*  98536 */ // Label 1328: @98536
     /*  98536 */ GIM_Reject,
     /*  98537 */ // Label 881: @98537
     /*  98537 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(98604), // Rule ID 3043 //
     /*  98542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  98545 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98548 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  98556 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98560 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  98564 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  98568 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  98575 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  98575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  98578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  98580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  98585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  98590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  98595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98598 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98602 */   GIR_RootConstrainSelectedInstOperands,
     /*  98603 */   // GIR_Coverage, 3043,
     /*  98603 */   GIR_EraseRootFromParent_Done,
     /*  98604 */ // Label 1329: @98604
     /*  98604 */ GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(98671), // Rule ID 3077 //
     /*  98609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  98612 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98615 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  98623 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98627 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  98631 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  98635 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  98642 */   // (ld:{ *:[f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  98642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  98645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  98647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  98652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  98657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  98662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98665 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98669 */   GIR_RootConstrainSelectedInstOperands,
     /*  98670 */   // GIR_Coverage, 3077,
     /*  98670 */   GIR_EraseRootFromParent_Done,
     /*  98671 */ // Label 1330: @98671
     /*  98671 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(98738), // Rule ID 8336 //
     /*  98676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  98679 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98682 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  98690 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98694 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  98698 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  98702 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  98709 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  98709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  98712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  98714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  98719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  98724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  98729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98732 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98736 */   GIR_RootConstrainSelectedInstOperands,
     /*  98737 */   // GIR_Coverage, 8336,
     /*  98737 */   GIR_EraseRootFromParent_Done,
     /*  98738 */ // Label 1331: @98738
     /*  98738 */ GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(98801), // Rule ID 3048 //
     /*  98743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  98746 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98749 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  98757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98761 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  98765 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  98772 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  98772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  98775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  98777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  98782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  98787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  98792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98799 */   GIR_RootConstrainSelectedInstOperands,
     /*  98800 */   // GIR_Coverage, 3048,
     /*  98800 */   GIR_EraseRootFromParent_Done,
     /*  98801 */ // Label 1332: @98801
     /*  98801 */ GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(98864), // Rule ID 3082 //
     /*  98806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  98809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98812 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  98820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98824 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  98828 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  98835 */   // (ld:{ *:[f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  98835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  98838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  98840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  98845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  98850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  98855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98858 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98862 */   GIR_RootConstrainSelectedInstOperands,
     /*  98863 */   // GIR_Coverage, 3082,
     /*  98863 */   GIR_EraseRootFromParent_Done,
     /*  98864 */ // Label 1333: @98864
     /*  98864 */ GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(98927), // Rule ID 8341 //
     /*  98869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  98872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98875 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  98883 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98887 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  98891 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  98898 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  98898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  98901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  98903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  98908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  98913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  98918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98925 */   GIR_RootConstrainSelectedInstOperands,
     /*  98926 */   // GIR_Coverage, 8341,
     /*  98926 */   GIR_EraseRootFromParent_Done,
     /*  98927 */ // Label 1334: @98927
     /*  98927 */ GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(98990), // Rule ID 3054 //
     /*  98932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  98935 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98938 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  98946 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98950 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  98954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  98961 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  98961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  98964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  98966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  98971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  98976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  98981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98984 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98988 */   GIR_RootConstrainSelectedInstOperands,
     /*  98989 */   // GIR_Coverage, 3054,
     /*  98989 */   GIR_EraseRootFromParent_Done,
     /*  98990 */ // Label 1335: @98990
     /*  98990 */ GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(99053), // Rule ID 3088 //
     /*  98995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  98998 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99001 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99009 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99013 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99017 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  99024 */   // (ld:{ *:[f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  99027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99047 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99051 */   GIR_RootConstrainSelectedInstOperands,
     /*  99052 */   // GIR_Coverage, 3088,
     /*  99052 */   GIR_EraseRootFromParent_Done,
     /*  99053 */ // Label 1336: @99053
     /*  99053 */ GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(99116), // Rule ID 8347 //
     /*  99058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  99061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99064 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99072 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99076 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99080 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  99087 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  99090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99110 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99114 */   GIR_RootConstrainSelectedInstOperands,
     /*  99115 */   // GIR_Coverage, 8347,
     /*  99115 */   GIR_EraseRootFromParent_Done,
     /*  99116 */ // Label 1337: @99116
     /*  99116 */ GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(99178), // Rule ID 3039 //
     /*  99121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  99124 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99127 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99135 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99139 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99143 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99147 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  99154 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  99157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99159 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99164 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99172 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99176 */   GIR_RootConstrainSelectedInstOperands,
     /*  99177 */   // GIR_Coverage, 3039,
     /*  99177 */   GIR_EraseRootFromParent_Done,
     /*  99178 */ // Label 1338: @99178
     /*  99178 */ GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(99240), // Rule ID 3040 //
     /*  99183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  99186 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99189 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99197 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99201 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99205 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  99216 */   // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  99219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99234 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99238 */   GIR_RootConstrainSelectedInstOperands,
     /*  99239 */   // GIR_Coverage, 3040,
     /*  99239 */   GIR_EraseRootFromParent_Done,
     /*  99240 */ // Label 1339: @99240
     /*  99240 */ GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(99302), // Rule ID 3041 //
     /*  99245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  99248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99251 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99263 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99267 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99271 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  99278 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  99278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  99281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99296 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99300 */   GIR_RootConstrainSelectedInstOperands,
     /*  99301 */   // GIR_Coverage, 3041,
     /*  99301 */   GIR_EraseRootFromParent_Done,
     /*  99302 */ // Label 1340: @99302
     /*  99302 */ GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(99367), // Rule ID 3042 //
     /*  99307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  99310 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99313 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99321 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99325 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99329 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99333 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  99340 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  99340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  99343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99361 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99365 */   GIR_RootConstrainSelectedInstOperands,
     /*  99366 */   // GIR_Coverage, 3042,
     /*  99366 */   GIR_EraseRootFromParent_Done,
     /*  99367 */ // Label 1341: @99367
     /*  99367 */ GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(99429), // Rule ID 3073 //
     /*  99372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  99375 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99378 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99390 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99394 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99398 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  99405 */   // (ld:{ *:[f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  99408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99423 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99427 */   GIR_RootConstrainSelectedInstOperands,
     /*  99428 */   // GIR_Coverage, 3073,
     /*  99428 */   GIR_EraseRootFromParent_Done,
     /*  99429 */ // Label 1342: @99429
     /*  99429 */ GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(99491), // Rule ID 3074 //
     /*  99434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  99437 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99440 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99448 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99452 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99456 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99460 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  99467 */   // (ld:{ *:[f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  99470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99477 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99485 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99489 */   GIR_RootConstrainSelectedInstOperands,
     /*  99490 */   // GIR_Coverage, 3074,
     /*  99490 */   GIR_EraseRootFromParent_Done,
     /*  99491 */ // Label 1343: @99491
     /*  99491 */ GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(99553), // Rule ID 3075 //
     /*  99496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  99499 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99502 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99510 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99514 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99518 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99522 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  99529 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  99529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  99532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99547 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99551 */   GIR_RootConstrainSelectedInstOperands,
     /*  99552 */   // GIR_Coverage, 3075,
     /*  99552 */   GIR_EraseRootFromParent_Done,
     /*  99553 */ // Label 1344: @99553
     /*  99553 */ GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(99618), // Rule ID 3076 //
     /*  99558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  99561 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99564 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99572 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99576 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99580 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99584 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  99591 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  99591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  99594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99612 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99616 */   GIR_RootConstrainSelectedInstOperands,
     /*  99617 */   // GIR_Coverage, 3076,
     /*  99617 */   GIR_EraseRootFromParent_Done,
     /*  99618 */ // Label 1345: @99618
     /*  99618 */ GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(99680), // Rule ID 8332 //
     /*  99623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  99626 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99629 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99637 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99641 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99645 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99649 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  99656 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  99659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99674 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99678 */   GIR_RootConstrainSelectedInstOperands,
     /*  99679 */   // GIR_Coverage, 8332,
     /*  99679 */   GIR_EraseRootFromParent_Done,
     /*  99680 */ // Label 1346: @99680
     /*  99680 */ GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(99742), // Rule ID 8333 //
     /*  99685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  99688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99691 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99699 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99703 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99707 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99711 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  99718 */   // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  99721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99728 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99736 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99740 */   GIR_RootConstrainSelectedInstOperands,
     /*  99741 */   // GIR_Coverage, 8333,
     /*  99741 */   GIR_EraseRootFromParent_Done,
     /*  99742 */ // Label 1347: @99742
     /*  99742 */ GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(99804), // Rule ID 8334 //
     /*  99747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  99750 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99753 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99761 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99765 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99769 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99773 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  99780 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  99780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  99783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99802 */   GIR_RootConstrainSelectedInstOperands,
     /*  99803 */   // GIR_Coverage, 8334,
     /*  99803 */   GIR_EraseRootFromParent_Done,
     /*  99804 */ // Label 1348: @99804
     /*  99804 */ GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(99869), // Rule ID 8335 //
     /*  99809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  99812 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99815 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99823 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99827 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99831 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  99835 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  99842 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  99842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  99845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99863 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99867 */   GIR_RootConstrainSelectedInstOperands,
     /*  99868 */   // GIR_Coverage, 8335,
     /*  99868 */   GIR_EraseRootFromParent_Done,
     /*  99869 */ // Label 1349: @99869
     /*  99869 */ GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(99927), // Rule ID 3045 //
     /*  99874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  99877 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99880 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99888 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99892 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99896 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  99903 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  99903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  99906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99925 */   GIR_RootConstrainSelectedInstOperands,
     /*  99926 */   // GIR_Coverage, 3045,
     /*  99926 */   GIR_EraseRootFromParent_Done,
     /*  99927 */ // Label 1350: @99927
     /*  99927 */ GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(99985), // Rule ID 3046 //
     /*  99932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  99935 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99938 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  99946 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99950 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  99954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  99961 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  99961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /*  99964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  99966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  99971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99983 */   GIR_RootConstrainSelectedInstOperands,
     /*  99984 */   // GIR_Coverage, 3046,
     /*  99984 */   GIR_EraseRootFromParent_Done,
     /*  99985 */ // Label 1351: @99985
     /*  99985 */ GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(100046), // Rule ID 3047 //
     /*  99990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  99993 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99996 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100008 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100012 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100019 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 100019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 100022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100040 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100044 */   GIR_RootConstrainSelectedInstOperands,
     /* 100045 */   // GIR_Coverage, 3047,
     /* 100045 */   GIR_EraseRootFromParent_Done,
     /* 100046 */ // Label 1352: @100046
     /* 100046 */ GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(100104), // Rule ID 3079 //
     /* 100051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 100054 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100057 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100069 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 100080 */   // (ld:{ *:[f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 100080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 100083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100098 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100102 */   GIR_RootConstrainSelectedInstOperands,
     /* 100103 */   // GIR_Coverage, 3079,
     /* 100103 */   GIR_EraseRootFromParent_Done,
     /* 100104 */ // Label 1353: @100104
     /* 100104 */ GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(100162), // Rule ID 3080 //
     /* 100109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 100112 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100115 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100123 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100127 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100131 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100138 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 100138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 100141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100156 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100160 */   GIR_RootConstrainSelectedInstOperands,
     /* 100161 */   // GIR_Coverage, 3080,
     /* 100161 */   GIR_EraseRootFromParent_Done,
     /* 100162 */ // Label 1354: @100162
     /* 100162 */ GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(100223), // Rule ID 3081 //
     /* 100167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 100170 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100173 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100181 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100185 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100196 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 100196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 100199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100217 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100221 */   GIR_RootConstrainSelectedInstOperands,
     /* 100222 */   // GIR_Coverage, 3081,
     /* 100222 */   GIR_EraseRootFromParent_Done,
     /* 100223 */ // Label 1355: @100223
     /* 100223 */ GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(100281), // Rule ID 8338 //
     /* 100228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 100231 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100234 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100242 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100246 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100250 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 100257 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 100257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 100260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100275 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100279 */   GIR_RootConstrainSelectedInstOperands,
     /* 100280 */   // GIR_Coverage, 8338,
     /* 100280 */   GIR_EraseRootFromParent_Done,
     /* 100281 */ // Label 1356: @100281
     /* 100281 */ GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(100339), // Rule ID 8339 //
     /* 100286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 100289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100292 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100300 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100304 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100308 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100315 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 100315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 100318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100333 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100337 */   GIR_RootConstrainSelectedInstOperands,
     /* 100338 */   // GIR_Coverage, 8339,
     /* 100338 */   GIR_EraseRootFromParent_Done,
     /* 100339 */ // Label 1357: @100339
     /* 100339 */ GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(100400), // Rule ID 8340 //
     /* 100344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 100347 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100350 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100358 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100362 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100366 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100373 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 100373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 100376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100378 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100383 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100398 */   GIR_RootConstrainSelectedInstOperands,
     /* 100399 */   // GIR_Coverage, 8340,
     /* 100399 */   GIR_EraseRootFromParent_Done,
     /* 100400 */ // Label 1358: @100400
     /* 100400 */ GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(100468), // Rule ID 8052 //
     /* 100405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 100408 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100411 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100415 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100420 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 100429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100433 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 100437 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100444 */   // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 100447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100462 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100466 */   GIR_RootConstrainSelectedInstOperands,
     /* 100467 */   // GIR_Coverage, 8052,
     /* 100467 */   GIR_EraseRootFromParent_Done,
     /* 100468 */ // Label 1359: @100468
     /* 100468 */ GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(100536), // Rule ID 8056 //
     /* 100473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 100476 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100479 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100483 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100488 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 100497 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100501 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 100505 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100512 */   // (AMDGPUld_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 100515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100530 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100534 */   GIR_RootConstrainSelectedInstOperands,
     /* 100535 */   // GIR_Coverage, 8056,
     /* 100535 */   GIR_EraseRootFromParent_Done,
     /* 100536 */ // Label 1360: @100536
     /* 100536 */ GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(100599), // Rule ID 7984 //
     /* 100541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 100544 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100547 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100551 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100556 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 100560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 100564 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100568 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100575 */   // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 100578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100593 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100597 */   GIR_RootConstrainSelectedInstOperands,
     /* 100598 */   // GIR_Coverage, 7984,
     /* 100598 */   GIR_EraseRootFromParent_Done,
     /* 100599 */ // Label 1361: @100599
     /* 100599 */ GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(100662), // Rule ID 7988 //
     /* 100604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 100607 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100610 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100614 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100619 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 100623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 100627 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100631 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100638 */   // (AMDGPUld_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 100641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100656 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100660 */   GIR_RootConstrainSelectedInstOperands,
     /* 100661 */   // GIR_Coverage, 7988,
     /* 100661 */   GIR_EraseRootFromParent_Done,
     /* 100662 */ // Label 1362: @100662
     /* 100662 */ GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(100717), // Rule ID 3050 //
     /* 100667 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100670 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100678 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100682 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100686 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 100693 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 100693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 100696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100711 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100715 */   GIR_RootConstrainSelectedInstOperands,
     /* 100716 */   // GIR_Coverage, 3050,
     /* 100716 */   GIR_EraseRootFromParent_Done,
     /* 100717 */ // Label 1363: @100717
     /* 100717 */ GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(100775), // Rule ID 3051 //
     /* 100722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 100725 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100728 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100740 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 100751 */   // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 100751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 100754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100769 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100773 */   GIR_RootConstrainSelectedInstOperands,
     /* 100774 */   // GIR_Coverage, 3051,
     /* 100774 */   GIR_EraseRootFromParent_Done,
     /* 100775 */ // Label 1364: @100775
     /* 100775 */ GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(100833), // Rule ID 3052 //
     /* 100780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 100783 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100786 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100798 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100802 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100809 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 100809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 100812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100827 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100831 */   GIR_RootConstrainSelectedInstOperands,
     /* 100832 */   // GIR_Coverage, 3052,
     /* 100832 */   GIR_EraseRootFromParent_Done,
     /* 100833 */ // Label 1365: @100833
     /* 100833 */ GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(100894), // Rule ID 3053 //
     /* 100838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 100841 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100844 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100852 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100856 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100860 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 100867 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 100867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 100870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 100882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100892 */   GIR_RootConstrainSelectedInstOperands,
     /* 100893 */   // GIR_Coverage, 3053,
     /* 100893 */   GIR_EraseRootFromParent_Done,
     /* 100894 */ // Label 1366: @100894
     /* 100894 */ GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(100949), // Rule ID 3084 //
     /* 100899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100902 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100910 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100914 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100918 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 100925 */   // (ld:{ *:[f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 100925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 100928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100943 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100947 */   GIR_RootConstrainSelectedInstOperands,
     /* 100948 */   // GIR_Coverage, 3084,
     /* 100948 */   GIR_EraseRootFromParent_Done,
     /* 100949 */ // Label 1367: @100949
     /* 100949 */ GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(101007), // Rule ID 3085 //
     /* 100954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 100957 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100960 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 100968 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100972 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 100976 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 100983 */   // (ld:{ *:[f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 100983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 100986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 100988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 100993 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101001 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101005 */   GIR_RootConstrainSelectedInstOperands,
     /* 101006 */   // GIR_Coverage, 3085,
     /* 101006 */   GIR_EraseRootFromParent_Done,
     /* 101007 */ // Label 1368: @101007
     /* 101007 */ GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(101065), // Rule ID 3086 //
     /* 101012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 101015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101030 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101034 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 101041 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 101041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 101044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 101056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101063 */   GIR_RootConstrainSelectedInstOperands,
     /* 101064 */   // GIR_Coverage, 3086,
     /* 101064 */   GIR_EraseRootFromParent_Done,
     /* 101065 */ // Label 1369: @101065
     /* 101065 */ GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(101126), // Rule ID 3087 //
     /* 101070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 101073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101076 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101088 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101092 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 101099 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 101102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 101114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101120 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101124 */   GIR_RootConstrainSelectedInstOperands,
     /* 101125 */   // GIR_Coverage, 3087,
     /* 101125 */   GIR_EraseRootFromParent_Done,
     /* 101126 */ // Label 1370: @101126
     /* 101126 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(101181), // Rule ID 8343 //
     /* 101131 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101134 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101142 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101146 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101150 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 101157 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 101157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 101160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101175 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101179 */   GIR_RootConstrainSelectedInstOperands,
     /* 101180 */   // GIR_Coverage, 8343,
     /* 101180 */   GIR_EraseRootFromParent_Done,
     /* 101181 */ // Label 1371: @101181
     /* 101181 */ GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(101239), // Rule ID 8344 //
     /* 101186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 101189 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101192 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101200 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101204 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101208 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 101215 */   // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 101215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 101218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101225 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101237 */   GIR_RootConstrainSelectedInstOperands,
     /* 101238 */   // GIR_Coverage, 8344,
     /* 101238 */   GIR_EraseRootFromParent_Done,
     /* 101239 */ // Label 1372: @101239
     /* 101239 */ GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(101297), // Rule ID 8345 //
     /* 101244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 101247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101250 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101262 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 101273 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 101273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 101276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 101288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101291 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101295 */   GIR_RootConstrainSelectedInstOperands,
     /* 101296 */   // GIR_Coverage, 8345,
     /* 101296 */   GIR_EraseRootFromParent_Done,
     /* 101297 */ // Label 1373: @101297
     /* 101297 */ GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(101358), // Rule ID 8346 //
     /* 101302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 101305 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101308 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101316 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101320 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101324 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 101331 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 101334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 101341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 101346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101352 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101356 */   GIR_RootConstrainSelectedInstOperands,
     /* 101357 */   // GIR_Coverage, 8346,
     /* 101357 */   GIR_EraseRootFromParent_Done,
     /* 101358 */ // Label 1374: @101358
     /* 101358 */ GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(101422), // Rule ID 8053 //
     /* 101363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 101366 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101369 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 101374 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 101379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 101383 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101387 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 101391 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 101398 */   // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 101398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 101401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 101408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101416 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101420 */   GIR_RootConstrainSelectedInstOperands,
     /* 101421 */   // GIR_Coverage, 8053,
     /* 101421 */   GIR_EraseRootFromParent_Done,
     /* 101422 */ // Label 1375: @101422
     /* 101422 */ GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(101486), // Rule ID 8057 //
     /* 101427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 101430 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101433 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 101438 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 101443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 101447 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101451 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 101455 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 101462 */   // (ld:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 101462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 101465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 101472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101480 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101484 */   GIR_RootConstrainSelectedInstOperands,
     /* 101485 */   // GIR_Coverage, 8057,
     /* 101485 */   GIR_EraseRootFromParent_Done,
     /* 101486 */ // Label 1376: @101486
     /* 101486 */ GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(101545), // Rule ID 7985 //
     /* 101491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 101494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101497 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 101502 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 101506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 101510 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101514 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 101521 */   // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 101521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 101524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 101531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101539 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101543 */   GIR_RootConstrainSelectedInstOperands,
     /* 101544 */   // GIR_Coverage, 7985,
     /* 101544 */   GIR_EraseRootFromParent_Done,
     /* 101545 */ // Label 1377: @101545
     /* 101545 */ GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(101604), // Rule ID 7989 //
     /* 101550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 101553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101556 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 101561 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 101565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 101569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101573 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 101580 */   // (ld:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 101580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 101583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 101590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101598 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101602 */   GIR_RootConstrainSelectedInstOperands,
     /* 101603 */   // GIR_Coverage, 7989,
     /* 101603 */   GIR_EraseRootFromParent_Done,
     /* 101604 */ // Label 1378: @101604
     /* 101604 */ GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(101658), // Rule ID 3044 //
     /* 101609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 101612 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101615 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101623 */   // MIs[0] sbase
     /* 101623 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 101631 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101635 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 101639 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 101642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101644 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 101646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101656 */   GIR_RootConstrainSelectedInstOperands,
     /* 101657 */   // GIR_Coverage, 3044,
     /* 101657 */   GIR_EraseRootFromParent_Done,
     /* 101658 */ // Label 1379: @101658
     /* 101658 */ GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(101712), // Rule ID 3078 //
     /* 101663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 101666 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101669 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101677 */   // MIs[0] sbase
     /* 101677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 101685 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101689 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 101693 */   // (ld:{ *:[f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 101696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101698 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 101700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101706 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101710 */   GIR_RootConstrainSelectedInstOperands,
     /* 101711 */   // GIR_Coverage, 3078,
     /* 101711 */   GIR_EraseRootFromParent_Done,
     /* 101712 */ // Label 1380: @101712
     /* 101712 */ GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(101766), // Rule ID 8337 //
     /* 101717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 101720 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101723 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101731 */   // MIs[0] sbase
     /* 101731 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 101739 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101743 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 101747 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 101750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101752 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 101754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101760 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101764 */   GIR_RootConstrainSelectedInstOperands,
     /* 101765 */   // GIR_Coverage, 8337,
     /* 101765 */   GIR_EraseRootFromParent_Done,
     /* 101766 */ // Label 1381: @101766
     /* 101766 */ GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(101816), // Rule ID 3049 //
     /* 101771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 101774 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101777 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101785 */   // MIs[0] sbase
     /* 101785 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 101793 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101797 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 101800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101802 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 101804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101810 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101814 */   GIR_RootConstrainSelectedInstOperands,
     /* 101815 */   // GIR_Coverage, 3049,
     /* 101815 */   GIR_EraseRootFromParent_Done,
     /* 101816 */ // Label 1382: @101816
     /* 101816 */ GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(101866), // Rule ID 3083 //
     /* 101821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 101824 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101827 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101835 */   // MIs[0] sbase
     /* 101835 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 101843 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101847 */   // (ld:{ *:[f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 101850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101852 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 101854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101860 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101864 */   GIR_RootConstrainSelectedInstOperands,
     /* 101865 */   // GIR_Coverage, 3083,
     /* 101865 */   GIR_EraseRootFromParent_Done,
     /* 101866 */ // Label 1383: @101866
     /* 101866 */ GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(101916), // Rule ID 8342 //
     /* 101871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 101874 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101877 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101885 */   // MIs[0] sbase
     /* 101885 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 101893 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101897 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 101900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101902 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 101904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101914 */   GIR_RootConstrainSelectedInstOperands,
     /* 101915 */   // GIR_Coverage, 8342,
     /* 101915 */   GIR_EraseRootFromParent_Done,
     /* 101916 */ // Label 1384: @101916
     /* 101916 */ GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(101963), // Rule ID 3055 //
     /* 101921 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101924 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101932 */   // MIs[0] sbase
     /* 101932 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 101940 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101944 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 101947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101949 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 101951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101957 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101961 */   GIR_RootConstrainSelectedInstOperands,
     /* 101962 */   // GIR_Coverage, 3055,
     /* 101962 */   GIR_EraseRootFromParent_Done,
     /* 101963 */ // Label 1385: @101963
     /* 101963 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(102010), // Rule ID 3089 //
     /* 101968 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101971 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 101979 */   // MIs[0] sbase
     /* 101979 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 101987 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 101991 */   // (ld:{ *:[f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 101991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 101994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 101996 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 101998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102008 */   GIR_RootConstrainSelectedInstOperands,
     /* 102009 */   // GIR_Coverage, 3089,
     /* 102009 */   GIR_EraseRootFromParent_Done,
     /* 102010 */ // Label 1386: @102010
     /* 102010 */ GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(102057), // Rule ID 8348 //
     /* 102015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102026 */   // MIs[0] sbase
     /* 102026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 102034 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102038 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 102038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 102041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102043 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 102045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102051 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102055 */   GIR_RootConstrainSelectedInstOperands,
     /* 102056 */   // GIR_Coverage, 8348,
     /* 102056 */   GIR_EraseRootFromParent_Done,
     /* 102057 */ // Label 1387: @102057
     /* 102057 */ GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(102117), // Rule ID 4293 //
     /* 102062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 102065 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102068 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 102073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102077 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102081 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 102088 */   // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 102091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 102098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 102103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102111 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102115 */   GIR_RootConstrainSelectedInstOperands,
     /* 102116 */   // GIR_Coverage, 4293,
     /* 102116 */   GIR_EraseRootFromParent_Done,
     /* 102117 */ // Label 1388: @102117
     /* 102117 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(102177), // Rule ID 4299 //
     /* 102122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 102125 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102128 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 102133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102137 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102141 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 102148 */   // (ld:{ *:[f64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 102151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 102158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 102163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102171 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102175 */   GIR_RootConstrainSelectedInstOperands,
     /* 102176 */   // GIR_Coverage, 4299,
     /* 102176 */   GIR_EraseRootFromParent_Done,
     /* 102177 */ // Label 1389: @102177
     /* 102177 */ GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(102232), // Rule ID 4292 //
     /* 102182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 102185 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102188 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 102193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102197 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102201 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 102208 */   // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 102208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 102211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 102218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102226 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102230 */   GIR_RootConstrainSelectedInstOperands,
     /* 102231 */   // GIR_Coverage, 4292,
     /* 102231 */   GIR_EraseRootFromParent_Done,
     /* 102232 */ // Label 1390: @102232
     /* 102232 */ GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(102287), // Rule ID 4298 //
     /* 102237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 102240 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102243 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 102248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102252 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102256 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 102263 */   // (ld:{ *:[f64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[f64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 102263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 102266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 102273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102281 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102285 */   GIR_RootConstrainSelectedInstOperands,
     /* 102286 */   // GIR_Coverage, 4298,
     /* 102286 */   GIR_EraseRootFromParent_Done,
     /* 102287 */ // Label 1391: @102287
     /* 102287 */ GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(102342), // Rule ID 4291 //
     /* 102292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 102295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102298 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 102303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102307 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102311 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 102318 */   // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 102318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 102321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 102328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102336 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102340 */   GIR_RootConstrainSelectedInstOperands,
     /* 102341 */   // GIR_Coverage, 4291,
     /* 102341 */   GIR_EraseRootFromParent_Done,
     /* 102342 */ // Label 1392: @102342
     /* 102342 */ GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(102397), // Rule ID 4297 //
     /* 102347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 102350 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102353 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 102358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102362 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102366 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 102373 */   // (ld:{ *:[f64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 102373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 102376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102378 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 102383 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102391 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102395 */   GIR_RootConstrainSelectedInstOperands,
     /* 102396 */   // GIR_Coverage, 4297,
     /* 102396 */   GIR_EraseRootFromParent_Done,
     /* 102397 */ // Label 1393: @102397
     /* 102397 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(102474), // Rule ID 6420 //
     /* 102402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 102405 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102408 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102415 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102430 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 102437 */   // (atomic_load:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 102437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 102440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 102442 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 102447 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 102452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 102457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 102462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102472 */   GIR_RootConstrainSelectedInstOperands,
     /* 102473 */   // GIR_Coverage, 6420,
     /* 102473 */   GIR_EraseRootFromParent_Done,
     /* 102474 */ // Label 1394: @102474
     /* 102474 */ GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(102544), // Rule ID 4527 //
     /* 102479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 102482 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102485 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102496 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102500 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 102507 */   // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 102507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 102510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 102512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 102517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 102522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 102527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 102532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102538 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102542 */   GIR_RootConstrainSelectedInstOperands,
     /* 102543 */   // GIR_Coverage, 4527,
     /* 102543 */   GIR_EraseRootFromParent_Done,
     /* 102544 */ // Label 1395: @102544
     /* 102544 */ GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(102611), // Rule ID 4529 //
     /* 102549 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102552 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102563 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102567 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 102574 */   // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 102574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 102577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 102579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 102584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 102589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 102594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 102599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102605 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102609 */   GIR_RootConstrainSelectedInstOperands,
     /* 102610 */   // GIR_Coverage, 4529,
     /* 102610 */   GIR_EraseRootFromParent_Done,
     /* 102611 */ // Label 1396: @102611
     /* 102611 */ GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(102681), // Rule ID 4531 //
     /* 102616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 102619 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102622 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102633 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102637 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 102644 */   // (ld:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 102644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 102647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 102649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 102654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 102659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 102664 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 102669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102675 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102679 */   GIR_RootConstrainSelectedInstOperands,
     /* 102680 */   // GIR_Coverage, 4531,
     /* 102680 */   GIR_EraseRootFromParent_Done,
     /* 102681 */ // Label 1397: @102681
     /* 102681 */ GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(102748), // Rule ID 4533 //
     /* 102686 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102689 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102700 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102704 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 102711 */   // (ld:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 102711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 102714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 102716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 102721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 102726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 102731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 102736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102742 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102746 */   GIR_RootConstrainSelectedInstOperands,
     /* 102747 */   // GIR_Coverage, 4533,
     /* 102747 */   GIR_EraseRootFromParent_Done,
     /* 102748 */ // Label 1398: @102748
     /* 102748 */ GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(102812), // Rule ID 7924 //
     /* 102753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 102756 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102759 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102763 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 102768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102772 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102776 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 102783 */   // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 102783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 102786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 102793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 102798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 102803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102806 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102810 */   GIR_RootConstrainSelectedInstOperands,
     /* 102811 */   // GIR_Coverage, 7924,
     /* 102811 */   GIR_EraseRootFromParent_Done,
     /* 102812 */ // Label 1399: @102812
     /* 102812 */ GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(102876), // Rule ID 7932 //
     /* 102817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 102820 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102823 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102827 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 102832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102836 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102840 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 102847 */   // (AMDGPUld_glue:{ *:[f64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 102847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 102850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 102857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 102862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 102867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102870 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102874 */   GIR_RootConstrainSelectedInstOperands,
     /* 102875 */   // GIR_Coverage, 7932,
     /* 102875 */   GIR_EraseRootFromParent_Done,
     /* 102876 */ // Label 1400: @102876
     /* 102876 */ GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(102941), // Rule ID 4526 //
     /* 102881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 102884 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102887 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102898 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102902 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 102909 */   // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 102909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 102912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 102914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 102919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 102924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102935 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102939 */   GIR_RootConstrainSelectedInstOperands,
     /* 102940 */   // GIR_Coverage, 4526,
     /* 102940 */   GIR_EraseRootFromParent_Done,
     /* 102941 */ // Label 1401: @102941
     /* 102941 */ GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(103003), // Rule ID 4528 //
     /* 102946 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102949 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 102960 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102964 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 102971 */   // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 102971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 102974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 102976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 102981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 102986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103001 */   GIR_RootConstrainSelectedInstOperands,
     /* 103002 */   // GIR_Coverage, 4528,
     /* 103002 */   GIR_EraseRootFromParent_Done,
     /* 103003 */ // Label 1402: @103003
     /* 103003 */ GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(103068), // Rule ID 4530 //
     /* 103008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 103011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103014 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103025 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 103036 */   // (ld:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 103036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 103039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 103041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 103046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 103056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103066 */   GIR_RootConstrainSelectedInstOperands,
     /* 103067 */   // GIR_Coverage, 4530,
     /* 103067 */   GIR_EraseRootFromParent_Done,
     /* 103068 */ // Label 1403: @103068
     /* 103068 */ GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(103130), // Rule ID 4532 //
     /* 103073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103076 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103087 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103091 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 103098 */   // (ld:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 103098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 103101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 103103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 103108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 103118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103124 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103128 */   GIR_RootConstrainSelectedInstOperands,
     /* 103129 */   // GIR_Coverage, 4532,
     /* 103129 */   GIR_EraseRootFromParent_Done,
     /* 103130 */ // Label 1404: @103130
     /* 103130 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(103190), // Rule ID 7926 //
     /* 103135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 103138 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103141 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 103146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103154 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 103161 */   // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 103161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 103164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 103171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 103176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 103181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103184 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103188 */   GIR_RootConstrainSelectedInstOperands,
     /* 103189 */   // GIR_Coverage, 7926,
     /* 103189 */   GIR_EraseRootFromParent_Done,
     /* 103190 */ // Label 1405: @103190
     /* 103190 */ GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(103250), // Rule ID 7934 //
     /* 103195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 103198 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103201 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 103206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103210 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103214 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 103221 */   // (ld:{ *:[f64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 103221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 103224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 103231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 103236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 103241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103244 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103248 */   GIR_RootConstrainSelectedInstOperands,
     /* 103249 */   // GIR_Coverage, 7934,
     /* 103249 */   GIR_EraseRootFromParent_Done,
     /* 103250 */ // Label 1406: @103250
     /* 103250 */ GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(103312), // Rule ID 7864 //
     /* 103255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 103258 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103261 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103268 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 103273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103281 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 103288 */   // (AMDGPUatomic_ld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64_glue>><<P:Predicate_atomic_load_64_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 103288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 103291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 103298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103306 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103310 */   GIR_RootConstrainSelectedInstOperands,
     /* 103311 */   // GIR_Coverage, 7864,
     /* 103311 */   GIR_EraseRootFromParent_Done,
     /* 103312 */ // Label 1407: @103312
     /* 103312 */ GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(103374), // Rule ID 7865 //
     /* 103317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 103320 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103330 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 103335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103339 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103343 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 103350 */   // (atomic_load:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 103350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 103353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 103360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103368 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103372 */   GIR_RootConstrainSelectedInstOperands,
     /* 103373 */   // GIR_Coverage, 7865,
     /* 103373 */   GIR_EraseRootFromParent_Done,
     /* 103374 */ // Label 1408: @103374
     /* 103374 */ GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(103443), // Rule ID 3956 //
     /* 103379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 103382 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103385 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103392 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103403 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103407 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 103414 */   // (atomic_load:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 103414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 103417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 103424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 103429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 103434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103437 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103441 */   GIR_RootConstrainSelectedInstOperands,
     /* 103442 */   // GIR_Coverage, 3956,
     /* 103442 */   GIR_EraseRootFromParent_Done,
     /* 103443 */ // Label 1409: @103443
     /* 103443 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(103505), // Rule ID 3892 //
     /* 103448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 103451 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103454 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103469 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 103476 */   // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 103476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 103479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 103486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 103491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 103496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103499 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103503 */   GIR_RootConstrainSelectedInstOperands,
     /* 103504 */   // GIR_Coverage, 3892,
     /* 103504 */   GIR_EraseRootFromParent_Done,
     /* 103505 */ // Label 1410: @103505
     /* 103505 */ GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(103567), // Rule ID 3896 //
     /* 103510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 103513 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103516 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103527 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103531 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 103538 */   // (ld:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[f64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 103538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 103541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 103548 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 103553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 103558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103561 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103565 */   GIR_RootConstrainSelectedInstOperands,
     /* 103566 */   // GIR_Coverage, 3896,
     /* 103566 */   GIR_EraseRootFromParent_Done,
     /* 103567 */ // Label 1411: @103567
     /* 103567 */ GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(103631), // Rule ID 3955 //
     /* 103572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 103575 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103578 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103585 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103596 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103600 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 103607 */   // (atomic_load:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 103607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 103610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 103617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103629 */   GIR_RootConstrainSelectedInstOperands,
     /* 103630 */   // GIR_Coverage, 3955,
     /* 103630 */   GIR_EraseRootFromParent_Done,
     /* 103631 */ // Label 1412: @103631
     /* 103631 */ GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(103688), // Rule ID 3891 //
     /* 103636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 103639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103642 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103653 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 103664 */   // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 103664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 103667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 103674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103682 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103686 */   GIR_RootConstrainSelectedInstOperands,
     /* 103687 */   // GIR_Coverage, 3891,
     /* 103687 */   GIR_EraseRootFromParent_Done,
     /* 103688 */ // Label 1413: @103688
     /* 103688 */ GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(103745), // Rule ID 3895 //
     /* 103693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 103696 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103699 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103710 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103714 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 103721 */   // (ld:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 103721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 103724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 103731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103739 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103743 */   GIR_RootConstrainSelectedInstOperands,
     /* 103744 */   // GIR_Coverage, 3895,
     /* 103744 */   GIR_EraseRootFromParent_Done,
     /* 103745 */ // Label 1414: @103745
     /* 103745 */ GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(103810), // Rule ID 3609 //
     /* 103750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 103753 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103756 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103763 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103775 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103779 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 103786 */   // (atomic_load:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 103786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 103789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 103796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103804 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103808 */   GIR_RootConstrainSelectedInstOperands,
     /* 103809 */   // GIR_Coverage, 3609,
     /* 103809 */   GIR_EraseRootFromParent_Done,
     /* 103810 */ // Label 1415: @103810
     /* 103810 */ GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(103868), // Rule ID 3629 //
     /* 103815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 103818 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103821 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103833 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103837 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 103844 */   // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 103844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 103847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 103854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103862 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103866 */   GIR_RootConstrainSelectedInstOperands,
     /* 103867 */   // GIR_Coverage, 3629,
     /* 103867 */   GIR_EraseRootFromParent_Done,
     /* 103868 */ // Label 1416: @103868
     /* 103868 */ GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(103926), // Rule ID 3631 //
     /* 103873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 103876 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103879 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 103887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 103891 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103895 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 103902 */   // (ld:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 103902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 103905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 103907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 103912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103924 */   GIR_RootConstrainSelectedInstOperands,
     /* 103925 */   // GIR_Coverage, 3631,
     /* 103925 */   GIR_EraseRootFromParent_Done,
     /* 103926 */ // Label 1417: @103926
     /* 103926 */ GIM_Reject,
     /* 103927 */ // Label 882: @103927
     /* 103927 */ GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(107170),
     /* 103932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103935 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(103999), // Rule ID 2954 //
     /* 103940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 103943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 103951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103959 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 103963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 103970 */     // (ld:{ *:[v2i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 103970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 103973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 103990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103997 */     GIR_RootConstrainSelectedInstOperands,
     /* 103998 */     // GIR_Coverage, 2954,
     /* 103998 */     GIR_EraseRootFromParent_Done,
     /* 103999 */   // Label 1419: @103999
     /* 103999 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(104063), // Rule ID 2966 //
     /* 104004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 104007 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104019 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104023 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 104034 */     // (ld:{ *:[v2f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 104037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 104054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104061 */     GIR_RootConstrainSelectedInstOperands,
     /* 104062 */     // GIR_Coverage, 2966,
     /* 104062 */     GIR_EraseRootFromParent_Done,
     /* 104063 */   // Label 1420: @104063
     /* 104063 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(104123), // Rule ID 2960 //
     /* 104068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 104071 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 104094 */     // (ld:{ *:[v2i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 104097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 104114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104121 */     GIR_RootConstrainSelectedInstOperands,
     /* 104122 */     // GIR_Coverage, 2960,
     /* 104122 */     GIR_EraseRootFromParent_Done,
     /* 104123 */   // Label 1421: @104123
     /* 104123 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(104183), // Rule ID 2972 //
     /* 104128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 104131 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104143 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 104154 */     // (ld:{ *:[v2f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 104157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 104174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104181 */     GIR_RootConstrainSelectedInstOperands,
     /* 104182 */     // GIR_Coverage, 2972,
     /* 104182 */     GIR_EraseRootFromParent_Done,
     /* 104183 */   // Label 1422: @104183
     /* 104183 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(104242), // Rule ID 2950 //
     /* 104188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 104191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104207 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 104218 */     // (ld:{ *:[v2i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 104221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104240 */     GIR_RootConstrainSelectedInstOperands,
     /* 104241 */     // GIR_Coverage, 2950,
     /* 104241 */     GIR_EraseRootFromParent_Done,
     /* 104242 */   // Label 1423: @104242
     /* 104242 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(104301), // Rule ID 2951 //
     /* 104247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 104250 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 104277 */     // (ld:{ *:[v2i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /* 104280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104299 */     GIR_RootConstrainSelectedInstOperands,
     /* 104300 */     // GIR_Coverage, 2951,
     /* 104300 */     GIR_EraseRootFromParent_Done,
     /* 104301 */   // Label 1424: @104301
     /* 104301 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(104360), // Rule ID 2952 //
     /* 104306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 104309 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104336 */     // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 104336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /* 104339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104358 */     GIR_RootConstrainSelectedInstOperands,
     /* 104359 */     // GIR_Coverage, 2952,
     /* 104359 */     GIR_EraseRootFromParent_Done,
     /* 104360 */   // Label 1425: @104360
     /* 104360 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(104422), // Rule ID 2953 //
     /* 104365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 104368 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104395 */     // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 104395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 104398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104420 */     GIR_RootConstrainSelectedInstOperands,
     /* 104421 */     // GIR_Coverage, 2953,
     /* 104421 */     GIR_EraseRootFromParent_Done,
     /* 104422 */   // Label 1426: @104422
     /* 104422 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(104481), // Rule ID 2962 //
     /* 104427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 104430 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104442 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 104457 */     // (ld:{ *:[v2f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 104460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104479 */     GIR_RootConstrainSelectedInstOperands,
     /* 104480 */     // GIR_Coverage, 2962,
     /* 104480 */     GIR_EraseRootFromParent_Done,
     /* 104481 */   // Label 1427: @104481
     /* 104481 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(104540), // Rule ID 2963 //
     /* 104486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 104489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104501 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 104516 */     // (ld:{ *:[v2f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /* 104519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104538 */     GIR_RootConstrainSelectedInstOperands,
     /* 104539 */     // GIR_Coverage, 2963,
     /* 104539 */     GIR_EraseRootFromParent_Done,
     /* 104540 */   // Label 1428: @104540
     /* 104540 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(104599), // Rule ID 2964 //
     /* 104545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 104548 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104575 */     // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 104575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /* 104578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104597 */     GIR_RootConstrainSelectedInstOperands,
     /* 104598 */     // GIR_Coverage, 2964,
     /* 104598 */     GIR_EraseRootFromParent_Done,
     /* 104599 */   // Label 1429: @104599
     /* 104599 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(104661), // Rule ID 2965 //
     /* 104604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 104607 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104623 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 104627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104634 */     // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 104634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 104637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104659 */     GIR_RootConstrainSelectedInstOperands,
     /* 104660 */     // GIR_Coverage, 2965,
     /* 104660 */     GIR_EraseRootFromParent_Done,
     /* 104661 */   // Label 1430: @104661
     /* 104661 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(104713), // Rule ID 2956 //
     /* 104666 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 104689 */     // (ld:{ *:[v2i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 104692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104711 */     GIR_RootConstrainSelectedInstOperands,
     /* 104712 */     // GIR_Coverage, 2956,
     /* 104712 */     GIR_EraseRootFromParent_Done,
     /* 104713 */   // Label 1431: @104713
     /* 104713 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(104768), // Rule ID 2957 //
     /* 104718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 104721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 104744 */     // (ld:{ *:[v2i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /* 104747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104766 */     GIR_RootConstrainSelectedInstOperands,
     /* 104767 */     // GIR_Coverage, 2957,
     /* 104767 */     GIR_EraseRootFromParent_Done,
     /* 104768 */   // Label 1432: @104768
     /* 104768 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(104823), // Rule ID 2958 //
     /* 104773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 104776 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104788 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104799 */     // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 104799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /* 104802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104821 */     GIR_RootConstrainSelectedInstOperands,
     /* 104822 */     // GIR_Coverage, 2958,
     /* 104822 */     GIR_EraseRootFromParent_Done,
     /* 104823 */   // Label 1433: @104823
     /* 104823 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(104881), // Rule ID 2959 //
     /* 104828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 104831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104854 */     // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 104854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 104857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104879 */     GIR_RootConstrainSelectedInstOperands,
     /* 104880 */     // GIR_Coverage, 2959,
     /* 104880 */     GIR_EraseRootFromParent_Done,
     /* 104881 */   // Label 1434: @104881
     /* 104881 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(104933), // Rule ID 2968 //
     /* 104886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104898 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 104909 */     // (ld:{ *:[v2f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 104912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104931 */     GIR_RootConstrainSelectedInstOperands,
     /* 104932 */     // GIR_Coverage, 2968,
     /* 104932 */     GIR_EraseRootFromParent_Done,
     /* 104933 */   // Label 1435: @104933
     /* 104933 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(104988), // Rule ID 2969 //
     /* 104938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 104941 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 104949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104953 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 104964 */     // (ld:{ *:[v2f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /* 104967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104986 */     GIR_RootConstrainSelectedInstOperands,
     /* 104987 */     // GIR_Coverage, 2969,
     /* 104987 */     GIR_EraseRootFromParent_Done,
     /* 104988 */   // Label 1436: @104988
     /* 104988 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(105043), // Rule ID 2970 //
     /* 104993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 104996 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105008 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 105019 */     // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 105019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /* 105022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 105029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105041 */     GIR_RootConstrainSelectedInstOperands,
     /* 105042 */     // GIR_Coverage, 2970,
     /* 105042 */     GIR_EraseRootFromParent_Done,
     /* 105043 */   // Label 1437: @105043
     /* 105043 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(105101), // Rule ID 2971 //
     /* 105048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 105051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105063 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 105074 */     // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 105077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 105084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105099 */     GIR_RootConstrainSelectedInstOperands,
     /* 105100 */     // GIR_Coverage, 2971,
     /* 105100 */     GIR_EraseRootFromParent_Done,
     /* 105101 */   // Label 1438: @105101
     /* 105101 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(105152), // Rule ID 2955 //
     /* 105106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 105109 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105117 */     // MIs[0] sbase
     /* 105117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105125 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 105133 */     // (ld:{ *:[v2i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 105136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105138 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105150 */     GIR_RootConstrainSelectedInstOperands,
     /* 105151 */     // GIR_Coverage, 2955,
     /* 105151 */     GIR_EraseRootFromParent_Done,
     /* 105152 */   // Label 1439: @105152
     /* 105152 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(105203), // Rule ID 2967 //
     /* 105157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 105160 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105168 */     // MIs[0] sbase
     /* 105168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105176 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105180 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 105184 */     // (ld:{ *:[v2f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 105187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105189 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105201 */     GIR_RootConstrainSelectedInstOperands,
     /* 105202 */     // GIR_Coverage, 2967,
     /* 105202 */     GIR_EraseRootFromParent_Done,
     /* 105203 */   // Label 1440: @105203
     /* 105203 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(105247), // Rule ID 2961 //
     /* 105208 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105216 */     // MIs[0] sbase
     /* 105216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105228 */     // (ld:{ *:[v2i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 105231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105233 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105245 */     GIR_RootConstrainSelectedInstOperands,
     /* 105246 */     // GIR_Coverage, 2961,
     /* 105246 */     GIR_EraseRootFromParent_Done,
     /* 105247 */   // Label 1441: @105247
     /* 105247 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(105291), // Rule ID 2973 //
     /* 105252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 105260 */     // MIs[0] sbase
     /* 105260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105268 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105272 */     // (ld:{ *:[v2f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 105275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105277 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105289 */     GIR_RootConstrainSelectedInstOperands,
     /* 105290 */     // GIR_Coverage, 2973,
     /* 105290 */     GIR_EraseRootFromParent_Done,
     /* 105291 */   // Label 1442: @105291
     /* 105291 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(105351), // Rule ID 6487 //
     /* 105296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 105299 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 105319 */     // (ld:{ *:[v2i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 105319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 105322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 105324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 105329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105349 */     GIR_RootConstrainSelectedInstOperands,
     /* 105350 */     // GIR_Coverage, 6487,
     /* 105350 */     GIR_EraseRootFromParent_Done,
     /* 105351 */   // Label 1443: @105351
     /* 105351 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(105411), // Rule ID 6489 //
     /* 105356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 105359 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 105379 */     // (ld:{ *:[v2i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 105379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 105382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 105384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 105389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105409 */     GIR_RootConstrainSelectedInstOperands,
     /* 105410 */     // GIR_Coverage, 6489,
     /* 105410 */     GIR_EraseRootFromParent_Done,
     /* 105411 */   // Label 1444: @105411
     /* 105411 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(105471), // Rule ID 6491 //
     /* 105416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 105419 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 105439 */     // (ld:{ *:[v2f16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2f16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 105439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 105442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 105444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 105449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105469 */     GIR_RootConstrainSelectedInstOperands,
     /* 105470 */     // GIR_Coverage, 6491,
     /* 105470 */     GIR_EraseRootFromParent_Done,
     /* 105471 */   // Label 1445: @105471
     /* 105471 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(105531), // Rule ID 6493 //
     /* 105476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 105479 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 105499 */     // (ld:{ *:[v2f16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2f16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 105499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 105502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 105504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 105509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105529 */     GIR_RootConstrainSelectedInstOperands,
     /* 105530 */     // GIR_Coverage, 6493,
     /* 105530 */     GIR_EraseRootFromParent_Done,
     /* 105531 */   // Label 1446: @105531
     /* 105531 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(105588), // Rule ID 4257 //
     /* 105536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 105539 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 105559 */     // (ld:{ *:[v2i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 105559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /* 105562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 105569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 105574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105586 */     GIR_RootConstrainSelectedInstOperands,
     /* 105587 */     // GIR_Coverage, 4257,
     /* 105587 */     GIR_EraseRootFromParent_Done,
     /* 105588 */   // Label 1447: @105588
     /* 105588 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(105645), // Rule ID 4263 //
     /* 105593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 105596 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 105616 */     // (ld:{ *:[v2f16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 105616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /* 105619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 105626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 105631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105643 */     GIR_RootConstrainSelectedInstOperands,
     /* 105644 */     // GIR_Coverage, 4263,
     /* 105644 */     GIR_EraseRootFromParent_Done,
     /* 105645 */   // Label 1448: @105645
     /* 105645 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(105697), // Rule ID 4256 //
     /* 105650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 105653 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 105673 */     // (ld:{ *:[v2i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[v2i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 105673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /* 105676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 105683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105695 */     GIR_RootConstrainSelectedInstOperands,
     /* 105696 */     // GIR_Coverage, 4256,
     /* 105696 */     GIR_EraseRootFromParent_Done,
     /* 105697 */   // Label 1449: @105697
     /* 105697 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(105749), // Rule ID 4262 //
     /* 105702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 105705 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 105725 */     // (ld:{ *:[v2f16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[v2f16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 105725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /* 105728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 105735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105747 */     GIR_RootConstrainSelectedInstOperands,
     /* 105748 */     // GIR_Coverage, 4262,
     /* 105748 */     GIR_EraseRootFromParent_Done,
     /* 105749 */   // Label 1450: @105749
     /* 105749 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(105801), // Rule ID 4255 //
     /* 105754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 105757 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 105777 */     // (ld:{ *:[v2i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 105777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /* 105780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 105787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105799 */     GIR_RootConstrainSelectedInstOperands,
     /* 105800 */     // GIR_Coverage, 4255,
     /* 105800 */     GIR_EraseRootFromParent_Done,
     /* 105801 */   // Label 1451: @105801
     /* 105801 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(105853), // Rule ID 4261 //
     /* 105806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 105809 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 105829 */     // (ld:{ *:[v2f16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 105829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /* 105832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 105839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105851 */     GIR_RootConstrainSelectedInstOperands,
     /* 105852 */     // GIR_Coverage, 4261,
     /* 105852 */     GIR_EraseRootFromParent_Done,
     /* 105853 */   // Label 1452: @105853
     /* 105853 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(105920), // Rule ID 4503 //
     /* 105858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 105861 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 105868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 105883 */     // (ld:{ *:[v2i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[v2i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 105883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /* 105886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 105888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 105893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 105898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 105903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 105908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105918 */     GIR_RootConstrainSelectedInstOperands,
     /* 105919 */     // GIR_Coverage, 4503,
     /* 105919 */     GIR_EraseRootFromParent_Done,
     /* 105920 */   // Label 1453: @105920
     /* 105920 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(105984), // Rule ID 4505 //
     /* 105925 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 105932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 105936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 105947 */     // (ld:{ *:[v2i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[v2i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 105947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /* 105950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 105952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 105957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 105962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 105967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 105972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105982 */     GIR_RootConstrainSelectedInstOperands,
     /* 105983 */     // GIR_Coverage, 4505,
     /* 105983 */     GIR_EraseRootFromParent_Done,
     /* 105984 */   // Label 1454: @105984
     /* 105984 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(106051), // Rule ID 4507 //
     /* 105989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 105992 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 105999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 106014 */     // (ld:{ *:[v2f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[v2f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /* 106017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106049 */     GIR_RootConstrainSelectedInstOperands,
     /* 106050 */     // GIR_Coverage, 4507,
     /* 106050 */     GIR_EraseRootFromParent_Done,
     /* 106051 */   // Label 1455: @106051
     /* 106051 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(106115), // Rule ID 4509 //
     /* 106056 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 106078 */     // (ld:{ *:[v2f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[v2f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /* 106081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106113 */     GIR_RootConstrainSelectedInstOperands,
     /* 106114 */     // GIR_Coverage, 4509,
     /* 106114 */     GIR_EraseRootFromParent_Done,
     /* 106115 */   // Label 1456: @106115
     /* 106115 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(106180), // Rule ID 6486 //
     /* 106120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 106123 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 106128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 106143 */     // (ld:{ *:[v2i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 106143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 106146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106178 */     GIR_RootConstrainSelectedInstOperands,
     /* 106179 */     // GIR_Coverage, 6486,
     /* 106179 */     GIR_EraseRootFromParent_Done,
     /* 106180 */   // Label 1457: @106180
     /* 106180 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(106245), // Rule ID 6488 //
     /* 106185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 106188 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 106193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 106208 */     // (ld:{ *:[v2i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 106208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 106211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106243 */     GIR_RootConstrainSelectedInstOperands,
     /* 106244 */     // GIR_Coverage, 6488,
     /* 106244 */     GIR_EraseRootFromParent_Done,
     /* 106245 */   // Label 1458: @106245
     /* 106245 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(106310), // Rule ID 6490 //
     /* 106250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 106253 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 106258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 106273 */     // (ld:{ *:[v2f16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 106273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 106276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106308 */     GIR_RootConstrainSelectedInstOperands,
     /* 106309 */     // GIR_Coverage, 6490,
     /* 106309 */     GIR_EraseRootFromParent_Done,
     /* 106310 */   // Label 1459: @106310
     /* 106310 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(106375), // Rule ID 6492 //
     /* 106315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 106318 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 106323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 106338 */     // (ld:{ *:[v2f16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 106338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 106341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106373 */     GIR_RootConstrainSelectedInstOperands,
     /* 106374 */     // GIR_Coverage, 6492,
     /* 106374 */     GIR_EraseRootFromParent_Done,
     /* 106375 */   // Label 1460: @106375
     /* 106375 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(106437), // Rule ID 4502 //
     /* 106380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 106383 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 106405 */     // (ld:{ *:[v2i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 106408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 106420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106435 */     GIR_RootConstrainSelectedInstOperands,
     /* 106436 */     // GIR_Coverage, 4502,
     /* 106436 */     GIR_EraseRootFromParent_Done,
     /* 106437 */   // Label 1461: @106437
     /* 106437 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(106496), // Rule ID 4504 //
     /* 106442 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 106464 */     // (ld:{ *:[v2i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 106467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 106479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106494 */     GIR_RootConstrainSelectedInstOperands,
     /* 106495 */     // GIR_Coverage, 4504,
     /* 106495 */     GIR_EraseRootFromParent_Done,
     /* 106496 */   // Label 1462: @106496
     /* 106496 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(106558), // Rule ID 4506 //
     /* 106501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 106504 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 106526 */     // (ld:{ *:[v2f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 106529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 106541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106556 */     GIR_RootConstrainSelectedInstOperands,
     /* 106557 */     // GIR_Coverage, 4506,
     /* 106557 */     GIR_EraseRootFromParent_Done,
     /* 106558 */   // Label 1463: @106558
     /* 106558 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(106617), // Rule ID 4508 //
     /* 106563 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 106585 */     // (ld:{ *:[v2f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 106588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 106600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106615 */     GIR_RootConstrainSelectedInstOperands,
     /* 106616 */     // GIR_Coverage, 4508,
     /* 106616 */     GIR_EraseRootFromParent_Done,
     /* 106617 */   // Label 1464: @106617
     /* 106617 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(106673), // Rule ID 7822 //
     /* 106622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 106625 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106629 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 106634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 106649 */     // (AMDGPUld_glue:{ *:[v2i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[v2i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 106649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /* 106652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 106659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106671 */     GIR_RootConstrainSelectedInstOperands,
     /* 106672 */     // GIR_Coverage, 7822,
     /* 106672 */     GIR_EraseRootFromParent_Done,
     /* 106673 */   // Label 1465: @106673
     /* 106673 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(106729), // Rule ID 7824 //
     /* 106678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 106681 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106685 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 106690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 106705 */     // (AMDGPUld_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 106705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /* 106708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 106715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106727 */     GIR_RootConstrainSelectedInstOperands,
     /* 106728 */     // GIR_Coverage, 7824,
     /* 106728 */     GIR_EraseRootFromParent_Done,
     /* 106729 */   // Label 1466: @106729
     /* 106729 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(106781), // Rule ID 7823 //
     /* 106734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 106737 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 106742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 106757 */     // (ld:{ *:[v2i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[v2i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 106757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /* 106760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 106767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106779 */     GIR_RootConstrainSelectedInstOperands,
     /* 106780 */     // GIR_Coverage, 7823,
     /* 106780 */     GIR_EraseRootFromParent_Done,
     /* 106781 */   // Label 1467: @106781
     /* 106781 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(106833), // Rule ID 7825 //
     /* 106786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 106789 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 106794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 106809 */     // (ld:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 106809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /* 106812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 106819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106831 */     GIR_RootConstrainSelectedInstOperands,
     /* 106832 */     // GIR_Coverage, 7825,
     /* 106832 */     GIR_EraseRootFromParent_Done,
     /* 106833 */   // Label 1468: @106833
     /* 106833 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(106892), // Rule ID 3868 //
     /* 106838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 106841 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 106863 */     // (ld:{ *:[v2i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[v2i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 106863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /* 106866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 106873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 106878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106890 */     GIR_RootConstrainSelectedInstOperands,
     /* 106891 */     // GIR_Coverage, 3868,
     /* 106891 */     GIR_EraseRootFromParent_Done,
     /* 106892 */   // Label 1469: @106892
     /* 106892 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(106951), // Rule ID 3872 //
     /* 106897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 106900 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 106922 */     // (ld:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[v2f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 106922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /* 106925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 106932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 106937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106949 */     GIR_RootConstrainSelectedInstOperands,
     /* 106950 */     // GIR_Coverage, 3872,
     /* 106950 */     GIR_EraseRootFromParent_Done,
     /* 106951 */   // Label 1470: @106951
     /* 106951 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(107005), // Rule ID 3867 //
     /* 106956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 106959 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 106970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 106981 */     // (ld:{ *:[v2i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[v2i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 106981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /* 106984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 106991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107003 */     GIR_RootConstrainSelectedInstOperands,
     /* 107004 */     // GIR_Coverage, 3867,
     /* 107004 */     GIR_EraseRootFromParent_Done,
     /* 107005 */   // Label 1471: @107005
     /* 107005 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(107059), // Rule ID 3871 //
     /* 107010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 107013 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 107024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 107035 */     // (ld:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[v2f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 107035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /* 107038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 107045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107057 */     GIR_RootConstrainSelectedInstOperands,
     /* 107058 */     // GIR_Coverage, 3871,
     /* 107058 */     GIR_EraseRootFromParent_Done,
     /* 107059 */   // Label 1472: @107059
     /* 107059 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(107114), // Rule ID 3616 //
     /* 107064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 107067 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 107079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 107090 */     // (ld:{ *:[v2i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[v2i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 107090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /* 107093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 107100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107112 */     GIR_RootConstrainSelectedInstOperands,
     /* 107113 */     // GIR_Coverage, 3616,
     /* 107113 */     GIR_EraseRootFromParent_Done,
     /* 107114 */   // Label 1473: @107114
     /* 107114 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(107169), // Rule ID 3618 //
     /* 107119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 107122 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 107134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 107145 */     // (ld:{ *:[v2f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[v2f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 107145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /* 107148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 107155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107167 */     GIR_RootConstrainSelectedInstOperands,
     /* 107168 */     // GIR_Coverage, 3618,
     /* 107168 */     GIR_EraseRootFromParent_Done,
     /* 107169 */   // Label 1474: @107169
     /* 107169 */   GIM_Reject,
     /* 107170 */ // Label 1418: @107170
     /* 107170 */ GIM_Reject,
     /* 107171 */ // Label 883: @107171
     /* 107171 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(111218),
     /* 107176 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107179 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(107243), // Rule ID 3026 //
     /* 107184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 107187 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107199 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107214 */     // (ld:{ *:[v2i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 107217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107241 */     GIR_RootConstrainSelectedInstOperands,
     /* 107242 */     // GIR_Coverage, 3026,
     /* 107242 */     GIR_EraseRootFromParent_Done,
     /* 107243 */   // Label 1476: @107243
     /* 107243 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(107307), // Rule ID 3060 //
     /* 107248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 107251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107267 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107278 */     // (ld:{ *:[v2f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 107281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107305 */     GIR_RootConstrainSelectedInstOperands,
     /* 107306 */     // GIR_Coverage, 3060,
     /* 107306 */     GIR_EraseRootFromParent_Done,
     /* 107307 */   // Label 1477: @107307
     /* 107307 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(107367), // Rule ID 3031 //
     /* 107312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 107315 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107338 */     // (ld:{ *:[v2i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 107341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107365 */     GIR_RootConstrainSelectedInstOperands,
     /* 107366 */     // GIR_Coverage, 3031,
     /* 107366 */     GIR_EraseRootFromParent_Done,
     /* 107367 */   // Label 1478: @107367
     /* 107367 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(107427), // Rule ID 3065 //
     /* 107372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 107375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107387 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107398 */     // (ld:{ *:[v2f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 107401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107425 */     GIR_RootConstrainSelectedInstOperands,
     /* 107426 */     // GIR_Coverage, 3065,
     /* 107426 */     GIR_EraseRootFromParent_Done,
     /* 107427 */   // Label 1479: @107427
     /* 107427 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(107487), // Rule ID 3037 //
     /* 107432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 107435 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107447 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107458 */     // (ld:{ *:[v2i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 107461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107485 */     GIR_RootConstrainSelectedInstOperands,
     /* 107486 */     // GIR_Coverage, 3037,
     /* 107486 */     GIR_EraseRootFromParent_Done,
     /* 107487 */   // Label 1480: @107487
     /* 107487 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(107547), // Rule ID 3071 //
     /* 107492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 107495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107518 */     // (ld:{ *:[v2f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 107521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107545 */     GIR_RootConstrainSelectedInstOperands,
     /* 107546 */     // GIR_Coverage, 3071,
     /* 107546 */     GIR_EraseRootFromParent_Done,
     /* 107547 */   // Label 1481: @107547
     /* 107547 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(107606), // Rule ID 3022 //
     /* 107552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 107555 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 107582 */     // (ld:{ *:[v2i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 107585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107604 */     GIR_RootConstrainSelectedInstOperands,
     /* 107605 */     // GIR_Coverage, 3022,
     /* 107605 */     GIR_EraseRootFromParent_Done,
     /* 107606 */   // Label 1482: @107606
     /* 107606 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(107665), // Rule ID 3023 //
     /* 107611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 107614 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107626 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107630 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 107641 */     // (ld:{ *:[v2i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 107644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107663 */     GIR_RootConstrainSelectedInstOperands,
     /* 107664 */     // GIR_Coverage, 3023,
     /* 107664 */     GIR_EraseRootFromParent_Done,
     /* 107665 */   // Label 1483: @107665
     /* 107665 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(107724), // Rule ID 3024 //
     /* 107670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 107673 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107685 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 107700 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 107700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 107703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107722 */     GIR_RootConstrainSelectedInstOperands,
     /* 107723 */     // GIR_Coverage, 3024,
     /* 107723 */     GIR_EraseRootFromParent_Done,
     /* 107724 */   // Label 1484: @107724
     /* 107724 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(107786), // Rule ID 3025 //
     /* 107729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 107732 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107744 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 107759 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 107759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 107762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107784 */     GIR_RootConstrainSelectedInstOperands,
     /* 107785 */     // GIR_Coverage, 3025,
     /* 107785 */     GIR_EraseRootFromParent_Done,
     /* 107786 */   // Label 1485: @107786
     /* 107786 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(107845), // Rule ID 3056 //
     /* 107791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 107794 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107810 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 107821 */     // (ld:{ *:[v2f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 107824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107843 */     GIR_RootConstrainSelectedInstOperands,
     /* 107844 */     // GIR_Coverage, 3056,
     /* 107844 */     GIR_EraseRootFromParent_Done,
     /* 107845 */   // Label 1486: @107845
     /* 107845 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(107904), // Rule ID 3057 //
     /* 107850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 107853 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107865 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107869 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 107880 */     // (ld:{ *:[v2f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 107883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107902 */     GIR_RootConstrainSelectedInstOperands,
     /* 107903 */     // GIR_Coverage, 3057,
     /* 107903 */     GIR_EraseRootFromParent_Done,
     /* 107904 */   // Label 1487: @107904
     /* 107904 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(107963), // Rule ID 3058 //
     /* 107909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 107912 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107924 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107928 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 107939 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 107939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 107942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107961 */     GIR_RootConstrainSelectedInstOperands,
     /* 107962 */     // GIR_Coverage, 3058,
     /* 107962 */     GIR_EraseRootFromParent_Done,
     /* 107963 */   // Label 1488: @107963
     /* 107963 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(108025), // Rule ID 3059 //
     /* 107968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 107971 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 107979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107983 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107987 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 107998 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 107998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 108001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108023 */     GIR_RootConstrainSelectedInstOperands,
     /* 108024 */     // GIR_Coverage, 3059,
     /* 108024 */     GIR_EraseRootFromParent_Done,
     /* 108025 */   // Label 1489: @108025
     /* 108025 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(108080), // Rule ID 3028 //
     /* 108030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 108033 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108045 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 108056 */     // (ld:{ *:[v2i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 108059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108078 */     GIR_RootConstrainSelectedInstOperands,
     /* 108079 */     // GIR_Coverage, 3028,
     /* 108079 */     GIR_EraseRootFromParent_Done,
     /* 108080 */   // Label 1490: @108080
     /* 108080 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(108135), // Rule ID 3029 //
     /* 108085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 108088 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108111 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 108111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 108114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108133 */     GIR_RootConstrainSelectedInstOperands,
     /* 108134 */     // GIR_Coverage, 3029,
     /* 108134 */     GIR_EraseRootFromParent_Done,
     /* 108135 */   // Label 1491: @108135
     /* 108135 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(108193), // Rule ID 3030 //
     /* 108140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 108143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108155 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108166 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 108166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 108169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108191 */     GIR_RootConstrainSelectedInstOperands,
     /* 108192 */     // GIR_Coverage, 3030,
     /* 108192 */     GIR_EraseRootFromParent_Done,
     /* 108193 */   // Label 1492: @108193
     /* 108193 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(108248), // Rule ID 3062 //
     /* 108198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 108201 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 108224 */     // (ld:{ *:[v2f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 108227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108246 */     GIR_RootConstrainSelectedInstOperands,
     /* 108247 */     // GIR_Coverage, 3062,
     /* 108247 */     GIR_EraseRootFromParent_Done,
     /* 108248 */   // Label 1493: @108248
     /* 108248 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(108303), // Rule ID 3063 //
     /* 108253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 108256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108268 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108279 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 108279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 108282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108301 */     GIR_RootConstrainSelectedInstOperands,
     /* 108302 */     // GIR_Coverage, 3063,
     /* 108302 */     GIR_EraseRootFromParent_Done,
     /* 108303 */   // Label 1494: @108303
     /* 108303 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(108361), // Rule ID 3064 //
     /* 108308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 108311 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108323 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108334 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 108334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 108337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108359 */     GIR_RootConstrainSelectedInstOperands,
     /* 108360 */     // GIR_Coverage, 3064,
     /* 108360 */     GIR_EraseRootFromParent_Done,
     /* 108361 */   // Label 1495: @108361
     /* 108361 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(108426), // Rule ID 8060 //
     /* 108366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 108369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108373 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 108378 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 108383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 108387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 108395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 108402 */     // (AMDGPUld_glue:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 108402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 108405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 108407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 108412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108424 */     GIR_RootConstrainSelectedInstOperands,
     /* 108425 */     // GIR_Coverage, 8060,
     /* 108425 */     GIR_EraseRootFromParent_Done,
     /* 108426 */   // Label 1496: @108426
     /* 108426 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(108491), // Rule ID 8064 //
     /* 108431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 108434 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108438 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 108443 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 108448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 108452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 108460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 108467 */     // (AMDGPUld_glue:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 108467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 108470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 108472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 108477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108489 */     GIR_RootConstrainSelectedInstOperands,
     /* 108490 */     // GIR_Coverage, 8064,
     /* 108490 */     GIR_EraseRootFromParent_Done,
     /* 108491 */   // Label 1497: @108491
     /* 108491 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(108551), // Rule ID 7992 //
     /* 108496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 108499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108503 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 108508 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 108512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 108516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 108527 */     // (AMDGPUld_glue:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 108527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 108530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 108532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 108537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108549 */     GIR_RootConstrainSelectedInstOperands,
     /* 108550 */     // GIR_Coverage, 7992,
     /* 108550 */     GIR_EraseRootFromParent_Done,
     /* 108551 */   // Label 1498: @108551
     /* 108551 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(108611), // Rule ID 7996 //
     /* 108556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 108559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108563 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 108568 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 108572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 108576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 108587 */     // (AMDGPUld_glue:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 108587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 108590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 108592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 108597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108609 */     GIR_RootConstrainSelectedInstOperands,
     /* 108610 */     // GIR_Coverage, 7996,
     /* 108610 */     GIR_EraseRootFromParent_Done,
     /* 108611 */   // Label 1499: @108611
     /* 108611 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(108663), // Rule ID 3033 //
     /* 108616 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108628 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 108639 */     // (ld:{ *:[v2i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 108642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108661 */     GIR_RootConstrainSelectedInstOperands,
     /* 108662 */     // GIR_Coverage, 3033,
     /* 108662 */     GIR_EraseRootFromParent_Done,
     /* 108663 */   // Label 1500: @108663
     /* 108663 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(108718), // Rule ID 3034 //
     /* 108668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 108671 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 108694 */     // (ld:{ *:[v2i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 108697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108716 */     GIR_RootConstrainSelectedInstOperands,
     /* 108717 */     // GIR_Coverage, 3034,
     /* 108717 */     GIR_EraseRootFromParent_Done,
     /* 108718 */   // Label 1501: @108718
     /* 108718 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(108773), // Rule ID 3035 //
     /* 108723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 108726 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108749 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 108749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 108752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108771 */     GIR_RootConstrainSelectedInstOperands,
     /* 108772 */     // GIR_Coverage, 3035,
     /* 108772 */     GIR_EraseRootFromParent_Done,
     /* 108773 */   // Label 1502: @108773
     /* 108773 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(108831), // Rule ID 3036 //
     /* 108778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 108781 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108793 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108804 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 108804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 108807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108829 */     GIR_RootConstrainSelectedInstOperands,
     /* 108830 */     // GIR_Coverage, 3036,
     /* 108830 */     GIR_EraseRootFromParent_Done,
     /* 108831 */   // Label 1503: @108831
     /* 108831 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(108883), // Rule ID 3067 //
     /* 108836 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 108859 */     // (ld:{ *:[v2f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 108862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108881 */     GIR_RootConstrainSelectedInstOperands,
     /* 108882 */     // GIR_Coverage, 3067,
     /* 108882 */     GIR_EraseRootFromParent_Done,
     /* 108883 */   // Label 1504: @108883
     /* 108883 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(108938), // Rule ID 3068 //
     /* 108888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 108891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 108914 */     // (ld:{ *:[v2f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 108917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108936 */     GIR_RootConstrainSelectedInstOperands,
     /* 108937 */     // GIR_Coverage, 3068,
     /* 108937 */     GIR_EraseRootFromParent_Done,
     /* 108938 */   // Label 1505: @108938
     /* 108938 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(108993), // Rule ID 3069 //
     /* 108943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 108946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 108954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108958 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108969 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 108969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 108972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108991 */     GIR_RootConstrainSelectedInstOperands,
     /* 108992 */     // GIR_Coverage, 3069,
     /* 108992 */     GIR_EraseRootFromParent_Done,
     /* 108993 */   // Label 1506: @108993
     /* 108993 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(109051), // Rule ID 3070 //
     /* 108998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 109001 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 109024 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 109027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 109034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 109039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109049 */     GIR_RootConstrainSelectedInstOperands,
     /* 109050 */     // GIR_Coverage, 3070,
     /* 109050 */     GIR_EraseRootFromParent_Done,
     /* 109051 */   // Label 1507: @109051
     /* 109051 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(109112), // Rule ID 8061 //
     /* 109056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 109059 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 109064 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 109069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109077 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 109081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 109088 */     // (ld:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 109088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 109091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 109098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109110 */     GIR_RootConstrainSelectedInstOperands,
     /* 109111 */     // GIR_Coverage, 8061,
     /* 109111 */     GIR_EraseRootFromParent_Done,
     /* 109112 */   // Label 1508: @109112
     /* 109112 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(109173), // Rule ID 8065 //
     /* 109117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 109120 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 109125 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 109130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 109142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 109149 */     // (ld:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 109149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 109152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 109159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109171 */     GIR_RootConstrainSelectedInstOperands,
     /* 109172 */     // GIR_Coverage, 8065,
     /* 109172 */     GIR_EraseRootFromParent_Done,
     /* 109173 */   // Label 1509: @109173
     /* 109173 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(109229), // Rule ID 7993 //
     /* 109178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 109181 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 109186 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 109190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 109205 */     // (ld:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 109205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 109208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 109215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109227 */     GIR_RootConstrainSelectedInstOperands,
     /* 109228 */     // GIR_Coverage, 7993,
     /* 109228 */     GIR_EraseRootFromParent_Done,
     /* 109229 */   // Label 1510: @109229
     /* 109229 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(109285), // Rule ID 7997 //
     /* 109234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 109237 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 109242 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 109246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 109261 */     // (ld:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 109261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 109264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 109271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109283 */     GIR_RootConstrainSelectedInstOperands,
     /* 109284 */     // GIR_Coverage, 7997,
     /* 109284 */     GIR_EraseRootFromParent_Done,
     /* 109285 */   // Label 1511: @109285
     /* 109285 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(109336), // Rule ID 3027 //
     /* 109290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 109293 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109301 */     // MIs[0] sbase
     /* 109301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 109309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109313 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 109317 */     // (ld:{ *:[v2i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 109320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109322 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109334 */     GIR_RootConstrainSelectedInstOperands,
     /* 109335 */     // GIR_Coverage, 3027,
     /* 109335 */     GIR_EraseRootFromParent_Done,
     /* 109336 */   // Label 1512: @109336
     /* 109336 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(109387), // Rule ID 3061 //
     /* 109341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 109344 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109352 */     // MIs[0] sbase
     /* 109352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 109360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 109368 */     // (ld:{ *:[v2f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 109371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109373 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109385 */     GIR_RootConstrainSelectedInstOperands,
     /* 109386 */     // GIR_Coverage, 3061,
     /* 109386 */     GIR_EraseRootFromParent_Done,
     /* 109387 */   // Label 1513: @109387
     /* 109387 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(109434), // Rule ID 3032 //
     /* 109392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 109395 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109403 */     // MIs[0] sbase
     /* 109403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 109411 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109415 */     // (ld:{ *:[v2i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 109418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109420 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109432 */     GIR_RootConstrainSelectedInstOperands,
     /* 109433 */     // GIR_Coverage, 3032,
     /* 109433 */     GIR_EraseRootFromParent_Done,
     /* 109434 */   // Label 1514: @109434
     /* 109434 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(109481), // Rule ID 3066 //
     /* 109439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 109442 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109450 */     // MIs[0] sbase
     /* 109450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 109458 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109462 */     // (ld:{ *:[v2f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 109465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109467 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109479 */     GIR_RootConstrainSelectedInstOperands,
     /* 109480 */     // GIR_Coverage, 3066,
     /* 109480 */     GIR_EraseRootFromParent_Done,
     /* 109481 */   // Label 1515: @109481
     /* 109481 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(109525), // Rule ID 3038 //
     /* 109486 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109494 */     // MIs[0] sbase
     /* 109494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 109502 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109506 */     // (ld:{ *:[v2i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 109509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109511 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109523 */     GIR_RootConstrainSelectedInstOperands,
     /* 109524 */     // GIR_Coverage, 3038,
     /* 109524 */     GIR_EraseRootFromParent_Done,
     /* 109525 */   // Label 1516: @109525
     /* 109525 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(109569), // Rule ID 3072 //
     /* 109530 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 109538 */     // MIs[0] sbase
     /* 109538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 109546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109550 */     // (ld:{ *:[v2f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 109553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109555 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109567 */     GIR_RootConstrainSelectedInstOperands,
     /* 109568 */     // GIR_Coverage, 3072,
     /* 109568 */     GIR_EraseRootFromParent_Done,
     /* 109569 */   // Label 1517: @109569
     /* 109569 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(109629), // Rule ID 6511 //
     /* 109574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 109577 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 109597 */     // (ld:{ *:[v2i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 109597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 109600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 109612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109627 */     GIR_RootConstrainSelectedInstOperands,
     /* 109628 */     // GIR_Coverage, 6511,
     /* 109628 */     GIR_EraseRootFromParent_Done,
     /* 109629 */   // Label 1518: @109629
     /* 109629 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(109689), // Rule ID 6513 //
     /* 109634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 109637 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 109657 */     // (ld:{ *:[v2i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 109657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 109660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 109672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109687 */     GIR_RootConstrainSelectedInstOperands,
     /* 109688 */     // GIR_Coverage, 6513,
     /* 109688 */     GIR_EraseRootFromParent_Done,
     /* 109689 */   // Label 1519: @109689
     /* 109689 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(109746), // Rule ID 4305 //
     /* 109694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 109697 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 109717 */     // (ld:{ *:[v2i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 109717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 109720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 109727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 109732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109744 */     GIR_RootConstrainSelectedInstOperands,
     /* 109745 */     // GIR_Coverage, 4305,
     /* 109745 */     GIR_EraseRootFromParent_Done,
     /* 109746 */   // Label 1520: @109746
     /* 109746 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(109803), // Rule ID 4311 //
     /* 109751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 109754 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 109774 */     // (ld:{ *:[v2f32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v2f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 109774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 109777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 109784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 109789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109801 */     GIR_RootConstrainSelectedInstOperands,
     /* 109802 */     // GIR_Coverage, 4311,
     /* 109802 */     GIR_EraseRootFromParent_Done,
     /* 109803 */   // Label 1521: @109803
     /* 109803 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(109855), // Rule ID 4304 //
     /* 109808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 109811 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 109831 */     // (ld:{ *:[v2i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v2i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 109831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 109834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 109841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109853 */     GIR_RootConstrainSelectedInstOperands,
     /* 109854 */     // GIR_Coverage, 4304,
     /* 109854 */     GIR_EraseRootFromParent_Done,
     /* 109855 */   // Label 1522: @109855
     /* 109855 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(109907), // Rule ID 4310 //
     /* 109860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 109863 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 109883 */     // (ld:{ *:[v2f32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v2f32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 109883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 109886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 109893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109905 */     GIR_RootConstrainSelectedInstOperands,
     /* 109906 */     // GIR_Coverage, 4310,
     /* 109906 */     GIR_EraseRootFromParent_Done,
     /* 109907 */   // Label 1523: @109907
     /* 109907 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(109959), // Rule ID 4303 //
     /* 109912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 109915 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 109935 */     // (ld:{ *:[v2i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 109935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 109938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 109945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109957 */     GIR_RootConstrainSelectedInstOperands,
     /* 109958 */     // GIR_Coverage, 4303,
     /* 109958 */     GIR_EraseRootFromParent_Done,
     /* 109959 */   // Label 1524: @109959
     /* 109959 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(110011), // Rule ID 4309 //
     /* 109964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 109967 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 109976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 109987 */     // (ld:{ *:[v2f32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v2f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 109987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 109990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 109997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110009 */     GIR_RootConstrainSelectedInstOperands,
     /* 110010 */     // GIR_Coverage, 4309,
     /* 110010 */     GIR_EraseRootFromParent_Done,
     /* 110011 */   // Label 1525: @110011
     /* 110011 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(110078), // Rule ID 4535 //
     /* 110016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 110019 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 110041 */     // (ld:{ *:[v2i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v2i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 110044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110076 */     GIR_RootConstrainSelectedInstOperands,
     /* 110077 */     // GIR_Coverage, 4535,
     /* 110077 */     GIR_EraseRootFromParent_Done,
     /* 110078 */   // Label 1526: @110078
     /* 110078 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(110142), // Rule ID 4537 //
     /* 110083 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 110105 */     // (ld:{ *:[v2i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v2i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 110108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110140 */     GIR_RootConstrainSelectedInstOperands,
     /* 110141 */     // GIR_Coverage, 4537,
     /* 110141 */     GIR_EraseRootFromParent_Done,
     /* 110142 */   // Label 1527: @110142
     /* 110142 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(110209), // Rule ID 4539 //
     /* 110147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 110150 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 110172 */     // (ld:{ *:[v2f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v2f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 110175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110207 */     GIR_RootConstrainSelectedInstOperands,
     /* 110208 */     // GIR_Coverage, 4539,
     /* 110208 */     GIR_EraseRootFromParent_Done,
     /* 110209 */   // Label 1528: @110209
     /* 110209 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(110273), // Rule ID 4541 //
     /* 110214 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 110236 */     // (ld:{ *:[v2f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v2f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 110239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110271 */     GIR_RootConstrainSelectedInstOperands,
     /* 110272 */     // GIR_Coverage, 4541,
     /* 110272 */     GIR_EraseRootFromParent_Done,
     /* 110273 */   // Label 1529: @110273
     /* 110273 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(110338), // Rule ID 6510 //
     /* 110278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 110281 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 110286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 110301 */     // (ld:{ *:[v2i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 110301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 110304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110336 */     GIR_RootConstrainSelectedInstOperands,
     /* 110337 */     // GIR_Coverage, 6510,
     /* 110337 */     GIR_EraseRootFromParent_Done,
     /* 110338 */   // Label 1530: @110338
     /* 110338 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(110403), // Rule ID 6512 //
     /* 110343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 110346 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 110351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 110366 */     // (ld:{ *:[v2i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 110366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 110369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110401 */     GIR_RootConstrainSelectedInstOperands,
     /* 110402 */     // GIR_Coverage, 6512,
     /* 110402 */     GIR_EraseRootFromParent_Done,
     /* 110403 */   // Label 1531: @110403
     /* 110403 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(110464), // Rule ID 7936 //
     /* 110408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 110411 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110415 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 110420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 110435 */     // (AMDGPUld_glue:{ *:[v2i32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 110435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 110438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 110445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 110450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 110455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110462 */     GIR_RootConstrainSelectedInstOperands,
     /* 110463 */     // GIR_Coverage, 7936,
     /* 110463 */     GIR_EraseRootFromParent_Done,
     /* 110464 */   // Label 1532: @110464
     /* 110464 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(110525), // Rule ID 7940 //
     /* 110469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 110472 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110476 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 110481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 110496 */     // (AMDGPUld_glue:{ *:[v2f32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 110496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 110499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 110506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 110511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 110516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110523 */     GIR_RootConstrainSelectedInstOperands,
     /* 110524 */     // GIR_Coverage, 7940,
     /* 110524 */     GIR_EraseRootFromParent_Done,
     /* 110525 */   // Label 1533: @110525
     /* 110525 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(110587), // Rule ID 4534 //
     /* 110530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 110533 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 110555 */     // (ld:{ *:[v2i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 110558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 110570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110585 */     GIR_RootConstrainSelectedInstOperands,
     /* 110586 */     // GIR_Coverage, 4534,
     /* 110586 */     GIR_EraseRootFromParent_Done,
     /* 110587 */   // Label 1534: @110587
     /* 110587 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(110646), // Rule ID 4536 //
     /* 110592 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 110614 */     // (ld:{ *:[v2i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 110617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 110629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110644 */     GIR_RootConstrainSelectedInstOperands,
     /* 110645 */     // GIR_Coverage, 4536,
     /* 110645 */     GIR_EraseRootFromParent_Done,
     /* 110646 */   // Label 1535: @110646
     /* 110646 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(110708), // Rule ID 4538 //
     /* 110651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 110654 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 110676 */     // (ld:{ *:[v2f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 110679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 110691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110706 */     GIR_RootConstrainSelectedInstOperands,
     /* 110707 */     // GIR_Coverage, 4538,
     /* 110707 */     GIR_EraseRootFromParent_Done,
     /* 110708 */   // Label 1536: @110708
     /* 110708 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(110767), // Rule ID 4540 //
     /* 110713 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 110735 */     // (ld:{ *:[v2f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 110738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 110750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110765 */     GIR_RootConstrainSelectedInstOperands,
     /* 110766 */     // GIR_Coverage, 4540,
     /* 110766 */     GIR_EraseRootFromParent_Done,
     /* 110767 */   // Label 1537: @110767
     /* 110767 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(110824), // Rule ID 7938 //
     /* 110772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 110775 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 110780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 110795 */     // (ld:{ *:[v2i32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 110795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 110798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 110805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 110810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 110815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110822 */     GIR_RootConstrainSelectedInstOperands,
     /* 110823 */     // GIR_Coverage, 7938,
     /* 110823 */     GIR_EraseRootFromParent_Done,
     /* 110824 */   // Label 1538: @110824
     /* 110824 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(110881), // Rule ID 7942 //
     /* 110829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 110832 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 110837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 110852 */     // (ld:{ *:[v2f32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 110852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 110855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 110862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 110867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 110872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110879 */     GIR_RootConstrainSelectedInstOperands,
     /* 110880 */     // GIR_Coverage, 7942,
     /* 110880 */     GIR_EraseRootFromParent_Done,
     /* 110881 */   // Label 1539: @110881
     /* 110881 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(110940), // Rule ID 3900 //
     /* 110886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 110889 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 110911 */     // (ld:{ *:[v2i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v2i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 110911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 110914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 110921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 110926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110938 */     GIR_RootConstrainSelectedInstOperands,
     /* 110939 */     // GIR_Coverage, 3900,
     /* 110939 */     GIR_EraseRootFromParent_Done,
     /* 110940 */   // Label 1540: @110940
     /* 110940 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(110999), // Rule ID 3904 //
     /* 110945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 110948 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 110959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 110970 */     // (ld:{ *:[v2f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v2f32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 110970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 110973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 110980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 110985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110997 */     GIR_RootConstrainSelectedInstOperands,
     /* 110998 */     // GIR_Coverage, 3904,
     /* 110998 */     GIR_EraseRootFromParent_Done,
     /* 110999 */   // Label 1541: @110999
     /* 110999 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(111053), // Rule ID 3899 //
     /* 111004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 111007 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 111014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 111018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 111029 */     // (ld:{ *:[v2i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v2i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 111029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 111032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 111034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 111039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111051 */     GIR_RootConstrainSelectedInstOperands,
     /* 111052 */     // GIR_Coverage, 3899,
     /* 111052 */     GIR_EraseRootFromParent_Done,
     /* 111053 */   // Label 1542: @111053
     /* 111053 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(111107), // Rule ID 3903 //
     /* 111058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 111061 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 111068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 111072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 111083 */     // (ld:{ *:[v2f32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v2f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 111083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 111086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 111088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 111093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111105 */     GIR_RootConstrainSelectedInstOperands,
     /* 111106 */     // GIR_Coverage, 3903,
     /* 111106 */     GIR_EraseRootFromParent_Done,
     /* 111107 */   // Label 1543: @111107
     /* 111107 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(111162), // Rule ID 3633 //
     /* 111112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 111115 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 111123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 111127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 111138 */     // (ld:{ *:[v2i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v2i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 111138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 111141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 111143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 111148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111160 */     GIR_RootConstrainSelectedInstOperands,
     /* 111161 */     // GIR_Coverage, 3633,
     /* 111161 */     GIR_EraseRootFromParent_Done,
     /* 111162 */   // Label 1544: @111162
     /* 111162 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(111217), // Rule ID 3635 //
     /* 111167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 111170 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 111178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 111182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 111193 */     // (ld:{ *:[v2f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v2f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 111193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 111196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 111198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 111203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111215 */     GIR_RootConstrainSelectedInstOperands,
     /* 111216 */     // GIR_Coverage, 3635,
     /* 111216 */     GIR_EraseRootFromParent_Done,
     /* 111217 */   // Label 1545: @111217
     /* 111217 */   GIM_Reject,
     /* 111218 */ // Label 1475: @111218
     /* 111218 */ GIM_Reject,
     /* 111219 */ // Label 884: @111219
     /* 111219 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(115016),
     /* 111224 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111227 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(111291), // Rule ID 3204 //
     /* 111232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111247 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111262 */     // (ld:{ *:[v2i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 111265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111289 */     GIR_RootConstrainSelectedInstOperands,
     /* 111290 */     // GIR_Coverage, 3204,
     /* 111290 */     GIR_EraseRootFromParent_Done,
     /* 111291 */   // Label 1547: @111291
     /* 111291 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(111355), // Rule ID 3221 //
     /* 111296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111299 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111311 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111326 */     // (ld:{ *:[v2f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 111329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111353 */     GIR_RootConstrainSelectedInstOperands,
     /* 111354 */     // GIR_Coverage, 3221,
     /* 111354 */     GIR_EraseRootFromParent_Done,
     /* 111355 */   // Label 1548: @111355
     /* 111355 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(111415), // Rule ID 3209 //
     /* 111360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111386 */     // (ld:{ *:[v2i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 111389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111413 */     GIR_RootConstrainSelectedInstOperands,
     /* 111414 */     // GIR_Coverage, 3209,
     /* 111414 */     GIR_EraseRootFromParent_Done,
     /* 111415 */   // Label 1549: @111415
     /* 111415 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(111475), // Rule ID 3226 //
     /* 111420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111435 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111446 */     // (ld:{ *:[v2f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 111449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111473 */     GIR_RootConstrainSelectedInstOperands,
     /* 111474 */     // GIR_Coverage, 3226,
     /* 111474 */     GIR_EraseRootFromParent_Done,
     /* 111475 */   // Label 1550: @111475
     /* 111475 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(111535), // Rule ID 3215 //
     /* 111480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 111483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111506 */     // (ld:{ *:[v2i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 111509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111533 */     GIR_RootConstrainSelectedInstOperands,
     /* 111534 */     // GIR_Coverage, 3215,
     /* 111534 */     GIR_EraseRootFromParent_Done,
     /* 111535 */   // Label 1551: @111535
     /* 111535 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(111595), // Rule ID 3232 //
     /* 111540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 111543 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111566 */     // (ld:{ *:[v2f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 111569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111593 */     GIR_RootConstrainSelectedInstOperands,
     /* 111594 */     // GIR_Coverage, 3232,
     /* 111594 */     GIR_EraseRootFromParent_Done,
     /* 111595 */   // Label 1552: @111595
     /* 111595 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(111654), // Rule ID 3200 //
     /* 111600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 111603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 111630 */     // (ld:{ *:[v2i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 111633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111652 */     GIR_RootConstrainSelectedInstOperands,
     /* 111653 */     // GIR_Coverage, 3200,
     /* 111653 */     GIR_EraseRootFromParent_Done,
     /* 111654 */   // Label 1553: @111654
     /* 111654 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(111713), // Rule ID 3201 //
     /* 111659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 111662 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111674 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 111689 */     // (ld:{ *:[v2i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 111692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111711 */     GIR_RootConstrainSelectedInstOperands,
     /* 111712 */     // GIR_Coverage, 3201,
     /* 111712 */     GIR_EraseRootFromParent_Done,
     /* 111713 */   // Label 1554: @111713
     /* 111713 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(111772), // Rule ID 3202 //
     /* 111718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 111721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111737 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 111748 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 111748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 111751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111770 */     GIR_RootConstrainSelectedInstOperands,
     /* 111771 */     // GIR_Coverage, 3202,
     /* 111771 */     GIR_EraseRootFromParent_Done,
     /* 111772 */   // Label 1555: @111772
     /* 111772 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(111834), // Rule ID 3203 //
     /* 111777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111796 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 111807 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 111807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 111810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111832 */     GIR_RootConstrainSelectedInstOperands,
     /* 111833 */     // GIR_Coverage, 3203,
     /* 111833 */     GIR_EraseRootFromParent_Done,
     /* 111834 */   // Label 1556: @111834
     /* 111834 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(111893), // Rule ID 3217 //
     /* 111839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 111842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111858 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 111869 */     // (ld:{ *:[v2f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 111872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111891 */     GIR_RootConstrainSelectedInstOperands,
     /* 111892 */     // GIR_Coverage, 3217,
     /* 111892 */     GIR_EraseRootFromParent_Done,
     /* 111893 */   // Label 1557: @111893
     /* 111893 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(111952), // Rule ID 3218 //
     /* 111898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 111901 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111917 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 111928 */     // (ld:{ *:[v2f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 111931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111950 */     GIR_RootConstrainSelectedInstOperands,
     /* 111951 */     // GIR_Coverage, 3218,
     /* 111951 */     GIR_EraseRootFromParent_Done,
     /* 111952 */   // Label 1558: @111952
     /* 111952 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(112011), // Rule ID 3219 //
     /* 111957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 111960 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 111968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 111987 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 111987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 111990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112009 */     GIR_RootConstrainSelectedInstOperands,
     /* 112010 */     // GIR_Coverage, 3219,
     /* 112010 */     GIR_EraseRootFromParent_Done,
     /* 112011 */   // Label 1559: @112011
     /* 112011 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(112073), // Rule ID 3220 //
     /* 112016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 112019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 112039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112046 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 112046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 112049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112071 */     GIR_RootConstrainSelectedInstOperands,
     /* 112072 */     // GIR_Coverage, 3220,
     /* 112072 */     GIR_EraseRootFromParent_Done,
     /* 112073 */   // Label 1560: @112073
     /* 112073 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(112128), // Rule ID 3206 //
     /* 112078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 112081 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 112104 */     // (ld:{ *:[v2i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 112107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112126 */     GIR_RootConstrainSelectedInstOperands,
     /* 112127 */     // GIR_Coverage, 3206,
     /* 112127 */     GIR_EraseRootFromParent_Done,
     /* 112128 */   // Label 1561: @112128
     /* 112128 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(112183), // Rule ID 3207 //
     /* 112133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 112136 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112148 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112159 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 112159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 112162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112181 */     GIR_RootConstrainSelectedInstOperands,
     /* 112182 */     // GIR_Coverage, 3207,
     /* 112182 */     GIR_EraseRootFromParent_Done,
     /* 112183 */   // Label 1562: @112183
     /* 112183 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(112241), // Rule ID 3208 //
     /* 112188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 112191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112214 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 112214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 112217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112239 */     GIR_RootConstrainSelectedInstOperands,
     /* 112240 */     // GIR_Coverage, 3208,
     /* 112240 */     GIR_EraseRootFromParent_Done,
     /* 112241 */   // Label 1563: @112241
     /* 112241 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(112296), // Rule ID 3223 //
     /* 112246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 112249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 112272 */     // (ld:{ *:[v2f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 112275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112294 */     GIR_RootConstrainSelectedInstOperands,
     /* 112295 */     // GIR_Coverage, 3223,
     /* 112295 */     GIR_EraseRootFromParent_Done,
     /* 112296 */   // Label 1564: @112296
     /* 112296 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(112351), // Rule ID 3224 //
     /* 112301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 112304 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112327 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 112327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 112330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112349 */     GIR_RootConstrainSelectedInstOperands,
     /* 112350 */     // GIR_Coverage, 3224,
     /* 112350 */     GIR_EraseRootFromParent_Done,
     /* 112351 */   // Label 1565: @112351
     /* 112351 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(112409), // Rule ID 3225 //
     /* 112356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 112359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112371 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112382 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 112382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 112385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112407 */     GIR_RootConstrainSelectedInstOperands,
     /* 112408 */     // GIR_Coverage, 3225,
     /* 112408 */     GIR_EraseRootFromParent_Done,
     /* 112409 */   // Label 1566: @112409
     /* 112409 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(112469), // Rule ID 8036 //
     /* 112414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 112417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112421 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112426 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 112430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 112434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112445 */     // (AMDGPUld_glue:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 112448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112467 */     GIR_RootConstrainSelectedInstOperands,
     /* 112468 */     // GIR_Coverage, 8036,
     /* 112468 */     GIR_EraseRootFromParent_Done,
     /* 112469 */   // Label 1567: @112469
     /* 112469 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(112529), // Rule ID 8040 //
     /* 112474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 112477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112481 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112486 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 112490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 112494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112505 */     // (AMDGPUld_glue:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 112508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112527 */     GIR_RootConstrainSelectedInstOperands,
     /* 112528 */     // GIR_Coverage, 8040,
     /* 112528 */     GIR_EraseRootFromParent_Done,
     /* 112529 */   // Label 1568: @112529
     /* 112529 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(112594), // Rule ID 8104 //
     /* 112534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 112537 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112541 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112546 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 112555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 112563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112570 */     // (AMDGPUld_glue:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 112573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112592 */     GIR_RootConstrainSelectedInstOperands,
     /* 112593 */     // GIR_Coverage, 8104,
     /* 112593 */     GIR_EraseRootFromParent_Done,
     /* 112594 */   // Label 1569: @112594
     /* 112594 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(112659), // Rule ID 8108 //
     /* 112599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 112602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112606 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112611 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 112620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 112628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112635 */     // (AMDGPUld_glue:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 112638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112657 */     GIR_RootConstrainSelectedInstOperands,
     /* 112658 */     // GIR_Coverage, 8108,
     /* 112658 */     GIR_EraseRootFromParent_Done,
     /* 112659 */   // Label 1570: @112659
     /* 112659 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(112711), // Rule ID 3211 //
     /* 112664 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112676 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 112687 */     // (ld:{ *:[v2i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 112690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112709 */     GIR_RootConstrainSelectedInstOperands,
     /* 112710 */     // GIR_Coverage, 3211,
     /* 112710 */     GIR_EraseRootFromParent_Done,
     /* 112711 */   // Label 1571: @112711
     /* 112711 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(112766), // Rule ID 3212 //
     /* 112716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 112719 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112731 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 112742 */     // (ld:{ *:[v2i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 112745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112764 */     GIR_RootConstrainSelectedInstOperands,
     /* 112765 */     // GIR_Coverage, 3212,
     /* 112765 */     GIR_EraseRootFromParent_Done,
     /* 112766 */   // Label 1572: @112766
     /* 112766 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(112821), // Rule ID 3213 //
     /* 112771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 112774 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112797 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 112797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 112800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112819 */     GIR_RootConstrainSelectedInstOperands,
     /* 112820 */     // GIR_Coverage, 3213,
     /* 112820 */     GIR_EraseRootFromParent_Done,
     /* 112821 */   // Label 1573: @112821
     /* 112821 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(112879), // Rule ID 3214 //
     /* 112826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 112829 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112852 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 112852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 112855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112877 */     GIR_RootConstrainSelectedInstOperands,
     /* 112878 */     // GIR_Coverage, 3214,
     /* 112878 */     GIR_EraseRootFromParent_Done,
     /* 112879 */   // Label 1574: @112879
     /* 112879 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(112931), // Rule ID 3228 //
     /* 112884 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 112907 */     // (ld:{ *:[v2f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 112910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112929 */     GIR_RootConstrainSelectedInstOperands,
     /* 112930 */     // GIR_Coverage, 3228,
     /* 112930 */     GIR_EraseRootFromParent_Done,
     /* 112931 */   // Label 1575: @112931
     /* 112931 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(112986), // Rule ID 3229 //
     /* 112936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 112939 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 112947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112951 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 112962 */     // (ld:{ *:[v2f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 112965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112984 */     GIR_RootConstrainSelectedInstOperands,
     /* 112985 */     // GIR_Coverage, 3229,
     /* 112985 */     GIR_EraseRootFromParent_Done,
     /* 112986 */   // Label 1576: @112986
     /* 112986 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(113041), // Rule ID 3230 //
     /* 112991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 112994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 113017 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 113017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 113020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 113027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 113032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113039 */     GIR_RootConstrainSelectedInstOperands,
     /* 113040 */     // GIR_Coverage, 3230,
     /* 113040 */     GIR_EraseRootFromParent_Done,
     /* 113041 */   // Label 1577: @113041
     /* 113041 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(113099), // Rule ID 3231 //
     /* 113046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 113049 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 113072 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 113075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 113082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 113087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113097 */     GIR_RootConstrainSelectedInstOperands,
     /* 113098 */     // GIR_Coverage, 3231,
     /* 113098 */     GIR_EraseRootFromParent_Done,
     /* 113099 */   // Label 1578: @113099
     /* 113099 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(113155), // Rule ID 8037 //
     /* 113104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 113107 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 113112 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 113116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 113131 */     // (ld:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 113131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 113134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 113141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113153 */     GIR_RootConstrainSelectedInstOperands,
     /* 113154 */     // GIR_Coverage, 8037,
     /* 113154 */     GIR_EraseRootFromParent_Done,
     /* 113155 */   // Label 1579: @113155
     /* 113155 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(113211), // Rule ID 8041 //
     /* 113160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 113163 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 113168 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 113172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 113187 */     // (ld:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 113187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 113190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 113197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113209 */     GIR_RootConstrainSelectedInstOperands,
     /* 113210 */     // GIR_Coverage, 8041,
     /* 113210 */     GIR_EraseRootFromParent_Done,
     /* 113211 */   // Label 1580: @113211
     /* 113211 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(113272), // Rule ID 8105 //
     /* 113216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 113219 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 113224 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 113229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113237 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 113241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 113248 */     // (ld:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 113248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 113251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 113258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113270 */     GIR_RootConstrainSelectedInstOperands,
     /* 113271 */     // GIR_Coverage, 8105,
     /* 113271 */     GIR_EraseRootFromParent_Done,
     /* 113272 */   // Label 1581: @113272
     /* 113272 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(113333), // Rule ID 8109 //
     /* 113277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 113280 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 113285 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 113290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 113302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 113309 */     // (ld:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 113309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 113312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 113319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113331 */     GIR_RootConstrainSelectedInstOperands,
     /* 113332 */     // GIR_Coverage, 8109,
     /* 113332 */     GIR_EraseRootFromParent_Done,
     /* 113333 */   // Label 1582: @113333
     /* 113333 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(113384), // Rule ID 3205 //
     /* 113338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 113341 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113349 */     // MIs[0] sbase
     /* 113349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113357 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 113365 */     // (ld:{ *:[v2i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 113368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113370 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113382 */     GIR_RootConstrainSelectedInstOperands,
     /* 113383 */     // GIR_Coverage, 3205,
     /* 113383 */     GIR_EraseRootFromParent_Done,
     /* 113384 */   // Label 1583: @113384
     /* 113384 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(113435), // Rule ID 3222 //
     /* 113389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 113392 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113400 */     // MIs[0] sbase
     /* 113400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113412 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 113416 */     // (ld:{ *:[v2f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 113419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113421 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113433 */     GIR_RootConstrainSelectedInstOperands,
     /* 113434 */     // GIR_Coverage, 3222,
     /* 113434 */     GIR_EraseRootFromParent_Done,
     /* 113435 */   // Label 1584: @113435
     /* 113435 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(113482), // Rule ID 3210 //
     /* 113440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 113443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113451 */     // MIs[0] sbase
     /* 113451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113463 */     // (ld:{ *:[v2i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 113466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113468 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113480 */     GIR_RootConstrainSelectedInstOperands,
     /* 113481 */     // GIR_Coverage, 3210,
     /* 113481 */     GIR_EraseRootFromParent_Done,
     /* 113482 */   // Label 1585: @113482
     /* 113482 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(113529), // Rule ID 3227 //
     /* 113487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 113490 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113498 */     // MIs[0] sbase
     /* 113498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113506 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113510 */     // (ld:{ *:[v2f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 113513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113515 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113527 */     GIR_RootConstrainSelectedInstOperands,
     /* 113528 */     // GIR_Coverage, 3227,
     /* 113528 */     GIR_EraseRootFromParent_Done,
     /* 113529 */   // Label 1586: @113529
     /* 113529 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(113573), // Rule ID 3216 //
     /* 113534 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113542 */     // MIs[0] sbase
     /* 113542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113550 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113554 */     // (ld:{ *:[v2i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 113557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113559 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113571 */     GIR_RootConstrainSelectedInstOperands,
     /* 113572 */     // GIR_Coverage, 3216,
     /* 113572 */     GIR_EraseRootFromParent_Done,
     /* 113573 */   // Label 1587: @113573
     /* 113573 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(113617), // Rule ID 3233 //
     /* 113578 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 113586 */     // MIs[0] sbase
     /* 113586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113598 */     // (ld:{ *:[v2f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 113601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113603 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113615 */     GIR_RootConstrainSelectedInstOperands,
     /* 113616 */     // GIR_Coverage, 3233,
     /* 113616 */     GIR_EraseRootFromParent_Done,
     /* 113617 */   // Label 1588: @113617
     /* 113617 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(113674), // Rule ID 4362 //
     /* 113622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 113625 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 113645 */     // (ld:{ *:[v2i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v2i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 113645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 113648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 113655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 113660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 113665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113672 */     GIR_RootConstrainSelectedInstOperands,
     /* 113673 */     // GIR_Coverage, 4362,
     /* 113673 */     GIR_EraseRootFromParent_Done,
     /* 113674 */   // Label 1589: @113674
     /* 113674 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(113731), // Rule ID 4368 //
     /* 113679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 113682 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 113702 */     // (ld:{ *:[v2f64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v2f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 113702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 113705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 113712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 113717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 113722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113729 */     GIR_RootConstrainSelectedInstOperands,
     /* 113730 */     // GIR_Coverage, 4368,
     /* 113730 */     GIR_EraseRootFromParent_Done,
     /* 113731 */   // Label 1590: @113731
     /* 113731 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(113783), // Rule ID 4361 //
     /* 113736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 113739 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 113759 */     // (ld:{ *:[v2i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v2i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 113759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 113762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 113769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113781 */     GIR_RootConstrainSelectedInstOperands,
     /* 113782 */     // GIR_Coverage, 4361,
     /* 113782 */     GIR_EraseRootFromParent_Done,
     /* 113783 */   // Label 1591: @113783
     /* 113783 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(113835), // Rule ID 4367 //
     /* 113788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 113791 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 113811 */     // (ld:{ *:[v2f64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v2f64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 113811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 113814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 113821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113833 */     GIR_RootConstrainSelectedInstOperands,
     /* 113834 */     // GIR_Coverage, 4367,
     /* 113834 */     GIR_EraseRootFromParent_Done,
     /* 113835 */   // Label 1592: @113835
     /* 113835 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(113887), // Rule ID 4360 //
     /* 113840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 113843 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 113863 */     // (ld:{ *:[v2i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v2i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 113863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 113866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 113873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113885 */     GIR_RootConstrainSelectedInstOperands,
     /* 113886 */     // GIR_Coverage, 4360,
     /* 113886 */     GIR_EraseRootFromParent_Done,
     /* 113887 */   // Label 1593: @113887
     /* 113887 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(113939), // Rule ID 4366 //
     /* 113892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 113895 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 113915 */     // (ld:{ *:[v2f64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v2f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 113915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 113918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 113925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113937 */     GIR_RootConstrainSelectedInstOperands,
     /* 113938 */     // GIR_Coverage, 4366,
     /* 113938 */     GIR_EraseRootFromParent_Done,
     /* 113939 */   // Label 1594: @113939
     /* 113939 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(114006), // Rule ID 4579 //
     /* 113944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 113947 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 113954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 113958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 113969 */     // (ld:{ *:[v2i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v2i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 113969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 113972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 113974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 113979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 113984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 113989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 113994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114004 */     GIR_RootConstrainSelectedInstOperands,
     /* 114005 */     // GIR_Coverage, 4579,
     /* 114005 */     GIR_EraseRootFromParent_Done,
     /* 114006 */   // Label 1595: @114006
     /* 114006 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(114070), // Rule ID 4581 //
     /* 114011 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 114033 */     // (ld:{ *:[v2i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v2i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 114036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 114043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 114053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 114058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114068 */     GIR_RootConstrainSelectedInstOperands,
     /* 114069 */     // GIR_Coverage, 4581,
     /* 114069 */     GIR_EraseRootFromParent_Done,
     /* 114070 */   // Label 1596: @114070
     /* 114070 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(114137), // Rule ID 4583 //
     /* 114075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 114078 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 114100 */     // (ld:{ *:[v2f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v2f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 114103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 114110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 114120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 114125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114135 */     GIR_RootConstrainSelectedInstOperands,
     /* 114136 */     // GIR_Coverage, 4583,
     /* 114136 */     GIR_EraseRootFromParent_Done,
     /* 114137 */   // Label 1597: @114137
     /* 114137 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(114201), // Rule ID 4585 //
     /* 114142 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 114164 */     // (ld:{ *:[v2f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v2f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 114167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 114174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 114184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 114189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114199 */     GIR_RootConstrainSelectedInstOperands,
     /* 114200 */     // GIR_Coverage, 4585,
     /* 114200 */     GIR_EraseRootFromParent_Done,
     /* 114201 */   // Label 1598: @114201
     /* 114201 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(114262), // Rule ID 7968 //
     /* 114206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 114209 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114213 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 114218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 114233 */     // (AMDGPUld_glue:{ *:[v2i64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 114233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 114236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 114243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 114248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 114253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114260 */     GIR_RootConstrainSelectedInstOperands,
     /* 114261 */     // GIR_Coverage, 7968,
     /* 114261 */     GIR_EraseRootFromParent_Done,
     /* 114262 */   // Label 1599: @114262
     /* 114262 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(114323), // Rule ID 7972 //
     /* 114267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 114270 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114274 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 114279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 114294 */     // (AMDGPUld_glue:{ *:[v2f64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 114294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 114297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 114304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 114309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 114314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114321 */     GIR_RootConstrainSelectedInstOperands,
     /* 114322 */     // GIR_Coverage, 7972,
     /* 114322 */     GIR_EraseRootFromParent_Done,
     /* 114323 */   // Label 1600: @114323
     /* 114323 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(114385), // Rule ID 4578 //
     /* 114328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 114331 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 114353 */     // (ld:{ *:[v2i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 114356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 114368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114383 */     GIR_RootConstrainSelectedInstOperands,
     /* 114384 */     // GIR_Coverage, 4578,
     /* 114384 */     GIR_EraseRootFromParent_Done,
     /* 114385 */   // Label 1601: @114385
     /* 114385 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(114444), // Rule ID 4580 //
     /* 114390 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 114412 */     // (ld:{ *:[v2i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 114415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 114427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114442 */     GIR_RootConstrainSelectedInstOperands,
     /* 114443 */     // GIR_Coverage, 4580,
     /* 114443 */     GIR_EraseRootFromParent_Done,
     /* 114444 */   // Label 1602: @114444
     /* 114444 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(114506), // Rule ID 4582 //
     /* 114449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 114452 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 114474 */     // (ld:{ *:[v2f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 114477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 114489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114504 */     GIR_RootConstrainSelectedInstOperands,
     /* 114505 */     // GIR_Coverage, 4582,
     /* 114505 */     GIR_EraseRootFromParent_Done,
     /* 114506 */   // Label 1603: @114506
     /* 114506 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(114565), // Rule ID 4584 //
     /* 114511 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 114533 */     // (ld:{ *:[v2f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 114536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 114548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114563 */     GIR_RootConstrainSelectedInstOperands,
     /* 114564 */     // GIR_Coverage, 4584,
     /* 114564 */     GIR_EraseRootFromParent_Done,
     /* 114565 */   // Label 1604: @114565
     /* 114565 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(114622), // Rule ID 7970 //
     /* 114570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 114573 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 114578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 114593 */     // (ld:{ *:[v2i64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 114593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 114596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 114603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 114608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 114613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114620 */     GIR_RootConstrainSelectedInstOperands,
     /* 114621 */     // GIR_Coverage, 7970,
     /* 114621 */     GIR_EraseRootFromParent_Done,
     /* 114622 */   // Label 1605: @114622
     /* 114622 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(114679), // Rule ID 7974 //
     /* 114627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 114630 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 114635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 114650 */     // (ld:{ *:[v2f64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 114650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 114653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 114660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 114665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 114670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114677 */     GIR_RootConstrainSelectedInstOperands,
     /* 114678 */     // GIR_Coverage, 7974,
     /* 114678 */     GIR_EraseRootFromParent_Done,
     /* 114679 */   // Label 1606: @114679
     /* 114679 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(114738), // Rule ID 3938 //
     /* 114684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 114687 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 114709 */     // (ld:{ *:[v2i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v2i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 114709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 114712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 114719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 114724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114736 */     GIR_RootConstrainSelectedInstOperands,
     /* 114737 */     // GIR_Coverage, 3938,
     /* 114737 */     GIR_EraseRootFromParent_Done,
     /* 114738 */   // Label 1607: @114738
     /* 114738 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(114797), // Rule ID 3942 //
     /* 114743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 114746 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 114768 */     // (ld:{ *:[v2f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v2f64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 114768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 114771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 114778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 114783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114795 */     GIR_RootConstrainSelectedInstOperands,
     /* 114796 */     // GIR_Coverage, 3942,
     /* 114796 */     GIR_EraseRootFromParent_Done,
     /* 114797 */   // Label 1608: @114797
     /* 114797 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(114851), // Rule ID 3937 //
     /* 114802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 114805 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 114827 */     // (ld:{ *:[v2i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v2i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 114827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 114830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 114837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114849 */     GIR_RootConstrainSelectedInstOperands,
     /* 114850 */     // GIR_Coverage, 3937,
     /* 114850 */     GIR_EraseRootFromParent_Done,
     /* 114851 */   // Label 1609: @114851
     /* 114851 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(114905), // Rule ID 3941 //
     /* 114856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 114859 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 114881 */     // (ld:{ *:[v2f64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v2f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 114881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 114884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 114891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114903 */     GIR_RootConstrainSelectedInstOperands,
     /* 114904 */     // GIR_Coverage, 3941,
     /* 114904 */     GIR_EraseRootFromParent_Done,
     /* 114905 */   // Label 1610: @114905
     /* 114905 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(114960), // Rule ID 3651 //
     /* 114910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 114913 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 114936 */     // (ld:{ *:[v2i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v2i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 114936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 114939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 114946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114958 */     GIR_RootConstrainSelectedInstOperands,
     /* 114959 */     // GIR_Coverage, 3651,
     /* 114959 */     GIR_EraseRootFromParent_Done,
     /* 114960 */   // Label 1611: @114960
     /* 114960 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(115015), // Rule ID 3653 //
     /* 114965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 114968 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 114980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 114991 */     // (ld:{ *:[v2f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v2f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 114991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 114994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 115001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115013 */     GIR_RootConstrainSelectedInstOperands,
     /* 115014 */     // GIR_Coverage, 3653,
     /* 115014 */     GIR_EraseRootFromParent_Done,
     /* 115015 */   // Label 1612: @115015
     /* 115015 */   GIM_Reject,
     /* 115016 */ // Label 1546: @115016
     /* 115016 */ GIM_Reject,
     /* 115017 */ // Label 885: @115017
     /* 115017 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(118235),
     /* 115022 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115025 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(115089), // Rule ID 3139 //
     /* 115030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115033 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115045 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115049 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115060 */     // (ld:{ *:[v3i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 115063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115087 */     GIR_RootConstrainSelectedInstOperands,
     /* 115088 */     // GIR_Coverage, 3139,
     /* 115088 */     GIR_EraseRootFromParent_Done,
     /* 115089 */   // Label 1614: @115089
     /* 115089 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(115153), // Rule ID 3154 //
     /* 115094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115097 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115109 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115113 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115124 */     // (ld:{ *:[v3f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 115127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115151 */     GIR_RootConstrainSelectedInstOperands,
     /* 115152 */     // GIR_Coverage, 3154,
     /* 115152 */     GIR_EraseRootFromParent_Done,
     /* 115153 */   // Label 1615: @115153
     /* 115153 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(115213), // Rule ID 3144 //
     /* 115158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115173 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115184 */     // (ld:{ *:[v3i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
     /* 115187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115211 */     GIR_RootConstrainSelectedInstOperands,
     /* 115212 */     // GIR_Coverage, 3144,
     /* 115212 */     GIR_EraseRootFromParent_Done,
     /* 115213 */   // Label 1616: @115213
     /* 115213 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(115273), // Rule ID 3159 //
     /* 115218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115221 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115233 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115244 */     // (ld:{ *:[v3f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
     /* 115247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115271 */     GIR_RootConstrainSelectedInstOperands,
     /* 115272 */     // GIR_Coverage, 3159,
     /* 115272 */     GIR_EraseRootFromParent_Done,
     /* 115273 */   // Label 1617: @115273
     /* 115273 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(115333), // Rule ID 3149 //
     /* 115278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 115281 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115304 */     // (ld:{ *:[v3i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 115307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115331 */     GIR_RootConstrainSelectedInstOperands,
     /* 115332 */     // GIR_Coverage, 3149,
     /* 115332 */     GIR_EraseRootFromParent_Done,
     /* 115333 */   // Label 1618: @115333
     /* 115333 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(115393), // Rule ID 3164 //
     /* 115338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 115341 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115353 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115364 */     // (ld:{ *:[v3f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 115367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115391 */     GIR_RootConstrainSelectedInstOperands,
     /* 115392 */     // GIR_Coverage, 3164,
     /* 115392 */     GIR_EraseRootFromParent_Done,
     /* 115393 */   // Label 1619: @115393
     /* 115393 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(115452), // Rule ID 3136 //
     /* 115398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 115401 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115413 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 115428 */     // (ld:{ *:[v3i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 115431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115450 */     GIR_RootConstrainSelectedInstOperands,
     /* 115451 */     // GIR_Coverage, 3136,
     /* 115451 */     GIR_EraseRootFromParent_Done,
     /* 115452 */   // Label 1620: @115452
     /* 115452 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(115511), // Rule ID 3137 //
     /* 115457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 115460 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115487 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 115487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
     /* 115490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115509 */     GIR_RootConstrainSelectedInstOperands,
     /* 115510 */     // GIR_Coverage, 3137,
     /* 115510 */     GIR_EraseRootFromParent_Done,
     /* 115511 */   // Label 1621: @115511
     /* 115511 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(115573), // Rule ID 3138 //
     /* 115516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115531 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115535 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115546 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 115546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 115549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115571 */     GIR_RootConstrainSelectedInstOperands,
     /* 115572 */     // GIR_Coverage, 3138,
     /* 115572 */     GIR_EraseRootFromParent_Done,
     /* 115573 */   // Label 1622: @115573
     /* 115573 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(115632), // Rule ID 3151 //
     /* 115578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 115581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 115608 */     // (ld:{ *:[v3f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 115611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115630 */     GIR_RootConstrainSelectedInstOperands,
     /* 115631 */     // GIR_Coverage, 3151,
     /* 115631 */     GIR_EraseRootFromParent_Done,
     /* 115632 */   // Label 1623: @115632
     /* 115632 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(115691), // Rule ID 3152 //
     /* 115637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 115640 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115652 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115667 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 115667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
     /* 115670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115689 */     GIR_RootConstrainSelectedInstOperands,
     /* 115690 */     // GIR_Coverage, 3152,
     /* 115690 */     GIR_EraseRootFromParent_Done,
     /* 115691 */   // Label 1624: @115691
     /* 115691 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(115753), // Rule ID 3153 //
     /* 115696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115699 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115711 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115726 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 115726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 115729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115751 */     GIR_RootConstrainSelectedInstOperands,
     /* 115752 */     // GIR_Coverage, 3153,
     /* 115752 */     GIR_EraseRootFromParent_Done,
     /* 115753 */   // Label 1625: @115753
     /* 115753 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(115808), // Rule ID 3141 //
     /* 115758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 115761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115773 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 115784 */     // (ld:{ *:[v3i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
     /* 115787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115806 */     GIR_RootConstrainSelectedInstOperands,
     /* 115807 */     // GIR_Coverage, 3141,
     /* 115807 */     GIR_EraseRootFromParent_Done,
     /* 115808 */   // Label 1626: @115808
     /* 115808 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(115863), // Rule ID 3142 //
     /* 115813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 115816 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115828 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115839 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 115839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_ec),
     /* 115842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115861 */     GIR_RootConstrainSelectedInstOperands,
     /* 115862 */     // GIR_Coverage, 3142,
     /* 115862 */     GIR_EraseRootFromParent_Done,
     /* 115863 */   // Label 1627: @115863
     /* 115863 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(115921), // Rule ID 3143 //
     /* 115868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115883 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115894 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 115894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
     /* 115897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115919 */     GIR_RootConstrainSelectedInstOperands,
     /* 115920 */     // GIR_Coverage, 3143,
     /* 115920 */     GIR_EraseRootFromParent_Done,
     /* 115921 */   // Label 1628: @115921
     /* 115921 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(115976), // Rule ID 3156 //
     /* 115926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 115929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 115952 */     // (ld:{ *:[v3f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
     /* 115955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115974 */     GIR_RootConstrainSelectedInstOperands,
     /* 115975 */     // GIR_Coverage, 3156,
     /* 115975 */     GIR_EraseRootFromParent_Done,
     /* 115976 */   // Label 1629: @115976
     /* 115976 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(116031), // Rule ID 3157 //
     /* 115981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 115984 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 115992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115996 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116007 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 116007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_ec),
     /* 116010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116029 */     GIR_RootConstrainSelectedInstOperands,
     /* 116030 */     // GIR_Coverage, 3157,
     /* 116030 */     GIR_EraseRootFromParent_Done,
     /* 116031 */   // Label 1630: @116031
     /* 116031 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(116089), // Rule ID 3158 //
     /* 116036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 116039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116051 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116062 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 116062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
     /* 116065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116087 */     GIR_RootConstrainSelectedInstOperands,
     /* 116088 */     // GIR_Coverage, 3158,
     /* 116088 */     GIR_EraseRootFromParent_Done,
     /* 116089 */   // Label 1631: @116089
     /* 116089 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(116149), // Rule ID 8020 //
     /* 116094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 116097 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116101 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116106 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 116110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116125 */     // (AMDGPUld_glue:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B96:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
     /* 116128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116147 */     GIR_RootConstrainSelectedInstOperands,
     /* 116148 */     // GIR_Coverage, 8020,
     /* 116148 */     GIR_EraseRootFromParent_Done,
     /* 116149 */   // Label 1632: @116149
     /* 116149 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(116209), // Rule ID 8024 //
     /* 116154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 116157 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116161 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116166 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 116170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116185 */     // (AMDGPUld_glue:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B96:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
     /* 116188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116207 */     GIR_RootConstrainSelectedInstOperands,
     /* 116208 */     // GIR_Coverage, 8024,
     /* 116208 */     GIR_EraseRootFromParent_Done,
     /* 116209 */   // Label 1633: @116209
     /* 116209 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(116265), // Rule ID 8088 //
     /* 116214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 116217 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116221 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116241 */     // (AMDGPUld_glue:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B96:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
     /* 116244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116263 */     GIR_RootConstrainSelectedInstOperands,
     /* 116264 */     // GIR_Coverage, 8088,
     /* 116264 */     GIR_EraseRootFromParent_Done,
     /* 116265 */   // Label 1634: @116265
     /* 116265 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(116321), // Rule ID 8092 //
     /* 116270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 116273 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116277 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116297 */     // (AMDGPUld_glue:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B96:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
     /* 116300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116319 */     GIR_RootConstrainSelectedInstOperands,
     /* 116320 */     // GIR_Coverage, 8092,
     /* 116320 */     GIR_EraseRootFromParent_Done,
     /* 116321 */   // Label 1635: @116321
     /* 116321 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(116373), // Rule ID 3146 //
     /* 116326 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116338 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 116349 */     // (ld:{ *:[v3i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 116349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 116352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116371 */     GIR_RootConstrainSelectedInstOperands,
     /* 116372 */     // GIR_Coverage, 3146,
     /* 116372 */     GIR_EraseRootFromParent_Done,
     /* 116373 */   // Label 1636: @116373
     /* 116373 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(116428), // Rule ID 3147 //
     /* 116378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 116381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116404 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 116404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
     /* 116407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116426 */     GIR_RootConstrainSelectedInstOperands,
     /* 116427 */     // GIR_Coverage, 3147,
     /* 116427 */     GIR_EraseRootFromParent_Done,
     /* 116428 */   // Label 1637: @116428
     /* 116428 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(116486), // Rule ID 3148 //
     /* 116433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 116436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116459 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 116459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 116462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116484 */     GIR_RootConstrainSelectedInstOperands,
     /* 116485 */     // GIR_Coverage, 3148,
     /* 116485 */     GIR_EraseRootFromParent_Done,
     /* 116486 */   // Label 1638: @116486
     /* 116486 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(116538), // Rule ID 3161 //
     /* 116491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116503 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 116514 */     // (ld:{ *:[v3f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 116514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 116517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116536 */     GIR_RootConstrainSelectedInstOperands,
     /* 116537 */     // GIR_Coverage, 3161,
     /* 116537 */     GIR_EraseRootFromParent_Done,
     /* 116538 */   // Label 1639: @116538
     /* 116538 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(116593), // Rule ID 3162 //
     /* 116543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 116546 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116569 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 116569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
     /* 116572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116591 */     GIR_RootConstrainSelectedInstOperands,
     /* 116592 */     // GIR_Coverage, 3162,
     /* 116592 */     GIR_EraseRootFromParent_Done,
     /* 116593 */   // Label 1640: @116593
     /* 116593 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(116651), // Rule ID 3163 //
     /* 116598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 116601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116613 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116624 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 116624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 116627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116649 */     GIR_RootConstrainSelectedInstOperands,
     /* 116650 */     // GIR_Coverage, 3163,
     /* 116650 */     GIR_EraseRootFromParent_Done,
     /* 116651 */   // Label 1641: @116651
     /* 116651 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(116707), // Rule ID 8021 //
     /* 116656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 116659 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116664 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 116668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116683 */     // (ld:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
     /* 116686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116705 */     GIR_RootConstrainSelectedInstOperands,
     /* 116706 */     // GIR_Coverage, 8021,
     /* 116706 */     GIR_EraseRootFromParent_Done,
     /* 116707 */   // Label 1642: @116707
     /* 116707 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(116763), // Rule ID 8025 //
     /* 116712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 116715 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116720 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 116724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116739 */     // (ld:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
     /* 116742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116761 */     GIR_RootConstrainSelectedInstOperands,
     /* 116762 */     // GIR_Coverage, 8025,
     /* 116762 */     GIR_EraseRootFromParent_Done,
     /* 116763 */   // Label 1643: @116763
     /* 116763 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(116815), // Rule ID 8089 //
     /* 116768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 116771 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116791 */     // (ld:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
     /* 116794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116813 */     GIR_RootConstrainSelectedInstOperands,
     /* 116814 */     // GIR_Coverage, 8089,
     /* 116814 */     GIR_EraseRootFromParent_Done,
     /* 116815 */   // Label 1644: @116815
     /* 116815 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(116867), // Rule ID 8093 //
     /* 116820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 116823 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 116832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116843 */     // (ld:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
     /* 116846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116865 */     GIR_RootConstrainSelectedInstOperands,
     /* 116866 */     // GIR_Coverage, 8093,
     /* 116866 */     GIR_EraseRootFromParent_Done,
     /* 116867 */   // Label 1645: @116867
     /* 116867 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(116918), // Rule ID 3140 //
     /* 116872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 116875 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116883 */     // MIs[0] sbase
     /* 116883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 116891 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116895 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 116899 */     // (ld:{ *:[v3i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 116899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 116902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116904 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 116906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116916 */     GIR_RootConstrainSelectedInstOperands,
     /* 116917 */     // GIR_Coverage, 3140,
     /* 116917 */     GIR_EraseRootFromParent_Done,
     /* 116918 */   // Label 1646: @116918
     /* 116918 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(116969), // Rule ID 3155 //
     /* 116923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 116926 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116934 */     // MIs[0] sbase
     /* 116934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 116942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 116950 */     // (ld:{ *:[v3f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 116950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 116953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116955 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 116957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116967 */     GIR_RootConstrainSelectedInstOperands,
     /* 116968 */     // GIR_Coverage, 3155,
     /* 116968 */     GIR_EraseRootFromParent_Done,
     /* 116969 */   // Label 1647: @116969
     /* 116969 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(117016), // Rule ID 3145 //
     /* 116974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 116977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 116985 */     // MIs[0] sbase
     /* 116985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 116993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116997 */     // (ld:{ *:[v3i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 116997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
     /* 117000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117002 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117014 */     GIR_RootConstrainSelectedInstOperands,
     /* 117015 */     // GIR_Coverage, 3145,
     /* 117015 */     GIR_EraseRootFromParent_Done,
     /* 117016 */   // Label 1648: @117016
     /* 117016 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(117063), // Rule ID 3160 //
     /* 117021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 117024 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 117032 */     // MIs[0] sbase
     /* 117032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117040 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117044 */     // (ld:{ *:[v3f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
     /* 117047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117049 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117061 */     GIR_RootConstrainSelectedInstOperands,
     /* 117062 */     // GIR_Coverage, 3160,
     /* 117062 */     GIR_EraseRootFromParent_Done,
     /* 117063 */   // Label 1649: @117063
     /* 117063 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(117107), // Rule ID 3150 //
     /* 117068 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 117076 */     // MIs[0] sbase
     /* 117076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117084 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117088 */     // (ld:{ *:[v3i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 117091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117093 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117105 */     GIR_RootConstrainSelectedInstOperands,
     /* 117106 */     // GIR_Coverage, 3150,
     /* 117106 */     GIR_EraseRootFromParent_Done,
     /* 117107 */   // Label 1650: @117107
     /* 117107 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(117151), // Rule ID 3165 //
     /* 117112 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 117120 */     // MIs[0] sbase
     /* 117120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117132 */     // (ld:{ *:[v3f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 117135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117137 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117149 */     GIR_RootConstrainSelectedInstOperands,
     /* 117150 */     // GIR_Coverage, 3165,
     /* 117150 */     GIR_EraseRootFromParent_Done,
     /* 117151 */   // Label 1651: @117151
     /* 117151 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(117211), // Rule ID 6515 //
     /* 117156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 117159 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 117179 */     // (ld:{ *:[v3i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 117179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 117182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 117194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117209 */     GIR_RootConstrainSelectedInstOperands,
     /* 117210 */     // GIR_Coverage, 6515,
     /* 117210 */     GIR_EraseRootFromParent_Done,
     /* 117211 */   // Label 1652: @117211
     /* 117211 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(117271), // Rule ID 6517 //
     /* 117216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 117219 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 117239 */     // (ld:{ *:[v3i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 117239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 117242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 117254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117269 */     GIR_RootConstrainSelectedInstOperands,
     /* 117270 */     // GIR_Coverage, 6517,
     /* 117270 */     GIR_EraseRootFromParent_Done,
     /* 117271 */   // Label 1653: @117271
     /* 117271 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(117328), // Rule ID 4347 //
     /* 117276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 117279 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 117299 */     // (ld:{ *:[v3i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX3_SVS:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 117299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX3_SVS),
     /* 117302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 117309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 117314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117326 */     GIR_RootConstrainSelectedInstOperands,
     /* 117327 */     // GIR_Coverage, 4347,
     /* 117327 */     GIR_EraseRootFromParent_Done,
     /* 117328 */   // Label 1654: @117328
     /* 117328 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(117380), // Rule ID 4346 //
     /* 117333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 117336 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 117356 */     // (ld:{ *:[v3i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX3_SADDR:{ *:[v3i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 117356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX3_SADDR),
     /* 117359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 117366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117378 */     GIR_RootConstrainSelectedInstOperands,
     /* 117379 */     // GIR_Coverage, 4346,
     /* 117379 */     GIR_EraseRootFromParent_Done,
     /* 117380 */   // Label 1655: @117380
     /* 117380 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(117432), // Rule ID 4345 //
     /* 117385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 117388 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 117408 */     // (ld:{ *:[v3i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX3:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 117408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX3),
     /* 117411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 117418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117430 */     GIR_RootConstrainSelectedInstOperands,
     /* 117431 */     // GIR_Coverage, 4345,
     /* 117431 */     GIR_EraseRootFromParent_Done,
     /* 117432 */   // Label 1656: @117432
     /* 117432 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(117499), // Rule ID 4563 //
     /* 117437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 117440 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 117462 */     // (ld:{ *:[v3i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_ADDR64:{ *:[v3i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_ADDR64),
     /* 117465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117497 */     GIR_RootConstrainSelectedInstOperands,
     /* 117498 */     // GIR_Coverage, 4563,
     /* 117498 */     GIR_EraseRootFromParent_Done,
     /* 117499 */   // Label 1657: @117499
     /* 117499 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(117563), // Rule ID 4565 //
     /* 117504 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 117526 */     // (ld:{ *:[v3i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64:{ *:[v3i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64),
     /* 117529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117561 */     GIR_RootConstrainSelectedInstOperands,
     /* 117562 */     // GIR_Coverage, 4565,
     /* 117562 */     GIR_EraseRootFromParent_Done,
     /* 117563 */   // Label 1658: @117563
     /* 117563 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(117630), // Rule ID 4567 //
     /* 117568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 117571 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 117593 */     // (ld:{ *:[v3f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_ADDR64:{ *:[v3f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_ADDR64),
     /* 117596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117628 */     GIR_RootConstrainSelectedInstOperands,
     /* 117629 */     // GIR_Coverage, 4567,
     /* 117629 */     GIR_EraseRootFromParent_Done,
     /* 117630 */   // Label 1659: @117630
     /* 117630 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(117694), // Rule ID 4569 //
     /* 117635 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 117657 */     // (ld:{ *:[v3f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64:{ *:[v3f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64),
     /* 117660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117692 */     GIR_RootConstrainSelectedInstOperands,
     /* 117693 */     // GIR_Coverage, 4569,
     /* 117693 */     GIR_EraseRootFromParent_Done,
     /* 117694 */   // Label 1660: @117694
     /* 117694 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(117759), // Rule ID 6514 //
     /* 117699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 117702 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 117722 */     // (ld:{ *:[v3i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_OFFEN:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 117722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFEN),
     /* 117725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117757 */     GIR_RootConstrainSelectedInstOperands,
     /* 117758 */     // GIR_Coverage, 6514,
     /* 117758 */     GIR_EraseRootFromParent_Done,
     /* 117759 */   // Label 1661: @117759
     /* 117759 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(117824), // Rule ID 6516 //
     /* 117764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 117767 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 117787 */     // (ld:{ *:[v3i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 117787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN),
     /* 117790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117822 */     GIR_RootConstrainSelectedInstOperands,
     /* 117823 */     // GIR_Coverage, 6516,
     /* 117823 */     GIR_EraseRootFromParent_Done,
     /* 117824 */   // Label 1662: @117824
     /* 117824 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(117886), // Rule ID 4562 //
     /* 117829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 117832 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 117854 */     // (ld:{ *:[v3i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 117857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 117869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117884 */     GIR_RootConstrainSelectedInstOperands,
     /* 117885 */     // GIR_Coverage, 4562,
     /* 117885 */     GIR_EraseRootFromParent_Done,
     /* 117886 */   // Label 1663: @117886
     /* 117886 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(117945), // Rule ID 4564 //
     /* 117891 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 117913 */     // (ld:{ *:[v3i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 117916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 117928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117943 */     GIR_RootConstrainSelectedInstOperands,
     /* 117944 */     // GIR_Coverage, 4564,
     /* 117944 */     GIR_EraseRootFromParent_Done,
     /* 117945 */   // Label 1664: @117945
     /* 117945 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(118007), // Rule ID 4566 //
     /* 117950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 117953 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 117964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 117975 */     // (ld:{ *:[v3f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 117978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 117990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118005 */     GIR_RootConstrainSelectedInstOperands,
     /* 118006 */     // GIR_Coverage, 4566,
     /* 118006 */     GIR_EraseRootFromParent_Done,
     /* 118007 */   // Label 1665: @118007
     /* 118007 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(118066), // Rule ID 4568 //
     /* 118012 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 118023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 118034 */     // (ld:{ *:[v3f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 118034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 118037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 118039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 118044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118064 */     GIR_RootConstrainSelectedInstOperands,
     /* 118065 */     // GIR_Coverage, 4568,
     /* 118065 */     GIR_EraseRootFromParent_Done,
     /* 118066 */   // Label 1666: @118066
     /* 118066 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(118125), // Rule ID 3928 //
     /* 118071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 118074 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 118085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 118096 */     // (ld:{ *:[v3i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX3_SADDR:{ *:[v3i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX3_SADDR),
     /* 118099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 118106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 118111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118123 */     GIR_RootConstrainSelectedInstOperands,
     /* 118124 */     // GIR_Coverage, 3928,
     /* 118124 */     GIR_EraseRootFromParent_Done,
     /* 118125 */   // Label 1667: @118125
     /* 118125 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(118179), // Rule ID 3927 //
     /* 118130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 118133 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 118144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 118155 */     // (ld:{ *:[v3i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX3:{ *:[v3i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 118155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX3),
     /* 118158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 118165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118177 */     GIR_RootConstrainSelectedInstOperands,
     /* 118178 */     // GIR_Coverage, 3927,
     /* 118178 */     GIR_EraseRootFromParent_Done,
     /* 118179 */   // Label 1668: @118179
     /* 118179 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(118234), // Rule ID 3589 //
     /* 118184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 118187 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 118199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 118210 */     // (ld:{ *:[v3i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX3:{ *:[v3i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 118210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX3),
     /* 118213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 118220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118232 */     GIR_RootConstrainSelectedInstOperands,
     /* 118233 */     // GIR_Coverage, 3589,
     /* 118233 */     GIR_EraseRootFromParent_Done,
     /* 118234 */   // Label 1669: @118234
     /* 118234 */   GIM_Reject,
     /* 118235 */ // Label 1613: @118235
     /* 118235 */ GIM_Reject,
     /* 118236 */ // Label 886: @118236
     /* 118236 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(122033),
     /* 118241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118244 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(118308), // Rule ID 3106 //
     /* 118249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 118252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118264 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118268 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118279 */     // (ld:{ *:[v4i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 118282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118306 */     GIR_RootConstrainSelectedInstOperands,
     /* 118307 */     // GIR_Coverage, 3106,
     /* 118307 */     GIR_EraseRootFromParent_Done,
     /* 118308 */   // Label 1671: @118308
     /* 118308 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(118372), // Rule ID 3123 //
     /* 118313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 118316 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118328 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118343 */     // (ld:{ *:[v4f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 118346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118370 */     GIR_RootConstrainSelectedInstOperands,
     /* 118371 */     // GIR_Coverage, 3123,
     /* 118371 */     GIR_EraseRootFromParent_Done,
     /* 118372 */   // Label 1672: @118372
     /* 118372 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(118432), // Rule ID 3111 //
     /* 118377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 118380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118403 */     // (ld:{ *:[v4i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 118406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118430 */     GIR_RootConstrainSelectedInstOperands,
     /* 118431 */     // GIR_Coverage, 3111,
     /* 118431 */     GIR_EraseRootFromParent_Done,
     /* 118432 */   // Label 1673: @118432
     /* 118432 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(118492), // Rule ID 3128 //
     /* 118437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 118440 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118463 */     // (ld:{ *:[v4f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 118466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118490 */     GIR_RootConstrainSelectedInstOperands,
     /* 118491 */     // GIR_Coverage, 3128,
     /* 118491 */     GIR_EraseRootFromParent_Done,
     /* 118492 */   // Label 1674: @118492
     /* 118492 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(118552), // Rule ID 3117 //
     /* 118497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 118500 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118523 */     // (ld:{ *:[v4i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 118526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118550 */     GIR_RootConstrainSelectedInstOperands,
     /* 118551 */     // GIR_Coverage, 3117,
     /* 118551 */     GIR_EraseRootFromParent_Done,
     /* 118552 */   // Label 1675: @118552
     /* 118552 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(118612), // Rule ID 3134 //
     /* 118557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 118560 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118572 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118583 */     // (ld:{ *:[v4f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 118586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118610 */     GIR_RootConstrainSelectedInstOperands,
     /* 118611 */     // GIR_Coverage, 3134,
     /* 118611 */     GIR_EraseRootFromParent_Done,
     /* 118612 */   // Label 1676: @118612
     /* 118612 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(118671), // Rule ID 3102 //
     /* 118617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 118620 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118632 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 118647 */     // (ld:{ *:[v4i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 118650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118669 */     GIR_RootConstrainSelectedInstOperands,
     /* 118670 */     // GIR_Coverage, 3102,
     /* 118670 */     GIR_EraseRootFromParent_Done,
     /* 118671 */   // Label 1677: @118671
     /* 118671 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(118730), // Rule ID 3103 //
     /* 118676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 118679 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118691 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 118706 */     // (ld:{ *:[v4i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 118709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118728 */     GIR_RootConstrainSelectedInstOperands,
     /* 118729 */     // GIR_Coverage, 3103,
     /* 118729 */     GIR_EraseRootFromParent_Done,
     /* 118730 */   // Label 1678: @118730
     /* 118730 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(118789), // Rule ID 3104 //
     /* 118735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 118738 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 118765 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 118765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 118768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118787 */     GIR_RootConstrainSelectedInstOperands,
     /* 118788 */     // GIR_Coverage, 3104,
     /* 118788 */     GIR_EraseRootFromParent_Done,
     /* 118789 */   // Label 1679: @118789
     /* 118789 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(118851), // Rule ID 3105 //
     /* 118794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 118797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 118824 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 118824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 118827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118849 */     GIR_RootConstrainSelectedInstOperands,
     /* 118850 */     // GIR_Coverage, 3105,
     /* 118850 */     GIR_EraseRootFromParent_Done,
     /* 118851 */   // Label 1680: @118851
     /* 118851 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(118910), // Rule ID 3119 //
     /* 118856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 118859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118875 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 118886 */     // (ld:{ *:[v4f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 118889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118908 */     GIR_RootConstrainSelectedInstOperands,
     /* 118909 */     // GIR_Coverage, 3119,
     /* 118909 */     GIR_EraseRootFromParent_Done,
     /* 118910 */   // Label 1681: @118910
     /* 118910 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(118969), // Rule ID 3120 //
     /* 118915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 118918 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 118945 */     // (ld:{ *:[v4f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 118948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118967 */     GIR_RootConstrainSelectedInstOperands,
     /* 118968 */     // GIR_Coverage, 3120,
     /* 118968 */     GIR_EraseRootFromParent_Done,
     /* 118969 */   // Label 1682: @118969
     /* 118969 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(119028), // Rule ID 3121 //
     /* 118974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 118977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 118985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118989 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119004 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 119004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 119007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119026 */     GIR_RootConstrainSelectedInstOperands,
     /* 119027 */     // GIR_Coverage, 3121,
     /* 119027 */     GIR_EraseRootFromParent_Done,
     /* 119028 */   // Label 1683: @119028
     /* 119028 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(119090), // Rule ID 3122 //
     /* 119033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 119036 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119048 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119052 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 119056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119063 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 119063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 119066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119088 */     GIR_RootConstrainSelectedInstOperands,
     /* 119089 */     // GIR_Coverage, 3122,
     /* 119089 */     GIR_EraseRootFromParent_Done,
     /* 119090 */   // Label 1684: @119090
     /* 119090 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(119145), // Rule ID 3108 //
     /* 119095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 119098 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 119121 */     // (ld:{ *:[v4i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 119124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119143 */     GIR_RootConstrainSelectedInstOperands,
     /* 119144 */     // GIR_Coverage, 3108,
     /* 119144 */     GIR_EraseRootFromParent_Done,
     /* 119145 */   // Label 1685: @119145
     /* 119145 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(119200), // Rule ID 3109 //
     /* 119150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 119153 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119165 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119176 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 119176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 119179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119198 */     GIR_RootConstrainSelectedInstOperands,
     /* 119199 */     // GIR_Coverage, 3109,
     /* 119199 */     GIR_EraseRootFromParent_Done,
     /* 119200 */   // Label 1686: @119200
     /* 119200 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(119258), // Rule ID 3110 //
     /* 119205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 119208 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119231 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 119231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 119234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119256 */     GIR_RootConstrainSelectedInstOperands,
     /* 119257 */     // GIR_Coverage, 3110,
     /* 119257 */     GIR_EraseRootFromParent_Done,
     /* 119258 */   // Label 1687: @119258
     /* 119258 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(119313), // Rule ID 3125 //
     /* 119263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 119266 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119278 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 119289 */     // (ld:{ *:[v4f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 119292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119311 */     GIR_RootConstrainSelectedInstOperands,
     /* 119312 */     // GIR_Coverage, 3125,
     /* 119312 */     GIR_EraseRootFromParent_Done,
     /* 119313 */   // Label 1688: @119313
     /* 119313 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(119368), // Rule ID 3126 //
     /* 119318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 119321 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119344 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 119344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 119347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119366 */     GIR_RootConstrainSelectedInstOperands,
     /* 119367 */     // GIR_Coverage, 3126,
     /* 119367 */     GIR_EraseRootFromParent_Done,
     /* 119368 */   // Label 1689: @119368
     /* 119368 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(119426), // Rule ID 3127 //
     /* 119373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 119376 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119388 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119399 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 119399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 119402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119424 */     GIR_RootConstrainSelectedInstOperands,
     /* 119425 */     // GIR_Coverage, 3127,
     /* 119425 */     GIR_EraseRootFromParent_Done,
     /* 119426 */   // Label 1690: @119426
     /* 119426 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(119491), // Rule ID 8068 //
     /* 119431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 119434 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119438 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119443 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 119452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 119460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 119467 */     // (AMDGPUld_glue:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 119467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 119470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 119472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 119477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119489 */     GIR_RootConstrainSelectedInstOperands,
     /* 119490 */     // GIR_Coverage, 8068,
     /* 119490 */     GIR_EraseRootFromParent_Done,
     /* 119491 */   // Label 1691: @119491
     /* 119491 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(119556), // Rule ID 8072 //
     /* 119496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 119499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119503 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119508 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 119517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 119525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 119532 */     // (AMDGPUld_glue:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 119532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 119535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 119537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 119542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119554 */     GIR_RootConstrainSelectedInstOperands,
     /* 119555 */     // GIR_Coverage, 8072,
     /* 119555 */     GIR_EraseRootFromParent_Done,
     /* 119556 */   // Label 1692: @119556
     /* 119556 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(119616), // Rule ID 8000 //
     /* 119561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 119564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119568 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119573 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 119577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 119581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 119592 */     // (AMDGPUld_glue:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 119592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 119595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 119597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 119602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119614 */     GIR_RootConstrainSelectedInstOperands,
     /* 119615 */     // GIR_Coverage, 8000,
     /* 119615 */     GIR_EraseRootFromParent_Done,
     /* 119616 */   // Label 1693: @119616
     /* 119616 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(119676), // Rule ID 8004 //
     /* 119621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 119624 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119628 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119633 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 119637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 119641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 119652 */     // (AMDGPUld_glue:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 119652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 119655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 119657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 119662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119674 */     GIR_RootConstrainSelectedInstOperands,
     /* 119675 */     // GIR_Coverage, 8004,
     /* 119675 */     GIR_EraseRootFromParent_Done,
     /* 119676 */   // Label 1694: @119676
     /* 119676 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(119728), // Rule ID 3113 //
     /* 119681 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119693 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 119704 */     // (ld:{ *:[v4i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 119707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119726 */     GIR_RootConstrainSelectedInstOperands,
     /* 119727 */     // GIR_Coverage, 3113,
     /* 119727 */     GIR_EraseRootFromParent_Done,
     /* 119728 */   // Label 1695: @119728
     /* 119728 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(119783), // Rule ID 3114 //
     /* 119733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 119736 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 119759 */     // (ld:{ *:[v4i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 119762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119781 */     GIR_RootConstrainSelectedInstOperands,
     /* 119782 */     // GIR_Coverage, 3114,
     /* 119782 */     GIR_EraseRootFromParent_Done,
     /* 119783 */   // Label 1696: @119783
     /* 119783 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(119838), // Rule ID 3115 //
     /* 119788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 119791 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119803 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119814 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 119814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 119817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119836 */     GIR_RootConstrainSelectedInstOperands,
     /* 119837 */     // GIR_Coverage, 3115,
     /* 119837 */     GIR_EraseRootFromParent_Done,
     /* 119838 */   // Label 1697: @119838
     /* 119838 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(119896), // Rule ID 3116 //
     /* 119843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 119846 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119858 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119869 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 119869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 119872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119894 */     GIR_RootConstrainSelectedInstOperands,
     /* 119895 */     // GIR_Coverage, 3116,
     /* 119895 */     GIR_EraseRootFromParent_Done,
     /* 119896 */   // Label 1698: @119896
     /* 119896 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(119948), // Rule ID 3130 //
     /* 119901 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 119924 */     // (ld:{ *:[v4f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 119927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119946 */     GIR_RootConstrainSelectedInstOperands,
     /* 119947 */     // GIR_Coverage, 3130,
     /* 119947 */     GIR_EraseRootFromParent_Done,
     /* 119948 */   // Label 1699: @119948
     /* 119948 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(120003), // Rule ID 3131 //
     /* 119953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 119956 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 119964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119968 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 119979 */     // (ld:{ *:[v4f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 119982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120001 */     GIR_RootConstrainSelectedInstOperands,
     /* 120002 */     // GIR_Coverage, 3131,
     /* 120002 */     GIR_EraseRootFromParent_Done,
     /* 120003 */   // Label 1700: @120003
     /* 120003 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(120058), // Rule ID 3132 //
     /* 120008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 120011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120023 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 120034 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 120034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 120037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 120049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120056 */     GIR_RootConstrainSelectedInstOperands,
     /* 120057 */     // GIR_Coverage, 3132,
     /* 120057 */     GIR_EraseRootFromParent_Done,
     /* 120058 */   // Label 1701: @120058
     /* 120058 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(120116), // Rule ID 3133 //
     /* 120063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 120066 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120078 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 120089 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 120092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 120104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120114 */     GIR_RootConstrainSelectedInstOperands,
     /* 120115 */     // GIR_Coverage, 3133,
     /* 120115 */     GIR_EraseRootFromParent_Done,
     /* 120116 */   // Label 1702: @120116
     /* 120116 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(120177), // Rule ID 8069 //
     /* 120121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 120124 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120129 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120142 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 120146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120153 */     // (ld:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 120156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120175 */     GIR_RootConstrainSelectedInstOperands,
     /* 120176 */     // GIR_Coverage, 8069,
     /* 120176 */     GIR_EraseRootFromParent_Done,
     /* 120177 */   // Label 1703: @120177
     /* 120177 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(120238), // Rule ID 8073 //
     /* 120182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 120185 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120190 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 120207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120214 */     // (ld:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 120217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120236 */     GIR_RootConstrainSelectedInstOperands,
     /* 120237 */     // GIR_Coverage, 8073,
     /* 120237 */     GIR_EraseRootFromParent_Done,
     /* 120238 */   // Label 1704: @120238
     /* 120238 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(120294), // Rule ID 8001 //
     /* 120243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 120246 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120251 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 120255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120270 */     // (ld:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 120273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120292 */     GIR_RootConstrainSelectedInstOperands,
     /* 120293 */     // GIR_Coverage, 8001,
     /* 120293 */     GIR_EraseRootFromParent_Done,
     /* 120294 */   // Label 1705: @120294
     /* 120294 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(120350), // Rule ID 8005 //
     /* 120299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 120302 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120307 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 120311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120326 */     // (ld:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 120329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120348 */     GIR_RootConstrainSelectedInstOperands,
     /* 120349 */     // GIR_Coverage, 8005,
     /* 120349 */     GIR_EraseRootFromParent_Done,
     /* 120350 */   // Label 1706: @120350
     /* 120350 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(120401), // Rule ID 3107 //
     /* 120355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 120358 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120366 */     // MIs[0] sbase
     /* 120366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120374 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120378 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 120382 */     // (ld:{ *:[v4i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 120385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120387 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120399 */     GIR_RootConstrainSelectedInstOperands,
     /* 120400 */     // GIR_Coverage, 3107,
     /* 120400 */     GIR_EraseRootFromParent_Done,
     /* 120401 */   // Label 1707: @120401
     /* 120401 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(120452), // Rule ID 3124 //
     /* 120406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 120409 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120417 */     // MIs[0] sbase
     /* 120417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120429 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 120433 */     // (ld:{ *:[v4f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 120436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120438 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120450 */     GIR_RootConstrainSelectedInstOperands,
     /* 120451 */     // GIR_Coverage, 3124,
     /* 120451 */     GIR_EraseRootFromParent_Done,
     /* 120452 */   // Label 1708: @120452
     /* 120452 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(120499), // Rule ID 3112 //
     /* 120457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 120460 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120468 */     // MIs[0] sbase
     /* 120468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120480 */     // (ld:{ *:[v4i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 120483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120485 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120497 */     GIR_RootConstrainSelectedInstOperands,
     /* 120498 */     // GIR_Coverage, 3112,
     /* 120498 */     GIR_EraseRootFromParent_Done,
     /* 120499 */   // Label 1709: @120499
     /* 120499 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(120546), // Rule ID 3129 //
     /* 120504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 120507 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120515 */     // MIs[0] sbase
     /* 120515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120523 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120527 */     // (ld:{ *:[v4f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 120530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120532 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120544 */     GIR_RootConstrainSelectedInstOperands,
     /* 120545 */     // GIR_Coverage, 3129,
     /* 120545 */     GIR_EraseRootFromParent_Done,
     /* 120546 */   // Label 1710: @120546
     /* 120546 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(120590), // Rule ID 3118 //
     /* 120551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120559 */     // MIs[0] sbase
     /* 120559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120571 */     // (ld:{ *:[v4i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 120574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120576 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120588 */     GIR_RootConstrainSelectedInstOperands,
     /* 120589 */     // GIR_Coverage, 3118,
     /* 120589 */     GIR_EraseRootFromParent_Done,
     /* 120590 */   // Label 1711: @120590
     /* 120590 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(120634), // Rule ID 3135 //
     /* 120595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 120603 */     // MIs[0] sbase
     /* 120603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120611 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120615 */     // (ld:{ *:[v4f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 120618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120620 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120632 */     GIR_RootConstrainSelectedInstOperands,
     /* 120633 */     // GIR_Coverage, 3135,
     /* 120633 */     GIR_EraseRootFromParent_Done,
     /* 120634 */   // Label 1712: @120634
     /* 120634 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(120691), // Rule ID 4317 //
     /* 120639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 120642 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 120647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 120662 */     // (ld:{ *:[v4f16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v4f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 120662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 120665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 120672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 120677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 120682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120689 */     GIR_RootConstrainSelectedInstOperands,
     /* 120690 */     // GIR_Coverage, 4317,
     /* 120690 */     GIR_EraseRootFromParent_Done,
     /* 120691 */   // Label 1713: @120691
     /* 120691 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(120748), // Rule ID 4323 //
     /* 120696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 120699 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 120704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 120719 */     // (ld:{ *:[v4i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v4i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 120719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 120722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 120729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 120734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 120739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120746 */     GIR_RootConstrainSelectedInstOperands,
     /* 120747 */     // GIR_Coverage, 4323,
     /* 120747 */     GIR_EraseRootFromParent_Done,
     /* 120748 */   // Label 1714: @120748
     /* 120748 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(120800), // Rule ID 4316 //
     /* 120753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 120756 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 120761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 120776 */     // (ld:{ *:[v4f16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v4f16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 120776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 120779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 120786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120798 */     GIR_RootConstrainSelectedInstOperands,
     /* 120799 */     // GIR_Coverage, 4316,
     /* 120799 */     GIR_EraseRootFromParent_Done,
     /* 120800 */   // Label 1715: @120800
     /* 120800 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(120852), // Rule ID 4322 //
     /* 120805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 120808 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 120813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 120828 */     // (ld:{ *:[v4i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v4i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 120828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 120831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 120838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120850 */     GIR_RootConstrainSelectedInstOperands,
     /* 120851 */     // GIR_Coverage, 4322,
     /* 120851 */     GIR_EraseRootFromParent_Done,
     /* 120852 */   // Label 1716: @120852
     /* 120852 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(120904), // Rule ID 4315 //
     /* 120857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 120860 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 120865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 120880 */     // (ld:{ *:[v4f16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v4f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 120880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 120883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 120890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120902 */     GIR_RootConstrainSelectedInstOperands,
     /* 120903 */     // GIR_Coverage, 4315,
     /* 120903 */     GIR_EraseRootFromParent_Done,
     /* 120904 */   // Label 1717: @120904
     /* 120904 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(120956), // Rule ID 4321 //
     /* 120909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 120912 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 120917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 120932 */     // (ld:{ *:[v4i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v4i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 120932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 120935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 120942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120954 */     GIR_RootConstrainSelectedInstOperands,
     /* 120955 */     // GIR_Coverage, 4321,
     /* 120955 */     GIR_EraseRootFromParent_Done,
     /* 120956 */   // Label 1718: @120956
     /* 120956 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(121023), // Rule ID 4543 //
     /* 120961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 120964 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 120971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 120975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 120986 */     // (ld:{ *:[v4f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v4f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 120986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 120989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 120991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 120996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121021 */     GIR_RootConstrainSelectedInstOperands,
     /* 121022 */     // GIR_Coverage, 4543,
     /* 121022 */     GIR_EraseRootFromParent_Done,
     /* 121023 */   // Label 1719: @121023
     /* 121023 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(121087), // Rule ID 4545 //
     /* 121028 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 121050 */     // (ld:{ *:[v4f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v4f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 121053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 121060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121085 */     GIR_RootConstrainSelectedInstOperands,
     /* 121086 */     // GIR_Coverage, 4545,
     /* 121086 */     GIR_EraseRootFromParent_Done,
     /* 121087 */   // Label 1720: @121087
     /* 121087 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(121154), // Rule ID 4547 //
     /* 121092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 121095 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 121117 */     // (ld:{ *:[v4i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v4i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 121120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 121127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121152 */     GIR_RootConstrainSelectedInstOperands,
     /* 121153 */     // GIR_Coverage, 4547,
     /* 121153 */     GIR_EraseRootFromParent_Done,
     /* 121154 */   // Label 1721: @121154
     /* 121154 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(121218), // Rule ID 4549 //
     /* 121159 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 121181 */     // (ld:{ *:[v4i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v4i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 121184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 121191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121216 */     GIR_RootConstrainSelectedInstOperands,
     /* 121217 */     // GIR_Coverage, 4549,
     /* 121217 */     GIR_EraseRootFromParent_Done,
     /* 121218 */   // Label 1722: @121218
     /* 121218 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(121279), // Rule ID 7944 //
     /* 121223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 121226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121230 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 121235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 121250 */     // (AMDGPUld_glue:{ *:[v4f16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 121250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 121253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 121260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 121265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 121270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121277 */     GIR_RootConstrainSelectedInstOperands,
     /* 121278 */     // GIR_Coverage, 7944,
     /* 121278 */     GIR_EraseRootFromParent_Done,
     /* 121279 */   // Label 1723: @121279
     /* 121279 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(121340), // Rule ID 7948 //
     /* 121284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 121287 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121291 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 121296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 121311 */     // (AMDGPUld_glue:{ *:[v4i16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 121311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 121314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 121321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 121326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 121331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121338 */     GIR_RootConstrainSelectedInstOperands,
     /* 121339 */     // GIR_Coverage, 7948,
     /* 121339 */     GIR_EraseRootFromParent_Done,
     /* 121340 */   // Label 1724: @121340
     /* 121340 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(121402), // Rule ID 4542 //
     /* 121345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 121348 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 121370 */     // (ld:{ *:[v4f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 121373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 121385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121400 */     GIR_RootConstrainSelectedInstOperands,
     /* 121401 */     // GIR_Coverage, 4542,
     /* 121401 */     GIR_EraseRootFromParent_Done,
     /* 121402 */   // Label 1725: @121402
     /* 121402 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(121461), // Rule ID 4544 //
     /* 121407 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 121429 */     // (ld:{ *:[v4f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 121432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 121444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121459 */     GIR_RootConstrainSelectedInstOperands,
     /* 121460 */     // GIR_Coverage, 4544,
     /* 121460 */     GIR_EraseRootFromParent_Done,
     /* 121461 */   // Label 1726: @121461
     /* 121461 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(121523), // Rule ID 4546 //
     /* 121466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 121469 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 121491 */     // (ld:{ *:[v4i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 121494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 121506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121521 */     GIR_RootConstrainSelectedInstOperands,
     /* 121522 */     // GIR_Coverage, 4546,
     /* 121522 */     GIR_EraseRootFromParent_Done,
     /* 121523 */   // Label 1727: @121523
     /* 121523 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(121582), // Rule ID 4548 //
     /* 121528 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 121550 */     // (ld:{ *:[v4i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 121553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 121565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121580 */     GIR_RootConstrainSelectedInstOperands,
     /* 121581 */     // GIR_Coverage, 4548,
     /* 121581 */     GIR_EraseRootFromParent_Done,
     /* 121582 */   // Label 1728: @121582
     /* 121582 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(121639), // Rule ID 7946 //
     /* 121587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 121590 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 121595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 121610 */     // (ld:{ *:[v4f16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 121610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 121613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 121620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 121625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 121630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121637 */     GIR_RootConstrainSelectedInstOperands,
     /* 121638 */     // GIR_Coverage, 7946,
     /* 121638 */     GIR_EraseRootFromParent_Done,
     /* 121639 */   // Label 1729: @121639
     /* 121639 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(121696), // Rule ID 7950 //
     /* 121644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 121647 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 121652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 121667 */     // (ld:{ *:[v4i16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 121667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 121670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 121677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 121682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 121687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121694 */     GIR_RootConstrainSelectedInstOperands,
     /* 121695 */     // GIR_Coverage, 7950,
     /* 121695 */     GIR_EraseRootFromParent_Done,
     /* 121696 */   // Label 1730: @121696
     /* 121696 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(121755), // Rule ID 3908 //
     /* 121701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 121704 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 121726 */     // (ld:{ *:[v4f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v4f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 121726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 121729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 121736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 121741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121753 */     GIR_RootConstrainSelectedInstOperands,
     /* 121754 */     // GIR_Coverage, 3908,
     /* 121754 */     GIR_EraseRootFromParent_Done,
     /* 121755 */   // Label 1731: @121755
     /* 121755 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(121814), // Rule ID 3912 //
     /* 121760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 121763 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 121785 */     // (ld:{ *:[v4i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v4i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 121785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 121788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 121795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 121800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121812 */     GIR_RootConstrainSelectedInstOperands,
     /* 121813 */     // GIR_Coverage, 3912,
     /* 121813 */     GIR_EraseRootFromParent_Done,
     /* 121814 */   // Label 1732: @121814
     /* 121814 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(121868), // Rule ID 3907 //
     /* 121819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 121822 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 121844 */     // (ld:{ *:[v4f16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v4f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 121844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 121847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 121854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121866 */     GIR_RootConstrainSelectedInstOperands,
     /* 121867 */     // GIR_Coverage, 3907,
     /* 121867 */     GIR_EraseRootFromParent_Done,
     /* 121868 */   // Label 1733: @121868
     /* 121868 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(121922), // Rule ID 3911 //
     /* 121873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 121876 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 121898 */     // (ld:{ *:[v4i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v4i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 121898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 121901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 121908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121920 */     GIR_RootConstrainSelectedInstOperands,
     /* 121921 */     // GIR_Coverage, 3911,
     /* 121921 */     GIR_EraseRootFromParent_Done,
     /* 121922 */   // Label 1734: @121922
     /* 121922 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(121977), // Rule ID 3637 //
     /* 121927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 121930 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 121953 */     // (ld:{ *:[v4f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v4f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 121953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 121956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 121963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121975 */     GIR_RootConstrainSelectedInstOperands,
     /* 121976 */     // GIR_Coverage, 3637,
     /* 121976 */     GIR_EraseRootFromParent_Done,
     /* 121977 */   // Label 1735: @121977
     /* 121977 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(122032), // Rule ID 3639 //
     /* 121982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 121985 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 121997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 122008 */     // (ld:{ *:[v4i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v4i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 122008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 122011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 122013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 122018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122030 */     GIR_RootConstrainSelectedInstOperands,
     /* 122031 */     // GIR_Coverage, 3639,
     /* 122031 */     GIR_EraseRootFromParent_Done,
     /* 122032 */   // Label 1736: @122032
     /* 122032 */   GIM_Reject,
     /* 122033 */ // Label 1670: @122033
     /* 122033 */ GIM_Reject,
     /* 122034 */ // Label 887: @122034
     /* 122034 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(126081),
     /* 122039 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122042 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(122106), // Rule ID 3170 //
     /* 122047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122050 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122077 */     // (ld:{ *:[v4i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 122080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122104 */     GIR_RootConstrainSelectedInstOperands,
     /* 122105 */     // GIR_Coverage, 3170,
     /* 122105 */     GIR_EraseRootFromParent_Done,
     /* 122106 */   // Label 1738: @122106
     /* 122106 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(122170), // Rule ID 3187 //
     /* 122111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122114 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122126 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122141 */     // (ld:{ *:[v4f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 122144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122168 */     GIR_RootConstrainSelectedInstOperands,
     /* 122169 */     // GIR_Coverage, 3187,
     /* 122169 */     GIR_EraseRootFromParent_Done,
     /* 122170 */   // Label 1739: @122170
     /* 122170 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(122230), // Rule ID 3175 //
     /* 122175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122201 */     // (ld:{ *:[v4i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 122204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122228 */     GIR_RootConstrainSelectedInstOperands,
     /* 122229 */     // GIR_Coverage, 3175,
     /* 122229 */     GIR_EraseRootFromParent_Done,
     /* 122230 */   // Label 1740: @122230
     /* 122230 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(122290), // Rule ID 3192 //
     /* 122235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122250 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122261 */     // (ld:{ *:[v4f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 122264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122288 */     GIR_RootConstrainSelectedInstOperands,
     /* 122289 */     // GIR_Coverage, 3192,
     /* 122289 */     GIR_EraseRootFromParent_Done,
     /* 122290 */   // Label 1741: @122290
     /* 122290 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(122350), // Rule ID 3181 //
     /* 122295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 122298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122310 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122321 */     // (ld:{ *:[v4i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 122324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122348 */     GIR_RootConstrainSelectedInstOperands,
     /* 122349 */     // GIR_Coverage, 3181,
     /* 122349 */     GIR_EraseRootFromParent_Done,
     /* 122350 */   // Label 1742: @122350
     /* 122350 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(122410), // Rule ID 3198 //
     /* 122355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 122358 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122381 */     // (ld:{ *:[v4f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 122384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122408 */     GIR_RootConstrainSelectedInstOperands,
     /* 122409 */     // GIR_Coverage, 3198,
     /* 122409 */     GIR_EraseRootFromParent_Done,
     /* 122410 */   // Label 1743: @122410
     /* 122410 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(122469), // Rule ID 3166 //
     /* 122415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 122418 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122430 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 122445 */     // (ld:{ *:[v4i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 122448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122467 */     GIR_RootConstrainSelectedInstOperands,
     /* 122468 */     // GIR_Coverage, 3166,
     /* 122468 */     GIR_EraseRootFromParent_Done,
     /* 122469 */   // Label 1744: @122469
     /* 122469 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(122528), // Rule ID 3167 //
     /* 122474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 122477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122493 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 122504 */     // (ld:{ *:[v4i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 122507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122526 */     GIR_RootConstrainSelectedInstOperands,
     /* 122527 */     // GIR_Coverage, 3167,
     /* 122527 */     GIR_EraseRootFromParent_Done,
     /* 122528 */   // Label 1745: @122528
     /* 122528 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(122587), // Rule ID 3168 //
     /* 122533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 122536 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122548 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122552 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 122563 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 122563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 122566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122585 */     GIR_RootConstrainSelectedInstOperands,
     /* 122586 */     // GIR_Coverage, 3168,
     /* 122586 */     GIR_EraseRootFromParent_Done,
     /* 122587 */   // Label 1746: @122587
     /* 122587 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(122649), // Rule ID 3169 //
     /* 122592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122607 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122611 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 122622 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 122622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 122625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122647 */     GIR_RootConstrainSelectedInstOperands,
     /* 122648 */     // GIR_Coverage, 3169,
     /* 122648 */     GIR_EraseRootFromParent_Done,
     /* 122649 */   // Label 1747: @122649
     /* 122649 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(122708), // Rule ID 3183 //
     /* 122654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 122657 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122673 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 122684 */     // (ld:{ *:[v4f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 122687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122706 */     GIR_RootConstrainSelectedInstOperands,
     /* 122707 */     // GIR_Coverage, 3183,
     /* 122707 */     GIR_EraseRootFromParent_Done,
     /* 122708 */   // Label 1748: @122708
     /* 122708 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(122767), // Rule ID 3184 //
     /* 122713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 122716 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122728 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 122743 */     // (ld:{ *:[v4f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 122746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122765 */     GIR_RootConstrainSelectedInstOperands,
     /* 122766 */     // GIR_Coverage, 3184,
     /* 122766 */     GIR_EraseRootFromParent_Done,
     /* 122767 */   // Label 1749: @122767
     /* 122767 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(122826), // Rule ID 3185 //
     /* 122772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 122775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122787 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122791 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 122802 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 122802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 122805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122824 */     GIR_RootConstrainSelectedInstOperands,
     /* 122825 */     // GIR_Coverage, 3185,
     /* 122825 */     GIR_EraseRootFromParent_Done,
     /* 122826 */   // Label 1750: @122826
     /* 122826 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(122888), // Rule ID 3186 //
     /* 122831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122834 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 122861 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 122861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 122864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122886 */     GIR_RootConstrainSelectedInstOperands,
     /* 122887 */     // GIR_Coverage, 3186,
     /* 122887 */     GIR_EraseRootFromParent_Done,
     /* 122888 */   // Label 1751: @122888
     /* 122888 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(122943), // Rule ID 3172 //
     /* 122893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 122896 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 122919 */     // (ld:{ *:[v4i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 122922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122941 */     GIR_RootConstrainSelectedInstOperands,
     /* 122942 */     // GIR_Coverage, 3172,
     /* 122942 */     GIR_EraseRootFromParent_Done,
     /* 122943 */   // Label 1752: @122943
     /* 122943 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(122998), // Rule ID 3173 //
     /* 122948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 122951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 122959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 122974 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 122974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 122977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122996 */     GIR_RootConstrainSelectedInstOperands,
     /* 122997 */     // GIR_Coverage, 3173,
     /* 122997 */     GIR_EraseRootFromParent_Done,
     /* 122998 */   // Label 1753: @122998
     /* 122998 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(123056), // Rule ID 3174 //
     /* 123003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 123006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123018 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123029 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 123029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 123032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123054 */     GIR_RootConstrainSelectedInstOperands,
     /* 123055 */     // GIR_Coverage, 3174,
     /* 123055 */     GIR_EraseRootFromParent_Done,
     /* 123056 */   // Label 1754: @123056
     /* 123056 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(123111), // Rule ID 3189 //
     /* 123061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 123064 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123076 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 123087 */     // (ld:{ *:[v4f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 123090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123109 */     GIR_RootConstrainSelectedInstOperands,
     /* 123110 */     // GIR_Coverage, 3189,
     /* 123110 */     GIR_EraseRootFromParent_Done,
     /* 123111 */   // Label 1755: @123111
     /* 123111 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(123166), // Rule ID 3190 //
     /* 123116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 123119 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123142 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 123142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 123145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123164 */     GIR_RootConstrainSelectedInstOperands,
     /* 123165 */     // GIR_Coverage, 3190,
     /* 123165 */     GIR_EraseRootFromParent_Done,
     /* 123166 */   // Label 1756: @123166
     /* 123166 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(123224), // Rule ID 3191 //
     /* 123171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 123174 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123186 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123197 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 123197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 123200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123222 */     GIR_RootConstrainSelectedInstOperands,
     /* 123223 */     // GIR_Coverage, 3191,
     /* 123223 */     GIR_EraseRootFromParent_Done,
     /* 123224 */   // Label 1757: @123224
     /* 123224 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(123284), // Rule ID 8028 //
     /* 123229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 123232 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123236 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123241 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 123245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 123249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123260 */     // (AMDGPUld_glue:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 123263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123282 */     GIR_RootConstrainSelectedInstOperands,
     /* 123283 */     // GIR_Coverage, 8028,
     /* 123283 */     GIR_EraseRootFromParent_Done,
     /* 123284 */   // Label 1758: @123284
     /* 123284 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(123344), // Rule ID 8032 //
     /* 123289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 123292 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123296 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123301 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 123305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 123309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123320 */     // (AMDGPUld_glue:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 123323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123342 */     GIR_RootConstrainSelectedInstOperands,
     /* 123343 */     // GIR_Coverage, 8032,
     /* 123343 */     GIR_EraseRootFromParent_Done,
     /* 123344 */   // Label 1759: @123344
     /* 123344 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(123409), // Rule ID 8096 //
     /* 123349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 123352 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123356 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123361 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 123370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123374 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 123378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123385 */     // (AMDGPUld_glue:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 123388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123407 */     GIR_RootConstrainSelectedInstOperands,
     /* 123408 */     // GIR_Coverage, 8096,
     /* 123408 */     GIR_EraseRootFromParent_Done,
     /* 123409 */   // Label 1760: @123409
     /* 123409 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(123474), // Rule ID 8100 //
     /* 123414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 123417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123421 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123426 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 123435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123439 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 123443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123450 */     // (AMDGPUld_glue:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 123453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123472 */     GIR_RootConstrainSelectedInstOperands,
     /* 123473 */     // GIR_Coverage, 8100,
     /* 123473 */     GIR_EraseRootFromParent_Done,
     /* 123474 */   // Label 1761: @123474
     /* 123474 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(123526), // Rule ID 3177 //
     /* 123479 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 123502 */     // (ld:{ *:[v4i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 123505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123524 */     GIR_RootConstrainSelectedInstOperands,
     /* 123525 */     // GIR_Coverage, 3177,
     /* 123525 */     GIR_EraseRootFromParent_Done,
     /* 123526 */   // Label 1762: @123526
     /* 123526 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(123581), // Rule ID 3178 //
     /* 123531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 123534 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 123557 */     // (ld:{ *:[v4i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 123560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123579 */     GIR_RootConstrainSelectedInstOperands,
     /* 123580 */     // GIR_Coverage, 3178,
     /* 123580 */     GIR_EraseRootFromParent_Done,
     /* 123581 */   // Label 1763: @123581
     /* 123581 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(123636), // Rule ID 3179 //
     /* 123586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 123589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123612 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 123612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 123615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123634 */     GIR_RootConstrainSelectedInstOperands,
     /* 123635 */     // GIR_Coverage, 3179,
     /* 123635 */     GIR_EraseRootFromParent_Done,
     /* 123636 */   // Label 1764: @123636
     /* 123636 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(123694), // Rule ID 3180 //
     /* 123641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 123644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123667 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 123667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 123670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123692 */     GIR_RootConstrainSelectedInstOperands,
     /* 123693 */     // GIR_Coverage, 3180,
     /* 123693 */     GIR_EraseRootFromParent_Done,
     /* 123694 */   // Label 1765: @123694
     /* 123694 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(123746), // Rule ID 3194 //
     /* 123699 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123711 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 123722 */     // (ld:{ *:[v4f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 123725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123744 */     GIR_RootConstrainSelectedInstOperands,
     /* 123745 */     // GIR_Coverage, 3194,
     /* 123745 */     GIR_EraseRootFromParent_Done,
     /* 123746 */   // Label 1766: @123746
     /* 123746 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(123801), // Rule ID 3195 //
     /* 123751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 123754 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123766 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 123777 */     // (ld:{ *:[v4f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 123780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123799 */     GIR_RootConstrainSelectedInstOperands,
     /* 123800 */     // GIR_Coverage, 3195,
     /* 123800 */     GIR_EraseRootFromParent_Done,
     /* 123801 */   // Label 1767: @123801
     /* 123801 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(123856), // Rule ID 3196 //
     /* 123806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 123809 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123832 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 123832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 123835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123854 */     GIR_RootConstrainSelectedInstOperands,
     /* 123855 */     // GIR_Coverage, 3196,
     /* 123855 */     GIR_EraseRootFromParent_Done,
     /* 123856 */   // Label 1768: @123856
     /* 123856 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(123914), // Rule ID 3197 //
     /* 123861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 123864 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 123872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123887 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 123887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 123890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123912 */     GIR_RootConstrainSelectedInstOperands,
     /* 123913 */     // GIR_Coverage, 3197,
     /* 123913 */     GIR_EraseRootFromParent_Done,
     /* 123914 */   // Label 1769: @123914
     /* 123914 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(123970), // Rule ID 8029 //
     /* 123919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 123922 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123927 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 123931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 123935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123946 */     // (ld:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 123949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123968 */     GIR_RootConstrainSelectedInstOperands,
     /* 123969 */     // GIR_Coverage, 8029,
     /* 123969 */     GIR_EraseRootFromParent_Done,
     /* 123970 */   // Label 1770: @123970
     /* 123970 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(124026), // Rule ID 8033 //
     /* 123975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 123978 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123983 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 123987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 123991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 124002 */     // (ld:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 124002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 124005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 124012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124024 */     GIR_RootConstrainSelectedInstOperands,
     /* 124025 */     // GIR_Coverage, 8033,
     /* 124025 */     GIR_EraseRootFromParent_Done,
     /* 124026 */   // Label 1771: @124026
     /* 124026 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(124087), // Rule ID 8097 //
     /* 124031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 124034 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 124039 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 124044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124052 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 124056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 124063 */     // (ld:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 124063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 124066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 124073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124085 */     GIR_RootConstrainSelectedInstOperands,
     /* 124086 */     // GIR_Coverage, 8097,
     /* 124086 */     GIR_EraseRootFromParent_Done,
     /* 124087 */   // Label 1772: @124087
     /* 124087 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(124148), // Rule ID 8101 //
     /* 124092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 124095 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 124100 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 124105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124113 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 124117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 124124 */     // (ld:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 124124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 124127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 124134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124146 */     GIR_RootConstrainSelectedInstOperands,
     /* 124147 */     // GIR_Coverage, 8101,
     /* 124147 */     GIR_EraseRootFromParent_Done,
     /* 124148 */   // Label 1773: @124148
     /* 124148 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(124199), // Rule ID 3171 //
     /* 124153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 124156 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124164 */     // MIs[0] sbase
     /* 124164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124172 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124176 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 124180 */     // (ld:{ *:[v4i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 124183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124185 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124197 */     GIR_RootConstrainSelectedInstOperands,
     /* 124198 */     // GIR_Coverage, 3171,
     /* 124198 */     GIR_EraseRootFromParent_Done,
     /* 124199 */   // Label 1774: @124199
     /* 124199 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(124250), // Rule ID 3188 //
     /* 124204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 124207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124215 */     // MIs[0] sbase
     /* 124215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124223 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124227 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 124231 */     // (ld:{ *:[v4f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 124234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124236 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124248 */     GIR_RootConstrainSelectedInstOperands,
     /* 124249 */     // GIR_Coverage, 3188,
     /* 124249 */     GIR_EraseRootFromParent_Done,
     /* 124250 */   // Label 1775: @124250
     /* 124250 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(124297), // Rule ID 3176 //
     /* 124255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 124258 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124266 */     // MIs[0] sbase
     /* 124266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124278 */     // (ld:{ *:[v4i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 124281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124283 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124295 */     GIR_RootConstrainSelectedInstOperands,
     /* 124296 */     // GIR_Coverage, 3176,
     /* 124296 */     GIR_EraseRootFromParent_Done,
     /* 124297 */   // Label 1776: @124297
     /* 124297 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(124344), // Rule ID 3193 //
     /* 124302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 124305 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124313 */     // MIs[0] sbase
     /* 124313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124325 */     // (ld:{ *:[v4f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 124328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124330 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124342 */     GIR_RootConstrainSelectedInstOperands,
     /* 124343 */     // GIR_Coverage, 3193,
     /* 124343 */     GIR_EraseRootFromParent_Done,
     /* 124344 */   // Label 1777: @124344
     /* 124344 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(124388), // Rule ID 3182 //
     /* 124349 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124357 */     // MIs[0] sbase
     /* 124357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124369 */     // (ld:{ *:[v4i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 124372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124374 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124386 */     GIR_RootConstrainSelectedInstOperands,
     /* 124387 */     // GIR_Coverage, 3182,
     /* 124387 */     GIR_EraseRootFromParent_Done,
     /* 124388 */   // Label 1778: @124388
     /* 124388 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(124432), // Rule ID 3199 //
     /* 124393 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 124401 */     // MIs[0] sbase
     /* 124401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124409 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124413 */     // (ld:{ *:[v4f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 124416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124418 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124430 */     GIR_RootConstrainSelectedInstOperands,
     /* 124431 */     // GIR_Coverage, 3199,
     /* 124431 */     GIR_EraseRootFromParent_Done,
     /* 124432 */   // Label 1779: @124432
     /* 124432 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(124492), // Rule ID 6519 //
     /* 124437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 124440 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 124460 */     // (ld:{ *:[v4i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 124460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 124463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 124465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 124470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 124475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 124480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124490 */     GIR_RootConstrainSelectedInstOperands,
     /* 124491 */     // GIR_Coverage, 6519,
     /* 124491 */     GIR_EraseRootFromParent_Done,
     /* 124492 */   // Label 1780: @124492
     /* 124492 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(124552), // Rule ID 6521 //
     /* 124497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 124500 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 124520 */     // (ld:{ *:[v4i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 124520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 124523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 124525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 124530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 124535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 124540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124550 */     GIR_RootConstrainSelectedInstOperands,
     /* 124551 */     // GIR_Coverage, 6521,
     /* 124551 */     GIR_EraseRootFromParent_Done,
     /* 124552 */   // Label 1781: @124552
     /* 124552 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(124609), // Rule ID 4350 //
     /* 124557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 124560 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 124580 */     // (ld:{ *:[v4i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 124580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 124583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 124590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 124595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 124600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124607 */     GIR_RootConstrainSelectedInstOperands,
     /* 124608 */     // GIR_Coverage, 4350,
     /* 124608 */     GIR_EraseRootFromParent_Done,
     /* 124609 */   // Label 1782: @124609
     /* 124609 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(124666), // Rule ID 4356 //
     /* 124614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 124617 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 124637 */     // (ld:{ *:[v4f32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v4f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 124637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 124640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 124647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 124652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 124657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124664 */     GIR_RootConstrainSelectedInstOperands,
     /* 124665 */     // GIR_Coverage, 4356,
     /* 124665 */     GIR_EraseRootFromParent_Done,
     /* 124666 */   // Label 1783: @124666
     /* 124666 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(124718), // Rule ID 4349 //
     /* 124671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 124674 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 124694 */     // (ld:{ *:[v4i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v4i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 124694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 124697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 124704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124716 */     GIR_RootConstrainSelectedInstOperands,
     /* 124717 */     // GIR_Coverage, 4349,
     /* 124717 */     GIR_EraseRootFromParent_Done,
     /* 124718 */   // Label 1784: @124718
     /* 124718 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(124770), // Rule ID 4355 //
     /* 124723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 124726 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 124746 */     // (ld:{ *:[v4f32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v4f32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 124746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 124749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 124756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124768 */     GIR_RootConstrainSelectedInstOperands,
     /* 124769 */     // GIR_Coverage, 4355,
     /* 124769 */     GIR_EraseRootFromParent_Done,
     /* 124770 */   // Label 1785: @124770
     /* 124770 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(124822), // Rule ID 4348 //
     /* 124775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 124778 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 124798 */     // (ld:{ *:[v4i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 124798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 124801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 124808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124820 */     GIR_RootConstrainSelectedInstOperands,
     /* 124821 */     // GIR_Coverage, 4348,
     /* 124821 */     GIR_EraseRootFromParent_Done,
     /* 124822 */   // Label 1786: @124822
     /* 124822 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(124874), // Rule ID 4354 //
     /* 124827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 124830 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 124850 */     // (ld:{ *:[v4f32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v4f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 124850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 124853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 124860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124872 */     GIR_RootConstrainSelectedInstOperands,
     /* 124873 */     // GIR_Coverage, 4354,
     /* 124873 */     GIR_EraseRootFromParent_Done,
     /* 124874 */   // Label 1787: @124874
     /* 124874 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(124941), // Rule ID 4571 //
     /* 124879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 124882 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 124889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 124904 */     // (ld:{ *:[v4i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v4i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 124904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 124907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 124909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 124914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 124919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 124924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 124929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124939 */     GIR_RootConstrainSelectedInstOperands,
     /* 124940 */     // GIR_Coverage, 4571,
     /* 124940 */     GIR_EraseRootFromParent_Done,
     /* 124941 */   // Label 1788: @124941
     /* 124941 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(125005), // Rule ID 4573 //
     /* 124946 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 124953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 124957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 124968 */     // (ld:{ *:[v4i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v4i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 124968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 124971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 124973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 124978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 124983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 124988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 124993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125003 */     GIR_RootConstrainSelectedInstOperands,
     /* 125004 */     // GIR_Coverage, 4573,
     /* 125004 */     GIR_EraseRootFromParent_Done,
     /* 125005 */   // Label 1789: @125005
     /* 125005 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(125072), // Rule ID 4575 //
     /* 125010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 125013 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 125035 */     // (ld:{ *:[v4f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v4f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 125038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 125045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 125055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 125060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125070 */     GIR_RootConstrainSelectedInstOperands,
     /* 125071 */     // GIR_Coverage, 4575,
     /* 125071 */     GIR_EraseRootFromParent_Done,
     /* 125072 */   // Label 1790: @125072
     /* 125072 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(125136), // Rule ID 4577 //
     /* 125077 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 125099 */     // (ld:{ *:[v4f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v4f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 125102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 125109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 125119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 125124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125134 */     GIR_RootConstrainSelectedInstOperands,
     /* 125135 */     // GIR_Coverage, 4577,
     /* 125135 */     GIR_EraseRootFromParent_Done,
     /* 125136 */   // Label 1791: @125136
     /* 125136 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(125201), // Rule ID 6518 //
     /* 125141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 125144 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 125149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 125164 */     // (ld:{ *:[v4i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 125164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 125167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 125174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 125184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 125189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125199 */     GIR_RootConstrainSelectedInstOperands,
     /* 125200 */     // GIR_Coverage, 6518,
     /* 125200 */     GIR_EraseRootFromParent_Done,
     /* 125201 */   // Label 1792: @125201
     /* 125201 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(125266), // Rule ID 6520 //
     /* 125206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 125209 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 125214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 125229 */     // (ld:{ *:[v4i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 125229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 125232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 125239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 125249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 125254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125264 */     GIR_RootConstrainSelectedInstOperands,
     /* 125265 */     // GIR_Coverage, 6520,
     /* 125265 */     GIR_EraseRootFromParent_Done,
     /* 125266 */   // Label 1793: @125266
     /* 125266 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(125327), // Rule ID 7928 //
     /* 125271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 125274 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125278 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 125283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 125298 */     // (AMDGPUld_glue:{ *:[v4i32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 125298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 125301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 125308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 125313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 125318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125325 */     GIR_RootConstrainSelectedInstOperands,
     /* 125326 */     // GIR_Coverage, 7928,
     /* 125326 */     GIR_EraseRootFromParent_Done,
     /* 125327 */   // Label 1794: @125327
     /* 125327 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(125388), // Rule ID 7964 //
     /* 125332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 125335 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125339 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 125344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 125359 */     // (AMDGPUld_glue:{ *:[v4f32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 125359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 125362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 125369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 125374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 125379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125386 */     GIR_RootConstrainSelectedInstOperands,
     /* 125387 */     // GIR_Coverage, 7964,
     /* 125387 */     GIR_EraseRootFromParent_Done,
     /* 125388 */   // Label 1795: @125388
     /* 125388 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(125450), // Rule ID 4570 //
     /* 125393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 125396 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 125418 */     // (ld:{ *:[v4i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 125421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125448 */     GIR_RootConstrainSelectedInstOperands,
     /* 125449 */     // GIR_Coverage, 4570,
     /* 125449 */     GIR_EraseRootFromParent_Done,
     /* 125450 */   // Label 1796: @125450
     /* 125450 */   GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(125509), // Rule ID 4572 //
     /* 125455 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 125477 */     // (ld:{ *:[v4i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 125480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125507 */     GIR_RootConstrainSelectedInstOperands,
     /* 125508 */     // GIR_Coverage, 4572,
     /* 125508 */     GIR_EraseRootFromParent_Done,
     /* 125509 */   // Label 1797: @125509
     /* 125509 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(125571), // Rule ID 4574 //
     /* 125514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 125517 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 125539 */     // (ld:{ *:[v4f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 125542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125569 */     GIR_RootConstrainSelectedInstOperands,
     /* 125570 */     // GIR_Coverage, 4574,
     /* 125570 */     GIR_EraseRootFromParent_Done,
     /* 125571 */   // Label 1798: @125571
     /* 125571 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(125630), // Rule ID 4576 //
     /* 125576 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 125598 */     // (ld:{ *:[v4f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 125601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125628 */     GIR_RootConstrainSelectedInstOperands,
     /* 125629 */     // GIR_Coverage, 4576,
     /* 125629 */     GIR_EraseRootFromParent_Done,
     /* 125630 */   // Label 1799: @125630
     /* 125630 */   GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(125687), // Rule ID 7930 //
     /* 125635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 125638 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 125643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 125658 */     // (ld:{ *:[v4i32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 125658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 125661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 125668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 125673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 125678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125685 */     GIR_RootConstrainSelectedInstOperands,
     /* 125686 */     // GIR_Coverage, 7930,
     /* 125686 */     GIR_EraseRootFromParent_Done,
     /* 125687 */   // Label 1800: @125687
     /* 125687 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(125744), // Rule ID 7966 //
     /* 125692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 125695 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 125700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 125715 */     // (ld:{ *:[v4f32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 125715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 125718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 125725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 125730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 125735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125742 */     GIR_RootConstrainSelectedInstOperands,
     /* 125743 */     // GIR_Coverage, 7966,
     /* 125743 */     GIR_EraseRootFromParent_Done,
     /* 125744 */   // Label 1801: @125744
     /* 125744 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(125803), // Rule ID 3930 //
     /* 125749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 125752 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 125774 */     // (ld:{ *:[v4i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v4i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 125774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 125777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 125784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 125789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125801 */     GIR_RootConstrainSelectedInstOperands,
     /* 125802 */     // GIR_Coverage, 3930,
     /* 125802 */     GIR_EraseRootFromParent_Done,
     /* 125803 */   // Label 1802: @125803
     /* 125803 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(125862), // Rule ID 3934 //
     /* 125808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 125811 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 125833 */     // (ld:{ *:[v4f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v4f32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 125833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 125836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 125843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 125848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125860 */     GIR_RootConstrainSelectedInstOperands,
     /* 125861 */     // GIR_Coverage, 3934,
     /* 125861 */     GIR_EraseRootFromParent_Done,
     /* 125862 */   // Label 1803: @125862
     /* 125862 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(125916), // Rule ID 3929 //
     /* 125867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 125870 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 125892 */     // (ld:{ *:[v4i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v4i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 125892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 125895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 125902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125914 */     GIR_RootConstrainSelectedInstOperands,
     /* 125915 */     // GIR_Coverage, 3929,
     /* 125915 */     GIR_EraseRootFromParent_Done,
     /* 125916 */   // Label 1804: @125916
     /* 125916 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(125970), // Rule ID 3933 //
     /* 125921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 125924 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 125946 */     // (ld:{ *:[v4f32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v4f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 125946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 125949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 125956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125968 */     GIR_RootConstrainSelectedInstOperands,
     /* 125969 */     // GIR_Coverage, 3933,
     /* 125969 */     GIR_EraseRootFromParent_Done,
     /* 125970 */   // Label 1805: @125970
     /* 125970 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(126025), // Rule ID 3647 //
     /* 125975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 125978 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 125990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 126001 */     // (ld:{ *:[v4i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v4i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 126001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 126004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 126006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 126011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126023 */     GIR_RootConstrainSelectedInstOperands,
     /* 126024 */     // GIR_Coverage, 3647,
     /* 126024 */     GIR_EraseRootFromParent_Done,
     /* 126025 */   // Label 1806: @126025
     /* 126025 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(126080), // Rule ID 3649 //
     /* 126030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 126033 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 126041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 126045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 126056 */     // (ld:{ *:[v4f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v4f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 126056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 126059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 126061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 126066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126078 */     GIR_RootConstrainSelectedInstOperands,
     /* 126079 */     // GIR_Coverage, 3649,
     /* 126079 */     GIR_EraseRootFromParent_Done,
     /* 126080 */   // Label 1807: @126080
     /* 126080 */   GIM_Reject,
     /* 126081 */ // Label 1737: @126081
     /* 126081 */ GIM_Reject,
     /* 126082 */ // Label 888: @126082
     /* 126082 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(127733),
     /* 126087 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126090 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126094 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126098 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(126154), // Rule ID 3306 //
     /* 126103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126114 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126125 */     // (ld:{ *:[v4i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 126128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126152 */     GIR_RootConstrainSelectedInstOperands,
     /* 126153 */     // GIR_Coverage, 3306,
     /* 126153 */     GIR_EraseRootFromParent_Done,
     /* 126154 */   // Label 1809: @126154
     /* 126154 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(126210), // Rule ID 3323 //
     /* 126159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126170 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126181 */     // (ld:{ *:[v4f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 126184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126208 */     GIR_RootConstrainSelectedInstOperands,
     /* 126209 */     // GIR_Coverage, 3323,
     /* 126209 */     GIR_EraseRootFromParent_Done,
     /* 126210 */   // Label 1810: @126210
     /* 126210 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(126262), // Rule ID 3311 //
     /* 126215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126233 */     // (ld:{ *:[v4i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 126236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126260 */     GIR_RootConstrainSelectedInstOperands,
     /* 126261 */     // GIR_Coverage, 3311,
     /* 126261 */     GIR_EraseRootFromParent_Done,
     /* 126262 */   // Label 1811: @126262
     /* 126262 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(126314), // Rule ID 3328 //
     /* 126267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126285 */     // (ld:{ *:[v4f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 126288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126312 */     GIR_RootConstrainSelectedInstOperands,
     /* 126313 */     // GIR_Coverage, 3328,
     /* 126313 */     GIR_EraseRootFromParent_Done,
     /* 126314 */   // Label 1812: @126314
     /* 126314 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(126366), // Rule ID 3317 //
     /* 126319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 126322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126337 */     // (ld:{ *:[v4i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 126340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126364 */     GIR_RootConstrainSelectedInstOperands,
     /* 126365 */     // GIR_Coverage, 3317,
     /* 126365 */     GIR_EraseRootFromParent_Done,
     /* 126366 */   // Label 1813: @126366
     /* 126366 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(126418), // Rule ID 3334 //
     /* 126371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 126374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126389 */     // (ld:{ *:[v4f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 126392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126416 */     GIR_RootConstrainSelectedInstOperands,
     /* 126417 */     // GIR_Coverage, 3334,
     /* 126417 */     GIR_EraseRootFromParent_Done,
     /* 126418 */   // Label 1814: @126418
     /* 126418 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(126469), // Rule ID 3302 //
     /* 126423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 126426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 126445 */     // (ld:{ *:[v4i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 126448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126467 */     GIR_RootConstrainSelectedInstOperands,
     /* 126468 */     // GIR_Coverage, 3302,
     /* 126468 */     GIR_EraseRootFromParent_Done,
     /* 126469 */   // Label 1815: @126469
     /* 126469 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(126520), // Rule ID 3303 //
     /* 126474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 126477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126485 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 126496 */     // (ld:{ *:[v4i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 126499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126518 */     GIR_RootConstrainSelectedInstOperands,
     /* 126519 */     // GIR_Coverage, 3303,
     /* 126519 */     GIR_EraseRootFromParent_Done,
     /* 126520 */   // Label 1816: @126520
     /* 126520 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(126571), // Rule ID 3304 //
     /* 126525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 126528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126547 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 126547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 126550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126569 */     GIR_RootConstrainSelectedInstOperands,
     /* 126570 */     // GIR_Coverage, 3304,
     /* 126570 */     GIR_EraseRootFromParent_Done,
     /* 126571 */   // Label 1817: @126571
     /* 126571 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(126625), // Rule ID 3305 //
     /* 126576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126587 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126598 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 126598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 126601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126623 */     GIR_RootConstrainSelectedInstOperands,
     /* 126624 */     // GIR_Coverage, 3305,
     /* 126624 */     GIR_EraseRootFromParent_Done,
     /* 126625 */   // Label 1818: @126625
     /* 126625 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(126676), // Rule ID 3319 //
     /* 126630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 126633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 126652 */     // (ld:{ *:[v4f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 126655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126674 */     GIR_RootConstrainSelectedInstOperands,
     /* 126675 */     // GIR_Coverage, 3319,
     /* 126675 */     GIR_EraseRootFromParent_Done,
     /* 126676 */   // Label 1819: @126676
     /* 126676 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(126727), // Rule ID 3320 //
     /* 126681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 126684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126692 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 126703 */     // (ld:{ *:[v4f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 126706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126725 */     GIR_RootConstrainSelectedInstOperands,
     /* 126726 */     // GIR_Coverage, 3320,
     /* 126726 */     GIR_EraseRootFromParent_Done,
     /* 126727 */   // Label 1820: @126727
     /* 126727 */   GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(126778), // Rule ID 3321 //
     /* 126732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 126735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126743 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126754 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 126754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 126757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126776 */     GIR_RootConstrainSelectedInstOperands,
     /* 126777 */     // GIR_Coverage, 3321,
     /* 126777 */     GIR_EraseRootFromParent_Done,
     /* 126778 */   // Label 1821: @126778
     /* 126778 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(126832), // Rule ID 3322 //
     /* 126783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126805 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 126805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 126808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126830 */     GIR_RootConstrainSelectedInstOperands,
     /* 126831 */     // GIR_Coverage, 3322,
     /* 126831 */     GIR_EraseRootFromParent_Done,
     /* 126832 */   // Label 1822: @126832
     /* 126832 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(126879), // Rule ID 3308 //
     /* 126837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 126840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 126855 */     // (ld:{ *:[v4i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 126858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126877 */     GIR_RootConstrainSelectedInstOperands,
     /* 126878 */     // GIR_Coverage, 3308,
     /* 126878 */     GIR_EraseRootFromParent_Done,
     /* 126879 */   // Label 1823: @126879
     /* 126879 */   GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(126926), // Rule ID 3309 //
     /* 126884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 126887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126902 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 126902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 126905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126924 */     GIR_RootConstrainSelectedInstOperands,
     /* 126925 */     // GIR_Coverage, 3309,
     /* 126925 */     GIR_EraseRootFromParent_Done,
     /* 126926 */   // Label 1824: @126926
     /* 126926 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(126976), // Rule ID 3310 //
     /* 126931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126949 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 126949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 126952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126974 */     GIR_RootConstrainSelectedInstOperands,
     /* 126975 */     // GIR_Coverage, 3310,
     /* 126975 */     GIR_EraseRootFromParent_Done,
     /* 126976 */   // Label 1825: @126976
     /* 126976 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(127023), // Rule ID 3325 //
     /* 126981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 126984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 126988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 126999 */     // (ld:{ *:[v4f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 127002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127021 */     GIR_RootConstrainSelectedInstOperands,
     /* 127022 */     // GIR_Coverage, 3325,
     /* 127022 */     GIR_EraseRootFromParent_Done,
     /* 127023 */   // Label 1826: @127023
     /* 127023 */   GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(127070), // Rule ID 3326 //
     /* 127028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 127031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127046 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 127046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 127049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127068 */     GIR_RootConstrainSelectedInstOperands,
     /* 127069 */     // GIR_Coverage, 3326,
     /* 127069 */     GIR_EraseRootFromParent_Done,
     /* 127070 */   // Label 1827: @127070
     /* 127070 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(127120), // Rule ID 3327 //
     /* 127075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 127078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127093 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 127096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127118 */     GIR_RootConstrainSelectedInstOperands,
     /* 127119 */     // GIR_Coverage, 3327,
     /* 127119 */     GIR_EraseRootFromParent_Done,
     /* 127120 */   // Label 1828: @127120
     /* 127120 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(127164), // Rule ID 3313 //
     /* 127125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 127140 */     // (ld:{ *:[v4i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 127143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127162 */     GIR_RootConstrainSelectedInstOperands,
     /* 127163 */     // GIR_Coverage, 3313,
     /* 127163 */     GIR_EraseRootFromParent_Done,
     /* 127164 */   // Label 1829: @127164
     /* 127164 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(127211), // Rule ID 3314 //
     /* 127169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 127172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 127187 */     // (ld:{ *:[v4i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 127190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127209 */     GIR_RootConstrainSelectedInstOperands,
     /* 127210 */     // GIR_Coverage, 3314,
     /* 127210 */     GIR_EraseRootFromParent_Done,
     /* 127211 */   // Label 1830: @127211
     /* 127211 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(127258), // Rule ID 3315 //
     /* 127216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 127219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127234 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 127234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 127237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127256 */     GIR_RootConstrainSelectedInstOperands,
     /* 127257 */     // GIR_Coverage, 3315,
     /* 127257 */     GIR_EraseRootFromParent_Done,
     /* 127258 */   // Label 1831: @127258
     /* 127258 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(127308), // Rule ID 3316 //
     /* 127263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 127266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127281 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 127284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127306 */     GIR_RootConstrainSelectedInstOperands,
     /* 127307 */     // GIR_Coverage, 3316,
     /* 127307 */     GIR_EraseRootFromParent_Done,
     /* 127308 */   // Label 1832: @127308
     /* 127308 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(127352), // Rule ID 3330 //
     /* 127313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 127328 */     // (ld:{ *:[v4f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 127331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127350 */     GIR_RootConstrainSelectedInstOperands,
     /* 127351 */     // GIR_Coverage, 3330,
     /* 127351 */     GIR_EraseRootFromParent_Done,
     /* 127352 */   // Label 1833: @127352
     /* 127352 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(127399), // Rule ID 3331 //
     /* 127357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 127360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 127375 */     // (ld:{ *:[v4f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 127378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127397 */     GIR_RootConstrainSelectedInstOperands,
     /* 127398 */     // GIR_Coverage, 3331,
     /* 127398 */     GIR_EraseRootFromParent_Done,
     /* 127399 */   // Label 1834: @127399
     /* 127399 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(127446), // Rule ID 3332 //
     /* 127404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 127407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127422 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 127422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 127425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127444 */     GIR_RootConstrainSelectedInstOperands,
     /* 127445 */     // GIR_Coverage, 3332,
     /* 127445 */     GIR_EraseRootFromParent_Done,
     /* 127446 */   // Label 1835: @127446
     /* 127446 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(127496), // Rule ID 3333 //
     /* 127451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 127454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127469 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 127472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127494 */     GIR_RootConstrainSelectedInstOperands,
     /* 127495 */     // GIR_Coverage, 3333,
     /* 127495 */     GIR_EraseRootFromParent_Done,
     /* 127496 */   // Label 1836: @127496
     /* 127496 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(127539), // Rule ID 3307 //
     /* 127501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 127504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127508 */     // MIs[0] sbase
     /* 127508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 127520 */     // (ld:{ *:[v4i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 127523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127525 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 127527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127537 */     GIR_RootConstrainSelectedInstOperands,
     /* 127538 */     // GIR_Coverage, 3307,
     /* 127538 */     GIR_EraseRootFromParent_Done,
     /* 127539 */   // Label 1837: @127539
     /* 127539 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(127582), // Rule ID 3324 //
     /* 127544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 127547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127551 */     // MIs[0] sbase
     /* 127551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 127563 */     // (ld:{ *:[v4f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 127566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127568 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 127570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127580 */     GIR_RootConstrainSelectedInstOperands,
     /* 127581 */     // GIR_Coverage, 3324,
     /* 127581 */     GIR_EraseRootFromParent_Done,
     /* 127582 */   // Label 1838: @127582
     /* 127582 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(127621), // Rule ID 3312 //
     /* 127587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 127590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127594 */     // MIs[0] sbase
     /* 127594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127602 */     // (ld:{ *:[v4i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 127605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127607 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 127609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127619 */     GIR_RootConstrainSelectedInstOperands,
     /* 127620 */     // GIR_Coverage, 3312,
     /* 127620 */     GIR_EraseRootFromParent_Done,
     /* 127621 */   // Label 1839: @127621
     /* 127621 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(127660), // Rule ID 3329 //
     /* 127626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 127629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127633 */     // MIs[0] sbase
     /* 127633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127641 */     // (ld:{ *:[v4f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 127644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127646 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 127648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127658 */     GIR_RootConstrainSelectedInstOperands,
     /* 127659 */     // GIR_Coverage, 3329,
     /* 127659 */     GIR_EraseRootFromParent_Done,
     /* 127660 */   // Label 1840: @127660
     /* 127660 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(127696), // Rule ID 3318 //
     /* 127665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127669 */     // MIs[0] sbase
     /* 127669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127677 */     // (ld:{ *:[v4i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 127680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127682 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 127684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127694 */     GIR_RootConstrainSelectedInstOperands,
     /* 127695 */     // GIR_Coverage, 3318,
     /* 127695 */     GIR_EraseRootFromParent_Done,
     /* 127696 */   // Label 1841: @127696
     /* 127696 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(127732), // Rule ID 3335 //
     /* 127701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 127705 */     // MIs[0] sbase
     /* 127705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127713 */     // (ld:{ *:[v4f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 127716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127718 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 127720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127730 */     GIR_RootConstrainSelectedInstOperands,
     /* 127731 */     // GIR_Coverage, 3335,
     /* 127731 */     GIR_EraseRootFromParent_Done,
     /* 127732 */   // Label 1842: @127732
     /* 127732 */   GIM_Reject,
     /* 127733 */ // Label 1808: @127733
     /* 127733 */ GIM_Reject,
     /* 127734 */ // Label 889: @127734
     /* 127734 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(131531),
     /* 127739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127742 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(127806), // Rule ID 3238 //
     /* 127747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 127750 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127762 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127766 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 127770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 127777 */     // (ld:{ *:[v8i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 127780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 127797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127804 */     GIR_RootConstrainSelectedInstOperands,
     /* 127805 */     // GIR_Coverage, 3238,
     /* 127805 */     GIR_EraseRootFromParent_Done,
     /* 127806 */   // Label 1844: @127806
     /* 127806 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(127870), // Rule ID 3255 //
     /* 127811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 127814 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127826 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127830 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 127834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 127841 */     // (ld:{ *:[v8f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 127844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 127861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127868 */     GIR_RootConstrainSelectedInstOperands,
     /* 127869 */     // GIR_Coverage, 3255,
     /* 127869 */     GIR_EraseRootFromParent_Done,
     /* 127870 */   // Label 1845: @127870
     /* 127870 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(127930), // Rule ID 3243 //
     /* 127875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 127878 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 127901 */     // (ld:{ *:[v8i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 127904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 127921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127928 */     GIR_RootConstrainSelectedInstOperands,
     /* 127929 */     // GIR_Coverage, 3243,
     /* 127929 */     GIR_EraseRootFromParent_Done,
     /* 127930 */   // Label 1846: @127930
     /* 127930 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(127990), // Rule ID 3260 //
     /* 127935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 127938 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 127961 */     // (ld:{ *:[v8f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 127964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 127981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127988 */     GIR_RootConstrainSelectedInstOperands,
     /* 127989 */     // GIR_Coverage, 3260,
     /* 127989 */     GIR_EraseRootFromParent_Done,
     /* 127990 */   // Label 1847: @127990
     /* 127990 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(128050), // Rule ID 3249 //
     /* 127995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 127998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 128021 */     // (ld:{ *:[v8i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 128024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128048 */     GIR_RootConstrainSelectedInstOperands,
     /* 128049 */     // GIR_Coverage, 3249,
     /* 128049 */     GIR_EraseRootFromParent_Done,
     /* 128050 */   // Label 1848: @128050
     /* 128050 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(128110), // Rule ID 3266 //
     /* 128055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 128058 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128070 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 128081 */     // (ld:{ *:[v8f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 128084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128108 */     GIR_RootConstrainSelectedInstOperands,
     /* 128109 */     // GIR_Coverage, 3266,
     /* 128109 */     GIR_EraseRootFromParent_Done,
     /* 128110 */   // Label 1849: @128110
     /* 128110 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(128169), // Rule ID 3234 //
     /* 128115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 128118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 128145 */     // (ld:{ *:[v8i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 128148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128167 */     GIR_RootConstrainSelectedInstOperands,
     /* 128168 */     // GIR_Coverage, 3234,
     /* 128168 */     GIR_EraseRootFromParent_Done,
     /* 128169 */   // Label 1850: @128169
     /* 128169 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(128228), // Rule ID 3235 //
     /* 128174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 128177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 128204 */     // (ld:{ *:[v8i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 128207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128226 */     GIR_RootConstrainSelectedInstOperands,
     /* 128227 */     // GIR_Coverage, 3235,
     /* 128227 */     GIR_EraseRootFromParent_Done,
     /* 128228 */   // Label 1851: @128228
     /* 128228 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(128287), // Rule ID 3236 //
     /* 128233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 128236 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128248 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128252 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128263 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 128263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 128266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128285 */     GIR_RootConstrainSelectedInstOperands,
     /* 128286 */     // GIR_Coverage, 3236,
     /* 128286 */     GIR_EraseRootFromParent_Done,
     /* 128287 */   // Label 1852: @128287
     /* 128287 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(128349), // Rule ID 3237 //
     /* 128292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 128295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128307 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128311 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128322 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 128322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 128325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128347 */     GIR_RootConstrainSelectedInstOperands,
     /* 128348 */     // GIR_Coverage, 3237,
     /* 128348 */     GIR_EraseRootFromParent_Done,
     /* 128349 */   // Label 1853: @128349
     /* 128349 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(128408), // Rule ID 3251 //
     /* 128354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 128357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128369 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 128384 */     // (ld:{ *:[v8f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 128387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128406 */     GIR_RootConstrainSelectedInstOperands,
     /* 128407 */     // GIR_Coverage, 3251,
     /* 128407 */     GIR_EraseRootFromParent_Done,
     /* 128408 */   // Label 1854: @128408
     /* 128408 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(128467), // Rule ID 3252 //
     /* 128413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 128416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128432 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 128443 */     // (ld:{ *:[v8f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 128446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128465 */     GIR_RootConstrainSelectedInstOperands,
     /* 128466 */     // GIR_Coverage, 3252,
     /* 128466 */     GIR_EraseRootFromParent_Done,
     /* 128467 */   // Label 1855: @128467
     /* 128467 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(128526), // Rule ID 3253 //
     /* 128472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 128475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128487 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128502 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 128502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 128505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128524 */     GIR_RootConstrainSelectedInstOperands,
     /* 128525 */     // GIR_Coverage, 3253,
     /* 128525 */     GIR_EraseRootFromParent_Done,
     /* 128526 */   // Label 1856: @128526
     /* 128526 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(128588), // Rule ID 3254 //
     /* 128531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 128534 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128550 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128561 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 128561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 128564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128586 */     GIR_RootConstrainSelectedInstOperands,
     /* 128587 */     // GIR_Coverage, 3254,
     /* 128587 */     GIR_EraseRootFromParent_Done,
     /* 128588 */   // Label 1857: @128588
     /* 128588 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(128643), // Rule ID 3240 //
     /* 128593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 128596 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128608 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 128619 */     // (ld:{ *:[v8i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 128622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128641 */     GIR_RootConstrainSelectedInstOperands,
     /* 128642 */     // GIR_Coverage, 3240,
     /* 128642 */     GIR_EraseRootFromParent_Done,
     /* 128643 */   // Label 1858: @128643
     /* 128643 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(128698), // Rule ID 3241 //
     /* 128648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 128651 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128663 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128674 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 128674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 128677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128696 */     GIR_RootConstrainSelectedInstOperands,
     /* 128697 */     // GIR_Coverage, 3241,
     /* 128697 */     GIR_EraseRootFromParent_Done,
     /* 128698 */   // Label 1859: @128698
     /* 128698 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(128756), // Rule ID 3242 //
     /* 128703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 128706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128718 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128729 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 128729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 128732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128754 */     GIR_RootConstrainSelectedInstOperands,
     /* 128755 */     // GIR_Coverage, 3242,
     /* 128755 */     GIR_EraseRootFromParent_Done,
     /* 128756 */   // Label 1860: @128756
     /* 128756 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(128811), // Rule ID 3257 //
     /* 128761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 128764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 128787 */     // (ld:{ *:[v8f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 128790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128809 */     GIR_RootConstrainSelectedInstOperands,
     /* 128810 */     // GIR_Coverage, 3257,
     /* 128810 */     GIR_EraseRootFromParent_Done,
     /* 128811 */   // Label 1861: @128811
     /* 128811 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(128866), // Rule ID 3258 //
     /* 128816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 128819 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128831 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128842 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 128842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 128845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128864 */     GIR_RootConstrainSelectedInstOperands,
     /* 128865 */     // GIR_Coverage, 3258,
     /* 128865 */     GIR_EraseRootFromParent_Done,
     /* 128866 */   // Label 1862: @128866
     /* 128866 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(128924), // Rule ID 3259 //
     /* 128871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 128874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128886 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 128897 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 128897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 128900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 128907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128922 */     GIR_RootConstrainSelectedInstOperands,
     /* 128923 */     // GIR_Coverage, 3259,
     /* 128923 */     GIR_EraseRootFromParent_Done,
     /* 128924 */   // Label 1863: @128924
     /* 128924 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(128984), // Rule ID 8044 //
     /* 128929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 128932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128936 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 128941 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 128945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 128960 */     // (AMDGPUld_glue:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 128960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 128963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 128965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 128970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128982 */     GIR_RootConstrainSelectedInstOperands,
     /* 128983 */     // GIR_Coverage, 8044,
     /* 128983 */     GIR_EraseRootFromParent_Done,
     /* 128984 */   // Label 1864: @128984
     /* 128984 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(129044), // Rule ID 8048 //
     /* 128989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 128992 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128996 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129001 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 129005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129020 */     // (AMDGPUld_glue:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 129023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129042 */     GIR_RootConstrainSelectedInstOperands,
     /* 129043 */     // GIR_Coverage, 8048,
     /* 129043 */     GIR_EraseRootFromParent_Done,
     /* 129044 */   // Label 1865: @129044
     /* 129044 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(129109), // Rule ID 8112 //
     /* 129049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 129052 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129056 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129061 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 129078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129085 */     // (AMDGPUld_glue:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 129088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129107 */     GIR_RootConstrainSelectedInstOperands,
     /* 129108 */     // GIR_Coverage, 8112,
     /* 129108 */     GIR_EraseRootFromParent_Done,
     /* 129109 */   // Label 1866: @129109
     /* 129109 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(129174), // Rule ID 8116 //
     /* 129114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 129117 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129121 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129126 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 129143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129150 */     // (AMDGPUld_glue:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 129153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129172 */     GIR_RootConstrainSelectedInstOperands,
     /* 129173 */     // GIR_Coverage, 8116,
     /* 129173 */     GIR_EraseRootFromParent_Done,
     /* 129174 */   // Label 1867: @129174
     /* 129174 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(129226), // Rule ID 3245 //
     /* 129179 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 129202 */     // (ld:{ *:[v8i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 129202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 129205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129224 */     GIR_RootConstrainSelectedInstOperands,
     /* 129225 */     // GIR_Coverage, 3245,
     /* 129225 */     GIR_EraseRootFromParent_Done,
     /* 129226 */   // Label 1868: @129226
     /* 129226 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(129281), // Rule ID 3246 //
     /* 129231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 129234 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 129257 */     // (ld:{ *:[v8i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 129257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 129260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129279 */     GIR_RootConstrainSelectedInstOperands,
     /* 129280 */     // GIR_Coverage, 3246,
     /* 129280 */     GIR_EraseRootFromParent_Done,
     /* 129281 */   // Label 1869: @129281
     /* 129281 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(129336), // Rule ID 3247 //
     /* 129286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 129289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 129312 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 129312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 129315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129334 */     GIR_RootConstrainSelectedInstOperands,
     /* 129335 */     // GIR_Coverage, 3247,
     /* 129335 */     GIR_EraseRootFromParent_Done,
     /* 129336 */   // Label 1870: @129336
     /* 129336 */   GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(129394), // Rule ID 3248 //
     /* 129341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 129344 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 129367 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 129367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 129370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129392 */     GIR_RootConstrainSelectedInstOperands,
     /* 129393 */     // GIR_Coverage, 3248,
     /* 129393 */     GIR_EraseRootFromParent_Done,
     /* 129394 */   // Label 1871: @129394
     /* 129394 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(129446), // Rule ID 3262 //
     /* 129399 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129411 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 129422 */     // (ld:{ *:[v8f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 129422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 129425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129444 */     GIR_RootConstrainSelectedInstOperands,
     /* 129445 */     // GIR_Coverage, 3262,
     /* 129445 */     GIR_EraseRootFromParent_Done,
     /* 129446 */   // Label 1872: @129446
     /* 129446 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(129501), // Rule ID 3263 //
     /* 129451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 129454 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129466 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 129477 */     // (ld:{ *:[v8f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 129477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 129480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129499 */     GIR_RootConstrainSelectedInstOperands,
     /* 129500 */     // GIR_Coverage, 3263,
     /* 129500 */     GIR_EraseRootFromParent_Done,
     /* 129501 */   // Label 1873: @129501
     /* 129501 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(129556), // Rule ID 3264 //
     /* 129506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 129509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 129532 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 129532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 129535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129554 */     GIR_RootConstrainSelectedInstOperands,
     /* 129555 */     // GIR_Coverage, 3264,
     /* 129555 */     GIR_EraseRootFromParent_Done,
     /* 129556 */   // Label 1874: @129556
     /* 129556 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(129614), // Rule ID 3265 //
     /* 129561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 129564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 129587 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 129587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 129590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129612 */     GIR_RootConstrainSelectedInstOperands,
     /* 129613 */     // GIR_Coverage, 3265,
     /* 129613 */     GIR_EraseRootFromParent_Done,
     /* 129614 */   // Label 1875: @129614
     /* 129614 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(129670), // Rule ID 8045 //
     /* 129619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 129622 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129627 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 129631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129646 */     // (ld:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 129649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129668 */     GIR_RootConstrainSelectedInstOperands,
     /* 129669 */     // GIR_Coverage, 8045,
     /* 129669 */     GIR_EraseRootFromParent_Done,
     /* 129670 */   // Label 1876: @129670
     /* 129670 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(129726), // Rule ID 8049 //
     /* 129675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 129678 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129683 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 129687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129702 */     // (ld:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 129705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129724 */     GIR_RootConstrainSelectedInstOperands,
     /* 129725 */     // GIR_Coverage, 8049,
     /* 129725 */     GIR_EraseRootFromParent_Done,
     /* 129726 */   // Label 1877: @129726
     /* 129726 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(129787), // Rule ID 8113 //
     /* 129731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 129734 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129739 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129752 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 129756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129763 */     // (ld:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 129766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129785 */     GIR_RootConstrainSelectedInstOperands,
     /* 129786 */     // GIR_Coverage, 8113,
     /* 129786 */     GIR_EraseRootFromParent_Done,
     /* 129787 */   // Label 1878: @129787
     /* 129787 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(129848), // Rule ID 8117 //
     /* 129792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 129795 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129800 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 129817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 129824 */     // (ld:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 129824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 129827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129846 */     GIR_RootConstrainSelectedInstOperands,
     /* 129847 */     // GIR_Coverage, 8117,
     /* 129847 */     GIR_EraseRootFromParent_Done,
     /* 129848 */   // Label 1879: @129848
     /* 129848 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(129899), // Rule ID 3239 //
     /* 129853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 129856 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129864 */     // MIs[0] sbase
     /* 129864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 129872 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 129880 */     // (ld:{ *:[v8i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 129880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 129883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129885 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 129887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129897 */     GIR_RootConstrainSelectedInstOperands,
     /* 129898 */     // GIR_Coverage, 3239,
     /* 129898 */     GIR_EraseRootFromParent_Done,
     /* 129899 */   // Label 1880: @129899
     /* 129899 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(129950), // Rule ID 3256 //
     /* 129904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 129907 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129915 */     // MIs[0] sbase
     /* 129915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 129923 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129927 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 129931 */     // (ld:{ *:[v8f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 129931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 129934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129936 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 129938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129948 */     GIR_RootConstrainSelectedInstOperands,
     /* 129949 */     // GIR_Coverage, 3256,
     /* 129949 */     GIR_EraseRootFromParent_Done,
     /* 129950 */   // Label 1881: @129950
     /* 129950 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(129997), // Rule ID 3244 //
     /* 129955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 129958 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 129966 */     // MIs[0] sbase
     /* 129966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 129974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129978 */     // (ld:{ *:[v8i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 129978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 129981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129983 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 129985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129995 */     GIR_RootConstrainSelectedInstOperands,
     /* 129996 */     // GIR_Coverage, 3244,
     /* 129996 */     GIR_EraseRootFromParent_Done,
     /* 129997 */   // Label 1882: @129997
     /* 129997 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(130044), // Rule ID 3261 //
     /* 130002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 130005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 130013 */     // MIs[0] sbase
     /* 130013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 130021 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 130025 */     // (ld:{ *:[v8f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 130025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 130028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130030 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 130032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130042 */     GIR_RootConstrainSelectedInstOperands,
     /* 130043 */     // GIR_Coverage, 3261,
     /* 130043 */     GIR_EraseRootFromParent_Done,
     /* 130044 */   // Label 1883: @130044
     /* 130044 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(130088), // Rule ID 3250 //
     /* 130049 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 130057 */     // MIs[0] sbase
     /* 130057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 130065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 130069 */     // (ld:{ *:[v8i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 130069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 130072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130074 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 130076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130086 */     GIR_RootConstrainSelectedInstOperands,
     /* 130087 */     // GIR_Coverage, 3250,
     /* 130087 */     GIR_EraseRootFromParent_Done,
     /* 130088 */   // Label 1884: @130088
     /* 130088 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(130132), // Rule ID 3267 //
     /* 130093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 130101 */     // MIs[0] sbase
     /* 130101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 130109 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 130113 */     // (ld:{ *:[v8f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 130113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 130116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130118 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 130120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130130 */     GIR_RootConstrainSelectedInstOperands,
     /* 130131 */     // GIR_Coverage, 3267,
     /* 130131 */     GIR_EraseRootFromParent_Done,
     /* 130132 */   // Label 1885: @130132
     /* 130132 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(130189), // Rule ID 4374 //
     /* 130137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 130140 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 130145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 130160 */     // (ld:{ *:[v8i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v8i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 130163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 130170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 130175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 130180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130187 */     GIR_RootConstrainSelectedInstOperands,
     /* 130188 */     // GIR_Coverage, 4374,
     /* 130188 */     GIR_EraseRootFromParent_Done,
     /* 130189 */   // Label 1886: @130189
     /* 130189 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(130246), // Rule ID 4380 //
     /* 130194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 130197 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 130202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 130217 */     // (ld:{ *:[v8f16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v8f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 130220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 130227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 130232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 130237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130244 */     GIR_RootConstrainSelectedInstOperands,
     /* 130245 */     // GIR_Coverage, 4380,
     /* 130245 */     GIR_EraseRootFromParent_Done,
     /* 130246 */   // Label 1887: @130246
     /* 130246 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(130298), // Rule ID 4373 //
     /* 130251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 130254 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 130259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 130274 */     // (ld:{ *:[v8i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v8i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 130274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 130277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 130284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130296 */     GIR_RootConstrainSelectedInstOperands,
     /* 130297 */     // GIR_Coverage, 4373,
     /* 130297 */     GIR_EraseRootFromParent_Done,
     /* 130298 */   // Label 1888: @130298
     /* 130298 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(130350), // Rule ID 4379 //
     /* 130303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 130306 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 130311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 130326 */     // (ld:{ *:[v8f16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v8f16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 130326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 130329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 130336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130348 */     GIR_RootConstrainSelectedInstOperands,
     /* 130349 */     // GIR_Coverage, 4379,
     /* 130349 */     GIR_EraseRootFromParent_Done,
     /* 130350 */   // Label 1889: @130350
     /* 130350 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(130402), // Rule ID 4372 //
     /* 130355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 130358 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 130363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 130378 */     // (ld:{ *:[v8i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v8i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 130378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 130381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 130388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130400 */     GIR_RootConstrainSelectedInstOperands,
     /* 130401 */     // GIR_Coverage, 4372,
     /* 130401 */     GIR_EraseRootFromParent_Done,
     /* 130402 */   // Label 1890: @130402
     /* 130402 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(130454), // Rule ID 4378 //
     /* 130407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 130410 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 130415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 130430 */     // (ld:{ *:[v8f16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v8f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 130430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 130433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 130440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130452 */     GIR_RootConstrainSelectedInstOperands,
     /* 130453 */     // GIR_Coverage, 4378,
     /* 130453 */     GIR_EraseRootFromParent_Done,
     /* 130454 */   // Label 1891: @130454
     /* 130454 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(130521), // Rule ID 4587 //
     /* 130459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 130462 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 130469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 130484 */     // (ld:{ *:[v8i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v8i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 130484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 130487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 130489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 130494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 130499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 130504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 130509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130519 */     GIR_RootConstrainSelectedInstOperands,
     /* 130520 */     // GIR_Coverage, 4587,
     /* 130520 */     GIR_EraseRootFromParent_Done,
     /* 130521 */   // Label 1892: @130521
     /* 130521 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(130585), // Rule ID 4589 //
     /* 130526 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 130533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 130548 */     // (ld:{ *:[v8i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v8i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 130548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 130551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 130553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 130558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 130563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 130568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 130573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130583 */     GIR_RootConstrainSelectedInstOperands,
     /* 130584 */     // GIR_Coverage, 4589,
     /* 130584 */     GIR_EraseRootFromParent_Done,
     /* 130585 */   // Label 1893: @130585
     /* 130585 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(130652), // Rule ID 4591 //
     /* 130590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 130593 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 130600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 130615 */     // (ld:{ *:[v8f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v8f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 130615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 130618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 130620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 130625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 130630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 130635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 130640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130650 */     GIR_RootConstrainSelectedInstOperands,
     /* 130651 */     // GIR_Coverage, 4591,
     /* 130651 */     GIR_EraseRootFromParent_Done,
     /* 130652 */   // Label 1894: @130652
     /* 130652 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(130716), // Rule ID 4593 //
     /* 130657 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 130664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 130679 */     // (ld:{ *:[v8f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v8f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 130679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 130682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 130684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 130689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 130694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 130699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 130704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130714 */     GIR_RootConstrainSelectedInstOperands,
     /* 130715 */     // GIR_Coverage, 4593,
     /* 130715 */     GIR_EraseRootFromParent_Done,
     /* 130716 */   // Label 1895: @130716
     /* 130716 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(130777), // Rule ID 7976 //
     /* 130721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 130724 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130728 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 130733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 130748 */     // (AMDGPUld_glue:{ *:[v8i16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 130748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 130751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 130758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 130763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 130768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130775 */     GIR_RootConstrainSelectedInstOperands,
     /* 130776 */     // GIR_Coverage, 7976,
     /* 130776 */     GIR_EraseRootFromParent_Done,
     /* 130777 */   // Label 1896: @130777
     /* 130777 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(130838), // Rule ID 7980 //
     /* 130782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 130785 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130789 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 130794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 130809 */     // (AMDGPUld_glue:{ *:[v8f16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 130809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 130812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 130814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 130819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 130824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 130829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130836 */     GIR_RootConstrainSelectedInstOperands,
     /* 130837 */     // GIR_Coverage, 7980,
     /* 130837 */     GIR_EraseRootFromParent_Done,
     /* 130838 */   // Label 1897: @130838
     /* 130838 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(130900), // Rule ID 4586 //
     /* 130843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 130846 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 130853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 130868 */     // (ld:{ *:[v8i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 130868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 130871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 130873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 130878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 130888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130898 */     GIR_RootConstrainSelectedInstOperands,
     /* 130899 */     // GIR_Coverage, 4586,
     /* 130899 */     GIR_EraseRootFromParent_Done,
     /* 130900 */   // Label 1898: @130900
     /* 130900 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(130959), // Rule ID 4588 //
     /* 130905 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 130912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 130927 */     // (ld:{ *:[v8i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 130927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 130930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 130932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 130937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 130947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130957 */     GIR_RootConstrainSelectedInstOperands,
     /* 130958 */     // GIR_Coverage, 4588,
     /* 130958 */     GIR_EraseRootFromParent_Done,
     /* 130959 */   // Label 1899: @130959
     /* 130959 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(131021), // Rule ID 4590 //
     /* 130964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 130967 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 130974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 130978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 130989 */     // (ld:{ *:[v8f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 130989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 130992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 130994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 130999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131019 */     GIR_RootConstrainSelectedInstOperands,
     /* 131020 */     // GIR_Coverage, 4590,
     /* 131020 */     GIR_EraseRootFromParent_Done,
     /* 131021 */   // Label 1900: @131021
     /* 131021 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(131080), // Rule ID 4592 //
     /* 131026 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 131048 */     // (ld:{ *:[v8f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 131048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 131051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 131053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 131058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131078 */     GIR_RootConstrainSelectedInstOperands,
     /* 131079 */     // GIR_Coverage, 4592,
     /* 131079 */     GIR_EraseRootFromParent_Done,
     /* 131080 */   // Label 1901: @131080
     /* 131080 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(131137), // Rule ID 7978 //
     /* 131085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 131088 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 131093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 131108 */     // (ld:{ *:[v8i16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 131108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 131111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 131118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 131123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 131128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131135 */     GIR_RootConstrainSelectedInstOperands,
     /* 131136 */     // GIR_Coverage, 7978,
     /* 131136 */     GIR_EraseRootFromParent_Done,
     /* 131137 */   // Label 1902: @131137
     /* 131137 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(131194), // Rule ID 7982 //
     /* 131142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 131145 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 131150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 131165 */     // (ld:{ *:[v8f16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 131165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 131168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 131175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 131180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 131185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131192 */     GIR_RootConstrainSelectedInstOperands,
     /* 131193 */     // GIR_Coverage, 7982,
     /* 131193 */     GIR_EraseRootFromParent_Done,
     /* 131194 */   // Label 1903: @131194
     /* 131194 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(131253), // Rule ID 3946 //
     /* 131199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 131202 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 131224 */     // (ld:{ *:[v8i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v8i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 131227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 131234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 131239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131251 */     GIR_RootConstrainSelectedInstOperands,
     /* 131252 */     // GIR_Coverage, 3946,
     /* 131252 */     GIR_EraseRootFromParent_Done,
     /* 131253 */   // Label 1904: @131253
     /* 131253 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(131312), // Rule ID 3950 //
     /* 131258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 131261 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 131283 */     // (ld:{ *:[v8f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v8f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 131286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 131293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 131298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131310 */     GIR_RootConstrainSelectedInstOperands,
     /* 131311 */     // GIR_Coverage, 3950,
     /* 131311 */     GIR_EraseRootFromParent_Done,
     /* 131312 */   // Label 1905: @131312
     /* 131312 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(131366), // Rule ID 3945 //
     /* 131317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 131320 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 131342 */     // (ld:{ *:[v8i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v8i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 131342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 131345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 131352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131364 */     GIR_RootConstrainSelectedInstOperands,
     /* 131365 */     // GIR_Coverage, 3945,
     /* 131365 */     GIR_EraseRootFromParent_Done,
     /* 131366 */   // Label 1906: @131366
     /* 131366 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(131420), // Rule ID 3949 //
     /* 131371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 131374 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 131396 */     // (ld:{ *:[v8f16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v8f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 131396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 131399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 131406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131418 */     GIR_RootConstrainSelectedInstOperands,
     /* 131419 */     // GIR_Coverage, 3949,
     /* 131419 */     GIR_EraseRootFromParent_Done,
     /* 131420 */   // Label 1907: @131420
     /* 131420 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(131475), // Rule ID 3655 //
     /* 131425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 131428 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 131451 */     // (ld:{ *:[v8i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v8i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 131451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 131454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 131461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131473 */     GIR_RootConstrainSelectedInstOperands,
     /* 131474 */     // GIR_Coverage, 3655,
     /* 131474 */     GIR_EraseRootFromParent_Done,
     /* 131475 */   // Label 1908: @131475
     /* 131475 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(131530), // Rule ID 3657 //
     /* 131480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 131483 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 131491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 131495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 131506 */     // (ld:{ *:[v8f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v8f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 131506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 131509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 131511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 131516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131528 */     GIR_RootConstrainSelectedInstOperands,
     /* 131529 */     // GIR_Coverage, 3657,
     /* 131529 */     GIR_EraseRootFromParent_Done,
     /* 131530 */   // Label 1909: @131530
     /* 131530 */   GIM_Reject,
     /* 131531 */ // Label 1843: @131531
     /* 131531 */ GIM_Reject,
     /* 131532 */ // Label 890: @131532
     /* 131532 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(133183),
     /* 131537 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131540 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131544 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 131548 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(131604), // Rule ID 3272 //
     /* 131553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 131556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 131568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131575 */     // (ld:{ *:[v8i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 131578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131602 */     GIR_RootConstrainSelectedInstOperands,
     /* 131603 */     // GIR_Coverage, 3272,
     /* 131603 */     GIR_EraseRootFromParent_Done,
     /* 131604 */   // Label 1911: @131604
     /* 131604 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(131660), // Rule ID 3289 //
     /* 131609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 131612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131620 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 131624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131631 */     // (ld:{ *:[v8f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 131634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131658 */     GIR_RootConstrainSelectedInstOperands,
     /* 131659 */     // GIR_Coverage, 3289,
     /* 131659 */     GIR_EraseRootFromParent_Done,
     /* 131660 */   // Label 1912: @131660
     /* 131660 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(131712), // Rule ID 3277 //
     /* 131665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 131668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131683 */     // (ld:{ *:[v8i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 131686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131710 */     GIR_RootConstrainSelectedInstOperands,
     /* 131711 */     // GIR_Coverage, 3277,
     /* 131711 */     GIR_EraseRootFromParent_Done,
     /* 131712 */   // Label 1913: @131712
     /* 131712 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(131764), // Rule ID 3294 //
     /* 131717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 131720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131735 */     // (ld:{ *:[v8f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 131738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131762 */     GIR_RootConstrainSelectedInstOperands,
     /* 131763 */     // GIR_Coverage, 3294,
     /* 131763 */     GIR_EraseRootFromParent_Done,
     /* 131764 */   // Label 1914: @131764
     /* 131764 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(131816), // Rule ID 3283 //
     /* 131769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 131772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131787 */     // (ld:{ *:[v8i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 131790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131814 */     GIR_RootConstrainSelectedInstOperands,
     /* 131815 */     // GIR_Coverage, 3283,
     /* 131815 */     GIR_EraseRootFromParent_Done,
     /* 131816 */   // Label 1915: @131816
     /* 131816 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(131868), // Rule ID 3300 //
     /* 131821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 131824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131839 */     // (ld:{ *:[v8f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 131842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131866 */     GIR_RootConstrainSelectedInstOperands,
     /* 131867 */     // GIR_Coverage, 3300,
     /* 131867 */     GIR_EraseRootFromParent_Done,
     /* 131868 */   // Label 1916: @131868
     /* 131868 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(131919), // Rule ID 3268 //
     /* 131873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 131876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131884 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 131888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 131895 */     // (ld:{ *:[v8i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 131898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131917 */     GIR_RootConstrainSelectedInstOperands,
     /* 131918 */     // GIR_Coverage, 3268,
     /* 131918 */     GIR_EraseRootFromParent_Done,
     /* 131919 */   // Label 1917: @131919
     /* 131919 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(131970), // Rule ID 3269 //
     /* 131924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 131927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131935 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 131939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 131946 */     // (ld:{ *:[v8i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 131949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131968 */     GIR_RootConstrainSelectedInstOperands,
     /* 131969 */     // GIR_Coverage, 3269,
     /* 131969 */     GIR_EraseRootFromParent_Done,
     /* 131970 */   // Label 1918: @131970
     /* 131970 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(132021), // Rule ID 3270 //
     /* 131975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 131978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131986 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 131990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 131997 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 131997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 132000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132019 */     GIR_RootConstrainSelectedInstOperands,
     /* 132020 */     // GIR_Coverage, 3270,
     /* 132020 */     GIR_EraseRootFromParent_Done,
     /* 132021 */   // Label 1919: @132021
     /* 132021 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(132075), // Rule ID 3271 //
     /* 132026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 132029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132037 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132048 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 132051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132073 */     GIR_RootConstrainSelectedInstOperands,
     /* 132074 */     // GIR_Coverage, 3271,
     /* 132074 */     GIR_EraseRootFromParent_Done,
     /* 132075 */   // Label 1920: @132075
     /* 132075 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(132126), // Rule ID 3285 //
     /* 132080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 132083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132102 */     // (ld:{ *:[v8f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 132105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132124 */     GIR_RootConstrainSelectedInstOperands,
     /* 132125 */     // GIR_Coverage, 3285,
     /* 132125 */     GIR_EraseRootFromParent_Done,
     /* 132126 */   // Label 1921: @132126
     /* 132126 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(132177), // Rule ID 3286 //
     /* 132131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 132134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132142 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 132153 */     // (ld:{ *:[v8f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 132156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132175 */     GIR_RootConstrainSelectedInstOperands,
     /* 132176 */     // GIR_Coverage, 3286,
     /* 132176 */     GIR_EraseRootFromParent_Done,
     /* 132177 */   // Label 1922: @132177
     /* 132177 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(132228), // Rule ID 3287 //
     /* 132182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 132185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132204 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 132207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132226 */     GIR_RootConstrainSelectedInstOperands,
     /* 132227 */     // GIR_Coverage, 3287,
     /* 132227 */     GIR_EraseRootFromParent_Done,
     /* 132228 */   // Label 1923: @132228
     /* 132228 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(132282), // Rule ID 3288 //
     /* 132233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 132236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132255 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 132258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132280 */     GIR_RootConstrainSelectedInstOperands,
     /* 132281 */     // GIR_Coverage, 3288,
     /* 132281 */     GIR_EraseRootFromParent_Done,
     /* 132282 */   // Label 1924: @132282
     /* 132282 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(132329), // Rule ID 3274 //
     /* 132287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 132290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132305 */     // (ld:{ *:[v8i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 132308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132327 */     GIR_RootConstrainSelectedInstOperands,
     /* 132328 */     // GIR_Coverage, 3274,
     /* 132328 */     GIR_EraseRootFromParent_Done,
     /* 132329 */   // Label 1925: @132329
     /* 132329 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(132376), // Rule ID 3275 //
     /* 132334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 132337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132352 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 132355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132374 */     GIR_RootConstrainSelectedInstOperands,
     /* 132375 */     // GIR_Coverage, 3275,
     /* 132375 */     GIR_EraseRootFromParent_Done,
     /* 132376 */   // Label 1926: @132376
     /* 132376 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(132426), // Rule ID 3276 //
     /* 132381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 132384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132399 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 132402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132424 */     GIR_RootConstrainSelectedInstOperands,
     /* 132425 */     // GIR_Coverage, 3276,
     /* 132425 */     GIR_EraseRootFromParent_Done,
     /* 132426 */   // Label 1927: @132426
     /* 132426 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(132473), // Rule ID 3291 //
     /* 132431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 132434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132449 */     // (ld:{ *:[v8f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 132452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132471 */     GIR_RootConstrainSelectedInstOperands,
     /* 132472 */     // GIR_Coverage, 3291,
     /* 132472 */     GIR_EraseRootFromParent_Done,
     /* 132473 */   // Label 1928: @132473
     /* 132473 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(132520), // Rule ID 3292 //
     /* 132478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 132481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132496 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 132499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132518 */     GIR_RootConstrainSelectedInstOperands,
     /* 132519 */     // GIR_Coverage, 3292,
     /* 132519 */     GIR_EraseRootFromParent_Done,
     /* 132520 */   // Label 1929: @132520
     /* 132520 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(132570), // Rule ID 3293 //
     /* 132525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 132528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132543 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 132546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132568 */     GIR_RootConstrainSelectedInstOperands,
     /* 132569 */     // GIR_Coverage, 3293,
     /* 132569 */     GIR_EraseRootFromParent_Done,
     /* 132570 */   // Label 1930: @132570
     /* 132570 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(132614), // Rule ID 3279 //
     /* 132575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132590 */     // (ld:{ *:[v8i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 132593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132612 */     GIR_RootConstrainSelectedInstOperands,
     /* 132613 */     // GIR_Coverage, 3279,
     /* 132613 */     GIR_EraseRootFromParent_Done,
     /* 132614 */   // Label 1931: @132614
     /* 132614 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(132661), // Rule ID 3280 //
     /* 132619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 132622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 132637 */     // (ld:{ *:[v8i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 132640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132659 */     GIR_RootConstrainSelectedInstOperands,
     /* 132660 */     // GIR_Coverage, 3280,
     /* 132660 */     GIR_EraseRootFromParent_Done,
     /* 132661 */   // Label 1932: @132661
     /* 132661 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(132708), // Rule ID 3281 //
     /* 132666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 132669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132684 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 132687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132706 */     GIR_RootConstrainSelectedInstOperands,
     /* 132707 */     // GIR_Coverage, 3281,
     /* 132707 */     GIR_EraseRootFromParent_Done,
     /* 132708 */   // Label 1933: @132708
     /* 132708 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(132758), // Rule ID 3282 //
     /* 132713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 132716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132731 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 132734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132756 */     GIR_RootConstrainSelectedInstOperands,
     /* 132757 */     // GIR_Coverage, 3282,
     /* 132757 */     GIR_EraseRootFromParent_Done,
     /* 132758 */   // Label 1934: @132758
     /* 132758 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(132802), // Rule ID 3296 //
     /* 132763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132778 */     // (ld:{ *:[v8f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 132781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132800 */     GIR_RootConstrainSelectedInstOperands,
     /* 132801 */     // GIR_Coverage, 3296,
     /* 132801 */     GIR_EraseRootFromParent_Done,
     /* 132802 */   // Label 1935: @132802
     /* 132802 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(132849), // Rule ID 3297 //
     /* 132807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 132810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 132825 */     // (ld:{ *:[v8f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 132828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132847 */     GIR_RootConstrainSelectedInstOperands,
     /* 132848 */     // GIR_Coverage, 3297,
     /* 132848 */     GIR_EraseRootFromParent_Done,
     /* 132849 */   // Label 1936: @132849
     /* 132849 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(132896), // Rule ID 3298 //
     /* 132854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 132857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132872 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 132875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132894 */     GIR_RootConstrainSelectedInstOperands,
     /* 132895 */     // GIR_Coverage, 3298,
     /* 132895 */     GIR_EraseRootFromParent_Done,
     /* 132896 */   // Label 1937: @132896
     /* 132896 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(132946), // Rule ID 3299 //
     /* 132901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 132904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132919 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 132922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132944 */     GIR_RootConstrainSelectedInstOperands,
     /* 132945 */     // GIR_Coverage, 3299,
     /* 132945 */     GIR_EraseRootFromParent_Done,
     /* 132946 */   // Label 1938: @132946
     /* 132946 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(132989), // Rule ID 3273 //
     /* 132951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 132954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 132958 */     // MIs[0] sbase
     /* 132958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 132966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132970 */     // (ld:{ *:[v8i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 132973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132975 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 132977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132987 */     GIR_RootConstrainSelectedInstOperands,
     /* 132988 */     // GIR_Coverage, 3273,
     /* 132988 */     GIR_EraseRootFromParent_Done,
     /* 132989 */   // Label 1939: @132989
     /* 132989 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(133032), // Rule ID 3290 //
     /* 132994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 132997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133001 */     // MIs[0] sbase
     /* 133001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133013 */     // (ld:{ *:[v8f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 133016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133018 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133030 */     GIR_RootConstrainSelectedInstOperands,
     /* 133031 */     // GIR_Coverage, 3290,
     /* 133031 */     GIR_EraseRootFromParent_Done,
     /* 133032 */   // Label 1940: @133032
     /* 133032 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(133071), // Rule ID 3278 //
     /* 133037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133044 */     // MIs[0] sbase
     /* 133044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133052 */     // (ld:{ *:[v8i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 133055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133057 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133069 */     GIR_RootConstrainSelectedInstOperands,
     /* 133070 */     // GIR_Coverage, 3278,
     /* 133070 */     GIR_EraseRootFromParent_Done,
     /* 133071 */   // Label 1941: @133071
     /* 133071 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(133110), // Rule ID 3295 //
     /* 133076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133083 */     // MIs[0] sbase
     /* 133083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133091 */     // (ld:{ *:[v8f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 133094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133096 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133108 */     GIR_RootConstrainSelectedInstOperands,
     /* 133109 */     // GIR_Coverage, 3295,
     /* 133109 */     GIR_EraseRootFromParent_Done,
     /* 133110 */   // Label 1942: @133110
     /* 133110 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(133146), // Rule ID 3284 //
     /* 133115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133119 */     // MIs[0] sbase
     /* 133119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133127 */     // (ld:{ *:[v8i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 133130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133132 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133144 */     GIR_RootConstrainSelectedInstOperands,
     /* 133145 */     // GIR_Coverage, 3284,
     /* 133145 */     GIR_EraseRootFromParent_Done,
     /* 133146 */   // Label 1943: @133146
     /* 133146 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(133182), // Rule ID 3301 //
     /* 133151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 133155 */     // MIs[0] sbase
     /* 133155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133163 */     // (ld:{ *:[v8f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 133166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133168 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133180 */     GIR_RootConstrainSelectedInstOperands,
     /* 133181 */     // GIR_Coverage, 3301,
     /* 133181 */     GIR_EraseRootFromParent_Done,
     /* 133182 */   // Label 1944: @133182
     /* 133182 */   GIM_Reject,
     /* 133183 */ // Label 1910: @133183
     /* 133183 */ GIM_Reject,
     /* 133184 */ // Label 891: @133184
     /* 133184 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(134835),
     /* 133189 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133192 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133196 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133200 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(133256), // Rule ID 3408 //
     /* 133205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 133208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133216 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 133227 */     // (ld:{ *:[v8i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 133230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 133247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133254 */     GIR_RootConstrainSelectedInstOperands,
     /* 133255 */     // GIR_Coverage, 3408,
     /* 133255 */     GIR_EraseRootFromParent_Done,
     /* 133256 */   // Label 1946: @133256
     /* 133256 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(133312), // Rule ID 3425 //
     /* 133261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 133264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 133283 */     // (ld:{ *:[v8f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 133286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 133303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133310 */     GIR_RootConstrainSelectedInstOperands,
     /* 133311 */     // GIR_Coverage, 3425,
     /* 133311 */     GIR_EraseRootFromParent_Done,
     /* 133312 */   // Label 1947: @133312
     /* 133312 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(133364), // Rule ID 3413 //
     /* 133317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 133320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 133335 */     // (ld:{ *:[v8i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 133338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 133355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133362 */     GIR_RootConstrainSelectedInstOperands,
     /* 133363 */     // GIR_Coverage, 3413,
     /* 133363 */     GIR_EraseRootFromParent_Done,
     /* 133364 */   // Label 1948: @133364
     /* 133364 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(133416), // Rule ID 3430 //
     /* 133369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 133372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 133387 */     // (ld:{ *:[v8f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 133390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 133407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133414 */     GIR_RootConstrainSelectedInstOperands,
     /* 133415 */     // GIR_Coverage, 3430,
     /* 133415 */     GIR_EraseRootFromParent_Done,
     /* 133416 */   // Label 1949: @133416
     /* 133416 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(133468), // Rule ID 3419 //
     /* 133421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 133424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 133439 */     // (ld:{ *:[v8i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 133442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 133459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133466 */     GIR_RootConstrainSelectedInstOperands,
     /* 133467 */     // GIR_Coverage, 3419,
     /* 133467 */     GIR_EraseRootFromParent_Done,
     /* 133468 */   // Label 1950: @133468
     /* 133468 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(133520), // Rule ID 3436 //
     /* 133473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 133476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 133491 */     // (ld:{ *:[v8f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 133494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 133511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133518 */     GIR_RootConstrainSelectedInstOperands,
     /* 133519 */     // GIR_Coverage, 3436,
     /* 133519 */     GIR_EraseRootFromParent_Done,
     /* 133520 */   // Label 1951: @133520
     /* 133520 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(133571), // Rule ID 3404 //
     /* 133525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 133547 */     // (ld:{ *:[v8i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 133550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133569 */     GIR_RootConstrainSelectedInstOperands,
     /* 133570 */     // GIR_Coverage, 3404,
     /* 133570 */     GIR_EraseRootFromParent_Done,
     /* 133571 */   // Label 1952: @133571
     /* 133571 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(133622), // Rule ID 3405 //
     /* 133576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 133579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133587 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 133598 */     // (ld:{ *:[v8i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 133601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133620 */     GIR_RootConstrainSelectedInstOperands,
     /* 133621 */     // GIR_Coverage, 3405,
     /* 133621 */     GIR_EraseRootFromParent_Done,
     /* 133622 */   // Label 1953: @133622
     /* 133622 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(133673), // Rule ID 3406 //
     /* 133627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 133630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133638 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 133649 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 133649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 133652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133671 */     GIR_RootConstrainSelectedInstOperands,
     /* 133672 */     // GIR_Coverage, 3406,
     /* 133672 */     GIR_EraseRootFromParent_Done,
     /* 133673 */   // Label 1954: @133673
     /* 133673 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(133727), // Rule ID 3407 //
     /* 133678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 133681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 133700 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 133703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133725 */     GIR_RootConstrainSelectedInstOperands,
     /* 133726 */     // GIR_Coverage, 3407,
     /* 133726 */     GIR_EraseRootFromParent_Done,
     /* 133727 */   // Label 1955: @133727
     /* 133727 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(133778), // Rule ID 3421 //
     /* 133732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133743 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 133754 */     // (ld:{ *:[v8f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 133757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133776 */     GIR_RootConstrainSelectedInstOperands,
     /* 133777 */     // GIR_Coverage, 3421,
     /* 133777 */     GIR_EraseRootFromParent_Done,
     /* 133778 */   // Label 1956: @133778
     /* 133778 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(133829), // Rule ID 3422 //
     /* 133783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 133786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 133805 */     // (ld:{ *:[v8f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 133808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133827 */     GIR_RootConstrainSelectedInstOperands,
     /* 133828 */     // GIR_Coverage, 3422,
     /* 133828 */     GIR_EraseRootFromParent_Done,
     /* 133829 */   // Label 1957: @133829
     /* 133829 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(133880), // Rule ID 3423 //
     /* 133834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 133837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133845 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 133856 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 133856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 133859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133878 */     GIR_RootConstrainSelectedInstOperands,
     /* 133879 */     // GIR_Coverage, 3423,
     /* 133879 */     GIR_EraseRootFromParent_Done,
     /* 133880 */   // Label 1958: @133880
     /* 133880 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(133934), // Rule ID 3424 //
     /* 133885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 133888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 133907 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 133910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133932 */     GIR_RootConstrainSelectedInstOperands,
     /* 133933 */     // GIR_Coverage, 3424,
     /* 133933 */     GIR_EraseRootFromParent_Done,
     /* 133934 */   // Label 1959: @133934
     /* 133934 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(133981), // Rule ID 3410 //
     /* 133939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 133957 */     // (ld:{ *:[v8i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 133960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133979 */     GIR_RootConstrainSelectedInstOperands,
     /* 133980 */     // GIR_Coverage, 3410,
     /* 133980 */     GIR_EraseRootFromParent_Done,
     /* 133981 */   // Label 1960: @133981
     /* 133981 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(134028), // Rule ID 3411 //
     /* 133986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 133989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 133993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134004 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 134004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 134007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134026 */     GIR_RootConstrainSelectedInstOperands,
     /* 134027 */     // GIR_Coverage, 3411,
     /* 134027 */     GIR_EraseRootFromParent_Done,
     /* 134028 */   // Label 1961: @134028
     /* 134028 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(134078), // Rule ID 3412 //
     /* 134033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 134036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134051 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 134054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134076 */     GIR_RootConstrainSelectedInstOperands,
     /* 134077 */     // GIR_Coverage, 3412,
     /* 134077 */     GIR_EraseRootFromParent_Done,
     /* 134078 */   // Label 1962: @134078
     /* 134078 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(134125), // Rule ID 3427 //
     /* 134083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 134086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 134101 */     // (ld:{ *:[v8f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 134104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134123 */     GIR_RootConstrainSelectedInstOperands,
     /* 134124 */     // GIR_Coverage, 3427,
     /* 134124 */     GIR_EraseRootFromParent_Done,
     /* 134125 */   // Label 1963: @134125
     /* 134125 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(134172), // Rule ID 3428 //
     /* 134130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 134133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134148 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 134148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 134151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134170 */     GIR_RootConstrainSelectedInstOperands,
     /* 134171 */     // GIR_Coverage, 3428,
     /* 134171 */     GIR_EraseRootFromParent_Done,
     /* 134172 */   // Label 1964: @134172
     /* 134172 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(134222), // Rule ID 3429 //
     /* 134177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 134180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134195 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 134198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134220 */     GIR_RootConstrainSelectedInstOperands,
     /* 134221 */     // GIR_Coverage, 3429,
     /* 134221 */     GIR_EraseRootFromParent_Done,
     /* 134222 */   // Label 1965: @134222
     /* 134222 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(134266), // Rule ID 3415 //
     /* 134227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 134242 */     // (ld:{ *:[v8i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 134245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134264 */     GIR_RootConstrainSelectedInstOperands,
     /* 134265 */     // GIR_Coverage, 3415,
     /* 134265 */     GIR_EraseRootFromParent_Done,
     /* 134266 */   // Label 1966: @134266
     /* 134266 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(134313), // Rule ID 3416 //
     /* 134271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 134274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 134289 */     // (ld:{ *:[v8i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 134292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134311 */     GIR_RootConstrainSelectedInstOperands,
     /* 134312 */     // GIR_Coverage, 3416,
     /* 134312 */     GIR_EraseRootFromParent_Done,
     /* 134313 */   // Label 1967: @134313
     /* 134313 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(134360), // Rule ID 3417 //
     /* 134318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 134321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134336 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 134336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 134339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134358 */     GIR_RootConstrainSelectedInstOperands,
     /* 134359 */     // GIR_Coverage, 3417,
     /* 134359 */     GIR_EraseRootFromParent_Done,
     /* 134360 */   // Label 1968: @134360
     /* 134360 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(134410), // Rule ID 3418 //
     /* 134365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 134368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134383 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 134386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134408 */     GIR_RootConstrainSelectedInstOperands,
     /* 134409 */     // GIR_Coverage, 3418,
     /* 134409 */     GIR_EraseRootFromParent_Done,
     /* 134410 */   // Label 1969: @134410
     /* 134410 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(134454), // Rule ID 3432 //
     /* 134415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 134430 */     // (ld:{ *:[v8f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 134433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134452 */     GIR_RootConstrainSelectedInstOperands,
     /* 134453 */     // GIR_Coverage, 3432,
     /* 134453 */     GIR_EraseRootFromParent_Done,
     /* 134454 */   // Label 1970: @134454
     /* 134454 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(134501), // Rule ID 3433 //
     /* 134459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 134462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 134477 */     // (ld:{ *:[v8f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 134480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134499 */     GIR_RootConstrainSelectedInstOperands,
     /* 134500 */     // GIR_Coverage, 3433,
     /* 134500 */     GIR_EraseRootFromParent_Done,
     /* 134501 */   // Label 1971: @134501
     /* 134501 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(134548), // Rule ID 3434 //
     /* 134506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 134509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134524 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 134524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 134527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134546 */     GIR_RootConstrainSelectedInstOperands,
     /* 134547 */     // GIR_Coverage, 3434,
     /* 134547 */     GIR_EraseRootFromParent_Done,
     /* 134548 */   // Label 1972: @134548
     /* 134548 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(134598), // Rule ID 3435 //
     /* 134553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 134556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 134571 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 134574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134596 */     GIR_RootConstrainSelectedInstOperands,
     /* 134597 */     // GIR_Coverage, 3435,
     /* 134597 */     GIR_EraseRootFromParent_Done,
     /* 134598 */   // Label 1973: @134598
     /* 134598 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(134641), // Rule ID 3409 //
     /* 134603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 134606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134610 */     // MIs[0] sbase
     /* 134610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 134618 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 134622 */     // (ld:{ *:[v8i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 134625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134627 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 134629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134639 */     GIR_RootConstrainSelectedInstOperands,
     /* 134640 */     // GIR_Coverage, 3409,
     /* 134640 */     GIR_EraseRootFromParent_Done,
     /* 134641 */   // Label 1974: @134641
     /* 134641 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(134684), // Rule ID 3426 //
     /* 134646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 134649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134653 */     // MIs[0] sbase
     /* 134653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 134661 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 134665 */     // (ld:{ *:[v8f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 134668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134670 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 134672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134682 */     GIR_RootConstrainSelectedInstOperands,
     /* 134683 */     // GIR_Coverage, 3426,
     /* 134683 */     GIR_EraseRootFromParent_Done,
     /* 134684 */   // Label 1975: @134684
     /* 134684 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(134723), // Rule ID 3414 //
     /* 134689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 134692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134696 */     // MIs[0] sbase
     /* 134696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 134704 */     // (ld:{ *:[v8i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 134707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134709 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 134711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134721 */     GIR_RootConstrainSelectedInstOperands,
     /* 134722 */     // GIR_Coverage, 3414,
     /* 134722 */     GIR_EraseRootFromParent_Done,
     /* 134723 */   // Label 1976: @134723
     /* 134723 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(134762), // Rule ID 3431 //
     /* 134728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 134731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134735 */     // MIs[0] sbase
     /* 134735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 134743 */     // (ld:{ *:[v8f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 134746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134748 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 134750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134760 */     GIR_RootConstrainSelectedInstOperands,
     /* 134761 */     // GIR_Coverage, 3431,
     /* 134761 */     GIR_EraseRootFromParent_Done,
     /* 134762 */   // Label 1977: @134762
     /* 134762 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(134798), // Rule ID 3420 //
     /* 134767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134771 */     // MIs[0] sbase
     /* 134771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 134779 */     // (ld:{ *:[v8i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 134782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134784 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 134786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134796 */     GIR_RootConstrainSelectedInstOperands,
     /* 134797 */     // GIR_Coverage, 3420,
     /* 134797 */     GIR_EraseRootFromParent_Done,
     /* 134798 */   // Label 1978: @134798
     /* 134798 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(134834), // Rule ID 3437 //
     /* 134803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 134807 */     // MIs[0] sbase
     /* 134807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 134815 */     // (ld:{ *:[v8f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 134815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 134818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134820 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 134822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134832 */     GIR_RootConstrainSelectedInstOperands,
     /* 134833 */     // GIR_Coverage, 3437,
     /* 134833 */     GIR_EraseRootFromParent_Done,
     /* 134834 */   // Label 1979: @134834
     /* 134834 */   GIM_Reject,
     /* 134835 */ // Label 1945: @134835
     /* 134835 */ GIM_Reject,
     /* 134836 */ // Label 892: @134836
     /* 134836 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(136487),
     /* 134841 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134844 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134848 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 134852 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(134908), // Rule ID 3340 //
     /* 134857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 134860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 134864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 134872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 134879 */     // (ld:{ *:[v16i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 134882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 134899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134906 */     GIR_RootConstrainSelectedInstOperands,
     /* 134907 */     // GIR_Coverage, 3340,
     /* 134907 */     GIR_EraseRootFromParent_Done,
     /* 134908 */   // Label 1981: @134908
     /* 134908 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(134964), // Rule ID 3357 //
     /* 134913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 134916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 134920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134924 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 134928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 134935 */     // (ld:{ *:[v16f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 134938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 134955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134962 */     GIR_RootConstrainSelectedInstOperands,
     /* 134963 */     // GIR_Coverage, 3357,
     /* 134963 */     GIR_EraseRootFromParent_Done,
     /* 134964 */   // Label 1982: @134964
     /* 134964 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(135016), // Rule ID 3345 //
     /* 134969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 134972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 134976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 134987 */     // (ld:{ *:[v16i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 134990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 134992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 134997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135014 */     GIR_RootConstrainSelectedInstOperands,
     /* 135015 */     // GIR_Coverage, 3345,
     /* 135015 */     GIR_EraseRootFromParent_Done,
     /* 135016 */   // Label 1983: @135016
     /* 135016 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(135068), // Rule ID 3362 //
     /* 135021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135039 */     // (ld:{ *:[v16f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 135042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135066 */     GIR_RootConstrainSelectedInstOperands,
     /* 135067 */     // GIR_Coverage, 3362,
     /* 135067 */     GIR_EraseRootFromParent_Done,
     /* 135068 */   // Label 1984: @135068
     /* 135068 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(135120), // Rule ID 3351 //
     /* 135073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 135076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135091 */     // (ld:{ *:[v16i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135118 */     GIR_RootConstrainSelectedInstOperands,
     /* 135119 */     // GIR_Coverage, 3351,
     /* 135119 */     GIR_EraseRootFromParent_Done,
     /* 135120 */   // Label 1985: @135120
     /* 135120 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(135172), // Rule ID 3368 //
     /* 135125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 135128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135143 */     // (ld:{ *:[v16f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135170 */     GIR_RootConstrainSelectedInstOperands,
     /* 135171 */     // GIR_Coverage, 3368,
     /* 135171 */     GIR_EraseRootFromParent_Done,
     /* 135172 */   // Label 1986: @135172
     /* 135172 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(135223), // Rule ID 3336 //
     /* 135177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 135180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 135199 */     // (ld:{ *:[v16i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 135202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135221 */     GIR_RootConstrainSelectedInstOperands,
     /* 135222 */     // GIR_Coverage, 3336,
     /* 135222 */     GIR_EraseRootFromParent_Done,
     /* 135223 */   // Label 1987: @135223
     /* 135223 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(135274), // Rule ID 3337 //
     /* 135228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 135231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135239 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 135250 */     // (ld:{ *:[v16i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 135253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135272 */     GIR_RootConstrainSelectedInstOperands,
     /* 135273 */     // GIR_Coverage, 3337,
     /* 135273 */     GIR_EraseRootFromParent_Done,
     /* 135274 */   // Label 1988: @135274
     /* 135274 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(135325), // Rule ID 3338 //
     /* 135279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 135282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135290 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135301 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 135301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 135304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135323 */     GIR_RootConstrainSelectedInstOperands,
     /* 135324 */     // GIR_Coverage, 3338,
     /* 135324 */     GIR_EraseRootFromParent_Done,
     /* 135325 */   // Label 1989: @135325
     /* 135325 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(135379), // Rule ID 3339 //
     /* 135330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135352 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 135352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135377 */     GIR_RootConstrainSelectedInstOperands,
     /* 135378 */     // GIR_Coverage, 3339,
     /* 135378 */     GIR_EraseRootFromParent_Done,
     /* 135379 */   // Label 1990: @135379
     /* 135379 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(135430), // Rule ID 3353 //
     /* 135384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 135387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135395 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 135406 */     // (ld:{ *:[v16f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 135409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135428 */     GIR_RootConstrainSelectedInstOperands,
     /* 135429 */     // GIR_Coverage, 3353,
     /* 135429 */     GIR_EraseRootFromParent_Done,
     /* 135430 */   // Label 1991: @135430
     /* 135430 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(135481), // Rule ID 3354 //
     /* 135435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 135438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 135457 */     // (ld:{ *:[v16f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 135460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135479 */     GIR_RootConstrainSelectedInstOperands,
     /* 135480 */     // GIR_Coverage, 3354,
     /* 135480 */     GIR_EraseRootFromParent_Done,
     /* 135481 */   // Label 1992: @135481
     /* 135481 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(135532), // Rule ID 3355 //
     /* 135486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 135489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135497 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135508 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 135508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 135511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135530 */     GIR_RootConstrainSelectedInstOperands,
     /* 135531 */     // GIR_Coverage, 3355,
     /* 135531 */     GIR_EraseRootFromParent_Done,
     /* 135532 */   // Label 1993: @135532
     /* 135532 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(135586), // Rule ID 3356 //
     /* 135537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135548 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135559 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 135559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135584 */     GIR_RootConstrainSelectedInstOperands,
     /* 135585 */     // GIR_Coverage, 3356,
     /* 135585 */     GIR_EraseRootFromParent_Done,
     /* 135586 */   // Label 1994: @135586
     /* 135586 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(135633), // Rule ID 3342 //
     /* 135591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 135594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 135609 */     // (ld:{ *:[v16i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 135612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135631 */     GIR_RootConstrainSelectedInstOperands,
     /* 135632 */     // GIR_Coverage, 3342,
     /* 135632 */     GIR_EraseRootFromParent_Done,
     /* 135633 */   // Label 1995: @135633
     /* 135633 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(135680), // Rule ID 3343 //
     /* 135638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 135641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135656 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 135656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 135659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135678 */     GIR_RootConstrainSelectedInstOperands,
     /* 135679 */     // GIR_Coverage, 3343,
     /* 135679 */     GIR_EraseRootFromParent_Done,
     /* 135680 */   // Label 1996: @135680
     /* 135680 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(135730), // Rule ID 3344 //
     /* 135685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135703 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 135703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 135706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135728 */     GIR_RootConstrainSelectedInstOperands,
     /* 135729 */     // GIR_Coverage, 3344,
     /* 135729 */     GIR_EraseRootFromParent_Done,
     /* 135730 */   // Label 1997: @135730
     /* 135730 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(135777), // Rule ID 3359 //
     /* 135735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 135738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 135753 */     // (ld:{ *:[v16f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 135756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135775 */     GIR_RootConstrainSelectedInstOperands,
     /* 135776 */     // GIR_Coverage, 3359,
     /* 135776 */     GIR_EraseRootFromParent_Done,
     /* 135777 */   // Label 1998: @135777
     /* 135777 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(135824), // Rule ID 3360 //
     /* 135782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 135785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135800 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 135800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 135803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135822 */     GIR_RootConstrainSelectedInstOperands,
     /* 135823 */     // GIR_Coverage, 3360,
     /* 135823 */     GIR_EraseRootFromParent_Done,
     /* 135824 */   // Label 1999: @135824
     /* 135824 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(135874), // Rule ID 3361 //
     /* 135829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135847 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 135847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 135850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135872 */     GIR_RootConstrainSelectedInstOperands,
     /* 135873 */     // GIR_Coverage, 3361,
     /* 135873 */     GIR_EraseRootFromParent_Done,
     /* 135874 */   // Label 2000: @135874
     /* 135874 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(135918), // Rule ID 3347 //
     /* 135879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 135894 */     // (ld:{ *:[v16i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 135897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135916 */     GIR_RootConstrainSelectedInstOperands,
     /* 135917 */     // GIR_Coverage, 3347,
     /* 135917 */     GIR_EraseRootFromParent_Done,
     /* 135918 */   // Label 2001: @135918
     /* 135918 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(135965), // Rule ID 3348 //
     /* 135923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 135926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 135941 */     // (ld:{ *:[v16i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 135944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135963 */     GIR_RootConstrainSelectedInstOperands,
     /* 135964 */     // GIR_Coverage, 3348,
     /* 135964 */     GIR_EraseRootFromParent_Done,
     /* 135965 */   // Label 2002: @135965
     /* 135965 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(136012), // Rule ID 3349 //
     /* 135970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 135973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135988 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 135988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 135991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136010 */     GIR_RootConstrainSelectedInstOperands,
     /* 136011 */     // GIR_Coverage, 3349,
     /* 136011 */     GIR_EraseRootFromParent_Done,
     /* 136012 */   // Label 2003: @136012
     /* 136012 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(136062), // Rule ID 3350 //
     /* 136017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 136020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136035 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 136038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136060 */     GIR_RootConstrainSelectedInstOperands,
     /* 136061 */     // GIR_Coverage, 3350,
     /* 136061 */     GIR_EraseRootFromParent_Done,
     /* 136062 */   // Label 2004: @136062
     /* 136062 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(136106), // Rule ID 3364 //
     /* 136067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 136082 */     // (ld:{ *:[v16f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136104 */     GIR_RootConstrainSelectedInstOperands,
     /* 136105 */     // GIR_Coverage, 3364,
     /* 136105 */     GIR_EraseRootFromParent_Done,
     /* 136106 */   // Label 2005: @136106
     /* 136106 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(136153), // Rule ID 3365 //
     /* 136111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 136114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 136129 */     // (ld:{ *:[v16f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 136132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136151 */     GIR_RootConstrainSelectedInstOperands,
     /* 136152 */     // GIR_Coverage, 3365,
     /* 136152 */     GIR_EraseRootFromParent_Done,
     /* 136153 */   // Label 2006: @136153
     /* 136153 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(136200), // Rule ID 3366 //
     /* 136158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 136161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136176 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 136176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 136179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136198 */     GIR_RootConstrainSelectedInstOperands,
     /* 136199 */     // GIR_Coverage, 3366,
     /* 136199 */     GIR_EraseRootFromParent_Done,
     /* 136200 */   // Label 2007: @136200
     /* 136200 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(136250), // Rule ID 3367 //
     /* 136205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 136208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136223 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 136226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136248 */     GIR_RootConstrainSelectedInstOperands,
     /* 136249 */     // GIR_Coverage, 3367,
     /* 136249 */     GIR_EraseRootFromParent_Done,
     /* 136250 */   // Label 2008: @136250
     /* 136250 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(136293), // Rule ID 3341 //
     /* 136255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136262 */     // MIs[0] sbase
     /* 136262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136270 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136274 */     // (ld:{ *:[v16i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136279 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136291 */     GIR_RootConstrainSelectedInstOperands,
     /* 136292 */     // GIR_Coverage, 3341,
     /* 136292 */     GIR_EraseRootFromParent_Done,
     /* 136293 */   // Label 2009: @136293
     /* 136293 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(136336), // Rule ID 3358 //
     /* 136298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136305 */     // MIs[0] sbase
     /* 136305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136313 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136317 */     // (ld:{ *:[v16f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136322 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136334 */     GIR_RootConstrainSelectedInstOperands,
     /* 136335 */     // GIR_Coverage, 3358,
     /* 136335 */     GIR_EraseRootFromParent_Done,
     /* 136336 */   // Label 2010: @136336
     /* 136336 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(136375), // Rule ID 3346 //
     /* 136341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136348 */     // MIs[0] sbase
     /* 136348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136356 */     // (ld:{ *:[v16i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 136359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136361 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136373 */     GIR_RootConstrainSelectedInstOperands,
     /* 136374 */     // GIR_Coverage, 3346,
     /* 136374 */     GIR_EraseRootFromParent_Done,
     /* 136375 */   // Label 2011: @136375
     /* 136375 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(136414), // Rule ID 3363 //
     /* 136380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136387 */     // MIs[0] sbase
     /* 136387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136395 */     // (ld:{ *:[v16f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 136398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136400 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136412 */     GIR_RootConstrainSelectedInstOperands,
     /* 136413 */     // GIR_Coverage, 3363,
     /* 136413 */     GIR_EraseRootFromParent_Done,
     /* 136414 */   // Label 2012: @136414
     /* 136414 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(136450), // Rule ID 3352 //
     /* 136419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136423 */     // MIs[0] sbase
     /* 136423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136431 */     // (ld:{ *:[v16i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136436 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136448 */     GIR_RootConstrainSelectedInstOperands,
     /* 136449 */     // GIR_Coverage, 3352,
     /* 136449 */     GIR_EraseRootFromParent_Done,
     /* 136450 */   // Label 2013: @136450
     /* 136450 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(136486), // Rule ID 3369 //
     /* 136455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136459 */     // MIs[0] sbase
     /* 136459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136467 */     // (ld:{ *:[v16f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136472 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136484 */     GIR_RootConstrainSelectedInstOperands,
     /* 136485 */     // GIR_Coverage, 3369,
     /* 136485 */     GIR_EraseRootFromParent_Done,
     /* 136486 */   // Label 2014: @136486
     /* 136486 */   GIM_Reject,
     /* 136487 */ // Label 1980: @136487
     /* 136487 */ GIM_Reject,
     /* 136488 */ // Label 893: @136488
     /* 136488 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(138139),
     /* 136493 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136496 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136500 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 136504 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(136560), // Rule ID 3374 //
     /* 136509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 136531 */     // (ld:{ *:[v16i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 136534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 136551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136558 */     GIR_RootConstrainSelectedInstOperands,
     /* 136559 */     // GIR_Coverage, 3374,
     /* 136559 */     GIR_EraseRootFromParent_Done,
     /* 136560 */   // Label 2016: @136560
     /* 136560 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(136616), // Rule ID 3391 //
     /* 136565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 136587 */     // (ld:{ *:[v16f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 136590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 136607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136614 */     GIR_RootConstrainSelectedInstOperands,
     /* 136615 */     // GIR_Coverage, 3391,
     /* 136615 */     GIR_EraseRootFromParent_Done,
     /* 136616 */   // Label 2017: @136616
     /* 136616 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(136668), // Rule ID 3379 //
     /* 136621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 136639 */     // (ld:{ *:[v16i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 136642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 136659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136666 */     GIR_RootConstrainSelectedInstOperands,
     /* 136667 */     // GIR_Coverage, 3379,
     /* 136667 */     GIR_EraseRootFromParent_Done,
     /* 136668 */   // Label 2018: @136668
     /* 136668 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(136720), // Rule ID 3396 //
     /* 136673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 136691 */     // (ld:{ *:[v16f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 136694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 136711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136718 */     GIR_RootConstrainSelectedInstOperands,
     /* 136719 */     // GIR_Coverage, 3396,
     /* 136719 */     GIR_EraseRootFromParent_Done,
     /* 136720 */   // Label 2019: @136720
     /* 136720 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(136772), // Rule ID 3385 //
     /* 136725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 136728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 136743 */     // (ld:{ *:[v16i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 136746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 136763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136770 */     GIR_RootConstrainSelectedInstOperands,
     /* 136771 */     // GIR_Coverage, 3385,
     /* 136771 */     GIR_EraseRootFromParent_Done,
     /* 136772 */   // Label 2020: @136772
     /* 136772 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(136824), // Rule ID 3402 //
     /* 136777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 136780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 136795 */     // (ld:{ *:[v16f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 136798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 136815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136822 */     GIR_RootConstrainSelectedInstOperands,
     /* 136823 */     // GIR_Coverage, 3402,
     /* 136823 */     GIR_EraseRootFromParent_Done,
     /* 136824 */   // Label 2021: @136824
     /* 136824 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(136875), // Rule ID 3370 //
     /* 136829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136840 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 136851 */     // (ld:{ *:[v16i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 136854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136873 */     GIR_RootConstrainSelectedInstOperands,
     /* 136874 */     // GIR_Coverage, 3370,
     /* 136874 */     GIR_EraseRootFromParent_Done,
     /* 136875 */   // Label 2022: @136875
     /* 136875 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(136926), // Rule ID 3371 //
     /* 136880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 136883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136891 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 136902 */     // (ld:{ *:[v16i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 136905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136924 */     GIR_RootConstrainSelectedInstOperands,
     /* 136925 */     // GIR_Coverage, 3371,
     /* 136925 */     GIR_EraseRootFromParent_Done,
     /* 136926 */   // Label 2023: @136926
     /* 136926 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(136977), // Rule ID 3372 //
     /* 136931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 136934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136953 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 136953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 136956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136975 */     GIR_RootConstrainSelectedInstOperands,
     /* 136976 */     // GIR_Coverage, 3372,
     /* 136976 */     GIR_EraseRootFromParent_Done,
     /* 136977 */   // Label 2024: @136977
     /* 136977 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(137031), // Rule ID 3373 //
     /* 136982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137004 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137029 */     GIR_RootConstrainSelectedInstOperands,
     /* 137030 */     // GIR_Coverage, 3373,
     /* 137030 */     GIR_EraseRootFromParent_Done,
     /* 137031 */   // Label 2025: @137031
     /* 137031 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(137082), // Rule ID 3387 //
     /* 137036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137058 */     // (ld:{ *:[v16f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 137061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137080 */     GIR_RootConstrainSelectedInstOperands,
     /* 137081 */     // GIR_Coverage, 3387,
     /* 137081 */     GIR_EraseRootFromParent_Done,
     /* 137082 */   // Label 2026: @137082
     /* 137082 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(137133), // Rule ID 3388 //
     /* 137087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 137090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 137109 */     // (ld:{ *:[v16f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 137112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137131 */     GIR_RootConstrainSelectedInstOperands,
     /* 137132 */     // GIR_Coverage, 3388,
     /* 137132 */     GIR_EraseRootFromParent_Done,
     /* 137133 */   // Label 2027: @137133
     /* 137133 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(137184), // Rule ID 3389 //
     /* 137138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 137141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137160 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 137163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137182 */     GIR_RootConstrainSelectedInstOperands,
     /* 137183 */     // GIR_Coverage, 3389,
     /* 137183 */     GIR_EraseRootFromParent_Done,
     /* 137184 */   // Label 2028: @137184
     /* 137184 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(137238), // Rule ID 3390 //
     /* 137189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137200 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137211 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137236 */     GIR_RootConstrainSelectedInstOperands,
     /* 137237 */     // GIR_Coverage, 3390,
     /* 137237 */     GIR_EraseRootFromParent_Done,
     /* 137238 */   // Label 2029: @137238
     /* 137238 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(137285), // Rule ID 3376 //
     /* 137243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137261 */     // (ld:{ *:[v16i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 137264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137283 */     GIR_RootConstrainSelectedInstOperands,
     /* 137284 */     // GIR_Coverage, 3376,
     /* 137284 */     GIR_EraseRootFromParent_Done,
     /* 137285 */   // Label 2030: @137285
     /* 137285 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(137332), // Rule ID 3377 //
     /* 137290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 137293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137308 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 137311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137330 */     GIR_RootConstrainSelectedInstOperands,
     /* 137331 */     // GIR_Coverage, 3377,
     /* 137331 */     GIR_EraseRootFromParent_Done,
     /* 137332 */   // Label 2031: @137332
     /* 137332 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(137382), // Rule ID 3378 //
     /* 137337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137355 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 137358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137380 */     GIR_RootConstrainSelectedInstOperands,
     /* 137381 */     // GIR_Coverage, 3378,
     /* 137381 */     GIR_EraseRootFromParent_Done,
     /* 137382 */   // Label 2032: @137382
     /* 137382 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(137429), // Rule ID 3393 //
     /* 137387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137405 */     // (ld:{ *:[v16f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 137408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137427 */     GIR_RootConstrainSelectedInstOperands,
     /* 137428 */     // GIR_Coverage, 3393,
     /* 137428 */     GIR_EraseRootFromParent_Done,
     /* 137429 */   // Label 2033: @137429
     /* 137429 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(137476), // Rule ID 3394 //
     /* 137434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 137437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137452 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 137455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137474 */     GIR_RootConstrainSelectedInstOperands,
     /* 137475 */     // GIR_Coverage, 3394,
     /* 137475 */     GIR_EraseRootFromParent_Done,
     /* 137476 */   // Label 2034: @137476
     /* 137476 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(137526), // Rule ID 3395 //
     /* 137481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137499 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 137502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137524 */     GIR_RootConstrainSelectedInstOperands,
     /* 137525 */     // GIR_Coverage, 3395,
     /* 137525 */     GIR_EraseRootFromParent_Done,
     /* 137526 */   // Label 2035: @137526
     /* 137526 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(137570), // Rule ID 3381 //
     /* 137531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137546 */     // (ld:{ *:[v16i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 137549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137568 */     GIR_RootConstrainSelectedInstOperands,
     /* 137569 */     // GIR_Coverage, 3381,
     /* 137569 */     GIR_EraseRootFromParent_Done,
     /* 137570 */   // Label 2036: @137570
     /* 137570 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(137617), // Rule ID 3382 //
     /* 137575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 137578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 137593 */     // (ld:{ *:[v16i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 137596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137615 */     GIR_RootConstrainSelectedInstOperands,
     /* 137616 */     // GIR_Coverage, 3382,
     /* 137616 */     GIR_EraseRootFromParent_Done,
     /* 137617 */   // Label 2037: @137617
     /* 137617 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(137664), // Rule ID 3383 //
     /* 137622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 137625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137640 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 137643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137662 */     GIR_RootConstrainSelectedInstOperands,
     /* 137663 */     // GIR_Coverage, 3383,
     /* 137663 */     GIR_EraseRootFromParent_Done,
     /* 137664 */   // Label 2038: @137664
     /* 137664 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(137714), // Rule ID 3384 //
     /* 137669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 137672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137687 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137712 */     GIR_RootConstrainSelectedInstOperands,
     /* 137713 */     // GIR_Coverage, 3384,
     /* 137713 */     GIR_EraseRootFromParent_Done,
     /* 137714 */   // Label 2039: @137714
     /* 137714 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(137758), // Rule ID 3398 //
     /* 137719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137734 */     // (ld:{ *:[v16f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 137737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137756 */     GIR_RootConstrainSelectedInstOperands,
     /* 137757 */     // GIR_Coverage, 3398,
     /* 137757 */     GIR_EraseRootFromParent_Done,
     /* 137758 */   // Label 2040: @137758
     /* 137758 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(137805), // Rule ID 3399 //
     /* 137763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 137766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 137781 */     // (ld:{ *:[v16f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 137784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137803 */     GIR_RootConstrainSelectedInstOperands,
     /* 137804 */     // GIR_Coverage, 3399,
     /* 137804 */     GIR_EraseRootFromParent_Done,
     /* 137805 */   // Label 2041: @137805
     /* 137805 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(137852), // Rule ID 3400 //
     /* 137810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 137813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137828 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 137831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137850 */     GIR_RootConstrainSelectedInstOperands,
     /* 137851 */     // GIR_Coverage, 3400,
     /* 137851 */     GIR_EraseRootFromParent_Done,
     /* 137852 */   // Label 2042: @137852
     /* 137852 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(137902), // Rule ID 3401 //
     /* 137857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 137860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137875 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137900 */     GIR_RootConstrainSelectedInstOperands,
     /* 137901 */     // GIR_Coverage, 3401,
     /* 137901 */     GIR_EraseRootFromParent_Done,
     /* 137902 */   // Label 2043: @137902
     /* 137902 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(137945), // Rule ID 3375 //
     /* 137907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137914 */     // MIs[0] sbase
     /* 137914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 137922 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137926 */     // (ld:{ *:[v16i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 137929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137931 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 137933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137943 */     GIR_RootConstrainSelectedInstOperands,
     /* 137944 */     // GIR_Coverage, 3375,
     /* 137944 */     GIR_EraseRootFromParent_Done,
     /* 137945 */   // Label 2044: @137945
     /* 137945 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(137988), // Rule ID 3392 //
     /* 137950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137957 */     // MIs[0] sbase
     /* 137957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 137965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137969 */     // (ld:{ *:[v16f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 137972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137974 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 137976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137986 */     GIR_RootConstrainSelectedInstOperands,
     /* 137987 */     // GIR_Coverage, 3392,
     /* 137987 */     GIR_EraseRootFromParent_Done,
     /* 137988 */   // Label 2045: @137988
     /* 137988 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(138027), // Rule ID 3380 //
     /* 137993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138000 */     // MIs[0] sbase
     /* 138000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138008 */     // (ld:{ *:[v16i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 138011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138013 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138025 */     GIR_RootConstrainSelectedInstOperands,
     /* 138026 */     // GIR_Coverage, 3380,
     /* 138026 */     GIR_EraseRootFromParent_Done,
     /* 138027 */   // Label 2046: @138027
     /* 138027 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(138066), // Rule ID 3397 //
     /* 138032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138039 */     // MIs[0] sbase
     /* 138039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138047 */     // (ld:{ *:[v16f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 138050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138052 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138064 */     GIR_RootConstrainSelectedInstOperands,
     /* 138065 */     // GIR_Coverage, 3397,
     /* 138065 */     GIR_EraseRootFromParent_Done,
     /* 138066 */   // Label 2047: @138066
     /* 138066 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(138102), // Rule ID 3386 //
     /* 138071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138075 */     // MIs[0] sbase
     /* 138075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138083 */     // (ld:{ *:[v16i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138088 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138100 */     GIR_RootConstrainSelectedInstOperands,
     /* 138101 */     // GIR_Coverage, 3386,
     /* 138101 */     GIR_EraseRootFromParent_Done,
     /* 138102 */   // Label 2048: @138102
     /* 138102 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(138138), // Rule ID 3403 //
     /* 138107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138111 */     // MIs[0] sbase
     /* 138111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138119 */     // (ld:{ *:[v16f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138124 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138136 */     GIR_RootConstrainSelectedInstOperands,
     /* 138137 */     // GIR_Coverage, 3403,
     /* 138137 */     GIR_EraseRootFromParent_Done,
     /* 138138 */   // Label 2049: @138138
     /* 138138 */   GIM_Reject,
     /* 138139 */ // Label 2015: @138139
     /* 138139 */ GIM_Reject,
     /* 138140 */ // Label 894: @138140
     /* 138140 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(139791),
     /* 138145 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138148 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138152 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 138156 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(138212), // Rule ID 3442 //
     /* 138161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138172 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138183 */     // (ld:{ *:[v32i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138210 */     GIR_RootConstrainSelectedInstOperands,
     /* 138211 */     // GIR_Coverage, 3442,
     /* 138211 */     GIR_EraseRootFromParent_Done,
     /* 138212 */   // Label 2051: @138212
     /* 138212 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(138268), // Rule ID 3459 //
     /* 138217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138239 */     // (ld:{ *:[v32f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138266 */     GIR_RootConstrainSelectedInstOperands,
     /* 138267 */     // GIR_Coverage, 3459,
     /* 138267 */     GIR_EraseRootFromParent_Done,
     /* 138268 */   // Label 2052: @138268
     /* 138268 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(138320), // Rule ID 3447 //
     /* 138273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138291 */     // (ld:{ *:[v32i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 138294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138318 */     GIR_RootConstrainSelectedInstOperands,
     /* 138319 */     // GIR_Coverage, 3447,
     /* 138319 */     GIR_EraseRootFromParent_Done,
     /* 138320 */   // Label 2053: @138320
     /* 138320 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(138372), // Rule ID 3464 //
     /* 138325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138343 */     // (ld:{ *:[v32f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 138346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138370 */     GIR_RootConstrainSelectedInstOperands,
     /* 138371 */     // GIR_Coverage, 3464,
     /* 138371 */     GIR_EraseRootFromParent_Done,
     /* 138372 */   // Label 2054: @138372
     /* 138372 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(138424), // Rule ID 3453 //
     /* 138377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 138380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138395 */     // (ld:{ *:[v32i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138422 */     GIR_RootConstrainSelectedInstOperands,
     /* 138423 */     // GIR_Coverage, 3453,
     /* 138423 */     GIR_EraseRootFromParent_Done,
     /* 138424 */   // Label 2055: @138424
     /* 138424 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(138476), // Rule ID 3470 //
     /* 138429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 138432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138447 */     // (ld:{ *:[v32f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138474 */     GIR_RootConstrainSelectedInstOperands,
     /* 138475 */     // GIR_Coverage, 3470,
     /* 138475 */     GIR_EraseRootFromParent_Done,
     /* 138476 */   // Label 2056: @138476
     /* 138476 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(138527), // Rule ID 3438 //
     /* 138481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138492 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 138503 */     // (ld:{ *:[v32i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138525 */     GIR_RootConstrainSelectedInstOperands,
     /* 138526 */     // GIR_Coverage, 3438,
     /* 138526 */     GIR_EraseRootFromParent_Done,
     /* 138527 */   // Label 2057: @138527
     /* 138527 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(138578), // Rule ID 3439 //
     /* 138532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 138535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138543 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 138554 */     // (ld:{ *:[v32i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 138557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138576 */     GIR_RootConstrainSelectedInstOperands,
     /* 138577 */     // GIR_Coverage, 3439,
     /* 138577 */     GIR_EraseRootFromParent_Done,
     /* 138578 */   // Label 2058: @138578
     /* 138578 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(138629), // Rule ID 3440 //
     /* 138583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 138586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 138605 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 138605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 138608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138627 */     GIR_RootConstrainSelectedInstOperands,
     /* 138628 */     // GIR_Coverage, 3440,
     /* 138628 */     GIR_EraseRootFromParent_Done,
     /* 138629 */   // Label 2059: @138629
     /* 138629 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(138683), // Rule ID 3441 //
     /* 138634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 138656 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138681 */     GIR_RootConstrainSelectedInstOperands,
     /* 138682 */     // GIR_Coverage, 3441,
     /* 138682 */     GIR_EraseRootFromParent_Done,
     /* 138683 */   // Label 2060: @138683
     /* 138683 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(138734), // Rule ID 3455 //
     /* 138688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138699 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 138710 */     // (ld:{ *:[v32f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138732 */     GIR_RootConstrainSelectedInstOperands,
     /* 138733 */     // GIR_Coverage, 3455,
     /* 138733 */     GIR_EraseRootFromParent_Done,
     /* 138734 */   // Label 2061: @138734
     /* 138734 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(138785), // Rule ID 3456 //
     /* 138739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 138742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 138761 */     // (ld:{ *:[v32f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 138764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138783 */     GIR_RootConstrainSelectedInstOperands,
     /* 138784 */     // GIR_Coverage, 3456,
     /* 138784 */     GIR_EraseRootFromParent_Done,
     /* 138785 */   // Label 2062: @138785
     /* 138785 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(138836), // Rule ID 3457 //
     /* 138790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 138793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 138812 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 138812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 138815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138834 */     GIR_RootConstrainSelectedInstOperands,
     /* 138835 */     // GIR_Coverage, 3457,
     /* 138835 */     GIR_EraseRootFromParent_Done,
     /* 138836 */   // Label 2063: @138836
     /* 138836 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(138890), // Rule ID 3458 //
     /* 138841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138852 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 138863 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138888 */     GIR_RootConstrainSelectedInstOperands,
     /* 138889 */     // GIR_Coverage, 3458,
     /* 138889 */     GIR_EraseRootFromParent_Done,
     /* 138890 */   // Label 2064: @138890
     /* 138890 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(138937), // Rule ID 3444 //
     /* 138895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 138913 */     // (ld:{ *:[v32i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 138916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138935 */     GIR_RootConstrainSelectedInstOperands,
     /* 138936 */     // GIR_Coverage, 3444,
     /* 138936 */     GIR_EraseRootFromParent_Done,
     /* 138937 */   // Label 2065: @138937
     /* 138937 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(138984), // Rule ID 3445 //
     /* 138942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 138945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 138960 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 138960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 138963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138982 */     GIR_RootConstrainSelectedInstOperands,
     /* 138983 */     // GIR_Coverage, 3445,
     /* 138983 */     GIR_EraseRootFromParent_Done,
     /* 138984 */   // Label 2066: @138984
     /* 138984 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(139034), // Rule ID 3446 //
     /* 138989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139007 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 139010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139032 */     GIR_RootConstrainSelectedInstOperands,
     /* 139033 */     // GIR_Coverage, 3446,
     /* 139033 */     GIR_EraseRootFromParent_Done,
     /* 139034 */   // Label 2067: @139034
     /* 139034 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(139081), // Rule ID 3461 //
     /* 139039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 139057 */     // (ld:{ *:[v32f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 139060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139079 */     GIR_RootConstrainSelectedInstOperands,
     /* 139080 */     // GIR_Coverage, 3461,
     /* 139080 */     GIR_EraseRootFromParent_Done,
     /* 139081 */   // Label 2068: @139081
     /* 139081 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(139128), // Rule ID 3462 //
     /* 139086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 139089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139104 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 139107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139126 */     GIR_RootConstrainSelectedInstOperands,
     /* 139127 */     // GIR_Coverage, 3462,
     /* 139127 */     GIR_EraseRootFromParent_Done,
     /* 139128 */   // Label 2069: @139128
     /* 139128 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(139178), // Rule ID 3463 //
     /* 139133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 139136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139151 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 139154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139176 */     GIR_RootConstrainSelectedInstOperands,
     /* 139177 */     // GIR_Coverage, 3463,
     /* 139177 */     GIR_EraseRootFromParent_Done,
     /* 139178 */   // Label 2070: @139178
     /* 139178 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(139222), // Rule ID 3449 //
     /* 139183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 139198 */     // (ld:{ *:[v32i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 139201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139220 */     GIR_RootConstrainSelectedInstOperands,
     /* 139221 */     // GIR_Coverage, 3449,
     /* 139221 */     GIR_EraseRootFromParent_Done,
     /* 139222 */   // Label 2071: @139222
     /* 139222 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(139269), // Rule ID 3450 //
     /* 139227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 139230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 139245 */     // (ld:{ *:[v32i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 139248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139267 */     GIR_RootConstrainSelectedInstOperands,
     /* 139268 */     // GIR_Coverage, 3450,
     /* 139268 */     GIR_EraseRootFromParent_Done,
     /* 139269 */   // Label 2072: @139269
     /* 139269 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(139316), // Rule ID 3451 //
     /* 139274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 139277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139292 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 139295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139314 */     GIR_RootConstrainSelectedInstOperands,
     /* 139315 */     // GIR_Coverage, 3451,
     /* 139315 */     GIR_EraseRootFromParent_Done,
     /* 139316 */   // Label 2073: @139316
     /* 139316 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(139366), // Rule ID 3452 //
     /* 139321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 139324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139339 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 139342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139364 */     GIR_RootConstrainSelectedInstOperands,
     /* 139365 */     // GIR_Coverage, 3452,
     /* 139365 */     GIR_EraseRootFromParent_Done,
     /* 139366 */   // Label 2074: @139366
     /* 139366 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(139410), // Rule ID 3466 //
     /* 139371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 139386 */     // (ld:{ *:[v32f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 139389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139408 */     GIR_RootConstrainSelectedInstOperands,
     /* 139409 */     // GIR_Coverage, 3466,
     /* 139409 */     GIR_EraseRootFromParent_Done,
     /* 139410 */   // Label 2075: @139410
     /* 139410 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(139457), // Rule ID 3467 //
     /* 139415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 139418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 139433 */     // (ld:{ *:[v32f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 139436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139455 */     GIR_RootConstrainSelectedInstOperands,
     /* 139456 */     // GIR_Coverage, 3467,
     /* 139456 */     GIR_EraseRootFromParent_Done,
     /* 139457 */   // Label 2076: @139457
     /* 139457 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(139504), // Rule ID 3468 //
     /* 139462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 139465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139480 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 139483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139502 */     GIR_RootConstrainSelectedInstOperands,
     /* 139503 */     // GIR_Coverage, 3468,
     /* 139503 */     GIR_EraseRootFromParent_Done,
     /* 139504 */   // Label 2077: @139504
     /* 139504 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(139554), // Rule ID 3469 //
     /* 139509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 139512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139527 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 139530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139552 */     GIR_RootConstrainSelectedInstOperands,
     /* 139553 */     // GIR_Coverage, 3469,
     /* 139553 */     GIR_EraseRootFromParent_Done,
     /* 139554 */   // Label 2078: @139554
     /* 139554 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(139597), // Rule ID 3443 //
     /* 139559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139566 */     // MIs[0] sbase
     /* 139566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 139574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 139578 */     // (ld:{ *:[v32i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 139581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139583 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 139585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139595 */     GIR_RootConstrainSelectedInstOperands,
     /* 139596 */     // GIR_Coverage, 3443,
     /* 139596 */     GIR_EraseRootFromParent_Done,
     /* 139597 */   // Label 2079: @139597
     /* 139597 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(139640), // Rule ID 3460 //
     /* 139602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139609 */     // MIs[0] sbase
     /* 139609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 139617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 139621 */     // (ld:{ *:[v32f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 139624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139626 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 139628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139638 */     GIR_RootConstrainSelectedInstOperands,
     /* 139639 */     // GIR_Coverage, 3460,
     /* 139639 */     GIR_EraseRootFromParent_Done,
     /* 139640 */   // Label 2080: @139640
     /* 139640 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(139679), // Rule ID 3448 //
     /* 139645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139652 */     // MIs[0] sbase
     /* 139652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 139660 */     // (ld:{ *:[v32i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 139663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139665 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 139667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139677 */     GIR_RootConstrainSelectedInstOperands,
     /* 139678 */     // GIR_Coverage, 3448,
     /* 139678 */     GIR_EraseRootFromParent_Done,
     /* 139679 */   // Label 2081: @139679
     /* 139679 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(139718), // Rule ID 3465 //
     /* 139684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139691 */     // MIs[0] sbase
     /* 139691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 139699 */     // (ld:{ *:[v32f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 139702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139704 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 139706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139716 */     GIR_RootConstrainSelectedInstOperands,
     /* 139717 */     // GIR_Coverage, 3465,
     /* 139717 */     GIR_EraseRootFromParent_Done,
     /* 139718 */   // Label 2082: @139718
     /* 139718 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(139754), // Rule ID 3454 //
     /* 139723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139727 */     // MIs[0] sbase
     /* 139727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 139735 */     // (ld:{ *:[v32i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 139738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139740 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 139742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139752 */     GIR_RootConstrainSelectedInstOperands,
     /* 139753 */     // GIR_Coverage, 3454,
     /* 139753 */     GIR_EraseRootFromParent_Done,
     /* 139754 */   // Label 2083: @139754
     /* 139754 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(139790), // Rule ID 3471 //
     /* 139759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 139763 */     // MIs[0] sbase
     /* 139763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 139771 */     // (ld:{ *:[v32f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 139774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139776 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 139778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139788 */     GIR_RootConstrainSelectedInstOperands,
     /* 139789 */     // GIR_Coverage, 3471,
     /* 139789 */     GIR_EraseRootFromParent_Done,
     /* 139790 */   // Label 2084: @139790
     /* 139790 */   GIM_Reject,
     /* 139791 */ // Label 2050: @139791
     /* 139791 */ GIM_Reject,
     /* 139792 */ // Label 895: @139792
     /* 139792 */ GIM_Reject,
     /* 139793 */ // Label 15: @139793
     /* 139793 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 2087*/ GIMT_Encode4(146858),
     /* 139804 */ /*GILLT_s16*//*Label 2085*/ GIMT_Encode4(139812),
     /* 139808 */ /*GILLT_s32*//*Label 2086*/ GIMT_Encode4(142250),
     /* 139812 */ // Label 2085: @139812
     /* 139812 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(139882), // Rule ID 6451 //
     /* 139817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 139820 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139823 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 139830 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 139835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 139839 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139843 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 139850 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 139850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 139853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 139855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 139860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139865 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 139870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139876 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139880 */   GIR_RootConstrainSelectedInstOperands,
     /* 139881 */   // GIR_Coverage, 6451,
     /* 139881 */   GIR_EraseRootFromParent_Done,
     /* 139882 */ // Label 2088: @139882
     /* 139882 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(139952), // Rule ID 6453 //
     /* 139887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 139890 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139893 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 139900 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 139905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 139909 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139913 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 139920 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 139920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 139923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 139925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 139930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 139940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139946 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139950 */   GIR_RootConstrainSelectedInstOperands,
     /* 139951 */   // GIR_Coverage, 6453,
     /* 139951 */   GIR_EraseRootFromParent_Done,
     /* 139952 */ // Label 2089: @139952
     /* 139952 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(140019), // Rule ID 4206 //
     /* 139957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /* 139960 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139963 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 139970 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 139975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 139979 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139983 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 139990 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SVS),
     /* 139993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 139995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 140000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 140005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140013 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140017 */   GIR_RootConstrainSelectedInstOperands,
     /* 140018 */   // GIR_Coverage, 4206,
     /* 140018 */   GIR_EraseRootFromParent_Done,
     /* 140019 */ // Label 2090: @140019
     /* 140019 */ GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(140086), // Rule ID 4221 //
     /* 140024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /* 140027 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140030 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140037 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140046 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140050 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 140057 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SVS),
     /* 140060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 140067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 140072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140084 */   GIR_RootConstrainSelectedInstOperands,
     /* 140085 */   // GIR_Coverage, 4221,
     /* 140085 */   GIR_EraseRootFromParent_Done,
     /* 140086 */ // Label 2091: @140086
     /* 140086 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(140153), // Rule ID 4236 //
     /* 140091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /* 140094 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140097 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140104 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 140113 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140117 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 140124 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_D16_SVS_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_D16_SVS_t16),
     /* 140127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 140134 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 140139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140147 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140151 */   GIR_RootConstrainSelectedInstOperands,
     /* 140152 */   // GIR_Coverage, 4236,
     /* 140152 */   GIR_EraseRootFromParent_Done,
     /* 140153 */ // Label 2092: @140153
     /* 140153 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(140215), // Rule ID 4205 //
     /* 140158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 140161 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140164 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140171 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140184 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 140191 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 140191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SADDR),
     /* 140194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 140201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140213 */   GIR_RootConstrainSelectedInstOperands,
     /* 140214 */   // GIR_Coverage, 4205,
     /* 140214 */   GIR_EraseRootFromParent_Done,
     /* 140215 */ // Label 2093: @140215
     /* 140215 */ GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(140277), // Rule ID 4220 //
     /* 140220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 140223 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140226 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140233 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140242 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140246 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 140253 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 140253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SADDR),
     /* 140256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 140263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140271 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140275 */   GIR_RootConstrainSelectedInstOperands,
     /* 140276 */   // GIR_Coverage, 4220,
     /* 140276 */   GIR_EraseRootFromParent_Done,
     /* 140277 */ // Label 2094: @140277
     /* 140277 */ GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(140339), // Rule ID 4235 //
     /* 140282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 140285 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140295 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 140304 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140308 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 140315 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_D16_SADDR_t16),
     /* 140318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 140325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140333 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140337 */   GIR_RootConstrainSelectedInstOperands,
     /* 140338 */   // GIR_Coverage, 4235,
     /* 140338 */   GIR_EraseRootFromParent_Done,
     /* 140339 */ // Label 2095: @140339
     /* 140339 */ GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(140401), // Rule ID 4204 //
     /* 140344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 140347 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140350 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140357 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140366 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140370 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 140377 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 140377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE),
     /* 140380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 140387 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140395 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140399 */   GIR_RootConstrainSelectedInstOperands,
     /* 140400 */   // GIR_Coverage, 4204,
     /* 140400 */   GIR_EraseRootFromParent_Done,
     /* 140401 */ // Label 2096: @140401
     /* 140401 */ GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(140463), // Rule ID 4219 //
     /* 140406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 140409 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140412 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140419 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140428 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140432 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 140439 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 140439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE),
     /* 140442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 140449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140457 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140461 */   GIR_RootConstrainSelectedInstOperands,
     /* 140462 */   // GIR_Coverage, 4219,
     /* 140462 */   GIR_EraseRootFromParent_Done,
     /* 140463 */ // Label 2097: @140463
     /* 140463 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(140525), // Rule ID 4234 //
     /* 140468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 140471 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140481 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 140490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140494 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 140501 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_D16_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_D16_t16),
     /* 140504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 140506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 140511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140519 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140523 */   GIR_RootConstrainSelectedInstOperands,
     /* 140524 */   // GIR_Coverage, 4234,
     /* 140524 */   GIR_EraseRootFromParent_Done,
     /* 140525 */ // Label 2098: @140525
     /* 140525 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(140600), // Rule ID 6450 //
     /* 140530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 140533 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140543 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140552 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140556 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 140563 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 140563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFEN),
     /* 140566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 140568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 140573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 140578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 140583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 140588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140594 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140598 */   GIR_RootConstrainSelectedInstOperands,
     /* 140599 */   // GIR_Coverage, 6450,
     /* 140599 */   GIR_EraseRootFromParent_Done,
     /* 140600 */ // Label 2099: @140600
     /* 140600 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(140675), // Rule ID 6452 //
     /* 140605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 140608 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140611 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140618 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 140623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140627 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140631 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 140638 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 140638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFEN),
     /* 140641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 140643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 140648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 140653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 140658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 140663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140669 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140673 */   GIR_RootConstrainSelectedInstOperands,
     /* 140674 */   // GIR_Coverage, 6452,
     /* 140674 */   GIR_EraseRootFromParent_Done,
     /* 140675 */ // Label 2100: @140675
     /* 140675 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(140746), // Rule ID 6422 //
     /* 140680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 140683 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140686 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140693 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 140699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140703 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140707 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 140714 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_constant>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 140714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 140717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 140719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 140724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140740 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140744 */   GIR_RootConstrainSelectedInstOperands,
     /* 140745 */   // GIR_Coverage, 6422,
     /* 140745 */   GIR_EraseRootFromParent_Done,
     /* 140746 */ // Label 2101: @140746
     /* 140746 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(140817), // Rule ID 6423 //
     /* 140751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 140754 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140757 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140764 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 140770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140774 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140778 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 140785 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_constant>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 140785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 140788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 140790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 140795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140811 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140815 */   GIR_RootConstrainSelectedInstOperands,
     /* 140816 */   // GIR_Coverage, 6423,
     /* 140816 */   GIR_EraseRootFromParent_Done,
     /* 140817 */ // Label 2102: @140817
     /* 140817 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(140889), // Rule ID 6428 //
     /* 140822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 140825 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140828 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140835 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 140842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140846 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140850 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 140857 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 140857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 140860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 140862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 140867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140883 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140887 */   GIR_RootConstrainSelectedInstOperands,
     /* 140888 */   // GIR_Coverage, 6428,
     /* 140888 */   GIR_EraseRootFromParent_Done,
     /* 140889 */ // Label 2103: @140889
     /* 140889 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(140961), // Rule ID 6429 //
     /* 140894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 140897 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140900 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140907 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 140914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140918 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140922 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 140929 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 140929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 140932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 140934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 140939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140955 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140959 */   GIR_RootConstrainSelectedInstOperands,
     /* 140960 */   // GIR_Coverage, 6429,
     /* 140960 */   GIR_EraseRootFromParent_Done,
     /* 140961 */ // Label 2104: @140961
     /* 140961 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(141023), // Rule ID 7790 //
     /* 140966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 140969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140972 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140979 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 140984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 140988 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140992 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 140999 */   // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi8_glue>><<P:Predicate_sextloadi8_local_m0>>  =>  (DS_READ_I8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 140999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
     /* 141002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141017 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141021 */   GIR_RootConstrainSelectedInstOperands,
     /* 141022 */   // GIR_Coverage, 7790,
     /* 141022 */   GIR_EraseRootFromParent_Done,
     /* 141023 */ // Label 2105: @141023
     /* 141023 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(141085), // Rule ID 7791 //
     /* 141028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 141031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141034 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141041 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141050 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141054 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141061 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 141064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141083 */   GIR_RootConstrainSelectedInstOperands,
     /* 141084 */   // GIR_Coverage, 7791,
     /* 141084 */   GIR_EraseRootFromParent_Done,
     /* 141085 */ // Label 2106: @141085
     /* 141085 */ GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(141147), // Rule ID 7792 //
     /* 141090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 141093 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141096 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141103 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 141112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141123 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_t16),
     /* 141126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141145 */   GIR_RootConstrainSelectedInstOperands,
     /* 141146 */   // GIR_Coverage, 7792,
     /* 141146 */   GIR_EraseRootFromParent_Done,
     /* 141147 */ // Label 2107: @141147
     /* 141147 */ GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(141209), // Rule ID 7805 //
     /* 141152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 141155 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141158 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141165 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141185 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 141188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141207 */   GIR_RootConstrainSelectedInstOperands,
     /* 141208 */   // GIR_Coverage, 7805,
     /* 141208 */   GIR_EraseRootFromParent_Done,
     /* 141209 */ // Label 2108: @141209
     /* 141209 */ GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(141271), // Rule ID 7846 //
     /* 141214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 141217 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141220 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141227 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141236 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141240 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141247 */   // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext_glue>><<P:Predicate_atomic_load_sext_8_glue>><<P:Predicate_atomic_load_sext_8_local_m0>>  =>  (DS_READ_I8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
     /* 141250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141265 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141269 */   GIR_RootConstrainSelectedInstOperands,
     /* 141270 */   // GIR_Coverage, 7846,
     /* 141270 */   GIR_EraseRootFromParent_Done,
     /* 141271 */ // Label 2109: @141271
     /* 141271 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(141333), // Rule ID 7847 //
     /* 141276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 141279 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141282 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141289 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141298 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141302 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141309 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 141312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141327 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141331 */   GIR_RootConstrainSelectedInstOperands,
     /* 141332 */   // GIR_Coverage, 7847,
     /* 141332 */   GIR_EraseRootFromParent_Done,
     /* 141333 */ // Label 2110: @141333
     /* 141333 */ GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(141395), // Rule ID 7848 //
     /* 141338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 141341 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141344 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141351 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141360 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141364 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141371 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 141374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141389 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141393 */   GIR_RootConstrainSelectedInstOperands,
     /* 141394 */   // GIR_Coverage, 7848,
     /* 141394 */   GIR_EraseRootFromParent_Done,
     /* 141395 */ // Label 2111: @141395
     /* 141395 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(141457), // Rule ID 7849 //
     /* 141400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 141403 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141406 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141413 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 141418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 141422 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141426 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 141433 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 141433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_t16),
     /* 141436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 141443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141451 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141455 */   GIR_RootConstrainSelectedInstOperands,
     /* 141456 */   // GIR_Coverage, 7849,
     /* 141456 */   GIR_EraseRootFromParent_Done,
     /* 141457 */ // Label 2112: @141457
     /* 141457 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(141526), // Rule ID 3816 //
     /* 141462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 141465 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141468 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141475 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141486 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 141497 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 141500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 141507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 141512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 141517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141520 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141524 */   GIR_RootConstrainSelectedInstOperands,
     /* 141525 */   // GIR_Coverage, 3816,
     /* 141525 */   GIR_EraseRootFromParent_Done,
     /* 141526 */ // Label 2113: @141526
     /* 141526 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(141595), // Rule ID 3834 //
     /* 141531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 141534 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141537 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141544 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141555 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141559 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 141566 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 141569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 141576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 141581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 141586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141593 */   GIR_RootConstrainSelectedInstOperands,
     /* 141594 */   // GIR_Coverage, 3834,
     /* 141594 */   GIR_EraseRootFromParent_Done,
     /* 141595 */ // Label 2114: @141595
     /* 141595 */ GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(141664), // Rule ID 3846 //
     /* 141600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 141603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141606 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141613 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 141635 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 141638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 141645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 141650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 141655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141658 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141662 */   GIR_RootConstrainSelectedInstOperands,
     /* 141663 */   // GIR_Coverage, 3846,
     /* 141663 */   GIR_EraseRootFromParent_Done,
     /* 141664 */ // Label 2115: @141664
     /* 141664 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(141733), // Rule ID 3856 //
     /* 141669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 141672 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141675 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141682 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 141693 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141697 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 141704 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_D16_SADDR_t16),
     /* 141707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 141714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 141719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 141724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141727 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141731 */   GIR_RootConstrainSelectedInstOperands,
     /* 141732 */   // GIR_Coverage, 3856,
     /* 141732 */   GIR_EraseRootFromParent_Done,
     /* 141733 */ // Label 2116: @141733
     /* 141733 */ GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(141797), // Rule ID 3815 //
     /* 141738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 141741 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141744 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141751 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141762 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141766 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 141773 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 141773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 141776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 141783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141791 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141795 */   GIR_RootConstrainSelectedInstOperands,
     /* 141796 */   // GIR_Coverage, 3815,
     /* 141796 */   GIR_EraseRootFromParent_Done,
     /* 141797 */ // Label 2117: @141797
     /* 141797 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(141861), // Rule ID 3833 //
     /* 141802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 141805 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141808 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141815 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141826 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141830 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 141837 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 141837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 141840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 141847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141855 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141859 */   GIR_RootConstrainSelectedInstOperands,
     /* 141860 */   // GIR_Coverage, 3833,
     /* 141860 */   GIR_EraseRootFromParent_Done,
     /* 141861 */ // Label 2118: @141861
     /* 141861 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(141925), // Rule ID 3845 //
     /* 141866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 141869 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141872 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141879 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 141890 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141894 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 141901 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 141901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 141904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 141911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141919 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141923 */   GIR_RootConstrainSelectedInstOperands,
     /* 141924 */   // GIR_Coverage, 3845,
     /* 141924 */   GIR_EraseRootFromParent_Done,
     /* 141925 */ // Label 2119: @141925
     /* 141925 */ GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(141989), // Rule ID 3855 //
     /* 141930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 141933 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141936 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 141943 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 141950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 141954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141958 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 141965 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_D16_t16),
     /* 141968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 141970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 141975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141987 */   GIR_RootConstrainSelectedInstOperands,
     /* 141988 */   // GIR_Coverage, 3855,
     /* 141988 */   GIR_EraseRootFromParent_Done,
     /* 141989 */ // Label 2120: @141989
     /* 141989 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(142054), // Rule ID 3584 //
     /* 141994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 141997 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 142000 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142007 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 142015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 142019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142023 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 142030 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 142030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 142033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 142035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 142040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142048 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142052 */   GIR_RootConstrainSelectedInstOperands,
     /* 142053 */   // GIR_Coverage, 3584,
     /* 142053 */   GIR_EraseRootFromParent_Done,
     /* 142054 */ // Label 2121: @142054
     /* 142054 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(142119), // Rule ID 3592 //
     /* 142059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /* 142062 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142065 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142072 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 142080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 142084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142088 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 142095 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 142095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 142098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 142100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 142105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142113 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142117 */   GIR_RootConstrainSelectedInstOperands,
     /* 142118 */   // GIR_Coverage, 3592,
     /* 142118 */   GIR_EraseRootFromParent_Done,
     /* 142119 */ // Label 2122: @142119
     /* 142119 */ GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(142184), // Rule ID 3598 //
     /* 142124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /* 142127 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142130 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142137 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 142145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 142149 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142153 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 142160 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 142160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 142163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 142165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 142170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142178 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142182 */   GIR_RootConstrainSelectedInstOperands,
     /* 142183 */   // GIR_Coverage, 3598,
     /* 142183 */   GIR_EraseRootFromParent_Done,
     /* 142184 */ // Label 2123: @142184
     /* 142184 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(142249), // Rule ID 3604 //
     /* 142189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /* 142192 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142195 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142202 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 142210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 142214 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142218 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 142225 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE_D16_t16),
     /* 142228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 142230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 142235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142243 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142247 */   GIR_RootConstrainSelectedInstOperands,
     /* 142248 */   // GIR_Coverage, 3604,
     /* 142248 */   GIR_EraseRootFromParent_Done,
     /* 142249 */ // Label 2124: @142249
     /* 142249 */ GIM_Reject,
     /* 142250 */ // Label 2086: @142250
     /* 142250 */ GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(142316), // Rule ID 2909 //
     /* 142255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142258 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142261 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142272 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142276 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
     /* 142280 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 142287 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_SGPR_IMM),
     /* 142290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 142307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142310 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142314 */   GIR_RootConstrainSelectedInstOperands,
     /* 142315 */   // GIR_Coverage, 2909,
     /* 142315 */   GIR_EraseRootFromParent_Done,
     /* 142316 */ // Label 2125: @142316
     /* 142316 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(142382), // Rule ID 2921 //
     /* 142321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142324 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142327 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 142334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142338 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142342 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
     /* 142346 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 142353 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_SGPR_IMM),
     /* 142356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 142373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142376 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142380 */   GIR_RootConstrainSelectedInstOperands,
     /* 142381 */   // GIR_Coverage, 2921,
     /* 142381 */   GIR_EraseRootFromParent_Done,
     /* 142382 */ // Label 2126: @142382
     /* 142382 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(142443), // Rule ID 2907 //
     /* 142387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142390 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142393 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142404 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142408 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
     /* 142412 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 142419 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_IMM),
     /* 142422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142437 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142441 */   GIR_RootConstrainSelectedInstOperands,
     /* 142442 */   // GIR_Coverage, 2907,
     /* 142442 */   GIR_EraseRootFromParent_Done,
     /* 142443 */ // Label 2127: @142443
     /* 142443 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(142507), // Rule ID 2908 //
     /* 142448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142451 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142454 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142469 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
     /* 142473 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 142480 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 142480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_SGPR_IMM),
     /* 142483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142501 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142505 */   GIR_RootConstrainSelectedInstOperands,
     /* 142506 */   // GIR_Coverage, 2908,
     /* 142506 */   GIR_EraseRootFromParent_Done,
     /* 142507 */ // Label 2128: @142507
     /* 142507 */ GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(142568), // Rule ID 2919 //
     /* 142512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142515 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142518 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 142525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142529 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142533 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
     /* 142537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 142544 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_IMM),
     /* 142547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142562 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142566 */   GIR_RootConstrainSelectedInstOperands,
     /* 142567 */   // GIR_Coverage, 2919,
     /* 142567 */   GIR_EraseRootFromParent_Done,
     /* 142568 */ // Label 2129: @142568
     /* 142568 */ GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(142632), // Rule ID 2920 //
     /* 142573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142576 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142579 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 142586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142594 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
     /* 142598 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 142605 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 142605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_SGPR_IMM),
     /* 142608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142626 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142630 */   GIR_RootConstrainSelectedInstOperands,
     /* 142631 */   // GIR_Coverage, 2920,
     /* 142631 */   GIR_EraseRootFromParent_Done,
     /* 142632 */ // Label 2130: @142632
     /* 142632 */ GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(142685), // Rule ID 2910 //
     /* 142637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142640 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142643 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142654 */   // MIs[0] sbase
     /* 142654 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 142662 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
     /* 142666 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 142666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_IMM),
     /* 142669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142671 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 142673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142679 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142683 */   GIR_RootConstrainSelectedInstOperands,
     /* 142684 */   // GIR_Coverage, 2910,
     /* 142684 */   GIR_EraseRootFromParent_Done,
     /* 142685 */ // Label 2131: @142685
     /* 142685 */ GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(142738), // Rule ID 2922 //
     /* 142690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 142693 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142696 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 142703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 142707 */   // MIs[0] sbase
     /* 142707 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 142715 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
     /* 142719 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 142719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_IMM),
     /* 142722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142724 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 142726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142732 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142736 */   GIR_RootConstrainSelectedInstOperands,
     /* 142737 */   // GIR_Coverage, 2922,
     /* 142737 */   GIR_EraseRootFromParent_Done,
     /* 142738 */ // Label 2132: @142738
     /* 142738 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(142808), // Rule ID 6437 //
     /* 142743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 142746 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142749 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142756 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 142761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 142765 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142769 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 142776 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 142776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 142779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 142781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 142786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 142796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142806 */   GIR_RootConstrainSelectedInstOperands,
     /* 142807 */   // GIR_Coverage, 6437,
     /* 142807 */   GIR_EraseRootFromParent_Done,
     /* 142808 */ // Label 2133: @142808
     /* 142808 */ GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(142878), // Rule ID 6441 //
     /* 142813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 142816 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 142826 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 142831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 142835 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142839 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 142846 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 142846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 142849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 142851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 142856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 142866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142872 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142876 */   GIR_RootConstrainSelectedInstOperands,
     /* 142877 */   // GIR_Coverage, 6441,
     /* 142877 */   GIR_EraseRootFromParent_Done,
     /* 142878 */ // Label 2134: @142878
     /* 142878 */ GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(142948), // Rule ID 6463 //
     /* 142883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 142886 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142889 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 142896 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 142901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 142905 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142909 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 142916 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 142916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
     /* 142919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 142921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 142926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 142936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142942 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142946 */   GIR_RootConstrainSelectedInstOperands,
     /* 142947 */   // GIR_Coverage, 6463,
     /* 142947 */   GIR_EraseRootFromParent_Done,
     /* 142948 */ // Label 2135: @142948
     /* 142948 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(143018), // Rule ID 6465 //
     /* 142953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 142956 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142959 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 142966 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 142971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 142975 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142979 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 142986 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 142986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
     /* 142989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 142991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 142996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 143001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143012 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143016 */   GIR_RootConstrainSelectedInstOperands,
     /* 143017 */   // GIR_Coverage, 6465,
     /* 143017 */   GIR_EraseRootFromParent_Done,
     /* 143018 */ // Label 2136: @143018
     /* 143018 */ GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(143085), // Rule ID 4188 //
     /* 143023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 143026 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143029 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143036 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143045 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143049 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 143056 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 143056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SVS),
     /* 143059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 143066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 143071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143083 */   GIR_RootConstrainSelectedInstOperands,
     /* 143084 */   // GIR_Coverage, 4188,
     /* 143084 */   GIR_EraseRootFromParent_Done,
     /* 143085 */ // Label 2137: @143085
     /* 143085 */ GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(143152), // Rule ID 4197 //
     /* 143090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 143093 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143096 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143103 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 143123 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (SCRATCH_LOAD_SSHORT_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 143123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SSHORT_SVS),
     /* 143126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 143133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 143138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143146 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143150 */   GIR_RootConstrainSelectedInstOperands,
     /* 143151 */   // GIR_Coverage, 4197,
     /* 143151 */   GIR_EraseRootFromParent_Done,
     /* 143152 */ // Label 2138: @143152
     /* 143152 */ GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(143214), // Rule ID 4187 //
     /* 143157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 143160 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143163 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143170 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143179 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143183 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 143190 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 143190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SADDR),
     /* 143193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 143200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143208 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143212 */   GIR_RootConstrainSelectedInstOperands,
     /* 143213 */   // GIR_Coverage, 4187,
     /* 143213 */   GIR_EraseRootFromParent_Done,
     /* 143214 */ // Label 2139: @143214
     /* 143214 */ GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(143276), // Rule ID 4196 //
     /* 143219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 143222 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143225 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143232 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143241 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143245 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 143252 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (SCRATCH_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 143252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SSHORT_SADDR),
     /* 143255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 143262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143274 */   GIR_RootConstrainSelectedInstOperands,
     /* 143275 */   // GIR_Coverage, 4196,
     /* 143275 */   GIR_EraseRootFromParent_Done,
     /* 143276 */ // Label 2140: @143276
     /* 143276 */ GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(143338), // Rule ID 4186 //
     /* 143281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 143284 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143287 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143294 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143303 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143307 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 143314 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 143314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE),
     /* 143317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 143324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143336 */   GIR_RootConstrainSelectedInstOperands,
     /* 143337 */   // GIR_Coverage, 4186,
     /* 143337 */   GIR_EraseRootFromParent_Done,
     /* 143338 */ // Label 2141: @143338
     /* 143338 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(143400), // Rule ID 4195 //
     /* 143343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 143346 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143349 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143356 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143369 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 143376 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (SCRATCH_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 143376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SSHORT),
     /* 143379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 143386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143398 */   GIR_RootConstrainSelectedInstOperands,
     /* 143399 */   // GIR_Coverage, 4195,
     /* 143399 */   GIR_EraseRootFromParent_Done,
     /* 143400 */ // Label 2142: @143400
     /* 143400 */ GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(143477), // Rule ID 4467 //
     /* 143405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 143408 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143411 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143418 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 143425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 143440 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 143440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
     /* 143443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 143450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 143460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 143465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143475 */   GIR_RootConstrainSelectedInstOperands,
     /* 143476 */   // GIR_Coverage, 4467,
     /* 143476 */   GIR_EraseRootFromParent_Done,
     /* 143477 */ // Label 2143: @143477
     /* 143477 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(143551), // Rule ID 4469 //
     /* 143482 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143485 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143492 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 143499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143503 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143507 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 143514 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 143514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_ADDR64),
     /* 143517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 143524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 143534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 143539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143545 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143549 */   GIR_RootConstrainSelectedInstOperands,
     /* 143550 */   // GIR_Coverage, 4469,
     /* 143550 */   GIR_EraseRootFromParent_Done,
     /* 143551 */ // Label 2144: @143551
     /* 143551 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(143628), // Rule ID 4471 //
     /* 143556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 143559 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 143562 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143569 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 143576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143580 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143584 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 143591 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 143591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
     /* 143594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 143601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 143611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 143616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143622 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143626 */   GIR_RootConstrainSelectedInstOperands,
     /* 143627 */   // GIR_Coverage, 4471,
     /* 143627 */   GIR_EraseRootFromParent_Done,
     /* 143628 */ // Label 2145: @143628
     /* 143628 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(143702), // Rule ID 4473 //
     /* 143633 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 143636 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143643 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 143650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143654 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143658 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 143665 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 143665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_ADDR64),
     /* 143668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 143675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 143685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 143690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143696 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143700 */   GIR_RootConstrainSelectedInstOperands,
     /* 143701 */   // GIR_Coverage, 4473,
     /* 143701 */   GIR_EraseRootFromParent_Done,
     /* 143702 */ // Label 2146: @143702
     /* 143702 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(143779), // Rule ID 4475 //
     /* 143707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 143710 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 143713 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143720 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 143727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143731 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 143742 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 143742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
     /* 143745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 143752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 143762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 143767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143773 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143777 */   GIR_RootConstrainSelectedInstOperands,
     /* 143778 */   // GIR_Coverage, 4475,
     /* 143778 */   GIR_EraseRootFromParent_Done,
     /* 143779 */ // Label 2147: @143779
     /* 143779 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(143853), // Rule ID 4477 //
     /* 143784 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 143787 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143794 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 143801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143805 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143809 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 143816 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 143816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_ADDR64),
     /* 143819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 143826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 143836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 143841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143847 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143851 */   GIR_RootConstrainSelectedInstOperands,
     /* 143852 */   // GIR_Coverage, 4477,
     /* 143852 */   GIR_EraseRootFromParent_Done,
     /* 143853 */ // Label 2148: @143853
     /* 143853 */ GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(143930), // Rule ID 4487 //
     /* 143858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 143861 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143864 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143871 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 143878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143882 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143886 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 143893 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 143893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_ADDR64),
     /* 143896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 143903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 143913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 143918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143924 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143928 */   GIR_RootConstrainSelectedInstOperands,
     /* 143929 */   // GIR_Coverage, 4487,
     /* 143929 */   GIR_EraseRootFromParent_Done,
     /* 143930 */ // Label 2149: @143930
     /* 143930 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(144004), // Rule ID 4489 //
     /* 143935 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143938 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143945 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 143952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143956 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143960 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 143967 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 143967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_ADDR64),
     /* 143970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 143977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 143987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 143992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143998 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144002 */   GIR_RootConstrainSelectedInstOperands,
     /* 144003 */   // GIR_Coverage, 4489,
     /* 144003 */   GIR_EraseRootFromParent_Done,
     /* 144004 */ // Label 2150: @144004
     /* 144004 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(144081), // Rule ID 4491 //
     /* 144009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 144012 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 144015 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144022 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144033 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144037 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 144044 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_ADDR64),
     /* 144047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144075 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144079 */   GIR_RootConstrainSelectedInstOperands,
     /* 144080 */   // GIR_Coverage, 4491,
     /* 144080 */   GIR_EraseRootFromParent_Done,
     /* 144081 */ // Label 2151: @144081
     /* 144081 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(144155), // Rule ID 4493 //
     /* 144086 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 144089 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144096 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144107 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144111 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 144118 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_ADDR64),
     /* 144121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144149 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144153 */   GIR_RootConstrainSelectedInstOperands,
     /* 144154 */   // GIR_Coverage, 4493,
     /* 144154 */   GIR_EraseRootFromParent_Done,
     /* 144155 */ // Label 2152: @144155
     /* 144155 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(144231), // Rule ID 6414 //
     /* 144160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 144163 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144166 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144173 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 144194 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_constant>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 144194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
     /* 144197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144229 */   GIR_RootConstrainSelectedInstOperands,
     /* 144230 */   // GIR_Coverage, 6414,
     /* 144230 */   GIR_EraseRootFromParent_Done,
     /* 144231 */ // Label 2153: @144231
     /* 144231 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(144307), // Rule ID 6417 //
     /* 144236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 144239 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144242 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144249 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144263 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 144270 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_constant>>  =>  (BUFFER_LOAD_SSHORT_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 144270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_ADDR64),
     /* 144273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144301 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144305 */   GIR_RootConstrainSelectedInstOperands,
     /* 144306 */   // GIR_Coverage, 6417,
     /* 144306 */   GIR_EraseRootFromParent_Done,
     /* 144307 */ // Label 2154: @144307
     /* 144307 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(144382), // Rule ID 6436 //
     /* 144312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 144315 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144318 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144325 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144334 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144338 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 144345 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 144345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFEN),
     /* 144348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144376 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144380 */   GIR_RootConstrainSelectedInstOperands,
     /* 144381 */   // GIR_Coverage, 6436,
     /* 144381 */   GIR_EraseRootFromParent_Done,
     /* 144382 */ // Label 2155: @144382
     /* 144382 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(144457), // Rule ID 6440 //
     /* 144387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 144390 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144393 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144400 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144409 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144413 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 144420 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 144420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFEN),
     /* 144423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144451 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144455 */   GIR_RootConstrainSelectedInstOperands,
     /* 144456 */   // GIR_Coverage, 6440,
     /* 144456 */   GIR_EraseRootFromParent_Done,
     /* 144457 */ // Label 2156: @144457
     /* 144457 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(144532), // Rule ID 6462 //
     /* 144462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 144465 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144468 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144475 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144484 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144488 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 144495 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 144495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFEN),
     /* 144498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144505 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144510 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144526 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144530 */   GIR_RootConstrainSelectedInstOperands,
     /* 144531 */   // GIR_Coverage, 6462,
     /* 144531 */   GIR_EraseRootFromParent_Done,
     /* 144532 */ // Label 2157: @144532
     /* 144532 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(144607), // Rule ID 6464 //
     /* 144537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 144540 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144543 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144550 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144559 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144563 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 144570 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 144570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFEN),
     /* 144573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144601 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144605 */   GIR_RootConstrainSelectedInstOperands,
     /* 144606 */   // GIR_Coverage, 6464,
     /* 144606 */   GIR_EraseRootFromParent_Done,
     /* 144607 */ // Label 2158: @144607
     /* 144607 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(144679), // Rule ID 4466 //
     /* 144612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 144615 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144618 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144625 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144640 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 144647 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 144650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 144662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 144667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144673 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144677 */   GIR_RootConstrainSelectedInstOperands,
     /* 144678 */   // GIR_Coverage, 4466,
     /* 144678 */   GIR_EraseRootFromParent_Done,
     /* 144679 */ // Label 2159: @144679
     /* 144679 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(144748), // Rule ID 4468 //
     /* 144684 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144687 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144694 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144705 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144709 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 144716 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 144719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 144731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 144736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144742 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144746 */   GIR_RootConstrainSelectedInstOperands,
     /* 144747 */   // GIR_Coverage, 4468,
     /* 144747 */   GIR_EraseRootFromParent_Done,
     /* 144748 */ // Label 2160: @144748
     /* 144748 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(144820), // Rule ID 4470 //
     /* 144753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 144756 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 144759 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144766 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144777 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144781 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 144788 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 144791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 144803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 144808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144814 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144818 */   GIR_RootConstrainSelectedInstOperands,
     /* 144819 */   // GIR_Coverage, 4470,
     /* 144819 */   GIR_EraseRootFromParent_Done,
     /* 144820 */ // Label 2161: @144820
     /* 144820 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(144889), // Rule ID 4472 //
     /* 144825 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 144828 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144835 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144846 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144850 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 144857 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 144860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 144872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 144877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144883 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144887 */   GIR_RootConstrainSelectedInstOperands,
     /* 144888 */   // GIR_Coverage, 4472,
     /* 144888 */   GIR_EraseRootFromParent_Done,
     /* 144889 */ // Label 2162: @144889
     /* 144889 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(144961), // Rule ID 4474 //
     /* 144894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 144897 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 144900 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144907 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144918 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144922 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 144929 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 144932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 144944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 144949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144955 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144959 */   GIR_RootConstrainSelectedInstOperands,
     /* 144960 */   // GIR_Coverage, 4474,
     /* 144960 */   GIR_EraseRootFromParent_Done,
     /* 144961 */ // Label 2163: @144961
     /* 144961 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(145030), // Rule ID 4476 //
     /* 144966 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 144969 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144976 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144987 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144991 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 144998 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 144998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 145001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 145003 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 145008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 145013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145024 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145028 */   GIR_RootConstrainSelectedInstOperands,
     /* 145029 */   // GIR_Coverage, 4476,
     /* 145029 */   GIR_EraseRootFromParent_Done,
     /* 145030 */ // Label 2164: @145030
     /* 145030 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(145102), // Rule ID 4486 //
     /* 145035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 145038 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145041 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145048 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145059 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145063 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 145070 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 145070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
     /* 145073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 145075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 145080 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 145085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145096 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145100 */   GIR_RootConstrainSelectedInstOperands,
     /* 145101 */   // GIR_Coverage, 4486,
     /* 145101 */   GIR_EraseRootFromParent_Done,
     /* 145102 */ // Label 2165: @145102
     /* 145102 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(145171), // Rule ID 4488 //
     /* 145107 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145110 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145117 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145128 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145132 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 145139 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 145139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
     /* 145142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 145144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 145149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 145154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145165 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145169 */   GIR_RootConstrainSelectedInstOperands,
     /* 145170 */   // GIR_Coverage, 4488,
     /* 145170 */   GIR_EraseRootFromParent_Done,
     /* 145171 */ // Label 2166: @145171
     /* 145171 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(145243), // Rule ID 4490 //
     /* 145176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 145179 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145182 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145189 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145200 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145204 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 145211 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 145211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
     /* 145214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 145216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 145221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 145226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145237 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145241 */   GIR_RootConstrainSelectedInstOperands,
     /* 145242 */   // GIR_Coverage, 4490,
     /* 145242 */   GIR_EraseRootFromParent_Done,
     /* 145243 */ // Label 2167: @145243
     /* 145243 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(145312), // Rule ID 4492 //
     /* 145248 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145251 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145258 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145269 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145273 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 145280 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 145280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
     /* 145283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 145285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 145290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 145295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145306 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145310 */   GIR_RootConstrainSelectedInstOperands,
     /* 145311 */   // GIR_Coverage, 4492,
     /* 145311 */   GIR_EraseRootFromParent_Done,
     /* 145312 */ // Label 2168: @145312
     /* 145312 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(145374), // Rule ID 7788 //
     /* 145317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 145320 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145330 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145339 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145343 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145350 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi8_glue>><<P:Predicate_sextloadi8_local_m0>>  =>  (DS_READ_I8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
     /* 145353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145368 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145372 */   GIR_RootConstrainSelectedInstOperands,
     /* 145373 */   // GIR_Coverage, 7788,
     /* 145373 */   GIR_EraseRootFromParent_Done,
     /* 145374 */ // Label 2169: @145374
     /* 145374 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(145436), // Rule ID 7789 //
     /* 145379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 145382 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145385 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145392 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145401 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145405 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145412 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 145415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145434 */   GIR_RootConstrainSelectedInstOperands,
     /* 145435 */   // GIR_Coverage, 7789,
     /* 145435 */   GIR_EraseRootFromParent_Done,
     /* 145436 */ // Label 2170: @145436
     /* 145436 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(145498), // Rule ID 7797 //
     /* 145441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 145444 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145447 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145454 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145474 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi16_glue>><<P:Predicate_sextloadi16_local_m0>>  =>  (DS_READ_I16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16),
     /* 145477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145496 */   GIR_RootConstrainSelectedInstOperands,
     /* 145497 */   // GIR_Coverage, 7797,
     /* 145497 */   GIR_EraseRootFromParent_Done,
     /* 145498 */ // Label 2171: @145498
     /* 145498 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(145560), // Rule ID 7798 //
     /* 145503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 145506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145509 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145516 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145525 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145529 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145536 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_local>>  =>  (DS_READ_I16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16_gfx9),
     /* 145539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145558 */   GIR_RootConstrainSelectedInstOperands,
     /* 145559 */   // GIR_Coverage, 7798,
     /* 145559 */   GIR_EraseRootFromParent_Done,
     /* 145560 */ // Label 2172: @145560
     /* 145560 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(145622), // Rule ID 7799 //
     /* 145565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 145568 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145571 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145578 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145587 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145591 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145598 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi16_glue>><<P:Predicate_sextloadi16_local_m0>>  =>  (DS_READ_I16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16),
     /* 145601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145616 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145620 */   GIR_RootConstrainSelectedInstOperands,
     /* 145621 */   // GIR_Coverage, 7799,
     /* 145621 */   GIR_EraseRootFromParent_Done,
     /* 145622 */ // Label 2173: @145622
     /* 145622 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(145684), // Rule ID 7800 //
     /* 145627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 145630 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145633 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145640 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145649 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145653 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145660 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_local>>  =>  (DS_READ_I16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16_gfx9),
     /* 145663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145665 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145682 */   GIR_RootConstrainSelectedInstOperands,
     /* 145683 */   // GIR_Coverage, 7800,
     /* 145683 */   GIR_EraseRootFromParent_Done,
     /* 145684 */ // Label 2174: @145684
     /* 145684 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(145746), // Rule ID 7850 //
     /* 145689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 145692 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145695 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145702 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145711 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145722 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext_glue>><<P:Predicate_atomic_load_sext_8_glue>><<P:Predicate_atomic_load_sext_8_local_m0>>  =>  (DS_READ_I8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
     /* 145725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145740 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145744 */   GIR_RootConstrainSelectedInstOperands,
     /* 145745 */   // GIR_Coverage, 7850,
     /* 145745 */   GIR_EraseRootFromParent_Done,
     /* 145746 */ // Label 2175: @145746
     /* 145746 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(145808), // Rule ID 7851 //
     /* 145751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 145754 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145757 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145764 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145773 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145777 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145784 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 145787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145806 */   GIR_RootConstrainSelectedInstOperands,
     /* 145807 */   // GIR_Coverage, 7851,
     /* 145807 */   GIR_EraseRootFromParent_Done,
     /* 145808 */ // Label 2176: @145808
     /* 145808 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(145870), // Rule ID 7860 //
     /* 145813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 145816 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145826 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145835 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145839 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145846 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext_glue>><<P:Predicate_atomic_load_sext_16_glue>><<P:Predicate_atomic_load_sext_16_local_m0>>  =>  (DS_READ_I16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16),
     /* 145849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145868 */   GIR_RootConstrainSelectedInstOperands,
     /* 145869 */   // GIR_Coverage, 7860,
     /* 145869 */   GIR_EraseRootFromParent_Done,
     /* 145870 */ // Label 2177: @145870
     /* 145870 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(145932), // Rule ID 7861 //
     /* 145875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 145878 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145881 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145888 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145897 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145901 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145908 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_local>>  =>  (DS_READ_I16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16_gfx9),
     /* 145911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145926 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145930 */   GIR_RootConstrainSelectedInstOperands,
     /* 145931 */   // GIR_Coverage, 7861,
     /* 145931 */   GIR_EraseRootFromParent_Done,
     /* 145932 */ // Label 2178: @145932
     /* 145932 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(146001), // Rule ID 3814 //
     /* 145937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 145940 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145943 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145950 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145961 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145965 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 145972 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 145972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 145975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 145982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 145987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145995 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145999 */   GIR_RootConstrainSelectedInstOperands,
     /* 146000 */   // GIR_Coverage, 3814,
     /* 146000 */   GIR_EraseRootFromParent_Done,
     /* 146001 */ // Label 2179: @146001
     /* 146001 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(146070), // Rule ID 3822 //
     /* 146006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 146009 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146012 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146019 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146030 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146034 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 146041 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 146044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 146051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 146056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146068 */   GIR_RootConstrainSelectedInstOperands,
     /* 146069 */   // GIR_Coverage, 3822,
     /* 146069 */   GIR_EraseRootFromParent_Done,
     /* 146070 */ // Label 2180: @146070
     /* 146070 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(146139), // Rule ID 3828 //
     /* 146075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 146078 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146081 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146088 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146103 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 146110 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (GLOBAL_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT_SADDR),
     /* 146113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 146120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 146125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146133 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146137 */   GIR_RootConstrainSelectedInstOperands,
     /* 146138 */   // GIR_Coverage, 3828,
     /* 146138 */   GIR_EraseRootFromParent_Done,
     /* 146139 */ // Label 2181: @146139
     /* 146139 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(146208), // Rule ID 3836 //
     /* 146144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 146147 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146150 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146157 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146168 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146172 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 146179 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT_SADDR),
     /* 146182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 146189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 146194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146202 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146206 */   GIR_RootConstrainSelectedInstOperands,
     /* 146207 */   // GIR_Coverage, 3836,
     /* 146207 */   GIR_EraseRootFromParent_Done,
     /* 146208 */ // Label 2182: @146208
     /* 146208 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(146277), // Rule ID 3848 //
     /* 146213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 146216 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146219 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146226 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 146248 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT_SADDR),
     /* 146251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 146258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 146263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146271 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146275 */   GIR_RootConstrainSelectedInstOperands,
     /* 146276 */   // GIR_Coverage, 3848,
     /* 146276 */   GIR_EraseRootFromParent_Done,
     /* 146277 */ // Label 2183: @146277
     /* 146277 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(146341), // Rule ID 3813 //
     /* 146282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 146285 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146295 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146306 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146310 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 146317 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 146320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146335 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146339 */   GIR_RootConstrainSelectedInstOperands,
     /* 146340 */   // GIR_Coverage, 3813,
     /* 146340 */   GIR_EraseRootFromParent_Done,
     /* 146341 */ // Label 2184: @146341
     /* 146341 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(146405), // Rule ID 3821 //
     /* 146346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 146349 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146352 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146359 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146370 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146374 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 146381 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 146384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146399 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146403 */   GIR_RootConstrainSelectedInstOperands,
     /* 146404 */   // GIR_Coverage, 3821,
     /* 146404 */   GIR_EraseRootFromParent_Done,
     /* 146405 */ // Label 2185: @146405
     /* 146405 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(146469), // Rule ID 3827 //
     /* 146410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 146413 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146416 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146423 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146434 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146438 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 146445 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (GLOBAL_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT),
     /* 146448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146463 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146467 */   GIR_RootConstrainSelectedInstOperands,
     /* 146468 */   // GIR_Coverage, 3827,
     /* 146468 */   GIR_EraseRootFromParent_Done,
     /* 146469 */ // Label 2186: @146469
     /* 146469 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(146533), // Rule ID 3835 //
     /* 146474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 146477 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146480 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146487 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146498 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146502 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 146509 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT),
     /* 146512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146527 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146531 */   GIR_RootConstrainSelectedInstOperands,
     /* 146532 */   // GIR_Coverage, 3835,
     /* 146532 */   GIR_EraseRootFromParent_Done,
     /* 146533 */ // Label 2187: @146533
     /* 146533 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(146597), // Rule ID 3847 //
     /* 146538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 146541 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146544 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146551 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146562 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146566 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 146573 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT),
     /* 146576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146591 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146595 */   GIR_RootConstrainSelectedInstOperands,
     /* 146596 */   // GIR_Coverage, 3847,
     /* 146596 */   GIR_EraseRootFromParent_Done,
     /* 146597 */ // Label 2188: @146597
     /* 146597 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(146662), // Rule ID 3582 //
     /* 146602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 146605 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146608 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146615 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146627 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146631 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 146638 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 146641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146656 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146660 */   GIR_RootConstrainSelectedInstOperands,
     /* 146661 */   // GIR_Coverage, 3582,
     /* 146661 */   GIR_EraseRootFromParent_Done,
     /* 146662 */ // Label 2189: @146662
     /* 146662 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(146727), // Rule ID 3583 //
     /* 146667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 146670 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146673 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146680 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146696 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 146703 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 146706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146725 */   GIR_RootConstrainSelectedInstOperands,
     /* 146726 */   // GIR_Coverage, 3583,
     /* 146726 */   GIR_EraseRootFromParent_Done,
     /* 146727 */ // Label 2190: @146727
     /* 146727 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(146792), // Rule ID 3587 //
     /* 146732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 146735 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146738 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146745 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 146768 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_flat>>  =>  (FLAT_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SSHORT),
     /* 146771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146790 */   GIR_RootConstrainSelectedInstOperands,
     /* 146791 */   // GIR_Coverage, 3587,
     /* 146791 */   GIR_EraseRootFromParent_Done,
     /* 146792 */ // Label 2191: @146792
     /* 146792 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(146857), // Rule ID 3588 //
     /* 146797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 146800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 146803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146810 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 146818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146822 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146826 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 146833 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_flat>>  =>  (FLAT_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 146833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SSHORT),
     /* 146836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146851 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146855 */   GIR_RootConstrainSelectedInstOperands,
     /* 146856 */   // GIR_Coverage, 3588,
     /* 146856 */   GIR_EraseRootFromParent_Done,
     /* 146857 */ // Label 2192: @146857
     /* 146857 */ GIM_Reject,
     /* 146858 */ // Label 2087: @146858
     /* 146858 */ GIM_Reject,
     /* 146859 */ // Label 16: @146859
     /* 146859 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 2195*/ GIMT_Encode4(153839),
     /* 146870 */ /*GILLT_s16*//*Label 2193*/ GIMT_Encode4(146878),
     /* 146874 */ /*GILLT_s32*//*Label 2194*/ GIMT_Encode4(149514),
     /* 146878 */ // Label 2193: @146878
     /* 146878 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(146948), // Rule ID 6459 //
     /* 146883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 146886 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146889 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146896 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 146901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146905 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146909 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 146916 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 146916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 146919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 146921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 146926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 146931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146942 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146946 */   GIR_RootConstrainSelectedInstOperands,
     /* 146947 */   // GIR_Coverage, 6459,
     /* 146947 */   GIR_EraseRootFromParent_Done,
     /* 146948 */ // Label 2196: @146948
     /* 146948 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(147018), // Rule ID 6461 //
     /* 146953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 146956 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146959 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146966 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 146971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146975 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146979 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 146986 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 146986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 146989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 146991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 146996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 147001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 147006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147012 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147016 */   GIR_RootConstrainSelectedInstOperands,
     /* 147017 */   // GIR_Coverage, 6461,
     /* 147017 */   GIR_EraseRootFromParent_Done,
     /* 147018 */ // Label 2197: @147018
     /* 147018 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(147085), // Rule ID 4203 //
     /* 147023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /* 147026 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147029 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147036 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147045 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147049 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 147056 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 147056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /* 147059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 147071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 147076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147083 */   GIR_RootConstrainSelectedInstOperands,
     /* 147084 */   // GIR_Coverage, 4203,
     /* 147084 */   GIR_EraseRootFromParent_Done,
     /* 147085 */ // Label 2198: @147085
     /* 147085 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(147152), // Rule ID 4218 //
     /* 147090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /* 147093 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147096 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147103 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 147123 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 147123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /* 147126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 147138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 147143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147146 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147150 */   GIR_RootConstrainSelectedInstOperands,
     /* 147151 */   // GIR_Coverage, 4218,
     /* 147151 */   GIR_EraseRootFromParent_Done,
     /* 147152 */ // Label 2199: @147152
     /* 147152 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(147219), // Rule ID 4233 //
     /* 147157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /* 147160 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147163 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147170 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 147179 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147183 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 147190 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_SVS_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 147190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_SVS_t16),
     /* 147193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 147205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 147210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147217 */   GIR_RootConstrainSelectedInstOperands,
     /* 147218 */   // GIR_Coverage, 4233,
     /* 147218 */   GIR_EraseRootFromParent_Done,
     /* 147219 */ // Label 2200: @147219
     /* 147219 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(147281), // Rule ID 4202 //
     /* 147224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 147227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147230 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147237 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147246 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147250 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 147257 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 147257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /* 147260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 147267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147275 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147279 */   GIR_RootConstrainSelectedInstOperands,
     /* 147280 */   // GIR_Coverage, 4202,
     /* 147280 */   GIR_EraseRootFromParent_Done,
     /* 147281 */ // Label 2201: @147281
     /* 147281 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(147343), // Rule ID 4217 //
     /* 147286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 147289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147292 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147299 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147308 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147312 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 147319 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 147319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /* 147322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 147329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147337 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147341 */   GIR_RootConstrainSelectedInstOperands,
     /* 147342 */   // GIR_Coverage, 4217,
     /* 147342 */   GIR_EraseRootFromParent_Done,
     /* 147343 */ // Label 2202: @147343
     /* 147343 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(147405), // Rule ID 4232 //
     /* 147348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 147351 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147354 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147361 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 147370 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147374 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 147381 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 147381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_SADDR_t16),
     /* 147384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 147391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147399 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147403 */   GIR_RootConstrainSelectedInstOperands,
     /* 147404 */   // GIR_Coverage, 4232,
     /* 147404 */   GIR_EraseRootFromParent_Done,
     /* 147405 */ // Label 2203: @147405
     /* 147405 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(147467), // Rule ID 4201 //
     /* 147410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 147413 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147416 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147423 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147436 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 147443 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 147443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /* 147446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147465 */   GIR_RootConstrainSelectedInstOperands,
     /* 147466 */   // GIR_Coverage, 4201,
     /* 147466 */   GIR_EraseRootFromParent_Done,
     /* 147467 */ // Label 2204: @147467
     /* 147467 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(147529), // Rule ID 4216 //
     /* 147472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 147475 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147478 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147485 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147494 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147498 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 147505 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 147505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /* 147508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147510 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147523 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147527 */   GIR_RootConstrainSelectedInstOperands,
     /* 147528 */   // GIR_Coverage, 4216,
     /* 147528 */   GIR_EraseRootFromParent_Done,
     /* 147529 */ // Label 2205: @147529
     /* 147529 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(147591), // Rule ID 4231 //
     /* 147534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 147537 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147540 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147547 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 147556 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147560 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 147567 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 147567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_t16),
     /* 147570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147585 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147589 */   GIR_RootConstrainSelectedInstOperands,
     /* 147590 */   // GIR_Coverage, 4231,
     /* 147590 */   GIR_EraseRootFromParent_Done,
     /* 147591 */ // Label 2206: @147591
     /* 147591 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(147666), // Rule ID 6458 //
     /* 147596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 147599 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147602 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147609 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147618 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 147629 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 147629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /* 147632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147664 */   GIR_RootConstrainSelectedInstOperands,
     /* 147665 */   // GIR_Coverage, 6458,
     /* 147665 */   GIR_EraseRootFromParent_Done,
     /* 147666 */ // Label 2207: @147666
     /* 147666 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(147741), // Rule ID 6460 //
     /* 147671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 147674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147677 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147684 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147693 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147697 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 147704 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 147704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /* 147707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147735 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147739 */   GIR_RootConstrainSelectedInstOperands,
     /* 147740 */   // GIR_Coverage, 6460,
     /* 147740 */   GIR_EraseRootFromParent_Done,
     /* 147741 */ // Label 2208: @147741
     /* 147741 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(147812), // Rule ID 6426 //
     /* 147746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 147749 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147752 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147759 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147769 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147773 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 147780 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 147780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 147783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 147795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 147800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147806 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147810 */   GIR_RootConstrainSelectedInstOperands,
     /* 147811 */   // GIR_Coverage, 6426,
     /* 147811 */   GIR_EraseRootFromParent_Done,
     /* 147812 */ // Label 2209: @147812
     /* 147812 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(147883), // Rule ID 6427 //
     /* 147817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 147820 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147823 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147830 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147840 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147844 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 147851 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 147851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 147854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 147866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 147871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147881 */   GIR_RootConstrainSelectedInstOperands,
     /* 147882 */   // GIR_Coverage, 6427,
     /* 147882 */   GIR_EraseRootFromParent_Done,
     /* 147883 */ // Label 2210: @147883
     /* 147883 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(147955), // Rule ID 6432 //
     /* 147888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 147891 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147894 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147901 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147912 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147916 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 147923 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 147923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 147926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 147938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 147943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147953 */   GIR_RootConstrainSelectedInstOperands,
     /* 147954 */   // GIR_Coverage, 6432,
     /* 147954 */   GIR_EraseRootFromParent_Done,
     /* 147955 */ // Label 2211: @147955
     /* 147955 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(148027), // Rule ID 6433 //
     /* 147960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 147963 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147966 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147973 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147984 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147988 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 147995 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 147995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 147998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 148010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148025 */   GIR_RootConstrainSelectedInstOperands,
     /* 148026 */   // GIR_Coverage, 6433,
     /* 148026 */   GIR_EraseRootFromParent_Done,
     /* 148027 */ // Label 2212: @148027
     /* 148027 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(148089), // Rule ID 7810 //
     /* 148032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 148035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148038 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148045 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148054 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148058 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148065 */   // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_zextload_glue>><<P:Predicate_zextloadi8_glue>><<P:Predicate_zextloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 148068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148083 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148087 */   GIR_RootConstrainSelectedInstOperands,
     /* 148088 */   // GIR_Coverage, 7810,
     /* 148088 */   GIR_EraseRootFromParent_Done,
     /* 148089 */ // Label 2213: @148089
     /* 148089 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(148151), // Rule ID 7811 //
     /* 148094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 148097 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148100 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148107 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148116 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148120 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148127 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 148130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148149 */   GIR_RootConstrainSelectedInstOperands,
     /* 148150 */   // GIR_Coverage, 7811,
     /* 148150 */   GIR_EraseRootFromParent_Done,
     /* 148151 */ // Label 2214: @148151
     /* 148151 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(148213), // Rule ID 7812 //
     /* 148156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 148159 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148162 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148169 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148178 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148182 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148189 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 148192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148207 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148211 */   GIR_RootConstrainSelectedInstOperands,
     /* 148212 */   // GIR_Coverage, 7812,
     /* 148212 */   GIR_EraseRootFromParent_Done,
     /* 148213 */ // Label 2215: @148213
     /* 148213 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(148275), // Rule ID 7813 //
     /* 148218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 148221 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148224 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148231 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 148240 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148251 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_t16),
     /* 148254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148273 */   GIR_RootConstrainSelectedInstOperands,
     /* 148274 */   // GIR_Coverage, 7813,
     /* 148274 */   GIR_EraseRootFromParent_Done,
     /* 148275 */ // Label 2216: @148275
     /* 148275 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(148337), // Rule ID 7840 //
     /* 148280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 148283 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148286 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148293 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148302 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148306 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148313 */   // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext_glue>><<P:Predicate_atomic_load_zext_8_glue>><<P:Predicate_atomic_load_zext_8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 148316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148331 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148335 */   GIR_RootConstrainSelectedInstOperands,
     /* 148336 */   // GIR_Coverage, 7840,
     /* 148336 */   GIR_EraseRootFromParent_Done,
     /* 148337 */ // Label 2217: @148337
     /* 148337 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(148399), // Rule ID 7841 //
     /* 148342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 148345 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148348 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148355 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148368 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148375 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 148378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148393 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148397 */   GIR_RootConstrainSelectedInstOperands,
     /* 148398 */   // GIR_Coverage, 7841,
     /* 148398 */   GIR_EraseRootFromParent_Done,
     /* 148399 */ // Label 2218: @148399
     /* 148399 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(148461), // Rule ID 7842 //
     /* 148404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 148407 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148410 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148417 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148430 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148437 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 148440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148442 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148447 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148455 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148459 */   GIR_RootConstrainSelectedInstOperands,
     /* 148460 */   // GIR_Coverage, 7842,
     /* 148460 */   GIR_EraseRootFromParent_Done,
     /* 148461 */ // Label 2219: @148461
     /* 148461 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(148523), // Rule ID 7843 //
     /* 148466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 148469 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148472 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148479 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 148484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 148488 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148492 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 148499 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 148499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_t16),
     /* 148502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 148509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148517 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148521 */   GIR_RootConstrainSelectedInstOperands,
     /* 148522 */   // GIR_Coverage, 7843,
     /* 148522 */   GIR_EraseRootFromParent_Done,
     /* 148523 */ // Label 2220: @148523
     /* 148523 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(148592), // Rule ID 3804 //
     /* 148528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 148531 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148534 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148541 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148552 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148556 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 148563 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 148563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 148566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 148573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 148578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148586 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148590 */   GIR_RootConstrainSelectedInstOperands,
     /* 148591 */   // GIR_Coverage, 3804,
     /* 148591 */   GIR_EraseRootFromParent_Done,
     /* 148592 */ // Label 2221: @148592
     /* 148592 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(148661), // Rule ID 3812 //
     /* 148597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 148600 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148603 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148610 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148625 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 148632 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 148632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 148635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 148642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 148647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148655 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148659 */   GIR_RootConstrainSelectedInstOperands,
     /* 148660 */   // GIR_Coverage, 3812,
     /* 148660 */   GIR_EraseRootFromParent_Done,
     /* 148661 */ // Label 2222: @148661
     /* 148661 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(148730), // Rule ID 3832 //
     /* 148666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 148669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148672 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148679 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148690 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148694 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 148701 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 148701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 148704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 148711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 148716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148728 */   GIR_RootConstrainSelectedInstOperands,
     /* 148729 */   // GIR_Coverage, 3832,
     /* 148729 */   GIR_EraseRootFromParent_Done,
     /* 148730 */ // Label 2223: @148730
     /* 148730 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(148799), // Rule ID 3844 //
     /* 148735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 148738 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148741 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148748 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 148770 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 148770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 148773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 148780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 148785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148793 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148797 */   GIR_RootConstrainSelectedInstOperands,
     /* 148798 */   // GIR_Coverage, 3844,
     /* 148798 */   GIR_EraseRootFromParent_Done,
     /* 148799 */ // Label 2224: @148799
     /* 148799 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(148868), // Rule ID 3854 //
     /* 148804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 148807 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148810 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148817 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 148828 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148832 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 148839 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 148839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_D16_SADDR_t16),
     /* 148842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 148849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 148854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148862 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148866 */   GIR_RootConstrainSelectedInstOperands,
     /* 148867 */   // GIR_Coverage, 3854,
     /* 148867 */   GIR_EraseRootFromParent_Done,
     /* 148868 */ // Label 2225: @148868
     /* 148868 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(148932), // Rule ID 3803 //
     /* 148873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 148876 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148879 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148886 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148897 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148901 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 148908 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 148908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 148911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 148918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148926 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148930 */   GIR_RootConstrainSelectedInstOperands,
     /* 148931 */   // GIR_Coverage, 3803,
     /* 148931 */   GIR_EraseRootFromParent_Done,
     /* 148932 */ // Label 2226: @148932
     /* 148932 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(148996), // Rule ID 3811 //
     /* 148937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 148940 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148943 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148950 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148961 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148965 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 148972 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 148972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 148975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 148977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 148982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 148987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148990 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148994 */   GIR_RootConstrainSelectedInstOperands,
     /* 148995 */   // GIR_Coverage, 3811,
     /* 148995 */   GIR_EraseRootFromParent_Done,
     /* 148996 */ // Label 2227: @148996
     /* 148996 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(149060), // Rule ID 3831 //
     /* 149001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 149004 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149007 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149014 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149025 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 149036 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 149039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149054 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149058 */   GIR_RootConstrainSelectedInstOperands,
     /* 149059 */   // GIR_Coverage, 3831,
     /* 149059 */   GIR_EraseRootFromParent_Done,
     /* 149060 */ // Label 2228: @149060
     /* 149060 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(149124), // Rule ID 3843 //
     /* 149065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 149068 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149071 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149078 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149089 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149093 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 149100 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 149103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149118 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149122 */   GIR_RootConstrainSelectedInstOperands,
     /* 149123 */   // GIR_Coverage, 3843,
     /* 149123 */   GIR_EraseRootFromParent_Done,
     /* 149124 */ // Label 2229: @149124
     /* 149124 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(149188), // Rule ID 3853 //
     /* 149129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 149132 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149135 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149142 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 149153 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149157 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 149164 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_D16_t16),
     /* 149167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149186 */   GIR_RootConstrainSelectedInstOperands,
     /* 149187 */   // GIR_Coverage, 3853,
     /* 149187 */   GIR_EraseRootFromParent_Done,
     /* 149188 */ // Label 2230: @149188
     /* 149188 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(149253), // Rule ID 3575 //
     /* 149193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 149196 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149199 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149206 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149218 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149222 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 149229 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 149232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149234 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149247 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149251 */   GIR_RootConstrainSelectedInstOperands,
     /* 149252 */   // GIR_Coverage, 3575,
     /* 149252 */   GIR_EraseRootFromParent_Done,
     /* 149253 */ // Label 2231: @149253
     /* 149253 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(149318), // Rule ID 3579 //
     /* 149258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 149261 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149264 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149271 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149283 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149287 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 149294 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /* 149297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149312 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149316 */   GIR_RootConstrainSelectedInstOperands,
     /* 149317 */   // GIR_Coverage, 3579,
     /* 149317 */   GIR_EraseRootFromParent_Done,
     /* 149318 */ // Label 2232: @149318
     /* 149318 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(149383), // Rule ID 3591 //
     /* 149323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /* 149326 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149329 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149336 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149348 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149352 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 149359 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 149362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149377 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149381 */   GIR_RootConstrainSelectedInstOperands,
     /* 149382 */   // GIR_Coverage, 3591,
     /* 149382 */   GIR_EraseRootFromParent_Done,
     /* 149383 */ // Label 2233: @149383
     /* 149383 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(149448), // Rule ID 3597 //
     /* 149388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /* 149391 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149394 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149401 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149413 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149417 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 149424 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 149424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 149427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149434 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149446 */   GIR_RootConstrainSelectedInstOperands,
     /* 149447 */   // GIR_Coverage, 3597,
     /* 149447 */   GIR_EraseRootFromParent_Done,
     /* 149448 */ // Label 2234: @149448
     /* 149448 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(149513), // Rule ID 3603 //
     /* 149453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /* 149456 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149459 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149466 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 149478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149482 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 149489 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE_D16_t16),
     /* 149492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 149499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149507 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149511 */   GIR_RootConstrainSelectedInstOperands,
     /* 149512 */   // GIR_Coverage, 3603,
     /* 149512 */   GIR_EraseRootFromParent_Done,
     /* 149513 */ // Label 2235: @149513
     /* 149513 */ GIM_Reject,
     /* 149514 */ // Label 2194: @149514
     /* 149514 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(149580), // Rule ID 2905 //
     /* 149519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 149522 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149525 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 149536 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149540 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
     /* 149544 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 149551 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
     /* 149554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 149556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 149561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 149566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 149571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149574 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149578 */   GIR_RootConstrainSelectedInstOperands,
     /* 149579 */   // GIR_Coverage, 2905,
     /* 149579 */   GIR_EraseRootFromParent_Done,
     /* 149580 */ // Label 2236: @149580
     /* 149580 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(149646), // Rule ID 2917 //
     /* 149585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 149588 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149591 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 149602 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149606 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
     /* 149610 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 149617 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
     /* 149620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 149622 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 149627 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 149632 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 149637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149640 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149644 */   GIR_RootConstrainSelectedInstOperands,
     /* 149645 */   // GIR_Coverage, 2917,
     /* 149645 */   GIR_EraseRootFromParent_Done,
     /* 149646 */ // Label 2237: @149646
     /* 149646 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(149707), // Rule ID 2903 //
     /* 149651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 149654 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149657 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 149668 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149672 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
     /* 149676 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 149683 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
     /* 149686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 149688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 149693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149701 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149705 */   GIR_RootConstrainSelectedInstOperands,
     /* 149706 */   // GIR_Coverage, 2903,
     /* 149706 */   GIR_EraseRootFromParent_Done,
     /* 149707 */ // Label 2238: @149707
     /* 149707 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(149771), // Rule ID 2904 //
     /* 149712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 149715 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149718 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 149729 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149733 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
     /* 149737 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 149744 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 149744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
     /* 149747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 149749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 149754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 149759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149765 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149769 */   GIR_RootConstrainSelectedInstOperands,
     /* 149770 */   // GIR_Coverage, 2904,
     /* 149770 */   GIR_EraseRootFromParent_Done,
     /* 149771 */ // Label 2239: @149771
     /* 149771 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(149832), // Rule ID 2915 //
     /* 149776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 149779 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 149793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149797 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
     /* 149801 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 149808 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
     /* 149811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 149813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 149818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149826 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149830 */   GIR_RootConstrainSelectedInstOperands,
     /* 149831 */   // GIR_Coverage, 2915,
     /* 149831 */   GIR_EraseRootFromParent_Done,
     /* 149832 */ // Label 2240: @149832
     /* 149832 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(149896), // Rule ID 2916 //
     /* 149837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 149840 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149843 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 149854 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149858 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
     /* 149862 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 149869 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 149869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
     /* 149872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 149874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 149879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 149884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149890 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149894 */   GIR_RootConstrainSelectedInstOperands,
     /* 149895 */   // GIR_Coverage, 2916,
     /* 149895 */   GIR_EraseRootFromParent_Done,
     /* 149896 */ // Label 2241: @149896
     /* 149896 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(149949), // Rule ID 2906 //
     /* 149901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 149904 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149907 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 149918 */   // MIs[0] sbase
     /* 149918 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 149926 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
     /* 149930 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 149930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
     /* 149933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 149935 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 149937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149943 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149947 */   GIR_RootConstrainSelectedInstOperands,
     /* 149948 */   // GIR_Coverage, 2906,
     /* 149948 */   GIR_EraseRootFromParent_Done,
     /* 149949 */ // Label 2242: @149949
     /* 149949 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(150002), // Rule ID 2918 //
     /* 149954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 149957 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149960 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 149971 */   // MIs[0] sbase
     /* 149971 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 149979 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
     /* 149983 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 149983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
     /* 149986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 149988 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 149990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149996 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150000 */   GIR_RootConstrainSelectedInstOperands,
     /* 150001 */   // GIR_Coverage, 2918,
     /* 150001 */   GIR_EraseRootFromParent_Done,
     /* 150002 */ // Label 2243: @150002
     /* 150002 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(150072), // Rule ID 6447 //
     /* 150007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 150010 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150013 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150020 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150029 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150033 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 150040 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 150040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 150043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 150055 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150066 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150070 */   GIR_RootConstrainSelectedInstOperands,
     /* 150071 */   // GIR_Coverage, 6447,
     /* 150071 */   GIR_EraseRootFromParent_Done,
     /* 150072 */ // Label 2244: @150072
     /* 150072 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(150142), // Rule ID 6449 //
     /* 150077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 150080 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150083 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150090 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150103 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 150110 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 150110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 150113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 150125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150136 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150140 */   GIR_RootConstrainSelectedInstOperands,
     /* 150141 */   // GIR_Coverage, 6449,
     /* 150141 */   GIR_EraseRootFromParent_Done,
     /* 150142 */ // Label 2245: @150142
     /* 150142 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(150212), // Rule ID 6471 //
     /* 150147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 150150 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150153 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150160 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150169 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150173 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 150180 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 150180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /* 150183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 150195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150206 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150210 */   GIR_RootConstrainSelectedInstOperands,
     /* 150211 */   // GIR_Coverage, 6471,
     /* 150211 */   GIR_EraseRootFromParent_Done,
     /* 150212 */ // Label 2246: @150212
     /* 150212 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(150282), // Rule ID 6473 //
     /* 150217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 150220 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150223 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150230 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150239 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150243 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 150250 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 150250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /* 150253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 150265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150276 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150280 */   GIR_RootConstrainSelectedInstOperands,
     /* 150281 */   // GIR_Coverage, 6473,
     /* 150281 */   GIR_EraseRootFromParent_Done,
     /* 150282 */ // Label 2247: @150282
     /* 150282 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(150349), // Rule ID 4185 //
     /* 150287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 150290 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150293 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150300 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150309 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150313 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 150320 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 150320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /* 150323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 150335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150347 */   GIR_RootConstrainSelectedInstOperands,
     /* 150348 */   // GIR_Coverage, 4185,
     /* 150348 */   GIR_EraseRootFromParent_Done,
     /* 150349 */ // Label 2248: @150349
     /* 150349 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(150416), // Rule ID 4194 //
     /* 150354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 150357 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150360 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150367 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150376 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150380 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 150387 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 150387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
     /* 150390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150392 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 150402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150414 */   GIR_RootConstrainSelectedInstOperands,
     /* 150415 */   // GIR_Coverage, 4194,
     /* 150415 */   GIR_EraseRootFromParent_Done,
     /* 150416 */ // Label 2249: @150416
     /* 150416 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(150478), // Rule ID 4184 //
     /* 150421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 150424 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150427 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150434 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150443 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150447 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 150454 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 150454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /* 150457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 150464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150472 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150476 */   GIR_RootConstrainSelectedInstOperands,
     /* 150477 */   // GIR_Coverage, 4184,
     /* 150477 */   GIR_EraseRootFromParent_Done,
     /* 150478 */ // Label 2250: @150478
     /* 150478 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(150540), // Rule ID 4193 //
     /* 150483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 150486 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150489 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150496 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150505 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150509 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 150516 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 150516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
     /* 150519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 150526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150534 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150538 */   GIR_RootConstrainSelectedInstOperands,
     /* 150539 */   // GIR_Coverage, 4193,
     /* 150539 */   GIR_EraseRootFromParent_Done,
     /* 150540 */ // Label 2251: @150540
     /* 150540 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(150602), // Rule ID 4183 //
     /* 150545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 150548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150551 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150558 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150567 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150571 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 150578 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 150578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /* 150581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150600 */   GIR_RootConstrainSelectedInstOperands,
     /* 150601 */   // GIR_Coverage, 4183,
     /* 150601 */   GIR_EraseRootFromParent_Done,
     /* 150602 */ // Label 2252: @150602
     /* 150602 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(150664), // Rule ID 4192 //
     /* 150607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 150610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150613 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150620 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150629 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150633 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 150640 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 150640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
     /* 150643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150658 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150662 */   GIR_RootConstrainSelectedInstOperands,
     /* 150663 */   // GIR_Coverage, 4192,
     /* 150663 */   GIR_EraseRootFromParent_Done,
     /* 150664 */ // Label 2253: @150664
     /* 150664 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(150741), // Rule ID 4439 //
     /* 150669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 150672 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 150675 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150682 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150693 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150697 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 150704 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 150704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /* 150707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 150714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 150724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 150729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150735 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150739 */   GIR_RootConstrainSelectedInstOperands,
     /* 150740 */   // GIR_Coverage, 4439,
     /* 150740 */   GIR_EraseRootFromParent_Done,
     /* 150741 */ // Label 2254: @150741
     /* 150741 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(150815), // Rule ID 4441 //
     /* 150746 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 150749 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150756 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150767 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150771 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 150778 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 150778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /* 150781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 150788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 150798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 150803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150809 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150813 */   GIR_RootConstrainSelectedInstOperands,
     /* 150814 */   // GIR_Coverage, 4441,
     /* 150814 */   GIR_EraseRootFromParent_Done,
     /* 150815 */ // Label 2255: @150815
     /* 150815 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(150892), // Rule ID 4447 //
     /* 150820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 150823 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 150826 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150833 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150844 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150848 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 150855 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 150855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /* 150858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 150865 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 150875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 150880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150886 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150890 */   GIR_RootConstrainSelectedInstOperands,
     /* 150891 */   // GIR_Coverage, 4447,
     /* 150891 */   GIR_EraseRootFromParent_Done,
     /* 150892 */ // Label 2256: @150892
     /* 150892 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(150966), // Rule ID 4449 //
     /* 150897 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 150900 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150907 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150918 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150922 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 150929 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 150929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /* 150932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 150939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 150949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 150954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150964 */   GIR_RootConstrainSelectedInstOperands,
     /* 150965 */   // GIR_Coverage, 4449,
     /* 150965 */   GIR_EraseRootFromParent_Done,
     /* 150966 */ // Label 2257: @150966
     /* 150966 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(151043), // Rule ID 4463 //
     /* 150971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 150974 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150977 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150984 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150995 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150999 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151006 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /* 151009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151041 */   GIR_RootConstrainSelectedInstOperands,
     /* 151042 */   // GIR_Coverage, 4463,
     /* 151042 */   GIR_EraseRootFromParent_Done,
     /* 151043 */ // Label 2258: @151043
     /* 151043 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(151117), // Rule ID 4465 //
     /* 151048 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151051 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151058 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151069 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151080 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /* 151083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151111 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151115 */   GIR_RootConstrainSelectedInstOperands,
     /* 151116 */   // GIR_Coverage, 4465,
     /* 151116 */   GIR_EraseRootFromParent_Done,
     /* 151117 */ // Label 2259: @151117
     /* 151117 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(151194), // Rule ID 4483 //
     /* 151122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 151125 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151128 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151135 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151146 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151150 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151157 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /* 151160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151192 */   GIR_RootConstrainSelectedInstOperands,
     /* 151193 */   // GIR_Coverage, 4483,
     /* 151193 */   GIR_EraseRootFromParent_Done,
     /* 151194 */ // Label 2260: @151194
     /* 151194 */ GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(151268), // Rule ID 4485 //
     /* 151199 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151202 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151209 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151224 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151231 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /* 151234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151262 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151266 */   GIR_RootConstrainSelectedInstOperands,
     /* 151267 */   // GIR_Coverage, 4485,
     /* 151267 */   GIR_EraseRootFromParent_Done,
     /* 151268 */ // Label 2261: @151268
     /* 151268 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(151344), // Rule ID 6416 //
     /* 151273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 151276 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151279 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151286 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151296 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151300 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151307 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 151307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /* 151310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151338 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151342 */   GIR_RootConstrainSelectedInstOperands,
     /* 151343 */   // GIR_Coverage, 6416,
     /* 151343 */   GIR_EraseRootFromParent_Done,
     /* 151344 */ // Label 2262: @151344
     /* 151344 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(151420), // Rule ID 6419 //
     /* 151349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 151352 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151355 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151362 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151372 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151376 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151383 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_constant>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 151383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /* 151386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151388 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151414 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151418 */   GIR_RootConstrainSelectedInstOperands,
     /* 151419 */   // GIR_Coverage, 6419,
     /* 151419 */   GIR_EraseRootFromParent_Done,
     /* 151420 */ // Label 2263: @151420
     /* 151420 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(151495), // Rule ID 6446 //
     /* 151425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 151428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151438 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151447 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151451 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 151458 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 151458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /* 151461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151489 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151493 */   GIR_RootConstrainSelectedInstOperands,
     /* 151494 */   // GIR_Coverage, 6446,
     /* 151494 */   GIR_EraseRootFromParent_Done,
     /* 151495 */ // Label 2264: @151495
     /* 151495 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(151570), // Rule ID 6448 //
     /* 151500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 151503 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151506 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151513 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151522 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151526 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 151533 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 151533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /* 151536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151548 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151568 */   GIR_RootConstrainSelectedInstOperands,
     /* 151569 */   // GIR_Coverage, 6448,
     /* 151569 */   GIR_EraseRootFromParent_Done,
     /* 151570 */ // Label 2265: @151570
     /* 151570 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(151645), // Rule ID 6470 //
     /* 151575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 151578 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151581 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151588 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151597 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 151608 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 151608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
     /* 151611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151639 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151643 */   GIR_RootConstrainSelectedInstOperands,
     /* 151644 */   // GIR_Coverage, 6470,
     /* 151644 */   GIR_EraseRootFromParent_Done,
     /* 151645 */ // Label 2266: @151645
     /* 151645 */ GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(151720), // Rule ID 6472 //
     /* 151650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 151653 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151656 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151663 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151672 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151676 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 151683 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 151683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
     /* 151686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151714 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151718 */   GIR_RootConstrainSelectedInstOperands,
     /* 151719 */   // GIR_Coverage, 6472,
     /* 151719 */   GIR_EraseRootFromParent_Done,
     /* 151720 */ // Label 2267: @151720
     /* 151720 */ GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(151792), // Rule ID 4438 //
     /* 151725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 151728 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 151731 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151738 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151749 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151753 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 151760 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 151763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 151775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 151780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151790 */   GIR_RootConstrainSelectedInstOperands,
     /* 151791 */   // GIR_Coverage, 4438,
     /* 151791 */   GIR_EraseRootFromParent_Done,
     /* 151792 */ // Label 2268: @151792
     /* 151792 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(151861), // Rule ID 4440 //
     /* 151797 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 151800 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151807 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151818 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151822 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 151829 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 151832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 151844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 151849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151855 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151859 */   GIR_RootConstrainSelectedInstOperands,
     /* 151860 */   // GIR_Coverage, 4440,
     /* 151860 */   GIR_EraseRootFromParent_Done,
     /* 151861 */ // Label 2269: @151861
     /* 151861 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(151933), // Rule ID 4446 //
     /* 151866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 151869 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 151872 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151879 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151890 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151894 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 151901 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /* 151904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 151916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 151921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151927 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151931 */   GIR_RootConstrainSelectedInstOperands,
     /* 151932 */   // GIR_Coverage, 4446,
     /* 151932 */   GIR_EraseRootFromParent_Done,
     /* 151933 */ // Label 2270: @151933
     /* 151933 */ GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(152002), // Rule ID 4448 //
     /* 151938 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 151941 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151948 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151959 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151963 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 151970 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /* 151973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 151985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 151990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151996 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152000 */   GIR_RootConstrainSelectedInstOperands,
     /* 152001 */   // GIR_Coverage, 4448,
     /* 152001 */   GIR_EraseRootFromParent_Done,
     /* 152002 */ // Label 2271: @152002
     /* 152002 */ GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(152074), // Rule ID 4462 //
     /* 152007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 152010 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152013 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152020 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152031 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152035 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 152042 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 152042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 152045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 152047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 152052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152068 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152072 */   GIR_RootConstrainSelectedInstOperands,
     /* 152073 */   // GIR_Coverage, 4462,
     /* 152073 */   GIR_EraseRootFromParent_Done,
     /* 152074 */ // Label 2272: @152074
     /* 152074 */ GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(152143), // Rule ID 4464 //
     /* 152079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152082 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152089 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152100 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152104 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 152111 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 152111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 152114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 152116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 152121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152126 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152137 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152141 */   GIR_RootConstrainSelectedInstOperands,
     /* 152142 */   // GIR_Coverage, 4464,
     /* 152142 */   GIR_EraseRootFromParent_Done,
     /* 152143 */ // Label 2273: @152143
     /* 152143 */ GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(152215), // Rule ID 4482 //
     /* 152148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 152151 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152154 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152161 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152172 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152176 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 152183 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 152183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /* 152186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 152188 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 152193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152213 */   GIR_RootConstrainSelectedInstOperands,
     /* 152214 */   // GIR_Coverage, 4482,
     /* 152214 */   GIR_EraseRootFromParent_Done,
     /* 152215 */ // Label 2274: @152215
     /* 152215 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(152284), // Rule ID 4484 //
     /* 152220 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152223 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152230 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152241 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152245 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 152252 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 152252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /* 152255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 152257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 152262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152278 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152282 */   GIR_RootConstrainSelectedInstOperands,
     /* 152283 */   // GIR_Coverage, 4484,
     /* 152283 */   GIR_EraseRootFromParent_Done,
     /* 152284 */ // Label 2275: @152284
     /* 152284 */ GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(152346), // Rule ID 7795 //
     /* 152289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 152292 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152295 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152302 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152311 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152315 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152322 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_zextload_glue>><<P:Predicate_zextloadi8_glue>><<P:Predicate_zextloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 152325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152332 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152340 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152344 */   GIR_RootConstrainSelectedInstOperands,
     /* 152345 */   // GIR_Coverage, 7795,
     /* 152345 */   GIR_EraseRootFromParent_Done,
     /* 152346 */ // Label 2276: @152346
     /* 152346 */ GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(152408), // Rule ID 7796 //
     /* 152351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 152354 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152357 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152364 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152373 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152384 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 152387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152402 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152406 */   GIR_RootConstrainSelectedInstOperands,
     /* 152407 */   // GIR_Coverage, 7796,
     /* 152407 */   GIR_EraseRootFromParent_Done,
     /* 152408 */ // Label 2277: @152408
     /* 152408 */ GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(152470), // Rule ID 7803 //
     /* 152413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 152416 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152419 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152426 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152435 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152439 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152446 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_zextload_glue>><<P:Predicate_zextloadi16_glue>><<P:Predicate_zextloadi16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /* 152449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152451 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152456 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152468 */   GIR_RootConstrainSelectedInstOperands,
     /* 152469 */   // GIR_Coverage, 7803,
     /* 152469 */   GIR_EraseRootFromParent_Done,
     /* 152470 */ // Label 2278: @152470
     /* 152470 */ GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(152532), // Rule ID 7804 //
     /* 152475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 152478 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152481 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152488 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152497 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152501 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152508 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /* 152511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152526 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152530 */   GIR_RootConstrainSelectedInstOperands,
     /* 152531 */   // GIR_Coverage, 7804,
     /* 152531 */   GIR_EraseRootFromParent_Done,
     /* 152532 */ // Label 2279: @152532
     /* 152532 */ GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(152594), // Rule ID 7844 //
     /* 152537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 152540 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152543 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152550 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152559 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152563 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152570 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext_glue>><<P:Predicate_atomic_load_zext_8_glue>><<P:Predicate_atomic_load_zext_8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 152573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152588 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152592 */   GIR_RootConstrainSelectedInstOperands,
     /* 152593 */   // GIR_Coverage, 7844,
     /* 152593 */   GIR_EraseRootFromParent_Done,
     /* 152594 */ // Label 2280: @152594
     /* 152594 */ GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(152656), // Rule ID 7845 //
     /* 152599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 152602 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152605 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152612 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152625 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152632 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 152635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152650 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152654 */   GIR_RootConstrainSelectedInstOperands,
     /* 152655 */   // GIR_Coverage, 7845,
     /* 152655 */   GIR_EraseRootFromParent_Done,
     /* 152656 */ // Label 2281: @152656
     /* 152656 */ GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(152718), // Rule ID 7858 //
     /* 152661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 152664 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152667 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152674 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152683 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152687 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152694 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext_glue>><<P:Predicate_atomic_load_zext_16_glue>><<P:Predicate_atomic_load_zext_16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /* 152697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152712 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152716 */   GIR_RootConstrainSelectedInstOperands,
     /* 152717 */   // GIR_Coverage, 7858,
     /* 152717 */   GIR_EraseRootFromParent_Done,
     /* 152718 */ // Label 2282: @152718
     /* 152718 */ GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(152780), // Rule ID 7859 //
     /* 152723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 152726 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152729 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152736 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152745 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152749 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152756 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /* 152759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152774 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152778 */   GIR_RootConstrainSelectedInstOperands,
     /* 152779 */   // GIR_Coverage, 7859,
     /* 152779 */   GIR_EraseRootFromParent_Done,
     /* 152780 */ // Label 2283: @152780
     /* 152780 */ GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(152849), // Rule ID 3802 //
     /* 152785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 152788 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152791 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152798 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152809 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152813 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 152820 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 152820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 152823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 152830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 152835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152843 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152847 */   GIR_RootConstrainSelectedInstOperands,
     /* 152848 */   // GIR_Coverage, 3802,
     /* 152848 */   GIR_EraseRootFromParent_Done,
     /* 152849 */ // Label 2284: @152849
     /* 152849 */ GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(152918), // Rule ID 3810 //
     /* 152854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 152857 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152860 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152867 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152878 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152882 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 152889 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 152889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 152892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 152899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 152904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152912 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152916 */   GIR_RootConstrainSelectedInstOperands,
     /* 152917 */   // GIR_Coverage, 3810,
     /* 152917 */   GIR_EraseRootFromParent_Done,
     /* 152918 */ // Label 2285: @152918
     /* 152918 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(152987), // Rule ID 3820 //
     /* 152923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 152926 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152929 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152936 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152951 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 152958 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 152958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 152961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 152968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 152973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152981 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152985 */   GIR_RootConstrainSelectedInstOperands,
     /* 152986 */   // GIR_Coverage, 3820,
     /* 152986 */   GIR_EraseRootFromParent_Done,
     /* 152987 */ // Label 2286: @152987
     /* 152987 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(153056), // Rule ID 3826 //
     /* 152992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 152995 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152998 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153005 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153016 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153020 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 153027 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 153030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 153037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 153042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 153047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153050 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153054 */   GIR_RootConstrainSelectedInstOperands,
     /* 153055 */   // GIR_Coverage, 3826,
     /* 153055 */   GIR_EraseRootFromParent_Done,
     /* 153056 */ // Label 2287: @153056
     /* 153056 */ GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(153125), // Rule ID 3838 //
     /* 153061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 153064 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153067 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153074 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153085 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153089 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 153096 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 153099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 153106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 153111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 153116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153119 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153123 */   GIR_RootConstrainSelectedInstOperands,
     /* 153124 */   // GIR_Coverage, 3838,
     /* 153124 */   GIR_EraseRootFromParent_Done,
     /* 153125 */ // Label 2288: @153125
     /* 153125 */ GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(153194), // Rule ID 3850 //
     /* 153130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 153133 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153136 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153143 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153154 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153158 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 153165 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 153168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 153175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 153180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 153185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153192 */   GIR_RootConstrainSelectedInstOperands,
     /* 153193 */   // GIR_Coverage, 3850,
     /* 153193 */   GIR_EraseRootFromParent_Done,
     /* 153194 */ // Label 2289: @153194
     /* 153194 */ GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(153258), // Rule ID 3801 //
     /* 153199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 153202 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153205 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153212 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153223 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153227 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153234 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 153237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153252 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153256 */   GIR_RootConstrainSelectedInstOperands,
     /* 153257 */   // GIR_Coverage, 3801,
     /* 153257 */   GIR_EraseRootFromParent_Done,
     /* 153258 */ // Label 2290: @153258
     /* 153258 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(153322), // Rule ID 3809 //
     /* 153263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 153266 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153269 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153276 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153287 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153291 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153298 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 153301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153320 */   GIR_RootConstrainSelectedInstOperands,
     /* 153321 */   // GIR_Coverage, 3809,
     /* 153321 */   GIR_EraseRootFromParent_Done,
     /* 153322 */ // Label 2291: @153322
     /* 153322 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(153386), // Rule ID 3819 //
     /* 153327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 153330 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153333 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153340 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153351 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153355 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153362 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 153365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153380 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153384 */   GIR_RootConstrainSelectedInstOperands,
     /* 153385 */   // GIR_Coverage, 3819,
     /* 153385 */   GIR_EraseRootFromParent_Done,
     /* 153386 */ // Label 2292: @153386
     /* 153386 */ GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(153450), // Rule ID 3825 //
     /* 153391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 153394 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153397 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153404 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153426 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 153429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153444 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153448 */   GIR_RootConstrainSelectedInstOperands,
     /* 153449 */   // GIR_Coverage, 3825,
     /* 153449 */   GIR_EraseRootFromParent_Done,
     /* 153450 */ // Label 2293: @153450
     /* 153450 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(153514), // Rule ID 3837 //
     /* 153455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 153458 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153461 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153468 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153479 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153483 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153490 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 153493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153508 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153512 */   GIR_RootConstrainSelectedInstOperands,
     /* 153513 */   // GIR_Coverage, 3837,
     /* 153513 */   GIR_EraseRootFromParent_Done,
     /* 153514 */ // Label 2294: @153514
     /* 153514 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(153578), // Rule ID 3849 //
     /* 153519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 153522 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153525 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153532 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153547 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153554 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 153557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153576 */   GIR_RootConstrainSelectedInstOperands,
     /* 153577 */   // GIR_Coverage, 3849,
     /* 153577 */   GIR_EraseRootFromParent_Done,
     /* 153578 */ // Label 2295: @153578
     /* 153578 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(153643), // Rule ID 3574 //
     /* 153583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 153586 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153589 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153596 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 153619 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 153622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153637 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153641 */   GIR_RootConstrainSelectedInstOperands,
     /* 153642 */   // GIR_Coverage, 3574,
     /* 153642 */   GIR_EraseRootFromParent_Done,
     /* 153643 */ // Label 2296: @153643
     /* 153643 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(153708), // Rule ID 3578 //
     /* 153648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 153651 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153654 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153661 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153673 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153677 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 153684 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /* 153687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153702 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153706 */   GIR_RootConstrainSelectedInstOperands,
     /* 153707 */   // GIR_Coverage, 3578,
     /* 153707 */   GIR_EraseRootFromParent_Done,
     /* 153708 */ // Label 2297: @153708
     /* 153708 */ GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(153773), // Rule ID 3581 //
     /* 153713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 153716 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153719 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153726 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 153749 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 153752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153771 */   GIR_RootConstrainSelectedInstOperands,
     /* 153772 */   // GIR_Coverage, 3581,
     /* 153772 */   GIR_EraseRootFromParent_Done,
     /* 153773 */ // Label 2298: @153773
     /* 153773 */ GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(153838), // Rule ID 3586 //
     /* 153778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 153781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153784 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153791 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153803 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153807 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 153814 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /* 153817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153832 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153836 */   GIR_RootConstrainSelectedInstOperands,
     /* 153837 */   // GIR_Coverage, 3586,
     /* 153837 */   GIR_EraseRootFromParent_Done,
     /* 153838 */ // Label 2299: @153838
     /* 153838 */ GIM_Reject,
     /* 153839 */ // Label 2195: @153839
     /* 153839 */ GIM_Reject,
     /* 153840 */ // Label 17: @153840
     /* 153840 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(23), /*)*//*default:*//*Label 2317*/ GIMT_Encode4(187744),
     /* 153851 */ /*GILLT_p0s64*//*Label 2300*/ GIMT_Encode4(153943),
     /* 153855 */ /*GILLT_p1s64*//*Label 2301*/ GIMT_Encode4(154936),
     /* 153859 */ /*GILLT_p2s32*//*Label 2302*/ GIMT_Encode4(155929),
     /* 153863 */ /*GILLT_p3s32*//*Label 2303*/ GIMT_Encode4(156800),
     /* 153867 */ /*GILLT_p4s64*//*Label 2304*/ GIMT_Encode4(157671),
     /* 153871 */ /*GILLT_p5s32*//*Label 2305*/ GIMT_Encode4(158664),
     /* 153875 */ /*GILLT_p6s32*//*Label 2306*/ GIMT_Encode4(159535), GIMT_Encode4(0),
     /* 153883 */ /*GILLT_s16*//*Label 2307*/ GIMT_Encode4(160406),
     /* 153887 */ /*GILLT_s32*//*Label 2308*/ GIMT_Encode4(164717),
     /* 153891 */ /*GILLT_s64*//*Label 2309*/ GIMT_Encode4(171819),
     /* 153895 */ /*GILLT_v2s16*//*Label 2310*/ GIMT_Encode4(174249),
     /* 153899 */ /*GILLT_v2s32*//*Label 2311*/ GIMT_Encode4(175981),
     /* 153903 */ /*GILLT_v2s64*//*Label 2312*/ GIMT_Encode4(178191),
     /* 153907 */ /*GILLT_v3s32*//*Label 2313*/ GIMT_Encode4(180167), GIMT_Encode4(0),
     /* 153915 */ /*GILLT_v4s16*//*Label 2314*/ GIMT_Encode4(181582),
     /* 153919 */ /*GILLT_v4s32*//*Label 2315*/ GIMT_Encode4(183558), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 153939 */ /*GILLT_v8s16*//*Label 2316*/ GIMT_Encode4(185768),
     /* 153943 */ // Label 2300: @153943
     /* 153943 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(154935),
     /* 153948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153951 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(154012), // Rule ID 8078 //
     /* 153956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 153959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 153963 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 153968 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 153973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 153981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 153988 */     // (AMDGPUst_glue p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 153988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 153991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 153996 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 153998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154010 */     GIR_RootConstrainSelectedInstOperands,
     /* 154011 */     // GIR_Coverage, 8078,
     /* 154011 */     GIR_EraseRootFromParent_Done,
     /* 154012 */   // Label 2319: @154012
     /* 154012 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(154068), // Rule ID 8010 //
     /* 154017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 154020 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 154024 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154029 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 154033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 154044 */     // (AMDGPUst_glue p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 154044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 154047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 154052 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 154054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154066 */     GIR_RootConstrainSelectedInstOperands,
     /* 154067 */     // GIR_Coverage, 8010,
     /* 154067 */     GIR_EraseRootFromParent_Done,
     /* 154068 */   // Label 2320: @154068
     /* 154068 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(154125), // Rule ID 8079 //
     /* 154073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 154076 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154081 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 154094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 154101 */     // (st p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 154101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 154104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 154109 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 154111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154123 */     GIR_RootConstrainSelectedInstOperands,
     /* 154124 */     // GIR_Coverage, 8079,
     /* 154124 */     GIR_EraseRootFromParent_Done,
     /* 154125 */   // Label 2321: @154125
     /* 154125 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(154177), // Rule ID 8011 //
     /* 154130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 154133 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154138 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 154142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 154153 */     // (st p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 154153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 154156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 154161 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 154163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154175 */     GIR_RootConstrainSelectedInstOperands,
     /* 154176 */     // GIR_Coverage, 8011,
     /* 154176 */     GIR_EraseRootFromParent_Done,
     /* 154177 */   // Label 2322: @154177
     /* 154177 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(154230), // Rule ID 4332 //
     /* 154182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 154185 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 154201 */     // (st p0:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 154201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 154204 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 154206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 154211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 154216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 154221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154228 */     GIR_RootConstrainSelectedInstOperands,
     /* 154229 */     // GIR_Coverage, 4332,
     /* 154229 */     GIR_EraseRootFromParent_Done,
     /* 154230 */   // Label 2323: @154230
     /* 154230 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(154278), // Rule ID 4331 //
     /* 154235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 154238 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 154254 */     // (st p0:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 154254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 154257 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 154259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 154264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154276 */     GIR_RootConstrainSelectedInstOperands,
     /* 154277 */     // GIR_Coverage, 4331,
     /* 154277 */     GIR_EraseRootFromParent_Done,
     /* 154278 */   // Label 2324: @154278
     /* 154278 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(154326), // Rule ID 4330 //
     /* 154283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 154286 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 154302 */     // (st p0:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 154302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 154305 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 154307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 154312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154324 */     GIR_RootConstrainSelectedInstOperands,
     /* 154325 */     // GIR_Coverage, 4330,
     /* 154325 */     GIR_EraseRootFromParent_Done,
     /* 154326 */   // Label 2325: @154326
     /* 154326 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(154387), // Rule ID 4657 //
     /* 154331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 154334 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 154339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 154350 */     // (st p0:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 p0:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 154350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 154353 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 154355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 154360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 154370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 154375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154385 */     GIR_RootConstrainSelectedInstOperands,
     /* 154386 */     // GIR_Coverage, 4657,
     /* 154386 */     GIR_EraseRootFromParent_Done,
     /* 154387 */   // Label 2326: @154387
     /* 154387 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(154445), // Rule ID 4659 //
     /* 154392 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 154397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 154408 */     // (st p0:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 p0:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 154408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 154411 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 154413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 154418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 154428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 154433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154443 */     GIR_RootConstrainSelectedInstOperands,
     /* 154444 */     // GIR_Coverage, 4659,
     /* 154444 */     GIR_EraseRootFromParent_Done,
     /* 154445 */   // Label 2327: @154445
     /* 154445 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(154562), // Rule ID 7953 //
     /* 154450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 154453 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 154457 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 154473 */     // (AMDGPUst_glue p0:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 154473 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154476 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154480 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154485 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 154491 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 154496 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 154501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154513 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 154519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 154524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 154529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 154532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 154537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 154543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 154548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 154553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154560 */     GIR_RootConstrainSelectedInstOperands,
     /* 154561 */     // GIR_Coverage, 7953,
     /* 154561 */     GIR_EraseRootFromParent_Done,
     /* 154562 */   // Label 2328: @154562
     /* 154562 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(154618), // Rule ID 4656 //
     /* 154567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 154570 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 154575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 154586 */     // (st p0:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 154586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 154589 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 154591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 154601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 154606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154616 */     GIR_RootConstrainSelectedInstOperands,
     /* 154617 */     // GIR_Coverage, 4656,
     /* 154617 */     GIR_EraseRootFromParent_Done,
     /* 154618 */   // Label 2329: @154618
     /* 154618 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(154671), // Rule ID 4658 //
     /* 154623 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 154628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 154639 */     // (st p0:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 154639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 154642 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 154644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 154654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 154659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154669 */     GIR_RootConstrainSelectedInstOperands,
     /* 154670 */     // GIR_Coverage, 4658,
     /* 154670 */     GIR_EraseRootFromParent_Done,
     /* 154671 */   // Label 2330: @154671
     /* 154671 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(154784), // Rule ID 7955 //
     /* 154676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 154679 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 154695 */     // (st p0:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 154695 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154698 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154702 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154707 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 154713 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 154718 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 154723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154735 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 154741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 154746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 154751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 154754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 154759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 154765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 154770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 154775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154782 */     GIR_RootConstrainSelectedInstOperands,
     /* 154783 */     // GIR_Coverage, 7955,
     /* 154783 */     GIR_EraseRootFromParent_Done,
     /* 154784 */   // Label 2331: @154784
     /* 154784 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(154837), // Rule ID 3918 //
     /* 154789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 154792 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 154797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 154808 */     // (st p0:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 154808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 154811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 154816 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 154818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 154823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 154828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154835 */     GIR_RootConstrainSelectedInstOperands,
     /* 154836 */     // GIR_Coverage, 3918,
     /* 154836 */     GIR_EraseRootFromParent_Done,
     /* 154837 */   // Label 2332: @154837
     /* 154837 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(154885), // Rule ID 3917 //
     /* 154842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 154845 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 154850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 154861 */     // (st p0:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 154861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 154864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 154869 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 154871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154883 */     GIR_RootConstrainSelectedInstOperands,
     /* 154884 */     // GIR_Coverage, 3917,
     /* 154884 */     GIR_EraseRootFromParent_Done,
     /* 154885 */   // Label 2333: @154885
     /* 154885 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(154934), // Rule ID 3640 //
     /* 154890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 154893 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 154899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 154910 */     // (st p0:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 154910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 154913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 154918 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 154920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154932 */     GIR_RootConstrainSelectedInstOperands,
     /* 154933 */     // GIR_Coverage, 3640,
     /* 154933 */     GIR_EraseRootFromParent_Done,
     /* 154934 */   // Label 2334: @154934
     /* 154934 */   GIM_Reject,
     /* 154935 */ // Label 2318: @154935
     /* 154935 */ GIM_Reject,
     /* 154936 */ // Label 2301: @154936
     /* 154936 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(155928),
     /* 154941 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154944 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(155005), // Rule ID 8082 //
     /* 154949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 154952 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 154956 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154961 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 154966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 154974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 154981 */     // (AMDGPUst_glue p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 154981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 154984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 154989 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 154991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155003 */     GIR_RootConstrainSelectedInstOperands,
     /* 155004 */     // GIR_Coverage, 8082,
     /* 155004 */     GIR_EraseRootFromParent_Done,
     /* 155005 */   // Label 2336: @155005
     /* 155005 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(155061), // Rule ID 8014 //
     /* 155010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 155013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 155017 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155022 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 155026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 155037 */     // (AMDGPUst_glue p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 155037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 155040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 155045 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 155047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155059 */     GIR_RootConstrainSelectedInstOperands,
     /* 155060 */     // GIR_Coverage, 8014,
     /* 155060 */     GIR_EraseRootFromParent_Done,
     /* 155061 */   // Label 2337: @155061
     /* 155061 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(155118), // Rule ID 8083 //
     /* 155066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 155069 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155074 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 155087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 155094 */     // (st p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 155094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 155097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 155102 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 155104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155116 */     GIR_RootConstrainSelectedInstOperands,
     /* 155117 */     // GIR_Coverage, 8083,
     /* 155117 */     GIR_EraseRootFromParent_Done,
     /* 155118 */   // Label 2338: @155118
     /* 155118 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(155170), // Rule ID 8015 //
     /* 155123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 155126 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155131 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 155135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 155146 */     // (st p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 155146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 155149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 155154 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 155156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155168 */     GIR_RootConstrainSelectedInstOperands,
     /* 155169 */     // GIR_Coverage, 8015,
     /* 155169 */     GIR_EraseRootFromParent_Done,
     /* 155170 */   // Label 2339: @155170
     /* 155170 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(155223), // Rule ID 4338 //
     /* 155175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 155178 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 155183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 155194 */     // (st p1:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 155194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 155197 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 155199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 155204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 155209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 155214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155221 */     GIR_RootConstrainSelectedInstOperands,
     /* 155222 */     // GIR_Coverage, 4338,
     /* 155222 */     GIR_EraseRootFromParent_Done,
     /* 155223 */   // Label 2340: @155223
     /* 155223 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(155271), // Rule ID 4337 //
     /* 155228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 155231 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 155236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 155247 */     // (st p1:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 155247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 155250 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 155252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 155257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155269 */     GIR_RootConstrainSelectedInstOperands,
     /* 155270 */     // GIR_Coverage, 4337,
     /* 155270 */     GIR_EraseRootFromParent_Done,
     /* 155271 */   // Label 2341: @155271
     /* 155271 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(155319), // Rule ID 4336 //
     /* 155276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 155279 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 155284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 155295 */     // (st p1:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 155295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 155298 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 155300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 155305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155317 */     GIR_RootConstrainSelectedInstOperands,
     /* 155318 */     // GIR_Coverage, 4336,
     /* 155318 */     GIR_EraseRootFromParent_Done,
     /* 155319 */   // Label 2342: @155319
     /* 155319 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(155380), // Rule ID 4661 //
     /* 155324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 155327 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 155332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 155343 */     // (st p1:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 p1:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 155346 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 155348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155378 */     GIR_RootConstrainSelectedInstOperands,
     /* 155379 */     // GIR_Coverage, 4661,
     /* 155379 */     GIR_EraseRootFromParent_Done,
     /* 155380 */   // Label 2343: @155380
     /* 155380 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(155438), // Rule ID 4663 //
     /* 155385 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 155390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 155401 */     // (st p1:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 p1:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 155404 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 155406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155436 */     GIR_RootConstrainSelectedInstOperands,
     /* 155437 */     // GIR_Coverage, 4663,
     /* 155437 */     GIR_EraseRootFromParent_Done,
     /* 155438 */   // Label 2344: @155438
     /* 155438 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(155555), // Rule ID 7957 //
     /* 155443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 155446 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 155450 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 155466 */     // (AMDGPUst_glue p1:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 155466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155478 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 155484 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 155489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 155494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155506 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 155512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 155517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 155522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 155525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 155530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 155536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 155541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 155546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155553 */     GIR_RootConstrainSelectedInstOperands,
     /* 155554 */     // GIR_Coverage, 7957,
     /* 155554 */     GIR_EraseRootFromParent_Done,
     /* 155555 */   // Label 2345: @155555
     /* 155555 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(155611), // Rule ID 4660 //
     /* 155560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 155563 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 155568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 155579 */     // (st p1:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 155582 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 155584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 155594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 155599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155609 */     GIR_RootConstrainSelectedInstOperands,
     /* 155610 */     // GIR_Coverage, 4660,
     /* 155610 */     GIR_EraseRootFromParent_Done,
     /* 155611 */   // Label 2346: @155611
     /* 155611 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(155664), // Rule ID 4662 //
     /* 155616 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 155621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 155632 */     // (st p1:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 155635 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 155637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 155647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 155652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155662 */     GIR_RootConstrainSelectedInstOperands,
     /* 155663 */     // GIR_Coverage, 4662,
     /* 155663 */     GIR_EraseRootFromParent_Done,
     /* 155664 */   // Label 2347: @155664
     /* 155664 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(155777), // Rule ID 7959 //
     /* 155669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 155672 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 155677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 155688 */     // (st p1:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 155688 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155691 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155695 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155700 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 155706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 155711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 155716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155728 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 155734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 155739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 155744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 155747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 155752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 155758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 155763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 155768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155775 */     GIR_RootConstrainSelectedInstOperands,
     /* 155776 */     // GIR_Coverage, 7959,
     /* 155776 */     GIR_EraseRootFromParent_Done,
     /* 155777 */   // Label 2348: @155777
     /* 155777 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(155830), // Rule ID 3922 //
     /* 155782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 155785 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 155790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 155801 */     // (st p1:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 155801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 155804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 155809 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 155811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 155816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 155821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155828 */     GIR_RootConstrainSelectedInstOperands,
     /* 155829 */     // GIR_Coverage, 3922,
     /* 155829 */     GIR_EraseRootFromParent_Done,
     /* 155830 */   // Label 2349: @155830
     /* 155830 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(155878), // Rule ID 3921 //
     /* 155835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 155838 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 155843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 155854 */     // (st p1:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 155854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 155857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 155862 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 155864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155876 */     GIR_RootConstrainSelectedInstOperands,
     /* 155877 */     // GIR_Coverage, 3921,
     /* 155877 */     GIR_EraseRootFromParent_Done,
     /* 155878 */   // Label 2350: @155878
     /* 155878 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(155927), // Rule ID 3642 //
     /* 155883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 155886 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 155892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 155903 */     // (st p1:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 155903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 155906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 155911 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 155913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 155918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155925 */     GIR_RootConstrainSelectedInstOperands,
     /* 155926 */     // GIR_Coverage, 3642,
     /* 155926 */     GIR_EraseRootFromParent_Done,
     /* 155927 */   // Label 2351: @155927
     /* 155927 */   GIM_Reject,
     /* 155928 */ // Label 2335: @155928
     /* 155928 */ GIM_Reject,
     /* 155929 */ // Label 2302: @155929
     /* 155929 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(156799),
     /* 155934 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155937 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(155993), // Rule ID 6617 //
     /* 155942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 155945 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 155950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 155961 */     // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 155961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 155964 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 155966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 155976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 155981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155991 */     GIR_RootConstrainSelectedInstOperands,
     /* 155992 */     // GIR_Coverage, 6617,
     /* 155992 */     GIR_EraseRootFromParent_Done,
     /* 155993 */   // Label 2353: @155993
     /* 155993 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(156049), // Rule ID 6619 //
     /* 155998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 156001 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 156017 */     // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 156017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 156020 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 156022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 156032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156047 */     GIR_RootConstrainSelectedInstOperands,
     /* 156048 */     // GIR_Coverage, 6619,
     /* 156048 */     GIR_EraseRootFromParent_Done,
     /* 156049 */   // Label 2354: @156049
     /* 156049 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(156102), // Rule ID 4272 //
     /* 156054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 156057 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 156073 */     // (st p2:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 156073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 156076 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 156083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 156088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156100 */     GIR_RootConstrainSelectedInstOperands,
     /* 156101 */     // GIR_Coverage, 4272,
     /* 156101 */     GIR_EraseRootFromParent_Done,
     /* 156102 */   // Label 2355: @156102
     /* 156102 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(156150), // Rule ID 4271 //
     /* 156107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 156110 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 156126 */     // (st p2:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 156126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 156129 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 156136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156148 */     GIR_RootConstrainSelectedInstOperands,
     /* 156149 */     // GIR_Coverage, 4271,
     /* 156149 */     GIR_EraseRootFromParent_Done,
     /* 156150 */   // Label 2356: @156150
     /* 156150 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(156198), // Rule ID 4270 //
     /* 156155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 156158 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 156174 */     // (st p2:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 156174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 156177 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 156184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156196 */     GIR_RootConstrainSelectedInstOperands,
     /* 156197 */     // GIR_Coverage, 4270,
     /* 156197 */     GIR_EraseRootFromParent_Done,
     /* 156198 */   // Label 2357: @156198
     /* 156198 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(156259), // Rule ID 4617 //
     /* 156203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 156206 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 156222 */     // (st p2:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p2:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 156222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 156225 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 156227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 156232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 156242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 156247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156257 */     GIR_RootConstrainSelectedInstOperands,
     /* 156258 */     // GIR_Coverage, 4617,
     /* 156258 */     GIR_EraseRootFromParent_Done,
     /* 156259 */   // Label 2358: @156259
     /* 156259 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(156317), // Rule ID 4619 //
     /* 156264 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 156280 */     // (st p2:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p2:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 156280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 156283 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 156285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 156290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 156300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 156305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156315 */     GIR_RootConstrainSelectedInstOperands,
     /* 156316 */     // GIR_Coverage, 4619,
     /* 156316 */     GIR_EraseRootFromParent_Done,
     /* 156317 */   // Label 2359: @156317
     /* 156317 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(156378), // Rule ID 6616 //
     /* 156322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 156325 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 156341 */     // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 156341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 156344 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 156346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 156351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 156361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 156366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156376 */     GIR_RootConstrainSelectedInstOperands,
     /* 156377 */     // GIR_Coverage, 6616,
     /* 156377 */     GIR_EraseRootFromParent_Done,
     /* 156378 */   // Label 2360: @156378
     /* 156378 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(156439), // Rule ID 6618 //
     /* 156383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 156386 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 156402 */     // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 156402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 156405 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 156407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 156412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 156422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 156427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156437 */     GIR_RootConstrainSelectedInstOperands,
     /* 156438 */     // GIR_Coverage, 6618,
     /* 156438 */     GIR_EraseRootFromParent_Done,
     /* 156439 */   // Label 2361: @156439
     /* 156439 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(156495), // Rule ID 4616 //
     /* 156444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 156447 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 156463 */     // (st p2:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 156463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 156466 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 156468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 156478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156493 */     GIR_RootConstrainSelectedInstOperands,
     /* 156494 */     // GIR_Coverage, 4616,
     /* 156494 */     GIR_EraseRootFromParent_Done,
     /* 156495 */   // Label 2362: @156495
     /* 156495 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(156548), // Rule ID 4618 //
     /* 156500 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 156516 */     // (st p2:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 156516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 156519 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 156521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 156531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156546 */     GIR_RootConstrainSelectedInstOperands,
     /* 156547 */     // GIR_Coverage, 4618,
     /* 156547 */     GIR_EraseRootFromParent_Done,
     /* 156548 */   // Label 2363: @156548
     /* 156548 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(156600), // Rule ID 7898 //
     /* 156553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 156556 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 156560 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 156565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 156576 */     // (AMDGPUst_glue p2:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 156576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 156579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 156584 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 156586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156598 */     GIR_RootConstrainSelectedInstOperands,
     /* 156599 */     // GIR_Coverage, 7898,
     /* 156599 */     GIR_EraseRootFromParent_Done,
     /* 156600 */   // Label 2364: @156600
     /* 156600 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(156648), // Rule ID 7899 //
     /* 156605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 156608 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 156613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 156624 */     // (st p2:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 156624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 156627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 156632 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 156634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156646 */     GIR_RootConstrainSelectedInstOperands,
     /* 156647 */     // GIR_Coverage, 7899,
     /* 156647 */     GIR_EraseRootFromParent_Done,
     /* 156648 */   // Label 2365: @156648
     /* 156648 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(156701), // Rule ID 3878 //
     /* 156653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 156656 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 156672 */     // (st p2:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 156672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 156675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 156680 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 156687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156699 */     GIR_RootConstrainSelectedInstOperands,
     /* 156700 */     // GIR_Coverage, 3878,
     /* 156700 */     GIR_EraseRootFromParent_Done,
     /* 156701 */   // Label 2366: @156701
     /* 156701 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(156749), // Rule ID 3877 //
     /* 156706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 156709 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 156714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 156725 */     // (st p2:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 156725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 156728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 156733 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156747 */     GIR_RootConstrainSelectedInstOperands,
     /* 156748 */     // GIR_Coverage, 3877,
     /* 156748 */     GIR_EraseRootFromParent_Done,
     /* 156749 */   // Label 2367: @156749
     /* 156749 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(156798), // Rule ID 3621 //
     /* 156754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 156757 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 156763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 156774 */     // (st p2:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 156774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 156777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 156782 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156796 */     GIR_RootConstrainSelectedInstOperands,
     /* 156797 */     // GIR_Coverage, 3621,
     /* 156797 */     GIR_EraseRootFromParent_Done,
     /* 156798 */   // Label 2368: @156798
     /* 156798 */   GIM_Reject,
     /* 156799 */ // Label 2352: @156799
     /* 156799 */ GIM_Reject,
     /* 156800 */ // Label 2303: @156800
     /* 156800 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(157670),
     /* 156805 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156808 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(156864), // Rule ID 6621 //
     /* 156813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 156816 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 156832 */     // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 156832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 156835 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 156837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 156847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156862 */     GIR_RootConstrainSelectedInstOperands,
     /* 156863 */     // GIR_Coverage, 6621,
     /* 156863 */     GIR_EraseRootFromParent_Done,
     /* 156864 */   // Label 2370: @156864
     /* 156864 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(156920), // Rule ID 6623 //
     /* 156869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 156872 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 156888 */     // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 156888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 156891 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 156893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 156903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156918 */     GIR_RootConstrainSelectedInstOperands,
     /* 156919 */     // GIR_Coverage, 6623,
     /* 156919 */     GIR_EraseRootFromParent_Done,
     /* 156920 */   // Label 2371: @156920
     /* 156920 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(156973), // Rule ID 4278 //
     /* 156925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 156928 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 156944 */     // (st p3:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 156944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 156947 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 156949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 156954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 156959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156971 */     GIR_RootConstrainSelectedInstOperands,
     /* 156972 */     // GIR_Coverage, 4278,
     /* 156972 */     GIR_EraseRootFromParent_Done,
     /* 156973 */   // Label 2372: @156973
     /* 156973 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(157021), // Rule ID 4277 //
     /* 156978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 156981 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 156986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 156997 */     // (st p3:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 156997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 157000 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 157007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157019 */     GIR_RootConstrainSelectedInstOperands,
     /* 157020 */     // GIR_Coverage, 4277,
     /* 157020 */     GIR_EraseRootFromParent_Done,
     /* 157021 */   // Label 2373: @157021
     /* 157021 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(157069), // Rule ID 4276 //
     /* 157026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 157029 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 157034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 157045 */     // (st p3:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 157045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 157048 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157067 */     GIR_RootConstrainSelectedInstOperands,
     /* 157068 */     // GIR_Coverage, 4276,
     /* 157068 */     GIR_EraseRootFromParent_Done,
     /* 157069 */   // Label 2374: @157069
     /* 157069 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(157130), // Rule ID 4621 //
     /* 157074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 157077 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 157082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 157093 */     // (st p3:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p3:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 157093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 157096 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 157098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 157103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 157113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 157118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157128 */     GIR_RootConstrainSelectedInstOperands,
     /* 157129 */     // GIR_Coverage, 4621,
     /* 157129 */     GIR_EraseRootFromParent_Done,
     /* 157130 */   // Label 2375: @157130
     /* 157130 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(157188), // Rule ID 4623 //
     /* 157135 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 157140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 157151 */     // (st p3:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p3:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 157151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 157154 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 157156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 157161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 157171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 157176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157186 */     GIR_RootConstrainSelectedInstOperands,
     /* 157187 */     // GIR_Coverage, 4623,
     /* 157187 */     GIR_EraseRootFromParent_Done,
     /* 157188 */   // Label 2376: @157188
     /* 157188 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(157249), // Rule ID 6620 //
     /* 157193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 157196 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 157201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 157212 */     // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 157212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 157215 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 157222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 157232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 157237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157247 */     GIR_RootConstrainSelectedInstOperands,
     /* 157248 */     // GIR_Coverage, 6620,
     /* 157248 */     GIR_EraseRootFromParent_Done,
     /* 157249 */   // Label 2377: @157249
     /* 157249 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(157310), // Rule ID 6622 //
     /* 157254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 157257 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 157262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 157273 */     // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 157273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 157276 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 157283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 157293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 157298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157308 */     GIR_RootConstrainSelectedInstOperands,
     /* 157309 */     // GIR_Coverage, 6622,
     /* 157309 */     GIR_EraseRootFromParent_Done,
     /* 157310 */   // Label 2378: @157310
     /* 157310 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(157366), // Rule ID 4620 //
     /* 157315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 157318 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 157323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 157334 */     // (st p3:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 157334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 157337 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 157339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 157349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 157354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157364 */     GIR_RootConstrainSelectedInstOperands,
     /* 157365 */     // GIR_Coverage, 4620,
     /* 157365 */     GIR_EraseRootFromParent_Done,
     /* 157366 */   // Label 2379: @157366
     /* 157366 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(157419), // Rule ID 4622 //
     /* 157371 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 157376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 157387 */     // (st p3:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 157387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 157390 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 157392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 157397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 157402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 157407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157417 */     GIR_RootConstrainSelectedInstOperands,
     /* 157418 */     // GIR_Coverage, 4622,
     /* 157418 */     GIR_EraseRootFromParent_Done,
     /* 157419 */   // Label 2380: @157419
     /* 157419 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(157471), // Rule ID 7900 //
     /* 157424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 157427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 157431 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 157447 */     // (AMDGPUst_glue p3:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 157447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 157450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 157455 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157469 */     GIR_RootConstrainSelectedInstOperands,
     /* 157470 */     // GIR_Coverage, 7900,
     /* 157470 */     GIR_EraseRootFromParent_Done,
     /* 157471 */   // Label 2381: @157471
     /* 157471 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(157519), // Rule ID 7901 //
     /* 157476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 157479 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 157495 */     // (st p3:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 157495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 157498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 157503 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157517 */     GIR_RootConstrainSelectedInstOperands,
     /* 157518 */     // GIR_Coverage, 7901,
     /* 157518 */     GIR_EraseRootFromParent_Done,
     /* 157519 */   // Label 2382: @157519
     /* 157519 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(157572), // Rule ID 3882 //
     /* 157524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 157527 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 157532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 157543 */     // (st p3:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 157543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 157546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 157551 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 157558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 157563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157570 */     GIR_RootConstrainSelectedInstOperands,
     /* 157571 */     // GIR_Coverage, 3882,
     /* 157571 */     GIR_EraseRootFromParent_Done,
     /* 157572 */   // Label 2383: @157572
     /* 157572 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(157620), // Rule ID 3881 //
     /* 157577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 157580 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 157585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 157596 */     // (st p3:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 157596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 157599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157604 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157618 */     GIR_RootConstrainSelectedInstOperands,
     /* 157619 */     // GIR_Coverage, 3881,
     /* 157619 */     GIR_EraseRootFromParent_Done,
     /* 157620 */   // Label 2384: @157620
     /* 157620 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(157669), // Rule ID 3623 //
     /* 157625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 157628 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 157634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 157645 */     // (st p3:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 157645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 157648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157653 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157667 */     GIR_RootConstrainSelectedInstOperands,
     /* 157668 */     // GIR_Coverage, 3623,
     /* 157668 */     GIR_EraseRootFromParent_Done,
     /* 157669 */   // Label 2385: @157669
     /* 157669 */   GIM_Reject,
     /* 157670 */ // Label 2369: @157670
     /* 157670 */ GIM_Reject,
     /* 157671 */ // Label 2304: @157671
     /* 157671 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(158663),
     /* 157676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157679 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(157740), // Rule ID 8086 //
     /* 157684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 157687 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 157691 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157696 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 157709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 157716 */     // (AMDGPUst_glue p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 157716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 157719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 157724 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157738 */     GIR_RootConstrainSelectedInstOperands,
     /* 157739 */     // GIR_Coverage, 8086,
     /* 157739 */     GIR_EraseRootFromParent_Done,
     /* 157740 */   // Label 2387: @157740
     /* 157740 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(157796), // Rule ID 8018 //
     /* 157745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 157748 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 157752 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157757 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 157761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 157772 */     // (AMDGPUst_glue p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 157772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 157775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 157780 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157794 */     GIR_RootConstrainSelectedInstOperands,
     /* 157795 */     // GIR_Coverage, 8018,
     /* 157795 */     GIR_EraseRootFromParent_Done,
     /* 157796 */   // Label 2388: @157796
     /* 157796 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(157853), // Rule ID 8087 //
     /* 157801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 157804 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157809 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157818 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 157822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 157829 */     // (st p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 157829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 157832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 157837 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157851 */     GIR_RootConstrainSelectedInstOperands,
     /* 157852 */     // GIR_Coverage, 8087,
     /* 157852 */     GIR_EraseRootFromParent_Done,
     /* 157853 */   // Label 2389: @157853
     /* 157853 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(157905), // Rule ID 8019 //
     /* 157858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 157861 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157866 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 157870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 157881 */     // (st p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 157881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 157884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 157889 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157903 */     GIR_RootConstrainSelectedInstOperands,
     /* 157904 */     // GIR_Coverage, 8019,
     /* 157904 */     GIR_EraseRootFromParent_Done,
     /* 157905 */   // Label 2390: @157905
     /* 157905 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(157958), // Rule ID 4344 //
     /* 157910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 157913 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 157918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 157929 */     // (st p4:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 157929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 157932 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 157944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 157949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157956 */     GIR_RootConstrainSelectedInstOperands,
     /* 157957 */     // GIR_Coverage, 4344,
     /* 157957 */     GIR_EraseRootFromParent_Done,
     /* 157958 */   // Label 2391: @157958
     /* 157958 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(158006), // Rule ID 4343 //
     /* 157963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 157966 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 157971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 157982 */     // (st p4:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 157982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 157985 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 157987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 157992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158004 */     GIR_RootConstrainSelectedInstOperands,
     /* 158005 */     // GIR_Coverage, 4343,
     /* 158005 */     GIR_EraseRootFromParent_Done,
     /* 158006 */   // Label 2392: @158006
     /* 158006 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(158054), // Rule ID 4342 //
     /* 158011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 158014 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 158030 */     // (st p4:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 158030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 158033 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 158040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158052 */     GIR_RootConstrainSelectedInstOperands,
     /* 158053 */     // GIR_Coverage, 4342,
     /* 158053 */     GIR_EraseRootFromParent_Done,
     /* 158054 */   // Label 2393: @158054
     /* 158054 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(158115), // Rule ID 4665 //
     /* 158059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 158062 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 158078 */     // (st p4:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 p4:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 158078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 158081 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 158083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 158088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 158098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 158103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158113 */     GIR_RootConstrainSelectedInstOperands,
     /* 158114 */     // GIR_Coverage, 4665,
     /* 158114 */     GIR_EraseRootFromParent_Done,
     /* 158115 */   // Label 2394: @158115
     /* 158115 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(158173), // Rule ID 4667 //
     /* 158120 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 158136 */     // (st p4:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 p4:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 158136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 158139 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 158141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 158146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 158156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 158161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158171 */     GIR_RootConstrainSelectedInstOperands,
     /* 158172 */     // GIR_Coverage, 4667,
     /* 158172 */     GIR_EraseRootFromParent_Done,
     /* 158173 */   // Label 2395: @158173
     /* 158173 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(158290), // Rule ID 7961 //
     /* 158178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 158181 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 158185 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 158201 */     // (AMDGPUst_glue p4:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 158201 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158204 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158208 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158213 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 158219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 158224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 158229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158241 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 158247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 158252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 158257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 158260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 158265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 158271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 158276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 158281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158288 */     GIR_RootConstrainSelectedInstOperands,
     /* 158289 */     // GIR_Coverage, 7961,
     /* 158289 */     GIR_EraseRootFromParent_Done,
     /* 158290 */   // Label 2396: @158290
     /* 158290 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(158346), // Rule ID 4664 //
     /* 158295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 158298 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 158314 */     // (st p4:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 158314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 158317 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 158319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 158329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158344 */     GIR_RootConstrainSelectedInstOperands,
     /* 158345 */     // GIR_Coverage, 4664,
     /* 158345 */     GIR_EraseRootFromParent_Done,
     /* 158346 */   // Label 2397: @158346
     /* 158346 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(158399), // Rule ID 4666 //
     /* 158351 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 158367 */     // (st p4:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 158367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 158370 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 158372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 158382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158397 */     GIR_RootConstrainSelectedInstOperands,
     /* 158398 */     // GIR_Coverage, 4666,
     /* 158398 */     GIR_EraseRootFromParent_Done,
     /* 158399 */   // Label 2398: @158399
     /* 158399 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(158512), // Rule ID 7963 //
     /* 158404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 158407 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 158423 */     // (st p4:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 158423 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158426 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158430 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158435 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 158441 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 158446 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 158451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158463 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 158469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 158474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 158479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 158482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 158487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 158493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 158498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 158503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158510 */     GIR_RootConstrainSelectedInstOperands,
     /* 158511 */     // GIR_Coverage, 7963,
     /* 158511 */     GIR_EraseRootFromParent_Done,
     /* 158512 */   // Label 2399: @158512
     /* 158512 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(158565), // Rule ID 3926 //
     /* 158517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 158520 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 158536 */     // (st p4:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 158536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 158539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 158544 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 158551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158563 */     GIR_RootConstrainSelectedInstOperands,
     /* 158564 */     // GIR_Coverage, 3926,
     /* 158564 */     GIR_EraseRootFromParent_Done,
     /* 158565 */   // Label 2400: @158565
     /* 158565 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(158613), // Rule ID 3925 //
     /* 158570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 158573 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 158589 */     // (st p4:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 158589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 158592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 158597 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158611 */     GIR_RootConstrainSelectedInstOperands,
     /* 158612 */     // GIR_Coverage, 3925,
     /* 158612 */     GIR_EraseRootFromParent_Done,
     /* 158613 */   // Label 2401: @158613
     /* 158613 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(158662), // Rule ID 3644 //
     /* 158618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 158621 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 158627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 158638 */     // (st p4:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 158638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 158641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 158646 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158660 */     GIR_RootConstrainSelectedInstOperands,
     /* 158661 */     // GIR_Coverage, 3644,
     /* 158661 */     GIR_EraseRootFromParent_Done,
     /* 158662 */   // Label 2402: @158662
     /* 158662 */   GIM_Reject,
     /* 158663 */ // Label 2386: @158663
     /* 158663 */ GIM_Reject,
     /* 158664 */ // Label 2305: @158664
     /* 158664 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(159534),
     /* 158669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158672 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(158728), // Rule ID 6625 //
     /* 158677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 158680 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 158696 */     // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 158696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 158699 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 158701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 158711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158726 */     GIR_RootConstrainSelectedInstOperands,
     /* 158727 */     // GIR_Coverage, 6625,
     /* 158727 */     GIR_EraseRootFromParent_Done,
     /* 158728 */   // Label 2404: @158728
     /* 158728 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(158784), // Rule ID 6627 //
     /* 158733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 158736 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 158752 */     // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 158752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 158755 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 158757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 158767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158782 */     GIR_RootConstrainSelectedInstOperands,
     /* 158783 */     // GIR_Coverage, 6627,
     /* 158783 */     GIR_EraseRootFromParent_Done,
     /* 158784 */   // Label 2405: @158784
     /* 158784 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(158837), // Rule ID 4284 //
     /* 158789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 158792 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 158808 */     // (st p5:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 158808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 158811 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 158818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 158823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158835 */     GIR_RootConstrainSelectedInstOperands,
     /* 158836 */     // GIR_Coverage, 4284,
     /* 158836 */     GIR_EraseRootFromParent_Done,
     /* 158837 */   // Label 2406: @158837
     /* 158837 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(158885), // Rule ID 4283 //
     /* 158842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 158845 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 158861 */     // (st p5:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 158861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 158864 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 158871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158883 */     GIR_RootConstrainSelectedInstOperands,
     /* 158884 */     // GIR_Coverage, 4283,
     /* 158884 */     GIR_EraseRootFromParent_Done,
     /* 158885 */   // Label 2407: @158885
     /* 158885 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(158933), // Rule ID 4282 //
     /* 158890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 158893 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 158909 */     // (st p5:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 158909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 158912 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 158919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158931 */     GIR_RootConstrainSelectedInstOperands,
     /* 158932 */     // GIR_Coverage, 4282,
     /* 158932 */     GIR_EraseRootFromParent_Done,
     /* 158933 */   // Label 2408: @158933
     /* 158933 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(158994), // Rule ID 4625 //
     /* 158938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 158941 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 158957 */     // (st p5:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p5:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 158957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 158960 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 158962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 158967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 158977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 158982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158992 */     GIR_RootConstrainSelectedInstOperands,
     /* 158993 */     // GIR_Coverage, 4625,
     /* 158993 */     GIR_EraseRootFromParent_Done,
     /* 158994 */   // Label 2409: @158994
     /* 158994 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(159052), // Rule ID 4627 //
     /* 158999 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 159015 */     // (st p5:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p5:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 159015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 159018 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 159020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 159025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 159035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 159040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159050 */     GIR_RootConstrainSelectedInstOperands,
     /* 159051 */     // GIR_Coverage, 4627,
     /* 159051 */     GIR_EraseRootFromParent_Done,
     /* 159052 */   // Label 2410: @159052
     /* 159052 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(159113), // Rule ID 6624 //
     /* 159057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 159060 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 159076 */     // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 159076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 159079 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 159086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 159096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 159101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159111 */     GIR_RootConstrainSelectedInstOperands,
     /* 159112 */     // GIR_Coverage, 6624,
     /* 159112 */     GIR_EraseRootFromParent_Done,
     /* 159113 */   // Label 2411: @159113
     /* 159113 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(159174), // Rule ID 6626 //
     /* 159118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 159121 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 159137 */     // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 159137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 159140 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 159147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 159157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 159162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159172 */     GIR_RootConstrainSelectedInstOperands,
     /* 159173 */     // GIR_Coverage, 6626,
     /* 159173 */     GIR_EraseRootFromParent_Done,
     /* 159174 */   // Label 2412: @159174
     /* 159174 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(159230), // Rule ID 4624 //
     /* 159179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 159182 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 159198 */     // (st p5:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 159198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 159201 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 159203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 159213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159228 */     GIR_RootConstrainSelectedInstOperands,
     /* 159229 */     // GIR_Coverage, 4624,
     /* 159229 */     GIR_EraseRootFromParent_Done,
     /* 159230 */   // Label 2413: @159230
     /* 159230 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(159283), // Rule ID 4626 //
     /* 159235 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 159251 */     // (st p5:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 159251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 159254 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 159256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 159266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159281 */     GIR_RootConstrainSelectedInstOperands,
     /* 159282 */     // GIR_Coverage, 4626,
     /* 159282 */     GIR_EraseRootFromParent_Done,
     /* 159283 */   // Label 2414: @159283
     /* 159283 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(159335), // Rule ID 7902 //
     /* 159288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 159291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 159295 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 159300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 159311 */     // (AMDGPUst_glue p5:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 159311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 159314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 159319 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159333 */     GIR_RootConstrainSelectedInstOperands,
     /* 159334 */     // GIR_Coverage, 7902,
     /* 159334 */     GIR_EraseRootFromParent_Done,
     /* 159335 */   // Label 2415: @159335
     /* 159335 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(159383), // Rule ID 7903 //
     /* 159340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 159343 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 159348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 159359 */     // (st p5:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 159359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 159362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 159367 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159381 */     GIR_RootConstrainSelectedInstOperands,
     /* 159382 */     // GIR_Coverage, 7903,
     /* 159382 */     GIR_EraseRootFromParent_Done,
     /* 159383 */   // Label 2416: @159383
     /* 159383 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(159436), // Rule ID 3886 //
     /* 159388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 159391 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 159407 */     // (st p5:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 159407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 159410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 159415 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 159422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159434 */     GIR_RootConstrainSelectedInstOperands,
     /* 159435 */     // GIR_Coverage, 3886,
     /* 159435 */     GIR_EraseRootFromParent_Done,
     /* 159436 */   // Label 2417: @159436
     /* 159436 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(159484), // Rule ID 3885 //
     /* 159441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 159444 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 159460 */     // (st p5:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 159460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 159463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 159468 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159482 */     GIR_RootConstrainSelectedInstOperands,
     /* 159483 */     // GIR_Coverage, 3885,
     /* 159483 */     GIR_EraseRootFromParent_Done,
     /* 159484 */   // Label 2418: @159484
     /* 159484 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(159533), // Rule ID 3625 //
     /* 159489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 159492 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 159498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 159509 */     // (st p5:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 159509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 159512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 159517 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159531 */     GIR_RootConstrainSelectedInstOperands,
     /* 159532 */     // GIR_Coverage, 3625,
     /* 159532 */     GIR_EraseRootFromParent_Done,
     /* 159533 */   // Label 2419: @159533
     /* 159533 */   GIM_Reject,
     /* 159534 */ // Label 2403: @159534
     /* 159534 */ GIM_Reject,
     /* 159535 */ // Label 2306: @159535
     /* 159535 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(160405),
     /* 159540 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159543 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(159599), // Rule ID 6629 //
     /* 159548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 159551 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 159567 */     // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 159567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 159570 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 159582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159597 */     GIR_RootConstrainSelectedInstOperands,
     /* 159598 */     // GIR_Coverage, 6629,
     /* 159598 */     GIR_EraseRootFromParent_Done,
     /* 159599 */   // Label 2421: @159599
     /* 159599 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(159655), // Rule ID 6631 //
     /* 159604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 159607 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 159623 */     // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 159623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 159626 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 159638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159653 */     GIR_RootConstrainSelectedInstOperands,
     /* 159654 */     // GIR_Coverage, 6631,
     /* 159654 */     GIR_EraseRootFromParent_Done,
     /* 159655 */   // Label 2422: @159655
     /* 159655 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(159708), // Rule ID 4290 //
     /* 159660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 159663 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 159679 */     // (st p6:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 159679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 159682 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 159689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 159694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159706 */     GIR_RootConstrainSelectedInstOperands,
     /* 159707 */     // GIR_Coverage, 4290,
     /* 159707 */     GIR_EraseRootFromParent_Done,
     /* 159708 */   // Label 2423: @159708
     /* 159708 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(159756), // Rule ID 4289 //
     /* 159713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 159716 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 159732 */     // (st p6:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 159732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 159735 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 159742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159754 */     GIR_RootConstrainSelectedInstOperands,
     /* 159755 */     // GIR_Coverage, 4289,
     /* 159755 */     GIR_EraseRootFromParent_Done,
     /* 159756 */   // Label 2424: @159756
     /* 159756 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(159804), // Rule ID 4288 //
     /* 159761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 159764 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 159780 */     // (st p6:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 159780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 159783 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 159790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159802 */     GIR_RootConstrainSelectedInstOperands,
     /* 159803 */     // GIR_Coverage, 4288,
     /* 159803 */     GIR_EraseRootFromParent_Done,
     /* 159804 */   // Label 2425: @159804
     /* 159804 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(159865), // Rule ID 4629 //
     /* 159809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 159812 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 159828 */     // (st p6:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p6:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 159828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 159831 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 159833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 159838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 159848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 159853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159863 */     GIR_RootConstrainSelectedInstOperands,
     /* 159864 */     // GIR_Coverage, 4629,
     /* 159864 */     GIR_EraseRootFromParent_Done,
     /* 159865 */   // Label 2426: @159865
     /* 159865 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(159923), // Rule ID 4631 //
     /* 159870 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 159886 */     // (st p6:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p6:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 159886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 159889 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 159891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 159896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 159906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 159911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159921 */     GIR_RootConstrainSelectedInstOperands,
     /* 159922 */     // GIR_Coverage, 4631,
     /* 159922 */     GIR_EraseRootFromParent_Done,
     /* 159923 */   // Label 2427: @159923
     /* 159923 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(159984), // Rule ID 6628 //
     /* 159928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 159931 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 159947 */     // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 159947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 159950 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 159957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 159967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 159972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159982 */     GIR_RootConstrainSelectedInstOperands,
     /* 159983 */     // GIR_Coverage, 6628,
     /* 159983 */     GIR_EraseRootFromParent_Done,
     /* 159984 */   // Label 2428: @159984
     /* 159984 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(160045), // Rule ID 6630 //
     /* 159989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 159992 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 160008 */     // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 160011 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 160018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 160028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 160033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160043 */     GIR_RootConstrainSelectedInstOperands,
     /* 160044 */     // GIR_Coverage, 6630,
     /* 160044 */     GIR_EraseRootFromParent_Done,
     /* 160045 */   // Label 2429: @160045
     /* 160045 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(160101), // Rule ID 4628 //
     /* 160050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 160053 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 160069 */     // (st p6:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 160069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 160072 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 160074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160099 */     GIR_RootConstrainSelectedInstOperands,
     /* 160100 */     // GIR_Coverage, 4628,
     /* 160100 */     GIR_EraseRootFromParent_Done,
     /* 160101 */   // Label 2430: @160101
     /* 160101 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(160154), // Rule ID 4630 //
     /* 160106 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 160122 */     // (st p6:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 160122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 160125 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 160127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160152 */     GIR_RootConstrainSelectedInstOperands,
     /* 160153 */     // GIR_Coverage, 4630,
     /* 160153 */     GIR_EraseRootFromParent_Done,
     /* 160154 */   // Label 2431: @160154
     /* 160154 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(160206), // Rule ID 7904 //
     /* 160159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 160162 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 160166 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 160171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 160182 */     // (AMDGPUst_glue p6:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 160182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 160185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 160190 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160204 */     GIR_RootConstrainSelectedInstOperands,
     /* 160205 */     // GIR_Coverage, 7904,
     /* 160205 */     GIR_EraseRootFromParent_Done,
     /* 160206 */   // Label 2432: @160206
     /* 160206 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(160254), // Rule ID 7905 //
     /* 160211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 160214 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 160219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 160230 */     // (st p6:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 160230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 160233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 160238 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160252 */     GIR_RootConstrainSelectedInstOperands,
     /* 160253 */     // GIR_Coverage, 7905,
     /* 160253 */     GIR_EraseRootFromParent_Done,
     /* 160254 */   // Label 2433: @160254
     /* 160254 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(160307), // Rule ID 3890 //
     /* 160259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 160262 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 160278 */     // (st p6:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 160278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 160281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 160286 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 160293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160305 */     GIR_RootConstrainSelectedInstOperands,
     /* 160306 */     // GIR_Coverage, 3890,
     /* 160306 */     GIR_EraseRootFromParent_Done,
     /* 160307 */   // Label 2434: @160307
     /* 160307 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(160355), // Rule ID 3889 //
     /* 160312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 160315 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 160331 */     // (st p6:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 160331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 160334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160339 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160353 */     GIR_RootConstrainSelectedInstOperands,
     /* 160354 */     // GIR_Coverage, 3889,
     /* 160354 */     GIR_EraseRootFromParent_Done,
     /* 160355 */   // Label 2435: @160355
     /* 160355 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(160404), // Rule ID 3627 //
     /* 160360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 160363 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 160369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 160380 */     // (st p6:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 160380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 160383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160388 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160402 */     GIR_RootConstrainSelectedInstOperands,
     /* 160403 */     // GIR_Coverage, 3627,
     /* 160403 */     GIR_EraseRootFromParent_Done,
     /* 160404 */   // Label 2436: @160404
     /* 160404 */   GIM_Reject,
     /* 160405 */ // Label 2420: @160405
     /* 160405 */ GIM_Reject,
     /* 160406 */ // Label 2307: @160406
     /* 160406 */ GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(160476), // Rule ID 6593 //
     /* 160411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 160414 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160417 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 160421 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 160428 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160433 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160437 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 160444 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
     /* 160447 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160470 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160474 */   GIR_RootConstrainSelectedInstOperands,
     /* 160475 */   // GIR_Coverage, 6593,
     /* 160475 */   GIR_EraseRootFromParent_Done,
     /* 160476 */ // Label 2437: @160476
     /* 160476 */ GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(160546), // Rule ID 6595 //
     /* 160481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 160484 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160487 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 160491 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 160498 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160503 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160507 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 160514 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
     /* 160517 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160540 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160544 */   GIR_RootConstrainSelectedInstOperands,
     /* 160545 */   // GIR_Coverage, 6595,
     /* 160545 */   GIR_EraseRootFromParent_Done,
     /* 160546 */ // Label 2438: @160546
     /* 160546 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(160605), // Rule ID 6597 //
     /* 160551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 160554 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160557 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160562 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160566 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 160573 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
     /* 160576 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160599 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160603 */   GIR_RootConstrainSelectedInstOperands,
     /* 160604 */   // GIR_Coverage, 6597,
     /* 160604 */   GIR_EraseRootFromParent_Done,
     /* 160605 */ // Label 2439: @160605
     /* 160605 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(160664), // Rule ID 6599 //
     /* 160610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 160613 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160616 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160625 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 160632 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
     /* 160635 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160658 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160662 */   GIR_RootConstrainSelectedInstOperands,
     /* 160663 */   // GIR_Coverage, 6599,
     /* 160663 */   GIR_EraseRootFromParent_Done,
     /* 160664 */ // Label 2440: @160664
     /* 160664 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(160731), // Rule ID 4212 //
     /* 160669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /* 160672 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160675 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 160679 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 160686 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160691 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160695 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 160702 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 160702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS),
     /* 160705 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160712 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 160717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160725 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160729 */   GIR_RootConstrainSelectedInstOperands,
     /* 160730 */   // GIR_Coverage, 4212,
     /* 160730 */   GIR_EraseRootFromParent_Done,
     /* 160731 */ // Label 2441: @160731
     /* 160731 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(160798), // Rule ID 4230 //
     /* 160736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /* 160739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160742 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 160746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 160753 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160758 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160762 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 160769 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 160769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS),
     /* 160772 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 160784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160792 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160796 */   GIR_RootConstrainSelectedInstOperands,
     /* 160797 */   // GIR_Coverage, 4230,
     /* 160797 */   GIR_EraseRootFromParent_Done,
     /* 160798 */ // Label 2442: @160798
     /* 160798 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(160865), // Rule ID 4242 //
     /* 160803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /* 160806 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160809 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 160813 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 160820 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160825 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160829 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 160836 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS_t16 anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 160836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS_t16),
     /* 160839 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 160851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160863 */   GIR_RootConstrainSelectedInstOperands,
     /* 160864 */   // GIR_Coverage, 4242,
     /* 160864 */   GIR_EraseRootFromParent_Done,
     /* 160865 */ // Label 2443: @160865
     /* 160865 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(160921), // Rule ID 3562 //
     /* 160870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /* 160873 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160876 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160881 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160885 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 160892 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SVS anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 160892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS),
     /* 160895 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 160907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160919 */   GIR_RootConstrainSelectedInstOperands,
     /* 160920 */   // GIR_Coverage, 3562,
     /* 160920 */   GIR_EraseRootFromParent_Done,
     /* 160921 */ // Label 2444: @160921
     /* 160921 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(160977), // Rule ID 3565 //
     /* 160926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /* 160929 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160932 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160937 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160941 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 160948 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SVS_t16 anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 160948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS_t16),
     /* 160951 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 160963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160971 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160975 */   GIR_RootConstrainSelectedInstOperands,
     /* 160976 */   // GIR_Coverage, 3565,
     /* 160976 */   GIR_EraseRootFromParent_Done,
     /* 160977 */ // Label 2445: @160977
     /* 160977 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(161033), // Rule ID 4227 //
     /* 160982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /* 160985 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160988 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160993 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160997 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 161004 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SVS anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS),
     /* 161007 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 161019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 161024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161027 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161031 */   GIR_RootConstrainSelectedInstOperands,
     /* 161032 */   // GIR_Coverage, 4227,
     /* 161032 */   GIR_EraseRootFromParent_Done,
     /* 161033 */ // Label 2446: @161033
     /* 161033 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(161095), // Rule ID 4211 //
     /* 161038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 161041 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161044 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161048 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161055 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161060 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161064 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 161071 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR),
     /* 161074 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161076 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161089 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161093 */   GIR_RootConstrainSelectedInstOperands,
     /* 161094 */   // GIR_Coverage, 4211,
     /* 161094 */   GIR_EraseRootFromParent_Done,
     /* 161095 */ // Label 2447: @161095
     /* 161095 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(161157), // Rule ID 4229 //
     /* 161100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 161103 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161106 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161110 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161117 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161122 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161126 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 161133 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR),
     /* 161136 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161151 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161155 */   GIR_RootConstrainSelectedInstOperands,
     /* 161156 */   // GIR_Coverage, 4229,
     /* 161156 */   GIR_EraseRootFromParent_Done,
     /* 161157 */ // Label 2448: @161157
     /* 161157 */ GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(161219), // Rule ID 4241 //
     /* 161162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 161165 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161168 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161179 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161188 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 161195 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR_t16 anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR_t16),
     /* 161198 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161217 */   GIR_RootConstrainSelectedInstOperands,
     /* 161218 */   // GIR_Coverage, 4241,
     /* 161218 */   GIR_EraseRootFromParent_Done,
     /* 161219 */ // Label 2449: @161219
     /* 161219 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(161270), // Rule ID 3561 //
     /* 161224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 161227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161230 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161235 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161239 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 161246 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SADDR anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR),
     /* 161249 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161264 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161268 */   GIR_RootConstrainSelectedInstOperands,
     /* 161269 */   // GIR_Coverage, 3561,
     /* 161269 */   GIR_EraseRootFromParent_Done,
     /* 161270 */ // Label 2450: @161270
     /* 161270 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(161321), // Rule ID 3564 //
     /* 161275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 161278 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161281 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161286 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161290 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 161297 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SADDR_t16 anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR_t16),
     /* 161300 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161315 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161319 */   GIR_RootConstrainSelectedInstOperands,
     /* 161320 */   // GIR_Coverage, 3564,
     /* 161320 */   GIR_EraseRootFromParent_Done,
     /* 161321 */ // Label 2451: @161321
     /* 161321 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(161372), // Rule ID 4226 //
     /* 161326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 161329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161332 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 161348 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SADDR anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR),
     /* 161351 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161366 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161370 */   GIR_RootConstrainSelectedInstOperands,
     /* 161371 */   // GIR_Coverage, 4226,
     /* 161371 */   GIR_EraseRootFromParent_Done,
     /* 161372 */ // Label 2452: @161372
     /* 161372 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(161434), // Rule ID 4210 //
     /* 161377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 161380 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161383 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161387 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161394 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161399 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161403 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 161410 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 161410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE),
     /* 161413 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161428 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161432 */   GIR_RootConstrainSelectedInstOperands,
     /* 161433 */   // GIR_Coverage, 4210,
     /* 161433 */   GIR_EraseRootFromParent_Done,
     /* 161434 */ // Label 2453: @161434
     /* 161434 */ GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(161496), // Rule ID 4228 //
     /* 161439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 161442 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161445 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161449 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161456 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161461 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161465 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 161472 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 161472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE),
     /* 161475 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161477 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161490 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161494 */   GIR_RootConstrainSelectedInstOperands,
     /* 161495 */   // GIR_Coverage, 4228,
     /* 161495 */   GIR_EraseRootFromParent_Done,
     /* 161496 */ // Label 2454: @161496
     /* 161496 */ GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(161558), // Rule ID 4240 //
     /* 161501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 161504 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161507 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161511 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161518 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161523 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161527 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 161534 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_t16 anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 161534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_t16),
     /* 161537 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161552 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161556 */   GIR_RootConstrainSelectedInstOperands,
     /* 161557 */   // GIR_Coverage, 4240,
     /* 161557 */   GIR_EraseRootFromParent_Done,
     /* 161558 */ // Label 2455: @161558
     /* 161558 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(161609), // Rule ID 3560 //
     /* 161563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 161566 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161569 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161574 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161578 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 161585 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 161585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT),
     /* 161588 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161603 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161607 */   GIR_RootConstrainSelectedInstOperands,
     /* 161608 */   // GIR_Coverage, 3560,
     /* 161608 */   GIR_EraseRootFromParent_Done,
     /* 161609 */ // Label 2456: @161609
     /* 161609 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(161660), // Rule ID 3563 //
     /* 161614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 161617 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161620 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161625 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161629 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 161636 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_t16 anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 161636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_t16),
     /* 161639 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161654 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161658 */   GIR_RootConstrainSelectedInstOperands,
     /* 161659 */   // GIR_Coverage, 3563,
     /* 161659 */   GIR_EraseRootFromParent_Done,
     /* 161660 */ // Label 2457: @161660
     /* 161660 */ GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(161711), // Rule ID 4225 //
     /* 161665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 161668 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161671 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161676 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161680 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 161687 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 161687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT),
     /* 161690 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161705 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161709 */   GIR_RootConstrainSelectedInstOperands,
     /* 161710 */   // GIR_Coverage, 4225,
     /* 161710 */   GIR_EraseRootFromParent_Done,
     /* 161711 */ // Label 2458: @161711
     /* 161711 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(161782), // Rule ID 6570 //
     /* 161716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 161719 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 161722 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161729 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 161734 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161738 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 161745 */   // (atomic_store i16:{ *:[i16] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (BUFFER_STORE_BYTE_ADDR64 ?:{ *:[i16] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 161745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_ADDR64),
     /* 161748 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 161750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 161755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 161760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 161765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 161770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161776 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161780 */   GIR_RootConstrainSelectedInstOperands,
     /* 161781 */   // GIR_Coverage, 6570,
     /* 161781 */   GIR_EraseRootFromParent_Done,
     /* 161782 */ // Label 2459: @161782
     /* 161782 */ GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(161853), // Rule ID 6574 //
     /* 161787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 161790 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 161793 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 161800 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 161805 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161809 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 161816 */   // (atomic_store i16:{ *:[i16] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (BUFFER_STORE_SHORT_ADDR64 ?:{ *:[i16] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 161816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_ADDR64),
     /* 161819 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 161821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 161826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 161831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 161836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 161841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161847 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161851 */   GIR_RootConstrainSelectedInstOperands,
     /* 161852 */   // GIR_Coverage, 6574,
     /* 161852 */   GIR_EraseRootFromParent_Done,
     /* 161853 */ // Label 2460: @161853
     /* 161853 */ GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(161928), // Rule ID 6592 //
     /* 161858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 161861 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161864 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161868 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161875 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 161891 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 161891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFEN),
     /* 161894 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 161896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 161901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 161906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 161911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 161916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161922 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161926 */   GIR_RootConstrainSelectedInstOperands,
     /* 161927 */   // GIR_Coverage, 6592,
     /* 161927 */   GIR_EraseRootFromParent_Done,
     /* 161928 */ // Label 2461: @161928
     /* 161928 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(162003), // Rule ID 6594 //
     /* 161933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 161936 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161939 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161943 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 161950 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161955 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161959 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 161966 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 161966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFEN),
     /* 161969 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 161971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 161976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 161981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 161986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 161991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162001 */   GIR_RootConstrainSelectedInstOperands,
     /* 162002 */   // GIR_Coverage, 6594,
     /* 162002 */   GIR_EraseRootFromParent_Done,
     /* 162003 */ // Label 2462: @162003
     /* 162003 */ GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(162067), // Rule ID 6596 //
     /* 162008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 162011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162014 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 162019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162023 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 162030 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 162030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFEN),
     /* 162033 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 162040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 162050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 162055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162061 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162065 */   GIR_RootConstrainSelectedInstOperands,
     /* 162066 */   // GIR_Coverage, 6596,
     /* 162066 */   GIR_EraseRootFromParent_Done,
     /* 162067 */ // Label 2463: @162067
     /* 162067 */ GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(162131), // Rule ID 6598 //
     /* 162072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 162075 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162078 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 162083 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162087 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 162094 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 162094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFEN),
     /* 162097 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 162104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 162114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 162119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162125 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162129 */   GIR_RootConstrainSelectedInstOperands,
     /* 162130 */   // GIR_Coverage, 6598,
     /* 162130 */   GIR_EraseRootFromParent_Done,
     /* 162131 */ // Label 2464: @162131
     /* 162131 */ GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(162201), // Rule ID 6580 //
     /* 162136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 162139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162142 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 162146 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162153 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162158 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162162 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 162169 */   // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 162169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
     /* 162172 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 162174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 162184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162195 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162199 */   GIR_RootConstrainSelectedInstOperands,
     /* 162200 */   // GIR_Coverage, 6580,
     /* 162200 */   GIR_EraseRootFromParent_Done,
     /* 162201 */ // Label 2465: @162201
     /* 162201 */ GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(162268), // Rule ID 6581 //
     /* 162206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162209 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 162213 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162220 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162225 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162229 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 162236 */   // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 162236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
     /* 162239 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 162241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 162251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162262 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162266 */   GIR_RootConstrainSelectedInstOperands,
     /* 162267 */   // GIR_Coverage, 6581,
     /* 162267 */   GIR_EraseRootFromParent_Done,
     /* 162268 */ // Label 2466: @162268
     /* 162268 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(162327), // Rule ID 6582 //
     /* 162273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 162276 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162279 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162284 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162288 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 162295 */   // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_SHORT_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 162295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
     /* 162298 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 162300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 162310 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162321 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162325 */   GIR_RootConstrainSelectedInstOperands,
     /* 162326 */   // GIR_Coverage, 6582,
     /* 162326 */   GIR_EraseRootFromParent_Done,
     /* 162327 */ // Label 2467: @162327
     /* 162327 */ GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(162383), // Rule ID 6583 //
     /* 162332 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162335 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162340 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162344 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 162351 */   // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 162351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
     /* 162354 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 162356 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162361 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 162366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162377 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162381 */   GIR_RootConstrainSelectedInstOperands,
     /* 162382 */   // GIR_Coverage, 6583,
     /* 162382 */   GIR_EraseRootFromParent_Done,
     /* 162383 */ // Label 2468: @162383
     /* 162383 */ GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(162441), // Rule ID 7906 //
     /* 162388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 162391 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162394 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162401 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162417 */   // (AMDGPUatomic_st_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8_glue>><<P:Predicate_atomic_store_8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
     /* 162420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162425 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162435 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162439 */   GIR_RootConstrainSelectedInstOperands,
     /* 162440 */   // GIR_Coverage, 7906,
     /* 162440 */   GIR_EraseRootFromParent_Done,
     /* 162441 */ // Label 2469: @162441
     /* 162441 */ GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(162499), // Rule ID 7907 //
     /* 162446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 162449 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162459 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162464 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162468 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162475 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 162478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162483 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162493 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162497 */   GIR_RootConstrainSelectedInstOperands,
     /* 162498 */   // GIR_Coverage, 7907,
     /* 162498 */   GIR_EraseRootFromParent_Done,
     /* 162499 */ // Label 2470: @162499
     /* 162499 */ GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(162557), // Rule ID 7908 //
     /* 162504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 162507 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162510 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162517 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162522 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162526 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162533 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 162536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162541 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162551 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162555 */   GIR_RootConstrainSelectedInstOperands,
     /* 162556 */   // GIR_Coverage, 7908,
     /* 162556 */   GIR_EraseRootFromParent_Done,
     /* 162557 */ // Label 2471: @162557
     /* 162557 */ GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(162615), // Rule ID 7909 //
     /* 162562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 162565 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162568 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162575 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162580 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162584 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162591 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_t16 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_t16),
     /* 162594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162599 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162609 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162613 */   GIR_RootConstrainSelectedInstOperands,
     /* 162614 */   // GIR_Coverage, 7909,
     /* 162614 */   GIR_EraseRootFromParent_Done,
     /* 162615 */ // Label 2472: @162615
     /* 162615 */ GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(162673), // Rule ID 7912 //
     /* 162620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 162623 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162626 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 162633 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162638 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162642 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162649 */   // (AMDGPUatomic_st_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16_glue>><<P:Predicate_atomic_store_16_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
     /* 162652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162657 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162667 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162671 */   GIR_RootConstrainSelectedInstOperands,
     /* 162672 */   // GIR_Coverage, 7912,
     /* 162672 */   GIR_EraseRootFromParent_Done,
     /* 162673 */ // Label 2473: @162673
     /* 162673 */ GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(162731), // Rule ID 7913 //
     /* 162678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 162681 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162684 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 162691 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162696 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162700 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162707 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 162710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162715 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162725 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162729 */   GIR_RootConstrainSelectedInstOperands,
     /* 162730 */   // GIR_Coverage, 7913,
     /* 162730 */   GIR_EraseRootFromParent_Done,
     /* 162731 */ // Label 2474: @162731
     /* 162731 */ GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(162789), // Rule ID 7914 //
     /* 162736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 162739 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162742 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 162749 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162754 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162758 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162765 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 162768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162773 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162783 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162787 */   GIR_RootConstrainSelectedInstOperands,
     /* 162788 */   // GIR_Coverage, 7914,
     /* 162788 */   GIR_EraseRootFromParent_Done,
     /* 162789 */ // Label 2475: @162789
     /* 162789 */ GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(162847), // Rule ID 7915 //
     /* 162794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 162797 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 162800 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 162807 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162812 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162816 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162823 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_t16 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_t16),
     /* 162826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162831 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162841 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162845 */   GIR_RootConstrainSelectedInstOperands,
     /* 162846 */   // GIR_Coverage, 7915,
     /* 162846 */   GIR_EraseRootFromParent_Done,
     /* 162847 */ // Label 2476: @162847
     /* 162847 */ GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(162909), // Rule ID 7880 //
     /* 162852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 162855 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162858 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 162862 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162869 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162874 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162878 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162885 */   // (AMDGPUst_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_truncstore_glue>><<P:Predicate_truncstorei8_glue>><<P:Predicate_truncstorei8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
     /* 162888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162893 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162907 */   GIR_RootConstrainSelectedInstOperands,
     /* 162908 */   // GIR_Coverage, 7880,
     /* 162908 */   GIR_EraseRootFromParent_Done,
     /* 162909 */ // Label 2477: @162909
     /* 162909 */ GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(162971), // Rule ID 7881 //
     /* 162914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 162917 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162920 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 162924 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162931 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162936 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162940 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 162947 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 162947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 162950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162955 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162965 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162969 */   GIR_RootConstrainSelectedInstOperands,
     /* 162970 */   // GIR_Coverage, 7881,
     /* 162970 */   GIR_EraseRootFromParent_Done,
     /* 162971 */ // Label 2478: @162971
     /* 162971 */ GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(163033), // Rule ID 7882 //
     /* 162976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 162979 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162982 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 162986 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 162993 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162998 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163002 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163009 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_t16 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_t16),
     /* 163012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163017 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163027 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163031 */   GIR_RootConstrainSelectedInstOperands,
     /* 163032 */   // GIR_Coverage, 7882,
     /* 163032 */   GIR_EraseRootFromParent_Done,
     /* 163033 */ // Label 2479: @163033
     /* 163033 */ GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(163095), // Rule ID 7885 //
     /* 163038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 163041 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163044 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163048 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163055 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163060 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163064 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163071 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 163074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163079 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163089 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163093 */   GIR_RootConstrainSelectedInstOperands,
     /* 163094 */   // GIR_Coverage, 7885,
     /* 163094 */   GIR_EraseRootFromParent_Done,
     /* 163095 */ // Label 2480: @163095
     /* 163095 */ GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(163150), // Rule ID 7886 //
     /* 163100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 163103 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163106 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163110 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163115 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163119 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163126 */   // (AMDGPUst_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
     /* 163129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163134 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163144 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163148 */   GIR_RootConstrainSelectedInstOperands,
     /* 163149 */   // GIR_Coverage, 7886,
     /* 163149 */   GIR_EraseRootFromParent_Done,
     /* 163150 */ // Label 2481: @163150
     /* 163150 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(163201), // Rule ID 7887 //
     /* 163155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 163158 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163161 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163170 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163177 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 163180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163185 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163195 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163199 */   GIR_RootConstrainSelectedInstOperands,
     /* 163200 */   // GIR_Coverage, 7887,
     /* 163200 */   GIR_EraseRootFromParent_Done,
     /* 163201 */ // Label 2482: @163201
     /* 163201 */ GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(163252), // Rule ID 7888 //
     /* 163206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 163209 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163212 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163217 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163221 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163228 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 163231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163236 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163238 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163250 */   GIR_RootConstrainSelectedInstOperands,
     /* 163251 */   // GIR_Coverage, 7888,
     /* 163251 */   GIR_EraseRootFromParent_Done,
     /* 163252 */ // Label 2483: @163252
     /* 163252 */ GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(163303), // Rule ID 7889 //
     /* 163257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 163260 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163263 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163272 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163279 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B16_t16 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_t16),
     /* 163282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163287 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163301 */   GIR_RootConstrainSelectedInstOperands,
     /* 163302 */   // GIR_Coverage, 7889,
     /* 163302 */   GIR_EraseRootFromParent_Done,
     /* 163303 */ // Label 2484: @163303
     /* 163303 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(163366), // Rule ID 4000 //
     /* 163308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 163311 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 163314 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163321 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163330 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163337 */   // (atomic_store i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 163340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163345 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163360 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163364 */   GIR_RootConstrainSelectedInstOperands,
     /* 163365 */   // GIR_Coverage, 4000,
     /* 163365 */   GIR_EraseRootFromParent_Done,
     /* 163366 */ // Label 2485: @163366
     /* 163366 */ GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(163429), // Rule ID 4004 //
     /* 163371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 163374 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 163377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 163384 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163389 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163393 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163400 */   // (atomic_store i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 163403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163408 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163423 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163427 */   GIR_RootConstrainSelectedInstOperands,
     /* 163428 */   // GIR_Coverage, 4004,
     /* 163428 */   GIR_EraseRootFromParent_Done,
     /* 163429 */ // Label 2486: @163429
     /* 163429 */ GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(163496), // Rule ID 3552 //
     /* 163434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 163437 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163440 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163444 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163451 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163456 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163460 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163467 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR_t16 ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR_t16),
     /* 163470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163475 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163477 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163490 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163494 */   GIR_RootConstrainSelectedInstOperands,
     /* 163495 */   // GIR_Coverage, 3552,
     /* 163495 */   GIR_EraseRootFromParent_Done,
     /* 163496 */ // Label 2487: @163496
     /* 163496 */ GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(163563), // Rule ID 3964 //
     /* 163501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 163504 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163507 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163511 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163518 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163523 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163527 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163534 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 163537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163542 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163557 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163561 */   GIR_RootConstrainSelectedInstOperands,
     /* 163562 */   // GIR_Coverage, 3964,
     /* 163562 */   GIR_EraseRootFromParent_Done,
     /* 163563 */ // Label 2488: @163563
     /* 163563 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(163630), // Rule ID 3968 //
     /* 163568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 163571 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163574 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163578 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163585 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163594 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163601 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 163604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163609 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163628 */   GIR_RootConstrainSelectedInstOperands,
     /* 163629 */   // GIR_Coverage, 3968,
     /* 163629 */   GIR_EraseRootFromParent_Done,
     /* 163630 */ // Label 2489: @163630
     /* 163630 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(163686), // Rule ID 3860 //
     /* 163635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 163638 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163641 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163646 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163650 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163657 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT_SADDR_t16 ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR_t16),
     /* 163660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163665 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163680 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163684 */   GIR_RootConstrainSelectedInstOperands,
     /* 163685 */   // GIR_Coverage, 3860,
     /* 163685 */   GIR_EraseRootFromParent_Done,
     /* 163686 */ // Label 2490: @163686
     /* 163686 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(163742), // Rule ID 3966 //
     /* 163691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 163694 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163697 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163702 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163706 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163713 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 163716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163721 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163728 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163736 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163740 */   GIR_RootConstrainSelectedInstOperands,
     /* 163741 */   // GIR_Coverage, 3966,
     /* 163741 */   GIR_EraseRootFromParent_Done,
     /* 163742 */ // Label 2491: @163742
     /* 163742 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(163798), // Rule ID 3970 //
     /* 163747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 163750 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163753 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163758 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163762 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163769 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 163772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163777 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163792 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163796 */   GIR_RootConstrainSelectedInstOperands,
     /* 163797 */   // GIR_Coverage, 3970,
     /* 163797 */   GIR_EraseRootFromParent_Done,
     /* 163798 */ // Label 2492: @163798
     /* 163798 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(163856), // Rule ID 3999 //
     /* 163803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 163806 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 163809 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163816 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163821 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163825 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 163832 */   // (atomic_store i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 163832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 163835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 163840 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163850 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163854 */   GIR_RootConstrainSelectedInstOperands,
     /* 163855 */   // GIR_Coverage, 3999,
     /* 163855 */   GIR_EraseRootFromParent_Done,
     /* 163856 */ // Label 2493: @163856
     /* 163856 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(163914), // Rule ID 4003 //
     /* 163861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 163864 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 163867 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 163874 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163879 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163883 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 163890 */   // (atomic_store i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 163890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 163893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 163898 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163908 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163912 */   GIR_RootConstrainSelectedInstOperands,
     /* 163913 */   // GIR_Coverage, 4003,
     /* 163913 */   GIR_EraseRootFromParent_Done,
     /* 163914 */ // Label 2494: @163914
     /* 163914 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(163976), // Rule ID 3551 //
     /* 163919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 163922 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163925 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163929 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163936 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163941 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163945 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 163952 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_t16 ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 163952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_t16),
     /* 163955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 163960 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163970 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163974 */   GIR_RootConstrainSelectedInstOperands,
     /* 163975 */   // GIR_Coverage, 3551,
     /* 163975 */   GIR_EraseRootFromParent_Done,
     /* 163976 */ // Label 2495: @163976
     /* 163976 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(164038), // Rule ID 3963 //
     /* 163981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 163984 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163987 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163991 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 163998 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164003 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164007 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164014 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 164017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164022 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164032 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164036 */   GIR_RootConstrainSelectedInstOperands,
     /* 164037 */   // GIR_Coverage, 3963,
     /* 164037 */   GIR_EraseRootFromParent_Done,
     /* 164038 */ // Label 2496: @164038
     /* 164038 */ GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(164100), // Rule ID 3967 //
     /* 164043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 164046 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164049 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164053 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164060 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164069 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164076 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 164079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164084 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164094 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164098 */   GIR_RootConstrainSelectedInstOperands,
     /* 164099 */   // GIR_Coverage, 3967,
     /* 164099 */   GIR_EraseRootFromParent_Done,
     /* 164100 */ // Label 2497: @164100
     /* 164100 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(164151), // Rule ID 3859 //
     /* 164105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 164108 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164111 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164116 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164120 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164127 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT_t16 ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_t16),
     /* 164130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164135 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164149 */   GIR_RootConstrainSelectedInstOperands,
     /* 164150 */   // GIR_Coverage, 3859,
     /* 164150 */   GIR_EraseRootFromParent_Done,
     /* 164151 */ // Label 2498: @164151
     /* 164151 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(164202), // Rule ID 3965 //
     /* 164156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 164159 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164162 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164167 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164171 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164178 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 164181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164186 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164188 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164196 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164200 */   GIR_RootConstrainSelectedInstOperands,
     /* 164201 */   // GIR_Coverage, 3965,
     /* 164201 */   GIR_EraseRootFromParent_Done,
     /* 164202 */ // Label 2499: @164202
     /* 164202 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(164253), // Rule ID 3969 //
     /* 164207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 164210 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164213 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164218 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164222 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164229 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 164232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164237 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164247 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164251 */   GIR_RootConstrainSelectedInstOperands,
     /* 164252 */   // GIR_Coverage, 3969,
     /* 164252 */   GIR_EraseRootFromParent_Done,
     /* 164253 */ // Label 2500: @164253
     /* 164253 */ GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(164312), // Rule ID 3662 //
     /* 164258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 164261 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 164264 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164271 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164281 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164288 */   // (atomic_store i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 164291 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164296 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164306 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164310 */   GIR_RootConstrainSelectedInstOperands,
     /* 164311 */   // GIR_Coverage, 3662,
     /* 164311 */   GIR_EraseRootFromParent_Done,
     /* 164312 */ // Label 2501: @164312
     /* 164312 */ GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(164371), // Rule ID 3664 //
     /* 164317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 164320 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 164323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 164330 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164336 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164340 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164347 */   // (atomic_store i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 164350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164355 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164369 */   GIR_RootConstrainSelectedInstOperands,
     /* 164370 */   // GIR_Coverage, 3664,
     /* 164370 */   GIR_EraseRootFromParent_Done,
     /* 164371 */ // Label 2502: @164371
     /* 164371 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(164434), // Rule ID 3594 //
     /* 164376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /* 164379 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164382 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164386 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164393 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164399 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164403 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164410 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 164413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164418 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164428 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164432 */   GIR_RootConstrainSelectedInstOperands,
     /* 164433 */   // GIR_Coverage, 3594,
     /* 164433 */   GIR_EraseRootFromParent_Done,
     /* 164434 */ // Label 2503: @164434
     /* 164434 */ GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(164497), // Rule ID 3600 //
     /* 164439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /* 164442 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164445 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164449 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164456 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164462 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164466 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164473 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 164476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164481 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164491 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164495 */   GIR_RootConstrainSelectedInstOperands,
     /* 164496 */   // GIR_Coverage, 3600,
     /* 164496 */   GIR_EraseRootFromParent_Done,
     /* 164497 */ // Label 2504: @164497
     /* 164497 */ GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(164560), // Rule ID 3606 //
     /* 164502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /* 164505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164508 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164512 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164519 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164525 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164529 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164536 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE_t16 ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE_t16),
     /* 164539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164544 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164558 */   GIR_RootConstrainSelectedInstOperands,
     /* 164559 */   // GIR_Coverage, 3606,
     /* 164559 */   GIR_EraseRootFromParent_Done,
     /* 164560 */ // Label 2505: @164560
     /* 164560 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(164612), // Rule ID 3595 //
     /* 164565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /* 164568 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164571 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164577 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164581 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164588 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 164591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164596 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164606 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164610 */   GIR_RootConstrainSelectedInstOperands,
     /* 164611 */   // GIR_Coverage, 3595,
     /* 164611 */   GIR_EraseRootFromParent_Done,
     /* 164612 */ // Label 2506: @164612
     /* 164612 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(164664), // Rule ID 3601 //
     /* 164617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /* 164620 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164623 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164629 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164633 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164640 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 164643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164648 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164658 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164662 */   GIR_RootConstrainSelectedInstOperands,
     /* 164663 */   // GIR_Coverage, 3601,
     /* 164663 */   GIR_EraseRootFromParent_Done,
     /* 164664 */ // Label 2507: @164664
     /* 164664 */ GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(164716), // Rule ID 3607 //
     /* 164669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /* 164672 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164675 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164681 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164685 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164692 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_SHORT_t16 ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 164692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT_t16),
     /* 164695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164700 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164710 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164714 */   GIR_RootConstrainSelectedInstOperands,
     /* 164715 */   // GIR_Coverage, 3607,
     /* 164715 */   GIR_EraseRootFromParent_Done,
     /* 164716 */ // Label 2508: @164716
     /* 164716 */ GIM_Reject,
     /* 164717 */ // Label 2308: @164717
     /* 164717 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(164812), // Rule ID 6645 //
     /* 164722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
     /* 164725 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164728 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164732 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 164739 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164744 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 164748 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 164752 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164756 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164760 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 164764 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164768 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164770 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 164777 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 164777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_OFFSET),
     /* 164780 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 164784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 164789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 164794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164805 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164810 */   GIR_RootConstrainSelectedInstOperands,
     /* 164811 */   // GIR_Coverage, 6645,
     /* 164811 */   GIR_EraseRootFromParent_Done,
     /* 164812 */ // Label 2509: @164812
     /* 164812 */ GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(164907), // Rule ID 6647 //
     /* 164817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
     /* 164820 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164823 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164827 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 164834 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164839 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 164843 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 164847 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164851 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164855 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 164859 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164865 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 164872 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 164872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFSET),
     /* 164875 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 164879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 164884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 164889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164905 */   GIR_RootConstrainSelectedInstOperands,
     /* 164906 */   // GIR_Coverage, 6647,
     /* 164906 */   GIR_EraseRootFromParent_Done,
     /* 164907 */ // Label 2510: @164907
     /* 164907 */ GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(165002), // Rule ID 6649 //
     /* 164912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
     /* 164915 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164918 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164922 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164929 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 164938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 164942 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164946 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164950 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 164954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164958 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164960 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 164967 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 164967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_OFFSET),
     /* 164970 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 164974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 164979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 164984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164995 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165000 */   GIR_RootConstrainSelectedInstOperands,
     /* 165001 */   // GIR_Coverage, 6649,
     /* 165001 */   GIR_EraseRootFromParent_Done,
     /* 165002 */ // Label 2511: @165002
     /* 165002 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(165097), // Rule ID 6651 //
     /* 165007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
     /* 165010 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165013 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165017 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165024 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165029 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165033 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165037 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165041 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165045 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165049 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165053 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165055 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 165062 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 165062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFSET),
     /* 165065 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 165069 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 165074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 165079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 165084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165090 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165095 */   GIR_RootConstrainSelectedInstOperands,
     /* 165096 */   // GIR_Coverage, 6651,
     /* 165096 */   GIR_EraseRootFromParent_Done,
     /* 165097 */ // Label 2512: @165097
     /* 165097 */ GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(165189), // Rule ID 4395 //
     /* 165102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 165105 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165108 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165112 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 165119 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165124 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165128 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165132 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165136 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165140 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165148 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165150 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 165157 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_private>>  =>  (SCRATCH_STORE_SHORT_D16_HI_SVS anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_D16_HI_SVS),
     /* 165160 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 165164 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 165174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 165179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165187 */   GIR_RootConstrainSelectedInstOperands,
     /* 165188 */   // GIR_Coverage, 4395,
     /* 165188 */   GIR_EraseRootFromParent_Done,
     /* 165189 */ // Label 2513: @165189
     /* 165189 */ GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(165281), // Rule ID 4398 //
     /* 165194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 165197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165200 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165204 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165211 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165216 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165220 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165224 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165228 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165232 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165236 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165240 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165242 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 165249 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (SCRATCH_STORE_BYTE_D16_HI_SVS anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_D16_HI_SVS),
     /* 165252 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 165256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 165266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 165271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165274 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165279 */   GIR_RootConstrainSelectedInstOperands,
     /* 165280 */   // GIR_Coverage, 4398,
     /* 165280 */   GIR_EraseRootFromParent_Done,
     /* 165281 */ // Label 2514: @165281
     /* 165281 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(165368), // Rule ID 4394 //
     /* 165286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
     /* 165289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165292 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165296 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 165303 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165316 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165320 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165324 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165328 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165332 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165334 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 165341 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_private>>  =>  (SCRATCH_STORE_SHORT_D16_HI_SADDR anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_D16_HI_SADDR),
     /* 165344 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 165348 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 165353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165361 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165366 */   GIR_RootConstrainSelectedInstOperands,
     /* 165367 */   // GIR_Coverage, 4394,
     /* 165367 */   GIR_EraseRootFromParent_Done,
     /* 165368 */ // Label 2515: @165368
     /* 165368 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(165455), // Rule ID 4397 //
     /* 165373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
     /* 165376 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165379 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165383 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165390 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165395 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165399 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165403 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165407 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165411 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165419 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165421 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 165428 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (SCRATCH_STORE_BYTE_D16_HI_SADDR anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_D16_HI_SADDR),
     /* 165431 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 165435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 165440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165448 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165453 */   GIR_RootConstrainSelectedInstOperands,
     /* 165454 */   // GIR_Coverage, 4397,
     /* 165454 */   GIR_EraseRootFromParent_Done,
     /* 165455 */ // Label 2516: @165455
     /* 165455 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(165542), // Rule ID 4393 //
     /* 165460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
     /* 165463 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165466 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165470 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 165477 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165482 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165486 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165490 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165494 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165498 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165502 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165506 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165508 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 165515 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_private>>  =>  (SCRATCH_STORE_SHORT_D16_HI anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 165515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_D16_HI),
     /* 165518 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 165522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165540 */   GIR_RootConstrainSelectedInstOperands,
     /* 165541 */   // GIR_Coverage, 4393,
     /* 165541 */   GIR_EraseRootFromParent_Done,
     /* 165542 */ // Label 2517: @165542
     /* 165542 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(165629), // Rule ID 4396 //
     /* 165547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
     /* 165550 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165553 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165557 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165564 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165569 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165573 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165577 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165581 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165585 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165589 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165593 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165595 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 165602 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (SCRATCH_STORE_BYTE_D16_HI anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 165602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_D16_HI),
     /* 165605 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 165609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165622 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165627 */   GIR_RootConstrainSelectedInstOperands,
     /* 165628 */   // GIR_Coverage, 4396,
     /* 165628 */   GIR_EraseRootFromParent_Done,
     /* 165629 */ // Label 2518: @165629
     /* 165629 */ GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(165729), // Rule ID 6644 //
     /* 165634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
     /* 165637 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165640 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165644 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 165651 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165656 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165664 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165668 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165672 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165676 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165680 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165682 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 165689 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 165689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_OFFEN),
     /* 165692 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 165696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 165701 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 165706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 165711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 165716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165727 */   GIR_RootConstrainSelectedInstOperands,
     /* 165728 */   // GIR_Coverage, 6644,
     /* 165728 */   GIR_EraseRootFromParent_Done,
     /* 165729 */ // Label 2519: @165729
     /* 165729 */ GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(165829), // Rule ID 6646 //
     /* 165734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
     /* 165737 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165740 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165744 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 165751 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165756 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165764 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165768 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165772 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165776 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165780 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165782 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 165789 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 165789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFEN),
     /* 165792 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 165796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 165801 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 165806 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 165811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 165816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165822 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165827 */   GIR_RootConstrainSelectedInstOperands,
     /* 165828 */   // GIR_Coverage, 6646,
     /* 165828 */   GIR_EraseRootFromParent_Done,
     /* 165829 */ // Label 2520: @165829
     /* 165829 */ GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(165929), // Rule ID 6648 //
     /* 165834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
     /* 165837 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165840 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165844 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165851 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165856 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165860 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165864 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165868 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165872 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165876 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165880 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165882 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 165889 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 165889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_OFFEN),
     /* 165892 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 165896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 165901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 165906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 165911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 165916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165922 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165927 */   GIR_RootConstrainSelectedInstOperands,
     /* 165928 */   // GIR_Coverage, 6648,
     /* 165928 */   GIR_EraseRootFromParent_Done,
     /* 165929 */ // Label 2521: @165929
     /* 165929 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(166029), // Rule ID 6650 //
     /* 165934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
     /* 165937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165940 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165944 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165951 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165956 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 165960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 165964 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165968 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165972 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 165976 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165980 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165982 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 165989 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 165989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFEN),
     /* 165992 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 165996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 166001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 166011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 166016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166022 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166027 */   GIR_RootConstrainSelectedInstOperands,
     /* 166028 */   // GIR_Coverage, 6650,
     /* 166028 */   GIR_EraseRootFromParent_Done,
     /* 166029 */ // Label 2522: @166029
     /* 166029 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(166099), // Rule ID 6585 //
     /* 166034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 166037 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166040 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166044 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166051 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166056 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166060 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166067 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
     /* 166070 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166093 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166097 */   GIR_RootConstrainSelectedInstOperands,
     /* 166098 */   // GIR_Coverage, 6585,
     /* 166098 */   GIR_EraseRootFromParent_Done,
     /* 166099 */ // Label 2523: @166099
     /* 166099 */ GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(166169), // Rule ID 6587 //
     /* 166104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 166107 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166110 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166114 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166121 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166126 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166130 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166137 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
     /* 166140 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166152 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166163 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166167 */   GIR_RootConstrainSelectedInstOperands,
     /* 166168 */   // GIR_Coverage, 6587,
     /* 166168 */   GIR_EraseRootFromParent_Done,
     /* 166169 */ // Label 2524: @166169
     /* 166169 */ GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(166239), // Rule ID 6589 //
     /* 166174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 166177 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166180 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166184 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 166191 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166196 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166200 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166207 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
     /* 166210 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166237 */   GIR_RootConstrainSelectedInstOperands,
     /* 166238 */   // GIR_Coverage, 6589,
     /* 166238 */   GIR_EraseRootFromParent_Done,
     /* 166239 */ // Label 2525: @166239
     /* 166239 */ GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(166309), // Rule ID 6591 //
     /* 166244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 166247 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166250 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166254 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 166261 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166266 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166270 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166277 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
     /* 166280 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166303 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166307 */   GIR_RootConstrainSelectedInstOperands,
     /* 166308 */   // GIR_Coverage, 6591,
     /* 166308 */   GIR_EraseRootFromParent_Done,
     /* 166309 */ // Label 2526: @166309
     /* 166309 */ GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(166368), // Rule ID 6601 //
     /* 166314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 166317 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166320 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166325 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166329 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166336 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 166339 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166362 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166366 */   GIR_RootConstrainSelectedInstOperands,
     /* 166367 */   // GIR_Coverage, 6601,
     /* 166367 */   GIR_EraseRootFromParent_Done,
     /* 166368 */ // Label 2527: @166368
     /* 166368 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(166427), // Rule ID 6603 //
     /* 166373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 166376 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166379 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166384 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166388 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166395 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 166398 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166421 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166425 */   GIR_RootConstrainSelectedInstOperands,
     /* 166426 */   // GIR_Coverage, 6603,
     /* 166426 */   GIR_EraseRootFromParent_Done,
     /* 166427 */ // Label 2528: @166427
     /* 166427 */ GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(166486), // Rule ID 6605 //
     /* 166432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 166435 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166438 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166443 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166447 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166454 */   // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[f32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 166457 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166469 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166480 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166484 */   GIR_RootConstrainSelectedInstOperands,
     /* 166485 */   // GIR_Coverage, 6605,
     /* 166485 */   GIR_EraseRootFromParent_Done,
     /* 166486 */ // Label 2529: @166486
     /* 166486 */ GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(166545), // Rule ID 6607 //
     /* 166491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 166494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166497 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166502 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166506 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 166513 */   // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[f32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 166516 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166523 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166539 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166543 */   GIR_RootConstrainSelectedInstOperands,
     /* 166544 */   // GIR_Coverage, 6607,
     /* 166544 */   GIR_EraseRootFromParent_Done,
     /* 166545 */ // Label 2530: @166545
     /* 166545 */ GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(166612), // Rule ID 4386 //
     /* 166550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 166553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166556 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166560 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166567 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166572 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166576 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 166583 */   // (st i32:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 166583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS),
     /* 166586 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 166588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 166593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 166598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166606 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166610 */   GIR_RootConstrainSelectedInstOperands,
     /* 166611 */   // GIR_Coverage, 4386,
     /* 166611 */   GIR_EraseRootFromParent_Done,
     /* 166612 */ // Label 2531: @166612
     /* 166612 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(166679), // Rule ID 4389 //
     /* 166617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 166620 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166623 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166627 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 166634 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166639 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166643 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 166650 */   // (st i32:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (SCRATCH_STORE_SHORT_SVS anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 166650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS),
     /* 166653 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 166655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 166660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 166665 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166673 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166677 */   GIR_RootConstrainSelectedInstOperands,
     /* 166678 */   // GIR_Coverage, 4389,
     /* 166678 */   GIR_EraseRootFromParent_Done,
     /* 166679 */ // Label 2532: @166679
     /* 166679 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(166735), // Rule ID 4248 //
     /* 166684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 166687 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166690 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166695 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166699 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 166706 */   // (st i32:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 166706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 166709 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 166711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 166716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 166721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166733 */   GIR_RootConstrainSelectedInstOperands,
     /* 166734 */   // GIR_Coverage, 4248,
     /* 166734 */   GIR_EraseRootFromParent_Done,
     /* 166735 */ // Label 2533: @166735
     /* 166735 */ GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(166791), // Rule ID 4254 //
     /* 166740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 166743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166746 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166751 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166755 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 166762 */   // (st f32:{ *:[f32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 166762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 166765 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 166767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 166772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 166777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166785 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166789 */   GIR_RootConstrainSelectedInstOperands,
     /* 166790 */   // GIR_Coverage, 4254,
     /* 166790 */   GIR_EraseRootFromParent_Done,
     /* 166791 */ // Label 2534: @166791
     /* 166791 */ GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(166853), // Rule ID 4385 //
     /* 166796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 166799 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166802 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166806 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166813 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166818 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166822 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 166829 */   // (st i32:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 166829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR),
     /* 166832 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 166834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 166839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 166844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166847 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166851 */   GIR_RootConstrainSelectedInstOperands,
     /* 166852 */   // GIR_Coverage, 4385,
     /* 166852 */   GIR_EraseRootFromParent_Done,
     /* 166853 */ // Label 2535: @166853
     /* 166853 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(166915), // Rule ID 4388 //
     /* 166858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 166861 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166864 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166868 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 166875 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 166891 */   // (st i32:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (SCRATCH_STORE_SHORT_SADDR anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 166891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR),
     /* 166894 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 166896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 166901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 166906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166909 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166913 */   GIR_RootConstrainSelectedInstOperands,
     /* 166914 */   // GIR_Coverage, 4388,
     /* 166914 */   GIR_EraseRootFromParent_Done,
     /* 166915 */ // Label 2536: @166915
     /* 166915 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(166966), // Rule ID 4247 //
     /* 166920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 166923 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166926 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166931 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166935 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 166942 */   // (st i32:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 166942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 166945 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 166947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 166952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 166957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166964 */   GIR_RootConstrainSelectedInstOperands,
     /* 166965 */   // GIR_Coverage, 4247,
     /* 166965 */   GIR_EraseRootFromParent_Done,
     /* 166966 */ // Label 2537: @166966
     /* 166966 */ GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(167017), // Rule ID 4253 //
     /* 166971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 166974 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166977 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166982 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166986 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 166993 */   // (st f32:{ *:[f32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 166993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 166996 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 166998 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 167003 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167011 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167015 */   GIR_RootConstrainSelectedInstOperands,
     /* 167016 */   // GIR_Coverage, 4253,
     /* 167016 */   GIR_EraseRootFromParent_Done,
     /* 167017 */ // Label 2538: @167017
     /* 167017 */ GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(167079), // Rule ID 4384 //
     /* 167022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 167025 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167028 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167032 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167039 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 167044 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167048 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 167055 */   // (st i32:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 167055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE),
     /* 167058 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167060 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 167065 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167073 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167077 */   GIR_RootConstrainSelectedInstOperands,
     /* 167078 */   // GIR_Coverage, 4384,
     /* 167078 */   GIR_EraseRootFromParent_Done,
     /* 167079 */ // Label 2539: @167079
     /* 167079 */ GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(167141), // Rule ID 4387 //
     /* 167084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 167087 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167090 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167094 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 167101 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 167106 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167110 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 167117 */   // (st i32:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (SCRATCH_STORE_SHORT anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 167117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT),
     /* 167120 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 167127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167135 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167139 */   GIR_RootConstrainSelectedInstOperands,
     /* 167140 */   // GIR_Coverage, 4387,
     /* 167140 */   GIR_EraseRootFromParent_Done,
     /* 167141 */ // Label 2540: @167141
     /* 167141 */ GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(167192), // Rule ID 4246 //
     /* 167146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 167149 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167152 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 167157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167161 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 167168 */   // (st i32:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 167168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 167171 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 167178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167186 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167190 */   GIR_RootConstrainSelectedInstOperands,
     /* 167191 */   // GIR_Coverage, 4246,
     /* 167191 */   GIR_EraseRootFromParent_Done,
     /* 167192 */ // Label 2541: @167192
     /* 167192 */ GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(167243), // Rule ID 4252 //
     /* 167197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 167200 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167203 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 167208 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167212 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 167219 */   // (st f32:{ *:[f32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 167219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 167222 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167224 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 167229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167237 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167241 */   GIR_RootConstrainSelectedInstOperands,
     /* 167242 */   // GIR_Coverage, 4252,
     /* 167242 */   GIR_EraseRootFromParent_Done,
     /* 167243 */ // Label 2542: @167243
     /* 167243 */ GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(167330), // Rule ID 7922 //
     /* 167248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 167251 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167254 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167258 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 167265 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 167270 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 167274 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 167278 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 167282 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 167286 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 167290 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167294 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167296 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 167303 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_local>>  =>  (DS_WRITE_B16_D16_HI ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 167303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_D16_HI),
     /* 167306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 167311 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 167315 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167323 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167328 */   GIR_RootConstrainSelectedInstOperands,
     /* 167329 */   // GIR_Coverage, 7922,
     /* 167329 */   GIR_EraseRootFromParent_Done,
     /* 167330 */ // Label 2543: @167330
     /* 167330 */ GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(167417), // Rule ID 7923 //
     /* 167335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 167338 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167341 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167345 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167352 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 167357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 167361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 167365 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 167369 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 167373 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 167377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167381 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167383 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 167390 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_local>>  =>  (DS_WRITE_B8_D16_HI ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 167390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_D16_HI),
     /* 167393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 167398 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 167402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167415 */   GIR_RootConstrainSelectedInstOperands,
     /* 167416 */   // GIR_Coverage, 7923,
     /* 167416 */   GIR_EraseRootFromParent_Done,
     /* 167417 */ // Label 2544: @167417
     /* 167417 */ GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(167488), // Rule ID 6568 //
     /* 167422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 167425 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167428 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167435 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167440 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167444 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 167451 */   // (atomic_store i32:{ *:[i32] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (BUFFER_STORE_BYTE_ADDR64 ?:{ *:[i32] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 167451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_ADDR64),
     /* 167454 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 167456 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 167461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 167466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 167471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 167476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167482 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167486 */   GIR_RootConstrainSelectedInstOperands,
     /* 167487 */   // GIR_Coverage, 6568,
     /* 167487 */   GIR_EraseRootFromParent_Done,
     /* 167488 */ // Label 2545: @167488
     /* 167488 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(167559), // Rule ID 6572 //
     /* 167493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 167496 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167499 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 167506 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167511 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167515 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 167522 */   // (atomic_store i32:{ *:[i32] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (BUFFER_STORE_SHORT_ADDR64 ?:{ *:[i32] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 167522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_ADDR64),
     /* 167525 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 167527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 167532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 167537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 167542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 167547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167553 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167557 */   GIR_RootConstrainSelectedInstOperands,
     /* 167558 */   // GIR_Coverage, 6572,
     /* 167558 */   GIR_EraseRootFromParent_Done,
     /* 167559 */ // Label 2546: @167559
     /* 167559 */ GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(167630), // Rule ID 6576 //
     /* 167564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 167567 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167570 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 167577 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167582 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167586 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 167593 */   // (atomic_store i32:{ *:[i32] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 ?:{ *:[i32] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 167593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 167596 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 167598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 167603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 167608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 167613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 167618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167628 */   GIR_RootConstrainSelectedInstOperands,
     /* 167629 */   // GIR_Coverage, 6576,
     /* 167629 */   GIR_EraseRootFromParent_Done,
     /* 167630 */ // Label 2547: @167630
     /* 167630 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(167705), // Rule ID 4435 //
     /* 167635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 167638 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167641 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167645 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167652 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167657 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167661 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 167668 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 167668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_ADDR64),
     /* 167671 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 167673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 167678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 167683 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 167688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 167693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167699 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167703 */   GIR_RootConstrainSelectedInstOperands,
     /* 167704 */   // GIR_Coverage, 4435,
     /* 167704 */   GIR_EraseRootFromParent_Done,
     /* 167705 */ // Label 2548: @167705
     /* 167705 */ GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(167777), // Rule ID 4595 //
     /* 167710 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167713 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167717 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167724 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167729 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167733 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 167740 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_VBUFFER_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 167740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_ADDR64),
     /* 167743 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 167745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 167750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 167755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 167760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 167765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167771 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167775 */   GIR_RootConstrainSelectedInstOperands,
     /* 167776 */   // GIR_Coverage, 4595,
     /* 167776 */   GIR_EraseRootFromParent_Done,
     /* 167777 */ // Label 2549: @167777
     /* 167777 */ GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(167852), // Rule ID 4597 //
     /* 167782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 167785 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167788 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167792 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 167799 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167804 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 167815 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 167815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_ADDR64),
     /* 167818 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 167820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 167825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 167830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 167835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 167840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167846 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167850 */   GIR_RootConstrainSelectedInstOperands,
     /* 167851 */   // GIR_Coverage, 4597,
     /* 167851 */   GIR_EraseRootFromParent_Done,
     /* 167852 */ // Label 2550: @167852
     /* 167852 */ GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(167924), // Rule ID 4599 //
     /* 167857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167860 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167864 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 167871 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167876 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167880 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 167887 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_VBUFFER_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 167887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_ADDR64),
     /* 167890 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 167892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 167897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 167902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 167907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 167912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167918 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167922 */   GIR_RootConstrainSelectedInstOperands,
     /* 167923 */   // GIR_Coverage, 4599,
     /* 167923 */   GIR_EraseRootFromParent_Done,
     /* 167924 */ // Label 2551: @167924
     /* 167924 */ GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(167999), // Rule ID 6584 //
     /* 167929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 167932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167935 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167946 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 167951 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167955 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 167962 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 167962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFEN),
     /* 167965 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 167967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 167972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 167977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 167982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 167987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167993 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167997 */   GIR_RootConstrainSelectedInstOperands,
     /* 167998 */   // GIR_Coverage, 6584,
     /* 167998 */   GIR_EraseRootFromParent_Done,
     /* 167999 */ // Label 2552: @167999
     /* 167999 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(168074), // Rule ID 6586 //
     /* 168004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 168007 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168010 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168014 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 168021 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168030 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168037 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFEN),
     /* 168040 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168068 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168072 */   GIR_RootConstrainSelectedInstOperands,
     /* 168073 */   // GIR_Coverage, 6586,
     /* 168073 */   GIR_EraseRootFromParent_Done,
     /* 168074 */ // Label 2553: @168074
     /* 168074 */ GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(168149), // Rule ID 6588 //
     /* 168079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 168082 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168085 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168089 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 168096 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168112 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFEN),
     /* 168115 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168143 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168147 */   GIR_RootConstrainSelectedInstOperands,
     /* 168148 */   // GIR_Coverage, 6588,
     /* 168148 */   GIR_EraseRootFromParent_Done,
     /* 168149 */ // Label 2554: @168149
     /* 168149 */ GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(168224), // Rule ID 6590 //
     /* 168154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 168157 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168160 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168164 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 168171 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168176 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168180 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168187 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFEN),
     /* 168190 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168197 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168218 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168222 */   GIR_RootConstrainSelectedInstOperands,
     /* 168223 */   // GIR_Coverage, 6590,
     /* 168223 */   GIR_EraseRootFromParent_Done,
     /* 168224 */ // Label 2555: @168224
     /* 168224 */ GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(168288), // Rule ID 4601 //
     /* 168229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 168232 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168235 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168240 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 168251 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 168251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 168254 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 168256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168282 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168286 */   GIR_RootConstrainSelectedInstOperands,
     /* 168287 */   // GIR_Coverage, 4601,
     /* 168287 */   GIR_EraseRootFromParent_Done,
     /* 168288 */ // Label 2556: @168288
     /* 168288 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(168349), // Rule ID 4603 //
     /* 168293 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168296 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168301 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 168312 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 168312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 168315 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 168317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168332 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168347 */   GIR_RootConstrainSelectedInstOperands,
     /* 168348 */   // GIR_Coverage, 4603,
     /* 168348 */   GIR_EraseRootFromParent_Done,
     /* 168349 */ // Label 2557: @168349
     /* 168349 */ GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(168413), // Rule ID 4605 //
     /* 168354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 168357 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168360 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168369 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 168376 */   // (st f32:{ *:[f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 f32:{ *:[f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 168376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 168379 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 168381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168407 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168411 */   GIR_RootConstrainSelectedInstOperands,
     /* 168412 */   // GIR_Coverage, 4605,
     /* 168412 */   GIR_EraseRootFromParent_Done,
     /* 168413 */ // Label 2558: @168413
     /* 168413 */ GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(168474), // Rule ID 4607 //
     /* 168418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168421 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168430 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 168437 */   // (st f32:{ *:[f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 f32:{ *:[f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 168437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 168440 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 168442 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168447 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168472 */   GIR_RootConstrainSelectedInstOperands,
     /* 168473 */   // GIR_Coverage, 4607,
     /* 168473 */   GIR_EraseRootFromParent_Done,
     /* 168474 */ // Label 2559: @168474
     /* 168474 */ GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(168538), // Rule ID 6600 //
     /* 168479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 168482 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168485 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168494 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168501 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 168504 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168532 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168536 */   GIR_RootConstrainSelectedInstOperands,
     /* 168537 */   // GIR_Coverage, 6600,
     /* 168537 */   GIR_EraseRootFromParent_Done,
     /* 168538 */ // Label 2560: @168538
     /* 168538 */ GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(168602), // Rule ID 6602 //
     /* 168543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 168546 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168549 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168558 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168565 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 168568 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168600 */   GIR_RootConstrainSelectedInstOperands,
     /* 168601 */   // GIR_Coverage, 6602,
     /* 168601 */   GIR_EraseRootFromParent_Done,
     /* 168602 */ // Label 2561: @168602
     /* 168602 */ GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(168666), // Rule ID 6604 //
     /* 168607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 168610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168613 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168618 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168629 */   // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[f32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 168632 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168664 */   GIR_RootConstrainSelectedInstOperands,
     /* 168665 */   // GIR_Coverage, 6604,
     /* 168665 */   GIR_EraseRootFromParent_Done,
     /* 168666 */ // Label 2562: @168666
     /* 168666 */ GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(168730), // Rule ID 6606 //
     /* 168671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 168674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168677 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168682 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168686 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 168693 */   // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[f32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 168696 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 168698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 168703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 168713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 168718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168728 */   GIR_RootConstrainSelectedInstOperands,
     /* 168729 */   // GIR_Coverage, 6606,
     /* 168729 */   GIR_EraseRootFromParent_Done,
     /* 168730 */ // Label 2563: @168730
     /* 168730 */ GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(168822), // Rule ID 3972 //
     /* 168735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 168738 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168741 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168745 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 168752 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168757 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 168761 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 168765 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 168769 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 168773 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 168777 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168783 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 168790 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_global>>  =>  (GLOBAL_STORE_SHORT_D16_HI_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 168790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_D16_HI_SADDR),
     /* 168793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 168798 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 168802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 168807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 168812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168815 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168820 */   GIR_RootConstrainSelectedInstOperands,
     /* 168821 */   // GIR_Coverage, 3972,
     /* 168821 */   GIR_EraseRootFromParent_Done,
     /* 168822 */ // Label 2564: @168822
     /* 168822 */ GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(168914), // Rule ID 3974 //
     /* 168827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 168830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168833 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168837 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 168844 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168849 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 168853 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 168857 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 168861 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 168865 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 168869 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168873 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 168882 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_global>>  =>  (GLOBAL_STORE_BYTE_D16_HI_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 168882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_D16_HI_SADDR),
     /* 168885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 168890 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 168894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 168899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 168904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168907 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168912 */   GIR_RootConstrainSelectedInstOperands,
     /* 168913 */   // GIR_Coverage, 3974,
     /* 168913 */   GIR_EraseRootFromParent_Done,
     /* 168914 */ // Label 2565: @168914
     /* 168914 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(168984), // Rule ID 4434 //
     /* 168919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 168922 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168925 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168929 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 168936 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168941 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168945 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 168952 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 168952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
     /* 168955 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 168957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 168967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 168972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168978 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168982 */   GIR_RootConstrainSelectedInstOperands,
     /* 168983 */   // GIR_Coverage, 4434,
     /* 168983 */   GIR_EraseRootFromParent_Done,
     /* 168984 */ // Label 2566: @168984
     /* 168984 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(169051), // Rule ID 4594 //
     /* 168989 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168992 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168996 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169003 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169008 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169012 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169019 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
     /* 169022 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169045 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169049 */   GIR_RootConstrainSelectedInstOperands,
     /* 169050 */   // GIR_Coverage, 4594,
     /* 169050 */   GIR_EraseRootFromParent_Done,
     /* 169051 */ // Label 2567: @169051
     /* 169051 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(169121), // Rule ID 4596 //
     /* 169056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 169059 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169062 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169066 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169073 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169078 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169082 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169089 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
     /* 169092 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169115 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169119 */   GIR_RootConstrainSelectedInstOperands,
     /* 169120 */   // GIR_Coverage, 4596,
     /* 169120 */   GIR_EraseRootFromParent_Done,
     /* 169121 */ // Label 2568: @169121
     /* 169121 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(169188), // Rule ID 4598 //
     /* 169126 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169129 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169133 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169140 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169145 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169149 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169156 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
     /* 169159 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169186 */   GIR_RootConstrainSelectedInstOperands,
     /* 169187 */   // GIR_Coverage, 4598,
     /* 169187 */   GIR_EraseRootFromParent_Done,
     /* 169188 */ // Label 2569: @169188
     /* 169188 */ GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(169247), // Rule ID 4600 //
     /* 169193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 169196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169199 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169204 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169208 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169215 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 169218 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169225 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169241 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169245 */   GIR_RootConstrainSelectedInstOperands,
     /* 169246 */   // GIR_Coverage, 4600,
     /* 169246 */   GIR_EraseRootFromParent_Done,
     /* 169247 */ // Label 2570: @169247
     /* 169247 */ GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(169303), // Rule ID 4602 //
     /* 169252 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169255 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169260 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169264 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169271 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 169274 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169286 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169301 */   GIR_RootConstrainSelectedInstOperands,
     /* 169302 */   // GIR_Coverage, 4602,
     /* 169302 */   GIR_EraseRootFromParent_Done,
     /* 169303 */ // Label 2571: @169303
     /* 169303 */ GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(169362), // Rule ID 4604 //
     /* 169308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 169311 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169314 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169330 */   // (st f32:{ *:[f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 169333 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169356 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169360 */   GIR_RootConstrainSelectedInstOperands,
     /* 169361 */   // GIR_Coverage, 4604,
     /* 169361 */   GIR_EraseRootFromParent_Done,
     /* 169362 */ // Label 2572: @169362
     /* 169362 */ GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(169418), // Rule ID 4606 //
     /* 169367 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169370 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169375 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169379 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 169386 */   // (st f32:{ *:[f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 169386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 169389 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 169391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169412 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169416 */   GIR_RootConstrainSelectedInstOperands,
     /* 169417 */   // GIR_Coverage, 4606,
     /* 169417 */   GIR_EraseRootFromParent_Done,
     /* 169418 */ // Label 2573: @169418
     /* 169418 */ GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(169505), // Rule ID 3971 //
     /* 169423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 169426 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169429 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169433 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169440 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169445 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169449 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169453 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169457 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169461 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169471 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 169478 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_global>>  =>  (GLOBAL_STORE_SHORT_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 169478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_D16_HI),
     /* 169481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 169486 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 169490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169498 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169503 */   GIR_RootConstrainSelectedInstOperands,
     /* 169504 */   // GIR_Coverage, 3971,
     /* 169504 */   GIR_EraseRootFromParent_Done,
     /* 169505 */ // Label 2574: @169505
     /* 169505 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(169592), // Rule ID 3973 //
     /* 169510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 169513 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169516 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169520 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169527 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 169532 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169536 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169540 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169544 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169548 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169552 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169556 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169558 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 169565 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_global>>  =>  (GLOBAL_STORE_BYTE_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 169565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_D16_HI),
     /* 169568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 169573 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 169577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169585 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169590 */   GIR_RootConstrainSelectedInstOperands,
     /* 169591 */   // GIR_Coverage, 3973,
     /* 169591 */   GIR_EraseRootFromParent_Done,
     /* 169592 */ // Label 2575: @169592
     /* 169592 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(169650), // Rule ID 7910 //
     /* 169597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 169600 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 169603 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169610 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 169615 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169619 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 169626 */   // (AMDGPUatomic_st_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8_glue>><<P:Predicate_atomic_store_8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 169626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
     /* 169629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 169634 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 169636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169644 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169648 */   GIR_RootConstrainSelectedInstOperands,
     /* 169649 */   // GIR_Coverage, 7910,
     /* 169649 */   GIR_EraseRootFromParent_Done,
     /* 169650 */ // Label 2576: @169650
     /* 169650 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(169708), // Rule ID 7911 //
     /* 169655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 169658 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 169661 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169668 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 169673 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169677 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 169684 */   // (atomic_store i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 169684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 169687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 169692 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 169694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169702 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169706 */   GIR_RootConstrainSelectedInstOperands,
     /* 169707 */   // GIR_Coverage, 7911,
     /* 169707 */   GIR_EraseRootFromParent_Done,
     /* 169708 */ // Label 2577: @169708
     /* 169708 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(169766), // Rule ID 7916 //
     /* 169713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 169716 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 169719 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169726 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 169731 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 169742 */   // (AMDGPUatomic_st_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16_glue>><<P:Predicate_atomic_store_16_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 169742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
     /* 169745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 169750 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 169752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169760 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169764 */   GIR_RootConstrainSelectedInstOperands,
     /* 169765 */   // GIR_Coverage, 7916,
     /* 169765 */   GIR_EraseRootFromParent_Done,
     /* 169766 */ // Label 2578: @169766
     /* 169766 */ GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(169824), // Rule ID 7917 //
     /* 169771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 169774 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 169777 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169784 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 169789 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169793 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 169800 */   // (atomic_store i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 169800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 169803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 169808 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 169810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169818 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169822 */   GIR_RootConstrainSelectedInstOperands,
     /* 169823 */   // GIR_Coverage, 7917,
     /* 169823 */   GIR_EraseRootFromParent_Done,
     /* 169824 */ // Label 2579: @169824
     /* 169824 */ GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(169882), // Rule ID 7918 //
     /* 169829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 169832 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 169835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 169842 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 169847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169851 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 169858 */   // (AMDGPUatomic_st_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32_glue>><<P:Predicate_atomic_store_32_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 169858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 169861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 169866 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 169868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169876 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169880 */   GIR_RootConstrainSelectedInstOperands,
     /* 169881 */   // GIR_Coverage, 7918,
     /* 169881 */   GIR_EraseRootFromParent_Done,
     /* 169882 */ // Label 2580: @169882
     /* 169882 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(169940), // Rule ID 7919 //
     /* 169887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 169890 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 169893 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 169900 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 169905 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169909 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 169916 */   // (atomic_store i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 169916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 169919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 169924 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 169926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 169938 */   GIR_RootConstrainSelectedInstOperands,
     /* 169939 */   // GIR_Coverage, 7919,
     /* 169939 */   GIR_EraseRootFromParent_Done,
     /* 169940 */ // Label 2581: @169940
     /* 169940 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(170002), // Rule ID 7878 //
     /* 169945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 169948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169951 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169955 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169962 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 169967 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169971 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 169978 */   // (AMDGPUst_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_truncstore_glue>><<P:Predicate_truncstorei8_glue>><<P:Predicate_truncstorei8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 169978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
     /* 169981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 169986 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 169988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169996 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170000 */   GIR_RootConstrainSelectedInstOperands,
     /* 170001 */   // GIR_Coverage, 7878,
     /* 170001 */   GIR_EraseRootFromParent_Done,
     /* 170002 */ // Label 2582: @170002
     /* 170002 */ GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(170064), // Rule ID 7879 //
     /* 170007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 170010 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170013 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170017 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 170024 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170029 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170033 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170040 */   // (st i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 170043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170048 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170058 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170062 */   GIR_RootConstrainSelectedInstOperands,
     /* 170063 */   // GIR_Coverage, 7879,
     /* 170063 */   GIR_EraseRootFromParent_Done,
     /* 170064 */ // Label 2583: @170064
     /* 170064 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(170126), // Rule ID 7883 //
     /* 170069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 170072 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170075 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170079 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170086 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170095 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170102 */   // (AMDGPUst_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_truncstore_glue>><<P:Predicate_truncstorei16_glue>><<P:Predicate_truncstorei16_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
     /* 170105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170110 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170120 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170124 */   GIR_RootConstrainSelectedInstOperands,
     /* 170125 */   // GIR_Coverage, 7883,
     /* 170125 */   GIR_EraseRootFromParent_Done,
     /* 170126 */ // Label 2584: @170126
     /* 170126 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(170188), // Rule ID 7884 //
     /* 170131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 170134 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170137 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170141 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170148 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170153 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170157 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170164 */   // (st i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 170167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170172 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170186 */   GIR_RootConstrainSelectedInstOperands,
     /* 170187 */   // GIR_Coverage, 7884,
     /* 170187 */   GIR_EraseRootFromParent_Done,
     /* 170188 */ // Label 2585: @170188
     /* 170188 */ GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(170243), // Rule ID 7890 //
     /* 170193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 170196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170199 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170203 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170208 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170212 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170219 */   // (AMDGPUst_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 170222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170227 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170237 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170241 */   GIR_RootConstrainSelectedInstOperands,
     /* 170242 */   // GIR_Coverage, 7890,
     /* 170242 */   GIR_EraseRootFromParent_Done,
     /* 170243 */ // Label 2586: @170243
     /* 170243 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(170298), // Rule ID 7892 //
     /* 170248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 170251 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170254 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170258 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170263 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170267 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170274 */   // (AMDGPUst_glue f32:{ *:[f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 170277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170282 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170292 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170296 */   GIR_RootConstrainSelectedInstOperands,
     /* 170297 */   // GIR_Coverage, 7892,
     /* 170297 */   GIR_EraseRootFromParent_Done,
     /* 170298 */ // Label 2587: @170298
     /* 170298 */ GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(170349), // Rule ID 7891 //
     /* 170303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 170306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170309 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170318 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170325 */   // (st i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 170328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170333 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170347 */   GIR_RootConstrainSelectedInstOperands,
     /* 170348 */   // GIR_Coverage, 7891,
     /* 170348 */   GIR_EraseRootFromParent_Done,
     /* 170349 */ // Label 2588: @170349
     /* 170349 */ GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(170400), // Rule ID 7893 //
     /* 170354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 170357 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170360 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 170365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170369 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 170376 */   // (st f32:{ *:[f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 170376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 170379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 170384 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170398 */   GIR_RootConstrainSelectedInstOperands,
     /* 170399 */   // GIR_Coverage, 7893,
     /* 170399 */   GIR_EraseRootFromParent_Done,
     /* 170400 */ // Label 2589: @170400
     /* 170400 */ GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(170463), // Rule ID 3998 //
     /* 170405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170408 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170411 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 170418 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170423 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170427 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 170434 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 170437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 170442 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170457 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170461 */   GIR_RootConstrainSelectedInstOperands,
     /* 170462 */   // GIR_Coverage, 3998,
     /* 170462 */   GIR_EraseRootFromParent_Done,
     /* 170463 */ // Label 2590: @170463
     /* 170463 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(170526), // Rule ID 4002 //
     /* 170468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170471 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170481 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170486 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 170497 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 170500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 170505 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170520 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170524 */   GIR_RootConstrainSelectedInstOperands,
     /* 170525 */   // GIR_Coverage, 4002,
     /* 170525 */   GIR_EraseRootFromParent_Done,
     /* 170526 */ // Label 2591: @170526
     /* 170526 */ GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(170589), // Rule ID 4006 //
     /* 170531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170534 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170537 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170544 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170549 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170553 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 170560 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 170563 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 170568 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170583 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170587 */   GIR_RootConstrainSelectedInstOperands,
     /* 170588 */   // GIR_Coverage, 4006,
     /* 170588 */   GIR_EraseRootFromParent_Done,
     /* 170589 */ // Label 2592: @170589
     /* 170589 */ GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(170656), // Rule ID 3958 //
     /* 170594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170597 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170600 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170604 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 170611 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170616 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170620 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 170627 */   // (st i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 170630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 170635 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170650 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170654 */   GIR_RootConstrainSelectedInstOperands,
     /* 170655 */   // GIR_Coverage, 3958,
     /* 170655 */   GIR_EraseRootFromParent_Done,
     /* 170656 */ // Label 2593: @170656
     /* 170656 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(170723), // Rule ID 3960 //
     /* 170661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170667 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170671 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170678 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170683 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170687 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 170694 */   // (st i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 170697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 170702 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170717 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170721 */   GIR_RootConstrainSelectedInstOperands,
     /* 170722 */   // GIR_Coverage, 3960,
     /* 170722 */   GIR_EraseRootFromParent_Done,
     /* 170723 */ // Label 2594: @170723
     /* 170723 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(170779), // Rule ID 3550 //
     /* 170728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170731 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170734 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170739 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170743 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 170750 */   // (st i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 170753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 170758 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170773 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170777 */   GIR_RootConstrainSelectedInstOperands,
     /* 170778 */   // GIR_Coverage, 3550,
     /* 170778 */   GIR_EraseRootFromParent_Done,
     /* 170779 */ // Label 2595: @170779
     /* 170779 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(170835), // Rule ID 3866 //
     /* 170784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170787 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170790 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 170806 */   // (st f32:{ *:[f32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 170809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 170814 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170829 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170833 */   GIR_RootConstrainSelectedInstOperands,
     /* 170834 */   // GIR_Coverage, 3866,
     /* 170834 */   GIR_EraseRootFromParent_Done,
     /* 170835 */ // Label 2596: @170835
     /* 170835 */ GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(170893), // Rule ID 3997 //
     /* 170840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170843 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 170853 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170858 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170862 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 170869 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 170869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 170872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 170877 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170891 */   GIR_RootConstrainSelectedInstOperands,
     /* 170892 */   // GIR_Coverage, 3997,
     /* 170892 */   GIR_EraseRootFromParent_Done,
     /* 170893 */ // Label 2597: @170893
     /* 170893 */ GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(170951), // Rule ID 4001 //
     /* 170898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170901 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170904 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170911 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170916 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170920 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 170927 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 170927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 170930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 170935 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170945 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170949 */   GIR_RootConstrainSelectedInstOperands,
     /* 170950 */   // GIR_Coverage, 4001,
     /* 170950 */   GIR_EraseRootFromParent_Done,
     /* 170951 */ // Label 2598: @170951
     /* 170951 */ GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(171009), // Rule ID 4005 //
     /* 170956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 170959 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170962 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170969 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 170974 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170978 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 170985 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 170985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 170988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 170993 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171003 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171007 */   GIR_RootConstrainSelectedInstOperands,
     /* 171008 */   // GIR_Coverage, 4005,
     /* 171008 */   GIR_EraseRootFromParent_Done,
     /* 171009 */ // Label 2599: @171009
     /* 171009 */ GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(171071), // Rule ID 3957 //
     /* 171014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 171017 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171020 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171024 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171031 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171036 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171040 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 171047 */   // (st i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 171050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171055 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171065 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171069 */   GIR_RootConstrainSelectedInstOperands,
     /* 171070 */   // GIR_Coverage, 3957,
     /* 171070 */   GIR_EraseRootFromParent_Done,
     /* 171071 */ // Label 2600: @171071
     /* 171071 */ GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(171133), // Rule ID 3959 //
     /* 171076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 171079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171082 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171086 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171093 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171098 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171102 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 171109 */   // (st i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 171112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171117 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171131 */   GIR_RootConstrainSelectedInstOperands,
     /* 171132 */   // GIR_Coverage, 3959,
     /* 171132 */   GIR_EraseRootFromParent_Done,
     /* 171133 */ // Label 2601: @171133
     /* 171133 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(171184), // Rule ID 3549 //
     /* 171138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 171141 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171144 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171149 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171153 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 171160 */   // (st i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 171163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171168 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171178 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171182 */   GIR_RootConstrainSelectedInstOperands,
     /* 171183 */   // GIR_Coverage, 3549,
     /* 171183 */   GIR_EraseRootFromParent_Done,
     /* 171184 */ // Label 2602: @171184
     /* 171184 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(171235), // Rule ID 3865 //
     /* 171189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 171192 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171195 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171200 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171204 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 171211 */   // (st f32:{ *:[f32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 171214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171219 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171229 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171233 */   GIR_RootConstrainSelectedInstOperands,
     /* 171234 */   // GIR_Coverage, 3865,
     /* 171234 */   GIR_EraseRootFromParent_Done,
     /* 171235 */ // Label 2603: @171235
     /* 171235 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(171323), // Rule ID 3785 //
     /* 171240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 171243 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171246 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171250 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171257 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171263 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 171267 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 171271 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 171275 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 171279 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 171283 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171287 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171289 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171296 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_flat>>  =>  (FLAT_STORE_SHORT_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT_D16_HI),
     /* 171299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171304 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 171308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171321 */   GIR_RootConstrainSelectedInstOperands,
     /* 171322 */   // GIR_Coverage, 3785,
     /* 171322 */   GIR_EraseRootFromParent_Done,
     /* 171323 */ // Label 2604: @171323
     /* 171323 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(171411), // Rule ID 3786 //
     /* 171328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 171331 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171334 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171338 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171345 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171351 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 171355 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 171359 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 171363 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 171367 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 171371 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171375 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171384 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_flat>>  =>  (FLAT_STORE_BYTE_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE_D16_HI),
     /* 171387 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171392 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 171396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171409 */   GIR_RootConstrainSelectedInstOperands,
     /* 171410 */   // GIR_Coverage, 3786,
     /* 171410 */   GIR_EraseRootFromParent_Done,
     /* 171411 */ // Label 2605: @171411
     /* 171411 */ GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(171470), // Rule ID 3659 //
     /* 171416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 171419 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171422 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171429 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171435 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171439 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171446 */   // (atomic_store i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 171449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171454 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171456 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171468 */   GIR_RootConstrainSelectedInstOperands,
     /* 171469 */   // GIR_Coverage, 3659,
     /* 171469 */   GIR_EraseRootFromParent_Done,
     /* 171470 */ // Label 2606: @171470
     /* 171470 */ GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(171529), // Rule ID 3661 //
     /* 171475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 171478 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171481 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171488 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171494 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171498 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171505 */   // (atomic_store i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 171508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171513 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171523 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171527 */   GIR_RootConstrainSelectedInstOperands,
     /* 171528 */   // GIR_Coverage, 3661,
     /* 171528 */   GIR_EraseRootFromParent_Done,
     /* 171529 */ // Label 2607: @171529
     /* 171529 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(171588), // Rule ID 3663 //
     /* 171534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 171537 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171540 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171547 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171553 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171557 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171564 */   // (atomic_store i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 171567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171572 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171582 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171586 */   GIR_RootConstrainSelectedInstOperands,
     /* 171587 */   // GIR_Coverage, 3663,
     /* 171587 */   GIR_EraseRootFromParent_Done,
     /* 171588 */ // Label 2608: @171588
     /* 171588 */ GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(171651), // Rule ID 3610 //
     /* 171593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 171596 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171599 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171603 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171610 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171616 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171620 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171627 */   // (st i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 171630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171635 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171645 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171649 */   GIR_RootConstrainSelectedInstOperands,
     /* 171650 */   // GIR_Coverage, 3610,
     /* 171650 */   GIR_EraseRootFromParent_Done,
     /* 171651 */ // Label 2609: @171651
     /* 171651 */ GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(171714), // Rule ID 3611 //
     /* 171656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 171659 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171662 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171666 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171673 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171679 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171683 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171690 */   // (st i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 171693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171698 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171708 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171712 */   GIR_RootConstrainSelectedInstOperands,
     /* 171713 */   // GIR_Coverage, 3611,
     /* 171713 */   GIR_EraseRootFromParent_Done,
     /* 171714 */ // Label 2610: @171714
     /* 171714 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(171766), // Rule ID 3613 //
     /* 171719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 171722 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171725 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171731 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171742 */   // (st i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 171745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171750 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171760 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171764 */   GIR_RootConstrainSelectedInstOperands,
     /* 171765 */   // GIR_Coverage, 3613,
     /* 171765 */   GIR_EraseRootFromParent_Done,
     /* 171766 */ // Label 2611: @171766
     /* 171766 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(171818), // Rule ID 3615 //
     /* 171771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 171774 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171777 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 171783 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171787 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 171794 */   // (st f32:{ *:[f32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 171794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 171797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171802 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171812 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171816 */   GIR_RootConstrainSelectedInstOperands,
     /* 171817 */   // GIR_Coverage, 3615,
     /* 171817 */   GIR_EraseRootFromParent_Done,
     /* 171818 */ // Label 2612: @171818
     /* 171818 */ GIM_Reject,
     /* 171819 */ // Label 2309: @171819
     /* 171819 */ GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(171883), // Rule ID 8054 //
     /* 171824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 171827 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171830 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171834 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 171839 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 171844 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171848 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 171852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 171859 */   // (AMDGPUst_glue i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 171859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 171862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 171867 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 171869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171881 */   GIR_RootConstrainSelectedInstOperands,
     /* 171882 */   // GIR_Coverage, 8054,
     /* 171882 */   GIR_EraseRootFromParent_Done,
     /* 171883 */ // Label 2613: @171883
     /* 171883 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(171947), // Rule ID 8058 //
     /* 171888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 171891 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171894 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171898 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 171903 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 171908 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171912 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 171916 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 171923 */   // (AMDGPUst_glue f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 171923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 171926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 171931 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 171933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171941 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171945 */   GIR_RootConstrainSelectedInstOperands,
     /* 171946 */   // GIR_Coverage, 8058,
     /* 171946 */   GIR_EraseRootFromParent_Done,
     /* 171947 */ // Label 2614: @171947
     /* 171947 */ GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(172006), // Rule ID 7986 //
     /* 171952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 171955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171958 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171962 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 171967 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 171971 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171975 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 171982 */   // (AMDGPUst_glue i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 171982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 171985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 171990 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 171992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172004 */   GIR_RootConstrainSelectedInstOperands,
     /* 172005 */   // GIR_Coverage, 7986,
     /* 172005 */   GIR_EraseRootFromParent_Done,
     /* 172006 */ // Label 2615: @172006
     /* 172006 */ GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(172065), // Rule ID 7990 //
     /* 172011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 172014 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172017 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 172021 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172026 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 172030 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172034 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 172041 */   // (AMDGPUst_glue f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 172041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 172044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 172049 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172063 */   GIR_RootConstrainSelectedInstOperands,
     /* 172064 */   // GIR_Coverage, 7990,
     /* 172064 */   GIR_EraseRootFromParent_Done,
     /* 172065 */ // Label 2616: @172065
     /* 172065 */ GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(172125), // Rule ID 8055 //
     /* 172070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 172073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172076 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172081 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172086 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172090 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 172094 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 172101 */   // (st i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 172101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 172104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 172109 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172119 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172123 */   GIR_RootConstrainSelectedInstOperands,
     /* 172124 */   // GIR_Coverage, 8055,
     /* 172124 */   GIR_EraseRootFromParent_Done,
     /* 172125 */ // Label 2617: @172125
     /* 172125 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(172185), // Rule ID 8059 //
     /* 172130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 172133 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172136 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172141 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172146 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172150 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 172154 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 172161 */   // (st f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 172161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 172164 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 172169 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172183 */   GIR_RootConstrainSelectedInstOperands,
     /* 172184 */   // GIR_Coverage, 8059,
     /* 172184 */   GIR_EraseRootFromParent_Done,
     /* 172185 */ // Label 2618: @172185
     /* 172185 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(172240), // Rule ID 7987 //
     /* 172190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 172193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172196 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172201 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 172205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 172216 */   // (st i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 172216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 172219 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 172224 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172234 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172238 */   GIR_RootConstrainSelectedInstOperands,
     /* 172239 */   // GIR_Coverage, 7987,
     /* 172239 */   GIR_EraseRootFromParent_Done,
     /* 172240 */ // Label 2619: @172240
     /* 172240 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(172295), // Rule ID 7991 //
     /* 172245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 172248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172251 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172256 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 172260 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172264 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 172271 */   // (st f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 172271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 172274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 172279 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172289 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172293 */   GIR_RootConstrainSelectedInstOperands,
     /* 172294 */   // GIR_Coverage, 7991,
     /* 172294 */   GIR_EraseRootFromParent_Done,
     /* 172295 */ // Label 2620: @172295
     /* 172295 */ GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(172351), // Rule ID 4296 //
     /* 172300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 172303 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172306 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172311 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172315 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 172322 */   // (st i64:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 172322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 172325 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 172327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 172332 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 172337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 172342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172345 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172349 */   GIR_RootConstrainSelectedInstOperands,
     /* 172350 */   // GIR_Coverage, 4296,
     /* 172350 */   GIR_EraseRootFromParent_Done,
     /* 172351 */ // Label 2621: @172351
     /* 172351 */ GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(172407), // Rule ID 4302 //
     /* 172356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 172359 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172362 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172367 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172371 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 172378 */   // (st f64:{ *:[f64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 172378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 172381 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 172383 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 172388 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 172393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 172398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172401 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172405 */   GIR_RootConstrainSelectedInstOperands,
     /* 172406 */   // GIR_Coverage, 4302,
     /* 172406 */   GIR_EraseRootFromParent_Done,
     /* 172407 */ // Label 2622: @172407
     /* 172407 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(172458), // Rule ID 4295 //
     /* 172412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 172415 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172418 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172423 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172427 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 172434 */   // (st i64:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 172434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 172437 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 172439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 172444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172452 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172456 */   GIR_RootConstrainSelectedInstOperands,
     /* 172457 */   // GIR_Coverage, 4295,
     /* 172457 */   GIR_EraseRootFromParent_Done,
     /* 172458 */ // Label 2623: @172458
     /* 172458 */ GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(172509), // Rule ID 4301 //
     /* 172463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 172466 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172469 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172474 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172478 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 172485 */   // (st f64:{ *:[f64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 172485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 172488 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 172490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 172495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172503 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172507 */   GIR_RootConstrainSelectedInstOperands,
     /* 172508 */   // GIR_Coverage, 4301,
     /* 172508 */   GIR_EraseRootFromParent_Done,
     /* 172509 */ // Label 2624: @172509
     /* 172509 */ GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(172560), // Rule ID 4294 //
     /* 172514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 172517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172520 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172525 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172529 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 172536 */   // (st i64:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 172536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 172539 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 172541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 172546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172558 */   GIR_RootConstrainSelectedInstOperands,
     /* 172559 */   // GIR_Coverage, 4294,
     /* 172559 */   GIR_EraseRootFromParent_Done,
     /* 172560 */ // Label 2625: @172560
     /* 172560 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(172611), // Rule ID 4300 //
     /* 172565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 172568 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172571 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172576 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172580 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 172587 */   // (st f64:{ *:[f64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 172587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 172590 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 172592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 172597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 172602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172605 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172609 */   GIR_RootConstrainSelectedInstOperands,
     /* 172610 */   // GIR_Coverage, 4300,
     /* 172610 */   GIR_EraseRootFromParent_Done,
     /* 172611 */ // Label 2626: @172611
     /* 172611 */ GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(172682), // Rule ID 6578 //
     /* 172616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 172619 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 172622 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 172629 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172634 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172638 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 172645 */   // (atomic_store i64:{ *:[i64] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 ?:{ *:[i64] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 172645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 172648 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 172650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172665 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172676 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172680 */   GIR_RootConstrainSelectedInstOperands,
     /* 172681 */   // GIR_Coverage, 6578,
     /* 172681 */   GIR_EraseRootFromParent_Done,
     /* 172682 */ // Label 2627: @172682
     /* 172682 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(172746), // Rule ID 4633 //
     /* 172687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 172690 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172693 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172698 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172702 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 172709 */   // (st i64:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 i64:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 172709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 172712 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 172714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172740 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172744 */   GIR_RootConstrainSelectedInstOperands,
     /* 172745 */   // GIR_Coverage, 4633,
     /* 172745 */   GIR_EraseRootFromParent_Done,
     /* 172746 */ // Label 2628: @172746
     /* 172746 */ GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(172807), // Rule ID 4635 //
     /* 172751 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172754 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 172770 */   // (st i64:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 i64:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 172770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 172773 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 172775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172805 */   GIR_RootConstrainSelectedInstOperands,
     /* 172806 */   // GIR_Coverage, 4635,
     /* 172806 */   GIR_EraseRootFromParent_Done,
     /* 172807 */ // Label 2629: @172807
     /* 172807 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(172871), // Rule ID 4637 //
     /* 172812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 172815 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172818 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172823 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172827 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 172834 */   // (st f64:{ *:[f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 f64:{ *:[f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 172834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 172837 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 172839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172865 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172869 */   GIR_RootConstrainSelectedInstOperands,
     /* 172870 */   // GIR_Coverage, 4637,
     /* 172870 */   GIR_EraseRootFromParent_Done,
     /* 172871 */ // Label 2630: @172871
     /* 172871 */ GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(172932), // Rule ID 4639 //
     /* 172876 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172879 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172884 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172888 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 172895 */   // (st f64:{ *:[f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 f64:{ *:[f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 172895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 172898 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 172900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172926 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172930 */   GIR_RootConstrainSelectedInstOperands,
     /* 172931 */   // GIR_Coverage, 4639,
     /* 172931 */   GIR_EraseRootFromParent_Done,
     /* 172932 */ // Label 2631: @172932
     /* 172932 */ GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(173052), // Rule ID 7925 //
     /* 172937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 172940 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172943 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 172947 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 172952 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172956 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 172963 */   // (AMDGPUst_glue i64:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 172963 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 172966 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172970 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172975 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 172981 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 172986 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 172991 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 172994 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172998 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173003 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 173009 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173014 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 173022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 173033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 173038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 173043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173046 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173050 */   GIR_RootConstrainSelectedInstOperands,
     /* 173051 */   // GIR_Coverage, 7925,
     /* 173051 */   GIR_EraseRootFromParent_Done,
     /* 173052 */ // Label 2632: @173052
     /* 173052 */ GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(173172), // Rule ID 7933 //
     /* 173057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 173060 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173063 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 173067 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173072 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173076 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 173083 */   // (AMDGPUst_glue f64:{ *:[f64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 173083 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 173086 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173090 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173095 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 173101 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173106 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 173114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173123 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 173129 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173134 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 173142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173147 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 173153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 173158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 173163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173166 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173170 */   GIR_RootConstrainSelectedInstOperands,
     /* 173171 */   // GIR_Coverage, 7933,
     /* 173171 */   GIR_EraseRootFromParent_Done,
     /* 173172 */ // Label 2633: @173172
     /* 173172 */ GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(173231), // Rule ID 4632 //
     /* 173177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 173180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173183 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173188 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173192 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173199 */   // (st i64:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 173202 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173229 */   GIR_RootConstrainSelectedInstOperands,
     /* 173230 */   // GIR_Coverage, 4632,
     /* 173230 */   GIR_EraseRootFromParent_Done,
     /* 173231 */ // Label 2634: @173231
     /* 173231 */ GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(173287), // Rule ID 4634 //
     /* 173236 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173239 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173244 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173248 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173255 */   // (st i64:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 173258 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173281 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173285 */   GIR_RootConstrainSelectedInstOperands,
     /* 173286 */   // GIR_Coverage, 4634,
     /* 173286 */   GIR_EraseRootFromParent_Done,
     /* 173287 */ // Label 2635: @173287
     /* 173287 */ GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(173346), // Rule ID 4636 //
     /* 173292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 173295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173298 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173303 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173307 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173314 */   // (st f64:{ *:[f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 173317 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173340 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173344 */   GIR_RootConstrainSelectedInstOperands,
     /* 173345 */   // GIR_Coverage, 4636,
     /* 173345 */   GIR_EraseRootFromParent_Done,
     /* 173346 */ // Label 2636: @173346
     /* 173346 */ GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(173402), // Rule ID 4638 //
     /* 173351 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173354 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173359 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173363 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173370 */   // (st f64:{ *:[f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 173373 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173396 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173400 */   GIR_RootConstrainSelectedInstOperands,
     /* 173401 */   // GIR_Coverage, 4638,
     /* 173401 */   GIR_EraseRootFromParent_Done,
     /* 173402 */ // Label 2637: @173402
     /* 173402 */ GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(173518), // Rule ID 7927 //
     /* 173407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 173410 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173413 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173418 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173422 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 173429 */   // (st i64:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 173429 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 173432 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173436 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173441 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 173447 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173452 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173457 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 173460 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173464 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173469 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 173475 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173480 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 173488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173493 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 173499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 173504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 173509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173516 */   GIR_RootConstrainSelectedInstOperands,
     /* 173517 */   // GIR_Coverage, 7927,
     /* 173517 */   GIR_EraseRootFromParent_Done,
     /* 173518 */ // Label 2638: @173518
     /* 173518 */ GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(173634), // Rule ID 7935 //
     /* 173523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 173526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173529 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173538 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 173545 */   // (st f64:{ *:[f64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 173545 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 173548 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173552 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173557 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 173563 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173568 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 173576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173585 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 173591 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 173596 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 173601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 173604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173609 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173612 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 173615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 173620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 173625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173628 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173632 */   GIR_RootConstrainSelectedInstOperands,
     /* 173633 */   // GIR_Coverage, 7935,
     /* 173633 */   GIR_EraseRootFromParent_Done,
     /* 173634 */ // Label 2639: @173634
     /* 173634 */ GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(173692), // Rule ID 7920 //
     /* 173639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 173642 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 173645 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 173652 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173657 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173661 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 173668 */   // (AMDGPUatomic_st_glue i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64_glue>><<P:Predicate_atomic_store_64_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 173668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 173671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173676 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 173678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173686 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173690 */   GIR_RootConstrainSelectedInstOperands,
     /* 173691 */   // GIR_Coverage, 7920,
     /* 173691 */   GIR_EraseRootFromParent_Done,
     /* 173692 */ // Label 2640: @173692
     /* 173692 */ GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(173750), // Rule ID 7921 //
     /* 173697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 173700 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 173703 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 173710 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173715 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173719 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 173726 */   // (atomic_store i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 173726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 173729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173734 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 173736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173744 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173748 */   GIR_RootConstrainSelectedInstOperands,
     /* 173749 */   // GIR_Coverage, 7921,
     /* 173749 */   GIR_EraseRootFromParent_Done,
     /* 173750 */ // Label 2641: @173750
     /* 173750 */ GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(173813), // Rule ID 4008 //
     /* 173755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 173758 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 173761 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 173768 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173773 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173777 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 173784 */   // (atomic_store i64:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 173784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 173787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 173792 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 173794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 173799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173807 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173811 */   GIR_RootConstrainSelectedInstOperands,
     /* 173812 */   // GIR_Coverage, 4008,
     /* 173812 */   GIR_EraseRootFromParent_Done,
     /* 173813 */ // Label 2642: @173813
     /* 173813 */ GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(173869), // Rule ID 3894 //
     /* 173818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 173821 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173824 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173829 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173833 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 173840 */   // (st i64:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 173840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 173843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 173848 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 173850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 173855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173863 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173867 */   GIR_RootConstrainSelectedInstOperands,
     /* 173868 */   // GIR_Coverage, 3894,
     /* 173868 */   GIR_EraseRootFromParent_Done,
     /* 173869 */ // Label 2643: @173869
     /* 173869 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(173925), // Rule ID 3898 //
     /* 173874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 173877 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173880 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173885 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173889 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 173896 */   // (st f64:{ *:[f64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 173896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 173899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 173904 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 173906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 173911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173919 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173923 */   GIR_RootConstrainSelectedInstOperands,
     /* 173924 */   // GIR_Coverage, 3898,
     /* 173924 */   GIR_EraseRootFromParent_Done,
     /* 173925 */ // Label 2644: @173925
     /* 173925 */ GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(173983), // Rule ID 4007 //
     /* 173930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 173933 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 173936 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 173943 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173952 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 173959 */   // (atomic_store i64:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 173959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 173962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 173967 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 173969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173977 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173981 */   GIR_RootConstrainSelectedInstOperands,
     /* 173982 */   // GIR_Coverage, 4007,
     /* 173982 */   GIR_EraseRootFromParent_Done,
     /* 173983 */ // Label 2645: @173983
     /* 173983 */ GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(174034), // Rule ID 3893 //
     /* 173988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 173991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173994 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173999 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174003 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 174010 */   // (st i64:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 174010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 174013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174018 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174028 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174032 */   GIR_RootConstrainSelectedInstOperands,
     /* 174033 */   // GIR_Coverage, 3893,
     /* 174033 */   GIR_EraseRootFromParent_Done,
     /* 174034 */ // Label 2646: @174034
     /* 174034 */ GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(174085), // Rule ID 3897 //
     /* 174039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174042 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174045 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174050 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174054 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 174061 */   // (st f64:{ *:[f64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 174061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 174064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174069 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174083 */   GIR_RootConstrainSelectedInstOperands,
     /* 174084 */   // GIR_Coverage, 3897,
     /* 174084 */   GIR_EraseRootFromParent_Done,
     /* 174085 */ // Label 2647: @174085
     /* 174085 */ GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(174144), // Rule ID 3660 //
     /* 174090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 174093 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 174096 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 174103 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 174109 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174113 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 174120 */   // (atomic_store i64:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 174120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 174123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174128 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174142 */   GIR_RootConstrainSelectedInstOperands,
     /* 174143 */   // GIR_Coverage, 3660,
     /* 174143 */   GIR_EraseRootFromParent_Done,
     /* 174144 */ // Label 2648: @174144
     /* 174144 */ GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(174196), // Rule ID 3628 //
     /* 174149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 174152 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174155 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 174161 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174165 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 174172 */   // (st i64:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 174172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 174175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174180 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174194 */   GIR_RootConstrainSelectedInstOperands,
     /* 174195 */   // GIR_Coverage, 3628,
     /* 174195 */   GIR_EraseRootFromParent_Done,
     /* 174196 */ // Label 2649: @174196
     /* 174196 */ GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(174248), // Rule ID 3630 //
     /* 174201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 174204 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174207 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 174213 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174217 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 174224 */   // (st f64:{ *:[f64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 174224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 174227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174232 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174234 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174246 */   GIR_RootConstrainSelectedInstOperands,
     /* 174247 */   // GIR_Coverage, 3630,
     /* 174247 */   GIR_EraseRootFromParent_Done,
     /* 174248 */ // Label 2650: @174248
     /* 174248 */ GIM_Reject,
     /* 174249 */ // Label 2310: @174249
     /* 174249 */ GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(175980),
     /* 174254 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174257 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(174313), // Rule ID 6609 //
     /* 174262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 174265 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 174281 */     // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 174281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 174284 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 174291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 174296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174311 */     GIR_RootConstrainSelectedInstOperands,
     /* 174312 */     // GIR_Coverage, 6609,
     /* 174312 */     GIR_EraseRootFromParent_Done,
     /* 174313 */   // Label 2652: @174313
     /* 174313 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(174369), // Rule ID 6611 //
     /* 174318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 174321 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 174337 */     // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 174337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 174340 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 174347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 174352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174367 */     GIR_RootConstrainSelectedInstOperands,
     /* 174368 */     // GIR_Coverage, 6611,
     /* 174368 */     GIR_EraseRootFromParent_Done,
     /* 174369 */   // Label 2653: @174369
     /* 174369 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(174425), // Rule ID 6613 //
     /* 174374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 174377 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 174393 */     // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 174393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 174396 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 174403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 174408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174423 */     GIR_RootConstrainSelectedInstOperands,
     /* 174424 */     // GIR_Coverage, 6613,
     /* 174424 */     GIR_EraseRootFromParent_Done,
     /* 174425 */   // Label 2654: @174425
     /* 174425 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(174481), // Rule ID 6615 //
     /* 174430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 174433 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 174449 */     // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 174449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 174452 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 174459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 174464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174479 */     GIR_RootConstrainSelectedInstOperands,
     /* 174480 */     // GIR_Coverage, 6615,
     /* 174480 */     GIR_EraseRootFromParent_Done,
     /* 174481 */   // Label 2655: @174481
     /* 174481 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(174534), // Rule ID 4260 //
     /* 174486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 174489 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 174505 */     // (st v2i16:{ *:[v2i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9820:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 174508 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 174520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174532 */     GIR_RootConstrainSelectedInstOperands,
     /* 174533 */     // GIR_Coverage, 4260,
     /* 174533 */     GIR_EraseRootFromParent_Done,
     /* 174534 */   // Label 2656: @174534
     /* 174534 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(174587), // Rule ID 4266 //
     /* 174539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 174542 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 174558 */     // (st v2f16:{ *:[v2f16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 174561 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 174573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174585 */     GIR_RootConstrainSelectedInstOperands,
     /* 174586 */     // GIR_Coverage, 4266,
     /* 174586 */     GIR_EraseRootFromParent_Done,
     /* 174587 */   // Label 2657: @174587
     /* 174587 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(174635), // Rule ID 4259 //
     /* 174592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 174595 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 174611 */     // (st v2i16:{ *:[v2i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9820:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 174614 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174633 */     GIR_RootConstrainSelectedInstOperands,
     /* 174634 */     // GIR_Coverage, 4259,
     /* 174634 */     GIR_EraseRootFromParent_Done,
     /* 174635 */   // Label 2658: @174635
     /* 174635 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(174683), // Rule ID 4265 //
     /* 174640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 174643 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 174659 */     // (st v2f16:{ *:[v2f16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 174662 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174681 */     GIR_RootConstrainSelectedInstOperands,
     /* 174682 */     // GIR_Coverage, 4265,
     /* 174682 */     GIR_EraseRootFromParent_Done,
     /* 174683 */   // Label 2659: @174683
     /* 174683 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(174731), // Rule ID 4258 //
     /* 174688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 174691 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 174707 */     // (st v2i16:{ *:[v2i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9820:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 174707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 174710 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174729 */     GIR_RootConstrainSelectedInstOperands,
     /* 174730 */     // GIR_Coverage, 4258,
     /* 174730 */     GIR_EraseRootFromParent_Done,
     /* 174731 */   // Label 2660: @174731
     /* 174731 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(174779), // Rule ID 4264 //
     /* 174736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 174739 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 174744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 174755 */     // (st v2f16:{ *:[v2f16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 174755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 174758 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174777 */     GIR_RootConstrainSelectedInstOperands,
     /* 174778 */     // GIR_Coverage, 4264,
     /* 174778 */     GIR_EraseRootFromParent_Done,
     /* 174779 */   // Label 2661: @174779
     /* 174779 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(174840), // Rule ID 4609 //
     /* 174784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 174787 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 174803 */     // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 v2i16:{ *:[v2i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 174803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 174806 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 174808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 174813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 174818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 174823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 174828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174838 */     GIR_RootConstrainSelectedInstOperands,
     /* 174839 */     // GIR_Coverage, 4609,
     /* 174839 */     GIR_EraseRootFromParent_Done,
     /* 174840 */   // Label 2662: @174840
     /* 174840 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(174898), // Rule ID 4611 //
     /* 174845 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 174861 */     // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 v2i16:{ *:[v2i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 174861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 174864 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 174866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 174871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 174876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 174881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 174886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174896 */     GIR_RootConstrainSelectedInstOperands,
     /* 174897 */     // GIR_Coverage, 4611,
     /* 174897 */     GIR_EraseRootFromParent_Done,
     /* 174898 */   // Label 2663: @174898
     /* 174898 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(174959), // Rule ID 4613 //
     /* 174903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 174906 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 174922 */     // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 v2f16:{ *:[v2f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 174922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 174925 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 174927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 174932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 174937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 174942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 174947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174957 */     GIR_RootConstrainSelectedInstOperands,
     /* 174958 */     // GIR_Coverage, 4613,
     /* 174958 */     GIR_EraseRootFromParent_Done,
     /* 174959 */   // Label 2664: @174959
     /* 174959 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(175017), // Rule ID 4615 //
     /* 174964 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 174980 */     // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 v2f16:{ *:[v2f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 174980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 174983 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 174985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 174990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 174995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 175000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 175005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175015 */     GIR_RootConstrainSelectedInstOperands,
     /* 175016 */     // GIR_Coverage, 4615,
     /* 175016 */     GIR_EraseRootFromParent_Done,
     /* 175017 */   // Label 2665: @175017
     /* 175017 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(175078), // Rule ID 6608 //
     /* 175022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 175025 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 175030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 175041 */     // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 175041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 175044 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 175051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 175061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 175066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175076 */     GIR_RootConstrainSelectedInstOperands,
     /* 175077 */     // GIR_Coverage, 6608,
     /* 175077 */     GIR_EraseRootFromParent_Done,
     /* 175078 */   // Label 2666: @175078
     /* 175078 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(175139), // Rule ID 6610 //
     /* 175083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 175086 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 175091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 175102 */     // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 175102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 175105 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 175112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 175122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 175127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175137 */     GIR_RootConstrainSelectedInstOperands,
     /* 175138 */     // GIR_Coverage, 6610,
     /* 175138 */     GIR_EraseRootFromParent_Done,
     /* 175139 */   // Label 2667: @175139
     /* 175139 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(175200), // Rule ID 6612 //
     /* 175144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 175147 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 175152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 175163 */     // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 175163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 175166 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 175173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 175183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 175188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175198 */     GIR_RootConstrainSelectedInstOperands,
     /* 175199 */     // GIR_Coverage, 6612,
     /* 175199 */     GIR_EraseRootFromParent_Done,
     /* 175200 */   // Label 2668: @175200
     /* 175200 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(175261), // Rule ID 6614 //
     /* 175205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 175208 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 175213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 175224 */     // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 175224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 175227 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 175234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 175244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 175249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175259 */     GIR_RootConstrainSelectedInstOperands,
     /* 175260 */     // GIR_Coverage, 6614,
     /* 175260 */     GIR_EraseRootFromParent_Done,
     /* 175261 */   // Label 2669: @175261
     /* 175261 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(175317), // Rule ID 4608 //
     /* 175266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 175269 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 175285 */     // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 175285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 175288 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 175290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 175300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 175305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175315 */     GIR_RootConstrainSelectedInstOperands,
     /* 175316 */     // GIR_Coverage, 4608,
     /* 175316 */     GIR_EraseRootFromParent_Done,
     /* 175317 */   // Label 2670: @175317
     /* 175317 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(175370), // Rule ID 4610 //
     /* 175322 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 175338 */     // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 175338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 175341 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 175343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 175353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 175358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175368 */     GIR_RootConstrainSelectedInstOperands,
     /* 175369 */     // GIR_Coverage, 4610,
     /* 175369 */     GIR_EraseRootFromParent_Done,
     /* 175370 */   // Label 2671: @175370
     /* 175370 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(175426), // Rule ID 4612 //
     /* 175375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 175378 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 175394 */     // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 175394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 175397 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 175399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 175409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 175414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175424 */     GIR_RootConstrainSelectedInstOperands,
     /* 175425 */     // GIR_Coverage, 4612,
     /* 175425 */     GIR_EraseRootFromParent_Done,
     /* 175426 */   // Label 2672: @175426
     /* 175426 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(175479), // Rule ID 4614 //
     /* 175431 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 175447 */     // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 175447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 175450 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 175452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 175457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 175462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 175467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175477 */     GIR_RootConstrainSelectedInstOperands,
     /* 175478 */     // GIR_Coverage, 4614,
     /* 175478 */     GIR_EraseRootFromParent_Done,
     /* 175479 */   // Label 2673: @175479
     /* 175479 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(175531), // Rule ID 7894 //
     /* 175484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 175487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 175491 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 175496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 175507 */     // (AMDGPUst_glue v2i16:{ *:[v2i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 175507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 175510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 175515 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175529 */     GIR_RootConstrainSelectedInstOperands,
     /* 175530 */     // GIR_Coverage, 7894,
     /* 175530 */     GIR_EraseRootFromParent_Done,
     /* 175531 */   // Label 2674: @175531
     /* 175531 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(175583), // Rule ID 7896 //
     /* 175536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 175539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 175543 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 175548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 175559 */     // (AMDGPUst_glue v2f16:{ *:[v2f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 175559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 175562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 175567 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175581 */     GIR_RootConstrainSelectedInstOperands,
     /* 175582 */     // GIR_Coverage, 7896,
     /* 175582 */     GIR_EraseRootFromParent_Done,
     /* 175583 */   // Label 2675: @175583
     /* 175583 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(175631), // Rule ID 7895 //
     /* 175588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 175591 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 175596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 175607 */     // (st v2i16:{ *:[v2i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 175607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 175610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 175615 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175629 */     GIR_RootConstrainSelectedInstOperands,
     /* 175630 */     // GIR_Coverage, 7895,
     /* 175630 */     GIR_EraseRootFromParent_Done,
     /* 175631 */   // Label 2676: @175631
     /* 175631 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(175679), // Rule ID 7897 //
     /* 175636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 175639 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 175644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 175655 */     // (st v2f16:{ *:[v2f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 175655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 175658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 175663 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175677 */     GIR_RootConstrainSelectedInstOperands,
     /* 175678 */     // GIR_Coverage, 7897,
     /* 175678 */     GIR_EraseRootFromParent_Done,
     /* 175679 */   // Label 2677: @175679
     /* 175679 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(175732), // Rule ID 3870 //
     /* 175684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 175687 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 175703 */     // (st v2i16:{ *:[v2i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[v2i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 175703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 175706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 175711 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 175718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 175723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175730 */     GIR_RootConstrainSelectedInstOperands,
     /* 175731 */     // GIR_Coverage, 3870,
     /* 175731 */     GIR_EraseRootFromParent_Done,
     /* 175732 */   // Label 2678: @175732
     /* 175732 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(175785), // Rule ID 3874 //
     /* 175737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 175740 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 175756 */     // (st v2f16:{ *:[v2f16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 175756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 175759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 175764 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 175771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 175776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175783 */     GIR_RootConstrainSelectedInstOperands,
     /* 175784 */     // GIR_Coverage, 3874,
     /* 175784 */     GIR_EraseRootFromParent_Done,
     /* 175785 */   // Label 2679: @175785
     /* 175785 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(175833), // Rule ID 3869 //
     /* 175790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 175793 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 175809 */     // (st v2i16:{ *:[v2i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 175809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 175812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175817 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175831 */     GIR_RootConstrainSelectedInstOperands,
     /* 175832 */     // GIR_Coverage, 3869,
     /* 175832 */     GIR_EraseRootFromParent_Done,
     /* 175833 */   // Label 2680: @175833
     /* 175833 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(175881), // Rule ID 3873 //
     /* 175838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 175841 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 175857 */     // (st v2f16:{ *:[v2f16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 175857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 175860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175865 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175879 */     GIR_RootConstrainSelectedInstOperands,
     /* 175880 */     // GIR_Coverage, 3873,
     /* 175880 */     GIR_EraseRootFromParent_Done,
     /* 175881 */   // Label 2681: @175881
     /* 175881 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(175930), // Rule ID 3617 //
     /* 175886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 175889 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 175895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 175906 */     // (st v2i16:{ *:[v2i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 175906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 175909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175914 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175928 */     GIR_RootConstrainSelectedInstOperands,
     /* 175929 */     // GIR_Coverage, 3617,
     /* 175929 */     GIR_EraseRootFromParent_Done,
     /* 175930 */   // Label 2682: @175930
     /* 175930 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(175979), // Rule ID 3619 //
     /* 175935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 175938 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 175944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 175955 */     // (st v2f16:{ *:[v2f16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 175955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 175958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175963 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175977 */     GIR_RootConstrainSelectedInstOperands,
     /* 175978 */     // GIR_Coverage, 3619,
     /* 175978 */     GIR_EraseRootFromParent_Done,
     /* 175979 */   // Label 2683: @175979
     /* 175979 */   GIM_Reject,
     /* 175980 */ // Label 2651: @175980
     /* 175980 */ GIM_Reject,
     /* 175981 */ // Label 2311: @175981
     /* 175981 */ GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(178190),
     /* 175986 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175989 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(176050), // Rule ID 8062 //
     /* 175994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 175997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 176001 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176006 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176015 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 176019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176026 */     // (AMDGPUst_glue v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 176029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176034 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176048 */     GIR_RootConstrainSelectedInstOperands,
     /* 176049 */     // GIR_Coverage, 8062,
     /* 176049 */     GIR_EraseRootFromParent_Done,
     /* 176050 */   // Label 2685: @176050
     /* 176050 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(176111), // Rule ID 8066 //
     /* 176055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 176058 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 176062 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176067 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176076 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 176080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176087 */     // (AMDGPUst_glue v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 176090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176095 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176109 */     GIR_RootConstrainSelectedInstOperands,
     /* 176110 */     // GIR_Coverage, 8066,
     /* 176110 */     GIR_EraseRootFromParent_Done,
     /* 176111 */   // Label 2686: @176111
     /* 176111 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(176167), // Rule ID 7994 //
     /* 176116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 176119 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 176123 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176128 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 176132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176143 */     // (AMDGPUst_glue v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 176146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176151 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176165 */     GIR_RootConstrainSelectedInstOperands,
     /* 176166 */     // GIR_Coverage, 7994,
     /* 176166 */     GIR_EraseRootFromParent_Done,
     /* 176167 */   // Label 2687: @176167
     /* 176167 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(176223), // Rule ID 7998 //
     /* 176172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 176175 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 176179 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176184 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 176188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176199 */     // (AMDGPUst_glue v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 176202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176207 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176221 */     GIR_RootConstrainSelectedInstOperands,
     /* 176222 */     // GIR_Coverage, 7998,
     /* 176222 */     GIR_EraseRootFromParent_Done,
     /* 176223 */   // Label 2688: @176223
     /* 176223 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(176280), // Rule ID 8063 //
     /* 176228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 176231 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176236 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176245 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 176249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176256 */     // (st v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 176259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176264 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176278 */     GIR_RootConstrainSelectedInstOperands,
     /* 176279 */     // GIR_Coverage, 8063,
     /* 176279 */     GIR_EraseRootFromParent_Done,
     /* 176280 */   // Label 2689: @176280
     /* 176280 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(176337), // Rule ID 8067 //
     /* 176285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 176288 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176293 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176302 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 176306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176313 */     // (st v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 176316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176321 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176335 */     GIR_RootConstrainSelectedInstOperands,
     /* 176336 */     // GIR_Coverage, 8067,
     /* 176336 */     GIR_EraseRootFromParent_Done,
     /* 176337 */   // Label 2690: @176337
     /* 176337 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(176389), // Rule ID 7995 //
     /* 176342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 176345 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176350 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 176354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176365 */     // (st v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 176368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176373 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176387 */     GIR_RootConstrainSelectedInstOperands,
     /* 176388 */     // GIR_Coverage, 7995,
     /* 176388 */     GIR_EraseRootFromParent_Done,
     /* 176389 */   // Label 2691: @176389
     /* 176389 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(176441), // Rule ID 7999 //
     /* 176394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 176397 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176402 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 176406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176417 */     // (st v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 176420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176425 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176439 */     GIR_RootConstrainSelectedInstOperands,
     /* 176440 */     // GIR_Coverage, 7999,
     /* 176440 */     GIR_EraseRootFromParent_Done,
     /* 176441 */   // Label 2692: @176441
     /* 176441 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(176497), // Rule ID 6633 //
     /* 176446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 176449 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 176465 */     // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_OFFSET VReg_64:{ *:[v2i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 176465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 176468 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 176475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 176480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 176485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176495 */     GIR_RootConstrainSelectedInstOperands,
     /* 176496 */     // GIR_Coverage, 6633,
     /* 176496 */     GIR_EraseRootFromParent_Done,
     /* 176497 */   // Label 2693: @176497
     /* 176497 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(176553), // Rule ID 6635 //
     /* 176502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 176505 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 176521 */     // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET VReg_64:{ *:[v2i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 176521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 176524 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 176531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 176536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 176541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176551 */     GIR_RootConstrainSelectedInstOperands,
     /* 176552 */     // GIR_Coverage, 6635,
     /* 176552 */     GIR_EraseRootFromParent_Done,
     /* 176553 */   // Label 2694: @176553
     /* 176553 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(176606), // Rule ID 4308 //
     /* 176558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 176561 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 176577 */     // (st v2i32:{ *:[v2i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 176577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 176580 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 176592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 176597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176604 */     GIR_RootConstrainSelectedInstOperands,
     /* 176605 */     // GIR_Coverage, 4308,
     /* 176605 */     GIR_EraseRootFromParent_Done,
     /* 176606 */   // Label 2695: @176606
     /* 176606 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(176659), // Rule ID 4314 //
     /* 176611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 176614 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 176630 */     // (st v2f32:{ *:[v2f32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9819:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 176630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 176633 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 176645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 176650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176657 */     GIR_RootConstrainSelectedInstOperands,
     /* 176658 */     // GIR_Coverage, 4314,
     /* 176658 */     GIR_EraseRootFromParent_Done,
     /* 176659 */   // Label 2696: @176659
     /* 176659 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(176707), // Rule ID 4307 //
     /* 176664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 176667 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 176683 */     // (st v2i32:{ *:[v2i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 176683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 176686 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 176693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176705 */     GIR_RootConstrainSelectedInstOperands,
     /* 176706 */     // GIR_Coverage, 4307,
     /* 176706 */     GIR_EraseRootFromParent_Done,
     /* 176707 */   // Label 2697: @176707
     /* 176707 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(176755), // Rule ID 4313 //
     /* 176712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 176715 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 176731 */     // (st v2f32:{ *:[v2f32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9819:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 176731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 176734 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 176741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176753 */     GIR_RootConstrainSelectedInstOperands,
     /* 176754 */     // GIR_Coverage, 4313,
     /* 176754 */     GIR_EraseRootFromParent_Done,
     /* 176755 */   // Label 2698: @176755
     /* 176755 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(176803), // Rule ID 4306 //
     /* 176760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 176763 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 176779 */     // (st v2i32:{ *:[v2i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 176779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 176782 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176801 */     GIR_RootConstrainSelectedInstOperands,
     /* 176802 */     // GIR_Coverage, 4306,
     /* 176802 */     GIR_EraseRootFromParent_Done,
     /* 176803 */   // Label 2699: @176803
     /* 176803 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(176851), // Rule ID 4312 //
     /* 176808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 176811 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 176827 */     // (st v2f32:{ *:[v2f32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9819:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 176827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 176830 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176849 */     GIR_RootConstrainSelectedInstOperands,
     /* 176850 */     // GIR_Coverage, 4312,
     /* 176850 */     GIR_EraseRootFromParent_Done,
     /* 176851 */   // Label 2700: @176851
     /* 176851 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(176912), // Rule ID 4641 //
     /* 176856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 176859 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 176864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 176875 */     // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v2i32:{ *:[v2i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 176875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 176878 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 176880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 176885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 176890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 176895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 176900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176910 */     GIR_RootConstrainSelectedInstOperands,
     /* 176911 */     // GIR_Coverage, 4641,
     /* 176911 */     GIR_EraseRootFromParent_Done,
     /* 176912 */   // Label 2701: @176912
     /* 176912 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(176970), // Rule ID 4643 //
     /* 176917 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 176922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 176933 */     // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v2i32:{ *:[v2i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 176933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 176936 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 176938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 176943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 176948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 176953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 176958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176968 */     GIR_RootConstrainSelectedInstOperands,
     /* 176969 */     // GIR_Coverage, 4643,
     /* 176969 */     GIR_EraseRootFromParent_Done,
     /* 176970 */   // Label 2702: @176970
     /* 176970 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(177031), // Rule ID 4645 //
     /* 176975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 176978 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 176983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 176994 */     // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v2f32:{ *:[v2f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 176994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 176997 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 176999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 177004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 177014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 177019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177029 */     GIR_RootConstrainSelectedInstOperands,
     /* 177030 */     // GIR_Coverage, 4645,
     /* 177030 */     GIR_EraseRootFromParent_Done,
     /* 177031 */   // Label 2703: @177031
     /* 177031 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(177089), // Rule ID 4647 //
     /* 177036 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 177052 */     // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v2f32:{ *:[v2f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 177055 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 177062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 177072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 177077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177087 */     GIR_RootConstrainSelectedInstOperands,
     /* 177088 */     // GIR_Coverage, 4647,
     /* 177088 */     GIR_EraseRootFromParent_Done,
     /* 177089 */   // Label 2704: @177089
     /* 177089 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(177150), // Rule ID 6632 //
     /* 177094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 177097 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 177102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 177113 */     // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_OFFEN VReg_64:{ *:[v2i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 177113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN),
     /* 177116 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 177118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 177123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 177133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 177138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177148 */     GIR_RootConstrainSelectedInstOperands,
     /* 177149 */     // GIR_Coverage, 6632,
     /* 177149 */     GIR_EraseRootFromParent_Done,
     /* 177150 */   // Label 2705: @177150
     /* 177150 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(177211), // Rule ID 6634 //
     /* 177155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 177158 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 177163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 177174 */     // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN VReg_64:{ *:[v2i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 177174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN),
     /* 177177 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 177179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 177184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 177194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 177199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177209 */     GIR_RootConstrainSelectedInstOperands,
     /* 177210 */     // GIR_Coverage, 6634,
     /* 177210 */     GIR_EraseRootFromParent_Done,
     /* 177211 */   // Label 2706: @177211
     /* 177211 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(177328), // Rule ID 7937 //
     /* 177216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 177219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 177223 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 177228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 177239 */     // (AMDGPUst_glue v2i32:{ *:[v2i32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 177239 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177242 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177246 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177251 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 177257 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177262 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177279 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 177285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 177298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 177303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 177309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 177314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 177319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177326 */     GIR_RootConstrainSelectedInstOperands,
     /* 177327 */     // GIR_Coverage, 7937,
     /* 177327 */     GIR_EraseRootFromParent_Done,
     /* 177328 */   // Label 2707: @177328
     /* 177328 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(177445), // Rule ID 7941 //
     /* 177333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 177336 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 177340 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 177345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 177356 */     // (AMDGPUst_glue v2f32:{ *:[v2f32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 177356 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177359 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177363 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177368 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 177374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177396 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 177402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 177415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 177420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 177426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 177431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 177436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177443 */     GIR_RootConstrainSelectedInstOperands,
     /* 177444 */     // GIR_Coverage, 7941,
     /* 177444 */     GIR_EraseRootFromParent_Done,
     /* 177445 */   // Label 2708: @177445
     /* 177445 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(177501), // Rule ID 4640 //
     /* 177450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 177453 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 177469 */     // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 177472 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 177484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177499 */     GIR_RootConstrainSelectedInstOperands,
     /* 177500 */     // GIR_Coverage, 4640,
     /* 177500 */     GIR_EraseRootFromParent_Done,
     /* 177501 */   // Label 2709: @177501
     /* 177501 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(177554), // Rule ID 4642 //
     /* 177506 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 177522 */     // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 177525 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 177537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177552 */     GIR_RootConstrainSelectedInstOperands,
     /* 177553 */     // GIR_Coverage, 4642,
     /* 177553 */     GIR_EraseRootFromParent_Done,
     /* 177554 */   // Label 2710: @177554
     /* 177554 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(177610), // Rule ID 4644 //
     /* 177559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 177562 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 177578 */     // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 177581 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 177593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177608 */     GIR_RootConstrainSelectedInstOperands,
     /* 177609 */     // GIR_Coverage, 4644,
     /* 177609 */     GIR_EraseRootFromParent_Done,
     /* 177610 */   // Label 2711: @177610
     /* 177610 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(177663), // Rule ID 4646 //
     /* 177615 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 177631 */     // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 177634 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 177646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177661 */     GIR_RootConstrainSelectedInstOperands,
     /* 177662 */     // GIR_Coverage, 4646,
     /* 177662 */     GIR_EraseRootFromParent_Done,
     /* 177663 */   // Label 2712: @177663
     /* 177663 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(177776), // Rule ID 7939 //
     /* 177668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 177671 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 177676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 177687 */     // (st v2i32:{ *:[v2i32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 177687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177699 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 177705 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177710 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177727 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 177733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 177746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 177751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 177757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 177762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 177767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177774 */     GIR_RootConstrainSelectedInstOperands,
     /* 177775 */     // GIR_Coverage, 7939,
     /* 177775 */     GIR_EraseRootFromParent_Done,
     /* 177776 */   // Label 2713: @177776
     /* 177776 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(177889), // Rule ID 7943 //
     /* 177781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 177784 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 177789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 177800 */     // (st v2f32:{ *:[v2f32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 177800 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177803 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177807 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177812 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 177818 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177823 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177840 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 177846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 177859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 177864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 177870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 177875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 177880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177887 */     GIR_RootConstrainSelectedInstOperands,
     /* 177888 */     // GIR_Coverage, 7943,
     /* 177888 */     GIR_EraseRootFromParent_Done,
     /* 177889 */   // Label 2714: @177889
     /* 177889 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(177942), // Rule ID 3902 //
     /* 177894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 177897 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 177913 */     // (st v2i32:{ *:[v2i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 177913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 177916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 177921 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 177923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 177928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177940 */     GIR_RootConstrainSelectedInstOperands,
     /* 177941 */     // GIR_Coverage, 3902,
     /* 177941 */     GIR_EraseRootFromParent_Done,
     /* 177942 */   // Label 2715: @177942
     /* 177942 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(177995), // Rule ID 3906 //
     /* 177947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 177950 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 177966 */     // (st v2f32:{ *:[v2f32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[v2f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 177966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 177969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 177974 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 177976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 177981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177993 */     GIR_RootConstrainSelectedInstOperands,
     /* 177994 */     // GIR_Coverage, 3906,
     /* 177994 */     GIR_EraseRootFromParent_Done,
     /* 177995 */   // Label 2716: @177995
     /* 177995 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(178043), // Rule ID 3901 //
     /* 178000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 178003 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 178008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 178019 */     // (st v2i32:{ *:[v2i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 178019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 178022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178027 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178041 */     GIR_RootConstrainSelectedInstOperands,
     /* 178042 */     // GIR_Coverage, 3901,
     /* 178042 */     GIR_EraseRootFromParent_Done,
     /* 178043 */   // Label 2717: @178043
     /* 178043 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(178091), // Rule ID 3905 //
     /* 178048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 178051 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 178056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 178067 */     // (st v2f32:{ *:[v2f32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 178067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 178070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178075 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178089 */     GIR_RootConstrainSelectedInstOperands,
     /* 178090 */     // GIR_Coverage, 3905,
     /* 178090 */     GIR_EraseRootFromParent_Done,
     /* 178091 */   // Label 2718: @178091
     /* 178091 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(178140), // Rule ID 3632 //
     /* 178096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 178099 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 178105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 178116 */     // (st v2i32:{ *:[v2i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 178116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 178119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178124 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178138 */     GIR_RootConstrainSelectedInstOperands,
     /* 178139 */     // GIR_Coverage, 3632,
     /* 178139 */     GIR_EraseRootFromParent_Done,
     /* 178140 */   // Label 2719: @178140
     /* 178140 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(178189), // Rule ID 3634 //
     /* 178145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 178148 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 178154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 178165 */     // (st v2f32:{ *:[v2f32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 178165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 178168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178173 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178187 */     GIR_RootConstrainSelectedInstOperands,
     /* 178188 */     // GIR_Coverage, 3634,
     /* 178188 */     GIR_EraseRootFromParent_Done,
     /* 178189 */   // Label 2720: @178189
     /* 178189 */   GIM_Reject,
     /* 178190 */ // Label 2684: @178190
     /* 178190 */ GIM_Reject,
     /* 178191 */ // Label 2312: @178191
     /* 178191 */ GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(180166),
     /* 178196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178199 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(178255), // Rule ID 8038 //
     /* 178204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 178207 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 178211 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178216 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 178220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178231 */     // (AMDGPUst_glue v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 178234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178239 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178253 */     GIR_RootConstrainSelectedInstOperands,
     /* 178254 */     // GIR_Coverage, 8038,
     /* 178254 */     GIR_EraseRootFromParent_Done,
     /* 178255 */   // Label 2722: @178255
     /* 178255 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(178311), // Rule ID 8042 //
     /* 178260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 178263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 178267 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178272 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 178276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178287 */     // (AMDGPUst_glue v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 178290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178295 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178309 */     GIR_RootConstrainSelectedInstOperands,
     /* 178310 */     // GIR_Coverage, 8042,
     /* 178310 */     GIR_EraseRootFromParent_Done,
     /* 178311 */   // Label 2723: @178311
     /* 178311 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(178372), // Rule ID 8106 //
     /* 178316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 178319 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 178323 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178328 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178337 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 178341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178348 */     // (AMDGPUst_glue v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 178351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178356 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178370 */     GIR_RootConstrainSelectedInstOperands,
     /* 178371 */     // GIR_Coverage, 8106,
     /* 178371 */     GIR_EraseRootFromParent_Done,
     /* 178372 */   // Label 2724: @178372
     /* 178372 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(178433), // Rule ID 8110 //
     /* 178377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 178380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 178384 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178389 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178398 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 178402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178409 */     // (AMDGPUst_glue v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 178412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178417 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178431 */     GIR_RootConstrainSelectedInstOperands,
     /* 178432 */     // GIR_Coverage, 8110,
     /* 178432 */     GIR_EraseRootFromParent_Done,
     /* 178433 */   // Label 2725: @178433
     /* 178433 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(178485), // Rule ID 8039 //
     /* 178438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 178441 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178446 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 178450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178461 */     // (st v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 178464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178469 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178483 */     GIR_RootConstrainSelectedInstOperands,
     /* 178484 */     // GIR_Coverage, 8039,
     /* 178484 */     GIR_EraseRootFromParent_Done,
     /* 178485 */   // Label 2726: @178485
     /* 178485 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(178537), // Rule ID 8043 //
     /* 178490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 178493 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178498 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 178502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178513 */     // (st v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 178516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178521 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178535 */     GIR_RootConstrainSelectedInstOperands,
     /* 178536 */     // GIR_Coverage, 8043,
     /* 178536 */     GIR_EraseRootFromParent_Done,
     /* 178537 */   // Label 2727: @178537
     /* 178537 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(178594), // Rule ID 8107 //
     /* 178542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 178545 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178550 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 178563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178570 */     // (st v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 178573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178578 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178592 */     GIR_RootConstrainSelectedInstOperands,
     /* 178593 */     // GIR_Coverage, 8107,
     /* 178593 */     GIR_EraseRootFromParent_Done,
     /* 178594 */   // Label 2728: @178594
     /* 178594 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(178651), // Rule ID 8111 //
     /* 178599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 178602 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178607 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 178612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 178620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 178627 */     // (st v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 178627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 178630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 178635 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178649 */     GIR_RootConstrainSelectedInstOperands,
     /* 178650 */     // GIR_Coverage, 8111,
     /* 178650 */     GIR_EraseRootFromParent_Done,
     /* 178651 */   // Label 2729: @178651
     /* 178651 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(178704), // Rule ID 4365 //
     /* 178656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 178659 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 178675 */     // (st v2i64:{ *:[v2i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 178675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 178678 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 178690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 178695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178702 */     GIR_RootConstrainSelectedInstOperands,
     /* 178703 */     // GIR_Coverage, 4365,
     /* 178703 */     GIR_EraseRootFromParent_Done,
     /* 178704 */   // Label 2730: @178704
     /* 178704 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(178757), // Rule ID 4371 //
     /* 178709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 178712 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 178728 */     // (st v2f64:{ *:[v2f64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9817:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 178728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 178731 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 178743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 178748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178755 */     GIR_RootConstrainSelectedInstOperands,
     /* 178756 */     // GIR_Coverage, 4371,
     /* 178756 */     GIR_EraseRootFromParent_Done,
     /* 178757 */   // Label 2731: @178757
     /* 178757 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(178805), // Rule ID 4364 //
     /* 178762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 178765 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 178781 */     // (st v2i64:{ *:[v2i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 178781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 178784 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 178791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178803 */     GIR_RootConstrainSelectedInstOperands,
     /* 178804 */     // GIR_Coverage, 4364,
     /* 178804 */     GIR_EraseRootFromParent_Done,
     /* 178805 */   // Label 2732: @178805
     /* 178805 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(178853), // Rule ID 4370 //
     /* 178810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 178813 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 178829 */     // (st v2f64:{ *:[v2f64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9817:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 178829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 178832 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 178839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178851 */     GIR_RootConstrainSelectedInstOperands,
     /* 178852 */     // GIR_Coverage, 4370,
     /* 178852 */     GIR_EraseRootFromParent_Done,
     /* 178853 */   // Label 2733: @178853
     /* 178853 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(178901), // Rule ID 4363 //
     /* 178858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 178861 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 178877 */     // (st v2i64:{ *:[v2i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 178877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 178880 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178899 */     GIR_RootConstrainSelectedInstOperands,
     /* 178900 */     // GIR_Coverage, 4363,
     /* 178900 */     GIR_EraseRootFromParent_Done,
     /* 178901 */   // Label 2734: @178901
     /* 178901 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(178949), // Rule ID 4369 //
     /* 178906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 178909 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 178925 */     // (st v2f64:{ *:[v2f64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9817:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 178925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 178928 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178947 */     GIR_RootConstrainSelectedInstOperands,
     /* 178948 */     // GIR_Coverage, 4369,
     /* 178948 */     GIR_EraseRootFromParent_Done,
     /* 178949 */   // Label 2735: @178949
     /* 178949 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(179010), // Rule ID 4685 //
     /* 178954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 178957 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 178962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 178973 */     // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v2i64:{ *:[v2i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 178973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 178976 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 178978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 178983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 178988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 178993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 178998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179008 */     GIR_RootConstrainSelectedInstOperands,
     /* 179009 */     // GIR_Coverage, 4685,
     /* 179009 */     GIR_EraseRootFromParent_Done,
     /* 179010 */   // Label 2736: @179010
     /* 179010 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(179068), // Rule ID 4687 //
     /* 179015 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 179031 */     // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v2i64:{ *:[v2i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 179034 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 179041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 179051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 179056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179066 */     GIR_RootConstrainSelectedInstOperands,
     /* 179067 */     // GIR_Coverage, 4687,
     /* 179067 */     GIR_EraseRootFromParent_Done,
     /* 179068 */   // Label 2737: @179068
     /* 179068 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(179129), // Rule ID 4689 //
     /* 179073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 179076 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 179092 */     // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v2f64:{ *:[v2f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 179095 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 179102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 179112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 179117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179127 */     GIR_RootConstrainSelectedInstOperands,
     /* 179128 */     // GIR_Coverage, 4689,
     /* 179128 */     GIR_EraseRootFromParent_Done,
     /* 179129 */   // Label 2738: @179129
     /* 179129 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(179187), // Rule ID 4691 //
     /* 179134 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 179150 */     // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v2f64:{ *:[v2f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 179153 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 179160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 179170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 179175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179185 */     GIR_RootConstrainSelectedInstOperands,
     /* 179186 */     // GIR_Coverage, 4691,
     /* 179186 */     GIR_EraseRootFromParent_Done,
     /* 179187 */   // Label 2739: @179187
     /* 179187 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(179304), // Rule ID 7969 //
     /* 179192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 179195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 179199 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 179204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 179215 */     // (AMDGPUst_glue v2i64:{ *:[v2i64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 179215 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 179218 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179222 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179227 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 179233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 179246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179255 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 179261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 179274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 179279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 179285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 179290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 179295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179302 */     GIR_RootConstrainSelectedInstOperands,
     /* 179303 */     // GIR_Coverage, 7969,
     /* 179303 */     GIR_EraseRootFromParent_Done,
     /* 179304 */   // Label 2740: @179304
     /* 179304 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(179421), // Rule ID 7973 //
     /* 179309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 179312 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 179316 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 179321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 179332 */     // (AMDGPUst_glue v2f64:{ *:[v2f64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 179332 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 179335 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179339 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179344 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 179350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179355 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 179363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179372 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 179378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 179391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 179396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 179402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 179407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 179412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179419 */     GIR_RootConstrainSelectedInstOperands,
     /* 179420 */     // GIR_Coverage, 7973,
     /* 179420 */     GIR_EraseRootFromParent_Done,
     /* 179421 */   // Label 2741: @179421
     /* 179421 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(179477), // Rule ID 4684 //
     /* 179426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 179429 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 179445 */     // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 179448 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 179460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179475 */     GIR_RootConstrainSelectedInstOperands,
     /* 179476 */     // GIR_Coverage, 4684,
     /* 179476 */     GIR_EraseRootFromParent_Done,
     /* 179477 */   // Label 2742: @179477
     /* 179477 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(179530), // Rule ID 4686 //
     /* 179482 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 179498 */     // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 179501 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 179513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179528 */     GIR_RootConstrainSelectedInstOperands,
     /* 179529 */     // GIR_Coverage, 4686,
     /* 179529 */     GIR_EraseRootFromParent_Done,
     /* 179530 */   // Label 2743: @179530
     /* 179530 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(179586), // Rule ID 4688 //
     /* 179535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 179538 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 179554 */     // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 179557 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 179569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179584 */     GIR_RootConstrainSelectedInstOperands,
     /* 179585 */     // GIR_Coverage, 4688,
     /* 179585 */     GIR_EraseRootFromParent_Done,
     /* 179586 */   // Label 2744: @179586
     /* 179586 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(179639), // Rule ID 4690 //
     /* 179591 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 179607 */     // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 179610 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 179622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179637 */     GIR_RootConstrainSelectedInstOperands,
     /* 179638 */     // GIR_Coverage, 4690,
     /* 179638 */     GIR_EraseRootFromParent_Done,
     /* 179639 */   // Label 2745: @179639
     /* 179639 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(179752), // Rule ID 7971 //
     /* 179644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 179647 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 179652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 179663 */     // (st v2i64:{ *:[v2i64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 179663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 179666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179675 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 179681 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 179694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179703 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 179709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 179722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 179727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 179733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 179738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 179743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179750 */     GIR_RootConstrainSelectedInstOperands,
     /* 179751 */     // GIR_Coverage, 7971,
     /* 179751 */     GIR_EraseRootFromParent_Done,
     /* 179752 */   // Label 2746: @179752
     /* 179752 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(179865), // Rule ID 7975 //
     /* 179757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 179760 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 179765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 179776 */     // (st v2f64:{ *:[v2f64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 179776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 179779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179788 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 179794 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179799 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 179807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179816 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 179822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 179827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 179832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 179835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 179840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 179846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 179851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 179856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179863 */     GIR_RootConstrainSelectedInstOperands,
     /* 179864 */     // GIR_Coverage, 7975,
     /* 179864 */     GIR_EraseRootFromParent_Done,
     /* 179865 */   // Label 2747: @179865
     /* 179865 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(179918), // Rule ID 3940 //
     /* 179870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 179873 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 179889 */     // (st v2i64:{ *:[v2i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 179889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 179892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 179897 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 179899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 179904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179916 */     GIR_RootConstrainSelectedInstOperands,
     /* 179917 */     // GIR_Coverage, 3940,
     /* 179917 */     GIR_EraseRootFromParent_Done,
     /* 179918 */   // Label 2748: @179918
     /* 179918 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(179971), // Rule ID 3944 //
     /* 179923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 179926 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 179942 */     // (st v2f64:{ *:[v2f64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9817:{ *:[v2f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 179942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 179945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 179950 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 179952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 179957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179969 */     GIR_RootConstrainSelectedInstOperands,
     /* 179970 */     // GIR_Coverage, 3944,
     /* 179970 */     GIR_EraseRootFromParent_Done,
     /* 179971 */   // Label 2749: @179971
     /* 179971 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(180019), // Rule ID 3939 //
     /* 179976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 179979 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 179995 */     // (st v2i64:{ *:[v2i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 179995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 179998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180003 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180017 */     GIR_RootConstrainSelectedInstOperands,
     /* 180018 */     // GIR_Coverage, 3939,
     /* 180018 */     GIR_EraseRootFromParent_Done,
     /* 180019 */   // Label 2750: @180019
     /* 180019 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(180067), // Rule ID 3943 //
     /* 180024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 180027 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 180032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 180043 */     // (st v2f64:{ *:[v2f64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 180043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 180046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180051 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180065 */     GIR_RootConstrainSelectedInstOperands,
     /* 180066 */     // GIR_Coverage, 3943,
     /* 180066 */     GIR_EraseRootFromParent_Done,
     /* 180067 */   // Label 2751: @180067
     /* 180067 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(180116), // Rule ID 3652 //
     /* 180072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 180075 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 180081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 180092 */     // (st v2i64:{ *:[v2i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 180092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 180095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180100 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180114 */     GIR_RootConstrainSelectedInstOperands,
     /* 180115 */     // GIR_Coverage, 3652,
     /* 180115 */     GIR_EraseRootFromParent_Done,
     /* 180116 */   // Label 2752: @180116
     /* 180116 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(180165), // Rule ID 3654 //
     /* 180121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 180124 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 180130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 180141 */     // (st v2f64:{ *:[v2f64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 180141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 180144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180149 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180163 */     GIR_RootConstrainSelectedInstOperands,
     /* 180164 */     // GIR_Coverage, 3654,
     /* 180164 */     GIR_EraseRootFromParent_Done,
     /* 180165 */   // Label 2753: @180165
     /* 180165 */   GIM_Reject,
     /* 180166 */ // Label 2721: @180166
     /* 180166 */ GIM_Reject,
     /* 180167 */ // Label 2313: @180167
     /* 180167 */ GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(181581),
     /* 180172 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180175 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(180231), // Rule ID 8022 //
     /* 180180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 180183 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 180187 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180192 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 180196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180207 */     // (AMDGPUst_glue v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9818:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
     /* 180210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180215 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180229 */     GIR_RootConstrainSelectedInstOperands,
     /* 180230 */     // GIR_Coverage, 8022,
     /* 180230 */     GIR_EraseRootFromParent_Done,
     /* 180231 */   // Label 2755: @180231
     /* 180231 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(180287), // Rule ID 8026 //
     /* 180236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 180239 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 180243 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180248 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 180252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180263 */     // (AMDGPUst_glue v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9818:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
     /* 180266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180271 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180285 */     GIR_RootConstrainSelectedInstOperands,
     /* 180286 */     // GIR_Coverage, 8026,
     /* 180286 */     GIR_EraseRootFromParent_Done,
     /* 180287 */   // Label 2756: @180287
     /* 180287 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(180339), // Rule ID 8090 //
     /* 180292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 180295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 180299 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180315 */     // (AMDGPUst_glue v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9818:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
     /* 180318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180323 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180337 */     GIR_RootConstrainSelectedInstOperands,
     /* 180338 */     // GIR_Coverage, 8090,
     /* 180338 */     GIR_EraseRootFromParent_Done,
     /* 180339 */   // Label 2757: @180339
     /* 180339 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(180391), // Rule ID 8094 //
     /* 180344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 180347 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 180351 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180367 */     // (AMDGPUst_glue v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9818:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
     /* 180370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180375 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180389 */     GIR_RootConstrainSelectedInstOperands,
     /* 180390 */     // GIR_Coverage, 8094,
     /* 180390 */     GIR_EraseRootFromParent_Done,
     /* 180391 */   // Label 2758: @180391
     /* 180391 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(180443), // Rule ID 8023 //
     /* 180396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 180399 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180404 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 180408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180419 */     // (st v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9818:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
     /* 180422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180427 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180441 */     GIR_RootConstrainSelectedInstOperands,
     /* 180442 */     // GIR_Coverage, 8023,
     /* 180442 */     GIR_EraseRootFromParent_Done,
     /* 180443 */   // Label 2759: @180443
     /* 180443 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(180495), // Rule ID 8027 //
     /* 180448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 180451 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180456 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 180460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180471 */     // (st v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9818:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
     /* 180474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180479 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180493 */     GIR_RootConstrainSelectedInstOperands,
     /* 180494 */     // GIR_Coverage, 8027,
     /* 180494 */     GIR_EraseRootFromParent_Done,
     /* 180495 */   // Label 2760: @180495
     /* 180495 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(180543), // Rule ID 8091 //
     /* 180500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 180503 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180519 */     // (st v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9818:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
     /* 180522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180527 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180541 */     GIR_RootConstrainSelectedInstOperands,
     /* 180542 */     // GIR_Coverage, 8091,
     /* 180542 */     GIR_EraseRootFromParent_Done,
     /* 180543 */   // Label 2761: @180543
     /* 180543 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(180591), // Rule ID 8095 //
     /* 180548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 180551 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180567 */     // (st v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9818:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
     /* 180570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180575 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180589 */     GIR_RootConstrainSelectedInstOperands,
     /* 180590 */     // GIR_Coverage, 8095,
     /* 180590 */     GIR_EraseRootFromParent_Done,
     /* 180591 */   // Label 2762: @180591
     /* 180591 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(180647), // Rule ID 6637 //
     /* 180596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 180599 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 180615 */     // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_OFFSET VReg_96:{ *:[v3i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 180615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET),
     /* 180618 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 180625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 180630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 180635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180645 */     GIR_RootConstrainSelectedInstOperands,
     /* 180646 */     // GIR_Coverage, 6637,
     /* 180646 */     GIR_EraseRootFromParent_Done,
     /* 180647 */   // Label 2763: @180647
     /* 180647 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(180703), // Rule ID 6639 //
     /* 180652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 180655 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 180671 */     // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET VReg_96:{ *:[v3i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 180671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET),
     /* 180674 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 180681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 180686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 180691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180701 */     GIR_RootConstrainSelectedInstOperands,
     /* 180702 */     // GIR_Coverage, 6639,
     /* 180702 */     GIR_EraseRootFromParent_Done,
     /* 180703 */   // Label 2764: @180703
     /* 180703 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(180756), // Rule ID 4392 //
     /* 180708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 180711 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 180727 */     // (st v3i32:{ *:[v3i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX3_SVS anonymous_9818:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 180727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX3_SVS),
     /* 180730 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 180742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 180747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180754 */     GIR_RootConstrainSelectedInstOperands,
     /* 180755 */     // GIR_Coverage, 4392,
     /* 180755 */     GIR_EraseRootFromParent_Done,
     /* 180756 */   // Label 2765: @180756
     /* 180756 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(180804), // Rule ID 4391 //
     /* 180761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 180764 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 180780 */     // (st v3i32:{ *:[v3i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX3_SADDR anonymous_9818:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 180780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX3_SADDR),
     /* 180783 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 180790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180802 */     GIR_RootConstrainSelectedInstOperands,
     /* 180803 */     // GIR_Coverage, 4391,
     /* 180803 */     GIR_EraseRootFromParent_Done,
     /* 180804 */   // Label 2766: @180804
     /* 180804 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(180852), // Rule ID 4390 //
     /* 180809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 180812 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 180828 */     // (st v3i32:{ *:[v3i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX3 anonymous_9818:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 180828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX3),
     /* 180831 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180850 */     GIR_RootConstrainSelectedInstOperands,
     /* 180851 */     // GIR_Coverage, 4390,
     /* 180851 */     GIR_EraseRootFromParent_Done,
     /* 180852 */   // Label 2767: @180852
     /* 180852 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(180913), // Rule ID 4669 //
     /* 180857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 180860 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 180865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 180876 */     // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_ADDR64 v3i32:{ *:[v3i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 180876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_ADDR64),
     /* 180879 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 180881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 180886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 180891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 180896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 180901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180911 */     GIR_RootConstrainSelectedInstOperands,
     /* 180912 */     // GIR_Coverage, 4669,
     /* 180912 */     GIR_EraseRootFromParent_Done,
     /* 180913 */   // Label 2768: @180913
     /* 180913 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(180971), // Rule ID 4671 //
     /* 180918 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 180923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 180934 */     // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_ADDR64 v3i32:{ *:[v3i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 180934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_ADDR64),
     /* 180937 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 180939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 180944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 180949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 180954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 180959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180969 */     GIR_RootConstrainSelectedInstOperands,
     /* 180970 */     // GIR_Coverage, 4671,
     /* 180970 */     GIR_EraseRootFromParent_Done,
     /* 180971 */   // Label 2769: @180971
     /* 180971 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(181032), // Rule ID 4673 //
     /* 180976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 180979 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 180984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 180995 */     // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_ADDR64 v3f32:{ *:[v3f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 180995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_ADDR64),
     /* 180998 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181030 */     GIR_RootConstrainSelectedInstOperands,
     /* 181031 */     // GIR_Coverage, 4673,
     /* 181031 */     GIR_EraseRootFromParent_Done,
     /* 181032 */   // Label 2770: @181032
     /* 181032 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(181090), // Rule ID 4675 //
     /* 181037 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 181053 */     // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_ADDR64 v3f32:{ *:[v3f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_ADDR64),
     /* 181056 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181088 */     GIR_RootConstrainSelectedInstOperands,
     /* 181089 */     // GIR_Coverage, 4675,
     /* 181089 */     GIR_EraseRootFromParent_Done,
     /* 181090 */   // Label 2771: @181090
     /* 181090 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(181151), // Rule ID 6636 //
     /* 181095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 181098 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 181103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 181114 */     // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_OFFEN VReg_96:{ *:[v3i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 181114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFEN),
     /* 181117 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181149 */     GIR_RootConstrainSelectedInstOperands,
     /* 181150 */     // GIR_Coverage, 6636,
     /* 181150 */     GIR_EraseRootFromParent_Done,
     /* 181151 */   // Label 2772: @181151
     /* 181151 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(181212), // Rule ID 6638 //
     /* 181156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 181159 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 181164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 181175 */     // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFEN VReg_96:{ *:[v3i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 181175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFEN),
     /* 181178 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181210 */     GIR_RootConstrainSelectedInstOperands,
     /* 181211 */     // GIR_Coverage, 6638,
     /* 181211 */     GIR_EraseRootFromParent_Done,
     /* 181212 */   // Label 2773: @181212
     /* 181212 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(181268), // Rule ID 4668 //
     /* 181217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 181220 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 181236 */     // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_OFFSET v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET),
     /* 181239 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 181251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181266 */     GIR_RootConstrainSelectedInstOperands,
     /* 181267 */     // GIR_Coverage, 4668,
     /* 181267 */     GIR_EraseRootFromParent_Done,
     /* 181268 */   // Label 2774: @181268
     /* 181268 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(181321), // Rule ID 4670 //
     /* 181273 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 181289 */     // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET),
     /* 181292 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 181304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181319 */     GIR_RootConstrainSelectedInstOperands,
     /* 181320 */     // GIR_Coverage, 4670,
     /* 181320 */     GIR_EraseRootFromParent_Done,
     /* 181321 */   // Label 2775: @181321
     /* 181321 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(181377), // Rule ID 4672 //
     /* 181326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 181329 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 181345 */     // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_OFFSET v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET),
     /* 181348 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 181360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181375 */     GIR_RootConstrainSelectedInstOperands,
     /* 181376 */     // GIR_Coverage, 4672,
     /* 181376 */     GIR_EraseRootFromParent_Done,
     /* 181377 */   // Label 2776: @181377
     /* 181377 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(181430), // Rule ID 4674 //
     /* 181382 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 181398 */     // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET),
     /* 181401 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 181413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181428 */     GIR_RootConstrainSelectedInstOperands,
     /* 181429 */     // GIR_Coverage, 4674,
     /* 181429 */     GIR_EraseRootFromParent_Done,
     /* 181430 */   // Label 2777: @181430
     /* 181430 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(181483), // Rule ID 3962 //
     /* 181435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 181438 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 181454 */     // (st v3i32:{ *:[v3i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX3_SADDR ?:{ *:[i32] }:$voffset, anonymous_9818:{ *:[v3i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 181454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX3_SADDR),
     /* 181457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 181462 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 181464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 181469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181481 */     GIR_RootConstrainSelectedInstOperands,
     /* 181482 */     // GIR_Coverage, 3962,
     /* 181482 */     GIR_EraseRootFromParent_Done,
     /* 181483 */   // Label 2778: @181483
     /* 181483 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(181531), // Rule ID 3961 //
     /* 181488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 181491 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 181507 */     // (st v3i32:{ *:[v3i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX3 ?:{ *:[i64] }:$vaddr, anonymous_9818:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 181507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX3),
     /* 181510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 181515 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 181517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181529 */     GIR_RootConstrainSelectedInstOperands,
     /* 181530 */     // GIR_Coverage, 3961,
     /* 181530 */     GIR_EraseRootFromParent_Done,
     /* 181531 */   // Label 2779: @181531
     /* 181531 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(181580), // Rule ID 3646 //
     /* 181536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 181539 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 181545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 181556 */     // (st v3i32:{ *:[v3i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX3 ?:{ *:[i64] }:$vaddr, anonymous_9818:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 181556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX3),
     /* 181559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 181564 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 181566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181578 */     GIR_RootConstrainSelectedInstOperands,
     /* 181579 */     // GIR_Coverage, 3646,
     /* 181579 */     GIR_EraseRootFromParent_Done,
     /* 181580 */   // Label 2780: @181580
     /* 181580 */   GIM_Reject,
     /* 181581 */ // Label 2754: @181581
     /* 181581 */ GIM_Reject,
     /* 181582 */ // Label 2314: @181582
     /* 181582 */ GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(183557),
     /* 181587 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181590 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(181651), // Rule ID 8070 //
     /* 181595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 181598 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 181602 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181607 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 181620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 181627 */     // (AMDGPUst_glue v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 181627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 181630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181635 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181649 */     GIR_RootConstrainSelectedInstOperands,
     /* 181650 */     // GIR_Coverage, 8070,
     /* 181650 */     GIR_EraseRootFromParent_Done,
     /* 181651 */   // Label 2782: @181651
     /* 181651 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(181712), // Rule ID 8074 //
     /* 181656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 181659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 181663 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181668 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 181681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 181688 */     // (AMDGPUst_glue v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 181688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 181691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181696 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181710 */     GIR_RootConstrainSelectedInstOperands,
     /* 181711 */     // GIR_Coverage, 8074,
     /* 181711 */     GIR_EraseRootFromParent_Done,
     /* 181712 */   // Label 2783: @181712
     /* 181712 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(181768), // Rule ID 8002 //
     /* 181717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 181720 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 181724 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181729 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 181733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 181744 */     // (AMDGPUst_glue v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 181744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 181747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181752 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181766 */     GIR_RootConstrainSelectedInstOperands,
     /* 181767 */     // GIR_Coverage, 8002,
     /* 181767 */     GIR_EraseRootFromParent_Done,
     /* 181768 */   // Label 2784: @181768
     /* 181768 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(181824), // Rule ID 8006 //
     /* 181773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 181776 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 181780 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181785 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 181789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 181800 */     // (AMDGPUst_glue v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 181800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 181803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181808 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181822 */     GIR_RootConstrainSelectedInstOperands,
     /* 181823 */     // GIR_Coverage, 8006,
     /* 181823 */     GIR_EraseRootFromParent_Done,
     /* 181824 */   // Label 2785: @181824
     /* 181824 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(181881), // Rule ID 8071 //
     /* 181829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 181832 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181837 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 181850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 181857 */     // (st v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 181857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 181860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181865 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181879 */     GIR_RootConstrainSelectedInstOperands,
     /* 181880 */     // GIR_Coverage, 8071,
     /* 181880 */     GIR_EraseRootFromParent_Done,
     /* 181881 */   // Label 2786: @181881
     /* 181881 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(181938), // Rule ID 8075 //
     /* 181886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 181889 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181894 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 181907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 181914 */     // (st v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 181914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 181917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181922 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181936 */     GIR_RootConstrainSelectedInstOperands,
     /* 181937 */     // GIR_Coverage, 8075,
     /* 181937 */     GIR_EraseRootFromParent_Done,
     /* 181938 */   // Label 2787: @181938
     /* 181938 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(181990), // Rule ID 8003 //
     /* 181943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 181946 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181951 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 181955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 181966 */     // (st v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 181966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 181969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181974 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 181981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181988 */     GIR_RootConstrainSelectedInstOperands,
     /* 181989 */     // GIR_Coverage, 8003,
     /* 181989 */     GIR_EraseRootFromParent_Done,
     /* 181990 */   // Label 2788: @181990
     /* 181990 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(182042), // Rule ID 8007 //
     /* 181995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 181998 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182003 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 182007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182018 */     // (st v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 182021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182026 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182040 */     GIR_RootConstrainSelectedInstOperands,
     /* 182041 */     // GIR_Coverage, 8007,
     /* 182041 */     GIR_EraseRootFromParent_Done,
     /* 182042 */   // Label 2789: @182042
     /* 182042 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(182095), // Rule ID 4320 //
     /* 182047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 182050 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 182066 */     // (st v4f16:{ *:[v4f16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9819:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 182066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 182069 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 182081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 182086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182093 */     GIR_RootConstrainSelectedInstOperands,
     /* 182094 */     // GIR_Coverage, 4320,
     /* 182094 */     GIR_EraseRootFromParent_Done,
     /* 182095 */   // Label 2790: @182095
     /* 182095 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(182148), // Rule ID 4326 //
     /* 182100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 182103 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 182119 */     // (st v4i16:{ *:[v4i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9819:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 182119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 182122 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 182134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 182139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182146 */     GIR_RootConstrainSelectedInstOperands,
     /* 182147 */     // GIR_Coverage, 4326,
     /* 182147 */     GIR_EraseRootFromParent_Done,
     /* 182148 */   // Label 2791: @182148
     /* 182148 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(182196), // Rule ID 4319 //
     /* 182153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 182156 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 182172 */     // (st v4f16:{ *:[v4f16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9819:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 182172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 182175 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 182182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182194 */     GIR_RootConstrainSelectedInstOperands,
     /* 182195 */     // GIR_Coverage, 4319,
     /* 182195 */     GIR_EraseRootFromParent_Done,
     /* 182196 */   // Label 2792: @182196
     /* 182196 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(182244), // Rule ID 4325 //
     /* 182201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 182204 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 182220 */     // (st v4i16:{ *:[v4i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9819:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 182220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 182223 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 182230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182242 */     GIR_RootConstrainSelectedInstOperands,
     /* 182243 */     // GIR_Coverage, 4325,
     /* 182243 */     GIR_EraseRootFromParent_Done,
     /* 182244 */   // Label 2793: @182244
     /* 182244 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(182292), // Rule ID 4318 //
     /* 182249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 182252 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 182268 */     // (st v4f16:{ *:[v4f16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9819:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 182268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 182271 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182290 */     GIR_RootConstrainSelectedInstOperands,
     /* 182291 */     // GIR_Coverage, 4318,
     /* 182291 */     GIR_EraseRootFromParent_Done,
     /* 182292 */   // Label 2794: @182292
     /* 182292 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(182340), // Rule ID 4324 //
     /* 182297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 182300 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 182316 */     // (st v4i16:{ *:[v4i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9819:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 182316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 182319 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182338 */     GIR_RootConstrainSelectedInstOperands,
     /* 182339 */     // GIR_Coverage, 4324,
     /* 182339 */     GIR_EraseRootFromParent_Done,
     /* 182340 */   // Label 2795: @182340
     /* 182340 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(182401), // Rule ID 4649 //
     /* 182345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 182348 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 182364 */     // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v4f16:{ *:[v4f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 182364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 182367 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 182369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 182374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 182379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 182384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 182389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182399 */     GIR_RootConstrainSelectedInstOperands,
     /* 182400 */     // GIR_Coverage, 4649,
     /* 182400 */     GIR_EraseRootFromParent_Done,
     /* 182401 */   // Label 2796: @182401
     /* 182401 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(182459), // Rule ID 4651 //
     /* 182406 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 182422 */     // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v4f16:{ *:[v4f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 182422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 182425 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 182427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 182432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 182437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 182442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 182447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182457 */     GIR_RootConstrainSelectedInstOperands,
     /* 182458 */     // GIR_Coverage, 4651,
     /* 182458 */     GIR_EraseRootFromParent_Done,
     /* 182459 */   // Label 2797: @182459
     /* 182459 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(182520), // Rule ID 4653 //
     /* 182464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 182467 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 182483 */     // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v4i16:{ *:[v4i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 182483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 182486 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 182488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 182493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 182498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 182503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 182508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182518 */     GIR_RootConstrainSelectedInstOperands,
     /* 182519 */     // GIR_Coverage, 4653,
     /* 182519 */     GIR_EraseRootFromParent_Done,
     /* 182520 */   // Label 2798: @182520
     /* 182520 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(182578), // Rule ID 4655 //
     /* 182525 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 182541 */     // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v4i16:{ *:[v4i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 182541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 182544 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 182546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 182551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 182556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 182561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 182566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182576 */     GIR_RootConstrainSelectedInstOperands,
     /* 182577 */     // GIR_Coverage, 4655,
     /* 182577 */     GIR_EraseRootFromParent_Done,
     /* 182578 */   // Label 2799: @182578
     /* 182578 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(182695), // Rule ID 7945 //
     /* 182583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 182586 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 182590 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 182606 */     // (AMDGPUst_glue v4f16:{ *:[v4f16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 182606 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 182609 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182613 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182618 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 182624 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 182629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 182634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182646 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 182652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 182657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 182662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 182665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 182681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 182686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182693 */     GIR_RootConstrainSelectedInstOperands,
     /* 182694 */     // GIR_Coverage, 7945,
     /* 182694 */     GIR_EraseRootFromParent_Done,
     /* 182695 */   // Label 2800: @182695
     /* 182695 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(182812), // Rule ID 7949 //
     /* 182700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 182703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 182707 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 182723 */     // (AMDGPUst_glue v4i16:{ *:[v4i16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 182723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 182726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182735 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 182741 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 182746 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 182751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182763 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 182769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 182774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 182779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 182782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 182798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 182803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182810 */     GIR_RootConstrainSelectedInstOperands,
     /* 182811 */     // GIR_Coverage, 7949,
     /* 182811 */     GIR_EraseRootFromParent_Done,
     /* 182812 */   // Label 2801: @182812
     /* 182812 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(182868), // Rule ID 4648 //
     /* 182817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 182820 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 182836 */     // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 182836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 182839 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 182841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 182846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 182851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 182856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182866 */     GIR_RootConstrainSelectedInstOperands,
     /* 182867 */     // GIR_Coverage, 4648,
     /* 182867 */     GIR_EraseRootFromParent_Done,
     /* 182868 */   // Label 2802: @182868
     /* 182868 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(182921), // Rule ID 4650 //
     /* 182873 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 182889 */     // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 182889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 182892 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 182894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 182899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 182904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 182909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182919 */     GIR_RootConstrainSelectedInstOperands,
     /* 182920 */     // GIR_Coverage, 4650,
     /* 182920 */     GIR_EraseRootFromParent_Done,
     /* 182921 */   // Label 2803: @182921
     /* 182921 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(182977), // Rule ID 4652 //
     /* 182926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 182929 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 182945 */     // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 182945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 182948 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 182950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 182955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 182960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 182965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182975 */     GIR_RootConstrainSelectedInstOperands,
     /* 182976 */     // GIR_Coverage, 4652,
     /* 182976 */     GIR_EraseRootFromParent_Done,
     /* 182977 */   // Label 2804: @182977
     /* 182977 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(183030), // Rule ID 4654 //
     /* 182982 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 182998 */     // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 182998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 183001 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 183003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 183008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 183013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183028 */     GIR_RootConstrainSelectedInstOperands,
     /* 183029 */     // GIR_Coverage, 4654,
     /* 183029 */     GIR_EraseRootFromParent_Done,
     /* 183030 */   // Label 2805: @183030
     /* 183030 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(183143), // Rule ID 7947 //
     /* 183035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 183038 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 183054 */     // (st v4f16:{ *:[v4f16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 183054 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 183057 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183061 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183066 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 183072 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 183077 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 183085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183094 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 183100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 183105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 183113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 183129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 183134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183141 */     GIR_RootConstrainSelectedInstOperands,
     /* 183142 */     // GIR_Coverage, 7947,
     /* 183142 */     GIR_EraseRootFromParent_Done,
     /* 183143 */   // Label 2806: @183143
     /* 183143 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(183256), // Rule ID 7951 //
     /* 183148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 183151 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 183167 */     // (st v4i16:{ *:[v4i16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 183167 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 183170 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183174 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183179 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 183185 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 183190 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 183198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183207 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 183213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 183218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 183226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 183242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 183247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183254 */     GIR_RootConstrainSelectedInstOperands,
     /* 183255 */     // GIR_Coverage, 7951,
     /* 183255 */     GIR_EraseRootFromParent_Done,
     /* 183256 */   // Label 2807: @183256
     /* 183256 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(183309), // Rule ID 3910 //
     /* 183261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 183264 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 183280 */     // (st v4f16:{ *:[v4f16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[v4f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 183280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 183283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 183288 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 183295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183307 */     GIR_RootConstrainSelectedInstOperands,
     /* 183308 */     // GIR_Coverage, 3910,
     /* 183308 */     GIR_EraseRootFromParent_Done,
     /* 183309 */   // Label 2808: @183309
     /* 183309 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(183362), // Rule ID 3914 //
     /* 183314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 183317 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 183333 */     // (st v4i16:{ *:[v4i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[v4i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 183333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 183336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 183341 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 183348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183360 */     GIR_RootConstrainSelectedInstOperands,
     /* 183361 */     // GIR_Coverage, 3914,
     /* 183361 */     GIR_EraseRootFromParent_Done,
     /* 183362 */   // Label 2809: @183362
     /* 183362 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(183410), // Rule ID 3909 //
     /* 183367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 183370 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 183386 */     // (st v4f16:{ *:[v4f16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 183386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 183389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 183394 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183408 */     GIR_RootConstrainSelectedInstOperands,
     /* 183409 */     // GIR_Coverage, 3909,
     /* 183409 */     GIR_EraseRootFromParent_Done,
     /* 183410 */   // Label 2810: @183410
     /* 183410 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(183458), // Rule ID 3913 //
     /* 183415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 183418 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 183434 */     // (st v4i16:{ *:[v4i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 183434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 183437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 183442 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183456 */     GIR_RootConstrainSelectedInstOperands,
     /* 183457 */     // GIR_Coverage, 3913,
     /* 183457 */     GIR_EraseRootFromParent_Done,
     /* 183458 */   // Label 2811: @183458
     /* 183458 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(183507), // Rule ID 3636 //
     /* 183463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 183466 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 183472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 183483 */     // (st v4f16:{ *:[v4f16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 183483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 183486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 183491 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183505 */     GIR_RootConstrainSelectedInstOperands,
     /* 183506 */     // GIR_Coverage, 3636,
     /* 183506 */     GIR_EraseRootFromParent_Done,
     /* 183507 */   // Label 2812: @183507
     /* 183507 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(183556), // Rule ID 3638 //
     /* 183512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 183515 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 183521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 183532 */     // (st v4i16:{ *:[v4i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 183532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 183535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 183540 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183554 */     GIR_RootConstrainSelectedInstOperands,
     /* 183555 */     // GIR_Coverage, 3638,
     /* 183555 */     GIR_EraseRootFromParent_Done,
     /* 183556 */   // Label 2813: @183556
     /* 183556 */   GIM_Reject,
     /* 183557 */ // Label 2781: @183557
     /* 183557 */ GIM_Reject,
     /* 183558 */ // Label 2315: @183558
     /* 183558 */ GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(185767),
     /* 183563 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183566 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(183622), // Rule ID 8030 //
     /* 183571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 183574 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 183578 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183583 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 183587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 183598 */     // (AMDGPUst_glue v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 183598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 183601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183606 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 183608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183620 */     GIR_RootConstrainSelectedInstOperands,
     /* 183621 */     // GIR_Coverage, 8030,
     /* 183621 */     GIR_EraseRootFromParent_Done,
     /* 183622 */   // Label 2815: @183622
     /* 183622 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(183678), // Rule ID 8034 //
     /* 183627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 183630 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 183634 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183639 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 183643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 183654 */     // (AMDGPUst_glue v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 183654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 183657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183662 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 183664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183676 */     GIR_RootConstrainSelectedInstOperands,
     /* 183677 */     // GIR_Coverage, 8034,
     /* 183677 */     GIR_EraseRootFromParent_Done,
     /* 183678 */   // Label 2816: @183678
     /* 183678 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(183739), // Rule ID 8098 //
     /* 183683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 183686 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 183690 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183695 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 183708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 183715 */     // (AMDGPUst_glue v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 183715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 183718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183723 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 183725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183737 */     GIR_RootConstrainSelectedInstOperands,
     /* 183738 */     // GIR_Coverage, 8098,
     /* 183738 */     GIR_EraseRootFromParent_Done,
     /* 183739 */   // Label 2817: @183739
     /* 183739 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(183800), // Rule ID 8102 //
     /* 183744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 183747 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 183751 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183756 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 183769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 183776 */     // (AMDGPUst_glue v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 183776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 183779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183784 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 183786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183798 */     GIR_RootConstrainSelectedInstOperands,
     /* 183799 */     // GIR_Coverage, 8102,
     /* 183799 */     GIR_EraseRootFromParent_Done,
     /* 183800 */   // Label 2818: @183800
     /* 183800 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(183852), // Rule ID 8031 //
     /* 183805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 183808 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183813 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 183817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 183828 */     // (st v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 183828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 183831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183836 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 183838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183850 */     GIR_RootConstrainSelectedInstOperands,
     /* 183851 */     // GIR_Coverage, 8031,
     /* 183851 */     GIR_EraseRootFromParent_Done,
     /* 183852 */   // Label 2819: @183852
     /* 183852 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(183904), // Rule ID 8035 //
     /* 183857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 183860 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183865 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 183869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 183880 */     // (st v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 183880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 183883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183888 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 183890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183902 */     GIR_RootConstrainSelectedInstOperands,
     /* 183903 */     // GIR_Coverage, 8035,
     /* 183903 */     GIR_EraseRootFromParent_Done,
     /* 183904 */   // Label 2820: @183904
     /* 183904 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(183961), // Rule ID 8099 //
     /* 183909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 183912 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183917 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183926 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 183930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 183937 */     // (st v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 183937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 183940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183945 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 183947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 183952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183959 */     GIR_RootConstrainSelectedInstOperands,
     /* 183960 */     // GIR_Coverage, 8099,
     /* 183960 */     GIR_EraseRootFromParent_Done,
     /* 183961 */   // Label 2821: @183961
     /* 183961 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(184018), // Rule ID 8103 //
     /* 183966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 183969 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183974 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183983 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 183987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 183994 */     // (st v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 183994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 183997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184002 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184016 */     GIR_RootConstrainSelectedInstOperands,
     /* 184017 */     // GIR_Coverage, 8103,
     /* 184017 */     GIR_EraseRootFromParent_Done,
     /* 184018 */   // Label 2822: @184018
     /* 184018 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(184074), // Rule ID 6641 //
     /* 184023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 184026 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 184042 */     // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_OFFSET VReg_128:{ *:[v4i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 184042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 184045 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 184057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 184062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184072 */     GIR_RootConstrainSelectedInstOperands,
     /* 184073 */     // GIR_Coverage, 6641,
     /* 184073 */     GIR_EraseRootFromParent_Done,
     /* 184074 */   // Label 2823: @184074
     /* 184074 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(184130), // Rule ID 6643 //
     /* 184079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 184082 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 184098 */     // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET VReg_128:{ *:[v4i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 184098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 184101 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 184113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 184118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184128 */     GIR_RootConstrainSelectedInstOperands,
     /* 184129 */     // GIR_Coverage, 6643,
     /* 184129 */     GIR_EraseRootFromParent_Done,
     /* 184130 */   // Label 2824: @184130
     /* 184130 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(184183), // Rule ID 4353 //
     /* 184135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 184138 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 184154 */     // (st v4i32:{ *:[v4i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9817:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 184154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 184157 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 184169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 184174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184181 */     GIR_RootConstrainSelectedInstOperands,
     /* 184182 */     // GIR_Coverage, 4353,
     /* 184182 */     GIR_EraseRootFromParent_Done,
     /* 184183 */   // Label 2825: @184183
     /* 184183 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(184236), // Rule ID 4359 //
     /* 184188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 184191 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 184207 */     // (st v4f32:{ *:[v4f32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9817:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 184207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 184210 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 184222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 184227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184234 */     GIR_RootConstrainSelectedInstOperands,
     /* 184235 */     // GIR_Coverage, 4359,
     /* 184235 */     GIR_EraseRootFromParent_Done,
     /* 184236 */   // Label 2826: @184236
     /* 184236 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(184284), // Rule ID 4352 //
     /* 184241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 184244 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 184260 */     // (st v4i32:{ *:[v4i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9817:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 184260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 184263 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 184270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184282 */     GIR_RootConstrainSelectedInstOperands,
     /* 184283 */     // GIR_Coverage, 4352,
     /* 184283 */     GIR_EraseRootFromParent_Done,
     /* 184284 */   // Label 2827: @184284
     /* 184284 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(184332), // Rule ID 4358 //
     /* 184289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 184292 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 184308 */     // (st v4f32:{ *:[v4f32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9817:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 184308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 184311 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 184318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184330 */     GIR_RootConstrainSelectedInstOperands,
     /* 184331 */     // GIR_Coverage, 4358,
     /* 184331 */     GIR_EraseRootFromParent_Done,
     /* 184332 */   // Label 2828: @184332
     /* 184332 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(184380), // Rule ID 4351 //
     /* 184337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 184340 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 184356 */     // (st v4i32:{ *:[v4i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9817:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 184356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 184359 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184378 */     GIR_RootConstrainSelectedInstOperands,
     /* 184379 */     // GIR_Coverage, 4351,
     /* 184379 */     GIR_EraseRootFromParent_Done,
     /* 184380 */   // Label 2829: @184380
     /* 184380 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(184428), // Rule ID 4357 //
     /* 184385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 184388 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 184404 */     // (st v4f32:{ *:[v4f32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9817:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 184404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 184407 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184426 */     GIR_RootConstrainSelectedInstOperands,
     /* 184427 */     // GIR_Coverage, 4357,
     /* 184427 */     GIR_EraseRootFromParent_Done,
     /* 184428 */   // Label 2830: @184428
     /* 184428 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(184489), // Rule ID 4677 //
     /* 184433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 184436 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 184441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 184452 */     // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v4i32:{ *:[v4i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 184452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 184455 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 184457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 184472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 184477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184487 */     GIR_RootConstrainSelectedInstOperands,
     /* 184488 */     // GIR_Coverage, 4677,
     /* 184488 */     GIR_EraseRootFromParent_Done,
     /* 184489 */   // Label 2831: @184489
     /* 184489 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(184547), // Rule ID 4679 //
     /* 184494 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 184499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 184510 */     // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v4i32:{ *:[v4i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 184510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 184513 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 184515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 184530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 184535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184545 */     GIR_RootConstrainSelectedInstOperands,
     /* 184546 */     // GIR_Coverage, 4679,
     /* 184546 */     GIR_EraseRootFromParent_Done,
     /* 184547 */   // Label 2832: @184547
     /* 184547 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(184608), // Rule ID 4681 //
     /* 184552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 184555 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 184560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 184571 */     // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v4f32:{ *:[v4f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 184571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 184574 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 184576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 184591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 184596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184606 */     GIR_RootConstrainSelectedInstOperands,
     /* 184607 */     // GIR_Coverage, 4681,
     /* 184607 */     GIR_EraseRootFromParent_Done,
     /* 184608 */   // Label 2833: @184608
     /* 184608 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(184666), // Rule ID 4683 //
     /* 184613 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 184618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 184629 */     // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v4f32:{ *:[v4f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 184629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 184632 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 184634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 184649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 184654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184664 */     GIR_RootConstrainSelectedInstOperands,
     /* 184665 */     // GIR_Coverage, 4683,
     /* 184665 */     GIR_EraseRootFromParent_Done,
     /* 184666 */   // Label 2834: @184666
     /* 184666 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(184727), // Rule ID 6640 //
     /* 184671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 184674 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 184690 */     // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_OFFEN VReg_128:{ *:[v4i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 184690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN),
     /* 184693 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 184710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 184715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184725 */     GIR_RootConstrainSelectedInstOperands,
     /* 184726 */     // GIR_Coverage, 6640,
     /* 184726 */     GIR_EraseRootFromParent_Done,
     /* 184727 */   // Label 2835: @184727
     /* 184727 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(184788), // Rule ID 6642 //
     /* 184732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 184735 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 184751 */     // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN VReg_128:{ *:[v4i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 184751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN),
     /* 184754 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 184771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 184776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184786 */     GIR_RootConstrainSelectedInstOperands,
     /* 184787 */     // GIR_Coverage, 6642,
     /* 184787 */     GIR_EraseRootFromParent_Done,
     /* 184788 */   // Label 2836: @184788
     /* 184788 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(184905), // Rule ID 7929 //
     /* 184793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 184796 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 184800 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 184816 */     // (AMDGPUst_glue v4i32:{ *:[v4i32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 184816 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 184819 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 184823 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184828 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 184834 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 184839 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 184844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 184847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 184851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184856 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 184862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 184867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 184872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 184875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 184883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 184886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 184891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 184896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184903 */     GIR_RootConstrainSelectedInstOperands,
     /* 184904 */     // GIR_Coverage, 7929,
     /* 184904 */     GIR_EraseRootFromParent_Done,
     /* 184905 */   // Label 2837: @184905
     /* 184905 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(185022), // Rule ID 7965 //
     /* 184910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 184913 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 184917 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 184933 */     // (AMDGPUst_glue v4f32:{ *:[v4f32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 184933 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 184936 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 184940 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184945 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 184951 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 184956 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 184961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 184964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 184968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184973 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 184979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 184984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 184989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 184992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 185000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 185003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 185008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 185013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185020 */     GIR_RootConstrainSelectedInstOperands,
     /* 185021 */     // GIR_Coverage, 7965,
     /* 185021 */     GIR_EraseRootFromParent_Done,
     /* 185022 */   // Label 2838: @185022
     /* 185022 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(185078), // Rule ID 4676 //
     /* 185027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 185030 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 185046 */     // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 185046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 185049 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 185061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185076 */     GIR_RootConstrainSelectedInstOperands,
     /* 185077 */     // GIR_Coverage, 4676,
     /* 185077 */     GIR_EraseRootFromParent_Done,
     /* 185078 */   // Label 2839: @185078
     /* 185078 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(185131), // Rule ID 4678 //
     /* 185083 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 185099 */     // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 185099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 185102 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 185114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185129 */     GIR_RootConstrainSelectedInstOperands,
     /* 185130 */     // GIR_Coverage, 4678,
     /* 185130 */     GIR_EraseRootFromParent_Done,
     /* 185131 */   // Label 2840: @185131
     /* 185131 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(185187), // Rule ID 4680 //
     /* 185136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 185139 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 185155 */     // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 185155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 185158 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 185170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185185 */     GIR_RootConstrainSelectedInstOperands,
     /* 185186 */     // GIR_Coverage, 4680,
     /* 185186 */     GIR_EraseRootFromParent_Done,
     /* 185187 */   // Label 2841: @185187
     /* 185187 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(185240), // Rule ID 4682 //
     /* 185192 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 185208 */     // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 185208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 185211 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 185223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185238 */     GIR_RootConstrainSelectedInstOperands,
     /* 185239 */     // GIR_Coverage, 4682,
     /* 185239 */     GIR_EraseRootFromParent_Done,
     /* 185240 */   // Label 2842: @185240
     /* 185240 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(185353), // Rule ID 7931 //
     /* 185245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 185248 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 185264 */     // (st v4i32:{ *:[v4i32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 185264 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 185267 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 185271 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185276 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 185282 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 185287 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 185292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 185295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 185299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185304 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 185310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 185315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 185320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 185323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 185331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 185334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 185339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 185344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185351 */     GIR_RootConstrainSelectedInstOperands,
     /* 185352 */     // GIR_Coverage, 7931,
     /* 185352 */     GIR_EraseRootFromParent_Done,
     /* 185353 */   // Label 2843: @185353
     /* 185353 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(185466), // Rule ID 7967 //
     /* 185358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 185361 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 185377 */     // (st v4f32:{ *:[v4f32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 185377 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 185380 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 185384 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185389 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 185395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 185400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 185405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 185408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 185412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185417 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 185423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 185428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 185433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 185436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 185444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 185447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 185452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 185457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185464 */     GIR_RootConstrainSelectedInstOperands,
     /* 185465 */     // GIR_Coverage, 7967,
     /* 185465 */     GIR_EraseRootFromParent_Done,
     /* 185466 */   // Label 2844: @185466
     /* 185466 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(185519), // Rule ID 3932 //
     /* 185471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 185474 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 185490 */     // (st v4i32:{ *:[v4i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9817:{ *:[v4i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 185490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 185493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 185498 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 185505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185517 */     GIR_RootConstrainSelectedInstOperands,
     /* 185518 */     // GIR_Coverage, 3932,
     /* 185518 */     GIR_EraseRootFromParent_Done,
     /* 185519 */   // Label 2845: @185519
     /* 185519 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(185572), // Rule ID 3936 //
     /* 185524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 185527 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 185543 */     // (st v4f32:{ *:[v4f32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9817:{ *:[v4f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 185543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 185546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 185551 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 185558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185570 */     GIR_RootConstrainSelectedInstOperands,
     /* 185571 */     // GIR_Coverage, 3936,
     /* 185571 */     GIR_EraseRootFromParent_Done,
     /* 185572 */   // Label 2846: @185572
     /* 185572 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(185620), // Rule ID 3931 //
     /* 185577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 185580 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 185596 */     // (st v4i32:{ *:[v4i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 185596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 185599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 185604 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185618 */     GIR_RootConstrainSelectedInstOperands,
     /* 185619 */     // GIR_Coverage, 3931,
     /* 185619 */     GIR_EraseRootFromParent_Done,
     /* 185620 */   // Label 2847: @185620
     /* 185620 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(185668), // Rule ID 3935 //
     /* 185625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 185628 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 185644 */     // (st v4f32:{ *:[v4f32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 185644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 185647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 185652 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185666 */     GIR_RootConstrainSelectedInstOperands,
     /* 185667 */     // GIR_Coverage, 3935,
     /* 185667 */     GIR_EraseRootFromParent_Done,
     /* 185668 */   // Label 2848: @185668
     /* 185668 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(185717), // Rule ID 3648 //
     /* 185673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 185676 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 185682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 185693 */     // (st v4i32:{ *:[v4i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 185693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 185696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 185701 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185715 */     GIR_RootConstrainSelectedInstOperands,
     /* 185716 */     // GIR_Coverage, 3648,
     /* 185716 */     GIR_EraseRootFromParent_Done,
     /* 185717 */   // Label 2849: @185717
     /* 185717 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(185766), // Rule ID 3650 //
     /* 185722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 185725 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 185731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 185742 */     // (st v4f32:{ *:[v4f32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 185742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 185745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 185750 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185764 */     GIR_RootConstrainSelectedInstOperands,
     /* 185765 */     // GIR_Coverage, 3650,
     /* 185765 */     GIR_EraseRootFromParent_Done,
     /* 185766 */   // Label 2850: @185766
     /* 185766 */   GIM_Reject,
     /* 185767 */ // Label 2814: @185767
     /* 185767 */ GIM_Reject,
     /* 185768 */ // Label 2316: @185768
     /* 185768 */ GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(187743),
     /* 185773 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185776 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(185832), // Rule ID 8046 //
     /* 185781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 185784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 185788 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185793 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 185797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 185808 */     // (AMDGPUst_glue v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 185808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 185811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185816 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 185818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185830 */     GIR_RootConstrainSelectedInstOperands,
     /* 185831 */     // GIR_Coverage, 8046,
     /* 185831 */     GIR_EraseRootFromParent_Done,
     /* 185832 */   // Label 2852: @185832
     /* 185832 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(185888), // Rule ID 8050 //
     /* 185837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 185840 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 185844 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185849 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 185853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 185864 */     // (AMDGPUst_glue v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 185864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 185867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185872 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 185874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185886 */     GIR_RootConstrainSelectedInstOperands,
     /* 185887 */     // GIR_Coverage, 8050,
     /* 185887 */     GIR_EraseRootFromParent_Done,
     /* 185888 */   // Label 2853: @185888
     /* 185888 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(185949), // Rule ID 8114 //
     /* 185893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 185896 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 185900 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185905 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 185918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 185925 */     // (AMDGPUst_glue v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 185925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 185928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185933 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 185935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185947 */     GIR_RootConstrainSelectedInstOperands,
     /* 185948 */     // GIR_Coverage, 8114,
     /* 185948 */     GIR_EraseRootFromParent_Done,
     /* 185949 */   // Label 2854: @185949
     /* 185949 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(186010), // Rule ID 8118 //
     /* 185954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 185957 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 185961 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185966 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 185979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 185986 */     // (AMDGPUst_glue v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 185986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 185989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185994 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 185996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186008 */     GIR_RootConstrainSelectedInstOperands,
     /* 186009 */     // GIR_Coverage, 8118,
     /* 186009 */     GIR_EraseRootFromParent_Done,
     /* 186010 */   // Label 2855: @186010
     /* 186010 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(186062), // Rule ID 8047 //
     /* 186015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 186018 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186023 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 186027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 186038 */     // (st v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 186038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 186041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186046 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 186048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186060 */     GIR_RootConstrainSelectedInstOperands,
     /* 186061 */     // GIR_Coverage, 8047,
     /* 186061 */     GIR_EraseRootFromParent_Done,
     /* 186062 */   // Label 2856: @186062
     /* 186062 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(186114), // Rule ID 8051 //
     /* 186067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 186070 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186075 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 186079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 186090 */     // (st v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 186090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 186093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186098 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 186100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186112 */     GIR_RootConstrainSelectedInstOperands,
     /* 186113 */     // GIR_Coverage, 8051,
     /* 186113 */     GIR_EraseRootFromParent_Done,
     /* 186114 */   // Label 2857: @186114
     /* 186114 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(186171), // Rule ID 8115 //
     /* 186119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 186122 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186127 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186136 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 186140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 186147 */     // (st v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 186147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 186150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186155 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 186157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186169 */     GIR_RootConstrainSelectedInstOperands,
     /* 186170 */     // GIR_Coverage, 8115,
     /* 186170 */     GIR_EraseRootFromParent_Done,
     /* 186171 */   // Label 2858: @186171
     /* 186171 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(186228), // Rule ID 8119 //
     /* 186176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 186179 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186184 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 186197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 186204 */     // (st v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9817:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 186204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 186207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186212 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 186214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186226 */     GIR_RootConstrainSelectedInstOperands,
     /* 186227 */     // GIR_Coverage, 8119,
     /* 186227 */     GIR_EraseRootFromParent_Done,
     /* 186228 */   // Label 2859: @186228
     /* 186228 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(186281), // Rule ID 4377 //
     /* 186233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 186236 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 186252 */     // (st v8i16:{ *:[v8i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9817:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 186252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 186255 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 186262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 186267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 186272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186279 */     GIR_RootConstrainSelectedInstOperands,
     /* 186280 */     // GIR_Coverage, 4377,
     /* 186280 */     GIR_EraseRootFromParent_Done,
     /* 186281 */   // Label 2860: @186281
     /* 186281 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(186334), // Rule ID 4383 //
     /* 186286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 186289 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 186305 */     // (st v8f16:{ *:[v8f16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9817:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 186305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 186308 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 186315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 186320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 186325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186332 */     GIR_RootConstrainSelectedInstOperands,
     /* 186333 */     // GIR_Coverage, 4383,
     /* 186333 */     GIR_EraseRootFromParent_Done,
     /* 186334 */   // Label 2861: @186334
     /* 186334 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(186382), // Rule ID 4376 //
     /* 186339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 186342 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 186358 */     // (st v8i16:{ *:[v8i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9817:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 186358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 186361 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 186368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186380 */     GIR_RootConstrainSelectedInstOperands,
     /* 186381 */     // GIR_Coverage, 4376,
     /* 186381 */     GIR_EraseRootFromParent_Done,
     /* 186382 */   // Label 2862: @186382
     /* 186382 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(186430), // Rule ID 4382 //
     /* 186387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 186390 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 186406 */     // (st v8f16:{ *:[v8f16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9817:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 186406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 186409 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 186416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186428 */     GIR_RootConstrainSelectedInstOperands,
     /* 186429 */     // GIR_Coverage, 4382,
     /* 186429 */     GIR_EraseRootFromParent_Done,
     /* 186430 */   // Label 2863: @186430
     /* 186430 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(186478), // Rule ID 4375 //
     /* 186435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 186438 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 186454 */     // (st v8i16:{ *:[v8i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9817:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 186454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 186457 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 186464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186476 */     GIR_RootConstrainSelectedInstOperands,
     /* 186477 */     // GIR_Coverage, 4375,
     /* 186477 */     GIR_EraseRootFromParent_Done,
     /* 186478 */   // Label 2864: @186478
     /* 186478 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(186526), // Rule ID 4381 //
     /* 186483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 186486 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 186502 */     // (st v8f16:{ *:[v8f16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9817:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 186502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 186505 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 186512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186524 */     GIR_RootConstrainSelectedInstOperands,
     /* 186525 */     // GIR_Coverage, 4381,
     /* 186525 */     GIR_EraseRootFromParent_Done,
     /* 186526 */   // Label 2865: @186526
     /* 186526 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(186587), // Rule ID 4693 //
     /* 186531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 186534 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 186550 */     // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v8i16:{ *:[v8i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 186553 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 186560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 186570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 186575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186585 */     GIR_RootConstrainSelectedInstOperands,
     /* 186586 */     // GIR_Coverage, 4693,
     /* 186586 */     GIR_EraseRootFromParent_Done,
     /* 186587 */   // Label 2866: @186587
     /* 186587 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(186645), // Rule ID 4695 //
     /* 186592 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 186608 */     // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v8i16:{ *:[v8i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 186611 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 186618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 186628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 186633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186643 */     GIR_RootConstrainSelectedInstOperands,
     /* 186644 */     // GIR_Coverage, 4695,
     /* 186644 */     GIR_EraseRootFromParent_Done,
     /* 186645 */   // Label 2867: @186645
     /* 186645 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(186706), // Rule ID 4697 //
     /* 186650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 186653 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 186669 */     // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v8f16:{ *:[v8f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 186672 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 186679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 186689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 186694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186704 */     GIR_RootConstrainSelectedInstOperands,
     /* 186705 */     // GIR_Coverage, 4697,
     /* 186705 */     GIR_EraseRootFromParent_Done,
     /* 186706 */   // Label 2868: @186706
     /* 186706 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(186764), // Rule ID 4699 //
     /* 186711 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 186727 */     // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v8f16:{ *:[v8f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 186730 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 186737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 186747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 186752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186762 */     GIR_RootConstrainSelectedInstOperands,
     /* 186763 */     // GIR_Coverage, 4699,
     /* 186763 */     GIR_EraseRootFromParent_Done,
     /* 186764 */   // Label 2869: @186764
     /* 186764 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(186881), // Rule ID 7977 //
     /* 186769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 186772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 186776 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 186792 */     // (AMDGPUst_glue v8i16:{ *:[v8i16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 186792 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 186795 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186799 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186804 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 186810 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 186815 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 186820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 186823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186832 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 186838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 186843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 186848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 186851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 186859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 186862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 186867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 186872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186879 */     GIR_RootConstrainSelectedInstOperands,
     /* 186880 */     // GIR_Coverage, 7977,
     /* 186880 */     GIR_EraseRootFromParent_Done,
     /* 186881 */   // Label 2870: @186881
     /* 186881 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(186998), // Rule ID 7981 //
     /* 186886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 186889 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 186893 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 186909 */     // (AMDGPUst_glue v8f16:{ *:[v8f16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 186909 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 186912 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186916 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186921 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 186927 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 186932 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 186937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 186940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186949 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 186955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 186960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 186965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 186968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 186976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 186979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 186984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 186989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186996 */     GIR_RootConstrainSelectedInstOperands,
     /* 186997 */     // GIR_Coverage, 7981,
     /* 186997 */     GIR_EraseRootFromParent_Done,
     /* 186998 */   // Label 2871: @186998
     /* 186998 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(187054), // Rule ID 4692 //
     /* 187003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 187006 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 187022 */     // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 187022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 187025 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 187027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 187032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 187037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187052 */     GIR_RootConstrainSelectedInstOperands,
     /* 187053 */     // GIR_Coverage, 4692,
     /* 187053 */     GIR_EraseRootFromParent_Done,
     /* 187054 */   // Label 2872: @187054
     /* 187054 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(187107), // Rule ID 4694 //
     /* 187059 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 187075 */     // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 187075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 187078 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 187080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 187085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 187090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187105 */     GIR_RootConstrainSelectedInstOperands,
     /* 187106 */     // GIR_Coverage, 4694,
     /* 187106 */     GIR_EraseRootFromParent_Done,
     /* 187107 */   // Label 2873: @187107
     /* 187107 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(187163), // Rule ID 4696 //
     /* 187112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 187115 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 187131 */     // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 187131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 187134 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 187136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 187141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 187146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187161 */     GIR_RootConstrainSelectedInstOperands,
     /* 187162 */     // GIR_Coverage, 4696,
     /* 187162 */     GIR_EraseRootFromParent_Done,
     /* 187163 */   // Label 2874: @187163
     /* 187163 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(187216), // Rule ID 4698 //
     /* 187168 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 187184 */     // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 187184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 187187 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 187189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 187194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 187199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187214 */     GIR_RootConstrainSelectedInstOperands,
     /* 187215 */     // GIR_Coverage, 4698,
     /* 187215 */     GIR_EraseRootFromParent_Done,
     /* 187216 */   // Label 2875: @187216
     /* 187216 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(187329), // Rule ID 7979 //
     /* 187221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 187224 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 187240 */     // (st v8i16:{ *:[v8i16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 187240 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 187243 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187247 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187252 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 187258 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187263 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 187268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 187271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187280 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 187286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 187296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 187299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 187307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 187310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 187315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 187320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187327 */     GIR_RootConstrainSelectedInstOperands,
     /* 187328 */     // GIR_Coverage, 7979,
     /* 187328 */     GIR_EraseRootFromParent_Done,
     /* 187329 */   // Label 2876: @187329
     /* 187329 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(187442), // Rule ID 7983 //
     /* 187334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 187337 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 187353 */     // (st v8f16:{ *:[v8f16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 187353 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 187356 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187360 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187365 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 187371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 187381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 187384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187393 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 187399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 187409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 187412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 187420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 187423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 187428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 187433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187440 */     GIR_RootConstrainSelectedInstOperands,
     /* 187441 */     // GIR_Coverage, 7983,
     /* 187441 */     GIR_EraseRootFromParent_Done,
     /* 187442 */   // Label 2877: @187442
     /* 187442 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(187495), // Rule ID 3948 //
     /* 187447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 187450 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 187466 */     // (st v8i16:{ *:[v8i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9817:{ *:[v8i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 187466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 187469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 187474 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 187481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187493 */     GIR_RootConstrainSelectedInstOperands,
     /* 187494 */     // GIR_Coverage, 3948,
     /* 187494 */     GIR_EraseRootFromParent_Done,
     /* 187495 */   // Label 2878: @187495
     /* 187495 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(187548), // Rule ID 3952 //
     /* 187500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 187503 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 187519 */     // (st v8f16:{ *:[v8f16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9817:{ *:[v8f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 187519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 187522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 187527 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 187534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187546 */     GIR_RootConstrainSelectedInstOperands,
     /* 187547 */     // GIR_Coverage, 3952,
     /* 187547 */     GIR_EraseRootFromParent_Done,
     /* 187548 */   // Label 2879: @187548
     /* 187548 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(187596), // Rule ID 3947 //
     /* 187553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 187556 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 187572 */     // (st v8i16:{ *:[v8i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 187572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 187575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 187580 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187594 */     GIR_RootConstrainSelectedInstOperands,
     /* 187595 */     // GIR_Coverage, 3947,
     /* 187595 */     GIR_EraseRootFromParent_Done,
     /* 187596 */   // Label 2880: @187596
     /* 187596 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(187644), // Rule ID 3951 //
     /* 187601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 187604 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 187620 */     // (st v8f16:{ *:[v8f16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 187620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 187623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 187628 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187642 */     GIR_RootConstrainSelectedInstOperands,
     /* 187643 */     // GIR_Coverage, 3951,
     /* 187643 */     GIR_EraseRootFromParent_Done,
     /* 187644 */   // Label 2881: @187644
     /* 187644 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(187693), // Rule ID 3656 //
     /* 187649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 187652 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 187658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 187669 */     // (st v8i16:{ *:[v8i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 187669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 187672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 187677 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187691 */     GIR_RootConstrainSelectedInstOperands,
     /* 187692 */     // GIR_Coverage, 3656,
     /* 187692 */     GIR_EraseRootFromParent_Done,
     /* 187693 */   // Label 2882: @187693
     /* 187693 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(187742), // Rule ID 3658 //
     /* 187698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 187701 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 187707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 187718 */     // (st v8f16:{ *:[v8f16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 187718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 187721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 187726 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187740 */     GIR_RootConstrainSelectedInstOperands,
     /* 187741 */     // GIR_Coverage, 3658,
     /* 187741 */     GIR_EraseRootFromParent_Done,
     /* 187742 */   // Label 2883: @187742
     /* 187742 */   GIM_Reject,
     /* 187743 */ // Label 2851: @187743
     /* 187743 */ GIM_Reject,
     /* 187744 */ // Label 2317: @187744
     /* 187744 */ GIM_Reject,
     /* 187745 */ // Label 18: @187745
     /* 187745 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 2886*/ GIMT_Encode4(188870),
     /* 187756 */ /*GILLT_s32*//*Label 2884*/ GIMT_Encode4(187764),
     /* 187760 */ /*GILLT_s64*//*Label 2885*/ GIMT_Encode4(188317),
     /* 187764 */ // Label 2884: @187764
     /* 187764 */ GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(188316),
     /* 187769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187772 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187775 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(187827), // Rule ID 8130 //
     /* 187780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 187783 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187788 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 187790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 187801 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_noret_i32>>  =>  (DS_CMPST_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$cmp, anonymous_9820:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 187801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B32),
     /* 187804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187809 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 187811 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 187813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187825 */     GIR_RootConstrainSelectedInstOperands,
     /* 187826 */     // GIR_Coverage, 8130,
     /* 187826 */     GIR_EraseRootFromParent_Done,
     /* 187827 */   // Label 2888: @187827
     /* 187827 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(187879), // Rule ID 8132 //
     /* 187832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 187835 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187840 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 187842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 187853 */     // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i32>>  =>  (DS_CMPST_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$cmp, anonymous_9820:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 187853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B32_gfx9),
     /* 187856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187861 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 187863 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 187865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187877 */     GIR_RootConstrainSelectedInstOperands,
     /* 187878 */     // GIR_Coverage, 8132,
     /* 187878 */     GIR_EraseRootFromParent_Done,
     /* 187879 */   // Label 2889: @187879
     /* 187879 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(187931), // Rule ID 8134 //
     /* 187884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
     /* 187887 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 187892 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 187894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 187905 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i32>>  =>  (DS_CMPST_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$cmp, anonymous_9820:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 187905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B32),
     /* 187908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187913 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 187915 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 187917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 187925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187929 */     GIR_RootConstrainSelectedInstOperands,
     /* 187930 */     // GIR_Coverage, 8134,
     /* 187930 */     GIR_EraseRootFromParent_Done,
     /* 187931 */   // Label 2890: @187931
     /* 187931 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(187983), // Rule ID 8136 //
     /* 187936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 187939 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187944 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 187946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 187957 */     // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i32>>  =>  (DS_CMPSTORE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$swap, anonymous_9820:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 187957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B32_gfx9),
     /* 187960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187965 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 187967 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 187969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187981 */     GIR_RootConstrainSelectedInstOperands,
     /* 187982 */     // GIR_Coverage, 8136,
     /* 187982 */     GIR_EraseRootFromParent_Done,
     /* 187983 */   // Label 2891: @187983
     /* 187983 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(188035), // Rule ID 8138 //
     /* 187988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
     /* 187991 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 187996 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 187998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188009 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i32>>  =>  (DS_CMPSTORE_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$swap, anonymous_9820:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B32),
     /* 188012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188017 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188019 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188033 */     GIR_RootConstrainSelectedInstOperands,
     /* 188034 */     // GIR_Coverage, 8138,
     /* 188034 */     GIR_EraseRootFromParent_Done,
     /* 188035 */   // Label 2892: @188035
     /* 188035 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(188091), // Rule ID 8129 //
     /* 188040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188043 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 188052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188063 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_i32>>  =>  (DS_CMPST_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$cmp, anonymous_9820:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B32),
     /* 188066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188073 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188075 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188089 */     GIR_RootConstrainSelectedInstOperands,
     /* 188090 */     // GIR_Coverage, 8129,
     /* 188090 */     GIR_EraseRootFromParent_Done,
     /* 188091 */   // Label 2893: @188091
     /* 188091 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(188147), // Rule ID 8131 //
     /* 188096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188099 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 188108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188119 */     // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i32>>  =>  (DS_CMPST_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$cmp, anonymous_9820:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B32_gfx9),
     /* 188122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188129 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188131 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188145 */     GIR_RootConstrainSelectedInstOperands,
     /* 188146 */     // GIR_Coverage, 8131,
     /* 188146 */     GIR_EraseRootFromParent_Done,
     /* 188147 */   // Label 2894: @188147
     /* 188147 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(188203), // Rule ID 8133 //
     /* 188152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
     /* 188155 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 188160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 188164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188175 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i32>>  =>  (DS_CMPST_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$cmp, anonymous_9820:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B32),
     /* 188178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188185 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188187 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188201 */     GIR_RootConstrainSelectedInstOperands,
     /* 188202 */     // GIR_Coverage, 8133,
     /* 188202 */     GIR_EraseRootFromParent_Done,
     /* 188203 */   // Label 2895: @188203
     /* 188203 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(188259), // Rule ID 8135 //
     /* 188208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 188211 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 188220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188231 */     // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i32>>  =>  (DS_CMPSTORE_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$swap, anonymous_9820:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B32_gfx9),
     /* 188234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188241 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188243 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188257 */     GIR_RootConstrainSelectedInstOperands,
     /* 188258 */     // GIR_Coverage, 8135,
     /* 188258 */     GIR_EraseRootFromParent_Done,
     /* 188259 */   // Label 2896: @188259
     /* 188259 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(188315), // Rule ID 8137 //
     /* 188264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
     /* 188267 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 188272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 188276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188287 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i32>>  =>  (DS_CMPSTORE_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$swap, anonymous_9820:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B32),
     /* 188290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188297 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188299 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188313 */     GIR_RootConstrainSelectedInstOperands,
     /* 188314 */     // GIR_Coverage, 8137,
     /* 188314 */     GIR_EraseRootFromParent_Done,
     /* 188315 */   // Label 2897: @188315
     /* 188315 */   GIM_Reject,
     /* 188316 */ // Label 2887: @188316
     /* 188316 */ GIM_Reject,
     /* 188317 */ // Label 2885: @188317
     /* 188317 */ GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(188869),
     /* 188322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188325 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188328 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(188380), // Rule ID 8305 //
     /* 188333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188336 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188341 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188354 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_noret_i64>>  =>  (DS_CMPST_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$cmp, anonymous_9819:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B64),
     /* 188357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188362 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188364 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188378 */     GIR_RootConstrainSelectedInstOperands,
     /* 188379 */     // GIR_Coverage, 8305,
     /* 188379 */     GIR_EraseRootFromParent_Done,
     /* 188380 */   // Label 2899: @188380
     /* 188380 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(188432), // Rule ID 8307 //
     /* 188385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188388 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188393 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188406 */     // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i64>>  =>  (DS_CMPST_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$cmp, anonymous_9819:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B64_gfx9),
     /* 188409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188414 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188416 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188430 */     GIR_RootConstrainSelectedInstOperands,
     /* 188431 */     // GIR_Coverage, 8307,
     /* 188431 */     GIR_EraseRootFromParent_Done,
     /* 188432 */   // Label 2900: @188432
     /* 188432 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(188484), // Rule ID 8309 //
     /* 188437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
     /* 188440 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 188445 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188458 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i64>>  =>  (DS_CMPST_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$cmp, anonymous_9819:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B64),
     /* 188461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188466 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188468 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188482 */     GIR_RootConstrainSelectedInstOperands,
     /* 188483 */     // GIR_Coverage, 8309,
     /* 188483 */     GIR_EraseRootFromParent_Done,
     /* 188484 */   // Label 2901: @188484
     /* 188484 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(188536), // Rule ID 8311 //
     /* 188489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 188492 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188497 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188510 */     // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i64>>  =>  (DS_CMPSTORE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$swap, anonymous_9819:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B64_gfx9),
     /* 188513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188518 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188520 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188534 */     GIR_RootConstrainSelectedInstOperands,
     /* 188535 */     // GIR_Coverage, 8311,
     /* 188535 */     GIR_EraseRootFromParent_Done,
     /* 188536 */   // Label 2902: @188536
     /* 188536 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(188588), // Rule ID 8313 //
     /* 188541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
     /* 188544 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 188549 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188562 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i64>>  =>  (DS_CMPSTORE_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$swap, anonymous_9819:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B64),
     /* 188565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188570 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188572 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188586 */     GIR_RootConstrainSelectedInstOperands,
     /* 188587 */     // GIR_Coverage, 8313,
     /* 188587 */     GIR_EraseRootFromParent_Done,
     /* 188588 */   // Label 2903: @188588
     /* 188588 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(188644), // Rule ID 8304 //
     /* 188593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188596 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 188605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188616 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_i64>>  =>  (DS_CMPST_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$cmp, anonymous_9819:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B64),
     /* 188619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188626 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188628 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188642 */     GIR_RootConstrainSelectedInstOperands,
     /* 188643 */     // GIR_Coverage, 8304,
     /* 188643 */     GIR_EraseRootFromParent_Done,
     /* 188644 */   // Label 2904: @188644
     /* 188644 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(188700), // Rule ID 8306 //
     /* 188649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 188652 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 188661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188672 */     // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i64>>  =>  (DS_CMPST_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$cmp, anonymous_9819:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B64_gfx9),
     /* 188675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188682 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188684 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188698 */     GIR_RootConstrainSelectedInstOperands,
     /* 188699 */     // GIR_Coverage, 8306,
     /* 188699 */     GIR_EraseRootFromParent_Done,
     /* 188700 */   // Label 2905: @188700
     /* 188700 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(188756), // Rule ID 8308 //
     /* 188705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
     /* 188708 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 188713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 188717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188728 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i64>>  =>  (DS_CMPST_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$cmp, anonymous_9819:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B64),
     /* 188731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188738 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188740 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188754 */     GIR_RootConstrainSelectedInstOperands,
     /* 188755 */     // GIR_Coverage, 8308,
     /* 188755 */     GIR_EraseRootFromParent_Done,
     /* 188756 */   // Label 2906: @188756
     /* 188756 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(188812), // Rule ID 8310 //
     /* 188761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 188764 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 188773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188784 */     // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i64>>  =>  (DS_CMPSTORE_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$swap, anonymous_9819:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 188784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B64_gfx9),
     /* 188787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188794 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188796 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188810 */     GIR_RootConstrainSelectedInstOperands,
     /* 188811 */     // GIR_Coverage, 8310,
     /* 188811 */     GIR_EraseRootFromParent_Done,
     /* 188812 */   // Label 2907: @188812
     /* 188812 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(188868), // Rule ID 8312 //
     /* 188817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
     /* 188820 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 188825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 188829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 188840 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i64>>  =>  (DS_CMPSTORE_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$swap, anonymous_9819:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 188840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B64),
     /* 188843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 188845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188850 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 188852 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 188854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 188862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188866 */     GIR_RootConstrainSelectedInstOperands,
     /* 188867 */     // GIR_Coverage, 8312,
     /* 188867 */     GIR_EraseRootFromParent_Done,
     /* 188868 */   // Label 2908: @188868
     /* 188868 */   GIM_Reject,
     /* 188869 */ // Label 2898: @188869
     /* 188869 */ GIM_Reject,
     /* 188870 */ // Label 2886: @188870
     /* 188870 */ GIM_Reject,
     /* 188871 */ // Label 19: @188871
     /* 188871 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 2911*/ GIMT_Encode4(191082),
     /* 188882 */ /*GILLT_s32*//*Label 2909*/ GIMT_Encode4(188890),
     /* 188886 */ /*GILLT_s64*//*Label 2910*/ GIMT_Encode4(189986),
     /* 188890 */ // Label 2909: @188890
     /* 188890 */ GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(189985),
     /* 188895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188898 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(188960), // Rule ID 5577 //
     /* 188903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 188906 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 188913 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 188926 */     // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 188926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_ADDR64),
     /* 188929 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 188931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 188936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 188941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 188946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 188951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188958 */     GIR_RootConstrainSelectedInstOperands,
     /* 188959 */     // GIR_Coverage, 5577,
     /* 188959 */     GIR_EraseRootFromParent_Done,
     /* 188960 */   // Label 2913: @188960
     /* 188960 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(189019), // Rule ID 5581 //
     /* 188965 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 188972 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 188974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 188985 */     // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 188985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64),
     /* 188988 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 188990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 188995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 189005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 189010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189017 */     GIR_RootConstrainSelectedInstOperands,
     /* 189018 */     // GIR_Coverage, 5581,
     /* 189018 */     GIR_EraseRootFromParent_Done,
     /* 189019 */   // Label 2914: @189019
     /* 189019 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(189085), // Rule ID 5573 //
     /* 189024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 189027 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 189049 */     // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_ADDR64_RTN),
     /* 189052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 189054 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 189061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 189071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 189076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189083 */     GIR_RootConstrainSelectedInstOperands,
     /* 189084 */     // GIR_Coverage, 5573,
     /* 189084 */     GIR_EraseRootFromParent_Done,
     /* 189085 */   // Label 2915: @189085
     /* 189085 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(189148), // Rule ID 5579 //
     /* 189090 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 189112 */     // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64_RTN),
     /* 189115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 189117 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 189124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 189134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 189139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189146 */     GIR_RootConstrainSelectedInstOperands,
     /* 189147 */     // GIR_Coverage, 5579,
     /* 189147 */     GIR_EraseRootFromParent_Done,
     /* 189148 */   // Label 2916: @189148
     /* 189148 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(189205), // Rule ID 5576 //
     /* 189153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 189156 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189163 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 189165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 189176 */     // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET),
     /* 189179 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 189191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189203 */     GIR_RootConstrainSelectedInstOperands,
     /* 189204 */     // GIR_Coverage, 5576,
     /* 189204 */     GIR_EraseRootFromParent_Done,
     /* 189205 */   // Label 2917: @189205
     /* 189205 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(189259), // Rule ID 5580 //
     /* 189210 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189217 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 189219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 189230 */     // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET),
     /* 189233 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 189245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189257 */     GIR_RootConstrainSelectedInstOperands,
     /* 189258 */     // GIR_Coverage, 5580,
     /* 189258 */     GIR_EraseRootFromParent_Done,
     /* 189259 */   // Label 2918: @189259
     /* 189259 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(189320), // Rule ID 5572 //
     /* 189264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 189267 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 189289 */     // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET_RTN),
     /* 189292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 189294 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 189306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189318 */     GIR_RootConstrainSelectedInstOperands,
     /* 189319 */     // GIR_Coverage, 5572,
     /* 189319 */     GIR_EraseRootFromParent_Done,
     /* 189320 */   // Label 2919: @189320
     /* 189320 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(189378), // Rule ID 5578 //
     /* 189325 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 189347 */     // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 189347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN),
     /* 189350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 189352 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 189354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 189364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189376 */     GIR_RootConstrainSelectedInstOperands,
     /* 189377 */     // GIR_Coverage, 5578,
     /* 189377 */     GIR_EraseRootFromParent_Done,
     /* 189378 */   // Label 2920: @189378
     /* 189378 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(189432), // Rule ID 8120 //
     /* 189383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 189386 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 189391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 189406 */     // (atomic_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_swap_local_m0_i32>>  =>  (DS_WRXCHG_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 189406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B32),
     /* 189409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189416 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 189418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189430 */     GIR_RootConstrainSelectedInstOperands,
     /* 189431 */     // GIR_Coverage, 8120,
     /* 189431 */     GIR_EraseRootFromParent_Done,
     /* 189432 */   // Label 2921: @189432
     /* 189432 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(189486), // Rule ID 8121 //
     /* 189437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 189440 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 189445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 189460 */     // (atomic_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_swap_local_i32>>  =>  (DS_WRXCHG_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 189460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B32_gfx9),
     /* 189463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189470 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 189472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189484 */     GIR_RootConstrainSelectedInstOperands,
     /* 189485 */     // GIR_Coverage, 8121,
     /* 189485 */     GIR_EraseRootFromParent_Done,
     /* 189486 */   // Label 2922: @189486
     /* 189486 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(189540), // Rule ID 8122 //
     /* 189491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 189494 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 189499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 189514 */     // (atomic_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_swap_region_m0_i32>>  =>  (DS_WRXCHG_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 189514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B32),
     /* 189517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189524 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 189526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189538 */     GIR_RootConstrainSelectedInstOperands,
     /* 189539 */     // GIR_Coverage, 8122,
     /* 189539 */     GIR_EraseRootFromParent_Done,
     /* 189540 */   // Label 2923: @189540
     /* 189540 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(189597), // Rule ID 4046 //
     /* 189545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 189548 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189555 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 189557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 189568 */     // (atomic_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SWAP_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 189568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_SADDR),
     /* 189571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 189576 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 189578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 189583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189595 */     GIR_RootConstrainSelectedInstOperands,
     /* 189596 */     // GIR_Coverage, 4046,
     /* 189596 */     GIR_EraseRootFromParent_Done,
     /* 189597 */   // Label 2924: @189597
     /* 189597 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(189658), // Rule ID 4048 //
     /* 189602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 189605 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 189627 */     // (atomic_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_i32>>  =>  (GLOBAL_ATOMIC_SWAP_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 189627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_SADDR_RTN),
     /* 189630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 189637 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 189639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 189644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189656 */     GIR_RootConstrainSelectedInstOperands,
     /* 189657 */     // GIR_Coverage, 4048,
     /* 189657 */     GIR_EraseRootFromParent_Done,
     /* 189658 */   // Label 2925: @189658
     /* 189658 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(189710), // Rule ID 4045 //
     /* 189663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 189666 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189673 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 189675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 189686 */     // (atomic_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 189686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP),
     /* 189689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 189694 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 189696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189708 */     GIR_RootConstrainSelectedInstOperands,
     /* 189709 */     // GIR_Coverage, 4045,
     /* 189709 */     GIR_EraseRootFromParent_Done,
     /* 189710 */   // Label 2926: @189710
     /* 189710 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(189766), // Rule ID 4047 //
     /* 189715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 189718 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 189740 */     // (atomic_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_i32>>  =>  (GLOBAL_ATOMIC_SWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 189740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_RTN),
     /* 189743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 189750 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 189752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189764 */     GIR_RootConstrainSelectedInstOperands,
     /* 189765 */     // GIR_Coverage, 4047,
     /* 189765 */     GIR_EraseRootFromParent_Done,
     /* 189766 */   // Label 2927: @189766
     /* 189766 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(189819), // Rule ID 3684 //
     /* 189771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 189774 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189782 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 189784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 189795 */     // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_flat_noret_i32>>  =>  (FLAT_ATOMIC_SWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 189795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP),
     /* 189798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 189803 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 189805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189817 */     GIR_RootConstrainSelectedInstOperands,
     /* 189818 */     // GIR_Coverage, 3684,
     /* 189818 */     GIR_EraseRootFromParent_Done,
     /* 189819 */   // Label 2928: @189819
     /* 189819 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(189871), // Rule ID 3744 //
     /* 189824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 189827 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189834 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 189836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 189847 */     // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (FLAT_ATOMIC_SWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 189847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP),
     /* 189850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 189855 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 189857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189869 */     GIR_RootConstrainSelectedInstOperands,
     /* 189870 */     // GIR_Coverage, 3744,
     /* 189870 */     GIR_EraseRootFromParent_Done,
     /* 189871 */   // Label 2929: @189871
     /* 189871 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(189928), // Rule ID 3683 //
     /* 189876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 189879 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 189902 */     // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_flat_i32>>  =>  (FLAT_ATOMIC_SWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 189902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_RTN),
     /* 189905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 189912 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 189914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189926 */     GIR_RootConstrainSelectedInstOperands,
     /* 189927 */     // GIR_Coverage, 3683,
     /* 189927 */     GIR_EraseRootFromParent_Done,
     /* 189928 */   // Label 2930: @189928
     /* 189928 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(189984), // Rule ID 3743 //
     /* 189933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 189936 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 189943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 189947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 189958 */     // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_i32>>  =>  (FLAT_ATOMIC_SWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 189958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_RTN),
     /* 189961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 189963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 189968 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 189970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 189978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189982 */     GIR_RootConstrainSelectedInstOperands,
     /* 189983 */     // GIR_Coverage, 3743,
     /* 189983 */     GIR_EraseRootFromParent_Done,
     /* 189984 */   // Label 2931: @189984
     /* 189984 */   GIM_Reject,
     /* 189985 */ // Label 2912: @189985
     /* 189985 */ GIM_Reject,
     /* 189986 */ // Label 2910: @189986
     /* 189986 */ GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(191081),
     /* 189991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189994 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(190056), // Rule ID 5673 //
     /* 189999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 190002 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190009 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 190022 */     // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_ADDR64),
     /* 190025 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 190032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 190042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 190047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190054 */     GIR_RootConstrainSelectedInstOperands,
     /* 190055 */     // GIR_Coverage, 5673,
     /* 190055 */     GIR_EraseRootFromParent_Done,
     /* 190056 */   // Label 2933: @190056
     /* 190056 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(190115), // Rule ID 5677 //
     /* 190061 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190068 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 190081 */     // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64),
     /* 190084 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 190091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 190101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 190106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190113 */     GIR_RootConstrainSelectedInstOperands,
     /* 190114 */     // GIR_Coverage, 5677,
     /* 190114 */     GIR_EraseRootFromParent_Done,
     /* 190115 */   // Label 2934: @190115
     /* 190115 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(190181), // Rule ID 5671 //
     /* 190120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 190123 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 190145 */     // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_ADDR64_RTN),
     /* 190148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 190150 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 190157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 190167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 190172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190179 */     GIR_RootConstrainSelectedInstOperands,
     /* 190180 */     // GIR_Coverage, 5671,
     /* 190180 */     GIR_EraseRootFromParent_Done,
     /* 190181 */   // Label 2935: @190181
     /* 190181 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(190244), // Rule ID 5675 //
     /* 190186 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 190208 */     // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64_RTN),
     /* 190211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 190213 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 190220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 190230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 190235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190242 */     GIR_RootConstrainSelectedInstOperands,
     /* 190243 */     // GIR_Coverage, 5675,
     /* 190243 */     GIR_EraseRootFromParent_Done,
     /* 190244 */   // Label 2936: @190244
     /* 190244 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(190301), // Rule ID 5672 //
     /* 190249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 190252 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190259 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 190272 */     // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET),
     /* 190275 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 190287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190299 */     GIR_RootConstrainSelectedInstOperands,
     /* 190300 */     // GIR_Coverage, 5672,
     /* 190300 */     GIR_EraseRootFromParent_Done,
     /* 190301 */   // Label 2937: @190301
     /* 190301 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(190355), // Rule ID 5676 //
     /* 190306 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190313 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 190326 */     // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET),
     /* 190329 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 190341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190353 */     GIR_RootConstrainSelectedInstOperands,
     /* 190354 */     // GIR_Coverage, 5676,
     /* 190354 */     GIR_EraseRootFromParent_Done,
     /* 190355 */   // Label 2938: @190355
     /* 190355 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(190416), // Rule ID 5670 //
     /* 190360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 190363 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 190385 */     // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN),
     /* 190388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 190390 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 190402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190414 */     GIR_RootConstrainSelectedInstOperands,
     /* 190415 */     // GIR_Coverage, 5670,
     /* 190415 */     GIR_EraseRootFromParent_Done,
     /* 190416 */   // Label 2939: @190416
     /* 190416 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(190474), // Rule ID 5674 //
     /* 190421 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 190443 */     // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 190443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN),
     /* 190446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 190448 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 190450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 190460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190472 */     GIR_RootConstrainSelectedInstOperands,
     /* 190473 */     // GIR_Coverage, 5674,
     /* 190473 */     GIR_EraseRootFromParent_Done,
     /* 190474 */   // Label 2940: @190474
     /* 190474 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(190528), // Rule ID 8223 //
     /* 190479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 190482 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 190487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 190502 */     // (atomic_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_swap_local_m0_i64>>  =>  (DS_WRXCHG_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 190502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B64),
     /* 190505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 190507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 190512 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 190514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190526 */     GIR_RootConstrainSelectedInstOperands,
     /* 190527 */     // GIR_Coverage, 8223,
     /* 190527 */     GIR_EraseRootFromParent_Done,
     /* 190528 */   // Label 2941: @190528
     /* 190528 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(190582), // Rule ID 8224 //
     /* 190533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 190536 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 190541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 190556 */     // (atomic_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_swap_local_i64>>  =>  (DS_WRXCHG_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 190556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B64_gfx9),
     /* 190559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 190561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 190566 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 190568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190580 */     GIR_RootConstrainSelectedInstOperands,
     /* 190581 */     // GIR_Coverage, 8224,
     /* 190581 */     GIR_EraseRootFromParent_Done,
     /* 190582 */   // Label 2942: @190582
     /* 190582 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(190636), // Rule ID 8225 //
     /* 190587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 190590 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 190595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 190610 */     // (atomic_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_swap_region_m0_i64>>  =>  (DS_WRXCHG_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 190610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B64),
     /* 190613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 190615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 190620 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 190622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190634 */     GIR_RootConstrainSelectedInstOperands,
     /* 190635 */     // GIR_Coverage, 8225,
     /* 190635 */     GIR_EraseRootFromParent_Done,
     /* 190636 */   // Label 2943: @190636
     /* 190636 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(190693), // Rule ID 4102 //
     /* 190641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 190644 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190651 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 190664 */     // (atomic_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 190664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2_SADDR),
     /* 190667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 190672 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 190674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 190679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190691 */     GIR_RootConstrainSelectedInstOperands,
     /* 190692 */     // GIR_Coverage, 4102,
     /* 190692 */     GIR_EraseRootFromParent_Done,
     /* 190693 */   // Label 2944: @190693
     /* 190693 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(190754), // Rule ID 4104 //
     /* 190698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 190701 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 190723 */     // (atomic_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 190723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2_SADDR_RTN),
     /* 190726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 190728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 190733 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 190735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 190740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190752 */     GIR_RootConstrainSelectedInstOperands,
     /* 190753 */     // GIR_Coverage, 4104,
     /* 190753 */     GIR_EraseRootFromParent_Done,
     /* 190754 */   // Label 2945: @190754
     /* 190754 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(190806), // Rule ID 4101 //
     /* 190759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 190762 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190769 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 190782 */     // (atomic_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 190782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2),
     /* 190785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 190790 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 190792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190804 */     GIR_RootConstrainSelectedInstOperands,
     /* 190805 */     // GIR_Coverage, 4101,
     /* 190805 */     GIR_EraseRootFromParent_Done,
     /* 190806 */   // Label 2946: @190806
     /* 190806 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(190862), // Rule ID 4103 //
     /* 190811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 190814 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 190836 */     // (atomic_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 190836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2_RTN),
     /* 190839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 190841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 190846 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 190848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 190856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190860 */     GIR_RootConstrainSelectedInstOperands,
     /* 190861 */     // GIR_Coverage, 4103,
     /* 190861 */     GIR_EraseRootFromParent_Done,
     /* 190862 */   // Label 2947: @190862
     /* 190862 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(190915), // Rule ID 3710 //
     /* 190867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 190870 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190878 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 190891 */     // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_flat_noret_i64>>  =>  (FLAT_ATOMIC_SWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 190891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2),
     /* 190894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 190899 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 190901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190913 */     GIR_RootConstrainSelectedInstOperands,
     /* 190914 */     // GIR_Coverage, 3710,
     /* 190914 */     GIR_EraseRootFromParent_Done,
     /* 190915 */   // Label 2948: @190915
     /* 190915 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(190967), // Rule ID 3770 //
     /* 190920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 190923 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190930 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 190932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 190943 */     // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (FLAT_ATOMIC_SWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 190943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2),
     /* 190946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 190951 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 190953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190965 */     GIR_RootConstrainSelectedInstOperands,
     /* 190966 */     // GIR_Coverage, 3770,
     /* 190966 */     GIR_EraseRootFromParent_Done,
     /* 190967 */   // Label 2949: @190967
     /* 190967 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(191024), // Rule ID 3709 //
     /* 190972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 190975 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 190983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 190987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 190998 */     // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_flat_i64>>  =>  (FLAT_ATOMIC_SWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 190998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2_RTN),
     /* 191001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 191003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 191008 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 191010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191022 */     GIR_RootConstrainSelectedInstOperands,
     /* 191023 */     // GIR_Coverage, 3709,
     /* 191023 */     GIR_EraseRootFromParent_Done,
     /* 191024 */   // Label 2950: @191024
     /* 191024 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(191080), // Rule ID 3769 //
     /* 191029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 191032 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 191043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 191054 */     // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_i64>>  =>  (FLAT_ATOMIC_SWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 191054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2_RTN),
     /* 191057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 191059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 191064 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 191066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191078 */     GIR_RootConstrainSelectedInstOperands,
     /* 191079 */     // GIR_Coverage, 3769,
     /* 191079 */     GIR_EraseRootFromParent_Done,
     /* 191080 */   // Label 2951: @191080
     /* 191080 */   GIM_Reject,
     /* 191081 */ // Label 2932: @191081
     /* 191081 */ GIM_Reject,
     /* 191082 */ // Label 2911: @191082
     /* 191082 */ GIM_Reject,
     /* 191083 */ // Label 20: @191083
     /* 191083 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 2954*/ GIMT_Encode4(193594),
     /* 191094 */ /*GILLT_s32*//*Label 2952*/ GIMT_Encode4(191102),
     /* 191098 */ /*GILLT_s64*//*Label 2953*/ GIMT_Encode4(192348),
     /* 191102 */ // Label 2952: @191102
     /* 191102 */ GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(192347),
     /* 191107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 191110 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(191172), // Rule ID 5585 //
     /* 191115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 191118 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191125 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 191138 */     // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_ADDR64),
     /* 191141 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 191148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 191158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 191163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191170 */     GIR_RootConstrainSelectedInstOperands,
     /* 191171 */     // GIR_Coverage, 5585,
     /* 191171 */     GIR_EraseRootFromParent_Done,
     /* 191172 */   // Label 2956: @191172
     /* 191172 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(191231), // Rule ID 5589 //
     /* 191177 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191184 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 191197 */     // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_ADDR64),
     /* 191200 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 191207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 191217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 191222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191229 */     GIR_RootConstrainSelectedInstOperands,
     /* 191230 */     // GIR_Coverage, 5589,
     /* 191230 */     GIR_EraseRootFromParent_Done,
     /* 191231 */   // Label 2957: @191231
     /* 191231 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(191297), // Rule ID 5583 //
     /* 191236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 191239 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 191250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 191261 */     // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_ADDR64_RTN),
     /* 191264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 191266 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 191273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 191283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 191288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191295 */     GIR_RootConstrainSelectedInstOperands,
     /* 191296 */     // GIR_Coverage, 5583,
     /* 191296 */     GIR_EraseRootFromParent_Done,
     /* 191297 */   // Label 2958: @191297
     /* 191297 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(191360), // Rule ID 5587 //
     /* 191302 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 191313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 191324 */     // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_ADDR64_RTN),
     /* 191327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 191329 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 191336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 191346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 191351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191358 */     GIR_RootConstrainSelectedInstOperands,
     /* 191359 */     // GIR_Coverage, 5587,
     /* 191359 */     GIR_EraseRootFromParent_Done,
     /* 191360 */   // Label 2959: @191360
     /* 191360 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(191417), // Rule ID 5584 //
     /* 191365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 191368 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191375 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 191388 */     // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET),
     /* 191391 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 191403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191415 */     GIR_RootConstrainSelectedInstOperands,
     /* 191416 */     // GIR_Coverage, 5584,
     /* 191416 */     GIR_EraseRootFromParent_Done,
     /* 191417 */   // Label 2960: @191417
     /* 191417 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(191471), // Rule ID 5588 //
     /* 191422 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191429 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 191442 */     // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET),
     /* 191445 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 191457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191469 */     GIR_RootConstrainSelectedInstOperands,
     /* 191470 */     // GIR_Coverage, 5588,
     /* 191470 */     GIR_EraseRootFromParent_Done,
     /* 191471 */   // Label 2961: @191471
     /* 191471 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(191532), // Rule ID 5582 //
     /* 191476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 191479 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 191490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 191501 */     // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET_RTN),
     /* 191504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 191506 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 191518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191530 */     GIR_RootConstrainSelectedInstOperands,
     /* 191531 */     // GIR_Coverage, 5582,
     /* 191531 */     GIR_EraseRootFromParent_Done,
     /* 191532 */   // Label 2962: @191532
     /* 191532 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(191590), // Rule ID 5586 //
     /* 191537 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 191548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 191559 */     // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 191559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN),
     /* 191562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 191564 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 191566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 191576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191588 */     GIR_RootConstrainSelectedInstOperands,
     /* 191589 */     // GIR_Coverage, 5586,
     /* 191589 */     GIR_EraseRootFromParent_Done,
     /* 191590 */   // Label 2963: @191590
     /* 191590 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(191640), // Rule ID 8124 //
     /* 191595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 191598 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 191603 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 191616 */     // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_m0_noret_i32>>  =>  (DS_ADD_U32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 191616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U32),
     /* 191619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191624 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 191626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191638 */     GIR_RootConstrainSelectedInstOperands,
     /* 191639 */     // GIR_Coverage, 8124,
     /* 191639 */     GIR_EraseRootFromParent_Done,
     /* 191640 */   // Label 2964: @191640
     /* 191640 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(191690), // Rule ID 8126 //
     /* 191645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 191648 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 191653 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 191666 */     // (atomic_load_add:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_noret_i32>>  =>  (DS_ADD_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 191666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U32_gfx9),
     /* 191669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191674 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 191676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191688 */     GIR_RootConstrainSelectedInstOperands,
     /* 191689 */     // GIR_Coverage, 8126,
     /* 191689 */     GIR_EraseRootFromParent_Done,
     /* 191690 */   // Label 2965: @191690
     /* 191690 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(191740), // Rule ID 8128 //
     /* 191695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 191698 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 191703 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 191716 */     // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_region_m0_noret_i32>>  =>  (DS_ADD_U32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 191716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U32),
     /* 191719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191724 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 191726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191738 */     GIR_RootConstrainSelectedInstOperands,
     /* 191739 */     // GIR_Coverage, 8128,
     /* 191739 */     GIR_EraseRootFromParent_Done,
     /* 191740 */   // Label 2966: @191740
     /* 191740 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(191794), // Rule ID 8123 //
     /* 191745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 191748 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 191753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 191757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 191768 */     // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_m0_i32>>  =>  (DS_ADD_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 191768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U32),
     /* 191771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 191773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191778 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 191780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191792 */     GIR_RootConstrainSelectedInstOperands,
     /* 191793 */     // GIR_Coverage, 8123,
     /* 191793 */     GIR_EraseRootFromParent_Done,
     /* 191794 */   // Label 2967: @191794
     /* 191794 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(191848), // Rule ID 8125 //
     /* 191799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 191802 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 191807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 191811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 191822 */     // (atomic_load_add:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_i32>>  =>  (DS_ADD_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 191822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U32_gfx9),
     /* 191825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 191827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191832 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 191834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191846 */     GIR_RootConstrainSelectedInstOperands,
     /* 191847 */     // GIR_Coverage, 8125,
     /* 191847 */     GIR_EraseRootFromParent_Done,
     /* 191848 */   // Label 2968: @191848
     /* 191848 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(191902), // Rule ID 8127 //
     /* 191853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 191856 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 191861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 191865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 191876 */     // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_region_m0_i32>>  =>  (DS_ADD_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 191876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U32),
     /* 191879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 191881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191886 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 191888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191900 */     GIR_RootConstrainSelectedInstOperands,
     /* 191901 */     // GIR_Coverage, 8127,
     /* 191901 */     GIR_EraseRootFromParent_Done,
     /* 191902 */   // Label 2969: @191902
     /* 191902 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(191959), // Rule ID 3554 //
     /* 191907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 191910 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191917 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 191930 */     // (atomic_load_add:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (GLOBAL_ATOMIC_ADD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 191930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_SADDR),
     /* 191933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 191938 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 191940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 191945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191957 */     GIR_RootConstrainSelectedInstOperands,
     /* 191958 */     // GIR_Coverage, 3554,
     /* 191958 */     GIR_EraseRootFromParent_Done,
     /* 191959 */   // Label 2970: @191959
     /* 191959 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(192020), // Rule ID 3556 //
     /* 191964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 191967 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 191974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 191978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 191989 */     // (atomic_load_add:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_i32>>  =>  (GLOBAL_ATOMIC_ADD_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 191989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_SADDR_RTN),
     /* 191992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 191994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 191999 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 192006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 192011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192018 */     GIR_RootConstrainSelectedInstOperands,
     /* 192019 */     // GIR_Coverage, 3556,
     /* 192019 */     GIR_EraseRootFromParent_Done,
     /* 192020 */   // Label 2971: @192020
     /* 192020 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(192072), // Rule ID 3553 //
     /* 192025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 192028 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192035 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 192048 */     // (atomic_load_add:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (GLOBAL_ATOMIC_ADD VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 192048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD),
     /* 192051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 192056 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192070 */     GIR_RootConstrainSelectedInstOperands,
     /* 192071 */     // GIR_Coverage, 3553,
     /* 192071 */     GIR_EraseRootFromParent_Done,
     /* 192072 */   // Label 2972: @192072
     /* 192072 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(192128), // Rule ID 3555 //
     /* 192077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 192080 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 192102 */     // (atomic_load_add:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_i32>>  =>  (GLOBAL_ATOMIC_ADD_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 192102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_RTN),
     /* 192105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 192112 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192126 */     GIR_RootConstrainSelectedInstOperands,
     /* 192127 */     // GIR_Coverage, 3555,
     /* 192127 */     GIR_EraseRootFromParent_Done,
     /* 192128 */   // Label 2973: @192128
     /* 192128 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(192181), // Rule ID 3541 //
     /* 192133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 192136 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192144 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 192157 */     // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_flat_noret_i32>>  =>  (FLAT_ATOMIC_ADD VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 192157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD),
     /* 192160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 192165 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192179 */     GIR_RootConstrainSelectedInstOperands,
     /* 192180 */     // GIR_Coverage, 3541,
     /* 192180 */     GIR_EraseRootFromParent_Done,
     /* 192181 */   // Label 2974: @192181
     /* 192181 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(192233), // Rule ID 3724 //
     /* 192186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 192189 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192196 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 192209 */     // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (FLAT_ATOMIC_ADD VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 192209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD),
     /* 192212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 192217 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192231 */     GIR_RootConstrainSelectedInstOperands,
     /* 192232 */     // GIR_Coverage, 3724,
     /* 192232 */     GIR_EraseRootFromParent_Done,
     /* 192233 */   // Label 2975: @192233
     /* 192233 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(192290), // Rule ID 3542 //
     /* 192238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 192241 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 192264 */     // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_flat_i32>>  =>  (FLAT_ATOMIC_ADD_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 192264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_RTN),
     /* 192267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 192274 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192288 */     GIR_RootConstrainSelectedInstOperands,
     /* 192289 */     // GIR_Coverage, 3542,
     /* 192289 */     GIR_EraseRootFromParent_Done,
     /* 192290 */   // Label 2976: @192290
     /* 192290 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(192346), // Rule ID 3723 //
     /* 192295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 192298 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 192320 */     // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_i32>>  =>  (FLAT_ATOMIC_ADD_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 192320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_RTN),
     /* 192323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 192330 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 192332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192344 */     GIR_RootConstrainSelectedInstOperands,
     /* 192345 */     // GIR_Coverage, 3723,
     /* 192345 */     GIR_EraseRootFromParent_Done,
     /* 192346 */   // Label 2977: @192346
     /* 192346 */   GIM_Reject,
     /* 192347 */ // Label 2955: @192347
     /* 192347 */ GIM_Reject,
     /* 192348 */ // Label 2953: @192348
     /* 192348 */ GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(193593),
     /* 192353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 192356 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(192418), // Rule ID 5681 //
     /* 192361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 192364 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192371 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 192384 */     // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_ADDR64),
     /* 192387 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 192394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 192404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 192409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192416 */     GIR_RootConstrainSelectedInstOperands,
     /* 192417 */     // GIR_Coverage, 5681,
     /* 192417 */     GIR_EraseRootFromParent_Done,
     /* 192418 */   // Label 2979: @192418
     /* 192418 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(192477), // Rule ID 5685 //
     /* 192423 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192430 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 192443 */     // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64),
     /* 192446 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 192453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 192463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 192468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192475 */     GIR_RootConstrainSelectedInstOperands,
     /* 192476 */     // GIR_Coverage, 5685,
     /* 192476 */     GIR_EraseRootFromParent_Done,
     /* 192477 */   // Label 2980: @192477
     /* 192477 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(192543), // Rule ID 5679 //
     /* 192482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 192485 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 192496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 192507 */     // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_ADDR64_RTN),
     /* 192510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 192512 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 192519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 192529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 192534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192541 */     GIR_RootConstrainSelectedInstOperands,
     /* 192542 */     // GIR_Coverage, 5679,
     /* 192542 */     GIR_EraseRootFromParent_Done,
     /* 192543 */   // Label 2981: @192543
     /* 192543 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(192606), // Rule ID 5683 //
     /* 192548 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 192559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 192570 */     // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64_RTN),
     /* 192573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 192575 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 192582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 192592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 192597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192604 */     GIR_RootConstrainSelectedInstOperands,
     /* 192605 */     // GIR_Coverage, 5683,
     /* 192605 */     GIR_EraseRootFromParent_Done,
     /* 192606 */   // Label 2982: @192606
     /* 192606 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(192663), // Rule ID 5680 //
     /* 192611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 192614 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192621 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 192634 */     // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET),
     /* 192637 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 192649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 192654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192661 */     GIR_RootConstrainSelectedInstOperands,
     /* 192662 */     // GIR_Coverage, 5680,
     /* 192662 */     GIR_EraseRootFromParent_Done,
     /* 192663 */   // Label 2983: @192663
     /* 192663 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(192717), // Rule ID 5684 //
     /* 192668 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192675 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 192688 */     // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET),
     /* 192691 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 192703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 192708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192715 */     GIR_RootConstrainSelectedInstOperands,
     /* 192716 */     // GIR_Coverage, 5684,
     /* 192716 */     GIR_EraseRootFromParent_Done,
     /* 192717 */   // Label 2984: @192717
     /* 192717 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(192778), // Rule ID 5678 //
     /* 192722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 192725 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 192736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 192747 */     // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET_RTN),
     /* 192750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 192752 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 192764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 192769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192776 */     GIR_RootConstrainSelectedInstOperands,
     /* 192777 */     // GIR_Coverage, 5678,
     /* 192777 */     GIR_EraseRootFromParent_Done,
     /* 192778 */   // Label 2985: @192778
     /* 192778 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(192836), // Rule ID 5682 //
     /* 192783 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 192794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 192805 */     // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN),
     /* 192808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 192810 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 192822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 192827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192834 */     GIR_RootConstrainSelectedInstOperands,
     /* 192835 */     // GIR_Coverage, 5682,
     /* 192835 */     GIR_EraseRootFromParent_Done,
     /* 192836 */   // Label 2986: @192836
     /* 192836 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(192886), // Rule ID 8227 //
     /* 192841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 192844 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 192849 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192862 */     // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_m0_noret_i64>>  =>  (DS_ADD_U64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 192862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U64),
     /* 192865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192870 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 192872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192884 */     GIR_RootConstrainSelectedInstOperands,
     /* 192885 */     // GIR_Coverage, 8227,
     /* 192885 */     GIR_EraseRootFromParent_Done,
     /* 192886 */   // Label 2987: @192886
     /* 192886 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(192936), // Rule ID 8229 //
     /* 192891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 192894 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 192899 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192912 */     // (atomic_load_add:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_noret_i64>>  =>  (DS_ADD_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 192912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U64_gfx9),
     /* 192915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192920 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 192922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192934 */     GIR_RootConstrainSelectedInstOperands,
     /* 192935 */     // GIR_Coverage, 8229,
     /* 192935 */     GIR_EraseRootFromParent_Done,
     /* 192936 */   // Label 2988: @192936
     /* 192936 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(192986), // Rule ID 8231 //
     /* 192941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 192944 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 192949 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192962 */     // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_region_m0_noret_i64>>  =>  (DS_ADD_U64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 192962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U64),
     /* 192965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192970 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 192972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192984 */     GIR_RootConstrainSelectedInstOperands,
     /* 192985 */     // GIR_Coverage, 8231,
     /* 192985 */     GIR_EraseRootFromParent_Done,
     /* 192986 */   // Label 2989: @192986
     /* 192986 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(193040), // Rule ID 8226 //
     /* 192991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 192994 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 192999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 193014 */     // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_m0_i64>>  =>  (DS_ADD_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 193014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U64),
     /* 193017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 193024 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 193026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193038 */     GIR_RootConstrainSelectedInstOperands,
     /* 193039 */     // GIR_Coverage, 8226,
     /* 193039 */     GIR_EraseRootFromParent_Done,
     /* 193040 */   // Label 2990: @193040
     /* 193040 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(193094), // Rule ID 8228 //
     /* 193045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 193048 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 193053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 193068 */     // (atomic_load_add:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_i64>>  =>  (DS_ADD_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 193068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U64_gfx9),
     /* 193071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 193078 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 193080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193092 */     GIR_RootConstrainSelectedInstOperands,
     /* 193093 */     // GIR_Coverage, 8228,
     /* 193093 */     GIR_EraseRootFromParent_Done,
     /* 193094 */   // Label 2991: @193094
     /* 193094 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(193148), // Rule ID 8230 //
     /* 193099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 193102 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 193107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 193122 */     // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_region_m0_i64>>  =>  (DS_ADD_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 193122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U64),
     /* 193125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 193132 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 193134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193146 */     GIR_RootConstrainSelectedInstOperands,
     /* 193147 */     // GIR_Coverage, 8230,
     /* 193147 */     GIR_EraseRootFromParent_Done,
     /* 193148 */   // Label 2992: @193148
     /* 193148 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(193205), // Rule ID 4062 //
     /* 193153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 193156 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193163 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 193176 */     // (atomic_load_add:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 193176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2_SADDR),
     /* 193179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 193184 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 193191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193203 */     GIR_RootConstrainSelectedInstOperands,
     /* 193204 */     // GIR_Coverage, 4062,
     /* 193204 */     GIR_EraseRootFromParent_Done,
     /* 193205 */   // Label 2993: @193205
     /* 193205 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(193266), // Rule ID 4064 //
     /* 193210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 193213 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 193235 */     // (atomic_load_add:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 193235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2_SADDR_RTN),
     /* 193238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 193245 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 193252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193264 */     GIR_RootConstrainSelectedInstOperands,
     /* 193265 */     // GIR_Coverage, 4064,
     /* 193265 */     GIR_EraseRootFromParent_Done,
     /* 193266 */   // Label 2994: @193266
     /* 193266 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(193318), // Rule ID 4061 //
     /* 193271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 193274 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193281 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 193294 */     // (atomic_load_add:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 193294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2),
     /* 193297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193302 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193316 */     GIR_RootConstrainSelectedInstOperands,
     /* 193317 */     // GIR_Coverage, 4061,
     /* 193317 */     GIR_EraseRootFromParent_Done,
     /* 193318 */   // Label 2995: @193318
     /* 193318 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(193374), // Rule ID 4063 //
     /* 193323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 193326 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 193348 */     // (atomic_load_add:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 193348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2_RTN),
     /* 193351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193358 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193372 */     GIR_RootConstrainSelectedInstOperands,
     /* 193373 */     // GIR_Coverage, 4063,
     /* 193373 */     GIR_EraseRootFromParent_Done,
     /* 193374 */   // Label 2996: @193374
     /* 193374 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(193427), // Rule ID 3690 //
     /* 193379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 193382 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193390 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 193403 */     // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_flat_noret_i64>>  =>  (FLAT_ATOMIC_ADD_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 193403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2),
     /* 193406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193411 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193425 */     GIR_RootConstrainSelectedInstOperands,
     /* 193426 */     // GIR_Coverage, 3690,
     /* 193426 */     GIR_EraseRootFromParent_Done,
     /* 193427 */   // Label 2997: @193427
     /* 193427 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(193479), // Rule ID 3750 //
     /* 193432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 193435 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193442 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 193455 */     // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (FLAT_ATOMIC_ADD_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 193455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2),
     /* 193458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193463 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193477 */     GIR_RootConstrainSelectedInstOperands,
     /* 193478 */     // GIR_Coverage, 3750,
     /* 193478 */     GIR_EraseRootFromParent_Done,
     /* 193479 */   // Label 2998: @193479
     /* 193479 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(193536), // Rule ID 3689 //
     /* 193484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 193487 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 193510 */     // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_flat_i64>>  =>  (FLAT_ATOMIC_ADD_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 193510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2_RTN),
     /* 193513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193520 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193534 */     GIR_RootConstrainSelectedInstOperands,
     /* 193535 */     // GIR_Coverage, 3689,
     /* 193535 */     GIR_EraseRootFromParent_Done,
     /* 193536 */   // Label 2999: @193536
     /* 193536 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(193592), // Rule ID 3749 //
     /* 193541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 193544 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 193555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 193566 */     // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_i64>>  =>  (FLAT_ATOMIC_ADD_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 193566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2_RTN),
     /* 193569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193576 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193590 */     GIR_RootConstrainSelectedInstOperands,
     /* 193591 */     // GIR_Coverage, 3749,
     /* 193591 */     GIR_EraseRootFromParent_Done,
     /* 193592 */   // Label 3000: @193592
     /* 193592 */   GIM_Reject,
     /* 193593 */ // Label 2978: @193593
     /* 193593 */ GIM_Reject,
     /* 193594 */ // Label 2954: @193594
     /* 193594 */ GIM_Reject,
     /* 193595 */ // Label 21: @193595
     /* 193595 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3003*/ GIMT_Encode4(196106),
     /* 193606 */ /*GILLT_s32*//*Label 3001*/ GIMT_Encode4(193614),
     /* 193610 */ /*GILLT_s64*//*Label 3002*/ GIMT_Encode4(194860),
     /* 193614 */ // Label 3001: @193614
     /* 193614 */ GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(194859),
     /* 193619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193622 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(193684), // Rule ID 5593 //
     /* 193627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 193630 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193637 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 193650 */     // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_ADDR64),
     /* 193653 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 193660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 193670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 193675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193682 */     GIR_RootConstrainSelectedInstOperands,
     /* 193683 */     // GIR_Coverage, 5593,
     /* 193683 */     GIR_EraseRootFromParent_Done,
     /* 193684 */   // Label 3005: @193684
     /* 193684 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(193743), // Rule ID 5597 //
     /* 193689 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193696 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 193709 */     // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_ADDR64),
     /* 193712 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 193719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 193729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 193734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193741 */     GIR_RootConstrainSelectedInstOperands,
     /* 193742 */     // GIR_Coverage, 5597,
     /* 193742 */     GIR_EraseRootFromParent_Done,
     /* 193743 */   // Label 3006: @193743
     /* 193743 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(193809), // Rule ID 5591 //
     /* 193748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 193751 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 193773 */     // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_ADDR64_RTN),
     /* 193776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 193778 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 193785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 193795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 193800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193807 */     GIR_RootConstrainSelectedInstOperands,
     /* 193808 */     // GIR_Coverage, 5591,
     /* 193808 */     GIR_EraseRootFromParent_Done,
     /* 193809 */   // Label 3007: @193809
     /* 193809 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(193872), // Rule ID 5595 //
     /* 193814 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 193836 */     // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_ADDR64_RTN),
     /* 193839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 193841 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 193848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 193858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 193863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193870 */     GIR_RootConstrainSelectedInstOperands,
     /* 193871 */     // GIR_Coverage, 5595,
     /* 193871 */     GIR_EraseRootFromParent_Done,
     /* 193872 */   // Label 3008: @193872
     /* 193872 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(193929), // Rule ID 5592 //
     /* 193877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 193880 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193887 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 193900 */     // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET),
     /* 193903 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 193915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193927 */     GIR_RootConstrainSelectedInstOperands,
     /* 193928 */     // GIR_Coverage, 5592,
     /* 193928 */     GIR_EraseRootFromParent_Done,
     /* 193929 */   // Label 3009: @193929
     /* 193929 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(193983), // Rule ID 5596 //
     /* 193934 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193941 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 193954 */     // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET),
     /* 193957 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 193969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193981 */     GIR_RootConstrainSelectedInstOperands,
     /* 193982 */     // GIR_Coverage, 5596,
     /* 193982 */     GIR_EraseRootFromParent_Done,
     /* 193983 */   // Label 3010: @193983
     /* 193983 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(194044), // Rule ID 5590 //
     /* 193988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 193991 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 194013 */     // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET_RTN),
     /* 194016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 194018 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 194030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194042 */     GIR_RootConstrainSelectedInstOperands,
     /* 194043 */     // GIR_Coverage, 5590,
     /* 194043 */     GIR_EraseRootFromParent_Done,
     /* 194044 */   // Label 3011: @194044
     /* 194044 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(194102), // Rule ID 5594 //
     /* 194049 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 194071 */     // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN),
     /* 194074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 194076 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 194088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194100 */     GIR_RootConstrainSelectedInstOperands,
     /* 194101 */     // GIR_Coverage, 5594,
     /* 194101 */     GIR_EraseRootFromParent_Done,
     /* 194102 */   // Label 3012: @194102
     /* 194102 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(194152), // Rule ID 8140 //
     /* 194107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 194110 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 194115 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194128 */     // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_m0_noret_i32>>  =>  (DS_SUB_U32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 194128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U32),
     /* 194131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194136 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194150 */     GIR_RootConstrainSelectedInstOperands,
     /* 194151 */     // GIR_Coverage, 8140,
     /* 194151 */     GIR_EraseRootFromParent_Done,
     /* 194152 */   // Label 3013: @194152
     /* 194152 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(194202), // Rule ID 8142 //
     /* 194157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 194160 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 194165 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194178 */     // (atomic_load_sub:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_noret_i32>>  =>  (DS_SUB_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 194178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U32_gfx9),
     /* 194181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194186 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194200 */     GIR_RootConstrainSelectedInstOperands,
     /* 194201 */     // GIR_Coverage, 8142,
     /* 194201 */     GIR_EraseRootFromParent_Done,
     /* 194202 */   // Label 3014: @194202
     /* 194202 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(194252), // Rule ID 8144 //
     /* 194207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 194210 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 194215 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194228 */     // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_region_m0_noret_i32>>  =>  (DS_SUB_U32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 194228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U32),
     /* 194231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194236 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194250 */     GIR_RootConstrainSelectedInstOperands,
     /* 194251 */     // GIR_Coverage, 8144,
     /* 194251 */     GIR_EraseRootFromParent_Done,
     /* 194252 */   // Label 3015: @194252
     /* 194252 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(194306), // Rule ID 8139 //
     /* 194257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 194260 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 194265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194280 */     // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_m0_i32>>  =>  (DS_SUB_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 194280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U32),
     /* 194283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194290 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194304 */     GIR_RootConstrainSelectedInstOperands,
     /* 194305 */     // GIR_Coverage, 8139,
     /* 194305 */     GIR_EraseRootFromParent_Done,
     /* 194306 */   // Label 3016: @194306
     /* 194306 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(194360), // Rule ID 8141 //
     /* 194311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 194314 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 194319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194334 */     // (atomic_load_sub:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_i32>>  =>  (DS_SUB_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 194334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U32_gfx9),
     /* 194337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194344 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194358 */     GIR_RootConstrainSelectedInstOperands,
     /* 194359 */     // GIR_Coverage, 8141,
     /* 194359 */     GIR_EraseRootFromParent_Done,
     /* 194360 */   // Label 3017: @194360
     /* 194360 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(194414), // Rule ID 8143 //
     /* 194365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 194368 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 194373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194388 */     // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_region_m0_i32>>  =>  (DS_SUB_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 194388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U32),
     /* 194391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194398 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194412 */     GIR_RootConstrainSelectedInstOperands,
     /* 194413 */     // GIR_Coverage, 8143,
     /* 194413 */     GIR_EraseRootFromParent_Done,
     /* 194414 */   // Label 3018: @194414
     /* 194414 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(194471), // Rule ID 4010 //
     /* 194419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 194422 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194429 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 194442 */     // (atomic_load_sub:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SUB_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 194442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_SADDR),
     /* 194445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 194450 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 194457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194469 */     GIR_RootConstrainSelectedInstOperands,
     /* 194470 */     // GIR_Coverage, 4010,
     /* 194470 */     GIR_EraseRootFromParent_Done,
     /* 194471 */   // Label 3019: @194471
     /* 194471 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(194532), // Rule ID 4012 //
     /* 194476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 194479 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 194501 */     // (atomic_load_sub:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (GLOBAL_ATOMIC_SUB_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 194501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_SADDR_RTN),
     /* 194504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 194511 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 194518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194530 */     GIR_RootConstrainSelectedInstOperands,
     /* 194531 */     // GIR_Coverage, 4012,
     /* 194531 */     GIR_EraseRootFromParent_Done,
     /* 194532 */   // Label 3020: @194532
     /* 194532 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(194584), // Rule ID 4009 //
     /* 194537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 194540 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194547 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 194560 */     // (atomic_load_sub:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 194560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB),
     /* 194563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194568 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194582 */     GIR_RootConstrainSelectedInstOperands,
     /* 194583 */     // GIR_Coverage, 4009,
     /* 194583 */     GIR_EraseRootFromParent_Done,
     /* 194584 */   // Label 3021: @194584
     /* 194584 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(194640), // Rule ID 4011 //
     /* 194589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 194592 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 194614 */     // (atomic_load_sub:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (GLOBAL_ATOMIC_SUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 194614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_RTN),
     /* 194617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194624 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194638 */     GIR_RootConstrainSelectedInstOperands,
     /* 194639 */     // GIR_Coverage, 4011,
     /* 194639 */     GIR_EraseRootFromParent_Done,
     /* 194640 */   // Label 3022: @194640
     /* 194640 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(194693), // Rule ID 3666 //
     /* 194645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 194648 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194656 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 194669 */     // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_flat_noret_i32>>  =>  (FLAT_ATOMIC_SUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 194669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB),
     /* 194672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194677 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194691 */     GIR_RootConstrainSelectedInstOperands,
     /* 194692 */     // GIR_Coverage, 3666,
     /* 194692 */     GIR_EraseRootFromParent_Done,
     /* 194693 */   // Label 3023: @194693
     /* 194693 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(194745), // Rule ID 3726 //
     /* 194698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 194701 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194708 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 194721 */     // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (FLAT_ATOMIC_SUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 194721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB),
     /* 194724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194729 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194743 */     GIR_RootConstrainSelectedInstOperands,
     /* 194744 */     // GIR_Coverage, 3726,
     /* 194744 */     GIR_EraseRootFromParent_Done,
     /* 194745 */   // Label 3024: @194745
     /* 194745 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(194802), // Rule ID 3665 //
     /* 194750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 194753 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 194776 */     // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_flat_i32>>  =>  (FLAT_ATOMIC_SUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 194776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_RTN),
     /* 194779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194786 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194800 */     GIR_RootConstrainSelectedInstOperands,
     /* 194801 */     // GIR_Coverage, 3665,
     /* 194801 */     GIR_EraseRootFromParent_Done,
     /* 194802 */   // Label 3025: @194802
     /* 194802 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(194858), // Rule ID 3725 //
     /* 194807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 194810 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 194821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 194832 */     // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (FLAT_ATOMIC_SUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 194832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_RTN),
     /* 194835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194842 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194856 */     GIR_RootConstrainSelectedInstOperands,
     /* 194857 */     // GIR_Coverage, 3725,
     /* 194857 */     GIR_EraseRootFromParent_Done,
     /* 194858 */   // Label 3026: @194858
     /* 194858 */   GIM_Reject,
     /* 194859 */ // Label 3004: @194859
     /* 194859 */ GIM_Reject,
     /* 194860 */ // Label 3002: @194860
     /* 194860 */ GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(196105),
     /* 194865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194868 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(194930), // Rule ID 5689 //
     /* 194873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 194876 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194883 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 194896 */     // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_ADDR64),
     /* 194899 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 194906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 194916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 194921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194928 */     GIR_RootConstrainSelectedInstOperands,
     /* 194929 */     // GIR_Coverage, 5689,
     /* 194929 */     GIR_EraseRootFromParent_Done,
     /* 194930 */   // Label 3028: @194930
     /* 194930 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(194989), // Rule ID 5693 //
     /* 194935 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194942 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 194955 */     // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64),
     /* 194958 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 194965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 194975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 194980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194987 */     GIR_RootConstrainSelectedInstOperands,
     /* 194988 */     // GIR_Coverage, 5693,
     /* 194988 */     GIR_EraseRootFromParent_Done,
     /* 194989 */   // Label 3029: @194989
     /* 194989 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(195055), // Rule ID 5687 //
     /* 194994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 194997 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 195019 */     // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_ADDR64_RTN),
     /* 195022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 195024 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 195031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 195041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 195046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195053 */     GIR_RootConstrainSelectedInstOperands,
     /* 195054 */     // GIR_Coverage, 5687,
     /* 195054 */     GIR_EraseRootFromParent_Done,
     /* 195055 */   // Label 3030: @195055
     /* 195055 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(195118), // Rule ID 5691 //
     /* 195060 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 195082 */     // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64_RTN),
     /* 195085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 195087 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 195094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 195104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 195109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195116 */     GIR_RootConstrainSelectedInstOperands,
     /* 195117 */     // GIR_Coverage, 5691,
     /* 195117 */     GIR_EraseRootFromParent_Done,
     /* 195118 */   // Label 3031: @195118
     /* 195118 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(195175), // Rule ID 5688 //
     /* 195123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 195126 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195133 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 195146 */     // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET),
     /* 195149 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 195161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195173 */     GIR_RootConstrainSelectedInstOperands,
     /* 195174 */     // GIR_Coverage, 5688,
     /* 195174 */     GIR_EraseRootFromParent_Done,
     /* 195175 */   // Label 3032: @195175
     /* 195175 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(195229), // Rule ID 5692 //
     /* 195180 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195187 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 195200 */     // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET),
     /* 195203 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 195215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195227 */     GIR_RootConstrainSelectedInstOperands,
     /* 195228 */     // GIR_Coverage, 5692,
     /* 195228 */     GIR_EraseRootFromParent_Done,
     /* 195229 */   // Label 3033: @195229
     /* 195229 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(195290), // Rule ID 5686 //
     /* 195234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 195237 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 195259 */     // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET_RTN),
     /* 195262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 195264 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 195276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195288 */     GIR_RootConstrainSelectedInstOperands,
     /* 195289 */     // GIR_Coverage, 5686,
     /* 195289 */     GIR_EraseRootFromParent_Done,
     /* 195290 */   // Label 3034: @195290
     /* 195290 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(195348), // Rule ID 5690 //
     /* 195295 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 195317 */     // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN),
     /* 195320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 195322 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 195334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195346 */     GIR_RootConstrainSelectedInstOperands,
     /* 195347 */     // GIR_Coverage, 5690,
     /* 195347 */     GIR_EraseRootFromParent_Done,
     /* 195348 */   // Label 3035: @195348
     /* 195348 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(195398), // Rule ID 8233 //
     /* 195353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 195356 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 195361 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195374 */     // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_m0_noret_i64>>  =>  (DS_SUB_U64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 195374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U64),
     /* 195377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195382 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195396 */     GIR_RootConstrainSelectedInstOperands,
     /* 195397 */     // GIR_Coverage, 8233,
     /* 195397 */     GIR_EraseRootFromParent_Done,
     /* 195398 */   // Label 3036: @195398
     /* 195398 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(195448), // Rule ID 8235 //
     /* 195403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 195406 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 195411 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195424 */     // (atomic_load_sub:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_noret_i64>>  =>  (DS_SUB_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 195424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U64_gfx9),
     /* 195427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195432 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195446 */     GIR_RootConstrainSelectedInstOperands,
     /* 195447 */     // GIR_Coverage, 8235,
     /* 195447 */     GIR_EraseRootFromParent_Done,
     /* 195448 */   // Label 3037: @195448
     /* 195448 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(195498), // Rule ID 8237 //
     /* 195453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 195456 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 195461 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195474 */     // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_region_m0_noret_i64>>  =>  (DS_SUB_U64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 195474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U64),
     /* 195477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195482 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195496 */     GIR_RootConstrainSelectedInstOperands,
     /* 195497 */     // GIR_Coverage, 8237,
     /* 195497 */     GIR_EraseRootFromParent_Done,
     /* 195498 */   // Label 3038: @195498
     /* 195498 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(195552), // Rule ID 8232 //
     /* 195503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 195506 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 195511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195526 */     // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_m0_i64>>  =>  (DS_SUB_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 195526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U64),
     /* 195529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195536 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195550 */     GIR_RootConstrainSelectedInstOperands,
     /* 195551 */     // GIR_Coverage, 8232,
     /* 195551 */     GIR_EraseRootFromParent_Done,
     /* 195552 */   // Label 3039: @195552
     /* 195552 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(195606), // Rule ID 8234 //
     /* 195557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 195560 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 195565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195580 */     // (atomic_load_sub:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_i64>>  =>  (DS_SUB_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 195580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U64_gfx9),
     /* 195583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195590 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195604 */     GIR_RootConstrainSelectedInstOperands,
     /* 195605 */     // GIR_Coverage, 8234,
     /* 195605 */     GIR_EraseRootFromParent_Done,
     /* 195606 */   // Label 3040: @195606
     /* 195606 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(195660), // Rule ID 8236 //
     /* 195611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 195614 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 195619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195634 */     // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_region_m0_i64>>  =>  (DS_SUB_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 195634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U64),
     /* 195637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195644 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195658 */     GIR_RootConstrainSelectedInstOperands,
     /* 195659 */     // GIR_Coverage, 8236,
     /* 195659 */     GIR_EraseRootFromParent_Done,
     /* 195660 */   // Label 3041: @195660
     /* 195660 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(195717), // Rule ID 4066 //
     /* 195665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 195668 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195675 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 195688 */     // (atomic_load_sub:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 195688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2_SADDR),
     /* 195691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 195696 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 195698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 195703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195715 */     GIR_RootConstrainSelectedInstOperands,
     /* 195716 */     // GIR_Coverage, 4066,
     /* 195716 */     GIR_EraseRootFromParent_Done,
     /* 195717 */   // Label 3042: @195717
     /* 195717 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(195778), // Rule ID 4068 //
     /* 195722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 195725 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 195747 */     // (atomic_load_sub:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 195747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2_SADDR_RTN),
     /* 195750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 195757 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 195759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 195764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195776 */     GIR_RootConstrainSelectedInstOperands,
     /* 195777 */     // GIR_Coverage, 4068,
     /* 195777 */     GIR_EraseRootFromParent_Done,
     /* 195778 */   // Label 3043: @195778
     /* 195778 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(195830), // Rule ID 4065 //
     /* 195783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 195786 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195793 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 195806 */     // (atomic_load_sub:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 195806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2),
     /* 195809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 195814 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 195816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195828 */     GIR_RootConstrainSelectedInstOperands,
     /* 195829 */     // GIR_Coverage, 4065,
     /* 195829 */     GIR_EraseRootFromParent_Done,
     /* 195830 */   // Label 3044: @195830
     /* 195830 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(195886), // Rule ID 4067 //
     /* 195835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 195838 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 195860 */     // (atomic_load_sub:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 195860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2_RTN),
     /* 195863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 195870 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 195872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195884 */     GIR_RootConstrainSelectedInstOperands,
     /* 195885 */     // GIR_Coverage, 4067,
     /* 195885 */     GIR_EraseRootFromParent_Done,
     /* 195886 */   // Label 3045: @195886
     /* 195886 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(195939), // Rule ID 3692 //
     /* 195891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 195894 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195902 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 195915 */     // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_flat_noret_i64>>  =>  (FLAT_ATOMIC_SUB_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 195915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2),
     /* 195918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 195923 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 195925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195937 */     GIR_RootConstrainSelectedInstOperands,
     /* 195938 */     // GIR_Coverage, 3692,
     /* 195938 */     GIR_EraseRootFromParent_Done,
     /* 195939 */   // Label 3046: @195939
     /* 195939 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(195991), // Rule ID 3752 //
     /* 195944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 195947 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195954 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 195967 */     // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (FLAT_ATOMIC_SUB_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 195967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2),
     /* 195970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 195975 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 195977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195989 */     GIR_RootConstrainSelectedInstOperands,
     /* 195990 */     // GIR_Coverage, 3752,
     /* 195990 */     GIR_EraseRootFromParent_Done,
     /* 195991 */   // Label 3047: @195991
     /* 195991 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(196048), // Rule ID 3691 //
     /* 195996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 195999 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 196011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 196022 */     // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_flat_i64>>  =>  (FLAT_ATOMIC_SUB_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 196022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2_RTN),
     /* 196025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 196027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196032 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196046 */     GIR_RootConstrainSelectedInstOperands,
     /* 196047 */     // GIR_Coverage, 3691,
     /* 196047 */     GIR_EraseRootFromParent_Done,
     /* 196048 */   // Label 3048: @196048
     /* 196048 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(196104), // Rule ID 3751 //
     /* 196053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 196056 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 196067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 196078 */     // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (FLAT_ATOMIC_SUB_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 196078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2_RTN),
     /* 196081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 196083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196088 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196102 */     GIR_RootConstrainSelectedInstOperands,
     /* 196103 */     // GIR_Coverage, 3751,
     /* 196103 */     GIR_EraseRootFromParent_Done,
     /* 196104 */   // Label 3049: @196104
     /* 196104 */   GIM_Reject,
     /* 196105 */ // Label 3027: @196105
     /* 196105 */ GIM_Reject,
     /* 196106 */ // Label 3003: @196106
     /* 196106 */ GIM_Reject,
     /* 196107 */ // Label 22: @196107
     /* 196107 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3052*/ GIMT_Encode4(198618),
     /* 196118 */ /*GILLT_s32*//*Label 3050*/ GIMT_Encode4(196126),
     /* 196122 */ /*GILLT_s64*//*Label 3051*/ GIMT_Encode4(197372),
     /* 196126 */ // Label 3050: @196126
     /* 196126 */ GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(197371),
     /* 196131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196134 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(196196), // Rule ID 5633 //
     /* 196139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 196142 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196149 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 196162 */     // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_ADDR64),
     /* 196165 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 196172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 196182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 196187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196194 */     GIR_RootConstrainSelectedInstOperands,
     /* 196195 */     // GIR_Coverage, 5633,
     /* 196195 */     GIR_EraseRootFromParent_Done,
     /* 196196 */   // Label 3054: @196196
     /* 196196 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(196255), // Rule ID 5637 //
     /* 196201 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196208 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 196221 */     // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_ADDR64),
     /* 196224 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 196231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 196241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 196246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196253 */     GIR_RootConstrainSelectedInstOperands,
     /* 196254 */     // GIR_Coverage, 5637,
     /* 196254 */     GIR_EraseRootFromParent_Done,
     /* 196255 */   // Label 3055: @196255
     /* 196255 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(196321), // Rule ID 5631 //
     /* 196260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 196263 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 196285 */     // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_ADDR64_RTN),
     /* 196288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 196290 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 196297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 196307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 196312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196319 */     GIR_RootConstrainSelectedInstOperands,
     /* 196320 */     // GIR_Coverage, 5631,
     /* 196320 */     GIR_EraseRootFromParent_Done,
     /* 196321 */   // Label 3056: @196321
     /* 196321 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(196384), // Rule ID 5635 //
     /* 196326 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 196348 */     // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_ADDR64_RTN),
     /* 196351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 196353 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 196360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 196370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 196375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196382 */     GIR_RootConstrainSelectedInstOperands,
     /* 196383 */     // GIR_Coverage, 5635,
     /* 196383 */     GIR_EraseRootFromParent_Done,
     /* 196384 */   // Label 3057: @196384
     /* 196384 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(196441), // Rule ID 5632 //
     /* 196389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 196392 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196399 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 196412 */     // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET),
     /* 196415 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 196427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196439 */     GIR_RootConstrainSelectedInstOperands,
     /* 196440 */     // GIR_Coverage, 5632,
     /* 196440 */     GIR_EraseRootFromParent_Done,
     /* 196441 */   // Label 3058: @196441
     /* 196441 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(196495), // Rule ID 5636 //
     /* 196446 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196453 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 196466 */     // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET),
     /* 196469 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 196481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196493 */     GIR_RootConstrainSelectedInstOperands,
     /* 196494 */     // GIR_Coverage, 5636,
     /* 196494 */     GIR_EraseRootFromParent_Done,
     /* 196495 */   // Label 3059: @196495
     /* 196495 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(196556), // Rule ID 5630 //
     /* 196500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 196503 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 196525 */     // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET_RTN),
     /* 196528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 196530 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 196542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196554 */     GIR_RootConstrainSelectedInstOperands,
     /* 196555 */     // GIR_Coverage, 5630,
     /* 196555 */     GIR_EraseRootFromParent_Done,
     /* 196556 */   // Label 3060: @196556
     /* 196556 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(196614), // Rule ID 5634 //
     /* 196561 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 196583 */     // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN),
     /* 196586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 196588 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 196600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196612 */     GIR_RootConstrainSelectedInstOperands,
     /* 196613 */     // GIR_Coverage, 5634,
     /* 196613 */     GIR_EraseRootFromParent_Done,
     /* 196614 */   // Label 3061: @196614
     /* 196614 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(196664), // Rule ID 8158 //
     /* 196619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 196622 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 196627 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 196640 */     // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_m0_noret_i32>>  =>  (DS_AND_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 196640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B32),
     /* 196643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 196648 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 196650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196662 */     GIR_RootConstrainSelectedInstOperands,
     /* 196663 */     // GIR_Coverage, 8158,
     /* 196663 */     GIR_EraseRootFromParent_Done,
     /* 196664 */   // Label 3062: @196664
     /* 196664 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(196714), // Rule ID 8160 //
     /* 196669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 196672 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 196677 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 196690 */     // (atomic_load_and:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_noret_i32>>  =>  (DS_AND_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 196690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B32_gfx9),
     /* 196693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 196698 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 196700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196712 */     GIR_RootConstrainSelectedInstOperands,
     /* 196713 */     // GIR_Coverage, 8160,
     /* 196713 */     GIR_EraseRootFromParent_Done,
     /* 196714 */   // Label 3063: @196714
     /* 196714 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(196764), // Rule ID 8162 //
     /* 196719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 196722 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 196727 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 196740 */     // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_region_m0_noret_i32>>  =>  (DS_AND_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 196740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B32),
     /* 196743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 196748 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 196750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196762 */     GIR_RootConstrainSelectedInstOperands,
     /* 196763 */     // GIR_Coverage, 8162,
     /* 196763 */     GIR_EraseRootFromParent_Done,
     /* 196764 */   // Label 3064: @196764
     /* 196764 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(196818), // Rule ID 8157 //
     /* 196769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 196772 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 196777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 196792 */     // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_m0_i32>>  =>  (DS_AND_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 196792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B32),
     /* 196795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 196797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 196802 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 196804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196816 */     GIR_RootConstrainSelectedInstOperands,
     /* 196817 */     // GIR_Coverage, 8157,
     /* 196817 */     GIR_EraseRootFromParent_Done,
     /* 196818 */   // Label 3065: @196818
     /* 196818 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(196872), // Rule ID 8159 //
     /* 196823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 196826 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 196831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 196846 */     // (atomic_load_and:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_i32>>  =>  (DS_AND_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 196846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B32_gfx9),
     /* 196849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 196851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 196856 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 196858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196870 */     GIR_RootConstrainSelectedInstOperands,
     /* 196871 */     // GIR_Coverage, 8159,
     /* 196871 */     GIR_EraseRootFromParent_Done,
     /* 196872 */   // Label 3066: @196872
     /* 196872 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(196926), // Rule ID 8161 //
     /* 196877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 196880 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 196885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 196900 */     // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_region_m0_i32>>  =>  (DS_AND_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 196900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B32),
     /* 196903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 196905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 196910 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 196912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196924 */     GIR_RootConstrainSelectedInstOperands,
     /* 196925 */     // GIR_Coverage, 8161,
     /* 196925 */     GIR_EraseRootFromParent_Done,
     /* 196926 */   // Label 3067: @196926
     /* 196926 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(196983), // Rule ID 4022 //
     /* 196931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 196934 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196941 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 196954 */     // (atomic_load_and:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (GLOBAL_ATOMIC_AND_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 196954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_SADDR),
     /* 196957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 196962 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 196969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196981 */     GIR_RootConstrainSelectedInstOperands,
     /* 196982 */     // GIR_Coverage, 4022,
     /* 196982 */     GIR_EraseRootFromParent_Done,
     /* 196983 */   // Label 3068: @196983
     /* 196983 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(197044), // Rule ID 4024 //
     /* 196988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 196991 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 197002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 197013 */     // (atomic_load_and:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_i32>>  =>  (GLOBAL_ATOMIC_AND_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 197013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_SADDR_RTN),
     /* 197016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 197023 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 197030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 197035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197042 */     GIR_RootConstrainSelectedInstOperands,
     /* 197043 */     // GIR_Coverage, 4024,
     /* 197043 */     GIR_EraseRootFromParent_Done,
     /* 197044 */   // Label 3069: @197044
     /* 197044 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(197096), // Rule ID 4021 //
     /* 197049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 197052 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197059 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 197072 */     // (atomic_load_and:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (GLOBAL_ATOMIC_AND VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 197072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND),
     /* 197075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197080 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197094 */     GIR_RootConstrainSelectedInstOperands,
     /* 197095 */     // GIR_Coverage, 4021,
     /* 197095 */     GIR_EraseRootFromParent_Done,
     /* 197096 */   // Label 3070: @197096
     /* 197096 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(197152), // Rule ID 4023 //
     /* 197101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 197104 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 197115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 197126 */     // (atomic_load_and:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_i32>>  =>  (GLOBAL_ATOMIC_AND_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 197126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_RTN),
     /* 197129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197136 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197150 */     GIR_RootConstrainSelectedInstOperands,
     /* 197151 */     // GIR_Coverage, 4023,
     /* 197151 */     GIR_EraseRootFromParent_Done,
     /* 197152 */   // Label 3071: @197152
     /* 197152 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(197205), // Rule ID 3672 //
     /* 197157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 197160 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197168 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 197181 */     // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_flat_noret_i32>>  =>  (FLAT_ATOMIC_AND VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 197181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND),
     /* 197184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197189 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197203 */     GIR_RootConstrainSelectedInstOperands,
     /* 197204 */     // GIR_Coverage, 3672,
     /* 197204 */     GIR_EraseRootFromParent_Done,
     /* 197205 */   // Label 3072: @197205
     /* 197205 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(197257), // Rule ID 3732 //
     /* 197210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 197213 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197220 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 197233 */     // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (FLAT_ATOMIC_AND VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 197233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND),
     /* 197236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197241 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197255 */     GIR_RootConstrainSelectedInstOperands,
     /* 197256 */     // GIR_Coverage, 3732,
     /* 197256 */     GIR_EraseRootFromParent_Done,
     /* 197257 */   // Label 3073: @197257
     /* 197257 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(197314), // Rule ID 3671 //
     /* 197262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 197265 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 197277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 197288 */     // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_flat_i32>>  =>  (FLAT_ATOMIC_AND_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 197288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_RTN),
     /* 197291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197298 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197312 */     GIR_RootConstrainSelectedInstOperands,
     /* 197313 */     // GIR_Coverage, 3671,
     /* 197313 */     GIR_EraseRootFromParent_Done,
     /* 197314 */   // Label 3074: @197314
     /* 197314 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(197370), // Rule ID 3731 //
     /* 197319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 197322 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 197333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 197344 */     // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_i32>>  =>  (FLAT_ATOMIC_AND_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 197344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_RTN),
     /* 197347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197354 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197368 */     GIR_RootConstrainSelectedInstOperands,
     /* 197369 */     // GIR_Coverage, 3731,
     /* 197369 */     GIR_EraseRootFromParent_Done,
     /* 197370 */   // Label 3075: @197370
     /* 197370 */   GIM_Reject,
     /* 197371 */ // Label 3053: @197371
     /* 197371 */ GIM_Reject,
     /* 197372 */ // Label 3051: @197372
     /* 197372 */ GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(198617),
     /* 197377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197380 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(197442), // Rule ID 5729 //
     /* 197385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 197388 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197395 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 197408 */     // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_ADDR64),
     /* 197411 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 197418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 197428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 197433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197440 */     GIR_RootConstrainSelectedInstOperands,
     /* 197441 */     // GIR_Coverage, 5729,
     /* 197441 */     GIR_EraseRootFromParent_Done,
     /* 197442 */   // Label 3077: @197442
     /* 197442 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(197501), // Rule ID 5733 //
     /* 197447 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197454 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 197467 */     // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64),
     /* 197470 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 197477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 197487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 197492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197499 */     GIR_RootConstrainSelectedInstOperands,
     /* 197500 */     // GIR_Coverage, 5733,
     /* 197500 */     GIR_EraseRootFromParent_Done,
     /* 197501 */   // Label 3078: @197501
     /* 197501 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(197567), // Rule ID 5727 //
     /* 197506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 197509 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 197531 */     // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_ADDR64_RTN),
     /* 197534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 197536 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 197543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 197553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 197558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197565 */     GIR_RootConstrainSelectedInstOperands,
     /* 197566 */     // GIR_Coverage, 5727,
     /* 197566 */     GIR_EraseRootFromParent_Done,
     /* 197567 */   // Label 3079: @197567
     /* 197567 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(197630), // Rule ID 5731 //
     /* 197572 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 197594 */     // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64_RTN),
     /* 197597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 197599 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 197606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 197616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 197621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197628 */     GIR_RootConstrainSelectedInstOperands,
     /* 197629 */     // GIR_Coverage, 5731,
     /* 197629 */     GIR_EraseRootFromParent_Done,
     /* 197630 */   // Label 3080: @197630
     /* 197630 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(197687), // Rule ID 5728 //
     /* 197635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 197638 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197645 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 197658 */     // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET),
     /* 197661 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 197673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 197678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197685 */     GIR_RootConstrainSelectedInstOperands,
     /* 197686 */     // GIR_Coverage, 5728,
     /* 197686 */     GIR_EraseRootFromParent_Done,
     /* 197687 */   // Label 3081: @197687
     /* 197687 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(197741), // Rule ID 5732 //
     /* 197692 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197699 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 197712 */     // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET),
     /* 197715 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 197727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 197732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197739 */     GIR_RootConstrainSelectedInstOperands,
     /* 197740 */     // GIR_Coverage, 5732,
     /* 197740 */     GIR_EraseRootFromParent_Done,
     /* 197741 */   // Label 3082: @197741
     /* 197741 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(197802), // Rule ID 5726 //
     /* 197746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 197749 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 197771 */     // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET_RTN),
     /* 197774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 197776 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 197788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 197793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197800 */     GIR_RootConstrainSelectedInstOperands,
     /* 197801 */     // GIR_Coverage, 5726,
     /* 197801 */     GIR_EraseRootFromParent_Done,
     /* 197802 */   // Label 3083: @197802
     /* 197802 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(197860), // Rule ID 5730 //
     /* 197807 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 197829 */     // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN),
     /* 197832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 197834 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 197846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 197851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197858 */     GIR_RootConstrainSelectedInstOperands,
     /* 197859 */     // GIR_Coverage, 5730,
     /* 197859 */     GIR_EraseRootFromParent_Done,
     /* 197860 */   // Label 3084: @197860
     /* 197860 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(197910), // Rule ID 8251 //
     /* 197865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 197868 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 197873 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 197886 */     // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_m0_noret_i64>>  =>  (DS_AND_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 197886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B64),
     /* 197889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 197894 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 197896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197908 */     GIR_RootConstrainSelectedInstOperands,
     /* 197909 */     // GIR_Coverage, 8251,
     /* 197909 */     GIR_EraseRootFromParent_Done,
     /* 197910 */   // Label 3085: @197910
     /* 197910 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(197960), // Rule ID 8253 //
     /* 197915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 197918 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 197923 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 197936 */     // (atomic_load_and:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_noret_i64>>  =>  (DS_AND_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 197936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B64_gfx9),
     /* 197939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 197944 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 197946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197958 */     GIR_RootConstrainSelectedInstOperands,
     /* 197959 */     // GIR_Coverage, 8253,
     /* 197959 */     GIR_EraseRootFromParent_Done,
     /* 197960 */   // Label 3086: @197960
     /* 197960 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(198010), // Rule ID 8255 //
     /* 197965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 197968 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 197973 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 197986 */     // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_region_m0_noret_i64>>  =>  (DS_AND_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 197986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B64),
     /* 197989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 197994 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 197996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198008 */     GIR_RootConstrainSelectedInstOperands,
     /* 198009 */     // GIR_Coverage, 8255,
     /* 198009 */     GIR_EraseRootFromParent_Done,
     /* 198010 */   // Label 3087: @198010
     /* 198010 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(198064), // Rule ID 8250 //
     /* 198015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 198018 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 198023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198038 */     // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_m0_i64>>  =>  (DS_AND_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 198038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B64),
     /* 198041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198048 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198062 */     GIR_RootConstrainSelectedInstOperands,
     /* 198063 */     // GIR_Coverage, 8250,
     /* 198063 */     GIR_EraseRootFromParent_Done,
     /* 198064 */   // Label 3088: @198064
     /* 198064 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(198118), // Rule ID 8252 //
     /* 198069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 198072 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 198077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198092 */     // (atomic_load_and:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_i64>>  =>  (DS_AND_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 198092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B64_gfx9),
     /* 198095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198102 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198116 */     GIR_RootConstrainSelectedInstOperands,
     /* 198117 */     // GIR_Coverage, 8252,
     /* 198117 */     GIR_EraseRootFromParent_Done,
     /* 198118 */   // Label 3089: @198118
     /* 198118 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(198172), // Rule ID 8254 //
     /* 198123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 198126 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 198131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198146 */     // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_region_m0_i64>>  =>  (DS_AND_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 198146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B64),
     /* 198149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198156 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198170 */     GIR_RootConstrainSelectedInstOperands,
     /* 198171 */     // GIR_Coverage, 8254,
     /* 198171 */     GIR_EraseRootFromParent_Done,
     /* 198172 */   // Label 3090: @198172
     /* 198172 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(198229), // Rule ID 4078 //
     /* 198177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 198180 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198187 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 198200 */     // (atomic_load_and:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (GLOBAL_ATOMIC_AND_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 198200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2_SADDR),
     /* 198203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 198208 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 198215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 198220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198227 */     GIR_RootConstrainSelectedInstOperands,
     /* 198228 */     // GIR_Coverage, 4078,
     /* 198228 */     GIR_EraseRootFromParent_Done,
     /* 198229 */   // Label 3091: @198229
     /* 198229 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(198290), // Rule ID 4080 //
     /* 198234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 198237 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 198259 */     // (atomic_load_and:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_i64>>  =>  (GLOBAL_ATOMIC_AND_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 198259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2_SADDR_RTN),
     /* 198262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 198269 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 198276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 198281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198288 */     GIR_RootConstrainSelectedInstOperands,
     /* 198289 */     // GIR_Coverage, 4080,
     /* 198289 */     GIR_EraseRootFromParent_Done,
     /* 198290 */   // Label 3092: @198290
     /* 198290 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(198342), // Rule ID 4077 //
     /* 198295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 198298 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198305 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 198318 */     // (atomic_load_and:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (GLOBAL_ATOMIC_AND_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 198318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2),
     /* 198321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198326 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198340 */     GIR_RootConstrainSelectedInstOperands,
     /* 198341 */     // GIR_Coverage, 4077,
     /* 198341 */     GIR_EraseRootFromParent_Done,
     /* 198342 */   // Label 3093: @198342
     /* 198342 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(198398), // Rule ID 4079 //
     /* 198347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 198350 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 198372 */     // (atomic_load_and:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_i64>>  =>  (GLOBAL_ATOMIC_AND_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 198372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2_RTN),
     /* 198375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198382 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198396 */     GIR_RootConstrainSelectedInstOperands,
     /* 198397 */     // GIR_Coverage, 4079,
     /* 198397 */     GIR_EraseRootFromParent_Done,
     /* 198398 */   // Label 3094: @198398
     /* 198398 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(198451), // Rule ID 3698 //
     /* 198403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 198406 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198414 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 198427 */     // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_flat_noret_i64>>  =>  (FLAT_ATOMIC_AND_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 198427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2),
     /* 198430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198435 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198449 */     GIR_RootConstrainSelectedInstOperands,
     /* 198450 */     // GIR_Coverage, 3698,
     /* 198450 */     GIR_EraseRootFromParent_Done,
     /* 198451 */   // Label 3095: @198451
     /* 198451 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(198503), // Rule ID 3758 //
     /* 198456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 198459 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198466 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 198479 */     // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (FLAT_ATOMIC_AND_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 198479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2),
     /* 198482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198487 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198501 */     GIR_RootConstrainSelectedInstOperands,
     /* 198502 */     // GIR_Coverage, 3758,
     /* 198502 */     GIR_EraseRootFromParent_Done,
     /* 198503 */   // Label 3096: @198503
     /* 198503 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(198560), // Rule ID 3697 //
     /* 198508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 198511 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 198534 */     // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_flat_i64>>  =>  (FLAT_ATOMIC_AND_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 198534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2_RTN),
     /* 198537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198544 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198558 */     GIR_RootConstrainSelectedInstOperands,
     /* 198559 */     // GIR_Coverage, 3697,
     /* 198559 */     GIR_EraseRootFromParent_Done,
     /* 198560 */   // Label 3097: @198560
     /* 198560 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(198616), // Rule ID 3757 //
     /* 198565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 198568 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 198579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 198590 */     // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_i64>>  =>  (FLAT_ATOMIC_AND_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 198590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2_RTN),
     /* 198593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198600 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198614 */     GIR_RootConstrainSelectedInstOperands,
     /* 198615 */     // GIR_Coverage, 3757,
     /* 198615 */     GIR_EraseRootFromParent_Done,
     /* 198616 */   // Label 3098: @198616
     /* 198616 */   GIM_Reject,
     /* 198617 */ // Label 3076: @198617
     /* 198617 */ GIM_Reject,
     /* 198618 */ // Label 3052: @198618
     /* 198618 */ GIM_Reject,
     /* 198619 */ // Label 23: @198619
     /* 198619 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3101*/ GIMT_Encode4(201130),
     /* 198630 */ /*GILLT_s32*//*Label 3099*/ GIMT_Encode4(198638),
     /* 198634 */ /*GILLT_s64*//*Label 3100*/ GIMT_Encode4(199884),
     /* 198638 */ // Label 3099: @198638
     /* 198638 */ GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(199883),
     /* 198643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198646 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(198708), // Rule ID 5641 //
     /* 198651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 198654 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198661 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 198674 */     // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_ADDR64),
     /* 198677 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 198684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 198694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 198699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198706 */     GIR_RootConstrainSelectedInstOperands,
     /* 198707 */     // GIR_Coverage, 5641,
     /* 198707 */     GIR_EraseRootFromParent_Done,
     /* 198708 */   // Label 3103: @198708
     /* 198708 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(198767), // Rule ID 5645 //
     /* 198713 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198720 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 198733 */     // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_ADDR64),
     /* 198736 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 198743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 198753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 198758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198765 */     GIR_RootConstrainSelectedInstOperands,
     /* 198766 */     // GIR_Coverage, 5645,
     /* 198766 */     GIR_EraseRootFromParent_Done,
     /* 198767 */   // Label 3104: @198767
     /* 198767 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(198833), // Rule ID 5639 //
     /* 198772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 198775 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 198786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 198797 */     // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_ADDR64_RTN),
     /* 198800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 198802 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 198809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 198819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 198824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198831 */     GIR_RootConstrainSelectedInstOperands,
     /* 198832 */     // GIR_Coverage, 5639,
     /* 198832 */     GIR_EraseRootFromParent_Done,
     /* 198833 */   // Label 3105: @198833
     /* 198833 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(198896), // Rule ID 5643 //
     /* 198838 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 198849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 198860 */     // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_ADDR64_RTN),
     /* 198863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 198865 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 198872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 198882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 198887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198894 */     GIR_RootConstrainSelectedInstOperands,
     /* 198895 */     // GIR_Coverage, 5643,
     /* 198895 */     GIR_EraseRootFromParent_Done,
     /* 198896 */   // Label 3106: @198896
     /* 198896 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(198953), // Rule ID 5640 //
     /* 198901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 198904 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198911 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 198924 */     // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET),
     /* 198927 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 198939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 198944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198951 */     GIR_RootConstrainSelectedInstOperands,
     /* 198952 */     // GIR_Coverage, 5640,
     /* 198952 */     GIR_EraseRootFromParent_Done,
     /* 198953 */   // Label 3107: @198953
     /* 198953 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(199007), // Rule ID 5644 //
     /* 198958 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198965 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 198978 */     // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET),
     /* 198981 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 198993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 198998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199005 */     GIR_RootConstrainSelectedInstOperands,
     /* 199006 */     // GIR_Coverage, 5644,
     /* 199006 */     GIR_EraseRootFromParent_Done,
     /* 199007 */   // Label 3108: @199007
     /* 199007 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(199068), // Rule ID 5638 //
     /* 199012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 199015 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 199037 */     // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET_RTN),
     /* 199040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 199042 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 199054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199066 */     GIR_RootConstrainSelectedInstOperands,
     /* 199067 */     // GIR_Coverage, 5638,
     /* 199067 */     GIR_EraseRootFromParent_Done,
     /* 199068 */   // Label 3109: @199068
     /* 199068 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(199126), // Rule ID 5642 //
     /* 199073 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 199095 */     // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN),
     /* 199098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 199100 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 199112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199124 */     GIR_RootConstrainSelectedInstOperands,
     /* 199125 */     // GIR_Coverage, 5642,
     /* 199125 */     GIR_EraseRootFromParent_Done,
     /* 199126 */   // Label 3110: @199126
     /* 199126 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(199176), // Rule ID 8164 //
     /* 199131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 199134 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 199139 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199152 */     // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_m0_noret_i32>>  =>  (DS_OR_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 199152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B32),
     /* 199155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199160 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199174 */     GIR_RootConstrainSelectedInstOperands,
     /* 199175 */     // GIR_Coverage, 8164,
     /* 199175 */     GIR_EraseRootFromParent_Done,
     /* 199176 */   // Label 3111: @199176
     /* 199176 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(199226), // Rule ID 8166 //
     /* 199181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 199184 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 199189 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199202 */     // (atomic_load_or:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_noret_i32>>  =>  (DS_OR_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 199202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B32_gfx9),
     /* 199205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199210 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199224 */     GIR_RootConstrainSelectedInstOperands,
     /* 199225 */     // GIR_Coverage, 8166,
     /* 199225 */     GIR_EraseRootFromParent_Done,
     /* 199226 */   // Label 3112: @199226
     /* 199226 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(199276), // Rule ID 8168 //
     /* 199231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 199234 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 199239 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199252 */     // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_region_m0_noret_i32>>  =>  (DS_OR_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 199252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B32),
     /* 199255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199260 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199274 */     GIR_RootConstrainSelectedInstOperands,
     /* 199275 */     // GIR_Coverage, 8168,
     /* 199275 */     GIR_EraseRootFromParent_Done,
     /* 199276 */   // Label 3113: @199276
     /* 199276 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(199330), // Rule ID 8163 //
     /* 199281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 199284 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 199289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199304 */     // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_m0_i32>>  =>  (DS_OR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 199304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B32),
     /* 199307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199314 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199328 */     GIR_RootConstrainSelectedInstOperands,
     /* 199329 */     // GIR_Coverage, 8163,
     /* 199329 */     GIR_EraseRootFromParent_Done,
     /* 199330 */   // Label 3114: @199330
     /* 199330 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(199384), // Rule ID 8165 //
     /* 199335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 199338 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 199343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199358 */     // (atomic_load_or:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_i32>>  =>  (DS_OR_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 199358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B32_gfx9),
     /* 199361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199368 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199382 */     GIR_RootConstrainSelectedInstOperands,
     /* 199383 */     // GIR_Coverage, 8165,
     /* 199383 */     GIR_EraseRootFromParent_Done,
     /* 199384 */   // Label 3115: @199384
     /* 199384 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(199438), // Rule ID 8167 //
     /* 199389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 199392 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 199397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199412 */     // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_region_m0_i32>>  =>  (DS_OR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 199412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B32),
     /* 199415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199422 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199436 */     GIR_RootConstrainSelectedInstOperands,
     /* 199437 */     // GIR_Coverage, 8167,
     /* 199437 */     GIR_EraseRootFromParent_Done,
     /* 199438 */   // Label 3116: @199438
     /* 199438 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(199495), // Rule ID 4042 //
     /* 199443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 199446 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199453 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 199466 */     // (atomic_load_or:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (GLOBAL_ATOMIC_OR_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 199466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_SADDR),
     /* 199469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 199474 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 199481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199493 */     GIR_RootConstrainSelectedInstOperands,
     /* 199494 */     // GIR_Coverage, 4042,
     /* 199494 */     GIR_EraseRootFromParent_Done,
     /* 199495 */   // Label 3117: @199495
     /* 199495 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(199556), // Rule ID 4044 //
     /* 199500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 199503 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 199525 */     // (atomic_load_or:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_i32>>  =>  (GLOBAL_ATOMIC_OR_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 199525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_SADDR_RTN),
     /* 199528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 199535 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 199542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199554 */     GIR_RootConstrainSelectedInstOperands,
     /* 199555 */     // GIR_Coverage, 4044,
     /* 199555 */     GIR_EraseRootFromParent_Done,
     /* 199556 */   // Label 3118: @199556
     /* 199556 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(199608), // Rule ID 4041 //
     /* 199561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 199564 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199571 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 199584 */     // (atomic_load_or:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (GLOBAL_ATOMIC_OR VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 199584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR),
     /* 199587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199592 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199606 */     GIR_RootConstrainSelectedInstOperands,
     /* 199607 */     // GIR_Coverage, 4041,
     /* 199607 */     GIR_EraseRootFromParent_Done,
     /* 199608 */   // Label 3119: @199608
     /* 199608 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(199664), // Rule ID 4043 //
     /* 199613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 199616 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 199638 */     // (atomic_load_or:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_i32>>  =>  (GLOBAL_ATOMIC_OR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 199638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_RTN),
     /* 199641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199648 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199662 */     GIR_RootConstrainSelectedInstOperands,
     /* 199663 */     // GIR_Coverage, 4043,
     /* 199663 */     GIR_EraseRootFromParent_Done,
     /* 199664 */   // Label 3120: @199664
     /* 199664 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(199717), // Rule ID 3682 //
     /* 199669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 199672 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199680 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 199693 */     // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_flat_noret_i32>>  =>  (FLAT_ATOMIC_OR VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 199693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR),
     /* 199696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199701 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199715 */     GIR_RootConstrainSelectedInstOperands,
     /* 199716 */     // GIR_Coverage, 3682,
     /* 199716 */     GIR_EraseRootFromParent_Done,
     /* 199717 */   // Label 3121: @199717
     /* 199717 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(199769), // Rule ID 3742 //
     /* 199722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 199725 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199732 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 199745 */     // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (FLAT_ATOMIC_OR VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 199745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR),
     /* 199748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199753 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199767 */     GIR_RootConstrainSelectedInstOperands,
     /* 199768 */     // GIR_Coverage, 3742,
     /* 199768 */     GIR_EraseRootFromParent_Done,
     /* 199769 */   // Label 3122: @199769
     /* 199769 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(199826), // Rule ID 3681 //
     /* 199774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 199777 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 199800 */     // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_flat_i32>>  =>  (FLAT_ATOMIC_OR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 199800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_RTN),
     /* 199803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199810 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199824 */     GIR_RootConstrainSelectedInstOperands,
     /* 199825 */     // GIR_Coverage, 3681,
     /* 199825 */     GIR_EraseRootFromParent_Done,
     /* 199826 */   // Label 3123: @199826
     /* 199826 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(199882), // Rule ID 3741 //
     /* 199831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 199834 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 199845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 199856 */     // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_i32>>  =>  (FLAT_ATOMIC_OR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 199856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_RTN),
     /* 199859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199866 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199880 */     GIR_RootConstrainSelectedInstOperands,
     /* 199881 */     // GIR_Coverage, 3741,
     /* 199881 */     GIR_EraseRootFromParent_Done,
     /* 199882 */   // Label 3124: @199882
     /* 199882 */   GIM_Reject,
     /* 199883 */ // Label 3102: @199883
     /* 199883 */ GIM_Reject,
     /* 199884 */ // Label 3100: @199884
     /* 199884 */ GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(201129),
     /* 199889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199892 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(199954), // Rule ID 5737 //
     /* 199897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 199900 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199907 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 199920 */     // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_ADDR64),
     /* 199923 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 199930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 199940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 199945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199952 */     GIR_RootConstrainSelectedInstOperands,
     /* 199953 */     // GIR_Coverage, 5737,
     /* 199953 */     GIR_EraseRootFromParent_Done,
     /* 199954 */   // Label 3126: @199954
     /* 199954 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(200013), // Rule ID 5741 //
     /* 199959 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199966 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 199979 */     // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64),
     /* 199982 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 199989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 199999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 200004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200011 */     GIR_RootConstrainSelectedInstOperands,
     /* 200012 */     // GIR_Coverage, 5741,
     /* 200012 */     GIR_EraseRootFromParent_Done,
     /* 200013 */   // Label 3127: @200013
     /* 200013 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(200079), // Rule ID 5735 //
     /* 200018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 200021 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 200043 */     // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_ADDR64_RTN),
     /* 200046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 200048 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 200055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 200065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 200070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200077 */     GIR_RootConstrainSelectedInstOperands,
     /* 200078 */     // GIR_Coverage, 5735,
     /* 200078 */     GIR_EraseRootFromParent_Done,
     /* 200079 */   // Label 3128: @200079
     /* 200079 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(200142), // Rule ID 5739 //
     /* 200084 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 200106 */     // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64_RTN),
     /* 200109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 200111 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 200118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 200128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 200133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200140 */     GIR_RootConstrainSelectedInstOperands,
     /* 200141 */     // GIR_Coverage, 5739,
     /* 200141 */     GIR_EraseRootFromParent_Done,
     /* 200142 */   // Label 3129: @200142
     /* 200142 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(200199), // Rule ID 5736 //
     /* 200147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 200150 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200157 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 200170 */     // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET),
     /* 200173 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 200185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200197 */     GIR_RootConstrainSelectedInstOperands,
     /* 200198 */     // GIR_Coverage, 5736,
     /* 200198 */     GIR_EraseRootFromParent_Done,
     /* 200199 */   // Label 3130: @200199
     /* 200199 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(200253), // Rule ID 5740 //
     /* 200204 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200211 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 200224 */     // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET),
     /* 200227 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 200239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200251 */     GIR_RootConstrainSelectedInstOperands,
     /* 200252 */     // GIR_Coverage, 5740,
     /* 200252 */     GIR_EraseRootFromParent_Done,
     /* 200253 */   // Label 3131: @200253
     /* 200253 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(200314), // Rule ID 5734 //
     /* 200258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 200261 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 200283 */     // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET_RTN),
     /* 200286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 200288 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 200300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200312 */     GIR_RootConstrainSelectedInstOperands,
     /* 200313 */     // GIR_Coverage, 5734,
     /* 200313 */     GIR_EraseRootFromParent_Done,
     /* 200314 */   // Label 3132: @200314
     /* 200314 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(200372), // Rule ID 5738 //
     /* 200319 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 200341 */     // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN),
     /* 200344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 200346 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 200358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200370 */     GIR_RootConstrainSelectedInstOperands,
     /* 200371 */     // GIR_Coverage, 5738,
     /* 200371 */     GIR_EraseRootFromParent_Done,
     /* 200372 */   // Label 3133: @200372
     /* 200372 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(200422), // Rule ID 8257 //
     /* 200377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 200380 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 200385 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200398 */     // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_m0_noret_i64>>  =>  (DS_OR_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 200398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B64),
     /* 200401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200406 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200420 */     GIR_RootConstrainSelectedInstOperands,
     /* 200421 */     // GIR_Coverage, 8257,
     /* 200421 */     GIR_EraseRootFromParent_Done,
     /* 200422 */   // Label 3134: @200422
     /* 200422 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(200472), // Rule ID 8259 //
     /* 200427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 200430 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 200435 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200448 */     // (atomic_load_or:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_noret_i64>>  =>  (DS_OR_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 200448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B64_gfx9),
     /* 200451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200456 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200470 */     GIR_RootConstrainSelectedInstOperands,
     /* 200471 */     // GIR_Coverage, 8259,
     /* 200471 */     GIR_EraseRootFromParent_Done,
     /* 200472 */   // Label 3135: @200472
     /* 200472 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(200522), // Rule ID 8261 //
     /* 200477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 200480 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 200485 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200498 */     // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_region_m0_noret_i64>>  =>  (DS_OR_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 200498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B64),
     /* 200501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200506 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200520 */     GIR_RootConstrainSelectedInstOperands,
     /* 200521 */     // GIR_Coverage, 8261,
     /* 200521 */     GIR_EraseRootFromParent_Done,
     /* 200522 */   // Label 3136: @200522
     /* 200522 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(200576), // Rule ID 8256 //
     /* 200527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 200530 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 200535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200550 */     // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_m0_i64>>  =>  (DS_OR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 200550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B64),
     /* 200553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200560 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200574 */     GIR_RootConstrainSelectedInstOperands,
     /* 200575 */     // GIR_Coverage, 8256,
     /* 200575 */     GIR_EraseRootFromParent_Done,
     /* 200576 */   // Label 3137: @200576
     /* 200576 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(200630), // Rule ID 8258 //
     /* 200581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 200584 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 200589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200604 */     // (atomic_load_or:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_i64>>  =>  (DS_OR_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 200604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B64_gfx9),
     /* 200607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200614 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200628 */     GIR_RootConstrainSelectedInstOperands,
     /* 200629 */     // GIR_Coverage, 8258,
     /* 200629 */     GIR_EraseRootFromParent_Done,
     /* 200630 */   // Label 3138: @200630
     /* 200630 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(200684), // Rule ID 8260 //
     /* 200635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 200638 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 200643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200658 */     // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_region_m0_i64>>  =>  (DS_OR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 200658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B64),
     /* 200661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200668 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200682 */     GIR_RootConstrainSelectedInstOperands,
     /* 200683 */     // GIR_Coverage, 8260,
     /* 200683 */     GIR_EraseRootFromParent_Done,
     /* 200684 */   // Label 3139: @200684
     /* 200684 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(200741), // Rule ID 4098 //
     /* 200689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 200692 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200699 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 200712 */     // (atomic_load_or:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (GLOBAL_ATOMIC_OR_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 200712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2_SADDR),
     /* 200715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 200720 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 200722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 200727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200739 */     GIR_RootConstrainSelectedInstOperands,
     /* 200740 */     // GIR_Coverage, 4098,
     /* 200740 */     GIR_EraseRootFromParent_Done,
     /* 200741 */   // Label 3140: @200741
     /* 200741 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(200802), // Rule ID 4100 //
     /* 200746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 200749 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 200771 */     // (atomic_load_or:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_i64>>  =>  (GLOBAL_ATOMIC_OR_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 200771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2_SADDR_RTN),
     /* 200774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 200781 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 200783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 200788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200800 */     GIR_RootConstrainSelectedInstOperands,
     /* 200801 */     // GIR_Coverage, 4100,
     /* 200801 */     GIR_EraseRootFromParent_Done,
     /* 200802 */   // Label 3141: @200802
     /* 200802 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(200854), // Rule ID 4097 //
     /* 200807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 200810 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200817 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 200830 */     // (atomic_load_or:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (GLOBAL_ATOMIC_OR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 200830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2),
     /* 200833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 200838 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 200840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200852 */     GIR_RootConstrainSelectedInstOperands,
     /* 200853 */     // GIR_Coverage, 4097,
     /* 200853 */     GIR_EraseRootFromParent_Done,
     /* 200854 */   // Label 3142: @200854
     /* 200854 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(200910), // Rule ID 4099 //
     /* 200859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 200862 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 200884 */     // (atomic_load_or:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_i64>>  =>  (GLOBAL_ATOMIC_OR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 200884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2_RTN),
     /* 200887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 200894 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 200896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200908 */     GIR_RootConstrainSelectedInstOperands,
     /* 200909 */     // GIR_Coverage, 4099,
     /* 200909 */     GIR_EraseRootFromParent_Done,
     /* 200910 */   // Label 3143: @200910
     /* 200910 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(200963), // Rule ID 3708 //
     /* 200915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 200918 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200926 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 200939 */     // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_flat_noret_i64>>  =>  (FLAT_ATOMIC_OR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 200939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2),
     /* 200942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 200947 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 200949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200961 */     GIR_RootConstrainSelectedInstOperands,
     /* 200962 */     // GIR_Coverage, 3708,
     /* 200962 */     GIR_EraseRootFromParent_Done,
     /* 200963 */   // Label 3144: @200963
     /* 200963 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(201015), // Rule ID 3768 //
     /* 200968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 200971 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200978 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 200991 */     // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (FLAT_ATOMIC_OR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 200991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2),
     /* 200994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 200999 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201013 */     GIR_RootConstrainSelectedInstOperands,
     /* 201014 */     // GIR_Coverage, 3768,
     /* 201014 */     GIR_EraseRootFromParent_Done,
     /* 201015 */   // Label 3145: @201015
     /* 201015 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(201072), // Rule ID 3707 //
     /* 201020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 201023 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 201035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 201046 */     // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_flat_i64>>  =>  (FLAT_ATOMIC_OR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 201046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2_RTN),
     /* 201049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 201051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201056 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201070 */     GIR_RootConstrainSelectedInstOperands,
     /* 201071 */     // GIR_Coverage, 3707,
     /* 201071 */     GIR_EraseRootFromParent_Done,
     /* 201072 */   // Label 3146: @201072
     /* 201072 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(201128), // Rule ID 3767 //
     /* 201077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 201080 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 201091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 201102 */     // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_i64>>  =>  (FLAT_ATOMIC_OR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 201102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2_RTN),
     /* 201105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 201107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201112 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201126 */     GIR_RootConstrainSelectedInstOperands,
     /* 201127 */     // GIR_Coverage, 3767,
     /* 201127 */     GIR_EraseRootFromParent_Done,
     /* 201128 */   // Label 3147: @201128
     /* 201128 */   GIM_Reject,
     /* 201129 */ // Label 3125: @201129
     /* 201129 */ GIM_Reject,
     /* 201130 */ // Label 3101: @201130
     /* 201130 */ GIM_Reject,
     /* 201131 */ // Label 24: @201131
     /* 201131 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3150*/ GIMT_Encode4(203642),
     /* 201142 */ /*GILLT_s32*//*Label 3148*/ GIMT_Encode4(201150),
     /* 201146 */ /*GILLT_s64*//*Label 3149*/ GIMT_Encode4(202396),
     /* 201150 */ // Label 3148: @201150
     /* 201150 */ GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(202395),
     /* 201155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201158 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(201220), // Rule ID 5649 //
     /* 201163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 201166 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201173 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 201186 */     // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_ADDR64),
     /* 201189 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 201196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 201206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 201211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201218 */     GIR_RootConstrainSelectedInstOperands,
     /* 201219 */     // GIR_Coverage, 5649,
     /* 201219 */     GIR_EraseRootFromParent_Done,
     /* 201220 */   // Label 3152: @201220
     /* 201220 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(201279), // Rule ID 5653 //
     /* 201225 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201232 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 201245 */     // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_ADDR64),
     /* 201248 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 201255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 201265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 201270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201277 */     GIR_RootConstrainSelectedInstOperands,
     /* 201278 */     // GIR_Coverage, 5653,
     /* 201278 */     GIR_EraseRootFromParent_Done,
     /* 201279 */   // Label 3153: @201279
     /* 201279 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(201345), // Rule ID 5647 //
     /* 201284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 201287 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 201309 */     // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_ADDR64_RTN),
     /* 201312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 201314 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 201321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 201331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 201336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201343 */     GIR_RootConstrainSelectedInstOperands,
     /* 201344 */     // GIR_Coverage, 5647,
     /* 201344 */     GIR_EraseRootFromParent_Done,
     /* 201345 */   // Label 3154: @201345
     /* 201345 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(201408), // Rule ID 5651 //
     /* 201350 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 201372 */     // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_ADDR64_RTN),
     /* 201375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 201377 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 201384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 201394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 201399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201406 */     GIR_RootConstrainSelectedInstOperands,
     /* 201407 */     // GIR_Coverage, 5651,
     /* 201407 */     GIR_EraseRootFromParent_Done,
     /* 201408 */   // Label 3155: @201408
     /* 201408 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(201465), // Rule ID 5648 //
     /* 201413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 201416 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201423 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 201436 */     // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET),
     /* 201439 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 201451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201463 */     GIR_RootConstrainSelectedInstOperands,
     /* 201464 */     // GIR_Coverage, 5648,
     /* 201464 */     GIR_EraseRootFromParent_Done,
     /* 201465 */   // Label 3156: @201465
     /* 201465 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(201519), // Rule ID 5652 //
     /* 201470 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201477 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 201490 */     // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET),
     /* 201493 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 201505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201517 */     GIR_RootConstrainSelectedInstOperands,
     /* 201518 */     // GIR_Coverage, 5652,
     /* 201518 */     GIR_EraseRootFromParent_Done,
     /* 201519 */   // Label 3157: @201519
     /* 201519 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(201580), // Rule ID 5646 //
     /* 201524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 201527 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 201549 */     // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET_RTN),
     /* 201552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 201554 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 201566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201578 */     GIR_RootConstrainSelectedInstOperands,
     /* 201579 */     // GIR_Coverage, 5646,
     /* 201579 */     GIR_EraseRootFromParent_Done,
     /* 201580 */   // Label 3158: @201580
     /* 201580 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(201638), // Rule ID 5650 //
     /* 201585 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 201607 */     // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN),
     /* 201610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 201612 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 201624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201636 */     GIR_RootConstrainSelectedInstOperands,
     /* 201637 */     // GIR_Coverage, 5650,
     /* 201637 */     GIR_EraseRootFromParent_Done,
     /* 201638 */   // Label 3159: @201638
     /* 201638 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(201688), // Rule ID 8170 //
     /* 201643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 201646 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 201651 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 201664 */     // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_m0_noret_i32>>  =>  (DS_XOR_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 201664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B32),
     /* 201667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 201672 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 201674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201686 */     GIR_RootConstrainSelectedInstOperands,
     /* 201687 */     // GIR_Coverage, 8170,
     /* 201687 */     GIR_EraseRootFromParent_Done,
     /* 201688 */   // Label 3160: @201688
     /* 201688 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(201738), // Rule ID 8172 //
     /* 201693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 201696 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 201701 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 201714 */     // (atomic_load_xor:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_noret_i32>>  =>  (DS_XOR_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 201714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B32_gfx9),
     /* 201717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 201722 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 201724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201736 */     GIR_RootConstrainSelectedInstOperands,
     /* 201737 */     // GIR_Coverage, 8172,
     /* 201737 */     GIR_EraseRootFromParent_Done,
     /* 201738 */   // Label 3161: @201738
     /* 201738 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(201788), // Rule ID 8174 //
     /* 201743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 201746 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 201751 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 201764 */     // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_region_m0_noret_i32>>  =>  (DS_XOR_B32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 201764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B32),
     /* 201767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 201772 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 201774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201786 */     GIR_RootConstrainSelectedInstOperands,
     /* 201787 */     // GIR_Coverage, 8174,
     /* 201787 */     GIR_EraseRootFromParent_Done,
     /* 201788 */   // Label 3162: @201788
     /* 201788 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(201842), // Rule ID 8169 //
     /* 201793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 201796 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 201801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 201816 */     // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_m0_i32>>  =>  (DS_XOR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 201816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B32),
     /* 201819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 201821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 201826 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 201828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201840 */     GIR_RootConstrainSelectedInstOperands,
     /* 201841 */     // GIR_Coverage, 8169,
     /* 201841 */     GIR_EraseRootFromParent_Done,
     /* 201842 */   // Label 3163: @201842
     /* 201842 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(201896), // Rule ID 8171 //
     /* 201847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 201850 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 201855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 201870 */     // (atomic_load_xor:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_i32>>  =>  (DS_XOR_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 201870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B32_gfx9),
     /* 201873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 201875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 201880 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 201882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201894 */     GIR_RootConstrainSelectedInstOperands,
     /* 201895 */     // GIR_Coverage, 8171,
     /* 201895 */     GIR_EraseRootFromParent_Done,
     /* 201896 */   // Label 3164: @201896
     /* 201896 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(201950), // Rule ID 8173 //
     /* 201901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 201904 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 201909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 201924 */     // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_region_m0_i32>>  =>  (DS_XOR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 201924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B32),
     /* 201927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 201929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 201934 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 201936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201948 */     GIR_RootConstrainSelectedInstOperands,
     /* 201949 */     // GIR_Coverage, 8173,
     /* 201949 */     GIR_EraseRootFromParent_Done,
     /* 201950 */   // Label 3165: @201950
     /* 201950 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(202007), // Rule ID 4054 //
     /* 201955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 201958 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201965 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 201978 */     // (atomic_load_xor:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (GLOBAL_ATOMIC_XOR_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 201978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_SADDR),
     /* 201981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 201986 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 201993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202005 */     GIR_RootConstrainSelectedInstOperands,
     /* 202006 */     // GIR_Coverage, 4054,
     /* 202006 */     GIR_EraseRootFromParent_Done,
     /* 202007 */   // Label 3166: @202007
     /* 202007 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(202068), // Rule ID 4056 //
     /* 202012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 202015 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 202026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 202037 */     // (atomic_load_xor:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (GLOBAL_ATOMIC_XOR_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 202037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_SADDR_RTN),
     /* 202040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 202047 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 202054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 202059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202066 */     GIR_RootConstrainSelectedInstOperands,
     /* 202067 */     // GIR_Coverage, 4056,
     /* 202067 */     GIR_EraseRootFromParent_Done,
     /* 202068 */   // Label 3167: @202068
     /* 202068 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(202120), // Rule ID 4053 //
     /* 202073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 202076 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202083 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 202096 */     // (atomic_load_xor:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (GLOBAL_ATOMIC_XOR VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 202096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR),
     /* 202099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202104 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202118 */     GIR_RootConstrainSelectedInstOperands,
     /* 202119 */     // GIR_Coverage, 4053,
     /* 202119 */     GIR_EraseRootFromParent_Done,
     /* 202120 */   // Label 3168: @202120
     /* 202120 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(202176), // Rule ID 4055 //
     /* 202125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 202128 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 202139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 202150 */     // (atomic_load_xor:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (GLOBAL_ATOMIC_XOR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 202150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_RTN),
     /* 202153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202160 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202174 */     GIR_RootConstrainSelectedInstOperands,
     /* 202175 */     // GIR_Coverage, 4055,
     /* 202175 */     GIR_EraseRootFromParent_Done,
     /* 202176 */   // Label 3169: @202176
     /* 202176 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(202229), // Rule ID 3688 //
     /* 202181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 202184 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202192 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 202205 */     // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_flat_noret_i32>>  =>  (FLAT_ATOMIC_XOR VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 202205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR),
     /* 202208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202213 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202227 */     GIR_RootConstrainSelectedInstOperands,
     /* 202228 */     // GIR_Coverage, 3688,
     /* 202228 */     GIR_EraseRootFromParent_Done,
     /* 202229 */   // Label 3170: @202229
     /* 202229 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(202281), // Rule ID 3748 //
     /* 202234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 202237 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202244 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 202257 */     // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (FLAT_ATOMIC_XOR VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 202257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR),
     /* 202260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202265 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202279 */     GIR_RootConstrainSelectedInstOperands,
     /* 202280 */     // GIR_Coverage, 3748,
     /* 202280 */     GIR_EraseRootFromParent_Done,
     /* 202281 */   // Label 3171: @202281
     /* 202281 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(202338), // Rule ID 3687 //
     /* 202286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 202289 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 202301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 202312 */     // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_flat_i32>>  =>  (FLAT_ATOMIC_XOR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 202312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_RTN),
     /* 202315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202322 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202336 */     GIR_RootConstrainSelectedInstOperands,
     /* 202337 */     // GIR_Coverage, 3687,
     /* 202337 */     GIR_EraseRootFromParent_Done,
     /* 202338 */   // Label 3172: @202338
     /* 202338 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(202394), // Rule ID 3747 //
     /* 202343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 202346 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 202357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 202368 */     // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (FLAT_ATOMIC_XOR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 202368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_RTN),
     /* 202371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202378 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202392 */     GIR_RootConstrainSelectedInstOperands,
     /* 202393 */     // GIR_Coverage, 3747,
     /* 202393 */     GIR_EraseRootFromParent_Done,
     /* 202394 */   // Label 3173: @202394
     /* 202394 */   GIM_Reject,
     /* 202395 */ // Label 3151: @202395
     /* 202395 */ GIM_Reject,
     /* 202396 */ // Label 3149: @202396
     /* 202396 */ GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(203641),
     /* 202401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202404 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(202466), // Rule ID 5745 //
     /* 202409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 202412 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202419 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 202432 */     // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_ADDR64),
     /* 202435 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 202442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 202452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 202457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202464 */     GIR_RootConstrainSelectedInstOperands,
     /* 202465 */     // GIR_Coverage, 5745,
     /* 202465 */     GIR_EraseRootFromParent_Done,
     /* 202466 */   // Label 3175: @202466
     /* 202466 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(202525), // Rule ID 5749 //
     /* 202471 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202478 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 202491 */     // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64),
     /* 202494 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 202501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 202511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 202516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202523 */     GIR_RootConstrainSelectedInstOperands,
     /* 202524 */     // GIR_Coverage, 5749,
     /* 202524 */     GIR_EraseRootFromParent_Done,
     /* 202525 */   // Label 3176: @202525
     /* 202525 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(202591), // Rule ID 5743 //
     /* 202530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 202533 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 202544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 202555 */     // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_ADDR64_RTN),
     /* 202558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 202560 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 202567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 202577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 202582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202589 */     GIR_RootConstrainSelectedInstOperands,
     /* 202590 */     // GIR_Coverage, 5743,
     /* 202590 */     GIR_EraseRootFromParent_Done,
     /* 202591 */   // Label 3177: @202591
     /* 202591 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(202654), // Rule ID 5747 //
     /* 202596 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 202607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 202618 */     // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64_RTN),
     /* 202621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 202623 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 202630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 202640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 202645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202652 */     GIR_RootConstrainSelectedInstOperands,
     /* 202653 */     // GIR_Coverage, 5747,
     /* 202653 */     GIR_EraseRootFromParent_Done,
     /* 202654 */   // Label 3178: @202654
     /* 202654 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(202711), // Rule ID 5744 //
     /* 202659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 202662 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202669 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 202682 */     // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET),
     /* 202685 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 202697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 202702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202709 */     GIR_RootConstrainSelectedInstOperands,
     /* 202710 */     // GIR_Coverage, 5744,
     /* 202710 */     GIR_EraseRootFromParent_Done,
     /* 202711 */   // Label 3179: @202711
     /* 202711 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(202765), // Rule ID 5748 //
     /* 202716 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202723 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 202736 */     // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET),
     /* 202739 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 202751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 202756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202763 */     GIR_RootConstrainSelectedInstOperands,
     /* 202764 */     // GIR_Coverage, 5748,
     /* 202764 */     GIR_EraseRootFromParent_Done,
     /* 202765 */   // Label 3180: @202765
     /* 202765 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(202826), // Rule ID 5742 //
     /* 202770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 202773 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 202784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 202795 */     // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET_RTN),
     /* 202798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 202800 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 202812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 202817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202824 */     GIR_RootConstrainSelectedInstOperands,
     /* 202825 */     // GIR_Coverage, 5742,
     /* 202825 */     GIR_EraseRootFromParent_Done,
     /* 202826 */   // Label 3181: @202826
     /* 202826 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(202884), // Rule ID 5746 //
     /* 202831 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 202842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 202853 */     // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN),
     /* 202856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 202858 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 202870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 202875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202882 */     GIR_RootConstrainSelectedInstOperands,
     /* 202883 */     // GIR_Coverage, 5746,
     /* 202883 */     GIR_EraseRootFromParent_Done,
     /* 202884 */   // Label 3182: @202884
     /* 202884 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(202934), // Rule ID 8263 //
     /* 202889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 202892 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 202897 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 202910 */     // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_m0_noret_i64>>  =>  (DS_XOR_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 202910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B64),
     /* 202913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 202918 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 202920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202932 */     GIR_RootConstrainSelectedInstOperands,
     /* 202933 */     // GIR_Coverage, 8263,
     /* 202933 */     GIR_EraseRootFromParent_Done,
     /* 202934 */   // Label 3183: @202934
     /* 202934 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(202984), // Rule ID 8265 //
     /* 202939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 202942 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 202947 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 202960 */     // (atomic_load_xor:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_noret_i64>>  =>  (DS_XOR_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 202960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B64_gfx9),
     /* 202963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 202968 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 202970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202982 */     GIR_RootConstrainSelectedInstOperands,
     /* 202983 */     // GIR_Coverage, 8265,
     /* 202983 */     GIR_EraseRootFromParent_Done,
     /* 202984 */   // Label 3184: @202984
     /* 202984 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(203034), // Rule ID 8267 //
     /* 202989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 202992 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 202997 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203010 */     // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_region_m0_noret_i64>>  =>  (DS_XOR_B64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 203010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B64),
     /* 203013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203018 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203032 */     GIR_RootConstrainSelectedInstOperands,
     /* 203033 */     // GIR_Coverage, 8267,
     /* 203033 */     GIR_EraseRootFromParent_Done,
     /* 203034 */   // Label 3185: @203034
     /* 203034 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(203088), // Rule ID 8262 //
     /* 203039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 203042 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 203047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203062 */     // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_m0_i64>>  =>  (DS_XOR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 203062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B64),
     /* 203065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203072 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203086 */     GIR_RootConstrainSelectedInstOperands,
     /* 203087 */     // GIR_Coverage, 8262,
     /* 203087 */     GIR_EraseRootFromParent_Done,
     /* 203088 */   // Label 3186: @203088
     /* 203088 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(203142), // Rule ID 8264 //
     /* 203093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 203096 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 203101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203116 */     // (atomic_load_xor:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_i64>>  =>  (DS_XOR_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 203116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B64_gfx9),
     /* 203119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203126 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203140 */     GIR_RootConstrainSelectedInstOperands,
     /* 203141 */     // GIR_Coverage, 8264,
     /* 203141 */     GIR_EraseRootFromParent_Done,
     /* 203142 */   // Label 3187: @203142
     /* 203142 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(203196), // Rule ID 8266 //
     /* 203147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 203150 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 203155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203170 */     // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_region_m0_i64>>  =>  (DS_XOR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 203170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B64),
     /* 203173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203180 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203194 */     GIR_RootConstrainSelectedInstOperands,
     /* 203195 */     // GIR_Coverage, 8266,
     /* 203195 */     GIR_EraseRootFromParent_Done,
     /* 203196 */   // Label 3188: @203196
     /* 203196 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(203253), // Rule ID 4110 //
     /* 203201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 203204 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203211 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 203224 */     // (atomic_load_xor:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 203224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2_SADDR),
     /* 203227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 203232 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 203239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 203244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203251 */     GIR_RootConstrainSelectedInstOperands,
     /* 203252 */     // GIR_Coverage, 4110,
     /* 203252 */     GIR_EraseRootFromParent_Done,
     /* 203253 */   // Label 3189: @203253
     /* 203253 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(203314), // Rule ID 4112 //
     /* 203258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 203261 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 203283 */     // (atomic_load_xor:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 203283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2_SADDR_RTN),
     /* 203286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 203293 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 203300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 203305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203312 */     GIR_RootConstrainSelectedInstOperands,
     /* 203313 */     // GIR_Coverage, 4112,
     /* 203313 */     GIR_EraseRootFromParent_Done,
     /* 203314 */   // Label 3190: @203314
     /* 203314 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(203366), // Rule ID 4109 //
     /* 203319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 203322 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203329 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 203342 */     // (atomic_load_xor:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 203342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2),
     /* 203345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203350 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203364 */     GIR_RootConstrainSelectedInstOperands,
     /* 203365 */     // GIR_Coverage, 4109,
     /* 203365 */     GIR_EraseRootFromParent_Done,
     /* 203366 */   // Label 3191: @203366
     /* 203366 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(203422), // Rule ID 4111 //
     /* 203371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 203374 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 203396 */     // (atomic_load_xor:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 203396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2_RTN),
     /* 203399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203406 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203420 */     GIR_RootConstrainSelectedInstOperands,
     /* 203421 */     // GIR_Coverage, 4111,
     /* 203421 */     GIR_EraseRootFromParent_Done,
     /* 203422 */   // Label 3192: @203422
     /* 203422 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(203475), // Rule ID 3714 //
     /* 203427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 203430 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203438 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 203451 */     // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_flat_noret_i64>>  =>  (FLAT_ATOMIC_XOR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 203451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2),
     /* 203454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203459 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203473 */     GIR_RootConstrainSelectedInstOperands,
     /* 203474 */     // GIR_Coverage, 3714,
     /* 203474 */     GIR_EraseRootFromParent_Done,
     /* 203475 */   // Label 3193: @203475
     /* 203475 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(203527), // Rule ID 3774 //
     /* 203480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 203483 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203490 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 203503 */     // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (FLAT_ATOMIC_XOR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 203503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2),
     /* 203506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203511 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203525 */     GIR_RootConstrainSelectedInstOperands,
     /* 203526 */     // GIR_Coverage, 3774,
     /* 203526 */     GIR_EraseRootFromParent_Done,
     /* 203527 */   // Label 3194: @203527
     /* 203527 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(203584), // Rule ID 3713 //
     /* 203532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 203535 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 203558 */     // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_flat_i64>>  =>  (FLAT_ATOMIC_XOR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 203558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2_RTN),
     /* 203561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203568 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203582 */     GIR_RootConstrainSelectedInstOperands,
     /* 203583 */     // GIR_Coverage, 3713,
     /* 203583 */     GIR_EraseRootFromParent_Done,
     /* 203584 */   // Label 3195: @203584
     /* 203584 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(203640), // Rule ID 3773 //
     /* 203589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 203592 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 203603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 203614 */     // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (FLAT_ATOMIC_XOR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 203614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2_RTN),
     /* 203617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203624 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203638 */     GIR_RootConstrainSelectedInstOperands,
     /* 203639 */     // GIR_Coverage, 3773,
     /* 203639 */     GIR_EraseRootFromParent_Done,
     /* 203640 */   // Label 3196: @203640
     /* 203640 */   GIM_Reject,
     /* 203641 */ // Label 3174: @203641
     /* 203641 */ GIM_Reject,
     /* 203642 */ // Label 3150: @203642
     /* 203642 */ GIM_Reject,
     /* 203643 */ // Label 25: @203643
     /* 203643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3199*/ GIMT_Encode4(206154),
     /* 203654 */ /*GILLT_s32*//*Label 3197*/ GIMT_Encode4(203662),
     /* 203658 */ /*GILLT_s64*//*Label 3198*/ GIMT_Encode4(204908),
     /* 203662 */ // Label 3197: @203662
     /* 203662 */ GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(204907),
     /* 203667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203670 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(203732), // Rule ID 5617 //
     /* 203675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 203678 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203685 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 203698 */     // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 203698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_ADDR64),
     /* 203701 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 203703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 203708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 203713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 203718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 203723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203730 */     GIR_RootConstrainSelectedInstOperands,
     /* 203731 */     // GIR_Coverage, 5617,
     /* 203731 */     GIR_EraseRootFromParent_Done,
     /* 203732 */   // Label 3201: @203732
     /* 203732 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(203791), // Rule ID 5621 //
     /* 203737 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203744 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 203757 */     // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 203757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64),
     /* 203760 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 203762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 203767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 203772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 203777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 203782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203789 */     GIR_RootConstrainSelectedInstOperands,
     /* 203790 */     // GIR_Coverage, 5621,
     /* 203790 */     GIR_EraseRootFromParent_Done,
     /* 203791 */   // Label 3202: @203791
     /* 203791 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(203857), // Rule ID 5615 //
     /* 203796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 203799 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 203810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 203821 */     // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 203821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_ADDR64_RTN),
     /* 203824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 203826 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 203828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 203833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 203838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 203843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 203848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203855 */     GIR_RootConstrainSelectedInstOperands,
     /* 203856 */     // GIR_Coverage, 5615,
     /* 203856 */     GIR_EraseRootFromParent_Done,
     /* 203857 */   // Label 3203: @203857
     /* 203857 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(203920), // Rule ID 5619 //
     /* 203862 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 203873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 203884 */     // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 203884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64_RTN),
     /* 203887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 203889 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 203891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 203896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 203901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 203906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 203911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203918 */     GIR_RootConstrainSelectedInstOperands,
     /* 203919 */     // GIR_Coverage, 5619,
     /* 203919 */     GIR_EraseRootFromParent_Done,
     /* 203920 */   // Label 3204: @203920
     /* 203920 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(203977), // Rule ID 5616 //
     /* 203925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 203928 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203935 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 203948 */     // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 203948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET),
     /* 203951 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 203953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 203958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 203963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 203968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203975 */     GIR_RootConstrainSelectedInstOperands,
     /* 203976 */     // GIR_Coverage, 5616,
     /* 203976 */     GIR_EraseRootFromParent_Done,
     /* 203977 */   // Label 3205: @203977
     /* 203977 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(204031), // Rule ID 5620 //
     /* 203982 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203989 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 204002 */     // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET),
     /* 204005 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 204017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204029 */     GIR_RootConstrainSelectedInstOperands,
     /* 204030 */     // GIR_Coverage, 5620,
     /* 204030 */     GIR_EraseRootFromParent_Done,
     /* 204031 */   // Label 3206: @204031
     /* 204031 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(204092), // Rule ID 5614 //
     /* 204036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 204039 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 204061 */     // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET_RTN),
     /* 204064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 204066 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 204078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204090 */     GIR_RootConstrainSelectedInstOperands,
     /* 204091 */     // GIR_Coverage, 5614,
     /* 204091 */     GIR_EraseRootFromParent_Done,
     /* 204092 */   // Label 3207: @204092
     /* 204092 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(204150), // Rule ID 5618 //
     /* 204097 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 204119 */     // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN),
     /* 204122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 204124 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 204136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204148 */     GIR_RootConstrainSelectedInstOperands,
     /* 204149 */     // GIR_Coverage, 5618,
     /* 204149 */     GIR_EraseRootFromParent_Done,
     /* 204150 */   // Label 3208: @204150
     /* 204150 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(204200), // Rule ID 8182 //
     /* 204155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 204158 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 204163 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204176 */     // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_m0_noret_i32>>  =>  (DS_MAX_I32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 204176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I32),
     /* 204179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204184 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204198 */     GIR_RootConstrainSelectedInstOperands,
     /* 204199 */     // GIR_Coverage, 8182,
     /* 204199 */     GIR_EraseRootFromParent_Done,
     /* 204200 */   // Label 3209: @204200
     /* 204200 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(204250), // Rule ID 8184 //
     /* 204205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 204208 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 204213 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204226 */     // (atomic_load_max:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_noret_i32>>  =>  (DS_MAX_I32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 204226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I32_gfx9),
     /* 204229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204234 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204248 */     GIR_RootConstrainSelectedInstOperands,
     /* 204249 */     // GIR_Coverage, 8184,
     /* 204249 */     GIR_EraseRootFromParent_Done,
     /* 204250 */   // Label 3210: @204250
     /* 204250 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(204300), // Rule ID 8186 //
     /* 204255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 204258 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 204263 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204276 */     // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_region_m0_noret_i32>>  =>  (DS_MAX_I32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 204276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I32),
     /* 204279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204284 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204298 */     GIR_RootConstrainSelectedInstOperands,
     /* 204299 */     // GIR_Coverage, 8186,
     /* 204299 */     GIR_EraseRootFromParent_Done,
     /* 204300 */   // Label 3211: @204300
     /* 204300 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(204354), // Rule ID 8181 //
     /* 204305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 204308 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 204313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204328 */     // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_m0_i32>>  =>  (DS_MAX_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 204328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I32),
     /* 204331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204338 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204352 */     GIR_RootConstrainSelectedInstOperands,
     /* 204353 */     // GIR_Coverage, 8181,
     /* 204353 */     GIR_EraseRootFromParent_Done,
     /* 204354 */   // Label 3212: @204354
     /* 204354 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(204408), // Rule ID 8183 //
     /* 204359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 204362 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 204367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204382 */     // (atomic_load_max:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_i32>>  =>  (DS_MAX_RTN_I32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 204382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I32_gfx9),
     /* 204385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204392 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204406 */     GIR_RootConstrainSelectedInstOperands,
     /* 204407 */     // GIR_Coverage, 8183,
     /* 204407 */     GIR_EraseRootFromParent_Done,
     /* 204408 */   // Label 3213: @204408
     /* 204408 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(204462), // Rule ID 8185 //
     /* 204413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 204416 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 204421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204436 */     // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_region_m0_i32>>  =>  (DS_MAX_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 204436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I32),
     /* 204439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204446 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204460 */     GIR_RootConstrainSelectedInstOperands,
     /* 204461 */     // GIR_Coverage, 8185,
     /* 204461 */     GIR_EraseRootFromParent_Done,
     /* 204462 */   // Label 3214: @204462
     /* 204462 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(204519), // Rule ID 4026 //
     /* 204467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 204470 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204477 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 204490 */     // (atomic_load_max:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 204490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_SADDR),
     /* 204493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 204498 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 204505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204517 */     GIR_RootConstrainSelectedInstOperands,
     /* 204518 */     // GIR_Coverage, 4026,
     /* 204518 */     GIR_EraseRootFromParent_Done,
     /* 204519 */   // Label 3215: @204519
     /* 204519 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(204580), // Rule ID 4028 //
     /* 204524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 204527 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 204549 */     // (atomic_load_max:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_i32>>  =>  (GLOBAL_ATOMIC_SMAX_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 204549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_SADDR_RTN),
     /* 204552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 204559 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 204566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204578 */     GIR_RootConstrainSelectedInstOperands,
     /* 204579 */     // GIR_Coverage, 4028,
     /* 204579 */     GIR_EraseRootFromParent_Done,
     /* 204580 */   // Label 3216: @204580
     /* 204580 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(204632), // Rule ID 4025 //
     /* 204585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 204588 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204595 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 204608 */     // (atomic_load_max:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 204608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX),
     /* 204611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 204616 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204630 */     GIR_RootConstrainSelectedInstOperands,
     /* 204631 */     // GIR_Coverage, 4025,
     /* 204631 */     GIR_EraseRootFromParent_Done,
     /* 204632 */   // Label 3217: @204632
     /* 204632 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(204688), // Rule ID 4027 //
     /* 204637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 204640 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 204662 */     // (atomic_load_max:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_i32>>  =>  (GLOBAL_ATOMIC_SMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 204662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_RTN),
     /* 204665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 204672 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204686 */     GIR_RootConstrainSelectedInstOperands,
     /* 204687 */     // GIR_Coverage, 4027,
     /* 204687 */     GIR_EraseRootFromParent_Done,
     /* 204688 */   // Label 3218: @204688
     /* 204688 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(204741), // Rule ID 3674 //
     /* 204693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 204696 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204704 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 204717 */     // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_flat_noret_i32>>  =>  (FLAT_ATOMIC_SMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 204717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX),
     /* 204720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 204725 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204739 */     GIR_RootConstrainSelectedInstOperands,
     /* 204740 */     // GIR_Coverage, 3674,
     /* 204740 */     GIR_EraseRootFromParent_Done,
     /* 204741 */   // Label 3219: @204741
     /* 204741 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(204793), // Rule ID 3734 //
     /* 204746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 204749 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204756 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 204769 */     // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (FLAT_ATOMIC_SMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 204769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX),
     /* 204772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 204777 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204791 */     GIR_RootConstrainSelectedInstOperands,
     /* 204792 */     // GIR_Coverage, 3734,
     /* 204792 */     GIR_EraseRootFromParent_Done,
     /* 204793 */   // Label 3220: @204793
     /* 204793 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(204850), // Rule ID 3673 //
     /* 204798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 204801 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 204824 */     // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_flat_i32>>  =>  (FLAT_ATOMIC_SMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 204824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_RTN),
     /* 204827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 204834 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204848 */     GIR_RootConstrainSelectedInstOperands,
     /* 204849 */     // GIR_Coverage, 3673,
     /* 204849 */     GIR_EraseRootFromParent_Done,
     /* 204850 */   // Label 3221: @204850
     /* 204850 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(204906), // Rule ID 3733 //
     /* 204855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 204858 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 204869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 204880 */     // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_i32>>  =>  (FLAT_ATOMIC_SMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 204880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_RTN),
     /* 204883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 204890 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204904 */     GIR_RootConstrainSelectedInstOperands,
     /* 204905 */     // GIR_Coverage, 3733,
     /* 204905 */     GIR_EraseRootFromParent_Done,
     /* 204906 */   // Label 3222: @204906
     /* 204906 */   GIM_Reject,
     /* 204907 */ // Label 3200: @204907
     /* 204907 */ GIM_Reject,
     /* 204908 */ // Label 3198: @204908
     /* 204908 */ GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(206153),
     /* 204913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 204916 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(204978), // Rule ID 5713 //
     /* 204921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 204924 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204931 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 204944 */     // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_ADDR64),
     /* 204947 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 204954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 204964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 204969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204976 */     GIR_RootConstrainSelectedInstOperands,
     /* 204977 */     // GIR_Coverage, 5713,
     /* 204977 */     GIR_EraseRootFromParent_Done,
     /* 204978 */   // Label 3224: @204978
     /* 204978 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(205037), // Rule ID 5717 //
     /* 204983 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204990 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 205003 */     // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64),
     /* 205006 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 205013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 205023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 205028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205035 */     GIR_RootConstrainSelectedInstOperands,
     /* 205036 */     // GIR_Coverage, 5717,
     /* 205036 */     GIR_EraseRootFromParent_Done,
     /* 205037 */   // Label 3225: @205037
     /* 205037 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(205103), // Rule ID 5711 //
     /* 205042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 205045 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 205067 */     // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_ADDR64_RTN),
     /* 205070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 205072 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 205079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 205089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 205094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205101 */     GIR_RootConstrainSelectedInstOperands,
     /* 205102 */     // GIR_Coverage, 5711,
     /* 205102 */     GIR_EraseRootFromParent_Done,
     /* 205103 */   // Label 3226: @205103
     /* 205103 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(205166), // Rule ID 5715 //
     /* 205108 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 205130 */     // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64_RTN),
     /* 205133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 205135 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 205142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 205152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 205157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205164 */     GIR_RootConstrainSelectedInstOperands,
     /* 205165 */     // GIR_Coverage, 5715,
     /* 205165 */     GIR_EraseRootFromParent_Done,
     /* 205166 */   // Label 3227: @205166
     /* 205166 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(205223), // Rule ID 5712 //
     /* 205171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 205174 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205181 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 205194 */     // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET),
     /* 205197 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 205209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205221 */     GIR_RootConstrainSelectedInstOperands,
     /* 205222 */     // GIR_Coverage, 5712,
     /* 205222 */     GIR_EraseRootFromParent_Done,
     /* 205223 */   // Label 3228: @205223
     /* 205223 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(205277), // Rule ID 5716 //
     /* 205228 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205235 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 205248 */     // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET),
     /* 205251 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 205263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205275 */     GIR_RootConstrainSelectedInstOperands,
     /* 205276 */     // GIR_Coverage, 5716,
     /* 205276 */     GIR_EraseRootFromParent_Done,
     /* 205277 */   // Label 3229: @205277
     /* 205277 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(205338), // Rule ID 5710 //
     /* 205282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 205285 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 205307 */     // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN),
     /* 205310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 205312 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 205324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205336 */     GIR_RootConstrainSelectedInstOperands,
     /* 205337 */     // GIR_Coverage, 5710,
     /* 205337 */     GIR_EraseRootFromParent_Done,
     /* 205338 */   // Label 3230: @205338
     /* 205338 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(205396), // Rule ID 5714 //
     /* 205343 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 205365 */     // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN),
     /* 205368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 205370 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 205382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205394 */     GIR_RootConstrainSelectedInstOperands,
     /* 205395 */     // GIR_Coverage, 5714,
     /* 205395 */     GIR_EraseRootFromParent_Done,
     /* 205396 */   // Label 3231: @205396
     /* 205396 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(205446), // Rule ID 8275 //
     /* 205401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 205404 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 205409 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205422 */     // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_m0_noret_i64>>  =>  (DS_MAX_I64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 205422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I64),
     /* 205425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205430 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205444 */     GIR_RootConstrainSelectedInstOperands,
     /* 205445 */     // GIR_Coverage, 8275,
     /* 205445 */     GIR_EraseRootFromParent_Done,
     /* 205446 */   // Label 3232: @205446
     /* 205446 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(205496), // Rule ID 8277 //
     /* 205451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 205454 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 205459 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205472 */     // (atomic_load_max:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_noret_i64>>  =>  (DS_MAX_I64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 205472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I64_gfx9),
     /* 205475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205480 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205494 */     GIR_RootConstrainSelectedInstOperands,
     /* 205495 */     // GIR_Coverage, 8277,
     /* 205495 */     GIR_EraseRootFromParent_Done,
     /* 205496 */   // Label 3233: @205496
     /* 205496 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(205546), // Rule ID 8279 //
     /* 205501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 205504 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 205509 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205522 */     // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_region_m0_noret_i64>>  =>  (DS_MAX_I64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 205522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I64),
     /* 205525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205530 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205544 */     GIR_RootConstrainSelectedInstOperands,
     /* 205545 */     // GIR_Coverage, 8279,
     /* 205545 */     GIR_EraseRootFromParent_Done,
     /* 205546 */   // Label 3234: @205546
     /* 205546 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(205600), // Rule ID 8274 //
     /* 205551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 205554 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 205559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205574 */     // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_m0_i64>>  =>  (DS_MAX_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 205574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I64),
     /* 205577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205584 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205598 */     GIR_RootConstrainSelectedInstOperands,
     /* 205599 */     // GIR_Coverage, 8274,
     /* 205599 */     GIR_EraseRootFromParent_Done,
     /* 205600 */   // Label 3235: @205600
     /* 205600 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(205654), // Rule ID 8276 //
     /* 205605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 205608 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 205613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205628 */     // (atomic_load_max:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_i64>>  =>  (DS_MAX_RTN_I64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 205628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I64_gfx9),
     /* 205631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205638 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205652 */     GIR_RootConstrainSelectedInstOperands,
     /* 205653 */     // GIR_Coverage, 8276,
     /* 205653 */     GIR_EraseRootFromParent_Done,
     /* 205654 */   // Label 3236: @205654
     /* 205654 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(205708), // Rule ID 8278 //
     /* 205659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 205662 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 205667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205682 */     // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_region_m0_i64>>  =>  (DS_MAX_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 205682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I64),
     /* 205685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205692 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205706 */     GIR_RootConstrainSelectedInstOperands,
     /* 205707 */     // GIR_Coverage, 8278,
     /* 205707 */     GIR_EraseRootFromParent_Done,
     /* 205708 */   // Label 3237: @205708
     /* 205708 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(205765), // Rule ID 4082 //
     /* 205713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 205716 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205723 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 205736 */     // (atomic_load_max:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 205736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2_SADDR),
     /* 205739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 205744 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 205746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 205751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205763 */     GIR_RootConstrainSelectedInstOperands,
     /* 205764 */     // GIR_Coverage, 4082,
     /* 205764 */     GIR_EraseRootFromParent_Done,
     /* 205765 */   // Label 3238: @205765
     /* 205765 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(205826), // Rule ID 4084 //
     /* 205770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 205773 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 205795 */     // (atomic_load_max:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 205795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2_SADDR_RTN),
     /* 205798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 205805 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 205807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 205812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205824 */     GIR_RootConstrainSelectedInstOperands,
     /* 205825 */     // GIR_Coverage, 4084,
     /* 205825 */     GIR_EraseRootFromParent_Done,
     /* 205826 */   // Label 3239: @205826
     /* 205826 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(205878), // Rule ID 4081 //
     /* 205831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 205834 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205841 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 205854 */     // (atomic_load_max:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 205854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2),
     /* 205857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 205862 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 205864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205876 */     GIR_RootConstrainSelectedInstOperands,
     /* 205877 */     // GIR_Coverage, 4081,
     /* 205877 */     GIR_EraseRootFromParent_Done,
     /* 205878 */   // Label 3240: @205878
     /* 205878 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(205934), // Rule ID 4083 //
     /* 205883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 205886 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 205908 */     // (atomic_load_max:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 205908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2_RTN),
     /* 205911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 205918 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 205920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205932 */     GIR_RootConstrainSelectedInstOperands,
     /* 205933 */     // GIR_Coverage, 4083,
     /* 205933 */     GIR_EraseRootFromParent_Done,
     /* 205934 */   // Label 3241: @205934
     /* 205934 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(205987), // Rule ID 3700 //
     /* 205939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 205942 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205950 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 205963 */     // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_flat_noret_i64>>  =>  (FLAT_ATOMIC_SMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 205963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2),
     /* 205966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 205971 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 205973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205985 */     GIR_RootConstrainSelectedInstOperands,
     /* 205986 */     // GIR_Coverage, 3700,
     /* 205986 */     GIR_EraseRootFromParent_Done,
     /* 205987 */   // Label 3242: @205987
     /* 205987 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(206039), // Rule ID 3760 //
     /* 205992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 205995 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206002 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 206015 */     // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (FLAT_ATOMIC_SMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 206015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2),
     /* 206018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206023 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206037 */     GIR_RootConstrainSelectedInstOperands,
     /* 206038 */     // GIR_Coverage, 3760,
     /* 206038 */     GIR_EraseRootFromParent_Done,
     /* 206039 */   // Label 3243: @206039
     /* 206039 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(206096), // Rule ID 3699 //
     /* 206044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 206047 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 206059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 206070 */     // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_flat_i64>>  =>  (FLAT_ATOMIC_SMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 206070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2_RTN),
     /* 206073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 206075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206080 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206094 */     GIR_RootConstrainSelectedInstOperands,
     /* 206095 */     // GIR_Coverage, 3699,
     /* 206095 */     GIR_EraseRootFromParent_Done,
     /* 206096 */   // Label 3244: @206096
     /* 206096 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(206152), // Rule ID 3759 //
     /* 206101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 206104 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 206115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 206126 */     // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_i64>>  =>  (FLAT_ATOMIC_SMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 206126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2_RTN),
     /* 206129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 206131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206136 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206150 */     GIR_RootConstrainSelectedInstOperands,
     /* 206151 */     // GIR_Coverage, 3759,
     /* 206151 */     GIR_EraseRootFromParent_Done,
     /* 206152 */   // Label 3245: @206152
     /* 206152 */   GIM_Reject,
     /* 206153 */ // Label 3223: @206153
     /* 206153 */ GIM_Reject,
     /* 206154 */ // Label 3199: @206154
     /* 206154 */ GIM_Reject,
     /* 206155 */ // Label 26: @206155
     /* 206155 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3248*/ GIMT_Encode4(208666),
     /* 206166 */ /*GILLT_s32*//*Label 3246*/ GIMT_Encode4(206174),
     /* 206170 */ /*GILLT_s64*//*Label 3247*/ GIMT_Encode4(207420),
     /* 206174 */ // Label 3246: @206174
     /* 206174 */ GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(207419),
     /* 206179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 206182 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(206244), // Rule ID 5601 //
     /* 206187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 206190 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206197 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 206210 */     // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_ADDR64),
     /* 206213 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 206220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 206230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 206235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206242 */     GIR_RootConstrainSelectedInstOperands,
     /* 206243 */     // GIR_Coverage, 5601,
     /* 206243 */     GIR_EraseRootFromParent_Done,
     /* 206244 */   // Label 3250: @206244
     /* 206244 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(206303), // Rule ID 5605 //
     /* 206249 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206256 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 206269 */     // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64),
     /* 206272 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 206279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 206289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 206294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206301 */     GIR_RootConstrainSelectedInstOperands,
     /* 206302 */     // GIR_Coverage, 5605,
     /* 206302 */     GIR_EraseRootFromParent_Done,
     /* 206303 */   // Label 3251: @206303
     /* 206303 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(206369), // Rule ID 5599 //
     /* 206308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 206311 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 206333 */     // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_ADDR64_RTN),
     /* 206336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 206338 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 206345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 206355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 206360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206367 */     GIR_RootConstrainSelectedInstOperands,
     /* 206368 */     // GIR_Coverage, 5599,
     /* 206368 */     GIR_EraseRootFromParent_Done,
     /* 206369 */   // Label 3252: @206369
     /* 206369 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(206432), // Rule ID 5603 //
     /* 206374 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 206396 */     // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64_RTN),
     /* 206399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 206401 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 206408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 206418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 206423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206430 */     GIR_RootConstrainSelectedInstOperands,
     /* 206431 */     // GIR_Coverage, 5603,
     /* 206431 */     GIR_EraseRootFromParent_Done,
     /* 206432 */   // Label 3253: @206432
     /* 206432 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(206489), // Rule ID 5600 //
     /* 206437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 206440 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206447 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 206460 */     // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET),
     /* 206463 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 206475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206487 */     GIR_RootConstrainSelectedInstOperands,
     /* 206488 */     // GIR_Coverage, 5600,
     /* 206488 */     GIR_EraseRootFromParent_Done,
     /* 206489 */   // Label 3254: @206489
     /* 206489 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(206543), // Rule ID 5604 //
     /* 206494 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206501 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 206514 */     // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET),
     /* 206517 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 206529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206541 */     GIR_RootConstrainSelectedInstOperands,
     /* 206542 */     // GIR_Coverage, 5604,
     /* 206542 */     GIR_EraseRootFromParent_Done,
     /* 206543 */   // Label 3255: @206543
     /* 206543 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(206604), // Rule ID 5598 //
     /* 206548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 206551 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 206573 */     // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET_RTN),
     /* 206576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 206578 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 206590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206602 */     GIR_RootConstrainSelectedInstOperands,
     /* 206603 */     // GIR_Coverage, 5598,
     /* 206603 */     GIR_EraseRootFromParent_Done,
     /* 206604 */   // Label 3256: @206604
     /* 206604 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(206662), // Rule ID 5602 //
     /* 206609 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 206631 */     // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN),
     /* 206634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 206636 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 206648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206660 */     GIR_RootConstrainSelectedInstOperands,
     /* 206661 */     // GIR_Coverage, 5602,
     /* 206661 */     GIR_EraseRootFromParent_Done,
     /* 206662 */   // Label 3257: @206662
     /* 206662 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(206712), // Rule ID 8176 //
     /* 206667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 206670 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 206675 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 206688 */     // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_m0_noret_i32>>  =>  (DS_MIN_I32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 206688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I32),
     /* 206691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 206696 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 206698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206710 */     GIR_RootConstrainSelectedInstOperands,
     /* 206711 */     // GIR_Coverage, 8176,
     /* 206711 */     GIR_EraseRootFromParent_Done,
     /* 206712 */   // Label 3258: @206712
     /* 206712 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(206762), // Rule ID 8178 //
     /* 206717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 206720 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 206725 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 206738 */     // (atomic_load_min:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_noret_i32>>  =>  (DS_MIN_I32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 206738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I32_gfx9),
     /* 206741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 206746 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 206748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206760 */     GIR_RootConstrainSelectedInstOperands,
     /* 206761 */     // GIR_Coverage, 8178,
     /* 206761 */     GIR_EraseRootFromParent_Done,
     /* 206762 */   // Label 3259: @206762
     /* 206762 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(206812), // Rule ID 8180 //
     /* 206767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 206770 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 206775 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 206788 */     // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_region_m0_noret_i32>>  =>  (DS_MIN_I32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 206788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I32),
     /* 206791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 206796 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 206798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206810 */     GIR_RootConstrainSelectedInstOperands,
     /* 206811 */     // GIR_Coverage, 8180,
     /* 206811 */     GIR_EraseRootFromParent_Done,
     /* 206812 */   // Label 3260: @206812
     /* 206812 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(206866), // Rule ID 8175 //
     /* 206817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 206820 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 206825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 206840 */     // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_m0_i32>>  =>  (DS_MIN_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 206840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I32),
     /* 206843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 206845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 206850 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 206852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206864 */     GIR_RootConstrainSelectedInstOperands,
     /* 206865 */     // GIR_Coverage, 8175,
     /* 206865 */     GIR_EraseRootFromParent_Done,
     /* 206866 */   // Label 3261: @206866
     /* 206866 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(206920), // Rule ID 8177 //
     /* 206871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 206874 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 206879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 206894 */     // (atomic_load_min:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_i32>>  =>  (DS_MIN_RTN_I32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 206894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I32_gfx9),
     /* 206897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 206899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 206904 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 206906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206918 */     GIR_RootConstrainSelectedInstOperands,
     /* 206919 */     // GIR_Coverage, 8177,
     /* 206919 */     GIR_EraseRootFromParent_Done,
     /* 206920 */   // Label 3262: @206920
     /* 206920 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(206974), // Rule ID 8179 //
     /* 206925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 206928 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 206933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 206948 */     // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_region_m0_i32>>  =>  (DS_MIN_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 206948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I32),
     /* 206951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 206953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 206958 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 206960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206972 */     GIR_RootConstrainSelectedInstOperands,
     /* 206973 */     // GIR_Coverage, 8179,
     /* 206973 */     GIR_EraseRootFromParent_Done,
     /* 206974 */   // Label 3263: @206974
     /* 206974 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(207031), // Rule ID 4034 //
     /* 206979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 206982 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206989 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 207002 */     // (atomic_load_min:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 207002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_SADDR),
     /* 207005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 207010 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 207017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 207022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207029 */     GIR_RootConstrainSelectedInstOperands,
     /* 207030 */     // GIR_Coverage, 4034,
     /* 207030 */     GIR_EraseRootFromParent_Done,
     /* 207031 */   // Label 3264: @207031
     /* 207031 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(207092), // Rule ID 4036 //
     /* 207036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 207039 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 207050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 207061 */     // (atomic_load_min:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_i32>>  =>  (GLOBAL_ATOMIC_SMIN_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 207061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_SADDR_RTN),
     /* 207064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 207071 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 207078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 207083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207090 */     GIR_RootConstrainSelectedInstOperands,
     /* 207091 */     // GIR_Coverage, 4036,
     /* 207091 */     GIR_EraseRootFromParent_Done,
     /* 207092 */   // Label 3265: @207092
     /* 207092 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(207144), // Rule ID 4033 //
     /* 207097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 207100 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207107 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 207120 */     // (atomic_load_min:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 207120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN),
     /* 207123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207128 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207142 */     GIR_RootConstrainSelectedInstOperands,
     /* 207143 */     // GIR_Coverage, 4033,
     /* 207143 */     GIR_EraseRootFromParent_Done,
     /* 207144 */   // Label 3266: @207144
     /* 207144 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(207200), // Rule ID 4035 //
     /* 207149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 207152 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 207163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 207174 */     // (atomic_load_min:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_i32>>  =>  (GLOBAL_ATOMIC_SMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 207174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_RTN),
     /* 207177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207184 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207198 */     GIR_RootConstrainSelectedInstOperands,
     /* 207199 */     // GIR_Coverage, 4035,
     /* 207199 */     GIR_EraseRootFromParent_Done,
     /* 207200 */   // Label 3267: @207200
     /* 207200 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(207253), // Rule ID 3678 //
     /* 207205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 207208 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207216 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 207229 */     // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_flat_noret_i32>>  =>  (FLAT_ATOMIC_SMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 207229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN),
     /* 207232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207237 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207251 */     GIR_RootConstrainSelectedInstOperands,
     /* 207252 */     // GIR_Coverage, 3678,
     /* 207252 */     GIR_EraseRootFromParent_Done,
     /* 207253 */   // Label 3268: @207253
     /* 207253 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(207305), // Rule ID 3738 //
     /* 207258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 207261 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207268 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 207281 */     // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (FLAT_ATOMIC_SMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 207281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN),
     /* 207284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207289 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207303 */     GIR_RootConstrainSelectedInstOperands,
     /* 207304 */     // GIR_Coverage, 3738,
     /* 207304 */     GIR_EraseRootFromParent_Done,
     /* 207305 */   // Label 3269: @207305
     /* 207305 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(207362), // Rule ID 3677 //
     /* 207310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 207313 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 207325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 207336 */     // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_flat_i32>>  =>  (FLAT_ATOMIC_SMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 207336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_RTN),
     /* 207339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207346 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207360 */     GIR_RootConstrainSelectedInstOperands,
     /* 207361 */     // GIR_Coverage, 3677,
     /* 207361 */     GIR_EraseRootFromParent_Done,
     /* 207362 */   // Label 3270: @207362
     /* 207362 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(207418), // Rule ID 3737 //
     /* 207367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 207370 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 207381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 207392 */     // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_i32>>  =>  (FLAT_ATOMIC_SMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 207392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_RTN),
     /* 207395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207402 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207416 */     GIR_RootConstrainSelectedInstOperands,
     /* 207417 */     // GIR_Coverage, 3737,
     /* 207417 */     GIR_EraseRootFromParent_Done,
     /* 207418 */   // Label 3271: @207418
     /* 207418 */   GIM_Reject,
     /* 207419 */ // Label 3249: @207419
     /* 207419 */ GIM_Reject,
     /* 207420 */ // Label 3247: @207420
     /* 207420 */ GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(208665),
     /* 207425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207428 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(207490), // Rule ID 5697 //
     /* 207433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 207436 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207443 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 207456 */     // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_ADDR64),
     /* 207459 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 207466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 207476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 207481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207488 */     GIR_RootConstrainSelectedInstOperands,
     /* 207489 */     // GIR_Coverage, 5697,
     /* 207489 */     GIR_EraseRootFromParent_Done,
     /* 207490 */   // Label 3273: @207490
     /* 207490 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(207549), // Rule ID 5701 //
     /* 207495 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207502 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 207515 */     // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64),
     /* 207518 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 207525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 207535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 207540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207547 */     GIR_RootConstrainSelectedInstOperands,
     /* 207548 */     // GIR_Coverage, 5701,
     /* 207548 */     GIR_EraseRootFromParent_Done,
     /* 207549 */   // Label 3274: @207549
     /* 207549 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(207615), // Rule ID 5695 //
     /* 207554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 207557 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 207568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 207579 */     // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_ADDR64_RTN),
     /* 207582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 207584 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 207591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 207601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 207606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207613 */     GIR_RootConstrainSelectedInstOperands,
     /* 207614 */     // GIR_Coverage, 5695,
     /* 207614 */     GIR_EraseRootFromParent_Done,
     /* 207615 */   // Label 3275: @207615
     /* 207615 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(207678), // Rule ID 5699 //
     /* 207620 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 207631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 207642 */     // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64_RTN),
     /* 207645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 207647 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 207654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 207664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 207669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207676 */     GIR_RootConstrainSelectedInstOperands,
     /* 207677 */     // GIR_Coverage, 5699,
     /* 207677 */     GIR_EraseRootFromParent_Done,
     /* 207678 */   // Label 3276: @207678
     /* 207678 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(207735), // Rule ID 5696 //
     /* 207683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 207686 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207693 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 207706 */     // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET),
     /* 207709 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 207721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 207726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207733 */     GIR_RootConstrainSelectedInstOperands,
     /* 207734 */     // GIR_Coverage, 5696,
     /* 207734 */     GIR_EraseRootFromParent_Done,
     /* 207735 */   // Label 3277: @207735
     /* 207735 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(207789), // Rule ID 5700 //
     /* 207740 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207747 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 207760 */     // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET),
     /* 207763 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 207775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 207780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207787 */     GIR_RootConstrainSelectedInstOperands,
     /* 207788 */     // GIR_Coverage, 5700,
     /* 207788 */     GIR_EraseRootFromParent_Done,
     /* 207789 */   // Label 3278: @207789
     /* 207789 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(207850), // Rule ID 5694 //
     /* 207794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 207797 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 207808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 207819 */     // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN),
     /* 207822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 207824 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 207836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 207841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207848 */     GIR_RootConstrainSelectedInstOperands,
     /* 207849 */     // GIR_Coverage, 5694,
     /* 207849 */     GIR_EraseRootFromParent_Done,
     /* 207850 */   // Label 3279: @207850
     /* 207850 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(207908), // Rule ID 5698 //
     /* 207855 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 207866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 207877 */     // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN),
     /* 207880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 207882 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 207894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 207899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207906 */     GIR_RootConstrainSelectedInstOperands,
     /* 207907 */     // GIR_Coverage, 5698,
     /* 207907 */     GIR_EraseRootFromParent_Done,
     /* 207908 */   // Label 3280: @207908
     /* 207908 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(207958), // Rule ID 8269 //
     /* 207913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 207916 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 207921 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 207934 */     // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_m0_noret_i64>>  =>  (DS_MIN_I64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 207934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I64),
     /* 207937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 207942 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 207944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207956 */     GIR_RootConstrainSelectedInstOperands,
     /* 207957 */     // GIR_Coverage, 8269,
     /* 207957 */     GIR_EraseRootFromParent_Done,
     /* 207958 */   // Label 3281: @207958
     /* 207958 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(208008), // Rule ID 8271 //
     /* 207963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 207966 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 207971 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 207984 */     // (atomic_load_min:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_noret_i64>>  =>  (DS_MIN_I64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 207984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I64_gfx9),
     /* 207987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 207992 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 207994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208006 */     GIR_RootConstrainSelectedInstOperands,
     /* 208007 */     // GIR_Coverage, 8271,
     /* 208007 */     GIR_EraseRootFromParent_Done,
     /* 208008 */   // Label 3282: @208008
     /* 208008 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(208058), // Rule ID 8273 //
     /* 208013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 208016 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 208021 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208034 */     // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_region_m0_noret_i64>>  =>  (DS_MIN_I64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 208034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I64),
     /* 208037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208042 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208056 */     GIR_RootConstrainSelectedInstOperands,
     /* 208057 */     // GIR_Coverage, 8273,
     /* 208057 */     GIR_EraseRootFromParent_Done,
     /* 208058 */   // Label 3283: @208058
     /* 208058 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(208112), // Rule ID 8268 //
     /* 208063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 208066 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 208071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208086 */     // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_m0_i64>>  =>  (DS_MIN_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 208086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I64),
     /* 208089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208096 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208110 */     GIR_RootConstrainSelectedInstOperands,
     /* 208111 */     // GIR_Coverage, 8268,
     /* 208111 */     GIR_EraseRootFromParent_Done,
     /* 208112 */   // Label 3284: @208112
     /* 208112 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(208166), // Rule ID 8270 //
     /* 208117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 208120 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 208125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208140 */     // (atomic_load_min:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_i64>>  =>  (DS_MIN_RTN_I64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 208140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I64_gfx9),
     /* 208143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208150 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208164 */     GIR_RootConstrainSelectedInstOperands,
     /* 208165 */     // GIR_Coverage, 8270,
     /* 208165 */     GIR_EraseRootFromParent_Done,
     /* 208166 */   // Label 3285: @208166
     /* 208166 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(208220), // Rule ID 8272 //
     /* 208171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 208174 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 208179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208194 */     // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_region_m0_i64>>  =>  (DS_MIN_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 208194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I64),
     /* 208197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208204 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208218 */     GIR_RootConstrainSelectedInstOperands,
     /* 208219 */     // GIR_Coverage, 8272,
     /* 208219 */     GIR_EraseRootFromParent_Done,
     /* 208220 */   // Label 3286: @208220
     /* 208220 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(208277), // Rule ID 4090 //
     /* 208225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 208228 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208235 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 208248 */     // (atomic_load_min:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 208248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2_SADDR),
     /* 208251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 208256 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 208263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 208268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208275 */     GIR_RootConstrainSelectedInstOperands,
     /* 208276 */     // GIR_Coverage, 4090,
     /* 208276 */     GIR_EraseRootFromParent_Done,
     /* 208277 */   // Label 3287: @208277
     /* 208277 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(208338), // Rule ID 4092 //
     /* 208282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 208285 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 208307 */     // (atomic_load_min:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 208307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2_SADDR_RTN),
     /* 208310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 208317 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 208324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 208329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208336 */     GIR_RootConstrainSelectedInstOperands,
     /* 208337 */     // GIR_Coverage, 4092,
     /* 208337 */     GIR_EraseRootFromParent_Done,
     /* 208338 */   // Label 3288: @208338
     /* 208338 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(208390), // Rule ID 4089 //
     /* 208343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 208346 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208353 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 208366 */     // (atomic_load_min:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 208366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2),
     /* 208369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208374 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208388 */     GIR_RootConstrainSelectedInstOperands,
     /* 208389 */     // GIR_Coverage, 4089,
     /* 208389 */     GIR_EraseRootFromParent_Done,
     /* 208390 */   // Label 3289: @208390
     /* 208390 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(208446), // Rule ID 4091 //
     /* 208395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 208398 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 208420 */     // (atomic_load_min:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 208420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2_RTN),
     /* 208423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208430 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208444 */     GIR_RootConstrainSelectedInstOperands,
     /* 208445 */     // GIR_Coverage, 4091,
     /* 208445 */     GIR_EraseRootFromParent_Done,
     /* 208446 */   // Label 3290: @208446
     /* 208446 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(208499), // Rule ID 3704 //
     /* 208451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 208454 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208462 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 208475 */     // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_flat_noret_i64>>  =>  (FLAT_ATOMIC_SMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 208475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2),
     /* 208478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208483 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208497 */     GIR_RootConstrainSelectedInstOperands,
     /* 208498 */     // GIR_Coverage, 3704,
     /* 208498 */     GIR_EraseRootFromParent_Done,
     /* 208499 */   // Label 3291: @208499
     /* 208499 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(208551), // Rule ID 3764 //
     /* 208504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 208507 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208514 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 208527 */     // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (FLAT_ATOMIC_SMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 208527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2),
     /* 208530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208535 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208549 */     GIR_RootConstrainSelectedInstOperands,
     /* 208550 */     // GIR_Coverage, 3764,
     /* 208550 */     GIR_EraseRootFromParent_Done,
     /* 208551 */   // Label 3292: @208551
     /* 208551 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(208608), // Rule ID 3703 //
     /* 208556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 208559 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 208582 */     // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_flat_i64>>  =>  (FLAT_ATOMIC_SMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 208582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2_RTN),
     /* 208585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208592 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208606 */     GIR_RootConstrainSelectedInstOperands,
     /* 208607 */     // GIR_Coverage, 3703,
     /* 208607 */     GIR_EraseRootFromParent_Done,
     /* 208608 */   // Label 3293: @208608
     /* 208608 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(208664), // Rule ID 3763 //
     /* 208613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 208616 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 208627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 208638 */     // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_i64>>  =>  (FLAT_ATOMIC_SMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 208638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2_RTN),
     /* 208641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208648 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208662 */     GIR_RootConstrainSelectedInstOperands,
     /* 208663 */     // GIR_Coverage, 3763,
     /* 208663 */     GIR_EraseRootFromParent_Done,
     /* 208664 */   // Label 3294: @208664
     /* 208664 */   GIM_Reject,
     /* 208665 */ // Label 3272: @208665
     /* 208665 */ GIM_Reject,
     /* 208666 */ // Label 3248: @208666
     /* 208666 */ GIM_Reject,
     /* 208667 */ // Label 27: @208667
     /* 208667 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3297*/ GIMT_Encode4(211178),
     /* 208678 */ /*GILLT_s32*//*Label 3295*/ GIMT_Encode4(208686),
     /* 208682 */ /*GILLT_s64*//*Label 3296*/ GIMT_Encode4(209932),
     /* 208686 */ // Label 3295: @208686
     /* 208686 */ GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(209931),
     /* 208691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 208694 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(208756), // Rule ID 5625 //
     /* 208699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 208702 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208709 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 208722 */     // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 208722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_ADDR64),
     /* 208725 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 208727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 208732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 208737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 208742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 208747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208754 */     GIR_RootConstrainSelectedInstOperands,
     /* 208755 */     // GIR_Coverage, 5625,
     /* 208755 */     GIR_EraseRootFromParent_Done,
     /* 208756 */   // Label 3299: @208756
     /* 208756 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(208815), // Rule ID 5629 //
     /* 208761 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208768 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 208781 */     // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 208781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64),
     /* 208784 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 208786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 208791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 208796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 208801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 208806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208813 */     GIR_RootConstrainSelectedInstOperands,
     /* 208814 */     // GIR_Coverage, 5629,
     /* 208814 */     GIR_EraseRootFromParent_Done,
     /* 208815 */   // Label 3300: @208815
     /* 208815 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(208881), // Rule ID 5623 //
     /* 208820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 208823 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 208834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 208845 */     // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 208845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_ADDR64_RTN),
     /* 208848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 208850 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 208852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 208857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 208862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 208867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 208872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208879 */     GIR_RootConstrainSelectedInstOperands,
     /* 208880 */     // GIR_Coverage, 5623,
     /* 208880 */     GIR_EraseRootFromParent_Done,
     /* 208881 */   // Label 3301: @208881
     /* 208881 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(208944), // Rule ID 5627 //
     /* 208886 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 208897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 208908 */     // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 208908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64_RTN),
     /* 208911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 208913 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 208915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 208920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 208925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 208930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 208935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208942 */     GIR_RootConstrainSelectedInstOperands,
     /* 208943 */     // GIR_Coverage, 5627,
     /* 208943 */     GIR_EraseRootFromParent_Done,
     /* 208944 */   // Label 3302: @208944
     /* 208944 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(209001), // Rule ID 5624 //
     /* 208949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 208952 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208959 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 208972 */     // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 208972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET),
     /* 208975 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 208977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 208982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 208987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 208992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208999 */     GIR_RootConstrainSelectedInstOperands,
     /* 209000 */     // GIR_Coverage, 5624,
     /* 209000 */     GIR_EraseRootFromParent_Done,
     /* 209001 */   // Label 3303: @209001
     /* 209001 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(209055), // Rule ID 5628 //
     /* 209006 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209013 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 209026 */     // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET),
     /* 209029 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 209041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209053 */     GIR_RootConstrainSelectedInstOperands,
     /* 209054 */     // GIR_Coverage, 5628,
     /* 209054 */     GIR_EraseRootFromParent_Done,
     /* 209055 */   // Label 3304: @209055
     /* 209055 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(209116), // Rule ID 5622 //
     /* 209060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 209063 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 209085 */     // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET_RTN),
     /* 209088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 209090 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 209102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209114 */     GIR_RootConstrainSelectedInstOperands,
     /* 209115 */     // GIR_Coverage, 5622,
     /* 209115 */     GIR_EraseRootFromParent_Done,
     /* 209116 */   // Label 3305: @209116
     /* 209116 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(209174), // Rule ID 5626 //
     /* 209121 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 209143 */     // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN),
     /* 209146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 209148 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 209160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209172 */     GIR_RootConstrainSelectedInstOperands,
     /* 209173 */     // GIR_Coverage, 5626,
     /* 209173 */     GIR_EraseRootFromParent_Done,
     /* 209174 */   // Label 3306: @209174
     /* 209174 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(209224), // Rule ID 8194 //
     /* 209179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 209182 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 209187 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209200 */     // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_m0_noret_i32>>  =>  (DS_MAX_U32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 209200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U32),
     /* 209203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209208 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209222 */     GIR_RootConstrainSelectedInstOperands,
     /* 209223 */     // GIR_Coverage, 8194,
     /* 209223 */     GIR_EraseRootFromParent_Done,
     /* 209224 */   // Label 3307: @209224
     /* 209224 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(209274), // Rule ID 8196 //
     /* 209229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 209232 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 209237 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209250 */     // (atomic_load_umax:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_noret_i32>>  =>  (DS_MAX_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 209250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U32_gfx9),
     /* 209253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209258 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209272 */     GIR_RootConstrainSelectedInstOperands,
     /* 209273 */     // GIR_Coverage, 8196,
     /* 209273 */     GIR_EraseRootFromParent_Done,
     /* 209274 */   // Label 3308: @209274
     /* 209274 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(209324), // Rule ID 8198 //
     /* 209279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 209282 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 209287 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209300 */     // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_region_m0_noret_i32>>  =>  (DS_MAX_U32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 209300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U32),
     /* 209303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209308 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209322 */     GIR_RootConstrainSelectedInstOperands,
     /* 209323 */     // GIR_Coverage, 8198,
     /* 209323 */     GIR_EraseRootFromParent_Done,
     /* 209324 */   // Label 3309: @209324
     /* 209324 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(209378), // Rule ID 8193 //
     /* 209329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 209332 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 209337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209352 */     // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_m0_i32>>  =>  (DS_MAX_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 209352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U32),
     /* 209355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209362 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209376 */     GIR_RootConstrainSelectedInstOperands,
     /* 209377 */     // GIR_Coverage, 8193,
     /* 209377 */     GIR_EraseRootFromParent_Done,
     /* 209378 */   // Label 3310: @209378
     /* 209378 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(209432), // Rule ID 8195 //
     /* 209383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 209386 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 209391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209406 */     // (atomic_load_umax:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_i32>>  =>  (DS_MAX_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 209406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U32_gfx9),
     /* 209409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209416 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209430 */     GIR_RootConstrainSelectedInstOperands,
     /* 209431 */     // GIR_Coverage, 8195,
     /* 209431 */     GIR_EraseRootFromParent_Done,
     /* 209432 */   // Label 3311: @209432
     /* 209432 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(209486), // Rule ID 8197 //
     /* 209437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 209440 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 209445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209460 */     // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_region_m0_i32>>  =>  (DS_MAX_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 209460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U32),
     /* 209463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209470 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209484 */     GIR_RootConstrainSelectedInstOperands,
     /* 209485 */     // GIR_Coverage, 8197,
     /* 209485 */     GIR_EraseRootFromParent_Done,
     /* 209486 */   // Label 3312: @209486
     /* 209486 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(209543), // Rule ID 4030 //
     /* 209491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 209494 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209501 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 209514 */     // (atomic_load_umax:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 209514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_SADDR),
     /* 209517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 209522 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 209529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209541 */     GIR_RootConstrainSelectedInstOperands,
     /* 209542 */     // GIR_Coverage, 4030,
     /* 209542 */     GIR_EraseRootFromParent_Done,
     /* 209543 */   // Label 3313: @209543
     /* 209543 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(209604), // Rule ID 4032 //
     /* 209548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 209551 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 209573 */     // (atomic_load_umax:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (GLOBAL_ATOMIC_UMAX_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 209573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_SADDR_RTN),
     /* 209576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 209583 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 209590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209602 */     GIR_RootConstrainSelectedInstOperands,
     /* 209603 */     // GIR_Coverage, 4032,
     /* 209603 */     GIR_EraseRootFromParent_Done,
     /* 209604 */   // Label 3314: @209604
     /* 209604 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(209656), // Rule ID 4029 //
     /* 209609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 209612 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209619 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 209632 */     // (atomic_load_umax:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 209632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX),
     /* 209635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 209640 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209654 */     GIR_RootConstrainSelectedInstOperands,
     /* 209655 */     // GIR_Coverage, 4029,
     /* 209655 */     GIR_EraseRootFromParent_Done,
     /* 209656 */   // Label 3315: @209656
     /* 209656 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(209712), // Rule ID 4031 //
     /* 209661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 209664 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 209686 */     // (atomic_load_umax:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (GLOBAL_ATOMIC_UMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 209686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_RTN),
     /* 209689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 209696 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209710 */     GIR_RootConstrainSelectedInstOperands,
     /* 209711 */     // GIR_Coverage, 4031,
     /* 209711 */     GIR_EraseRootFromParent_Done,
     /* 209712 */   // Label 3316: @209712
     /* 209712 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(209765), // Rule ID 3676 //
     /* 209717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 209720 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209728 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 209741 */     // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_flat_noret_i32>>  =>  (FLAT_ATOMIC_UMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 209741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX),
     /* 209744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 209749 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209763 */     GIR_RootConstrainSelectedInstOperands,
     /* 209764 */     // GIR_Coverage, 3676,
     /* 209764 */     GIR_EraseRootFromParent_Done,
     /* 209765 */   // Label 3317: @209765
     /* 209765 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(209817), // Rule ID 3736 //
     /* 209770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 209773 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209780 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 209793 */     // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (FLAT_ATOMIC_UMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 209793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX),
     /* 209796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 209801 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209815 */     GIR_RootConstrainSelectedInstOperands,
     /* 209816 */     // GIR_Coverage, 3736,
     /* 209816 */     GIR_EraseRootFromParent_Done,
     /* 209817 */   // Label 3318: @209817
     /* 209817 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(209874), // Rule ID 3675 //
     /* 209822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 209825 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 209848 */     // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_flat_i32>>  =>  (FLAT_ATOMIC_UMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 209848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_RTN),
     /* 209851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 209858 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209872 */     GIR_RootConstrainSelectedInstOperands,
     /* 209873 */     // GIR_Coverage, 3675,
     /* 209873 */     GIR_EraseRootFromParent_Done,
     /* 209874 */   // Label 3319: @209874
     /* 209874 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(209930), // Rule ID 3735 //
     /* 209879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 209882 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 209893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 209904 */     // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (FLAT_ATOMIC_UMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 209904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_RTN),
     /* 209907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 209914 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209928 */     GIR_RootConstrainSelectedInstOperands,
     /* 209929 */     // GIR_Coverage, 3735,
     /* 209929 */     GIR_EraseRootFromParent_Done,
     /* 209930 */   // Label 3320: @209930
     /* 209930 */   GIM_Reject,
     /* 209931 */ // Label 3298: @209931
     /* 209931 */ GIM_Reject,
     /* 209932 */ // Label 3296: @209932
     /* 209932 */ GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(211177),
     /* 209937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 209940 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(210002), // Rule ID 5721 //
     /* 209945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 209948 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209955 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 209968 */     // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_ADDR64),
     /* 209971 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 209978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 209988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 209993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210000 */     GIR_RootConstrainSelectedInstOperands,
     /* 210001 */     // GIR_Coverage, 5721,
     /* 210001 */     GIR_EraseRootFromParent_Done,
     /* 210002 */   // Label 3322: @210002
     /* 210002 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(210061), // Rule ID 5725 //
     /* 210007 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210014 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 210027 */     // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64),
     /* 210030 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 210037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 210047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 210052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210059 */     GIR_RootConstrainSelectedInstOperands,
     /* 210060 */     // GIR_Coverage, 5725,
     /* 210060 */     GIR_EraseRootFromParent_Done,
     /* 210061 */   // Label 3323: @210061
     /* 210061 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(210127), // Rule ID 5719 //
     /* 210066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 210069 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 210091 */     // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_ADDR64_RTN),
     /* 210094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 210096 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 210103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 210113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 210118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210125 */     GIR_RootConstrainSelectedInstOperands,
     /* 210126 */     // GIR_Coverage, 5719,
     /* 210126 */     GIR_EraseRootFromParent_Done,
     /* 210127 */   // Label 3324: @210127
     /* 210127 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(210190), // Rule ID 5723 //
     /* 210132 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 210154 */     // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64_RTN),
     /* 210157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 210159 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 210166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 210176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 210181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210188 */     GIR_RootConstrainSelectedInstOperands,
     /* 210189 */     // GIR_Coverage, 5723,
     /* 210189 */     GIR_EraseRootFromParent_Done,
     /* 210190 */   // Label 3325: @210190
     /* 210190 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(210247), // Rule ID 5720 //
     /* 210195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 210198 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210205 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 210218 */     // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET),
     /* 210221 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 210233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210245 */     GIR_RootConstrainSelectedInstOperands,
     /* 210246 */     // GIR_Coverage, 5720,
     /* 210246 */     GIR_EraseRootFromParent_Done,
     /* 210247 */   // Label 3326: @210247
     /* 210247 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(210301), // Rule ID 5724 //
     /* 210252 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210259 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 210272 */     // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET),
     /* 210275 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 210287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210299 */     GIR_RootConstrainSelectedInstOperands,
     /* 210300 */     // GIR_Coverage, 5724,
     /* 210300 */     GIR_EraseRootFromParent_Done,
     /* 210301 */   // Label 3327: @210301
     /* 210301 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(210362), // Rule ID 5718 //
     /* 210306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 210309 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 210331 */     // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN),
     /* 210334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 210336 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 210348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210360 */     GIR_RootConstrainSelectedInstOperands,
     /* 210361 */     // GIR_Coverage, 5718,
     /* 210361 */     GIR_EraseRootFromParent_Done,
     /* 210362 */   // Label 3328: @210362
     /* 210362 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(210420), // Rule ID 5722 //
     /* 210367 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 210389 */     // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN),
     /* 210392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 210394 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 210406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210418 */     GIR_RootConstrainSelectedInstOperands,
     /* 210419 */     // GIR_Coverage, 5722,
     /* 210419 */     GIR_EraseRootFromParent_Done,
     /* 210420 */   // Label 3329: @210420
     /* 210420 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(210470), // Rule ID 8287 //
     /* 210425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 210428 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 210433 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210446 */     // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_m0_noret_i64>>  =>  (DS_MAX_U64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 210446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U64),
     /* 210449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210454 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210468 */     GIR_RootConstrainSelectedInstOperands,
     /* 210469 */     // GIR_Coverage, 8287,
     /* 210469 */     GIR_EraseRootFromParent_Done,
     /* 210470 */   // Label 3330: @210470
     /* 210470 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(210520), // Rule ID 8289 //
     /* 210475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 210478 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 210483 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210496 */     // (atomic_load_umax:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_noret_i64>>  =>  (DS_MAX_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 210496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U64_gfx9),
     /* 210499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210504 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210518 */     GIR_RootConstrainSelectedInstOperands,
     /* 210519 */     // GIR_Coverage, 8289,
     /* 210519 */     GIR_EraseRootFromParent_Done,
     /* 210520 */   // Label 3331: @210520
     /* 210520 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(210570), // Rule ID 8291 //
     /* 210525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 210528 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 210533 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210546 */     // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_region_m0_noret_i64>>  =>  (DS_MAX_U64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 210546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U64),
     /* 210549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210554 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210568 */     GIR_RootConstrainSelectedInstOperands,
     /* 210569 */     // GIR_Coverage, 8291,
     /* 210569 */     GIR_EraseRootFromParent_Done,
     /* 210570 */   // Label 3332: @210570
     /* 210570 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(210624), // Rule ID 8286 //
     /* 210575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 210578 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 210583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210598 */     // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_m0_i64>>  =>  (DS_MAX_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 210598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U64),
     /* 210601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210608 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210622 */     GIR_RootConstrainSelectedInstOperands,
     /* 210623 */     // GIR_Coverage, 8286,
     /* 210623 */     GIR_EraseRootFromParent_Done,
     /* 210624 */   // Label 3333: @210624
     /* 210624 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(210678), // Rule ID 8288 //
     /* 210629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 210632 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 210637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210652 */     // (atomic_load_umax:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_i64>>  =>  (DS_MAX_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 210652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U64_gfx9),
     /* 210655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210662 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210676 */     GIR_RootConstrainSelectedInstOperands,
     /* 210677 */     // GIR_Coverage, 8288,
     /* 210677 */     GIR_EraseRootFromParent_Done,
     /* 210678 */   // Label 3334: @210678
     /* 210678 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(210732), // Rule ID 8290 //
     /* 210683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 210686 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 210691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210706 */     // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_region_m0_i64>>  =>  (DS_MAX_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 210706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U64),
     /* 210709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210716 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210730 */     GIR_RootConstrainSelectedInstOperands,
     /* 210731 */     // GIR_Coverage, 8290,
     /* 210731 */     GIR_EraseRootFromParent_Done,
     /* 210732 */   // Label 3335: @210732
     /* 210732 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(210789), // Rule ID 4086 //
     /* 210737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 210740 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210747 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 210760 */     // (atomic_load_umax:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 210760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2_SADDR),
     /* 210763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 210768 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 210770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 210775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210787 */     GIR_RootConstrainSelectedInstOperands,
     /* 210788 */     // GIR_Coverage, 4086,
     /* 210788 */     GIR_EraseRootFromParent_Done,
     /* 210789 */   // Label 3336: @210789
     /* 210789 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(210850), // Rule ID 4088 //
     /* 210794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 210797 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 210819 */     // (atomic_load_umax:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 210819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2_SADDR_RTN),
     /* 210822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 210829 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 210831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 210836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210848 */     GIR_RootConstrainSelectedInstOperands,
     /* 210849 */     // GIR_Coverage, 4088,
     /* 210849 */     GIR_EraseRootFromParent_Done,
     /* 210850 */   // Label 3337: @210850
     /* 210850 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(210902), // Rule ID 4085 //
     /* 210855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 210858 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210865 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 210878 */     // (atomic_load_umax:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 210878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2),
     /* 210881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 210886 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 210888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210900 */     GIR_RootConstrainSelectedInstOperands,
     /* 210901 */     // GIR_Coverage, 4085,
     /* 210901 */     GIR_EraseRootFromParent_Done,
     /* 210902 */   // Label 3338: @210902
     /* 210902 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(210958), // Rule ID 4087 //
     /* 210907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 210910 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 210932 */     // (atomic_load_umax:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 210932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2_RTN),
     /* 210935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 210942 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 210944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210956 */     GIR_RootConstrainSelectedInstOperands,
     /* 210957 */     // GIR_Coverage, 4087,
     /* 210957 */     GIR_EraseRootFromParent_Done,
     /* 210958 */   // Label 3339: @210958
     /* 210958 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(211011), // Rule ID 3702 //
     /* 210963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 210966 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210974 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 210987 */     // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_flat_noret_i64>>  =>  (FLAT_ATOMIC_UMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 210987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2),
     /* 210990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 210995 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 210997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211009 */     GIR_RootConstrainSelectedInstOperands,
     /* 211010 */     // GIR_Coverage, 3702,
     /* 211010 */     GIR_EraseRootFromParent_Done,
     /* 211011 */   // Label 3340: @211011
     /* 211011 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(211063), // Rule ID 3762 //
     /* 211016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 211019 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211026 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 211039 */     // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (FLAT_ATOMIC_UMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 211039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2),
     /* 211042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211047 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211061 */     GIR_RootConstrainSelectedInstOperands,
     /* 211062 */     // GIR_Coverage, 3762,
     /* 211062 */     GIR_EraseRootFromParent_Done,
     /* 211063 */   // Label 3341: @211063
     /* 211063 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(211120), // Rule ID 3701 //
     /* 211068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 211071 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 211083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 211094 */     // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_flat_i64>>  =>  (FLAT_ATOMIC_UMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 211094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2_RTN),
     /* 211097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 211099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211104 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211118 */     GIR_RootConstrainSelectedInstOperands,
     /* 211119 */     // GIR_Coverage, 3701,
     /* 211119 */     GIR_EraseRootFromParent_Done,
     /* 211120 */   // Label 3342: @211120
     /* 211120 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(211176), // Rule ID 3761 //
     /* 211125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 211128 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 211139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 211150 */     // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (FLAT_ATOMIC_UMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 211150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2_RTN),
     /* 211153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 211155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211160 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211174 */     GIR_RootConstrainSelectedInstOperands,
     /* 211175 */     // GIR_Coverage, 3761,
     /* 211175 */     GIR_EraseRootFromParent_Done,
     /* 211176 */   // Label 3343: @211176
     /* 211176 */   GIM_Reject,
     /* 211177 */ // Label 3321: @211177
     /* 211177 */ GIM_Reject,
     /* 211178 */ // Label 3297: @211178
     /* 211178 */ GIM_Reject,
     /* 211179 */ // Label 28: @211179
     /* 211179 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3346*/ GIMT_Encode4(213690),
     /* 211190 */ /*GILLT_s32*//*Label 3344*/ GIMT_Encode4(211198),
     /* 211194 */ /*GILLT_s64*//*Label 3345*/ GIMT_Encode4(212444),
     /* 211198 */ // Label 3344: @211198
     /* 211198 */ GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(212443),
     /* 211203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211206 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(211268), // Rule ID 5609 //
     /* 211211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 211214 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211221 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 211234 */     // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_ADDR64),
     /* 211237 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 211244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 211254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 211259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211266 */     GIR_RootConstrainSelectedInstOperands,
     /* 211267 */     // GIR_Coverage, 5609,
     /* 211267 */     GIR_EraseRootFromParent_Done,
     /* 211268 */   // Label 3348: @211268
     /* 211268 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(211327), // Rule ID 5613 //
     /* 211273 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211280 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 211293 */     // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64),
     /* 211296 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 211303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 211313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 211318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211325 */     GIR_RootConstrainSelectedInstOperands,
     /* 211326 */     // GIR_Coverage, 5613,
     /* 211326 */     GIR_EraseRootFromParent_Done,
     /* 211327 */   // Label 3349: @211327
     /* 211327 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(211393), // Rule ID 5607 //
     /* 211332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 211335 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 211357 */     // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_ADDR64_RTN),
     /* 211360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 211362 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 211369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 211379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 211384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211391 */     GIR_RootConstrainSelectedInstOperands,
     /* 211392 */     // GIR_Coverage, 5607,
     /* 211392 */     GIR_EraseRootFromParent_Done,
     /* 211393 */   // Label 3350: @211393
     /* 211393 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(211456), // Rule ID 5611 //
     /* 211398 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 211420 */     // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64_RTN),
     /* 211423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 211425 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 211432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 211442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 211447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211454 */     GIR_RootConstrainSelectedInstOperands,
     /* 211455 */     // GIR_Coverage, 5611,
     /* 211455 */     GIR_EraseRootFromParent_Done,
     /* 211456 */   // Label 3351: @211456
     /* 211456 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(211513), // Rule ID 5608 //
     /* 211461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 211464 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211471 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 211484 */     // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET),
     /* 211487 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 211499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211511 */     GIR_RootConstrainSelectedInstOperands,
     /* 211512 */     // GIR_Coverage, 5608,
     /* 211512 */     GIR_EraseRootFromParent_Done,
     /* 211513 */   // Label 3352: @211513
     /* 211513 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(211567), // Rule ID 5612 //
     /* 211518 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211525 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 211538 */     // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET),
     /* 211541 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 211553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211565 */     GIR_RootConstrainSelectedInstOperands,
     /* 211566 */     // GIR_Coverage, 5612,
     /* 211566 */     GIR_EraseRootFromParent_Done,
     /* 211567 */   // Label 3353: @211567
     /* 211567 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(211628), // Rule ID 5606 //
     /* 211572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 211575 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 211597 */     // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET_RTN),
     /* 211600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 211602 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 211614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211626 */     GIR_RootConstrainSelectedInstOperands,
     /* 211627 */     // GIR_Coverage, 5606,
     /* 211627 */     GIR_EraseRootFromParent_Done,
     /* 211628 */   // Label 3354: @211628
     /* 211628 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(211686), // Rule ID 5610 //
     /* 211633 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 211655 */     // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN),
     /* 211658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 211660 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 211672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211684 */     GIR_RootConstrainSelectedInstOperands,
     /* 211685 */     // GIR_Coverage, 5610,
     /* 211685 */     GIR_EraseRootFromParent_Done,
     /* 211686 */   // Label 3355: @211686
     /* 211686 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(211736), // Rule ID 8188 //
     /* 211691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 211694 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 211699 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 211712 */     // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_m0_noret_i32>>  =>  (DS_MIN_U32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 211712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U32),
     /* 211715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 211720 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 211722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211734 */     GIR_RootConstrainSelectedInstOperands,
     /* 211735 */     // GIR_Coverage, 8188,
     /* 211735 */     GIR_EraseRootFromParent_Done,
     /* 211736 */   // Label 3356: @211736
     /* 211736 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(211786), // Rule ID 8190 //
     /* 211741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 211744 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 211749 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 211762 */     // (atomic_load_umin:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_noret_i32>>  =>  (DS_MIN_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 211762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U32_gfx9),
     /* 211765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 211770 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 211772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211784 */     GIR_RootConstrainSelectedInstOperands,
     /* 211785 */     // GIR_Coverage, 8190,
     /* 211785 */     GIR_EraseRootFromParent_Done,
     /* 211786 */   // Label 3357: @211786
     /* 211786 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(211836), // Rule ID 8192 //
     /* 211791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 211794 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 211799 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 211812 */     // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_region_m0_noret_i32>>  =>  (DS_MIN_U32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 211812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U32),
     /* 211815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 211820 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 211822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211834 */     GIR_RootConstrainSelectedInstOperands,
     /* 211835 */     // GIR_Coverage, 8192,
     /* 211835 */     GIR_EraseRootFromParent_Done,
     /* 211836 */   // Label 3358: @211836
     /* 211836 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(211890), // Rule ID 8187 //
     /* 211841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 211844 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 211849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 211864 */     // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_m0_i32>>  =>  (DS_MIN_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 211864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U32),
     /* 211867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 211869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 211874 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 211876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211888 */     GIR_RootConstrainSelectedInstOperands,
     /* 211889 */     // GIR_Coverage, 8187,
     /* 211889 */     GIR_EraseRootFromParent_Done,
     /* 211890 */   // Label 3359: @211890
     /* 211890 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(211944), // Rule ID 8189 //
     /* 211895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 211898 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 211903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 211918 */     // (atomic_load_umin:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_i32>>  =>  (DS_MIN_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 211918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U32_gfx9),
     /* 211921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 211923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 211928 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 211930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211942 */     GIR_RootConstrainSelectedInstOperands,
     /* 211943 */     // GIR_Coverage, 8189,
     /* 211943 */     GIR_EraseRootFromParent_Done,
     /* 211944 */   // Label 3360: @211944
     /* 211944 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(211998), // Rule ID 8191 //
     /* 211949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 211952 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 211957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 211972 */     // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_region_m0_i32>>  =>  (DS_MIN_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 211972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U32),
     /* 211975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 211977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 211982 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 211984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211996 */     GIR_RootConstrainSelectedInstOperands,
     /* 211997 */     // GIR_Coverage, 8191,
     /* 211997 */     GIR_EraseRootFromParent_Done,
     /* 211998 */   // Label 3361: @211998
     /* 211998 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(212055), // Rule ID 4038 //
     /* 212003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 212006 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212013 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 212026 */     // (atomic_load_umin:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 212026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_SADDR),
     /* 212029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 212034 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 212041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 212046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212053 */     GIR_RootConstrainSelectedInstOperands,
     /* 212054 */     // GIR_Coverage, 4038,
     /* 212054 */     GIR_EraseRootFromParent_Done,
     /* 212055 */   // Label 3362: @212055
     /* 212055 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(212116), // Rule ID 4040 //
     /* 212060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 212063 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 212074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 212085 */     // (atomic_load_umin:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (GLOBAL_ATOMIC_UMIN_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 212085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_SADDR_RTN),
     /* 212088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 212095 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 212102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 212107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212114 */     GIR_RootConstrainSelectedInstOperands,
     /* 212115 */     // GIR_Coverage, 4040,
     /* 212115 */     GIR_EraseRootFromParent_Done,
     /* 212116 */   // Label 3363: @212116
     /* 212116 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(212168), // Rule ID 4037 //
     /* 212121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 212124 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212131 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 212144 */     // (atomic_load_umin:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 212144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN),
     /* 212147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212152 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212166 */     GIR_RootConstrainSelectedInstOperands,
     /* 212167 */     // GIR_Coverage, 4037,
     /* 212167 */     GIR_EraseRootFromParent_Done,
     /* 212168 */   // Label 3364: @212168
     /* 212168 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(212224), // Rule ID 4039 //
     /* 212173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 212176 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 212187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 212198 */     // (atomic_load_umin:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (GLOBAL_ATOMIC_UMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 212198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_RTN),
     /* 212201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212208 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212222 */     GIR_RootConstrainSelectedInstOperands,
     /* 212223 */     // GIR_Coverage, 4039,
     /* 212223 */     GIR_EraseRootFromParent_Done,
     /* 212224 */   // Label 3365: @212224
     /* 212224 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(212277), // Rule ID 3680 //
     /* 212229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 212232 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212240 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 212253 */     // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_flat_noret_i32>>  =>  (FLAT_ATOMIC_UMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 212253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN),
     /* 212256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212261 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212275 */     GIR_RootConstrainSelectedInstOperands,
     /* 212276 */     // GIR_Coverage, 3680,
     /* 212276 */     GIR_EraseRootFromParent_Done,
     /* 212277 */   // Label 3366: @212277
     /* 212277 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(212329), // Rule ID 3740 //
     /* 212282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 212285 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212292 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 212305 */     // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (FLAT_ATOMIC_UMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 212305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN),
     /* 212308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212313 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212327 */     GIR_RootConstrainSelectedInstOperands,
     /* 212328 */     // GIR_Coverage, 3740,
     /* 212328 */     GIR_EraseRootFromParent_Done,
     /* 212329 */   // Label 3367: @212329
     /* 212329 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(212386), // Rule ID 3679 //
     /* 212334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 212337 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 212349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 212360 */     // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_flat_i32>>  =>  (FLAT_ATOMIC_UMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 212360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_RTN),
     /* 212363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212370 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212384 */     GIR_RootConstrainSelectedInstOperands,
     /* 212385 */     // GIR_Coverage, 3679,
     /* 212385 */     GIR_EraseRootFromParent_Done,
     /* 212386 */   // Label 3368: @212386
     /* 212386 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(212442), // Rule ID 3739 //
     /* 212391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 212394 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 212405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 212416 */     // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (FLAT_ATOMIC_UMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 212416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_RTN),
     /* 212419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212426 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212440 */     GIR_RootConstrainSelectedInstOperands,
     /* 212441 */     // GIR_Coverage, 3739,
     /* 212441 */     GIR_EraseRootFromParent_Done,
     /* 212442 */   // Label 3369: @212442
     /* 212442 */   GIM_Reject,
     /* 212443 */ // Label 3347: @212443
     /* 212443 */ GIM_Reject,
     /* 212444 */ // Label 3345: @212444
     /* 212444 */ GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(213689),
     /* 212449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212452 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(212514), // Rule ID 5705 //
     /* 212457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 212460 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212467 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 212480 */     // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_ADDR64),
     /* 212483 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 212490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 212500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 212505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212512 */     GIR_RootConstrainSelectedInstOperands,
     /* 212513 */     // GIR_Coverage, 5705,
     /* 212513 */     GIR_EraseRootFromParent_Done,
     /* 212514 */   // Label 3371: @212514
     /* 212514 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(212573), // Rule ID 5709 //
     /* 212519 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212526 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 212539 */     // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64),
     /* 212542 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 212549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 212559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 212564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212571 */     GIR_RootConstrainSelectedInstOperands,
     /* 212572 */     // GIR_Coverage, 5709,
     /* 212572 */     GIR_EraseRootFromParent_Done,
     /* 212573 */   // Label 3372: @212573
     /* 212573 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(212639), // Rule ID 5703 //
     /* 212578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 212581 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 212592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 212603 */     // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_ADDR64_RTN),
     /* 212606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 212608 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 212615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 212625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 212630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212637 */     GIR_RootConstrainSelectedInstOperands,
     /* 212638 */     // GIR_Coverage, 5703,
     /* 212638 */     GIR_EraseRootFromParent_Done,
     /* 212639 */   // Label 3373: @212639
     /* 212639 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(212702), // Rule ID 5707 //
     /* 212644 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 212655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 212666 */     // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64_RTN),
     /* 212669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 212671 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 212678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 212688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 212693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212700 */     GIR_RootConstrainSelectedInstOperands,
     /* 212701 */     // GIR_Coverage, 5707,
     /* 212701 */     GIR_EraseRootFromParent_Done,
     /* 212702 */   // Label 3374: @212702
     /* 212702 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(212759), // Rule ID 5704 //
     /* 212707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 212710 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212717 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 212730 */     // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET),
     /* 212733 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 212745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 212750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212757 */     GIR_RootConstrainSelectedInstOperands,
     /* 212758 */     // GIR_Coverage, 5704,
     /* 212758 */     GIR_EraseRootFromParent_Done,
     /* 212759 */   // Label 3375: @212759
     /* 212759 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(212813), // Rule ID 5708 //
     /* 212764 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212771 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 212784 */     // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET),
     /* 212787 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 212799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 212804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212811 */     GIR_RootConstrainSelectedInstOperands,
     /* 212812 */     // GIR_Coverage, 5708,
     /* 212812 */     GIR_EraseRootFromParent_Done,
     /* 212813 */   // Label 3376: @212813
     /* 212813 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(212874), // Rule ID 5702 //
     /* 212818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 212821 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 212832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 212843 */     // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN),
     /* 212846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 212848 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 212860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 212865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212872 */     GIR_RootConstrainSelectedInstOperands,
     /* 212873 */     // GIR_Coverage, 5702,
     /* 212873 */     GIR_EraseRootFromParent_Done,
     /* 212874 */   // Label 3377: @212874
     /* 212874 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(212932), // Rule ID 5706 //
     /* 212879 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 212890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 212901 */     // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN),
     /* 212904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 212906 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 212918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 212923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212930 */     GIR_RootConstrainSelectedInstOperands,
     /* 212931 */     // GIR_Coverage, 5706,
     /* 212931 */     GIR_EraseRootFromParent_Done,
     /* 212932 */   // Label 3378: @212932
     /* 212932 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(212982), // Rule ID 8281 //
     /* 212937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 212940 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 212945 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 212958 */     // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_m0_noret_i64>>  =>  (DS_MIN_U64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 212958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U64),
     /* 212961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 212966 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 212968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212980 */     GIR_RootConstrainSelectedInstOperands,
     /* 212981 */     // GIR_Coverage, 8281,
     /* 212981 */     GIR_EraseRootFromParent_Done,
     /* 212982 */   // Label 3379: @212982
     /* 212982 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(213032), // Rule ID 8283 //
     /* 212987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 212990 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 212995 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213008 */     // (atomic_load_umin:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_noret_i64>>  =>  (DS_MIN_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U64_gfx9),
     /* 213011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213016 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213030 */     GIR_RootConstrainSelectedInstOperands,
     /* 213031 */     // GIR_Coverage, 8283,
     /* 213031 */     GIR_EraseRootFromParent_Done,
     /* 213032 */   // Label 3380: @213032
     /* 213032 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(213082), // Rule ID 8285 //
     /* 213037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 213040 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 213045 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213058 */     // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_region_m0_noret_i64>>  =>  (DS_MIN_U64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 213058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U64),
     /* 213061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213066 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213080 */     GIR_RootConstrainSelectedInstOperands,
     /* 213081 */     // GIR_Coverage, 8285,
     /* 213081 */     GIR_EraseRootFromParent_Done,
     /* 213082 */   // Label 3381: @213082
     /* 213082 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(213136), // Rule ID 8280 //
     /* 213087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 213090 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213110 */     // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_m0_i64>>  =>  (DS_MIN_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U64),
     /* 213113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213120 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213134 */     GIR_RootConstrainSelectedInstOperands,
     /* 213135 */     // GIR_Coverage, 8280,
     /* 213135 */     GIR_EraseRootFromParent_Done,
     /* 213136 */   // Label 3382: @213136
     /* 213136 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(213190), // Rule ID 8282 //
     /* 213141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 213144 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213164 */     // (atomic_load_umin:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_i64>>  =>  (DS_MIN_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U64_gfx9),
     /* 213167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213174 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213188 */     GIR_RootConstrainSelectedInstOperands,
     /* 213189 */     // GIR_Coverage, 8282,
     /* 213189 */     GIR_EraseRootFromParent_Done,
     /* 213190 */   // Label 3383: @213190
     /* 213190 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(213244), // Rule ID 8284 //
     /* 213195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 213198 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 213203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213218 */     // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_region_m0_i64>>  =>  (DS_MIN_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 213218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U64),
     /* 213221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213228 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213242 */     GIR_RootConstrainSelectedInstOperands,
     /* 213243 */     // GIR_Coverage, 8284,
     /* 213243 */     GIR_EraseRootFromParent_Done,
     /* 213244 */   // Label 3384: @213244
     /* 213244 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(213301), // Rule ID 4094 //
     /* 213249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 213252 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213259 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 213272 */     // (atomic_load_umin:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 213272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2_SADDR),
     /* 213275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 213280 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 213287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 213292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213299 */     GIR_RootConstrainSelectedInstOperands,
     /* 213300 */     // GIR_Coverage, 4094,
     /* 213300 */     GIR_EraseRootFromParent_Done,
     /* 213301 */   // Label 3385: @213301
     /* 213301 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(213362), // Rule ID 4096 //
     /* 213306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 213309 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 213331 */     // (atomic_load_umin:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 213331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2_SADDR_RTN),
     /* 213334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 213341 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 213348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 213353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213360 */     GIR_RootConstrainSelectedInstOperands,
     /* 213361 */     // GIR_Coverage, 4096,
     /* 213361 */     GIR_EraseRootFromParent_Done,
     /* 213362 */   // Label 3386: @213362
     /* 213362 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(213414), // Rule ID 4093 //
     /* 213367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 213370 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213377 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 213390 */     // (atomic_load_umin:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 213390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2),
     /* 213393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213398 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213412 */     GIR_RootConstrainSelectedInstOperands,
     /* 213413 */     // GIR_Coverage, 4093,
     /* 213413 */     GIR_EraseRootFromParent_Done,
     /* 213414 */   // Label 3387: @213414
     /* 213414 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(213470), // Rule ID 4095 //
     /* 213419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 213422 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 213444 */     // (atomic_load_umin:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 213444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2_RTN),
     /* 213447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213454 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213468 */     GIR_RootConstrainSelectedInstOperands,
     /* 213469 */     // GIR_Coverage, 4095,
     /* 213469 */     GIR_EraseRootFromParent_Done,
     /* 213470 */   // Label 3388: @213470
     /* 213470 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(213523), // Rule ID 3706 //
     /* 213475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 213478 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213486 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 213499 */     // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_flat_noret_i64>>  =>  (FLAT_ATOMIC_UMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 213499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2),
     /* 213502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213507 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213521 */     GIR_RootConstrainSelectedInstOperands,
     /* 213522 */     // GIR_Coverage, 3706,
     /* 213522 */     GIR_EraseRootFromParent_Done,
     /* 213523 */   // Label 3389: @213523
     /* 213523 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(213575), // Rule ID 3766 //
     /* 213528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 213531 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213538 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 213551 */     // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (FLAT_ATOMIC_UMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 213551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2),
     /* 213554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213559 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213573 */     GIR_RootConstrainSelectedInstOperands,
     /* 213574 */     // GIR_Coverage, 3766,
     /* 213574 */     GIR_EraseRootFromParent_Done,
     /* 213575 */   // Label 3390: @213575
     /* 213575 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(213632), // Rule ID 3705 //
     /* 213580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 213583 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 213606 */     // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_flat_i64>>  =>  (FLAT_ATOMIC_UMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 213606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2_RTN),
     /* 213609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213616 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213630 */     GIR_RootConstrainSelectedInstOperands,
     /* 213631 */     // GIR_Coverage, 3705,
     /* 213631 */     GIR_EraseRootFromParent_Done,
     /* 213632 */   // Label 3391: @213632
     /* 213632 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(213688), // Rule ID 3765 //
     /* 213637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 213640 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 213651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 213662 */     // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (FLAT_ATOMIC_UMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 213662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2_RTN),
     /* 213665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213672 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213686 */     GIR_RootConstrainSelectedInstOperands,
     /* 213687 */     // GIR_Coverage, 3765,
     /* 213687 */     GIR_EraseRootFromParent_Done,
     /* 213688 */   // Label 3392: @213688
     /* 213688 */   GIM_Reject,
     /* 213689 */ // Label 3370: @213689
     /* 213689 */ GIM_Reject,
     /* 213690 */ // Label 3346: @213690
     /* 213690 */ GIM_Reject,
     /* 213691 */ // Label 29: @213691
     /* 213691 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 3396*/ GIMT_Encode4(215901),
     /* 213702 */ /*GILLT_s32*//*Label 3393*/ GIMT_Encode4(213714),
     /* 213706 */ /*GILLT_s64*//*Label 3394*/ GIMT_Encode4(214372),
     /* 213710 */ /*GILLT_v2s16*//*Label 3395*/ GIMT_Encode4(214822),
     /* 213714 */ // Label 3393: @213714
     /* 213714 */ GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(214371),
     /* 213719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213722 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(213772), // Rule ID 8218 //
     /* 213727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_LDSRequiresM0Init),
     /* 213730 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213735 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213748 */     // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_noret_f32>>  =>  (DS_ADD_F32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F32),
     /* 213751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213756 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213770 */     GIR_RootConstrainSelectedInstOperands,
     /* 213771 */     // GIR_Coverage, 8218,
     /* 213771 */     GIR_EraseRootFromParent_Done,
     /* 213772 */   // Label 3398: @213772
     /* 213772 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(213822), // Rule ID 8220 //
     /* 213777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_NotLDSRequiresM0Init),
     /* 213780 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213785 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213798 */     // (atomic_load_fadd:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_f32>>  =>  (DS_ADD_F32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F32_gfx9),
     /* 213801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213806 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213820 */     GIR_RootConstrainSelectedInstOperands,
     /* 213821 */     // GIR_Coverage, 8220,
     /* 213821 */     GIR_EraseRootFromParent_Done,
     /* 213822 */   // Label 3399: @213822
     /* 213822 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(213872), // Rule ID 8222 //
     /* 213827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_HasLDSFPAtomicAddF32),
     /* 213830 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 213835 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213848 */     // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_noret_f32>>  =>  (DS_ADD_F32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 213848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F32),
     /* 213851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213856 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213870 */     GIR_RootConstrainSelectedInstOperands,
     /* 213871 */     // GIR_Coverage, 8222,
     /* 213871 */     GIR_EraseRootFromParent_Done,
     /* 213872 */   // Label 3400: @213872
     /* 213872 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(213926), // Rule ID 8217 //
     /* 213877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_LDSRequiresM0Init),
     /* 213880 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 213889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213900 */     // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_f32>>  =>  (DS_ADD_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F32),
     /* 213903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213910 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213924 */     GIR_RootConstrainSelectedInstOperands,
     /* 213925 */     // GIR_Coverage, 8217,
     /* 213925 */     GIR_EraseRootFromParent_Done,
     /* 213926 */   // Label 3401: @213926
     /* 213926 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(213980), // Rule ID 8219 //
     /* 213931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_NotLDSRequiresM0Init),
     /* 213934 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 213943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213954 */     // (atomic_load_fadd:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_f32>>  =>  (DS_ADD_RTN_F32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F32_gfx9),
     /* 213957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213964 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213978 */     GIR_RootConstrainSelectedInstOperands,
     /* 213979 */     // GIR_Coverage, 8219,
     /* 213979 */     GIR_EraseRootFromParent_Done,
     /* 213980 */   // Label 3402: @213980
     /* 213980 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(214034), // Rule ID 8221 //
     /* 213985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_HasLDSFPAtomicAddF32),
     /* 213988 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 213993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 213997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214008 */     // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_f32>>  =>  (DS_ADD_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 214008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F32),
     /* 214011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214018 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214032 */     GIR_RootConstrainSelectedInstOperands,
     /* 214033 */     // GIR_Coverage, 8221,
     /* 214033 */     GIR_EraseRootFromParent_Done,
     /* 214034 */   // Label 3403: @214034
     /* 214034 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(214091), // Rule ID 4156 //
     /* 214039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 214042 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214049 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 214062 */     // (atomic_load_fadd:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 214062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32_SADDR),
     /* 214065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 214070 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 214077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214089 */     GIR_RootConstrainSelectedInstOperands,
     /* 214090 */     // GIR_Coverage, 4156,
     /* 214090 */     GIR_EraseRootFromParent_Done,
     /* 214091 */   // Label 3404: @214091
     /* 214091 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(214152), // Rule ID 4160 //
     /* 214096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 214099 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 214110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 214121 */     // (atomic_load_fadd:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 214121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32_SADDR_RTN),
     /* 214124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 214131 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 214138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214150 */     GIR_RootConstrainSelectedInstOperands,
     /* 214151 */     // GIR_Coverage, 4160,
     /* 214151 */     GIR_EraseRootFromParent_Done,
     /* 214152 */   // Label 3405: @214152
     /* 214152 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(214204), // Rule ID 4155 //
     /* 214157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 214160 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214167 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 214180 */     // (atomic_load_fadd:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 214180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32),
     /* 214183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214188 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214202 */     GIR_RootConstrainSelectedInstOperands,
     /* 214203 */     // GIR_Coverage, 4155,
     /* 214203 */     GIR_EraseRootFromParent_Done,
     /* 214204 */   // Label 3406: @214204
     /* 214204 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(214260), // Rule ID 4159 //
     /* 214209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 214212 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 214223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 214234 */     // (atomic_load_fadd:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 214234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32_RTN),
     /* 214237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214244 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214258 */     GIR_RootConstrainSelectedInstOperands,
     /* 214259 */     // GIR_Coverage, 4159,
     /* 214259 */     GIR_EraseRootFromParent_Done,
     /* 214260 */   // Label 3407: @214260
     /* 214260 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(214313), // Rule ID 4180 //
     /* 214265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAtomicFaddF32Inst),
     /* 214268 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214276 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 214289 */     // (atomic_load_fadd:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_flat_noret_f32>>  =>  (FLAT_ATOMIC_ADD_F32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 214289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F32),
     /* 214292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214297 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214311 */     GIR_RootConstrainSelectedInstOperands,
     /* 214312 */     // GIR_Coverage, 4180,
     /* 214312 */     GIR_EraseRootFromParent_Done,
     /* 214313 */   // Label 3408: @214313
     /* 214313 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(214370), // Rule ID 4179 //
     /* 214318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAtomicFaddF32Inst),
     /* 214321 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 214333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 214344 */     // (atomic_load_fadd:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_flat_f32>>  =>  (FLAT_ATOMIC_ADD_F32_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 214344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F32_RTN),
     /* 214347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214354 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214368 */     GIR_RootConstrainSelectedInstOperands,
     /* 214369 */     // GIR_Coverage, 4179,
     /* 214369 */     GIR_EraseRootFromParent_Done,
     /* 214370 */   // Label 3409: @214370
     /* 214370 */   GIM_Reject,
     /* 214371 */ // Label 3397: @214371
     /* 214371 */ GIM_Reject,
     /* 214372 */ // Label 3394: @214372
     /* 214372 */ GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(214821),
     /* 214377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214380 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(214430), // Rule ID 8315 //
     /* 214385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLdsAtomicAddF64),
     /* 214388 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214393 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214406 */     // (atomic_load_fadd:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_f64>>  =>  (DS_ADD_F64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 214406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F64),
     /* 214409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214414 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214428 */     GIR_RootConstrainSelectedInstOperands,
     /* 214429 */     // GIR_Coverage, 8315,
     /* 214429 */     GIR_EraseRootFromParent_Done,
     /* 214430 */   // Label 3411: @214430
     /* 214430 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(214484), // Rule ID 8314 //
     /* 214435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLdsAtomicAddF64),
     /* 214438 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214458 */     // (atomic_load_fadd:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fadd_local_f64>>  =>  (DS_ADD_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 214458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F64),
     /* 214461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214468 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214482 */     GIR_RootConstrainSelectedInstOperands,
     /* 214483 */     // GIR_Coverage, 8314,
     /* 214483 */     GIR_EraseRootFromParent_Done,
     /* 214484 */   // Label 3412: @214484
     /* 214484 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(214541), // Rule ID 4174 //
     /* 214489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 214492 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214499 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 214512 */     // (atomic_load_fadd:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 214512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64_SADDR),
     /* 214515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 214520 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 214527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214539 */     GIR_RootConstrainSelectedInstOperands,
     /* 214540 */     // GIR_Coverage, 4174,
     /* 214540 */     GIR_EraseRootFromParent_Done,
     /* 214541 */   // Label 3413: @214541
     /* 214541 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(214602), // Rule ID 4176 //
     /* 214546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 214549 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 214571 */     // (atomic_load_fadd:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64_SADDR_RTN:{ *:[f64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 214571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64_SADDR_RTN),
     /* 214574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 214581 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 214588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214600 */     GIR_RootConstrainSelectedInstOperands,
     /* 214601 */     // GIR_Coverage, 4176,
     /* 214601 */     GIR_EraseRootFromParent_Done,
     /* 214602 */   // Label 3414: @214602
     /* 214602 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(214654), // Rule ID 4173 //
     /* 214607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 214610 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214617 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 214630 */     // (atomic_load_fadd:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 214630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64),
     /* 214633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214638 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214652 */     GIR_RootConstrainSelectedInstOperands,
     /* 214653 */     // GIR_Coverage, 4173,
     /* 214653 */     GIR_EraseRootFromParent_Done,
     /* 214654 */   // Label 3415: @214654
     /* 214654 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(214710), // Rule ID 4175 //
     /* 214659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 214662 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 214684 */     // (atomic_load_fadd:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 214684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64_RTN),
     /* 214687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214694 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214708 */     GIR_RootConstrainSelectedInstOperands,
     /* 214709 */     // GIR_Coverage, 4175,
     /* 214709 */     GIR_EraseRootFromParent_Done,
     /* 214710 */   // Label 3416: @214710
     /* 214710 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(214763), // Rule ID 4178 //
     /* 214715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 214718 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214726 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 214739 */     // (atomic_load_fadd:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_flat_noret_f64>>  =>  (FLAT_ATOMIC_ADD_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 214739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F64),
     /* 214742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214747 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214761 */     GIR_RootConstrainSelectedInstOperands,
     /* 214762 */     // GIR_Coverage, 4178,
     /* 214762 */     GIR_EraseRootFromParent_Done,
     /* 214763 */   // Label 3417: @214763
     /* 214763 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(214820), // Rule ID 4177 //
     /* 214768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 214771 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 214794 */     // (atomic_load_fadd:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_flat_f64>>  =>  (FLAT_ATOMIC_ADD_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 214794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F64_RTN),
     /* 214797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214804 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214818 */     GIR_RootConstrainSelectedInstOperands,
     /* 214819 */     // GIR_Coverage, 4177,
     /* 214819 */     GIR_EraseRootFromParent_Done,
     /* 214820 */   // Label 3418: @214820
     /* 214820 */   GIM_Reject,
     /* 214821 */ // Label 3410: @214821
     /* 214821 */ GIM_Reject,
     /* 214822 */ // Label 3395: @214822
     /* 214822 */ GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(215900),
     /* 214827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 214830 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(214880), // Rule ID 8212 //
     /* 214835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
     /* 214838 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214843 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214856 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 214856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
     /* 214859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214864 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214878 */     GIR_RootConstrainSelectedInstOperands,
     /* 214879 */     // GIR_Coverage, 8212,
     /* 214879 */     GIR_EraseRootFromParent_Done,
     /* 214880 */   // Label 3420: @214880
     /* 214880 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(214930), // Rule ID 8214 //
     /* 214885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
     /* 214888 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214893 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214906 */     // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_v2f16>>  =>  (DS_PK_ADD_F16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 214906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16_gfx9),
     /* 214909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214914 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214928 */     GIR_RootConstrainSelectedInstOperands,
     /* 214929 */     // GIR_Coverage, 8214,
     /* 214929 */     GIR_EraseRootFromParent_Done,
     /* 214930 */   // Label 3421: @214930
     /* 214930 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(214980), // Rule ID 8216 //
     /* 214935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
     /* 214938 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 214943 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214956 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 214956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
     /* 214959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214964 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214978 */     GIR_RootConstrainSelectedInstOperands,
     /* 214979 */     // GIR_Coverage, 8216,
     /* 214979 */     GIR_EraseRootFromParent_Done,
     /* 214980 */   // Label 3422: @214980
     /* 214980 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(215030), // Rule ID 8317 //
     /* 214985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
     /* 214988 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214993 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215006 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
     /* 215009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215014 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215028 */     GIR_RootConstrainSelectedInstOperands,
     /* 215029 */     // GIR_Coverage, 8317,
     /* 215029 */     GIR_EraseRootFromParent_Done,
     /* 215030 */   // Label 3423: @215030
     /* 215030 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(215080), // Rule ID 8319 //
     /* 215035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
     /* 215038 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215043 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215056 */     // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_v2f16>>  =>  (DS_PK_ADD_F16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16_gfx9),
     /* 215059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215064 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215078 */     GIR_RootConstrainSelectedInstOperands,
     /* 215079 */     // GIR_Coverage, 8319,
     /* 215079 */     GIR_EraseRootFromParent_Done,
     /* 215080 */   // Label 3424: @215080
     /* 215080 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(215130), // Rule ID 8321 //
     /* 215085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
     /* 215088 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 215093 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215106 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 215106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
     /* 215109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215114 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215128 */     GIR_RootConstrainSelectedInstOperands,
     /* 215129 */     // GIR_Coverage, 8321,
     /* 215129 */     GIR_EraseRootFromParent_Done,
     /* 215130 */   // Label 3425: @215130
     /* 215130 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(215184), // Rule ID 8211 //
     /* 215135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
     /* 215138 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215158 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
     /* 215161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215168 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215182 */     GIR_RootConstrainSelectedInstOperands,
     /* 215183 */     // GIR_Coverage, 8211,
     /* 215183 */     GIR_EraseRootFromParent_Done,
     /* 215184 */   // Label 3426: @215184
     /* 215184 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(215238), // Rule ID 8213 //
     /* 215189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
     /* 215192 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215212 */     // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_v2f16>>  =>  (DS_PK_ADD_RTN_F16_gfx9:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16_gfx9),
     /* 215215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215222 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215236 */     GIR_RootConstrainSelectedInstOperands,
     /* 215237 */     // GIR_Coverage, 8213,
     /* 215237 */     GIR_EraseRootFromParent_Done,
     /* 215238 */   // Label 3427: @215238
     /* 215238 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(215292), // Rule ID 8215 //
     /* 215243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
     /* 215246 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 215251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215266 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 215266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
     /* 215269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215276 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215290 */     GIR_RootConstrainSelectedInstOperands,
     /* 215291 */     // GIR_Coverage, 8215,
     /* 215291 */     GIR_EraseRootFromParent_Done,
     /* 215292 */   // Label 3428: @215292
     /* 215292 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(215346), // Rule ID 8316 //
     /* 215297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
     /* 215300 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215320 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
     /* 215323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215330 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215344 */     GIR_RootConstrainSelectedInstOperands,
     /* 215345 */     // GIR_Coverage, 8316,
     /* 215345 */     GIR_EraseRootFromParent_Done,
     /* 215346 */   // Label 3429: @215346
     /* 215346 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(215400), // Rule ID 8318 //
     /* 215351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
     /* 215354 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215374 */     // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_v2f16>>  =>  (DS_PK_ADD_RTN_F16_gfx9:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16_gfx9),
     /* 215377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215384 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215398 */     GIR_RootConstrainSelectedInstOperands,
     /* 215399 */     // GIR_Coverage, 8318,
     /* 215399 */     GIR_EraseRootFromParent_Done,
     /* 215400 */   // Label 3430: @215400
     /* 215400 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(215454), // Rule ID 8320 //
     /* 215405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
     /* 215408 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 215413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215428 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 215428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
     /* 215431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215438 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215452 */     GIR_RootConstrainSelectedInstOperands,
     /* 215453 */     // GIR_Coverage, 8320,
     /* 215453 */     GIR_EraseRootFromParent_Done,
     /* 215454 */   // Label 3431: @215454
     /* 215454 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(215511), // Rule ID 4158 //
     /* 215459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 215462 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215469 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 215482 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 215482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_SADDR),
     /* 215485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 215490 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 215497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 215502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215509 */     GIR_RootConstrainSelectedInstOperands,
     /* 215510 */     // GIR_Coverage, 4158,
     /* 215510 */     GIR_EraseRootFromParent_Done,
     /* 215511 */   // Label 3432: @215511
     /* 215511 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(215568), // Rule ID 4162 //
     /* 215516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 215519 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215526 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 215539 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 215539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_SADDR),
     /* 215542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 215547 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 215554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 215559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215566 */     GIR_RootConstrainSelectedInstOperands,
     /* 215567 */     // GIR_Coverage, 4162,
     /* 215567 */     GIR_EraseRootFromParent_Done,
     /* 215568 */   // Label 3433: @215568
     /* 215568 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(215629), // Rule ID 4164 //
     /* 215573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 215576 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 215598 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_SADDR_RTN:{ *:[v2f16] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 215598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_SADDR_RTN),
     /* 215601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 215608 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 215615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 215620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215627 */     GIR_RootConstrainSelectedInstOperands,
     /* 215628 */     // GIR_Coverage, 4164,
     /* 215628 */     GIR_EraseRootFromParent_Done,
     /* 215629 */   // Label 3434: @215629
     /* 215629 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(215681), // Rule ID 4157 //
     /* 215634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 215637 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215644 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 215657 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 215657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16),
     /* 215660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 215665 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215679 */     GIR_RootConstrainSelectedInstOperands,
     /* 215680 */     // GIR_Coverage, 4157,
     /* 215680 */     GIR_EraseRootFromParent_Done,
     /* 215681 */   // Label 3435: @215681
     /* 215681 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(215733), // Rule ID 4161 //
     /* 215686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 215689 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215696 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 215709 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 215709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16),
     /* 215712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 215717 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215731 */     GIR_RootConstrainSelectedInstOperands,
     /* 215732 */     // GIR_Coverage, 4161,
     /* 215732 */     GIR_EraseRootFromParent_Done,
     /* 215733 */   // Label 3436: @215733
     /* 215733 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(215789), // Rule ID 4163 //
     /* 215738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 215741 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 215763 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_RTN:{ *:[v2f16] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 215763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_RTN),
     /* 215766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 215773 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215787 */     GIR_RootConstrainSelectedInstOperands,
     /* 215788 */     // GIR_Coverage, 4163,
     /* 215788 */     GIR_EraseRootFromParent_Done,
     /* 215789 */   // Label 3437: @215789
     /* 215789 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(215842), // Rule ID 4182 //
     /* 215794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFlatPkAdd16Insts),
     /* 215797 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215805 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 215818 */     // (atomic_load_fadd:{ *:[v2f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_flat_noret_v2f16>>  =>  (FLAT_ATOMIC_PK_ADD_F16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 215818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_PK_ADD_F16),
     /* 215821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 215826 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215840 */     GIR_RootConstrainSelectedInstOperands,
     /* 215841 */     // GIR_Coverage, 4182,
     /* 215841 */     GIR_EraseRootFromParent_Done,
     /* 215842 */   // Label 3438: @215842
     /* 215842 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(215899), // Rule ID 4181 //
     /* 215847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFlatPkAdd16Insts),
     /* 215850 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 215873 */     // (atomic_load_fadd:{ *:[v2f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_flat_v2f16>>  =>  (FLAT_ATOMIC_PK_ADD_F16_RTN:{ *:[v2f16] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 215873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_PK_ADD_F16_RTN),
     /* 215876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 215883 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215897 */     GIR_RootConstrainSelectedInstOperands,
     /* 215898 */     // GIR_Coverage, 4181,
     /* 215898 */     GIR_EraseRootFromParent_Done,
     /* 215899 */   // Label 3439: @215899
     /* 215899 */   GIM_Reject,
     /* 215900 */ // Label 3419: @215900
     /* 215900 */ GIM_Reject,
     /* 215901 */ // Label 3396: @215901
     /* 215901 */ GIM_Reject,
     /* 215902 */ // Label 30: @215902
     /* 215902 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3442*/ GIMT_Encode4(218547),
     /* 215913 */ /*GILLT_s32*//*Label 3440*/ GIMT_Encode4(215921),
     /* 215917 */ /*GILLT_s64*//*Label 3441*/ GIMT_Encode4(217289),
     /* 215921 */ // Label 3440: @215921
     /* 215921 */ GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(217288),
     /* 215926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 215929 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(215991), // Rule ID 5777 //
     /* 215934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 215937 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215944 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 215957 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_ADDR64 anonymous_9820:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 215957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_ADDR64),
     /* 215960 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 215962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 215967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 215972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 215977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 215982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215989 */     GIR_RootConstrainSelectedInstOperands,
     /* 215990 */     // GIR_Coverage, 5777,
     /* 215990 */     GIR_EraseRootFromParent_Done,
     /* 215991 */   // Label 3444: @215991
     /* 215991 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(216053), // Rule ID 5781 //
     /* 215996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 215999 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216006 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 216019 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64 anonymous_9820:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64),
     /* 216022 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 216029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 216039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 216044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216051 */     GIR_RootConstrainSelectedInstOperands,
     /* 216052 */     // GIR_Coverage, 5781,
     /* 216052 */     GIR_EraseRootFromParent_Done,
     /* 216053 */   // Label 3445: @216053
     /* 216053 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(216119), // Rule ID 5775 //
     /* 216058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216061 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 216083 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_ADDR64_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_ADDR64_RTN),
     /* 216086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 216088 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 216095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 216105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 216110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216117 */     GIR_RootConstrainSelectedInstOperands,
     /* 216118 */     // GIR_Coverage, 5775,
     /* 216118 */     GIR_EraseRootFromParent_Done,
     /* 216119 */   // Label 3446: @216119
     /* 216119 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(216185), // Rule ID 5779 //
     /* 216124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216127 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 216149 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64_RTN),
     /* 216152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 216154 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 216161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 216171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 216176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216183 */     GIR_RootConstrainSelectedInstOperands,
     /* 216184 */     // GIR_Coverage, 5779,
     /* 216184 */     GIR_EraseRootFromParent_Done,
     /* 216185 */   // Label 3447: @216185
     /* 216185 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(216242), // Rule ID 5776 //
     /* 216190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216193 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216200 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 216213 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_OFFSET anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET),
     /* 216216 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 216228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216240 */     GIR_RootConstrainSelectedInstOperands,
     /* 216241 */     // GIR_Coverage, 5776,
     /* 216241 */     GIR_EraseRootFromParent_Done,
     /* 216242 */   // Label 3448: @216242
     /* 216242 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(216299), // Rule ID 5780 //
     /* 216247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216250 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216257 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 216270 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET),
     /* 216273 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 216285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216297 */     GIR_RootConstrainSelectedInstOperands,
     /* 216298 */     // GIR_Coverage, 5780,
     /* 216298 */     GIR_EraseRootFromParent_Done,
     /* 216299 */   // Label 3449: @216299
     /* 216299 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(216360), // Rule ID 5774 //
     /* 216304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216307 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 216329 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_OFFSET_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET_RTN),
     /* 216332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 216334 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 216346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216358 */     GIR_RootConstrainSelectedInstOperands,
     /* 216359 */     // GIR_Coverage, 5774,
     /* 216359 */     GIR_EraseRootFromParent_Done,
     /* 216360 */   // Label 3450: @216360
     /* 216360 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(216421), // Rule ID 5778 //
     /* 216365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 216368 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 216390 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN),
     /* 216393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 216395 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 216407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216419 */     GIR_RootConstrainSelectedInstOperands,
     /* 216420 */     // GIR_Coverage, 5778,
     /* 216420 */     GIR_EraseRootFromParent_Done,
     /* 216421 */   // Label 3451: @216421
     /* 216421 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(216471), // Rule ID 8206 //
     /* 216426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 216429 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 216434 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 216447 */     // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_noret_f32>>  =>  (DS_MAX_F32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 216447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F32),
     /* 216450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 216455 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 216457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216469 */     GIR_RootConstrainSelectedInstOperands,
     /* 216470 */     // GIR_Coverage, 8206,
     /* 216470 */     GIR_EraseRootFromParent_Done,
     /* 216471 */   // Label 3452: @216471
     /* 216471 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(216521), // Rule ID 8208 //
     /* 216476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 216479 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 216484 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 216497 */     // (atomic_load_fmax:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_noret_f32>>  =>  (DS_MAX_F32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 216497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F32_gfx9),
     /* 216500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 216505 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 216507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216519 */     GIR_RootConstrainSelectedInstOperands,
     /* 216520 */     // GIR_Coverage, 8208,
     /* 216520 */     GIR_EraseRootFromParent_Done,
     /* 216521 */   // Label 3453: @216521
     /* 216521 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(216571), // Rule ID 8210 //
     /* 216526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 216529 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 216534 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 216547 */     // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_noret_f32>>  =>  (DS_MAX_F32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 216547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F32),
     /* 216550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 216555 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 216557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216569 */     GIR_RootConstrainSelectedInstOperands,
     /* 216570 */     // GIR_Coverage, 8210,
     /* 216570 */     GIR_EraseRootFromParent_Done,
     /* 216571 */   // Label 3454: @216571
     /* 216571 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(216625), // Rule ID 8205 //
     /* 216576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 216579 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 216584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 216599 */     // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_f32>>  =>  (DS_MAX_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 216599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F32),
     /* 216602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 216609 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 216611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216623 */     GIR_RootConstrainSelectedInstOperands,
     /* 216624 */     // GIR_Coverage, 8205,
     /* 216624 */     GIR_EraseRootFromParent_Done,
     /* 216625 */   // Label 3455: @216625
     /* 216625 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(216679), // Rule ID 8207 //
     /* 216630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 216633 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 216638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 216653 */     // (atomic_load_fmax:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_f32>>  =>  (DS_MAX_RTN_F32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 216653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F32_gfx9),
     /* 216656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 216663 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 216665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216677 */     GIR_RootConstrainSelectedInstOperands,
     /* 216678 */     // GIR_Coverage, 8207,
     /* 216678 */     GIR_EraseRootFromParent_Done,
     /* 216679 */   // Label 3456: @216679
     /* 216679 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(216733), // Rule ID 8209 //
     /* 216684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 216687 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 216692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 216707 */     // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_f32>>  =>  (DS_MAX_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 216707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F32),
     /* 216710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 216717 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 216719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216731 */     GIR_RootConstrainSelectedInstOperands,
     /* 216732 */     // GIR_Coverage, 8209,
     /* 216732 */     GIR_EraseRootFromParent_Done,
     /* 216733 */   // Label 3457: @216733
     /* 216733 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(216790), // Rule ID 4136 //
     /* 216738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 216741 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216748 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 216761 */     // (atomic_load_fmax:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 216761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR),
     /* 216764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 216769 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 216776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216788 */     GIR_RootConstrainSelectedInstOperands,
     /* 216789 */     // GIR_Coverage, 4136,
     /* 216789 */     GIR_EraseRootFromParent_Done,
     /* 216790 */   // Label 3458: @216790
     /* 216790 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(216851), // Rule ID 4138 //
     /* 216795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 216798 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 216820 */     // (atomic_load_fmax:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (GLOBAL_ATOMIC_FMAX_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 216820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR_RTN),
     /* 216823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 216830 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 216837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216849 */     GIR_RootConstrainSelectedInstOperands,
     /* 216850 */     // GIR_Coverage, 4138,
     /* 216850 */     GIR_EraseRootFromParent_Done,
     /* 216851 */   // Label 3459: @216851
     /* 216851 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(216903), // Rule ID 4135 //
     /* 216856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 216859 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216866 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 216879 */     // (atomic_load_fmax:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 216879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX),
     /* 216882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 216887 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216901 */     GIR_RootConstrainSelectedInstOperands,
     /* 216902 */     // GIR_Coverage, 4135,
     /* 216902 */     GIR_EraseRootFromParent_Done,
     /* 216903 */   // Label 3460: @216903
     /* 216903 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(216959), // Rule ID 4137 //
     /* 216908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 216911 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 216933 */     // (atomic_load_fmax:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (GLOBAL_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 216933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_RTN),
     /* 216936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 216943 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216957 */     GIR_RootConstrainSelectedInstOperands,
     /* 216958 */     // GIR_Coverage, 4137,
     /* 216958 */     GIR_EraseRootFromParent_Done,
     /* 216959 */   // Label 3461: @216959
     /* 216959 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(217012), // Rule ID 3718 //
     /* 216964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 216967 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216975 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 216988 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 216988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
     /* 216991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 216996 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217010 */     GIR_RootConstrainSelectedInstOperands,
     /* 217011 */     // GIR_Coverage, 3718,
     /* 217011 */     GIR_EraseRootFromParent_Done,
     /* 217012 */   // Label 3462: @217012
     /* 217012 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(217064), // Rule ID 3778 //
     /* 217017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 217020 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217027 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217040 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 217040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
     /* 217043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217048 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217062 */     GIR_RootConstrainSelectedInstOperands,
     /* 217063 */     // GIR_Coverage, 3778,
     /* 217063 */     GIR_EraseRootFromParent_Done,
     /* 217064 */   // Label 3463: @217064
     /* 217064 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(217117), // Rule ID 4142 //
     /* 217069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
     /* 217072 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217080 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217093 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 217093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
     /* 217096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217101 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217115 */     GIR_RootConstrainSelectedInstOperands,
     /* 217116 */     // GIR_Coverage, 4142,
     /* 217116 */     GIR_EraseRootFromParent_Done,
     /* 217117 */   // Label 3464: @217117
     /* 217117 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(217174), // Rule ID 3717 //
     /* 217122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 217125 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 217137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217148 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_f32>>  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 217148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
     /* 217151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217158 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217172 */     GIR_RootConstrainSelectedInstOperands,
     /* 217173 */     // GIR_Coverage, 3717,
     /* 217173 */     GIR_EraseRootFromParent_Done,
     /* 217174 */   // Label 3465: @217174
     /* 217174 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(217230), // Rule ID 3777 //
     /* 217179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 217182 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 217193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217204 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 217204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
     /* 217207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217214 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217228 */     GIR_RootConstrainSelectedInstOperands,
     /* 217229 */     // GIR_Coverage, 3777,
     /* 217229 */     GIR_EraseRootFromParent_Done,
     /* 217230 */   // Label 3466: @217230
     /* 217230 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(217287), // Rule ID 4141 //
     /* 217235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
     /* 217238 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 217250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217261 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_f32>>  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 217261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
     /* 217264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217271 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217285 */     GIR_RootConstrainSelectedInstOperands,
     /* 217286 */     // GIR_Coverage, 4141,
     /* 217286 */     GIR_EraseRootFromParent_Done,
     /* 217287 */   // Label 3467: @217287
     /* 217287 */   GIM_Reject,
     /* 217288 */ // Label 3443: @217288
     /* 217288 */ GIM_Reject,
     /* 217289 */ // Label 3441: @217289
     /* 217289 */ GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(218546),
     /* 217294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217297 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(217359), // Rule ID 5793 //
     /* 217302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217305 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217312 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 217325 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_ADDR64 anonymous_9819:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_ADDR64),
     /* 217328 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 217335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 217345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 217350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217357 */     GIR_RootConstrainSelectedInstOperands,
     /* 217358 */     // GIR_Coverage, 5793,
     /* 217358 */     GIR_EraseRootFromParent_Done,
     /* 217359 */   // Label 3469: @217359
     /* 217359 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(217421), // Rule ID 5797 //
     /* 217364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217367 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217374 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 217387 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64 anonymous_9819:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64),
     /* 217390 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 217397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 217407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 217412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217419 */     GIR_RootConstrainSelectedInstOperands,
     /* 217420 */     // GIR_Coverage, 5797,
     /* 217420 */     GIR_EraseRootFromParent_Done,
     /* 217421 */   // Label 3470: @217421
     /* 217421 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(217487), // Rule ID 5791 //
     /* 217426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217429 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 217451 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_ADDR64_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_ADDR64_RTN),
     /* 217454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 217456 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 217463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 217473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 217478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217485 */     GIR_RootConstrainSelectedInstOperands,
     /* 217486 */     // GIR_Coverage, 5791,
     /* 217486 */     GIR_EraseRootFromParent_Done,
     /* 217487 */   // Label 3471: @217487
     /* 217487 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(217553), // Rule ID 5795 //
     /* 217492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217495 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 217517 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64_RTN),
     /* 217520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 217522 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 217529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 217539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 217544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217551 */     GIR_RootConstrainSelectedInstOperands,
     /* 217552 */     // GIR_Coverage, 5795,
     /* 217552 */     GIR_EraseRootFromParent_Done,
     /* 217553 */   // Label 3472: @217553
     /* 217553 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(217610), // Rule ID 5792 //
     /* 217558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217561 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217568 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 217581 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET),
     /* 217584 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 217596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 217601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217608 */     GIR_RootConstrainSelectedInstOperands,
     /* 217609 */     // GIR_Coverage, 5792,
     /* 217609 */     GIR_EraseRootFromParent_Done,
     /* 217610 */   // Label 3473: @217610
     /* 217610 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(217667), // Rule ID 5796 //
     /* 217615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217618 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217625 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 217638 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET),
     /* 217641 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 217653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 217658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217665 */     GIR_RootConstrainSelectedInstOperands,
     /* 217666 */     // GIR_Coverage, 5796,
     /* 217666 */     GIR_EraseRootFromParent_Done,
     /* 217667 */   // Label 3474: @217667
     /* 217667 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(217728), // Rule ID 5790 //
     /* 217672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217675 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 217697 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET_RTN),
     /* 217700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 217702 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 217714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 217719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217726 */     GIR_RootConstrainSelectedInstOperands,
     /* 217727 */     // GIR_Coverage, 5790,
     /* 217727 */     GIR_EraseRootFromParent_Done,
     /* 217728 */   // Label 3475: @217728
     /* 217728 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(217789), // Rule ID 5794 //
     /* 217733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 217736 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 217758 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 217758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN),
     /* 217761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 217763 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 217765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 217770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 217775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 217780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217787 */     GIR_RootConstrainSelectedInstOperands,
     /* 217788 */     // GIR_Coverage, 5794,
     /* 217788 */     GIR_EraseRootFromParent_Done,
     /* 217789 */   // Label 3476: @217789
     /* 217789 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(217839), // Rule ID 8299 //
     /* 217794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 217797 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 217802 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217815 */     // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_noret_f64>>  =>  (DS_MAX_F64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 217815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F64),
     /* 217818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217823 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217837 */     GIR_RootConstrainSelectedInstOperands,
     /* 217838 */     // GIR_Coverage, 8299,
     /* 217838 */     GIR_EraseRootFromParent_Done,
     /* 217839 */   // Label 3477: @217839
     /* 217839 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(217889), // Rule ID 8301 //
     /* 217844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 217847 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 217852 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217865 */     // (atomic_load_fmax:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_noret_f64>>  =>  (DS_MAX_F64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 217865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F64_gfx9),
     /* 217868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217873 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217887 */     GIR_RootConstrainSelectedInstOperands,
     /* 217888 */     // GIR_Coverage, 8301,
     /* 217888 */     GIR_EraseRootFromParent_Done,
     /* 217889 */   // Label 3478: @217889
     /* 217889 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(217939), // Rule ID 8303 //
     /* 217894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 217897 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 217902 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217915 */     // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_noret_f64>>  =>  (DS_MAX_F64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 217915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F64),
     /* 217918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217923 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217937 */     GIR_RootConstrainSelectedInstOperands,
     /* 217938 */     // GIR_Coverage, 8303,
     /* 217938 */     GIR_EraseRootFromParent_Done,
     /* 217939 */   // Label 3479: @217939
     /* 217939 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(217993), // Rule ID 8298 //
     /* 217944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 217947 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 217952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217967 */     // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_f64>>  =>  (DS_MAX_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 217967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F64),
     /* 217970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217977 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217991 */     GIR_RootConstrainSelectedInstOperands,
     /* 217992 */     // GIR_Coverage, 8298,
     /* 217992 */     GIR_EraseRootFromParent_Done,
     /* 217993 */   // Label 3480: @217993
     /* 217993 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(218047), // Rule ID 8300 //
     /* 217998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 218001 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 218006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218021 */     // (atomic_load_fmax:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_f64>>  =>  (DS_MAX_RTN_F64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 218021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F64_gfx9),
     /* 218024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218031 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218045 */     GIR_RootConstrainSelectedInstOperands,
     /* 218046 */     // GIR_Coverage, 8300,
     /* 218046 */     GIR_EraseRootFromParent_Done,
     /* 218047 */   // Label 3481: @218047
     /* 218047 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(218101), // Rule ID 8302 //
     /* 218052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 218055 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 218060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218075 */     // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_f64>>  =>  (DS_MAX_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 218075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F64),
     /* 218078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218085 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218099 */     GIR_RootConstrainSelectedInstOperands,
     /* 218100 */     // GIR_Coverage, 8302,
     /* 218100 */     GIR_EraseRootFromParent_Done,
     /* 218101 */   // Label 3482: @218101
     /* 218101 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(218158), // Rule ID 4170 //
     /* 218106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 218109 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218116 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 218129 */     // (atomic_load_fmax:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 218129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64_SADDR),
     /* 218132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 218137 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 218144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 218149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218156 */     GIR_RootConstrainSelectedInstOperands,
     /* 218157 */     // GIR_Coverage, 4170,
     /* 218157 */     GIR_EraseRootFromParent_Done,
     /* 218158 */   // Label 3483: @218158
     /* 218158 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(218219), // Rule ID 4172 //
     /* 218163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 218166 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 218188 */     // (atomic_load_fmax:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64_SADDR_RTN:{ *:[f64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 218188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64_SADDR_RTN),
     /* 218191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 218198 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 218205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 218210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218217 */     GIR_RootConstrainSelectedInstOperands,
     /* 218218 */     // GIR_Coverage, 4172,
     /* 218218 */     GIR_EraseRootFromParent_Done,
     /* 218219 */   // Label 3484: @218219
     /* 218219 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(218271), // Rule ID 4169 //
     /* 218224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 218227 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218234 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 218247 */     // (atomic_load_fmax:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64),
     /* 218250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218255 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218269 */     GIR_RootConstrainSelectedInstOperands,
     /* 218270 */     // GIR_Coverage, 4169,
     /* 218270 */     GIR_EraseRootFromParent_Done,
     /* 218271 */   // Label 3485: @218271
     /* 218271 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(218327), // Rule ID 4171 //
     /* 218276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 218279 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 218301 */     // (atomic_load_fmax:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64_RTN),
     /* 218304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218311 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218325 */     GIR_RootConstrainSelectedInstOperands,
     /* 218326 */     // GIR_Coverage, 4171,
     /* 218326 */     GIR_EraseRootFromParent_Done,
     /* 218327 */   // Label 3486: @218327
     /* 218327 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(218380), // Rule ID 3722 //
     /* 218332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 218335 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218343 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 218356 */     // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_flat_noret_f64>>  =>  (FLAT_ATOMIC_MAX_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64),
     /* 218359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218364 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218378 */     GIR_RootConstrainSelectedInstOperands,
     /* 218379 */     // GIR_Coverage, 3722,
     /* 218379 */     GIR_EraseRootFromParent_Done,
     /* 218380 */   // Label 3487: @218380
     /* 218380 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(218432), // Rule ID 3782 //
     /* 218385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 218388 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218395 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 218408 */     // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (FLAT_ATOMIC_MAX_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64),
     /* 218411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218416 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218430 */     GIR_RootConstrainSelectedInstOperands,
     /* 218431 */     // GIR_Coverage, 3782,
     /* 218431 */     GIR_EraseRootFromParent_Done,
     /* 218432 */   // Label 3488: @218432
     /* 218432 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(218489), // Rule ID 3721 //
     /* 218437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 218440 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 218463 */     // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_flat_f64>>  =>  (FLAT_ATOMIC_MAX_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64_RTN),
     /* 218466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218473 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218487 */     GIR_RootConstrainSelectedInstOperands,
     /* 218488 */     // GIR_Coverage, 3721,
     /* 218488 */     GIR_EraseRootFromParent_Done,
     /* 218489 */   // Label 3489: @218489
     /* 218489 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(218545), // Rule ID 3781 //
     /* 218494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 218497 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 218519 */     // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (FLAT_ATOMIC_MAX_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64_RTN),
     /* 218522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218529 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218543 */     GIR_RootConstrainSelectedInstOperands,
     /* 218544 */     // GIR_Coverage, 3781,
     /* 218544 */     GIR_EraseRootFromParent_Done,
     /* 218545 */   // Label 3490: @218545
     /* 218545 */   GIM_Reject,
     /* 218546 */ // Label 3468: @218546
     /* 218546 */ GIM_Reject,
     /* 218547 */ // Label 3442: @218547
     /* 218547 */ GIM_Reject,
     /* 218548 */ // Label 31: @218548
     /* 218548 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3493*/ GIMT_Encode4(221193),
     /* 218559 */ /*GILLT_s32*//*Label 3491*/ GIMT_Encode4(218567),
     /* 218563 */ /*GILLT_s64*//*Label 3492*/ GIMT_Encode4(219935),
     /* 218567 */ // Label 3491: @218567
     /* 218567 */ GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(219934),
     /* 218572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218575 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(218637), // Rule ID 5769 //
     /* 218580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 218583 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218590 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 218603 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_ADDR64 anonymous_9820:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 218603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_ADDR64),
     /* 218606 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 218608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 218613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 218618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 218623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 218628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218635 */     GIR_RootConstrainSelectedInstOperands,
     /* 218636 */     // GIR_Coverage, 5769,
     /* 218636 */     GIR_EraseRootFromParent_Done,
     /* 218637 */   // Label 3495: @218637
     /* 218637 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(218699), // Rule ID 5773 //
     /* 218642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 218645 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218652 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 218665 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64 anonymous_9820:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 218665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64),
     /* 218668 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 218670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 218675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 218680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 218685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 218690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218697 */     GIR_RootConstrainSelectedInstOperands,
     /* 218698 */     // GIR_Coverage, 5773,
     /* 218698 */     GIR_EraseRootFromParent_Done,
     /* 218699 */   // Label 3496: @218699
     /* 218699 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(218765), // Rule ID 5767 //
     /* 218704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 218707 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 218718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 218729 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_ADDR64_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 218729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_ADDR64_RTN),
     /* 218732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 218734 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 218736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 218741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 218746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 218751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 218756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218763 */     GIR_RootConstrainSelectedInstOperands,
     /* 218764 */     // GIR_Coverage, 5767,
     /* 218764 */     GIR_EraseRootFromParent_Done,
     /* 218765 */   // Label 3497: @218765
     /* 218765 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(218831), // Rule ID 5771 //
     /* 218770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 218773 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 218784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 218795 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 218795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64_RTN),
     /* 218798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 218800 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 218802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 218807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 218812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 218817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 218822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218829 */     GIR_RootConstrainSelectedInstOperands,
     /* 218830 */     // GIR_Coverage, 5771,
     /* 218830 */     GIR_EraseRootFromParent_Done,
     /* 218831 */   // Label 3498: @218831
     /* 218831 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(218888), // Rule ID 5768 //
     /* 218836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 218839 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218846 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 218859 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_OFFSET anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 218859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET),
     /* 218862 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 218864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 218869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 218874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 218879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218886 */     GIR_RootConstrainSelectedInstOperands,
     /* 218887 */     // GIR_Coverage, 5768,
     /* 218887 */     GIR_EraseRootFromParent_Done,
     /* 218888 */   // Label 3499: @218888
     /* 218888 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(218945), // Rule ID 5772 //
     /* 218893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 218896 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218903 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 218916 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 218916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET),
     /* 218919 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 218921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 218926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 218931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 218936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218943 */     GIR_RootConstrainSelectedInstOperands,
     /* 218944 */     // GIR_Coverage, 5772,
     /* 218944 */     GIR_EraseRootFromParent_Done,
     /* 218945 */   // Label 3500: @218945
     /* 218945 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(219006), // Rule ID 5766 //
     /* 218950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 218953 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 218964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 218975 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_OFFSET_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 218975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET_RTN),
     /* 218978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 218980 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 218982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 218987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 218992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 218997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219004 */     GIR_RootConstrainSelectedInstOperands,
     /* 219005 */     // GIR_Coverage, 5766,
     /* 219005 */     GIR_EraseRootFromParent_Done,
     /* 219006 */   // Label 3501: @219006
     /* 219006 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(219067), // Rule ID 5770 //
     /* 219011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 219014 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 219036 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 219036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN),
     /* 219039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 219041 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 219043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 219048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 219053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 219058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219065 */     GIR_RootConstrainSelectedInstOperands,
     /* 219066 */     // GIR_Coverage, 5770,
     /* 219066 */     GIR_EraseRootFromParent_Done,
     /* 219067 */   // Label 3502: @219067
     /* 219067 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(219117), // Rule ID 8200 //
     /* 219072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 219075 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 219080 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219093 */     // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_noret_f32>>  =>  (DS_MIN_F32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F32),
     /* 219096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219101 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219115 */     GIR_RootConstrainSelectedInstOperands,
     /* 219116 */     // GIR_Coverage, 8200,
     /* 219116 */     GIR_EraseRootFromParent_Done,
     /* 219117 */   // Label 3503: @219117
     /* 219117 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(219167), // Rule ID 8202 //
     /* 219122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 219125 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 219130 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219143 */     // (atomic_load_fmin:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_noret_f32>>  =>  (DS_MIN_F32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F32_gfx9),
     /* 219146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219151 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219165 */     GIR_RootConstrainSelectedInstOperands,
     /* 219166 */     // GIR_Coverage, 8202,
     /* 219166 */     GIR_EraseRootFromParent_Done,
     /* 219167 */   // Label 3504: @219167
     /* 219167 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(219217), // Rule ID 8204 //
     /* 219172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 219175 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 219180 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219193 */     // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_noret_f32>>  =>  (DS_MIN_F32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 219193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F32),
     /* 219196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219201 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219215 */     GIR_RootConstrainSelectedInstOperands,
     /* 219216 */     // GIR_Coverage, 8204,
     /* 219216 */     GIR_EraseRootFromParent_Done,
     /* 219217 */   // Label 3505: @219217
     /* 219217 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(219271), // Rule ID 8199 //
     /* 219222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 219225 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 219230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219245 */     // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_f32>>  =>  (DS_MIN_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F32),
     /* 219248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219255 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219269 */     GIR_RootConstrainSelectedInstOperands,
     /* 219270 */     // GIR_Coverage, 8199,
     /* 219270 */     GIR_EraseRootFromParent_Done,
     /* 219271 */   // Label 3506: @219271
     /* 219271 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(219325), // Rule ID 8201 //
     /* 219276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 219279 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 219284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219299 */     // (atomic_load_fmin:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_f32>>  =>  (DS_MIN_RTN_F32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F32_gfx9),
     /* 219302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219309 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219323 */     GIR_RootConstrainSelectedInstOperands,
     /* 219324 */     // GIR_Coverage, 8201,
     /* 219324 */     GIR_EraseRootFromParent_Done,
     /* 219325 */   // Label 3507: @219325
     /* 219325 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(219379), // Rule ID 8203 //
     /* 219330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 219333 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 219338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219353 */     // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_f32>>  =>  (DS_MIN_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 219353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F32),
     /* 219356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219363 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219377 */     GIR_RootConstrainSelectedInstOperands,
     /* 219378 */     // GIR_Coverage, 8203,
     /* 219378 */     GIR_EraseRootFromParent_Done,
     /* 219379 */   // Label 3508: @219379
     /* 219379 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(219436), // Rule ID 4132 //
     /* 219384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 219387 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219394 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 219407 */     // (atomic_load_fmin:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 219407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR),
     /* 219410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 219415 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 219422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 219427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219434 */     GIR_RootConstrainSelectedInstOperands,
     /* 219435 */     // GIR_Coverage, 4132,
     /* 219435 */     GIR_EraseRootFromParent_Done,
     /* 219436 */   // Label 3509: @219436
     /* 219436 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(219497), // Rule ID 4134 //
     /* 219441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 219444 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 219466 */     // (atomic_load_fmin:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (GLOBAL_ATOMIC_FMIN_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 219466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR_RTN),
     /* 219469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 219476 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 219483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 219488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219495 */     GIR_RootConstrainSelectedInstOperands,
     /* 219496 */     // GIR_Coverage, 4134,
     /* 219496 */     GIR_EraseRootFromParent_Done,
     /* 219497 */   // Label 3510: @219497
     /* 219497 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(219549), // Rule ID 4131 //
     /* 219502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 219505 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219512 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 219525 */     // (atomic_load_fmin:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 219525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN),
     /* 219528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219533 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219547 */     GIR_RootConstrainSelectedInstOperands,
     /* 219548 */     // GIR_Coverage, 4131,
     /* 219548 */     GIR_EraseRootFromParent_Done,
     /* 219549 */   // Label 3511: @219549
     /* 219549 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(219605), // Rule ID 4133 //
     /* 219554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 219557 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 219579 */     // (atomic_load_fmin:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (GLOBAL_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 219579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_RTN),
     /* 219582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219589 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219603 */     GIR_RootConstrainSelectedInstOperands,
     /* 219604 */     // GIR_Coverage, 4133,
     /* 219604 */     GIR_EraseRootFromParent_Done,
     /* 219605 */   // Label 3512: @219605
     /* 219605 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(219658), // Rule ID 3716 //
     /* 219610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 219613 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219621 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 219634 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 219634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
     /* 219637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219642 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219656 */     GIR_RootConstrainSelectedInstOperands,
     /* 219657 */     // GIR_Coverage, 3716,
     /* 219657 */     GIR_EraseRootFromParent_Done,
     /* 219658 */   // Label 3513: @219658
     /* 219658 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(219710), // Rule ID 3776 //
     /* 219663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 219666 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219673 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 219686 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 219686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
     /* 219689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219694 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219708 */     GIR_RootConstrainSelectedInstOperands,
     /* 219709 */     // GIR_Coverage, 3776,
     /* 219709 */     GIR_EraseRootFromParent_Done,
     /* 219710 */   // Label 3514: @219710
     /* 219710 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(219763), // Rule ID 4140 //
     /* 219715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
     /* 219718 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219726 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 219739 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 219739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
     /* 219742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219747 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219761 */     GIR_RootConstrainSelectedInstOperands,
     /* 219762 */     // GIR_Coverage, 4140,
     /* 219762 */     GIR_EraseRootFromParent_Done,
     /* 219763 */   // Label 3515: @219763
     /* 219763 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(219820), // Rule ID 3715 //
     /* 219768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 219771 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 219794 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_f32>>  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 219794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
     /* 219797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219804 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219818 */     GIR_RootConstrainSelectedInstOperands,
     /* 219819 */     // GIR_Coverage, 3715,
     /* 219819 */     GIR_EraseRootFromParent_Done,
     /* 219820 */   // Label 3516: @219820
     /* 219820 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(219876), // Rule ID 3775 //
     /* 219825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 219828 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 219850 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 219850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
     /* 219853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219860 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219874 */     GIR_RootConstrainSelectedInstOperands,
     /* 219875 */     // GIR_Coverage, 3775,
     /* 219875 */     GIR_EraseRootFromParent_Done,
     /* 219876 */   // Label 3517: @219876
     /* 219876 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(219933), // Rule ID 4139 //
     /* 219881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
     /* 219884 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 219907 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_f32>>  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 219907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
     /* 219910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219917 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219931 */     GIR_RootConstrainSelectedInstOperands,
     /* 219932 */     // GIR_Coverage, 4139,
     /* 219932 */     GIR_EraseRootFromParent_Done,
     /* 219933 */   // Label 3518: @219933
     /* 219933 */   GIM_Reject,
     /* 219934 */ // Label 3494: @219934
     /* 219934 */ GIM_Reject,
     /* 219935 */ // Label 3492: @219935
     /* 219935 */ GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(221192),
     /* 219940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219943 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(220005), // Rule ID 5785 //
     /* 219948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 219951 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219958 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 219971 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_ADDR64 anonymous_9819:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 219971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_ADDR64),
     /* 219974 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 219976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 219981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 219986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 219991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 219996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220003 */     GIR_RootConstrainSelectedInstOperands,
     /* 220004 */     // GIR_Coverage, 5785,
     /* 220004 */     GIR_EraseRootFromParent_Done,
     /* 220005 */   // Label 3520: @220005
     /* 220005 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(220067), // Rule ID 5789 //
     /* 220010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220013 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220020 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 220033 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64 anonymous_9819:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64),
     /* 220036 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 220043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 220053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 220058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220065 */     GIR_RootConstrainSelectedInstOperands,
     /* 220066 */     // GIR_Coverage, 5789,
     /* 220066 */     GIR_EraseRootFromParent_Done,
     /* 220067 */   // Label 3521: @220067
     /* 220067 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(220133), // Rule ID 5783 //
     /* 220072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220075 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 220097 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_ADDR64_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_ADDR64_RTN),
     /* 220100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 220102 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 220109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 220119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 220124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220131 */     GIR_RootConstrainSelectedInstOperands,
     /* 220132 */     // GIR_Coverage, 5783,
     /* 220132 */     GIR_EraseRootFromParent_Done,
     /* 220133 */   // Label 3522: @220133
     /* 220133 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(220199), // Rule ID 5787 //
     /* 220138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220141 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 220163 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64_RTN),
     /* 220166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 220168 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 220175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 220185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 220190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220197 */     GIR_RootConstrainSelectedInstOperands,
     /* 220198 */     // GIR_Coverage, 5787,
     /* 220198 */     GIR_EraseRootFromParent_Done,
     /* 220199 */   // Label 3523: @220199
     /* 220199 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(220256), // Rule ID 5784 //
     /* 220204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220207 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220214 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 220227 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET),
     /* 220230 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 220242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220254 */     GIR_RootConstrainSelectedInstOperands,
     /* 220255 */     // GIR_Coverage, 5784,
     /* 220255 */     GIR_EraseRootFromParent_Done,
     /* 220256 */   // Label 3524: @220256
     /* 220256 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(220313), // Rule ID 5788 //
     /* 220261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220264 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220271 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 220284 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET),
     /* 220287 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 220299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220311 */     GIR_RootConstrainSelectedInstOperands,
     /* 220312 */     // GIR_Coverage, 5788,
     /* 220312 */     GIR_EraseRootFromParent_Done,
     /* 220313 */   // Label 3525: @220313
     /* 220313 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(220374), // Rule ID 5782 //
     /* 220318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220321 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 220343 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET_RTN),
     /* 220346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 220348 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 220360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220372 */     GIR_RootConstrainSelectedInstOperands,
     /* 220373 */     // GIR_Coverage, 5782,
     /* 220373 */     GIR_EraseRootFromParent_Done,
     /* 220374 */   // Label 3526: @220374
     /* 220374 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(220435), // Rule ID 5786 //
     /* 220379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 220382 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 220404 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN),
     /* 220407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 220409 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 220421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220433 */     GIR_RootConstrainSelectedInstOperands,
     /* 220434 */     // GIR_Coverage, 5786,
     /* 220434 */     GIR_EraseRootFromParent_Done,
     /* 220435 */   // Label 3527: @220435
     /* 220435 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(220485), // Rule ID 8293 //
     /* 220440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 220443 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 220448 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220461 */     // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_noret_f64>>  =>  (DS_MIN_F64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 220461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F64),
     /* 220464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220469 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220483 */     GIR_RootConstrainSelectedInstOperands,
     /* 220484 */     // GIR_Coverage, 8293,
     /* 220484 */     GIR_EraseRootFromParent_Done,
     /* 220485 */   // Label 3528: @220485
     /* 220485 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(220535), // Rule ID 8295 //
     /* 220490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 220493 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 220498 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220511 */     // (atomic_load_fmin:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_noret_f64>>  =>  (DS_MIN_F64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 220511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F64_gfx9),
     /* 220514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220519 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220533 */     GIR_RootConstrainSelectedInstOperands,
     /* 220534 */     // GIR_Coverage, 8295,
     /* 220534 */     GIR_EraseRootFromParent_Done,
     /* 220535 */   // Label 3529: @220535
     /* 220535 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(220585), // Rule ID 8297 //
     /* 220540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 220543 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 220548 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220561 */     // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_noret_f64>>  =>  (DS_MIN_F64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 220561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F64),
     /* 220564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220569 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220583 */     GIR_RootConstrainSelectedInstOperands,
     /* 220584 */     // GIR_Coverage, 8297,
     /* 220584 */     GIR_EraseRootFromParent_Done,
     /* 220585 */   // Label 3530: @220585
     /* 220585 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(220639), // Rule ID 8292 //
     /* 220590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 220593 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 220598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220613 */     // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_f64>>  =>  (DS_MIN_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 220613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F64),
     /* 220616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220623 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220637 */     GIR_RootConstrainSelectedInstOperands,
     /* 220638 */     // GIR_Coverage, 8292,
     /* 220638 */     GIR_EraseRootFromParent_Done,
     /* 220639 */   // Label 3531: @220639
     /* 220639 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(220693), // Rule ID 8294 //
     /* 220644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 220647 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 220652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220667 */     // (atomic_load_fmin:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_f64>>  =>  (DS_MIN_RTN_F64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 220667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F64_gfx9),
     /* 220670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220677 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220691 */     GIR_RootConstrainSelectedInstOperands,
     /* 220692 */     // GIR_Coverage, 8294,
     /* 220692 */     GIR_EraseRootFromParent_Done,
     /* 220693 */   // Label 3532: @220693
     /* 220693 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(220747), // Rule ID 8296 //
     /* 220698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 220701 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 220706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220721 */     // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_f64>>  =>  (DS_MIN_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 220721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F64),
     /* 220724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220731 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220745 */     GIR_RootConstrainSelectedInstOperands,
     /* 220746 */     // GIR_Coverage, 8296,
     /* 220746 */     GIR_EraseRootFromParent_Done,
     /* 220747 */   // Label 3533: @220747
     /* 220747 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(220804), // Rule ID 4166 //
     /* 220752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 220755 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220762 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 220775 */     // (atomic_load_fmin:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 220775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64_SADDR),
     /* 220778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 220783 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 220785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 220790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220802 */     GIR_RootConstrainSelectedInstOperands,
     /* 220803 */     // GIR_Coverage, 4166,
     /* 220803 */     GIR_EraseRootFromParent_Done,
     /* 220804 */   // Label 3534: @220804
     /* 220804 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(220865), // Rule ID 4168 //
     /* 220809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 220812 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 220834 */     // (atomic_load_fmin:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64_SADDR_RTN:{ *:[f64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 220834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64_SADDR_RTN),
     /* 220837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 220844 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 220846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 220851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220863 */     GIR_RootConstrainSelectedInstOperands,
     /* 220864 */     // GIR_Coverage, 4168,
     /* 220864 */     GIR_EraseRootFromParent_Done,
     /* 220865 */   // Label 3535: @220865
     /* 220865 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(220917), // Rule ID 4165 //
     /* 220870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 220873 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220880 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 220893 */     // (atomic_load_fmin:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 220893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64),
     /* 220896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 220901 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 220903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220915 */     GIR_RootConstrainSelectedInstOperands,
     /* 220916 */     // GIR_Coverage, 4165,
     /* 220916 */     GIR_EraseRootFromParent_Done,
     /* 220917 */   // Label 3536: @220917
     /* 220917 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(220973), // Rule ID 4167 //
     /* 220922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 220925 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 220936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 220947 */     // (atomic_load_fmin:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 220947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64_RTN),
     /* 220950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 220957 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 220959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220971 */     GIR_RootConstrainSelectedInstOperands,
     /* 220972 */     // GIR_Coverage, 4167,
     /* 220972 */     GIR_EraseRootFromParent_Done,
     /* 220973 */   // Label 3537: @220973
     /* 220973 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(221026), // Rule ID 3720 //
     /* 220978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 220981 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220989 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 221002 */     // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_flat_noret_f64>>  =>  (FLAT_ATOMIC_MIN_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 221002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64),
     /* 221005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221010 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221024 */     GIR_RootConstrainSelectedInstOperands,
     /* 221025 */     // GIR_Coverage, 3720,
     /* 221025 */     GIR_EraseRootFromParent_Done,
     /* 221026 */   // Label 3538: @221026
     /* 221026 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(221078), // Rule ID 3780 //
     /* 221031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 221034 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221041 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 221054 */     // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (FLAT_ATOMIC_MIN_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 221054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64),
     /* 221057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221062 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221076 */     GIR_RootConstrainSelectedInstOperands,
     /* 221077 */     // GIR_Coverage, 3780,
     /* 221077 */     GIR_EraseRootFromParent_Done,
     /* 221078 */   // Label 3539: @221078
     /* 221078 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(221135), // Rule ID 3719 //
     /* 221083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 221086 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 221098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 221109 */     // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_flat_f64>>  =>  (FLAT_ATOMIC_MIN_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 221109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64_RTN),
     /* 221112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 221114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221119 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221133 */     GIR_RootConstrainSelectedInstOperands,
     /* 221134 */     // GIR_Coverage, 3719,
     /* 221134 */     GIR_EraseRootFromParent_Done,
     /* 221135 */   // Label 3540: @221135
     /* 221135 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(221191), // Rule ID 3779 //
     /* 221140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 221143 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 221154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 221165 */     // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (FLAT_ATOMIC_MIN_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 221165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64_RTN),
     /* 221168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 221170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221175 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221189 */     GIR_RootConstrainSelectedInstOperands,
     /* 221190 */     // GIR_Coverage, 3779,
     /* 221190 */     GIR_EraseRootFromParent_Done,
     /* 221191 */   // Label 3541: @221191
     /* 221191 */   GIM_Reject,
     /* 221192 */ // Label 3519: @221192
     /* 221192 */ GIM_Reject,
     /* 221193 */ // Label 3493: @221193
     /* 221193 */ GIM_Reject,
     /* 221194 */ // Label 32: @221194
     /* 221194 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3544*/ GIMT_Encode4(223705),
     /* 221205 */ /*GILLT_s32*//*Label 3542*/ GIMT_Encode4(221213),
     /* 221209 */ /*GILLT_s64*//*Label 3543*/ GIMT_Encode4(222459),
     /* 221213 */ // Label 3542: @221213
     /* 221213 */ GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(222458),
     /* 221218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 221221 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(221283), // Rule ID 5657 //
     /* 221226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 221229 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221236 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 221249 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_ADDR64),
     /* 221252 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 221259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 221269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 221274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221281 */     GIR_RootConstrainSelectedInstOperands,
     /* 221282 */     // GIR_Coverage, 5657,
     /* 221282 */     GIR_EraseRootFromParent_Done,
     /* 221283 */   // Label 3546: @221283
     /* 221283 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(221342), // Rule ID 5661 //
     /* 221288 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221295 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 221308 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_ADDR64),
     /* 221311 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 221318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 221328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 221333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221340 */     GIR_RootConstrainSelectedInstOperands,
     /* 221341 */     // GIR_Coverage, 5661,
     /* 221341 */     GIR_EraseRootFromParent_Done,
     /* 221342 */   // Label 3547: @221342
     /* 221342 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(221408), // Rule ID 5655 //
     /* 221347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 221350 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 221372 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_ADDR64_RTN),
     /* 221375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 221377 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 221384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 221394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 221399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221406 */     GIR_RootConstrainSelectedInstOperands,
     /* 221407 */     // GIR_Coverage, 5655,
     /* 221407 */     GIR_EraseRootFromParent_Done,
     /* 221408 */   // Label 3548: @221408
     /* 221408 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(221471), // Rule ID 5659 //
     /* 221413 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 221435 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_ADDR64_RTN),
     /* 221438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 221440 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 221447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 221457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 221462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221469 */     GIR_RootConstrainSelectedInstOperands,
     /* 221470 */     // GIR_Coverage, 5659,
     /* 221470 */     GIR_EraseRootFromParent_Done,
     /* 221471 */   // Label 3549: @221471
     /* 221471 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(221528), // Rule ID 5656 //
     /* 221476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 221479 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221486 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 221499 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET),
     /* 221502 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 221514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221526 */     GIR_RootConstrainSelectedInstOperands,
     /* 221527 */     // GIR_Coverage, 5656,
     /* 221527 */     GIR_EraseRootFromParent_Done,
     /* 221528 */   // Label 3550: @221528
     /* 221528 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(221582), // Rule ID 5660 //
     /* 221533 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221540 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 221553 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET),
     /* 221556 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 221568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221580 */     GIR_RootConstrainSelectedInstOperands,
     /* 221581 */     // GIR_Coverage, 5660,
     /* 221581 */     GIR_EraseRootFromParent_Done,
     /* 221582 */   // Label 3551: @221582
     /* 221582 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(221643), // Rule ID 5654 //
     /* 221587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 221590 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221601 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 221612 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET_RTN),
     /* 221615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 221617 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 221629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221641 */     GIR_RootConstrainSelectedInstOperands,
     /* 221642 */     // GIR_Coverage, 5654,
     /* 221642 */     GIR_EraseRootFromParent_Done,
     /* 221643 */   // Label 3552: @221643
     /* 221643 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(221701), // Rule ID 5658 //
     /* 221648 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 221670 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN),
     /* 221673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 221675 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 221687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221699 */     GIR_RootConstrainSelectedInstOperands,
     /* 221700 */     // GIR_Coverage, 5658,
     /* 221700 */     GIR_EraseRootFromParent_Done,
     /* 221701 */   // Label 3553: @221701
     /* 221701 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(221751), // Rule ID 8146 //
     /* 221706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 221709 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 221714 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 221727 */     // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_noret_i32>>  =>  (DS_INC_U32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 221727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U32),
     /* 221730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 221735 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 221737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221749 */     GIR_RootConstrainSelectedInstOperands,
     /* 221750 */     // GIR_Coverage, 8146,
     /* 221750 */     GIR_EraseRootFromParent_Done,
     /* 221751 */   // Label 3554: @221751
     /* 221751 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(221801), // Rule ID 8148 //
     /* 221756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 221759 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 221764 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 221777 */     // (atomic_load_uinc_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_noret_i32>>  =>  (DS_INC_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 221777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U32_gfx9),
     /* 221780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 221785 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 221787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221799 */     GIR_RootConstrainSelectedInstOperands,
     /* 221800 */     // GIR_Coverage, 8148,
     /* 221800 */     GIR_EraseRootFromParent_Done,
     /* 221801 */   // Label 3555: @221801
     /* 221801 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(221851), // Rule ID 8150 //
     /* 221806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 221809 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 221814 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 221827 */     // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_noret_i32>>  =>  (DS_INC_U32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 221827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U32),
     /* 221830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 221835 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 221837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221849 */     GIR_RootConstrainSelectedInstOperands,
     /* 221850 */     // GIR_Coverage, 8150,
     /* 221850 */     GIR_EraseRootFromParent_Done,
     /* 221851 */   // Label 3556: @221851
     /* 221851 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(221905), // Rule ID 8145 //
     /* 221856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 221859 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 221864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 221879 */     // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_i32>>  =>  (DS_INC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 221879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U32),
     /* 221882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 221884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 221889 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 221891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221903 */     GIR_RootConstrainSelectedInstOperands,
     /* 221904 */     // GIR_Coverage, 8145,
     /* 221904 */     GIR_EraseRootFromParent_Done,
     /* 221905 */   // Label 3557: @221905
     /* 221905 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(221959), // Rule ID 8147 //
     /* 221910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 221913 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 221918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 221933 */     // (atomic_load_uinc_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_i32>>  =>  (DS_INC_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 221933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U32_gfx9),
     /* 221936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 221938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 221943 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 221945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221957 */     GIR_RootConstrainSelectedInstOperands,
     /* 221958 */     // GIR_Coverage, 8147,
     /* 221958 */     GIR_EraseRootFromParent_Done,
     /* 221959 */   // Label 3558: @221959
     /* 221959 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(222013), // Rule ID 8149 //
     /* 221964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 221967 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 221972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 221987 */     // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_i32>>  =>  (DS_INC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 221987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U32),
     /* 221990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 221992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 221997 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 221999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222011 */     GIR_RootConstrainSelectedInstOperands,
     /* 222012 */     // GIR_Coverage, 8149,
     /* 222012 */     GIR_EraseRootFromParent_Done,
     /* 222013 */   // Label 3559: @222013
     /* 222013 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(222070), // Rule ID 4014 //
     /* 222018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 222021 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222028 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 222041 */     // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_INC_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 222041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_SADDR),
     /* 222044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 222049 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 222056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222068 */     GIR_RootConstrainSelectedInstOperands,
     /* 222069 */     // GIR_Coverage, 4014,
     /* 222069 */     GIR_EraseRootFromParent_Done,
     /* 222070 */   // Label 3560: @222070
     /* 222070 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(222131), // Rule ID 4016 //
     /* 222075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 222078 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 222100 */     // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_INC_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 222100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_SADDR_RTN),
     /* 222103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 222110 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 222117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222129 */     GIR_RootConstrainSelectedInstOperands,
     /* 222130 */     // GIR_Coverage, 4016,
     /* 222130 */     GIR_EraseRootFromParent_Done,
     /* 222131 */   // Label 3561: @222131
     /* 222131 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(222183), // Rule ID 4013 //
     /* 222136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 222139 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222146 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 222159 */     // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_INC VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 222159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC),
     /* 222162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222167 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222181 */     GIR_RootConstrainSelectedInstOperands,
     /* 222182 */     // GIR_Coverage, 4013,
     /* 222182 */     GIR_EraseRootFromParent_Done,
     /* 222183 */   // Label 3562: @222183
     /* 222183 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(222239), // Rule ID 4015 //
     /* 222188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 222191 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 222213 */     // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_INC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 222213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_RTN),
     /* 222216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222223 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222237 */     GIR_RootConstrainSelectedInstOperands,
     /* 222238 */     // GIR_Coverage, 4015,
     /* 222238 */     GIR_EraseRootFromParent_Done,
     /* 222239 */   // Label 3563: @222239
     /* 222239 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(222292), // Rule ID 3668 //
     /* 222244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 222247 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222255 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 222268 */     // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_noret_i32>>  =>  (FLAT_ATOMIC_INC VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 222268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC),
     /* 222271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222276 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222290 */     GIR_RootConstrainSelectedInstOperands,
     /* 222291 */     // GIR_Coverage, 3668,
     /* 222291 */     GIR_EraseRootFromParent_Done,
     /* 222292 */   // Label 3564: @222292
     /* 222292 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(222344), // Rule ID 3728 //
     /* 222297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 222300 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222307 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 222320 */     // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (FLAT_ATOMIC_INC VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 222320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC),
     /* 222323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222328 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222342 */     GIR_RootConstrainSelectedInstOperands,
     /* 222343 */     // GIR_Coverage, 3728,
     /* 222343 */     GIR_EraseRootFromParent_Done,
     /* 222344 */   // Label 3565: @222344
     /* 222344 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(222401), // Rule ID 3667 //
     /* 222349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 222352 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 222375 */     // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_i32>>  =>  (FLAT_ATOMIC_INC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 222375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_RTN),
     /* 222378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222385 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222399 */     GIR_RootConstrainSelectedInstOperands,
     /* 222400 */     // GIR_Coverage, 3667,
     /* 222400 */     GIR_EraseRootFromParent_Done,
     /* 222401 */   // Label 3566: @222401
     /* 222401 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(222457), // Rule ID 3727 //
     /* 222406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 222409 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 222431 */     // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (FLAT_ATOMIC_INC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 222431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_RTN),
     /* 222434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222441 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222455 */     GIR_RootConstrainSelectedInstOperands,
     /* 222456 */     // GIR_Coverage, 3727,
     /* 222456 */     GIR_EraseRootFromParent_Done,
     /* 222457 */   // Label 3567: @222457
     /* 222457 */   GIM_Reject,
     /* 222458 */ // Label 3545: @222458
     /* 222458 */ GIM_Reject,
     /* 222459 */ // Label 3543: @222459
     /* 222459 */ GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(223704),
     /* 222464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 222467 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(222529), // Rule ID 5753 //
     /* 222472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 222475 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222482 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 222495 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_ADDR64),
     /* 222498 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 222505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 222515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 222520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222527 */     GIR_RootConstrainSelectedInstOperands,
     /* 222528 */     // GIR_Coverage, 5753,
     /* 222528 */     GIR_EraseRootFromParent_Done,
     /* 222529 */   // Label 3569: @222529
     /* 222529 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(222588), // Rule ID 5757 //
     /* 222534 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222541 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 222554 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64),
     /* 222557 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 222564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 222574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 222579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222586 */     GIR_RootConstrainSelectedInstOperands,
     /* 222587 */     // GIR_Coverage, 5757,
     /* 222587 */     GIR_EraseRootFromParent_Done,
     /* 222588 */   // Label 3570: @222588
     /* 222588 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(222654), // Rule ID 5751 //
     /* 222593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 222596 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 222607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 222618 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_ADDR64_RTN),
     /* 222621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 222623 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 222630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 222640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 222645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222652 */     GIR_RootConstrainSelectedInstOperands,
     /* 222653 */     // GIR_Coverage, 5751,
     /* 222653 */     GIR_EraseRootFromParent_Done,
     /* 222654 */   // Label 3571: @222654
     /* 222654 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(222717), // Rule ID 5755 //
     /* 222659 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 222670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 222681 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64_RTN),
     /* 222684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 222686 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 222693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 222703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 222708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222715 */     GIR_RootConstrainSelectedInstOperands,
     /* 222716 */     // GIR_Coverage, 5755,
     /* 222716 */     GIR_EraseRootFromParent_Done,
     /* 222717 */   // Label 3572: @222717
     /* 222717 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(222774), // Rule ID 5752 //
     /* 222722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 222725 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222732 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 222745 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET),
     /* 222748 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 222760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222772 */     GIR_RootConstrainSelectedInstOperands,
     /* 222773 */     // GIR_Coverage, 5752,
     /* 222773 */     GIR_EraseRootFromParent_Done,
     /* 222774 */   // Label 3573: @222774
     /* 222774 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(222828), // Rule ID 5756 //
     /* 222779 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222786 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 222799 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET),
     /* 222802 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 222814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222826 */     GIR_RootConstrainSelectedInstOperands,
     /* 222827 */     // GIR_Coverage, 5756,
     /* 222827 */     GIR_EraseRootFromParent_Done,
     /* 222828 */   // Label 3574: @222828
     /* 222828 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(222889), // Rule ID 5750 //
     /* 222833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 222836 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 222847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 222858 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET_RTN),
     /* 222861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 222863 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 222875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222887 */     GIR_RootConstrainSelectedInstOperands,
     /* 222888 */     // GIR_Coverage, 5750,
     /* 222888 */     GIR_EraseRootFromParent_Done,
     /* 222889 */   // Label 3575: @222889
     /* 222889 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(222947), // Rule ID 5754 //
     /* 222894 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 222905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 222916 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN),
     /* 222919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 222921 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 222933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222945 */     GIR_RootConstrainSelectedInstOperands,
     /* 222946 */     // GIR_Coverage, 5754,
     /* 222946 */     GIR_EraseRootFromParent_Done,
     /* 222947 */   // Label 3576: @222947
     /* 222947 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(222997), // Rule ID 8239 //
     /* 222952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 222955 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 222960 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 222973 */     // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_noret_i64>>  =>  (DS_INC_U64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 222973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U64),
     /* 222976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 222981 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 222983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222995 */     GIR_RootConstrainSelectedInstOperands,
     /* 222996 */     // GIR_Coverage, 8239,
     /* 222996 */     GIR_EraseRootFromParent_Done,
     /* 222997 */   // Label 3577: @222997
     /* 222997 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(223047), // Rule ID 8241 //
     /* 223002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 223005 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 223010 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223023 */     // (atomic_load_uinc_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_noret_i64>>  =>  (DS_INC_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 223023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U64_gfx9),
     /* 223026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223031 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223045 */     GIR_RootConstrainSelectedInstOperands,
     /* 223046 */     // GIR_Coverage, 8241,
     /* 223046 */     GIR_EraseRootFromParent_Done,
     /* 223047 */   // Label 3578: @223047
     /* 223047 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(223097), // Rule ID 8243 //
     /* 223052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 223055 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 223060 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223073 */     // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_noret_i64>>  =>  (DS_INC_U64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 223073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U64),
     /* 223076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223081 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223095 */     GIR_RootConstrainSelectedInstOperands,
     /* 223096 */     // GIR_Coverage, 8243,
     /* 223096 */     GIR_EraseRootFromParent_Done,
     /* 223097 */   // Label 3579: @223097
     /* 223097 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(223151), // Rule ID 8238 //
     /* 223102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 223105 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 223110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223125 */     // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_i64>>  =>  (DS_INC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 223125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U64),
     /* 223128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223135 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223149 */     GIR_RootConstrainSelectedInstOperands,
     /* 223150 */     // GIR_Coverage, 8238,
     /* 223150 */     GIR_EraseRootFromParent_Done,
     /* 223151 */   // Label 3580: @223151
     /* 223151 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(223205), // Rule ID 8240 //
     /* 223156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 223159 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 223164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223179 */     // (atomic_load_uinc_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_i64>>  =>  (DS_INC_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 223179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U64_gfx9),
     /* 223182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223189 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223203 */     GIR_RootConstrainSelectedInstOperands,
     /* 223204 */     // GIR_Coverage, 8240,
     /* 223204 */     GIR_EraseRootFromParent_Done,
     /* 223205 */   // Label 3581: @223205
     /* 223205 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(223259), // Rule ID 8242 //
     /* 223210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 223213 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 223218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223233 */     // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_i64>>  =>  (DS_INC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 223233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U64),
     /* 223236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223243 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223257 */     GIR_RootConstrainSelectedInstOperands,
     /* 223258 */     // GIR_Coverage, 8242,
     /* 223258 */     GIR_EraseRootFromParent_Done,
     /* 223259 */   // Label 3582: @223259
     /* 223259 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(223316), // Rule ID 4070 //
     /* 223264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 223267 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223274 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 223287 */     // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_INC_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 223287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2_SADDR),
     /* 223290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 223295 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 223302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 223307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223314 */     GIR_RootConstrainSelectedInstOperands,
     /* 223315 */     // GIR_Coverage, 4070,
     /* 223315 */     GIR_EraseRootFromParent_Done,
     /* 223316 */   // Label 3583: @223316
     /* 223316 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(223377), // Rule ID 4072 //
     /* 223321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 223324 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 223346 */     // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_INC_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 223346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2_SADDR_RTN),
     /* 223349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 223356 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 223363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 223368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223375 */     GIR_RootConstrainSelectedInstOperands,
     /* 223376 */     // GIR_Coverage, 4072,
     /* 223376 */     GIR_EraseRootFromParent_Done,
     /* 223377 */   // Label 3584: @223377
     /* 223377 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(223429), // Rule ID 4069 //
     /* 223382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 223385 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223392 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 223405 */     // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_INC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 223405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2),
     /* 223408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223413 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223427 */     GIR_RootConstrainSelectedInstOperands,
     /* 223428 */     // GIR_Coverage, 4069,
     /* 223428 */     GIR_EraseRootFromParent_Done,
     /* 223429 */   // Label 3585: @223429
     /* 223429 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(223485), // Rule ID 4071 //
     /* 223434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 223437 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 223459 */     // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_INC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 223459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2_RTN),
     /* 223462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223469 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223483 */     GIR_RootConstrainSelectedInstOperands,
     /* 223484 */     // GIR_Coverage, 4071,
     /* 223484 */     GIR_EraseRootFromParent_Done,
     /* 223485 */   // Label 3586: @223485
     /* 223485 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(223538), // Rule ID 3694 //
     /* 223490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 223493 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223501 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223514 */     // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_noret_i64>>  =>  (FLAT_ATOMIC_INC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 223514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2),
     /* 223517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223522 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223536 */     GIR_RootConstrainSelectedInstOperands,
     /* 223537 */     // GIR_Coverage, 3694,
     /* 223537 */     GIR_EraseRootFromParent_Done,
     /* 223538 */   // Label 3587: @223538
     /* 223538 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(223590), // Rule ID 3754 //
     /* 223543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 223546 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223553 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223566 */     // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (FLAT_ATOMIC_INC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 223566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2),
     /* 223569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223574 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223588 */     GIR_RootConstrainSelectedInstOperands,
     /* 223589 */     // GIR_Coverage, 3754,
     /* 223589 */     GIR_EraseRootFromParent_Done,
     /* 223590 */   // Label 3588: @223590
     /* 223590 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(223647), // Rule ID 3693 //
     /* 223595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 223598 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223621 */     // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_i64>>  =>  (FLAT_ATOMIC_INC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 223621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2_RTN),
     /* 223624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223631 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223645 */     GIR_RootConstrainSelectedInstOperands,
     /* 223646 */     // GIR_Coverage, 3693,
     /* 223646 */     GIR_EraseRootFromParent_Done,
     /* 223647 */   // Label 3589: @223647
     /* 223647 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(223703), // Rule ID 3753 //
     /* 223652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 223655 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 223666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223677 */     // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (FLAT_ATOMIC_INC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 223677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2_RTN),
     /* 223680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223687 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223701 */     GIR_RootConstrainSelectedInstOperands,
     /* 223702 */     // GIR_Coverage, 3753,
     /* 223702 */     GIR_EraseRootFromParent_Done,
     /* 223703 */   // Label 3590: @223703
     /* 223703 */   GIM_Reject,
     /* 223704 */ // Label 3568: @223704
     /* 223704 */ GIM_Reject,
     /* 223705 */ // Label 3544: @223705
     /* 223705 */ GIM_Reject,
     /* 223706 */ // Label 33: @223706
     /* 223706 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3593*/ GIMT_Encode4(226217),
     /* 223717 */ /*GILLT_s32*//*Label 3591*/ GIMT_Encode4(223725),
     /* 223721 */ /*GILLT_s64*//*Label 3592*/ GIMT_Encode4(224971),
     /* 223725 */ // Label 3591: @223725
     /* 223725 */ GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(224970),
     /* 223730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 223733 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(223795), // Rule ID 5665 //
     /* 223738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 223741 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223748 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 223761 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 223761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_ADDR64),
     /* 223764 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 223766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 223771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 223776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 223781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 223786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223793 */     GIR_RootConstrainSelectedInstOperands,
     /* 223794 */     // GIR_Coverage, 5665,
     /* 223794 */     GIR_EraseRootFromParent_Done,
     /* 223795 */   // Label 3595: @223795
     /* 223795 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(223854), // Rule ID 5669 //
     /* 223800 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223807 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 223820 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_ADDR64 anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 223820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_ADDR64),
     /* 223823 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 223825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 223830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 223835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 223840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 223845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223852 */     GIR_RootConstrainSelectedInstOperands,
     /* 223853 */     // GIR_Coverage, 5669,
     /* 223853 */     GIR_EraseRootFromParent_Done,
     /* 223854 */   // Label 3596: @223854
     /* 223854 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(223920), // Rule ID 5663 //
     /* 223859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 223862 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 223873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 223884 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 223884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_ADDR64_RTN),
     /* 223887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 223889 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 223891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 223896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 223901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 223906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 223911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223918 */     GIR_RootConstrainSelectedInstOperands,
     /* 223919 */     // GIR_Coverage, 5663,
     /* 223919 */     GIR_EraseRootFromParent_Done,
     /* 223920 */   // Label 3597: @223920
     /* 223920 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(223983), // Rule ID 5667 //
     /* 223925 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 223936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 223947 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 223947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_ADDR64_RTN),
     /* 223950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 223952 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 223954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 223959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 223964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 223969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 223974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223981 */     GIR_RootConstrainSelectedInstOperands,
     /* 223982 */     // GIR_Coverage, 5667,
     /* 223982 */     GIR_EraseRootFromParent_Done,
     /* 223983 */   // Label 3598: @223983
     /* 223983 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(224040), // Rule ID 5664 //
     /* 223988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 223991 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223998 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 224011 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET),
     /* 224014 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 224026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224038 */     GIR_RootConstrainSelectedInstOperands,
     /* 224039 */     // GIR_Coverage, 5664,
     /* 224039 */     GIR_EraseRootFromParent_Done,
     /* 224040 */   // Label 3599: @224040
     /* 224040 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(224094), // Rule ID 5668 //
     /* 224045 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224052 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 224065 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET),
     /* 224068 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 224080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224092 */     GIR_RootConstrainSelectedInstOperands,
     /* 224093 */     // GIR_Coverage, 5668,
     /* 224093 */     GIR_EraseRootFromParent_Done,
     /* 224094 */   // Label 3600: @224094
     /* 224094 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(224155), // Rule ID 5662 //
     /* 224099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 224102 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224113 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 224124 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET_RTN),
     /* 224127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 224129 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 224141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224153 */     GIR_RootConstrainSelectedInstOperands,
     /* 224154 */     // GIR_Coverage, 5662,
     /* 224154 */     GIR_EraseRootFromParent_Done,
     /* 224155 */   // Label 3601: @224155
     /* 224155 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(224213), // Rule ID 5666 //
     /* 224160 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 224182 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN),
     /* 224185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 224187 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 224199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224211 */     GIR_RootConstrainSelectedInstOperands,
     /* 224212 */     // GIR_Coverage, 5666,
     /* 224212 */     GIR_EraseRootFromParent_Done,
     /* 224213 */   // Label 3602: @224213
     /* 224213 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(224263), // Rule ID 8152 //
     /* 224218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 224221 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 224226 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224239 */     // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_noret_i32>>  =>  (DS_DEC_U32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 224239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U32),
     /* 224242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224247 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224261 */     GIR_RootConstrainSelectedInstOperands,
     /* 224262 */     // GIR_Coverage, 8152,
     /* 224262 */     GIR_EraseRootFromParent_Done,
     /* 224263 */   // Label 3603: @224263
     /* 224263 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(224313), // Rule ID 8154 //
     /* 224268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 224271 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 224276 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224289 */     // (atomic_load_udec_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_noret_i32>>  =>  (DS_DEC_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 224289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U32_gfx9),
     /* 224292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224297 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224311 */     GIR_RootConstrainSelectedInstOperands,
     /* 224312 */     // GIR_Coverage, 8154,
     /* 224312 */     GIR_EraseRootFromParent_Done,
     /* 224313 */   // Label 3604: @224313
     /* 224313 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(224363), // Rule ID 8156 //
     /* 224318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 224321 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 224326 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224339 */     // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_noret_i32>>  =>  (DS_DEC_U32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 224339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U32),
     /* 224342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224347 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224361 */     GIR_RootConstrainSelectedInstOperands,
     /* 224362 */     // GIR_Coverage, 8156,
     /* 224362 */     GIR_EraseRootFromParent_Done,
     /* 224363 */   // Label 3605: @224363
     /* 224363 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(224417), // Rule ID 8151 //
     /* 224368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 224371 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 224376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224391 */     // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_i32>>  =>  (DS_DEC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 224391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U32),
     /* 224394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224401 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224415 */     GIR_RootConstrainSelectedInstOperands,
     /* 224416 */     // GIR_Coverage, 8151,
     /* 224416 */     GIR_EraseRootFromParent_Done,
     /* 224417 */   // Label 3606: @224417
     /* 224417 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(224471), // Rule ID 8153 //
     /* 224422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 224425 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 224430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224445 */     // (atomic_load_udec_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_i32>>  =>  (DS_DEC_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 224445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U32_gfx9),
     /* 224448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224455 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224469 */     GIR_RootConstrainSelectedInstOperands,
     /* 224470 */     // GIR_Coverage, 8153,
     /* 224470 */     GIR_EraseRootFromParent_Done,
     /* 224471 */   // Label 3607: @224471
     /* 224471 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(224525), // Rule ID 8155 //
     /* 224476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 224479 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 224484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224499 */     // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_i32>>  =>  (DS_DEC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 224499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U32),
     /* 224502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224509 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224523 */     GIR_RootConstrainSelectedInstOperands,
     /* 224524 */     // GIR_Coverage, 8155,
     /* 224524 */     GIR_EraseRootFromParent_Done,
     /* 224525 */   // Label 3608: @224525
     /* 224525 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(224582), // Rule ID 4018 //
     /* 224530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 224533 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224540 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 224553 */     // (atomic_load_udec_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_DEC_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 224553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_SADDR),
     /* 224556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 224561 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 224568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224580 */     GIR_RootConstrainSelectedInstOperands,
     /* 224581 */     // GIR_Coverage, 4018,
     /* 224581 */     GIR_EraseRootFromParent_Done,
     /* 224582 */   // Label 3609: @224582
     /* 224582 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(224643), // Rule ID 4020 //
     /* 224587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 224590 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224601 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 224612 */     // (atomic_load_udec_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_DEC_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 224612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_SADDR_RTN),
     /* 224615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 224622 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 224629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224641 */     GIR_RootConstrainSelectedInstOperands,
     /* 224642 */     // GIR_Coverage, 4020,
     /* 224642 */     GIR_EraseRootFromParent_Done,
     /* 224643 */   // Label 3610: @224643
     /* 224643 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(224695), // Rule ID 4017 //
     /* 224648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 224651 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224658 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 224671 */     // (atomic_load_udec_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_DEC VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 224671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC),
     /* 224674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 224679 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224693 */     GIR_RootConstrainSelectedInstOperands,
     /* 224694 */     // GIR_Coverage, 4017,
     /* 224694 */     GIR_EraseRootFromParent_Done,
     /* 224695 */   // Label 3611: @224695
     /* 224695 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(224751), // Rule ID 4019 //
     /* 224700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 224703 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 224725 */     // (atomic_load_udec_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_DEC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 224725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_RTN),
     /* 224728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 224735 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224749 */     GIR_RootConstrainSelectedInstOperands,
     /* 224750 */     // GIR_Coverage, 4019,
     /* 224750 */     GIR_EraseRootFromParent_Done,
     /* 224751 */   // Label 3612: @224751
     /* 224751 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(224804), // Rule ID 3670 //
     /* 224756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 224759 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224767 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 224780 */     // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_noret_i32>>  =>  (FLAT_ATOMIC_DEC VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 224780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC),
     /* 224783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 224788 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224802 */     GIR_RootConstrainSelectedInstOperands,
     /* 224803 */     // GIR_Coverage, 3670,
     /* 224803 */     GIR_EraseRootFromParent_Done,
     /* 224804 */   // Label 3613: @224804
     /* 224804 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(224856), // Rule ID 3730 //
     /* 224809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 224812 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224819 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 224832 */     // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (FLAT_ATOMIC_DEC VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 224832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC),
     /* 224835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 224840 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224854 */     GIR_RootConstrainSelectedInstOperands,
     /* 224855 */     // GIR_Coverage, 3730,
     /* 224855 */     GIR_EraseRootFromParent_Done,
     /* 224856 */   // Label 3614: @224856
     /* 224856 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(224913), // Rule ID 3669 //
     /* 224861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 224864 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 224887 */     // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_i32>>  =>  (FLAT_ATOMIC_DEC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 224887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_RTN),
     /* 224890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 224897 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224911 */     GIR_RootConstrainSelectedInstOperands,
     /* 224912 */     // GIR_Coverage, 3669,
     /* 224912 */     GIR_EraseRootFromParent_Done,
     /* 224913 */   // Label 3615: @224913
     /* 224913 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(224969), // Rule ID 3729 //
     /* 224918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 224921 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 224932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 224943 */     // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (FLAT_ATOMIC_DEC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 224943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_RTN),
     /* 224946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 224953 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224967 */     GIR_RootConstrainSelectedInstOperands,
     /* 224968 */     // GIR_Coverage, 3729,
     /* 224968 */     GIR_EraseRootFromParent_Done,
     /* 224969 */   // Label 3616: @224969
     /* 224969 */   GIM_Reject,
     /* 224970 */ // Label 3594: @224970
     /* 224970 */ GIM_Reject,
     /* 224971 */ // Label 3592: @224971
     /* 224971 */ GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(226216),
     /* 224976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224979 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(225041), // Rule ID 5761 //
     /* 224984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 224987 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224994 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 225007 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_ADDR64),
     /* 225010 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 225017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 225027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 225032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225039 */     GIR_RootConstrainSelectedInstOperands,
     /* 225040 */     // GIR_Coverage, 5761,
     /* 225040 */     GIR_EraseRootFromParent_Done,
     /* 225041 */   // Label 3618: @225041
     /* 225041 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(225100), // Rule ID 5765 //
     /* 225046 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225053 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 225066 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64 anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64),
     /* 225069 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 225076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 225086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 225091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225098 */     GIR_RootConstrainSelectedInstOperands,
     /* 225099 */     // GIR_Coverage, 5765,
     /* 225099 */     GIR_EraseRootFromParent_Done,
     /* 225100 */   // Label 3619: @225100
     /* 225100 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(225166), // Rule ID 5759 //
     /* 225105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 225108 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 225130 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_ADDR64_RTN),
     /* 225133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 225135 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 225142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 225152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 225157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225164 */     GIR_RootConstrainSelectedInstOperands,
     /* 225165 */     // GIR_Coverage, 5759,
     /* 225165 */     GIR_EraseRootFromParent_Done,
     /* 225166 */   // Label 3620: @225166
     /* 225166 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(225229), // Rule ID 5763 //
     /* 225171 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 225193 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64_RTN),
     /* 225196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 225198 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 225205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 225215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 225220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225227 */     GIR_RootConstrainSelectedInstOperands,
     /* 225228 */     // GIR_Coverage, 5763,
     /* 225228 */     GIR_EraseRootFromParent_Done,
     /* 225229 */   // Label 3621: @225229
     /* 225229 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(225286), // Rule ID 5760 //
     /* 225234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 225237 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225244 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 225257 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET),
     /* 225260 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 225272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225284 */     GIR_RootConstrainSelectedInstOperands,
     /* 225285 */     // GIR_Coverage, 5760,
     /* 225285 */     GIR_EraseRootFromParent_Done,
     /* 225286 */   // Label 3622: @225286
     /* 225286 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(225340), // Rule ID 5764 //
     /* 225291 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225298 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 225311 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET),
     /* 225314 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 225326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225338 */     GIR_RootConstrainSelectedInstOperands,
     /* 225339 */     // GIR_Coverage, 5764,
     /* 225339 */     GIR_EraseRootFromParent_Done,
     /* 225340 */   // Label 3623: @225340
     /* 225340 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(225401), // Rule ID 5758 //
     /* 225345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 225348 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 225370 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET_RTN),
     /* 225373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 225375 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 225387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225399 */     GIR_RootConstrainSelectedInstOperands,
     /* 225400 */     // GIR_Coverage, 5758,
     /* 225400 */     GIR_EraseRootFromParent_Done,
     /* 225401 */   // Label 3624: @225401
     /* 225401 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(225459), // Rule ID 5762 //
     /* 225406 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 225428 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN),
     /* 225431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 225433 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 225445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225457 */     GIR_RootConstrainSelectedInstOperands,
     /* 225458 */     // GIR_Coverage, 5762,
     /* 225458 */     GIR_EraseRootFromParent_Done,
     /* 225459 */   // Label 3625: @225459
     /* 225459 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(225509), // Rule ID 8245 //
     /* 225464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 225467 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 225472 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225485 */     // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_noret_i64>>  =>  (DS_DEC_U64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 225485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U64),
     /* 225488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225493 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225507 */     GIR_RootConstrainSelectedInstOperands,
     /* 225508 */     // GIR_Coverage, 8245,
     /* 225508 */     GIR_EraseRootFromParent_Done,
     /* 225509 */   // Label 3626: @225509
     /* 225509 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(225559), // Rule ID 8247 //
     /* 225514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 225517 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 225522 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225535 */     // (atomic_load_udec_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_noret_i64>>  =>  (DS_DEC_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 225535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U64_gfx9),
     /* 225538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225543 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225557 */     GIR_RootConstrainSelectedInstOperands,
     /* 225558 */     // GIR_Coverage, 8247,
     /* 225558 */     GIR_EraseRootFromParent_Done,
     /* 225559 */   // Label 3627: @225559
     /* 225559 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(225609), // Rule ID 8249 //
     /* 225564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 225567 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 225572 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225585 */     // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_noret_i64>>  =>  (DS_DEC_U64 ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 225585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U64),
     /* 225588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225593 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225607 */     GIR_RootConstrainSelectedInstOperands,
     /* 225608 */     // GIR_Coverage, 8249,
     /* 225608 */     GIR_EraseRootFromParent_Done,
     /* 225609 */   // Label 3628: @225609
     /* 225609 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(225663), // Rule ID 8244 //
     /* 225614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 225617 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 225622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225637 */     // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_i64>>  =>  (DS_DEC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 225637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U64),
     /* 225640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225647 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225661 */     GIR_RootConstrainSelectedInstOperands,
     /* 225662 */     // GIR_Coverage, 8244,
     /* 225662 */     GIR_EraseRootFromParent_Done,
     /* 225663 */   // Label 3629: @225663
     /* 225663 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(225717), // Rule ID 8246 //
     /* 225668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 225671 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 225676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225691 */     // (atomic_load_udec_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_i64>>  =>  (DS_DEC_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 225691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U64_gfx9),
     /* 225694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225701 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225715 */     GIR_RootConstrainSelectedInstOperands,
     /* 225716 */     // GIR_Coverage, 8246,
     /* 225716 */     GIR_EraseRootFromParent_Done,
     /* 225717 */   // Label 3630: @225717
     /* 225717 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(225771), // Rule ID 8248 //
     /* 225722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 225725 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 225730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225745 */     // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_i64>>  =>  (DS_DEC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9819:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 225745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U64),
     /* 225748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225755 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225769 */     GIR_RootConstrainSelectedInstOperands,
     /* 225770 */     // GIR_Coverage, 8248,
     /* 225770 */     GIR_EraseRootFromParent_Done,
     /* 225771 */   // Label 3631: @225771
     /* 225771 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(225828), // Rule ID 4074 //
     /* 225776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 225779 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225786 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 225799 */     // (atomic_load_udec_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 225799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2_SADDR),
     /* 225802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 225807 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 225809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 225814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225826 */     GIR_RootConstrainSelectedInstOperands,
     /* 225827 */     // GIR_Coverage, 4074,
     /* 225827 */     GIR_EraseRootFromParent_Done,
     /* 225828 */   // Label 3632: @225828
     /* 225828 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(225889), // Rule ID 4076 //
     /* 225833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 225836 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 225858 */     // (atomic_load_udec_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 225858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2_SADDR_RTN),
     /* 225861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 225868 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 225870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 225875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225887 */     GIR_RootConstrainSelectedInstOperands,
     /* 225888 */     // GIR_Coverage, 4076,
     /* 225888 */     GIR_EraseRootFromParent_Done,
     /* 225889 */   // Label 3633: @225889
     /* 225889 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(225941), // Rule ID 4073 //
     /* 225894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 225897 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225904 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 225917 */     // (atomic_load_udec_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 225917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2),
     /* 225920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 225925 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 225927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225939 */     GIR_RootConstrainSelectedInstOperands,
     /* 225940 */     // GIR_Coverage, 4073,
     /* 225940 */     GIR_EraseRootFromParent_Done,
     /* 225941 */   // Label 3634: @225941
     /* 225941 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(225997), // Rule ID 4075 //
     /* 225946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 225949 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 225971 */     // (atomic_load_udec_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 225971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2_RTN),
     /* 225974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 225981 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 225983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225995 */     GIR_RootConstrainSelectedInstOperands,
     /* 225996 */     // GIR_Coverage, 4075,
     /* 225996 */     GIR_EraseRootFromParent_Done,
     /* 225997 */   // Label 3635: @225997
     /* 225997 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(226050), // Rule ID 3696 //
     /* 226002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 226005 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226013 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 226026 */     // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_noret_i64>>  =>  (FLAT_ATOMIC_DEC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 226026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2),
     /* 226029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226034 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226048 */     GIR_RootConstrainSelectedInstOperands,
     /* 226049 */     // GIR_Coverage, 3696,
     /* 226049 */     GIR_EraseRootFromParent_Done,
     /* 226050 */   // Label 3636: @226050
     /* 226050 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(226102), // Rule ID 3756 //
     /* 226055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 226058 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226065 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 226078 */     // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (FLAT_ATOMIC_DEC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 226078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2),
     /* 226081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226086 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226100 */     GIR_RootConstrainSelectedInstOperands,
     /* 226101 */     // GIR_Coverage, 3756,
     /* 226101 */     GIR_EraseRootFromParent_Done,
     /* 226102 */   // Label 3637: @226102
     /* 226102 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(226159), // Rule ID 3695 //
     /* 226107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 226110 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 226122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 226133 */     // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_i64>>  =>  (FLAT_ATOMIC_DEC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 226133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2_RTN),
     /* 226136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 226138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226143 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226157 */     GIR_RootConstrainSelectedInstOperands,
     /* 226158 */     // GIR_Coverage, 3695,
     /* 226158 */     GIR_EraseRootFromParent_Done,
     /* 226159 */   // Label 3638: @226159
     /* 226159 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(226215), // Rule ID 3755 //
     /* 226164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 226167 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 226178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 226189 */     // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (FLAT_ATOMIC_DEC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 226189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2_RTN),
     /* 226192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 226194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226199 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226213 */     GIR_RootConstrainSelectedInstOperands,
     /* 226214 */     // GIR_Coverage, 3755,
     /* 226214 */     GIR_EraseRootFromParent_Done,
     /* 226215 */   // Label 3639: @226215
     /* 226215 */   GIM_Reject,
     /* 226216 */ // Label 3617: @226216
     /* 226216 */ GIM_Reject,
     /* 226217 */ // Label 3593: @226217
     /* 226217 */ GIM_Reject,
     /* 226218 */ // Label 34: @226218
     /* 226218 */ GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(226236), // Rule ID 1333 //
     /* 226223 */   // MIs[0] ordering
     /* 226223 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 226226 */   // MIs[0] scope
     /* 226226 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 226229 */   // (atomic_fence (timm:{ *:[i32] }):$ordering, (timm:{ *:[i32] }):$scope)  =>  (ATOMIC_FENCE (timm:{ *:[i32] }):$ordering, (timm:{ *:[i32] }):$scope)
     /* 226229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::ATOMIC_FENCE),
     /* 226234 */   GIR_RootConstrainSelectedInstOperands,
     /* 226235 */   // GIR_Coverage, 1333,
     /* 226235 */   GIR_Done,
     /* 226236 */ // Label 3640: @226236
     /* 226236 */ GIM_Reject,
     /* 226237 */ // Label 35: @226237
     /* 226237 */ GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(226672),
     /* 226242 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_prefetch),
     /* 226246 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(226355),
     /* 226251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /* 226255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 226258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 226261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 226264 */     GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(226309), // Rule ID 3529 //
     /* 226269 */       GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_zero),
     /* 226274 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 226281 */       // (prefetch (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_zero>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_INST ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 226281 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_INST),
     /* 226284 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 226289 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226294 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 226300 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226303 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226307 */       GIR_RootConstrainSelectedInstOperands,
     /* 226308 */       // GIR_Coverage, 3529,
     /* 226308 */       GIR_EraseRootFromParent_Done,
     /* 226309 */     // Label 3643: @226309
     /* 226309 */     GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(226354), // Rule ID 3532 //
     /* 226314 */       GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_one),
     /* 226319 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 226326 */       // (prefetch (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_one>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 226326 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 226329 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 226334 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226339 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 226345 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226348 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226352 */       GIR_RootConstrainSelectedInstOperands,
     /* 226353 */       // GIR_Coverage, 3532,
     /* 226353 */       GIR_EraseRootFromParent_Done,
     /* 226354 */     // Label 3644: @226354
     /* 226354 */     GIM_Reject,
     /* 226355 */   // Label 3642: @226355
     /* 226355 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(226405), // Rule ID 3530 //
     /* 226360 */     // MIs[0] sbase
     /* 226360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/64,
     /* 226364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 226368 */     // MIs[0] Operand 1
     /* 226368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 226371 */     // MIs[0] Operand 2
     /* 226371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 226374 */     // MIs[0] Operand 3
     /* 226374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 226377 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_zero),
     /* 226382 */     // (prefetch SReg_64:{ *:[i64] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_zero>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_INST ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 226382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_INST),
     /* 226385 */     GIR_RootToRootCopy, /*OpIdx*/0, // sbase
     /* 226387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 226396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226403 */     GIR_RootConstrainSelectedInstOperands,
     /* 226404 */     // GIR_Coverage, 3530,
     /* 226404 */     GIR_EraseRootFromParent_Done,
     /* 226405 */   // Label 3645: @226405
     /* 226405 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(226513), // Rule ID 3531 //
     /* 226410 */     // MIs[0] sbase
     /* 226410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /* 226414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 226418 */     // MIs[0] Operand 1
     /* 226418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 226421 */     // MIs[0] Operand 2
     /* 226421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 226424 */     // MIs[0] Operand 3
     /* 226424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 226427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_zero),
     /* 226432 */     // (prefetch SReg_32:{ *:[i32] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_zero>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_INST (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$sbase, sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i32] } 0:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 226432 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 226435 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 226439 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226444 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 226447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 226449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 226452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 226456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // sbase
     /* 226465 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 226468 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 226471 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 226474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 226479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 226484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 226489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_INST),
     /* 226492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 226495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 226504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226511 */     GIR_RootConstrainSelectedInstOperands,
     /* 226512 */     // GIR_Coverage, 3531,
     /* 226512 */     GIR_EraseRootFromParent_Done,
     /* 226513 */   // Label 3646: @226513
     /* 226513 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(226563), // Rule ID 3533 //
     /* 226518 */     // MIs[0] sbase
     /* 226518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/64,
     /* 226522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 226526 */     // MIs[0] Operand 1
     /* 226526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 226529 */     // MIs[0] Operand 2
     /* 226529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 226532 */     // MIs[0] Operand 3
     /* 226532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 226535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_one),
     /* 226540 */     // (prefetch SReg_64:{ *:[i64] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_one>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 226540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 226543 */     GIR_RootToRootCopy, /*OpIdx*/0, // sbase
     /* 226545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 226554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226561 */     GIR_RootConstrainSelectedInstOperands,
     /* 226562 */     // GIR_Coverage, 3533,
     /* 226562 */     GIR_EraseRootFromParent_Done,
     /* 226563 */   // Label 3647: @226563
     /* 226563 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(226671), // Rule ID 3534 //
     /* 226568 */     // MIs[0] sbase
     /* 226568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /* 226572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 226576 */     // MIs[0] Operand 1
     /* 226576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 226579 */     // MIs[0] Operand 2
     /* 226579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 226582 */     // MIs[0] Operand 3
     /* 226582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 226585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_one),
     /* 226590 */     // (prefetch SReg_32:{ *:[i32] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_one>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_DATA (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$sbase, sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i32] } 0:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 226590 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 226593 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 226597 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226602 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 226605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 226607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 226610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 226614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226619 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // sbase
     /* 226623 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 226626 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 226629 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 226632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 226637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 226642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 226647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 226650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 226653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 226662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226669 */     GIR_RootConstrainSelectedInstOperands,
     /* 226670 */     // GIR_Coverage, 3534,
     /* 226670 */     GIR_EraseRootFromParent_Done,
     /* 226671 */   // Label 3648: @226671
     /* 226671 */   GIM_Reject,
     /* 226672 */ // Label 3641: @226672
     /* 226672 */ GIM_Reject,
     /* 226673 */ // Label 36: @226673
     /* 226673 */ GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(226754),
     /* 226678 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 226681 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(226705), // Rule ID 20 //
     /* 226686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_getpc),
     /* 226691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 226694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 226698 */     // (intrinsic_wo_chain:{ *:[i64] } 3163:{ *:[iPTR] })  =>  (S_GETPC_B64_pseudo:{ *:[i64] })
     /* 226698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETPC_B64_pseudo),
     /* 226701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 226703 */     GIR_RootConstrainSelectedInstOperands,
     /* 226704 */     // GIR_Coverage, 20,
     /* 226704 */     GIR_EraseRootFromParent_Done,
     /* 226705 */   // Label 3650: @226705
     /* 226705 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(226729), // Rule ID 1343 //
     /* 226710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_groupstaticsize),
     /* 226715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 226718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 226722 */     // (intrinsic_wo_chain:{ *:[i32] } 2222:{ *:[iPTR] })  =>  (GET_GROUPSTATICSIZE:{ *:[i32] })
     /* 226722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GET_GROUPSTATICSIZE),
     /* 226725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 226727 */     GIR_RootConstrainSelectedInstOperands,
     /* 226728 */     // GIR_Coverage, 1343,
     /* 226728 */     GIR_EraseRootFromParent_Done,
     /* 226729 */   // Label 3651: @226729
     /* 226729 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(226753), // Rule ID 1350 //
     /* 226734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ps_live),
     /* 226739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 226742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 226746 */     // (intrinsic_wo_chain:{ *:[i1] } 3086:{ *:[iPTR] })  =>  (SI_PS_LIVE:{ *:[i1] })
     /* 226746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_PS_LIVE),
     /* 226749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226751 */     GIR_RootConstrainSelectedInstOperands,
     /* 226752 */     // GIR_Coverage, 1350,
     /* 226752 */     GIR_EraseRootFromParent_Done,
     /* 226753 */   // Label 3652: @226753
     /* 226753 */   GIM_Reject,
     /* 226754 */ // Label 3649: @226754
     /* 226754 */ GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(230500),
     /* 226759 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 226762 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(226844), // Rule ID 2689 //
     /* 226767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 226770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 226775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 226778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 226781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 226785 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21538),
     /* 226789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 226796 */     // (intrinsic_wo_chain:{ *:[f16] } 2198:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21538>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_EXP_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 226796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 226799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_EXP_F16_e64),
     /* 226803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 226813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 226818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 226823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 226828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 226830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 226833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 226838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 226843 */     // GIR_Coverage, 2689,
     /* 226843 */     GIR_EraseRootFromParent_Done,
     /* 226844 */   // Label 3654: @226844
     /* 226844 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(226926), // Rule ID 2691 //
     /* 226849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 226852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 226857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 226860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 226863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 226867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21540),
     /* 226871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 226878 */     // (intrinsic_wo_chain:{ *:[f16] } 3014:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21540>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_LOG_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 226878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 226881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_LOG_F16_e64),
     /* 226885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 226895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 226900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 226905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 226910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 226912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 226915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 226920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 226925 */     // GIR_Coverage, 2691,
     /* 226925 */     GIR_EraseRootFromParent_Done,
     /* 226926 */   // Label 3655: @226926
     /* 226926 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(227008), // Rule ID 2693 //
     /* 226931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 226934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 226939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 226942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 226945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 226949 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21532),
     /* 226953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 226960 */     // (intrinsic_wo_chain:{ *:[f16] } 3139:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21532>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_RCP_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 226960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 226963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RCP_F16_e64),
     /* 226967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 226972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 226977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 226982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 226987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 226992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 226994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 226997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227007 */     // GIR_Coverage, 2693,
     /* 227007 */     GIR_EraseRootFromParent_Done,
     /* 227008 */   // Label 3656: @227008
     /* 227008 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(227090), // Rule ID 2695 //
     /* 227013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 227021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 227024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 227027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21534),
     /* 227035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227042 */     // (intrinsic_wo_chain:{ *:[f16] } 3144:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21534>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_RSQ_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 227042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RSQ_F16_e64),
     /* 227049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 227079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227089 */     // GIR_Coverage, 2695,
     /* 227089 */     GIR_EraseRootFromParent_Done,
     /* 227090 */   // Label 3657: @227090
     /* 227090 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(227172), // Rule ID 2698 //
     /* 227095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 227103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 227106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 227109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227113 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21536),
     /* 227117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227124 */     // (intrinsic_wo_chain:{ *:[f16] } 3233:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21536>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_SQRT_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 227124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 227127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F16_e64),
     /* 227131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 227136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 227158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 227161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 227166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227171 */     // GIR_Coverage, 2698,
     /* 227171 */     GIR_EraseRootFromParent_Done,
     /* 227172 */   // Label 3658: @227172
     /* 227172 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(227205), // Rule ID 16 //
     /* 227177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sffbh),
     /* 227182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 227192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13762),
     /* 227196 */     // (intrinsic_wo_chain:{ *:[i32] } 3202:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13762>>  =>  (S_FLBIT_I32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 227196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32),
     /* 227199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 227201 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 227203 */     GIR_RootConstrainSelectedInstOperands,
     /* 227204 */     // GIR_Coverage, 16,
     /* 227204 */     GIR_EraseRootFromParent_Done,
     /* 227205 */   // Label 3659: @227205
     /* 227205 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(227237), // Rule ID 1334 //
     /* 227210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 227213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_inverse_ballot),
     /* 227218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 227221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 227228 */     // (intrinsic_wo_chain:{ *:[i1] } 3004:{ *:[iPTR] }, i32:{ *:[i32] }:$mask)  =>  (S_INVERSE_BALLOT_U32:{ *:[i1] } i32:{ *:[i32] }:$mask)
     /* 227228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INVERSE_BALLOT_U32),
     /* 227231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 227233 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 227235 */     GIR_RootConstrainSelectedInstOperands,
     /* 227236 */     // GIR_Coverage, 1334,
     /* 227236 */     GIR_EraseRootFromParent_Done,
     /* 227237 */   // Label 3660: @227237
     /* 227237 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(227269), // Rule ID 1335 //
     /* 227242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 227245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_inverse_ballot),
     /* 227250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 227253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 227256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 227260 */     // (intrinsic_wo_chain:{ *:[i1] } 3004:{ *:[iPTR] }, i64:{ *:[i64] }:$mask)  =>  (S_INVERSE_BALLOT_U64:{ *:[i1] } i64:{ *:[i64] }:$mask)
     /* 227260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INVERSE_BALLOT_U64),
     /* 227263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 227265 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 227267 */     GIR_RootConstrainSelectedInstOperands,
     /* 227268 */     // GIR_Coverage, 1335,
     /* 227268 */     GIR_EraseRootFromParent_Done,
     /* 227269 */   // Label 3661: @227269
     /* 227269 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(227330), // Rule ID 1075 //
     /* 227274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 227282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227292 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21527),
     /* 227296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227303 */     // (intrinsic_wo_chain:{ *:[f32] } 2198:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21527>>  =>  (V_S_EXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_EXP_F32_e64),
     /* 227306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227328 */     GIR_RootConstrainSelectedInstOperands,
     /* 227329 */     // GIR_Coverage, 1075,
     /* 227329 */     GIR_EraseRootFromParent_Done,
     /* 227330 */   // Label 3662: @227330
     /* 227330 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(227391), // Rule ID 1077 //
     /* 227335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 227343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227353 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21530),
     /* 227357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227364 */     // (intrinsic_wo_chain:{ *:[f32] } 3014:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21530>>  =>  (V_S_LOG_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_LOG_F32_e64),
     /* 227367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227389 */     GIR_RootConstrainSelectedInstOperands,
     /* 227390 */     // GIR_Coverage, 1077,
     /* 227390 */     GIR_EraseRootFromParent_Done,
     /* 227391 */   // Label 3663: @227391
     /* 227391 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(227452), // Rule ID 1079 //
     /* 227396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 227404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21532),
     /* 227418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227425 */     // (intrinsic_wo_chain:{ *:[f32] } 3139:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21532>>  =>  (V_S_RCP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RCP_F32_e64),
     /* 227428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227450 */     GIR_RootConstrainSelectedInstOperands,
     /* 227451 */     // GIR_Coverage, 1079,
     /* 227451 */     GIR_EraseRootFromParent_Done,
     /* 227452 */   // Label 3664: @227452
     /* 227452 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(227513), // Rule ID 1081 //
     /* 227457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 227465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21534),
     /* 227479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227486 */     // (intrinsic_wo_chain:{ *:[f32] } 3144:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21534>>  =>  (V_S_RSQ_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RSQ_F32_e64),
     /* 227489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227511 */     GIR_RootConstrainSelectedInstOperands,
     /* 227512 */     // GIR_Coverage, 1081,
     /* 227512 */     GIR_EraseRootFromParent_Done,
     /* 227513 */   // Label 3665: @227513
     /* 227513 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(227574), // Rule ID 1084 //
     /* 227518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 227521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 227526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 227536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21536),
     /* 227540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227547 */     // (intrinsic_wo_chain:{ *:[f32] } 3233:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21536>>  =>  (V_S_SQRT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F32_e64),
     /* 227550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227572 */     GIR_RootConstrainSelectedInstOperands,
     /* 227573 */     // GIR_Coverage, 1084,
     /* 227573 */     GIR_EraseRootFromParent_Done,
     /* 227574 */   // Label 3666: @227574
     /* 227574 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(227628), // Rule ID 655 //
     /* 227579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 227584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 227594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227601 */     // (intrinsic_wo_chain:{ *:[f32] } 2212:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F32_e64),
     /* 227604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227626 */     GIR_RootConstrainSelectedInstOperands,
     /* 227627 */     // GIR_Coverage, 655,
     /* 227627 */     GIR_EraseRootFromParent_Done,
     /* 227628 */   // Label 3667: @227628
     /* 227628 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(227682), // Rule ID 661 //
     /* 227633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 227638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 227648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227655 */     // (intrinsic_wo_chain:{ *:[f32] } 2198:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F32_e64),
     /* 227658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227680 */     GIR_RootConstrainSelectedInstOperands,
     /* 227681 */     // GIR_Coverage, 661,
     /* 227681 */     GIR_EraseRootFromParent_Done,
     /* 227682 */   // Label 3668: @227682
     /* 227682 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(227736), // Rule ID 663 //
     /* 227687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 227692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 227702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227709 */     // (intrinsic_wo_chain:{ *:[f32] } 3014:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F32_e64),
     /* 227712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227734 */     GIR_RootConstrainSelectedInstOperands,
     /* 227735 */     // GIR_Coverage, 663,
     /* 227735 */     GIR_EraseRootFromParent_Done,
     /* 227736 */   // Label 3669: @227736
     /* 227736 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(227790), // Rule ID 665 //
     /* 227741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 227746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 227756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227763 */     // (intrinsic_wo_chain:{ *:[f32] } 3139:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F32_e64),
     /* 227766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227788 */     GIR_RootConstrainSelectedInstOperands,
     /* 227789 */     // GIR_Coverage, 665,
     /* 227789 */     GIR_EraseRootFromParent_Done,
     /* 227790 */   // Label 3670: @227790
     /* 227790 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(227844), // Rule ID 668 //
     /* 227795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 227800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 227810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227817 */     // (intrinsic_wo_chain:{ *:[f32] } 3144:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F32_e64),
     /* 227820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227842 */     GIR_RootConstrainSelectedInstOperands,
     /* 227843 */     // GIR_Coverage, 668,
     /* 227843 */     GIR_EraseRootFromParent_Done,
     /* 227844 */   // Label 3671: @227844
     /* 227844 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(227898), // Rule ID 670 //
     /* 227849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 227854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 227857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 227864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227871 */     // (intrinsic_wo_chain:{ *:[f32] } 3233:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F32_e64),
     /* 227874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227896 */     GIR_RootConstrainSelectedInstOperands,
     /* 227897 */     // GIR_Coverage, 670,
     /* 227897 */     GIR_EraseRootFromParent_Done,
     /* 227898 */   // Label 3672: @227898
     /* 227898 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(227952), // Rule ID 671 //
     /* 227903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 227908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 227911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 227914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 227918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227925 */     // (intrinsic_wo_chain:{ *:[f64] } 3139:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F64_e64),
     /* 227928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 227950 */     GIR_RootConstrainSelectedInstOperands,
     /* 227951 */     // GIR_Coverage, 671,
     /* 227951 */     GIR_EraseRootFromParent_Done,
     /* 227952 */   // Label 3673: @227952
     /* 227952 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(228006), // Rule ID 673 //
     /* 227957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 227962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 227965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 227968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 227972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 227979 */     // (intrinsic_wo_chain:{ *:[f64] } 3144:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 227979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F64_e64),
     /* 227982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 227989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 227994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 227999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228004 */     GIR_RootConstrainSelectedInstOperands,
     /* 228005 */     // GIR_Coverage, 673,
     /* 228005 */     GIR_EraseRootFromParent_Done,
     /* 228006 */   // Label 3674: @228006
     /* 228006 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(228060), // Rule ID 675 //
     /* 228011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 228016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 228019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 228026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228033 */     // (intrinsic_wo_chain:{ *:[f64] } 3233:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F64_e64),
     /* 228036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228058 */     GIR_RootConstrainSelectedInstOperands,
     /* 228059 */     // GIR_Coverage, 675,
     /* 228059 */     GIR_EraseRootFromParent_Done,
     /* 228060 */   // Label 3675: @228060
     /* 228060 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(228114), // Rule ID 676 //
     /* 228065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
     /* 228070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228087 */     // (intrinsic_wo_chain:{ *:[f32] } 3203:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F32_e64),
     /* 228090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228112 */     GIR_RootConstrainSelectedInstOperands,
     /* 228113 */     // GIR_Coverage, 676,
     /* 228113 */     GIR_EraseRootFromParent_Done,
     /* 228114 */   // Label 3676: @228114
     /* 228114 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(228168), // Rule ID 678 //
     /* 228119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
     /* 228124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228141 */     // (intrinsic_wo_chain:{ *:[f32] } 2087:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_COS_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F32_e64),
     /* 228144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228166 */     GIR_RootConstrainSelectedInstOperands,
     /* 228167 */     // GIR_Coverage, 678,
     /* 228167 */     GIR_EraseRootFromParent_Done,
     /* 228168 */   // Label 3677: @228168
     /* 228168 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(228207), // Rule ID 685 //
     /* 228173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sffbh),
     /* 228178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228195 */     // (intrinsic_wo_chain:{ *:[i32] } 3202:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBH_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 228195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBH_I32_e64),
     /* 228198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228205 */     GIR_RootConstrainSelectedInstOperands,
     /* 228206 */     // GIR_Coverage, 685,
     /* 228206 */     GIR_EraseRootFromParent_Done,
     /* 228207 */   // Label 3678: @228207
     /* 228207 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(228261), // Rule ID 687 //
     /* 228212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 228217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228234 */     // (intrinsic_wo_chain:{ *:[i32] } 2213:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_EXP_I32_F64_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I32_F64_e64),
     /* 228237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228259 */     GIR_RootConstrainSelectedInstOperands,
     /* 228260 */     // GIR_Coverage, 687,
     /* 228260 */     GIR_EraseRootFromParent_Done,
     /* 228261 */   // Label 3679: @228261
     /* 228261 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(228315), // Rule ID 688 //
     /* 228266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 228271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 228274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 228281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228288 */     // (intrinsic_wo_chain:{ *:[f64] } 2214:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F64_e64),
     /* 228291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228313 */     GIR_RootConstrainSelectedInstOperands,
     /* 228314 */     // GIR_Coverage, 688,
     /* 228314 */     GIR_EraseRootFromParent_Done,
     /* 228315 */   // Label 3680: @228315
     /* 228315 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(228369), // Rule ID 689 //
     /* 228320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 228325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 228328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 228335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228342 */     // (intrinsic_wo_chain:{ *:[f64] } 2212:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F64_e64),
     /* 228345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228367 */     GIR_RootConstrainSelectedInstOperands,
     /* 228368 */     // GIR_Coverage, 689,
     /* 228368 */     GIR_EraseRootFromParent_Done,
     /* 228369 */   // Label 3681: @228369
     /* 228369 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(228418), // Rule ID 691 //
     /* 228374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 228379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228396 */     // (intrinsic_wo_chain:{ *:[i32] } 2213:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp))  =>  (V_FREXP_EXP_I32_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp)
     /* 228396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I32_F32_e64),
     /* 228399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228416 */     GIR_RootConstrainSelectedInstOperands,
     /* 228417 */     // GIR_Coverage, 691,
     /* 228417 */     GIR_EraseRootFromParent_Done,
     /* 228418 */   // Label 3682: @228418
     /* 228418 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(228472), // Rule ID 692 //
     /* 228423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 228428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228445 */     // (intrinsic_wo_chain:{ *:[f32] } 2214:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F32_e64),
     /* 228448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228470 */     GIR_RootConstrainSelectedInstOperands,
     /* 228471 */     // GIR_Coverage, 692,
     /* 228471 */     GIR_EraseRootFromParent_Done,
     /* 228472 */   // Label 3683: @228472
     /* 228472 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(228529), // Rule ID 693 //
     /* 228477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 228480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log_clamp),
     /* 228485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228502 */     // (intrinsic_wo_chain:{ *:[f32] } 3015:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_CLAMP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_CLAMP_F32_e64),
     /* 228505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228527 */     GIR_RootConstrainSelectedInstOperands,
     /* 228528 */     // GIR_Coverage, 693,
     /* 228528 */     GIR_EraseRootFromParent_Done,
     /* 228529 */   // Label 3684: @228529
     /* 228529 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(228586), // Rule ID 694 //
     /* 228534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 228537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp_legacy),
     /* 228542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228559 */     // (intrinsic_wo_chain:{ *:[f32] } 3140:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_LEGACY_F32_e64),
     /* 228562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228584 */     GIR_RootConstrainSelectedInstOperands,
     /* 228585 */     // GIR_Coverage, 694,
     /* 228585 */     GIR_EraseRootFromParent_Done,
     /* 228586 */   // Label 3685: @228586
     /* 228586 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(228643), // Rule ID 696 //
     /* 228591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 228594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq_clamp),
     /* 228599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228616 */     // (intrinsic_wo_chain:{ *:[f32] } 3145:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_CLAMP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_CLAMP_F32_e64),
     /* 228619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228641 */     GIR_RootConstrainSelectedInstOperands,
     /* 228642 */     // GIR_Coverage, 696,
     /* 228642 */     GIR_EraseRootFromParent_Done,
     /* 228643 */   // Label 3686: @228643
     /* 228643 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(228700), // Rule ID 698 //
     /* 228648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 228651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq_legacy),
     /* 228656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 228659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 228662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228673 */     // (intrinsic_wo_chain:{ *:[f32] } 3146:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_LEGACY_F32_e64),
     /* 228676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228698 */     GIR_RootConstrainSelectedInstOperands,
     /* 228699 */     // GIR_Coverage, 698,
     /* 228699 */     GIR_EraseRootFromParent_Done,
     /* 228700 */   // Label 3687: @228700
     /* 228700 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(228757), // Rule ID 699 //
     /* 228705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 228708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq_clamp),
     /* 228713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 228716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 228723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228730 */     // (intrinsic_wo_chain:{ *:[f64] } 3145:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_CLAMP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_CLAMP_F64_e64),
     /* 228733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228755 */     GIR_RootConstrainSelectedInstOperands,
     /* 228756 */     // GIR_Coverage, 699,
     /* 228756 */     GIR_EraseRootFromParent_Done,
     /* 228757 */   // Label 3688: @228757
     /* 228757 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(228814), // Rule ID 717 //
     /* 228762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 228765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 228770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 228773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 228776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228787 */     // (intrinsic_wo_chain:{ *:[f16] } 3139:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F16_e64),
     /* 228790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228812 */     GIR_RootConstrainSelectedInstOperands,
     /* 228813 */     // GIR_Coverage, 717,
     /* 228813 */     GIR_EraseRootFromParent_Done,
     /* 228814 */   // Label 3689: @228814
     /* 228814 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(228871), // Rule ID 721 //
     /* 228819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 228822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 228827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 228830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 228833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228844 */     // (intrinsic_wo_chain:{ *:[f16] } 3139:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F16_fake16_e64),
     /* 228847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228869 */     GIR_RootConstrainSelectedInstOperands,
     /* 228870 */     // GIR_Coverage, 721,
     /* 228870 */     GIR_EraseRootFromParent_Done,
     /* 228871 */   // Label 3690: @228871
     /* 228871 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(228928), // Rule ID 724 //
     /* 228876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 228879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 228884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 228887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 228890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228901 */     // (intrinsic_wo_chain:{ *:[f16] } 3233:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_e64),
     /* 228904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228926 */     GIR_RootConstrainSelectedInstOperands,
     /* 228927 */     // GIR_Coverage, 724,
     /* 228927 */     GIR_EraseRootFromParent_Done,
     /* 228928 */   // Label 3691: @228928
     /* 228928 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(228985), // Rule ID 728 //
     /* 228933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 228936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 228941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 228944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 228947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 228951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 228958 */     // (intrinsic_wo_chain:{ *:[f16] } 3233:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 228958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_fake16_e64),
     /* 228961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 228968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 228973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 228978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 228983 */     GIR_RootConstrainSelectedInstOperands,
     /* 228984 */     // GIR_Coverage, 728,
     /* 228984 */     GIR_EraseRootFromParent_Done,
     /* 228985 */   // Label 3692: @228985
     /* 228985 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(229042), // Rule ID 729 //
     /* 228990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 228993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 228998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229015 */     // (intrinsic_wo_chain:{ *:[f16] } 3144:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F16_e64),
     /* 229018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229040 */     GIR_RootConstrainSelectedInstOperands,
     /* 229041 */     // GIR_Coverage, 729,
     /* 229041 */     GIR_EraseRootFromParent_Done,
     /* 229042 */   // Label 3693: @229042
     /* 229042 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(229099), // Rule ID 733 //
     /* 229047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 229055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229072 */     // (intrinsic_wo_chain:{ *:[f16] } 3144:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F16_fake16_e64),
     /* 229075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229097 */     GIR_RootConstrainSelectedInstOperands,
     /* 229098 */     // GIR_Coverage, 733,
     /* 229098 */     GIR_EraseRootFromParent_Done,
     /* 229099 */   // Label 3694: @229099
     /* 229099 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(229156), // Rule ID 735 //
     /* 229104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 229112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229129 */     // (intrinsic_wo_chain:{ *:[f16] } 3014:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_e64),
     /* 229132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229154 */     GIR_RootConstrainSelectedInstOperands,
     /* 229155 */     // GIR_Coverage, 735,
     /* 229155 */     GIR_EraseRootFromParent_Done,
     /* 229156 */   // Label 3695: @229156
     /* 229156 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(229213), // Rule ID 739 //
     /* 229161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 229169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229186 */     // (intrinsic_wo_chain:{ *:[f16] } 3014:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_fake16_e64),
     /* 229189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229211 */     GIR_RootConstrainSelectedInstOperands,
     /* 229212 */     // GIR_Coverage, 739,
     /* 229212 */     GIR_EraseRootFromParent_Done,
     /* 229213 */   // Label 3696: @229213
     /* 229213 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(229270), // Rule ID 741 //
     /* 229218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 229226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229243 */     // (intrinsic_wo_chain:{ *:[f16] } 2198:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_e64),
     /* 229246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229268 */     GIR_RootConstrainSelectedInstOperands,
     /* 229269 */     // GIR_Coverage, 741,
     /* 229269 */     GIR_EraseRootFromParent_Done,
     /* 229270 */   // Label 3697: @229270
     /* 229270 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(229327), // Rule ID 745 //
     /* 229275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 229283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229300 */     // (intrinsic_wo_chain:{ *:[f16] } 2198:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_fake16_e64),
     /* 229303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229325 */     GIR_RootConstrainSelectedInstOperands,
     /* 229326 */     // GIR_Coverage, 745,
     /* 229326 */     GIR_EraseRootFromParent_Done,
     /* 229327 */   // Label 3698: @229327
     /* 229327 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(229384), // Rule ID 747 //
     /* 229332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
     /* 229340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229357 */     // (intrinsic_wo_chain:{ *:[f16] } 3203:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F16_e64),
     /* 229360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229382 */     GIR_RootConstrainSelectedInstOperands,
     /* 229383 */     // GIR_Coverage, 747,
     /* 229383 */     GIR_EraseRootFromParent_Done,
     /* 229384 */   // Label 3699: @229384
     /* 229384 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(229441), // Rule ID 751 //
     /* 229389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
     /* 229397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229414 */     // (intrinsic_wo_chain:{ *:[f16] } 3203:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F16_fake16_e64),
     /* 229417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229439 */     GIR_RootConstrainSelectedInstOperands,
     /* 229440 */     // GIR_Coverage, 751,
     /* 229440 */     GIR_EraseRootFromParent_Done,
     /* 229441 */   // Label 3700: @229441
     /* 229441 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(229498), // Rule ID 753 //
     /* 229446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
     /* 229454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229471 */     // (intrinsic_wo_chain:{ *:[f16] } 2087:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_COS_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F16_e64),
     /* 229474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229496 */     GIR_RootConstrainSelectedInstOperands,
     /* 229497 */     // GIR_Coverage, 753,
     /* 229497 */     GIR_EraseRootFromParent_Done,
     /* 229498 */   // Label 3701: @229498
     /* 229498 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(229555), // Rule ID 757 //
     /* 229503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
     /* 229511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229528 */     // (intrinsic_wo_chain:{ *:[f16] } 2087:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_COS_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F16_fake16_e64),
     /* 229531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229553 */     GIR_RootConstrainSelectedInstOperands,
     /* 229554 */     // GIR_Coverage, 757,
     /* 229554 */     GIR_EraseRootFromParent_Done,
     /* 229555 */   // Label 3702: @229555
     /* 229555 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(229612), // Rule ID 759 //
     /* 229560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 229568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229585 */     // (intrinsic_wo_chain:{ *:[f16] } 2214:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F16_e64),
     /* 229588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229610 */     GIR_RootConstrainSelectedInstOperands,
     /* 229611 */     // GIR_Coverage, 759,
     /* 229611 */     GIR_EraseRootFromParent_Done,
     /* 229612 */   // Label 3703: @229612
     /* 229612 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(229669), // Rule ID 761 //
     /* 229617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 229625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229642 */     // (intrinsic_wo_chain:{ *:[f16] } 2214:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F16_fake16_e64),
     /* 229645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229667 */     GIR_RootConstrainSelectedInstOperands,
     /* 229668 */     // GIR_Coverage, 761,
     /* 229668 */     GIR_EraseRootFromParent_Done,
     /* 229669 */   // Label 3704: @229669
     /* 229669 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(229726), // Rule ID 762 //
     /* 229674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 229682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229699 */     // (intrinsic_wo_chain:{ *:[i16] } 2213:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_EXP_I16_F16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I16_F16_e64),
     /* 229702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229724 */     GIR_RootConstrainSelectedInstOperands,
     /* 229725 */     // GIR_Coverage, 762,
     /* 229725 */     GIR_EraseRootFromParent_Done,
     /* 229726 */   // Label 3705: @229726
     /* 229726 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(229783), // Rule ID 764 //
     /* 229731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 229739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229756 */     // (intrinsic_wo_chain:{ *:[i16] } 2213:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_EXP_I16_F16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I16_F16_fake16_e64),
     /* 229759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229781 */     GIR_RootConstrainSelectedInstOperands,
     /* 229782 */     // GIR_Coverage, 764,
     /* 229782 */     GIR_EraseRootFromParent_Done,
     /* 229783 */   // Label 3706: @229783
     /* 229783 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(229840), // Rule ID 777 //
     /* 229788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 229791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 229796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229813 */     // (intrinsic_wo_chain:{ *:[f16] } 2212:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F16_e64),
     /* 229816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229838 */     GIR_RootConstrainSelectedInstOperands,
     /* 229839 */     // GIR_Coverage, 777,
     /* 229839 */     GIR_EraseRootFromParent_Done,
     /* 229840 */   // Label 3707: @229840
     /* 229840 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(229897), // Rule ID 781 //
     /* 229845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 229848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 229853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229870 */     // (intrinsic_wo_chain:{ *:[f16] } 2212:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 229870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F16_fake16_e64),
     /* 229873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 229890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 229895 */     GIR_RootConstrainSelectedInstOperands,
     /* 229896 */     // GIR_Coverage, 781,
     /* 229896 */     GIR_EraseRootFromParent_Done,
     /* 229897 */   // Label 3708: @229897
     /* 229897 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(229939), // Rule ID 783 //
     /* 229902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPrngInst),
     /* 229905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_prng_b32),
     /* 229910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 229913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 229916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 229920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 229927 */     // (intrinsic_wo_chain:{ *:[i32] } 3085:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_PRNG_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 229927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PRNG_B32_e64),
     /* 229930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229937 */     GIR_RootConstrainSelectedInstOperands,
     /* 229938 */     // GIR_Coverage, 783,
     /* 229938 */     GIR_EraseRootFromParent_Done,
     /* 229939 */   // Label 3709: @229939
     /* 229939 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(229995), // Rule ID 719 //
     /* 229944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 229947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 229952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 229955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 229958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 229962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 229969 */     // (intrinsic_wo_chain:{ *:[f16] } 3139:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_RCP_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 229969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F16_t16_e64),
     /* 229972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 229979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 229984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 229987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 229990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 229993 */     GIR_RootConstrainSelectedInstOperands,
     /* 229994 */     // GIR_Coverage, 719,
     /* 229994 */     GIR_EraseRootFromParent_Done,
     /* 229995 */   // Label 3710: @229995
     /* 229995 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(230051), // Rule ID 726 //
     /* 230000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 230008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230025 */     // (intrinsic_wo_chain:{ *:[f16] } 3233:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_SQRT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_t16_e64),
     /* 230028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230049 */     GIR_RootConstrainSelectedInstOperands,
     /* 230050 */     // GIR_Coverage, 726,
     /* 230050 */     GIR_EraseRootFromParent_Done,
     /* 230051 */   // Label 3711: @230051
     /* 230051 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(230107), // Rule ID 731 //
     /* 230056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 230064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230081 */     // (intrinsic_wo_chain:{ *:[f16] } 3144:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_RSQ_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F16_t16_e64),
     /* 230084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230105 */     GIR_RootConstrainSelectedInstOperands,
     /* 230106 */     // GIR_Coverage, 731,
     /* 230106 */     GIR_EraseRootFromParent_Done,
     /* 230107 */   // Label 3712: @230107
     /* 230107 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(230163), // Rule ID 737 //
     /* 230112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 230120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230137 */     // (intrinsic_wo_chain:{ *:[f16] } 3014:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LOG_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_t16_e64),
     /* 230140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230161 */     GIR_RootConstrainSelectedInstOperands,
     /* 230162 */     // GIR_Coverage, 737,
     /* 230162 */     GIR_EraseRootFromParent_Done,
     /* 230163 */   // Label 3713: @230163
     /* 230163 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(230219), // Rule ID 743 //
     /* 230168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 230176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230193 */     // (intrinsic_wo_chain:{ *:[f16] } 2198:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_EXP_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_t16_e64),
     /* 230196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230217 */     GIR_RootConstrainSelectedInstOperands,
     /* 230218 */     // GIR_Coverage, 743,
     /* 230218 */     GIR_EraseRootFromParent_Done,
     /* 230219 */   // Label 3714: @230219
     /* 230219 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(230275), // Rule ID 749 //
     /* 230224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
     /* 230232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230249 */     // (intrinsic_wo_chain:{ *:[f16] } 3203:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_SIN_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F16_t16_e64),
     /* 230252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230273 */     GIR_RootConstrainSelectedInstOperands,
     /* 230274 */     // GIR_Coverage, 749,
     /* 230274 */     GIR_EraseRootFromParent_Done,
     /* 230275 */   // Label 3715: @230275
     /* 230275 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(230331), // Rule ID 755 //
     /* 230280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
     /* 230288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230305 */     // (intrinsic_wo_chain:{ *:[f16] } 2087:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_COS_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F16_t16_e64),
     /* 230308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230329 */     GIR_RootConstrainSelectedInstOperands,
     /* 230330 */     // GIR_Coverage, 755,
     /* 230330 */     GIR_EraseRootFromParent_Done,
     /* 230331 */   // Label 3716: @230331
     /* 230331 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(230387), // Rule ID 760 //
     /* 230336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 230344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230361 */     // (intrinsic_wo_chain:{ *:[f16] } 2214:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FREXP_MANT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F16_t16_e64),
     /* 230364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230385 */     GIR_RootConstrainSelectedInstOperands,
     /* 230386 */     // GIR_Coverage, 760,
     /* 230386 */     GIR_EraseRootFromParent_Done,
     /* 230387 */   // Label 3717: @230387
     /* 230387 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(230443), // Rule ID 763 //
     /* 230392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 230400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230417 */     // (intrinsic_wo_chain:{ *:[i16] } 2213:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FREXP_EXP_I16_F16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I16_F16_t16_e64),
     /* 230420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230441 */     GIR_RootConstrainSelectedInstOperands,
     /* 230442 */     // GIR_Coverage, 763,
     /* 230442 */     GIR_EraseRootFromParent_Done,
     /* 230443 */   // Label 3718: @230443
     /* 230443 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(230499), // Rule ID 779 //
     /* 230448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 230456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 230473 */     // (intrinsic_wo_chain:{ *:[f16] } 2212:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FRACT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 230473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F16_t16_e64),
     /* 230476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230497 */     GIR_RootConstrainSelectedInstOperands,
     /* 230498 */     // GIR_Coverage, 779,
     /* 230498 */     GIR_EraseRootFromParent_Done,
     /* 230499 */   // Label 3719: @230499
     /* 230499 */   GIM_Reject,
     /* 230500 */ // Label 3653: @230500
     /* 230500 */ GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(233038),
     /* 230505 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 230508 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(230557), // Rule ID 1891 //
     /* 230513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 230518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 230521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 230524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 230531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 230538 */     // (intrinsic_wo_chain:{ *:[i1] } 2086:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 230538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F32_e64),
     /* 230541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 230543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230553 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230555 */     GIR_RootConstrainSelectedInstOperands,
     /* 230556 */     // GIR_Coverage, 1891,
     /* 230556 */     GIR_EraseRootFromParent_Done,
     /* 230557 */   // Label 3721: @230557
     /* 230557 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(230644), // Rule ID 1893 //
     /* 230562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 230565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 230570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 230573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 230583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 230590 */     // (intrinsic_wo_chain:{ *:[i1] } 2086:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, VSrcT_f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[i32] }:$src1, lo16:{ *:[i32] }), 0:{ *:[i32] })
     /* 230590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 230593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 230597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230602 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(2), // src1
     /* 230608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 230613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 230618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_t16_e64),
     /* 230621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 230623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230642 */     GIR_RootConstrainSelectedInstOperands,
     /* 230643 */     // GIR_Coverage, 1893,
     /* 230643 */     GIR_EraseRootFromParent_Done,
     /* 230644 */   // Label 3722: @230644
     /* 230644 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(230699), // Rule ID 1895 //
     /* 230649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 230652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 230657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 230660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 230670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 230677 */     // (intrinsic_wo_chain:{ *:[i1] } 2086:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$src1)
     /* 230677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_fake16_e64),
     /* 230680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 230682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230695 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230697 */     GIR_RootConstrainSelectedInstOperands,
     /* 230698 */     // GIR_Coverage, 1895,
     /* 230698 */     GIR_EraseRootFromParent_Done,
     /* 230699 */   // Label 3723: @230699
     /* 230699 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(230748), // Rule ID 1897 //
     /* 230704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 230709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 230712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 230715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 230722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 230729 */     // (intrinsic_wo_chain:{ *:[i1] } 2086:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 230729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F64_e64),
     /* 230732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 230734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230744 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230746 */     GIR_RootConstrainSelectedInstOperands,
     /* 230747 */     // GIR_Coverage, 1897,
     /* 230747 */     GIR_EraseRootFromParent_Done,
     /* 230748 */   // Label 3724: @230748
     /* 230748 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(230800), // Rule ID 1899 //
     /* 230753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 230756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 230761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 230764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 230770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 230774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 230781 */     // (intrinsic_wo_chain:{ *:[i1] } 2086:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1)
     /* 230781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_e64),
     /* 230784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 230786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230796 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230798 */     GIR_RootConstrainSelectedInstOperands,
     /* 230799 */     // GIR_Coverage, 1899,
     /* 230799 */     GIR_EraseRootFromParent_Done,
     /* 230800 */   // Label 3725: @230800
     /* 230800 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(230855), // Rule ID 2395 //
     /* 230805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtFP8VOP1Bug_HasFP8ConversionInsts),
     /* 230808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 230813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 230816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 230819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 230823 */     // MIs[0] Operand 3
     /* 230823 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 230834 */     // (intrinsic_wo_chain:{ *:[f32] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 230834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
     /* 230837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230842 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 230844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230853 */     GIR_RootConstrainSelectedInstOperands,
     /* 230854 */     // GIR_Coverage, 2395,
     /* 230854 */     GIR_EraseRootFromParent_Done,
     /* 230855 */   // Label 3726: @230855
     /* 230855 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(230910), // Rule ID 2396 //
     /* 230860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtFP8VOP1Bug_HasFP8ConversionInsts),
     /* 230863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 230868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 230871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 230874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 230878 */     // MIs[0] Operand 3
     /* 230878 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 230889 */     // (intrinsic_wo_chain:{ *:[f32] } 2093:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 230889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
     /* 230892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230897 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 230899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230908 */     GIR_RootConstrainSelectedInstOperands,
     /* 230909 */     // GIR_Coverage, 2396,
     /* 230909 */     GIR_EraseRootFromParent_Done,
     /* 230910 */   // Label 3727: @230910
     /* 230910 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(230953), // Rule ID 2397 //
     /* 230915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasNoCvtFP8VOP1Bug_HasSDWA),
     /* 230918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 230923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 230926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 230929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 230933 */     // MIs[0] Operand 3
     /* 230933 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 230944 */     // (intrinsic_wo_chain:{ *:[f32] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_FP8_e32:{ *:[f32] } ?:{ *:[i32] }:$src)
     /* 230944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_e32),
     /* 230947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230949 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 230951 */     GIR_RootConstrainSelectedInstOperands,
     /* 230952 */     // GIR_Coverage, 2397,
     /* 230952 */     GIR_EraseRootFromParent_Done,
     /* 230953 */   // Label 3728: @230953
     /* 230953 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(230996), // Rule ID 2398 //
     /* 230958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasNoCvtFP8VOP1Bug_HasSDWA),
     /* 230961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 230966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 230969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 230972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 230976 */     // MIs[0] Operand 3
     /* 230976 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 230987 */     // (intrinsic_wo_chain:{ *:[f32] } 2093:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_BF8_e32:{ *:[f32] } ?:{ *:[i32] }:$src)
     /* 230987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_e32),
     /* 230990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 230994 */     GIR_RootConstrainSelectedInstOperands,
     /* 230995 */     // GIR_Coverage, 2398,
     /* 230995 */     GIR_EraseRootFromParent_Done,
     /* 230996 */   // Label 3729: @230996
     /* 230996 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(231051), // Rule ID 2399 //
     /* 231001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 231009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231019 */     // MIs[0] Operand 3
     /* 231019 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 231030 */     // (intrinsic_wo_chain:{ *:[f32] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 1:{ *:[i32] })
     /* 231030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
     /* 231033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231038 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 231049 */     GIR_RootConstrainSelectedInstOperands,
     /* 231050 */     // GIR_Coverage, 2399,
     /* 231050 */     GIR_EraseRootFromParent_Done,
     /* 231051 */   // Label 3730: @231051
     /* 231051 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(231106), // Rule ID 2400 //
     /* 231056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 231064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231074 */     // MIs[0] Operand 3
     /* 231074 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 231085 */     // (intrinsic_wo_chain:{ *:[f32] } 2093:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 1:{ *:[i32] })
     /* 231085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
     /* 231088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231093 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 231104 */     GIR_RootConstrainSelectedInstOperands,
     /* 231105 */     // GIR_Coverage, 2400,
     /* 231105 */     GIR_EraseRootFromParent_Done,
     /* 231106 */   // Label 3731: @231106
     /* 231106 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(231161), // Rule ID 2401 //
     /* 231111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 231119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231129 */     // MIs[0] Operand 3
     /* 231129 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 231140 */     // (intrinsic_wo_chain:{ *:[f32] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 2:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 2:{ *:[i32] })
     /* 231140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
     /* 231143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 231159 */     GIR_RootConstrainSelectedInstOperands,
     /* 231160 */     // GIR_Coverage, 2401,
     /* 231160 */     GIR_EraseRootFromParent_Done,
     /* 231161 */   // Label 3732: @231161
     /* 231161 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(231216), // Rule ID 2402 //
     /* 231166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 231174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231184 */     // MIs[0] Operand 3
     /* 231184 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 231195 */     // (intrinsic_wo_chain:{ *:[f32] } 2093:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 2:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 2:{ *:[i32] })
     /* 231195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
     /* 231198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231203 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 231214 */     GIR_RootConstrainSelectedInstOperands,
     /* 231215 */     // GIR_Coverage, 2402,
     /* 231215 */     GIR_EraseRootFromParent_Done,
     /* 231216 */   // Label 3733: @231216
     /* 231216 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(231271), // Rule ID 2403 //
     /* 231221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 231229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231239 */     // MIs[0] Operand 3
     /* 231239 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 231250 */     // (intrinsic_wo_chain:{ *:[f32] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 3:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /* 231250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
     /* 231253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231258 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 231269 */     GIR_RootConstrainSelectedInstOperands,
     /* 231270 */     // GIR_Coverage, 2403,
     /* 231270 */     GIR_EraseRootFromParent_Done,
     /* 231271 */   // Label 3734: @231271
     /* 231271 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(231326), // Rule ID 2404 //
     /* 231276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 231284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231294 */     // MIs[0] Operand 3
     /* 231294 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 231305 */     // (intrinsic_wo_chain:{ *:[f32] } 2093:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 3:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /* 231305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
     /* 231308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231313 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 231324 */     GIR_RootConstrainSelectedInstOperands,
     /* 231325 */     // GIR_Coverage, 2404,
     /* 231325 */     GIR_EraseRootFromParent_Done,
     /* 231326 */   // Label 3735: @231326
     /* 231326 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(231369), // Rule ID 2405 //
     /* 231331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
     /* 231339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231349 */     // MIs[0] Operand 3
     /* 231349 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 231360 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
     /* 231360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_e32),
     /* 231363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231365 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231367 */     GIR_RootConstrainSelectedInstOperands,
     /* 231368 */     // GIR_Coverage, 2405,
     /* 231368 */     GIR_EraseRootFromParent_Done,
     /* 231369 */   // Label 3736: @231369
     /* 231369 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(231412), // Rule ID 2406 //
     /* 231374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
     /* 231382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231392 */     // MIs[0] Operand 3
     /* 231392 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 231403 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
     /* 231403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_e32),
     /* 231406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231408 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231410 */     GIR_RootConstrainSelectedInstOperands,
     /* 231411 */     // GIR_Coverage, 2406,
     /* 231411 */     GIR_EraseRootFromParent_Done,
     /* 231412 */   // Label 3737: @231412
     /* 231412 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(231467), // Rule ID 2407 //
     /* 231417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
     /* 231425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231435 */     // MIs[0] Operand 3
     /* 231435 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
     /* 231446 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_sdwa:{ *:[v2f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 5:{ *:[i32] })
     /* 231446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_sdwa),
     /* 231449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231454 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 231465 */     GIR_RootConstrainSelectedInstOperands,
     /* 231466 */     // GIR_Coverage, 2407,
     /* 231466 */     GIR_EraseRootFromParent_Done,
     /* 231467 */   // Label 3738: @231467
     /* 231467 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(231522), // Rule ID 2408 //
     /* 231472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 231475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
     /* 231480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231490 */     // MIs[0] Operand 3
     /* 231490 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
     /* 231501 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_sdwa:{ *:[v2f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 5:{ *:[i32] })
     /* 231501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_sdwa),
     /* 231504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231509 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 231520 */     GIR_RootConstrainSelectedInstOperands,
     /* 231521 */     // GIR_Coverage, 2408,
     /* 231521 */     GIR_EraseRootFromParent_Done,
     /* 231522 */   // Label 3739: @231522
     /* 231522 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(231565), // Rule ID 2411 //
     /* 231527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 231530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
     /* 231535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231545 */     // MIs[0] Operand 3
     /* 231545 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 231556 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_fake16_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
     /* 231556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_fake16_e32),
     /* 231559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231561 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231563 */     GIR_RootConstrainSelectedInstOperands,
     /* 231564 */     // GIR_Coverage, 2411,
     /* 231564 */     GIR_EraseRootFromParent_Done,
     /* 231565 */   // Label 3740: @231565
     /* 231565 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(231608), // Rule ID 2412 //
     /* 231570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 231573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
     /* 231578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231588 */     // MIs[0] Operand 3
     /* 231588 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 231599 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_fake16_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
     /* 231599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_fake16_e32),
     /* 231602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231604 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231606 */     GIR_RootConstrainSelectedInstOperands,
     /* 231607 */     // GIR_Coverage, 2412,
     /* 231607 */     GIR_EraseRootFromParent_Done,
     /* 231608 */   // Label 3741: @231608
     /* 231608 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(231657), // Rule ID 2413 //
     /* 231613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 231616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
     /* 231621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231631 */     // MIs[0] Operand 3
     /* 231631 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
     /* 231642 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_fake16_e64:{ *:[v2f32] } 4:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i32] })
     /* 231642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_fake16_e64),
     /* 231645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 231650 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231655 */     GIR_RootConstrainSelectedInstOperands,
     /* 231656 */     // GIR_Coverage, 2413,
     /* 231656 */     GIR_EraseRootFromParent_Done,
     /* 231657 */   // Label 3742: @231657
     /* 231657 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(231706), // Rule ID 2414 //
     /* 231662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 231665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
     /* 231670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231680 */     // MIs[0] Operand 3
     /* 231680 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
     /* 231691 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_fake16_e64:{ *:[v2f32] } 4:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i32] })
     /* 231691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_fake16_e64),
     /* 231694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 231699 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 231701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 231704 */     GIR_RootConstrainSelectedInstOperands,
     /* 231705 */     // GIR_Coverage, 2414,
     /* 231705 */     GIR_EraseRootFromParent_Done,
     /* 231706 */   // Label 3743: @231706
     /* 231706 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(231747), // Rule ID 2409 //
     /* 231711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 231714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 231719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231729 */     // MIs[0] byte_sel
     /* 231729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 231732 */     // (intrinsic_wo_chain:{ *:[f32] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_F32_FP8_OP_SEL_e64:{ *:[f32] } ?:{ *:[i32] }:$src0, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
     /* 231732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_OP_SEL_e64),
     /* 231735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231737 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 231739 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
     /* 231745 */     GIR_RootConstrainSelectedInstOperands,
     /* 231746 */     // GIR_Coverage, 2409,
     /* 231746 */     GIR_EraseRootFromParent_Done,
     /* 231747 */   // Label 3744: @231747
     /* 231747 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(231788), // Rule ID 2410 //
     /* 231752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 231755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 231760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231770 */     // MIs[0] byte_sel
     /* 231770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 231773 */     // (intrinsic_wo_chain:{ *:[f32] } 2093:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_F32_BF8_OP_SEL_e64:{ *:[f32] } ?:{ *:[i32] }:$src0, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
     /* 231773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_OP_SEL_e64),
     /* 231776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231778 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 231780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
     /* 231786 */     GIR_RootConstrainSelectedInstOperands,
     /* 231787 */     // GIR_Coverage, 2410,
     /* 231787 */     GIR_EraseRootFromParent_Done,
     /* 231788 */   // Label 3745: @231788
     /* 231788 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(231837), // Rule ID 108 //
     /* 231793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 231796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pkrtz),
     /* 231801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 231804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 231810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 231814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 231818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 231822 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13802),
     /* 231826 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2104:{ *:[iPTR] }, SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13802>>  =>  (S_CVT_PK_RTZ_F16_F32:{ *:[v2f16] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 231826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_PK_RTZ_F16_F32),
     /* 231829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 231831 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 231833 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 231835 */     GIR_RootConstrainSelectedInstOperands,
     /* 231836 */     // GIR_Coverage, 108,
     /* 231836 */     GIR_EraseRootFromParent_Done,
     /* 231837 */   // Label 3746: @231837
     /* 231837 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(231940), // Rule ID 2501 //
     /* 231842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /* 231847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 231850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 231856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231860 */     // (intrinsic_wo_chain:{ *:[i64] } 3072:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MUL_I32_I24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub0:{ *:[i32] }, (V_MUL_HI_I32_I24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub1:{ *:[i32] })
     /* 231860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 231863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_I24_e64),
     /* 231867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231872 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src0
     /* 231876 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src1
     /* 231880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 231882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 231885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_I32_I24_e64),
     /* 231889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src0
     /* 231898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // src1
     /* 231902 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 231905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 231910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231915 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 231918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 231921 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 231924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231939 */     // GIR_Coverage, 2501,
     /* 231939 */     GIR_EraseRootFromParent_Done,
     /* 231940 */   // Label 3747: @231940
     /* 231940 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(232043), // Rule ID 2503 //
     /* 231945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /* 231950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 231953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 231959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 231963 */     // (intrinsic_wo_chain:{ *:[i64] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MUL_U32_U24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub0:{ *:[i32] }, (V_MUL_HI_U32_U24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub1:{ *:[i32] })
     /* 231963 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 231966 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_U24_e64),
     /* 231970 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231975 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src0
     /* 231979 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src1
     /* 231983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 231985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 231988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_U32_U24_e64),
     /* 231992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src0
     /* 232001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // src1
     /* 232005 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 232008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 232013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232018 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 232021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 232024 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 232027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 232032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232042 */     // GIR_Coverage, 2503,
     /* 232042 */     GIR_EraseRootFromParent_Done,
     /* 232043 */   // Label 3748: @232043
     /* 232043 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(232117), // Rule ID 788 //
     /* 232048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 232053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 232080 */     // (intrinsic_wo_chain:{ *:[f32] } 2211:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LEGACY_F32_e64),
     /* 232083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 232100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 232105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232115 */     GIR_RootConstrainSelectedInstOperands,
     /* 232116 */     // GIR_Coverage, 788,
     /* 232116 */     GIR_EraseRootFromParent_Done,
     /* 232117 */   // Label 3749: @232117
     /* 232117 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(232186), // Rule ID 822 //
     /* 232122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pknorm_i16),
     /* 232127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 232130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 232154 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2102:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_CVT_PKNORM_I16_F32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 232154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PKNORM_I16_F32_e64),
     /* 232157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 232174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 232179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232184 */     GIR_RootConstrainSelectedInstOperands,
     /* 232185 */     // GIR_Coverage, 822,
     /* 232185 */     GIR_EraseRootFromParent_Done,
     /* 232186 */   // Label 3750: @232186
     /* 232186 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(232255), // Rule ID 824 //
     /* 232191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pknorm_u16),
     /* 232196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 232199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 232223 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2103:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_CVT_PKNORM_U16_F32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 232223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PKNORM_U16_F32_e64),
     /* 232226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 232243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 232248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232253 */     GIR_RootConstrainSelectedInstOperands,
     /* 232254 */     // GIR_Coverage, 824,
     /* 232254 */     GIR_EraseRootFromParent_Done,
     /* 232255 */   // Label 3751: @232255
     /* 232255 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(232329), // Rule ID 826 //
     /* 232260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pkrtz),
     /* 232265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 232268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 232292 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2104:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_CVT_PKRTZ_F16_F32_e64:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PKRTZ_F16_F32_e64),
     /* 232295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 232312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 232317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232327 */     GIR_RootConstrainSelectedInstOperands,
     /* 232328 */     // GIR_Coverage, 826,
     /* 232328 */     GIR_EraseRootFromParent_Done,
     /* 232329 */   // Label 3752: @232329
     /* 232329 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(232403), // Rule ID 982 //
     /* 232334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_trig_preop),
     /* 232339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 232342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 232345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 232352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 232366 */     // (intrinsic_wo_chain:{ *:[f64] } 3299:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_TRIG_PREOP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRIG_PREOP_F64_e64),
     /* 232369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 232386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 232391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232401 */     GIR_RootConstrainSelectedInstOperands,
     /* 232402 */     // GIR_Coverage, 982,
     /* 232402 */     GIR_EraseRootFromParent_Done,
     /* 232403 */   // Label 3753: @232403
     /* 232403 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(232477), // Rule ID 8411 //
     /* 232408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 232413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 232433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232440 */     // (intrinsic_wo_chain:{ *:[f32] } 2211:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LEGACY_F32_e64),
     /* 232443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 232450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 232455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 232460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 232465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 232470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 232475 */     GIR_RootConstrainSelectedInstOperands,
     /* 232476 */     // GIR_Coverage, 8411,
     /* 232476 */     GIR_EraseRootFromParent_Done,
     /* 232477 */   // Label 3754: @232477
     /* 232477 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(232524), // Rule ID 1054 //
     /* 232482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
     /* 232485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f32_fp6),
     /* 232490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 232493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 232496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 232503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232510 */     // (intrinsic_wo_chain:{ *:[v32f32] } 2136:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F32_FP6_e64:{ *:[v32f32] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
     /* 232510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F32_FP6_e64),
     /* 232513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232520 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232522 */     GIR_RootConstrainSelectedInstOperands,
     /* 232523 */     // GIR_Coverage, 1054,
     /* 232523 */     GIR_EraseRootFromParent_Done,
     /* 232524 */   // Label 3755: @232524
     /* 232524 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(232571), // Rule ID 1055 //
     /* 232529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
     /* 232532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f32_bf6),
     /* 232537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 232540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 232543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 232550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232557 */     // (intrinsic_wo_chain:{ *:[v32f32] } 2135:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F32_BF6_e64:{ *:[v32f32] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
     /* 232557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F32_BF6_e64),
     /* 232560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232567 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232569 */     GIR_RootConstrainSelectedInstOperands,
     /* 232570 */     // GIR_Coverage, 1055,
     /* 232570 */     GIR_EraseRootFromParent_Done,
     /* 232571 */   // Label 3756: @232571
     /* 232571 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(232618), // Rule ID 1056 //
     /* 232576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
     /* 232579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f16_fp6),
     /* 232584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 232587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 232590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 232597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232604 */     // (intrinsic_wo_chain:{ *:[v32f16] } 2134:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F16_FP6_e64:{ *:[v32f16] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
     /* 232604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F16_FP6_e64),
     /* 232607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232614 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232616 */     GIR_RootConstrainSelectedInstOperands,
     /* 232617 */     // GIR_Coverage, 1056,
     /* 232617 */     GIR_EraseRootFromParent_Done,
     /* 232618 */   // Label 3757: @232618
     /* 232618 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(232665), // Rule ID 1057 //
     /* 232623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
     /* 232626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f16_bf6),
     /* 232631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 232634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 232637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 232644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232651 */     // (intrinsic_wo_chain:{ *:[v32f16] } 2133:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F16_BF6_e64:{ *:[v32f16] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
     /* 232651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F16_BF6_e64),
     /* 232654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232661 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232663 */     GIR_RootConstrainSelectedInstOperands,
     /* 232664 */     // GIR_Coverage, 1057,
     /* 232664 */     GIR_EraseRootFromParent_Done,
     /* 232665 */   // Label 3758: @232665
     /* 232665 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(232712), // Rule ID 1058 //
     /* 232670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 232673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_fp6_f16),
     /* 232678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 232681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 232684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 232691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232698 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2138:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_FP6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, f32:{ *:[f32] }:$src1)
     /* 232698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_FP6_F16_e64),
     /* 232701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232708 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232710 */     GIR_RootConstrainSelectedInstOperands,
     /* 232711 */     // GIR_Coverage, 1058,
     /* 232711 */     GIR_EraseRootFromParent_Done,
     /* 232712 */   // Label 3759: @232712
     /* 232712 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(232759), // Rule ID 1059 //
     /* 232717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 232720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_bf6_f16),
     /* 232725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 232728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 232731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 232738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232745 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2132:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_BF6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, f32:{ *:[f32] }:$src1)
     /* 232745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_BF6_F16_e64),
     /* 232748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232755 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232757 */     GIR_RootConstrainSelectedInstOperands,
     /* 232758 */     // GIR_Coverage, 1059,
     /* 232758 */     GIR_EraseRootFromParent_Done,
     /* 232759 */   // Label 3760: @232759
     /* 232759 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(232796), // Rule ID 792 //
     /* 232764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /* 232769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232782 */     // (intrinsic_wo_chain:{ *:[i32] } 3072:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_I32_I24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 232782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_I32_I24_e64),
     /* 232785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232787 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 232789 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232794 */     GIR_RootConstrainSelectedInstOperands,
     /* 232795 */     // GIR_Coverage, 792,
     /* 232795 */     GIR_EraseRootFromParent_Done,
     /* 232796 */   // Label 3761: @232796
     /* 232796 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(232830), // Rule ID 794 //
     /* 232801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mulhi_i24),
     /* 232806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232819 */     // (intrinsic_wo_chain:{ *:[i32] } 3074:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_I32_I24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 232819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_I24_e64),
     /* 232822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232824 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 232826 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232828 */     GIR_RootConstrainSelectedInstOperands,
     /* 232829 */     // GIR_Coverage, 794,
     /* 232829 */     GIR_EraseRootFromParent_Done,
     /* 232830 */   // Label 3762: @232830
     /* 232830 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(232867), // Rule ID 796 //
     /* 232835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /* 232840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232853 */     // (intrinsic_wo_chain:{ *:[i32] } 3073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_U32_U24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 232853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_U32_U24_e64),
     /* 232856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232858 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 232860 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232865 */     GIR_RootConstrainSelectedInstOperands,
     /* 232866 */     // GIR_Coverage, 796,
     /* 232866 */     GIR_EraseRootFromParent_Done,
     /* 232867 */   // Label 3763: @232867
     /* 232867 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(232901), // Rule ID 798 //
     /* 232872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mulhi_u24),
     /* 232877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232890 */     // (intrinsic_wo_chain:{ *:[i32] } 3075:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_U32_U24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 232890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_U24_e64),
     /* 232893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232895 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 232897 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232899 */     GIR_RootConstrainSelectedInstOperands,
     /* 232900 */     // GIR_Coverage, 798,
     /* 232900 */     GIR_EraseRootFromParent_Done,
     /* 232901 */   // Label 3764: @232901
     /* 232901 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(232935), // Rule ID 818 //
     /* 232906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mbcnt_lo),
     /* 232911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232924 */     // (intrinsic_wo_chain:{ *:[i32] } 3019:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MBCNT_LO_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 232924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MBCNT_LO_U32_B32_e64),
     /* 232927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232929 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 232931 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232933 */     GIR_RootConstrainSelectedInstOperands,
     /* 232934 */     // GIR_Coverage, 818,
     /* 232934 */     GIR_EraseRootFromParent_Done,
     /* 232935 */   // Label 3765: @232935
     /* 232935 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(232969), // Rule ID 819 //
     /* 232940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mbcnt_hi),
     /* 232945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232958 */     // (intrinsic_wo_chain:{ *:[i32] } 3018:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MBCNT_HI_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 232958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MBCNT_HI_U32_B32_e64),
     /* 232961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232963 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 232965 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232967 */     GIR_RootConstrainSelectedInstOperands,
     /* 232968 */     // GIR_Coverage, 819,
     /* 232968 */     GIR_EraseRootFromParent_Done,
     /* 232969 */   // Label 3766: @232969
     /* 232969 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(233003), // Rule ID 828 //
     /* 232974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_u16),
     /* 232979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 232982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232992 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_CVT_PK_U16_U32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 232992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_U16_U32_e64),
     /* 232995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232997 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 232999 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233001 */     GIR_RootConstrainSelectedInstOperands,
     /* 233002 */     // GIR_Coverage, 828,
     /* 233002 */     GIR_EraseRootFromParent_Done,
     /* 233003 */   // Label 3767: @233003
     /* 233003 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(233037), // Rule ID 830 //
     /* 233008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_i16),
     /* 233013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 233016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233026 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2099:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_CVT_PK_I16_I32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 233026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_I16_I32_e64),
     /* 233029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233031 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 233033 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233035 */     GIR_RootConstrainSelectedInstOperands,
     /* 233036 */     // GIR_Coverage, 830,
     /* 233036 */     GIR_EraseRootFromParent_Done,
     /* 233037 */   // Label 3768: @233037
     /* 233037 */   GIM_Reject,
     /* 233038 */ // Label 3720: @233038
     /* 233038 */ GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(237602),
     /* 233043 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 233046 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(233139), // Rule ID 2566 //
     /* 233051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 233054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_alignbyte),
     /* 233059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 233082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 233089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 233096 */     // (intrinsic_wo_chain:{ *:[i32] } 2077:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ALIGNBYTE_B32_fake16_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, VSrc_b32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, VSrc_b32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[i32] }:$src2)
     /* 233096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBYTE_B32_fake16_e64),
     /* 233099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 233116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 233126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 233131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233137 */     GIR_RootConstrainSelectedInstOperands,
     /* 233138 */     // GIR_Coverage, 2566,
     /* 233138 */     GIR_EraseRootFromParent_Done,
     /* 233139 */   // Label 3770: @233139
     /* 233139 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(233259), // Rule ID 2567 //
     /* 233144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 233147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_alignbyte),
     /* 233152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 233175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 233182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 233189 */     // (intrinsic_wo_chain:{ *:[i32] } 2077:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ALIGNBYTE_B32_t16_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, VSrc_b32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, VSrc_b32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[i16] } VGPR_32:{ *:[i32] }:$src2, lo16:{ *:[i32] }))
     /* 233189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 233192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 233196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233201 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src2
     /* 233208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 233213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBYTE_B32_t16_e64),
     /* 233221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 233238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 233248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233257 */     GIR_RootConstrainSelectedInstOperands,
     /* 233258 */     // GIR_Coverage, 2567,
     /* 233258 */     GIR_EraseRootFromParent_Done,
     /* 233259 */   // Label 3771: @233259
     /* 233259 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(233349), // Rule ID 6920 //
     /* 233264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10),
     /* 233269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 233292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 233299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 233306 */     // (intrinsic_wo_chain:{ *:[f32] } 2993:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_INTERP_P10_F32_inreg:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 233306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F32_inreg),
     /* 233309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 233326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 233336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 233341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 233347 */     GIR_RootConstrainSelectedInstOperands,
     /* 233348 */     // GIR_Coverage, 6920,
     /* 233348 */     GIR_EraseRootFromParent_Done,
     /* 233349 */   // Label 3772: @233349
     /* 233349 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(233439), // Rule ID 6921 //
     /* 233354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2),
     /* 233359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 233382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 233389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 233396 */     // (intrinsic_wo_chain:{ *:[f32] } 2995:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_INTERP_P2_F32_inreg:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 233396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F32_inreg),
     /* 233399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 233416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 233426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 233431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 233437 */     GIR_RootConstrainSelectedInstOperands,
     /* 233438 */     // GIR_Coverage, 6921,
     /* 233438 */     GIR_EraseRootFromParent_Done,
     /* 233439 */   // Label 3773: @233439
     /* 233439 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(233526), // Rule ID 7001 //
     /* 233444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 233447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
     /* 233452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233489 */     // (intrinsic_wo_chain:{ *:[f32] } 2209:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_MAC_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 233489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F32_e64),
     /* 233492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 233518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233524 */     GIR_RootConstrainSelectedInstOperands,
     /* 233525 */     // GIR_Coverage, 7001,
     /* 233525 */     GIR_EraseRootFromParent_Done,
     /* 233526 */   // Label 3774: @233526
     /* 233526 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(233613), // Rule ID 7005 //
     /* 233531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaLegacy32),
     /* 233534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fma_legacy),
     /* 233539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233576 */     // (intrinsic_wo_chain:{ *:[f32] } 2208:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_FMAC_LEGACY_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 233576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_LEGACY_F32_e64),
     /* 233579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 233605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233611 */     GIR_RootConstrainSelectedInstOperands,
     /* 233612 */     // GIR_Coverage, 7005,
     /* 233612 */     GIR_EraseRootFromParent_Done,
     /* 233613 */   // Label 3775: @233613
     /* 233613 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(233700), // Rule ID 7007 //
     /* 233618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 233621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
     /* 233626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 233635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 233638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 233663 */     // (intrinsic_wo_chain:{ *:[f16] } 2209:{ *:[iPTR] }, (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_MAC_F16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 233663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F16_e64),
     /* 233666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 233684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 233692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233698 */     GIR_RootConstrainSelectedInstOperands,
     /* 233699 */     // GIR_Coverage, 7007,
     /* 233699 */     GIR_EraseRootFromParent_Done,
     /* 233700 */   // Label 3776: @233700
     /* 233700 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(233763), // Rule ID 2750 //
     /* 233705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
     /* 233708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_fp8_bf8),
     /* 233713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 233736 */     // (intrinsic_wo_chain:{ *:[f32] } 2166:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_FP8_BF8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
     /* 233736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_FP8_BF8),
     /* 233739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 233743 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 233750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 233755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233761 */     GIR_RootConstrainSelectedInstOperands,
     /* 233762 */     // GIR_Coverage, 2750,
     /* 233762 */     GIR_EraseRootFromParent_Done,
     /* 233763 */   // Label 3777: @233763
     /* 233763 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(233826), // Rule ID 2751 //
     /* 233768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
     /* 233771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_bf8_fp8),
     /* 233776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 233799 */     // (intrinsic_wo_chain:{ *:[f32] } 2165:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_BF8_FP8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
     /* 233799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_BF8_FP8),
     /* 233802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233804 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 233806 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 233813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 233818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233824 */     GIR_RootConstrainSelectedInstOperands,
     /* 233825 */     // GIR_Coverage, 2751,
     /* 233825 */     GIR_EraseRootFromParent_Done,
     /* 233826 */   // Label 3778: @233826
     /* 233826 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(233889), // Rule ID 2752 //
     /* 233831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
     /* 233834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_fp8_fp8),
     /* 233839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 233862 */     // (intrinsic_wo_chain:{ *:[f32] } 2167:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_FP8_FP8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
     /* 233862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_FP8_FP8),
     /* 233865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233867 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 233869 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 233876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 233881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233887 */     GIR_RootConstrainSelectedInstOperands,
     /* 233888 */     // GIR_Coverage, 2752,
     /* 233888 */     GIR_EraseRootFromParent_Done,
     /* 233889 */   // Label 3779: @233889
     /* 233889 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(233952), // Rule ID 2753 //
     /* 233894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
     /* 233897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_bf8_bf8),
     /* 233902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 233908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 233911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 233925 */     // (intrinsic_wo_chain:{ *:[f32] } 2164:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_BF8_BF8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
     /* 233925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_BF8_BF8),
     /* 233928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233930 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 233932 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 233939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 233944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233950 */     GIR_RootConstrainSelectedInstOperands,
     /* 233951 */     // GIR_Coverage, 2753,
     /* 233951 */     GIR_EraseRootFromParent_Done,
     /* 233952 */   // Label 3780: @233952
     /* 233952 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(234017), // Rule ID 6913 //
     /* 233957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 233960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_param_load),
     /* 233965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 233968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 233971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233975 */     // MIs[0] attrchan
     /* 233975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 233978 */     // MIs[0] attr
     /* 233978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 233981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 233985 */     // (intrinsic_wo_chain:{ *:[f32] } 3011:{ *:[iPTR] }, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (LDS_PARAM_LOAD:{ *:[f32] } (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, 0:{ *:[i32] })
     /* 233985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 233989 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233995 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // M0
     /* 233999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::LDS_PARAM_LOAD),
     /* 234002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234004 */     GIR_RootToRootCopy, /*OpIdx*/3, // attr
     /* 234006 */     GIR_RootToRootCopy, /*OpIdx*/2, // attrchan
     /* 234008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 234015 */     GIR_RootConstrainSelectedInstOperands,
     /* 234016 */     // GIR_Coverage, 6913,
     /* 234016 */     GIR_EraseRootFromParent_Done,
     /* 234017 */   // Label 3781: @234017
     /* 234017 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(234085), // Rule ID 6915 //
     /* 234022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 234025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_param_load),
     /* 234030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234040 */     // MIs[0] attrchan
     /* 234040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 234043 */     // MIs[0] attr
     /* 234043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 234046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 234050 */     // (intrinsic_wo_chain:{ *:[f32] } 3011:{ *:[iPTR] }, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (DS_PARAM_LOAD:{ *:[f32] } (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, 0:{ *:[i32] }, 1:{ *:[i32] })
     /* 234050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 234054 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234060 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // M0
     /* 234064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PARAM_LOAD),
     /* 234067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234069 */     GIR_RootToRootCopy, /*OpIdx*/3, // attr
     /* 234071 */     GIR_RootToRootCopy, /*OpIdx*/2, // attrchan
     /* 234073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 234083 */     GIR_RootConstrainSelectedInstOperands,
     /* 234084 */     // GIR_Coverage, 6915,
     /* 234084 */     GIR_EraseRootFromParent_Done,
     /* 234085 */   // Label 3782: @234085
     /* 234085 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(234137), // Rule ID 2624 //
     /* 234090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f32_fp8),
     /* 234095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234108 */     // MIs[0] index
     /* 234108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234111 */     // (intrinsic_wo_chain:{ *:[f32] } 2110:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_F32_FP8_e64:{ *:[f32] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
     /* 234111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F32_FP8_e64),
     /* 234114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234116 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
     /* 234122 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234124 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
     /* 234130 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234135 */     GIR_RootConstrainSelectedInstOperands,
     /* 234136 */     // GIR_Coverage, 2624,
     /* 234136 */     GIR_EraseRootFromParent_Done,
     /* 234137 */   // Label 3783: @234137
     /* 234137 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(234189), // Rule ID 2625 //
     /* 234142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f32_bf8),
     /* 234147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234160 */     // MIs[0] index
     /* 234160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234163 */     // (intrinsic_wo_chain:{ *:[f32] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_F32_BF8_e64:{ *:[f32] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
     /* 234163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F32_BF8_e64),
     /* 234166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234168 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
     /* 234174 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
     /* 234182 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234187 */     GIR_RootConstrainSelectedInstOperands,
     /* 234188 */     // GIR_Coverage, 2625,
     /* 234188 */     GIR_EraseRootFromParent_Done,
     /* 234189 */   // Label 3784: @234189
     /* 234189 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(234241), // Rule ID 2626 //
     /* 234194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f16_fp4),
     /* 234199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 234202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234212 */     // MIs[0] index
     /* 234212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234215 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_F16_FP4_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
     /* 234215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F16_FP4_e64),
     /* 234218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234220 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
     /* 234226 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234228 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
     /* 234234 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234239 */     GIR_RootConstrainSelectedInstOperands,
     /* 234240 */     // GIR_Coverage, 2626,
     /* 234240 */     GIR_EraseRootFromParent_Done,
     /* 234241 */   // Label 3785: @234241
     /* 234241 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(234290), // Rule ID 2633 //
     /* 234246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f32_fp8),
     /* 234251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 234264 */     // MIs[0] word_sel
     /* 234264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234267 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2122:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F32_FP8_e64:{ *:[v2f32] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
     /* 234267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F32_FP8_e64),
     /* 234270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234272 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
     /* 234278 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234283 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234288 */     GIR_RootConstrainSelectedInstOperands,
     /* 234289 */     // GIR_Coverage, 2633,
     /* 234289 */     GIR_EraseRootFromParent_Done,
     /* 234290 */   // Label 3786: @234290
     /* 234290 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(234339), // Rule ID 2634 //
     /* 234295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f32_bf8),
     /* 234300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 234313 */     // MIs[0] word_sel
     /* 234313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234316 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F32_BF8_e64:{ *:[v2f32] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
     /* 234316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F32_BF8_e64),
     /* 234319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234321 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
     /* 234327 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234332 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234337 */     GIR_RootConstrainSelectedInstOperands,
     /* 234338 */     // GIR_Coverage, 2634,
     /* 234338 */     GIR_EraseRootFromParent_Done,
     /* 234339 */   // Label 3787: @234339
     /* 234339 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(234388), // Rule ID 2635 //
     /* 234344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f16_bf8),
     /* 234349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 234352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234362 */     // MIs[0] word_sel
     /* 234362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234365 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2117:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F16_BF8_e64:{ *:[v2f16] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
     /* 234365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F16_BF8_e64),
     /* 234368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234370 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
     /* 234376 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234381 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234386 */     GIR_RootConstrainSelectedInstOperands,
     /* 234387 */     // GIR_Coverage, 2635,
     /* 234387 */     GIR_EraseRootFromParent_Done,
     /* 234388 */   // Label 3788: @234388
     /* 234388 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(234437), // Rule ID 2636 //
     /* 234393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f16_fp8),
     /* 234398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 234401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234411 */     // MIs[0] word_sel
     /* 234411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234414 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2119:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F16_FP8_e64:{ *:[v2f16] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
     /* 234414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F16_FP8_e64),
     /* 234417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
     /* 234425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234430 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234435 */     GIR_RootConstrainSelectedInstOperands,
     /* 234436 */     // GIR_Coverage, 2636,
     /* 234436 */     GIR_EraseRootFromParent_Done,
     /* 234437 */   // Label 3789: @234437
     /* 234437 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(234489), // Rule ID 2639 //
     /* 234442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f32_fp4),
     /* 234447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 234460 */     // MIs[0] index
     /* 234460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 234463 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_F32_FP4_e64:{ *:[v2f32] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
     /* 234463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F32_FP4_e64),
     /* 234466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
     /* 234474 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234476 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
     /* 234482 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234487 */     GIR_RootConstrainSelectedInstOperands,
     /* 234488 */     // GIR_Coverage, 2639,
     /* 234488 */     GIR_EraseRootFromParent_Done,
     /* 234489 */   // Label 3790: @234489
     /* 234489 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(234531), // Rule ID 2703 //
     /* 234494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sad_u8),
     /* 234499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234515 */     // (intrinsic_wo_chain:{ *:[i32] } 3193:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /* 234515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U8_e64),
     /* 234518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234520 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234522 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234524 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 234526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234529 */     GIR_RootConstrainSelectedInstOperands,
     /* 234530 */     // GIR_Coverage, 2703,
     /* 234530 */     GIR_EraseRootFromParent_Done,
     /* 234531 */   // Label 3791: @234531
     /* 234531 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(234573), // Rule ID 2704 //
     /* 234536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sad_hi_u8),
     /* 234541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234557 */     // (intrinsic_wo_chain:{ *:[i32] } 3191:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_SAD_HI_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /* 234557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_HI_U8_e64),
     /* 234560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234562 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234564 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234566 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 234568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234571 */     GIR_RootConstrainSelectedInstOperands,
     /* 234572 */     // GIR_Coverage, 2704,
     /* 234572 */     GIR_EraseRootFromParent_Done,
     /* 234573 */   // Label 3792: @234573
     /* 234573 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(234615), // Rule ID 2705 //
     /* 234578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sad_u16),
     /* 234583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234599 */     // (intrinsic_wo_chain:{ *:[i32] } 3192:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U16_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /* 234599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U16_e64),
     /* 234602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234604 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234606 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234608 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 234610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234613 */     GIR_RootConstrainSelectedInstOperands,
     /* 234614 */     // GIR_Coverage, 2705,
     /* 234614 */     GIR_EraseRootFromParent_Done,
     /* 234615 */   // Label 3793: @234615
     /* 234615 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(234657), // Rule ID 2706 //
     /* 234620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_msad_u8),
     /* 234625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234641 */     // (intrinsic_wo_chain:{ *:[i32] } 3071:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_MSAD_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /* 234641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MSAD_U8_e64),
     /* 234644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234646 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234648 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234650 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 234652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234655 */     GIR_RootConstrainSelectedInstOperands,
     /* 234656 */     // GIR_Coverage, 2706,
     /* 234656 */     GIR_EraseRootFromParent_Done,
     /* 234657 */   // Label 3794: @234657
     /* 234657 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(234699), // Rule ID 2707 //
     /* 234662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mqsad_pk_u16_u8),
     /* 234667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 234670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 234673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 234679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 234683 */     // (intrinsic_wo_chain:{ *:[i64] } 3069:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2)  =>  (V_MQSAD_PK_U16_U8_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /* 234683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MQSAD_PK_U16_U8_e64),
     /* 234686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234688 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234690 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234692 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 234694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234697 */     GIR_RootConstrainSelectedInstOperands,
     /* 234698 */     // GIR_Coverage, 2707,
     /* 234698 */     GIR_EraseRootFromParent_Done,
     /* 234699 */   // Label 3795: @234699
     /* 234699 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(234741), // Rule ID 2708 //
     /* 234704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_qsad_pk_u16_u8),
     /* 234709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 234712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 234715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 234721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 234725 */     // (intrinsic_wo_chain:{ *:[i64] } 3087:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2)  =>  (V_QSAD_PK_U16_U8_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /* 234725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_QSAD_PK_U16_U8_e64),
     /* 234728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234730 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234732 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234734 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 234736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234739 */     GIR_RootConstrainSelectedInstOperands,
     /* 234740 */     // GIR_Coverage, 2708,
     /* 234740 */     GIR_EraseRootFromParent_Done,
     /* 234741 */   // Label 3796: @234741
     /* 234741 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(234783), // Rule ID 2709 //
     /* 234746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mqsad_u32_u8),
     /* 234751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 234757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 234767 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3070:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (V_MQSAD_U32_U8_e64:{ *:[v4i32] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, 0:{ *:[i1] })
     /* 234767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MQSAD_U32_U8_e64),
     /* 234770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234772 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 234774 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234776 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 234778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234781 */     GIR_RootConstrainSelectedInstOperands,
     /* 234782 */     // GIR_Coverage, 2709,
     /* 234782 */     GIR_EraseRootFromParent_Done,
     /* 234783 */   // Label 3797: @234783
     /* 234783 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(234880), // Rule ID 922 //
     /* 234788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 234791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
     /* 234796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 234819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 234826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 234833 */     // (intrinsic_wo_chain:{ *:[f32] } 2209:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 234833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F32_e64),
     /* 234836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 234853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 234858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 234863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 234868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 234873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 234878 */     GIR_RootConstrainSelectedInstOperands,
     /* 234879 */     // GIR_Coverage, 922,
     /* 234879 */     GIR_EraseRootFromParent_Done,
     /* 234880 */   // Label 3798: @234880
     /* 234880 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(234977), // Rule ID 924 //
     /* 234885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaLegacy32),
     /* 234888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fma_legacy),
     /* 234893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 234916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 234923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 234930 */     // (intrinsic_wo_chain:{ *:[f32] } 2208:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 234930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_LEGACY_F32_e64),
     /* 234933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 234950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 234955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 234960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 234965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 234970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 234975 */     GIR_RootConstrainSelectedInstOperands,
     /* 234976 */     // GIR_Coverage, 924,
     /* 234976 */     GIR_EraseRootFromParent_Done,
     /* 234977 */   // Label 3799: @234977
     /* 234977 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(235071), // Rule ID 951 //
     /* 234982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubeid),
     /* 234987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235024 */     // (intrinsic_wo_chain:{ *:[f32] } 2089:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBEID_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBEID_F32_e64),
     /* 235027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235069 */     GIR_RootConstrainSelectedInstOperands,
     /* 235070 */     // GIR_Coverage, 951,
     /* 235070 */     GIR_EraseRootFromParent_Done,
     /* 235071 */   // Label 3800: @235071
     /* 235071 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(235165), // Rule ID 952 //
     /* 235076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubesc),
     /* 235081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235118 */     // (intrinsic_wo_chain:{ *:[f32] } 2091:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBESC_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBESC_F32_e64),
     /* 235121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235163 */     GIR_RootConstrainSelectedInstOperands,
     /* 235164 */     // GIR_Coverage, 952,
     /* 235164 */     GIR_EraseRootFromParent_Done,
     /* 235165 */   // Label 3801: @235165
     /* 235165 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(235259), // Rule ID 953 //
     /* 235170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubetc),
     /* 235175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235212 */     // (intrinsic_wo_chain:{ *:[f32] } 2092:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBETC_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBETC_F32_e64),
     /* 235215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235257 */     GIR_RootConstrainSelectedInstOperands,
     /* 235258 */     // GIR_Coverage, 953,
     /* 235258 */     GIR_EraseRootFromParent_Done,
     /* 235259 */   // Label 3802: @235259
     /* 235259 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(235353), // Rule ID 954 //
     /* 235264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubema),
     /* 235269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235306 */     // (intrinsic_wo_chain:{ *:[f32] } 2090:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBEMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBEMA_F32_e64),
     /* 235309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235351 */     GIR_RootConstrainSelectedInstOperands,
     /* 235352 */     // GIR_Coverage, 954,
     /* 235352 */     GIR_EraseRootFromParent_Done,
     /* 235353 */   // Label 3803: @235353
     /* 235353 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(235447), // Rule ID 971 //
     /* 235358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
     /* 235363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235400 */     // (intrinsic_wo_chain:{ *:[f32] } 2210:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 235403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235445 */     GIR_RootConstrainSelectedInstOperands,
     /* 235446 */     // GIR_Coverage, 971,
     /* 235446 */     GIR_EraseRootFromParent_Done,
     /* 235447 */   // Label 3804: @235447
     /* 235447 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(235536), // Rule ID 975 //
     /* 235452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_u8_f32),
     /* 235457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235494 */     // (intrinsic_wo_chain:{ *:[i32] } 2101:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CVT_PK_U8_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 235494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_U8_F32_e64),
     /* 235497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235534 */     GIR_RootConstrainSelectedInstOperands,
     /* 235535 */     // GIR_Coverage, 975,
     /* 235535 */     GIR_EraseRootFromParent_Done,
     /* 235536 */   // Label 3805: @235536
     /* 235536 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(235630), // Rule ID 976 //
     /* 235541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 235546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235583 */     // (intrinsic_wo_chain:{ *:[f32] } 2161:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F32_e64),
     /* 235586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235628 */     GIR_RootConstrainSelectedInstOperands,
     /* 235629 */     // GIR_Coverage, 976,
     /* 235629 */     GIR_EraseRootFromParent_Done,
     /* 235630 */   // Label 3806: @235630
     /* 235630 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(235724), // Rule ID 978 //
     /* 235635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 235640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 235643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 235646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 235649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 235652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 235656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235677 */     // (intrinsic_wo_chain:{ *:[f64] } 2161:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F64_e64),
     /* 235680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235722 */     GIR_RootConstrainSelectedInstOperands,
     /* 235723 */     // GIR_Coverage, 978,
     /* 235723 */     GIR_EraseRootFromParent_Done,
     /* 235724 */   // Label 3807: @235724
     /* 235724 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(235821), // Rule ID 997 //
     /* 235729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 235732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 235737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 235740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 235743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 235746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 235749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235774 */     // (intrinsic_wo_chain:{ *:[f16] } 2161:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_e64),
     /* 235777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235819 */     GIR_RootConstrainSelectedInstOperands,
     /* 235820 */     // GIR_Coverage, 997,
     /* 235820 */     GIR_EraseRootFromParent_Done,
     /* 235821 */   // Label 3808: @235821
     /* 235821 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(235918), // Rule ID 1014 //
     /* 235826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 235829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
     /* 235834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 235837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 235840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 235843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 235846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235871 */     // (intrinsic_wo_chain:{ *:[f16] } 2209:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F16_e64),
     /* 235874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 235881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 235886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 235891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 235896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 235906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 235911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 235916 */     GIR_RootConstrainSelectedInstOperands,
     /* 235917 */     // GIR_Coverage, 1014,
     /* 235917 */     GIR_EraseRootFromParent_Done,
     /* 235918 */   // Label 3809: @235918
     /* 235918 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(236015), // Rule ID 8446 //
     /* 235923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaLegacy32),
     /* 235926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fma_legacy),
     /* 235931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 235943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 235961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 235968 */     // (intrinsic_wo_chain:{ *:[f32] } 2208:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 235968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_LEGACY_F32_e64),
     /* 235971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 235978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 235983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 235988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 235993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 235998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 236008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 236013 */     GIR_RootConstrainSelectedInstOperands,
     /* 236014 */     // GIR_Coverage, 8446,
     /* 236014 */     GIR_EraseRootFromParent_Done,
     /* 236015 */   // Label 3810: @236015
     /* 236015 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(236111), // Rule ID 1001 //
     /* 236020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 236023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 236028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236065 */     // (intrinsic_wo_chain:{ *:[f16] } 2161:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_gfx9_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_gfx9_e64),
     /* 236068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236109 */     GIR_RootConstrainSelectedInstOperands,
     /* 236110 */     // GIR_Coverage, 1001,
     /* 236110 */     GIR_EraseRootFromParent_Done,
     /* 236111 */   // Label 3811: @236111
     /* 236111 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(236207), // Rule ID 1003 //
     /* 236116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 236119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 236124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 236140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236161 */     // (intrinsic_wo_chain:{ *:[f16] } 2161:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_gfx9_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_gfx9_t16_e64),
     /* 236164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236205 */     GIR_RootConstrainSelectedInstOperands,
     /* 236206 */     // GIR_Coverage, 1003,
     /* 236206 */     GIR_EraseRootFromParent_Done,
     /* 236207 */   // Label 3812: @236207
     /* 236207 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(236303), // Rule ID 1005 //
     /* 236212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 236215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 236220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236257 */     // (intrinsic_wo_chain:{ *:[f16] } 2161:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_gfx9_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_gfx9_fake16_e64),
     /* 236260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236301 */     GIR_RootConstrainSelectedInstOperands,
     /* 236302 */     // GIR_Coverage, 1005,
     /* 236302 */     GIR_EraseRootFromParent_Done,
     /* 236303 */   // Label 3813: @236303
     /* 236303 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(236399), // Rule ID 1018 //
     /* 236308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 236311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
     /* 236316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236353 */     // (intrinsic_wo_chain:{ *:[f16] } 2210:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 236356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236397 */     GIR_RootConstrainSelectedInstOperands,
     /* 236398 */     // GIR_Coverage, 1018,
     /* 236398 */     GIR_EraseRootFromParent_Done,
     /* 236399 */   // Label 3814: @236399
     /* 236399 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(236495), // Rule ID 1020 //
     /* 236404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 236407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
     /* 236412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 236428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236449 */     // (intrinsic_wo_chain:{ *:[f16] } 2210:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 236452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236493 */     GIR_RootConstrainSelectedInstOperands,
     /* 236494 */     // GIR_Coverage, 1020,
     /* 236494 */     GIR_EraseRootFromParent_Done,
     /* 236495 */   // Label 3815: @236495
     /* 236495 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(236591), // Rule ID 1022 //
     /* 236500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 236503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
     /* 236508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 236514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 236517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236545 */     // (intrinsic_wo_chain:{ *:[f16] } 2210:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 236548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236589 */     GIR_RootConstrainSelectedInstOperands,
     /* 236590 */     // GIR_Coverage, 1022,
     /* 236590 */     GIR_EraseRootFromParent_Done,
     /* 236591 */   // Label 3816: @236591
     /* 236591 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(236681), // Rule ID 1072 //
     /* 236596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_NotHasTrue16BitInsts),
     /* 236599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f16_f16),
     /* 236604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 236610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 236613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236641 */     // (intrinsic_wo_chain:{ *:[f16] } 2203:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_F16_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F16_F16_e64),
     /* 236644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236679 */     GIR_RootConstrainSelectedInstOperands,
     /* 236680 */     // GIR_Coverage, 1072,
     /* 236680 */     GIR_EraseRootFromParent_Done,
     /* 236681 */   // Label 3817: @236681
     /* 236681 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(236771), // Rule ID 1073 //
     /* 236686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_UseRealTrue16Insts),
     /* 236689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f16_f16),
     /* 236694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 236700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 236703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 236710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236731 */     // (intrinsic_wo_chain:{ *:[f16] } 2203:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_F16_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F16_F16_t16_e64),
     /* 236734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236769 */     GIR_RootConstrainSelectedInstOperands,
     /* 236770 */     // GIR_Coverage, 1073,
     /* 236770 */     GIR_EraseRootFromParent_Done,
     /* 236771 */   // Label 3818: @236771
     /* 236771 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(236861), // Rule ID 1074 //
     /* 236776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_UseFakeTrue16Insts),
     /* 236779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f16_f16),
     /* 236784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 236790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 236793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 236796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236821 */     // (intrinsic_wo_chain:{ *:[f16] } 2203:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_F16_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 236821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F16_F16_fake16_e64),
     /* 236824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236859 */     GIR_RootConstrainSelectedInstOperands,
     /* 236860 */     // GIR_Coverage, 1074,
     /* 236860 */     GIR_EraseRootFromParent_Done,
     /* 236861 */   // Label 3819: @236861
     /* 236861 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(236951), // Rule ID 1085 //
     /* 236866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /* 236869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ashr_pk_i8_i32),
     /* 236874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 236880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 236886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236911 */     // (intrinsic_wo_chain:{ *:[i16] } 2078:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ASHR_PK_I8_I32_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2)
     /* 236911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_I8_I32_e64),
     /* 236914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 236941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 236946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236949 */     GIR_RootConstrainSelectedInstOperands,
     /* 236950 */     // GIR_Coverage, 1085,
     /* 236950 */     GIR_EraseRootFromParent_Done,
     /* 236951 */   // Label 3820: @236951
     /* 236951 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(237041), // Rule ID 1086 //
     /* 236956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /* 236959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ashr_pk_u8_i32),
     /* 236964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 236967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 236970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 236976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 236994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237001 */     // (intrinsic_wo_chain:{ *:[i16] } 2079:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ASHR_PK_U8_I32_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2)
     /* 237001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_U8_I32_e64),
     /* 237004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 237011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 237021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 237026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 237031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 237036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237039 */     GIR_RootConstrainSelectedInstOperands,
     /* 237040 */     // GIR_Coverage, 1086,
     /* 237040 */     GIR_EraseRootFromParent_Done,
     /* 237041 */   // Label 3821: @237041
     /* 237041 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(237090), // Rule ID 927 //
     /* 237046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lerp),
     /* 237051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237074 */     // (intrinsic_wo_chain:{ *:[i32] } 3012:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_LERP_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 237074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LERP_U8_e64),
     /* 237077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237084 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237086 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237088 */     GIR_RootConstrainSelectedInstOperands,
     /* 237089 */     // GIR_Coverage, 927,
     /* 237089 */     GIR_EraseRootFromParent_Done,
     /* 237090 */   // Label 3822: @237090
     /* 237090 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(237139), // Rule ID 955 //
     /* 237095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ubfe),
     /* 237100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237123 */     // (intrinsic_wo_chain:{ *:[i32] } 3300:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_BFE_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 237123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /* 237126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237133 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237135 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237137 */     GIR_RootConstrainSelectedInstOperands,
     /* 237138 */     // GIR_Coverage, 955,
     /* 237138 */     GIR_EraseRootFromParent_Done,
     /* 237139 */   // Label 3823: @237139
     /* 237139 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(237188), // Rule ID 957 //
     /* 237144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sbfe),
     /* 237149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237172 */     // (intrinsic_wo_chain:{ *:[i32] } 3194:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_BFE_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 237172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
     /* 237175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237182 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237184 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237186 */     GIR_RootConstrainSelectedInstOperands,
     /* 237187 */     // GIR_Coverage, 957,
     /* 237187 */     GIR_EraseRootFromParent_Done,
     /* 237188 */   // Label 3824: @237188
     /* 237188 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(237237), // Rule ID 962 //
     /* 237193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_alignbyte),
     /* 237198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237221 */     // (intrinsic_wo_chain:{ *:[i32] } 2077:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBYTE_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 237221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBYTE_B32_e64),
     /* 237224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237231 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237233 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237235 */     GIR_RootConstrainSelectedInstOperands,
     /* 237236 */     // GIR_Coverage, 962,
     /* 237236 */     GIR_EraseRootFromParent_Done,
     /* 237237 */   // Label 3825: @237237
     /* 237237 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(237289), // Rule ID 995 //
     /* 237242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 237245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_perm),
     /* 237250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237273 */     // (intrinsic_wo_chain:{ *:[i32] } 3076:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_PERM_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 237273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 237276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237283 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237285 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237287 */     GIR_RootConstrainSelectedInstOperands,
     /* 237288 */     // GIR_Coverage, 995,
     /* 237288 */     GIR_EraseRootFromParent_Done,
     /* 237289 */   // Label 3826: @237289
     /* 237289 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(237341), // Rule ID 1060 //
     /* 237294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 237297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_bf6_f16),
     /* 237302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 237305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 237308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 237318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237325 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2149:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_BF6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 237325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_BF6_F16_e64),
     /* 237328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237335 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237337 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237339 */     GIR_RootConstrainSelectedInstOperands,
     /* 237340 */     // GIR_Coverage, 1060,
     /* 237340 */     GIR_EraseRootFromParent_Done,
     /* 237341 */   // Label 3827: @237341
     /* 237341 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(237393), // Rule ID 1061 //
     /* 237346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 237349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_bf6_f32),
     /* 237354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 237357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s32,
     /* 237360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 237370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237377 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2150:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f32] } v32f32:{ *:[v32f32] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_BF6_F32_e64:{ *:[v6i32] } v32f32:{ *:[v32f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 237377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_BF6_F32_e64),
     /* 237380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237387 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237389 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237391 */     GIR_RootConstrainSelectedInstOperands,
     /* 237392 */     // GIR_Coverage, 1061,
     /* 237392 */     GIR_EraseRootFromParent_Done,
     /* 237393 */   // Label 3828: @237393
     /* 237393 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(237445), // Rule ID 1062 //
     /* 237398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 237401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_fp6_f16),
     /* 237406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 237409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 237412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 237422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237429 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2152:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_FP6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 237429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_FP6_F16_e64),
     /* 237432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237439 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237441 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237443 */     GIR_RootConstrainSelectedInstOperands,
     /* 237444 */     // GIR_Coverage, 1062,
     /* 237444 */     GIR_EraseRootFromParent_Done,
     /* 237445 */   // Label 3829: @237445
     /* 237445 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(237497), // Rule ID 1063 //
     /* 237450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 237453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_fp6_f32),
     /* 237458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 237461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s32,
     /* 237464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 237474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237481 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2153:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f32] } v32f32:{ *:[v32f32] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_FP6_F32_e64:{ *:[v6i32] } v32f32:{ *:[v32f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 237481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_FP6_F32_e64),
     /* 237484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237491 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237493 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237495 */     GIR_RootConstrainSelectedInstOperands,
     /* 237496 */     // GIR_Coverage, 1063,
     /* 237496 */     GIR_EraseRootFromParent_Done,
     /* 237497 */   // Label 3830: @237497
     /* 237497 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(237549), // Rule ID 1064 //
     /* 237502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 237505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_2xpk16_fp6_f32),
     /* 237510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 237513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 237516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 237519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 237526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237533 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2106:{ *:[iPTR] }, (VOP3Mods0:{ *:[v16f32] } v16f32:{ *:[v16f32] }:$src0), v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_2XPK16_FP6_F32_e64:{ *:[v6i32] } v16f32:{ *:[v16f32] }:$src0, v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 237533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_2XPK16_FP6_F32_e64),
     /* 237536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237543 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237545 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237547 */     GIR_RootConstrainSelectedInstOperands,
     /* 237548 */     // GIR_Coverage, 1064,
     /* 237548 */     GIR_EraseRootFromParent_Done,
     /* 237549 */   // Label 3831: @237549
     /* 237549 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(237601), // Rule ID 1065 //
     /* 237554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 237557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_2xpk16_bf6_f32),
     /* 237562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 237565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 237568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 237571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 237578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 237585 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2105:{ *:[iPTR] }, (VOP3Mods0:{ *:[v16f32] } v16f32:{ *:[v16f32] }:$src0), v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_2XPK16_BF6_F32_e64:{ *:[v6i32] } v16f32:{ *:[v16f32] }:$src0, v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 237585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_2XPK16_BF6_F32_e64),
     /* 237588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237595 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237597 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237599 */     GIR_RootConstrainSelectedInstOperands,
     /* 237600 */     // GIR_Coverage, 1065,
     /* 237600 */     GIR_EraseRootFromParent_Done,
     /* 237601 */   // Label 3832: @237601
     /* 237601 */   GIM_Reject,
     /* 237602 */ // Label 3769: @237602
     /* 237602 */ GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(242587),
     /* 237607 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 237610 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(237663), // Rule ID 2515 //
     /* 237615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot5Insts),
     /* 237618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2),
     /* 237623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 237629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 237632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237639 */     // MIs[0] Operand 5
     /* 237639 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 237650 */     // (intrinsic_wo_chain:{ *:[f32] } 2201:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src0, v2f16:{ *:[v2f16] }:$src1, f32:{ *:[f32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT2C_F32_F16_e32:{ *:[f32] } ?:{ *:[v2f16] }:$src0, ?:{ *:[v2f16] }:$src1, ?:{ *:[f32] }:$src2)
     /* 237650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2C_F32_F16_e32),
     /* 237653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237655 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 237657 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237659 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237661 */     GIR_RootConstrainSelectedInstOperands,
     /* 237662 */     // GIR_Coverage, 2515,
     /* 237662 */     GIR_EraseRootFromParent_Done,
     /* 237663 */   // Label 3834: @237663
     /* 237663 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(237716), // Rule ID 2517 //
     /* 237668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot6Insts),
     /* 237671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot4),
     /* 237676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237692 */     // MIs[0] Operand 5
     /* 237692 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 237703 */     // (intrinsic_wo_chain:{ *:[i32] } 3198:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT4C_I32_I8_e32:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2)
     /* 237703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4C_I32_I8_e32),
     /* 237706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237708 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 237710 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237712 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237714 */     GIR_RootConstrainSelectedInstOperands,
     /* 237715 */     // GIR_Coverage, 2517,
     /* 237715 */     GIR_EraseRootFromParent_Done,
     /* 237716 */   // Label 3835: @237716
     /* 237716 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(237769), // Rule ID 2518 //
     /* 237721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot4Insts),
     /* 237724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot2),
     /* 237729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 237735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 237738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237745 */     // MIs[0] Operand 5
     /* 237745 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 237756 */     // (intrinsic_wo_chain:{ *:[i32] } 3197:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT2C_I32_I16_e32:{ *:[i32] } ?:{ *:[v2i16] }:$src0, ?:{ *:[v2i16] }:$src1, ?:{ *:[i32] }:$src2)
     /* 237756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2C_I32_I16_e32),
     /* 237759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237761 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 237763 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237765 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237767 */     GIR_RootConstrainSelectedInstOperands,
     /* 237768 */     // GIR_Coverage, 2518,
     /* 237768 */     GIR_EraseRootFromParent_Done,
     /* 237769 */   // Label 3836: @237769
     /* 237769 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(237822), // Rule ID 2519 //
     /* 237774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot3Insts),
     /* 237777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot8),
     /* 237782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237798 */     // MIs[0] Operand 5
     /* 237798 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 237809 */     // (intrinsic_wo_chain:{ *:[i32] } 3199:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT8C_I32_I4_e32:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2)
     /* 237809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8C_I32_I4_e32),
     /* 237812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237814 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 237816 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237818 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 237820 */     GIR_RootConstrainSelectedInstOperands,
     /* 237821 */     // GIR_Coverage, 2519,
     /* 237821 */     GIR_EraseRootFromParent_Done,
     /* 237822 */   // Label 3837: @237822
     /* 237822 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(237929), // Rule ID 6916 //
     /* 237827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 237830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
     /* 237835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237851 */     // MIs[0] Operand 5
     /* 237851 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 237862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 237869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 237876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 237883 */     // (intrinsic_wo_chain:{ *:[f32] } 2994:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 237883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_fake16),
     /* 237886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 237893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 237903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 237908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 237913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 237918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 237927 */     GIR_RootConstrainSelectedInstOperands,
     /* 237928 */     // GIR_Coverage, 6916,
     /* 237928 */     GIR_EraseRootFromParent_Done,
     /* 237929 */   // Label 3838: @237929
     /* 237929 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(238036), // Rule ID 6917 //
     /* 237934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 237937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
     /* 237942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237958 */     // MIs[0] Operand 5
     /* 237958 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 237969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 237976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 237983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 237990 */     // (intrinsic_wo_chain:{ *:[f32] } 2994:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 237990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_fake16),
     /* 237993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 238005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 238025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 238034 */     GIR_RootConstrainSelectedInstOperands,
     /* 238035 */     // GIR_Coverage, 6917,
     /* 238035 */     GIR_EraseRootFromParent_Done,
     /* 238036 */   // Label 3839: @238036
     /* 238036 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(238197), // Rule ID 6918 //
     /* 238041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 238044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
     /* 238049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238065 */     // MIs[0] Operand 5
     /* 238065 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 238076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238097 */     // (intrinsic_wo_chain:{ *:[f32] } 2994:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, lo16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 238097 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 238100 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238104 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238109 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src2
     /* 238116 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238121 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 238129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238138 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
     /* 238145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_t16),
     /* 238158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 238186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 238195 */     GIR_RootConstrainSelectedInstOperands,
     /* 238196 */     // GIR_Coverage, 6918,
     /* 238196 */     GIR_EraseRootFromParent_Done,
     /* 238197 */   // Label 3840: @238197
     /* 238197 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(238358), // Rule ID 6919 //
     /* 238202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 238205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
     /* 238210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238226 */     // MIs[0] Operand 5
     /* 238226 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 238237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238258 */     // (intrinsic_wo_chain:{ *:[f32] } 2994:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, hi16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 238258 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 238261 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238265 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238270 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src2
     /* 238277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238282 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 238290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238299 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
     /* 238306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_t16),
     /* 238319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 238347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 238356 */     GIR_RootConstrainSelectedInstOperands,
     /* 238357 */     // GIR_Coverage, 6919,
     /* 238357 */     GIR_EraseRootFromParent_Done,
     /* 238358 */   // Label 3841: @238358
     /* 238358 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(238492), // Rule ID 6922 //
     /* 238363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 238366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
     /* 238371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 238374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238387 */     // MIs[0] Operand 5
     /* 238387 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 238398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238419 */     // (intrinsic_wo_chain:{ *:[f16] } 2996:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 238419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 238422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238431 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
     /* 238438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_t16),
     /* 238451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 238481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 238490 */     GIR_RootConstrainSelectedInstOperands,
     /* 238491 */     // GIR_Coverage, 6922,
     /* 238491 */     GIR_EraseRootFromParent_Done,
     /* 238492 */   // Label 3842: @238492
     /* 238492 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(238626), // Rule ID 6923 //
     /* 238497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 238500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
     /* 238505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 238508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238521 */     // MIs[0] Operand 5
     /* 238521 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 238532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238553 */     // (intrinsic_wo_chain:{ *:[f16] } 2996:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 238553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 238556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238565 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
     /* 238572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_t16),
     /* 238585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 238615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 238624 */     GIR_RootConstrainSelectedInstOperands,
     /* 238625 */     // GIR_Coverage, 6923,
     /* 238625 */     GIR_EraseRootFromParent_Done,
     /* 238626 */   // Label 3843: @238626
     /* 238626 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(238787), // Rule ID 6924 //
     /* 238631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 238634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
     /* 238639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238655 */     // MIs[0] Operand 5
     /* 238655 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 238666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238687 */     // (intrinsic_wo_chain:{ *:[f32] } 3000:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, lo16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 238687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 238690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238699 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src2
     /* 238706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 238719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238728 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
     /* 238735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_t16),
     /* 238748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 238776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 238785 */     GIR_RootConstrainSelectedInstOperands,
     /* 238786 */     // GIR_Coverage, 6924,
     /* 238786 */     GIR_EraseRootFromParent_Done,
     /* 238787 */   // Label 3844: @238787
     /* 238787 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(238948), // Rule ID 6925 //
     /* 238792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 238795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
     /* 238800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238816 */     // MIs[0] Operand 5
     /* 238816 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 238827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238848 */     // (intrinsic_wo_chain:{ *:[f32] } 3000:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, hi16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 238848 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 238851 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238855 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238860 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src2
     /* 238867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 238880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238889 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
     /* 238896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_t16),
     /* 238909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 238919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 238937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 238946 */     GIR_RootConstrainSelectedInstOperands,
     /* 238947 */     // GIR_Coverage, 6925,
     /* 238947 */     GIR_EraseRootFromParent_Done,
     /* 238948 */   // Label 3845: @238948
     /* 238948 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(239082), // Rule ID 6926 //
     /* 238953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 238956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
     /* 238961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 238964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 238977 */     // MIs[0] Operand 5
     /* 238977 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 238988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 238995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239009 */     // (intrinsic_wo_chain:{ *:[f16] } 3003:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 239012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 239016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 239021 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
     /* 239028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 239033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_t16),
     /* 239041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 239051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239080 */     GIR_RootConstrainSelectedInstOperands,
     /* 239081 */     // GIR_Coverage, 6926,
     /* 239081 */     GIR_EraseRootFromParent_Done,
     /* 239082 */   // Label 3846: @239082
     /* 239082 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(239216), // Rule ID 6927 //
     /* 239087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 239090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
     /* 239095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 239098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 239111 */     // MIs[0] Operand 5
     /* 239111 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 239122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239143 */     // (intrinsic_wo_chain:{ *:[f16] } 3003:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 239146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 239150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 239155 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
     /* 239162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 239167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_t16),
     /* 239175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 239185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239214 */     GIR_RootConstrainSelectedInstOperands,
     /* 239215 */     // GIR_Coverage, 6927,
     /* 239215 */     GIR_EraseRootFromParent_Done,
     /* 239216 */   // Label 3847: @239216
     /* 239216 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(239323), // Rule ID 6928 //
     /* 239221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 239224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
     /* 239229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 239232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239245 */     // MIs[0] Operand 5
     /* 239245 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 239256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239277 */     // (intrinsic_wo_chain:{ *:[f16] } 2996:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_fake16),
     /* 239280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239321 */     GIR_RootConstrainSelectedInstOperands,
     /* 239322 */     // GIR_Coverage, 6928,
     /* 239322 */     GIR_EraseRootFromParent_Done,
     /* 239323 */   // Label 3848: @239323
     /* 239323 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(239430), // Rule ID 6929 //
     /* 239328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 239331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
     /* 239336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 239339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239352 */     // MIs[0] Operand 5
     /* 239352 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 239363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 239370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239384 */     // (intrinsic_wo_chain:{ *:[f16] } 2996:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_fake16),
     /* 239387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239428 */     GIR_RootConstrainSelectedInstOperands,
     /* 239429 */     // GIR_Coverage, 6929,
     /* 239429 */     GIR_EraseRootFromParent_Done,
     /* 239430 */   // Label 3849: @239430
     /* 239430 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(239537), // Rule ID 6930 //
     /* 239435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 239438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
     /* 239443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239459 */     // MIs[0] Operand 5
     /* 239459 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 239470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239491 */     // (intrinsic_wo_chain:{ *:[f32] } 3000:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_fake16),
     /* 239494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239535 */     GIR_RootConstrainSelectedInstOperands,
     /* 239536 */     // GIR_Coverage, 6930,
     /* 239536 */     GIR_EraseRootFromParent_Done,
     /* 239537 */   // Label 3850: @239537
     /* 239537 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(239644), // Rule ID 6931 //
     /* 239542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 239545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
     /* 239550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239566 */     // MIs[0] Operand 5
     /* 239566 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 239577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 239584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 239598 */     // (intrinsic_wo_chain:{ *:[f32] } 3000:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_fake16),
     /* 239601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239642 */     GIR_RootConstrainSelectedInstOperands,
     /* 239643 */     // GIR_Coverage, 6931,
     /* 239643 */     GIR_EraseRootFromParent_Done,
     /* 239644 */   // Label 3851: @239644
     /* 239644 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(239751), // Rule ID 6932 //
     /* 239649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 239652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
     /* 239657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 239660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239673 */     // MIs[0] Operand 5
     /* 239673 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 239684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239705 */     // (intrinsic_wo_chain:{ *:[f16] } 3003:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_fake16),
     /* 239708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239749 */     GIR_RootConstrainSelectedInstOperands,
     /* 239750 */     // GIR_Coverage, 6932,
     /* 239750 */     GIR_EraseRootFromParent_Done,
     /* 239751 */   // Label 3852: @239751
     /* 239751 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(239858), // Rule ID 6933 //
     /* 239756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 239759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
     /* 239764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 239767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239780 */     // MIs[0] Operand 5
     /* 239780 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 239791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 239798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 239812 */     // (intrinsic_wo_chain:{ *:[f16] } 3003:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 239812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_fake16),
     /* 239815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 239856 */     GIR_RootConstrainSelectedInstOperands,
     /* 239857 */     // GIR_Coverage, 6933,
     /* 239857 */     GIR_EraseRootFromParent_Done,
     /* 239858 */   // Label 3853: @239858
     /* 239858 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(239972), // Rule ID 2680 //
     /* 239863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 239866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
     /* 239871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
     /* 239886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXEC_XNULLRegClassID),
     /* 239894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239915 */     // (intrinsic_wo_chain:{ *:[f32] } 2162:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC:{ *:[i1] })  =>  (V_DIV_FMAS_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2)
     /* 239915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 239919 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 239925 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC
     /* 239929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F32_e64),
     /* 239932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 239970 */     GIR_RootConstrainSelectedInstOperands,
     /* 239971 */     // GIR_Coverage, 2680,
     /* 239971 */     GIR_EraseRootFromParent_Done,
     /* 239972 */   // Label 3854: @239972
     /* 239972 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(240086), // Rule ID 2682 //
     /* 239977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 239980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
     /* 239985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 239988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 239991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 239994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 239997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
     /* 240000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 240004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXEC_XNULLRegClassID),
     /* 240008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240029 */     // (intrinsic_wo_chain:{ *:[f64] } 2162:{ *:[iPTR] }, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC:{ *:[i1] })  =>  (V_DIV_FMAS_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f64] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f64] }:$src2)
     /* 240029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 240033 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC
     /* 240043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F64_e64),
     /* 240046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240084 */     GIR_RootConstrainSelectedInstOperands,
     /* 240085 */     // GIR_Coverage, 2682,
     /* 240085 */     GIR_EraseRootFromParent_Done,
     /* 240086 */   // Label 3855: @240086
     /* 240086 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(240200), // Rule ID 2684 //
     /* 240091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 240094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
     /* 240099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
     /* 240114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 240122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240143 */     // (intrinsic_wo_chain:{ *:[f32] } 2162:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC_LO:{ *:[i1] })  =>  (V_DIV_FMAS_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2)
     /* 240143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 240147 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC_LO), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC_LO
     /* 240157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F32_e64),
     /* 240160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240198 */     GIR_RootConstrainSelectedInstOperands,
     /* 240199 */     // GIR_Coverage, 2684,
     /* 240199 */     GIR_EraseRootFromParent_Done,
     /* 240200 */   // Label 3856: @240200
     /* 240200 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(240314), // Rule ID 2686 //
     /* 240205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 240208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
     /* 240213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 240216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 240219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 240222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 240225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
     /* 240228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 240232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 240236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240257 */     // (intrinsic_wo_chain:{ *:[f64] } 2162:{ *:[iPTR] }, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC_LO:{ *:[i1] })  =>  (V_DIV_FMAS_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f64] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f64] }:$src2)
     /* 240257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 240261 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC_LO), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240267 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC_LO
     /* 240271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F64_e64),
     /* 240274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240312 */     GIR_RootConstrainSelectedInstOperands,
     /* 240313 */     // GIR_Coverage, 2686,
     /* 240313 */     GIR_EraseRootFromParent_Done,
     /* 240314 */   // Label 3857: @240314
     /* 240314 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(240395), // Rule ID 2587 //
     /* 240319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 240322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 240327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240343 */     // MIs[0] byte_sel
     /* 240343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240360 */     // (intrinsic_wo_chain:{ *:[i32] } 2157:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$old, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_SR_FP8_F32_gfx12_e64:{ *:[i32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$old, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
     /* 240360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_gfx12_e64),
     /* 240363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240385 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 240387 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
     /* 240393 */     GIR_RootConstrainSelectedInstOperands,
     /* 240394 */     // GIR_Coverage, 2587,
     /* 240394 */     GIR_EraseRootFromParent_Done,
     /* 240395 */   // Label 3858: @240395
     /* 240395 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(240476), // Rule ID 2588 //
     /* 240400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 240403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 240408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240424 */     // MIs[0] byte_sel
     /* 240424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 240427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240441 */     // (intrinsic_wo_chain:{ *:[i32] } 2155:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$old, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_SR_BF8_F32_gfx12_e64:{ *:[i32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$old, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
     /* 240441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_gfx12_e64),
     /* 240444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240466 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 240468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
     /* 240474 */     GIR_RootConstrainSelectedInstOperands,
     /* 240475 */     // GIR_Coverage, 2588,
     /* 240475 */     GIR_EraseRootFromParent_Done,
     /* 240476 */   // Label 3859: @240476
     /* 240476 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(240539), // Rule ID 1330 //
     /* 240481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX90APlus),
     /* 240484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_mov),
     /* 240489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 240495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240499 */     // MIs[0] vsrc
     /* 240499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 240502 */     // MIs[0] attrchan
     /* 240502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 240505 */     // MIs[0] attr
     /* 240505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 240508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 240512 */     // (intrinsic_wo_chain:{ *:[f32] } 2997:{ *:[iPTR] }, (timm:{ *:[i32] }):$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_MOV_F32:{ *:[f32] } (timm:{ *:[i32] }):$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
     /* 240512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 240516 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // M0
     /* 240526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_MOV_F32),
     /* 240529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240531 */     GIR_RootToRootCopy, /*OpIdx*/2, // vsrc
     /* 240533 */     GIR_RootToRootCopy, /*OpIdx*/4, // attr
     /* 240535 */     GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
     /* 240537 */     GIR_RootConstrainSelectedInstOperands,
     /* 240538 */     // GIR_Coverage, 1330,
     /* 240538 */     GIR_EraseRootFromParent_Done,
     /* 240539 */   // Label 3860: @240539
     /* 240539 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(240602), // Rule ID 1327 //
     /* 240544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_has32BankLDS_isNotGFX90APlus),
     /* 240547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p1),
     /* 240552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 240561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240565 */     // MIs[0] attrchan
     /* 240565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 240568 */     // MIs[0] attr
     /* 240568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 240571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 240575 */     // (intrinsic_wo_chain:{ *:[f32] } 2998:{ *:[iPTR] }, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_P1_F32:{ *:[f32] } f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
     /* 240575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 240579 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240585 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // M0
     /* 240589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P1_F32),
     /* 240592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240594 */     GIR_RootToRootCopy, /*OpIdx*/2, // vsrc
     /* 240596 */     GIR_RootToRootCopy, /*OpIdx*/4, // attr
     /* 240598 */     GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
     /* 240600 */     GIR_RootConstrainSelectedInstOperands,
     /* 240601 */     // GIR_Coverage, 1327,
     /* 240601 */     GIR_EraseRootFromParent_Done,
     /* 240602 */   // Label 3861: @240602
     /* 240602 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(240665), // Rule ID 1328 //
     /* 240607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_has16BankLDS_isNotGFX90APlus),
     /* 240610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p1),
     /* 240615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 240624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240628 */     // MIs[0] attrchan
     /* 240628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 240631 */     // MIs[0] attr
     /* 240631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 240634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 240638 */     // (intrinsic_wo_chain:{ *:[f32] } 2998:{ *:[iPTR] }, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_P1_F32_16bank:{ *:[f32] } f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
     /* 240638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 240642 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // M0
     /* 240652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P1_F32_16bank),
     /* 240655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240657 */     GIR_RootToRootCopy, /*OpIdx*/2, // vsrc
     /* 240659 */     GIR_RootToRootCopy, /*OpIdx*/4, // attr
     /* 240661 */     GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
     /* 240663 */     GIR_RootConstrainSelectedInstOperands,
     /* 240664 */     // GIR_Coverage, 1328,
     /* 240664 */     GIR_EraseRootFromParent_Done,
     /* 240665 */   // Label 3862: @240665
     /* 240665 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(240727), // Rule ID 2575 //
     /* 240670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX9Plus),
     /* 240673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_fp8_f32),
     /* 240678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240694 */     // MIs[0] Operand 5
     /* 240694 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 240705 */     // (intrinsic_wo_chain:{ *:[i32] } 2098:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i1] })  =>  (V_CVT_PK_FP8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 240705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_FP8_F32_e64),
     /* 240708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240713 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 240715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240718 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 240720 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 240722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240725 */     GIR_RootConstrainSelectedInstOperands,
     /* 240726 */     // GIR_Coverage, 2575,
     /* 240726 */     GIR_EraseRootFromParent_Done,
     /* 240727 */   // Label 3863: @240727
     /* 240727 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(240789), // Rule ID 2576 //
     /* 240732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX9Plus),
     /* 240735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_bf8_f32),
     /* 240740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240756 */     // MIs[0] Operand 5
     /* 240756 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 240767 */     // (intrinsic_wo_chain:{ *:[i32] } 2095:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i1] })  =>  (V_CVT_PK_BF8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 240767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF8_F32_e64),
     /* 240770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240775 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 240777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240780 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 240782 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 240784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240787 */     GIR_RootConstrainSelectedInstOperands,
     /* 240788 */     // GIR_Coverage, 2576,
     /* 240788 */     GIR_EraseRootFromParent_Done,
     /* 240789 */   // Label 3864: @240789
     /* 240789 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(240851), // Rule ID 2577 //
     /* 240794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX9Plus),
     /* 240797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_fp8_f32),
     /* 240802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240818 */     // MIs[0] Operand 5
     /* 240818 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 240829 */     // (intrinsic_wo_chain:{ *:[i32] } 2098:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, -1:{ *:[i1] })  =>  (V_CVT_PK_FP8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 240829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_FP8_F32_e64),
     /* 240832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 240837 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 240839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240842 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 240844 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 240846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240849 */     GIR_RootConstrainSelectedInstOperands,
     /* 240850 */     // GIR_Coverage, 2577,
     /* 240850 */     GIR_EraseRootFromParent_Done,
     /* 240851 */   // Label 3865: @240851
     /* 240851 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(240913), // Rule ID 2578 //
     /* 240856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX9Plus),
     /* 240859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_bf8_f32),
     /* 240864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240880 */     // MIs[0] Operand 5
     /* 240880 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 240891 */     // (intrinsic_wo_chain:{ *:[i32] } 2095:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, -1:{ *:[i1] })  =>  (V_CVT_PK_BF8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 240891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF8_F32_e64),
     /* 240894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 240899 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 240901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240904 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 240906 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 240908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240911 */     GIR_RootConstrainSelectedInstOperands,
     /* 240912 */     // GIR_Coverage, 2578,
     /* 240912 */     GIR_EraseRootFromParent_Done,
     /* 240913 */   // Label 3866: @240913
     /* 240913 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(240978), // Rule ID 2579 //
     /* 240918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 240921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 240926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240942 */     // MIs[0] Operand 5
     /* 240942 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 240953 */     // (intrinsic_wo_chain:{ *:[i32] } 2157:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 240953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
     /* 240956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240961 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 240963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240966 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 240968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240971 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 240973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240976 */     GIR_RootConstrainSelectedInstOperands,
     /* 240977 */     // GIR_Coverage, 2579,
     /* 240977 */     GIR_EraseRootFromParent_Done,
     /* 240978 */   // Label 3867: @240978
     /* 240978 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(241043), // Rule ID 2580 //
     /* 240983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 240986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 240991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241007 */     // MIs[0] Operand 5
     /* 241007 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 241018 */     // (intrinsic_wo_chain:{ *:[i32] } 2155:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
     /* 241021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241031 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241036 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241041 */     GIR_RootConstrainSelectedInstOperands,
     /* 241042 */     // GIR_Coverage, 2580,
     /* 241042 */     GIR_EraseRootFromParent_Done,
     /* 241043 */   // Label 3868: @241043
     /* 241043 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(241108), // Rule ID 2581 //
     /* 241048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 241056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241072 */     // MIs[0] Operand 5
     /* 241072 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 241083 */     // (intrinsic_wo_chain:{ *:[i32] } 2157:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 1:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
     /* 241086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241091 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241096 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 241101 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241106 */     GIR_RootConstrainSelectedInstOperands,
     /* 241107 */     // GIR_Coverage, 2581,
     /* 241107 */     GIR_EraseRootFromParent_Done,
     /* 241108 */   // Label 3869: @241108
     /* 241108 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(241173), // Rule ID 2582 //
     /* 241113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 241121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241137 */     // MIs[0] Operand 5
     /* 241137 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 241148 */     // (intrinsic_wo_chain:{ *:[i32] } 2155:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 1:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
     /* 241151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241161 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 241166 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241171 */     GIR_RootConstrainSelectedInstOperands,
     /* 241172 */     // GIR_Coverage, 2582,
     /* 241172 */     GIR_EraseRootFromParent_Done,
     /* 241173 */   // Label 3870: @241173
     /* 241173 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(241238), // Rule ID 2583 //
     /* 241178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 241186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241202 */     // MIs[0] Operand 5
     /* 241202 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(2),
     /* 241213 */     // (intrinsic_wo_chain:{ *:[i32] } 2157:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 2:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
     /* 241216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 241221 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241226 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241231 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241236 */     GIR_RootConstrainSelectedInstOperands,
     /* 241237 */     // GIR_Coverage, 2583,
     /* 241237 */     GIR_EraseRootFromParent_Done,
     /* 241238 */   // Label 3871: @241238
     /* 241238 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(241303), // Rule ID 2584 //
     /* 241243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 241251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241267 */     // MIs[0] Operand 5
     /* 241267 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(2),
     /* 241278 */     // (intrinsic_wo_chain:{ *:[i32] } 2155:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 2:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
     /* 241281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 241286 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241291 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241296 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241301 */     GIR_RootConstrainSelectedInstOperands,
     /* 241302 */     // GIR_Coverage, 2584,
     /* 241302 */     GIR_EraseRootFromParent_Done,
     /* 241303 */   // Label 3872: @241303
     /* 241303 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(241368), // Rule ID 2585 //
     /* 241308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 241316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241332 */     // MIs[0] Operand 5
     /* 241332 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(3),
     /* 241343 */     // (intrinsic_wo_chain:{ *:[i32] } 2157:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 3:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
     /* 241346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 241351 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241356 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 241361 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241366 */     GIR_RootConstrainSelectedInstOperands,
     /* 241367 */     // GIR_Coverage, 2585,
     /* 241367 */     GIR_EraseRootFromParent_Done,
     /* 241368 */   // Label 3873: @241368
     /* 241368 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(241433), // Rule ID 2586 //
     /* 241373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 241376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 241381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241397 */     // MIs[0] Operand 5
     /* 241397 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(3),
     /* 241408 */     // (intrinsic_wo_chain:{ *:[i32] } 2155:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 3:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 241408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
     /* 241411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 241416 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241421 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 241426 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 241428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241431 */     GIR_RootConstrainSelectedInstOperands,
     /* 241432 */     // GIR_Coverage, 2586,
     /* 241432 */     GIR_EraseRootFromParent_Done,
     /* 241433 */   // Label 3874: @241433
     /* 241433 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(241487), // Rule ID 2637 //
     /* 241438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp8_f16),
     /* 241443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 241446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 241449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 241452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241459 */     // MIs[0] word_sel
     /* 241459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241462 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2127:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_FP8_F16_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 241462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP8_F16_e64),
     /* 241465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241467 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 241473 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 241475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241478 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 241480 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 241482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241485 */     GIR_RootConstrainSelectedInstOperands,
     /* 241486 */     // GIR_Coverage, 2637,
     /* 241486 */     GIR_EraseRootFromParent_Done,
     /* 241487 */   // Label 3875: @241487
     /* 241487 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(241541), // Rule ID 2638 //
     /* 241492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_bf8_f16),
     /* 241497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 241500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 241503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 241506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241513 */     // MIs[0] word_sel
     /* 241513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241516 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2115:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_BF8_F16_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 241516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_BF8_F16_e64),
     /* 241519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241521 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 241527 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 241529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241532 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 241534 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 241536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241539 */     GIR_RootConstrainSelectedInstOperands,
     /* 241540 */     // GIR_Coverage, 2638,
     /* 241540 */     GIR_EraseRootFromParent_Done,
     /* 241541 */   // Label 3876: @241541
     /* 241541 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(241601), // Rule ID 2641 //
     /* 241546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp4_f16),
     /* 241551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 241560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241567 */     // MIs[0] index
     /* 241567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241570 */     // (intrinsic_wo_chain:{ *:[i32] } 2124:{ *:[iPTR] }, i32:{ *:[i32] }:$src2, v2f16:{ *:[v2f16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_FP4_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src2)
     /* 241570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP4_F16_e64),
     /* 241573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241575 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 241581 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 241583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241586 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 241588 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 241594 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 241596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241599 */     GIR_RootConstrainSelectedInstOperands,
     /* 241600 */     // GIR_Coverage, 2641,
     /* 241600 */     GIR_EraseRootFromParent_Done,
     /* 241601 */   // Label 3877: @241601
     /* 241601 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(241658), // Rule ID 2688 //
     /* 241606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF32ToF16BF16ConversionSRInsts),
     /* 241609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_f16_f32),
     /* 241614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 241617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 241620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241630 */     // MIs[0] word_sel
     /* 241630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241633 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2156:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SR_F16_F32_e64:{ *:[v2f16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 241633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_F16_F32_e64),
     /* 241636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241638 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 241644 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 241646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241649 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 241651 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 241653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241656 */     GIR_RootConstrainSelectedInstOperands,
     /* 241657 */     // GIR_Coverage, 2688,
     /* 241657 */     GIR_EraseRootFromParent_Done,
     /* 241658 */   // Label 3878: @241658
     /* 241658 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(241720), // Rule ID 2748 //
     /* 241663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
     /* 241666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot8),
     /* 241671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241687 */     // MIs[0] clamp
     /* 241687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241690 */     // (intrinsic_wo_chain:{ *:[i32] } 3199:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_I32_IU4:{ *:[i32] } 9:{ *:[i32] }, i32:{ *:[i32] }:$src0, 9:{ *:[i32] }, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 241690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_I32_IU4),
     /* 241693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 241698 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 241703 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 241708 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241710 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 241712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241718 */     GIR_RootConstrainSelectedInstOperands,
     /* 241719 */     // GIR_Coverage, 2748,
     /* 241719 */     GIR_EraseRootFromParent_Done,
     /* 241720 */   // Label 3879: @241720
     /* 241720 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(241782), // Rule ID 2749 //
     /* 241725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
     /* 241728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot4),
     /* 241733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241749 */     // MIs[0] clamp
     /* 241749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241752 */     // (intrinsic_wo_chain:{ *:[i32] } 3198:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_I32_IU8:{ *:[i32] } 9:{ *:[i32] }, i32:{ *:[i32] }:$src0, 9:{ *:[i32] }, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 241752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_IU8),
     /* 241755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 241760 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 241765 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 241770 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241772 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 241774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241780 */     GIR_RootConstrainSelectedInstOperands,
     /* 241781 */     // GIR_Coverage, 2749,
     /* 241781 */     GIR_EraseRootFromParent_Done,
     /* 241782 */   // Label 3880: @241782
     /* 241782 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(241826), // Rule ID 2676 //
     /* 241787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBitOp3Insts),
     /* 241790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_bitop3),
     /* 241795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241811 */     // MIs[0] bitop3
     /* 241811 */     // No operand predicates
     /* 241811 */     // (intrinsic_wo_chain:{ *:[i32] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$bitop3)  =>  (V_BITOP3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2, (timm:{ *:[i32] }):$bitop3)
     /* 241811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BITOP3_B32_e64),
     /* 241814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241816 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241818 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241820 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241822 */     GIR_RootToRootCopy, /*OpIdx*/5, // bitop3
     /* 241824 */     GIR_RootConstrainSelectedInstOperands,
     /* 241825 */     // GIR_Coverage, 2676,
     /* 241825 */     GIR_EraseRootFromParent_Done,
     /* 241826 */   // Label 3881: @241826
     /* 241826 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(241882), // Rule ID 2677 //
     /* 241831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBitOp3Insts),
     /* 241834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_bitop3),
     /* 241839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 241842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 241845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 241848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 241851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241855 */     // MIs[0] bitop3
     /* 241855 */     // No operand predicates
     /* 241855 */     // (intrinsic_wo_chain:{ *:[i16] } 2082:{ *:[iPTR] }, i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$bitop3)  =>  (V_BITOP3_B16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, (timm:{ *:[i32] }):$bitop3, 0:{ *:[i32] })
     /* 241855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BITOP3_B16_e64),
     /* 241858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241863 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241868 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241873 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241875 */     GIR_RootToRootCopy, /*OpIdx*/5, // bitop3
     /* 241877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241880 */     GIR_RootConstrainSelectedInstOperands,
     /* 241881 */     // GIR_Coverage, 2677,
     /* 241881 */     GIR_EraseRootFromParent_Done,
     /* 241882 */   // Label 3882: @241882
     /* 241882 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(241986), // Rule ID 1115 //
     /* 241887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /* 241890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot2),
     /* 241895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 241901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 241904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241911 */     // MIs[0] clamp
     /* 241911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 241914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 241921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 241928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 241935 */     // (intrinsic_wo_chain:{ *:[i32] } 3197:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT2_I32_I16:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 241935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /* 241938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 241945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 241955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 241960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 241965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 241970 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 241972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241984 */     GIR_RootConstrainSelectedInstOperands,
     /* 241985 */     // GIR_Coverage, 1115,
     /* 241985 */     GIR_EraseRootFromParent_Done,
     /* 241986 */   // Label 3883: @241986
     /* 241986 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(242090), // Rule ID 1116 //
     /* 241991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /* 241994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_udot2),
     /* 241999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 242005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 242008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242015 */     // MIs[0] clamp
     /* 242015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242039 */     // (intrinsic_wo_chain:{ *:[i32] } 3301:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT2_U32_U16:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 242039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /* 242042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242074 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242088 */     GIR_RootConstrainSelectedInstOperands,
     /* 242089 */     // GIR_Coverage, 1116,
     /* 242089 */     GIR_EraseRootFromParent_Done,
     /* 242090 */   // Label 3884: @242090
     /* 242090 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(242194), // Rule ID 1117 //
     /* 242095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot10Insts),
     /* 242098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2),
     /* 242103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 242109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 242112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242119 */     // MIs[0] clamp
     /* 242119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242143 */     // (intrinsic_wo_chain:{ *:[f32] } 2201:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT2_F32_F16:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 242143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F32_F16),
     /* 242146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242178 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242192 */     GIR_RootConstrainSelectedInstOperands,
     /* 242193 */     // GIR_Coverage, 1117,
     /* 242193 */     GIR_EraseRootFromParent_Done,
     /* 242194 */   // Label 3885: @242194
     /* 242194 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(242292), // Rule ID 1119 //
     /* 242199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /* 242202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_udot4),
     /* 242207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242223 */     // MIs[0] clamp
     /* 242223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242247 */     // (intrinsic_wo_chain:{ *:[i32] } 3302:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_U32_U8:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 242247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /* 242250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242282 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242290 */     GIR_RootConstrainSelectedInstOperands,
     /* 242291 */     // GIR_Coverage, 1119,
     /* 242291 */     GIR_EraseRootFromParent_Done,
     /* 242292 */   // Label 3886: @242292
     /* 242292 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(242390), // Rule ID 1120 //
     /* 242297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /* 242300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_udot8),
     /* 242305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242321 */     // MIs[0] clamp
     /* 242321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242345 */     // (intrinsic_wo_chain:{ *:[i32] } 3303:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_U32_U4:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 242345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_U32_U4),
     /* 242348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242380 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242388 */     GIR_RootConstrainSelectedInstOperands,
     /* 242389 */     // GIR_Coverage, 1120,
     /* 242389 */     GIR_EraseRootFromParent_Done,
     /* 242390 */   // Label 3887: @242390
     /* 242390 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(242488), // Rule ID 1121 //
     /* 242395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /* 242398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot4),
     /* 242403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242419 */     // MIs[0] clamp
     /* 242419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242443 */     // (intrinsic_wo_chain:{ *:[i32] } 3198:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_I32_I8:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 242443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /* 242446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242478 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242486 */     GIR_RootConstrainSelectedInstOperands,
     /* 242487 */     // GIR_Coverage, 1121,
     /* 242487 */     GIR_EraseRootFromParent_Done,
     /* 242488 */   // Label 3888: @242488
     /* 242488 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(242586), // Rule ID 1122 //
     /* 242493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /* 242496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot8),
     /* 242501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242517 */     // MIs[0] clamp
     /* 242517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 242541 */     // (intrinsic_wo_chain:{ *:[i32] } 3199:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_I32_I4:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 242541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_I32_I4),
     /* 242544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242576 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 242578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242584 */     GIR_RootConstrainSelectedInstOperands,
     /* 242585 */     // GIR_Coverage, 1122,
     /* 242585 */     GIR_EraseRootFromParent_Done,
     /* 242586 */   // Label 3889: @242586
     /* 242586 */   GIM_Reject,
     /* 242587 */ // Label 3833: @242587
     /* 242587 */ GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(243604),
     /* 242592 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 242595 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(242663), // Rule ID 2627 //
     /* 242600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_fp8),
     /* 242605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 242608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 242611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242621 */     // MIs[0] src_sel
     /* 242621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242624 */     // MIs[0] Operand 6
     /* 242624 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(0),
     /* 242635 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2108:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, 0:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_FP8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 242635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_FP8_e64),
     /* 242638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // src_sel
     /* 242646 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 242648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // src_sel
     /* 242654 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 242656 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 242658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242661 */     GIR_RootConstrainSelectedInstOperands,
     /* 242662 */     // GIR_Coverage, 2627,
     /* 242662 */     GIR_EraseRootFromParent_Done,
     /* 242663 */   // Label 3891: @242663
     /* 242663 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(242731), // Rule ID 2628 //
     /* 242668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_bf8),
     /* 242673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 242676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 242679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242689 */     // MIs[0] src_sel
     /* 242689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242692 */     // MIs[0] Operand 6
     /* 242692 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(0),
     /* 242703 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2107:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, 0:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_BF8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 242703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_BF8_e64),
     /* 242706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242708 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // src_sel
     /* 242714 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 242716 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // src_sel
     /* 242722 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 242724 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 242726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242729 */     GIR_RootConstrainSelectedInstOperands,
     /* 242730 */     // GIR_Coverage, 2628,
     /* 242730 */     GIR_EraseRootFromParent_Done,
     /* 242731 */   // Label 3892: @242731
     /* 242731 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(242799), // Rule ID 2629 //
     /* 242736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_fp8),
     /* 242741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 242744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 242747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242757 */     // MIs[0] src_sel
     /* 242757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242760 */     // MIs[0] Operand 6
     /* 242760 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(-1),
     /* 242771 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2108:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, -1:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_FP8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 242771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_FP8_e64),
     /* 242774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242776 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_1), // src_sel
     /* 242782 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 242784 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_1), // src_sel
     /* 242790 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 242792 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 242794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242797 */     GIR_RootConstrainSelectedInstOperands,
     /* 242798 */     // GIR_Coverage, 2629,
     /* 242798 */     GIR_EraseRootFromParent_Done,
     /* 242799 */   // Label 3893: @242799
     /* 242799 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(242867), // Rule ID 2630 //
     /* 242804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_bf8),
     /* 242809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 242812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 242815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242825 */     // MIs[0] src_sel
     /* 242825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242828 */     // MIs[0] Operand 6
     /* 242828 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(-1),
     /* 242839 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2107:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, -1:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_BF8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 242839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_BF8_e64),
     /* 242842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242844 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_1), // src_sel
     /* 242850 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 242852 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_1), // src_sel
     /* 242858 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 242860 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 242862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242865 */     GIR_RootConstrainSelectedInstOperands,
     /* 242866 */     // GIR_Coverage, 2630,
     /* 242866 */     GIR_EraseRootFromParent_Done,
     /* 242867 */   // Label 3894: @242867
     /* 242867 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(242935), // Rule ID 1329 //
     /* 242872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX90APlus),
     /* 242875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2),
     /* 242880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 242892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242896 */     // MIs[0] attrchan
     /* 242896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 242899 */     // MIs[0] attr
     /* 242899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242902 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 242906 */     // (intrinsic_wo_chain:{ *:[f32] } 3001:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_P2_F32:{ *:[f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
     /* 242906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 242910 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // M0
     /* 242920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F32),
     /* 242923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242925 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 242927 */     GIR_RootToRootCopy, /*OpIdx*/3, // vsrc
     /* 242929 */     GIR_RootToRootCopy, /*OpIdx*/5, // attr
     /* 242931 */     GIR_RootToRootCopy, /*OpIdx*/4, // attrchan
     /* 242933 */     GIR_RootConstrainSelectedInstOperands,
     /* 242934 */     // GIR_Coverage, 1329,
     /* 242934 */     GIR_EraseRootFromParent_Done,
     /* 242935 */   // Label 3895: @242935
     /* 242935 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(242997), // Rule ID 2631 //
     /* 242940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp8_f32),
     /* 242945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 242948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 242951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 242960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242964 */     // MIs[0] word_sel
     /* 242964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 242967 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2128:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_FP8_F32_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 242967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP8_F32_e64),
     /* 242970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242972 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 242978 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 242980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242983 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 242985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242988 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 242990 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 242992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242995 */     GIR_RootConstrainSelectedInstOperands,
     /* 242996 */     // GIR_Coverage, 2631,
     /* 242996 */     GIR_EraseRootFromParent_Done,
     /* 242997 */   // Label 3896: @242997
     /* 242997 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(243059), // Rule ID 2632 //
     /* 243002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_bf8_f32),
     /* 243007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 243010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 243013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243026 */     // MIs[0] word_sel
     /* 243026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243029 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2116:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_BF8_F32_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 243029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_BF8_F32_e64),
     /* 243032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243034 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 243040 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243045 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243050 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243052 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243057 */     GIR_RootConstrainSelectedInstOperands,
     /* 243058 */     // GIR_Coverage, 2632,
     /* 243058 */     GIR_EraseRootFromParent_Done,
     /* 243059 */   // Label 3897: @243059
     /* 243059 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(243124), // Rule ID 2640 //
     /* 243064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp4_f32),
     /* 243069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243088 */     // MIs[0] index
     /* 243088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243091 */     // (intrinsic_wo_chain:{ *:[i32] } 2125:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_FP4_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP4_F32_e64),
     /* 243094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243096 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243102 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243107 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243109 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243115 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243117 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243122 */     GIR_RootConstrainSelectedInstOperands,
     /* 243123 */     // GIR_Coverage, 2640,
     /* 243123 */     GIR_EraseRootFromParent_Done,
     /* 243124 */   // Label 3898: @243124
     /* 243124 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(243189), // Rule ID 2642 //
     /* 243129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk_fp4_f16),
     /* 243134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 243143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243153 */     // MIs[0] index
     /* 243153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243156 */     // (intrinsic_wo_chain:{ *:[i32] } 2146:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_PK_FP4_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK_FP4_F16_e64),
     /* 243159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243161 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243167 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243172 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243174 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243180 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243182 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243187 */     GIR_RootConstrainSelectedInstOperands,
     /* 243188 */     // GIR_Coverage, 2642,
     /* 243188 */     GIR_EraseRootFromParent_Done,
     /* 243189 */   // Label 3899: @243189
     /* 243189 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(243254), // Rule ID 2643 //
     /* 243194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk_fp4_f32),
     /* 243199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 243208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243218 */     // MIs[0] index
     /* 243218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243221 */     // (intrinsic_wo_chain:{ *:[i32] } 2147:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_PK_FP4_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK_FP4_F32_e64),
     /* 243224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243226 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243232 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243237 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243239 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243245 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243247 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243252 */     GIR_RootConstrainSelectedInstOperands,
     /* 243253 */     // GIR_Coverage, 2643,
     /* 243253 */     GIR_EraseRootFromParent_Done,
     /* 243254 */   // Label 3900: @243254
     /* 243254 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(243319), // Rule ID 2644 //
     /* 243259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_bf8_f16),
     /* 243264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 243273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243283 */     // MIs[0] index
     /* 243283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243286 */     // (intrinsic_wo_chain:{ *:[i32] } 2140:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_BF8_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_BF8_F16_e64),
     /* 243289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243291 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243297 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243302 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243304 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243310 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243312 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243317 */     GIR_RootConstrainSelectedInstOperands,
     /* 243318 */     // GIR_Coverage, 2644,
     /* 243318 */     GIR_EraseRootFromParent_Done,
     /* 243319 */   // Label 3901: @243319
     /* 243319 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(243384), // Rule ID 2645 //
     /* 243324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_bf8_f32),
     /* 243329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243348 */     // MIs[0] index
     /* 243348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243351 */     // (intrinsic_wo_chain:{ *:[i32] } 2141:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_BF8_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_BF8_F32_e64),
     /* 243354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243362 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243367 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243369 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243375 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243377 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243382 */     GIR_RootConstrainSelectedInstOperands,
     /* 243383 */     // GIR_Coverage, 2645,
     /* 243383 */     GIR_EraseRootFromParent_Done,
     /* 243384 */   // Label 3902: @243384
     /* 243384 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(243449), // Rule ID 2646 //
     /* 243389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_fp8_f16),
     /* 243394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 243403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243413 */     // MIs[0] index
     /* 243413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243416 */     // (intrinsic_wo_chain:{ *:[i32] } 2143:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_FP8_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_FP8_F16_e64),
     /* 243419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243421 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243427 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243432 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243434 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243440 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243442 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243447 */     GIR_RootConstrainSelectedInstOperands,
     /* 243448 */     // GIR_Coverage, 2646,
     /* 243448 */     GIR_EraseRootFromParent_Done,
     /* 243449 */   // Label 3903: @243449
     /* 243449 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(243514), // Rule ID 2647 //
     /* 243454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_fp8_f32),
     /* 243459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243478 */     // MIs[0] index
     /* 243478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243481 */     // (intrinsic_wo_chain:{ *:[i32] } 2144:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_FP8_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 243481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_FP8_F32_e64),
     /* 243484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 243492 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243497 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 243499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 243505 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 243507 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 243509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243512 */     GIR_RootConstrainSelectedInstOperands,
     /* 243513 */     // GIR_Coverage, 2647,
     /* 243513 */     GIR_EraseRootFromParent_Done,
     /* 243514 */   // Label 3904: @243514
     /* 243514 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(243603), // Rule ID 1017 //
     /* 243519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_has32BankLDS_isNotGFX90APlus),
     /* 243522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p1_f16),
     /* 243527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 243536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243540 */     // MIs[0] attrchan
     /* 243540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 243543 */     // MIs[0] attr
     /* 243543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 243546 */     // MIs[0] high
     /* 243546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243549 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 243553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 243560 */     // (intrinsic_wo_chain:{ *:[f32] } 2999:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, (timm:{ *:[i1] }):$high, M0:{ *:[i32] })  =>  (V_INTERP_P1LL_F16:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i1] }):$high)
     /* 243560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 243564 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243570 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // M0
     /* 243574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P1LL_F16),
     /* 243577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 243584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 243589 */     GIR_RootToRootCopy, /*OpIdx*/4, // attr
     /* 243591 */     GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
     /* 243593 */     GIR_RootToRootCopy, /*OpIdx*/5, // high
     /* 243595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243601 */     GIR_RootConstrainSelectedInstOperands,
     /* 243602 */     // GIR_Coverage, 1017,
     /* 243602 */     GIR_EraseRootFromParent_Done,
     /* 243603 */   // Label 3905: @243603
     /* 243603 */   GIM_Reject,
     /* 243604 */ // Label 3890: @243604
     /* 243604 */ GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(243879),
     /* 243609 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 243612 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(243692), // Rule ID 2746 //
     /* 243617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
     /* 243620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sudot4),
     /* 243625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 243637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243641 */     // MIs[0] clamp
     /* 243641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 243644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 243651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 243658 */     // (intrinsic_wo_chain:{ *:[i32] } 3286:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_mods), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_mods), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_I32_IU8:{ *:[i32] } ?:{ *:[i32] }:$src0_mods, i32:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1_mods, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 243658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_IU8),
     /* 243661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_mods
     /* 243668 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_mods
     /* 243675 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 243677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 243680 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 243682 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 243684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243690 */     GIR_RootConstrainSelectedInstOperands,
     /* 243691 */     // GIR_Coverage, 2746,
     /* 243691 */     GIR_EraseRootFromParent_Done,
     /* 243692 */   // Label 3907: @243692
     /* 243692 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(243772), // Rule ID 2747 //
     /* 243697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
     /* 243700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sudot8),
     /* 243705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 243714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 243717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243721 */     // MIs[0] clamp
     /* 243721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 243724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 243731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 243738 */     // (intrinsic_wo_chain:{ *:[i32] } 3287:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_mods), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_mods), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_I32_IU4:{ *:[i32] } ?:{ *:[i32] }:$src0_mods, i32:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1_mods, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 243738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_I32_IU4),
     /* 243741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_mods
     /* 243748 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 243750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_mods
     /* 243755 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 243757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 243760 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 243762 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 243764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243770 */     GIR_RootConstrainSelectedInstOperands,
     /* 243771 */     // GIR_Coverage, 2747,
     /* 243771 */     GIR_EraseRootFromParent_Done,
     /* 243772 */   // Label 3908: @243772
     /* 243772 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(243878), // Rule ID 1016 //
     /* 243777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isNotGFX90APlus),
     /* 243780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_f16),
     /* 243785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 243788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 243797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243801 */     // MIs[0] attrchan
     /* 243801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 243804 */     // MIs[0] attr
     /* 243804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243807 */     // MIs[0] high
     /* 243807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 243810 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 243814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 243821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 243828 */     // (intrinsic_wo_chain:{ *:[f16] } 3002:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, (timm:{ *:[i1] }):$high, M0:{ *:[i32] })  =>  (V_INTERP_P2_F16:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$high)
     /* 243828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 243832 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243838 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // M0
     /* 243842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16),
     /* 243845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 243852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 243857 */     GIR_RootToRootCopy, /*OpIdx*/5, // attr
     /* 243859 */     GIR_RootToRootCopy, /*OpIdx*/4, // attrchan
     /* 243861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 243866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 243871 */     GIR_RootToRootCopy, /*OpIdx*/6, // high
     /* 243873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243876 */     GIR_RootConstrainSelectedInstOperands,
     /* 243877 */     // GIR_Coverage, 1016,
     /* 243877 */     GIR_EraseRootFromParent_Done,
     /* 243878 */   // Label 3909: @243878
     /* 243878 */   GIM_Reject,
     /* 243879 */ // Label 3906: @243879
     /* 243879 */ GIM_Reject,
     /* 243880 */ // Label 37: @243880
     /* 243880 */ GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(244054),
     /* 243885 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 243888 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(243903), // Rule ID 1314 //
     /* 243893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_inv),
     /* 243898 */     // (intrinsic_void 3155:{ *:[iPTR] })  =>  (S_DCACHE_INV)
     /* 243898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_INV),
     /* 243901 */     GIR_RootConstrainSelectedInstOperands,
     /* 243902 */     // GIR_Coverage, 1314,
     /* 243902 */     GIR_EraseRootFromParent_Done,
     /* 243903 */   // Label 3911: @243903
     /* 243903 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(243921), // Rule ID 1315 //
     /* 243908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7GFX8GFX9),
     /* 243911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_inv_vol),
     /* 243916 */     // (intrinsic_void 3156:{ *:[iPTR] })  =>  (S_DCACHE_INV_VOL)
     /* 243916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_INV_VOL),
     /* 243919 */     GIR_RootConstrainSelectedInstOperands,
     /* 243920 */     // GIR_Coverage, 1315,
     /* 243920 */     GIR_EraseRootFromParent_Done,
     /* 243921 */   // Label 3912: @243921
     /* 243921 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(243939), // Rule ID 1316 //
     /* 243926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasScalarStores_isGFX8Plus),
     /* 243929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_wb),
     /* 243934 */     // (intrinsic_void 3157:{ *:[iPTR] })  =>  (S_DCACHE_WB)
     /* 243934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_WB),
     /* 243937 */     GIR_RootConstrainSelectedInstOperands,
     /* 243938 */     // GIR_Coverage, 1316,
     /* 243938 */     GIR_EraseRootFromParent_Done,
     /* 243939 */   // Label 3913: @243939
     /* 243939 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(243957), // Rule ID 1317 //
     /* 243944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasScalarStores_isGFX8Plus),
     /* 243947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_wb_vol),
     /* 243952 */     // (intrinsic_void 3158:{ *:[iPTR] })  =>  (S_DCACHE_WB_VOL)
     /* 243952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_WB_VOL),
     /* 243955 */     GIR_RootConstrainSelectedInstOperands,
     /* 243956 */     // GIR_Coverage, 1317,
     /* 243956 */     GIR_EraseRootFromParent_Done,
     /* 243957 */   // Label 3914: @243957
     /* 243957 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(243975), // Rule ID 1324 //
     /* 243962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6),
     /* 243965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_buffer_wbinvl1_sc),
     /* 243970 */     // (intrinsic_void 2084:{ *:[iPTR] })  =>  (BUFFER_WBINVL1_SC)
     /* 243970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_WBINVL1_SC),
     /* 243973 */     GIR_RootConstrainSelectedInstOperands,
     /* 243974 */     // GIR_Coverage, 1324,
     /* 243974 */     GIR_EraseRootFromParent_Done,
     /* 243975 */   // Label 3915: @243975
     /* 243975 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(243993), // Rule ID 1325 //
     /* 243980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX940Plus),
     /* 243983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_buffer_wbinvl1),
     /* 243988 */     // (intrinsic_void 2083:{ *:[iPTR] })  =>  (BUFFER_WBINVL1)
     /* 243988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_WBINVL1),
     /* 243991 */     GIR_RootConstrainSelectedInstOperands,
     /* 243992 */     // GIR_Coverage, 1325,
     /* 243992 */     GIR_EraseRootFromParent_Done,
     /* 243993 */   // Label 3916: @243993
     /* 243993 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(244011), // Rule ID 1326 //
     /* 243998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX940Plus),
     /* 244001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_buffer_wbinvl1_vol),
     /* 244006 */     // (intrinsic_void 2085:{ *:[iPTR] })  =>  (BUFFER_WBINVL1_VOL)
     /* 244006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_WBINVL1_VOL),
     /* 244009 */     GIR_RootConstrainSelectedInstOperands,
     /* 244010 */     // GIR_Coverage, 1326,
     /* 244010 */     GIR_EraseRootFromParent_Done,
     /* 244011 */   // Label 3917: @244011
     /* 244011 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(244032), // Rule ID 1872 //
     /* 244016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 244019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_event_export_ready),
     /* 244024 */     // (intrinsic_void 3183:{ *:[iPTR] })  =>  (S_WAIT_EVENT 0:{ *:[i16] })
     /* 244024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_EVENT),
     /* 244027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244030 */     GIR_RootConstrainSelectedInstOperands,
     /* 244031 */     // GIR_Coverage, 1872,
     /* 244031 */     GIR_EraseRootFromParent_Done,
     /* 244032 */   // Label 3918: @244032
     /* 244032 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(244053), // Rule ID 1873 //
     /* 244037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 244040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_event_export_ready),
     /* 244045 */     // (intrinsic_void 3183:{ *:[iPTR] })  =>  (S_WAIT_EVENT 2:{ *:[i16] })
     /* 244045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_EVENT),
     /* 244048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 244051 */     GIR_RootConstrainSelectedInstOperands,
     /* 244052 */     // GIR_Coverage, 1873,
     /* 244052 */     GIR_EraseRootFromParent_Done,
     /* 244053 */   // Label 3919: @244053
     /* 244053 */   GIM_Reject,
     /* 244054 */ // Label 3910: @244054
     /* 244054 */ GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(244771),
     /* 244059 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 244062 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(244120), // Rule ID 6960 //
     /* 244067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_kill),
     /* 244072 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 244075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 244079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 244083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /* 244087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /* 244091 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 244095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 244097 */     // (intrinsic_void 3008:{ *:[iPTR] }, (xor:{ *:[i1] } i1:{ *:[i1] }:$src, -1:{ *:[i1] }))  =>  (SI_KILL_I1_PSEUDO SCSrc_i1:{ *:[i1] }:$src, -1:{ *:[i1] })
     /* 244097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_KILL_I1_PSEUDO),
     /* 244100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 244104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 244107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 244110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
     /* 244113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 244118 */     GIR_RootConstrainSelectedInstOperands,
     /* 244119 */     // GIR_Coverage, 6960,
     /* 244119 */     GIR_EraseRootFromParent_Done,
     /* 244120 */   // Label 3921: @244120
     /* 244120 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(244178), // Rule ID 6963 //
     /* 244125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_wqm_demote),
     /* 244130 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 244133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 244137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 244141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /* 244145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /* 244149 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 244153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 244155 */     // (intrinsic_void 3331:{ *:[iPTR] }, (xor:{ *:[i1] } i1:{ *:[i1] }:$src, -1:{ *:[i1] }))  =>  (SI_DEMOTE_I1 SCSrc_i1:{ *:[i1] }:$src, -1:{ *:[i1] })
     /* 244155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_DEMOTE_I1),
     /* 244158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 244162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 244165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 244168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
     /* 244171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 244176 */     GIR_RootConstrainSelectedInstOperands,
     /* 244177 */     // GIR_Coverage, 6963,
     /* 244177 */     GIR_EraseRootFromParent_Done,
     /* 244178 */   // Label 3922: @244178
     /* 244178 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(244198), // Rule ID 178 //
     /* 244183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_nop),
     /* 244188 */     // MIs[0] simm16
     /* 244188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244191 */     // (intrinsic_void 3168:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_NOP (timm:{ *:[i16] }):$simm16)
     /* 244191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOP),
     /* 244194 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244196 */     GIR_RootConstrainSelectedInstOperands,
     /* 244197 */     // GIR_Coverage, 178,
     /* 244197 */     GIR_EraseRootFromParent_Done,
     /* 244198 */   // Label 3923: @244198
     /* 244198 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(244218), // Rule ID 183 //
     /* 244203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_waitcnt),
     /* 244208 */     // MIs[0] simm16
     /* 244208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244211 */     // (intrinsic_void 3189:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_WAITCNT (timm:{ *:[i32] }):$simm16)
     /* 244211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAITCNT),
     /* 244214 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244216 */     GIR_RootConstrainSelectedInstOperands,
     /* 244217 */     // GIR_Coverage, 183,
     /* 244217 */     GIR_EraseRootFromParent_Done,
     /* 244218 */   // Label 3924: @244218
     /* 244218 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(244238), // Rule ID 184 //
     /* 244223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sethalt),
     /* 244228 */     // MIs[0] simm16
     /* 244228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244231 */     // (intrinsic_void 3174:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_SETHALT (timm:{ *:[i32] }):$simm16)
     /* 244231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SETHALT),
     /* 244234 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244236 */     GIR_RootConstrainSelectedInstOperands,
     /* 244237 */     // GIR_Coverage, 184,
     /* 244237 */     GIR_EraseRootFromParent_Done,
     /* 244238 */   // Label 3925: @244238
     /* 244238 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(244258), // Rule ID 185 //
     /* 244243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sleep),
     /* 244248 */     // MIs[0] simm16
     /* 244248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244251 */     // (intrinsic_void 3177:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_SLEEP (timm:{ *:[i32] }):$simm16)
     /* 244251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SLEEP),
     /* 244254 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244256 */     GIR_RootConstrainSelectedInstOperands,
     /* 244257 */     // GIR_Coverage, 185,
     /* 244257 */     GIR_EraseRootFromParent_Done,
     /* 244258 */   // Label 3926: @244258
     /* 244258 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(244278), // Rule ID 187 //
     /* 244263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_setprio),
     /* 244268 */     // MIs[0] simm16
     /* 244268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244271 */     // (intrinsic_void 3175:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_SETPRIO (timm:{ *:[i16] }):$simm16)
     /* 244271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SETPRIO),
     /* 244274 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244276 */     GIR_RootConstrainSelectedInstOperands,
     /* 244277 */     // GIR_Coverage, 187,
     /* 244277 */     GIR_EraseRootFromParent_Done,
     /* 244278 */   // Label 3927: @244278
     /* 244278 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(244298), // Rule ID 190 //
     /* 244283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_incperflevel),
     /* 244288 */     // MIs[0] simm16
     /* 244288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244291 */     // (intrinsic_void 3165:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_INCPERFLEVEL (timm:{ *:[i32] }):$simm16)
     /* 244291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INCPERFLEVEL),
     /* 244294 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244296 */     GIR_RootConstrainSelectedInstOperands,
     /* 244297 */     // GIR_Coverage, 190,
     /* 244297 */     GIR_EraseRootFromParent_Done,
     /* 244298 */   // Label 3928: @244298
     /* 244298 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(244318), // Rule ID 191 //
     /* 244303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_decperflevel),
     /* 244308 */     // MIs[0] simm16
     /* 244308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244311 */     // (intrinsic_void 3159:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_DECPERFLEVEL (timm:{ *:[i32] }):$simm16)
     /* 244311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DECPERFLEVEL),
     /* 244314 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244316 */     GIR_RootConstrainSelectedInstOperands,
     /* 244317 */     // GIR_Coverage, 191,
     /* 244317 */     GIR_EraseRootFromParent_Done,
     /* 244318 */   // Label 3929: @244318
     /* 244318 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(244341), // Rule ID 194 //
     /* 244323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 244326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_ttracedata_imm),
     /* 244331 */     // MIs[0] simm16
     /* 244331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244334 */     // (intrinsic_void 3180:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_TTRACEDATA_IMM (timm:{ *:[i16] }):$simm16)
     /* 244334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_TTRACEDATA_IMM),
     /* 244337 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244339 */     GIR_RootConstrainSelectedInstOperands,
     /* 244340 */     // GIR_Coverage, 194,
     /* 244340 */     GIR_EraseRootFromParent_Done,
     /* 244341 */   // Label 3930: @244341
     /* 244341 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(244364), // Rule ID 195 //
     /* 244346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 244349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_loadcnt),
     /* 244354 */     // MIs[0] simm16
     /* 244354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244357 */     // (intrinsic_void 3186:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_LOADCNT (timm:{ *:[i16] }):$simm16)
     /* 244357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_LOADCNT),
     /* 244360 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244362 */     GIR_RootConstrainSelectedInstOperands,
     /* 244363 */     // GIR_Coverage, 195,
     /* 244363 */     GIR_EraseRootFromParent_Done,
     /* 244364 */   // Label 3931: @244364
     /* 244364 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(244387), // Rule ID 196 //
     /* 244369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 244372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_storecnt),
     /* 244377 */     // MIs[0] simm16
     /* 244377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244380 */     // (intrinsic_void 3188:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_STORECNT (timm:{ *:[i16] }):$simm16)
     /* 244380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_STORECNT),
     /* 244383 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244385 */     GIR_RootConstrainSelectedInstOperands,
     /* 244386 */     // GIR_Coverage, 196,
     /* 244386 */     GIR_EraseRootFromParent_Done,
     /* 244387 */   // Label 3932: @244387
     /* 244387 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(244410), // Rule ID 197 //
     /* 244392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasImageInsts_isGFX12Plus),
     /* 244395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_samplecnt),
     /* 244400 */     // MIs[0] simm16
     /* 244400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244403 */     // (intrinsic_void 3187:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_SAMPLECNT (timm:{ *:[i16] }):$simm16)
     /* 244403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_SAMPLECNT),
     /* 244406 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244408 */     GIR_RootConstrainSelectedInstOperands,
     /* 244409 */     // GIR_Coverage, 197,
     /* 244409 */     GIR_EraseRootFromParent_Done,
     /* 244410 */   // Label 3933: @244410
     /* 244410 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(244433), // Rule ID 198 //
     /* 244415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasImageInsts_isGFX12Plus),
     /* 244418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_bvhcnt),
     /* 244423 */     // MIs[0] simm16
     /* 244423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244426 */     // (intrinsic_void 3181:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_BVHCNT (timm:{ *:[i16] }):$simm16)
     /* 244426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_BVHCNT),
     /* 244429 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244431 */     GIR_RootConstrainSelectedInstOperands,
     /* 244432 */     // GIR_Coverage, 198,
     /* 244432 */     GIR_EraseRootFromParent_Done,
     /* 244433 */   // Label 3934: @244433
     /* 244433 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(244456), // Rule ID 199 //
     /* 244438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExportInsts_isGFX12Plus),
     /* 244441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_expcnt),
     /* 244446 */     // MIs[0] simm16
     /* 244446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244449 */     // (intrinsic_void 3184:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_EXPCNT (timm:{ *:[i16] }):$simm16)
     /* 244449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_EXPCNT),
     /* 244452 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244454 */     GIR_RootConstrainSelectedInstOperands,
     /* 244455 */     // GIR_Coverage, 199,
     /* 244455 */     GIR_EraseRootFromParent_Done,
     /* 244456 */   // Label 3935: @244456
     /* 244456 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(244479), // Rule ID 200 //
     /* 244461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 244464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_dscnt),
     /* 244469 */     // MIs[0] simm16
     /* 244469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244472 */     // (intrinsic_void 3182:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_DSCNT (timm:{ *:[i16] }):$simm16)
     /* 244472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_DSCNT),
     /* 244475 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244477 */     GIR_RootConstrainSelectedInstOperands,
     /* 244478 */     // GIR_Coverage, 200,
     /* 244478 */     GIR_EraseRootFromParent_Done,
     /* 244479 */   // Label 3936: @244479
     /* 244479 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(244502), // Rule ID 201 //
     /* 244484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 244487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_kmcnt),
     /* 244492 */     // MIs[0] simm16
     /* 244492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244495 */     // (intrinsic_void 3185:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_KMCNT (timm:{ *:[i16] }):$simm16)
     /* 244495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_KMCNT),
     /* 244498 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 244500 */     GIR_RootConstrainSelectedInstOperands,
     /* 244501 */     // GIR_Coverage, 201,
     /* 244501 */     GIR_EraseRootFromParent_Done,
     /* 244502 */   // Label 3937: @244502
     /* 244502 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(244529), // Rule ID 1313 //
     /* 244507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemTimeInst),
     /* 244510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_memtime),
     /* 244515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 244522 */     // (intrinsic_w_chain:{ *:[i64] } 3167:{ *:[iPTR] })  =>  (S_MEMTIME:{ *:[i64] })
     /* 244522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMTIME),
     /* 244525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 244527 */     GIR_RootConstrainSelectedInstOperands,
     /* 244528 */     // GIR_Coverage, 1313,
     /* 244528 */     GIR_EraseRootFromParent_Done,
     /* 244529 */   // Label 3938: @244529
     /* 244529 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(244556), // Rule ID 1318 //
     /* 244534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemRealTime),
     /* 244537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_memrealtime),
     /* 244542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 244549 */     // (intrinsic_w_chain:{ *:[i64] } 3166:{ *:[iPTR] })  =>  (S_MEMREALTIME:{ *:[i64] })
     /* 244549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMREALTIME),
     /* 244552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 244554 */     GIR_RootConstrainSelectedInstOperands,
     /* 244555 */     // GIR_Coverage, 1318,
     /* 244555 */     GIR_EraseRootFromParent_Done,
     /* 244556 */   // Label 3939: @244556
     /* 244556 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(244583), // Rule ID 1319 //
     /* 244561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGetWaveIdInst),
     /* 244564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_get_waveid_in_workgroup),
     /* 244569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 244576 */     // (intrinsic_w_chain:{ *:[i32] } 3162:{ *:[iPTR] })  =>  (S_GET_WAVEID_IN_WORKGROUP:{ *:[i32] })
     /* 244576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_GET_WAVEID_IN_WORKGROUP),
     /* 244579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 244581 */     GIR_RootConstrainSelectedInstOperands,
     /* 244582 */     // GIR_Coverage, 1319,
     /* 244582 */     GIR_EraseRootFromParent_Done,
     /* 244583 */   // Label 3940: @244583
     /* 244583 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(244611), // Rule ID 1351 //
     /* 244588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_live_mask),
     /* 244593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 244596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 244600 */     // (intrinsic_w_chain:{ *:[i1] } 3013:{ *:[iPTR] })  =>  (SI_LIVE_MASK:{ *:[i1] })
     /* 244600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_LIVE_MASK),
     /* 244603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244609 */     GIR_RootConstrainSelectedInstOperands,
     /* 244610 */     // GIR_Coverage, 1351,
     /* 244610 */     GIR_EraseRootFromParent_Done,
     /* 244611 */   // Label 3941: @244611
     /* 244611 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(244644), // Rule ID 1876 //
     /* 244616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9GFX10),
     /* 244619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_pops_exiting_wave_id),
     /* 244624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 244631 */     // (intrinsic_w_chain:{ *:[i32] } 3084:{ *:[iPTR] })  =>  (S_MOV_B32_sideeffects:{ *:[i32] } SRC_POPS_EXITING_WAVE_ID:{ *:[i32] })
     /* 244631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32_sideeffects),
     /* 244634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 244636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SRC_POPS_EXITING_WAVE_ID), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 244642 */     GIR_RootConstrainSelectedInstOperands,
     /* 244643 */     // GIR_Coverage, 1876,
     /* 244643 */     GIR_EraseRootFromParent_Done,
     /* 244644 */   // Label 3942: @244644
     /* 244644 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(244668), // Rule ID 186 //
     /* 244649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sleep_var),
     /* 244654 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 244657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 244661 */     // (intrinsic_void 3178:{ *:[iPTR] }, SSrc_b32:{ *:[i32] }:$src0)  =>  (S_SLEEP_VAR SSrc_b32:{ *:[i32] }:$src0)
     /* 244661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SLEEP_VAR),
     /* 244664 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 244666 */     GIR_RootConstrainSelectedInstOperands,
     /* 244667 */     // GIR_Coverage, 186,
     /* 244667 */     GIR_EraseRootFromParent_Done,
     /* 244668 */   // Label 3943: @244668
     /* 244668 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(244704), // Rule ID 192 //
     /* 244673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_ttracedata),
     /* 244678 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 244681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 244685 */     // (intrinsic_void 3179:{ *:[iPTR] }, M0:{ *:[i32] })  =>  (S_TTRACEDATA)
     /* 244685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 244689 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244695 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // M0
     /* 244699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_TTRACEDATA),
     /* 244702 */     GIR_RootConstrainSelectedInstOperands,
     /* 244703 */     // GIR_Coverage, 192,
     /* 244703 */     GIR_EraseRootFromParent_Done,
     /* 244704 */   // Label 3944: @244704
     /* 244704 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(244737), // Rule ID 6959 //
     /* 244709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_kill),
     /* 244714 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 244717 */     // (intrinsic_void 3008:{ *:[iPTR] }, i1:{ *:[i1] }:$src)  =>  (SI_KILL_I1_PSEUDO SCSrc_i1:{ *:[i1] }:$src, 0:{ *:[i1] })
     /* 244717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_KILL_I1_PSEUDO),
     /* 244720 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 244722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 244728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
     /* 244731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244735 */     GIR_RootConstrainSelectedInstOperands,
     /* 244736 */     // GIR_Coverage, 6959,
     /* 244736 */     GIR_EraseRootFromParent_Done,
     /* 244737 */   // Label 3945: @244737
     /* 244737 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(244770), // Rule ID 6962 //
     /* 244742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_wqm_demote),
     /* 244747 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 244750 */     // (intrinsic_void 3331:{ *:[iPTR] }, i1:{ *:[i1] }:$src)  =>  (SI_DEMOTE_I1 SCSrc_i1:{ *:[i1] }:$src, 0:{ *:[i1] })
     /* 244750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_DEMOTE_I1),
     /* 244753 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 244755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 244761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
     /* 244764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244768 */     GIR_RootConstrainSelectedInstOperands,
     /* 244769 */     // GIR_Coverage, 6962,
     /* 244769 */     GIR_EraseRootFromParent_Done,
     /* 244770 */   // Label 3946: @244770
     /* 244770 */   GIM_Reject,
     /* 244771 */ // Label 3920: @244771
     /* 244771 */ GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(245337),
     /* 244776 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 244779 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(244848), // Rule ID 3537 //
     /* 244784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 244787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
     /* 244792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 244795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 244799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 244803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 244807 */     // MIs[1] Operand 1
     /* 244807 */     // No operand predicates
     /* 244807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 244809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 244816 */     // (intrinsic_void 3169:{ *:[iPTR] }, (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), (imm:{ *:[i32] }):$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$len))
     /* 244816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 244819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 244824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 244829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 244835 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // len
     /* 244841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 244846 */     GIR_RootConstrainSelectedInstOperands,
     /* 244847 */     // GIR_Coverage, 3537,
     /* 244847 */     GIR_EraseRootFromParent_Done,
     /* 244848 */   // Label 3948: @244848
     /* 244848 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(244903), // Rule ID 3535 //
     /* 244853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 244856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
     /* 244861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 244864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 244868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 244872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 244879 */     // (intrinsic_void 3169:{ *:[iPTR] }, (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), SReg_32:{ *:[i32] }:$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$len, 0:{ *:[i8] })
     /* 244879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 244882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 244887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 244892 */     GIR_RootToRootCopy, /*OpIdx*/2, // len
     /* 244894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244901 */     GIR_RootConstrainSelectedInstOperands,
     /* 244902 */     // GIR_Coverage, 3535,
     /* 244902 */     GIR_EraseRootFromParent_Done,
     /* 244903 */   // Label 3949: @244903
     /* 244903 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(244940), // Rule ID 119 //
     /* 244908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_setreg),
     /* 244913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 244916 */     // MIs[0] simm16
     /* 244916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 244919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SIMM16bit),
     /* 244924 */     // (intrinsic_void 3176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_SIMM16bit>><<X:as_i16timm>>:$simm16, i32:{ *:[i32] }:$sdst)  =>  (S_SETREG_B32 i32:{ *:[i32] }:$sdst, (as_i16timm:{ *:[i32] } (timm:{ *:[i32] }):$simm16))
     /* 244924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SETREG_B32),
     /* 244927 */     GIR_RootToRootCopy, /*OpIdx*/2, // sdst
     /* 244929 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // simm16
     /* 244935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::MODE*/0,
     /* 244938 */     GIR_RootConstrainSelectedInstOperands,
     /* 244939 */     // GIR_Coverage, 119,
     /* 244939 */     GIR_EraseRootFromParent_Done,
     /* 244940 */   // Label 3950: @244940
     /* 244940 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(244972), // Rule ID 25 //
     /* 244945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 244948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsg_rtn),
     /* 244953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 244960 */     // MIs[0] src0
     /* 244960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 244963 */     // (intrinsic_w_chain:{ *:[i32] } 3172:{ *:[iPTR] }, (timm:{ *:[i32] }):$src0)  =>  (S_SENDMSG_RTN_B32:{ *:[i32] } (timm:{ *:[i32] }):$src0)
     /* 244963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG_RTN_B32),
     /* 244966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 244968 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 244970 */     GIR_RootConstrainSelectedInstOperands,
     /* 244971 */     // GIR_Coverage, 25,
     /* 244971 */     GIR_EraseRootFromParent_Done,
     /* 244972 */   // Label 3951: @244972
     /* 244972 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(245004), // Rule ID 26 //
     /* 244977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 244980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsg_rtn),
     /* 244985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 244992 */     // MIs[0] src0
     /* 244992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 244995 */     // (intrinsic_w_chain:{ *:[i64] } 3172:{ *:[iPTR] }, (timm:{ *:[i32] }):$src0)  =>  (S_SENDMSG_RTN_B64:{ *:[i64] } (timm:{ *:[i32] }):$src0)
     /* 244995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG_RTN_B64),
     /* 244998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 245000 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245002 */     GIR_RootConstrainSelectedInstOperands,
     /* 245003 */     // GIR_Coverage, 26,
     /* 245003 */     GIR_EraseRootFromParent_Done,
     /* 245004 */   // Label 3952: @245004
     /* 245004 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(245033), // Rule ID 118 //
     /* 245009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_getreg),
     /* 245014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 245021 */     // MIs[0] simm16
     /* 245021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 245024 */     // (intrinsic_w_chain:{ *:[i32] } 3164:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_GETREG_B32:{ *:[i32] } (timm:{ *:[i32] }):$simm16)
     /* 245024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
     /* 245027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 245029 */     GIR_RootToRootCopy, /*OpIdx*/2, // simm16
     /* 245031 */     GIR_RootConstrainSelectedInstOperands,
     /* 245032 */     // GIR_Coverage, 118,
     /* 245032 */     GIR_EraseRootFromParent_Done,
     /* 245033 */   // Label 3953: @245033
     /* 245033 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(245094), // Rule ID 3538 //
     /* 245038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 245041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
     /* 245046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245049 */     // MIs[0] sbase
     /* 245049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 245053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 245057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 245065 */     // MIs[1] Operand 1
     /* 245065 */     // No operand predicates
     /* 245065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245067 */     // (intrinsic_void 3169:{ *:[iPTR] }, SReg_64:{ *:[i64] }:$sbase, (imm:{ *:[i32] }):$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$len))
     /* 245067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 245070 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 245072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 245081 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // len
     /* 245087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245092 */     GIR_RootConstrainSelectedInstOperands,
     /* 245093 */     // GIR_Coverage, 3538,
     /* 245093 */     GIR_EraseRootFromParent_Done,
     /* 245094 */   // Label 3954: @245094
     /* 245094 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(245135), // Rule ID 188 //
     /* 245099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsg),
     /* 245104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245107 */     // MIs[0] simm16
     /* 245107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 245110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 245114 */     // (intrinsic_void 3171:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16, M0:{ *:[i32] })  =>  (S_SENDMSG (timm:{ *:[i32] }):$simm16)
     /* 245114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245118 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
     /* 245128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG),
     /* 245131 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 245133 */     GIR_RootConstrainSelectedInstOperands,
     /* 245134 */     // GIR_Coverage, 188,
     /* 245134 */     GIR_EraseRootFromParent_Done,
     /* 245135 */   // Label 3955: @245135
     /* 245135 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(245176), // Rule ID 189 //
     /* 245140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsghalt),
     /* 245145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245148 */     // MIs[0] simm16
     /* 245148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 245151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 245155 */     // (intrinsic_void 3173:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16, M0:{ *:[i32] })  =>  (S_SENDMSGHALT (timm:{ *:[i32] }):$simm16)
     /* 245155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245159 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245165 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
     /* 245169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSGHALT),
     /* 245172 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 245174 */     GIR_RootConstrainSelectedInstOperands,
     /* 245175 */     // GIR_Coverage, 189,
     /* 245175 */     GIR_EraseRootFromParent_Done,
     /* 245176 */   // Label 3956: @245176
     /* 245176 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(245231), // Rule ID 6912 //
     /* 245181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 245184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_direct_load),
     /* 245189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 245203 */     // (intrinsic_w_chain:{ *:[f32] } 3009:{ *:[iPTR] }, M0:{ *:[i32] })  =>  (LDS_DIRECT_LOAD:{ *:[f32] } 0:{ *:[i32] })
     /* 245203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245207 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
     /* 245217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::LDS_DIRECT_LOAD),
     /* 245220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245229 */     GIR_RootConstrainSelectedInstOperands,
     /* 245230 */     // GIR_Coverage, 6912,
     /* 245230 */     GIR_EraseRootFromParent_Done,
     /* 245231 */   // Label 3957: @245231
     /* 245231 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(245289), // Rule ID 6914 //
     /* 245236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 245239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_direct_load),
     /* 245244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 245258 */     // (intrinsic_w_chain:{ *:[f32] } 3009:{ *:[iPTR] }, M0:{ *:[i32] })  =>  (DS_DIRECT_LOAD:{ *:[f32] } 0:{ *:[i32] }, 1:{ *:[i32] })
     /* 245258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245262 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
     /* 245272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DIRECT_LOAD),
     /* 245275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 245283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245287 */     GIR_RootConstrainSelectedInstOperands,
     /* 245288 */     // GIR_Coverage, 6914,
     /* 245288 */     GIR_EraseRootFromParent_Done,
     /* 245289 */   // Label 3958: @245289
     /* 245289 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(245336), // Rule ID 3536 //
     /* 245294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 245297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
     /* 245302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245305 */     // MIs[0] sbase
     /* 245305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 245309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 245313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 245317 */     // (intrinsic_void 3169:{ *:[iPTR] }, SReg_64:{ *:[i64] }:$sbase, SReg_32:{ *:[i32] }:$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, ?:{ *:[i32] }:$len, 0:{ *:[i8] })
     /* 245317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 245320 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 245322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245325 */     GIR_RootToRootCopy, /*OpIdx*/2, // len
     /* 245327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245334 */     GIR_RootConstrainSelectedInstOperands,
     /* 245335 */     // GIR_Coverage, 3536,
     /* 245335 */     GIR_EraseRootFromParent_Done,
     /* 245336 */   // Label 3959: @245336
     /* 245336 */   GIM_Reject,
     /* 245337 */ // Label 3947: @245337
     /* 245337 */ GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(247499),
     /* 245342 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 245345 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(245415), // Rule ID 1321 //
     /* 245350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
     /* 245353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 245358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 245368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 245379 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_ADDR64_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 245379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_ADDR64_RTN),
     /* 245382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 245384 */     GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
     /* 245386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 245391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 245396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 245401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 245406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 245409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245413 */     GIR_RootConstrainSelectedInstOperands,
     /* 245414 */     // GIR_Coverage, 1321,
     /* 245414 */     GIR_EraseRootFromParent_Done,
     /* 245415 */   // Label 3961: @245415
     /* 245415 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(245485), // Rule ID 1323 //
     /* 245420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
     /* 245423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 245428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 245438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 245449 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_VBUFFER_ADDR64_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 245449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_VBUFFER_ADDR64_RTN),
     /* 245452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 245454 */     GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
     /* 245456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 245461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 245466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 245471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 245476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 245479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245483 */     GIR_RootConstrainSelectedInstOperands,
     /* 245484 */     // GIR_Coverage, 1323,
     /* 245484 */     GIR_EraseRootFromParent_Done,
     /* 245485 */   // Label 3962: @245485
     /* 245485 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(245550), // Rule ID 1320 //
     /* 245490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
     /* 245493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 245498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 245508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 245519 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_OFFSET_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 245519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_OFFSET_RTN),
     /* 245522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 245524 */     GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
     /* 245526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 245531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 245536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 245541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 245544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245548 */     GIR_RootConstrainSelectedInstOperands,
     /* 245549 */     // GIR_Coverage, 1320,
     /* 245549 */     GIR_EraseRootFromParent_Done,
     /* 245550 */   // Label 3963: @245550
     /* 245550 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(245615), // Rule ID 1322 //
     /* 245555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
     /* 245558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 245563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 245573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 245584 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_VBUFFER_OFFSET_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 245584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_VBUFFER_OFFSET_RTN),
     /* 245587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 245589 */     GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
     /* 245591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 245596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 245601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 245606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 245609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245613 */     GIR_RootConstrainSelectedInstOperands,
     /* 245614 */     // GIR_Coverage, 1322,
     /* 245614 */     GIR_EraseRootFromParent_Done,
     /* 245615 */   // Label 3964: @245615
     /* 245615 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(245676), // Rule ID 7786 //
     /* 245620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
     /* 245623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 245628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245634 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 245639 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 245641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 245652 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_local_addrspace>>  =>  (DS_COND_SUB_U32 ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 245652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_COND_SUB_U32),
     /* 245655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 245660 */     GIR_RootToRootCopy, /*OpIdx*/3, // value
     /* 245662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 245667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245674 */     GIR_RootConstrainSelectedInstOperands,
     /* 245675 */     // GIR_Coverage, 7786,
     /* 245675 */     GIR_EraseRootFromParent_Done,
     /* 245676 */   // Label 3965: @245676
     /* 245676 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(245741), // Rule ID 7785 //
     /* 245681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 245684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 245689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245695 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 245700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 245704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 245715 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_local_addrspace>>  =>  (DS_COND_SUB_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9820:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 245715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_COND_SUB_RTN_U32),
     /* 245718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 245725 */     GIR_RootToRootCopy, /*OpIdx*/3, // value
     /* 245727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 245732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245739 */     GIR_RootConstrainSelectedInstOperands,
     /* 245740 */     // GIR_Coverage, 7785,
     /* 245740 */     GIR_EraseRootFromParent_Done,
     /* 245741 */   // Label 3966: @245741
     /* 245741 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(245809), // Rule ID 4116 //
     /* 245746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
     /* 245749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 245754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245760 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 245767 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 245769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 245780 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 245780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32_SADDR),
     /* 245783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 245788 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 245790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 245795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 245800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245807 */     GIR_RootConstrainSelectedInstOperands,
     /* 245808 */     // GIR_Coverage, 4116,
     /* 245808 */     GIR_EraseRootFromParent_Done,
     /* 245809 */   // Label 3967: @245809
     /* 245809 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(245870), // Rule ID 4060 //
     /* 245814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 245817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 245822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245828 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 245830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 245841 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_csub_noret>>  =>  (GLOBAL_ATOMIC_CSUB_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 245841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB_SADDR),
     /* 245844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 245849 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 245851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 245856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 245861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245868 */     GIR_RootConstrainSelectedInstOperands,
     /* 245869 */     // GIR_Coverage, 4060,
     /* 245869 */     GIR_EraseRootFromParent_Done,
     /* 245870 */   // Label 3968: @245870
     /* 245870 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(245931), // Rule ID 4144 //
     /* 245875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 245878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
     /* 245883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245889 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 245891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 245902 */     // (intrinsic_w_chain:{ *:[f32] } 2217:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmin_num_noret>>  =>  (GLOBAL_ATOMIC_FMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 245902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR),
     /* 245905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 245910 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 245912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 245917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 245922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245929 */     GIR_RootConstrainSelectedInstOperands,
     /* 245930 */     // GIR_Coverage, 4144,
     /* 245930 */     GIR_EraseRootFromParent_Done,
     /* 245931 */   // Label 3969: @245931
     /* 245931 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(245992), // Rule ID 4148 //
     /* 245936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 245939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
     /* 245944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245950 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 245952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 245956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 245963 */     // (intrinsic_w_chain:{ *:[f32] } 2216:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmax_num_noret>>  =>  (GLOBAL_ATOMIC_FMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 245963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR),
     /* 245966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 245971 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 245973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 245978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 245983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245990 */     GIR_RootConstrainSelectedInstOperands,
     /* 245991 */     // GIR_Coverage, 4148,
     /* 245991 */     GIR_EraseRootFromParent_Done,
     /* 245992 */   // Label 3970: @245992
     /* 245992 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(246064), // Rule ID 4114 //
     /* 245997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_isGFX12Plus),
     /* 246000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 246005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246011 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 246018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246033 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32_SADDR_RTN),
     /* 246036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246043 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246062 */     GIR_RootConstrainSelectedInstOperands,
     /* 246063 */     // GIR_Coverage, 4114,
     /* 246063 */     GIR_EraseRootFromParent_Done,
     /* 246064 */   // Label 3971: @246064
     /* 246064 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(246129), // Rule ID 4058 //
     /* 246069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 246072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 246077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246098 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)  =>  (GLOBAL_ATOMIC_CSUB_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB_SADDR_RTN),
     /* 246101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246108 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246127 */     GIR_RootConstrainSelectedInstOperands,
     /* 246128 */     // GIR_Coverage, 4058,
     /* 246128 */     GIR_EraseRootFromParent_Done,
     /* 246129 */   // Label 3972: @246129
     /* 246129 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(246194), // Rule ID 4118 //
     /* 246134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 246137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_ordered_add_b64),
     /* 246142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 246148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 246152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246163 */     // (intrinsic_w_chain:{ *:[i64] } 2218:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)  =>  (GLOBAL_ATOMIC_ORDERED_ADD_B64_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ORDERED_ADD_B64_SADDR_RTN),
     /* 246166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246173 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246192 */     GIR_RootConstrainSelectedInstOperands,
     /* 246193 */     // GIR_Coverage, 4118,
     /* 246193 */     GIR_EraseRootFromParent_Done,
     /* 246194 */   // Label 3973: @246194
     /* 246194 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(246259), // Rule ID 4146 //
     /* 246199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 246202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
     /* 246207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246228 */     // (intrinsic_w_chain:{ *:[f32] } 2217:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMIN_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR_RTN),
     /* 246231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246238 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246257 */     GIR_RootConstrainSelectedInstOperands,
     /* 246258 */     // GIR_Coverage, 4146,
     /* 246258 */     GIR_EraseRootFromParent_Done,
     /* 246259 */   // Label 3974: @246259
     /* 246259 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(246324), // Rule ID 4150 //
     /* 246264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 246267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
     /* 246272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 246293 */     // (intrinsic_w_chain:{ *:[f32] } 2216:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMAX_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 246293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR_RTN),
     /* 246296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 246303 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 246310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 246315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246322 */     GIR_RootConstrainSelectedInstOperands,
     /* 246323 */     // GIR_Coverage, 4150,
     /* 246323 */     GIR_EraseRootFromParent_Done,
     /* 246324 */   // Label 3975: @246324
     /* 246324 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(246387), // Rule ID 4115 //
     /* 246329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
     /* 246332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 246337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246343 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 246350 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 246352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246363 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32),
     /* 246366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246371 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246385 */     GIR_RootConstrainSelectedInstOperands,
     /* 246386 */     // GIR_Coverage, 4115,
     /* 246386 */     GIR_EraseRootFromParent_Done,
     /* 246387 */   // Label 3976: @246387
     /* 246387 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(246443), // Rule ID 4059 //
     /* 246392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 246395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 246400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246406 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 246408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246419 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_csub_noret>>  =>  (GLOBAL_ATOMIC_CSUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB),
     /* 246422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246427 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246441 */     GIR_RootConstrainSelectedInstOperands,
     /* 246442 */     // GIR_Coverage, 4059,
     /* 246442 */     GIR_EraseRootFromParent_Done,
     /* 246443 */   // Label 3977: @246443
     /* 246443 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(246499), // Rule ID 4143 //
     /* 246448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 246451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
     /* 246456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246462 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 246464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246475 */     // (intrinsic_w_chain:{ *:[f32] } 2217:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmin_num_noret>>  =>  (GLOBAL_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN),
     /* 246478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246483 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246497 */     GIR_RootConstrainSelectedInstOperands,
     /* 246498 */     // GIR_Coverage, 4143,
     /* 246498 */     GIR_EraseRootFromParent_Done,
     /* 246499 */   // Label 3978: @246499
     /* 246499 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(246555), // Rule ID 4147 //
     /* 246504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 246507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
     /* 246512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246518 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 246520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246531 */     // (intrinsic_w_chain:{ *:[f32] } 2216:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmax_num_noret>>  =>  (GLOBAL_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX),
     /* 246534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246539 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246553 */     GIR_RootConstrainSelectedInstOperands,
     /* 246554 */     // GIR_Coverage, 4147,
     /* 246554 */     GIR_EraseRootFromParent_Done,
     /* 246555 */   // Label 3979: @246555
     /* 246555 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(246622), // Rule ID 4113 //
     /* 246560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_isGFX12Plus),
     /* 246563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 246568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246574 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 246581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246596 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32_RTN),
     /* 246599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246606 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246620 */     GIR_RootConstrainSelectedInstOperands,
     /* 246621 */     // GIR_Coverage, 4113,
     /* 246621 */     GIR_EraseRootFromParent_Done,
     /* 246622 */   // Label 3980: @246622
     /* 246622 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(246682), // Rule ID 4057 //
     /* 246627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 246630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 246635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246656 */     // (intrinsic_w_chain:{ *:[i32] } 2215:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)  =>  (GLOBAL_ATOMIC_CSUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB_RTN),
     /* 246659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246666 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246680 */     GIR_RootConstrainSelectedInstOperands,
     /* 246681 */     // GIR_Coverage, 4057,
     /* 246681 */     GIR_EraseRootFromParent_Done,
     /* 246682 */   // Label 3981: @246682
     /* 246682 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(246742), // Rule ID 4117 //
     /* 246687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 246690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_ordered_add_b64),
     /* 246695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 246701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 246705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246716 */     // (intrinsic_w_chain:{ *:[i64] } 2218:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)  =>  (GLOBAL_ATOMIC_ORDERED_ADD_B64_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 246716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ORDERED_ADD_B64_RTN),
     /* 246719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246726 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246740 */     GIR_RootConstrainSelectedInstOperands,
     /* 246741 */     // GIR_Coverage, 4117,
     /* 246741 */     GIR_EraseRootFromParent_Done,
     /* 246742 */   // Label 3982: @246742
     /* 246742 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(246802), // Rule ID 4145 //
     /* 246747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 246750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
     /* 246755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246776 */     // (intrinsic_w_chain:{ *:[f32] } 2217:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_RTN),
     /* 246779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246786 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246800 */     GIR_RootConstrainSelectedInstOperands,
     /* 246801 */     // GIR_Coverage, 4145,
     /* 246801 */     GIR_EraseRootFromParent_Done,
     /* 246802 */   // Label 3983: @246802
     /* 246802 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(246862), // Rule ID 4149 //
     /* 246807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 246810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
     /* 246815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 246825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 246829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 246836 */     // (intrinsic_w_chain:{ *:[f32] } 2216:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 246836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_RTN),
     /* 246839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 246846 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 246848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 246853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 246856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246860 */     GIR_RootConstrainSelectedInstOperands,
     /* 246861 */     // GIR_Coverage, 4149,
     /* 246861 */     GIR_EraseRootFromParent_Done,
     /* 246862 */   // Label 3984: @246862
     /* 246862 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(246904), // Rule ID 8323 //
     /* 246867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_add_gs_reg_rtn),
     /* 246872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 246878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 246882 */     // MIs[0] offset32
     /* 246882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246885 */     // (intrinsic_w_chain:{ *:[i64] } 2168:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (DS_ADD_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32))
     /* 246885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_GS_REG_RTN),
     /* 246888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246890 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 246892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
     /* 246898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246902 */     GIR_RootConstrainSelectedInstOperands,
     /* 246903 */     // GIR_Coverage, 8323,
     /* 246903 */     GIR_EraseRootFromParent_Done,
     /* 246904 */   // Label 3985: @246904
     /* 246904 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(246998), // Rule ID 8324 //
     /* 246909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_add_gs_reg_rtn),
     /* 246914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 246920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246924 */     // MIs[0] offset32
     /* 246924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246927 */     // (intrinsic_w_chain:{ *:[i32] } 2168:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i64] } (DS_ADD_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32)), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 246927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 246930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_GS_REG_RTN),
     /* 246934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src
     /* 246943 */     GIR_CustomOperandRenderer, /*InsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
     /* 246949 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 246955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 246958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246967 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 246970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 246975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 246980 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 246987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 246997 */     // GIR_Coverage, 8324,
     /* 246997 */     GIR_EraseRootFromParent_Done,
     /* 246998 */   // Label 3986: @246998
     /* 246998 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(247040), // Rule ID 8325 //
     /* 247003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_sub_gs_reg_rtn),
     /* 247008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 247011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 247018 */     // MIs[0] offset32
     /* 247018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 247021 */     // (intrinsic_w_chain:{ *:[i64] } 2190:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (DS_SUB_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32))
     /* 247021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_GS_REG_RTN),
     /* 247024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 247028 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
     /* 247034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247038 */     GIR_RootConstrainSelectedInstOperands,
     /* 247039 */     // GIR_Coverage, 8325,
     /* 247039 */     GIR_EraseRootFromParent_Done,
     /* 247040 */   // Label 3987: @247040
     /* 247040 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(247134), // Rule ID 8326 //
     /* 247045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_sub_gs_reg_rtn),
     /* 247050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247060 */     // MIs[0] offset32
     /* 247060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 247063 */     // (intrinsic_w_chain:{ *:[i32] } 2190:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i64] } (DS_SUB_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32)), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 247063 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 247066 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_GS_REG_RTN),
     /* 247070 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247075 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src
     /* 247079 */     GIR_CustomOperandRenderer, /*InsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
     /* 247085 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 247091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 247094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247103 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 247106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 247111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 247116 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 247123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 247133 */     // GIR_Coverage, 8326,
     /* 247133 */     GIR_EraseRootFromParent_Done,
     /* 247134 */   // Label 3988: @247134
     /* 247134 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(247198), // Rule ID 3784 //
     /* 247139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
     /* 247142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 247147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247153 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 247161 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 247163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 247174 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_flat_addrspace>>  =>  (FLAT_ATOMIC_COND_SUB_U32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_COND_SUB_U32),
     /* 247177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247182 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247196 */     GIR_RootConstrainSelectedInstOperands,
     /* 247197 */     // GIR_Coverage, 3784,
     /* 247197 */     GIR_EraseRootFromParent_Done,
     /* 247198 */   // Label 3989: @247198
     /* 247198 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(247254), // Rule ID 4152 //
     /* 247203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 247206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmin_num),
     /* 247211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247217 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 247219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 247230 */     // (intrinsic_w_chain:{ *:[f32] } 2207:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_flat_atomic_fmin_num_noret>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
     /* 247233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247238 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247252 */     GIR_RootConstrainSelectedInstOperands,
     /* 247253 */     // GIR_Coverage, 4152,
     /* 247253 */     GIR_EraseRootFromParent_Done,
     /* 247254 */   // Label 3990: @247254
     /* 247254 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(247310), // Rule ID 4154 //
     /* 247259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 247262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmax_num),
     /* 247267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247273 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 247275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 247286 */     // (intrinsic_w_chain:{ *:[f32] } 2206:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_flat_atomic_fmax_num_noret>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
     /* 247289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247294 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247308 */     GIR_RootConstrainSelectedInstOperands,
     /* 247309 */     // GIR_Coverage, 4154,
     /* 247309 */     GIR_EraseRootFromParent_Done,
     /* 247310 */   // Label 3991: @247310
     /* 247310 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(247378), // Rule ID 3783 //
     /* 247315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_isGFX12Plus),
     /* 247318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 247323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247329 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 247337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 247341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 247352 */     // (intrinsic_w_chain:{ *:[i32] } 2080:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_flat_addrspace>>  =>  (FLAT_ATOMIC_COND_SUB_U32_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_COND_SUB_U32_RTN),
     /* 247355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247362 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247376 */     GIR_RootConstrainSelectedInstOperands,
     /* 247377 */     // GIR_Coverage, 3783,
     /* 247377 */     GIR_EraseRootFromParent_Done,
     /* 247378 */   // Label 3992: @247378
     /* 247378 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(247438), // Rule ID 4151 //
     /* 247383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 247386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmin_num),
     /* 247391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 247401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 247412 */     // (intrinsic_w_chain:{ *:[f32] } 2207:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
     /* 247415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247422 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247436 */     GIR_RootConstrainSelectedInstOperands,
     /* 247437 */     // GIR_Coverage, 4151,
     /* 247437 */     GIR_EraseRootFromParent_Done,
     /* 247438 */   // Label 3993: @247438
     /* 247438 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(247498), // Rule ID 4153 //
     /* 247443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 247446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmax_num),
     /* 247451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 247461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 247465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 247472 */     // (intrinsic_w_chain:{ *:[f32] } 2206:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9820:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 247472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
     /* 247475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 247482 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 247484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 247489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247496 */     GIR_RootConstrainSelectedInstOperands,
     /* 247497 */     // GIR_Coverage, 4153,
     /* 247497 */     GIR_EraseRootFromParent_Done,
     /* 247498 */   // Label 3994: @247498
     /* 247498 */   GIM_Reject,
     /* 247499 */ // Label 3960: @247499
     /* 247499 */ GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(247833),
     /* 247504 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 247507 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_compr),
     /* 247512 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 247515 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s16,
     /* 247518 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 247521 */   GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 247524 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247528 */   GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247532 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(247607), // Rule ID 6908 //
     /* 247537 */     // MIs[0] Operand 5
     /* 247537 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 247548 */     // MIs[0] vm
     /* 247548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247551 */     // (intrinsic_void 2196:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 247551 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 247554 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 247558 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 247565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 247568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 247572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 247579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
     /* 247582 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 247584 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247586 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 247591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 247594 */     GIR_RootToRootCopy, /*OpIdx*/6, // vm
     /* 247596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247599 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 247601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247605 */     GIR_RootConstrainSelectedInstOperands,
     /* 247606 */     // GIR_Coverage, 6908,
     /* 247606 */     GIR_EraseRootFromParent_Done,
     /* 247607 */   // Label 3996: @247607
     /* 247607 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(247682), // Rule ID 6909 //
     /* 247612 */     // MIs[0] Operand 5
     /* 247612 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 247623 */     // MIs[0] vm
     /* 247623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247626 */     // (intrinsic_void 2196:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 247626 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 247629 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 247633 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 247640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 247643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 247647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 247654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
     /* 247657 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 247659 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247661 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 247666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 247669 */     GIR_RootToRootCopy, /*OpIdx*/6, // vm
     /* 247671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247674 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 247676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247680 */     GIR_RootConstrainSelectedInstOperands,
     /* 247681 */     // GIR_Coverage, 6909,
     /* 247681 */     GIR_EraseRootFromParent_Done,
     /* 247682 */   // Label 3997: @247682
     /* 247682 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(247757), // Rule ID 6910 //
     /* 247687 */     // MIs[0] Operand 5
     /* 247687 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 247698 */     // MIs[0] vm
     /* 247698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247701 */     // (intrinsic_void 2196:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 247701 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 247704 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 247708 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 247715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 247718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 247722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 247729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
     /* 247732 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 247734 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247736 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 247741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 247744 */     GIR_RootToRootCopy, /*OpIdx*/6, // vm
     /* 247746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247749 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 247751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247755 */     GIR_RootConstrainSelectedInstOperands,
     /* 247756 */     // GIR_Coverage, 6910,
     /* 247756 */     GIR_EraseRootFromParent_Done,
     /* 247757 */   // Label 3998: @247757
     /* 247757 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(247832), // Rule ID 6911 //
     /* 247762 */     // MIs[0] Operand 5
     /* 247762 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 247773 */     // MIs[0] vm
     /* 247773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247776 */     // (intrinsic_void 2196:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 247776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 247779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 247783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 247790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 247793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 247797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 247804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
     /* 247807 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 247809 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247811 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 247816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 247819 */     GIR_RootToRootCopy, /*OpIdx*/6, // vm
     /* 247821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 247824 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 247826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247830 */     GIR_RootConstrainSelectedInstOperands,
     /* 247831 */     // GIR_Coverage, 6911,
     /* 247831 */     GIR_EraseRootFromParent_Done,
     /* 247832 */   // Label 3999: @247832
     /* 247832 */   GIM_Reject,
     /* 247833 */ // Label 3995: @247833
     /* 247833 */ GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(248590),
     /* 247838 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 247841 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(247925), // Rule ID 6900 //
     /* 247846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
     /* 247851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 247860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 247863 */     // MIs[0] tgt
     /* 247863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 247866 */     // MIs[0] en
     /* 247866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 247869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247881 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247885 */     // MIs[0] Operand 7
     /* 247885 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 247896 */     // MIs[0] vm
     /* 247896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 247899 */     // (intrinsic_void 2195:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 247899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
     /* 247902 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 247904 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247906 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247908 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 247910 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 247912 */     GIR_RootToRootCopy, /*OpIdx*/8, // vm
     /* 247914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247917 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 247919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247923 */     GIR_RootConstrainSelectedInstOperands,
     /* 247924 */     // GIR_Coverage, 6900,
     /* 247924 */     GIR_EraseRootFromParent_Done,
     /* 247925 */   // Label 4001: @247925
     /* 247925 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(248009), // Rule ID 6901 //
     /* 247930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
     /* 247935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 247944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 247947 */     // MIs[0] tgt
     /* 247947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 247950 */     // MIs[0] en
     /* 247950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 247953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247965 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247969 */     // MIs[0] Operand 7
     /* 247969 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
     /* 247980 */     // MIs[0] vm
     /* 247980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 247983 */     // (intrinsic_void 2195:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 247983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
     /* 247986 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 247988 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247990 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247992 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 247994 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 247996 */     GIR_RootToRootCopy, /*OpIdx*/8, // vm
     /* 247998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248001 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248007 */     GIR_RootConstrainSelectedInstOperands,
     /* 248008 */     // GIR_Coverage, 6901,
     /* 248008 */     GIR_EraseRootFromParent_Done,
     /* 248009 */   // Label 4002: @248009
     /* 248009 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(248093), // Rule ID 6902 //
     /* 248014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
     /* 248019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248031 */     // MIs[0] tgt
     /* 248031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248034 */     // MIs[0] en
     /* 248034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248049 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248053 */     // MIs[0] Operand 7
     /* 248053 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 248064 */     // MIs[0] vm
     /* 248064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 248067 */     // (intrinsic_void 2195:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
     /* 248070 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248072 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248074 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248076 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248078 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248080 */     GIR_RootToRootCopy, /*OpIdx*/8, // vm
     /* 248082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248085 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248091 */     GIR_RootConstrainSelectedInstOperands,
     /* 248092 */     // GIR_Coverage, 6902,
     /* 248092 */     GIR_EraseRootFromParent_Done,
     /* 248093 */   // Label 4003: @248093
     /* 248093 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(248177), // Rule ID 6903 //
     /* 248098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
     /* 248103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248115 */     // MIs[0] tgt
     /* 248115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248118 */     // MIs[0] en
     /* 248118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248133 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248137 */     // MIs[0] Operand 7
     /* 248137 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
     /* 248148 */     // MIs[0] vm
     /* 248148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 248151 */     // (intrinsic_void 2195:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
     /* 248154 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248156 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248158 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248160 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248162 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248164 */     GIR_RootToRootCopy, /*OpIdx*/8, // vm
     /* 248166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248169 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248175 */     GIR_RootConstrainSelectedInstOperands,
     /* 248176 */     // GIR_Coverage, 6903,
     /* 248176 */     GIR_EraseRootFromParent_Done,
     /* 248177 */   // Label 4004: @248177
     /* 248177 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(248280), // Rule ID 6904 //
     /* 248182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
     /* 248187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248199 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 248202 */     // MIs[0] tgt
     /* 248202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248205 */     // MIs[0] en
     /* 248205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248220 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248224 */     // MIs[0] Operand 7
     /* 248224 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 248235 */     GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 248239 */     // (intrinsic_void 2197:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248243 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
     /* 248253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW),
     /* 248256 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248258 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248260 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248262 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248264 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248272 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248278 */     GIR_RootConstrainSelectedInstOperands,
     /* 248279 */     // GIR_Coverage, 6904,
     /* 248279 */     GIR_EraseRootFromParent_Done,
     /* 248280 */   // Label 4005: @248280
     /* 248280 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(248383), // Rule ID 6905 //
     /* 248285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
     /* 248290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248302 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 248305 */     // MIs[0] tgt
     /* 248305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248308 */     // MIs[0] en
     /* 248308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248323 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248327 */     // MIs[0] Operand 7
     /* 248327 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
     /* 248338 */     GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 248342 */     // (intrinsic_void 2197:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, -1:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248346 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248352 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
     /* 248356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW_DONE),
     /* 248359 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248361 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248363 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248365 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248367 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248375 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248381 */     GIR_RootConstrainSelectedInstOperands,
     /* 248382 */     // GIR_Coverage, 6905,
     /* 248382 */     GIR_EraseRootFromParent_Done,
     /* 248383 */   // Label 4006: @248383
     /* 248383 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(248486), // Rule ID 6906 //
     /* 248388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
     /* 248393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248405 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 248408 */     // MIs[0] tgt
     /* 248408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248411 */     // MIs[0] en
     /* 248411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248426 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248430 */     // MIs[0] Operand 7
     /* 248430 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 248441 */     GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 248445 */     // (intrinsic_void 2197:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248449 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
     /* 248459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW),
     /* 248462 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248464 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248466 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248468 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248470 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248478 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248484 */     GIR_RootConstrainSelectedInstOperands,
     /* 248485 */     // GIR_Coverage, 6906,
     /* 248485 */     GIR_EraseRootFromParent_Done,
     /* 248486 */   // Label 4007: @248486
     /* 248486 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(248589), // Rule ID 6907 //
     /* 248491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
     /* 248496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 248502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248508 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 248511 */     // MIs[0] tgt
     /* 248511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248514 */     // MIs[0] en
     /* 248514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 248517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248529 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248533 */     // MIs[0] Operand 7
     /* 248533 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
     /* 248544 */     GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 248548 */     // (intrinsic_void 2197:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, -1:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 248548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248552 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248558 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
     /* 248562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW_DONE),
     /* 248565 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 248567 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248569 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 248571 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 248573 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 248575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248581 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 248583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248587 */     GIR_RootConstrainSelectedInstOperands,
     /* 248588 */     // GIR_Coverage, 6907,
     /* 248588 */     GIR_EraseRootFromParent_Done,
     /* 248589 */   // Label 4008: @248589
     /* 248589 */   GIM_Reject,
     /* 248590 */ // Label 4000: @248590
     /* 248590 */ GIM_Reject,
     /* 248591 */ // Label 38: @248591
     /* 248591 */ GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(249391),
     /* 248596 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 248599 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(248638), // Rule ID 7560 //
     /* 248604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 248609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 248615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 248619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 248623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 248627 */     // MIs[1] Operand 1
     /* 248627 */     // No operand predicates
     /* 248627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248629 */     // (intrinsic_wo_chain:{ *:[i32] } 3141:{ *:[iPTR] }, (imm:{ *:[i32] }):$src)  =>  (S_MOV_B32:{ *:[i32] } SReg_32:{ *:[i32] }:$src)
     /* 248629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 248632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 248634 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 248636 */     GIR_RootConstrainSelectedInstOperands,
     /* 248637 */     // GIR_Coverage, 7560,
     /* 248637 */     GIR_EraseRootFromParent_Done,
     /* 248638 */   // Label 4010: @248638
     /* 248638 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(248671), // Rule ID 2381 //
     /* 248643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 248648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 248654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 248658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 248662 */     // (intrinsic_wo_chain:{ *:[i32] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 248662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 248665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248667 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 248669 */     GIR_RootConstrainSelectedInstOperands,
     /* 248670 */     // GIR_Coverage, 2381,
     /* 248670 */     GIR_EraseRootFromParent_Done,
     /* 248671 */   // Label 4011: @248671
     /* 248671 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(248704), // Rule ID 2382 //
     /* 248676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 248681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 248687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 248691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 248695 */     // (intrinsic_wo_chain:{ *:[f32] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[f32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[f32] } VRegOrLdsSrc_32:{ *:[f32] }:$src0)
     /* 248695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 248698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248700 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 248702 */     GIR_RootConstrainSelectedInstOperands,
     /* 248703 */     // GIR_Coverage, 2382,
     /* 248703 */     GIR_EraseRootFromParent_Done,
     /* 248704 */   // Label 4012: @248704
     /* 248704 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(248737), // Rule ID 2383 //
     /* 248709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 248714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 248717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 248720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 248724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 248728 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[v2i16] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[v2i16] } VRegOrLdsSrc_32:{ *:[v2i16] }:$src0)
     /* 248728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 248731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248733 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 248735 */     GIR_RootConstrainSelectedInstOperands,
     /* 248736 */     // GIR_Coverage, 2383,
     /* 248736 */     GIR_EraseRootFromParent_Done,
     /* 248737 */   // Label 4013: @248737
     /* 248737 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(248770), // Rule ID 2384 //
     /* 248742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 248747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 248750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 248753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 248757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 248761 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[v2f16] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[v2f16] } VRegOrLdsSrc_32:{ *:[v2f16] }:$src0)
     /* 248761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 248764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248766 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 248768 */     GIR_RootConstrainSelectedInstOperands,
     /* 248769 */     // GIR_Coverage, 2384,
     /* 248769 */     GIR_EraseRootFromParent_Done,
     /* 248770 */   // Label 4014: @248770
     /* 248770 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(248803), // Rule ID 2385 //
     /* 248775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 248780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 248783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 248786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 248790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 248794 */     // (intrinsic_wo_chain:{ *:[i32] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 248794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 248797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248799 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 248801 */     GIR_RootConstrainSelectedInstOperands,
     /* 248802 */     // GIR_Coverage, 2385,
     /* 248802 */     GIR_EraseRootFromParent_Done,
     /* 248803 */   // Label 4015: @248803
     /* 248803 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(248836), // Rule ID 2386 //
     /* 248808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 248813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 248816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 248819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 248823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 248827 */     // (intrinsic_wo_chain:{ *:[i32] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 248827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 248830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248832 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 248834 */     GIR_RootConstrainSelectedInstOperands,
     /* 248835 */     // GIR_Coverage, 2386,
     /* 248835 */     GIR_EraseRootFromParent_Done,
     /* 248836 */   // Label 4016: @248836
     /* 248836 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(248869), // Rule ID 2387 //
     /* 248841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 248846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 248849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 248852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 248856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 248860 */     // (intrinsic_wo_chain:{ *:[i32] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 248860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 248863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 248867 */     GIR_RootConstrainSelectedInstOperands,
     /* 248868 */     // GIR_Coverage, 2387,
     /* 248868 */     GIR_EraseRootFromParent_Done,
     /* 248869 */   // Label 4017: @248869
     /* 248869 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(248902), // Rule ID 2388 //
     /* 248874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 248879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 248882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 248885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 248889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 248893 */     // (intrinsic_wo_chain:{ *:[i32] } 3141:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 248893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 248896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248898 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 248900 */     GIR_RootConstrainSelectedInstOperands,
     /* 248901 */     // GIR_Coverage, 2388,
     /* 248901 */     GIR_EraseRootFromParent_Done,
     /* 248902 */   // Label 4018: @248902
     /* 248902 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(248935), // Rule ID 2415 //
     /* 248907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 248912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 248918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248926 */     // (intrinsic_wo_chain:{ *:[i32] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 248926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 248929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248931 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 248933 */     GIR_RootConstrainSelectedInstOperands,
     /* 248934 */     // GIR_Coverage, 2415,
     /* 248934 */     GIR_EraseRootFromParent_Done,
     /* 248935 */   // Label 4019: @248935
     /* 248935 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(248968), // Rule ID 2416 //
     /* 248940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 248945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 248951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248959 */     // (intrinsic_wo_chain:{ *:[f32] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[f32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[f32] } VRegSrc_32:{ *:[f32] }:$src0)
     /* 248959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 248962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248964 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 248966 */     GIR_RootConstrainSelectedInstOperands,
     /* 248967 */     // GIR_Coverage, 2416,
     /* 248967 */     GIR_EraseRootFromParent_Done,
     /* 248968 */   // Label 4020: @248968
     /* 248968 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(249001), // Rule ID 2417 //
     /* 248973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 248978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 248981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 248984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248992 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[v2i16] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[v2i16] } VRegSrc_32:{ *:[v2i16] }:$src0)
     /* 248992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 248995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248997 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 248999 */     GIR_RootConstrainSelectedInstOperands,
     /* 249000 */     // GIR_Coverage, 2417,
     /* 249000 */     GIR_EraseRootFromParent_Done,
     /* 249001 */   // Label 4021: @249001
     /* 249001 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(249034), // Rule ID 2418 //
     /* 249006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 249011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 249014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 249017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249025 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[v2f16] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[v2f16] } VRegSrc_32:{ *:[v2f16] }:$src0)
     /* 249025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 249028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249030 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249032 */     GIR_RootConstrainSelectedInstOperands,
     /* 249033 */     // GIR_Coverage, 2418,
     /* 249033 */     GIR_EraseRootFromParent_Done,
     /* 249034 */   // Label 4022: @249034
     /* 249034 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(249067), // Rule ID 2419 //
     /* 249039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 249044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 249050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249058 */     // (intrinsic_wo_chain:{ *:[i32] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 249058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 249061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249063 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249065 */     GIR_RootConstrainSelectedInstOperands,
     /* 249066 */     // GIR_Coverage, 2419,
     /* 249066 */     GIR_EraseRootFromParent_Done,
     /* 249067 */   // Label 4023: @249067
     /* 249067 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(249100), // Rule ID 2420 //
     /* 249072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 249077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 249083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249091 */     // (intrinsic_wo_chain:{ *:[i32] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 249091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 249094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249098 */     GIR_RootConstrainSelectedInstOperands,
     /* 249099 */     // GIR_Coverage, 2420,
     /* 249099 */     GIR_EraseRootFromParent_Done,
     /* 249100 */   // Label 4024: @249100
     /* 249100 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(249133), // Rule ID 2421 //
     /* 249105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 249110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 249116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249124 */     // (intrinsic_wo_chain:{ *:[i32] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 249124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 249127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249129 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249131 */     GIR_RootConstrainSelectedInstOperands,
     /* 249132 */     // GIR_Coverage, 2421,
     /* 249132 */     GIR_EraseRootFromParent_Done,
     /* 249133 */   // Label 4025: @249133
     /* 249133 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(249166), // Rule ID 2422 //
     /* 249138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 249143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 249149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249157 */     // (intrinsic_wo_chain:{ *:[i32] } 3081:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 249157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 249160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249164 */     GIR_RootConstrainSelectedInstOperands,
     /* 249165 */     // GIR_Coverage, 2422,
     /* 249165 */     GIR_EraseRootFromParent_Done,
     /* 249166 */   // Label 4026: @249166
     /* 249166 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(249198), // Rule ID 2 //
     /* 249171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_wqm),
     /* 249176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 249186 */     // (intrinsic_wo_chain:{ *:[i32] } 3190:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)  =>  (S_WQM_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
     /* 249186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B32),
     /* 249189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249191 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 249196 */     GIR_RootConstrainSelectedInstOperands,
     /* 249197 */     // GIR_Coverage, 2,
     /* 249197 */     GIR_EraseRootFromParent_Done,
     /* 249198 */   // Label 4027: @249198
     /* 249198 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(249230), // Rule ID 3 //
     /* 249203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_wqm),
     /* 249208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 249218 */     // (intrinsic_wo_chain:{ *:[i64] } 3190:{ *:[iPTR] }, i64:{ *:[i64] }:$src0)  =>  (S_WQM_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0)
     /* 249218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B64),
     /* 249221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249223 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 249228 */     GIR_RootConstrainSelectedInstOperands,
     /* 249229 */     // GIR_Coverage, 3,
     /* 249229 */     GIR_EraseRootFromParent_Done,
     /* 249230 */   // Label 4028: @249230
     /* 249230 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(249259), // Rule ID 21 //
     /* 249235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_quadmask),
     /* 249240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 249250 */     // (intrinsic_wo_chain:{ *:[i32] } 3170:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)  =>  (S_QUADMASK_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 249250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_QUADMASK_B32),
     /* 249253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249255 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249257 */     GIR_RootConstrainSelectedInstOperands,
     /* 249258 */     // GIR_Coverage, 21,
     /* 249258 */     GIR_EraseRootFromParent_Done,
     /* 249259 */   // Label 4029: @249259
     /* 249259 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(249288), // Rule ID 22 //
     /* 249264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_quadmask),
     /* 249269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 249279 */     // (intrinsic_wo_chain:{ *:[i64] } 3170:{ *:[iPTR] }, i64:{ *:[i64] }:$src0)  =>  (S_QUADMASK_B64:{ *:[i64] } i64:{ *:[i64] }:$src0)
     /* 249279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_QUADMASK_B64),
     /* 249282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249286 */     GIR_RootConstrainSelectedInstOperands,
     /* 249287 */     // GIR_Coverage, 22,
     /* 249287 */     GIR_EraseRootFromParent_Done,
     /* 249288 */   // Label 4030: @249288
     /* 249288 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(249320), // Rule ID 24 //
     /* 249293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 249296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_bitreplicate),
     /* 249301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 249311 */     // (intrinsic_wo_chain:{ *:[i64] } 3152:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)  =>  (S_BITREPLICATE_B64_B32:{ *:[i64] } i32:{ *:[i32] }:$src0)
     /* 249311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BITREPLICATE_B64_B32),
     /* 249314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249316 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249318 */     GIR_RootConstrainSelectedInstOperands,
     /* 249319 */     // GIR_Coverage, 24,
     /* 249319 */     GIR_EraseRootFromParent_Done,
     /* 249320 */   // Label 4031: @249320
     /* 249320 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(249355), // Rule ID 1864 //
     /* 249325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 249328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wqm_vote),
     /* 249333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 249336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 249339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 249343 */     // (intrinsic_wo_chain:{ *:[i1] } 3332:{ *:[iPTR] }, i1:{ *:[i1] }:$src0)  =>  (S_WQM_B32:{ *:[i1] }:{ *:[i1] } SSrc_b32:{ *:[i1] }:$src0)
     /* 249343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B32),
     /* 249346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249348 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 249353 */     GIR_RootConstrainSelectedInstOperands,
     /* 249354 */     // GIR_Coverage, 1864,
     /* 249354 */     GIR_EraseRootFromParent_Done,
     /* 249355 */   // Label 4032: @249355
     /* 249355 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(249390), // Rule ID 1865 //
     /* 249360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 249363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wqm_vote),
     /* 249368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 249371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 249374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 249378 */     // (intrinsic_wo_chain:{ *:[i1] } 3332:{ *:[iPTR] }, i1:{ *:[i1] }:$src0)  =>  (S_WQM_B64:{ *:[i1] }:{ *:[i1] } SSrc_b64:{ *:[i1] }:$src0)
     /* 249378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B64),
     /* 249381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249383 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249385 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 249388 */     GIR_RootConstrainSelectedInstOperands,
     /* 249389 */     // GIR_Coverage, 1865,
     /* 249389 */     GIR_EraseRootFromParent_Done,
     /* 249390 */   // Label 4033: @249390
     /* 249390 */   GIM_Reject,
     /* 249391 */ // Label 4009: @249391
     /* 249391 */ GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(251716),
     /* 249396 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 249399 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(249451), // Rule ID 1364 //
     /* 249404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 249407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_permute),
     /* 249412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 249421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 249425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 249432 */     // (intrinsic_wo_chain:{ *:[i32] } 2185:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data0)  =>  (DS_PERMUTE_B32:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$data0, i32:{ *:[i32] }:$offset)
     /* 249432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PERMUTE_B32),
     /* 249435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // addr
     /* 249442 */     GIR_RootToRootCopy, /*OpIdx*/3, // data0
     /* 249444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 249449 */     GIR_RootConstrainSelectedInstOperands,
     /* 249450 */     // GIR_Coverage, 1364,
     /* 249450 */     GIR_EraseRootFromParent_Done,
     /* 249451 */   // Label 4035: @249451
     /* 249451 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(249503), // Rule ID 1365 //
     /* 249456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 249459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_bpermute),
     /* 249464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 249473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 249477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 249484 */     // (intrinsic_wo_chain:{ *:[i32] } 2170:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data0)  =>  (DS_BPERMUTE_B32:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$data0, i32:{ *:[i32] }:$offset)
     /* 249484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_BPERMUTE_B32),
     /* 249487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // addr
     /* 249494 */     GIR_RootToRootCopy, /*OpIdx*/3, // data0
     /* 249496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 249501 */     GIR_RootConstrainSelectedInstOperands,
     /* 249502 */     // GIR_Coverage, 1365,
     /* 249502 */     GIR_EraseRootFromParent_Done,
     /* 249503 */   // Label 4036: @249503
     /* 249503 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(249555), // Rule ID 1366 //
     /* 249508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 249511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_bpermute_fi_b32),
     /* 249516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 249525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 249529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 249536 */     // (intrinsic_wo_chain:{ *:[i32] } 2171:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data0)  =>  (DS_BPERMUTE_FI_B32:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$data0, i32:{ *:[i32] }:$offset)
     /* 249536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_BPERMUTE_FI_B32),
     /* 249539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // addr
     /* 249546 */     GIR_RootToRootCopy, /*OpIdx*/3, // data0
     /* 249548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 249553 */     GIR_RootConstrainSelectedInstOperands,
     /* 249554 */     // GIR_Coverage, 1366,
     /* 249554 */     GIR_EraseRootFromParent_Done,
     /* 249555 */   // Label 4037: @249555
     /* 249555 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(249608), // Rule ID 2446 //
     /* 249560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 249563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 249568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249578 */     // MIs[0] dpp8
     /* 249578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 249581 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 249581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 249584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249586 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249588 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249590 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 249596 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 249606 */     GIR_RootConstrainSelectedInstOperands,
     /* 249607 */     // GIR_Coverage, 2446,
     /* 249607 */     GIR_EraseRootFromParent_Done,
     /* 249608 */   // Label 4038: @249608
     /* 249608 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(249661), // Rule ID 2447 //
     /* 249613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 249616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 249621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249631 */     // MIs[0] dpp8
     /* 249631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 249634 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 249634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 249637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249639 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249641 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249643 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 249649 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 249659 */     GIR_RootConstrainSelectedInstOperands,
     /* 249660 */     // GIR_Coverage, 2447,
     /* 249660 */     GIR_EraseRootFromParent_Done,
     /* 249661 */   // Label 4039: @249661
     /* 249661 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(249714), // Rule ID 2448 //
     /* 249666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 249669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 249674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249684 */     // MIs[0] dpp8
     /* 249684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 249687 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 249687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 249690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249692 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249694 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249696 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 249702 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 249712 */     GIR_RootConstrainSelectedInstOperands,
     /* 249713 */     // GIR_Coverage, 2448,
     /* 249713 */     GIR_EraseRootFromParent_Done,
     /* 249714 */   // Label 4040: @249714
     /* 249714 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(249767), // Rule ID 2449 //
     /* 249719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 249722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 249727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249737 */     // MIs[0] dpp8
     /* 249737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 249740 */     // (intrinsic_wo_chain:{ *:[f32] } 3068:{ *:[iPTR] }, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[f32] } VGPR_32:{ *:[f32] }:$src, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 249740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 249743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249745 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249749 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 249755 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 249765 */     GIR_RootConstrainSelectedInstOperands,
     /* 249766 */     // GIR_Coverage, 2449,
     /* 249766 */     GIR_EraseRootFromParent_Done,
     /* 249767 */   // Label 4041: @249767
     /* 249767 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(249820), // Rule ID 2450 //
     /* 249772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 249775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 249780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249790 */     // MIs[0] dpp8
     /* 249790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 249793 */     // (intrinsic_wo_chain:{ *:[f32] } 3068:{ *:[iPTR] }, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[f32] } VGPR_32:{ *:[f32] }:$src, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 249793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 249796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249798 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249800 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 249808 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 249818 */     GIR_RootConstrainSelectedInstOperands,
     /* 249819 */     // GIR_Coverage, 2450,
     /* 249819 */     GIR_EraseRootFromParent_Done,
     /* 249820 */   // Label 4042: @249820
     /* 249820 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(249873), // Rule ID 2451 //
     /* 249825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 249828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 249833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249843 */     // MIs[0] dpp8
     /* 249843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 249846 */     // (intrinsic_wo_chain:{ *:[f32] } 3068:{ *:[iPTR] }, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[f32] } VGPR_32:{ *:[f32] }:$src, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 249846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 249849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249851 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249853 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249855 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 249861 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 249871 */     GIR_RootConstrainSelectedInstOperands,
     /* 249872 */     // GIR_Coverage, 2451,
     /* 249872 */     GIR_EraseRootFromParent_Done,
     /* 249873 */   // Label 4043: @249873
     /* 249873 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(249926), // Rule ID 2452 //
     /* 249878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 249881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 249886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 249889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 249892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249896 */     // MIs[0] dpp8
     /* 249896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 249899 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3068:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$src, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 249899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 249902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249904 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249906 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249908 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 249914 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 249924 */     GIR_RootConstrainSelectedInstOperands,
     /* 249925 */     // GIR_Coverage, 2452,
     /* 249925 */     GIR_EraseRootFromParent_Done,
     /* 249926 */   // Label 4044: @249926
     /* 249926 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(249979), // Rule ID 2453 //
     /* 249931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 249934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 249939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 249942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 249945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249949 */     // MIs[0] dpp8
     /* 249949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 249952 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3068:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$src, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 249952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 249955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249957 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249959 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249961 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 249967 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 249977 */     GIR_RootConstrainSelectedInstOperands,
     /* 249978 */     // GIR_Coverage, 2453,
     /* 249978 */     GIR_EraseRootFromParent_Done,
     /* 249979 */   // Label 4045: @249979
     /* 249979 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(250032), // Rule ID 2454 //
     /* 249984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 249987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 249992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 249995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 249998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250002 */     // MIs[0] dpp8
     /* 250002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250005 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3068:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$src, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 250008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250010 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250012 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250014 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250020 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250030 */     GIR_RootConstrainSelectedInstOperands,
     /* 250031 */     // GIR_Coverage, 2454,
     /* 250031 */     GIR_EraseRootFromParent_Done,
     /* 250032 */   // Label 4046: @250032
     /* 250032 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(250085), // Rule ID 2455 //
     /* 250037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 250040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 250048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 250051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250055 */     // MIs[0] dpp8
     /* 250055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250058 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3068:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 250061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250063 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250065 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250067 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250073 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250083 */     GIR_RootConstrainSelectedInstOperands,
     /* 250084 */     // GIR_Coverage, 2455,
     /* 250084 */     GIR_EraseRootFromParent_Done,
     /* 250085 */   // Label 4047: @250085
     /* 250085 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(250138), // Rule ID 2456 //
     /* 250090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 250093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 250101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 250104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250108 */     // MIs[0] dpp8
     /* 250108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250111 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3068:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 250114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250116 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250118 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250120 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250126 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250136 */     GIR_RootConstrainSelectedInstOperands,
     /* 250137 */     // GIR_Coverage, 2456,
     /* 250137 */     GIR_EraseRootFromParent_Done,
     /* 250138 */   // Label 4048: @250138
     /* 250138 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(250191), // Rule ID 2457 //
     /* 250143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 250154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 250157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250161 */     // MIs[0] dpp8
     /* 250161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250164 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3068:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 250167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250171 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250173 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250179 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250189 */     GIR_RootConstrainSelectedInstOperands,
     /* 250190 */     // GIR_Coverage, 2457,
     /* 250190 */     GIR_EraseRootFromParent_Done,
     /* 250191 */   // Label 4049: @250191
     /* 250191 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(250244), // Rule ID 2458 //
     /* 250196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 250199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 250207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 250210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250214 */     // MIs[0] dpp8
     /* 250214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250217 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 250220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250222 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250226 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250232 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250242 */     GIR_RootConstrainSelectedInstOperands,
     /* 250243 */     // GIR_Coverage, 2458,
     /* 250243 */     GIR_EraseRootFromParent_Done,
     /* 250244 */   // Label 4050: @250244
     /* 250244 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(250297), // Rule ID 2459 //
     /* 250249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 250252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 250260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 250263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250267 */     // MIs[0] dpp8
     /* 250267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250270 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 250273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250277 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250279 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250285 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250295 */     GIR_RootConstrainSelectedInstOperands,
     /* 250296 */     // GIR_Coverage, 2459,
     /* 250296 */     GIR_EraseRootFromParent_Done,
     /* 250297 */   // Label 4051: @250297
     /* 250297 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(250350), // Rule ID 2460 //
     /* 250302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 250313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 250316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250320 */     // MIs[0] dpp8
     /* 250320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250323 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 250326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250328 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250330 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250338 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250348 */     GIR_RootConstrainSelectedInstOperands,
     /* 250349 */     // GIR_Coverage, 2460,
     /* 250349 */     GIR_EraseRootFromParent_Done,
     /* 250350 */   // Label 4052: @250350
     /* 250350 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(250403), // Rule ID 2461 //
     /* 250355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 250358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 250366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 250369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250373 */     // MIs[0] dpp8
     /* 250373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250376 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 250379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250381 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250383 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250385 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250391 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250401 */     GIR_RootConstrainSelectedInstOperands,
     /* 250402 */     // GIR_Coverage, 2461,
     /* 250402 */     GIR_EraseRootFromParent_Done,
     /* 250403 */   // Label 4053: @250403
     /* 250403 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(250456), // Rule ID 2462 //
     /* 250408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 250411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 250419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 250422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250426 */     // MIs[0] dpp8
     /* 250426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250429 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 250432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250434 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250436 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250438 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250444 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250454 */     GIR_RootConstrainSelectedInstOperands,
     /* 250455 */     // GIR_Coverage, 2462,
     /* 250455 */     GIR_EraseRootFromParent_Done,
     /* 250456 */   // Label 4054: @250456
     /* 250456 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(250509), // Rule ID 2463 //
     /* 250461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 250472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 250475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250479 */     // MIs[0] dpp8
     /* 250479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250482 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 250485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250487 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250489 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250491 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250497 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250507 */     GIR_RootConstrainSelectedInstOperands,
     /* 250508 */     // GIR_Coverage, 2463,
     /* 250508 */     GIR_EraseRootFromParent_Done,
     /* 250509 */   // Label 4055: @250509
     /* 250509 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(250562), // Rule ID 2464 //
     /* 250514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 250517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 250525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 250528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250532 */     // MIs[0] dpp8
     /* 250532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250535 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 250538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250540 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250542 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250544 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250550 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250560 */     GIR_RootConstrainSelectedInstOperands,
     /* 250561 */     // GIR_Coverage, 2464,
     /* 250561 */     GIR_EraseRootFromParent_Done,
     /* 250562 */   // Label 4056: @250562
     /* 250562 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(250615), // Rule ID 2465 //
     /* 250567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 250570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 250578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 250581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250585 */     // MIs[0] dpp8
     /* 250585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250588 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 250591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250593 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250595 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250597 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250603 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250613 */     GIR_RootConstrainSelectedInstOperands,
     /* 250614 */     // GIR_Coverage, 2465,
     /* 250614 */     GIR_EraseRootFromParent_Done,
     /* 250615 */   // Label 4057: @250615
     /* 250615 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(250668), // Rule ID 2466 //
     /* 250620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 250631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 250634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250638 */     // MIs[0] dpp8
     /* 250638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250641 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 250644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250646 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250648 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250650 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250656 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250666 */     GIR_RootConstrainSelectedInstOperands,
     /* 250667 */     // GIR_Coverage, 2466,
     /* 250667 */     GIR_EraseRootFromParent_Done,
     /* 250668 */   // Label 4058: @250668
     /* 250668 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(250721), // Rule ID 2467 //
     /* 250673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 250676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 250684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 250687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250691 */     // MIs[0] dpp8
     /* 250691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250694 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 250697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250699 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250701 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250709 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250719 */     GIR_RootConstrainSelectedInstOperands,
     /* 250720 */     // GIR_Coverage, 2467,
     /* 250720 */     GIR_EraseRootFromParent_Done,
     /* 250721 */   // Label 4059: @250721
     /* 250721 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(250774), // Rule ID 2468 //
     /* 250726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 250729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 250737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 250740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250744 */     // MIs[0] dpp8
     /* 250744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250747 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 250750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250752 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250754 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250756 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250762 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250772 */     GIR_RootConstrainSelectedInstOperands,
     /* 250773 */     // GIR_Coverage, 2468,
     /* 250773 */     GIR_EraseRootFromParent_Done,
     /* 250774 */   // Label 4060: @250774
     /* 250774 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(250827), // Rule ID 2469 //
     /* 250779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 250787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 250790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 250793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 250797 */     // MIs[0] dpp8
     /* 250797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250800 */     // (intrinsic_wo_chain:{ *:[i32] } 3068:{ *:[iPTR] }, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 250800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 250803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250805 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250807 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250809 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 250815 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 250825 */     GIR_RootConstrainSelectedInstOperands,
     /* 250826 */     // GIR_Coverage, 2469,
     /* 250826 */     GIR_EraseRootFromParent_Done,
     /* 250827 */   // Label 4061: @250827
     /* 250827 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(250868), // Rule ID 7787 //
     /* 250832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_swizzle),
     /* 250837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 250843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 250847 */     // MIs[0] offset16
     /* 250847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 250850 */     // (intrinsic_wo_chain:{ *:[i32] } 2191:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset16)  =>  (DS_SWIZZLE_B32:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, (as_i16timm:{ *:[i16] } ?:{ *:[i32] }:$offset16), 0:{ *:[i1] })
     /* 250850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SWIZZLE_B32),
     /* 250853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250855 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset16
     /* 250863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250866 */     GIR_RootConstrainSelectedInstOperands,
     /* 250867 */     // GIR_Coverage, 7787,
     /* 250867 */     GIR_EraseRootFromParent_Done,
     /* 250868 */   // Label 4062: @250868
     /* 250868 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(250902), // Rule ID 2470 //
     /* 250873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 250878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 250884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 250891 */     // (intrinsic_wo_chain:{ *:[i32] } 3142:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 250891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 250894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250896 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 250898 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 250900 */     GIR_RootConstrainSelectedInstOperands,
     /* 250901 */     // GIR_Coverage, 2470,
     /* 250901 */     GIR_EraseRootFromParent_Done,
     /* 250902 */   // Label 4063: @250902
     /* 250902 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(250936), // Rule ID 2472 //
     /* 250907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 250912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 250918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 250925 */     // (intrinsic_wo_chain:{ *:[f32] } 3142:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[f32] } VRegOrLdsSrc_32:{ *:[f32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 250925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 250928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250930 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 250932 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 250934 */     GIR_RootConstrainSelectedInstOperands,
     /* 250935 */     // GIR_Coverage, 2472,
     /* 250935 */     GIR_EraseRootFromParent_Done,
     /* 250936 */   // Label 4064: @250936
     /* 250936 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(250970), // Rule ID 2474 //
     /* 250941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 250946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 250949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 250952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 250959 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3142:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[v2i16] } VRegOrLdsSrc_32:{ *:[v2i16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 250959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 250962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250964 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 250966 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 250968 */     GIR_RootConstrainSelectedInstOperands,
     /* 250969 */     // GIR_Coverage, 2474,
     /* 250969 */     GIR_EraseRootFromParent_Done,
     /* 250970 */   // Label 4065: @250970
     /* 250970 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(251004), // Rule ID 2476 //
     /* 250975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 250980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 250983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 250986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 250993 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3142:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[v2f16] } VRegOrLdsSrc_32:{ *:[v2f16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 250993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 250996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250998 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 251000 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 251002 */     GIR_RootConstrainSelectedInstOperands,
     /* 251003 */     // GIR_Coverage, 2476,
     /* 251003 */     GIR_EraseRootFromParent_Done,
     /* 251004 */   // Label 4066: @251004
     /* 251004 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(251038), // Rule ID 2478 //
     /* 251009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 251014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 251017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 251020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 251027 */     // (intrinsic_wo_chain:{ *:[i32] } 3142:{ *:[iPTR] }, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 251027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 251030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251032 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 251034 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 251036 */     GIR_RootConstrainSelectedInstOperands,
     /* 251037 */     // GIR_Coverage, 2478,
     /* 251037 */     GIR_EraseRootFromParent_Done,
     /* 251038 */   // Label 4067: @251038
     /* 251038 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(251072), // Rule ID 2480 //
     /* 251043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 251048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 251051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 251054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 251061 */     // (intrinsic_wo_chain:{ *:[i32] } 3142:{ *:[iPTR] }, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 251061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 251064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251066 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 251068 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 251070 */     GIR_RootConstrainSelectedInstOperands,
     /* 251071 */     // GIR_Coverage, 2480,
     /* 251071 */     GIR_EraseRootFromParent_Done,
     /* 251072 */   // Label 4068: @251072
     /* 251072 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(251106), // Rule ID 2482 //
     /* 251077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 251082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 251085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 251088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 251095 */     // (intrinsic_wo_chain:{ *:[i32] } 3142:{ *:[iPTR] }, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 251095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 251098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251100 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 251102 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 251104 */     GIR_RootConstrainSelectedInstOperands,
     /* 251105 */     // GIR_Coverage, 2482,
     /* 251105 */     GIR_EraseRootFromParent_Done,
     /* 251106 */   // Label 4069: @251106
     /* 251106 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(251140), // Rule ID 2484 //
     /* 251111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 251116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 251119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 251122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 251129 */     // (intrinsic_wo_chain:{ *:[i32] } 3142:{ *:[iPTR] }, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 251129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 251132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251134 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 251136 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 251138 */     GIR_RootConstrainSelectedInstOperands,
     /* 251139 */     // GIR_Coverage, 2484,
     /* 251139 */     GIR_EraseRootFromParent_Done,
     /* 251140 */   // Label 4070: @251140
     /* 251140 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(251197), // Rule ID 6938 //
     /* 251145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251163 */     // (intrinsic_wo_chain:{ *:[i32] } 3200:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251185 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251190 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251195 */     GIR_RootConstrainSelectedInstOperands,
     /* 251196 */     // GIR_Coverage, 6938,
     /* 251196 */     GIR_EraseRootFromParent_Done,
     /* 251197 */   // Label 4071: @251197
     /* 251197 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(251254), // Rule ID 6939 //
     /* 251202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251220 */     // (intrinsic_wo_chain:{ *:[f32] } 3200:{ *:[iPTR] }, f32:{ *:[f32] }:$src, f32:{ *:[f32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[f32] } 0:{ *:[i32] }, VSrc_b32:{ *:[f32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[f32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251242 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251247 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251252 */     GIR_RootConstrainSelectedInstOperands,
     /* 251253 */     // GIR_Coverage, 6939,
     /* 251253 */     GIR_EraseRootFromParent_Done,
     /* 251254 */   // Label 4072: @251254
     /* 251254 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(251311), // Rule ID 6940 //
     /* 251259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 251267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 251270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 251273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251277 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3200:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, v2i16:{ *:[v2i16] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[v2i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[v2i16] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[v2i16] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251299 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251304 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251309 */     GIR_RootConstrainSelectedInstOperands,
     /* 251310 */     // GIR_Coverage, 6940,
     /* 251310 */     GIR_EraseRootFromParent_Done,
     /* 251311 */   // Label 4073: @251311
     /* 251311 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(251368), // Rule ID 6941 //
     /* 251316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 251324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 251327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 251330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251334 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3200:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, v2f16:{ *:[v2f16] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[v2f16] } 0:{ *:[i32] }, VSrc_b32:{ *:[v2f16] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[v2f16] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251356 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251361 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251366 */     GIR_RootConstrainSelectedInstOperands,
     /* 251367 */     // GIR_Coverage, 6941,
     /* 251367 */     GIR_EraseRootFromParent_Done,
     /* 251368 */   // Label 4074: @251368
     /* 251368 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(251425), // Rule ID 6942 //
     /* 251373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 251381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 251384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
     /* 251387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251391 */     // (intrinsic_wo_chain:{ *:[i32] } 3200:{ *:[iPTR] }, p2:{ *:[i32] }:$src, p2:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251413 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251418 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251423 */     GIR_RootConstrainSelectedInstOperands,
     /* 251424 */     // GIR_Coverage, 6942,
     /* 251424 */     GIR_EraseRootFromParent_Done,
     /* 251425 */   // Label 4075: @251425
     /* 251425 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(251482), // Rule ID 6943 //
     /* 251430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 251438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 251441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
     /* 251444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251448 */     // (intrinsic_wo_chain:{ *:[i32] } 3200:{ *:[iPTR] }, p3:{ *:[i32] }:$src, p3:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251470 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251475 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251480 */     GIR_RootConstrainSelectedInstOperands,
     /* 251481 */     // GIR_Coverage, 6943,
     /* 251481 */     GIR_EraseRootFromParent_Done,
     /* 251482 */   // Label 4076: @251482
     /* 251482 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(251539), // Rule ID 6944 //
     /* 251487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 251495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 251498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
     /* 251501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251505 */     // (intrinsic_wo_chain:{ *:[i32] } 3200:{ *:[iPTR] }, p5:{ *:[i32] }:$src, p5:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251527 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251532 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251537 */     GIR_RootConstrainSelectedInstOperands,
     /* 251538 */     // GIR_Coverage, 6944,
     /* 251538 */     GIR_EraseRootFromParent_Done,
     /* 251539 */   // Label 4077: @251539
     /* 251539 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(251596), // Rule ID 6945 //
     /* 251544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 251549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 251552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 251555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
     /* 251558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251562 */     // (intrinsic_wo_chain:{ *:[i32] } 3200:{ *:[iPTR] }, p6:{ *:[i32] }:$src, p6:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251584 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251589 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251594 */     GIR_RootConstrainSelectedInstOperands,
     /* 251595 */     // GIR_Coverage, 6945,
     /* 251595 */     GIR_EraseRootFromParent_Done,
     /* 251596 */   // Label 4078: @251596
     /* 251596 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(251653), // Rule ID 6946 //
     /* 251601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive_chain_arg),
     /* 251606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251619 */     // (intrinsic_wo_chain:{ *:[i32] } 3201:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$src, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 251619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 251622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 251636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251641 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251646 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 251648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251651 */     GIR_RootConstrainSelectedInstOperands,
     /* 251652 */     // GIR_Coverage, 6946,
     /* 251652 */     GIR_EraseRootFromParent_Done,
     /* 251653 */   // Label 4079: @251653
     /* 251653 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(251684), // Rule ID 1336 //
     /* 251658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wave_reduce_umin),
     /* 251663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
     /* 251673 */     // MIs[0] strategy
     /* 251673 */     // No operand predicates
     /* 251673 */     // (intrinsic_wo_chain:{ *:[i32] } 3309:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)  =>  (WAVE_REDUCE_UMIN_PSEUDO_U32:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)
     /* 251673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::WAVE_REDUCE_UMIN_PSEUDO_U32),
     /* 251676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 251678 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251680 */     GIR_RootToRootCopy, /*OpIdx*/3, // strategy
     /* 251682 */     GIR_RootConstrainSelectedInstOperands,
     /* 251683 */     // GIR_Coverage, 1336,
     /* 251683 */     GIR_EraseRootFromParent_Done,
     /* 251684 */   // Label 4080: @251684
     /* 251684 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(251715), // Rule ID 1337 //
     /* 251689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wave_reduce_umax),
     /* 251694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
     /* 251704 */     // MIs[0] strategy
     /* 251704 */     // No operand predicates
     /* 251704 */     // (intrinsic_wo_chain:{ *:[i32] } 3308:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)  =>  (WAVE_REDUCE_UMAX_PSEUDO_U32:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)
     /* 251704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::WAVE_REDUCE_UMAX_PSEUDO_U32),
     /* 251707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 251709 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251711 */     GIR_RootToRootCopy, /*OpIdx*/3, // strategy
     /* 251713 */     GIR_RootConstrainSelectedInstOperands,
     /* 251714 */     // GIR_Coverage, 1337,
     /* 251714 */     GIR_EraseRootFromParent_Done,
     /* 251715 */   // Label 4081: @251715
     /* 251715 */   GIM_Reject,
     /* 251716 */ // Label 4034: @251716
     /* 251716 */ GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(254041),
     /* 251721 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 251724 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(251815), // Rule ID 2815 //
     /* 251729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 251732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 251737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 251740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 251743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 251746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 251749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 251753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 251760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 251767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 251774 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3318:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_F16_w32_threeaddr:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 251774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w32_threeaddr),
     /* 251777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 251784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 251789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 251794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 251799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 251802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 251807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251813 */     GIR_RootConstrainSelectedInstOperands,
     /* 251814 */     // GIR_Coverage, 2815,
     /* 251814 */     GIR_EraseRootFromParent_Done,
     /* 251815 */   // Label 4083: @251815
     /* 251815 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(251906), // Rule ID 2848 //
     /* 251820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 251823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 251828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 251831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 251834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 251837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 251840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 251844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 251851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 251858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 251865 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3318:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_F16_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 251865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w64_threeaddr),
     /* 251868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 251875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 251880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 251885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 251890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 251893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 251898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251904 */     GIR_RootConstrainSelectedInstOperands,
     /* 251905 */     // GIR_Coverage, 2848,
     /* 251905 */     GIR_EraseRootFromParent_Done,
     /* 251906 */   // Label 4084: @251906
     /* 251906 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(251999), // Rule ID 2800 //
     /* 251911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 251914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 251919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 251922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 251925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 251928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 251931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 251935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 251942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 251949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 251956 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3318:{ *:[iPTR] }, (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_twoaddr_w32:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 251956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_twoaddr_w32),
     /* 251959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 251966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 251971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 251976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 251981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 251986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 251991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251997 */     GIR_RootConstrainSelectedInstOperands,
     /* 251998 */     // GIR_Coverage, 2800,
     /* 251998 */     GIR_EraseRootFromParent_Done,
     /* 251999 */   // Label 4085: @251999
     /* 251999 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(252092), // Rule ID 2801 //
     /* 252004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 252007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 252012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 252018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 252021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252049 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3315:{ *:[iPTR] }, (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_twoaddr_w32:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16i16:{ *:[v16i16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 252049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_twoaddr_w32),
     /* 252052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 252059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 252064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 252069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 252074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 252079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 252084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252090 */     GIR_RootConstrainSelectedInstOperands,
     /* 252091 */     // GIR_Coverage, 2801,
     /* 252091 */     GIR_EraseRootFromParent_Done,
     /* 252092 */   // Label 4086: @252092
     /* 252092 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(252185), // Rule ID 2806 //
     /* 252097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 252100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 252105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 252111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 252114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 252117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 252121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252142 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3318:{ *:[iPTR] }, (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_twoaddr_w64:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 252142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_twoaddr_w64),
     /* 252145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 252152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 252157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 252162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 252167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 252172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 252177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252183 */     GIR_RootConstrainSelectedInstOperands,
     /* 252184 */     // GIR_Coverage, 2806,
     /* 252184 */     GIR_EraseRootFromParent_Done,
     /* 252185 */   // Label 4087: @252185
     /* 252185 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(252278), // Rule ID 2807 //
     /* 252190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 252193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 252198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 252204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 252207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 252210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 252214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 252235 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3315:{ *:[iPTR] }, (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_twoaddr_w64:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16i16:{ *:[v16i16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 252235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_twoaddr_w64),
     /* 252238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 252245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 252250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 252255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 252260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 252265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 252270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252276 */     GIR_RootConstrainSelectedInstOperands,
     /* 252277 */     // GIR_Coverage, 2807,
     /* 252277 */     GIR_EraseRootFromParent_Done,
     /* 252278 */   // Label 4088: @252278
     /* 252278 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(252371), // Rule ID 2814 //
     /* 252283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 252286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 252291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 252297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 252300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 252314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 252321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamods),
     /* 252328 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3318:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_w32_twoaddr:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 252328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w32_twoaddr),
     /* 252331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 252338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 252343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 252348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 252353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 252358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 252363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252369 */     GIR_RootConstrainSelectedInstOperands,
     /* 252370 */     // GIR_Coverage, 2814,
     /* 252370 */     GIR_EraseRootFromParent_Done,
     /* 252371 */   // Label 4089: @252371
     /* 252371 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(252464), // Rule ID 2847 //
     /* 252376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 252379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 252384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 252390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 252393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 252396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 252400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 252407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 252414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamods),
     /* 252421 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3318:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 252421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w64_twoaddr),
     /* 252424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 252431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 252436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 252441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 252446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 252451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 252456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252462 */     GIR_RootConstrainSelectedInstOperands,
     /* 252463 */     // GIR_Coverage, 2847,
     /* 252463 */     GIR_EraseRootFromParent_Done,
     /* 252464 */   // Label 4090: @252464
     /* 252464 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(252531), // Rule ID 2817 //
     /* 252469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 252472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 252477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 252483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 252486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252500 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3315:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF16_w32_threeaddr:{ *:[v8f32] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 252500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w32_threeaddr),
     /* 252503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 252510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252513 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 252515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 252523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252529 */     GIR_RootConstrainSelectedInstOperands,
     /* 252530 */     // GIR_Coverage, 2817,
     /* 252530 */     GIR_EraseRootFromParent_Done,
     /* 252531 */   // Label 4091: @252531
     /* 252531 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(252592), // Rule ID 2827 //
     /* 252536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 252539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
     /* 252544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 252550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 252553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252567 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3320:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 252567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w32_threeaddr),
     /* 252570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252572 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 252574 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 252576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 252584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252590 */     GIR_RootConstrainSelectedInstOperands,
     /* 252591 */     // GIR_Coverage, 2827,
     /* 252591 */     GIR_EraseRootFromParent_Done,
     /* 252592 */   // Label 4092: @252592
     /* 252592 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(252653), // Rule ID 2829 //
     /* 252597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 252600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
     /* 252605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 252611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 252614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252628 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3319:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 252628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w32_threeaddr),
     /* 252631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252633 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 252635 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 252637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 252645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252651 */     GIR_RootConstrainSelectedInstOperands,
     /* 252652 */     // GIR_Coverage, 2829,
     /* 252652 */     GIR_EraseRootFromParent_Done,
     /* 252653 */   // Label 4093: @252653
     /* 252653 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(252714), // Rule ID 2831 //
     /* 252658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 252661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
     /* 252666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 252672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 252675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252689 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3317:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 252689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w32_threeaddr),
     /* 252692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252694 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 252696 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 252698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 252706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252712 */     GIR_RootConstrainSelectedInstOperands,
     /* 252713 */     // GIR_Coverage, 2831,
     /* 252713 */     GIR_EraseRootFromParent_Done,
     /* 252714 */   // Label 4094: @252714
     /* 252714 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(252775), // Rule ID 2833 //
     /* 252719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 252722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
     /* 252727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 252730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 252733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 252736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 252739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 252743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252750 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3316:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 252750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w32_threeaddr),
     /* 252753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252755 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 252757 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 252759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 252767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252773 */     GIR_RootConstrainSelectedInstOperands,
     /* 252774 */     // GIR_Coverage, 2833,
     /* 252774 */     GIR_EraseRootFromParent_Done,
     /* 252775 */   // Label 4095: @252775
     /* 252775 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(252842), // Rule ID 2850 //
     /* 252780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 252783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 252788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 252794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 252797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 252800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 252804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252811 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3315:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF16_w64_threeaddr:{ *:[v4f32] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 252811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w64_threeaddr),
     /* 252814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252819 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 252821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252824 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 252826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 252834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252840 */     GIR_RootConstrainSelectedInstOperands,
     /* 252841 */     // GIR_Coverage, 2850,
     /* 252841 */     GIR_EraseRootFromParent_Done,
     /* 252842 */   // Label 4096: @252842
     /* 252842 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(252903), // Rule ID 2860 //
     /* 252847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 252850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
     /* 252855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 252861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 252864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 252867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 252871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252878 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3320:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 252878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w64_threeaddr),
     /* 252881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252883 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 252885 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 252887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 252895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252901 */     GIR_RootConstrainSelectedInstOperands,
     /* 252902 */     // GIR_Coverage, 2860,
     /* 252902 */     GIR_EraseRootFromParent_Done,
     /* 252903 */   // Label 4097: @252903
     /* 252903 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(252964), // Rule ID 2862 //
     /* 252908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 252911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
     /* 252916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 252922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 252925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 252928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 252932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 252939 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3319:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 252939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w64_threeaddr),
     /* 252942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 252944 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 252946 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 252948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 252951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 252956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252962 */     GIR_RootConstrainSelectedInstOperands,
     /* 252963 */     // GIR_Coverage, 2862,
     /* 252963 */     GIR_EraseRootFromParent_Done,
     /* 252964 */   // Label 4098: @252964
     /* 252964 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(253025), // Rule ID 2864 //
     /* 252969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 252972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
     /* 252977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 252980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 252983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 252986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 252989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 252993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 253000 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3317:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 253000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w64_threeaddr),
     /* 253003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253005 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253007 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253023 */     GIR_RootConstrainSelectedInstOperands,
     /* 253024 */     // GIR_Coverage, 2864,
     /* 253024 */     GIR_EraseRootFromParent_Done,
     /* 253025 */   // Label 4099: @253025
     /* 253025 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(253086), // Rule ID 2866 //
     /* 253030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
     /* 253038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 253061 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3316:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 253061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w64_threeaddr),
     /* 253064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253066 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253068 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253084 */     GIR_RootConstrainSelectedInstOperands,
     /* 253085 */     // GIR_Coverage, 2866,
     /* 253085 */     GIR_EraseRootFromParent_Done,
     /* 253086 */   // Label 4100: @253086
     /* 253086 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(253155), // Rule ID 2816 //
     /* 253091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 253094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 253099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 253102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 253105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 253108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 253111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 253115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253122 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3315:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_w32_twoaddr:{ *:[v8f32] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 253122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w32_twoaddr),
     /* 253125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253130 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253135 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253153 */     GIR_RootConstrainSelectedInstOperands,
     /* 253154 */     // GIR_Coverage, 2816,
     /* 253154 */     GIR_EraseRootFromParent_Done,
     /* 253155 */   // Label 4101: @253155
     /* 253155 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(253218), // Rule ID 2826 //
     /* 253160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 253163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
     /* 253168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 253171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 253174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 253177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 253180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 253184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253191 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3320:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 253191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w32_twoaddr),
     /* 253194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253196 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253198 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253216 */     GIR_RootConstrainSelectedInstOperands,
     /* 253217 */     // GIR_Coverage, 2826,
     /* 253217 */     GIR_EraseRootFromParent_Done,
     /* 253218 */   // Label 4102: @253218
     /* 253218 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(253281), // Rule ID 2828 //
     /* 253223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 253226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
     /* 253231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 253234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 253237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 253240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 253243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 253247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253254 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3319:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 253254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w32_twoaddr),
     /* 253257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253259 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253261 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253279 */     GIR_RootConstrainSelectedInstOperands,
     /* 253280 */     // GIR_Coverage, 2828,
     /* 253280 */     GIR_EraseRootFromParent_Done,
     /* 253281 */   // Label 4103: @253281
     /* 253281 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(253344), // Rule ID 2830 //
     /* 253286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 253289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
     /* 253294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 253297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 253300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 253303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 253306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 253310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253317 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3317:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 253317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w32_twoaddr),
     /* 253320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253322 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253324 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253342 */     GIR_RootConstrainSelectedInstOperands,
     /* 253343 */     // GIR_Coverage, 2830,
     /* 253343 */     GIR_EraseRootFromParent_Done,
     /* 253344 */   // Label 4104: @253344
     /* 253344 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(253407), // Rule ID 2832 //
     /* 253349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 253352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
     /* 253357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 253360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 253363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 253366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 253369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 253373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253380 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3316:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 253380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w32_twoaddr),
     /* 253383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253385 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253387 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253405 */     GIR_RootConstrainSelectedInstOperands,
     /* 253406 */     // GIR_Coverage, 2832,
     /* 253406 */     GIR_EraseRootFromParent_Done,
     /* 253407 */   // Label 4105: @253407
     /* 253407 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(253476), // Rule ID 2849 //
     /* 253412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 253420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 253426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 253429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253443 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3315:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_w64_twoaddr:{ *:[v4f32] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 253443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w64_twoaddr),
     /* 253446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 253456 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253474 */     GIR_RootConstrainSelectedInstOperands,
     /* 253475 */     // GIR_Coverage, 2849,
     /* 253475 */     GIR_EraseRootFromParent_Done,
     /* 253476 */   // Label 4106: @253476
     /* 253476 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(253539), // Rule ID 2859 //
     /* 253481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
     /* 253489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253512 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3320:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 253512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w64_twoaddr),
     /* 253515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253517 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253519 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253537 */     GIR_RootConstrainSelectedInstOperands,
     /* 253538 */     // GIR_Coverage, 2859,
     /* 253538 */     GIR_EraseRootFromParent_Done,
     /* 253539 */   // Label 4107: @253539
     /* 253539 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(253602), // Rule ID 2861 //
     /* 253544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
     /* 253552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253575 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3319:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 253575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w64_twoaddr),
     /* 253578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253580 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253582 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253600 */     GIR_RootConstrainSelectedInstOperands,
     /* 253601 */     // GIR_Coverage, 2861,
     /* 253601 */     GIR_EraseRootFromParent_Done,
     /* 253602 */   // Label 4108: @253602
     /* 253602 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(253665), // Rule ID 2863 //
     /* 253607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
     /* 253615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253638 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3317:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 253638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w64_twoaddr),
     /* 253641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253643 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253645 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253663 */     GIR_RootConstrainSelectedInstOperands,
     /* 253664 */     // GIR_Coverage, 2863,
     /* 253664 */     GIR_EraseRootFromParent_Done,
     /* 253665 */   // Label 4109: @253665
     /* 253665 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(253728), // Rule ID 2865 //
     /* 253670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 253673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
     /* 253678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 253681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 253690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 253694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 253701 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3316:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 253701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w64_twoaddr),
     /* 253704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253706 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253708 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 253715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 253720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253726 */     GIR_RootConstrainSelectedInstOperands,
     /* 253727 */     // GIR_Coverage, 2865,
     /* 253727 */     GIR_EraseRootFromParent_Done,
     /* 253728 */   // Label 4110: @253728
     /* 253728 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(253767), // Rule ID 2471 //
     /* 253733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 253738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 253750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253754 */     // (intrinsic_wo_chain:{ *:[i32] } 3333:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 253754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 253757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253759 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253761 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253763 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 253765 */     GIR_RootConstrainSelectedInstOperands,
     /* 253766 */     // GIR_Coverage, 2471,
     /* 253766 */     GIR_EraseRootFromParent_Done,
     /* 253767 */   // Label 4111: @253767
     /* 253767 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(253806), // Rule ID 2473 //
     /* 253772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 253777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 253789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253793 */     // (intrinsic_wo_chain:{ *:[f32] } 3333:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[f32] } SCSrc_b32:{ *:[f32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[f32] }:$src2)
     /* 253793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 253796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253798 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253800 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253802 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 253804 */     GIR_RootConstrainSelectedInstOperands,
     /* 253805 */     // GIR_Coverage, 2473,
     /* 253805 */     GIR_EraseRootFromParent_Done,
     /* 253806 */   // Label 4112: @253806
     /* 253806 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(253845), // Rule ID 2475 //
     /* 253811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 253816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 253819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 253822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s16,
     /* 253828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253832 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3333:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1, v2i16:{ *:[v2i16] }:$src2)  =>  (V_WRITELANE_B32:{ *:[v2i16] } SCSrc_b32:{ *:[v2i16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[v2i16] }:$src2)
     /* 253832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 253835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253837 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253839 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253841 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 253843 */     GIR_RootConstrainSelectedInstOperands,
     /* 253844 */     // GIR_Coverage, 2475,
     /* 253844 */     GIR_EraseRootFromParent_Done,
     /* 253845 */   // Label 4113: @253845
     /* 253845 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(253884), // Rule ID 2477 //
     /* 253850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 253855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 253858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 253861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s16,
     /* 253867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253871 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3333:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, v2f16:{ *:[v2f16] }:$src2)  =>  (V_WRITELANE_B32:{ *:[v2f16] } SCSrc_b32:{ *:[v2f16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[v2f16] }:$src2)
     /* 253871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 253874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253876 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253878 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253880 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 253882 */     GIR_RootConstrainSelectedInstOperands,
     /* 253883 */     // GIR_Coverage, 2477,
     /* 253883 */     GIR_EraseRootFromParent_Done,
     /* 253884 */   // Label 4114: @253884
     /* 253884 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(253923), // Rule ID 2479 //
     /* 253889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 253894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 253897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 253900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p2s32,
     /* 253906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253910 */     // (intrinsic_wo_chain:{ *:[i32] } 3333:{ *:[iPTR] }, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p2:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 253910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 253913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253915 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253917 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253919 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 253921 */     GIR_RootConstrainSelectedInstOperands,
     /* 253922 */     // GIR_Coverage, 2479,
     /* 253922 */     GIR_EraseRootFromParent_Done,
     /* 253923 */   // Label 4115: @253923
     /* 253923 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(253962), // Rule ID 2481 //
     /* 253928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 253933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 253936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 253939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p3s32,
     /* 253945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253949 */     // (intrinsic_wo_chain:{ *:[i32] } 3333:{ *:[iPTR] }, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p3:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 253949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 253952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253956 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253958 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 253960 */     GIR_RootConstrainSelectedInstOperands,
     /* 253961 */     // GIR_Coverage, 2481,
     /* 253961 */     GIR_EraseRootFromParent_Done,
     /* 253962 */   // Label 4116: @253962
     /* 253962 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(254001), // Rule ID 2483 //
     /* 253967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 253972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 253975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 253978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p5s32,
     /* 253984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253988 */     // (intrinsic_wo_chain:{ *:[i32] } 3333:{ *:[iPTR] }, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p5:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 253988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 253991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253993 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253995 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 253997 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 253999 */     GIR_RootConstrainSelectedInstOperands,
     /* 254000 */     // GIR_Coverage, 2483,
     /* 254000 */     GIR_EraseRootFromParent_Done,
     /* 254001 */   // Label 4117: @254001
     /* 254001 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(254040), // Rule ID 2485 //
     /* 254006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 254011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 254014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 254017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 254020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p6s32,
     /* 254023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254027 */     // (intrinsic_wo_chain:{ *:[i32] } 3333:{ *:[iPTR] }, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p6:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 254027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 254030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254032 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 254034 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 254036 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 254038 */     GIR_RootConstrainSelectedInstOperands,
     /* 254039 */     // GIR_Coverage, 2485,
     /* 254039 */     GIR_EraseRootFromParent_Done,
     /* 254040 */   // Label 4118: @254040
     /* 254040 */   GIM_Reject,
     /* 254041 */ // Label 4082: @254041
     /* 254041 */ GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(256514),
     /* 254046 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 254049 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(254151), // Rule ID 2819 //
     /* 254054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 254057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 254062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 254065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 254071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 254074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 254078 */     // MIs[0] Operand 5
     /* 254078 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 254089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 254110 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3313:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w32_threeaddr:{ *:[v8f16] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, 8:{ *:[i32] }, v8f16:{ *:[v8f16] }:$src2)
     /* 254110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w32_threeaddr),
     /* 254113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 254138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254149 */     GIR_RootConstrainSelectedInstOperands,
     /* 254150 */     // GIR_Coverage, 2819,
     /* 254150 */     GIR_EraseRootFromParent_Done,
     /* 254151 */   // Label 4120: @254151
     /* 254151 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(254253), // Rule ID 2852 //
     /* 254156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 254159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 254164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 254167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 254173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 254176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 254180 */     // MIs[0] Operand 5
     /* 254180 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 254191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 254212 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3313:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w64_threeaddr:{ *:[v4f16] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, 8:{ *:[i32] }, v4f16:{ *:[v4f16] }:$src2)
     /* 254212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w64_threeaddr),
     /* 254215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 254240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254251 */     GIR_RootConstrainSelectedInstOperands,
     /* 254252 */     // GIR_Coverage, 2852,
     /* 254252 */     GIR_EraseRootFromParent_Done,
     /* 254253 */   // Label 4121: @254253
     /* 254253 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(254357), // Rule ID 2818 //
     /* 254258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 254261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 254266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 254269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 254275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 254278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 254282 */     // MIs[0] Operand 5
     /* 254282 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 254293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamodsf16NegAbs),
     /* 254314 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3313:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF16NegAbs:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w32_twoaddr:{ *:[v8f16] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f16:{ *:[v8f16] }:$src2)
     /* 254314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w32_twoaddr),
     /* 254317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 254344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254355 */     GIR_RootConstrainSelectedInstOperands,
     /* 254356 */     // GIR_Coverage, 2818,
     /* 254356 */     GIR_EraseRootFromParent_Done,
     /* 254357 */   // Label 4122: @254357
     /* 254357 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(254461), // Rule ID 2851 //
     /* 254362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 254365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 254370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 254373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 254379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 254382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 254386 */     // MIs[0] Operand 5
     /* 254386 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 254397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamodsf16NegAbs),
     /* 254418 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3313:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF16NegAbs:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w64_twoaddr:{ *:[v4f16] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f16:{ *:[v4f16] }:$src2)
     /* 254418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w64_twoaddr),
     /* 254421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 254448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254459 */     GIR_RootConstrainSelectedInstOperands,
     /* 254460 */     // GIR_Coverage, 2851,
     /* 254460 */     GIR_EraseRootFromParent_Done,
     /* 254461 */   // Label 4123: @254461
     /* 254461 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(254559), // Rule ID 2836 //
     /* 254466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 254469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_f16),
     /* 254474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 254477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 254483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 254486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 254489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 254493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 254514 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3293:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_F16_w32_twoaddr:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 254514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_F16_w32_twoaddr),
     /* 254517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254539 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 254541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 254551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254557 */     GIR_RootConstrainSelectedInstOperands,
     /* 254558 */     // GIR_Coverage, 2836,
     /* 254558 */     GIR_EraseRootFromParent_Done,
     /* 254559 */   // Label 4124: @254559
     /* 254559 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(254657), // Rule ID 2838 //
     /* 254564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 254567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f16_16x16x32_f16),
     /* 254572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 254575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 254581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 254584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 254587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 254591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 254612 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3289:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v8f16:{ *:[v8f16] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F16_16X16X32_F16_w32_twoaddr:{ *:[v8f16] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, v8f16:{ *:[v8f16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 254612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F16_16X16X32_F16_w32_twoaddr),
     /* 254615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254637 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 254639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 254649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254655 */     GIR_RootConstrainSelectedInstOperands,
     /* 254656 */     // GIR_Coverage, 2838,
     /* 254656 */     GIR_EraseRootFromParent_Done,
     /* 254657 */   // Label 4125: @254657
     /* 254657 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(254755), // Rule ID 2869 //
     /* 254662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 254665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_f16),
     /* 254670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 254673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 254679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 254682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 254685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 254689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 254710 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3293:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_F16_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 254710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_F16_w64_twoaddr),
     /* 254713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254735 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 254737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_8bit
     /* 254747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254753 */     GIR_RootConstrainSelectedInstOperands,
     /* 254754 */     // GIR_Coverage, 2869,
     /* 254754 */     GIR_EraseRootFromParent_Done,
     /* 254755 */   // Label 4126: @254755
     /* 254755 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(254853), // Rule ID 2871 //
     /* 254760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 254763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f16_16x16x32_f16),
     /* 254768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 254771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 254777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 254780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 254783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 254787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 254801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 254808 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3289:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v4f16:{ *:[v4f16] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F16_16X16X32_F16_w64_twoaddr:{ *:[v4f16] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, v4f16:{ *:[v4f16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 254808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F16_16X16X32_F16_w64_twoaddr),
     /* 254811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 254818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 254823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 254828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 254833 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 254835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 254840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_8bit
     /* 254845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254851 */     GIR_RootConstrainSelectedInstOperands,
     /* 254852 */     // GIR_Coverage, 2871,
     /* 254852 */     GIR_EraseRootFromParent_Done,
     /* 254853 */   // Label 4127: @254853
     /* 254853 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(254931), // Rule ID 2821 //
     /* 254858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 254861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 254866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 254869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 254875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 254878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 254882 */     // MIs[0] Operand 5
     /* 254882 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 254893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 254900 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3311:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, (WMMAVISrc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w32_threeaddr:{ *:[v8i16] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src2)
     /* 254900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w32_threeaddr),
     /* 254903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 254908 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 254910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 254913 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 254915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 254918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 254923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254929 */     GIR_RootConstrainSelectedInstOperands,
     /* 254930 */     // GIR_Coverage, 2821,
     /* 254930 */     GIR_EraseRootFromParent_Done,
     /* 254931 */   // Label 4128: @254931
     /* 254931 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(255009), // Rule ID 2854 //
     /* 254936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 254939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 254944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 254947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 254953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 254956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 254960 */     // MIs[0] Operand 5
     /* 254960 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 254971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 254978 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3311:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, (WMMAVISrc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w64_threeaddr:{ *:[v4i16] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src2)
     /* 254978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w64_threeaddr),
     /* 254981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 254986 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 254988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 254991 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 254993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 254996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255007 */     GIR_RootConstrainSelectedInstOperands,
     /* 255008 */     // GIR_Coverage, 2854,
     /* 255008 */     GIR_EraseRootFromParent_Done,
     /* 255009 */   // Label 4129: @255009
     /* 255009 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(255083), // Rule ID 2837 //
     /* 255014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 255017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf16),
     /* 255022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 255025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 255028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 255031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 255034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 255041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 255048 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3290:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_BF16_w32_twoaddr:{ *:[v8f32] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 255048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF16_w32_twoaddr),
     /* 255051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255056 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255061 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255063 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 255075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255081 */     GIR_RootConstrainSelectedInstOperands,
     /* 255082 */     // GIR_Coverage, 2837,
     /* 255082 */     GIR_EraseRootFromParent_Done,
     /* 255083 */   // Label 4130: @255083
     /* 255083 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(255157), // Rule ID 2839 //
     /* 255088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 255091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_bf16_16x16x32_bf16),
     /* 255096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 255099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 255102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 255105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 255108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 255115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 255122 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3288:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_BF16_16X16X32_BF16_w32_twoaddr:{ *:[v8i16] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 255122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_BF16_16X16X32_BF16_w32_twoaddr),
     /* 255125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255130 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255135 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255137 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 255149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255155 */     GIR_RootConstrainSelectedInstOperands,
     /* 255156 */     // GIR_Coverage, 2839,
     /* 255156 */     GIR_EraseRootFromParent_Done,
     /* 255157 */   // Label 4131: @255157
     /* 255157 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(255219), // Rule ID 2843 //
     /* 255162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 255165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_fp8),
     /* 255170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 255173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 255176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 255179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 255182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 255189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 255196 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3295:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 255196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_FP8_w32_twoaddr),
     /* 255199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255201 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255203 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255205 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 255217 */     GIR_RootConstrainSelectedInstOperands,
     /* 255218 */     // GIR_Coverage, 2843,
     /* 255218 */     GIR_EraseRootFromParent_Done,
     /* 255219 */   // Label 4132: @255219
     /* 255219 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(255281), // Rule ID 2844 //
     /* 255224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 255227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_bf8),
     /* 255232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 255235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 255238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 255241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 255244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 255251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 255258 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3294:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 255258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_BF8_w32_twoaddr),
     /* 255261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255263 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255265 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255267 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 255279 */     GIR_RootConstrainSelectedInstOperands,
     /* 255280 */     // GIR_Coverage, 2844,
     /* 255280 */     GIR_EraseRootFromParent_Done,
     /* 255281 */   // Label 4133: @255281
     /* 255281 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(255343), // Rule ID 2845 //
     /* 255286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 255289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_fp8),
     /* 255294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 255297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 255300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 255303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 255306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 255313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 255320 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3292:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 255320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_FP8_w32_twoaddr),
     /* 255323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255325 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255327 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255329 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 255341 */     GIR_RootConstrainSelectedInstOperands,
     /* 255342 */     // GIR_Coverage, 2845,
     /* 255342 */     GIR_EraseRootFromParent_Done,
     /* 255343 */   // Label 4134: @255343
     /* 255343 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(255405), // Rule ID 2846 //
     /* 255348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 255351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_bf8),
     /* 255356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 255359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 255362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 255365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 255368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 255375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 255382 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3291:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 255382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_BF8_w32_twoaddr),
     /* 255385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255387 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255389 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255391 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 255403 */     GIR_RootConstrainSelectedInstOperands,
     /* 255404 */     // GIR_Coverage, 2846,
     /* 255404 */     GIR_EraseRootFromParent_Done,
     /* 255405 */   // Label 4135: @255405
     /* 255405 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(255479), // Rule ID 2870 //
     /* 255410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 255413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf16),
     /* 255418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 255421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 255424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 255427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 255430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 255437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 255444 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3290:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_BF16_w64_twoaddr:{ *:[v4f32] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 255444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF16_w64_twoaddr),
     /* 255447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255452 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255457 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255459 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 255471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255477 */     GIR_RootConstrainSelectedInstOperands,
     /* 255478 */     // GIR_Coverage, 2870,
     /* 255478 */     GIR_EraseRootFromParent_Done,
     /* 255479 */   // Label 4136: @255479
     /* 255479 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(255553), // Rule ID 2872 //
     /* 255484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 255487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_bf16_16x16x32_bf16),
     /* 255492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 255495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 255498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 255501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 255504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 255511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 255518 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3288:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v4i16:{ *:[v4i16] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_BF16_16X16X32_BF16_w64_twoaddr:{ *:[v4i16] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, v4i16:{ *:[v4i16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 255518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_BF16_16X16X32_BF16_w64_twoaddr),
     /* 255521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255526 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255531 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255533 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 255545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255551 */     GIR_RootConstrainSelectedInstOperands,
     /* 255552 */     // GIR_Coverage, 2872,
     /* 255552 */     GIR_EraseRootFromParent_Done,
     /* 255553 */   // Label 4137: @255553
     /* 255553 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(255615), // Rule ID 2876 //
     /* 255558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 255561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_fp8),
     /* 255566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 255569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 255572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 255575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 255578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 255585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 255592 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3295:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 255592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_FP8_w64_twoaddr),
     /* 255595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255597 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255599 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255601 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 255613 */     GIR_RootConstrainSelectedInstOperands,
     /* 255614 */     // GIR_Coverage, 2876,
     /* 255614 */     GIR_EraseRootFromParent_Done,
     /* 255615 */   // Label 4138: @255615
     /* 255615 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(255677), // Rule ID 2877 //
     /* 255620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 255623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_bf8),
     /* 255628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 255631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 255634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 255637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 255640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 255647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 255654 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3294:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 255654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_BF8_w64_twoaddr),
     /* 255657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255659 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255661 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255663 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 255675 */     GIR_RootConstrainSelectedInstOperands,
     /* 255676 */     // GIR_Coverage, 2877,
     /* 255676 */     GIR_EraseRootFromParent_Done,
     /* 255677 */   // Label 4139: @255677
     /* 255677 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(255739), // Rule ID 2878 //
     /* 255682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 255685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_fp8),
     /* 255690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 255693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 255696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 255699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 255702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 255709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 255716 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3292:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 255716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_FP8_w64_twoaddr),
     /* 255719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255721 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255723 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255725 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 255737 */     GIR_RootConstrainSelectedInstOperands,
     /* 255738 */     // GIR_Coverage, 2878,
     /* 255738 */     GIR_EraseRootFromParent_Done,
     /* 255739 */   // Label 4140: @255739
     /* 255739 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(255801), // Rule ID 2879 //
     /* 255744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 255747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_bf8),
     /* 255752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 255755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 255758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 255761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 255764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 255767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 255771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 255778 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3291:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 255778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_BF8_w64_twoaddr),
     /* 255781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255783 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255785 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255787 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 255789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 255794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 255799 */     GIR_RootConstrainSelectedInstOperands,
     /* 255800 */     // GIR_Coverage, 2879,
     /* 255800 */     GIR_EraseRootFromParent_Done,
     /* 255801 */   // Label 4141: @255801
     /* 255801 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(255873), // Rule ID 2798 //
     /* 255806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 255809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 255814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 255817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 255820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 255823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
     /* 255826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 255830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 255837 */     // (intrinsic_wo_chain:{ *:[v16f16] } 3313:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v16f16:{ *:[v16f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_twoaddr_w32:{ *:[v16f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16f16:{ *:[v16f16] }:$src2)
     /* 255837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_twoaddr_w32),
     /* 255840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255845 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255850 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 255857 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 255859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255871 */     GIR_RootConstrainSelectedInstOperands,
     /* 255872 */     // GIR_Coverage, 2798,
     /* 255872 */     GIR_EraseRootFromParent_Done,
     /* 255873 */   // Label 4142: @255873
     /* 255873 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(255945), // Rule ID 2802 //
     /* 255878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 255881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 255886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 255889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 255892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 255895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
     /* 255898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 255902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 255909 */     // (intrinsic_wo_chain:{ *:[v16i16] } 3311:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v16i16:{ *:[v16i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_twoaddr_w32:{ *:[v16i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16i16:{ *:[v16i16] }:$src2)
     /* 255909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_twoaddr_w32),
     /* 255912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255917 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255922 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 255929 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 255931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255943 */     GIR_RootConstrainSelectedInstOperands,
     /* 255944 */     // GIR_Coverage, 2802,
     /* 255944 */     GIR_EraseRootFromParent_Done,
     /* 255945 */   // Label 4143: @255945
     /* 255945 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(256017), // Rule ID 2803 //
     /* 255950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 255953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16_tied),
     /* 255958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 255961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 255964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 255967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
     /* 255970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 255974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 255981 */     // (intrinsic_wo_chain:{ *:[v16f16] } 3314:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v16f16:{ *:[v16f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w32:{ *:[v16f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16f16:{ *:[v16f16] }:$src2)
     /* 255981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w32),
     /* 255984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255989 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 255994 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256001 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256015 */     GIR_RootConstrainSelectedInstOperands,
     /* 256016 */     // GIR_Coverage, 2803,
     /* 256016 */     GIR_EraseRootFromParent_Done,
     /* 256017 */   // Label 4144: @256017
     /* 256017 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(256089), // Rule ID 2804 //
     /* 256022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 256025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16_tied),
     /* 256030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 256033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
     /* 256042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 256053 */     // (intrinsic_wo_chain:{ *:[v16i16] } 3312:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v16i16:{ *:[v16i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w32:{ *:[v16i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16i16:{ *:[v16i16] }:$src2)
     /* 256053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w32),
     /* 256056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256061 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256066 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256073 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256087 */     GIR_RootConstrainSelectedInstOperands,
     /* 256088 */     // GIR_Coverage, 2804,
     /* 256088 */     GIR_EraseRootFromParent_Done,
     /* 256089 */   // Label 4145: @256089
     /* 256089 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(256161), // Rule ID 2808 //
     /* 256094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 256097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 256102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 256114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 256125 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3313:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v8f16:{ *:[v8f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_twoaddr_w64:{ *:[v8f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f16:{ *:[v8f16] }:$src2)
     /* 256125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_twoaddr_w64),
     /* 256128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256138 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256145 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256159 */     GIR_RootConstrainSelectedInstOperands,
     /* 256160 */     // GIR_Coverage, 2808,
     /* 256160 */     GIR_EraseRootFromParent_Done,
     /* 256161 */   // Label 4146: @256161
     /* 256161 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(256233), // Rule ID 2809 //
     /* 256166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 256169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 256174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 256186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 256197 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3311:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_twoaddr_w64:{ *:[v8i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8i16:{ *:[v8i16] }:$src2)
     /* 256197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_twoaddr_w64),
     /* 256200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256205 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256210 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256217 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256231 */     GIR_RootConstrainSelectedInstOperands,
     /* 256232 */     // GIR_Coverage, 2809,
     /* 256232 */     GIR_EraseRootFromParent_Done,
     /* 256233 */   // Label 4147: @256233
     /* 256233 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(256305), // Rule ID 2810 //
     /* 256238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 256241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16_tied),
     /* 256246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 256258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 256269 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3314:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v8f16:{ *:[v8f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w64:{ *:[v8f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f16:{ *:[v8f16] }:$src2)
     /* 256269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w64),
     /* 256272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256277 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256282 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256289 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256303 */     GIR_RootConstrainSelectedInstOperands,
     /* 256304 */     // GIR_Coverage, 2810,
     /* 256304 */     GIR_EraseRootFromParent_Done,
     /* 256305 */   // Label 4148: @256305
     /* 256305 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(256377), // Rule ID 2811 //
     /* 256310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 256313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16_tied),
     /* 256318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 256330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 256341 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3312:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w64:{ *:[v8i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8i16:{ *:[v8i16] }:$src2)
     /* 256341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w64),
     /* 256344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256349 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256354 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 256361 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256375 */     GIR_RootConstrainSelectedInstOperands,
     /* 256376 */     // GIR_Coverage, 2811,
     /* 256376 */     GIR_EraseRootFromParent_Done,
     /* 256377 */   // Label 4149: @256377
     /* 256377 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(256445), // Rule ID 2820 //
     /* 256382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 256385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 256390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 256399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 256402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256406 */     // MIs[0] Operand 5
     /* 256406 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 256417 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3311:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2, 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w32_twoaddr:{ *:[v8i16] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src2)
     /* 256417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w32_twoaddr),
     /* 256420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256430 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256435 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256443 */     GIR_RootConstrainSelectedInstOperands,
     /* 256444 */     // GIR_Coverage, 2820,
     /* 256444 */     GIR_EraseRootFromParent_Done,
     /* 256445 */   // Label 4150: @256445
     /* 256445 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(256513), // Rule ID 2853 //
     /* 256450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 256453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 256458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 256461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 256467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 256470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 256474 */     // MIs[0] Operand 5
     /* 256474 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 256485 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3311:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4i16:{ *:[v4i16] }:$src2, 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w64_twoaddr:{ *:[v4i16] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src2)
     /* 256485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w64_twoaddr),
     /* 256488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256493 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256498 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256503 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 256505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256511 */     GIR_RootConstrainSelectedInstOperands,
     /* 256512 */     // GIR_Coverage, 2853,
     /* 256512 */     GIR_EraseRootFromParent_Done,
     /* 256513 */   // Label 4151: @256513
     /* 256513 */   GIM_Reject,
     /* 256514 */ // Label 4119: @256514
     /* 256514 */ GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(256786),
     /* 256519 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 256522 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(256592), // Rule ID 2423 //
     /* 256527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 256530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp),
     /* 256535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 256541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 256545 */     // MIs[0] dpp_ctrl
     /* 256545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 256548 */     // MIs[0] row_mask
     /* 256548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256551 */     // MIs[0] bank_mask
     /* 256551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 256554 */     // MIs[0] bound_ctrl
     /* 256554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 256557 */     // (intrinsic_wo_chain:{ *:[i32] } 3067:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 256557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 256560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256562 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 256564 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 256566 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 256572 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 256578 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 256584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 256590 */     GIR_RootConstrainSelectedInstOperands,
     /* 256591 */     // GIR_Coverage, 2423,
     /* 256591 */     GIR_EraseRootFromParent_Done,
     /* 256592 */   // Label 4153: @256592
     /* 256592 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(256659), // Rule ID 7546 //
     /* 256597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp),
     /* 256602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 256605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 256612 */     // MIs[0] dpp_ctrl
     /* 256612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 256615 */     // MIs[0] row_mask
     /* 256615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256618 */     // MIs[0] bank_mask
     /* 256618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 256621 */     // MIs[0] bound_ctrl
     /* 256621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 256624 */     // (intrinsic_wo_chain:{ *:[i64] } 3067:{ *:[iPTR] }, i64:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$src, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 256624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 256627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256629 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 256631 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 256633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 256639 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 256645 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 256651 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 256657 */     GIR_RootConstrainSelectedInstOperands,
     /* 256658 */     // GIR_Coverage, 7546,
     /* 256658 */     GIR_EraseRootFromParent_Done,
     /* 256659 */   // Label 4154: @256659
     /* 256659 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(256722), // Rule ID 2674 //
     /* 256664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 256667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16_var),
     /* 256672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 256678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 256681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 256684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 256688 */     // MIs[0] fi
     /* 256688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 256691 */     // MIs[0] bc
     /* 256691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 256694 */     // (intrinsic_wo_chain:{ *:[i32] } 3079:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_VAR_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), VGPR_32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 256694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_VAR_B32_e64),
     /* 256697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 256705 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 256707 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 256713 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 256715 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 256717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256720 */     GIR_RootConstrainSelectedInstOperands,
     /* 256721 */     // GIR_Coverage, 2674,
     /* 256721 */     GIR_EraseRootFromParent_Done,
     /* 256722 */   // Label 4155: @256722
     /* 256722 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(256785), // Rule ID 2675 //
     /* 256727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 256730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16_var),
     /* 256735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 256741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 256744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 256747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 256751 */     // MIs[0] fi
     /* 256751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 256754 */     // MIs[0] bc
     /* 256754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 256757 */     // (intrinsic_wo_chain:{ *:[i32] } 3083:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_VAR_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), VGPR_32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 256757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_VAR_B32_e64),
     /* 256760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256762 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 256768 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 256770 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 256776 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 256778 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 256780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256783 */     GIR_RootConstrainSelectedInstOperands,
     /* 256784 */     // GIR_Coverage, 2675,
     /* 256784 */     GIR_EraseRootFromParent_Done,
     /* 256785 */   // Label 4156: @256785
     /* 256785 */   GIM_Reject,
     /* 256786 */ // Label 4152: @256786
     /* 256786 */ GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(267105),
     /* 256791 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 256794 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(256875), // Rule ID 2823 //
     /* 256799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 256802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 256807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 256810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 256813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 256816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 256819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256823 */     // MIs[0] clamp
     /* 256823 */     // No operand predicates
     /* 256823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 256830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 256837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 256844 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3322:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8i32] } v8i32:{ *:[v8i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w32_threeaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 256844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w32_threeaddr),
     /* 256847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 256854 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 256856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 256861 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 256863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 256868 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 256870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256873 */     GIR_RootConstrainSelectedInstOperands,
     /* 256874 */     // GIR_Coverage, 2823,
     /* 256874 */     GIR_EraseRootFromParent_Done,
     /* 256875 */   // Label 4158: @256875
     /* 256875 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(256956), // Rule ID 2825 //
     /* 256880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 256883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 256888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 256891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 256894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 256897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 256900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256904 */     // MIs[0] clamp
     /* 256904 */     // No operand predicates
     /* 256904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 256911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 256918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 256925 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3321:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v8i32] } v8i32:{ *:[v8i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w32_threeaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 256925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w32_threeaddr),
     /* 256928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 256935 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 256937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 256942 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 256944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 256949 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 256951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256954 */     GIR_RootConstrainSelectedInstOperands,
     /* 256955 */     // GIR_Coverage, 2825,
     /* 256955 */     GIR_EraseRootFromParent_Done,
     /* 256956 */   // Label 4159: @256956
     /* 256956 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(257037), // Rule ID 2835 //
     /* 256961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 256964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
     /* 256969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 256972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 256975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 256978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 256981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256985 */     // MIs[0] clamp
     /* 256985 */     // No operand predicates
     /* 256985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 256992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 256999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257006 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3323:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8i32] } v8i32:{ *:[v8i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w32_threeaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w32_threeaddr),
     /* 257009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257016 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257023 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 257030 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257035 */     GIR_RootConstrainSelectedInstOperands,
     /* 257036 */     // GIR_Coverage, 2835,
     /* 257036 */     GIR_EraseRootFromParent_Done,
     /* 257037 */   // Label 4160: @257037
     /* 257037 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(257118), // Rule ID 2856 //
     /* 257042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 257050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 257059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 257062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257066 */     // MIs[0] clamp
     /* 257066 */     // No operand predicates
     /* 257066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257087 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3322:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w64_threeaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w64_threeaddr),
     /* 257090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257097 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257104 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 257111 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257116 */     GIR_RootConstrainSelectedInstOperands,
     /* 257117 */     // GIR_Coverage, 2856,
     /* 257117 */     GIR_EraseRootFromParent_Done,
     /* 257118 */   // Label 4161: @257118
     /* 257118 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(257199), // Rule ID 2858 //
     /* 257123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 257131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 257140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 257143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257147 */     // MIs[0] clamp
     /* 257147 */     // No operand predicates
     /* 257147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257168 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3321:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w64_threeaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w64_threeaddr),
     /* 257171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257178 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257185 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 257192 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257197 */     GIR_RootConstrainSelectedInstOperands,
     /* 257198 */     // GIR_Coverage, 2858,
     /* 257198 */     GIR_EraseRootFromParent_Done,
     /* 257199 */   // Label 4162: @257199
     /* 257199 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(257280), // Rule ID 2868 //
     /* 257204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
     /* 257212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 257221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 257224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257228 */     // MIs[0] clamp
     /* 257228 */     // No operand predicates
     /* 257228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257249 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3323:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w64_threeaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w64_threeaddr),
     /* 257252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257259 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257266 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 257273 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257278 */     GIR_RootConstrainSelectedInstOperands,
     /* 257279 */     // GIR_Coverage, 2868,
     /* 257279 */     GIR_EraseRootFromParent_Done,
     /* 257280 */   // Label 4163: @257280
     /* 257280 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(257360), // Rule ID 2799 //
     /* 257285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 257288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 257293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /* 257302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 257305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257309 */     // MIs[0] clamp
     /* 257309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 257312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257326 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3322:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v4i32:{ *:[v4i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_twoaddr_w32:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v4i32:{ *:[v4i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, 8:{ *:[i32] }, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_twoaddr_w32),
     /* 257329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257336 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257343 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257348 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257350 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257358 */     GIR_RootConstrainSelectedInstOperands,
     /* 257359 */     // GIR_Coverage, 2799,
     /* 257359 */     GIR_EraseRootFromParent_Done,
     /* 257360 */   // Label 4164: @257360
     /* 257360 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(257440), // Rule ID 2805 //
     /* 257365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 257368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 257373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 257382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 257385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257389 */     // MIs[0] clamp
     /* 257389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 257392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257406 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3321:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_twoaddr_w32:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_twoaddr_w32),
     /* 257409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257416 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257423 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257428 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257430 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257438 */     GIR_RootConstrainSelectedInstOperands,
     /* 257439 */     // GIR_Coverage, 2805,
     /* 257439 */     GIR_EraseRootFromParent_Done,
     /* 257440 */   // Label 4165: @257440
     /* 257440 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(257520), // Rule ID 2812 //
     /* 257445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 257448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 257453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /* 257462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 257465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257469 */     // MIs[0] clamp
     /* 257469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 257472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257486 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3322:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v4i32:{ *:[v4i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_twoaddr_w64:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, v4i32:{ *:[v4i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, 8:{ *:[i32] }, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_twoaddr_w64),
     /* 257489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257496 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257503 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257508 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257510 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257518 */     GIR_RootConstrainSelectedInstOperands,
     /* 257519 */     // GIR_Coverage, 2812,
     /* 257519 */     GIR_EraseRootFromParent_Done,
     /* 257520 */   // Label 4166: @257520
     /* 257520 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(257600), // Rule ID 2813 //
     /* 257525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 257528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 257533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 257542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 257545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257549 */     // MIs[0] clamp
     /* 257549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 257552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257566 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3321:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_twoaddr_w64:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_twoaddr_w64),
     /* 257569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257576 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257583 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257588 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257590 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257598 */     GIR_RootConstrainSelectedInstOperands,
     /* 257599 */     // GIR_Coverage, 2813,
     /* 257599 */     GIR_EraseRootFromParent_Done,
     /* 257600 */   // Label 4167: @257600
     /* 257600 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(257671), // Rule ID 2822 //
     /* 257605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 257613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 257622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 257625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257629 */     // MIs[0] clamp
     /* 257629 */     // No operand predicates
     /* 257629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257643 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3322:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w32_twoaddr),
     /* 257646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257653 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257660 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257662 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257664 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257669 */     GIR_RootConstrainSelectedInstOperands,
     /* 257670 */     // GIR_Coverage, 2822,
     /* 257670 */     GIR_EraseRootFromParent_Done,
     /* 257671 */   // Label 4168: @257671
     /* 257671 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(257742), // Rule ID 2824 //
     /* 257676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 257684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 257693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 257696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257700 */     // MIs[0] clamp
     /* 257700 */     // No operand predicates
     /* 257700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257714 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3321:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w32_twoaddr),
     /* 257717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257724 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257731 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257733 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257735 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257740 */     GIR_RootConstrainSelectedInstOperands,
     /* 257741 */     // GIR_Coverage, 2824,
     /* 257741 */     GIR_EraseRootFromParent_Done,
     /* 257742 */   // Label 4169: @257742
     /* 257742 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(257813), // Rule ID 2834 //
     /* 257747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
     /* 257755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 257764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 257767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257771 */     // MIs[0] clamp
     /* 257771 */     // No operand predicates
     /* 257771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257785 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3323:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w32_twoaddr),
     /* 257788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257795 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257802 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257804 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257806 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257811 */     GIR_RootConstrainSelectedInstOperands,
     /* 257812 */     // GIR_Coverage, 2834,
     /* 257812 */     GIR_EraseRootFromParent_Done,
     /* 257813 */   // Label 4170: @257813
     /* 257813 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(257884), // Rule ID 2855 //
     /* 257818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 257826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 257835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 257838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257842 */     // MIs[0] clamp
     /* 257842 */     // No operand predicates
     /* 257842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257856 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3322:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w64_twoaddr),
     /* 257859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257866 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257873 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257875 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257877 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257882 */     GIR_RootConstrainSelectedInstOperands,
     /* 257883 */     // GIR_Coverage, 2855,
     /* 257883 */     GIR_EraseRootFromParent_Done,
     /* 257884 */   // Label 4171: @257884
     /* 257884 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(257955), // Rule ID 2857 //
     /* 257889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 257897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 257906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 257909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257913 */     // MIs[0] clamp
     /* 257913 */     // No operand predicates
     /* 257913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257927 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3321:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w64_twoaddr),
     /* 257930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 257937 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 257939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 257944 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 257946 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 257948 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 257950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257953 */     GIR_RootConstrainSelectedInstOperands,
     /* 257954 */     // GIR_Coverage, 2857,
     /* 257954 */     GIR_EraseRootFromParent_Done,
     /* 257955 */   // Label 4172: @257955
     /* 257955 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(258026), // Rule ID 2867 //
     /* 257960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
     /* 257968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 257977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 257980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257984 */     // MIs[0] clamp
     /* 257984 */     // No operand predicates
     /* 257984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 257998 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3323:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 257998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w64_twoaddr),
     /* 258001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 258008 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 258010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 258015 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 258017 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 258019 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 258021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258024 */     GIR_RootConstrainSelectedInstOperands,
     /* 258025 */     // GIR_Coverage, 2867,
     /* 258025 */     GIR_EraseRootFromParent_Done,
     /* 258026 */   // Label 4173: @258026
     /* 258026 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(258099), // Rule ID 2424 //
     /* 258031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 258042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 258045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258052 */     // MIs[0] dpp_ctrl
     /* 258052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258055 */     // MIs[0] row_mask
     /* 258055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258058 */     // MIs[0] bank_mask
     /* 258058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258061 */     // MIs[0] bound_ctrl
     /* 258061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258064 */     // (intrinsic_wo_chain:{ *:[i32] } 3305:{ *:[iPTR] }, i32:{ *:[i32] }:$old, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258069 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258071 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258073 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258079 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258085 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258091 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258097 */     GIR_RootConstrainSelectedInstOperands,
     /* 258098 */     // GIR_Coverage, 2424,
     /* 258098 */     GIR_EraseRootFromParent_Done,
     /* 258099 */   // Label 4174: @258099
     /* 258099 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(258172), // Rule ID 2425 //
     /* 258104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 258115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 258118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258125 */     // MIs[0] dpp_ctrl
     /* 258125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258128 */     // MIs[0] row_mask
     /* 258128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258131 */     // MIs[0] bank_mask
     /* 258131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258134 */     // MIs[0] bound_ctrl
     /* 258134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258137 */     // (intrinsic_wo_chain:{ *:[f32] } 3305:{ *:[iPTR] }, f32:{ *:[f32] }:$old, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[f32] } VGPR_32:{ *:[f32] }:$old, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258142 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258144 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258146 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258158 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258164 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258170 */     GIR_RootConstrainSelectedInstOperands,
     /* 258171 */     // GIR_Coverage, 2425,
     /* 258171 */     GIR_EraseRootFromParent_Done,
     /* 258172 */   // Label 4175: @258172
     /* 258172 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(258245), // Rule ID 2426 //
     /* 258177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 258188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 258191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 258194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258198 */     // MIs[0] dpp_ctrl
     /* 258198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258201 */     // MIs[0] row_mask
     /* 258201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258204 */     // MIs[0] bank_mask
     /* 258204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258207 */     // MIs[0] bound_ctrl
     /* 258207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258210 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3305:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$old, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$old, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258215 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258217 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258219 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258225 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258231 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258237 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258243 */     GIR_RootConstrainSelectedInstOperands,
     /* 258244 */     // GIR_Coverage, 2426,
     /* 258244 */     GIR_EraseRootFromParent_Done,
     /* 258245 */   // Label 4176: @258245
     /* 258245 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(258318), // Rule ID 2427 //
     /* 258250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 258261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 258264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 258267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258271 */     // MIs[0] dpp_ctrl
     /* 258271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258274 */     // MIs[0] row_mask
     /* 258274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258277 */     // MIs[0] bank_mask
     /* 258277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258280 */     // MIs[0] bound_ctrl
     /* 258280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258283 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3305:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$old, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$old, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258288 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258290 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258292 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258298 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258304 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258310 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258316 */     GIR_RootConstrainSelectedInstOperands,
     /* 258317 */     // GIR_Coverage, 2427,
     /* 258317 */     GIR_EraseRootFromParent_Done,
     /* 258318 */   // Label 4177: @258318
     /* 258318 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(258391), // Rule ID 2428 //
     /* 258323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 258334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 258337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
     /* 258340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258344 */     // MIs[0] dpp_ctrl
     /* 258344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258347 */     // MIs[0] row_mask
     /* 258347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258350 */     // MIs[0] bank_mask
     /* 258350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258353 */     // MIs[0] bound_ctrl
     /* 258353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258356 */     // (intrinsic_wo_chain:{ *:[i32] } 3305:{ *:[iPTR] }, p2:{ *:[i32] }:$old, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258361 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258363 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258365 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258371 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258377 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258383 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258389 */     GIR_RootConstrainSelectedInstOperands,
     /* 258390 */     // GIR_Coverage, 2428,
     /* 258390 */     GIR_EraseRootFromParent_Done,
     /* 258391 */   // Label 4178: @258391
     /* 258391 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(258464), // Rule ID 2429 //
     /* 258396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 258407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 258410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
     /* 258413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258417 */     // MIs[0] dpp_ctrl
     /* 258417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258420 */     // MIs[0] row_mask
     /* 258420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258423 */     // MIs[0] bank_mask
     /* 258423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258426 */     // MIs[0] bound_ctrl
     /* 258426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258429 */     // (intrinsic_wo_chain:{ *:[i32] } 3305:{ *:[iPTR] }, p3:{ *:[i32] }:$old, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258434 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258436 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258438 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258444 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258450 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258456 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258462 */     GIR_RootConstrainSelectedInstOperands,
     /* 258463 */     // GIR_Coverage, 2429,
     /* 258463 */     GIR_EraseRootFromParent_Done,
     /* 258464 */   // Label 4179: @258464
     /* 258464 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(258537), // Rule ID 2430 //
     /* 258469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 258480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 258483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
     /* 258486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258490 */     // MIs[0] dpp_ctrl
     /* 258490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258493 */     // MIs[0] row_mask
     /* 258493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258496 */     // MIs[0] bank_mask
     /* 258496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258499 */     // MIs[0] bound_ctrl
     /* 258499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258502 */     // (intrinsic_wo_chain:{ *:[i32] } 3305:{ *:[iPTR] }, p5:{ *:[i32] }:$old, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258507 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258509 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258511 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258517 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258523 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258529 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258535 */     GIR_RootConstrainSelectedInstOperands,
     /* 258536 */     // GIR_Coverage, 2430,
     /* 258536 */     GIR_EraseRootFromParent_Done,
     /* 258537 */   // Label 4180: @258537
     /* 258537 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(258610), // Rule ID 2431 //
     /* 258542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 258545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 258553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 258556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
     /* 258559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258563 */     // MIs[0] dpp_ctrl
     /* 258563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258566 */     // MIs[0] row_mask
     /* 258566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258569 */     // MIs[0] bank_mask
     /* 258569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258572 */     // MIs[0] bound_ctrl
     /* 258572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258575 */     // (intrinsic_wo_chain:{ *:[i32] } 3305:{ *:[iPTR] }, p6:{ *:[i32] }:$old, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 258578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258580 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258582 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258590 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258602 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258608 */     GIR_RootConstrainSelectedInstOperands,
     /* 258609 */     // GIR_Coverage, 2431,
     /* 258609 */     GIR_EraseRootFromParent_Done,
     /* 258610 */   // Label 4181: @258610
     /* 258610 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(258680), // Rule ID 7547 //
     /* 258615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 258623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 258626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 258629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 258633 */     // MIs[0] dpp_ctrl
     /* 258633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258636 */     // MIs[0] row_mask
     /* 258636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258639 */     // MIs[0] bank_mask
     /* 258639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258642 */     // MIs[0] bound_ctrl
     /* 258642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258645 */     // (intrinsic_wo_chain:{ *:[i64] } 3305:{ *:[iPTR] }, i64:{ *:[i64] }:$old, i64:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 258648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258650 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258652 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258660 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258666 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258672 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258678 */     GIR_RootConstrainSelectedInstOperands,
     /* 258679 */     // GIR_Coverage, 7547,
     /* 258679 */     GIR_EraseRootFromParent_Done,
     /* 258680 */   // Label 4182: @258680
     /* 258680 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(258750), // Rule ID 7548 //
     /* 258685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 258693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 258696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 258699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 258703 */     // MIs[0] dpp_ctrl
     /* 258703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258706 */     // MIs[0] row_mask
     /* 258706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258709 */     // MIs[0] bank_mask
     /* 258709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258712 */     // MIs[0] bound_ctrl
     /* 258712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258715 */     // (intrinsic_wo_chain:{ *:[f64] } 3305:{ *:[iPTR] }, f64:{ *:[f64] }:$old, f64:{ *:[f64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[f64] } VReg_64_Align2:{ *:[f64] }:$old, VReg_64_Align2:{ *:[f64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 258718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258720 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258722 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258742 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258748 */     GIR_RootConstrainSelectedInstOperands,
     /* 258749 */     // GIR_Coverage, 7548,
     /* 258749 */     GIR_EraseRootFromParent_Done,
     /* 258750 */   // Label 4183: @258750
     /* 258750 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(258820), // Rule ID 7549 //
     /* 258755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 258763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 258766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 258769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 258773 */     // MIs[0] dpp_ctrl
     /* 258773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258776 */     // MIs[0] row_mask
     /* 258776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258779 */     // MIs[0] bank_mask
     /* 258779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258782 */     // MIs[0] bound_ctrl
     /* 258782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258785 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3305:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$old, v2i32:{ *:[v2i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v2i32] } VReg_64_Align2:{ *:[v2i32] }:$old, VReg_64_Align2:{ *:[v2i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 258788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258790 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258792 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258794 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258800 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258806 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258812 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258818 */     GIR_RootConstrainSelectedInstOperands,
     /* 258819 */     // GIR_Coverage, 7549,
     /* 258819 */     GIR_EraseRootFromParent_Done,
     /* 258820 */   // Label 4184: @258820
     /* 258820 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(258890), // Rule ID 7550 //
     /* 258825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 258833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 258836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 258839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 258843 */     // MIs[0] dpp_ctrl
     /* 258843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258846 */     // MIs[0] row_mask
     /* 258846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258849 */     // MIs[0] bank_mask
     /* 258849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258852 */     // MIs[0] bound_ctrl
     /* 258852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258855 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3305:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$old, v2f32:{ *:[v2f32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v2f32] } VReg_64_Align2:{ *:[v2f32] }:$old, VReg_64_Align2:{ *:[v2f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 258858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258860 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258862 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258864 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258870 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258876 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258882 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258888 */     GIR_RootConstrainSelectedInstOperands,
     /* 258889 */     // GIR_Coverage, 7550,
     /* 258889 */     GIR_EraseRootFromParent_Done,
     /* 258890 */   // Label 4185: @258890
     /* 258890 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(258960), // Rule ID 7551 //
     /* 258895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p0s64,
     /* 258903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 258906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 258909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 258913 */     // MIs[0] dpp_ctrl
     /* 258913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258916 */     // MIs[0] row_mask
     /* 258916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258919 */     // MIs[0] bank_mask
     /* 258919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258922 */     // MIs[0] bound_ctrl
     /* 258922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258925 */     // (intrinsic_wo_chain:{ *:[i64] } 3305:{ *:[iPTR] }, p0:{ *:[i64] }:$old, p0:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 258928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258930 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 258932 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 258934 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 258940 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 258946 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 258952 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 258958 */     GIR_RootConstrainSelectedInstOperands,
     /* 258959 */     // GIR_Coverage, 7551,
     /* 258959 */     GIR_EraseRootFromParent_Done,
     /* 258960 */   // Label 4186: @258960
     /* 258960 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(259030), // Rule ID 7552 //
     /* 258965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 258970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p1s64,
     /* 258973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p1s64,
     /* 258976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p1s64,
     /* 258979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 258983 */     // MIs[0] dpp_ctrl
     /* 258983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 258986 */     // MIs[0] row_mask
     /* 258986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258989 */     // MIs[0] bank_mask
     /* 258989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 258992 */     // MIs[0] bound_ctrl
     /* 258992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 258995 */     // (intrinsic_wo_chain:{ *:[i64] } 3305:{ *:[iPTR] }, p1:{ *:[i64] }:$old, p1:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 258995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 258998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259000 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 259002 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 259004 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 259010 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 259016 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 259022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 259028 */     GIR_RootConstrainSelectedInstOperands,
     /* 259029 */     // GIR_Coverage, 7552,
     /* 259029 */     GIR_EraseRootFromParent_Done,
     /* 259030 */   // Label 4187: @259030
     /* 259030 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(259100), // Rule ID 7553 //
     /* 259035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 259040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p4s64,
     /* 259043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p4s64,
     /* 259046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p4s64,
     /* 259049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 259053 */     // MIs[0] dpp_ctrl
     /* 259053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 259056 */     // MIs[0] row_mask
     /* 259056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259059 */     // MIs[0] bank_mask
     /* 259059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259062 */     // MIs[0] bound_ctrl
     /* 259062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259065 */     // (intrinsic_wo_chain:{ *:[i64] } 3305:{ *:[iPTR] }, p4:{ *:[i64] }:$old, p4:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 259065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 259068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259070 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 259072 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 259074 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 259080 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 259086 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 259092 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 259098 */     GIR_RootConstrainSelectedInstOperands,
     /* 259099 */     // GIR_Coverage, 7553,
     /* 259099 */     GIR_EraseRootFromParent_Done,
     /* 259100 */   // Label 4188: @259100
     /* 259100 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(259170), // Rule ID 7554 //
     /* 259105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 259110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 259113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 259119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 259123 */     // MIs[0] dpp_ctrl
     /* 259123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 259126 */     // MIs[0] row_mask
     /* 259126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259129 */     // MIs[0] bank_mask
     /* 259129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259132 */     // MIs[0] bound_ctrl
     /* 259132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259135 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3305:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$old, v4i16:{ *:[v4i16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v4i16] } VReg_64_Align2:{ *:[v4i16] }:$old, VReg_64_Align2:{ *:[v4i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 259135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 259138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259140 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 259142 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 259144 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 259150 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 259156 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 259162 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 259168 */     GIR_RootConstrainSelectedInstOperands,
     /* 259169 */     // GIR_Coverage, 7554,
     /* 259169 */     GIR_EraseRootFromParent_Done,
     /* 259170 */   // Label 4189: @259170
     /* 259170 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(259240), // Rule ID 7555 //
     /* 259175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 259180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 259183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 259189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 259193 */     // MIs[0] dpp_ctrl
     /* 259193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 259196 */     // MIs[0] row_mask
     /* 259196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259199 */     // MIs[0] bank_mask
     /* 259199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259202 */     // MIs[0] bound_ctrl
     /* 259202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259205 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3305:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$old, v4f16:{ *:[v4f16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v4f16] } VReg_64_Align2:{ *:[v4f16] }:$old, VReg_64_Align2:{ *:[v4f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 259205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 259208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259210 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 259212 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 259214 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 259220 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 259226 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 259232 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 259238 */     GIR_RootConstrainSelectedInstOperands,
     /* 259239 */     // GIR_Coverage, 7555,
     /* 259239 */     GIR_EraseRootFromParent_Done,
     /* 259240 */   // Label 4190: @259240
     /* 259240 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(259311), // Rule ID 2649 //
     /* 259245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 259253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 259256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 259259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 259262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259272 */     // MIs[0] fi
     /* 259272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259275 */     // MIs[0] bc
     /* 259275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259278 */     // (intrinsic_wo_chain:{ *:[i32] } 3077:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 259278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 259281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259283 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259289 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259291 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259297 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259302 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259304 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259309 */     GIR_RootConstrainSelectedInstOperands,
     /* 259310 */     // GIR_Coverage, 2649,
     /* 259310 */     GIR_EraseRootFromParent_Done,
     /* 259311 */   // Label 4191: @259311
     /* 259311 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(259382), // Rule ID 2650 //
     /* 259316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 259324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 259327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 259330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 259333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259343 */     // MIs[0] fi
     /* 259343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259346 */     // MIs[0] bc
     /* 259346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259349 */     // (intrinsic_wo_chain:{ *:[i32] } 3082:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 259349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 259352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259354 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259360 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259368 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259373 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259375 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259380 */     GIR_RootConstrainSelectedInstOperands,
     /* 259381 */     // GIR_Coverage, 2650,
     /* 259381 */     GIR_EraseRootFromParent_Done,
     /* 259382 */   // Label 4192: @259382
     /* 259382 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(259453), // Rule ID 2651 //
     /* 259387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 259395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 259398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 259401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 259404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259414 */     // MIs[0] fi
     /* 259414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259417 */     // MIs[0] bc
     /* 259417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259420 */     // (intrinsic_wo_chain:{ *:[f32] } 3077:{ *:[iPTR] }, f32:{ *:[f32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[f32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[f32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[f32] }:$vdst_in)
     /* 259420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 259423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259431 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259433 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259439 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259444 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259446 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259451 */     GIR_RootConstrainSelectedInstOperands,
     /* 259452 */     // GIR_Coverage, 2651,
     /* 259452 */     GIR_EraseRootFromParent_Done,
     /* 259453 */   // Label 4193: @259453
     /* 259453 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(259524), // Rule ID 2652 //
     /* 259458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 259466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 259469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 259472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 259475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259485 */     // MIs[0] fi
     /* 259485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259488 */     // MIs[0] bc
     /* 259488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259491 */     // (intrinsic_wo_chain:{ *:[f32] } 3082:{ *:[iPTR] }, f32:{ *:[f32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[f32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[f32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[f32] }:$vdst_in)
     /* 259491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 259494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259496 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259502 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259504 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259510 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259515 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259517 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259522 */     GIR_RootConstrainSelectedInstOperands,
     /* 259523 */     // GIR_Coverage, 2652,
     /* 259523 */     GIR_EraseRootFromParent_Done,
     /* 259524 */   // Label 4194: @259524
     /* 259524 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(259595), // Rule ID 2653 //
     /* 259529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 259537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 259540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 259543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 259546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259556 */     // MIs[0] fi
     /* 259556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259559 */     // MIs[0] bc
     /* 259559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259562 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3077:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[v2i16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2i16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 259562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 259565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259567 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259573 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259575 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259581 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259586 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259588 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259593 */     GIR_RootConstrainSelectedInstOperands,
     /* 259594 */     // GIR_Coverage, 2653,
     /* 259594 */     GIR_EraseRootFromParent_Done,
     /* 259595 */   // Label 4195: @259595
     /* 259595 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(259666), // Rule ID 2654 //
     /* 259600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 259608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 259611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 259614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 259617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259627 */     // MIs[0] fi
     /* 259627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259630 */     // MIs[0] bc
     /* 259630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259633 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3082:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[v2i16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2i16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 259633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 259636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259638 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259644 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259652 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259657 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259659 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259664 */     GIR_RootConstrainSelectedInstOperands,
     /* 259665 */     // GIR_Coverage, 2654,
     /* 259665 */     GIR_EraseRootFromParent_Done,
     /* 259666 */   // Label 4196: @259666
     /* 259666 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(259737), // Rule ID 2655 //
     /* 259671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 259679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 259682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 259685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 259688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259698 */     // MIs[0] fi
     /* 259698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259701 */     // MIs[0] bc
     /* 259701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259704 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3077:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[v2f16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2f16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 259704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 259707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259709 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259715 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259723 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259728 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259730 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259735 */     GIR_RootConstrainSelectedInstOperands,
     /* 259736 */     // GIR_Coverage, 2655,
     /* 259736 */     GIR_EraseRootFromParent_Done,
     /* 259737 */   // Label 4197: @259737
     /* 259737 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(259808), // Rule ID 2656 //
     /* 259742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 259750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 259753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 259756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 259759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259769 */     // MIs[0] fi
     /* 259769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259772 */     // MIs[0] bc
     /* 259772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259775 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3082:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[v2f16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2f16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 259775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 259778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259786 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259788 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259794 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259799 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259801 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259806 */     GIR_RootConstrainSelectedInstOperands,
     /* 259807 */     // GIR_Coverage, 2656,
     /* 259807 */     GIR_EraseRootFromParent_Done,
     /* 259808 */   // Label 4198: @259808
     /* 259808 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(259879), // Rule ID 2657 //
     /* 259813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 259821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 259824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 259827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
     /* 259830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259840 */     // MIs[0] fi
     /* 259840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259843 */     // MIs[0] bc
     /* 259843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259846 */     // (intrinsic_wo_chain:{ *:[i32] } 3077:{ *:[iPTR] }, p2:{ *:[i32] }:$vdst_in, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 259846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 259849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259851 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259857 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259859 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259865 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259870 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259872 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259877 */     GIR_RootConstrainSelectedInstOperands,
     /* 259878 */     // GIR_Coverage, 2657,
     /* 259878 */     GIR_EraseRootFromParent_Done,
     /* 259879 */   // Label 4199: @259879
     /* 259879 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(259950), // Rule ID 2658 //
     /* 259884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 259892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 259895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 259898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
     /* 259901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259911 */     // MIs[0] fi
     /* 259911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259914 */     // MIs[0] bc
     /* 259914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259917 */     // (intrinsic_wo_chain:{ *:[i32] } 3082:{ *:[iPTR] }, p2:{ *:[i32] }:$vdst_in, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 259917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 259920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259928 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 259930 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 259936 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 259938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259941 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 259943 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 259945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259948 */     GIR_RootConstrainSelectedInstOperands,
     /* 259949 */     // GIR_Coverage, 2658,
     /* 259949 */     GIR_EraseRootFromParent_Done,
     /* 259950 */   // Label 4200: @259950
     /* 259950 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(260021), // Rule ID 2659 //
     /* 259955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 259958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 259963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 259966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 259969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
     /* 259972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 259975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 259982 */     // MIs[0] fi
     /* 259982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 259985 */     // MIs[0] bc
     /* 259985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 259988 */     // (intrinsic_wo_chain:{ *:[i32] } 3077:{ *:[iPTR] }, p3:{ *:[i32] }:$vdst_in, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 259988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 259991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259993 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 259999 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260001 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260007 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260012 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260014 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260019 */     GIR_RootConstrainSelectedInstOperands,
     /* 260020 */     // GIR_Coverage, 2659,
     /* 260020 */     GIR_EraseRootFromParent_Done,
     /* 260021 */   // Label 4201: @260021
     /* 260021 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(260092), // Rule ID 2660 //
     /* 260026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 260034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 260037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 260040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
     /* 260043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260053 */     // MIs[0] fi
     /* 260053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260056 */     // MIs[0] bc
     /* 260056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260059 */     // (intrinsic_wo_chain:{ *:[i32] } 3082:{ *:[iPTR] }, p3:{ *:[i32] }:$vdst_in, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 260059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 260062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260070 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260072 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260078 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260083 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260085 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260090 */     GIR_RootConstrainSelectedInstOperands,
     /* 260091 */     // GIR_Coverage, 2660,
     /* 260091 */     GIR_EraseRootFromParent_Done,
     /* 260092 */   // Label 4202: @260092
     /* 260092 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(260163), // Rule ID 2661 //
     /* 260097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 260105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 260108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 260111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
     /* 260114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260124 */     // MIs[0] fi
     /* 260124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260127 */     // MIs[0] bc
     /* 260127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260130 */     // (intrinsic_wo_chain:{ *:[i32] } 3077:{ *:[iPTR] }, p5:{ *:[i32] }:$vdst_in, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 260130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 260133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260141 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260143 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260149 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260154 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260156 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260161 */     GIR_RootConstrainSelectedInstOperands,
     /* 260162 */     // GIR_Coverage, 2661,
     /* 260162 */     GIR_EraseRootFromParent_Done,
     /* 260163 */   // Label 4203: @260163
     /* 260163 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(260234), // Rule ID 2662 //
     /* 260168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 260176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 260179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 260182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
     /* 260185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260195 */     // MIs[0] fi
     /* 260195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260198 */     // MIs[0] bc
     /* 260198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260201 */     // (intrinsic_wo_chain:{ *:[i32] } 3082:{ *:[iPTR] }, p5:{ *:[i32] }:$vdst_in, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 260201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 260204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260212 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260214 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260220 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260225 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260227 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260232 */     GIR_RootConstrainSelectedInstOperands,
     /* 260233 */     // GIR_Coverage, 2662,
     /* 260233 */     GIR_EraseRootFromParent_Done,
     /* 260234 */   // Label 4204: @260234
     /* 260234 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(260305), // Rule ID 2663 //
     /* 260239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 260247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 260250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 260253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
     /* 260256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260266 */     // MIs[0] fi
     /* 260266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260269 */     // MIs[0] bc
     /* 260269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260272 */     // (intrinsic_wo_chain:{ *:[i32] } 3077:{ *:[iPTR] }, p6:{ *:[i32] }:$vdst_in, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 260272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 260275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260277 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260283 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260285 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260291 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260296 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260298 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260303 */     GIR_RootConstrainSelectedInstOperands,
     /* 260304 */     // GIR_Coverage, 2663,
     /* 260304 */     GIR_EraseRootFromParent_Done,
     /* 260305 */   // Label 4205: @260305
     /* 260305 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(260376), // Rule ID 2664 //
     /* 260310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 260313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 260318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 260321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 260324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
     /* 260327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 260330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260337 */     // MIs[0] fi
     /* 260337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260340 */     // MIs[0] bc
     /* 260340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260343 */     // (intrinsic_wo_chain:{ *:[i32] } 3082:{ *:[iPTR] }, p6:{ *:[i32] }:$vdst_in, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 260343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 260346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260348 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 260354 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 260356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 260362 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 260364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260367 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 260369 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 260371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260374 */     GIR_RootConstrainSelectedInstOperands,
     /* 260375 */     // GIR_Coverage, 2664,
     /* 260375 */     GIR_EraseRootFromParent_Done,
     /* 260376 */   // Label 4206: @260376
     /* 260376 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(260437), // Rule ID 1123 //
     /* 260381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 260384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x1f32),
     /* 260389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 260401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 260405 */     // MIs[0] cbsz
     /* 260405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260408 */     // MIs[0] abid
     /* 260408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260411 */     // MIs[0] blgp
     /* 260411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23242),
     /* 260418 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3050:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23242>>  =>  (V_MFMA_F32_4X4X1F32_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X1F32_e64),
     /* 260421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260423 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260425 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260427 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260429 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260431 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260433 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260435 */     GIR_RootConstrainSelectedInstOperands,
     /* 260436 */     // GIR_Coverage, 1123,
     /* 260436 */     GIR_EraseRootFromParent_Done,
     /* 260437 */   // Label 4207: @260437
     /* 260437 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(260498), // Rule ID 1124 //
     /* 260442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 260445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x1f32),
     /* 260450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 260462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 260466 */     // MIs[0] cbsz
     /* 260466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260469 */     // MIs[0] abid
     /* 260469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260472 */     // MIs[0] blgp
     /* 260472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23244),
     /* 260479 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3050:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23244>>  =>  (V_MFMA_F32_4X4X1F32_vgprcd_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X1F32_vgprcd_e64),
     /* 260482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260484 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260486 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260488 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260490 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260492 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260494 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260496 */     GIR_RootConstrainSelectedInstOperands,
     /* 260497 */     // GIR_Coverage, 1124,
     /* 260497 */     GIR_EraseRootFromParent_Done,
     /* 260498 */   // Label 4208: @260498
     /* 260498 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(260559), // Rule ID 1125 //
     /* 260503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 260506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x1f32),
     /* 260511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 260514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 260523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 260527 */     // MIs[0] cbsz
     /* 260527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260530 */     // MIs[0] abid
     /* 260530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260533 */     // MIs[0] blgp
     /* 260533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23248),
     /* 260540 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3022:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23248>>  =>  (V_MFMA_F32_16X16X1F32_mac_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X1F32_mac_e64),
     /* 260543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260545 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260547 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260549 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260551 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260553 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260555 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260557 */     GIR_RootConstrainSelectedInstOperands,
     /* 260558 */     // GIR_Coverage, 1125,
     /* 260558 */     GIR_EraseRootFromParent_Done,
     /* 260559 */   // Label 4209: @260559
     /* 260559 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(260620), // Rule ID 1126 //
     /* 260564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 260567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x1f32),
     /* 260572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 260575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 260584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 260588 */     // MIs[0] cbsz
     /* 260588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260591 */     // MIs[0] abid
     /* 260591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260594 */     // MIs[0] blgp
     /* 260594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23250),
     /* 260601 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3022:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23250>>  =>  (V_MFMA_F32_16X16X1F32_mac_vgprcd_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X1F32_mac_vgprcd_e64),
     /* 260604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260606 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260608 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260610 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260612 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260614 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260616 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260618 */     GIR_RootConstrainSelectedInstOperands,
     /* 260619 */     // GIR_Coverage, 1126,
     /* 260619 */     GIR_EraseRootFromParent_Done,
     /* 260620 */   // Label 4210: @260620
     /* 260620 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(260681), // Rule ID 1127 //
     /* 260625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 260628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f32),
     /* 260633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 260645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 260649 */     // MIs[0] cbsz
     /* 260649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260652 */     // MIs[0] abid
     /* 260652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260655 */     // MIs[0] blgp
     /* 260655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23252),
     /* 260662 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23252>>  =>  (V_MFMA_F32_16X16X4F32_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F32_e64),
     /* 260665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260667 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260669 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260671 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260673 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260675 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260677 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260679 */     GIR_RootConstrainSelectedInstOperands,
     /* 260680 */     // GIR_Coverage, 1127,
     /* 260680 */     GIR_EraseRootFromParent_Done,
     /* 260681 */   // Label 4211: @260681
     /* 260681 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(260742), // Rule ID 1128 //
     /* 260686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 260689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f32),
     /* 260694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 260706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 260710 */     // MIs[0] cbsz
     /* 260710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260713 */     // MIs[0] abid
     /* 260713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260716 */     // MIs[0] blgp
     /* 260716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23254),
     /* 260723 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23254>>  =>  (V_MFMA_F32_16X16X4F32_vgprcd_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F32_vgprcd_e64),
     /* 260726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260728 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260730 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260732 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260734 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260736 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260738 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260740 */     GIR_RootConstrainSelectedInstOperands,
     /* 260741 */     // GIR_Coverage, 1128,
     /* 260741 */     GIR_EraseRootFromParent_Done,
     /* 260742 */   // Label 4212: @260742
     /* 260742 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(260803), // Rule ID 1129 //
     /* 260747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 260750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x1f32),
     /* 260755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 260758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 260767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 260771 */     // MIs[0] cbsz
     /* 260771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260774 */     // MIs[0] abid
     /* 260774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260777 */     // MIs[0] blgp
     /* 260777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260780 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23258),
     /* 260784 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3041:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23258>>  =>  (V_MFMA_F32_32X32X1F32_mac_e64:{ *:[v32f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X1F32_mac_e64),
     /* 260787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260789 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260791 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260793 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260795 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260797 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260799 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260801 */     GIR_RootConstrainSelectedInstOperands,
     /* 260802 */     // GIR_Coverage, 1129,
     /* 260802 */     GIR_EraseRootFromParent_Done,
     /* 260803 */   // Label 4213: @260803
     /* 260803 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(260864), // Rule ID 1130 //
     /* 260808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 260811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x1f32),
     /* 260816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 260819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 260828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 260832 */     // MIs[0] cbsz
     /* 260832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260835 */     // MIs[0] abid
     /* 260835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260838 */     // MIs[0] blgp
     /* 260838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23260),
     /* 260845 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3041:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23260>>  =>  (V_MFMA_F32_32X32X1F32_mac_vgprcd_e64:{ *:[v32f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X1F32_mac_vgprcd_e64),
     /* 260848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260850 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260852 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260854 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260856 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260858 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260860 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260862 */     GIR_RootConstrainSelectedInstOperands,
     /* 260863 */     // GIR_Coverage, 1130,
     /* 260863 */     GIR_EraseRootFromParent_Done,
     /* 260864 */   // Label 4214: @260864
     /* 260864 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(260925), // Rule ID 1131 //
     /* 260869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 260872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2f32),
     /* 260877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 260880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 260889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 260893 */     // MIs[0] cbsz
     /* 260893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260896 */     // MIs[0] abid
     /* 260896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260899 */     // MIs[0] blgp
     /* 260899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260902 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23262),
     /* 260906 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3043:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23262>>  =>  (V_MFMA_F32_32X32X2F32_mac_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2F32_mac_e64),
     /* 260909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260911 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260913 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260915 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260917 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260919 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260921 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260923 */     GIR_RootConstrainSelectedInstOperands,
     /* 260924 */     // GIR_Coverage, 1131,
     /* 260924 */     GIR_EraseRootFromParent_Done,
     /* 260925 */   // Label 4215: @260925
     /* 260925 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(260986), // Rule ID 1132 //
     /* 260930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 260933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2f32),
     /* 260938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 260941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 260947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 260950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 260954 */     // MIs[0] cbsz
     /* 260954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260957 */     // MIs[0] abid
     /* 260957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260960 */     // MIs[0] blgp
     /* 260960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 260963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23264),
     /* 260967 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3043:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23264>>  =>  (V_MFMA_F32_32X32X2F32_mac_vgprcd_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 260967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2F32_mac_vgprcd_e64),
     /* 260970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260972 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260974 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260976 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260978 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 260980 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 260982 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 260984 */     GIR_RootConstrainSelectedInstOperands,
     /* 260985 */     // GIR_Coverage, 1132,
     /* 260985 */     GIR_EraseRootFromParent_Done,
     /* 260986 */   // Label 4216: @260986
     /* 260986 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(261047), // Rule ID 1133 //
     /* 260991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 260994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4f16),
     /* 260999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 261015 */     // MIs[0] cbsz
     /* 261015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261018 */     // MIs[0] abid
     /* 261018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261021 */     // MIs[0] blgp
     /* 261021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23266),
     /* 261028 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3053:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23266>>  =>  (V_MFMA_F32_4X4X4F16_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4F16_e64),
     /* 261031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261033 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261035 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261037 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261039 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261041 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261043 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261045 */     GIR_RootConstrainSelectedInstOperands,
     /* 261046 */     // GIR_Coverage, 1133,
     /* 261046 */     GIR_EraseRootFromParent_Done,
     /* 261047 */   // Label 4217: @261047
     /* 261047 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(261108), // Rule ID 1134 //
     /* 261052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4f16),
     /* 261060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 261076 */     // MIs[0] cbsz
     /* 261076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261079 */     // MIs[0] abid
     /* 261079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261082 */     // MIs[0] blgp
     /* 261082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261085 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23268),
     /* 261089 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3053:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23268>>  =>  (V_MFMA_F32_4X4X4F16_vgprcd_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4F16_vgprcd_e64),
     /* 261092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261094 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261096 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261098 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261100 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261102 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261104 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261106 */     GIR_RootConstrainSelectedInstOperands,
     /* 261107 */     // GIR_Coverage, 1134,
     /* 261107 */     GIR_EraseRootFromParent_Done,
     /* 261108 */   // Label 4218: @261108
     /* 261108 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(261169), // Rule ID 1135 //
     /* 261113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_4x4x4i8),
     /* 261121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 261137 */     // MIs[0] cbsz
     /* 261137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261140 */     // MIs[0] abid
     /* 261140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261143 */     // MIs[0] blgp
     /* 261143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23270),
     /* 261150 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3064:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23270>>  =>  (V_MFMA_I32_4X4X4I8_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_4X4X4I8_e64),
     /* 261153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261155 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261157 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261159 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261161 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261163 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261165 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261167 */     GIR_RootConstrainSelectedInstOperands,
     /* 261168 */     // GIR_Coverage, 1135,
     /* 261168 */     GIR_EraseRootFromParent_Done,
     /* 261169 */   // Label 4219: @261169
     /* 261169 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(261230), // Rule ID 1136 //
     /* 261174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_4x4x4i8),
     /* 261182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 261198 */     // MIs[0] cbsz
     /* 261198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261201 */     // MIs[0] abid
     /* 261201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261204 */     // MIs[0] blgp
     /* 261204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261207 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23272),
     /* 261211 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3064:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23272>>  =>  (V_MFMA_I32_4X4X4I8_vgprcd_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_4X4X4I8_vgprcd_e64),
     /* 261214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261216 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261218 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261220 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261222 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261224 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261226 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261228 */     GIR_RootConstrainSelectedInstOperands,
     /* 261229 */     // GIR_Coverage, 1136,
     /* 261229 */     GIR_EraseRootFromParent_Done,
     /* 261230 */   // Label 4220: @261230
     /* 261230 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(261291), // Rule ID 1137 //
     /* 261235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f16),
     /* 261243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 261246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 261255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 261259 */     // MIs[0] cbsz
     /* 261259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261262 */     // MIs[0] abid
     /* 261262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261265 */     // MIs[0] blgp
     /* 261265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261268 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23276),
     /* 261272 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3031:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23276>>  =>  (V_MFMA_F32_16X16X4F16_mac_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F16_mac_e64),
     /* 261275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261277 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261279 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261281 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261283 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261285 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261287 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261289 */     GIR_RootConstrainSelectedInstOperands,
     /* 261290 */     // GIR_Coverage, 1137,
     /* 261290 */     GIR_EraseRootFromParent_Done,
     /* 261291 */   // Label 4221: @261291
     /* 261291 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(261352), // Rule ID 1138 //
     /* 261296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f16),
     /* 261304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 261307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 261316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 261320 */     // MIs[0] cbsz
     /* 261320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261323 */     // MIs[0] abid
     /* 261323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261326 */     // MIs[0] blgp
     /* 261326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23278),
     /* 261333 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3031:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23278>>  =>  (V_MFMA_F32_16X16X4F16_mac_vgprcd_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F16_mac_vgprcd_e64),
     /* 261336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261338 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261340 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261342 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261344 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261346 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261348 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261350 */     GIR_RootConstrainSelectedInstOperands,
     /* 261351 */     // GIR_Coverage, 1138,
     /* 261351 */     GIR_EraseRootFromParent_Done,
     /* 261352 */   // Label 4222: @261352
     /* 261352 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(261413), // Rule ID 1139 //
     /* 261357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16f16),
     /* 261365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 261381 */     // MIs[0] cbsz
     /* 261381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261384 */     // MIs[0] abid
     /* 261384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261387 */     // MIs[0] blgp
     /* 261387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261390 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23280),
     /* 261394 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3021:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23280>>  =>  (V_MFMA_F32_16X16X16F16_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16F16_e64),
     /* 261397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261399 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261401 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261403 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261405 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261407 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261409 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261411 */     GIR_RootConstrainSelectedInstOperands,
     /* 261412 */     // GIR_Coverage, 1139,
     /* 261412 */     GIR_EraseRootFromParent_Done,
     /* 261413 */   // Label 4223: @261413
     /* 261413 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(261474), // Rule ID 1140 //
     /* 261418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16f16),
     /* 261426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 261442 */     // MIs[0] cbsz
     /* 261442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261445 */     // MIs[0] abid
     /* 261445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261448 */     // MIs[0] blgp
     /* 261448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261451 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23282),
     /* 261455 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3021:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23282>>  =>  (V_MFMA_F32_16X16X16F16_vgprcd_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16F16_vgprcd_e64),
     /* 261458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261460 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261462 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261464 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261466 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261468 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261470 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261472 */     GIR_RootConstrainSelectedInstOperands,
     /* 261473 */     // GIR_Coverage, 1140,
     /* 261473 */     GIR_EraseRootFromParent_Done,
     /* 261474 */   // Label 4224: @261474
     /* 261474 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(261535), // Rule ID 1141 //
     /* 261479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x4i8),
     /* 261487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 261490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 261499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 261503 */     // MIs[0] cbsz
     /* 261503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261506 */     // MIs[0] abid
     /* 261506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261509 */     // MIs[0] blgp
     /* 261509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23286),
     /* 261516 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3058:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23286>>  =>  (V_MFMA_I32_16X16X4I8_mac_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X4I8_mac_e64),
     /* 261519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261523 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261525 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261527 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261529 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261531 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261533 */     GIR_RootConstrainSelectedInstOperands,
     /* 261534 */     // GIR_Coverage, 1141,
     /* 261534 */     GIR_EraseRootFromParent_Done,
     /* 261535 */   // Label 4225: @261535
     /* 261535 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(261596), // Rule ID 1142 //
     /* 261540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x4i8),
     /* 261548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 261551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 261560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 261564 */     // MIs[0] cbsz
     /* 261564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261567 */     // MIs[0] abid
     /* 261567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261570 */     // MIs[0] blgp
     /* 261570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261573 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23288),
     /* 261577 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3058:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23288>>  =>  (V_MFMA_I32_16X16X4I8_mac_vgprcd_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X4I8_mac_vgprcd_e64),
     /* 261580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261582 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261584 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261586 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261588 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261590 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261592 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261594 */     GIR_RootConstrainSelectedInstOperands,
     /* 261595 */     // GIR_Coverage, 1142,
     /* 261595 */     GIR_EraseRootFromParent_Done,
     /* 261596 */   // Label 4226: @261596
     /* 261596 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(261657), // Rule ID 1143 //
     /* 261601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4f16),
     /* 261609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 261612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 261621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 261625 */     // MIs[0] cbsz
     /* 261625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261628 */     // MIs[0] abid
     /* 261628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261631 */     // MIs[0] blgp
     /* 261631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261634 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23292),
     /* 261638 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3047:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23292>>  =>  (V_MFMA_F32_32X32X4F16_mac_e64:{ *:[v32f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4F16_mac_e64),
     /* 261641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261643 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261645 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261647 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261649 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261651 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261653 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261655 */     GIR_RootConstrainSelectedInstOperands,
     /* 261656 */     // GIR_Coverage, 1143,
     /* 261656 */     GIR_EraseRootFromParent_Done,
     /* 261657 */   // Label 4227: @261657
     /* 261657 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(261718), // Rule ID 1144 //
     /* 261662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4f16),
     /* 261670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 261673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 261682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 261686 */     // MIs[0] cbsz
     /* 261686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261689 */     // MIs[0] abid
     /* 261689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261692 */     // MIs[0] blgp
     /* 261692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23294),
     /* 261699 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3047:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23294>>  =>  (V_MFMA_F32_32X32X4F16_mac_vgprcd_e64:{ *:[v32f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4F16_mac_vgprcd_e64),
     /* 261702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261704 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261706 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261708 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261710 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261712 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261714 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261716 */     GIR_RootConstrainSelectedInstOperands,
     /* 261717 */     // GIR_Coverage, 1144,
     /* 261717 */     GIR_EraseRootFromParent_Done,
     /* 261718 */   // Label 4228: @261718
     /* 261718 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(261779), // Rule ID 1145 //
     /* 261723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8f16),
     /* 261731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 261734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 261743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 261747 */     // MIs[0] cbsz
     /* 261747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261750 */     // MIs[0] abid
     /* 261750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261753 */     // MIs[0] blgp
     /* 261753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261756 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23296),
     /* 261760 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3049:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23296>>  =>  (V_MFMA_F32_32X32X8F16_mac_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8F16_mac_e64),
     /* 261763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261765 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261767 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261769 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261771 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261773 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261775 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261777 */     GIR_RootConstrainSelectedInstOperands,
     /* 261778 */     // GIR_Coverage, 1145,
     /* 261778 */     GIR_EraseRootFromParent_Done,
     /* 261779 */   // Label 4229: @261779
     /* 261779 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(261840), // Rule ID 1146 //
     /* 261784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8f16),
     /* 261792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 261795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 261804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 261808 */     // MIs[0] cbsz
     /* 261808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261811 */     // MIs[0] abid
     /* 261811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261814 */     // MIs[0] blgp
     /* 261814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261817 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23298),
     /* 261821 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3049:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23298>>  =>  (V_MFMA_F32_32X32X8F16_mac_vgprcd_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8F16_mac_vgprcd_e64),
     /* 261824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261826 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261828 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261830 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261832 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261834 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261836 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261838 */     GIR_RootConstrainSelectedInstOperands,
     /* 261839 */     // GIR_Coverage, 1146,
     /* 261839 */     GIR_EraseRootFromParent_Done,
     /* 261840 */   // Label 4230: @261840
     /* 261840 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(261901), // Rule ID 1147 //
     /* 261845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 261848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x4i8),
     /* 261853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 261856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 261865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 261869 */     // MIs[0] cbsz
     /* 261869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261872 */     // MIs[0] abid
     /* 261872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261875 */     // MIs[0] blgp
     /* 261875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261878 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23302),
     /* 261882 */     // (intrinsic_wo_chain:{ *:[v32i32] } 3062:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23302>>  =>  (V_MFMA_I32_32X32X4I8_mac_e64:{ *:[v32i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X4I8_mac_e64),
     /* 261885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261887 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261889 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261891 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261893 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261895 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261897 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261899 */     GIR_RootConstrainSelectedInstOperands,
     /* 261900 */     // GIR_Coverage, 1147,
     /* 261900 */     GIR_EraseRootFromParent_Done,
     /* 261901 */   // Label 4231: @261901
     /* 261901 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(261962), // Rule ID 1148 //
     /* 261906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 261909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x4i8),
     /* 261914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 261917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 261926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 261930 */     // MIs[0] cbsz
     /* 261930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261933 */     // MIs[0] abid
     /* 261933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261936 */     // MIs[0] blgp
     /* 261936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23304),
     /* 261943 */     // (intrinsic_wo_chain:{ *:[v32i32] } 3062:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23304>>  =>  (V_MFMA_I32_32X32X4I8_mac_vgprcd_e64:{ *:[v32i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 261943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X4I8_mac_vgprcd_e64),
     /* 261946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261948 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 261950 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 261952 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 261954 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 261956 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 261958 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 261960 */     GIR_RootConstrainSelectedInstOperands,
     /* 261961 */     // GIR_Coverage, 1148,
     /* 261961 */     GIR_EraseRootFromParent_Done,
     /* 261962 */   // Label 4232: @261962
     /* 261962 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(262023), // Rule ID 1149 //
     /* 261967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 261970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x16i8),
     /* 261975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 261991 */     // MIs[0] cbsz
     /* 261991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261994 */     // MIs[0] abid
     /* 261994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261997 */     // MIs[0] blgp
     /* 261997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23306),
     /* 262004 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3056:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23306>>  =>  (V_MFMA_I32_16X16X16I8_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X16I8_e64),
     /* 262007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262011 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262013 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262015 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262017 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262019 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262021 */     GIR_RootConstrainSelectedInstOperands,
     /* 262022 */     // GIR_Coverage, 1149,
     /* 262022 */     GIR_EraseRootFromParent_Done,
     /* 262023 */   // Label 4233: @262023
     /* 262023 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(262084), // Rule ID 1150 //
     /* 262028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 262031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x16i8),
     /* 262036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 262042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 262048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 262052 */     // MIs[0] cbsz
     /* 262052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262055 */     // MIs[0] abid
     /* 262055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262058 */     // MIs[0] blgp
     /* 262058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23308),
     /* 262065 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3056:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23308>>  =>  (V_MFMA_I32_16X16X16I8_vgprcd_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X16I8_vgprcd_e64),
     /* 262068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262070 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262072 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262074 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262076 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262078 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262080 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262082 */     GIR_RootConstrainSelectedInstOperands,
     /* 262083 */     // GIR_Coverage, 1150,
     /* 262083 */     GIR_EraseRootFromParent_Done,
     /* 262084 */   // Label 4234: @262084
     /* 262084 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(262145), // Rule ID 1151 //
     /* 262089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 262092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x8i8),
     /* 262097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 262100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 262103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 262109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 262113 */     // MIs[0] cbsz
     /* 262113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262116 */     // MIs[0] abid
     /* 262116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262119 */     // MIs[0] blgp
     /* 262119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23310),
     /* 262126 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3063:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23310>>  =>  (V_MFMA_I32_32X32X8I8_mac_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X8I8_mac_e64),
     /* 262129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262131 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262133 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262135 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262137 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262139 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262141 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262143 */     GIR_RootConstrainSelectedInstOperands,
     /* 262144 */     // GIR_Coverage, 1151,
     /* 262144 */     GIR_EraseRootFromParent_Done,
     /* 262145 */   // Label 4235: @262145
     /* 262145 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(262206), // Rule ID 1152 //
     /* 262150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 262153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x8i8),
     /* 262158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 262161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 262164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 262170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 262174 */     // MIs[0] cbsz
     /* 262174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262177 */     // MIs[0] abid
     /* 262177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262180 */     // MIs[0] blgp
     /* 262180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262183 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23312),
     /* 262187 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3063:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23312>>  =>  (V_MFMA_I32_32X32X8I8_mac_vgprcd_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X8I8_mac_vgprcd_e64),
     /* 262190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262192 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262194 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262196 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262198 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262200 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262202 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262204 */     GIR_RootConstrainSelectedInstOperands,
     /* 262205 */     // GIR_Coverage, 1152,
     /* 262205 */     GIR_EraseRootFromParent_Done,
     /* 262206 */   // Label 4236: @262206
     /* 262206 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(262267), // Rule ID 1153 //
     /* 262211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 262214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x2bf16),
     /* 262219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 262231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 262235 */     // MIs[0] cbsz
     /* 262235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262238 */     // MIs[0] abid
     /* 262238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262241 */     // MIs[0] blgp
     /* 262241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23314),
     /* 262248 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3051:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23314>>  =>  (V_MFMA_F32_4X4X2BF16_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X2BF16_e64),
     /* 262251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262255 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262257 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262259 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262261 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262263 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262265 */     GIR_RootConstrainSelectedInstOperands,
     /* 262266 */     // GIR_Coverage, 1153,
     /* 262266 */     GIR_EraseRootFromParent_Done,
     /* 262267 */   // Label 4237: @262267
     /* 262267 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(262328), // Rule ID 1154 //
     /* 262272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 262275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x2bf16),
     /* 262280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 262292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 262296 */     // MIs[0] cbsz
     /* 262296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262299 */     // MIs[0] abid
     /* 262299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262302 */     // MIs[0] blgp
     /* 262302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262305 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23316),
     /* 262309 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3051:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23316>>  =>  (V_MFMA_F32_4X4X2BF16_vgprcd_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X2BF16_vgprcd_e64),
     /* 262312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262314 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262316 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262318 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262320 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262322 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262324 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262326 */     GIR_RootConstrainSelectedInstOperands,
     /* 262327 */     // GIR_Coverage, 1154,
     /* 262327 */     GIR_EraseRootFromParent_Done,
     /* 262328 */   // Label 4238: @262328
     /* 262328 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(262389), // Rule ID 1155 //
     /* 262333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 262336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x2bf16),
     /* 262341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 262344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 262353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 262357 */     // MIs[0] cbsz
     /* 262357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262360 */     // MIs[0] abid
     /* 262360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262363 */     // MIs[0] blgp
     /* 262363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262366 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23320),
     /* 262370 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3023:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23320>>  =>  (V_MFMA_F32_16X16X2BF16_mac_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X2BF16_mac_e64),
     /* 262373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262375 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262377 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262379 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262381 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262383 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262385 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262387 */     GIR_RootConstrainSelectedInstOperands,
     /* 262388 */     // GIR_Coverage, 1155,
     /* 262388 */     GIR_EraseRootFromParent_Done,
     /* 262389 */   // Label 4239: @262389
     /* 262389 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(262450), // Rule ID 1156 //
     /* 262394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 262397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x2bf16),
     /* 262402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 262405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 262414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 262418 */     // MIs[0] cbsz
     /* 262418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262421 */     // MIs[0] abid
     /* 262421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262424 */     // MIs[0] blgp
     /* 262424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262427 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23322),
     /* 262431 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3023:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23322>>  =>  (V_MFMA_F32_16X16X2BF16_mac_vgprcd_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X2BF16_mac_vgprcd_e64),
     /* 262434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262436 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262438 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262440 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262442 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262444 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262446 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262448 */     GIR_RootConstrainSelectedInstOperands,
     /* 262449 */     // GIR_Coverage, 1156,
     /* 262449 */     GIR_EraseRootFromParent_Done,
     /* 262450 */   // Label 4240: @262450
     /* 262450 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(262511), // Rule ID 1157 //
     /* 262455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 262458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8bf16),
     /* 262463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 262475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 262479 */     // MIs[0] cbsz
     /* 262479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262482 */     // MIs[0] abid
     /* 262482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262485 */     // MIs[0] blgp
     /* 262485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262488 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23324),
     /* 262492 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3034:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23324>>  =>  (V_MFMA_F32_16X16X8BF16_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8BF16_e64),
     /* 262495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262497 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262499 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262501 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262503 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262505 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262507 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262509 */     GIR_RootConstrainSelectedInstOperands,
     /* 262510 */     // GIR_Coverage, 1157,
     /* 262510 */     GIR_EraseRootFromParent_Done,
     /* 262511 */   // Label 4241: @262511
     /* 262511 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(262572), // Rule ID 1158 //
     /* 262516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 262519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8bf16),
     /* 262524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 262536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 262540 */     // MIs[0] cbsz
     /* 262540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262543 */     // MIs[0] abid
     /* 262543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262546 */     // MIs[0] blgp
     /* 262546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23326),
     /* 262553 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3034:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23326>>  =>  (V_MFMA_F32_16X16X8BF16_vgprcd_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8BF16_vgprcd_e64),
     /* 262556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262558 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262560 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262562 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262564 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262566 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262568 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262570 */     GIR_RootConstrainSelectedInstOperands,
     /* 262571 */     // GIR_Coverage, 1158,
     /* 262571 */     GIR_EraseRootFromParent_Done,
     /* 262572 */   // Label 4242: @262572
     /* 262572 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(262633), // Rule ID 1159 //
     /* 262577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 262580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2bf16),
     /* 262585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 262588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 262597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 262601 */     // MIs[0] cbsz
     /* 262601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262604 */     // MIs[0] abid
     /* 262604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262607 */     // MIs[0] blgp
     /* 262607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262610 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23330),
     /* 262614 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3042:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23330>>  =>  (V_MFMA_F32_32X32X2BF16_mac_e64:{ *:[v32f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2BF16_mac_e64),
     /* 262617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262619 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262621 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262623 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262625 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262627 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262629 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262631 */     GIR_RootConstrainSelectedInstOperands,
     /* 262632 */     // GIR_Coverage, 1159,
     /* 262632 */     GIR_EraseRootFromParent_Done,
     /* 262633 */   // Label 4243: @262633
     /* 262633 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(262694), // Rule ID 1160 //
     /* 262638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 262641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2bf16),
     /* 262646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 262649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 262658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 262662 */     // MIs[0] cbsz
     /* 262662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262665 */     // MIs[0] abid
     /* 262665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262668 */     // MIs[0] blgp
     /* 262668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262671 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23332),
     /* 262675 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3042:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23332>>  =>  (V_MFMA_F32_32X32X2BF16_mac_vgprcd_e64:{ *:[v32f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2BF16_mac_vgprcd_e64),
     /* 262678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262680 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262682 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262684 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262686 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262688 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262690 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262692 */     GIR_RootConstrainSelectedInstOperands,
     /* 262693 */     // GIR_Coverage, 1160,
     /* 262693 */     GIR_EraseRootFromParent_Done,
     /* 262694 */   // Label 4244: @262694
     /* 262694 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(262755), // Rule ID 1161 //
     /* 262699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 262702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16),
     /* 262707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 262710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 262719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 262723 */     // MIs[0] cbsz
     /* 262723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262726 */     // MIs[0] abid
     /* 262726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262729 */     // MIs[0] blgp
     /* 262729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23334),
     /* 262736 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3045:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23334>>  =>  (V_MFMA_F32_32X32X4BF16_mac_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_mac_e64),
     /* 262739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262743 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262745 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262747 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262749 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262751 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262753 */     GIR_RootConstrainSelectedInstOperands,
     /* 262754 */     // GIR_Coverage, 1161,
     /* 262754 */     GIR_EraseRootFromParent_Done,
     /* 262755 */   // Label 4245: @262755
     /* 262755 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(262816), // Rule ID 1162 //
     /* 262760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 262763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16),
     /* 262768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 262771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 262780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 262784 */     // MIs[0] cbsz
     /* 262784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262787 */     // MIs[0] abid
     /* 262787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262790 */     // MIs[0] blgp
     /* 262790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262793 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23336),
     /* 262797 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3045:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23336>>  =>  (V_MFMA_F32_32X32X4BF16_mac_vgprcd_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_mac_vgprcd_e64),
     /* 262800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262802 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262804 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262806 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262808 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262810 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262812 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262814 */     GIR_RootConstrainSelectedInstOperands,
     /* 262815 */     // GIR_Coverage, 1162,
     /* 262815 */     GIR_EraseRootFromParent_Done,
     /* 262816 */   // Label 4246: @262816
     /* 262816 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(262877), // Rule ID 1163 //
     /* 262821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 262824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_f16),
     /* 262829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 262838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 262841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 262845 */     // MIs[0] cbsz
     /* 262845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262848 */     // MIs[0] abid
     /* 262848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262851 */     // MIs[0] blgp
     /* 262851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23338),
     /* 262858 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3027:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23338>>  =>  (V_MFMA_F32_16X16X32_F16_e64:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_F16_e64),
     /* 262861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262863 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262865 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262867 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262869 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262871 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262873 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262875 */     GIR_RootConstrainSelectedInstOperands,
     /* 262876 */     // GIR_Coverage, 1163,
     /* 262876 */     GIR_EraseRootFromParent_Done,
     /* 262877 */   // Label 4247: @262877
     /* 262877 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(262938), // Rule ID 1164 //
     /* 262882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 262885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_f16),
     /* 262890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 262899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 262902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 262906 */     // MIs[0] cbsz
     /* 262906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262909 */     // MIs[0] abid
     /* 262909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262912 */     // MIs[0] blgp
     /* 262912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262915 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23340),
     /* 262919 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3027:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23340>>  =>  (V_MFMA_F32_16X16X32_F16_vgprcd_e64:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_F16_vgprcd_e64),
     /* 262922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262924 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262926 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262928 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262930 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262932 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262934 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262936 */     GIR_RootConstrainSelectedInstOperands,
     /* 262937 */     // GIR_Coverage, 1164,
     /* 262937 */     GIR_EraseRootFromParent_Done,
     /* 262938 */   // Label 4248: @262938
     /* 262938 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(262999), // Rule ID 1165 //
     /* 262943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 262946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_f16),
     /* 262951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 262954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 262960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 262963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 262967 */     // MIs[0] cbsz
     /* 262967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262970 */     // MIs[0] abid
     /* 262970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262973 */     // MIs[0] blgp
     /* 262973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23344),
     /* 262980 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3038:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23344>>  =>  (V_MFMA_F32_32X32X16_F16_mac_e64:{ *:[v16f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 262980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_F16_mac_e64),
     /* 262983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262985 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 262987 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 262989 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 262991 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 262993 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 262995 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 262997 */     GIR_RootConstrainSelectedInstOperands,
     /* 262998 */     // GIR_Coverage, 1165,
     /* 262998 */     GIR_EraseRootFromParent_Done,
     /* 262999 */   // Label 4249: @262999
     /* 262999 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(263060), // Rule ID 1166 //
     /* 263004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 263007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_f16),
     /* 263012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 263021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 263028 */     // MIs[0] cbsz
     /* 263028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263031 */     // MIs[0] abid
     /* 263031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263034 */     // MIs[0] blgp
     /* 263034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263037 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23346),
     /* 263041 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3038:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23346>>  =>  (V_MFMA_F32_32X32X16_F16_mac_vgprcd_e64:{ *:[v16f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_F16_mac_vgprcd_e64),
     /* 263044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263046 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263048 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263050 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263052 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263054 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263056 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263058 */     GIR_RootConstrainSelectedInstOperands,
     /* 263059 */     // GIR_Coverage, 1166,
     /* 263059 */     GIR_EraseRootFromParent_Done,
     /* 263060 */   // Label 4250: @263060
     /* 263060 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(263121), // Rule ID 1167 //
     /* 263065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 263068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x64_i8),
     /* 263073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 263076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 263079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 263082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 263085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 263089 */     // MIs[0] cbsz
     /* 263089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263092 */     // MIs[0] abid
     /* 263092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263095 */     // MIs[0] blgp
     /* 263095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23352),
     /* 263102 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3059:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23352>>  =>  (V_MFMA_I32_16X16X64_I8_e64:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X64_I8_e64),
     /* 263105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263107 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263109 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263111 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263113 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263115 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263117 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263119 */     GIR_RootConstrainSelectedInstOperands,
     /* 263120 */     // GIR_Coverage, 1167,
     /* 263120 */     GIR_EraseRootFromParent_Done,
     /* 263121 */   // Label 4251: @263121
     /* 263121 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(263182), // Rule ID 1168 //
     /* 263126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 263129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x64_i8),
     /* 263134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 263137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 263140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 263143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 263146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 263150 */     // MIs[0] cbsz
     /* 263150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263153 */     // MIs[0] abid
     /* 263153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263156 */     // MIs[0] blgp
     /* 263156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23354),
     /* 263163 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3059:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23354>>  =>  (V_MFMA_I32_16X16X64_I8_vgprcd_e64:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X64_I8_vgprcd_e64),
     /* 263166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263168 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263170 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263172 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263174 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263176 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263178 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263180 */     GIR_RootConstrainSelectedInstOperands,
     /* 263181 */     // GIR_Coverage, 1168,
     /* 263181 */     GIR_EraseRootFromParent_Done,
     /* 263182 */   // Label 4252: @263182
     /* 263182 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(263243), // Rule ID 1169 //
     /* 263187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 263190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x32_i8),
     /* 263195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 263201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 263204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 263211 */     // MIs[0] cbsz
     /* 263211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263214 */     // MIs[0] abid
     /* 263214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263217 */     // MIs[0] blgp
     /* 263217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23364),
     /* 263224 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3061:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23364>>  =>  (V_MFMA_I32_32X32X32_I8_mac_e64:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X32_I8_mac_e64),
     /* 263227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263229 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263231 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263233 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263235 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263237 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263239 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263241 */     GIR_RootConstrainSelectedInstOperands,
     /* 263242 */     // GIR_Coverage, 1169,
     /* 263242 */     GIR_EraseRootFromParent_Done,
     /* 263243 */   // Label 4253: @263243
     /* 263243 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(263304), // Rule ID 1170 //
     /* 263248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 263251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x32_i8),
     /* 263256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 263262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 263265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 263272 */     // MIs[0] cbsz
     /* 263272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263275 */     // MIs[0] abid
     /* 263275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263278 */     // MIs[0] blgp
     /* 263278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23366),
     /* 263285 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3061:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23366>>  =>  (V_MFMA_I32_32X32X32_I8_mac_vgprcd_e64:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X32_I8_mac_vgprcd_e64),
     /* 263288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263290 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263292 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263294 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263296 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263298 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263300 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263302 */     GIR_RootConstrainSelectedInstOperands,
     /* 263303 */     // GIR_Coverage, 1170,
     /* 263303 */     GIR_EraseRootFromParent_Done,
     /* 263304 */   // Label 4254: @263304
     /* 263304 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(263365), // Rule ID 1243 //
     /* 263309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16_1k),
     /* 263317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 263320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 263329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 263333 */     // MIs[0] cbsz
     /* 263333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263336 */     // MIs[0] abid
     /* 263336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263339 */     // MIs[0] blgp
     /* 263339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263342 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23488),
     /* 263346 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3046:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23488>>  =>  (V_MFMA_F32_32X32X4BF16_1K_mac_e64:{ *:[v32f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_1K_mac_e64),
     /* 263349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263351 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263353 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263355 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263357 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263359 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263361 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263363 */     GIR_RootConstrainSelectedInstOperands,
     /* 263364 */     // GIR_Coverage, 1243,
     /* 263364 */     GIR_EraseRootFromParent_Done,
     /* 263365 */   // Label 4255: @263365
     /* 263365 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(263426), // Rule ID 1244 //
     /* 263370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16_1k),
     /* 263378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 263381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 263390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 263394 */     // MIs[0] cbsz
     /* 263394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263397 */     // MIs[0] abid
     /* 263397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263400 */     // MIs[0] blgp
     /* 263400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263403 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23490),
     /* 263407 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3046:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23490>>  =>  (V_MFMA_F32_32X32X4BF16_1K_mac_vgprcd_e64:{ *:[v32f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_1K_mac_vgprcd_e64),
     /* 263410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263412 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263414 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263416 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263418 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263420 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263422 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263424 */     GIR_RootConstrainSelectedInstOperands,
     /* 263425 */     // GIR_Coverage, 1244,
     /* 263425 */     GIR_EraseRootFromParent_Done,
     /* 263426 */   // Label 4256: @263426
     /* 263426 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(263487), // Rule ID 1245 //
     /* 263431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4bf16_1k),
     /* 263439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 263455 */     // MIs[0] cbsz
     /* 263455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263458 */     // MIs[0] abid
     /* 263458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263461 */     // MIs[0] blgp
     /* 263461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263464 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23494),
     /* 263468 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3030:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23494>>  =>  (V_MFMA_F32_16X16X4BF16_1K_mac_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4BF16_1K_mac_e64),
     /* 263471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263473 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263475 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263477 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263479 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263481 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263483 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263485 */     GIR_RootConstrainSelectedInstOperands,
     /* 263486 */     // GIR_Coverage, 1245,
     /* 263486 */     GIR_EraseRootFromParent_Done,
     /* 263487 */   // Label 4257: @263487
     /* 263487 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(263548), // Rule ID 1246 //
     /* 263492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4bf16_1k),
     /* 263500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 263516 */     // MIs[0] cbsz
     /* 263516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263519 */     // MIs[0] abid
     /* 263519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263522 */     // MIs[0] blgp
     /* 263522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263525 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23496),
     /* 263529 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3030:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23496>>  =>  (V_MFMA_F32_16X16X4BF16_1K_mac_vgprcd_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4BF16_1K_mac_vgprcd_e64),
     /* 263532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263534 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263536 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263538 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263540 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263542 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263544 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263546 */     GIR_RootConstrainSelectedInstOperands,
     /* 263547 */     // GIR_Coverage, 1246,
     /* 263547 */     GIR_EraseRootFromParent_Done,
     /* 263548 */   // Label 4258: @263548
     /* 263548 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(263609), // Rule ID 1247 //
     /* 263553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4bf16_1k),
     /* 263561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 263564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 263573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 263577 */     // MIs[0] cbsz
     /* 263577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263580 */     // MIs[0] abid
     /* 263580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263583 */     // MIs[0] blgp
     /* 263583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263586 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23498),
     /* 263590 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3052:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23498>>  =>  (V_MFMA_F32_4X4X4BF16_1K_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4BF16_1K_e64),
     /* 263593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263595 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263597 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263599 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263601 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263603 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263605 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263607 */     GIR_RootConstrainSelectedInstOperands,
     /* 263608 */     // GIR_Coverage, 1247,
     /* 263608 */     GIR_EraseRootFromParent_Done,
     /* 263609 */   // Label 4259: @263609
     /* 263609 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(263670), // Rule ID 1248 //
     /* 263614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4bf16_1k),
     /* 263622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 263625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 263634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 263638 */     // MIs[0] cbsz
     /* 263638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263641 */     // MIs[0] abid
     /* 263641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263644 */     // MIs[0] blgp
     /* 263644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23500),
     /* 263651 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3052:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23500>>  =>  (V_MFMA_F32_4X4X4BF16_1K_vgprcd_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4BF16_1K_vgprcd_e64),
     /* 263654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263656 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263658 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263660 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263662 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263664 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263666 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263668 */     GIR_RootConstrainSelectedInstOperands,
     /* 263669 */     // GIR_Coverage, 1248,
     /* 263669 */     GIR_EraseRootFromParent_Done,
     /* 263670 */   // Label 4260: @263670
     /* 263670 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(263731), // Rule ID 1249 //
     /* 263675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8bf16_1k),
     /* 263683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 263699 */     // MIs[0] cbsz
     /* 263699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263702 */     // MIs[0] abid
     /* 263702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263705 */     // MIs[0] blgp
     /* 263705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23502),
     /* 263712 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3048:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23502>>  =>  (V_MFMA_F32_32X32X8BF16_1K_mac_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8BF16_1K_mac_e64),
     /* 263715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263717 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263719 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263721 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263723 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263725 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263727 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263729 */     GIR_RootConstrainSelectedInstOperands,
     /* 263730 */     // GIR_Coverage, 1249,
     /* 263730 */     GIR_EraseRootFromParent_Done,
     /* 263731 */   // Label 4261: @263731
     /* 263731 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(263792), // Rule ID 1250 //
     /* 263736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8bf16_1k),
     /* 263744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 263747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 263756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 263760 */     // MIs[0] cbsz
     /* 263760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263763 */     // MIs[0] abid
     /* 263763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263766 */     // MIs[0] blgp
     /* 263766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263769 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23504),
     /* 263773 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3048:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23504>>  =>  (V_MFMA_F32_32X32X8BF16_1K_mac_vgprcd_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8BF16_1K_mac_vgprcd_e64),
     /* 263776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263778 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263780 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263782 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263784 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263786 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263788 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263790 */     GIR_RootConstrainSelectedInstOperands,
     /* 263791 */     // GIR_Coverage, 1250,
     /* 263791 */     GIR_EraseRootFromParent_Done,
     /* 263792 */   // Label 4262: @263792
     /* 263792 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(263853), // Rule ID 1251 //
     /* 263797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16bf16_1k),
     /* 263805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 263808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 263817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 263821 */     // MIs[0] cbsz
     /* 263821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263824 */     // MIs[0] abid
     /* 263824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263827 */     // MIs[0] blgp
     /* 263827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263830 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23506),
     /* 263834 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3020:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23506>>  =>  (V_MFMA_F32_16X16X16BF16_1K_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16BF16_1K_e64),
     /* 263837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263839 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263841 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263843 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263845 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263847 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263849 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263851 */     GIR_RootConstrainSelectedInstOperands,
     /* 263852 */     // GIR_Coverage, 1251,
     /* 263852 */     GIR_EraseRootFromParent_Done,
     /* 263853 */   // Label 4263: @263853
     /* 263853 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(263914), // Rule ID 1252 //
     /* 263858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16bf16_1k),
     /* 263866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 263869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 263878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 263882 */     // MIs[0] cbsz
     /* 263882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263885 */     // MIs[0] abid
     /* 263885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263888 */     // MIs[0] blgp
     /* 263888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263891 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23508),
     /* 263895 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3020:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23508>>  =>  (V_MFMA_F32_16X16X16BF16_1K_vgprcd_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16BF16_1K_vgprcd_e64),
     /* 263898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263900 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263902 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263904 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263906 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263908 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263910 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263912 */     GIR_RootConstrainSelectedInstOperands,
     /* 263913 */     // GIR_Coverage, 1252,
     /* 263913 */     GIR_EraseRootFromParent_Done,
     /* 263914 */   // Label 4264: @263914
     /* 263914 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(263975), // Rule ID 1253 //
     /* 263919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_16x16x4f64),
     /* 263927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 263930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 263933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 263936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s64,
     /* 263939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_256RegClassID),
     /* 263943 */     // MIs[0] cbsz
     /* 263943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263946 */     // MIs[0] abid
     /* 263946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263949 */     // MIs[0] blgp
     /* 263949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263952 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23512),
     /* 263956 */     // (intrinsic_wo_chain:{ *:[v4f64] } 3054:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23512>>  =>  (V_MFMA_F64_16X16X4F64_mac_e64:{ *:[v4f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 263956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_16X16X4F64_mac_e64),
     /* 263959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263961 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 263963 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 263965 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 263967 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 263969 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 263971 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 263973 */     GIR_RootConstrainSelectedInstOperands,
     /* 263974 */     // GIR_Coverage, 1253,
     /* 263974 */     GIR_EraseRootFromParent_Done,
     /* 263975 */   // Label 4265: @263975
     /* 263975 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(264036), // Rule ID 1254 //
     /* 263980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 263983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_16x16x4f64),
     /* 263988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 263991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 263994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 263997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s64,
     /* 264000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 264004 */     // MIs[0] cbsz
     /* 264004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264007 */     // MIs[0] abid
     /* 264007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264010 */     // MIs[0] blgp
     /* 264010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23514),
     /* 264017 */     // (intrinsic_wo_chain:{ *:[v4f64] } 3054:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23514>>  =>  (V_MFMA_F64_16X16X4F64_mac_vgprcd_e64:{ *:[v4f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_16X16X4F64_mac_vgprcd_e64),
     /* 264020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264022 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264024 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264026 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264028 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264030 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264032 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264034 */     GIR_RootConstrainSelectedInstOperands,
     /* 264035 */     // GIR_Coverage, 1254,
     /* 264035 */     GIR_EraseRootFromParent_Done,
     /* 264036 */   // Label 4266: @264036
     /* 264036 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(264097), // Rule ID 1255 //
     /* 264041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 264044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_4x4x4f64),
     /* 264049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 264061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_64RegClassID),
     /* 264065 */     // MIs[0] cbsz
     /* 264065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264068 */     // MIs[0] abid
     /* 264068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264071 */     // MIs[0] blgp
     /* 264071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23516),
     /* 264078 */     // (intrinsic_wo_chain:{ *:[f64] } 3055:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23516>>  =>  (V_MFMA_F64_4X4X4F64_e64:{ *:[f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_4X4X4F64_e64),
     /* 264081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264083 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264085 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264087 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264089 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264091 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264093 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264095 */     GIR_RootConstrainSelectedInstOperands,
     /* 264096 */     // GIR_Coverage, 1255,
     /* 264096 */     GIR_EraseRootFromParent_Done,
     /* 264097 */   // Label 4267: @264097
     /* 264097 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(264158), // Rule ID 1256 //
     /* 264102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 264105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_4x4x4f64),
     /* 264110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 264113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 264122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 264126 */     // MIs[0] cbsz
     /* 264126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264129 */     // MIs[0] abid
     /* 264129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264132 */     // MIs[0] blgp
     /* 264132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264135 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23518),
     /* 264139 */     // (intrinsic_wo_chain:{ *:[f64] } 3055:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23518>>  =>  (V_MFMA_F64_4X4X4F64_vgprcd_e64:{ *:[f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_4X4X4F64_vgprcd_e64),
     /* 264142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264144 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264146 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264148 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264150 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264152 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264154 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264156 */     GIR_RootConstrainSelectedInstOperands,
     /* 264157 */     // GIR_Coverage, 1256,
     /* 264157 */     GIR_EraseRootFromParent_Done,
     /* 264158 */   // Label 4268: @264158
     /* 264158 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(264219), // Rule ID 1257 //
     /* 264163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 264166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x16_i8),
     /* 264171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 264174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 264183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 264187 */     // MIs[0] cbsz
     /* 264187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264190 */     // MIs[0] abid
     /* 264190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264193 */     // MIs[0] blgp
     /* 264193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23522),
     /* 264200 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3060:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23522>>  =>  (V_MFMA_I32_32X32X16I8_mac_e64:{ *:[v16i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X16I8_mac_e64),
     /* 264203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264205 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264207 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264209 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264211 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264213 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264215 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264217 */     GIR_RootConstrainSelectedInstOperands,
     /* 264218 */     // GIR_Coverage, 1257,
     /* 264218 */     GIR_EraseRootFromParent_Done,
     /* 264219 */   // Label 4269: @264219
     /* 264219 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(264280), // Rule ID 1258 //
     /* 264224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX940Plus),
     /* 264227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x16_i8),
     /* 264232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 264235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 264244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 264248 */     // MIs[0] cbsz
     /* 264248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264251 */     // MIs[0] abid
     /* 264251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264254 */     // MIs[0] blgp
     /* 264254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23524),
     /* 264261 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3060:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23524>>  =>  (V_MFMA_I32_32X32X16I8_mac_vgprcd_e64:{ *:[v16i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X16I8_mac_vgprcd_e64),
     /* 264264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264266 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264268 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264270 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264272 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264274 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264276 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264278 */     GIR_RootConstrainSelectedInstOperands,
     /* 264279 */     // GIR_Coverage, 1258,
     /* 264279 */     GIR_EraseRootFromParent_Done,
     /* 264280 */   // Label 4270: @264280
     /* 264280 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(264341), // Rule ID 1259 //
     /* 264285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 264288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x32_i8),
     /* 264293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 264309 */     // MIs[0] cbsz
     /* 264309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264312 */     // MIs[0] abid
     /* 264312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264315 */     // MIs[0] blgp
     /* 264315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264318 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23526),
     /* 264322 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3057:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23526>>  =>  (V_MFMA_I32_16X16X32I8_e64:{ *:[v4i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X32I8_e64),
     /* 264325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264327 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264329 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264331 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264333 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264335 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264337 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264339 */     GIR_RootConstrainSelectedInstOperands,
     /* 264340 */     // GIR_Coverage, 1259,
     /* 264340 */     GIR_EraseRootFromParent_Done,
     /* 264341 */   // Label 4271: @264341
     /* 264341 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(264402), // Rule ID 1260 //
     /* 264346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX940Plus),
     /* 264349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x32_i8),
     /* 264354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 264370 */     // MIs[0] cbsz
     /* 264370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264373 */     // MIs[0] abid
     /* 264373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264376 */     // MIs[0] blgp
     /* 264376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264379 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23528),
     /* 264383 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3057:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23528>>  =>  (V_MFMA_I32_16X16X32I8_vgprcd_e64:{ *:[v4i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X32I8_vgprcd_e64),
     /* 264386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264388 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264390 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264392 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264394 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264396 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264398 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264400 */     GIR_RootConstrainSelectedInstOperands,
     /* 264401 */     // GIR_Coverage, 1260,
     /* 264401 */     GIR_EraseRootFromParent_Done,
     /* 264402 */   // Label 4272: @264402
     /* 264402 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(264463), // Rule ID 1261 //
     /* 264407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts),
     /* 264410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8_xf32),
     /* 264415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 264424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 264431 */     // MIs[0] cbsz
     /* 264431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264434 */     // MIs[0] abid
     /* 264434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264437 */     // MIs[0] blgp
     /* 264437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23530),
     /* 264444 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3033:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23530>>  =>  (V_MFMA_F32_16X16X8XF32_e64:{ *:[v4f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8XF32_e64),
     /* 264447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264449 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264451 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264453 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264455 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264457 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264459 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264461 */     GIR_RootConstrainSelectedInstOperands,
     /* 264462 */     // GIR_Coverage, 1261,
     /* 264462 */     GIR_EraseRootFromParent_Done,
     /* 264463 */   // Label 4273: @264463
     /* 264463 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(264524), // Rule ID 1262 //
     /* 264468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts_isGFX90APlus),
     /* 264471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8_xf32),
     /* 264476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 264485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 264492 */     // MIs[0] cbsz
     /* 264492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264495 */     // MIs[0] abid
     /* 264495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264498 */     // MIs[0] blgp
     /* 264498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264501 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23532),
     /* 264505 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3033:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23532>>  =>  (V_MFMA_F32_16X16X8XF32_vgprcd_e64:{ *:[v4f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8XF32_vgprcd_e64),
     /* 264508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264510 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264512 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264514 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264516 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264518 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264520 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264522 */     GIR_RootConstrainSelectedInstOperands,
     /* 264523 */     // GIR_Coverage, 1262,
     /* 264523 */     GIR_EraseRootFromParent_Done,
     /* 264524 */   // Label 4274: @264524
     /* 264524 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(264585), // Rule ID 1263 //
     /* 264529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts),
     /* 264532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4_xf32),
     /* 264537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 264540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 264546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 264549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 264553 */     // MIs[0] cbsz
     /* 264553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264556 */     // MIs[0] abid
     /* 264556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264559 */     // MIs[0] blgp
     /* 264559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264562 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23536),
     /* 264566 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3044:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23536>>  =>  (V_MFMA_F32_32X32X4XF32_mac_e64:{ *:[v16f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4XF32_mac_e64),
     /* 264569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264571 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264573 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264575 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264577 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264579 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264581 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264583 */     GIR_RootConstrainSelectedInstOperands,
     /* 264584 */     // GIR_Coverage, 1263,
     /* 264584 */     GIR_EraseRootFromParent_Done,
     /* 264585 */   // Label 4275: @264585
     /* 264585 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(264646), // Rule ID 1264 //
     /* 264590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts_isGFX90APlus),
     /* 264593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4_xf32),
     /* 264598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 264601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 264607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 264610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 264614 */     // MIs[0] cbsz
     /* 264614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264617 */     // MIs[0] abid
     /* 264617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264620 */     // MIs[0] blgp
     /* 264620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264623 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23538),
     /* 264627 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3044:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23538>>  =>  (V_MFMA_F32_32X32X4XF32_mac_vgprcd_e64:{ *:[v16f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4XF32_mac_vgprcd_e64),
     /* 264630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264632 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264634 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264636 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264638 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264640 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264642 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264644 */     GIR_RootConstrainSelectedInstOperands,
     /* 264645 */     // GIR_Coverage, 1264,
     /* 264645 */     GIR_EraseRootFromParent_Done,
     /* 264646 */   // Label 4276: @264646
     /* 264646 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(264707), // Rule ID 1265 //
     /* 264651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 264654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_bf8),
     /* 264659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 264675 */     // MIs[0] cbsz
     /* 264675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264678 */     // MIs[0] abid
     /* 264678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264681 */     // MIs[0] blgp
     /* 264681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23540),
     /* 264688 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3025:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23540>>  =>  (V_MFMA_F32_16X16X32_BF8_BF8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_BF8_e64),
     /* 264691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264693 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264695 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264697 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264699 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264701 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264703 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264705 */     GIR_RootConstrainSelectedInstOperands,
     /* 264706 */     // GIR_Coverage, 1265,
     /* 264706 */     GIR_EraseRootFromParent_Done,
     /* 264707 */   // Label 4277: @264707
     /* 264707 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(264768), // Rule ID 1266 //
     /* 264712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 264715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_bf8),
     /* 264720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 264736 */     // MIs[0] cbsz
     /* 264736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264739 */     // MIs[0] abid
     /* 264739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264742 */     // MIs[0] blgp
     /* 264742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23542),
     /* 264749 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3025:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23542>>  =>  (V_MFMA_F32_16X16X32_BF8_BF8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_BF8_vgprcd_e64),
     /* 264752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264754 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264756 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264758 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264760 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264762 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264764 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264766 */     GIR_RootConstrainSelectedInstOperands,
     /* 264767 */     // GIR_Coverage, 1266,
     /* 264767 */     GIR_EraseRootFromParent_Done,
     /* 264768 */   // Label 4278: @264768
     /* 264768 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(264829), // Rule ID 1267 //
     /* 264773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 264776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_fp8),
     /* 264781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 264797 */     // MIs[0] cbsz
     /* 264797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264800 */     // MIs[0] abid
     /* 264800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264803 */     // MIs[0] blgp
     /* 264803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23544),
     /* 264810 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3026:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23544>>  =>  (V_MFMA_F32_16X16X32_BF8_FP8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_FP8_e64),
     /* 264813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264815 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264817 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264819 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264821 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264823 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264825 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264827 */     GIR_RootConstrainSelectedInstOperands,
     /* 264828 */     // GIR_Coverage, 1267,
     /* 264828 */     GIR_EraseRootFromParent_Done,
     /* 264829 */   // Label 4279: @264829
     /* 264829 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(264890), // Rule ID 1268 //
     /* 264834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 264837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_fp8),
     /* 264842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 264858 */     // MIs[0] cbsz
     /* 264858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264861 */     // MIs[0] abid
     /* 264861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264864 */     // MIs[0] blgp
     /* 264864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23546),
     /* 264871 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3026:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23546>>  =>  (V_MFMA_F32_16X16X32_BF8_FP8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_FP8_vgprcd_e64),
     /* 264874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264876 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264878 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264880 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264882 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264884 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264886 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264888 */     GIR_RootConstrainSelectedInstOperands,
     /* 264889 */     // GIR_Coverage, 1268,
     /* 264889 */     GIR_EraseRootFromParent_Done,
     /* 264890 */   // Label 4280: @264890
     /* 264890 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(264951), // Rule ID 1269 //
     /* 264895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 264898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_bf8),
     /* 264903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 264919 */     // MIs[0] cbsz
     /* 264919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264922 */     // MIs[0] abid
     /* 264922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264925 */     // MIs[0] blgp
     /* 264925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264928 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23548),
     /* 264932 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3028:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23548>>  =>  (V_MFMA_F32_16X16X32_FP8_BF8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_BF8_e64),
     /* 264935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264937 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264939 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264941 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264943 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264945 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264947 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264949 */     GIR_RootConstrainSelectedInstOperands,
     /* 264950 */     // GIR_Coverage, 1269,
     /* 264950 */     GIR_EraseRootFromParent_Done,
     /* 264951 */   // Label 4281: @264951
     /* 264951 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(265012), // Rule ID 1270 //
     /* 264956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 264959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_bf8),
     /* 264964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 264973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 264980 */     // MIs[0] cbsz
     /* 264980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264983 */     // MIs[0] abid
     /* 264983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264986 */     // MIs[0] blgp
     /* 264986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264989 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23550),
     /* 264993 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3028:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23550>>  =>  (V_MFMA_F32_16X16X32_FP8_BF8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_BF8_vgprcd_e64),
     /* 264996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264998 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265000 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265002 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265004 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265006 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265008 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265010 */     GIR_RootConstrainSelectedInstOperands,
     /* 265011 */     // GIR_Coverage, 1270,
     /* 265011 */     GIR_EraseRootFromParent_Done,
     /* 265012 */   // Label 4282: @265012
     /* 265012 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(265073), // Rule ID 1271 //
     /* 265017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 265020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_fp8),
     /* 265025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 265041 */     // MIs[0] cbsz
     /* 265041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265044 */     // MIs[0] abid
     /* 265044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265047 */     // MIs[0] blgp
     /* 265047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23552),
     /* 265054 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3029:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23552>>  =>  (V_MFMA_F32_16X16X32_FP8_FP8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_FP8_e64),
     /* 265057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265059 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265061 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265063 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265065 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265067 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265069 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265071 */     GIR_RootConstrainSelectedInstOperands,
     /* 265072 */     // GIR_Coverage, 1271,
     /* 265072 */     GIR_EraseRootFromParent_Done,
     /* 265073 */   // Label 4283: @265073
     /* 265073 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(265134), // Rule ID 1272 //
     /* 265078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 265081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_fp8),
     /* 265086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 265102 */     // MIs[0] cbsz
     /* 265102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265105 */     // MIs[0] abid
     /* 265105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265108 */     // MIs[0] blgp
     /* 265108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23554),
     /* 265115 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3029:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23554>>  =>  (V_MFMA_F32_16X16X32_FP8_FP8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_FP8_vgprcd_e64),
     /* 265118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265120 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265122 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265124 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265126 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265128 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265130 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265132 */     GIR_RootConstrainSelectedInstOperands,
     /* 265133 */     // GIR_Coverage, 1272,
     /* 265133 */     GIR_EraseRootFromParent_Done,
     /* 265134 */   // Label 4284: @265134
     /* 265134 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(265195), // Rule ID 1273 //
     /* 265139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 265142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_bf8),
     /* 265147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 265163 */     // MIs[0] cbsz
     /* 265163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265166 */     // MIs[0] abid
     /* 265166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265169 */     // MIs[0] blgp
     /* 265169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265172 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23558),
     /* 265176 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3036:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23558>>  =>  (V_MFMA_F32_32X32X16_BF8_BF8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_BF8_mac_e64),
     /* 265179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265183 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265185 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265187 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265189 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265191 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265193 */     GIR_RootConstrainSelectedInstOperands,
     /* 265194 */     // GIR_Coverage, 1273,
     /* 265194 */     GIR_EraseRootFromParent_Done,
     /* 265195 */   // Label 4285: @265195
     /* 265195 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(265256), // Rule ID 1274 //
     /* 265200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 265203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_bf8),
     /* 265208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 265224 */     // MIs[0] cbsz
     /* 265224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265227 */     // MIs[0] abid
     /* 265227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265230 */     // MIs[0] blgp
     /* 265230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265233 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23560),
     /* 265237 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3036:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23560>>  =>  (V_MFMA_F32_32X32X16_BF8_BF8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_BF8_mac_vgprcd_e64),
     /* 265240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265242 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265244 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265246 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265248 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265250 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265252 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265254 */     GIR_RootConstrainSelectedInstOperands,
     /* 265255 */     // GIR_Coverage, 1274,
     /* 265255 */     GIR_EraseRootFromParent_Done,
     /* 265256 */   // Label 4286: @265256
     /* 265256 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(265317), // Rule ID 1275 //
     /* 265261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 265264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_fp8),
     /* 265269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 265285 */     // MIs[0] cbsz
     /* 265285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265288 */     // MIs[0] abid
     /* 265288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265291 */     // MIs[0] blgp
     /* 265291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23562),
     /* 265298 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3037:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23562>>  =>  (V_MFMA_F32_32X32X16_BF8_FP8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_FP8_mac_e64),
     /* 265301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265303 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265305 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265307 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265309 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265311 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265313 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265315 */     GIR_RootConstrainSelectedInstOperands,
     /* 265316 */     // GIR_Coverage, 1275,
     /* 265316 */     GIR_EraseRootFromParent_Done,
     /* 265317 */   // Label 4287: @265317
     /* 265317 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(265378), // Rule ID 1276 //
     /* 265322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 265325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_fp8),
     /* 265330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 265346 */     // MIs[0] cbsz
     /* 265346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265349 */     // MIs[0] abid
     /* 265349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265352 */     // MIs[0] blgp
     /* 265352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23564),
     /* 265359 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3037:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23564>>  =>  (V_MFMA_F32_32X32X16_BF8_FP8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_FP8_mac_vgprcd_e64),
     /* 265362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265364 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265366 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265368 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265370 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265372 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265374 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265376 */     GIR_RootConstrainSelectedInstOperands,
     /* 265377 */     // GIR_Coverage, 1276,
     /* 265377 */     GIR_EraseRootFromParent_Done,
     /* 265378 */   // Label 4288: @265378
     /* 265378 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(265439), // Rule ID 1277 //
     /* 265383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 265386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_bf8),
     /* 265391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 265407 */     // MIs[0] cbsz
     /* 265407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265410 */     // MIs[0] abid
     /* 265410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265413 */     // MIs[0] blgp
     /* 265413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265416 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23566),
     /* 265420 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3039:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23566>>  =>  (V_MFMA_F32_32X32X16_FP8_BF8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_BF8_mac_e64),
     /* 265423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265427 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265429 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265431 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265433 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265435 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265437 */     GIR_RootConstrainSelectedInstOperands,
     /* 265438 */     // GIR_Coverage, 1277,
     /* 265438 */     GIR_EraseRootFromParent_Done,
     /* 265439 */   // Label 4289: @265439
     /* 265439 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(265500), // Rule ID 1278 //
     /* 265444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 265447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_bf8),
     /* 265452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 265468 */     // MIs[0] cbsz
     /* 265468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265471 */     // MIs[0] abid
     /* 265471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265474 */     // MIs[0] blgp
     /* 265474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265477 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23568),
     /* 265481 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3039:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23568>>  =>  (V_MFMA_F32_32X32X16_FP8_BF8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_BF8_mac_vgprcd_e64),
     /* 265484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265486 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265488 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265490 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265492 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265494 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265496 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265498 */     GIR_RootConstrainSelectedInstOperands,
     /* 265499 */     // GIR_Coverage, 1278,
     /* 265499 */     GIR_EraseRootFromParent_Done,
     /* 265500 */   // Label 4290: @265500
     /* 265500 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(265561), // Rule ID 1279 //
     /* 265505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 265508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_fp8),
     /* 265513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 265529 */     // MIs[0] cbsz
     /* 265529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265532 */     // MIs[0] abid
     /* 265532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265535 */     // MIs[0] blgp
     /* 265535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265538 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23570),
     /* 265542 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3040:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23570>>  =>  (V_MFMA_F32_32X32X16_FP8_FP8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_FP8_mac_e64),
     /* 265545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265547 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265549 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265551 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265553 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265555 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265557 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265559 */     GIR_RootConstrainSelectedInstOperands,
     /* 265560 */     // GIR_Coverage, 1279,
     /* 265560 */     GIR_EraseRootFromParent_Done,
     /* 265561 */   // Label 4291: @265561
     /* 265561 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(265622), // Rule ID 1280 //
     /* 265566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 265569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_fp8),
     /* 265574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 265580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 265583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 265590 */     // MIs[0] cbsz
     /* 265590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265593 */     // MIs[0] abid
     /* 265593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265596 */     // MIs[0] blgp
     /* 265596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265599 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23572),
     /* 265603 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3040:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23572>>  =>  (V_MFMA_F32_32X32X16_FP8_FP8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_FP8_mac_vgprcd_e64),
     /* 265606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265608 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265610 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265612 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265614 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265616 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265618 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265620 */     GIR_RootConstrainSelectedInstOperands,
     /* 265621 */     // GIR_Coverage, 1280,
     /* 265621 */     GIR_EraseRootFromParent_Done,
     /* 265622 */   // Label 4292: @265622
     /* 265622 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(265679), // Rule ID 1281 //
     /* 265627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 265630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x32_f16),
     /* 265635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 265644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 265650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 265654 */     // MIs[0] cbsz
     /* 265654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265657 */     // MIs[0] abid
     /* 265657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265660 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3209:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X32_F16_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 265660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X32_F16_e64),
     /* 265663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265665 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265667 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265669 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 265671 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 265673 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 265675 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265677 */     GIR_RootConstrainSelectedInstOperands,
     /* 265678 */     // GIR_Coverage, 1281,
     /* 265678 */     GIR_EraseRootFromParent_Done,
     /* 265679 */   // Label 4293: @265679
     /* 265679 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(265736), // Rule ID 1282 //
     /* 265684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 265687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x16_f16),
     /* 265692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 265701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 265707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 265711 */     // MIs[0] cbsz
     /* 265711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265714 */     // MIs[0] abid
     /* 265714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265717 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3217:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X16_F16_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 265717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X16_F16_e64),
     /* 265720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265722 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265724 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265726 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 265728 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 265730 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 265732 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265734 */     GIR_RootConstrainSelectedInstOperands,
     /* 265735 */     // GIR_Coverage, 1282,
     /* 265735 */     GIR_EraseRootFromParent_Done,
     /* 265736 */   // Label 4294: @265736
     /* 265736 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(265793), // Rule ID 1283 //
     /* 265741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 265744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x32_bf16),
     /* 265749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 265758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 265764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 265768 */     // MIs[0] cbsz
     /* 265768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265771 */     // MIs[0] abid
     /* 265771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265774 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3208:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X32_BF16_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 265774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X32_BF16_e64),
     /* 265777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265781 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265783 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 265785 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 265787 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 265789 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265791 */     GIR_RootConstrainSelectedInstOperands,
     /* 265792 */     // GIR_Coverage, 1283,
     /* 265792 */     GIR_EraseRootFromParent_Done,
     /* 265793 */   // Label 4295: @265793
     /* 265793 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(265850), // Rule ID 1284 //
     /* 265798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 265801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x16_bf16),
     /* 265806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 265815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 265821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 265825 */     // MIs[0] cbsz
     /* 265825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265828 */     // MIs[0] abid
     /* 265828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265831 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3216:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X16_BF16_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 265831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X16_BF16_e64),
     /* 265834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265836 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265838 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265840 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 265842 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 265844 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 265846 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265848 */     GIR_RootConstrainSelectedInstOperands,
     /* 265849 */     // GIR_Coverage, 1284,
     /* 265849 */     GIR_EraseRootFromParent_Done,
     /* 265850 */   // Label 4296: @265850
     /* 265850 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(265907), // Rule ID 1285 //
     /* 265855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 265858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_16x16x64_i8),
     /* 265863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 265869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 265872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 265878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 265882 */     // MIs[0] cbsz
     /* 265882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265885 */     // MIs[0] abid
     /* 265885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265888 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3229:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_16X16X64_I8_e64:{ *:[v4i32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4i32:{ *:[v4i32] }:$src2)
     /* 265888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_16X16X64_I8_e64),
     /* 265891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265893 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265895 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265897 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 265899 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 265901 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 265903 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265905 */     GIR_RootConstrainSelectedInstOperands,
     /* 265906 */     // GIR_Coverage, 1285,
     /* 265906 */     GIR_EraseRootFromParent_Done,
     /* 265907 */   // Label 4297: @265907
     /* 265907 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(265964), // Rule ID 1286 //
     /* 265912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 265915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_32x32x32_i8),
     /* 265920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 265926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 265929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 265935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 265939 */     // MIs[0] cbsz
     /* 265939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265942 */     // MIs[0] abid
     /* 265942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265945 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3230:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_32X32X32_I8_e64:{ *:[v16i32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16i32:{ *:[v16i32] }:$src2)
     /* 265945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_32X32X32_I8_e64),
     /* 265948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265950 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265952 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265954 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 265956 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 265958 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 265960 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265962 */     GIR_RootConstrainSelectedInstOperands,
     /* 265963 */     // GIR_Coverage, 1286,
     /* 265963 */     GIR_EraseRootFromParent_Done,
     /* 265964 */   // Label 4298: @265964
     /* 265964 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(266021), // Rule ID 1287 //
     /* 265969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 265972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_bf8_bf8),
     /* 265977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 265983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 265986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 265992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 265996 */     // MIs[0] cbsz
     /* 265996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265999 */     // MIs[0] abid
     /* 265999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266002 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3211:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_BF8_BF8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_BF8_BF8_e64),
     /* 266005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266007 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266009 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266011 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266013 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266015 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266017 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266019 */     GIR_RootConstrainSelectedInstOperands,
     /* 266020 */     // GIR_Coverage, 1287,
     /* 266020 */     GIR_EraseRootFromParent_Done,
     /* 266021 */   // Label 4299: @266021
     /* 266021 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(266078), // Rule ID 1288 //
     /* 266026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_bf8_fp8),
     /* 266034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266053 */     // MIs[0] cbsz
     /* 266053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266056 */     // MIs[0] abid
     /* 266056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266059 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3212:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_BF8_FP8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_BF8_FP8_e64),
     /* 266062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266064 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266066 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266068 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266070 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266072 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266074 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266076 */     GIR_RootConstrainSelectedInstOperands,
     /* 266077 */     // GIR_Coverage, 1288,
     /* 266077 */     GIR_EraseRootFromParent_Done,
     /* 266078 */   // Label 4300: @266078
     /* 266078 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(266135), // Rule ID 1289 //
     /* 266083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_fp8_bf8),
     /* 266091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266110 */     // MIs[0] cbsz
     /* 266110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266113 */     // MIs[0] abid
     /* 266113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266116 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3214:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_FP8_BF8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_FP8_BF8_e64),
     /* 266119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266121 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266123 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266125 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266127 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266129 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266131 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266133 */     GIR_RootConstrainSelectedInstOperands,
     /* 266134 */     // GIR_Coverage, 1289,
     /* 266134 */     GIR_EraseRootFromParent_Done,
     /* 266135 */   // Label 4301: @266135
     /* 266135 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(266192), // Rule ID 1290 //
     /* 266140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_fp8_fp8),
     /* 266148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266167 */     // MIs[0] cbsz
     /* 266167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266170 */     // MIs[0] abid
     /* 266170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266173 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3215:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_FP8_FP8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_FP8_FP8_e64),
     /* 266176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266178 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266180 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266182 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266184 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266186 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266188 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266190 */     GIR_RootConstrainSelectedInstOperands,
     /* 266191 */     // GIR_Coverage, 1290,
     /* 266191 */     GIR_EraseRootFromParent_Done,
     /* 266192 */   // Label 4302: @266192
     /* 266192 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(266249), // Rule ID 1291 //
     /* 266197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_bf8_bf8),
     /* 266205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266224 */     // MIs[0] cbsz
     /* 266224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266227 */     // MIs[0] abid
     /* 266227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266230 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3219:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_BF8_BF8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_BF8_BF8_e64),
     /* 266233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266235 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266237 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266239 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266241 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266243 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266245 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266247 */     GIR_RootConstrainSelectedInstOperands,
     /* 266248 */     // GIR_Coverage, 1291,
     /* 266248 */     GIR_EraseRootFromParent_Done,
     /* 266249 */   // Label 4303: @266249
     /* 266249 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(266306), // Rule ID 1292 //
     /* 266254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_bf8_fp8),
     /* 266262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266281 */     // MIs[0] cbsz
     /* 266281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266284 */     // MIs[0] abid
     /* 266284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266287 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3220:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_BF8_FP8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_BF8_FP8_e64),
     /* 266290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266292 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266294 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266296 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266298 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266300 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266302 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266304 */     GIR_RootConstrainSelectedInstOperands,
     /* 266305 */     // GIR_Coverage, 1292,
     /* 266305 */     GIR_EraseRootFromParent_Done,
     /* 266306 */   // Label 4304: @266306
     /* 266306 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(266363), // Rule ID 1293 //
     /* 266311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_fp8_bf8),
     /* 266319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266338 */     // MIs[0] cbsz
     /* 266338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266341 */     // MIs[0] abid
     /* 266341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266344 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3222:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_FP8_BF8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_FP8_BF8_e64),
     /* 266347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266349 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266351 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266353 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266355 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266357 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266359 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266361 */     GIR_RootConstrainSelectedInstOperands,
     /* 266362 */     // GIR_Coverage, 1293,
     /* 266362 */     GIR_EraseRootFromParent_Done,
     /* 266363 */   // Label 4305: @266363
     /* 266363 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(266420), // Rule ID 1294 //
     /* 266368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 266371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_fp8_fp8),
     /* 266376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 266382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266395 */     // MIs[0] cbsz
     /* 266395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266398 */     // MIs[0] abid
     /* 266398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266401 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3223:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_FP8_FP8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_FP8_FP8_e64),
     /* 266404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266406 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266408 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266410 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266412 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266414 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266416 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266418 */     GIR_RootConstrainSelectedInstOperands,
     /* 266419 */     // GIR_Coverage, 1294,
     /* 266419 */     GIR_EraseRootFromParent_Done,
     /* 266420 */   // Label 4306: @266420
     /* 266420 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(266477), // Rule ID 1295 //
     /* 266425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_f16),
     /* 266433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 266439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 266442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266452 */     // MIs[0] cbsz
     /* 266452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266455 */     // MIs[0] abid
     /* 266455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266458 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3213:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_F16_e64:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_F16_e64),
     /* 266461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266465 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266467 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266469 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266471 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266473 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266475 */     GIR_RootConstrainSelectedInstOperands,
     /* 266476 */     // GIR_Coverage, 1295,
     /* 266476 */     GIR_EraseRootFromParent_Done,
     /* 266477 */   // Label 4307: @266477
     /* 266477 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(266534), // Rule ID 1296 //
     /* 266482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_f16),
     /* 266490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 266496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 266499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266509 */     // MIs[0] cbsz
     /* 266509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266512 */     // MIs[0] abid
     /* 266512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266515 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3221:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_F16_e64:{ *:[v16f32] } v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_F16_e64),
     /* 266518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266520 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266522 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266524 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266526 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266528 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266530 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266532 */     GIR_RootConstrainSelectedInstOperands,
     /* 266533 */     // GIR_Coverage, 1296,
     /* 266533 */     GIR_EraseRootFromParent_Done,
     /* 266534 */   // Label 4308: @266534
     /* 266534 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(266591), // Rule ID 1297 //
     /* 266539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_16x16x128_i8),
     /* 266547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 266556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266566 */     // MIs[0] cbsz
     /* 266566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266569 */     // MIs[0] abid
     /* 266569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266572 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3228:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_16X16X128_I8_e64:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4i32:{ *:[v4i32] }:$src2)
     /* 266572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_16X16X128_I8_e64),
     /* 266575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266577 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266579 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266581 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266583 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266585 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266587 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266589 */     GIR_RootConstrainSelectedInstOperands,
     /* 266590 */     // GIR_Coverage, 1297,
     /* 266590 */     GIR_EraseRootFromParent_Done,
     /* 266591 */   // Label 4309: @266591
     /* 266591 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(266648), // Rule ID 1298 //
     /* 266596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_32x32x64_i8),
     /* 266604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 266613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266623 */     // MIs[0] cbsz
     /* 266623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266626 */     // MIs[0] abid
     /* 266626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266629 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3231:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_32X32X64_I8_e64:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16i32:{ *:[v16i32] }:$src2)
     /* 266629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_32X32X64_I8_e64),
     /* 266632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266634 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266636 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266638 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266640 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266642 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266644 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266646 */     GIR_RootConstrainSelectedInstOperands,
     /* 266647 */     // GIR_Coverage, 1298,
     /* 266647 */     GIR_EraseRootFromParent_Done,
     /* 266648 */   // Label 4310: @266648
     /* 266648 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(266705), // Rule ID 1299 //
     /* 266653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_bf8_bf8),
     /* 266661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 266670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266680 */     // MIs[0] cbsz
     /* 266680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266683 */     // MIs[0] abid
     /* 266683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266686 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3204:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_BF8_BF8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_BF8_BF8_e64),
     /* 266689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266691 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266693 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266695 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266697 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266699 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266701 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266703 */     GIR_RootConstrainSelectedInstOperands,
     /* 266704 */     // GIR_Coverage, 1299,
     /* 266704 */     GIR_EraseRootFromParent_Done,
     /* 266705 */   // Label 4311: @266705
     /* 266705 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(266762), // Rule ID 1300 //
     /* 266710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_bf8_fp8),
     /* 266718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 266727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266737 */     // MIs[0] cbsz
     /* 266737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266740 */     // MIs[0] abid
     /* 266740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266743 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3205:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_BF8_FP8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_BF8_FP8_e64),
     /* 266746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266748 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266750 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266752 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266754 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266756 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266758 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266760 */     GIR_RootConstrainSelectedInstOperands,
     /* 266761 */     // GIR_Coverage, 1300,
     /* 266761 */     GIR_EraseRootFromParent_Done,
     /* 266762 */   // Label 4312: @266762
     /* 266762 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(266819), // Rule ID 1301 //
     /* 266767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_fp8_bf8),
     /* 266775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 266784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266794 */     // MIs[0] cbsz
     /* 266794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266797 */     // MIs[0] abid
     /* 266797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266800 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3206:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_FP8_BF8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_FP8_BF8_e64),
     /* 266803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266805 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266807 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266809 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266811 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266813 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266815 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266817 */     GIR_RootConstrainSelectedInstOperands,
     /* 266818 */     // GIR_Coverage, 1301,
     /* 266818 */     GIR_EraseRootFromParent_Done,
     /* 266819 */   // Label 4313: @266819
     /* 266819 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(266876), // Rule ID 1302 //
     /* 266824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_fp8_fp8),
     /* 266832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 266841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 266851 */     // MIs[0] cbsz
     /* 266851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266854 */     // MIs[0] abid
     /* 266854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266857 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3207:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_FP8_FP8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 266857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_FP8_FP8_e64),
     /* 266860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266862 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266864 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266866 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266868 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266870 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266872 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266874 */     GIR_RootConstrainSelectedInstOperands,
     /* 266875 */     // GIR_Coverage, 1302,
     /* 266875 */     GIR_EraseRootFromParent_Done,
     /* 266876 */   // Label 4314: @266876
     /* 266876 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(266933), // Rule ID 1303 //
     /* 266881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_bf8_bf8),
     /* 266889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 266898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266908 */     // MIs[0] cbsz
     /* 266908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266911 */     // MIs[0] abid
     /* 266911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266914 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3224:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_BF8_BF8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_BF8_BF8_e64),
     /* 266917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266919 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266921 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266923 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266925 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266927 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266929 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266931 */     GIR_RootConstrainSelectedInstOperands,
     /* 266932 */     // GIR_Coverage, 1303,
     /* 266932 */     GIR_EraseRootFromParent_Done,
     /* 266933 */   // Label 4315: @266933
     /* 266933 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(266990), // Rule ID 1304 //
     /* 266938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_bf8_fp8),
     /* 266946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 266955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 266961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 266965 */     // MIs[0] cbsz
     /* 266965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266968 */     // MIs[0] abid
     /* 266968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266971 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3225:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_BF8_FP8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 266971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_BF8_FP8_e64),
     /* 266974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266978 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266980 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 266982 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 266984 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 266986 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266988 */     GIR_RootConstrainSelectedInstOperands,
     /* 266989 */     // GIR_Coverage, 1304,
     /* 266989 */     GIR_EraseRootFromParent_Done,
     /* 266990 */   // Label 4316: @266990
     /* 266990 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(267047), // Rule ID 1305 //
     /* 266995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 266998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_fp8_bf8),
     /* 267003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 267009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 267012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 267018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 267022 */     // MIs[0] cbsz
     /* 267022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267025 */     // MIs[0] abid
     /* 267025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267028 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3226:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_FP8_BF8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 267028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_FP8_BF8_e64),
     /* 267031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267033 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267035 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267037 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 267039 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 267041 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 267043 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267045 */     GIR_RootConstrainSelectedInstOperands,
     /* 267046 */     // GIR_Coverage, 1305,
     /* 267046 */     GIR_EraseRootFromParent_Done,
     /* 267047 */   // Label 4317: @267047
     /* 267047 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(267104), // Rule ID 1306 //
     /* 267052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_fp8_fp8),
     /* 267060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 267066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 267069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 267075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 267079 */     // MIs[0] cbsz
     /* 267079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267082 */     // MIs[0] abid
     /* 267082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267085 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3227:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_FP8_FP8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 267085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_FP8_FP8_e64),
     /* 267088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267090 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267092 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267094 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 267096 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 267098 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 267100 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267102 */     GIR_RootConstrainSelectedInstOperands,
     /* 267103 */     // GIR_Coverage, 1306,
     /* 267103 */     GIR_EraseRootFromParent_Done,
     /* 267104 */   // Label 4318: @267104
     /* 267104 */   GIM_Reject,
     /* 267105 */ // Label 4157: @267105
     /* 267105 */ GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(267645),
     /* 267110 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 267113 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(267204), // Rule ID 2840 //
     /* 267118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 267121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu8),
     /* 267126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 267129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 267132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /* 267135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 267138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 267141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 267145 */     // MIs[0] clamp
     /* 267145 */     // No operand predicates
     /* 267145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 267166 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3297:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU8_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
     /* 267166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU8_w32_twoaddr),
     /* 267169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 267176 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 267178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 267183 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 267185 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 267187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 267192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 267197 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 267199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267202 */     GIR_RootConstrainSelectedInstOperands,
     /* 267203 */     // GIR_Coverage, 2840,
     /* 267203 */     GIR_EraseRootFromParent_Done,
     /* 267204 */   // Label 4320: @267204
     /* 267204 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(267295), // Rule ID 2841 //
     /* 267209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 267212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu4),
     /* 267217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 267220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 267223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 267226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 267229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 267232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 267236 */     // MIs[0] clamp
     /* 267236 */     // No operand predicates
     /* 267236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 267257 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3296:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
     /* 267257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU4_w32_twoaddr),
     /* 267260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 267267 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 267269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 267274 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 267276 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 267278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 267283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 267288 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 267290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267293 */     GIR_RootConstrainSelectedInstOperands,
     /* 267294 */     // GIR_Coverage, 2841,
     /* 267294 */     GIR_EraseRootFromParent_Done,
     /* 267295 */   // Label 4321: @267295
     /* 267295 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(267386), // Rule ID 2873 //
     /* 267300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 267303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu8),
     /* 267308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 267314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 267317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 267320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 267323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 267327 */     // MIs[0] clamp
     /* 267327 */     // No operand predicates
     /* 267327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 267348 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3297:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU8_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit, i1:{ *:[i1] }:$clamp)
     /* 267348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU8_w64_twoaddr),
     /* 267351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 267358 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 267360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 267365 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 267367 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 267369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 267374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_8bit
     /* 267379 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 267381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267384 */     GIR_RootConstrainSelectedInstOperands,
     /* 267385 */     // GIR_Coverage, 2873,
     /* 267385 */     GIR_EraseRootFromParent_Done,
     /* 267386 */   // Label 4322: @267386
     /* 267386 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(267477), // Rule ID 2874 //
     /* 267391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 267394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu4),
     /* 267399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 267405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 267408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 267411 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 267414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 267418 */     // MIs[0] clamp
     /* 267418 */     // No operand predicates
     /* 267418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 267439 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3296:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
     /* 267439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU4_w64_twoaddr),
     /* 267442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 267449 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 267451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 267456 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 267458 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 267460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 267465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 267470 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 267472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267475 */     GIR_RootConstrainSelectedInstOperands,
     /* 267476 */     // GIR_Coverage, 2874,
     /* 267476 */     GIR_EraseRootFromParent_Done,
     /* 267477 */   // Label 4323: @267477
     /* 267477 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(267568), // Rule ID 2875 //
     /* 267482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 267485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x64_iu4),
     /* 267490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 267496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 267499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 267502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 267505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 267509 */     // MIs[0] clamp
     /* 267509 */     // No operand predicates
     /* 267509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 267530 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3298:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X64_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
     /* 267530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X64_IU4_w64_twoaddr),
     /* 267533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 267540 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 267542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 267547 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 267549 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 267551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 267556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 267561 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 267563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267566 */     GIR_RootConstrainSelectedInstOperands,
     /* 267567 */     // GIR_Coverage, 2875,
     /* 267567 */     GIR_EraseRootFromParent_Done,
     /* 267568 */   // Label 4324: @267568
     /* 267568 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(267644), // Rule ID 2842 //
     /* 267573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 267576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x64_iu4),
     /* 267581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 267584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 267587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /* 267590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 267593 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 267596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 267600 */     // MIs[0] clamp
     /* 267600 */     // No operand predicates
     /* 267600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 267614 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3298:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X64_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 267614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X64_IU4_w32_twoaddr),
     /* 267617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 267624 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 267626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 267631 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 267633 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 267635 */     GIR_RootToRootCopy, /*OpIdx*/7, // src2
     /* 267637 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 267639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267642 */     GIR_RootConstrainSelectedInstOperands,
     /* 267643 */     // GIR_Coverage, 2842,
     /* 267643 */     GIR_EraseRootFromParent_Done,
     /* 267644 */   // Label 4325: @267644
     /* 267644 */   GIM_Reject,
     /* 267645 */ // Label 4319: @267645
     /* 267645 */ GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(273558),
     /* 267650 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/11,
     /* 267653 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(267723), // Rule ID 1171 //
     /* 267658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 267666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 267672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 267675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267678 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 267681 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 267684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 267688 */     // MIs[0] cbsz
     /* 267688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267691 */     // MIs[0] blgp
     /* 267691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267694 */     // MIs[0] Operand 7
     /* 267694 */     // No operand predicates
     /* 267694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 267698 */     // MIs[0] Operand 9
     /* 267698 */     // No operand predicates
     /* 267698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 267702 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23368),
     /* 267706 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23368>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f8_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 267706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f8_e64),
     /* 267709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267711 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267713 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267715 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267717 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267719 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 267721 */     GIR_RootConstrainSelectedInstOperands,
     /* 267722 */     // GIR_Coverage, 1171,
     /* 267722 */     GIR_EraseRootFromParent_Done,
     /* 267723 */   // Label 4327: @267723
     /* 267723 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(267793), // Rule ID 1172 //
     /* 267728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 267731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 267736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 267742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 267745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267748 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 267751 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 267754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 267758 */     // MIs[0] cbsz
     /* 267758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267761 */     // MIs[0] blgp
     /* 267761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267764 */     // MIs[0] Operand 7
     /* 267764 */     // No operand predicates
     /* 267764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 267768 */     // MIs[0] Operand 9
     /* 267768 */     // No operand predicates
     /* 267768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 267772 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23370),
     /* 267776 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23370>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 267776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64),
     /* 267779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267781 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267783 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267785 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267787 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267789 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 267791 */     GIR_RootConstrainSelectedInstOperands,
     /* 267792 */     // GIR_Coverage, 1172,
     /* 267792 */     GIR_EraseRootFromParent_Done,
     /* 267793 */   // Label 4328: @267793
     /* 267793 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(267863), // Rule ID 1173 //
     /* 267798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 267806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 267812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 267815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267818 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 267821 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 267824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 267828 */     // MIs[0] cbsz
     /* 267828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267831 */     // MIs[0] blgp
     /* 267831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267834 */     // MIs[0] Operand 7
     /* 267834 */     // No operand predicates
     /* 267834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 267838 */     // MIs[0] Operand 9
     /* 267838 */     // No operand predicates
     /* 267838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 267842 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23368),
     /* 267846 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23368>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f6_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 267846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f6_e64),
     /* 267849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267851 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267853 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267855 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267857 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267859 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 267861 */     GIR_RootConstrainSelectedInstOperands,
     /* 267862 */     // GIR_Coverage, 1173,
     /* 267862 */     GIR_EraseRootFromParent_Done,
     /* 267863 */   // Label 4329: @267863
     /* 267863 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(267933), // Rule ID 1174 //
     /* 267868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 267871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 267876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 267882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 267885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267888 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 267891 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 267894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 267898 */     // MIs[0] cbsz
     /* 267898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267901 */     // MIs[0] blgp
     /* 267901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267904 */     // MIs[0] Operand 7
     /* 267904 */     // No operand predicates
     /* 267904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 267908 */     // MIs[0] Operand 9
     /* 267908 */     // No operand predicates
     /* 267908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 267912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23370),
     /* 267916 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23370>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 267916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64),
     /* 267919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267921 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267923 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267925 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267927 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267929 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 267931 */     GIR_RootConstrainSelectedInstOperands,
     /* 267932 */     // GIR_Coverage, 1174,
     /* 267932 */     GIR_EraseRootFromParent_Done,
     /* 267933 */   // Label 4330: @267933
     /* 267933 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(268003), // Rule ID 1175 //
     /* 267938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 267946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 267952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 267955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267958 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 267961 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 267964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 267968 */     // MIs[0] cbsz
     /* 267968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267971 */     // MIs[0] blgp
     /* 267971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267974 */     // MIs[0] Operand 7
     /* 267974 */     // No operand predicates
     /* 267974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 267978 */     // MIs[0] Operand 9
     /* 267978 */     // No operand predicates
     /* 267978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 267982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23368),
     /* 267986 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23368>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f8_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 267986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f8_e64),
     /* 267989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267993 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267995 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267997 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267999 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268001 */     GIR_RootConstrainSelectedInstOperands,
     /* 268002 */     // GIR_Coverage, 1175,
     /* 268002 */     GIR_EraseRootFromParent_Done,
     /* 268003 */   // Label 4331: @268003
     /* 268003 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(268073), // Rule ID 1176 //
     /* 268008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 268022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 268025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268028 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268031 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268038 */     // MIs[0] cbsz
     /* 268038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268041 */     // MIs[0] blgp
     /* 268041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268044 */     // MIs[0] Operand 7
     /* 268044 */     // No operand predicates
     /* 268044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268048 */     // MIs[0] Operand 9
     /* 268048 */     // No operand predicates
     /* 268048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268052 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23370),
     /* 268056 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23370>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64),
     /* 268059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268061 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268063 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268065 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268067 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268069 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268071 */     GIR_RootConstrainSelectedInstOperands,
     /* 268072 */     // GIR_Coverage, 1176,
     /* 268072 */     GIR_EraseRootFromParent_Done,
     /* 268073 */   // Label 4332: @268073
     /* 268073 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(268143), // Rule ID 1177 //
     /* 268078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 268092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 268095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268098 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268101 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268108 */     // MIs[0] cbsz
     /* 268108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268111 */     // MIs[0] blgp
     /* 268111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268114 */     // MIs[0] Operand 7
     /* 268114 */     // No operand predicates
     /* 268114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268118 */     // MIs[0] Operand 9
     /* 268118 */     // No operand predicates
     /* 268118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23368),
     /* 268126 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23368>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f6_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f6_e64),
     /* 268129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268131 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268133 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268135 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268137 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268139 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268141 */     GIR_RootConstrainSelectedInstOperands,
     /* 268142 */     // GIR_Coverage, 1177,
     /* 268142 */     GIR_EraseRootFromParent_Done,
     /* 268143 */   // Label 4333: @268143
     /* 268143 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(268213), // Rule ID 1178 //
     /* 268148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 268162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 268165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268168 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268171 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268178 */     // MIs[0] cbsz
     /* 268178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268181 */     // MIs[0] blgp
     /* 268181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268184 */     // MIs[0] Operand 7
     /* 268184 */     // No operand predicates
     /* 268184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268188 */     // MIs[0] Operand 9
     /* 268188 */     // No operand predicates
     /* 268188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23370),
     /* 268196 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23370>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64),
     /* 268199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268201 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268203 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268205 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268207 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268209 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268211 */     GIR_RootConstrainSelectedInstOperands,
     /* 268212 */     // GIR_Coverage, 1178,
     /* 268212 */     GIR_EraseRootFromParent_Done,
     /* 268213 */   // Label 4334: @268213
     /* 268213 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(268283), // Rule ID 1179 //
     /* 268218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 268232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 268235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268238 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268241 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268248 */     // MIs[0] cbsz
     /* 268248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268251 */     // MIs[0] blgp
     /* 268251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268254 */     // MIs[0] Operand 7
     /* 268254 */     // No operand predicates
     /* 268254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268258 */     // MIs[0] Operand 9
     /* 268258 */     // No operand predicates
     /* 268258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23368),
     /* 268266 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23368>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f4_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f4_e64),
     /* 268269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268271 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268273 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268275 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268277 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268279 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268281 */     GIR_RootConstrainSelectedInstOperands,
     /* 268282 */     // GIR_Coverage, 1179,
     /* 268282 */     GIR_EraseRootFromParent_Done,
     /* 268283 */   // Label 4335: @268283
     /* 268283 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(268353), // Rule ID 1180 //
     /* 268288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 268302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 268305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268308 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268311 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268318 */     // MIs[0] cbsz
     /* 268318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268321 */     // MIs[0] blgp
     /* 268321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268324 */     // MIs[0] Operand 7
     /* 268324 */     // No operand predicates
     /* 268324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268328 */     // MIs[0] Operand 9
     /* 268328 */     // No operand predicates
     /* 268328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23370),
     /* 268336 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23370>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64),
     /* 268339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268341 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268343 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268345 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268347 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268349 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268351 */     GIR_RootConstrainSelectedInstOperands,
     /* 268352 */     // GIR_Coverage, 1180,
     /* 268352 */     GIR_EraseRootFromParent_Done,
     /* 268353 */   // Label 4336: @268353
     /* 268353 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(268423), // Rule ID 1181 //
     /* 268358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 268372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 268375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268378 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268381 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268388 */     // MIs[0] cbsz
     /* 268388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268391 */     // MIs[0] blgp
     /* 268391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268394 */     // MIs[0] Operand 7
     /* 268394 */     // No operand predicates
     /* 268394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268398 */     // MIs[0] Operand 9
     /* 268398 */     // No operand predicates
     /* 268398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268402 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23368),
     /* 268406 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23368>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f8_e64),
     /* 268409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268411 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268413 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268415 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268417 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268419 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268421 */     GIR_RootConstrainSelectedInstOperands,
     /* 268422 */     // GIR_Coverage, 1181,
     /* 268422 */     GIR_EraseRootFromParent_Done,
     /* 268423 */   // Label 4337: @268423
     /* 268423 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(268493), // Rule ID 1182 //
     /* 268428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 268442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 268445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268448 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268451 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268458 */     // MIs[0] cbsz
     /* 268458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268461 */     // MIs[0] blgp
     /* 268461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268464 */     // MIs[0] Operand 7
     /* 268464 */     // No operand predicates
     /* 268464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268468 */     // MIs[0] Operand 9
     /* 268468 */     // No operand predicates
     /* 268468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23370),
     /* 268476 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23370>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64),
     /* 268479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268481 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268483 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268485 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268487 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268489 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268491 */     GIR_RootConstrainSelectedInstOperands,
     /* 268492 */     // GIR_Coverage, 1182,
     /* 268492 */     GIR_EraseRootFromParent_Done,
     /* 268493 */   // Label 4338: @268493
     /* 268493 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(268563), // Rule ID 1183 //
     /* 268498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 268512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 268515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268518 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268521 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268528 */     // MIs[0] cbsz
     /* 268528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268531 */     // MIs[0] blgp
     /* 268531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268534 */     // MIs[0] Operand 7
     /* 268534 */     // No operand predicates
     /* 268534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268538 */     // MIs[0] Operand 9
     /* 268538 */     // No operand predicates
     /* 268538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23368),
     /* 268546 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23368>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f4_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f4_e64),
     /* 268549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268551 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268553 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268555 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268557 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268559 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268561 */     GIR_RootConstrainSelectedInstOperands,
     /* 268562 */     // GIR_Coverage, 1183,
     /* 268562 */     GIR_EraseRootFromParent_Done,
     /* 268563 */   // Label 4339: @268563
     /* 268563 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(268633), // Rule ID 1184 //
     /* 268568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 268582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 268585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268588 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268591 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268598 */     // MIs[0] cbsz
     /* 268598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268601 */     // MIs[0] blgp
     /* 268601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268604 */     // MIs[0] Operand 7
     /* 268604 */     // No operand predicates
     /* 268604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268608 */     // MIs[0] Operand 9
     /* 268608 */     // No operand predicates
     /* 268608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23370),
     /* 268616 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23370>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64),
     /* 268619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268621 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268623 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268625 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268627 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268629 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268631 */     GIR_RootConstrainSelectedInstOperands,
     /* 268632 */     // GIR_Coverage, 1184,
     /* 268632 */     GIR_EraseRootFromParent_Done,
     /* 268633 */   // Label 4340: @268633
     /* 268633 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(268703), // Rule ID 1185 //
     /* 268638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 268652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 268655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268658 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268661 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268668 */     // MIs[0] cbsz
     /* 268668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268671 */     // MIs[0] blgp
     /* 268671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268674 */     // MIs[0] Operand 7
     /* 268674 */     // No operand predicates
     /* 268674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268678 */     // MIs[0] Operand 9
     /* 268678 */     // No operand predicates
     /* 268678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268682 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23368),
     /* 268686 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23368>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f6_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f6_e64),
     /* 268689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268691 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268693 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268695 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268697 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268699 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268701 */     GIR_RootConstrainSelectedInstOperands,
     /* 268702 */     // GIR_Coverage, 1185,
     /* 268702 */     GIR_EraseRootFromParent_Done,
     /* 268703 */   // Label 4341: @268703
     /* 268703 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(268773), // Rule ID 1186 //
     /* 268708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 268722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 268725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268728 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268731 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268738 */     // MIs[0] cbsz
     /* 268738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268741 */     // MIs[0] blgp
     /* 268741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268744 */     // MIs[0] Operand 7
     /* 268744 */     // No operand predicates
     /* 268744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268748 */     // MIs[0] Operand 9
     /* 268748 */     // No operand predicates
     /* 268748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268752 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23370),
     /* 268756 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23370>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64),
     /* 268759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268761 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268763 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268765 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268767 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268769 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268771 */     GIR_RootConstrainSelectedInstOperands,
     /* 268772 */     // GIR_Coverage, 1186,
     /* 268772 */     GIR_EraseRootFromParent_Done,
     /* 268773 */   // Label 4342: @268773
     /* 268773 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(268843), // Rule ID 1187 //
     /* 268778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 268792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 268795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268798 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268801 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268808 */     // MIs[0] cbsz
     /* 268808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268811 */     // MIs[0] blgp
     /* 268811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268814 */     // MIs[0] Operand 7
     /* 268814 */     // No operand predicates
     /* 268814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268818 */     // MIs[0] Operand 9
     /* 268818 */     // No operand predicates
     /* 268818 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268822 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23368),
     /* 268826 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23368>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f4_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f4_e64),
     /* 268829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268831 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268833 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268835 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268837 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268839 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268841 */     GIR_RootConstrainSelectedInstOperands,
     /* 268842 */     // GIR_Coverage, 1187,
     /* 268842 */     GIR_EraseRootFromParent_Done,
     /* 268843 */   // Label 4343: @268843
     /* 268843 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(268913), // Rule ID 1188 //
     /* 268848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 268856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 268862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 268865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268868 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268871 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268878 */     // MIs[0] cbsz
     /* 268878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268881 */     // MIs[0] blgp
     /* 268881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268884 */     // MIs[0] Operand 7
     /* 268884 */     // No operand predicates
     /* 268884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268888 */     // MIs[0] Operand 9
     /* 268888 */     // No operand predicates
     /* 268888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268892 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23370),
     /* 268896 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23370>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64),
     /* 268899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268901 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268903 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268905 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268907 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268909 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268911 */     GIR_RootConstrainSelectedInstOperands,
     /* 268912 */     // GIR_Coverage, 1188,
     /* 268912 */     GIR_EraseRootFromParent_Done,
     /* 268913 */   // Label 4344: @268913
     /* 268913 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(268983), // Rule ID 1189 //
     /* 268918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 268921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 268926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 268929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 268932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 268935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 268938 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 268941 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 268944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 268948 */     // MIs[0] cbsz
     /* 268948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268951 */     // MIs[0] blgp
     /* 268951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268954 */     // MIs[0] Operand 7
     /* 268954 */     // No operand predicates
     /* 268954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 268958 */     // MIs[0] Operand 9
     /* 268958 */     // No operand predicates
     /* 268958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 268962 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23390),
     /* 268966 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23390>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 268966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_e64),
     /* 268969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268971 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268973 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268975 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268977 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268979 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 268981 */     GIR_RootConstrainSelectedInstOperands,
     /* 268982 */     // GIR_Coverage, 1189,
     /* 268982 */     GIR_EraseRootFromParent_Done,
     /* 268983 */   // Label 4345: @268983
     /* 268983 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(269053), // Rule ID 1190 //
     /* 268988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 268991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 268996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 268999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 269002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 269005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269008 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269011 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269018 */     // MIs[0] cbsz
     /* 269018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269021 */     // MIs[0] blgp
     /* 269021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269024 */     // MIs[0] Operand 7
     /* 269024 */     // No operand predicates
     /* 269024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269028 */     // MIs[0] Operand 9
     /* 269028 */     // No operand predicates
     /* 269028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23392),
     /* 269036 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23392>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64),
     /* 269039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269041 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269043 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269045 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269047 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269049 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269051 */     GIR_RootConstrainSelectedInstOperands,
     /* 269052 */     // GIR_Coverage, 1190,
     /* 269052 */     GIR_EraseRootFromParent_Done,
     /* 269053 */   // Label 4346: @269053
     /* 269053 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(269123), // Rule ID 1191 //
     /* 269058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 269072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 269075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269078 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269081 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269088 */     // MIs[0] cbsz
     /* 269088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269091 */     // MIs[0] blgp
     /* 269091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269094 */     // MIs[0] Operand 7
     /* 269094 */     // No operand predicates
     /* 269094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269098 */     // MIs[0] Operand 9
     /* 269098 */     // No operand predicates
     /* 269098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269102 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23390),
     /* 269106 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23390>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_e64),
     /* 269109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269111 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269113 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269115 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269117 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269119 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269121 */     GIR_RootConstrainSelectedInstOperands,
     /* 269122 */     // GIR_Coverage, 1191,
     /* 269122 */     GIR_EraseRootFromParent_Done,
     /* 269123 */   // Label 4347: @269123
     /* 269123 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(269193), // Rule ID 1192 //
     /* 269128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 269142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 269145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269148 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269151 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269158 */     // MIs[0] cbsz
     /* 269158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269161 */     // MIs[0] blgp
     /* 269161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269164 */     // MIs[0] Operand 7
     /* 269164 */     // No operand predicates
     /* 269164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269168 */     // MIs[0] Operand 9
     /* 269168 */     // No operand predicates
     /* 269168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269172 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23392),
     /* 269176 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23392>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64),
     /* 269179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269183 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269185 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269187 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269189 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269191 */     GIR_RootConstrainSelectedInstOperands,
     /* 269192 */     // GIR_Coverage, 1192,
     /* 269192 */     GIR_EraseRootFromParent_Done,
     /* 269193 */   // Label 4348: @269193
     /* 269193 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(269263), // Rule ID 1193 //
     /* 269198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 269212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 269215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269218 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269221 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269228 */     // MIs[0] cbsz
     /* 269228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269231 */     // MIs[0] blgp
     /* 269231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269234 */     // MIs[0] Operand 7
     /* 269234 */     // No operand predicates
     /* 269234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269238 */     // MIs[0] Operand 9
     /* 269238 */     // No operand predicates
     /* 269238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269242 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23390),
     /* 269246 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23390>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_e64),
     /* 269249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269251 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269253 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269255 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269257 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269259 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269261 */     GIR_RootConstrainSelectedInstOperands,
     /* 269262 */     // GIR_Coverage, 1193,
     /* 269262 */     GIR_EraseRootFromParent_Done,
     /* 269263 */   // Label 4349: @269263
     /* 269263 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(269333), // Rule ID 1194 //
     /* 269268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 269282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 269285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269288 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269291 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269298 */     // MIs[0] cbsz
     /* 269298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269301 */     // MIs[0] blgp
     /* 269301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269304 */     // MIs[0] Operand 7
     /* 269304 */     // No operand predicates
     /* 269304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269308 */     // MIs[0] Operand 9
     /* 269308 */     // No operand predicates
     /* 269308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269312 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23392),
     /* 269316 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23392>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64),
     /* 269319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269321 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269323 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269325 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269327 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269329 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269331 */     GIR_RootConstrainSelectedInstOperands,
     /* 269332 */     // GIR_Coverage, 1194,
     /* 269332 */     GIR_EraseRootFromParent_Done,
     /* 269333 */   // Label 4350: @269333
     /* 269333 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(269403), // Rule ID 1195 //
     /* 269338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 269352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 269355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269358 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269361 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269368 */     // MIs[0] cbsz
     /* 269368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269371 */     // MIs[0] blgp
     /* 269371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269374 */     // MIs[0] Operand 7
     /* 269374 */     // No operand predicates
     /* 269374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269378 */     // MIs[0] Operand 9
     /* 269378 */     // No operand predicates
     /* 269378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269382 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23390),
     /* 269386 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23390>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_e64),
     /* 269389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269391 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269393 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269395 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269397 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269399 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269401 */     GIR_RootConstrainSelectedInstOperands,
     /* 269402 */     // GIR_Coverage, 1195,
     /* 269402 */     GIR_EraseRootFromParent_Done,
     /* 269403 */   // Label 4351: @269403
     /* 269403 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(269473), // Rule ID 1196 //
     /* 269408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 269422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 269425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269428 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269431 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269438 */     // MIs[0] cbsz
     /* 269438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269441 */     // MIs[0] blgp
     /* 269441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269444 */     // MIs[0] Operand 7
     /* 269444 */     // No operand predicates
     /* 269444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269448 */     // MIs[0] Operand 9
     /* 269448 */     // No operand predicates
     /* 269448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23392),
     /* 269456 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23392>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64),
     /* 269459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269461 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269463 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269465 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269467 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269469 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269471 */     GIR_RootConstrainSelectedInstOperands,
     /* 269472 */     // GIR_Coverage, 1196,
     /* 269472 */     GIR_EraseRootFromParent_Done,
     /* 269473 */   // Label 4352: @269473
     /* 269473 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(269543), // Rule ID 1197 //
     /* 269478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 269492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 269495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269498 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269501 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269508 */     // MIs[0] cbsz
     /* 269508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269511 */     // MIs[0] blgp
     /* 269511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269514 */     // MIs[0] Operand 7
     /* 269514 */     // No operand predicates
     /* 269514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269518 */     // MIs[0] Operand 9
     /* 269518 */     // No operand predicates
     /* 269518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23390),
     /* 269526 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23390>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_e64),
     /* 269529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269531 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269533 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269535 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269537 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269539 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269541 */     GIR_RootConstrainSelectedInstOperands,
     /* 269542 */     // GIR_Coverage, 1197,
     /* 269542 */     GIR_EraseRootFromParent_Done,
     /* 269543 */   // Label 4353: @269543
     /* 269543 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(269613), // Rule ID 1198 //
     /* 269548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 269562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 269565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269568 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269571 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269578 */     // MIs[0] cbsz
     /* 269578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269581 */     // MIs[0] blgp
     /* 269581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269584 */     // MIs[0] Operand 7
     /* 269584 */     // No operand predicates
     /* 269584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269588 */     // MIs[0] Operand 9
     /* 269588 */     // No operand predicates
     /* 269588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269592 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23392),
     /* 269596 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23392>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64),
     /* 269599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269601 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269603 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269605 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269607 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269609 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269611 */     GIR_RootConstrainSelectedInstOperands,
     /* 269612 */     // GIR_Coverage, 1198,
     /* 269612 */     GIR_EraseRootFromParent_Done,
     /* 269613 */   // Label 4354: @269613
     /* 269613 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(269683), // Rule ID 1199 //
     /* 269618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 269635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269638 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269641 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269648 */     // MIs[0] cbsz
     /* 269648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269651 */     // MIs[0] blgp
     /* 269651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269654 */     // MIs[0] Operand 7
     /* 269654 */     // No operand predicates
     /* 269654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269658 */     // MIs[0] Operand 9
     /* 269658 */     // No operand predicates
     /* 269658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269662 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23390),
     /* 269666 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23390>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_e64),
     /* 269669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269671 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269673 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269675 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269677 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269679 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269681 */     GIR_RootConstrainSelectedInstOperands,
     /* 269682 */     // GIR_Coverage, 1199,
     /* 269682 */     GIR_EraseRootFromParent_Done,
     /* 269683 */   // Label 4355: @269683
     /* 269683 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(269753), // Rule ID 1200 //
     /* 269688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 269705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269708 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269711 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269718 */     // MIs[0] cbsz
     /* 269718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269721 */     // MIs[0] blgp
     /* 269721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269724 */     // MIs[0] Operand 7
     /* 269724 */     // No operand predicates
     /* 269724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269728 */     // MIs[0] Operand 9
     /* 269728 */     // No operand predicates
     /* 269728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23392),
     /* 269736 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23392>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64),
     /* 269739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269743 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269745 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269747 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269749 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269751 */     GIR_RootConstrainSelectedInstOperands,
     /* 269752 */     // GIR_Coverage, 1200,
     /* 269752 */     GIR_EraseRootFromParent_Done,
     /* 269753 */   // Label 4356: @269753
     /* 269753 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(269823), // Rule ID 1201 //
     /* 269758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 269772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 269775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269778 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269781 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269788 */     // MIs[0] cbsz
     /* 269788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269791 */     // MIs[0] blgp
     /* 269791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269794 */     // MIs[0] Operand 7
     /* 269794 */     // No operand predicates
     /* 269794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269798 */     // MIs[0] Operand 9
     /* 269798 */     // No operand predicates
     /* 269798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269802 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23390),
     /* 269806 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23390>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_e64),
     /* 269809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269811 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269813 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269815 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269817 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269819 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269821 */     GIR_RootConstrainSelectedInstOperands,
     /* 269822 */     // GIR_Coverage, 1201,
     /* 269822 */     GIR_EraseRootFromParent_Done,
     /* 269823 */   // Label 4357: @269823
     /* 269823 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(269893), // Rule ID 1202 //
     /* 269828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 269842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 269845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269848 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269851 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269858 */     // MIs[0] cbsz
     /* 269858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269861 */     // MIs[0] blgp
     /* 269861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269864 */     // MIs[0] Operand 7
     /* 269864 */     // No operand predicates
     /* 269864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269868 */     // MIs[0] Operand 9
     /* 269868 */     // No operand predicates
     /* 269868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269872 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23392),
     /* 269876 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23392>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64),
     /* 269879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269881 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269883 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269885 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269887 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269889 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269891 */     GIR_RootConstrainSelectedInstOperands,
     /* 269892 */     // GIR_Coverage, 1202,
     /* 269892 */     GIR_EraseRootFromParent_Done,
     /* 269893 */   // Label 4358: @269893
     /* 269893 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(269963), // Rule ID 1203 //
     /* 269898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 269901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 269915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269918 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269921 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269928 */     // MIs[0] cbsz
     /* 269928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269931 */     // MIs[0] blgp
     /* 269931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269934 */     // MIs[0] Operand 7
     /* 269934 */     // No operand predicates
     /* 269934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 269938 */     // MIs[0] Operand 9
     /* 269938 */     // No operand predicates
     /* 269938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 269942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23390),
     /* 269946 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23390>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 269946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_e64),
     /* 269949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269951 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269953 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269955 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269957 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269959 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 269961 */     GIR_RootConstrainSelectedInstOperands,
     /* 269962 */     // GIR_Coverage, 1203,
     /* 269962 */     GIR_EraseRootFromParent_Done,
     /* 269963 */   // Label 4359: @269963
     /* 269963 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(270033), // Rule ID 1204 //
     /* 269968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 269971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 269976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 269985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269988 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 269991 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 269994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269998 */     // MIs[0] cbsz
     /* 269998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270001 */     // MIs[0] blgp
     /* 270001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270004 */     // MIs[0] Operand 7
     /* 270004 */     // No operand predicates
     /* 270004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 270008 */     // MIs[0] Operand 9
     /* 270008 */     // No operand predicates
     /* 270008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 270012 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23392),
     /* 270016 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23392>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 270016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64),
     /* 270019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270023 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270025 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270027 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270029 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270031 */     GIR_RootConstrainSelectedInstOperands,
     /* 270032 */     // GIR_Coverage, 1204,
     /* 270032 */     GIR_EraseRootFromParent_Done,
     /* 270033 */   // Label 4360: @270033
     /* 270033 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(270103), // Rule ID 1205 //
     /* 270038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 270046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270058 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270061 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 270068 */     // MIs[0] cbsz
     /* 270068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270071 */     // MIs[0] blgp
     /* 270071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270074 */     // MIs[0] Operand 7
     /* 270074 */     // No operand predicates
     /* 270074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 270078 */     // MIs[0] Operand 9
     /* 270078 */     // No operand predicates
     /* 270078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 270082 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23390),
     /* 270086 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23390>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 270086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_e64),
     /* 270089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270091 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270093 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270095 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270097 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270099 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270101 */     GIR_RootConstrainSelectedInstOperands,
     /* 270102 */     // GIR_Coverage, 1205,
     /* 270102 */     GIR_EraseRootFromParent_Done,
     /* 270103 */   // Label 4361: @270103
     /* 270103 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(270173), // Rule ID 1206 //
     /* 270108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 270111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 270116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270128 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270131 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 270138 */     // MIs[0] cbsz
     /* 270138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270141 */     // MIs[0] blgp
     /* 270141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270144 */     // MIs[0] Operand 7
     /* 270144 */     // No operand predicates
     /* 270144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 270148 */     // MIs[0] Operand 9
     /* 270148 */     // No operand predicates
     /* 270148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 270152 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23392),
     /* 270156 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23392>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 270156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64),
     /* 270159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270161 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270163 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270165 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270167 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270169 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270171 */     GIR_RootConstrainSelectedInstOperands,
     /* 270172 */     // GIR_Coverage, 1206,
     /* 270172 */     GIR_EraseRootFromParent_Done,
     /* 270173 */   // Label 4362: @270173
     /* 270173 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(270267), // Rule ID 1207 //
     /* 270178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 270192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 270195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270198 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270201 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 270208 */     // MIs[0] cbsz
     /* 270208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270211 */     // MIs[0] blgp
     /* 270211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270214 */     // MIs[0] scale_src0_opsel
     /* 270214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270222 */     // MIs[0] scale_src1_opsel
     /* 270222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23426),
     /* 270234 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23426>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_e64),
     /* 270237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270239 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270241 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270243 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270245 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270247 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270249 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 270251 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 270253 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 270259 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 270265 */     GIR_RootConstrainSelectedInstOperands,
     /* 270266 */     // GIR_Coverage, 1207,
     /* 270266 */     GIR_EraseRootFromParent_Done,
     /* 270267 */   // Label 4363: @270267
     /* 270267 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(270361), // Rule ID 1208 //
     /* 270272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 270286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 270289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270292 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270295 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 270302 */     // MIs[0] cbsz
     /* 270302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270305 */     // MIs[0] blgp
     /* 270305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270308 */     // MIs[0] scale_src0_opsel
     /* 270308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270316 */     // MIs[0] scale_src1_opsel
     /* 270316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270319 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23428),
     /* 270328 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23428>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64),
     /* 270331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270333 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270335 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270337 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270339 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270341 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270343 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 270345 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 270347 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 270353 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 270359 */     GIR_RootConstrainSelectedInstOperands,
     /* 270360 */     // GIR_Coverage, 1208,
     /* 270360 */     GIR_EraseRootFromParent_Done,
     /* 270361 */   // Label 4364: @270361
     /* 270361 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(270455), // Rule ID 1209 //
     /* 270366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 270380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 270383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270386 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270389 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 270396 */     // MIs[0] cbsz
     /* 270396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270399 */     // MIs[0] blgp
     /* 270399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270402 */     // MIs[0] scale_src0_opsel
     /* 270402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270405 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270410 */     // MIs[0] scale_src1_opsel
     /* 270410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270413 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270418 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23426),
     /* 270422 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23426>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_e64),
     /* 270425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270427 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270429 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270431 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270433 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270435 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270437 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 270439 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 270441 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 270447 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 270453 */     GIR_RootConstrainSelectedInstOperands,
     /* 270454 */     // GIR_Coverage, 1209,
     /* 270454 */     GIR_EraseRootFromParent_Done,
     /* 270455 */   // Label 4365: @270455
     /* 270455 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(270549), // Rule ID 1210 //
     /* 270460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 270474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 270477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270480 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270483 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 270490 */     // MIs[0] cbsz
     /* 270490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270493 */     // MIs[0] blgp
     /* 270493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270496 */     // MIs[0] scale_src0_opsel
     /* 270496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270504 */     // MIs[0] scale_src1_opsel
     /* 270504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270507 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23428),
     /* 270516 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23428>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64),
     /* 270519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270523 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270525 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270527 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270529 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270531 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 270533 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 270535 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 270541 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 270547 */     GIR_RootConstrainSelectedInstOperands,
     /* 270548 */     // GIR_Coverage, 1210,
     /* 270548 */     GIR_EraseRootFromParent_Done,
     /* 270549 */   // Label 4366: @270549
     /* 270549 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(270643), // Rule ID 1211 //
     /* 270554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 270568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 270571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270574 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270577 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 270584 */     // MIs[0] cbsz
     /* 270584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270587 */     // MIs[0] blgp
     /* 270587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270590 */     // MIs[0] scale_src0_opsel
     /* 270590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270598 */     // MIs[0] scale_src1_opsel
     /* 270598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270601 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270606 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23426),
     /* 270610 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23426>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_e64),
     /* 270613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270615 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270617 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270619 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270621 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270623 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270625 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 270627 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 270629 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 270635 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 270641 */     GIR_RootConstrainSelectedInstOperands,
     /* 270642 */     // GIR_Coverage, 1211,
     /* 270642 */     GIR_EraseRootFromParent_Done,
     /* 270643 */   // Label 4367: @270643
     /* 270643 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(270737), // Rule ID 1212 //
     /* 270648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 270662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 270665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270668 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270671 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 270678 */     // MIs[0] cbsz
     /* 270678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270681 */     // MIs[0] blgp
     /* 270681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270684 */     // MIs[0] scale_src0_opsel
     /* 270684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270692 */     // MIs[0] scale_src1_opsel
     /* 270692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270700 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23428),
     /* 270704 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23428>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64),
     /* 270707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270709 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270711 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270713 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270715 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270717 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270719 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 270721 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 270723 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 270729 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 270735 */     GIR_RootConstrainSelectedInstOperands,
     /* 270736 */     // GIR_Coverage, 1212,
     /* 270736 */     GIR_EraseRootFromParent_Done,
     /* 270737 */   // Label 4368: @270737
     /* 270737 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(270831), // Rule ID 1213 //
     /* 270742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 270756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 270759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270762 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270765 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 270772 */     // MIs[0] cbsz
     /* 270772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270775 */     // MIs[0] blgp
     /* 270775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270778 */     // MIs[0] scale_src0_opsel
     /* 270778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270786 */     // MIs[0] scale_src1_opsel
     /* 270786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23426),
     /* 270798 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23426>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_e64),
     /* 270801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270803 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270805 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270807 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270809 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270811 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270813 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 270815 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 270817 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 270823 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 270829 */     GIR_RootConstrainSelectedInstOperands,
     /* 270830 */     // GIR_Coverage, 1213,
     /* 270830 */     GIR_EraseRootFromParent_Done,
     /* 270831 */   // Label 4369: @270831
     /* 270831 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(270925), // Rule ID 1214 //
     /* 270836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 270850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 270853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270856 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270859 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 270866 */     // MIs[0] cbsz
     /* 270866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270869 */     // MIs[0] blgp
     /* 270869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270872 */     // MIs[0] scale_src0_opsel
     /* 270872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270880 */     // MIs[0] scale_src1_opsel
     /* 270880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270883 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23428),
     /* 270892 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23428>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64),
     /* 270895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270897 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270899 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270901 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270903 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270905 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 270907 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 270909 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 270911 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 270917 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 270923 */     GIR_RootConstrainSelectedInstOperands,
     /* 270924 */     // GIR_Coverage, 1214,
     /* 270924 */     GIR_EraseRootFromParent_Done,
     /* 270925 */   // Label 4370: @270925
     /* 270925 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(271019), // Rule ID 1215 //
     /* 270930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 270938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 270944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270950 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 270953 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 270956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 270960 */     // MIs[0] cbsz
     /* 270960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 270963 */     // MIs[0] blgp
     /* 270963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270966 */     // MIs[0] scale_src0_opsel
     /* 270966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270974 */     // MIs[0] scale_src1_opsel
     /* 270974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 270977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 270982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23426),
     /* 270986 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23426>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 270986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_e64),
     /* 270989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270993 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270995 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270997 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 270999 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271001 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271003 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271005 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271011 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271017 */     GIR_RootConstrainSelectedInstOperands,
     /* 271018 */     // GIR_Coverage, 1215,
     /* 271018 */     GIR_EraseRootFromParent_Done,
     /* 271019 */   // Label 4371: @271019
     /* 271019 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(271113), // Rule ID 1216 //
     /* 271024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 271038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 271041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271044 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271047 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 271054 */     // MIs[0] cbsz
     /* 271054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271057 */     // MIs[0] blgp
     /* 271057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271060 */     // MIs[0] scale_src0_opsel
     /* 271060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271068 */     // MIs[0] scale_src1_opsel
     /* 271068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271076 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23428),
     /* 271080 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23428>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64),
     /* 271083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271085 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271087 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271089 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271091 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271093 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271095 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271097 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271099 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271111 */     GIR_RootConstrainSelectedInstOperands,
     /* 271112 */     // GIR_Coverage, 1216,
     /* 271112 */     GIR_EraseRootFromParent_Done,
     /* 271113 */   // Label 4372: @271113
     /* 271113 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(271207), // Rule ID 1217 //
     /* 271118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271138 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271141 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 271148 */     // MIs[0] cbsz
     /* 271148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271151 */     // MIs[0] blgp
     /* 271151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271154 */     // MIs[0] scale_src0_opsel
     /* 271154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271157 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271162 */     // MIs[0] scale_src1_opsel
     /* 271162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271165 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271170 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23426),
     /* 271174 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23426>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_e64),
     /* 271177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271179 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271181 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271183 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271185 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271187 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271189 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271191 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271193 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271199 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271205 */     GIR_RootConstrainSelectedInstOperands,
     /* 271206 */     // GIR_Coverage, 1217,
     /* 271206 */     GIR_EraseRootFromParent_Done,
     /* 271207 */   // Label 4373: @271207
     /* 271207 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(271301), // Rule ID 1218 //
     /* 271212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271232 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271235 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 271242 */     // MIs[0] cbsz
     /* 271242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271245 */     // MIs[0] blgp
     /* 271245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271248 */     // MIs[0] scale_src0_opsel
     /* 271248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271256 */     // MIs[0] scale_src1_opsel
     /* 271256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271264 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23428),
     /* 271268 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23428>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64),
     /* 271271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271273 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271275 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271277 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271279 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271281 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271283 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271285 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271293 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271299 */     GIR_RootConstrainSelectedInstOperands,
     /* 271300 */     // GIR_Coverage, 1218,
     /* 271300 */     GIR_EraseRootFromParent_Done,
     /* 271301 */   // Label 4374: @271301
     /* 271301 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(271395), // Rule ID 1219 //
     /* 271306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 271320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 271323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271326 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271329 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 271336 */     // MIs[0] cbsz
     /* 271336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271339 */     // MIs[0] blgp
     /* 271339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271342 */     // MIs[0] scale_src0_opsel
     /* 271342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271350 */     // MIs[0] scale_src1_opsel
     /* 271350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271353 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271358 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23426),
     /* 271362 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23426>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_e64),
     /* 271365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271369 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271371 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271373 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271375 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271377 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271379 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271381 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271387 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271393 */     GIR_RootConstrainSelectedInstOperands,
     /* 271394 */     // GIR_Coverage, 1219,
     /* 271394 */     GIR_EraseRootFromParent_Done,
     /* 271395 */   // Label 4375: @271395
     /* 271395 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(271489), // Rule ID 1220 //
     /* 271400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 271414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 271417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271420 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271423 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 271430 */     // MIs[0] cbsz
     /* 271430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271433 */     // MIs[0] blgp
     /* 271433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271436 */     // MIs[0] scale_src0_opsel
     /* 271436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271444 */     // MIs[0] scale_src1_opsel
     /* 271444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271447 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23428),
     /* 271456 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23428>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64),
     /* 271459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271461 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271463 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271465 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271467 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271469 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271471 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271473 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271475 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271481 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271487 */     GIR_RootConstrainSelectedInstOperands,
     /* 271488 */     // GIR_Coverage, 1220,
     /* 271488 */     GIR_EraseRootFromParent_Done,
     /* 271489 */   // Label 4376: @271489
     /* 271489 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(271583), // Rule ID 1221 //
     /* 271494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 271511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271514 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271517 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 271524 */     // MIs[0] cbsz
     /* 271524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271527 */     // MIs[0] blgp
     /* 271527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271530 */     // MIs[0] scale_src0_opsel
     /* 271530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271533 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271538 */     // MIs[0] scale_src1_opsel
     /* 271538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271541 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23426),
     /* 271550 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23426>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_e64),
     /* 271553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271555 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271557 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271559 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271561 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271563 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271565 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271567 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271569 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271575 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271581 */     GIR_RootConstrainSelectedInstOperands,
     /* 271582 */     // GIR_Coverage, 1221,
     /* 271582 */     GIR_EraseRootFromParent_Done,
     /* 271583 */   // Label 4377: @271583
     /* 271583 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(271677), // Rule ID 1222 //
     /* 271588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 271605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271608 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271611 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 271618 */     // MIs[0] cbsz
     /* 271618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271621 */     // MIs[0] blgp
     /* 271621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271624 */     // MIs[0] scale_src0_opsel
     /* 271624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271632 */     // MIs[0] scale_src1_opsel
     /* 271632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271635 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23428),
     /* 271644 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23428>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64),
     /* 271647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271651 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271653 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271655 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271657 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271659 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271661 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271663 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271669 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271675 */     GIR_RootConstrainSelectedInstOperands,
     /* 271676 */     // GIR_Coverage, 1222,
     /* 271676 */     GIR_EraseRootFromParent_Done,
     /* 271677 */   // Label 4378: @271677
     /* 271677 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(271771), // Rule ID 1223 //
     /* 271682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 271699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271702 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271705 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 271712 */     // MIs[0] cbsz
     /* 271712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271715 */     // MIs[0] blgp
     /* 271715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271718 */     // MIs[0] scale_src0_opsel
     /* 271718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271726 */     // MIs[0] scale_src1_opsel
     /* 271726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271734 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23426),
     /* 271738 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23426>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_e64),
     /* 271741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271743 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271745 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271747 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271749 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271751 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271753 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271755 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271757 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271763 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271769 */     GIR_RootConstrainSelectedInstOperands,
     /* 271770 */     // GIR_Coverage, 1223,
     /* 271770 */     GIR_EraseRootFromParent_Done,
     /* 271771 */   // Label 4379: @271771
     /* 271771 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(271865), // Rule ID 1224 //
     /* 271776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 271784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 271793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271796 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271799 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 271806 */     // MIs[0] cbsz
     /* 271806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271809 */     // MIs[0] blgp
     /* 271809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271812 */     // MIs[0] scale_src0_opsel
     /* 271812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271815 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271820 */     // MIs[0] scale_src1_opsel
     /* 271820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271823 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271828 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23428),
     /* 271832 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3065:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23428>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64),
     /* 271835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271837 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271839 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271841 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271843 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271845 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271847 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271849 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271851 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271863 */     GIR_RootConstrainSelectedInstOperands,
     /* 271864 */     // GIR_Coverage, 1224,
     /* 271864 */     GIR_EraseRootFromParent_Done,
     /* 271865 */   // Label 4380: @271865
     /* 271865 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(271959), // Rule ID 1225 //
     /* 271870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 271878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 271881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 271884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 271890 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271893 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 271900 */     // MIs[0] cbsz
     /* 271900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271903 */     // MIs[0] blgp
     /* 271903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271906 */     // MIs[0] scale_src0_opsel
     /* 271906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271914 */     // MIs[0] scale_src1_opsel
     /* 271914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 271917 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 271922 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23448),
     /* 271926 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23448>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 271926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_e64),
     /* 271929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271931 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271933 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271935 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271937 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 271939 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 271941 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 271943 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 271945 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 271951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 271957 */     GIR_RootConstrainSelectedInstOperands,
     /* 271958 */     // GIR_Coverage, 1225,
     /* 271958 */     GIR_EraseRootFromParent_Done,
     /* 271959 */   // Label 4381: @271959
     /* 271959 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(272053), // Rule ID 1226 //
     /* 271964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 271972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 271975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 271978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 271984 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 271987 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 271990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 271994 */     // MIs[0] cbsz
     /* 271994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 271997 */     // MIs[0] blgp
     /* 271997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272000 */     // MIs[0] scale_src0_opsel
     /* 272000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272003 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272008 */     // MIs[0] scale_src1_opsel
     /* 272008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272011 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272016 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23450),
     /* 272020 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23450>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64),
     /* 272023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272025 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272027 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272029 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272031 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272033 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272035 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272037 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272039 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272051 */     GIR_RootConstrainSelectedInstOperands,
     /* 272052 */     // GIR_Coverage, 1226,
     /* 272052 */     GIR_EraseRootFromParent_Done,
     /* 272053 */   // Label 4382: @272053
     /* 272053 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(272147), // Rule ID 1227 //
     /* 272058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 272075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272078 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272081 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 272088 */     // MIs[0] cbsz
     /* 272088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272091 */     // MIs[0] blgp
     /* 272091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272094 */     // MIs[0] scale_src0_opsel
     /* 272094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272102 */     // MIs[0] scale_src1_opsel
     /* 272102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23448),
     /* 272114 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23448>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_e64),
     /* 272117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272119 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272121 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272123 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272125 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272127 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272129 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272131 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272133 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272139 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272145 */     GIR_RootConstrainSelectedInstOperands,
     /* 272146 */     // GIR_Coverage, 1227,
     /* 272146 */     GIR_EraseRootFromParent_Done,
     /* 272147 */   // Label 4383: @272147
     /* 272147 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(272241), // Rule ID 1228 //
     /* 272152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 272169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272172 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272175 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 272182 */     // MIs[0] cbsz
     /* 272182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272185 */     // MIs[0] blgp
     /* 272185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272188 */     // MIs[0] scale_src0_opsel
     /* 272188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272191 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272196 */     // MIs[0] scale_src1_opsel
     /* 272196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272199 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23450),
     /* 272208 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23450>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64),
     /* 272211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272213 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272215 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272217 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272219 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272221 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272223 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272225 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272227 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272233 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272239 */     GIR_RootConstrainSelectedInstOperands,
     /* 272240 */     // GIR_Coverage, 1228,
     /* 272240 */     GIR_EraseRootFromParent_Done,
     /* 272241 */   // Label 4384: @272241
     /* 272241 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(272335), // Rule ID 1229 //
     /* 272246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272266 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272269 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 272276 */     // MIs[0] cbsz
     /* 272276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272279 */     // MIs[0] blgp
     /* 272279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272282 */     // MIs[0] scale_src0_opsel
     /* 272282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272290 */     // MIs[0] scale_src1_opsel
     /* 272290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23448),
     /* 272302 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23448>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_e64),
     /* 272305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272307 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272309 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272311 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272313 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272315 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272317 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272319 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272321 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272327 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272333 */     GIR_RootConstrainSelectedInstOperands,
     /* 272334 */     // GIR_Coverage, 1229,
     /* 272334 */     GIR_EraseRootFromParent_Done,
     /* 272335 */   // Label 4385: @272335
     /* 272335 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(272429), // Rule ID 1230 //
     /* 272340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272360 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272363 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 272370 */     // MIs[0] cbsz
     /* 272370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272373 */     // MIs[0] blgp
     /* 272373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272376 */     // MIs[0] scale_src0_opsel
     /* 272376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272379 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272384 */     // MIs[0] scale_src1_opsel
     /* 272384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272387 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23450),
     /* 272396 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23450>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64),
     /* 272399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272401 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272403 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272405 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272407 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272409 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272411 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272413 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272415 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272421 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272427 */     GIR_RootConstrainSelectedInstOperands,
     /* 272428 */     // GIR_Coverage, 1230,
     /* 272428 */     GIR_EraseRootFromParent_Done,
     /* 272429 */   // Label 4386: @272429
     /* 272429 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(272523), // Rule ID 1231 //
     /* 272434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 272451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272454 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272457 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 272464 */     // MIs[0] cbsz
     /* 272464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272467 */     // MIs[0] blgp
     /* 272467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272470 */     // MIs[0] scale_src0_opsel
     /* 272470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272478 */     // MIs[0] scale_src1_opsel
     /* 272478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23448),
     /* 272490 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23448>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_e64),
     /* 272493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272495 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272497 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272499 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272501 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272503 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272505 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272507 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272509 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272515 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272521 */     GIR_RootConstrainSelectedInstOperands,
     /* 272522 */     // GIR_Coverage, 1231,
     /* 272522 */     GIR_EraseRootFromParent_Done,
     /* 272523 */   // Label 4387: @272523
     /* 272523 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(272617), // Rule ID 1232 //
     /* 272528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 272545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272548 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272551 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 272558 */     // MIs[0] cbsz
     /* 272558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272561 */     // MIs[0] blgp
     /* 272561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272564 */     // MIs[0] scale_src0_opsel
     /* 272564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272567 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272572 */     // MIs[0] scale_src1_opsel
     /* 272572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23450),
     /* 272584 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23450>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64),
     /* 272587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272589 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272591 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272593 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272595 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272597 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272599 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272601 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272603 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272609 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272615 */     GIR_RootConstrainSelectedInstOperands,
     /* 272616 */     // GIR_Coverage, 1232,
     /* 272616 */     GIR_EraseRootFromParent_Done,
     /* 272617 */   // Label 4388: @272617
     /* 272617 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(272711), // Rule ID 1233 //
     /* 272622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 272639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272642 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272645 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 272652 */     // MIs[0] cbsz
     /* 272652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272655 */     // MIs[0] blgp
     /* 272655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272658 */     // MIs[0] scale_src0_opsel
     /* 272658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272666 */     // MIs[0] scale_src1_opsel
     /* 272666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272669 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272674 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23448),
     /* 272678 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23448>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_e64),
     /* 272681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272683 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272685 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272687 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272689 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272691 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272693 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272695 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272697 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272709 */     GIR_RootConstrainSelectedInstOperands,
     /* 272710 */     // GIR_Coverage, 1233,
     /* 272710 */     GIR_EraseRootFromParent_Done,
     /* 272711 */   // Label 4389: @272711
     /* 272711 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(272805), // Rule ID 1234 //
     /* 272716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 272733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272736 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272739 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 272746 */     // MIs[0] cbsz
     /* 272746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272749 */     // MIs[0] blgp
     /* 272749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272752 */     // MIs[0] scale_src0_opsel
     /* 272752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272755 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272760 */     // MIs[0] scale_src1_opsel
     /* 272760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23450),
     /* 272772 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23450>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64),
     /* 272775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272777 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272779 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272781 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272783 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272785 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272787 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272789 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272791 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272803 */     GIR_RootConstrainSelectedInstOperands,
     /* 272804 */     // GIR_Coverage, 1234,
     /* 272804 */     GIR_EraseRootFromParent_Done,
     /* 272805 */   // Label 4390: @272805
     /* 272805 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(272899), // Rule ID 1235 //
     /* 272810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272830 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272833 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 272840 */     // MIs[0] cbsz
     /* 272840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272843 */     // MIs[0] blgp
     /* 272843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272846 */     // MIs[0] scale_src0_opsel
     /* 272846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272854 */     // MIs[0] scale_src1_opsel
     /* 272854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272857 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272862 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23448),
     /* 272866 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23448>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_e64),
     /* 272869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272871 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272873 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272875 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272877 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272879 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272881 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272883 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272885 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272891 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272897 */     GIR_RootConstrainSelectedInstOperands,
     /* 272898 */     // GIR_Coverage, 1235,
     /* 272898 */     GIR_EraseRootFromParent_Done,
     /* 272899 */   // Label 4391: @272899
     /* 272899 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(272993), // Rule ID 1236 //
     /* 272904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 272912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 272915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 272924 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272927 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 272934 */     // MIs[0] cbsz
     /* 272934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272937 */     // MIs[0] blgp
     /* 272937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272940 */     // MIs[0] scale_src0_opsel
     /* 272940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 272943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272948 */     // MIs[0] scale_src1_opsel
     /* 272948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 272951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 272956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23450),
     /* 272960 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23450>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 272960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64),
     /* 272963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272965 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272967 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272969 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272971 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272973 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272975 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 272977 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 272979 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 272985 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 272991 */     GIR_RootConstrainSelectedInstOperands,
     /* 272992 */     // GIR_Coverage, 1236,
     /* 272992 */     GIR_EraseRootFromParent_Done,
     /* 272993 */   // Label 4392: @272993
     /* 272993 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(273087), // Rule ID 1237 //
     /* 272998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 273012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273018 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273021 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 273028 */     // MIs[0] cbsz
     /* 273028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273031 */     // MIs[0] blgp
     /* 273031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273034 */     // MIs[0] scale_src0_opsel
     /* 273034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273037 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273042 */     // MIs[0] scale_src1_opsel
     /* 273042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273045 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23448),
     /* 273054 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23448>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_e64),
     /* 273057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273059 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273061 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273063 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273065 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273067 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273069 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273071 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273073 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273079 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273085 */     GIR_RootConstrainSelectedInstOperands,
     /* 273086 */     // GIR_Coverage, 1237,
     /* 273086 */     GIR_EraseRootFromParent_Done,
     /* 273087 */   // Label 4393: @273087
     /* 273087 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(273181), // Rule ID 1238 //
     /* 273092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 273106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273112 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273115 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 273122 */     // MIs[0] cbsz
     /* 273122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273125 */     // MIs[0] blgp
     /* 273125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273128 */     // MIs[0] scale_src0_opsel
     /* 273128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273136 */     // MIs[0] scale_src1_opsel
     /* 273136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273139 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273144 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23450),
     /* 273148 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23450>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64),
     /* 273151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273153 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273155 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273157 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273159 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273161 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273163 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273165 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273167 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273173 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273179 */     GIR_RootConstrainSelectedInstOperands,
     /* 273180 */     // GIR_Coverage, 1238,
     /* 273180 */     GIR_EraseRootFromParent_Done,
     /* 273181 */   // Label 4394: @273181
     /* 273181 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(273275), // Rule ID 1239 //
     /* 273186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 273203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273206 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273209 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 273216 */     // MIs[0] cbsz
     /* 273216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273219 */     // MIs[0] blgp
     /* 273219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273222 */     // MIs[0] scale_src0_opsel
     /* 273222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273230 */     // MIs[0] scale_src1_opsel
     /* 273230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273238 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23448),
     /* 273242 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23448>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_e64),
     /* 273245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273247 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273249 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273251 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273253 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273255 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273257 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273259 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273261 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273273 */     GIR_RootConstrainSelectedInstOperands,
     /* 273274 */     // GIR_Coverage, 1239,
     /* 273274 */     GIR_EraseRootFromParent_Done,
     /* 273275 */   // Label 4395: @273275
     /* 273275 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(273369), // Rule ID 1240 //
     /* 273280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 273297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273300 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273303 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 273310 */     // MIs[0] cbsz
     /* 273310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273313 */     // MIs[0] blgp
     /* 273313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273316 */     // MIs[0] scale_src0_opsel
     /* 273316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273319 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273324 */     // MIs[0] scale_src1_opsel
     /* 273324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23450),
     /* 273336 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23450>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64),
     /* 273339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273341 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273343 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273345 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273347 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273349 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273351 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273353 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273355 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273361 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273367 */     GIR_RootConstrainSelectedInstOperands,
     /* 273368 */     // GIR_Coverage, 1240,
     /* 273368 */     GIR_EraseRootFromParent_Done,
     /* 273369 */   // Label 4396: @273369
     /* 273369 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(273463), // Rule ID 1241 //
     /* 273374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273394 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273397 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 273404 */     // MIs[0] cbsz
     /* 273404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273407 */     // MIs[0] blgp
     /* 273407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273410 */     // MIs[0] scale_src0_opsel
     /* 273410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273413 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273418 */     // MIs[0] scale_src1_opsel
     /* 273418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23448),
     /* 273430 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23448>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_e64),
     /* 273433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273435 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273437 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273439 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273441 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273443 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273445 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273447 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273449 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273455 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273461 */     GIR_RootConstrainSelectedInstOperands,
     /* 273462 */     // GIR_Coverage, 1241,
     /* 273462 */     GIR_EraseRootFromParent_Done,
     /* 273463 */   // Label 4397: @273463
     /* 273463 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(273557), // Rule ID 1242 //
     /* 273468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273488 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273491 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 273498 */     // MIs[0] cbsz
     /* 273498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273501 */     // MIs[0] blgp
     /* 273501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273504 */     // MIs[0] scale_src0_opsel
     /* 273504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 273507 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273512 */     // MIs[0] scale_src1_opsel
     /* 273512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 273515 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 273520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23450),
     /* 273524 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3066:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23450>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
     /* 273524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64),
     /* 273527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273531 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273533 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273535 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273537 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273539 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 273541 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 273543 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
     /* 273549 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
     /* 273555 */     GIR_RootConstrainSelectedInstOperands,
     /* 273556 */     // GIR_Coverage, 1242,
     /* 273556 */     GIR_EraseRootFromParent_Done,
     /* 273557 */   // Label 4398: @273557
     /* 273557 */   GIM_Reject,
     /* 273558 */ // Label 4326: @273558
     /* 273558 */ GIM_Reject,
     /* 273559 */ // Label 39: @273559
     /* 273559 */ GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(273635),
     /* 273564 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 273567 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(273582), // Rule ID 181 //
     /* 273572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_barrier),
     /* 273577 */     // (intrinsic_void 3147:{ *:[iPTR] })  =>  (S_BARRIER)
     /* 273577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BARRIER),
     /* 273580 */     GIR_RootConstrainSelectedInstOperands,
     /* 273581 */     // GIR_Coverage, 181,
     /* 273581 */     GIR_EraseRootFromParent_Done,
     /* 273582 */   // Label 4400: @273582
     /* 273582 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(273597), // Rule ID 1344 //
     /* 273587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_wave_barrier),
     /* 273592 */     // (intrinsic_void 3306:{ *:[iPTR] })  =>  (WAVE_BARRIER)
     /* 273592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::WAVE_BARRIER),
     /* 273595 */     GIR_RootConstrainSelectedInstOperands,
     /* 273596 */     // GIR_Coverage, 1344,
     /* 273596 */     GIR_EraseRootFromParent_Done,
     /* 273597 */   // Label 4401: @273597
     /* 273597 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(273616), // Rule ID 1352 //
     /* 273602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_unreachable),
     /* 273607 */     // (intrinsic_void 3304:{ *:[iPTR] })  =>  (SI_MASKED_UNREACHABLE)
     /* 273607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_MASKED_UNREACHABLE),
     /* 273610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273614 */     GIR_RootConstrainSelectedInstOperands,
     /* 273615 */     // GIR_Coverage, 1352,
     /* 273615 */     GIR_EraseRootFromParent_Done,
     /* 273616 */   // Label 4402: @273616
     /* 273616 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(273634), // Rule ID 1867 //
     /* 273621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_endpgm),
     /* 273626 */     // (intrinsic_void 2194:{ *:[iPTR] })  =>  (S_ENDPGM 0:{ *:[i16] })
     /* 273626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ENDPGM),
     /* 273629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273632 */     GIR_RootConstrainSelectedInstOperands,
     /* 273633 */     // GIR_Coverage, 1867,
     /* 273633 */     GIR_EraseRootFromParent_Done,
     /* 273634 */   // Label 4403: @273634
     /* 273634 */   GIM_Reject,
     /* 273635 */ // Label 4399: @273635
     /* 273635 */ GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(273774),
     /* 273640 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 273643 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(273663), // Rule ID 41 //
     /* 273648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_barrier_signal),
     /* 273653 */     // MIs[0] src0
     /* 273653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273656 */     // (intrinsic_void 3148:{ *:[iPTR] }, (timm:{ *:[i32] }):$src0)  =>  (S_BARRIER_SIGNAL_IMM (timm:{ *:[i32] }):$src0)
     /* 273656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BARRIER_SIGNAL_IMM),
     /* 273659 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 273661 */     GIR_RootConstrainSelectedInstOperands,
     /* 273662 */     // GIR_Coverage, 41,
     /* 273662 */     GIR_EraseRootFromParent_Done,
     /* 273663 */   // Label 4405: @273663
     /* 273663 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(273683), // Rule ID 182 //
     /* 273668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_barrier_wait),
     /* 273673 */     // MIs[0] simm16
     /* 273673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273676 */     // (intrinsic_void 3151:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_BARRIER_WAIT (timm:{ *:[i16] }):$simm16)
     /* 273676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BARRIER_WAIT),
     /* 273679 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 273681 */     GIR_RootConstrainSelectedInstOperands,
     /* 273682 */     // GIR_Coverage, 182,
     /* 273682 */     GIR_EraseRootFromParent_Done,
     /* 273683 */   // Label 4406: @273683
     /* 273683 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(273703), // Rule ID 1345 //
     /* 273688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_sched_barrier),
     /* 273693 */     // MIs[0] mask
     /* 273693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273696 */     // (intrinsic_void 3195:{ *:[iPTR] }, (timm:{ *:[i32] }):$mask)  =>  (SCHED_BARRIER (timm:{ *:[i32] }):$mask)
     /* 273696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCHED_BARRIER),
     /* 273699 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 273701 */     GIR_RootConstrainSelectedInstOperands,
     /* 273702 */     // GIR_Coverage, 1345,
     /* 273702 */     GIR_EraseRootFromParent_Done,
     /* 273703 */   // Label 4407: @273703
     /* 273703 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(273723), // Rule ID 1347 //
     /* 273708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_iglp_opt),
     /* 273713 */     // MIs[0] mask
     /* 273713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273716 */     // (intrinsic_void 2226:{ *:[iPTR] }, (timm:{ *:[i32] }):$mask)  =>  (IGLP_OPT (timm:{ *:[i32] }):$mask)
     /* 273716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::IGLP_OPT),
     /* 273719 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 273721 */     GIR_RootConstrainSelectedInstOperands,
     /* 273722 */     // GIR_Coverage, 1347,
     /* 273722 */     GIR_EraseRootFromParent_Done,
     /* 273723 */   // Label 4408: @273723
     /* 273723 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(273746), // Rule ID 1353 //
     /* 273728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_init_exec),
     /* 273733 */     // MIs[0] src
     /* 273733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 273736 */     // (intrinsic_void 2990:{ *:[iPTR] }, (timm:{ *:[i64] }):$src)  =>  (SI_INIT_EXEC (timm:{ *:[i64] }):$src)
     /* 273736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_INIT_EXEC),
     /* 273739 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 273741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 273744 */     GIR_RootConstrainSelectedInstOperands,
     /* 273745 */     // GIR_Coverage, 1353,
     /* 273745 */     GIR_EraseRootFromParent_Done,
     /* 273746 */   // Label 4409: @273746
     /* 273746 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(273773), // Rule ID 1355 //
     /* 273751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_init_whole_wave),
     /* 273756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 273759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 273763 */     // (intrinsic_w_chain:{ *:[i1] } 2992:{ *:[iPTR] })  =>  (SI_INIT_WHOLE_WAVE:{ *:[i1] })
     /* 273763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_INIT_WHOLE_WAVE),
     /* 273766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 273771 */     GIR_RootConstrainSelectedInstOperands,
     /* 273772 */     // GIR_Coverage, 1355,
     /* 273772 */     GIR_EraseRootFromParent_Done,
     /* 273773 */   // Label 4410: @273773
     /* 273773 */   GIM_Reject,
     /* 273774 */ // Label 4404: @273774
     /* 273774 */ GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(274776),
     /* 273779 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 273782 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(273837), // Rule ID 8327 //
     /* 273787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr4_b64),
     /* 273795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 273798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 273802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 273806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 273813 */     // (intrinsic_w_chain:{ *:[v2i32] } 2187:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B4:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 273813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B4),
     /* 273816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 273823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 273828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273835 */     GIR_RootConstrainSelectedInstOperands,
     /* 273836 */     // GIR_Coverage, 8327,
     /* 273836 */     GIR_EraseRootFromParent_Done,
     /* 273837 */   // Label 4412: @273837
     /* 273837 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(273892), // Rule ID 8328 //
     /* 273842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr8_b64),
     /* 273850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 273853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 273857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 273861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 273868 */     // (intrinsic_w_chain:{ *:[v2i32] } 2189:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B8:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 273868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B8),
     /* 273871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 273878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 273883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273890 */     GIR_RootConstrainSelectedInstOperands,
     /* 273891 */     // GIR_Coverage, 8328,
     /* 273891 */     GIR_EraseRootFromParent_Done,
     /* 273892 */   // Label 4413: @273892
     /* 273892 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(273947), // Rule ID 8329 //
     /* 273897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr6_b96),
     /* 273905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v3s32,
     /* 273908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 273912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 273916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 273923 */     // (intrinsic_w_chain:{ *:[v3i32] } 2188:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B96_TR_B6:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 273923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_TR_B6),
     /* 273926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 273933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 273938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273945 */     GIR_RootConstrainSelectedInstOperands,
     /* 273946 */     // GIR_Coverage, 8329,
     /* 273946 */     GIR_EraseRootFromParent_Done,
     /* 273947 */   // Label 4414: @273947
     /* 273947 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(274002), // Rule ID 8330 //
     /* 273952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr16_b64),
     /* 273960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 273963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 273967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 273971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 273978 */     // (intrinsic_w_chain:{ *:[v4i16] } 2186:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B16:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 273978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B16),
     /* 273981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 273988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 273993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274000 */     GIR_RootConstrainSelectedInstOperands,
     /* 274001 */     // GIR_Coverage, 8330,
     /* 274001 */     GIR_EraseRootFromParent_Done,
     /* 274002 */   // Label 4415: @274002
     /* 274002 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(274057), // Rule ID 8331 //
     /* 274007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr16_b64),
     /* 274015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 274033 */     // (intrinsic_w_chain:{ *:[v4f16] } 2186:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B16:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 274033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B16),
     /* 274036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 274043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274055 */     GIR_RootConstrainSelectedInstOperands,
     /* 274056 */     // GIR_Coverage, 8331,
     /* 274056 */     GIR_EraseRootFromParent_Done,
     /* 274057 */   // Label 4416: @274057
     /* 274057 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(274117), // Rule ID 4120 //
     /* 274062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 274065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
     /* 274070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 274073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 274088 */     // (intrinsic_w_chain:{ *:[v2i32] } 2221:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w32_SADDR:{ *:[v2i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 274088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w32_SADDR),
     /* 274091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 274098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 274103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 274108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274115 */     GIR_RootConstrainSelectedInstOperands,
     /* 274116 */     // GIR_Coverage, 4120,
     /* 274116 */     GIR_EraseRootFromParent_Done,
     /* 274117 */   // Label 4417: @274117
     /* 274117 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(274177), // Rule ID 4122 //
     /* 274122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 274125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 274137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 274148 */     // (intrinsic_w_chain:{ *:[v8i16] } 2220:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32_SADDR:{ *:[v8i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 274148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32_SADDR),
     /* 274151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 274158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 274163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 274168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274175 */     GIR_RootConstrainSelectedInstOperands,
     /* 274176 */     // GIR_Coverage, 4122,
     /* 274176 */     GIR_EraseRootFromParent_Done,
     /* 274177 */   // Label 4418: @274177
     /* 274177 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(274237), // Rule ID 4124 //
     /* 274182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 274185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 274197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 274208 */     // (intrinsic_w_chain:{ *:[v8f16] } 2220:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32_SADDR:{ *:[v8f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 274208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32_SADDR),
     /* 274211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 274218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 274223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 274228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274235 */     GIR_RootConstrainSelectedInstOperands,
     /* 274236 */     // GIR_Coverage, 4124,
     /* 274236 */     GIR_EraseRootFromParent_Done,
     /* 274237 */   // Label 4419: @274237
     /* 274237 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(274297), // Rule ID 4126 //
     /* 274242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 274245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
     /* 274250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 274253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 274257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 274268 */     // (intrinsic_w_chain:{ *:[i32] } 2221:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w64_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 274268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w64_SADDR),
     /* 274271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 274278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 274283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 274288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274295 */     GIR_RootConstrainSelectedInstOperands,
     /* 274296 */     // GIR_Coverage, 4126,
     /* 274296 */     GIR_EraseRootFromParent_Done,
     /* 274297 */   // Label 4420: @274297
     /* 274297 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(274357), // Rule ID 4128 //
     /* 274302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 274305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 274328 */     // (intrinsic_w_chain:{ *:[v4i16] } 2220:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64_SADDR:{ *:[v4i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 274328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64_SADDR),
     /* 274331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 274338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 274343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 274348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274355 */     GIR_RootConstrainSelectedInstOperands,
     /* 274356 */     // GIR_Coverage, 4128,
     /* 274356 */     GIR_EraseRootFromParent_Done,
     /* 274357 */   // Label 4421: @274357
     /* 274357 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(274417), // Rule ID 4130 //
     /* 274362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 274365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 274388 */     // (intrinsic_w_chain:{ *:[v4f16] } 2220:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64_SADDR:{ *:[v4f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 274388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64_SADDR),
     /* 274391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 274398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 274403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 274408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274415 */     GIR_RootConstrainSelectedInstOperands,
     /* 274416 */     // GIR_Coverage, 4130,
     /* 274416 */     GIR_EraseRootFromParent_Done,
     /* 274417 */   // Label 4422: @274417
     /* 274417 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(274472), // Rule ID 4119 //
     /* 274422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 274425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
     /* 274430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 274433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 274448 */     // (intrinsic_w_chain:{ *:[v2i32] } 2221:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w32:{ *:[v2i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 274448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w32),
     /* 274451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 274458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274470 */     GIR_RootConstrainSelectedInstOperands,
     /* 274471 */     // GIR_Coverage, 4119,
     /* 274471 */     GIR_EraseRootFromParent_Done,
     /* 274472 */   // Label 4423: @274472
     /* 274472 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(274527), // Rule ID 4121 //
     /* 274477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 274480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 274492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 274503 */     // (intrinsic_w_chain:{ *:[v8i16] } 2220:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32:{ *:[v8i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 274503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32),
     /* 274506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 274513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274525 */     GIR_RootConstrainSelectedInstOperands,
     /* 274526 */     // GIR_Coverage, 4121,
     /* 274526 */     GIR_EraseRootFromParent_Done,
     /* 274527 */   // Label 4424: @274527
     /* 274527 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(274582), // Rule ID 4123 //
     /* 274532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 274535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 274547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 274558 */     // (intrinsic_w_chain:{ *:[v8f16] } 2220:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32:{ *:[v8f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 274558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32),
     /* 274561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 274568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274580 */     GIR_RootConstrainSelectedInstOperands,
     /* 274581 */     // GIR_Coverage, 4123,
     /* 274581 */     GIR_EraseRootFromParent_Done,
     /* 274582 */   // Label 4425: @274582
     /* 274582 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(274637), // Rule ID 4125 //
     /* 274587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 274590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
     /* 274595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 274598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 274602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 274613 */     // (intrinsic_w_chain:{ *:[i32] } 2221:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 274613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w64),
     /* 274616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 274623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274635 */     GIR_RootConstrainSelectedInstOperands,
     /* 274636 */     // GIR_Coverage, 4125,
     /* 274636 */     GIR_EraseRootFromParent_Done,
     /* 274637 */   // Label 4426: @274637
     /* 274637 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(274692), // Rule ID 4127 //
     /* 274642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 274645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 274668 */     // (intrinsic_w_chain:{ *:[v4i16] } 2220:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64:{ *:[v4i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 274668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64),
     /* 274671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 274678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274690 */     GIR_RootConstrainSelectedInstOperands,
     /* 274691 */     // GIR_Coverage, 4127,
     /* 274691 */     GIR_EraseRootFromParent_Done,
     /* 274692 */   // Label 4427: @274692
     /* 274692 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(274747), // Rule ID 4129 //
     /* 274697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 274700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 274705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 274712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 274716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 274723 */     // (intrinsic_w_chain:{ *:[v4f16] } 2220:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64:{ *:[v4f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 274723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64),
     /* 274726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 274733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 274738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274745 */     GIR_RootConstrainSelectedInstOperands,
     /* 274746 */     // GIR_Coverage, 4129,
     /* 274746 */     GIR_EraseRootFromParent_Done,
     /* 274747 */   // Label 4428: @274747
     /* 274747 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(274775), // Rule ID 1354 //
     /* 274752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_init_exec_from_input),
     /* 274757 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 274760 */     // MIs[0] shift
     /* 274760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 274763 */     // (intrinsic_void 2991:{ *:[iPTR] }, i32:{ *:[i32] }:$input, (timm:{ *:[i32] }):$shift)  =>  (SI_INIT_EXEC_FROM_INPUT i32:{ *:[i32] }:$input, (timm:{ *:[i32] }):$shift)
     /* 274763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_INIT_EXEC_FROM_INPUT),
     /* 274766 */     GIR_RootToRootCopy, /*OpIdx*/1, // input
     /* 274768 */     GIR_RootToRootCopy, /*OpIdx*/2, // shift
     /* 274770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 274773 */     GIR_RootConstrainSelectedInstOperands,
     /* 274774 */     // GIR_Coverage, 1354,
     /* 274774 */     GIR_EraseRootFromParent_Done,
     /* 274775 */   // Label 4429: @274775
     /* 274775 */   GIM_Reject,
     /* 274776 */ // Label 4411: @274776
     /* 274776 */ GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(274809), // Rule ID 1346 //
     /* 274781 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 274784 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_sched_group_barrier),
     /* 274789 */   // MIs[0] mask
     /* 274789 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274792 */   // MIs[0] size
     /* 274792 */   GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 274795 */   // MIs[0] syncid
     /* 274795 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 274798 */   // (intrinsic_void 3196:{ *:[iPTR] }, (timm:{ *:[i32] }):$mask, (timm:{ *:[i32] }):$size, (timm:{ *:[i32] }):$syncid)  =>  (SCHED_GROUP_BARRIER (timm:{ *:[i32] }):$mask, (timm:{ *:[i32] }):$size, (timm:{ *:[i32] }):$syncid)
     /* 274798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCHED_GROUP_BARRIER),
     /* 274801 */   GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 274803 */   GIR_RootToRootCopy, /*OpIdx*/2, // size
     /* 274805 */   GIR_RootToRootCopy, /*OpIdx*/3, // syncid
     /* 274807 */   GIR_RootConstrainSelectedInstOperands,
     /* 274808 */   // GIR_Coverage, 1346,
     /* 274808 */   GIR_EraseRootFromParent_Done,
     /* 274809 */ // Label 4430: @274809
     /* 274809 */ GIM_Reject,
     /* 274810 */ // Label 40: @274810
     /* 274810 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4434*/ GIMT_Encode4(275372),
     /* 274821 */ /*GILLT_s16*//*Label 4431*/ GIMT_Encode4(274833),
     /* 274825 */ /*GILLT_s32*//*Label 4432*/ GIMT_Encode4(274870),
     /* 274829 */ /*GILLT_s64*//*Label 4433*/ GIMT_Encode4(274969),
     /* 274833 */ // Label 4431: @274833
     /* 274833 */ GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(274869), // Rule ID 2558 //
     /* 274838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 274841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 274844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 274848 */   // (anyext:{ *:[i16] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src)
     /* 274848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 274851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 274865 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 274867 */   GIR_RootConstrainSelectedInstOperands,
     /* 274868 */   // GIR_Coverage, 2558,
     /* 274868 */   GIR_EraseRootFromParent_Done,
     /* 274869 */ // Label 4435: @274869
     /* 274869 */ GIM_Reject,
     /* 274870 */ // Label 4432: @274870
     /* 274870 */ GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(274935), // Rule ID 2442 //
     /* 274875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 274878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 274881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 274885 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19283),
     /* 274889 */   // (anyext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_19283>>  =>  (REG_SEQUENCE:{ *:[i32] } VGPR_32:{ *:[i32] }, ?:{ *:[i16] }:$src, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i16] }), hi16:{ *:[i32] })
     /* 274889 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 274892 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 274896 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 274903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 274906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274908 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 274910 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /* 274913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 274916 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /* 274919 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 274924 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 274929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 274934 */   // GIR_Coverage, 2442,
     /* 274934 */   GIR_EraseRootFromParent_Done,
     /* 274935 */ // Label 4436: @274935
     /* 274935 */ GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(274968), // Rule ID 7311 //
     /* 274940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 274943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 274947 */   // (anyext:{ *:[i32] } i1:{ *:[i1] }:$src0)  =>  (V_CNDMASK_B32_e64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, i1:{ *:[i1] }:$src0)
     /* 274947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 274950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 274961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 274964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 274966 */   GIR_RootConstrainSelectedInstOperands,
     /* 274967 */   // GIR_Coverage, 7311,
     /* 274967 */   GIR_EraseRootFromParent_Done,
     /* 274968 */ // Label 4437: @274968
     /* 274968 */ GIM_Reject,
     /* 274969 */ // Label 4433: @274969
     /* 274969 */ GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(275052), // Rule ID 2433 //
     /* 274974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX8Plus),
     /* 274977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 274980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 274984 */   // (anyext:{ *:[i64] } i16:{ *:[i16] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (COPY:{ *:[i32] } ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 274984 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 274987 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 274991 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274996 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 274999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 275001 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275004 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275008 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275013 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 275017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 275022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275027 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 275030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 275033 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 275036 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275051 */   // GIR_Coverage, 2433,
     /* 275051 */   GIR_EraseRootFromParent_Done,
     /* 275052 */ // Label 4438: @275052
     /* 275052 */ GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(275135), // Rule ID 2437 //
     /* 275057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX8Plus),
     /* 275060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 275063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275067 */   // (anyext:{ *:[i64] } i16:{ *:[i16] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (COPY:{ *:[i32] } ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 275067 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 275070 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 275074 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275079 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 275082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 275084 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275091 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275096 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 275100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 275105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275107 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275110 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 275113 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 275116 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 275119 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275124 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275134 */   // GIR_Coverage, 2437,
     /* 275134 */   GIR_EraseRootFromParent_Done,
     /* 275135 */ // Label 4439: @275135
     /* 275135 */ GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(275221), // Rule ID 2443 //
     /* 275140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 275143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 275146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275150 */   // (anyext:{ *:[i64] } i16:{ *:[i16] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i16] }:$src, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i16] }), hi16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] })
     /* 275150 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 275153 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 275157 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 275164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 275171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 275181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275183 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 275185 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /* 275188 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275191 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /* 275194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 275197 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 275200 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 275210 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 275215 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/5, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275220 */   // GIR_Coverage, 2443,
     /* 275220 */   GIR_EraseRootFromParent_Done,
     /* 275221 */ // Label 4440: @275221
     /* 275221 */ GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(275279), // Rule ID 7391 //
     /* 275226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 275229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 275233 */   // (anyext:{ *:[i64] } i32:{ *:[i32] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] })
     /* 275233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 275240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275245 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 275250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275252 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 275254 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 275257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275260 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 275263 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 275268 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 275273 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 275278 */   // GIR_Coverage, 7391,
     /* 275278 */   GIR_EraseRootFromParent_Done,
     /* 275279 */ // Label 4441: @275279
     /* 275279 */ GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(275371), // Rule ID 7393 //
     /* 275284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 275287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275291 */   // (anyext:{ *:[i64] } i1:{ *:[i1] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 275291 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 275294 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 275298 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275303 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 275306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 275308 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275311 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 275315 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275320 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 275323 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 275326 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 275329 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 275332 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 275336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 275341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275343 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275346 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 275349 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 275352 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 275355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275370 */   // GIR_Coverage, 7393,
     /* 275370 */   GIR_EraseRootFromParent_Done,
     /* 275371 */ // Label 4442: @275371
     /* 275371 */ GIM_Reject,
     /* 275372 */ // Label 4434: @275372
     /* 275372 */ GIM_Reject,
     /* 275373 */ // Label 41: @275373
     /* 275373 */ GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(275612),
     /* 275378 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 275381 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4446*/ GIMT_Encode4(275496),
     /* 275392 */   /*GILLT_s16*//*Label 4444*/ GIMT_Encode4(275400),
     /* 275396 */   /*GILLT_s32*//*Label 4445*/ GIMT_Encode4(275448),
     /* 275400 */   // Label 4444: @275400
     /* 275400 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(275447), // Rule ID 7443 //
     /* 275405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 275409 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34817),
     /* 275413 */     // (trunc:{ *:[i1] } i16:{ *:[i16] }:$a)<<P:Predicate_anonymous_34817>>  =>  (V_CMP_EQ_U32_e64:{ *:[i1] } (V_AND_B32_e64:{ *:[i16] } 1:{ *:[i32] }, ?:{ *:[i16] }:$a), 1:{ *:[i32] })
     /* 275413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 275420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275425 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 275428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 275432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U32_e64),
     /* 275437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 275439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 275445 */     GIR_RootConstrainSelectedInstOperands,
     /* 275446 */     // GIR_Coverage, 7443,
     /* 275446 */     GIR_EraseRootFromParent_Done,
     /* 275447 */   // Label 4447: @275447
     /* 275447 */   GIM_Reject,
     /* 275448 */   // Label 4445: @275448
     /* 275448 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(275495), // Rule ID 7442 //
     /* 275453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 275457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34817),
     /* 275461 */     // (trunc:{ *:[i1] } i32:{ *:[i32] }:$a)<<P:Predicate_anonymous_34817>>  =>  (V_CMP_EQ_U32_e64:{ *:[i1] } (V_AND_B32_e64:{ *:[i16] } 1:{ *:[i32] }, ?:{ *:[i32] }:$a), 1:{ *:[i32] })
     /* 275461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 275468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275473 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 275476 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 275480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U32_e64),
     /* 275485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 275487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 275493 */     GIR_RootConstrainSelectedInstOperands,
     /* 275494 */     // GIR_Coverage, 7442,
     /* 275494 */     GIR_EraseRootFromParent_Done,
     /* 275495 */   // Label 4448: @275495
     /* 275495 */   GIM_Reject,
     /* 275496 */   // Label 4446: @275496
     /* 275496 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4451*/ GIMT_Encode4(275611),
     /* 275507 */   /*GILLT_s16*//*Label 4449*/ GIMT_Encode4(275515),
     /* 275511 */   /*GILLT_s32*//*Label 4450*/ GIMT_Encode4(275563),
     /* 275515 */   // Label 4449: @275515
     /* 275515 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(275562), // Rule ID 7440 //
     /* 275520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34813),
     /* 275524 */     // (trunc:{ *:[i1] } i16:{ *:[i16] }:$a)<<P:Predicate_anonymous_34813>>  =>  (S_CMP_EQ_U32:{ *:[i1] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } 1:{ *:[i32] }, ?:{ *:[i16] }:$a), 1:{ *:[i32] })
     /* 275524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 275527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 275531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 275539 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 275543 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AMDGPU::SCC*/0,
     /* 275546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_CMP_EQ_U32),
     /* 275551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 275557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 275560 */     GIR_RootConstrainSelectedInstOperands,
     /* 275561 */     // GIR_Coverage, 7440,
     /* 275561 */     GIR_EraseRootFromParent_Done,
     /* 275562 */   // Label 4452: @275562
     /* 275562 */   GIM_Reject,
     /* 275563 */   // Label 4450: @275563
     /* 275563 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(275610), // Rule ID 7439 //
     /* 275568 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34813),
     /* 275572 */     // (trunc:{ *:[i1] } i32:{ *:[i32] }:$a)<<P:Predicate_anonymous_34813>>  =>  (S_CMP_EQ_U32:{ *:[i1] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } 1:{ *:[i32] }, ?:{ *:[i32] }:$a), 1:{ *:[i32] })
     /* 275572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 275575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 275579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275584 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 275587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 275591 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AMDGPU::SCC*/0,
     /* 275594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 275596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_CMP_EQ_U32),
     /* 275599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 275605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 275608 */     GIR_RootConstrainSelectedInstOperands,
     /* 275609 */     // GIR_Coverage, 7439,
     /* 275609 */     GIR_EraseRootFromParent_Done,
     /* 275610 */   // Label 4453: @275610
     /* 275610 */   GIM_Reject,
     /* 275611 */   // Label 4451: @275611
     /* 275611 */   GIM_Reject,
     /* 275612 */ // Label 4443: @275612
     /* 275612 */ GIM_Reject,
     /* 275613 */ // Label 42: @275613
     /* 275613 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(11), /*)*//*default:*//*Label 4465*/ GIMT_Encode4(276338),
     /* 275624 */ /*GILLT_p0s64*//*Label 4454*/ GIMT_Encode4(275668),
     /* 275628 */ /*GILLT_p1s64*//*Label 4455*/ GIMT_Encode4(275711),
     /* 275632 */ /*GILLT_p2s32*//*Label 4456*/ GIMT_Encode4(275754),
     /* 275636 */ /*GILLT_p3s32*//*Label 4457*/ GIMT_Encode4(275797),
     /* 275640 */ /*GILLT_p4s64*//*Label 4458*/ GIMT_Encode4(275840),
     /* 275644 */ /*GILLT_p5s32*//*Label 4459*/ GIMT_Encode4(275883),
     /* 275648 */ /*GILLT_p6s32*//*Label 4460*/ GIMT_Encode4(275926),
     /* 275652 */ /*GILLT_s1*//*Label 4461*/ GIMT_Encode4(275969),
     /* 275656 */ /*GILLT_s16*//*Label 4462*/ GIMT_Encode4(276014),
     /* 275660 */ /*GILLT_s32*//*Label 4463*/ GIMT_Encode4(276118),
     /* 275664 */ /*GILLT_s64*//*Label 4464*/ GIMT_Encode4(276161),
     /* 275668 */ // Label 4454: @275668
     /* 275668 */ GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(275691), // Rule ID 7297 //
     /* 275673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275677 */   // MIs[0] Operand 1
     /* 275677 */   // No operand predicates
     /* 275677 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34644),
     /* 275681 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34644>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 275681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 275684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275686 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275689 */   GIR_RootConstrainSelectedInstOperands,
     /* 275690 */   // GIR_Coverage, 7297,
     /* 275690 */   GIR_EraseRootFromParent_Done,
     /* 275691 */ // Label 4466: @275691
     /* 275691 */ GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(275710), // Rule ID 7299 //
     /* 275696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 275700 */   // MIs[0] Operand 1
     /* 275700 */   // No operand predicates
     /* 275700 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 275700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 275703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 275705 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275708 */   GIR_RootConstrainSelectedInstOperands,
     /* 275709 */   // GIR_Coverage, 7299,
     /* 275709 */   GIR_EraseRootFromParent_Done,
     /* 275710 */ // Label 4467: @275710
     /* 275710 */ GIM_Reject,
     /* 275711 */ // Label 4455: @275711
     /* 275711 */ GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(275734), // Rule ID 7294 //
     /* 275716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275720 */   // MIs[0] Operand 1
     /* 275720 */   // No operand predicates
     /* 275720 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34640),
     /* 275724 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34640>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 275724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 275727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275729 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275732 */   GIR_RootConstrainSelectedInstOperands,
     /* 275733 */   // GIR_Coverage, 7294,
     /* 275733 */   GIR_EraseRootFromParent_Done,
     /* 275734 */ // Label 4468: @275734
     /* 275734 */ GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(275753), // Rule ID 7296 //
     /* 275739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 275743 */   // MIs[0] Operand 1
     /* 275743 */   // No operand predicates
     /* 275743 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 275743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 275746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 275748 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275751 */   GIR_RootConstrainSelectedInstOperands,
     /* 275752 */   // GIR_Coverage, 7296,
     /* 275752 */   GIR_EraseRootFromParent_Done,
     /* 275753 */ // Label 4469: @275753
     /* 275753 */ GIM_Reject,
     /* 275754 */ // Label 4456: @275754
     /* 275754 */ GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(275777), // Rule ID 7271 //
     /* 275759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275763 */   // MIs[0] Operand 1
     /* 275763 */   // No operand predicates
     /* 275763 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34603),
     /* 275767 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34603>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 275767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 275770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275772 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275775 */   GIR_RootConstrainSelectedInstOperands,
     /* 275776 */   // GIR_Coverage, 7271,
     /* 275776 */   GIR_EraseRootFromParent_Done,
     /* 275777 */ // Label 4470: @275777
     /* 275777 */ GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(275796), // Rule ID 7272 //
     /* 275782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 275786 */   // MIs[0] Operand 1
     /* 275786 */   // No operand predicates
     /* 275786 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 275786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 275789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 275791 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275794 */   GIR_RootConstrainSelectedInstOperands,
     /* 275795 */   // GIR_Coverage, 7272,
     /* 275795 */   GIR_EraseRootFromParent_Done,
     /* 275796 */ // Label 4471: @275796
     /* 275796 */ GIM_Reject,
     /* 275797 */ // Label 4457: @275797
     /* 275797 */ GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(275820), // Rule ID 7265 //
     /* 275802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275806 */   // MIs[0] Operand 1
     /* 275806 */   // No operand predicates
     /* 275806 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34594),
     /* 275810 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34594>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 275810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 275813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275815 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275818 */   GIR_RootConstrainSelectedInstOperands,
     /* 275819 */   // GIR_Coverage, 7265,
     /* 275819 */   GIR_EraseRootFromParent_Done,
     /* 275820 */ // Label 4472: @275820
     /* 275820 */ GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(275839), // Rule ID 7266 //
     /* 275825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 275829 */   // MIs[0] Operand 1
     /* 275829 */   // No operand predicates
     /* 275829 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 275829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 275832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 275834 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275837 */   GIR_RootConstrainSelectedInstOperands,
     /* 275838 */   // GIR_Coverage, 7266,
     /* 275838 */   GIR_EraseRootFromParent_Done,
     /* 275839 */ // Label 4473: @275839
     /* 275839 */ GIM_Reject,
     /* 275840 */ // Label 4458: @275840
     /* 275840 */ GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(275863), // Rule ID 7300 //
     /* 275845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 275849 */   // MIs[0] Operand 1
     /* 275849 */   // No operand predicates
     /* 275849 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34648),
     /* 275853 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34648>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 275853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 275856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275858 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275861 */   GIR_RootConstrainSelectedInstOperands,
     /* 275862 */   // GIR_Coverage, 7300,
     /* 275862 */   GIR_EraseRootFromParent_Done,
     /* 275863 */ // Label 4474: @275863
     /* 275863 */ GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(275882), // Rule ID 7302 //
     /* 275868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 275872 */   // MIs[0] Operand 1
     /* 275872 */   // No operand predicates
     /* 275872 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 275872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 275875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 275877 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275880 */   GIR_RootConstrainSelectedInstOperands,
     /* 275881 */   // GIR_Coverage, 7302,
     /* 275881 */   GIR_EraseRootFromParent_Done,
     /* 275882 */ // Label 4475: @275882
     /* 275882 */ GIM_Reject,
     /* 275883 */ // Label 4459: @275883
     /* 275883 */ GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(275906), // Rule ID 7267 //
     /* 275888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275892 */   // MIs[0] Operand 1
     /* 275892 */   // No operand predicates
     /* 275892 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34597),
     /* 275896 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34597>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 275896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 275899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275901 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275904 */   GIR_RootConstrainSelectedInstOperands,
     /* 275905 */   // GIR_Coverage, 7267,
     /* 275905 */   GIR_EraseRootFromParent_Done,
     /* 275906 */ // Label 4476: @275906
     /* 275906 */ GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(275925), // Rule ID 7268 //
     /* 275911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 275915 */   // MIs[0] Operand 1
     /* 275915 */   // No operand predicates
     /* 275915 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 275915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 275918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 275920 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275923 */   GIR_RootConstrainSelectedInstOperands,
     /* 275924 */   // GIR_Coverage, 7268,
     /* 275924 */   GIR_EraseRootFromParent_Done,
     /* 275925 */ // Label 4477: @275925
     /* 275925 */ GIM_Reject,
     /* 275926 */ // Label 4460: @275926
     /* 275926 */ GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(275949), // Rule ID 7269 //
     /* 275931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 275935 */   // MIs[0] Operand 1
     /* 275935 */   // No operand predicates
     /* 275935 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34600),
     /* 275939 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34600>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 275939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 275942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275944 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275947 */   GIR_RootConstrainSelectedInstOperands,
     /* 275948 */   // GIR_Coverage, 7269,
     /* 275948 */   GIR_EraseRootFromParent_Done,
     /* 275949 */ // Label 4478: @275949
     /* 275949 */ GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(275968), // Rule ID 7270 //
     /* 275954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 275958 */   // MIs[0] Operand 1
     /* 275958 */   // No operand predicates
     /* 275958 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 275958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 275961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 275963 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275966 */   GIR_RootConstrainSelectedInstOperands,
     /* 275967 */   // GIR_Coverage, 7270,
     /* 275967 */   GIR_EraseRootFromParent_Done,
     /* 275968 */ // Label 4479: @275968
     /* 275968 */ GIM_Reject,
     /* 275969 */ // Label 4461: @275969
     /* 275969 */ GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(275991), // Rule ID 7306 //
     /* 275974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 275977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 275981 */   // MIs[0] Operand 1
     /* 275981 */   // No operand predicates
     /* 275981 */   // (imm:{ *:[i1] }):$imm  =>  (S_MOV_B64:{ *:[i1] } (imm:{ *:[i1] }):$imm)
     /* 275981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 275984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 275986 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 275989 */   GIR_RootConstrainSelectedInstOperands,
     /* 275990 */   // GIR_Coverage, 7306,
     /* 275990 */   GIR_EraseRootFromParent_Done,
     /* 275991 */ // Label 4480: @275991
     /* 275991 */ GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(276013), // Rule ID 7307 //
     /* 275996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 275999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276003 */   // MIs[0] Operand 1
     /* 276003 */   // No operand predicates
     /* 276003 */   // (imm:{ *:[i1] }):$imm  =>  (S_MOV_B32:{ *:[i1] } (imm:{ *:[i1] }):$imm)
     /* 276003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276008 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276011 */   GIR_RootConstrainSelectedInstOperands,
     /* 276012 */   // GIR_Coverage, 7307,
     /* 276012 */   GIR_EraseRootFromParent_Done,
     /* 276013 */ // Label 4481: @276013
     /* 276013 */ GIM_Reject,
     /* 276014 */ // Label 4462: @276014
     /* 276014 */ GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(276040), // Rule ID 7277 //
     /* 276019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 276022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276026 */   // MIs[0] Operand 1
     /* 276026 */   // No operand predicates
     /* 276026 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34613),
     /* 276030 */   // (imm:{ *:[i16] })<<P:Predicate_anonymous_34613>>:$imm  =>  (V_MOV_B32_e32:{ *:[i16] } (imm:{ *:[i16] }):$imm)
     /* 276030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276035 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276038 */   GIR_RootConstrainSelectedInstOperands,
     /* 276039 */   // GIR_Coverage, 7277,
     /* 276039 */   GIR_EraseRootFromParent_Done,
     /* 276040 */ // Label 4482: @276040
     /* 276040 */ GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(276066), // Rule ID 7279 //
     /* 276045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 276048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276052 */   // MIs[0] Operand 1
     /* 276052 */   // No operand predicates
     /* 276052 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34613),
     /* 276056 */   // (imm:{ *:[i16] })<<P:Predicate_anonymous_34613>>:$imm  =>  (V_MOV_B32_e32:{ *:[i16] } (imm:{ *:[i16] }):$imm)
     /* 276056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276061 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276064 */   GIR_RootConstrainSelectedInstOperands,
     /* 276065 */   // GIR_Coverage, 7279,
     /* 276065 */   GIR_EraseRootFromParent_Done,
     /* 276066 */ // Label 4483: @276066
     /* 276066 */ GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(276098), // Rule ID 7281 //
     /* 276071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 276074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 276078 */   // MIs[0] Operand 1
     /* 276078 */   // No operand predicates
     /* 276078 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34613),
     /* 276082 */   // (imm:{ *:[i16] })<<P:Predicate_anonymous_34613>>:$imm  =>  (V_MOV_B16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, (imm:{ *:[i16] }):$imm, 0:{ *:[i32] })
     /* 276082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B16_t16_e64),
     /* 276085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276090 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276096 */   GIR_RootConstrainSelectedInstOperands,
     /* 276097 */   // GIR_Coverage, 7281,
     /* 276097 */   GIR_EraseRootFromParent_Done,
     /* 276098 */ // Label 4484: @276098
     /* 276098 */ GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(276117), // Rule ID 1870 //
     /* 276103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276107 */   // MIs[0] Operand 1
     /* 276107 */   // No operand predicates
     /* 276107 */   // (imm:{ *:[i16] }):$imm  =>  (S_MOV_B32:{ *:[i16] } (imm:{ *:[i16] }):$imm)
     /* 276107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276112 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276115 */   GIR_RootConstrainSelectedInstOperands,
     /* 276116 */   // GIR_Coverage, 1870,
     /* 276116 */   GIR_EraseRootFromParent_Done,
     /* 276117 */ // Label 4485: @276117
     /* 276117 */ GIM_Reject,
     /* 276118 */ // Label 4463: @276118
     /* 276118 */ GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(276141), // Rule ID 7263 //
     /* 276123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276127 */   // MIs[0] Operand 1
     /* 276127 */   // No operand predicates
     /* 276127 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34593),
     /* 276131 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34593>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 276131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276136 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276139 */   GIR_RootConstrainSelectedInstOperands,
     /* 276140 */   // GIR_Coverage, 7263,
     /* 276140 */   GIR_EraseRootFromParent_Done,
     /* 276141 */ // Label 4486: @276141
     /* 276141 */ GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(276160), // Rule ID 7264 //
     /* 276146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276150 */   // MIs[0] Operand 1
     /* 276150 */   // No operand predicates
     /* 276150 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 276150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276155 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276158 */   GIR_RootConstrainSelectedInstOperands,
     /* 276159 */   // GIR_Coverage, 7264,
     /* 276159 */   GIR_EraseRootFromParent_Done,
     /* 276160 */ // Label 4487: @276160
     /* 276160 */ GIM_Reject,
     /* 276161 */ // Label 4464: @276161
     /* 276161 */ GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(276184), // Rule ID 7292 //
     /* 276166 */   GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
     /* 276170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276174 */   // MIs[0] Operand 1
     /* 276174 */   // No operand predicates
     /* 276174 */   // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
     /* 276174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 276177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276179 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276182 */   GIR_RootConstrainSelectedInstOperands,
     /* 276183 */   // GIR_Coverage, 7292,
     /* 276183 */   GIR_EraseRootFromParent_Done,
     /* 276184 */ // Label 4488: @276184
     /* 276184 */ GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(276207), // Rule ID 7295 //
     /* 276189 */   GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
     /* 276193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276197 */   // MIs[0] Operand 1
     /* 276197 */   // No operand predicates
     /* 276197 */   // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
     /* 276197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 276200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276202 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276205 */   GIR_RootConstrainSelectedInstOperands,
     /* 276206 */   // GIR_Coverage, 7295,
     /* 276206 */   GIR_EraseRootFromParent_Done,
     /* 276207 */ // Label 4489: @276207
     /* 276207 */ GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(276230), // Rule ID 7298 //
     /* 276212 */   GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
     /* 276216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276220 */   // MIs[0] Operand 1
     /* 276220 */   // No operand predicates
     /* 276220 */   // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
     /* 276220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 276223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276225 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276228 */   GIR_RootConstrainSelectedInstOperands,
     /* 276229 */   // GIR_Coverage, 7298,
     /* 276229 */   GIR_EraseRootFromParent_Done,
     /* 276230 */ // Label 4490: @276230
     /* 276230 */ GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(276253), // Rule ID 7301 //
     /* 276235 */   GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
     /* 276239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276243 */   // MIs[0] Operand 1
     /* 276243 */   // No operand predicates
     /* 276243 */   // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
     /* 276243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 276246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276248 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276251 */   GIR_RootConstrainSelectedInstOperands,
     /* 276252 */   // GIR_Coverage, 7301,
     /* 276252 */   GIR_EraseRootFromParent_Done,
     /* 276253 */ // Label 4491: @276253
     /* 276253 */ GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(276276), // Rule ID 7283 //
     /* 276258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 276262 */   // MIs[0] Operand 1
     /* 276262 */   // No operand predicates
     /* 276262 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34625),
     /* 276266 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34625>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 276266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 276269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276271 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276274 */   GIR_RootConstrainSelectedInstOperands,
     /* 276275 */   // GIR_Coverage, 7283,
     /* 276275 */   GIR_EraseRootFromParent_Done,
     /* 276276 */ // Label 4492: @276276
     /* 276276 */ GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(276299), // Rule ID 7291 //
     /* 276281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 276285 */   // MIs[0] Operand 1
     /* 276285 */   // No operand predicates
     /* 276285 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34625),
     /* 276289 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34625>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 276289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 276292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276294 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276297 */   GIR_RootConstrainSelectedInstOperands,
     /* 276298 */   // GIR_Coverage, 7291,
     /* 276298 */   GIR_EraseRootFromParent_Done,
     /* 276299 */ // Label 4493: @276299
     /* 276299 */ GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(276318), // Rule ID 7285 //
     /* 276304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276308 */   // MIs[0] Operand 1
     /* 276308 */   // No operand predicates
     /* 276308 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 276308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 276311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276313 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276316 */   GIR_RootConstrainSelectedInstOperands,
     /* 276317 */   // GIR_Coverage, 7285,
     /* 276317 */   GIR_EraseRootFromParent_Done,
     /* 276318 */ // Label 4494: @276318
     /* 276318 */ GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(276337), // Rule ID 7293 //
     /* 276323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276327 */   // MIs[0] Operand 1
     /* 276327 */   // No operand predicates
     /* 276327 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 276327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 276330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276332 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 276335 */   GIR_RootConstrainSelectedInstOperands,
     /* 276336 */   // GIR_Coverage, 7293,
     /* 276336 */   GIR_EraseRootFromParent_Done,
     /* 276337 */ // Label 4495: @276337
     /* 276337 */ GIM_Reject,
     /* 276338 */ // Label 4465: @276338
     /* 276338 */ GIM_Reject,
     /* 276339 */ // Label 43: @276339
     /* 276339 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4499*/ GIMT_Encode4(276620),
     /* 276350 */ /*GILLT_s16*//*Label 4496*/ GIMT_Encode4(276362),
     /* 276354 */ /*GILLT_s32*//*Label 4497*/ GIMT_Encode4(276434),
     /* 276358 */ /*GILLT_s64*//*Label 4498*/ GIMT_Encode4(276502),
     /* 276362 */ // Label 4496: @276362
     /* 276362 */ GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(276387), // Rule ID 7278 //
     /* 276367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276371 */   // MIs[0] Operand 1
     /* 276371 */   // No operand predicates
     /* 276371 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34615),
     /* 276375 */   // (fpimm:{ *:[f16] })<<P:Predicate_anonymous_34615>>:$imm  =>  (V_MOV_B32_e32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[f16] } ?:{ *:[f16] }:$imm))
     /* 276375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276380 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 276385 */   GIR_RootConstrainSelectedInstOperands,
     /* 276386 */   // GIR_Coverage, 7278,
     /* 276386 */   GIR_EraseRootFromParent_Done,
     /* 276387 */ // Label 4500: @276387
     /* 276387 */ GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(276412), // Rule ID 7280 //
     /* 276392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276396 */   // MIs[0] Operand 1
     /* 276396 */   // No operand predicates
     /* 276396 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34615),
     /* 276400 */   // (fpimm:{ *:[f16] })<<P:Predicate_anonymous_34615>>:$imm  =>  (V_MOV_B32_e32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[f16] } ?:{ *:[f16] }:$imm))
     /* 276400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276405 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 276410 */   GIR_RootConstrainSelectedInstOperands,
     /* 276411 */   // GIR_Coverage, 7280,
     /* 276411 */   GIR_EraseRootFromParent_Done,
     /* 276412 */ // Label 4501: @276412
     /* 276412 */ GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(276433), // Rule ID 7288 //
     /* 276417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276421 */   // MIs[0] Operand 1
     /* 276421 */   // No operand predicates
     /* 276421 */   // (fpimm:{ *:[f16] }):$imm  =>  (S_MOV_B32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[i32] } ?:{ *:[f16] }:$imm))
     /* 276421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276426 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 276431 */   GIR_RootConstrainSelectedInstOperands,
     /* 276432 */   // GIR_Coverage, 7288,
     /* 276432 */   GIR_EraseRootFromParent_Done,
     /* 276433 */ // Label 4502: @276433
     /* 276433 */ GIM_Reject,
     /* 276434 */ // Label 4497: @276434
     /* 276434 */ GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(276459), // Rule ID 7289 //
     /* 276439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276443 */   // MIs[0] Operand 1
     /* 276443 */   // No operand predicates
     /* 276443 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34635),
     /* 276447 */   // (fpimm:{ *:[f32] })<<P:Predicate_anonymous_34635>>:$imm  =>  (V_MOV_B32_e32:{ *:[f32] } (bitcast_fpimm_to_i32:{ *:[f32] } ?:{ *:[f32] }:$imm))
     /* 276447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 276450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276452 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 276457 */   GIR_RootConstrainSelectedInstOperands,
     /* 276458 */   // GIR_Coverage, 7289,
     /* 276458 */   GIR_EraseRootFromParent_Done,
     /* 276459 */ // Label 4503: @276459
     /* 276459 */ GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(276480), // Rule ID 7287 //
     /* 276464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276468 */   // MIs[0] Operand 1
     /* 276468 */   // No operand predicates
     /* 276468 */   // (fpimm:{ *:[f32] }):$imm  =>  (S_MOV_B32:{ *:[f32] } (bitcast_fpimm_to_i32:{ *:[f32] } ?:{ *:[f32] }:$imm))
     /* 276468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276473 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 276478 */   GIR_RootConstrainSelectedInstOperands,
     /* 276479 */   // GIR_Coverage, 7287,
     /* 276479 */   GIR_EraseRootFromParent_Done,
     /* 276480 */ // Label 4504: @276480
     /* 276480 */ GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(276501), // Rule ID 7290 //
     /* 276485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276489 */   // MIs[0] Operand 1
     /* 276489 */   // No operand predicates
     /* 276489 */   // (fpimm:{ *:[f32] }):$imm  =>  (S_MOV_B32:{ *:[f32] } (bitcast_fpimm_to_i32:{ *:[f32] } ?:{ *:[f32] }:$imm))
     /* 276489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276494 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 276499 */   GIR_RootConstrainSelectedInstOperands,
     /* 276500 */   // GIR_Coverage, 7290,
     /* 276500 */   GIR_EraseRootFromParent_Done,
     /* 276501 */ // Label 4505: @276501
     /* 276501 */ GIM_Reject,
     /* 276502 */ // Label 4498: @276502
     /* 276502 */ GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(276527), // Rule ID 7304 //
     /* 276507 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_InlineImmFP64),
     /* 276511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276515 */   // MIs[0] Operand 1
     /* 276515 */   // No operand predicates
     /* 276515 */   // (fpimm:{ *:[f64] })<<P:Predicate_InlineImmFP64>>:$imm  =>  (S_MOV_B64:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[i64] } ?:{ *:[f64] }:$imm))
     /* 276515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 276518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276520 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 276525 */   GIR_RootConstrainSelectedInstOperands,
     /* 276526 */   // GIR_Coverage, 7304,
     /* 276526 */   GIR_EraseRootFromParent_Done,
     /* 276527 */ // Label 4506: @276527
     /* 276527 */ GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(276552), // Rule ID 7284 //
     /* 276532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 276536 */   // MIs[0] Operand 1
     /* 276536 */   // No operand predicates
     /* 276536 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34627),
     /* 276540 */   // (fpimm:{ *:[f64] })<<P:Predicate_anonymous_34627>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[f64] } ?:{ *:[f64] }:$imm))
     /* 276540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 276543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276545 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 276550 */   GIR_RootConstrainSelectedInstOperands,
     /* 276551 */   // GIR_Coverage, 7284,
     /* 276551 */   GIR_EraseRootFromParent_Done,
     /* 276552 */ // Label 4507: @276552
     /* 276552 */ GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(276577), // Rule ID 7303 //
     /* 276557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 276561 */   // MIs[0] Operand 1
     /* 276561 */   // No operand predicates
     /* 276561 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34627),
     /* 276565 */   // (fpimm:{ *:[f64] })<<P:Predicate_anonymous_34627>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[f64] } ?:{ *:[f64] }:$imm))
     /* 276565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 276568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276570 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 276575 */   GIR_RootConstrainSelectedInstOperands,
     /* 276576 */   // GIR_Coverage, 7303,
     /* 276576 */   GIR_EraseRootFromParent_Done,
     /* 276577 */ // Label 4508: @276577
     /* 276577 */ GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(276598), // Rule ID 7286 //
     /* 276582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276586 */   // MIs[0] Operand 1
     /* 276586 */   // No operand predicates
     /* 276586 */   // (fpimm:{ *:[f64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[i64] } (fpimm:{ *:[f64] }):$imm))
     /* 276586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 276589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276591 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 276596 */   GIR_RootConstrainSelectedInstOperands,
     /* 276597 */   // GIR_Coverage, 7286,
     /* 276597 */   GIR_EraseRootFromParent_Done,
     /* 276598 */ // Label 4509: @276598
     /* 276598 */ GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(276619), // Rule ID 7305 //
     /* 276603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276607 */   // MIs[0] Operand 1
     /* 276607 */   // No operand predicates
     /* 276607 */   // (fpimm:{ *:[f64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[i64] } (fpimm:{ *:[f64] }):$imm))
     /* 276607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 276610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 276612 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 276617 */   GIR_RootConstrainSelectedInstOperands,
     /* 276618 */   // GIR_Coverage, 7305,
     /* 276618 */   GIR_EraseRootFromParent_Done,
     /* 276619 */ // Label 4510: @276619
     /* 276619 */ GIM_Reject,
     /* 276620 */ // Label 4499: @276620
     /* 276620 */ GIM_Reject,
     /* 276621 */ // Label 44: @276621
     /* 276621 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4514*/ GIMT_Encode4(277423),
     /* 276632 */ /*GILLT_s16*//*Label 4511*/ GIMT_Encode4(276644),
     /* 276636 */ /*GILLT_s32*//*Label 4512*/ GIMT_Encode4(276681),
     /* 276640 */ /*GILLT_s64*//*Label 4513*/ GIMT_Encode4(276769),
     /* 276644 */ // Label 4511: @276644
     /* 276644 */ GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(276680), // Rule ID 2559 //
     /* 276649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 276652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 276655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276659 */   // (sext:{ *:[i16] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, ?:{ *:[i1] }:$src)
     /* 276659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 276662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 276676 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 276678 */   GIR_RootConstrainSelectedInstOperands,
     /* 276679 */   // GIR_Coverage, 2559,
     /* 276679 */   GIR_EraseRootFromParent_Done,
     /* 276680 */ // Label 4515: @276680
     /* 276680 */ GIM_Reject,
     /* 276681 */ // Label 4512: @276681
     /* 276681 */ GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(276704), // Rule ID 1871 //
     /* 276686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 276689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 276693 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13813),
     /* 276697 */   // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13813>>  =>  (S_SEXT_I32_I16:{ *:[i32] } ?:{ *:[i16] }:$src)
     /* 276697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SEXT_I32_I16),
     /* 276702 */   GIR_RootConstrainSelectedInstOperands,
     /* 276703 */   // GIR_Coverage, 1871,
     /* 276703 */   GIR_Done,
     /* 276704 */ // Label 4516: @276704
     /* 276704 */ GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(276735), // Rule ID 2568 //
     /* 276709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 276712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276716 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20351),
     /* 276720 */   // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_20351>>  =>  (V_BFE_I32_e64:{ *:[i32] } i16:{ *:[i16] }:$src, 0:{ *:[i32] }, 16:{ *:[i32] })
     /* 276720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
     /* 276723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276725 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 276727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 276733 */   GIR_RootConstrainSelectedInstOperands,
     /* 276734 */   // GIR_Coverage, 2568,
     /* 276734 */   GIR_EraseRootFromParent_Done,
     /* 276735 */ // Label 4517: @276735
     /* 276735 */ GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(276768), // Rule ID 7309 //
     /* 276740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 276743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 276747 */   // (sext:{ *:[i32] } i1:{ *:[i1] }:$src0)  =>  (V_CNDMASK_B32_e64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, i1:{ *:[i1] }:$src0)
     /* 276747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 276750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 276761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 276764 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 276766 */   GIR_RootConstrainSelectedInstOperands,
     /* 276767 */   // GIR_Coverage, 7309,
     /* 276767 */   GIR_EraseRootFromParent_Done,
     /* 276768 */ // Label 4518: @276768
     /* 276768 */ GIM_Reject,
     /* 276769 */ // Label 4513: @276769
     /* 276769 */ GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(276914), // Rule ID 1881 //
     /* 276774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 276777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276781 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13813),
     /* 276785 */   // (sext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13813>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (S_SEXT_I32_I16:{ *:[i32] } ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_ASHR_I32:{ *:[i1] }:{ *:[i1] } (S_SEXT_I32_I16:{ *:[i32] } ?:{ *:[i16] }:$src), (S_MOV_B32:{ *:[i1] } 31:{ *:[i32] })), SGPR_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 276785 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
     /* 276788 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276792 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276797 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/31,
     /* 276800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 276802 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 276805 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::S_SEXT_I32_I16),
     /* 276809 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276814 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 276818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 276820 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 276823 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
     /* 276827 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276832 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 276835 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 276838 */   GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
     /* 276841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 276843 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 276846 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276850 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276855 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 276858 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
     /* 276863 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 276866 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_SEXT_I32_I16),
     /* 276870 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276875 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 276879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 276881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 276884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276889 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 276892 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 276895 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 276898 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 276903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 276908 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 276913 */   // GIR_Coverage, 1881,
     /* 276913 */   GIR_EraseRootFromParent_Done,
     /* 276914 */ // Label 4519: @276914
     /* 276914 */ GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(277136), // Rule ID 2569 //
     /* 276919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 276922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 276926 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20351),
     /* 276930 */   // (sext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_20351>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFE_I32_e64:{ *:[i32] } ?:{ *:[i16] }:$src, (S_MOV_B32:{ *:[i16] } 0:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 16:{ *:[i32] })), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (V_ASHRREV_I32_e32:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 31:{ *:[i32] }), (V_BFE_I32_e64:{ *:[i32] } ?:{ *:[i16] }:$src, (S_MOV_B32:{ *:[i16] } 0:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 16:{ *:[i32] }))), VGPR_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 276930 */   GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s16,
     /* 276933 */   GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276937 */   GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276942 */   GIR_AddImm8, /*InsnID*/9, /*Imm*/16,
     /* 276945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 276947 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /* 276950 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276954 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276959 */   GIR_AddImm8, /*InsnID*/8, /*Imm*/0,
     /* 276962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 276964 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 276967 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
     /* 276971 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276976 */   GIR_Copy, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 276980 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 276983 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
     /* 276986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 276988 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
     /* 276991 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 276995 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277000 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
     /* 277003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 277005 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 277008 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e32),
     /* 277012 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277017 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 277020 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 277023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 277025 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 277028 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277032 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277037 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 277040 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277045 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 277048 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 277052 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277057 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/16,
     /* 277060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 277062 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 277065 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 277069 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277074 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 277077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277079 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 277082 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
     /* 277086 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277091 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 277095 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277098 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 277101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 277106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277111 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 277114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 277117 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 277120 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 277125 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277130 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277135 */   // GIR_Coverage, 2569,
     /* 277135 */   GIR_EraseRootFromParent_Done,
     /* 277136 */ // Label 4520: @277136
     /* 277136 */ GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(277228), // Rule ID 7394 //
     /* 277141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 277144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 277148 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13813),
     /* 277152 */   // (sext:{ *:[i64] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_13813>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_ASHR_I32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i32] }:$src, 31:{ *:[i32] }), SReg_32_XM0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 277152 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 277155 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
     /* 277159 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277164 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 277168 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 277171 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for AMDGPU::SCC*/0,
     /* 277174 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 277179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277188 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277191 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 277196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 277199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277201 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 277203 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 277206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277209 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 277212 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 277217 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 277222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 277227 */   // GIR_Coverage, 7394,
     /* 277227 */   GIR_EraseRootFromParent_Done,
     /* 277228 */ // Label 4521: @277228
     /* 277228 */ GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(277317), // Rule ID 7395 //
     /* 277233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 277236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 277240 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20351),
     /* 277244 */   // (sext:{ *:[i64] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_20351>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (V_ASHRREV_I32_e64:{ *:[i16] } 31:{ *:[i32] }, ?:{ *:[i32] }:$src), VGPR_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 277244 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 277247 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 277251 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277256 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 277259 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 277263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277265 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 277268 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277272 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277277 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277280 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 277288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 277292 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 277295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277298 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 277301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 277306 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277311 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277316 */   // GIR_Coverage, 7395,
     /* 277316 */   GIR_EraseRootFromParent_Done,
     /* 277317 */ // Label 4522: @277317
     /* 277317 */ GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(277422), // Rule ID 7396 //
     /* 277322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 277325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 277329 */   // (sext:{ *:[i64] } i1:{ *:[i1] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub1:{ *:[i32] })
     /* 277329 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 277332 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 277336 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277341 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 277344 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 277347 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 277350 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/uint8_t(-1),
     /* 277353 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 277357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 277362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 277366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277371 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 277374 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 277377 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 277380 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 277383 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 277387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 277392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277394 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277397 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 277400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 277403 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 277406 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 277411 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277421 */   // GIR_Coverage, 7396,
     /* 277421 */   GIR_EraseRootFromParent_Done,
     /* 277422 */ // Label 4523: @277422
     /* 277422 */ GIM_Reject,
     /* 277423 */ // Label 4514: @277423
     /* 277423 */ GIM_Reject,
     /* 277424 */ // Label 45: @277424
     /* 277424 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4527*/ GIMT_Encode4(280626),
     /* 277435 */ /*GILLT_s16*//*Label 4524*/ GIMT_Encode4(277447),
     /* 277439 */ /*GILLT_s32*//*Label 4525*/ GIMT_Encode4(277484),
     /* 277443 */ /*GILLT_s64*//*Label 4526*/ GIMT_Encode4(278772),
     /* 277447 */ // Label 4524: @277447
     /* 277447 */ GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(277483), // Rule ID 2557 //
     /* 277452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 277455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 277458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277462 */   // (zext:{ *:[i16] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src)
     /* 277462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 277465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 277479 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 277481 */   GIR_RootConstrainSelectedInstOperands,
     /* 277482 */   // GIR_Coverage, 2557,
     /* 277482 */   GIR_EraseRootFromParent_Done,
     /* 277483 */ // Label 4528: @277483
     /* 277483 */ GIM_Reject,
     /* 277484 */ // Label 4525: @277484
     /* 277484 */ GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(277560), // Rule ID 2554 //
     /* 277489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 277492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 277507 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 277511 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 277515 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277519 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 277523 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 277527 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 277531 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277535 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277539 */   // MIs[3] Operand 1
     /* 277539 */   // No operand predicates
     /* 277539 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 277543 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277545 */   // (zext:{ *:[i32] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (V_ASHRREV_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 277545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 277548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277550 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 277554 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 277558 */   GIR_RootConstrainSelectedInstOperands,
     /* 277559 */   // GIR_Coverage, 2554,
     /* 277559 */   GIR_EraseRootFromParent_Done,
     /* 277560 */ // Label 4529: @277560
     /* 277560 */ GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(277636), // Rule ID 2550 //
     /* 277565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 277568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277575 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277579 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 277583 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 277587 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 277591 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277595 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 277599 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 277603 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 277607 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277611 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277615 */   // MIs[3] Operand 1
     /* 277615 */   // No operand predicates
     /* 277615 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 277619 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277621 */   // (zext:{ *:[i32] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (V_LSHRREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 277621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 277624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277626 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 277630 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 277634 */   GIR_RootConstrainSelectedInstOperands,
     /* 277635 */   // GIR_Coverage, 2550,
     /* 277635 */   GIR_EraseRootFromParent_Done,
     /* 277636 */ // Label 4530: @277636
     /* 277636 */ GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(277712), // Rule ID 2546 //
     /* 277641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 277644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277651 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277655 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 277659 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 277663 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 277667 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277671 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 277675 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 277679 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 277683 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277687 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277691 */   // MIs[3] Operand 1
     /* 277691 */   // No operand predicates
     /* 277691 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 277695 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277697 */   // (zext:{ *:[i32] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (V_LSHLREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 277697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 277700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277702 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 277706 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 277710 */   GIR_RootConstrainSelectedInstOperands,
     /* 277711 */   // GIR_Coverage, 2546,
     /* 277711 */   GIR_EraseRootFromParent_Done,
     /* 277712 */ // Label 4531: @277712
     /* 277712 */ GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(277776), // Rule ID 2532 //
     /* 277717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 277720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 277735 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 277739 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 277743 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277747 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277751 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /* 277755 */   // MIs[2] Operand 1
     /* 277755 */   // No operand predicates
     /* 277755 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277757 */   // (zext:{ *:[i32] } (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1))  =>  (V_SUB_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1))
     /* 277757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /* 277760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277762 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 277766 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /* 277771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277774 */   GIR_RootConstrainSelectedInstOperands,
     /* 277775 */   // GIR_Coverage, 2532,
     /* 277775 */   GIR_EraseRootFromParent_Done,
     /* 277776 */ // Label 4532: @277776
     /* 277776 */ GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(277847), // Rule ID 2570 //
     /* 277781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 277784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277791 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277795 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 277799 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 277803 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 277807 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277811 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 277815 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 277819 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 277823 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277825 */   // (zext:{ *:[i32] } (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MAD_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, VSrc_b16:{ *:[i16] }:$src2)
     /* 277825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
     /* 277828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277830 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 277834 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 277838 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 277842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277845 */   GIR_RootConstrainSelectedInstOperands,
     /* 277846 */   // GIR_Coverage, 2570,
     /* 277846 */   GIR_EraseRootFromParent_Done,
     /* 277847 */ // Label 4533: @277847
     /* 277847 */ GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(277918), // Rule ID 8481 //
     /* 277852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 277855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 277870 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 277874 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 277878 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277882 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 277886 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 277890 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 277894 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277896 */   // (zext:{ *:[i32] } (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MAD_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, VSrc_b16:{ *:[i16] }:$src2)
     /* 277896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
     /* 277899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277901 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 277905 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 277909 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 277913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277916 */   GIR_RootConstrainSelectedInstOperands,
     /* 277917 */   // GIR_Coverage, 8481,
     /* 277917 */   GIR_EraseRootFromParent_Done,
     /* 277918 */ // Label 4534: @277918
     /* 277918 */ GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(277988), // Rule ID 7454 //
     /* 277923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX8Plus),
     /* 277926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 277933 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277937 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 277941 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 277945 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277947 */   // (zext:{ *:[i32] } (bswap:{ *:[i16] } i16:{ *:[i16] }:$a))  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 277947 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 277950 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 277954 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277959 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
     /* 277969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 277974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277979 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 277983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277986 */   GIR_RootConstrainSelectedInstOperands,
     /* 277987 */   // GIR_Coverage, 7454,
     /* 277987 */   GIR_EraseRootFromParent_Done,
     /* 277988 */ // Label 4535: @277988
     /* 277988 */ GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(278058), // Rule ID 7456 //
     /* 277993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX8Plus),
     /* 277996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 277999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278003 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278007 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 278011 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278015 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278017 */   // (zext:{ *:[i32] } (bswap:{ *:[i16] } i16:{ *:[i16] }:$a))  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 278017 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 278020 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 278024 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278029 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
     /* 278039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 278044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278049 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 278053 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278056 */   GIR_RootConstrainSelectedInstOperands,
     /* 278057 */   // GIR_Coverage, 7456,
     /* 278057 */   GIR_EraseRootFromParent_Done,
     /* 278058 */ // Label 4536: @278058
     /* 278058 */ GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(278145), // Rule ID 7458 //
     /* 278063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX8Plus),
     /* 278066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278073 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278077 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 278081 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278085 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278087 */   // (zext:{ *:[i32] } (bswap:{ *:[i16] } i16:{ *:[i16] }:$a))  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, (COPY:{ *:[i16] } VGPR_16:{ *:[i16] }:$a), (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 278087 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 278090 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 278094 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278099 */   GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(202113025),
     /* 278109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 278114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278123 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 278127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 278132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278137 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278140 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 278143 */   GIR_RootConstrainSelectedInstOperands,
     /* 278144 */   // GIR_Coverage, 7458,
     /* 278144 */   GIR_EraseRootFromParent_Done,
     /* 278145 */ // Label 4537: @278145
     /* 278145 */ GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(278196), // Rule ID 2520 //
     /* 278150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278160 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278164 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278168 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278172 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278176 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278178 */   // (zext:{ *:[i32] } (add:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_ADD_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
     /* 278181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278183 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278187 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278194 */   GIR_RootConstrainSelectedInstOperands,
     /* 278195 */   // GIR_Coverage, 2520,
     /* 278195 */   GIR_EraseRootFromParent_Done,
     /* 278196 */ // Label 4538: @278196
     /* 278196 */ GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(278244), // Rule ID 2553 //
     /* 278201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278211 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278215 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 278219 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278223 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278227 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278229 */   // (zext:{ *:[i32] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_ASHRREV_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 278232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278234 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 278238 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 278242 */   GIR_RootConstrainSelectedInstOperands,
     /* 278243 */   // GIR_Coverage, 2553,
     /* 278243 */   GIR_EraseRootFromParent_Done,
     /* 278244 */ // Label 4539: @278244
     /* 278244 */ GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(278292), // Rule ID 2549 //
     /* 278249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278259 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278263 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 278267 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278271 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278275 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278277 */   // (zext:{ *:[i32] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_LSHRREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 278280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278282 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 278286 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 278290 */   GIR_RootConstrainSelectedInstOperands,
     /* 278291 */   // GIR_Coverage, 2549,
     /* 278291 */   GIR_EraseRootFromParent_Done,
     /* 278292 */ // Label 4540: @278292
     /* 278292 */ GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(278340), // Rule ID 2533 //
     /* 278297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278307 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278311 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 278315 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278319 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278323 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278325 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MUL_LO_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_e64),
     /* 278328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278330 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278334 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278338 */   GIR_RootConstrainSelectedInstOperands,
     /* 278339 */   // GIR_Coverage, 2533,
     /* 278339 */   GIR_EraseRootFromParent_Done,
     /* 278340 */ // Label 4541: @278340
     /* 278340 */ GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(278388), // Rule ID 2545 //
     /* 278345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278355 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 278363 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278367 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278371 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278373 */   // (zext:{ *:[i32] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_LSHLREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 278376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278378 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 278382 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 278386 */   GIR_RootConstrainSelectedInstOperands,
     /* 278387 */   // GIR_Coverage, 2545,
     /* 278387 */   GIR_EraseRootFromParent_Done,
     /* 278388 */ // Label 4542: @278388
     /* 278388 */ GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(278436), // Rule ID 2539 //
     /* 278393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278403 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278407 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 278411 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278415 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278419 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278421 */   // (zext:{ *:[i32] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAX_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_e64),
     /* 278424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278426 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278430 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278434 */   GIR_RootConstrainSelectedInstOperands,
     /* 278435 */   // GIR_Coverage, 2539,
     /* 278435 */   GIR_EraseRootFromParent_Done,
     /* 278436 */ // Label 4543: @278436
     /* 278436 */ GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(278484), // Rule ID 2537 //
     /* 278441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278451 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278455 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 278459 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278463 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278467 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278469 */   // (zext:{ *:[i32] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MIN_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_e64),
     /* 278472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278474 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278478 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278482 */   GIR_RootConstrainSelectedInstOperands,
     /* 278483 */   // GIR_Coverage, 2537,
     /* 278483 */   GIR_EraseRootFromParent_Done,
     /* 278484 */ // Label 4544: @278484
     /* 278484 */ GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(278535), // Rule ID 2535 //
     /* 278489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 278507 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278511 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278515 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278517 */   // (zext:{ *:[i32] } (sub:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_SUB_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /* 278520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278522 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278526 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278533 */   GIR_RootConstrainSelectedInstOperands,
     /* 278534 */   // GIR_Coverage, 2535,
     /* 278534 */   GIR_EraseRootFromParent_Done,
     /* 278535 */ // Label 4545: @278535
     /* 278535 */ GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(278583), // Rule ID 2543 //
     /* 278540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278550 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278554 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 278558 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278562 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278566 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278568 */   // (zext:{ *:[i32] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAX_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_e64),
     /* 278571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278573 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278577 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278581 */   GIR_RootConstrainSelectedInstOperands,
     /* 278582 */   // GIR_Coverage, 2543,
     /* 278582 */   GIR_EraseRootFromParent_Done,
     /* 278583 */ // Label 4546: @278583
     /* 278583 */ GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(278631), // Rule ID 2541 //
     /* 278588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278598 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278602 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 278606 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278610 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278614 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278616 */   // (zext:{ *:[i32] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MIN_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 278616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_e64),
     /* 278619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278621 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 278625 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 278629 */   GIR_RootConstrainSelectedInstOperands,
     /* 278630 */   // GIR_Coverage, 2541,
     /* 278630 */   GIR_EraseRootFromParent_Done,
     /* 278631 */ // Label 4547: @278631
     /* 278631 */ GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(278686), // Rule ID 1882 //
     /* 278636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 278643 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13825),
     /* 278647 */   // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13825>>  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } (S_MOV_B32:{ *:[i1] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src)
     /* 278647 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 278650 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 278654 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278659 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 278669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 278674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 278676 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278679 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 278681 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 278684 */   GIR_RootConstrainSelectedInstOperands,
     /* 278685 */   // GIR_Coverage, 1882,
     /* 278685 */   GIR_EraseRootFromParent_Done,
     /* 278686 */ // Label 4548: @278686
     /* 278686 */ GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(278738), // Rule ID 7435 //
     /* 278691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278698 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34808),
     /* 278702 */   // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_34808>>  =>  (V_AND_B32_e64:{ *:[i32] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src)
     /* 278702 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 278705 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 278709 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278714 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 278724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 278729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278731 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278734 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 278736 */   GIR_RootConstrainSelectedInstOperands,
     /* 278737 */   // GIR_Coverage, 7435,
     /* 278737 */   GIR_EraseRootFromParent_Done,
     /* 278738 */ // Label 4549: @278738
     /* 278738 */ GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(278771), // Rule ID 7310 //
     /* 278743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 278746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278750 */   // (zext:{ *:[i32] } i1:{ *:[i1] }:$src0)  =>  (V_CNDMASK_B32_e64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, i1:{ *:[i1] }:$src0)
     /* 278750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 278753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 278767 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 278769 */   GIR_RootConstrainSelectedInstOperands,
     /* 278770 */   // GIR_Coverage, 7310,
     /* 278770 */   GIR_EraseRootFromParent_Done,
     /* 278771 */ // Label 4550: @278771
     /* 278771 */ GIM_Reject,
     /* 278772 */ // Label 4526: @278772
     /* 278772 */ GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(278905), // Rule ID 2556 //
     /* 278777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 278787 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278791 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 278795 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278799 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278803 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278807 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 278811 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 278815 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 278819 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 278823 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278827 */   // MIs[3] Operand 1
     /* 278827 */   // No operand predicates
     /* 278827 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 278831 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278833 */   // (zext:{ *:[i64] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_ASHRREV_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 278833 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 278836 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 278840 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278845 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 278848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278850 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 278853 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 278857 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278862 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 278866 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 278870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 278875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 278877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278880 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 278883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 278886 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 278889 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 278894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278899 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 278904 */   // GIR_Coverage, 2556,
     /* 278904 */   GIR_EraseRootFromParent_Done,
     /* 278905 */ // Label 4551: @278905
     /* 278905 */ GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(279038), // Rule ID 2552 //
     /* 278910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 278913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 278916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 278920 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278924 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 278928 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 278932 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 278936 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278940 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 278944 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 278948 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 278952 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 278956 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278960 */   // MIs[3] Operand 1
     /* 278960 */   // No operand predicates
     /* 278960 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 278964 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278966 */   // (zext:{ *:[i64] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHRREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 278966 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 278969 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 278973 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278978 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 278981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278983 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 278986 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 278990 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278995 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 278999 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 279003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279013 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279019 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279022 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279032 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279037 */   // GIR_Coverage, 2552,
     /* 279037 */   GIR_EraseRootFromParent_Done,
     /* 279038 */ // Label 4552: @279038
     /* 279038 */ GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(279171), // Rule ID 2548 //
     /* 279043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 279061 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279065 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279069 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279073 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 279077 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 279081 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 279085 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 279089 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279093 */   // MIs[3] Operand 1
     /* 279093 */   // No operand predicates
     /* 279093 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 279097 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279099 */   // (zext:{ *:[i64] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHLREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279099 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279102 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279106 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279111 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279114 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279116 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279119 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 279123 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279128 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 279132 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 279136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279146 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279149 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279152 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279170 */   // GIR_Coverage, 2548,
     /* 279170 */   GIR_EraseRootFromParent_Done,
     /* 279171 */ // Label 4553: @279171
     /* 279171 */ GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(279279), // Rule ID 2521 //
     /* 279176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 279194 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279198 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279202 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279204 */   // (zext:{ *:[i64] } (add:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_ADD_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279204 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279207 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279211 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279216 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279221 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279224 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
     /* 279228 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279233 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 279237 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 279241 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 279244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279254 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279260 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279263 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279268 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279273 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279278 */   // GIR_Coverage, 2521,
     /* 279278 */   GIR_EraseRootFromParent_Done,
     /* 279279 */ // Label 4554: @279279
     /* 279279 */ GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(279384), // Rule ID 2555 //
     /* 279284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279294 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279298 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 279302 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279306 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279310 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279312 */   // (zext:{ *:[i64] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_ASHRREV_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279312 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279315 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279319 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279324 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 279336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279341 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 279345 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 279349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279356 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279359 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279365 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279368 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279373 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279383 */   // GIR_Coverage, 2555,
     /* 279383 */   GIR_EraseRootFromParent_Done,
     /* 279384 */ // Label 4555: @279384
     /* 279384 */ GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(279489), // Rule ID 2551 //
     /* 279389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279399 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279403 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 279407 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279411 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279415 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279417 */   // (zext:{ *:[i64] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHRREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279417 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279420 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279424 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279429 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 279441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279446 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 279450 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 279454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279464 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279467 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279470 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279473 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279478 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279488 */   // GIR_Coverage, 2551,
     /* 279488 */   GIR_EraseRootFromParent_Done,
     /* 279489 */ // Label 4556: @279489
     /* 279489 */ GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(279594), // Rule ID 2534 //
     /* 279494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279504 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279508 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 279512 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279516 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279522 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MUL_LO_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279522 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279525 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279529 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279534 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_e64),
     /* 279546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279551 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 279555 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 279559 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279569 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279575 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279588 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279593 */   // GIR_Coverage, 2534,
     /* 279593 */   GIR_EraseRootFromParent_Done,
     /* 279594 */ // Label 4557: @279594
     /* 279594 */ GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(279699), // Rule ID 2547 //
     /* 279599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279609 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279613 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 279617 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279621 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279625 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279627 */   // (zext:{ *:[i64] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHLREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279627 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279630 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279634 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279639 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279644 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279647 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 279651 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279656 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 279660 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 279664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279671 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279674 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279680 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279683 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279688 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279698 */   // GIR_Coverage, 2547,
     /* 279698 */   GIR_EraseRootFromParent_Done,
     /* 279699 */ // Label 4558: @279699
     /* 279699 */ GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(279804), // Rule ID 2540 //
     /* 279704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279714 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279718 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 279722 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279726 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279730 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279732 */   // (zext:{ *:[i64] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MAX_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279732 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279735 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279739 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279744 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_e64),
     /* 279756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279761 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 279765 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 279769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279779 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279782 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279785 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279788 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279793 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279798 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279803 */   // GIR_Coverage, 2540,
     /* 279803 */   GIR_EraseRootFromParent_Done,
     /* 279804 */ // Label 4559: @279804
     /* 279804 */ GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(279909), // Rule ID 2538 //
     /* 279809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279819 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279823 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 279827 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279831 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279835 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279837 */   // (zext:{ *:[i64] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MIN_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279837 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279840 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279844 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279849 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279854 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279857 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_e64),
     /* 279861 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279866 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 279870 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 279874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279881 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279884 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279887 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279890 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279898 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279908 */   // GIR_Coverage, 2538,
     /* 279908 */   GIR_EraseRootFromParent_Done,
     /* 279909 */ // Label 4560: @279909
     /* 279909 */ GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(280017), // Rule ID 2536 //
     /* 279914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 279917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279924 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279928 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 279932 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279936 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 279940 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279942 */   // (zext:{ *:[i64] } (sub:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_SUB_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279942 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279945 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279949 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279954 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279959 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279962 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /* 279966 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279971 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 279975 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 279979 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 279982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279992 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279998 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280001 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280016 */   // GIR_Coverage, 2536,
     /* 280016 */   GIR_EraseRootFromParent_Done,
     /* 280017 */ // Label 4561: @280017
     /* 280017 */ GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(280122), // Rule ID 2544 //
     /* 280022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 280025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 280040 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280044 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 280048 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280050 */   // (zext:{ *:[i64] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MAX_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280050 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 280053 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280057 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280062 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 280065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280067 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280070 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_e64),
     /* 280074 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280079 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 280083 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 280087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280097 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280100 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 280103 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280111 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280121 */   // GIR_Coverage, 2544,
     /* 280121 */   GIR_EraseRootFromParent_Done,
     /* 280122 */ // Label 4562: @280122
     /* 280122 */ GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(280227), // Rule ID 2542 //
     /* 280127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 280130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280137 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280141 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 280145 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280149 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 280153 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280155 */   // (zext:{ *:[i64] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MIN_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280155 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 280158 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280162 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280167 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 280170 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280172 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280175 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_e64),
     /* 280179 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280184 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 280188 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 280192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280199 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280202 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280205 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 280208 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280211 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280221 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280226 */   // GIR_Coverage, 2542,
     /* 280226 */   GIR_EraseRootFromParent_Done,
     /* 280227 */ // Label 4563: @280227
     /* 280227 */ GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(280361), // Rule ID 1880 //
     /* 280232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280239 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13825),
     /* 280243 */   // (zext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13825>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i16] }:$src, (S_MOV_B32:{ *:[i1] } 65535:{ *:[i32] })), SGPR_32:{ *:[i32] }), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280243 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s1,
     /* 280246 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280250 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280255 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 280258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280260 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 280263 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280267 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280272 */   GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(65535),
     /* 280282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280284 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 280287 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 280291 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280296 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 280300 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 280303 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for AMDGPU::SCC*/0,
     /* 280306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280308 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 280311 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280315 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280320 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280323 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
     /* 280328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280333 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280336 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 280342 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280345 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280350 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 280355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 280360 */   // GIR_Coverage, 1880,
     /* 280360 */   GIR_EraseRootFromParent_Done,
     /* 280361 */ // Label 4564: @280361
     /* 280361 */ GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(280472), // Rule ID 7436 //
     /* 280366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280373 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34808),
     /* 280377 */   // (zext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_34808>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_AND_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280377 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 280380 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280384 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280389 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 280392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280394 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 280397 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280401 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280406 */   GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(65535),
     /* 280416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280418 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280421 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 280425 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280430 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280433 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 280437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280447 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 280453 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280456 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280466 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280471 */   // GIR_Coverage, 7436,
     /* 280471 */   GIR_EraseRootFromParent_Done,
     /* 280472 */ // Label 4565: @280472
     /* 280472 */ GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(280533), // Rule ID 7390 //
     /* 280477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 280480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280484 */   // (zext:{ *:[i64] } i32:{ *:[i32] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 280487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280496 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 280499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280506 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 280508 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280514 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 280527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 280532 */   // GIR_Coverage, 7390,
     /* 280532 */   GIR_EraseRootFromParent_Done,
     /* 280533 */ // Label 4566: @280533
     /* 280533 */ GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(280625), // Rule ID 7392 //
     /* 280538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 280541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280545 */   // (zext:{ *:[i64] } i1:{ *:[i1] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 280545 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 280548 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280552 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280557 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 280560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280562 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280565 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 280569 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280574 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 280577 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 280580 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 280583 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280586 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 280590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 280595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280600 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 280603 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 280606 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 280609 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280614 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280619 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280624 */   // GIR_Coverage, 7392,
     /* 280624 */   GIR_EraseRootFromParent_Done,
     /* 280625 */ // Label 4567: @280625
     /* 280625 */ GIM_Reject,
     /* 280626 */ // Label 4527: @280626
     /* 280626 */ GIM_Reject,
     /* 280627 */ // Label 46: @280627
     /* 280627 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4572*/ GIMT_Encode4(282162),
     /* 280638 */ /*GILLT_s16*//*Label 4568*/ GIMT_Encode4(280654),
     /* 280642 */ /*GILLT_s32*//*Label 4569*/ GIMT_Encode4(280965),
     /* 280646 */ /*GILLT_s64*//*Label 4570*/ GIMT_Encode4(281606),
     /* 280650 */ /*GILLT_v2s16*//*Label 4571*/ GIMT_Encode4(281993),
     /* 280654 */ // Label 4568: @280654
     /* 280654 */ GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(280964),
     /* 280659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 280665 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(280751), // Rule ID 843 //
     /* 280670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 280673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 280677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 280685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 280693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280701 */     // MIs[2] Operand 1
     /* 280701 */     // No operand predicates
     /* 280701 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 280705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 280714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 280721 */     // (shl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHLREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 280721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_t16_e64),
     /* 280724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 280731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 280736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 280741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 280746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280749 */     GIR_RootConstrainSelectedInstOperands,
     /* 280750 */     // GIR_Coverage, 843,
     /* 280750 */     GIR_EraseRootFromParent_Done,
     /* 280751 */   // Label 4574: @280751
     /* 280751 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(280807), // Rule ID 842 //
     /* 280756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 280759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 280763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 280770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 280777 */     // (shl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LSHLREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 280777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_t16_e64),
     /* 280780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 280787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 280792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 280797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 280802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280805 */     GIR_RootConstrainSelectedInstOperands,
     /* 280806 */     // GIR_Coverage, 842,
     /* 280806 */     GIR_EraseRootFromParent_Done,
     /* 280807 */   // Label 4575: @280807
     /* 280807 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(280862), // Rule ID 841 //
     /* 280812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 280815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 280827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 280835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280843 */     // MIs[2] Operand 1
     /* 280843 */     // No operand predicates
     /* 280843 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 280847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280849 */     // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHLREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 280849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 280852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 280858 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 280860 */     GIR_RootConstrainSelectedInstOperands,
     /* 280861 */     // GIR_Coverage, 841,
     /* 280861 */     GIR_EraseRootFromParent_Done,
     /* 280862 */   // Label 4576: @280862
     /* 280862 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(280917), // Rule ID 845 //
     /* 280867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 280870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 280882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 280890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280898 */     // MIs[2] Operand 1
     /* 280898 */     // No operand predicates
     /* 280898 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 280902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280904 */     // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHLREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 280904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_fake16_e64),
     /* 280907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 280913 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 280915 */     GIR_RootConstrainSelectedInstOperands,
     /* 280916 */     // GIR_Coverage, 845,
     /* 280916 */     GIR_EraseRootFromParent_Done,
     /* 280917 */   // Label 4577: @280917
     /* 280917 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(280940), // Rule ID 840 //
     /* 280922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 280925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280929 */     // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHLREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 280929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 280932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 280936 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 280938 */     GIR_RootConstrainSelectedInstOperands,
     /* 280939 */     // GIR_Coverage, 840,
     /* 280939 */     GIR_EraseRootFromParent_Done,
     /* 280940 */   // Label 4578: @280940
     /* 280940 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(280963), // Rule ID 844 //
     /* 280945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 280948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280952 */     // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHLREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 280952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_fake16_e64),
     /* 280955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280957 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 280959 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 280961 */     GIR_RootConstrainSelectedInstOperands,
     /* 280962 */     // GIR_Coverage, 844,
     /* 280962 */     GIR_EraseRootFromParent_Done,
     /* 280963 */   // Label 4579: @280963
     /* 280963 */   GIM_Reject,
     /* 280964 */ // Label 4573: @280964
     /* 280964 */ GIM_Reject,
     /* 280965 */ // Label 4569: @280965
     /* 280965 */ GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(281605),
     /* 280970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 280973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 280976 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(281044), // Rule ID 7561 //
     /* 280981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 280985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 280993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 281009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 281013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 281017 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /* 281021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 281025 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34974),
     /* 281029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281031 */     // (shl:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] }), i32:{ *:[i32] }:$b)<<P:Predicate_anonymous_34974>>  =>  (S_BFM_B32:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /* 281031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BFM_B32),
     /* 281034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 281036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // a
     /* 281040 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 281042 */     GIR_RootConstrainSelectedInstOperands,
     /* 281043 */     // GIR_Coverage, 7561,
     /* 281043 */     GIR_EraseRootFromParent_Done,
     /* 281044 */   // Label 4581: @281044
     /* 281044 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(281112), // Rule ID 7563 //
     /* 281049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 281061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 281077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 281081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 281085 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /* 281089 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 281093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34976),
     /* 281097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281099 */     // (shl:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] }), i32:{ *:[i32] }:$b)<<P:Predicate_anonymous_34976>>  =>  (V_BFM_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /* 281099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFM_B32_e64),
     /* 281102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // a
     /* 281108 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 281110 */     GIR_RootConstrainSelectedInstOperands,
     /* 281111 */     // GIR_Coverage, 7563,
     /* 281111 */     GIR_EraseRootFromParent_Done,
     /* 281112 */   // Label 4582: @281112
     /* 281112 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(281207), // Rule ID 2592 //
     /* 281117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 281120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 281132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281140 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 281142 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /* 281146 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /* 281150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 281154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 281162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 281166 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/2, // Name : pred:2:z
     /* 281170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281178 */     // MIs[3] Operand 1
     /* 281178 */     // No operand predicates
     /* 281178 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 281182 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20811),
     /* 281186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281188 */     // (shl:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:2:x, i32:{ *:[i32] }:$src1:$pred:2:y)<<P:Predicate_anonymous_20812>>, (and:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:2:z, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:2:Predicate_anonymous_20811>>  =>  (V_ADD_LSHL_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 281188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_LSHL_U32_e64),
     /* 281191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 281197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 281201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 281205 */     GIR_RootConstrainSelectedInstOperands,
     /* 281206 */     // GIR_Coverage, 2592,
     /* 281206 */     GIR_EraseRootFromParent_Done,
     /* 281207 */   // Label 4583: @281207
     /* 281207 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(281275), // Rule ID 69 //
     /* 281212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281249 */     // MIs[2] Operand 1
     /* 281249 */     // No operand predicates
     /* 281249 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 281253 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13788),
     /* 281257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281259 */     // (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_13788>>  =>  (S_LSHL_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 281259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /* 281262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 281264 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 281266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 281270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 281273 */     GIR_RootConstrainSelectedInstOperands,
     /* 281274 */     // GIR_Coverage, 69,
     /* 281274 */     GIR_EraseRootFromParent_Done,
     /* 281275 */   // Label 4584: @281275
     /* 281275 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(281331), // Rule ID 2491 //
     /* 281280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281308 */     // MIs[2] Operand 1
     /* 281308 */     // No operand predicates
     /* 281308 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 281312 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19682),
     /* 281316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281318 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_19682>>  =>  (V_LSHLREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 281318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 281321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 281327 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 281329 */     GIR_RootConstrainSelectedInstOperands,
     /* 281330 */     // GIR_Coverage, 2491,
     /* 281330 */     GIR_EraseRootFromParent_Done,
     /* 281331 */   // Label 4585: @281331
     /* 281331 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(281396), // Rule ID 2591 //
     /* 281336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 281339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 281351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281359 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 281361 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /* 281365 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /* 281369 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:2:z
     /* 281373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20811),
     /* 281377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281379 */     // (shl:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:2:x, i32:{ *:[i32] }:$src1:$pred:2:y)<<P:Predicate_anonymous_20812>>, i32:{ *:[i32] }:$src2:$pred:2:z)<<P:2:Predicate_anonymous_20811>>  =>  (V_ADD_LSHL_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 281379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_LSHL_U32_e64),
     /* 281382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 281388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 281392 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 281394 */     GIR_RootConstrainSelectedInstOperands,
     /* 281395 */     // GIR_Coverage, 2591,
     /* 281395 */     GIR_EraseRootFromParent_Done,
     /* 281396 */   // Label 4586: @281396
     /* 281396 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(281430), // Rule ID 68 //
     /* 281401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281413 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13788),
     /* 281417 */     // (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13788>>  =>  (S_LSHL_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 281417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /* 281422 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 281428 */     GIR_RootConstrainSelectedInstOperands,
     /* 281429 */     // GIR_Coverage, 68,
     /* 281429 */     GIR_Done,
     /* 281430 */   // Label 4587: @281430
     /* 281430 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(281454), // Rule ID 2490 //
     /* 281435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281439 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19682),
     /* 281443 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19682>>  =>  (V_LSHLREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 281443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 281446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281448 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 281450 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 281452 */     GIR_RootConstrainSelectedInstOperands,
     /* 281453 */     // GIR_Coverage, 2490,
     /* 281453 */     GIR_EraseRootFromParent_Done,
     /* 281454 */   // Label 4588: @281454
     /* 281454 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(281506), // Rule ID 813 //
     /* 281459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281487 */     // MIs[2] Operand 1
     /* 281487 */     // No operand predicates
     /* 281487 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 281491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281493 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHLREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 281493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 281496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 281502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 281504 */     GIR_RootConstrainSelectedInstOperands,
     /* 281505 */     // GIR_Coverage, 813,
     /* 281505 */     GIR_EraseRootFromParent_Done,
     /* 281506 */   // Label 4589: @281506
     /* 281506 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(281561), // Rule ID 839 //
     /* 281511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 281514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281542 */     // MIs[2] Operand 1
     /* 281542 */     // No operand predicates
     /* 281542 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 281546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281548 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 281548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B32_e64),
     /* 281551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281553 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 281555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 281559 */     GIR_RootConstrainSelectedInstOperands,
     /* 281560 */     // GIR_Coverage, 839,
     /* 281560 */     GIR_EraseRootFromParent_Done,
     /* 281561 */   // Label 4590: @281561
     /* 281561 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(281581), // Rule ID 812 //
     /* 281566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281570 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_LSHLREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 281570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 281573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281575 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 281577 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 281579 */     GIR_RootConstrainSelectedInstOperands,
     /* 281580 */     // GIR_Coverage, 812,
     /* 281580 */     GIR_EraseRootFromParent_Done,
     /* 281581 */   // Label 4591: @281581
     /* 281581 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(281604), // Rule ID 838 //
     /* 281586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 281589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281593 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_LSHL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 281593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B32_e64),
     /* 281598 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 281602 */     GIR_RootConstrainSelectedInstOperands,
     /* 281603 */     // GIR_Coverage, 838,
     /* 281603 */     GIR_Done,
     /* 281604 */   // Label 4592: @281604
     /* 281604 */   GIM_Reject,
     /* 281605 */ // Label 4580: @281605
     /* 281605 */ GIM_Reject,
     /* 281606 */ // Label 4570: @281606
     /* 281606 */ GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(281992),
     /* 281611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 281614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 281617 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(281685), // Rule ID 71 //
     /* 281622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 281626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 281630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281659 */     // MIs[2] Operand 1
     /* 281659 */     // No operand predicates
     /* 281659 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 281663 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13789),
     /* 281667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281669 */     // (shl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)<<P:Predicate_anonymous_13789>>  =>  (S_LSHL_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 281669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B64),
     /* 281672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 281674 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 281676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 281680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 281683 */     GIR_RootConstrainSelectedInstOperands,
     /* 281684 */     // GIR_Coverage, 71,
     /* 281684 */     GIR_EraseRootFromParent_Done,
     /* 281685 */   // Label 4594: @281685
     /* 281685 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(281719), // Rule ID 70 //
     /* 281690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 281694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 281698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281702 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13789),
     /* 281706 */     // (shl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13789>>  =>  (S_LSHL_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 281706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B64),
     /* 281711 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 281717 */     GIR_RootConstrainSelectedInstOperands,
     /* 281718 */     // GIR_Coverage, 70,
     /* 281718 */     GIR_Done,
     /* 281719 */   // Label 4595: @281719
     /* 281719 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(281784), // Rule ID 984 //
     /* 281724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 281727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 281731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281755 */     // MIs[2] Operand 1
     /* 281755 */     // No operand predicates
     /* 281755 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 281759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 281768 */     // (shl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHL_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 281768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B64_e64),
     /* 281771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 281778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 281782 */     GIR_RootConstrainSelectedInstOperands,
     /* 281783 */     // GIR_Coverage, 984,
     /* 281783 */     GIR_EraseRootFromParent_Done,
     /* 281784 */   // Label 4596: @281784
     /* 281784 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(281847), // Rule ID 994 //
     /* 281789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9GFX10GFX11),
     /* 281792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 281796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281820 */     // MIs[2] Operand 1
     /* 281820 */     // No operand predicates
     /* 281820 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 281824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 281833 */     // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHLREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 281833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_e64),
     /* 281836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 281843 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 281845 */     GIR_RootConstrainSelectedInstOperands,
     /* 281846 */     // GIR_Coverage, 994,
     /* 281846 */     GIR_EraseRootFromParent_Done,
     /* 281847 */   // Label 4597: @281847
     /* 281847 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(281880), // Rule ID 983 //
     /* 281852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 281855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 281859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 281866 */     // (shl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_LSHL_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 281866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B64_e64),
     /* 281869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 281876 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 281878 */     GIR_RootConstrainSelectedInstOperands,
     /* 281879 */     // GIR_Coverage, 983,
     /* 281879 */     GIR_EraseRootFromParent_Done,
     /* 281880 */   // Label 4598: @281880
     /* 281880 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(281913), // Rule ID 993 //
     /* 281885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9GFX10GFX11),
     /* 281888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 281892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 281899 */     // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_LSHLREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 281899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_e64),
     /* 281902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 281909 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 281911 */     GIR_RootConstrainSelectedInstOperands,
     /* 281912 */     // GIR_Coverage, 993,
     /* 281912 */     GIR_EraseRootFromParent_Done,
     /* 281913 */   // Label 4599: @281913
     /* 281913 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(281968), // Rule ID 920 //
     /* 281918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 281921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 281925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 281941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281949 */     // MIs[2] Operand 1
     /* 281949 */     // No operand predicates
     /* 281949 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 281953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281955 */     // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHLREV_B64_pseudo_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 281955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_pseudo_e64),
     /* 281958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 281964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 281966 */     GIR_RootConstrainSelectedInstOperands,
     /* 281967 */     // GIR_Coverage, 920,
     /* 281967 */     GIR_EraseRootFromParent_Done,
     /* 281968 */   // Label 4600: @281968
     /* 281968 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(281991), // Rule ID 919 //
     /* 281973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 281976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 281980 */     // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_LSHLREV_B64_pseudo_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 281980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_pseudo_e64),
     /* 281983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281985 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 281987 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 281989 */     GIR_RootConstrainSelectedInstOperands,
     /* 281990 */     // GIR_Coverage, 919,
     /* 281990 */     GIR_EraseRootFromParent_Done,
     /* 281991 */   // Label 4601: @281991
     /* 281991 */   GIM_Reject,
     /* 281992 */ // Label 4593: @281992
     /* 281992 */ GIM_Reject,
     /* 281993 */ // Label 4571: @281993
     /* 281993 */ GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(282161),
     /* 281998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 282001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 282004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282008 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(282099), // Rule ID 1108 //
     /* 282013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 282025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 282029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282037 */     // MIs[2] Operand 1
     /* 282037 */     // No operand predicates
     /* 282037 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 282041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 282050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 282057 */     // (shl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[v2i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_PK_LSHLREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 282057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHLREV_B16),
     /* 282060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 282067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 282072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 282077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 282082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282097 */     GIR_RootConstrainSelectedInstOperands,
     /* 282098 */     // GIR_Coverage, 1108,
     /* 282098 */     GIR_EraseRootFromParent_Done,
     /* 282099 */   // Label 4603: @282099
     /* 282099 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(282160), // Rule ID 1107 //
     /* 282104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 282111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 282118 */     // (shl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_LSHLREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 282118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHLREV_B16),
     /* 282121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 282128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 282133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 282138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 282143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282158 */     GIR_RootConstrainSelectedInstOperands,
     /* 282159 */     // GIR_Coverage, 1107,
     /* 282159 */     GIR_EraseRootFromParent_Done,
     /* 282160 */   // Label 4604: @282160
     /* 282160 */   GIM_Reject,
     /* 282161 */ // Label 4602: @282161
     /* 282161 */ GIM_Reject,
     /* 282162 */ // Label 4572: @282162
     /* 282162 */ GIM_Reject,
     /* 282163 */ // Label 47: @282163
     /* 282163 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4609*/ GIMT_Encode4(283324),
     /* 282174 */ /*GILLT_s16*//*Label 4605*/ GIMT_Encode4(282190),
     /* 282178 */ /*GILLT_s32*//*Label 4606*/ GIMT_Encode4(282501),
     /* 282182 */ /*GILLT_s64*//*Label 4607*/ GIMT_Encode4(282846),
     /* 282186 */ /*GILLT_v2s16*//*Label 4608*/ GIMT_Encode4(283155),
     /* 282190 */ // Label 4605: @282190
     /* 282190 */ GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(282500),
     /* 282195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 282201 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(282287), // Rule ID 849 //
     /* 282206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 282209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 282213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282237 */     // MIs[2] Operand 1
     /* 282237 */     // No operand predicates
     /* 282237 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 282241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 282250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 282257 */     // (srl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHRREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 282257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_t16_e64),
     /* 282260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 282267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 282272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 282277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 282282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282285 */     GIR_RootConstrainSelectedInstOperands,
     /* 282286 */     // GIR_Coverage, 849,
     /* 282286 */     GIR_EraseRootFromParent_Done,
     /* 282287 */   // Label 4611: @282287
     /* 282287 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(282343), // Rule ID 848 //
     /* 282292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 282295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 282299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 282306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 282313 */     // (srl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LSHRREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 282313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_t16_e64),
     /* 282316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 282323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 282328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 282333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 282338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282341 */     GIR_RootConstrainSelectedInstOperands,
     /* 282342 */     // GIR_Coverage, 848,
     /* 282342 */     GIR_EraseRootFromParent_Done,
     /* 282343 */   // Label 4612: @282343
     /* 282343 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(282398), // Rule ID 847 //
     /* 282348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 282351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282379 */     // MIs[2] Operand 1
     /* 282379 */     // No operand predicates
     /* 282379 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 282383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282385 */     // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHRREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 282385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 282388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282394 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282396 */     GIR_RootConstrainSelectedInstOperands,
     /* 282397 */     // GIR_Coverage, 847,
     /* 282397 */     GIR_EraseRootFromParent_Done,
     /* 282398 */   // Label 4613: @282398
     /* 282398 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(282453), // Rule ID 851 //
     /* 282403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 282406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282434 */     // MIs[2] Operand 1
     /* 282434 */     // No operand predicates
     /* 282434 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 282438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282440 */     // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHRREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 282440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_fake16_e64),
     /* 282443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282449 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282451 */     GIR_RootConstrainSelectedInstOperands,
     /* 282452 */     // GIR_Coverage, 851,
     /* 282452 */     GIR_EraseRootFromParent_Done,
     /* 282453 */   // Label 4614: @282453
     /* 282453 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(282476), // Rule ID 846 //
     /* 282458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 282461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282465 */     // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHRREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 282465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 282468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282470 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 282472 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282474 */     GIR_RootConstrainSelectedInstOperands,
     /* 282475 */     // GIR_Coverage, 846,
     /* 282475 */     GIR_EraseRootFromParent_Done,
     /* 282476 */   // Label 4615: @282476
     /* 282476 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(282499), // Rule ID 850 //
     /* 282481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 282484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282488 */     // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHRREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 282488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_fake16_e64),
     /* 282491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282493 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 282495 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282497 */     GIR_RootConstrainSelectedInstOperands,
     /* 282498 */     // GIR_Coverage, 850,
     /* 282498 */     GIR_EraseRootFromParent_Done,
     /* 282499 */   // Label 4616: @282499
     /* 282499 */   GIM_Reject,
     /* 282500 */ // Label 4610: @282500
     /* 282500 */ GIM_Reject,
     /* 282501 */ // Label 4606: @282501
     /* 282501 */ GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(282845),
     /* 282506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 282509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 282512 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(282580), // Rule ID 73 //
     /* 282517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 282541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282554 */     // MIs[2] Operand 1
     /* 282554 */     // No operand predicates
     /* 282554 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 282558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13790),
     /* 282562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282564 */     // (srl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_13790>>  =>  (S_LSHR_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 282564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B32),
     /* 282567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 282569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 282571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 282575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 282578 */     GIR_RootConstrainSelectedInstOperands,
     /* 282579 */     // GIR_Coverage, 73,
     /* 282579 */     GIR_EraseRootFromParent_Done,
     /* 282580 */   // Label 4618: @282580
     /* 282580 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(282636), // Rule ID 2487 //
     /* 282585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 282605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282613 */     // MIs[2] Operand 1
     /* 282613 */     // No operand predicates
     /* 282613 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 282617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19678),
     /* 282621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282623 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_19678>>  =>  (V_LSHRREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 282623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 282626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 282632 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 282634 */     GIR_RootConstrainSelectedInstOperands,
     /* 282635 */     // GIR_Coverage, 2487,
     /* 282635 */     GIR_EraseRootFromParent_Done,
     /* 282636 */   // Label 4619: @282636
     /* 282636 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(282670), // Rule ID 72 //
     /* 282641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282653 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13790),
     /* 282657 */     // (srl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13790>>  =>  (S_LSHR_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 282657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B32),
     /* 282662 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 282668 */     GIR_RootConstrainSelectedInstOperands,
     /* 282669 */     // GIR_Coverage, 72,
     /* 282669 */     GIR_Done,
     /* 282670 */   // Label 4620: @282670
     /* 282670 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(282694), // Rule ID 2486 //
     /* 282675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19678),
     /* 282683 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19678>>  =>  (V_LSHRREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 282683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 282686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282688 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 282690 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 282692 */     GIR_RootConstrainSelectedInstOperands,
     /* 282693 */     // GIR_Coverage, 2486,
     /* 282693 */     GIR_EraseRootFromParent_Done,
     /* 282694 */   // Label 4621: @282694
     /* 282694 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(282746), // Rule ID 809 //
     /* 282699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 282719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282727 */     // MIs[2] Operand 1
     /* 282727 */     // No operand predicates
     /* 282727 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 282731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282733 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHRREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 282733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 282736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282742 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282744 */     GIR_RootConstrainSelectedInstOperands,
     /* 282745 */     // GIR_Coverage, 809,
     /* 282745 */     GIR_EraseRootFromParent_Done,
     /* 282746 */   // Label 4622: @282746
     /* 282746 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(282801), // Rule ID 835 //
     /* 282751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 282754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 282774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282782 */     // MIs[2] Operand 1
     /* 282782 */     // No operand predicates
     /* 282782 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 282786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282788 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 282788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B32_e64),
     /* 282791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282793 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 282795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 282799 */     GIR_RootConstrainSelectedInstOperands,
     /* 282800 */     // GIR_Coverage, 835,
     /* 282800 */     GIR_EraseRootFromParent_Done,
     /* 282801 */   // Label 4623: @282801
     /* 282801 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(282821), // Rule ID 808 //
     /* 282806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282810 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_LSHRREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 282810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 282813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282815 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 282817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 282819 */     GIR_RootConstrainSelectedInstOperands,
     /* 282820 */     // GIR_Coverage, 808,
     /* 282820 */     GIR_EraseRootFromParent_Done,
     /* 282821 */   // Label 4624: @282821
     /* 282821 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(282844), // Rule ID 834 //
     /* 282826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 282829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282833 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_LSHR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 282833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B32_e64),
     /* 282838 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 282842 */     GIR_RootConstrainSelectedInstOperands,
     /* 282843 */     // GIR_Coverage, 834,
     /* 282843 */     GIR_Done,
     /* 282844 */   // Label 4625: @282844
     /* 282844 */   GIM_Reject,
     /* 282845 */ // Label 4617: @282845
     /* 282845 */ GIM_Reject,
     /* 282846 */ // Label 4607: @282846
     /* 282846 */ GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(283154),
     /* 282851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 282854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 282857 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(282925), // Rule ID 75 //
     /* 282862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 282866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 282870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 282886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282899 */     // MIs[2] Operand 1
     /* 282899 */     // No operand predicates
     /* 282899 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 282903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13791),
     /* 282907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282909 */     // (srl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)<<P:Predicate_anonymous_13791>>  =>  (S_LSHR_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 282909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B64),
     /* 282912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 282914 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 282916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 282920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 282923 */     GIR_RootConstrainSelectedInstOperands,
     /* 282924 */     // GIR_Coverage, 75,
     /* 282924 */     GIR_EraseRootFromParent_Done,
     /* 282925 */   // Label 4627: @282925
     /* 282925 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(282959), // Rule ID 74 //
     /* 282930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 282934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 282938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 282942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13791),
     /* 282946 */     // (srl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13791>>  =>  (S_LSHR_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 282946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B64),
     /* 282951 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 282957 */     GIR_RootConstrainSelectedInstOperands,
     /* 282958 */     // GIR_Coverage, 74,
     /* 282958 */     GIR_Done,
     /* 282959 */   // Label 4628: @282959
     /* 282959 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(283024), // Rule ID 986 //
     /* 282964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 282967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 282971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 282987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282995 */     // MIs[2] Operand 1
     /* 282995 */     // No operand predicates
     /* 282995 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 282999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 283008 */     // (srl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHR_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 283008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B64_e64),
     /* 283011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 283018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 283022 */     GIR_RootConstrainSelectedInstOperands,
     /* 283023 */     // GIR_Coverage, 986,
     /* 283023 */     GIR_EraseRootFromParent_Done,
     /* 283024 */   // Label 4629: @283024
     /* 283024 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(283087), // Rule ID 990 //
     /* 283029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 283032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 283052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283060 */     // MIs[2] Operand 1
     /* 283060 */     // No operand predicates
     /* 283060 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 283064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 283073 */     // (srl:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHRREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 283073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B64_e64),
     /* 283076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 283083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283085 */     GIR_RootConstrainSelectedInstOperands,
     /* 283086 */     // GIR_Coverage, 990,
     /* 283086 */     GIR_EraseRootFromParent_Done,
     /* 283087 */   // Label 4630: @283087
     /* 283087 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(283120), // Rule ID 985 //
     /* 283092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 283095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 283106 */     // (srl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_LSHR_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 283106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B64_e64),
     /* 283109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 283116 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 283118 */     GIR_RootConstrainSelectedInstOperands,
     /* 283119 */     // GIR_Coverage, 985,
     /* 283119 */     GIR_EraseRootFromParent_Done,
     /* 283120 */   // Label 4631: @283120
     /* 283120 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(283153), // Rule ID 989 //
     /* 283125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 283128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 283139 */     // (srl:{ *:[i64] } i64:{ *:[i64] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_LSHRREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 283139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B64_e64),
     /* 283142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 283149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283151 */     GIR_RootConstrainSelectedInstOperands,
     /* 283152 */     // GIR_Coverage, 989,
     /* 283152 */     GIR_EraseRootFromParent_Done,
     /* 283153 */   // Label 4632: @283153
     /* 283153 */   GIM_Reject,
     /* 283154 */ // Label 4626: @283154
     /* 283154 */ GIM_Reject,
     /* 283155 */ // Label 4608: @283155
     /* 283155 */ GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(283323),
     /* 283160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 283163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 283166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283170 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(283261), // Rule ID 1112 //
     /* 283175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 283187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 283191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283199 */     // MIs[2] Operand 1
     /* 283199 */     // No operand predicates
     /* 283199 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 283203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 283212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 283219 */     // (srl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[v2i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_PK_LSHRREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 283219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHRREV_B16),
     /* 283222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 283229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 283234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 283239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 283244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283259 */     GIR_RootConstrainSelectedInstOperands,
     /* 283260 */     // GIR_Coverage, 1112,
     /* 283260 */     GIR_EraseRootFromParent_Done,
     /* 283261 */   // Label 4634: @283261
     /* 283261 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(283322), // Rule ID 1111 //
     /* 283266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 283273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 283280 */     // (srl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_LSHRREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 283280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHRREV_B16),
     /* 283283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 283290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 283295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 283300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 283305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283320 */     GIR_RootConstrainSelectedInstOperands,
     /* 283321 */     // GIR_Coverage, 1111,
     /* 283321 */     GIR_EraseRootFromParent_Done,
     /* 283322 */   // Label 4635: @283322
     /* 283322 */   GIM_Reject,
     /* 283323 */ // Label 4633: @283323
     /* 283323 */ GIM_Reject,
     /* 283324 */ // Label 4609: @283324
     /* 283324 */ GIM_Reject,
     /* 283325 */ // Label 48: @283325
     /* 283325 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4640*/ GIMT_Encode4(284486),
     /* 283336 */ /*GILLT_s16*//*Label 4636*/ GIMT_Encode4(283352),
     /* 283340 */ /*GILLT_s32*//*Label 4637*/ GIMT_Encode4(283663),
     /* 283344 */ /*GILLT_s64*//*Label 4638*/ GIMT_Encode4(284008),
     /* 283348 */ /*GILLT_v2s16*//*Label 4639*/ GIMT_Encode4(284317),
     /* 283352 */ // Label 4636: @283352
     /* 283352 */ GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(283662),
     /* 283357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 283363 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(283449), // Rule ID 855 //
     /* 283368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 283371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 283375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283399 */     // MIs[2] Operand 1
     /* 283399 */     // No operand predicates
     /* 283399 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 283403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 283412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 283419 */     // (sra:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_ASHRREV_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 283419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_t16_e64),
     /* 283422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 283429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 283434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 283439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 283444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283447 */     GIR_RootConstrainSelectedInstOperands,
     /* 283448 */     // GIR_Coverage, 855,
     /* 283448 */     GIR_EraseRootFromParent_Done,
     /* 283449 */   // Label 4642: @283449
     /* 283449 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(283505), // Rule ID 854 //
     /* 283454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 283457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 283461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 283468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 283475 */     // (sra:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_ASHRREV_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 283475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_t16_e64),
     /* 283478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 283485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 283490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 283495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 283500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283503 */     GIR_RootConstrainSelectedInstOperands,
     /* 283504 */     // GIR_Coverage, 854,
     /* 283504 */     GIR_EraseRootFromParent_Done,
     /* 283505 */   // Label 4643: @283505
     /* 283505 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(283560), // Rule ID 853 //
     /* 283510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 283513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283541 */     // MIs[2] Operand 1
     /* 283541 */     // No operand predicates
     /* 283541 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 283545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283547 */     // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_ASHRREV_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 283547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 283550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 283556 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283558 */     GIR_RootConstrainSelectedInstOperands,
     /* 283559 */     // GIR_Coverage, 853,
     /* 283559 */     GIR_EraseRootFromParent_Done,
     /* 283560 */   // Label 4644: @283560
     /* 283560 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(283615), // Rule ID 857 //
     /* 283565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 283568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283596 */     // MIs[2] Operand 1
     /* 283596 */     // No operand predicates
     /* 283596 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 283600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283602 */     // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_ASHRREV_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 283602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_fake16_e64),
     /* 283605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 283611 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283613 */     GIR_RootConstrainSelectedInstOperands,
     /* 283614 */     // GIR_Coverage, 857,
     /* 283614 */     GIR_EraseRootFromParent_Done,
     /* 283615 */   // Label 4645: @283615
     /* 283615 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(283638), // Rule ID 852 //
     /* 283620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 283623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283627 */     // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_ASHRREV_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 283627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 283630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283632 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 283634 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283636 */     GIR_RootConstrainSelectedInstOperands,
     /* 283637 */     // GIR_Coverage, 852,
     /* 283637 */     GIR_EraseRootFromParent_Done,
     /* 283638 */   // Label 4646: @283638
     /* 283638 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(283661), // Rule ID 856 //
     /* 283643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 283646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283650 */     // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_ASHRREV_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 283650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_fake16_e64),
     /* 283653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283655 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 283657 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283659 */     GIR_RootConstrainSelectedInstOperands,
     /* 283660 */     // GIR_Coverage, 856,
     /* 283660 */     GIR_EraseRootFromParent_Done,
     /* 283661 */   // Label 4647: @283661
     /* 283661 */   GIM_Reject,
     /* 283662 */ // Label 4641: @283662
     /* 283662 */ GIM_Reject,
     /* 283663 */ // Label 4637: @283663
     /* 283663 */ GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(284007),
     /* 283668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 283671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 283674 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(283742), // Rule ID 77 //
     /* 283679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 283683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 283687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 283703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 283708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283716 */     // MIs[2] Operand 1
     /* 283716 */     // No operand predicates
     /* 283716 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 283720 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13792),
     /* 283724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283726 */     // (sra:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_13792>>  =>  (S_ASHR_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 283726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
     /* 283729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 283731 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 283733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 283737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 283740 */     GIR_RootConstrainSelectedInstOperands,
     /* 283741 */     // GIR_Coverage, 77,
     /* 283741 */     GIR_EraseRootFromParent_Done,
     /* 283742 */   // Label 4649: @283742
     /* 283742 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(283798), // Rule ID 2489 //
     /* 283747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 283767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283775 */     // MIs[2] Operand 1
     /* 283775 */     // No operand predicates
     /* 283775 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 283779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19680),
     /* 283783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283785 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_19680>>  =>  (V_ASHRREV_I32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 283785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 283788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 283794 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 283796 */     GIR_RootConstrainSelectedInstOperands,
     /* 283797 */     // GIR_Coverage, 2489,
     /* 283797 */     GIR_EraseRootFromParent_Done,
     /* 283798 */   // Label 4650: @283798
     /* 283798 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(283832), // Rule ID 76 //
     /* 283803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 283807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 283811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 283815 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13792),
     /* 283819 */     // (sra:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13792>>  =>  (S_ASHR_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 283819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
     /* 283824 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 283830 */     GIR_RootConstrainSelectedInstOperands,
     /* 283831 */     // GIR_Coverage, 76,
     /* 283831 */     GIR_Done,
     /* 283832 */   // Label 4651: @283832
     /* 283832 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(283856), // Rule ID 2488 //
     /* 283837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19680),
     /* 283845 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19680>>  =>  (V_ASHRREV_I32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 283845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 283848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283850 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 283852 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 283854 */     GIR_RootConstrainSelectedInstOperands,
     /* 283855 */     // GIR_Coverage, 2488,
     /* 283855 */     GIR_EraseRootFromParent_Done,
     /* 283856 */   // Label 4652: @283856
     /* 283856 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(283908), // Rule ID 811 //
     /* 283861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 283881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283889 */     // MIs[2] Operand 1
     /* 283889 */     // No operand predicates
     /* 283889 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 283893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283895 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_ASHRREV_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 283895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 283898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 283904 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283906 */     GIR_RootConstrainSelectedInstOperands,
     /* 283907 */     // GIR_Coverage, 811,
     /* 283907 */     GIR_EraseRootFromParent_Done,
     /* 283908 */   // Label 4653: @283908
     /* 283908 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(283963), // Rule ID 837 //
     /* 283913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 283916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 283936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283944 */     // MIs[2] Operand 1
     /* 283944 */     // No operand predicates
     /* 283944 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 283948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283950 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_ASHR_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 283950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I32_e64),
     /* 283953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283955 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 283957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 283961 */     GIR_RootConstrainSelectedInstOperands,
     /* 283962 */     // GIR_Coverage, 837,
     /* 283962 */     GIR_EraseRootFromParent_Done,
     /* 283963 */   // Label 4654: @283963
     /* 283963 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(283983), // Rule ID 810 //
     /* 283968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283972 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_ASHRREV_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 283972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 283975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283977 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 283979 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 283981 */     GIR_RootConstrainSelectedInstOperands,
     /* 283982 */     // GIR_Coverage, 810,
     /* 283982 */     GIR_EraseRootFromParent_Done,
     /* 283983 */   // Label 4655: @283983
     /* 283983 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(284006), // Rule ID 836 //
     /* 283988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 283991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283995 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ASHR_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 283995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I32_e64),
     /* 284000 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 284004 */     GIR_RootConstrainSelectedInstOperands,
     /* 284005 */     // GIR_Coverage, 836,
     /* 284005 */     GIR_Done,
     /* 284006 */   // Label 4656: @284006
     /* 284006 */   GIM_Reject,
     /* 284007 */ // Label 4648: @284007
     /* 284007 */ GIM_Reject,
     /* 284008 */ // Label 4638: @284008
     /* 284008 */ GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(284316),
     /* 284013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 284016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 284019 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(284087), // Rule ID 79 //
     /* 284024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 284028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 284032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 284040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 284048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 284053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284061 */     // MIs[2] Operand 1
     /* 284061 */     // No operand predicates
     /* 284061 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 284065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13793),
     /* 284069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284071 */     // (sra:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)<<P:Predicate_anonymous_13793>>  =>  (S_ASHR_I64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 284071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I64),
     /* 284074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 284076 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 284082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 284085 */     GIR_RootConstrainSelectedInstOperands,
     /* 284086 */     // GIR_Coverage, 79,
     /* 284086 */     GIR_EraseRootFromParent_Done,
     /* 284087 */   // Label 4658: @284087
     /* 284087 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(284121), // Rule ID 78 //
     /* 284092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 284096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 284100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 284104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13793),
     /* 284108 */     // (sra:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13793>>  =>  (S_ASHR_I64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 284108 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I64),
     /* 284113 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 284119 */     GIR_RootConstrainSelectedInstOperands,
     /* 284120 */     // GIR_Coverage, 78,
     /* 284120 */     GIR_Done,
     /* 284121 */   // Label 4659: @284121
     /* 284121 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(284186), // Rule ID 988 //
     /* 284126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 284129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 284141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 284149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284157 */     // MIs[2] Operand 1
     /* 284157 */     // No operand predicates
     /* 284157 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 284161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 284170 */     // (sra:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_ASHR_I64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 284170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I64_e64),
     /* 284173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 284180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 284184 */     GIR_RootConstrainSelectedInstOperands,
     /* 284185 */     // GIR_Coverage, 988,
     /* 284185 */     GIR_EraseRootFromParent_Done,
     /* 284186 */   // Label 4660: @284186
     /* 284186 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(284249), // Rule ID 992 //
     /* 284191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 284194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 284206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 284214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284222 */     // MIs[2] Operand 1
     /* 284222 */     // No operand predicates
     /* 284222 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 284226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 284235 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_ASHRREV_I64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 284235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I64_e64),
     /* 284238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 284245 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 284247 */     GIR_RootConstrainSelectedInstOperands,
     /* 284248 */     // GIR_Coverage, 992,
     /* 284248 */     GIR_EraseRootFromParent_Done,
     /* 284249 */   // Label 4661: @284249
     /* 284249 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(284282), // Rule ID 987 //
     /* 284254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 284257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 284268 */     // (sra:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_ASHR_I64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 284268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I64_e64),
     /* 284271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 284278 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 284280 */     GIR_RootConstrainSelectedInstOperands,
     /* 284281 */     // GIR_Coverage, 987,
     /* 284281 */     GIR_EraseRootFromParent_Done,
     /* 284282 */   // Label 4662: @284282
     /* 284282 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(284315), // Rule ID 991 //
     /* 284287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 284290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 284301 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_ASHRREV_I64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 284301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I64_e64),
     /* 284304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 284311 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 284313 */     GIR_RootConstrainSelectedInstOperands,
     /* 284314 */     // GIR_Coverage, 991,
     /* 284314 */     GIR_EraseRootFromParent_Done,
     /* 284315 */   // Label 4663: @284315
     /* 284315 */   GIM_Reject,
     /* 284316 */ // Label 4657: @284316
     /* 284316 */ GIM_Reject,
     /* 284317 */ // Label 4639: @284317
     /* 284317 */ GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(284485),
     /* 284322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 284325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 284328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284332 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(284423), // Rule ID 1110 //
     /* 284337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 284345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 284349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 284353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284361 */     // MIs[2] Operand 1
     /* 284361 */     // No operand predicates
     /* 284361 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 284365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 284374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 284381 */     // (sra:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[v2i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_PK_ASHRREV_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 284381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ASHRREV_I16),
     /* 284384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 284391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 284396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 284401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 284406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284421 */     GIR_RootConstrainSelectedInstOperands,
     /* 284422 */     // GIR_Coverage, 1110,
     /* 284422 */     GIR_EraseRootFromParent_Done,
     /* 284423 */   // Label 4665: @284423
     /* 284423 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(284484), // Rule ID 1109 //
     /* 284428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 284435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 284442 */     // (sra:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_ASHRREV_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 284442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ASHRREV_I16),
     /* 284445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 284452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 284457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 284462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 284467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284482 */     GIR_RootConstrainSelectedInstOperands,
     /* 284483 */     // GIR_Coverage, 1109,
     /* 284483 */     GIR_EraseRootFromParent_Done,
     /* 284484 */   // Label 4666: @284484
     /* 284484 */   GIM_Reject,
     /* 284485 */ // Label 4664: @284485
     /* 284485 */ GIM_Reject,
     /* 284486 */ // Label 4640: @284486
     /* 284486 */ GIM_Reject,
     /* 284487 */ // Label 49: @284487
     /* 284487 */ GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(284748),
     /* 284492 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 284495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 284498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 284501 */   GIM_SwitchType, /*MI*/0, /*Op*/3, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4670*/ GIMT_Encode4(284709),
     /* 284512 */   /*GILLT_s16*//*Label 4668*/ GIMT_Encode4(284520),
     /* 284516 */   /*GILLT_s32*//*Label 4669*/ GIMT_Encode4(284597),
     /* 284520 */   // Label 4668: @284520
     /* 284520 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(284596), // Rule ID 961 //
     /* 284525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 284528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 284539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 284546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 284553 */     // (fshr:{ *:[i32] } (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 284553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 284556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 284563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 284568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 284573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 284578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 284583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 284588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284594 */     GIR_RootConstrainSelectedInstOperands,
     /* 284595 */     // GIR_Coverage, 961,
     /* 284595 */     GIR_EraseRootFromParent_Done,
     /* 284596 */   // Label 4671: @284596
     /* 284596 */   GIM_Reject,
     /* 284597 */   // Label 4669: @284597
     /* 284597 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(284708),
     /* 284602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284606 */     GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(284671), // Rule ID 7331 //
     /* 284611 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 284614 */       // (fshr:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBIT_B32_t16_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VGPR_32:{ *:[i32] }:$src2, lo16:{ *:[i32] }), 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 284614 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 284617 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284621 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284626 */       GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(2), // src2
     /* 284632 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 284637 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284642 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_t16_e64),
     /* 284645 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284647 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284650 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284652 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284655 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 284657 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284660 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284663 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284666 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284669 */       GIR_RootConstrainSelectedInstOperands,
     /* 284670 */       // GIR_Coverage, 7331,
     /* 284670 */       GIR_EraseRootFromParent_Done,
     /* 284671 */     // Label 4673: @284671
     /* 284671 */     GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(284707), // Rule ID 7335 //
     /* 284676 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 284679 */       // (fshr:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 284679 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 284682 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284684 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284687 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284689 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284692 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 284694 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284697 */       GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 284699 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284702 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284705 */       GIR_RootConstrainSelectedInstOperands,
     /* 284706 */       // GIR_Coverage, 7335,
     /* 284706 */       GIR_EraseRootFromParent_Done,
     /* 284707 */     // Label 4674: @284707
     /* 284707 */     GIM_Reject,
     /* 284708 */   // Label 4672: @284708
     /* 284708 */   GIM_Reject,
     /* 284709 */   // Label 4670: @284709
     /* 284709 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(284747), // Rule ID 960 //
     /* 284714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 284717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 284720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 284731 */     // (fshr:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBIT_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 284731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 284734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 284741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 284743 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 284745 */     GIR_RootConstrainSelectedInstOperands,
     /* 284746 */     // GIR_Coverage, 960,
     /* 284746 */     GIR_EraseRootFromParent_Done,
     /* 284747 */   // Label 4675: @284747
     /* 284747 */   GIM_Reject,
     /* 284748 */ // Label 4667: @284748
     /* 284748 */ GIM_Reject,
     /* 284749 */ // Label 50: @284749
     /* 284749 */ GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(284825),
     /* 284754 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 284757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 284760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 284763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284767 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(284788), // Rule ID 7326 //
     /* 284772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 284775 */     // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ALIGNBIT_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
     /* 284775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 284778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284780 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284782 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284784 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 284786 */     GIR_RootConstrainSelectedInstOperands,
     /* 284787 */     // GIR_Coverage, 7326,
     /* 284787 */     GIR_EraseRootFromParent_Done,
     /* 284788 */   // Label 4677: @284788
     /* 284788 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(284824), // Rule ID 7332 //
     /* 284793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 284796 */     // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 284796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 284799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 284801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284804 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 284811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284814 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 284816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284822 */     GIR_RootConstrainSelectedInstOperands,
     /* 284823 */     // GIR_Coverage, 7332,
     /* 284823 */     GIR_EraseRootFromParent_Done,
     /* 284824 */   // Label 4678: @284824
     /* 284824 */   GIM_Reject,
     /* 284825 */ // Label 4676: @284825
     /* 284825 */ GIM_Reject,
     /* 284826 */ // Label 51: @284826
     /* 284826 */ GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(286417),
     /* 284831 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 284834 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4683*/ GIMT_Encode4(286117),
     /* 284845 */   /*GILLT_s16*//*Label 4680*/ GIMT_Encode4(284857),
     /* 284849 */   /*GILLT_s32*//*Label 4681*/ GIMT_Encode4(285921),
     /* 284853 */   /*GILLT_s64*//*Label 4682*/ GIMT_Encode4(286019),
     /* 284857 */   // Label 4680: @284857
     /* 284857 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(285920),
     /* 284862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 284865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 284869 */     GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(284926), // Rule ID 460 //
     /* 284874 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 284877 */       // MIs[0] Operand 1
     /* 284877 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 284882 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 284889 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 284896 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETLT:{ *:[Other] })  =>  (V_CMP_LT_I16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 284896 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I16_t16_e64),
     /* 284899 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 284901 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 284906 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 284911 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 284916 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 284921 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284924 */       GIR_RootConstrainSelectedInstOperands,
     /* 284925 */       // GIR_Coverage, 460,
     /* 284925 */       GIR_EraseRootFromParent_Done,
     /* 284926 */     // Label 4685: @284926
     /* 284926 */     GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(284983), // Rule ID 466 //
     /* 284931 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 284934 */       // MIs[0] Operand 1
     /* 284934 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 284939 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 284946 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 284953 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETLE:{ *:[Other] })  =>  (V_CMP_LE_I16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 284953 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I16_t16_e64),
     /* 284956 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 284958 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 284963 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 284968 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 284973 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 284978 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284981 */       GIR_RootConstrainSelectedInstOperands,
     /* 284982 */       // GIR_Coverage, 466,
     /* 284982 */       GIR_EraseRootFromParent_Done,
     /* 284983 */     // Label 4686: @284983
     /* 284983 */     GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(285040), // Rule ID 469 //
     /* 284988 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 284991 */       // MIs[0] Operand 1
     /* 284991 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 284996 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285003 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285010 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETGT:{ *:[Other] })  =>  (V_CMP_GT_I16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285010 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I16_t16_e64),
     /* 285013 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285015 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285020 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285025 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285030 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285035 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285038 */       GIR_RootConstrainSelectedInstOperands,
     /* 285039 */       // GIR_Coverage, 469,
     /* 285039 */       GIR_EraseRootFromParent_Done,
     /* 285040 */     // Label 4687: @285040
     /* 285040 */     GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(285097), // Rule ID 475 //
     /* 285045 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285048 */       // MIs[0] Operand 1
     /* 285048 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 285053 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285060 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285067 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETGE:{ *:[Other] })  =>  (V_CMP_GE_I16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285067 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I16_t16_e64),
     /* 285070 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285072 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285077 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285082 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285087 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285092 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285095 */       GIR_RootConstrainSelectedInstOperands,
     /* 285096 */       // GIR_Coverage, 475,
     /* 285096 */       GIR_EraseRootFromParent_Done,
     /* 285097 */     // Label 4688: @285097
     /* 285097 */     GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(285154), // Rule ID 484 //
     /* 285102 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285105 */       // MIs[0] Operand 1
     /* 285105 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 285110 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285117 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285124 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_LT_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285124 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U16_t16_e64),
     /* 285127 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285129 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285134 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285139 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285144 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285149 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285152 */       GIR_RootConstrainSelectedInstOperands,
     /* 285153 */       // GIR_Coverage, 484,
     /* 285153 */       GIR_EraseRootFromParent_Done,
     /* 285154 */     // Label 4689: @285154
     /* 285154 */     GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(285211), // Rule ID 488 //
     /* 285159 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285162 */       // MIs[0] Operand 1
     /* 285162 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 285167 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285174 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285181 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285181 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U16_t16_e64),
     /* 285184 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285186 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285191 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285196 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285201 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285206 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285209 */       GIR_RootConstrainSelectedInstOperands,
     /* 285210 */       // GIR_Coverage, 488,
     /* 285210 */       GIR_EraseRootFromParent_Done,
     /* 285211 */     // Label 4690: @285211
     /* 285211 */     GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(285268), // Rule ID 493 //
     /* 285216 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285219 */       // MIs[0] Operand 1
     /* 285219 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 285224 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285231 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285238 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_LE_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285238 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U16_t16_e64),
     /* 285241 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285243 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285248 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285253 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285258 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285263 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285266 */       GIR_RootConstrainSelectedInstOperands,
     /* 285267 */       // GIR_Coverage, 493,
     /* 285267 */       GIR_EraseRootFromParent_Done,
     /* 285268 */     // Label 4691: @285268
     /* 285268 */     GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(285325), // Rule ID 496 //
     /* 285273 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285276 */       // MIs[0] Operand 1
     /* 285276 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 285281 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285288 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285295 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285295 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U16_t16_e64),
     /* 285298 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285300 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285305 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285310 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285315 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285320 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285323 */       GIR_RootConstrainSelectedInstOperands,
     /* 285324 */       // GIR_Coverage, 496,
     /* 285324 */       GIR_EraseRootFromParent_Done,
     /* 285325 */     // Label 4692: @285325
     /* 285325 */     GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(285382), // Rule ID 500 //
     /* 285330 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285333 */       // MIs[0] Operand 1
     /* 285333 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 285338 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285345 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285352 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETNE:{ *:[Other] })  =>  (V_CMP_NE_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285352 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U16_t16_e64),
     /* 285355 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285357 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285362 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285367 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285372 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285377 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285380 */       GIR_RootConstrainSelectedInstOperands,
     /* 285381 */       // GIR_Coverage, 500,
     /* 285381 */       GIR_EraseRootFromParent_Done,
     /* 285382 */     // Label 4693: @285382
     /* 285382 */     GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(285439), // Rule ID 505 //
     /* 285387 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 285390 */       // MIs[0] Operand 1
     /* 285390 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 285395 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 285402 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 285409 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285409 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U16_t16_e64),
     /* 285412 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285414 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 285419 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 285424 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 285429 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 285434 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285437 */       GIR_RootConstrainSelectedInstOperands,
     /* 285438 */       // GIR_Coverage, 505,
     /* 285438 */       GIR_EraseRootFromParent_Done,
     /* 285439 */     // Label 4694: @285439
     /* 285439 */     GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(285463), // Rule ID 459 //
     /* 285444 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285447 */       // MIs[0] Operand 1
     /* 285447 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 285452 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285452 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I16_e64),
     /* 285455 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285457 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285459 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285461 */       GIR_RootConstrainSelectedInstOperands,
     /* 285462 */       // GIR_Coverage, 459,
     /* 285462 */       GIR_EraseRootFromParent_Done,
     /* 285463 */     // Label 4695: @285463
     /* 285463 */     GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(285487), // Rule ID 461 //
     /* 285468 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285471 */       // MIs[0] Operand 1
     /* 285471 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 285476 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285476 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I16_fake16_e64),
     /* 285479 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285481 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285483 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285485 */       GIR_RootConstrainSelectedInstOperands,
     /* 285486 */       // GIR_Coverage, 461,
     /* 285486 */       GIR_EraseRootFromParent_Done,
     /* 285487 */     // Label 4696: @285487
     /* 285487 */     GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(285511), // Rule ID 465 //
     /* 285492 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285495 */       // MIs[0] Operand 1
     /* 285495 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 285500 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285500 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I16_e64),
     /* 285503 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285505 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285507 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285509 */       GIR_RootConstrainSelectedInstOperands,
     /* 285510 */       // GIR_Coverage, 465,
     /* 285510 */       GIR_EraseRootFromParent_Done,
     /* 285511 */     // Label 4697: @285511
     /* 285511 */     GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(285535), // Rule ID 467 //
     /* 285516 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285519 */       // MIs[0] Operand 1
     /* 285519 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 285524 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285524 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I16_fake16_e64),
     /* 285527 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285529 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285531 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285533 */       GIR_RootConstrainSelectedInstOperands,
     /* 285534 */       // GIR_Coverage, 467,
     /* 285534 */       GIR_EraseRootFromParent_Done,
     /* 285535 */     // Label 4698: @285535
     /* 285535 */     GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(285559), // Rule ID 468 //
     /* 285540 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285543 */       // MIs[0] Operand 1
     /* 285543 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 285548 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285548 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I16_e64),
     /* 285551 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285553 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285555 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285557 */       GIR_RootConstrainSelectedInstOperands,
     /* 285558 */       // GIR_Coverage, 468,
     /* 285558 */       GIR_EraseRootFromParent_Done,
     /* 285559 */     // Label 4699: @285559
     /* 285559 */     GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(285583), // Rule ID 470 //
     /* 285564 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285567 */       // MIs[0] Operand 1
     /* 285567 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 285572 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285572 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I16_fake16_e64),
     /* 285575 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285577 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285579 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285581 */       GIR_RootConstrainSelectedInstOperands,
     /* 285582 */       // GIR_Coverage, 470,
     /* 285582 */       GIR_EraseRootFromParent_Done,
     /* 285583 */     // Label 4700: @285583
     /* 285583 */     GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(285607), // Rule ID 474 //
     /* 285588 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285591 */       // MIs[0] Operand 1
     /* 285591 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 285596 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285596 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I16_e64),
     /* 285599 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285601 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285603 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285605 */       GIR_RootConstrainSelectedInstOperands,
     /* 285606 */       // GIR_Coverage, 474,
     /* 285606 */       GIR_EraseRootFromParent_Done,
     /* 285607 */     // Label 4701: @285607
     /* 285607 */     GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(285631), // Rule ID 476 //
     /* 285612 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285615 */       // MIs[0] Operand 1
     /* 285615 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 285620 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285620 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I16_fake16_e64),
     /* 285623 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285625 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285627 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285629 */       GIR_RootConstrainSelectedInstOperands,
     /* 285630 */       // GIR_Coverage, 476,
     /* 285630 */       GIR_EraseRootFromParent_Done,
     /* 285631 */     // Label 4702: @285631
     /* 285631 */     GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(285655), // Rule ID 483 //
     /* 285636 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285639 */       // MIs[0] Operand 1
     /* 285639 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 285644 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285644 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U16_e64),
     /* 285647 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285649 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285651 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285653 */       GIR_RootConstrainSelectedInstOperands,
     /* 285654 */       // GIR_Coverage, 483,
     /* 285654 */       GIR_EraseRootFromParent_Done,
     /* 285655 */     // Label 4703: @285655
     /* 285655 */     GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(285679), // Rule ID 485 //
     /* 285660 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285663 */       // MIs[0] Operand 1
     /* 285663 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 285668 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285668 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U16_fake16_e64),
     /* 285671 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285673 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285675 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285677 */       GIR_RootConstrainSelectedInstOperands,
     /* 285678 */       // GIR_Coverage, 485,
     /* 285678 */       GIR_EraseRootFromParent_Done,
     /* 285679 */     // Label 4704: @285679
     /* 285679 */     GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(285703), // Rule ID 486 //
     /* 285684 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285687 */       // MIs[0] Operand 1
     /* 285687 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 285692 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285692 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U16_e64),
     /* 285695 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285697 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285699 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285701 */       GIR_RootConstrainSelectedInstOperands,
     /* 285702 */       // GIR_Coverage, 486,
     /* 285702 */       GIR_EraseRootFromParent_Done,
     /* 285703 */     // Label 4705: @285703
     /* 285703 */     GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(285727), // Rule ID 490 //
     /* 285708 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285711 */       // MIs[0] Operand 1
     /* 285711 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 285716 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285716 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U16_fake16_e64),
     /* 285719 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285721 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285723 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285725 */       GIR_RootConstrainSelectedInstOperands,
     /* 285726 */       // GIR_Coverage, 490,
     /* 285726 */       GIR_EraseRootFromParent_Done,
     /* 285727 */     // Label 4706: @285727
     /* 285727 */     GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(285751), // Rule ID 492 //
     /* 285732 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285735 */       // MIs[0] Operand 1
     /* 285735 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 285740 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285740 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U16_e64),
     /* 285743 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285745 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285747 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285749 */       GIR_RootConstrainSelectedInstOperands,
     /* 285750 */       // GIR_Coverage, 492,
     /* 285750 */       GIR_EraseRootFromParent_Done,
     /* 285751 */     // Label 4707: @285751
     /* 285751 */     GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(285775), // Rule ID 494 //
     /* 285756 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285759 */       // MIs[0] Operand 1
     /* 285759 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 285764 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285764 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U16_fake16_e64),
     /* 285767 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285769 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285771 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285773 */       GIR_RootConstrainSelectedInstOperands,
     /* 285774 */       // GIR_Coverage, 494,
     /* 285774 */       GIR_EraseRootFromParent_Done,
     /* 285775 */     // Label 4708: @285775
     /* 285775 */     GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(285799), // Rule ID 495 //
     /* 285780 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285783 */       // MIs[0] Operand 1
     /* 285783 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 285788 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285788 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U16_e64),
     /* 285791 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285793 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285795 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285797 */       GIR_RootConstrainSelectedInstOperands,
     /* 285798 */       // GIR_Coverage, 495,
     /* 285798 */       GIR_EraseRootFromParent_Done,
     /* 285799 */     // Label 4709: @285799
     /* 285799 */     GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(285823), // Rule ID 497 //
     /* 285804 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285807 */       // MIs[0] Operand 1
     /* 285807 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 285812 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285812 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U16_fake16_e64),
     /* 285815 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285817 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285819 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285821 */       GIR_RootConstrainSelectedInstOperands,
     /* 285822 */       // GIR_Coverage, 497,
     /* 285822 */       GIR_EraseRootFromParent_Done,
     /* 285823 */     // Label 4710: @285823
     /* 285823 */     GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(285847), // Rule ID 498 //
     /* 285828 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285831 */       // MIs[0] Operand 1
     /* 285831 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 285836 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285836 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U16_e64),
     /* 285839 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285841 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285843 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285845 */       GIR_RootConstrainSelectedInstOperands,
     /* 285846 */       // GIR_Coverage, 498,
     /* 285846 */       GIR_EraseRootFromParent_Done,
     /* 285847 */     // Label 4711: @285847
     /* 285847 */     GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(285871), // Rule ID 502 //
     /* 285852 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285855 */       // MIs[0] Operand 1
     /* 285855 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 285860 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285860 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U16_fake16_e64),
     /* 285863 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285865 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285867 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285869 */       GIR_RootConstrainSelectedInstOperands,
     /* 285870 */       // GIR_Coverage, 502,
     /* 285870 */       GIR_EraseRootFromParent_Done,
     /* 285871 */     // Label 4712: @285871
     /* 285871 */     GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(285895), // Rule ID 504 //
     /* 285876 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285879 */       // MIs[0] Operand 1
     /* 285879 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 285884 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285884 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U16_e64),
     /* 285887 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285889 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285891 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285893 */       GIR_RootConstrainSelectedInstOperands,
     /* 285894 */       // GIR_Coverage, 504,
     /* 285894 */       GIR_EraseRootFromParent_Done,
     /* 285895 */     // Label 4713: @285895
     /* 285895 */     GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(285919), // Rule ID 506 //
     /* 285900 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 285903 */       // MIs[0] Operand 1
     /* 285903 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 285908 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285908 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U16_fake16_e64),
     /* 285911 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285913 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285915 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285917 */       GIR_RootConstrainSelectedInstOperands,
     /* 285918 */       // GIR_Coverage, 506,
     /* 285918 */       GIR_EraseRootFromParent_Done,
     /* 285919 */     // Label 4714: @285919
     /* 285919 */     GIM_Reject,
     /* 285920 */   // Label 4684: @285920
     /* 285920 */   GIM_Reject,
     /* 285921 */   // Label 4681: @285921
     /* 285921 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(286018),
     /* 285926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 285929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 285933 */     GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(285954), // Rule ID 559 //
     /* 285938 */       // MIs[0] Operand 1
     /* 285938 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 285943 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 285943 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I32_e64),
     /* 285946 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285948 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285950 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285952 */       GIR_RootConstrainSelectedInstOperands,
     /* 285953 */       // GIR_Coverage, 559,
     /* 285953 */       GIR_EraseRootFromParent_Done,
     /* 285954 */     // Label 4716: @285954
     /* 285954 */     GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(285975), // Rule ID 561 //
     /* 285959 */       // MIs[0] Operand 1
     /* 285959 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 285964 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 285964 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I32_e64),
     /* 285967 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285969 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285971 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285973 */       GIR_RootConstrainSelectedInstOperands,
     /* 285974 */       // GIR_Coverage, 561,
     /* 285974 */       GIR_EraseRootFromParent_Done,
     /* 285975 */     // Label 4717: @285975
     /* 285975 */     GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(285996), // Rule ID 562 //
     /* 285980 */       // MIs[0] Operand 1
     /* 285980 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 285985 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 285985 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I32_e64),
     /* 285988 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285990 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285992 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 285994 */       GIR_RootConstrainSelectedInstOperands,
     /* 285995 */       // GIR_Coverage, 562,
     /* 285995 */       GIR_EraseRootFromParent_Done,
     /* 285996 */     // Label 4718: @285996
     /* 285996 */     GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(286017), // Rule ID 564 //
     /* 286001 */       // MIs[0] Operand 1
     /* 286001 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 286006 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286006 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I32_e64),
     /* 286009 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286011 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286013 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286015 */       GIR_RootConstrainSelectedInstOperands,
     /* 286016 */       // GIR_Coverage, 564,
     /* 286016 */       GIR_EraseRootFromParent_Done,
     /* 286017 */     // Label 4719: @286017
     /* 286017 */     GIM_Reject,
     /* 286018 */   // Label 4715: @286018
     /* 286018 */   GIM_Reject,
     /* 286019 */   // Label 4682: @286019
     /* 286019 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(286116),
     /* 286024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 286027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 286031 */     GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(286052), // Rule ID 575 //
     /* 286036 */       // MIs[0] Operand 1
     /* 286036 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 286041 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286041 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I64_e64),
     /* 286044 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286046 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286048 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286050 */       GIR_RootConstrainSelectedInstOperands,
     /* 286051 */       // GIR_Coverage, 575,
     /* 286051 */       GIR_EraseRootFromParent_Done,
     /* 286052 */     // Label 4721: @286052
     /* 286052 */     GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(286073), // Rule ID 577 //
     /* 286057 */       // MIs[0] Operand 1
     /* 286057 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 286062 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286062 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I64_e64),
     /* 286065 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286067 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286069 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286071 */       GIR_RootConstrainSelectedInstOperands,
     /* 286072 */       // GIR_Coverage, 577,
     /* 286072 */       GIR_EraseRootFromParent_Done,
     /* 286073 */     // Label 4722: @286073
     /* 286073 */     GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(286094), // Rule ID 578 //
     /* 286078 */       // MIs[0] Operand 1
     /* 286078 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 286083 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286083 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I64_e64),
     /* 286086 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286088 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286090 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286092 */       GIR_RootConstrainSelectedInstOperands,
     /* 286093 */       // GIR_Coverage, 578,
     /* 286093 */       GIR_EraseRootFromParent_Done,
     /* 286094 */     // Label 4723: @286094
     /* 286094 */     GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(286115), // Rule ID 580 //
     /* 286099 */       // MIs[0] Operand 1
     /* 286099 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 286104 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286104 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I64_e64),
     /* 286107 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286109 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286111 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286113 */       GIR_RootConstrainSelectedInstOperands,
     /* 286114 */       // GIR_Coverage, 580,
     /* 286114 */       GIR_EraseRootFromParent_Done,
     /* 286115 */     // Label 4724: @286115
     /* 286115 */     GIM_Reject,
     /* 286116 */   // Label 4720: @286116
     /* 286116 */   GIM_Reject,
     /* 286117 */   // Label 4683: @286117
     /* 286117 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 4727*/ GIMT_Encode4(286416),
     /* 286128 */   /*GILLT_s32*//*Label 4725*/ GIMT_Encode4(286136),
     /* 286132 */   /*GILLT_s64*//*Label 4726*/ GIMT_Encode4(286276),
     /* 286136 */   // Label 4725: @286136
     /* 286136 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(286275),
     /* 286141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 286144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 286148 */     GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(286169), // Rule ID 591 //
     /* 286153 */       // MIs[0] Operand 1
     /* 286153 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 286158 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286158 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U32_e64),
     /* 286161 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286163 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286165 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286167 */       GIR_RootConstrainSelectedInstOperands,
     /* 286168 */       // GIR_Coverage, 591,
     /* 286168 */       GIR_EraseRootFromParent_Done,
     /* 286169 */     // Label 4729: @286169
     /* 286169 */     GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(286190), // Rule ID 592 //
     /* 286174 */       // MIs[0] Operand 1
     /* 286174 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 286179 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286179 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U32_e64),
     /* 286182 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286184 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286186 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286188 */       GIR_RootConstrainSelectedInstOperands,
     /* 286189 */       // GIR_Coverage, 592,
     /* 286189 */       GIR_EraseRootFromParent_Done,
     /* 286190 */     // Label 4730: @286190
     /* 286190 */     GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(286211), // Rule ID 594 //
     /* 286195 */       // MIs[0] Operand 1
     /* 286195 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 286200 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286200 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U32_e64),
     /* 286203 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286205 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286207 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286209 */       GIR_RootConstrainSelectedInstOperands,
     /* 286210 */       // GIR_Coverage, 594,
     /* 286210 */       GIR_EraseRootFromParent_Done,
     /* 286211 */     // Label 4731: @286211
     /* 286211 */     GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(286232), // Rule ID 595 //
     /* 286216 */       // MIs[0] Operand 1
     /* 286216 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 286221 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286221 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U32_e64),
     /* 286224 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286226 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286228 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286230 */       GIR_RootConstrainSelectedInstOperands,
     /* 286231 */       // GIR_Coverage, 595,
     /* 286231 */       GIR_EraseRootFromParent_Done,
     /* 286232 */     // Label 4732: @286232
     /* 286232 */     GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(286253), // Rule ID 596 //
     /* 286237 */       // MIs[0] Operand 1
     /* 286237 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 286242 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286242 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U32_e64),
     /* 286245 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286247 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286249 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286251 */       GIR_RootConstrainSelectedInstOperands,
     /* 286252 */       // GIR_Coverage, 596,
     /* 286252 */       GIR_EraseRootFromParent_Done,
     /* 286253 */     // Label 4733: @286253
     /* 286253 */     GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(286274), // Rule ID 598 //
     /* 286258 */       // MIs[0] Operand 1
     /* 286258 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 286263 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286263 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U32_e64),
     /* 286266 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286268 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286270 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286272 */       GIR_RootConstrainSelectedInstOperands,
     /* 286273 */       // GIR_Coverage, 598,
     /* 286273 */       GIR_EraseRootFromParent_Done,
     /* 286274 */     // Label 4734: @286274
     /* 286274 */     GIM_Reject,
     /* 286275 */   // Label 4728: @286275
     /* 286275 */   GIM_Reject,
     /* 286276 */   // Label 4726: @286276
     /* 286276 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(286415),
     /* 286281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 286284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 286288 */     GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(286309), // Rule ID 609 //
     /* 286293 */       // MIs[0] Operand 1
     /* 286293 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 286298 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286298 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U64_e64),
     /* 286301 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286303 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286305 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286307 */       GIR_RootConstrainSelectedInstOperands,
     /* 286308 */       // GIR_Coverage, 609,
     /* 286308 */       GIR_EraseRootFromParent_Done,
     /* 286309 */     // Label 4736: @286309
     /* 286309 */     GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(286330), // Rule ID 610 //
     /* 286314 */       // MIs[0] Operand 1
     /* 286314 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 286319 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286319 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U64_e64),
     /* 286322 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286324 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286326 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286328 */       GIR_RootConstrainSelectedInstOperands,
     /* 286329 */       // GIR_Coverage, 610,
     /* 286329 */       GIR_EraseRootFromParent_Done,
     /* 286330 */     // Label 4737: @286330
     /* 286330 */     GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(286351), // Rule ID 612 //
     /* 286335 */       // MIs[0] Operand 1
     /* 286335 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 286340 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286340 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U64_e64),
     /* 286343 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286345 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286347 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286349 */       GIR_RootConstrainSelectedInstOperands,
     /* 286350 */       // GIR_Coverage, 612,
     /* 286350 */       GIR_EraseRootFromParent_Done,
     /* 286351 */     // Label 4738: @286351
     /* 286351 */     GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(286372), // Rule ID 613 //
     /* 286356 */       // MIs[0] Operand 1
     /* 286356 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 286361 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286361 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U64_e64),
     /* 286364 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286366 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286368 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286370 */       GIR_RootConstrainSelectedInstOperands,
     /* 286371 */       // GIR_Coverage, 613,
     /* 286371 */       GIR_EraseRootFromParent_Done,
     /* 286372 */     // Label 4739: @286372
     /* 286372 */     GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(286393), // Rule ID 614 //
     /* 286377 */       // MIs[0] Operand 1
     /* 286377 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 286382 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286382 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U64_e64),
     /* 286385 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286387 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286389 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286391 */       GIR_RootConstrainSelectedInstOperands,
     /* 286392 */       // GIR_Coverage, 614,
     /* 286392 */       GIR_EraseRootFromParent_Done,
     /* 286393 */     // Label 4740: @286393
     /* 286393 */     GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(286414), // Rule ID 616 //
     /* 286398 */       // MIs[0] Operand 1
     /* 286398 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 286403 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286403 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U64_e64),
     /* 286406 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286408 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286410 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 286412 */       GIR_RootConstrainSelectedInstOperands,
     /* 286413 */       // GIR_Coverage, 616,
     /* 286413 */       GIR_EraseRootFromParent_Done,
     /* 286414 */     // Label 4741: @286414
     /* 286414 */     GIM_Reject,
     /* 286415 */   // Label 4735: @286415
     /* 286415 */   GIM_Reject,
     /* 286416 */   // Label 4727: @286416
     /* 286416 */   GIM_Reject,
     /* 286417 */ // Label 4679: @286417
     /* 286417 */ GIM_Reject,
     /* 286418 */ // Label 52: @286418
     /* 286418 */ GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(290580),
     /* 286423 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 286426 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4746*/ GIMT_Encode4(290579),
     /* 286437 */   /*GILLT_s16*//*Label 4743*/ GIMT_Encode4(286449),
     /* 286441 */   /*GILLT_s32*//*Label 4744*/ GIMT_Encode4(288983),
     /* 286445 */   /*GILLT_s64*//*Label 4745*/ GIMT_Encode4(289781),
     /* 286449 */   // Label 4743: @286449
     /* 286449 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(288982),
     /* 286454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 286457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 286461 */     GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(286520), // Rule ID 345 //
     /* 286466 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 286469 */       // MIs[0] Operand 1
     /* 286469 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 286474 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286481 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 286488 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 286488 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F16_e64),
     /* 286491 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286493 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 286498 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286503 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 286508 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 286513 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 286518 */       GIR_RootConstrainSelectedInstOperands,
     /* 286519 */       // GIR_Coverage, 345,
     /* 286519 */       GIR_EraseRootFromParent_Done,
     /* 286520 */     // Label 4748: @286520
     /* 286520 */     GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(286582), // Rule ID 347 //
     /* 286525 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 286528 */       // MIs[0] Operand 1
     /* 286528 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 286533 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286540 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 286547 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 286547 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F16_t16_e64),
     /* 286550 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286552 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 286557 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286562 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 286567 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 286572 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 286577 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286580 */       GIR_RootConstrainSelectedInstOperands,
     /* 286581 */       // GIR_Coverage, 347,
     /* 286581 */       GIR_EraseRootFromParent_Done,
     /* 286582 */     // Label 4749: @286582
     /* 286582 */     GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(286641), // Rule ID 349 //
     /* 286587 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 286590 */       // MIs[0] Operand 1
     /* 286590 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 286595 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286602 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 286609 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 286609 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F16_fake16_e64),
     /* 286612 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286614 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 286619 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286624 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 286629 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 286634 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 286639 */       GIR_RootConstrainSelectedInstOperands,
     /* 286640 */       // GIR_Coverage, 349,
     /* 286640 */       GIR_EraseRootFromParent_Done,
     /* 286641 */     // Label 4750: @286641
     /* 286641 */     GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(286700), // Rule ID 351 //
     /* 286646 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 286649 */       // MIs[0] Operand 1
     /* 286649 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 286654 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286661 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 286668 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 286668 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_e64),
     /* 286671 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286673 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 286678 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286683 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 286688 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 286693 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 286698 */       GIR_RootConstrainSelectedInstOperands,
     /* 286699 */       // GIR_Coverage, 351,
     /* 286699 */       GIR_EraseRootFromParent_Done,
     /* 286700 */     // Label 4751: @286700
     /* 286700 */     GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(286762), // Rule ID 353 //
     /* 286705 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 286708 */       // MIs[0] Operand 1
     /* 286708 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 286713 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286720 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 286727 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 286727 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_t16_e64),
     /* 286730 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286732 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 286737 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286742 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 286747 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 286752 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 286757 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286760 */       GIR_RootConstrainSelectedInstOperands,
     /* 286761 */       // GIR_Coverage, 353,
     /* 286761 */       GIR_EraseRootFromParent_Done,
     /* 286762 */     // Label 4752: @286762
     /* 286762 */     GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(286821), // Rule ID 355 //
     /* 286767 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 286770 */       // MIs[0] Operand 1
     /* 286770 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 286775 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286782 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 286789 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 286789 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_fake16_e64),
     /* 286792 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286794 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 286799 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286804 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 286809 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 286814 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 286819 */       GIR_RootConstrainSelectedInstOperands,
     /* 286820 */       // GIR_Coverage, 355,
     /* 286820 */       GIR_EraseRootFromParent_Done,
     /* 286821 */     // Label 4753: @286821
     /* 286821 */     GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(286880), // Rule ID 357 //
     /* 286826 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 286829 */       // MIs[0] Operand 1
     /* 286829 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 286834 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286841 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 286848 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 286848 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F16_e64),
     /* 286851 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286853 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 286858 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286863 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 286868 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 286873 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 286878 */       GIR_RootConstrainSelectedInstOperands,
     /* 286879 */       // GIR_Coverage, 357,
     /* 286879 */       GIR_EraseRootFromParent_Done,
     /* 286880 */     // Label 4754: @286880
     /* 286880 */     GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(286942), // Rule ID 359 //
     /* 286885 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 286888 */       // MIs[0] Operand 1
     /* 286888 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 286893 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286900 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 286907 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 286907 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F16_t16_e64),
     /* 286910 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286912 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 286917 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286922 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 286927 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 286932 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 286937 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286940 */       GIR_RootConstrainSelectedInstOperands,
     /* 286941 */       // GIR_Coverage, 359,
     /* 286941 */       GIR_EraseRootFromParent_Done,
     /* 286942 */     // Label 4755: @286942
     /* 286942 */     GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(287001), // Rule ID 361 //
     /* 286947 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 286950 */       // MIs[0] Operand 1
     /* 286950 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 286955 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286962 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 286969 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 286969 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F16_fake16_e64),
     /* 286972 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286974 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 286979 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286984 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 286989 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 286994 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 286999 */       GIR_RootConstrainSelectedInstOperands,
     /* 287000 */       // GIR_Coverage, 361,
     /* 287000 */       GIR_EraseRootFromParent_Done,
     /* 287001 */     // Label 4756: @287001
     /* 287001 */     GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(287060), // Rule ID 363 //
     /* 287006 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 287009 */       // MIs[0] Operand 1
     /* 287009 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 287014 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287021 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287028 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287028 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F16_e64),
     /* 287031 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287033 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287038 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287043 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287048 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287053 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287058 */       GIR_RootConstrainSelectedInstOperands,
     /* 287059 */       // GIR_Coverage, 363,
     /* 287059 */       GIR_EraseRootFromParent_Done,
     /* 287060 */     // Label 4757: @287060
     /* 287060 */     GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(287122), // Rule ID 365 //
     /* 287065 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 287068 */       // MIs[0] Operand 1
     /* 287068 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 287073 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287080 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287087 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287087 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F16_t16_e64),
     /* 287090 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287092 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287097 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287102 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287107 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287112 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287117 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287120 */       GIR_RootConstrainSelectedInstOperands,
     /* 287121 */       // GIR_Coverage, 365,
     /* 287121 */       GIR_EraseRootFromParent_Done,
     /* 287122 */     // Label 4758: @287122
     /* 287122 */     GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(287181), // Rule ID 367 //
     /* 287127 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 287130 */       // MIs[0] Operand 1
     /* 287130 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 287135 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287142 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287149 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287149 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F16_fake16_e64),
     /* 287152 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287154 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287159 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287164 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287169 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287174 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287179 */       GIR_RootConstrainSelectedInstOperands,
     /* 287180 */       // GIR_Coverage, 367,
     /* 287180 */       GIR_EraseRootFromParent_Done,
     /* 287181 */     // Label 4759: @287181
     /* 287181 */     GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(287240), // Rule ID 369 //
     /* 287186 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 287189 */       // MIs[0] Operand 1
     /* 287189 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 287194 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287201 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287208 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287208 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F16_e64),
     /* 287211 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287213 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287218 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287223 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287228 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287233 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287238 */       GIR_RootConstrainSelectedInstOperands,
     /* 287239 */       // GIR_Coverage, 369,
     /* 287239 */       GIR_EraseRootFromParent_Done,
     /* 287240 */     // Label 4760: @287240
     /* 287240 */     GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(287302), // Rule ID 371 //
     /* 287245 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 287248 */       // MIs[0] Operand 1
     /* 287248 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 287253 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287260 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287267 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287267 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F16_t16_e64),
     /* 287270 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287272 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287277 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287282 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287287 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287292 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287297 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287300 */       GIR_RootConstrainSelectedInstOperands,
     /* 287301 */       // GIR_Coverage, 371,
     /* 287301 */       GIR_EraseRootFromParent_Done,
     /* 287302 */     // Label 4761: @287302
     /* 287302 */     GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(287361), // Rule ID 373 //
     /* 287307 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 287310 */       // MIs[0] Operand 1
     /* 287310 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 287315 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287322 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287329 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287329 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F16_fake16_e64),
     /* 287332 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287334 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287339 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287344 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287349 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287354 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287359 */       GIR_RootConstrainSelectedInstOperands,
     /* 287360 */       // GIR_Coverage, 373,
     /* 287360 */       GIR_EraseRootFromParent_Done,
     /* 287361 */     // Label 4762: @287361
     /* 287361 */     GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(287420), // Rule ID 375 //
     /* 287366 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 287369 */       // MIs[0] Operand 1
     /* 287369 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 287374 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287381 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287388 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287388 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F16_e64),
     /* 287391 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287393 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287398 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287403 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287408 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287413 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287418 */       GIR_RootConstrainSelectedInstOperands,
     /* 287419 */       // GIR_Coverage, 375,
     /* 287419 */       GIR_EraseRootFromParent_Done,
     /* 287420 */     // Label 4763: @287420
     /* 287420 */     GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(287482), // Rule ID 377 //
     /* 287425 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 287428 */       // MIs[0] Operand 1
     /* 287428 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 287433 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287440 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287447 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287447 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F16_t16_e64),
     /* 287450 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287452 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287457 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287462 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287467 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287472 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287477 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287480 */       GIR_RootConstrainSelectedInstOperands,
     /* 287481 */       // GIR_Coverage, 377,
     /* 287481 */       GIR_EraseRootFromParent_Done,
     /* 287482 */     // Label 4764: @287482
     /* 287482 */     GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(287541), // Rule ID 379 //
     /* 287487 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 287490 */       // MIs[0] Operand 1
     /* 287490 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 287495 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287502 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287509 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287509 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F16_fake16_e64),
     /* 287512 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287514 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287519 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287524 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287529 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287534 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287539 */       GIR_RootConstrainSelectedInstOperands,
     /* 287540 */       // GIR_Coverage, 379,
     /* 287540 */       GIR_EraseRootFromParent_Done,
     /* 287541 */     // Label 4765: @287541
     /* 287541 */     GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(287600), // Rule ID 381 //
     /* 287546 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 287549 */       // MIs[0] Operand 1
     /* 287549 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 287554 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287561 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287568 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287568 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F16_e64),
     /* 287571 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287573 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287578 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287583 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287588 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287593 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287598 */       GIR_RootConstrainSelectedInstOperands,
     /* 287599 */       // GIR_Coverage, 381,
     /* 287599 */       GIR_EraseRootFromParent_Done,
     /* 287600 */     // Label 4766: @287600
     /* 287600 */     GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(287662), // Rule ID 382 //
     /* 287605 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 287608 */       // MIs[0] Operand 1
     /* 287608 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 287613 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287620 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287627 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287627 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F16_t16_e64),
     /* 287630 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287632 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287637 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287642 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287647 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287652 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287657 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287660 */       GIR_RootConstrainSelectedInstOperands,
     /* 287661 */       // GIR_Coverage, 382,
     /* 287661 */       GIR_EraseRootFromParent_Done,
     /* 287662 */     // Label 4767: @287662
     /* 287662 */     GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(287721), // Rule ID 383 //
     /* 287667 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 287670 */       // MIs[0] Operand 1
     /* 287670 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 287675 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287682 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287689 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287689 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F16_fake16_e64),
     /* 287692 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287694 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287699 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287704 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287709 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287714 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287719 */       GIR_RootConstrainSelectedInstOperands,
     /* 287720 */       // GIR_Coverage, 383,
     /* 287720 */       GIR_EraseRootFromParent_Done,
     /* 287721 */     // Label 4768: @287721
     /* 287721 */     GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(287780), // Rule ID 384 //
     /* 287726 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 287729 */       // MIs[0] Operand 1
     /* 287729 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 287734 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287741 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287748 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287748 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F16_e64),
     /* 287751 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287753 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287758 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287763 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287768 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287773 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287778 */       GIR_RootConstrainSelectedInstOperands,
     /* 287779 */       // GIR_Coverage, 384,
     /* 287779 */       GIR_EraseRootFromParent_Done,
     /* 287780 */     // Label 4769: @287780
     /* 287780 */     GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(287842), // Rule ID 385 //
     /* 287785 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 287788 */       // MIs[0] Operand 1
     /* 287788 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 287793 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287800 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287807 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287807 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F16_t16_e64),
     /* 287810 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287812 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287817 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287822 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287827 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287832 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287837 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287840 */       GIR_RootConstrainSelectedInstOperands,
     /* 287841 */       // GIR_Coverage, 385,
     /* 287841 */       GIR_EraseRootFromParent_Done,
     /* 287842 */     // Label 4770: @287842
     /* 287842 */     GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(287901), // Rule ID 386 //
     /* 287847 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 287850 */       // MIs[0] Operand 1
     /* 287850 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 287855 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287862 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287869 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287869 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F16_fake16_e64),
     /* 287872 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287874 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287879 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287884 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287889 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287894 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287899 */       GIR_RootConstrainSelectedInstOperands,
     /* 287900 */       // GIR_Coverage, 386,
     /* 287900 */       GIR_EraseRootFromParent_Done,
     /* 287901 */     // Label 4771: @287901
     /* 287901 */     GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(287960), // Rule ID 387 //
     /* 287906 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 287909 */       // MIs[0] Operand 1
     /* 287909 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 287914 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287921 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287928 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287928 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F16_e64),
     /* 287931 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287933 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287938 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287943 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 287948 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 287953 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 287958 */       GIR_RootConstrainSelectedInstOperands,
     /* 287959 */       // GIR_Coverage, 387,
     /* 287959 */       GIR_EraseRootFromParent_Done,
     /* 287960 */     // Label 4772: @287960
     /* 287960 */     GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(288022), // Rule ID 388 //
     /* 287965 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 287968 */       // MIs[0] Operand 1
     /* 287968 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 287973 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287980 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 287987 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 287987 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F16_t16_e64),
     /* 287990 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287992 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 287997 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288002 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288007 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288012 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288017 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288020 */       GIR_RootConstrainSelectedInstOperands,
     /* 288021 */       // GIR_Coverage, 388,
     /* 288021 */       GIR_EraseRootFromParent_Done,
     /* 288022 */     // Label 4773: @288022
     /* 288022 */     GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(288081), // Rule ID 389 //
     /* 288027 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 288030 */       // MIs[0] Operand 1
     /* 288030 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 288035 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288042 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288049 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288049 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F16_fake16_e64),
     /* 288052 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288054 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288059 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288064 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288069 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288074 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288079 */       GIR_RootConstrainSelectedInstOperands,
     /* 288080 */       // GIR_Coverage, 389,
     /* 288080 */       GIR_EraseRootFromParent_Done,
     /* 288081 */     // Label 4774: @288081
     /* 288081 */     GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(288140), // Rule ID 390 //
     /* 288086 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 288089 */       // MIs[0] Operand 1
     /* 288089 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 288094 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288101 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288108 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288108 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F16_e64),
     /* 288111 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288113 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288118 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288123 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288128 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288133 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288138 */       GIR_RootConstrainSelectedInstOperands,
     /* 288139 */       // GIR_Coverage, 390,
     /* 288139 */       GIR_EraseRootFromParent_Done,
     /* 288140 */     // Label 4775: @288140
     /* 288140 */     GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(288202), // Rule ID 391 //
     /* 288145 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 288148 */       // MIs[0] Operand 1
     /* 288148 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 288153 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288160 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288167 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288167 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F16_t16_e64),
     /* 288170 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288172 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288177 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288182 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288187 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288192 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288197 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288200 */       GIR_RootConstrainSelectedInstOperands,
     /* 288201 */       // GIR_Coverage, 391,
     /* 288201 */       GIR_EraseRootFromParent_Done,
     /* 288202 */     // Label 4776: @288202
     /* 288202 */     GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(288261), // Rule ID 392 //
     /* 288207 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 288210 */       // MIs[0] Operand 1
     /* 288210 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 288215 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288222 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288229 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288229 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F16_fake16_e64),
     /* 288232 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288234 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288239 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288244 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288249 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288254 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288259 */       GIR_RootConstrainSelectedInstOperands,
     /* 288260 */       // GIR_Coverage, 392,
     /* 288260 */       GIR_EraseRootFromParent_Done,
     /* 288261 */     // Label 4777: @288261
     /* 288261 */     GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(288320), // Rule ID 393 //
     /* 288266 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 288269 */       // MIs[0] Operand 1
     /* 288269 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 288274 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288281 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288288 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288288 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F16_e64),
     /* 288291 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288293 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288298 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288303 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288308 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288313 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288318 */       GIR_RootConstrainSelectedInstOperands,
     /* 288319 */       // GIR_Coverage, 393,
     /* 288319 */       GIR_EraseRootFromParent_Done,
     /* 288320 */     // Label 4778: @288320
     /* 288320 */     GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(288382), // Rule ID 394 //
     /* 288325 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 288328 */       // MIs[0] Operand 1
     /* 288328 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 288333 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288340 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288347 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288347 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F16_t16_e64),
     /* 288350 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288352 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288357 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288362 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288367 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288372 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288377 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288380 */       GIR_RootConstrainSelectedInstOperands,
     /* 288381 */       // GIR_Coverage, 394,
     /* 288381 */       GIR_EraseRootFromParent_Done,
     /* 288382 */     // Label 4779: @288382
     /* 288382 */     GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(288441), // Rule ID 395 //
     /* 288387 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 288390 */       // MIs[0] Operand 1
     /* 288390 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 288395 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288402 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288409 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288409 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F16_fake16_e64),
     /* 288412 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288414 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288419 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288424 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288429 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288434 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288439 */       GIR_RootConstrainSelectedInstOperands,
     /* 288440 */       // GIR_Coverage, 395,
     /* 288440 */       GIR_EraseRootFromParent_Done,
     /* 288441 */     // Label 4780: @288441
     /* 288441 */     GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(288500), // Rule ID 396 //
     /* 288446 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 288449 */       // MIs[0] Operand 1
     /* 288449 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 288454 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288461 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288468 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288468 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F16_e64),
     /* 288471 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288473 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288478 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288483 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288488 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288493 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288498 */       GIR_RootConstrainSelectedInstOperands,
     /* 288499 */       // GIR_Coverage, 396,
     /* 288499 */       GIR_EraseRootFromParent_Done,
     /* 288500 */     // Label 4781: @288500
     /* 288500 */     GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(288562), // Rule ID 397 //
     /* 288505 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 288508 */       // MIs[0] Operand 1
     /* 288508 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 288513 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288520 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288527 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288527 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F16_t16_e64),
     /* 288530 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288532 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288537 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288542 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288547 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288552 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288557 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288560 */       GIR_RootConstrainSelectedInstOperands,
     /* 288561 */       // GIR_Coverage, 397,
     /* 288561 */       GIR_EraseRootFromParent_Done,
     /* 288562 */     // Label 4782: @288562
     /* 288562 */     GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(288621), // Rule ID 398 //
     /* 288567 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 288570 */       // MIs[0] Operand 1
     /* 288570 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 288575 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288582 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288589 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288589 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F16_fake16_e64),
     /* 288592 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288594 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288599 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288604 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288609 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288614 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288619 */       GIR_RootConstrainSelectedInstOperands,
     /* 288620 */       // GIR_Coverage, 398,
     /* 288620 */       GIR_EraseRootFromParent_Done,
     /* 288621 */     // Label 4783: @288621
     /* 288621 */     GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(288680), // Rule ID 399 //
     /* 288626 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 288629 */       // MIs[0] Operand 1
     /* 288629 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 288634 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288641 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288648 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288648 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F16_e64),
     /* 288651 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288653 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288658 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288663 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288668 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288673 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288678 */       GIR_RootConstrainSelectedInstOperands,
     /* 288679 */       // GIR_Coverage, 399,
     /* 288679 */       GIR_EraseRootFromParent_Done,
     /* 288680 */     // Label 4784: @288680
     /* 288680 */     GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(288742), // Rule ID 400 //
     /* 288685 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 288688 */       // MIs[0] Operand 1
     /* 288688 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 288693 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288700 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288707 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288707 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F16_t16_e64),
     /* 288710 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288712 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288717 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288722 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288727 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288732 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288737 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288740 */       GIR_RootConstrainSelectedInstOperands,
     /* 288741 */       // GIR_Coverage, 400,
     /* 288741 */       GIR_EraseRootFromParent_Done,
     /* 288742 */     // Label 4785: @288742
     /* 288742 */     GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(288801), // Rule ID 401 //
     /* 288747 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 288750 */       // MIs[0] Operand 1
     /* 288750 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 288755 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288762 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288769 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288769 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F16_fake16_e64),
     /* 288772 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288774 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288779 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288784 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288789 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288794 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288799 */       GIR_RootConstrainSelectedInstOperands,
     /* 288800 */       // GIR_Coverage, 401,
     /* 288800 */       GIR_EraseRootFromParent_Done,
     /* 288801 */     // Label 4786: @288801
     /* 288801 */     GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(288860), // Rule ID 402 //
     /* 288806 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 288809 */       // MIs[0] Operand 1
     /* 288809 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 288814 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288821 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288828 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288828 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F16_e64),
     /* 288831 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288833 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288838 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288843 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288848 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288853 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288858 */       GIR_RootConstrainSelectedInstOperands,
     /* 288859 */       // GIR_Coverage, 402,
     /* 288859 */       GIR_EraseRootFromParent_Done,
     /* 288860 */     // Label 4787: @288860
     /* 288860 */     GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(288922), // Rule ID 403 //
     /* 288865 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 288868 */       // MIs[0] Operand 1
     /* 288868 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 288873 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288880 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288887 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288887 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F16_t16_e64),
     /* 288890 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288892 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288897 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288902 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288907 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288912 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288917 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288920 */       GIR_RootConstrainSelectedInstOperands,
     /* 288921 */       // GIR_Coverage, 403,
     /* 288921 */       GIR_EraseRootFromParent_Done,
     /* 288922 */     // Label 4788: @288922
     /* 288922 */     GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(288981), // Rule ID 404 //
     /* 288927 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 288930 */       // MIs[0] Operand 1
     /* 288930 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 288935 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288942 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 288949 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 288949 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F16_fake16_e64),
     /* 288952 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288954 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288959 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288964 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288969 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288974 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 288979 */       GIR_RootConstrainSelectedInstOperands,
     /* 288980 */       // GIR_Coverage, 404,
     /* 288980 */       GIR_EraseRootFromParent_Done,
     /* 288981 */     // Label 4789: @288981
     /* 288981 */     GIM_Reject,
     /* 288982 */   // Label 4747: @288982
     /* 288982 */   GIM_Reject,
     /* 288983 */   // Label 4744: @288983
     /* 288983 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(289780),
     /* 288988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 288991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 288995 */     GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(289051), // Rule ID 203 //
     /* 289000 */       // MIs[0] Operand 1
     /* 289000 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 289005 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289012 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289019 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289019 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F32_e64),
     /* 289022 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289024 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289029 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289034 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289039 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289044 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289049 */       GIR_RootConstrainSelectedInstOperands,
     /* 289050 */       // GIR_Coverage, 203,
     /* 289050 */       GIR_EraseRootFromParent_Done,
     /* 289051 */     // Label 4791: @289051
     /* 289051 */     GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(289107), // Rule ID 205 //
     /* 289056 */       // MIs[0] Operand 1
     /* 289056 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 289061 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289068 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289075 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289075 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F32_e64),
     /* 289078 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289080 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289085 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289090 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289095 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289100 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289105 */       GIR_RootConstrainSelectedInstOperands,
     /* 289106 */       // GIR_Coverage, 205,
     /* 289106 */       GIR_EraseRootFromParent_Done,
     /* 289107 */     // Label 4792: @289107
     /* 289107 */     GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(289163), // Rule ID 207 //
     /* 289112 */       // MIs[0] Operand 1
     /* 289112 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 289117 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289124 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289131 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289131 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F32_e64),
     /* 289134 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289136 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289141 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289146 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289151 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289156 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289161 */       GIR_RootConstrainSelectedInstOperands,
     /* 289162 */       // GIR_Coverage, 207,
     /* 289162 */       GIR_EraseRootFromParent_Done,
     /* 289163 */     // Label 4793: @289163
     /* 289163 */     GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(289219), // Rule ID 209 //
     /* 289168 */       // MIs[0] Operand 1
     /* 289168 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 289173 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289180 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289187 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289187 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F32_e64),
     /* 289190 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289192 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289197 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289202 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289207 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289212 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289217 */       GIR_RootConstrainSelectedInstOperands,
     /* 289218 */       // GIR_Coverage, 209,
     /* 289218 */       GIR_EraseRootFromParent_Done,
     /* 289219 */     // Label 4794: @289219
     /* 289219 */     GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(289275), // Rule ID 211 //
     /* 289224 */       // MIs[0] Operand 1
     /* 289224 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 289229 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289236 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289243 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289243 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F32_e64),
     /* 289246 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289248 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289253 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289258 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289263 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289268 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289273 */       GIR_RootConstrainSelectedInstOperands,
     /* 289274 */       // GIR_Coverage, 211,
     /* 289274 */       GIR_EraseRootFromParent_Done,
     /* 289275 */     // Label 4795: @289275
     /* 289275 */     GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(289331), // Rule ID 213 //
     /* 289280 */       // MIs[0] Operand 1
     /* 289280 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 289285 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289292 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289299 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289299 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F32_e64),
     /* 289302 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289304 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289309 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289314 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289319 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289324 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289329 */       GIR_RootConstrainSelectedInstOperands,
     /* 289330 */       // GIR_Coverage, 213,
     /* 289330 */       GIR_EraseRootFromParent_Done,
     /* 289331 */     // Label 4796: @289331
     /* 289331 */     GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(289387), // Rule ID 215 //
     /* 289336 */       // MIs[0] Operand 1
     /* 289336 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 289341 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289348 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289355 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289355 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F32_e64),
     /* 289358 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289360 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289365 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289370 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289375 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289380 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289385 */       GIR_RootConstrainSelectedInstOperands,
     /* 289386 */       // GIR_Coverage, 215,
     /* 289386 */       GIR_EraseRootFromParent_Done,
     /* 289387 */     // Label 4797: @289387
     /* 289387 */     GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(289443), // Rule ID 216 //
     /* 289392 */       // MIs[0] Operand 1
     /* 289392 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 289397 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289404 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289411 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289411 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F32_e64),
     /* 289414 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289416 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289421 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289426 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289431 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289436 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289441 */       GIR_RootConstrainSelectedInstOperands,
     /* 289442 */       // GIR_Coverage, 216,
     /* 289442 */       GIR_EraseRootFromParent_Done,
     /* 289443 */     // Label 4798: @289443
     /* 289443 */     GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(289499), // Rule ID 217 //
     /* 289448 */       // MIs[0] Operand 1
     /* 289448 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 289453 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289460 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289467 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289467 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F32_e64),
     /* 289470 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289472 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289477 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289482 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289487 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289492 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289497 */       GIR_RootConstrainSelectedInstOperands,
     /* 289498 */       // GIR_Coverage, 217,
     /* 289498 */       GIR_EraseRootFromParent_Done,
     /* 289499 */     // Label 4799: @289499
     /* 289499 */     GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(289555), // Rule ID 218 //
     /* 289504 */       // MIs[0] Operand 1
     /* 289504 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 289509 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289516 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289523 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289523 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F32_e64),
     /* 289526 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289528 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289533 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289538 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289543 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289548 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289553 */       GIR_RootConstrainSelectedInstOperands,
     /* 289554 */       // GIR_Coverage, 218,
     /* 289554 */       GIR_EraseRootFromParent_Done,
     /* 289555 */     // Label 4800: @289555
     /* 289555 */     GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(289611), // Rule ID 219 //
     /* 289560 */       // MIs[0] Operand 1
     /* 289560 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 289565 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289572 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289579 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289579 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F32_e64),
     /* 289582 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289584 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289589 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289594 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289599 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289604 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289609 */       GIR_RootConstrainSelectedInstOperands,
     /* 289610 */       // GIR_Coverage, 219,
     /* 289610 */       GIR_EraseRootFromParent_Done,
     /* 289611 */     // Label 4801: @289611
     /* 289611 */     GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(289667), // Rule ID 220 //
     /* 289616 */       // MIs[0] Operand 1
     /* 289616 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 289621 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289628 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289635 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289635 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F32_e64),
     /* 289638 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289640 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289645 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289650 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289655 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289660 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289665 */       GIR_RootConstrainSelectedInstOperands,
     /* 289666 */       // GIR_Coverage, 220,
     /* 289666 */       GIR_EraseRootFromParent_Done,
     /* 289667 */     // Label 4802: @289667
     /* 289667 */     GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(289723), // Rule ID 221 //
     /* 289672 */       // MIs[0] Operand 1
     /* 289672 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 289677 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289684 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289691 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289691 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F32_e64),
     /* 289694 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289696 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289701 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289706 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289711 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289716 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289721 */       GIR_RootConstrainSelectedInstOperands,
     /* 289722 */       // GIR_Coverage, 221,
     /* 289722 */       GIR_EraseRootFromParent_Done,
     /* 289723 */     // Label 4803: @289723
     /* 289723 */     GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(289779), // Rule ID 222 //
     /* 289728 */       // MIs[0] Operand 1
     /* 289728 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 289733 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289740 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289747 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289747 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F32_e64),
     /* 289750 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289752 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289757 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289762 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289767 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289772 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289777 */       GIR_RootConstrainSelectedInstOperands,
     /* 289778 */       // GIR_Coverage, 222,
     /* 289778 */       GIR_EraseRootFromParent_Done,
     /* 289779 */     // Label 4804: @289779
     /* 289779 */     GIM_Reject,
     /* 289780 */   // Label 4790: @289780
     /* 289780 */   GIM_Reject,
     /* 289781 */   // Label 4745: @289781
     /* 289781 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(290578),
     /* 289786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 289789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 289793 */     GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(289849), // Rule ID 241 //
     /* 289798 */       // MIs[0] Operand 1
     /* 289798 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 289803 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289810 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289817 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289817 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F64_e64),
     /* 289820 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289822 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289827 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289832 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289837 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289842 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289847 */       GIR_RootConstrainSelectedInstOperands,
     /* 289848 */       // GIR_Coverage, 241,
     /* 289848 */       GIR_EraseRootFromParent_Done,
     /* 289849 */     // Label 4806: @289849
     /* 289849 */     GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(289905), // Rule ID 243 //
     /* 289854 */       // MIs[0] Operand 1
     /* 289854 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 289859 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289866 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289873 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289873 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F64_e64),
     /* 289876 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289878 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289883 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289888 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289893 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289898 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289903 */       GIR_RootConstrainSelectedInstOperands,
     /* 289904 */       // GIR_Coverage, 243,
     /* 289904 */       GIR_EraseRootFromParent_Done,
     /* 289905 */     // Label 4807: @289905
     /* 289905 */     GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(289961), // Rule ID 245 //
     /* 289910 */       // MIs[0] Operand 1
     /* 289910 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 289915 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289922 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289929 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289929 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F64_e64),
     /* 289932 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289934 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289939 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289944 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289949 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289954 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 289959 */       GIR_RootConstrainSelectedInstOperands,
     /* 289960 */       // GIR_Coverage, 245,
     /* 289960 */       GIR_EraseRootFromParent_Done,
     /* 289961 */     // Label 4808: @289961
     /* 289961 */     GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(290017), // Rule ID 247 //
     /* 289966 */       // MIs[0] Operand 1
     /* 289966 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 289971 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289978 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289985 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 289985 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F64_e64),
     /* 289988 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289990 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289995 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290000 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290005 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290010 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290015 */       GIR_RootConstrainSelectedInstOperands,
     /* 290016 */       // GIR_Coverage, 247,
     /* 290016 */       GIR_EraseRootFromParent_Done,
     /* 290017 */     // Label 4809: @290017
     /* 290017 */     GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(290073), // Rule ID 249 //
     /* 290022 */       // MIs[0] Operand 1
     /* 290022 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 290027 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290034 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290041 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290041 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F64_e64),
     /* 290044 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290046 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290051 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290056 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290061 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290066 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290071 */       GIR_RootConstrainSelectedInstOperands,
     /* 290072 */       // GIR_Coverage, 249,
     /* 290072 */       GIR_EraseRootFromParent_Done,
     /* 290073 */     // Label 4810: @290073
     /* 290073 */     GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(290129), // Rule ID 251 //
     /* 290078 */       // MIs[0] Operand 1
     /* 290078 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 290083 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290090 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290097 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290097 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F64_e64),
     /* 290100 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290102 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290107 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290112 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290117 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290122 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290127 */       GIR_RootConstrainSelectedInstOperands,
     /* 290128 */       // GIR_Coverage, 251,
     /* 290128 */       GIR_EraseRootFromParent_Done,
     /* 290129 */     // Label 4811: @290129
     /* 290129 */     GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(290185), // Rule ID 253 //
     /* 290134 */       // MIs[0] Operand 1
     /* 290134 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 290139 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290146 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290153 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290153 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F64_e64),
     /* 290156 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290158 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290163 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290168 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290173 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290178 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290183 */       GIR_RootConstrainSelectedInstOperands,
     /* 290184 */       // GIR_Coverage, 253,
     /* 290184 */       GIR_EraseRootFromParent_Done,
     /* 290185 */     // Label 4812: @290185
     /* 290185 */     GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(290241), // Rule ID 254 //
     /* 290190 */       // MIs[0] Operand 1
     /* 290190 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 290195 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290202 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290209 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290209 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F64_e64),
     /* 290212 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290214 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290219 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290224 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290229 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290234 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290239 */       GIR_RootConstrainSelectedInstOperands,
     /* 290240 */       // GIR_Coverage, 254,
     /* 290240 */       GIR_EraseRootFromParent_Done,
     /* 290241 */     // Label 4813: @290241
     /* 290241 */     GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(290297), // Rule ID 255 //
     /* 290246 */       // MIs[0] Operand 1
     /* 290246 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 290251 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290258 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290265 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290265 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F64_e64),
     /* 290268 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290270 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290275 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290280 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290285 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290290 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290295 */       GIR_RootConstrainSelectedInstOperands,
     /* 290296 */       // GIR_Coverage, 255,
     /* 290296 */       GIR_EraseRootFromParent_Done,
     /* 290297 */     // Label 4814: @290297
     /* 290297 */     GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(290353), // Rule ID 256 //
     /* 290302 */       // MIs[0] Operand 1
     /* 290302 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 290307 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290314 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290321 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290321 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F64_e64),
     /* 290324 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290326 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290331 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290336 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290341 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290346 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290351 */       GIR_RootConstrainSelectedInstOperands,
     /* 290352 */       // GIR_Coverage, 256,
     /* 290352 */       GIR_EraseRootFromParent_Done,
     /* 290353 */     // Label 4815: @290353
     /* 290353 */     GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(290409), // Rule ID 257 //
     /* 290358 */       // MIs[0] Operand 1
     /* 290358 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 290363 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290370 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290377 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290377 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F64_e64),
     /* 290380 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290382 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290387 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290392 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290397 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290402 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290407 */       GIR_RootConstrainSelectedInstOperands,
     /* 290408 */       // GIR_Coverage, 257,
     /* 290408 */       GIR_EraseRootFromParent_Done,
     /* 290409 */     // Label 4816: @290409
     /* 290409 */     GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(290465), // Rule ID 258 //
     /* 290414 */       // MIs[0] Operand 1
     /* 290414 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 290419 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290426 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290433 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290433 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F64_e64),
     /* 290436 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290438 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290443 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290448 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290453 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290458 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290463 */       GIR_RootConstrainSelectedInstOperands,
     /* 290464 */       // GIR_Coverage, 258,
     /* 290464 */       GIR_EraseRootFromParent_Done,
     /* 290465 */     // Label 4817: @290465
     /* 290465 */     GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(290521), // Rule ID 259 //
     /* 290470 */       // MIs[0] Operand 1
     /* 290470 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 290475 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290482 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290489 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290489 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F64_e64),
     /* 290492 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290494 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290499 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290504 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290509 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290514 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290519 */       GIR_RootConstrainSelectedInstOperands,
     /* 290520 */       // GIR_Coverage, 259,
     /* 290520 */       GIR_EraseRootFromParent_Done,
     /* 290521 */     // Label 4818: @290521
     /* 290521 */     GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(290577), // Rule ID 260 //
     /* 290526 */       // MIs[0] Operand 1
     /* 290526 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 290531 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290538 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290545 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290545 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F64_e64),
     /* 290548 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290550 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290555 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290560 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290565 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290570 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290575 */       GIR_RootConstrainSelectedInstOperands,
     /* 290576 */       // GIR_Coverage, 260,
     /* 290576 */       GIR_EraseRootFromParent_Done,
     /* 290577 */     // Label 4819: @290577
     /* 290577 */     GIM_Reject,
     /* 290578 */   // Label 4805: @290578
     /* 290578 */   GIM_Reject,
     /* 290579 */   // Label 4746: @290579
     /* 290579 */   GIM_Reject,
     /* 290580 */ // Label 4742: @290580
     /* 290580 */ GIM_Reject,
     /* 290581 */ // Label 53: @290581
     /* 290581 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4822*/ GIMT_Encode4(290924),
     /* 290592 */ /*GILLT_s16*//*Label 4820*/ GIMT_Encode4(290600),
     /* 290596 */ /*GILLT_s32*//*Label 4821*/ GIMT_Encode4(290808),
     /* 290600 */ // Label 4820: @290600
     /* 290600 */ GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(290807),
     /* 290605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 290608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 290611 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 290614 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(290645), // Rule ID 7013 //
     /* 290619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 290622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 290626 */     // (select:{ *:[f16] } i1:{ *:[i1] }:$src0, f16:{ *:[f16] }:$src1, f16:{ *:[f16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[f16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 290626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 290629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 290631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290634 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 290636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290639 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 290641 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 290643 */     GIR_RootConstrainSelectedInstOperands,
     /* 290644 */     // GIR_Coverage, 7013,
     /* 290644 */     GIR_EraseRootFromParent_Done,
     /* 290645 */   // Label 4824: @290645
     /* 290645 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(290676), // Rule ID 7014 //
     /* 290650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 290653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 290657 */     // (select:{ *:[i16] } i1:{ *:[i1] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 290657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 290660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 290662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290665 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 290667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290670 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 290672 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 290674 */     GIR_RootConstrainSelectedInstOperands,
     /* 290675 */     // GIR_Coverage, 7014,
     /* 290675 */     GIR_EraseRootFromParent_Done,
     /* 290676 */   // Label 4825: @290676
     /* 290676 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(290707), // Rule ID 7015 //
     /* 290681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 290684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 290688 */     // (select:{ *:[f16] } i1:{ *:[i1] }:$src0, f16:{ *:[f16] }:$src1, f16:{ *:[f16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[f16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 290688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 290691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 290693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290696 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 290698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290701 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 290703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 290705 */     GIR_RootConstrainSelectedInstOperands,
     /* 290706 */     // GIR_Coverage, 7015,
     /* 290706 */     GIR_EraseRootFromParent_Done,
     /* 290707 */   // Label 4826: @290707
     /* 290707 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(290738), // Rule ID 7016 //
     /* 290712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 290715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 290719 */     // (select:{ *:[i16] } i1:{ *:[i1] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 290719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 290722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 290724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290727 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 290729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290732 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 290734 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 290736 */     GIR_RootConstrainSelectedInstOperands,
     /* 290737 */     // GIR_Coverage, 7016,
     /* 290737 */     GIR_EraseRootFromParent_Done,
     /* 290738 */   // Label 4827: @290738
     /* 290738 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(290772), // Rule ID 7017 //
     /* 290743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 290746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 290750 */     // (select:{ *:[f16] } i1:{ *:[i1] }:$src0, f16:{ *:[f16] }:$src1, f16:{ *:[f16] }:$src2)  =>  (V_CNDMASK_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src2, 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 290750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B16_t16_e64),
     /* 290753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 290755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290758 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 290760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290763 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 290765 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 290767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290770 */     GIR_RootConstrainSelectedInstOperands,
     /* 290771 */     // GIR_Coverage, 7017,
     /* 290771 */     GIR_EraseRootFromParent_Done,
     /* 290772 */   // Label 4828: @290772
     /* 290772 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(290806), // Rule ID 7018 //
     /* 290777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 290780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 290784 */     // (select:{ *:[i16] } i1:{ *:[i1] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2)  =>  (V_CNDMASK_B16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 290784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B16_t16_e64),
     /* 290787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 290789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290792 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 290794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290797 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 290799 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 290801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290804 */     GIR_RootConstrainSelectedInstOperands,
     /* 290805 */     // GIR_Coverage, 7018,
     /* 290805 */     GIR_EraseRootFromParent_Done,
     /* 290806 */   // Label 4829: @290806
     /* 290806 */   GIM_Reject,
     /* 290807 */ // Label 4823: @290807
     /* 290807 */ GIM_Reject,
     /* 290808 */ // Label 4821: @290808
     /* 290808 */ GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(290923),
     /* 290813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 290816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 290819 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 290822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 290826 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(290874), // Rule ID 7011 //
     /* 290831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 290838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 290845 */     // (select:{ *:[i32] } i1:{ *:[i1] }:$src0, (VOP3ModsNonCanonicalizing:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3ModsNonCanonicalizing:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_CNDMASK_B32_e64:{ *:[i32] } FP32InputMods:{ *:[i32] }:$src2_mods, VSrc_b32:{ *:[i32] }:$src2, FP32InputMods:{ *:[i32] }:$src1_mods, VSrc_b32:{ *:[i32] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 290845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 290848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 290850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src2_mods
     /* 290855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src2
     /* 290860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 290865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 290870 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 290872 */     GIR_RootConstrainSelectedInstOperands,
     /* 290873 */     // GIR_Coverage, 7011,
     /* 290873 */     GIR_EraseRootFromParent_Done,
     /* 290874 */   // Label 4831: @290874
     /* 290874 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(290922), // Rule ID 7012 //
     /* 290879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 290886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 290893 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$src0, (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_CNDMASK_B32_e64:{ *:[f32] } FP32InputMods:{ *:[i32] }:$src2_mods, VSrc_b32:{ *:[f32] }:$src2, FP32InputMods:{ *:[i32] }:$src1_mods, VSrc_b32:{ *:[f32] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 290893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 290896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 290898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src2_mods
     /* 290903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src2
     /* 290908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 290913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 290918 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 290920 */     GIR_RootConstrainSelectedInstOperands,
     /* 290921 */     // GIR_Coverage, 7012,
     /* 290921 */     GIR_EraseRootFromParent_Done,
     /* 290922 */   // Label 4832: @290922
     /* 290922 */   GIM_Reject,
     /* 290923 */ // Label 4830: @290923
     /* 290923 */ GIM_Reject,
     /* 290924 */ // Label 4822: @290924
     /* 290924 */ GIM_Reject,
     /* 290925 */ // Label 54: @290925
     /* 290925 */ GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(291033),
     /* 290930 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 290933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 290936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 290939 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(290970), // Rule ID 86 //
     /* 290944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 290947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 290951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 290955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 290959 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13795),
     /* 290963 */     // (mulhu:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13795>>  =>  (S_MUL_HI_U32:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 290963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_HI_U32),
     /* 290968 */     GIR_RootConstrainSelectedInstOperands,
     /* 290969 */     // GIR_Coverage, 86,
     /* 290969 */     GIR_Done,
     /* 290970 */   // Label 4834: @290970
     /* 290970 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(291032),
     /* 290975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 290979 */     GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(291005), // Rule ID 939 //
     /* 290984 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290991 */       // (mulhu:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 290991 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_e64),
     /* 290994 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 290996 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291001 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291003 */       GIR_RootConstrainSelectedInstOperands,
     /* 291004 */       // GIR_Coverage, 939,
     /* 291004 */       GIR_EraseRootFromParent_Done,
     /* 291005 */     // Label 4836: @291005
     /* 291005 */     GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(291031), // Rule ID 8460 //
     /* 291010 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291017 */       // (mulhu:{ *:[i32] } i32:{ *:[i32] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_MUL_HI_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 291017 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_e64),
     /* 291020 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291022 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291027 */       GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 291029 */       GIR_RootConstrainSelectedInstOperands,
     /* 291030 */       // GIR_Coverage, 8460,
     /* 291030 */       GIR_EraseRootFromParent_Done,
     /* 291031 */     // Label 4837: @291031
     /* 291031 */     GIM_Reject,
     /* 291032 */   // Label 4835: @291032
     /* 291032 */   GIM_Reject,
     /* 291033 */ // Label 4833: @291033
     /* 291033 */ GIM_Reject,
     /* 291034 */ // Label 55: @291034
     /* 291034 */ GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(291142),
     /* 291039 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 291042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 291045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 291048 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(291079), // Rule ID 87 //
     /* 291053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 291056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 291060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 291064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 291068 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13796),
     /* 291072 */     // (mulhs:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13796>>  =>  (S_MUL_HI_I32:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 291072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_HI_I32),
     /* 291077 */     GIR_RootConstrainSelectedInstOperands,
     /* 291078 */     // GIR_Coverage, 87,
     /* 291078 */     GIR_Done,
     /* 291079 */   // Label 4839: @291079
     /* 291079 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(291141),
     /* 291084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291088 */     GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(291114), // Rule ID 940 //
     /* 291093 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291100 */       // (mulhs:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 291100 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_e64),
     /* 291103 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291105 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291110 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291112 */       GIR_RootConstrainSelectedInstOperands,
     /* 291113 */       // GIR_Coverage, 940,
     /* 291113 */       GIR_EraseRootFromParent_Done,
     /* 291114 */     // Label 4841: @291114
     /* 291114 */     GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(291140), // Rule ID 8461 //
     /* 291119 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291126 */       // (mulhs:{ *:[i32] } i32:{ *:[i32] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_MUL_HI_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 291126 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_e64),
     /* 291129 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291131 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291136 */       GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 291138 */       GIR_RootConstrainSelectedInstOperands,
     /* 291139 */       // GIR_Coverage, 8461,
     /* 291139 */       GIR_EraseRootFromParent_Done,
     /* 291140 */     // Label 4842: @291140
     /* 291140 */     GIM_Reject,
     /* 291141 */   // Label 4840: @291141
     /* 291141 */   GIM_Reject,
     /* 291142 */ // Label 4838: @291142
     /* 291142 */ GIM_Reject,
     /* 291143 */ // Label 56: @291143
     /* 291143 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4846*/ GIMT_Encode4(291530),
     /* 291154 */ /*GILLT_s16*//*Label 4843*/ GIMT_Encode4(291170),
     /* 291158 */ /*GILLT_s32*//*Label 4844*/ GIMT_Encode4(291386), GIMT_Encode4(0),
     /* 291166 */ /*GILLT_v2s16*//*Label 4845*/ GIMT_Encode4(291455),
     /* 291170 */ // Label 4843: @291170
     /* 291170 */ GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(291385),
     /* 291175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 291178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 291181 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(291240), // Rule ID 2665 //
     /* 291186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /* 291189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291207 */     // (uaddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 291207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_e64),
     /* 291210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291238 */     GIR_RootConstrainSelectedInstOperands,
     /* 291239 */     // GIR_Coverage, 2665,
     /* 291239 */     GIR_EraseRootFromParent_Done,
     /* 291240 */   // Label 4848: @291240
     /* 291240 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(291299), // Rule ID 2668 //
     /* 291245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 291248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 291252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291266 */     // (uaddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 291266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_t16_e64),
     /* 291269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291297 */     GIR_RootConstrainSelectedInstOperands,
     /* 291298 */     // GIR_Coverage, 2668,
     /* 291298 */     GIR_EraseRootFromParent_Done,
     /* 291299 */   // Label 4849: @291299
     /* 291299 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(291358), // Rule ID 2671 //
     /* 291304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 291307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291325 */     // (uaddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 291325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_fake16_e64),
     /* 291328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291356 */     GIR_RootConstrainSelectedInstOperands,
     /* 291357 */     // GIR_Coverage, 2671,
     /* 291357 */     GIR_EraseRootFromParent_Done,
     /* 291358 */   // Label 4850: @291358
     /* 291358 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(291384), // Rule ID 2564 //
     /* 291363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasIntClamp),
     /* 291366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291370 */     // (uaddsat:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_ADD_U16_e64:{ *:[i16] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, 1:{ *:[i1] })
     /* 291370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
     /* 291373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291375 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 291377 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291382 */     GIR_RootConstrainSelectedInstOperands,
     /* 291383 */     // GIR_Coverage, 2564,
     /* 291383 */     GIR_EraseRootFromParent_Done,
     /* 291384 */   // Label 4851: @291384
     /* 291384 */   GIM_Reject,
     /* 291385 */ // Label 4847: @291385
     /* 291385 */ GIM_Reject,
     /* 291386 */ // Label 4844: @291386
     /* 291386 */ GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(291454),
     /* 291391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 291394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 291397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291401 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(291423), // Rule ID 2562 //
     /* 291406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts_HasIntClamp),
     /* 291409 */     // (uaddsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 291409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U32_e64),
     /* 291412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291414 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 291416 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291421 */     GIR_RootConstrainSelectedInstOperands,
     /* 291422 */     // GIR_Coverage, 2562,
     /* 291422 */     GIR_EraseRootFromParent_Done,
     /* 291423 */   // Label 4853: @291423
     /* 291423 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(291453), // Rule ID 2560 //
     /* 291428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasIntClamp),
     /* 291431 */     // (uaddsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ADD_CO_U32_e64:{ *:[i32] }:{ *:[i1] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 291431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 291434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_CO_U32_e64),
     /* 291437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291439 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 291444 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 291446 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291451 */     GIR_RootConstrainSelectedInstOperands,
     /* 291452 */     // GIR_Coverage, 2560,
     /* 291452 */     GIR_EraseRootFromParent_Done,
     /* 291453 */   // Label 4854: @291453
     /* 291453 */   GIM_Reject,
     /* 291454 */ // Label 4852: @291454
     /* 291454 */ GIM_Reject,
     /* 291455 */ // Label 4845: @291455
     /* 291455 */ GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(291529), // Rule ID 2712 //
     /* 291460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 291463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 291466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 291469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291473 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 291480 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 291487 */   // (uaddsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_U16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
     /* 291487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_U16),
     /* 291490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291527 */   GIR_RootConstrainSelectedInstOperands,
     /* 291528 */   // GIR_Coverage, 2712,
     /* 291528 */   GIR_EraseRootFromParent_Done,
     /* 291529 */ // Label 4855: @291529
     /* 291529 */ GIM_Reject,
     /* 291530 */ // Label 4846: @291530
     /* 291530 */ GIM_Reject,
     /* 291531 */ // Label 57: @291531
     /* 291531 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4859*/ GIMT_Encode4(291856),
     /* 291542 */ /*GILLT_s16*//*Label 4856*/ GIMT_Encode4(291558),
     /* 291546 */ /*GILLT_s32*//*Label 4857*/ GIMT_Encode4(291748), GIMT_Encode4(0),
     /* 291554 */ /*GILLT_v2s16*//*Label 4858*/ GIMT_Encode4(291781),
     /* 291558 */ // Label 4856: @291558
     /* 291558 */ GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(291747),
     /* 291563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 291566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 291569 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(291628), // Rule ID 2605 //
     /* 291574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 291577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291595 */     // (saddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_I16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 291595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I16_e64),
     /* 291598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291626 */     GIR_RootConstrainSelectedInstOperands,
     /* 291627 */     // GIR_Coverage, 2605,
     /* 291627 */     GIR_EraseRootFromParent_Done,
     /* 291628 */   // Label 4861: @291628
     /* 291628 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(291687), // Rule ID 2607 //
     /* 291633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 291636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 291640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291654 */     // (saddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_I16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 291654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I16_t16_e64),
     /* 291657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291685 */     GIR_RootConstrainSelectedInstOperands,
     /* 291686 */     // GIR_Coverage, 2607,
     /* 291686 */     GIR_EraseRootFromParent_Done,
     /* 291687 */   // Label 4862: @291687
     /* 291687 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(291746), // Rule ID 2609 //
     /* 291692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 291695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291713 */     // (saddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_I16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 291713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I16_fake16_e64),
     /* 291716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291744 */     GIR_RootConstrainSelectedInstOperands,
     /* 291745 */     // GIR_Coverage, 2609,
     /* 291745 */     GIR_EraseRootFromParent_Done,
     /* 291746 */   // Label 4863: @291746
     /* 291746 */   GIM_Reject,
     /* 291747 */ // Label 4860: @291747
     /* 291747 */ GIM_Reject,
     /* 291748 */ // Label 4857: @291748
     /* 291748 */ GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(291780), // Rule ID 2602 //
     /* 291753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 291756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 291759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 291762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291766 */   // (saddsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ADD_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 291766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I32_e64),
     /* 291769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291771 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 291773 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 291775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291778 */   GIR_RootConstrainSelectedInstOperands,
     /* 291779 */   // GIR_Coverage, 2602,
     /* 291779 */   GIR_EraseRootFromParent_Done,
     /* 291780 */ // Label 4864: @291780
     /* 291780 */ GIM_Reject,
     /* 291781 */ // Label 4858: @291781
     /* 291781 */ GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(291855), // Rule ID 2713 //
     /* 291786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 291789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 291792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 291795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 291806 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 291813 */   // (saddsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_I16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
     /* 291813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_I16),
     /* 291816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291853 */   GIR_RootConstrainSelectedInstOperands,
     /* 291854 */   // GIR_Coverage, 2713,
     /* 291854 */   GIR_EraseRootFromParent_Done,
     /* 291855 */ // Label 4865: @291855
     /* 291855 */ GIM_Reject,
     /* 291856 */ // Label 4859: @291856
     /* 291856 */ GIM_Reject,
     /* 291857 */ // Label 58: @291857
     /* 291857 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4869*/ GIMT_Encode4(292244),
     /* 291868 */ /*GILLT_s16*//*Label 4866*/ GIMT_Encode4(291884),
     /* 291872 */ /*GILLT_s32*//*Label 4867*/ GIMT_Encode4(292100), GIMT_Encode4(0),
     /* 291880 */ /*GILLT_v2s16*//*Label 4868*/ GIMT_Encode4(292169),
     /* 291884 */ // Label 4866: @291884
     /* 291884 */ GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(292099),
     /* 291889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 291892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 291895 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(291954), // Rule ID 2666 //
     /* 291900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /* 291903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 291907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291921 */     // (usubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 291921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_e64),
     /* 291924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 291949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291952 */     GIR_RootConstrainSelectedInstOperands,
     /* 291953 */     // GIR_Coverage, 2666,
     /* 291953 */     GIR_EraseRootFromParent_Done,
     /* 291954 */   // Label 4871: @291954
     /* 291954 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(292013), // Rule ID 2669 //
     /* 291959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 291962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 291966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 291980 */     // (usubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 291980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_t16_e64),
     /* 291983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 291985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292011 */     GIR_RootConstrainSelectedInstOperands,
     /* 292012 */     // GIR_Coverage, 2669,
     /* 292012 */     GIR_EraseRootFromParent_Done,
     /* 292013 */   // Label 4872: @292013
     /* 292013 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(292072), // Rule ID 2672 //
     /* 292018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 292021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292039 */     // (usubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 292039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_fake16_e64),
     /* 292042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292070 */     GIR_RootConstrainSelectedInstOperands,
     /* 292071 */     // GIR_Coverage, 2672,
     /* 292071 */     GIR_EraseRootFromParent_Done,
     /* 292072 */   // Label 4873: @292072
     /* 292072 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(292098), // Rule ID 2565 //
     /* 292077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasIntClamp),
     /* 292080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292084 */     // (usubsat:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_SUB_U16_e64:{ *:[i16] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, 1:{ *:[i1] })
     /* 292084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /* 292087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292089 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 292091 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 292093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292096 */     GIR_RootConstrainSelectedInstOperands,
     /* 292097 */     // GIR_Coverage, 2565,
     /* 292097 */     GIR_EraseRootFromParent_Done,
     /* 292098 */   // Label 4874: @292098
     /* 292098 */   GIM_Reject,
     /* 292099 */ // Label 4870: @292099
     /* 292099 */ GIM_Reject,
     /* 292100 */ // Label 4867: @292100
     /* 292100 */ GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(292168),
     /* 292105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 292108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 292111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292115 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(292137), // Rule ID 2563 //
     /* 292120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts_HasIntClamp),
     /* 292123 */     // (usubsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_SUB_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 292123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e64),
     /* 292126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292128 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 292130 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 292132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292135 */     GIR_RootConstrainSelectedInstOperands,
     /* 292136 */     // GIR_Coverage, 2563,
     /* 292136 */     GIR_EraseRootFromParent_Done,
     /* 292137 */   // Label 4876: @292137
     /* 292137 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(292167), // Rule ID 2561 //
     /* 292142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasIntClamp),
     /* 292145 */     // (usubsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_SUB_CO_U32_e64:{ *:[i32] }:{ *:[i1] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 292145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 292148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e64),
     /* 292151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292153 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 292158 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 292160 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 292162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292165 */     GIR_RootConstrainSelectedInstOperands,
     /* 292166 */     // GIR_Coverage, 2561,
     /* 292166 */     GIR_EraseRootFromParent_Done,
     /* 292167 */   // Label 4877: @292167
     /* 292167 */   GIM_Reject,
     /* 292168 */ // Label 4875: @292168
     /* 292168 */ GIM_Reject,
     /* 292169 */ // Label 4868: @292169
     /* 292169 */ GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(292243), // Rule ID 2714 //
     /* 292174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 292177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 292180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 292183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 292194 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 292201 */   // (usubsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_SUB_U16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
     /* 292201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_SUB_U16),
     /* 292204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292241 */   GIR_RootConstrainSelectedInstOperands,
     /* 292242 */   // GIR_Coverage, 2714,
     /* 292242 */   GIR_EraseRootFromParent_Done,
     /* 292243 */ // Label 4878: @292243
     /* 292243 */ GIM_Reject,
     /* 292244 */ // Label 4869: @292244
     /* 292244 */ GIM_Reject,
     /* 292245 */ // Label 59: @292245
     /* 292245 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4882*/ GIMT_Encode4(292570),
     /* 292256 */ /*GILLT_s16*//*Label 4879*/ GIMT_Encode4(292272),
     /* 292260 */ /*GILLT_s32*//*Label 4880*/ GIMT_Encode4(292462), GIMT_Encode4(0),
     /* 292268 */ /*GILLT_v2s16*//*Label 4881*/ GIMT_Encode4(292495),
     /* 292272 */ // Label 4879: @292272
     /* 292272 */ GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(292461),
     /* 292277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 292280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 292283 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(292342), // Rule ID 2606 //
     /* 292288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 292291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292309 */     // (ssubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_I16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 292309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I16_e64),
     /* 292312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292340 */     GIR_RootConstrainSelectedInstOperands,
     /* 292341 */     // GIR_Coverage, 2606,
     /* 292341 */     GIR_EraseRootFromParent_Done,
     /* 292342 */   // Label 4884: @292342
     /* 292342 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(292401), // Rule ID 2608 //
     /* 292347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 292350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 292354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292368 */     // (ssubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_I16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 292368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I16_t16_e64),
     /* 292371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292399 */     GIR_RootConstrainSelectedInstOperands,
     /* 292400 */     // GIR_Coverage, 2608,
     /* 292400 */     GIR_EraseRootFromParent_Done,
     /* 292401 */   // Label 4885: @292401
     /* 292401 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(292460), // Rule ID 2610 //
     /* 292406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 292409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 292427 */     // (ssubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_I16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 292427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I16_fake16_e64),
     /* 292430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292458 */     GIR_RootConstrainSelectedInstOperands,
     /* 292459 */     // GIR_Coverage, 2610,
     /* 292459 */     GIR_EraseRootFromParent_Done,
     /* 292460 */   // Label 4886: @292460
     /* 292460 */   GIM_Reject,
     /* 292461 */ // Label 4883: @292461
     /* 292461 */ GIM_Reject,
     /* 292462 */ // Label 4880: @292462
     /* 292462 */ GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(292494), // Rule ID 2603 //
     /* 292467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 292470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 292473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 292476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292480 */   // (ssubsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_SUB_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 292480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I32_e64),
     /* 292483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 292487 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 292489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292492 */   GIR_RootConstrainSelectedInstOperands,
     /* 292493 */   // GIR_Coverage, 2603,
     /* 292493 */   GIR_EraseRootFromParent_Done,
     /* 292494 */ // Label 4887: @292494
     /* 292494 */ GIM_Reject,
     /* 292495 */ // Label 4881: @292495
     /* 292495 */ GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(292569), // Rule ID 2715 //
     /* 292500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 292503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 292506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 292509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292513 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 292520 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 292527 */   // (ssubsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_SUB_I16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
     /* 292527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_SUB_I16),
     /* 292530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 292555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292567 */   GIR_RootConstrainSelectedInstOperands,
     /* 292568 */   // GIR_Coverage, 2715,
     /* 292568 */   GIR_EraseRootFromParent_Done,
     /* 292569 */ // Label 4888: @292569
     /* 292569 */ GIM_Reject,
     /* 292570 */ // Label 4882: @292570
     /* 292570 */ GIM_Reject,
     /* 292571 */ // Label 60: @292571
     /* 292571 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 4894*/ GIMT_Encode4(293928),
     /* 292582 */ /*GILLT_s16*//*Label 4889*/ GIMT_Encode4(292602),
     /* 292586 */ /*GILLT_s32*//*Label 4890*/ GIMT_Encode4(292964),
     /* 292590 */ /*GILLT_s64*//*Label 4891*/ GIMT_Encode4(293528),
     /* 292594 */ /*GILLT_v2s16*//*Label 4892*/ GIMT_Encode4(293781),
     /* 292598 */ /*GILLT_v2s32*//*Label 4893*/ GIMT_Encode4(293853),
     /* 292602 */ // Label 4889: @292602
     /* 292602 */ GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(292963),
     /* 292607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 292610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 292613 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(292648), // Rule ID 97 //
     /* 292618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 292621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 292625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 292629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 292633 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13797),
     /* 292637 */     // (fadd:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13797>>  =>  (S_ADD_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 292637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F16),
     /* 292642 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 292646 */     GIR_RootConstrainSelectedInstOperands,
     /* 292647 */     // GIR_Coverage, 97,
     /* 292647 */     GIR_Done,
     /* 292648 */   // Label 4896: @292648
     /* 292648 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(292711), // Rule ID 859 //
     /* 292653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 292656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292674 */     // (fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 292674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
     /* 292677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 292709 */     GIR_RootConstrainSelectedInstOperands,
     /* 292710 */     // GIR_Coverage, 859,
     /* 292710 */     GIR_EraseRootFromParent_Done,
     /* 292711 */   // Label 4897: @292711
     /* 292711 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(292774), // Rule ID 863 //
     /* 292716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 292719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292737 */     // (fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 292737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
     /* 292740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 292772 */     GIR_RootConstrainSelectedInstOperands,
     /* 292773 */     // GIR_Coverage, 863,
     /* 292773 */     GIR_EraseRootFromParent_Done,
     /* 292774 */   // Label 4898: @292774
     /* 292774 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(292837), // Rule ID 8421 //
     /* 292779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 292782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292800 */     // (fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 292800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
     /* 292803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 292810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 292815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 292820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 292825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 292830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 292835 */     GIR_RootConstrainSelectedInstOperands,
     /* 292836 */     // GIR_Coverage, 8421,
     /* 292836 */     GIR_EraseRootFromParent_Done,
     /* 292837 */   // Label 4899: @292837
     /* 292837 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(292900), // Rule ID 8423 //
     /* 292842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 292845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292863 */     // (fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 292863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
     /* 292866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 292873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 292878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 292883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 292888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 292893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 292898 */     GIR_RootConstrainSelectedInstOperands,
     /* 292899 */     // GIR_Coverage, 8423,
     /* 292899 */     GIR_EraseRootFromParent_Done,
     /* 292900 */   // Label 4900: @292900
     /* 292900 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(292962), // Rule ID 861 //
     /* 292905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 292908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 292912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 292919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 292926 */     // (fadd:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 292926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_t16_e64),
     /* 292929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 292931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292960 */     GIR_RootConstrainSelectedInstOperands,
     /* 292961 */     // GIR_Coverage, 861,
     /* 292961 */     GIR_EraseRootFromParent_Done,
     /* 292962 */   // Label 4901: @292962
     /* 292962 */   GIM_Reject,
     /* 292963 */ // Label 4895: @292963
     /* 292963 */ GIM_Reject,
     /* 292964 */ // Label 4890: @292964
     /* 292964 */ GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(293527),
     /* 292969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 292972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 292975 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(293071), // Rule ID 11141 //
     /* 292980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals_isGFX6GFX7GFX10),
     /* 292983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 292987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 292995 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 292998 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 293003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 293007 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 293011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 293020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 293027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 293034 */     // (fadd:{ *:[f32] } (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2), (intrinsic_wo_chain:{ *:[f32] } 2211:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1)))  =>  (V_MAC_LEGACY_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 293034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_LEGACY_F32_e64),
     /* 293037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 293047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 293055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 293063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293069 */     GIR_RootConstrainSelectedInstOperands,
     /* 293070 */     // GIR_Coverage, 11141,
     /* 293070 */     GIR_EraseRootFromParent_Done,
     /* 293071 */   // Label 4903: @293071
     /* 293071 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(293173), // Rule ID 11143 //
     /* 293076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals),
     /* 293079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 293091 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 293094 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 293099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 293103 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 293107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293130 */     // (fadd:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mod), (intrinsic_wo_chain:{ *:[f32] } 2211:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mod)))  =>  (V_MAD_LEGACY_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mod, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mod, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mod, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 293130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_LEGACY_F32_e64),
     /* 293133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mod
     /* 293140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 293145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mod
     /* 293150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 293155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mod
     /* 293160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 293165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293171 */     GIR_RootConstrainSelectedInstOperands,
     /* 293172 */     // GIR_Coverage, 11143,
     /* 293172 */     GIR_EraseRootFromParent_Done,
     /* 293173 */   // Label 4904: @293173
     /* 293173 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(293269), // Rule ID 7003 //
     /* 293178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals_isGFX6GFX7GFX10),
     /* 293181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 293193 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 293196 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 293201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 293205 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 293209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 293218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 293225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 293232 */     // (fadd:{ *:[f32] } (intrinsic_wo_chain:{ *:[f32] } 2211:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1)), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_MAC_LEGACY_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 293232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_LEGACY_F32_e64),
     /* 293235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 293261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293267 */     GIR_RootConstrainSelectedInstOperands,
     /* 293268 */     // GIR_Coverage, 7003,
     /* 293268 */     GIR_EraseRootFromParent_Done,
     /* 293269 */   // Label 4905: @293269
     /* 293269 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(293371), // Rule ID 7009 //
     /* 293274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals),
     /* 293277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 293289 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 293292 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 293297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 293301 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 293305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293328 */     // (fadd:{ *:[f32] } (intrinsic_wo_chain:{ *:[f32] } 2211:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mod)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mod))  =>  (V_MAD_LEGACY_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mod, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mod, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mod, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 293328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_LEGACY_F32_e64),
     /* 293331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mod
     /* 293338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mod
     /* 293348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mod
     /* 293358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 293363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293369 */     GIR_RootConstrainSelectedInstOperands,
     /* 293370 */     // GIR_Coverage, 7009,
     /* 293370 */     GIR_EraseRootFromParent_Done,
     /* 293371 */   // Label 4906: @293371
     /* 293371 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(293406), // Rule ID 89 //
     /* 293376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 293379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 293383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 293387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 293391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13797),
     /* 293395 */     // (fadd:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13797>>  =>  (S_ADD_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 293395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F32),
     /* 293400 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 293404 */     GIR_RootConstrainSelectedInstOperands,
     /* 293405 */     // GIR_Coverage, 89,
     /* 293405 */     GIR_Done,
     /* 293406 */   // Label 4907: @293406
     /* 293406 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(293466), // Rule ID 785 //
     /* 293411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293429 */     // (fadd:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
     /* 293432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 293464 */     GIR_RootConstrainSelectedInstOperands,
     /* 293465 */     // GIR_Coverage, 785,
     /* 293465 */     GIR_EraseRootFromParent_Done,
     /* 293466 */   // Label 4908: @293466
     /* 293466 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(293526), // Rule ID 8410 //
     /* 293471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293489 */     // (fadd:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
     /* 293492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 293499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 293504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 293509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 293514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 293519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 293524 */     GIR_RootConstrainSelectedInstOperands,
     /* 293525 */     // GIR_Coverage, 8410,
     /* 293525 */     GIR_EraseRootFromParent_Done,
     /* 293526 */   // Label 4909: @293526
     /* 293526 */   GIM_Reject,
     /* 293527 */ // Label 4902: @293527
     /* 293527 */ GIM_Reject,
     /* 293528 */ // Label 4891: @293528
     /* 293528 */ GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(293780),
     /* 293533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 293536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 293539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 293543 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(293602), // Rule ID 913 //
     /* 293548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 293551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293565 */     // (fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
     /* 293568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 293600 */     GIR_RootConstrainSelectedInstOperands,
     /* 293601 */     // GIR_Coverage, 913,
     /* 293601 */     GIR_EraseRootFromParent_Done,
     /* 293602 */   // Label 4911: @293602
     /* 293602 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(293661), // Rule ID 931 //
     /* 293607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 293610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293624 */     // (fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 293627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 293659 */     GIR_RootConstrainSelectedInstOperands,
     /* 293660 */     // GIR_Coverage, 931,
     /* 293660 */     GIR_EraseRootFromParent_Done,
     /* 293661 */   // Label 4912: @293661
     /* 293661 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(293720), // Rule ID 8439 //
     /* 293666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 293669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293683 */     // (fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
     /* 293686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 293693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 293698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 293703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 293708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 293713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 293718 */     GIR_RootConstrainSelectedInstOperands,
     /* 293719 */     // GIR_Coverage, 8439,
     /* 293719 */     GIR_EraseRootFromParent_Done,
     /* 293720 */   // Label 4913: @293720
     /* 293720 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(293779), // Rule ID 8452 //
     /* 293725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 293728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293742 */     // (fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 293742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 293745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 293752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 293757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 293762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 293767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 293772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 293777 */     GIR_RootConstrainSelectedInstOperands,
     /* 293778 */     // GIR_Coverage, 8452,
     /* 293778 */     GIR_EraseRootFromParent_Done,
     /* 293779 */   // Label 4914: @293779
     /* 293779 */   GIM_Reject,
     /* 293780 */ // Label 4910: @293780
     /* 293780 */ GIM_Reject,
     /* 293781 */ // Label 4892: @293781
     /* 293781 */ GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(293852), // Rule ID 1091 //
     /* 293786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 293789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 293792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 293796 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 293803 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 293810 */   // (fadd:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 293810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F16),
     /* 293813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293850 */   GIR_RootConstrainSelectedInstOperands,
     /* 293851 */   // GIR_Coverage, 1091,
     /* 293851 */   GIR_EraseRootFromParent_Done,
     /* 293852 */ // Label 4915: @293852
     /* 293852 */ GIM_Reject,
     /* 293853 */ // Label 4893: @293853
     /* 293853 */ GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(293927), // Rule ID 1312 //
     /* 293858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 293861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 293864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 293867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 293871 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 293878 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 293885 */   // (fadd:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
     /* 293885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F32),
     /* 293888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 293890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293925 */   GIR_RootConstrainSelectedInstOperands,
     /* 293926 */   // GIR_Coverage, 1312,
     /* 293926 */   GIR_EraseRootFromParent_Done,
     /* 293927 */ // Label 4916: @293927
     /* 293927 */ GIM_Reject,
     /* 293928 */ // Label 4894: @293928
     /* 293928 */ GIM_Reject,
     /* 293929 */ // Label 61: @293929
     /* 293929 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4919*/ GIMT_Encode4(294292),
     /* 293940 */ /*GILLT_s16*//*Label 4917*/ GIMT_Encode4(293948),
     /* 293944 */ /*GILLT_s32*//*Label 4918*/ GIMT_Encode4(294184),
     /* 293948 */ // Label 4917: @293948
     /* 293948 */ GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(294183),
     /* 293953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 293956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 293959 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(293994), // Rule ID 105 //
     /* 293964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 293967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 293971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 293975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 293979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13801),
     /* 293983 */     // (fsub:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13801>>  =>  (S_SUB_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 293983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F16),
     /* 293988 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 293992 */     GIR_RootConstrainSelectedInstOperands,
     /* 293993 */     // GIR_Coverage, 105,
     /* 293993 */     GIR_Done,
     /* 293994 */   // Label 4921: @293994
     /* 293994 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(294057), // Rule ID 865 //
     /* 293999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 294002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294020 */     // (fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_e64),
     /* 294023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 294055 */     GIR_RootConstrainSelectedInstOperands,
     /* 294056 */     // GIR_Coverage, 865,
     /* 294056 */     GIR_EraseRootFromParent_Done,
     /* 294057 */   // Label 4922: @294057
     /* 294057 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(294120), // Rule ID 869 //
     /* 294062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 294065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294083 */     // (fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_fake16_e64),
     /* 294086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 294118 */     GIR_RootConstrainSelectedInstOperands,
     /* 294119 */     // GIR_Coverage, 869,
     /* 294119 */     GIR_EraseRootFromParent_Done,
     /* 294120 */   // Label 4923: @294120
     /* 294120 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(294182), // Rule ID 867 //
     /* 294125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 294128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 294132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 294139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 294146 */     // (fsub:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 294146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_t16_e64),
     /* 294149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294180 */     GIR_RootConstrainSelectedInstOperands,
     /* 294181 */     // GIR_Coverage, 867,
     /* 294181 */     GIR_EraseRootFromParent_Done,
     /* 294182 */   // Label 4924: @294182
     /* 294182 */   GIM_Reject,
     /* 294183 */ // Label 4920: @294183
     /* 294183 */ GIM_Reject,
     /* 294184 */ // Label 4918: @294184
     /* 294184 */ GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(294291),
     /* 294189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 294192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 294195 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(294230), // Rule ID 107 //
     /* 294200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 294203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294215 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13801),
     /* 294219 */     // (fsub:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13801>>  =>  (S_SUB_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 294219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F32),
     /* 294224 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 294228 */     GIR_RootConstrainSelectedInstOperands,
     /* 294229 */     // GIR_Coverage, 107,
     /* 294229 */     GIR_Done,
     /* 294230 */   // Label 4926: @294230
     /* 294230 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(294290), // Rule ID 787 //
     /* 294235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294253 */     // (fsub:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F32_e64),
     /* 294256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 294288 */     GIR_RootConstrainSelectedInstOperands,
     /* 294289 */     // GIR_Coverage, 787,
     /* 294289 */     GIR_EraseRootFromParent_Done,
     /* 294290 */   // Label 4927: @294290
     /* 294290 */   GIM_Reject,
     /* 294291 */ // Label 4925: @294291
     /* 294291 */ GIM_Reject,
     /* 294292 */ // Label 4919: @294292
     /* 294292 */ GIM_Reject,
     /* 294293 */ // Label 62: @294293
     /* 294293 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 4933*/ GIMT_Encode4(295678),
     /* 294304 */ /*GILLT_s16*//*Label 4928*/ GIMT_Encode4(294324),
     /* 294308 */ /*GILLT_s32*//*Label 4929*/ GIMT_Encode4(294686),
     /* 294312 */ /*GILLT_s64*//*Label 4930*/ GIMT_Encode4(294854),
     /* 294316 */ /*GILLT_v2s16*//*Label 4931*/ GIMT_Encode4(295531),
     /* 294320 */ /*GILLT_v2s32*//*Label 4932*/ GIMT_Encode4(295603),
     /* 294324 */ // Label 4928: @294324
     /* 294324 */ GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(294685),
     /* 294329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 294332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 294335 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(294370), // Rule ID 99 //
     /* 294340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 294343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13800),
     /* 294359 */     // (fmul:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13800>>  =>  (S_MUL_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 294359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F16),
     /* 294364 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 294368 */     GIR_RootConstrainSelectedInstOperands,
     /* 294369 */     // GIR_Coverage, 99,
     /* 294369 */     GIR_Done,
     /* 294370 */   // Label 4935: @294370
     /* 294370 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(294433), // Rule ID 871 //
     /* 294375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 294378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294396 */     // (fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 294399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 294431 */     GIR_RootConstrainSelectedInstOperands,
     /* 294432 */     // GIR_Coverage, 871,
     /* 294432 */     GIR_EraseRootFromParent_Done,
     /* 294433 */   // Label 4936: @294433
     /* 294433 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(294496), // Rule ID 875 //
     /* 294438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 294441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294459 */     // (fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 294462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 294494 */     GIR_RootConstrainSelectedInstOperands,
     /* 294495 */     // GIR_Coverage, 875,
     /* 294495 */     GIR_EraseRootFromParent_Done,
     /* 294496 */   // Label 4937: @294496
     /* 294496 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(294559), // Rule ID 8425 //
     /* 294501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 294504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294522 */     // (fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 294525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 294532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 294537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 294542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 294547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 294552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 294557 */     GIR_RootConstrainSelectedInstOperands,
     /* 294558 */     // GIR_Coverage, 8425,
     /* 294558 */     GIR_EraseRootFromParent_Done,
     /* 294559 */   // Label 4938: @294559
     /* 294559 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(294622), // Rule ID 8427 //
     /* 294564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 294567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294585 */     // (fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 294588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 294595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 294600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 294605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 294610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 294615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 294620 */     GIR_RootConstrainSelectedInstOperands,
     /* 294621 */     // GIR_Coverage, 8427,
     /* 294621 */     GIR_EraseRootFromParent_Done,
     /* 294622 */   // Label 4939: @294622
     /* 294622 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(294684), // Rule ID 873 //
     /* 294627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 294630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 294634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 294641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 294648 */     // (fmul:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 294648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
     /* 294651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294682 */     GIR_RootConstrainSelectedInstOperands,
     /* 294683 */     // GIR_Coverage, 873,
     /* 294683 */     GIR_EraseRootFromParent_Done,
     /* 294684 */   // Label 4940: @294684
     /* 294684 */   GIM_Reject,
     /* 294685 */ // Label 4934: @294685
     /* 294685 */ GIM_Reject,
     /* 294686 */ // Label 4929: @294686
     /* 294686 */ GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(294853),
     /* 294691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 294694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 294697 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(294732), // Rule ID 95 //
     /* 294702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 294705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 294717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13800),
     /* 294721 */     // (fmul:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13800>>  =>  (S_MUL_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 294721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F32),
     /* 294726 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 294730 */     GIR_RootConstrainSelectedInstOperands,
     /* 294731 */     // GIR_Coverage, 95,
     /* 294731 */     GIR_Done,
     /* 294732 */   // Label 4942: @294732
     /* 294732 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(294792), // Rule ID 791 //
     /* 294737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294755 */     // (fmul:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 294758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 294790 */     GIR_RootConstrainSelectedInstOperands,
     /* 294791 */     // GIR_Coverage, 791,
     /* 294791 */     GIR_EraseRootFromParent_Done,
     /* 294792 */   // Label 4943: @294792
     /* 294792 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(294852), // Rule ID 8414 //
     /* 294797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294815 */     // (fmul:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 294815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 294818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 294825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 294830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 294835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 294840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 294845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 294850 */     GIR_RootConstrainSelectedInstOperands,
     /* 294851 */     // GIR_Coverage, 8414,
     /* 294851 */     GIR_EraseRootFromParent_Done,
     /* 294852 */   // Label 4944: @294852
     /* 294852 */   GIM_Reject,
     /* 294853 */ // Label 4941: @294853
     /* 294853 */ GIM_Reject,
     /* 294854 */ // Label 4930: @294854
     /* 294854 */ GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(295530),
     /* 294859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 294862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 294865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 294869 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(294943), // Rule ID 7780 //
     /* 294874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 294882 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
     /* 294886 */     // MIs[1] Operand 1
     /* 294886 */     // No operand predicates
     /* 294886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294895 */     // (fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 294895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 294902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294907 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 294912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 294914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 294917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 294924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294941 */     GIR_RootConstrainSelectedInstOperands,
     /* 294942 */     // GIR_Coverage, 7780,
     /* 294942 */     GIR_EraseRootFromParent_Done,
     /* 294943 */   // Label 4946: @294943
     /* 294943 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(295017), // Rule ID 13446 //
     /* 294948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 294956 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
     /* 294960 */     // MIs[1] Operand 1
     /* 294960 */     // No operand predicates
     /* 294960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294969 */     // (fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 294969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 294972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 294976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294981 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 294986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 294988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 294991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 294998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295015 */     GIR_RootConstrainSelectedInstOperands,
     /* 295016 */     // GIR_Coverage, 13446,
     /* 295016 */     GIR_EraseRootFromParent_Done,
     /* 295017 */   // Label 4947: @295017
     /* 295017 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(295093), // Rule ID 7784 //
     /* 295022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 295030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 295034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295042 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 295046 */     // MIs[2] Operand 1
     /* 295046 */     // No operand predicates
     /* 295046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295048 */     // (fmul:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 295048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 295051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 295055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295060 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 295065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 295067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 295070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 295075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 295079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295091 */     GIR_RootConstrainSelectedInstOperands,
     /* 295092 */     // GIR_Coverage, 7784,
     /* 295092 */     GIR_EraseRootFromParent_Done,
     /* 295093 */   // Label 4948: @295093
     /* 295093 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(295169), // Rule ID 13450 //
     /* 295098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295106 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 295110 */     // MIs[1] Operand 1
     /* 295110 */     // No operand predicates
     /* 295110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 295118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 295122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295124 */     // (fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0))  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 295124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 295127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 295131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295136 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 295141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 295143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 295146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 295151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 295155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295167 */     GIR_RootConstrainSelectedInstOperands,
     /* 295168 */     // GIR_Coverage, 13450,
     /* 295168 */     GIR_EraseRootFromParent_Done,
     /* 295169 */   // Label 4949: @295169
     /* 295169 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(295231), // Rule ID 13448 //
     /* 295174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295182 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 295186 */     // MIs[1] Operand 1
     /* 295186 */     // No operand predicates
     /* 295186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295188 */     // (fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, f64:{ *:[f64] }:$src0)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 295188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 295191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 295195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295200 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 295205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 295207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 295210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 295215 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 295217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295229 */     GIR_RootConstrainSelectedInstOperands,
     /* 295230 */     // GIR_Coverage, 13448,
     /* 295230 */     GIR_EraseRootFromParent_Done,
     /* 295231 */   // Label 4950: @295231
     /* 295231 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(295293), // Rule ID 7782 //
     /* 295236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 295244 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 295248 */     // MIs[1] Operand 1
     /* 295248 */     // No operand predicates
     /* 295248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295250 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$src0, (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 295250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 295253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 295257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295262 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 295267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 295269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 295272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 295277 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 295279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295291 */     GIR_RootConstrainSelectedInstOperands,
     /* 295292 */     // GIR_Coverage, 7782,
     /* 295292 */     GIR_EraseRootFromParent_Done,
     /* 295293 */   // Label 4951: @295293
     /* 295293 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(295352), // Rule ID 914 //
     /* 295298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 295301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 295315 */     // (fmul:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 295315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_pseudo_e64),
     /* 295318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 295345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 295350 */     GIR_RootConstrainSelectedInstOperands,
     /* 295351 */     // GIR_Coverage, 914,
     /* 295351 */     GIR_EraseRootFromParent_Done,
     /* 295352 */   // Label 4952: @295352
     /* 295352 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(295411), // Rule ID 933 //
     /* 295357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 295360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 295374 */     // (fmul:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 295374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 295377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 295404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 295409 */     GIR_RootConstrainSelectedInstOperands,
     /* 295410 */     // GIR_Coverage, 933,
     /* 295410 */     GIR_EraseRootFromParent_Done,
     /* 295411 */   // Label 4953: @295411
     /* 295411 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(295470), // Rule ID 8440 //
     /* 295416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 295419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 295426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295433 */     // (fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 295433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_pseudo_e64),
     /* 295436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 295443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 295448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 295453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 295458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 295463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 295468 */     GIR_RootConstrainSelectedInstOperands,
     /* 295469 */     // GIR_Coverage, 8440,
     /* 295469 */     GIR_EraseRootFromParent_Done,
     /* 295470 */   // Label 4954: @295470
     /* 295470 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(295529), // Rule ID 8454 //
     /* 295475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 295478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 295485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295492 */     // (fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 295492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 295495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 295502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 295507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 295512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 295517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 295522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 295527 */     GIR_RootConstrainSelectedInstOperands,
     /* 295528 */     // GIR_Coverage, 8454,
     /* 295528 */     GIR_EraseRootFromParent_Done,
     /* 295529 */   // Label 4955: @295529
     /* 295529 */   GIM_Reject,
     /* 295530 */ // Label 4945: @295530
     /* 295530 */ GIM_Reject,
     /* 295531 */ // Label 4931: @295531
     /* 295531 */ GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(295602), // Rule ID 1093 //
     /* 295536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 295539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 295542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295546 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 295553 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 295560 */   // (fmul:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 295560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F16),
     /* 295563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295600 */   GIR_RootConstrainSelectedInstOperands,
     /* 295601 */   // GIR_Coverage, 1093,
     /* 295601 */   GIR_EraseRootFromParent_Done,
     /* 295602 */ // Label 4956: @295602
     /* 295602 */ GIM_Reject,
     /* 295603 */ // Label 4932: @295603
     /* 295603 */ GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(295677), // Rule ID 1310 //
     /* 295608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 295611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 295614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 295617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 295621 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 295628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 295635 */   // (fmul:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
     /* 295635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F32),
     /* 295638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295675 */   GIR_RootConstrainSelectedInstOperands,
     /* 295676 */   // GIR_Coverage, 1310,
     /* 295676 */   GIR_EraseRootFromParent_Done,
     /* 295677 */ // Label 4957: @295677
     /* 295677 */ GIM_Reject,
     /* 295678 */ // Label 4933: @295678
     /* 295678 */ GIM_Reject,
     /* 295679 */ // Label 63: @295679
     /* 295679 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 4963*/ GIMT_Encode4(297547),
     /* 295690 */ /*GILLT_s16*//*Label 4958*/ GIMT_Encode4(295710),
     /* 295694 */ /*GILLT_s32*//*Label 4959*/ GIMT_Encode4(296375),
     /* 295698 */ /*GILLT_s64*//*Label 4960*/ GIMT_Encode4(297128),
     /* 295702 */ /*GILLT_v2s16*//*Label 4961*/ GIMT_Encode4(297360),
     /* 295706 */ /*GILLT_v2s32*//*Label 4962*/ GIMT_Encode4(297452),
     /* 295710 */ // Label 4958: @295710
     /* 295710 */ GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(296374),
     /* 295715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 295718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 295721 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 295724 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(295763), // Rule ID 113 //
     /* 295729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 295732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 295736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 295740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 295744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 295748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13803),
     /* 295752 */     // (fma:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)<<P:Predicate_anonymous_13803>>  =>  (S_FMAC_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)
     /* 295752 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F16),
     /* 295757 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 295761 */     GIR_RootConstrainSelectedInstOperands,
     /* 295762 */     // GIR_Coverage, 113,
     /* 295762 */     GIR_Done,
     /* 295763 */   // Label 4965: @295763
     /* 295763 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(295833), // Rule ID 7492 //
     /* 295768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /* 295771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 295782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 295789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 295796 */     // (fma:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f16] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f16] } f32:{ *:[f32] }:$src2))  =>  (V_FMAC_F16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2)
     /* 295796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F16_e64),
     /* 295799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 295825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295831 */     GIR_RootConstrainSelectedInstOperands,
     /* 295832 */     // GIR_Coverage, 7492,
     /* 295832 */     GIR_EraseRootFromParent_Done,
     /* 295833 */   // Label 4966: @295833
     /* 295833 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(295906), // Rule ID 7493 //
     /* 295838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX10Plus),
     /* 295841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 295845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 295852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 295859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 295866 */     // (fma:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_FMAC_F16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2)
     /* 295866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F16_t16_e64),
     /* 295869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 295895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295904 */     GIR_RootConstrainSelectedInstOperands,
     /* 295905 */     // GIR_Coverage, 7493,
     /* 295905 */     GIR_EraseRootFromParent_Done,
     /* 295906 */   // Label 4967: @295906
     /* 295906 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(295976), // Rule ID 7494 //
     /* 295911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX10Plus),
     /* 295914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 295925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 295932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 295939 */     // (fma:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_FMAC_F16_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2)
     /* 295939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F16_fake16_e64),
     /* 295942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 295968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295974 */     GIR_RootConstrainSelectedInstOperands,
     /* 295975 */     // GIR_Coverage, 7494,
     /* 295975 */     GIR_EraseRootFromParent_Done,
     /* 295976 */   // Label 4968: @295976
     /* 295976 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(296056), // Rule ID 1000 //
     /* 295981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 295984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 296002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 296009 */     // (fma:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 296009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
     /* 296012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 296039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 296049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 296054 */     GIR_RootConstrainSelectedInstOperands,
     /* 296055 */     // GIR_Coverage, 1000,
     /* 296055 */     GIR_EraseRootFromParent_Done,
     /* 296056 */   // Label 4969: @296056
     /* 296056 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(296136), // Rule ID 8467 //
     /* 296061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 296064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 296075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 296082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 296089 */     // (fma:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 296089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
     /* 296092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 296099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 296104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 296109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 296114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 296119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 296129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 296134 */     GIR_RootConstrainSelectedInstOperands,
     /* 296135 */     // GIR_Coverage, 8467,
     /* 296135 */     GIR_EraseRootFromParent_Done,
     /* 296136 */   // Label 4970: @296136
     /* 296136 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(296215), // Rule ID 1008 //
     /* 296141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 296144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296169 */     // (fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 296169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_e64),
     /* 296172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 296199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296213 */     GIR_RootConstrainSelectedInstOperands,
     /* 296214 */     // GIR_Coverage, 1008,
     /* 296214 */     GIR_EraseRootFromParent_Done,
     /* 296215 */   // Label 4971: @296215
     /* 296215 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(296294), // Rule ID 1010 //
     /* 296220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 296223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 296227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296248 */     // (fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 296248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_t16_e64),
     /* 296251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 296278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296292 */     GIR_RootConstrainSelectedInstOperands,
     /* 296293 */     // GIR_Coverage, 1010,
     /* 296293 */     GIR_EraseRootFromParent_Done,
     /* 296294 */   // Label 4972: @296294
     /* 296294 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(296373), // Rule ID 1012 //
     /* 296299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 296302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 296327 */     // (fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 296327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_fake16_e64),
     /* 296330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 296357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296371 */     GIR_RootConstrainSelectedInstOperands,
     /* 296372 */     // GIR_Coverage, 1012,
     /* 296372 */     GIR_EraseRootFromParent_Done,
     /* 296373 */   // Label 4973: @296373
     /* 296373 */   GIM_Reject,
     /* 296374 */ // Label 4964: @296374
     /* 296374 */ GIM_Reject,
     /* 296375 */ // Label 4959: @296375
     /* 296375 */ GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(297127),
     /* 296380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 296383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 296386 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 296389 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(296468), // Rule ID 2732 //
     /* 296394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 296397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 296408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296422 */     // (fma:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 296422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 296425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 296432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 296442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 296452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296466 */     GIR_RootConstrainSelectedInstOperands,
     /* 296467 */     // GIR_Coverage, 2732,
     /* 296467 */     GIR_EraseRootFromParent_Done,
     /* 296468 */   // Label 4975: @296468
     /* 296468 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(296547), // Rule ID 2733 //
     /* 296473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 296476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 296494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296501 */     // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
     /* 296501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 296504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 296511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 296521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 296531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296545 */     GIR_RootConstrainSelectedInstOperands,
     /* 296546 */     // GIR_Coverage, 2733,
     /* 296546 */     GIR_EraseRootFromParent_Done,
     /* 296547 */   // Label 4976: @296547
     /* 296547 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(296626), // Rule ID 2734 //
     /* 296552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 296555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 296580 */     // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 296580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 296583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 296590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 296600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 296610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296624 */     GIR_RootConstrainSelectedInstOperands,
     /* 296625 */     // GIR_Coverage, 2734,
     /* 296625 */     GIR_EraseRootFromParent_Done,
     /* 296626 */   // Label 4977: @296626
     /* 296626 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(296705), // Rule ID 8510 //
     /* 296631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 296634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 296652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296659 */     // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 296659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 296662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 296669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 296674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 296679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 296684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 296689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296703 */     GIR_RootConstrainSelectedInstOperands,
     /* 296704 */     // GIR_Coverage, 8510,
     /* 296704 */     GIR_EraseRootFromParent_Done,
     /* 296705 */   // Label 4978: @296705
     /* 296705 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(296784), // Rule ID 8511 //
     /* 296710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 296713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 296724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296738 */     // (fma:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
     /* 296738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 296741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 296748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 296753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 296758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 296763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 296768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296782 */     GIR_RootConstrainSelectedInstOperands,
     /* 296783 */     // GIR_Coverage, 8511,
     /* 296783 */     GIR_EraseRootFromParent_Done,
     /* 296784 */   // Label 4979: @296784
     /* 296784 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(296863), // Rule ID 8512 //
     /* 296789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 296792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 296810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 296817 */     // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 296817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 296820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 296827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 296832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 296837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 296842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 296847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296861 */     GIR_RootConstrainSelectedInstOperands,
     /* 296862 */     // GIR_Coverage, 8512,
     /* 296862 */     GIR_EraseRootFromParent_Done,
     /* 296863 */   // Label 4980: @296863
     /* 296863 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(296902), // Rule ID 111 //
     /* 296868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 296871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 296875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 296879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 296883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 296887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13803),
     /* 296891 */     // (fma:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)<<P:Predicate_anonymous_13803>>  =>  (S_FMAC_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)
     /* 296891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F32),
     /* 296896 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 296900 */     GIR_RootConstrainSelectedInstOperands,
     /* 296901 */     // GIR_Coverage, 111,
     /* 296901 */     GIR_Done,
     /* 296902 */   // Label 4981: @296902
     /* 296902 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(296972), // Rule ID 7491 //
     /* 296907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /* 296910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 296921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 296928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 296935 */     // (fma:{ *:[f32] } (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_FMAC_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2)
     /* 296935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F32_e64),
     /* 296938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 296964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296970 */     GIR_RootConstrainSelectedInstOperands,
     /* 296971 */     // GIR_Coverage, 7491,
     /* 296971 */     GIR_EraseRootFromParent_Done,
     /* 296972 */   // Label 4982: @296972
     /* 296972 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(297049), // Rule ID 926 //
     /* 296977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 296988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 296995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297002 */     // (fma:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
     /* 297005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 297042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 297047 */     GIR_RootConstrainSelectedInstOperands,
     /* 297048 */     // GIR_Coverage, 926,
     /* 297048 */     GIR_EraseRootFromParent_Done,
     /* 297049 */   // Label 4983: @297049
     /* 297049 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(297126), // Rule ID 8448 //
     /* 297054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297079 */     // (fma:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
     /* 297082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 297089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 297094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 297099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 297104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 297119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 297124 */     GIR_RootConstrainSelectedInstOperands,
     /* 297125 */     // GIR_Coverage, 8448,
     /* 297125 */     GIR_EraseRootFromParent_Done,
     /* 297126 */   // Label 4984: @297126
     /* 297126 */   GIM_Reject,
     /* 297127 */ // Label 4974: @297127
     /* 297127 */ GIM_Reject,
     /* 297128 */ // Label 4960: @297128
     /* 297128 */ GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(297359),
     /* 297133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 297136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 297139 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 297142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 297146 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(297212), // Rule ID 7495 //
     /* 297151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmacF64Inst),
     /* 297154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297175 */     // (fma:{ *:[f64] } (VOP3NoMods:{ *:[f64] } f64:{ *:[f64] }:$src0), (VOP3NoMods:{ *:[f64] } f64:{ *:[f64] }:$src1), (VOP3NoMods:{ *:[f64] } f64:{ *:[f64] }:$src2))  =>  (V_FMAC_F64_e64:{ *:[f64] } 0:{ *:[i32] }, ?:{ *:[f64] }:$src0, 0:{ *:[i32] }, ?:{ *:[f64] }:$src1, 0:{ *:[i32] }, ?:{ *:[f64] }:$src2)
     /* 297175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F64_e64),
     /* 297178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297210 */     GIR_RootConstrainSelectedInstOperands,
     /* 297211 */     // GIR_Coverage, 7495,
     /* 297211 */     GIR_EraseRootFromParent_Done,
     /* 297212 */   // Label 4986: @297212
     /* 297212 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(297285), // Rule ID 929 //
     /* 297217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297238 */     // (fma:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
     /* 297241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 297278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 297283 */     GIR_RootConstrainSelectedInstOperands,
     /* 297284 */     // GIR_Coverage, 929,
     /* 297284 */     GIR_EraseRootFromParent_Done,
     /* 297285 */   // Label 4987: @297285
     /* 297285 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(297358), // Rule ID 8450 //
     /* 297290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297311 */     // (fma:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
     /* 297314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 297321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 297326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 297331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 297336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 297351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 297356 */     GIR_RootConstrainSelectedInstOperands,
     /* 297357 */     // GIR_Coverage, 8450,
     /* 297357 */     GIR_EraseRootFromParent_Done,
     /* 297358 */   // Label 4988: @297358
     /* 297358 */   GIM_Reject,
     /* 297359 */ // Label 4985: @297359
     /* 297359 */ GIM_Reject,
     /* 297360 */ // Label 4961: @297360
     /* 297360 */ GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(297451), // Rule ID 1089 //
     /* 297365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 297368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 297371 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 297374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297378 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 297385 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 297392 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 297399 */   // (fma:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f16:{ *:[v2f16] }:$src2)
     /* 297399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F16),
     /* 297402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297404 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297449 */   GIR_RootConstrainSelectedInstOperands,
     /* 297450 */   // GIR_Coverage, 1089,
     /* 297450 */   GIR_EraseRootFromParent_Done,
     /* 297451 */ // Label 4989: @297451
     /* 297451 */ GIM_Reject,
     /* 297452 */ // Label 4962: @297452
     /* 297452 */ GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(297546), // Rule ID 1308 //
     /* 297457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 297460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 297463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 297466 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 297469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 297473 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 297480 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 297487 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 297494 */   // (fma:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f32:{ *:[v2f32] }:$src2)
     /* 297494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F32),
     /* 297497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297544 */   GIR_RootConstrainSelectedInstOperands,
     /* 297545 */   // GIR_Coverage, 1308,
     /* 297545 */   GIR_EraseRootFromParent_Done,
     /* 297546 */ // Label 4990: @297546
     /* 297546 */ GIM_Reject,
     /* 297547 */ // Label 4963: @297547
     /* 297547 */ GIM_Reject,
     /* 297548 */ // Label 64: @297548
     /* 297548 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4993*/ GIMT_Encode4(298493),
     /* 297559 */ /*GILLT_s16*//*Label 4991*/ GIMT_Encode4(297567),
     /* 297563 */ /*GILLT_s32*//*Label 4992*/ GIMT_Encode4(297805),
     /* 297567 */ // Label 4991: @297567
     /* 297567 */ GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(297804),
     /* 297572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 297575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 297578 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 297581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297585 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(297651), // Rule ID 7006 //
     /* 297590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 297593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297614 */     // (fmad:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_MAC_F16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 297614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F16_e64),
     /* 297617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297649 */     GIR_RootConstrainSelectedInstOperands,
     /* 297650 */     // GIR_Coverage, 7006,
     /* 297650 */     GIR_EraseRootFromParent_Done,
     /* 297651 */   // Label 4995: @297651
     /* 297651 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(297727), // Rule ID 1013 //
     /* 297656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 297659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297680 */     // (fmad:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F16_e64),
     /* 297683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 297720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 297725 */     GIR_RootConstrainSelectedInstOperands,
     /* 297726 */     // GIR_Coverage, 1013,
     /* 297726 */     GIR_EraseRootFromParent_Done,
     /* 297727 */   // Label 4996: @297727
     /* 297727 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(297803), // Rule ID 8468 //
     /* 297732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 297735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297756 */     // (fmad:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F16_e64),
     /* 297759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 297766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 297771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 297776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 297781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 297786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 297796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 297801 */     GIR_RootConstrainSelectedInstOperands,
     /* 297802 */     // GIR_Coverage, 8468,
     /* 297802 */     GIR_EraseRootFromParent_Done,
     /* 297803 */   // Label 4997: @297803
     /* 297803 */   GIM_Reject,
     /* 297804 */ // Label 4994: @297804
     /* 297804 */ GIM_Reject,
     /* 297805 */ // Label 4992: @297805
     /* 297805 */ GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(298492),
     /* 297810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 297813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 297816 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 297819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297823 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(297898), // Rule ID 2716 //
     /* 297828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 297831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 297838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 297845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 297852 */     // (fmad:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 297852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 297855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 297862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 297872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 297882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297896 */     GIR_RootConstrainSelectedInstOperands,
     /* 297897 */     // GIR_Coverage, 2716,
     /* 297897 */     GIR_EraseRootFromParent_Done,
     /* 297898 */   // Label 4999: @297898
     /* 297898 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(297973), // Rule ID 2717 //
     /* 297903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 297906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 297913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 297920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 297927 */     // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
     /* 297927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 297930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 297937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 297947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 297957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297971 */     GIR_RootConstrainSelectedInstOperands,
     /* 297972 */     // GIR_Coverage, 2717,
     /* 297972 */     GIR_EraseRootFromParent_Done,
     /* 297973 */   // Label 5000: @297973
     /* 297973 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(298048), // Rule ID 2718 //
     /* 297978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 297981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 297988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 297995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 298002 */     // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 298002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 298005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 298012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 298022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 298032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298046 */     GIR_RootConstrainSelectedInstOperands,
     /* 298047 */     // GIR_Coverage, 2718,
     /* 298047 */     GIR_EraseRootFromParent_Done,
     /* 298048 */   // Label 5001: @298048
     /* 298048 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(298114), // Rule ID 7000 //
     /* 298053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 298056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 298063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 298070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 298077 */     // (fmad:{ *:[f32] } (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_MAC_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 298077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F32_e64),
     /* 298080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298112 */     GIR_RootConstrainSelectedInstOperands,
     /* 298113 */     // GIR_Coverage, 7000,
     /* 298113 */     GIR_EraseRootFromParent_Done,
     /* 298114 */   // Label 5002: @298114
     /* 298114 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(298189), // Rule ID 8507 //
     /* 298119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 298122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 298136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298143 */     // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 298143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 298146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 298153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 298158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 298163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 298168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 298173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298187 */     GIR_RootConstrainSelectedInstOperands,
     /* 298188 */     // GIR_Coverage, 8507,
     /* 298188 */     GIR_EraseRootFromParent_Done,
     /* 298189 */   // Label 5003: @298189
     /* 298189 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(298264), // Rule ID 8508 //
     /* 298194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 298197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 298204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298218 */     // (fmad:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
     /* 298218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 298221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 298228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 298233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 298238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 298243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 298248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298262 */     GIR_RootConstrainSelectedInstOperands,
     /* 298263 */     // GIR_Coverage, 8508,
     /* 298263 */     GIR_EraseRootFromParent_Done,
     /* 298264 */   // Label 5004: @298264
     /* 298264 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(298339), // Rule ID 8509 //
     /* 298269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 298272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 298286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 298293 */     // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 298293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 298296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 298303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 298308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 298313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 298318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 298323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298337 */     GIR_RootConstrainSelectedInstOperands,
     /* 298338 */     // GIR_Coverage, 8509,
     /* 298338 */     GIR_EraseRootFromParent_Done,
     /* 298339 */   // Label 5005: @298339
     /* 298339 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(298415), // Rule ID 921 //
     /* 298344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 298347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298368 */     // (fmad:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F32_e64),
     /* 298371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 298388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 298398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298413 */     GIR_RootConstrainSelectedInstOperands,
     /* 298414 */     // GIR_Coverage, 921,
     /* 298414 */     GIR_EraseRootFromParent_Done,
     /* 298415 */   // Label 5006: @298415
     /* 298415 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(298491), // Rule ID 8445 //
     /* 298420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 298423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298444 */     // (fmad:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F32_e64),
     /* 298447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 298454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 298459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 298464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 298469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 298474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 298479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 298484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 298489 */     GIR_RootConstrainSelectedInstOperands,
     /* 298490 */     // GIR_Coverage, 8445,
     /* 298490 */     GIR_EraseRootFromParent_Done,
     /* 298491 */   // Label 5007: @298491
     /* 298491 */   GIM_Reject,
     /* 298492 */ // Label 4998: @298492
     /* 298492 */ GIM_Reject,
     /* 298493 */ // Label 4993: @298493
     /* 298493 */ GIM_Reject,
     /* 298494 */ // Label 65: @298494
     /* 298494 */ GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(298611), // Rule ID 7308 //
     /* 298499 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 298502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 298505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 298508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298512 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298519 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298526 */   // (fpow:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_EXP_F32_e64:{ *:[f32] } 0:{ *:[i32] }, (V_MUL_LEGACY_F32_e64:{ *:[i16] } ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, (V_LOG_F32_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0), 0:{ *:[i1] }, 0:{ *:[i32] }))
     /* 298526 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 298529 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F32_e64),
     /* 298533 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 298543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298548 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 298551 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 298554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 298556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 298559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LEGACY_F32_e64),
     /* 298563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 298573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298578 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 298581 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298584 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 298587 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 298590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F32_e64),
     /* 298595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298600 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298609 */   GIR_RootConstrainSelectedInstOperands,
     /* 298610 */   // GIR_Coverage, 7308,
     /* 298610 */   GIR_EraseRootFromParent_Done,
     /* 298611 */ // Label 5008: @298611
     /* 298611 */ GIM_Reject,
     /* 298612 */ // Label 66: @298612
     /* 298612 */ GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(298834),
     /* 298617 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 298620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 298623 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(298694), // Rule ID 2690 //
     /* 298628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 298631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 298635 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21538),
     /* 298639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298646 */     // (fexp2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21538>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_EXP_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 298646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 298649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_EXP_F16_e64),
     /* 298653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 298693 */     // GIR_Coverage, 2690,
     /* 298693 */     GIR_EraseRootFromParent_Done,
     /* 298694 */   // Label 5010: @298694
     /* 298694 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(298788),
     /* 298699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298703 */     GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(298745), // Rule ID 742 //
     /* 298708 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 298711 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298718 */       // (fexp2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298718 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_e64),
     /* 298721 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298723 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298728 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298733 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298738 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298743 */       GIR_RootConstrainSelectedInstOperands,
     /* 298744 */       // GIR_Coverage, 742,
     /* 298744 */       GIR_EraseRootFromParent_Done,
     /* 298745 */     // Label 5012: @298745
     /* 298745 */     GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(298787), // Rule ID 746 //
     /* 298750 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 298753 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298760 */       // (fexp2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298760 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_fake16_e64),
     /* 298763 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298765 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298770 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298775 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298780 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298785 */       GIR_RootConstrainSelectedInstOperands,
     /* 298786 */       // GIR_Coverage, 746,
     /* 298786 */       GIR_EraseRootFromParent_Done,
     /* 298787 */     // Label 5013: @298787
     /* 298787 */     GIM_Reject,
     /* 298788 */   // Label 5011: @298788
     /* 298788 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(298833), // Rule ID 744 //
     /* 298793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 298796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 298800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 298807 */     // (fexp2:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_EXP_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 298807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_t16_e64),
     /* 298810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298831 */     GIR_RootConstrainSelectedInstOperands,
     /* 298832 */     // GIR_Coverage, 744,
     /* 298832 */     GIR_EraseRootFromParent_Done,
     /* 298833 */   // Label 5014: @298833
     /* 298833 */   GIM_Reject,
     /* 298834 */ // Label 5009: @298834
     /* 298834 */ GIM_Reject,
     /* 298835 */ // Label 67: @298835
     /* 298835 */ GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(299057),
     /* 298840 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 298843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 298846 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(298917), // Rule ID 2692 //
     /* 298851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 298854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 298858 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21540),
     /* 298862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298869 */     // (flog2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21540>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_LOG_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 298869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 298872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_LOG_F16_e64),
     /* 298876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 298916 */     // GIR_Coverage, 2692,
     /* 298916 */     GIR_EraseRootFromParent_Done,
     /* 298917 */   // Label 5016: @298917
     /* 298917 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(299011),
     /* 298922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298926 */     GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(298968), // Rule ID 736 //
     /* 298931 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 298934 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298941 */       // (flog2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298941 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_e64),
     /* 298944 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298946 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298951 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298956 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298961 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298966 */       GIR_RootConstrainSelectedInstOperands,
     /* 298967 */       // GIR_Coverage, 736,
     /* 298967 */       GIR_EraseRootFromParent_Done,
     /* 298968 */     // Label 5018: @298968
     /* 298968 */     GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(299010), // Rule ID 740 //
     /* 298973 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 298976 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298983 */       // (flog2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298983 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_fake16_e64),
     /* 298986 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298988 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298993 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298998 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299003 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299008 */       GIR_RootConstrainSelectedInstOperands,
     /* 299009 */       // GIR_Coverage, 740,
     /* 299009 */       GIR_EraseRootFromParent_Done,
     /* 299010 */     // Label 5019: @299010
     /* 299010 */     GIM_Reject,
     /* 299011 */   // Label 5017: @299011
     /* 299011 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(299056), // Rule ID 738 //
     /* 299016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 299019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 299023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 299030 */     // (flog2:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LOG_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 299030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_t16_e64),
     /* 299033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299054 */     GIR_RootConstrainSelectedInstOperands,
     /* 299055 */     // GIR_Coverage, 738,
     /* 299055 */     GIR_EraseRootFromParent_Done,
     /* 299056 */   // Label 5020: @299056
     /* 299056 */   GIM_Reject,
     /* 299057 */ // Label 5015: @299057
     /* 299057 */ GIM_Reject,
     /* 299058 */ // Label 68: @299058
     /* 299058 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5024*/ GIMT_Encode4(299420),
     /* 299069 */ /*GILLT_s16*//*Label 5021*/ GIMT_Encode4(299081),
     /* 299073 */ /*GILLT_s32*//*Label 5022*/ GIMT_Encode4(299286),
     /* 299077 */ /*GILLT_s64*//*Label 5023*/ GIMT_Encode4(299353),
     /* 299081 */ // Label 5021: @299081
     /* 299081 */ GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(299285),
     /* 299086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 299089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 299092 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(299155), // Rule ID 2506 //
     /* 299097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 299100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299118 */     // (fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
     /* 299118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_e64),
     /* 299121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299153 */     GIR_RootConstrainSelectedInstOperands,
     /* 299154 */     // GIR_Coverage, 2506,
     /* 299154 */     GIR_EraseRootFromParent_Done,
     /* 299155 */   // Label 5026: @299155
     /* 299155 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(299221), // Rule ID 2508 //
     /* 299160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 299163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 299167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299181 */     // (fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod, 0:{ *:[i32] })
     /* 299181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_t16_e64),
     /* 299184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299219 */     GIR_RootConstrainSelectedInstOperands,
     /* 299220 */     // GIR_Coverage, 2508,
     /* 299220 */     GIR_EraseRootFromParent_Done,
     /* 299221 */   // Label 5027: @299221
     /* 299221 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(299284), // Rule ID 2510 //
     /* 299226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 299229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299247 */     // (fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
     /* 299247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_fake16_e64),
     /* 299250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299282 */     GIR_RootConstrainSelectedInstOperands,
     /* 299283 */     // GIR_Coverage, 2510,
     /* 299283 */     GIR_EraseRootFromParent_Done,
     /* 299284 */   // Label 5028: @299284
     /* 299284 */   GIM_Reject,
     /* 299285 */ // Label 5025: @299285
     /* 299285 */ GIM_Reject,
     /* 299286 */ // Label 5022: @299286
     /* 299286 */ GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(299352), // Rule ID 821 //
     /* 299291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 299297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299301 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299308 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 299315 */   // (fldexp:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F32_e64),
     /* 299318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299350 */   GIR_RootConstrainSelectedInstOperands,
     /* 299351 */   // GIR_Coverage, 821,
     /* 299351 */   GIR_EraseRootFromParent_Done,
     /* 299352 */ // Label 5029: @299352
     /* 299352 */ GIM_Reject,
     /* 299353 */ // Label 5023: @299353
     /* 299353 */ GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(299419), // Rule ID 981 //
     /* 299358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 299364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 299368 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299375 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 299382 */   // (fldexp:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 299385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299387 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299392 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299417 */   GIR_RootConstrainSelectedInstOperands,
     /* 299418 */   // GIR_Coverage, 981,
     /* 299418 */   GIR_EraseRootFromParent_Done,
     /* 299419 */ // Label 5030: @299419
     /* 299419 */ GIM_Reject,
     /* 299420 */ // Label 5024: @299420
     /* 299420 */ GIM_Reject,
     /* 299421 */ // Label 69: @299421
     /* 299421 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5036*/ GIMT_Encode4(301283),
     /* 299432 */ /*GILLT_s16*//*Label 5031*/ GIMT_Encode4(299452),
     /* 299436 */ /*GILLT_s32*//*Label 5032*/ GIMT_Encode4(299938),
     /* 299440 */ /*GILLT_s64*//*Label 5033*/ GIMT_Encode4(300192),
     /* 299444 */ /*GILLT_v2s16*//*Label 5034*/ GIMT_Encode4(300870),
     /* 299448 */ /*GILLT_v2s32*//*Label 5035*/ GIMT_Encode4(301226),
     /* 299452 */ // Label 5031: @299452
     /* 299452 */ GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(299937),
     /* 299457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 299460 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(299533), // Rule ID 7228 //
     /* 299465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 299469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 299477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 299486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34532),
     /* 299490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299492 */     // (fneg:{ *:[f16] } (fabs:{ *:[f16] } SReg_32:{ *:[f16] }:$src))<<P:Predicate_anonymous_34532>>  =>  (S_OR_B32:{ *:[f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src, (S_MOV_B32:{ *:[i1] } 32768:{ *:[i32] }))
     /* 299492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 299495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299504 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 299514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 299519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 299521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 299525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 299531 */     GIR_RootConstrainSelectedInstOperands,
     /* 299532 */     // GIR_Coverage, 7228,
     /* 299532 */     GIR_EraseRootFromParent_Done,
     /* 299533 */   // Label 5038: @299533
     /* 299533 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(299602), // Rule ID 7244 //
     /* 299538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 299541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 299553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299564 */     // (fneg:{ *:[f16] } (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src))  =>  (V_OR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 299564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299576 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 299586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 299591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 299600 */     GIR_RootConstrainSelectedInstOperands,
     /* 299601 */     // GIR_Coverage, 7244,
     /* 299601 */     GIR_EraseRootFromParent_Done,
     /* 299602 */   // Label 5039: @299602
     /* 299602 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(299663), // Rule ID 7247 //
     /* 299607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 299610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 299614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 299622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 299631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299633 */     // (fneg:{ *:[f16] } (fabs:{ *:[f16] } VGPR_16:{ *:[f16] }:$src))  =>  (V_OR_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 32768:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[f16] }:$src)
     /* 299633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B16_t16_e64),
     /* 299636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299641 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32768),
     /* 299651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 299658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299661 */     GIR_RootConstrainSelectedInstOperands,
     /* 299662 */     // GIR_Coverage, 7247,
     /* 299662 */     GIR_EraseRootFromParent_Done,
     /* 299663 */   // Label 5040: @299663
     /* 299663 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(299732), // Rule ID 7250 //
     /* 299668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 299671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 299683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299694 */     // (fneg:{ *:[f16] } (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src))  =>  (V_OR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 299694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299706 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 299716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 299721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 299730 */     GIR_RootConstrainSelectedInstOperands,
     /* 299731 */     // GIR_Coverage, 7250,
     /* 299731 */     GIR_EraseRootFromParent_Done,
     /* 299732 */   // Label 5041: @299732
     /* 299732 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(299788), // Rule ID 7226 //
     /* 299737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 299741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 299745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34532),
     /* 299749 */     // (fneg:{ *:[f16] } SReg_32:{ *:[f16] }:$src)<<P:Predicate_anonymous_34532>>  =>  (S_XOR_B32:{ *:[f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src, (S_MOV_B32:{ *:[i1] } 32768:{ *:[i32] }))
     /* 299749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 299752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299761 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 299771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /* 299776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 299778 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 299780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 299786 */     GIR_RootConstrainSelectedInstOperands,
     /* 299787 */     // GIR_Coverage, 7226,
     /* 299787 */     GIR_EraseRootFromParent_Done,
     /* 299788 */   // Label 5042: @299788
     /* 299788 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(299840), // Rule ID 7243 //
     /* 299793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 299796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299804 */     // (fneg:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_XOR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 299804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299816 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 299826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 299831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299836 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 299838 */     GIR_RootConstrainSelectedInstOperands,
     /* 299839 */     // GIR_Coverage, 7243,
     /* 299839 */     GIR_EraseRootFromParent_Done,
     /* 299840 */   // Label 5043: @299840
     /* 299840 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(299884), // Rule ID 7246 //
     /* 299845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 299848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 299852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 299856 */     // (fneg:{ *:[f16] } VGPR_16:{ *:[f16] }:$src)  =>  (V_XOR_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 32768:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[f16] }:$src)
     /* 299856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B16_t16_e64),
     /* 299859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299864 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32768),
     /* 299874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 299879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299882 */     GIR_RootConstrainSelectedInstOperands,
     /* 299883 */     // GIR_Coverage, 7246,
     /* 299883 */     GIR_EraseRootFromParent_Done,
     /* 299884 */   // Label 5044: @299884
     /* 299884 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(299936), // Rule ID 7249 //
     /* 299889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 299892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299900 */     // (fneg:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_XOR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 299900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299912 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 299922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 299927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299932 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 299934 */     GIR_RootConstrainSelectedInstOperands,
     /* 299935 */     // GIR_Coverage, 7249,
     /* 299935 */     GIR_EraseRootFromParent_Done,
     /* 299936 */   // Label 5045: @299936
     /* 299936 */   GIM_Reject,
     /* 299937 */ // Label 5037: @299937
     /* 299937 */ GIM_Reject,
     /* 299938 */ // Label 5032: @299938
     /* 299938 */ GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(300191),
     /* 299943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299946 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(300019), // Rule ID 7223 //
     /* 299951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 299955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 299963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 299972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34532),
     /* 299976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299978 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } SReg_32:{ *:[f32] }:$src))<<P:Predicate_anonymous_34532>>  =>  (S_OR_B32:{ *:[f32] }:{ *:[i1] } SReg_32:{ *:[f32] }:$src, (S_MOV_B32:{ *:[i1] } 2147483648:{ *:[i32] }))
     /* 299978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 299981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299990 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
     /* 300000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 300005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 300007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 300011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 300017 */     GIR_RootConstrainSelectedInstOperands,
     /* 300018 */     // GIR_Coverage, 7223,
     /* 300018 */     GIR_EraseRootFromParent_Done,
     /* 300019 */   // Label 5047: @300019
     /* 300019 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(300085), // Rule ID 7239 //
     /* 300024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 300036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300047 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } VGPR_32:{ *:[f32] }:$src))  =>  (V_OR_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483648:{ *:[i32] }), VGPR_32:{ *:[f32] }:$src)
     /* 300047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 300050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300059 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
     /* 300069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 300074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 300083 */     GIR_RootConstrainSelectedInstOperands,
     /* 300084 */     // GIR_Coverage, 7239,
     /* 300084 */     GIR_EraseRootFromParent_Done,
     /* 300085 */   // Label 5048: @300085
     /* 300085 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(300141), // Rule ID 7225 //
     /* 300090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34532),
     /* 300102 */     // (fneg:{ *:[f32] } SReg_32:{ *:[f32] }:$src)<<P:Predicate_anonymous_34532>>  =>  (S_XOR_B32:{ *:[f32] }:{ *:[i1] } SReg_32:{ *:[f32] }:$src, (S_MOV_B32:{ *:[i1] } 2147483648:{ *:[i32] }))
     /* 300102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 300105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300114 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
     /* 300124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /* 300129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 300131 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 300133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 300139 */     GIR_RootConstrainSelectedInstOperands,
     /* 300140 */     // GIR_Coverage, 7225,
     /* 300140 */     GIR_EraseRootFromParent_Done,
     /* 300141 */   // Label 5049: @300141
     /* 300141 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(300190), // Rule ID 7241 //
     /* 300146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300154 */     // (fneg:{ *:[f32] } VGPR_32:{ *:[f32] }:$src)  =>  (V_XOR_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483648:{ *:[i32] }), VGPR_32:{ *:[f32] }:$src)
     /* 300154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 300157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300166 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
     /* 300176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 300181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300186 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 300188 */     GIR_RootConstrainSelectedInstOperands,
     /* 300189 */     // GIR_Coverage, 7241,
     /* 300189 */     GIR_EraseRootFromParent_Done,
     /* 300190 */   // Label 5050: @300190
     /* 300190 */   GIM_Reject,
     /* 300191 */ // Label 5046: @300191
     /* 300191 */ GIM_Reject,
     /* 300192 */ // Label 5033: @300192
     /* 300192 */ GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(300869),
     /* 300197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300200 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(300388), // Rule ID 7238 //
     /* 300205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 300217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34532),
     /* 300230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300232 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } SReg_64:{ *:[f64] }:$src))<<P:Predicate_anonymous_34532>>  =>  (REG_SEQUENCE:{ *:[f64] } SReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_OR_B32:{ *:[i1] }:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i1] } 2147483648:{ *:[i32] })), SReg_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 300232 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
     /* 300235 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300239 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300244 */     GIR_AddImm, /*InsnID*/5, /*Imm*/GIMT_Encode8(2147483648),
     /* 300254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 300256 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 300259 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300263 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300268 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 300274 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 300279 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300284 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 300287 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 300291 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300296 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 300299 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 300302 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
     /* 300305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 300307 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 300310 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300314 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300319 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 300322 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 300330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300339 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 300345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 300350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 300358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300363 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 300366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 300369 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 300372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 300382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 300387 */     // GIR_Coverage, 7238,
     /* 300387 */     GIR_EraseRootFromParent_Done,
     /* 300388 */   // Label 5052: @300388
     /* 300388 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(300549), // Rule ID 7256 //
     /* 300393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 300405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300416 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } VReg_64:{ *:[f64] }:$src))  =>  (REG_SEQUENCE:{ *:[f64] } VReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (V_OR_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i32] } 2147483648:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /* 300416 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 300419 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300423 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300428 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 300434 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300439 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300444 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 300447 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300451 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300456 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(2147483648),
     /* 300466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 300468 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 300471 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 300475 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300480 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 300483 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 300486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 300488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 300491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300500 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 300506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 300519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300524 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 300527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 300530 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 300533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300548 */     // GIR_Coverage, 7256,
     /* 300548 */     GIR_EraseRootFromParent_Done,
     /* 300549 */   // Label 5053: @300549
     /* 300549 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(300722), // Rule ID 7237 //
     /* 300554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300562 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34532),
     /* 300566 */     // (fneg:{ *:[f64] } SReg_64:{ *:[f64] }:$src)<<P:Predicate_anonymous_34532>>  =>  (REG_SEQUENCE:{ *:[f64] } SReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_XOR_B32:{ *:[i1] }:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i32] } 2147483648:{ *:[i32] })), SReg_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 300566 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 300569 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300573 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300578 */     GIR_AddImm, /*InsnID*/5, /*Imm*/GIMT_Encode8(2147483648),
     /* 300588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 300590 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 300593 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300597 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300602 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 300608 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 300613 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300618 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 300621 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /* 300625 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300630 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 300633 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 300636 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
     /* 300639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 300641 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 300644 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300648 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300653 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 300656 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 300664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300673 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 300679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 300684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 300692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300697 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 300700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 300703 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 300706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 300711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 300716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 300721 */     // GIR_Coverage, 7237,
     /* 300721 */     GIR_EraseRootFromParent_Done,
     /* 300722 */   // Label 5054: @300722
     /* 300722 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(300868), // Rule ID 7255 //
     /* 300727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300735 */     // (fneg:{ *:[f64] } VReg_64:{ *:[f64] }:$src)  =>  (REG_SEQUENCE:{ *:[f64] } VReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (V_XOR_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i32] } 2147483648:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /* 300735 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 300738 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300742 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300747 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 300753 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300758 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300763 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 300766 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300770 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300775 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(2147483648),
     /* 300785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 300787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 300790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 300794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300799 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 300802 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 300805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 300807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 300810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300819 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 300825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 300838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300843 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 300846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 300849 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 300852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 300857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300867 */     // GIR_Coverage, 7255,
     /* 300867 */     GIR_EraseRootFromParent_Done,
     /* 300868 */   // Label 5055: @300868
     /* 300868 */   GIM_Reject,
     /* 300869 */ // Label 5051: @300869
     /* 300869 */ GIM_Reject,
     /* 300870 */ // Label 5034: @300870
     /* 300870 */ GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(301225),
     /* 300875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 300878 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(300980), // Rule ID 7231 //
     /* 300883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 300895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 300907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 300915 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 300917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300922 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2147450879),
     /* 300933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34532),
     /* 300937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300939 */     // (fneg:{ *:[v2f16] } (bitconvert:{ *:[v2f16] } (and:{ *:[i32] } SReg_32:{ *:[i32] }:$src, 2147450879:{ *:[i32] })<<P:Predicate_and_oneuse>>))<<P:Predicate_anonymous_34532>>  =>  (S_OR_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[i32] }:$src, (S_MOV_B32:{ *:[i1] } 2147516416:{ *:[i32] }))
     /* 300939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 300942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 300946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300951 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 300961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 300966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 300968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /* 300972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 300978 */     GIR_RootConstrainSelectedInstOperands,
     /* 300979 */     // GIR_Coverage, 7231,
     /* 300979 */     GIR_EraseRootFromParent_Done,
     /* 300980 */   // Label 5057: @300980
     /* 300980 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(301053), // Rule ID 7232 //
     /* 300985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 300997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 301001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34532),
     /* 301010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301012 */     // (fneg:{ *:[v2f16] } (fabs:{ *:[v2f16] } SReg_32:{ *:[v2f16] }:$src))<<P:Predicate_anonymous_34532>>  =>  (S_OR_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[v2f16] }:$src, (S_MOV_B32:{ *:[i1] } 2147516416:{ *:[i32] }))
     /* 301012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 301015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 301019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301024 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 301034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 301039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 301041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 301045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301048 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 301051 */     GIR_RootConstrainSelectedInstOperands,
     /* 301052 */     // GIR_Coverage, 7232,
     /* 301052 */     GIR_EraseRootFromParent_Done,
     /* 301053 */   // Label 5058: @301053
     /* 301053 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(301119), // Rule ID 7253 //
     /* 301058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 301070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 301074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301081 */     // (fneg:{ *:[v2f16] } (fabs:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src))  =>  (V_OR_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 2147516416:{ *:[i32] }), VGPR_32:{ *:[v2f16] }:$src)
     /* 301081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 301084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 301088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301093 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 301103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 301108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 301117 */     GIR_RootConstrainSelectedInstOperands,
     /* 301118 */     // GIR_Coverage, 7253,
     /* 301118 */     GIR_EraseRootFromParent_Done,
     /* 301119 */   // Label 5059: @301119
     /* 301119 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(301175), // Rule ID 7229 //
     /* 301124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301132 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34532),
     /* 301136 */     // (fneg:{ *:[v2f16] } SReg_32:{ *:[v2f16] }:$src)<<P:Predicate_anonymous_34532>>  =>  (S_XOR_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[v2f16] }:$src, (S_MOV_B32:{ *:[i1] } 2147516416:{ *:[i32] }))
     /* 301136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 301139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 301143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301148 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 301158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /* 301163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 301165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 301167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 301173 */     GIR_RootConstrainSelectedInstOperands,
     /* 301174 */     // GIR_Coverage, 7229,
     /* 301174 */     GIR_EraseRootFromParent_Done,
     /* 301175 */   // Label 5060: @301175
     /* 301175 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(301224), // Rule ID 7251 //
     /* 301180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301188 */     // (fneg:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src)  =>  (V_XOR_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 2147516416:{ *:[i32] }), VGPR_32:{ *:[v2f16] }:$src)
     /* 301188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 301191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 301195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301200 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 301210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 301215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 301222 */     GIR_RootConstrainSelectedInstOperands,
     /* 301223 */     // GIR_Coverage, 7251,
     /* 301223 */     GIR_EraseRootFromParent_Done,
     /* 301224 */   // Label 5061: @301224
     /* 301224 */   GIM_Reject,
     /* 301225 */ // Label 5056: @301225
     /* 301225 */ GIM_Reject,
     /* 301226 */ // Label 5035: @301226
     /* 301226 */ GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(301282), // Rule ID 7257 //
     /* 301231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 301234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301245 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34580),
     /* 301249 */   // (fneg:{ *:[v2f32] } VReg_64:{ *:[v2f32] }:$src)<<P:Predicate_anonymous_34580>>  =>  (V_PK_ADD_F32:{ *:[v2f32] } 11:{ *:[i32] }, VReg_64:{ *:[v2f32] }:$src, 11:{ *:[i32] }, 0:{ *:[i64] }, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 301249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F32),
     /* 301252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 301257 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 301259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 301262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301280 */   GIR_RootConstrainSelectedInstOperands,
     /* 301281 */   // GIR_Coverage, 7257,
     /* 301281 */   GIR_EraseRootFromParent_Done,
     /* 301282 */ // Label 5062: @301282
     /* 301282 */ GIM_Reject,
     /* 301283 */ // Label 5036: @301283
     /* 301283 */ GIM_Reject,
     /* 301284 */ // Label 70: @301284
     /* 301284 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 5065*/ GIMT_Encode4(301683),
     /* 301295 */ /*GILLT_s32*//*Label 5063*/ GIMT_Encode4(301303),
     /* 301299 */ /*GILLT_s64*//*Label 5064*/ GIMT_Encode4(301477),
     /* 301303 */ // Label 5063: @301303
     /* 301303 */ GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(301476),
     /* 301308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301311 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(301338), // Rule ID 31 //
     /* 301316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 301319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301323 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13770),
     /* 301327 */     // (fpextend:{ *:[f32] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13770>>  =>  (S_CVT_F32_F16:{ *:[f32] } f16:{ *:[f16] }:$src0)
     /* 301327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F32_F16),
     /* 301332 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 301336 */     GIR_RootConstrainSelectedInstOperands,
     /* 301337 */     // GIR_Coverage, 31,
     /* 301337 */     GIR_Done,
     /* 301338 */   // Label 5067: @301338
     /* 301338 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(301384), // Rule ID 644 //
     /* 301343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 301346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 301357 */     // (fpextend:{ *:[f32] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 301357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
     /* 301360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 301377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 301382 */     GIR_RootConstrainSelectedInstOperands,
     /* 301383 */     // GIR_Coverage, 644,
     /* 301383 */     GIR_EraseRootFromParent_Done,
     /* 301384 */   // Label 5068: @301384
     /* 301384 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(301430), // Rule ID 648 //
     /* 301389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 301392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 301403 */     // (fpextend:{ *:[f32] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_F16_fake16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 301403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
     /* 301406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 301423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 301428 */     GIR_RootConstrainSelectedInstOperands,
     /* 301429 */     // GIR_Coverage, 648,
     /* 301429 */     GIR_EraseRootFromParent_Done,
     /* 301430 */   // Label 5069: @301430
     /* 301430 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(301475), // Rule ID 646 //
     /* 301435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 301438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 301449 */     // (fpextend:{ *:[f32] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F32_F16_t16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 301449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
     /* 301452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301473 */     GIR_RootConstrainSelectedInstOperands,
     /* 301474 */     // GIR_Coverage, 646,
     /* 301474 */     GIR_EraseRootFromParent_Done,
     /* 301475 */   // Label 5070: @301475
     /* 301475 */   GIM_Reject,
     /* 301476 */ // Label 5066: @301476
     /* 301476 */ GIM_Reject,
     /* 301477 */ // Label 5064: @301477
     /* 301477 */ GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(301529), // Rule ID 6983 //
     /* 301482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 301485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301492 */   // (fpextend:{ *:[f64] } f16:{ *:[f16] }:$src)  =>  (V_CVT_F64_F32_e32:{ *:[f64] } (V_CVT_F32_F16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src))
     /* 301492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 301495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
     /* 301499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301504 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301507 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 301511 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301514 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e32),
     /* 301522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301527 */   GIR_RootConstrainSelectedInstOperands,
     /* 301528 */   // GIR_Coverage, 6983,
     /* 301528 */   GIR_EraseRootFromParent_Done,
     /* 301529 */ // Label 5071: @301529
     /* 301529 */ GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(301584), // Rule ID 6989 //
     /* 301534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 301537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301544 */   // (fpextend:{ *:[f64] } f16:{ *:[f16] }:$src)  =>  (V_CVT_F64_F32_e32:{ *:[f64] } (V_CVT_F32_F16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src))
     /* 301544 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 301547 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
     /* 301551 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301556 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301559 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 301563 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301566 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301569 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e32),
     /* 301577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301582 */   GIR_RootConstrainSelectedInstOperands,
     /* 301583 */   // GIR_Coverage, 6989,
     /* 301583 */   GIR_EraseRootFromParent_Done,
     /* 301584 */ // Label 5072: @301584
     /* 301584 */ GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(301636), // Rule ID 6995 //
     /* 301589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 301592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301599 */   // (fpextend:{ *:[f64] } f16:{ *:[f16] }:$src)  =>  (V_CVT_F64_F32_e32:{ *:[f64] } (V_CVT_F32_F16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src))
     /* 301599 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 301602 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
     /* 301606 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301611 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301614 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 301618 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301621 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e32),
     /* 301629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301631 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301634 */   GIR_RootConstrainSelectedInstOperands,
     /* 301635 */   // GIR_Coverage, 6995,
     /* 301635 */   GIR_EraseRootFromParent_Done,
     /* 301636 */ // Label 5073: @301636
     /* 301636 */ GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(301682), // Rule ID 630 //
     /* 301641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301648 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 301655 */   // (fpextend:{ *:[f64] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F64_F32_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 301655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e64),
     /* 301658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301665 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 301675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 301680 */   GIR_RootConstrainSelectedInstOperands,
     /* 301681 */   // GIR_Coverage, 630,
     /* 301681 */   GIR_EraseRootFromParent_Done,
     /* 301682 */ // Label 5074: @301682
     /* 301682 */ GIM_Reject,
     /* 301683 */ // Label 5065: @301683
     /* 301683 */ GIM_Reject,
     /* 301684 */ // Label 71: @301684
     /* 301684 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5078*/ GIMT_Encode4(302619),
     /* 301695 */ /*GILLT_s16*//*Label 5075*/ GIMT_Encode4(301711),
     /* 301699 */ /*GILLT_s32*//*Label 5076*/ GIMT_Encode4(302327), GIMT_Encode4(0),
     /* 301707 */ /*GILLT_v2s16*//*Label 5077*/ GIMT_Encode4(302374),
     /* 301711 */ // Label 5075: @301711
     /* 301711 */ GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(302326),
     /* 301716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301719 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(301837), // Rule ID 2738 //
     /* 301724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 301727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 301739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 301747 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 301751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301774 */     // (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))  =>  (V_FMA_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
     /* 301774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 301777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 301781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
     /* 301791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 301808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 301813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 301818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 301823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301835 */     GIR_RootConstrainSelectedInstOperands,
     /* 301836 */     // GIR_Coverage, 2738,
     /* 301836 */     GIR_EraseRootFromParent_Done,
     /* 301837 */   // Label 5080: @301837
     /* 301837 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(301955), // Rule ID 2722 //
     /* 301842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 301845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAD),
     /* 301857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 301865 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 301869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301892 */     // (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))  =>  (V_MAD_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
     /* 301892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 301895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 301899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
     /* 301909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 301926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 301931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 301936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 301941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301953 */     GIR_RootConstrainSelectedInstOperands,
     /* 301954 */     // GIR_Coverage, 2722,
     /* 301954 */     GIR_EraseRootFromParent_Done,
     /* 301955 */   // Label 5081: @301955
     /* 301955 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(302058), // Rule ID 2720 //
     /* 301960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 301963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 301975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 301983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301999 */     // (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_MAD_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
     /* 301999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 302002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
     /* 302016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 302033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 302038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302056 */     GIR_RootConstrainSelectedInstOperands,
     /* 302057 */     // GIR_Coverage, 2720,
     /* 302057 */     GIR_EraseRootFromParent_Done,
     /* 302058 */   // Label 5082: @302058
     /* 302058 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(302161), // Rule ID 2736 //
     /* 302063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 302066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 302078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 302082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 302086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302102 */     // (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_FMA_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
     /* 302102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 302105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
     /* 302119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 302136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 302141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302159 */     GIR_RootConstrainSelectedInstOperands,
     /* 302160 */     // GIR_Coverage, 2736,
     /* 302160 */     GIR_EraseRootFromParent_Done,
     /* 302161 */   // Label 5083: @302161
     /* 302161 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(302188), // Rule ID 36 //
     /* 302166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 302169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 302173 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13775),
     /* 302177 */     // (fpround:{ *:[f16] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13775>>  =>  (S_CVT_F16_F32:{ *:[f16] } f32:{ *:[f32] }:$src0)
     /* 302177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F16_F32),
     /* 302182 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 302186 */     GIR_RootConstrainSelectedInstOperands,
     /* 302187 */     // GIR_Coverage, 36,
     /* 302187 */     GIR_Done,
     /* 302188 */   // Label 5084: @302188
     /* 302188 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(302234), // Rule ID 638 //
     /* 302193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 302196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 302207 */     // (fpround:{ *:[f16] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_F32_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 302207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e64),
     /* 302210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 302227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 302232 */     GIR_RootConstrainSelectedInstOperands,
     /* 302233 */     // GIR_Coverage, 638,
     /* 302233 */     GIR_EraseRootFromParent_Done,
     /* 302234 */   // Label 5085: @302234
     /* 302234 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(302280), // Rule ID 642 //
     /* 302239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 302242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 302253 */     // (fpround:{ *:[f16] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 302253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 302256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 302273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 302278 */     GIR_RootConstrainSelectedInstOperands,
     /* 302279 */     // GIR_Coverage, 642,
     /* 302279 */     GIR_EraseRootFromParent_Done,
     /* 302280 */   // Label 5086: @302280
     /* 302280 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(302325), // Rule ID 640 //
     /* 302285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 302288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 302292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 302299 */     // (fpround:{ *:[f16] } (VOP3OpSelMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0)
     /* 302299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 302302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302323 */     GIR_RootConstrainSelectedInstOperands,
     /* 302324 */     // GIR_Coverage, 640,
     /* 302324 */     GIR_EraseRootFromParent_Done,
     /* 302325 */   // Label 5087: @302325
     /* 302325 */   GIM_Reject,
     /* 302326 */ // Label 5079: @302326
     /* 302326 */ GIM_Reject,
     /* 302327 */ // Label 5076: @302327
     /* 302327 */ GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(302373), // Rule ID 628 //
     /* 302332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302339 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 302346 */   // (fpround:{ *:[f32] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_F64_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 302346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
     /* 302349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302356 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302361 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 302366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 302371 */   GIR_RootConstrainSelectedInstOperands,
     /* 302372 */   // GIR_Coverage, 628,
     /* 302372 */   GIR_EraseRootFromParent_Done,
     /* 302373 */ // Label 5088: @302373
     /* 302373 */ GIM_Reject,
     /* 302374 */ // Label 5077: @302374
     /* 302374 */ GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(302470), // Rule ID 2621 //
     /* 302379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtPkF16F32Inst),
     /* 302382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302389 */   // (fpround:{ *:[v2f16] } v2f32:{ *:[v2f32] }:$src)  =>  (V_CVT_PK_F16_F32_e64:{ *:[v2f16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[v2f32] }:$src, sub0:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[v2f32] }:$src, sub1:{ *:[i32] }))
     /* 302389 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 302392 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302396 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302401 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 302407 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302412 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 302417 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 302420 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302424 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302429 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 302435 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302440 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 302445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F16_F32_e64),
     /* 302448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302459 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 302462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302468 */   GIR_RootConstrainSelectedInstOperands,
     /* 302469 */   // GIR_Coverage, 2621,
     /* 302469 */   GIR_EraseRootFromParent_Done,
     /* 302470 */ // Label 5089: @302470
     /* 302470 */ GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(302618), // Rule ID 2622 //
     /* 302475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtPkF16F32Inst),
     /* 302478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302485 */   // (fpround:{ *:[v2f16] } v2f64:{ *:[v2f64] }:$src)  =>  (V_CVT_PK_F16_F32_e64:{ *:[v2f16] } 0:{ *:[i32] }, (V_CVT_F32_F64_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$src, sub0_sub1:{ *:[i32] })), 0:{ *:[i32] }, (V_CVT_F32_F64_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$src, sub2_sub3:{ *:[i32] })))
     /* 302485 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 302488 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302492 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302497 */   GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(24), // src
     /* 302503 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 302508 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 302513 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 302516 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
     /* 302520 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302525 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 302528 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 302531 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 302534 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 302537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 302539 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 302542 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302546 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302551 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 302557 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 302562 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 302567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 302570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
     /* 302574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302579 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302582 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 302585 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302588 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F16_F32_e64),
     /* 302596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 302610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302616 */   GIR_RootConstrainSelectedInstOperands,
     /* 302617 */   // GIR_Coverage, 2622,
     /* 302617 */   GIR_EraseRootFromParent_Done,
     /* 302618 */ // Label 5090: @302618
     /* 302618 */ GIM_Reject,
     /* 302619 */ // Label 5078: @302619
     /* 302619 */ GIM_Reject,
     /* 302620 */ // Label 72: @302620
     /* 302620 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(10), /*)*//*default:*//*Label 5094*/ GIMT_Encode4(303345),
     /* 302631 */ /*GILLT_s1*//*Label 5091*/ GIMT_Encode4(302643),
     /* 302635 */ /*GILLT_s16*//*Label 5092*/ GIMT_Encode4(302916),
     /* 302639 */ /*GILLT_s32*//*Label 5093*/ GIMT_Encode4(303063),
     /* 302643 */ // Label 5091: @302643
     /* 302643 */ GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(302698), // Rule ID 7398 //
     /* 302648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 302651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 302654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 302658 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302665 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_e64:{ *:[i1] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 302665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_e64),
     /* 302668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 302670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302673 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 302683 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302696 */   GIR_RootConstrainSelectedInstOperands,
     /* 302697 */   // GIR_Coverage, 7398,
     /* 302697 */   GIR_EraseRootFromParent_Done,
     /* 302698 */ // Label 5095: @302698
     /* 302698 */ GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(302756), // Rule ID 7400 //
     /* 302703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 302706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 302709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 302713 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302720 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_t16_e64:{ *:[i1] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 302720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_t16_e64),
     /* 302723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 302725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302728 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 302738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302754 */   GIR_RootConstrainSelectedInstOperands,
     /* 302755 */   // GIR_Coverage, 7400,
     /* 302755 */   GIR_EraseRootFromParent_Done,
     /* 302756 */ // Label 5096: @302756
     /* 302756 */ GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(302811), // Rule ID 7402 //
     /* 302761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 302764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 302767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 302771 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302778 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_fake16_e64:{ *:[i1] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 302778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_fake16_e64),
     /* 302781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 302783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302786 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 302796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302801 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302809 */   GIR_RootConstrainSelectedInstOperands,
     /* 302810 */   // GIR_Coverage, 7402,
     /* 302810 */   GIR_EraseRootFromParent_Done,
     /* 302811 */ // Label 5097: @302811
     /* 302811 */ GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(302863), // Rule ID 7404 //
     /* 302816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 302823 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302830 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F32_e64:{ *:[i1] } 0:{ *:[i32] }, 3212836864:{ *:[i32] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, 0:{ *:[i1] })
     /* 302830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F32_e64),
     /* 302833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 302835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302838 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3212836864),
     /* 302848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302861 */   GIR_RootConstrainSelectedInstOperands,
     /* 302862 */   // GIR_Coverage, 7404,
     /* 302862 */   GIR_EraseRootFromParent_Done,
     /* 302863 */ // Label 5098: @302863
     /* 302863 */ GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(302915), // Rule ID 7406 //
     /* 302868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 302875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302882 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F64_e64:{ *:[i1] } 0:{ *:[i32] }, -4616189618054758400:{ *:[i64] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, 0:{ *:[i1] })
     /* 302882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F64_e64),
     /* 302885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 302887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302890 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-4616189618054758400),
     /* 302900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302913 */   GIR_RootConstrainSelectedInstOperands,
     /* 302914 */   // GIR_Coverage, 7406,
     /* 302914 */   GIR_EraseRootFromParent_Done,
     /* 302915 */ // Label 5099: @302915
     /* 302915 */ GIM_Reject,
     /* 302916 */ // Label 5092: @302916
     /* 302916 */ GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(303062),
     /* 302921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 302924 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(302970), // Rule ID 714 //
     /* 302929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 302932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 302943 */     // (fp_to_sint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I16_F16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 302943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I16_F16_e64),
     /* 302946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 302963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 302968 */     GIR_RootConstrainSelectedInstOperands,
     /* 302969 */     // GIR_Coverage, 714,
     /* 302969 */     GIR_EraseRootFromParent_Done,
     /* 302970 */   // Label 5101: @302970
     /* 302970 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(303016), // Rule ID 716 //
     /* 302975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 302978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 302989 */     // (fp_to_sint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I16_F16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 302989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I16_F16_fake16_e64),
     /* 302992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303014 */     GIR_RootConstrainSelectedInstOperands,
     /* 303015 */     // GIR_Coverage, 716,
     /* 303015 */     GIR_EraseRootFromParent_Done,
     /* 303016 */   // Label 5102: @303016
     /* 303016 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(303061), // Rule ID 715 //
     /* 303021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 303024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 303028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 303035 */     // (fp_to_sint:{ *:[i16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_I16_F16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 303035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I16_F16_t16_e64),
     /* 303038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303059 */     GIR_RootConstrainSelectedInstOperands,
     /* 303060 */     // GIR_Coverage, 715,
     /* 303060 */     GIR_EraseRootFromParent_Done,
     /* 303061 */   // Label 5103: @303061
     /* 303061 */   GIM_Reject,
     /* 303062 */ // Label 5100: @303062
     /* 303062 */ GIM_Reject,
     /* 303063 */ // Label 5093: @303063
     /* 303063 */ GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(303093), // Rule ID 29 //
     /* 303068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 303071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 303078 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13768),
     /* 303082 */   // (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13768>>  =>  (S_CVT_I32_F32:{ *:[i32] } f32:{ *:[f32] }:$src0)
     /* 303082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_I32_F32),
     /* 303087 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 303091 */   GIR_RootConstrainSelectedInstOperands,
     /* 303092 */   // GIR_Coverage, 29,
     /* 303092 */   GIR_Done,
     /* 303093 */ // Label 5104: @303093
     /* 303093 */ GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(303145), // Rule ID 6984 //
     /* 303098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 303101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303108 */   // (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_I32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src))
     /* 303108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
     /* 303115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303120 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303123 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 303127 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303130 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e32),
     /* 303138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303140 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303143 */   GIR_RootConstrainSelectedInstOperands,
     /* 303144 */   // GIR_Coverage, 6984,
     /* 303144 */   GIR_EraseRootFromParent_Done,
     /* 303145 */ // Label 5105: @303145
     /* 303145 */ GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(303200), // Rule ID 6990 //
     /* 303150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 303153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303160 */   // (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_I32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src))
     /* 303160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
     /* 303167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303172 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303175 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 303179 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303182 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303185 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e32),
     /* 303193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303198 */   GIR_RootConstrainSelectedInstOperands,
     /* 303199 */   // GIR_Coverage, 6990,
     /* 303199 */   GIR_EraseRootFromParent_Done,
     /* 303200 */ // Label 5106: @303200
     /* 303200 */ GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(303252), // Rule ID 6996 //
     /* 303205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 303208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303215 */   // (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_I32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[f16] }:$src))
     /* 303215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
     /* 303222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303227 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303230 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 303234 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303237 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e32),
     /* 303245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303247 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303250 */   GIR_RootConstrainSelectedInstOperands,
     /* 303251 */   // GIR_Coverage, 6996,
     /* 303251 */   GIR_EraseRootFromParent_Done,
     /* 303252 */ // Label 5107: @303252
     /* 303252 */ GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(303298), // Rule ID 626 //
     /* 303257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303264 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303271 */   // (fp_to_sint:{ *:[i32] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I32_F64_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F64_e64),
     /* 303274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303286 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303291 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303296 */   GIR_RootConstrainSelectedInstOperands,
     /* 303297 */   // GIR_Coverage, 626,
     /* 303297 */   GIR_EraseRootFromParent_Done,
     /* 303298 */ // Label 5108: @303298
     /* 303298 */ GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(303344), // Rule ID 636 //
     /* 303303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303310 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303317 */   // (fp_to_sint:{ *:[i32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I32_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e64),
     /* 303320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303332 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303342 */   GIR_RootConstrainSelectedInstOperands,
     /* 303343 */   // GIR_Coverage, 636,
     /* 303343 */   GIR_EraseRootFromParent_Done,
     /* 303344 */ // Label 5109: @303344
     /* 303344 */ GIM_Reject,
     /* 303345 */ // Label 5094: @303345
     /* 303345 */ GIM_Reject,
     /* 303346 */ // Label 73: @303346
     /* 303346 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(10), /*)*//*default:*//*Label 5113*/ GIMT_Encode4(304071),
     /* 303357 */ /*GILLT_s1*//*Label 5110*/ GIMT_Encode4(303369),
     /* 303361 */ /*GILLT_s16*//*Label 5111*/ GIMT_Encode4(303642),
     /* 303365 */ /*GILLT_s32*//*Label 5112*/ GIMT_Encode4(303789),
     /* 303369 */ // Label 5110: @303369
     /* 303369 */ GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(303424), // Rule ID 7397 //
     /* 303374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 303377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303384 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303391 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_e64:{ *:[i1] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 303391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_e64),
     /* 303394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303399 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 303409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303422 */   GIR_RootConstrainSelectedInstOperands,
     /* 303423 */   // GIR_Coverage, 7397,
     /* 303423 */   GIR_EraseRootFromParent_Done,
     /* 303424 */ // Label 5114: @303424
     /* 303424 */ GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(303482), // Rule ID 7399 //
     /* 303429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 303432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303439 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303446 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_t16_e64:{ *:[i1] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 303446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_t16_e64),
     /* 303449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303454 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 303464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303469 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303480 */   GIR_RootConstrainSelectedInstOperands,
     /* 303481 */   // GIR_Coverage, 7399,
     /* 303481 */   GIR_EraseRootFromParent_Done,
     /* 303482 */ // Label 5115: @303482
     /* 303482 */ GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(303537), // Rule ID 7401 //
     /* 303487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 303490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303497 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303504 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_fake16_e64:{ *:[i1] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 303504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_fake16_e64),
     /* 303507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303512 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 303522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303535 */   GIR_RootConstrainSelectedInstOperands,
     /* 303536 */   // GIR_Coverage, 7401,
     /* 303536 */   GIR_EraseRootFromParent_Done,
     /* 303537 */ // Label 5116: @303537
     /* 303537 */ GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(303589), // Rule ID 7403 //
     /* 303542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303556 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F32_e64:{ *:[i1] } 0:{ *:[i32] }, 1065353216:{ *:[i32] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, 0:{ *:[i1] })
     /* 303556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F32_e64),
     /* 303559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303564 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
     /* 303574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303587 */   GIR_RootConstrainSelectedInstOperands,
     /* 303588 */   // GIR_Coverage, 7403,
     /* 303588 */   GIR_EraseRootFromParent_Done,
     /* 303589 */ // Label 5117: @303589
     /* 303589 */ GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(303641), // Rule ID 7405 //
     /* 303594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 303601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303608 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F64_e64:{ *:[i1] } 0:{ *:[i32] }, 4607182418800017408:{ *:[i64] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, 0:{ *:[i1] })
     /* 303608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F64_e64),
     /* 303611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303616 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(4607182418800017408),
     /* 303626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303639 */   GIR_RootConstrainSelectedInstOperands,
     /* 303640 */   // GIR_Coverage, 7405,
     /* 303640 */   GIR_EraseRootFromParent_Done,
     /* 303641 */ // Label 5118: @303641
     /* 303641 */ GIM_Reject,
     /* 303642 */ // Label 5111: @303642
     /* 303642 */ GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(303788),
     /* 303647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303650 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(303696), // Rule ID 711 //
     /* 303655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 303658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303669 */     // (fp_to_uint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U16_F16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U16_F16_e64),
     /* 303672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303694 */     GIR_RootConstrainSelectedInstOperands,
     /* 303695 */     // GIR_Coverage, 711,
     /* 303695 */     GIR_EraseRootFromParent_Done,
     /* 303696 */   // Label 5120: @303696
     /* 303696 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(303742), // Rule ID 713 //
     /* 303701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 303704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303715 */     // (fp_to_uint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U16_F16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U16_F16_fake16_e64),
     /* 303718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303740 */     GIR_RootConstrainSelectedInstOperands,
     /* 303741 */     // GIR_Coverage, 713,
     /* 303741 */     GIR_EraseRootFromParent_Done,
     /* 303742 */   // Label 5121: @303742
     /* 303742 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(303787), // Rule ID 712 //
     /* 303747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 303750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 303754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 303761 */     // (fp_to_uint:{ *:[i16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_U16_F16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 303761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U16_F16_t16_e64),
     /* 303764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303785 */     GIR_RootConstrainSelectedInstOperands,
     /* 303786 */     // GIR_Coverage, 712,
     /* 303786 */     GIR_EraseRootFromParent_Done,
     /* 303787 */   // Label 5122: @303787
     /* 303787 */   GIM_Reject,
     /* 303788 */ // Label 5119: @303788
     /* 303788 */ GIM_Reject,
     /* 303789 */ // Label 5112: @303789
     /* 303789 */ GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(303819), // Rule ID 30 //
     /* 303794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 303797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 303804 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13769),
     /* 303808 */   // (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13769>>  =>  (S_CVT_U32_F32:{ *:[i32] } f32:{ *:[f32] }:$src0)
     /* 303808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_U32_F32),
     /* 303813 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 303817 */   GIR_RootConstrainSelectedInstOperands,
     /* 303818 */   // GIR_Coverage, 30,
     /* 303818 */   GIR_Done,
     /* 303819 */ // Label 5123: @303819
     /* 303819 */ GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(303871), // Rule ID 6985 //
     /* 303824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 303827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303834 */   // (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_U32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src))
     /* 303834 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303837 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
     /* 303841 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303846 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303849 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 303853 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303856 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e32),
     /* 303864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303869 */   GIR_RootConstrainSelectedInstOperands,
     /* 303870 */   // GIR_Coverage, 6985,
     /* 303870 */   GIR_EraseRootFromParent_Done,
     /* 303871 */ // Label 5124: @303871
     /* 303871 */ GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(303926), // Rule ID 6991 //
     /* 303876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 303879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303886 */   // (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_U32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src))
     /* 303886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
     /* 303893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303898 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303901 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 303905 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303908 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303911 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e32),
     /* 303919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303924 */   GIR_RootConstrainSelectedInstOperands,
     /* 303925 */   // GIR_Coverage, 6991,
     /* 303925 */   GIR_EraseRootFromParent_Done,
     /* 303926 */ // Label 5125: @303926
     /* 303926 */ GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(303978), // Rule ID 6997 //
     /* 303931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 303934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303941 */   // (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_U32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[f16] }:$src))
     /* 303941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
     /* 303948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303953 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303956 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 303960 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303963 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e32),
     /* 303971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303973 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303976 */   GIR_RootConstrainSelectedInstOperands,
     /* 303977 */   // GIR_Coverage, 6997,
     /* 303977 */   GIR_EraseRootFromParent_Done,
     /* 303978 */ // Label 5126: @303978
     /* 303978 */ GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(304024), // Rule ID 631 //
     /* 303983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303990 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303997 */   // (fp_to_uint:{ *:[i32] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U32_F64_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F64_e64),
     /* 304000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 304007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 304017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 304022 */   GIR_RootConstrainSelectedInstOperands,
     /* 304023 */   // GIR_Coverage, 631,
     /* 304023 */   GIR_EraseRootFromParent_Done,
     /* 304024 */ // Label 5127: @304024
     /* 304024 */ GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(304070), // Rule ID 635 //
     /* 304029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304036 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 304043 */   // (fp_to_uint:{ *:[i32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U32_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 304043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e64),
     /* 304046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 304053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 304063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 304068 */   GIR_RootConstrainSelectedInstOperands,
     /* 304069 */   // GIR_Coverage, 635,
     /* 304069 */   GIR_EraseRootFromParent_Done,
     /* 304070 */ // Label 5128: @304070
     /* 304070 */ GIM_Reject,
     /* 304071 */ // Label 5113: @304071
     /* 304071 */ GIM_Reject,
     /* 304072 */ // Label 74: @304072
     /* 304072 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5132*/ GIMT_Encode4(304804),
     /* 304083 */ /*GILLT_s16*//*Label 5129*/ GIMT_Encode4(304095),
     /* 304087 */ /*GILLT_s32*//*Label 5130*/ GIMT_Encode4(304598),
     /* 304091 */ /*GILLT_s64*//*Label 5131*/ GIMT_Encode4(304710),
     /* 304095 */ // Label 5129: @304095
     /* 304095 */ GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(304147), // Rule ID 6986 //
     /* 304100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 304103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304110 */   // (sint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_I32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 304110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e32),
     /* 304117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304122 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e64),
     /* 304131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304145 */   GIR_RootConstrainSelectedInstOperands,
     /* 304146 */   // GIR_Coverage, 6986,
     /* 304146 */   GIR_EraseRootFromParent_Done,
     /* 304147 */ // Label 5133: @304147
     /* 304147 */ GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(304202), // Rule ID 6992 //
     /* 304152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 304155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 304162 */   // (sint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_I32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 304162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e32),
     /* 304169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304174 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 304183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304188 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304200 */   GIR_RootConstrainSelectedInstOperands,
     /* 304201 */   // GIR_Coverage, 6992,
     /* 304201 */   GIR_EraseRootFromParent_Done,
     /* 304202 */ // Label 5134: @304202
     /* 304202 */ GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(304254), // Rule ID 6998 //
     /* 304207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 304210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304217 */   // (sint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_I32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 304217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e32),
     /* 304224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304229 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 304238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304252 */   GIR_RootConstrainSelectedInstOperands,
     /* 304253 */   // GIR_Coverage, 6998,
     /* 304253 */   GIR_EraseRootFromParent_Done,
     /* 304254 */ // Label 5135: @304254
     /* 304254 */ GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(304316), // Rule ID 7423 //
     /* 304259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 304262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 304265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304269 */   // (sint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_e32:{ *:[f16] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
     /* 304269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 304276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304281 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304284 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304287 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304290 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(3212836864),
     /* 304300 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e32),
     /* 304309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304314 */   GIR_RootConstrainSelectedInstOperands,
     /* 304315 */   // GIR_Coverage, 7423,
     /* 304315 */   GIR_EraseRootFromParent_Done,
     /* 304316 */ // Label 5136: @304316
     /* 304316 */ GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(304390), // Rule ID 7424 //
     /* 304321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 304324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 304327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 304331 */   // (sint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 304331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 304338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304343 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304346 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304349 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304352 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(3212836864),
     /* 304362 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 304371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304376 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304388 */   GIR_RootConstrainSelectedInstOperands,
     /* 304389 */   // GIR_Coverage, 7424,
     /* 304389 */   GIR_EraseRootFromParent_Done,
     /* 304390 */ // Label 5137: @304390
     /* 304390 */ GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(304461), // Rule ID 7425 //
     /* 304395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 304398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 304401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304405 */   // (sint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 304405 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304408 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 304412 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304417 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304420 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304423 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304426 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(3212836864),
     /* 304436 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 304445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304459 */   GIR_RootConstrainSelectedInstOperands,
     /* 304460 */   // GIR_Coverage, 7425,
     /* 304460 */   GIR_EraseRootFromParent_Done,
     /* 304461 */ // Label 5138: @304461
     /* 304461 */ GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(304505), // Rule ID 708 //
     /* 304466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 304469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304476 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 304483 */   // (sint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_I16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 304483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_I16_e64),
     /* 304486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 304498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 304503 */   GIR_RootConstrainSelectedInstOperands,
     /* 304504 */   // GIR_Coverage, 708,
     /* 304504 */   GIR_EraseRootFromParent_Done,
     /* 304505 */ // Label 5139: @304505
     /* 304505 */ GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(304549), // Rule ID 710 //
     /* 304510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 304513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304520 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 304527 */   // (sint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_I16_fake16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 304527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_I16_fake16_e64),
     /* 304530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 304542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 304547 */   GIR_RootConstrainSelectedInstOperands,
     /* 304548 */   // GIR_Coverage, 710,
     /* 304548 */   GIR_EraseRootFromParent_Done,
     /* 304549 */ // Label 5140: @304549
     /* 304549 */ GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(304597), // Rule ID 709 //
     /* 304554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 304557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 304564 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 304571 */   // (sint_to_fp:{ *:[f16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F16_I16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0)
     /* 304571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_I16_t16_e64),
     /* 304574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 304581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304595 */   GIR_RootConstrainSelectedInstOperands,
     /* 304596 */   // GIR_Coverage, 709,
     /* 304596 */   GIR_EraseRootFromParent_Done,
     /* 304597 */ // Label 5141: @304597
     /* 304597 */ GIM_Reject,
     /* 304598 */ // Label 5130: @304598
     /* 304598 */ GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(304628), // Rule ID 27 //
     /* 304603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 304606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 304613 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13766),
     /* 304617 */   // (sint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13766>>  =>  (S_CVT_F32_I32:{ *:[f32] } i32:{ *:[i32] }:$src0)
     /* 304617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F32_I32),
     /* 304622 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 304626 */   GIR_RootConstrainSelectedInstOperands,
     /* 304627 */   // GIR_Coverage, 27,
     /* 304627 */   GIR_Done,
     /* 304628 */ // Label 5142: @304628
     /* 304628 */ GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(304668), // Rule ID 7429 //
     /* 304633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 304636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304640 */   // (sint_to_fp:{ *:[f32] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src)
     /* 304640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 304643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304654 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3212836864),
     /* 304664 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 304666 */   GIR_RootConstrainSelectedInstOperands,
     /* 304667 */   // GIR_Coverage, 7429,
     /* 304667 */   GIR_EraseRootFromParent_Done,
     /* 304668 */ // Label 5143: @304668
     /* 304668 */ GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(304709), // Rule ID 633 //
     /* 304673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304680 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 304687 */   // (sint_to_fp:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_I32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 304687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e64),
     /* 304690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 304702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 304707 */   GIR_RootConstrainSelectedInstOperands,
     /* 304708 */   // GIR_Coverage, 633,
     /* 304708 */   GIR_EraseRootFromParent_Done,
     /* 304709 */ // Label 5144: @304709
     /* 304709 */ GIM_Reject,
     /* 304710 */ // Label 5131: @304710
     /* 304710 */ GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(304762), // Rule ID 7431 //
     /* 304715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 304718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 304722 */   // (sint_to_fp:{ *:[f64] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F64_I32_e32:{ *:[f64] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
     /* 304722 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304725 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 304729 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304734 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304737 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304740 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304743 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 304746 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_I32_e32),
     /* 304755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304760 */   GIR_RootConstrainSelectedInstOperands,
     /* 304761 */   // GIR_Coverage, 7431,
     /* 304761 */   GIR_EraseRootFromParent_Done,
     /* 304762 */ // Label 5145: @304762
     /* 304762 */ GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(304803), // Rule ID 627 //
     /* 304767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 304774 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 304781 */   // (sint_to_fp:{ *:[f64] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F64_I32_e64:{ *:[f64] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 304781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_I32_e64),
     /* 304784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 304791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 304796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 304801 */   GIR_RootConstrainSelectedInstOperands,
     /* 304802 */   // GIR_Coverage, 627,
     /* 304802 */   GIR_EraseRootFromParent_Done,
     /* 304803 */ // Label 5146: @304803
     /* 304803 */ GIM_Reject,
     /* 304804 */ // Label 5132: @304804
     /* 304804 */ GIM_Reject,
     /* 304805 */ // Label 75: @304805
     /* 304805 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5150*/ GIMT_Encode4(305537),
     /* 304816 */ /*GILLT_s16*//*Label 5147*/ GIMT_Encode4(304828),
     /* 304820 */ /*GILLT_s32*//*Label 5148*/ GIMT_Encode4(305331),
     /* 304824 */ /*GILLT_s64*//*Label 5149*/ GIMT_Encode4(305443),
     /* 304828 */ // Label 5147: @304828
     /* 304828 */ GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(304880), // Rule ID 6987 //
     /* 304833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 304836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304843 */   // (uint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_U32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 304843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e32),
     /* 304850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304855 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e64),
     /* 304864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304878 */   GIR_RootConstrainSelectedInstOperands,
     /* 304879 */   // GIR_Coverage, 6987,
     /* 304879 */   GIR_EraseRootFromParent_Done,
     /* 304880 */ // Label 5151: @304880
     /* 304880 */ GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(304935), // Rule ID 6993 //
     /* 304885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 304888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 304895 */   // (uint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_U32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 304895 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304898 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e32),
     /* 304902 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304907 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 304916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304933 */   GIR_RootConstrainSelectedInstOperands,
     /* 304934 */   // GIR_Coverage, 6993,
     /* 304934 */   GIR_EraseRootFromParent_Done,
     /* 304935 */ // Label 5152: @304935
     /* 304935 */ GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(304987), // Rule ID 6999 //
     /* 304940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 304943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304950 */   // (uint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_U32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 304950 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304953 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e32),
     /* 304957 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304962 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 304966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 304971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304976 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304985 */   GIR_RootConstrainSelectedInstOperands,
     /* 304986 */   // GIR_Coverage, 6999,
     /* 304986 */   GIR_EraseRootFromParent_Done,
     /* 304987 */ // Label 5153: @304987
     /* 304987 */ GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(305049), // Rule ID 7426 //
     /* 304992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 304995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 304998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305002 */   // (uint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_e32:{ *:[f16] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
     /* 305002 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305005 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 305009 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305014 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305017 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305020 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305023 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(1065353216),
     /* 305033 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e32),
     /* 305042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305047 */   GIR_RootConstrainSelectedInstOperands,
     /* 305048 */   // GIR_Coverage, 7426,
     /* 305048 */   GIR_EraseRootFromParent_Done,
     /* 305049 */ // Label 5154: @305049
     /* 305049 */ GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(305123), // Rule ID 7427 //
     /* 305054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 305057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 305060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 305064 */   // (uint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 305064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 305071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305076 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305079 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305082 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305085 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(1065353216),
     /* 305095 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 305104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305121 */   GIR_RootConstrainSelectedInstOperands,
     /* 305122 */   // GIR_Coverage, 7427,
     /* 305122 */   GIR_EraseRootFromParent_Done,
     /* 305123 */ // Label 5155: @305123
     /* 305123 */ GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(305194), // Rule ID 7428 //
     /* 305128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 305131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 305134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305138 */   // (uint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 305138 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305141 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 305145 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305150 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305153 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305156 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305159 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(1065353216),
     /* 305169 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305173 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 305178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305192 */   GIR_RootConstrainSelectedInstOperands,
     /* 305193 */   // GIR_Coverage, 7428,
     /* 305193 */   GIR_EraseRootFromParent_Done,
     /* 305194 */ // Label 5156: @305194
     /* 305194 */ GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(305238), // Rule ID 705 //
     /* 305199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 305202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 305216 */   // (uint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_U16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 305216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_U16_e64),
     /* 305219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 305231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 305236 */   GIR_RootConstrainSelectedInstOperands,
     /* 305237 */   // GIR_Coverage, 705,
     /* 305237 */   GIR_EraseRootFromParent_Done,
     /* 305238 */ // Label 5157: @305238
     /* 305238 */ GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(305282), // Rule ID 707 //
     /* 305243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 305246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305253 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 305260 */   // (uint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_U16_fake16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 305260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_U16_fake16_e64),
     /* 305263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 305275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 305280 */   GIR_RootConstrainSelectedInstOperands,
     /* 305281 */   // GIR_Coverage, 707,
     /* 305281 */   GIR_EraseRootFromParent_Done,
     /* 305282 */ // Label 5158: @305282
     /* 305282 */ GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(305330), // Rule ID 706 //
     /* 305287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 305290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 305297 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 305304 */   // (uint_to_fp:{ *:[f16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F16_U16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0)
     /* 305304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_U16_t16_e64),
     /* 305307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 305314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305328 */   GIR_RootConstrainSelectedInstOperands,
     /* 305329 */   // GIR_Coverage, 706,
     /* 305329 */   GIR_EraseRootFromParent_Done,
     /* 305330 */ // Label 5159: @305330
     /* 305330 */ GIM_Reject,
     /* 305331 */ // Label 5148: @305331
     /* 305331 */ GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(305361), // Rule ID 28 //
     /* 305336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 305339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305346 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13767),
     /* 305350 */   // (uint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13767>>  =>  (S_CVT_F32_U32:{ *:[f32] } i32:{ *:[i32] }:$src0)
     /* 305350 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F32_U32),
     /* 305355 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 305359 */   GIR_RootConstrainSelectedInstOperands,
     /* 305360 */   // GIR_Coverage, 28,
     /* 305360 */   GIR_Done,
     /* 305361 */ // Label 5160: @305361
     /* 305361 */ GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(305401), // Rule ID 7430 //
     /* 305366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 305369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305373 */   // (uint_to_fp:{ *:[f32] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src)
     /* 305373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 305376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305387 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
     /* 305397 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 305399 */   GIR_RootConstrainSelectedInstOperands,
     /* 305400 */   // GIR_Coverage, 7430,
     /* 305400 */   GIR_EraseRootFromParent_Done,
     /* 305401 */ // Label 5161: @305401
     /* 305401 */ GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(305442), // Rule ID 634 //
     /* 305406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305413 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 305420 */   // (uint_to_fp:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_U32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 305420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e64),
     /* 305423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 305435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 305440 */   GIR_RootConstrainSelectedInstOperands,
     /* 305441 */   // GIR_Coverage, 634,
     /* 305441 */   GIR_EraseRootFromParent_Done,
     /* 305442 */ // Label 5162: @305442
     /* 305442 */ GIM_Reject,
     /* 305443 */ // Label 5149: @305443
     /* 305443 */ GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(305495), // Rule ID 7432 //
     /* 305448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 305451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305455 */   // (uint_to_fp:{ *:[f64] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F64_U32_e32:{ *:[f64] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
     /* 305455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 305462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305467 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305470 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305473 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305476 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 305479 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_U32_e32),
     /* 305488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305490 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305493 */   GIR_RootConstrainSelectedInstOperands,
     /* 305494 */   // GIR_Coverage, 7432,
     /* 305494 */   GIR_EraseRootFromParent_Done,
     /* 305495 */ // Label 5163: @305495
     /* 305495 */ GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(305536), // Rule ID 632 //
     /* 305500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305507 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 305514 */   // (uint_to_fp:{ *:[f64] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F64_U32_e64:{ *:[f64] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 305514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_U32_e64),
     /* 305517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 305529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 305534 */   GIR_RootConstrainSelectedInstOperands,
     /* 305535 */   // GIR_Coverage, 632,
     /* 305535 */   GIR_EraseRootFromParent_Done,
     /* 305536 */ // Label 5164: @305536
     /* 305536 */ GIM_Reject,
     /* 305537 */ // Label 5150: @305537
     /* 305537 */ GIM_Reject,
     /* 305538 */ // Label 76: @305538
     /* 305538 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5169*/ GIMT_Encode4(306338),
     /* 305549 */ /*GILLT_s16*//*Label 5165*/ GIMT_Encode4(305565),
     /* 305553 */ /*GILLT_s32*//*Label 5166*/ GIMT_Encode4(305779),
     /* 305557 */ /*GILLT_s64*//*Label 5167*/ GIMT_Encode4(305894),
     /* 305561 */ /*GILLT_v2s16*//*Label 5168*/ GIMT_Encode4(306223),
     /* 305565 */ // Label 5165: @305565
     /* 305565 */ GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(305778),
     /* 305570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305573 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(305629), // Rule ID 7227 //
     /* 305578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305586 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34534),
     /* 305590 */     // (fabs:{ *:[f16] } SReg_32:{ *:[f16] }:$src)<<P:Predicate_anonymous_34534>>  =>  (S_AND_B32:{ *:[f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src, (S_MOV_B32:{ *:[i1] } 32767:{ *:[i32] }))
     /* 305590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 305593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305602 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 305612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 305617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 305619 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 305621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 305627 */     GIR_RootConstrainSelectedInstOperands,
     /* 305628 */     // GIR_Coverage, 7227,
     /* 305628 */     GIR_EraseRootFromParent_Done,
     /* 305629 */   // Label 5171: @305629
     /* 305629 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(305681), // Rule ID 7242 //
     /* 305634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 305637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305645 */     // (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_AND_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 305645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305657 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 305667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 305672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 305679 */     GIR_RootConstrainSelectedInstOperands,
     /* 305680 */     // GIR_Coverage, 7242,
     /* 305680 */     GIR_EraseRootFromParent_Done,
     /* 305681 */   // Label 5172: @305681
     /* 305681 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(305725), // Rule ID 7245 //
     /* 305686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 305689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 305693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 305697 */     // (fabs:{ *:[f16] } VGPR_16:{ *:[f16] }:$src)  =>  (V_AND_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 32767:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[f16] }:$src)
     /* 305697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B16_t16_e64),
     /* 305700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305705 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32767),
     /* 305715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305718 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 305720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305723 */     GIR_RootConstrainSelectedInstOperands,
     /* 305724 */     // GIR_Coverage, 7245,
     /* 305724 */     GIR_EraseRootFromParent_Done,
     /* 305725 */   // Label 5173: @305725
     /* 305725 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(305777), // Rule ID 7248 //
     /* 305730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 305733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305741 */     // (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_AND_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 305741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305753 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 305763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 305768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305773 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 305775 */     GIR_RootConstrainSelectedInstOperands,
     /* 305776 */     // GIR_Coverage, 7248,
     /* 305776 */     GIR_EraseRootFromParent_Done,
     /* 305777 */   // Label 5174: @305777
     /* 305777 */   GIM_Reject,
     /* 305778 */ // Label 5170: @305778
     /* 305778 */ GIM_Reject,
     /* 305779 */ // Label 5166: @305779
     /* 305779 */ GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(305893),
     /* 305784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305787 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(305843), // Rule ID 7224 //
     /* 305792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34534),
     /* 305804 */     // (fabs:{ *:[f32] } SReg_32:{ *:[f32] }:$src)<<P:Predicate_anonymous_34534>>  =>  (S_AND_B32:{ *:[f32] }:{ *:[i1] } SReg_32:{ *:[f32] }:$src, (S_MOV_B32:{ *:[i1] } 2147483647:{ *:[i32] }))
     /* 305804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 305807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305816 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 305826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 305831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 305833 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 305835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 305841 */     GIR_RootConstrainSelectedInstOperands,
     /* 305842 */     // GIR_Coverage, 7224,
     /* 305842 */     GIR_EraseRootFromParent_Done,
     /* 305843 */   // Label 5176: @305843
     /* 305843 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(305892), // Rule ID 7240 //
     /* 305848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305856 */     // (fabs:{ *:[f32] } VGPR_32:{ *:[f32] }:$src)  =>  (V_AND_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), VGPR_32:{ *:[f32] }:$src)
     /* 305856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305868 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 305878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 305883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305888 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 305890 */     GIR_RootConstrainSelectedInstOperands,
     /* 305891 */     // GIR_Coverage, 7240,
     /* 305891 */     GIR_EraseRootFromParent_Done,
     /* 305892 */   // Label 5177: @305892
     /* 305892 */   GIM_Reject,
     /* 305893 */ // Label 5175: @305893
     /* 305893 */ GIM_Reject,
     /* 305894 */ // Label 5167: @305894
     /* 305894 */ GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(306222),
     /* 305899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 305902 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(306075), // Rule ID 7236 //
     /* 305907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 305911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 305915 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34534),
     /* 305919 */     // (fabs:{ *:[f64] } SReg_64:{ *:[f64] }:$src)<<P:Predicate_anonymous_34534>>  =>  (REG_SEQUENCE:{ *:[f64] } SReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i1] } 2147483647:{ *:[i32] })), SReg_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 305919 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
     /* 305922 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305926 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305931 */     GIR_AddImm, /*InsnID*/5, /*Imm*/GIMT_Encode8(2147483647),
     /* 305941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305943 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 305946 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305950 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305955 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 305961 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 305966 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 305971 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 305974 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 305978 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305983 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305986 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 305989 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
     /* 305992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 305994 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 305997 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306001 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306006 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 306009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 306014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306026 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 306032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 306037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 306042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 306045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306050 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 306053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306056 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 306059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 306064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 306069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 306074 */     // GIR_Coverage, 7236,
     /* 306074 */     GIR_EraseRootFromParent_Done,
     /* 306075 */   // Label 5179: @306075
     /* 306075 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(306221), // Rule ID 7254 //
     /* 306080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306088 */     // (fabs:{ *:[f64] } VReg_64:{ *:[f64] }:$src)  =>  (REG_SEQUENCE:{ *:[f64] } VReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (V_AND_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i32] } 2147483647:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /* 306088 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 306091 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306095 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306100 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 306106 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306111 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306116 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 306119 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306123 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306128 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(2147483647),
     /* 306138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 306140 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 306143 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 306147 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306152 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 306155 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 306158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306172 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 306178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 306191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306196 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 306199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306202 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 306205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306220 */     // GIR_Coverage, 7254,
     /* 306220 */     GIR_EraseRootFromParent_Done,
     /* 306221 */   // Label 5180: @306221
     /* 306221 */   GIM_Reject,
     /* 306222 */ // Label 5178: @306222
     /* 306222 */ GIM_Reject,
     /* 306223 */ // Label 5168: @306223
     /* 306223 */ GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(306337),
     /* 306228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 306231 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(306287), // Rule ID 7230 //
     /* 306236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 306240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 306244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34534),
     /* 306248 */     // (fabs:{ *:[v2f16] } SReg_32:{ *:[v2f16] }:$src)<<P:Predicate_anonymous_34534>>  =>  (S_AND_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[v2f16] }:$src, (S_MOV_B32:{ *:[i1] } 2147450879:{ *:[i32] }))
     /* 306248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 306251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306260 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147450879),
     /* 306270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 306275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 306277 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 306279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 306285 */     GIR_RootConstrainSelectedInstOperands,
     /* 306286 */     // GIR_Coverage, 7230,
     /* 306286 */     GIR_EraseRootFromParent_Done,
     /* 306287 */   // Label 5182: @306287
     /* 306287 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(306336), // Rule ID 7252 //
     /* 306292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306300 */     // (fabs:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src)  =>  (V_AND_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 2147450879:{ *:[i32] }), VGPR_32:{ *:[v2f16] }:$src)
     /* 306300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306312 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147450879),
     /* 306322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 306327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306332 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 306334 */     GIR_RootConstrainSelectedInstOperands,
     /* 306335 */     // GIR_Coverage, 7252,
     /* 306335 */     GIR_EraseRootFromParent_Done,
     /* 306336 */   // Label 5183: @306336
     /* 306336 */   GIM_Reject,
     /* 306337 */ // Label 5181: @306337
     /* 306337 */ GIM_Reject,
     /* 306338 */ // Label 5169: @306338
     /* 306338 */ GIM_Reject,
     /* 306339 */ // Label 77: @306339
     /* 306339 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 5186*/ GIMT_Encode4(306701),
     /* 306350 */ /*GILLT_s16*//*Label 5184*/ GIMT_Encode4(306358),
     /* 306354 */ /*GILLT_s32*//*Label 5185*/ GIMT_Encode4(306490),
     /* 306358 */ // Label 5184: @306358
     /* 306358 */ GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(306489),
     /* 306363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 306366 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(306416), // Rule ID 7258 //
     /* 306371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 306374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306378 */     // (fcopysign:{ *:[f16] } f16:{ *:[f16] }:$src0, f16:{ *:[f16] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), ?:{ *:[f16] }:$src0, ?:{ *:[f16] }:$src1)
     /* 306378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306390 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 306400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 306405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306410 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 306412 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 306414 */     GIR_RootConstrainSelectedInstOperands,
     /* 306415 */     // GIR_Coverage, 7258,
     /* 306415 */     GIR_EraseRootFromParent_Done,
     /* 306416 */   // Label 5188: @306416
     /* 306416 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(306488), // Rule ID 7261 //
     /* 306421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 306424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306428 */     // (fcopysign:{ *:[f16] } f16:{ *:[f16] }:$src0, f32:{ *:[f32] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), ?:{ *:[f16] }:$src0, (V_LSHRREV_B32_e64:{ *:[i16] } 16:{ *:[i32] }, ?:{ *:[f32] }:$src1))
     /* 306428 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 306431 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 306435 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306440 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/16,
     /* 306443 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 306447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306461 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 306471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 306476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306481 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 306483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306486 */     GIR_RootConstrainSelectedInstOperands,
     /* 306487 */     // GIR_Coverage, 7261,
     /* 306487 */     GIR_EraseRootFromParent_Done,
     /* 306488 */   // Label 5189: @306488
     /* 306488 */   GIM_Reject,
     /* 306489 */ // Label 5187: @306489
     /* 306489 */ GIM_Reject,
     /* 306490 */ // Label 5185: @306490
     /* 306490 */ GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(306700),
     /* 306495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306498 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(306570), // Rule ID 7259 //
     /* 306503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 306506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306510 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$src0, f16:{ *:[f16] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), ?:{ *:[f32] }:$src0, (V_LSHLREV_B32_e64:{ *:[i16] } 16:{ *:[i32] }, ?:{ *:[f16] }:$src1))
     /* 306510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 306513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 306517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306522 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/16,
     /* 306525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 306529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306543 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 306553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 306558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306563 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 306565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306568 */     GIR_RootConstrainSelectedInstOperands,
     /* 306569 */     // GIR_Coverage, 7259,
     /* 306569 */     GIR_EraseRootFromParent_Done,
     /* 306570 */   // Label 5191: @306570
     /* 306570 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(306620), // Rule ID 7322 //
     /* 306575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 306578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306582 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), ?:{ *:[f32] }:$src0, ?:{ *:[f32] }:$src1)
     /* 306582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306594 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 306604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 306609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306614 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 306616 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 306618 */     GIR_RootConstrainSelectedInstOperands,
     /* 306619 */     // GIR_Coverage, 7322,
     /* 306619 */     GIR_EraseRootFromParent_Done,
     /* 306620 */   // Label 5192: @306620
     /* 306620 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(306699), // Rule ID 7323 //
     /* 306625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 306628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306632 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$src0, f64:{ *:[f64] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), ?:{ *:[f32] }:$src0, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src1, sub1:{ *:[i32] }))
     /* 306632 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 306635 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306639 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306644 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // src1
     /* 306650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 306655 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 306660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 306667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306672 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 306682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 306687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306692 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 306694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306697 */     GIR_RootConstrainSelectedInstOperands,
     /* 306698 */     // GIR_Coverage, 7323,
     /* 306698 */     GIR_EraseRootFromParent_Done,
     /* 306699 */   // Label 5193: @306699
     /* 306699 */   GIM_Reject,
     /* 306700 */ // Label 5190: @306700
     /* 306700 */ GIM_Reject,
     /* 306701 */ // Label 5186: @306701
     /* 306701 */ GIM_Reject,
     /* 306702 */ // Label 78: @306702
     /* 306702 */ GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(307032),
     /* 306707 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 306710 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5198*/ GIMT_Encode4(307031),
     /* 306721 */   /*GILLT_s16*//*Label 5195*/ GIMT_Encode4(306733),
     /* 306725 */   /*GILLT_s32*//*Label 5196*/ GIMT_Encode4(306915),
     /* 306729 */   /*GILLT_s64*//*Label 5197*/ GIMT_Encode4(306973),
     /* 306733 */   // Label 5195: @306733
     /* 306733 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(306914),
     /* 306738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 306742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 306745 */     GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(306798), // Rule ID 2880 //
     /* 306750 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 306753 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 306760 */       // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f16:{ *:[f16] }:$src0, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 306760 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306763 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 306767 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306772 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 306776 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306778 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_e64),
     /* 306781 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 306783 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 306788 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 306793 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306796 */       GIR_RootConstrainSelectedInstOperands,
     /* 306797 */       // GIR_Coverage, 2880,
     /* 306797 */       GIR_EraseRootFromParent_Done,
     /* 306798 */     // Label 5200: @306798
     /* 306798 */     GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(306857), // Rule ID 2881 //
     /* 306803 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 306806 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 306813 */       // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 306813 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306816 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 306820 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306825 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 306829 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306831 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_t16_e64),
     /* 306834 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 306836 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 306841 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 306846 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306849 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306852 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306855 */       GIR_RootConstrainSelectedInstOperands,
     /* 306856 */       // GIR_Coverage, 2881,
     /* 306856 */       GIR_EraseRootFromParent_Done,
     /* 306857 */     // Label 5201: @306857
     /* 306857 */     GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(306913), // Rule ID 2882 //
     /* 306862 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 306865 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 306872 */       // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 306872 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306875 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 306879 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306884 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 306888 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306890 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_fake16_e64),
     /* 306893 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 306895 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 306900 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 306905 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306908 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306911 */       GIR_RootConstrainSelectedInstOperands,
     /* 306912 */       // GIR_Coverage, 2882,
     /* 306912 */       GIR_EraseRootFromParent_Done,
     /* 306913 */     // Label 5202: @306913
     /* 306913 */     GIM_Reject,
     /* 306914 */   // Label 5199: @306914
     /* 306914 */   GIM_Reject,
     /* 306915 */   // Label 5196: @306915
     /* 306915 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(306972), // Rule ID 2883 //
     /* 306920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 306924 */     // MIs[0] mask
     /* 306924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 306927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 306934 */     // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f32:{ *:[f32] }:$src0, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 306934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 306941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 306950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F32_e64),
     /* 306955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 306957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 306962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 306967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306970 */     GIR_RootConstrainSelectedInstOperands,
     /* 306971 */     // GIR_Coverage, 2883,
     /* 306971 */     GIR_EraseRootFromParent_Done,
     /* 306972 */   // Label 5203: @306972
     /* 306972 */   GIM_Reject,
     /* 306973 */   // Label 5197: @306973
     /* 306973 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(307030), // Rule ID 2884 //
     /* 306978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 306982 */     // MIs[0] mask
     /* 306982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 306985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 306992 */     // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f64:{ *:[f64] }:$src0, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 306992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 306999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307004 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 307008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 307010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F64_e64),
     /* 307013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 307020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307028 */     GIR_RootConstrainSelectedInstOperands,
     /* 307029 */     // GIR_Coverage, 2884,
     /* 307029 */     GIR_EraseRootFromParent_Done,
     /* 307030 */   // Label 5204: @307030
     /* 307030 */   GIM_Reject,
     /* 307031 */   // Label 5198: @307031
     /* 307031 */   GIM_Reject,
     /* 307032 */ // Label 5194: @307032
     /* 307032 */ GIM_Reject,
     /* 307033 */ // Label 79: @307033
     /* 307033 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5210*/ GIMT_Encode4(308500),
     /* 307044 */ /*GILLT_s16*//*Label 5205*/ GIMT_Encode4(307064),
     /* 307048 */ /*GILLT_s32*//*Label 5206*/ GIMT_Encode4(307770),
     /* 307052 */ /*GILLT_s64*//*Label 5207*/ GIMT_Encode4(307990),
     /* 307056 */ /*GILLT_v2s16*//*Label 5208*/ GIMT_Encode4(308247),
     /* 307060 */ /*GILLT_v2s32*//*Label 5209*/ GIMT_Encode4(308432),
     /* 307064 */ // Label 5205: @307064
     /* 307064 */ GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(307769),
     /* 307069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307072 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(307124), // Rule ID 7480 //
     /* 307077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasMinMaxDenormModes_NotHasTrue16BitInsts),
     /* 307080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307091 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 307091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 307094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307122 */     GIR_RootConstrainSelectedInstOperands,
     /* 307123 */     // GIR_Coverage, 7480,
     /* 307123 */     GIR_EraseRootFromParent_Done,
     /* 307124 */   // Label 5212: @307124
     /* 307124 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(307179), // Rule ID 7481 //
     /* 307129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasMinMaxDenormModes_UseRealTrue16Insts),
     /* 307132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 307136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307143 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 307143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 307146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307177 */     GIR_RootConstrainSelectedInstOperands,
     /* 307178 */     // GIR_Coverage, 7481,
     /* 307178 */     GIR_EraseRootFromParent_Done,
     /* 307179 */   // Label 5213: @307179
     /* 307179 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(307231), // Rule ID 7482 //
     /* 307184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasMinMaxDenormModes_UseFakeTrue16Insts),
     /* 307187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307198 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 307198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 307201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307229 */     GIR_RootConstrainSelectedInstOperands,
     /* 307230 */     // GIR_Coverage, 7482,
     /* 307230 */     GIR_EraseRootFromParent_Done,
     /* 307231 */   // Label 5214: @307231
     /* 307231 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(307283), // Rule ID 7487 //
     /* 307236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_NotHasTrue16BitInsts),
     /* 307239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307250 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 307250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 307253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307281 */     GIR_RootConstrainSelectedInstOperands,
     /* 307282 */     // GIR_Coverage, 7487,
     /* 307282 */     GIR_EraseRootFromParent_Done,
     /* 307283 */   // Label 5215: @307283
     /* 307283 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(307338), // Rule ID 7488 //
     /* 307288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_UseRealTrue16Insts),
     /* 307291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 307295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307302 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 307302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 307305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307336 */     GIR_RootConstrainSelectedInstOperands,
     /* 307337 */     // GIR_Coverage, 7488,
     /* 307337 */     GIR_EraseRootFromParent_Done,
     /* 307338 */   // Label 5216: @307338
     /* 307338 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(307390), // Rule ID 7489 //
     /* 307343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_UseFakeTrue16Insts),
     /* 307346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307357 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 307357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 307360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307388 */     GIR_RootConstrainSelectedInstOperands,
     /* 307389 */     // GIR_Coverage, 7489,
     /* 307389 */     GIR_EraseRootFromParent_Done,
     /* 307390 */   // Label 5217: @307390
     /* 307390 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(307459), // Rule ID 7467 //
     /* 307395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 307398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307423 */     // (fcanonicalize:{ *:[f16] } (fneg:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F16_e64:{ *:[f16] } 0:{ *:[i32] }, 48128:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
     /* 307423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 307426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307431 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 307441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307457 */     GIR_RootConstrainSelectedInstOperands,
     /* 307458 */     // GIR_Coverage, 7467,
     /* 307458 */     GIR_EraseRootFromParent_Done,
     /* 307459 */   // Label 5218: @307459
     /* 307459 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(307531), // Rule ID 7469 //
     /* 307464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 307467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 307471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307492 */     // (fcanonicalize:{ *:[f16] } (fneg:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 307492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
     /* 307495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307500 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 307510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307529 */     GIR_RootConstrainSelectedInstOperands,
     /* 307530 */     // GIR_Coverage, 7469,
     /* 307530 */     GIR_EraseRootFromParent_Done,
     /* 307531 */   // Label 5219: @307531
     /* 307531 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(307600), // Rule ID 7471 //
     /* 307536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 307539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307564 */     // (fcanonicalize:{ *:[f16] } (fneg:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, 48128:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
     /* 307564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 307567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307572 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 307582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307598 */     GIR_RootConstrainSelectedInstOperands,
     /* 307599 */     // GIR_Coverage, 7471,
     /* 307599 */     GIR_EraseRootFromParent_Done,
     /* 307600 */   // Label 5220: @307600
     /* 307600 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(307655), // Rule ID 7466 //
     /* 307605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 307608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307619 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F16_e64:{ *:[f16] } 0:{ *:[i32] }, 15360:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
     /* 307619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 307622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307627 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 307637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307653 */     GIR_RootConstrainSelectedInstOperands,
     /* 307654 */     // GIR_Coverage, 7466,
     /* 307654 */     GIR_EraseRootFromParent_Done,
     /* 307655 */   // Label 5221: @307655
     /* 307655 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(307713), // Rule ID 7468 //
     /* 307660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 307663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 307667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307674 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 307674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
     /* 307677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307682 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 307692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307711 */     GIR_RootConstrainSelectedInstOperands,
     /* 307712 */     // GIR_Coverage, 7468,
     /* 307712 */     GIR_EraseRootFromParent_Done,
     /* 307713 */   // Label 5222: @307713
     /* 307713 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(307768), // Rule ID 7470 //
     /* 307718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 307721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307732 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, 15360:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
     /* 307732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 307735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307740 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 307750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307766 */     GIR_RootConstrainSelectedInstOperands,
     /* 307767 */     // GIR_Coverage, 7470,
     /* 307767 */     GIR_EraseRootFromParent_Done,
     /* 307768 */   // Label 5223: @307768
     /* 307768 */   GIM_Reject,
     /* 307769 */ // Label 5211: @307769
     /* 307769 */ GIM_Reject,
     /* 307770 */ // Label 5206: @307770
     /* 307770 */ GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(307989),
     /* 307775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307782 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(307830), // Rule ID 7477 //
     /* 307787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes),
     /* 307790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307797 */     // (fcanonicalize:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
     /* 307797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 307800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307828 */     GIR_RootConstrainSelectedInstOperands,
     /* 307829 */     // GIR_Coverage, 7477,
     /* 307829 */     GIR_EraseRootFromParent_Done,
     /* 307830 */   // Label 5225: @307830
     /* 307830 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(307878), // Rule ID 7484 //
     /* 307835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FalsePredicate_NotHasMinMaxDenormModes),
     /* 307838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307845 */     // (fcanonicalize:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
     /* 307845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 307848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307876 */     GIR_RootConstrainSelectedInstOperands,
     /* 307877 */     // GIR_Coverage, 7484,
     /* 307877 */     GIR_EraseRootFromParent_Done,
     /* 307878 */   // Label 5226: @307878
     /* 307878 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(307940), // Rule ID 7474 //
     /* 307883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307904 */     // (fcanonicalize:{ *:[f32] } (fneg:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F32_e64:{ *:[f32] } 0:{ *:[i32] }, 3212836864:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
     /* 307904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 307907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307912 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3212836864),
     /* 307922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307938 */     GIR_RootConstrainSelectedInstOperands,
     /* 307939 */     // GIR_Coverage, 7474,
     /* 307939 */     GIR_EraseRootFromParent_Done,
     /* 307940 */   // Label 5227: @307940
     /* 307940 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(307988), // Rule ID 7473 //
     /* 307945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307952 */     // (fcanonicalize:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F32_e64:{ *:[f32] } 0:{ *:[i32] }, 1065353216:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
     /* 307952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 307955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307960 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
     /* 307970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 307975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 307980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307986 */     GIR_RootConstrainSelectedInstOperands,
     /* 307987 */     // GIR_Coverage, 7473,
     /* 307987 */     GIR_EraseRootFromParent_Done,
     /* 307988 */   // Label 5228: @307988
     /* 307988 */   GIM_Reject,
     /* 307989 */ // Label 5224: @307989
     /* 307989 */ GIM_Reject,
     /* 307990 */ // Label 5207: @307990
     /* 307990 */ GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(308246),
     /* 307995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 308002 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(308050), // Rule ID 7478 //
     /* 308007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes_isNotGFX12Plus),
     /* 308010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308017 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 308017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 308020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308048 */     GIR_RootConstrainSelectedInstOperands,
     /* 308049 */     // GIR_Coverage, 7478,
     /* 308049 */     GIR_EraseRootFromParent_Done,
     /* 308050 */   // Label 5230: @308050
     /* 308050 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(308098), // Rule ID 7479 //
     /* 308055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes_isGFX12Plus),
     /* 308058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308065 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 308065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 308068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308096 */     GIR_RootConstrainSelectedInstOperands,
     /* 308097 */     // GIR_Coverage, 7479,
     /* 308097 */     GIR_EraseRootFromParent_Done,
     /* 308098 */   // Label 5231: @308098
     /* 308098 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(308146), // Rule ID 7485 //
     /* 308103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isNotGFX12Plus),
     /* 308106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308113 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 308113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 308116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308144 */     GIR_RootConstrainSelectedInstOperands,
     /* 308145 */     // GIR_Coverage, 7485,
     /* 308145 */     GIR_EraseRootFromParent_Done,
     /* 308146 */   // Label 5232: @308146
     /* 308146 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(308194), // Rule ID 7486 //
     /* 308151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isGFX12Plus),
     /* 308154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308161 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 308161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 308164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308192 */     GIR_RootConstrainSelectedInstOperands,
     /* 308193 */     // GIR_Coverage, 7486,
     /* 308193 */     GIR_EraseRootFromParent_Done,
     /* 308194 */   // Label 5233: @308194
     /* 308194 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(308245), // Rule ID 7476 //
     /* 308199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 308202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308209 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F64_e64:{ *:[f64] } 0:{ *:[i32] }, 4607182418800017408:{ *:[i64] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 308209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 308212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308217 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(4607182418800017408),
     /* 308227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308243 */     GIR_RootConstrainSelectedInstOperands,
     /* 308244 */     // GIR_Coverage, 7476,
     /* 308244 */     GIR_EraseRootFromParent_Done,
     /* 308245 */   // Label 5234: @308245
     /* 308245 */   GIM_Reject,
     /* 308246 */ // Label 5229: @308246
     /* 308246 */ GIM_Reject,
     /* 308247 */ // Label 5208: @308247
     /* 308247 */ GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(308431),
     /* 308252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 308255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308259 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(308316), // Rule ID 7483 //
     /* 308264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes),
     /* 308267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 308274 */     // (fcanonicalize:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MAX_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, 0:{ *:[i1] })
     /* 308274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 308277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308314 */     GIR_RootConstrainSelectedInstOperands,
     /* 308315 */     // GIR_Coverage, 7483,
     /* 308315 */     GIR_EraseRootFromParent_Done,
     /* 308316 */   // Label 5236: @308316
     /* 308316 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(308373), // Rule ID 7490 //
     /* 308321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_NotHasMinMaxDenormModes),
     /* 308324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 308331 */     // (fcanonicalize:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MAX_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, 0:{ *:[i1] })
     /* 308331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 308334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308371 */     GIR_RootConstrainSelectedInstOperands,
     /* 308372 */     // GIR_Coverage, 7490,
     /* 308372 */     GIR_EraseRootFromParent_Done,
     /* 308373 */   // Label 5237: @308373
     /* 308373 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(308430), // Rule ID 7472 //
     /* 308378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 308385 */     // (fcanonicalize:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MUL_F16:{ *:[v2f16] } 0:{ *:[i32] }, 15360:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, 0:{ *:[i1] })
     /* 308385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F16),
     /* 308388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308393 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 308403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308428 */     GIR_RootConstrainSelectedInstOperands,
     /* 308429 */     // GIR_Coverage, 7472,
     /* 308429 */     GIR_EraseRootFromParent_Done,
     /* 308430 */   // Label 5238: @308430
     /* 308430 */   GIM_Reject,
     /* 308431 */ // Label 5235: @308431
     /* 308431 */ GIM_Reject,
     /* 308432 */ // Label 5209: @308432
     /* 308432 */ GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(308499), // Rule ID 7475 //
     /* 308437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 308440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 308443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 308447 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 308454 */   // (fcanonicalize:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MUL_F32:{ *:[v2f32] } 0:{ *:[i32] }, 1065353216:{ *:[i64] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f32] }:$src)
     /* 308454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F32),
     /* 308457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308462 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
     /* 308472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 308477 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 308482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308497 */   GIR_RootConstrainSelectedInstOperands,
     /* 308498 */   // GIR_Coverage, 7475,
     /* 308498 */   GIR_EraseRootFromParent_Done,
     /* 308499 */ // Label 5239: @308499
     /* 308499 */ GIM_Reject,
     /* 308500 */ // Label 5210: @308500
     /* 308500 */ GIM_Reject,
     /* 308501 */ // Label 80: @308501
     /* 308501 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5244*/ GIMT_Encode4(380279),
     /* 308512 */ /*GILLT_s16*//*Label 5240*/ GIMT_Encode4(308528),
     /* 308516 */ /*GILLT_s32*//*Label 5241*/ GIMT_Encode4(362442),
     /* 308520 */ /*GILLT_s64*//*Label 5242*/ GIMT_Encode4(379954),
     /* 308524 */ /*GILLT_v2s16*//*Label 5243*/ GIMT_Encode4(380207),
     /* 308528 */ // Label 5240: @308528
     /* 308528 */ GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(362441),
     /* 308533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 308539 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(308674), // Rule ID 12257 //
     /* 308544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 308547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 308559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 308575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 308583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 308591 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 308591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 308596 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 308596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 308601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 308605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308621 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308628 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 308628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 308631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 308638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 308643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 308648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 308653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 308658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 308663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308672 */     GIR_RootConstrainSelectedInstOperands,
     /* 308673 */     // GIR_Coverage, 12257,
     /* 308673 */     GIR_EraseRootFromParent_Done,
     /* 308674 */   // Label 5246: @308674
     /* 308674 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(308809), // Rule ID 12258 //
     /* 308679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 308682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 308694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 308710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 308718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 308726 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 308726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 308731 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 308731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 308736 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 308740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308763 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 308763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 308766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 308773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 308778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 308783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 308788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 308793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 308798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308807 */     GIR_RootConstrainSelectedInstOperands,
     /* 308808 */     // GIR_Coverage, 12258,
     /* 308808 */     GIR_EraseRootFromParent_Done,
     /* 308809 */   // Label 5247: @308809
     /* 308809 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(308944), // Rule ID 12261 //
     /* 308814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 308817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 308829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 308845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 308853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 308861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 308861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 308866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 308866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 308871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 308875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 308898 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 308898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 308901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 308908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 308913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 308918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 308923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 308928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 308933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308942 */     GIR_RootConstrainSelectedInstOperands,
     /* 308943 */     // GIR_Coverage, 12261,
     /* 308943 */     GIR_EraseRootFromParent_Done,
     /* 308944 */   // Label 5248: @308944
     /* 308944 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(309079), // Rule ID 12262 //
     /* 308949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 308952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 308964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 308980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 308984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 308988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 308996 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 308996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309001 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309033 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 309036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 309043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 309048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 309053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 309058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309077 */     GIR_RootConstrainSelectedInstOperands,
     /* 309078 */     // GIR_Coverage, 12262,
     /* 309078 */     GIR_EraseRootFromParent_Done,
     /* 309079 */   // Label 5249: @309079
     /* 309079 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(309214), // Rule ID 12737 //
     /* 309084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 309087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 309091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309136 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309141 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309145 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309168 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 309171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 309178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 309188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 309193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309212 */     GIR_RootConstrainSelectedInstOperands,
     /* 309213 */     // GIR_Coverage, 12737,
     /* 309213 */     GIR_EraseRootFromParent_Done,
     /* 309214 */   // Label 5250: @309214
     /* 309214 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(309349), // Rule ID 12738 //
     /* 309219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 309222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 309226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309266 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309271 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309276 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309303 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 309306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 309313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 309323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 309328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309347 */     GIR_RootConstrainSelectedInstOperands,
     /* 309348 */     // GIR_Coverage, 12738,
     /* 309348 */     GIR_EraseRootFromParent_Done,
     /* 309349 */   // Label 5251: @309349
     /* 309349 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(309484), // Rule ID 12741 //
     /* 309354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 309357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 309361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309401 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309411 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309415 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309438 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 309441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 309448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 309453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 309458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 309463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309482 */     GIR_RootConstrainSelectedInstOperands,
     /* 309483 */     // GIR_Coverage, 12741,
     /* 309483 */     GIR_EraseRootFromParent_Done,
     /* 309484 */   // Label 5252: @309484
     /* 309484 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(309619), // Rule ID 12742 //
     /* 309489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 309492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 309496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309536 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309541 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309573 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 309576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 309583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 309588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 309593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 309598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309617 */     GIR_RootConstrainSelectedInstOperands,
     /* 309618 */     // GIR_Coverage, 12742,
     /* 309618 */     GIR_EraseRootFromParent_Done,
     /* 309619 */   // Label 5253: @309619
     /* 309619 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(309754), // Rule ID 13217 //
     /* 309624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 309627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309671 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309676 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309708 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 309711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 309718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 309728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 309733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309752 */     GIR_RootConstrainSelectedInstOperands,
     /* 309753 */     // GIR_Coverage, 13217,
     /* 309753 */     GIR_EraseRootFromParent_Done,
     /* 309754 */   // Label 5254: @309754
     /* 309754 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(309889), // Rule ID 13218 //
     /* 309759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 309762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309811 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309843 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 309846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 309853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 309863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 309868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 309873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 309878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309887 */     GIR_RootConstrainSelectedInstOperands,
     /* 309888 */     // GIR_Coverage, 13218,
     /* 309888 */     GIR_EraseRootFromParent_Done,
     /* 309889 */   // Label 5255: @309889
     /* 309889 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(310024), // Rule ID 13221 //
     /* 309894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 309897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 309917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 309925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 309933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 309941 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 309941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 309946 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 309946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 309951 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 309955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309971 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 309978 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 309981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 309988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 309993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 309998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 310003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310022 */     GIR_RootConstrainSelectedInstOperands,
     /* 310023 */     // GIR_Coverage, 13221,
     /* 310023 */     GIR_EraseRootFromParent_Done,
     /* 310024 */   // Label 5256: @310024
     /* 310024 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(310159), // Rule ID 13222 //
     /* 310029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 310032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 310076 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310081 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310090 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310113 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 310116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 310123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 310128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 310133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 310138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310157 */     GIR_RootConstrainSelectedInstOperands,
     /* 310158 */     // GIR_Coverage, 13222,
     /* 310158 */     GIR_EraseRootFromParent_Done,
     /* 310159 */   // Label 5257: @310159
     /* 310159 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(310294), // Rule ID 12242 //
     /* 310164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 310167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 310211 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310216 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310241 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310248 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 310251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 310258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 310263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 310268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 310273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310292 */     GIR_RootConstrainSelectedInstOperands,
     /* 310293 */     // GIR_Coverage, 12242,
     /* 310293 */     GIR_EraseRootFromParent_Done,
     /* 310294 */   // Label 5258: @310294
     /* 310294 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(310429), // Rule ID 12243 //
     /* 310299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 310302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 310346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310383 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 310386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 310393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 310398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 310403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 310408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310427 */     GIR_RootConstrainSelectedInstOperands,
     /* 310428 */     // GIR_Coverage, 12243,
     /* 310428 */     GIR_EraseRootFromParent_Done,
     /* 310429 */   // Label 5259: @310429
     /* 310429 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(310564), // Rule ID 12246 //
     /* 310434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 310437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 310481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310511 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310518 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 310521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 310528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 310533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 310538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 310543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310562 */     GIR_RootConstrainSelectedInstOperands,
     /* 310563 */     // GIR_Coverage, 12246,
     /* 310563 */     GIR_EraseRootFromParent_Done,
     /* 310564 */   // Label 5260: @310564
     /* 310564 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(310699), // Rule ID 12247 //
     /* 310569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 310572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 310616 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310621 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310621 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310626 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310646 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310653 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 310656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 310663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 310668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 310673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 310678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310697 */     GIR_RootConstrainSelectedInstOperands,
     /* 310698 */     // GIR_Coverage, 12247,
     /* 310698 */     GIR_EraseRootFromParent_Done,
     /* 310699 */   // Label 5261: @310699
     /* 310699 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(310834), // Rule ID 12722 //
     /* 310704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 310707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 310711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 310751 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310756 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310765 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310788 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 310791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 310798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 310803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 310808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 310813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310832 */     GIR_RootConstrainSelectedInstOperands,
     /* 310833 */     // GIR_Coverage, 12722,
     /* 310833 */     GIR_EraseRootFromParent_Done,
     /* 310834 */   // Label 5262: @310834
     /* 310834 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(310969), // Rule ID 12723 //
     /* 310839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 310842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 310846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 310878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 310886 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 310886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 310891 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 310891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 310896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 310900 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 310923 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 310923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 310926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 310933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 310938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 310943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 310948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 310953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 310958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310967 */     GIR_RootConstrainSelectedInstOperands,
     /* 310968 */     // GIR_Coverage, 12723,
     /* 310968 */     GIR_EraseRootFromParent_Done,
     /* 310969 */   // Label 5263: @310969
     /* 310969 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(311104), // Rule ID 12726 //
     /* 310974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 310977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 310981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 310989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311021 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311026 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311035 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311051 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311058 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 311061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 311068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 311073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 311078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 311083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311102 */     GIR_RootConstrainSelectedInstOperands,
     /* 311103 */     // GIR_Coverage, 12726,
     /* 311103 */     GIR_EraseRootFromParent_Done,
     /* 311104 */   // Label 5264: @311104
     /* 311104 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(311239), // Rule ID 12727 //
     /* 311109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 311112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 311116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311193 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 311196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 311203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 311208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 311213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 311218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311237 */     GIR_RootConstrainSelectedInstOperands,
     /* 311238 */     // GIR_Coverage, 12727,
     /* 311238 */     GIR_EraseRootFromParent_Done,
     /* 311239 */   // Label 5265: @311239
     /* 311239 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(311374), // Rule ID 13202 //
     /* 311244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 311247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311291 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311296 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311321 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311328 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 311331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 311338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 311343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 311348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 311353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311372 */     GIR_RootConstrainSelectedInstOperands,
     /* 311373 */     // GIR_Coverage, 13202,
     /* 311373 */     GIR_EraseRootFromParent_Done,
     /* 311374 */   // Label 5266: @311374
     /* 311374 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(311509), // Rule ID 13203 //
     /* 311379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 311382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311414 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311426 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311431 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311436 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311456 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311463 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 311466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 311473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 311478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 311483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 311488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311507 */     GIR_RootConstrainSelectedInstOperands,
     /* 311508 */     // GIR_Coverage, 13203,
     /* 311508 */     GIR_EraseRootFromParent_Done,
     /* 311509 */   // Label 5267: @311509
     /* 311509 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(311644), // Rule ID 13206 //
     /* 311514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 311517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311561 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311561 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311566 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311575 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311598 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 311601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 311608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 311613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 311618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 311623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311642 */     GIR_RootConstrainSelectedInstOperands,
     /* 311643 */     // GIR_Coverage, 13206,
     /* 311643 */     GIR_EraseRootFromParent_Done,
     /* 311644 */   // Label 5268: @311644
     /* 311644 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(311779), // Rule ID 13207 //
     /* 311649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 311652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 311696 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311701 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311706 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311733 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 311736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 311743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 311748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 311753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 311758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311777 */     GIR_RootConstrainSelectedInstOperands,
     /* 311778 */     // GIR_Coverage, 13207,
     /* 311778 */     GIR_EraseRootFromParent_Done,
     /* 311779 */   // Label 5269: @311779
     /* 311779 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(311914), // Rule ID 7640 //
     /* 311784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 311787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 311827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 311831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311836 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311868 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 311871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 311878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 311883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 311888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 311893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 311898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 311903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311912 */     GIR_RootConstrainSelectedInstOperands,
     /* 311913 */     // GIR_Coverage, 7640,
     /* 311913 */     GIR_EraseRootFromParent_Done,
     /* 311914 */   // Label 5270: @311914
     /* 311914 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(312049), // Rule ID 7672 //
     /* 311919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 311922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 311926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 311942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 311950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 311958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 311962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 311966 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 311966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 311971 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 311971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 311976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 311980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311996 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312003 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 312006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 312013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 312018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 312023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 312028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312047 */     GIR_RootConstrainSelectedInstOperands,
     /* 312048 */     // GIR_Coverage, 7672,
     /* 312048 */     GIR_EraseRootFromParent_Done,
     /* 312049 */   // Label 5271: @312049
     /* 312049 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(312184), // Rule ID 7704 //
     /* 312054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 312057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312101 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312106 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312138 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 312141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 312148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 312153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 312158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 312163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312182 */     GIR_RootConstrainSelectedInstOperands,
     /* 312183 */     // GIR_Coverage, 7704,
     /* 312183 */     GIR_EraseRootFromParent_Done,
     /* 312184 */   // Label 5272: @312184
     /* 312184 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(312319), // Rule ID 12256 //
     /* 312189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 312192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312236 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312241 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312273 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 312276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 312283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 312288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 312293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 312298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312317 */     GIR_RootConstrainSelectedInstOperands,
     /* 312318 */     // GIR_Coverage, 12256,
     /* 312318 */     GIR_EraseRootFromParent_Done,
     /* 312319 */   // Label 5273: @312319
     /* 312319 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(312454), // Rule ID 12259 //
     /* 312324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 312327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312371 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312376 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312408 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 312411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 312418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 312423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 312428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 312433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312452 */     GIR_RootConstrainSelectedInstOperands,
     /* 312453 */     // GIR_Coverage, 12259,
     /* 312453 */     GIR_EraseRootFromParent_Done,
     /* 312454 */   // Label 5274: @312454
     /* 312454 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(312589), // Rule ID 12260 //
     /* 312459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 312462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312506 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312511 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312543 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 312546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 312553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 312558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 312563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 312568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312587 */     GIR_RootConstrainSelectedInstOperands,
     /* 312588 */     // GIR_Coverage, 12260,
     /* 312588 */     GIR_EraseRootFromParent_Done,
     /* 312589 */   // Label 5275: @312589
     /* 312589 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(312724), // Rule ID 12736 //
     /* 312594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 312597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 312601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312641 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312646 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312651 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312678 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 312681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 312688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 312693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 312698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 312703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312722 */     GIR_RootConstrainSelectedInstOperands,
     /* 312723 */     // GIR_Coverage, 12736,
     /* 312723 */     GIR_EraseRootFromParent_Done,
     /* 312724 */   // Label 5276: @312724
     /* 312724 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(312859), // Rule ID 12739 //
     /* 312729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 312732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 312736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312776 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312781 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312813 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 312816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 312823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 312828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 312833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 312838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312857 */     GIR_RootConstrainSelectedInstOperands,
     /* 312858 */     // GIR_Coverage, 12739,
     /* 312858 */     GIR_EraseRootFromParent_Done,
     /* 312859 */   // Label 5277: @312859
     /* 312859 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(312994), // Rule ID 12740 //
     /* 312864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 312867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 312871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 312903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 312911 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 312911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 312916 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 312916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 312921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 312925 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312948 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 312948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 312951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 312958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 312963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 312968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 312973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 312978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 312983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312992 */     GIR_RootConstrainSelectedInstOperands,
     /* 312993 */     // GIR_Coverage, 12740,
     /* 312993 */     GIR_EraseRootFromParent_Done,
     /* 312994 */   // Label 5278: @312994
     /* 312994 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(313129), // Rule ID 13216 //
     /* 312999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 313002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313046 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313051 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313051 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313056 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313076 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313083 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 313086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 313093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 313098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 313103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 313108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313127 */     GIR_RootConstrainSelectedInstOperands,
     /* 313128 */     // GIR_Coverage, 13216,
     /* 313128 */     GIR_EraseRootFromParent_Done,
     /* 313129 */   // Label 5279: @313129
     /* 313129 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(313264), // Rule ID 13219 //
     /* 313134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 313137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313169 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313181 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313186 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313218 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 313221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 313228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 313233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 313238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 313243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313262 */     GIR_RootConstrainSelectedInstOperands,
     /* 313263 */     // GIR_Coverage, 13219,
     /* 313263 */     GIR_EraseRootFromParent_Done,
     /* 313264 */   // Label 5280: @313264
     /* 313264 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(313399), // Rule ID 13220 //
     /* 313269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 313272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313316 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313321 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313326 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313353 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 313356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 313363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 313368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 313373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 313378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313397 */     GIR_RootConstrainSelectedInstOperands,
     /* 313398 */     // GIR_Coverage, 13220,
     /* 313398 */     GIR_EraseRootFromParent_Done,
     /* 313399 */   // Label 5281: @313399
     /* 313399 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(313534), // Rule ID 7639 //
     /* 313404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 313407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 313451 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313456 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313488 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 313491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 313498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 313503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 313508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 313513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313532 */     GIR_RootConstrainSelectedInstOperands,
     /* 313533 */     // GIR_Coverage, 7639,
     /* 313533 */     GIR_EraseRootFromParent_Done,
     /* 313534 */   // Label 5282: @313534
     /* 313534 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(313669), // Rule ID 7671 //
     /* 313539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 313542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 313546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 313586 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313591 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313596 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313616 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313623 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 313626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 313633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 313638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 313643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 313648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313667 */     GIR_RootConstrainSelectedInstOperands,
     /* 313668 */     // GIR_Coverage, 7671,
     /* 313668 */     GIR_EraseRootFromParent_Done,
     /* 313669 */   // Label 5283: @313669
     /* 313669 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(313804), // Rule ID 7703 //
     /* 313674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 313677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 313721 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313721 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313726 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313731 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313758 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 313761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 313768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 313773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 313778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 313783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313802 */     GIR_RootConstrainSelectedInstOperands,
     /* 313803 */     // GIR_Coverage, 7703,
     /* 313803 */     GIR_EraseRootFromParent_Done,
     /* 313804 */   // Label 5284: @313804
     /* 313804 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(313939), // Rule ID 12241 //
     /* 313809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 313812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 313856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313893 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 313896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 313903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 313908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 313913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 313918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313937 */     GIR_RootConstrainSelectedInstOperands,
     /* 313938 */     // GIR_Coverage, 12241,
     /* 313938 */     GIR_EraseRootFromParent_Done,
     /* 313939 */   // Label 5285: @313939
     /* 313939 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(314074), // Rule ID 12244 //
     /* 313944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 313947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 313991 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313996 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314001 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314021 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314028 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 314031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314072 */     GIR_RootConstrainSelectedInstOperands,
     /* 314073 */     // GIR_Coverage, 12244,
     /* 314073 */     GIR_EraseRootFromParent_Done,
     /* 314074 */   // Label 5286: @314074
     /* 314074 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(314209), // Rule ID 12245 //
     /* 314079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 314082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314136 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314163 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 314166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314207 */     GIR_RootConstrainSelectedInstOperands,
     /* 314208 */     // GIR_Coverage, 12245,
     /* 314208 */     GIR_EraseRootFromParent_Done,
     /* 314209 */   // Label 5287: @314209
     /* 314209 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(314344), // Rule ID 12721 //
     /* 314214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 314217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 314221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314249 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314261 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314266 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314271 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314291 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314298 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 314301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 314308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 314313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 314318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 314323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314342 */     GIR_RootConstrainSelectedInstOperands,
     /* 314343 */     // GIR_Coverage, 12721,
     /* 314343 */     GIR_EraseRootFromParent_Done,
     /* 314344 */   // Label 5288: @314344
     /* 314344 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(314479), // Rule ID 12724 //
     /* 314349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 314352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 314356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314396 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314401 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314406 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314433 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 314436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314477 */     GIR_RootConstrainSelectedInstOperands,
     /* 314478 */     // GIR_Coverage, 12724,
     /* 314478 */     GIR_EraseRootFromParent_Done,
     /* 314479 */   // Label 5289: @314479
     /* 314479 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(314614), // Rule ID 12725 //
     /* 314484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 314487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 314491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314531 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314536 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314568 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 314571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314612 */     GIR_RootConstrainSelectedInstOperands,
     /* 314613 */     // GIR_Coverage, 12725,
     /* 314613 */     GIR_EraseRootFromParent_Done,
     /* 314614 */   // Label 5290: @314614
     /* 314614 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(314749), // Rule ID 13201 //
     /* 314619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 314622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314666 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314671 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314676 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314703 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 314706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 314713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 314718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 314723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 314728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314747 */     GIR_RootConstrainSelectedInstOperands,
     /* 314748 */     // GIR_Coverage, 13201,
     /* 314748 */     GIR_EraseRootFromParent_Done,
     /* 314749 */   // Label 5291: @314749
     /* 314749 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(314884), // Rule ID 13204 //
     /* 314754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 314757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314838 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 314841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314882 */     GIR_RootConstrainSelectedInstOperands,
     /* 314883 */     // GIR_Coverage, 13204,
     /* 314883 */     GIR_EraseRootFromParent_Done,
     /* 314884 */   // Label 5292: @314884
     /* 314884 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(315019), // Rule ID 13205 //
     /* 314889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 314892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 314932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314936 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314941 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314973 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 314976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315017 */     GIR_RootConstrainSelectedInstOperands,
     /* 315018 */     // GIR_Coverage, 13205,
     /* 315018 */     GIR_EraseRootFromParent_Done,
     /* 315019 */   // Label 5293: @315019
     /* 315019 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(315154), // Rule ID 12227 //
     /* 315024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 315027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 315031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 315055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 315071 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315076 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315081 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315108 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 315111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 315118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 315123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 315128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 315133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315152 */     GIR_RootConstrainSelectedInstOperands,
     /* 315153 */     // GIR_Coverage, 12227,
     /* 315153 */     GIR_EraseRootFromParent_Done,
     /* 315154 */   // Label 5294: @315154
     /* 315154 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(315289), // Rule ID 12228 //
     /* 315159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 315162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 315166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 315190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315194 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 315206 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315206 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315211 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315216 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315236 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315243 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 315246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 315253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 315258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 315263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 315268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315287 */     GIR_RootConstrainSelectedInstOperands,
     /* 315288 */     // GIR_Coverage, 12228,
     /* 315288 */     GIR_EraseRootFromParent_Done,
     /* 315289 */   // Label 5295: @315289
     /* 315289 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(315424), // Rule ID 12231 //
     /* 315294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 315297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 315301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 315325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 315341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315351 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315378 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 315381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 315388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 315393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 315398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 315403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315422 */     GIR_RootConstrainSelectedInstOperands,
     /* 315423 */     // GIR_Coverage, 12231,
     /* 315423 */     GIR_EraseRootFromParent_Done,
     /* 315424 */   // Label 5296: @315424
     /* 315424 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(315559), // Rule ID 12232 //
     /* 315429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 315432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 315436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 315460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 315476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315513 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 315516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 315523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 315528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 315533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 315538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315557 */     GIR_RootConstrainSelectedInstOperands,
     /* 315558 */     // GIR_Coverage, 12232,
     /* 315558 */     GIR_EraseRootFromParent_Done,
     /* 315559 */   // Label 5297: @315559
     /* 315559 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(315694), // Rule ID 12707 //
     /* 315564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 315567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 315571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 315595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 315611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315616 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315634 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315648 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 315651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 315658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 315663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 315668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 315673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315692 */     GIR_RootConstrainSelectedInstOperands,
     /* 315693 */     // GIR_Coverage, 12707,
     /* 315693 */     GIR_EraseRootFromParent_Done,
     /* 315694 */   // Label 5298: @315694
     /* 315694 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(315829), // Rule ID 12708 //
     /* 315699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 315702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 315706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 315730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 315746 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315751 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315756 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315783 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 315786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 315793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 315798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 315803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 315808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315827 */     GIR_RootConstrainSelectedInstOperands,
     /* 315828 */     // GIR_Coverage, 12708,
     /* 315828 */     GIR_EraseRootFromParent_Done,
     /* 315829 */   // Label 5299: @315829
     /* 315829 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(315964), // Rule ID 12711 //
     /* 315834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 315837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 315841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 315865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 315881 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315886 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315891 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315895 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315918 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 315921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 315928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 315933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 315938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 315943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315962 */     GIR_RootConstrainSelectedInstOperands,
     /* 315963 */     // GIR_Coverage, 12711,
     /* 315963 */     GIR_EraseRootFromParent_Done,
     /* 315964 */   // Label 5300: @315964
     /* 315964 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(316099), // Rule ID 12712 //
     /* 315969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 315972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 315976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316016 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316021 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316053 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 316056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 316063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 316068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 316073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 316078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316097 */     GIR_RootConstrainSelectedInstOperands,
     /* 316098 */     // GIR_Coverage, 12712,
     /* 316098 */     GIR_EraseRootFromParent_Done,
     /* 316099 */   // Label 5301: @316099
     /* 316099 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(316234), // Rule ID 13187 //
     /* 316104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 316107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316188 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 316191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 316198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 316203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 316208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 316213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316232 */     GIR_RootConstrainSelectedInstOperands,
     /* 316233 */     // GIR_Coverage, 13187,
     /* 316233 */     GIR_EraseRootFromParent_Done,
     /* 316234 */   // Label 5302: @316234
     /* 316234 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(316369), // Rule ID 13188 //
     /* 316239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 316242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316291 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316296 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316323 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 316326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 316333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 316338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 316343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 316348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316367 */     GIR_RootConstrainSelectedInstOperands,
     /* 316368 */     // GIR_Coverage, 13188,
     /* 316368 */     GIR_EraseRootFromParent_Done,
     /* 316369 */   // Label 5303: @316369
     /* 316369 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(316504), // Rule ID 13191 //
     /* 316374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 316377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316426 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316458 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 316461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 316468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 316473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 316478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 316483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316502 */     GIR_RootConstrainSelectedInstOperands,
     /* 316503 */     // GIR_Coverage, 13191,
     /* 316503 */     GIR_EraseRootFromParent_Done,
     /* 316504 */   // Label 5304: @316504
     /* 316504 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(316639), // Rule ID 13192 //
     /* 316509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 316512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316556 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316561 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316561 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316593 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 316596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 316603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 316608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 316613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 316618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316637 */     GIR_RootConstrainSelectedInstOperands,
     /* 316638 */     // GIR_Coverage, 13192,
     /* 316638 */     GIR_EraseRootFromParent_Done,
     /* 316639 */   // Label 5305: @316639
     /* 316639 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(316774), // Rule ID 12212 //
     /* 316644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 316647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316679 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 316691 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316691 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316696 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316728 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 316731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 316738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 316743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 316748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 316753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316772 */     GIR_RootConstrainSelectedInstOperands,
     /* 316773 */     // GIR_Coverage, 12212,
     /* 316773 */     GIR_EraseRootFromParent_Done,
     /* 316774 */   // Label 5306: @316774
     /* 316774 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(316909), // Rule ID 12213 //
     /* 316779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 316782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 316826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316836 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316863 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 316866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 316873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 316878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 316883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 316888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316907 */     GIR_RootConstrainSelectedInstOperands,
     /* 316908 */     // GIR_Coverage, 12213,
     /* 316908 */     GIR_EraseRootFromParent_Done,
     /* 316909 */   // Label 5307: @316909
     /* 316909 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(317044), // Rule ID 12216 //
     /* 316914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 316917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 316945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 316961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316966 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316998 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 317001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 317008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 317013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 317018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 317023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317042 */     GIR_RootConstrainSelectedInstOperands,
     /* 317043 */     // GIR_Coverage, 12216,
     /* 317043 */     GIR_EraseRootFromParent_Done,
     /* 317044 */   // Label 5308: @317044
     /* 317044 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(317179), // Rule ID 12217 //
     /* 317049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 317052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 317056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317101 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317133 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 317136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 317143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 317148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 317153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 317158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317177 */     GIR_RootConstrainSelectedInstOperands,
     /* 317178 */     // GIR_Coverage, 12217,
     /* 317178 */     GIR_EraseRootFromParent_Done,
     /* 317179 */   // Label 5309: @317179
     /* 317179 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(317314), // Rule ID 12692 //
     /* 317184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 317187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 317191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317231 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317236 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317241 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317254 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317268 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 317271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 317278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 317283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 317288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 317293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317312 */     GIR_RootConstrainSelectedInstOperands,
     /* 317313 */     // GIR_Coverage, 12692,
     /* 317313 */     GIR_EraseRootFromParent_Done,
     /* 317314 */   // Label 5310: @317314
     /* 317314 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(317449), // Rule ID 12693 //
     /* 317319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 317322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 317326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317366 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317371 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317376 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317403 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 317406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 317413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 317418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 317423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 317428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317447 */     GIR_RootConstrainSelectedInstOperands,
     /* 317448 */     // GIR_Coverage, 12693,
     /* 317448 */     GIR_EraseRootFromParent_Done,
     /* 317449 */   // Label 5311: @317449
     /* 317449 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(317584), // Rule ID 12696 //
     /* 317454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 317457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 317461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317506 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317538 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 317541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 317548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 317553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 317558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 317563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317582 */     GIR_RootConstrainSelectedInstOperands,
     /* 317583 */     // GIR_Coverage, 12696,
     /* 317583 */     GIR_EraseRootFromParent_Done,
     /* 317584 */   // Label 5312: @317584
     /* 317584 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(317719), // Rule ID 12697 //
     /* 317589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 317592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 317596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317636 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317641 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317673 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 317676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 317683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 317688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 317693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 317698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317717 */     GIR_RootConstrainSelectedInstOperands,
     /* 317718 */     // GIR_Coverage, 12697,
     /* 317718 */     GIR_EraseRootFromParent_Done,
     /* 317719 */   // Label 5313: @317719
     /* 317719 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(317854), // Rule ID 13172 //
     /* 317724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 317727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 317731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317808 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 317811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 317818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 317823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 317828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 317833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317852 */     GIR_RootConstrainSelectedInstOperands,
     /* 317853 */     // GIR_Coverage, 13172,
     /* 317853 */     GIR_EraseRootFromParent_Done,
     /* 317854 */   // Label 5314: @317854
     /* 317854 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(317989), // Rule ID 13173 //
     /* 317859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 317862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 317866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 317890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317906 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317911 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317916 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317943 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 317946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 317953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 317958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 317963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 317968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317987 */     GIR_RootConstrainSelectedInstOperands,
     /* 317988 */     // GIR_Coverage, 13173,
     /* 317988 */     GIR_EraseRootFromParent_Done,
     /* 317989 */   // Label 5315: @317989
     /* 317989 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(318124), // Rule ID 13176 //
     /* 317994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 317997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318041 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318041 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318046 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318051 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318055 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318078 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 318081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 318088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 318093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 318098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 318103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318122 */     GIR_RootConstrainSelectedInstOperands,
     /* 318123 */     // GIR_Coverage, 13176,
     /* 318123 */     GIR_EraseRootFromParent_Done,
     /* 318124 */   // Label 5316: @318124
     /* 318124 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(318259), // Rule ID 13177 //
     /* 318129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 318132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318176 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318176 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318181 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318186 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318213 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 318216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 318223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 318228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 318233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 318238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318257 */     GIR_RootConstrainSelectedInstOperands,
     /* 318258 */     // GIR_Coverage, 13177,
     /* 318258 */     GIR_EraseRootFromParent_Done,
     /* 318259 */   // Label 5317: @318259
     /* 318259 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(318394), // Rule ID 7638 //
     /* 318264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 318267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 318311 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318316 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318348 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 318351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 318358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 318363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 318368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 318373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318392 */     GIR_RootConstrainSelectedInstOperands,
     /* 318393 */     // GIR_Coverage, 7638,
     /* 318393 */     GIR_EraseRootFromParent_Done,
     /* 318394 */   // Label 5318: @318394
     /* 318394 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(318529), // Rule ID 7670 //
     /* 318399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 318402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 318406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 318446 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318451 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318483 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 318486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 318493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 318498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 318503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 318508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318527 */     GIR_RootConstrainSelectedInstOperands,
     /* 318528 */     // GIR_Coverage, 7670,
     /* 318528 */     GIR_EraseRootFromParent_Done,
     /* 318529 */   // Label 5319: @318529
     /* 318529 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(318664), // Rule ID 7702 //
     /* 318534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 318537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 318581 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318586 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318618 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 318621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 318628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 318633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 318638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 318643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318662 */     GIR_RootConstrainSelectedInstOperands,
     /* 318663 */     // GIR_Coverage, 7702,
     /* 318663 */     GIR_EraseRootFromParent_Done,
     /* 318664 */   // Label 5320: @318664
     /* 318664 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(318799), // Rule ID 12226 //
     /* 318669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 318672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 318716 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318716 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318721 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318721 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318726 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318732 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318753 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 318756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 318763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 318768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 318773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 318778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318797 */     GIR_RootConstrainSelectedInstOperands,
     /* 318798 */     // GIR_Coverage, 12226,
     /* 318798 */     GIR_EraseRootFromParent_Done,
     /* 318799 */   // Label 5321: @318799
     /* 318799 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(318934), // Rule ID 12229 //
     /* 318804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 318807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 318851 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318861 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318888 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 318891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 318898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 318903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 318908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 318913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318932 */     GIR_RootConstrainSelectedInstOperands,
     /* 318933 */     // GIR_Coverage, 12229,
     /* 318933 */     GIR_EraseRootFromParent_Done,
     /* 318934 */   // Label 5322: @318934
     /* 318934 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(319069), // Rule ID 12230 //
     /* 318939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 318942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 318970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 318986 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318991 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318996 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319023 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 319026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 319033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319067 */     GIR_RootConstrainSelectedInstOperands,
     /* 319068 */     // GIR_Coverage, 12230,
     /* 319068 */     GIR_EraseRootFromParent_Done,
     /* 319069 */   // Label 5323: @319069
     /* 319069 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(319204), // Rule ID 12706 //
     /* 319074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 319077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 319081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319121 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319126 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319158 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 319161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 319168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 319173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 319178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 319183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319202 */     GIR_RootConstrainSelectedInstOperands,
     /* 319203 */     // GIR_Coverage, 12706,
     /* 319203 */     GIR_EraseRootFromParent_Done,
     /* 319204 */   // Label 5324: @319204
     /* 319204 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(319339), // Rule ID 12709 //
     /* 319209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 319212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 319216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319256 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319261 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319270 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319293 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 319296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 319303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319337 */     GIR_RootConstrainSelectedInstOperands,
     /* 319338 */     // GIR_Coverage, 12709,
     /* 319338 */     GIR_EraseRootFromParent_Done,
     /* 319339 */   // Label 5325: @319339
     /* 319339 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(319474), // Rule ID 12710 //
     /* 319344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 319347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 319351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319379 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319391 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319396 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319401 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319428 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 319431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 319438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319472 */     GIR_RootConstrainSelectedInstOperands,
     /* 319473 */     // GIR_Coverage, 12710,
     /* 319473 */     GIR_EraseRootFromParent_Done,
     /* 319474 */   // Label 5326: @319474
     /* 319474 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(319609), // Rule ID 13186 //
     /* 319479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 319482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319522 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319526 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319526 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319531 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319563 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 319566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 319573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 319578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 319583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 319588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319607 */     GIR_RootConstrainSelectedInstOperands,
     /* 319608 */     // GIR_Coverage, 13186,
     /* 319608 */     GIR_EraseRootFromParent_Done,
     /* 319609 */   // Label 5327: @319609
     /* 319609 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(319744), // Rule ID 13189 //
     /* 319614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 319617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319661 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319666 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319671 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319698 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 319701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 319708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319742 */     GIR_RootConstrainSelectedInstOperands,
     /* 319743 */     // GIR_Coverage, 13189,
     /* 319743 */     GIR_EraseRootFromParent_Done,
     /* 319744 */   // Label 5328: @319744
     /* 319744 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(319879), // Rule ID 13190 //
     /* 319749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 319752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319833 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 319836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 319843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319877 */     GIR_RootConstrainSelectedInstOperands,
     /* 319878 */     // GIR_Coverage, 13190,
     /* 319878 */     GIR_EraseRootFromParent_Done,
     /* 319879 */   // Label 5329: @319879
     /* 319879 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(320014), // Rule ID 7637 //
     /* 319884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 319887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 319931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319936 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319968 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 319971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 319978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 319983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 319988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 319993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320012 */     GIR_RootConstrainSelectedInstOperands,
     /* 320013 */     // GIR_Coverage, 7637,
     /* 320013 */     GIR_EraseRootFromParent_Done,
     /* 320014 */   // Label 5330: @320014
     /* 320014 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(320149), // Rule ID 7669 //
     /* 320019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 320022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 320026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 320066 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320071 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320076 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320103 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 320106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 320113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 320118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 320123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 320128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320147 */     GIR_RootConstrainSelectedInstOperands,
     /* 320148 */     // GIR_Coverage, 7669,
     /* 320148 */     GIR_EraseRootFromParent_Done,
     /* 320149 */   // Label 5331: @320149
     /* 320149 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(320284), // Rule ID 7701 //
     /* 320154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 320157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 320201 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320201 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320206 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320206 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320211 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320215 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320238 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 320241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 320248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 320253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 320258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 320263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320282 */     GIR_RootConstrainSelectedInstOperands,
     /* 320283 */     // GIR_Coverage, 7701,
     /* 320283 */     GIR_EraseRootFromParent_Done,
     /* 320284 */   // Label 5332: @320284
     /* 320284 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(320419), // Rule ID 12211 //
     /* 320289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 320292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 320336 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320346 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320373 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 320376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 320383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 320388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 320393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 320398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320417 */     GIR_RootConstrainSelectedInstOperands,
     /* 320418 */     // GIR_Coverage, 12211,
     /* 320418 */     GIR_EraseRootFromParent_Done,
     /* 320419 */   // Label 5333: @320419
     /* 320419 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(320554), // Rule ID 12214 //
     /* 320424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 320427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 320471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320485 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320508 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 320511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 320518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 320523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 320528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 320533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320552 */     GIR_RootConstrainSelectedInstOperands,
     /* 320553 */     // GIR_Coverage, 12214,
     /* 320553 */     GIR_EraseRootFromParent_Done,
     /* 320554 */   // Label 5334: @320554
     /* 320554 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(320689), // Rule ID 12215 //
     /* 320559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 320562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 320606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320643 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 320646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 320653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 320658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 320663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 320668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320687 */     GIR_RootConstrainSelectedInstOperands,
     /* 320688 */     // GIR_Coverage, 12215,
     /* 320688 */     GIR_EraseRootFromParent_Done,
     /* 320689 */   // Label 5335: @320689
     /* 320689 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(320824), // Rule ID 12691 //
     /* 320694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 320697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 320701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 320741 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320746 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320764 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320778 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 320781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 320788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 320793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 320798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 320803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320822 */     GIR_RootConstrainSelectedInstOperands,
     /* 320823 */     // GIR_Coverage, 12691,
     /* 320823 */     GIR_EraseRootFromParent_Done,
     /* 320824 */   // Label 5336: @320824
     /* 320824 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(320959), // Rule ID 12694 //
     /* 320829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 320832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 320836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 320872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 320876 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320881 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320886 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320899 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320913 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 320916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 320923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 320928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 320933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 320938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320957 */     GIR_RootConstrainSelectedInstOperands,
     /* 320958 */     // GIR_Coverage, 12694,
     /* 320958 */     GIR_EraseRootFromParent_Done,
     /* 320959 */   // Label 5337: @320959
     /* 320959 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(321094), // Rule ID 12695 //
     /* 320964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 320967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 320971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 321007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321011 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321016 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321021 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321041 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321048 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 321051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 321068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 321073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321092 */     GIR_RootConstrainSelectedInstOperands,
     /* 321093 */     // GIR_Coverage, 12695,
     /* 321093 */     GIR_EraseRootFromParent_Done,
     /* 321094 */   // Label 5338: @321094
     /* 321094 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(321229), // Rule ID 13171 //
     /* 321099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 321102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 321142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321146 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321183 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 321186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 321193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 321198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 321203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 321208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321227 */     GIR_RootConstrainSelectedInstOperands,
     /* 321228 */     // GIR_Coverage, 13171,
     /* 321228 */     GIR_EraseRootFromParent_Done,
     /* 321229 */   // Label 5339: @321229
     /* 321229 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(321364), // Rule ID 13174 //
     /* 321234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 321237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 321277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321291 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321318 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 321321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 321338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 321343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321362 */     GIR_RootConstrainSelectedInstOperands,
     /* 321363 */     // GIR_Coverage, 13174,
     /* 321363 */     GIR_EraseRootFromParent_Done,
     /* 321364 */   // Label 5340: @321364
     /* 321364 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(321499), // Rule ID 13175 //
     /* 321369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 321372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 321412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321430 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321453 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 321456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 321473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 321478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321497 */     GIR_RootConstrainSelectedInstOperands,
     /* 321498 */     // GIR_Coverage, 13175,
     /* 321498 */     GIR_EraseRootFromParent_Done,
     /* 321499 */   // Label 5341: @321499
     /* 321499 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(321634), // Rule ID 12267 //
     /* 321504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 321507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 321535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 321547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321551 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 321556 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 321561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321565 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321588 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 321591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 321608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 321613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 321618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 321623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321632 */     GIR_RootConstrainSelectedInstOperands,
     /* 321633 */     // GIR_Coverage, 12267,
     /* 321633 */     GIR_EraseRootFromParent_Done,
     /* 321634 */   // Label 5342: @321634
     /* 321634 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(321769), // Rule ID 12268 //
     /* 321639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 321642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 321670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321674 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 321682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321686 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321686 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 321691 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321691 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 321696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321723 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 321726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 321743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 321748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 321753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 321758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321767 */     GIR_RootConstrainSelectedInstOperands,
     /* 321768 */     // GIR_Coverage, 12268,
     /* 321768 */     GIR_EraseRootFromParent_Done,
     /* 321769 */   // Label 5343: @321769
     /* 321769 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(321904), // Rule ID 12269 //
     /* 321774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 321777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 321805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321809 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 321817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321821 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 321826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 321831 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321858 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 321861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 321868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 321873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 321878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 321883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 321888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 321893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321902 */     GIR_RootConstrainSelectedInstOperands,
     /* 321903 */     // GIR_Coverage, 12269,
     /* 321903 */     GIR_EraseRootFromParent_Done,
     /* 321904 */   // Label 5344: @321904
     /* 321904 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(322039), // Rule ID 12270 //
     /* 321909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 321912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 321940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 321952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321956 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 321961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 321966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321993 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 321996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 322003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 322008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 322013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 322018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322037 */     GIR_RootConstrainSelectedInstOperands,
     /* 322038 */     // GIR_Coverage, 12270,
     /* 322038 */     GIR_EraseRootFromParent_Done,
     /* 322039 */   // Label 5345: @322039
     /* 322039 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(322174), // Rule ID 12747 //
     /* 322044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 322047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 322051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322091 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322128 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 322131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 322138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 322143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 322148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 322153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322172 */     GIR_RootConstrainSelectedInstOperands,
     /* 322173 */     // GIR_Coverage, 12747,
     /* 322173 */     GIR_EraseRootFromParent_Done,
     /* 322174 */   // Label 5346: @322174
     /* 322174 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(322309), // Rule ID 12748 //
     /* 322179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 322182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 322186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322231 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322236 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322263 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 322266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 322273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 322278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 322283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 322288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322307 */     GIR_RootConstrainSelectedInstOperands,
     /* 322308 */     // GIR_Coverage, 12748,
     /* 322308 */     GIR_EraseRootFromParent_Done,
     /* 322309 */   // Label 5347: @322309
     /* 322309 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(322444), // Rule ID 12749 //
     /* 322314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 322317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 322321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322361 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322366 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322371 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322398 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 322401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 322408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 322413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 322418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 322423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322442 */     GIR_RootConstrainSelectedInstOperands,
     /* 322443 */     // GIR_Coverage, 12749,
     /* 322443 */     GIR_EraseRootFromParent_Done,
     /* 322444 */   // Label 5348: @322444
     /* 322444 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(322579), // Rule ID 12750 //
     /* 322449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 322452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 322456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322496 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322496 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322506 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322533 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 322536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 322543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 322548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 322553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 322558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322577 */     GIR_RootConstrainSelectedInstOperands,
     /* 322578 */     // GIR_Coverage, 12750,
     /* 322578 */     GIR_EraseRootFromParent_Done,
     /* 322579 */   // Label 5349: @322579
     /* 322579 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(322714), // Rule ID 13227 //
     /* 322584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 322587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 322591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322631 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322636 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322668 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 322671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 322678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 322683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 322688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 322693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322712 */     GIR_RootConstrainSelectedInstOperands,
     /* 322713 */     // GIR_Coverage, 13227,
     /* 322713 */     GIR_EraseRootFromParent_Done,
     /* 322714 */   // Label 5350: @322714
     /* 322714 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(322849), // Rule ID 13228 //
     /* 322719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 322722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 322726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322766 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322803 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 322806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 322813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 322818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 322823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 322828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322847 */     GIR_RootConstrainSelectedInstOperands,
     /* 322848 */     // GIR_Coverage, 13228,
     /* 322848 */     GIR_EraseRootFromParent_Done,
     /* 322849 */   // Label 5351: @322849
     /* 322849 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(322984), // Rule ID 13229 //
     /* 322854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 322857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 322861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322901 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 322906 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 322911 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322938 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 322941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 322948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 322953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 322958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 322963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 322968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 322973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322982 */     GIR_RootConstrainSelectedInstOperands,
     /* 322983 */     // GIR_Coverage, 13229,
     /* 322983 */     GIR_EraseRootFromParent_Done,
     /* 322984 */   // Label 5352: @322984
     /* 322984 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(323119), // Rule ID 13230 //
     /* 322989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 322992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 322996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323036 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323041 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323041 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323046 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323066 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323073 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 323076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 323083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 323088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 323093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 323098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323117 */     GIR_RootConstrainSelectedInstOperands,
     /* 323118 */     // GIR_Coverage, 13230,
     /* 323118 */     GIR_EraseRootFromParent_Done,
     /* 323119 */   // Label 5353: @323119
     /* 323119 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(323254), // Rule ID 12207 //
     /* 323124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 323127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323159 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323171 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323171 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323176 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323176 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323181 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323185 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323201 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323208 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 323211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 323218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 323223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 323228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 323233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323252 */     GIR_RootConstrainSelectedInstOperands,
     /* 323253 */     // GIR_Coverage, 12207,
     /* 323253 */     GIR_EraseRootFromParent_Done,
     /* 323254 */   // Label 5354: @323254
     /* 323254 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(323389), // Rule ID 12208 //
     /* 323259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 323262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323306 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323311 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323343 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 323346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 323353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 323358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 323363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 323368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323387 */     GIR_RootConstrainSelectedInstOperands,
     /* 323388 */     // GIR_Coverage, 12208,
     /* 323388 */     GIR_EraseRootFromParent_Done,
     /* 323389 */   // Label 5355: @323389
     /* 323389 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(323524), // Rule ID 12209 //
     /* 323394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 323397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323441 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323446 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323451 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323478 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 323481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 323488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 323493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 323498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 323503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323522 */     GIR_RootConstrainSelectedInstOperands,
     /* 323523 */     // GIR_Coverage, 12209,
     /* 323523 */     GIR_EraseRootFromParent_Done,
     /* 323524 */   // Label 5356: @323524
     /* 323524 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(323659), // Rule ID 12210 //
     /* 323529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 323532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323581 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323586 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323590 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323613 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 323616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 323623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 323628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 323633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 323638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323657 */     GIR_RootConstrainSelectedInstOperands,
     /* 323658 */     // GIR_Coverage, 12210,
     /* 323658 */     GIR_EraseRootFromParent_Done,
     /* 323659 */   // Label 5357: @323659
     /* 323659 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(323794), // Rule ID 12687 //
     /* 323664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 323667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 323671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323711 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323716 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323716 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323721 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323741 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323748 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 323751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 323758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 323763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 323768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 323773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323792 */     GIR_RootConstrainSelectedInstOperands,
     /* 323793 */     // GIR_Coverage, 12687,
     /* 323793 */     GIR_EraseRootFromParent_Done,
     /* 323794 */   // Label 5358: @323794
     /* 323794 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(323929), // Rule ID 12688 //
     /* 323799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 323802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 323806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323846 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323851 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323856 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323860 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323883 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 323886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 323893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 323898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 323903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 323908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 323913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 323918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323927 */     GIR_RootConstrainSelectedInstOperands,
     /* 323928 */     // GIR_Coverage, 12688,
     /* 323928 */     GIR_EraseRootFromParent_Done,
     /* 323929 */   // Label 5359: @323929
     /* 323929 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(324064), // Rule ID 12689 //
     /* 323934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 323937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 323941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323981 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323981 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 323986 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 323991 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324011 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324018 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 324021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 324028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 324033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 324038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 324043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324062 */     GIR_RootConstrainSelectedInstOperands,
     /* 324063 */     // GIR_Coverage, 12689,
     /* 324063 */     GIR_EraseRootFromParent_Done,
     /* 324064 */   // Label 5360: @324064
     /* 324064 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(324199), // Rule ID 12690 //
     /* 324069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 324072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 324076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324116 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324121 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324126 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324153 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 324156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 324163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 324168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 324173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 324178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324197 */     GIR_RootConstrainSelectedInstOperands,
     /* 324198 */     // GIR_Coverage, 12690,
     /* 324198 */     GIR_EraseRootFromParent_Done,
     /* 324199 */   // Label 5361: @324199
     /* 324199 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(324334), // Rule ID 13167 //
     /* 324204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 324207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324251 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324256 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324288 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 324291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 324298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 324303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 324308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 324313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324332 */     GIR_RootConstrainSelectedInstOperands,
     /* 324333 */     // GIR_Coverage, 13167,
     /* 324333 */     GIR_EraseRootFromParent_Done,
     /* 324334 */   // Label 5362: @324334
     /* 324334 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(324469), // Rule ID 13168 //
     /* 324339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 324342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324386 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324391 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324423 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 324426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 324433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 324438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 324443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 324448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324467 */     GIR_RootConstrainSelectedInstOperands,
     /* 324468 */     // GIR_Coverage, 13168,
     /* 324468 */     GIR_EraseRootFromParent_Done,
     /* 324469 */   // Label 5363: @324469
     /* 324469 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(324604), // Rule ID 13169 //
     /* 324474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 324477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324521 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324526 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324526 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324531 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324551 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324558 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 324561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 324568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 324573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 324578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 324583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324602 */     GIR_RootConstrainSelectedInstOperands,
     /* 324603 */     // GIR_Coverage, 13169,
     /* 324603 */     GIR_EraseRootFromParent_Done,
     /* 324604 */   // Label 5364: @324604
     /* 324604 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(324739), // Rule ID 13170 //
     /* 324609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 324612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324656 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324656 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324661 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324666 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324670 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324672 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324679 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324686 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324693 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 324696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 324703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 324708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 324713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 324718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324737 */     GIR_RootConstrainSelectedInstOperands,
     /* 324738 */     // GIR_Coverage, 13170,
     /* 324738 */     GIR_EraseRootFromParent_Done,
     /* 324739 */   // Label 5365: @324739
     /* 324739 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(324874), // Rule ID 12252 //
     /* 324744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 324747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 324775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324791 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324828 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 324831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 324838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 324843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 324848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 324853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324872 */     GIR_RootConstrainSelectedInstOperands,
     /* 324873 */     // GIR_Coverage, 12252,
     /* 324873 */     GIR_EraseRootFromParent_Done,
     /* 324874 */   // Label 5366: @324874
     /* 324874 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(325009), // Rule ID 12253 //
     /* 324879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 324882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 324910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 324931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 324936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324963 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 324966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 324973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 324978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 324983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 324988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 324993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 324998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325007 */     GIR_RootConstrainSelectedInstOperands,
     /* 325008 */     // GIR_Coverage, 12253,
     /* 325008 */     GIR_EraseRootFromParent_Done,
     /* 325009 */   // Label 5367: @325009
     /* 325009 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(325144), // Rule ID 12254 //
     /* 325014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 325017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 325021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325066 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325071 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325098 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 325101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 325108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 325113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 325118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 325123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325142 */     GIR_RootConstrainSelectedInstOperands,
     /* 325143 */     // GIR_Coverage, 12254,
     /* 325143 */     GIR_EraseRootFromParent_Done,
     /* 325144 */   // Label 5368: @325144
     /* 325144 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(325279), // Rule ID 12255 //
     /* 325149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 325152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 325156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325196 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325201 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325201 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325206 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325233 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 325236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 325243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 325248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 325253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 325258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325277 */     GIR_RootConstrainSelectedInstOperands,
     /* 325278 */     // GIR_Coverage, 12255,
     /* 325278 */     GIR_EraseRootFromParent_Done,
     /* 325279 */   // Label 5369: @325279
     /* 325279 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(325414), // Rule ID 12732 //
     /* 325284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 325287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 325291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325331 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325331 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325336 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325354 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325361 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325368 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 325371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 325378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 325383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 325388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 325393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325412 */     GIR_RootConstrainSelectedInstOperands,
     /* 325413 */     // GIR_Coverage, 12732,
     /* 325413 */     GIR_EraseRootFromParent_Done,
     /* 325414 */   // Label 5370: @325414
     /* 325414 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(325549), // Rule ID 12733 //
     /* 325419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 325422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 325426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325454 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325466 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325480 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325489 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325503 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 325506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 325513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 325518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 325523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 325528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325547 */     GIR_RootConstrainSelectedInstOperands,
     /* 325548 */     // GIR_Coverage, 12733,
     /* 325548 */     GIR_EraseRootFromParent_Done,
     /* 325549 */   // Label 5371: @325549
     /* 325549 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(325684), // Rule ID 12734 //
     /* 325554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 325557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 325561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325601 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325611 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325624 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325638 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 325641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 325648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 325653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 325658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 325663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325682 */     GIR_RootConstrainSelectedInstOperands,
     /* 325683 */     // GIR_Coverage, 12734,
     /* 325683 */     GIR_EraseRootFromParent_Done,
     /* 325684 */   // Label 5372: @325684
     /* 325684 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(325819), // Rule ID 12735 //
     /* 325689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 325692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 325696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325736 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325741 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325746 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325766 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325773 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 325776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 325783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 325788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 325793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 325798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325817 */     GIR_RootConstrainSelectedInstOperands,
     /* 325818 */     // GIR_Coverage, 12735,
     /* 325818 */     GIR_EraseRootFromParent_Done,
     /* 325819 */   // Label 5373: @325819
     /* 325819 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(325954), // Rule ID 13212 //
     /* 325824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 325827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 325831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325876 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325881 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325908 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 325911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 325918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 325923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 325928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 325933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 325938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 325943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325952 */     GIR_RootConstrainSelectedInstOperands,
     /* 325953 */     // GIR_Coverage, 13212,
     /* 325953 */     GIR_EraseRootFromParent_Done,
     /* 325954 */   // Label 5374: @325954
     /* 325954 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(326089), // Rule ID 13213 //
     /* 325959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 325962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 325966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326006 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326011 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326016 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326020 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326036 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326043 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 326046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 326053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 326058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 326063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 326068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326087 */     GIR_RootConstrainSelectedInstOperands,
     /* 326088 */     // GIR_Coverage, 13213,
     /* 326088 */     GIR_EraseRootFromParent_Done,
     /* 326089 */   // Label 5375: @326089
     /* 326089 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(326224), // Rule ID 13214 //
     /* 326094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 326097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326141 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326141 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326146 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326151 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326164 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326171 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326178 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 326181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 326188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 326193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 326198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 326203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326222 */     GIR_RootConstrainSelectedInstOperands,
     /* 326223 */     // GIR_Coverage, 13214,
     /* 326223 */     GIR_EraseRootFromParent_Done,
     /* 326224 */   // Label 5376: @326224
     /* 326224 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(326359), // Rule ID 13215 //
     /* 326229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 326232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326276 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326286 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326299 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326306 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326313 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 326316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 326323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 326328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 326333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 326338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326357 */     GIR_RootConstrainSelectedInstOperands,
     /* 326358 */     // GIR_Coverage, 13215,
     /* 326358 */     GIR_EraseRootFromParent_Done,
     /* 326359 */   // Label 5377: @326359
     /* 326359 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(326494), // Rule ID 12192 //
     /* 326364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 326367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 326411 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326448 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 326451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 326458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 326463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 326468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 326473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326492 */     GIR_RootConstrainSelectedInstOperands,
     /* 326493 */     // GIR_Coverage, 12192,
     /* 326493 */     GIR_EraseRootFromParent_Done,
     /* 326494 */   // Label 5378: @326494
     /* 326494 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(326629), // Rule ID 12193 //
     /* 326499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 326502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 326546 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326551 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326556 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326569 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326576 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326583 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 326586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 326593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 326598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 326603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 326608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326627 */     GIR_RootConstrainSelectedInstOperands,
     /* 326628 */     // GIR_Coverage, 12193,
     /* 326628 */     GIR_EraseRootFromParent_Done,
     /* 326629 */   // Label 5379: @326629
     /* 326629 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(326764), // Rule ID 12194 //
     /* 326634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 326637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326677 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 326681 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326686 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326686 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326691 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326711 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326718 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 326721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 326728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 326733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 326738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 326743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326762 */     GIR_RootConstrainSelectedInstOperands,
     /* 326763 */     // GIR_Coverage, 12194,
     /* 326763 */     GIR_EraseRootFromParent_Done,
     /* 326764 */   // Label 5380: @326764
     /* 326764 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(326899), // Rule ID 12195 //
     /* 326769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 326772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 326816 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326816 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326821 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326826 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326853 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 326856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 326863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 326868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 326873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 326878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326897 */     GIR_RootConstrainSelectedInstOperands,
     /* 326898 */     // GIR_Coverage, 12195,
     /* 326898 */     GIR_EraseRootFromParent_Done,
     /* 326899 */   // Label 5381: @326899
     /* 326899 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(327034), // Rule ID 12672 //
     /* 326904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 326907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 326911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 326935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 326951 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326956 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326961 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326974 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326988 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 326991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 326998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 327003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 327008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 327013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327032 */     GIR_RootConstrainSelectedInstOperands,
     /* 327033 */     // GIR_Coverage, 12672,
     /* 327033 */     GIR_EraseRootFromParent_Done,
     /* 327034 */   // Label 5382: @327034
     /* 327034 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(327169), // Rule ID 12673 //
     /* 327039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 327042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 327046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327086 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327091 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327096 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327123 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 327126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 327133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 327138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 327143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 327148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327167 */     GIR_RootConstrainSelectedInstOperands,
     /* 327168 */     // GIR_Coverage, 12673,
     /* 327168 */     GIR_EraseRootFromParent_Done,
     /* 327169 */   // Label 5383: @327169
     /* 327169 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(327304), // Rule ID 12674 //
     /* 327174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 327177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 327181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327258 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 327261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 327268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 327273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 327278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 327283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327302 */     GIR_RootConstrainSelectedInstOperands,
     /* 327303 */     // GIR_Coverage, 12674,
     /* 327303 */     GIR_EraseRootFromParent_Done,
     /* 327304 */   // Label 5384: @327304
     /* 327304 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(327439), // Rule ID 12675 //
     /* 327309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 327312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 327316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327361 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327366 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327393 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 327396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 327403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 327408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 327413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 327418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327437 */     GIR_RootConstrainSelectedInstOperands,
     /* 327438 */     // GIR_Coverage, 12675,
     /* 327438 */     GIR_EraseRootFromParent_Done,
     /* 327439 */   // Label 5385: @327439
     /* 327439 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(327574), // Rule ID 13152 //
     /* 327444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 327447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327491 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327496 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327496 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327501 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327505 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327521 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327528 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 327531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 327538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 327543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 327548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 327553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327572 */     GIR_RootConstrainSelectedInstOperands,
     /* 327573 */     // GIR_Coverage, 13152,
     /* 327573 */     GIR_EraseRootFromParent_Done,
     /* 327574 */   // Label 5386: @327574
     /* 327574 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(327709), // Rule ID 13153 //
     /* 327579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 327582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327626 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327626 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327631 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327649 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327656 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327663 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 327666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 327673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 327678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 327683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 327688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327707 */     GIR_RootConstrainSelectedInstOperands,
     /* 327708 */     // GIR_Coverage, 13153,
     /* 327708 */     GIR_EraseRootFromParent_Done,
     /* 327709 */   // Label 5387: @327709
     /* 327709 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(327844), // Rule ID 13154 //
     /* 327714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 327717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327766 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327771 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327798 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 327801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 327808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 327813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 327818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 327823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327842 */     GIR_RootConstrainSelectedInstOperands,
     /* 327843 */     // GIR_Coverage, 13154,
     /* 327843 */     GIR_EraseRootFromParent_Done,
     /* 327844 */   // Label 5388: @327844
     /* 327844 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(327979), // Rule ID 13155 //
     /* 327849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 327852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 327880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327896 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327901 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327910 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327919 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327926 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327933 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 327936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 327943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 327948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 327953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 327958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327977 */     GIR_RootConstrainSelectedInstOperands,
     /* 327978 */     // GIR_Coverage, 13155,
     /* 327978 */     GIR_EraseRootFromParent_Done,
     /* 327979 */   // Label 5389: @327979
     /* 327979 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(328114), // Rule ID 12263 //
     /* 327984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 327987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328031 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328036 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328061 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328068 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 328071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 328078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 328083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 328088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 328093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 328098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 328103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328112 */     GIR_RootConstrainSelectedInstOperands,
     /* 328113 */     // GIR_Coverage, 12263,
     /* 328113 */     GIR_EraseRootFromParent_Done,
     /* 328114 */   // Label 5390: @328114
     /* 328114 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(328249), // Rule ID 12264 //
     /* 328119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 328122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 328126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328166 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328171 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328171 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328176 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328189 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328196 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328203 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 328206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 328213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 328218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 328223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 328228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 328233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 328238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328247 */     GIR_RootConstrainSelectedInstOperands,
     /* 328248 */     // GIR_Coverage, 12264,
     /* 328248 */     GIR_EraseRootFromParent_Done,
     /* 328249 */   // Label 5391: @328249
     /* 328249 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(328384), // Rule ID 12265 //
     /* 328254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 328257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 328261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328301 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328306 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328311 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328331 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328338 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 328341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 328348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 328353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 328358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 328363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 328368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 328373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328382 */     GIR_RootConstrainSelectedInstOperands,
     /* 328383 */     // GIR_Coverage, 12265,
     /* 328383 */     GIR_EraseRootFromParent_Done,
     /* 328384 */   // Label 5392: @328384
     /* 328384 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(328519), // Rule ID 12266 //
     /* 328389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 328392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 328396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328436 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328441 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328473 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 328476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 328483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 328488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 328493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 328498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 328503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 328508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328517 */     GIR_RootConstrainSelectedInstOperands,
     /* 328518 */     // GIR_Coverage, 12266,
     /* 328518 */     GIR_EraseRootFromParent_Done,
     /* 328519 */   // Label 5393: @328519
     /* 328519 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(328654), // Rule ID 12743 //
     /* 328524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 328527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 328531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328571 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328601 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328608 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 328611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 328618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 328623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 328628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 328633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 328638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 328643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328652 */     GIR_RootConstrainSelectedInstOperands,
     /* 328653 */     // GIR_Coverage, 12743,
     /* 328653 */     GIR_EraseRootFromParent_Done,
     /* 328654 */   // Label 5394: @328654
     /* 328654 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(328789), // Rule ID 12744 //
     /* 328659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 328662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 328666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328706 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328711 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328736 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328743 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 328746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 328753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 328758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 328763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 328768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 328773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 328778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328787 */     GIR_RootConstrainSelectedInstOperands,
     /* 328788 */     // GIR_Coverage, 12744,
     /* 328788 */     GIR_EraseRootFromParent_Done,
     /* 328789 */   // Label 5395: @328789
     /* 328789 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(328924), // Rule ID 12745 //
     /* 328794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 328797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 328801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328841 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328846 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328871 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328878 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 328881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 328888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 328893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 328898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 328903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 328908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 328913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328922 */     GIR_RootConstrainSelectedInstOperands,
     /* 328923 */     // GIR_Coverage, 12745,
     /* 328923 */     GIR_EraseRootFromParent_Done,
     /* 328924 */   // Label 5396: @328924
     /* 328924 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(329059), // Rule ID 12746 //
     /* 328929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 328932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 328936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328976 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328976 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328981 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328981 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328986 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329006 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329013 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 329016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 329023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 329028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 329033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 329038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329057 */     GIR_RootConstrainSelectedInstOperands,
     /* 329058 */     // GIR_Coverage, 12746,
     /* 329058 */     GIR_EraseRootFromParent_Done,
     /* 329059 */   // Label 5397: @329059
     /* 329059 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(329194), // Rule ID 13223 //
     /* 329064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 329067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329111 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329111 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329116 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329134 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329141 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329148 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 329151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 329158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 329163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 329168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 329173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329192 */     GIR_RootConstrainSelectedInstOperands,
     /* 329193 */     // GIR_Coverage, 13223,
     /* 329193 */     GIR_EraseRootFromParent_Done,
     /* 329194 */   // Label 5398: @329194
     /* 329194 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(329329), // Rule ID 13224 //
     /* 329199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 329202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329246 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329251 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329256 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329269 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329283 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 329286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 329293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 329298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 329303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 329308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329327 */     GIR_RootConstrainSelectedInstOperands,
     /* 329328 */     // GIR_Coverage, 13224,
     /* 329328 */     GIR_EraseRootFromParent_Done,
     /* 329329 */   // Label 5399: @329329
     /* 329329 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(329464), // Rule ID 13225 //
     /* 329334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 329337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329381 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329386 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329411 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329418 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 329421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 329428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 329433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 329438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 329443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329462 */     GIR_RootConstrainSelectedInstOperands,
     /* 329463 */     // GIR_Coverage, 13225,
     /* 329463 */     GIR_EraseRootFromParent_Done,
     /* 329464 */   // Label 5400: @329464
     /* 329464 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(329599), // Rule ID 13226 //
     /* 329469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 329472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329516 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329521 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329553 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 329556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 329563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 329568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 329573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 329578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329597 */     GIR_RootConstrainSelectedInstOperands,
     /* 329598 */     // GIR_Coverage, 13226,
     /* 329598 */     GIR_EraseRootFromParent_Done,
     /* 329599 */   // Label 5401: @329599
     /* 329599 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(329734), // Rule ID 12203 //
     /* 329604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 329607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 329651 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329656 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329656 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329661 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329688 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 329691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 329698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 329703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 329708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 329713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329732 */     GIR_RootConstrainSelectedInstOperands,
     /* 329733 */     // GIR_Coverage, 12203,
     /* 329733 */     GIR_EraseRootFromParent_Done,
     /* 329734 */   // Label 5402: @329734
     /* 329734 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(329869), // Rule ID 12204 //
     /* 329739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 329742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 329786 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329786 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329791 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329796 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329800 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329816 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329823 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 329826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 329833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 329838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 329843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 329848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329867 */     GIR_RootConstrainSelectedInstOperands,
     /* 329868 */     // GIR_Coverage, 12204,
     /* 329868 */     GIR_EraseRootFromParent_Done,
     /* 329869 */   // Label 5403: @329869
     /* 329869 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(330004), // Rule ID 12205 //
     /* 329874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 329877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 329921 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329931 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329951 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329958 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 329961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 329968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 329973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 329978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 329983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 329988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 329993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330002 */     GIR_RootConstrainSelectedInstOperands,
     /* 330003 */     // GIR_Coverage, 12205,
     /* 330003 */     GIR_EraseRootFromParent_Done,
     /* 330004 */   // Label 5404: @330004
     /* 330004 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(330139), // Rule ID 12206 //
     /* 330009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 330012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330056 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330093 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 330096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 330103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 330108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 330113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 330118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330137 */     GIR_RootConstrainSelectedInstOperands,
     /* 330138 */     // GIR_Coverage, 12206,
     /* 330138 */     GIR_EraseRootFromParent_Done,
     /* 330139 */   // Label 5405: @330139
     /* 330139 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(330274), // Rule ID 12683 //
     /* 330144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 330147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 330151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330191 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330196 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330221 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330228 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 330231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 330238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 330243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 330248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 330253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330272 */     GIR_RootConstrainSelectedInstOperands,
     /* 330273 */     // GIR_Coverage, 12683,
     /* 330273 */     GIR_EraseRootFromParent_Done,
     /* 330274 */   // Label 5406: @330274
     /* 330274 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(330409), // Rule ID 12684 //
     /* 330279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 330282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 330286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330326 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330331 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330331 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330336 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330340 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330356 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330363 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 330366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 330373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 330378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 330383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 330388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330407 */     GIR_RootConstrainSelectedInstOperands,
     /* 330408 */     // GIR_Coverage, 12684,
     /* 330408 */     GIR_EraseRootFromParent_Done,
     /* 330409 */   // Label 5407: @330409
     /* 330409 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(330544), // Rule ID 12685 //
     /* 330414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 330417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 330421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330461 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330461 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330466 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330471 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330484 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330491 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330498 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 330501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 330508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 330513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 330518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 330523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330542 */     GIR_RootConstrainSelectedInstOperands,
     /* 330543 */     // GIR_Coverage, 12685,
     /* 330543 */     GIR_EraseRootFromParent_Done,
     /* 330544 */   // Label 5408: @330544
     /* 330544 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(330679), // Rule ID 12686 //
     /* 330549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 330552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 330556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330596 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330601 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330606 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330619 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330633 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 330636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 330643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 330648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 330653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 330658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330677 */     GIR_RootConstrainSelectedInstOperands,
     /* 330678 */     // GIR_Coverage, 12686,
     /* 330678 */     GIR_EraseRootFromParent_Done,
     /* 330679 */   // Label 5409: @330679
     /* 330679 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(330814), // Rule ID 13163 //
     /* 330684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 330687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330731 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330736 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330768 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 330771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 330778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 330783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 330788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 330793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330812 */     GIR_RootConstrainSelectedInstOperands,
     /* 330813 */     // GIR_Coverage, 13163,
     /* 330813 */     GIR_EraseRootFromParent_Done,
     /* 330814 */   // Label 5410: @330814
     /* 330814 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(330949), // Rule ID 13164 //
     /* 330819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 330822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330896 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330903 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 330906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 330913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 330918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 330923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 330928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 330933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 330938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330947 */     GIR_RootConstrainSelectedInstOperands,
     /* 330948 */     // GIR_Coverage, 13164,
     /* 330948 */     GIR_EraseRootFromParent_Done,
     /* 330949 */   // Label 5411: @330949
     /* 330949 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(331084), // Rule ID 13165 //
     /* 330954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 330957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 330981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 330985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 331001 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331006 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331011 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331031 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331038 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 331041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 331048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 331053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 331058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 331063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331082 */     GIR_RootConstrainSelectedInstOperands,
     /* 331083 */     // GIR_Coverage, 13165,
     /* 331083 */     GIR_EraseRootFromParent_Done,
     /* 331084 */   // Label 5412: @331084
     /* 331084 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(331219), // Rule ID 13166 //
     /* 331089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 331092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 331120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 331136 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331141 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331141 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331159 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331166 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331173 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 331176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 331183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 331188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 331193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 331198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331217 */     GIR_RootConstrainSelectedInstOperands,
     /* 331218 */     // GIR_Coverage, 13166,
     /* 331218 */     GIR_EraseRootFromParent_Done,
     /* 331219 */   // Label 5413: @331219
     /* 331219 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(331354), // Rule ID 12248 //
     /* 331224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 331227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331271 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331276 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331285 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331294 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331308 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 331311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 331318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 331323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 331328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 331333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331352 */     GIR_RootConstrainSelectedInstOperands,
     /* 331353 */     // GIR_Coverage, 12248,
     /* 331353 */     GIR_EraseRootFromParent_Done,
     /* 331354 */   // Label 5414: @331354
     /* 331354 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(331489), // Rule ID 12249 //
     /* 331359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 331362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331411 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331416 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331429 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331443 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 331446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 331453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 331458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 331463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 331468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331487 */     GIR_RootConstrainSelectedInstOperands,
     /* 331488 */     // GIR_Coverage, 12249,
     /* 331488 */     GIR_EraseRootFromParent_Done,
     /* 331489 */   // Label 5415: @331489
     /* 331489 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(331624), // Rule ID 12250 //
     /* 331494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 331497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331541 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331546 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331578 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 331581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 331588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 331593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 331598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 331603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331622 */     GIR_RootConstrainSelectedInstOperands,
     /* 331623 */     // GIR_Coverage, 12250,
     /* 331623 */     GIR_EraseRootFromParent_Done,
     /* 331624 */   // Label 5416: @331624
     /* 331624 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(331759), // Rule ID 12251 //
     /* 331629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 331632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331676 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331681 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331686 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331706 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331713 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 331716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 331723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 331728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 331733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 331738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331757 */     GIR_RootConstrainSelectedInstOperands,
     /* 331758 */     // GIR_Coverage, 12251,
     /* 331758 */     GIR_EraseRootFromParent_Done,
     /* 331759 */   // Label 5417: @331759
     /* 331759 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(331894), // Rule ID 12728 //
     /* 331764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 331767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 331771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331811 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331816 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331816 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331834 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331841 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331848 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 331851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 331858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 331863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 331868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 331873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 331878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 331883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331892 */     GIR_RootConstrainSelectedInstOperands,
     /* 331893 */     // GIR_Coverage, 12728,
     /* 331893 */     GIR_EraseRootFromParent_Done,
     /* 331894 */   // Label 5418: @331894
     /* 331894 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(332029), // Rule ID 12729 //
     /* 331899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 331902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 331906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331946 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331951 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331969 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331983 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 331986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 331993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 331998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 332003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 332008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332027 */     GIR_RootConstrainSelectedInstOperands,
     /* 332028 */     // GIR_Coverage, 12729,
     /* 332028 */     GIR_EraseRootFromParent_Done,
     /* 332029 */   // Label 5419: @332029
     /* 332029 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(332164), // Rule ID 12730 //
     /* 332034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 332037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 332041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332081 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332086 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332111 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332118 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 332121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 332128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 332133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 332138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 332143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332162 */     GIR_RootConstrainSelectedInstOperands,
     /* 332163 */     // GIR_Coverage, 12730,
     /* 332163 */     GIR_EraseRootFromParent_Done,
     /* 332164 */   // Label 5420: @332164
     /* 332164 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(332299), // Rule ID 12731 //
     /* 332169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 332172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 332176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332216 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332246 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332253 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 332256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 332263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 332268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 332273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 332278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332297 */     GIR_RootConstrainSelectedInstOperands,
     /* 332298 */     // GIR_Coverage, 12731,
     /* 332298 */     GIR_EraseRootFromParent_Done,
     /* 332299 */   // Label 5421: @332299
     /* 332299 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(332434), // Rule ID 13208 //
     /* 332304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 332307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332374 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332381 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332388 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 332391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 332398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 332403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 332408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 332413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332432 */     GIR_RootConstrainSelectedInstOperands,
     /* 332433 */     // GIR_Coverage, 13208,
     /* 332433 */     GIR_EraseRootFromParent_Done,
     /* 332434 */   // Label 5422: @332434
     /* 332434 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(332569), // Rule ID 13209 //
     /* 332439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 332442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332491 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332516 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332523 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 332526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 332533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 332538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 332543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 332548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332567 */     GIR_RootConstrainSelectedInstOperands,
     /* 332568 */     // GIR_Coverage, 13209,
     /* 332568 */     GIR_EraseRootFromParent_Done,
     /* 332569 */   // Label 5423: @332569
     /* 332569 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(332704), // Rule ID 13210 //
     /* 332574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 332577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332621 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332621 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332626 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332626 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332631 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332658 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 332661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 332668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 332673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 332678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 332683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332702 */     GIR_RootConstrainSelectedInstOperands,
     /* 332703 */     // GIR_Coverage, 13210,
     /* 332703 */     GIR_EraseRootFromParent_Done,
     /* 332704 */   // Label 5424: @332704
     /* 332704 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(332839), // Rule ID 13211 //
     /* 332709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 332712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332756 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332766 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332779 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332793 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 332796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 332803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 332808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 332813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 332818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332837 */     GIR_RootConstrainSelectedInstOperands,
     /* 332838 */     // GIR_Coverage, 13211,
     /* 332838 */     GIR_EraseRootFromParent_Done,
     /* 332839 */   // Label 5425: @332839
     /* 332839 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(332974), // Rule ID 12188 //
     /* 332844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 332847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 332891 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332896 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332928 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 332931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 332938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 332943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 332948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 332953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332972 */     GIR_RootConstrainSelectedInstOperands,
     /* 332973 */     // GIR_Coverage, 12188,
     /* 332973 */     GIR_EraseRootFromParent_Done,
     /* 332974 */   // Label 5426: @332974
     /* 332974 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(333109), // Rule ID 12189 //
     /* 332979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 332982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333026 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333031 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333049 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333063 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 333066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 333073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 333078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 333083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 333088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333107 */     GIR_RootConstrainSelectedInstOperands,
     /* 333108 */     // GIR_Coverage, 12189,
     /* 333108 */     GIR_EraseRootFromParent_Done,
     /* 333109 */   // Label 5427: @333109
     /* 333109 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(333244), // Rule ID 12190 //
     /* 333114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 333117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 333121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333166 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333171 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333191 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333198 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 333201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 333208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 333213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 333218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 333223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333242 */     GIR_RootConstrainSelectedInstOperands,
     /* 333243 */     // GIR_Coverage, 12190,
     /* 333243 */     GIR_EraseRootFromParent_Done,
     /* 333244 */   // Label 5428: @333244
     /* 333244 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(333379), // Rule ID 12191 //
     /* 333249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 333252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 333256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333296 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333301 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333306 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333326 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333333 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 333336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 333343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 333348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 333353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 333358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333377 */     GIR_RootConstrainSelectedInstOperands,
     /* 333378 */     // GIR_Coverage, 12191,
     /* 333378 */     GIR_EraseRootFromParent_Done,
     /* 333379 */   // Label 5429: @333379
     /* 333379 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(333514), // Rule ID 12668 //
     /* 333384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 333387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 333391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333431 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333436 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333441 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333445 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333461 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333468 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 333471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 333478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 333483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 333488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 333493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333512 */     GIR_RootConstrainSelectedInstOperands,
     /* 333513 */     // GIR_Coverage, 12668,
     /* 333513 */     GIR_EraseRootFromParent_Done,
     /* 333514 */   // Label 5430: @333514
     /* 333514 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(333649), // Rule ID 12669 //
     /* 333519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 333522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 333526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333566 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333571 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333589 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333596 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333603 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 333606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 333613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 333618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 333623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 333628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333647 */     GIR_RootConstrainSelectedInstOperands,
     /* 333648 */     // GIR_Coverage, 12669,
     /* 333648 */     GIR_EraseRootFromParent_Done,
     /* 333649 */   // Label 5431: @333649
     /* 333649 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(333784), // Rule ID 12670 //
     /* 333654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 333657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 333661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333701 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333706 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333711 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333738 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 333741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 333748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 333753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 333758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 333763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333782 */     GIR_RootConstrainSelectedInstOperands,
     /* 333783 */     // GIR_Coverage, 12670,
     /* 333783 */     GIR_EraseRootFromParent_Done,
     /* 333784 */   // Label 5432: @333784
     /* 333784 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(333919), // Rule ID 12671 //
     /* 333789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 333792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 333796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333836 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333841 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333859 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333866 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333873 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 333876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 333883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 333888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 333893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 333898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333917 */     GIR_RootConstrainSelectedInstOperands,
     /* 333918 */     // GIR_Coverage, 12671,
     /* 333918 */     GIR_EraseRootFromParent_Done,
     /* 333919 */   // Label 5433: @333919
     /* 333919 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(334054), // Rule ID 13148 //
     /* 333924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 333927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 333931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 333955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 333971 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333976 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333976 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334001 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334008 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 334011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 334018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 334023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 334028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 334033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334052 */     GIR_RootConstrainSelectedInstOperands,
     /* 334053 */     // GIR_Coverage, 13148,
     /* 334053 */     GIR_EraseRootFromParent_Done,
     /* 334054 */   // Label 5434: @334054
     /* 334054 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(334189), // Rule ID 13149 //
     /* 334059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 334062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 334090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334106 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334111 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334111 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334116 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334129 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334136 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334143 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 334146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 334153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 334158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 334163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 334168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334187 */     GIR_RootConstrainSelectedInstOperands,
     /* 334188 */     // GIR_Coverage, 13149,
     /* 334188 */     GIR_EraseRootFromParent_Done,
     /* 334189 */   // Label 5435: @334189
     /* 334189 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(334324), // Rule ID 13150 //
     /* 334194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 334197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 334225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334241 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334246 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334264 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334278 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 334281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 334288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 334293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 334298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 334303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334322 */     GIR_RootConstrainSelectedInstOperands,
     /* 334323 */     // GIR_Coverage, 13150,
     /* 334323 */     GIR_EraseRootFromParent_Done,
     /* 334324 */   // Label 5436: @334324
     /* 334324 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(334459), // Rule ID 13151 //
     /* 334329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 334332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 334360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334376 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334381 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334386 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334399 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334413 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 334416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 334423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 334428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 334433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 334438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334457 */     GIR_RootConstrainSelectedInstOperands,
     /* 334458 */     // GIR_Coverage, 13151,
     /* 334458 */     GIR_EraseRootFromParent_Done,
     /* 334459 */   // Label 5437: @334459
     /* 334459 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(334594), // Rule ID 12197 //
     /* 334464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 334467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 334507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 334511 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 334516 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 334521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334541 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334548 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 334551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 334558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 334563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 334568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 334573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334592 */     GIR_RootConstrainSelectedInstOperands,
     /* 334593 */     // GIR_Coverage, 12197,
     /* 334593 */     GIR_EraseRootFromParent_Done,
     /* 334594 */   // Label 5438: @334594
     /* 334594 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(334729), // Rule ID 12198 //
     /* 334599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 334602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 334642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 334646 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 334651 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 334656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334676 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334683 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 334686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 334693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 334698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 334703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 334708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334727 */     GIR_RootConstrainSelectedInstOperands,
     /* 334728 */     // GIR_Coverage, 12198,
     /* 334728 */     GIR_EraseRootFromParent_Done,
     /* 334729 */   // Label 5439: @334729
     /* 334729 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(334864), // Rule ID 12201 //
     /* 334734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 334737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334769 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 334777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 334781 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 334786 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334786 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 334791 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334818 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 334821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 334828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 334833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 334838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 334843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334862 */     GIR_RootConstrainSelectedInstOperands,
     /* 334863 */     // GIR_Coverage, 12201,
     /* 334863 */     GIR_EraseRootFromParent_Done,
     /* 334864 */   // Label 5440: @334864
     /* 334864 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(334999), // Rule ID 12202 //
     /* 334869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 334872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 334912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 334916 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 334921 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 334926 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334953 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 334956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 334963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 334968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 334973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 334978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334997 */     GIR_RootConstrainSelectedInstOperands,
     /* 334998 */     // GIR_Coverage, 12202,
     /* 334998 */     GIR_EraseRootFromParent_Done,
     /* 334999 */   // Label 5441: @334999
     /* 334999 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(335134), // Rule ID 12677 //
     /* 335004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 335007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 335011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335051 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335051 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335056 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335088 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 335091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 335098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 335103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 335108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 335113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335132 */     GIR_RootConstrainSelectedInstOperands,
     /* 335133 */     // GIR_Coverage, 12677,
     /* 335133 */     GIR_EraseRootFromParent_Done,
     /* 335134 */   // Label 5442: @335134
     /* 335134 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(335269), // Rule ID 12678 //
     /* 335139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 335142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 335146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335186 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335191 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335216 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335223 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 335226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 335233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 335238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 335243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 335248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335267 */     GIR_RootConstrainSelectedInstOperands,
     /* 335268 */     // GIR_Coverage, 12678,
     /* 335268 */     GIR_EraseRootFromParent_Done,
     /* 335269 */   // Label 5443: @335269
     /* 335269 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(335404), // Rule ID 12681 //
     /* 335274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 335277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 335281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335321 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335326 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335331 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335335 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335351 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335358 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 335361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 335368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 335373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 335378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 335383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335402 */     GIR_RootConstrainSelectedInstOperands,
     /* 335403 */     // GIR_Coverage, 12681,
     /* 335403 */     GIR_EraseRootFromParent_Done,
     /* 335404 */   // Label 5444: @335404
     /* 335404 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(335539), // Rule ID 12682 //
     /* 335409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 335412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 335416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335456 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335461 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335461 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335466 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335486 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335493 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 335496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 335503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 335508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 335513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 335518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335537 */     GIR_RootConstrainSelectedInstOperands,
     /* 335538 */     // GIR_Coverage, 12682,
     /* 335538 */     GIR_EraseRootFromParent_Done,
     /* 335539 */   // Label 5445: @335539
     /* 335539 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(335674), // Rule ID 13157 //
     /* 335544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 335547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335591 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335596 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335621 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335628 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 335631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 335638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 335643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 335648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 335653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335672 */     GIR_RootConstrainSelectedInstOperands,
     /* 335673 */     // GIR_Coverage, 13157,
     /* 335673 */     GIR_EraseRootFromParent_Done,
     /* 335674 */   // Label 5446: @335674
     /* 335674 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(335809), // Rule ID 13158 //
     /* 335679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 335682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335726 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335731 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335736 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335763 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 335766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 335773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 335778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 335783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 335788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335807 */     GIR_RootConstrainSelectedInstOperands,
     /* 335808 */     // GIR_Coverage, 13158,
     /* 335808 */     GIR_EraseRootFromParent_Done,
     /* 335809 */   // Label 5447: @335809
     /* 335809 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(335944), // Rule ID 13161 //
     /* 335814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 335817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 335866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 335871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335898 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 335901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 335908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 335913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 335918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 335923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335942 */     GIR_RootConstrainSelectedInstOperands,
     /* 335943 */     // GIR_Coverage, 13161,
     /* 335943 */     GIR_EraseRootFromParent_Done,
     /* 335944 */   // Label 5448: @335944
     /* 335944 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(336079), // Rule ID 13162 //
     /* 335949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 335952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 335992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335996 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336001 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336033 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 336036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 336043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 336048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 336053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 336058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336077 */     GIR_RootConstrainSelectedInstOperands,
     /* 336078 */     // GIR_Coverage, 13162,
     /* 336078 */     GIR_EraseRootFromParent_Done,
     /* 336079 */   // Label 5449: @336079
     /* 336079 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(336214), // Rule ID 12182 //
     /* 336084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 336087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 336091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336136 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336141 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336145 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336168 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 336171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 336178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 336183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 336188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 336193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336212 */     GIR_RootConstrainSelectedInstOperands,
     /* 336213 */     // GIR_Coverage, 12182,
     /* 336213 */     GIR_EraseRootFromParent_Done,
     /* 336214 */   // Label 5450: @336214
     /* 336214 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(336349), // Rule ID 12183 //
     /* 336219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 336222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 336226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336266 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336271 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336276 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336303 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 336306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 336313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 336318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 336323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 336328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336347 */     GIR_RootConstrainSelectedInstOperands,
     /* 336348 */     // GIR_Coverage, 12183,
     /* 336348 */     GIR_EraseRootFromParent_Done,
     /* 336349 */   // Label 5451: @336349
     /* 336349 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(336484), // Rule ID 12186 //
     /* 336354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 336357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 336361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336401 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336411 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336415 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336438 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 336441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 336448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 336453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 336458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 336463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336482 */     GIR_RootConstrainSelectedInstOperands,
     /* 336483 */     // GIR_Coverage, 12186,
     /* 336483 */     GIR_EraseRootFromParent_Done,
     /* 336484 */   // Label 5452: @336484
     /* 336484 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(336619), // Rule ID 12187 //
     /* 336489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 336492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 336496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336536 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336541 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336573 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 336576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 336583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 336588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 336593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 336598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336617 */     GIR_RootConstrainSelectedInstOperands,
     /* 336618 */     // GIR_Coverage, 12187,
     /* 336618 */     GIR_EraseRootFromParent_Done,
     /* 336619 */   // Label 5453: @336619
     /* 336619 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(336754), // Rule ID 12662 //
     /* 336624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 336627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 336631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336671 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336676 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336708 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 336711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 336718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 336723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 336728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 336733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336752 */     GIR_RootConstrainSelectedInstOperands,
     /* 336753 */     // GIR_Coverage, 12662,
     /* 336753 */     GIR_EraseRootFromParent_Done,
     /* 336754 */   // Label 5454: @336754
     /* 336754 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(336889), // Rule ID 12663 //
     /* 336759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 336762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 336766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336811 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336843 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 336846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 336853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 336858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 336863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 336868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336887 */     GIR_RootConstrainSelectedInstOperands,
     /* 336888 */     // GIR_Coverage, 12663,
     /* 336888 */     GIR_EraseRootFromParent_Done,
     /* 336889 */   // Label 5455: @336889
     /* 336889 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(337024), // Rule ID 12666 //
     /* 336894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 336897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 336901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 336909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 336937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336941 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 336946 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 336951 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336971 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336978 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 336981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 336988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 336993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 336998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 337003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337022 */     GIR_RootConstrainSelectedInstOperands,
     /* 337023 */     // GIR_Coverage, 12666,
     /* 337023 */     GIR_EraseRootFromParent_Done,
     /* 337024 */   // Label 5456: @337024
     /* 337024 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(337159), // Rule ID 12667 //
     /* 337029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 337032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 337036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 337072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337076 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337081 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337090 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337113 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 337116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 337123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 337128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 337133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 337138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337157 */     GIR_RootConstrainSelectedInstOperands,
     /* 337158 */     // GIR_Coverage, 12667,
     /* 337158 */     GIR_EraseRootFromParent_Done,
     /* 337159 */   // Label 5457: @337159
     /* 337159 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(337294), // Rule ID 13142 //
     /* 337164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 337167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 337207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337211 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337216 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337241 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337248 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 337251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 337258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 337263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 337268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 337273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337292 */     GIR_RootConstrainSelectedInstOperands,
     /* 337293 */     // GIR_Coverage, 13142,
     /* 337293 */     GIR_EraseRootFromParent_Done,
     /* 337294 */   // Label 5458: @337294
     /* 337294 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(337429), // Rule ID 13143 //
     /* 337299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 337302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 337342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337383 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 337386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 337393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 337398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 337403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 337408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337427 */     GIR_RootConstrainSelectedInstOperands,
     /* 337428 */     // GIR_Coverage, 13143,
     /* 337428 */     GIR_EraseRootFromParent_Done,
     /* 337429 */   // Label 5459: @337429
     /* 337429 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(337564), // Rule ID 13146 //
     /* 337434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 337437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 337477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337511 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337518 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 337521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 337528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 337533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 337538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 337543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337562 */     GIR_RootConstrainSelectedInstOperands,
     /* 337563 */     // GIR_Coverage, 13146,
     /* 337563 */     GIR_EraseRootFromParent_Done,
     /* 337564 */   // Label 5460: @337564
     /* 337564 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(337699), // Rule ID 13147 //
     /* 337569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 337572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 337612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337616 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337621 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337621 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337626 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337646 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337653 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 337656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 337663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 337668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 337673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 337678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337697 */     GIR_RootConstrainSelectedInstOperands,
     /* 337698 */     // GIR_Coverage, 13147,
     /* 337698 */     GIR_EraseRootFromParent_Done,
     /* 337699 */   // Label 5461: @337699
     /* 337699 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(337834), // Rule ID 7636 //
     /* 337704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 337707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 337747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 337751 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337756 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337765 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337788 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 337791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 337798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 337803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 337808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 337813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337832 */     GIR_RootConstrainSelectedInstOperands,
     /* 337833 */     // GIR_Coverage, 7636,
     /* 337833 */     GIR_EraseRootFromParent_Done,
     /* 337834 */   // Label 5462: @337834
     /* 337834 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(337969), // Rule ID 7668 //
     /* 337839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 337842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 337846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 337882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 337886 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 337891 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 337896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337900 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337923 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 337926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 337933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 337938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 337943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 337948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337967 */     GIR_RootConstrainSelectedInstOperands,
     /* 337968 */     // GIR_Coverage, 7668,
     /* 337968 */     GIR_EraseRootFromParent_Done,
     /* 337969 */   // Label 5463: @337969
     /* 337969 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(338104), // Rule ID 7700 //
     /* 337974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 337977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338021 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338026 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338035 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338051 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338058 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 338061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 338068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 338073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 338078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 338083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338102 */     GIR_RootConstrainSelectedInstOperands,
     /* 338103 */     // GIR_Coverage, 7700,
     /* 338103 */     GIR_EraseRootFromParent_Done,
     /* 338104 */   // Label 5464: @338104
     /* 338104 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(338239), // Rule ID 12196 //
     /* 338109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 338112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338193 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 338196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 338203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 338208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 338213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 338218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338237 */     GIR_RootConstrainSelectedInstOperands,
     /* 338238 */     // GIR_Coverage, 12196,
     /* 338238 */     GIR_EraseRootFromParent_Done,
     /* 338239 */   // Label 5465: @338239
     /* 338239 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(338374), // Rule ID 12199 //
     /* 338244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 338247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338291 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338296 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338321 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338328 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 338331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 338338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 338343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 338348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 338353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338372 */     GIR_RootConstrainSelectedInstOperands,
     /* 338373 */     // GIR_Coverage, 12199,
     /* 338373 */     GIR_EraseRootFromParent_Done,
     /* 338374 */   // Label 5466: @338374
     /* 338374 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(338509), // Rule ID 12200 //
     /* 338379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 338382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338414 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338426 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338431 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338436 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338456 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338463 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 338466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 338473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 338478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 338483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 338488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338507 */     GIR_RootConstrainSelectedInstOperands,
     /* 338508 */     // GIR_Coverage, 12200,
     /* 338508 */     GIR_EraseRootFromParent_Done,
     /* 338509 */   // Label 5467: @338509
     /* 338509 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(338644), // Rule ID 12676 //
     /* 338514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 338517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 338521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338561 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338561 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338566 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338575 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338598 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 338601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 338608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 338613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 338618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 338623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338642 */     GIR_RootConstrainSelectedInstOperands,
     /* 338643 */     // GIR_Coverage, 12676,
     /* 338643 */     GIR_EraseRootFromParent_Done,
     /* 338644 */   // Label 5468: @338644
     /* 338644 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(338779), // Rule ID 12679 //
     /* 338649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 338652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 338656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338696 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338701 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338706 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338733 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 338736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 338743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 338748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 338753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 338758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338777 */     GIR_RootConstrainSelectedInstOperands,
     /* 338778 */     // GIR_Coverage, 12679,
     /* 338778 */     GIR_EraseRootFromParent_Done,
     /* 338779 */   // Label 5469: @338779
     /* 338779 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(338914), // Rule ID 12680 //
     /* 338784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 338787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 338791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338831 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338836 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338868 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 338871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 338878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 338883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 338888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 338893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338912 */     GIR_RootConstrainSelectedInstOperands,
     /* 338913 */     // GIR_Coverage, 12680,
     /* 338913 */     GIR_EraseRootFromParent_Done,
     /* 338914 */   // Label 5470: @338914
     /* 338914 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(339049), // Rule ID 13156 //
     /* 338919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 338922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 338962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338966 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338971 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338996 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339003 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 339006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 339013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 339018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 339023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 339028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339047 */     GIR_RootConstrainSelectedInstOperands,
     /* 339048 */     // GIR_Coverage, 13156,
     /* 339048 */     GIR_EraseRootFromParent_Done,
     /* 339049 */   // Label 5471: @339049
     /* 339049 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(339184), // Rule ID 13159 //
     /* 339054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 339057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 339101 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339106 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339138 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 339141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 339148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 339153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 339158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 339163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339182 */     GIR_RootConstrainSelectedInstOperands,
     /* 339183 */     // GIR_Coverage, 13159,
     /* 339183 */     GIR_EraseRootFromParent_Done,
     /* 339184 */   // Label 5472: @339184
     /* 339184 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(339319), // Rule ID 13160 //
     /* 339189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 339192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 339236 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339241 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339273 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 339276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 339283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 339288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 339293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 339298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339317 */     GIR_RootConstrainSelectedInstOperands,
     /* 339318 */     // GIR_Coverage, 13160,
     /* 339318 */     GIR_EraseRootFromParent_Done,
     /* 339319 */   // Label 5473: @339319
     /* 339319 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(339454), // Rule ID 7635 //
     /* 339324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 339327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 339371 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339376 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339408 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 339411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 339418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 339423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 339428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 339433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339452 */     GIR_RootConstrainSelectedInstOperands,
     /* 339453 */     // GIR_Coverage, 7635,
     /* 339453 */     GIR_EraseRootFromParent_Done,
     /* 339454 */   // Label 5474: @339454
     /* 339454 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(339589), // Rule ID 7667 //
     /* 339459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 339462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 339466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 339506 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339511 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339543 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 339546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 339553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 339558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 339563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 339568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339587 */     GIR_RootConstrainSelectedInstOperands,
     /* 339588 */     // GIR_Coverage, 7667,
     /* 339588 */     GIR_EraseRootFromParent_Done,
     /* 339589 */   // Label 5475: @339589
     /* 339589 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(339724), // Rule ID 7699 //
     /* 339594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 339597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 339641 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339646 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339651 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339678 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 339681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 339688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 339693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 339698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 339703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339722 */     GIR_RootConstrainSelectedInstOperands,
     /* 339723 */     // GIR_Coverage, 7699,
     /* 339723 */     GIR_EraseRootFromParent_Done,
     /* 339724 */   // Label 5476: @339724
     /* 339724 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(339859), // Rule ID 12181 //
     /* 339729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 339732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 339776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339781 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339813 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 339816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 339823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 339828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 339833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 339838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339857 */     GIR_RootConstrainSelectedInstOperands,
     /* 339858 */     // GIR_Coverage, 12181,
     /* 339858 */     GIR_EraseRootFromParent_Done,
     /* 339859 */   // Label 5477: @339859
     /* 339859 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(339994), // Rule ID 12184 //
     /* 339864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 339867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 339907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 339911 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339916 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339925 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339948 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 339951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 339958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 339963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 339968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 339973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339992 */     GIR_RootConstrainSelectedInstOperands,
     /* 339993 */     // GIR_Coverage, 12184,
     /* 339993 */     GIR_EraseRootFromParent_Done,
     /* 339994 */   // Label 5478: @339994
     /* 339994 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(340129), // Rule ID 12185 //
     /* 339999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 340002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340046 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340051 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340051 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340056 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340076 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340083 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 340086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 340093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 340098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 340103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 340108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340127 */     GIR_RootConstrainSelectedInstOperands,
     /* 340128 */     // GIR_Coverage, 12185,
     /* 340128 */     GIR_EraseRootFromParent_Done,
     /* 340129 */   // Label 5479: @340129
     /* 340129 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(340264), // Rule ID 12661 //
     /* 340134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 340137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 340141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340169 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340181 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340186 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340218 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 340221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 340228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 340233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 340238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 340243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340262 */     GIR_RootConstrainSelectedInstOperands,
     /* 340263 */     // GIR_Coverage, 12661,
     /* 340263 */     GIR_EraseRootFromParent_Done,
     /* 340264 */   // Label 5480: @340264
     /* 340264 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(340399), // Rule ID 12664 //
     /* 340269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 340272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 340276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340316 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340321 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340326 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340353 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 340356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 340363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 340368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 340373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 340378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340397 */     GIR_RootConstrainSelectedInstOperands,
     /* 340398 */     // GIR_Coverage, 12664,
     /* 340398 */     GIR_EraseRootFromParent_Done,
     /* 340399 */   // Label 5481: @340399
     /* 340399 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(340534), // Rule ID 12665 //
     /* 340404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 340407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 340411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340451 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340456 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340488 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 340491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 340498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 340503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 340508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 340513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340532 */     GIR_RootConstrainSelectedInstOperands,
     /* 340533 */     // GIR_Coverage, 12665,
     /* 340533 */     GIR_EraseRootFromParent_Done,
     /* 340534 */   // Label 5482: @340534
     /* 340534 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(340669), // Rule ID 13141 //
     /* 340539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 340542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340586 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340591 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340596 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340616 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340623 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 340626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 340633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 340638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 340643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 340648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340667 */     GIR_RootConstrainSelectedInstOperands,
     /* 340668 */     // GIR_Coverage, 13141,
     /* 340668 */     GIR_EraseRootFromParent_Done,
     /* 340669 */   // Label 5483: @340669
     /* 340669 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(340804), // Rule ID 13144 //
     /* 340674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 340677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340721 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340721 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340726 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340731 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340758 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 340761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 340768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 340773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 340778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 340783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340802 */     GIR_RootConstrainSelectedInstOperands,
     /* 340803 */     // GIR_Coverage, 13144,
     /* 340803 */     GIR_EraseRootFromParent_Done,
     /* 340804 */   // Label 5484: @340804
     /* 340804 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(340939), // Rule ID 13145 //
     /* 340809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 340812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 340852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340893 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 340896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 340903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 340908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 340913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 340918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340937 */     GIR_RootConstrainSelectedInstOperands,
     /* 340938 */     // GIR_Coverage, 13145,
     /* 340938 */     GIR_EraseRootFromParent_Done,
     /* 340939 */   // Label 5485: @340939
     /* 340939 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(341074), // Rule ID 12167 //
     /* 340944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 340947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 340987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 340991 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340996 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341001 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341021 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341028 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 341031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 341038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 341043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 341048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 341053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341072 */     GIR_RootConstrainSelectedInstOperands,
     /* 341073 */     // GIR_Coverage, 12167,
     /* 341073 */     GIR_EraseRootFromParent_Done,
     /* 341074 */   // Label 5486: @341074
     /* 341074 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(341209), // Rule ID 12168 //
     /* 341079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 341082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 341086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 341126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341136 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341163 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 341166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 341173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 341178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 341183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 341188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341207 */     GIR_RootConstrainSelectedInstOperands,
     /* 341208 */     // GIR_Coverage, 12168,
     /* 341208 */     GIR_EraseRootFromParent_Done,
     /* 341209 */   // Label 5487: @341209
     /* 341209 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(341344), // Rule ID 12171 //
     /* 341214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 341217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 341221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341249 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 341261 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341266 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341271 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341291 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341298 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 341301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 341308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 341313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 341318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 341323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341342 */     GIR_RootConstrainSelectedInstOperands,
     /* 341343 */     // GIR_Coverage, 12171,
     /* 341343 */     GIR_EraseRootFromParent_Done,
     /* 341344 */   // Label 5488: @341344
     /* 341344 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(341479), // Rule ID 12172 //
     /* 341349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 341352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 341356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 341396 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341401 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341406 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341433 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 341436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 341443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 341448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 341453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 341458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341477 */     GIR_RootConstrainSelectedInstOperands,
     /* 341478 */     // GIR_Coverage, 12172,
     /* 341478 */     GIR_EraseRootFromParent_Done,
     /* 341479 */   // Label 5489: @341479
     /* 341479 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(341614), // Rule ID 12647 //
     /* 341484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 341487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 341491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 341531 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341536 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341568 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 341571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 341578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 341583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 341588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 341593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341612 */     GIR_RootConstrainSelectedInstOperands,
     /* 341613 */     // GIR_Coverage, 12647,
     /* 341613 */     GIR_EraseRootFromParent_Done,
     /* 341614 */   // Label 5490: @341614
     /* 341614 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(341749), // Rule ID 12648 //
     /* 341619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 341622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 341626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 341666 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341671 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341676 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341703 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 341706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 341713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 341718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 341723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 341728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341747 */     GIR_RootConstrainSelectedInstOperands,
     /* 341748 */     // GIR_Coverage, 12648,
     /* 341748 */     GIR_EraseRootFromParent_Done,
     /* 341749 */   // Label 5491: @341749
     /* 341749 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(341884), // Rule ID 12651 //
     /* 341754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 341757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 341761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 341801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341838 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 341841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 341848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 341853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 341858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 341863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341882 */     GIR_RootConstrainSelectedInstOperands,
     /* 341883 */     // GIR_Coverage, 12651,
     /* 341883 */     GIR_EraseRootFromParent_Done,
     /* 341884 */   // Label 5492: @341884
     /* 341884 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(342019), // Rule ID 12652 //
     /* 341889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 341892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 341896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 341936 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341941 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341973 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 341976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 341983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 341988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 341993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 341998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342017 */     GIR_RootConstrainSelectedInstOperands,
     /* 342018 */     // GIR_Coverage, 12652,
     /* 342018 */     GIR_EraseRootFromParent_Done,
     /* 342019 */   // Label 5493: @342019
     /* 342019 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(342154), // Rule ID 13127 //
     /* 342024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 342027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342071 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342076 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342081 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342108 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 342111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 342118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 342123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 342128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 342133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342152 */     GIR_RootConstrainSelectedInstOperands,
     /* 342153 */     // GIR_Coverage, 13127,
     /* 342153 */     GIR_EraseRootFromParent_Done,
     /* 342154 */   // Label 5494: @342154
     /* 342154 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(342289), // Rule ID 13128 //
     /* 342159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 342162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342194 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342206 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342206 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342211 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342216 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342236 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342243 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 342246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 342253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 342258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 342263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 342268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342287 */     GIR_RootConstrainSelectedInstOperands,
     /* 342288 */     // GIR_Coverage, 13128,
     /* 342288 */     GIR_EraseRootFromParent_Done,
     /* 342289 */   // Label 5495: @342289
     /* 342289 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(342424), // Rule ID 13131 //
     /* 342294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 342297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342351 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342378 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 342381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 342388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 342393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 342398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 342403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342422 */     GIR_RootConstrainSelectedInstOperands,
     /* 342423 */     // GIR_Coverage, 13131,
     /* 342423 */     GIR_EraseRootFromParent_Done,
     /* 342424 */   // Label 5496: @342424
     /* 342424 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(342559), // Rule ID 13132 //
     /* 342429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 342432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342513 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 342516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 342523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 342528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 342533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 342538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342557 */     GIR_RootConstrainSelectedInstOperands,
     /* 342558 */     // GIR_Coverage, 13132,
     /* 342558 */     GIR_EraseRootFromParent_Done,
     /* 342559 */   // Label 5497: @342559
     /* 342559 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(342694), // Rule ID 12152 //
     /* 342564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 342567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 342611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342616 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342634 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342648 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 342651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 342658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 342663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 342668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 342673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342692 */     GIR_RootConstrainSelectedInstOperands,
     /* 342693 */     // GIR_Coverage, 12152,
     /* 342693 */     GIR_EraseRootFromParent_Done,
     /* 342694 */   // Label 5498: @342694
     /* 342694 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(342829), // Rule ID 12153 //
     /* 342699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 342702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 342746 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342751 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342756 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342783 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 342786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 342793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 342798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 342803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 342808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342827 */     GIR_RootConstrainSelectedInstOperands,
     /* 342828 */     // GIR_Coverage, 12153,
     /* 342828 */     GIR_EraseRootFromParent_Done,
     /* 342829 */   // Label 5499: @342829
     /* 342829 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(342964), // Rule ID 12156 //
     /* 342834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 342837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 342881 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342886 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342891 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342895 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342918 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 342921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 342928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 342933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 342938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 342943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342962 */     GIR_RootConstrainSelectedInstOperands,
     /* 342963 */     // GIR_Coverage, 12156,
     /* 342963 */     GIR_EraseRootFromParent_Done,
     /* 342964 */   // Label 5500: @342964
     /* 342964 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(343099), // Rule ID 12157 //
     /* 342969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 342972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343016 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343021 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343053 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 343056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 343063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 343068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 343073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 343078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343097 */     GIR_RootConstrainSelectedInstOperands,
     /* 343098 */     // GIR_Coverage, 12157,
     /* 343098 */     GIR_EraseRootFromParent_Done,
     /* 343099 */   // Label 5501: @343099
     /* 343099 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(343234), // Rule ID 12632 //
     /* 343104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 343107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 343111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343188 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 343191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 343198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 343203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 343208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 343213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343232 */     GIR_RootConstrainSelectedInstOperands,
     /* 343233 */     // GIR_Coverage, 12632,
     /* 343233 */     GIR_EraseRootFromParent_Done,
     /* 343234 */   // Label 5502: @343234
     /* 343234 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(343369), // Rule ID 12633 //
     /* 343239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 343242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 343246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343291 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343296 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343323 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 343326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 343333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 343338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 343343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 343348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343367 */     GIR_RootConstrainSelectedInstOperands,
     /* 343368 */     // GIR_Coverage, 12633,
     /* 343368 */     GIR_EraseRootFromParent_Done,
     /* 343369 */   // Label 5503: @343369
     /* 343369 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(343504), // Rule ID 12636 //
     /* 343374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 343377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 343381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343426 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343458 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 343461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 343468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 343473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 343478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 343483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343502 */     GIR_RootConstrainSelectedInstOperands,
     /* 343503 */     // GIR_Coverage, 12636,
     /* 343503 */     GIR_EraseRootFromParent_Done,
     /* 343504 */   // Label 5504: @343504
     /* 343504 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(343639), // Rule ID 12637 //
     /* 343509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 343512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 343516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343556 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343561 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343561 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343593 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 343596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 343603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 343608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 343613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 343618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343637 */     GIR_RootConstrainSelectedInstOperands,
     /* 343638 */     // GIR_Coverage, 12637,
     /* 343638 */     GIR_EraseRootFromParent_Done,
     /* 343639 */   // Label 5505: @343639
     /* 343639 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(343774), // Rule ID 13112 //
     /* 343644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 343647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 343651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343679 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343691 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343691 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343696 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343728 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 343731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 343738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 343743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 343748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 343753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343772 */     GIR_RootConstrainSelectedInstOperands,
     /* 343773 */     // GIR_Coverage, 13112,
     /* 343773 */     GIR_EraseRootFromParent_Done,
     /* 343774 */   // Label 5506: @343774
     /* 343774 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(343909), // Rule ID 13113 //
     /* 343779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 343782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 343786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343836 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343863 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 343866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 343873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 343878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 343883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 343888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343907 */     GIR_RootConstrainSelectedInstOperands,
     /* 343908 */     // GIR_Coverage, 13113,
     /* 343908 */     GIR_EraseRootFromParent_Done,
     /* 343909 */   // Label 5507: @343909
     /* 343909 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(344044), // Rule ID 13116 //
     /* 343914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 343917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 343921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 343957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343966 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343998 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 344001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 344008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 344013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 344018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 344023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344042 */     GIR_RootConstrainSelectedInstOperands,
     /* 344043 */     // GIR_Coverage, 13116,
     /* 344043 */     GIR_EraseRootFromParent_Done,
     /* 344044 */   // Label 5508: @344044
     /* 344044 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(344179), // Rule ID 13117 //
     /* 344049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 344052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 344092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 344096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344101 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344133 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 344136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 344143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 344148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 344153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 344158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344177 */     GIR_RootConstrainSelectedInstOperands,
     /* 344178 */     // GIR_Coverage, 13117,
     /* 344178 */     GIR_EraseRootFromParent_Done,
     /* 344179 */   // Label 5509: @344179
     /* 344179 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(344314), // Rule ID 7634 //
     /* 344184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 344187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 344231 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344236 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344241 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344254 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344268 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 344271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 344278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 344283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 344288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 344293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344312 */     GIR_RootConstrainSelectedInstOperands,
     /* 344313 */     // GIR_Coverage, 7634,
     /* 344313 */     GIR_EraseRootFromParent_Done,
     /* 344314 */   // Label 5510: @344314
     /* 344314 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(344449), // Rule ID 7666 //
     /* 344319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 344322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 344326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 344366 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344371 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344376 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344403 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 344406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 344413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 344418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 344423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 344428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344447 */     GIR_RootConstrainSelectedInstOperands,
     /* 344448 */     // GIR_Coverage, 7666,
     /* 344448 */     GIR_EraseRootFromParent_Done,
     /* 344449 */   // Label 5511: @344449
     /* 344449 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(344584), // Rule ID 7698 //
     /* 344454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 344457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 344501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344506 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344538 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 344541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 344548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 344553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 344558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 344563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344582 */     GIR_RootConstrainSelectedInstOperands,
     /* 344583 */     // GIR_Coverage, 7698,
     /* 344583 */     GIR_EraseRootFromParent_Done,
     /* 344584 */   // Label 5512: @344584
     /* 344584 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(344719), // Rule ID 12166 //
     /* 344589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 344592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 344636 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344641 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344673 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 344676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 344683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 344688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 344693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 344698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344717 */     GIR_RootConstrainSelectedInstOperands,
     /* 344718 */     // GIR_Coverage, 12166,
     /* 344718 */     GIR_EraseRootFromParent_Done,
     /* 344719 */   // Label 5513: @344719
     /* 344719 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(344854), // Rule ID 12169 //
     /* 344724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 344727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 344771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344808 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 344811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 344818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 344823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 344828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 344833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344852 */     GIR_RootConstrainSelectedInstOperands,
     /* 344853 */     // GIR_Coverage, 12169,
     /* 344853 */     GIR_EraseRootFromParent_Done,
     /* 344854 */   // Label 5514: @344854
     /* 344854 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(344989), // Rule ID 12170 //
     /* 344859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 344862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 344906 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344911 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344916 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344943 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 344946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 344953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 344958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 344963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 344968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344987 */     GIR_RootConstrainSelectedInstOperands,
     /* 344988 */     // GIR_Coverage, 12170,
     /* 344988 */     GIR_EraseRootFromParent_Done,
     /* 344989 */   // Label 5515: @344989
     /* 344989 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(345124), // Rule ID 12646 //
     /* 344994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 344997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 345001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345041 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345041 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345046 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345051 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345055 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345078 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 345081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 345088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 345093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 345098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 345103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345122 */     GIR_RootConstrainSelectedInstOperands,
     /* 345123 */     // GIR_Coverage, 12646,
     /* 345123 */     GIR_EraseRootFromParent_Done,
     /* 345124 */   // Label 5516: @345124
     /* 345124 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(345259), // Rule ID 12649 //
     /* 345129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 345132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 345136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345176 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345176 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345181 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345186 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345213 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 345216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 345223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 345228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 345233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 345238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345257 */     GIR_RootConstrainSelectedInstOperands,
     /* 345258 */     // GIR_Coverage, 12649,
     /* 345258 */     GIR_EraseRootFromParent_Done,
     /* 345259 */   // Label 5517: @345259
     /* 345259 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(345394), // Rule ID 12650 //
     /* 345264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 345267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 345271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345311 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345316 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345348 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 345351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 345358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 345363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 345368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 345373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345392 */     GIR_RootConstrainSelectedInstOperands,
     /* 345393 */     // GIR_Coverage, 12650,
     /* 345393 */     GIR_EraseRootFromParent_Done,
     /* 345394 */   // Label 5518: @345394
     /* 345394 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(345529), // Rule ID 13126 //
     /* 345399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 345402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345446 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345451 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345483 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 345486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 345493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 345498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 345503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 345508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345527 */     GIR_RootConstrainSelectedInstOperands,
     /* 345528 */     // GIR_Coverage, 13126,
     /* 345528 */     GIR_EraseRootFromParent_Done,
     /* 345529 */   // Label 5519: @345529
     /* 345529 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(345664), // Rule ID 13129 //
     /* 345534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 345537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345581 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345586 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345618 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 345621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 345628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 345633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 345638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 345643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345662 */     GIR_RootConstrainSelectedInstOperands,
     /* 345663 */     // GIR_Coverage, 13129,
     /* 345663 */     GIR_EraseRootFromParent_Done,
     /* 345664 */   // Label 5520: @345664
     /* 345664 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(345799), // Rule ID 13130 //
     /* 345669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 345672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345716 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345716 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345721 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345721 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345726 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345732 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345753 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 345756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 345763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 345768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 345773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 345778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345797 */     GIR_RootConstrainSelectedInstOperands,
     /* 345798 */     // GIR_Coverage, 13130,
     /* 345798 */     GIR_EraseRootFromParent_Done,
     /* 345799 */   // Label 5521: @345799
     /* 345799 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(345934), // Rule ID 7633 //
     /* 345804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 345807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 345851 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345861 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345888 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 345891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 345898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 345903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 345908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 345913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345932 */     GIR_RootConstrainSelectedInstOperands,
     /* 345933 */     // GIR_Coverage, 7633,
     /* 345933 */     GIR_EraseRootFromParent_Done,
     /* 345934 */   // Label 5522: @345934
     /* 345934 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(346069), // Rule ID 7665 //
     /* 345939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 345942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 345946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 345986 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345991 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345996 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346023 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 346026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 346033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 346038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 346043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 346048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346067 */     GIR_RootConstrainSelectedInstOperands,
     /* 346068 */     // GIR_Coverage, 7665,
     /* 346068 */     GIR_EraseRootFromParent_Done,
     /* 346069 */   // Label 5523: @346069
     /* 346069 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(346204), // Rule ID 7697 //
     /* 346074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 346077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346121 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346158 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 346161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 346168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 346173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 346178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 346183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346202 */     GIR_RootConstrainSelectedInstOperands,
     /* 346203 */     // GIR_Coverage, 7697,
     /* 346203 */     GIR_EraseRootFromParent_Done,
     /* 346204 */   // Label 5524: @346204
     /* 346204 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(346339), // Rule ID 12151 //
     /* 346209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 346212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346256 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346261 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346270 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346293 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 346296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 346303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 346308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 346313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 346318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346337 */     GIR_RootConstrainSelectedInstOperands,
     /* 346338 */     // GIR_Coverage, 12151,
     /* 346338 */     GIR_EraseRootFromParent_Done,
     /* 346339 */   // Label 5525: @346339
     /* 346339 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(346474), // Rule ID 12154 //
     /* 346344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 346347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346379 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346391 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346396 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346401 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346428 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 346431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 346438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 346443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 346448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 346453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346472 */     GIR_RootConstrainSelectedInstOperands,
     /* 346473 */     // GIR_Coverage, 12154,
     /* 346473 */     GIR_EraseRootFromParent_Done,
     /* 346474 */   // Label 5526: @346474
     /* 346474 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(346609), // Rule ID 12155 //
     /* 346479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 346482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346522 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346526 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346526 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346531 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346563 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 346566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 346573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 346578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 346583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 346588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346607 */     GIR_RootConstrainSelectedInstOperands,
     /* 346608 */     // GIR_Coverage, 12155,
     /* 346608 */     GIR_EraseRootFromParent_Done,
     /* 346609 */   // Label 5527: @346609
     /* 346609 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(346744), // Rule ID 12631 //
     /* 346614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 346617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 346621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346661 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346666 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346671 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346698 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 346701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 346708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 346713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 346718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 346723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346742 */     GIR_RootConstrainSelectedInstOperands,
     /* 346743 */     // GIR_Coverage, 12631,
     /* 346743 */     GIR_EraseRootFromParent_Done,
     /* 346744 */   // Label 5528: @346744
     /* 346744 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(346879), // Rule ID 12634 //
     /* 346749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 346752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 346756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346796 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346801 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346833 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 346836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 346843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 346848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 346853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 346858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346877 */     GIR_RootConstrainSelectedInstOperands,
     /* 346878 */     // GIR_Coverage, 12634,
     /* 346878 */     GIR_EraseRootFromParent_Done,
     /* 346879 */   // Label 5529: @346879
     /* 346879 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(347014), // Rule ID 12635 //
     /* 346884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 346887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 346891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 346927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 346931 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346936 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346968 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 346971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 346978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 346983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 346988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 346993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347012 */     GIR_RootConstrainSelectedInstOperands,
     /* 347013 */     // GIR_Coverage, 12635,
     /* 347013 */     GIR_EraseRootFromParent_Done,
     /* 347014 */   // Label 5530: @347014
     /* 347014 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(347149), // Rule ID 13111 //
     /* 347019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 347022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 347062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347066 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347071 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347076 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347103 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 347106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 347113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 347118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 347123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 347128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347147 */     GIR_RootConstrainSelectedInstOperands,
     /* 347148 */     // GIR_Coverage, 13111,
     /* 347148 */     GIR_EraseRootFromParent_Done,
     /* 347149 */   // Label 5531: @347149
     /* 347149 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(347284), // Rule ID 13114 //
     /* 347154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 347157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 347197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347201 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347201 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347206 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347206 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347211 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347215 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347238 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 347241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 347248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 347253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 347258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 347263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347282 */     GIR_RootConstrainSelectedInstOperands,
     /* 347283 */     // GIR_Coverage, 13114,
     /* 347283 */     GIR_EraseRootFromParent_Done,
     /* 347284 */   // Label 5532: @347284
     /* 347284 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(347419), // Rule ID 13115 //
     /* 347289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 347292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 347332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347336 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347346 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347373 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 347376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 347383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 347388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 347393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 347398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347417 */     GIR_RootConstrainSelectedInstOperands,
     /* 347418 */     // GIR_Coverage, 13115,
     /* 347418 */     GIR_EraseRootFromParent_Done,
     /* 347419 */   // Label 5533: @347419
     /* 347419 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(347554), // Rule ID 12237 //
     /* 347424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 347427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 347451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 347455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 347467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 347471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 347476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 347481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347485 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347508 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 347511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 347518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 347523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 347528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 347533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 347538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 347543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347552 */     GIR_RootConstrainSelectedInstOperands,
     /* 347553 */     // GIR_Coverage, 12237,
     /* 347553 */     GIR_EraseRootFromParent_Done,
     /* 347554 */   // Label 5534: @347554
     /* 347554 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(347689), // Rule ID 12238 //
     /* 347559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 347562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 347586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 347590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 347602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 347606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 347611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 347616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347643 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 347646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 347653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 347658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 347663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 347668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 347673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 347678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347687 */     GIR_RootConstrainSelectedInstOperands,
     /* 347688 */     // GIR_Coverage, 12238,
     /* 347688 */     GIR_EraseRootFromParent_Done,
     /* 347689 */   // Label 5535: @347689
     /* 347689 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(347824), // Rule ID 12239 //
     /* 347694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 347697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 347721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 347725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 347737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 347741 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 347746 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 347751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347778 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 347781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 347788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 347793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 347798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 347803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 347808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 347813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347822 */     GIR_RootConstrainSelectedInstOperands,
     /* 347823 */     // GIR_Coverage, 12239,
     /* 347823 */     GIR_EraseRootFromParent_Done,
     /* 347824 */   // Label 5536: @347824
     /* 347824 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(347959), // Rule ID 12240 //
     /* 347829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 347832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 347856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 347860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 347872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 347876 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 347881 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 347886 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347913 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 347916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 347923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 347928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 347933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 347938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 347943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 347948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347957 */     GIR_RootConstrainSelectedInstOperands,
     /* 347958 */     // GIR_Coverage, 12240,
     /* 347958 */     GIR_EraseRootFromParent_Done,
     /* 347959 */   // Label 5537: @347959
     /* 347959 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(348094), // Rule ID 12717 //
     /* 347964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 347967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 347971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 347991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 347995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348011 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348016 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348021 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348034 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348041 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348048 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 348051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 348058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 348063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 348068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 348073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348092 */     GIR_RootConstrainSelectedInstOperands,
     /* 348093 */     // GIR_Coverage, 12717,
     /* 348093 */     GIR_EraseRootFromParent_Done,
     /* 348094 */   // Label 5538: @348094
     /* 348094 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(348229), // Rule ID 12718 //
     /* 348099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 348102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 348106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348146 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348183 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 348186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 348193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 348198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 348203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 348208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348227 */     GIR_RootConstrainSelectedInstOperands,
     /* 348228 */     // GIR_Coverage, 12718,
     /* 348228 */     GIR_EraseRootFromParent_Done,
     /* 348229 */   // Label 5539: @348229
     /* 348229 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(348364), // Rule ID 12719 //
     /* 348234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 348237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 348241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348291 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348318 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 348321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 348328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 348333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 348338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 348343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348362 */     GIR_RootConstrainSelectedInstOperands,
     /* 348363 */     // GIR_Coverage, 12719,
     /* 348363 */     GIR_EraseRootFromParent_Done,
     /* 348364 */   // Label 5540: @348364
     /* 348364 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(348499), // Rule ID 12720 //
     /* 348369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 348372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 348376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348430 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348453 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 348456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 348463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 348468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 348473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 348478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348497 */     GIR_RootConstrainSelectedInstOperands,
     /* 348498 */     // GIR_Coverage, 12720,
     /* 348498 */     GIR_EraseRootFromParent_Done,
     /* 348499 */   // Label 5541: @348499
     /* 348499 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(348634), // Rule ID 13197 //
     /* 348504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 348507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 348511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348551 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348556 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348565 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348588 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 348591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 348598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 348603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 348608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 348613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348632 */     GIR_RootConstrainSelectedInstOperands,
     /* 348633 */     // GIR_Coverage, 13197,
     /* 348633 */     GIR_EraseRootFromParent_Done,
     /* 348634 */   // Label 5542: @348634
     /* 348634 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(348769), // Rule ID 13198 //
     /* 348639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 348642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 348646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348674 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348686 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348686 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348691 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348691 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348723 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 348726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 348733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 348738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 348743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 348748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348767 */     GIR_RootConstrainSelectedInstOperands,
     /* 348768 */     // GIR_Coverage, 13198,
     /* 348768 */     GIR_EraseRootFromParent_Done,
     /* 348769 */   // Label 5543: @348769
     /* 348769 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(348904), // Rule ID 13199 //
     /* 348774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 348777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 348781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348809 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348821 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348831 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348858 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 348861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 348868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 348873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 348878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 348883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 348888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 348893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348902 */     GIR_RootConstrainSelectedInstOperands,
     /* 348903 */     // GIR_Coverage, 13199,
     /* 348903 */     GIR_EraseRootFromParent_Done,
     /* 348904 */   // Label 5544: @348904
     /* 348904 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(349039), // Rule ID 13200 //
     /* 348909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 348912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 348916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 348952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 348956 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 348961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 348966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348993 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 348996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 349003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 349008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 349013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 349018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349037 */     GIR_RootConstrainSelectedInstOperands,
     /* 349038 */     // GIR_Coverage, 13200,
     /* 349038 */     GIR_EraseRootFromParent_Done,
     /* 349039 */   // Label 5545: @349039
     /* 349039 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(349174), // Rule ID 12177 //
     /* 349044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 349047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349091 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349128 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 349131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 349138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 349143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 349148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 349153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349172 */     GIR_RootConstrainSelectedInstOperands,
     /* 349173 */     // GIR_Coverage, 12177,
     /* 349173 */     GIR_EraseRootFromParent_Done,
     /* 349174 */   // Label 5546: @349174
     /* 349174 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(349309), // Rule ID 12178 //
     /* 349179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 349182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349231 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349236 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349263 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 349266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 349273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 349278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 349283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 349288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349307 */     GIR_RootConstrainSelectedInstOperands,
     /* 349308 */     // GIR_Coverage, 12178,
     /* 349308 */     GIR_EraseRootFromParent_Done,
     /* 349309 */   // Label 5547: @349309
     /* 349309 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(349444), // Rule ID 12179 //
     /* 349314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 349317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349361 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349366 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349371 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349398 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 349401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 349408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 349413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 349418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 349423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349442 */     GIR_RootConstrainSelectedInstOperands,
     /* 349443 */     // GIR_Coverage, 12179,
     /* 349443 */     GIR_EraseRootFromParent_Done,
     /* 349444 */   // Label 5548: @349444
     /* 349444 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(349579), // Rule ID 12180 //
     /* 349449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 349452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349496 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349496 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349506 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349533 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 349536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 349543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 349548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 349553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 349558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349577 */     GIR_RootConstrainSelectedInstOperands,
     /* 349578 */     // GIR_Coverage, 12180,
     /* 349578 */     GIR_EraseRootFromParent_Done,
     /* 349579 */   // Label 5549: @349579
     /* 349579 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(349714), // Rule ID 12657 //
     /* 349584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 349587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 349591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349631 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349636 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349668 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 349671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 349678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 349683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 349688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 349693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349712 */     GIR_RootConstrainSelectedInstOperands,
     /* 349713 */     // GIR_Coverage, 12657,
     /* 349713 */     GIR_EraseRootFromParent_Done,
     /* 349714 */   // Label 5550: @349714
     /* 349714 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(349849), // Rule ID 12658 //
     /* 349719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 349722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 349726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349766 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349803 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 349806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 349813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 349818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 349823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 349828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349847 */     GIR_RootConstrainSelectedInstOperands,
     /* 349848 */     // GIR_Coverage, 12658,
     /* 349848 */     GIR_EraseRootFromParent_Done,
     /* 349849 */   // Label 5551: @349849
     /* 349849 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(349984), // Rule ID 12659 //
     /* 349854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 349857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 349861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 349897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349901 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 349906 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 349911 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349938 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 349941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 349948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 349953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 349958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 349963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 349968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 349973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349982 */     GIR_RootConstrainSelectedInstOperands,
     /* 349983 */     // GIR_Coverage, 12659,
     /* 349983 */     GIR_EraseRootFromParent_Done,
     /* 349984 */   // Label 5552: @349984
     /* 349984 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(350119), // Rule ID 12660 //
     /* 349989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 349992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 349996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350036 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350041 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350041 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350046 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350066 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350073 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 350076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 350083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 350088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 350093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 350098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350117 */     GIR_RootConstrainSelectedInstOperands,
     /* 350118 */     // GIR_Coverage, 12660,
     /* 350118 */     GIR_EraseRootFromParent_Done,
     /* 350119 */   // Label 5553: @350119
     /* 350119 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(350254), // Rule ID 13137 //
     /* 350124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 350127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350159 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350171 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350171 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350176 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350176 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350181 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350185 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350201 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350208 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 350211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 350218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 350223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 350228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 350233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350252 */     GIR_RootConstrainSelectedInstOperands,
     /* 350253 */     // GIR_Coverage, 13137,
     /* 350253 */     GIR_EraseRootFromParent_Done,
     /* 350254 */   // Label 5554: @350254
     /* 350254 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(350389), // Rule ID 13138 //
     /* 350259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 350262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350306 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350311 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350343 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 350346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 350353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 350358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 350363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 350368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350387 */     GIR_RootConstrainSelectedInstOperands,
     /* 350388 */     // GIR_Coverage, 13138,
     /* 350388 */     GIR_EraseRootFromParent_Done,
     /* 350389 */   // Label 5555: @350389
     /* 350389 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(350524), // Rule ID 13139 //
     /* 350394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 350397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350441 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350446 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350451 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350478 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 350481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 350488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 350493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 350498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 350503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350522 */     GIR_RootConstrainSelectedInstOperands,
     /* 350523 */     // GIR_Coverage, 13139,
     /* 350523 */     GIR_EraseRootFromParent_Done,
     /* 350524 */   // Label 5556: @350524
     /* 350524 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(350659), // Rule ID 13140 //
     /* 350529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 350532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350581 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350586 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350590 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350613 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 350616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 350623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 350628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 350633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 350638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350657 */     GIR_RootConstrainSelectedInstOperands,
     /* 350658 */     // GIR_Coverage, 13140,
     /* 350658 */     GIR_EraseRootFromParent_Done,
     /* 350659 */   // Label 5557: @350659
     /* 350659 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(350794), // Rule ID 12222 //
     /* 350664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 350667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 350695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 350711 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350716 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350716 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350721 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350741 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350748 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 350751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 350758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 350763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 350768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 350773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350792 */     GIR_RootConstrainSelectedInstOperands,
     /* 350793 */     // GIR_Coverage, 12222,
     /* 350793 */     GIR_EraseRootFromParent_Done,
     /* 350794 */   // Label 5558: @350794
     /* 350794 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(350929), // Rule ID 12223 //
     /* 350799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 350802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 350830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 350846 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350851 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350856 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350860 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350883 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 350886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 350893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 350898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 350903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 350908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 350913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 350918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350927 */     GIR_RootConstrainSelectedInstOperands,
     /* 350928 */     // GIR_Coverage, 12223,
     /* 350928 */     GIR_EraseRootFromParent_Done,
     /* 350929 */   // Label 5559: @350929
     /* 350929 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(351064), // Rule ID 12224 //
     /* 350934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 350937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 350965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 350977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 350981 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350981 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 350986 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 350991 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351011 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351018 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 351021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 351028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 351033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 351038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 351043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351062 */     GIR_RootConstrainSelectedInstOperands,
     /* 351063 */     // GIR_Coverage, 12224,
     /* 351063 */     GIR_EraseRootFromParent_Done,
     /* 351064 */   // Label 5560: @351064
     /* 351064 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(351199), // Rule ID 12225 //
     /* 351069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 351072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 351076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351116 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351121 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351126 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351153 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 351156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 351163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 351168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 351173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 351178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351197 */     GIR_RootConstrainSelectedInstOperands,
     /* 351198 */     // GIR_Coverage, 12225,
     /* 351198 */     GIR_EraseRootFromParent_Done,
     /* 351199 */   // Label 5561: @351199
     /* 351199 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(351334), // Rule ID 12702 //
     /* 351204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 351207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 351211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351251 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351256 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351288 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 351291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 351298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 351303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 351308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 351313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351332 */     GIR_RootConstrainSelectedInstOperands,
     /* 351333 */     // GIR_Coverage, 12702,
     /* 351333 */     GIR_EraseRootFromParent_Done,
     /* 351334 */   // Label 5562: @351334
     /* 351334 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(351469), // Rule ID 12703 //
     /* 351339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 351342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 351346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351386 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351391 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351423 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 351426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 351433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 351438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 351443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 351448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351467 */     GIR_RootConstrainSelectedInstOperands,
     /* 351468 */     // GIR_Coverage, 12703,
     /* 351468 */     GIR_EraseRootFromParent_Done,
     /* 351469 */   // Label 5563: @351469
     /* 351469 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(351604), // Rule ID 12704 //
     /* 351474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 351477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 351481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351521 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351526 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351526 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351531 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351551 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351558 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 351561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 351568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 351573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 351578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 351583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351602 */     GIR_RootConstrainSelectedInstOperands,
     /* 351603 */     // GIR_Coverage, 12704,
     /* 351603 */     GIR_EraseRootFromParent_Done,
     /* 351604 */   // Label 5564: @351604
     /* 351604 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(351739), // Rule ID 12705 //
     /* 351609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 351612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 351616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351656 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351656 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351661 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351666 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351670 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351672 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351679 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351686 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351693 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 351696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 351703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 351708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 351713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 351718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351737 */     GIR_RootConstrainSelectedInstOperands,
     /* 351738 */     // GIR_Coverage, 12705,
     /* 351738 */     GIR_EraseRootFromParent_Done,
     /* 351739 */   // Label 5565: @351739
     /* 351739 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(351874), // Rule ID 13182 //
     /* 351744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 351747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 351751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351791 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351828 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 351831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 351838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 351843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 351848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 351853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351872 */     GIR_RootConstrainSelectedInstOperands,
     /* 351873 */     // GIR_Coverage, 13182,
     /* 351873 */     GIR_EraseRootFromParent_Done,
     /* 351874 */   // Label 5566: @351874
     /* 351874 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(352009), // Rule ID 13183 //
     /* 351879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 351882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 351886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351963 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 351966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 351973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 351978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 351983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 351988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352007 */     GIR_RootConstrainSelectedInstOperands,
     /* 352008 */     // GIR_Coverage, 13183,
     /* 352008 */     GIR_EraseRootFromParent_Done,
     /* 352009 */   // Label 5567: @352009
     /* 352009 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(352144), // Rule ID 13184 //
     /* 352014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 352017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352066 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352071 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352098 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 352101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 352108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 352113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 352118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 352123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352142 */     GIR_RootConstrainSelectedInstOperands,
     /* 352143 */     // GIR_Coverage, 13184,
     /* 352143 */     GIR_EraseRootFromParent_Done,
     /* 352144 */   // Label 5568: @352144
     /* 352144 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(352279), // Rule ID 13185 //
     /* 352149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 352152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352196 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352201 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352201 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352206 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352233 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 352236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 352243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 352248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 352253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 352258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352277 */     GIR_RootConstrainSelectedInstOperands,
     /* 352278 */     // GIR_Coverage, 13185,
     /* 352278 */     GIR_EraseRootFromParent_Done,
     /* 352279 */   // Label 5569: @352279
     /* 352279 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(352414), // Rule ID 12162 //
     /* 352284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 352287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352331 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352331 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352336 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352354 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352361 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352368 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 352371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 352378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 352383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 352388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 352393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352412 */     GIR_RootConstrainSelectedInstOperands,
     /* 352413 */     // GIR_Coverage, 12162,
     /* 352413 */     GIR_EraseRootFromParent_Done,
     /* 352414 */   // Label 5570: @352414
     /* 352414 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(352549), // Rule ID 12163 //
     /* 352419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 352422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352454 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352466 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352480 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352489 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352503 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 352506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 352513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 352518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 352523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 352528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352547 */     GIR_RootConstrainSelectedInstOperands,
     /* 352548 */     // GIR_Coverage, 12163,
     /* 352548 */     GIR_EraseRootFromParent_Done,
     /* 352549 */   // Label 5571: @352549
     /* 352549 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(352684), // Rule ID 12164 //
     /* 352554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 352557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352601 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352611 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352624 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352638 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 352641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 352648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 352653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 352658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 352663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352682 */     GIR_RootConstrainSelectedInstOperands,
     /* 352683 */     // GIR_Coverage, 12164,
     /* 352683 */     GIR_EraseRootFromParent_Done,
     /* 352684 */   // Label 5572: @352684
     /* 352684 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(352819), // Rule ID 12165 //
     /* 352689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 352692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352736 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352741 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352746 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352766 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352773 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 352776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 352783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 352788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 352793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 352798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352817 */     GIR_RootConstrainSelectedInstOperands,
     /* 352818 */     // GIR_Coverage, 12165,
     /* 352818 */     GIR_EraseRootFromParent_Done,
     /* 352819 */   // Label 5573: @352819
     /* 352819 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(352954), // Rule ID 12642 //
     /* 352824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 352827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 352831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352876 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352881 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352908 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 352911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 352918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 352923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 352928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 352933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352952 */     GIR_RootConstrainSelectedInstOperands,
     /* 352953 */     // GIR_Coverage, 12642,
     /* 352953 */     GIR_EraseRootFromParent_Done,
     /* 352954 */   // Label 5574: @352954
     /* 352954 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(353089), // Rule ID 12643 //
     /* 352959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 352962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 352966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 352990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353006 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353011 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353016 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353020 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353036 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353043 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 353046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 353053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 353058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 353063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 353068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353087 */     GIR_RootConstrainSelectedInstOperands,
     /* 353088 */     // GIR_Coverage, 12643,
     /* 353088 */     GIR_EraseRootFromParent_Done,
     /* 353089 */   // Label 5575: @353089
     /* 353089 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(353224), // Rule ID 12644 //
     /* 353094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 353097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 353101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353141 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353141 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353146 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353151 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353164 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353171 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353178 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 353181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 353188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 353193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 353198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 353203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353222 */     GIR_RootConstrainSelectedInstOperands,
     /* 353223 */     // GIR_Coverage, 12644,
     /* 353223 */     GIR_EraseRootFromParent_Done,
     /* 353224 */   // Label 5576: @353224
     /* 353224 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(353359), // Rule ID 12645 //
     /* 353229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 353232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 353236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353276 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353286 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353299 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353306 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353313 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 353316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 353323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 353328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 353333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 353338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353357 */     GIR_RootConstrainSelectedInstOperands,
     /* 353358 */     // GIR_Coverage, 12645,
     /* 353358 */     GIR_EraseRootFromParent_Done,
     /* 353359 */   // Label 5577: @353359
     /* 353359 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(353494), // Rule ID 13122 //
     /* 353364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 353367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353411 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353448 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 353451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 353458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 353463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 353468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 353473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353492 */     GIR_RootConstrainSelectedInstOperands,
     /* 353493 */     // GIR_Coverage, 13122,
     /* 353493 */     GIR_EraseRootFromParent_Done,
     /* 353494 */   // Label 5578: @353494
     /* 353494 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(353629), // Rule ID 13123 //
     /* 353499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 353502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353546 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353551 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353556 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353569 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353576 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353583 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 353586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 353593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 353598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 353603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 353608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353627 */     GIR_RootConstrainSelectedInstOperands,
     /* 353628 */     // GIR_Coverage, 13123,
     /* 353628 */     GIR_EraseRootFromParent_Done,
     /* 353629 */   // Label 5579: @353629
     /* 353629 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(353764), // Rule ID 13124 //
     /* 353634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 353637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353677 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353681 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353686 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353686 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353691 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353711 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353718 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 353721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 353728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 353733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 353738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 353743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353762 */     GIR_RootConstrainSelectedInstOperands,
     /* 353763 */     // GIR_Coverage, 13124,
     /* 353763 */     GIR_EraseRootFromParent_Done,
     /* 353764 */   // Label 5580: @353764
     /* 353764 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(353899), // Rule ID 13125 //
     /* 353769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 353772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 353800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353816 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353816 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353821 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353826 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353853 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 353856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 353863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 353868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 353873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 353878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353897 */     GIR_RootConstrainSelectedInstOperands,
     /* 353898 */     // GIR_Coverage, 13125,
     /* 353898 */     GIR_EraseRootFromParent_Done,
     /* 353899 */   // Label 5581: @353899
     /* 353899 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(354034), // Rule ID 12233 //
     /* 353904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 353907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 353931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 353935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 353951 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353956 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353961 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353974 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353988 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 353991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 353998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 354003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 354008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 354013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354032 */     GIR_RootConstrainSelectedInstOperands,
     /* 354033 */     // GIR_Coverage, 12233,
     /* 354033 */     GIR_EraseRootFromParent_Done,
     /* 354034 */   // Label 5582: @354034
     /* 354034 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(354169), // Rule ID 12234 //
     /* 354039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 354042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 354046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 354086 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354091 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354096 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354123 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 354126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 354133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 354138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 354143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 354148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354167 */     GIR_RootConstrainSelectedInstOperands,
     /* 354168 */     // GIR_Coverage, 12234,
     /* 354168 */     GIR_EraseRootFromParent_Done,
     /* 354169 */   // Label 5583: @354169
     /* 354169 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(354304), // Rule ID 12235 //
     /* 354174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 354177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 354181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 354221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354258 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 354261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 354268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 354273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 354278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 354283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354302 */     GIR_RootConstrainSelectedInstOperands,
     /* 354303 */     // GIR_Coverage, 12235,
     /* 354303 */     GIR_EraseRootFromParent_Done,
     /* 354304 */   // Label 5584: @354304
     /* 354304 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(354439), // Rule ID 12236 //
     /* 354309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 354312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 354316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 354356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354361 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354366 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354393 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 354396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 354403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 354408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 354413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 354418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354437 */     GIR_RootConstrainSelectedInstOperands,
     /* 354438 */     // GIR_Coverage, 12236,
     /* 354438 */     GIR_EraseRootFromParent_Done,
     /* 354439 */   // Label 5585: @354439
     /* 354439 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(354574), // Rule ID 12713 //
     /* 354444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 354447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 354451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 354491 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354496 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354496 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354501 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354505 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354521 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354528 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 354531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 354538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 354543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 354548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 354553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354572 */     GIR_RootConstrainSelectedInstOperands,
     /* 354573 */     // GIR_Coverage, 12713,
     /* 354573 */     GIR_EraseRootFromParent_Done,
     /* 354574 */   // Label 5586: @354574
     /* 354574 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(354709), // Rule ID 12714 //
     /* 354579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 354582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 354586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 354626 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354626 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354631 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354649 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354656 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354663 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 354666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 354673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 354678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 354683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 354688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354707 */     GIR_RootConstrainSelectedInstOperands,
     /* 354708 */     // GIR_Coverage, 12714,
     /* 354708 */     GIR_EraseRootFromParent_Done,
     /* 354709 */   // Label 5587: @354709
     /* 354709 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(354844), // Rule ID 12715 //
     /* 354714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 354717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 354721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 354761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354766 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354771 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354798 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 354801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 354808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 354813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 354818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 354823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354842 */     GIR_RootConstrainSelectedInstOperands,
     /* 354843 */     // GIR_Coverage, 12715,
     /* 354843 */     GIR_EraseRootFromParent_Done,
     /* 354844 */   // Label 5588: @354844
     /* 354844 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(354979), // Rule ID 12716 //
     /* 354849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 354852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 354856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 354896 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354901 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354910 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354919 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354926 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354933 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 354936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 354943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 354948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 354953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 354958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 354963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 354968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354977 */     GIR_RootConstrainSelectedInstOperands,
     /* 354978 */     // GIR_Coverage, 12716,
     /* 354978 */     GIR_EraseRootFromParent_Done,
     /* 354979 */   // Label 5589: @354979
     /* 354979 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(355114), // Rule ID 13193 //
     /* 354984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 354987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 354991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355031 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355036 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355061 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355068 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 355071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 355078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 355083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 355088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 355093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355112 */     GIR_RootConstrainSelectedInstOperands,
     /* 355113 */     // GIR_Coverage, 13193,
     /* 355113 */     GIR_EraseRootFromParent_Done,
     /* 355114 */   // Label 5590: @355114
     /* 355114 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(355249), // Rule ID 13194 //
     /* 355119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 355122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355166 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355171 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355171 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355176 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355189 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355196 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355203 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 355206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 355213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 355218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 355223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 355228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355247 */     GIR_RootConstrainSelectedInstOperands,
     /* 355248 */     // GIR_Coverage, 13194,
     /* 355248 */     GIR_EraseRootFromParent_Done,
     /* 355249 */   // Label 5591: @355249
     /* 355249 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(355384), // Rule ID 13195 //
     /* 355254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 355257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355301 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355306 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355311 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355331 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355338 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 355341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 355348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 355353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 355358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 355363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355382 */     GIR_RootConstrainSelectedInstOperands,
     /* 355383 */     // GIR_Coverage, 13195,
     /* 355383 */     GIR_EraseRootFromParent_Done,
     /* 355384 */   // Label 5592: @355384
     /* 355384 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(355519), // Rule ID 13196 //
     /* 355389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 355392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355436 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355441 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355473 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 355476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 355483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 355488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 355493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 355498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355517 */     GIR_RootConstrainSelectedInstOperands,
     /* 355518 */     // GIR_Coverage, 13196,
     /* 355518 */     GIR_EraseRootFromParent_Done,
     /* 355519 */   // Label 5593: @355519
     /* 355519 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(355654), // Rule ID 12173 //
     /* 355524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 355527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355571 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355601 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355608 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 355611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 355618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 355623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 355628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 355633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355652 */     GIR_RootConstrainSelectedInstOperands,
     /* 355653 */     // GIR_Coverage, 12173,
     /* 355653 */     GIR_EraseRootFromParent_Done,
     /* 355654 */   // Label 5594: @355654
     /* 355654 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(355789), // Rule ID 12174 //
     /* 355659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 355662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355706 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355711 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355736 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355743 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 355746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 355753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 355758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 355763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 355768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355787 */     GIR_RootConstrainSelectedInstOperands,
     /* 355788 */     // GIR_Coverage, 12174,
     /* 355788 */     GIR_EraseRootFromParent_Done,
     /* 355789 */   // Label 5595: @355789
     /* 355789 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(355924), // Rule ID 12175 //
     /* 355794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 355797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355841 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355846 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355871 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355878 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 355881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 355888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 355893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 355898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 355903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 355908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 355913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355922 */     GIR_RootConstrainSelectedInstOperands,
     /* 355923 */     // GIR_Coverage, 12175,
     /* 355923 */     GIR_EraseRootFromParent_Done,
     /* 355924 */   // Label 5596: @355924
     /* 355924 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(356059), // Rule ID 12176 //
     /* 355929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 355932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 355960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355976 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355976 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355981 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355981 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355986 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356006 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356013 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 356016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 356023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 356028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 356033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 356038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356057 */     GIR_RootConstrainSelectedInstOperands,
     /* 356058 */     // GIR_Coverage, 12176,
     /* 356058 */     GIR_EraseRootFromParent_Done,
     /* 356059 */   // Label 5597: @356059
     /* 356059 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(356194), // Rule ID 12653 //
     /* 356064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 356067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 356071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356111 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356111 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356116 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356134 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356141 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356148 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 356151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 356158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 356163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 356168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 356173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356192 */     GIR_RootConstrainSelectedInstOperands,
     /* 356193 */     // GIR_Coverage, 12653,
     /* 356193 */     GIR_EraseRootFromParent_Done,
     /* 356194 */   // Label 5598: @356194
     /* 356194 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(356329), // Rule ID 12654 //
     /* 356199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 356202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 356206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356246 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356251 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356256 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356269 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356283 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 356286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 356293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 356298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 356303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 356308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356327 */     GIR_RootConstrainSelectedInstOperands,
     /* 356328 */     // GIR_Coverage, 12654,
     /* 356328 */     GIR_EraseRootFromParent_Done,
     /* 356329 */   // Label 5599: @356329
     /* 356329 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(356464), // Rule ID 12655 //
     /* 356334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 356337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 356341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356381 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356386 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356411 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356418 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 356421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 356428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 356433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 356438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 356443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356462 */     GIR_RootConstrainSelectedInstOperands,
     /* 356463 */     // GIR_Coverage, 12655,
     /* 356463 */     GIR_EraseRootFromParent_Done,
     /* 356464 */   // Label 5600: @356464
     /* 356464 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(356599), // Rule ID 12656 //
     /* 356469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 356472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 356476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356516 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356521 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356553 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 356556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 356563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 356568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 356573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 356578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356597 */     GIR_RootConstrainSelectedInstOperands,
     /* 356598 */     // GIR_Coverage, 12656,
     /* 356598 */     GIR_EraseRootFromParent_Done,
     /* 356599 */   // Label 5601: @356599
     /* 356599 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(356734), // Rule ID 13133 //
     /* 356604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 356607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 356611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356651 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356656 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356656 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356661 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356688 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 356691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 356698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 356703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 356708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 356713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356732 */     GIR_RootConstrainSelectedInstOperands,
     /* 356733 */     // GIR_Coverage, 13133,
     /* 356733 */     GIR_EraseRootFromParent_Done,
     /* 356734 */   // Label 5602: @356734
     /* 356734 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(356869), // Rule ID 13134 //
     /* 356739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 356742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 356746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356786 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356786 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356791 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356796 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356800 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356816 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356823 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 356826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 356833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 356838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 356843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 356848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356867 */     GIR_RootConstrainSelectedInstOperands,
     /* 356868 */     // GIR_Coverage, 13134,
     /* 356868 */     GIR_EraseRootFromParent_Done,
     /* 356869 */   // Label 5603: @356869
     /* 356869 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(357004), // Rule ID 13135 //
     /* 356874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 356877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 356881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 356901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 356905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356921 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356931 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356951 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356958 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 356961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 356968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 356973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 356978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 356983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 356988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 356993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357002 */     GIR_RootConstrainSelectedInstOperands,
     /* 357003 */     // GIR_Coverage, 13135,
     /* 357003 */     GIR_EraseRootFromParent_Done,
     /* 357004 */   // Label 5604: @357004
     /* 357004 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(357139), // Rule ID 13136 //
     /* 357009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 357012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 357040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357056 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357093 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 357096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 357103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 357108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 357113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 357118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357137 */     GIR_RootConstrainSelectedInstOperands,
     /* 357138 */     // GIR_Coverage, 13136,
     /* 357138 */     GIR_EraseRootFromParent_Done,
     /* 357139 */   // Label 5605: @357139
     /* 357139 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(357274), // Rule ID 12218 //
     /* 357144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 357147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 357191 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357196 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357221 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357228 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 357231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 357238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 357243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 357248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 357253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357272 */     GIR_RootConstrainSelectedInstOperands,
     /* 357273 */     // GIR_Coverage, 12218,
     /* 357273 */     GIR_EraseRootFromParent_Done,
     /* 357274 */   // Label 5606: @357274
     /* 357274 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(357409), // Rule ID 12219 //
     /* 357279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 357282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 357326 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357331 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357331 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357336 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357340 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357356 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357363 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 357366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 357373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 357378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 357383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 357388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357407 */     GIR_RootConstrainSelectedInstOperands,
     /* 357408 */     // GIR_Coverage, 12219,
     /* 357408 */     GIR_EraseRootFromParent_Done,
     /* 357409 */   // Label 5607: @357409
     /* 357409 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(357544), // Rule ID 12220 //
     /* 357414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 357417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 357461 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357461 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357466 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357471 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357484 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357491 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357498 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 357501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 357508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 357513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 357518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 357523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357542 */     GIR_RootConstrainSelectedInstOperands,
     /* 357543 */     // GIR_Coverage, 12220,
     /* 357543 */     GIR_EraseRootFromParent_Done,
     /* 357544 */   // Label 5608: @357544
     /* 357544 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(357679), // Rule ID 12221 //
     /* 357549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 357552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 357596 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357601 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357606 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357619 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357633 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 357636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 357643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 357648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 357653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 357658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357677 */     GIR_RootConstrainSelectedInstOperands,
     /* 357678 */     // GIR_Coverage, 12221,
     /* 357678 */     GIR_EraseRootFromParent_Done,
     /* 357679 */   // Label 5609: @357679
     /* 357679 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(357814), // Rule ID 12698 //
     /* 357684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 357687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 357691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 357731 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357736 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357768 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 357771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 357778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 357783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 357788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 357793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357812 */     GIR_RootConstrainSelectedInstOperands,
     /* 357813 */     // GIR_Coverage, 12698,
     /* 357813 */     GIR_EraseRootFromParent_Done,
     /* 357814 */   // Label 5610: @357814
     /* 357814 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(357949), // Rule ID 12699 //
     /* 357819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 357822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 357826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 357866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357896 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357903 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 357906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 357913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 357918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 357923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 357928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 357933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 357938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357947 */     GIR_RootConstrainSelectedInstOperands,
     /* 357948 */     // GIR_Coverage, 12699,
     /* 357948 */     GIR_EraseRootFromParent_Done,
     /* 357949 */   // Label 5611: @357949
     /* 357949 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(358084), // Rule ID 12700 //
     /* 357954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 357957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 357961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 357981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358001 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358006 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358011 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358031 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358038 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 358041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 358048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 358053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 358058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 358063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358082 */     GIR_RootConstrainSelectedInstOperands,
     /* 358083 */     // GIR_Coverage, 12700,
     /* 358083 */     GIR_EraseRootFromParent_Done,
     /* 358084 */   // Label 5612: @358084
     /* 358084 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(358219), // Rule ID 12701 //
     /* 358089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 358092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 358096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358136 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358141 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358141 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358159 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358166 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358173 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 358176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 358183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 358188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 358193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 358198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358217 */     GIR_RootConstrainSelectedInstOperands,
     /* 358218 */     // GIR_Coverage, 12701,
     /* 358218 */     GIR_EraseRootFromParent_Done,
     /* 358219 */   // Label 5613: @358219
     /* 358219 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(358354), // Rule ID 13178 //
     /* 358224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 358227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358271 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358276 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358285 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358294 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358308 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 358311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 358318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 358323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 358328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 358333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358352 */     GIR_RootConstrainSelectedInstOperands,
     /* 358353 */     // GIR_Coverage, 13178,
     /* 358353 */     GIR_EraseRootFromParent_Done,
     /* 358354 */   // Label 5614: @358354
     /* 358354 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(358489), // Rule ID 13179 //
     /* 358359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 358362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358411 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358416 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358429 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358443 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 358446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 358453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 358458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 358463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 358468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358487 */     GIR_RootConstrainSelectedInstOperands,
     /* 358488 */     // GIR_Coverage, 13179,
     /* 358488 */     GIR_EraseRootFromParent_Done,
     /* 358489 */   // Label 5615: @358489
     /* 358489 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(358624), // Rule ID 13180 //
     /* 358494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 358497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358541 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358546 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358578 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 358581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 358588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 358593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 358598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 358603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358622 */     GIR_RootConstrainSelectedInstOperands,
     /* 358623 */     // GIR_Coverage, 13180,
     /* 358623 */     GIR_EraseRootFromParent_Done,
     /* 358624 */   // Label 5616: @358624
     /* 358624 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(358759), // Rule ID 13181 //
     /* 358629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 358632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358676 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358681 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358686 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358706 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358713 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 358716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 358723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 358728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 358733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 358738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358757 */     GIR_RootConstrainSelectedInstOperands,
     /* 358758 */     // GIR_Coverage, 13181,
     /* 358758 */     GIR_EraseRootFromParent_Done,
     /* 358759 */   // Label 5617: @358759
     /* 358759 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(358894), // Rule ID 12158 //
     /* 358764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 358767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358811 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358816 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358816 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358834 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358841 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358848 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 358851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 358858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 358863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 358868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 358873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358892 */     GIR_RootConstrainSelectedInstOperands,
     /* 358893 */     // GIR_Coverage, 12158,
     /* 358893 */     GIR_EraseRootFromParent_Done,
     /* 358894 */   // Label 5618: @358894
     /* 358894 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(359029), // Rule ID 12159 //
     /* 358899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 358902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358946 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358951 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358969 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358983 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 358986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 358993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 358998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 359003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 359008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359027 */     GIR_RootConstrainSelectedInstOperands,
     /* 359028 */     // GIR_Coverage, 12159,
     /* 359028 */     GIR_EraseRootFromParent_Done,
     /* 359029 */   // Label 5619: @359029
     /* 359029 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(359164), // Rule ID 12160 //
     /* 359034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 359037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 359041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359081 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359086 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359111 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359118 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 359121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 359128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 359133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 359138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 359143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359162 */     GIR_RootConstrainSelectedInstOperands,
     /* 359163 */     // GIR_Coverage, 12160,
     /* 359163 */     GIR_EraseRootFromParent_Done,
     /* 359164 */   // Label 5620: @359164
     /* 359164 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(359299), // Rule ID 12161 //
     /* 359169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 359172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 359176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359216 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359246 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359253 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 359256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 359263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 359268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 359273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 359278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359297 */     GIR_RootConstrainSelectedInstOperands,
     /* 359298 */     // GIR_Coverage, 12161,
     /* 359298 */     GIR_EraseRootFromParent_Done,
     /* 359299 */   // Label 5621: @359299
     /* 359299 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(359434), // Rule ID 12638 //
     /* 359304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 359307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 359311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359374 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359381 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359388 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 359391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 359398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 359403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 359408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 359413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359432 */     GIR_RootConstrainSelectedInstOperands,
     /* 359433 */     // GIR_Coverage, 12638,
     /* 359433 */     GIR_EraseRootFromParent_Done,
     /* 359434 */   // Label 5622: @359434
     /* 359434 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(359569), // Rule ID 12639 //
     /* 359439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 359442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 359446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359491 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359516 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359523 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 359526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 359533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 359538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 359543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 359548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359567 */     GIR_RootConstrainSelectedInstOperands,
     /* 359568 */     // GIR_Coverage, 12639,
     /* 359568 */     GIR_EraseRootFromParent_Done,
     /* 359569 */   // Label 5623: @359569
     /* 359569 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(359704), // Rule ID 12640 //
     /* 359574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 359577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 359581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359621 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359621 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359626 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359626 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359631 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359658 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 359661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 359668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 359673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 359678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 359683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359702 */     GIR_RootConstrainSelectedInstOperands,
     /* 359703 */     // GIR_Coverage, 12640,
     /* 359703 */     GIR_EraseRootFromParent_Done,
     /* 359704 */   // Label 5624: @359704
     /* 359704 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(359839), // Rule ID 12641 //
     /* 359709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 359712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 359716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359756 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359766 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359779 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359793 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 359796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 359803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 359808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 359813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 359818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359837 */     GIR_RootConstrainSelectedInstOperands,
     /* 359838 */     // GIR_Coverage, 12641,
     /* 359838 */     GIR_EraseRootFromParent_Done,
     /* 359839 */   // Label 5625: @359839
     /* 359839 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(359974), // Rule ID 13118 //
     /* 359844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 359847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 359851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 359875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359891 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359896 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359928 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 359931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 359938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 359943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 359948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 359953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359972 */     GIR_RootConstrainSelectedInstOperands,
     /* 359973 */     // GIR_Coverage, 13118,
     /* 359973 */     GIR_EraseRootFromParent_Done,
     /* 359974 */   // Label 5626: @359974
     /* 359974 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(360109), // Rule ID 13119 //
     /* 359979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 359982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 359986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 360010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360026 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360031 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360049 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360063 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 360066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 360073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 360078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 360083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 360088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360107 */     GIR_RootConstrainSelectedInstOperands,
     /* 360108 */     // GIR_Coverage, 13119,
     /* 360108 */     GIR_EraseRootFromParent_Done,
     /* 360109 */   // Label 5627: @360109
     /* 360109 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(360244), // Rule ID 13120 //
     /* 360114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 360117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 360121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 360145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360166 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360171 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360191 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360198 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 360201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 360218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 360223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360242 */     GIR_RootConstrainSelectedInstOperands,
     /* 360243 */     // GIR_Coverage, 13120,
     /* 360243 */     GIR_EraseRootFromParent_Done,
     /* 360244 */   // Label 5628: @360244
     /* 360244 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(360379), // Rule ID 13121 //
     /* 360249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 360252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 360256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 360280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360296 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360301 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360306 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360326 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360333 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 360336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 360353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 360358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360377 */     GIR_RootConstrainSelectedInstOperands,
     /* 360378 */     // GIR_Coverage, 13121,
     /* 360378 */     GIR_EraseRootFromParent_Done,
     /* 360379 */   // Label 5629: @360379
     /* 360379 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(360494), // Rule ID 13266 //
     /* 360384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 360387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 360391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 360399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 360411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360419 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 360421 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 360425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360448 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 360451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 360468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 360473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 360478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 360483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360492 */     GIR_RootConstrainSelectedInstOperands,
     /* 360493 */     // GIR_Coverage, 13266,
     /* 360493 */     GIR_EraseRootFromParent_Done,
     /* 360494 */   // Label 5630: @360494
     /* 360494 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(360609), // Rule ID 13282 //
     /* 360499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 360502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 360506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 360514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 360526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360534 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 360536 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 360540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360563 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 360566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 360583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 360588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 360593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 360598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360607 */     GIR_RootConstrainSelectedInstOperands,
     /* 360608 */     // GIR_Coverage, 13282,
     /* 360608 */     GIR_EraseRootFromParent_Done,
     /* 360609 */   // Label 5631: @360609
     /* 360609 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(360724), // Rule ID 13265 //
     /* 360614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 360617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 360621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 360629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360649 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 360651 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 360655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360678 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 360681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 360698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 360703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 360708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 360713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360722 */     GIR_RootConstrainSelectedInstOperands,
     /* 360723 */     // GIR_Coverage, 13265,
     /* 360723 */     GIR_EraseRootFromParent_Done,
     /* 360724 */   // Label 5632: @360724
     /* 360724 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(360839), // Rule ID 13281 //
     /* 360729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 360732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 360736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 360744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360764 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 360766 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 360770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360779 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360793 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 360796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 360813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 360818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 360823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 360828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360837 */     GIR_RootConstrainSelectedInstOperands,
     /* 360838 */     // GIR_Coverage, 13281,
     /* 360838 */     GIR_EraseRootFromParent_Done,
     /* 360839 */   // Label 5633: @360839
     /* 360839 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(360954), // Rule ID 7740 //
     /* 360844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 360847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 360851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 360859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 360871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360879 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 360881 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 360885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360908 */     // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 360911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 360918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 360923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 360928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 360933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360952 */     GIR_RootConstrainSelectedInstOperands,
     /* 360953 */     // GIR_Coverage, 7740,
     /* 360953 */     GIR_EraseRootFromParent_Done,
     /* 360954 */   // Label 5634: @360954
     /* 360954 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(361069), // Rule ID 7756 //
     /* 360959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 360962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 360966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 360974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 360986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360994 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 360996 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 361000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361023 */     // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 361026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361067 */     GIR_RootConstrainSelectedInstOperands,
     /* 361068 */     // GIR_Coverage, 7756,
     /* 361068 */     GIR_EraseRootFromParent_Done,
     /* 361069 */   // Label 5635: @361069
     /* 361069 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(361184), // Rule ID 7739 //
     /* 361074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 361077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 361081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 361089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361109 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 361111 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 361115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361138 */     // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 361141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361182 */     GIR_RootConstrainSelectedInstOperands,
     /* 361183 */     // GIR_Coverage, 7739,
     /* 361183 */     GIR_EraseRootFromParent_Done,
     /* 361184 */   // Label 5636: @361184
     /* 361184 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(361299), // Rule ID 7755 //
     /* 361189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 361192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 361204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361224 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 361226 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 361230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361246 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361253 */     // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 361256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361297 */     GIR_RootConstrainSelectedInstOperands,
     /* 361298 */     // GIR_Coverage, 7755,
     /* 361298 */     GIR_EraseRootFromParent_Done,
     /* 361299 */   // Label 5637: @361299
     /* 361299 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(361398), // Rule ID 13258 //
     /* 361304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 361307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 361311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 361319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361327 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 361329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361352 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 361355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 361362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 361367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 361372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 361377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 361382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 361387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361396 */     GIR_RootConstrainSelectedInstOperands,
     /* 361397 */     // GIR_Coverage, 13258,
     /* 361397 */     GIR_EraseRootFromParent_Done,
     /* 361398 */   // Label 5638: @361398
     /* 361398 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(361497), // Rule ID 13274 //
     /* 361403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 361406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 361418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361426 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 361428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361451 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 361454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 361461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 361466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 361471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 361476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 361481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 361486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361495 */     GIR_RootConstrainSelectedInstOperands,
     /* 361496 */     // GIR_Coverage, 13274,
     /* 361496 */     GIR_EraseRootFromParent_Done,
     /* 361497 */   // Label 5639: @361497
     /* 361497 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(361596), // Rule ID 13257 //
     /* 361502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 361505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 361509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361525 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 361527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361550 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 361553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 361560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 361565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 361570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 361575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 361580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 361585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361594 */     GIR_RootConstrainSelectedInstOperands,
     /* 361595 */     // GIR_Coverage, 13257,
     /* 361595 */     GIR_EraseRootFromParent_Done,
     /* 361596 */   // Label 5640: @361596
     /* 361596 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(361695), // Rule ID 13273 //
     /* 361601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 361604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361624 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 361626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361635 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361649 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 361652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 361659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 361664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 361669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 361674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 361679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 361684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361693 */     GIR_RootConstrainSelectedInstOperands,
     /* 361694 */     // GIR_Coverage, 13273,
     /* 361694 */     GIR_EraseRootFromParent_Done,
     /* 361695 */   // Label 5641: @361695
     /* 361695 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(361794), // Rule ID 7732 //
     /* 361700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 361703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 361707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 361715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361723 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 361725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361734 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361748 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 361751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361792 */     GIR_RootConstrainSelectedInstOperands,
     /* 361793 */     // GIR_Coverage, 7732,
     /* 361793 */     GIR_EraseRootFromParent_Done,
     /* 361794 */   // Label 5642: @361794
     /* 361794 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(361893), // Rule ID 7748 //
     /* 361799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 361802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 361814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361822 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 361824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361847 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 361850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361891 */     GIR_RootConstrainSelectedInstOperands,
     /* 361892 */     // GIR_Coverage, 7748,
     /* 361892 */     GIR_EraseRootFromParent_Done,
     /* 361893 */   // Label 5643: @361893
     /* 361893 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(361992), // Rule ID 7731 //
     /* 361898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 361901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 361905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361921 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 361923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361946 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 361949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361990 */     GIR_RootConstrainSelectedInstOperands,
     /* 361991 */     // GIR_Coverage, 7731,
     /* 361991 */     GIR_EraseRootFromParent_Done,
     /* 361992 */   // Label 5644: @361992
     /* 361992 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(362091), // Rule ID 7747 //
     /* 361997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 362000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 362012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 362016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 362020 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 362022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362045 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 362048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 362055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 362065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362089 */     GIR_RootConstrainSelectedInstOperands,
     /* 362090 */     // GIR_Coverage, 7747,
     /* 362090 */     GIR_EraseRootFromParent_Done,
     /* 362091 */   // Label 5645: @362091
     /* 362091 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(362126), // Rule ID 101 //
     /* 362096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 362099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 362103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 362107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 362111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13798),
     /* 362115 */     // (fminnum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13798>>  =>  (S_MIN_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 362115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F16),
     /* 362120 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 362124 */     GIR_RootConstrainSelectedInstOperands,
     /* 362125 */     // GIR_Coverage, 101,
     /* 362125 */     GIR_Done,
     /* 362126 */   // Label 5646: @362126
     /* 362126 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(362189), // Rule ID 886 //
     /* 362131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 362134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 362145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362152 */     // (fminnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 362152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
     /* 362155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 362162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 362172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 362182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 362187 */     GIR_RootConstrainSelectedInstOperands,
     /* 362188 */     // GIR_Coverage, 886,
     /* 362188 */     GIR_EraseRootFromParent_Done,
     /* 362189 */   // Label 5647: @362189
     /* 362189 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(362252), // Rule ID 890 //
     /* 362194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 362197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 362208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362215 */     // (fminnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 362215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
     /* 362218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 362225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 362235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 362245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 362250 */     GIR_RootConstrainSelectedInstOperands,
     /* 362251 */     // GIR_Coverage, 890,
     /* 362251 */     GIR_EraseRootFromParent_Done,
     /* 362252 */   // Label 5648: @362252
     /* 362252 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(362315), // Rule ID 8433 //
     /* 362257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 362260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 362278 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 362278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
     /* 362281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 362288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 362293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 362298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 362303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 362308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 362313 */     GIR_RootConstrainSelectedInstOperands,
     /* 362314 */     // GIR_Coverage, 8433,
     /* 362314 */     GIR_EraseRootFromParent_Done,
     /* 362315 */   // Label 5649: @362315
     /* 362315 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(362378), // Rule ID 8435 //
     /* 362320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 362323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 362341 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 362341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
     /* 362344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 362351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 362356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 362361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 362366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 362371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 362376 */     GIR_RootConstrainSelectedInstOperands,
     /* 362377 */     // GIR_Coverage, 8435,
     /* 362377 */     GIR_EraseRootFromParent_Done,
     /* 362378 */   // Label 5650: @362378
     /* 362378 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(362440), // Rule ID 888 //
     /* 362383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 362386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 362390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 362397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 362404 */     // (fminnum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 362404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_t16_e64),
     /* 362407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 362414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 362424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362438 */     GIR_RootConstrainSelectedInstOperands,
     /* 362439 */     // GIR_Coverage, 888,
     /* 362439 */     GIR_EraseRootFromParent_Done,
     /* 362440 */   // Label 5651: @362440
     /* 362440 */   GIM_Reject,
     /* 362441 */ // Label 5245: @362441
     /* 362441 */ GIM_Reject,
     /* 362442 */ // Label 5241: @362442
     /* 362442 */ GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(379953),
     /* 362447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 362450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362453 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(362582), // Rule ID 11747 //
     /* 362458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 362474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 362478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 362490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 362494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 362502 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362502 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 362507 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 362512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362539 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 362542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 362549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 362559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362580 */     GIR_RootConstrainSelectedInstOperands,
     /* 362581 */     // GIR_Coverage, 11747,
     /* 362581 */     GIR_EraseRootFromParent_Done,
     /* 362582 */   // Label 5653: @362582
     /* 362582 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(362711), // Rule ID 11748 //
     /* 362587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 362603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 362607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 362619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 362623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 362631 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 362636 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 362641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362668 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 362671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 362678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 362688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362709 */     GIR_RootConstrainSelectedInstOperands,
     /* 362710 */     // GIR_Coverage, 11748,
     /* 362710 */     GIR_EraseRootFromParent_Done,
     /* 362711 */   // Label 5654: @362711
     /* 362711 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(362840), // Rule ID 11751 //
     /* 362716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 362732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 362736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 362748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 362752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 362760 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362760 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 362765 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 362770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362790 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362797 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 362800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 362807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 362812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 362817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 362822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362838 */     GIR_RootConstrainSelectedInstOperands,
     /* 362839 */     // GIR_Coverage, 11751,
     /* 362839 */     GIR_EraseRootFromParent_Done,
     /* 362840 */   // Label 5655: @362840
     /* 362840 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(362969), // Rule ID 11752 //
     /* 362845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 362861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 362865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 362877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 362881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 362889 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 362894 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 362899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362919 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362926 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 362929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 362936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 362941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 362946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 362951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362967 */     GIR_RootConstrainSelectedInstOperands,
     /* 362968 */     // GIR_Coverage, 11752,
     /* 362968 */     GIR_EraseRootFromParent_Done,
     /* 362969 */   // Label 5656: @362969
     /* 362969 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(363098), // Rule ID 11732 //
     /* 362974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 362990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 362994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 363014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363018 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363018 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363023 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363055 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 363065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 363070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 363075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 363080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363096 */     GIR_RootConstrainSelectedInstOperands,
     /* 363097 */     // GIR_Coverage, 11732,
     /* 363097 */     GIR_EraseRootFromParent_Done,
     /* 363098 */   // Label 5657: @363098
     /* 363098 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(363227), // Rule ID 11733 //
     /* 363103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 363143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363147 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363152 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363157 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363184 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 363194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 363199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 363204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 363209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363225 */     GIR_RootConstrainSelectedInstOperands,
     /* 363226 */     // GIR_Coverage, 11733,
     /* 363226 */     GIR_EraseRootFromParent_Done,
     /* 363227 */   // Label 5658: @363227
     /* 363227 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(363356), // Rule ID 11736 //
     /* 363232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 363272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363276 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363281 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363286 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363306 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363313 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 363323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 363328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 363333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 363338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363354 */     GIR_RootConstrainSelectedInstOperands,
     /* 363355 */     // GIR_Coverage, 11736,
     /* 363355 */     GIR_EraseRootFromParent_Done,
     /* 363356 */   // Label 5659: @363356
     /* 363356 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(363485), // Rule ID 11737 //
     /* 363361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 363401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363405 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363405 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363410 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363435 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363442 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 363452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 363457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 363462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 363467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363483 */     GIR_RootConstrainSelectedInstOperands,
     /* 363484 */     // GIR_Coverage, 11737,
     /* 363484 */     GIR_EraseRootFromParent_Done,
     /* 363485 */   // Label 5660: @363485
     /* 363485 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(363614), // Rule ID 7606 //
     /* 363490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 363530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 363534 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363539 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363544 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363571 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 363581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 363586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 363591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 363596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363612 */     GIR_RootConstrainSelectedInstOperands,
     /* 363613 */     // GIR_Coverage, 7606,
     /* 363613 */     GIR_EraseRootFromParent_Done,
     /* 363614 */   // Label 5661: @363614
     /* 363614 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(363743), // Rule ID 11746 //
     /* 363619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 363659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 363663 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363663 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363668 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363673 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363700 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 363710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 363715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 363720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 363725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363741 */     GIR_RootConstrainSelectedInstOperands,
     /* 363742 */     // GIR_Coverage, 11746,
     /* 363742 */     GIR_EraseRootFromParent_Done,
     /* 363743 */   // Label 5662: @363743
     /* 363743 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(363872), // Rule ID 11749 //
     /* 363748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 363788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 363792 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363797 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363802 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363822 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363829 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 363839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 363844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 363849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 363854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363870 */     GIR_RootConstrainSelectedInstOperands,
     /* 363871 */     // GIR_Coverage, 11749,
     /* 363871 */     GIR_EraseRootFromParent_Done,
     /* 363872 */   // Label 5663: @363872
     /* 363872 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(364001), // Rule ID 11750 //
     /* 363877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 363897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 363909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 363913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 363917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 363921 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 363926 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 363931 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363951 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363958 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 363961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 363968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 363973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 363978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 363983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363999 */     GIR_RootConstrainSelectedInstOperands,
     /* 364000 */     // GIR_Coverage, 11750,
     /* 364000 */     GIR_EraseRootFromParent_Done,
     /* 364001 */   // Label 5664: @364001
     /* 364001 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(364130), // Rule ID 7605 //
     /* 364006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364050 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364050 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364055 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364060 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364080 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364087 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 364097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 364102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 364107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 364112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364128 */     GIR_RootConstrainSelectedInstOperands,
     /* 364129 */     // GIR_Coverage, 7605,
     /* 364129 */     GIR_EraseRootFromParent_Done,
     /* 364130 */   // Label 5665: @364130
     /* 364130 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(364259), // Rule ID 11731 //
     /* 364135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364179 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364184 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364216 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 364226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 364231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 364236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 364241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364257 */     GIR_RootConstrainSelectedInstOperands,
     /* 364258 */     // GIR_Coverage, 11731,
     /* 364258 */     GIR_EraseRootFromParent_Done,
     /* 364259 */   // Label 5666: @364259
     /* 364259 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(364388), // Rule ID 11734 //
     /* 364264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364308 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364313 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364318 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364338 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364345 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 364355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 364360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 364365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 364370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364386 */     GIR_RootConstrainSelectedInstOperands,
     /* 364387 */     // GIR_Coverage, 11734,
     /* 364387 */     GIR_EraseRootFromParent_Done,
     /* 364388 */   // Label 5667: @364388
     /* 364388 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(364517), // Rule ID 11735 //
     /* 364393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364437 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364442 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364447 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364474 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 364484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 364489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 364494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 364499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364515 */     GIR_RootConstrainSelectedInstOperands,
     /* 364516 */     // GIR_Coverage, 11735,
     /* 364516 */     GIR_EraseRootFromParent_Done,
     /* 364517 */   // Label 5668: @364517
     /* 364517 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(364646), // Rule ID 11717 //
     /* 364522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 364562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 364566 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364571 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364596 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364603 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 364613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 364618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 364623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 364628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364644 */     GIR_RootConstrainSelectedInstOperands,
     /* 364645 */     // GIR_Coverage, 11717,
     /* 364645 */     GIR_EraseRootFromParent_Done,
     /* 364646 */   // Label 5669: @364646
     /* 364646 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(364775), // Rule ID 11718 //
     /* 364651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 364691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 364695 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364700 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364725 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364732 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 364742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 364747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 364752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 364757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364773 */     GIR_RootConstrainSelectedInstOperands,
     /* 364774 */     // GIR_Coverage, 11718,
     /* 364774 */     GIR_EraseRootFromParent_Done,
     /* 364775 */   // Label 5670: @364775
     /* 364775 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(364904), // Rule ID 11721 //
     /* 364780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 364820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 364824 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364829 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364834 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364861 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 364871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 364876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 364881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 364886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364902 */     GIR_RootConstrainSelectedInstOperands,
     /* 364903 */     // GIR_Coverage, 11721,
     /* 364903 */     GIR_EraseRootFromParent_Done,
     /* 364904 */   // Label 5671: @364904
     /* 364904 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(365033), // Rule ID 11722 //
     /* 364909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 364925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 364929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 364941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 364945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 364949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 364953 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364953 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 364958 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 364963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364967 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364983 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364990 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 364993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 365000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 365005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 365010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 365015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365031 */     GIR_RootConstrainSelectedInstOperands,
     /* 365032 */     // GIR_Coverage, 11722,
     /* 365032 */     GIR_EraseRootFromParent_Done,
     /* 365033 */   // Label 5672: @365033
     /* 365033 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(365162), // Rule ID 11702 //
     /* 365038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 365082 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365087 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365092 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365112 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365119 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 365129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 365134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 365139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 365144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365160 */     GIR_RootConstrainSelectedInstOperands,
     /* 365161 */     // GIR_Coverage, 11702,
     /* 365161 */     GIR_EraseRootFromParent_Done,
     /* 365162 */   // Label 5673: @365162
     /* 365162 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(365291), // Rule ID 11703 //
     /* 365167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 365211 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365216 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365241 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365248 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 365258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 365263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 365268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 365273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365289 */     GIR_RootConstrainSelectedInstOperands,
     /* 365290 */     // GIR_Coverage, 11703,
     /* 365290 */     GIR_EraseRootFromParent_Done,
     /* 365291 */   // Label 5674: @365291
     /* 365291 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(365420), // Rule ID 11706 //
     /* 365296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 365340 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365340 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365345 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365377 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 365387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 365392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 365397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 365402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365418 */     GIR_RootConstrainSelectedInstOperands,
     /* 365419 */     // GIR_Coverage, 11706,
     /* 365419 */     GIR_EraseRootFromParent_Done,
     /* 365420 */   // Label 5675: @365420
     /* 365420 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(365549), // Rule ID 11707 //
     /* 365425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 365469 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365474 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365506 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 365516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 365521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 365526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 365531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365547 */     GIR_RootConstrainSelectedInstOperands,
     /* 365548 */     // GIR_Coverage, 11707,
     /* 365548 */     GIR_EraseRootFromParent_Done,
     /* 365549 */   // Label 5676: @365549
     /* 365549 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(365678), // Rule ID 7604 //
     /* 365554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 365594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 365598 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365598 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365603 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365608 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365635 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 365645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 365650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 365655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 365660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365676 */     GIR_RootConstrainSelectedInstOperands,
     /* 365677 */     // GIR_Coverage, 7604,
     /* 365677 */     GIR_EraseRootFromParent_Done,
     /* 365678 */   // Label 5677: @365678
     /* 365678 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(365807), // Rule ID 11716 //
     /* 365683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 365723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 365727 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365732 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365737 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365741 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365764 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 365774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 365779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 365784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 365789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365805 */     GIR_RootConstrainSelectedInstOperands,
     /* 365806 */     // GIR_Coverage, 11716,
     /* 365806 */     GIR_EraseRootFromParent_Done,
     /* 365807 */   // Label 5678: @365807
     /* 365807 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(365936), // Rule ID 11719 //
     /* 365812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 365852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 365856 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365861 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365893 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 365896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 365903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 365908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 365913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 365918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365934 */     GIR_RootConstrainSelectedInstOperands,
     /* 365935 */     // GIR_Coverage, 11719,
     /* 365935 */     GIR_EraseRootFromParent_Done,
     /* 365936 */   // Label 5679: @365936
     /* 365936 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(366065), // Rule ID 11720 //
     /* 365941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 365957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 365961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 365973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 365977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 365981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 365985 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 365985 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365990 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 365990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 365995 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 365999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366022 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 366032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 366037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 366042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 366047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366063 */     GIR_RootConstrainSelectedInstOperands,
     /* 366064 */     // GIR_Coverage, 11720,
     /* 366064 */     GIR_EraseRootFromParent_Done,
     /* 366065 */   // Label 5680: @366065
     /* 366065 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(366194), // Rule ID 7603 //
     /* 366070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 366114 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 366119 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 366124 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366151 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 366161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 366166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 366171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366192 */     GIR_RootConstrainSelectedInstOperands,
     /* 366193 */     // GIR_Coverage, 7603,
     /* 366193 */     GIR_EraseRootFromParent_Done,
     /* 366194 */   // Label 5681: @366194
     /* 366194 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(366323), // Rule ID 11701 //
     /* 366199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 366243 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 366248 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 366253 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366280 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 366290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 366295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 366300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366321 */     GIR_RootConstrainSelectedInstOperands,
     /* 366322 */     // GIR_Coverage, 11701,
     /* 366322 */     GIR_EraseRootFromParent_Done,
     /* 366323 */   // Label 5682: @366323
     /* 366323 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(366452), // Rule ID 11704 //
     /* 366328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 366372 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 366377 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 366382 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366409 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 366419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 366424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 366429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 366434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366450 */     GIR_RootConstrainSelectedInstOperands,
     /* 366451 */     // GIR_Coverage, 11704,
     /* 366451 */     GIR_EraseRootFromParent_Done,
     /* 366452 */   // Label 5683: @366452
     /* 366452 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(366581), // Rule ID 11705 //
     /* 366457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 366501 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 366506 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 366511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366538 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 366548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 366553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 366558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 366563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366579 */     GIR_RootConstrainSelectedInstOperands,
     /* 366580 */     // GIR_Coverage, 11705,
     /* 366580 */     GIR_EraseRootFromParent_Done,
     /* 366581 */   // Label 5684: @366581
     /* 366581 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(366710), // Rule ID 11757 //
     /* 366586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 366614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 366626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366630 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366630 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 366635 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 366640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366667 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 366677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 366682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 366687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 366692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 366697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 366702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366708 */     GIR_RootConstrainSelectedInstOperands,
     /* 366709 */     // GIR_Coverage, 11757,
     /* 366709 */     GIR_EraseRootFromParent_Done,
     /* 366710 */   // Label 5685: @366710
     /* 366710 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(366839), // Rule ID 11758 //
     /* 366715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 366743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 366755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366759 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 366764 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 366769 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366796 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 366806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 366811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 366816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 366821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 366826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 366831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366837 */     GIR_RootConstrainSelectedInstOperands,
     /* 366838 */     // GIR_Coverage, 11758,
     /* 366838 */     GIR_EraseRootFromParent_Done,
     /* 366839 */   // Label 5686: @366839
     /* 366839 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(366968), // Rule ID 11759 //
     /* 366844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 366872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 366884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366888 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366888 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 366893 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 366898 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366925 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 366935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 366940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 366945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 366955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 366960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366966 */     GIR_RootConstrainSelectedInstOperands,
     /* 366967 */     // GIR_Coverage, 11759,
     /* 366967 */     GIR_EraseRootFromParent_Done,
     /* 366968 */   // Label 5687: @366968
     /* 366968 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(367097), // Rule ID 11760 //
     /* 366973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367017 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367017 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367022 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367027 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367054 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 367064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 367069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 367074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 367079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367095 */     GIR_RootConstrainSelectedInstOperands,
     /* 367096 */     // GIR_Coverage, 11760,
     /* 367096 */     GIR_EraseRootFromParent_Done,
     /* 367097 */   // Label 5688: @367097
     /* 367097 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(367226), // Rule ID 11697 //
     /* 367102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 367146 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367151 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367183 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 367193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 367198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 367203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 367208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367224 */     GIR_RootConstrainSelectedInstOperands,
     /* 367225 */     // GIR_Coverage, 11697,
     /* 367225 */     GIR_EraseRootFromParent_Done,
     /* 367226 */   // Label 5689: @367226
     /* 367226 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(367355), // Rule ID 11698 //
     /* 367231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 367275 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367275 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367280 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367285 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367312 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 367322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 367327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 367332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 367337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367353 */     GIR_RootConstrainSelectedInstOperands,
     /* 367354 */     // GIR_Coverage, 11698,
     /* 367354 */     GIR_EraseRootFromParent_Done,
     /* 367355 */   // Label 5690: @367355
     /* 367355 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(367484), // Rule ID 11699 //
     /* 367360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 367404 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367409 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367441 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 367451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 367456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 367461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 367466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367482 */     GIR_RootConstrainSelectedInstOperands,
     /* 367483 */     // GIR_Coverage, 11699,
     /* 367483 */     GIR_EraseRootFromParent_Done,
     /* 367484 */   // Label 5691: @367484
     /* 367484 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(367613), // Rule ID 11700 //
     /* 367489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 367533 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367533 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367538 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367543 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367563 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367570 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 367580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 367585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 367590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 367595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367611 */     GIR_RootConstrainSelectedInstOperands,
     /* 367612 */     // GIR_Coverage, 11700,
     /* 367612 */     GIR_EraseRootFromParent_Done,
     /* 367613 */   // Label 5692: @367613
     /* 367613 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(367742), // Rule ID 11742 //
     /* 367618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 367646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367662 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367662 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367667 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367672 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367685 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367699 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 367709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 367714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 367719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 367724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367740 */     GIR_RootConstrainSelectedInstOperands,
     /* 367741 */     // GIR_Coverage, 11742,
     /* 367741 */     GIR_EraseRootFromParent_Done,
     /* 367742 */   // Label 5693: @367742
     /* 367742 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(367871), // Rule ID 11743 //
     /* 367747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 367775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367791 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367796 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367828 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 367838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 367843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 367848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 367853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367869 */     GIR_RootConstrainSelectedInstOperands,
     /* 367870 */     // GIR_Coverage, 11743,
     /* 367870 */     GIR_EraseRootFromParent_Done,
     /* 367871 */   // Label 5694: @367871
     /* 367871 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(368000), // Rule ID 11744 //
     /* 367876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 367904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367920 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367920 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 367925 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 367930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367936 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367943 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367957 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 367967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 367972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 367977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 367982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 367987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 367992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367998 */     GIR_RootConstrainSelectedInstOperands,
     /* 367999 */     // GIR_Coverage, 11744,
     /* 367999 */     GIR_EraseRootFromParent_Done,
     /* 368000 */   // Label 5695: @368000
     /* 368000 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(368129), // Rule ID 11745 //
     /* 368005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368049 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368054 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368059 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368072 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368086 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 368096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 368101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 368106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 368111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 368116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 368121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368127 */     GIR_RootConstrainSelectedInstOperands,
     /* 368128 */     // GIR_Coverage, 11745,
     /* 368128 */     GIR_EraseRootFromParent_Done,
     /* 368129 */   // Label 5696: @368129
     /* 368129 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(368258), // Rule ID 11682 //
     /* 368134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 368178 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368183 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368201 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368215 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 368225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 368230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 368235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 368240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 368245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 368250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368256 */     GIR_RootConstrainSelectedInstOperands,
     /* 368257 */     // GIR_Coverage, 11682,
     /* 368257 */     GIR_EraseRootFromParent_Done,
     /* 368258 */   // Label 5697: @368258
     /* 368258 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(368387), // Rule ID 11683 //
     /* 368263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368295 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 368307 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368307 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368312 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368312 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368317 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368330 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368344 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 368354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 368359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 368364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 368369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 368374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 368379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368385 */     GIR_RootConstrainSelectedInstOperands,
     /* 368386 */     // GIR_Coverage, 11683,
     /* 368386 */     GIR_EraseRootFromParent_Done,
     /* 368387 */   // Label 5698: @368387
     /* 368387 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(368516), // Rule ID 11684 //
     /* 368392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 368436 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368441 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368473 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 368483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 368488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 368493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 368498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 368503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 368508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368514 */     GIR_RootConstrainSelectedInstOperands,
     /* 368515 */     // GIR_Coverage, 11684,
     /* 368515 */     GIR_EraseRootFromParent_Done,
     /* 368516 */   // Label 5699: @368516
     /* 368516 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(368645), // Rule ID 11685 //
     /* 368521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 368565 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368565 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368570 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368575 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368595 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368602 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 368612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 368617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 368622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 368627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 368632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 368637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368643 */     GIR_RootConstrainSelectedInstOperands,
     /* 368644 */     // GIR_Coverage, 11685,
     /* 368644 */     GIR_EraseRootFromParent_Done,
     /* 368645 */   // Label 5700: @368645
     /* 368645 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(368774), // Rule ID 11753 //
     /* 368650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 368678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368694 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368699 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368731 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 368741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 368746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 368751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 368756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 368761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 368766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368772 */     GIR_RootConstrainSelectedInstOperands,
     /* 368773 */     // GIR_Coverage, 11753,
     /* 368773 */     GIR_EraseRootFromParent_Done,
     /* 368774 */   // Label 5701: @368774
     /* 368774 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(368903), // Rule ID 11754 //
     /* 368779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 368807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368823 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368823 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368828 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368833 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368837 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368853 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368860 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 368870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 368875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 368880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 368885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 368890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 368895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368901 */     GIR_RootConstrainSelectedInstOperands,
     /* 368902 */     // GIR_Coverage, 11754,
     /* 368902 */     GIR_EraseRootFromParent_Done,
     /* 368903 */   // Label 5702: @368903
     /* 368903 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(369032), // Rule ID 11755 //
     /* 368908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 368936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368952 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368952 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 368957 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 368962 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368975 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368982 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368989 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 368999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 369004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 369009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 369014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369030 */     GIR_RootConstrainSelectedInstOperands,
     /* 369031 */     // GIR_Coverage, 11755,
     /* 369031 */     GIR_EraseRootFromParent_Done,
     /* 369032 */   // Label 5703: @369032
     /* 369032 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(369161), // Rule ID 11756 //
     /* 369037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369081 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369086 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369111 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369118 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 369128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 369133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 369138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 369143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369159 */     GIR_RootConstrainSelectedInstOperands,
     /* 369160 */     // GIR_Coverage, 11756,
     /* 369160 */     GIR_EraseRootFromParent_Done,
     /* 369161 */   // Label 5704: @369161
     /* 369161 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(369290), // Rule ID 11693 //
     /* 369166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369210 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369210 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369215 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369215 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369247 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 369257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 369262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 369267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 369272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369288 */     GIR_RootConstrainSelectedInstOperands,
     /* 369289 */     // GIR_Coverage, 11693,
     /* 369289 */     GIR_EraseRootFromParent_Done,
     /* 369290 */   // Label 5705: @369290
     /* 369290 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(369419), // Rule ID 11694 //
     /* 369295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369339 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369344 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369349 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369353 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369362 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369376 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 369386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 369391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 369396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 369401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369417 */     GIR_RootConstrainSelectedInstOperands,
     /* 369418 */     // GIR_Coverage, 11694,
     /* 369418 */     GIR_EraseRootFromParent_Done,
     /* 369419 */   // Label 5706: @369419
     /* 369419 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(369548), // Rule ID 11695 //
     /* 369424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369468 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369468 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369473 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369478 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369491 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369505 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 369515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 369520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 369525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 369530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369546 */     GIR_RootConstrainSelectedInstOperands,
     /* 369547 */     // GIR_Coverage, 11695,
     /* 369547 */     GIR_EraseRootFromParent_Done,
     /* 369548 */   // Label 5707: @369548
     /* 369548 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(369677), // Rule ID 11696 //
     /* 369553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369593 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369597 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369602 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369607 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369620 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369634 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 369644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 369649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 369654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 369659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369675 */     GIR_RootConstrainSelectedInstOperands,
     /* 369676 */     // GIR_Coverage, 11696,
     /* 369676 */     GIR_EraseRootFromParent_Done,
     /* 369677 */   // Label 5708: @369677
     /* 369677 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(369806), // Rule ID 11738 //
     /* 369682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 369710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369726 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369731 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369736 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369749 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369763 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 369773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 369778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 369783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 369788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369804 */     GIR_RootConstrainSelectedInstOperands,
     /* 369805 */     // GIR_Coverage, 11738,
     /* 369805 */     GIR_EraseRootFromParent_Done,
     /* 369806 */   // Label 5709: @369806
     /* 369806 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(369935), // Rule ID 11739 //
     /* 369811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 369839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369855 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369855 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369860 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369865 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369878 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369892 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 369902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 369907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 369912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 369917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369933 */     GIR_RootConstrainSelectedInstOperands,
     /* 369934 */     // GIR_Coverage, 11739,
     /* 369934 */     GIR_EraseRootFromParent_Done,
     /* 369935 */   // Label 5710: @369935
     /* 369935 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(370064), // Rule ID 11740 //
     /* 369940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 369968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369984 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 369989 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 369994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370007 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370021 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 370031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 370036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 370041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 370046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370062 */     GIR_RootConstrainSelectedInstOperands,
     /* 370063 */     // GIR_Coverage, 11740,
     /* 370063 */     GIR_EraseRootFromParent_Done,
     /* 370064 */   // Label 5711: @370064
     /* 370064 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(370193), // Rule ID 11741 //
     /* 370069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370113 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370113 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 370118 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370118 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 370123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370127 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370136 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370143 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370150 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 370160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 370165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 370170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 370175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370191 */     GIR_RootConstrainSelectedInstOperands,
     /* 370192 */     // GIR_Coverage, 11741,
     /* 370192 */     GIR_EraseRootFromParent_Done,
     /* 370193 */   // Label 5712: @370193
     /* 370193 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(370322), // Rule ID 11678 //
     /* 370198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370242 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 370247 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370247 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 370252 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370272 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370279 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 370289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 370294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 370299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 370304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370320 */     GIR_RootConstrainSelectedInstOperands,
     /* 370321 */     // GIR_Coverage, 11678,
     /* 370321 */     GIR_EraseRootFromParent_Done,
     /* 370322 */   // Label 5713: @370322
     /* 370322 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(370451), // Rule ID 11679 //
     /* 370327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370371 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 370376 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 370381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370408 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 370418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 370423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 370428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 370433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370449 */     GIR_RootConstrainSelectedInstOperands,
     /* 370450 */     // GIR_Coverage, 11679,
     /* 370450 */     GIR_EraseRootFromParent_Done,
     /* 370451 */   // Label 5714: @370451
     /* 370451 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(370580), // Rule ID 11680 //
     /* 370456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370500 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370500 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 370505 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 370510 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370537 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 370547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 370552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 370557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 370562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370578 */     GIR_RootConstrainSelectedInstOperands,
     /* 370579 */     // GIR_Coverage, 11680,
     /* 370579 */     GIR_EraseRootFromParent_Done,
     /* 370580 */   // Label 5715: @370580
     /* 370580 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(370709), // Rule ID 11681 //
     /* 370585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370629 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 370634 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 370639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370643 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370652 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370666 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 370676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 370681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 370686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 370691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370707 */     GIR_RootConstrainSelectedInstOperands,
     /* 370708 */     // GIR_Coverage, 11681,
     /* 370708 */     GIR_EraseRootFromParent_Done,
     /* 370709 */   // Label 5716: @370709
     /* 370709 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(370838), // Rule ID 11687 //
     /* 370714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 370754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 370758 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370758 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370763 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 370768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370795 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 370805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 370810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 370815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 370820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370836 */     GIR_RootConstrainSelectedInstOperands,
     /* 370837 */     // GIR_Coverage, 11687,
     /* 370837 */     GIR_EraseRootFromParent_Done,
     /* 370838 */   // Label 5717: @370838
     /* 370838 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(370967), // Rule ID 11688 //
     /* 370843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 370883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 370887 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370887 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 370892 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370901 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370924 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 370934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 370939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 370944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 370949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370965 */     GIR_RootConstrainSelectedInstOperands,
     /* 370966 */     // GIR_Coverage, 11688,
     /* 370966 */     GIR_EraseRootFromParent_Done,
     /* 370967 */   // Label 5718: @370967
     /* 370967 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(371096), // Rule ID 11691 //
     /* 370972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371016 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371021 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371053 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 371063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 371068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 371073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 371078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371094 */     GIR_RootConstrainSelectedInstOperands,
     /* 371095 */     // GIR_Coverage, 11691,
     /* 371095 */     GIR_EraseRootFromParent_Done,
     /* 371096 */   // Label 5719: @371096
     /* 371096 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(371225), // Rule ID 11692 //
     /* 371101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371145 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371145 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371150 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371155 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371182 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 371192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 371197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 371202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 371207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371223 */     GIR_RootConstrainSelectedInstOperands,
     /* 371224 */     // GIR_Coverage, 11692,
     /* 371224 */     GIR_EraseRootFromParent_Done,
     /* 371225 */   // Label 5720: @371225
     /* 371225 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(371354), // Rule ID 11672 //
     /* 371230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 371274 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371279 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371311 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 371321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 371326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 371331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 371336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371352 */     GIR_RootConstrainSelectedInstOperands,
     /* 371353 */     // GIR_Coverage, 11672,
     /* 371353 */     GIR_EraseRootFromParent_Done,
     /* 371354 */   // Label 5721: @371354
     /* 371354 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(371483), // Rule ID 11673 //
     /* 371359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 371403 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371408 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371413 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371433 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371440 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 371450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 371455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 371460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 371465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371481 */     GIR_RootConstrainSelectedInstOperands,
     /* 371482 */     // GIR_Coverage, 11673,
     /* 371482 */     GIR_EraseRootFromParent_Done,
     /* 371483 */   // Label 5722: @371483
     /* 371483 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(371612), // Rule ID 11676 //
     /* 371488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 371532 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371532 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371537 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371562 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371569 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 371579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 371584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 371589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 371594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371610 */     GIR_RootConstrainSelectedInstOperands,
     /* 371611 */     // GIR_Coverage, 11676,
     /* 371611 */     GIR_EraseRootFromParent_Done,
     /* 371612 */   // Label 5723: @371612
     /* 371612 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(371741), // Rule ID 11677 //
     /* 371617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 371661 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371666 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371671 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371698 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 371708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 371713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 371718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 371723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371739 */     GIR_RootConstrainSelectedInstOperands,
     /* 371740 */     // GIR_Coverage, 11677,
     /* 371740 */     GIR_EraseRootFromParent_Done,
     /* 371741 */   // Label 5724: @371741
     /* 371741 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(371870), // Rule ID 7602 //
     /* 371746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 371786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371790 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371790 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371795 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371804 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371827 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 371837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 371842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 371847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 371852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371868 */     GIR_RootConstrainSelectedInstOperands,
     /* 371869 */     // GIR_Coverage, 7602,
     /* 371869 */     GIR_EraseRootFromParent_Done,
     /* 371870 */   // Label 5725: @371870
     /* 371870 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(371999), // Rule ID 11686 //
     /* 371875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 371915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371919 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 371924 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371929 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371956 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 371966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 371971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 371976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 371981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 371986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 371991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371997 */     GIR_RootConstrainSelectedInstOperands,
     /* 371998 */     // GIR_Coverage, 11686,
     /* 371998 */     GIR_EraseRootFromParent_Done,
     /* 371999 */   // Label 5726: @371999
     /* 371999 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(372128), // Rule ID 11689 //
     /* 372004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 372048 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372048 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372053 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372058 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372078 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372085 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 372095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 372100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 372105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 372110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372126 */     GIR_RootConstrainSelectedInstOperands,
     /* 372127 */     // GIR_Coverage, 11689,
     /* 372127 */     GIR_EraseRootFromParent_Done,
     /* 372128 */   // Label 5727: @372128
     /* 372128 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(372257), // Rule ID 11690 //
     /* 372133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 372177 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372177 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372182 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372214 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 372224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 372229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 372234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 372239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372255 */     GIR_RootConstrainSelectedInstOperands,
     /* 372256 */     // GIR_Coverage, 11690,
     /* 372256 */     GIR_EraseRootFromParent_Done,
     /* 372257 */   // Label 5728: @372257
     /* 372257 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(372386), // Rule ID 7601 //
     /* 372262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372306 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372311 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372343 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 372353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 372358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 372363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 372368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372384 */     GIR_RootConstrainSelectedInstOperands,
     /* 372385 */     // GIR_Coverage, 7601,
     /* 372385 */     GIR_EraseRootFromParent_Done,
     /* 372386 */   // Label 5729: @372386
     /* 372386 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(372515), // Rule ID 11671 //
     /* 372391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372435 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372435 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372440 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372440 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372445 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372449 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372465 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372472 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 372482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 372487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 372492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 372497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372513 */     GIR_RootConstrainSelectedInstOperands,
     /* 372514 */     // GIR_Coverage, 11671,
     /* 372514 */     GIR_EraseRootFromParent_Done,
     /* 372515 */   // Label 5730: @372515
     /* 372515 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(372644), // Rule ID 11674 //
     /* 372520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372564 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372569 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372578 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372580 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372601 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 372611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 372616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 372621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 372626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372642 */     GIR_RootConstrainSelectedInstOperands,
     /* 372643 */     // GIR_Coverage, 11674,
     /* 372643 */     GIR_EraseRootFromParent_Done,
     /* 372644 */   // Label 5731: @372644
     /* 372644 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(372773), // Rule ID 11675 //
     /* 372649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372681 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372685 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 372689 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372693 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372693 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372698 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372703 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372707 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372723 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372730 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 372740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 372745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 372750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 372755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372771 */     GIR_RootConstrainSelectedInstOperands,
     /* 372772 */     // GIR_Coverage, 11675,
     /* 372772 */     GIR_EraseRootFromParent_Done,
     /* 372773 */   // Label 5732: @372773
     /* 372773 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(372902), // Rule ID 11657 //
     /* 372778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 372822 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372822 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372827 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372832 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372838 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372859 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 372869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 372874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 372879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 372884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 372889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 372894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372900 */     GIR_RootConstrainSelectedInstOperands,
     /* 372901 */     // GIR_Coverage, 11657,
     /* 372901 */     GIR_EraseRootFromParent_Done,
     /* 372902 */   // Label 5733: @372902
     /* 372902 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(373031), // Rule ID 11658 //
     /* 372907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 372951 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 372956 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 372961 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372988 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 372998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 373003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 373008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 373013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373029 */     GIR_RootConstrainSelectedInstOperands,
     /* 373030 */     // GIR_Coverage, 11658,
     /* 373030 */     GIR_EraseRootFromParent_Done,
     /* 373031 */   // Label 5734: @373031
     /* 373031 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(373160), // Rule ID 11661 //
     /* 373036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373080 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373080 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373085 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373085 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373117 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 373127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 373132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 373137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 373142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373158 */     GIR_RootConstrainSelectedInstOperands,
     /* 373159 */     // GIR_Coverage, 11661,
     /* 373159 */     GIR_EraseRootFromParent_Done,
     /* 373160 */   // Label 5735: @373160
     /* 373160 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(373289), // Rule ID 11662 //
     /* 373165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373197 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373209 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373209 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373214 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373214 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373219 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373246 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 373256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 373261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 373266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 373271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373287 */     GIR_RootConstrainSelectedInstOperands,
     /* 373288 */     // GIR_Coverage, 11662,
     /* 373288 */     GIR_EraseRootFromParent_Done,
     /* 373289 */   // Label 5736: @373289
     /* 373289 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(373418), // Rule ID 11642 //
     /* 373294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 373338 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373338 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373343 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373368 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373375 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 373385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 373390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 373395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 373400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373416 */     GIR_RootConstrainSelectedInstOperands,
     /* 373417 */     // GIR_Coverage, 11642,
     /* 373417 */     GIR_EraseRootFromParent_Done,
     /* 373418 */   // Label 5737: @373418
     /* 373418 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(373547), // Rule ID 11643 //
     /* 373423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 373467 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373467 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373472 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373472 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373477 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373497 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373504 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 373514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 373519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 373524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 373529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373545 */     GIR_RootConstrainSelectedInstOperands,
     /* 373546 */     // GIR_Coverage, 11643,
     /* 373546 */     GIR_EraseRootFromParent_Done,
     /* 373547 */   // Label 5738: @373547
     /* 373547 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(373676), // Rule ID 11646 //
     /* 373552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 373596 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373601 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373606 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373633 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 373643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 373648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 373653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 373658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373674 */     GIR_RootConstrainSelectedInstOperands,
     /* 373675 */     // GIR_Coverage, 11646,
     /* 373675 */     GIR_EraseRootFromParent_Done,
     /* 373676 */   // Label 5739: @373676
     /* 373676 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(373805), // Rule ID 11647 //
     /* 373681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 373725 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373725 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373730 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373755 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373762 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 373772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 373777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 373782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 373787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373803 */     GIR_RootConstrainSelectedInstOperands,
     /* 373804 */     // GIR_Coverage, 11647,
     /* 373804 */     GIR_EraseRootFromParent_Done,
     /* 373805 */   // Label 5740: @373805
     /* 373805 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(373934), // Rule ID 7600 //
     /* 373810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 373850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373854 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373854 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373859 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373864 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373884 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373891 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 373901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 373906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 373911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 373916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373932 */     GIR_RootConstrainSelectedInstOperands,
     /* 373933 */     // GIR_Coverage, 7600,
     /* 373933 */     GIR_EraseRootFromParent_Done,
     /* 373934 */   // Label 5741: @373934
     /* 373934 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(374063), // Rule ID 11656 //
     /* 373939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373971 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 373979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373983 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373983 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 373988 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373988 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 373993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373997 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374013 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374020 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 374030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 374035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 374040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 374045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374061 */     GIR_RootConstrainSelectedInstOperands,
     /* 374062 */     // GIR_Coverage, 11656,
     /* 374062 */     GIR_EraseRootFromParent_Done,
     /* 374063 */   // Label 5742: @374063
     /* 374063 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(374192), // Rule ID 11659 //
     /* 374068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 374112 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374112 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374117 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374117 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374149 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 374159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 374164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 374169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 374174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374190 */     GIR_RootConstrainSelectedInstOperands,
     /* 374191 */     // GIR_Coverage, 11659,
     /* 374191 */     GIR_EraseRootFromParent_Done,
     /* 374192 */   // Label 5743: @374192
     /* 374192 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(374321), // Rule ID 11660 //
     /* 374197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 374241 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374246 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374278 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 374288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 374293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 374298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 374303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374319 */     GIR_RootConstrainSelectedInstOperands,
     /* 374320 */     // GIR_Coverage, 11660,
     /* 374320 */     GIR_EraseRootFromParent_Done,
     /* 374321 */   // Label 5744: @374321
     /* 374321 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(374450), // Rule ID 7599 //
     /* 374326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374370 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374370 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374375 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374384 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374400 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374407 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 374417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 374422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 374427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 374432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374448 */     GIR_RootConstrainSelectedInstOperands,
     /* 374449 */     // GIR_Coverage, 7599,
     /* 374449 */     GIR_EraseRootFromParent_Done,
     /* 374450 */   // Label 5745: @374450
     /* 374450 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(374579), // Rule ID 11641 //
     /* 374455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374499 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374504 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374509 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374513 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374536 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 374546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 374551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 374556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 374561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374577 */     GIR_RootConstrainSelectedInstOperands,
     /* 374578 */     // GIR_Coverage, 11641,
     /* 374578 */     GIR_EraseRootFromParent_Done,
     /* 374579 */   // Label 5746: @374579
     /* 374579 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(374708), // Rule ID 11644 //
     /* 374584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374628 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374628 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374633 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374633 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374638 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374665 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 374675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 374680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 374685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 374690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374706 */     GIR_RootConstrainSelectedInstOperands,
     /* 374707 */     // GIR_Coverage, 11644,
     /* 374707 */     GIR_EraseRootFromParent_Done,
     /* 374708 */   // Label 5747: @374708
     /* 374708 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(374837), // Rule ID 11645 //
     /* 374713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374757 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374757 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 374762 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374762 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 374767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374787 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374794 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 374804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 374809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 374814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 374819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374835 */     GIR_RootConstrainSelectedInstOperands,
     /* 374836 */     // GIR_Coverage, 11645,
     /* 374836 */     GIR_EraseRootFromParent_Done,
     /* 374837 */   // Label 5748: @374837
     /* 374837 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(374966), // Rule ID 11727 //
     /* 374842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 374870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 374886 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 374891 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 374896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374900 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374909 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374923 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 374933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 374938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 374943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 374948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 374953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 374958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374964 */     GIR_RootConstrainSelectedInstOperands,
     /* 374965 */     // GIR_Coverage, 11727,
     /* 374965 */     GIR_EraseRootFromParent_Done,
     /* 374966 */   // Label 5749: @374966
     /* 374966 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(375095), // Rule ID 11728 //
     /* 374971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 374999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375015 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375015 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375020 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375025 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375038 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375045 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375052 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 375062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 375067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 375072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 375077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375093 */     GIR_RootConstrainSelectedInstOperands,
     /* 375094 */     // GIR_Coverage, 11728,
     /* 375094 */     GIR_EraseRootFromParent_Done,
     /* 375095 */   // Label 5750: @375095
     /* 375095 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(375224), // Rule ID 11729 //
     /* 375100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375144 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375149 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375167 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375181 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 375191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 375196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 375201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 375206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375222 */     GIR_RootConstrainSelectedInstOperands,
     /* 375223 */     // GIR_Coverage, 11729,
     /* 375223 */     GIR_EraseRootFromParent_Done,
     /* 375224 */   // Label 5751: @375224
     /* 375224 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(375353), // Rule ID 11730 //
     /* 375229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375273 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375273 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375278 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375278 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375283 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375303 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375310 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 375320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 375325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 375330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 375335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375351 */     GIR_RootConstrainSelectedInstOperands,
     /* 375352 */     // GIR_Coverage, 11730,
     /* 375352 */     GIR_EraseRootFromParent_Done,
     /* 375353 */   // Label 5752: @375353
     /* 375353 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(375482), // Rule ID 11667 //
     /* 375358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375402 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375402 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375407 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375412 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375425 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375439 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 375449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 375454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 375459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 375464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375480 */     GIR_RootConstrainSelectedInstOperands,
     /* 375481 */     // GIR_Coverage, 11667,
     /* 375481 */     GIR_EraseRootFromParent_Done,
     /* 375482 */   // Label 5753: @375482
     /* 375482 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(375611), // Rule ID 11668 //
     /* 375487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375531 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375536 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375568 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 375578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 375583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 375588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 375593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375609 */     GIR_RootConstrainSelectedInstOperands,
     /* 375610 */     // GIR_Coverage, 11668,
     /* 375610 */     GIR_EraseRootFromParent_Done,
     /* 375611 */   // Label 5754: @375611
     /* 375611 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(375740), // Rule ID 11669 //
     /* 375616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375660 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375665 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375665 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375670 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375674 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375683 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375697 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 375707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 375712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 375717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 375722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375738 */     GIR_RootConstrainSelectedInstOperands,
     /* 375739 */     // GIR_Coverage, 11669,
     /* 375739 */     GIR_EraseRootFromParent_Done,
     /* 375740 */   // Label 5755: @375740
     /* 375740 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(375869), // Rule ID 11670 //
     /* 375745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375789 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375794 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375826 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 375836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 375841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 375846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 375851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375867 */     GIR_RootConstrainSelectedInstOperands,
     /* 375868 */     // GIR_Coverage, 11670,
     /* 375868 */     GIR_EraseRootFromParent_Done,
     /* 375869 */   // Label 5756: @375869
     /* 375869 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(375998), // Rule ID 11712 //
     /* 375874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 375902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375918 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375918 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375923 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375928 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375955 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 375965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 375970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 375975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 375980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 375985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 375990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375996 */     GIR_RootConstrainSelectedInstOperands,
     /* 375997 */     // GIR_Coverage, 11712,
     /* 375997 */     GIR_EraseRootFromParent_Done,
     /* 375998 */   // Label 5757: @375998
     /* 375998 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(376127), // Rule ID 11713 //
     /* 376003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376047 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376052 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376057 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376061 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376070 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376084 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 376094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 376099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 376104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 376109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376125 */     GIR_RootConstrainSelectedInstOperands,
     /* 376126 */     // GIR_Coverage, 11713,
     /* 376126 */     GIR_EraseRootFromParent_Done,
     /* 376127 */   // Label 5758: @376127
     /* 376127 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(376256), // Rule ID 11714 //
     /* 376132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376176 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376176 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376181 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376186 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376213 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 376223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 376228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 376233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 376238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376254 */     GIR_RootConstrainSelectedInstOperands,
     /* 376255 */     // GIR_Coverage, 11714,
     /* 376255 */     GIR_EraseRootFromParent_Done,
     /* 376256 */   // Label 5759: @376256
     /* 376256 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(376385), // Rule ID 11715 //
     /* 376261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376305 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376305 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376310 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376328 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376342 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 376352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 376357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 376362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 376367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376383 */     GIR_RootConstrainSelectedInstOperands,
     /* 376384 */     // GIR_Coverage, 11715,
     /* 376384 */     GIR_EraseRootFromParent_Done,
     /* 376385 */   // Label 5760: @376385
     /* 376385 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(376514), // Rule ID 11652 //
     /* 376390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376434 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376439 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376471 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 376481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 376486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 376491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 376496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376512 */     GIR_RootConstrainSelectedInstOperands,
     /* 376513 */     // GIR_Coverage, 11652,
     /* 376513 */     GIR_EraseRootFromParent_Done,
     /* 376514 */   // Label 5761: @376514
     /* 376514 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(376643), // Rule ID 11653 //
     /* 376519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376563 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376563 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376568 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376573 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376600 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 376610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 376615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 376620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 376625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376641 */     GIR_RootConstrainSelectedInstOperands,
     /* 376642 */     // GIR_Coverage, 11653,
     /* 376642 */     GIR_EraseRootFromParent_Done,
     /* 376643 */   // Label 5762: @376643
     /* 376643 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(376772), // Rule ID 11654 //
     /* 376648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376692 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376692 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376697 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376697 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376702 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376706 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376715 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376729 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 376739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 376744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 376749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 376754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376770 */     GIR_RootConstrainSelectedInstOperands,
     /* 376771 */     // GIR_Coverage, 11654,
     /* 376771 */     GIR_EraseRootFromParent_Done,
     /* 376772 */   // Label 5763: @376772
     /* 376772 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(376901), // Rule ID 11655 //
     /* 376777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376809 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376821 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376826 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376831 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376858 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 376868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 376873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 376878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 376883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 376888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 376893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376899 */     GIR_RootConstrainSelectedInstOperands,
     /* 376900 */     // GIR_Coverage, 11655,
     /* 376900 */     GIR_EraseRootFromParent_Done,
     /* 376901 */   // Label 5764: @376901
     /* 376901 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(377030), // Rule ID 11723 //
     /* 376906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 376934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376950 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376950 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 376955 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 376960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376980 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376987 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 376997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 377002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377028 */     GIR_RootConstrainSelectedInstOperands,
     /* 377029 */     // GIR_Coverage, 11723,
     /* 377029 */     GIR_EraseRootFromParent_Done,
     /* 377030 */   // Label 5765: @377030
     /* 377030 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(377159), // Rule ID 11724 //
     /* 377035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 377079 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377084 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377116 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 377126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 377131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377157 */     GIR_RootConstrainSelectedInstOperands,
     /* 377158 */     // GIR_Coverage, 11724,
     /* 377158 */     GIR_EraseRootFromParent_Done,
     /* 377159 */   // Label 5766: @377159
     /* 377159 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(377288), // Rule ID 11725 //
     /* 377164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 377208 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377208 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377213 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377218 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377245 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 377255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 377260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 377265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 377270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377286 */     GIR_RootConstrainSelectedInstOperands,
     /* 377287 */     // GIR_Coverage, 11725,
     /* 377287 */     GIR_EraseRootFromParent_Done,
     /* 377288 */   // Label 5767: @377288
     /* 377288 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(377417), // Rule ID 11726 //
     /* 377293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 377337 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377337 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377342 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377342 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377347 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377360 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377367 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377374 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 377384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 377389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 377394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 377399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377415 */     GIR_RootConstrainSelectedInstOperands,
     /* 377416 */     // GIR_Coverage, 11726,
     /* 377416 */     GIR_EraseRootFromParent_Done,
     /* 377417 */   // Label 5768: @377417
     /* 377417 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(377546), // Rule ID 11663 //
     /* 377422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377454 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377466 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377471 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377480 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377489 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377503 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 377513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 377518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377544 */     GIR_RootConstrainSelectedInstOperands,
     /* 377545 */     // GIR_Coverage, 11663,
     /* 377545 */     GIR_EraseRootFromParent_Done,
     /* 377546 */   // Label 5769: @377546
     /* 377546 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(377675), // Rule ID 11664 //
     /* 377551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377583 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377595 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377600 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377605 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377609 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377625 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377632 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 377642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 377647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377673 */     GIR_RootConstrainSelectedInstOperands,
     /* 377674 */     // GIR_Coverage, 11664,
     /* 377674 */     GIR_EraseRootFromParent_Done,
     /* 377675 */   // Label 5770: @377675
     /* 377675 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(377804), // Rule ID 11665 //
     /* 377680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377724 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377724 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377729 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377734 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377740 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377747 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377761 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 377771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 377776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 377781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 377786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377802 */     GIR_RootConstrainSelectedInstOperands,
     /* 377803 */     // GIR_Coverage, 11665,
     /* 377803 */     GIR_EraseRootFromParent_Done,
     /* 377804 */   // Label 5771: @377804
     /* 377804 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(377933), // Rule ID 11666 //
     /* 377809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377853 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377853 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377858 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377863 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377867 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377890 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 377900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 377905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 377910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 377915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377931 */     GIR_RootConstrainSelectedInstOperands,
     /* 377932 */     // GIR_Coverage, 11666,
     /* 377932 */     GIR_EraseRootFromParent_Done,
     /* 377933 */   // Label 5772: @377933
     /* 377933 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(378062), // Rule ID 11708 //
     /* 377938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 377966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 377982 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377982 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 377987 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377987 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 377992 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378005 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378019 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 378029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 378034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 378039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 378044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378060 */     GIR_RootConstrainSelectedInstOperands,
     /* 378061 */     // GIR_Coverage, 11708,
     /* 378061 */     GIR_EraseRootFromParent_Done,
     /* 378062 */   // Label 5773: @378062
     /* 378062 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(378191), // Rule ID 11709 //
     /* 378067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 378111 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378111 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378116 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378134 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378141 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378148 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 378158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 378163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 378168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 378173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378189 */     GIR_RootConstrainSelectedInstOperands,
     /* 378190 */     // GIR_Coverage, 11709,
     /* 378190 */     GIR_EraseRootFromParent_Done,
     /* 378191 */   // Label 5774: @378191
     /* 378191 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(378320), // Rule ID 11710 //
     /* 378196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 378240 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378240 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378245 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378250 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378270 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378277 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 378287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 378292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 378297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 378302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378318 */     GIR_RootConstrainSelectedInstOperands,
     /* 378319 */     // GIR_Coverage, 11710,
     /* 378319 */     GIR_EraseRootFromParent_Done,
     /* 378320 */   // Label 5775: @378320
     /* 378320 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(378449), // Rule ID 11711 //
     /* 378325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 378369 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378374 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378379 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378383 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378392 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378399 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378406 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 378416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 378421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 378426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 378431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378447 */     GIR_RootConstrainSelectedInstOperands,
     /* 378448 */     // GIR_Coverage, 11711,
     /* 378448 */     GIR_EraseRootFromParent_Done,
     /* 378449 */   // Label 5776: @378449
     /* 378449 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(378578), // Rule ID 11648 //
     /* 378454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378486 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378498 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378498 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378503 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378503 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378508 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378521 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378528 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378535 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 378545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 378550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 378555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 378560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378576 */     GIR_RootConstrainSelectedInstOperands,
     /* 378577 */     // GIR_Coverage, 11648,
     /* 378577 */     GIR_EraseRootFromParent_Done,
     /* 378578 */   // Label 5777: @378578
     /* 378578 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(378707), // Rule ID 11649 //
     /* 378583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378627 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378627 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378632 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378637 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378650 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378657 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378664 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 378674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 378679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 378684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 378689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378705 */     GIR_RootConstrainSelectedInstOperands,
     /* 378706 */     // GIR_Coverage, 11649,
     /* 378706 */     GIR_EraseRootFromParent_Done,
     /* 378707 */   // Label 5778: @378707
     /* 378707 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(378836), // Rule ID 11650 //
     /* 378712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378756 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378761 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378766 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378779 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378793 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 378803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 378808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 378813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 378818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378834 */     GIR_RootConstrainSelectedInstOperands,
     /* 378835 */     // GIR_Coverage, 11650,
     /* 378835 */     GIR_EraseRootFromParent_Done,
     /* 378836 */   // Label 5779: @378836
     /* 378836 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(378965), // Rule ID 11651 //
     /* 378841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378885 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378885 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 378890 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378890 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 378895 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378908 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378915 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378922 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 378932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 378937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 378942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 378947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378963 */     GIR_RootConstrainSelectedInstOperands,
     /* 378964 */     // GIR_Coverage, 11651,
     /* 378964 */     GIR_EraseRootFromParent_Done,
     /* 378965 */   // Label 5780: @378965
     /* 378965 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(379077), // Rule ID 13250 //
     /* 378970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 378973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 378985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 378997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379005 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 379007 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 379011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379034 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 379054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 379059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 379064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 379069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379075 */     GIR_RootConstrainSelectedInstOperands,
     /* 379076 */     // GIR_Coverage, 13250,
     /* 379076 */     GIR_EraseRootFromParent_Done,
     /* 379077 */   // Label 5781: @379077
     /* 379077 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(379189), // Rule ID 13249 //
     /* 379082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 379097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379117 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 379119 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 379123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379146 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 379166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 379171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 379176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 379181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379187 */     GIR_RootConstrainSelectedInstOperands,
     /* 379188 */     // GIR_Coverage, 13249,
     /* 379188 */     GIR_EraseRootFromParent_Done,
     /* 379189 */   // Label 5782: @379189
     /* 379189 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(379301), // Rule ID 7724 //
     /* 379194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 379209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 379221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379229 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 379231 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 379235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379258 */     // (fminnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 379268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 379273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 379278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 379283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 379288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 379293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379299 */     GIR_RootConstrainSelectedInstOperands,
     /* 379300 */     // GIR_Coverage, 7724,
     /* 379300 */     GIR_EraseRootFromParent_Done,
     /* 379301 */   // Label 5783: @379301
     /* 379301 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(379413), // Rule ID 7723 //
     /* 379306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 379321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379341 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 379343 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 379347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379356 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379363 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379370 */     // (fminnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 379380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 379385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 379390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 379395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 379400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 379405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379411 */     GIR_RootConstrainSelectedInstOperands,
     /* 379412 */     // GIR_Coverage, 7723,
     /* 379412 */     GIR_EraseRootFromParent_Done,
     /* 379413 */   // Label 5784: @379413
     /* 379413 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(379509), // Rule ID 13242 //
     /* 379418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 379433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379441 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 379443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379466 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 379486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 379491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 379496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 379501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379507 */     GIR_RootConstrainSelectedInstOperands,
     /* 379508 */     // GIR_Coverage, 13242,
     /* 379508 */     GIR_EraseRootFromParent_Done,
     /* 379509 */   // Label 5785: @379509
     /* 379509 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(379605), // Rule ID 13241 //
     /* 379514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379537 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 379539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379562 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 379582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 379587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 379592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 379597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379603 */     GIR_RootConstrainSelectedInstOperands,
     /* 379604 */     // GIR_Coverage, 13241,
     /* 379604 */     GIR_EraseRootFromParent_Done,
     /* 379605 */   // Label 5786: @379605
     /* 379605 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(379701), // Rule ID 7716 //
     /* 379610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 379625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379633 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 379635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379658 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 379668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 379673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 379678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 379683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 379688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 379693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379699 */     GIR_RootConstrainSelectedInstOperands,
     /* 379700 */     // GIR_Coverage, 7716,
     /* 379700 */     GIR_EraseRootFromParent_Done,
     /* 379701 */   // Label 5787: @379701
     /* 379701 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(379797), // Rule ID 7715 //
     /* 379706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 379709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379729 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 379731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379740 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379754 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 379757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 379764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 379769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 379774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 379779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 379784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 379789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379795 */     GIR_RootConstrainSelectedInstOperands,
     /* 379796 */     // GIR_Coverage, 7715,
     /* 379796 */     GIR_EraseRootFromParent_Done,
     /* 379797 */   // Label 5788: @379797
     /* 379797 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(379832), // Rule ID 91 //
     /* 379802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 379805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 379809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 379813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 379817 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13798),
     /* 379821 */     // (fminnum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13798>>  =>  (S_MIN_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 379821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F32),
     /* 379826 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 379830 */     GIR_RootConstrainSelectedInstOperands,
     /* 379831 */     // GIR_Coverage, 91,
     /* 379831 */     GIR_Done,
     /* 379832 */   // Label 5789: @379832
     /* 379832 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(379892), // Rule ID 801 //
     /* 379837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 379848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379855 */     // (fminnum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 379855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
     /* 379858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 379865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 379870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 379875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 379880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 379885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 379890 */     GIR_RootConstrainSelectedInstOperands,
     /* 379891 */     // GIR_Coverage, 801,
     /* 379891 */     GIR_EraseRootFromParent_Done,
     /* 379892 */   // Label 5790: @379892
     /* 379892 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(379952), // Rule ID 8416 //
     /* 379897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 379915 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 379915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
     /* 379918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 379925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 379935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 379940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 379945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 379950 */     GIR_RootConstrainSelectedInstOperands,
     /* 379951 */     // GIR_Coverage, 8416,
     /* 379951 */     GIR_EraseRootFromParent_Done,
     /* 379952 */   // Label 5791: @379952
     /* 379952 */   GIM_Reject,
     /* 379953 */ // Label 5652: @379953
     /* 379953 */ GIM_Reject,
     /* 379954 */ // Label 5242: @379954
     /* 379954 */ GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(380206),
     /* 379959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 379962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 379965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 379969 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(380028), // Rule ID 916 //
     /* 379974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 379977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 379984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379991 */     // (fminnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 379991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
     /* 379994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 380001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 380006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 380011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 380021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 380026 */     GIR_RootConstrainSelectedInstOperands,
     /* 380027 */     // GIR_Coverage, 916,
     /* 380027 */     GIR_EraseRootFromParent_Done,
     /* 380028 */   // Label 5793: @380028
     /* 380028 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(380087), // Rule ID 935 //
     /* 380033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 380036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 380043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380050 */     // (fminnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 380050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 380053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 380060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 380065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 380070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 380080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 380085 */     GIR_RootConstrainSelectedInstOperands,
     /* 380086 */     // GIR_Coverage, 935,
     /* 380086 */     GIR_EraseRootFromParent_Done,
     /* 380087 */   // Label 5794: @380087
     /* 380087 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(380146), // Rule ID 8442 //
     /* 380092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 380095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 380109 */     // (fminnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 380109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
     /* 380112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 380119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 380124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 380129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 380134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 380139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 380144 */     GIR_RootConstrainSelectedInstOperands,
     /* 380145 */     // GIR_Coverage, 8442,
     /* 380145 */     GIR_EraseRootFromParent_Done,
     /* 380146 */   // Label 5795: @380146
     /* 380146 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(380205), // Rule ID 8456 //
     /* 380151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 380154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 380168 */     // (fminnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 380168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 380171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 380178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 380183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 380188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 380193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 380198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 380203 */     GIR_RootConstrainSelectedInstOperands,
     /* 380204 */     // GIR_Coverage, 8456,
     /* 380204 */     GIR_EraseRootFromParent_Done,
     /* 380205 */   // Label 5796: @380205
     /* 380205 */   GIM_Reject,
     /* 380206 */ // Label 5792: @380206
     /* 380206 */ GIM_Reject,
     /* 380207 */ // Label 5243: @380207
     /* 380207 */ GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(380278), // Rule ID 1097 //
     /* 380212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 380215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 380218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380222 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 380229 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 380236 */   // (fminnum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 380236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_F16),
     /* 380239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 380246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 380251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 380256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380276 */   GIR_RootConstrainSelectedInstOperands,
     /* 380277 */   // GIR_Coverage, 1097,
     /* 380277 */   GIR_EraseRootFromParent_Done,
     /* 380278 */ // Label 5797: @380278
     /* 380278 */ GIM_Reject,
     /* 380279 */ // Label 5244: @380279
     /* 380279 */ GIM_Reject,
     /* 380280 */ // Label 81: @380280
     /* 380280 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5802*/ GIMT_Encode4(452058),
     /* 380291 */ /*GILLT_s16*//*Label 5798*/ GIMT_Encode4(380307),
     /* 380295 */ /*GILLT_s32*//*Label 5799*/ GIMT_Encode4(434221),
     /* 380299 */ /*GILLT_s64*//*Label 5800*/ GIMT_Encode4(451733),
     /* 380303 */ /*GILLT_v2s16*//*Label 5801*/ GIMT_Encode4(451986),
     /* 380307 */ // Label 5798: @380307
     /* 380307 */ GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(434220),
     /* 380312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 380315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 380318 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(380453), // Rule ID 12017 //
     /* 380323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 380326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 380346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 380358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 380362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 380370 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380370 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 380375 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 380380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 380384 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380400 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380407 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 380410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 380417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 380422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 380427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 380437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 380442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380451 */     GIR_RootConstrainSelectedInstOperands,
     /* 380452 */     // GIR_Coverage, 12017,
     /* 380452 */     GIR_EraseRootFromParent_Done,
     /* 380453 */   // Label 5804: @380453
     /* 380453 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(380588), // Rule ID 12018 //
     /* 380458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 380461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 380481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 380493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 380497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 380505 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 380510 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 380515 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 380519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380535 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380542 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 380545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 380552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 380557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 380562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 380572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 380577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380586 */     GIR_RootConstrainSelectedInstOperands,
     /* 380587 */     // GIR_Coverage, 12018,
     /* 380587 */     GIR_EraseRootFromParent_Done,
     /* 380588 */   // Label 5805: @380588
     /* 380588 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(380723), // Rule ID 12021 //
     /* 380593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 380596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 380616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 380628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 380632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 380640 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 380645 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 380650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 380654 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380670 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380677 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 380680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 380687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 380692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 380697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 380702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 380707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 380712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380721 */     GIR_RootConstrainSelectedInstOperands,
     /* 380722 */     // GIR_Coverage, 12021,
     /* 380722 */     GIR_EraseRootFromParent_Done,
     /* 380723 */   // Label 5806: @380723
     /* 380723 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(380858), // Rule ID 12022 //
     /* 380728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 380731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 380751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 380763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 380767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 380775 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 380780 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380780 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 380785 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 380789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380805 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380812 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 380815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 380822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 380827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 380832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 380837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 380842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 380847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380856 */     GIR_RootConstrainSelectedInstOperands,
     /* 380857 */     // GIR_Coverage, 12022,
     /* 380857 */     GIR_EraseRootFromParent_Done,
     /* 380858 */   // Label 5807: @380858
     /* 380858 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(380993), // Rule ID 12497 //
     /* 380863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 380866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 380870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 380882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 380886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 380898 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 380902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 380910 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 380915 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380915 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 380920 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 380924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380940 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380947 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 380950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 380957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 380962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 380967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 380977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 380982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380991 */     GIR_RootConstrainSelectedInstOperands,
     /* 380992 */     // GIR_Coverage, 12497,
     /* 380992 */     GIR_EraseRootFromParent_Done,
     /* 380993 */   // Label 5808: @380993
     /* 380993 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(381128), // Rule ID 12498 //
     /* 380998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 381001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 381005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381045 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381045 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381050 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381050 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381055 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381059 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381075 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381082 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 381085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 381092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 381097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 381102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 381107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381126 */     GIR_RootConstrainSelectedInstOperands,
     /* 381127 */     // GIR_Coverage, 12498,
     /* 381127 */     GIR_EraseRootFromParent_Done,
     /* 381128 */   // Label 5809: @381128
     /* 381128 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(381263), // Rule ID 12501 //
     /* 381133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 381136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 381140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381180 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381180 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381185 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381194 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381210 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381217 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 381220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 381227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 381232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 381237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 381242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381261 */     GIR_RootConstrainSelectedInstOperands,
     /* 381262 */     // GIR_Coverage, 12501,
     /* 381262 */     GIR_EraseRootFromParent_Done,
     /* 381263 */   // Label 5810: @381263
     /* 381263 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(381398), // Rule ID 12502 //
     /* 381268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 381271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 381275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381315 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381320 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381352 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 381355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 381362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 381367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 381372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 381377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381396 */     GIR_RootConstrainSelectedInstOperands,
     /* 381397 */     // GIR_Coverage, 12502,
     /* 381397 */     GIR_EraseRootFromParent_Done,
     /* 381398 */   // Label 5811: @381398
     /* 381398 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(381533), // Rule ID 12977 //
     /* 381403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 381406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381450 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381455 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381460 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381487 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 381490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 381497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 381502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 381507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 381512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381531 */     GIR_RootConstrainSelectedInstOperands,
     /* 381532 */     // GIR_Coverage, 12977,
     /* 381532 */     GIR_EraseRootFromParent_Done,
     /* 381533 */   // Label 5812: @381533
     /* 381533 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(381668), // Rule ID 12978 //
     /* 381538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 381541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381585 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381590 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381590 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381595 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381608 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381615 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381622 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 381625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 381632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 381637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 381642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 381647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381666 */     GIR_RootConstrainSelectedInstOperands,
     /* 381667 */     // GIR_Coverage, 12978,
     /* 381667 */     GIR_EraseRootFromParent_Done,
     /* 381668 */   // Label 5813: @381668
     /* 381668 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(381803), // Rule ID 12981 //
     /* 381673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 381676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381712 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381716 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381720 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381720 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381725 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381725 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381730 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381750 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381757 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 381760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 381767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 381772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 381777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 381782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381801 */     GIR_RootConstrainSelectedInstOperands,
     /* 381802 */     // GIR_Coverage, 12981,
     /* 381802 */     GIR_EraseRootFromParent_Done,
     /* 381803 */   // Label 5814: @381803
     /* 381803 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(381938), // Rule ID 12982 //
     /* 381808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 381811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381855 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381855 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381860 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 381865 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 381869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381892 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 381895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 381902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 381907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 381912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 381917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381936 */     GIR_RootConstrainSelectedInstOperands,
     /* 381937 */     // GIR_Coverage, 12982,
     /* 381937 */     GIR_EraseRootFromParent_Done,
     /* 381938 */   // Label 5815: @381938
     /* 381938 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(382073), // Rule ID 12002 //
     /* 381943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 381946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 381962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 381966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 381978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 381982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 381990 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 381995 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382027 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 382030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 382037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 382042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 382047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 382052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382071 */     GIR_RootConstrainSelectedInstOperands,
     /* 382072 */     // GIR_Coverage, 12002,
     /* 382072 */     GIR_EraseRootFromParent_Done,
     /* 382073 */   // Label 5816: @382073
     /* 382073 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(382208), // Rule ID 12003 //
     /* 382078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 382081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382125 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382130 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382135 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382155 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382162 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 382165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 382172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 382177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 382182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 382187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382206 */     GIR_RootConstrainSelectedInstOperands,
     /* 382207 */     // GIR_Coverage, 12003,
     /* 382207 */     GIR_EraseRootFromParent_Done,
     /* 382208 */   // Label 5817: @382208
     /* 382208 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(382343), // Rule ID 12006 //
     /* 382213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 382216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382260 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382265 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382265 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382270 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382290 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382297 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 382300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 382307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 382312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 382317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 382322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382341 */     GIR_RootConstrainSelectedInstOperands,
     /* 382342 */     // GIR_Coverage, 12006,
     /* 382342 */     GIR_EraseRootFromParent_Done,
     /* 382343 */   // Label 5818: @382343
     /* 382343 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(382478), // Rule ID 12007 //
     /* 382348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 382351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382395 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382395 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382400 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382400 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382405 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382409 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382425 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382432 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 382435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 382442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 382447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 382452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 382457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382476 */     GIR_RootConstrainSelectedInstOperands,
     /* 382477 */     // GIR_Coverage, 12007,
     /* 382477 */     GIR_EraseRootFromParent_Done,
     /* 382478 */   // Label 5819: @382478
     /* 382478 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(382613), // Rule ID 12482 //
     /* 382483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 382486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 382490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382522 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382526 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382530 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382530 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382535 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382540 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382560 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382567 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 382570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 382577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 382582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 382587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 382592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382611 */     GIR_RootConstrainSelectedInstOperands,
     /* 382612 */     // GIR_Coverage, 12482,
     /* 382612 */     GIR_EraseRootFromParent_Done,
     /* 382613 */   // Label 5820: @382613
     /* 382613 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(382748), // Rule ID 12483 //
     /* 382618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 382621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 382625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382665 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382665 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382670 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382675 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382702 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 382705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 382712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 382717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 382722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 382727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382746 */     GIR_RootConstrainSelectedInstOperands,
     /* 382747 */     // GIR_Coverage, 12483,
     /* 382747 */     GIR_EraseRootFromParent_Done,
     /* 382748 */   // Label 5821: @382748
     /* 382748 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(382883), // Rule ID 12486 //
     /* 382753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 382756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 382760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382792 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382796 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382800 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382805 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382810 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382814 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382837 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 382840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 382847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 382852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 382857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 382862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382881 */     GIR_RootConstrainSelectedInstOperands,
     /* 382882 */     // GIR_Coverage, 12486,
     /* 382882 */     GIR_EraseRootFromParent_Done,
     /* 382883 */   // Label 5822: @382883
     /* 382883 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(383018), // Rule ID 12487 //
     /* 382888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 382891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 382895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 382907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 382911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 382923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 382927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382935 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 382940 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 382945 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 382949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382972 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 382975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 382982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 382987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 382992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 382997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383016 */     GIR_RootConstrainSelectedInstOperands,
     /* 383017 */     // GIR_Coverage, 12487,
     /* 383017 */     GIR_EraseRootFromParent_Done,
     /* 383018 */   // Label 5823: @383018
     /* 383018 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(383153), // Rule ID 12962 //
     /* 383023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 383026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383070 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383070 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383075 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383075 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383080 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383100 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383107 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 383110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 383117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 383122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 383127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 383132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383151 */     GIR_RootConstrainSelectedInstOperands,
     /* 383152 */     // GIR_Coverage, 12962,
     /* 383152 */     GIR_EraseRootFromParent_Done,
     /* 383153 */   // Label 5824: @383153
     /* 383153 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(383288), // Rule ID 12963 //
     /* 383158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 383161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383205 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383205 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383210 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383210 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383215 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383219 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383242 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 383245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 383252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 383257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 383262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 383267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383286 */     GIR_RootConstrainSelectedInstOperands,
     /* 383287 */     // GIR_Coverage, 12963,
     /* 383287 */     GIR_EraseRootFromParent_Done,
     /* 383288 */   // Label 5825: @383288
     /* 383288 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(383423), // Rule ID 12966 //
     /* 383293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 383296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383340 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383340 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383345 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383377 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 383380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 383387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 383392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 383397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 383402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383421 */     GIR_RootConstrainSelectedInstOperands,
     /* 383422 */     // GIR_Coverage, 12966,
     /* 383422 */     GIR_EraseRootFromParent_Done,
     /* 383423 */   // Label 5826: @383423
     /* 383423 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(383558), // Rule ID 12967 //
     /* 383428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 383431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383475 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383480 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383480 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383485 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383505 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383512 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 383515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 383522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 383527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 383532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 383537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383556 */     GIR_RootConstrainSelectedInstOperands,
     /* 383557 */     // GIR_Coverage, 12967,
     /* 383557 */     GIR_EraseRootFromParent_Done,
     /* 383558 */   // Label 5827: @383558
     /* 383558 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(383693), // Rule ID 7624 //
     /* 383563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 383566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 383606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 383610 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383615 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383615 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383620 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383624 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383647 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 383650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 383657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 383662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 383667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 383672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383691 */     GIR_RootConstrainSelectedInstOperands,
     /* 383692 */     // GIR_Coverage, 7624,
     /* 383692 */     GIR_EraseRootFromParent_Done,
     /* 383693 */   // Label 5828: @383693
     /* 383693 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(383828), // Rule ID 7656 //
     /* 383698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 383701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 383705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 383741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 383745 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383750 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383750 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383755 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383759 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383775 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383782 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 383785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 383792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 383797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 383802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 383807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383826 */     GIR_RootConstrainSelectedInstOperands,
     /* 383827 */     // GIR_Coverage, 7656,
     /* 383827 */     GIR_EraseRootFromParent_Done,
     /* 383828 */   // Label 5829: @383828
     /* 383828 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(383963), // Rule ID 7688 //
     /* 383833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 383836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 383872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 383876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 383880 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383880 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 383885 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383885 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 383890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 383894 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383910 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383917 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 383920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 383927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 383932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 383937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 383942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383961 */     GIR_RootConstrainSelectedInstOperands,
     /* 383962 */     // GIR_Coverage, 7688,
     /* 383962 */     GIR_EraseRootFromParent_Done,
     /* 383963 */   // Label 5830: @383963
     /* 383963 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(384098), // Rule ID 12016 //
     /* 383968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 383971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 383991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 383999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384015 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384015 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384020 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384025 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384045 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384052 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 384055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 384062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 384072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384096 */     GIR_RootConstrainSelectedInstOperands,
     /* 384097 */     // GIR_Coverage, 12016,
     /* 384097 */     GIR_EraseRootFromParent_Done,
     /* 384098 */   // Label 5831: @384098
     /* 384098 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(384233), // Rule ID 12019 //
     /* 384103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 384106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384150 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384155 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384155 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384160 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384187 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 384190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 384197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 384202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 384207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 384212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384231 */     GIR_RootConstrainSelectedInstOperands,
     /* 384232 */     // GIR_Coverage, 12019,
     /* 384232 */     GIR_EraseRootFromParent_Done,
     /* 384233 */   // Label 5832: @384233
     /* 384233 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(384368), // Rule ID 12020 //
     /* 384238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 384241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384285 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384290 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384295 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384322 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 384325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 384332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 384337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 384342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 384347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384366 */     GIR_RootConstrainSelectedInstOperands,
     /* 384367 */     // GIR_Coverage, 12020,
     /* 384367 */     GIR_EraseRootFromParent_Done,
     /* 384368 */   // Label 5833: @384368
     /* 384368 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(384503), // Rule ID 12496 //
     /* 384373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 384376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 384380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384416 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384420 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384425 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384425 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384430 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384457 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 384460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 384467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 384477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384501 */     GIR_RootConstrainSelectedInstOperands,
     /* 384502 */     // GIR_Coverage, 12496,
     /* 384502 */     GIR_EraseRootFromParent_Done,
     /* 384503 */   // Label 5834: @384503
     /* 384503 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(384638), // Rule ID 12499 //
     /* 384508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 384511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 384515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384555 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384555 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384560 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384560 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384565 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384569 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384585 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384592 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 384595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 384602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 384607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 384612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 384617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384636 */     GIR_RootConstrainSelectedInstOperands,
     /* 384637 */     // GIR_Coverage, 12499,
     /* 384637 */     GIR_EraseRootFromParent_Done,
     /* 384638 */   // Label 5835: @384638
     /* 384638 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(384773), // Rule ID 12500 //
     /* 384643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 384646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 384650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384690 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384690 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384695 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384700 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384727 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 384730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 384737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 384742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 384747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 384752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384771 */     GIR_RootConstrainSelectedInstOperands,
     /* 384772 */     // GIR_Coverage, 12500,
     /* 384772 */     GIR_EraseRootFromParent_Done,
     /* 384773 */   // Label 5836: @384773
     /* 384773 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(384908), // Rule ID 12976 //
     /* 384778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 384781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384825 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384825 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384830 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384830 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384835 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384862 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 384865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 384872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 384882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384906 */     GIR_RootConstrainSelectedInstOperands,
     /* 384907 */     // GIR_Coverage, 12976,
     /* 384907 */     GIR_EraseRootFromParent_Done,
     /* 384908 */   // Label 5837: @384908
     /* 384908 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(385043), // Rule ID 12979 //
     /* 384913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 384916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 384956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384960 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384965 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384965 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384997 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 385000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 385007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 385012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 385017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 385022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385041 */     GIR_RootConstrainSelectedInstOperands,
     /* 385042 */     // GIR_Coverage, 12979,
     /* 385042 */     GIR_EraseRootFromParent_Done,
     /* 385043 */   // Label 5838: @385043
     /* 385043 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(385178), // Rule ID 12980 //
     /* 385048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 385051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 385095 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385100 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385100 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385105 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385132 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 385135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 385142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 385147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 385152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 385157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385176 */     GIR_RootConstrainSelectedInstOperands,
     /* 385177 */     // GIR_Coverage, 12980,
     /* 385177 */     GIR_EraseRootFromParent_Done,
     /* 385178 */   // Label 5839: @385178
     /* 385178 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(385313), // Rule ID 7623 //
     /* 385183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 385186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 385230 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385230 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385235 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385235 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385240 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385244 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385267 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 385270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 385277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 385282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 385287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 385292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385311 */     GIR_RootConstrainSelectedInstOperands,
     /* 385312 */     // GIR_Coverage, 7623,
     /* 385312 */     GIR_EraseRootFromParent_Done,
     /* 385313 */   // Label 5840: @385313
     /* 385313 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(385448), // Rule ID 7655 //
     /* 385318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 385321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 385325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385361 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 385365 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385365 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385370 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385370 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385395 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385402 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 385405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 385412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 385417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 385422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 385427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385446 */     GIR_RootConstrainSelectedInstOperands,
     /* 385447 */     // GIR_Coverage, 7655,
     /* 385447 */     GIR_EraseRootFromParent_Done,
     /* 385448 */   // Label 5841: @385448
     /* 385448 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(385583), // Rule ID 7687 //
     /* 385453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 385456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 385500 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385500 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385505 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385510 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385537 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 385540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 385547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 385552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 385557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 385562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385581 */     GIR_RootConstrainSelectedInstOperands,
     /* 385582 */     // GIR_Coverage, 7687,
     /* 385582 */     GIR_EraseRootFromParent_Done,
     /* 385583 */   // Label 5842: @385583
     /* 385583 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(385718), // Rule ID 12001 //
     /* 385588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 385591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 385635 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385640 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385649 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385672 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 385675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 385682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 385687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 385692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 385697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385716 */     GIR_RootConstrainSelectedInstOperands,
     /* 385717 */     // GIR_Coverage, 12001,
     /* 385717 */     GIR_EraseRootFromParent_Done,
     /* 385718 */   // Label 5843: @385718
     /* 385718 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(385853), // Rule ID 12004 //
     /* 385723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 385726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 385770 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385775 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385780 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385807 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 385810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 385817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 385822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 385827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 385832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385851 */     GIR_RootConstrainSelectedInstOperands,
     /* 385852 */     // GIR_Coverage, 12004,
     /* 385852 */     GIR_EraseRootFromParent_Done,
     /* 385853 */   // Label 5844: @385853
     /* 385853 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(385988), // Rule ID 12005 //
     /* 385858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 385861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 385901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 385905 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385910 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385915 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385942 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 385945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 385952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 385957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 385962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 385967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385986 */     GIR_RootConstrainSelectedInstOperands,
     /* 385987 */     // GIR_Coverage, 12005,
     /* 385987 */     GIR_EraseRootFromParent_Done,
     /* 385988 */   // Label 5845: @385988
     /* 385988 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(386123), // Rule ID 12481 //
     /* 385993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 385996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 386000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386040 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386040 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386045 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386045 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386070 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386077 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 386080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 386087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 386092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 386097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 386102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386121 */     GIR_RootConstrainSelectedInstOperands,
     /* 386122 */     // GIR_Coverage, 12481,
     /* 386122 */     GIR_EraseRootFromParent_Done,
     /* 386123 */   // Label 5846: @386123
     /* 386123 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(386258), // Rule ID 12484 //
     /* 386128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 386131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 386135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386167 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386171 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386175 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386175 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386180 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386180 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386185 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386212 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 386215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 386222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 386227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 386232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 386237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386256 */     GIR_RootConstrainSelectedInstOperands,
     /* 386257 */     // GIR_Coverage, 12484,
     /* 386257 */     GIR_EraseRootFromParent_Done,
     /* 386258 */   // Label 5847: @386258
     /* 386258 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(386393), // Rule ID 12485 //
     /* 386263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 386266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 386270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386310 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386315 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386320 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386347 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 386350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 386357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 386362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 386367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 386372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386391 */     GIR_RootConstrainSelectedInstOperands,
     /* 386392 */     // GIR_Coverage, 12485,
     /* 386392 */     GIR_EraseRootFromParent_Done,
     /* 386393 */   // Label 5848: @386393
     /* 386393 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(386528), // Rule ID 12961 //
     /* 386398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 386401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386445 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386450 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386455 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386482 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 386485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 386492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 386497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 386502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 386507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386526 */     GIR_RootConstrainSelectedInstOperands,
     /* 386527 */     // GIR_Coverage, 12961,
     /* 386527 */     GIR_EraseRootFromParent_Done,
     /* 386528 */   // Label 5849: @386528
     /* 386528 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(386663), // Rule ID 12964 //
     /* 386533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 386536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386580 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386585 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386590 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386617 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 386620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 386627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 386632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 386637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 386642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386661 */     GIR_RootConstrainSelectedInstOperands,
     /* 386662 */     // GIR_Coverage, 12964,
     /* 386662 */     GIR_EraseRootFromParent_Done,
     /* 386663 */   // Label 5850: @386663
     /* 386663 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(386798), // Rule ID 12965 //
     /* 386668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 386671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 386711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386715 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386715 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386720 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386720 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386729 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386752 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 386755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 386762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 386767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 386772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 386777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386796 */     GIR_RootConstrainSelectedInstOperands,
     /* 386797 */     // GIR_Coverage, 12965,
     /* 386797 */     GIR_EraseRootFromParent_Done,
     /* 386798 */   // Label 5851: @386798
     /* 386798 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(386933), // Rule ID 11987 //
     /* 386803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 386806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 386834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386842 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386846 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 386850 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386850 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386855 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386855 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386860 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386880 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386887 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 386890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 386897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 386902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 386907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 386912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386931 */     GIR_RootConstrainSelectedInstOperands,
     /* 386932 */     // GIR_Coverage, 11987,
     /* 386932 */     GIR_EraseRootFromParent_Done,
     /* 386933 */   // Label 5852: @386933
     /* 386933 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(387068), // Rule ID 11988 //
     /* 386938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 386941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 386969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 386985 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386985 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386990 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386995 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387022 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 387025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 387032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 387037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 387042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 387047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387066 */     GIR_RootConstrainSelectedInstOperands,
     /* 387067 */     // GIR_Coverage, 11988,
     /* 387067 */     GIR_EraseRootFromParent_Done,
     /* 387068 */   // Label 5853: @387068
     /* 387068 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(387203), // Rule ID 11991 //
     /* 387073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 387076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 387080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387120 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387125 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387150 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387157 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 387160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 387167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 387172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 387177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 387182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387201 */     GIR_RootConstrainSelectedInstOperands,
     /* 387202 */     // GIR_Coverage, 11991,
     /* 387202 */     GIR_EraseRootFromParent_Done,
     /* 387203 */   // Label 5854: @387203
     /* 387203 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(387338), // Rule ID 11992 //
     /* 387208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 387211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 387215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387255 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387260 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387292 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 387295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 387302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 387307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 387312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 387317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387336 */     GIR_RootConstrainSelectedInstOperands,
     /* 387337 */     // GIR_Coverage, 11992,
     /* 387337 */     GIR_EraseRootFromParent_Done,
     /* 387338 */   // Label 5855: @387338
     /* 387338 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(387473), // Rule ID 12467 //
     /* 387343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 387346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 387350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387390 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387395 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387395 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387400 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387404 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387427 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 387430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 387437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 387442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 387447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 387452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387471 */     GIR_RootConstrainSelectedInstOperands,
     /* 387472 */     // GIR_Coverage, 12467,
     /* 387472 */     GIR_EraseRootFromParent_Done,
     /* 387473 */   // Label 5856: @387473
     /* 387473 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(387608), // Rule ID 12468 //
     /* 387478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 387481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 387485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387525 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387525 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387530 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387530 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387535 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387539 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387555 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387562 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 387565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 387572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 387577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 387582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 387587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387606 */     GIR_RootConstrainSelectedInstOperands,
     /* 387607 */     // GIR_Coverage, 12468,
     /* 387607 */     GIR_EraseRootFromParent_Done,
     /* 387608 */   // Label 5857: @387608
     /* 387608 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(387743), // Rule ID 12471 //
     /* 387613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 387616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 387620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387660 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387665 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387665 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387670 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387674 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387697 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 387700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 387707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 387712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 387717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 387722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387741 */     GIR_RootConstrainSelectedInstOperands,
     /* 387742 */     // GIR_Coverage, 12471,
     /* 387742 */     GIR_EraseRootFromParent_Done,
     /* 387743 */   // Label 5858: @387743
     /* 387743 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(387878), // Rule ID 12472 //
     /* 387748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 387751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 387755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387795 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387800 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387832 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 387835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 387842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 387847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 387852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 387857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387876 */     GIR_RootConstrainSelectedInstOperands,
     /* 387877 */     // GIR_Coverage, 12472,
     /* 387877 */     GIR_EraseRootFromParent_Done,
     /* 387878 */   // Label 5859: @387878
     /* 387878 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(388013), // Rule ID 12947 //
     /* 387883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 387886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 387890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 387914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 387930 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387935 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387940 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387967 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 387970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 387977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 387982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 387987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 387992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388011 */     GIR_RootConstrainSelectedInstOperands,
     /* 388012 */     // GIR_Coverage, 12947,
     /* 388012 */     GIR_EraseRootFromParent_Done,
     /* 388013 */   // Label 5860: @388013
     /* 388013 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(388148), // Rule ID 12948 //
     /* 388018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 388021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388065 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388070 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388070 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388079 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388102 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 388105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 388112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 388117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 388122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 388127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388146 */     GIR_RootConstrainSelectedInstOperands,
     /* 388147 */     // GIR_Coverage, 12948,
     /* 388147 */     GIR_EraseRootFromParent_Done,
     /* 388148 */   // Label 5861: @388148
     /* 388148 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(388283), // Rule ID 12951 //
     /* 388153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 388156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388200 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388200 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388205 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388205 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388210 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388237 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 388240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 388247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 388252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 388257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 388262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388281 */     GIR_RootConstrainSelectedInstOperands,
     /* 388282 */     // GIR_Coverage, 12951,
     /* 388282 */     GIR_EraseRootFromParent_Done,
     /* 388283 */   // Label 5862: @388283
     /* 388283 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(388418), // Rule ID 12952 //
     /* 388288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 388291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388335 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388335 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388340 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388340 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388345 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388349 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388372 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 388375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 388382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 388387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 388392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 388397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388416 */     GIR_RootConstrainSelectedInstOperands,
     /* 388417 */     // GIR_Coverage, 12952,
     /* 388417 */     GIR_EraseRootFromParent_Done,
     /* 388418 */   // Label 5863: @388418
     /* 388418 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(388553), // Rule ID 11972 //
     /* 388423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 388426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388466 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 388470 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388470 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388475 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388480 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388507 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 388510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 388517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 388522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 388527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 388532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388551 */     GIR_RootConstrainSelectedInstOperands,
     /* 388552 */     // GIR_Coverage, 11972,
     /* 388552 */     GIR_EraseRootFromParent_Done,
     /* 388553 */   // Label 5864: @388553
     /* 388553 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(388688), // Rule ID 11973 //
     /* 388558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 388561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 388605 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388610 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388642 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 388645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 388652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 388657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 388662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 388667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388686 */     GIR_RootConstrainSelectedInstOperands,
     /* 388687 */     // GIR_Coverage, 11973,
     /* 388687 */     GIR_EraseRootFromParent_Done,
     /* 388688 */   // Label 5865: @388688
     /* 388688 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(388823), // Rule ID 11976 //
     /* 388693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 388696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 388740 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388745 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388777 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 388780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 388787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 388792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 388797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 388802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388821 */     GIR_RootConstrainSelectedInstOperands,
     /* 388822 */     // GIR_Coverage, 11976,
     /* 388822 */     GIR_EraseRootFromParent_Done,
     /* 388823 */   // Label 5866: @388823
     /* 388823 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(388958), // Rule ID 11977 //
     /* 388828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 388831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 388875 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388875 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388880 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388880 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388885 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388889 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388905 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388912 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 388915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 388922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 388927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 388932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 388937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388956 */     GIR_RootConstrainSelectedInstOperands,
     /* 388957 */     // GIR_Coverage, 11977,
     /* 388957 */     GIR_EraseRootFromParent_Done,
     /* 388958 */   // Label 5867: @388958
     /* 388958 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(389093), // Rule ID 12452 //
     /* 388963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 388966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 388970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 388994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389006 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389010 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389010 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389015 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389015 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389020 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389047 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 389050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 389057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 389062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 389067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 389072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389091 */     GIR_RootConstrainSelectedInstOperands,
     /* 389092 */     // GIR_Coverage, 12452,
     /* 389092 */     GIR_EraseRootFromParent_Done,
     /* 389093 */   // Label 5868: @389093
     /* 389093 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(389228), // Rule ID 12453 //
     /* 389098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 389101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 389105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389145 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389145 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389150 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389155 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389182 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 389185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 389192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 389197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 389202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 389207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389226 */     GIR_RootConstrainSelectedInstOperands,
     /* 389227 */     // GIR_Coverage, 12453,
     /* 389227 */     GIR_EraseRootFromParent_Done,
     /* 389228 */   // Label 5869: @389228
     /* 389228 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(389363), // Rule ID 12456 //
     /* 389233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 389236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 389240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389280 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389285 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389290 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389294 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389317 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 389320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 389327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 389332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 389337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 389342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389361 */     GIR_RootConstrainSelectedInstOperands,
     /* 389362 */     // GIR_Coverage, 12456,
     /* 389362 */     GIR_EraseRootFromParent_Done,
     /* 389363 */   // Label 5870: @389363
     /* 389363 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(389498), // Rule ID 12457 //
     /* 389368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 389371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 389375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389415 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389420 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389452 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 389455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 389462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 389467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 389472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 389477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389496 */     GIR_RootConstrainSelectedInstOperands,
     /* 389497 */     // GIR_Coverage, 12457,
     /* 389497 */     GIR_EraseRootFromParent_Done,
     /* 389498 */   // Label 5871: @389498
     /* 389498 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(389633), // Rule ID 12932 //
     /* 389503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 389506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 389510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389550 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389550 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389555 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389555 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389587 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 389590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 389597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 389602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 389607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 389612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389631 */     GIR_RootConstrainSelectedInstOperands,
     /* 389632 */     // GIR_Coverage, 12932,
     /* 389632 */     GIR_EraseRootFromParent_Done,
     /* 389633 */   // Label 5872: @389633
     /* 389633 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(389768), // Rule ID 12933 //
     /* 389638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 389641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 389645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389673 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389685 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389685 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389690 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389690 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389699 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389715 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389722 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 389725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 389732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 389737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 389742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 389747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389766 */     GIR_RootConstrainSelectedInstOperands,
     /* 389767 */     // GIR_Coverage, 12933,
     /* 389767 */     GIR_EraseRootFromParent_Done,
     /* 389768 */   // Label 5873: @389768
     /* 389768 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(389903), // Rule ID 12936 //
     /* 389773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 389776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 389780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389820 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389820 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389825 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389825 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389830 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389850 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389857 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 389860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 389867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 389872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 389877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 389882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389901 */     GIR_RootConstrainSelectedInstOperands,
     /* 389902 */     // GIR_Coverage, 12936,
     /* 389902 */     GIR_EraseRootFromParent_Done,
     /* 389903 */   // Label 5874: @389903
     /* 389903 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(390038), // Rule ID 12937 //
     /* 389908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 389911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 389915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 389939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389955 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389960 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389992 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 389995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 390002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 390007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 390012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 390017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390036 */     GIR_RootConstrainSelectedInstOperands,
     /* 390037 */     // GIR_Coverage, 12937,
     /* 390037 */     GIR_EraseRootFromParent_Done,
     /* 390038 */   // Label 5875: @390038
     /* 390038 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(390173), // Rule ID 7622 //
     /* 390043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 390046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 390090 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390095 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390127 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 390130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 390137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 390142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 390147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 390152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390171 */     GIR_RootConstrainSelectedInstOperands,
     /* 390172 */     // GIR_Coverage, 7622,
     /* 390172 */     GIR_EraseRootFromParent_Done,
     /* 390173 */   // Label 5876: @390173
     /* 390173 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(390308), // Rule ID 7654 //
     /* 390178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 390181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 390185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 390225 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390230 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390230 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390235 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390262 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 390265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 390272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 390277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 390282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 390287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390306 */     GIR_RootConstrainSelectedInstOperands,
     /* 390307 */     // GIR_Coverage, 7654,
     /* 390307 */     GIR_EraseRootFromParent_Done,
     /* 390308 */   // Label 5877: @390308
     /* 390308 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(390443), // Rule ID 7686 //
     /* 390313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 390316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 390360 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390360 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390365 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390365 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390390 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390397 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 390400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 390407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 390412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 390417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 390422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390441 */     GIR_RootConstrainSelectedInstOperands,
     /* 390442 */     // GIR_Coverage, 7686,
     /* 390442 */     GIR_EraseRootFromParent_Done,
     /* 390443 */   // Label 5878: @390443
     /* 390443 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(390578), // Rule ID 11986 //
     /* 390448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 390451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 390495 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390495 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390500 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390500 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390509 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390511 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390532 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 390535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 390542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 390547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 390552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 390557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390576 */     GIR_RootConstrainSelectedInstOperands,
     /* 390577 */     // GIR_Coverage, 11986,
     /* 390577 */     GIR_EraseRootFromParent_Done,
     /* 390578 */   // Label 5879: @390578
     /* 390578 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(390713), // Rule ID 11989 //
     /* 390583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 390586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 390630 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390630 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390635 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390667 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 390670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 390677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 390682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 390687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 390692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390711 */     GIR_RootConstrainSelectedInstOperands,
     /* 390712 */     // GIR_Coverage, 11989,
     /* 390712 */     GIR_EraseRootFromParent_Done,
     /* 390713 */   // Label 5880: @390713
     /* 390713 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(390848), // Rule ID 11990 //
     /* 390718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 390721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 390765 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390770 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390775 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390802 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 390805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 390812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 390817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 390822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 390827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390846 */     GIR_RootConstrainSelectedInstOperands,
     /* 390847 */     // GIR_Coverage, 11990,
     /* 390847 */     GIR_EraseRootFromParent_Done,
     /* 390848 */   // Label 5881: @390848
     /* 390848 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(390983), // Rule ID 12466 //
     /* 390853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 390856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 390860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 390884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 390900 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390905 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390937 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 390940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 390947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 390952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 390957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 390962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390981 */     GIR_RootConstrainSelectedInstOperands,
     /* 390982 */     // GIR_Coverage, 12466,
     /* 390982 */     GIR_EraseRootFromParent_Done,
     /* 390983 */   // Label 5882: @390983
     /* 390983 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(391118), // Rule ID 12469 //
     /* 390988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 390991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 390995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391023 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391035 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391035 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391040 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391040 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391045 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391072 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 391075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 391082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 391087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 391092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 391097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391116 */     GIR_RootConstrainSelectedInstOperands,
     /* 391117 */     // GIR_Coverage, 12469,
     /* 391117 */     GIR_EraseRootFromParent_Done,
     /* 391118 */   // Label 5883: @391118
     /* 391118 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(391253), // Rule ID 12470 //
     /* 391123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 391126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 391130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391158 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391170 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391170 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391175 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391175 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391180 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391184 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391207 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 391210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 391217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 391222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 391227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 391232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391251 */     GIR_RootConstrainSelectedInstOperands,
     /* 391252 */     // GIR_Coverage, 12470,
     /* 391252 */     GIR_EraseRootFromParent_Done,
     /* 391253 */   // Label 5884: @391253
     /* 391253 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(391388), // Rule ID 12946 //
     /* 391258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 391261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391305 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391305 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391310 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391342 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 391345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 391352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 391357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 391362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 391367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391386 */     GIR_RootConstrainSelectedInstOperands,
     /* 391387 */     // GIR_Coverage, 12946,
     /* 391387 */     GIR_EraseRootFromParent_Done,
     /* 391388 */   // Label 5885: @391388
     /* 391388 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(391523), // Rule ID 12949 //
     /* 391393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 391396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391440 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391440 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391445 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391450 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391477 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 391480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 391487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 391492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 391497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 391502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391521 */     GIR_RootConstrainSelectedInstOperands,
     /* 391522 */     // GIR_Coverage, 12949,
     /* 391522 */     GIR_EraseRootFromParent_Done,
     /* 391523 */   // Label 5886: @391523
     /* 391523 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(391658), // Rule ID 12950 //
     /* 391528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 391531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391575 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391580 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391612 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 391615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 391622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 391627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 391632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 391637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391656 */     GIR_RootConstrainSelectedInstOperands,
     /* 391657 */     // GIR_Coverage, 12950,
     /* 391657 */     GIR_EraseRootFromParent_Done,
     /* 391658 */   // Label 5887: @391658
     /* 391658 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(391793), // Rule ID 7621 //
     /* 391663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 391666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 391710 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391715 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391715 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391720 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391740 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391747 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 391750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 391757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 391762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 391767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 391772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391791 */     GIR_RootConstrainSelectedInstOperands,
     /* 391792 */     // GIR_Coverage, 7621,
     /* 391792 */     GIR_EraseRootFromParent_Done,
     /* 391793 */   // Label 5888: @391793
     /* 391793 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(391928), // Rule ID 7653 //
     /* 391798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 391801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 391805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391833 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391841 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 391845 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391850 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391850 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391882 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 391885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 391892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 391897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 391902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 391907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391926 */     GIR_RootConstrainSelectedInstOperands,
     /* 391927 */     // GIR_Coverage, 7653,
     /* 391927 */     GIR_EraseRootFromParent_Done,
     /* 391928 */   // Label 5889: @391928
     /* 391928 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(392063), // Rule ID 7685 //
     /* 391933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 391936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 391980 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391980 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391985 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391985 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391990 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391994 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392010 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392017 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 392020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 392027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 392032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 392037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 392042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392061 */     GIR_RootConstrainSelectedInstOperands,
     /* 392062 */     // GIR_Coverage, 7685,
     /* 392062 */     GIR_EraseRootFromParent_Done,
     /* 392063 */   // Label 5890: @392063
     /* 392063 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(392198), // Rule ID 11971 //
     /* 392068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 392071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392115 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392120 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392125 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392138 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392145 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392152 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 392155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 392162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 392167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 392172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 392177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392196 */     GIR_RootConstrainSelectedInstOperands,
     /* 392197 */     // GIR_Coverage, 11971,
     /* 392197 */     GIR_EraseRootFromParent_Done,
     /* 392198 */   // Label 5891: @392198
     /* 392198 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(392333), // Rule ID 11974 //
     /* 392203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 392206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392250 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392255 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392260 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392287 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 392290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 392297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 392302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 392307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 392312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392331 */     GIR_RootConstrainSelectedInstOperands,
     /* 392332 */     // GIR_Coverage, 11974,
     /* 392332 */     GIR_EraseRootFromParent_Done,
     /* 392333 */   // Label 5892: @392333
     /* 392333 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(392468), // Rule ID 11975 //
     /* 392338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 392341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392385 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392390 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392395 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392422 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 392425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 392432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 392437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 392442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 392447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392466 */     GIR_RootConstrainSelectedInstOperands,
     /* 392467 */     // GIR_Coverage, 11975,
     /* 392467 */     GIR_EraseRootFromParent_Done,
     /* 392468 */   // Label 5893: @392468
     /* 392468 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(392603), // Rule ID 12451 //
     /* 392473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 392476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 392480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392520 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392520 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392525 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392525 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392530 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392534 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392550 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392557 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 392560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 392567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 392572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 392577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 392582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392601 */     GIR_RootConstrainSelectedInstOperands,
     /* 392602 */     // GIR_Coverage, 12451,
     /* 392602 */     GIR_EraseRootFromParent_Done,
     /* 392603 */   // Label 5894: @392603
     /* 392603 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(392738), // Rule ID 12454 //
     /* 392608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 392611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 392615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392655 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392655 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392660 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392665 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392669 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392685 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392692 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 392695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 392702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 392707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 392712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 392717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392736 */     GIR_RootConstrainSelectedInstOperands,
     /* 392737 */     // GIR_Coverage, 12454,
     /* 392737 */     GIR_EraseRootFromParent_Done,
     /* 392738 */   // Label 5895: @392738
     /* 392738 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(392873), // Rule ID 12455 //
     /* 392743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 392746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 392750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392790 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392790 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392795 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392804 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392827 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 392830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 392837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 392842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 392847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 392852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392871 */     GIR_RootConstrainSelectedInstOperands,
     /* 392872 */     // GIR_Coverage, 12455,
     /* 392872 */     GIR_EraseRootFromParent_Done,
     /* 392873 */   // Label 5896: @392873
     /* 392873 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(393008), // Rule ID 12931 //
     /* 392878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 392881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392925 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392930 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392935 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392962 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 392965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 392972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 392977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 392982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 392987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393006 */     GIR_RootConstrainSelectedInstOperands,
     /* 393007 */     // GIR_Coverage, 12931,
     /* 393007 */     GIR_EraseRootFromParent_Done,
     /* 393008 */   // Label 5897: @393008
     /* 393008 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(393143), // Rule ID 12934 //
     /* 393013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 393016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393060 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393065 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393070 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393090 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393097 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 393100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 393117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 393122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393141 */     GIR_RootConstrainSelectedInstOperands,
     /* 393142 */     // GIR_Coverage, 12934,
     /* 393142 */     GIR_EraseRootFromParent_Done,
     /* 393143 */   // Label 5898: @393143
     /* 393143 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(393278), // Rule ID 12935 //
     /* 393148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 393151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 393191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393195 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393195 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393200 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393200 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393225 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393232 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 393235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 393252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 393257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393276 */     GIR_RootConstrainSelectedInstOperands,
     /* 393277 */     // GIR_Coverage, 12935,
     /* 393277 */     GIR_EraseRootFromParent_Done,
     /* 393278 */   // Label 5899: @393278
     /* 393278 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(393413), // Rule ID 12027 //
     /* 393283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 393286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 393314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 393326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393330 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393330 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 393335 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393335 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 393340 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393344 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393353 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393360 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393367 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 393370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 393387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 393392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 393397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 393402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393411 */     GIR_RootConstrainSelectedInstOperands,
     /* 393412 */     // GIR_Coverage, 12027,
     /* 393412 */     GIR_EraseRootFromParent_Done,
     /* 393413 */   // Label 5900: @393413
     /* 393413 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(393548), // Rule ID 12028 //
     /* 393418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 393421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 393449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 393461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393465 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393465 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 393470 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393470 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 393475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393495 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393502 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 393505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 393522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 393527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 393532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 393537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393546 */     GIR_RootConstrainSelectedInstOperands,
     /* 393547 */     // GIR_Coverage, 12028,
     /* 393547 */     GIR_EraseRootFromParent_Done,
     /* 393548 */   // Label 5901: @393548
     /* 393548 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(393683), // Rule ID 12029 //
     /* 393553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 393556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 393584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 393596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393600 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 393605 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 393610 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393637 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 393640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 393647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 393652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 393657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 393662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 393667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 393672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393681 */     GIR_RootConstrainSelectedInstOperands,
     /* 393682 */     // GIR_Coverage, 12029,
     /* 393682 */     GIR_EraseRootFromParent_Done,
     /* 393683 */   // Label 5902: @393683
     /* 393683 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(393818), // Rule ID 12030 //
     /* 393688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 393691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 393719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 393731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393735 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 393740 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 393745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393772 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 393775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 393782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 393787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 393792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 393797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 393802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 393807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393816 */     GIR_RootConstrainSelectedInstOperands,
     /* 393817 */     // GIR_Coverage, 12030,
     /* 393817 */     GIR_EraseRootFromParent_Done,
     /* 393818 */   // Label 5903: @393818
     /* 393818 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(393953), // Rule ID 12507 //
     /* 393823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 393826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 393830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 393854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 393866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393870 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 393875 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393875 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 393880 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393907 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 393910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 393927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 393932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 393937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 393942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393951 */     GIR_RootConstrainSelectedInstOperands,
     /* 393952 */     // GIR_Coverage, 12507,
     /* 393952 */     GIR_EraseRootFromParent_Done,
     /* 393953 */   // Label 5904: @393953
     /* 393953 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(394088), // Rule ID 12508 //
     /* 393958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 393961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 393965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 393989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394005 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394005 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394010 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394010 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394015 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394042 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 394045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 394052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 394057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 394062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 394067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394086 */     GIR_RootConstrainSelectedInstOperands,
     /* 394087 */     // GIR_Coverage, 12508,
     /* 394087 */     GIR_EraseRootFromParent_Done,
     /* 394088 */   // Label 5905: @394088
     /* 394088 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(394223), // Rule ID 12509 //
     /* 394093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 394096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 394100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394140 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394145 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394145 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394150 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394156 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394163 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394177 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 394180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 394187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 394192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 394197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 394202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394221 */     GIR_RootConstrainSelectedInstOperands,
     /* 394222 */     // GIR_Coverage, 12509,
     /* 394222 */     GIR_EraseRootFromParent_Done,
     /* 394223 */   // Label 5906: @394223
     /* 394223 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(394358), // Rule ID 12510 //
     /* 394228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 394231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 394235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394275 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394275 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394280 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394285 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394312 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 394315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 394322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 394327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 394332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 394337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394356 */     GIR_RootConstrainSelectedInstOperands,
     /* 394357 */     // GIR_Coverage, 12510,
     /* 394357 */     GIR_EraseRootFromParent_Done,
     /* 394358 */   // Label 5907: @394358
     /* 394358 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(394493), // Rule ID 12987 //
     /* 394363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 394366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394410 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394415 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394420 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394424 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394433 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394440 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394447 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 394450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 394457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 394462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 394467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 394472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394491 */     GIR_RootConstrainSelectedInstOperands,
     /* 394492 */     // GIR_Coverage, 12987,
     /* 394492 */     GIR_EraseRootFromParent_Done,
     /* 394493 */   // Label 5908: @394493
     /* 394493 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(394628), // Rule ID 12988 //
     /* 394498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 394501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394545 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394545 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394550 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394550 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394575 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394582 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 394585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 394592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 394597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 394602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 394607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394626 */     GIR_RootConstrainSelectedInstOperands,
     /* 394627 */     // GIR_Coverage, 12988,
     /* 394627 */     GIR_EraseRootFromParent_Done,
     /* 394628 */   // Label 5909: @394628
     /* 394628 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(394763), // Rule ID 12989 //
     /* 394633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 394636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394680 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394685 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394685 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394690 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394694 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394696 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394703 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394710 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394717 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 394720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 394727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 394732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 394737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 394742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394761 */     GIR_RootConstrainSelectedInstOperands,
     /* 394762 */     // GIR_Coverage, 12989,
     /* 394762 */     GIR_EraseRootFromParent_Done,
     /* 394763 */   // Label 5910: @394763
     /* 394763 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(394898), // Rule ID 12990 //
     /* 394768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 394771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394815 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394815 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394820 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394820 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394825 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394829 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394838 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394852 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 394855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 394862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 394867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 394872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 394877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 394882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 394887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394896 */     GIR_RootConstrainSelectedInstOperands,
     /* 394897 */     // GIR_Coverage, 12990,
     /* 394897 */     GIR_EraseRootFromParent_Done,
     /* 394898 */   // Label 5911: @394898
     /* 394898 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(395033), // Rule ID 11967 //
     /* 394903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 394906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 394930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 394946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 394950 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394950 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 394955 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 394960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394980 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394987 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 394990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 394997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 395002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 395007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 395012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395031 */     GIR_RootConstrainSelectedInstOperands,
     /* 395032 */     // GIR_Coverage, 11967,
     /* 395032 */     GIR_EraseRootFromParent_Done,
     /* 395033 */   // Label 5912: @395033
     /* 395033 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(395168), // Rule ID 11968 //
     /* 395038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 395041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395085 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395085 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395090 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395108 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395115 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395122 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 395125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 395132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 395137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 395142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 395147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395166 */     GIR_RootConstrainSelectedInstOperands,
     /* 395167 */     // GIR_Coverage, 11968,
     /* 395167 */     GIR_EraseRootFromParent_Done,
     /* 395168 */   // Label 5913: @395168
     /* 395168 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(395303), // Rule ID 11969 //
     /* 395173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 395176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395220 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395225 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395250 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395257 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 395260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 395267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 395272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 395277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 395282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395301 */     GIR_RootConstrainSelectedInstOperands,
     /* 395302 */     // GIR_Coverage, 11969,
     /* 395302 */     GIR_EraseRootFromParent_Done,
     /* 395303 */   // Label 5914: @395303
     /* 395303 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(395438), // Rule ID 11970 //
     /* 395308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 395311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395355 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395360 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395360 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395369 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395392 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 395395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 395402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 395407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 395412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 395417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395436 */     GIR_RootConstrainSelectedInstOperands,
     /* 395437 */     // GIR_Coverage, 11970,
     /* 395437 */     GIR_EraseRootFromParent_Done,
     /* 395438 */   // Label 5915: @395438
     /* 395438 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(395573), // Rule ID 12447 //
     /* 395443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 395446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 395450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395490 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395490 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395495 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395495 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395500 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395506 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395520 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395527 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 395530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 395537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 395542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 395547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 395552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395571 */     GIR_RootConstrainSelectedInstOperands,
     /* 395572 */     // GIR_Coverage, 12447,
     /* 395572 */     GIR_EraseRootFromParent_Done,
     /* 395573 */   // Label 5916: @395573
     /* 395573 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(395708), // Rule ID 12448 //
     /* 395578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 395581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 395585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395613 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395625 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395625 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395630 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395630 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395635 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395639 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395648 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395655 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395662 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 395665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 395672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 395677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 395682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 395687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395706 */     GIR_RootConstrainSelectedInstOperands,
     /* 395707 */     // GIR_Coverage, 12448,
     /* 395707 */     GIR_EraseRootFromParent_Done,
     /* 395708 */   // Label 5917: @395708
     /* 395708 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(395843), // Rule ID 12449 //
     /* 395713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 395716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 395720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395760 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395760 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395765 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395783 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395790 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395797 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 395800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 395807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 395812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 395817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 395822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395841 */     GIR_RootConstrainSelectedInstOperands,
     /* 395842 */     // GIR_Coverage, 12449,
     /* 395842 */     GIR_EraseRootFromParent_Done,
     /* 395843 */   // Label 5918: @395843
     /* 395843 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(395978), // Rule ID 12450 //
     /* 395848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 395851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 395855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 395875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 395891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395895 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395895 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 395900 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 395905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395932 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 395935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 395942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 395947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 395952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 395957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 395962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 395967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395976 */     GIR_RootConstrainSelectedInstOperands,
     /* 395977 */     // GIR_Coverage, 12450,
     /* 395977 */     GIR_EraseRootFromParent_Done,
     /* 395978 */   // Label 5919: @395978
     /* 395978 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(396113), // Rule ID 12927 //
     /* 395983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 395986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 396014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396030 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396030 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396035 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396035 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396040 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396053 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396060 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396067 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 396070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 396077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 396082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 396087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 396092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396111 */     GIR_RootConstrainSelectedInstOperands,
     /* 396112 */     // GIR_Coverage, 12927,
     /* 396112 */     GIR_EraseRootFromParent_Done,
     /* 396113 */   // Label 5920: @396113
     /* 396113 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(396248), // Rule ID 12928 //
     /* 396118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 396121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 396149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396165 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396165 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396170 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396170 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396175 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396179 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396195 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396202 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 396205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 396212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 396217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 396222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 396227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396246 */     GIR_RootConstrainSelectedInstOperands,
     /* 396247 */     // GIR_Coverage, 12928,
     /* 396247 */     GIR_EraseRootFromParent_Done,
     /* 396248 */   // Label 5921: @396248
     /* 396248 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(396383), // Rule ID 12929 //
     /* 396253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 396256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 396284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396300 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396300 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396305 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396305 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396310 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396316 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396323 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396330 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396337 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 396340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 396347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 396352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 396357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 396362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396381 */     GIR_RootConstrainSelectedInstOperands,
     /* 396382 */     // GIR_Coverage, 12929,
     /* 396382 */     GIR_EraseRootFromParent_Done,
     /* 396383 */   // Label 5922: @396383
     /* 396383 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(396518), // Rule ID 12930 //
     /* 396388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 396391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 396419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396435 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396435 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396440 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396440 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396445 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396449 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396465 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396472 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 396475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 396482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 396487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 396492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 396497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396516 */     GIR_RootConstrainSelectedInstOperands,
     /* 396517 */     // GIR_Coverage, 12930,
     /* 396517 */     GIR_EraseRootFromParent_Done,
     /* 396518 */   // Label 5923: @396518
     /* 396518 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(396653), // Rule ID 12012 //
     /* 396523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 396526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 396554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396570 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396575 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396600 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396607 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 396610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 396617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 396622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 396627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 396632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396651 */     GIR_RootConstrainSelectedInstOperands,
     /* 396652 */     // GIR_Coverage, 12012,
     /* 396652 */     GIR_EraseRootFromParent_Done,
     /* 396653 */   // Label 5924: @396653
     /* 396653 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(396788), // Rule ID 12013 //
     /* 396658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 396661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 396689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396705 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396710 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396728 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396735 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396742 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 396745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 396752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 396757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 396762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 396767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396786 */     GIR_RootConstrainSelectedInstOperands,
     /* 396787 */     // GIR_Coverage, 12013,
     /* 396787 */     GIR_EraseRootFromParent_Done,
     /* 396788 */   // Label 5925: @396788
     /* 396788 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(396923), // Rule ID 12014 //
     /* 396793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 396796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 396824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396840 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396845 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396863 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396870 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396877 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 396880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 396887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 396892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 396897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 396902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 396907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 396912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396921 */     GIR_RootConstrainSelectedInstOperands,
     /* 396922 */     // GIR_Coverage, 12014,
     /* 396922 */     GIR_EraseRootFromParent_Done,
     /* 396923 */   // Label 5926: @396923
     /* 396923 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(397058), // Rule ID 12015 //
     /* 396928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 396931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 396959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396975 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396975 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 396980 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396980 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 396985 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396989 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396991 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397005 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397012 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 397015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 397022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 397027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 397032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 397037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397056 */     GIR_RootConstrainSelectedInstOperands,
     /* 397057 */     // GIR_Coverage, 12015,
     /* 397057 */     GIR_EraseRootFromParent_Done,
     /* 397058 */   // Label 5927: @397058
     /* 397058 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(397193), // Rule ID 12492 //
     /* 397063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 397066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 397070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397110 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397110 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397115 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397120 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397124 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397133 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397140 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397147 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 397150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 397167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 397172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397191 */     GIR_RootConstrainSelectedInstOperands,
     /* 397192 */     // GIR_Coverage, 12492,
     /* 397192 */     GIR_EraseRootFromParent_Done,
     /* 397193 */   // Label 5928: @397193
     /* 397193 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(397328), // Rule ID 12493 //
     /* 397198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 397201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 397205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397245 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397250 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397255 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397282 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 397285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 397302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 397307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397326 */     GIR_RootConstrainSelectedInstOperands,
     /* 397327 */     // GIR_Coverage, 12493,
     /* 397327 */     GIR_EraseRootFromParent_Done,
     /* 397328 */   // Label 5929: @397328
     /* 397328 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(397463), // Rule ID 12494 //
     /* 397333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 397336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 397340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397380 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397385 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397390 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397403 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397410 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397417 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 397420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 397427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 397432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 397437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 397442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397461 */     GIR_RootConstrainSelectedInstOperands,
     /* 397462 */     // GIR_Coverage, 12494,
     /* 397462 */     GIR_EraseRootFromParent_Done,
     /* 397463 */   // Label 5930: @397463
     /* 397463 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(397598), // Rule ID 12495 //
     /* 397468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 397471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 397475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397515 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397520 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397520 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397525 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397552 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 397555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 397562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 397567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 397572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 397577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397596 */     GIR_RootConstrainSelectedInstOperands,
     /* 397597 */     // GIR_Coverage, 12495,
     /* 397597 */     GIR_EraseRootFromParent_Done,
     /* 397598 */   // Label 5931: @397598
     /* 397598 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(397733), // Rule ID 12972 //
     /* 397603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 397606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 397610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397650 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397655 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397655 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397660 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397664 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397680 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397687 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 397690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 397707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 397712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397731 */     GIR_RootConstrainSelectedInstOperands,
     /* 397732 */     // GIR_Coverage, 12972,
     /* 397732 */     GIR_EraseRootFromParent_Done,
     /* 397733 */   // Label 5932: @397733
     /* 397733 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(397868), // Rule ID 12973 //
     /* 397738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 397741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 397745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397785 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397785 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397790 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397790 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397795 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397799 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397808 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397815 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397822 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 397825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 397842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 397847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397866 */     GIR_RootConstrainSelectedInstOperands,
     /* 397867 */     // GIR_Coverage, 12973,
     /* 397867 */     GIR_EraseRootFromParent_Done,
     /* 397868 */   // Label 5933: @397868
     /* 397868 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(398003), // Rule ID 12974 //
     /* 397873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 397876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 397880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397920 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397920 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397925 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397936 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397943 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397957 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 397960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 397967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 397972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 397977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 397982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398001 */     GIR_RootConstrainSelectedInstOperands,
     /* 398002 */     // GIR_Coverage, 12974,
     /* 398002 */     GIR_EraseRootFromParent_Done,
     /* 398003 */   // Label 5934: @398003
     /* 398003 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(398138), // Rule ID 12975 //
     /* 398008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 398011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398055 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398060 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398078 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398092 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 398095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 398102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 398107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 398112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 398117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398136 */     GIR_RootConstrainSelectedInstOperands,
     /* 398137 */     // GIR_Coverage, 12975,
     /* 398137 */     GIR_EraseRootFromParent_Done,
     /* 398138 */   // Label 5935: @398138
     /* 398138 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(398273), // Rule ID 11952 //
     /* 398143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 398146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 398190 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398195 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398195 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398200 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398220 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398227 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 398230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 398237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 398242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 398247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 398252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398271 */     GIR_RootConstrainSelectedInstOperands,
     /* 398272 */     // GIR_Coverage, 11952,
     /* 398272 */     GIR_EraseRootFromParent_Done,
     /* 398273 */   // Label 5936: @398273
     /* 398273 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(398408), // Rule ID 11953 //
     /* 398278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 398281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 398325 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398330 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398330 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398335 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398355 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398362 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 398365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 398372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 398377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 398382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 398387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398406 */     GIR_RootConstrainSelectedInstOperands,
     /* 398407 */     // GIR_Coverage, 11953,
     /* 398407 */     GIR_EraseRootFromParent_Done,
     /* 398408 */   // Label 5937: @398408
     /* 398408 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(398543), // Rule ID 11954 //
     /* 398413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 398416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 398460 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398460 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398465 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398465 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398470 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398476 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398483 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398490 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398497 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 398500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 398507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 398512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 398517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 398522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398541 */     GIR_RootConstrainSelectedInstOperands,
     /* 398542 */     // GIR_Coverage, 11954,
     /* 398542 */     GIR_EraseRootFromParent_Done,
     /* 398543 */   // Label 5938: @398543
     /* 398543 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(398678), // Rule ID 11955 //
     /* 398548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 398551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398583 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 398595 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398600 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398605 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398609 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398625 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398632 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 398635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 398642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 398647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 398652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 398657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398676 */     GIR_RootConstrainSelectedInstOperands,
     /* 398677 */     // GIR_Coverage, 11955,
     /* 398677 */     GIR_EraseRootFromParent_Done,
     /* 398678 */   // Label 5939: @398678
     /* 398678 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(398813), // Rule ID 12432 //
     /* 398683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 398686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 398690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 398730 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398735 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398740 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398753 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398760 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398767 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 398770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 398777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 398782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 398787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 398792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398811 */     GIR_RootConstrainSelectedInstOperands,
     /* 398812 */     // GIR_Coverage, 12432,
     /* 398812 */     GIR_EraseRootFromParent_Done,
     /* 398813 */   // Label 5940: @398813
     /* 398813 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(398948), // Rule ID 12433 //
     /* 398818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 398821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 398825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 398865 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398870 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398875 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398879 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398895 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398902 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 398905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 398912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 398917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 398922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 398927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398946 */     GIR_RootConstrainSelectedInstOperands,
     /* 398947 */     // GIR_Coverage, 12433,
     /* 398947 */     GIR_EraseRootFromParent_Done,
     /* 398948 */   // Label 5941: @398948
     /* 398948 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(399083), // Rule ID 12434 //
     /* 398953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 398956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 398960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 398984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399000 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399005 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399005 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399030 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399037 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 399040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 399047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 399052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 399057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 399062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399081 */     GIR_RootConstrainSelectedInstOperands,
     /* 399082 */     // GIR_Coverage, 12434,
     /* 399082 */     GIR_EraseRootFromParent_Done,
     /* 399083 */   // Label 5942: @399083
     /* 399083 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(399218), // Rule ID 12435 //
     /* 399088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 399091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 399095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 399119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399135 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399140 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399165 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399172 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 399175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 399182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 399187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 399192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 399197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399216 */     GIR_RootConstrainSelectedInstOperands,
     /* 399217 */     // GIR_Coverage, 12435,
     /* 399217 */     GIR_EraseRootFromParent_Done,
     /* 399218 */   // Label 5943: @399218
     /* 399218 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(399353), // Rule ID 12912 //
     /* 399223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 399226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 399254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399270 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399270 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399275 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399275 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399280 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399293 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399300 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399307 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 399310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 399317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 399322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 399327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 399332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399351 */     GIR_RootConstrainSelectedInstOperands,
     /* 399352 */     // GIR_Coverage, 12912,
     /* 399352 */     GIR_EraseRootFromParent_Done,
     /* 399353 */   // Label 5944: @399353
     /* 399353 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(399488), // Rule ID 12913 //
     /* 399358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 399361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 399389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399405 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399405 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399410 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399428 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399435 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399442 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 399445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 399452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 399457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 399462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 399467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399486 */     GIR_RootConstrainSelectedInstOperands,
     /* 399487 */     // GIR_Coverage, 12913,
     /* 399487 */     GIR_EraseRootFromParent_Done,
     /* 399488 */   // Label 5945: @399488
     /* 399488 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(399623), // Rule ID 12914 //
     /* 399493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 399496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 399524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399540 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399545 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399545 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399550 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399563 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399577 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 399580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 399587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 399592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 399597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 399602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399621 */     GIR_RootConstrainSelectedInstOperands,
     /* 399622 */     // GIR_Coverage, 12914,
     /* 399622 */     GIR_EraseRootFromParent_Done,
     /* 399623 */   // Label 5946: @399623
     /* 399623 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(399758), // Rule ID 12915 //
     /* 399628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 399631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 399659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399675 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399680 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399685 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399705 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399712 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 399715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 399722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 399727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 399732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 399737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399756 */     GIR_RootConstrainSelectedInstOperands,
     /* 399757 */     // GIR_Coverage, 12915,
     /* 399757 */     GIR_EraseRootFromParent_Done,
     /* 399758 */   // Label 5947: @399758
     /* 399758 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(399893), // Rule ID 12023 //
     /* 399763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 399766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 399794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399810 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399810 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399815 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399815 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399820 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399833 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399840 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399847 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 399850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 399857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 399862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 399867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 399872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 399877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 399882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399891 */     GIR_RootConstrainSelectedInstOperands,
     /* 399892 */     // GIR_Coverage, 12023,
     /* 399892 */     GIR_EraseRootFromParent_Done,
     /* 399893 */   // Label 5948: @399893
     /* 399893 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(400028), // Rule ID 12024 //
     /* 399898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 399901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 399929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399945 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399945 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399950 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399950 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399959 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399975 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399982 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 399985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 399992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 399997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 400002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 400007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400026 */     GIR_RootConstrainSelectedInstOperands,
     /* 400027 */     // GIR_Coverage, 12024,
     /* 400027 */     GIR_EraseRootFromParent_Done,
     /* 400028 */   // Label 5949: @400028
     /* 400028 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(400163), // Rule ID 12025 //
     /* 400033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 400036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 400040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400080 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400080 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400085 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400085 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400117 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 400120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 400127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 400132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 400137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 400142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400161 */     GIR_RootConstrainSelectedInstOperands,
     /* 400162 */     // GIR_Coverage, 12025,
     /* 400162 */     GIR_EraseRootFromParent_Done,
     /* 400163 */   // Label 5950: @400163
     /* 400163 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(400298), // Rule ID 12026 //
     /* 400168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 400171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 400175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400215 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400215 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400220 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400252 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 400255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 400262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 400267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 400272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 400277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400296 */     GIR_RootConstrainSelectedInstOperands,
     /* 400297 */     // GIR_Coverage, 12026,
     /* 400297 */     GIR_EraseRootFromParent_Done,
     /* 400298 */   // Label 5951: @400298
     /* 400298 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(400433), // Rule ID 12503 //
     /* 400303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 400306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 400310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400350 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400355 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400387 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 400390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 400397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 400402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 400407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 400412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400431 */     GIR_RootConstrainSelectedInstOperands,
     /* 400432 */     // GIR_Coverage, 12503,
     /* 400432 */     GIR_EraseRootFromParent_Done,
     /* 400433 */   // Label 5952: @400433
     /* 400433 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(400568), // Rule ID 12504 //
     /* 400438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 400441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 400445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400481 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400485 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400485 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400490 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400490 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400508 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400515 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400522 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 400525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 400532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 400537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 400542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 400547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400566 */     GIR_RootConstrainSelectedInstOperands,
     /* 400567 */     // GIR_Coverage, 12504,
     /* 400567 */     GIR_EraseRootFromParent_Done,
     /* 400568 */   // Label 5953: @400568
     /* 400568 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(400703), // Rule ID 12505 //
     /* 400573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 400576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 400580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400620 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400620 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400625 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400625 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400630 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400650 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400657 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 400660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 400667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 400672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 400677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 400682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400701 */     GIR_RootConstrainSelectedInstOperands,
     /* 400702 */     // GIR_Coverage, 12505,
     /* 400702 */     GIR_EraseRootFromParent_Done,
     /* 400703 */   // Label 5954: @400703
     /* 400703 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(400838), // Rule ID 12506 //
     /* 400708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 400711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 400715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400747 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400751 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400755 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400755 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400760 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400760 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400778 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400785 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400792 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 400795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 400802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 400807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 400812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 400817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400836 */     GIR_RootConstrainSelectedInstOperands,
     /* 400837 */     // GIR_Coverage, 12506,
     /* 400837 */     GIR_EraseRootFromParent_Done,
     /* 400838 */   // Label 5955: @400838
     /* 400838 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(400973), // Rule ID 12983 //
     /* 400843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 400846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 400850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400890 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400890 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400895 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400895 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400900 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400913 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400927 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 400930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 400937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 400942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 400947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 400952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 400957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 400962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400971 */     GIR_RootConstrainSelectedInstOperands,
     /* 400972 */     // GIR_Coverage, 12983,
     /* 400972 */     GIR_EraseRootFromParent_Done,
     /* 400973 */   // Label 5956: @400973
     /* 400973 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(401108), // Rule ID 12984 //
     /* 400978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 400981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 400985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401025 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401025 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401030 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401030 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401039 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401055 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401062 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 401065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 401072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 401077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 401082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 401087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401106 */     GIR_RootConstrainSelectedInstOperands,
     /* 401107 */     // GIR_Coverage, 12984,
     /* 401107 */     GIR_EraseRootFromParent_Done,
     /* 401108 */   // Label 5957: @401108
     /* 401108 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(401243), // Rule ID 12985 //
     /* 401113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 401116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401160 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401160 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401165 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401165 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401170 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401190 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401197 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 401200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 401207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 401212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 401217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 401222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401241 */     GIR_RootConstrainSelectedInstOperands,
     /* 401242 */     // GIR_Coverage, 12985,
     /* 401242 */     GIR_EraseRootFromParent_Done,
     /* 401243 */   // Label 5958: @401243
     /* 401243 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(401378), // Rule ID 12986 //
     /* 401248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 401251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401295 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401295 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401300 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401300 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401305 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401325 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401332 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 401335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 401342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 401347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 401352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 401357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401376 */     GIR_RootConstrainSelectedInstOperands,
     /* 401377 */     // GIR_Coverage, 12986,
     /* 401377 */     GIR_EraseRootFromParent_Done,
     /* 401378 */   // Label 5959: @401378
     /* 401378 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(401513), // Rule ID 11963 //
     /* 401383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 401386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 401430 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401430 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401435 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401435 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401444 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401453 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401460 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401467 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 401470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 401477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 401482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 401487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 401492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401511 */     GIR_RootConstrainSelectedInstOperands,
     /* 401512 */     // GIR_Coverage, 11963,
     /* 401512 */     GIR_EraseRootFromParent_Done,
     /* 401513 */   // Label 5960: @401513
     /* 401513 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(401648), // Rule ID 11964 //
     /* 401518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 401521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 401565 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401565 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401570 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401575 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401595 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401602 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 401605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 401612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 401617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 401622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 401627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401646 */     GIR_RootConstrainSelectedInstOperands,
     /* 401647 */     // GIR_Coverage, 11964,
     /* 401647 */     GIR_EraseRootFromParent_Done,
     /* 401648 */   // Label 5961: @401648
     /* 401648 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(401783), // Rule ID 11965 //
     /* 401653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 401656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 401700 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401705 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401710 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401723 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401730 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401737 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 401740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 401747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 401752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 401757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 401762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401781 */     GIR_RootConstrainSelectedInstOperands,
     /* 401782 */     // GIR_Coverage, 11965,
     /* 401782 */     GIR_EraseRootFromParent_Done,
     /* 401783 */   // Label 5962: @401783
     /* 401783 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(401918), // Rule ID 11966 //
     /* 401788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 401791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 401835 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401835 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401840 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401845 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401849 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401865 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401872 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 401875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 401882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 401887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 401892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 401897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 401902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 401907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401916 */     GIR_RootConstrainSelectedInstOperands,
     /* 401917 */     // GIR_Coverage, 11966,
     /* 401917 */     GIR_EraseRootFromParent_Done,
     /* 401918 */   // Label 5963: @401918
     /* 401918 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(402053), // Rule ID 12443 //
     /* 401923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 401926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 401930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 401954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 401970 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401970 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401975 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401975 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401993 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402000 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402007 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 402010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 402017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 402022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 402027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 402032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402051 */     GIR_RootConstrainSelectedInstOperands,
     /* 402052 */     // GIR_Coverage, 12443,
     /* 402052 */     GIR_EraseRootFromParent_Done,
     /* 402053 */   // Label 5964: @402053
     /* 402053 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(402188), // Rule ID 12444 //
     /* 402058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 402061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 402065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402105 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402105 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402110 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402110 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402115 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402119 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402128 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402135 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402142 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 402145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 402152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 402157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 402162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 402167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402186 */     GIR_RootConstrainSelectedInstOperands,
     /* 402187 */     // GIR_Coverage, 12444,
     /* 402187 */     GIR_EraseRootFromParent_Done,
     /* 402188 */   // Label 5965: @402188
     /* 402188 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(402323), // Rule ID 12445 //
     /* 402193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 402196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 402200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402240 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402240 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402245 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402250 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402270 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402277 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 402280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 402287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 402292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 402297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 402302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402321 */     GIR_RootConstrainSelectedInstOperands,
     /* 402322 */     // GIR_Coverage, 12445,
     /* 402322 */     GIR_EraseRootFromParent_Done,
     /* 402323 */   // Label 5966: @402323
     /* 402323 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(402458), // Rule ID 12446 //
     /* 402328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 402331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 402335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402375 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402380 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402385 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402389 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402398 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402405 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402412 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 402415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 402422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 402427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 402432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 402437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402456 */     GIR_RootConstrainSelectedInstOperands,
     /* 402457 */     // GIR_Coverage, 12446,
     /* 402457 */     GIR_EraseRootFromParent_Done,
     /* 402458 */   // Label 5967: @402458
     /* 402458 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(402593), // Rule ID 12923 //
     /* 402463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 402466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402510 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402515 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402526 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402540 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402547 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 402550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 402557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 402562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 402567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 402572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402591 */     GIR_RootConstrainSelectedInstOperands,
     /* 402592 */     // GIR_Coverage, 12923,
     /* 402592 */     GIR_EraseRootFromParent_Done,
     /* 402593 */   // Label 5968: @402593
     /* 402593 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(402728), // Rule ID 12924 //
     /* 402598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 402601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402645 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402650 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402655 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402675 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402682 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 402685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 402692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 402697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 402702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 402707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402726 */     GIR_RootConstrainSelectedInstOperands,
     /* 402727 */     // GIR_Coverage, 12924,
     /* 402727 */     GIR_EraseRootFromParent_Done,
     /* 402728 */   // Label 5969: @402728
     /* 402728 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(402863), // Rule ID 12925 //
     /* 402733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 402736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402780 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402780 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402785 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402785 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402790 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402803 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402810 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402817 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 402820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 402827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 402832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 402837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 402842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402861 */     GIR_RootConstrainSelectedInstOperands,
     /* 402862 */     // GIR_Coverage, 12925,
     /* 402862 */     GIR_EraseRootFromParent_Done,
     /* 402863 */   // Label 5970: @402863
     /* 402863 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(402998), // Rule ID 12926 //
     /* 402868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 402871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 402899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402915 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402915 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402920 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402920 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402925 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402938 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402945 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402952 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 402955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 402962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 402967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 402972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 402977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 402982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 402987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402996 */     GIR_RootConstrainSelectedInstOperands,
     /* 402997 */     // GIR_Coverage, 12926,
     /* 402997 */     GIR_EraseRootFromParent_Done,
     /* 402998 */   // Label 5971: @402998
     /* 402998 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(403133), // Rule ID 12008 //
     /* 403003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 403006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 403010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403050 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403050 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403055 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403060 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403073 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403080 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403087 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 403090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 403097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 403102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 403107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 403112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403131 */     GIR_RootConstrainSelectedInstOperands,
     /* 403132 */     // GIR_Coverage, 12008,
     /* 403132 */     GIR_EraseRootFromParent_Done,
     /* 403133 */   // Label 5972: @403133
     /* 403133 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(403268), // Rule ID 12009 //
     /* 403138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 403141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 403145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403185 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403190 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403215 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403222 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 403225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 403232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 403237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 403242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 403247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403266 */     GIR_RootConstrainSelectedInstOperands,
     /* 403267 */     // GIR_Coverage, 12009,
     /* 403267 */     GIR_EraseRootFromParent_Done,
     /* 403268 */   // Label 5973: @403268
     /* 403268 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(403403), // Rule ID 12010 //
     /* 403273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 403276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 403280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403320 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403325 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403330 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403334 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403343 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403350 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403357 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 403360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 403367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 403372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 403377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 403382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403401 */     GIR_RootConstrainSelectedInstOperands,
     /* 403402 */     // GIR_Coverage, 12010,
     /* 403402 */     GIR_EraseRootFromParent_Done,
     /* 403403 */   // Label 5974: @403403
     /* 403403 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(403538), // Rule ID 12011 //
     /* 403408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 403411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 403415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403455 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403460 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403460 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403485 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403492 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 403495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 403502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 403507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 403512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 403517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403536 */     GIR_RootConstrainSelectedInstOperands,
     /* 403537 */     // GIR_Coverage, 12011,
     /* 403537 */     GIR_EraseRootFromParent_Done,
     /* 403538 */   // Label 5975: @403538
     /* 403538 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(403673), // Rule ID 12488 //
     /* 403543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 403546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 403550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403590 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403590 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403595 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403604 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403613 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403620 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403627 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 403630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 403637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 403642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 403647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 403652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403671 */     GIR_RootConstrainSelectedInstOperands,
     /* 403672 */     // GIR_Coverage, 12488,
     /* 403672 */     GIR_EraseRootFromParent_Done,
     /* 403673 */   // Label 5976: @403673
     /* 403673 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(403808), // Rule ID 12489 //
     /* 403678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 403681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 403685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403725 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403725 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403730 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403748 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403755 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403762 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 403765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 403772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 403777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 403782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 403787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403806 */     GIR_RootConstrainSelectedInstOperands,
     /* 403807 */     // GIR_Coverage, 12489,
     /* 403807 */     GIR_EraseRootFromParent_Done,
     /* 403808 */   // Label 5977: @403808
     /* 403808 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(403943), // Rule ID 12490 //
     /* 403813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 403816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 403820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403860 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403865 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403870 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403897 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 403900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 403907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 403912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 403917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 403922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 403927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 403932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403941 */     GIR_RootConstrainSelectedInstOperands,
     /* 403942 */     // GIR_Coverage, 12490,
     /* 403942 */     GIR_EraseRootFromParent_Done,
     /* 403943 */   // Label 5978: @403943
     /* 403943 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(404078), // Rule ID 12491 //
     /* 403948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 403951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 403955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403995 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404000 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404005 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404025 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404032 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 404035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 404042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 404047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 404052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 404057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404076 */     GIR_RootConstrainSelectedInstOperands,
     /* 404077 */     // GIR_Coverage, 12491,
     /* 404077 */     GIR_EraseRootFromParent_Done,
     /* 404078 */   // Label 5979: @404078
     /* 404078 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(404213), // Rule ID 12968 //
     /* 404083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 404086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404130 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404135 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404144 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404153 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404160 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404167 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 404170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 404177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 404182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 404187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 404192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404211 */     GIR_RootConstrainSelectedInstOperands,
     /* 404212 */     // GIR_Coverage, 12968,
     /* 404212 */     GIR_EraseRootFromParent_Done,
     /* 404213 */   // Label 5980: @404213
     /* 404213 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(404348), // Rule ID 12969 //
     /* 404218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 404221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404265 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404265 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404270 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404270 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404275 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404288 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404295 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404302 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 404305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 404312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 404317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 404322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 404327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404346 */     GIR_RootConstrainSelectedInstOperands,
     /* 404347 */     // GIR_Coverage, 12969,
     /* 404347 */     GIR_EraseRootFromParent_Done,
     /* 404348 */   // Label 5981: @404348
     /* 404348 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(404483), // Rule ID 12970 //
     /* 404353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 404356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404400 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404400 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404405 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404405 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404410 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404414 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404423 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404437 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 404440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 404447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 404452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 404457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 404462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404481 */     GIR_RootConstrainSelectedInstOperands,
     /* 404482 */     // GIR_Coverage, 12970,
     /* 404482 */     GIR_EraseRootFromParent_Done,
     /* 404483 */   // Label 5982: @404483
     /* 404483 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(404618), // Rule ID 12971 //
     /* 404488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 404491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404535 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404540 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404549 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404558 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404565 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404572 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 404575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 404582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 404587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 404592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 404597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404616 */     GIR_RootConstrainSelectedInstOperands,
     /* 404617 */     // GIR_Coverage, 12971,
     /* 404617 */     GIR_EraseRootFromParent_Done,
     /* 404618 */   // Label 5983: @404618
     /* 404618 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(404753), // Rule ID 11948 //
     /* 404623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 404626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 404670 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404675 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404680 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404707 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 404710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 404717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 404722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 404727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 404732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404751 */     GIR_RootConstrainSelectedInstOperands,
     /* 404752 */     // GIR_Coverage, 11948,
     /* 404752 */     GIR_EraseRootFromParent_Done,
     /* 404753 */   // Label 5984: @404753
     /* 404753 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(404888), // Rule ID 11949 //
     /* 404758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 404761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 404805 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404810 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404810 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404815 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404828 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404835 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404842 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 404845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 404852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 404857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 404862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 404867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404886 */     GIR_RootConstrainSelectedInstOperands,
     /* 404887 */     // GIR_Coverage, 11949,
     /* 404887 */     GIR_EraseRootFromParent_Done,
     /* 404888 */   // Label 5985: @404888
     /* 404888 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(405023), // Rule ID 11950 //
     /* 404893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 404896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 404940 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404945 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404945 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404963 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404970 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404977 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 404980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 404987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 404992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 404997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 405002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405021 */     GIR_RootConstrainSelectedInstOperands,
     /* 405022 */     // GIR_Coverage, 11950,
     /* 405022 */     GIR_EraseRootFromParent_Done,
     /* 405023 */   // Label 5986: @405023
     /* 405023 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(405158), // Rule ID 11951 //
     /* 405028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 405031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 405035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405071 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405075 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405075 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405080 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405080 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405085 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405098 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405105 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405112 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 405115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 405122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 405127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 405132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 405137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405156 */     GIR_RootConstrainSelectedInstOperands,
     /* 405157 */     // GIR_Coverage, 11951,
     /* 405157 */     GIR_EraseRootFromParent_Done,
     /* 405158 */   // Label 5987: @405158
     /* 405158 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(405293), // Rule ID 12428 //
     /* 405163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 405166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 405170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405210 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405210 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405215 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405215 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405247 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 405250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 405257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 405262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 405267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 405272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405291 */     GIR_RootConstrainSelectedInstOperands,
     /* 405292 */     // GIR_Coverage, 12428,
     /* 405292 */     GIR_EraseRootFromParent_Done,
     /* 405293 */   // Label 5988: @405293
     /* 405293 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(405428), // Rule ID 12429 //
     /* 405298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 405301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 405305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405345 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405350 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405368 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405382 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 405385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 405392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 405397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 405402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 405407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405426 */     GIR_RootConstrainSelectedInstOperands,
     /* 405427 */     // GIR_Coverage, 12429,
     /* 405427 */     GIR_EraseRootFromParent_Done,
     /* 405428 */   // Label 5989: @405428
     /* 405428 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(405563), // Rule ID 12430 //
     /* 405433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 405436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 405440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405480 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405480 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405485 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405485 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405490 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405494 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405510 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405517 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 405520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 405527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 405532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 405537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 405542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405561 */     GIR_RootConstrainSelectedInstOperands,
     /* 405562 */     // GIR_Coverage, 12430,
     /* 405562 */     GIR_EraseRootFromParent_Done,
     /* 405563 */   // Label 5990: @405563
     /* 405563 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(405698), // Rule ID 12431 //
     /* 405568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 405571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 405575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405615 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405615 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405620 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405620 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405625 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405629 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405631 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405638 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405645 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405652 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 405655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 405662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 405667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 405672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 405677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405696 */     GIR_RootConstrainSelectedInstOperands,
     /* 405697 */     // GIR_Coverage, 12431,
     /* 405697 */     GIR_EraseRootFromParent_Done,
     /* 405698 */   // Label 5991: @405698
     /* 405698 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(405833), // Rule ID 12908 //
     /* 405703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 405706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 405710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405738 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405750 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405750 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405755 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405755 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405760 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405764 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405780 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405787 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 405790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 405797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 405802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 405807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 405812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405831 */     GIR_RootConstrainSelectedInstOperands,
     /* 405832 */     // GIR_Coverage, 12908,
     /* 405832 */     GIR_EraseRootFromParent_Done,
     /* 405833 */   // Label 5992: @405833
     /* 405833 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(405968), // Rule ID 12909 //
     /* 405838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 405841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 405845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 405869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405885 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405885 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405890 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405890 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405895 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405908 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405915 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405922 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 405925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 405932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 405937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 405942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 405947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405966 */     GIR_RootConstrainSelectedInstOperands,
     /* 405967 */     // GIR_Coverage, 12909,
     /* 405967 */     GIR_EraseRootFromParent_Done,
     /* 405968 */   // Label 5993: @405968
     /* 405968 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(406103), // Rule ID 12910 //
     /* 405973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 405976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 405980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 406004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406020 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 406025 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406025 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 406030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406043 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406057 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 406060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 406067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 406072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 406077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 406082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406101 */     GIR_RootConstrainSelectedInstOperands,
     /* 406102 */     // GIR_Coverage, 12910,
     /* 406102 */     GIR_EraseRootFromParent_Done,
     /* 406103 */   // Label 5994: @406103
     /* 406103 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(406238), // Rule ID 12911 //
     /* 406108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 406111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 406139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406151 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406155 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406155 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 406160 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406160 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 406165 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406185 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406192 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 406195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 406202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 406207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 406212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 406217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406236 */     GIR_RootConstrainSelectedInstOperands,
     /* 406237 */     // GIR_Coverage, 12911,
     /* 406237 */     GIR_EraseRootFromParent_Done,
     /* 406238 */   // Label 5995: @406238
     /* 406238 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(406373), // Rule ID 11957 //
     /* 406243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 406246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406290 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 406295 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406295 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 406300 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406327 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 406330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 406337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 406342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 406347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 406352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406371 */     GIR_RootConstrainSelectedInstOperands,
     /* 406372 */     // GIR_Coverage, 11957,
     /* 406372 */     GIR_EraseRootFromParent_Done,
     /* 406373 */   // Label 5996: @406373
     /* 406373 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(406508), // Rule ID 11958 //
     /* 406378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 406381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406425 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406425 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 406430 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406430 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 406435 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406455 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406462 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 406465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 406472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 406477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 406482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 406487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406506 */     GIR_RootConstrainSelectedInstOperands,
     /* 406507 */     // GIR_Coverage, 11958,
     /* 406507 */     GIR_EraseRootFromParent_Done,
     /* 406508 */   // Label 5997: @406508
     /* 406508 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(406643), // Rule ID 11961 //
     /* 406513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 406516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406560 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406560 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 406565 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406565 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 406570 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406576 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406590 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406597 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 406600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 406607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 406612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 406617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 406622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406641 */     GIR_RootConstrainSelectedInstOperands,
     /* 406642 */     // GIR_Coverage, 11961,
     /* 406642 */     GIR_EraseRootFromParent_Done,
     /* 406643 */   // Label 5998: @406643
     /* 406643 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(406778), // Rule ID 11962 //
     /* 406648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 406651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406695 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 406700 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 406705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406725 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406732 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 406735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 406742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 406747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 406752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 406757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406776 */     GIR_RootConstrainSelectedInstOperands,
     /* 406777 */     // GIR_Coverage, 11962,
     /* 406777 */     GIR_EraseRootFromParent_Done,
     /* 406778 */   // Label 5999: @406778
     /* 406778 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(406913), // Rule ID 12437 //
     /* 406783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 406786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 406790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406826 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406830 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406830 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 406835 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406835 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 406840 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406867 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 406870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 406877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 406882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 406887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 406892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406911 */     GIR_RootConstrainSelectedInstOperands,
     /* 406912 */     // GIR_Coverage, 12437,
     /* 406912 */     GIR_EraseRootFromParent_Done,
     /* 406913 */   // Label 6000: @406913
     /* 406913 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(407048), // Rule ID 12438 //
     /* 406918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 406921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 406925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406965 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406965 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 406970 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406970 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 406975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406995 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407002 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 407005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 407012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 407017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 407022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 407027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407046 */     GIR_RootConstrainSelectedInstOperands,
     /* 407047 */     // GIR_Coverage, 12438,
     /* 407047 */     GIR_EraseRootFromParent_Done,
     /* 407048 */   // Label 6001: @407048
     /* 407048 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(407183), // Rule ID 12441 //
     /* 407053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 407056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 407060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407100 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407100 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407105 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407105 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407130 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407137 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 407140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 407147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 407152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 407157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 407162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407181 */     GIR_RootConstrainSelectedInstOperands,
     /* 407182 */     // GIR_Coverage, 12441,
     /* 407182 */     GIR_EraseRootFromParent_Done,
     /* 407183 */   // Label 6002: @407183
     /* 407183 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(407318), // Rule ID 12442 //
     /* 407188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 407191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 407195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407235 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407235 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407240 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407240 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407245 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407272 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 407275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 407282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 407287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 407292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 407297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407316 */     GIR_RootConstrainSelectedInstOperands,
     /* 407317 */     // GIR_Coverage, 12442,
     /* 407317 */     GIR_EraseRootFromParent_Done,
     /* 407318 */   // Label 6003: @407318
     /* 407318 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(407453), // Rule ID 12917 //
     /* 407323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 407326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407370 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407370 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407375 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407384 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407400 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407407 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 407410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 407417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 407422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 407427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 407432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407451 */     GIR_RootConstrainSelectedInstOperands,
     /* 407452 */     // GIR_Coverage, 12917,
     /* 407452 */     GIR_EraseRootFromParent_Done,
     /* 407453 */   // Label 6004: @407453
     /* 407453 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(407588), // Rule ID 12918 //
     /* 407458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 407461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407505 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407510 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407515 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407535 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407542 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 407545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 407552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 407557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 407562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 407567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407586 */     GIR_RootConstrainSelectedInstOperands,
     /* 407587 */     // GIR_Coverage, 12918,
     /* 407587 */     GIR_EraseRootFromParent_Done,
     /* 407588 */   // Label 6005: @407588
     /* 407588 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(407723), // Rule ID 12921 //
     /* 407593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 407596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407640 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407645 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407654 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407670 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407677 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 407680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 407687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 407692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 407697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 407702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407721 */     GIR_RootConstrainSelectedInstOperands,
     /* 407722 */     // GIR_Coverage, 12921,
     /* 407722 */     GIR_EraseRootFromParent_Done,
     /* 407723 */   // Label 6006: @407723
     /* 407723 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(407858), // Rule ID 12922 //
     /* 407728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 407731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407775 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407780 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407780 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407785 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407805 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407812 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 407815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 407822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 407827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 407832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 407837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407856 */     GIR_RootConstrainSelectedInstOperands,
     /* 407857 */     // GIR_Coverage, 12922,
     /* 407857 */     GIR_EraseRootFromParent_Done,
     /* 407858 */   // Label 6007: @407858
     /* 407858 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(407993), // Rule ID 11942 //
     /* 407863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 407866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407898 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 407910 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 407915 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407915 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 407920 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407940 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407947 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 407950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 407957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 407962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 407967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 407972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407991 */     GIR_RootConstrainSelectedInstOperands,
     /* 407992 */     // GIR_Coverage, 11942,
     /* 407992 */     GIR_EraseRootFromParent_Done,
     /* 407993 */   // Label 6008: @407993
     /* 407993 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(408128), // Rule ID 11943 //
     /* 407998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 408001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 408005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408045 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408045 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408050 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408050 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408055 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408059 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408075 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408082 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 408085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 408092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 408097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 408102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 408107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408126 */     GIR_RootConstrainSelectedInstOperands,
     /* 408127 */     // GIR_Coverage, 11943,
     /* 408127 */     GIR_EraseRootFromParent_Done,
     /* 408128 */   // Label 6009: @408128
     /* 408128 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(408263), // Rule ID 11946 //
     /* 408133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 408136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 408140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408180 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408180 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408185 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408194 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408210 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408217 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 408220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 408227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 408232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 408237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 408242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408261 */     GIR_RootConstrainSelectedInstOperands,
     /* 408262 */     // GIR_Coverage, 11946,
     /* 408262 */     GIR_EraseRootFromParent_Done,
     /* 408263 */   // Label 6010: @408263
     /* 408263 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(408398), // Rule ID 11947 //
     /* 408268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 408271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 408275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408315 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408320 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408352 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 408355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 408362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 408367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 408372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 408377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408396 */     GIR_RootConstrainSelectedInstOperands,
     /* 408397 */     // GIR_Coverage, 11947,
     /* 408397 */     GIR_EraseRootFromParent_Done,
     /* 408398 */   // Label 6011: @408398
     /* 408398 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(408533), // Rule ID 12422 //
     /* 408403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 408406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 408410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408450 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408455 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408460 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408487 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 408490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 408497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 408502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 408507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 408512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408531 */     GIR_RootConstrainSelectedInstOperands,
     /* 408532 */     // GIR_Coverage, 12422,
     /* 408532 */     GIR_EraseRootFromParent_Done,
     /* 408533 */   // Label 6012: @408533
     /* 408533 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(408668), // Rule ID 12423 //
     /* 408538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 408541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 408545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408585 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408590 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408590 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408595 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408608 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408615 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408622 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 408625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 408632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 408637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 408642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 408647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408666 */     GIR_RootConstrainSelectedInstOperands,
     /* 408667 */     // GIR_Coverage, 12423,
     /* 408667 */     GIR_EraseRootFromParent_Done,
     /* 408668 */   // Label 6013: @408668
     /* 408668 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(408803), // Rule ID 12426 //
     /* 408673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 408676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 408680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408712 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408716 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408720 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408720 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408725 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408725 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408730 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408750 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408757 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 408760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 408767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 408772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 408777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 408782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408801 */     GIR_RootConstrainSelectedInstOperands,
     /* 408802 */     // GIR_Coverage, 12426,
     /* 408802 */     GIR_EraseRootFromParent_Done,
     /* 408803 */   // Label 6014: @408803
     /* 408803 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(408938), // Rule ID 12427 //
     /* 408808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 408811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 408815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408855 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408855 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408860 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 408865 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408892 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 408895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 408902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 408907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 408912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 408917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408936 */     GIR_RootConstrainSelectedInstOperands,
     /* 408937 */     // GIR_Coverage, 12427,
     /* 408937 */     GIR_EraseRootFromParent_Done,
     /* 408938 */   // Label 6015: @408938
     /* 408938 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(409073), // Rule ID 12902 //
     /* 408943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 408946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 408950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 408958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408990 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 408995 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409027 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 409030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 409037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 409042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 409047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 409052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409071 */     GIR_RootConstrainSelectedInstOperands,
     /* 409072 */     // GIR_Coverage, 12902,
     /* 409072 */     GIR_EraseRootFromParent_Done,
     /* 409073 */   // Label 6016: @409073
     /* 409073 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(409208), // Rule ID 12903 //
     /* 409078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 409081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409125 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409130 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409135 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409155 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409162 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 409165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 409172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 409177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 409182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 409187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409206 */     GIR_RootConstrainSelectedInstOperands,
     /* 409207 */     // GIR_Coverage, 12903,
     /* 409207 */     GIR_EraseRootFromParent_Done,
     /* 409208 */   // Label 6017: @409208
     /* 409208 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(409343), // Rule ID 12906 //
     /* 409213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 409216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409260 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409265 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409265 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409270 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409290 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409297 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 409300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 409307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 409312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 409317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 409322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409341 */     GIR_RootConstrainSelectedInstOperands,
     /* 409342 */     // GIR_Coverage, 12906,
     /* 409342 */     GIR_EraseRootFromParent_Done,
     /* 409343 */   // Label 6018: @409343
     /* 409343 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(409478), // Rule ID 12907 //
     /* 409348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 409351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409395 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409395 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409400 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409400 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409405 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409409 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409425 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409432 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 409435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 409442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 409447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 409452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 409457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409476 */     GIR_RootConstrainSelectedInstOperands,
     /* 409477 */     // GIR_Coverage, 12907,
     /* 409477 */     GIR_EraseRootFromParent_Done,
     /* 409478 */   // Label 6019: @409478
     /* 409478 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(409613), // Rule ID 7620 //
     /* 409483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 409486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409522 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 409526 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 409530 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409530 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409535 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409540 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409560 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409567 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 409570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 409577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 409582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 409587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 409592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409611 */     GIR_RootConstrainSelectedInstOperands,
     /* 409612 */     // GIR_Coverage, 7620,
     /* 409612 */     GIR_EraseRootFromParent_Done,
     /* 409613 */   // Label 6020: @409613
     /* 409613 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(409748), // Rule ID 7652 //
     /* 409618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 409621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 409625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 409661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 409665 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409665 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409670 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409675 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409702 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 409705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 409712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 409717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 409722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 409727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409746 */     GIR_RootConstrainSelectedInstOperands,
     /* 409747 */     // GIR_Coverage, 7652,
     /* 409747 */     GIR_EraseRootFromParent_Done,
     /* 409748 */   // Label 6021: @409748
     /* 409748 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(409883), // Rule ID 7684 //
     /* 409753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 409756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409792 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 409796 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 409800 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409805 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409810 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409814 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409837 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 409840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 409847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 409852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 409857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 409862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409881 */     GIR_RootConstrainSelectedInstOperands,
     /* 409882 */     // GIR_Coverage, 7684,
     /* 409882 */     GIR_EraseRootFromParent_Done,
     /* 409883 */   // Label 6022: @409883
     /* 409883 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(410018), // Rule ID 11956 //
     /* 409888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 409891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 409931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 409935 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 409940 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 409945 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409972 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 409975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 409982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 409987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 409992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 409997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410016 */     GIR_RootConstrainSelectedInstOperands,
     /* 410017 */     // GIR_Coverage, 11956,
     /* 410017 */     GIR_EraseRootFromParent_Done,
     /* 410018 */   // Label 6023: @410018
     /* 410018 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(410153), // Rule ID 11959 //
     /* 410023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 410026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410070 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410070 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410075 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410075 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410080 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410100 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410107 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 410110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 410117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 410122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 410127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 410132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410151 */     GIR_RootConstrainSelectedInstOperands,
     /* 410152 */     // GIR_Coverage, 11959,
     /* 410152 */     GIR_EraseRootFromParent_Done,
     /* 410153 */   // Label 6024: @410153
     /* 410153 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(410288), // Rule ID 11960 //
     /* 410158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 410161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410205 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410205 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410210 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410210 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410215 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410219 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410242 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 410245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 410252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 410257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 410262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 410267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410286 */     GIR_RootConstrainSelectedInstOperands,
     /* 410287 */     // GIR_Coverage, 11960,
     /* 410287 */     GIR_EraseRootFromParent_Done,
     /* 410288 */   // Label 6025: @410288
     /* 410288 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(410423), // Rule ID 12436 //
     /* 410293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 410296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 410300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410340 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410340 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410345 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410377 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 410380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 410387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 410392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 410397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 410402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410421 */     GIR_RootConstrainSelectedInstOperands,
     /* 410422 */     // GIR_Coverage, 12436,
     /* 410422 */     GIR_EraseRootFromParent_Done,
     /* 410423 */   // Label 6026: @410423
     /* 410423 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(410558), // Rule ID 12439 //
     /* 410428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 410431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 410435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410475 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410480 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410480 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410485 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410505 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410512 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 410515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 410522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 410527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 410532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 410537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410556 */     GIR_RootConstrainSelectedInstOperands,
     /* 410557 */     // GIR_Coverage, 12439,
     /* 410557 */     GIR_EraseRootFromParent_Done,
     /* 410558 */   // Label 6027: @410558
     /* 410558 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(410693), // Rule ID 12440 //
     /* 410563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 410566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 410570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410610 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410615 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410615 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410620 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410624 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410647 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 410650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 410657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 410662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 410667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 410672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410691 */     GIR_RootConstrainSelectedInstOperands,
     /* 410692 */     // GIR_Coverage, 12440,
     /* 410692 */     GIR_EraseRootFromParent_Done,
     /* 410693 */   // Label 6028: @410693
     /* 410693 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(410828), // Rule ID 12916 //
     /* 410698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 410701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410745 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410750 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410750 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410755 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410759 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410775 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410782 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 410785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 410792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 410797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 410802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 410807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410826 */     GIR_RootConstrainSelectedInstOperands,
     /* 410827 */     // GIR_Coverage, 12916,
     /* 410827 */     GIR_EraseRootFromParent_Done,
     /* 410828 */   // Label 6029: @410828
     /* 410828 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(410963), // Rule ID 12919 //
     /* 410833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 410836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 410876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410880 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410880 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410885 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410885 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410894 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410910 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410917 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 410920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 410927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 410932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 410937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 410942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410961 */     GIR_RootConstrainSelectedInstOperands,
     /* 410962 */     // GIR_Coverage, 12919,
     /* 410962 */     GIR_EraseRootFromParent_Done,
     /* 410963 */   // Label 6030: @410963
     /* 410963 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(411098), // Rule ID 12920 //
     /* 410968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 410971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 411015 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411015 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411020 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411025 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411045 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411052 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 411055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 411062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 411067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 411072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 411077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411096 */     GIR_RootConstrainSelectedInstOperands,
     /* 411097 */     // GIR_Coverage, 12920,
     /* 411097 */     GIR_EraseRootFromParent_Done,
     /* 411098 */   // Label 6031: @411098
     /* 411098 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(411233), // Rule ID 7619 //
     /* 411103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 411106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 411150 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411155 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411155 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411160 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411187 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 411190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 411197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 411202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 411207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 411212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411231 */     GIR_RootConstrainSelectedInstOperands,
     /* 411232 */     // GIR_Coverage, 7619,
     /* 411232 */     GIR_EraseRootFromParent_Done,
     /* 411233 */   // Label 6032: @411233
     /* 411233 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(411368), // Rule ID 7651 //
     /* 411238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 411241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 411245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 411285 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411290 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411295 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411322 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 411325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 411332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 411337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 411342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 411347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411366 */     GIR_RootConstrainSelectedInstOperands,
     /* 411367 */     // GIR_Coverage, 7651,
     /* 411367 */     GIR_EraseRootFromParent_Done,
     /* 411368 */   // Label 6033: @411368
     /* 411368 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(411503), // Rule ID 7683 //
     /* 411373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 411376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411416 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 411420 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411425 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411425 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411430 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411457 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 411460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 411467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 411472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 411477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 411482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411501 */     GIR_RootConstrainSelectedInstOperands,
     /* 411502 */     // GIR_Coverage, 7683,
     /* 411502 */     GIR_EraseRootFromParent_Done,
     /* 411503 */   // Label 6034: @411503
     /* 411503 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(411638), // Rule ID 11941 //
     /* 411508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 411511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 411555 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411555 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411560 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411560 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411565 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411569 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411585 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411592 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 411595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 411602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 411607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 411612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 411617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411636 */     GIR_RootConstrainSelectedInstOperands,
     /* 411637 */     // GIR_Coverage, 11941,
     /* 411637 */     GIR_EraseRootFromParent_Done,
     /* 411638 */   // Label 6035: @411638
     /* 411638 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(411773), // Rule ID 11944 //
     /* 411643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 411646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 411690 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411690 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411695 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411700 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411727 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 411730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 411737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 411742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 411747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 411752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411771 */     GIR_RootConstrainSelectedInstOperands,
     /* 411772 */     // GIR_Coverage, 11944,
     /* 411772 */     GIR_EraseRootFromParent_Done,
     /* 411773 */   // Label 6036: @411773
     /* 411773 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(411908), // Rule ID 11945 //
     /* 411778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 411781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 411825 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411825 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411830 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411830 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411835 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411862 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 411865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 411872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 411877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 411882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 411887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411906 */     GIR_RootConstrainSelectedInstOperands,
     /* 411907 */     // GIR_Coverage, 11945,
     /* 411907 */     GIR_EraseRootFromParent_Done,
     /* 411908 */   // Label 6037: @411908
     /* 411908 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(412043), // Rule ID 12421 //
     /* 411913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 411916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 411920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 411956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 411960 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411965 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411965 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411997 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 412000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 412007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 412012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 412017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 412022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412041 */     GIR_RootConstrainSelectedInstOperands,
     /* 412042 */     // GIR_Coverage, 12421,
     /* 412042 */     GIR_EraseRootFromParent_Done,
     /* 412043 */   // Label 6038: @412043
     /* 412043 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(412178), // Rule ID 12424 //
     /* 412048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 412051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 412055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 412091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412095 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412100 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412100 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412105 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412132 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 412135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412176 */     GIR_RootConstrainSelectedInstOperands,
     /* 412177 */     // GIR_Coverage, 12424,
     /* 412177 */     GIR_EraseRootFromParent_Done,
     /* 412178 */   // Label 6039: @412178
     /* 412178 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(412313), // Rule ID 12425 //
     /* 412183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 412186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 412190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 412226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412230 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412230 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412235 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412235 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412240 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412244 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412267 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 412270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412311 */     GIR_RootConstrainSelectedInstOperands,
     /* 412312 */     // GIR_Coverage, 12425,
     /* 412312 */     GIR_EraseRootFromParent_Done,
     /* 412313 */   // Label 6040: @412313
     /* 412313 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(412448), // Rule ID 12901 //
     /* 412318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 412321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 412361 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412365 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412365 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412370 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412370 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412395 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412402 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 412405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 412412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 412417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 412422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 412427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412446 */     GIR_RootConstrainSelectedInstOperands,
     /* 412447 */     // GIR_Coverage, 12901,
     /* 412447 */     GIR_EraseRootFromParent_Done,
     /* 412448 */   // Label 6041: @412448
     /* 412448 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(412583), // Rule ID 12904 //
     /* 412453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 412456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 412496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412500 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412500 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412505 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412510 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412537 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 412540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412581 */     GIR_RootConstrainSelectedInstOperands,
     /* 412582 */     // GIR_Coverage, 12904,
     /* 412582 */     GIR_EraseRootFromParent_Done,
     /* 412583 */   // Label 6042: @412583
     /* 412583 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(412718), // Rule ID 12905 //
     /* 412588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 412591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 412631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412635 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412640 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412649 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412672 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 412675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412716 */     GIR_RootConstrainSelectedInstOperands,
     /* 412717 */     // GIR_Coverage, 12905,
     /* 412717 */     GIR_EraseRootFromParent_Done,
     /* 412718 */   // Label 6043: @412718
     /* 412718 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(412853), // Rule ID 11927 //
     /* 412723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 412726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 412770 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412775 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412780 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412807 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 412810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 412817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 412822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 412827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 412832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412851 */     GIR_RootConstrainSelectedInstOperands,
     /* 412852 */     // GIR_Coverage, 11927,
     /* 412852 */     GIR_EraseRootFromParent_Done,
     /* 412853 */   // Label 6044: @412853
     /* 412853 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(412988), // Rule ID 11928 //
     /* 412858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 412861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 412905 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412910 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412915 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412942 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 412945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 412952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 412957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 412962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 412967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412986 */     GIR_RootConstrainSelectedInstOperands,
     /* 412987 */     // GIR_Coverage, 11928,
     /* 412987 */     GIR_EraseRootFromParent_Done,
     /* 412988 */   // Label 6045: @412988
     /* 412988 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(413123), // Rule ID 11931 //
     /* 412993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 412996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 413000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413040 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413040 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413045 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413045 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413070 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413077 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 413080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 413087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 413092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 413097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 413102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413121 */     GIR_RootConstrainSelectedInstOperands,
     /* 413122 */     // GIR_Coverage, 11931,
     /* 413122 */     GIR_EraseRootFromParent_Done,
     /* 413123 */   // Label 6046: @413123
     /* 413123 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(413258), // Rule ID 11932 //
     /* 413128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 413131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 413135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413167 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413171 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413175 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413175 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413180 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413180 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413185 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413212 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 413215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 413222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 413227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 413232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 413237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413256 */     GIR_RootConstrainSelectedInstOperands,
     /* 413257 */     // GIR_Coverage, 11932,
     /* 413257 */     GIR_EraseRootFromParent_Done,
     /* 413258 */   // Label 6047: @413258
     /* 413258 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(413393), // Rule ID 12407 //
     /* 413263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 413266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 413270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413310 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413315 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413320 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413347 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 413350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 413357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 413362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 413367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 413372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413391 */     GIR_RootConstrainSelectedInstOperands,
     /* 413392 */     // GIR_Coverage, 12407,
     /* 413392 */     GIR_EraseRootFromParent_Done,
     /* 413393 */   // Label 6048: @413393
     /* 413393 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(413528), // Rule ID 12408 //
     /* 413398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 413401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 413405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413445 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413450 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413455 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413482 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 413485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 413492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 413497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 413502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 413507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413526 */     GIR_RootConstrainSelectedInstOperands,
     /* 413527 */     // GIR_Coverage, 12408,
     /* 413527 */     GIR_EraseRootFromParent_Done,
     /* 413528 */   // Label 6049: @413528
     /* 413528 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(413663), // Rule ID 12411 //
     /* 413533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 413536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 413540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413580 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413585 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413590 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413617 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 413620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 413627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 413632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 413637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 413642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413661 */     GIR_RootConstrainSelectedInstOperands,
     /* 413662 */     // GIR_Coverage, 12411,
     /* 413662 */     GIR_EraseRootFromParent_Done,
     /* 413663 */   // Label 6050: @413663
     /* 413663 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(413798), // Rule ID 12412 //
     /* 413668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 413671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 413675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413715 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413715 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413720 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413720 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413729 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413752 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 413755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 413762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 413767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 413772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 413777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413796 */     GIR_RootConstrainSelectedInstOperands,
     /* 413797 */     // GIR_Coverage, 12412,
     /* 413797 */     GIR_EraseRootFromParent_Done,
     /* 413798 */   // Label 6051: @413798
     /* 413798 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(413933), // Rule ID 12887 //
     /* 413803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 413806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 413810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413842 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413846 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413850 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413850 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413855 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413855 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413860 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413880 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413887 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 413890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 413897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 413902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 413907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 413912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413931 */     GIR_RootConstrainSelectedInstOperands,
     /* 413932 */     // GIR_Coverage, 12887,
     /* 413932 */     GIR_EraseRootFromParent_Done,
     /* 413933 */   // Label 6052: @413933
     /* 413933 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(414068), // Rule ID 12888 //
     /* 413938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 413941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 413945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413985 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413985 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413990 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413995 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414022 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 414025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 414032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 414037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 414042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 414047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414066 */     GIR_RootConstrainSelectedInstOperands,
     /* 414067 */     // GIR_Coverage, 12888,
     /* 414067 */     GIR_EraseRootFromParent_Done,
     /* 414068 */   // Label 6053: @414068
     /* 414068 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(414203), // Rule ID 12891 //
     /* 414073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 414076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414120 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414125 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414150 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414157 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 414160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 414167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 414172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 414177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 414182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414201 */     GIR_RootConstrainSelectedInstOperands,
     /* 414202 */     // GIR_Coverage, 12891,
     /* 414202 */     GIR_EraseRootFromParent_Done,
     /* 414203 */   // Label 6054: @414203
     /* 414203 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(414338), // Rule ID 12892 //
     /* 414208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 414211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414255 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414260 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414292 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 414295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 414302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 414307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 414312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 414317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414336 */     GIR_RootConstrainSelectedInstOperands,
     /* 414337 */     // GIR_Coverage, 12892,
     /* 414337 */     GIR_EraseRootFromParent_Done,
     /* 414338 */   // Label 6055: @414338
     /* 414338 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(414473), // Rule ID 11912 //
     /* 414343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 414346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 414390 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414395 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414395 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414400 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414404 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414427 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 414430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 414437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 414442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 414447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 414452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414471 */     GIR_RootConstrainSelectedInstOperands,
     /* 414472 */     // GIR_Coverage, 11912,
     /* 414472 */     GIR_EraseRootFromParent_Done,
     /* 414473 */   // Label 6056: @414473
     /* 414473 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(414608), // Rule ID 11913 //
     /* 414478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 414481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 414525 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414525 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414530 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414530 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414535 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414539 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414555 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414562 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 414565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 414572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 414577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 414582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 414587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414606 */     GIR_RootConstrainSelectedInstOperands,
     /* 414607 */     // GIR_Coverage, 11913,
     /* 414607 */     GIR_EraseRootFromParent_Done,
     /* 414608 */   // Label 6057: @414608
     /* 414608 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(414743), // Rule ID 11916 //
     /* 414613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 414616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 414660 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414665 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414665 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414670 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414674 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414697 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 414700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 414707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 414712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 414717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 414722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414741 */     GIR_RootConstrainSelectedInstOperands,
     /* 414742 */     // GIR_Coverage, 11916,
     /* 414742 */     GIR_EraseRootFromParent_Done,
     /* 414743 */   // Label 6058: @414743
     /* 414743 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(414878), // Rule ID 11917 //
     /* 414748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 414751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 414795 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414800 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414832 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 414835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 414842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 414847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 414852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 414857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414876 */     GIR_RootConstrainSelectedInstOperands,
     /* 414877 */     // GIR_Coverage, 11917,
     /* 414877 */     GIR_EraseRootFromParent_Done,
     /* 414878 */   // Label 6059: @414878
     /* 414878 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(415013), // Rule ID 12392 //
     /* 414883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 414886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 414890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 414930 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414935 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414940 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414967 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 414970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 414977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 414982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 414987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 414992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415011 */     GIR_RootConstrainSelectedInstOperands,
     /* 415012 */     // GIR_Coverage, 12392,
     /* 415012 */     GIR_EraseRootFromParent_Done,
     /* 415013 */   // Label 6060: @415013
     /* 415013 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(415148), // Rule ID 12393 //
     /* 415018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 415021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 415025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415065 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415070 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415070 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415079 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415102 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 415105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 415112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 415117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 415122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 415127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415146 */     GIR_RootConstrainSelectedInstOperands,
     /* 415147 */     // GIR_Coverage, 12393,
     /* 415147 */     GIR_EraseRootFromParent_Done,
     /* 415148 */   // Label 6061: @415148
     /* 415148 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(415283), // Rule ID 12396 //
     /* 415153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 415156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 415160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415200 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415200 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415205 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415205 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415210 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415237 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 415240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 415247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 415252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 415257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 415262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415281 */     GIR_RootConstrainSelectedInstOperands,
     /* 415282 */     // GIR_Coverage, 12396,
     /* 415282 */     GIR_EraseRootFromParent_Done,
     /* 415283 */   // Label 6062: @415283
     /* 415283 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(415418), // Rule ID 12397 //
     /* 415288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 415291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 415295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415335 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415335 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415340 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415340 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415345 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415349 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415372 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 415375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 415382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 415387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 415392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 415397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415416 */     GIR_RootConstrainSelectedInstOperands,
     /* 415417 */     // GIR_Coverage, 12397,
     /* 415417 */     GIR_EraseRootFromParent_Done,
     /* 415418 */   // Label 6063: @415418
     /* 415418 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(415553), // Rule ID 12872 //
     /* 415423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 415426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415466 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415470 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415470 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415475 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415480 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415507 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 415510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 415517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 415522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 415527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 415532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415551 */     GIR_RootConstrainSelectedInstOperands,
     /* 415552 */     // GIR_Coverage, 12872,
     /* 415552 */     GIR_EraseRootFromParent_Done,
     /* 415553 */   // Label 6064: @415553
     /* 415553 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(415688), // Rule ID 12873 //
     /* 415558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 415561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415605 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415610 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415642 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 415645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 415652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 415657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 415662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 415667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415686 */     GIR_RootConstrainSelectedInstOperands,
     /* 415687 */     // GIR_Coverage, 12873,
     /* 415687 */     GIR_EraseRootFromParent_Done,
     /* 415688 */   // Label 6065: @415688
     /* 415688 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(415823), // Rule ID 12876 //
     /* 415693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 415696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415740 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415745 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415777 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 415780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 415787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 415792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 415797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 415802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415821 */     GIR_RootConstrainSelectedInstOperands,
     /* 415822 */     // GIR_Coverage, 12876,
     /* 415822 */     GIR_EraseRootFromParent_Done,
     /* 415823 */   // Label 6066: @415823
     /* 415823 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(415958), // Rule ID 12877 //
     /* 415828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 415831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415875 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415875 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415880 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415880 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415885 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415889 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415905 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415912 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 415915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 415922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 415927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 415932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 415937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415956 */     GIR_RootConstrainSelectedInstOperands,
     /* 415957 */     // GIR_Coverage, 12877,
     /* 415957 */     GIR_EraseRootFromParent_Done,
     /* 415958 */   // Label 6067: @415958
     /* 415958 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(416093), // Rule ID 7618 //
     /* 415963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 415966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416006 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416010 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416010 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416015 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416015 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416020 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416047 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 416050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 416057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 416062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 416067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 416072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416091 */     GIR_RootConstrainSelectedInstOperands,
     /* 416092 */     // GIR_Coverage, 7618,
     /* 416092 */     GIR_EraseRootFromParent_Done,
     /* 416093 */   // Label 6068: @416093
     /* 416093 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(416228), // Rule ID 7650 //
     /* 416098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 416101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 416105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416145 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416145 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416150 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416155 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416182 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 416185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 416192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 416197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 416202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 416207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416226 */     GIR_RootConstrainSelectedInstOperands,
     /* 416227 */     // GIR_Coverage, 7650,
     /* 416227 */     GIR_EraseRootFromParent_Done,
     /* 416228 */   // Label 6069: @416228
     /* 416228 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(416363), // Rule ID 7682 //
     /* 416233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 416236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416280 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416285 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416290 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416294 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416317 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 416320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 416327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 416332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 416337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 416342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416361 */     GIR_RootConstrainSelectedInstOperands,
     /* 416362 */     // GIR_Coverage, 7682,
     /* 416362 */     GIR_EraseRootFromParent_Done,
     /* 416363 */   // Label 6070: @416363
     /* 416363 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(416498), // Rule ID 11926 //
     /* 416368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 416371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416415 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416420 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416452 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 416455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 416462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 416467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 416472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 416477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416496 */     GIR_RootConstrainSelectedInstOperands,
     /* 416497 */     // GIR_Coverage, 11926,
     /* 416497 */     GIR_EraseRootFromParent_Done,
     /* 416498 */   // Label 6071: @416498
     /* 416498 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(416633), // Rule ID 11929 //
     /* 416503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 416506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416550 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416550 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416555 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416555 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416587 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 416590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 416597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 416602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 416607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 416612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416631 */     GIR_RootConstrainSelectedInstOperands,
     /* 416632 */     // GIR_Coverage, 11929,
     /* 416632 */     GIR_EraseRootFromParent_Done,
     /* 416633 */   // Label 6072: @416633
     /* 416633 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(416768), // Rule ID 11930 //
     /* 416638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 416641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416673 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416685 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416685 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416690 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416690 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416699 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416715 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416722 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 416725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 416732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 416737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 416742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 416747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416766 */     GIR_RootConstrainSelectedInstOperands,
     /* 416767 */     // GIR_Coverage, 11930,
     /* 416767 */     GIR_EraseRootFromParent_Done,
     /* 416768 */   // Label 6073: @416768
     /* 416768 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(416903), // Rule ID 12406 //
     /* 416773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 416776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 416780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416820 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416820 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416825 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416825 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416830 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416850 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416857 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 416860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 416867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 416872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 416877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 416882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416901 */     GIR_RootConstrainSelectedInstOperands,
     /* 416902 */     // GIR_Coverage, 12406,
     /* 416902 */     GIR_EraseRootFromParent_Done,
     /* 416903 */   // Label 6074: @416903
     /* 416903 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(417038), // Rule ID 12409 //
     /* 416908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 416911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 416915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 416955 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416960 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416992 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 416995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 417002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 417007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 417012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 417017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417036 */     GIR_RootConstrainSelectedInstOperands,
     /* 417037 */     // GIR_Coverage, 12409,
     /* 417037 */     GIR_EraseRootFromParent_Done,
     /* 417038 */   // Label 6075: @417038
     /* 417038 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(417173), // Rule ID 12410 //
     /* 417043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 417046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 417050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417090 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417095 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417127 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 417130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 417137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 417142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 417147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 417152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417171 */     GIR_RootConstrainSelectedInstOperands,
     /* 417172 */     // GIR_Coverage, 12410,
     /* 417172 */     GIR_EraseRootFromParent_Done,
     /* 417173 */   // Label 6076: @417173
     /* 417173 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(417308), // Rule ID 12886 //
     /* 417178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 417181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417225 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417230 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417230 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417235 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417262 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 417265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 417272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 417277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 417282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 417287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417306 */     GIR_RootConstrainSelectedInstOperands,
     /* 417307 */     // GIR_Coverage, 12886,
     /* 417307 */     GIR_EraseRootFromParent_Done,
     /* 417308 */   // Label 6077: @417308
     /* 417308 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(417443), // Rule ID 12889 //
     /* 417313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 417316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417360 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417360 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417365 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417365 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417390 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417397 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 417400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 417407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 417412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 417417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 417422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417441 */     GIR_RootConstrainSelectedInstOperands,
     /* 417442 */     // GIR_Coverage, 12889,
     /* 417442 */     GIR_EraseRootFromParent_Done,
     /* 417443 */   // Label 6078: @417443
     /* 417443 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(417578), // Rule ID 12890 //
     /* 417448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 417451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417495 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417495 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417500 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417500 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417509 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417511 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417532 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 417535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 417542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 417547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 417552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 417557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417576 */     GIR_RootConstrainSelectedInstOperands,
     /* 417577 */     // GIR_Coverage, 12890,
     /* 417577 */     GIR_EraseRootFromParent_Done,
     /* 417578 */   // Label 6079: @417578
     /* 417578 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(417713), // Rule ID 7617 //
     /* 417583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 417586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 417630 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417630 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417635 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417667 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 417670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 417677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 417682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 417687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 417692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417711 */     GIR_RootConstrainSelectedInstOperands,
     /* 417712 */     // GIR_Coverage, 7617,
     /* 417712 */     GIR_EraseRootFromParent_Done,
     /* 417713 */   // Label 6080: @417713
     /* 417713 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(417848), // Rule ID 7649 //
     /* 417718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 417721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 417725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 417765 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417770 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417775 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417802 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 417805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 417812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 417817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 417822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 417827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417846 */     GIR_RootConstrainSelectedInstOperands,
     /* 417847 */     // GIR_Coverage, 7649,
     /* 417847 */     GIR_EraseRootFromParent_Done,
     /* 417848 */   // Label 6081: @417848
     /* 417848 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(417983), // Rule ID 7681 //
     /* 417853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 417856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 417900 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417905 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417937 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 417940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 417947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 417952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 417957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 417962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417981 */     GIR_RootConstrainSelectedInstOperands,
     /* 417982 */     // GIR_Coverage, 7681,
     /* 417982 */     GIR_EraseRootFromParent_Done,
     /* 417983 */   // Label 6082: @417983
     /* 417983 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(418118), // Rule ID 11911 //
     /* 417988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 417991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418023 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418035 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418035 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418040 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418040 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418045 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418072 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 418075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 418082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 418087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 418092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 418097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418116 */     GIR_RootConstrainSelectedInstOperands,
     /* 418117 */     // GIR_Coverage, 11911,
     /* 418117 */     GIR_EraseRootFromParent_Done,
     /* 418118 */   // Label 6083: @418118
     /* 418118 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(418253), // Rule ID 11914 //
     /* 418123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 418126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418158 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418170 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418170 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418175 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418175 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418180 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418184 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418207 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 418210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 418217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 418222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 418227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 418232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418251 */     GIR_RootConstrainSelectedInstOperands,
     /* 418252 */     // GIR_Coverage, 11914,
     /* 418252 */     GIR_EraseRootFromParent_Done,
     /* 418253 */   // Label 6084: @418253
     /* 418253 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(418388), // Rule ID 11915 //
     /* 418258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 418261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418305 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418305 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418310 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418342 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 418345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 418352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 418357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 418362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 418367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418386 */     GIR_RootConstrainSelectedInstOperands,
     /* 418387 */     // GIR_Coverage, 11915,
     /* 418387 */     GIR_EraseRootFromParent_Done,
     /* 418388 */   // Label 6085: @418388
     /* 418388 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(418523), // Rule ID 12391 //
     /* 418393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 418396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 418400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418440 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418440 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418445 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418450 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418477 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 418480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 418487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 418492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 418497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 418502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418521 */     GIR_RootConstrainSelectedInstOperands,
     /* 418522 */     // GIR_Coverage, 12391,
     /* 418522 */     GIR_EraseRootFromParent_Done,
     /* 418523 */   // Label 6086: @418523
     /* 418523 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(418658), // Rule ID 12394 //
     /* 418528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 418531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 418535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418575 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418580 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418612 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 418615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 418622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 418627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 418632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 418637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418656 */     GIR_RootConstrainSelectedInstOperands,
     /* 418657 */     // GIR_Coverage, 12394,
     /* 418657 */     GIR_EraseRootFromParent_Done,
     /* 418658 */   // Label 6087: @418658
     /* 418658 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(418793), // Rule ID 12395 //
     /* 418663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 418666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 418670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418710 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418715 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418715 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418720 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418740 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418747 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 418750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 418757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 418762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 418767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 418772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418791 */     GIR_RootConstrainSelectedInstOperands,
     /* 418792 */     // GIR_Coverage, 12395,
     /* 418792 */     GIR_EraseRootFromParent_Done,
     /* 418793 */   // Label 6088: @418793
     /* 418793 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(418928), // Rule ID 12871 //
     /* 418798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 418801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418833 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418841 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418845 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418850 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418850 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418882 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 418885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 418892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 418897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 418902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 418907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418926 */     GIR_RootConstrainSelectedInstOperands,
     /* 418927 */     // GIR_Coverage, 12871,
     /* 418927 */     GIR_EraseRootFromParent_Done,
     /* 418928 */   // Label 6089: @418928
     /* 418928 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(419063), // Rule ID 12874 //
     /* 418933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 418936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 418976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418980 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418980 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418985 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418985 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418990 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418994 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419010 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419017 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 419020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 419037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 419042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419061 */     GIR_RootConstrainSelectedInstOperands,
     /* 419062 */     // GIR_Coverage, 12874,
     /* 419062 */     GIR_EraseRootFromParent_Done,
     /* 419063 */   // Label 6090: @419063
     /* 419063 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(419198), // Rule ID 12875 //
     /* 419068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 419071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 419095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 419111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 419115 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 419120 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 419125 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419138 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419145 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419152 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 419155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 419172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 419177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419196 */     GIR_RootConstrainSelectedInstOperands,
     /* 419197 */     // GIR_Coverage, 12875,
     /* 419197 */     GIR_EraseRootFromParent_Done,
     /* 419198 */   // Label 6091: @419198
     /* 419198 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(419333), // Rule ID 11997 //
     /* 419203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 419206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 419234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 419246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 419250 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 419255 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 419260 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419287 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 419290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 419307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 419312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 419317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 419322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419331 */     GIR_RootConstrainSelectedInstOperands,
     /* 419332 */     // GIR_Coverage, 11997,
     /* 419332 */     GIR_EraseRootFromParent_Done,
     /* 419333 */   // Label 6092: @419333
     /* 419333 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(419468), // Rule ID 11998 //
     /* 419338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 419341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 419369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 419381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 419385 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 419390 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 419395 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419422 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 419425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 419442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 419447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 419452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 419457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419466 */     GIR_RootConstrainSelectedInstOperands,
     /* 419467 */     // GIR_Coverage, 11998,
     /* 419467 */     GIR_EraseRootFromParent_Done,
     /* 419468 */   // Label 6093: @419468
     /* 419468 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(419603), // Rule ID 11999 //
     /* 419473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 419476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 419504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 419516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 419520 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419520 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 419525 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419525 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 419530 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419534 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419550 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419557 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 419560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 419567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 419572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 419577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 419582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 419587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 419592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419601 */     GIR_RootConstrainSelectedInstOperands,
     /* 419602 */     // GIR_Coverage, 11999,
     /* 419602 */     GIR_EraseRootFromParent_Done,
     /* 419603 */   // Label 6094: @419603
     /* 419603 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(419738), // Rule ID 12000 //
     /* 419608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 419611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 419639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 419651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 419655 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419655 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 419660 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 419665 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419669 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419678 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419685 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419692 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 419695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 419702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 419707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 419712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 419717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 419722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 419727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419736 */     GIR_RootConstrainSelectedInstOperands,
     /* 419737 */     // GIR_Coverage, 12000,
     /* 419737 */     GIR_EraseRootFromParent_Done,
     /* 419738 */   // Label 6095: @419738
     /* 419738 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(419873), // Rule ID 12477 //
     /* 419743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 419746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 419750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 419774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 419786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 419790 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419790 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 419795 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 419800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419804 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419813 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419827 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 419830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 419847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 419852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 419857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 419862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419871 */     GIR_RootConstrainSelectedInstOperands,
     /* 419872 */     // GIR_Coverage, 12477,
     /* 419872 */     GIR_EraseRootFromParent_Done,
     /* 419873 */   // Label 6096: @419873
     /* 419873 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(420008), // Rule ID 12478 //
     /* 419878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 419881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 419885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 419905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 419909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 419921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 419925 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 419930 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 419935 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419962 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 419965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 419982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 419987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 419992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 419997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420006 */     GIR_RootConstrainSelectedInstOperands,
     /* 420007 */     // GIR_Coverage, 12478,
     /* 420007 */     GIR_EraseRootFromParent_Done,
     /* 420008 */   // Label 6097: @420008
     /* 420008 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(420143), // Rule ID 12479 //
     /* 420013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 420016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 420020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 420060 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420065 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420070 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420083 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420090 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420097 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 420100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 420107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 420112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 420117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 420122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420141 */     GIR_RootConstrainSelectedInstOperands,
     /* 420142 */     // GIR_Coverage, 12479,
     /* 420142 */     GIR_EraseRootFromParent_Done,
     /* 420143 */   // Label 6098: @420143
     /* 420143 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(420278), // Rule ID 12480 //
     /* 420148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 420151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 420155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 420195 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420195 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420200 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420200 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420225 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420232 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 420235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 420242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 420247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 420252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 420257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420276 */     GIR_RootConstrainSelectedInstOperands,
     /* 420277 */     // GIR_Coverage, 12480,
     /* 420277 */     GIR_EraseRootFromParent_Done,
     /* 420278 */   // Label 6099: @420278
     /* 420278 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(420413), // Rule ID 12957 //
     /* 420283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 420286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 420330 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420330 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420335 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420335 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420340 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420344 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420353 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420360 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420367 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 420370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 420377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 420382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 420387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 420392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420411 */     GIR_RootConstrainSelectedInstOperands,
     /* 420412 */     // GIR_Coverage, 12957,
     /* 420412 */     GIR_EraseRootFromParent_Done,
     /* 420413 */   // Label 6100: @420413
     /* 420413 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(420548), // Rule ID 12958 //
     /* 420418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 420421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 420465 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420465 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420470 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420470 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420495 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420502 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 420505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 420512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 420517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 420522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 420527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420546 */     GIR_RootConstrainSelectedInstOperands,
     /* 420547 */     // GIR_Coverage, 12958,
     /* 420547 */     GIR_EraseRootFromParent_Done,
     /* 420548 */   // Label 6101: @420548
     /* 420548 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(420683), // Rule ID 12959 //
     /* 420553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 420556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 420600 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420605 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420610 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420637 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 420640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 420647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 420652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 420657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 420662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420681 */     GIR_RootConstrainSelectedInstOperands,
     /* 420682 */     // GIR_Coverage, 12959,
     /* 420682 */     GIR_EraseRootFromParent_Done,
     /* 420683 */   // Label 6102: @420683
     /* 420683 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(420818), // Rule ID 12960 //
     /* 420688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 420691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 420735 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420740 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420772 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 420775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 420782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 420787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 420792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 420797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420816 */     GIR_RootConstrainSelectedInstOperands,
     /* 420817 */     // GIR_Coverage, 12960,
     /* 420817 */     GIR_EraseRootFromParent_Done,
     /* 420818 */   // Label 6103: @420818
     /* 420818 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(420953), // Rule ID 11937 //
     /* 420823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 420826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 420866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420870 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 420875 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420875 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 420880 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420907 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 420910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 420917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 420922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 420927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 420932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 420937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 420942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420951 */     GIR_RootConstrainSelectedInstOperands,
     /* 420952 */     // GIR_Coverage, 11937,
     /* 420952 */     GIR_EraseRootFromParent_Done,
     /* 420953 */   // Label 6104: @420953
     /* 420953 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(421088), // Rule ID 11938 //
     /* 420958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 420961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421005 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421005 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421010 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421010 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421015 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421042 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 421045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 421057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 421062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 421067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421086 */     GIR_RootConstrainSelectedInstOperands,
     /* 421087 */     // GIR_Coverage, 11938,
     /* 421087 */     GIR_EraseRootFromParent_Done,
     /* 421088 */   // Label 6105: @421088
     /* 421088 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(421223), // Rule ID 11939 //
     /* 421093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 421096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 421100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421140 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421145 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421145 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421150 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421156 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421163 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421177 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 421180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 421187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 421192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 421197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 421202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421221 */     GIR_RootConstrainSelectedInstOperands,
     /* 421222 */     // GIR_Coverage, 11939,
     /* 421222 */     GIR_EraseRootFromParent_Done,
     /* 421223 */   // Label 6106: @421223
     /* 421223 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(421358), // Rule ID 11940 //
     /* 421228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 421231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 421235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421275 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421275 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421280 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421285 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421312 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 421315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 421322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 421327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 421332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 421337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421356 */     GIR_RootConstrainSelectedInstOperands,
     /* 421357 */     // GIR_Coverage, 11940,
     /* 421357 */     GIR_EraseRootFromParent_Done,
     /* 421358 */   // Label 6107: @421358
     /* 421358 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(421493), // Rule ID 12417 //
     /* 421363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 421366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 421370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421410 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421415 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421420 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421424 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421433 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421440 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421447 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 421450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 421462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 421467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 421472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421491 */     GIR_RootConstrainSelectedInstOperands,
     /* 421492 */     // GIR_Coverage, 12417,
     /* 421492 */     GIR_EraseRootFromParent_Done,
     /* 421493 */   // Label 6108: @421493
     /* 421493 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(421628), // Rule ID 12418 //
     /* 421498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 421501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 421505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421545 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421545 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421550 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421550 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421575 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421582 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 421585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 421597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 421602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 421607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421626 */     GIR_RootConstrainSelectedInstOperands,
     /* 421627 */     // GIR_Coverage, 12418,
     /* 421627 */     GIR_EraseRootFromParent_Done,
     /* 421628 */   // Label 6109: @421628
     /* 421628 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(421763), // Rule ID 12419 //
     /* 421633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 421636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 421640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421680 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421685 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421685 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421690 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421694 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421696 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421703 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421710 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421717 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 421720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 421727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 421732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 421737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 421742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421761 */     GIR_RootConstrainSelectedInstOperands,
     /* 421762 */     // GIR_Coverage, 12419,
     /* 421762 */     GIR_EraseRootFromParent_Done,
     /* 421763 */   // Label 6110: @421763
     /* 421763 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(421898), // Rule ID 12420 //
     /* 421768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 421771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 421775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421815 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421815 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421820 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421820 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421825 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421829 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421838 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421852 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 421855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 421862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 421867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 421872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 421877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 421882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 421887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421896 */     GIR_RootConstrainSelectedInstOperands,
     /* 421897 */     // GIR_Coverage, 12420,
     /* 421897 */     GIR_EraseRootFromParent_Done,
     /* 421898 */   // Label 6111: @421898
     /* 421898 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(422033), // Rule ID 12897 //
     /* 421903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 421906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 421910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 421946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421950 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421950 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 421955 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 421960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421980 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421987 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 421990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 422002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 422007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 422012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422031 */     GIR_RootConstrainSelectedInstOperands,
     /* 422032 */     // GIR_Coverage, 12897,
     /* 422032 */     GIR_EraseRootFromParent_Done,
     /* 422033 */   // Label 6112: @422033
     /* 422033 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(422168), // Rule ID 12898 //
     /* 422038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 422041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 422069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422085 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422085 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422090 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422108 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422115 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422122 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 422125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 422132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 422137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 422142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 422147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422166 */     GIR_RootConstrainSelectedInstOperands,
     /* 422167 */     // GIR_Coverage, 12898,
     /* 422167 */     GIR_EraseRootFromParent_Done,
     /* 422168 */   // Label 6113: @422168
     /* 422168 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(422303), // Rule ID 12899 //
     /* 422173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 422176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 422204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422220 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422225 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422250 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422257 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 422260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 422267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 422272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 422277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 422282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422301 */     GIR_RootConstrainSelectedInstOperands,
     /* 422302 */     // GIR_Coverage, 12899,
     /* 422302 */     GIR_EraseRootFromParent_Done,
     /* 422303 */   // Label 6114: @422303
     /* 422303 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(422438), // Rule ID 12900 //
     /* 422308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 422311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 422339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422355 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422360 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422360 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422369 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422392 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 422395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 422402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 422407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 422412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 422417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422436 */     GIR_RootConstrainSelectedInstOperands,
     /* 422437 */     // GIR_Coverage, 12900,
     /* 422437 */     GIR_EraseRootFromParent_Done,
     /* 422438 */   // Label 6115: @422438
     /* 422438 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(422573), // Rule ID 11982 //
     /* 422443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 422446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 422490 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422490 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422495 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422495 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422500 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422506 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422520 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422527 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 422530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 422537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 422542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 422547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 422552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422571 */     GIR_RootConstrainSelectedInstOperands,
     /* 422572 */     // GIR_Coverage, 11982,
     /* 422572 */     GIR_EraseRootFromParent_Done,
     /* 422573 */   // Label 6116: @422573
     /* 422573 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(422708), // Rule ID 11983 //
     /* 422578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 422581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422613 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 422625 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422625 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422630 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422630 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422635 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422639 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422648 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422655 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422662 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 422665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 422672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 422677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 422682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 422687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422706 */     GIR_RootConstrainSelectedInstOperands,
     /* 422707 */     // GIR_Coverage, 11983,
     /* 422707 */     GIR_EraseRootFromParent_Done,
     /* 422708 */   // Label 6117: @422708
     /* 422708 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(422843), // Rule ID 11984 //
     /* 422713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 422716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 422760 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422760 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422765 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422783 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422790 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422797 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 422800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 422807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 422812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 422817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 422822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422841 */     GIR_RootConstrainSelectedInstOperands,
     /* 422842 */     // GIR_Coverage, 11984,
     /* 422842 */     GIR_EraseRootFromParent_Done,
     /* 422843 */   // Label 6118: @422843
     /* 422843 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(422978), // Rule ID 11985 //
     /* 422848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 422851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 422875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 422891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 422895 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422895 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 422900 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 422905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422932 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 422935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 422942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 422947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 422952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 422957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 422962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 422967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422976 */     GIR_RootConstrainSelectedInstOperands,
     /* 422977 */     // GIR_Coverage, 11985,
     /* 422977 */     GIR_EraseRootFromParent_Done,
     /* 422978 */   // Label 6119: @422978
     /* 422978 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(423113), // Rule ID 12462 //
     /* 422983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 422986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 422990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423030 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423030 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423035 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423035 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423040 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423053 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423060 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423067 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 423070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 423077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 423082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 423087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 423092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423111 */     GIR_RootConstrainSelectedInstOperands,
     /* 423112 */     // GIR_Coverage, 12462,
     /* 423112 */     GIR_EraseRootFromParent_Done,
     /* 423113 */   // Label 6120: @423113
     /* 423113 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(423248), // Rule ID 12463 //
     /* 423118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 423121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 423125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423165 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423165 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423170 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423170 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423175 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423179 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423195 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423202 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 423205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 423212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 423217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 423222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 423227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423246 */     GIR_RootConstrainSelectedInstOperands,
     /* 423247 */     // GIR_Coverage, 12463,
     /* 423247 */     GIR_EraseRootFromParent_Done,
     /* 423248 */   // Label 6121: @423248
     /* 423248 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(423383), // Rule ID 12464 //
     /* 423253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 423256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 423260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423300 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423300 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423305 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423305 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423310 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423316 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423323 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423330 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423337 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 423340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 423347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 423352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 423357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 423362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423381 */     GIR_RootConstrainSelectedInstOperands,
     /* 423382 */     // GIR_Coverage, 12464,
     /* 423382 */     GIR_EraseRootFromParent_Done,
     /* 423383 */   // Label 6122: @423383
     /* 423383 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(423518), // Rule ID 12465 //
     /* 423388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 423391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 423395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423435 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423435 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423440 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423440 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423445 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423449 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423465 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423472 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 423475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 423482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 423487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 423492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 423497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423516 */     GIR_RootConstrainSelectedInstOperands,
     /* 423517 */     // GIR_Coverage, 12465,
     /* 423517 */     GIR_EraseRootFromParent_Done,
     /* 423518 */   // Label 6123: @423518
     /* 423518 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(423653), // Rule ID 12942 //
     /* 423523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 423526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423570 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423575 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423600 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423607 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 423610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 423617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 423622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 423627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 423632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423651 */     GIR_RootConstrainSelectedInstOperands,
     /* 423652 */     // GIR_Coverage, 12942,
     /* 423652 */     GIR_EraseRootFromParent_Done,
     /* 423653 */   // Label 6124: @423653
     /* 423653 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(423788), // Rule ID 12943 //
     /* 423658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 423661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423705 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423710 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423728 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423735 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423742 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 423745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 423752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 423757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 423762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 423767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423786 */     GIR_RootConstrainSelectedInstOperands,
     /* 423787 */     // GIR_Coverage, 12943,
     /* 423787 */     GIR_EraseRootFromParent_Done,
     /* 423788 */   // Label 6125: @423788
     /* 423788 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(423923), // Rule ID 12944 //
     /* 423793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 423796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423840 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423845 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423863 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423870 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423877 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 423880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 423887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 423892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 423897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 423902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423921 */     GIR_RootConstrainSelectedInstOperands,
     /* 423922 */     // GIR_Coverage, 12944,
     /* 423922 */     GIR_EraseRootFromParent_Done,
     /* 423923 */   // Label 6126: @423923
     /* 423923 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(424058), // Rule ID 12945 //
     /* 423928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 423931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423975 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423975 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423980 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423980 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423985 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423989 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423991 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424005 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424012 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 424015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 424022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 424027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 424032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 424037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424056 */     GIR_RootConstrainSelectedInstOperands,
     /* 424057 */     // GIR_Coverage, 12945,
     /* 424057 */     GIR_EraseRootFromParent_Done,
     /* 424058 */   // Label 6127: @424058
     /* 424058 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(424193), // Rule ID 11922 //
     /* 424063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 424066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424110 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424110 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424115 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424120 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424124 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424133 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424140 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424147 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 424150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 424157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 424162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 424167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 424172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424191 */     GIR_RootConstrainSelectedInstOperands,
     /* 424192 */     // GIR_Coverage, 11922,
     /* 424192 */     GIR_EraseRootFromParent_Done,
     /* 424193 */   // Label 6128: @424193
     /* 424193 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(424328), // Rule ID 11923 //
     /* 424198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 424201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424245 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424250 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424255 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424282 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 424285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 424292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 424297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 424302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 424307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424326 */     GIR_RootConstrainSelectedInstOperands,
     /* 424327 */     // GIR_Coverage, 11923,
     /* 424327 */     GIR_EraseRootFromParent_Done,
     /* 424328 */   // Label 6129: @424328
     /* 424328 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(424463), // Rule ID 11924 //
     /* 424333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 424336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424380 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424385 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424390 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424403 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424410 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424417 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 424420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 424427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 424432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 424437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 424442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424461 */     GIR_RootConstrainSelectedInstOperands,
     /* 424462 */     // GIR_Coverage, 11924,
     /* 424462 */     GIR_EraseRootFromParent_Done,
     /* 424463 */   // Label 6130: @424463
     /* 424463 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(424598), // Rule ID 11925 //
     /* 424468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 424471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424515 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424520 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424520 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424525 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424552 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 424555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 424562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 424567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 424572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 424577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424596 */     GIR_RootConstrainSelectedInstOperands,
     /* 424597 */     // GIR_Coverage, 11925,
     /* 424597 */     GIR_EraseRootFromParent_Done,
     /* 424598 */   // Label 6131: @424598
     /* 424598 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(424733), // Rule ID 12402 //
     /* 424603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 424606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 424610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424650 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424655 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424655 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424660 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424664 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424680 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424687 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 424690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 424697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 424702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 424707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 424712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424731 */     GIR_RootConstrainSelectedInstOperands,
     /* 424732 */     // GIR_Coverage, 12402,
     /* 424732 */     GIR_EraseRootFromParent_Done,
     /* 424733 */   // Label 6132: @424733
     /* 424733 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(424868), // Rule ID 12403 //
     /* 424738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 424741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 424745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424785 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424785 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424790 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424790 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424795 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424799 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424808 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424815 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424822 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 424825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 424832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 424837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 424842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 424847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424866 */     GIR_RootConstrainSelectedInstOperands,
     /* 424867 */     // GIR_Coverage, 12403,
     /* 424867 */     GIR_EraseRootFromParent_Done,
     /* 424868 */   // Label 6133: @424868
     /* 424868 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(425003), // Rule ID 12404 //
     /* 424873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 424876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 424880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 424904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424920 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424920 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424925 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424936 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424943 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424957 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 424960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 424967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 424972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 424977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 424982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425001 */     GIR_RootConstrainSelectedInstOperands,
     /* 425002 */     // GIR_Coverage, 12404,
     /* 425002 */     GIR_EraseRootFromParent_Done,
     /* 425003 */   // Label 6134: @425003
     /* 425003 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(425138), // Rule ID 12405 //
     /* 425008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 425011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 425015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 425039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425055 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425060 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425078 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425092 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 425095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 425102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 425107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 425112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 425117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425136 */     GIR_RootConstrainSelectedInstOperands,
     /* 425137 */     // GIR_Coverage, 12405,
     /* 425137 */     GIR_EraseRootFromParent_Done,
     /* 425138 */   // Label 6135: @425138
     /* 425138 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(425273), // Rule ID 12882 //
     /* 425143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 425146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 425174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425190 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425195 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425195 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425200 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425220 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425227 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 425230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 425237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 425242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 425247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 425252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425271 */     GIR_RootConstrainSelectedInstOperands,
     /* 425272 */     // GIR_Coverage, 12882,
     /* 425272 */     GIR_EraseRootFromParent_Done,
     /* 425273 */   // Label 6136: @425273
     /* 425273 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(425408), // Rule ID 12883 //
     /* 425278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 425281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 425309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425325 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425330 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425330 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425335 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425355 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425362 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 425365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 425372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 425377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 425382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 425387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425406 */     GIR_RootConstrainSelectedInstOperands,
     /* 425407 */     // GIR_Coverage, 12883,
     /* 425407 */     GIR_EraseRootFromParent_Done,
     /* 425408 */   // Label 6137: @425408
     /* 425408 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(425543), // Rule ID 12884 //
     /* 425413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 425416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 425444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425460 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425460 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425465 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425465 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425470 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425476 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425483 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425490 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425497 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 425500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 425507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 425512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 425517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 425522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425541 */     GIR_RootConstrainSelectedInstOperands,
     /* 425542 */     // GIR_Coverage, 12884,
     /* 425542 */     GIR_EraseRootFromParent_Done,
     /* 425543 */   // Label 6138: @425543
     /* 425543 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(425678), // Rule ID 12885 //
     /* 425548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 425551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 425579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425583 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425595 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425600 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425605 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425609 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425625 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425632 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 425635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 425642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 425647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 425652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 425657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425676 */     GIR_RootConstrainSelectedInstOperands,
     /* 425677 */     // GIR_Coverage, 12885,
     /* 425677 */     GIR_EraseRootFromParent_Done,
     /* 425678 */   // Label 6139: @425678
     /* 425678 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(425813), // Rule ID 11993 //
     /* 425683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 425686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 425710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 425714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 425730 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425735 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425740 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425753 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425760 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425767 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 425770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 425777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 425782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 425787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 425792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 425797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 425802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425811 */     GIR_RootConstrainSelectedInstOperands,
     /* 425812 */     // GIR_Coverage, 11993,
     /* 425812 */     GIR_EraseRootFromParent_Done,
     /* 425813 */   // Label 6140: @425813
     /* 425813 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(425948), // Rule ID 11994 //
     /* 425818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 425821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 425845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 425849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 425865 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425870 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425875 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425879 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425895 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425902 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 425905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 425912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 425917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 425922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 425927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 425932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 425937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425946 */     GIR_RootConstrainSelectedInstOperands,
     /* 425947 */     // GIR_Coverage, 11994,
     /* 425947 */     GIR_EraseRootFromParent_Done,
     /* 425948 */   // Label 6141: @425948
     /* 425948 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(426083), // Rule ID 11995 //
     /* 425953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 425956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 425980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 425984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426000 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426005 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426005 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426030 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426037 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 426040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 426047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 426052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 426057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 426062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426081 */     GIR_RootConstrainSelectedInstOperands,
     /* 426082 */     // GIR_Coverage, 11995,
     /* 426082 */     GIR_EraseRootFromParent_Done,
     /* 426083 */   // Label 6142: @426083
     /* 426083 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(426218), // Rule ID 11996 //
     /* 426088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 426091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 426095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426135 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426140 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426165 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426172 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 426175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 426182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 426187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 426192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 426197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426216 */     GIR_RootConstrainSelectedInstOperands,
     /* 426217 */     // GIR_Coverage, 11996,
     /* 426217 */     GIR_EraseRootFromParent_Done,
     /* 426218 */   // Label 6143: @426218
     /* 426218 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(426353), // Rule ID 12473 //
     /* 426223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 426226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 426230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426270 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426270 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426275 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426275 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426280 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426293 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426300 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426307 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 426310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 426317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 426322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 426327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 426332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426351 */     GIR_RootConstrainSelectedInstOperands,
     /* 426352 */     // GIR_Coverage, 12473,
     /* 426352 */     GIR_EraseRootFromParent_Done,
     /* 426353 */   // Label 6144: @426353
     /* 426353 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(426488), // Rule ID 12474 //
     /* 426358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 426361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 426365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426405 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426405 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426410 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426428 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426435 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426442 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 426445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 426452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 426457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 426462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 426467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426486 */     GIR_RootConstrainSelectedInstOperands,
     /* 426487 */     // GIR_Coverage, 12474,
     /* 426487 */     GIR_EraseRootFromParent_Done,
     /* 426488 */   // Label 6145: @426488
     /* 426488 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(426623), // Rule ID 12475 //
     /* 426493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 426496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 426500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426540 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426545 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426545 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426550 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426563 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426577 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 426580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 426587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 426592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 426597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 426602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426621 */     GIR_RootConstrainSelectedInstOperands,
     /* 426622 */     // GIR_Coverage, 12475,
     /* 426622 */     GIR_EraseRootFromParent_Done,
     /* 426623 */   // Label 6146: @426623
     /* 426623 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(426758), // Rule ID 12476 //
     /* 426628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 426631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 426635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426675 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426680 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426685 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426705 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426712 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 426715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 426722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 426727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 426732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 426737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426756 */     GIR_RootConstrainSelectedInstOperands,
     /* 426757 */     // GIR_Coverage, 12476,
     /* 426757 */     GIR_EraseRootFromParent_Done,
     /* 426758 */   // Label 6147: @426758
     /* 426758 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(426893), // Rule ID 12953 //
     /* 426763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 426766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 426770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426810 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426810 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426815 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426815 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426820 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426833 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426840 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426847 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 426850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 426857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 426862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 426867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 426872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 426877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 426882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426891 */     GIR_RootConstrainSelectedInstOperands,
     /* 426892 */     // GIR_Coverage, 12953,
     /* 426892 */     GIR_EraseRootFromParent_Done,
     /* 426893 */   // Label 6148: @426893
     /* 426893 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(427028), // Rule ID 12954 //
     /* 426898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 426901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 426905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 426925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426945 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426945 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426950 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426950 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426959 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426975 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426982 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 426985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 426992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 426997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 427002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 427007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427026 */     GIR_RootConstrainSelectedInstOperands,
     /* 427027 */     // GIR_Coverage, 12954,
     /* 427027 */     GIR_EraseRootFromParent_Done,
     /* 427028 */   // Label 6149: @427028
     /* 427028 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(427163), // Rule ID 12955 //
     /* 427033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 427036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427080 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427080 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427085 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427085 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427117 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 427120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 427127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 427132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 427137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 427142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427161 */     GIR_RootConstrainSelectedInstOperands,
     /* 427162 */     // GIR_Coverage, 12955,
     /* 427162 */     GIR_EraseRootFromParent_Done,
     /* 427163 */   // Label 6150: @427163
     /* 427163 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(427298), // Rule ID 12956 //
     /* 427168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 427171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427215 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427215 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427220 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427252 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 427255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 427262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 427267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 427272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 427277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427296 */     GIR_RootConstrainSelectedInstOperands,
     /* 427297 */     // GIR_Coverage, 12956,
     /* 427297 */     GIR_EraseRootFromParent_Done,
     /* 427298 */   // Label 6151: @427298
     /* 427298 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(427433), // Rule ID 11933 //
     /* 427303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 427306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427350 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427355 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427387 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 427390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 427397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 427402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 427407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 427412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427431 */     GIR_RootConstrainSelectedInstOperands,
     /* 427432 */     // GIR_Coverage, 11933,
     /* 427432 */     GIR_EraseRootFromParent_Done,
     /* 427433 */   // Label 6152: @427433
     /* 427433 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(427568), // Rule ID 11934 //
     /* 427438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 427441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427481 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427485 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427485 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427490 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427490 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427508 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427515 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427522 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 427525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 427532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 427537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 427542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 427547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427566 */     GIR_RootConstrainSelectedInstOperands,
     /* 427567 */     // GIR_Coverage, 11934,
     /* 427567 */     GIR_EraseRootFromParent_Done,
     /* 427568 */   // Label 6153: @427568
     /* 427568 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(427703), // Rule ID 11935 //
     /* 427573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 427576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427620 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427620 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427625 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427625 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427630 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427650 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427657 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 427660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 427667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 427672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 427677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 427682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427701 */     GIR_RootConstrainSelectedInstOperands,
     /* 427702 */     // GIR_Coverage, 11935,
     /* 427702 */     GIR_EraseRootFromParent_Done,
     /* 427703 */   // Label 6154: @427703
     /* 427703 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(427838), // Rule ID 11936 //
     /* 427708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 427711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427747 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427751 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427755 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427755 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427760 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427760 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427778 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427785 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427792 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 427795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 427802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 427807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 427812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 427817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427836 */     GIR_RootConstrainSelectedInstOperands,
     /* 427837 */     // GIR_Coverage, 11936,
     /* 427837 */     GIR_EraseRootFromParent_Done,
     /* 427838 */   // Label 6155: @427838
     /* 427838 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(427973), // Rule ID 12413 //
     /* 427843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 427846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 427850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 427870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 427874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427890 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427890 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427895 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427895 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427900 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427913 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427927 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 427930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 427937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 427942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 427947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 427952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 427957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 427962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427971 */     GIR_RootConstrainSelectedInstOperands,
     /* 427972 */     // GIR_Coverage, 12413,
     /* 427972 */     GIR_EraseRootFromParent_Done,
     /* 427973 */   // Label 6156: @427973
     /* 427973 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(428108), // Rule ID 12414 //
     /* 427978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 427981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 427985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428025 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428025 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428030 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428030 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428039 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428055 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428062 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 428065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 428072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 428077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 428082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 428087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428106 */     GIR_RootConstrainSelectedInstOperands,
     /* 428107 */     // GIR_Coverage, 12414,
     /* 428107 */     GIR_EraseRootFromParent_Done,
     /* 428108 */   // Label 6157: @428108
     /* 428108 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(428243), // Rule ID 12415 //
     /* 428113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 428116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 428120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428160 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428160 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428165 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428165 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428170 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428190 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428197 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 428200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 428207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 428212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 428217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 428222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428241 */     GIR_RootConstrainSelectedInstOperands,
     /* 428242 */     // GIR_Coverage, 12415,
     /* 428242 */     GIR_EraseRootFromParent_Done,
     /* 428243 */   // Label 6158: @428243
     /* 428243 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(428378), // Rule ID 12416 //
     /* 428248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 428251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 428255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428295 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428295 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428300 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428300 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428305 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428325 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428332 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 428335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 428342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 428347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 428352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 428357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428376 */     GIR_RootConstrainSelectedInstOperands,
     /* 428377 */     // GIR_Coverage, 12416,
     /* 428377 */     GIR_EraseRootFromParent_Done,
     /* 428378 */   // Label 6159: @428378
     /* 428378 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(428513), // Rule ID 12893 //
     /* 428383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 428386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428430 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428430 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428435 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428435 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428444 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428453 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428460 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428467 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 428470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 428477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 428482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 428487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 428492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428511 */     GIR_RootConstrainSelectedInstOperands,
     /* 428512 */     // GIR_Coverage, 12893,
     /* 428512 */     GIR_EraseRootFromParent_Done,
     /* 428513 */   // Label 6160: @428513
     /* 428513 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(428648), // Rule ID 12894 //
     /* 428518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 428521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428565 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428565 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428570 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428575 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428595 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428602 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 428605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 428612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 428617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 428622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 428627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428646 */     GIR_RootConstrainSelectedInstOperands,
     /* 428647 */     // GIR_Coverage, 12894,
     /* 428647 */     GIR_EraseRootFromParent_Done,
     /* 428648 */   // Label 6161: @428648
     /* 428648 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(428783), // Rule ID 12895 //
     /* 428653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 428656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428700 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428705 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428710 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428723 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428730 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428737 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 428740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 428747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 428752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 428757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 428762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428781 */     GIR_RootConstrainSelectedInstOperands,
     /* 428782 */     // GIR_Coverage, 12895,
     /* 428782 */     GIR_EraseRootFromParent_Done,
     /* 428783 */   // Label 6162: @428783
     /* 428783 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(428918), // Rule ID 12896 //
     /* 428788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 428791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 428819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428835 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428835 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428840 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428845 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428849 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428865 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428872 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 428875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 428882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 428887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 428892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 428897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 428902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 428907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428916 */     GIR_RootConstrainSelectedInstOperands,
     /* 428917 */     // GIR_Coverage, 12896,
     /* 428917 */     GIR_EraseRootFromParent_Done,
     /* 428918 */   // Label 6163: @428918
     /* 428918 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(429053), // Rule ID 11978 //
     /* 428923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 428926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 428950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 428954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 428970 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428970 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428975 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428975 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428993 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429000 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429007 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 429010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 429017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 429022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 429027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 429032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429051 */     GIR_RootConstrainSelectedInstOperands,
     /* 429052 */     // GIR_Coverage, 11978,
     /* 429052 */     GIR_EraseRootFromParent_Done,
     /* 429053 */   // Label 6164: @429053
     /* 429053 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(429188), // Rule ID 11979 //
     /* 429058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 429061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 429065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 429105 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429105 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429110 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429110 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429115 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429119 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429128 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429135 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429142 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 429145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 429152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 429157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 429162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 429167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429186 */     GIR_RootConstrainSelectedInstOperands,
     /* 429187 */     // GIR_Coverage, 11979,
     /* 429187 */     GIR_EraseRootFromParent_Done,
     /* 429188 */   // Label 6165: @429188
     /* 429188 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(429323), // Rule ID 11980 //
     /* 429193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 429196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 429200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 429240 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429240 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429245 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429250 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429270 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429277 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 429280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 429287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 429292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 429297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 429302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429321 */     GIR_RootConstrainSelectedInstOperands,
     /* 429322 */     // GIR_Coverage, 11980,
     /* 429322 */     GIR_EraseRootFromParent_Done,
     /* 429323 */   // Label 6166: @429323
     /* 429323 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(429458), // Rule ID 11981 //
     /* 429328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 429331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 429335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 429375 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429380 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429385 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429389 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429398 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429405 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429412 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 429415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 429422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 429427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 429432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 429437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429456 */     GIR_RootConstrainSelectedInstOperands,
     /* 429457 */     // GIR_Coverage, 11981,
     /* 429457 */     GIR_EraseRootFromParent_Done,
     /* 429458 */   // Label 6167: @429458
     /* 429458 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(429593), // Rule ID 12458 //
     /* 429463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 429466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 429470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 429510 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429515 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429526 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429540 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429547 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 429550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 429557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 429562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 429567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 429572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429591 */     GIR_RootConstrainSelectedInstOperands,
     /* 429592 */     // GIR_Coverage, 12458,
     /* 429592 */     GIR_EraseRootFromParent_Done,
     /* 429593 */   // Label 6168: @429593
     /* 429593 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(429728), // Rule ID 12459 //
     /* 429598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 429601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 429605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 429645 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429650 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429655 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429675 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429682 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 429685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 429692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 429697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 429702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 429707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429726 */     GIR_RootConstrainSelectedInstOperands,
     /* 429727 */     // GIR_Coverage, 12459,
     /* 429727 */     GIR_EraseRootFromParent_Done,
     /* 429728 */   // Label 6169: @429728
     /* 429728 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(429863), // Rule ID 12460 //
     /* 429733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 429736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 429740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 429780 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429780 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429785 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429785 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429790 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429803 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429810 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429817 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 429820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 429827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 429832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 429837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 429842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429861 */     GIR_RootConstrainSelectedInstOperands,
     /* 429862 */     // GIR_Coverage, 12460,
     /* 429862 */     GIR_EraseRootFromParent_Done,
     /* 429863 */   // Label 6170: @429863
     /* 429863 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(429998), // Rule ID 12461 //
     /* 429868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 429871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 429875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 429915 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429915 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429920 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429920 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429925 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429938 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429945 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429952 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 429955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 429962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 429967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 429972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 429977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 429982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 429987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429996 */     GIR_RootConstrainSelectedInstOperands,
     /* 429997 */     // GIR_Coverage, 12461,
     /* 429997 */     GIR_EraseRootFromParent_Done,
     /* 429998 */   // Label 6171: @429998
     /* 429998 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(430133), // Rule ID 12938 //
     /* 430003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 430006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430050 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430050 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430055 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430060 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430073 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430080 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430087 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 430090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 430097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 430102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 430107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 430112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430131 */     GIR_RootConstrainSelectedInstOperands,
     /* 430132 */     // GIR_Coverage, 12938,
     /* 430132 */     GIR_EraseRootFromParent_Done,
     /* 430133 */   // Label 6172: @430133
     /* 430133 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(430268), // Rule ID 12939 //
     /* 430138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 430141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430185 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430190 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430215 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430222 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 430225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 430232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 430237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 430242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 430247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430266 */     GIR_RootConstrainSelectedInstOperands,
     /* 430267 */     // GIR_Coverage, 12939,
     /* 430267 */     GIR_EraseRootFromParent_Done,
     /* 430268 */   // Label 6173: @430268
     /* 430268 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(430403), // Rule ID 12940 //
     /* 430273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 430276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430320 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430325 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430330 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430334 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430343 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430350 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430357 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 430360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 430367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 430372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 430377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 430382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430401 */     GIR_RootConstrainSelectedInstOperands,
     /* 430402 */     // GIR_Coverage, 12940,
     /* 430402 */     GIR_EraseRootFromParent_Done,
     /* 430403 */   // Label 6174: @430403
     /* 430403 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(430538), // Rule ID 12941 //
     /* 430408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 430411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430455 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430460 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430460 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430485 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430492 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 430495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 430502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 430507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 430512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 430517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430536 */     GIR_RootConstrainSelectedInstOperands,
     /* 430537 */     // GIR_Coverage, 12941,
     /* 430537 */     GIR_EraseRootFromParent_Done,
     /* 430538 */   // Label 6175: @430538
     /* 430538 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(430673), // Rule ID 11918 //
     /* 430543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 430546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430590 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430590 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430595 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430604 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430613 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430620 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430627 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 430630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 430637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 430642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 430647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 430652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430671 */     GIR_RootConstrainSelectedInstOperands,
     /* 430672 */     // GIR_Coverage, 11918,
     /* 430672 */     GIR_EraseRootFromParent_Done,
     /* 430673 */   // Label 6176: @430673
     /* 430673 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(430808), // Rule ID 11919 //
     /* 430678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 430681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430725 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430725 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430730 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430748 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430755 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430762 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 430765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 430772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 430777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 430782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 430787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430806 */     GIR_RootConstrainSelectedInstOperands,
     /* 430807 */     // GIR_Coverage, 11919,
     /* 430807 */     GIR_EraseRootFromParent_Done,
     /* 430808 */   // Label 6177: @430808
     /* 430808 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(430943), // Rule ID 11920 //
     /* 430813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 430816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430860 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430865 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430870 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430897 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 430900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 430907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 430912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 430917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 430922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430941 */     GIR_RootConstrainSelectedInstOperands,
     /* 430942 */     // GIR_Coverage, 11920,
     /* 430942 */     GIR_EraseRootFromParent_Done,
     /* 430943 */   // Label 6178: @430943
     /* 430943 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(431078), // Rule ID 11921 //
     /* 430948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 430951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430995 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431000 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431005 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431025 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431032 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 431035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 431042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 431047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 431052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 431057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431076 */     GIR_RootConstrainSelectedInstOperands,
     /* 431077 */     // GIR_Coverage, 11921,
     /* 431077 */     GIR_EraseRootFromParent_Done,
     /* 431078 */   // Label 6179: @431078
     /* 431078 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(431213), // Rule ID 12398 //
     /* 431083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 431086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 431090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431130 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431135 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431144 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431153 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431160 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431167 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 431170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 431177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 431182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 431187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 431192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431211 */     GIR_RootConstrainSelectedInstOperands,
     /* 431212 */     // GIR_Coverage, 12398,
     /* 431212 */     GIR_EraseRootFromParent_Done,
     /* 431213 */   // Label 6180: @431213
     /* 431213 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(431348), // Rule ID 12399 //
     /* 431218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 431221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 431225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431265 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431265 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431270 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431270 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431275 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431288 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431295 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431302 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 431305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 431312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 431317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 431322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 431327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431346 */     GIR_RootConstrainSelectedInstOperands,
     /* 431347 */     // GIR_Coverage, 12399,
     /* 431347 */     GIR_EraseRootFromParent_Done,
     /* 431348 */   // Label 6181: @431348
     /* 431348 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(431483), // Rule ID 12400 //
     /* 431353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 431356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 431360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431400 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431400 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431405 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431405 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431410 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431414 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431423 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431437 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 431440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 431447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 431452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 431457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 431462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431481 */     GIR_RootConstrainSelectedInstOperands,
     /* 431482 */     // GIR_Coverage, 12400,
     /* 431482 */     GIR_EraseRootFromParent_Done,
     /* 431483 */   // Label 6182: @431483
     /* 431483 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(431618), // Rule ID 12401 //
     /* 431488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 431491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 431495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431535 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431540 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431549 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431558 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431565 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431572 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 431575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 431582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 431587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 431592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 431597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431616 */     GIR_RootConstrainSelectedInstOperands,
     /* 431617 */     // GIR_Coverage, 12401,
     /* 431617 */     GIR_EraseRootFromParent_Done,
     /* 431618 */   // Label 6183: @431618
     /* 431618 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(431753), // Rule ID 12878 //
     /* 431623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 431626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 431630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431670 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431675 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431680 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431707 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 431710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 431717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 431722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 431727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 431732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431751 */     GIR_RootConstrainSelectedInstOperands,
     /* 431752 */     // GIR_Coverage, 12878,
     /* 431752 */     GIR_EraseRootFromParent_Done,
     /* 431753 */   // Label 6184: @431753
     /* 431753 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(431888), // Rule ID 12879 //
     /* 431758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 431761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 431765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431805 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431810 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431810 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431815 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431828 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431835 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431842 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 431845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 431852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 431857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 431862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 431867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431886 */     GIR_RootConstrainSelectedInstOperands,
     /* 431887 */     // GIR_Coverage, 12879,
     /* 431887 */     GIR_EraseRootFromParent_Done,
     /* 431888 */   // Label 6185: @431888
     /* 431888 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(432023), // Rule ID 12880 //
     /* 431893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 431896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 431900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 431924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431940 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431945 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431945 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431963 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431970 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431977 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 431980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 431987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 431992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 431997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 432002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432021 */     GIR_RootConstrainSelectedInstOperands,
     /* 432022 */     // GIR_Coverage, 12880,
     /* 432022 */     GIR_EraseRootFromParent_Done,
     /* 432023 */   // Label 6186: @432023
     /* 432023 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(432158), // Rule ID 12881 //
     /* 432028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 432031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 432051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 432059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 432071 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432075 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 432075 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 432080 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 432080 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 432085 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 432089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432098 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432105 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432112 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 432115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 432132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 432137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432156 */     GIR_RootConstrainSelectedInstOperands,
     /* 432157 */     // GIR_Coverage, 12881,
     /* 432157 */     GIR_EraseRootFromParent_Done,
     /* 432158 */   // Label 6187: @432158
     /* 432158 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(432273), // Rule ID 13262 //
     /* 432163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 432166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 432170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 432178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 432190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432194 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432198 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 432200 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 432204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432220 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432227 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 432230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 432247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 432252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 432257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 432262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432271 */     GIR_RootConstrainSelectedInstOperands,
     /* 432272 */     // GIR_Coverage, 13262,
     /* 432272 */     GIR_EraseRootFromParent_Done,
     /* 432273 */   // Label 6188: @432273
     /* 432273 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(432388), // Rule ID 13278 //
     /* 432278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 432281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 432293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 432305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432313 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 432315 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 432319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432328 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432342 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 432345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 432362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 432367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 432372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 432377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432386 */     GIR_RootConstrainSelectedInstOperands,
     /* 432387 */     // GIR_Coverage, 13278,
     /* 432387 */     GIR_EraseRootFromParent_Done,
     /* 432388 */   // Label 6189: @432388
     /* 432388 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(432503), // Rule ID 13261 //
     /* 432393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 432396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 432400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 432408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432428 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 432430 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 432434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432443 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432457 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 432460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 432477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 432482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 432487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 432492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432501 */     GIR_RootConstrainSelectedInstOperands,
     /* 432502 */     // GIR_Coverage, 13261,
     /* 432502 */     GIR_EraseRootFromParent_Done,
     /* 432503 */   // Label 6190: @432503
     /* 432503 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(432618), // Rule ID 13277 //
     /* 432508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 432511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 432519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 432523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432543 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 432545 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 432549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432558 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432565 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432572 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 432575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 432592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 432597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 432602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 432607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432616 */     GIR_RootConstrainSelectedInstOperands,
     /* 432617 */     // GIR_Coverage, 13277,
     /* 432617 */     GIR_EraseRootFromParent_Done,
     /* 432618 */   // Label 6191: @432618
     /* 432618 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(432733), // Rule ID 7736 //
     /* 432623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 432626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 432630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 432638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 432650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432658 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 432660 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 432664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432680 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432687 */     // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 432690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 432697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 432702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 432707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 432712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432731 */     GIR_RootConstrainSelectedInstOperands,
     /* 432732 */     // GIR_Coverage, 7736,
     /* 432732 */     GIR_EraseRootFromParent_Done,
     /* 432733 */   // Label 6192: @432733
     /* 432733 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(432848), // Rule ID 7752 //
     /* 432738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 432741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 432753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 432765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432769 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432773 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 432775 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 432779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432802 */     // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 432805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 432812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 432817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 432822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 432827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432846 */     GIR_RootConstrainSelectedInstOperands,
     /* 432847 */     // GIR_Coverage, 7752,
     /* 432847 */     GIR_EraseRootFromParent_Done,
     /* 432848 */   // Label 6193: @432848
     /* 432848 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(432963), // Rule ID 7735 //
     /* 432853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 432856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 432860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 432868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432888 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 432890 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 432894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 432896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432903 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432910 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432917 */     // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 432920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 432927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 432932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 432937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 432942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432961 */     GIR_RootConstrainSelectedInstOperands,
     /* 432962 */     // GIR_Coverage, 7735,
     /* 432962 */     GIR_EraseRootFromParent_Done,
     /* 432963 */   // Label 6194: @432963
     /* 432963 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(433078), // Rule ID 7751 //
     /* 432968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 432971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 432983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 433003 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 433005 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 433009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 433011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433025 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433032 */     // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 433035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433076 */     GIR_RootConstrainSelectedInstOperands,
     /* 433077 */     // GIR_Coverage, 7751,
     /* 433077 */     GIR_EraseRootFromParent_Done,
     /* 433078 */   // Label 6195: @433078
     /* 433078 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(433177), // Rule ID 13254 //
     /* 433083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 433086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 433090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433106 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433131 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 433134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 433141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 433146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 433151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 433156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 433161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 433166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433175 */     GIR_RootConstrainSelectedInstOperands,
     /* 433176 */     // GIR_Coverage, 13254,
     /* 433176 */     GIR_EraseRootFromParent_Done,
     /* 433177 */   // Label 6196: @433177
     /* 433177 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(433276), // Rule ID 13270 //
     /* 433182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 433185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433205 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433230 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 433233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 433240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 433245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 433250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 433255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 433260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 433265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433274 */     GIR_RootConstrainSelectedInstOperands,
     /* 433275 */     // GIR_Coverage, 13270,
     /* 433275 */     GIR_EraseRootFromParent_Done,
     /* 433276 */   // Label 6197: @433276
     /* 433276 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(433375), // Rule ID 13253 //
     /* 433281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 433284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 433288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433304 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433329 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 433332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 433339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 433344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 433349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 433354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 433359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 433364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433373 */     GIR_RootConstrainSelectedInstOperands,
     /* 433374 */     // GIR_Coverage, 13253,
     /* 433374 */     GIR_EraseRootFromParent_Done,
     /* 433375 */   // Label 6198: @433375
     /* 433375 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(433474), // Rule ID 13269 //
     /* 433380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 433383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 433391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433403 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433428 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 433431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 433438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 433443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 433448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 433453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 433458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 433463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433472 */     GIR_RootConstrainSelectedInstOperands,
     /* 433473 */     // GIR_Coverage, 13269,
     /* 433473 */     GIR_EraseRootFromParent_Done,
     /* 433474 */   // Label 6199: @433474
     /* 433474 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(433573), // Rule ID 7728 //
     /* 433479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 433482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 433486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433502 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433527 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 433530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433571 */     GIR_RootConstrainSelectedInstOperands,
     /* 433572 */     // GIR_Coverage, 7728,
     /* 433572 */     GIR_EraseRootFromParent_Done,
     /* 433573 */   // Label 6200: @433573
     /* 433573 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(433672), // Rule ID 7744 //
     /* 433578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 433581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433601 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433626 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 433629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433670 */     GIR_RootConstrainSelectedInstOperands,
     /* 433671 */     // GIR_Coverage, 7744,
     /* 433671 */     GIR_EraseRootFromParent_Done,
     /* 433672 */   // Label 6201: @433672
     /* 433672 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(433771), // Rule ID 7727 //
     /* 433677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 433680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 433684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433700 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433725 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 433728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433769 */     GIR_RootConstrainSelectedInstOperands,
     /* 433770 */     // GIR_Coverage, 7727,
     /* 433770 */     GIR_EraseRootFromParent_Done,
     /* 433771 */   // Label 6202: @433771
     /* 433771 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(433870), // Rule ID 7743 //
     /* 433776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 433779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433799 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 433801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433824 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 433827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433868 */     GIR_RootConstrainSelectedInstOperands,
     /* 433869 */     // GIR_Coverage, 7743,
     /* 433869 */     GIR_EraseRootFromParent_Done,
     /* 433870 */   // Label 6203: @433870
     /* 433870 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(433905), // Rule ID 103 //
     /* 433875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 433878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 433882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 433886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 433890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13799),
     /* 433894 */     // (fmaxnum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13799>>  =>  (S_MAX_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 433894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F16),
     /* 433899 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 433903 */     GIR_RootConstrainSelectedInstOperands,
     /* 433904 */     // GIR_Coverage, 103,
     /* 433904 */     GIR_Done,
     /* 433905 */   // Label 6204: @433905
     /* 433905 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(433968), // Rule ID 880 //
     /* 433910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 433913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 433924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433931 */     // (fmaxnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 433931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 433934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 433941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 433951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 433961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 433966 */     GIR_RootConstrainSelectedInstOperands,
     /* 433967 */     // GIR_Coverage, 880,
     /* 433967 */     GIR_EraseRootFromParent_Done,
     /* 433968 */   // Label 6205: @433968
     /* 433968 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(434031), // Rule ID 884 //
     /* 433973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 433976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 433987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433994 */     // (fmaxnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 433994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 433997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 434004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 434014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 434024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 434029 */     GIR_RootConstrainSelectedInstOperands,
     /* 434030 */     // GIR_Coverage, 884,
     /* 434030 */     GIR_EraseRootFromParent_Done,
     /* 434031 */   // Label 6206: @434031
     /* 434031 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(434094), // Rule ID 8429 //
     /* 434036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 434039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 434057 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 434057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 434060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 434067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 434072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 434077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 434082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 434087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 434092 */     GIR_RootConstrainSelectedInstOperands,
     /* 434093 */     // GIR_Coverage, 8429,
     /* 434093 */     GIR_EraseRootFromParent_Done,
     /* 434094 */   // Label 6207: @434094
     /* 434094 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(434157), // Rule ID 8431 //
     /* 434099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 434102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 434120 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 434120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 434123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 434130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 434135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 434140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 434145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 434150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 434155 */     GIR_RootConstrainSelectedInstOperands,
     /* 434156 */     // GIR_Coverage, 8431,
     /* 434156 */     GIR_EraseRootFromParent_Done,
     /* 434157 */   // Label 6208: @434157
     /* 434157 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(434219), // Rule ID 882 //
     /* 434162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 434165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 434169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 434176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 434183 */     // (fmaxnum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 434183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 434186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 434193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 434203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434217 */     GIR_RootConstrainSelectedInstOperands,
     /* 434218 */     // GIR_Coverage, 882,
     /* 434218 */     GIR_EraseRootFromParent_Done,
     /* 434219 */   // Label 6209: @434219
     /* 434219 */   GIM_Reject,
     /* 434220 */ // Label 5803: @434220
     /* 434220 */ GIM_Reject,
     /* 434221 */ // Label 5799: @434221
     /* 434221 */ GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(451732),
     /* 434226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 434229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 434232 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(434361), // Rule ID 11507 //
     /* 434237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 434253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 434257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 434261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 434269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 434273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 434281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 434286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 434291 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434318 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 434321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 434328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 434338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434359 */     GIR_RootConstrainSelectedInstOperands,
     /* 434360 */     // GIR_Coverage, 11507,
     /* 434360 */     GIR_EraseRootFromParent_Done,
     /* 434361 */   // Label 6211: @434361
     /* 434361 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(434490), // Rule ID 11508 //
     /* 434366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 434382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 434386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 434390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 434398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 434402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 434410 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 434415 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 434420 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434424 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434440 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434447 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 434450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 434457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 434467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434488 */     GIR_RootConstrainSelectedInstOperands,
     /* 434489 */     // GIR_Coverage, 11508,
     /* 434489 */     GIR_EraseRootFromParent_Done,
     /* 434490 */   // Label 6212: @434490
     /* 434490 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(434619), // Rule ID 11511 //
     /* 434495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 434511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 434515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 434519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 434527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 434531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 434539 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 434544 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 434549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434569 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434576 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 434579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 434586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 434591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 434596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 434601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434617 */     GIR_RootConstrainSelectedInstOperands,
     /* 434618 */     // GIR_Coverage, 11511,
     /* 434618 */     GIR_EraseRootFromParent_Done,
     /* 434619 */   // Label 6213: @434619
     /* 434619 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(434748), // Rule ID 11512 //
     /* 434624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 434640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 434644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 434648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 434656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 434660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 434668 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 434673 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 434678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434705 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 434708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 434715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 434720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 434725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 434730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434746 */     GIR_RootConstrainSelectedInstOperands,
     /* 434747 */     // GIR_Coverage, 11512,
     /* 434747 */     GIR_EraseRootFromParent_Done,
     /* 434748 */   // Label 6214: @434748
     /* 434748 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(434877), // Rule ID 11492 //
     /* 434753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 434769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 434773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 434777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 434785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 434789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434793 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 434797 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 434802 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 434807 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434834 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 434837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 434844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 434854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434875 */     GIR_RootConstrainSelectedInstOperands,
     /* 434876 */     // GIR_Coverage, 11492,
     /* 434876 */     GIR_EraseRootFromParent_Done,
     /* 434877 */   // Label 6215: @434877
     /* 434877 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(435006), // Rule ID 11493 //
     /* 434882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 434898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 434902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 434906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 434914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 434918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 434926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 434931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 434936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434963 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 434966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 434973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 434983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435004 */     GIR_RootConstrainSelectedInstOperands,
     /* 435005 */     // GIR_Coverage, 11493,
     /* 435005 */     GIR_EraseRootFromParent_Done,
     /* 435006 */   // Label 6216: @435006
     /* 435006 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(435135), // Rule ID 11496 //
     /* 435011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435055 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435060 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435092 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 435102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 435107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 435112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 435117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435133 */     GIR_RootConstrainSelectedInstOperands,
     /* 435134 */     // GIR_Coverage, 11496,
     /* 435134 */     GIR_EraseRootFromParent_Done,
     /* 435135 */   // Label 6217: @435135
     /* 435135 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(435264), // Rule ID 11497 //
     /* 435140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435184 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435189 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435194 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435221 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 435231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 435236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 435241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 435246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435262 */     GIR_RootConstrainSelectedInstOperands,
     /* 435263 */     // GIR_Coverage, 11497,
     /* 435263 */     GIR_EraseRootFromParent_Done,
     /* 435264 */   // Label 6218: @435264
     /* 435264 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(435393), // Rule ID 7590 //
     /* 435269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 435309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 435313 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435318 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435323 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435343 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435350 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 435360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 435365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 435370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 435375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435391 */     GIR_RootConstrainSelectedInstOperands,
     /* 435392 */     // GIR_Coverage, 7590,
     /* 435392 */     GIR_EraseRootFromParent_Done,
     /* 435393 */   // Label 6219: @435393
     /* 435393 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(435522), // Rule ID 11506 //
     /* 435398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 435438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 435442 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435447 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435456 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435472 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435479 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 435489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 435494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 435499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 435504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435520 */     GIR_RootConstrainSelectedInstOperands,
     /* 435521 */     // GIR_Coverage, 11506,
     /* 435521 */     GIR_EraseRootFromParent_Done,
     /* 435522 */   // Label 6220: @435522
     /* 435522 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(435651), // Rule ID 11509 //
     /* 435527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 435567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 435571 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435601 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435608 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 435618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 435623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 435628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 435633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435649 */     GIR_RootConstrainSelectedInstOperands,
     /* 435650 */     // GIR_Coverage, 11509,
     /* 435650 */     GIR_EraseRootFromParent_Done,
     /* 435651 */   // Label 6221: @435651
     /* 435651 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(435780), // Rule ID 11510 //
     /* 435656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 435696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 435700 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435705 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435710 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435730 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435737 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 435747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 435752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 435757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 435762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435778 */     GIR_RootConstrainSelectedInstOperands,
     /* 435779 */     // GIR_Coverage, 11510,
     /* 435779 */     GIR_EraseRootFromParent_Done,
     /* 435780 */   // Label 6222: @435780
     /* 435780 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(435909), // Rule ID 7589 //
     /* 435785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 435825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435829 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435834 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435859 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435866 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 435876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 435881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 435886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 435891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435907 */     GIR_RootConstrainSelectedInstOperands,
     /* 435908 */     // GIR_Coverage, 7589,
     /* 435908 */     GIR_EraseRootFromParent_Done,
     /* 435909 */   // Label 6223: @435909
     /* 435909 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(436038), // Rule ID 11491 //
     /* 435914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 435930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 435934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 435938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 435942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 435946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 435950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 435954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435958 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 435963 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 435968 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435988 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435995 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 435998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 436005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 436010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 436015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 436020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436036 */     GIR_RootConstrainSelectedInstOperands,
     /* 436037 */     // GIR_Coverage, 11491,
     /* 436037 */     GIR_EraseRootFromParent_Done,
     /* 436038 */   // Label 6224: @436038
     /* 436038 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(436167), // Rule ID 11494 //
     /* 436043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 436083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 436087 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436092 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436097 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436117 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436124 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 436144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 436149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436165 */     GIR_RootConstrainSelectedInstOperands,
     /* 436166 */     // GIR_Coverage, 11494,
     /* 436166 */     GIR_EraseRootFromParent_Done,
     /* 436167 */   // Label 6225: @436167
     /* 436167 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(436296), // Rule ID 11495 //
     /* 436172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 436212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 436216 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436246 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436253 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 436273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 436278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436294 */     GIR_RootConstrainSelectedInstOperands,
     /* 436295 */     // GIR_Coverage, 11495,
     /* 436295 */     GIR_EraseRootFromParent_Done,
     /* 436296 */   // Label 6226: @436296
     /* 436296 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(436425), // Rule ID 11477 //
     /* 436301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 436345 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436350 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436382 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 436392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 436397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 436402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 436407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436423 */     GIR_RootConstrainSelectedInstOperands,
     /* 436424 */     // GIR_Coverage, 11477,
     /* 436424 */     GIR_EraseRootFromParent_Done,
     /* 436425 */   // Label 6227: @436425
     /* 436425 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(436554), // Rule ID 11478 //
     /* 436430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 436474 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436479 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436504 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436511 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 436521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 436526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 436531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 436536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436552 */     GIR_RootConstrainSelectedInstOperands,
     /* 436553 */     // GIR_Coverage, 11478,
     /* 436553 */     GIR_EraseRootFromParent_Done,
     /* 436554 */   // Label 6228: @436554
     /* 436554 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(436683), // Rule ID 11481 //
     /* 436559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 436603 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436608 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436613 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436640 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 436660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 436665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436681 */     GIR_RootConstrainSelectedInstOperands,
     /* 436682 */     // GIR_Coverage, 11481,
     /* 436682 */     GIR_EraseRootFromParent_Done,
     /* 436683 */   // Label 6229: @436683
     /* 436683 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(436812), // Rule ID 11482 //
     /* 436688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 436732 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436737 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436742 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436762 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436769 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 436789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 436794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436810 */     GIR_RootConstrainSelectedInstOperands,
     /* 436811 */     // GIR_Coverage, 11482,
     /* 436811 */     GIR_EraseRootFromParent_Done,
     /* 436812 */   // Label 6230: @436812
     /* 436812 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(436941), // Rule ID 11462 //
     /* 436817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 436861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 436866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436898 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 436901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 436908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 436913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 436918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 436923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436939 */     GIR_RootConstrainSelectedInstOperands,
     /* 436940 */     // GIR_Coverage, 11462,
     /* 436940 */     GIR_EraseRootFromParent_Done,
     /* 436941 */   // Label 6231: @436941
     /* 436941 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(437070), // Rule ID 11463 //
     /* 436946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 436962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 436966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 436970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 436978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 436982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 436986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 436990 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 436995 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437027 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 437037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 437042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 437047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 437052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437068 */     GIR_RootConstrainSelectedInstOperands,
     /* 437069 */     // GIR_Coverage, 11463,
     /* 437069 */     GIR_EraseRootFromParent_Done,
     /* 437070 */   // Label 6232: @437070
     /* 437070 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(437199), // Rule ID 11466 //
     /* 437075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 437115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 437119 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437124 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437156 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 437166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 437171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 437176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 437181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437197 */     GIR_RootConstrainSelectedInstOperands,
     /* 437198 */     // GIR_Coverage, 11466,
     /* 437198 */     GIR_EraseRootFromParent_Done,
     /* 437199 */   // Label 6233: @437199
     /* 437199 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(437328), // Rule ID 11467 //
     /* 437204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 437244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 437248 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437253 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437278 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437285 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 437295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 437300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 437305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 437310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437326 */     GIR_RootConstrainSelectedInstOperands,
     /* 437327 */     // GIR_Coverage, 11467,
     /* 437327 */     GIR_EraseRootFromParent_Done,
     /* 437328 */   // Label 6234: @437328
     /* 437328 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(437457), // Rule ID 7588 //
     /* 437333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 437373 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 437377 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437382 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437387 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437414 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 437424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 437429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 437434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 437439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437455 */     GIR_RootConstrainSelectedInstOperands,
     /* 437456 */     // GIR_Coverage, 7588,
     /* 437456 */     GIR_EraseRootFromParent_Done,
     /* 437457 */   // Label 6235: @437457
     /* 437457 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(437586), // Rule ID 11476 //
     /* 437462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 437502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 437506 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437511 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437543 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 437553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 437558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 437563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 437568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437584 */     GIR_RootConstrainSelectedInstOperands,
     /* 437585 */     // GIR_Coverage, 11476,
     /* 437585 */     GIR_EraseRootFromParent_Done,
     /* 437586 */   // Label 6236: @437586
     /* 437586 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(437715), // Rule ID 11479 //
     /* 437591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 437631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 437635 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437640 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437649 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437672 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 437682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 437687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 437692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 437697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437713 */     GIR_RootConstrainSelectedInstOperands,
     /* 437714 */     // GIR_Coverage, 11479,
     /* 437714 */     GIR_EraseRootFromParent_Done,
     /* 437715 */   // Label 6237: @437715
     /* 437715 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(437844), // Rule ID 11480 //
     /* 437720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 437760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 437764 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437769 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437801 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 437811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 437816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 437821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 437826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437842 */     GIR_RootConstrainSelectedInstOperands,
     /* 437843 */     // GIR_Coverage, 11480,
     /* 437843 */     GIR_EraseRootFromParent_Done,
     /* 437844 */   // Label 6238: @437844
     /* 437844 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(437973), // Rule ID 7587 //
     /* 437849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 437873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 437881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 437885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 437889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 437893 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 437893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 437898 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 437898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 437903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 437907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 437909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437923 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437930 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 437933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 437940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 437945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 437950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 437955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437971 */     GIR_RootConstrainSelectedInstOperands,
     /* 437972 */     // GIR_Coverage, 7587,
     /* 437972 */     GIR_EraseRootFromParent_Done,
     /* 437973 */   // Label 6239: @437973
     /* 437973 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(438102), // Rule ID 11461 //
     /* 437978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 437994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 437998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 438002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 438006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 438018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 438022 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 438027 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 438032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438059 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 438069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 438074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 438079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 438084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 438089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438100 */     GIR_RootConstrainSelectedInstOperands,
     /* 438101 */     // GIR_Coverage, 11461,
     /* 438101 */     GIR_EraseRootFromParent_Done,
     /* 438102 */   // Label 6240: @438102
     /* 438102 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(438231), // Rule ID 11464 //
     /* 438107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 438131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 438135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 438147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 438151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 438156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 438161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438188 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 438198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 438203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 438208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 438213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 438218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438229 */     GIR_RootConstrainSelectedInstOperands,
     /* 438230 */     // GIR_Coverage, 11464,
     /* 438230 */     GIR_EraseRootFromParent_Done,
     /* 438231 */   // Label 6241: @438231
     /* 438231 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(438360), // Rule ID 11465 //
     /* 438236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 438260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 438264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 438276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 438280 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 438285 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 438290 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438294 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438317 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 438327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 438332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 438337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 438342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 438347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438358 */     GIR_RootConstrainSelectedInstOperands,
     /* 438359 */     // GIR_Coverage, 11465,
     /* 438359 */     GIR_EraseRootFromParent_Done,
     /* 438360 */   // Label 6242: @438360
     /* 438360 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(438489), // Rule ID 11517 //
     /* 438365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 438389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 438393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 438405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438409 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 438414 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 438419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438446 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 438456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 438461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 438466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 438471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 438476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 438481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438487 */     GIR_RootConstrainSelectedInstOperands,
     /* 438488 */     // GIR_Coverage, 11517,
     /* 438488 */     GIR_EraseRootFromParent_Done,
     /* 438489 */   // Label 6243: @438489
     /* 438489 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(438618), // Rule ID 11518 //
     /* 438494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 438518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 438522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 438534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438538 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 438543 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 438548 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438575 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 438585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 438590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 438595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 438600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 438605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 438610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438616 */     GIR_RootConstrainSelectedInstOperands,
     /* 438617 */     // GIR_Coverage, 11518,
     /* 438617 */     GIR_EraseRootFromParent_Done,
     /* 438618 */   // Label 6244: @438618
     /* 438618 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(438747), // Rule ID 11519 //
     /* 438623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 438647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 438651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 438663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438667 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 438672 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 438677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438704 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 438714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 438719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 438724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 438729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 438734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 438739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438745 */     GIR_RootConstrainSelectedInstOperands,
     /* 438746 */     // GIR_Coverage, 11519,
     /* 438746 */     GIR_EraseRootFromParent_Done,
     /* 438747 */   // Label 6245: @438747
     /* 438747 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(438876), // Rule ID 11520 //
     /* 438752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 438776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 438780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 438792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 438801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 438806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438833 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 438843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 438848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 438853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 438858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 438863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 438868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438874 */     GIR_RootConstrainSelectedInstOperands,
     /* 438875 */     // GIR_Coverage, 11520,
     /* 438875 */     GIR_EraseRootFromParent_Done,
     /* 438876 */   // Label 6246: @438876
     /* 438876 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(439005), // Rule ID 11457 //
     /* 438881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 438905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 438909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 438921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 438925 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 438930 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 438935 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438962 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 438972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 438977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 438982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 438987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 438992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 438997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439003 */     GIR_RootConstrainSelectedInstOperands,
     /* 439004 */     // GIR_Coverage, 11457,
     /* 439004 */     GIR_EraseRootFromParent_Done,
     /* 439005 */   // Label 6247: @439005
     /* 439005 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(439134), // Rule ID 11458 //
     /* 439010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 439038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 439054 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439059 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439064 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439091 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 439101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 439106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 439111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 439116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439132 */     GIR_RootConstrainSelectedInstOperands,
     /* 439133 */     // GIR_Coverage, 11458,
     /* 439133 */     GIR_EraseRootFromParent_Done,
     /* 439134 */   // Label 6248: @439134
     /* 439134 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(439263), // Rule ID 11459 //
     /* 439139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 439167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 439183 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439188 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439220 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 439230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 439235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 439240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 439245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439261 */     GIR_RootConstrainSelectedInstOperands,
     /* 439262 */     // GIR_Coverage, 11459,
     /* 439262 */     GIR_EraseRootFromParent_Done,
     /* 439263 */   // Label 6249: @439263
     /* 439263 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(439392), // Rule ID 11460 //
     /* 439268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 439296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 439312 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439312 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439317 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439349 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 439359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 439364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 439369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 439374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439390 */     GIR_RootConstrainSelectedInstOperands,
     /* 439391 */     // GIR_Coverage, 11460,
     /* 439391 */     GIR_EraseRootFromParent_Done,
     /* 439392 */   // Label 6250: @439392
     /* 439392 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(439521), // Rule ID 11502 //
     /* 439397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 439425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439441 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439446 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439451 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439478 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 439488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 439493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 439498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 439503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439519 */     GIR_RootConstrainSelectedInstOperands,
     /* 439520 */     // GIR_Coverage, 11502,
     /* 439520 */     GIR_EraseRootFromParent_Done,
     /* 439521 */   // Label 6251: @439521
     /* 439521 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(439650), // Rule ID 11503 //
     /* 439526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 439554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439570 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439575 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439600 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439607 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 439617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 439622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 439627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 439632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439648 */     GIR_RootConstrainSelectedInstOperands,
     /* 439649 */     // GIR_Coverage, 11503,
     /* 439649 */     GIR_EraseRootFromParent_Done,
     /* 439650 */   // Label 6252: @439650
     /* 439650 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(439779), // Rule ID 11504 //
     /* 439655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 439683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439699 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439704 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439736 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 439746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 439751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 439756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 439761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439777 */     GIR_RootConstrainSelectedInstOperands,
     /* 439778 */     // GIR_Coverage, 11504,
     /* 439778 */     GIR_EraseRootFromParent_Done,
     /* 439779 */   // Label 6253: @439779
     /* 439779 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(439908), // Rule ID 11505 //
     /* 439784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 439812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439828 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439833 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439838 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439865 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 439875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 439880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 439885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 439890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 439895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 439900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439906 */     GIR_RootConstrainSelectedInstOperands,
     /* 439907 */     // GIR_Coverage, 11505,
     /* 439907 */     GIR_EraseRootFromParent_Done,
     /* 439908 */   // Label 6254: @439908
     /* 439908 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(440037), // Rule ID 11442 //
     /* 439913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 439937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 439941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 439953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 439957 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 439962 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 439967 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439980 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439994 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 440004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 440009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 440014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 440019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 440024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 440029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440035 */     GIR_RootConstrainSelectedInstOperands,
     /* 440036 */     // GIR_Coverage, 11442,
     /* 440036 */     GIR_EraseRootFromParent_Done,
     /* 440037 */   // Label 6255: @440037
     /* 440037 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(440166), // Rule ID 11443 //
     /* 440042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 440066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 440070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 440086 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440091 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440096 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440123 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 440133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 440138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 440143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 440148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 440153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 440158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440164 */     GIR_RootConstrainSelectedInstOperands,
     /* 440165 */     // GIR_Coverage, 11443,
     /* 440165 */     GIR_EraseRootFromParent_Done,
     /* 440166 */   // Label 6256: @440166
     /* 440166 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(440295), // Rule ID 11444 //
     /* 440171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 440195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 440199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 440215 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440215 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440220 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440252 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 440262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 440267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 440282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 440287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440293 */     GIR_RootConstrainSelectedInstOperands,
     /* 440294 */     // GIR_Coverage, 11444,
     /* 440294 */     GIR_EraseRootFromParent_Done,
     /* 440295 */   // Label 6257: @440295
     /* 440295 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(440424), // Rule ID 11445 //
     /* 440300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 440324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 440328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 440344 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440349 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440354 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440367 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440374 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440381 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 440391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 440396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 440411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 440416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440422 */     GIR_RootConstrainSelectedInstOperands,
     /* 440423 */     // GIR_Coverage, 11445,
     /* 440423 */     GIR_EraseRootFromParent_Done,
     /* 440424 */   // Label 6258: @440424
     /* 440424 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(440553), // Rule ID 11513 //
     /* 440429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 440453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 440457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440473 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440478 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440483 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440510 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 440520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 440525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440551 */     GIR_RootConstrainSelectedInstOperands,
     /* 440552 */     // GIR_Coverage, 11513,
     /* 440552 */     GIR_EraseRootFromParent_Done,
     /* 440553 */   // Label 6259: @440553
     /* 440553 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(440682), // Rule ID 11514 //
     /* 440558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 440582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 440586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440602 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440607 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440607 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440616 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440625 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440632 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440639 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 440649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 440654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440680 */     GIR_RootConstrainSelectedInstOperands,
     /* 440681 */     // GIR_Coverage, 11514,
     /* 440681 */     GIR_EraseRootFromParent_Done,
     /* 440682 */   // Label 6260: @440682
     /* 440682 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(440811), // Rule ID 11515 //
     /* 440687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 440711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 440715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440731 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440736 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440768 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 440778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 440783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 440788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 440793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440809 */     GIR_RootConstrainSelectedInstOperands,
     /* 440810 */     // GIR_Coverage, 11515,
     /* 440810 */     GIR_EraseRootFromParent_Done,
     /* 440811 */   // Label 6261: @440811
     /* 440811 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(440940), // Rule ID 11516 //
     /* 440816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 440840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 440844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440860 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440865 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440870 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440897 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 440907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 440912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 440917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 440922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440938 */     GIR_RootConstrainSelectedInstOperands,
     /* 440939 */     // GIR_Coverage, 11516,
     /* 440939 */     GIR_EraseRootFromParent_Done,
     /* 440940 */   // Label 6262: @440940
     /* 440940 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(441069), // Rule ID 11453 //
     /* 440945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 440969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 440973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 440985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 440989 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 440994 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 440999 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441003 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441026 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 441036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 441041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 441046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 441051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441067 */     GIR_RootConstrainSelectedInstOperands,
     /* 441068 */     // GIR_Coverage, 11453,
     /* 441068 */     GIR_EraseRootFromParent_Done,
     /* 441069 */   // Label 6263: @441069
     /* 441069 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(441198), // Rule ID 11454 //
     /* 441074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 441102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441118 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441118 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441123 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441123 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441141 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441148 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441155 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 441165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 441170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 441175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 441180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441196 */     GIR_RootConstrainSelectedInstOperands,
     /* 441197 */     // GIR_Coverage, 11454,
     /* 441197 */     GIR_EraseRootFromParent_Done,
     /* 441198 */   // Label 6264: @441198
     /* 441198 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(441327), // Rule ID 11455 //
     /* 441203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 441231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441235 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441247 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441247 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441252 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441252 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441270 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441277 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441284 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 441294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 441299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 441304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 441309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441325 */     GIR_RootConstrainSelectedInstOperands,
     /* 441326 */     // GIR_Coverage, 11455,
     /* 441326 */     GIR_EraseRootFromParent_Done,
     /* 441327 */   // Label 6265: @441327
     /* 441327 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(441456), // Rule ID 11456 //
     /* 441332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 441360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441376 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441381 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441386 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441399 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441413 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 441423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 441428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 441433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 441438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441454 */     GIR_RootConstrainSelectedInstOperands,
     /* 441455 */     // GIR_Coverage, 11456,
     /* 441455 */     GIR_EraseRootFromParent_Done,
     /* 441456 */   // Label 6266: @441456
     /* 441456 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(441585), // Rule ID 11498 //
     /* 441461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 441489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441505 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441510 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441515 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441528 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441535 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441542 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 441552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 441557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 441562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 441567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441583 */     GIR_RootConstrainSelectedInstOperands,
     /* 441584 */     // GIR_Coverage, 11498,
     /* 441584 */     GIR_EraseRootFromParent_Done,
     /* 441585 */   // Label 6267: @441585
     /* 441585 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(441714), // Rule ID 11499 //
     /* 441590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 441618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441634 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441639 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441644 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441648 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441657 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441671 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 441681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 441686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 441691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 441696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441712 */     GIR_RootConstrainSelectedInstOperands,
     /* 441713 */     // GIR_Coverage, 11499,
     /* 441713 */     GIR_EraseRootFromParent_Done,
     /* 441714 */   // Label 6268: @441714
     /* 441714 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(441843), // Rule ID 11500 //
     /* 441719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 441747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441763 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441768 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441768 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441773 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441793 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441800 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 441810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 441815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 441820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 441825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441841 */     GIR_RootConstrainSelectedInstOperands,
     /* 441842 */     // GIR_Coverage, 11500,
     /* 441842 */     GIR_EraseRootFromParent_Done,
     /* 441843 */   // Label 6269: @441843
     /* 441843 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(441972), // Rule ID 11501 //
     /* 441848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 441872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 441876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 441888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441892 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 441897 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441897 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 441902 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441915 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441929 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 441939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 441944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 441949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 441954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441970 */     GIR_RootConstrainSelectedInstOperands,
     /* 441971 */     // GIR_Coverage, 11501,
     /* 441971 */     GIR_EraseRootFromParent_Done,
     /* 441972 */   // Label 6270: @441972
     /* 441972 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(442101), // Rule ID 11438 //
     /* 441977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 442001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 442017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442021 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 442026 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 442031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442035 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442051 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442058 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 442068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 442073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 442078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 442083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442099 */     GIR_RootConstrainSelectedInstOperands,
     /* 442100 */     // GIR_Coverage, 11438,
     /* 442100 */     GIR_EraseRootFromParent_Done,
     /* 442101 */   // Label 6271: @442101
     /* 442101 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(442230), // Rule ID 11439 //
     /* 442106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 442130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 442146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442150 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 442155 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442155 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 442160 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442173 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442187 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 442197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 442202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 442207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 442212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442228 */     GIR_RootConstrainSelectedInstOperands,
     /* 442229 */     // GIR_Coverage, 11439,
     /* 442229 */     GIR_EraseRootFromParent_Done,
     /* 442230 */   // Label 6272: @442230
     /* 442230 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(442359), // Rule ID 11440 //
     /* 442235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 442259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 442275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442279 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 442284 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 442289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442302 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442316 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 442326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 442331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 442336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 442341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442357 */     GIR_RootConstrainSelectedInstOperands,
     /* 442358 */     // GIR_Coverage, 11440,
     /* 442358 */     GIR_EraseRootFromParent_Done,
     /* 442359 */   // Label 6273: @442359
     /* 442359 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(442488), // Rule ID 11441 //
     /* 442364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 442388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 442404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442408 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 442413 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 442418 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442445 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 442455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 442460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 442465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 442470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442486 */     GIR_RootConstrainSelectedInstOperands,
     /* 442487 */     // GIR_Coverage, 11441,
     /* 442487 */     GIR_EraseRootFromParent_Done,
     /* 442488 */   // Label 6274: @442488
     /* 442488 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(442617), // Rule ID 11447 //
     /* 442493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 442517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 442533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 442537 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 442542 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 442547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442567 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442574 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 442584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 442589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 442594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 442599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442615 */     GIR_RootConstrainSelectedInstOperands,
     /* 442616 */     // GIR_Coverage, 11447,
     /* 442616 */     GIR_EraseRootFromParent_Done,
     /* 442617 */   // Label 6275: @442617
     /* 442617 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(442746), // Rule ID 11448 //
     /* 442622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 442646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 442662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 442666 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 442671 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 442676 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442703 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 442713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 442718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 442723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 442728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442744 */     GIR_RootConstrainSelectedInstOperands,
     /* 442745 */     // GIR_Coverage, 11448,
     /* 442745 */     GIR_EraseRootFromParent_Done,
     /* 442746 */   // Label 6276: @442746
     /* 442746 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(442875), // Rule ID 11451 //
     /* 442751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 442775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 442791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 442795 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 442800 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 442805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442832 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 442842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 442847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 442852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 442857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442873 */     GIR_RootConstrainSelectedInstOperands,
     /* 442874 */     // GIR_Coverage, 11451,
     /* 442874 */     GIR_EraseRootFromParent_Done,
     /* 442875 */   // Label 6277: @442875
     /* 442875 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(443004), // Rule ID 11452 //
     /* 442880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 442904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 442920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 442924 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 442929 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 442934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442961 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 442971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 442976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 442981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 442986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443002 */     GIR_RootConstrainSelectedInstOperands,
     /* 443003 */     // GIR_Coverage, 11452,
     /* 443003 */     GIR_EraseRootFromParent_Done,
     /* 443004 */   // Label 6278: @443004
     /* 443004 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(443133), // Rule ID 11432 //
     /* 443009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 443049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 443053 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443058 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443063 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443083 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443090 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 443100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 443105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 443110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 443115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443131 */     GIR_RootConstrainSelectedInstOperands,
     /* 443132 */     // GIR_Coverage, 11432,
     /* 443132 */     GIR_EraseRootFromParent_Done,
     /* 443133 */   // Label 6279: @443133
     /* 443133 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(443262), // Rule ID 11433 //
     /* 443138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 443178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 443182 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443187 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443219 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 443229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 443234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 443239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 443244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443260 */     GIR_RootConstrainSelectedInstOperands,
     /* 443261 */     // GIR_Coverage, 11433,
     /* 443261 */     GIR_EraseRootFromParent_Done,
     /* 443262 */   // Label 6280: @443262
     /* 443262 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(443391), // Rule ID 11436 //
     /* 443267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 443307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 443311 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443316 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443348 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 443358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 443363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 443368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 443373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443389 */     GIR_RootConstrainSelectedInstOperands,
     /* 443390 */     // GIR_Coverage, 11436,
     /* 443390 */     GIR_EraseRootFromParent_Done,
     /* 443391 */   // Label 6281: @443391
     /* 443391 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(443520), // Rule ID 11437 //
     /* 443396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 443436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 443440 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443440 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443445 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443450 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443477 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 443487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 443492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 443497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 443502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443518 */     GIR_RootConstrainSelectedInstOperands,
     /* 443519 */     // GIR_Coverage, 11437,
     /* 443519 */     GIR_EraseRootFromParent_Done,
     /* 443520 */   // Label 6282: @443520
     /* 443520 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(443649), // Rule ID 7586 //
     /* 443525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 443565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443569 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443574 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443606 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 443616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 443621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 443626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 443631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443647 */     GIR_RootConstrainSelectedInstOperands,
     /* 443648 */     // GIR_Coverage, 7586,
     /* 443648 */     GIR_EraseRootFromParent_Done,
     /* 443649 */   // Label 6283: @443649
     /* 443649 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(443778), // Rule ID 11446 //
     /* 443654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 443694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443698 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443703 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443728 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443735 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 443745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 443750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 443755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 443760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443776 */     GIR_RootConstrainSelectedInstOperands,
     /* 443777 */     // GIR_Coverage, 11446,
     /* 443777 */     GIR_EraseRootFromParent_Done,
     /* 443778 */   // Label 6284: @443778
     /* 443778 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(443907), // Rule ID 11449 //
     /* 443783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 443823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443827 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443832 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443864 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 443874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 443879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 443884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 443889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 443894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 443899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443905 */     GIR_RootConstrainSelectedInstOperands,
     /* 443906 */     // GIR_Coverage, 11449,
     /* 443906 */     GIR_EraseRootFromParent_Done,
     /* 443907 */   // Label 6285: @443907
     /* 443907 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(444036), // Rule ID 11450 //
     /* 443912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 443936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 443952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443956 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 443961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 443966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443993 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 444003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 444008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 444013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 444018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444034 */     GIR_RootConstrainSelectedInstOperands,
     /* 444035 */     // GIR_Coverage, 11450,
     /* 444035 */     GIR_EraseRootFromParent_Done,
     /* 444036 */   // Label 6286: @444036
     /* 444036 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(444165), // Rule ID 7585 //
     /* 444041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 444081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444085 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444085 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444090 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444115 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444122 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 444132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 444137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 444142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 444147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444163 */     GIR_RootConstrainSelectedInstOperands,
     /* 444164 */     // GIR_Coverage, 7585,
     /* 444164 */     GIR_EraseRootFromParent_Done,
     /* 444165 */   // Label 6287: @444165
     /* 444165 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(444294), // Rule ID 11431 //
     /* 444170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 444210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444214 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444214 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444219 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444251 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 444261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 444266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 444271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 444276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444292 */     GIR_RootConstrainSelectedInstOperands,
     /* 444293 */     // GIR_Coverage, 11431,
     /* 444293 */     GIR_EraseRootFromParent_Done,
     /* 444294 */   // Label 6288: @444294
     /* 444294 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(444423), // Rule ID 11434 //
     /* 444299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 444339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444343 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444348 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444353 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444380 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 444390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 444395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 444400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 444405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444421 */     GIR_RootConstrainSelectedInstOperands,
     /* 444422 */     // GIR_Coverage, 11434,
     /* 444422 */     GIR_EraseRootFromParent_Done,
     /* 444423 */   // Label 6289: @444423
     /* 444423 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(444552), // Rule ID 11435 //
     /* 444428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 444468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444472 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444472 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444477 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444477 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444482 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444486 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444488 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444502 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444509 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 444519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 444524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 444529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 444534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444550 */     GIR_RootConstrainSelectedInstOperands,
     /* 444551 */     // GIR_Coverage, 11435,
     /* 444551 */     GIR_EraseRootFromParent_Done,
     /* 444552 */   // Label 6290: @444552
     /* 444552 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(444681), // Rule ID 11417 //
     /* 444557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 444597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 444601 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444611 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444638 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 444648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 444653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 444658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 444663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444679 */     GIR_RootConstrainSelectedInstOperands,
     /* 444680 */     // GIR_Coverage, 11417,
     /* 444680 */     GIR_EraseRootFromParent_Done,
     /* 444681 */   // Label 6291: @444681
     /* 444681 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(444810), // Rule ID 11418 //
     /* 444686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 444726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 444730 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444735 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444740 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444760 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444767 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 444777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 444782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 444787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 444792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444808 */     GIR_RootConstrainSelectedInstOperands,
     /* 444809 */     // GIR_Coverage, 11418,
     /* 444809 */     GIR_EraseRootFromParent_Done,
     /* 444810 */   // Label 6292: @444810
     /* 444810 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(444939), // Rule ID 11421 //
     /* 444815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 444855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 444859 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444864 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444869 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444896 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 444906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 444911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 444916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 444921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444937 */     GIR_RootConstrainSelectedInstOperands,
     /* 444938 */     // GIR_Coverage, 11421,
     /* 444938 */     GIR_EraseRootFromParent_Done,
     /* 444939 */   // Label 6293: @444939
     /* 444939 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(445068), // Rule ID 11422 //
     /* 444944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 444968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 444984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 444988 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444988 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 444993 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 444998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445002 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445025 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 445035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 445040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 445045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 445050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445066 */     GIR_RootConstrainSelectedInstOperands,
     /* 445067 */     // GIR_Coverage, 11422,
     /* 445067 */     GIR_EraseRootFromParent_Done,
     /* 445068 */   // Label 6294: @445068
     /* 445068 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(445197), // Rule ID 11402 //
     /* 445073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 445113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 445117 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445117 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445122 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445122 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445127 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445147 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445154 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 445164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 445169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 445174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 445179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445195 */     GIR_RootConstrainSelectedInstOperands,
     /* 445196 */     // GIR_Coverage, 11402,
     /* 445196 */     GIR_EraseRootFromParent_Done,
     /* 445197 */   // Label 6295: @445197
     /* 445197 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(445326), // Rule ID 11403 //
     /* 445202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 445242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 445246 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445251 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445256 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445283 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 445293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 445298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 445303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 445308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445324 */     GIR_RootConstrainSelectedInstOperands,
     /* 445325 */     // GIR_Coverage, 11403,
     /* 445325 */     GIR_EraseRootFromParent_Done,
     /* 445326 */   // Label 6296: @445326
     /* 445326 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(445455), // Rule ID 11406 //
     /* 445331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 445371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 445375 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445380 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445385 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445389 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445405 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445412 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 445422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 445427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 445432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 445437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445453 */     GIR_RootConstrainSelectedInstOperands,
     /* 445454 */     // GIR_Coverage, 11406,
     /* 445454 */     GIR_EraseRootFromParent_Done,
     /* 445455 */   // Label 6297: @445455
     /* 445455 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(445584), // Rule ID 11407 //
     /* 445460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 445500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 445504 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445509 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445514 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445541 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 445551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 445556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 445561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 445566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445582 */     GIR_RootConstrainSelectedInstOperands,
     /* 445583 */     // GIR_Coverage, 11407,
     /* 445583 */     GIR_EraseRootFromParent_Done,
     /* 445584 */   // Label 6298: @445584
     /* 445584 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(445713), // Rule ID 7584 //
     /* 445589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 445629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445633 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445633 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445638 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445643 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445647 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445663 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445670 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 445680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 445685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 445690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 445695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445711 */     GIR_RootConstrainSelectedInstOperands,
     /* 445712 */     // GIR_Coverage, 7584,
     /* 445712 */     GIR_EraseRootFromParent_Done,
     /* 445713 */   // Label 6299: @445713
     /* 445713 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(445842), // Rule ID 11416 //
     /* 445718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445750 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 445758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445762 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445762 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445767 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445772 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445792 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445799 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 445809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 445814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 445819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 445824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445840 */     GIR_RootConstrainSelectedInstOperands,
     /* 445841 */     // GIR_Coverage, 11416,
     /* 445841 */     GIR_EraseRootFromParent_Done,
     /* 445842 */   // Label 6300: @445842
     /* 445842 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(445971), // Rule ID 11419 //
     /* 445847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 445871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 445887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445891 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 445896 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 445901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445928 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 445938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 445943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 445948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 445953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445969 */     GIR_RootConstrainSelectedInstOperands,
     /* 445970 */     // GIR_Coverage, 11419,
     /* 445970 */     GIR_EraseRootFromParent_Done,
     /* 445971 */   // Label 6301: @445971
     /* 445971 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(446100), // Rule ID 11420 //
     /* 445976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 446000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 446016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 446020 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 446025 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446025 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 446030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446057 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 446067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 446072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 446077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 446082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446098 */     GIR_RootConstrainSelectedInstOperands,
     /* 446099 */     // GIR_Coverage, 11420,
     /* 446099 */     GIR_EraseRootFromParent_Done,
     /* 446100 */   // Label 6302: @446100
     /* 446100 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(446229), // Rule ID 7583 //
     /* 446105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 446129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 446145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446149 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 446154 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 446159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446186 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 446196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 446201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 446206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 446211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446227 */     GIR_RootConstrainSelectedInstOperands,
     /* 446228 */     // GIR_Coverage, 7583,
     /* 446228 */     GIR_EraseRootFromParent_Done,
     /* 446229 */   // Label 6303: @446229
     /* 446229 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(446358), // Rule ID 11401 //
     /* 446234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 446258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 446274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446278 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446278 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 446283 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 446288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446315 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 446325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 446330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 446335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 446340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446356 */     GIR_RootConstrainSelectedInstOperands,
     /* 446357 */     // GIR_Coverage, 11401,
     /* 446357 */     GIR_EraseRootFromParent_Done,
     /* 446358 */   // Label 6304: @446358
     /* 446358 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(446487), // Rule ID 11404 //
     /* 446363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 446387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 446403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446407 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 446412 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 446417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446437 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446444 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 446454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 446459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 446464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 446469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446485 */     GIR_RootConstrainSelectedInstOperands,
     /* 446486 */     // GIR_Coverage, 11404,
     /* 446486 */     GIR_EraseRootFromParent_Done,
     /* 446487 */   // Label 6305: @446487
     /* 446487 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(446616), // Rule ID 11405 //
     /* 446492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 446516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 446532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446536 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 446541 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 446546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446573 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 446583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 446588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 446593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 446598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446614 */     GIR_RootConstrainSelectedInstOperands,
     /* 446615 */     // GIR_Coverage, 11405,
     /* 446615 */     GIR_EraseRootFromParent_Done,
     /* 446616 */   // Label 6306: @446616
     /* 446616 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(446745), // Rule ID 11487 //
     /* 446621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 446645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 446649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 446661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446665 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446665 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 446670 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 446675 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446688 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446702 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 446712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 446717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 446722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 446727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 446732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 446737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446743 */     GIR_RootConstrainSelectedInstOperands,
     /* 446744 */     // GIR_Coverage, 11487,
     /* 446744 */     GIR_EraseRootFromParent_Done,
     /* 446745 */   // Label 6307: @446745
     /* 446745 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(446874), // Rule ID 11488 //
     /* 446750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 446774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 446778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 446790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446794 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 446799 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 446804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446808 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446817 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446831 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 446841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 446846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 446851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 446856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 446861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 446866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446872 */     GIR_RootConstrainSelectedInstOperands,
     /* 446873 */     // GIR_Coverage, 11488,
     /* 446873 */     GIR_EraseRootFromParent_Done,
     /* 446874 */   // Label 6308: @446874
     /* 446874 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(447003), // Rule ID 11489 //
     /* 446879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 446903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 446907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 446919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446923 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 446928 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 446933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446953 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446960 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 446970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 446975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 446980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 446985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 446990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 446995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447001 */     GIR_RootConstrainSelectedInstOperands,
     /* 447002 */     // GIR_Coverage, 11489,
     /* 447002 */     GIR_EraseRootFromParent_Done,
     /* 447003 */   // Label 6309: @447003
     /* 447003 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(447132), // Rule ID 11490 //
     /* 447008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447052 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447057 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447075 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447089 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 447099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 447104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 447109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 447114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447130 */     GIR_RootConstrainSelectedInstOperands,
     /* 447131 */     // GIR_Coverage, 11490,
     /* 447131 */     GIR_EraseRootFromParent_Done,
     /* 447132 */   // Label 6310: @447132
     /* 447132 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(447261), // Rule ID 11427 //
     /* 447137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447169 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447181 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447186 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447218 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 447228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 447233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 447238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 447243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447259 */     GIR_RootConstrainSelectedInstOperands,
     /* 447260 */     // GIR_Coverage, 11427,
     /* 447260 */     GIR_EraseRootFromParent_Done,
     /* 447261 */   // Label 6311: @447261
     /* 447261 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(447390), // Rule ID 11428 //
     /* 447266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447310 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447315 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447320 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447333 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447347 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 447357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 447362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 447367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 447372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447388 */     GIR_RootConstrainSelectedInstOperands,
     /* 447389 */     // GIR_Coverage, 11428,
     /* 447389 */     GIR_EraseRootFromParent_Done,
     /* 447390 */   // Label 6312: @447390
     /* 447390 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(447519), // Rule ID 11429 //
     /* 447395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447439 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447444 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447449 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447462 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447476 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 447486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 447491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 447496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 447501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447517 */     GIR_RootConstrainSelectedInstOperands,
     /* 447518 */     // GIR_Coverage, 11429,
     /* 447518 */     GIR_EraseRootFromParent_Done,
     /* 447519 */   // Label 6313: @447519
     /* 447519 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(447648), // Rule ID 11430 //
     /* 447524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447556 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447568 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447573 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447573 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447578 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447598 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447605 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 447615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 447620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 447625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 447630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447646 */     GIR_RootConstrainSelectedInstOperands,
     /* 447647 */     // GIR_Coverage, 11430,
     /* 447647 */     GIR_EraseRootFromParent_Done,
     /* 447648 */   // Label 6314: @447648
     /* 447648 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(447777), // Rule ID 11472 //
     /* 447653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 447681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447697 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447697 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447702 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447734 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 447744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 447749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 447754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 447759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447775 */     GIR_RootConstrainSelectedInstOperands,
     /* 447776 */     // GIR_Coverage, 11472,
     /* 447776 */     GIR_EraseRootFromParent_Done,
     /* 447777 */   // Label 6315: @447777
     /* 447777 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(447906), // Rule ID 11473 //
     /* 447782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 447810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447836 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447863 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 447873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 447878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 447883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 447888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 447893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 447898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447904 */     GIR_RootConstrainSelectedInstOperands,
     /* 447905 */     // GIR_Coverage, 11473,
     /* 447905 */     GIR_EraseRootFromParent_Done,
     /* 447906 */   // Label 6316: @447906
     /* 447906 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(448035), // Rule ID 11474 //
     /* 447911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 447935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 447939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 447951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447955 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 447960 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 447965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447992 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 448002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 448007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448033 */     GIR_RootConstrainSelectedInstOperands,
     /* 448034 */     // GIR_Coverage, 11474,
     /* 448034 */     GIR_EraseRootFromParent_Done,
     /* 448035 */   // Label 6317: @448035
     /* 448035 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(448164), // Rule ID 11475 //
     /* 448040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 448064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448084 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448089 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448107 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448121 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 448131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 448136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448162 */     GIR_RootConstrainSelectedInstOperands,
     /* 448163 */     // GIR_Coverage, 11475,
     /* 448163 */     GIR_EraseRootFromParent_Done,
     /* 448164 */   // Label 6318: @448164
     /* 448164 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(448293), // Rule ID 11412 //
     /* 448169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 448193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448213 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448218 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448223 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448236 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448250 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 448260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 448265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 448270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 448275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448291 */     GIR_RootConstrainSelectedInstOperands,
     /* 448292 */     // GIR_Coverage, 11412,
     /* 448292 */     GIR_EraseRootFromParent_Done,
     /* 448293 */   // Label 6319: @448293
     /* 448293 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(448422), // Rule ID 11413 //
     /* 448298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 448322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448342 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448342 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448347 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448352 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448379 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 448389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 448394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 448399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 448404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448420 */     GIR_RootConstrainSelectedInstOperands,
     /* 448421 */     // GIR_Coverage, 11413,
     /* 448421 */     GIR_EraseRootFromParent_Done,
     /* 448422 */   // Label 6320: @448422
     /* 448422 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(448551), // Rule ID 11414 //
     /* 448427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 448451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448485 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448508 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 448518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 448523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448549 */     GIR_RootConstrainSelectedInstOperands,
     /* 448550 */     // GIR_Coverage, 11414,
     /* 448550 */     GIR_EraseRootFromParent_Done,
     /* 448551 */   // Label 6321: @448551
     /* 448551 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(448680), // Rule ID 11415 //
     /* 448556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 448580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448600 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448605 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448610 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448637 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 448647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 448652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 448667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 448672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448678 */     GIR_RootConstrainSelectedInstOperands,
     /* 448679 */     // GIR_Coverage, 11415,
     /* 448679 */     GIR_EraseRootFromParent_Done,
     /* 448680 */   // Label 6322: @448680
     /* 448680 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(448809), // Rule ID 11483 //
     /* 448685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 448709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 448713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448729 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448734 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448766 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 448776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 448781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 448796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 448801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448807 */     GIR_RootConstrainSelectedInstOperands,
     /* 448808 */     // GIR_Coverage, 11483,
     /* 448808 */     GIR_EraseRootFromParent_Done,
     /* 448809 */   // Label 6323: @448809
     /* 448809 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(448938), // Rule ID 11484 //
     /* 448814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 448838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 448842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448858 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448863 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448895 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 448905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 448910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 448925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 448930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448936 */     GIR_RootConstrainSelectedInstOperands,
     /* 448937 */     // GIR_Coverage, 11484,
     /* 448937 */     GIR_EraseRootFromParent_Done,
     /* 448938 */   // Label 6324: @448938
     /* 448938 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(449067), // Rule ID 11485 //
     /* 448943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 448967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 448971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448975 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 448983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448987 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448987 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 448992 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 448997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449010 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449024 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 449034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 449039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 449044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 449049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449065 */     GIR_RootConstrainSelectedInstOperands,
     /* 449066 */     // GIR_Coverage, 11485,
     /* 449066 */     GIR_EraseRootFromParent_Done,
     /* 449067 */   // Label 6325: @449067
     /* 449067 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(449196), // Rule ID 11486 //
     /* 449072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 449116 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449121 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449126 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449153 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 449163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 449168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 449173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 449178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449194 */     GIR_RootConstrainSelectedInstOperands,
     /* 449195 */     // GIR_Coverage, 11486,
     /* 449195 */     GIR_EraseRootFromParent_Done,
     /* 449196 */   // Label 6326: @449196
     /* 449196 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(449325), // Rule ID 11423 //
     /* 449201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449245 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449250 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449255 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449282 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 449292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 449297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 449302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 449307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449323 */     GIR_RootConstrainSelectedInstOperands,
     /* 449324 */     // GIR_Coverage, 11423,
     /* 449324 */     GIR_EraseRootFromParent_Done,
     /* 449325 */   // Label 6327: @449325
     /* 449325 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(449454), // Rule ID 11424 //
     /* 449330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449374 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449379 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449411 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 449421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 449426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 449431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 449436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449452 */     GIR_RootConstrainSelectedInstOperands,
     /* 449453 */     // GIR_Coverage, 11424,
     /* 449453 */     GIR_EraseRootFromParent_Done,
     /* 449454 */   // Label 6328: @449454
     /* 449454 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(449583), // Rule ID 11425 //
     /* 449459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449503 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449503 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449508 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449540 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 449550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 449555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 449560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 449565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449581 */     GIR_RootConstrainSelectedInstOperands,
     /* 449582 */     // GIR_Coverage, 11425,
     /* 449582 */     GIR_EraseRootFromParent_Done,
     /* 449583 */   // Label 6329: @449583
     /* 449583 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(449712), // Rule ID 11426 //
     /* 449588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449632 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449637 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449655 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449669 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 449679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 449684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 449689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 449694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449710 */     GIR_RootConstrainSelectedInstOperands,
     /* 449711 */     // GIR_Coverage, 11426,
     /* 449711 */     GIR_EraseRootFromParent_Done,
     /* 449712 */   // Label 6330: @449712
     /* 449712 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(449841), // Rule ID 11468 //
     /* 449717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 449745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 449761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449766 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449771 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449798 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 449808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 449813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 449818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 449823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449839 */     GIR_RootConstrainSelectedInstOperands,
     /* 449840 */     // GIR_Coverage, 11468,
     /* 449840 */     GIR_EraseRootFromParent_Done,
     /* 449841 */   // Label 6331: @449841
     /* 449841 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(449970), // Rule ID 11469 //
     /* 449846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 449874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 449886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 449890 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449890 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 449895 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449895 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 449900 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449913 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449927 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 449937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 449942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 449947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 449952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449968 */     GIR_RootConstrainSelectedInstOperands,
     /* 449969 */     // GIR_Coverage, 11469,
     /* 449969 */     GIR_EraseRootFromParent_Done,
     /* 449970 */   // Label 6332: @449970
     /* 449970 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(450099), // Rule ID 11470 //
     /* 449975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 449999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 450019 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450024 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450029 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450049 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450056 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 450066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 450071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 450076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 450081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450097 */     GIR_RootConstrainSelectedInstOperands,
     /* 450098 */     // GIR_Coverage, 11470,
     /* 450098 */     GIR_EraseRootFromParent_Done,
     /* 450099 */   // Label 6333: @450099
     /* 450099 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(450228), // Rule ID 11471 //
     /* 450104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 450148 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450148 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450153 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450171 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450185 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 450195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 450200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 450205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 450210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450226 */     GIR_RootConstrainSelectedInstOperands,
     /* 450227 */     // GIR_Coverage, 11471,
     /* 450227 */     GIR_EraseRootFromParent_Done,
     /* 450228 */   // Label 6334: @450228
     /* 450228 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(450357), // Rule ID 11408 //
     /* 450233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450277 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450282 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450287 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450300 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450307 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450314 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 450324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 450329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 450334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 450339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450355 */     GIR_RootConstrainSelectedInstOperands,
     /* 450356 */     // GIR_Coverage, 11408,
     /* 450356 */     GIR_EraseRootFromParent_Done,
     /* 450357 */   // Label 6335: @450357
     /* 450357 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(450486), // Rule ID 11409 //
     /* 450362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450411 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450416 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450429 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450443 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 450453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 450458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 450463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 450468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450484 */     GIR_RootConstrainSelectedInstOperands,
     /* 450485 */     // GIR_Coverage, 11409,
     /* 450485 */     GIR_EraseRootFromParent_Done,
     /* 450486 */   // Label 6336: @450486
     /* 450486 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(450615), // Rule ID 11410 //
     /* 450491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450535 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450540 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450549 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450558 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450565 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450572 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 450582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 450587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 450592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 450597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450613 */     GIR_RootConstrainSelectedInstOperands,
     /* 450614 */     // GIR_Coverage, 11410,
     /* 450614 */     GIR_EraseRootFromParent_Done,
     /* 450615 */   // Label 6337: @450615
     /* 450615 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(450744), // Rule ID 11411 //
     /* 450620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 450660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450664 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 450669 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 450674 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450687 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450701 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 450711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 450716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 450721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 450726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450742 */     GIR_RootConstrainSelectedInstOperands,
     /* 450743 */     // GIR_Coverage, 11411,
     /* 450743 */     GIR_EraseRootFromParent_Done,
     /* 450744 */   // Label 6338: @450744
     /* 450744 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(450856), // Rule ID 13246 //
     /* 450749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 450752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 450760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 450764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 450776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450784 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 450786 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 450790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 450792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450813 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 450816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 450823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 450828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 450833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 450838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 450843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 450848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450854 */     GIR_RootConstrainSelectedInstOperands,
     /* 450855 */     // GIR_Coverage, 13246,
     /* 450855 */     GIR_EraseRootFromParent_Done,
     /* 450856 */   // Label 6339: @450856
     /* 450856 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(450968), // Rule ID 13245 //
     /* 450861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 450864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 450872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 450876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450896 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 450898 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 450902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 450904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450925 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 450928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 450935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 450940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 450945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 450950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 450955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 450960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450966 */     GIR_RootConstrainSelectedInstOperands,
     /* 450967 */     // GIR_Coverage, 13245,
     /* 450967 */     GIR_EraseRootFromParent_Done,
     /* 450968 */   // Label 6340: @450968
     /* 450968 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(451080), // Rule ID 7720 //
     /* 450973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 450976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 450988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 450996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 451000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451008 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 451010 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 451014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 451016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451030 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451037 */     // (fmaxnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 451047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 451052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 451057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 451067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 451072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451078 */     GIR_RootConstrainSelectedInstOperands,
     /* 451079 */     // GIR_Coverage, 7720,
     /* 451079 */     GIR_EraseRootFromParent_Done,
     /* 451080 */   // Label 6341: @451080
     /* 451080 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(451192), // Rule ID 7719 //
     /* 451085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 451088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 451100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 451108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451120 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 451122 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 451126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 451128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451135 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451149 */     // (fmaxnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 451159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 451164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 451169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 451179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 451184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451190 */     GIR_RootConstrainSelectedInstOperands,
     /* 451191 */     // GIR_Coverage, 7719,
     /* 451191 */     GIR_EraseRootFromParent_Done,
     /* 451192 */   // Label 6342: @451192
     /* 451192 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(451288), // Rule ID 13238 //
     /* 451197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 451200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 451208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 451212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451220 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 451222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 451224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451245 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 451255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 451265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 451270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 451275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 451280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451286 */     GIR_RootConstrainSelectedInstOperands,
     /* 451287 */     // GIR_Coverage, 13238,
     /* 451287 */     GIR_EraseRootFromParent_Done,
     /* 451288 */   // Label 6343: @451288
     /* 451288 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(451384), // Rule ID 13237 //
     /* 451293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 451296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 451304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451316 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 451318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 451320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451341 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 451351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 451361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 451366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 451371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 451376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451382 */     GIR_RootConstrainSelectedInstOperands,
     /* 451383 */     // GIR_Coverage, 13237,
     /* 451383 */     GIR_EraseRootFromParent_Done,
     /* 451384 */   // Label 6344: @451384
     /* 451384 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(451480), // Rule ID 7712 //
     /* 451389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 451392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 451404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451412 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 451414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 451416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451437 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 451447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 451452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 451457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 451467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 451472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451478 */     GIR_RootConstrainSelectedInstOperands,
     /* 451479 */     // GIR_Coverage, 7712,
     /* 451479 */     GIR_EraseRootFromParent_Done,
     /* 451480 */   // Label 6345: @451480
     /* 451480 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(451576), // Rule ID 7711 //
     /* 451485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 451488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451508 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 451510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 451512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451526 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451533 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 451536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 451543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 451548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 451553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 451563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 451568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451574 */     GIR_RootConstrainSelectedInstOperands,
     /* 451575 */     // GIR_Coverage, 7711,
     /* 451575 */     GIR_EraseRootFromParent_Done,
     /* 451576 */   // Label 6346: @451576
     /* 451576 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(451611), // Rule ID 93 //
     /* 451581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 451584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 451588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 451592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 451596 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13799),
     /* 451600 */     // (fmaxnum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13799>>  =>  (S_MAX_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 451600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F32),
     /* 451605 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 451609 */     GIR_RootConstrainSelectedInstOperands,
     /* 451610 */     // GIR_Coverage, 93,
     /* 451610 */     GIR_Done,
     /* 451611 */   // Label 6347: @451611
     /* 451611 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(451671), // Rule ID 803 //
     /* 451616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 451627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451634 */     // (fmaxnum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 451634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 451637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 451644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 451649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 451654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 451664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 451669 */     GIR_RootConstrainSelectedInstOperands,
     /* 451670 */     // GIR_Coverage, 803,
     /* 451670 */     GIR_EraseRootFromParent_Done,
     /* 451671 */   // Label 6348: @451671
     /* 451671 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(451731), // Rule ID 8418 //
     /* 451676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 451694 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 451694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 451697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 451704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 451714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 451719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 451724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 451729 */     GIR_RootConstrainSelectedInstOperands,
     /* 451730 */     // GIR_Coverage, 8418,
     /* 451730 */     GIR_EraseRootFromParent_Done,
     /* 451731 */   // Label 6349: @451731
     /* 451731 */   GIM_Reject,
     /* 451732 */ // Label 6210: @451732
     /* 451732 */ GIM_Reject,
     /* 451733 */ // Label 5800: @451733
     /* 451733 */ GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(451985),
     /* 451738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 451741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 451744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 451748 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(451807), // Rule ID 918 //
     /* 451753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 451756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 451763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451770 */     // (fmaxnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 451770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 451773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 451780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 451785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 451790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 451800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 451805 */     GIR_RootConstrainSelectedInstOperands,
     /* 451806 */     // GIR_Coverage, 918,
     /* 451806 */     GIR_EraseRootFromParent_Done,
     /* 451807 */   // Label 6351: @451807
     /* 451807 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(451866), // Rule ID 937 //
     /* 451812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 451815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 451822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451829 */     // (fmaxnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 451829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 451832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 451839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 451844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 451849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 451859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 451864 */     GIR_RootConstrainSelectedInstOperands,
     /* 451865 */     // GIR_Coverage, 937,
     /* 451865 */     GIR_EraseRootFromParent_Done,
     /* 451866 */   // Label 6352: @451866
     /* 451866 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(451925), // Rule ID 8444 //
     /* 451871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 451874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 451888 */     // (fmaxnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 451888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 451891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 451898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 451908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 451913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 451918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 451923 */     GIR_RootConstrainSelectedInstOperands,
     /* 451924 */     // GIR_Coverage, 8444,
     /* 451924 */     GIR_EraseRootFromParent_Done,
     /* 451925 */   // Label 6353: @451925
     /* 451925 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(451984), // Rule ID 8458 //
     /* 451930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 451933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 451947 */     // (fmaxnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 451947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 451950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 451957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 451967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 451972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 451977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 451982 */     GIR_RootConstrainSelectedInstOperands,
     /* 451983 */     // GIR_Coverage, 8458,
     /* 451983 */     GIR_EraseRootFromParent_Done,
     /* 451984 */   // Label 6354: @451984
     /* 451984 */   GIM_Reject,
     /* 451985 */ // Label 6350: @451985
     /* 451985 */ GIM_Reject,
     /* 451986 */ // Label 5801: @451986
     /* 451986 */ GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(452057), // Rule ID 1095 //
     /* 451991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 451994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 451997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452001 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 452008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 452015 */   // (fmaxnum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 452015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 452018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 452025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 452030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 452035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452055 */   GIR_RootConstrainSelectedInstOperands,
     /* 452056 */   // GIR_Coverage, 1095,
     /* 452056 */   GIR_EraseRootFromParent_Done,
     /* 452057 */ // Label 6355: @452057
     /* 452057 */ GIM_Reject,
     /* 452058 */ // Label 5802: @452058
     /* 452058 */ GIM_Reject,
     /* 452059 */ // Label 82: @452059
     /* 452059 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 6360*/ GIMT_Encode4(523837),
     /* 452070 */ /*GILLT_s16*//*Label 6356*/ GIMT_Encode4(452086),
     /* 452074 */ /*GILLT_s32*//*Label 6357*/ GIMT_Encode4(506000),
     /* 452078 */ /*GILLT_s64*//*Label 6358*/ GIMT_Encode4(523512),
     /* 452082 */ /*GILLT_v2s16*//*Label 6359*/ GIMT_Encode4(523765),
     /* 452086 */ // Label 6356: @452086
     /* 452086 */ GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(505999),
     /* 452091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 452094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 452097 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(452232), // Rule ID 12137 //
     /* 452102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 452105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 452121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 452125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 452129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 452137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 452141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 452145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452149 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 452154 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 452159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 452163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452186 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 452189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 452196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 452201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 452206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 452216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 452221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452230 */     GIR_RootConstrainSelectedInstOperands,
     /* 452231 */     // GIR_Coverage, 12137,
     /* 452231 */     GIR_EraseRootFromParent_Done,
     /* 452232 */   // Label 6362: @452232
     /* 452232 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(452367), // Rule ID 12138 //
     /* 452237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 452240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 452256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 452260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 452264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 452272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 452276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 452280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452284 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 452289 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 452294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 452298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452321 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 452324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 452331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 452336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 452341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 452351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 452356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452365 */     GIR_RootConstrainSelectedInstOperands,
     /* 452366 */     // GIR_Coverage, 12138,
     /* 452366 */     GIR_EraseRootFromParent_Done,
     /* 452367 */   // Label 6363: @452367
     /* 452367 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(452502), // Rule ID 12141 //
     /* 452372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 452375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 452391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 452395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 452399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 452407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 452411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 452415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452419 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 452424 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 452429 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 452433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452449 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452456 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 452459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 452466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 452471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 452476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 452481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 452486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 452491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452500 */     GIR_RootConstrainSelectedInstOperands,
     /* 452501 */     // GIR_Coverage, 12141,
     /* 452501 */     GIR_EraseRootFromParent_Done,
     /* 452502 */   // Label 6364: @452502
     /* 452502 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(452637), // Rule ID 12142 //
     /* 452507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 452510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 452526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 452530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 452534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 452542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 452546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 452550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452554 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 452559 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 452564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 452568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452584 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452591 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 452594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 452601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 452606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 452611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 452616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 452621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 452626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452635 */     GIR_RootConstrainSelectedInstOperands,
     /* 452636 */     // GIR_Coverage, 12142,
     /* 452636 */     GIR_EraseRootFromParent_Done,
     /* 452637 */   // Label 6365: @452637
     /* 452637 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(452772), // Rule ID 12617 //
     /* 452642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 452645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 452649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 452661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 452665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 452669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 452677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 452681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 452685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452689 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 452694 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 452699 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 452703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452719 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452726 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 452729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 452736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 452741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 452746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 452756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 452761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452770 */     GIR_RootConstrainSelectedInstOperands,
     /* 452771 */     // GIR_Coverage, 12617,
     /* 452771 */     GIR_EraseRootFromParent_Done,
     /* 452772 */   // Label 6366: @452772
     /* 452772 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(452907), // Rule ID 12618 //
     /* 452777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 452780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 452784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 452796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 452800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 452804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 452812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 452816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 452820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452824 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 452829 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 452834 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 452838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452861 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 452864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 452871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 452876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 452881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 452891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 452896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452905 */     GIR_RootConstrainSelectedInstOperands,
     /* 452906 */     // GIR_Coverage, 12618,
     /* 452906 */     GIR_EraseRootFromParent_Done,
     /* 452907 */   // Label 6367: @452907
     /* 452907 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(453042), // Rule ID 12621 //
     /* 452912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 452915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 452919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 452931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 452935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 452939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 452943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 452947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 452951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 452955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452959 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 452964 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 452969 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 452973 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452996 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 452999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 453006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 453011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 453016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 453021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453040 */     GIR_RootConstrainSelectedInstOperands,
     /* 453041 */     // GIR_Coverage, 12621,
     /* 453041 */     GIR_EraseRootFromParent_Done,
     /* 453042 */   // Label 6368: @453042
     /* 453042 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(453177), // Rule ID 12622 //
     /* 453047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 453050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 453054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453094 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453099 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453131 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 453134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 453141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 453146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 453151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 453156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453175 */     GIR_RootConstrainSelectedInstOperands,
     /* 453176 */     // GIR_Coverage, 12622,
     /* 453176 */     GIR_EraseRootFromParent_Done,
     /* 453177 */   // Label 6369: @453177
     /* 453177 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(453312), // Rule ID 13097 //
     /* 453182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 453185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453229 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453234 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453234 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453239 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453259 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453266 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 453269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 453276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 453281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 453286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 453291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453310 */     GIR_RootConstrainSelectedInstOperands,
     /* 453311 */     // GIR_Coverage, 13097,
     /* 453311 */     GIR_EraseRootFromParent_Done,
     /* 453312 */   // Label 6370: @453312
     /* 453312 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(453447), // Rule ID 13098 //
     /* 453317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 453320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453364 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453364 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453369 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453374 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453401 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 453404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 453411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 453416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 453421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 453426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453445 */     GIR_RootConstrainSelectedInstOperands,
     /* 453446 */     // GIR_Coverage, 13098,
     /* 453446 */     GIR_EraseRootFromParent_Done,
     /* 453447 */   // Label 6371: @453447
     /* 453447 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(453582), // Rule ID 13101 //
     /* 453452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 453455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453499 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453504 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453509 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453513 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453536 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 453539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 453546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 453551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 453556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 453561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453580 */     GIR_RootConstrainSelectedInstOperands,
     /* 453581 */     // GIR_Coverage, 13101,
     /* 453581 */     GIR_EraseRootFromParent_Done,
     /* 453582 */   // Label 6372: @453582
     /* 453582 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(453717), // Rule ID 13102 //
     /* 453587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 453590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453634 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453639 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453644 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453648 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453671 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 453674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 453681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 453686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 453691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 453696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453715 */     GIR_RootConstrainSelectedInstOperands,
     /* 453716 */     // GIR_Coverage, 13102,
     /* 453716 */     GIR_EraseRootFromParent_Done,
     /* 453717 */   // Label 6373: @453717
     /* 453717 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(453852), // Rule ID 12122 //
     /* 453722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 453725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 453769 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453774 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453806 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 453809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 453816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 453821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 453826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 453831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453850 */     GIR_RootConstrainSelectedInstOperands,
     /* 453851 */     // GIR_Coverage, 12122,
     /* 453851 */     GIR_EraseRootFromParent_Done,
     /* 453852 */   // Label 6374: @453852
     /* 453852 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(453987), // Rule ID 12123 //
     /* 453857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 453860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 453876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 453880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 453884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 453892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 453896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 453900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 453904 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 453909 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 453914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 453918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453934 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453941 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 453944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 453951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 453956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 453961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 453966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453985 */     GIR_RootConstrainSelectedInstOperands,
     /* 453986 */     // GIR_Coverage, 12123,
     /* 453986 */     GIR_EraseRootFromParent_Done,
     /* 453987 */   // Label 6375: @453987
     /* 453987 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(454122), // Rule ID 12126 //
     /* 453992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 453995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454039 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454044 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454049 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454076 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 454079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 454086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 454091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 454096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 454101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454120 */     GIR_RootConstrainSelectedInstOperands,
     /* 454121 */     // GIR_Coverage, 12126,
     /* 454121 */     GIR_EraseRootFromParent_Done,
     /* 454122 */   // Label 6376: @454122
     /* 454122 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(454257), // Rule ID 12127 //
     /* 454127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 454130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454174 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454174 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454179 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454184 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454211 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 454214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 454221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 454226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 454231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 454236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454255 */     GIR_RootConstrainSelectedInstOperands,
     /* 454256 */     // GIR_Coverage, 12127,
     /* 454256 */     GIR_EraseRootFromParent_Done,
     /* 454257 */   // Label 6377: @454257
     /* 454257 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(454392), // Rule ID 12602 //
     /* 454262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 454265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 454269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454309 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454314 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454319 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454346 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 454349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 454356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 454361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 454366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 454371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454390 */     GIR_RootConstrainSelectedInstOperands,
     /* 454391 */     // GIR_Coverage, 12602,
     /* 454391 */     GIR_EraseRootFromParent_Done,
     /* 454392 */   // Label 6378: @454392
     /* 454392 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(454527), // Rule ID 12603 //
     /* 454397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 454400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 454404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454444 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454449 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454454 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454481 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 454484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 454491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 454496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 454501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 454506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454525 */     GIR_RootConstrainSelectedInstOperands,
     /* 454526 */     // GIR_Coverage, 12603,
     /* 454526 */     GIR_EraseRootFromParent_Done,
     /* 454527 */   // Label 6379: @454527
     /* 454527 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(454662), // Rule ID 12606 //
     /* 454532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 454535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 454539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454579 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454584 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454616 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 454619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 454626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 454631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 454636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 454641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454660 */     GIR_RootConstrainSelectedInstOperands,
     /* 454661 */     // GIR_Coverage, 12606,
     /* 454661 */     GIR_EraseRootFromParent_Done,
     /* 454662 */   // Label 6380: @454662
     /* 454662 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(454797), // Rule ID 12607 //
     /* 454667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 454670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 454674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454714 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454719 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454724 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454744 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454751 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 454754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 454761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 454766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 454771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 454776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454795 */     GIR_RootConstrainSelectedInstOperands,
     /* 454796 */     // GIR_Coverage, 12607,
     /* 454796 */     GIR_EraseRootFromParent_Done,
     /* 454797 */   // Label 6381: @454797
     /* 454797 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(454932), // Rule ID 13082 //
     /* 454802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 454805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454849 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454849 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454854 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454854 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454879 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454886 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 454889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 454896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 454901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 454906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 454911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454930 */     GIR_RootConstrainSelectedInstOperands,
     /* 454931 */     // GIR_Coverage, 13082,
     /* 454931 */     GIR_EraseRootFromParent_Done,
     /* 454932 */   // Label 6382: @454932
     /* 454932 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(455067), // Rule ID 13083 //
     /* 454937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 454940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 454956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 454960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 454964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 454972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 454976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 454980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454984 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 454989 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 454994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 454998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455021 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 455024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 455036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 455041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 455046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455065 */     GIR_RootConstrainSelectedInstOperands,
     /* 455066 */     // GIR_Coverage, 13083,
     /* 455066 */     GIR_EraseRootFromParent_Done,
     /* 455067 */   // Label 6383: @455067
     /* 455067 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(455202), // Rule ID 13086 //
     /* 455072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 455075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 455115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 455119 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455124 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455156 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 455159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 455166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 455171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 455176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 455181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455200 */     GIR_RootConstrainSelectedInstOperands,
     /* 455201 */     // GIR_Coverage, 13086,
     /* 455201 */     GIR_EraseRootFromParent_Done,
     /* 455202 */   // Label 6384: @455202
     /* 455202 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(455337), // Rule ID 13087 //
     /* 455207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 455210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 455250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 455254 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455259 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455264 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455291 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 455294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 455301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 455306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 455311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 455316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455335 */     GIR_RootConstrainSelectedInstOperands,
     /* 455336 */     // GIR_Coverage, 13087,
     /* 455336 */     GIR_EraseRootFromParent_Done,
     /* 455337 */   // Label 6385: @455337
     /* 455337 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(455472), // Rule ID 7632 //
     /* 455342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 455345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 455385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 455389 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455394 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455426 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 455429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 455441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 455446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 455451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455470 */     GIR_RootConstrainSelectedInstOperands,
     /* 455471 */     // GIR_Coverage, 7632,
     /* 455471 */     GIR_EraseRootFromParent_Done,
     /* 455472 */   // Label 6386: @455472
     /* 455472 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(455607), // Rule ID 7664 //
     /* 455477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 455480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 455484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 455520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 455524 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455529 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455561 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 455564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 455576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 455581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 455586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455605 */     GIR_RootConstrainSelectedInstOperands,
     /* 455606 */     // GIR_Coverage, 7664,
     /* 455606 */     GIR_EraseRootFromParent_Done,
     /* 455607 */   // Label 6387: @455607
     /* 455607 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(455742), // Rule ID 7696 //
     /* 455612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 455615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 455655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 455659 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455659 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455664 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455696 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 455699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 455711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 455716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 455721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455740 */     GIR_RootConstrainSelectedInstOperands,
     /* 455741 */     // GIR_Coverage, 7696,
     /* 455741 */     GIR_EraseRootFromParent_Done,
     /* 455742 */   // Label 6388: @455742
     /* 455742 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(455877), // Rule ID 12136 //
     /* 455747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 455750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 455790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 455794 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455799 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455808 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455831 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 455834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 455846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 455851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 455856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455875 */     GIR_RootConstrainSelectedInstOperands,
     /* 455876 */     // GIR_Coverage, 12136,
     /* 455876 */     GIR_EraseRootFromParent_Done,
     /* 455877 */   // Label 6389: @455877
     /* 455877 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(456012), // Rule ID 12139 //
     /* 455882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 455885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 455901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 455905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 455909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 455913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 455917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 455921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 455925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 455929 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 455934 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 455939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 455943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455966 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 455969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 455976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 455981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 455986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 455991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456010 */     GIR_RootConstrainSelectedInstOperands,
     /* 456011 */     // GIR_Coverage, 12139,
     /* 456011 */     GIR_EraseRootFromParent_Done,
     /* 456012 */   // Label 6390: @456012
     /* 456012 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(456147), // Rule ID 12140 //
     /* 456017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 456020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456064 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456069 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456101 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 456104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 456111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 456116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 456121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 456126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456145 */     GIR_RootConstrainSelectedInstOperands,
     /* 456146 */     // GIR_Coverage, 12140,
     /* 456146 */     GIR_EraseRootFromParent_Done,
     /* 456147 */   // Label 6391: @456147
     /* 456147 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(456282), // Rule ID 12616 //
     /* 456152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 456155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 456159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456199 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456204 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456204 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456236 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 456239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 456246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 456251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 456256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 456261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456280 */     GIR_RootConstrainSelectedInstOperands,
     /* 456281 */     // GIR_Coverage, 12616,
     /* 456281 */     GIR_EraseRootFromParent_Done,
     /* 456282 */   // Label 6392: @456282
     /* 456282 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(456417), // Rule ID 12619 //
     /* 456287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 456290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 456294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456334 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456334 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456339 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456344 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456364 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456371 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 456374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 456381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 456386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 456391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 456396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456415 */     GIR_RootConstrainSelectedInstOperands,
     /* 456416 */     // GIR_Coverage, 12619,
     /* 456416 */     GIR_EraseRootFromParent_Done,
     /* 456417 */   // Label 6393: @456417
     /* 456417 */   GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(456552), // Rule ID 12620 //
     /* 456422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 456425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 456429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456469 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456474 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456506 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 456509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 456516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 456521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 456526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 456531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456550 */     GIR_RootConstrainSelectedInstOperands,
     /* 456551 */     // GIR_Coverage, 12620,
     /* 456551 */     GIR_EraseRootFromParent_Done,
     /* 456552 */   // Label 6394: @456552
     /* 456552 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(456687), // Rule ID 13096 //
     /* 456557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 456560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456604 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456609 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456614 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456641 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 456644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 456651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 456656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 456661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 456666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456685 */     GIR_RootConstrainSelectedInstOperands,
     /* 456686 */     // GIR_Coverage, 13096,
     /* 456686 */     GIR_EraseRootFromParent_Done,
     /* 456687 */   // Label 6395: @456687
     /* 456687 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(456822), // Rule ID 13099 //
     /* 456692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 456695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456739 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456744 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456776 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 456779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 456786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 456791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 456796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 456801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456820 */     GIR_RootConstrainSelectedInstOperands,
     /* 456821 */     // GIR_Coverage, 13099,
     /* 456821 */     GIR_EraseRootFromParent_Done,
     /* 456822 */   // Label 6396: @456822
     /* 456822 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(456957), // Rule ID 13100 //
     /* 456827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 456830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 456870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456874 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456879 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456879 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456884 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456904 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456911 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 456914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 456921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 456926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 456931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 456936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456955 */     GIR_RootConstrainSelectedInstOperands,
     /* 456956 */     // GIR_Coverage, 13100,
     /* 456956 */     GIR_EraseRootFromParent_Done,
     /* 456957 */   // Label 6397: @456957
     /* 456957 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(457092), // Rule ID 7631 //
     /* 456962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 456965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457009 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457014 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457019 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457023 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457046 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 457049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 457056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 457061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 457066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 457071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457090 */     GIR_RootConstrainSelectedInstOperands,
     /* 457091 */     // GIR_Coverage, 7631,
     /* 457091 */     GIR_EraseRootFromParent_Done,
     /* 457092 */   // Label 6398: @457092
     /* 457092 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(457227), // Rule ID 7663 //
     /* 457097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 457100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 457104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457144 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457149 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457181 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 457184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 457191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 457196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 457201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 457206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457225 */     GIR_RootConstrainSelectedInstOperands,
     /* 457226 */     // GIR_Coverage, 7663,
     /* 457226 */     GIR_EraseRootFromParent_Done,
     /* 457227 */   // Label 6399: @457227
     /* 457227 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(457362), // Rule ID 7695 //
     /* 457232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 457235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 457239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457279 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457284 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457316 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 457319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 457326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 457331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 457336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 457341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457360 */     GIR_RootConstrainSelectedInstOperands,
     /* 457361 */     // GIR_Coverage, 7695,
     /* 457361 */     GIR_EraseRootFromParent_Done,
     /* 457362 */   // Label 6400: @457362
     /* 457362 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(457497), // Rule ID 12121 //
     /* 457367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 457370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 457374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457414 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457419 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457451 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 457454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 457461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 457466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 457471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 457476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457495 */     GIR_RootConstrainSelectedInstOperands,
     /* 457496 */     // GIR_Coverage, 12121,
     /* 457496 */     GIR_EraseRootFromParent_Done,
     /* 457497 */   // Label 6401: @457497
     /* 457497 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(457632), // Rule ID 12124 //
     /* 457502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 457505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 457509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457549 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457554 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457579 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457586 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 457589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 457596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 457601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 457606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 457611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457630 */     GIR_RootConstrainSelectedInstOperands,
     /* 457631 */     // GIR_Coverage, 12124,
     /* 457631 */     GIR_EraseRootFromParent_Done,
     /* 457632 */   // Label 6402: @457632
     /* 457632 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(457767), // Rule ID 12125 //
     /* 457637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 457640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 457644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457684 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457689 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457714 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457721 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 457724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 457731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 457736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 457741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 457746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457765 */     GIR_RootConstrainSelectedInstOperands,
     /* 457766 */     // GIR_Coverage, 12125,
     /* 457766 */     GIR_EraseRootFromParent_Done,
     /* 457767 */   // Label 6403: @457767
     /* 457767 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(457902), // Rule ID 12601 //
     /* 457772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 457775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 457779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457807 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457819 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457819 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457824 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457856 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 457859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 457866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 457871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 457876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 457881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457900 */     GIR_RootConstrainSelectedInstOperands,
     /* 457901 */     // GIR_Coverage, 12601,
     /* 457901 */     GIR_EraseRootFromParent_Done,
     /* 457902 */   // Label 6404: @457902
     /* 457902 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(458037), // Rule ID 12604 //
     /* 457907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 457910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 457914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 457950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 457954 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457959 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457968 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457991 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 457994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 458001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 458006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 458011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 458016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458035 */     GIR_RootConstrainSelectedInstOperands,
     /* 458036 */     // GIR_Coverage, 12604,
     /* 458036 */     GIR_EraseRootFromParent_Done,
     /* 458037 */   // Label 6405: @458037
     /* 458037 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(458172), // Rule ID 12605 //
     /* 458042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 458045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 458049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 458085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458089 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458094 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458126 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 458129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 458136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 458141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 458146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 458151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458170 */     GIR_RootConstrainSelectedInstOperands,
     /* 458171 */     // GIR_Coverage, 12605,
     /* 458171 */     GIR_EraseRootFromParent_Done,
     /* 458172 */   // Label 6406: @458172
     /* 458172 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(458307), // Rule ID 13081 //
     /* 458177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 458180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 458220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458224 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458229 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458234 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458261 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 458264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 458271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 458276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 458281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 458286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458305 */     GIR_RootConstrainSelectedInstOperands,
     /* 458306 */     // GIR_Coverage, 13081,
     /* 458306 */     GIR_EraseRootFromParent_Done,
     /* 458307 */   // Label 6407: @458307
     /* 458307 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(458442), // Rule ID 13084 //
     /* 458312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 458315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 458355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458359 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458364 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458364 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458369 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458396 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 458399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 458406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 458411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 458416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 458421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458440 */     GIR_RootConstrainSelectedInstOperands,
     /* 458441 */     // GIR_Coverage, 13084,
     /* 458441 */     GIR_EraseRootFromParent_Done,
     /* 458442 */   // Label 6408: @458442
     /* 458442 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(458577), // Rule ID 13085 //
     /* 458447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 458450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 458490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458494 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458499 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458531 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 458534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 458541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 458546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 458551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 458556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458575 */     GIR_RootConstrainSelectedInstOperands,
     /* 458576 */     // GIR_Coverage, 13085,
     /* 458576 */     GIR_EraseRootFromParent_Done,
     /* 458577 */   // Label 6409: @458577
     /* 458577 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(458712), // Rule ID 12107 //
     /* 458582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 458585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 458613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 458625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 458629 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458634 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458643 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458666 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 458669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 458676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 458681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 458686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 458691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458710 */     GIR_RootConstrainSelectedInstOperands,
     /* 458711 */     // GIR_Coverage, 12107,
     /* 458711 */     GIR_EraseRootFromParent_Done,
     /* 458712 */   // Label 6410: @458712
     /* 458712 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(458847), // Rule ID 12108 //
     /* 458717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 458720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 458748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 458760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 458764 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458769 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458801 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 458804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 458811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 458816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 458821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 458826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458845 */     GIR_RootConstrainSelectedInstOperands,
     /* 458846 */     // GIR_Coverage, 12108,
     /* 458846 */     GIR_EraseRootFromParent_Done,
     /* 458847 */   // Label 6411: @458847
     /* 458847 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(458982), // Rule ID 12111 //
     /* 458852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 458855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 458883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 458895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 458899 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458904 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458909 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458936 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 458939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 458946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 458951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 458956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 458961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458980 */     GIR_RootConstrainSelectedInstOperands,
     /* 458981 */     // GIR_Coverage, 12111,
     /* 458981 */     GIR_EraseRootFromParent_Done,
     /* 458982 */   // Label 6412: @458982
     /* 458982 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(459117), // Rule ID 12112 //
     /* 458987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 458990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459034 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459039 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459044 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459071 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 459074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 459081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 459086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 459091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 459096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459115 */     GIR_RootConstrainSelectedInstOperands,
     /* 459116 */     // GIR_Coverage, 12112,
     /* 459116 */     GIR_EraseRootFromParent_Done,
     /* 459117 */   // Label 6413: @459117
     /* 459117 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(459252), // Rule ID 12587 //
     /* 459122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 459125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 459129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459165 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459169 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459174 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459174 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459179 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459206 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 459209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 459216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 459221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 459226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 459231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459250 */     GIR_RootConstrainSelectedInstOperands,
     /* 459251 */     // GIR_Coverage, 12587,
     /* 459251 */     GIR_EraseRootFromParent_Done,
     /* 459252 */   // Label 6414: @459252
     /* 459252 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(459387), // Rule ID 12588 //
     /* 459257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 459260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 459264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459304 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459304 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459309 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459314 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459341 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 459344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 459351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 459356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 459361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 459366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459385 */     GIR_RootConstrainSelectedInstOperands,
     /* 459386 */     // GIR_Coverage, 12588,
     /* 459386 */     GIR_EraseRootFromParent_Done,
     /* 459387 */   // Label 6415: @459387
     /* 459387 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(459522), // Rule ID 12591 //
     /* 459392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 459395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 459399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459439 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459444 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459449 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459476 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 459479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 459486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 459491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 459496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 459501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459520 */     GIR_RootConstrainSelectedInstOperands,
     /* 459521 */     // GIR_Coverage, 12591,
     /* 459521 */     GIR_EraseRootFromParent_Done,
     /* 459522 */   // Label 6416: @459522
     /* 459522 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(459657), // Rule ID 12592 //
     /* 459527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 459530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 459534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459574 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459579 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459588 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459611 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 459614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 459621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 459626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 459631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 459636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459655 */     GIR_RootConstrainSelectedInstOperands,
     /* 459656 */     // GIR_Coverage, 12592,
     /* 459656 */     GIR_EraseRootFromParent_Done,
     /* 459657 */   // Label 6417: @459657
     /* 459657 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(459792), // Rule ID 13067 //
     /* 459662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 459665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 459669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459709 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459714 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459732 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459746 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 459749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 459756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 459761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 459766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 459771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459790 */     GIR_RootConstrainSelectedInstOperands,
     /* 459791 */     // GIR_Coverage, 13067,
     /* 459791 */     GIR_EraseRootFromParent_Done,
     /* 459792 */   // Label 6418: @459792
     /* 459792 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(459927), // Rule ID 13068 //
     /* 459797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 459800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 459804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459844 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459849 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459849 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459881 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 459884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 459891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 459896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 459901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 459906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459925 */     GIR_RootConstrainSelectedInstOperands,
     /* 459926 */     // GIR_Coverage, 13068,
     /* 459926 */     GIR_EraseRootFromParent_Done,
     /* 459927 */   // Label 6419: @459927
     /* 459927 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(460062), // Rule ID 13071 //
     /* 459932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 459935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 459939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 459963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459979 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459984 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459989 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460016 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 460019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 460026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 460031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 460036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 460041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460060 */     GIR_RootConstrainSelectedInstOperands,
     /* 460061 */     // GIR_Coverage, 13071,
     /* 460061 */     GIR_EraseRootFromParent_Done,
     /* 460062 */   // Label 6420: @460062
     /* 460062 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(460197), // Rule ID 13072 //
     /* 460067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 460070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 460114 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460119 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460124 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460151 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 460154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 460161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 460166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 460171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 460176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460195 */     GIR_RootConstrainSelectedInstOperands,
     /* 460196 */     // GIR_Coverage, 13072,
     /* 460196 */     GIR_EraseRootFromParent_Done,
     /* 460197 */   // Label 6421: @460197
     /* 460197 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(460332), // Rule ID 12092 //
     /* 460202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 460205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 460249 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460254 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460286 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 460289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 460296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 460301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 460306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 460311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460330 */     GIR_RootConstrainSelectedInstOperands,
     /* 460331 */     // GIR_Coverage, 12092,
     /* 460331 */     GIR_EraseRootFromParent_Done,
     /* 460332 */   // Label 6422: @460332
     /* 460332 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(460467), // Rule ID 12093 //
     /* 460337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 460340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 460384 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460389 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460394 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460421 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 460424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 460431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 460436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 460441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 460446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460465 */     GIR_RootConstrainSelectedInstOperands,
     /* 460466 */     // GIR_Coverage, 12093,
     /* 460466 */     GIR_EraseRootFromParent_Done,
     /* 460467 */   // Label 6423: @460467
     /* 460467 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(460602), // Rule ID 12096 //
     /* 460472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 460475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 460519 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460524 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460556 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 460559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 460566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 460571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 460576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 460581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460600 */     GIR_RootConstrainSelectedInstOperands,
     /* 460601 */     // GIR_Coverage, 12096,
     /* 460601 */     GIR_EraseRootFromParent_Done,
     /* 460602 */   // Label 6424: @460602
     /* 460602 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(460737), // Rule ID 12097 //
     /* 460607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 460610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 460654 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460659 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460659 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460664 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460691 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 460694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 460701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 460706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 460711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 460716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460735 */     GIR_RootConstrainSelectedInstOperands,
     /* 460736 */     // GIR_Coverage, 12097,
     /* 460736 */     GIR_EraseRootFromParent_Done,
     /* 460737 */   // Label 6425: @460737
     /* 460737 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(460872), // Rule ID 12572 //
     /* 460742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 460745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 460749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 460789 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460794 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460826 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 460829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 460836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 460841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 460846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 460851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460870 */     GIR_RootConstrainSelectedInstOperands,
     /* 460871 */     // GIR_Coverage, 12572,
     /* 460871 */     GIR_EraseRootFromParent_Done,
     /* 460872 */   // Label 6426: @460872
     /* 460872 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(461007), // Rule ID 12573 //
     /* 460877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 460880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 460884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 460908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 460920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 460924 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460929 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460961 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 460964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 460971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 460976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 460981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 460986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461005 */     GIR_RootConstrainSelectedInstOperands,
     /* 461006 */     // GIR_Coverage, 12573,
     /* 461006 */     GIR_EraseRootFromParent_Done,
     /* 461007 */   // Label 6427: @461007
     /* 461007 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(461142), // Rule ID 12576 //
     /* 461012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 461015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 461019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 461055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461059 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461064 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461069 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461096 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 461099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 461106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 461111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 461116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 461121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461140 */     GIR_RootConstrainSelectedInstOperands,
     /* 461141 */     // GIR_Coverage, 12576,
     /* 461141 */     GIR_EraseRootFromParent_Done,
     /* 461142 */   // Label 6428: @461142
     /* 461142 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(461277), // Rule ID 12577 //
     /* 461147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 461150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 461154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 461190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461194 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461199 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461231 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 461234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 461241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 461246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 461251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 461256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461275 */     GIR_RootConstrainSelectedInstOperands,
     /* 461276 */     // GIR_Coverage, 12577,
     /* 461276 */     GIR_EraseRootFromParent_Done,
     /* 461277 */   // Label 6429: @461277
     /* 461277 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(461412), // Rule ID 13052 //
     /* 461282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 461285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 461325 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461329 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461329 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461334 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461334 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461366 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 461369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 461376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 461381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 461386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 461391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461410 */     GIR_RootConstrainSelectedInstOperands,
     /* 461411 */     // GIR_Coverage, 13052,
     /* 461411 */     GIR_EraseRootFromParent_Done,
     /* 461412 */   // Label 6430: @461412
     /* 461412 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(461547), // Rule ID 13053 //
     /* 461417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 461420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 461460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461464 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461464 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461469 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461474 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461501 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 461504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 461511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 461516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 461521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 461526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461545 */     GIR_RootConstrainSelectedInstOperands,
     /* 461546 */     // GIR_Coverage, 13053,
     /* 461546 */     GIR_EraseRootFromParent_Done,
     /* 461547 */   // Label 6431: @461547
     /* 461547 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(461682), // Rule ID 13056 //
     /* 461552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 461555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 461595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461599 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461604 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461636 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 461639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 461646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 461651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 461656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 461661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461680 */     GIR_RootConstrainSelectedInstOperands,
     /* 461681 */     // GIR_Coverage, 13056,
     /* 461681 */     GIR_EraseRootFromParent_Done,
     /* 461682 */   // Label 6432: @461682
     /* 461682 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(461817), // Rule ID 13057 //
     /* 461687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 461690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 461730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461734 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461739 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461744 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461771 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 461774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 461781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 461786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 461791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 461796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461815 */     GIR_RootConstrainSelectedInstOperands,
     /* 461816 */     // GIR_Coverage, 13057,
     /* 461816 */     GIR_EraseRootFromParent_Done,
     /* 461817 */   // Label 6433: @461817
     /* 461817 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(461952), // Rule ID 7630 //
     /* 461822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 461825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 461865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 461869 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461874 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461906 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 461909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 461916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 461921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 461926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 461931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461950 */     GIR_RootConstrainSelectedInstOperands,
     /* 461951 */     // GIR_Coverage, 7630,
     /* 461951 */     GIR_EraseRootFromParent_Done,
     /* 461952 */   // Label 6434: @461952
     /* 461952 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(462087), // Rule ID 7662 //
     /* 461957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 461960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 461964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 461988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462004 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462009 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462014 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462034 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462041 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 462044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 462051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 462056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 462061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 462066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462085 */     GIR_RootConstrainSelectedInstOperands,
     /* 462086 */     // GIR_Coverage, 7662,
     /* 462086 */     GIR_EraseRootFromParent_Done,
     /* 462087 */   // Label 6435: @462087
     /* 462087 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(462222), // Rule ID 7694 //
     /* 462092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 462095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 462099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462139 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462139 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462144 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462176 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 462179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 462186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 462191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 462196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 462201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462220 */     GIR_RootConstrainSelectedInstOperands,
     /* 462221 */     // GIR_Coverage, 7694,
     /* 462221 */     GIR_EraseRootFromParent_Done,
     /* 462222 */   // Label 6436: @462222
     /* 462222 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(462357), // Rule ID 12106 //
     /* 462227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 462230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 462234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462274 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462279 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462311 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 462314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 462321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 462326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 462331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 462336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462355 */     GIR_RootConstrainSelectedInstOperands,
     /* 462356 */     // GIR_Coverage, 12106,
     /* 462356 */     GIR_EraseRootFromParent_Done,
     /* 462357 */   // Label 6437: @462357
     /* 462357 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(462492), // Rule ID 12109 //
     /* 462362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 462365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 462369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462409 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462414 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462446 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 462449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 462456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 462461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 462466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 462471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462490 */     GIR_RootConstrainSelectedInstOperands,
     /* 462491 */     // GIR_Coverage, 12109,
     /* 462491 */     GIR_EraseRootFromParent_Done,
     /* 462492 */   // Label 6438: @462492
     /* 462492 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(462627), // Rule ID 12110 //
     /* 462497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 462500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 462504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462544 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462549 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462554 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462581 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 462584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 462591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 462596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 462601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 462606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462625 */     GIR_RootConstrainSelectedInstOperands,
     /* 462626 */     // GIR_Coverage, 12110,
     /* 462626 */     GIR_EraseRootFromParent_Done,
     /* 462627 */   // Label 6439: @462627
     /* 462627 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(462762), // Rule ID 12586 //
     /* 462632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 462635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 462639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462679 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462684 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462716 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 462719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 462726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 462731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 462736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 462741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462760 */     GIR_RootConstrainSelectedInstOperands,
     /* 462761 */     // GIR_Coverage, 12586,
     /* 462761 */     GIR_EraseRootFromParent_Done,
     /* 462762 */   // Label 6440: @462762
     /* 462762 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(462897), // Rule ID 12589 //
     /* 462767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 462770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 462774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462814 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462814 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462819 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462819 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462824 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462830 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462851 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 462854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 462861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 462866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 462871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 462876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462895 */     GIR_RootConstrainSelectedInstOperands,
     /* 462896 */     // GIR_Coverage, 12589,
     /* 462896 */     GIR_EraseRootFromParent_Done,
     /* 462897 */   // Label 6441: @462897
     /* 462897 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(463032), // Rule ID 12590 //
     /* 462902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 462905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 462909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 462933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 462949 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462954 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462959 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462986 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 462989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 462996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 463001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 463006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 463011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463030 */     GIR_RootConstrainSelectedInstOperands,
     /* 463031 */     // GIR_Coverage, 12590,
     /* 463031 */     GIR_EraseRootFromParent_Done,
     /* 463032 */   // Label 6442: @463032
     /* 463032 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(463167), // Rule ID 13066 //
     /* 463037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 463040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463084 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463089 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463121 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 463124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 463131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 463136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 463141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 463146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463165 */     GIR_RootConstrainSelectedInstOperands,
     /* 463166 */     // GIR_Coverage, 13066,
     /* 463166 */     GIR_EraseRootFromParent_Done,
     /* 463167 */   // Label 6443: @463167
     /* 463167 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(463302), // Rule ID 13069 //
     /* 463172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 463175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463219 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463224 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463256 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 463259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 463266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 463271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 463276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 463281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463300 */     GIR_RootConstrainSelectedInstOperands,
     /* 463301 */     // GIR_Coverage, 13069,
     /* 463301 */     GIR_EraseRootFromParent_Done,
     /* 463302 */   // Label 6444: @463302
     /* 463302 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(463437), // Rule ID 13070 //
     /* 463307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 463310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463354 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463359 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463391 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 463394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 463401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 463406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 463411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 463416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463435 */     GIR_RootConstrainSelectedInstOperands,
     /* 463436 */     // GIR_Coverage, 13070,
     /* 463436 */     GIR_EraseRootFromParent_Done,
     /* 463437 */   // Label 6445: @463437
     /* 463437 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(463572), // Rule ID 7629 //
     /* 463442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 463445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 463489 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463494 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463526 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 463529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 463536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 463541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 463546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 463551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463570 */     GIR_RootConstrainSelectedInstOperands,
     /* 463571 */     // GIR_Coverage, 7629,
     /* 463571 */     GIR_EraseRootFromParent_Done,
     /* 463572 */   // Label 6446: @463572
     /* 463572 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(463707), // Rule ID 7661 //
     /* 463577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 463580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 463584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 463624 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463629 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463634 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463661 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 463664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 463671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 463676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 463681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 463686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463705 */     GIR_RootConstrainSelectedInstOperands,
     /* 463706 */     // GIR_Coverage, 7661,
     /* 463706 */     GIR_EraseRootFromParent_Done,
     /* 463707 */   // Label 6447: @463707
     /* 463707 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(463842), // Rule ID 7693 //
     /* 463712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 463715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 463759 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463764 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463769 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463796 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 463799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 463806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 463811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 463816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 463821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463840 */     GIR_RootConstrainSelectedInstOperands,
     /* 463841 */     // GIR_Coverage, 7693,
     /* 463841 */     GIR_EraseRootFromParent_Done,
     /* 463842 */   // Label 6448: @463842
     /* 463842 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(463977), // Rule ID 12091 //
     /* 463847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 463850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 463890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 463894 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463899 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463931 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 463934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 463941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 463946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 463951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 463956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463975 */     GIR_RootConstrainSelectedInstOperands,
     /* 463976 */     // GIR_Coverage, 12091,
     /* 463976 */     GIR_EraseRootFromParent_Done,
     /* 463977 */   // Label 6449: @463977
     /* 463977 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(464112), // Rule ID 12094 //
     /* 463982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 463985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464029 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464034 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464066 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 464069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 464076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 464081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 464086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 464091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464110 */     GIR_RootConstrainSelectedInstOperands,
     /* 464111 */     // GIR_Coverage, 12094,
     /* 464111 */     GIR_EraseRootFromParent_Done,
     /* 464112 */   // Label 6450: @464112
     /* 464112 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(464247), // Rule ID 12095 //
     /* 464117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 464120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464164 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464169 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464201 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 464204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 464211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 464216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 464221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 464226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464245 */     GIR_RootConstrainSelectedInstOperands,
     /* 464246 */     // GIR_Coverage, 12095,
     /* 464246 */     GIR_EraseRootFromParent_Done,
     /* 464247 */   // Label 6451: @464247
     /* 464247 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(464382), // Rule ID 12571 //
     /* 464252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 464255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 464259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464299 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464299 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464304 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464304 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464336 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 464339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 464346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 464351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 464356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 464361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464380 */     GIR_RootConstrainSelectedInstOperands,
     /* 464381 */     // GIR_Coverage, 12571,
     /* 464381 */     GIR_EraseRootFromParent_Done,
     /* 464382 */   // Label 6452: @464382
     /* 464382 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(464517), // Rule ID 12574 //
     /* 464387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 464390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 464394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464434 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464439 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464471 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 464474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 464481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 464486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 464491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 464496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464515 */     GIR_RootConstrainSelectedInstOperands,
     /* 464516 */     // GIR_Coverage, 12574,
     /* 464516 */     GIR_EraseRootFromParent_Done,
     /* 464517 */   // Label 6453: @464517
     /* 464517 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(464652), // Rule ID 12575 //
     /* 464522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 464525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 464529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464569 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464574 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464606 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 464609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 464616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 464621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 464626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 464631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464650 */     GIR_RootConstrainSelectedInstOperands,
     /* 464651 */     // GIR_Coverage, 12575,
     /* 464651 */     GIR_EraseRootFromParent_Done,
     /* 464652 */   // Label 6454: @464652
     /* 464652 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(464787), // Rule ID 13051 //
     /* 464657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 464660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464704 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464709 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464718 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464741 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 464744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 464751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 464756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 464761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 464766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464785 */     GIR_RootConstrainSelectedInstOperands,
     /* 464786 */     // GIR_Coverage, 13051,
     /* 464786 */     GIR_EraseRootFromParent_Done,
     /* 464787 */   // Label 6455: @464787
     /* 464787 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(464922), // Rule ID 13054 //
     /* 464792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 464795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464839 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464844 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464876 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 464879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 464886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 464891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 464896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 464901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464920 */     GIR_RootConstrainSelectedInstOperands,
     /* 464921 */     // GIR_Coverage, 13054,
     /* 464921 */     GIR_EraseRootFromParent_Done,
     /* 464922 */   // Label 6456: @464922
     /* 464922 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(465057), // Rule ID 13055 //
     /* 464927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 464930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 464970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464974 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464979 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464984 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465011 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 465014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 465021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 465026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 465031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 465036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 465041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 465046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465055 */     GIR_RootConstrainSelectedInstOperands,
     /* 465056 */     // GIR_Coverage, 13055,
     /* 465056 */     GIR_EraseRootFromParent_Done,
     /* 465057 */   // Label 6457: @465057
     /* 465057 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(465192), // Rule ID 12147 //
     /* 465062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 465065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 465089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 465093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465101 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 465105 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465109 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 465114 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 465119 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465146 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 465149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 465156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 465161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 465166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 465171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 465176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 465181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465190 */     GIR_RootConstrainSelectedInstOperands,
     /* 465191 */     // GIR_Coverage, 12147,
     /* 465191 */     GIR_EraseRootFromParent_Done,
     /* 465192 */   // Label 6458: @465192
     /* 465192 */   GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(465327), // Rule ID 12148 //
     /* 465197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 465200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 465224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 465228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 465240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465244 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 465249 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 465254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465281 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 465284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 465291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 465296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 465301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 465306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 465311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 465316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465325 */     GIR_RootConstrainSelectedInstOperands,
     /* 465326 */     // GIR_Coverage, 12148,
     /* 465326 */     GIR_EraseRootFromParent_Done,
     /* 465327 */   // Label 6459: @465327
     /* 465327 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(465462), // Rule ID 12149 //
     /* 465332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 465335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 465359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 465363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 465375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465379 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 465384 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 465389 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465416 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 465419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 465426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 465431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 465436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 465441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 465446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 465451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465460 */     GIR_RootConstrainSelectedInstOperands,
     /* 465461 */     // GIR_Coverage, 12149,
     /* 465461 */     GIR_EraseRootFromParent_Done,
     /* 465462 */   // Label 6460: @465462
     /* 465462 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(465597), // Rule ID 12150 //
     /* 465467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 465470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 465494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 465498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 465510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465514 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 465519 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 465524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465551 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 465554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 465561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 465566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 465571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 465576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 465581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 465586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465595 */     GIR_RootConstrainSelectedInstOperands,
     /* 465596 */     // GIR_Coverage, 12150,
     /* 465596 */     GIR_EraseRootFromParent_Done,
     /* 465597 */   // Label 6461: @465597
     /* 465597 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(465732), // Rule ID 12627 //
     /* 465602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 465605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 465609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 465629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 465633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 465645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465649 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 465654 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 465659 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465663 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465679 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465686 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 465689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 465696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 465701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 465706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 465711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 465716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 465721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465730 */     GIR_RootConstrainSelectedInstOperands,
     /* 465731 */     // GIR_Coverage, 12627,
     /* 465731 */     GIR_EraseRootFromParent_Done,
     /* 465732 */   // Label 6462: @465732
     /* 465732 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(465867), // Rule ID 12628 //
     /* 465737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 465740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 465744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 465764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 465768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 465780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465784 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465784 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 465789 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 465794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465821 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 465824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 465831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 465836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 465841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 465846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 465851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 465856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465865 */     GIR_RootConstrainSelectedInstOperands,
     /* 465866 */     // GIR_Coverage, 12628,
     /* 465866 */     GIR_EraseRootFromParent_Done,
     /* 465867 */   // Label 6463: @465867
     /* 465867 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(466002), // Rule ID 12629 //
     /* 465872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 465875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 465879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 465899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 465903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 465915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465919 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 465924 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 465929 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465956 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 465959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 465966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 465971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 465976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 465981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 465986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 465991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466000 */     GIR_RootConstrainSelectedInstOperands,
     /* 466001 */     // GIR_Coverage, 12629,
     /* 466001 */     GIR_EraseRootFromParent_Done,
     /* 466002 */   // Label 6464: @466002
     /* 466002 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(466137), // Rule ID 12630 //
     /* 466007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 466010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 466014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466054 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466059 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466064 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466091 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 466094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 466101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 466106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 466111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 466116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466135 */     GIR_RootConstrainSelectedInstOperands,
     /* 466136 */     // GIR_Coverage, 12630,
     /* 466136 */     GIR_EraseRootFromParent_Done,
     /* 466137 */   // Label 6465: @466137
     /* 466137 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(466272), // Rule ID 13107 //
     /* 466142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 466145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466189 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466194 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466199 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466203 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466226 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 466229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 466236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 466241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 466246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 466251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466270 */     GIR_RootConstrainSelectedInstOperands,
     /* 466271 */     // GIR_Coverage, 13107,
     /* 466271 */     GIR_EraseRootFromParent_Done,
     /* 466272 */   // Label 6466: @466272
     /* 466272 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(466407), // Rule ID 13108 //
     /* 466277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 466280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466324 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466329 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466329 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466354 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466361 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 466364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 466371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 466376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 466381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 466386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466405 */     GIR_RootConstrainSelectedInstOperands,
     /* 466406 */     // GIR_Coverage, 13108,
     /* 466406 */     GIR_EraseRootFromParent_Done,
     /* 466407 */   // Label 6467: @466407
     /* 466407 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(466542), // Rule ID 13109 //
     /* 466412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 466415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466447 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466451 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466455 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466459 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466464 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466464 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466469 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466489 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466496 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 466499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 466506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 466511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 466516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 466521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466540 */     GIR_RootConstrainSelectedInstOperands,
     /* 466541 */     // GIR_Coverage, 13109,
     /* 466541 */     GIR_EraseRootFromParent_Done,
     /* 466542 */   // Label 6468: @466542
     /* 466542 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(466677), // Rule ID 13110 //
     /* 466547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 466550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466594 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466594 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466599 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466604 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466608 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466624 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466631 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 466634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 466641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 466646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 466651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 466656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466675 */     GIR_RootConstrainSelectedInstOperands,
     /* 466676 */     // GIR_Coverage, 13110,
     /* 466676 */     GIR_EraseRootFromParent_Done,
     /* 466677 */   // Label 6469: @466677
     /* 466677 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(466812), // Rule ID 12087 //
     /* 466682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 466685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 466729 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466734 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466766 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 466769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 466776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 466781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 466786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 466791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466810 */     GIR_RootConstrainSelectedInstOperands,
     /* 466811 */     // GIR_Coverage, 12087,
     /* 466811 */     GIR_EraseRootFromParent_Done,
     /* 466812 */   // Label 6470: @466812
     /* 466812 */   GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(466947), // Rule ID 12088 //
     /* 466817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 466820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 466864 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 466869 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 466874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466901 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 466904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 466911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 466916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 466921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 466926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 466931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 466936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466945 */     GIR_RootConstrainSelectedInstOperands,
     /* 466946 */     // GIR_Coverage, 12088,
     /* 466946 */     GIR_EraseRootFromParent_Done,
     /* 466947 */   // Label 6471: @466947
     /* 466947 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(467082), // Rule ID 12089 //
     /* 466952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 466955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 466979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 466995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 466999 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467004 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467036 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 467039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 467046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 467051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 467056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 467061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467080 */     GIR_RootConstrainSelectedInstOperands,
     /* 467081 */     // GIR_Coverage, 12089,
     /* 467081 */     GIR_EraseRootFromParent_Done,
     /* 467082 */   // Label 6472: @467082
     /* 467082 */   GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(467217), // Rule ID 12090 //
     /* 467087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 467090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 467094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467134 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467139 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467139 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467144 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467164 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467171 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 467174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 467181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 467186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 467191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 467196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467215 */     GIR_RootConstrainSelectedInstOperands,
     /* 467216 */     // GIR_Coverage, 12090,
     /* 467216 */     GIR_EraseRootFromParent_Done,
     /* 467217 */   // Label 6473: @467217
     /* 467217 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(467352), // Rule ID 12567 //
     /* 467222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 467225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 467229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467269 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467269 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467274 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467279 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467299 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467306 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 467309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 467316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 467321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 467326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 467331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467350 */     GIR_RootConstrainSelectedInstOperands,
     /* 467351 */     // GIR_Coverage, 12567,
     /* 467351 */     GIR_EraseRootFromParent_Done,
     /* 467352 */   // Label 6474: @467352
     /* 467352 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(467487), // Rule ID 12568 //
     /* 467357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 467360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 467364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467404 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467409 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467441 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 467444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 467451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 467456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 467461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 467466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467485 */     GIR_RootConstrainSelectedInstOperands,
     /* 467486 */     // GIR_Coverage, 12568,
     /* 467486 */     GIR_EraseRootFromParent_Done,
     /* 467487 */   // Label 6475: @467487
     /* 467487 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(467622), // Rule ID 12569 //
     /* 467492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 467495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 467499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467539 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467544 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467562 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467569 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467576 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 467579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 467586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 467591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 467596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 467601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467620 */     GIR_RootConstrainSelectedInstOperands,
     /* 467621 */     // GIR_Coverage, 12569,
     /* 467621 */     GIR_EraseRootFromParent_Done,
     /* 467622 */   // Label 6476: @467622
     /* 467622 */   GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(467757), // Rule ID 12570 //
     /* 467627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 467630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 467634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467674 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467679 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467711 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 467714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 467721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 467726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 467731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 467736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467755 */     GIR_RootConstrainSelectedInstOperands,
     /* 467756 */     // GIR_Coverage, 12570,
     /* 467756 */     GIR_EraseRootFromParent_Done,
     /* 467757 */   // Label 6477: @467757
     /* 467757 */   GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(467892), // Rule ID 13047 //
     /* 467762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 467765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 467769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467809 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467814 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467814 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467846 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 467849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 467856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 467861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 467866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 467871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 467876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 467881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467890 */     GIR_RootConstrainSelectedInstOperands,
     /* 467891 */     // GIR_Coverage, 13047,
     /* 467891 */     GIR_EraseRootFromParent_Done,
     /* 467892 */   // Label 6478: @467892
     /* 467892 */   GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(468027), // Rule ID 13048 //
     /* 467897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 467900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 467904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 467924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 467940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467944 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467944 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 467949 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 467954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467974 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467981 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 467984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 467991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 467996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 468001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 468006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468025 */     GIR_RootConstrainSelectedInstOperands,
     /* 468026 */     // GIR_Coverage, 13048,
     /* 468026 */     GIR_EraseRootFromParent_Done,
     /* 468027 */   // Label 6479: @468027
     /* 468027 */   GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(468162), // Rule ID 13049 //
     /* 468032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 468035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 468063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468079 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468084 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468116 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 468119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 468126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 468131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 468136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 468141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468160 */     GIR_RootConstrainSelectedInstOperands,
     /* 468161 */     // GIR_Coverage, 13049,
     /* 468161 */     GIR_EraseRootFromParent_Done,
     /* 468162 */   // Label 6480: @468162
     /* 468162 */   GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(468297), // Rule ID 13050 //
     /* 468167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 468170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 468198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468214 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468214 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468219 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468237 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468251 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 468254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 468261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 468266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 468271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 468276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468295 */     GIR_RootConstrainSelectedInstOperands,
     /* 468296 */     // GIR_Coverage, 13050,
     /* 468296 */     GIR_EraseRootFromParent_Done,
     /* 468297 */   // Label 6481: @468297
     /* 468297 */   GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(468432), // Rule ID 12132 //
     /* 468302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 468305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468349 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468354 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468359 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468386 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 468389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 468396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 468401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 468406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 468411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468430 */     GIR_RootConstrainSelectedInstOperands,
     /* 468431 */     // GIR_Coverage, 12132,
     /* 468431 */     GIR_EraseRootFromParent_Done,
     /* 468432 */   // Label 6482: @468432
     /* 468432 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(468567), // Rule ID 12133 //
     /* 468437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 468440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468484 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468489 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468521 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 468524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 468531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 468536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 468541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 468546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468565 */     GIR_RootConstrainSelectedInstOperands,
     /* 468566 */     // GIR_Coverage, 12133,
     /* 468566 */     GIR_EraseRootFromParent_Done,
     /* 468567 */   // Label 6483: @468567
     /* 468567 */   GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(468702), // Rule ID 12134 //
     /* 468572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 468575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468619 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468624 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468629 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468635 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468649 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468656 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 468659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 468666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 468671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 468676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 468681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468700 */     GIR_RootConstrainSelectedInstOperands,
     /* 468701 */     // GIR_Coverage, 12134,
     /* 468701 */     GIR_EraseRootFromParent_Done,
     /* 468702 */   // Label 6484: @468702
     /* 468702 */   GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(468837), // Rule ID 12135 //
     /* 468707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 468710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468754 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468754 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468759 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468764 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468777 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468791 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 468794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 468801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 468806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 468811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 468816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468835 */     GIR_RootConstrainSelectedInstOperands,
     /* 468836 */     // GIR_Coverage, 12135,
     /* 468836 */     GIR_EraseRootFromParent_Done,
     /* 468837 */   // Label 6485: @468837
     /* 468837 */   GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(468972), // Rule ID 12612 //
     /* 468842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 468845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 468849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 468869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 468885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468889 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 468894 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 468899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468919 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468926 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 468929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 468936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 468941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 468946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 468951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 468956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 468961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468970 */     GIR_RootConstrainSelectedInstOperands,
     /* 468971 */     // GIR_Coverage, 12612,
     /* 468971 */     GIR_EraseRootFromParent_Done,
     /* 468972 */   // Label 6486: @468972
     /* 468972 */   GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(469107), // Rule ID 12613 //
     /* 468977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 468980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 468984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469024 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469029 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469034 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469061 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 469064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 469071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 469076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 469081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 469086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469105 */     GIR_RootConstrainSelectedInstOperands,
     /* 469106 */     // GIR_Coverage, 12613,
     /* 469106 */     GIR_EraseRootFromParent_Done,
     /* 469107 */   // Label 6487: @469107
     /* 469107 */   GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(469242), // Rule ID 12614 //
     /* 469112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 469115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 469119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469159 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469164 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469169 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469189 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469196 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 469199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 469206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 469211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 469216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 469221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469240 */     GIR_RootConstrainSelectedInstOperands,
     /* 469241 */     // GIR_Coverage, 12614,
     /* 469241 */     GIR_EraseRootFromParent_Done,
     /* 469242 */   // Label 6488: @469242
     /* 469242 */   GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(469377), // Rule ID 12615 //
     /* 469247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 469250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 469254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469282 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469294 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469299 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469299 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469304 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469310 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469331 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 469334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 469341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 469346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 469351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 469356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469375 */     GIR_RootConstrainSelectedInstOperands,
     /* 469376 */     // GIR_Coverage, 12615,
     /* 469376 */     GIR_EraseRootFromParent_Done,
     /* 469377 */   // Label 6489: @469377
     /* 469377 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(469512), // Rule ID 13092 //
     /* 469382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 469385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469429 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469434 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469439 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469466 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 469469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 469476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 469481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 469486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 469491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469510 */     GIR_RootConstrainSelectedInstOperands,
     /* 469511 */     // GIR_Coverage, 13092,
     /* 469511 */     GIR_EraseRootFromParent_Done,
     /* 469512 */   // Label 6490: @469512
     /* 469512 */   GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(469647), // Rule ID 13093 //
     /* 469517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 469520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469564 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469569 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469578 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469580 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469601 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 469604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 469611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 469616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 469621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 469626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469645 */     GIR_RootConstrainSelectedInstOperands,
     /* 469646 */     // GIR_Coverage, 13093,
     /* 469646 */     GIR_EraseRootFromParent_Done,
     /* 469647 */   // Label 6491: @469647
     /* 469647 */   GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(469782), // Rule ID 13094 //
     /* 469652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 469655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469699 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469704 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469736 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 469739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 469746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 469751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 469756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 469761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469780 */     GIR_RootConstrainSelectedInstOperands,
     /* 469781 */     // GIR_Coverage, 13094,
     /* 469781 */     GIR_EraseRootFromParent_Done,
     /* 469782 */   // Label 6492: @469782
     /* 469782 */   GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(469917), // Rule ID 13095 //
     /* 469787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 469790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469834 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469839 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469844 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469871 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 469874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 469881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 469886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 469891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 469896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469915 */     GIR_RootConstrainSelectedInstOperands,
     /* 469916 */     // GIR_Coverage, 13095,
     /* 469916 */     GIR_EraseRootFromParent_Done,
     /* 469917 */   // Label 6493: @469917
     /* 469917 */   GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(470052), // Rule ID 12072 //
     /* 469922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 469925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 469969 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469974 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470006 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 470009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 470016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 470021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 470026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 470031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470050 */     GIR_RootConstrainSelectedInstOperands,
     /* 470051 */     // GIR_Coverage, 12072,
     /* 470051 */     GIR_EraseRootFromParent_Done,
     /* 470052 */   // Label 6494: @470052
     /* 470052 */   GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(470187), // Rule ID 12073 //
     /* 470057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 470060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 470064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 470104 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470109 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470114 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470127 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470134 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470141 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 470144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 470151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 470156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 470161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 470166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470185 */     GIR_RootConstrainSelectedInstOperands,
     /* 470186 */     // GIR_Coverage, 12073,
     /* 470186 */     GIR_EraseRootFromParent_Done,
     /* 470187 */   // Label 6495: @470187
     /* 470187 */   GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(470322), // Rule ID 12074 //
     /* 470192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 470195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 470199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 470239 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470239 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470244 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470249 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470262 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470269 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470276 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 470279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 470286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 470291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 470296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 470301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470320 */     GIR_RootConstrainSelectedInstOperands,
     /* 470321 */     // GIR_Coverage, 12074,
     /* 470321 */     GIR_EraseRootFromParent_Done,
     /* 470322 */   // Label 6496: @470322
     /* 470322 */   GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(470457), // Rule ID 12075 //
     /* 470327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 470330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 470334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 470374 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470379 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470411 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 470414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 470421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 470426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 470431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 470436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470455 */     GIR_RootConstrainSelectedInstOperands,
     /* 470456 */     // GIR_Coverage, 12075,
     /* 470456 */     GIR_EraseRootFromParent_Done,
     /* 470457 */   // Label 6497: @470457
     /* 470457 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(470592), // Rule ID 12552 //
     /* 470462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 470465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 470469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 470509 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470514 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470519 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470546 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 470549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 470556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 470561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 470566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 470571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470590 */     GIR_RootConstrainSelectedInstOperands,
     /* 470591 */     // GIR_Coverage, 12552,
     /* 470591 */     GIR_EraseRootFromParent_Done,
     /* 470592 */   // Label 6498: @470592
     /* 470592 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(470727), // Rule ID 12553 //
     /* 470597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 470600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 470604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 470644 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470649 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470654 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470681 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 470684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 470691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 470696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 470701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 470706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470725 */     GIR_RootConstrainSelectedInstOperands,
     /* 470726 */     // GIR_Coverage, 12553,
     /* 470726 */     GIR_EraseRootFromParent_Done,
     /* 470727 */   // Label 6499: @470727
     /* 470727 */   GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(470862), // Rule ID 12554 //
     /* 470732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 470735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 470739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 470779 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470784 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470784 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470816 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 470819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 470826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 470831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 470836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 470841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470860 */     GIR_RootConstrainSelectedInstOperands,
     /* 470861 */     // GIR_Coverage, 12554,
     /* 470861 */     GIR_EraseRootFromParent_Done,
     /* 470862 */   // Label 6500: @470862
     /* 470862 */   GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(470997), // Rule ID 12555 //
     /* 470867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 470870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 470874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 470898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 470914 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470914 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470919 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470924 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470951 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 470954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 470961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 470966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 470971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 470976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470995 */     GIR_RootConstrainSelectedInstOperands,
     /* 470996 */     // GIR_Coverage, 12555,
     /* 470996 */     GIR_EraseRootFromParent_Done,
     /* 470997 */   // Label 6501: @470997
     /* 470997 */   GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(471132), // Rule ID 13032 //
     /* 471002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 471005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 471033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471049 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471054 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471059 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471072 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471086 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 471089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 471096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 471101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 471106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 471111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471130 */     GIR_RootConstrainSelectedInstOperands,
     /* 471131 */     // GIR_Coverage, 13032,
     /* 471131 */     GIR_EraseRootFromParent_Done,
     /* 471132 */   // Label 6502: @471132
     /* 471132 */   GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(471267), // Rule ID 13033 //
     /* 471137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 471140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 471168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471184 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471189 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471194 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471221 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 471224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 471231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 471236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 471241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 471246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471265 */     GIR_RootConstrainSelectedInstOperands,
     /* 471266 */     // GIR_Coverage, 13033,
     /* 471266 */     GIR_EraseRootFromParent_Done,
     /* 471267 */   // Label 6503: @471267
     /* 471267 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(471402), // Rule ID 13034 //
     /* 471272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 471275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 471303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471319 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471324 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471356 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 471359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 471366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 471371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 471376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 471381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471400 */     GIR_RootConstrainSelectedInstOperands,
     /* 471401 */     // GIR_Coverage, 13034,
     /* 471401 */     GIR_EraseRootFromParent_Done,
     /* 471402 */   // Label 6504: @471402
     /* 471402 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(471537), // Rule ID 13035 //
     /* 471407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 471410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 471438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471454 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471459 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471464 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471484 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471491 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 471494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 471501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 471506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 471511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 471516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471535 */     GIR_RootConstrainSelectedInstOperands,
     /* 471536 */     // GIR_Coverage, 13035,
     /* 471536 */     GIR_EraseRootFromParent_Done,
     /* 471537 */   // Label 6505: @471537
     /* 471537 */   GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(471672), // Rule ID 12143 //
     /* 471542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 471545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 471569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 471573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471589 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471594 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471594 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471599 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471619 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471626 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 471629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 471636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 471641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 471646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 471651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 471656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 471661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471670 */     GIR_RootConstrainSelectedInstOperands,
     /* 471671 */     // GIR_Coverage, 12143,
     /* 471671 */     GIR_EraseRootFromParent_Done,
     /* 471672 */   // Label 6506: @471672
     /* 471672 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(471807), // Rule ID 12144 //
     /* 471677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 471680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 471704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 471708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471724 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471724 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471729 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471734 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471740 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471747 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471761 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 471764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 471771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 471776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 471781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 471786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 471791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 471796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471805 */     GIR_RootConstrainSelectedInstOperands,
     /* 471806 */     // GIR_Coverage, 12144,
     /* 471806 */     GIR_EraseRootFromParent_Done,
     /* 471807 */   // Label 6507: @471807
     /* 471807 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(471942), // Rule ID 12145 //
     /* 471812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 471815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 471839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 471843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471859 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471864 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471869 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471882 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471896 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 471899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 471906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 471911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 471916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 471921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 471926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 471931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471940 */     GIR_RootConstrainSelectedInstOperands,
     /* 471941 */     // GIR_Coverage, 12145,
     /* 471941 */     GIR_EraseRootFromParent_Done,
     /* 471942 */   // Label 6508: @471942
     /* 471942 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(472077), // Rule ID 12146 //
     /* 471947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 471950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 471974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 471978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471994 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471999 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472004 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472031 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 472034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 472041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 472046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 472051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 472056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472075 */     GIR_RootConstrainSelectedInstOperands,
     /* 472076 */     // GIR_Coverage, 12146,
     /* 472076 */     GIR_EraseRootFromParent_Done,
     /* 472077 */   // Label 6509: @472077
     /* 472077 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(472212), // Rule ID 12623 //
     /* 472082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 472085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 472089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472129 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472134 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472152 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472159 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472166 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 472169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 472176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 472181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 472186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 472191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472210 */     GIR_RootConstrainSelectedInstOperands,
     /* 472211 */     // GIR_Coverage, 12623,
     /* 472211 */     GIR_EraseRootFromParent_Done,
     /* 472212 */   // Label 6510: @472212
     /* 472212 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(472347), // Rule ID 12624 //
     /* 472217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 472220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 472224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472264 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472264 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472269 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472269 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472278 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472294 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472301 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 472304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 472311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 472316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 472321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 472326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472345 */     GIR_RootConstrainSelectedInstOperands,
     /* 472346 */     // GIR_Coverage, 12624,
     /* 472346 */     GIR_EraseRootFromParent_Done,
     /* 472347 */   // Label 6511: @472347
     /* 472347 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(472482), // Rule ID 12625 //
     /* 472352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 472355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 472359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472399 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472399 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472404 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472409 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472422 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472429 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472436 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 472439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 472446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 472451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 472456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 472461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472480 */     GIR_RootConstrainSelectedInstOperands,
     /* 472481 */     // GIR_Coverage, 12625,
     /* 472481 */     GIR_EraseRootFromParent_Done,
     /* 472482 */   // Label 6512: @472482
     /* 472482 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(472617), // Rule ID 12626 //
     /* 472487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 472490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 472494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472534 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472539 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472544 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472557 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472571 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 472574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 472581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 472586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 472591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 472596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472615 */     GIR_RootConstrainSelectedInstOperands,
     /* 472616 */     // GIR_Coverage, 12626,
     /* 472616 */     GIR_EraseRootFromParent_Done,
     /* 472617 */   // Label 6513: @472617
     /* 472617 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(472752), // Rule ID 13103 //
     /* 472622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 472625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 472629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472669 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472674 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472706 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 472709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 472716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 472721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 472726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 472731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472750 */     GIR_RootConstrainSelectedInstOperands,
     /* 472751 */     // GIR_Coverage, 13103,
     /* 472751 */     GIR_EraseRootFromParent_Done,
     /* 472752 */   // Label 6514: @472752
     /* 472752 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(472887), // Rule ID 13104 //
     /* 472757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 472760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 472764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472804 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472809 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472814 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472834 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472841 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 472844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 472851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 472856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 472861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 472866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 472871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 472876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472885 */     GIR_RootConstrainSelectedInstOperands,
     /* 472886 */     // GIR_Coverage, 13104,
     /* 472886 */     GIR_EraseRootFromParent_Done,
     /* 472887 */   // Label 6515: @472887
     /* 472887 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(473022), // Rule ID 13105 //
     /* 472892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 472895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 472899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 472919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472939 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472944 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472944 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472949 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472969 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472976 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 472979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 472986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 472991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 472996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 473001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473020 */     GIR_RootConstrainSelectedInstOperands,
     /* 473021 */     // GIR_Coverage, 13105,
     /* 473021 */     GIR_EraseRootFromParent_Done,
     /* 473022 */   // Label 6516: @473022
     /* 473022 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(473157), // Rule ID 13106 //
     /* 473027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 473030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473074 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473074 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473079 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473084 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473097 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473111 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 473114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 473121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 473126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 473131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 473136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473155 */     GIR_RootConstrainSelectedInstOperands,
     /* 473156 */     // GIR_Coverage, 13106,
     /* 473156 */     GIR_EraseRootFromParent_Done,
     /* 473157 */   // Label 6517: @473157
     /* 473157 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(473292), // Rule ID 12083 //
     /* 473162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 473165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473197 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 473209 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473209 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473214 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473214 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473219 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473232 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473246 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 473249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 473256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 473261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 473266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 473271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473290 */     GIR_RootConstrainSelectedInstOperands,
     /* 473291 */     // GIR_Coverage, 12083,
     /* 473291 */     GIR_EraseRootFromParent_Done,
     /* 473292 */   // Label 6518: @473292
     /* 473292 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(473427), // Rule ID 12084 //
     /* 473297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 473300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 473344 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473349 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473354 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473367 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473374 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473381 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 473384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 473391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 473396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 473401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 473406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473425 */     GIR_RootConstrainSelectedInstOperands,
     /* 473426 */     // GIR_Coverage, 12084,
     /* 473426 */     GIR_EraseRootFromParent_Done,
     /* 473427 */   // Label 6519: @473427
     /* 473427 */   GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(473562), // Rule ID 12085 //
     /* 473432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 473435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 473479 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473484 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473502 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473516 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 473519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 473526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 473531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 473536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 473541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473560 */     GIR_RootConstrainSelectedInstOperands,
     /* 473561 */     // GIR_Coverage, 12085,
     /* 473561 */     GIR_EraseRootFromParent_Done,
     /* 473562 */   // Label 6520: @473562
     /* 473562 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(473697), // Rule ID 12086 //
     /* 473567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 473570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 473614 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473619 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473651 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 473654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 473661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 473666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 473671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 473676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473695 */     GIR_RootConstrainSelectedInstOperands,
     /* 473696 */     // GIR_Coverage, 12086,
     /* 473696 */     GIR_EraseRootFromParent_Done,
     /* 473697 */   // Label 6521: @473697
     /* 473697 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(473832), // Rule ID 12563 //
     /* 473702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 473705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 473709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 473749 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473749 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473754 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473754 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473759 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473779 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473786 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 473789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 473796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 473801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 473806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 473811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473830 */     GIR_RootConstrainSelectedInstOperands,
     /* 473831 */     // GIR_Coverage, 12563,
     /* 473831 */     GIR_EraseRootFromParent_Done,
     /* 473832 */   // Label 6522: @473832
     /* 473832 */   GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(473967), // Rule ID 12564 //
     /* 473837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 473840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 473844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 473868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 473884 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473889 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473894 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473907 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473921 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 473924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 473931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 473936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 473941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 473946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 473951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 473956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473965 */     GIR_RootConstrainSelectedInstOperands,
     /* 473966 */     // GIR_Coverage, 12564,
     /* 473966 */     GIR_EraseRootFromParent_Done,
     /* 473967 */   // Label 6523: @473967
     /* 473967 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(474102), // Rule ID 12565 //
     /* 473972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 473975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 473979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 473999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474019 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474024 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474029 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474049 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474056 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 474059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 474066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 474071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 474076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 474081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474100 */     GIR_RootConstrainSelectedInstOperands,
     /* 474101 */     // GIR_Coverage, 12565,
     /* 474101 */     GIR_EraseRootFromParent_Done,
     /* 474102 */   // Label 6524: @474102
     /* 474102 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(474237), // Rule ID 12566 //
     /* 474107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 474110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 474114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474154 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474159 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474164 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474191 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 474194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 474201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 474206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 474211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 474216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474235 */     GIR_RootConstrainSelectedInstOperands,
     /* 474236 */     // GIR_Coverage, 12566,
     /* 474236 */     GIR_EraseRootFromParent_Done,
     /* 474237 */   // Label 6525: @474237
     /* 474237 */   GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(474372), // Rule ID 13043 //
     /* 474242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 474245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474289 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474294 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474299 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474326 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 474329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 474336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 474341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 474346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 474351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474370 */     GIR_RootConstrainSelectedInstOperands,
     /* 474371 */     // GIR_Coverage, 13043,
     /* 474371 */     GIR_EraseRootFromParent_Done,
     /* 474372 */   // Label 6526: @474372
     /* 474372 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(474507), // Rule ID 13044 //
     /* 474377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 474380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474424 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474429 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474447 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474461 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 474464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 474471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 474476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 474481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 474486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474505 */     GIR_RootConstrainSelectedInstOperands,
     /* 474506 */     // GIR_Coverage, 13044,
     /* 474506 */     GIR_EraseRootFromParent_Done,
     /* 474507 */   // Label 6527: @474507
     /* 474507 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(474642), // Rule ID 13045 //
     /* 474512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 474515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474559 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474564 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474569 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474582 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474589 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474596 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 474599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 474606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 474611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 474616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 474621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474640 */     GIR_RootConstrainSelectedInstOperands,
     /* 474641 */     // GIR_Coverage, 13045,
     /* 474641 */     GIR_EraseRootFromParent_Done,
     /* 474642 */   // Label 6528: @474642
     /* 474642 */   GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(474777), // Rule ID 13046 //
     /* 474647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 474650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 474678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474694 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474699 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474731 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 474734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 474741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 474746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 474751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 474756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474775 */     GIR_RootConstrainSelectedInstOperands,
     /* 474776 */     // GIR_Coverage, 13046,
     /* 474776 */     GIR_EraseRootFromParent_Done,
     /* 474777 */   // Label 6529: @474777
     /* 474777 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(474912), // Rule ID 12128 //
     /* 474782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 474785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 474813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474829 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474834 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474859 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474866 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 474869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 474876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 474881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 474886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 474891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 474896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 474901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474910 */     GIR_RootConstrainSelectedInstOperands,
     /* 474911 */     // GIR_Coverage, 12128,
     /* 474911 */     GIR_EraseRootFromParent_Done,
     /* 474912 */   // Label 6530: @474912
     /* 474912 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(475047), // Rule ID 12129 //
     /* 474917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 474920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 474944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 474948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474964 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474969 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475001 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 475004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 475011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 475016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 475021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 475026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475045 */     GIR_RootConstrainSelectedInstOperands,
     /* 475046 */     // GIR_Coverage, 12129,
     /* 475046 */     GIR_EraseRootFromParent_Done,
     /* 475047 */   // Label 6531: @475047
     /* 475047 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(475182), // Rule ID 12130 //
     /* 475052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 475055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 475059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475099 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475104 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475109 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475129 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475136 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 475139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 475146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 475151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 475156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 475161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475180 */     GIR_RootConstrainSelectedInstOperands,
     /* 475181 */     // GIR_Coverage, 12130,
     /* 475181 */     GIR_EraseRootFromParent_Done,
     /* 475182 */   // Label 6532: @475182
     /* 475182 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(475317), // Rule ID 12131 //
     /* 475187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 475190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 475194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475234 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475234 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475239 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475239 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475257 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475264 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475271 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 475274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 475281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 475286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 475291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 475296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475315 */     GIR_RootConstrainSelectedInstOperands,
     /* 475316 */     // GIR_Coverage, 12131,
     /* 475316 */     GIR_EraseRootFromParent_Done,
     /* 475317 */   // Label 6533: @475317
     /* 475317 */   GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(475452), // Rule ID 12608 //
     /* 475322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 475325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 475329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475369 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475374 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475379 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475383 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475392 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475399 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475406 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 475409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 475416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 475421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 475426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 475431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475450 */     GIR_RootConstrainSelectedInstOperands,
     /* 475451 */     // GIR_Coverage, 12608,
     /* 475451 */     GIR_EraseRootFromParent_Done,
     /* 475452 */   // Label 6534: @475452
     /* 475452 */   GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(475587), // Rule ID 12609 //
     /* 475457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 475460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 475464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475504 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475509 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475514 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475527 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475541 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 475544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 475551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 475556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 475561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 475566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475585 */     GIR_RootConstrainSelectedInstOperands,
     /* 475586 */     // GIR_Coverage, 12609,
     /* 475586 */     GIR_EraseRootFromParent_Done,
     /* 475587 */   // Label 6535: @475587
     /* 475587 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(475722), // Rule ID 12610 //
     /* 475592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 475595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 475599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475639 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475644 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475669 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475676 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 475679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 475686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 475691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 475696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 475701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475720 */     GIR_RootConstrainSelectedInstOperands,
     /* 475721 */     // GIR_Coverage, 12610,
     /* 475721 */     GIR_EraseRootFromParent_Done,
     /* 475722 */   // Label 6536: @475722
     /* 475722 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(475857), // Rule ID 12611 //
     /* 475727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 475730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 475734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475774 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475779 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475811 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 475814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 475821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 475826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 475831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 475836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475855 */     GIR_RootConstrainSelectedInstOperands,
     /* 475856 */     // GIR_Coverage, 12611,
     /* 475856 */     GIR_EraseRootFromParent_Done,
     /* 475857 */   // Label 6537: @475857
     /* 475857 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(475992), // Rule ID 13088 //
     /* 475862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 475865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 475869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475909 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475914 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475914 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475919 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475946 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 475949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 475956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 475961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 475966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 475971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 475976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 475981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475990 */     GIR_RootConstrainSelectedInstOperands,
     /* 475991 */     // GIR_Coverage, 13088,
     /* 475991 */     GIR_EraseRootFromParent_Done,
     /* 475992 */   // Label 6538: @475992
     /* 475992 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(476127), // Rule ID 13089 //
     /* 475997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 476000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476044 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476049 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476054 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476058 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476067 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476074 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476081 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 476084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 476091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 476096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 476101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 476106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476125 */     GIR_RootConstrainSelectedInstOperands,
     /* 476126 */     // GIR_Coverage, 13089,
     /* 476126 */     GIR_EraseRootFromParent_Done,
     /* 476127 */   // Label 6539: @476127
     /* 476127 */   GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(476262), // Rule ID 13090 //
     /* 476132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 476135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476179 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476184 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476202 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476216 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 476219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 476226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 476231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 476236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 476241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476260 */     GIR_RootConstrainSelectedInstOperands,
     /* 476261 */     // GIR_Coverage, 13090,
     /* 476261 */     GIR_EraseRootFromParent_Done,
     /* 476262 */   // Label 6540: @476262
     /* 476262 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(476397), // Rule ID 13091 //
     /* 476267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 476270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476314 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476319 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476328 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476351 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 476354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 476361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 476366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 476371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 476376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476395 */     GIR_RootConstrainSelectedInstOperands,
     /* 476396 */     // GIR_Coverage, 13091,
     /* 476396 */     GIR_EraseRootFromParent_Done,
     /* 476397 */   // Label 6541: @476397
     /* 476397 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(476532), // Rule ID 12068 //
     /* 476402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 476405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 476449 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476454 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476472 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476479 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476486 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 476489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 476496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 476501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 476506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 476511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476530 */     GIR_RootConstrainSelectedInstOperands,
     /* 476531 */     // GIR_Coverage, 12068,
     /* 476531 */     GIR_EraseRootFromParent_Done,
     /* 476532 */   // Label 6542: @476532
     /* 476532 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(476667), // Rule ID 12069 //
     /* 476537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 476540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 476584 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476589 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476614 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476621 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 476624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 476631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 476636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 476641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 476646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476665 */     GIR_RootConstrainSelectedInstOperands,
     /* 476666 */     // GIR_Coverage, 12069,
     /* 476666 */     GIR_EraseRootFromParent_Done,
     /* 476667 */   // Label 6543: @476667
     /* 476667 */   GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(476802), // Rule ID 12070 //
     /* 476672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 476675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 476719 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476724 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476724 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476729 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476733 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476742 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476749 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476756 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 476759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 476766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 476771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 476776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 476781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476800 */     GIR_RootConstrainSelectedInstOperands,
     /* 476801 */     // GIR_Coverage, 12070,
     /* 476801 */     GIR_EraseRootFromParent_Done,
     /* 476802 */   // Label 6544: @476802
     /* 476802 */   GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(476937), // Rule ID 12071 //
     /* 476807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 476810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 476854 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476854 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476859 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476864 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476877 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476884 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476891 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 476894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 476901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 476906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 476911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 476916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476935 */     GIR_RootConstrainSelectedInstOperands,
     /* 476936 */     // GIR_Coverage, 12071,
     /* 476936 */     GIR_EraseRootFromParent_Done,
     /* 476937 */   // Label 6545: @476937
     /* 476937 */   GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(477072), // Rule ID 12548 //
     /* 476942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 476945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 476949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 476973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 476989 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476994 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476999 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477003 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477026 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 477029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 477036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 477041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 477046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 477051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477070 */     GIR_RootConstrainSelectedInstOperands,
     /* 477071 */     // GIR_Coverage, 12548,
     /* 477071 */     GIR_EraseRootFromParent_Done,
     /* 477072 */   // Label 6546: @477072
     /* 477072 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(477207), // Rule ID 12549 //
     /* 477077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 477080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 477084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477124 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477129 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477147 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477161 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 477164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 477171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 477176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 477181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 477186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477205 */     GIR_RootConstrainSelectedInstOperands,
     /* 477206 */     // GIR_Coverage, 12549,
     /* 477206 */     GIR_EraseRootFromParent_Done,
     /* 477207 */   // Label 6547: @477207
     /* 477207 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(477342), // Rule ID 12550 //
     /* 477212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 477215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 477219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477259 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477264 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477264 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477269 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477273 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477282 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477289 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477296 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 477299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 477306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 477311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 477316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 477321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477340 */     GIR_RootConstrainSelectedInstOperands,
     /* 477341 */     // GIR_Coverage, 12550,
     /* 477341 */     GIR_EraseRootFromParent_Done,
     /* 477342 */   // Label 6548: @477342
     /* 477342 */   GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(477477), // Rule ID 12551 //
     /* 477347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 477350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 477354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477382 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477394 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477399 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477399 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477424 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477431 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 477434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 477441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 477446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 477451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 477456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477475 */     GIR_RootConstrainSelectedInstOperands,
     /* 477476 */     // GIR_Coverage, 12551,
     /* 477476 */     GIR_EraseRootFromParent_Done,
     /* 477477 */   // Label 6549: @477477
     /* 477477 */   GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(477612), // Rule ID 13028 //
     /* 477482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 477485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477529 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477534 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477539 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477543 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477552 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477559 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477566 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 477569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 477576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 477581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 477586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 477591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477610 */     GIR_RootConstrainSelectedInstOperands,
     /* 477611 */     // GIR_Coverage, 13028,
     /* 477611 */     GIR_EraseRootFromParent_Done,
     /* 477612 */   // Label 6550: @477612
     /* 477612 */   GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(477747), // Rule ID 13029 //
     /* 477617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 477620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477664 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477669 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477674 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477687 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477701 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 477704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 477711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 477716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 477721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 477726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477745 */     GIR_RootConstrainSelectedInstOperands,
     /* 477746 */     // GIR_Coverage, 13029,
     /* 477746 */     GIR_EraseRootFromParent_Done,
     /* 477747 */   // Label 6551: @477747
     /* 477747 */   GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(477882), // Rule ID 13030 //
     /* 477752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 477755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477799 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477804 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477822 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477836 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 477839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 477846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 477851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 477856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 477861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477880 */     GIR_RootConstrainSelectedInstOperands,
     /* 477881 */     // GIR_Coverage, 13030,
     /* 477881 */     GIR_EraseRootFromParent_Done,
     /* 477882 */   // Label 6552: @477882
     /* 477882 */   GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(478017), // Rule ID 13031 //
     /* 477887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 477890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 477918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477934 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477939 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477944 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477964 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477971 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 477974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 477981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 477986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 477991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 477996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478015 */     GIR_RootConstrainSelectedInstOperands,
     /* 478016 */     // GIR_Coverage, 13031,
     /* 478016 */     GIR_EraseRootFromParent_Done,
     /* 478017 */   // Label 6553: @478017
     /* 478017 */   GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(478152), // Rule ID 12077 //
     /* 478022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 478025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 478029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 478049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 478065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478069 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 478074 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478074 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 478079 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478083 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478099 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478106 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 478109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 478116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 478121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 478126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 478131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478150 */     GIR_RootConstrainSelectedInstOperands,
     /* 478151 */     // GIR_Coverage, 12077,
     /* 478151 */     GIR_EraseRootFromParent_Done,
     /* 478152 */   // Label 6554: @478152
     /* 478152 */   GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(478287), // Rule ID 12078 //
     /* 478157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 478160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 478164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 478184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 478200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478204 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478204 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 478209 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478209 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 478214 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478234 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478241 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 478244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 478251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 478256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 478261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 478266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478285 */     GIR_RootConstrainSelectedInstOperands,
     /* 478286 */     // GIR_Coverage, 12078,
     /* 478286 */     GIR_EraseRootFromParent_Done,
     /* 478287 */   // Label 6555: @478287
     /* 478287 */   GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(478422), // Rule ID 12081 //
     /* 478292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 478295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 478299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 478319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 478335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478339 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 478344 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 478349 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478353 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478376 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 478379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 478386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 478391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 478396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 478401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478420 */     GIR_RootConstrainSelectedInstOperands,
     /* 478421 */     // GIR_Coverage, 12081,
     /* 478421 */     GIR_EraseRootFromParent_Done,
     /* 478422 */   // Label 6556: @478422
     /* 478422 */   GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(478557), // Rule ID 12082 //
     /* 478427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 478430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 478434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 478454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 478470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478474 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 478479 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 478484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478504 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478511 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 478514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 478521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 478526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 478531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 478536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478555 */     GIR_RootConstrainSelectedInstOperands,
     /* 478556 */     // GIR_Coverage, 12082,
     /* 478556 */     GIR_EraseRootFromParent_Done,
     /* 478557 */   // Label 6557: @478557
     /* 478557 */   GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(478692), // Rule ID 12557 //
     /* 478562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 478565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 478569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 478589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 478605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478609 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 478614 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 478619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478646 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 478649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 478656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 478661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 478666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 478671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478690 */     GIR_RootConstrainSelectedInstOperands,
     /* 478691 */     // GIR_Coverage, 12557,
     /* 478691 */     GIR_EraseRootFromParent_Done,
     /* 478692 */   // Label 6558: @478692
     /* 478692 */   GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(478827), // Rule ID 12558 //
     /* 478697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 478700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 478704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 478724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 478740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478744 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 478749 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478749 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 478754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478774 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478781 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 478784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 478791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 478796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 478801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 478806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478825 */     GIR_RootConstrainSelectedInstOperands,
     /* 478826 */     // GIR_Coverage, 12558,
     /* 478826 */     GIR_EraseRootFromParent_Done,
     /* 478827 */   // Label 6559: @478827
     /* 478827 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(478962), // Rule ID 12561 //
     /* 478832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 478835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 478839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 478859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 478875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478879 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478879 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 478884 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 478889 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478909 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478916 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 478919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 478926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 478931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 478936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 478941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478960 */     GIR_RootConstrainSelectedInstOperands,
     /* 478961 */     // GIR_Coverage, 12561,
     /* 478961 */     GIR_EraseRootFromParent_Done,
     /* 478962 */   // Label 6560: @478962
     /* 478962 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(479097), // Rule ID 12562 //
     /* 478967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 478970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 478974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 478994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 479014 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479019 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479051 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 479054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 479061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 479066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 479071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 479076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479095 */     GIR_RootConstrainSelectedInstOperands,
     /* 479096 */     // GIR_Coverage, 12562,
     /* 479096 */     GIR_EraseRootFromParent_Done,
     /* 479097 */   // Label 6561: @479097
     /* 479097 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(479232), // Rule ID 13037 //
     /* 479102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 479105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 479149 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479154 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479186 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 479189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 479196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 479201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 479206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 479211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479230 */     GIR_RootConstrainSelectedInstOperands,
     /* 479231 */     // GIR_Coverage, 13037,
     /* 479231 */     GIR_EraseRootFromParent_Done,
     /* 479232 */   // Label 6562: @479232
     /* 479232 */   GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(479367), // Rule ID 13038 //
     /* 479237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 479240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 479284 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479289 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479321 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 479324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 479331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 479336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 479341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 479346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479365 */     GIR_RootConstrainSelectedInstOperands,
     /* 479366 */     // GIR_Coverage, 13038,
     /* 479366 */     GIR_EraseRootFromParent_Done,
     /* 479367 */   // Label 6563: @479367
     /* 479367 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(479502), // Rule ID 13041 //
     /* 479372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 479375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 479419 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479424 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479429 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479449 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479456 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 479459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 479466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 479471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 479476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 479481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479500 */     GIR_RootConstrainSelectedInstOperands,
     /* 479501 */     // GIR_Coverage, 13041,
     /* 479501 */     GIR_EraseRootFromParent_Done,
     /* 479502 */   // Label 6564: @479502
     /* 479502 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(479637), // Rule ID 13042 //
     /* 479507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 479510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 479554 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479559 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479584 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479591 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 479594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 479601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 479606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 479611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 479616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479635 */     GIR_RootConstrainSelectedInstOperands,
     /* 479636 */     // GIR_Coverage, 13042,
     /* 479636 */     GIR_EraseRootFromParent_Done,
     /* 479637 */   // Label 6565: @479637
     /* 479637 */   GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(479772), // Rule ID 12062 //
     /* 479642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 479645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 479689 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479694 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479699 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479719 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479726 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 479729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 479736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 479741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 479746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 479751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479770 */     GIR_RootConstrainSelectedInstOperands,
     /* 479771 */     // GIR_Coverage, 12062,
     /* 479771 */     GIR_EraseRootFromParent_Done,
     /* 479772 */   // Label 6566: @479772
     /* 479772 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(479907), // Rule ID 12063 //
     /* 479777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 479780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 479824 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479829 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479834 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479861 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 479864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 479871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 479876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 479881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 479886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479905 */     GIR_RootConstrainSelectedInstOperands,
     /* 479906 */     // GIR_Coverage, 12063,
     /* 479906 */     GIR_EraseRootFromParent_Done,
     /* 479907 */   // Label 6567: @479907
     /* 479907 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(480042), // Rule ID 12066 //
     /* 479912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 479915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 479939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 479955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 479959 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 479964 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 479969 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479973 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479996 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 479999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 480006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 480011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 480016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 480021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480040 */     GIR_RootConstrainSelectedInstOperands,
     /* 480041 */     // GIR_Coverage, 12066,
     /* 480041 */     GIR_EraseRootFromParent_Done,
     /* 480042 */   // Label 6568: @480042
     /* 480042 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(480177), // Rule ID 12067 //
     /* 480047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 480050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 480054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480094 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480099 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480131 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 480134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 480141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 480146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 480151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 480156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480175 */     GIR_RootConstrainSelectedInstOperands,
     /* 480176 */     // GIR_Coverage, 12067,
     /* 480176 */     GIR_EraseRootFromParent_Done,
     /* 480177 */   // Label 6569: @480177
     /* 480177 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(480312), // Rule ID 12542 //
     /* 480182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 480185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 480189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480229 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480234 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480234 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480239 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480259 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480266 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 480269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 480276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 480281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 480286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 480291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480310 */     GIR_RootConstrainSelectedInstOperands,
     /* 480311 */     // GIR_Coverage, 12542,
     /* 480311 */     GIR_EraseRootFromParent_Done,
     /* 480312 */   // Label 6570: @480312
     /* 480312 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(480447), // Rule ID 12543 //
     /* 480317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 480320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 480324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480364 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480364 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480369 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480374 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480401 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 480404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 480411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 480416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 480421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 480426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480445 */     GIR_RootConstrainSelectedInstOperands,
     /* 480446 */     // GIR_Coverage, 12543,
     /* 480446 */     GIR_EraseRootFromParent_Done,
     /* 480447 */   // Label 6571: @480447
     /* 480447 */   GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(480582), // Rule ID 12546 //
     /* 480452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 480455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 480459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480499 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480504 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480509 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480513 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480536 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 480539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 480546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 480551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 480556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 480561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480580 */     GIR_RootConstrainSelectedInstOperands,
     /* 480581 */     // GIR_Coverage, 12546,
     /* 480581 */     GIR_EraseRootFromParent_Done,
     /* 480582 */   // Label 6572: @480582
     /* 480582 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(480717), // Rule ID 12547 //
     /* 480587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 480590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 480594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480634 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480639 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480644 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480648 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480671 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 480674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 480681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 480686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 480691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 480696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480715 */     GIR_RootConstrainSelectedInstOperands,
     /* 480716 */     // GIR_Coverage, 12547,
     /* 480716 */     GIR_EraseRootFromParent_Done,
     /* 480717 */   // Label 6573: @480717
     /* 480717 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(480852), // Rule ID 13022 //
     /* 480722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 480725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 480729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480769 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480774 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480806 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 480809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 480816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 480821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 480826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 480831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480850 */     GIR_RootConstrainSelectedInstOperands,
     /* 480851 */     // GIR_Coverage, 13022,
     /* 480851 */     GIR_EraseRootFromParent_Done,
     /* 480852 */   // Label 6574: @480852
     /* 480852 */   GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(480987), // Rule ID 13023 //
     /* 480857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 480860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 480864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 480884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 480900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480904 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 480909 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 480914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480934 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480941 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 480944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 480951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 480956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 480961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 480966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480985 */     GIR_RootConstrainSelectedInstOperands,
     /* 480986 */     // GIR_Coverage, 13023,
     /* 480986 */     GIR_EraseRootFromParent_Done,
     /* 480987 */   // Label 6575: @480987
     /* 480987 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(481122), // Rule ID 13026 //
     /* 480992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 480995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 480999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 481035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 481039 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481044 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481049 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481076 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 481079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 481086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 481091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 481096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 481101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481120 */     GIR_RootConstrainSelectedInstOperands,
     /* 481121 */     // GIR_Coverage, 13026,
     /* 481121 */     GIR_EraseRootFromParent_Done,
     /* 481122 */   // Label 6576: @481122
     /* 481122 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(481257), // Rule ID 13027 //
     /* 481127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 481130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 481170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 481174 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481174 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481179 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481184 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481211 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 481214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 481221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 481226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 481231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 481236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481255 */     GIR_RootConstrainSelectedInstOperands,
     /* 481256 */     // GIR_Coverage, 13027,
     /* 481256 */     GIR_EraseRootFromParent_Done,
     /* 481257 */   // Label 6577: @481257
     /* 481257 */   GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(481392), // Rule ID 7628 //
     /* 481262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 481265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 481305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 481309 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481314 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481319 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481346 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 481349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 481356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 481361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 481366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 481371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481390 */     GIR_RootConstrainSelectedInstOperands,
     /* 481391 */     // GIR_Coverage, 7628,
     /* 481391 */     GIR_EraseRootFromParent_Done,
     /* 481392 */   // Label 6578: @481392
     /* 481392 */   GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(481527), // Rule ID 7660 //
     /* 481397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 481400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 481404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 481440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 481444 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481449 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481454 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481481 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 481484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 481491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 481496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 481501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 481506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481525 */     GIR_RootConstrainSelectedInstOperands,
     /* 481526 */     // GIR_Coverage, 7660,
     /* 481526 */     GIR_EraseRootFromParent_Done,
     /* 481527 */   // Label 6579: @481527
     /* 481527 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(481662), // Rule ID 7692 //
     /* 481532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 481535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 481575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 481579 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481584 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481616 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 481619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 481626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 481631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 481636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 481641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481660 */     GIR_RootConstrainSelectedInstOperands,
     /* 481661 */     // GIR_Coverage, 7692,
     /* 481661 */     GIR_EraseRootFromParent_Done,
     /* 481662 */   // Label 6580: @481662
     /* 481662 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(481797), // Rule ID 12076 //
     /* 481667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 481670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 481710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 481714 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481719 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481724 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481744 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481751 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 481754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 481761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 481766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 481771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 481776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481795 */     GIR_RootConstrainSelectedInstOperands,
     /* 481796 */     // GIR_Coverage, 12076,
     /* 481796 */     GIR_EraseRootFromParent_Done,
     /* 481797 */   // Label 6581: @481797
     /* 481797 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(481932), // Rule ID 12079 //
     /* 481802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 481805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 481845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 481849 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481849 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481854 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481854 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481879 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481886 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 481889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 481896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 481901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 481906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 481911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481930 */     GIR_RootConstrainSelectedInstOperands,
     /* 481931 */     // GIR_Coverage, 12079,
     /* 481931 */     GIR_EraseRootFromParent_Done,
     /* 481932 */   // Label 6582: @481932
     /* 481932 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(482067), // Rule ID 12080 //
     /* 481937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 481940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 481964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 481980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 481984 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 481989 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 481994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482021 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 482024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 482036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 482041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 482046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482065 */     GIR_RootConstrainSelectedInstOperands,
     /* 482066 */     // GIR_Coverage, 12080,
     /* 482066 */     GIR_EraseRootFromParent_Done,
     /* 482067 */   // Label 6583: @482067
     /* 482067 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(482202), // Rule ID 12556 //
     /* 482072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 482075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 482079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482119 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482124 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482156 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 482159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 482166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 482171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 482176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 482181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482200 */     GIR_RootConstrainSelectedInstOperands,
     /* 482201 */     // GIR_Coverage, 12556,
     /* 482201 */     GIR_EraseRootFromParent_Done,
     /* 482202 */   // Label 6584: @482202
     /* 482202 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(482337), // Rule ID 12559 //
     /* 482207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 482210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 482214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482254 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482259 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482264 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482291 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 482294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 482306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 482311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 482316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482335 */     GIR_RootConstrainSelectedInstOperands,
     /* 482336 */     // GIR_Coverage, 12559,
     /* 482336 */     GIR_EraseRootFromParent_Done,
     /* 482337 */   // Label 6585: @482337
     /* 482337 */   GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(482472), // Rule ID 12560 //
     /* 482342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 482345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 482349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482389 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482394 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482426 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 482429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 482441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 482446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 482451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482470 */     GIR_RootConstrainSelectedInstOperands,
     /* 482471 */     // GIR_Coverage, 12560,
     /* 482471 */     GIR_EraseRootFromParent_Done,
     /* 482472 */   // Label 6586: @482472
     /* 482472 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(482607), // Rule ID 13036 //
     /* 482477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 482480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482524 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482529 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482561 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 482564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 482571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 482576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 482581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 482586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482605 */     GIR_RootConstrainSelectedInstOperands,
     /* 482606 */     // GIR_Coverage, 13036,
     /* 482606 */     GIR_EraseRootFromParent_Done,
     /* 482607 */   // Label 6587: @482607
     /* 482607 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(482742), // Rule ID 13039 //
     /* 482612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 482615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482659 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482659 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482664 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482696 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 482699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 482711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 482716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 482721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482740 */     GIR_RootConstrainSelectedInstOperands,
     /* 482741 */     // GIR_Coverage, 13039,
     /* 482741 */     GIR_EraseRootFromParent_Done,
     /* 482742 */   // Label 6588: @482742
     /* 482742 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(482877), // Rule ID 13040 //
     /* 482747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 482750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482794 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482799 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482808 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482831 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 482834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 482846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 482851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 482856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482875 */     GIR_RootConstrainSelectedInstOperands,
     /* 482876 */     // GIR_Coverage, 13040,
     /* 482876 */     GIR_EraseRootFromParent_Done,
     /* 482877 */   // Label 6589: @482877
     /* 482877 */   GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(483012), // Rule ID 7627 //
     /* 482882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 482885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 482925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 482929 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482934 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482966 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 482969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 482976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 482981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 482986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 482991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483010 */     GIR_RootConstrainSelectedInstOperands,
     /* 483011 */     // GIR_Coverage, 7627,
     /* 483011 */     GIR_EraseRootFromParent_Done,
     /* 483012 */   // Label 6590: @483012
     /* 483012 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(483147), // Rule ID 7659 //
     /* 483017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 483020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 483024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 483064 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483069 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483101 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 483104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 483111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 483116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 483121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 483126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483145 */     GIR_RootConstrainSelectedInstOperands,
     /* 483146 */     // GIR_Coverage, 7659,
     /* 483146 */     GIR_EraseRootFromParent_Done,
     /* 483147 */   // Label 6591: @483147
     /* 483147 */   GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(483282), // Rule ID 7691 //
     /* 483152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 483155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 483199 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483204 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483204 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483236 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 483239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 483246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 483251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 483256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 483261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483280 */     GIR_RootConstrainSelectedInstOperands,
     /* 483281 */     // GIR_Coverage, 7691,
     /* 483281 */     GIR_EraseRootFromParent_Done,
     /* 483282 */   // Label 6592: @483282
     /* 483282 */   GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(483417), // Rule ID 12061 //
     /* 483287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 483290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 483334 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483334 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483339 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483344 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483364 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483371 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 483374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 483381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 483386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 483391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 483396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483415 */     GIR_RootConstrainSelectedInstOperands,
     /* 483416 */     // GIR_Coverage, 12061,
     /* 483416 */     GIR_EraseRootFromParent_Done,
     /* 483417 */   // Label 6593: @483417
     /* 483417 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(483552), // Rule ID 12064 //
     /* 483422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 483425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 483469 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483474 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483506 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 483509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 483516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 483521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 483526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 483531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483550 */     GIR_RootConstrainSelectedInstOperands,
     /* 483551 */     // GIR_Coverage, 12064,
     /* 483551 */     GIR_EraseRootFromParent_Done,
     /* 483552 */   // Label 6594: @483552
     /* 483552 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(483687), // Rule ID 12065 //
     /* 483557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 483560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 483604 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483609 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483614 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483641 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 483644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 483651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 483656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 483661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 483666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483685 */     GIR_RootConstrainSelectedInstOperands,
     /* 483686 */     // GIR_Coverage, 12065,
     /* 483686 */     GIR_EraseRootFromParent_Done,
     /* 483687 */   // Label 6595: @483687
     /* 483687 */   GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(483822), // Rule ID 12541 //
     /* 483692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 483695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 483699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 483739 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483744 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483776 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 483779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 483786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 483791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 483796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 483801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483820 */     GIR_RootConstrainSelectedInstOperands,
     /* 483821 */     // GIR_Coverage, 12541,
     /* 483821 */     GIR_EraseRootFromParent_Done,
     /* 483822 */   // Label 6596: @483822
     /* 483822 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(483957), // Rule ID 12544 //
     /* 483827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 483830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 483834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 483870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 483874 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483879 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483879 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483884 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483904 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483911 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 483914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 483921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 483926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 483931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 483936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483955 */     GIR_RootConstrainSelectedInstOperands,
     /* 483956 */     // GIR_Coverage, 12544,
     /* 483956 */     GIR_EraseRootFromParent_Done,
     /* 483957 */   // Label 6597: @483957
     /* 483957 */   GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(484092), // Rule ID 12545 //
     /* 483962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 483965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 483969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 484005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484009 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484014 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484019 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484023 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484046 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 484049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 484056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 484061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 484066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 484071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484090 */     GIR_RootConstrainSelectedInstOperands,
     /* 484091 */     // GIR_Coverage, 12545,
     /* 484091 */     GIR_EraseRootFromParent_Done,
     /* 484092 */   // Label 6598: @484092
     /* 484092 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(484227), // Rule ID 13021 //
     /* 484097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 484100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 484140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484144 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484149 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484181 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 484184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 484191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 484196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 484201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 484206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484225 */     GIR_RootConstrainSelectedInstOperands,
     /* 484226 */     // GIR_Coverage, 13021,
     /* 484226 */     GIR_EraseRootFromParent_Done,
     /* 484227 */   // Label 6599: @484227
     /* 484227 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(484362), // Rule ID 13024 //
     /* 484232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 484235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 484275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484279 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484284 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484316 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 484319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 484326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 484331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 484336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 484341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484360 */     GIR_RootConstrainSelectedInstOperands,
     /* 484361 */     // GIR_Coverage, 13024,
     /* 484361 */     GIR_EraseRootFromParent_Done,
     /* 484362 */   // Label 6600: @484362
     /* 484362 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(484497), // Rule ID 13025 //
     /* 484367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 484370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 484410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484414 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484419 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484451 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 484454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 484461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 484466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 484471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 484476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484495 */     GIR_RootConstrainSelectedInstOperands,
     /* 484496 */     // GIR_Coverage, 13025,
     /* 484496 */     GIR_EraseRootFromParent_Done,
     /* 484497 */   // Label 6601: @484497
     /* 484497 */   GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(484632), // Rule ID 12047 //
     /* 484502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 484505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 484545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 484549 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484554 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484579 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484586 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 484589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 484596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 484601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 484606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 484611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484630 */     GIR_RootConstrainSelectedInstOperands,
     /* 484631 */     // GIR_Coverage, 12047,
     /* 484631 */     GIR_EraseRootFromParent_Done,
     /* 484632 */   // Label 6602: @484632
     /* 484632 */   GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(484767), // Rule ID 12048 //
     /* 484637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 484640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 484680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 484684 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484689 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484714 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484721 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 484724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 484731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 484736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 484741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 484746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484765 */     GIR_RootConstrainSelectedInstOperands,
     /* 484766 */     // GIR_Coverage, 12048,
     /* 484766 */     GIR_EraseRootFromParent_Done,
     /* 484767 */   // Label 6603: @484767
     /* 484767 */   GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(484902), // Rule ID 12051 //
     /* 484772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 484775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484807 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 484815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 484819 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484819 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484824 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484856 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 484859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 484866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 484871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 484876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 484881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484900 */     GIR_RootConstrainSelectedInstOperands,
     /* 484901 */     // GIR_Coverage, 12051,
     /* 484901 */     GIR_EraseRootFromParent_Done,
     /* 484902 */   // Label 6604: @484902
     /* 484902 */   GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(485037), // Rule ID 12052 //
     /* 484907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 484910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 484950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 484954 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484959 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484968 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484991 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 484994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 485001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 485006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 485011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 485016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485035 */     GIR_RootConstrainSelectedInstOperands,
     /* 485036 */     // GIR_Coverage, 12052,
     /* 485036 */     GIR_EraseRootFromParent_Done,
     /* 485037 */   // Label 6605: @485037
     /* 485037 */   GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(485172), // Rule ID 12527 //
     /* 485042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 485045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 485049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485089 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485094 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485126 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 485129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 485136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 485141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 485146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 485151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485170 */     GIR_RootConstrainSelectedInstOperands,
     /* 485171 */     // GIR_Coverage, 12527,
     /* 485171 */     GIR_EraseRootFromParent_Done,
     /* 485172 */   // Label 6606: @485172
     /* 485172 */   GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(485307), // Rule ID 12528 //
     /* 485177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 485180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 485184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485224 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485229 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485234 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485261 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 485264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 485271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 485276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 485281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 485286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485305 */     GIR_RootConstrainSelectedInstOperands,
     /* 485306 */     // GIR_Coverage, 12528,
     /* 485306 */     GIR_EraseRootFromParent_Done,
     /* 485307 */   // Label 6607: @485307
     /* 485307 */   GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(485442), // Rule ID 12531 //
     /* 485312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 485315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 485319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485359 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485364 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485364 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485369 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485396 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 485399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 485406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 485411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 485416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 485421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485440 */     GIR_RootConstrainSelectedInstOperands,
     /* 485441 */     // GIR_Coverage, 12531,
     /* 485441 */     GIR_EraseRootFromParent_Done,
     /* 485442 */   // Label 6608: @485442
     /* 485442 */   GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(485577), // Rule ID 12532 //
     /* 485447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 485450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 485454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485494 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485499 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485531 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 485534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 485541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 485546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 485551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 485556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485575 */     GIR_RootConstrainSelectedInstOperands,
     /* 485576 */     // GIR_Coverage, 12532,
     /* 485576 */     GIR_EraseRootFromParent_Done,
     /* 485577 */   // Label 6609: @485577
     /* 485577 */   GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(485712), // Rule ID 13007 //
     /* 485582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 485585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 485589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485629 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485634 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485643 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485666 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 485669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 485676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 485681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 485686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 485691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485710 */     GIR_RootConstrainSelectedInstOperands,
     /* 485711 */     // GIR_Coverage, 13007,
     /* 485711 */     GIR_EraseRootFromParent_Done,
     /* 485712 */   // Label 6610: @485712
     /* 485712 */   GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(485847), // Rule ID 13008 //
     /* 485717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 485720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 485724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485764 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485769 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485801 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 485804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 485811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 485816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 485821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 485826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485845 */     GIR_RootConstrainSelectedInstOperands,
     /* 485846 */     // GIR_Coverage, 13008,
     /* 485846 */     GIR_EraseRootFromParent_Done,
     /* 485847 */   // Label 6611: @485847
     /* 485847 */   GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(485982), // Rule ID 13011 //
     /* 485852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 485855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 485859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485899 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485904 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485909 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485936 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 485939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 485946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 485951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 485956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 485961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485980 */     GIR_RootConstrainSelectedInstOperands,
     /* 485981 */     // GIR_Coverage, 13011,
     /* 485981 */     GIR_EraseRootFromParent_Done,
     /* 485982 */   // Label 6612: @485982
     /* 485982 */   GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(486117), // Rule ID 13012 //
     /* 485987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 485990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 485994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 486034 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486039 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486044 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486071 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 486074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 486081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 486086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 486091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 486096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486115 */     GIR_RootConstrainSelectedInstOperands,
     /* 486116 */     // GIR_Coverage, 13012,
     /* 486116 */     GIR_EraseRootFromParent_Done,
     /* 486117 */   // Label 6613: @486117
     /* 486117 */   GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(486252), // Rule ID 12032 //
     /* 486122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 486125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486165 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 486169 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486174 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486174 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486179 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486206 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 486209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 486216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 486221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 486226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 486231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486250 */     GIR_RootConstrainSelectedInstOperands,
     /* 486251 */     // GIR_Coverage, 12032,
     /* 486251 */     GIR_EraseRootFromParent_Done,
     /* 486252 */   // Label 6614: @486252
     /* 486252 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(486387), // Rule ID 12033 //
     /* 486257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 486260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 486304 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486304 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486309 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486314 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486341 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 486344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 486351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 486356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 486361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 486366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486385 */     GIR_RootConstrainSelectedInstOperands,
     /* 486386 */     // GIR_Coverage, 12033,
     /* 486386 */     GIR_EraseRootFromParent_Done,
     /* 486387 */   // Label 6615: @486387
     /* 486387 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(486522), // Rule ID 12036 //
     /* 486392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 486395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 486439 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486444 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486449 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486476 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 486479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 486486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 486491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 486496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 486501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486520 */     GIR_RootConstrainSelectedInstOperands,
     /* 486521 */     // GIR_Coverage, 12036,
     /* 486521 */     GIR_EraseRootFromParent_Done,
     /* 486522 */   // Label 6616: @486522
     /* 486522 */   GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(486657), // Rule ID 12037 //
     /* 486527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 486530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 486574 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486579 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486588 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486611 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 486614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 486621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 486626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 486631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 486636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486655 */     GIR_RootConstrainSelectedInstOperands,
     /* 486656 */     // GIR_Coverage, 12037,
     /* 486656 */     GIR_EraseRootFromParent_Done,
     /* 486657 */   // Label 6617: @486657
     /* 486657 */   GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(486792), // Rule ID 12512 //
     /* 486662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 486665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 486669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 486709 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486714 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486732 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486746 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 486749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 486756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 486761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 486766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 486771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486790 */     GIR_RootConstrainSelectedInstOperands,
     /* 486791 */     // GIR_Coverage, 12512,
     /* 486791 */     GIR_EraseRootFromParent_Done,
     /* 486792 */   // Label 6618: @486792
     /* 486792 */   GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(486927), // Rule ID 12513 //
     /* 486797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 486800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 486804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 486844 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486849 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486849 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486881 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 486884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 486891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 486896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 486901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 486906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486925 */     GIR_RootConstrainSelectedInstOperands,
     /* 486926 */     // GIR_Coverage, 12513,
     /* 486926 */     GIR_EraseRootFromParent_Done,
     /* 486927 */   // Label 6619: @486927
     /* 486927 */   GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(487062), // Rule ID 12516 //
     /* 486932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 486935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 486939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 486975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 486979 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486984 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486989 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487016 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 487019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 487026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 487031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 487036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 487041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487060 */     GIR_RootConstrainSelectedInstOperands,
     /* 487061 */     // GIR_Coverage, 12516,
     /* 487061 */     GIR_EraseRootFromParent_Done,
     /* 487062 */   // Label 6620: @487062
     /* 487062 */   GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(487197), // Rule ID 12517 //
     /* 487067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 487070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 487074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 487110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487114 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487119 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487124 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487151 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 487154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 487161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 487166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 487171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 487176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487195 */     GIR_RootConstrainSelectedInstOperands,
     /* 487196 */     // GIR_Coverage, 12517,
     /* 487196 */     GIR_EraseRootFromParent_Done,
     /* 487197 */   // Label 6621: @487197
     /* 487197 */   GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(487332), // Rule ID 12992 //
     /* 487202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 487205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 487245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487249 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487254 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487286 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 487289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 487296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 487301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 487306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 487311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487330 */     GIR_RootConstrainSelectedInstOperands,
     /* 487331 */     // GIR_Coverage, 12992,
     /* 487331 */     GIR_EraseRootFromParent_Done,
     /* 487332 */   // Label 6622: @487332
     /* 487332 */   GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(487467), // Rule ID 12993 //
     /* 487337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 487340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 487380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487384 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487389 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487394 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487421 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 487424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 487431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 487436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 487441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 487446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487465 */     GIR_RootConstrainSelectedInstOperands,
     /* 487466 */     // GIR_Coverage, 12993,
     /* 487466 */     GIR_EraseRootFromParent_Done,
     /* 487467 */   // Label 6623: @487467
     /* 487467 */   GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(487602), // Rule ID 12996 //
     /* 487472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 487475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 487515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487519 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487524 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487556 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 487559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 487566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 487571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 487576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 487581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487600 */     GIR_RootConstrainSelectedInstOperands,
     /* 487601 */     // GIR_Coverage, 12996,
     /* 487601 */     GIR_EraseRootFromParent_Done,
     /* 487602 */   // Label 6624: @487602
     /* 487602 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(487737), // Rule ID 12997 //
     /* 487607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 487610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 487650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487654 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487659 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487659 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487664 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487691 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 487694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 487701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 487706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 487711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 487716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487735 */     GIR_RootConstrainSelectedInstOperands,
     /* 487736 */     // GIR_Coverage, 12997,
     /* 487736 */     GIR_EraseRootFromParent_Done,
     /* 487737 */   // Label 6625: @487737
     /* 487737 */   GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(487872), // Rule ID 7626 //
     /* 487742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 487745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 487785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 487789 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487794 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487826 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 487829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 487836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 487841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 487846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 487851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487870 */     GIR_RootConstrainSelectedInstOperands,
     /* 487871 */     // GIR_Coverage, 7626,
     /* 487871 */     GIR_EraseRootFromParent_Done,
     /* 487872 */   // Label 6626: @487872
     /* 487872 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(488007), // Rule ID 7658 //
     /* 487877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 487880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 487884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 487920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 487924 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487929 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487961 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 487964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 487971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 487976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 487981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 487986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488005 */     GIR_RootConstrainSelectedInstOperands,
     /* 488006 */     // GIR_Coverage, 7658,
     /* 488006 */     GIR_EraseRootFromParent_Done,
     /* 488007 */   // Label 6627: @488007
     /* 488007 */   GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(488142), // Rule ID 7690 //
     /* 488012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 488015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488059 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488064 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488069 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488096 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 488099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 488106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 488111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 488116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 488121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488140 */     GIR_RootConstrainSelectedInstOperands,
     /* 488141 */     // GIR_Coverage, 7690,
     /* 488141 */     GIR_EraseRootFromParent_Done,
     /* 488142 */   // Label 6628: @488142
     /* 488142 */   GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(488277), // Rule ID 12046 //
     /* 488147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 488150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488194 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488199 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488231 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 488234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 488241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 488246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 488251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 488256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488275 */     GIR_RootConstrainSelectedInstOperands,
     /* 488276 */     // GIR_Coverage, 12046,
     /* 488276 */     GIR_EraseRootFromParent_Done,
     /* 488277 */   // Label 6629: @488277
     /* 488277 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(488412), // Rule ID 12049 //
     /* 488282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 488285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488325 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488329 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488329 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488334 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488334 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488366 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 488369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 488376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 488381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 488386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 488391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488410 */     GIR_RootConstrainSelectedInstOperands,
     /* 488411 */     // GIR_Coverage, 12049,
     /* 488411 */     GIR_EraseRootFromParent_Done,
     /* 488412 */   // Label 6630: @488412
     /* 488412 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(488547), // Rule ID 12050 //
     /* 488417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 488420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488464 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488464 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488469 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488474 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488501 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 488504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 488511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 488516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 488521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 488526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488545 */     GIR_RootConstrainSelectedInstOperands,
     /* 488546 */     // GIR_Coverage, 12050,
     /* 488546 */     GIR_EraseRootFromParent_Done,
     /* 488547 */   // Label 6631: @488547
     /* 488547 */   GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(488682), // Rule ID 12526 //
     /* 488552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 488555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 488559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488599 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488604 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488636 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 488639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 488646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 488651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 488656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 488661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488680 */     GIR_RootConstrainSelectedInstOperands,
     /* 488681 */     // GIR_Coverage, 12526,
     /* 488681 */     GIR_EraseRootFromParent_Done,
     /* 488682 */   // Label 6632: @488682
     /* 488682 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(488817), // Rule ID 12529 //
     /* 488687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 488690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 488694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488734 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488739 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488744 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488771 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 488774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 488781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 488786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 488791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 488796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488815 */     GIR_RootConstrainSelectedInstOperands,
     /* 488816 */     // GIR_Coverage, 12529,
     /* 488816 */     GIR_EraseRootFromParent_Done,
     /* 488817 */   // Label 6633: @488817
     /* 488817 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(488952), // Rule ID 12530 //
     /* 488822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 488825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 488829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488869 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488874 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488906 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 488909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 488916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 488921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 488926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 488931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488950 */     GIR_RootConstrainSelectedInstOperands,
     /* 488951 */     // GIR_Coverage, 12530,
     /* 488951 */     GIR_EraseRootFromParent_Done,
     /* 488952 */   // Label 6634: @488952
     /* 488952 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(489087), // Rule ID 13006 //
     /* 488957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 488960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489004 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489009 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489014 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489034 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489041 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 489044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 489051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 489056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 489061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 489066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489085 */     GIR_RootConstrainSelectedInstOperands,
     /* 489086 */     // GIR_Coverage, 13006,
     /* 489086 */     GIR_EraseRootFromParent_Done,
     /* 489087 */   // Label 6635: @489087
     /* 489087 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(489222), // Rule ID 13009 //
     /* 489092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 489095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489139 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489139 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489144 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489176 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 489179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 489186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 489191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 489196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 489201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489220 */     GIR_RootConstrainSelectedInstOperands,
     /* 489221 */     // GIR_Coverage, 13009,
     /* 489221 */     GIR_EraseRootFromParent_Done,
     /* 489222 */   // Label 6636: @489222
     /* 489222 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(489357), // Rule ID 13010 //
     /* 489227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 489230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489274 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489279 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489311 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 489314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 489321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 489326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 489331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 489336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489355 */     GIR_RootConstrainSelectedInstOperands,
     /* 489356 */     // GIR_Coverage, 13010,
     /* 489356 */     GIR_EraseRootFromParent_Done,
     /* 489357 */   // Label 6637: @489357
     /* 489357 */   GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(489492), // Rule ID 7625 //
     /* 489362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 489365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 489409 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489414 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489446 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 489449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 489456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 489461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 489466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 489471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489490 */     GIR_RootConstrainSelectedInstOperands,
     /* 489491 */     // GIR_Coverage, 7625,
     /* 489491 */     GIR_EraseRootFromParent_Done,
     /* 489492 */   // Label 6638: @489492
     /* 489492 */   GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(489627), // Rule ID 7657 //
     /* 489497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 489500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 489504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 489544 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489549 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489554 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489581 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 489584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 489591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 489596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 489601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 489606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489625 */     GIR_RootConstrainSelectedInstOperands,
     /* 489626 */     // GIR_Coverage, 7657,
     /* 489626 */     GIR_EraseRootFromParent_Done,
     /* 489627 */   // Label 6639: @489627
     /* 489627 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(489762), // Rule ID 7689 //
     /* 489632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 489635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 489679 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489684 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489716 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 489719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 489726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 489731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 489736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 489741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489760 */     GIR_RootConstrainSelectedInstOperands,
     /* 489761 */     // GIR_Coverage, 7689,
     /* 489761 */     GIR_EraseRootFromParent_Done,
     /* 489762 */   // Label 6640: @489762
     /* 489762 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(489897), // Rule ID 12031 //
     /* 489767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 489770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 489814 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489814 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489819 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489819 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489824 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489830 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489851 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 489854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 489861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 489866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 489871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 489876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489895 */     GIR_RootConstrainSelectedInstOperands,
     /* 489896 */     // GIR_Coverage, 12031,
     /* 489896 */     GIR_EraseRootFromParent_Done,
     /* 489897 */   // Label 6641: @489897
     /* 489897 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(490032), // Rule ID 12034 //
     /* 489902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 489905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 489945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 489949 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489954 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489959 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489986 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 489989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 489996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 490001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 490006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 490011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490030 */     GIR_RootConstrainSelectedInstOperands,
     /* 490031 */     // GIR_Coverage, 12034,
     /* 490031 */     GIR_EraseRootFromParent_Done,
     /* 490032 */   // Label 6642: @490032
     /* 490032 */   GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(490167), // Rule ID 12035 //
     /* 490037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 490040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490084 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490089 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490121 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 490124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 490131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 490136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 490141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 490146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490165 */     GIR_RootConstrainSelectedInstOperands,
     /* 490166 */     // GIR_Coverage, 12035,
     /* 490166 */     GIR_EraseRootFromParent_Done,
     /* 490167 */   // Label 6643: @490167
     /* 490167 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(490302), // Rule ID 12511 //
     /* 490172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 490175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 490179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490219 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490224 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490256 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 490259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 490266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 490271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 490276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 490281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490300 */     GIR_RootConstrainSelectedInstOperands,
     /* 490301 */     // GIR_Coverage, 12511,
     /* 490301 */     GIR_EraseRootFromParent_Done,
     /* 490302 */   // Label 6644: @490302
     /* 490302 */   GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(490437), // Rule ID 12514 //
     /* 490307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 490310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 490314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490354 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490359 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490391 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 490394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 490401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 490406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 490411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 490416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490435 */     GIR_RootConstrainSelectedInstOperands,
     /* 490436 */     // GIR_Coverage, 12514,
     /* 490436 */     GIR_EraseRootFromParent_Done,
     /* 490437 */   // Label 6645: @490437
     /* 490437 */   GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(490572), // Rule ID 12515 //
     /* 490442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 490445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 490449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490489 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490494 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490526 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 490529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 490536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 490541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 490546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 490551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490570 */     GIR_RootConstrainSelectedInstOperands,
     /* 490571 */     // GIR_Coverage, 12515,
     /* 490571 */     GIR_EraseRootFromParent_Done,
     /* 490572 */   // Label 6646: @490572
     /* 490572 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(490707), // Rule ID 12991 //
     /* 490577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 490580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490624 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490629 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490634 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490661 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 490664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 490671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 490676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 490681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 490686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490705 */     GIR_RootConstrainSelectedInstOperands,
     /* 490706 */     // GIR_Coverage, 12991,
     /* 490706 */     GIR_EraseRootFromParent_Done,
     /* 490707 */   // Label 6647: @490707
     /* 490707 */   GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(490842), // Rule ID 12994 //
     /* 490712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 490715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490759 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490764 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490769 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490796 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 490799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 490806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 490811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 490816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 490821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490840 */     GIR_RootConstrainSelectedInstOperands,
     /* 490841 */     // GIR_Coverage, 12994,
     /* 490841 */     GIR_EraseRootFromParent_Done,
     /* 490842 */   // Label 6648: @490842
     /* 490842 */   GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(490977), // Rule ID 12995 //
     /* 490847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 490850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 490890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490894 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490899 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490931 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 490934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 490941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 490946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 490951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 490956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490975 */     GIR_RootConstrainSelectedInstOperands,
     /* 490976 */     // GIR_Coverage, 12995,
     /* 490976 */     GIR_EraseRootFromParent_Done,
     /* 490977 */   // Label 6649: @490977
     /* 490977 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(491112), // Rule ID 12117 //
     /* 490982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 490985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491029 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 491034 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 491039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491066 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 491069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 491076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 491081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 491086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 491091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 491096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 491101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491110 */     GIR_RootConstrainSelectedInstOperands,
     /* 491111 */     // GIR_Coverage, 12117,
     /* 491111 */     GIR_EraseRootFromParent_Done,
     /* 491112 */   // Label 6650: @491112
     /* 491112 */   GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(491247), // Rule ID 12118 //
     /* 491117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 491120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 491124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491164 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 491169 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 491174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491201 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 491204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 491211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 491216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 491221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 491226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 491231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 491236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491245 */     GIR_RootConstrainSelectedInstOperands,
     /* 491246 */     // GIR_Coverage, 12118,
     /* 491246 */     GIR_EraseRootFromParent_Done,
     /* 491247 */   // Label 6651: @491247
     /* 491247 */   GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(491382), // Rule ID 12119 //
     /* 491252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 491255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 491259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491299 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491299 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 491304 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491304 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 491309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491336 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 491339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 491346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 491351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 491356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 491361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 491366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 491371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491380 */     GIR_RootConstrainSelectedInstOperands,
     /* 491381 */     // GIR_Coverage, 12119,
     /* 491381 */     GIR_EraseRootFromParent_Done,
     /* 491382 */   // Label 6652: @491382
     /* 491382 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(491517), // Rule ID 12120 //
     /* 491387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 491390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 491394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491434 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 491439 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 491444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491471 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 491474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 491481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 491486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 491491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 491496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 491501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 491506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491515 */     GIR_RootConstrainSelectedInstOperands,
     /* 491516 */     // GIR_Coverage, 12120,
     /* 491516 */     GIR_EraseRootFromParent_Done,
     /* 491517 */   // Label 6653: @491517
     /* 491517 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(491652), // Rule ID 12597 //
     /* 491522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 491525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 491529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491569 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 491574 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 491579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491606 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 491609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 491616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 491621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 491626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 491631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 491636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 491641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491650 */     GIR_RootConstrainSelectedInstOperands,
     /* 491651 */     // GIR_Coverage, 12597,
     /* 491651 */     GIR_EraseRootFromParent_Done,
     /* 491652 */   // Label 6654: @491652
     /* 491652 */   GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(491787), // Rule ID 12598 //
     /* 491657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 491660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 491664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491704 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 491709 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 491714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491718 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491741 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 491744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 491751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 491756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 491761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 491766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 491771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 491776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491785 */     GIR_RootConstrainSelectedInstOperands,
     /* 491786 */     // GIR_Coverage, 12598,
     /* 491786 */     GIR_EraseRootFromParent_Done,
     /* 491787 */   // Label 6655: @491787
     /* 491787 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(491922), // Rule ID 12599 //
     /* 491792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 491795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 491799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491839 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 491844 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 491849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491876 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 491879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 491886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 491891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 491896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 491901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 491906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 491911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491920 */     GIR_RootConstrainSelectedInstOperands,
     /* 491921 */     // GIR_Coverage, 12599,
     /* 491921 */     GIR_EraseRootFromParent_Done,
     /* 491922 */   // Label 6656: @491922
     /* 491922 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(492057), // Rule ID 12600 //
     /* 491927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 491930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 491934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 491954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 491958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 491970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 491974 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 491979 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 491984 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491997 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492011 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 492014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 492021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 492026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 492031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 492036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492055 */     GIR_RootConstrainSelectedInstOperands,
     /* 492056 */     // GIR_Coverage, 12600,
     /* 492056 */     GIR_EraseRootFromParent_Done,
     /* 492057 */   // Label 6657: @492057
     /* 492057 */   GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(492192), // Rule ID 13077 //
     /* 492062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 492065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492101 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492105 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 492109 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492114 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492119 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492146 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 492149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 492156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 492161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 492166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 492171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492190 */     GIR_RootConstrainSelectedInstOperands,
     /* 492191 */     // GIR_Coverage, 13077,
     /* 492191 */     GIR_EraseRootFromParent_Done,
     /* 492192 */   // Label 6658: @492192
     /* 492192 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(492327), // Rule ID 13078 //
     /* 492197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 492200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 492244 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492249 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492281 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 492284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 492291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 492296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 492301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 492306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492325 */     GIR_RootConstrainSelectedInstOperands,
     /* 492326 */     // GIR_Coverage, 13078,
     /* 492326 */     GIR_EraseRootFromParent_Done,
     /* 492327 */   // Label 6659: @492327
     /* 492327 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(492462), // Rule ID 13079 //
     /* 492332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 492335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 492379 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492384 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492389 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492416 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 492419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 492426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 492431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 492436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 492441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492460 */     GIR_RootConstrainSelectedInstOperands,
     /* 492461 */     // GIR_Coverage, 13079,
     /* 492461 */     GIR_EraseRootFromParent_Done,
     /* 492462 */   // Label 6660: @492462
     /* 492462 */   GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(492597), // Rule ID 13080 //
     /* 492467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 492470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 492514 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492519 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492551 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 492554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 492561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 492566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 492571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 492576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492595 */     GIR_RootConstrainSelectedInstOperands,
     /* 492596 */     // GIR_Coverage, 13080,
     /* 492596 */     GIR_EraseRootFromParent_Done,
     /* 492597 */   // Label 6661: @492597
     /* 492597 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(492732), // Rule ID 12057 //
     /* 492602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 492605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492649 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492654 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492659 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492663 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492679 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492686 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 492689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 492696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 492701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 492706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 492711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492730 */     GIR_RootConstrainSelectedInstOperands,
     /* 492731 */     // GIR_Coverage, 12057,
     /* 492731 */     GIR_EraseRootFromParent_Done,
     /* 492732 */   // Label 6662: @492732
     /* 492732 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(492867), // Rule ID 12058 //
     /* 492737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 492740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492784 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492784 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492789 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492821 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 492824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 492831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 492836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 492841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 492846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492865 */     GIR_RootConstrainSelectedInstOperands,
     /* 492866 */     // GIR_Coverage, 12058,
     /* 492866 */     GIR_EraseRootFromParent_Done,
     /* 492867 */   // Label 6663: @492867
     /* 492867 */   GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(493002), // Rule ID 12059 //
     /* 492872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 492875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 492899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 492915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492919 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 492924 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 492929 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492956 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 492959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 492966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 492971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 492976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 492981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 492986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 492991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493000 */     GIR_RootConstrainSelectedInstOperands,
     /* 493001 */     // GIR_Coverage, 12059,
     /* 493001 */     GIR_EraseRootFromParent_Done,
     /* 493002 */   // Label 6664: @493002
     /* 493002 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(493137), // Rule ID 12060 //
     /* 493007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 493010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 493014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493054 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493059 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493064 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493091 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 493094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 493101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 493106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 493111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 493116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493135 */     GIR_RootConstrainSelectedInstOperands,
     /* 493136 */     // GIR_Coverage, 12060,
     /* 493136 */     GIR_EraseRootFromParent_Done,
     /* 493137 */   // Label 6665: @493137
     /* 493137 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(493272), // Rule ID 12537 //
     /* 493142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 493145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 493149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493189 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493194 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493199 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493203 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493226 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 493229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 493236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 493241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 493246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 493251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493270 */     GIR_RootConstrainSelectedInstOperands,
     /* 493271 */     // GIR_Coverage, 12537,
     /* 493271 */     GIR_EraseRootFromParent_Done,
     /* 493272 */   // Label 6666: @493272
     /* 493272 */   GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(493407), // Rule ID 12538 //
     /* 493277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 493280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 493284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493324 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493329 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493329 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493354 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493361 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 493364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 493371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 493376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 493381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 493386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493405 */     GIR_RootConstrainSelectedInstOperands,
     /* 493406 */     // GIR_Coverage, 12538,
     /* 493406 */     GIR_EraseRootFromParent_Done,
     /* 493407 */   // Label 6667: @493407
     /* 493407 */   GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(493542), // Rule ID 12539 //
     /* 493412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 493415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 493419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493447 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493451 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493455 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493459 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493464 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493464 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493469 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493489 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493496 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 493499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 493506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 493511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 493516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 493521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493540 */     GIR_RootConstrainSelectedInstOperands,
     /* 493541 */     // GIR_Coverage, 12539,
     /* 493541 */     GIR_EraseRootFromParent_Done,
     /* 493542 */   // Label 6668: @493542
     /* 493542 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(493677), // Rule ID 12540 //
     /* 493547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 493550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 493554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493594 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493594 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493599 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493604 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493608 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493624 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493631 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 493634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 493641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 493646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 493651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 493656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493675 */     GIR_RootConstrainSelectedInstOperands,
     /* 493676 */     // GIR_Coverage, 12540,
     /* 493676 */     GIR_EraseRootFromParent_Done,
     /* 493677 */   // Label 6669: @493677
     /* 493677 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(493812), // Rule ID 13017 //
     /* 493682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 493685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 493689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493729 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493734 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493766 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 493769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 493776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 493781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 493786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 493791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493810 */     GIR_RootConstrainSelectedInstOperands,
     /* 493811 */     // GIR_Coverage, 13017,
     /* 493811 */     GIR_EraseRootFromParent_Done,
     /* 493812 */   // Label 6670: @493812
     /* 493812 */   GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(493947), // Rule ID 13018 //
     /* 493817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 493820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 493824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493864 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 493869 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 493874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493901 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 493904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 493911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 493916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 493921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 493926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 493931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 493936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493945 */     GIR_RootConstrainSelectedInstOperands,
     /* 493946 */     // GIR_Coverage, 13018,
     /* 493946 */     GIR_EraseRootFromParent_Done,
     /* 493947 */   // Label 6671: @493947
     /* 493947 */   GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(494082), // Rule ID 13019 //
     /* 493952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 493955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 493959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 493979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 493995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493999 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494004 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494036 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 494039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 494046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 494051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 494056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 494061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494080 */     GIR_RootConstrainSelectedInstOperands,
     /* 494081 */     // GIR_Coverage, 13019,
     /* 494081 */     GIR_EraseRootFromParent_Done,
     /* 494082 */   // Label 6672: @494082
     /* 494082 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(494217), // Rule ID 13020 //
     /* 494087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 494090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 494118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494134 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494139 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494139 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494144 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494164 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494171 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 494174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 494181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 494186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 494191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 494196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494215 */     GIR_RootConstrainSelectedInstOperands,
     /* 494216 */     // GIR_Coverage, 13020,
     /* 494216 */     GIR_EraseRootFromParent_Done,
     /* 494217 */   // Label 6673: @494217
     /* 494217 */   GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(494352), // Rule ID 12102 //
     /* 494222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 494225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 494269 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494269 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494274 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494279 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494299 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494306 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 494309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 494316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 494321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 494326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 494331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494350 */     GIR_RootConstrainSelectedInstOperands,
     /* 494351 */     // GIR_Coverage, 12102,
     /* 494351 */     GIR_EraseRootFromParent_Done,
     /* 494352 */   // Label 6674: @494352
     /* 494352 */   GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(494487), // Rule ID 12103 //
     /* 494357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 494360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 494404 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494409 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494441 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 494444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 494451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 494456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 494461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 494466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494485 */     GIR_RootConstrainSelectedInstOperands,
     /* 494486 */     // GIR_Coverage, 12103,
     /* 494486 */     GIR_EraseRootFromParent_Done,
     /* 494487 */   // Label 6675: @494487
     /* 494487 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(494622), // Rule ID 12104 //
     /* 494492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 494495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 494539 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494544 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494562 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494569 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494576 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 494579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 494586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 494591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 494596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 494601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494620 */     GIR_RootConstrainSelectedInstOperands,
     /* 494621 */     // GIR_Coverage, 12104,
     /* 494621 */     GIR_EraseRootFromParent_Done,
     /* 494622 */   // Label 6676: @494622
     /* 494622 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(494757), // Rule ID 12105 //
     /* 494627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 494630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 494674 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494679 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494711 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 494714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 494721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 494726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 494731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 494736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494755 */     GIR_RootConstrainSelectedInstOperands,
     /* 494756 */     // GIR_Coverage, 12105,
     /* 494756 */     GIR_EraseRootFromParent_Done,
     /* 494757 */   // Label 6677: @494757
     /* 494757 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(494892), // Rule ID 12582 //
     /* 494762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 494765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 494769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 494809 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494814 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494814 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494846 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 494849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 494856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 494861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 494866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 494871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 494876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 494881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494890 */     GIR_RootConstrainSelectedInstOperands,
     /* 494891 */     // GIR_Coverage, 12582,
     /* 494891 */     GIR_EraseRootFromParent_Done,
     /* 494892 */   // Label 6678: @494892
     /* 494892 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(495027), // Rule ID 12583 //
     /* 494897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 494900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 494904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 494924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 494940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 494944 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494944 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 494949 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 494954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494974 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494981 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 494984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 494991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 494996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 495001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 495006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495025 */     GIR_RootConstrainSelectedInstOperands,
     /* 495026 */     // GIR_Coverage, 12583,
     /* 495026 */     GIR_EraseRootFromParent_Done,
     /* 495027 */   // Label 6679: @495027
     /* 495027 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(495162), // Rule ID 12584 //
     /* 495032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 495035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 495039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495079 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495084 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495116 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 495119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 495126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 495131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 495136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 495141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495160 */     GIR_RootConstrainSelectedInstOperands,
     /* 495161 */     // GIR_Coverage, 12584,
     /* 495161 */     GIR_EraseRootFromParent_Done,
     /* 495162 */   // Label 6680: @495162
     /* 495162 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(495297), // Rule ID 12585 //
     /* 495167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 495170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 495174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495214 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495214 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495219 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495237 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495251 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 495254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 495261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 495266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 495271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 495276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495295 */     GIR_RootConstrainSelectedInstOperands,
     /* 495296 */     // GIR_Coverage, 12585,
     /* 495296 */     GIR_EraseRootFromParent_Done,
     /* 495297 */   // Label 6681: @495297
     /* 495297 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(495432), // Rule ID 13062 //
     /* 495302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 495305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495349 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495354 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495359 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495386 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 495389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 495396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 495401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 495406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 495411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495430 */     GIR_RootConstrainSelectedInstOperands,
     /* 495431 */     // GIR_Coverage, 13062,
     /* 495431 */     GIR_EraseRootFromParent_Done,
     /* 495432 */   // Label 6682: @495432
     /* 495432 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(495567), // Rule ID 13063 //
     /* 495437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 495440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495484 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495489 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495521 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 495524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 495531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 495536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 495541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 495546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495565 */     GIR_RootConstrainSelectedInstOperands,
     /* 495566 */     // GIR_Coverage, 13063,
     /* 495566 */     GIR_EraseRootFromParent_Done,
     /* 495567 */   // Label 6683: @495567
     /* 495567 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(495702), // Rule ID 13064 //
     /* 495572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 495575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495619 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495624 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495629 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495635 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495649 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495656 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 495659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 495666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 495671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 495676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 495681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495700 */     GIR_RootConstrainSelectedInstOperands,
     /* 495701 */     // GIR_Coverage, 13064,
     /* 495701 */     GIR_EraseRootFromParent_Done,
     /* 495702 */   // Label 6684: @495702
     /* 495702 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(495837), // Rule ID 13065 //
     /* 495707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 495710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495754 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495754 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495759 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495764 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495777 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495791 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 495794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 495801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 495806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 495811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 495816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495835 */     GIR_RootConstrainSelectedInstOperands,
     /* 495836 */     // GIR_Coverage, 13065,
     /* 495836 */     GIR_EraseRootFromParent_Done,
     /* 495837 */   // Label 6685: @495837
     /* 495837 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(495972), // Rule ID 12042 //
     /* 495842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 495845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495889 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495894 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495919 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495926 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 495929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 495936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 495941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 495946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 495951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495970 */     GIR_RootConstrainSelectedInstOperands,
     /* 495971 */     // GIR_Coverage, 12042,
     /* 495971 */     GIR_EraseRootFromParent_Done,
     /* 495972 */   // Label 6686: @495972
     /* 495972 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(496107), // Rule ID 12043 //
     /* 495977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 495980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496024 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496029 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496034 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496061 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 496064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 496071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 496076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 496081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 496086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496105 */     GIR_RootConstrainSelectedInstOperands,
     /* 496106 */     // GIR_Coverage, 12043,
     /* 496106 */     GIR_EraseRootFromParent_Done,
     /* 496107 */   // Label 6687: @496107
     /* 496107 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(496242), // Rule ID 12044 //
     /* 496112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 496115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 496119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496159 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496164 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496169 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496189 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496196 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 496199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 496206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 496211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 496216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 496221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496240 */     GIR_RootConstrainSelectedInstOperands,
     /* 496241 */     // GIR_Coverage, 12044,
     /* 496241 */     GIR_EraseRootFromParent_Done,
     /* 496242 */   // Label 6688: @496242
     /* 496242 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(496377), // Rule ID 12045 //
     /* 496247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 496250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 496254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496282 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496294 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496299 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496299 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496304 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496310 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496331 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 496334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 496341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 496346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 496351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 496356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496375 */     GIR_RootConstrainSelectedInstOperands,
     /* 496376 */     // GIR_Coverage, 12045,
     /* 496376 */     GIR_EraseRootFromParent_Done,
     /* 496377 */   // Label 6689: @496377
     /* 496377 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(496512), // Rule ID 12522 //
     /* 496382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 496385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 496389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496429 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496434 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496439 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496466 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 496469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 496476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 496481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 496486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 496491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496510 */     GIR_RootConstrainSelectedInstOperands,
     /* 496511 */     // GIR_Coverage, 12522,
     /* 496511 */     GIR_EraseRootFromParent_Done,
     /* 496512 */   // Label 6690: @496512
     /* 496512 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(496647), // Rule ID 12523 //
     /* 496517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 496520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 496524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496564 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496569 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496578 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496580 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496601 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 496604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 496611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 496616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 496621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 496626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496645 */     GIR_RootConstrainSelectedInstOperands,
     /* 496646 */     // GIR_Coverage, 12523,
     /* 496646 */     GIR_EraseRootFromParent_Done,
     /* 496647 */   // Label 6691: @496647
     /* 496647 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(496782), // Rule ID 12524 //
     /* 496652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 496655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 496659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496699 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496704 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496736 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 496739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 496746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 496751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 496756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 496761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496780 */     GIR_RootConstrainSelectedInstOperands,
     /* 496781 */     // GIR_Coverage, 12524,
     /* 496781 */     GIR_EraseRootFromParent_Done,
     /* 496782 */   // Label 6692: @496782
     /* 496782 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(496917), // Rule ID 12525 //
     /* 496787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 496790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 496794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496834 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496839 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496844 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496871 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 496874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 496881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 496886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 496891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 496896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496915 */     GIR_RootConstrainSelectedInstOperands,
     /* 496916 */     // GIR_Coverage, 12525,
     /* 496916 */     GIR_EraseRootFromParent_Done,
     /* 496917 */   // Label 6693: @496917
     /* 496917 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(497052), // Rule ID 13002 //
     /* 496922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 496925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 496929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 496953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496969 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496974 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497006 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 497009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 497016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 497021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 497026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 497031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497050 */     GIR_RootConstrainSelectedInstOperands,
     /* 497051 */     // GIR_Coverage, 13002,
     /* 497051 */     GIR_EraseRootFromParent_Done,
     /* 497052 */   // Label 6694: @497052
     /* 497052 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(497187), // Rule ID 13003 //
     /* 497057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 497060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 497088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497104 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497109 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497114 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497127 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497134 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497141 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 497144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 497151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 497156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 497161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 497166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497185 */     GIR_RootConstrainSelectedInstOperands,
     /* 497186 */     // GIR_Coverage, 13003,
     /* 497186 */     GIR_EraseRootFromParent_Done,
     /* 497187 */   // Label 6695: @497187
     /* 497187 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(497322), // Rule ID 13004 //
     /* 497192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 497195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 497223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497239 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497239 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497244 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497249 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497262 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497269 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497276 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 497279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 497286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 497291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 497296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 497301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497320 */     GIR_RootConstrainSelectedInstOperands,
     /* 497321 */     // GIR_Coverage, 13004,
     /* 497321 */     GIR_EraseRootFromParent_Done,
     /* 497322 */   // Label 6696: @497322
     /* 497322 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(497457), // Rule ID 13005 //
     /* 497327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 497330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 497358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497374 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497379 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497411 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 497414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 497421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 497426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 497431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 497436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497455 */     GIR_RootConstrainSelectedInstOperands,
     /* 497456 */     // GIR_Coverage, 13005,
     /* 497456 */     GIR_EraseRootFromParent_Done,
     /* 497457 */   // Label 6697: @497457
     /* 497457 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(497592), // Rule ID 12113 //
     /* 497462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 497465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 497489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 497509 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497514 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497519 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497546 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 497549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 497556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 497561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 497566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 497571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 497576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 497581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497590 */     GIR_RootConstrainSelectedInstOperands,
     /* 497591 */     // GIR_Coverage, 12113,
     /* 497591 */     GIR_EraseRootFromParent_Done,
     /* 497592 */   // Label 6698: @497592
     /* 497592 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(497727), // Rule ID 12114 //
     /* 497597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 497600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 497624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 497644 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497649 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497654 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497681 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 497684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 497691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 497696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 497701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 497706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 497711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 497716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497725 */     GIR_RootConstrainSelectedInstOperands,
     /* 497726 */     // GIR_Coverage, 12114,
     /* 497726 */     GIR_EraseRootFromParent_Done,
     /* 497727 */   // Label 6699: @497727
     /* 497727 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(497862), // Rule ID 12115 //
     /* 497732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 497735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 497759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 497779 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497784 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497784 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497816 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 497819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 497826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 497831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 497836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 497841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 497846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 497851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497860 */     GIR_RootConstrainSelectedInstOperands,
     /* 497861 */     // GIR_Coverage, 12115,
     /* 497861 */     GIR_EraseRootFromParent_Done,
     /* 497862 */   // Label 6700: @497862
     /* 497862 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(497997), // Rule ID 12116 //
     /* 497867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 497870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 497894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 497914 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497914 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497919 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497924 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497951 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 497954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 497961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 497966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 497971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 497976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 497981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 497986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497995 */     GIR_RootConstrainSelectedInstOperands,
     /* 497996 */     // GIR_Coverage, 12116,
     /* 497996 */     GIR_EraseRootFromParent_Done,
     /* 497997 */   // Label 6701: @497997
     /* 497997 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(498132), // Rule ID 12593 //
     /* 498002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 498005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 498009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498049 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498054 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498059 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498072 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498086 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 498089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 498096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 498101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 498106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 498111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498130 */     GIR_RootConstrainSelectedInstOperands,
     /* 498131 */     // GIR_Coverage, 12593,
     /* 498131 */     GIR_EraseRootFromParent_Done,
     /* 498132 */   // Label 6702: @498132
     /* 498132 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(498267), // Rule ID 12594 //
     /* 498137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 498140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 498144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498184 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498189 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498194 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498221 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 498224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 498231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 498236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 498241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 498246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498265 */     GIR_RootConstrainSelectedInstOperands,
     /* 498266 */     // GIR_Coverage, 12594,
     /* 498266 */     GIR_EraseRootFromParent_Done,
     /* 498267 */   // Label 6703: @498267
     /* 498267 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(498402), // Rule ID 12595 //
     /* 498272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 498275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 498279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498319 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498324 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498356 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 498359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 498366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 498371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 498376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 498381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498400 */     GIR_RootConstrainSelectedInstOperands,
     /* 498401 */     // GIR_Coverage, 12595,
     /* 498401 */     GIR_EraseRootFromParent_Done,
     /* 498402 */   // Label 6704: @498402
     /* 498402 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(498537), // Rule ID 12596 //
     /* 498407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 498410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 498414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498454 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498459 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498464 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498484 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498491 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 498494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 498501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 498506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 498511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 498516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498535 */     GIR_RootConstrainSelectedInstOperands,
     /* 498536 */     // GIR_Coverage, 12596,
     /* 498536 */     GIR_EraseRootFromParent_Done,
     /* 498537 */   // Label 6705: @498537
     /* 498537 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(498672), // Rule ID 13073 //
     /* 498542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 498545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498589 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498594 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498594 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498599 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498619 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498626 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 498629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 498636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 498641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 498646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 498651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498670 */     GIR_RootConstrainSelectedInstOperands,
     /* 498671 */     // GIR_Coverage, 13073,
     /* 498671 */     GIR_EraseRootFromParent_Done,
     /* 498672 */   // Label 6706: @498672
     /* 498672 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(498807), // Rule ID 13074 //
     /* 498677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 498680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498724 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498724 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498729 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498734 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498740 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498747 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498761 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 498764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 498771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 498776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 498781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 498786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498805 */     GIR_RootConstrainSelectedInstOperands,
     /* 498806 */     // GIR_Coverage, 13074,
     /* 498806 */     GIR_EraseRootFromParent_Done,
     /* 498807 */   // Label 6707: @498807
     /* 498807 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(498942), // Rule ID 13075 //
     /* 498812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 498815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498859 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498864 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498869 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498882 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498896 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 498899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 498906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 498911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 498916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 498921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 498926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 498931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498940 */     GIR_RootConstrainSelectedInstOperands,
     /* 498941 */     // GIR_Coverage, 13075,
     /* 498941 */     GIR_EraseRootFromParent_Done,
     /* 498942 */   // Label 6708: @498942
     /* 498942 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(499077), // Rule ID 13076 //
     /* 498947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 498950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 498974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498994 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498999 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499004 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499031 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 499034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 499041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 499046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 499051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 499056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499075 */     GIR_RootConstrainSelectedInstOperands,
     /* 499076 */     // GIR_Coverage, 13076,
     /* 499076 */     GIR_EraseRootFromParent_Done,
     /* 499077 */   // Label 6709: @499077
     /* 499077 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(499212), // Rule ID 12053 //
     /* 499082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 499085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 499089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499129 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499134 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499152 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499159 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499166 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 499169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 499176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 499181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 499186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 499191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499210 */     GIR_RootConstrainSelectedInstOperands,
     /* 499211 */     // GIR_Coverage, 12053,
     /* 499211 */     GIR_EraseRootFromParent_Done,
     /* 499212 */   // Label 6710: @499212
     /* 499212 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(499347), // Rule ID 12054 //
     /* 499217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 499220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 499224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499264 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499264 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499269 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499269 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499278 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499294 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499301 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 499304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 499311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 499316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 499321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 499326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499345 */     GIR_RootConstrainSelectedInstOperands,
     /* 499346 */     // GIR_Coverage, 12054,
     /* 499346 */     GIR_EraseRootFromParent_Done,
     /* 499347 */   // Label 6711: @499347
     /* 499347 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(499482), // Rule ID 12055 //
     /* 499352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 499355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 499359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499399 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499399 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499404 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499409 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499422 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499429 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499436 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 499439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 499446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 499451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 499456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 499461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499480 */     GIR_RootConstrainSelectedInstOperands,
     /* 499481 */     // GIR_Coverage, 12055,
     /* 499481 */     GIR_EraseRootFromParent_Done,
     /* 499482 */   // Label 6712: @499482
     /* 499482 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(499617), // Rule ID 12056 //
     /* 499487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 499490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 499494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499534 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499539 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499544 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499557 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499571 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 499574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 499581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 499586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 499591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 499596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499615 */     GIR_RootConstrainSelectedInstOperands,
     /* 499616 */     // GIR_Coverage, 12056,
     /* 499616 */     GIR_EraseRootFromParent_Done,
     /* 499617 */   // Label 6713: @499617
     /* 499617 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(499752), // Rule ID 12533 //
     /* 499622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 499625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 499629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499669 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499674 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499706 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 499709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 499716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 499721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 499726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 499731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499750 */     GIR_RootConstrainSelectedInstOperands,
     /* 499751 */     // GIR_Coverage, 12533,
     /* 499751 */     GIR_EraseRootFromParent_Done,
     /* 499752 */   // Label 6714: @499752
     /* 499752 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(499887), // Rule ID 12534 //
     /* 499757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 499760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 499764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499804 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499809 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499814 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499834 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499841 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 499844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 499851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 499856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 499861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 499866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 499871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 499876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499885 */     GIR_RootConstrainSelectedInstOperands,
     /* 499886 */     // GIR_Coverage, 12534,
     /* 499886 */     GIR_EraseRootFromParent_Done,
     /* 499887 */   // Label 6715: @499887
     /* 499887 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(500022), // Rule ID 12535 //
     /* 499892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 499895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 499899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 499919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 499923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499939 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499944 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499944 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499949 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499969 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499976 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 499979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 499986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 499991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 499996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 500001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500020 */     GIR_RootConstrainSelectedInstOperands,
     /* 500021 */     // GIR_Coverage, 12535,
     /* 500021 */     GIR_EraseRootFromParent_Done,
     /* 500022 */   // Label 6716: @500022
     /* 500022 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(500157), // Rule ID 12536 //
     /* 500027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 500030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 500034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 500058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500074 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500074 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500079 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500084 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500097 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500111 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 500114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 500121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 500126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 500131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 500136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500155 */     GIR_RootConstrainSelectedInstOperands,
     /* 500156 */     // GIR_Coverage, 12536,
     /* 500156 */     GIR_EraseRootFromParent_Done,
     /* 500157 */   // Label 6717: @500157
     /* 500157 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(500292), // Rule ID 13013 //
     /* 500162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 500165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 500193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500197 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500209 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500209 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500214 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500214 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500219 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500232 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500246 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 500249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 500256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 500261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 500266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 500271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500290 */     GIR_RootConstrainSelectedInstOperands,
     /* 500291 */     // GIR_Coverage, 13013,
     /* 500291 */     GIR_EraseRootFromParent_Done,
     /* 500292 */   // Label 6718: @500292
     /* 500292 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(500427), // Rule ID 13014 //
     /* 500297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 500300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 500328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500344 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500349 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500354 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500367 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500374 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500381 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 500384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 500391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 500396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 500401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 500406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500425 */     GIR_RootConstrainSelectedInstOperands,
     /* 500426 */     // GIR_Coverage, 13014,
     /* 500426 */     GIR_EraseRootFromParent_Done,
     /* 500427 */   // Label 6719: @500427
     /* 500427 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(500562), // Rule ID 13015 //
     /* 500432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 500435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 500463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500479 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500484 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500502 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500516 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 500519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 500526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 500531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 500536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 500541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500560 */     GIR_RootConstrainSelectedInstOperands,
     /* 500561 */     // GIR_Coverage, 13015,
     /* 500561 */     GIR_EraseRootFromParent_Done,
     /* 500562 */   // Label 6720: @500562
     /* 500562 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(500697), // Rule ID 13016 //
     /* 500567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 500570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 500598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500614 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500619 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500651 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 500654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 500661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 500666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 500671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 500676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500695 */     GIR_RootConstrainSelectedInstOperands,
     /* 500696 */     // GIR_Coverage, 13016,
     /* 500696 */     GIR_EraseRootFromParent_Done,
     /* 500697 */   // Label 6721: @500697
     /* 500697 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(500832), // Rule ID 12098 //
     /* 500702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 500705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 500733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 500749 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500749 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500754 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500754 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500759 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500779 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500786 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 500789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 500796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 500801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 500806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 500811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500830 */     GIR_RootConstrainSelectedInstOperands,
     /* 500831 */     // GIR_Coverage, 12098,
     /* 500831 */     GIR_EraseRootFromParent_Done,
     /* 500832 */   // Label 6722: @500832
     /* 500832 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(500967), // Rule ID 12099 //
     /* 500837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 500840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 500868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 500884 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500889 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500894 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500907 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500921 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 500924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 500931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 500936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 500941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 500946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 500951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 500956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500965 */     GIR_RootConstrainSelectedInstOperands,
     /* 500966 */     // GIR_Coverage, 12099,
     /* 500966 */     GIR_EraseRootFromParent_Done,
     /* 500967 */   // Label 6723: @500967
     /* 500967 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(501102), // Rule ID 12100 //
     /* 500972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 500975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 500999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501019 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501024 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501029 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501049 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501056 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 501059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 501066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 501071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 501076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 501081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501100 */     GIR_RootConstrainSelectedInstOperands,
     /* 501101 */     // GIR_Coverage, 12100,
     /* 501101 */     GIR_EraseRootFromParent_Done,
     /* 501102 */   // Label 6724: @501102
     /* 501102 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(501237), // Rule ID 12101 //
     /* 501107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 501110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 501114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501154 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501159 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501164 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501191 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 501194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 501201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 501206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 501211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 501216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501235 */     GIR_RootConstrainSelectedInstOperands,
     /* 501236 */     // GIR_Coverage, 12101,
     /* 501236 */     GIR_EraseRootFromParent_Done,
     /* 501237 */   // Label 6725: @501237
     /* 501237 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(501372), // Rule ID 12578 //
     /* 501242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 501245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 501249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501289 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501294 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501299 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501326 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 501329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 501336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 501341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 501346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 501351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501370 */     GIR_RootConstrainSelectedInstOperands,
     /* 501371 */     // GIR_Coverage, 12578,
     /* 501371 */     GIR_EraseRootFromParent_Done,
     /* 501372 */   // Label 6726: @501372
     /* 501372 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(501507), // Rule ID 12579 //
     /* 501377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 501380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 501384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501424 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501429 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501447 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501461 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 501464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 501471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 501476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 501481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 501486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501505 */     GIR_RootConstrainSelectedInstOperands,
     /* 501506 */     // GIR_Coverage, 12579,
     /* 501506 */     GIR_EraseRootFromParent_Done,
     /* 501507 */   // Label 6727: @501507
     /* 501507 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(501642), // Rule ID 12580 //
     /* 501512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 501515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 501519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501559 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501564 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501569 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501582 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501589 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501596 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 501599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 501606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 501611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 501616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 501621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501640 */     GIR_RootConstrainSelectedInstOperands,
     /* 501641 */     // GIR_Coverage, 12580,
     /* 501641 */     GIR_EraseRootFromParent_Done,
     /* 501642 */   // Label 6728: @501642
     /* 501642 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(501777), // Rule ID 12581 //
     /* 501647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 501650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 501654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501694 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501699 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501731 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 501734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 501741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 501746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 501751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 501756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501775 */     GIR_RootConstrainSelectedInstOperands,
     /* 501776 */     // GIR_Coverage, 12581,
     /* 501776 */     GIR_EraseRootFromParent_Done,
     /* 501777 */   // Label 6729: @501777
     /* 501777 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(501912), // Rule ID 13058 //
     /* 501782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 501785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 501789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501829 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501834 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501859 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501866 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 501869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 501876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 501881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 501886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 501891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 501901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501910 */     GIR_RootConstrainSelectedInstOperands,
     /* 501911 */     // GIR_Coverage, 13058,
     /* 501911 */     GIR_EraseRootFromParent_Done,
     /* 501912 */   // Label 6730: @501912
     /* 501912 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(502047), // Rule ID 13059 //
     /* 501917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 501920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 501924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501964 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501969 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502001 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 502004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 502011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 502016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 502021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 502026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502045 */     GIR_RootConstrainSelectedInstOperands,
     /* 502046 */     // GIR_Coverage, 13059,
     /* 502046 */     GIR_EraseRootFromParent_Done,
     /* 502047 */   // Label 6731: @502047
     /* 502047 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(502182), // Rule ID 13060 //
     /* 502052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 502055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 502099 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502104 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502109 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502129 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502136 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 502139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 502146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 502151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 502156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 502161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502180 */     GIR_RootConstrainSelectedInstOperands,
     /* 502181 */     // GIR_Coverage, 13060,
     /* 502181 */     GIR_EraseRootFromParent_Done,
     /* 502182 */   // Label 6732: @502182
     /* 502182 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(502317), // Rule ID 13061 //
     /* 502187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 502190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 502234 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502234 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502239 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502239 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502257 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502264 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502271 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 502274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 502281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 502286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 502291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 502296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502315 */     GIR_RootConstrainSelectedInstOperands,
     /* 502316 */     // GIR_Coverage, 13061,
     /* 502316 */     GIR_EraseRootFromParent_Done,
     /* 502317 */   // Label 6733: @502317
     /* 502317 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(502452), // Rule ID 12038 //
     /* 502322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 502325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502369 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502374 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502379 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502383 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502392 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502399 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502406 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 502409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 502416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 502421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 502426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 502431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502450 */     GIR_RootConstrainSelectedInstOperands,
     /* 502451 */     // GIR_Coverage, 12038,
     /* 502451 */     GIR_EraseRootFromParent_Done,
     /* 502452 */   // Label 6734: @502452
     /* 502452 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(502587), // Rule ID 12039 //
     /* 502457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 502460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502504 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502509 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502514 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502527 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502541 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 502544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 502551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 502556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 502561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 502566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502585 */     GIR_RootConstrainSelectedInstOperands,
     /* 502586 */     // GIR_Coverage, 12039,
     /* 502586 */     GIR_EraseRootFromParent_Done,
     /* 502587 */   // Label 6735: @502587
     /* 502587 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(502722), // Rule ID 12040 //
     /* 502592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 502595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502639 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502644 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502669 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502676 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 502679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 502686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 502691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 502696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 502701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502720 */     GIR_RootConstrainSelectedInstOperands,
     /* 502721 */     // GIR_Coverage, 12040,
     /* 502721 */     GIR_EraseRootFromParent_Done,
     /* 502722 */   // Label 6736: @502722
     /* 502722 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(502857), // Rule ID 12041 //
     /* 502727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 502730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502774 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502779 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502811 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 502814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 502821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 502826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 502831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 502836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502855 */     GIR_RootConstrainSelectedInstOperands,
     /* 502856 */     // GIR_Coverage, 12041,
     /* 502856 */     GIR_EraseRootFromParent_Done,
     /* 502857 */   // Label 6737: @502857
     /* 502857 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(502992), // Rule ID 12518 //
     /* 502862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 502865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 502869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 502893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502909 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502914 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502914 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502919 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502946 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 502949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 502956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 502961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 502966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 502971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502990 */     GIR_RootConstrainSelectedInstOperands,
     /* 502991 */     // GIR_Coverage, 12518,
     /* 502991 */     GIR_EraseRootFromParent_Done,
     /* 502992 */   // Label 6738: @502992
     /* 502992 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(503127), // Rule ID 12519 //
     /* 502997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 503000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 503004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503044 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503049 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503054 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503058 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503067 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503074 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503081 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 503084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 503091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 503096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 503101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 503106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503125 */     GIR_RootConstrainSelectedInstOperands,
     /* 503126 */     // GIR_Coverage, 12519,
     /* 503126 */     GIR_EraseRootFromParent_Done,
     /* 503127 */   // Label 6739: @503127
     /* 503127 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(503262), // Rule ID 12520 //
     /* 503132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 503135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 503139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503179 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503184 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503202 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503216 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 503219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 503226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 503231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 503236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 503241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503260 */     GIR_RootConstrainSelectedInstOperands,
     /* 503261 */     // GIR_Coverage, 12520,
     /* 503261 */     GIR_EraseRootFromParent_Done,
     /* 503262 */   // Label 6740: @503262
     /* 503262 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(503397), // Rule ID 12521 //
     /* 503267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 503270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 503274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503314 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503319 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503328 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503351 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 503354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 503361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 503366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 503371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 503376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503395 */     GIR_RootConstrainSelectedInstOperands,
     /* 503396 */     // GIR_Coverage, 12521,
     /* 503396 */     GIR_EraseRootFromParent_Done,
     /* 503397 */   // Label 6741: @503397
     /* 503397 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(503532), // Rule ID 12998 //
     /* 503402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 503405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503449 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503454 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503472 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503479 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503486 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 503489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 503496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 503501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 503506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 503511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503530 */     GIR_RootConstrainSelectedInstOperands,
     /* 503531 */     // GIR_Coverage, 12998,
     /* 503531 */     GIR_EraseRootFromParent_Done,
     /* 503532 */   // Label 6742: @503532
     /* 503532 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(503667), // Rule ID 12999 //
     /* 503537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 503540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503584 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503589 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503614 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503621 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 503624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 503631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 503636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 503641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 503646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503665 */     GIR_RootConstrainSelectedInstOperands,
     /* 503666 */     // GIR_Coverage, 12999,
     /* 503666 */     GIR_EraseRootFromParent_Done,
     /* 503667 */   // Label 6743: @503667
     /* 503667 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(503802), // Rule ID 13000 //
     /* 503672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 503675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503719 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503724 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503724 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503729 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503733 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503742 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503749 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503756 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 503759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 503766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 503771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 503776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 503781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503800 */     GIR_RootConstrainSelectedInstOperands,
     /* 503801 */     // GIR_Coverage, 13000,
     /* 503801 */     GIR_EraseRootFromParent_Done,
     /* 503802 */   // Label 6744: @503802
     /* 503802 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(503937), // Rule ID 13001 //
     /* 503807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 503810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 503838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503854 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503854 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503859 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503864 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503877 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503884 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503891 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 503894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 503901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 503906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 503911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 503916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503935 */     GIR_RootConstrainSelectedInstOperands,
     /* 503936 */     // GIR_Coverage, 13001,
     /* 503936 */     GIR_EraseRootFromParent_Done,
     /* 503937 */   // Label 6745: @503937
     /* 503937 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(504052), // Rule ID 13264 //
     /* 503942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 503945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 503949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 503953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 503957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 503969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503977 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 503979 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 503983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 503985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504006 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 504009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 504026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 504031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 504036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 504041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504050 */     GIR_RootConstrainSelectedInstOperands,
     /* 504051 */     // GIR_Coverage, 13264,
     /* 504051 */     GIR_EraseRootFromParent_Done,
     /* 504052 */   // Label 6746: @504052
     /* 504052 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(504167), // Rule ID 13280 //
     /* 504057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 504060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 504064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 504068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 504084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504092 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504094 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 504098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504107 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504121 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 504124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 504141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 504146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 504151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 504156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504165 */     GIR_RootConstrainSelectedInstOperands,
     /* 504166 */     // GIR_Coverage, 13280,
     /* 504166 */     GIR_EraseRootFromParent_Done,
     /* 504167 */   // Label 6747: @504167
     /* 504167 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(504282), // Rule ID 13263 //
     /* 504172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 504175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 504179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 504183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504207 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504209 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 504213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504236 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 504239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 504256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 504261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 504266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 504271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504280 */     GIR_RootConstrainSelectedInstOperands,
     /* 504281 */     // GIR_Coverage, 13263,
     /* 504281 */     GIR_EraseRootFromParent_Done,
     /* 504282 */   // Label 6748: @504282
     /* 504282 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(504397), // Rule ID 13279 //
     /* 504287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 504290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 504294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 504298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504322 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504324 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 504328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504351 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 504354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 504371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 504376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 504381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 504386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504395 */     GIR_RootConstrainSelectedInstOperands,
     /* 504396 */     // GIR_Coverage, 13279,
     /* 504396 */     GIR_EraseRootFromParent_Done,
     /* 504397 */   // Label 6749: @504397
     /* 504397 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(504512), // Rule ID 7738 //
     /* 504402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 504405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 504409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 504429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504437 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504439 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 504443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504466 */     // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 504469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 504476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 504481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 504486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 504491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504510 */     GIR_RootConstrainSelectedInstOperands,
     /* 504511 */     // GIR_Coverage, 7738,
     /* 504511 */     GIR_EraseRootFromParent_Done,
     /* 504512 */   // Label 6750: @504512
     /* 504512 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(504627), // Rule ID 7754 //
     /* 504517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 504520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 504524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 504544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504552 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504554 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 504558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504567 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504581 */     // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 504584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 504591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 504596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 504601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 504606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504625 */     GIR_RootConstrainSelectedInstOperands,
     /* 504626 */     // GIR_Coverage, 7754,
     /* 504626 */     GIR_EraseRootFromParent_Done,
     /* 504627 */   // Label 6751: @504627
     /* 504627 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(504742), // Rule ID 7737 //
     /* 504632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 504635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 504639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504667 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504669 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 504673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504682 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504696 */     // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 504699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 504706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 504711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 504716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 504721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504740 */     GIR_RootConstrainSelectedInstOperands,
     /* 504741 */     // GIR_Coverage, 7737,
     /* 504741 */     GIR_EraseRootFromParent_Done,
     /* 504742 */   // Label 6752: @504742
     /* 504742 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(504857), // Rule ID 7753 //
     /* 504747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 504750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 504754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 504762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504782 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 504784 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 504788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 504790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504811 */     // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 504814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 504821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 504826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 504831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 504836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504855 */     GIR_RootConstrainSelectedInstOperands,
     /* 504856 */     // GIR_Coverage, 7753,
     /* 504856 */     GIR_EraseRootFromParent_Done,
     /* 504857 */   // Label 6753: @504857
     /* 504857 */   GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(504956), // Rule ID 13256 //
     /* 504862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 504865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 504869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 504873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 504877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 504885 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 504887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 504889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504910 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 504913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 504930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 504935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 504940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 504945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504954 */     GIR_RootConstrainSelectedInstOperands,
     /* 504955 */     // GIR_Coverage, 13256,
     /* 504955 */     GIR_EraseRootFromParent_Done,
     /* 504956 */   // Label 6754: @504956
     /* 504956 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(505055), // Rule ID 13272 //
     /* 504961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 504964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 504968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 504972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 504976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 504984 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 504986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 504988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505009 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 505012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 505019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 505024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 505029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 505034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 505039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 505044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505053 */     GIR_RootConstrainSelectedInstOperands,
     /* 505054 */     // GIR_Coverage, 13272,
     /* 505054 */     GIR_EraseRootFromParent_Done,
     /* 505055 */   // Label 6755: @505055
     /* 505055 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(505154), // Rule ID 13255 //
     /* 505060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 505063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 505067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 505071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505083 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505108 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 505111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 505118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 505123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 505128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 505133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 505138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 505143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505152 */     GIR_RootConstrainSelectedInstOperands,
     /* 505153 */     // GIR_Coverage, 13255,
     /* 505153 */     GIR_EraseRootFromParent_Done,
     /* 505154 */   // Label 6756: @505154
     /* 505154 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(505253), // Rule ID 13271 //
     /* 505159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 505162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 505170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505182 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505207 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 505210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 505217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 505222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 505227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 505232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 505237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 505242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505251 */     GIR_RootConstrainSelectedInstOperands,
     /* 505252 */     // GIR_Coverage, 13271,
     /* 505252 */     GIR_EraseRootFromParent_Done,
     /* 505253 */   // Label 6757: @505253
     /* 505253 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(505352), // Rule ID 7730 //
     /* 505258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 505261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 505265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 505273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505281 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505306 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 505309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 505316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505350 */     GIR_RootConstrainSelectedInstOperands,
     /* 505351 */     // GIR_Coverage, 7730,
     /* 505351 */     GIR_EraseRootFromParent_Done,
     /* 505352 */   // Label 6758: @505352
     /* 505352 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(505451), // Rule ID 7746 //
     /* 505357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 505360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 505372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505380 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505405 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 505408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 505415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505449 */     GIR_RootConstrainSelectedInstOperands,
     /* 505450 */     // GIR_Coverage, 7746,
     /* 505450 */     GIR_EraseRootFromParent_Done,
     /* 505451 */   // Label 6759: @505451
     /* 505451 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(505550), // Rule ID 7729 //
     /* 505456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 505459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 505463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505479 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505504 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 505507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 505514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505548 */     GIR_RootConstrainSelectedInstOperands,
     /* 505549 */     // GIR_Coverage, 7729,
     /* 505549 */     GIR_EraseRootFromParent_Done,
     /* 505550 */   // Label 6760: @505550
     /* 505550 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(505649), // Rule ID 7745 //
     /* 505555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 505558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505578 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 505580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 505582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505603 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 505606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 505613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505647 */     GIR_RootConstrainSelectedInstOperands,
     /* 505648 */     // GIR_Coverage, 7745,
     /* 505648 */     GIR_EraseRootFromParent_Done,
     /* 505649 */   // Label 6761: @505649
     /* 505649 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(505684), // Rule ID 100 //
     /* 505654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 505657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 505661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 505665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 505669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13798),
     /* 505673 */     // (fminnum_ieee:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13798>>  =>  (S_MIN_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 505673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F16),
     /* 505678 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 505682 */     GIR_RootConstrainSelectedInstOperands,
     /* 505683 */     // GIR_Coverage, 100,
     /* 505683 */     GIR_Done,
     /* 505684 */   // Label 6762: @505684
     /* 505684 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(505747), // Rule ID 885 //
     /* 505689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 505692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 505703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505710 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 505710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
     /* 505713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 505720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 505730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 505740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 505745 */     GIR_RootConstrainSelectedInstOperands,
     /* 505746 */     // GIR_Coverage, 885,
     /* 505746 */     GIR_EraseRootFromParent_Done,
     /* 505747 */   // Label 6763: @505747
     /* 505747 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(505810), // Rule ID 889 //
     /* 505752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 505755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 505766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505773 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 505773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
     /* 505776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 505783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 505793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 505803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 505808 */     GIR_RootConstrainSelectedInstOperands,
     /* 505809 */     // GIR_Coverage, 889,
     /* 505809 */     GIR_EraseRootFromParent_Done,
     /* 505810 */   // Label 6764: @505810
     /* 505810 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(505873), // Rule ID 8432 //
     /* 505815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 505818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 505836 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 505836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
     /* 505839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 505846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 505851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 505856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 505861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 505866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 505871 */     GIR_RootConstrainSelectedInstOperands,
     /* 505872 */     // GIR_Coverage, 8432,
     /* 505872 */     GIR_EraseRootFromParent_Done,
     /* 505873 */   // Label 6765: @505873
     /* 505873 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(505936), // Rule ID 8434 //
     /* 505878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 505881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 505899 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 505899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
     /* 505902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 505909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 505914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 505919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 505924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 505929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 505934 */     GIR_RootConstrainSelectedInstOperands,
     /* 505935 */     // GIR_Coverage, 8434,
     /* 505935 */     GIR_EraseRootFromParent_Done,
     /* 505936 */   // Label 6766: @505936
     /* 505936 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(505998), // Rule ID 887 //
     /* 505941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 505944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 505948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 505955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 505962 */     // (fminnum_ieee:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 505962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_t16_e64),
     /* 505965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 505972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 505982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505996 */     GIR_RootConstrainSelectedInstOperands,
     /* 505997 */     // GIR_Coverage, 887,
     /* 505997 */     GIR_EraseRootFromParent_Done,
     /* 505998 */   // Label 6767: @505998
     /* 505998 */   GIM_Reject,
     /* 505999 */ // Label 6361: @505999
     /* 505999 */ GIM_Reject,
     /* 506000 */ // Label 6357: @506000
     /* 506000 */ GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(523511),
     /* 506005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 506008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 506011 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(506140), // Rule ID 11627 //
     /* 506016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 506060 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 506065 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 506070 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506090 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506097 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 506100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 506107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 506117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506138 */     GIR_RootConstrainSelectedInstOperands,
     /* 506139 */     // GIR_Coverage, 11627,
     /* 506139 */     GIR_EraseRootFromParent_Done,
     /* 506140 */   // Label 6769: @506140
     /* 506140 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(506269), // Rule ID 11628 //
     /* 506145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 506189 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 506194 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 506199 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506203 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506226 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 506229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 506236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 506246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506267 */     GIR_RootConstrainSelectedInstOperands,
     /* 506268 */     // GIR_Coverage, 11628,
     /* 506268 */     GIR_EraseRootFromParent_Done,
     /* 506269 */   // Label 6770: @506269
     /* 506269 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(506398), // Rule ID 11631 //
     /* 506274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 506318 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 506323 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 506328 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506355 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 506358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 506365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 506370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 506375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 506380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506396 */     GIR_RootConstrainSelectedInstOperands,
     /* 506397 */     // GIR_Coverage, 11631,
     /* 506397 */     GIR_EraseRootFromParent_Done,
     /* 506398 */   // Label 6771: @506398
     /* 506398 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(506527), // Rule ID 11632 //
     /* 506403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 506447 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 506452 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506452 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 506457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506484 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 506487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 506494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 506499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 506504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 506509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506525 */     GIR_RootConstrainSelectedInstOperands,
     /* 506526 */     // GIR_Coverage, 11632,
     /* 506526 */     GIR_EraseRootFromParent_Done,
     /* 506527 */   // Label 6772: @506527
     /* 506527 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(506656), // Rule ID 11612 //
     /* 506532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 506576 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 506581 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 506586 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506590 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506613 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 506616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 506623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 506633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506654 */     GIR_RootConstrainSelectedInstOperands,
     /* 506655 */     // GIR_Coverage, 11612,
     /* 506655 */     GIR_EraseRootFromParent_Done,
     /* 506656 */   // Label 6773: @506656
     /* 506656 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(506785), // Rule ID 11613 //
     /* 506661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 506705 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 506710 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 506715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506735 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506742 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 506745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 506752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 506762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506783 */     GIR_RootConstrainSelectedInstOperands,
     /* 506784 */     // GIR_Coverage, 11613,
     /* 506784 */     GIR_EraseRootFromParent_Done,
     /* 506785 */   // Label 6774: @506785
     /* 506785 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(506914), // Rule ID 11616 //
     /* 506790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 506834 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 506839 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 506844 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506871 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 506874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 506881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 506886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 506891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 506896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506912 */     GIR_RootConstrainSelectedInstOperands,
     /* 506913 */     // GIR_Coverage, 11616,
     /* 506913 */     GIR_EraseRootFromParent_Done,
     /* 506914 */   // Label 6775: @506914
     /* 506914 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(507043), // Rule ID 11617 //
     /* 506919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 506935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 506939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 506943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 506951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 506955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 506959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 506963 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 506968 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 506973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506993 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507000 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 507010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 507015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 507020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 507025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507041 */     GIR_RootConstrainSelectedInstOperands,
     /* 507042 */     // GIR_Coverage, 11617,
     /* 507042 */     GIR_EraseRootFromParent_Done,
     /* 507043 */   // Label 6776: @507043
     /* 507043 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(507172), // Rule ID 7598 //
     /* 507048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 507088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 507092 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507097 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507097 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507102 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507106 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507129 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 507139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 507144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 507149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 507154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507170 */     GIR_RootConstrainSelectedInstOperands,
     /* 507171 */     // GIR_Coverage, 7598,
     /* 507171 */     GIR_EraseRootFromParent_Done,
     /* 507172 */   // Label 6777: @507172
     /* 507172 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(507301), // Rule ID 11626 //
     /* 507177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 507217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 507221 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507226 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507258 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 507268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 507273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 507278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 507283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507299 */     GIR_RootConstrainSelectedInstOperands,
     /* 507300 */     // GIR_Coverage, 11626,
     /* 507300 */     GIR_EraseRootFromParent_Done,
     /* 507301 */   // Label 6778: @507301
     /* 507301 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(507430), // Rule ID 11629 //
     /* 507306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 507346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 507350 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507355 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507387 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 507397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 507402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 507407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 507412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507428 */     GIR_RootConstrainSelectedInstOperands,
     /* 507429 */     // GIR_Coverage, 11629,
     /* 507429 */     GIR_EraseRootFromParent_Done,
     /* 507430 */   // Label 6779: @507430
     /* 507430 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(507559), // Rule ID 11630 //
     /* 507435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 507475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 507479 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507484 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507516 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 507526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 507531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 507536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 507541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507557 */     GIR_RootConstrainSelectedInstOperands,
     /* 507558 */     // GIR_Coverage, 11630,
     /* 507558 */     GIR_EraseRootFromParent_Done,
     /* 507559 */   // Label 6780: @507559
     /* 507559 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(507688), // Rule ID 7597 //
     /* 507564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 507604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507608 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507613 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507618 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507631 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507638 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507645 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 507655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 507660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 507665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 507670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507686 */     GIR_RootConstrainSelectedInstOperands,
     /* 507687 */     // GIR_Coverage, 7597,
     /* 507687 */     GIR_EraseRootFromParent_Done,
     /* 507688 */   // Label 6781: @507688
     /* 507688 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(507817), // Rule ID 11611 //
     /* 507693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 507733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507737 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507742 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507747 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507751 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507767 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507774 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 507784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 507789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 507794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 507799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507815 */     GIR_RootConstrainSelectedInstOperands,
     /* 507816 */     // GIR_Coverage, 11611,
     /* 507816 */     GIR_EraseRootFromParent_Done,
     /* 507817 */   // Label 6782: @507817
     /* 507817 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(507946), // Rule ID 11614 //
     /* 507822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 507862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507866 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 507871 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 507876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507896 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507903 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 507906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 507913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 507918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 507923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 507928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507944 */     GIR_RootConstrainSelectedInstOperands,
     /* 507945 */     // GIR_Coverage, 11614,
     /* 507945 */     GIR_EraseRootFromParent_Done,
     /* 507946 */   // Label 6783: @507946
     /* 507946 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(508075), // Rule ID 11615 //
     /* 507951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 507967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 507971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 507975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 507979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 507983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 507987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 507991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507995 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508000 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508005 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508025 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508032 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 508052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 508057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508073 */     GIR_RootConstrainSelectedInstOperands,
     /* 508074 */     // GIR_Coverage, 11615,
     /* 508074 */     GIR_EraseRootFromParent_Done,
     /* 508075 */   // Label 6784: @508075
     /* 508075 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(508204), // Rule ID 11597 //
     /* 508080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 508120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 508124 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508129 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508161 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 508171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 508176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 508181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 508186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508202 */     GIR_RootConstrainSelectedInstOperands,
     /* 508203 */     // GIR_Coverage, 11597,
     /* 508203 */     GIR_EraseRootFromParent_Done,
     /* 508204 */   // Label 6785: @508204
     /* 508204 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(508333), // Rule ID 11598 //
     /* 508209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 508249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 508253 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508258 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508283 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508290 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 508300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 508305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 508310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 508315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508331 */     GIR_RootConstrainSelectedInstOperands,
     /* 508332 */     // GIR_Coverage, 11598,
     /* 508332 */     GIR_EraseRootFromParent_Done,
     /* 508333 */   // Label 6786: @508333
     /* 508333 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(508462), // Rule ID 11601 //
     /* 508338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 508378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 508382 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508387 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508396 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508419 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 508439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 508444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508460 */     GIR_RootConstrainSelectedInstOperands,
     /* 508461 */     // GIR_Coverage, 11601,
     /* 508461 */     GIR_EraseRootFromParent_Done,
     /* 508462 */   // Label 6787: @508462
     /* 508462 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(508591), // Rule ID 11602 //
     /* 508467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 508507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 508511 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508516 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508541 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508548 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 508568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 508573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508589 */     GIR_RootConstrainSelectedInstOperands,
     /* 508590 */     // GIR_Coverage, 11602,
     /* 508590 */     GIR_EraseRootFromParent_Done,
     /* 508591 */   // Label 6788: @508591
     /* 508591 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(508720), // Rule ID 11582 //
     /* 508596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 508636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 508640 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508645 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508654 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508670 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508677 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 508687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 508692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 508697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 508702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508718 */     GIR_RootConstrainSelectedInstOperands,
     /* 508719 */     // GIR_Coverage, 11582,
     /* 508719 */     GIR_EraseRootFromParent_Done,
     /* 508720 */   // Label 6789: @508720
     /* 508720 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(508849), // Rule ID 11583 //
     /* 508725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 508765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 508769 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508774 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508806 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 508816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 508821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 508826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 508831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508847 */     GIR_RootConstrainSelectedInstOperands,
     /* 508848 */     // GIR_Coverage, 11583,
     /* 508848 */     GIR_EraseRootFromParent_Done,
     /* 508849 */   // Label 6790: @508849
     /* 508849 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(508978), // Rule ID 11586 //
     /* 508854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 508874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 508878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 508886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 508890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 508894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 508898 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 508903 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 508908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508935 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 508938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 508955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 508960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508976 */     GIR_RootConstrainSelectedInstOperands,
     /* 508977 */     // GIR_Coverage, 11586,
     /* 508977 */     GIR_EraseRootFromParent_Done,
     /* 508978 */   // Label 6791: @508978
     /* 508978 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(509107), // Rule ID 11587 //
     /* 508983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 508999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 509023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 509027 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509032 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509037 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509064 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 509074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 509079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 509084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 509089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509105 */     GIR_RootConstrainSelectedInstOperands,
     /* 509106 */     // GIR_Coverage, 11587,
     /* 509106 */     GIR_EraseRootFromParent_Done,
     /* 509107 */   // Label 6792: @509107
     /* 509107 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(509236), // Rule ID 7596 //
     /* 509112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 509152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 509156 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509161 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509193 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 509203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 509208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 509213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 509218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509234 */     GIR_RootConstrainSelectedInstOperands,
     /* 509235 */     // GIR_Coverage, 7596,
     /* 509235 */     GIR_EraseRootFromParent_Done,
     /* 509236 */   // Label 6793: @509236
     /* 509236 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(509365), // Rule ID 11596 //
     /* 509241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 509281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 509285 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509290 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509295 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509322 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 509332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 509337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 509342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 509347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509363 */     GIR_RootConstrainSelectedInstOperands,
     /* 509364 */     // GIR_Coverage, 11596,
     /* 509364 */     GIR_EraseRootFromParent_Done,
     /* 509365 */   // Label 6794: @509365
     /* 509365 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(509494), // Rule ID 11599 //
     /* 509370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 509410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 509414 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509419 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509451 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 509461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 509466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 509471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 509476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509492 */     GIR_RootConstrainSelectedInstOperands,
     /* 509493 */     // GIR_Coverage, 11599,
     /* 509493 */     GIR_EraseRootFromParent_Done,
     /* 509494 */   // Label 6795: @509494
     /* 509494 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(509623), // Rule ID 11600 //
     /* 509499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509531 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 509539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 509543 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509548 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509553 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509580 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 509590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 509595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 509600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 509605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509621 */     GIR_RootConstrainSelectedInstOperands,
     /* 509622 */     // GIR_Coverage, 11600,
     /* 509622 */     GIR_EraseRootFromParent_Done,
     /* 509623 */   // Label 6796: @509623
     /* 509623 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(509752), // Rule ID 7595 //
     /* 509628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 509668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 509672 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509677 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509682 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509709 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 509719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 509724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 509729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 509734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509750 */     GIR_RootConstrainSelectedInstOperands,
     /* 509751 */     // GIR_Coverage, 7595,
     /* 509751 */     GIR_EraseRootFromParent_Done,
     /* 509752 */   // Label 6797: @509752
     /* 509752 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(509881), // Rule ID 11581 //
     /* 509757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 509797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 509801 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509806 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509838 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 509848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 509853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 509858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 509863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509879 */     GIR_RootConstrainSelectedInstOperands,
     /* 509880 */     // GIR_Coverage, 11581,
     /* 509880 */     GIR_EraseRootFromParent_Done,
     /* 509881 */   // Label 6798: @509881
     /* 509881 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(510010), // Rule ID 11584 //
     /* 509886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 509902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 509906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 509910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 509918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 509922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 509926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 509930 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 509930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 509935 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 509935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 509940 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 509944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 509946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509967 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 509970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 509977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 509982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 509987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 509992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 510002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510008 */     GIR_RootConstrainSelectedInstOperands,
     /* 510009 */     // GIR_Coverage, 11584,
     /* 510009 */     GIR_EraseRootFromParent_Done,
     /* 510010 */   // Label 6799: @510010
     /* 510010 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(510139), // Rule ID 11585 //
     /* 510015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 510039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 510043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 510055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 510059 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 510064 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 510069 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510096 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 510106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 510111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 510116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 510121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 510126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 510131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510137 */     GIR_RootConstrainSelectedInstOperands,
     /* 510138 */     // GIR_Coverage, 11585,
     /* 510138 */     GIR_EraseRootFromParent_Done,
     /* 510139 */   // Label 6800: @510139
     /* 510139 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(510268), // Rule ID 11637 //
     /* 510144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 510168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 510184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510188 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 510193 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 510198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510225 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 510235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 510240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 510245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 510250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 510255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 510260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510266 */     GIR_RootConstrainSelectedInstOperands,
     /* 510267 */     // GIR_Coverage, 11637,
     /* 510267 */     GIR_EraseRootFromParent_Done,
     /* 510268 */   // Label 6801: @510268
     /* 510268 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(510397), // Rule ID 11638 //
     /* 510273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 510297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 510313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510317 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 510322 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 510327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510354 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 510364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 510369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 510374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 510379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 510384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 510389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510395 */     GIR_RootConstrainSelectedInstOperands,
     /* 510396 */     // GIR_Coverage, 11638,
     /* 510396 */     GIR_EraseRootFromParent_Done,
     /* 510397 */   // Label 6802: @510397
     /* 510397 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(510526), // Rule ID 11639 //
     /* 510402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 510426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 510442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510446 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 510451 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 510456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510483 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 510493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 510498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 510503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 510508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 510513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 510518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510524 */     GIR_RootConstrainSelectedInstOperands,
     /* 510525 */     // GIR_Coverage, 11639,
     /* 510525 */     GIR_EraseRootFromParent_Done,
     /* 510526 */   // Label 6803: @510526
     /* 510526 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(510655), // Rule ID 11640 //
     /* 510531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 510555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 510571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510575 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 510580 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 510585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510598 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510612 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 510622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 510627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 510632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 510637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 510642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 510647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510653 */     GIR_RootConstrainSelectedInstOperands,
     /* 510654 */     // GIR_Coverage, 11640,
     /* 510654 */     GIR_EraseRootFromParent_Done,
     /* 510655 */   // Label 6804: @510655
     /* 510655 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(510784), // Rule ID 11577 //
     /* 510660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 510684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 510700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 510704 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 510709 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 510714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510718 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510741 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 510751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 510756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 510761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 510766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 510771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 510776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510782 */     GIR_RootConstrainSelectedInstOperands,
     /* 510783 */     // GIR_Coverage, 11577,
     /* 510783 */     GIR_EraseRootFromParent_Done,
     /* 510784 */   // Label 6805: @510784
     /* 510784 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(510913), // Rule ID 11578 //
     /* 510789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 510813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 510829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 510833 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 510838 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 510843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510863 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510870 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 510880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 510885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 510890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 510895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 510900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 510905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510911 */     GIR_RootConstrainSelectedInstOperands,
     /* 510912 */     // GIR_Coverage, 11578,
     /* 510912 */     GIR_EraseRootFromParent_Done,
     /* 510913 */   // Label 6806: @510913
     /* 510913 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(511042), // Rule ID 11579 //
     /* 510918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 510942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 510958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 510962 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 510967 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 510972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510999 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 511009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 511014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 511019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 511024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511040 */     GIR_RootConstrainSelectedInstOperands,
     /* 511041 */     // GIR_Coverage, 11579,
     /* 511041 */     GIR_EraseRootFromParent_Done,
     /* 511042 */   // Label 6807: @511042
     /* 511042 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(511171), // Rule ID 11580 //
     /* 511047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 511075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 511091 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511096 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511128 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 511138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 511143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 511148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 511153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511169 */     GIR_RootConstrainSelectedInstOperands,
     /* 511170 */     // GIR_Coverage, 11580,
     /* 511170 */     GIR_EraseRootFromParent_Done,
     /* 511171 */   // Label 6808: @511171
     /* 511171 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(511300), // Rule ID 11622 //
     /* 511176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511220 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511225 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511250 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511257 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 511267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 511272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 511277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 511282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511298 */     GIR_RootConstrainSelectedInstOperands,
     /* 511299 */     // GIR_Coverage, 11622,
     /* 511299 */     GIR_EraseRootFromParent_Done,
     /* 511300 */   // Label 6809: @511300
     /* 511300 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(511429), // Rule ID 11623 //
     /* 511305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511349 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511354 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511359 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511386 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 511396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 511401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 511406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 511411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511427 */     GIR_RootConstrainSelectedInstOperands,
     /* 511428 */     // GIR_Coverage, 11623,
     /* 511428 */     GIR_EraseRootFromParent_Done,
     /* 511429 */   // Label 6810: @511429
     /* 511429 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(511558), // Rule ID 11624 //
     /* 511434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511478 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511483 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511488 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511508 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511515 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 511525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 511530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 511535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 511540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511556 */     GIR_RootConstrainSelectedInstOperands,
     /* 511557 */     // GIR_Coverage, 11624,
     /* 511557 */     GIR_EraseRootFromParent_Done,
     /* 511558 */   // Label 6811: @511558
     /* 511558 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(511687), // Rule ID 11625 //
     /* 511563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511607 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511607 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511612 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511644 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 511654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 511659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 511664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 511669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511685 */     GIR_RootConstrainSelectedInstOperands,
     /* 511686 */     // GIR_Coverage, 11625,
     /* 511686 */     GIR_EraseRootFromParent_Done,
     /* 511687 */   // Label 6812: @511687
     /* 511687 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(511816), // Rule ID 11562 //
     /* 511692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 511736 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511741 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511746 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511766 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511773 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 511783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 511788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 511793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 511798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511814 */     GIR_RootConstrainSelectedInstOperands,
     /* 511815 */     // GIR_Coverage, 11562,
     /* 511815 */     GIR_EraseRootFromParent_Done,
     /* 511816 */   // Label 6813: @511816
     /* 511816 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(511945), // Rule ID 11563 //
     /* 511821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 511865 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511870 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 511875 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511879 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511895 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511902 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 511912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 511917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 511922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 511927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 511932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 511937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511943 */     GIR_RootConstrainSelectedInstOperands,
     /* 511944 */     // GIR_Coverage, 11563,
     /* 511944 */     GIR_EraseRootFromParent_Done,
     /* 511945 */   // Label 6814: @511945
     /* 511945 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(512074), // Rule ID 11564 //
     /* 511950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 511974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 511990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 511994 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 511999 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512004 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512031 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 512041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 512046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 512061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 512066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512072 */     GIR_RootConstrainSelectedInstOperands,
     /* 512073 */     // GIR_Coverage, 11564,
     /* 512073 */     GIR_EraseRootFromParent_Done,
     /* 512074 */   // Label 6815: @512074
     /* 512074 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(512203), // Rule ID 11565 //
     /* 512079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 512103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 512107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512111 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 512123 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512123 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512128 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512128 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512133 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512137 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512139 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512153 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512160 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 512170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 512175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 512190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 512195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512201 */     GIR_RootConstrainSelectedInstOperands,
     /* 512202 */     // GIR_Coverage, 11565,
     /* 512202 */     GIR_EraseRootFromParent_Done,
     /* 512203 */   // Label 6816: @512203
     /* 512203 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(512332), // Rule ID 11633 //
     /* 512208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 512232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512252 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512252 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512257 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512282 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512289 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 512299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 512304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512330 */     GIR_RootConstrainSelectedInstOperands,
     /* 512331 */     // GIR_Coverage, 11633,
     /* 512331 */     GIR_EraseRootFromParent_Done,
     /* 512332 */   // Label 6817: @512332
     /* 512332 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(512461), // Rule ID 11634 //
     /* 512337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 512361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512381 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512386 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512411 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512418 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 512428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 512433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512459 */     GIR_RootConstrainSelectedInstOperands,
     /* 512460 */     // GIR_Coverage, 11634,
     /* 512460 */     GIR_EraseRootFromParent_Done,
     /* 512461 */   // Label 6818: @512461
     /* 512461 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(512590), // Rule ID 11635 //
     /* 512466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 512490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512510 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512515 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512526 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512540 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512547 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 512557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 512562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 512567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 512572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512588 */     GIR_RootConstrainSelectedInstOperands,
     /* 512589 */     // GIR_Coverage, 11635,
     /* 512589 */     GIR_EraseRootFromParent_Done,
     /* 512590 */   // Label 6819: @512590
     /* 512590 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(512719), // Rule ID 11636 //
     /* 512595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 512619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512639 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512644 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512669 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512676 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 512686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 512691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 512696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 512701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512717 */     GIR_RootConstrainSelectedInstOperands,
     /* 512718 */     // GIR_Coverage, 11636,
     /* 512718 */     GIR_EraseRootFromParent_Done,
     /* 512719 */   // Label 6820: @512719
     /* 512719 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(512848), // Rule ID 11573 //
     /* 512724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 512748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 512768 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512768 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512773 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512778 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512805 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 512815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 512820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512846 */     GIR_RootConstrainSelectedInstOperands,
     /* 512847 */     // GIR_Coverage, 11573,
     /* 512847 */     GIR_EraseRootFromParent_Done,
     /* 512848 */   // Label 6821: @512848
     /* 512848 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(512977), // Rule ID 11574 //
     /* 512853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 512877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 512893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 512897 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512897 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 512902 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512902 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 512907 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512927 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512934 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 512944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 512949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512975 */     GIR_RootConstrainSelectedInstOperands,
     /* 512976 */     // GIR_Coverage, 11574,
     /* 512976 */     GIR_EraseRootFromParent_Done,
     /* 512977 */   // Label 6822: @512977
     /* 512977 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(513106), // Rule ID 11575 //
     /* 512982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 513010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513026 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513031 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513049 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513063 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 513073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 513078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 513083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 513088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513104 */     GIR_RootConstrainSelectedInstOperands,
     /* 513105 */     // GIR_Coverage, 11575,
     /* 513105 */     GIR_EraseRootFromParent_Done,
     /* 513106 */   // Label 6823: @513106
     /* 513106 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(513235), // Rule ID 11576 //
     /* 513111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 513139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513151 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513155 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513155 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513160 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513160 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513165 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513185 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513192 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 513202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 513207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 513212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 513217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513233 */     GIR_RootConstrainSelectedInstOperands,
     /* 513234 */     // GIR_Coverage, 11576,
     /* 513234 */     GIR_EraseRootFromParent_Done,
     /* 513235 */   // Label 6824: @513235
     /* 513235 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(513364), // Rule ID 11618 //
     /* 513240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513284 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513289 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513307 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513321 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 513331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 513336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 513341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 513346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513362 */     GIR_RootConstrainSelectedInstOperands,
     /* 513363 */     // GIR_Coverage, 11618,
     /* 513363 */     GIR_EraseRootFromParent_Done,
     /* 513364 */   // Label 6825: @513364
     /* 513364 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(513493), // Rule ID 11619 //
     /* 513369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513413 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513418 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513418 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513423 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513443 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513450 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 513460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 513465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 513470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 513475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513491 */     GIR_RootConstrainSelectedInstOperands,
     /* 513492 */     // GIR_Coverage, 11619,
     /* 513492 */     GIR_EraseRootFromParent_Done,
     /* 513493 */   // Label 6826: @513493
     /* 513493 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(513622), // Rule ID 11620 //
     /* 513498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513542 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513547 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513552 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513565 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513579 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 513589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 513594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 513599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 513604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513620 */     GIR_RootConstrainSelectedInstOperands,
     /* 513621 */     // GIR_Coverage, 11620,
     /* 513621 */     GIR_EraseRootFromParent_Done,
     /* 513622 */   // Label 6827: @513622
     /* 513622 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(513751), // Rule ID 11621 //
     /* 513627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513671 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513676 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513708 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 513718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 513723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 513728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 513733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513749 */     GIR_RootConstrainSelectedInstOperands,
     /* 513750 */     // GIR_Coverage, 11621,
     /* 513750 */     GIR_EraseRootFromParent_Done,
     /* 513751 */   // Label 6828: @513751
     /* 513751 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(513880), // Rule ID 11558 //
     /* 513756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513792 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513796 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513800 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513805 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513810 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513814 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513823 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513837 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 513847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 513852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 513857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 513862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513878 */     GIR_RootConstrainSelectedInstOperands,
     /* 513879 */     // GIR_Coverage, 11558,
     /* 513879 */     GIR_EraseRootFromParent_Done,
     /* 513880 */   // Label 6829: @513880
     /* 513880 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(514009), // Rule ID 11559 //
     /* 513885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 513909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 513925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513929 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 513934 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 513939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513966 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 513976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 513981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 513986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 513991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514007 */     GIR_RootConstrainSelectedInstOperands,
     /* 514008 */     // GIR_Coverage, 11559,
     /* 514008 */     GIR_EraseRootFromParent_Done,
     /* 514009 */   // Label 6830: @514009
     /* 514009 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(514138), // Rule ID 11560 //
     /* 514014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 514038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 514042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 514054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514058 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 514063 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 514068 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514095 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 514105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 514110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 514115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 514120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514136 */     GIR_RootConstrainSelectedInstOperands,
     /* 514137 */     // GIR_Coverage, 11560,
     /* 514137 */     GIR_EraseRootFromParent_Done,
     /* 514138 */   // Label 6831: @514138
     /* 514138 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(514267), // Rule ID 11561 //
     /* 514143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 514167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 514171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 514183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514187 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 514192 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 514197 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514210 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514224 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 514234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 514239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 514244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 514249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514265 */     GIR_RootConstrainSelectedInstOperands,
     /* 514266 */     // GIR_Coverage, 11561,
     /* 514266 */     GIR_EraseRootFromParent_Done,
     /* 514267 */   // Label 6832: @514267
     /* 514267 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(514396), // Rule ID 11567 //
     /* 514272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 514312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 514316 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 514321 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 514326 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514353 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 514363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 514368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 514373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 514378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514394 */     GIR_RootConstrainSelectedInstOperands,
     /* 514395 */     // GIR_Coverage, 11567,
     /* 514395 */     GIR_EraseRootFromParent_Done,
     /* 514396 */   // Label 6833: @514396
     /* 514396 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(514525), // Rule ID 11568 //
     /* 514401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 514441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 514445 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 514450 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 514455 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514482 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 514492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 514497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 514502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 514507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514523 */     GIR_RootConstrainSelectedInstOperands,
     /* 514524 */     // GIR_Coverage, 11568,
     /* 514524 */     GIR_EraseRootFromParent_Done,
     /* 514525 */   // Label 6834: @514525
     /* 514525 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(514654), // Rule ID 11571 //
     /* 514530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 514570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 514574 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 514579 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 514584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514588 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514611 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 514621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 514626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 514631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 514636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514652 */     GIR_RootConstrainSelectedInstOperands,
     /* 514653 */     // GIR_Coverage, 11571,
     /* 514653 */     GIR_EraseRootFromParent_Done,
     /* 514654 */   // Label 6835: @514654
     /* 514654 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(514783), // Rule ID 11572 //
     /* 514659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 514699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 514703 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 514708 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 514713 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514733 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514740 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 514750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 514755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 514760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 514765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514781 */     GIR_RootConstrainSelectedInstOperands,
     /* 514782 */     // GIR_Coverage, 11572,
     /* 514782 */     GIR_EraseRootFromParent_Done,
     /* 514783 */   // Label 6836: @514783
     /* 514783 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(514912), // Rule ID 11552 //
     /* 514788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 514828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 514832 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 514837 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 514842 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514869 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 514879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 514884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 514889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 514894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514910 */     GIR_RootConstrainSelectedInstOperands,
     /* 514911 */     // GIR_Coverage, 11552,
     /* 514911 */     GIR_EraseRootFromParent_Done,
     /* 514912 */   // Label 6837: @514912
     /* 514912 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(515041), // Rule ID 11553 //
     /* 514917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 514957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 514961 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 514966 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 514971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514998 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 515008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 515013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 515018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 515023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515039 */     GIR_RootConstrainSelectedInstOperands,
     /* 515040 */     // GIR_Coverage, 11553,
     /* 515040 */     GIR_EraseRootFromParent_Done,
     /* 515041 */   // Label 6838: @515041
     /* 515041 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(515170), // Rule ID 11556 //
     /* 515046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 515086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 515090 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515095 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515127 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 515137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 515142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 515147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 515152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515168 */     GIR_RootConstrainSelectedInstOperands,
     /* 515169 */     // GIR_Coverage, 11556,
     /* 515169 */     GIR_EraseRootFromParent_Done,
     /* 515170 */   // Label 6839: @515170
     /* 515170 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(515299), // Rule ID 11557 //
     /* 515175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 515215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 515219 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515224 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515256 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 515266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 515271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 515276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 515281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515297 */     GIR_RootConstrainSelectedInstOperands,
     /* 515298 */     // GIR_Coverage, 11557,
     /* 515298 */     GIR_EraseRootFromParent_Done,
     /* 515299 */   // Label 6840: @515299
     /* 515299 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(515428), // Rule ID 7594 //
     /* 515304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 515344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 515348 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515353 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515358 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515385 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 515395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 515400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 515405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 515410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515426 */     GIR_RootConstrainSelectedInstOperands,
     /* 515427 */     // GIR_Coverage, 7594,
     /* 515427 */     GIR_EraseRootFromParent_Done,
     /* 515428 */   // Label 6841: @515428
     /* 515428 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(515557), // Rule ID 11566 //
     /* 515433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 515473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 515477 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515477 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515482 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515487 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515514 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 515524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 515529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 515534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 515539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515555 */     GIR_RootConstrainSelectedInstOperands,
     /* 515556 */     // GIR_Coverage, 11566,
     /* 515556 */     GIR_EraseRootFromParent_Done,
     /* 515557 */   // Label 6842: @515557
     /* 515557 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(515686), // Rule ID 11569 //
     /* 515562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 515602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 515606 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515611 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515643 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 515653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 515658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 515663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 515668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515684 */     GIR_RootConstrainSelectedInstOperands,
     /* 515685 */     // GIR_Coverage, 11569,
     /* 515685 */     GIR_EraseRootFromParent_Done,
     /* 515686 */   // Label 6843: @515686
     /* 515686 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(515815), // Rule ID 11570 //
     /* 515691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 515731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 515735 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515740 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515772 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 515782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 515787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 515792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 515797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515813 */     GIR_RootConstrainSelectedInstOperands,
     /* 515814 */     // GIR_Coverage, 11570,
     /* 515814 */     GIR_EraseRootFromParent_Done,
     /* 515815 */   // Label 6844: @515815
     /* 515815 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(515944), // Rule ID 7593 //
     /* 515820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 515860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 515864 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 515869 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515901 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 515911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 515916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 515921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 515926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 515931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 515936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515942 */     GIR_RootConstrainSelectedInstOperands,
     /* 515943 */     // GIR_Coverage, 7593,
     /* 515943 */     GIR_EraseRootFromParent_Done,
     /* 515944 */   // Label 6845: @515944
     /* 515944 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(516073), // Rule ID 11551 //
     /* 515949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 515973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 515989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 515993 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 515998 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516003 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516030 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 516040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 516045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 516050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 516055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516071 */     GIR_RootConstrainSelectedInstOperands,
     /* 516072 */     // GIR_Coverage, 11551,
     /* 516072 */     GIR_EraseRootFromParent_Done,
     /* 516073 */   // Label 6846: @516073
     /* 516073 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(516202), // Rule ID 11554 //
     /* 516078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 516118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 516122 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516122 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516127 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516132 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516138 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516152 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516159 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 516169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 516174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 516179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 516184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516200 */     GIR_RootConstrainSelectedInstOperands,
     /* 516201 */     // GIR_Coverage, 11554,
     /* 516201 */     GIR_EraseRootFromParent_Done,
     /* 516202 */   // Label 6847: @516202
     /* 516202 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(516331), // Rule ID 11555 //
     /* 516207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 516247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 516251 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516256 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516288 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 516298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 516303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 516308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 516313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516329 */     GIR_RootConstrainSelectedInstOperands,
     /* 516330 */     // GIR_Coverage, 11555,
     /* 516330 */     GIR_EraseRootFromParent_Done,
     /* 516331 */   // Label 6848: @516331
     /* 516331 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(516460), // Rule ID 11537 //
     /* 516336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 516376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 516380 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516385 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516390 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516410 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516417 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 516427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 516432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 516437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 516442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516458 */     GIR_RootConstrainSelectedInstOperands,
     /* 516459 */     // GIR_Coverage, 11537,
     /* 516459 */     GIR_EraseRootFromParent_Done,
     /* 516460 */   // Label 6849: @516460
     /* 516460 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(516589), // Rule ID 11538 //
     /* 516465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 516505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 516509 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516514 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516519 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516546 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 516556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 516561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 516566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 516571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516587 */     GIR_RootConstrainSelectedInstOperands,
     /* 516588 */     // GIR_Coverage, 11538,
     /* 516588 */     GIR_EraseRootFromParent_Done,
     /* 516589 */   // Label 6850: @516589
     /* 516589 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(516718), // Rule ID 11541 //
     /* 516594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 516634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 516638 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516643 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516643 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516648 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516675 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 516685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 516690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 516695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 516700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516716 */     GIR_RootConstrainSelectedInstOperands,
     /* 516717 */     // GIR_Coverage, 11541,
     /* 516717 */     GIR_EraseRootFromParent_Done,
     /* 516718 */   // Label 6851: @516718
     /* 516718 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(516847), // Rule ID 11542 //
     /* 516723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 516763 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 516767 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516772 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516777 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516804 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 516814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 516819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 516824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 516829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516845 */     GIR_RootConstrainSelectedInstOperands,
     /* 516846 */     // GIR_Coverage, 11542,
     /* 516846 */     GIR_EraseRootFromParent_Done,
     /* 516847 */   // Label 6852: @516847
     /* 516847 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(516976), // Rule ID 11522 //
     /* 516852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 516876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 516892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 516896 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 516901 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 516906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516910 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516926 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516933 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 516943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 516948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 516953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 516958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516974 */     GIR_RootConstrainSelectedInstOperands,
     /* 516975 */     // GIR_Coverage, 11522,
     /* 516975 */     GIR_EraseRootFromParent_Done,
     /* 516976 */   // Label 6853: @516976
     /* 516976 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(517105), // Rule ID 11523 //
     /* 516981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 517021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 517025 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517025 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517030 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517030 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517039 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517055 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517062 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 517072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 517077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 517082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 517087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517103 */     GIR_RootConstrainSelectedInstOperands,
     /* 517104 */     // GIR_Coverage, 11523,
     /* 517104 */     GIR_EraseRootFromParent_Done,
     /* 517105 */   // Label 6854: @517105
     /* 517105 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(517234), // Rule ID 11526 //
     /* 517110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 517150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 517154 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517159 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517164 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517191 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 517201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 517206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 517211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 517216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517232 */     GIR_RootConstrainSelectedInstOperands,
     /* 517233 */     // GIR_Coverage, 11526,
     /* 517233 */     GIR_EraseRootFromParent_Done,
     /* 517234 */   // Label 6855: @517234
     /* 517234 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(517363), // Rule ID 11527 //
     /* 517239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 517279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 517283 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517288 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517313 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517320 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 517330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 517335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 517340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 517345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517361 */     GIR_RootConstrainSelectedInstOperands,
     /* 517362 */     // GIR_Coverage, 11527,
     /* 517362 */     GIR_EraseRootFromParent_Done,
     /* 517363 */   // Label 6856: @517363
     /* 517363 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(517492), // Rule ID 7592 //
     /* 517368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 517408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 517412 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517417 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517422 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517442 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517449 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 517459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 517464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 517469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 517474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517490 */     GIR_RootConstrainSelectedInstOperands,
     /* 517491 */     // GIR_Coverage, 7592,
     /* 517491 */     GIR_EraseRootFromParent_Done,
     /* 517492 */   // Label 6857: @517492
     /* 517492 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(517621), // Rule ID 11536 //
     /* 517497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 517537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 517541 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517546 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517578 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 517588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 517593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 517598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 517603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517619 */     GIR_RootConstrainSelectedInstOperands,
     /* 517620 */     // GIR_Coverage, 11536,
     /* 517620 */     GIR_EraseRootFromParent_Done,
     /* 517621 */   // Label 6858: @517621
     /* 517621 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(517750), // Rule ID 11539 //
     /* 517626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 517666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 517670 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517675 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517680 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517707 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 517717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 517722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 517727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 517732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517748 */     GIR_RootConstrainSelectedInstOperands,
     /* 517749 */     // GIR_Coverage, 11539,
     /* 517749 */     GIR_EraseRootFromParent_Done,
     /* 517750 */   // Label 6859: @517750
     /* 517750 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(517879), // Rule ID 11540 //
     /* 517755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 517795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 517799 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517804 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517836 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 517846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 517851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 517856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 517861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517877 */     GIR_RootConstrainSelectedInstOperands,
     /* 517878 */     // GIR_Coverage, 11540,
     /* 517878 */     GIR_EraseRootFromParent_Done,
     /* 517879 */   // Label 6860: @517879
     /* 517879 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(518008), // Rule ID 7591 //
     /* 517884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 517908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517916 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 517924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 517928 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 517933 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517933 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 517938 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517965 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 517975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 517980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 517985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 517990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518006 */     GIR_RootConstrainSelectedInstOperands,
     /* 518007 */     // GIR_Coverage, 7591,
     /* 518007 */     GIR_EraseRootFromParent_Done,
     /* 518008 */   // Label 6861: @518008
     /* 518008 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(518137), // Rule ID 11521 //
     /* 518013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 518037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 518053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 518057 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 518062 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 518067 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518087 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518094 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 518104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 518109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 518114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 518119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518135 */     GIR_RootConstrainSelectedInstOperands,
     /* 518136 */     // GIR_Coverage, 11521,
     /* 518136 */     GIR_EraseRootFromParent_Done,
     /* 518137 */   // Label 6862: @518137
     /* 518137 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(518266), // Rule ID 11524 //
     /* 518142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 518166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 518182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 518186 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 518191 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 518196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518216 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518223 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 518243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 518248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518264 */     GIR_RootConstrainSelectedInstOperands,
     /* 518265 */     // GIR_Coverage, 11524,
     /* 518265 */     GIR_EraseRootFromParent_Done,
     /* 518266 */   // Label 6863: @518266
     /* 518266 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(518395), // Rule ID 11525 //
     /* 518271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 518295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 518311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 518315 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 518320 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 518325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518352 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 518372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 518377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518393 */     GIR_RootConstrainSelectedInstOperands,
     /* 518394 */     // GIR_Coverage, 11525,
     /* 518394 */     GIR_EraseRootFromParent_Done,
     /* 518395 */   // Label 6864: @518395
     /* 518395 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(518524), // Rule ID 11607 //
     /* 518400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 518424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 518428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 518440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518444 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 518449 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 518454 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518481 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 518501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 518506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 518511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 518516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518522 */     GIR_RootConstrainSelectedInstOperands,
     /* 518523 */     // GIR_Coverage, 11607,
     /* 518523 */     GIR_EraseRootFromParent_Done,
     /* 518524 */   // Label 6865: @518524
     /* 518524 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(518653), // Rule ID 11608 //
     /* 518529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 518553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 518557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518561 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 518569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518573 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518573 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 518578 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518578 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 518583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518596 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518610 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 518630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 518635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 518640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 518645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518651 */     GIR_RootConstrainSelectedInstOperands,
     /* 518652 */     // GIR_Coverage, 11608,
     /* 518652 */     GIR_EraseRootFromParent_Done,
     /* 518653 */   // Label 6866: @518653
     /* 518653 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(518782), // Rule ID 11609 //
     /* 518658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 518682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 518686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 518698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518702 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 518707 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 518712 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518725 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518739 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 518749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 518754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 518759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 518764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 518769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 518774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518780 */     GIR_RootConstrainSelectedInstOperands,
     /* 518781 */     // GIR_Coverage, 11609,
     /* 518781 */     GIR_EraseRootFromParent_Done,
     /* 518782 */   // Label 6867: @518782
     /* 518782 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(518911), // Rule ID 11610 //
     /* 518787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 518811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 518815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 518827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518831 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 518836 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 518841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518868 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 518878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 518883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 518888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 518893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 518898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 518903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518909 */     GIR_RootConstrainSelectedInstOperands,
     /* 518910 */     // GIR_Coverage, 11610,
     /* 518910 */     GIR_EraseRootFromParent_Done,
     /* 518911 */   // Label 6868: @518911
     /* 518911 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(519040), // Rule ID 11547 //
     /* 518916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 518940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 518944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 518956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518960 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 518965 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518965 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 518970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518983 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518997 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 519007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 519012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 519017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 519022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519038 */     GIR_RootConstrainSelectedInstOperands,
     /* 519039 */     // GIR_Coverage, 11547,
     /* 519039 */     GIR_EraseRootFromParent_Done,
     /* 519040 */   // Label 6869: @519040
     /* 519040 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(519169), // Rule ID 11548 //
     /* 519045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 519073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519089 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519094 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519112 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519126 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 519136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 519141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 519146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 519151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519167 */     GIR_RootConstrainSelectedInstOperands,
     /* 519168 */     // GIR_Coverage, 11548,
     /* 519168 */     GIR_EraseRootFromParent_Done,
     /* 519169 */   // Label 6870: @519169
     /* 519169 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(519298), // Rule ID 11549 //
     /* 519174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 519202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519218 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519223 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519241 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519255 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 519265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 519270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 519275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 519280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519296 */     GIR_RootConstrainSelectedInstOperands,
     /* 519297 */     // GIR_Coverage, 11549,
     /* 519297 */     GIR_EraseRootFromParent_Done,
     /* 519298 */   // Label 6871: @519298
     /* 519298 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(519427), // Rule ID 11550 //
     /* 519303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 519331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519347 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519352 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519357 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519384 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 519394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 519399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 519404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 519409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519425 */     GIR_RootConstrainSelectedInstOperands,
     /* 519426 */     // GIR_Coverage, 11550,
     /* 519426 */     GIR_EraseRootFromParent_Done,
     /* 519427 */   // Label 6872: @519427
     /* 519427 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(519556), // Rule ID 11592 //
     /* 519432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 519460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519476 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519481 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519513 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 519523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 519528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 519533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 519538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519554 */     GIR_RootConstrainSelectedInstOperands,
     /* 519555 */     // GIR_Coverage, 11592,
     /* 519555 */     GIR_EraseRootFromParent_Done,
     /* 519556 */   // Label 6873: @519556
     /* 519556 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(519685), // Rule ID 11593 //
     /* 519561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 519589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519605 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519610 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519642 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 519652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 519657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 519662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 519667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519683 */     GIR_RootConstrainSelectedInstOperands,
     /* 519684 */     // GIR_Coverage, 11593,
     /* 519684 */     GIR_EraseRootFromParent_Done,
     /* 519685 */   // Label 6874: @519685
     /* 519685 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(519814), // Rule ID 11594 //
     /* 519690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 519718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519734 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519739 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519744 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519771 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 519781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 519786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 519791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 519796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519812 */     GIR_RootConstrainSelectedInstOperands,
     /* 519813 */     // GIR_Coverage, 11594,
     /* 519813 */     GIR_EraseRootFromParent_Done,
     /* 519814 */   // Label 6875: @519814
     /* 519814 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(519943), // Rule ID 11595 //
     /* 519819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 519847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519863 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519868 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 519873 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519877 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519900 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 519910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 519915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 519920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 519925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 519930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 519935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519941 */     GIR_RootConstrainSelectedInstOperands,
     /* 519942 */     // GIR_Coverage, 11595,
     /* 519942 */     GIR_EraseRootFromParent_Done,
     /* 519943 */   // Label 6876: @519943
     /* 519943 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(520072), // Rule ID 11532 //
     /* 519948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 519972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 519976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 519988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519992 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 519997 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520002 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520029 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 520039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 520044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 520049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 520054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 520059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 520064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520070 */     GIR_RootConstrainSelectedInstOperands,
     /* 520071 */     // GIR_Coverage, 11532,
     /* 520071 */     GIR_EraseRootFromParent_Done,
     /* 520072 */   // Label 6877: @520072
     /* 520072 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(520201), // Rule ID 11533 //
     /* 520077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 520101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 520105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520121 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520126 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520158 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 520168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 520173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 520178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 520183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 520188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 520193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520199 */     GIR_RootConstrainSelectedInstOperands,
     /* 520200 */     // GIR_Coverage, 11533,
     /* 520200 */     GIR_EraseRootFromParent_Done,
     /* 520201 */   // Label 6878: @520201
     /* 520201 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(520330), // Rule ID 11534 //
     /* 520206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 520230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 520234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520250 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520255 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520260 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520287 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 520297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 520302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 520317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 520322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520328 */     GIR_RootConstrainSelectedInstOperands,
     /* 520329 */     // GIR_Coverage, 11534,
     /* 520329 */     GIR_EraseRootFromParent_Done,
     /* 520330 */   // Label 6879: @520330
     /* 520330 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(520459), // Rule ID 11535 //
     /* 520335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 520359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 520363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520379 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520384 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520389 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520416 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 520426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 520431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 520446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 520451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520457 */     GIR_RootConstrainSelectedInstOperands,
     /* 520458 */     // GIR_Coverage, 11535,
     /* 520458 */     GIR_EraseRootFromParent_Done,
     /* 520459 */   // Label 6880: @520459
     /* 520459 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(520588), // Rule ID 11603 //
     /* 520464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 520488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 520492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520508 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520513 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520518 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520545 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 520555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 520560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 520580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520586 */     GIR_RootConstrainSelectedInstOperands,
     /* 520587 */     // GIR_Coverage, 11603,
     /* 520587 */     GIR_EraseRootFromParent_Done,
     /* 520588 */   // Label 6881: @520588
     /* 520588 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(520717), // Rule ID 11604 //
     /* 520593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 520617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 520621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520637 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520642 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520674 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 520684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 520689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 520709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520715 */     GIR_RootConstrainSelectedInstOperands,
     /* 520716 */     // GIR_Coverage, 11604,
     /* 520716 */     GIR_EraseRootFromParent_Done,
     /* 520717 */   // Label 6882: @520717
     /* 520717 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(520846), // Rule ID 11605 //
     /* 520722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 520746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 520750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520766 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520771 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520803 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 520813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 520818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 520823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 520828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 520838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520844 */     GIR_RootConstrainSelectedInstOperands,
     /* 520845 */     // GIR_Coverage, 11605,
     /* 520845 */     GIR_EraseRootFromParent_Done,
     /* 520846 */   // Label 6883: @520846
     /* 520846 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(520975), // Rule ID 11606 //
     /* 520851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 520875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 520879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 520891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520895 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520895 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 520900 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 520905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520932 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 520942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 520947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 520952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 520957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 520967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520973 */     GIR_RootConstrainSelectedInstOperands,
     /* 520974 */     // GIR_Coverage, 11606,
     /* 520974 */     GIR_EraseRootFromParent_Done,
     /* 520975 */   // Label 6884: @520975
     /* 520975 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(521104), // Rule ID 11543 //
     /* 520980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521024 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521029 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521034 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521061 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 521071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 521076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 521081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 521086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521102 */     GIR_RootConstrainSelectedInstOperands,
     /* 521103 */     // GIR_Coverage, 11543,
     /* 521103 */     GIR_EraseRootFromParent_Done,
     /* 521104 */   // Label 6885: @521104
     /* 521104 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(521233), // Rule ID 11544 //
     /* 521109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521153 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521158 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521163 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521167 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521190 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 521200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 521205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 521210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 521215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521231 */     GIR_RootConstrainSelectedInstOperands,
     /* 521232 */     // GIR_Coverage, 11544,
     /* 521232 */     GIR_EraseRootFromParent_Done,
     /* 521233 */   // Label 6886: @521233
     /* 521233 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(521362), // Rule ID 11545 //
     /* 521238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521282 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521287 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521292 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521319 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 521329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 521334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 521339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 521344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521360 */     GIR_RootConstrainSelectedInstOperands,
     /* 521361 */     // GIR_Coverage, 11545,
     /* 521361 */     GIR_EraseRootFromParent_Done,
     /* 521362 */   // Label 6887: @521362
     /* 521362 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(521491), // Rule ID 11546 //
     /* 521367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521411 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521416 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521448 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 521458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 521463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 521468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 521473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521489 */     GIR_RootConstrainSelectedInstOperands,
     /* 521490 */     // GIR_Coverage, 11546,
     /* 521490 */     GIR_EraseRootFromParent_Done,
     /* 521491 */   // Label 6888: @521491
     /* 521491 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(521620), // Rule ID 11588 //
     /* 521496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 521524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 521540 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521545 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521545 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521550 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521563 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521577 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 521587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 521592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 521597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 521602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521618 */     GIR_RootConstrainSelectedInstOperands,
     /* 521619 */     // GIR_Coverage, 11588,
     /* 521619 */     GIR_EraseRootFromParent_Done,
     /* 521620 */   // Label 6889: @521620
     /* 521620 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(521749), // Rule ID 11589 //
     /* 521625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 521653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 521669 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521674 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521706 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 521716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 521721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 521726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 521731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521747 */     GIR_RootConstrainSelectedInstOperands,
     /* 521748 */     // GIR_Coverage, 11589,
     /* 521748 */     GIR_EraseRootFromParent_Done,
     /* 521749 */   // Label 6890: @521749
     /* 521749 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(521878), // Rule ID 11590 //
     /* 521754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 521782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 521798 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521803 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521828 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521835 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 521845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 521850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 521855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 521860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521876 */     GIR_RootConstrainSelectedInstOperands,
     /* 521877 */     // GIR_Coverage, 11590,
     /* 521877 */     GIR_EraseRootFromParent_Done,
     /* 521878 */   // Label 6891: @521878
     /* 521878 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(522007), // Rule ID 11591 //
     /* 521883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 521907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 521911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521915 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 521923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 521927 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 521932 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 521937 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521964 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 521974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 521979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 521984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 521989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522005 */     GIR_RootConstrainSelectedInstOperands,
     /* 522006 */     // GIR_Coverage, 11591,
     /* 522006 */     GIR_EraseRootFromParent_Done,
     /* 522007 */   // Label 6892: @522007
     /* 522007 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(522136), // Rule ID 11528 //
     /* 522012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 522052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522056 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 522061 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 522066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522093 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 522103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 522108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 522113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 522118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522134 */     GIR_RootConstrainSelectedInstOperands,
     /* 522135 */     // GIR_Coverage, 11528,
     /* 522135 */     GIR_EraseRootFromParent_Done,
     /* 522136 */   // Label 6893: @522136
     /* 522136 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(522265), // Rule ID 11529 //
     /* 522141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 522181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522185 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 522190 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 522195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522215 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522222 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 522232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 522237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 522242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 522247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522263 */     GIR_RootConstrainSelectedInstOperands,
     /* 522264 */     // GIR_Coverage, 11529,
     /* 522264 */     GIR_EraseRootFromParent_Done,
     /* 522265 */   // Label 6894: @522265
     /* 522265 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(522394), // Rule ID 11530 //
     /* 522270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 522310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522314 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 522319 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 522324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522328 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522351 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 522371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 522376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522392 */     GIR_RootConstrainSelectedInstOperands,
     /* 522393 */     // GIR_Coverage, 11530,
     /* 522393 */     GIR_EraseRootFromParent_Done,
     /* 522394 */   // Label 6895: @522394
     /* 522394 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(522523), // Rule ID 11531 //
     /* 522399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 522439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522443 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 522448 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 522453 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522480 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 522500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 522505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522521 */     GIR_RootConstrainSelectedInstOperands,
     /* 522522 */     // GIR_Coverage, 11531,
     /* 522522 */     GIR_EraseRootFromParent_Done,
     /* 522523 */   // Label 6896: @522523
     /* 522523 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(522635), // Rule ID 13248 //
     /* 522528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 522531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 522539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 522543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 522555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522563 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 522565 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 522569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 522571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522585 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522592 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 522595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 522612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 522617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 522622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 522627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522633 */     GIR_RootConstrainSelectedInstOperands,
     /* 522634 */     // GIR_Coverage, 13248,
     /* 522634 */     GIR_EraseRootFromParent_Done,
     /* 522635 */   // Label 6897: @522635
     /* 522635 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(522747), // Rule ID 13247 //
     /* 522640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 522643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 522651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 522655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522675 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 522677 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 522681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 522683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522704 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 522707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 522724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 522729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 522734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 522739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522745 */     GIR_RootConstrainSelectedInstOperands,
     /* 522746 */     // GIR_Coverage, 13247,
     /* 522746 */     GIR_EraseRootFromParent_Done,
     /* 522747 */   // Label 6898: @522747
     /* 522747 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(522859), // Rule ID 7722 //
     /* 522752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 522755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 522767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 522779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522787 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 522789 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 522793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 522795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522816 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 522819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 522826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 522831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 522836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 522841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522857 */     GIR_RootConstrainSelectedInstOperands,
     /* 522858 */     // GIR_Coverage, 7722,
     /* 522858 */     GIR_EraseRootFromParent_Done,
     /* 522859 */   // Label 6899: @522859
     /* 522859 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(522971), // Rule ID 7721 //
     /* 522864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 522867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 522879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 522887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522899 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 522901 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 522905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 522907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522928 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 522931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 522938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 522943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 522948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 522953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522969 */     GIR_RootConstrainSelectedInstOperands,
     /* 522970 */     // GIR_Coverage, 7721,
     /* 522970 */     GIR_EraseRootFromParent_Done,
     /* 522971 */   // Label 6900: @522971
     /* 522971 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(523067), // Rule ID 13240 //
     /* 522976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 522979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 522987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 522991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522999 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 523001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 523003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523024 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 523027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 523034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 523044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 523049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 523054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 523059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523065 */     GIR_RootConstrainSelectedInstOperands,
     /* 523066 */     // GIR_Coverage, 13240,
     /* 523066 */     GIR_EraseRootFromParent_Done,
     /* 523067 */   // Label 6901: @523067
     /* 523067 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(523163), // Rule ID 13239 //
     /* 523072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 523075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 523083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523095 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 523097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 523099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523120 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 523123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 523130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 523140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 523145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 523150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 523155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523161 */     GIR_RootConstrainSelectedInstOperands,
     /* 523162 */     // GIR_Coverage, 13239,
     /* 523162 */     GIR_EraseRootFromParent_Done,
     /* 523163 */   // Label 6902: @523163
     /* 523163 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(523259), // Rule ID 7714 //
     /* 523168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 523171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 523183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523191 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 523193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 523195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523216 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 523219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 523226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 523236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 523246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 523251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523257 */     GIR_RootConstrainSelectedInstOperands,
     /* 523258 */     // GIR_Coverage, 7714,
     /* 523258 */     GIR_EraseRootFromParent_Done,
     /* 523259 */   // Label 6903: @523259
     /* 523259 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(523355), // Rule ID 7713 //
     /* 523264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 523267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523287 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 523289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 523291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523312 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 523315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 523322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 523332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 523342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 523347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523353 */     GIR_RootConstrainSelectedInstOperands,
     /* 523354 */     // GIR_Coverage, 7713,
     /* 523354 */     GIR_EraseRootFromParent_Done,
     /* 523355 */   // Label 6904: @523355
     /* 523355 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(523390), // Rule ID 90 //
     /* 523360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 523363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 523367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 523371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 523375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13798),
     /* 523379 */     // (fminnum_ieee:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13798>>  =>  (S_MIN_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 523379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F32),
     /* 523384 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 523388 */     GIR_RootConstrainSelectedInstOperands,
     /* 523389 */     // GIR_Coverage, 90,
     /* 523389 */     GIR_Done,
     /* 523390 */   // Label 6905: @523390
     /* 523390 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(523450), // Rule ID 800 //
     /* 523395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 523406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523413 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 523413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
     /* 523416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 523423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 523433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 523443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 523448 */     GIR_RootConstrainSelectedInstOperands,
     /* 523449 */     // GIR_Coverage, 800,
     /* 523449 */     GIR_EraseRootFromParent_Done,
     /* 523450 */   // Label 6906: @523450
     /* 523450 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(523510), // Rule ID 8415 //
     /* 523455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 523473 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 523473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
     /* 523476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 523483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 523493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 523498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 523503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 523508 */     GIR_RootConstrainSelectedInstOperands,
     /* 523509 */     // GIR_Coverage, 8415,
     /* 523509 */     GIR_EraseRootFromParent_Done,
     /* 523510 */   // Label 6907: @523510
     /* 523510 */   GIM_Reject,
     /* 523511 */ // Label 6768: @523511
     /* 523511 */ GIM_Reject,
     /* 523512 */ // Label 6358: @523512
     /* 523512 */ GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(523764),
     /* 523517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 523520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 523523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 523527 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(523586), // Rule ID 915 //
     /* 523532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 523535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 523542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523549 */     // (fminnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 523549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
     /* 523552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 523559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 523569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 523579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 523584 */     GIR_RootConstrainSelectedInstOperands,
     /* 523585 */     // GIR_Coverage, 915,
     /* 523585 */     GIR_EraseRootFromParent_Done,
     /* 523586 */   // Label 6909: @523586
     /* 523586 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(523645), // Rule ID 934 //
     /* 523591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 523594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 523601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523608 */     // (fminnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 523608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 523611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 523618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 523628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 523638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 523643 */     GIR_RootConstrainSelectedInstOperands,
     /* 523644 */     // GIR_Coverage, 934,
     /* 523644 */     GIR_EraseRootFromParent_Done,
     /* 523645 */   // Label 6910: @523645
     /* 523645 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(523704), // Rule ID 8441 //
     /* 523650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 523653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 523667 */     // (fminnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 523667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
     /* 523670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 523677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 523687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 523692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 523697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 523702 */     GIR_RootConstrainSelectedInstOperands,
     /* 523703 */     // GIR_Coverage, 8441,
     /* 523703 */     GIR_EraseRootFromParent_Done,
     /* 523704 */   // Label 6911: @523704
     /* 523704 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(523763), // Rule ID 8455 //
     /* 523709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 523712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 523726 */     // (fminnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 523726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 523729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 523736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 523746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 523751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 523756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 523761 */     GIR_RootConstrainSelectedInstOperands,
     /* 523762 */     // GIR_Coverage, 8455,
     /* 523762 */     GIR_EraseRootFromParent_Done,
     /* 523763 */   // Label 6912: @523763
     /* 523763 */   GIM_Reject,
     /* 523764 */ // Label 6908: @523764
     /* 523764 */ GIM_Reject,
     /* 523765 */ // Label 6359: @523765
     /* 523765 */ GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(523836), // Rule ID 1096 //
     /* 523770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 523773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 523776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523780 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 523787 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 523794 */   // (fminnum_ieee:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 523794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_F16),
     /* 523797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 523804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 523814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523834 */   GIR_RootConstrainSelectedInstOperands,
     /* 523835 */   // GIR_Coverage, 1096,
     /* 523835 */   GIR_EraseRootFromParent_Done,
     /* 523836 */ // Label 6913: @523836
     /* 523836 */ GIM_Reject,
     /* 523837 */ // Label 6360: @523837
     /* 523837 */ GIM_Reject,
     /* 523838 */ // Label 83: @523838
     /* 523838 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 6918*/ GIMT_Encode4(595616),
     /* 523849 */ /*GILLT_s16*//*Label 6914*/ GIMT_Encode4(523865),
     /* 523853 */ /*GILLT_s32*//*Label 6915*/ GIMT_Encode4(577779),
     /* 523857 */ /*GILLT_s64*//*Label 6916*/ GIMT_Encode4(595291),
     /* 523861 */ /*GILLT_v2s16*//*Label 6917*/ GIMT_Encode4(595544),
     /* 523865 */ // Label 6914: @523865
     /* 523865 */ GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(577778),
     /* 523870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 523873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 523876 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(524011), // Rule ID 11897 //
     /* 523881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 523884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 523896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 523900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 523904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 523908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 523912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 523916 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 523920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 523924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 523928 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 523928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 523933 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 523933 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 523938 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 523942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 523944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523965 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 523968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 523975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 523980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 523985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 523995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524009 */     GIR_RootConstrainSelectedInstOperands,
     /* 524010 */     // GIR_Coverage, 11897,
     /* 524010 */     GIR_EraseRootFromParent_Done,
     /* 524011 */   // Label 6920: @524011
     /* 524011 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(524146), // Rule ID 11898 //
     /* 524016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 524019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 524055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 524059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524063 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 524068 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524068 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 524073 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 524077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524093 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524100 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 524103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 524110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 524115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 524120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 524125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524144 */     GIR_RootConstrainSelectedInstOperands,
     /* 524145 */     // GIR_Coverage, 11898,
     /* 524145 */     GIR_EraseRootFromParent_Done,
     /* 524146 */   // Label 6921: @524146
     /* 524146 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(524281), // Rule ID 11901 //
     /* 524151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 524154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524186 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 524190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 524194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524198 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524198 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 524203 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524203 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 524208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 524212 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524228 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524235 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 524238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 524245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 524250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 524255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 524260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524279 */     GIR_RootConstrainSelectedInstOperands,
     /* 524280 */     // GIR_Coverage, 11901,
     /* 524280 */     GIR_EraseRootFromParent_Done,
     /* 524281 */   // Label 6922: @524281
     /* 524281 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(524416), // Rule ID 11902 //
     /* 524286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 524289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 524325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 524329 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524333 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524333 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 524338 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524338 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 524343 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 524347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524363 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524370 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 524373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 524380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 524385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 524390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 524395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524414 */     GIR_RootConstrainSelectedInstOperands,
     /* 524415 */     // GIR_Coverage, 11902,
     /* 524415 */     GIR_EraseRootFromParent_Done,
     /* 524416 */   // Label 6923: @524416
     /* 524416 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(524551), // Rule ID 12377 //
     /* 524421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 524424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 524428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 524460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 524464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524468 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524468 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 524473 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 524478 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 524482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524505 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 524508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 524515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 524520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 524525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 524530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524549 */     GIR_RootConstrainSelectedInstOperands,
     /* 524550 */     // GIR_Coverage, 12377,
     /* 524550 */     GIR_EraseRootFromParent_Done,
     /* 524551 */   // Label 6924: @524551
     /* 524551 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(524686), // Rule ID 12378 //
     /* 524556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 524559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 524563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 524595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 524599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524603 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 524608 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 524613 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 524617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524640 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 524643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 524650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 524655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 524660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 524665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524684 */     GIR_RootConstrainSelectedInstOperands,
     /* 524685 */     // GIR_Coverage, 12378,
     /* 524685 */     GIR_EraseRootFromParent_Done,
     /* 524686 */   // Label 6925: @524686
     /* 524686 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(524821), // Rule ID 12381 //
     /* 524691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 524694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 524698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 524730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 524734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524738 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 524743 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 524748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 524752 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524768 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524775 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 524778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 524785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 524790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 524795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 524800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524819 */     GIR_RootConstrainSelectedInstOperands,
     /* 524820 */     // GIR_Coverage, 12381,
     /* 524820 */     GIR_EraseRootFromParent_Done,
     /* 524821 */   // Label 6926: @524821
     /* 524821 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(524956), // Rule ID 12382 //
     /* 524826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 524829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 524833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524861 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 524865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 524869 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524873 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 524878 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524878 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 524883 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 524887 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524903 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524910 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 524913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 524920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 524925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 524930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 524935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 524945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524954 */     GIR_RootConstrainSelectedInstOperands,
     /* 524955 */     // GIR_Coverage, 12382,
     /* 524955 */     GIR_EraseRootFromParent_Done,
     /* 524956 */   // Label 6927: @524956
     /* 524956 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(525091), // Rule ID 12857 //
     /* 524961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 524964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 524980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 524984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 524988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 524996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525008 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525008 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525013 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525013 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525018 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525038 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525045 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 525048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 525055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 525060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 525065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 525070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525089 */     GIR_RootConstrainSelectedInstOperands,
     /* 525090 */     // GIR_Coverage, 12857,
     /* 525090 */     GIR_EraseRootFromParent_Done,
     /* 525091 */   // Label 6928: @525091
     /* 525091 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(525226), // Rule ID 12858 //
     /* 525096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 525099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525143 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525143 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525148 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525148 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525153 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525157 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525173 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525180 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 525183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 525190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 525195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 525200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 525205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525224 */     GIR_RootConstrainSelectedInstOperands,
     /* 525225 */     // GIR_Coverage, 12858,
     /* 525225 */     GIR_EraseRootFromParent_Done,
     /* 525226 */   // Label 6929: @525226
     /* 525226 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(525361), // Rule ID 12861 //
     /* 525231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 525234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525278 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525278 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525283 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525315 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 525318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 525325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 525330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 525335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 525340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525359 */     GIR_RootConstrainSelectedInstOperands,
     /* 525360 */     // GIR_Coverage, 12861,
     /* 525360 */     GIR_EraseRootFromParent_Done,
     /* 525361 */   // Label 6930: @525361
     /* 525361 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(525496), // Rule ID 12862 //
     /* 525366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 525369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525413 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525418 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525418 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525423 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525443 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525450 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 525453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 525460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 525465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 525470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 525475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525494 */     GIR_RootConstrainSelectedInstOperands,
     /* 525495 */     // GIR_Coverage, 12862,
     /* 525495 */     GIR_EraseRootFromParent_Done,
     /* 525496 */   // Label 6931: @525496
     /* 525496 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(525631), // Rule ID 11882 //
     /* 525501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 525504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525548 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525553 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525553 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525585 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 525588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 525595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 525600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 525605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 525610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525629 */     GIR_RootConstrainSelectedInstOperands,
     /* 525630 */     // GIR_Coverage, 11882,
     /* 525630 */     GIR_EraseRootFromParent_Done,
     /* 525631 */   // Label 6932: @525631
     /* 525631 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(525766), // Rule ID 11883 //
     /* 525636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 525639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525683 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525683 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525688 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525693 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525720 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 525723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 525730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 525735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 525740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 525745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525764 */     GIR_RootConstrainSelectedInstOperands,
     /* 525765 */     // GIR_Coverage, 11883,
     /* 525765 */     GIR_EraseRootFromParent_Done,
     /* 525766 */   // Label 6933: @525766
     /* 525766 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(525901), // Rule ID 11886 //
     /* 525771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 525774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525818 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525818 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525823 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525823 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525828 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525848 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525855 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 525858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 525865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 525870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 525875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 525880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525899 */     GIR_RootConstrainSelectedInstOperands,
     /* 525900 */     // GIR_Coverage, 11886,
     /* 525900 */     GIR_EraseRootFromParent_Done,
     /* 525901 */   // Label 6934: @525901
     /* 525901 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(526036), // Rule ID 11887 //
     /* 525906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 525909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 525925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 525929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 525933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 525941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 525945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 525949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525953 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525953 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 525958 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 525963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 525967 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525983 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525990 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 525993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 526000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 526005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 526010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 526015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526034 */     GIR_RootConstrainSelectedInstOperands,
     /* 526035 */     // GIR_Coverage, 11887,
     /* 526035 */     GIR_EraseRootFromParent_Done,
     /* 526036 */   // Label 6935: @526036
     /* 526036 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(526171), // Rule ID 12362 //
     /* 526041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 526044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 526048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526088 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526093 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526125 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 526128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 526135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 526140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 526145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 526150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526169 */     GIR_RootConstrainSelectedInstOperands,
     /* 526170 */     // GIR_Coverage, 12362,
     /* 526170 */     GIR_EraseRootFromParent_Done,
     /* 526171 */   // Label 6936: @526171
     /* 526171 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(526306), // Rule ID 12363 //
     /* 526176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 526179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 526183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526223 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526228 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526228 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526233 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526253 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526260 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 526263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 526270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 526275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 526280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 526285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526304 */     GIR_RootConstrainSelectedInstOperands,
     /* 526305 */     // GIR_Coverage, 12363,
     /* 526305 */     GIR_EraseRootFromParent_Done,
     /* 526306 */   // Label 6937: @526306
     /* 526306 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(526441), // Rule ID 12366 //
     /* 526311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 526314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 526318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526346 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526358 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526358 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526363 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526368 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526388 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526395 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 526398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 526405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 526410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 526415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 526420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526439 */     GIR_RootConstrainSelectedInstOperands,
     /* 526440 */     // GIR_Coverage, 12366,
     /* 526440 */     GIR_EraseRootFromParent_Done,
     /* 526441 */   // Label 6938: @526441
     /* 526441 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(526576), // Rule ID 12367 //
     /* 526446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 526449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 526453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526493 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526498 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526498 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526503 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526507 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526530 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 526533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 526540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 526545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 526550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 526555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526574 */     GIR_RootConstrainSelectedInstOperands,
     /* 526575 */     // GIR_Coverage, 12367,
     /* 526575 */     GIR_EraseRootFromParent_Done,
     /* 526576 */   // Label 6939: @526576
     /* 526576 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(526711), // Rule ID 12842 //
     /* 526581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 526584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526628 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526628 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526633 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526633 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526638 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526665 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 526668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 526675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 526680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 526685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 526690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526709 */     GIR_RootConstrainSelectedInstOperands,
     /* 526710 */     // GIR_Coverage, 12842,
     /* 526710 */     GIR_EraseRootFromParent_Done,
     /* 526711 */   // Label 6940: @526711
     /* 526711 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(526846), // Rule ID 12843 //
     /* 526716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 526719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526763 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526768 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526768 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526773 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526793 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526800 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 526803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 526810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 526815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 526820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 526825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526844 */     GIR_RootConstrainSelectedInstOperands,
     /* 526845 */     // GIR_Coverage, 12843,
     /* 526845 */     GIR_EraseRootFromParent_Done,
     /* 526846 */   // Label 6941: @526846
     /* 526846 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(526981), // Rule ID 12846 //
     /* 526851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 526854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 526870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 526874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 526878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 526882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 526886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 526890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 526894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526898 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 526903 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 526908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 526912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526935 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 526938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 526945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 526950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 526955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 526960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526979 */     GIR_RootConstrainSelectedInstOperands,
     /* 526980 */     // GIR_Coverage, 12846,
     /* 526980 */     GIR_EraseRootFromParent_Done,
     /* 526981 */   // Label 6942: @526981
     /* 526981 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(527116), // Rule ID 12847 //
     /* 526986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 526989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 527029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 527033 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527038 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527038 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527043 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527047 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527063 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527070 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 527073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 527080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 527085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 527090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 527095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527114 */     GIR_RootConstrainSelectedInstOperands,
     /* 527115 */     // GIR_Coverage, 12847,
     /* 527115 */     GIR_EraseRootFromParent_Done,
     /* 527116 */   // Label 6943: @527116
     /* 527116 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(527251), // Rule ID 7616 //
     /* 527121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 527124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 527164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527168 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527168 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527173 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527173 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527178 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527198 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527205 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 527208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 527215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 527225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527249 */     GIR_RootConstrainSelectedInstOperands,
     /* 527250 */     // GIR_Coverage, 7616,
     /* 527250 */     GIR_EraseRootFromParent_Done,
     /* 527251 */   // Label 6944: @527251
     /* 527251 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(527386), // Rule ID 7648 //
     /* 527256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 527259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 527263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 527299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527303 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527308 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527313 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527333 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527340 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 527343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 527350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 527360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527384 */     GIR_RootConstrainSelectedInstOperands,
     /* 527385 */     // GIR_Coverage, 7648,
     /* 527385 */     GIR_EraseRootFromParent_Done,
     /* 527386 */   // Label 6945: @527386
     /* 527386 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(527521), // Rule ID 7680 //
     /* 527391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 527394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 527434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527438 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527438 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527443 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527475 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 527478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 527485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 527495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527519 */     GIR_RootConstrainSelectedInstOperands,
     /* 527520 */     // GIR_Coverage, 7680,
     /* 527520 */     GIR_EraseRootFromParent_Done,
     /* 527521 */   // Label 6946: @527521
     /* 527521 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(527656), // Rule ID 11896 //
     /* 527526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 527529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527561 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 527569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527573 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527573 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527578 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527578 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527610 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 527613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 527620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 527630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527654 */     GIR_RootConstrainSelectedInstOperands,
     /* 527655 */     // GIR_Coverage, 11896,
     /* 527655 */     GIR_EraseRootFromParent_Done,
     /* 527656 */   // Label 6947: @527656
     /* 527656 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(527791), // Rule ID 11899 //
     /* 527661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 527664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 527704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527708 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527713 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527713 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527718 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527738 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527745 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 527748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 527755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 527760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 527765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 527770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527789 */     GIR_RootConstrainSelectedInstOperands,
     /* 527790 */     // GIR_Coverage, 11899,
     /* 527790 */     GIR_EraseRootFromParent_Done,
     /* 527791 */   // Label 6948: @527791
     /* 527791 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(527926), // Rule ID 11900 //
     /* 527796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 527799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 527839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527843 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527848 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527853 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527880 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 527883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 527890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 527895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 527900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 527905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527924 */     GIR_RootConstrainSelectedInstOperands,
     /* 527925 */     // GIR_Coverage, 11900,
     /* 527925 */     GIR_EraseRootFromParent_Done,
     /* 527926 */   // Label 6949: @527926
     /* 527926 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(528061), // Rule ID 12376 //
     /* 527931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 527934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 527938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 527950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 527954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 527958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 527962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 527966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 527970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 527974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527978 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 527978 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 527983 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 527983 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 527988 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 527992 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 527994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528008 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528015 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 528018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 528025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 528030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 528035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 528040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528059 */     GIR_RootConstrainSelectedInstOperands,
     /* 528060 */     // GIR_Coverage, 12376,
     /* 528060 */     GIR_EraseRootFromParent_Done,
     /* 528061 */   // Label 6950: @528061
     /* 528061 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(528196), // Rule ID 12379 //
     /* 528066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 528069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 528073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528113 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528113 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528118 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528118 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528127 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528143 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528150 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 528153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 528160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 528170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 528175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528194 */     GIR_RootConstrainSelectedInstOperands,
     /* 528195 */     // GIR_Coverage, 12379,
     /* 528195 */     GIR_EraseRootFromParent_Done,
     /* 528196 */   // Label 6951: @528196
     /* 528196 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(528331), // Rule ID 12380 //
     /* 528201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 528204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 528208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528248 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528253 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528278 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528285 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 528288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 528295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 528305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 528310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528329 */     GIR_RootConstrainSelectedInstOperands,
     /* 528330 */     // GIR_Coverage, 12380,
     /* 528330 */     GIR_EraseRootFromParent_Done,
     /* 528331 */   // Label 6952: @528331
     /* 528331 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(528466), // Rule ID 12856 //
     /* 528336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 528339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 528343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528383 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528388 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528397 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528413 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528420 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 528423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 528430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 528435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 528440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 528445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528464 */     GIR_RootConstrainSelectedInstOperands,
     /* 528465 */     // GIR_Coverage, 12856,
     /* 528465 */     GIR_EraseRootFromParent_Done,
     /* 528466 */   // Label 6953: @528466
     /* 528466 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(528601), // Rule ID 12859 //
     /* 528471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 528474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 528478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528518 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528523 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528523 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528528 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528555 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 528558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 528565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 528575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 528580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528599 */     GIR_RootConstrainSelectedInstOperands,
     /* 528600 */     // GIR_Coverage, 12859,
     /* 528600 */     GIR_EraseRootFromParent_Done,
     /* 528601 */   // Label 6954: @528601
     /* 528601 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(528736), // Rule ID 12860 //
     /* 528606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 528609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 528613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528641 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528653 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528653 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528658 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528658 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528663 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528683 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528690 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 528693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 528700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 528710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 528715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528734 */     GIR_RootConstrainSelectedInstOperands,
     /* 528735 */     // GIR_Coverage, 12860,
     /* 528735 */     GIR_EraseRootFromParent_Done,
     /* 528736 */   // Label 6955: @528736
     /* 528736 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(528871), // Rule ID 7615 //
     /* 528741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 528744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 528748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 528788 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528788 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528793 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528798 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528818 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528825 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 528828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 528835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 528840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 528845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 528850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528869 */     GIR_RootConstrainSelectedInstOperands,
     /* 528870 */     // GIR_Coverage, 7615,
     /* 528870 */     GIR_EraseRootFromParent_Done,
     /* 528871 */   // Label 6956: @528871
     /* 528871 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(529006), // Rule ID 7647 //
     /* 528876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 528879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 528883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 528919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 528923 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528928 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528953 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528960 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 528963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 528970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 528975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 528980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 528985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529004 */     GIR_RootConstrainSelectedInstOperands,
     /* 529005 */     // GIR_Coverage, 7647,
     /* 529005 */     GIR_EraseRootFromParent_Done,
     /* 529006 */   // Label 6957: @529006
     /* 529006 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(529141), // Rule ID 7679 //
     /* 529011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 529014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529058 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529063 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529068 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529095 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 529098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 529105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 529110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 529115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 529120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529139 */     GIR_RootConstrainSelectedInstOperands,
     /* 529140 */     // GIR_Coverage, 7679,
     /* 529140 */     GIR_EraseRootFromParent_Done,
     /* 529141 */   // Label 6958: @529141
     /* 529141 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(529276), // Rule ID 11881 //
     /* 529146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 529149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529193 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529198 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529198 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529230 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 529233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 529240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 529245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 529250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 529255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529274 */     GIR_RootConstrainSelectedInstOperands,
     /* 529275 */     // GIR_Coverage, 11881,
     /* 529275 */     GIR_EraseRootFromParent_Done,
     /* 529276 */   // Label 6959: @529276
     /* 529276 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(529411), // Rule ID 11884 //
     /* 529281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 529284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529316 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529328 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529328 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529333 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529333 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529338 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529358 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529365 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 529368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 529375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 529380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 529385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 529390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529409 */     GIR_RootConstrainSelectedInstOperands,
     /* 529410 */     // GIR_Coverage, 11884,
     /* 529410 */     GIR_EraseRootFromParent_Done,
     /* 529411 */   // Label 6960: @529411
     /* 529411 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(529546), // Rule ID 11885 //
     /* 529416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 529419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529463 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529463 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529468 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529468 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529473 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529477 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529500 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 529503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 529510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 529515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 529520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 529525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529544 */     GIR_RootConstrainSelectedInstOperands,
     /* 529545 */     // GIR_Coverage, 11885,
     /* 529545 */     GIR_EraseRootFromParent_Done,
     /* 529546 */   // Label 6961: @529546
     /* 529546 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(529681), // Rule ID 12361 //
     /* 529551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 529554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 529558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529598 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529598 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529603 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529608 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529635 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 529638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 529645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 529650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 529655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 529660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529679 */     GIR_RootConstrainSelectedInstOperands,
     /* 529680 */     // GIR_Coverage, 12361,
     /* 529680 */     GIR_EraseRootFromParent_Done,
     /* 529681 */   // Label 6962: @529681
     /* 529681 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(529816), // Rule ID 12364 //
     /* 529686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 529689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 529693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529733 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529738 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529743 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529763 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529770 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 529773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 529780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 529785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 529790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 529795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529814 */     GIR_RootConstrainSelectedInstOperands,
     /* 529815 */     // GIR_Coverage, 12364,
     /* 529815 */     GIR_EraseRootFromParent_Done,
     /* 529816 */   // Label 6963: @529816
     /* 529816 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(529951), // Rule ID 12365 //
     /* 529821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 529824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 529828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529868 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529873 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529878 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529905 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 529908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 529915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 529920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 529925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 529930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529949 */     GIR_RootConstrainSelectedInstOperands,
     /* 529950 */     // GIR_Coverage, 12365,
     /* 529950 */     GIR_EraseRootFromParent_Done,
     /* 529951 */   // Label 6964: @529951
     /* 529951 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(530086), // Rule ID 12841 //
     /* 529956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 529959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 529999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530003 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530008 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530008 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530033 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530040 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 530043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 530050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 530055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 530060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 530065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530084 */     GIR_RootConstrainSelectedInstOperands,
     /* 530085 */     // GIR_Coverage, 12841,
     /* 530085 */     GIR_EraseRootFromParent_Done,
     /* 530086 */   // Label 6965: @530086
     /* 530086 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(530221), // Rule ID 12844 //
     /* 530091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 530094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 530134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530138 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530138 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530143 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530143 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530148 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530168 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530175 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 530178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 530185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 530190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 530195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 530200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530219 */     GIR_RootConstrainSelectedInstOperands,
     /* 530220 */     // GIR_Coverage, 12844,
     /* 530220 */     GIR_EraseRootFromParent_Done,
     /* 530221 */   // Label 6966: @530221
     /* 530221 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(530356), // Rule ID 12845 //
     /* 530226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 530229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 530269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530273 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530273 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530278 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530278 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530283 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530303 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530310 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 530313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 530320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 530325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 530330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 530335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530354 */     GIR_RootConstrainSelectedInstOperands,
     /* 530355 */     // GIR_Coverage, 12845,
     /* 530355 */     GIR_EraseRootFromParent_Done,
     /* 530356 */   // Label 6967: @530356
     /* 530356 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(530491), // Rule ID 11867 //
     /* 530361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 530364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 530392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 530408 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530413 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530418 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530445 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 530448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 530455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 530460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 530465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 530470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530489 */     GIR_RootConstrainSelectedInstOperands,
     /* 530490 */     // GIR_Coverage, 11867,
     /* 530490 */     GIR_EraseRootFromParent_Done,
     /* 530491 */   // Label 6968: @530491
     /* 530491 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(530626), // Rule ID 11868 //
     /* 530496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 530499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 530527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530531 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 530543 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530548 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530553 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530580 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 530583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 530590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 530595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 530600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 530605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530624 */     GIR_RootConstrainSelectedInstOperands,
     /* 530625 */     // GIR_Coverage, 11868,
     /* 530625 */     GIR_EraseRootFromParent_Done,
     /* 530626 */   // Label 6969: @530626
     /* 530626 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(530761), // Rule ID 11871 //
     /* 530631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 530634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 530662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 530678 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530678 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530683 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530683 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530688 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530715 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 530718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 530725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 530730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 530735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 530740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530759 */     GIR_RootConstrainSelectedInstOperands,
     /* 530760 */     // GIR_Coverage, 11871,
     /* 530760 */     GIR_EraseRootFromParent_Done,
     /* 530761 */   // Label 6970: @530761
     /* 530761 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(530896), // Rule ID 11872 //
     /* 530766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 530769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 530797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 530813 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530818 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530818 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530823 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530843 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530850 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 530853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 530860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 530865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 530870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 530875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530894 */     GIR_RootConstrainSelectedInstOperands,
     /* 530895 */     // GIR_Coverage, 11872,
     /* 530895 */     GIR_EraseRootFromParent_Done,
     /* 530896 */   // Label 6971: @530896
     /* 530896 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(531031), // Rule ID 12347 //
     /* 530901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 530904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 530908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 530932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 530948 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530948 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530953 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530953 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530958 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530985 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 530988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 530995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 531000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 531005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 531010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531029 */     GIR_RootConstrainSelectedInstOperands,
     /* 531030 */     // GIR_Coverage, 12347,
     /* 531030 */     GIR_EraseRootFromParent_Done,
     /* 531031 */   // Label 6972: @531031
     /* 531031 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(531166), // Rule ID 12348 //
     /* 531036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 531039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 531043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531071 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531083 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531083 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531088 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531120 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 531123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 531130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 531135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 531140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 531145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531164 */     GIR_RootConstrainSelectedInstOperands,
     /* 531165 */     // GIR_Coverage, 12348,
     /* 531165 */     GIR_EraseRootFromParent_Done,
     /* 531166 */   // Label 6973: @531166
     /* 531166 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(531301), // Rule ID 12351 //
     /* 531171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 531174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 531178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531218 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531223 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531255 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 531258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 531265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 531270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 531275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 531280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531299 */     GIR_RootConstrainSelectedInstOperands,
     /* 531300 */     // GIR_Coverage, 12351,
     /* 531300 */     GIR_EraseRootFromParent_Done,
     /* 531301 */   // Label 6974: @531301
     /* 531301 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(531436), // Rule ID 12352 //
     /* 531306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 531309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 531313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531353 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531358 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531358 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531363 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531383 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531390 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 531393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 531400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 531405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 531410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 531415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531434 */     GIR_RootConstrainSelectedInstOperands,
     /* 531435 */     // GIR_Coverage, 12352,
     /* 531435 */     GIR_EraseRootFromParent_Done,
     /* 531436 */   // Label 6975: @531436
     /* 531436 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(531571), // Rule ID 12827 //
     /* 531441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 531444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531476 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531488 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531493 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531498 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531511 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531518 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531525 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 531528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 531535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 531540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 531545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 531550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531569 */     GIR_RootConstrainSelectedInstOperands,
     /* 531570 */     // GIR_Coverage, 12827,
     /* 531570 */     GIR_EraseRootFromParent_Done,
     /* 531571 */   // Label 6976: @531571
     /* 531571 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(531706), // Rule ID 12828 //
     /* 531576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 531579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531611 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531623 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531623 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531628 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531628 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531633 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531637 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531660 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 531663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 531670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 531675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 531680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 531685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531704 */     GIR_RootConstrainSelectedInstOperands,
     /* 531705 */     // GIR_Coverage, 12828,
     /* 531705 */     GIR_EraseRootFromParent_Done,
     /* 531706 */   // Label 6977: @531706
     /* 531706 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(531841), // Rule ID 12831 //
     /* 531711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 531714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531758 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531758 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531763 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531795 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 531798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 531805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 531810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 531815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 531820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531839 */     GIR_RootConstrainSelectedInstOperands,
     /* 531840 */     // GIR_Coverage, 12831,
     /* 531840 */     GIR_EraseRootFromParent_Done,
     /* 531841 */   // Label 6978: @531841
     /* 531841 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(531976), // Rule ID 12832 //
     /* 531846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 531849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 531877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531893 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531898 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531923 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531930 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 531933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 531940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 531945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 531950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 531955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531974 */     GIR_RootConstrainSelectedInstOperands,
     /* 531975 */     // GIR_Coverage, 12832,
     /* 531975 */     GIR_EraseRootFromParent_Done,
     /* 531976 */   // Label 6979: @531976
     /* 531976 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(532111), // Rule ID 11852 //
     /* 531981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 531984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532028 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532033 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532065 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 532068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 532075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 532080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 532085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 532090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532109 */     GIR_RootConstrainSelectedInstOperands,
     /* 532110 */     // GIR_Coverage, 11852,
     /* 532110 */     GIR_EraseRootFromParent_Done,
     /* 532111 */   // Label 6980: @532111
     /* 532111 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(532246), // Rule ID 11853 //
     /* 532116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 532119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 532123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532163 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532168 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532168 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532173 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532193 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532200 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 532203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 532210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 532215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 532220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 532225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532244 */     GIR_RootConstrainSelectedInstOperands,
     /* 532245 */     // GIR_Coverage, 11853,
     /* 532245 */     GIR_EraseRootFromParent_Done,
     /* 532246 */   // Label 6981: @532246
     /* 532246 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(532381), // Rule ID 11856 //
     /* 532251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 532254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 532258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532298 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532298 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532303 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532308 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532328 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532335 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 532338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 532345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 532350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 532355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 532360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532379 */     GIR_RootConstrainSelectedInstOperands,
     /* 532380 */     // GIR_Coverage, 11856,
     /* 532380 */     GIR_EraseRootFromParent_Done,
     /* 532381 */   // Label 6982: @532381
     /* 532381 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(532516), // Rule ID 11857 //
     /* 532386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 532389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 532393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532433 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532433 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532438 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532438 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532443 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532447 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532463 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532470 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 532473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 532480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 532485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 532490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 532495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532514 */     GIR_RootConstrainSelectedInstOperands,
     /* 532515 */     // GIR_Coverage, 11857,
     /* 532515 */     GIR_EraseRootFromParent_Done,
     /* 532516 */   // Label 6983: @532516
     /* 532516 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(532651), // Rule ID 12332 //
     /* 532521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 532524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 532528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532556 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532568 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532573 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532573 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532578 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532598 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532605 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 532608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 532615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 532620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 532625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 532630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532649 */     GIR_RootConstrainSelectedInstOperands,
     /* 532650 */     // GIR_Coverage, 12332,
     /* 532650 */     GIR_EraseRootFromParent_Done,
     /* 532651 */   // Label 6984: @532651
     /* 532651 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(532786), // Rule ID 12333 //
     /* 532656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 532659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 532663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532703 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532708 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532713 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532733 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532740 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 532743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 532750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 532755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 532760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 532765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532784 */     GIR_RootConstrainSelectedInstOperands,
     /* 532785 */     // GIR_Coverage, 12333,
     /* 532785 */     GIR_EraseRootFromParent_Done,
     /* 532786 */   // Label 6985: @532786
     /* 532786 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(532921), // Rule ID 12336 //
     /* 532791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 532794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 532798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532838 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532843 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532875 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 532878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 532885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 532890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 532895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 532900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532919 */     GIR_RootConstrainSelectedInstOperands,
     /* 532920 */     // GIR_Coverage, 12336,
     /* 532920 */     GIR_EraseRootFromParent_Done,
     /* 532921 */   // Label 6986: @532921
     /* 532921 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(533056), // Rule ID 12337 //
     /* 532926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 532929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 532933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 532957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 532969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 532973 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532978 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532978 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532983 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533003 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533010 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 533013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 533020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 533025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 533030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 533035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533054 */     GIR_RootConstrainSelectedInstOperands,
     /* 533055 */     // GIR_Coverage, 12337,
     /* 533055 */     GIR_EraseRootFromParent_Done,
     /* 533056 */   // Label 6987: @533056
     /* 533056 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(533191), // Rule ID 12812 //
     /* 533061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 533064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 533104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533108 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533108 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533113 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533113 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533118 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533138 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533145 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 533148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 533155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 533160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 533165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 533170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533189 */     GIR_RootConstrainSelectedInstOperands,
     /* 533190 */     // GIR_Coverage, 12812,
     /* 533190 */     GIR_EraseRootFromParent_Done,
     /* 533191 */   // Label 6988: @533191
     /* 533191 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(533326), // Rule ID 12813 //
     /* 533196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 533199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 533239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533243 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533248 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533253 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533280 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 533283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 533290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 533295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 533300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 533305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533324 */     GIR_RootConstrainSelectedInstOperands,
     /* 533325 */     // GIR_Coverage, 12813,
     /* 533325 */     GIR_EraseRootFromParent_Done,
     /* 533326 */   // Label 6989: @533326
     /* 533326 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(533461), // Rule ID 12816 //
     /* 533331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 533334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 533374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533378 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533383 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533388 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533415 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 533418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 533425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 533430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 533435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 533440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533459 */     GIR_RootConstrainSelectedInstOperands,
     /* 533460 */     // GIR_Coverage, 12816,
     /* 533460 */     GIR_EraseRootFromParent_Done,
     /* 533461 */   // Label 6990: @533461
     /* 533461 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(533596), // Rule ID 12817 //
     /* 533466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 533469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 533509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533513 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533518 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533523 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533527 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533550 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 533553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 533560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 533565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 533570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 533575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533594 */     GIR_RootConstrainSelectedInstOperands,
     /* 533595 */     // GIR_Coverage, 12817,
     /* 533595 */     GIR_EraseRootFromParent_Done,
     /* 533596 */   // Label 6991: @533596
     /* 533596 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(533731), // Rule ID 7614 //
     /* 533601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 533604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 533644 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 533648 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533648 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533653 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533653 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533662 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533678 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533685 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 533688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 533695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 533700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 533705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 533710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533729 */     GIR_RootConstrainSelectedInstOperands,
     /* 533730 */     // GIR_Coverage, 7614,
     /* 533730 */     GIR_EraseRootFromParent_Done,
     /* 533731 */   // Label 6992: @533731
     /* 533731 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(533866), // Rule ID 7646 //
     /* 533736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 533739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 533743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533771 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 533779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 533783 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533788 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533788 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533793 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533797 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533813 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533820 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 533823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 533830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 533835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 533840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 533845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533864 */     GIR_RootConstrainSelectedInstOperands,
     /* 533865 */     // GIR_Coverage, 7646,
     /* 533865 */     GIR_EraseRootFromParent_Done,
     /* 533866 */   // Label 6993: @533866
     /* 533866 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(534001), // Rule ID 7678 //
     /* 533871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 533874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 533902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 533914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 533918 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533918 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533923 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533928 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533955 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 533958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 533965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 533970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 533975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 533980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533999 */     GIR_RootConstrainSelectedInstOperands,
     /* 534000 */     // GIR_Coverage, 7678,
     /* 534000 */     GIR_EraseRootFromParent_Done,
     /* 534001 */   // Label 6994: @534001
     /* 534001 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(534136), // Rule ID 11866 //
     /* 534006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 534009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534053 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534058 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534063 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534083 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534090 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 534093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 534100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 534105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 534110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 534115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534134 */     GIR_RootConstrainSelectedInstOperands,
     /* 534135 */     // GIR_Coverage, 11866,
     /* 534135 */     GIR_EraseRootFromParent_Done,
     /* 534136 */   // Label 6995: @534136
     /* 534136 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(534271), // Rule ID 11869 //
     /* 534141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 534144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534188 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534193 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534225 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 534228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 534235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 534240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 534245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 534250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534269 */     GIR_RootConstrainSelectedInstOperands,
     /* 534270 */     // GIR_Coverage, 11869,
     /* 534270 */     GIR_EraseRootFromParent_Done,
     /* 534271 */   // Label 6996: @534271
     /* 534271 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(534406), // Rule ID 11870 //
     /* 534276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 534279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534323 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534328 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534328 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534353 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534360 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 534363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 534370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 534375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 534380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 534385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534404 */     GIR_RootConstrainSelectedInstOperands,
     /* 534405 */     // GIR_Coverage, 11870,
     /* 534405 */     GIR_EraseRootFromParent_Done,
     /* 534406 */   // Label 6997: @534406
     /* 534406 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(534541), // Rule ID 12346 //
     /* 534411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 534414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 534418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534458 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534458 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534463 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534463 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534468 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534472 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534495 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 534498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 534505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 534510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 534515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 534520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534539 */     GIR_RootConstrainSelectedInstOperands,
     /* 534540 */     // GIR_Coverage, 12346,
     /* 534540 */     GIR_EraseRootFromParent_Done,
     /* 534541 */   // Label 6998: @534541
     /* 534541 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(534676), // Rule ID 12349 //
     /* 534546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 534549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 534553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534593 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534593 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534598 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534598 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534603 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534630 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 534633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 534640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 534645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 534650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 534655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534674 */     GIR_RootConstrainSelectedInstOperands,
     /* 534675 */     // GIR_Coverage, 12349,
     /* 534675 */     GIR_EraseRootFromParent_Done,
     /* 534676 */   // Label 6999: @534676
     /* 534676 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(534811), // Rule ID 12350 //
     /* 534681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 534684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 534688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534728 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534728 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534733 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534765 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 534768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 534775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 534780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 534785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 534790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534809 */     GIR_RootConstrainSelectedInstOperands,
     /* 534810 */     // GIR_Coverage, 12350,
     /* 534810 */     GIR_EraseRootFromParent_Done,
     /* 534811 */   // Label 7000: @534811
     /* 534811 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(534946), // Rule ID 12826 //
     /* 534816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 534819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534863 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534868 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534873 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534877 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534900 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 534903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 534910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 534915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 534920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 534925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534944 */     GIR_RootConstrainSelectedInstOperands,
     /* 534945 */     // GIR_Coverage, 12826,
     /* 534945 */     GIR_EraseRootFromParent_Done,
     /* 534946 */   // Label 7001: @534946
     /* 534946 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(535081), // Rule ID 12829 //
     /* 534951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 534954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534998 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535003 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535008 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535035 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 535038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 535045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 535050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 535055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 535060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535079 */     GIR_RootConstrainSelectedInstOperands,
     /* 535080 */     // GIR_Coverage, 12829,
     /* 535080 */     GIR_EraseRootFromParent_Done,
     /* 535081 */   // Label 7002: @535081
     /* 535081 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(535216), // Rule ID 12830 //
     /* 535086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 535089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 535133 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535138 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535138 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535143 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535156 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535163 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535170 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 535173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 535180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 535185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 535190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 535195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535214 */     GIR_RootConstrainSelectedInstOperands,
     /* 535215 */     // GIR_Coverage, 12830,
     /* 535215 */     GIR_EraseRootFromParent_Done,
     /* 535216 */   // Label 7003: @535216
     /* 535216 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(535351), // Rule ID 7613 //
     /* 535221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 535224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 535268 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535268 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535273 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535273 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535278 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535282 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535305 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 535308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 535315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 535320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 535325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 535330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535349 */     GIR_RootConstrainSelectedInstOperands,
     /* 535350 */     // GIR_Coverage, 7613,
     /* 535350 */     GIR_EraseRootFromParent_Done,
     /* 535351 */   // Label 7004: @535351
     /* 535351 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(535486), // Rule ID 7645 //
     /* 535356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 535359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 535363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 535403 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535408 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535413 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535433 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535440 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 535443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 535450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 535455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 535460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 535465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535484 */     GIR_RootConstrainSelectedInstOperands,
     /* 535485 */     // GIR_Coverage, 7645,
     /* 535485 */     GIR_EraseRootFromParent_Done,
     /* 535486 */   // Label 7005: @535486
     /* 535486 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(535621), // Rule ID 7677 //
     /* 535491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 535494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 535538 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535543 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535548 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535575 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 535578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 535585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 535590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 535595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 535600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535619 */     GIR_RootConstrainSelectedInstOperands,
     /* 535620 */     // GIR_Coverage, 7677,
     /* 535620 */     GIR_EraseRootFromParent_Done,
     /* 535621 */   // Label 7006: @535621
     /* 535621 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(535756), // Rule ID 11851 //
     /* 535626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 535629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 535673 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535678 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535678 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535696 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535703 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535710 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 535713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 535720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 535725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 535730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 535735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535754 */     GIR_RootConstrainSelectedInstOperands,
     /* 535755 */     // GIR_Coverage, 11851,
     /* 535755 */     GIR_EraseRootFromParent_Done,
     /* 535756 */   // Label 7007: @535756
     /* 535756 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(535891), // Rule ID 11854 //
     /* 535761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 535764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 535808 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535813 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535818 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535838 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535845 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 535848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 535855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 535860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 535865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 535870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535889 */     GIR_RootConstrainSelectedInstOperands,
     /* 535890 */     // GIR_Coverage, 11854,
     /* 535890 */     GIR_EraseRootFromParent_Done,
     /* 535891 */   // Label 7008: @535891
     /* 535891 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(536026), // Rule ID 11855 //
     /* 535896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 535899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 535939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 535943 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535943 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535948 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535948 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535953 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535957 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535980 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 535983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 535990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 535995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536024 */     GIR_RootConstrainSelectedInstOperands,
     /* 536025 */     // GIR_Coverage, 11855,
     /* 536025 */     GIR_EraseRootFromParent_Done,
     /* 536026 */   // Label 7009: @536026
     /* 536026 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(536161), // Rule ID 12331 //
     /* 536031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 536034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 536038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 536074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536078 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536078 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536083 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536083 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536088 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536108 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536115 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 536118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 536125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 536130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 536135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 536140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536159 */     GIR_RootConstrainSelectedInstOperands,
     /* 536160 */     // GIR_Coverage, 12331,
     /* 536160 */     GIR_EraseRootFromParent_Done,
     /* 536161 */   // Label 7010: @536161
     /* 536161 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(536296), // Rule ID 12334 //
     /* 536166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 536169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 536173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 536209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536213 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536218 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536223 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536250 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 536253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536294 */     GIR_RootConstrainSelectedInstOperands,
     /* 536295 */     // GIR_Coverage, 12334,
     /* 536295 */     GIR_EraseRootFromParent_Done,
     /* 536296 */   // Label 7011: @536296
     /* 536296 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(536431), // Rule ID 12335 //
     /* 536301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 536304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 536308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 536344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536348 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536353 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536358 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536385 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 536388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536429 */     GIR_RootConstrainSelectedInstOperands,
     /* 536430 */     // GIR_Coverage, 12335,
     /* 536430 */     GIR_EraseRootFromParent_Done,
     /* 536431 */   // Label 7012: @536431
     /* 536431 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(536566), // Rule ID 12811 //
     /* 536436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 536439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 536479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536483 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536488 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536493 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536506 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536520 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 536523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 536530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 536535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 536540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 536545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536564 */     GIR_RootConstrainSelectedInstOperands,
     /* 536565 */     // GIR_Coverage, 12811,
     /* 536565 */     GIR_EraseRootFromParent_Done,
     /* 536566 */   // Label 7013: @536566
     /* 536566 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(536701), // Rule ID 12814 //
     /* 536571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 536574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 536614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536618 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536618 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536623 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536623 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536628 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536634 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536648 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536655 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 536658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536699 */     GIR_RootConstrainSelectedInstOperands,
     /* 536700 */     // GIR_Coverage, 12814,
     /* 536700 */     GIR_EraseRootFromParent_Done,
     /* 536701 */   // Label 7014: @536701
     /* 536701 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(536836), // Rule ID 12815 //
     /* 536706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 536709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536741 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 536749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536753 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536753 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536758 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536758 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536767 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536783 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536790 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 536793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536834 */     GIR_RootConstrainSelectedInstOperands,
     /* 536835 */     // GIR_Coverage, 12815,
     /* 536835 */     GIR_EraseRootFromParent_Done,
     /* 536836 */   // Label 7015: @536836
     /* 536836 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(536971), // Rule ID 11907 //
     /* 536841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 536844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 536868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 536872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 536884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536888 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536888 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 536893 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 536898 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536925 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 536928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 536945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 536950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 536955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 536960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536969 */     GIR_RootConstrainSelectedInstOperands,
     /* 536970 */     // GIR_Coverage, 11907,
     /* 536970 */     GIR_EraseRootFromParent_Done,
     /* 536971 */   // Label 7016: @536971
     /* 536971 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(537106), // Rule ID 11908 //
     /* 536976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 536979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537011 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537023 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537028 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537053 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537060 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 537063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 537070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 537075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 537080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 537085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 537090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 537095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537104 */     GIR_RootConstrainSelectedInstOperands,
     /* 537105 */     // GIR_Coverage, 11908,
     /* 537105 */     GIR_EraseRootFromParent_Done,
     /* 537106 */   // Label 7017: @537106
     /* 537106 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(537241), // Rule ID 11909 //
     /* 537111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 537114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 537118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537158 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537163 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537168 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537195 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 537198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 537205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 537210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 537215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 537220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 537225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 537230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537239 */     GIR_RootConstrainSelectedInstOperands,
     /* 537240 */     // GIR_Coverage, 11909,
     /* 537240 */     GIR_EraseRootFromParent_Done,
     /* 537241 */   // Label 7018: @537241
     /* 537241 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(537376), // Rule ID 11910 //
     /* 537246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 537249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 537253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537281 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537293 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537293 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537298 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537298 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537303 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537323 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537330 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 537333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 537340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 537345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 537350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 537355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 537360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 537365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537374 */     GIR_RootConstrainSelectedInstOperands,
     /* 537375 */     // GIR_Coverage, 11910,
     /* 537375 */     GIR_EraseRootFromParent_Done,
     /* 537376 */   // Label 7019: @537376
     /* 537376 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(537511), // Rule ID 12387 //
     /* 537381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 537384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 537388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537428 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537428 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537433 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537433 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537438 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537465 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 537468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 537475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 537480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 537485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 537490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 537495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 537500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537509 */     GIR_RootConstrainSelectedInstOperands,
     /* 537510 */     // GIR_Coverage, 12387,
     /* 537510 */     GIR_EraseRootFromParent_Done,
     /* 537511 */   // Label 7020: @537511
     /* 537511 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(537646), // Rule ID 12388 //
     /* 537516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 537519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 537523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537563 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537563 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537568 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537573 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537600 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 537603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 537610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 537615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 537620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 537625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 537630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 537635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537644 */     GIR_RootConstrainSelectedInstOperands,
     /* 537645 */     // GIR_Coverage, 12388,
     /* 537645 */     GIR_EraseRootFromParent_Done,
     /* 537646 */   // Label 7021: @537646
     /* 537646 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(537781), // Rule ID 12389 //
     /* 537651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 537654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 537658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537698 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537703 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537728 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537735 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 537738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 537745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 537750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 537755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 537760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 537765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 537770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537779 */     GIR_RootConstrainSelectedInstOperands,
     /* 537780 */     // GIR_Coverage, 12389,
     /* 537780 */     GIR_EraseRootFromParent_Done,
     /* 537781 */   // Label 7022: @537781
     /* 537781 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(537916), // Rule ID 12390 //
     /* 537786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 537789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 537793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537833 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537838 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537863 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537870 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 537873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 537880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 537885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 537890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 537895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 537900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 537905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537914 */     GIR_RootConstrainSelectedInstOperands,
     /* 537915 */     // GIR_Coverage, 12390,
     /* 537915 */     GIR_EraseRootFromParent_Done,
     /* 537916 */   // Label 7023: @537916
     /* 537916 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(538051), // Rule ID 12867 //
     /* 537921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 537924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 537928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 537948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 537952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 537964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537968 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 537973 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 537978 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537982 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538005 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 538008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 538015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 538020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 538025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 538030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538049 */     GIR_RootConstrainSelectedInstOperands,
     /* 538050 */     // GIR_Coverage, 12867,
     /* 538050 */     GIR_EraseRootFromParent_Done,
     /* 538051 */   // Label 7024: @538051
     /* 538051 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(538186), // Rule ID 12868 //
     /* 538056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 538059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538099 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538103 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538103 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538108 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538108 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538113 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538117 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538133 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538140 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 538143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 538150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 538155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 538160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 538165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538184 */     GIR_RootConstrainSelectedInstOperands,
     /* 538185 */     // GIR_Coverage, 12868,
     /* 538185 */     GIR_EraseRootFromParent_Done,
     /* 538186 */   // Label 7025: @538186
     /* 538186 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(538321), // Rule ID 12869 //
     /* 538191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 538194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538238 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538238 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538243 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538248 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538254 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538275 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 538278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 538285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 538290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 538295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 538300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538319 */     GIR_RootConstrainSelectedInstOperands,
     /* 538320 */     // GIR_Coverage, 12869,
     /* 538320 */     GIR_EraseRootFromParent_Done,
     /* 538321 */   // Label 7026: @538321
     /* 538321 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(538456), // Rule ID 12870 //
     /* 538326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 538329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538373 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538373 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538378 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538383 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538403 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538410 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 538413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 538420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 538425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 538430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 538435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538454 */     GIR_RootConstrainSelectedInstOperands,
     /* 538455 */     // GIR_Coverage, 12870,
     /* 538455 */     GIR_EraseRootFromParent_Done,
     /* 538456 */   // Label 7027: @538456
     /* 538456 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(538591), // Rule ID 11847 //
     /* 538461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 538464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538508 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538513 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538518 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538545 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 538548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 538555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 538560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 538565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 538570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538589 */     GIR_RootConstrainSelectedInstOperands,
     /* 538590 */     // GIR_Coverage, 11847,
     /* 538590 */     GIR_EraseRootFromParent_Done,
     /* 538591 */   // Label 7028: @538591
     /* 538591 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(538726), // Rule ID 11848 //
     /* 538596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 538599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538643 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538643 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538648 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538648 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538653 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538680 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 538683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 538690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 538695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 538700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 538705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538724 */     GIR_RootConstrainSelectedInstOperands,
     /* 538725 */     // GIR_Coverage, 11848,
     /* 538725 */     GIR_EraseRootFromParent_Done,
     /* 538726 */   // Label 7029: @538726
     /* 538726 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(538861), // Rule ID 11849 //
     /* 538731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 538734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538778 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538778 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538783 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538788 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538808 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538815 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 538818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 538825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 538830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 538835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 538840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538859 */     GIR_RootConstrainSelectedInstOperands,
     /* 538860 */     // GIR_Coverage, 11849,
     /* 538860 */     GIR_EraseRootFromParent_Done,
     /* 538861 */   // Label 7030: @538861
     /* 538861 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(538996), // Rule ID 11850 //
     /* 538866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 538869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 538893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 538909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538913 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538913 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 538918 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538918 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 538923 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538927 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538943 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538950 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 538953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 538960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 538965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 538970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 538975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 538980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 538985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538994 */     GIR_RootConstrainSelectedInstOperands,
     /* 538995 */     // GIR_Coverage, 11850,
     /* 538995 */     GIR_EraseRootFromParent_Done,
     /* 538996 */   // Label 7031: @538996
     /* 538996 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(539131), // Rule ID 12327 //
     /* 539001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 539004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 539008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539048 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539048 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539053 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539058 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539078 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539085 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 539088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 539095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 539100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 539105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 539110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539129 */     GIR_RootConstrainSelectedInstOperands,
     /* 539130 */     // GIR_Coverage, 12327,
     /* 539130 */     GIR_EraseRootFromParent_Done,
     /* 539131 */   // Label 7032: @539131
     /* 539131 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(539266), // Rule ID 12328 //
     /* 539136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 539139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 539143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539183 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539188 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539220 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 539223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 539230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 539235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 539240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 539245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539264 */     GIR_RootConstrainSelectedInstOperands,
     /* 539265 */     // GIR_Coverage, 12328,
     /* 539265 */     GIR_EraseRootFromParent_Done,
     /* 539266 */   // Label 7033: @539266
     /* 539266 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(539401), // Rule ID 12329 //
     /* 539271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 539274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 539278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539318 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539323 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539328 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539355 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 539358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 539365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 539370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 539375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 539380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539399 */     GIR_RootConstrainSelectedInstOperands,
     /* 539400 */     // GIR_Coverage, 12329,
     /* 539400 */     GIR_EraseRootFromParent_Done,
     /* 539401 */   // Label 7034: @539401
     /* 539401 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(539536), // Rule ID 12330 //
     /* 539406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 539409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 539413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539453 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539458 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539458 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539467 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539483 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539490 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 539493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 539500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 539505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 539510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 539515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539534 */     GIR_RootConstrainSelectedInstOperands,
     /* 539535 */     // GIR_Coverage, 12330,
     /* 539535 */     GIR_EraseRootFromParent_Done,
     /* 539536 */   // Label 7035: @539536
     /* 539536 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(539671), // Rule ID 12807 //
     /* 539541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 539544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 539548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539588 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539588 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539593 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539593 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539598 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539602 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539625 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 539628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 539635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 539640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 539645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 539650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539669 */     GIR_RootConstrainSelectedInstOperands,
     /* 539670 */     // GIR_Coverage, 12807,
     /* 539670 */     GIR_EraseRootFromParent_Done,
     /* 539671 */   // Label 7036: @539671
     /* 539671 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(539806), // Rule ID 12808 //
     /* 539676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 539679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 539683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539723 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539728 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539728 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539737 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539753 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539760 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 539763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 539770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 539775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 539780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 539785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539804 */     GIR_RootConstrainSelectedInstOperands,
     /* 539805 */     // GIR_Coverage, 12808,
     /* 539805 */     GIR_EraseRootFromParent_Done,
     /* 539806 */   // Label 7037: @539806
     /* 539806 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(539941), // Rule ID 12809 //
     /* 539811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 539814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 539818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539858 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 539863 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539895 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 539898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 539905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 539910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 539915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 539920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 539925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 539930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539939 */     GIR_RootConstrainSelectedInstOperands,
     /* 539940 */     // GIR_Coverage, 12809,
     /* 539940 */     GIR_EraseRootFromParent_Done,
     /* 539941 */   // Label 7038: @539941
     /* 539941 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(540076), // Rule ID 12810 //
     /* 539946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 539949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 539953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 539973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 539989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539993 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 539998 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540003 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540030 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 540033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 540040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 540045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 540050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 540055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540074 */     GIR_RootConstrainSelectedInstOperands,
     /* 540075 */     // GIR_Coverage, 12810,
     /* 540075 */     GIR_EraseRootFromParent_Done,
     /* 540076 */   // Label 7039: @540076
     /* 540076 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(540211), // Rule ID 11892 //
     /* 540081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 540084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540128 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540128 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540133 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540165 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 540168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 540175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 540180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 540185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 540190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540209 */     GIR_RootConstrainSelectedInstOperands,
     /* 540210 */     // GIR_Coverage, 11892,
     /* 540210 */     GIR_EraseRootFromParent_Done,
     /* 540211 */   // Label 7040: @540211
     /* 540211 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(540346), // Rule ID 11893 //
     /* 540216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 540219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540263 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540268 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540268 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540273 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540277 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540293 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540300 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 540303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 540310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 540315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 540320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 540325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540344 */     GIR_RootConstrainSelectedInstOperands,
     /* 540345 */     // GIR_Coverage, 11893,
     /* 540345 */     GIR_EraseRootFromParent_Done,
     /* 540346 */   // Label 7041: @540346
     /* 540346 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(540481), // Rule ID 11894 //
     /* 540351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 540354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540398 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540398 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540403 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540428 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540435 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 540438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 540445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 540450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 540455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 540460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540479 */     GIR_RootConstrainSelectedInstOperands,
     /* 540480 */     // GIR_Coverage, 11894,
     /* 540480 */     GIR_EraseRootFromParent_Done,
     /* 540481 */   // Label 7042: @540481
     /* 540481 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(540616), // Rule ID 11895 //
     /* 540486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 540489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540533 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540533 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540538 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540543 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540563 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540570 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 540573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 540580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 540585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 540590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 540595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540614 */     GIR_RootConstrainSelectedInstOperands,
     /* 540615 */     // GIR_Coverage, 11895,
     /* 540615 */     GIR_EraseRootFromParent_Done,
     /* 540616 */   // Label 7043: @540616
     /* 540616 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(540751), // Rule ID 12372 //
     /* 540621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 540624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 540628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540668 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540673 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540705 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 540708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 540715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 540720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 540725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 540730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540749 */     GIR_RootConstrainSelectedInstOperands,
     /* 540750 */     // GIR_Coverage, 12372,
     /* 540750 */     GIR_EraseRootFromParent_Done,
     /* 540751 */   // Label 7044: @540751
     /* 540751 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(540886), // Rule ID 12373 //
     /* 540756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 540759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 540763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540803 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540808 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540833 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540840 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 540843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 540850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 540855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 540860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 540865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 540870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 540875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540884 */     GIR_RootConstrainSelectedInstOperands,
     /* 540885 */     // GIR_Coverage, 12373,
     /* 540885 */     GIR_EraseRootFromParent_Done,
     /* 540886 */   // Label 7045: @540886
     /* 540886 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(541021), // Rule ID 12374 //
     /* 540891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 540894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 540898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 540918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 540934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540938 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 540943 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540943 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 540948 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540975 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 540978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 540985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 540990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 540995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 541000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541019 */     GIR_RootConstrainSelectedInstOperands,
     /* 541020 */     // GIR_Coverage, 12374,
     /* 541020 */     GIR_EraseRootFromParent_Done,
     /* 541021 */   // Label 7046: @541021
     /* 541021 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(541156), // Rule ID 12375 //
     /* 541026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 541029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 541033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541073 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541073 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541078 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541078 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541087 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541110 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 541113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 541120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 541125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 541130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 541135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541154 */     GIR_RootConstrainSelectedInstOperands,
     /* 541155 */     // GIR_Coverage, 12375,
     /* 541155 */     GIR_EraseRootFromParent_Done,
     /* 541156 */   // Label 7047: @541156
     /* 541156 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(541291), // Rule ID 12852 //
     /* 541161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 541164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541208 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541208 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541213 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541218 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541245 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 541248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 541255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 541260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 541265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 541270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541289 */     GIR_RootConstrainSelectedInstOperands,
     /* 541290 */     // GIR_Coverage, 12852,
     /* 541290 */     GIR_EraseRootFromParent_Done,
     /* 541291 */   // Label 7048: @541291
     /* 541291 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(541426), // Rule ID 12853 //
     /* 541296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 541299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541343 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541348 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541353 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541380 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 541383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 541390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 541395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 541400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 541405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541424 */     GIR_RootConstrainSelectedInstOperands,
     /* 541425 */     // GIR_Coverage, 12853,
     /* 541425 */     GIR_EraseRootFromParent_Done,
     /* 541426 */   // Label 7049: @541426
     /* 541426 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(541561), // Rule ID 12854 //
     /* 541431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 541434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541478 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541483 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541488 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541508 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541515 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 541518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 541525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 541530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 541535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 541540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541559 */     GIR_RootConstrainSelectedInstOperands,
     /* 541560 */     // GIR_Coverage, 12854,
     /* 541560 */     GIR_EraseRootFromParent_Done,
     /* 541561 */   // Label 7050: @541561
     /* 541561 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(541696), // Rule ID 12855 //
     /* 541566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 541569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541613 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541618 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541618 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541623 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541650 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 541653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 541660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 541665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 541670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 541675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541694 */     GIR_RootConstrainSelectedInstOperands,
     /* 541695 */     // GIR_Coverage, 12855,
     /* 541695 */     GIR_EraseRootFromParent_Done,
     /* 541696 */   // Label 7051: @541696
     /* 541696 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(541831), // Rule ID 11832 //
     /* 541701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 541704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 541748 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541748 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541753 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541753 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541758 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541762 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541764 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541778 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541785 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 541788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 541795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 541800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 541805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 541810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541829 */     GIR_RootConstrainSelectedInstOperands,
     /* 541830 */     // GIR_Coverage, 11832,
     /* 541830 */     GIR_EraseRootFromParent_Done,
     /* 541831 */   // Label 7052: @541831
     /* 541831 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(541966), // Rule ID 11833 //
     /* 541836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 541839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 541883 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541888 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541888 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541893 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541897 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541899 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541913 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541920 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 541923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 541930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 541935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 541940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 541945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541964 */     GIR_RootConstrainSelectedInstOperands,
     /* 541965 */     // GIR_Coverage, 11833,
     /* 541965 */     GIR_EraseRootFromParent_Done,
     /* 541966 */   // Label 7053: @541966
     /* 541966 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(542101), // Rule ID 11834 //
     /* 541971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 541974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542018 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542018 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542023 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542041 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542055 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 542058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 542065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 542070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 542075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 542080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542099 */     GIR_RootConstrainSelectedInstOperands,
     /* 542100 */     // GIR_Coverage, 11834,
     /* 542100 */     GIR_EraseRootFromParent_Done,
     /* 542101 */   // Label 7054: @542101
     /* 542101 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(542236), // Rule ID 11835 //
     /* 542106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 542109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 542113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542153 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542158 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542163 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542167 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542190 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 542193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 542200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 542205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 542210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 542215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542234 */     GIR_RootConstrainSelectedInstOperands,
     /* 542235 */     // GIR_Coverage, 11835,
     /* 542235 */     GIR_EraseRootFromParent_Done,
     /* 542236 */   // Label 7055: @542236
     /* 542236 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(542371), // Rule ID 12312 //
     /* 542241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 542244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 542248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542288 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542293 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542293 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542325 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 542328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 542335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 542340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 542345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 542350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542369 */     GIR_RootConstrainSelectedInstOperands,
     /* 542370 */     // GIR_Coverage, 12312,
     /* 542370 */     GIR_EraseRootFromParent_Done,
     /* 542371 */   // Label 7056: @542371
     /* 542371 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(542506), // Rule ID 12313 //
     /* 542376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 542379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 542383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542419 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542423 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542423 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542428 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542428 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542433 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542437 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542453 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542460 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 542463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 542470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 542475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 542480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 542485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542504 */     GIR_RootConstrainSelectedInstOperands,
     /* 542505 */     // GIR_Coverage, 12313,
     /* 542505 */     GIR_EraseRootFromParent_Done,
     /* 542506 */   // Label 7057: @542506
     /* 542506 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(542641), // Rule ID 12314 //
     /* 542511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 542514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 542518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542558 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542558 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542563 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542563 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542568 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542595 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 542598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 542605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 542610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 542615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 542620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542639 */     GIR_RootConstrainSelectedInstOperands,
     /* 542640 */     // GIR_Coverage, 12314,
     /* 542640 */     GIR_EraseRootFromParent_Done,
     /* 542641 */   // Label 7058: @542641
     /* 542641 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(542776), // Rule ID 12315 //
     /* 542646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 542649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 542653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542681 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542685 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542689 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542693 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542693 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542698 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542703 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542707 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542723 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542730 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 542733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 542740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 542745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 542750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 542755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542774 */     GIR_RootConstrainSelectedInstOperands,
     /* 542775 */     // GIR_Coverage, 12315,
     /* 542775 */     GIR_EraseRootFromParent_Done,
     /* 542776 */   // Label 7059: @542776
     /* 542776 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(542911), // Rule ID 12792 //
     /* 542781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 542784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 542788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542828 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542833 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542838 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542865 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 542868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 542875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 542880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 542885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 542890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542909 */     GIR_RootConstrainSelectedInstOperands,
     /* 542910 */     // GIR_Coverage, 12792,
     /* 542910 */     GIR_EraseRootFromParent_Done,
     /* 542911 */   // Label 7060: @542911
     /* 542911 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(543046), // Rule ID 12793 //
     /* 542916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 542919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 542923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 542947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542963 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542968 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542993 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543000 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 543003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 543010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 543015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 543020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 543025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543044 */     GIR_RootConstrainSelectedInstOperands,
     /* 543045 */     // GIR_Coverage, 12793,
     /* 543045 */     GIR_EraseRootFromParent_Done,
     /* 543046 */   // Label 7061: @543046
     /* 543046 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(543181), // Rule ID 12794 //
     /* 543051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 543054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 543082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 543098 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543103 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543103 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543128 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543135 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 543138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 543145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 543150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543179 */     GIR_RootConstrainSelectedInstOperands,
     /* 543180 */     // GIR_Coverage, 12794,
     /* 543180 */     GIR_EraseRootFromParent_Done,
     /* 543181 */   // Label 7062: @543181
     /* 543181 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(543316), // Rule ID 12795 //
     /* 543186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 543189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 543217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 543233 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543233 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543238 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543238 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543243 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543270 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 543273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 543280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 543285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543314 */     GIR_RootConstrainSelectedInstOperands,
     /* 543315 */     // GIR_Coverage, 12795,
     /* 543315 */     GIR_EraseRootFromParent_Done,
     /* 543316 */   // Label 7063: @543316
     /* 543316 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(543451), // Rule ID 11903 //
     /* 543321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 543324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 543348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543368 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543368 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543373 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543373 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543378 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543384 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543398 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543405 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 543408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 543415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 543420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 543435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 543440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543449 */     GIR_RootConstrainSelectedInstOperands,
     /* 543450 */     // GIR_Coverage, 11903,
     /* 543450 */     GIR_EraseRootFromParent_Done,
     /* 543451 */   // Label 7064: @543451
     /* 543451 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(543586), // Rule ID 11904 //
     /* 543456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 543459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 543483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543503 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543503 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543508 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543540 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 543543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 543550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 543555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 543570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 543575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543584 */     GIR_RootConstrainSelectedInstOperands,
     /* 543585 */     // GIR_Coverage, 11904,
     /* 543585 */     GIR_EraseRootFromParent_Done,
     /* 543586 */   // Label 7065: @543586
     /* 543586 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(543721), // Rule ID 11905 //
     /* 543591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 543594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 543618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543638 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543643 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543643 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543648 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543675 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 543678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 543685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 543690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 543695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 543700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 543705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 543710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543719 */     GIR_RootConstrainSelectedInstOperands,
     /* 543720 */     // GIR_Coverage, 11905,
     /* 543720 */     GIR_EraseRootFromParent_Done,
     /* 543721 */   // Label 7066: @543721
     /* 543721 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(543856), // Rule ID 11906 //
     /* 543726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 543729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 543753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543773 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543778 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543778 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543783 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543803 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543810 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 543813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 543820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 543825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 543830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 543835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 543840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 543845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543854 */     GIR_RootConstrainSelectedInstOperands,
     /* 543855 */     // GIR_Coverage, 11906,
     /* 543855 */     GIR_EraseRootFromParent_Done,
     /* 543856 */   // Label 7067: @543856
     /* 543856 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(543991), // Rule ID 12383 //
     /* 543861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 543864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 543868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 543888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543908 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543908 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543913 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543913 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543918 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543922 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543938 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543945 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 543948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 543955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 543960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 543975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 543980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543989 */     GIR_RootConstrainSelectedInstOperands,
     /* 543990 */     // GIR_Coverage, 12383,
     /* 543990 */     GIR_EraseRootFromParent_Done,
     /* 543991 */   // Label 7068: @543991
     /* 543991 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(544126), // Rule ID 12384 //
     /* 543996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 543999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 544003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544043 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544043 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544048 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544048 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544053 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544057 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544059 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544066 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544073 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544080 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 544083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 544090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 544095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 544100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 544105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544124 */     GIR_RootConstrainSelectedInstOperands,
     /* 544125 */     // GIR_Coverage, 12384,
     /* 544125 */     GIR_EraseRootFromParent_Done,
     /* 544126 */   // Label 7069: @544126
     /* 544126 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(544261), // Rule ID 12385 //
     /* 544131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 544134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 544138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544178 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544183 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544201 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544215 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 544218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 544225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 544230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 544235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 544240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544259 */     GIR_RootConstrainSelectedInstOperands,
     /* 544260 */     // GIR_Coverage, 12385,
     /* 544260 */     GIR_EraseRootFromParent_Done,
     /* 544261 */   // Label 7070: @544261
     /* 544261 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(544396), // Rule ID 12386 //
     /* 544266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 544269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 544273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544313 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544318 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544323 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544343 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544350 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 544353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 544360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 544365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 544370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 544375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544394 */     GIR_RootConstrainSelectedInstOperands,
     /* 544395 */     // GIR_Coverage, 12386,
     /* 544395 */     GIR_EraseRootFromParent_Done,
     /* 544396 */   // Label 7071: @544396
     /* 544396 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(544531), // Rule ID 12863 //
     /* 544401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 544404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544448 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544453 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544458 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544485 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 544488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 544495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 544500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 544505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 544510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544529 */     GIR_RootConstrainSelectedInstOperands,
     /* 544530 */     // GIR_Coverage, 12863,
     /* 544530 */     GIR_EraseRootFromParent_Done,
     /* 544531 */   // Label 7072: @544531
     /* 544531 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(544666), // Rule ID 12864 //
     /* 544536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 544539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544575 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544579 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544583 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544588 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544588 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544613 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544620 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 544623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 544630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 544635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 544640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 544645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544664 */     GIR_RootConstrainSelectedInstOperands,
     /* 544665 */     // GIR_Coverage, 12864,
     /* 544665 */     GIR_EraseRootFromParent_Done,
     /* 544666 */   // Label 7073: @544666
     /* 544666 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(544801), // Rule ID 12865 //
     /* 544671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 544674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544718 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544718 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544723 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544728 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544732 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544734 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544741 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544748 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544755 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 544758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 544765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 544770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 544775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 544780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544799 */     GIR_RootConstrainSelectedInstOperands,
     /* 544800 */     // GIR_Coverage, 12865,
     /* 544800 */     GIR_EraseRootFromParent_Done,
     /* 544801 */   // Label 7074: @544801
     /* 544801 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(544936), // Rule ID 12866 //
     /* 544806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 544809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544853 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544853 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544858 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544863 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544867 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544890 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 544893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 544900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 544905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 544910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 544915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 544920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 544925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544934 */     GIR_RootConstrainSelectedInstOperands,
     /* 544935 */     // GIR_Coverage, 12866,
     /* 544935 */     GIR_EraseRootFromParent_Done,
     /* 544936 */   // Label 7075: @544936
     /* 544936 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(545071), // Rule ID 11843 //
     /* 544941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 544944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 544968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 544988 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544988 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544993 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545002 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545011 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545025 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 545028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 545035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 545040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 545045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 545050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545069 */     GIR_RootConstrainSelectedInstOperands,
     /* 545070 */     // GIR_Coverage, 11843,
     /* 545070 */     GIR_EraseRootFromParent_Done,
     /* 545071 */   // Label 7076: @545071
     /* 545071 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(545206), // Rule ID 11844 //
     /* 545076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 545079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 545083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545111 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 545123 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545123 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545128 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545128 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545133 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545137 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545139 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545153 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545160 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 545163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 545170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 545175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 545180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 545185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545204 */     GIR_RootConstrainSelectedInstOperands,
     /* 545205 */     // GIR_Coverage, 11844,
     /* 545205 */     GIR_EraseRootFromParent_Done,
     /* 545206 */   // Label 7077: @545206
     /* 545206 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(545341), // Rule ID 11845 //
     /* 545211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 545214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 545218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 545258 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545263 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545268 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545288 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545295 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 545298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 545305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 545310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 545315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 545320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545339 */     GIR_RootConstrainSelectedInstOperands,
     /* 545340 */     // GIR_Coverage, 11845,
     /* 545340 */     GIR_EraseRootFromParent_Done,
     /* 545341 */   // Label 7078: @545341
     /* 545341 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(545476), // Rule ID 11846 //
     /* 545346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 545349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 545353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 545393 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545393 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545398 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545398 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545403 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545423 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545430 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 545433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 545440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 545445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 545450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 545455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545474 */     GIR_RootConstrainSelectedInstOperands,
     /* 545475 */     // GIR_Coverage, 11846,
     /* 545475 */     GIR_EraseRootFromParent_Done,
     /* 545476 */   // Label 7079: @545476
     /* 545476 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(545611), // Rule ID 12323 //
     /* 545481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 545484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 545488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545516 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 545528 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545528 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545533 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545533 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545538 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545551 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545558 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545565 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 545568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 545575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 545580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 545585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 545590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545609 */     GIR_RootConstrainSelectedInstOperands,
     /* 545610 */     // GIR_Coverage, 12323,
     /* 545610 */     GIR_EraseRootFromParent_Done,
     /* 545611 */   // Label 7080: @545611
     /* 545611 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(545746), // Rule ID 12324 //
     /* 545616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 545619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 545623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 545663 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545663 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545668 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545673 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545686 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545700 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 545703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 545710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 545715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 545720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 545725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545744 */     GIR_RootConstrainSelectedInstOperands,
     /* 545745 */     // GIR_Coverage, 12324,
     /* 545745 */     GIR_EraseRootFromParent_Done,
     /* 545746 */   // Label 7081: @545746
     /* 545746 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(545881), // Rule ID 12325 //
     /* 545751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 545754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 545758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 545798 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545803 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545828 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545835 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 545838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 545845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 545850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 545855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 545860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 545865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 545870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545879 */     GIR_RootConstrainSelectedInstOperands,
     /* 545880 */     // GIR_Coverage, 12325,
     /* 545880 */     GIR_EraseRootFromParent_Done,
     /* 545881 */   // Label 7082: @545881
     /* 545881 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(546016), // Rule ID 12326 //
     /* 545886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 545889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 545893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 545913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 545917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 545933 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545933 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545938 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545963 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545970 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 545973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 545980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 545985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 545990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 545995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546014 */     GIR_RootConstrainSelectedInstOperands,
     /* 546015 */     // GIR_Coverage, 12326,
     /* 546015 */     GIR_EraseRootFromParent_Done,
     /* 546016 */   // Label 7083: @546016
     /* 546016 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(546151), // Rule ID 12803 //
     /* 546021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 546024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 546052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546068 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546068 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546073 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546073 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546078 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546098 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546105 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 546108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 546115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 546120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 546125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 546130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546149 */     GIR_RootConstrainSelectedInstOperands,
     /* 546150 */     // GIR_Coverage, 12803,
     /* 546150 */     GIR_EraseRootFromParent_Done,
     /* 546151 */   // Label 7084: @546151
     /* 546151 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(546286), // Rule ID 12804 //
     /* 546156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 546159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 546187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546203 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546203 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546208 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546208 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546240 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 546243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 546250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 546255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 546260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 546265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546284 */     GIR_RootConstrainSelectedInstOperands,
     /* 546285 */     // GIR_Coverage, 12804,
     /* 546285 */     GIR_EraseRootFromParent_Done,
     /* 546286 */   // Label 7085: @546286
     /* 546286 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(546421), // Rule ID 12805 //
     /* 546291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 546294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 546322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546338 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546338 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546343 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546361 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546368 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546375 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 546378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 546385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 546390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 546395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 546400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546419 */     GIR_RootConstrainSelectedInstOperands,
     /* 546420 */     // GIR_Coverage, 12805,
     /* 546420 */     GIR_EraseRootFromParent_Done,
     /* 546421 */   // Label 7086: @546421
     /* 546421 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(546556), // Rule ID 12806 //
     /* 546426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 546429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 546457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546473 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546478 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546483 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546510 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 546513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 546520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 546525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 546530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 546535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546554 */     GIR_RootConstrainSelectedInstOperands,
     /* 546555 */     // GIR_Coverage, 12806,
     /* 546555 */     GIR_EraseRootFromParent_Done,
     /* 546556 */   // Label 7087: @546556
     /* 546556 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(546691), // Rule ID 11888 //
     /* 546561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 546564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 546592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546608 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546613 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546618 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546638 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546645 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 546648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 546655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 546660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 546665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 546670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546689 */     GIR_RootConstrainSelectedInstOperands,
     /* 546690 */     // GIR_Coverage, 11888,
     /* 546690 */     GIR_EraseRootFromParent_Done,
     /* 546691 */   // Label 7088: @546691
     /* 546691 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(546826), // Rule ID 11889 //
     /* 546696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 546699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 546727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546743 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546748 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546748 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546766 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546780 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 546783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 546790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 546795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 546800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 546805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546824 */     GIR_RootConstrainSelectedInstOperands,
     /* 546825 */     // GIR_Coverage, 11889,
     /* 546825 */     GIR_EraseRootFromParent_Done,
     /* 546826 */   // Label 7089: @546826
     /* 546826 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(546961), // Rule ID 11890 //
     /* 546831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 546834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 546862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546866 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546878 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546878 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546883 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546908 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546915 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 546918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 546925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 546930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 546935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 546940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 546945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 546950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546959 */     GIR_RootConstrainSelectedInstOperands,
     /* 546960 */     // GIR_Coverage, 11890,
     /* 546960 */     GIR_EraseRootFromParent_Done,
     /* 546961 */   // Label 7090: @546961
     /* 546961 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(547096), // Rule ID 11891 //
     /* 546966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 546969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 546993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 546997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547013 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547013 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547018 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547018 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547023 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547036 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547043 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547050 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 547053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 547060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 547065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 547070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 547075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547094 */     GIR_RootConstrainSelectedInstOperands,
     /* 547095 */     // GIR_Coverage, 11891,
     /* 547095 */     GIR_EraseRootFromParent_Done,
     /* 547096 */   // Label 7091: @547096
     /* 547096 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(547231), // Rule ID 12368 //
     /* 547101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 547104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 547108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547148 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547148 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547153 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547171 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547185 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 547188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 547195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 547200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 547205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 547210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547229 */     GIR_RootConstrainSelectedInstOperands,
     /* 547230 */     // GIR_Coverage, 12368,
     /* 547230 */     GIR_EraseRootFromParent_Done,
     /* 547231 */   // Label 7092: @547231
     /* 547231 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(547366), // Rule ID 12369 //
     /* 547236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 547239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 547243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547283 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547288 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547306 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547313 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547320 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 547323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 547330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 547335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 547340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 547345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547364 */     GIR_RootConstrainSelectedInstOperands,
     /* 547365 */     // GIR_Coverage, 12369,
     /* 547365 */     GIR_EraseRootFromParent_Done,
     /* 547366 */   // Label 7093: @547366
     /* 547366 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(547501), // Rule ID 12370 //
     /* 547371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 547374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 547378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547418 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547418 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547423 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547423 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547448 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547455 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 547458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 547465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 547470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 547475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 547480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547499 */     GIR_RootConstrainSelectedInstOperands,
     /* 547500 */     // GIR_Coverage, 12370,
     /* 547500 */     GIR_EraseRootFromParent_Done,
     /* 547501 */   // Label 7094: @547501
     /* 547501 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(547636), // Rule ID 12371 //
     /* 547506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 547509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 547513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547553 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547553 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547558 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547558 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547563 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547567 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547576 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547583 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547590 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 547593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 547600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 547605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 547610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 547615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547634 */     GIR_RootConstrainSelectedInstOperands,
     /* 547635 */     // GIR_Coverage, 12371,
     /* 547635 */     GIR_EraseRootFromParent_Done,
     /* 547636 */   // Label 7095: @547636
     /* 547636 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(547771), // Rule ID 12848 //
     /* 547641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 547644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 547648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547688 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547693 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547693 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547698 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547711 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547718 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547725 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 547728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 547735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 547740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 547745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 547750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547769 */     GIR_RootConstrainSelectedInstOperands,
     /* 547770 */     // GIR_Coverage, 12848,
     /* 547770 */     GIR_EraseRootFromParent_Done,
     /* 547771 */   // Label 7096: @547771
     /* 547771 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(547906), // Rule ID 12849 //
     /* 547776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 547779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 547783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547823 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547823 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547828 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547833 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547837 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547853 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547860 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 547863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 547870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 547875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 547880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 547885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547904 */     GIR_RootConstrainSelectedInstOperands,
     /* 547905 */     // GIR_Coverage, 12849,
     /* 547905 */     GIR_EraseRootFromParent_Done,
     /* 547906 */   // Label 7097: @547906
     /* 547906 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(548041), // Rule ID 12850 //
     /* 547911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 547914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 547918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547958 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547963 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547968 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547988 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547995 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 547998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 548005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 548010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 548015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 548020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548039 */     GIR_RootConstrainSelectedInstOperands,
     /* 548040 */     // GIR_Coverage, 12850,
     /* 548040 */     GIR_EraseRootFromParent_Done,
     /* 548041 */   // Label 7098: @548041
     /* 548041 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(548176), // Rule ID 12851 //
     /* 548046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 548049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548093 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548098 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548107 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548123 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548130 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 548133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 548140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 548145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 548150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 548155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548174 */     GIR_RootConstrainSelectedInstOperands,
     /* 548175 */     // GIR_Coverage, 12851,
     /* 548175 */     GIR_EraseRootFromParent_Done,
     /* 548176 */   // Label 7099: @548176
     /* 548176 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(548311), // Rule ID 11828 //
     /* 548181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 548184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 548228 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548228 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548233 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548233 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548238 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548242 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548258 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548265 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 548268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 548275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 548280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 548285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 548290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548309 */     GIR_RootConstrainSelectedInstOperands,
     /* 548310 */     // GIR_Coverage, 11828,
     /* 548310 */     GIR_EraseRootFromParent_Done,
     /* 548311 */   // Label 7100: @548311
     /* 548311 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(548446), // Rule ID 11829 //
     /* 548316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 548319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548351 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 548363 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548368 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548368 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548393 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548400 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 548403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 548410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 548415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 548420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 548425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548444 */     GIR_RootConstrainSelectedInstOperands,
     /* 548445 */     // GIR_Coverage, 11829,
     /* 548445 */     GIR_EraseRootFromParent_Done,
     /* 548446 */   // Label 7101: @548446
     /* 548446 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(548581), // Rule ID 11830 //
     /* 548451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 548454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548486 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 548498 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548498 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548503 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548503 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548508 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548521 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548528 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548535 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 548538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 548545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 548550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 548555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 548560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548579 */     GIR_RootConstrainSelectedInstOperands,
     /* 548580 */     // GIR_Coverage, 11830,
     /* 548580 */     GIR_EraseRootFromParent_Done,
     /* 548581 */   // Label 7102: @548581
     /* 548581 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(548716), // Rule ID 11831 //
     /* 548586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 548589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 548633 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548633 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548638 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548643 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548647 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548656 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548663 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548670 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 548673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 548680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 548685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 548690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 548695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548714 */     GIR_RootConstrainSelectedInstOperands,
     /* 548715 */     // GIR_Coverage, 11831,
     /* 548715 */     GIR_EraseRootFromParent_Done,
     /* 548716 */   // Label 7103: @548716
     /* 548716 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(548851), // Rule ID 12308 //
     /* 548721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 548724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 548728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 548768 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548768 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548773 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548778 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548805 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 548808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 548815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 548820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 548825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 548830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548849 */     GIR_RootConstrainSelectedInstOperands,
     /* 548850 */     // GIR_Coverage, 12308,
     /* 548850 */     GIR_EraseRootFromParent_Done,
     /* 548851 */   // Label 7104: @548851
     /* 548851 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(548986), // Rule ID 12309 //
     /* 548856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 548859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 548863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 548887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 548903 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548908 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548908 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548926 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548933 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548940 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 548943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 548950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 548955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 548960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 548965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548984 */     GIR_RootConstrainSelectedInstOperands,
     /* 548985 */     // GIR_Coverage, 12309,
     /* 548985 */     GIR_EraseRootFromParent_Done,
     /* 548986 */   // Label 7105: @548986
     /* 548986 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(549121), // Rule ID 12310 //
     /* 548991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 548994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 548998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549038 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549038 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549043 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549043 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549048 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549054 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549061 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549068 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549075 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 549078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 549085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 549090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 549095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 549100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549119 */     GIR_RootConstrainSelectedInstOperands,
     /* 549120 */     // GIR_Coverage, 12310,
     /* 549120 */     GIR_EraseRootFromParent_Done,
     /* 549121 */   // Label 7106: @549121
     /* 549121 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(549256), // Rule ID 12311 //
     /* 549126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 549129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 549133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549161 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549173 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549173 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549178 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549183 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549196 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549203 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549210 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 549213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 549220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 549225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 549230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 549235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549254 */     GIR_RootConstrainSelectedInstOperands,
     /* 549255 */     // GIR_Coverage, 12311,
     /* 549255 */     GIR_EraseRootFromParent_Done,
     /* 549256 */   // Label 7107: @549256
     /* 549256 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(549391), // Rule ID 12788 //
     /* 549261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 549264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549308 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549313 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549318 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549331 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549338 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549345 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 549348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 549355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 549360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 549365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 549370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549389 */     GIR_RootConstrainSelectedInstOperands,
     /* 549390 */     // GIR_Coverage, 12788,
     /* 549390 */     GIR_EraseRootFromParent_Done,
     /* 549391 */   // Label 7108: @549391
     /* 549391 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(549526), // Rule ID 12789 //
     /* 549396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 549399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549443 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549448 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549453 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549480 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 549483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 549490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 549495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 549500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 549505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549524 */     GIR_RootConstrainSelectedInstOperands,
     /* 549525 */     // GIR_Coverage, 12789,
     /* 549525 */     GIR_EraseRootFromParent_Done,
     /* 549526 */   // Label 7109: @549526
     /* 549526 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(549661), // Rule ID 12790 //
     /* 549531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 549534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549578 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549578 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549583 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549588 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549601 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549608 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549615 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 549618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 549625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 549630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 549635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 549640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549659 */     GIR_RootConstrainSelectedInstOperands,
     /* 549660 */     // GIR_Coverage, 12790,
     /* 549660 */     GIR_EraseRootFromParent_Done,
     /* 549661 */   // Label 7110: @549661
     /* 549661 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(549796), // Rule ID 12791 //
     /* 549666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 549669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 549697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549701 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549705 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549709 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549713 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549713 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549718 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549718 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549723 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549727 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549736 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549743 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549750 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 549753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 549760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 549765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 549770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 549775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549794 */     GIR_RootConstrainSelectedInstOperands,
     /* 549795 */     // GIR_Coverage, 12791,
     /* 549795 */     GIR_EraseRootFromParent_Done,
     /* 549796 */   // Label 7111: @549796
     /* 549796 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(549931), // Rule ID 11837 //
     /* 549801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 549804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 549828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 549844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 549848 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 549853 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549853 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 549858 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549878 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549885 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 549888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 549895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 549900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 549905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 549910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549929 */     GIR_RootConstrainSelectedInstOperands,
     /* 549930 */     // GIR_Coverage, 11837,
     /* 549930 */     GIR_EraseRootFromParent_Done,
     /* 549931 */   // Label 7112: @549931
     /* 549931 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(550066), // Rule ID 11838 //
     /* 549936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 549939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 549963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549971 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 549979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 549983 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549983 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 549988 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549988 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 549993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549997 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550013 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550020 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 550023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 550030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 550035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 550040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 550045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550064 */     GIR_RootConstrainSelectedInstOperands,
     /* 550065 */     // GIR_Coverage, 11838,
     /* 550065 */     GIR_EraseRootFromParent_Done,
     /* 550066 */   // Label 7113: @550066
     /* 550066 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(550201), // Rule ID 11841 //
     /* 550071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 550074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 550078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550118 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550118 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550123 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550123 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550148 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550155 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 550158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 550165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 550170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 550175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 550180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550199 */     GIR_RootConstrainSelectedInstOperands,
     /* 550200 */     // GIR_Coverage, 11841,
     /* 550200 */     GIR_EraseRootFromParent_Done,
     /* 550201 */   // Label 7114: @550201
     /* 550201 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(550336), // Rule ID 11842 //
     /* 550206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 550209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 550213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550253 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550258 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550283 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550290 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 550293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 550300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 550305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 550310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 550315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550334 */     GIR_RootConstrainSelectedInstOperands,
     /* 550335 */     // GIR_Coverage, 11842,
     /* 550335 */     GIR_EraseRootFromParent_Done,
     /* 550336 */   // Label 7115: @550336
     /* 550336 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(550471), // Rule ID 12317 //
     /* 550341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 550344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 550348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550388 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550393 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550393 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550398 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550402 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550418 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550425 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 550428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 550435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 550440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 550445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 550450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550469 */     GIR_RootConstrainSelectedInstOperands,
     /* 550470 */     // GIR_Coverage, 12317,
     /* 550470 */     GIR_EraseRootFromParent_Done,
     /* 550471 */   // Label 7116: @550471
     /* 550471 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(550606), // Rule ID 12318 //
     /* 550476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 550479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 550483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550511 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550523 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550523 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550528 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550528 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550533 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550537 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550553 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550560 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 550563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 550570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 550575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 550580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 550585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550604 */     GIR_RootConstrainSelectedInstOperands,
     /* 550605 */     // GIR_Coverage, 12318,
     /* 550605 */     GIR_EraseRootFromParent_Done,
     /* 550606 */   // Label 7117: @550606
     /* 550606 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(550741), // Rule ID 12321 //
     /* 550611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 550614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 550618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550658 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550658 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550663 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550663 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550668 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550672 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550688 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550695 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 550698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 550705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 550710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 550715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 550720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550739 */     GIR_RootConstrainSelectedInstOperands,
     /* 550740 */     // GIR_Coverage, 12321,
     /* 550740 */     GIR_EraseRootFromParent_Done,
     /* 550741 */   // Label 7118: @550741
     /* 550741 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(550876), // Rule ID 12322 //
     /* 550746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 550749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 550753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550793 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550798 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550803 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550823 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550830 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 550833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 550840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 550845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 550850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 550855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550874 */     GIR_RootConstrainSelectedInstOperands,
     /* 550875 */     // GIR_Coverage, 12322,
     /* 550875 */     GIR_EraseRootFromParent_Done,
     /* 550876 */   // Label 7119: @550876
     /* 550876 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(551011), // Rule ID 12797 //
     /* 550881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 550884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 550888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 550908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550916 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 550924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550928 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 550933 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550933 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 550938 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550965 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 550968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 550975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 550980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 550985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 550990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551009 */     GIR_RootConstrainSelectedInstOperands,
     /* 551010 */     // GIR_Coverage, 12797,
     /* 551010 */     GIR_EraseRootFromParent_Done,
     /* 551011 */   // Label 7120: @551011
     /* 551011 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(551146), // Rule ID 12798 //
     /* 551016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 551019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 551063 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551068 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551068 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551073 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551093 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551100 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 551103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 551110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 551115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 551120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 551125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551144 */     GIR_RootConstrainSelectedInstOperands,
     /* 551145 */     // GIR_Coverage, 12798,
     /* 551145 */     GIR_EraseRootFromParent_Done,
     /* 551146 */   // Label 7121: @551146
     /* 551146 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(551281), // Rule ID 12801 //
     /* 551151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 551154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551186 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 551198 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551198 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551203 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551203 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551212 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551228 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551235 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 551238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 551245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 551250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 551255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 551260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551279 */     GIR_RootConstrainSelectedInstOperands,
     /* 551280 */     // GIR_Coverage, 12801,
     /* 551280 */     GIR_EraseRootFromParent_Done,
     /* 551281 */   // Label 7122: @551281
     /* 551281 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(551416), // Rule ID 12802 //
     /* 551286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 551289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551329 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 551333 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551333 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551338 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551338 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551343 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551363 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551370 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 551373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 551380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 551385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 551390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 551395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551414 */     GIR_RootConstrainSelectedInstOperands,
     /* 551415 */     // GIR_Coverage, 12802,
     /* 551415 */     GIR_EraseRootFromParent_Done,
     /* 551416 */   // Label 7123: @551416
     /* 551416 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(551551), // Rule ID 11822 //
     /* 551421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 551424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551468 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551468 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551473 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551478 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551505 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 551508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 551515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 551520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 551525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 551530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551549 */     GIR_RootConstrainSelectedInstOperands,
     /* 551550 */     // GIR_Coverage, 11822,
     /* 551550 */     GIR_EraseRootFromParent_Done,
     /* 551551 */   // Label 7124: @551551
     /* 551551 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(551686), // Rule ID 11823 //
     /* 551556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 551559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551603 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551608 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551613 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551640 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 551643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 551650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 551655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 551660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 551665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551684 */     GIR_RootConstrainSelectedInstOperands,
     /* 551685 */     // GIR_Coverage, 11823,
     /* 551685 */     GIR_EraseRootFromParent_Done,
     /* 551686 */   // Label 7125: @551686
     /* 551686 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(551821), // Rule ID 11826 //
     /* 551691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 551694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551738 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551743 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551752 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551768 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551775 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 551778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 551785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 551790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 551795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 551800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551819 */     GIR_RootConstrainSelectedInstOperands,
     /* 551820 */     // GIR_Coverage, 11826,
     /* 551820 */     GIR_EraseRootFromParent_Done,
     /* 551821 */   // Label 7126: @551821
     /* 551821 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(551956), // Rule ID 11827 //
     /* 551826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 551829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551861 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 551869 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551873 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 551878 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551878 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 551883 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551887 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551903 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551910 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 551913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 551920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 551925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 551930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 551935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551954 */     GIR_RootConstrainSelectedInstOperands,
     /* 551955 */     // GIR_Coverage, 11827,
     /* 551955 */     GIR_EraseRootFromParent_Done,
     /* 551956 */   // Label 7127: @551956
     /* 551956 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(552091), // Rule ID 12302 //
     /* 551961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 551964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 551968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 551976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 551988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552008 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552008 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552013 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552013 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552018 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552038 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552045 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 552048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 552055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 552060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 552065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 552070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552089 */     GIR_RootConstrainSelectedInstOperands,
     /* 552090 */     // GIR_Coverage, 12302,
     /* 552090 */     GIR_EraseRootFromParent_Done,
     /* 552091 */   // Label 7128: @552091
     /* 552091 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(552226), // Rule ID 12303 //
     /* 552096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 552099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 552103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552143 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552143 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552148 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552148 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552153 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552157 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552173 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552180 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 552183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 552190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 552195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 552200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 552205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552224 */     GIR_RootConstrainSelectedInstOperands,
     /* 552225 */     // GIR_Coverage, 12303,
     /* 552225 */     GIR_EraseRootFromParent_Done,
     /* 552226 */   // Label 7129: @552226
     /* 552226 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(552361), // Rule ID 12306 //
     /* 552231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 552234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 552238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552278 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552278 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552283 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552315 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 552318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 552325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 552330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 552335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 552340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552359 */     GIR_RootConstrainSelectedInstOperands,
     /* 552360 */     // GIR_Coverage, 12306,
     /* 552360 */     GIR_EraseRootFromParent_Done,
     /* 552361 */   // Label 7130: @552361
     /* 552361 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(552496), // Rule ID 12307 //
     /* 552366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 552369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 552373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552413 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552418 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552418 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552423 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552443 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552450 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 552453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 552460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 552465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 552470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 552475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552494 */     GIR_RootConstrainSelectedInstOperands,
     /* 552495 */     // GIR_Coverage, 12307,
     /* 552495 */     GIR_EraseRootFromParent_Done,
     /* 552496 */   // Label 7131: @552496
     /* 552496 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(552631), // Rule ID 12782 //
     /* 552501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 552504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552548 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552553 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552553 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552585 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 552588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 552595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 552600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 552605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 552610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552629 */     GIR_RootConstrainSelectedInstOperands,
     /* 552630 */     // GIR_Coverage, 12782,
     /* 552630 */     GIR_EraseRootFromParent_Done,
     /* 552631 */   // Label 7132: @552631
     /* 552631 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(552766), // Rule ID 12783 //
     /* 552636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 552639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552683 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552683 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552688 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552693 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552720 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 552723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 552730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 552735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 552740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 552745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552764 */     GIR_RootConstrainSelectedInstOperands,
     /* 552765 */     // GIR_Coverage, 12783,
     /* 552765 */     GIR_EraseRootFromParent_Done,
     /* 552766 */   // Label 7133: @552766
     /* 552766 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(552901), // Rule ID 12786 //
     /* 552771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 552774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552818 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552818 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552823 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552823 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552828 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552848 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552855 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 552858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 552865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 552870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 552875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 552880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552899 */     GIR_RootConstrainSelectedInstOperands,
     /* 552900 */     // GIR_Coverage, 12786,
     /* 552900 */     GIR_EraseRootFromParent_Done,
     /* 552901 */   // Label 7134: @552901
     /* 552901 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(553036), // Rule ID 12787 //
     /* 552906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 552909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 552933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 552949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552953 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552953 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 552958 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 552963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552967 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552983 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552990 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 552993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 553000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 553005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 553010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 553015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553034 */     GIR_RootConstrainSelectedInstOperands,
     /* 553035 */     // GIR_Coverage, 12787,
     /* 553035 */     GIR_EraseRootFromParent_Done,
     /* 553036 */   // Label 7135: @553036
     /* 553036 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(553171), // Rule ID 7612 //
     /* 553041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 553044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 553084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 553088 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553093 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553125 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 553128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553169 */     GIR_RootConstrainSelectedInstOperands,
     /* 553170 */     // GIR_Coverage, 7612,
     /* 553170 */     GIR_EraseRootFromParent_Done,
     /* 553171 */   // Label 7136: @553171
     /* 553171 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(553306), // Rule ID 7644 //
     /* 553176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 553179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 553183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 553219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 553223 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553228 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553228 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553233 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553253 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553260 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 553263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553304 */     GIR_RootConstrainSelectedInstOperands,
     /* 553305 */     // GIR_Coverage, 7644,
     /* 553305 */     GIR_EraseRootFromParent_Done,
     /* 553306 */   // Label 7137: @553306
     /* 553306 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(553441), // Rule ID 7676 //
     /* 553311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 553314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553346 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 553354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 553358 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553358 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553363 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553368 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553388 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553395 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 553398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553439 */     GIR_RootConstrainSelectedInstOperands,
     /* 553440 */     // GIR_Coverage, 7676,
     /* 553440 */     GIR_EraseRootFromParent_Done,
     /* 553441 */   // Label 7138: @553441
     /* 553441 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(553576), // Rule ID 11836 //
     /* 553446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 553449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 553489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 553493 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553498 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553498 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553503 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553507 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553530 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 553533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553574 */     GIR_RootConstrainSelectedInstOperands,
     /* 553575 */     // GIR_Coverage, 11836,
     /* 553575 */     GIR_EraseRootFromParent_Done,
     /* 553576 */   // Label 7139: @553576
     /* 553576 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(553711), // Rule ID 11839 //
     /* 553581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 553584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 553624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 553628 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553628 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553633 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553633 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553638 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553665 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 553668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 553675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 553680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 553685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 553690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553709 */     GIR_RootConstrainSelectedInstOperands,
     /* 553710 */     // GIR_Coverage, 11839,
     /* 553710 */     GIR_EraseRootFromParent_Done,
     /* 553711 */   // Label 7140: @553711
     /* 553711 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(553846), // Rule ID 11840 //
     /* 553716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 553719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 553759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 553763 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553768 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553768 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553773 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553793 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553800 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 553803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 553810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 553815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 553820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 553825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553844 */     GIR_RootConstrainSelectedInstOperands,
     /* 553845 */     // GIR_Coverage, 11840,
     /* 553845 */     GIR_EraseRootFromParent_Done,
     /* 553846 */   // Label 7141: @553846
     /* 553846 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(553981), // Rule ID 12316 //
     /* 553851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 553854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 553858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 553878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 553894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 553898 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 553903 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 553908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553935 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 553938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553979 */     GIR_RootConstrainSelectedInstOperands,
     /* 553980 */     // GIR_Coverage, 12316,
     /* 553980 */     GIR_EraseRootFromParent_Done,
     /* 553981 */   // Label 7142: @553981
     /* 553981 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(554116), // Rule ID 12319 //
     /* 553986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 553989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 553993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554033 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554038 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554038 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554043 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554047 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554063 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554070 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 554073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 554080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 554085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 554090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 554095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554114 */     GIR_RootConstrainSelectedInstOperands,
     /* 554115 */     // GIR_Coverage, 12319,
     /* 554115 */     GIR_EraseRootFromParent_Done,
     /* 554116 */   // Label 7143: @554116
     /* 554116 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(554251), // Rule ID 12320 //
     /* 554121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 554124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 554128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554168 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554168 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554173 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554173 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554178 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554198 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554205 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 554208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 554215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 554220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 554225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 554230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554249 */     GIR_RootConstrainSelectedInstOperands,
     /* 554250 */     // GIR_Coverage, 12320,
     /* 554250 */     GIR_EraseRootFromParent_Done,
     /* 554251 */   // Label 7144: @554251
     /* 554251 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(554386), // Rule ID 12796 //
     /* 554256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 554259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554303 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554308 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554313 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554333 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554340 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 554343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 554350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 554355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 554360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 554365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554384 */     GIR_RootConstrainSelectedInstOperands,
     /* 554385 */     // GIR_Coverage, 12796,
     /* 554385 */     GIR_EraseRootFromParent_Done,
     /* 554386 */   // Label 7145: @554386
     /* 554386 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(554521), // Rule ID 12799 //
     /* 554391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 554394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554438 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554438 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554443 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554475 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 554478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 554485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 554490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 554495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 554500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554519 */     GIR_RootConstrainSelectedInstOperands,
     /* 554520 */     // GIR_Coverage, 12799,
     /* 554520 */     GIR_EraseRootFromParent_Done,
     /* 554521 */   // Label 7146: @554521
     /* 554521 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(554656), // Rule ID 12800 //
     /* 554526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 554529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554561 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554573 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554573 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554578 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554578 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554610 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 554613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 554620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 554625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 554630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 554635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554654 */     GIR_RootConstrainSelectedInstOperands,
     /* 554655 */     // GIR_Coverage, 12800,
     /* 554655 */     GIR_EraseRootFromParent_Done,
     /* 554656 */   // Label 7147: @554656
     /* 554656 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(554791), // Rule ID 7611 //
     /* 554661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 554664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 554708 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554713 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554713 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554718 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554738 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554745 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 554748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 554755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 554760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 554765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 554770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554789 */     GIR_RootConstrainSelectedInstOperands,
     /* 554790 */     // GIR_Coverage, 7611,
     /* 554790 */     GIR_EraseRootFromParent_Done,
     /* 554791 */   // Label 7148: @554791
     /* 554791 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(554926), // Rule ID 7643 //
     /* 554796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 554799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 554803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 554843 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554848 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554853 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554880 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 554883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 554890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 554895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 554900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 554905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554924 */     GIR_RootConstrainSelectedInstOperands,
     /* 554925 */     // GIR_Coverage, 7643,
     /* 554925 */     GIR_EraseRootFromParent_Done,
     /* 554926 */   // Label 7149: @554926
     /* 554926 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(555061), // Rule ID 7675 //
     /* 554931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 554934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 554974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 554978 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554978 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554983 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554983 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554988 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554992 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555008 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555015 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 555018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 555025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 555030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 555035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 555040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555059 */     GIR_RootConstrainSelectedInstOperands,
     /* 555060 */     // GIR_Coverage, 7675,
     /* 555060 */     GIR_EraseRootFromParent_Done,
     /* 555061 */   // Label 7150: @555061
     /* 555061 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(555196), // Rule ID 11821 //
     /* 555066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 555069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555113 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555113 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555118 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555118 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555127 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555143 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555150 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 555153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 555160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 555165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 555170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 555175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555194 */     GIR_RootConstrainSelectedInstOperands,
     /* 555195 */     // GIR_Coverage, 11821,
     /* 555195 */     GIR_EraseRootFromParent_Done,
     /* 555196 */   // Label 7151: @555196
     /* 555196 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(555331), // Rule ID 11824 //
     /* 555201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 555204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555248 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555253 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555278 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555285 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 555288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 555295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 555300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 555305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 555310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555329 */     GIR_RootConstrainSelectedInstOperands,
     /* 555330 */     // GIR_Coverage, 11824,
     /* 555330 */     GIR_EraseRootFromParent_Done,
     /* 555331 */   // Label 7152: @555331
     /* 555331 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(555466), // Rule ID 11825 //
     /* 555336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 555339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555383 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555388 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555397 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555413 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555420 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 555423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 555430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 555435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 555440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 555445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555464 */     GIR_RootConstrainSelectedInstOperands,
     /* 555465 */     // GIR_Coverage, 11825,
     /* 555465 */     GIR_EraseRootFromParent_Done,
     /* 555466 */   // Label 7153: @555466
     /* 555466 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(555601), // Rule ID 12301 //
     /* 555471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 555474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 555478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555518 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555523 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555523 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555528 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555555 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 555558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 555565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 555570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 555575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 555580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555599 */     GIR_RootConstrainSelectedInstOperands,
     /* 555600 */     // GIR_Coverage, 12301,
     /* 555600 */     GIR_EraseRootFromParent_Done,
     /* 555601 */   // Label 7154: @555601
     /* 555601 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(555736), // Rule ID 12304 //
     /* 555606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 555609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 555613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555641 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555653 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555653 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555658 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555658 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555663 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555683 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555690 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 555693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 555700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 555705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 555710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 555715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555734 */     GIR_RootConstrainSelectedInstOperands,
     /* 555735 */     // GIR_Coverage, 12304,
     /* 555735 */     GIR_EraseRootFromParent_Done,
     /* 555736 */   // Label 7155: @555736
     /* 555736 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(555871), // Rule ID 12305 //
     /* 555741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 555744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 555748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555788 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555788 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555793 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555798 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555818 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555825 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 555828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 555835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 555840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 555845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 555850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555869 */     GIR_RootConstrainSelectedInstOperands,
     /* 555870 */     // GIR_Coverage, 12305,
     /* 555870 */     GIR_EraseRootFromParent_Done,
     /* 555871 */   // Label 7156: @555871
     /* 555871 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(556006), // Rule ID 12781 //
     /* 555876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 555879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 555919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555923 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555928 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555953 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555960 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 555963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 555970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 555975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 555980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 555985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556004 */     GIR_RootConstrainSelectedInstOperands,
     /* 556005 */     // GIR_Coverage, 12781,
     /* 556005 */     GIR_EraseRootFromParent_Done,
     /* 556006 */   // Label 7157: @556006
     /* 556006 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(556141), // Rule ID 12784 //
     /* 556011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 556014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 556054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556058 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556063 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556068 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556095 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 556098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 556105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 556110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 556115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 556120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556139 */     GIR_RootConstrainSelectedInstOperands,
     /* 556140 */     // GIR_Coverage, 12784,
     /* 556140 */     GIR_EraseRootFromParent_Done,
     /* 556141 */   // Label 7158: @556141
     /* 556141 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(556276), // Rule ID 12785 //
     /* 556146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 556149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 556189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556193 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556198 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556198 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556230 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 556233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 556240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 556245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 556250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 556255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556274 */     GIR_RootConstrainSelectedInstOperands,
     /* 556275 */     // GIR_Coverage, 12785,
     /* 556275 */     GIR_EraseRootFromParent_Done,
     /* 556276 */   // Label 7159: @556276
     /* 556276 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(556411), // Rule ID 11807 //
     /* 556281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 556284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556316 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 556328 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556328 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556333 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556333 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556338 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556358 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556365 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 556368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 556375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 556380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 556385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 556390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556409 */     GIR_RootConstrainSelectedInstOperands,
     /* 556410 */     // GIR_Coverage, 11807,
     /* 556410 */     GIR_EraseRootFromParent_Done,
     /* 556411 */   // Label 7160: @556411
     /* 556411 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(556546), // Rule ID 11808 //
     /* 556416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 556419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 556463 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556463 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556468 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556468 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556473 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556477 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556500 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 556503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 556510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 556515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 556520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 556525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556544 */     GIR_RootConstrainSelectedInstOperands,
     /* 556545 */     // GIR_Coverage, 11808,
     /* 556545 */     GIR_EraseRootFromParent_Done,
     /* 556546 */   // Label 7161: @556546
     /* 556546 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(556681), // Rule ID 11811 //
     /* 556551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 556554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 556598 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556598 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556603 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556608 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556635 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 556638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 556645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 556650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 556655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 556660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556679 */     GIR_RootConstrainSelectedInstOperands,
     /* 556680 */     // GIR_Coverage, 11811,
     /* 556680 */     GIR_EraseRootFromParent_Done,
     /* 556681 */   // Label 7162: @556681
     /* 556681 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(556816), // Rule ID 11812 //
     /* 556686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 556689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 556733 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556738 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556743 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556763 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556770 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 556773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 556780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 556785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 556790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 556795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556814 */     GIR_RootConstrainSelectedInstOperands,
     /* 556815 */     // GIR_Coverage, 11812,
     /* 556815 */     GIR_EraseRootFromParent_Done,
     /* 556816 */   // Label 7163: @556816
     /* 556816 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(556951), // Rule ID 12287 //
     /* 556821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 556824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 556828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 556868 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556873 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556878 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556905 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 556908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 556915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 556920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 556925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 556930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556949 */     GIR_RootConstrainSelectedInstOperands,
     /* 556950 */     // GIR_Coverage, 12287,
     /* 556950 */     GIR_EraseRootFromParent_Done,
     /* 556951 */   // Label 7164: @556951
     /* 556951 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(557086), // Rule ID 12288 //
     /* 556956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 556959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 556963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557003 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557008 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557008 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557033 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557040 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 557043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 557055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 557060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 557065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557084 */     GIR_RootConstrainSelectedInstOperands,
     /* 557085 */     // GIR_Coverage, 12288,
     /* 557085 */     GIR_EraseRootFromParent_Done,
     /* 557086 */   // Label 7165: @557086
     /* 557086 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(557221), // Rule ID 12291 //
     /* 557091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 557094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 557098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557138 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557138 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557143 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557143 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557148 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557168 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557175 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 557178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 557185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 557190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 557195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 557200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557219 */     GIR_RootConstrainSelectedInstOperands,
     /* 557220 */     // GIR_Coverage, 12291,
     /* 557220 */     GIR_EraseRootFromParent_Done,
     /* 557221 */   // Label 7166: @557221
     /* 557221 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(557356), // Rule ID 12292 //
     /* 557226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 557229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 557233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557273 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557273 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557278 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557278 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557283 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557303 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557310 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 557313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 557320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 557325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 557330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 557335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557354 */     GIR_RootConstrainSelectedInstOperands,
     /* 557355 */     // GIR_Coverage, 12292,
     /* 557355 */     GIR_EraseRootFromParent_Done,
     /* 557356 */   // Label 7167: @557356
     /* 557356 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(557491), // Rule ID 12767 //
     /* 557361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 557364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557408 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557413 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557418 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557445 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 557448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 557460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 557465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 557470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557489 */     GIR_RootConstrainSelectedInstOperands,
     /* 557490 */     // GIR_Coverage, 12767,
     /* 557490 */     GIR_EraseRootFromParent_Done,
     /* 557491 */   // Label 7168: @557491
     /* 557491 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(557626), // Rule ID 12768 //
     /* 557496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 557499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557531 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557543 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557548 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557553 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557580 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 557583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 557595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 557600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 557605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557624 */     GIR_RootConstrainSelectedInstOperands,
     /* 557625 */     // GIR_Coverage, 12768,
     /* 557625 */     GIR_EraseRootFromParent_Done,
     /* 557626 */   // Label 7169: @557626
     /* 557626 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(557761), // Rule ID 12771 //
     /* 557631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 557634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557678 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557678 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557683 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557683 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557688 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557715 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 557718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 557725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 557730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 557735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 557740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557759 */     GIR_RootConstrainSelectedInstOperands,
     /* 557760 */     // GIR_Coverage, 12771,
     /* 557760 */     GIR_EraseRootFromParent_Done,
     /* 557761 */   // Label 7170: @557761
     /* 557761 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(557896), // Rule ID 12772 //
     /* 557766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 557769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557813 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557818 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557818 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557823 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557827 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557843 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557850 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 557853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 557860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 557865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 557870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 557875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557894 */     GIR_RootConstrainSelectedInstOperands,
     /* 557895 */     // GIR_Coverage, 12772,
     /* 557895 */     GIR_EraseRootFromParent_Done,
     /* 557896 */   // Label 7171: @557896
     /* 557896 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(558031), // Rule ID 11792 //
     /* 557901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 557904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 557948 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557948 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557953 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557953 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557958 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557985 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 557988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 558000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 558005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 558010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558029 */     GIR_RootConstrainSelectedInstOperands,
     /* 558030 */     // GIR_Coverage, 11792,
     /* 558030 */     GIR_EraseRootFromParent_Done,
     /* 558031 */   // Label 7172: @558031
     /* 558031 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(558166), // Rule ID 11793 //
     /* 558036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 558039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558071 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 558083 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558083 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558088 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558120 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 558123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 558130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 558135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 558140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 558145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558164 */     GIR_RootConstrainSelectedInstOperands,
     /* 558165 */     // GIR_Coverage, 11793,
     /* 558165 */     GIR_EraseRootFromParent_Done,
     /* 558166 */   // Label 7173: @558166
     /* 558166 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(558301), // Rule ID 11796 //
     /* 558171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 558174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 558218 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558223 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558255 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 558258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 558265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 558270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 558275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 558280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558299 */     GIR_RootConstrainSelectedInstOperands,
     /* 558300 */     // GIR_Coverage, 11796,
     /* 558300 */     GIR_EraseRootFromParent_Done,
     /* 558301 */   // Label 7174: @558301
     /* 558301 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(558436), // Rule ID 11797 //
     /* 558306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 558309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 558353 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558358 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558358 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558363 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558383 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558390 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 558393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 558400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 558405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 558410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 558415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558434 */     GIR_RootConstrainSelectedInstOperands,
     /* 558435 */     // GIR_Coverage, 11797,
     /* 558435 */     GIR_EraseRootFromParent_Done,
     /* 558436 */   // Label 7175: @558436
     /* 558436 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(558571), // Rule ID 12272 //
     /* 558441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 558444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 558448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558476 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 558488 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558493 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558498 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558511 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558518 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558525 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 558528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 558535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 558540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 558545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 558550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558569 */     GIR_RootConstrainSelectedInstOperands,
     /* 558570 */     // GIR_Coverage, 12272,
     /* 558570 */     GIR_EraseRootFromParent_Done,
     /* 558571 */   // Label 7176: @558571
     /* 558571 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(558706), // Rule ID 12273 //
     /* 558576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 558579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 558583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558611 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 558623 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558623 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558628 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558628 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558633 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558637 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558660 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 558663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 558670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 558675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 558680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 558685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558704 */     GIR_RootConstrainSelectedInstOperands,
     /* 558705 */     // GIR_Coverage, 12273,
     /* 558705 */     GIR_EraseRootFromParent_Done,
     /* 558706 */   // Label 7177: @558706
     /* 558706 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(558841), // Rule ID 12276 //
     /* 558711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 558714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 558718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 558758 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558758 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558763 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558795 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 558798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 558805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 558810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 558815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 558820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558839 */     GIR_RootConstrainSelectedInstOperands,
     /* 558840 */     // GIR_Coverage, 12276,
     /* 558840 */     GIR_EraseRootFromParent_Done,
     /* 558841 */   // Label 7178: @558841
     /* 558841 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(558976), // Rule ID 12277 //
     /* 558846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 558849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 558853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 558889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 558893 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558898 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558923 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558930 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 558933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 558940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 558945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 558950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 558955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558974 */     GIR_RootConstrainSelectedInstOperands,
     /* 558975 */     // GIR_Coverage, 12277,
     /* 558975 */     GIR_EraseRootFromParent_Done,
     /* 558976 */   // Label 7179: @558976
     /* 558976 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(559111), // Rule ID 12752 //
     /* 558981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 558984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 559024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559028 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559033 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559065 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 559068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 559075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 559080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 559085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 559090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559109 */     GIR_RootConstrainSelectedInstOperands,
     /* 559110 */     // GIR_Coverage, 12752,
     /* 559110 */     GIR_EraseRootFromParent_Done,
     /* 559111 */   // Label 7180: @559111
     /* 559111 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(559246), // Rule ID 12753 //
     /* 559116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 559119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 559159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559163 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559168 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559168 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559173 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559193 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559200 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 559203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 559210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 559215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 559220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 559225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559244 */     GIR_RootConstrainSelectedInstOperands,
     /* 559245 */     // GIR_Coverage, 12753,
     /* 559245 */     GIR_EraseRootFromParent_Done,
     /* 559246 */   // Label 7181: @559246
     /* 559246 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(559381), // Rule ID 12756 //
     /* 559251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 559254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 559294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559298 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559298 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559303 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559308 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559314 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559328 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559335 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 559338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 559345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 559350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 559355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 559360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559379 */     GIR_RootConstrainSelectedInstOperands,
     /* 559380 */     // GIR_Coverage, 12756,
     /* 559380 */     GIR_EraseRootFromParent_Done,
     /* 559381 */   // Label 7182: @559381
     /* 559381 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(559516), // Rule ID 12757 //
     /* 559386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 559389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 559429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559433 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559433 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559438 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559438 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559443 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559447 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559463 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559470 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 559473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 559480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 559485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 559490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 559495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559514 */     GIR_RootConstrainSelectedInstOperands,
     /* 559515 */     // GIR_Coverage, 12757,
     /* 559515 */     GIR_EraseRootFromParent_Done,
     /* 559516 */   // Label 7183: @559516
     /* 559516 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(559651), // Rule ID 7610 //
     /* 559521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 559524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559556 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 559564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 559568 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559573 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559573 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559578 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559598 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559605 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 559608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 559615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 559620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 559625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 559630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559649 */     GIR_RootConstrainSelectedInstOperands,
     /* 559650 */     // GIR_Coverage, 7610,
     /* 559650 */     GIR_EraseRootFromParent_Done,
     /* 559651 */   // Label 7184: @559651
     /* 559651 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(559786), // Rule ID 7642 //
     /* 559656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 559659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 559663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 559699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 559703 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559708 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559713 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559733 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559740 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 559743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 559750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 559755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 559760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 559765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559784 */     GIR_RootConstrainSelectedInstOperands,
     /* 559785 */     // GIR_Coverage, 7642,
     /* 559785 */     GIR_EraseRootFromParent_Done,
     /* 559786 */   // Label 7185: @559786
     /* 559786 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(559921), // Rule ID 7674 //
     /* 559791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 559794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 559834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 559838 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559843 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559875 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 559878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 559885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 559890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 559895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 559900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559919 */     GIR_RootConstrainSelectedInstOperands,
     /* 559920 */     // GIR_Coverage, 7674,
     /* 559920 */     GIR_EraseRootFromParent_Done,
     /* 559921 */   // Label 7186: @559921
     /* 559921 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(560056), // Rule ID 11806 //
     /* 559926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 559929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 559969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 559973 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559978 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559978 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559983 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560003 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560010 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 560013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 560020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 560025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 560030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 560035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560054 */     GIR_RootConstrainSelectedInstOperands,
     /* 560055 */     // GIR_Coverage, 11806,
     /* 560055 */     GIR_EraseRootFromParent_Done,
     /* 560056 */   // Label 7187: @560056
     /* 560056 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(560191), // Rule ID 11809 //
     /* 560061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 560064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560108 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560108 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560113 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560113 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560118 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560138 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560145 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 560148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 560155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 560160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 560165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 560170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560189 */     GIR_RootConstrainSelectedInstOperands,
     /* 560190 */     // GIR_Coverage, 11809,
     /* 560190 */     GIR_EraseRootFromParent_Done,
     /* 560191 */   // Label 7188: @560191
     /* 560191 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(560326), // Rule ID 11810 //
     /* 560196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 560199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560243 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560248 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560253 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560280 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 560283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 560290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 560295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 560300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 560305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560324 */     GIR_RootConstrainSelectedInstOperands,
     /* 560325 */     // GIR_Coverage, 11810,
     /* 560325 */     GIR_EraseRootFromParent_Done,
     /* 560326 */   // Label 7189: @560326
     /* 560326 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(560461), // Rule ID 12286 //
     /* 560331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 560334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 560338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560378 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560383 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560388 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560415 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 560418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 560425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 560430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 560435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 560440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560459 */     GIR_RootConstrainSelectedInstOperands,
     /* 560460 */     // GIR_Coverage, 12286,
     /* 560460 */     GIR_EraseRootFromParent_Done,
     /* 560461 */   // Label 7190: @560461
     /* 560461 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(560596), // Rule ID 12289 //
     /* 560466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 560469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 560473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560513 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560518 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560523 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560527 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560550 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 560553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 560560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 560565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 560570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 560575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560594 */     GIR_RootConstrainSelectedInstOperands,
     /* 560595 */     // GIR_Coverage, 12289,
     /* 560595 */     GIR_EraseRootFromParent_Done,
     /* 560596 */   // Label 7191: @560596
     /* 560596 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(560731), // Rule ID 12290 //
     /* 560601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 560604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 560608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560644 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560648 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560648 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560653 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560653 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560662 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560678 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560685 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 560688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 560695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 560700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 560705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 560710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560729 */     GIR_RootConstrainSelectedInstOperands,
     /* 560730 */     // GIR_Coverage, 12290,
     /* 560730 */     GIR_EraseRootFromParent_Done,
     /* 560731 */   // Label 7192: @560731
     /* 560731 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(560866), // Rule ID 12766 //
     /* 560736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 560739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560771 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560783 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560788 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560788 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560793 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560797 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560813 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560820 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 560823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 560830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 560835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 560840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 560845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560864 */     GIR_RootConstrainSelectedInstOperands,
     /* 560865 */     // GIR_Coverage, 12766,
     /* 560865 */     GIR_EraseRootFromParent_Done,
     /* 560866 */   // Label 7193: @560866
     /* 560866 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(561001), // Rule ID 12769 //
     /* 560871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 560874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560918 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560918 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560923 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560928 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560955 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 560958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 560965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 560970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 560975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 560980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560999 */     GIR_RootConstrainSelectedInstOperands,
     /* 561000 */     // GIR_Coverage, 12769,
     /* 561000 */     GIR_EraseRootFromParent_Done,
     /* 561001 */   // Label 7194: @561001
     /* 561001 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(561136), // Rule ID 12770 //
     /* 561006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 561009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 561053 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561058 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561063 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561083 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561090 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 561093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 561100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 561105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 561110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 561115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561134 */     GIR_RootConstrainSelectedInstOperands,
     /* 561135 */     // GIR_Coverage, 12770,
     /* 561135 */     GIR_EraseRootFromParent_Done,
     /* 561136 */   // Label 7195: @561136
     /* 561136 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(561271), // Rule ID 7609 //
     /* 561141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 561144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 561188 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561193 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561225 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 561228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 561235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 561240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 561245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 561250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561269 */     GIR_RootConstrainSelectedInstOperands,
     /* 561270 */     // GIR_Coverage, 7609,
     /* 561270 */     GIR_EraseRootFromParent_Done,
     /* 561271 */   // Label 7196: @561271
     /* 561271 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(561406), // Rule ID 7641 //
     /* 561276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 561279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 561283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 561323 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561328 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561328 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561353 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561360 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 561363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 561370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 561375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 561380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 561385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561404 */     GIR_RootConstrainSelectedInstOperands,
     /* 561405 */     // GIR_Coverage, 7641,
     /* 561405 */     GIR_EraseRootFromParent_Done,
     /* 561406 */   // Label 7197: @561406
     /* 561406 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(561541), // Rule ID 7673 //
     /* 561411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 561414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 561458 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561458 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561463 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561463 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561468 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561472 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561495 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 561498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 561505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 561510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 561515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 561520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561539 */     GIR_RootConstrainSelectedInstOperands,
     /* 561540 */     // GIR_Coverage, 7673,
     /* 561540 */     GIR_EraseRootFromParent_Done,
     /* 561541 */   // Label 7198: @561541
     /* 561541 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(561676), // Rule ID 11791 //
     /* 561546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 561549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 561593 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561593 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561598 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561598 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561603 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561630 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 561633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 561640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 561645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 561650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 561655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561674 */     GIR_RootConstrainSelectedInstOperands,
     /* 561675 */     // GIR_Coverage, 11791,
     /* 561675 */     GIR_EraseRootFromParent_Done,
     /* 561676 */   // Label 7199: @561676
     /* 561676 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(561811), // Rule ID 11794 //
     /* 561681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 561684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 561728 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561728 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561733 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561765 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 561768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 561775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 561780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 561785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 561790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561809 */     GIR_RootConstrainSelectedInstOperands,
     /* 561810 */     // GIR_Coverage, 11794,
     /* 561810 */     GIR_EraseRootFromParent_Done,
     /* 561811 */   // Label 7200: @561811
     /* 561811 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(561946), // Rule ID 11795 //
     /* 561816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 561819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 561863 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561868 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561873 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561877 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561900 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 561903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 561910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 561915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 561920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 561925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561944 */     GIR_RootConstrainSelectedInstOperands,
     /* 561945 */     // GIR_Coverage, 11795,
     /* 561945 */     GIR_EraseRootFromParent_Done,
     /* 561946 */   // Label 7201: @561946
     /* 561946 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(562081), // Rule ID 12271 //
     /* 561951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 561954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 561958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 561994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 561998 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562003 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562008 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562035 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 562038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 562045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 562050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 562055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 562060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562079 */     GIR_RootConstrainSelectedInstOperands,
     /* 562080 */     // GIR_Coverage, 12271,
     /* 562080 */     GIR_EraseRootFromParent_Done,
     /* 562081 */   // Label 7202: @562081
     /* 562081 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(562216), // Rule ID 12274 //
     /* 562086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 562089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 562093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 562129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562133 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562138 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562138 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562143 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562156 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562163 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562170 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 562173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 562190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 562195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562214 */     GIR_RootConstrainSelectedInstOperands,
     /* 562215 */     // GIR_Coverage, 12274,
     /* 562215 */     GIR_EraseRootFromParent_Done,
     /* 562216 */   // Label 7203: @562216
     /* 562216 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(562351), // Rule ID 12275 //
     /* 562221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 562224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 562228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 562264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562268 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562268 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562273 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562273 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562278 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562282 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562305 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 562308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 562325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 562330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562349 */     GIR_RootConstrainSelectedInstOperands,
     /* 562350 */     // GIR_Coverage, 12275,
     /* 562350 */     GIR_EraseRootFromParent_Done,
     /* 562351 */   // Label 7204: @562351
     /* 562351 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(562486), // Rule ID 12751 //
     /* 562356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 562359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 562399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562403 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562408 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562413 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562433 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562440 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 562443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 562450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 562455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 562460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 562465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562484 */     GIR_RootConstrainSelectedInstOperands,
     /* 562485 */     // GIR_Coverage, 12751,
     /* 562485 */     GIR_EraseRootFromParent_Done,
     /* 562486 */   // Label 7205: @562486
     /* 562486 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(562621), // Rule ID 12754 //
     /* 562491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 562494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 562534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562538 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562543 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562548 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562575 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 562578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 562595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 562600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562619 */     GIR_RootConstrainSelectedInstOperands,
     /* 562620 */     // GIR_Coverage, 12754,
     /* 562620 */     GIR_EraseRootFromParent_Done,
     /* 562621 */   // Label 7206: @562621
     /* 562621 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(562756), // Rule ID 12755 //
     /* 562626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 562629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 562669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562673 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562678 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562678 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562696 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562703 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562710 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 562713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 562730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 562735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562754 */     GIR_RootConstrainSelectedInstOperands,
     /* 562755 */     // GIR_Coverage, 12755,
     /* 562755 */     GIR_EraseRootFromParent_Done,
     /* 562756 */   // Label 7207: @562756
     /* 562756 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(562891), // Rule ID 11877 //
     /* 562761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 562764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 562788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 562792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 562804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 562808 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 562813 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 562818 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562838 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562845 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 562848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 562865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 562870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 562875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 562880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562889 */     GIR_RootConstrainSelectedInstOperands,
     /* 562890 */     // GIR_Coverage, 11877,
     /* 562890 */     GIR_EraseRootFromParent_Done,
     /* 562891 */   // Label 7208: @562891
     /* 562891 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(563026), // Rule ID 11878 //
     /* 562896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 562899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 562923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 562927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 562939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 562943 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562943 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 562948 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562948 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 562953 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562957 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562980 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 562983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 563000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 563005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563024 */     GIR_RootConstrainSelectedInstOperands,
     /* 563025 */     // GIR_Coverage, 11878,
     /* 563025 */     GIR_EraseRootFromParent_Done,
     /* 563026 */   // Label 7209: @563026
     /* 563026 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(563161), // Rule ID 11879 //
     /* 563031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 563034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 563038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563078 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563078 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563083 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563083 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563088 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563108 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563115 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 563118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 563125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 563130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 563135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 563140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563159 */     GIR_RootConstrainSelectedInstOperands,
     /* 563160 */     // GIR_Coverage, 11879,
     /* 563160 */     GIR_EraseRootFromParent_Done,
     /* 563161 */   // Label 7210: @563161
     /* 563161 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(563296), // Rule ID 11880 //
     /* 563166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 563169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 563173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563213 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563218 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563223 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563236 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563250 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 563253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 563260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 563265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 563270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 563275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563294 */     GIR_RootConstrainSelectedInstOperands,
     /* 563295 */     // GIR_Coverage, 11880,
     /* 563295 */     GIR_EraseRootFromParent_Done,
     /* 563296 */   // Label 7211: @563296
     /* 563296 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(563431), // Rule ID 12357 //
     /* 563301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 563304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 563308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563348 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563353 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563358 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563385 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 563388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 563395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 563400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 563405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 563410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563429 */     GIR_RootConstrainSelectedInstOperands,
     /* 563430 */     // GIR_Coverage, 12357,
     /* 563430 */     GIR_EraseRootFromParent_Done,
     /* 563431 */   // Label 7212: @563431
     /* 563431 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(563566), // Rule ID 12358 //
     /* 563436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 563439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 563443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563483 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563488 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563493 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563520 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 563523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 563530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 563535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 563540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 563545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563564 */     GIR_RootConstrainSelectedInstOperands,
     /* 563565 */     // GIR_Coverage, 12358,
     /* 563565 */     GIR_EraseRootFromParent_Done,
     /* 563566 */   // Label 7213: @563566
     /* 563566 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(563701), // Rule ID 12359 //
     /* 563571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 563574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 563578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563618 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563618 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563623 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563623 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563628 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563634 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563648 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563655 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 563658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 563665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 563670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 563675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 563680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563699 */     GIR_RootConstrainSelectedInstOperands,
     /* 563700 */     // GIR_Coverage, 12359,
     /* 563700 */     GIR_EraseRootFromParent_Done,
     /* 563701 */   // Label 7214: @563701
     /* 563701 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(563836), // Rule ID 12360 //
     /* 563706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 563709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 563713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563741 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563753 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563753 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563758 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563758 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563767 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563783 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563790 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 563793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 563800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 563805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 563810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 563815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563834 */     GIR_RootConstrainSelectedInstOperands,
     /* 563835 */     // GIR_Coverage, 12360,
     /* 563835 */     GIR_EraseRootFromParent_Done,
     /* 563836 */   // Label 7215: @563836
     /* 563836 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(563971), // Rule ID 12837 //
     /* 563841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 563844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 563848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 563868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 563884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 563888 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563888 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 563893 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 563898 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563925 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 563928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 563935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 563940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 563945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 563950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 563955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 563960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563969 */     GIR_RootConstrainSelectedInstOperands,
     /* 563970 */     // GIR_Coverage, 12837,
     /* 563970 */     GIR_EraseRootFromParent_Done,
     /* 563971 */   // Label 7216: @563971
     /* 563971 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(564106), // Rule ID 12838 //
     /* 563976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 563979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 563983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564011 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 564023 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564028 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564053 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564060 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 564063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 564070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 564075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 564080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 564085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564104 */     GIR_RootConstrainSelectedInstOperands,
     /* 564105 */     // GIR_Coverage, 12838,
     /* 564105 */     GIR_EraseRootFromParent_Done,
     /* 564106 */   // Label 7217: @564106
     /* 564106 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(564241), // Rule ID 12839 //
     /* 564111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 564114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 564158 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564163 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564168 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564195 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 564198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 564205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 564210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 564215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 564220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564239 */     GIR_RootConstrainSelectedInstOperands,
     /* 564240 */     // GIR_Coverage, 12839,
     /* 564240 */     GIR_EraseRootFromParent_Done,
     /* 564241 */   // Label 7218: @564241
     /* 564241 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(564376), // Rule ID 12840 //
     /* 564246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 564249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564281 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 564293 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564293 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564298 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564298 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564303 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564323 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564330 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 564333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 564340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 564345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 564350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 564355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564374 */     GIR_RootConstrainSelectedInstOperands,
     /* 564375 */     // GIR_Coverage, 12840,
     /* 564375 */     GIR_EraseRootFromParent_Done,
     /* 564376 */   // Label 7219: @564376
     /* 564376 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(564511), // Rule ID 11817 //
     /* 564381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 564384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564428 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564428 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564433 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564433 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564438 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564465 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 564468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 564475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 564480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 564485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 564490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564509 */     GIR_RootConstrainSelectedInstOperands,
     /* 564510 */     // GIR_Coverage, 11817,
     /* 564510 */     GIR_EraseRootFromParent_Done,
     /* 564511 */   // Label 7220: @564511
     /* 564511 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(564646), // Rule ID 11818 //
     /* 564516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 564519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564563 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564563 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564568 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564573 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564600 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 564603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 564610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 564615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 564620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 564625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564644 */     GIR_RootConstrainSelectedInstOperands,
     /* 564645 */     // GIR_Coverage, 11818,
     /* 564645 */     GIR_EraseRootFromParent_Done,
     /* 564646 */   // Label 7221: @564646
     /* 564646 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(564781), // Rule ID 11819 //
     /* 564651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 564654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564698 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564703 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564728 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564735 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 564738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 564745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 564750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 564755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 564760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564779 */     GIR_RootConstrainSelectedInstOperands,
     /* 564780 */     // GIR_Coverage, 11819,
     /* 564780 */     GIR_EraseRootFromParent_Done,
     /* 564781 */   // Label 7222: @564781
     /* 564781 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(564916), // Rule ID 11820 //
     /* 564786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 564789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564833 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564838 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564863 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564870 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 564873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 564880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 564885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 564890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 564895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 564900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 564905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564914 */     GIR_RootConstrainSelectedInstOperands,
     /* 564915 */     // GIR_Coverage, 11820,
     /* 564915 */     GIR_EraseRootFromParent_Done,
     /* 564916 */   // Label 7223: @564916
     /* 564916 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(565051), // Rule ID 12297 //
     /* 564921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 564924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 564928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 564948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 564964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564968 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 564973 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 564978 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564982 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565005 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 565008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 565015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 565020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 565025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 565030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565049 */     GIR_RootConstrainSelectedInstOperands,
     /* 565050 */     // GIR_Coverage, 12297,
     /* 565050 */     GIR_EraseRootFromParent_Done,
     /* 565051 */   // Label 7224: @565051
     /* 565051 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(565186), // Rule ID 12298 //
     /* 565056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 565059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 565063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565099 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565103 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565103 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565108 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565108 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565113 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565117 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565133 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565140 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 565143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 565150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 565155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 565160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 565165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565184 */     GIR_RootConstrainSelectedInstOperands,
     /* 565185 */     // GIR_Coverage, 12298,
     /* 565185 */     GIR_EraseRootFromParent_Done,
     /* 565186 */   // Label 7225: @565186
     /* 565186 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(565321), // Rule ID 12299 //
     /* 565191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 565194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 565198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565238 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565238 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565243 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565248 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565254 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565275 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 565278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 565285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 565290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 565295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 565300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565319 */     GIR_RootConstrainSelectedInstOperands,
     /* 565320 */     // GIR_Coverage, 12299,
     /* 565320 */     GIR_EraseRootFromParent_Done,
     /* 565321 */   // Label 7226: @565321
     /* 565321 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(565456), // Rule ID 12300 //
     /* 565326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 565329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 565333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565373 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565373 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565378 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565383 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565403 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565410 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 565413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 565420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 565425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 565430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 565435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565454 */     GIR_RootConstrainSelectedInstOperands,
     /* 565455 */     // GIR_Coverage, 12300,
     /* 565455 */     GIR_EraseRootFromParent_Done,
     /* 565456 */   // Label 7227: @565456
     /* 565456 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(565591), // Rule ID 12777 //
     /* 565461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 565464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 565468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565508 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565513 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565518 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565545 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 565548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 565555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 565560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 565565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 565570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565589 */     GIR_RootConstrainSelectedInstOperands,
     /* 565590 */     // GIR_Coverage, 12777,
     /* 565590 */     GIR_EraseRootFromParent_Done,
     /* 565591 */   // Label 7228: @565591
     /* 565591 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(565726), // Rule ID 12778 //
     /* 565596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 565599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 565603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565643 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565643 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565648 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565648 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565653 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565680 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 565683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 565690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 565695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 565700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 565705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565724 */     GIR_RootConstrainSelectedInstOperands,
     /* 565725 */     // GIR_Coverage, 12778,
     /* 565725 */     GIR_EraseRootFromParent_Done,
     /* 565726 */   // Label 7229: @565726
     /* 565726 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(565861), // Rule ID 12779 //
     /* 565731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 565734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 565738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565778 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565778 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565783 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565788 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565808 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565815 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 565818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 565825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 565830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 565835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 565840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565859 */     GIR_RootConstrainSelectedInstOperands,
     /* 565860 */     // GIR_Coverage, 12779,
     /* 565860 */     GIR_EraseRootFromParent_Done,
     /* 565861 */   // Label 7230: @565861
     /* 565861 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(565996), // Rule ID 12780 //
     /* 565866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 565869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 565873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 565893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 565909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565913 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565913 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 565918 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565918 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 565923 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565927 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565943 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565950 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 565953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 565960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 565965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 565970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 565975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 565980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 565985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565994 */     GIR_RootConstrainSelectedInstOperands,
     /* 565995 */     // GIR_Coverage, 12780,
     /* 565995 */     GIR_EraseRootFromParent_Done,
     /* 565996 */   // Label 7231: @565996
     /* 565996 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(566131), // Rule ID 11862 //
     /* 566001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 566004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 566048 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566048 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566053 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566058 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566078 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566085 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 566088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 566095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 566100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 566105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 566110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566129 */     GIR_RootConstrainSelectedInstOperands,
     /* 566130 */     // GIR_Coverage, 11862,
     /* 566130 */     GIR_EraseRootFromParent_Done,
     /* 566131 */   // Label 7232: @566131
     /* 566131 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(566266), // Rule ID 11863 //
     /* 566136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 566139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 566183 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566188 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566220 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 566223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 566230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 566235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 566240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 566245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566264 */     GIR_RootConstrainSelectedInstOperands,
     /* 566265 */     // GIR_Coverage, 11863,
     /* 566265 */     GIR_EraseRootFromParent_Done,
     /* 566266 */   // Label 7233: @566266
     /* 566266 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(566401), // Rule ID 11864 //
     /* 566271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 566274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 566318 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566323 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566328 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566355 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 566358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 566365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 566370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 566375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 566380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566399 */     GIR_RootConstrainSelectedInstOperands,
     /* 566400 */     // GIR_Coverage, 11864,
     /* 566400 */     GIR_EraseRootFromParent_Done,
     /* 566401 */   // Label 7234: @566401
     /* 566401 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(566536), // Rule ID 11865 //
     /* 566406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 566409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 566453 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566458 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566458 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566467 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566483 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566490 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 566493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 566500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 566505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 566510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 566515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566534 */     GIR_RootConstrainSelectedInstOperands,
     /* 566535 */     // GIR_Coverage, 11865,
     /* 566535 */     GIR_EraseRootFromParent_Done,
     /* 566536 */   // Label 7235: @566536
     /* 566536 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(566671), // Rule ID 12342 //
     /* 566541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 566544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 566548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 566588 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566588 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566593 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566593 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566598 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566602 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566625 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 566628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 566635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 566640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 566645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 566650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566669 */     GIR_RootConstrainSelectedInstOperands,
     /* 566670 */     // GIR_Coverage, 12342,
     /* 566670 */     GIR_EraseRootFromParent_Done,
     /* 566671 */   // Label 7236: @566671
     /* 566671 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(566806), // Rule ID 12343 //
     /* 566676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 566679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 566683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 566723 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566728 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566728 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566737 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566753 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566760 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 566763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 566770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 566775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 566780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 566785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566804 */     GIR_RootConstrainSelectedInstOperands,
     /* 566805 */     // GIR_Coverage, 12343,
     /* 566805 */     GIR_EraseRootFromParent_Done,
     /* 566806 */   // Label 7237: @566806
     /* 566806 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(566941), // Rule ID 12344 //
     /* 566811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 566814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 566818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 566858 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 566863 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566895 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 566898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 566905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 566910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 566915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 566920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 566925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 566930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566939 */     GIR_RootConstrainSelectedInstOperands,
     /* 566940 */     // GIR_Coverage, 12344,
     /* 566940 */     GIR_EraseRootFromParent_Done,
     /* 566941 */   // Label 7238: @566941
     /* 566941 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(567076), // Rule ID 12345 //
     /* 566946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 566949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 566953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 566973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 566989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 566993 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 566998 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567003 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567030 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 567033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 567040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 567045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 567050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 567055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567074 */     GIR_RootConstrainSelectedInstOperands,
     /* 567075 */     // GIR_Coverage, 12345,
     /* 567075 */     GIR_EraseRootFromParent_Done,
     /* 567076 */   // Label 7239: @567076
     /* 567076 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(567211), // Rule ID 12822 //
     /* 567081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 567084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567128 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567128 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567133 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567165 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 567168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 567175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 567180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 567185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 567190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567209 */     GIR_RootConstrainSelectedInstOperands,
     /* 567210 */     // GIR_Coverage, 12822,
     /* 567210 */     GIR_EraseRootFromParent_Done,
     /* 567211 */   // Label 7240: @567211
     /* 567211 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(567346), // Rule ID 12823 //
     /* 567216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 567219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567263 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567268 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567268 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567273 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567277 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567293 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567300 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 567303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 567310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 567315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 567320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 567325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567344 */     GIR_RootConstrainSelectedInstOperands,
     /* 567345 */     // GIR_Coverage, 12823,
     /* 567345 */     GIR_EraseRootFromParent_Done,
     /* 567346 */   // Label 7241: @567346
     /* 567346 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(567481), // Rule ID 12824 //
     /* 567351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 567354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567398 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567398 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567403 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567428 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567435 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 567438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 567445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 567450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 567455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 567460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567479 */     GIR_RootConstrainSelectedInstOperands,
     /* 567480 */     // GIR_Coverage, 12824,
     /* 567480 */     GIR_EraseRootFromParent_Done,
     /* 567481 */   // Label 7242: @567481
     /* 567481 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(567616), // Rule ID 12825 //
     /* 567486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 567489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567533 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567533 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567538 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567543 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567563 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567570 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 567573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 567580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 567585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 567590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 567595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567614 */     GIR_RootConstrainSelectedInstOperands,
     /* 567615 */     // GIR_Coverage, 12825,
     /* 567615 */     GIR_EraseRootFromParent_Done,
     /* 567616 */   // Label 7243: @567616
     /* 567616 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(567751), // Rule ID 11802 //
     /* 567621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 567624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567668 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567673 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567705 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 567708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 567715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 567720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 567725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 567730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567749 */     GIR_RootConstrainSelectedInstOperands,
     /* 567750 */     // GIR_Coverage, 11802,
     /* 567750 */     GIR_EraseRootFromParent_Done,
     /* 567751 */   // Label 7244: @567751
     /* 567751 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(567886), // Rule ID 11803 //
     /* 567756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 567759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567803 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567808 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567833 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567840 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 567843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 567850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 567855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 567860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 567865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567884 */     GIR_RootConstrainSelectedInstOperands,
     /* 567885 */     // GIR_Coverage, 11803,
     /* 567885 */     GIR_EraseRootFromParent_Done,
     /* 567886 */   // Label 7245: @567886
     /* 567886 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(568021), // Rule ID 11804 //
     /* 567891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 567894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567938 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567943 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567943 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567948 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567975 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 567978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 567985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 567990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 567995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 568000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568019 */     GIR_RootConstrainSelectedInstOperands,
     /* 568020 */     // GIR_Coverage, 11804,
     /* 568020 */     GIR_EraseRootFromParent_Done,
     /* 568021 */   // Label 7246: @568021
     /* 568021 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(568156), // Rule ID 11805 //
     /* 568026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 568029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 568033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568073 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568073 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568078 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568078 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568087 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568110 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 568113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 568120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 568125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 568130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 568135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568154 */     GIR_RootConstrainSelectedInstOperands,
     /* 568155 */     // GIR_Coverage, 11805,
     /* 568155 */     GIR_EraseRootFromParent_Done,
     /* 568156 */   // Label 7247: @568156
     /* 568156 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(568291), // Rule ID 12282 //
     /* 568161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 568164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 568168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568208 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568208 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568213 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568218 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568245 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 568248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 568255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 568260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 568265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 568270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568289 */     GIR_RootConstrainSelectedInstOperands,
     /* 568290 */     // GIR_Coverage, 12282,
     /* 568290 */     GIR_EraseRootFromParent_Done,
     /* 568291 */   // Label 7248: @568291
     /* 568291 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(568426), // Rule ID 12283 //
     /* 568296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 568299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 568303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568343 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568348 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568353 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568380 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 568383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 568390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 568395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 568400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 568405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568424 */     GIR_RootConstrainSelectedInstOperands,
     /* 568425 */     // GIR_Coverage, 12283,
     /* 568425 */     GIR_EraseRootFromParent_Done,
     /* 568426 */   // Label 7249: @568426
     /* 568426 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(568561), // Rule ID 12284 //
     /* 568431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 568434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 568438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568478 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568483 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568488 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568508 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568515 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 568518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 568525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 568530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 568535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 568540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568559 */     GIR_RootConstrainSelectedInstOperands,
     /* 568560 */     // GIR_Coverage, 12284,
     /* 568560 */     GIR_EraseRootFromParent_Done,
     /* 568561 */   // Label 7250: @568561
     /* 568561 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(568696), // Rule ID 12285 //
     /* 568566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 568569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 568573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568613 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568618 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568618 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568623 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568650 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 568653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 568660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 568665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 568670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 568675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568694 */     GIR_RootConstrainSelectedInstOperands,
     /* 568695 */     // GIR_Coverage, 12285,
     /* 568695 */     GIR_EraseRootFromParent_Done,
     /* 568696 */   // Label 7251: @568696
     /* 568696 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(568831), // Rule ID 12762 //
     /* 568701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 568704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 568708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568748 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568748 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568753 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568753 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568758 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568762 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568764 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568778 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568785 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 568788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 568795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 568800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 568805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 568810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568829 */     GIR_RootConstrainSelectedInstOperands,
     /* 568830 */     // GIR_Coverage, 12762,
     /* 568830 */     GIR_EraseRootFromParent_Done,
     /* 568831 */   // Label 7252: @568831
     /* 568831 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(568966), // Rule ID 12763 //
     /* 568836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 568839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 568843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 568867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568883 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568888 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568888 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568893 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568897 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568899 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568913 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568920 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 568923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 568930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 568935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 568940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 568945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568964 */     GIR_RootConstrainSelectedInstOperands,
     /* 568965 */     // GIR_Coverage, 12763,
     /* 568965 */     GIR_EraseRootFromParent_Done,
     /* 568966 */   // Label 7253: @568966
     /* 568966 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(569101), // Rule ID 12764 //
     /* 568971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 568974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 568978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 569002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569018 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569018 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569023 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569041 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569055 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 569058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 569065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 569070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 569075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 569080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 569090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569099 */     GIR_RootConstrainSelectedInstOperands,
     /* 569100 */     // GIR_Coverage, 12764,
     /* 569100 */     GIR_EraseRootFromParent_Done,
     /* 569101 */   // Label 7254: @569101
     /* 569101 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(569236), // Rule ID 12765 //
     /* 569106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 569109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 569133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 569137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569153 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569158 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569163 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569167 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569190 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 569193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 569200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 569205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 569210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 569215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 569225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569234 */     GIR_RootConstrainSelectedInstOperands,
     /* 569235 */     // GIR_Coverage, 12765,
     /* 569235 */     GIR_EraseRootFromParent_Done,
     /* 569236 */   // Label 7255: @569236
     /* 569236 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(569371), // Rule ID 11873 //
     /* 569241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 569244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 569268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 569288 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569293 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569293 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569325 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 569328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 569335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 569340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 569345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 569350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 569355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 569360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569369 */     GIR_RootConstrainSelectedInstOperands,
     /* 569370 */     // GIR_Coverage, 11873,
     /* 569370 */     GIR_EraseRootFromParent_Done,
     /* 569371 */   // Label 7256: @569371
     /* 569371 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(569506), // Rule ID 11874 //
     /* 569376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 569379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 569403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569419 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 569423 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569423 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569428 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569428 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569433 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569437 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569453 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569460 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 569463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 569470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 569475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 569480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 569485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 569490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 569495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569504 */     GIR_RootConstrainSelectedInstOperands,
     /* 569505 */     // GIR_Coverage, 11874,
     /* 569505 */     GIR_EraseRootFromParent_Done,
     /* 569506 */   // Label 7257: @569506
     /* 569506 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(569641), // Rule ID 11875 //
     /* 569511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 569514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 569538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 569558 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569558 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569563 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569563 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569568 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569595 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 569598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 569605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 569610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 569615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 569620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 569625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 569630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569639 */     GIR_RootConstrainSelectedInstOperands,
     /* 569640 */     // GIR_Coverage, 11875,
     /* 569640 */     GIR_EraseRootFromParent_Done,
     /* 569641 */   // Label 7258: @569641
     /* 569641 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(569776), // Rule ID 11876 //
     /* 569646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 569649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 569673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569681 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569685 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569689 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 569693 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569693 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569698 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569703 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569707 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569723 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569730 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 569733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 569740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 569745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 569750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 569755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 569760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 569765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569774 */     GIR_RootConstrainSelectedInstOperands,
     /* 569775 */     // GIR_Coverage, 11876,
     /* 569775 */     GIR_EraseRootFromParent_Done,
     /* 569776 */   // Label 7259: @569776
     /* 569776 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(569911), // Rule ID 12353 //
     /* 569781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 569784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 569788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 569808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 569828 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569833 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569838 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569865 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 569868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 569875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 569880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 569885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 569890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 569895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 569900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569909 */     GIR_RootConstrainSelectedInstOperands,
     /* 569910 */     // GIR_Coverage, 12353,
     /* 569910 */     GIR_EraseRootFromParent_Done,
     /* 569911 */   // Label 7260: @569911
     /* 569911 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(570046), // Rule ID 12354 //
     /* 569916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 569919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 569923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 569943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 569963 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569968 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569993 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570000 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 570003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 570010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 570015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 570020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 570025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570044 */     GIR_RootConstrainSelectedInstOperands,
     /* 570045 */     // GIR_Coverage, 12354,
     /* 570045 */     GIR_EraseRootFromParent_Done,
     /* 570046 */   // Label 7261: @570046
     /* 570046 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(570181), // Rule ID 12355 //
     /* 570051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 570054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 570058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570098 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570103 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570103 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570128 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570135 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 570138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 570145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 570150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 570155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 570160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570179 */     GIR_RootConstrainSelectedInstOperands,
     /* 570180 */     // GIR_Coverage, 12355,
     /* 570180 */     GIR_EraseRootFromParent_Done,
     /* 570181 */   // Label 7262: @570181
     /* 570181 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(570316), // Rule ID 12356 //
     /* 570186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 570189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 570193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570233 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570233 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570238 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570238 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570243 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570270 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 570273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 570280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 570285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 570290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 570295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570314 */     GIR_RootConstrainSelectedInstOperands,
     /* 570315 */     // GIR_Coverage, 12356,
     /* 570315 */     GIR_EraseRootFromParent_Done,
     /* 570316 */   // Label 7263: @570316
     /* 570316 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(570451), // Rule ID 12833 //
     /* 570321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 570324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570368 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570368 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570373 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570373 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570378 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570384 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570398 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570405 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 570408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 570415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 570420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 570425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 570430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570449 */     GIR_RootConstrainSelectedInstOperands,
     /* 570450 */     // GIR_Coverage, 12833,
     /* 570450 */     GIR_EraseRootFromParent_Done,
     /* 570451 */   // Label 7264: @570451
     /* 570451 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(570586), // Rule ID 12834 //
     /* 570456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 570459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570503 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570503 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570508 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570540 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 570543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 570550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 570555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 570560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 570565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570584 */     GIR_RootConstrainSelectedInstOperands,
     /* 570585 */     // GIR_Coverage, 12834,
     /* 570585 */     GIR_EraseRootFromParent_Done,
     /* 570586 */   // Label 7265: @570586
     /* 570586 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(570721), // Rule ID 12835 //
     /* 570591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 570594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570638 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570643 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570643 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570648 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570654 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570675 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 570678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 570685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 570690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 570695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 570700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570719 */     GIR_RootConstrainSelectedInstOperands,
     /* 570720 */     // GIR_Coverage, 12835,
     /* 570720 */     GIR_EraseRootFromParent_Done,
     /* 570721 */   // Label 7266: @570721
     /* 570721 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(570856), // Rule ID 12836 //
     /* 570726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 570729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570773 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570778 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570778 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570783 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570803 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570810 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 570813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 570820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 570825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 570830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 570835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570854 */     GIR_RootConstrainSelectedInstOperands,
     /* 570855 */     // GIR_Coverage, 12836,
     /* 570855 */     GIR_EraseRootFromParent_Done,
     /* 570856 */   // Label 7267: @570856
     /* 570856 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(570991), // Rule ID 11813 //
     /* 570861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 570864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 570888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570908 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570908 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570913 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570913 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570918 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570922 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570938 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570945 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 570948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 570955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 570960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 570965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 570970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 570975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 570980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570989 */     GIR_RootConstrainSelectedInstOperands,
     /* 570990 */     // GIR_Coverage, 11813,
     /* 570990 */     GIR_EraseRootFromParent_Done,
     /* 570991 */   // Label 7268: @570991
     /* 570991 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(571126), // Rule ID 11814 //
     /* 570996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 570999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 571003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571043 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571043 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571048 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571048 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571053 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571057 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571059 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571066 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571073 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571080 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 571083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 571090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 571095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 571100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 571105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571124 */     GIR_RootConstrainSelectedInstOperands,
     /* 571125 */     // GIR_Coverage, 11814,
     /* 571125 */     GIR_EraseRootFromParent_Done,
     /* 571126 */   // Label 7269: @571126
     /* 571126 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(571261), // Rule ID 11815 //
     /* 571131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 571134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 571138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571178 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571183 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571201 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571215 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 571218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 571225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 571230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 571235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 571240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571259 */     GIR_RootConstrainSelectedInstOperands,
     /* 571260 */     // GIR_Coverage, 11815,
     /* 571260 */     GIR_EraseRootFromParent_Done,
     /* 571261 */   // Label 7270: @571261
     /* 571261 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(571396), // Rule ID 11816 //
     /* 571266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 571269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 571273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571313 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571318 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571323 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571343 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571350 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 571353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 571360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 571365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 571370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 571375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571394 */     GIR_RootConstrainSelectedInstOperands,
     /* 571395 */     // GIR_Coverage, 11816,
     /* 571395 */     GIR_EraseRootFromParent_Done,
     /* 571396 */   // Label 7271: @571396
     /* 571396 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(571531), // Rule ID 12293 //
     /* 571401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 571404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 571408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571448 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571453 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571458 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571485 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 571488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 571495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 571500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 571505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 571510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571529 */     GIR_RootConstrainSelectedInstOperands,
     /* 571530 */     // GIR_Coverage, 12293,
     /* 571530 */     GIR_EraseRootFromParent_Done,
     /* 571531 */   // Label 7272: @571531
     /* 571531 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(571666), // Rule ID 12294 //
     /* 571536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 571539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 571543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571575 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571579 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571583 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571588 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571588 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571613 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571620 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 571623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 571630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 571635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 571640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 571645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571664 */     GIR_RootConstrainSelectedInstOperands,
     /* 571665 */     // GIR_Coverage, 12294,
     /* 571665 */     GIR_EraseRootFromParent_Done,
     /* 571666 */   // Label 7273: @571666
     /* 571666 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(571801), // Rule ID 12295 //
     /* 571671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 571674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 571678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571718 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571718 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571723 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571728 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571732 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571734 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571741 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571748 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571755 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 571758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 571765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 571770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 571775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 571780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571799 */     GIR_RootConstrainSelectedInstOperands,
     /* 571800 */     // GIR_Coverage, 12295,
     /* 571800 */     GIR_EraseRootFromParent_Done,
     /* 571801 */   // Label 7274: @571801
     /* 571801 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(571936), // Rule ID 12296 //
     /* 571806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 571809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 571813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571853 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571853 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571858 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571863 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571867 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571890 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 571893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 571900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 571905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 571910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 571915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 571920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 571925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571934 */     GIR_RootConstrainSelectedInstOperands,
     /* 571935 */     // GIR_Coverage, 12296,
     /* 571935 */     GIR_EraseRootFromParent_Done,
     /* 571936 */   // Label 7275: @571936
     /* 571936 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(572071), // Rule ID 12773 //
     /* 571941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 571944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 571948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 571968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 571972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571988 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571988 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571993 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572002 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572011 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572025 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 572028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 572035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 572040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 572045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 572050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572069 */     GIR_RootConstrainSelectedInstOperands,
     /* 572070 */     // GIR_Coverage, 12773,
     /* 572070 */     GIR_EraseRootFromParent_Done,
     /* 572071 */   // Label 7276: @572071
     /* 572071 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(572206), // Rule ID 12774 //
     /* 572076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 572079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 572107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572111 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572123 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572123 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572128 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572128 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572133 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572137 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572139 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572153 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572160 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 572163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 572170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 572175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 572180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 572185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572204 */     GIR_RootConstrainSelectedInstOperands,
     /* 572205 */     // GIR_Coverage, 12774,
     /* 572205 */     GIR_EraseRootFromParent_Done,
     /* 572206 */   // Label 7277: @572206
     /* 572206 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(572341), // Rule ID 12775 //
     /* 572211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 572214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 572242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572258 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572263 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572268 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572288 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572295 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 572298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 572305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 572310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 572315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 572320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572339 */     GIR_RootConstrainSelectedInstOperands,
     /* 572340 */     // GIR_Coverage, 12775,
     /* 572340 */     GIR_EraseRootFromParent_Done,
     /* 572341 */   // Label 7278: @572341
     /* 572341 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(572476), // Rule ID 12776 //
     /* 572346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 572349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 572377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572393 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572393 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572398 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572398 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572403 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572423 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572430 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 572433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 572440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 572445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 572450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 572455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572474 */     GIR_RootConstrainSelectedInstOperands,
     /* 572475 */     // GIR_Coverage, 12776,
     /* 572475 */     GIR_EraseRootFromParent_Done,
     /* 572476 */   // Label 7279: @572476
     /* 572476 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(572611), // Rule ID 11858 //
     /* 572481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 572484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 572512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572516 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 572528 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572528 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572533 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572533 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572538 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572551 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572558 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572565 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 572568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 572575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 572580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 572585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 572590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572609 */     GIR_RootConstrainSelectedInstOperands,
     /* 572610 */     // GIR_Coverage, 11858,
     /* 572610 */     GIR_EraseRootFromParent_Done,
     /* 572611 */   // Label 7280: @572611
     /* 572611 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(572746), // Rule ID 11859 //
     /* 572616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 572619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 572647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 572663 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572663 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572668 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572673 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572686 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572700 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 572703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 572710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 572715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 572720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 572725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572744 */     GIR_RootConstrainSelectedInstOperands,
     /* 572745 */     // GIR_Coverage, 11859,
     /* 572745 */     GIR_EraseRootFromParent_Done,
     /* 572746 */   // Label 7281: @572746
     /* 572746 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(572881), // Rule ID 11860 //
     /* 572751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 572754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 572782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 572798 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572803 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572828 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572835 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 572838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 572845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 572850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 572855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 572860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 572865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 572870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572879 */     GIR_RootConstrainSelectedInstOperands,
     /* 572880 */     // GIR_Coverage, 11860,
     /* 572880 */     GIR_EraseRootFromParent_Done,
     /* 572881 */   // Label 7282: @572881
     /* 572881 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(573016), // Rule ID 11861 //
     /* 572886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 572889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 572913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 572917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 572933 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572933 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572938 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572963 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572970 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 572973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 572980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 572985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 572990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 572995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573014 */     GIR_RootConstrainSelectedInstOperands,
     /* 573015 */     // GIR_Coverage, 11861,
     /* 573015 */     GIR_EraseRootFromParent_Done,
     /* 573016 */   // Label 7283: @573016
     /* 573016 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(573151), // Rule ID 12338 //
     /* 573021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 573024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 573028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573068 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573068 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573073 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573073 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573078 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573098 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573105 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 573108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 573115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 573120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 573125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 573130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573149 */     GIR_RootConstrainSelectedInstOperands,
     /* 573150 */     // GIR_Coverage, 12338,
     /* 573150 */     GIR_EraseRootFromParent_Done,
     /* 573151 */   // Label 7284: @573151
     /* 573151 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(573286), // Rule ID 12339 //
     /* 573156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 573159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 573163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573203 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573203 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573208 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573208 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573240 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 573243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 573250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 573255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 573260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 573265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573284 */     GIR_RootConstrainSelectedInstOperands,
     /* 573285 */     // GIR_Coverage, 12339,
     /* 573285 */     GIR_EraseRootFromParent_Done,
     /* 573286 */   // Label 7285: @573286
     /* 573286 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(573421), // Rule ID 12340 //
     /* 573291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 573294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 573298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573338 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573338 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573343 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573361 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573368 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573375 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 573378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 573385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 573390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 573395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 573400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573419 */     GIR_RootConstrainSelectedInstOperands,
     /* 573420 */     // GIR_Coverage, 12340,
     /* 573420 */     GIR_EraseRootFromParent_Done,
     /* 573421 */   // Label 7286: @573421
     /* 573421 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(573556), // Rule ID 12341 //
     /* 573426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 573429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 573433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573473 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573478 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573483 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573510 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 573513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 573520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 573525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 573530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 573535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573554 */     GIR_RootConstrainSelectedInstOperands,
     /* 573555 */     // GIR_Coverage, 12341,
     /* 573555 */     GIR_EraseRootFromParent_Done,
     /* 573556 */   // Label 7287: @573556
     /* 573556 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(573691), // Rule ID 12818 //
     /* 573561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 573564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573608 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573613 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573618 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573638 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573645 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 573648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 573655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 573660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 573665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 573670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573689 */     GIR_RootConstrainSelectedInstOperands,
     /* 573690 */     // GIR_Coverage, 12818,
     /* 573690 */     GIR_EraseRootFromParent_Done,
     /* 573691 */   // Label 7288: @573691
     /* 573691 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(573826), // Rule ID 12819 //
     /* 573696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 573699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573743 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573748 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573748 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573766 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573780 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 573783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 573790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 573795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 573800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 573805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573824 */     GIR_RootConstrainSelectedInstOperands,
     /* 573825 */     // GIR_Coverage, 12819,
     /* 573825 */     GIR_EraseRootFromParent_Done,
     /* 573826 */   // Label 7289: @573826
     /* 573826 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(573961), // Rule ID 12820 //
     /* 573831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 573834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573866 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573878 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573878 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573883 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573908 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573915 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 573918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 573925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 573930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 573935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 573940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573959 */     GIR_RootConstrainSelectedInstOperands,
     /* 573960 */     // GIR_Coverage, 12820,
     /* 573960 */     GIR_EraseRootFromParent_Done,
     /* 573961 */   // Label 7290: @573961
     /* 573961 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(574096), // Rule ID 12821 //
     /* 573966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 573969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 574013 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574013 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574018 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574018 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574023 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574036 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574043 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574050 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 574053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 574060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 574065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 574070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 574075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574094 */     GIR_RootConstrainSelectedInstOperands,
     /* 574095 */     // GIR_Coverage, 12821,
     /* 574095 */     GIR_EraseRootFromParent_Done,
     /* 574096 */   // Label 7291: @574096
     /* 574096 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(574231), // Rule ID 11798 //
     /* 574101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 574104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 574108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574148 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574148 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574153 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574171 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574185 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 574188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 574195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 574200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 574205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 574210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574229 */     GIR_RootConstrainSelectedInstOperands,
     /* 574230 */     // GIR_Coverage, 11798,
     /* 574230 */     GIR_EraseRootFromParent_Done,
     /* 574231 */   // Label 7292: @574231
     /* 574231 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(574366), // Rule ID 11799 //
     /* 574236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 574239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 574243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574283 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574288 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574306 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574313 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574320 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 574323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 574330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 574335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 574340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 574345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574364 */     GIR_RootConstrainSelectedInstOperands,
     /* 574365 */     // GIR_Coverage, 11799,
     /* 574365 */     GIR_EraseRootFromParent_Done,
     /* 574366 */   // Label 7293: @574366
     /* 574366 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(574501), // Rule ID 11800 //
     /* 574371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 574374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 574378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574418 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574418 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574423 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574423 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574448 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574455 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 574458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 574465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 574470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 574475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 574480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574499 */     GIR_RootConstrainSelectedInstOperands,
     /* 574500 */     // GIR_Coverage, 11800,
     /* 574500 */     GIR_EraseRootFromParent_Done,
     /* 574501 */   // Label 7294: @574501
     /* 574501 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(574636), // Rule ID 11801 //
     /* 574506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 574509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 574513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574553 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574553 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574558 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574558 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574563 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574567 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574576 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574583 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574590 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 574593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 574600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 574605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 574610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 574615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574634 */     GIR_RootConstrainSelectedInstOperands,
     /* 574635 */     // GIR_Coverage, 11801,
     /* 574635 */     GIR_EraseRootFromParent_Done,
     /* 574636 */   // Label 7295: @574636
     /* 574636 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(574771), // Rule ID 12278 //
     /* 574641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 574644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 574648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574688 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574693 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574693 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574698 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574711 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574718 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574725 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 574728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 574735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 574740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 574745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 574750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574769 */     GIR_RootConstrainSelectedInstOperands,
     /* 574770 */     // GIR_Coverage, 12278,
     /* 574770 */     GIR_EraseRootFromParent_Done,
     /* 574771 */   // Label 7296: @574771
     /* 574771 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(574906), // Rule ID 12279 //
     /* 574776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 574779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 574783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574823 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574823 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574828 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574833 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574837 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574853 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574860 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 574863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 574870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 574875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 574880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 574885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574904 */     GIR_RootConstrainSelectedInstOperands,
     /* 574905 */     // GIR_Coverage, 12279,
     /* 574905 */     GIR_EraseRootFromParent_Done,
     /* 574906 */   // Label 7297: @574906
     /* 574906 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(575041), // Rule ID 12280 //
     /* 574911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 574914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 574918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 574942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574958 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574963 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574968 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574988 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574995 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 574998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 575015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 575020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575039 */     GIR_RootConstrainSelectedInstOperands,
     /* 575040 */     // GIR_Coverage, 12280,
     /* 575040 */     GIR_EraseRootFromParent_Done,
     /* 575041 */   // Label 7298: @575041
     /* 575041 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(575176), // Rule ID 12281 //
     /* 575046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 575049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 575053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 575077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575093 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575098 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575107 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575123 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575130 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 575133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 575150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 575155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575174 */     GIR_RootConstrainSelectedInstOperands,
     /* 575175 */     // GIR_Coverage, 12281,
     /* 575175 */     GIR_EraseRootFromParent_Done,
     /* 575176 */   // Label 7299: @575176
     /* 575176 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(575311), // Rule ID 12758 //
     /* 575181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 575184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 575212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575228 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575228 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575233 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575233 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575238 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575242 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575258 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575265 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 575268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 575275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 575280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 575285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 575290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575309 */     GIR_RootConstrainSelectedInstOperands,
     /* 575310 */     // GIR_Coverage, 12758,
     /* 575310 */     GIR_EraseRootFromParent_Done,
     /* 575311 */   // Label 7300: @575311
     /* 575311 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(575446), // Rule ID 12759 //
     /* 575316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 575319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 575347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575351 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575363 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575368 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575368 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575393 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575400 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 575403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 575410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 575415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 575420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 575425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575444 */     GIR_RootConstrainSelectedInstOperands,
     /* 575445 */     // GIR_Coverage, 12759,
     /* 575445 */     GIR_EraseRootFromParent_Done,
     /* 575446 */   // Label 7301: @575446
     /* 575446 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(575581), // Rule ID 12760 //
     /* 575451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 575454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 575482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575486 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575498 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575498 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575503 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575503 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575508 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575521 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575528 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575535 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 575538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 575555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 575560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575579 */     GIR_RootConstrainSelectedInstOperands,
     /* 575580 */     // GIR_Coverage, 12760,
     /* 575580 */     GIR_EraseRootFromParent_Done,
     /* 575581 */   // Label 7302: @575581
     /* 575581 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(575716), // Rule ID 12761 //
     /* 575586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 575589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 575617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575633 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575633 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575638 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575643 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575647 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575656 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575663 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575670 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 575673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 575690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 575695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575714 */     GIR_RootConstrainSelectedInstOperands,
     /* 575715 */     // GIR_Coverage, 12761,
     /* 575715 */     GIR_EraseRootFromParent_Done,
     /* 575716 */   // Label 7303: @575716
     /* 575716 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(575831), // Rule ID 13260 //
     /* 575721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 575724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 575728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 575732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 575736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 575748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575756 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 575758 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 575762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 575764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575778 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575785 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 575788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 575805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 575810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 575815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 575820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575829 */     GIR_RootConstrainSelectedInstOperands,
     /* 575830 */     // GIR_Coverage, 13260,
     /* 575830 */     GIR_EraseRootFromParent_Done,
     /* 575831 */   // Label 7304: @575831
     /* 575831 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(575946), // Rule ID 13276 //
     /* 575836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 575839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 575847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 575851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 575863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575871 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 575873 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 575877 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 575879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575900 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 575903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 575920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 575925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 575930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 575935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575944 */     GIR_RootConstrainSelectedInstOperands,
     /* 575945 */     // GIR_Coverage, 13276,
     /* 575945 */     GIR_EraseRootFromParent_Done,
     /* 575946 */   // Label 7305: @575946
     /* 575946 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(576061), // Rule ID 13259 //
     /* 575951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 575954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 575958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 575962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 575966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575986 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 575988 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 575992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 575994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576001 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576008 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576015 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 576018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 576035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 576040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 576045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 576050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576059 */     GIR_RootConstrainSelectedInstOperands,
     /* 576060 */     // GIR_Coverage, 13259,
     /* 576060 */     GIR_EraseRootFromParent_Done,
     /* 576061 */   // Label 7306: @576061
     /* 576061 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(576176), // Rule ID 13275 //
     /* 576066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 576069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 576077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 576081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576101 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 576103 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 576107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 576109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576123 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576130 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 576133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 576150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 576155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 576160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 576165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576174 */     GIR_RootConstrainSelectedInstOperands,
     /* 576175 */     // GIR_Coverage, 13275,
     /* 576175 */     GIR_EraseRootFromParent_Done,
     /* 576176 */   // Label 7307: @576176
     /* 576176 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(576291), // Rule ID 7734 //
     /* 576181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 576184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 576188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 576196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 576208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576216 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 576218 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 576222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 576224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576245 */     // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 576248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 576255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 576260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 576265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 576270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576289 */     GIR_RootConstrainSelectedInstOperands,
     /* 576290 */     // GIR_Coverage, 7734,
     /* 576290 */     GIR_EraseRootFromParent_Done,
     /* 576291 */   // Label 7308: @576291
     /* 576291 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(576406), // Rule ID 7750 //
     /* 576296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 576299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 576311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 576323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576331 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 576333 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 576337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 576339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576353 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576360 */     // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 576363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 576370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 576375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 576380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 576385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576404 */     GIR_RootConstrainSelectedInstOperands,
     /* 576405 */     // GIR_Coverage, 7750,
     /* 576405 */     GIR_EraseRootFromParent_Done,
     /* 576406 */   // Label 7309: @576406
     /* 576406 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(576521), // Rule ID 7733 //
     /* 576411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 576414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 576418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 576426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576446 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 576448 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 576452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 576454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576461 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576475 */     // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 576478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 576485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 576490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 576495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 576500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576519 */     GIR_RootConstrainSelectedInstOperands,
     /* 576520 */     // GIR_Coverage, 7733,
     /* 576520 */     GIR_EraseRootFromParent_Done,
     /* 576521 */   // Label 7310: @576521
     /* 576521 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(576636), // Rule ID 7749 //
     /* 576526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 576529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 576541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576561 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 576563 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 576567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 576569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576576 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576583 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576590 */     // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 576593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 576600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 576605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 576610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 576615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576634 */     GIR_RootConstrainSelectedInstOperands,
     /* 576635 */     // GIR_Coverage, 7749,
     /* 576635 */     GIR_EraseRootFromParent_Done,
     /* 576636 */   // Label 7311: @576636
     /* 576636 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(576735), // Rule ID 13252 //
     /* 576641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 576644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 576648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 576652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 576656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 576664 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 576666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 576668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576689 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 576692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 576709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 576714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 576719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 576724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576733 */     GIR_RootConstrainSelectedInstOperands,
     /* 576734 */     // GIR_Coverage, 13252,
     /* 576734 */     GIR_EraseRootFromParent_Done,
     /* 576735 */   // Label 7312: @576735
     /* 576735 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(576834), // Rule ID 13268 //
     /* 576740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 576743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 576751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 576755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 576763 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 576765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 576767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576788 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 576791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 576808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 576813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 576818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 576823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576832 */     GIR_RootConstrainSelectedInstOperands,
     /* 576833 */     // GIR_Coverage, 13268,
     /* 576833 */     GIR_EraseRootFromParent_Done,
     /* 576834 */   // Label 7313: @576834
     /* 576834 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(576933), // Rule ID 13251 //
     /* 576839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 576842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 576846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 576850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 576862 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 576864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 576866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576887 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 576890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 576907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 576912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 576917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 576922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576931 */     GIR_RootConstrainSelectedInstOperands,
     /* 576932 */     // GIR_Coverage, 13251,
     /* 576932 */     GIR_EraseRootFromParent_Done,
     /* 576933 */   // Label 7314: @576933
     /* 576933 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(577032), // Rule ID 13267 //
     /* 576938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 576941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 576949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 576961 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 576963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 576965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576986 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 576989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 577001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 577006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 577011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 577016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 577021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577030 */     GIR_RootConstrainSelectedInstOperands,
     /* 577031 */     // GIR_Coverage, 13267,
     /* 577031 */     GIR_EraseRootFromParent_Done,
     /* 577032 */   // Label 7315: @577032
     /* 577032 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(577131), // Rule ID 7726 //
     /* 577037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 577040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 577044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577060 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 577062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 577064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577085 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 577088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 577095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 577105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577129 */     GIR_RootConstrainSelectedInstOperands,
     /* 577130 */     // GIR_Coverage, 7726,
     /* 577130 */     GIR_EraseRootFromParent_Done,
     /* 577131 */   // Label 7316: @577131
     /* 577131 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(577230), // Rule ID 7742 //
     /* 577136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 577139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577159 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 577161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 577163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577184 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 577187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 577194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 577204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577228 */     GIR_RootConstrainSelectedInstOperands,
     /* 577229 */     // GIR_Coverage, 7742,
     /* 577229 */     GIR_EraseRootFromParent_Done,
     /* 577230 */   // Label 7317: @577230
     /* 577230 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(577329), // Rule ID 7725 //
     /* 577235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 577238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 577242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577258 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 577260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 577262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577283 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 577286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 577293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 577303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577327 */     GIR_RootConstrainSelectedInstOperands,
     /* 577328 */     // GIR_Coverage, 7725,
     /* 577328 */     GIR_EraseRootFromParent_Done,
     /* 577329 */   // Label 7318: @577329
     /* 577329 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(577428), // Rule ID 7741 //
     /* 577334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 577337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577357 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 577359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 577361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577382 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 577385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 577392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 577402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577426 */     GIR_RootConstrainSelectedInstOperands,
     /* 577427 */     // GIR_Coverage, 7741,
     /* 577427 */     GIR_EraseRootFromParent_Done,
     /* 577428 */   // Label 7319: @577428
     /* 577428 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(577463), // Rule ID 102 //
     /* 577433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 577436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 577440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 577444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 577448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13799),
     /* 577452 */     // (fmaxnum_ieee:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13799>>  =>  (S_MAX_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 577452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F16),
     /* 577457 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 577461 */     GIR_RootConstrainSelectedInstOperands,
     /* 577462 */     // GIR_Coverage, 102,
     /* 577462 */     GIR_Done,
     /* 577463 */   // Label 7320: @577463
     /* 577463 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(577526), // Rule ID 879 //
     /* 577468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 577471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 577482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577489 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 577489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 577492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 577499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 577509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 577519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 577524 */     GIR_RootConstrainSelectedInstOperands,
     /* 577525 */     // GIR_Coverage, 879,
     /* 577525 */     GIR_EraseRootFromParent_Done,
     /* 577526 */   // Label 7321: @577526
     /* 577526 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(577589), // Rule ID 883 //
     /* 577531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 577534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 577545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577552 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 577552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 577555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 577562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 577572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 577582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 577587 */     GIR_RootConstrainSelectedInstOperands,
     /* 577588 */     // GIR_Coverage, 883,
     /* 577588 */     GIR_EraseRootFromParent_Done,
     /* 577589 */   // Label 7322: @577589
     /* 577589 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(577652), // Rule ID 8428 //
     /* 577594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 577597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 577615 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 577615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 577618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 577625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 577630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 577635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 577640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 577645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 577650 */     GIR_RootConstrainSelectedInstOperands,
     /* 577651 */     // GIR_Coverage, 8428,
     /* 577651 */     GIR_EraseRootFromParent_Done,
     /* 577652 */   // Label 7323: @577652
     /* 577652 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(577715), // Rule ID 8430 //
     /* 577657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 577660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 577678 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 577678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 577681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 577688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 577693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 577698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 577703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 577708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 577713 */     GIR_RootConstrainSelectedInstOperands,
     /* 577714 */     // GIR_Coverage, 8430,
     /* 577714 */     GIR_EraseRootFromParent_Done,
     /* 577715 */   // Label 7324: @577715
     /* 577715 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(577777), // Rule ID 881 //
     /* 577720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 577723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 577727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 577734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 577741 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 577741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 577744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 577751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 577761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577775 */     GIR_RootConstrainSelectedInstOperands,
     /* 577776 */     // GIR_Coverage, 881,
     /* 577776 */     GIR_EraseRootFromParent_Done,
     /* 577777 */   // Label 7325: @577777
     /* 577777 */   GIM_Reject,
     /* 577778 */ // Label 6919: @577778
     /* 577778 */ GIM_Reject,
     /* 577779 */ // Label 6915: @577779
     /* 577779 */ GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(595290),
     /* 577784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 577787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 577790 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(577919), // Rule ID 11387 //
     /* 577795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 577811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 577815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 577819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 577827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 577831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 577835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 577839 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 577839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 577844 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 577844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 577849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 577853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 577855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577876 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 577879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 577886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 577896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577917 */     GIR_RootConstrainSelectedInstOperands,
     /* 577918 */     // GIR_Coverage, 11387,
     /* 577918 */     GIR_EraseRootFromParent_Done,
     /* 577919 */   // Label 7327: @577919
     /* 577919 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(578048), // Rule ID 11388 //
     /* 577924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 577940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 577944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 577948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 577956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 577960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 577964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 577968 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 577968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 577973 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 577973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 577978 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 577982 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 577984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577991 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578005 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 578015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 578020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 578025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 578030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578046 */     GIR_RootConstrainSelectedInstOperands,
     /* 578047 */     // GIR_Coverage, 11388,
     /* 578047 */     GIR_EraseRootFromParent_Done,
     /* 578048 */   // Label 7328: @578048
     /* 578048 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(578177), // Rule ID 11391 //
     /* 578053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 578093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 578097 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578097 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578102 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578102 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578107 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578127 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578134 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 578144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 578149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 578154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 578159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578175 */     GIR_RootConstrainSelectedInstOperands,
     /* 578176 */     // GIR_Coverage, 11391,
     /* 578176 */     GIR_EraseRootFromParent_Done,
     /* 578177 */   // Label 7329: @578177
     /* 578177 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(578306), // Rule ID 11392 //
     /* 578182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 578222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 578226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578231 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578236 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578263 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 578273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 578278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 578283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 578288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578304 */     GIR_RootConstrainSelectedInstOperands,
     /* 578305 */     // GIR_Coverage, 11392,
     /* 578305 */     GIR_EraseRootFromParent_Done,
     /* 578306 */   // Label 7330: @578306
     /* 578306 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(578435), // Rule ID 11372 //
     /* 578311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 578351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578355 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578360 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578360 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578369 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578392 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 578402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 578407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 578412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 578417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578433 */     GIR_RootConstrainSelectedInstOperands,
     /* 578434 */     // GIR_Coverage, 11372,
     /* 578434 */     GIR_EraseRootFromParent_Done,
     /* 578435 */   // Label 7331: @578435
     /* 578435 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(578564), // Rule ID 11373 //
     /* 578440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 578480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578484 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578489 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578521 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 578531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 578536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 578541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 578546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578562 */     GIR_RootConstrainSelectedInstOperands,
     /* 578563 */     // GIR_Coverage, 11373,
     /* 578563 */     GIR_EraseRootFromParent_Done,
     /* 578564 */   // Label 7332: @578564
     /* 578564 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(578693), // Rule ID 11376 //
     /* 578569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 578609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578613 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578618 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578618 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578623 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578650 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 578660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 578665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 578670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 578675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578691 */     GIR_RootConstrainSelectedInstOperands,
     /* 578692 */     // GIR_Coverage, 11376,
     /* 578692 */     GIR_EraseRootFromParent_Done,
     /* 578693 */   // Label 7333: @578693
     /* 578693 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(578822), // Rule ID 11377 //
     /* 578698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 578738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578742 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578747 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578752 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578779 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 578789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 578794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 578799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 578804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578820 */     GIR_RootConstrainSelectedInstOperands,
     /* 578821 */     // GIR_Coverage, 11377,
     /* 578821 */     GIR_EraseRootFromParent_Done,
     /* 578822 */   // Label 7334: @578822
     /* 578822 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(578951), // Rule ID 7582 //
     /* 578827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 578867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 578871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 578876 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 578881 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578908 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 578911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 578918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 578923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 578928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 578933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578949 */     GIR_RootConstrainSelectedInstOperands,
     /* 578950 */     // GIR_Coverage, 7582,
     /* 578950 */     GIR_EraseRootFromParent_Done,
     /* 578951 */   // Label 7335: @578951
     /* 578951 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(579080), // Rule ID 11386 //
     /* 578956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 578972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 578976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 578980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 578988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 578992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 578996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 579000 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579005 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579005 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579030 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579037 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 579047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 579052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 579057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 579062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579078 */     GIR_RootConstrainSelectedInstOperands,
     /* 579079 */     // GIR_Coverage, 11386,
     /* 579079 */     GIR_EraseRootFromParent_Done,
     /* 579080 */   // Label 7336: @579080
     /* 579080 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(579209), // Rule ID 11389 //
     /* 579085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 579125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 579129 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579134 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579159 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579166 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 579176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 579181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 579186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 579191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579207 */     GIR_RootConstrainSelectedInstOperands,
     /* 579208 */     // GIR_Coverage, 11389,
     /* 579208 */     GIR_EraseRootFromParent_Done,
     /* 579209 */   // Label 7337: @579209
     /* 579209 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(579338), // Rule ID 11390 //
     /* 579214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 579254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 579258 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579263 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579268 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579288 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579295 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 579305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 579310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 579315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 579320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579336 */     GIR_RootConstrainSelectedInstOperands,
     /* 579337 */     // GIR_Coverage, 11390,
     /* 579337 */     GIR_EraseRootFromParent_Done,
     /* 579338 */   // Label 7338: @579338
     /* 579338 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(579467), // Rule ID 7581 //
     /* 579343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579375 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 579383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579387 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579392 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579392 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579424 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 579434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 579439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 579444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 579449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579465 */     GIR_RootConstrainSelectedInstOperands,
     /* 579466 */     // GIR_Coverage, 7581,
     /* 579466 */     GIR_EraseRootFromParent_Done,
     /* 579467 */   // Label 7339: @579467
     /* 579467 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(579596), // Rule ID 11371 //
     /* 579472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 579512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579516 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579521 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579553 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 579563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 579568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 579573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 579578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579594 */     GIR_RootConstrainSelectedInstOperands,
     /* 579595 */     // GIR_Coverage, 11371,
     /* 579595 */     GIR_EraseRootFromParent_Done,
     /* 579596 */   // Label 7340: @579596
     /* 579596 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(579725), // Rule ID 11374 //
     /* 579601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 579641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579645 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579650 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579655 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579675 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579682 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 579692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 579697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 579702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 579707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579723 */     GIR_RootConstrainSelectedInstOperands,
     /* 579724 */     // GIR_Coverage, 11374,
     /* 579724 */     GIR_EraseRootFromParent_Done,
     /* 579725 */   // Label 7341: @579725
     /* 579725 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(579854), // Rule ID 11375 //
     /* 579730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 579770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579774 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579779 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579811 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 579821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 579826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 579831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 579836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579852 */     GIR_RootConstrainSelectedInstOperands,
     /* 579853 */     // GIR_Coverage, 11375,
     /* 579853 */     GIR_EraseRootFromParent_Done,
     /* 579854 */   // Label 7342: @579854
     /* 579854 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(579983), // Rule ID 11357 //
     /* 579859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 579871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 579875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 579879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 579883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 579891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 579895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 579899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 579903 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 579908 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579908 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 579913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579933 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579940 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 579943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 579950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 579955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 579960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 579965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579981 */     GIR_RootConstrainSelectedInstOperands,
     /* 579982 */     // GIR_Coverage, 11357,
     /* 579982 */     GIR_EraseRootFromParent_Done,
     /* 579983 */   // Label 7343: @579983
     /* 579983 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(580112), // Rule ID 11358 //
     /* 579988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 580032 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580037 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580037 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580062 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580069 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 580079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 580084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 580089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 580094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580110 */     GIR_RootConstrainSelectedInstOperands,
     /* 580111 */     // GIR_Coverage, 11358,
     /* 580111 */     GIR_EraseRootFromParent_Done,
     /* 580112 */   // Label 7344: @580112
     /* 580112 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(580241), // Rule ID 11361 //
     /* 580117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 580161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580166 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580171 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580191 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580198 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 580208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 580213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 580218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 580223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580239 */     GIR_RootConstrainSelectedInstOperands,
     /* 580240 */     // GIR_Coverage, 11361,
     /* 580240 */     GIR_EraseRootFromParent_Done,
     /* 580241 */   // Label 7345: @580241
     /* 580241 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(580370), // Rule ID 11362 //
     /* 580246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 580290 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580295 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580295 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580300 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580327 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 580337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 580342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 580347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 580352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580368 */     GIR_RootConstrainSelectedInstOperands,
     /* 580369 */     // GIR_Coverage, 11362,
     /* 580369 */     GIR_EraseRootFromParent_Done,
     /* 580370 */   // Label 7346: @580370
     /* 580370 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(580499), // Rule ID 11342 //
     /* 580375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 580419 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580424 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580429 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580449 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580456 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 580466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 580471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 580476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 580481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580497 */     GIR_RootConstrainSelectedInstOperands,
     /* 580498 */     // GIR_Coverage, 11342,
     /* 580498 */     GIR_EraseRootFromParent_Done,
     /* 580499 */   // Label 7347: @580499
     /* 580499 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(580628), // Rule ID 11343 //
     /* 580504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 580548 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580553 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580553 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580585 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 580595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 580600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 580605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 580610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580626 */     GIR_RootConstrainSelectedInstOperands,
     /* 580627 */     // GIR_Coverage, 11343,
     /* 580627 */     GIR_EraseRootFromParent_Done,
     /* 580628 */   // Label 7348: @580628
     /* 580628 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(580757), // Rule ID 11346 //
     /* 580633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 580677 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580682 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580687 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580707 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580714 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 580724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 580729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 580734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 580739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580755 */     GIR_RootConstrainSelectedInstOperands,
     /* 580756 */     // GIR_Coverage, 11346,
     /* 580756 */     GIR_EraseRootFromParent_Done,
     /* 580757 */   // Label 7349: @580757
     /* 580757 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(580886), // Rule ID 11347 //
     /* 580762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 580802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 580806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580811 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580843 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 580853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 580858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 580863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 580868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580884 */     GIR_RootConstrainSelectedInstOperands,
     /* 580885 */     // GIR_Coverage, 11347,
     /* 580885 */     GIR_EraseRootFromParent_Done,
     /* 580886 */   // Label 7350: @580886
     /* 580886 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(581015), // Rule ID 7580 //
     /* 580891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 580907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 580911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 580915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 580923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 580927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 580931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 580935 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 580940 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 580945 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580972 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 580975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 580982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 580987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 580992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 580997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581013 */     GIR_RootConstrainSelectedInstOperands,
     /* 581014 */     // GIR_Coverage, 7580,
     /* 581014 */     GIR_EraseRootFromParent_Done,
     /* 581015 */   // Label 7351: @581015
     /* 581015 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(581144), // Rule ID 11356 //
     /* 581020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 581064 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581069 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581101 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 581111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 581121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581142 */     GIR_RootConstrainSelectedInstOperands,
     /* 581143 */     // GIR_Coverage, 11356,
     /* 581143 */     GIR_EraseRootFromParent_Done,
     /* 581144 */   // Label 7352: @581144
     /* 581144 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(581273), // Rule ID 11359 //
     /* 581149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 581193 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581198 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581198 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581230 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 581240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 581245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 581250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 581255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581271 */     GIR_RootConstrainSelectedInstOperands,
     /* 581272 */     // GIR_Coverage, 11359,
     /* 581272 */     GIR_EraseRootFromParent_Done,
     /* 581273 */   // Label 7353: @581273
     /* 581273 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(581402), // Rule ID 11360 //
     /* 581278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 581322 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581327 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581327 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581359 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 581369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 581374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 581379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 581384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581400 */     GIR_RootConstrainSelectedInstOperands,
     /* 581401 */     // GIR_Coverage, 11360,
     /* 581401 */     GIR_EraseRootFromParent_Done,
     /* 581402 */   // Label 7354: @581402
     /* 581402 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(581531), // Rule ID 7579 //
     /* 581407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 581451 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581456 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581488 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 581498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 581508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581529 */     GIR_RootConstrainSelectedInstOperands,
     /* 581530 */     // GIR_Coverage, 7579,
     /* 581530 */     GIR_EraseRootFromParent_Done,
     /* 581531 */   // Label 7355: @581531
     /* 581531 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(581660), // Rule ID 11341 //
     /* 581536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 581580 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581585 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581590 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581617 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 581627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 581637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581658 */     GIR_RootConstrainSelectedInstOperands,
     /* 581659 */     // GIR_Coverage, 11341,
     /* 581659 */     GIR_EraseRootFromParent_Done,
     /* 581660 */   // Label 7356: @581660
     /* 581660 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(581789), // Rule ID 11344 //
     /* 581665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 581709 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581714 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581732 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581746 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 581756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 581761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 581766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 581771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581787 */     GIR_RootConstrainSelectedInstOperands,
     /* 581788 */     // GIR_Coverage, 11344,
     /* 581788 */     GIR_EraseRootFromParent_Done,
     /* 581789 */   // Label 7357: @581789
     /* 581789 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(581918), // Rule ID 11345 //
     /* 581794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 581818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 581834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 581838 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 581843 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 581848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581875 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 581878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 581885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 581890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 581895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 581900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581916 */     GIR_RootConstrainSelectedInstOperands,
     /* 581917 */     // GIR_Coverage, 11345,
     /* 581917 */     GIR_EraseRootFromParent_Done,
     /* 581918 */   // Label 7358: @581918
     /* 581918 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(582047), // Rule ID 11397 //
     /* 581923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 581939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 581943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 581947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 581951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 581955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 581959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 581963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581967 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 581967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 581972 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 581972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 581977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 581981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 581983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581997 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582004 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 582014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 582024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 582029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582045 */     GIR_RootConstrainSelectedInstOperands,
     /* 582046 */     // GIR_Coverage, 11397,
     /* 582046 */     GIR_EraseRootFromParent_Done,
     /* 582047 */   // Label 7359: @582047
     /* 582047 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(582176), // Rule ID 11398 //
     /* 582052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 582101 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 582106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582133 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 582143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 582153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 582158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582174 */     GIR_RootConstrainSelectedInstOperands,
     /* 582175 */     // GIR_Coverage, 11398,
     /* 582175 */     GIR_EraseRootFromParent_Done,
     /* 582176 */   // Label 7360: @582176
     /* 582176 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(582305), // Rule ID 11399 //
     /* 582181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582225 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 582230 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582230 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 582235 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582262 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 582272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 582277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 582282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 582287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582303 */     GIR_RootConstrainSelectedInstOperands,
     /* 582304 */     // GIR_Coverage, 11399,
     /* 582304 */     GIR_EraseRootFromParent_Done,
     /* 582305 */   // Label 7361: @582305
     /* 582305 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(582434), // Rule ID 11400 //
     /* 582310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582354 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 582359 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 582364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582391 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 582401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 582406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 582411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 582416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582432 */     GIR_RootConstrainSelectedInstOperands,
     /* 582433 */     // GIR_Coverage, 11400,
     /* 582433 */     GIR_EraseRootFromParent_Done,
     /* 582434 */   // Label 7362: @582434
     /* 582434 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(582563), // Rule ID 11337 //
     /* 582439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 582483 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 582488 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 582493 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582520 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 582530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 582540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 582545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582561 */     GIR_RootConstrainSelectedInstOperands,
     /* 582562 */     // GIR_Coverage, 11337,
     /* 582562 */     GIR_EraseRootFromParent_Done,
     /* 582563 */   // Label 7363: @582563
     /* 582563 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(582692), // Rule ID 11338 //
     /* 582568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 582612 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 582617 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 582622 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582649 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 582659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 582669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 582674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582690 */     GIR_RootConstrainSelectedInstOperands,
     /* 582691 */     // GIR_Coverage, 11338,
     /* 582691 */     GIR_EraseRootFromParent_Done,
     /* 582692 */   // Label 7364: @582692
     /* 582692 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(582821), // Rule ID 11339 //
     /* 582697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 582741 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 582746 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 582751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582778 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 582788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 582793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 582798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 582803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582819 */     GIR_RootConstrainSelectedInstOperands,
     /* 582820 */     // GIR_Coverage, 11339,
     /* 582820 */     GIR_EraseRootFromParent_Done,
     /* 582821 */   // Label 7365: @582821
     /* 582821 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(582950), // Rule ID 11340 //
     /* 582826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 582870 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 582875 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582875 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 582880 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582907 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 582917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 582922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 582927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 582932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 582937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 582942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582948 */     GIR_RootConstrainSelectedInstOperands,
     /* 582949 */     // GIR_Coverage, 11340,
     /* 582949 */     GIR_EraseRootFromParent_Done,
     /* 582950 */   // Label 7366: @582950
     /* 582950 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(583079), // Rule ID 11382 //
     /* 582955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 582979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 582983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 582995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582999 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583004 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583036 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 583046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 583051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 583056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 583061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583077 */     GIR_RootConstrainSelectedInstOperands,
     /* 583078 */     // GIR_Coverage, 11382,
     /* 583078 */     GIR_EraseRootFromParent_Done,
     /* 583079 */   // Label 7367: @583079
     /* 583079 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(583208), // Rule ID 11383 //
     /* 583084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583128 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583128 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583133 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583165 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 583175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 583180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 583185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 583190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583206 */     GIR_RootConstrainSelectedInstOperands,
     /* 583207 */     // GIR_Coverage, 11383,
     /* 583207 */     GIR_EraseRootFromParent_Done,
     /* 583208 */   // Label 7368: @583208
     /* 583208 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(583337), // Rule ID 11384 //
     /* 583213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583257 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583262 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583267 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583271 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583294 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 583304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 583309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 583314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 583319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583335 */     GIR_RootConstrainSelectedInstOperands,
     /* 583336 */     // GIR_Coverage, 11384,
     /* 583336 */     GIR_EraseRootFromParent_Done,
     /* 583337 */   // Label 7369: @583337
     /* 583337 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(583466), // Rule ID 11385 //
     /* 583342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583386 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583391 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583423 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 583433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 583438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 583443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 583448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583464 */     GIR_RootConstrainSelectedInstOperands,
     /* 583465 */     // GIR_Coverage, 11385,
     /* 583465 */     GIR_EraseRootFromParent_Done,
     /* 583466 */   // Label 7370: @583466
     /* 583466 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(583595), // Rule ID 11322 //
     /* 583471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 583515 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583520 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583520 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583525 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583552 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 583562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 583567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 583572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 583577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583593 */     GIR_RootConstrainSelectedInstOperands,
     /* 583594 */     // GIR_Coverage, 11322,
     /* 583594 */     GIR_EraseRootFromParent_Done,
     /* 583595 */   // Label 7371: @583595
     /* 583595 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(583724), // Rule ID 11323 //
     /* 583600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 583644 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583649 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583654 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583681 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 583691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 583696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 583701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 583706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583722 */     GIR_RootConstrainSelectedInstOperands,
     /* 583723 */     // GIR_Coverage, 11323,
     /* 583723 */     GIR_EraseRootFromParent_Done,
     /* 583724 */   // Label 7372: @583724
     /* 583724 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(583853), // Rule ID 11324 //
     /* 583729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 583773 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583778 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583778 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583783 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583803 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583810 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 583820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 583825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 583830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 583835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583851 */     GIR_RootConstrainSelectedInstOperands,
     /* 583852 */     // GIR_Coverage, 11324,
     /* 583852 */     GIR_EraseRootFromParent_Done,
     /* 583853 */   // Label 7373: @583853
     /* 583853 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(583982), // Rule ID 11325 //
     /* 583858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 583882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 583898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 583902 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583902 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 583907 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583907 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 583912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583939 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 583949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 583954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 583959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 583964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 583969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 583974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583980 */     GIR_RootConstrainSelectedInstOperands,
     /* 583981 */     // GIR_Coverage, 11325,
     /* 583981 */     GIR_EraseRootFromParent_Done,
     /* 583982 */   // Label 7374: @583982
     /* 583982 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(584111), // Rule ID 11393 //
     /* 583987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584031 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584036 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584061 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584068 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 584078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 584083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 584088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 584093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584109 */     GIR_RootConstrainSelectedInstOperands,
     /* 584110 */     // GIR_Coverage, 11393,
     /* 584110 */     GIR_EraseRootFromParent_Done,
     /* 584111 */   // Label 7375: @584111
     /* 584111 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(584240), // Rule ID 11394 //
     /* 584116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584160 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584160 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584165 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584165 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584170 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584190 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584197 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 584207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 584212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 584217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 584222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584238 */     GIR_RootConstrainSelectedInstOperands,
     /* 584239 */     // GIR_Coverage, 11394,
     /* 584239 */     GIR_EraseRootFromParent_Done,
     /* 584240 */   // Label 7376: @584240
     /* 584240 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(584369), // Rule ID 11395 //
     /* 584245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584289 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584294 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584299 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584326 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 584336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 584341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 584346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 584351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584367 */     GIR_RootConstrainSelectedInstOperands,
     /* 584368 */     // GIR_Coverage, 11395,
     /* 584368 */     GIR_EraseRootFromParent_Done,
     /* 584369 */   // Label 7377: @584369
     /* 584369 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(584498), // Rule ID 11396 //
     /* 584374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584418 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584418 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584423 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584423 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584448 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584455 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 584465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 584470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 584475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 584480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584496 */     GIR_RootConstrainSelectedInstOperands,
     /* 584497 */     // GIR_Coverage, 11396,
     /* 584497 */     GIR_EraseRootFromParent_Done,
     /* 584498 */   // Label 7378: @584498
     /* 584498 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(584627), // Rule ID 11333 //
     /* 584503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584547 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584552 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584552 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584557 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584577 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584584 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 584594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 584599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 584604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 584609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584625 */     GIR_RootConstrainSelectedInstOperands,
     /* 584626 */     // GIR_Coverage, 11333,
     /* 584626 */     GIR_EraseRootFromParent_Done,
     /* 584627 */   // Label 7379: @584627
     /* 584627 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(584756), // Rule ID 11334 //
     /* 584632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584676 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584681 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584686 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584706 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584713 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 584723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 584728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 584733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 584738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584754 */     GIR_RootConstrainSelectedInstOperands,
     /* 584755 */     // GIR_Coverage, 11334,
     /* 584755 */     GIR_EraseRootFromParent_Done,
     /* 584756 */   // Label 7380: @584756
     /* 584756 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(584885), // Rule ID 11335 //
     /* 584761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584805 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584810 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584810 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584815 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584828 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584835 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584842 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 584852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 584857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 584862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 584867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584883 */     GIR_RootConstrainSelectedInstOperands,
     /* 584884 */     // GIR_Coverage, 11335,
     /* 584884 */     GIR_EraseRootFromParent_Done,
     /* 584885 */   // Label 7381: @584885
     /* 584885 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(585014), // Rule ID 11336 //
     /* 584890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 584914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 584930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584934 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 584939 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 584944 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584964 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584971 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 584981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 584986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 584991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 584996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585012 */     GIR_RootConstrainSelectedInstOperands,
     /* 585013 */     // GIR_Coverage, 11336,
     /* 585013 */     GIR_EraseRootFromParent_Done,
     /* 585014 */   // Label 7382: @585014
     /* 585014 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(585143), // Rule ID 11378 //
     /* 585019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585063 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585068 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585068 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585073 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585093 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585100 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 585110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 585115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 585120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 585125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585141 */     GIR_RootConstrainSelectedInstOperands,
     /* 585142 */     // GIR_Coverage, 11378,
     /* 585142 */     GIR_EraseRootFromParent_Done,
     /* 585143 */   // Label 7383: @585143
     /* 585143 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(585272), // Rule ID 11379 //
     /* 585148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585192 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585197 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585197 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585202 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585215 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585229 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 585239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 585244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 585249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 585254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585270 */     GIR_RootConstrainSelectedInstOperands,
     /* 585271 */     // GIR_Coverage, 11379,
     /* 585271 */     GIR_EraseRootFromParent_Done,
     /* 585272 */   // Label 7384: @585272
     /* 585272 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(585401), // Rule ID 11380 //
     /* 585277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585321 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585326 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585331 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585335 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585351 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585358 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 585368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 585373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 585378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 585383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585399 */     GIR_RootConstrainSelectedInstOperands,
     /* 585400 */     // GIR_Coverage, 11380,
     /* 585400 */     GIR_EraseRootFromParent_Done,
     /* 585401 */   // Label 7385: @585401
     /* 585401 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(585530), // Rule ID 11381 //
     /* 585406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585450 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585455 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585460 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585487 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 585497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 585502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 585507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 585512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585528 */     GIR_RootConstrainSelectedInstOperands,
     /* 585529 */     // GIR_Coverage, 11381,
     /* 585529 */     GIR_EraseRootFromParent_Done,
     /* 585530 */   // Label 7386: @585530
     /* 585530 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(585659), // Rule ID 11318 //
     /* 585535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585579 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585584 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585616 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 585626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 585631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 585636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 585641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585657 */     GIR_RootConstrainSelectedInstOperands,
     /* 585658 */     // GIR_Coverage, 11318,
     /* 585658 */     GIR_EraseRootFromParent_Done,
     /* 585659 */   // Label 7387: @585659
     /* 585659 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(585788), // Rule ID 11319 //
     /* 585664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585708 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585713 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585713 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585718 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585738 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585745 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 585755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 585760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 585765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 585770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585786 */     GIR_RootConstrainSelectedInstOperands,
     /* 585787 */     // GIR_Coverage, 11319,
     /* 585787 */     GIR_EraseRootFromParent_Done,
     /* 585788 */   // Label 7388: @585788
     /* 585788 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(585917), // Rule ID 11320 //
     /* 585793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585837 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585842 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585842 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585847 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585874 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 585884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 585889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 585894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 585899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585915 */     GIR_RootConstrainSelectedInstOperands,
     /* 585916 */     // GIR_Coverage, 11320,
     /* 585916 */     GIR_EraseRootFromParent_Done,
     /* 585917 */   // Label 7389: @585917
     /* 585917 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(586046), // Rule ID 11321 //
     /* 585922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 585946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 585962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585966 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 585971 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 585976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585996 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586003 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 586013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 586018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 586023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 586028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586044 */     GIR_RootConstrainSelectedInstOperands,
     /* 586045 */     // GIR_Coverage, 11321,
     /* 586045 */     GIR_EraseRootFromParent_Done,
     /* 586046 */   // Label 7390: @586046
     /* 586046 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(586175), // Rule ID 11327 //
     /* 586051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 586091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 586095 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586100 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586100 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586105 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586132 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 586142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 586147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 586152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 586157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586173 */     GIR_RootConstrainSelectedInstOperands,
     /* 586174 */     // GIR_Coverage, 11327,
     /* 586174 */     GIR_EraseRootFromParent_Done,
     /* 586175 */   // Label 7391: @586175
     /* 586175 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(586304), // Rule ID 11328 //
     /* 586180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 586220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 586224 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586229 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586234 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586261 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 586271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 586276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 586281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 586286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586302 */     GIR_RootConstrainSelectedInstOperands,
     /* 586303 */     // GIR_Coverage, 11328,
     /* 586303 */     GIR_EraseRootFromParent_Done,
     /* 586304 */   // Label 7392: @586304
     /* 586304 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(586433), // Rule ID 11331 //
     /* 586309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 586349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 586353 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586358 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586358 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586363 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586383 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586390 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 586400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 586405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 586410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 586415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586431 */     GIR_RootConstrainSelectedInstOperands,
     /* 586432 */     // GIR_Coverage, 11331,
     /* 586432 */     GIR_EraseRootFromParent_Done,
     /* 586433 */   // Label 7393: @586433
     /* 586433 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(586562), // Rule ID 11332 //
     /* 586438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 586478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 586482 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586487 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586487 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586492 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586519 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 586529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 586534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 586539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 586544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586560 */     GIR_RootConstrainSelectedInstOperands,
     /* 586561 */     // GIR_Coverage, 11332,
     /* 586561 */     GIR_EraseRootFromParent_Done,
     /* 586562 */   // Label 7394: @586562
     /* 586562 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(586691), // Rule ID 11312 //
     /* 586567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 586607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 586611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586616 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586634 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586648 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 586658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 586663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 586668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 586673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586689 */     GIR_RootConstrainSelectedInstOperands,
     /* 586690 */     // GIR_Coverage, 11312,
     /* 586690 */     GIR_EraseRootFromParent_Done,
     /* 586691 */   // Label 7395: @586691
     /* 586691 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(586820), // Rule ID 11313 //
     /* 586696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 586736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 586740 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586745 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586777 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 586787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 586792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 586797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 586802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586818 */     GIR_RootConstrainSelectedInstOperands,
     /* 586819 */     // GIR_Coverage, 11313,
     /* 586819 */     GIR_EraseRootFromParent_Done,
     /* 586820 */   // Label 7396: @586820
     /* 586820 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(586949), // Rule ID 11316 //
     /* 586825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 586865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 586869 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586874 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586906 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 586916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 586921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 586926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 586931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586947 */     GIR_RootConstrainSelectedInstOperands,
     /* 586948 */     // GIR_Coverage, 11316,
     /* 586948 */     GIR_EraseRootFromParent_Done,
     /* 586949 */   // Label 7397: @586949
     /* 586949 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(587078), // Rule ID 11317 //
     /* 586954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 586994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 586998 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587003 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587008 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587035 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 587045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 587050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 587055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 587060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587076 */     GIR_RootConstrainSelectedInstOperands,
     /* 587077 */     // GIR_Coverage, 11317,
     /* 587077 */     GIR_EraseRootFromParent_Done,
     /* 587078 */   // Label 7398: @587078
     /* 587078 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(587207), // Rule ID 7578 //
     /* 587083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 587123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 587127 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587132 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587164 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 587174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 587179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 587184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 587189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587205 */     GIR_RootConstrainSelectedInstOperands,
     /* 587206 */     // GIR_Coverage, 7578,
     /* 587206 */     GIR_EraseRootFromParent_Done,
     /* 587207 */   // Label 7399: @587207
     /* 587207 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(587336), // Rule ID 11326 //
     /* 587212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 587252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 587256 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587261 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587270 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587293 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 587303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 587308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 587313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 587318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587334 */     GIR_RootConstrainSelectedInstOperands,
     /* 587335 */     // GIR_Coverage, 11326,
     /* 587335 */     GIR_EraseRootFromParent_Done,
     /* 587336 */   // Label 7400: @587336
     /* 587336 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(587465), // Rule ID 11329 //
     /* 587341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 587381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 587385 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587390 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587395 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587422 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 587432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 587437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 587442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 587447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587463 */     GIR_RootConstrainSelectedInstOperands,
     /* 587464 */     // GIR_Coverage, 11329,
     /* 587464 */     GIR_EraseRootFromParent_Done,
     /* 587465 */   // Label 7401: @587465
     /* 587465 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(587594), // Rule ID 11330 //
     /* 587470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 587510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 587514 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587519 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587551 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 587561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 587566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 587571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 587576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587592 */     GIR_RootConstrainSelectedInstOperands,
     /* 587593 */     // GIR_Coverage, 11330,
     /* 587593 */     GIR_EraseRootFromParent_Done,
     /* 587594 */   // Label 7402: @587594
     /* 587594 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(587723), // Rule ID 7577 //
     /* 587599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 587639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 587643 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587643 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587648 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587648 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587653 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587680 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 587690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 587695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 587700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 587705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587721 */     GIR_RootConstrainSelectedInstOperands,
     /* 587722 */     // GIR_Coverage, 7577,
     /* 587722 */     GIR_EraseRootFromParent_Done,
     /* 587723 */   // Label 7403: @587723
     /* 587723 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(587852), // Rule ID 11311 //
     /* 587728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 587768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 587772 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587777 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587777 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587782 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587809 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 587819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 587824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 587829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 587834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587850 */     GIR_RootConstrainSelectedInstOperands,
     /* 587851 */     // GIR_Coverage, 11311,
     /* 587851 */     GIR_EraseRootFromParent_Done,
     /* 587852 */   // Label 7404: @587852
     /* 587852 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(587981), // Rule ID 11314 //
     /* 587857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 587881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 587897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 587901 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 587906 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 587911 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587938 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 587948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 587953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 587958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 587963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 587968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 587973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587979 */     GIR_RootConstrainSelectedInstOperands,
     /* 587980 */     // GIR_Coverage, 11314,
     /* 587980 */     GIR_EraseRootFromParent_Done,
     /* 587981 */   // Label 7405: @587981
     /* 587981 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(588110), // Rule ID 11315 //
     /* 587986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 588026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 588030 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588030 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588035 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588035 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588040 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588060 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588067 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 588077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 588082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 588087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 588092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588108 */     GIR_RootConstrainSelectedInstOperands,
     /* 588109 */     // GIR_Coverage, 11315,
     /* 588109 */     GIR_EraseRootFromParent_Done,
     /* 588110 */   // Label 7406: @588110
     /* 588110 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(588239), // Rule ID 11297 //
     /* 588115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 588155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 588159 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588164 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588169 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588189 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588196 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 588206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 588211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 588216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 588221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588237 */     GIR_RootConstrainSelectedInstOperands,
     /* 588238 */     // GIR_Coverage, 11297,
     /* 588238 */     GIR_EraseRootFromParent_Done,
     /* 588239 */   // Label 7407: @588239
     /* 588239 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(588368), // Rule ID 11298 //
     /* 588244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588280 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 588284 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 588288 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588293 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588293 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588325 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 588335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 588340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 588345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 588350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588366 */     GIR_RootConstrainSelectedInstOperands,
     /* 588367 */     // GIR_Coverage, 11298,
     /* 588367 */     GIR_EraseRootFromParent_Done,
     /* 588368 */   // Label 7408: @588368
     /* 588368 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(588497), // Rule ID 11301 //
     /* 588373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588405 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 588413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 588417 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588422 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588422 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588427 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588447 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588454 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 588464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 588469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 588474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 588479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588495 */     GIR_RootConstrainSelectedInstOperands,
     /* 588496 */     // GIR_Coverage, 11301,
     /* 588496 */     GIR_EraseRootFromParent_Done,
     /* 588497 */   // Label 7409: @588497
     /* 588497 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(588626), // Rule ID 11302 //
     /* 588502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 588542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 588546 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588551 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588556 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588576 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588583 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 588593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 588598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 588603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 588608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588624 */     GIR_RootConstrainSelectedInstOperands,
     /* 588625 */     // GIR_Coverage, 11302,
     /* 588625 */     GIR_EraseRootFromParent_Done,
     /* 588626 */   // Label 7410: @588626
     /* 588626 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(588755), // Rule ID 11282 //
     /* 588631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 588671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 588675 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588680 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588685 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588705 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588712 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 588722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 588727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 588732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 588737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588753 */     GIR_RootConstrainSelectedInstOperands,
     /* 588754 */     // GIR_Coverage, 11282,
     /* 588754 */     GIR_EraseRootFromParent_Done,
     /* 588755 */   // Label 7411: @588755
     /* 588755 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(588884), // Rule ID 11283 //
     /* 588760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 588800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 588804 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588809 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588814 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588834 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588841 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 588851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 588856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 588861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 588866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588882 */     GIR_RootConstrainSelectedInstOperands,
     /* 588883 */     // GIR_Coverage, 11283,
     /* 588883 */     GIR_EraseRootFromParent_Done,
     /* 588884 */   // Label 7412: @588884
     /* 588884 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(589013), // Rule ID 11286 //
     /* 588889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 588913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 588929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 588933 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588933 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 588938 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 588943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588963 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588970 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 588980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 588985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 588990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 588995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589011 */     GIR_RootConstrainSelectedInstOperands,
     /* 589012 */     // GIR_Coverage, 11286,
     /* 589012 */     GIR_EraseRootFromParent_Done,
     /* 589013 */   // Label 7413: @589013
     /* 589013 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(589142), // Rule ID 11287 //
     /* 589018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 589058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 589062 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589067 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589072 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589076 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589092 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589099 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 589109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 589114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 589119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 589124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589140 */     GIR_RootConstrainSelectedInstOperands,
     /* 589141 */     // GIR_Coverage, 11287,
     /* 589141 */     GIR_EraseRootFromParent_Done,
     /* 589142 */   // Label 7414: @589142
     /* 589142 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(589271), // Rule ID 7576 //
     /* 589147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 589187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 589191 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589196 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589221 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589228 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 589238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 589243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 589248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 589253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589269 */     GIR_RootConstrainSelectedInstOperands,
     /* 589270 */     // GIR_Coverage, 7576,
     /* 589270 */     GIR_EraseRootFromParent_Done,
     /* 589271 */   // Label 7415: @589271
     /* 589271 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(589400), // Rule ID 11296 //
     /* 589276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 589316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 589320 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589325 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589330 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589334 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589350 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589357 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 589367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 589372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 589377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 589382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589398 */     GIR_RootConstrainSelectedInstOperands,
     /* 589399 */     // GIR_Coverage, 11296,
     /* 589399 */     GIR_EraseRootFromParent_Done,
     /* 589400 */   // Label 7416: @589400
     /* 589400 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(589529), // Rule ID 11299 //
     /* 589405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 589445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 589449 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589454 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589479 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589486 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 589496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 589501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 589506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 589511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589527 */     GIR_RootConstrainSelectedInstOperands,
     /* 589528 */     // GIR_Coverage, 11299,
     /* 589528 */     GIR_EraseRootFromParent_Done,
     /* 589529 */   // Label 7417: @589529
     /* 589529 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(589658), // Rule ID 11300 //
     /* 589534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 589574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 589578 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589578 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589583 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589588 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589608 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589615 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 589625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 589630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 589635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 589640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589656 */     GIR_RootConstrainSelectedInstOperands,
     /* 589657 */     // GIR_Coverage, 11300,
     /* 589657 */     GIR_EraseRootFromParent_Done,
     /* 589658 */   // Label 7418: @589658
     /* 589658 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(589787), // Rule ID 7575 //
     /* 589663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 589703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 589707 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589712 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589712 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589721 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589744 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 589754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 589759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 589764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 589769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589785 */     GIR_RootConstrainSelectedInstOperands,
     /* 589786 */     // GIR_Coverage, 7575,
     /* 589786 */     GIR_EraseRootFromParent_Done,
     /* 589787 */   // Label 7419: @589787
     /* 589787 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(589916), // Rule ID 11281 //
     /* 589792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 589832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 589836 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589841 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589866 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589873 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 589883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 589888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 589893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 589898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589914 */     GIR_RootConstrainSelectedInstOperands,
     /* 589915 */     // GIR_Coverage, 11281,
     /* 589915 */     GIR_EraseRootFromParent_Done,
     /* 589916 */   // Label 7420: @589916
     /* 589916 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(590045), // Rule ID 11284 //
     /* 589921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 589945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 589961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 589965 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589965 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 589970 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589970 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 589975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589995 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590002 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 590022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 590027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590043 */     GIR_RootConstrainSelectedInstOperands,
     /* 590044 */     // GIR_Coverage, 11284,
     /* 590044 */     GIR_EraseRootFromParent_Done,
     /* 590045 */   // Label 7421: @590045
     /* 590045 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(590174), // Rule ID 11285 //
     /* 590050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 590074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 590090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 590094 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 590099 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 590104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590131 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 590151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 590156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590172 */     GIR_RootConstrainSelectedInstOperands,
     /* 590173 */     // GIR_Coverage, 11285,
     /* 590173 */     GIR_EraseRootFromParent_Done,
     /* 590174 */   // Label 7422: @590174
     /* 590174 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(590303), // Rule ID 11367 //
     /* 590179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 590203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590223 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590228 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590228 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590233 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590246 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590253 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590260 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 590280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 590285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 590290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 590295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590301 */     GIR_RootConstrainSelectedInstOperands,
     /* 590302 */     // GIR_Coverage, 11367,
     /* 590302 */     GIR_EraseRootFromParent_Done,
     /* 590303 */   // Label 7423: @590303
     /* 590303 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(590432), // Rule ID 11368 //
     /* 590308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 590332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590352 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590357 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590357 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590362 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590382 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590389 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 590409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 590414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 590419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 590424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590430 */     GIR_RootConstrainSelectedInstOperands,
     /* 590431 */     // GIR_Coverage, 11368,
     /* 590431 */     GIR_EraseRootFromParent_Done,
     /* 590432 */   // Label 7424: @590432
     /* 590432 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(590561), // Rule ID 11369 //
     /* 590437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 590461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590504 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590511 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590518 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 590528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 590533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 590538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 590543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 590548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 590553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590559 */     GIR_RootConstrainSelectedInstOperands,
     /* 590560 */     // GIR_Coverage, 11369,
     /* 590560 */     GIR_EraseRootFromParent_Done,
     /* 590561 */   // Label 7425: @590561
     /* 590561 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(590690), // Rule ID 11370 //
     /* 590566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 590590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590610 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590615 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590615 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590620 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590624 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590647 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 590657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 590662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 590667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 590672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 590677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 590682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590688 */     GIR_RootConstrainSelectedInstOperands,
     /* 590689 */     // GIR_Coverage, 11370,
     /* 590689 */     GIR_EraseRootFromParent_Done,
     /* 590690 */   // Label 7426: @590690
     /* 590690 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(590819), // Rule ID 11307 //
     /* 590695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 590719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590739 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590744 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590762 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590776 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 590796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 590801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 590806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 590811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590817 */     GIR_RootConstrainSelectedInstOperands,
     /* 590818 */     // GIR_Coverage, 11307,
     /* 590818 */     GIR_EraseRootFromParent_Done,
     /* 590819 */   // Label 7427: @590819
     /* 590819 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(590948), // Rule ID 11308 //
     /* 590824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 590848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590868 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590873 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590878 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590905 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 590925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 590930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 590935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 590940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590946 */     GIR_RootConstrainSelectedInstOperands,
     /* 590947 */     // GIR_Coverage, 11308,
     /* 590947 */     GIR_EraseRootFromParent_Done,
     /* 590948 */   // Label 7428: @590948
     /* 590948 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(591077), // Rule ID 11309 //
     /* 590953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 590977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590997 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591002 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591007 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591034 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 591044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 591049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 591054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 591059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591075 */     GIR_RootConstrainSelectedInstOperands,
     /* 591076 */     // GIR_Coverage, 11309,
     /* 591076 */     GIR_EraseRootFromParent_Done,
     /* 591077 */   // Label 7429: @591077
     /* 591077 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(591206), // Rule ID 11310 //
     /* 591082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 591110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591136 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591163 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 591173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 591178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 591183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 591188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591204 */     GIR_RootConstrainSelectedInstOperands,
     /* 591205 */     // GIR_Coverage, 11310,
     /* 591205 */     GIR_EraseRootFromParent_Done,
     /* 591206 */   // Label 7430: @591206
     /* 591206 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(591335), // Rule ID 11352 //
     /* 591211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591255 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591260 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591278 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591292 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 591302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 591307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 591312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 591317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591333 */     GIR_RootConstrainSelectedInstOperands,
     /* 591334 */     // GIR_Coverage, 11352,
     /* 591334 */     GIR_EraseRootFromParent_Done,
     /* 591335 */   // Label 7431: @591335
     /* 591335 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(591464), // Rule ID 11353 //
     /* 591340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591384 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591389 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591394 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591421 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 591431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 591436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 591441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 591446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591462 */     GIR_RootConstrainSelectedInstOperands,
     /* 591463 */     // GIR_Coverage, 11353,
     /* 591463 */     GIR_EraseRootFromParent_Done,
     /* 591464 */   // Label 7432: @591464
     /* 591464 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(591593), // Rule ID 11354 //
     /* 591469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591513 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591518 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591523 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591527 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591550 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 591560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 591565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 591570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 591575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591591 */     GIR_RootConstrainSelectedInstOperands,
     /* 591592 */     // GIR_Coverage, 11354,
     /* 591592 */     GIR_EraseRootFromParent_Done,
     /* 591593 */   // Label 7433: @591593
     /* 591593 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(591722), // Rule ID 11355 //
     /* 591598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591642 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591647 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591652 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591679 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 591689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 591694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 591699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 591704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591720 */     GIR_RootConstrainSelectedInstOperands,
     /* 591721 */     // GIR_Coverage, 11355,
     /* 591721 */     GIR_EraseRootFromParent_Done,
     /* 591722 */   // Label 7434: @591722
     /* 591722 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(591851), // Rule ID 11292 //
     /* 591727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591808 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 591818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 591823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 591828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 591833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591849 */     GIR_RootConstrainSelectedInstOperands,
     /* 591850 */     // GIR_Coverage, 11292,
     /* 591850 */     GIR_EraseRootFromParent_Done,
     /* 591851 */   // Label 7435: @591851
     /* 591851 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(591980), // Rule ID 11293 //
     /* 591856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 591880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 591896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591900 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 591905 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 591910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591923 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591937 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 591947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 591952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 591957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 591962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 591967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 591972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591978 */     GIR_RootConstrainSelectedInstOperands,
     /* 591979 */     // GIR_Coverage, 11293,
     /* 591979 */     GIR_EraseRootFromParent_Done,
     /* 591980 */   // Label 7436: @591980
     /* 591980 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(592109), // Rule ID 11294 //
     /* 591985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 592009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 592013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592029 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592034 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592066 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 592076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 592081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 592096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 592101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592107 */     GIR_RootConstrainSelectedInstOperands,
     /* 592108 */     // GIR_Coverage, 11294,
     /* 592108 */     GIR_EraseRootFromParent_Done,
     /* 592109 */   // Label 7437: @592109
     /* 592109 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(592238), // Rule ID 11295 //
     /* 592114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 592138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 592142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592158 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592163 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592168 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592195 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 592205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 592210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 592225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 592230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592236 */     GIR_RootConstrainSelectedInstOperands,
     /* 592237 */     // GIR_Coverage, 11295,
     /* 592237 */     GIR_EraseRootFromParent_Done,
     /* 592238 */   // Label 7438: @592238
     /* 592238 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(592367), // Rule ID 11363 //
     /* 592243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 592267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 592287 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592292 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592324 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 592334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 592339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592365 */     GIR_RootConstrainSelectedInstOperands,
     /* 592366 */     // GIR_Coverage, 11363,
     /* 592366 */     GIR_EraseRootFromParent_Done,
     /* 592367 */   // Label 7439: @592367
     /* 592367 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(592496), // Rule ID 11364 //
     /* 592372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 592396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 592416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592430 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592453 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 592463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 592468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592494 */     GIR_RootConstrainSelectedInstOperands,
     /* 592495 */     // GIR_Coverage, 11364,
     /* 592495 */     GIR_EraseRootFromParent_Done,
     /* 592496 */   // Label 7440: @592496
     /* 592496 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(592625), // Rule ID 11365 //
     /* 592501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 592525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 592545 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592545 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592550 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592550 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592575 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592582 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 592592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 592597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 592602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 592607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592623 */     GIR_RootConstrainSelectedInstOperands,
     /* 592624 */     // GIR_Coverage, 11365,
     /* 592624 */     GIR_EraseRootFromParent_Done,
     /* 592625 */   // Label 7441: @592625
     /* 592625 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(592754), // Rule ID 11366 //
     /* 592630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 592654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 592674 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592679 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592711 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 592721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 592726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 592731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 592736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592752 */     GIR_RootConstrainSelectedInstOperands,
     /* 592753 */     // GIR_Coverage, 11366,
     /* 592753 */     GIR_EraseRootFromParent_Done,
     /* 592754 */   // Label 7442: @592754
     /* 592754 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(592883), // Rule ID 11303 //
     /* 592759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 592783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592803 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592808 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592833 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592840 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 592850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 592855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592881 */     GIR_RootConstrainSelectedInstOperands,
     /* 592882 */     // GIR_Coverage, 11303,
     /* 592882 */     GIR_EraseRootFromParent_Done,
     /* 592883 */   // Label 7443: @592883
     /* 592883 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(593012), // Rule ID 11304 //
     /* 592888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 592912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 592928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592932 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 592937 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592937 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 592942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592969 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 592979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 592984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593010 */     GIR_RootConstrainSelectedInstOperands,
     /* 593011 */     // GIR_Coverage, 11304,
     /* 593011 */     GIR_EraseRootFromParent_Done,
     /* 593012 */   // Label 7444: @593012
     /* 593012 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(593141), // Rule ID 11305 //
     /* 593017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 593045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593066 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593071 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593098 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 593108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 593113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 593118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 593123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593139 */     GIR_RootConstrainSelectedInstOperands,
     /* 593140 */     // GIR_Coverage, 11305,
     /* 593140 */     GIR_EraseRootFromParent_Done,
     /* 593141 */   // Label 7445: @593141
     /* 593141 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(593270), // Rule ID 11306 //
     /* 593146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 593174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593190 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593195 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593195 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593200 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593220 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593227 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 593237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 593242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 593247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 593252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593268 */     GIR_RootConstrainSelectedInstOperands,
     /* 593269 */     // GIR_Coverage, 11306,
     /* 593269 */     GIR_EraseRootFromParent_Done,
     /* 593270 */   // Label 7446: @593270
     /* 593270 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(593399), // Rule ID 11348 //
     /* 593275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 593319 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593324 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593356 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 593366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 593371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 593376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 593381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593397 */     GIR_RootConstrainSelectedInstOperands,
     /* 593398 */     // GIR_Coverage, 11348,
     /* 593398 */     GIR_EraseRootFromParent_Done,
     /* 593399 */   // Label 7447: @593399
     /* 593399 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(593528), // Rule ID 11349 //
     /* 593404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 593448 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593453 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593458 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593485 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 593495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 593500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 593505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 593510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593526 */     GIR_RootConstrainSelectedInstOperands,
     /* 593527 */     // GIR_Coverage, 11349,
     /* 593527 */     GIR_EraseRootFromParent_Done,
     /* 593528 */   // Label 7448: @593528
     /* 593528 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(593657), // Rule ID 11350 //
     /* 593533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 593577 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593582 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593587 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593600 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593614 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 593624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 593629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 593634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 593639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593655 */     GIR_RootConstrainSelectedInstOperands,
     /* 593656 */     // GIR_Coverage, 11350,
     /* 593656 */     GIR_EraseRootFromParent_Done,
     /* 593657 */   // Label 7449: @593657
     /* 593657 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(593786), // Rule ID 11351 //
     /* 593662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 593706 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593711 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593736 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593743 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 593753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 593758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 593763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 593768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593784 */     GIR_RootConstrainSelectedInstOperands,
     /* 593785 */     // GIR_Coverage, 11351,
     /* 593785 */     GIR_EraseRootFromParent_Done,
     /* 593786 */   // Label 7450: @593786
     /* 593786 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(593915), // Rule ID 11288 //
     /* 593791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593835 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593835 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593840 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593845 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593849 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593865 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593872 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 593882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 593887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 593892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 593897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593913 */     GIR_RootConstrainSelectedInstOperands,
     /* 593914 */     // GIR_Coverage, 11288,
     /* 593914 */     GIR_EraseRootFromParent_Done,
     /* 593915 */   // Label 7451: @593915
     /* 593915 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(594044), // Rule ID 11289 //
     /* 593920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 593944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 593960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593964 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 593969 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 593974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594001 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 594011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 594016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 594021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 594026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594042 */     GIR_RootConstrainSelectedInstOperands,
     /* 594043 */     // GIR_Coverage, 11289,
     /* 594043 */     GIR_EraseRootFromParent_Done,
     /* 594044 */   // Label 7452: @594044
     /* 594044 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(594173), // Rule ID 11290 //
     /* 594049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 594077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 594089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594093 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 594098 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 594098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 594103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594107 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594123 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594130 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 594150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 594155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594171 */     GIR_RootConstrainSelectedInstOperands,
     /* 594172 */     // GIR_Coverage, 11290,
     /* 594172 */     GIR_EraseRootFromParent_Done,
     /* 594173 */   // Label 7453: @594173
     /* 594173 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(594302), // Rule ID 11291 //
     /* 594178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 594206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 594218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594222 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 594222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 594227 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 594232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594259 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 594279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 594284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594300 */     GIR_RootConstrainSelectedInstOperands,
     /* 594301 */     // GIR_Coverage, 11291,
     /* 594301 */     GIR_EraseRootFromParent_Done,
     /* 594302 */   // Label 7454: @594302
     /* 594302 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(594414), // Rule ID 13244 //
     /* 594307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 594310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 594318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 594322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 594334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594342 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 594344 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 594348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 594350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594357 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594364 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594371 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 594374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 594391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 594396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 594401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 594406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594412 */     GIR_RootConstrainSelectedInstOperands,
     /* 594413 */     // GIR_Coverage, 13244,
     /* 594413 */     GIR_EraseRootFromParent_Done,
     /* 594414 */   // Label 7455: @594414
     /* 594414 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(594526), // Rule ID 13243 //
     /* 594419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 594422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 594430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 594434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594454 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 594456 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 594460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 594462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594483 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 594486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 594503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 594508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 594513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 594518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594524 */     GIR_RootConstrainSelectedInstOperands,
     /* 594525 */     // GIR_Coverage, 13243,
     /* 594525 */     GIR_EraseRootFromParent_Done,
     /* 594526 */   // Label 7456: @594526
     /* 594526 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(594638), // Rule ID 7718 //
     /* 594531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 594534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 594546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 594558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594566 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 594568 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 594572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 594574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594595 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 594598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 594605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 594610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 594615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 594620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594636 */     GIR_RootConstrainSelectedInstOperands,
     /* 594637 */     // GIR_Coverage, 7718,
     /* 594637 */     GIR_EraseRootFromParent_Done,
     /* 594638 */   // Label 7457: @594638
     /* 594638 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(594750), // Rule ID 7717 //
     /* 594643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 594646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 594658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 594666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594674 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594678 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 594680 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 594684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 594686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594707 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 594710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 594717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 594722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 594727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 594732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594748 */     GIR_RootConstrainSelectedInstOperands,
     /* 594749 */     // GIR_Coverage, 7717,
     /* 594749 */     GIR_EraseRootFromParent_Done,
     /* 594750 */   // Label 7458: @594750
     /* 594750 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(594846), // Rule ID 13236 //
     /* 594755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 594758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 594766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 594770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594778 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 594780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 594782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594803 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 594806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 594823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 594828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 594833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 594838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594844 */     GIR_RootConstrainSelectedInstOperands,
     /* 594845 */     // GIR_Coverage, 13236,
     /* 594845 */     GIR_EraseRootFromParent_Done,
     /* 594846 */   // Label 7459: @594846
     /* 594846 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(594942), // Rule ID 13235 //
     /* 594851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 594854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 594862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594874 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 594876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 594878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594899 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 594902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 594919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 594924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 594929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 594934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594940 */     GIR_RootConstrainSelectedInstOperands,
     /* 594941 */     // GIR_Coverage, 13235,
     /* 594941 */     GIR_EraseRootFromParent_Done,
     /* 594942 */   // Label 7460: @594942
     /* 594942 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(595038), // Rule ID 7710 //
     /* 594947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 594950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 594962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594970 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 594972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 594974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594995 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 594998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 595005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 595015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 595025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 595030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595036 */     GIR_RootConstrainSelectedInstOperands,
     /* 595037 */     // GIR_Coverage, 7710,
     /* 595037 */     GIR_EraseRootFromParent_Done,
     /* 595038 */   // Label 7461: @595038
     /* 595038 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(595134), // Rule ID 7709 //
     /* 595043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 595046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 595054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 595062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 595066 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 595068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 595070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595091 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 595094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 595101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 595111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 595121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 595126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595132 */     GIR_RootConstrainSelectedInstOperands,
     /* 595133 */     // GIR_Coverage, 7709,
     /* 595133 */     GIR_EraseRootFromParent_Done,
     /* 595134 */   // Label 7462: @595134
     /* 595134 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(595169), // Rule ID 92 //
     /* 595139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 595142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 595146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 595150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 595154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13799),
     /* 595158 */     // (fmaxnum_ieee:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13799>>  =>  (S_MAX_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 595158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F32),
     /* 595163 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 595167 */     GIR_RootConstrainSelectedInstOperands,
     /* 595168 */     // GIR_Coverage, 92,
     /* 595168 */     GIR_Done,
     /* 595169 */   // Label 7463: @595169
     /* 595169 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(595229), // Rule ID 802 //
     /* 595174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 595185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595192 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 595192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 595195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 595202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 595212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 595222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 595227 */     GIR_RootConstrainSelectedInstOperands,
     /* 595228 */     // GIR_Coverage, 802,
     /* 595228 */     GIR_EraseRootFromParent_Done,
     /* 595229 */   // Label 7464: @595229
     /* 595229 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(595289), // Rule ID 8417 //
     /* 595234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 595252 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 595252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 595255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 595262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 595272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 595277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 595282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 595287 */     GIR_RootConstrainSelectedInstOperands,
     /* 595288 */     // GIR_Coverage, 8417,
     /* 595288 */     GIR_EraseRootFromParent_Done,
     /* 595289 */   // Label 7465: @595289
     /* 595289 */   GIM_Reject,
     /* 595290 */ // Label 7326: @595290
     /* 595290 */ GIM_Reject,
     /* 595291 */ // Label 6916: @595291
     /* 595291 */ GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(595543),
     /* 595296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 595299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 595302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 595306 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(595365), // Rule ID 917 //
     /* 595311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 595314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 595321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595328 */     // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 595328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 595331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 595338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 595348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 595358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 595363 */     GIR_RootConstrainSelectedInstOperands,
     /* 595364 */     // GIR_Coverage, 917,
     /* 595364 */     GIR_EraseRootFromParent_Done,
     /* 595365 */   // Label 7467: @595365
     /* 595365 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(595424), // Rule ID 936 //
     /* 595370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 595373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 595380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595387 */     // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 595387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 595390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 595397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 595407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 595417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 595422 */     GIR_RootConstrainSelectedInstOperands,
     /* 595423 */     // GIR_Coverage, 936,
     /* 595423 */     GIR_EraseRootFromParent_Done,
     /* 595424 */   // Label 7468: @595424
     /* 595424 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(595483), // Rule ID 8443 //
     /* 595429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 595432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 595446 */     // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 595446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 595449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 595456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 595466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 595471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 595476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 595481 */     GIR_RootConstrainSelectedInstOperands,
     /* 595482 */     // GIR_Coverage, 8443,
     /* 595482 */     GIR_EraseRootFromParent_Done,
     /* 595483 */   // Label 7469: @595483
     /* 595483 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(595542), // Rule ID 8457 //
     /* 595488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 595491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 595505 */     // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 595505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 595508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 595515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 595525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 595530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 595535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 595540 */     GIR_RootConstrainSelectedInstOperands,
     /* 595541 */     // GIR_Coverage, 8457,
     /* 595541 */     GIR_EraseRootFromParent_Done,
     /* 595542 */   // Label 7470: @595542
     /* 595542 */   GIM_Reject,
     /* 595543 */ // Label 7466: @595543
     /* 595543 */ GIM_Reject,
     /* 595544 */ // Label 6917: @595544
     /* 595544 */ GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(595615), // Rule ID 1094 //
     /* 595549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 595552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 595555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595559 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 595566 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 595573 */   // (fmaxnum_ieee:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 595573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 595576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 595583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 595593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595613 */   GIR_RootConstrainSelectedInstOperands,
     /* 595614 */   // GIR_Coverage, 1094,
     /* 595614 */   GIR_EraseRootFromParent_Done,
     /* 595615 */ // Label 7471: @595615
     /* 595615 */ GIM_Reject,
     /* 595616 */ // Label 6918: @595616
     /* 595616 */ GIM_Reject,
     /* 595617 */ // Label 84: @595617
     /* 595617 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7476*/ GIMT_Encode4(597743),
     /* 595628 */ /*GILLT_s16*//*Label 7472*/ GIMT_Encode4(595644),
     /* 595632 */ /*GILLT_s32*//*Label 7473*/ GIMT_Encode4(596774),
     /* 595636 */ /*GILLT_s64*//*Label 7474*/ GIMT_Encode4(597453),
     /* 595640 */ /*GILLT_v2s16*//*Label 7475*/ GIMT_Encode4(597588),
     /* 595644 */ // Label 7472: @595644
     /* 595644 */ GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(596773),
     /* 595649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 595652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 595655 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(595774), // Rule ID 13440 //
     /* 595660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 595663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 595667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 595671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 595675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 595679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 595683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 595687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 595691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 595695 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 595697 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 595701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 595705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 595707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595714 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595728 */     // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35005>>)<<P:Predicate_anonymous_20186>>  =>  (V_MAXIMUMMINIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_t16_e64),
     /* 595731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 595738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 595748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 595753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 595758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 595763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595772 */     GIR_RootConstrainSelectedInstOperands,
     /* 595773 */     // GIR_Coverage, 13440,
     /* 595773 */     GIR_EraseRootFromParent_Done,
     /* 595774 */   // Label 7478: @595774
     /* 595774 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(595893), // Rule ID 13444 //
     /* 595779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 595782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 595790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 595794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 595798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 595802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 595806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 595810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 595814 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 595816 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 595820 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 595824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 595826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595833 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595840 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595847 */     // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35005>>)<<P:Predicate_anonymous_20186>>  =>  (V_MAXIMUMMINIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_fake16_e64),
     /* 595850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 595857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 595867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 595872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 595877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 595882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595891 */     GIR_RootConstrainSelectedInstOperands,
     /* 595892 */     // GIR_Coverage, 13444,
     /* 595892 */     GIR_EraseRootFromParent_Done,
     /* 595893 */   // Label 7479: @595893
     /* 595893 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(596012), // Rule ID 7774 //
     /* 595898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 595901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 595905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 595909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 595913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 595917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 595921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 595925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 595929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 595933 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 595935 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 595939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 595943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 595945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595966 */     // (fminimum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20186>>  =>  (V_MAXIMUMMINIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_t16_e64),
     /* 595969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 595976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 595981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 595986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 595996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 596001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596010 */     GIR_RootConstrainSelectedInstOperands,
     /* 596011 */     // GIR_Coverage, 7774,
     /* 596011 */     GIR_EraseRootFromParent_Done,
     /* 596012 */   // Label 7480: @596012
     /* 596012 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(596131), // Rule ID 7778 //
     /* 596017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 596020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 596032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 596036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 596040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 596048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 596052 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 596054 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 596058 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 596062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 596064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596078 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596085 */     // (fminimum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20186>>  =>  (V_MAXIMUMMINIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_fake16_e64),
     /* 596088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 596095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 596105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 596115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 596120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596129 */     GIR_RootConstrainSelectedInstOperands,
     /* 596130 */     // GIR_Coverage, 7778,
     /* 596130 */     GIR_EraseRootFromParent_Done,
     /* 596131 */   // Label 7481: @596131
     /* 596131 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(596234), // Rule ID 13438 //
     /* 596136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 596139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 596143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 596147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 596155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 596159 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 596161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 596165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 596167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596188 */     // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_20186>>  =>  (V_MAXIMUMMINIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_t16_e64),
     /* 596191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 596198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 596203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 596208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 596213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 596218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 596223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596232 */     GIR_RootConstrainSelectedInstOperands,
     /* 596233 */     // GIR_Coverage, 13438,
     /* 596233 */     GIR_EraseRootFromParent_Done,
     /* 596234 */   // Label 7482: @596234
     /* 596234 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(596337), // Rule ID 13442 //
     /* 596239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 596242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 596250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 596258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 596262 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 596264 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 596268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 596270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596291 */     // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_20186>>  =>  (V_MAXIMUMMINIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_fake16_e64),
     /* 596294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 596301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 596306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 596311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 596316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 596321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 596326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596335 */     GIR_RootConstrainSelectedInstOperands,
     /* 596336 */     // GIR_Coverage, 13442,
     /* 596336 */     GIR_EraseRootFromParent_Done,
     /* 596337 */   // Label 7483: @596337
     /* 596337 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(596440), // Rule ID 7772 //
     /* 596342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 596345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 596349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 596361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 596365 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 596367 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 596371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 596373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596394 */     // (fminimum:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20186>>  =>  (V_MAXIMUMMINIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_t16_e64),
     /* 596397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 596404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 596414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 596424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 596429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596438 */     GIR_RootConstrainSelectedInstOperands,
     /* 596439 */     // GIR_Coverage, 7772,
     /* 596439 */     GIR_EraseRootFromParent_Done,
     /* 596440 */   // Label 7484: @596440
     /* 596440 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(596543), // Rule ID 7776 //
     /* 596445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 596448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 596464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 596468 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 596470 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 596474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 596476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596497 */     // (fminimum:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20186>>  =>  (V_MAXIMUMMINIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_fake16_e64),
     /* 596500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 596507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 596517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 596527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 596532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596541 */     GIR_RootConstrainSelectedInstOperands,
     /* 596542 */     // GIR_Coverage, 7776,
     /* 596542 */     GIR_EraseRootFromParent_Done,
     /* 596543 */   // Label 7485: @596543
     /* 596543 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(596609), // Rule ID 943 //
     /* 596548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX12Plus),
     /* 596551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 596559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 596566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 596573 */     // (fminimum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20186>>  =>  (V_MINIMUM_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 596573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F16_e64),
     /* 596576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 596583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 596593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596607 */     GIR_RootConstrainSelectedInstOperands,
     /* 596608 */     // GIR_Coverage, 943,
     /* 596608 */     GIR_EraseRootFromParent_Done,
     /* 596609 */   // Label 7486: @596609
     /* 596609 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(596675), // Rule ID 944 //
     /* 596614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 596617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 596621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 596625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 596632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 596639 */     // (fminimum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20186>>  =>  (V_MINIMUM_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 596639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F16_t16_e64),
     /* 596642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 596649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 596659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596673 */     GIR_RootConstrainSelectedInstOperands,
     /* 596674 */     // GIR_Coverage, 944,
     /* 596674 */     GIR_EraseRootFromParent_Done,
     /* 596675 */   // Label 7487: @596675
     /* 596675 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(596741), // Rule ID 945 //
     /* 596680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 596683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596687 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 596691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 596698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 596705 */     // (fminimum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20186>>  =>  (V_MINIMUM_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 596705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F16_fake16_e64),
     /* 596708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 596715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 596725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596739 */     GIR_RootConstrainSelectedInstOperands,
     /* 596740 */     // GIR_Coverage, 945,
     /* 596740 */     GIR_EraseRootFromParent_Done,
     /* 596741 */   // Label 7488: @596741
     /* 596741 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(596772), // Rule ID 116 //
     /* 596746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 596749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 596753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 596757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 596761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13804),
     /* 596765 */     // (fminimum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13804>>  =>  (S_MINIMUM_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 596765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MINIMUM_F16),
     /* 596770 */     GIR_RootConstrainSelectedInstOperands,
     /* 596771 */     // GIR_Coverage, 116,
     /* 596771 */     GIR_Done,
     /* 596772 */   // Label 7489: @596772
     /* 596772 */   GIM_Reject,
     /* 596773 */ // Label 7477: @596773
     /* 596773 */ GIM_Reject,
     /* 596774 */ // Label 7473: @596774
     /* 596774 */ GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(597452),
     /* 596779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 596782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 596785 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(596901), // Rule ID 13436 //
     /* 596790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 596793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 596801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 596805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 596809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 596813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 596821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 596825 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 596827 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 596831 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 596835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 596837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596858 */     // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35005>>)<<P:Predicate_anonymous_20186>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
     /* 596861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 596868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 596873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 596878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 596883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 596888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 596893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596899 */     GIR_RootConstrainSelectedInstOperands,
     /* 596900 */     // GIR_Coverage, 13436,
     /* 596900 */     GIR_EraseRootFromParent_Done,
     /* 596901 */   // Label 7491: @596901
     /* 596901 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(597017), // Rule ID 7770 //
     /* 596906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 596909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 596921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 596925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 596929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 596933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 596937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 596941 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 596943 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 596947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 596951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 596953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596974 */     // (fminimum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20186>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
     /* 596977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 596984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 596994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 597004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 597009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597015 */     GIR_RootConstrainSelectedInstOperands,
     /* 597016 */     // GIR_Coverage, 7770,
     /* 597016 */     GIR_EraseRootFromParent_Done,
     /* 597017 */   // Label 7492: @597017
     /* 597017 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(597117), // Rule ID 13434 //
     /* 597022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 597033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 597037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 597045 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 597047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 597051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 597053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597074 */     // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_20186>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
     /* 597077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 597084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 597089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 597094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 597099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 597104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 597109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597115 */     GIR_RootConstrainSelectedInstOperands,
     /* 597116 */     // GIR_Coverage, 13434,
     /* 597116 */     GIR_EraseRootFromParent_Done,
     /* 597117 */   // Label 7493: @597117
     /* 597117 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(597217), // Rule ID 7768 //
     /* 597122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 597133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 597137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 597145 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 597147 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 597151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 597153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597174 */     // (fminimum:{ *:[f32] } (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20186>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
     /* 597177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 597184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 597204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 597209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597215 */     GIR_RootConstrainSelectedInstOperands,
     /* 597216 */     // GIR_Coverage, 7768,
     /* 597216 */     GIR_EraseRootFromParent_Done,
     /* 597217 */   // Label 7494: @597217
     /* 597217 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(597284), // Rule ID 941 //
     /* 597222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 597233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 597240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597247 */     // (fminimum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20186>>  =>  (V_MINIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 597247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F32_e64),
     /* 597250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 597257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 597267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 597277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 597282 */     GIR_RootConstrainSelectedInstOperands,
     /* 597283 */     // GIR_Coverage, 941,
     /* 597283 */     GIR_EraseRootFromParent_Done,
     /* 597284 */   // Label 7495: @597284
     /* 597284 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(597351), // Rule ID 8462 //
     /* 597289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597296 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20186),
     /* 597300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 597314 */     // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20186>>  =>  (V_MINIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 597314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F32_e64),
     /* 597317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 597324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 597329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 597334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 597339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 597344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 597349 */     GIR_RootConstrainSelectedInstOperands,
     /* 597350 */     // GIR_Coverage, 8462,
     /* 597350 */     GIR_EraseRootFromParent_Done,
     /* 597351 */   // Label 7496: @597351
     /* 597351 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(597420), // Rule ID 2710 //
     /* 597356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3F32),
     /* 597359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597377 */     // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_MINIMUM3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1)
     /* 597377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM3_F32_e64),
     /* 597380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 597387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597418 */     GIR_RootConstrainSelectedInstOperands,
     /* 597419 */     // GIR_Coverage, 2710,
     /* 597419 */     GIR_EraseRootFromParent_Done,
     /* 597420 */   // Label 7497: @597420
     /* 597420 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(597451), // Rule ID 114 //
     /* 597425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 597432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 597436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 597440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13804),
     /* 597444 */     // (fminimum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13804>>  =>  (S_MINIMUM_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 597444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MINIMUM_F32),
     /* 597449 */     GIR_RootConstrainSelectedInstOperands,
     /* 597450 */     // GIR_Coverage, 114,
     /* 597450 */     GIR_Done,
     /* 597451 */   // Label 7498: @597451
     /* 597451 */   GIM_Reject,
     /* 597452 */ // Label 7490: @597452
     /* 597452 */ GIM_Reject,
     /* 597453 */ // Label 7474: @597453
     /* 597453 */ GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(597587),
     /* 597458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 597461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 597464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 597468 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(597527), // Rule ID 949 //
     /* 597473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 597483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597490 */     // (fminimum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MINIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 597490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F64_e64),
     /* 597493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 597500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 597510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 597520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 597525 */     GIR_RootConstrainSelectedInstOperands,
     /* 597526 */     // GIR_Coverage, 949,
     /* 597526 */     GIR_EraseRootFromParent_Done,
     /* 597527 */   // Label 7500: @597527
     /* 597527 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(597586), // Rule ID 8464 //
     /* 597532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 597549 */     // (fminimum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MINIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 597549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F64_e64),
     /* 597552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 597559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 597564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 597569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 597574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 597579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 597584 */     GIR_RootConstrainSelectedInstOperands,
     /* 597585 */     // GIR_Coverage, 8464,
     /* 597585 */     GIR_EraseRootFromParent_Done,
     /* 597586 */   // Label 7501: @597586
     /* 597586 */   GIM_Reject,
     /* 597587 */ // Label 7499: @597587
     /* 597587 */ GIM_Reject,
     /* 597588 */ // Label 7475: @597588
     /* 597588 */ GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(597742),
     /* 597593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 597596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 597599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597603 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(597677), // Rule ID 2728 //
     /* 597608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3PKF16),
     /* 597611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 597618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 597625 */     // (fminimum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_PK_MINIMUM3_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[v2f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1)
     /* 597625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MINIMUM3_F16),
     /* 597628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 597635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597675 */     GIR_RootConstrainSelectedInstOperands,
     /* 597676 */     // GIR_Coverage, 2728,
     /* 597676 */     GIR_EraseRootFromParent_Done,
     /* 597677 */   // Label 7503: @597677
     /* 597677 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(597741), // Rule ID 1105 //
     /* 597682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 597685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 597692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 597699 */     // (fminimum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MINIMUM_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 597699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MINIMUM_F16),
     /* 597702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 597709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 597719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597739 */     GIR_RootConstrainSelectedInstOperands,
     /* 597740 */     // GIR_Coverage, 1105,
     /* 597740 */     GIR_EraseRootFromParent_Done,
     /* 597741 */   // Label 7504: @597741
     /* 597741 */   GIM_Reject,
     /* 597742 */ // Label 7502: @597742
     /* 597742 */ GIM_Reject,
     /* 597743 */ // Label 7476: @597743
     /* 597743 */ GIM_Reject,
     /* 597744 */ // Label 85: @597744
     /* 597744 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7509*/ GIMT_Encode4(599870),
     /* 597755 */ /*GILLT_s16*//*Label 7505*/ GIMT_Encode4(597771),
     /* 597759 */ /*GILLT_s32*//*Label 7506*/ GIMT_Encode4(598901),
     /* 597763 */ /*GILLT_s64*//*Label 7507*/ GIMT_Encode4(599580),
     /* 597767 */ /*GILLT_v2s16*//*Label 7508*/ GIMT_Encode4(599715),
     /* 597771 */ // Label 7505: @597771
     /* 597771 */ GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(598900),
     /* 597776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 597779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 597782 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(597901), // Rule ID 13439 //
     /* 597787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 597790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 597794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 597798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 597802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 597806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 597810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 597814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 597818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 597822 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 597824 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 597828 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 597832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 597834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597841 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597848 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597855 */     // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35005>>)<<P:Predicate_anonymous_20189>>  =>  (V_MINIMUMMAXIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_t16_e64),
     /* 597858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 597865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 597870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 597875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 597880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 597885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 597890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597899 */     GIR_RootConstrainSelectedInstOperands,
     /* 597900 */     // GIR_Coverage, 13439,
     /* 597900 */     GIR_EraseRootFromParent_Done,
     /* 597901 */   // Label 7511: @597901
     /* 597901 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(598020), // Rule ID 13443 //
     /* 597906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 597909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 597917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 597921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 597925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 597929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 597933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 597937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 597941 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 597943 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 597947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 597951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 597953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597974 */     // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35005>>)<<P:Predicate_anonymous_20189>>  =>  (V_MINIMUMMAXIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_fake16_e64),
     /* 597977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 597984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 597989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 597994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 597999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 598004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 598009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598018 */     GIR_RootConstrainSelectedInstOperands,
     /* 598019 */     // GIR_Coverage, 13443,
     /* 598019 */     GIR_EraseRootFromParent_Done,
     /* 598020 */   // Label 7512: @598020
     /* 598020 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(598139), // Rule ID 7773 //
     /* 598025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 598028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 598032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 598040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 598056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 598060 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 598062 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 598066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 598070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 598072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598093 */     // (fmaximum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20189>>  =>  (V_MINIMUMMAXIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_t16_e64),
     /* 598096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 598103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 598113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598137 */     GIR_RootConstrainSelectedInstOperands,
     /* 598138 */     // GIR_Coverage, 7773,
     /* 598138 */     GIR_EraseRootFromParent_Done,
     /* 598139 */   // Label 7513: @598139
     /* 598139 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(598258), // Rule ID 7777 //
     /* 598144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 598147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 598159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 598175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 598179 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 598181 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 598185 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 598189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 598191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598198 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598212 */     // (fmaximum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20189>>  =>  (V_MINIMUMMAXIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_fake16_e64),
     /* 598215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 598222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 598232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598256 */     GIR_RootConstrainSelectedInstOperands,
     /* 598257 */     // GIR_Coverage, 7777,
     /* 598257 */     GIR_EraseRootFromParent_Done,
     /* 598258 */   // Label 7514: @598258
     /* 598258 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(598361), // Rule ID 13437 //
     /* 598263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 598266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 598270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 598274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 598286 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 598288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 598292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 598294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598315 */     // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_20189>>  =>  (V_MINIMUMMAXIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_t16_e64),
     /* 598318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 598325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 598330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 598335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 598340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 598345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 598350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598359 */     GIR_RootConstrainSelectedInstOperands,
     /* 598360 */     // GIR_Coverage, 13437,
     /* 598360 */     GIR_EraseRootFromParent_Done,
     /* 598361 */   // Label 7515: @598361
     /* 598361 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(598464), // Rule ID 13441 //
     /* 598366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 598369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 598377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 598389 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 598391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 598395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 598397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598418 */     // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_20189>>  =>  (V_MINIMUMMAXIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_fake16_e64),
     /* 598421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 598428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 598433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 598438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 598443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 598448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 598453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598462 */     GIR_RootConstrainSelectedInstOperands,
     /* 598463 */     // GIR_Coverage, 13441,
     /* 598463 */     GIR_EraseRootFromParent_Done,
     /* 598464 */   // Label 7516: @598464
     /* 598464 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(598567), // Rule ID 7771 //
     /* 598469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 598472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 598476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 598492 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 598494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 598498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 598500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598521 */     // (fmaximum:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20189>>  =>  (V_MINIMUMMAXIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_t16_e64),
     /* 598524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 598531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 598541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598565 */     GIR_RootConstrainSelectedInstOperands,
     /* 598566 */     // GIR_Coverage, 7771,
     /* 598566 */     GIR_EraseRootFromParent_Done,
     /* 598567 */   // Label 7517: @598567
     /* 598567 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(598670), // Rule ID 7775 //
     /* 598572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 598575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 598591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 598595 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 598597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 598601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 598603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598624 */     // (fmaximum:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20189>>  =>  (V_MINIMUMMAXIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_fake16_e64),
     /* 598627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 598634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 598644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598668 */     GIR_RootConstrainSelectedInstOperands,
     /* 598669 */     // GIR_Coverage, 7775,
     /* 598669 */     GIR_EraseRootFromParent_Done,
     /* 598670 */   // Label 7518: @598670
     /* 598670 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(598736), // Rule ID 946 //
     /* 598675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX12Plus),
     /* 598678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598682 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 598686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 598693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 598700 */     // (fmaximum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20189>>  =>  (V_MAXIMUM_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 598700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F16_e64),
     /* 598703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 598710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 598720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598734 */     GIR_RootConstrainSelectedInstOperands,
     /* 598735 */     // GIR_Coverage, 946,
     /* 598735 */     GIR_EraseRootFromParent_Done,
     /* 598736 */   // Label 7519: @598736
     /* 598736 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(598802), // Rule ID 947 //
     /* 598741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 598744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 598748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 598752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 598759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 598766 */     // (fmaximum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20189>>  =>  (V_MAXIMUM_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 598766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F16_t16_e64),
     /* 598769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 598776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 598786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598800 */     GIR_RootConstrainSelectedInstOperands,
     /* 598801 */     // GIR_Coverage, 947,
     /* 598801 */     GIR_EraseRootFromParent_Done,
     /* 598802 */   // Label 7520: @598802
     /* 598802 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(598868), // Rule ID 948 //
     /* 598807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 598810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598814 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 598818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 598825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 598832 */     // (fmaximum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20189>>  =>  (V_MAXIMUM_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 598832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F16_fake16_e64),
     /* 598835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 598842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 598852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598866 */     GIR_RootConstrainSelectedInstOperands,
     /* 598867 */     // GIR_Coverage, 948,
     /* 598867 */     GIR_EraseRootFromParent_Done,
     /* 598868 */   // Label 7521: @598868
     /* 598868 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(598899), // Rule ID 117 //
     /* 598873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 598876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 598880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 598884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 598888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13805),
     /* 598892 */     // (fmaximum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13805>>  =>  (S_MAXIMUM_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 598892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAXIMUM_F16),
     /* 598897 */     GIR_RootConstrainSelectedInstOperands,
     /* 598898 */     // GIR_Coverage, 117,
     /* 598898 */     GIR_Done,
     /* 598899 */   // Label 7522: @598899
     /* 598899 */   GIM_Reject,
     /* 598900 */ // Label 7510: @598900
     /* 598900 */ GIM_Reject,
     /* 598901 */ // Label 7506: @598901
     /* 598901 */ GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(599579),
     /* 598906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 598909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 598912 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(599028), // Rule ID 13435 //
     /* 598917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 598920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 598928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 598932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 598936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 598944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 598948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 598952 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 598954 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 598958 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 598962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 598964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598971 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598985 */     // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35005>>)<<P:Predicate_anonymous_20189>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
     /* 598988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 598995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 599000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 599005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 599010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 599015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 599020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599026 */     GIR_RootConstrainSelectedInstOperands,
     /* 599027 */     // GIR_Coverage, 13435,
     /* 599027 */     GIR_EraseRootFromParent_Done,
     /* 599028 */   // Label 7524: @599028
     /* 599028 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(599144), // Rule ID 7769 //
     /* 599033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 599044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 599048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 599052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 599056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 599060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 599064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 599068 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 599070 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35005),
     /* 599074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 599078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 599080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599087 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599101 */     // (fmaximum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35005>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20189>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 599101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
     /* 599104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 599111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 599131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 599136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599142 */     GIR_RootConstrainSelectedInstOperands,
     /* 599143 */     // GIR_Coverage, 7769,
     /* 599143 */     GIR_EraseRootFromParent_Done,
     /* 599144 */   // Label 7525: @599144
     /* 599144 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(599244), // Rule ID 13433 //
     /* 599149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 599160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 599164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 599168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 599172 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 599174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 599178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 599180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599201 */     // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_20189>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 599201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
     /* 599204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 599211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 599216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 599221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 599226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 599231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 599236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599242 */     GIR_RootConstrainSelectedInstOperands,
     /* 599243 */     // GIR_Coverage, 13433,
     /* 599243 */     GIR_EraseRootFromParent_Done,
     /* 599244 */   // Label 7526: @599244
     /* 599244 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(599344), // Rule ID 7767 //
     /* 599249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 599260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 599264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 599268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 599272 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 599274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 599278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 599280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599301 */     // (fmaximum:{ *:[f32] } (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_20189>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 599301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
     /* 599304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 599311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 599331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 599336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599342 */     GIR_RootConstrainSelectedInstOperands,
     /* 599343 */     // GIR_Coverage, 7767,
     /* 599343 */     GIR_EraseRootFromParent_Done,
     /* 599344 */   // Label 7527: @599344
     /* 599344 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(599411), // Rule ID 942 //
     /* 599349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 599360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599374 */     // (fmaximum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_20189>>  =>  (V_MAXIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F32_e64),
     /* 599377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 599384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 599394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 599404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 599409 */     GIR_RootConstrainSelectedInstOperands,
     /* 599410 */     // GIR_Coverage, 942,
     /* 599410 */     GIR_EraseRootFromParent_Done,
     /* 599411 */   // Label 7528: @599411
     /* 599411 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(599478), // Rule ID 8463 //
     /* 599416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599423 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20189),
     /* 599427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599441 */     // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20189>>  =>  (V_MAXIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F32_e64),
     /* 599444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 599451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 599456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 599461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 599466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 599471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 599476 */     GIR_RootConstrainSelectedInstOperands,
     /* 599477 */     // GIR_Coverage, 8463,
     /* 599477 */     GIR_EraseRootFromParent_Done,
     /* 599478 */   // Label 7529: @599478
     /* 599478 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(599547), // Rule ID 2711 //
     /* 599483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3F32),
     /* 599486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599504 */     // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_MAXIMUM3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1)
     /* 599504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM3_F32_e64),
     /* 599507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 599514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599545 */     GIR_RootConstrainSelectedInstOperands,
     /* 599546 */     // GIR_Coverage, 2711,
     /* 599546 */     GIR_EraseRootFromParent_Done,
     /* 599547 */   // Label 7530: @599547
     /* 599547 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(599578), // Rule ID 115 //
     /* 599552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 599559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 599563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 599567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13805),
     /* 599571 */     // (fmaximum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13805>>  =>  (S_MAXIMUM_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 599571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAXIMUM_F32),
     /* 599576 */     GIR_RootConstrainSelectedInstOperands,
     /* 599577 */     // GIR_Coverage, 115,
     /* 599577 */     GIR_Done,
     /* 599578 */   // Label 7531: @599578
     /* 599578 */   GIM_Reject,
     /* 599579 */ // Label 7523: @599579
     /* 599579 */ GIM_Reject,
     /* 599580 */ // Label 7507: @599580
     /* 599580 */ GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(599714),
     /* 599585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 599588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 599591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 599595 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(599654), // Rule ID 950 //
     /* 599600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599617 */     // (fmaximum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAXIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F64_e64),
     /* 599620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 599627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 599637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 599647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 599652 */     GIR_RootConstrainSelectedInstOperands,
     /* 599653 */     // GIR_Coverage, 950,
     /* 599653 */     GIR_EraseRootFromParent_Done,
     /* 599654 */   // Label 7533: @599654
     /* 599654 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(599713), // Rule ID 8465 //
     /* 599659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599676 */     // (fmaximum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAXIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F64_e64),
     /* 599679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 599686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 599691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 599696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 599701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 599706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 599711 */     GIR_RootConstrainSelectedInstOperands,
     /* 599712 */     // GIR_Coverage, 8465,
     /* 599712 */     GIR_EraseRootFromParent_Done,
     /* 599713 */   // Label 7534: @599713
     /* 599713 */   GIM_Reject,
     /* 599714 */ // Label 7532: @599714
     /* 599714 */ GIM_Reject,
     /* 599715 */ // Label 7508: @599715
     /* 599715 */ GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(599869),
     /* 599720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 599723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 599726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599730 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(599804), // Rule ID 2729 //
     /* 599735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3PKF16),
     /* 599738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 599745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 599752 */     // (fmaximum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_PK_MAXIMUM3_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[v2f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1)
     /* 599752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAXIMUM3_F16),
     /* 599755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 599762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599802 */     GIR_RootConstrainSelectedInstOperands,
     /* 599803 */     // GIR_Coverage, 2729,
     /* 599803 */     GIR_EraseRootFromParent_Done,
     /* 599804 */   // Label 7536: @599804
     /* 599804 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(599868), // Rule ID 1104 //
     /* 599809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 599819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 599826 */     // (fmaximum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAXIMUM_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 599826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAXIMUM_F16),
     /* 599829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 599836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 599846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599866 */     GIR_RootConstrainSelectedInstOperands,
     /* 599867 */     // GIR_Coverage, 1104,
     /* 599867 */     GIR_EraseRootFromParent_Done,
     /* 599868 */   // Label 7537: @599868
     /* 599868 */   GIM_Reject,
     /* 599869 */ // Label 7535: @599869
     /* 599869 */ GIM_Reject,
     /* 599870 */ // Label 7509: @599870
     /* 599870 */ GIM_Reject,
     /* 599871 */ // Label 86: @599871
     /* 599871 */ GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(599994),
     /* 599876 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 599879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 599883 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(599938), // Rule ID 1874 //
     /* 599888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 599891 */     // (get_fpmode:{ *:[i32] })  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } 8909823:{ *:[i32] }, (S_GETREG_B32:{ *:[i1] } 47105:{ *:[i32] }))
     /* 599891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 599894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
     /* 599898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 599903 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(47105),
     /* 599913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 599915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 599918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 599920 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(8909823),
     /* 599930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 599933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 599936 */     GIR_RootConstrainSelectedInstOperands,
     /* 599937 */     // GIR_Coverage, 1874,
     /* 599937 */     GIR_EraseRootFromParent_Done,
     /* 599938 */   // Label 7539: @599938
     /* 599938 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(599993), // Rule ID 1875 //
     /* 599943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 599946 */     // (get_fpmode:{ *:[i32] })  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } 521215:{ *:[i32] }, (S_GETREG_B32:{ *:[i1] } 36865:{ *:[i32] }))
     /* 599946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 599949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
     /* 599953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 599958 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(36865),
     /* 599968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 599970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 599973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 599975 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(521215),
     /* 599985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 599988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 599991 */     GIR_RootConstrainSelectedInstOperands,
     /* 599992 */     // GIR_Coverage, 1875,
     /* 599992 */     GIR_EraseRootFromParent_Done,
     /* 599993 */   // Label 7540: @599993
     /* 599993 */   GIM_Reject,
     /* 599994 */ // Label 7538: @599994
     /* 599994 */ GIM_Reject,
     /* 599995 */ // Label 87: @599995
     /* 599995 */ GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(600071), // Rule ID 2594 //
     /* 600000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 600003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 600006 */   // MIs[0] DstI[vdst]
     /* 600006 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /* 600010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600014 */   // MIs[0] Operand 1
     /* 600014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 600018 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600022 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_PTR_ADD),
     /* 600026 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 600030 */   GIM_CheckHasOneUse, /*MI*/1,
     /* 600032 */   // MIs[1] src0
     /* 600032 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/32,
     /* 600036 */   GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /* 600040 */   GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /* 600044 */   GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:4:z
     /* 600048 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20816),
     /* 600052 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 600054 */   // (ptradd:{ *:[i32] } (ptradd:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:4:x, i32:{ *:[i32] }:$src1:$pred:4:y)<<P:Predicate_anonymous_20817>>, i32:{ *:[i32] }:$src2:$pred:4:z)<<P:4:Predicate_anonymous_20816>>  =>  (V_ADD3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 600054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD3_U32_e64),
     /* 600057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600059 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 600063 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 600067 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 600069 */   GIR_RootConstrainSelectedInstOperands,
     /* 600070 */   // GIR_Coverage, 2594,
     /* 600070 */   GIR_EraseRootFromParent_Done,
     /* 600071 */ // Label 7541: @600071
     /* 600071 */ GIM_Reject,
     /* 600072 */ // Label 88: @600072
     /* 600072 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7545*/ GIMT_Encode4(606435),
     /* 600083 */ /*GILLT_s16*//*Label 7542*/ GIMT_Encode4(600099),
     /* 600087 */ /*GILLT_s32*//*Label 7543*/ GIMT_Encode4(604918), GIMT_Encode4(0),
     /* 600095 */ /*GILLT_v2s16*//*Label 7544*/ GIMT_Encode4(606363),
     /* 600099 */ // Label 7542: @600099
     /* 600099 */ GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(604917),
     /* 600104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 600107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 600110 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(600208), // Rule ID 11783 //
     /* 600115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 600118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600162 */     // MIs[3] src0
     /* 600162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600167 */     // MIs[3] src1
     /* 600167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600174 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 600177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 600186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 600193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600206 */     GIR_RootConstrainSelectedInstOperands,
     /* 600207 */     // GIR_Coverage, 11783,
     /* 600207 */     GIR_EraseRootFromParent_Done,
     /* 600208 */   // Label 7547: @600208
     /* 600208 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(600306), // Rule ID 11784 //
     /* 600213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 600216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600260 */     // MIs[3] src1
     /* 600260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600265 */     // MIs[3] src0
     /* 600265 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600270 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600272 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 600275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 600284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 600291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600304 */     GIR_RootConstrainSelectedInstOperands,
     /* 600305 */     // GIR_Coverage, 11784,
     /* 600305 */     GIR_EraseRootFromParent_Done,
     /* 600306 */   // Label 7548: @600306
     /* 600306 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(600404), // Rule ID 11785 //
     /* 600311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 600314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600346 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600358 */     // MIs[3] src0
     /* 600358 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600363 */     // MIs[3] src1
     /* 600363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600370 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 600373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 600382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 600389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600402 */     GIR_RootConstrainSelectedInstOperands,
     /* 600403 */     // GIR_Coverage, 11785,
     /* 600403 */     GIR_EraseRootFromParent_Done,
     /* 600404 */   // Label 7549: @600404
     /* 600404 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(600502), // Rule ID 11786 //
     /* 600409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 600412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600456 */     // MIs[3] src1
     /* 600456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600461 */     // MIs[3] src0
     /* 600461 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600468 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 600471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 600480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 600487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600500 */     GIR_RootConstrainSelectedInstOperands,
     /* 600501 */     // GIR_Coverage, 11786,
     /* 600501 */     GIR_EraseRootFromParent_Done,
     /* 600502 */   // Label 7550: @600502
     /* 600502 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(600600), // Rule ID 13335 //
     /* 600507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 600510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 600514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600554 */     // MIs[3] src0
     /* 600554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600559 */     // MIs[3] src1
     /* 600559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600566 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 600569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 600578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 600585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600598 */     GIR_RootConstrainSelectedInstOperands,
     /* 600599 */     // GIR_Coverage, 13335,
     /* 600599 */     GIR_EraseRootFromParent_Done,
     /* 600600 */   // Label 7551: @600600
     /* 600600 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(600698), // Rule ID 13336 //
     /* 600605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 600608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 600612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600652 */     // MIs[3] src1
     /* 600652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600657 */     // MIs[3] src0
     /* 600657 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600662 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600664 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 600667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 600676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 600683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600696 */     GIR_RootConstrainSelectedInstOperands,
     /* 600697 */     // GIR_Coverage, 13336,
     /* 600697 */     GIR_EraseRootFromParent_Done,
     /* 600698 */   // Label 7552: @600698
     /* 600698 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(600796), // Rule ID 13337 //
     /* 600703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 600706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 600710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600738 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600750 */     // MIs[3] src0
     /* 600750 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600755 */     // MIs[3] src1
     /* 600755 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600762 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 600765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 600774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 600781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600794 */     GIR_RootConstrainSelectedInstOperands,
     /* 600795 */     // GIR_Coverage, 13337,
     /* 600795 */     GIR_EraseRootFromParent_Done,
     /* 600796 */   // Label 7553: @600796
     /* 600796 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(600894), // Rule ID 13338 //
     /* 600801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 600804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 600808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600848 */     // MIs[3] src1
     /* 600848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600853 */     // MIs[3] src0
     /* 600853 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600860 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 600863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 600872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 600879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600892 */     GIR_RootConstrainSelectedInstOperands,
     /* 600893 */     // GIR_Coverage, 13338,
     /* 600893 */     GIR_EraseRootFromParent_Done,
     /* 600894 */   // Label 7554: @600894
     /* 600894 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(600992), // Rule ID 13395 //
     /* 600899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 600902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 600930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 600942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 600946 */     // MIs[3] src0
     /* 600946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 600951 */     // MIs[3] src1
     /* 600951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 600956 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 600958 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 600958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 600961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 600970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 600977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 600984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600990 */     GIR_RootConstrainSelectedInstOperands,
     /* 600991 */     // GIR_Coverage, 13395,
     /* 600991 */     GIR_EraseRootFromParent_Done,
     /* 600992 */   // Label 7555: @600992
     /* 600992 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(601090), // Rule ID 13396 //
     /* 600997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 601000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 601024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601044 */     // MIs[3] src1
     /* 601044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601049 */     // MIs[3] src0
     /* 601049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601056 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 601059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 601068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 601075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 601082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601088 */     GIR_RootConstrainSelectedInstOperands,
     /* 601089 */     // GIR_Coverage, 13396,
     /* 601089 */     GIR_EraseRootFromParent_Done,
     /* 601090 */   // Label 7556: @601090
     /* 601090 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(601188), // Rule ID 13397 //
     /* 601095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 601098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 601122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601142 */     // MIs[3] src0
     /* 601142 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601147 */     // MIs[3] src1
     /* 601147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601154 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 601157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 601166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 601173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 601180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601186 */     GIR_RootConstrainSelectedInstOperands,
     /* 601187 */     // GIR_Coverage, 13397,
     /* 601187 */     GIR_EraseRootFromParent_Done,
     /* 601188 */   // Label 7557: @601188
     /* 601188 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(601286), // Rule ID 13398 //
     /* 601193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 601196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 601220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601240 */     // MIs[3] src1
     /* 601240 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601245 */     // MIs[3] src0
     /* 601245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601252 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 601255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 601264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 601271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 601278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601284 */     GIR_RootConstrainSelectedInstOperands,
     /* 601285 */     // GIR_Coverage, 13398,
     /* 601285 */     GIR_EraseRootFromParent_Done,
     /* 601286 */   // Label 7558: @601286
     /* 601286 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(601384), // Rule ID 11787 //
     /* 601291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 601294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 601318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601338 */     // MIs[3] src0
     /* 601338 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601343 */     // MIs[3] src1
     /* 601343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601350 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 601353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 601362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 601369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 601376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601382 */     GIR_RootConstrainSelectedInstOperands,
     /* 601383 */     // GIR_Coverage, 11787,
     /* 601383 */     GIR_EraseRootFromParent_Done,
     /* 601384 */   // Label 7559: @601384
     /* 601384 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(601482), // Rule ID 11788 //
     /* 601389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 601392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 601416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601436 */     // MIs[3] src1
     /* 601436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601441 */     // MIs[3] src0
     /* 601441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601448 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 601451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 601460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 601467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 601474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601480 */     GIR_RootConstrainSelectedInstOperands,
     /* 601481 */     // GIR_Coverage, 11788,
     /* 601481 */     GIR_EraseRootFromParent_Done,
     /* 601482 */   // Label 7560: @601482
     /* 601482 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(601580), // Rule ID 11789 //
     /* 601487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 601490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 601514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601534 */     // MIs[3] src0
     /* 601534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601539 */     // MIs[3] src1
     /* 601539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601546 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 601549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 601558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 601565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 601572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601578 */     GIR_RootConstrainSelectedInstOperands,
     /* 601579 */     // GIR_Coverage, 11789,
     /* 601579 */     GIR_EraseRootFromParent_Done,
     /* 601580 */   // Label 7561: @601580
     /* 601580 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(601678), // Rule ID 11790 //
     /* 601585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 601588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 601612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601632 */     // MIs[3] src1
     /* 601632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601637 */     // MIs[3] src0
     /* 601637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601644 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 601647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 601656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 601663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 601670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601676 */     GIR_RootConstrainSelectedInstOperands,
     /* 601677 */     // GIR_Coverage, 11790,
     /* 601677 */     GIR_EraseRootFromParent_Done,
     /* 601678 */   // Label 7562: @601678
     /* 601678 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(601776), // Rule ID 13339 //
     /* 601683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 601686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 601690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 601710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601730 */     // MIs[3] src0
     /* 601730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601735 */     // MIs[3] src1
     /* 601735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601742 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 601745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 601754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 601761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 601768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601774 */     GIR_RootConstrainSelectedInstOperands,
     /* 601775 */     // GIR_Coverage, 13339,
     /* 601775 */     GIR_EraseRootFromParent_Done,
     /* 601776 */   // Label 7563: @601776
     /* 601776 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(601874), // Rule ID 13340 //
     /* 601781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 601784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 601788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 601808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601828 */     // MIs[3] src1
     /* 601828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601833 */     // MIs[3] src0
     /* 601833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601840 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 601843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 601852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 601859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 601866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601872 */     GIR_RootConstrainSelectedInstOperands,
     /* 601873 */     // GIR_Coverage, 13340,
     /* 601873 */     GIR_EraseRootFromParent_Done,
     /* 601874 */   // Label 7564: @601874
     /* 601874 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(601972), // Rule ID 13341 //
     /* 601879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 601882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 601886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 601902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 601906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 601910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 601914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 601918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 601922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601926 */     // MIs[3] src0
     /* 601926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 601931 */     // MIs[3] src1
     /* 601931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 601936 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 601938 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 601938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 601941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 601950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 601957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 601964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601970 */     GIR_RootConstrainSelectedInstOperands,
     /* 601971 */     // GIR_Coverage, 13341,
     /* 601971 */     GIR_EraseRootFromParent_Done,
     /* 601972 */   // Label 7565: @601972
     /* 601972 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(602070), // Rule ID 13342 //
     /* 601977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 601980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 601984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 601992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 601996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 602004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 602020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602024 */     // MIs[3] src1
     /* 602024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 602029 */     // MIs[3] src0
     /* 602029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 602034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602036 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 602039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 602048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 602055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 602062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602068 */     GIR_RootConstrainSelectedInstOperands,
     /* 602069 */     // GIR_Coverage, 13342,
     /* 602069 */     GIR_EraseRootFromParent_Done,
     /* 602070 */   // Label 7566: @602070
     /* 602070 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(602168), // Rule ID 13399 //
     /* 602075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 602078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 602102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 602118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602122 */     // MIs[3] src0
     /* 602122 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 602127 */     // MIs[3] src1
     /* 602127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 602132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602134 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 602137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 602146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 602153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 602160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602166 */     GIR_RootConstrainSelectedInstOperands,
     /* 602167 */     // GIR_Coverage, 13399,
     /* 602167 */     GIR_EraseRootFromParent_Done,
     /* 602168 */   // Label 7567: @602168
     /* 602168 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(602266), // Rule ID 13400 //
     /* 602173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 602176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 602200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 602216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602220 */     // MIs[3] src1
     /* 602220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 602225 */     // MIs[3] src0
     /* 602225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 602230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602232 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 602235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 602244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 602251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 602258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602264 */     GIR_RootConstrainSelectedInstOperands,
     /* 602265 */     // GIR_Coverage, 13400,
     /* 602265 */     GIR_EraseRootFromParent_Done,
     /* 602266 */   // Label 7568: @602266
     /* 602266 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(602364), // Rule ID 13401 //
     /* 602271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 602274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 602298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 602314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602318 */     // MIs[3] src0
     /* 602318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 602323 */     // MIs[3] src1
     /* 602323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 602328 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602330 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 602333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 602342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 602349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 602356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602362 */     GIR_RootConstrainSelectedInstOperands,
     /* 602363 */     // GIR_Coverage, 13401,
     /* 602363 */     GIR_EraseRootFromParent_Done,
     /* 602364 */   // Label 7569: @602364
     /* 602364 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(602462), // Rule ID 13402 //
     /* 602369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 602372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 602396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 602412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602416 */     // MIs[3] src1
     /* 602416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 602421 */     // MIs[3] src0
     /* 602421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 602426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602428 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 602431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 602440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 602447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 602454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602460 */     GIR_RootConstrainSelectedInstOperands,
     /* 602461 */     // GIR_Coverage, 13402,
     /* 602461 */     GIR_EraseRootFromParent_Done,
     /* 602462 */   // Label 7570: @602462
     /* 602462 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(602560), // Rule ID 7608 //
     /* 602467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 602470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 602494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 602510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602514 */     // MIs[3] src0
     /* 602514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 602519 */     // MIs[3] src1
     /* 602519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 602524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602526 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 602529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 602538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 602545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 602552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602558 */     GIR_RootConstrainSelectedInstOperands,
     /* 602559 */     // GIR_Coverage, 7608,
     /* 602559 */     GIR_EraseRootFromParent_Done,
     /* 602560 */   // Label 7571: @602560
     /* 602560 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(602658), // Rule ID 7760 //
     /* 602565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 602568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 602572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 602592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 602608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602612 */     // MIs[3] src0
     /* 602612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 602617 */     // MIs[3] src1
     /* 602617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 602622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602624 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 602627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 602636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 602643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 602650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602656 */     GIR_RootConstrainSelectedInstOperands,
     /* 602657 */     // GIR_Coverage, 7760,
     /* 602657 */     GIR_EraseRootFromParent_Done,
     /* 602658 */   // Label 7572: @602658
     /* 602658 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(602756), // Rule ID 7764 //
     /* 602663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 602666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 602690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 602706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602710 */     // MIs[3] src0
     /* 602710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 602715 */     // MIs[3] src1
     /* 602715 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 602720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602722 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 602725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 602734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 602741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 602748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602754 */     GIR_RootConstrainSelectedInstOperands,
     /* 602755 */     // GIR_Coverage, 7764,
     /* 602755 */     GIR_EraseRootFromParent_Done,
     /* 602756 */   // Label 7573: @602756
     /* 602756 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(602854), // Rule ID 11776 //
     /* 602761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 602764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 602788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 602804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602808 */     // MIs[3] src1
     /* 602808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 602813 */     // MIs[3] src0
     /* 602813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 602818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602820 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 602823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 602832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 602839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 602846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602852 */     GIR_RootConstrainSelectedInstOperands,
     /* 602853 */     // GIR_Coverage, 11776,
     /* 602853 */     GIR_EraseRootFromParent_Done,
     /* 602854 */   // Label 7574: @602854
     /* 602854 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(602952), // Rule ID 11779 //
     /* 602859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 602862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 602886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 602902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 602906 */     // MIs[3] src0
     /* 602906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 602911 */     // MIs[3] src1
     /* 602911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 602916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 602918 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 602918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 602921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 602930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 602937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 602944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602950 */     GIR_RootConstrainSelectedInstOperands,
     /* 602951 */     // GIR_Coverage, 11779,
     /* 602951 */     GIR_EraseRootFromParent_Done,
     /* 602952 */   // Label 7575: @602952
     /* 602952 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(603050), // Rule ID 11780 //
     /* 602957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 602960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 602984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 602988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603004 */     // MIs[3] src1
     /* 603004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603009 */     // MIs[3] src0
     /* 603009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603016 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 603019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 603028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 603035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603048 */     GIR_RootConstrainSelectedInstOperands,
     /* 603049 */     // GIR_Coverage, 11780,
     /* 603049 */     GIR_EraseRootFromParent_Done,
     /* 603050 */   // Label 7576: @603050
     /* 603050 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(603148), // Rule ID 13328 //
     /* 603055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 603058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 603062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603102 */     // MIs[3] src1
     /* 603102 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603107 */     // MIs[3] src0
     /* 603107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603114 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 603117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 603126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 603133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603146 */     GIR_RootConstrainSelectedInstOperands,
     /* 603147 */     // GIR_Coverage, 13328,
     /* 603147 */     GIR_EraseRootFromParent_Done,
     /* 603148 */   // Label 7577: @603148
     /* 603148 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(603246), // Rule ID 13331 //
     /* 603153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 603156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 603160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603200 */     // MIs[3] src0
     /* 603200 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603205 */     // MIs[3] src1
     /* 603205 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603212 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 603215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 603224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 603231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603244 */     GIR_RootConstrainSelectedInstOperands,
     /* 603245 */     // GIR_Coverage, 13331,
     /* 603245 */     GIR_EraseRootFromParent_Done,
     /* 603246 */   // Label 7578: @603246
     /* 603246 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(603344), // Rule ID 13332 //
     /* 603251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 603254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 603258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603298 */     // MIs[3] src1
     /* 603298 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603303 */     // MIs[3] src0
     /* 603303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603310 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 603313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 603322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 603329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603342 */     GIR_RootConstrainSelectedInstOperands,
     /* 603343 */     // GIR_Coverage, 13332,
     /* 603343 */     GIR_EraseRootFromParent_Done,
     /* 603344 */   // Label 7579: @603344
     /* 603344 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(603442), // Rule ID 13388 //
     /* 603349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 603352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603396 */     // MIs[3] src1
     /* 603396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603401 */     // MIs[3] src0
     /* 603401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603408 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 603411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 603420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 603427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603440 */     GIR_RootConstrainSelectedInstOperands,
     /* 603441 */     // GIR_Coverage, 13388,
     /* 603441 */     GIR_EraseRootFromParent_Done,
     /* 603442 */   // Label 7580: @603442
     /* 603442 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(603540), // Rule ID 13391 //
     /* 603447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 603450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603494 */     // MIs[3] src0
     /* 603494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603499 */     // MIs[3] src1
     /* 603499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603506 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 603509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 603518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 603525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603538 */     GIR_RootConstrainSelectedInstOperands,
     /* 603539 */     // GIR_Coverage, 13391,
     /* 603539 */     GIR_EraseRootFromParent_Done,
     /* 603540 */   // Label 7581: @603540
     /* 603540 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(603638), // Rule ID 13392 //
     /* 603545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 603548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 603588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603592 */     // MIs[3] src1
     /* 603592 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603597 */     // MIs[3] src0
     /* 603597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603602 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603604 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 603607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 603616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 603623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 603630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603636 */     GIR_RootConstrainSelectedInstOperands,
     /* 603637 */     // GIR_Coverage, 13392,
     /* 603637 */     GIR_EraseRootFromParent_Done,
     /* 603638 */   // Label 7582: @603638
     /* 603638 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(603736), // Rule ID 11777 //
     /* 603643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 603646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 603686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603690 */     // MIs[3] src0
     /* 603690 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603695 */     // MIs[3] src1
     /* 603695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603702 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 603705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 603714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 603721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 603728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603734 */     GIR_RootConstrainSelectedInstOperands,
     /* 603735 */     // GIR_Coverage, 11777,
     /* 603735 */     GIR_EraseRootFromParent_Done,
     /* 603736 */   // Label 7583: @603736
     /* 603736 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(603834), // Rule ID 11778 //
     /* 603741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 603744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 603784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603788 */     // MIs[3] src1
     /* 603788 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603793 */     // MIs[3] src0
     /* 603793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603800 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 603803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 603812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 603819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 603826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603832 */     GIR_RootConstrainSelectedInstOperands,
     /* 603833 */     // GIR_Coverage, 11778,
     /* 603833 */     GIR_EraseRootFromParent_Done,
     /* 603834 */   // Label 7584: @603834
     /* 603834 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(603932), // Rule ID 11781 //
     /* 603839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 603842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 603882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603886 */     // MIs[3] src0
     /* 603886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603891 */     // MIs[3] src1
     /* 603891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603896 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603898 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 603901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 603910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 603917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 603924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603930 */     GIR_RootConstrainSelectedInstOperands,
     /* 603931 */     // GIR_Coverage, 11781,
     /* 603931 */     GIR_EraseRootFromParent_Done,
     /* 603932 */   // Label 7585: @603932
     /* 603932 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(604030), // Rule ID 11782 //
     /* 603937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 603940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 603964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 603968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 603972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 603976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 603980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 603984 */     // MIs[3] src1
     /* 603984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 603989 */     // MIs[3] src0
     /* 603989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 603994 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 603996 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 603996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 603999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 604008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 604015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604028 */     GIR_RootConstrainSelectedInstOperands,
     /* 604029 */     // GIR_Coverage, 11782,
     /* 604029 */     GIR_EraseRootFromParent_Done,
     /* 604030 */   // Label 7586: @604030
     /* 604030 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(604128), // Rule ID 13329 //
     /* 604035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 604038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 604042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604082 */     // MIs[3] src0
     /* 604082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604087 */     // MIs[3] src1
     /* 604087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604094 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 604097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 604106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 604113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604126 */     GIR_RootConstrainSelectedInstOperands,
     /* 604127 */     // GIR_Coverage, 13329,
     /* 604127 */     GIR_EraseRootFromParent_Done,
     /* 604128 */   // Label 7587: @604128
     /* 604128 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(604226), // Rule ID 13330 //
     /* 604133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 604136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 604140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604180 */     // MIs[3] src1
     /* 604180 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604185 */     // MIs[3] src0
     /* 604185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604192 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 604195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 604204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 604211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604224 */     GIR_RootConstrainSelectedInstOperands,
     /* 604225 */     // GIR_Coverage, 13330,
     /* 604225 */     GIR_EraseRootFromParent_Done,
     /* 604226 */   // Label 7588: @604226
     /* 604226 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(604324), // Rule ID 13333 //
     /* 604231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 604234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 604238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604278 */     // MIs[3] src0
     /* 604278 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604283 */     // MIs[3] src1
     /* 604283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604290 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 604293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 604302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 604309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604322 */     GIR_RootConstrainSelectedInstOperands,
     /* 604323 */     // GIR_Coverage, 13333,
     /* 604323 */     GIR_EraseRootFromParent_Done,
     /* 604324 */   // Label 7589: @604324
     /* 604324 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(604422), // Rule ID 13334 //
     /* 604329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 604332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 604336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604376 */     // MIs[3] src1
     /* 604376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604381 */     // MIs[3] src0
     /* 604381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604388 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 604391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 604400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 604407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604420 */     GIR_RootConstrainSelectedInstOperands,
     /* 604421 */     // GIR_Coverage, 13334,
     /* 604421 */     GIR_EraseRootFromParent_Done,
     /* 604422 */   // Label 7590: @604422
     /* 604422 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(604520), // Rule ID 13389 //
     /* 604427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 604430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604474 */     // MIs[3] src0
     /* 604474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604479 */     // MIs[3] src1
     /* 604479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604486 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 604489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 604498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 604505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604518 */     GIR_RootConstrainSelectedInstOperands,
     /* 604519 */     // GIR_Coverage, 13389,
     /* 604519 */     GIR_EraseRootFromParent_Done,
     /* 604520 */   // Label 7591: @604520
     /* 604520 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(604618), // Rule ID 13390 //
     /* 604525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 604528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604572 */     // MIs[3] src1
     /* 604572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604577 */     // MIs[3] src0
     /* 604577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604584 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 604587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 604596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 604603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604616 */     GIR_RootConstrainSelectedInstOperands,
     /* 604617 */     // GIR_Coverage, 13390,
     /* 604617 */     GIR_EraseRootFromParent_Done,
     /* 604618 */   // Label 7592: @604618
     /* 604618 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(604716), // Rule ID 13393 //
     /* 604623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 604626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604670 */     // MIs[3] src0
     /* 604670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604675 */     // MIs[3] src1
     /* 604675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604682 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 604685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 604694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 604701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604714 */     GIR_RootConstrainSelectedInstOperands,
     /* 604715 */     // GIR_Coverage, 13393,
     /* 604715 */     GIR_EraseRootFromParent_Done,
     /* 604716 */   // Label 7593: @604716
     /* 604716 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(604814), // Rule ID 13394 //
     /* 604721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 604724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 604748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 604764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604768 */     // MIs[3] src1
     /* 604768 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 604773 */     // MIs[3] src0
     /* 604773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 604778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604780 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 604783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 604792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 604799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 604806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604812 */     GIR_RootConstrainSelectedInstOperands,
     /* 604813 */     // GIR_Coverage, 13394,
     /* 604813 */     GIR_EraseRootFromParent_Done,
     /* 604814 */   // Label 7594: @604814
     /* 604814 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(604870), // Rule ID 901 //
     /* 604819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 604822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 604826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 604833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 604840 */     // (smin:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 604840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_t16_e64),
     /* 604843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 604850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 604855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 604860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 604865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604868 */     GIR_RootConstrainSelectedInstOperands,
     /* 604869 */     // GIR_Coverage, 901,
     /* 604869 */     GIR_EraseRootFromParent_Done,
     /* 604870 */   // Label 7595: @604870
     /* 604870 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(604893), // Rule ID 900 //
     /* 604875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 604878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604882 */     // (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 604882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_e64),
     /* 604887 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 604891 */     GIR_RootConstrainSelectedInstOperands,
     /* 604892 */     // GIR_Coverage, 900,
     /* 604892 */     GIR_Done,
     /* 604893 */   // Label 7596: @604893
     /* 604893 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(604916), // Rule ID 902 //
     /* 604898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 604901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604905 */     // (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 604905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_fake16_e64),
     /* 604910 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 604914 */     GIR_RootConstrainSelectedInstOperands,
     /* 604915 */     // GIR_Coverage, 902,
     /* 604915 */     GIR_Done,
     /* 604916 */   // Label 7597: @604916
     /* 604916 */   GIM_Reject,
     /* 604917 */ // Label 7546: @604917
     /* 604917 */ GIM_Reject,
     /* 604918 */ // Label 7543: @604918
     /* 604918 */ GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(606362),
     /* 604923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 604926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 604929 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(605009), // Rule ID 11228 //
     /* 604934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 604950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 604954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 604958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 604966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 604970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 604974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604978 */     // MIs[3] src0
     /* 604978 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 604983 */     // MIs[3] src1
     /* 604983 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 604988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604990 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 604990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 604993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 604999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 605003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605007 */     GIR_RootConstrainSelectedInstOperands,
     /* 605008 */     // GIR_Coverage, 11228,
     /* 605008 */     GIR_EraseRootFromParent_Done,
     /* 605009 */   // Label 7599: @605009
     /* 605009 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(605089), // Rule ID 11229 //
     /* 605014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605058 */     // MIs[3] src1
     /* 605058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605063 */     // MIs[3] src0
     /* 605063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605070 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 605079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 605083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605087 */     GIR_RootConstrainSelectedInstOperands,
     /* 605088 */     // GIR_Coverage, 11229,
     /* 605088 */     GIR_EraseRootFromParent_Done,
     /* 605089 */   // Label 7600: @605089
     /* 605089 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(605169), // Rule ID 11230 //
     /* 605094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605138 */     // MIs[3] src0
     /* 605138 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605143 */     // MIs[3] src1
     /* 605143 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605150 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 605159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 605163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605167 */     GIR_RootConstrainSelectedInstOperands,
     /* 605168 */     // GIR_Coverage, 11230,
     /* 605168 */     GIR_EraseRootFromParent_Done,
     /* 605169 */   // Label 7601: @605169
     /* 605169 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(605249), // Rule ID 11231 //
     /* 605174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605218 */     // MIs[3] src1
     /* 605218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605223 */     // MIs[3] src0
     /* 605223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605230 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 605239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 605243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605247 */     GIR_RootConstrainSelectedInstOperands,
     /* 605248 */     // GIR_Coverage, 11231,
     /* 605248 */     GIR_EraseRootFromParent_Done,
     /* 605249 */   // Label 7602: @605249
     /* 605249 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(605329), // Rule ID 11232 //
     /* 605254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 605278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605298 */     // MIs[3] src0
     /* 605298 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605303 */     // MIs[3] src1
     /* 605303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605310 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 605319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 605323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 605327 */     GIR_RootConstrainSelectedInstOperands,
     /* 605328 */     // GIR_Coverage, 11232,
     /* 605328 */     GIR_EraseRootFromParent_Done,
     /* 605329 */   // Label 7603: @605329
     /* 605329 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(605409), // Rule ID 11233 //
     /* 605334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 605358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605378 */     // MIs[3] src1
     /* 605378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605383 */     // MIs[3] src0
     /* 605383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605390 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 605399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 605403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 605407 */     GIR_RootConstrainSelectedInstOperands,
     /* 605408 */     // GIR_Coverage, 11233,
     /* 605408 */     GIR_EraseRootFromParent_Done,
     /* 605409 */   // Label 7604: @605409
     /* 605409 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(605489), // Rule ID 11234 //
     /* 605414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 605438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605458 */     // MIs[3] src0
     /* 605458 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605463 */     // MIs[3] src1
     /* 605463 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605470 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 605479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 605483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 605487 */     GIR_RootConstrainSelectedInstOperands,
     /* 605488 */     // GIR_Coverage, 11234,
     /* 605488 */     GIR_EraseRootFromParent_Done,
     /* 605489 */   // Label 7605: @605489
     /* 605489 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(605569), // Rule ID 11235 //
     /* 605494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 605518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605538 */     // MIs[3] src1
     /* 605538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605543 */     // MIs[3] src0
     /* 605543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605550 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 605559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 605563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 605567 */     GIR_RootConstrainSelectedInstOperands,
     /* 605568 */     // GIR_Coverage, 11235,
     /* 605568 */     GIR_EraseRootFromParent_Done,
     /* 605569 */   // Label 7606: @605569
     /* 605569 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(605649), // Rule ID 7571 //
     /* 605574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 605598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 605614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605618 */     // MIs[3] src0
     /* 605618 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 605623 */     // MIs[3] src1
     /* 605623 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 605628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605630 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 605639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 605643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 605647 */     GIR_RootConstrainSelectedInstOperands,
     /* 605648 */     // GIR_Coverage, 7571,
     /* 605648 */     GIR_EraseRootFromParent_Done,
     /* 605649 */   // Label 7607: @605649
     /* 605649 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(605729), // Rule ID 11221 //
     /* 605654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 605678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 605694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605698 */     // MIs[3] src1
     /* 605698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 605703 */     // MIs[3] src0
     /* 605703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 605708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605710 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 605719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 605723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 605727 */     GIR_RootConstrainSelectedInstOperands,
     /* 605728 */     // GIR_Coverage, 11221,
     /* 605728 */     GIR_EraseRootFromParent_Done,
     /* 605729 */   // Label 7608: @605729
     /* 605729 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(605809), // Rule ID 11224 //
     /* 605734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 605758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 605774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605778 */     // MIs[3] src0
     /* 605778 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 605783 */     // MIs[3] src1
     /* 605783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 605788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605790 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 605799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 605803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 605807 */     GIR_RootConstrainSelectedInstOperands,
     /* 605808 */     // GIR_Coverage, 11224,
     /* 605808 */     GIR_EraseRootFromParent_Done,
     /* 605809 */   // Label 7609: @605809
     /* 605809 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(605889), // Rule ID 11225 //
     /* 605814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 605838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 605854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605858 */     // MIs[3] src1
     /* 605858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 605863 */     // MIs[3] src0
     /* 605863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 605868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605870 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 605879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 605883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 605887 */     GIR_RootConstrainSelectedInstOperands,
     /* 605888 */     // GIR_Coverage, 11225,
     /* 605888 */     GIR_EraseRootFromParent_Done,
     /* 605889 */   // Label 7610: @605889
     /* 605889 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(605969), // Rule ID 11222 //
     /* 605894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 605918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 605926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 605930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 605934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605938 */     // MIs[3] src0
     /* 605938 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 605943 */     // MIs[3] src1
     /* 605943 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 605948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605950 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 605950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 605953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 605959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 605963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 605967 */     GIR_RootConstrainSelectedInstOperands,
     /* 605968 */     // GIR_Coverage, 11222,
     /* 605968 */     GIR_EraseRootFromParent_Done,
     /* 605969 */   // Label 7611: @605969
     /* 605969 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(606049), // Rule ID 11223 //
     /* 605974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 605990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 605994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 605998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 606006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 606010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 606014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606018 */     // MIs[3] src1
     /* 606018 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 606023 */     // MIs[3] src0
     /* 606023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 606028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606030 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 606033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 606039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 606043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 606047 */     GIR_RootConstrainSelectedInstOperands,
     /* 606048 */     // GIR_Coverage, 11223,
     /* 606048 */     GIR_EraseRootFromParent_Done,
     /* 606049 */   // Label 7612: @606049
     /* 606049 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(606129), // Rule ID 11226 //
     /* 606054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 606070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 606074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 606078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 606086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 606090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 606094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606098 */     // MIs[3] src0
     /* 606098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 606103 */     // MIs[3] src1
     /* 606103 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 606108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606110 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 606113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 606119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 606123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 606127 */     GIR_RootConstrainSelectedInstOperands,
     /* 606128 */     // GIR_Coverage, 11226,
     /* 606128 */     GIR_EraseRootFromParent_Done,
     /* 606129 */   // Label 7613: @606129
     /* 606129 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(606209), // Rule ID 11227 //
     /* 606134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 606150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 606154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 606158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 606166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 606170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 606174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606178 */     // MIs[3] src1
     /* 606178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 606183 */     // MIs[3] src0
     /* 606183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 606188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606190 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 606193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 606199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 606203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 606207 */     GIR_RootConstrainSelectedInstOperands,
     /* 606208 */     // GIR_Coverage, 11227,
     /* 606208 */     GIR_EraseRootFromParent_Done,
     /* 606209 */   // Label 7614: @606209
     /* 606209 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(606262), // Rule ID 7705 //
     /* 606214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 606217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 606233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 606237 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 606239 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35007),
     /* 606243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 606245 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smax_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_35007>>  =>  (V_MAXMIN_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_I32_e64),
     /* 606248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 606254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 606258 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 606260 */     GIR_RootConstrainSelectedInstOperands,
     /* 606261 */     // GIR_Coverage, 7705,
     /* 606261 */     GIR_EraseRootFromParent_Done,
     /* 606262 */   // Label 7615: @606262
     /* 606262 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(606315), // Rule ID 13231 //
     /* 606267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 606270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 606278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 606286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 606290 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 606292 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35007),
     /* 606296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 606298 */     // (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smax_oneuse>>)<<P:Predicate_anonymous_35007>>  =>  (V_MAXMIN_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 606298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_I32_e64),
     /* 606301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 606307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 606311 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 606313 */     GIR_RootConstrainSelectedInstOperands,
     /* 606314 */     // GIR_Coverage, 13231,
     /* 606314 */     GIR_EraseRootFromParent_Done,
     /* 606315 */   // Label 7616: @606315
     /* 606315 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(606341), // Rule ID 47 //
     /* 606320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 606324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13780),
     /* 606328 */     // (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13780>>  =>  (S_MIN_I32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 606328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_I32),
     /* 606333 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 606339 */     GIR_RootConstrainSelectedInstOperands,
     /* 606340 */     // GIR_Coverage, 47,
     /* 606340 */     GIR_Done,
     /* 606341 */   // Label 7617: @606341
     /* 606341 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(606361), // Rule ID 804 //
     /* 606346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606350 */     // (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MIN_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 606350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I32_e64),
     /* 606355 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 606359 */     GIR_RootConstrainSelectedInstOperands,
     /* 606360 */     // GIR_Coverage, 804,
     /* 606360 */     GIR_Done,
     /* 606361 */   // Label 7618: @606361
     /* 606361 */   GIM_Reject,
     /* 606362 */ // Label 7598: @606362
     /* 606362 */ GIM_Reject,
     /* 606363 */ // Label 7544: @606363
     /* 606363 */ GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(606434), // Rule ID 1100 //
     /* 606368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 606371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 606374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606378 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 606385 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 606392 */   // (smin:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 606392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_I16),
     /* 606395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 606402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 606407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 606412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 606417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606432 */   GIR_RootConstrainSelectedInstOperands,
     /* 606433 */   // GIR_Coverage, 1100,
     /* 606433 */   GIR_EraseRootFromParent_Done,
     /* 606434 */ // Label 7619: @606434
     /* 606434 */ GIM_Reject,
     /* 606435 */ // Label 7545: @606435
     /* 606435 */ GIM_Reject,
     /* 606436 */ // Label 89: @606436
     /* 606436 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7623*/ GIMT_Encode4(612961),
     /* 606447 */ /*GILLT_s16*//*Label 7620*/ GIMT_Encode4(606463),
     /* 606451 */ /*GILLT_s32*//*Label 7621*/ GIMT_Encode4(611282), GIMT_Encode4(0),
     /* 606459 */ /*GILLT_v2s16*//*Label 7622*/ GIMT_Encode4(612889),
     /* 606463 */ // Label 7620: @606463
     /* 606463 */ GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(611281),
     /* 606468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 606471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 606474 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(606572), // Rule ID 11768 //
     /* 606479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 606482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 606506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606522 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606526 */     // MIs[3] src0
     /* 606526 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606531 */     // MIs[3] src1
     /* 606531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606538 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 606541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 606550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 606557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 606564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606570 */     GIR_RootConstrainSelectedInstOperands,
     /* 606571 */     // GIR_Coverage, 11768,
     /* 606571 */     GIR_EraseRootFromParent_Done,
     /* 606572 */   // Label 7625: @606572
     /* 606572 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(606670), // Rule ID 11769 //
     /* 606577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 606580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 606604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606624 */     // MIs[3] src1
     /* 606624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606629 */     // MIs[3] src0
     /* 606629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606636 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 606639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 606648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 606655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 606662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606668 */     GIR_RootConstrainSelectedInstOperands,
     /* 606669 */     // GIR_Coverage, 11769,
     /* 606669 */     GIR_EraseRootFromParent_Done,
     /* 606670 */   // Label 7626: @606670
     /* 606670 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(606768), // Rule ID 11770 //
     /* 606675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 606678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 606702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606722 */     // MIs[3] src0
     /* 606722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606727 */     // MIs[3] src1
     /* 606727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606732 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606734 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 606737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 606746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 606753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 606760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606766 */     GIR_RootConstrainSelectedInstOperands,
     /* 606767 */     // GIR_Coverage, 11770,
     /* 606767 */     GIR_EraseRootFromParent_Done,
     /* 606768 */   // Label 7627: @606768
     /* 606768 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(606866), // Rule ID 11771 //
     /* 606773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 606776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 606800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606820 */     // MIs[3] src1
     /* 606820 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606825 */     // MIs[3] src0
     /* 606825 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606832 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 606835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 606844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 606851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 606858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606864 */     GIR_RootConstrainSelectedInstOperands,
     /* 606865 */     // GIR_Coverage, 11771,
     /* 606865 */     GIR_EraseRootFromParent_Done,
     /* 606866 */   // Label 7628: @606866
     /* 606866 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(606964), // Rule ID 13320 //
     /* 606871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 606874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 606878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 606898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606918 */     // MIs[3] src0
     /* 606918 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606923 */     // MIs[3] src1
     /* 606923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606930 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 606933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 606942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 606949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 606956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606962 */     GIR_RootConstrainSelectedInstOperands,
     /* 606963 */     // GIR_Coverage, 13320,
     /* 606963 */     GIR_EraseRootFromParent_Done,
     /* 606964 */   // Label 7629: @606964
     /* 606964 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(607062), // Rule ID 13321 //
     /* 606969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 606972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 606976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 606996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607016 */     // MIs[3] src1
     /* 607016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607021 */     // MIs[3] src0
     /* 607021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607026 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607028 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 607031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 607040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 607047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607060 */     GIR_RootConstrainSelectedInstOperands,
     /* 607061 */     // GIR_Coverage, 13321,
     /* 607061 */     GIR_EraseRootFromParent_Done,
     /* 607062 */   // Label 7630: @607062
     /* 607062 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(607160), // Rule ID 13322 //
     /* 607067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 607070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 607074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607114 */     // MIs[3] src0
     /* 607114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607119 */     // MIs[3] src1
     /* 607119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607124 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607126 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 607129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 607138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 607145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607158 */     GIR_RootConstrainSelectedInstOperands,
     /* 607159 */     // GIR_Coverage, 13322,
     /* 607159 */     GIR_EraseRootFromParent_Done,
     /* 607160 */   // Label 7631: @607160
     /* 607160 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(607258), // Rule ID 13323 //
     /* 607165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 607168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 607172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607212 */     // MIs[3] src1
     /* 607212 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607217 */     // MIs[3] src0
     /* 607217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607224 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 607227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 607236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 607243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607256 */     GIR_RootConstrainSelectedInstOperands,
     /* 607257 */     // GIR_Coverage, 13323,
     /* 607257 */     GIR_EraseRootFromParent_Done,
     /* 607258 */   // Label 7632: @607258
     /* 607258 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(607356), // Rule ID 13380 //
     /* 607263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 607266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607310 */     // MIs[3] src0
     /* 607310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607315 */     // MIs[3] src1
     /* 607315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607322 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 607325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 607334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 607341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607354 */     GIR_RootConstrainSelectedInstOperands,
     /* 607355 */     // GIR_Coverage, 13380,
     /* 607355 */     GIR_EraseRootFromParent_Done,
     /* 607356 */   // Label 7633: @607356
     /* 607356 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(607454), // Rule ID 13381 //
     /* 607361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 607364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607408 */     // MIs[3] src1
     /* 607408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607413 */     // MIs[3] src0
     /* 607413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607420 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 607423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 607432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 607439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607452 */     GIR_RootConstrainSelectedInstOperands,
     /* 607453 */     // GIR_Coverage, 13381,
     /* 607453 */     GIR_EraseRootFromParent_Done,
     /* 607454 */   // Label 7634: @607454
     /* 607454 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(607552), // Rule ID 13382 //
     /* 607459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 607462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607506 */     // MIs[3] src0
     /* 607506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607511 */     // MIs[3] src1
     /* 607511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607518 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 607521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 607530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 607537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607550 */     GIR_RootConstrainSelectedInstOperands,
     /* 607551 */     // GIR_Coverage, 13382,
     /* 607551 */     GIR_EraseRootFromParent_Done,
     /* 607552 */   // Label 7635: @607552
     /* 607552 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(607650), // Rule ID 13383 //
     /* 607557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 607560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 607584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607604 */     // MIs[3] src1
     /* 607604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607609 */     // MIs[3] src0
     /* 607609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607616 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 607619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 607628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 607635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 607642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607648 */     GIR_RootConstrainSelectedInstOperands,
     /* 607649 */     // GIR_Coverage, 13383,
     /* 607649 */     GIR_EraseRootFromParent_Done,
     /* 607650 */   // Label 7636: @607650
     /* 607650 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(607748), // Rule ID 11772 //
     /* 607655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 607658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 607682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607702 */     // MIs[3] src0
     /* 607702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607707 */     // MIs[3] src1
     /* 607707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607714 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 607717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 607726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 607733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 607740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607746 */     GIR_RootConstrainSelectedInstOperands,
     /* 607747 */     // GIR_Coverage, 11772,
     /* 607747 */     GIR_EraseRootFromParent_Done,
     /* 607748 */   // Label 7637: @607748
     /* 607748 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(607846), // Rule ID 11773 //
     /* 607753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 607756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 607780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607792 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607796 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607800 */     // MIs[3] src1
     /* 607800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607805 */     // MIs[3] src0
     /* 607805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607812 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 607815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 607824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 607831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 607838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607844 */     GIR_RootConstrainSelectedInstOperands,
     /* 607845 */     // GIR_Coverage, 11773,
     /* 607845 */     GIR_EraseRootFromParent_Done,
     /* 607846 */   // Label 7638: @607846
     /* 607846 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(607944), // Rule ID 11774 //
     /* 607851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 607854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 607878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607898 */     // MIs[3] src0
     /* 607898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 607903 */     // MIs[3] src1
     /* 607903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 607908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607910 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 607913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 607922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 607929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 607936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607942 */     GIR_RootConstrainSelectedInstOperands,
     /* 607943 */     // GIR_Coverage, 11774,
     /* 607943 */     GIR_EraseRootFromParent_Done,
     /* 607944 */   // Label 7639: @607944
     /* 607944 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(608042), // Rule ID 11775 //
     /* 607949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 607952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 607976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 607992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607996 */     // MIs[3] src1
     /* 607996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608001 */     // MIs[3] src0
     /* 608001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608008 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 608011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 608020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 608027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608040 */     GIR_RootConstrainSelectedInstOperands,
     /* 608041 */     // GIR_Coverage, 11775,
     /* 608041 */     GIR_EraseRootFromParent_Done,
     /* 608042 */   // Label 7640: @608042
     /* 608042 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(608140), // Rule ID 13324 //
     /* 608047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 608050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 608054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608094 */     // MIs[3] src0
     /* 608094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608099 */     // MIs[3] src1
     /* 608099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608106 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 608109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 608118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 608125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608138 */     GIR_RootConstrainSelectedInstOperands,
     /* 608139 */     // GIR_Coverage, 13324,
     /* 608139 */     GIR_EraseRootFromParent_Done,
     /* 608140 */   // Label 7641: @608140
     /* 608140 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(608238), // Rule ID 13325 //
     /* 608145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 608148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 608152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608192 */     // MIs[3] src1
     /* 608192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608197 */     // MIs[3] src0
     /* 608197 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608204 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 608207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 608216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 608223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608236 */     GIR_RootConstrainSelectedInstOperands,
     /* 608237 */     // GIR_Coverage, 13325,
     /* 608237 */     GIR_EraseRootFromParent_Done,
     /* 608238 */   // Label 7642: @608238
     /* 608238 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(608336), // Rule ID 13326 //
     /* 608243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 608246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 608250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608290 */     // MIs[3] src0
     /* 608290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608295 */     // MIs[3] src1
     /* 608295 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608302 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 608305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 608314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 608321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608334 */     GIR_RootConstrainSelectedInstOperands,
     /* 608335 */     // GIR_Coverage, 13326,
     /* 608335 */     GIR_EraseRootFromParent_Done,
     /* 608336 */   // Label 7643: @608336
     /* 608336 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(608434), // Rule ID 13327 //
     /* 608341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 608344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 608348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608388 */     // MIs[3] src1
     /* 608388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608393 */     // MIs[3] src0
     /* 608393 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608400 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 608403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 608412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 608419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608432 */     GIR_RootConstrainSelectedInstOperands,
     /* 608433 */     // GIR_Coverage, 13327,
     /* 608433 */     GIR_EraseRootFromParent_Done,
     /* 608434 */   // Label 7644: @608434
     /* 608434 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(608532), // Rule ID 13384 //
     /* 608439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 608442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608486 */     // MIs[3] src0
     /* 608486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608491 */     // MIs[3] src1
     /* 608491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608498 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 608501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 608510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 608517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608530 */     GIR_RootConstrainSelectedInstOperands,
     /* 608531 */     // GIR_Coverage, 13384,
     /* 608531 */     GIR_EraseRootFromParent_Done,
     /* 608532 */   // Label 7645: @608532
     /* 608532 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(608630), // Rule ID 13385 //
     /* 608537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 608540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608584 */     // MIs[3] src1
     /* 608584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608589 */     // MIs[3] src0
     /* 608589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608596 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 608599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 608608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 608615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608628 */     GIR_RootConstrainSelectedInstOperands,
     /* 608629 */     // GIR_Coverage, 13385,
     /* 608629 */     GIR_EraseRootFromParent_Done,
     /* 608630 */   // Label 7646: @608630
     /* 608630 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(608728), // Rule ID 13386 //
     /* 608635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 608638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608682 */     // MIs[3] src0
     /* 608682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608687 */     // MIs[3] src1
     /* 608687 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608694 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 608697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 608706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 608713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608726 */     GIR_RootConstrainSelectedInstOperands,
     /* 608727 */     // GIR_Coverage, 13386,
     /* 608727 */     GIR_EraseRootFromParent_Done,
     /* 608728 */   // Label 7647: @608728
     /* 608728 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(608826), // Rule ID 13387 //
     /* 608733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 608736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 608760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 608776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608780 */     // MIs[3] src1
     /* 608780 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 608785 */     // MIs[3] src0
     /* 608785 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 608790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608792 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 608795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 608804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 608811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 608818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608824 */     GIR_RootConstrainSelectedInstOperands,
     /* 608825 */     // GIR_Coverage, 13387,
     /* 608825 */     GIR_EraseRootFromParent_Done,
     /* 608826 */   // Label 7648: @608826
     /* 608826 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(608924), // Rule ID 7607 //
     /* 608831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 608834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 608858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608866 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 608874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608878 */     // MIs[3] src0
     /* 608878 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 608883 */     // MIs[3] src1
     /* 608883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 608888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608890 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 608893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 608902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 608909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 608916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608922 */     GIR_RootConstrainSelectedInstOperands,
     /* 608923 */     // GIR_Coverage, 7607,
     /* 608923 */     GIR_EraseRootFromParent_Done,
     /* 608924 */   // Label 7649: @608924
     /* 608924 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(609022), // Rule ID 7759 //
     /* 608929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 608932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 608936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 608956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 608972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608976 */     // MIs[3] src0
     /* 608976 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 608981 */     // MIs[3] src1
     /* 608981 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 608986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608988 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 608991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 609000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 609007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609020 */     GIR_RootConstrainSelectedInstOperands,
     /* 609021 */     // GIR_Coverage, 7759,
     /* 609021 */     GIR_EraseRootFromParent_Done,
     /* 609022 */   // Label 7650: @609022
     /* 609022 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(609120), // Rule ID 7763 //
     /* 609027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 609030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609074 */     // MIs[3] src0
     /* 609074 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609079 */     // MIs[3] src1
     /* 609079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609086 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 609089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 609098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 609105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609118 */     GIR_RootConstrainSelectedInstOperands,
     /* 609119 */     // GIR_Coverage, 7763,
     /* 609119 */     GIR_EraseRootFromParent_Done,
     /* 609120 */   // Label 7651: @609120
     /* 609120 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(609218), // Rule ID 11761 //
     /* 609125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 609128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609172 */     // MIs[3] src1
     /* 609172 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609177 */     // MIs[3] src0
     /* 609177 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609184 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 609187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 609196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 609203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609216 */     GIR_RootConstrainSelectedInstOperands,
     /* 609217 */     // GIR_Coverage, 11761,
     /* 609217 */     GIR_EraseRootFromParent_Done,
     /* 609218 */   // Label 7652: @609218
     /* 609218 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(609316), // Rule ID 11764 //
     /* 609223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 609226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609270 */     // MIs[3] src0
     /* 609270 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609275 */     // MIs[3] src1
     /* 609275 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609282 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 609285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 609294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 609301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609314 */     GIR_RootConstrainSelectedInstOperands,
     /* 609315 */     // GIR_Coverage, 11764,
     /* 609315 */     GIR_EraseRootFromParent_Done,
     /* 609316 */   // Label 7653: @609316
     /* 609316 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(609414), // Rule ID 11765 //
     /* 609321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 609324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609368 */     // MIs[3] src1
     /* 609368 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609373 */     // MIs[3] src0
     /* 609373 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609380 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 609383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 609392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 609399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609412 */     GIR_RootConstrainSelectedInstOperands,
     /* 609413 */     // GIR_Coverage, 11765,
     /* 609413 */     GIR_EraseRootFromParent_Done,
     /* 609414 */   // Label 7654: @609414
     /* 609414 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(609512), // Rule ID 13313 //
     /* 609419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 609422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 609426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609454 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609466 */     // MIs[3] src1
     /* 609466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609471 */     // MIs[3] src0
     /* 609471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609476 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609478 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 609481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 609490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 609497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609510 */     GIR_RootConstrainSelectedInstOperands,
     /* 609511 */     // GIR_Coverage, 13313,
     /* 609511 */     GIR_EraseRootFromParent_Done,
     /* 609512 */   // Label 7655: @609512
     /* 609512 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(609610), // Rule ID 13316 //
     /* 609517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 609520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 609524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609564 */     // MIs[3] src0
     /* 609564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609569 */     // MIs[3] src1
     /* 609569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609576 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 609579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 609588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 609595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609608 */     GIR_RootConstrainSelectedInstOperands,
     /* 609609 */     // GIR_Coverage, 13316,
     /* 609609 */     GIR_EraseRootFromParent_Done,
     /* 609610 */   // Label 7656: @609610
     /* 609610 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(609708), // Rule ID 13317 //
     /* 609615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 609618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 609622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609662 */     // MIs[3] src1
     /* 609662 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609667 */     // MIs[3] src0
     /* 609667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609672 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609674 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 609677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 609686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 609693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609706 */     GIR_RootConstrainSelectedInstOperands,
     /* 609707 */     // GIR_Coverage, 13317,
     /* 609707 */     GIR_EraseRootFromParent_Done,
     /* 609708 */   // Label 7657: @609708
     /* 609708 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(609806), // Rule ID 13373 //
     /* 609713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 609716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609760 */     // MIs[3] src1
     /* 609760 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609765 */     // MIs[3] src0
     /* 609765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609772 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 609775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 609784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 609791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609804 */     GIR_RootConstrainSelectedInstOperands,
     /* 609805 */     // GIR_Coverage, 13373,
     /* 609805 */     GIR_EraseRootFromParent_Done,
     /* 609806 */   // Label 7658: @609806
     /* 609806 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(609904), // Rule ID 13376 //
     /* 609811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 609814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609858 */     // MIs[3] src0
     /* 609858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609863 */     // MIs[3] src1
     /* 609863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609870 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 609873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 609882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 609889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609902 */     GIR_RootConstrainSelectedInstOperands,
     /* 609903 */     // GIR_Coverage, 13376,
     /* 609903 */     GIR_EraseRootFromParent_Done,
     /* 609904 */   // Label 7659: @609904
     /* 609904 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(610002), // Rule ID 13377 //
     /* 609909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 609912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 609952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609956 */     // MIs[3] src1
     /* 609956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609961 */     // MIs[3] src0
     /* 609961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609968 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 609971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 609980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 609987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 609994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610000 */     GIR_RootConstrainSelectedInstOperands,
     /* 610001 */     // GIR_Coverage, 13377,
     /* 610001 */     GIR_EraseRootFromParent_Done,
     /* 610002 */   // Label 7660: @610002
     /* 610002 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(610100), // Rule ID 11762 //
     /* 610007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 610010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610054 */     // MIs[3] src0
     /* 610054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610059 */     // MIs[3] src1
     /* 610059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610066 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 610069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610098 */     GIR_RootConstrainSelectedInstOperands,
     /* 610099 */     // GIR_Coverage, 11762,
     /* 610099 */     GIR_EraseRootFromParent_Done,
     /* 610100 */   // Label 7661: @610100
     /* 610100 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(610198), // Rule ID 11763 //
     /* 610105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 610108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610152 */     // MIs[3] src1
     /* 610152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610157 */     // MIs[3] src0
     /* 610157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610164 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 610167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610196 */     GIR_RootConstrainSelectedInstOperands,
     /* 610197 */     // GIR_Coverage, 11763,
     /* 610197 */     GIR_EraseRootFromParent_Done,
     /* 610198 */   // Label 7662: @610198
     /* 610198 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(610296), // Rule ID 11766 //
     /* 610203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 610206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610250 */     // MIs[3] src0
     /* 610250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610255 */     // MIs[3] src1
     /* 610255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610262 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 610265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 610274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 610281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610294 */     GIR_RootConstrainSelectedInstOperands,
     /* 610295 */     // GIR_Coverage, 11766,
     /* 610295 */     GIR_EraseRootFromParent_Done,
     /* 610296 */   // Label 7663: @610296
     /* 610296 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(610394), // Rule ID 11767 //
     /* 610301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 610304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610348 */     // MIs[3] src1
     /* 610348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610353 */     // MIs[3] src0
     /* 610353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610360 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 610363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 610372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 610379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610392 */     GIR_RootConstrainSelectedInstOperands,
     /* 610393 */     // GIR_Coverage, 11767,
     /* 610393 */     GIR_EraseRootFromParent_Done,
     /* 610394 */   // Label 7664: @610394
     /* 610394 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(610492), // Rule ID 13314 //
     /* 610399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 610402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 610406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610446 */     // MIs[3] src0
     /* 610446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610451 */     // MIs[3] src1
     /* 610451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610456 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610458 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 610461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610490 */     GIR_RootConstrainSelectedInstOperands,
     /* 610491 */     // GIR_Coverage, 13314,
     /* 610491 */     GIR_EraseRootFromParent_Done,
     /* 610492 */   // Label 7665: @610492
     /* 610492 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(610590), // Rule ID 13315 //
     /* 610497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 610500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 610504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610544 */     // MIs[3] src1
     /* 610544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610549 */     // MIs[3] src0
     /* 610549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610556 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 610559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610588 */     GIR_RootConstrainSelectedInstOperands,
     /* 610589 */     // GIR_Coverage, 13315,
     /* 610589 */     GIR_EraseRootFromParent_Done,
     /* 610590 */   // Label 7666: @610590
     /* 610590 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(610688), // Rule ID 13318 //
     /* 610595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 610598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 610602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610642 */     // MIs[3] src0
     /* 610642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610647 */     // MIs[3] src1
     /* 610647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610654 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 610657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 610666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 610673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610686 */     GIR_RootConstrainSelectedInstOperands,
     /* 610687 */     // GIR_Coverage, 13318,
     /* 610687 */     GIR_EraseRootFromParent_Done,
     /* 610688 */   // Label 7667: @610688
     /* 610688 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(610786), // Rule ID 13319 //
     /* 610693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 610696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 610700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610740 */     // MIs[3] src1
     /* 610740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610745 */     // MIs[3] src0
     /* 610745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610752 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 610755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 610764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 610771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610784 */     GIR_RootConstrainSelectedInstOperands,
     /* 610785 */     // GIR_Coverage, 13319,
     /* 610785 */     GIR_EraseRootFromParent_Done,
     /* 610786 */   // Label 7668: @610786
     /* 610786 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(610884), // Rule ID 13374 //
     /* 610791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 610794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610838 */     // MIs[3] src0
     /* 610838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610843 */     // MIs[3] src1
     /* 610843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610850 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 610853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610882 */     GIR_RootConstrainSelectedInstOperands,
     /* 610883 */     // GIR_Coverage, 13374,
     /* 610883 */     GIR_EraseRootFromParent_Done,
     /* 610884 */   // Label 7669: @610884
     /* 610884 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(610982), // Rule ID 13375 //
     /* 610889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 610892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610936 */     // MIs[3] src1
     /* 610936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610941 */     // MIs[3] src0
     /* 610941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610948 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 610951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610980 */     GIR_RootConstrainSelectedInstOperands,
     /* 610981 */     // GIR_Coverage, 13375,
     /* 610981 */     GIR_EraseRootFromParent_Done,
     /* 610982 */   // Label 7670: @610982
     /* 610982 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(611080), // Rule ID 13378 //
     /* 610987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 610990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 611014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 611030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611034 */     // MIs[3] src0
     /* 611034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 611039 */     // MIs[3] src1
     /* 611039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 611044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611046 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 611049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 611058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 611065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 611072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611078 */     GIR_RootConstrainSelectedInstOperands,
     /* 611079 */     // GIR_Coverage, 13378,
     /* 611079 */     GIR_EraseRootFromParent_Done,
     /* 611080 */   // Label 7671: @611080
     /* 611080 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(611178), // Rule ID 13379 //
     /* 611085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 611088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 611112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 611128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611132 */     // MIs[3] src1
     /* 611132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 611137 */     // MIs[3] src0
     /* 611137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 611142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611144 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 611147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 611156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 611163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 611170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611176 */     GIR_RootConstrainSelectedInstOperands,
     /* 611177 */     // GIR_Coverage, 13379,
     /* 611177 */     GIR_EraseRootFromParent_Done,
     /* 611178 */   // Label 7672: @611178
     /* 611178 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(611234), // Rule ID 895 //
     /* 611183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 611186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 611190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 611197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 611204 */     // (smax:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 611204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_t16_e64),
     /* 611207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 611214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 611219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 611224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 611229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611232 */     GIR_RootConstrainSelectedInstOperands,
     /* 611233 */     // GIR_Coverage, 895,
     /* 611233 */     GIR_EraseRootFromParent_Done,
     /* 611234 */   // Label 7673: @611234
     /* 611234 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(611257), // Rule ID 894 //
     /* 611239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 611242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611246 */     // (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 611246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_e64),
     /* 611251 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 611255 */     GIR_RootConstrainSelectedInstOperands,
     /* 611256 */     // GIR_Coverage, 894,
     /* 611256 */     GIR_Done,
     /* 611257 */   // Label 7674: @611257
     /* 611257 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(611280), // Rule ID 896 //
     /* 611262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 611265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611269 */     // (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 611269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_fake16_e64),
     /* 611274 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 611278 */     GIR_RootConstrainSelectedInstOperands,
     /* 611279 */     // GIR_Coverage, 896,
     /* 611279 */     GIR_Done,
     /* 611280 */   // Label 7675: @611280
     /* 611280 */   GIM_Reject,
     /* 611281 */ // Label 7624: @611281
     /* 611281 */ GIM_Reject,
     /* 611282 */ // Label 7621: @611282
     /* 611282 */ GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(612888),
     /* 611287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 611290 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(611373), // Rule ID 11243 //
     /* 611295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611342 */     // MIs[3] src0
     /* 611342 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611347 */     // MIs[3] src1
     /* 611347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611354 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 611354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 611357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 611363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 611367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611371 */     GIR_RootConstrainSelectedInstOperands,
     /* 611372 */     // GIR_Coverage, 11243,
     /* 611372 */     GIR_EraseRootFromParent_Done,
     /* 611373 */   // Label 7677: @611373
     /* 611373 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(611456), // Rule ID 11244 //
     /* 611378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611425 */     // MIs[3] src1
     /* 611425 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611430 */     // MIs[3] src0
     /* 611430 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611437 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 611437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 611440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 611446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 611450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611454 */     GIR_RootConstrainSelectedInstOperands,
     /* 611455 */     // GIR_Coverage, 11244,
     /* 611455 */     GIR_EraseRootFromParent_Done,
     /* 611456 */   // Label 7678: @611456
     /* 611456 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(611539), // Rule ID 11245 //
     /* 611461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611508 */     // MIs[3] src0
     /* 611508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611513 */     // MIs[3] src1
     /* 611513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611520 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 611520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 611523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 611529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 611533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611537 */     GIR_RootConstrainSelectedInstOperands,
     /* 611538 */     // GIR_Coverage, 11245,
     /* 611538 */     GIR_EraseRootFromParent_Done,
     /* 611539 */   // Label 7679: @611539
     /* 611539 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(611622), // Rule ID 11246 //
     /* 611544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611591 */     // MIs[3] src1
     /* 611591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611596 */     // MIs[3] src0
     /* 611596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611603 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 611603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 611606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 611612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 611616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611620 */     GIR_RootConstrainSelectedInstOperands,
     /* 611621 */     // GIR_Coverage, 11246,
     /* 611621 */     GIR_EraseRootFromParent_Done,
     /* 611622 */   // Label 7680: @611622
     /* 611622 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(611705), // Rule ID 11247 //
     /* 611627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 611654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611674 */     // MIs[3] src0
     /* 611674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611679 */     // MIs[3] src1
     /* 611679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611686 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 611686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 611689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 611695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 611699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 611703 */     GIR_RootConstrainSelectedInstOperands,
     /* 611704 */     // GIR_Coverage, 11247,
     /* 611704 */     GIR_EraseRootFromParent_Done,
     /* 611705 */   // Label 7681: @611705
     /* 611705 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(611788), // Rule ID 11248 //
     /* 611710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 611737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611757 */     // MIs[3] src1
     /* 611757 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611762 */     // MIs[3] src0
     /* 611762 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611767 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611769 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 611769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 611772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 611778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 611782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 611786 */     GIR_RootConstrainSelectedInstOperands,
     /* 611787 */     // GIR_Coverage, 11248,
     /* 611787 */     GIR_EraseRootFromParent_Done,
     /* 611788 */   // Label 7682: @611788
     /* 611788 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(611871), // Rule ID 11249 //
     /* 611793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 611820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611840 */     // MIs[3] src0
     /* 611840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611845 */     // MIs[3] src1
     /* 611845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611852 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 611852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 611855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 611861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 611865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 611869 */     GIR_RootConstrainSelectedInstOperands,
     /* 611870 */     // GIR_Coverage, 11249,
     /* 611870 */     GIR_EraseRootFromParent_Done,
     /* 611871 */   // Label 7683: @611871
     /* 611871 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(611954), // Rule ID 11250 //
     /* 611876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 611903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611923 */     // MIs[3] src1
     /* 611923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611928 */     // MIs[3] src0
     /* 611928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611935 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 611935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 611938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 611944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 611948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 611952 */     GIR_RootConstrainSelectedInstOperands,
     /* 611953 */     // GIR_Coverage, 11250,
     /* 611953 */     GIR_EraseRootFromParent_Done,
     /* 611954 */   // Label 7684: @611954
     /* 611954 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(612037), // Rule ID 7572 //
     /* 611959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 611962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 611978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 611982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 611986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 611994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 611998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 612002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612006 */     // MIs[3] src0
     /* 612006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612011 */     // MIs[3] src1
     /* 612011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612016 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612018 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 612027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 612031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 612035 */     GIR_RootConstrainSelectedInstOperands,
     /* 612036 */     // GIR_Coverage, 7572,
     /* 612036 */     GIR_EraseRootFromParent_Done,
     /* 612037 */   // Label 7685: @612037
     /* 612037 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(612120), // Rule ID 11236 //
     /* 612042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 612085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612089 */     // MIs[3] src1
     /* 612089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612094 */     // MIs[3] src0
     /* 612094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612101 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 612110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 612114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 612118 */     GIR_RootConstrainSelectedInstOperands,
     /* 612119 */     // GIR_Coverage, 11236,
     /* 612119 */     GIR_EraseRootFromParent_Done,
     /* 612120 */   // Label 7686: @612120
     /* 612120 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(612203), // Rule ID 11239 //
     /* 612125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 612168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612172 */     // MIs[3] src0
     /* 612172 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612177 */     // MIs[3] src1
     /* 612177 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612184 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 612193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 612197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 612201 */     GIR_RootConstrainSelectedInstOperands,
     /* 612202 */     // GIR_Coverage, 11239,
     /* 612202 */     GIR_EraseRootFromParent_Done,
     /* 612203 */   // Label 7687: @612203
     /* 612203 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(612286), // Rule ID 11240 //
     /* 612208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 612251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612255 */     // MIs[3] src1
     /* 612255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612260 */     // MIs[3] src0
     /* 612260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612267 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 612276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 612280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 612284 */     GIR_RootConstrainSelectedInstOperands,
     /* 612285 */     // GIR_Coverage, 11240,
     /* 612285 */     GIR_EraseRootFromParent_Done,
     /* 612286 */   // Label 7688: @612286
     /* 612286 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(612369), // Rule ID 11237 //
     /* 612291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 612334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612338 */     // MIs[3] src0
     /* 612338 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612343 */     // MIs[3] src1
     /* 612343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612350 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 612359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 612363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 612367 */     GIR_RootConstrainSelectedInstOperands,
     /* 612368 */     // GIR_Coverage, 11237,
     /* 612368 */     GIR_EraseRootFromParent_Done,
     /* 612369 */   // Label 7689: @612369
     /* 612369 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(612452), // Rule ID 11238 //
     /* 612374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 612417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612421 */     // MIs[3] src1
     /* 612421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612426 */     // MIs[3] src0
     /* 612426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612433 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 612442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 612446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 612450 */     GIR_RootConstrainSelectedInstOperands,
     /* 612451 */     // GIR_Coverage, 11238,
     /* 612451 */     GIR_EraseRootFromParent_Done,
     /* 612452 */   // Label 7690: @612452
     /* 612452 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(612535), // Rule ID 11241 //
     /* 612457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 612500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612504 */     // MIs[3] src0
     /* 612504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612509 */     // MIs[3] src1
     /* 612509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612516 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 612525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 612529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 612533 */     GIR_RootConstrainSelectedInstOperands,
     /* 612534 */     // GIR_Coverage, 11241,
     /* 612534 */     GIR_EraseRootFromParent_Done,
     /* 612535 */   // Label 7691: @612535
     /* 612535 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(612618), // Rule ID 11242 //
     /* 612540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 612567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 612575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 612579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 612583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612587 */     // MIs[3] src1
     /* 612587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 612592 */     // MIs[3] src0
     /* 612592 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612599 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 612602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 612608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 612612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 612616 */     GIR_RootConstrainSelectedInstOperands,
     /* 612617 */     // GIR_Coverage, 11242,
     /* 612617 */     GIR_EraseRootFromParent_Done,
     /* 612618 */   // Label 7692: @612618
     /* 612618 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(612672), // Rule ID 8470 //
     /* 612623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 612627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 612635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612643 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 612647 */     // MIs[0] x
     /* 612647 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 612652 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13782),
     /* 612656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 612658 */     // (smax:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$x)<<P:Predicate_anonymous_13782>>  =>  (S_ABS_I32:{ *:[i32] }:{ *:[i1] } SReg_32:{ *:[i32] }:$x)
     /* 612658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ABS_I32),
     /* 612661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 612663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // x
     /* 612667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 612670 */     GIR_RootConstrainSelectedInstOperands,
     /* 612671 */     // GIR_Coverage, 8470,
     /* 612671 */     GIR_EraseRootFromParent_Done,
     /* 612672 */   // Label 7693: @612672
     /* 612672 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(612723), // Rule ID 1869 //
     /* 612677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 612684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 612688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 612692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612696 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 612700 */     // MIs[1] x
     /* 612700 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 612705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13782),
     /* 612709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 612711 */     // (smax:{ *:[i32] } i32:{ *:[i32] }:$x, (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_13782>>  =>  (S_ABS_I32:{ *:[i32] }:{ *:[i1] } SReg_32:{ *:[i32] }:$x)
     /* 612711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ABS_I32),
     /* 612714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 612716 */     GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 612718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 612721 */     GIR_RootConstrainSelectedInstOperands,
     /* 612722 */     // GIR_Coverage, 1869,
     /* 612722 */     GIR_EraseRootFromParent_Done,
     /* 612723 */   // Label 7694: @612723
     /* 612723 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(612779), // Rule ID 7706 //
     /* 612728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 612731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612754 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 612756 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35009),
     /* 612760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 612762 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smin_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_35009>>  =>  (V_MINMAX_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_I32_e64),
     /* 612765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 612771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 612775 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 612777 */     GIR_RootConstrainSelectedInstOperands,
     /* 612778 */     // GIR_Coverage, 7706,
     /* 612778 */     GIR_EraseRootFromParent_Done,
     /* 612779 */   // Label 7695: @612779
     /* 612779 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(612835), // Rule ID 13232 //
     /* 612784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 612787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 612798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 612806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 612810 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 612812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35009),
     /* 612816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 612818 */     // (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smin_oneuse>>)<<P:Predicate_anonymous_35009>>  =>  (V_MINMAX_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 612818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_I32_e64),
     /* 612821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 612827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 612831 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 612833 */     GIR_RootConstrainSelectedInstOperands,
     /* 612834 */     // GIR_Coverage, 13232,
     /* 612834 */     GIR_EraseRootFromParent_Done,
     /* 612835 */   // Label 7696: @612835
     /* 612835 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(612864), // Rule ID 49 //
     /* 612840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 612847 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13782),
     /* 612851 */     // (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13782>>  =>  (S_MAX_I32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 612851 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_I32),
     /* 612856 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 612862 */     GIR_RootConstrainSelectedInstOperands,
     /* 612863 */     // GIR_Coverage, 49,
     /* 612863 */     GIR_Done,
     /* 612864 */   // Label 7697: @612864
     /* 612864 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(612887), // Rule ID 805 //
     /* 612869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 612872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612876 */     // (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MAX_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 612876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I32_e64),
     /* 612881 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 612885 */     GIR_RootConstrainSelectedInstOperands,
     /* 612886 */     // GIR_Coverage, 805,
     /* 612886 */     GIR_Done,
     /* 612887 */   // Label 7698: @612887
     /* 612887 */   GIM_Reject,
     /* 612888 */ // Label 7676: @612888
     /* 612888 */ GIM_Reject,
     /* 612889 */ // Label 7622: @612889
     /* 612889 */ GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(612960), // Rule ID 1102 //
     /* 612894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 612897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 612900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612904 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 612911 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 612918 */   // (smax:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 612918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_I16),
     /* 612921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 612928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 612933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 612938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 612943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612958 */   GIR_RootConstrainSelectedInstOperands,
     /* 612959 */   // GIR_Coverage, 1102,
     /* 612959 */   GIR_EraseRootFromParent_Done,
     /* 612960 */ // Label 7699: @612960
     /* 612960 */ GIM_Reject,
     /* 612961 */ // Label 7623: @612961
     /* 612961 */ GIM_Reject,
     /* 612962 */ // Label 90: @612962
     /* 612962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7703*/ GIMT_Encode4(619325),
     /* 612973 */ /*GILLT_s16*//*Label 7700*/ GIMT_Encode4(612989),
     /* 612977 */ /*GILLT_s32*//*Label 7701*/ GIMT_Encode4(617808), GIMT_Encode4(0),
     /* 612985 */ /*GILLT_v2s16*//*Label 7702*/ GIMT_Encode4(619253),
     /* 612989 */ // Label 7700: @612989
     /* 612989 */ GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(617807),
     /* 612994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 612997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 613000 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(613098), // Rule ID 13305 //
     /* 613005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 613008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613052 */     // MIs[3] src0
     /* 613052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613057 */     // MIs[3] src1
     /* 613057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613064 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 613067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 613076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 613083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613096 */     GIR_RootConstrainSelectedInstOperands,
     /* 613097 */     // GIR_Coverage, 13305,
     /* 613097 */     GIR_EraseRootFromParent_Done,
     /* 613098 */   // Label 7705: @613098
     /* 613098 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(613196), // Rule ID 13306 //
     /* 613103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 613106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613150 */     // MIs[3] src1
     /* 613150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613155 */     // MIs[3] src0
     /* 613155 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613162 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 613165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 613174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 613181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613194 */     GIR_RootConstrainSelectedInstOperands,
     /* 613195 */     // GIR_Coverage, 13306,
     /* 613195 */     GIR_EraseRootFromParent_Done,
     /* 613196 */   // Label 7706: @613196
     /* 613196 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(613294), // Rule ID 13307 //
     /* 613201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 613204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613248 */     // MIs[3] src0
     /* 613248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613253 */     // MIs[3] src1
     /* 613253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613260 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 613263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 613272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 613279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613292 */     GIR_RootConstrainSelectedInstOperands,
     /* 613293 */     // GIR_Coverage, 13307,
     /* 613293 */     GIR_EraseRootFromParent_Done,
     /* 613294 */   // Label 7707: @613294
     /* 613294 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(613392), // Rule ID 13308 //
     /* 613299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 613302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613346 */     // MIs[3] src1
     /* 613346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613351 */     // MIs[3] src0
     /* 613351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613358 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 613361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 613370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 613377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613390 */     GIR_RootConstrainSelectedInstOperands,
     /* 613391 */     // GIR_Coverage, 13308,
     /* 613391 */     GIR_EraseRootFromParent_Done,
     /* 613392 */   // Label 7708: @613392
     /* 613392 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(613490), // Rule ID 13365 //
     /* 613397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 613400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 613404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613444 */     // MIs[3] src0
     /* 613444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613449 */     // MIs[3] src1
     /* 613449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613456 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 613459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 613468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 613475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613488 */     GIR_RootConstrainSelectedInstOperands,
     /* 613489 */     // GIR_Coverage, 13365,
     /* 613489 */     GIR_EraseRootFromParent_Done,
     /* 613490 */   // Label 7709: @613490
     /* 613490 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(613588), // Rule ID 13366 //
     /* 613495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 613498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 613502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613542 */     // MIs[3] src1
     /* 613542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613547 */     // MIs[3] src0
     /* 613547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613554 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 613557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 613566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 613573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613586 */     GIR_RootConstrainSelectedInstOperands,
     /* 613587 */     // GIR_Coverage, 13366,
     /* 613587 */     GIR_EraseRootFromParent_Done,
     /* 613588 */   // Label 7710: @613588
     /* 613588 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(613686), // Rule ID 13367 //
     /* 613593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 613596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 613600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613640 */     // MIs[3] src0
     /* 613640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613645 */     // MIs[3] src1
     /* 613645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613652 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 613655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 613664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 613671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613684 */     GIR_RootConstrainSelectedInstOperands,
     /* 613685 */     // GIR_Coverage, 13367,
     /* 613685 */     GIR_EraseRootFromParent_Done,
     /* 613686 */   // Label 7711: @613686
     /* 613686 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(613784), // Rule ID 13368 //
     /* 613691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 613694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 613698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613738 */     // MIs[3] src1
     /* 613738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613743 */     // MIs[3] src0
     /* 613743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613750 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 613753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 613762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 613769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613782 */     GIR_RootConstrainSelectedInstOperands,
     /* 613783 */     // GIR_Coverage, 13368,
     /* 613783 */     GIR_EraseRootFromParent_Done,
     /* 613784 */   // Label 7712: @613784
     /* 613784 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(613882), // Rule ID 13425 //
     /* 613789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 613792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613836 */     // MIs[3] src0
     /* 613836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613841 */     // MIs[3] src1
     /* 613841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613848 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 613851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 613860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 613867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613880 */     GIR_RootConstrainSelectedInstOperands,
     /* 613881 */     // GIR_Coverage, 13425,
     /* 613881 */     GIR_EraseRootFromParent_Done,
     /* 613882 */   // Label 7713: @613882
     /* 613882 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(613980), // Rule ID 13426 //
     /* 613887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 613890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 613914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 613918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 613934 */     // MIs[3] src1
     /* 613934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613939 */     // MIs[3] src0
     /* 613939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613946 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 613949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 613958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 613965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 613972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613978 */     GIR_RootConstrainSelectedInstOperands,
     /* 613979 */     // GIR_Coverage, 13426,
     /* 613979 */     GIR_EraseRootFromParent_Done,
     /* 613980 */   // Label 7714: @613980
     /* 613980 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(614078), // Rule ID 13427 //
     /* 613985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 613988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 614012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614032 */     // MIs[3] src0
     /* 614032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614037 */     // MIs[3] src1
     /* 614037 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614044 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 614047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 614056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 614063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 614070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614076 */     GIR_RootConstrainSelectedInstOperands,
     /* 614077 */     // GIR_Coverage, 13427,
     /* 614077 */     GIR_EraseRootFromParent_Done,
     /* 614078 */   // Label 7715: @614078
     /* 614078 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(614176), // Rule ID 13428 //
     /* 614083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 614086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 614110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614130 */     // MIs[3] src1
     /* 614130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614135 */     // MIs[3] src0
     /* 614135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614142 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 614145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 614154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 614161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 614168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614174 */     GIR_RootConstrainSelectedInstOperands,
     /* 614175 */     // GIR_Coverage, 13428,
     /* 614175 */     GIR_EraseRootFromParent_Done,
     /* 614176 */   // Label 7716: @614176
     /* 614176 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(614274), // Rule ID 13309 //
     /* 614181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 614184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614228 */     // MIs[3] src0
     /* 614228 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614233 */     // MIs[3] src1
     /* 614233 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614240 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 614243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 614252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 614259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 614266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614272 */     GIR_RootConstrainSelectedInstOperands,
     /* 614273 */     // GIR_Coverage, 13309,
     /* 614273 */     GIR_EraseRootFromParent_Done,
     /* 614274 */   // Label 7717: @614274
     /* 614274 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(614372), // Rule ID 13310 //
     /* 614279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 614282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614326 */     // MIs[3] src1
     /* 614326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614331 */     // MIs[3] src0
     /* 614331 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614338 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 614341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 614350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 614357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 614364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614370 */     GIR_RootConstrainSelectedInstOperands,
     /* 614371 */     // GIR_Coverage, 13310,
     /* 614371 */     GIR_EraseRootFromParent_Done,
     /* 614372 */   // Label 7718: @614372
     /* 614372 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(614470), // Rule ID 13311 //
     /* 614377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 614380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614424 */     // MIs[3] src0
     /* 614424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614429 */     // MIs[3] src1
     /* 614429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614436 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 614439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 614448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 614455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 614462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614468 */     GIR_RootConstrainSelectedInstOperands,
     /* 614469 */     // GIR_Coverage, 13311,
     /* 614469 */     GIR_EraseRootFromParent_Done,
     /* 614470 */   // Label 7719: @614470
     /* 614470 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(614568), // Rule ID 13312 //
     /* 614475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 614478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614522 */     // MIs[3] src1
     /* 614522 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614527 */     // MIs[3] src0
     /* 614527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614534 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 614537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 614546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 614553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 614560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614566 */     GIR_RootConstrainSelectedInstOperands,
     /* 614567 */     // GIR_Coverage, 13312,
     /* 614567 */     GIR_EraseRootFromParent_Done,
     /* 614568 */   // Label 7720: @614568
     /* 614568 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(614666), // Rule ID 13369 //
     /* 614573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 614576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 614580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614620 */     // MIs[3] src0
     /* 614620 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614625 */     // MIs[3] src1
     /* 614625 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614632 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 614635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 614644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 614651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 614658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614664 */     GIR_RootConstrainSelectedInstOperands,
     /* 614665 */     // GIR_Coverage, 13369,
     /* 614665 */     GIR_EraseRootFromParent_Done,
     /* 614666 */   // Label 7721: @614666
     /* 614666 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(614764), // Rule ID 13370 //
     /* 614671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 614674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 614678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614718 */     // MIs[3] src1
     /* 614718 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614723 */     // MIs[3] src0
     /* 614723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614730 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 614733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 614742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 614749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 614756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614762 */     GIR_RootConstrainSelectedInstOperands,
     /* 614763 */     // GIR_Coverage, 13370,
     /* 614763 */     GIR_EraseRootFromParent_Done,
     /* 614764 */   // Label 7722: @614764
     /* 614764 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(614862), // Rule ID 13371 //
     /* 614769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 614772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 614776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614816 */     // MIs[3] src0
     /* 614816 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614821 */     // MIs[3] src1
     /* 614821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614828 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 614831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 614840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 614847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 614854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614860 */     GIR_RootConstrainSelectedInstOperands,
     /* 614861 */     // GIR_Coverage, 13371,
     /* 614861 */     GIR_EraseRootFromParent_Done,
     /* 614862 */   // Label 7723: @614862
     /* 614862 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(614960), // Rule ID 13372 //
     /* 614867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 614870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 614874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 614910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614914 */     // MIs[3] src1
     /* 614914 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 614919 */     // MIs[3] src0
     /* 614919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 614924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614926 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 614929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 614938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 614945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 614952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614958 */     GIR_RootConstrainSelectedInstOperands,
     /* 614959 */     // GIR_Coverage, 13372,
     /* 614959 */     GIR_EraseRootFromParent_Done,
     /* 614960 */   // Label 7724: @614960
     /* 614960 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(615058), // Rule ID 13429 //
     /* 614965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 614968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 614980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 614992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 614996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615012 */     // MIs[3] src0
     /* 615012 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615017 */     // MIs[3] src1
     /* 615017 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615024 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 615027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 615036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 615043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 615050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615056 */     GIR_RootConstrainSelectedInstOperands,
     /* 615057 */     // GIR_Coverage, 13429,
     /* 615057 */     GIR_EraseRootFromParent_Done,
     /* 615058 */   // Label 7725: @615058
     /* 615058 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(615156), // Rule ID 13430 //
     /* 615063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 615066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 615090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615110 */     // MIs[3] src1
     /* 615110 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615115 */     // MIs[3] src0
     /* 615115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615122 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 615125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 615134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 615141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 615148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615154 */     GIR_RootConstrainSelectedInstOperands,
     /* 615155 */     // GIR_Coverage, 13430,
     /* 615155 */     GIR_EraseRootFromParent_Done,
     /* 615156 */   // Label 7726: @615156
     /* 615156 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(615254), // Rule ID 13431 //
     /* 615161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 615164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 615188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615208 */     // MIs[3] src0
     /* 615208 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615213 */     // MIs[3] src1
     /* 615213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615220 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 615223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 615232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 615239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 615246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615252 */     GIR_RootConstrainSelectedInstOperands,
     /* 615253 */     // GIR_Coverage, 13431,
     /* 615253 */     GIR_EraseRootFromParent_Done,
     /* 615254 */   // Label 7727: @615254
     /* 615254 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(615352), // Rule ID 13432 //
     /* 615259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 615262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 615286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615306 */     // MIs[3] src1
     /* 615306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615311 */     // MIs[3] src0
     /* 615311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615318 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 615321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 615330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 615337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 615344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615350 */     GIR_RootConstrainSelectedInstOperands,
     /* 615351 */     // GIR_Coverage, 13432,
     /* 615351 */     GIR_EraseRootFromParent_Done,
     /* 615352 */   // Label 7728: @615352
     /* 615352 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(615450), // Rule ID 7758 //
     /* 615357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 615360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 615400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615404 */     // MIs[3] src0
     /* 615404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615409 */     // MIs[3] src1
     /* 615409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615414 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615416 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 615419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 615428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 615435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 615442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615448 */     GIR_RootConstrainSelectedInstOperands,
     /* 615449 */     // GIR_Coverage, 7758,
     /* 615449 */     GIR_EraseRootFromParent_Done,
     /* 615450 */   // Label 7729: @615450
     /* 615450 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(615548), // Rule ID 7762 //
     /* 615455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 615458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 615462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 615498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615502 */     // MIs[3] src0
     /* 615502 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615507 */     // MIs[3] src1
     /* 615507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615512 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615514 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 615517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 615526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 615533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 615540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615546 */     GIR_RootConstrainSelectedInstOperands,
     /* 615547 */     // GIR_Coverage, 7762,
     /* 615547 */     GIR_EraseRootFromParent_Done,
     /* 615548 */   // Label 7730: @615548
     /* 615548 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(615646), // Rule ID 7766 //
     /* 615553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 615556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 615596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615600 */     // MIs[3] src0
     /* 615600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615605 */     // MIs[3] src1
     /* 615605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615612 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 615615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 615624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 615631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 615638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615644 */     GIR_RootConstrainSelectedInstOperands,
     /* 615645 */     // GIR_Coverage, 7766,
     /* 615645 */     GIR_EraseRootFromParent_Done,
     /* 615646 */   // Label 7731: @615646
     /* 615646 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(615744), // Rule ID 13298 //
     /* 615651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 615654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 615694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615698 */     // MIs[3] src1
     /* 615698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615703 */     // MIs[3] src0
     /* 615703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615710 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 615713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 615722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 615729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 615736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615742 */     GIR_RootConstrainSelectedInstOperands,
     /* 615743 */     // GIR_Coverage, 13298,
     /* 615743 */     GIR_EraseRootFromParent_Done,
     /* 615744 */   // Label 7732: @615744
     /* 615744 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(615842), // Rule ID 13301 //
     /* 615749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 615752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 615792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615796 */     // MIs[3] src0
     /* 615796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615801 */     // MIs[3] src1
     /* 615801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615808 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 615811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 615820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 615827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 615834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615840 */     GIR_RootConstrainSelectedInstOperands,
     /* 615841 */     // GIR_Coverage, 13301,
     /* 615841 */     GIR_EraseRootFromParent_Done,
     /* 615842 */   // Label 7733: @615842
     /* 615842 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(615940), // Rule ID 13302 //
     /* 615847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 615850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 615890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615894 */     // MIs[3] src1
     /* 615894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615899 */     // MIs[3] src0
     /* 615899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615906 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 615909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 615918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 615925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 615932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615938 */     GIR_RootConstrainSelectedInstOperands,
     /* 615939 */     // GIR_Coverage, 13302,
     /* 615939 */     GIR_EraseRootFromParent_Done,
     /* 615940 */   // Label 7734: @615940
     /* 615940 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(616038), // Rule ID 13358 //
     /* 615945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 615948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 615952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 615976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 615988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 615992 */     // MIs[3] src1
     /* 615992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615997 */     // MIs[3] src0
     /* 615997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616002 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616004 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 616007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 616023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616036 */     GIR_RootConstrainSelectedInstOperands,
     /* 616037 */     // GIR_Coverage, 13358,
     /* 616037 */     GIR_EraseRootFromParent_Done,
     /* 616038 */   // Label 7735: @616038
     /* 616038 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(616136), // Rule ID 13361 //
     /* 616043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 616046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 616050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616090 */     // MIs[3] src0
     /* 616090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616095 */     // MIs[3] src1
     /* 616095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616102 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 616105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616134 */     GIR_RootConstrainSelectedInstOperands,
     /* 616135 */     // GIR_Coverage, 13361,
     /* 616135 */     GIR_EraseRootFromParent_Done,
     /* 616136 */   // Label 7736: @616136
     /* 616136 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(616234), // Rule ID 13362 //
     /* 616141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 616144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 616148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616188 */     // MIs[3] src1
     /* 616188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616193 */     // MIs[3] src0
     /* 616193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616200 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 616203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616232 */     GIR_RootConstrainSelectedInstOperands,
     /* 616233 */     // GIR_Coverage, 13362,
     /* 616233 */     GIR_EraseRootFromParent_Done,
     /* 616234 */   // Label 7737: @616234
     /* 616234 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(616332), // Rule ID 13418 //
     /* 616239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 616242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616286 */     // MIs[3] src1
     /* 616286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616291 */     // MIs[3] src0
     /* 616291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616298 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 616301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 616317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616330 */     GIR_RootConstrainSelectedInstOperands,
     /* 616331 */     // GIR_Coverage, 13418,
     /* 616331 */     GIR_EraseRootFromParent_Done,
     /* 616332 */   // Label 7738: @616332
     /* 616332 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(616430), // Rule ID 13421 //
     /* 616337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 616340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616384 */     // MIs[3] src0
     /* 616384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616389 */     // MIs[3] src1
     /* 616389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616396 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 616399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616428 */     GIR_RootConstrainSelectedInstOperands,
     /* 616429 */     // GIR_Coverage, 13421,
     /* 616429 */     GIR_EraseRootFromParent_Done,
     /* 616430 */   // Label 7739: @616430
     /* 616430 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(616528), // Rule ID 13422 //
     /* 616435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 616438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616482 */     // MIs[3] src1
     /* 616482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616487 */     // MIs[3] src0
     /* 616487 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616494 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 616497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616526 */     GIR_RootConstrainSelectedInstOperands,
     /* 616527 */     // GIR_Coverage, 13422,
     /* 616527 */     GIR_EraseRootFromParent_Done,
     /* 616528 */   // Label 7740: @616528
     /* 616528 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(616626), // Rule ID 13299 //
     /* 616533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 616536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 616576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616580 */     // MIs[3] src0
     /* 616580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616585 */     // MIs[3] src1
     /* 616585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616590 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616592 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 616595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 616611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 616618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616624 */     GIR_RootConstrainSelectedInstOperands,
     /* 616625 */     // GIR_Coverage, 13299,
     /* 616625 */     GIR_EraseRootFromParent_Done,
     /* 616626 */   // Label 7741: @616626
     /* 616626 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(616724), // Rule ID 13300 //
     /* 616631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 616634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 616674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616678 */     // MIs[3] src1
     /* 616678 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616683 */     // MIs[3] src0
     /* 616683 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616690 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 616693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 616709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 616716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616722 */     GIR_RootConstrainSelectedInstOperands,
     /* 616723 */     // GIR_Coverage, 13300,
     /* 616723 */     GIR_EraseRootFromParent_Done,
     /* 616724 */   // Label 7742: @616724
     /* 616724 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(616822), // Rule ID 13303 //
     /* 616729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 616732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 616772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616776 */     // MIs[3] src0
     /* 616776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616781 */     // MIs[3] src1
     /* 616781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616788 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 616791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 616814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616820 */     GIR_RootConstrainSelectedInstOperands,
     /* 616821 */     // GIR_Coverage, 13303,
     /* 616821 */     GIR_EraseRootFromParent_Done,
     /* 616822 */   // Label 7743: @616822
     /* 616822 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(616920), // Rule ID 13304 //
     /* 616827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 616830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 616870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616874 */     // MIs[3] src1
     /* 616874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616879 */     // MIs[3] src0
     /* 616879 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616886 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 616889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 616912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616918 */     GIR_RootConstrainSelectedInstOperands,
     /* 616919 */     // GIR_Coverage, 13304,
     /* 616919 */     GIR_EraseRootFromParent_Done,
     /* 616920 */   // Label 7744: @616920
     /* 616920 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(617018), // Rule ID 13359 //
     /* 616925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 616928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 616932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 616944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 616948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 616956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 616960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 616964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 616968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 616972 */     // MIs[3] src0
     /* 616972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616977 */     // MIs[3] src1
     /* 616977 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616982 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616984 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 616984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 616987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 616999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 617003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617016 */     GIR_RootConstrainSelectedInstOperands,
     /* 617017 */     // GIR_Coverage, 13359,
     /* 617017 */     GIR_EraseRootFromParent_Done,
     /* 617018 */   // Label 7745: @617018
     /* 617018 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(617116), // Rule ID 13360 //
     /* 617023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 617026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 617030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617070 */     // MIs[3] src1
     /* 617070 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617075 */     // MIs[3] src0
     /* 617075 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617082 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 617085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 617094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 617101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617114 */     GIR_RootConstrainSelectedInstOperands,
     /* 617115 */     // GIR_Coverage, 13360,
     /* 617115 */     GIR_EraseRootFromParent_Done,
     /* 617116 */   // Label 7746: @617116
     /* 617116 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(617214), // Rule ID 13363 //
     /* 617121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 617124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 617128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617168 */     // MIs[3] src0
     /* 617168 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617173 */     // MIs[3] src1
     /* 617173 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617180 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 617183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 617192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 617199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617212 */     GIR_RootConstrainSelectedInstOperands,
     /* 617213 */     // GIR_Coverage, 13363,
     /* 617213 */     GIR_EraseRootFromParent_Done,
     /* 617214 */   // Label 7747: @617214
     /* 617214 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(617312), // Rule ID 13364 //
     /* 617219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 617222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 617226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617266 */     // MIs[3] src1
     /* 617266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617271 */     // MIs[3] src0
     /* 617271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617278 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 617281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 617290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 617297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617310 */     GIR_RootConstrainSelectedInstOperands,
     /* 617311 */     // GIR_Coverage, 13364,
     /* 617311 */     GIR_EraseRootFromParent_Done,
     /* 617312 */   // Label 7748: @617312
     /* 617312 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(617410), // Rule ID 13419 //
     /* 617317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 617320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617364 */     // MIs[3] src0
     /* 617364 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617369 */     // MIs[3] src1
     /* 617369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617376 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 617379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 617388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 617395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617408 */     GIR_RootConstrainSelectedInstOperands,
     /* 617409 */     // GIR_Coverage, 13419,
     /* 617409 */     GIR_EraseRootFromParent_Done,
     /* 617410 */   // Label 7749: @617410
     /* 617410 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(617508), // Rule ID 13420 //
     /* 617415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 617418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617462 */     // MIs[3] src1
     /* 617462 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617467 */     // MIs[3] src0
     /* 617467 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617472 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617474 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 617477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 617486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 617493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617506 */     GIR_RootConstrainSelectedInstOperands,
     /* 617507 */     // GIR_Coverage, 13420,
     /* 617507 */     GIR_EraseRootFromParent_Done,
     /* 617508 */   // Label 7750: @617508
     /* 617508 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(617606), // Rule ID 13423 //
     /* 617513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 617516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617560 */     // MIs[3] src0
     /* 617560 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617565 */     // MIs[3] src1
     /* 617565 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617572 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 617575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 617584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 617591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617604 */     GIR_RootConstrainSelectedInstOperands,
     /* 617605 */     // GIR_Coverage, 13423,
     /* 617605 */     GIR_EraseRootFromParent_Done,
     /* 617606 */   // Label 7751: @617606
     /* 617606 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(617704), // Rule ID 13424 //
     /* 617611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 617614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 617638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 617654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617658 */     // MIs[3] src1
     /* 617658 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 617663 */     // MIs[3] src0
     /* 617663 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617670 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 617673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 617682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 617689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617702 */     GIR_RootConstrainSelectedInstOperands,
     /* 617703 */     // GIR_Coverage, 13424,
     /* 617703 */     GIR_EraseRootFromParent_Done,
     /* 617704 */   // Label 7752: @617704
     /* 617704 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(617760), // Rule ID 898 //
     /* 617709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 617712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 617716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 617723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 617730 */     // (umin:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 617730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_t16_e64),
     /* 617733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 617740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 617745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 617750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 617755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617758 */     GIR_RootConstrainSelectedInstOperands,
     /* 617759 */     // GIR_Coverage, 898,
     /* 617759 */     GIR_EraseRootFromParent_Done,
     /* 617760 */   // Label 7753: @617760
     /* 617760 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(617783), // Rule ID 897 //
     /* 617765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 617768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617772 */     // (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 617772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_e64),
     /* 617777 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 617781 */     GIR_RootConstrainSelectedInstOperands,
     /* 617782 */     // GIR_Coverage, 897,
     /* 617782 */     GIR_Done,
     /* 617783 */   // Label 7754: @617783
     /* 617783 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(617806), // Rule ID 899 //
     /* 617788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 617791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617795 */     // (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_U16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 617795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_fake16_e64),
     /* 617800 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 617804 */     GIR_RootConstrainSelectedInstOperands,
     /* 617805 */     // GIR_Coverage, 899,
     /* 617805 */     GIR_Done,
     /* 617806 */   // Label 7755: @617806
     /* 617806 */   GIM_Reject,
     /* 617807 */ // Label 7704: @617807
     /* 617807 */ GIM_Reject,
     /* 617808 */ // Label 7701: @617808
     /* 617808 */ GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(619252),
     /* 617813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 617816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 617819 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(617899), // Rule ID 11258 //
     /* 617824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 617840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 617844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 617848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 617856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 617860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 617864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617868 */     // MIs[3] src0
     /* 617868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 617873 */     // MIs[3] src1
     /* 617873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 617878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617880 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 617880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 617883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 617889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 617893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 617897 */     GIR_RootConstrainSelectedInstOperands,
     /* 617898 */     // GIR_Coverage, 11258,
     /* 617898 */     GIR_EraseRootFromParent_Done,
     /* 617899 */   // Label 7757: @617899
     /* 617899 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(617979), // Rule ID 11259 //
     /* 617904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 617920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 617924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 617928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 617936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 617940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 617944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617948 */     // MIs[3] src1
     /* 617948 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 617953 */     // MIs[3] src0
     /* 617953 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 617958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617960 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 617960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 617963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 617969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 617973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 617977 */     GIR_RootConstrainSelectedInstOperands,
     /* 617978 */     // GIR_Coverage, 11259,
     /* 617978 */     GIR_EraseRootFromParent_Done,
     /* 617979 */   // Label 7758: @617979
     /* 617979 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(618059), // Rule ID 11260 //
     /* 617984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 618008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618028 */     // MIs[3] src0
     /* 618028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618033 */     // MIs[3] src1
     /* 618033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618040 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 618057 */     GIR_RootConstrainSelectedInstOperands,
     /* 618058 */     // GIR_Coverage, 11260,
     /* 618058 */     GIR_EraseRootFromParent_Done,
     /* 618059 */   // Label 7759: @618059
     /* 618059 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(618139), // Rule ID 11261 //
     /* 618064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 618088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618108 */     // MIs[3] src1
     /* 618108 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618113 */     // MIs[3] src0
     /* 618113 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618120 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 618137 */     GIR_RootConstrainSelectedInstOperands,
     /* 618138 */     // GIR_Coverage, 11261,
     /* 618138 */     GIR_EraseRootFromParent_Done,
     /* 618139 */   // Label 7760: @618139
     /* 618139 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(618219), // Rule ID 11262 //
     /* 618144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 618168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618188 */     // MIs[3] src0
     /* 618188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618193 */     // MIs[3] src1
     /* 618193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618200 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 618209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 618213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 618217 */     GIR_RootConstrainSelectedInstOperands,
     /* 618218 */     // GIR_Coverage, 11262,
     /* 618218 */     GIR_EraseRootFromParent_Done,
     /* 618219 */   // Label 7761: @618219
     /* 618219 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(618299), // Rule ID 11263 //
     /* 618224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 618248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618268 */     // MIs[3] src1
     /* 618268 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618273 */     // MIs[3] src0
     /* 618273 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618278 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618280 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 618289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 618293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 618297 */     GIR_RootConstrainSelectedInstOperands,
     /* 618298 */     // GIR_Coverage, 11263,
     /* 618298 */     GIR_EraseRootFromParent_Done,
     /* 618299 */   // Label 7762: @618299
     /* 618299 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(618379), // Rule ID 11264 //
     /* 618304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 618328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618348 */     // MIs[3] src0
     /* 618348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618353 */     // MIs[3] src1
     /* 618353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618360 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 618377 */     GIR_RootConstrainSelectedInstOperands,
     /* 618378 */     // GIR_Coverage, 11264,
     /* 618378 */     GIR_EraseRootFromParent_Done,
     /* 618379 */   // Label 7763: @618379
     /* 618379 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(618459), // Rule ID 11265 //
     /* 618384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 618408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618428 */     // MIs[3] src1
     /* 618428 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618433 */     // MIs[3] src0
     /* 618433 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618440 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 618457 */     GIR_RootConstrainSelectedInstOperands,
     /* 618458 */     // GIR_Coverage, 11265,
     /* 618458 */     GIR_EraseRootFromParent_Done,
     /* 618459 */   // Label 7764: @618459
     /* 618459 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(618539), // Rule ID 7573 //
     /* 618464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 618488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 618504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618508 */     // MIs[3] src0
     /* 618508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 618513 */     // MIs[3] src1
     /* 618513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 618518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618520 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 618529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 618533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 618537 */     GIR_RootConstrainSelectedInstOperands,
     /* 618538 */     // GIR_Coverage, 7573,
     /* 618538 */     GIR_EraseRootFromParent_Done,
     /* 618539 */   // Label 7765: @618539
     /* 618539 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(618619), // Rule ID 11251 //
     /* 618544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 618568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 618584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618588 */     // MIs[3] src1
     /* 618588 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 618593 */     // MIs[3] src0
     /* 618593 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 618598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618600 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 618609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 618613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 618617 */     GIR_RootConstrainSelectedInstOperands,
     /* 618618 */     // GIR_Coverage, 11251,
     /* 618618 */     GIR_EraseRootFromParent_Done,
     /* 618619 */   // Label 7766: @618619
     /* 618619 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(618699), // Rule ID 11254 //
     /* 618624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 618648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 618664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618668 */     // MIs[3] src0
     /* 618668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 618673 */     // MIs[3] src1
     /* 618673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 618678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618680 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 618689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 618693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 618697 */     GIR_RootConstrainSelectedInstOperands,
     /* 618698 */     // GIR_Coverage, 11254,
     /* 618698 */     GIR_EraseRootFromParent_Done,
     /* 618699 */   // Label 7767: @618699
     /* 618699 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(618779), // Rule ID 11255 //
     /* 618704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 618728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 618744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618748 */     // MIs[3] src1
     /* 618748 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 618753 */     // MIs[3] src0
     /* 618753 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 618758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618760 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 618769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 618773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 618777 */     GIR_RootConstrainSelectedInstOperands,
     /* 618778 */     // GIR_Coverage, 11255,
     /* 618778 */     GIR_EraseRootFromParent_Done,
     /* 618779 */   // Label 7768: @618779
     /* 618779 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(618859), // Rule ID 11252 //
     /* 618784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 618808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 618824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618828 */     // MIs[3] src0
     /* 618828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 618833 */     // MIs[3] src1
     /* 618833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 618838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618840 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 618849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 618853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 618857 */     GIR_RootConstrainSelectedInstOperands,
     /* 618858 */     // GIR_Coverage, 11252,
     /* 618858 */     GIR_EraseRootFromParent_Done,
     /* 618859 */   // Label 7769: @618859
     /* 618859 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(618939), // Rule ID 11253 //
     /* 618864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 618888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 618904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618908 */     // MIs[3] src1
     /* 618908 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 618913 */     // MIs[3] src0
     /* 618913 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 618918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618920 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 618920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 618923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 618929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 618933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 618937 */     GIR_RootConstrainSelectedInstOperands,
     /* 618938 */     // GIR_Coverage, 11253,
     /* 618938 */     GIR_EraseRootFromParent_Done,
     /* 618939 */   // Label 7770: @618939
     /* 618939 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(619019), // Rule ID 11256 //
     /* 618944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 618960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 618964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 618968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 618976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 618980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 618984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618988 */     // MIs[3] src0
     /* 618988 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 618993 */     // MIs[3] src1
     /* 618993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 618998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619000 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 619000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 619003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 619009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 619013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 619017 */     GIR_RootConstrainSelectedInstOperands,
     /* 619018 */     // GIR_Coverage, 11256,
     /* 619018 */     GIR_EraseRootFromParent_Done,
     /* 619019 */   // Label 7771: @619019
     /* 619019 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(619099), // Rule ID 11257 //
     /* 619024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 619040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 619044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 619048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 619056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 619060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 619064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619068 */     // MIs[3] src1
     /* 619068 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 619073 */     // MIs[3] src0
     /* 619073 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 619078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619080 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 619080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 619083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 619089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 619093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 619097 */     GIR_RootConstrainSelectedInstOperands,
     /* 619098 */     // GIR_Coverage, 11257,
     /* 619098 */     GIR_EraseRootFromParent_Done,
     /* 619099 */   // Label 7772: @619099
     /* 619099 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(619152), // Rule ID 7707 //
     /* 619104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 619107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 619123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 619127 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 619129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35011),
     /* 619133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 619135 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umax_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_35011>>  =>  (V_MAXMIN_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 619135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_U32_e64),
     /* 619138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 619144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 619148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 619150 */     GIR_RootConstrainSelectedInstOperands,
     /* 619151 */     // GIR_Coverage, 7707,
     /* 619151 */     GIR_EraseRootFromParent_Done,
     /* 619152 */   // Label 7773: @619152
     /* 619152 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(619205), // Rule ID 13233 //
     /* 619157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 619160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 619168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 619176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 619180 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 619182 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35011),
     /* 619186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 619188 */     // (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umax_oneuse>>)<<P:Predicate_anonymous_35011>>  =>  (V_MAXMIN_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 619188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_U32_e64),
     /* 619191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 619197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 619201 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 619203 */     GIR_RootConstrainSelectedInstOperands,
     /* 619204 */     // GIR_Coverage, 13233,
     /* 619204 */     GIR_EraseRootFromParent_Done,
     /* 619205 */   // Label 7774: @619205
     /* 619205 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(619231), // Rule ID 48 //
     /* 619210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 619214 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13781),
     /* 619218 */     // (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13781>>  =>  (S_MIN_U32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 619218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_U32),
     /* 619223 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 619229 */     GIR_RootConstrainSelectedInstOperands,
     /* 619230 */     // GIR_Coverage, 48,
     /* 619230 */     GIR_Done,
     /* 619231 */   // Label 7775: @619231
     /* 619231 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(619251), // Rule ID 806 //
     /* 619236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619240 */     // (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MIN_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 619240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U32_e64),
     /* 619245 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 619249 */     GIR_RootConstrainSelectedInstOperands,
     /* 619250 */     // GIR_Coverage, 806,
     /* 619250 */     GIR_Done,
     /* 619251 */   // Label 7776: @619251
     /* 619251 */   GIM_Reject,
     /* 619252 */ // Label 7756: @619252
     /* 619252 */ GIM_Reject,
     /* 619253 */ // Label 7702: @619253
     /* 619253 */ GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(619324), // Rule ID 1101 //
     /* 619258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 619261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 619264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619268 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 619275 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 619282 */   // (umin:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 619282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_U16),
     /* 619285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 619292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 619297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 619302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 619307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619322 */   GIR_RootConstrainSelectedInstOperands,
     /* 619323 */   // GIR_Coverage, 1101,
     /* 619323 */   GIR_EraseRootFromParent_Done,
     /* 619324 */ // Label 7777: @619324
     /* 619324 */ GIM_Reject,
     /* 619325 */ // Label 7703: @619325
     /* 619325 */ GIM_Reject,
     /* 619326 */ // Label 91: @619326
     /* 619326 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7781*/ GIMT_Encode4(625689),
     /* 619337 */ /*GILLT_s16*//*Label 7778*/ GIMT_Encode4(619353),
     /* 619341 */ /*GILLT_s32*//*Label 7779*/ GIMT_Encode4(624172), GIMT_Encode4(0),
     /* 619349 */ /*GILLT_v2s16*//*Label 7780*/ GIMT_Encode4(625617),
     /* 619353 */ // Label 7778: @619353
     /* 619353 */ GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(624171),
     /* 619358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 619361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 619364 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(619462), // Rule ID 13290 //
     /* 619369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 619372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 619396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619416 */     // MIs[3] src0
     /* 619416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619421 */     // MIs[3] src1
     /* 619421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619428 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 619431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 619440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 619447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 619454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619460 */     GIR_RootConstrainSelectedInstOperands,
     /* 619461 */     // GIR_Coverage, 13290,
     /* 619461 */     GIR_EraseRootFromParent_Done,
     /* 619462 */   // Label 7783: @619462
     /* 619462 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(619560), // Rule ID 13291 //
     /* 619467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 619470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 619494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619514 */     // MIs[3] src1
     /* 619514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619519 */     // MIs[3] src0
     /* 619519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619526 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 619529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 619538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 619545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 619552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619558 */     GIR_RootConstrainSelectedInstOperands,
     /* 619559 */     // GIR_Coverage, 13291,
     /* 619559 */     GIR_EraseRootFromParent_Done,
     /* 619560 */   // Label 7784: @619560
     /* 619560 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(619658), // Rule ID 13292 //
     /* 619565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 619568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 619592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619612 */     // MIs[3] src0
     /* 619612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619617 */     // MIs[3] src1
     /* 619617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619624 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 619627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 619636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 619643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 619650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619656 */     GIR_RootConstrainSelectedInstOperands,
     /* 619657 */     // GIR_Coverage, 13292,
     /* 619657 */     GIR_EraseRootFromParent_Done,
     /* 619658 */   // Label 7785: @619658
     /* 619658 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(619756), // Rule ID 13293 //
     /* 619663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 619666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 619690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619710 */     // MIs[3] src1
     /* 619710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619715 */     // MIs[3] src0
     /* 619715 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619722 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 619725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 619734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 619741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 619748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619754 */     GIR_RootConstrainSelectedInstOperands,
     /* 619755 */     // GIR_Coverage, 13293,
     /* 619755 */     GIR_EraseRootFromParent_Done,
     /* 619756 */   // Label 7786: @619756
     /* 619756 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(619854), // Rule ID 13350 //
     /* 619761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 619764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 619768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 619788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619808 */     // MIs[3] src0
     /* 619808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619813 */     // MIs[3] src1
     /* 619813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619820 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 619823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 619832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 619839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 619846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619852 */     GIR_RootConstrainSelectedInstOperands,
     /* 619853 */     // GIR_Coverage, 13350,
     /* 619853 */     GIR_EraseRootFromParent_Done,
     /* 619854 */   // Label 7787: @619854
     /* 619854 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(619952), // Rule ID 13351 //
     /* 619859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 619862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 619866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 619886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619906 */     // MIs[3] src1
     /* 619906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619911 */     // MIs[3] src0
     /* 619911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619918 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 619921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 619930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 619937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 619944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619950 */     GIR_RootConstrainSelectedInstOperands,
     /* 619951 */     // GIR_Coverage, 13351,
     /* 619951 */     GIR_EraseRootFromParent_Done,
     /* 619952 */   // Label 7788: @619952
     /* 619952 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(620050), // Rule ID 13352 //
     /* 619957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 619960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 619964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 619984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620004 */     // MIs[3] src0
     /* 620004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620009 */     // MIs[3] src1
     /* 620009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620016 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 620019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 620028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 620035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620048 */     GIR_RootConstrainSelectedInstOperands,
     /* 620049 */     // GIR_Coverage, 13352,
     /* 620049 */     GIR_EraseRootFromParent_Done,
     /* 620050 */   // Label 7789: @620050
     /* 620050 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(620148), // Rule ID 13353 //
     /* 620055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 620058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 620062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 620082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620102 */     // MIs[3] src1
     /* 620102 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620107 */     // MIs[3] src0
     /* 620107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620114 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 620117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 620126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 620133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620146 */     GIR_RootConstrainSelectedInstOperands,
     /* 620147 */     // GIR_Coverage, 13353,
     /* 620147 */     GIR_EraseRootFromParent_Done,
     /* 620148 */   // Label 7790: @620148
     /* 620148 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(620246), // Rule ID 13410 //
     /* 620153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 620156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 620180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620200 */     // MIs[3] src0
     /* 620200 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620205 */     // MIs[3] src1
     /* 620205 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620212 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 620215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 620224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 620231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620244 */     GIR_RootConstrainSelectedInstOperands,
     /* 620245 */     // GIR_Coverage, 13410,
     /* 620245 */     GIR_EraseRootFromParent_Done,
     /* 620246 */   // Label 7791: @620246
     /* 620246 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(620344), // Rule ID 13411 //
     /* 620251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 620254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 620278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620298 */     // MIs[3] src1
     /* 620298 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620303 */     // MIs[3] src0
     /* 620303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620310 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 620313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 620322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 620329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620342 */     GIR_RootConstrainSelectedInstOperands,
     /* 620343 */     // GIR_Coverage, 13411,
     /* 620343 */     GIR_EraseRootFromParent_Done,
     /* 620344 */   // Label 7792: @620344
     /* 620344 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(620442), // Rule ID 13412 //
     /* 620349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 620352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 620376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620396 */     // MIs[3] src0
     /* 620396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620401 */     // MIs[3] src1
     /* 620401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620408 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 620411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 620420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 620427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620440 */     GIR_RootConstrainSelectedInstOperands,
     /* 620441 */     // GIR_Coverage, 13412,
     /* 620441 */     GIR_EraseRootFromParent_Done,
     /* 620442 */   // Label 7793: @620442
     /* 620442 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(620540), // Rule ID 13413 //
     /* 620447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 620450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 620474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620494 */     // MIs[3] src1
     /* 620494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620499 */     // MIs[3] src0
     /* 620499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620506 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 620509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 620518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 620525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 620532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620538 */     GIR_RootConstrainSelectedInstOperands,
     /* 620539 */     // GIR_Coverage, 13413,
     /* 620539 */     GIR_EraseRootFromParent_Done,
     /* 620540 */   // Label 7794: @620540
     /* 620540 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(620638), // Rule ID 13294 //
     /* 620545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 620548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 620572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620592 */     // MIs[3] src0
     /* 620592 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620597 */     // MIs[3] src1
     /* 620597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620602 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620604 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 620607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 620616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 620623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 620630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620636 */     GIR_RootConstrainSelectedInstOperands,
     /* 620637 */     // GIR_Coverage, 13294,
     /* 620637 */     GIR_EraseRootFromParent_Done,
     /* 620638 */   // Label 7795: @620638
     /* 620638 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(620736), // Rule ID 13295 //
     /* 620643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 620646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 620670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620690 */     // MIs[3] src1
     /* 620690 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620695 */     // MIs[3] src0
     /* 620695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620702 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 620705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 620714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 620721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 620728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620734 */     GIR_RootConstrainSelectedInstOperands,
     /* 620735 */     // GIR_Coverage, 13295,
     /* 620735 */     GIR_EraseRootFromParent_Done,
     /* 620736 */   // Label 7796: @620736
     /* 620736 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(620834), // Rule ID 13296 //
     /* 620741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 620744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 620768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620788 */     // MIs[3] src0
     /* 620788 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620793 */     // MIs[3] src1
     /* 620793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620800 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 620803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 620812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 620819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 620826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620832 */     GIR_RootConstrainSelectedInstOperands,
     /* 620833 */     // GIR_Coverage, 13296,
     /* 620833 */     GIR_EraseRootFromParent_Done,
     /* 620834 */   // Label 7797: @620834
     /* 620834 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(620932), // Rule ID 13297 //
     /* 620839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 620842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 620866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620886 */     // MIs[3] src1
     /* 620886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620891 */     // MIs[3] src0
     /* 620891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620896 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620898 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 620901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 620910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 620917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 620924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620930 */     GIR_RootConstrainSelectedInstOperands,
     /* 620931 */     // GIR_Coverage, 13297,
     /* 620931 */     GIR_EraseRootFromParent_Done,
     /* 620932 */   // Label 7798: @620932
     /* 620932 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(621030), // Rule ID 13354 //
     /* 620937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 620940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 620944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 620964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 620980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620984 */     // MIs[3] src0
     /* 620984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 620989 */     // MIs[3] src1
     /* 620989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 620994 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620996 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 620999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 621008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 621015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621028 */     GIR_RootConstrainSelectedInstOperands,
     /* 621029 */     // GIR_Coverage, 13354,
     /* 621029 */     GIR_EraseRootFromParent_Done,
     /* 621030 */   // Label 7799: @621030
     /* 621030 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(621128), // Rule ID 13355 //
     /* 621035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 621038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 621042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621082 */     // MIs[3] src1
     /* 621082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621087 */     // MIs[3] src0
     /* 621087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621094 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 621097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 621106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 621113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621126 */     GIR_RootConstrainSelectedInstOperands,
     /* 621127 */     // GIR_Coverage, 13355,
     /* 621127 */     GIR_EraseRootFromParent_Done,
     /* 621128 */   // Label 7800: @621128
     /* 621128 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(621226), // Rule ID 13356 //
     /* 621133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 621136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 621140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621180 */     // MIs[3] src0
     /* 621180 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621185 */     // MIs[3] src1
     /* 621185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621192 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 621195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 621204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 621211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621224 */     GIR_RootConstrainSelectedInstOperands,
     /* 621225 */     // GIR_Coverage, 13356,
     /* 621225 */     GIR_EraseRootFromParent_Done,
     /* 621226 */   // Label 7801: @621226
     /* 621226 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(621324), // Rule ID 13357 //
     /* 621231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 621234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 621238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621278 */     // MIs[3] src1
     /* 621278 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621283 */     // MIs[3] src0
     /* 621283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621290 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 621293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 621302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 621309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621322 */     GIR_RootConstrainSelectedInstOperands,
     /* 621323 */     // GIR_Coverage, 13357,
     /* 621323 */     GIR_EraseRootFromParent_Done,
     /* 621324 */   // Label 7802: @621324
     /* 621324 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(621422), // Rule ID 13414 //
     /* 621329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 621332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621376 */     // MIs[3] src0
     /* 621376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621381 */     // MIs[3] src1
     /* 621381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621388 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 621391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 621400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 621407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621420 */     GIR_RootConstrainSelectedInstOperands,
     /* 621421 */     // GIR_Coverage, 13414,
     /* 621421 */     GIR_EraseRootFromParent_Done,
     /* 621422 */   // Label 7803: @621422
     /* 621422 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(621520), // Rule ID 13415 //
     /* 621427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 621430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621474 */     // MIs[3] src1
     /* 621474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621479 */     // MIs[3] src0
     /* 621479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621486 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 621489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 621498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 621505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621518 */     GIR_RootConstrainSelectedInstOperands,
     /* 621519 */     // GIR_Coverage, 13415,
     /* 621519 */     GIR_EraseRootFromParent_Done,
     /* 621520 */   // Label 7804: @621520
     /* 621520 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(621618), // Rule ID 13416 //
     /* 621525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 621528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621572 */     // MIs[3] src0
     /* 621572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621577 */     // MIs[3] src1
     /* 621577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621584 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 621587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 621596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 621603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621616 */     GIR_RootConstrainSelectedInstOperands,
     /* 621617 */     // GIR_Coverage, 13416,
     /* 621617 */     GIR_EraseRootFromParent_Done,
     /* 621618 */   // Label 7805: @621618
     /* 621618 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(621716), // Rule ID 13417 //
     /* 621623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 621626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 621650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 621666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621670 */     // MIs[3] src1
     /* 621670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 621675 */     // MIs[3] src0
     /* 621675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 621680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621682 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 621685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 621694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 621701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 621708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621714 */     GIR_RootConstrainSelectedInstOperands,
     /* 621715 */     // GIR_Coverage, 13417,
     /* 621715 */     GIR_EraseRootFromParent_Done,
     /* 621716 */   // Label 7806: @621716
     /* 621716 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(621814), // Rule ID 7757 //
     /* 621721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 621724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 621748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 621764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621768 */     // MIs[3] src0
     /* 621768 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 621773 */     // MIs[3] src1
     /* 621773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 621778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621780 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 621783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 621792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 621799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 621806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621812 */     GIR_RootConstrainSelectedInstOperands,
     /* 621813 */     // GIR_Coverage, 7757,
     /* 621813 */     GIR_EraseRootFromParent_Done,
     /* 621814 */   // Label 7807: @621814
     /* 621814 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(621912), // Rule ID 7761 //
     /* 621819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 621822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 621826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 621846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 621862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621866 */     // MIs[3] src0
     /* 621866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 621871 */     // MIs[3] src1
     /* 621871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 621876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621878 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 621881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 621890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 621897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 621904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621910 */     GIR_RootConstrainSelectedInstOperands,
     /* 621911 */     // GIR_Coverage, 7761,
     /* 621911 */     GIR_EraseRootFromParent_Done,
     /* 621912 */   // Label 7808: @621912
     /* 621912 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(622010), // Rule ID 7765 //
     /* 621917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 621920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 621944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 621960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621964 */     // MIs[3] src0
     /* 621964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 621969 */     // MIs[3] src1
     /* 621969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 621974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621976 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 621979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 621988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 621995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622008 */     GIR_RootConstrainSelectedInstOperands,
     /* 622009 */     // GIR_Coverage, 7765,
     /* 622009 */     GIR_EraseRootFromParent_Done,
     /* 622010 */   // Label 7809: @622010
     /* 622010 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(622108), // Rule ID 13283 //
     /* 622015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 622018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622062 */     // MIs[3] src1
     /* 622062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622067 */     // MIs[3] src0
     /* 622067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622074 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 622077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 622086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 622093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622106 */     GIR_RootConstrainSelectedInstOperands,
     /* 622107 */     // GIR_Coverage, 13283,
     /* 622107 */     GIR_EraseRootFromParent_Done,
     /* 622108 */   // Label 7810: @622108
     /* 622108 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(622206), // Rule ID 13286 //
     /* 622113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 622116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622160 */     // MIs[3] src0
     /* 622160 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622165 */     // MIs[3] src1
     /* 622165 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622172 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 622175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 622184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 622191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622204 */     GIR_RootConstrainSelectedInstOperands,
     /* 622205 */     // GIR_Coverage, 13286,
     /* 622205 */     GIR_EraseRootFromParent_Done,
     /* 622206 */   // Label 7811: @622206
     /* 622206 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(622304), // Rule ID 13287 //
     /* 622211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 622214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622258 */     // MIs[3] src1
     /* 622258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622263 */     // MIs[3] src0
     /* 622263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622270 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 622273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 622282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 622289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622302 */     GIR_RootConstrainSelectedInstOperands,
     /* 622303 */     // GIR_Coverage, 13287,
     /* 622303 */     GIR_EraseRootFromParent_Done,
     /* 622304 */   // Label 7812: @622304
     /* 622304 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(622402), // Rule ID 13343 //
     /* 622309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 622312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 622316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622356 */     // MIs[3] src1
     /* 622356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622361 */     // MIs[3] src0
     /* 622361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622368 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 622371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 622380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 622387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622400 */     GIR_RootConstrainSelectedInstOperands,
     /* 622401 */     // GIR_Coverage, 13343,
     /* 622401 */     GIR_EraseRootFromParent_Done,
     /* 622402 */   // Label 7813: @622402
     /* 622402 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(622500), // Rule ID 13346 //
     /* 622407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 622410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 622414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622454 */     // MIs[3] src0
     /* 622454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622459 */     // MIs[3] src1
     /* 622459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622466 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 622469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 622478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 622485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622498 */     GIR_RootConstrainSelectedInstOperands,
     /* 622499 */     // GIR_Coverage, 13346,
     /* 622499 */     GIR_EraseRootFromParent_Done,
     /* 622500 */   // Label 7814: @622500
     /* 622500 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(622598), // Rule ID 13347 //
     /* 622505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 622508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 622512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622552 */     // MIs[3] src1
     /* 622552 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622557 */     // MIs[3] src0
     /* 622557 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622564 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 622567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 622576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 622583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622596 */     GIR_RootConstrainSelectedInstOperands,
     /* 622597 */     // GIR_Coverage, 13347,
     /* 622597 */     GIR_EraseRootFromParent_Done,
     /* 622598 */   // Label 7815: @622598
     /* 622598 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(622696), // Rule ID 13403 //
     /* 622603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 622606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622650 */     // MIs[3] src1
     /* 622650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622655 */     // MIs[3] src0
     /* 622655 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622662 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 622665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 622674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 622681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622694 */     GIR_RootConstrainSelectedInstOperands,
     /* 622695 */     // GIR_Coverage, 13403,
     /* 622695 */     GIR_EraseRootFromParent_Done,
     /* 622696 */   // Label 7816: @622696
     /* 622696 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(622794), // Rule ID 13406 //
     /* 622701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 622704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622748 */     // MIs[3] src0
     /* 622748 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622753 */     // MIs[3] src1
     /* 622753 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622760 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 622763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 622772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 622779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622792 */     GIR_RootConstrainSelectedInstOperands,
     /* 622793 */     // GIR_Coverage, 13406,
     /* 622793 */     GIR_EraseRootFromParent_Done,
     /* 622794 */   // Label 7817: @622794
     /* 622794 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(622892), // Rule ID 13407 //
     /* 622799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 622802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622846 */     // MIs[3] src1
     /* 622846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622851 */     // MIs[3] src0
     /* 622851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622858 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 622861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 622870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 622877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622890 */     GIR_RootConstrainSelectedInstOperands,
     /* 622891 */     // GIR_Coverage, 13407,
     /* 622891 */     GIR_EraseRootFromParent_Done,
     /* 622892 */   // Label 7818: @622892
     /* 622892 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(622990), // Rule ID 13284 //
     /* 622897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 622900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 622940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622944 */     // MIs[3] src0
     /* 622944 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622949 */     // MIs[3] src1
     /* 622949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622956 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 622959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 622968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 622975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 622982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622988 */     GIR_RootConstrainSelectedInstOperands,
     /* 622989 */     // GIR_Coverage, 13284,
     /* 622989 */     GIR_EraseRootFromParent_Done,
     /* 622990 */   // Label 7819: @622990
     /* 622990 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(623088), // Rule ID 13285 //
     /* 622995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 622998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623042 */     // MIs[3] src1
     /* 623042 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623047 */     // MIs[3] src0
     /* 623047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623054 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 623057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623086 */     GIR_RootConstrainSelectedInstOperands,
     /* 623087 */     // GIR_Coverage, 13285,
     /* 623087 */     GIR_EraseRootFromParent_Done,
     /* 623088 */   // Label 7820: @623088
     /* 623088 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(623186), // Rule ID 13288 //
     /* 623093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 623096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623140 */     // MIs[3] src0
     /* 623140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623145 */     // MIs[3] src1
     /* 623145 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623152 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 623155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623184 */     GIR_RootConstrainSelectedInstOperands,
     /* 623185 */     // GIR_Coverage, 13288,
     /* 623185 */     GIR_EraseRootFromParent_Done,
     /* 623186 */   // Label 7821: @623186
     /* 623186 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(623284), // Rule ID 13289 //
     /* 623191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 623194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623238 */     // MIs[3] src1
     /* 623238 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623243 */     // MIs[3] src0
     /* 623243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623250 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 623253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623282 */     GIR_RootConstrainSelectedInstOperands,
     /* 623283 */     // GIR_Coverage, 13289,
     /* 623283 */     GIR_EraseRootFromParent_Done,
     /* 623284 */   // Label 7822: @623284
     /* 623284 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(623382), // Rule ID 13344 //
     /* 623289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 623292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 623296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623336 */     // MIs[3] src0
     /* 623336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623341 */     // MIs[3] src1
     /* 623341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623346 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623348 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 623351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623380 */     GIR_RootConstrainSelectedInstOperands,
     /* 623381 */     // GIR_Coverage, 13344,
     /* 623381 */     GIR_EraseRootFromParent_Done,
     /* 623382 */   // Label 7823: @623382
     /* 623382 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(623480), // Rule ID 13345 //
     /* 623387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 623390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 623394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623434 */     // MIs[3] src1
     /* 623434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623439 */     // MIs[3] src0
     /* 623439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623444 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623446 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 623449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623478 */     GIR_RootConstrainSelectedInstOperands,
     /* 623479 */     // GIR_Coverage, 13345,
     /* 623479 */     GIR_EraseRootFromParent_Done,
     /* 623480 */   // Label 7824: @623480
     /* 623480 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(623578), // Rule ID 13348 //
     /* 623485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 623488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 623492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623532 */     // MIs[3] src0
     /* 623532 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623537 */     // MIs[3] src1
     /* 623537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623544 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 623547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623576 */     GIR_RootConstrainSelectedInstOperands,
     /* 623577 */     // GIR_Coverage, 13348,
     /* 623577 */     GIR_EraseRootFromParent_Done,
     /* 623578 */   // Label 7825: @623578
     /* 623578 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(623676), // Rule ID 13349 //
     /* 623583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 623586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 623590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623630 */     // MIs[3] src1
     /* 623630 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623635 */     // MIs[3] src0
     /* 623635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623642 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 623645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623674 */     GIR_RootConstrainSelectedInstOperands,
     /* 623675 */     // GIR_Coverage, 13349,
     /* 623675 */     GIR_EraseRootFromParent_Done,
     /* 623676 */   // Label 7826: @623676
     /* 623676 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(623774), // Rule ID 13404 //
     /* 623681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 623684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623728 */     // MIs[3] src0
     /* 623728 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623733 */     // MIs[3] src1
     /* 623733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623740 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 623743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623772 */     GIR_RootConstrainSelectedInstOperands,
     /* 623773 */     // GIR_Coverage, 13404,
     /* 623773 */     GIR_EraseRootFromParent_Done,
     /* 623774 */   // Label 7827: @623774
     /* 623774 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(623872), // Rule ID 13405 //
     /* 623779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 623782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623826 */     // MIs[3] src1
     /* 623826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623831 */     // MIs[3] src0
     /* 623831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623838 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 623841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623870 */     GIR_RootConstrainSelectedInstOperands,
     /* 623871 */     // GIR_Coverage, 13405,
     /* 623871 */     GIR_EraseRootFromParent_Done,
     /* 623872 */   // Label 7828: @623872
     /* 623872 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(623970), // Rule ID 13408 //
     /* 623877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 623880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623924 */     // MIs[3] src0
     /* 623924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623929 */     // MIs[3] src1
     /* 623929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623936 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 623939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623968 */     GIR_RootConstrainSelectedInstOperands,
     /* 623969 */     // GIR_Coverage, 13408,
     /* 623969 */     GIR_EraseRootFromParent_Done,
     /* 623970 */   // Label 7829: @623970
     /* 623970 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(624068), // Rule ID 13409 //
     /* 623975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 623978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 624002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 624018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624022 */     // MIs[3] src1
     /* 624022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 624027 */     // MIs[3] src0
     /* 624027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 624032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624034 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 624037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 624046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 624053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 624060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624066 */     GIR_RootConstrainSelectedInstOperands,
     /* 624067 */     // GIR_Coverage, 13409,
     /* 624067 */     GIR_EraseRootFromParent_Done,
     /* 624068 */   // Label 7830: @624068
     /* 624068 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(624124), // Rule ID 892 //
     /* 624073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 624076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 624080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 624087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 624094 */     // (umax:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 624094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_t16_e64),
     /* 624097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 624104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 624109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 624114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 624119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624122 */     GIR_RootConstrainSelectedInstOperands,
     /* 624123 */     // GIR_Coverage, 892,
     /* 624123 */     GIR_EraseRootFromParent_Done,
     /* 624124 */   // Label 7831: @624124
     /* 624124 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(624147), // Rule ID 891 //
     /* 624129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 624132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624136 */     // (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 624136 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_e64),
     /* 624141 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 624145 */     GIR_RootConstrainSelectedInstOperands,
     /* 624146 */     // GIR_Coverage, 891,
     /* 624146 */     GIR_Done,
     /* 624147 */   // Label 7832: @624147
     /* 624147 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(624170), // Rule ID 893 //
     /* 624152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 624155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624159 */     // (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_U16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 624159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_fake16_e64),
     /* 624164 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 624168 */     GIR_RootConstrainSelectedInstOperands,
     /* 624169 */     // GIR_Coverage, 893,
     /* 624169 */     GIR_Done,
     /* 624170 */   // Label 7833: @624170
     /* 624170 */   GIM_Reject,
     /* 624171 */ // Label 7782: @624171
     /* 624171 */ GIM_Reject,
     /* 624172 */ // Label 7779: @624172
     /* 624172 */ GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(625616),
     /* 624177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 624180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 624183 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(624263), // Rule ID 11273 //
     /* 624188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624232 */     // MIs[3] src0
     /* 624232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624237 */     // MIs[3] src1
     /* 624237 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624242 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624244 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 624253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 624257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624261 */     GIR_RootConstrainSelectedInstOperands,
     /* 624262 */     // GIR_Coverage, 11273,
     /* 624262 */     GIR_EraseRootFromParent_Done,
     /* 624263 */   // Label 7835: @624263
     /* 624263 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(624343), // Rule ID 11274 //
     /* 624268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624312 */     // MIs[3] src1
     /* 624312 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624317 */     // MIs[3] src0
     /* 624317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624324 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 624333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 624337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624341 */     GIR_RootConstrainSelectedInstOperands,
     /* 624342 */     // GIR_Coverage, 11274,
     /* 624342 */     GIR_EraseRootFromParent_Done,
     /* 624343 */   // Label 7836: @624343
     /* 624343 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(624423), // Rule ID 11275 //
     /* 624348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624392 */     // MIs[3] src0
     /* 624392 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624397 */     // MIs[3] src1
     /* 624397 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624402 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624404 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 624413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 624417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624421 */     GIR_RootConstrainSelectedInstOperands,
     /* 624422 */     // GIR_Coverage, 11275,
     /* 624422 */     GIR_EraseRootFromParent_Done,
     /* 624423 */   // Label 7837: @624423
     /* 624423 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(624503), // Rule ID 11276 //
     /* 624428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624472 */     // MIs[3] src1
     /* 624472 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624477 */     // MIs[3] src0
     /* 624477 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624484 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 624493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 624497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624501 */     GIR_RootConstrainSelectedInstOperands,
     /* 624502 */     // GIR_Coverage, 11276,
     /* 624502 */     GIR_EraseRootFromParent_Done,
     /* 624503 */   // Label 7838: @624503
     /* 624503 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(624583), // Rule ID 11277 //
     /* 624508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 624532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624552 */     // MIs[3] src0
     /* 624552 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624557 */     // MIs[3] src1
     /* 624557 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624564 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 624573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 624577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 624581 */     GIR_RootConstrainSelectedInstOperands,
     /* 624582 */     // GIR_Coverage, 11277,
     /* 624582 */     GIR_EraseRootFromParent_Done,
     /* 624583 */   // Label 7839: @624583
     /* 624583 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(624663), // Rule ID 11278 //
     /* 624588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 624612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624632 */     // MIs[3] src1
     /* 624632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624637 */     // MIs[3] src0
     /* 624637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624644 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 624653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 624657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 624661 */     GIR_RootConstrainSelectedInstOperands,
     /* 624662 */     // GIR_Coverage, 11278,
     /* 624662 */     GIR_EraseRootFromParent_Done,
     /* 624663 */   // Label 7840: @624663
     /* 624663 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(624743), // Rule ID 11279 //
     /* 624668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 624692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624712 */     // MIs[3] src0
     /* 624712 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624717 */     // MIs[3] src1
     /* 624717 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624724 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 624733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 624737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 624741 */     GIR_RootConstrainSelectedInstOperands,
     /* 624742 */     // GIR_Coverage, 11279,
     /* 624742 */     GIR_EraseRootFromParent_Done,
     /* 624743 */   // Label 7841: @624743
     /* 624743 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(624823), // Rule ID 11280 //
     /* 624748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 624772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624792 */     // MIs[3] src1
     /* 624792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624797 */     // MIs[3] src0
     /* 624797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624804 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 624813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 624817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 624821 */     GIR_RootConstrainSelectedInstOperands,
     /* 624822 */     // GIR_Coverage, 11280,
     /* 624822 */     GIR_EraseRootFromParent_Done,
     /* 624823 */   // Label 7842: @624823
     /* 624823 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(624903), // Rule ID 7574 //
     /* 624828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 624852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 624868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624872 */     // MIs[3] src0
     /* 624872 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 624877 */     // MIs[3] src1
     /* 624877 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 624882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624884 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 624893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 624897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 624901 */     GIR_RootConstrainSelectedInstOperands,
     /* 624902 */     // GIR_Coverage, 7574,
     /* 624902 */     GIR_EraseRootFromParent_Done,
     /* 624903 */   // Label 7843: @624903
     /* 624903 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(624983), // Rule ID 11266 //
     /* 624908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 624924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 624928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 624932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 624940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 624944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 624948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624952 */     // MIs[3] src1
     /* 624952 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 624957 */     // MIs[3] src0
     /* 624957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 624962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624964 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 624964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 624967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 624973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 624977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 624981 */     GIR_RootConstrainSelectedInstOperands,
     /* 624982 */     // GIR_Coverage, 11266,
     /* 624982 */     GIR_EraseRootFromParent_Done,
     /* 624983 */   // Label 7844: @624983
     /* 624983 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(625063), // Rule ID 11269 //
     /* 624988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 625028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625032 */     // MIs[3] src0
     /* 625032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625037 */     // MIs[3] src1
     /* 625037 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625044 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 625053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 625057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 625061 */     GIR_RootConstrainSelectedInstOperands,
     /* 625062 */     // GIR_Coverage, 11269,
     /* 625062 */     GIR_EraseRootFromParent_Done,
     /* 625063 */   // Label 7845: @625063
     /* 625063 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(625143), // Rule ID 11270 //
     /* 625068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 625108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625112 */     // MIs[3] src1
     /* 625112 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625117 */     // MIs[3] src0
     /* 625117 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625124 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 625133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 625137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 625141 */     GIR_RootConstrainSelectedInstOperands,
     /* 625142 */     // GIR_Coverage, 11270,
     /* 625142 */     GIR_EraseRootFromParent_Done,
     /* 625143 */   // Label 7846: @625143
     /* 625143 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(625223), // Rule ID 11267 //
     /* 625148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 625188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625192 */     // MIs[3] src0
     /* 625192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625197 */     // MIs[3] src1
     /* 625197 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625204 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 625213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 625217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 625221 */     GIR_RootConstrainSelectedInstOperands,
     /* 625222 */     // GIR_Coverage, 11267,
     /* 625222 */     GIR_EraseRootFromParent_Done,
     /* 625223 */   // Label 7847: @625223
     /* 625223 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(625303), // Rule ID 11268 //
     /* 625228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 625268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625272 */     // MIs[3] src1
     /* 625272 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625277 */     // MIs[3] src0
     /* 625277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625282 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625284 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 625293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 625297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 625301 */     GIR_RootConstrainSelectedInstOperands,
     /* 625302 */     // GIR_Coverage, 11268,
     /* 625302 */     GIR_EraseRootFromParent_Done,
     /* 625303 */   // Label 7848: @625303
     /* 625303 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(625383), // Rule ID 11271 //
     /* 625308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 625348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625352 */     // MIs[3] src0
     /* 625352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625357 */     // MIs[3] src1
     /* 625357 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625364 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 625373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 625377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 625381 */     GIR_RootConstrainSelectedInstOperands,
     /* 625382 */     // GIR_Coverage, 11271,
     /* 625382 */     GIR_EraseRootFromParent_Done,
     /* 625383 */   // Label 7849: @625383
     /* 625383 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(625463), // Rule ID 11272 //
     /* 625388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 625412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 625420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 625424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 625428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625432 */     // MIs[3] src1
     /* 625432 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 625437 */     // MIs[3] src0
     /* 625437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 625442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625444 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 625447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 625453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 625457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 625461 */     GIR_RootConstrainSelectedInstOperands,
     /* 625462 */     // GIR_Coverage, 11272,
     /* 625462 */     GIR_EraseRootFromParent_Done,
     /* 625463 */   // Label 7850: @625463
     /* 625463 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(625516), // Rule ID 7708 //
     /* 625468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 625471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625491 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 625493 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35013),
     /* 625497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 625499 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umin_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_35013>>  =>  (V_MINMAX_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_U32_e64),
     /* 625502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 625508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 625512 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 625514 */     GIR_RootConstrainSelectedInstOperands,
     /* 625515 */     // GIR_Coverage, 7708,
     /* 625515 */     GIR_EraseRootFromParent_Done,
     /* 625516 */   // Label 7851: @625516
     /* 625516 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(625569), // Rule ID 13234 //
     /* 625521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 625524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 625532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 625540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 625544 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 625546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35013),
     /* 625550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 625552 */     // (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umin_oneuse>>)<<P:Predicate_anonymous_35013>>  =>  (V_MINMAX_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 625552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_U32_e64),
     /* 625555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 625561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 625565 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 625567 */     GIR_RootConstrainSelectedInstOperands,
     /* 625568 */     // GIR_Coverage, 13234,
     /* 625568 */     GIR_EraseRootFromParent_Done,
     /* 625569 */   // Label 7852: @625569
     /* 625569 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(625595), // Rule ID 50 //
     /* 625574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 625578 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13783),
     /* 625582 */     // (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13783>>  =>  (S_MAX_U32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 625582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_U32),
     /* 625587 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 625593 */     GIR_RootConstrainSelectedInstOperands,
     /* 625594 */     // GIR_Coverage, 50,
     /* 625594 */     GIR_Done,
     /* 625595 */   // Label 7853: @625595
     /* 625595 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(625615), // Rule ID 807 //
     /* 625600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625604 */     // (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MAX_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 625604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U32_e64),
     /* 625609 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 625613 */     GIR_RootConstrainSelectedInstOperands,
     /* 625614 */     // GIR_Coverage, 807,
     /* 625614 */     GIR_Done,
     /* 625615 */   // Label 7854: @625615
     /* 625615 */   GIM_Reject,
     /* 625616 */ // Label 7834: @625616
     /* 625616 */ GIM_Reject,
     /* 625617 */ // Label 7780: @625617
     /* 625617 */ GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(625688), // Rule ID 1103 //
     /* 625622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 625625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 625628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625632 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 625639 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 625646 */   // (umax:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 625646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_U16),
     /* 625649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 625656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 625661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 625666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 625671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625686 */   GIR_RootConstrainSelectedInstOperands,
     /* 625687 */   // GIR_Coverage, 1103,
     /* 625687 */   GIR_EraseRootFromParent_Done,
     /* 625688 */ // Label 7855: @625688
     /* 625688 */ GIM_Reject,
     /* 625689 */ // Label 7781: @625689
     /* 625689 */ GIM_Reject,
     /* 625690 */ // Label 92: @625690
     /* 625690 */ GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(625826),
     /* 625695 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 625698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 625701 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(625750), // Rule ID 7434 //
     /* 625706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
     /* 625709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625713 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34805),
     /* 625717 */     // (abs:{ *:[i32] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_34805>>  =>  (V_MAX_I32_e64:{ *:[i32] } (V_SUB_U32_e32:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src), ?:{ *:[i32] }:$src)
     /* 625717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 625720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e32),
     /* 625724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 625729 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 625732 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 625736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 625738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I32_e64),
     /* 625741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 625746 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 625748 */     GIR_RootConstrainSelectedInstOperands,
     /* 625749 */     // GIR_Coverage, 7434,
     /* 625749 */     GIR_EraseRootFromParent_Done,
     /* 625750 */   // Label 7857: @625750
     /* 625750 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(625776), // Rule ID 23 //
     /* 625755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 625759 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13765),
     /* 625763 */     // (abs:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13765>>  =>  (S_ABS_I32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
     /* 625763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ABS_I32),
     /* 625768 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 625774 */     GIR_RootConstrainSelectedInstOperands,
     /* 625775 */     // GIR_Coverage, 23,
     /* 625775 */     GIR_Done,
     /* 625776 */   // Label 7858: @625776
     /* 625776 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(625825), // Rule ID 7433 //
     /* 625781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625785 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34805),
     /* 625789 */     // (abs:{ *:[i32] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_34805>>  =>  (V_MAX_I32_e64:{ *:[i32] } (V_SUB_CO_U32_e32:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src), ?:{ *:[i32] }:$src)
     /* 625789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 625792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e32),
     /* 625796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 625801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 625804 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 625808 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AMDGPU::VCC*/0,
     /* 625811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 625813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I32_e64),
     /* 625816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 625821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 625823 */     GIR_RootConstrainSelectedInstOperands,
     /* 625824 */     // GIR_Coverage, 7433,
     /* 625824 */     GIR_EraseRootFromParent_Done,
     /* 625825 */   // Label 7859: @625825
     /* 625825 */   GIM_Reject,
     /* 625826 */ // Label 7856: @625826
     /* 625826 */ GIM_Reject,
     /* 625827 */ // Label 93: @625827
     /* 625827 */ GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(625860),
     /* 625832 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 625835 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(625847), // Rule ID 179 //
     /* 625840 */     // (br (bb:{ *:[Other] }):$simm16)  =>  (S_BRANCH (bb:{ *:[Other] }):$simm16)
     /* 625840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BRANCH),
     /* 625845 */     GIR_RootConstrainSelectedInstOperands,
     /* 625846 */     // GIR_Coverage, 179,
     /* 625846 */     GIR_Done,
     /* 625847 */   // Label 7861: @625847
     /* 625847 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(625859), // Rule ID 180 //
     /* 625852 */     // (br (bb:{ *:[Other] }):$simm16)  =>  (S_BRANCH_pad_s_nop (bb:{ *:[Other] }):$simm16)
     /* 625852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BRANCH_pad_s_nop),
     /* 625857 */     GIR_RootConstrainSelectedInstOperands,
     /* 625858 */     // GIR_Coverage, 180,
     /* 625858 */     GIR_Done,
     /* 625859 */   // Label 7862: @625859
     /* 625859 */   GIM_Reject,
     /* 625860 */ // Label 7860: @625860
     /* 625860 */ GIM_Reject,
     /* 625861 */ // Label 94: @625861
     /* 625861 */ GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(625959),
     /* 625866 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 625869 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7866*/ GIMT_Encode4(625958),
     /* 625880 */   /*GILLT_s32*//*Label 7864*/ GIMT_Encode4(625888),
     /* 625884 */   /*GILLT_s64*//*Label 7865*/ GIMT_Encode4(625937),
     /* 625888 */   // Label 7864: @625888
     /* 625888 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(625908), // Rule ID 10 //
     /* 625893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 625897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13760),
     /* 625901 */     // (cttz_zero_undef:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13760>>  =>  (S_FF1_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 625901 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B32),
     /* 625906 */     GIR_RootConstrainSelectedInstOperands,
     /* 625907 */     // GIR_Coverage, 10,
     /* 625907 */     GIR_Done,
     /* 625908 */   // Label 7867: @625908
     /* 625908 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(625936), // Rule ID 683 //
     /* 625913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 625924 */     // (cttz_zero_undef:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 625924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBL_B32_e64),
     /* 625927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 625934 */     GIR_RootConstrainSelectedInstOperands,
     /* 625935 */     // GIR_Coverage, 683,
     /* 625935 */     GIR_EraseRootFromParent_Done,
     /* 625936 */   // Label 7868: @625936
     /* 625936 */   GIM_Reject,
     /* 625937 */   // Label 7865: @625937
     /* 625937 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(625957), // Rule ID 8 //
     /* 625942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 625946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13760),
     /* 625950 */     // (cttz_zero_undef:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13760>>  =>  (S_FF1_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
     /* 625950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B64),
     /* 625955 */     GIR_RootConstrainSelectedInstOperands,
     /* 625956 */     // GIR_Coverage, 8,
     /* 625956 */     GIR_Done,
     /* 625957 */   // Label 7869: @625957
     /* 625957 */   GIM_Reject,
     /* 625958 */   // Label 7866: @625958
     /* 625958 */   GIM_Reject,
     /* 625959 */ // Label 7863: @625959
     /* 625959 */ GIM_Reject,
     /* 625960 */ // Label 95: @625960
     /* 625960 */ GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(626061),
     /* 625965 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 625968 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7873*/ GIMT_Encode4(626029),
     /* 625979 */   /*GILLT_s32*//*Label 7871*/ GIMT_Encode4(625987),
     /* 625983 */   /*GILLT_s64*//*Label 7872*/ GIMT_Encode4(626008),
     /* 625987 */   // Label 7871: @625987
     /* 625987 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(626007), // Rule ID 12 //
     /* 625992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 625996 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13761),
     /* 626000 */     // (ctlz_zero_undef:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13761>>  =>  (S_FLBIT_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 626000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B32),
     /* 626005 */     GIR_RootConstrainSelectedInstOperands,
     /* 626006 */     // GIR_Coverage, 12,
     /* 626006 */     GIR_Done,
     /* 626007 */   // Label 7874: @626007
     /* 626007 */   GIM_Reject,
     /* 626008 */   // Label 7872: @626008
     /* 626008 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(626028), // Rule ID 14 //
     /* 626013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 626017 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13761),
     /* 626021 */     // (ctlz_zero_undef:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13761>>  =>  (S_FLBIT_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
     /* 626021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B64),
     /* 626026 */     GIR_RootConstrainSelectedInstOperands,
     /* 626027 */     // GIR_Coverage, 14,
     /* 626027 */     GIR_Done,
     /* 626028 */   // Label 7875: @626028
     /* 626028 */   GIM_Reject,
     /* 626029 */   // Label 7873: @626029
     /* 626029 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(626060), // Rule ID 681 //
     /* 626034 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 626037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 626048 */     // (ctlz_zero_undef:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBH_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 626048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBH_U32_e64),
     /* 626051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 626058 */     GIR_RootConstrainSelectedInstOperands,
     /* 626059 */     // GIR_Coverage, 681,
     /* 626059 */     GIR_EraseRootFromParent_Done,
     /* 626060 */   // Label 7876: @626060
     /* 626060 */   GIM_Reject,
     /* 626061 */ // Label 7870: @626061
     /* 626061 */ GIM_Reject,
     /* 626062 */ // Label 96: @626062
     /* 626062 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7879*/ GIMT_Encode4(626276),
     /* 626073 */ /*GILLT_s32*//*Label 7877*/ GIMT_Encode4(626081),
     /* 626077 */ /*GILLT_s64*//*Label 7878*/ GIMT_Encode4(626168),
     /* 626081 */ // Label 7877: @626081
     /* 626081 */ GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(626110), // Rule ID 6 //
     /* 626086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 626089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 626093 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13759),
     /* 626097 */   // (ctpop:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13759>>  =>  (S_BCNT1_I32_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
     /* 626097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BCNT1_I32_B32),
     /* 626102 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 626108 */   GIR_RootConstrainSelectedInstOperands,
     /* 626109 */   // GIR_Coverage, 6,
     /* 626109 */   GIR_Done,
     /* 626110 */ // Label 7880: @626110
     /* 626110 */ GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(626139), // Rule ID 7 //
     /* 626115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 626118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 626122 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13759),
     /* 626126 */   // (ctpop:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13759>>  =>  (S_BCNT1_I32_B64:{ *:[i32] }:{ *:[i1] } i64:{ *:[i64] }:$src0)
     /* 626126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BCNT1_I32_B64),
     /* 626131 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 626137 */   GIR_RootConstrainSelectedInstOperands,
     /* 626138 */   // GIR_Coverage, 7,
     /* 626138 */   GIR_Done,
     /* 626139 */ // Label 7881: @626139
     /* 626139 */ GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(626167), // Rule ID 7020 //
     /* 626144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 626147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626151 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34225),
     /* 626155 */   // (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34225>>  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$popcnt, 0:{ *:[i32] })
     /* 626155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /* 626158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626160 */   GIR_RootToRootCopy, /*OpIdx*/1, // popcnt
     /* 626162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626165 */   GIR_RootConstrainSelectedInstOperands,
     /* 626166 */   // GIR_Coverage, 7020,
     /* 626166 */   GIR_EraseRootFromParent_Done,
     /* 626167 */ // Label 7882: @626167
     /* 626167 */ GIM_Reject,
     /* 626168 */ // Label 7878: @626168
     /* 626168 */ GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(626275), // Rule ID 1868 //
     /* 626173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 626176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 626180 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13759),
     /* 626184 */   // (ctpop:{ *:[i64] } i64:{ *:[i64] }:$src)<<P:Predicate_anonymous_13759>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_BCNT1_I32_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i64] }:$src), SReg_32:{ *:[i32] }), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 626184 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 626187 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626191 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626196 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 626199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 626201 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 626204 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_BCNT1_I32_B64),
     /* 626208 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626213 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 626217 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for AMDGPU::SCC*/0,
     /* 626220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 626222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 626225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 626229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626234 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 626237 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 626242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 626245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 626247 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626250 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 626253 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 626256 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 626259 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 626264 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 626269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 626274 */   // GIR_Coverage, 1868,
     /* 626274 */   GIR_EraseRootFromParent_Done,
     /* 626275 */ // Label 7883: @626275
     /* 626275 */ GIM_Reject,
     /* 626276 */ // Label 7879: @626276
     /* 626276 */ GIM_Reject,
     /* 626277 */ // Label 97: @626277
     /* 626277 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7888*/ GIMT_Encode4(628025),
     /* 626288 */ /*GILLT_s16*//*Label 7884*/ GIMT_Encode4(626304),
     /* 626292 */ /*GILLT_s32*//*Label 7885*/ GIMT_Encode4(626516),
     /* 626296 */ /*GILLT_s64*//*Label 7886*/ GIMT_Encode4(626803),
     /* 626300 */ /*GILLT_v2s16*//*Label 7887*/ GIMT_Encode4(627970),
     /* 626304 */ // Label 7884: @626304
     /* 626304 */ GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(626515),
     /* 626309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 626312 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(626363), // Rule ID 7453 //
     /* 626317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX8Plus),
     /* 626320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626324 */     // (bswap:{ *:[i16] } i16:{ *:[i16] }:$a)  =>  (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 626324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626336 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
     /* 626346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 626351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626356 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 626358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626361 */     GIR_RootConstrainSelectedInstOperands,
     /* 626362 */     // GIR_Coverage, 7453,
     /* 626362 */     GIR_EraseRootFromParent_Done,
     /* 626363 */   // Label 7890: @626363
     /* 626363 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(626414), // Rule ID 7455 //
     /* 626368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX8Plus),
     /* 626371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626375 */     // (bswap:{ *:[i16] } i16:{ *:[i16] }:$a)  =>  (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 626375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626387 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
     /* 626397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 626402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626407 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 626409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626412 */     GIR_RootConstrainSelectedInstOperands,
     /* 626413 */     // GIR_Coverage, 7455,
     /* 626413 */     GIR_EraseRootFromParent_Done,
     /* 626414 */   // Label 7891: @626414
     /* 626414 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(626514), // Rule ID 7457 //
     /* 626419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX8Plus),
     /* 626422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 626426 */     // (bswap:{ *:[i16] } i16:{ *:[i16] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i16] } (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, (COPY:{ *:[i16] } VGPR_16:{ *:[i16] }:$a), (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] })), lo16:{ *:[i32] })
     /* 626426 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 626429 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626433 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626438 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(202113025),
     /* 626448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 626450 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 626453 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 626457 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626462 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 626468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 626475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626480 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 626483 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 626486 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 626489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 626494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 626496 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::lo16),
     /* 626503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 626508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626513 */     // GIR_Coverage, 7457,
     /* 626513 */     GIR_EraseRootFromParent_Done,
     /* 626514 */   // Label 7892: @626514
     /* 626514 */   GIM_Reject,
     /* 626515 */ // Label 7889: @626515
     /* 626515 */ GIM_Reject,
     /* 626516 */ // Label 7885: @626516
     /* 626516 */ GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(626802),
     /* 626521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 626524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626528 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(626575), // Rule ID 7451 //
     /* 626533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 626536 */     // (bswap:{ *:[i32] } i32:{ *:[i32] }:$a)  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 66051:{ *:[i32] }))
     /* 626536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626548 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(66051),
     /* 626558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 626563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626568 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 626570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626573 */     GIR_RootConstrainSelectedInstOperands,
     /* 626574 */     // GIR_Coverage, 7451,
     /* 626574 */     GIR_EraseRootFromParent_Done,
     /* 626575 */   // Label 7894: @626575
     /* 626575 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(626673), // Rule ID 7447 //
     /* 626580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 626583 */     // (bswap:{ *:[i32] } i32:{ *:[i32] }:$a)  =>  (V_BFI_B32_e64:{ *:[i32] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i32] }:$a, VSrc_b32:{ *:[i32] }:$a, 24:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i32] }:$a, VSrc_b32:{ *:[i32] }:$a, 8:{ *:[i32] }))
     /* 626583 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 626586 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 626590 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626595 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626599 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626603 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/8,
     /* 626606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 626608 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 626611 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 626615 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626620 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626624 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626628 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/24,
     /* 626631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 626633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626645 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(16711935),
     /* 626655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 626660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 626668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 626671 */     GIR_RootConstrainSelectedInstOperands,
     /* 626672 */     // GIR_Coverage, 7447,
     /* 626672 */     GIR_EraseRootFromParent_Done,
     /* 626673 */   // Label 7895: @626673
     /* 626673 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(626801), // Rule ID 7448 //
     /* 626678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 626681 */     // (bswap:{ *:[i32] } i32:{ *:[i32] }:$a)  =>  (V_BFI_B32_e64:{ *:[i32] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, 0:{ *:[i32] }, 24:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, 0:{ *:[i32] }, 8:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] }))
     /* 626681 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 626684 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 626688 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626693 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 626696 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626700 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 626703 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626707 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 626710 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/8,
     /* 626713 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 626716 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 626719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 626721 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 626724 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 626728 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626733 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 626736 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626740 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 626743 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 626747 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 626750 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/24,
     /* 626753 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 626756 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 626759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 626761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626773 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(16711935),
     /* 626783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 626788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 626796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 626799 */     GIR_RootConstrainSelectedInstOperands,
     /* 626800 */     // GIR_Coverage, 7448,
     /* 626800 */     GIR_EraseRootFromParent_Done,
     /* 626801 */   // Label 7896: @626801
     /* 626801 */   GIM_Reject,
     /* 626802 */ // Label 7893: @626802
     /* 626802 */ GIM_Reject,
     /* 626803 */ // Label 7886: @626803
     /* 626803 */ GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(627969),
     /* 626808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 626811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 626815 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(627006), // Rule ID 7452 //
     /* 626820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 626823 */     // (bswap:{ *:[i64] } i64:{ *:[i64] }:$a)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 66051:{ *:[i32] })), sub0:{ *:[i32] }, (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 66051:{ *:[i32] })), sub1:{ *:[i32] })
     /* 626823 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
     /* 626826 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626830 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626835 */     GIR_AddImm, /*InsnID*/6, /*Imm*/GIMT_Encode8(66051),
     /* 626845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 626847 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 626850 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 626854 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626859 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 626865 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626870 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 626875 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 626878 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 626882 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626887 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 626890 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 626893 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/5,
     /* 626896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 626898 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 626901 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 626905 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626910 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(66051),
     /* 626920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 626922 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 626925 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 626929 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626934 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 626940 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626945 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 626950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 626953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 626957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 626962 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 626965 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 626968 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 626971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 626973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 626976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 626978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 626981 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 626984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 626987 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 626990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 626995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627005 */     // GIR_Coverage, 7452,
     /* 627005 */     GIR_EraseRootFromParent_Done,
     /* 627006 */   // Label 7898: @627006
     /* 627006 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(627457), // Rule ID 7449 //
     /* 627011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 627014 */     // (bswap:{ *:[i64] } i64:{ *:[i64] }:$a)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 24:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 8:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 24:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 8:{ *:[i32] })), sub1:{ *:[i32] })
     /* 627014 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 627017 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627021 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627026 */     GIR_CopySubReg, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627032 */     GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627037 */     GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627042 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 627045 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627049 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627054 */     GIR_CopySubReg, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627060 */     GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627065 */     GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627070 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s16,
     /* 627073 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 627077 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627082 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 627085 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
     /* 627088 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/8,
     /* 627091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 627093 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 627096 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627100 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627105 */     GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627111 */     GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627116 */     GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627121 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 627124 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627128 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627133 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627139 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627144 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627149 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s16,
     /* 627152 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 627156 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627161 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 627164 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/12,
     /* 627167 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/24,
     /* 627170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 627172 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s16,
     /* 627175 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 627179 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627184 */     GIR_AddImm, /*InsnID*/10, /*Imm*/GIMT_Encode8(16711935),
     /* 627194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 627196 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s16,
     /* 627199 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 627203 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627208 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 627211 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 627214 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/13,
     /* 627217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 627219 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 627222 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627226 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627231 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 627237 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627242 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627247 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 627250 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627254 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627259 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 627265 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627270 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627275 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
     /* 627278 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 627282 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627287 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 627290 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/7,
     /* 627293 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/8,
     /* 627296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 627298 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 627301 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627305 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627310 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 627316 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627321 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627326 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 627329 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627333 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627338 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 627344 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627349 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627354 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 627357 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 627361 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627366 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 627369 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 627372 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/24,
     /* 627375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 627377 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 627380 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 627384 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627389 */     GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(16711935),
     /* 627399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 627401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 627404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 627408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627413 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 627416 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 627419 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 627422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 627424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 627427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 627429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 627432 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 627435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 627438 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 627441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627456 */     // GIR_Coverage, 7449,
     /* 627456 */     GIR_EraseRootFromParent_Done,
     /* 627457 */   // Label 7899: @627457
     /* 627457 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(627968), // Rule ID 7450 //
     /* 627462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 627465 */     // (bswap:{ *:[i64] } i64:{ *:[i64] }:$a)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 0:{ *:[i32] }, 24:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 0:{ *:[i32] }, 8:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 0:{ *:[i32] }, 24:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 0:{ *:[i32] }, 8:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] })), sub1:{ *:[i32] })
     /* 627465 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 627468 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627472 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627477 */     GIR_CopySubReg, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627483 */     GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627488 */     GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627493 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 627496 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627500 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627505 */     GIR_CopySubReg, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627511 */     GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627516 */     GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627521 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s16,
     /* 627524 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 627528 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627533 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 627536 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 627539 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 627542 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
     /* 627545 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 627548 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/8,
     /* 627551 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 627554 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 627557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 627559 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 627562 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627566 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627571 */     GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627577 */     GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627582 */     GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627587 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 627590 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627594 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627599 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 627605 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627610 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627615 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s16,
     /* 627618 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 627622 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627627 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 627630 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 627633 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 627636 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/12,
     /* 627639 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 627642 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/24,
     /* 627645 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 627648 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 627651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 627653 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s16,
     /* 627656 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 627660 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627665 */     GIR_AddImm, /*InsnID*/10, /*Imm*/GIMT_Encode8(16711935),
     /* 627675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 627677 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s16,
     /* 627680 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 627684 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627689 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 627692 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 627695 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/13,
     /* 627698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 627700 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 627703 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627707 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627712 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 627718 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627723 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627728 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 627731 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627735 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627740 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 627746 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627751 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627756 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
     /* 627759 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 627763 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627768 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 627771 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 627774 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 627777 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/7,
     /* 627780 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 627783 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/8,
     /* 627786 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 627789 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 627792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 627794 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 627797 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627801 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627806 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 627812 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627817 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627822 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 627825 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 627829 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627834 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 627840 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627845 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627850 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 627853 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 627857 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627862 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 627865 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 627868 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 627871 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 627874 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 627877 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/24,
     /* 627880 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 627883 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 627886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 627888 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 627891 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 627895 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627900 */     GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(16711935),
     /* 627910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 627912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 627915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 627919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627924 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 627927 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 627930 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 627933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 627935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 627938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 627940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 627943 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 627946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 627949 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 627952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 627957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627967 */     // GIR_Coverage, 7450,
     /* 627967 */     GIR_EraseRootFromParent_Done,
     /* 627968 */   // Label 7900: @627968
     /* 627968 */   GIM_Reject,
     /* 627969 */ // Label 7897: @627969
     /* 627969 */ GIM_Reject,
     /* 627970 */ // Label 7887: @627970
     /* 627970 */ GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(628024), // Rule ID 7459 //
     /* 627975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 627978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 627981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627985 */   // (bswap:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a)  =>  (V_PERM_B32_e64:{ *:[v2i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[v2i16] }:$a, (S_MOV_B32:{ *:[i16] } 33751041:{ *:[i32] }))
     /* 627985 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 627988 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 627992 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 627997 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(33751041),
     /* 628007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 628009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 628012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628017 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 628019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 628022 */   GIR_RootConstrainSelectedInstOperands,
     /* 628023 */   // GIR_Coverage, 7459,
     /* 628023 */   GIR_EraseRootFromParent_Done,
     /* 628024 */ // Label 7901: @628024
     /* 628024 */ GIM_Reject,
     /* 628025 */ // Label 7888: @628025
     /* 628025 */ GIM_Reject,
     /* 628026 */ // Label 98: @628026
     /* 628026 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7904*/ GIMT_Encode4(628273),
     /* 628037 */ /*GILLT_s32*//*Label 7902*/ GIMT_Encode4(628045),
     /* 628041 */ /*GILLT_s64*//*Label 7903*/ GIMT_Encode4(628107),
     /* 628045 */ // Label 7902: @628045
     /* 628045 */ GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(628106),
     /* 628050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 628053 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(628073), // Rule ID 4 //
     /* 628058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 628062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13758),
     /* 628066 */     // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13758>>  =>  (S_BREV_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 628066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BREV_B32),
     /* 628071 */     GIR_RootConstrainSelectedInstOperands,
     /* 628072 */     // GIR_Coverage, 4,
     /* 628072 */     GIR_Done,
     /* 628073 */   // Label 7906: @628073
     /* 628073 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(628105), // Rule ID 680 //
     /* 628078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628082 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_18365),
     /* 628086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628093 */     // (bitreverse:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))<<P:Predicate_anonymous_18365>>  =>  (V_BFREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 628093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFREV_B32_e64),
     /* 628096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628103 */     GIR_RootConstrainSelectedInstOperands,
     /* 628104 */     // GIR_Coverage, 680,
     /* 628104 */     GIR_EraseRootFromParent_Done,
     /* 628105 */   // Label 7907: @628105
     /* 628105 */   GIM_Reject,
     /* 628106 */ // Label 7905: @628106
     /* 628106 */ GIM_Reject,
     /* 628107 */ // Label 7903: @628107
     /* 628107 */ GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(628272),
     /* 628112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 628115 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(628135), // Rule ID 5 //
     /* 628120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 628124 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13758),
     /* 628128 */     // (bitreverse:{ *:[i64] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13758>>  =>  (S_BREV_B64:{ *:[i64] } i64:{ *:[i64] }:$src0)
     /* 628128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BREV_B64),
     /* 628133 */     GIR_RootConstrainSelectedInstOperands,
     /* 628134 */     // GIR_Coverage, 5,
     /* 628134 */     GIR_Done,
     /* 628135 */   // Label 7909: @628135
     /* 628135 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(628271), // Rule ID 7460 //
     /* 628140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628144 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_18365),
     /* 628148 */     // (bitreverse:{ *:[i64] } i64:{ *:[i64] }:$a)<<P:Predicate_anonymous_18365>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFREV_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFREV_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] })), sub1:{ *:[i32] })
     /* 628148 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 628151 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 628155 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628160 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 628166 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628171 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628176 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 628179 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFREV_B32_e64),
     /* 628183 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628188 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 628191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 628193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 628196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 628200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628205 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 628211 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628216 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 628224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFREV_B32_e64),
     /* 628228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628233 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 628236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 628238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 628241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 628243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 628246 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 628249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 628252 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 628255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628270 */     // GIR_Coverage, 7460,
     /* 628270 */     GIR_EraseRootFromParent_Done,
     /* 628271 */   // Label 7910: @628271
     /* 628271 */   GIM_Reject,
     /* 628272 */ // Label 7908: @628272
     /* 628272 */ GIM_Reject,
     /* 628273 */ // Label 7904: @628273
     /* 628273 */ GIM_Reject,
     /* 628274 */ // Label 99: @628274
     /* 628274 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 7914*/ GIMT_Encode4(628601),
     /* 628285 */ /*GILLT_s16*//*Label 7911*/ GIMT_Encode4(628297),
     /* 628289 */ /*GILLT_s32*//*Label 7912*/ GIMT_Encode4(628471),
     /* 628293 */ /*GILLT_s64*//*Label 7913*/ GIMT_Encode4(628551),
     /* 628297 */ // Label 7911: @628297
     /* 628297 */ GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(628470),
     /* 628302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 628305 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(628332), // Rule ID 37 //
     /* 628310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 628313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 628317 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13771),
     /* 628321 */     // (fceil:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13771>>  =>  (S_CEIL_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
     /* 628321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CEIL_F16),
     /* 628326 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 628330 */     GIR_RootConstrainSelectedInstOperands,
     /* 628331 */     // GIR_Coverage, 37,
     /* 628331 */     GIR_Done,
     /* 628332 */   // Label 7916: @628332
     /* 628332 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(628378), // Rule ID 768 //
     /* 628337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 628340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628351 */     // (fceil:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 628351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F16_e64),
     /* 628354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628376 */     GIR_RootConstrainSelectedInstOperands,
     /* 628377 */     // GIR_Coverage, 768,
     /* 628377 */     GIR_EraseRootFromParent_Done,
     /* 628378 */   // Label 7917: @628378
     /* 628378 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(628424), // Rule ID 770 //
     /* 628383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 628386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628397 */     // (fceil:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 628397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F16_fake16_e64),
     /* 628400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628422 */     GIR_RootConstrainSelectedInstOperands,
     /* 628423 */     // GIR_Coverage, 770,
     /* 628423 */     GIR_EraseRootFromParent_Done,
     /* 628424 */   // Label 7918: @628424
     /* 628424 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(628469), // Rule ID 769 //
     /* 628429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 628432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 628436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 628443 */     // (fceil:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CEIL_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 628443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F16_t16_e64),
     /* 628446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628467 */     GIR_RootConstrainSelectedInstOperands,
     /* 628468 */     // GIR_Coverage, 769,
     /* 628468 */     GIR_EraseRootFromParent_Done,
     /* 628469 */   // Label 7919: @628469
     /* 628469 */   GIM_Reject,
     /* 628470 */ // Label 7915: @628470
     /* 628470 */ GIM_Reject,
     /* 628471 */ // Label 7912: @628471
     /* 628471 */ GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(628550),
     /* 628476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 628479 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(628506), // Rule ID 32 //
     /* 628484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 628487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 628491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13771),
     /* 628495 */     // (fceil:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13771>>  =>  (S_CEIL_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
     /* 628495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CEIL_F32),
     /* 628500 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 628504 */     GIR_RootConstrainSelectedInstOperands,
     /* 628505 */     // GIR_Coverage, 32,
     /* 628505 */     GIR_Done,
     /* 628506 */   // Label 7921: @628506
     /* 628506 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(628549), // Rule ID 658 //
     /* 628511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628522 */     // (fceil:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 628522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F32_e64),
     /* 628525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628547 */     GIR_RootConstrainSelectedInstOperands,
     /* 628548 */     // GIR_Coverage, 658,
     /* 628548 */     GIR_EraseRootFromParent_Done,
     /* 628549 */   // Label 7922: @628549
     /* 628549 */   GIM_Reject,
     /* 628550 */ // Label 7920: @628550
     /* 628550 */ GIM_Reject,
     /* 628551 */ // Label 7913: @628551
     /* 628551 */ GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(628600), // Rule ID 702 //
     /* 628556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
     /* 628559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 628562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 628566 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628573 */   // (fceil:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 628573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F64_e64),
     /* 628576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628598 */   GIR_RootConstrainSelectedInstOperands,
     /* 628599 */   // GIR_Coverage, 702,
     /* 628599 */   GIR_EraseRootFromParent_Done,
     /* 628600 */ // Label 7923: @628600
     /* 628600 */ GIM_Reject,
     /* 628601 */ // Label 7914: @628601
     /* 628601 */ GIM_Reject,
     /* 628602 */ // Label 100: @628602
     /* 628602 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 7926*/ GIMT_Encode4(628893),
     /* 628613 */ /*GILLT_s16*//*Label 7924*/ GIMT_Encode4(628621),
     /* 628617 */ /*GILLT_s32*//*Label 7925*/ GIMT_Encode4(628839),
     /* 628621 */ // Label 7924: @628621
     /* 628621 */ GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(628838),
     /* 628626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 628629 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(628700), // Rule ID 2697 //
     /* 628634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 628637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 628641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21536),
     /* 628645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628652 */     // (fsqrt:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21536>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_SQRT_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 628652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 628655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F16_e64),
     /* 628659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 628664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 628686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 628689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 628691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 628694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 628699 */     // GIR_Coverage, 2697,
     /* 628699 */     GIR_EraseRootFromParent_Done,
     /* 628700 */   // Label 7928: @628700
     /* 628700 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(628746), // Rule ID 723 //
     /* 628705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 628708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628719 */     // (fsqrt:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 628719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_e64),
     /* 628722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628744 */     GIR_RootConstrainSelectedInstOperands,
     /* 628745 */     // GIR_Coverage, 723,
     /* 628745 */     GIR_EraseRootFromParent_Done,
     /* 628746 */   // Label 7929: @628746
     /* 628746 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(628792), // Rule ID 727 //
     /* 628751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 628754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628765 */     // (fsqrt:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 628765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_fake16_e64),
     /* 628768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628790 */     GIR_RootConstrainSelectedInstOperands,
     /* 628791 */     // GIR_Coverage, 727,
     /* 628791 */     GIR_EraseRootFromParent_Done,
     /* 628792 */   // Label 7930: @628792
     /* 628792 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(628837), // Rule ID 725 //
     /* 628797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 628800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 628804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 628811 */     // (fsqrt:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_SQRT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 628811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_t16_e64),
     /* 628814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628835 */     GIR_RootConstrainSelectedInstOperands,
     /* 628836 */     // GIR_Coverage, 725,
     /* 628836 */     GIR_EraseRootFromParent_Done,
     /* 628837 */   // Label 7931: @628837
     /* 628837 */   GIM_Reject,
     /* 628838 */ // Label 7927: @628838
     /* 628838 */ GIM_Reject,
     /* 628839 */ // Label 7925: @628839
     /* 628839 */ GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(628892), // Rule ID 1083 //
     /* 628844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 628847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 628850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 628854 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21536),
     /* 628858 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628865 */   // (fsqrt:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21536>>  =>  (V_S_SQRT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 628865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F32_e64),
     /* 628868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628890 */   GIR_RootConstrainSelectedInstOperands,
     /* 628891 */   // GIR_Coverage, 1083,
     /* 628891 */   GIR_EraseRootFromParent_Done,
     /* 628892 */ // Label 7932: @628892
     /* 628892 */ GIM_Reject,
     /* 628893 */ // Label 7926: @628893
     /* 628893 */ GIM_Reject,
     /* 628894 */ // Label 101: @628894
     /* 628894 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 7936*/ GIMT_Encode4(629407),
     /* 628905 */ /*GILLT_s16*//*Label 7933*/ GIMT_Encode4(628917),
     /* 628909 */ /*GILLT_s32*//*Label 7934*/ GIMT_Encode4(629091),
     /* 628913 */ /*GILLT_s64*//*Label 7935*/ GIMT_Encode4(629171),
     /* 628917 */ // Label 7933: @628917
     /* 628917 */ GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(629090),
     /* 628922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 628925 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(628952), // Rule ID 38 //
     /* 628930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 628933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 628937 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13772),
     /* 628941 */     // (ffloor:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13772>>  =>  (S_FLOOR_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
     /* 628941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLOOR_F16),
     /* 628946 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 628950 */     GIR_RootConstrainSelectedInstOperands,
     /* 628951 */     // GIR_Coverage, 38,
     /* 628951 */     GIR_Done,
     /* 628952 */   // Label 7938: @628952
     /* 628952 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(628998), // Rule ID 765 //
     /* 628957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 628960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 628971 */     // (ffloor:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 628971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F16_e64),
     /* 628974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 628991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 628996 */     GIR_RootConstrainSelectedInstOperands,
     /* 628997 */     // GIR_Coverage, 765,
     /* 628997 */     GIR_EraseRootFromParent_Done,
     /* 628998 */   // Label 7939: @628998
     /* 628998 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(629044), // Rule ID 767 //
     /* 629003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 629006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629017 */     // (ffloor:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F16_fake16_e64),
     /* 629020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629042 */     GIR_RootConstrainSelectedInstOperands,
     /* 629043 */     // GIR_Coverage, 767,
     /* 629043 */     GIR_EraseRootFromParent_Done,
     /* 629044 */   // Label 7940: @629044
     /* 629044 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(629089), // Rule ID 766 //
     /* 629049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 629052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 629056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 629063 */     // (ffloor:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FLOOR_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 629063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F16_t16_e64),
     /* 629066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629087 */     GIR_RootConstrainSelectedInstOperands,
     /* 629088 */     // GIR_Coverage, 766,
     /* 629088 */     GIR_EraseRootFromParent_Done,
     /* 629089 */   // Label 7941: @629089
     /* 629089 */   GIM_Reject,
     /* 629090 */ // Label 7937: @629090
     /* 629090 */ GIM_Reject,
     /* 629091 */ // Label 7934: @629091
     /* 629091 */ GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(629170),
     /* 629096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 629099 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(629126), // Rule ID 33 //
     /* 629104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 629107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 629111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13772),
     /* 629115 */     // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13772>>  =>  (S_FLOOR_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
     /* 629115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLOOR_F32),
     /* 629120 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 629124 */     GIR_RootConstrainSelectedInstOperands,
     /* 629125 */     // GIR_Coverage, 33,
     /* 629125 */     GIR_Done,
     /* 629126 */   // Label 7943: @629126
     /* 629126 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(629169), // Rule ID 660 //
     /* 629131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629142 */     // (ffloor:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F32_e64),
     /* 629145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629167 */     GIR_RootConstrainSelectedInstOperands,
     /* 629168 */     // GIR_Coverage, 660,
     /* 629168 */     GIR_EraseRootFromParent_Done,
     /* 629169 */   // Label 7944: @629169
     /* 629169 */   GIM_Reject,
     /* 629170 */ // Label 7942: @629170
     /* 629170 */ GIM_Reject,
     /* 629171 */ // Label 7935: @629171
     /* 629171 */ GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(629406),
     /* 629176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 629179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 629183 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(629363), // Rule ID 7556 //
     /* 629188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6),
     /* 629191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 629198 */     // (ffloor:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$x, i32:{ *:[i32] }:$mods))  =>  (V_ADD_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$mods, ?:{ *:[f64] }:$x, 1:{ *:[i32] }, (V_CNDMASK_B64_PSEUDO:{ *:[i64] } (V_MIN_F64_e64:{ *:[i64] } 0:{ *:[i32] }, (V_FRACT_F64_e64:{ *:[i64] } ?:{ *:[i32] }:$mods, ?:{ *:[f64] }:$x), 0:{ *:[i32] }, (V_MOV_B64_PSEUDO:{ *:[i64] } 4607182418800017407:{ *:[i64] })), ?:{ *:[f64] }:$x, (V_CMP_CLASS_F64_e64:{ *:[i1] } 0:{ *:[i32] }, ?:{ *:[f64] }:$x, 3:{ *:[i32] })))
     /* 629198 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
     /* 629201 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F64_e64),
     /* 629205 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 629210 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/0,
     /* 629213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
     /* 629218 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/3,
     /* 629221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 629223 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 629226 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 629230 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 629235 */     GIR_AddImm, /*InsnID*/4, /*Imm*/GIMT_Encode8(4607182418800017407),
     /* 629245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 629247 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 629250 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F64_e64),
     /* 629254 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 629259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // mods
     /* 629264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
     /* 629269 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 629272 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 629275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 629277 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 629280 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 629284 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 629289 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 629292 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 629295 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 629298 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 629301 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 629304 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 629307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 629309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 629312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B64_PSEUDO),
     /* 629316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 629321 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 629324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
     /* 629329 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 629332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 629334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 629337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // mods
     /* 629344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
     /* 629349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 629352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 629355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629361 */     GIR_RootConstrainSelectedInstOperands,
     /* 629362 */     // GIR_Coverage, 7556,
     /* 629362 */     GIR_EraseRootFromParent_Done,
     /* 629363 */   // Label 7946: @629363
     /* 629363 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(629405), // Rule ID 704 //
     /* 629368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
     /* 629371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629378 */     // (ffloor:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F64_e64),
     /* 629381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629403 */     GIR_RootConstrainSelectedInstOperands,
     /* 629404 */     // GIR_Coverage, 704,
     /* 629404 */     GIR_EraseRootFromParent_Done,
     /* 629405 */   // Label 7947: @629405
     /* 629405 */   GIM_Reject,
     /* 629406 */ // Label 7945: @629406
     /* 629406 */ GIM_Reject,
     /* 629407 */ // Label 7936: @629407
     /* 629407 */ GIM_Reject,
     /* 629408 */ // Label 102: @629408
     /* 629408 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 7953*/ GIMT_Encode4(630369),
     /* 629419 */ /*GILLT_s16*//*Label 7948*/ GIMT_Encode4(629439),
     /* 629423 */ /*GILLT_s32*//*Label 7949*/ GIMT_Encode4(629801),
     /* 629427 */ /*GILLT_s64*//*Label 7950*/ GIMT_Encode4(629969),
     /* 629431 */ /*GILLT_v2s16*//*Label 7951*/ GIMT_Encode4(630222),
     /* 629435 */ /*GILLT_v2s32*//*Label 7952*/ GIMT_Encode4(630294),
     /* 629439 */ // Label 7948: @629439
     /* 629439 */ GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(629800),
     /* 629444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 629447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 629450 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(629485), // Rule ID 96 //
     /* 629455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 629458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 629462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 629466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 629470 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13797),
     /* 629474 */     // (strict_fadd:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13797>>  =>  (S_ADD_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 629474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F16),
     /* 629479 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 629483 */     GIR_RootConstrainSelectedInstOperands,
     /* 629484 */     // GIR_Coverage, 96,
     /* 629484 */     GIR_Done,
     /* 629485 */   // Label 7955: @629485
     /* 629485 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(629548), // Rule ID 858 //
     /* 629490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 629493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 629511 */     // (strict_fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
     /* 629514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 629531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 629536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629546 */     GIR_RootConstrainSelectedInstOperands,
     /* 629547 */     // GIR_Coverage, 858,
     /* 629547 */     GIR_EraseRootFromParent_Done,
     /* 629548 */   // Label 7956: @629548
     /* 629548 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(629611), // Rule ID 862 //
     /* 629553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 629556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 629574 */     // (strict_fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
     /* 629577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 629594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 629599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629609 */     GIR_RootConstrainSelectedInstOperands,
     /* 629610 */     // GIR_Coverage, 862,
     /* 629610 */     GIR_EraseRootFromParent_Done,
     /* 629611 */   // Label 7957: @629611
     /* 629611 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(629674), // Rule ID 8420 //
     /* 629616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 629619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 629630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629637 */     // (strict_fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
     /* 629640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 629647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 629652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 629657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 629662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 629667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 629672 */     GIR_RootConstrainSelectedInstOperands,
     /* 629673 */     // GIR_Coverage, 8420,
     /* 629673 */     GIR_EraseRootFromParent_Done,
     /* 629674 */   // Label 7958: @629674
     /* 629674 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(629737), // Rule ID 8422 //
     /* 629679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 629682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 629693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629700 */     // (strict_fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
     /* 629703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 629710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 629715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 629720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 629725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 629730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 629735 */     GIR_RootConstrainSelectedInstOperands,
     /* 629736 */     // GIR_Coverage, 8422,
     /* 629736 */     GIR_EraseRootFromParent_Done,
     /* 629737 */   // Label 7959: @629737
     /* 629737 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(629799), // Rule ID 860 //
     /* 629742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 629745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 629749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 629756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 629763 */     // (strict_fadd:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 629763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_t16_e64),
     /* 629766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 629783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 629788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 629797 */     GIR_RootConstrainSelectedInstOperands,
     /* 629798 */     // GIR_Coverage, 860,
     /* 629798 */     GIR_EraseRootFromParent_Done,
     /* 629799 */   // Label 7960: @629799
     /* 629799 */   GIM_Reject,
     /* 629800 */ // Label 7954: @629800
     /* 629800 */ GIM_Reject,
     /* 629801 */ // Label 7949: @629801
     /* 629801 */ GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(629968),
     /* 629806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 629809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 629812 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(629847), // Rule ID 88 //
     /* 629817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 629820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 629824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 629828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 629832 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13797),
     /* 629836 */     // (strict_fadd:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13797>>  =>  (S_ADD_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 629836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F32),
     /* 629841 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 629845 */     GIR_RootConstrainSelectedInstOperands,
     /* 629846 */     // GIR_Coverage, 88,
     /* 629846 */     GIR_Done,
     /* 629847 */   // Label 7962: @629847
     /* 629847 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(629907), // Rule ID 784 //
     /* 629852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 629870 */     // (strict_fadd:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
     /* 629873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 629880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 629885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 629890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 629895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 629900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 629905 */     GIR_RootConstrainSelectedInstOperands,
     /* 629906 */     // GIR_Coverage, 784,
     /* 629906 */     GIR_EraseRootFromParent_Done,
     /* 629907 */   // Label 7963: @629907
     /* 629907 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(629967), // Rule ID 8409 //
     /* 629912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 629923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629930 */     // (strict_fadd:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 629930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
     /* 629933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 629940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 629945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 629950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 629955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 629960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 629965 */     GIR_RootConstrainSelectedInstOperands,
     /* 629966 */     // GIR_Coverage, 8409,
     /* 629966 */     GIR_EraseRootFromParent_Done,
     /* 629967 */   // Label 7964: @629967
     /* 629967 */   GIM_Reject,
     /* 629968 */ // Label 7961: @629968
     /* 629968 */ GIM_Reject,
     /* 629969 */ // Label 7950: @629969
     /* 629969 */ GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(630221),
     /* 629974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 629977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 629980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 629984 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(630043), // Rule ID 912 //
     /* 629989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 629992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 629999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630006 */     // (strict_fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
     /* 630009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 630036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 630041 */     GIR_RootConstrainSelectedInstOperands,
     /* 630042 */     // GIR_Coverage, 912,
     /* 630042 */     GIR_EraseRootFromParent_Done,
     /* 630043 */   // Label 7966: @630043
     /* 630043 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(630102), // Rule ID 930 //
     /* 630048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 630051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630065 */     // (strict_fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 630068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 630095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 630100 */     GIR_RootConstrainSelectedInstOperands,
     /* 630101 */     // GIR_Coverage, 930,
     /* 630101 */     GIR_EraseRootFromParent_Done,
     /* 630102 */   // Label 7967: @630102
     /* 630102 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(630161), // Rule ID 8438 //
     /* 630107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 630110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630124 */     // (strict_fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
     /* 630127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 630134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 630139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 630144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 630149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 630154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 630159 */     GIR_RootConstrainSelectedInstOperands,
     /* 630160 */     // GIR_Coverage, 8438,
     /* 630160 */     GIR_EraseRootFromParent_Done,
     /* 630161 */   // Label 7968: @630161
     /* 630161 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(630220), // Rule ID 8451 //
     /* 630166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 630169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630183 */     // (strict_fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 630186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 630193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 630198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 630203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 630208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 630213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 630218 */     GIR_RootConstrainSelectedInstOperands,
     /* 630219 */     // GIR_Coverage, 8451,
     /* 630219 */     GIR_EraseRootFromParent_Done,
     /* 630220 */   // Label 7969: @630220
     /* 630220 */   GIM_Reject,
     /* 630221 */ // Label 7965: @630221
     /* 630221 */ GIM_Reject,
     /* 630222 */ // Label 7951: @630222
     /* 630222 */ GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(630293), // Rule ID 1090 //
     /* 630227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 630230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 630233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630237 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 630244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 630251 */   // (strict_fadd:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 630251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F16),
     /* 630254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630291 */   GIR_RootConstrainSelectedInstOperands,
     /* 630292 */   // GIR_Coverage, 1090,
     /* 630292 */   GIR_EraseRootFromParent_Done,
     /* 630293 */ // Label 7970: @630293
     /* 630293 */ GIM_Reject,
     /* 630294 */ // Label 7952: @630294
     /* 630294 */ GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(630368), // Rule ID 1311 //
     /* 630299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 630302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 630305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 630308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 630312 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 630319 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 630326 */   // (strict_fadd:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
     /* 630326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F32),
     /* 630329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630331 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630366 */   GIR_RootConstrainSelectedInstOperands,
     /* 630367 */   // GIR_Coverage, 1311,
     /* 630367 */   GIR_EraseRootFromParent_Done,
     /* 630368 */ // Label 7971: @630368
     /* 630368 */ GIM_Reject,
     /* 630369 */ // Label 7953: @630369
     /* 630369 */ GIM_Reject,
     /* 630370 */ // Label 103: @630370
     /* 630370 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 7974*/ GIMT_Encode4(630733),
     /* 630381 */ /*GILLT_s16*//*Label 7972*/ GIMT_Encode4(630389),
     /* 630385 */ /*GILLT_s32*//*Label 7973*/ GIMT_Encode4(630625),
     /* 630389 */ // Label 7972: @630389
     /* 630389 */ GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(630624),
     /* 630394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 630397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 630400 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(630435), // Rule ID 104 //
     /* 630405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 630408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630420 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13801),
     /* 630424 */     // (strict_fsub:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13801>>  =>  (S_SUB_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 630424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F16),
     /* 630429 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 630433 */     GIR_RootConstrainSelectedInstOperands,
     /* 630434 */     // GIR_Coverage, 104,
     /* 630434 */     GIR_Done,
     /* 630435 */   // Label 7976: @630435
     /* 630435 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(630498), // Rule ID 864 //
     /* 630440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 630443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630461 */     // (strict_fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_e64),
     /* 630464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 630491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 630496 */     GIR_RootConstrainSelectedInstOperands,
     /* 630497 */     // GIR_Coverage, 864,
     /* 630497 */     GIR_EraseRootFromParent_Done,
     /* 630498 */   // Label 7977: @630498
     /* 630498 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(630561), // Rule ID 868 //
     /* 630503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 630506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630524 */     // (strict_fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_fake16_e64),
     /* 630527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 630554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 630559 */     GIR_RootConstrainSelectedInstOperands,
     /* 630560 */     // GIR_Coverage, 868,
     /* 630560 */     GIR_EraseRootFromParent_Done,
     /* 630561 */   // Label 7978: @630561
     /* 630561 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(630623), // Rule ID 866 //
     /* 630566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 630569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 630573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 630580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 630587 */     // (strict_fsub:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 630587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_t16_e64),
     /* 630590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630621 */     GIR_RootConstrainSelectedInstOperands,
     /* 630622 */     // GIR_Coverage, 866,
     /* 630622 */     GIR_EraseRootFromParent_Done,
     /* 630623 */   // Label 7979: @630623
     /* 630623 */   GIM_Reject,
     /* 630624 */ // Label 7975: @630624
     /* 630624 */ GIM_Reject,
     /* 630625 */ // Label 7973: @630625
     /* 630625 */ GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(630732),
     /* 630630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 630633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 630636 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(630671), // Rule ID 106 //
     /* 630641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 630644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13801),
     /* 630660 */     // (strict_fsub:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13801>>  =>  (S_SUB_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 630660 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F32),
     /* 630665 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 630669 */     GIR_RootConstrainSelectedInstOperands,
     /* 630670 */     // GIR_Coverage, 106,
     /* 630670 */     GIR_Done,
     /* 630671 */   // Label 7981: @630671
     /* 630671 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(630731), // Rule ID 786 //
     /* 630676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630694 */     // (strict_fsub:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F32_e64),
     /* 630697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 630724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 630729 */     GIR_RootConstrainSelectedInstOperands,
     /* 630730 */     // GIR_Coverage, 786,
     /* 630730 */     GIR_EraseRootFromParent_Done,
     /* 630731 */   // Label 7982: @630731
     /* 630731 */   GIM_Reject,
     /* 630732 */ // Label 7980: @630732
     /* 630732 */ GIM_Reject,
     /* 630733 */ // Label 7974: @630733
     /* 630733 */ GIM_Reject,
     /* 630734 */ // Label 104: @630734
     /* 630734 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 7988*/ GIMT_Encode4(632001),
     /* 630745 */ /*GILLT_s16*//*Label 7983*/ GIMT_Encode4(630765),
     /* 630749 */ /*GILLT_s32*//*Label 7984*/ GIMT_Encode4(631127),
     /* 630753 */ /*GILLT_s64*//*Label 7985*/ GIMT_Encode4(631295),
     /* 630757 */ /*GILLT_v2s16*//*Label 7986*/ GIMT_Encode4(631854),
     /* 630761 */ /*GILLT_v2s32*//*Label 7987*/ GIMT_Encode4(631926),
     /* 630765 */ // Label 7983: @630765
     /* 630765 */ GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(631126),
     /* 630770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 630773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 630776 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(630811), // Rule ID 98 //
     /* 630781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 630784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630796 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13800),
     /* 630800 */     // (strict_fmul:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13800>>  =>  (S_MUL_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 630800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F16),
     /* 630805 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 630809 */     GIR_RootConstrainSelectedInstOperands,
     /* 630810 */     // GIR_Coverage, 98,
     /* 630810 */     GIR_Done,
     /* 630811 */   // Label 7990: @630811
     /* 630811 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(630874), // Rule ID 870 //
     /* 630816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 630819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630837 */     // (strict_fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 630840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 630867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 630872 */     GIR_RootConstrainSelectedInstOperands,
     /* 630873 */     // GIR_Coverage, 870,
     /* 630873 */     GIR_EraseRootFromParent_Done,
     /* 630874 */   // Label 7991: @630874
     /* 630874 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(630937), // Rule ID 874 //
     /* 630879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 630882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630900 */     // (strict_fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 630903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 630930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 630935 */     GIR_RootConstrainSelectedInstOperands,
     /* 630936 */     // GIR_Coverage, 874,
     /* 630936 */     GIR_EraseRootFromParent_Done,
     /* 630937 */   // Label 7992: @630937
     /* 630937 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(631000), // Rule ID 8424 //
     /* 630942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 630945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 630956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630963 */     // (strict_fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 630963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 630966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 630973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 630978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 630983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 630988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 630993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 630998 */     GIR_RootConstrainSelectedInstOperands,
     /* 630999 */     // GIR_Coverage, 8424,
     /* 630999 */     GIR_EraseRootFromParent_Done,
     /* 631000 */   // Label 7993: @631000
     /* 631000 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(631063), // Rule ID 8426 //
     /* 631005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 631008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 631026 */     // (strict_fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 631026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 631029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 631036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 631041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 631046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 631051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 631056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 631061 */     GIR_RootConstrainSelectedInstOperands,
     /* 631062 */     // GIR_Coverage, 8426,
     /* 631062 */     GIR_EraseRootFromParent_Done,
     /* 631063 */   // Label 7994: @631063
     /* 631063 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(631125), // Rule ID 872 //
     /* 631068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 631071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 631075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 631082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 631089 */     // (strict_fmul:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 631089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
     /* 631092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 631099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 631109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 631114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631123 */     GIR_RootConstrainSelectedInstOperands,
     /* 631124 */     // GIR_Coverage, 872,
     /* 631124 */     GIR_EraseRootFromParent_Done,
     /* 631125 */   // Label 7995: @631125
     /* 631125 */   GIM_Reject,
     /* 631126 */ // Label 7989: @631126
     /* 631126 */ GIM_Reject,
     /* 631127 */ // Label 7984: @631127
     /* 631127 */ GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(631294),
     /* 631132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 631135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 631138 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(631173), // Rule ID 94 //
     /* 631143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 631146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 631150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 631154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 631158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13800),
     /* 631162 */     // (strict_fmul:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13800>>  =>  (S_MUL_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 631162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F32),
     /* 631167 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 631171 */     GIR_RootConstrainSelectedInstOperands,
     /* 631172 */     // GIR_Coverage, 94,
     /* 631172 */     GIR_Done,
     /* 631173 */   // Label 7997: @631173
     /* 631173 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(631233), // Rule ID 790 //
     /* 631178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 631189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631196 */     // (strict_fmul:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 631196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 631199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 631206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 631216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 631221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 631226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 631231 */     GIR_RootConstrainSelectedInstOperands,
     /* 631232 */     // GIR_Coverage, 790,
     /* 631232 */     GIR_EraseRootFromParent_Done,
     /* 631233 */   // Label 7998: @631233
     /* 631233 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(631293), // Rule ID 8413 //
     /* 631238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 631256 */     // (strict_fmul:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 631256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 631259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 631266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 631271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 631276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 631281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 631286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 631291 */     GIR_RootConstrainSelectedInstOperands,
     /* 631292 */     // GIR_Coverage, 8413,
     /* 631292 */     GIR_EraseRootFromParent_Done,
     /* 631293 */   // Label 7999: @631293
     /* 631293 */   GIM_Reject,
     /* 631294 */ // Label 7996: @631294
     /* 631294 */ GIM_Reject,
     /* 631295 */ // Label 7985: @631295
     /* 631295 */ GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(631853),
     /* 631300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 631303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 631306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631310 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(631384), // Rule ID 7779 //
     /* 631315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 631319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 631323 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
     /* 631327 */     // MIs[1] Operand 1
     /* 631327 */     // No operand predicates
     /* 631327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 631329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631336 */     // (strict_fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 631336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631348 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 631353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 631358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 631365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631382 */     GIR_RootConstrainSelectedInstOperands,
     /* 631383 */     // GIR_Coverage, 7779,
     /* 631383 */     GIR_EraseRootFromParent_Done,
     /* 631384 */   // Label 8001: @631384
     /* 631384 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(631458), // Rule ID 13445 //
     /* 631389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 631393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 631397 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
     /* 631401 */     // MIs[1] Operand 1
     /* 631401 */     // No operand predicates
     /* 631401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 631403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631410 */     // (strict_fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 631410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631422 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 631427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 631432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 631439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631456 */     GIR_RootConstrainSelectedInstOperands,
     /* 631457 */     // GIR_Coverage, 13445,
     /* 631457 */     GIR_EraseRootFromParent_Done,
     /* 631458 */   // Label 8002: @631458
     /* 631458 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(631534), // Rule ID 7783 //
     /* 631463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 631467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 631471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 631475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 631479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 631483 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 631487 */     // MIs[2] Operand 1
     /* 631487 */     // No operand predicates
     /* 631487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 631489 */     // (strict_fmul:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 631489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631501 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 631506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 631511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 631516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 631520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631532 */     GIR_RootConstrainSelectedInstOperands,
     /* 631533 */     // GIR_Coverage, 7783,
     /* 631533 */     GIR_EraseRootFromParent_Done,
     /* 631534 */   // Label 8003: @631534
     /* 631534 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(631610), // Rule ID 13449 //
     /* 631539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 631543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 631547 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 631551 */     // MIs[1] Operand 1
     /* 631551 */     // No operand predicates
     /* 631551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 631555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 631559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 631563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 631565 */     // (strict_fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0))  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 631565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631577 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 631582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 631587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 631592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 631596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631608 */     GIR_RootConstrainSelectedInstOperands,
     /* 631609 */     // GIR_Coverage, 13449,
     /* 631609 */     GIR_EraseRootFromParent_Done,
     /* 631610 */   // Label 8004: @631610
     /* 631610 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(631672), // Rule ID 13447 //
     /* 631615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 631619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 631623 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 631627 */     // MIs[1] Operand 1
     /* 631627 */     // No operand predicates
     /* 631627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 631629 */     // (strict_fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, f64:{ *:[f64] }:$src0)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 631629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631641 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 631646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 631651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 631656 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 631658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631670 */     GIR_RootConstrainSelectedInstOperands,
     /* 631671 */     // GIR_Coverage, 13447,
     /* 631671 */     GIR_EraseRootFromParent_Done,
     /* 631672 */   // Label 8005: @631672
     /* 631672 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(631734), // Rule ID 7781 //
     /* 631677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 631681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 631685 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 631689 */     // MIs[1] Operand 1
     /* 631689 */     // No operand predicates
     /* 631689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 631691 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$src0, (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 631691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631703 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 631708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 631713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 631718 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 631720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631732 */     GIR_RootConstrainSelectedInstOperands,
     /* 631733 */     // GIR_Coverage, 7781,
     /* 631733 */     GIR_EraseRootFromParent_Done,
     /* 631734 */   // Label 8006: @631734
     /* 631734 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(631793), // Rule ID 932 //
     /* 631739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 631742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 631749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631756 */     // (strict_fmul:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 631756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 631759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 631766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 631776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 631781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 631786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 631791 */     GIR_RootConstrainSelectedInstOperands,
     /* 631792 */     // GIR_Coverage, 932,
     /* 631792 */     GIR_EraseRootFromParent_Done,
     /* 631793 */   // Label 8007: @631793
     /* 631793 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(631852), // Rule ID 8453 //
     /* 631798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 631801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 631808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 631815 */     // (strict_fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 631815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 631818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 631825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 631830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 631835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 631840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 631845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 631850 */     GIR_RootConstrainSelectedInstOperands,
     /* 631851 */     // GIR_Coverage, 8453,
     /* 631851 */     GIR_EraseRootFromParent_Done,
     /* 631852 */   // Label 8008: @631852
     /* 631852 */   GIM_Reject,
     /* 631853 */ // Label 8000: @631853
     /* 631853 */ GIM_Reject,
     /* 631854 */ // Label 7986: @631854
     /* 631854 */ GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(631925), // Rule ID 1092 //
     /* 631859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 631862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 631865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631869 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 631876 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 631883 */   // (strict_fmul:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 631883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F16),
     /* 631886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 631893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 631903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 631908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631923 */   GIR_RootConstrainSelectedInstOperands,
     /* 631924 */   // GIR_Coverage, 1092,
     /* 631924 */   GIR_EraseRootFromParent_Done,
     /* 631925 */ // Label 8009: @631925
     /* 631925 */ GIM_Reject,
     /* 631926 */ // Label 7987: @631926
     /* 631926 */ GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(632000), // Rule ID 1309 //
     /* 631931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 631934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 631937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 631940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631944 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 631951 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 631958 */   // (strict_fmul:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
     /* 631958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F32),
     /* 631961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 631968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 631973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 631978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 631983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 631998 */   GIR_RootConstrainSelectedInstOperands,
     /* 631999 */   // GIR_Coverage, 1309,
     /* 631999 */   GIR_EraseRootFromParent_Done,
     /* 632000 */ // Label 8010: @632000
     /* 632000 */ GIM_Reject,
     /* 632001 */ // Label 7988: @632001
     /* 632001 */ GIM_Reject,
     /* 632002 */ // Label 105: @632002
     /* 632002 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 8016*/ GIMT_Encode4(633047),
     /* 632013 */ /*GILLT_s16*//*Label 8011*/ GIMT_Encode4(632033),
     /* 632017 */ /*GILLT_s32*//*Label 8012*/ GIMT_Encode4(632485),
     /* 632021 */ /*GILLT_s64*//*Label 8013*/ GIMT_Encode4(632694),
     /* 632025 */ /*GILLT_v2s16*//*Label 8014*/ GIMT_Encode4(632860),
     /* 632029 */ /*GILLT_v2s32*//*Label 8015*/ GIMT_Encode4(632952),
     /* 632033 */ // Label 8011: @632033
     /* 632033 */ GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(632484),
     /* 632038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 632041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 632044 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 632047 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(632086), // Rule ID 112 //
     /* 632052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 632055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632071 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13803),
     /* 632075 */     // (strict_fma:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)<<P:Predicate_anonymous_13803>>  =>  (S_FMAC_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)
     /* 632075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F16),
     /* 632080 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 632084 */     GIR_RootConstrainSelectedInstOperands,
     /* 632085 */     // GIR_Coverage, 112,
     /* 632085 */     GIR_Done,
     /* 632086 */   // Label 8018: @632086
     /* 632086 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(632166), // Rule ID 999 //
     /* 632091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 632094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632119 */     // (strict_fma:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
     /* 632122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 632159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 632164 */     GIR_RootConstrainSelectedInstOperands,
     /* 632165 */     // GIR_Coverage, 999,
     /* 632165 */     GIR_EraseRootFromParent_Done,
     /* 632166 */   // Label 8019: @632166
     /* 632166 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(632246), // Rule ID 8466 //
     /* 632171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 632174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632199 */     // (strict_fma:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
     /* 632202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 632209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 632214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 632219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 632224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 632239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 632244 */     GIR_RootConstrainSelectedInstOperands,
     /* 632245 */     // GIR_Coverage, 8466,
     /* 632245 */     GIR_EraseRootFromParent_Done,
     /* 632246 */   // Label 8020: @632246
     /* 632246 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(632325), // Rule ID 1007 //
     /* 632251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 632254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632279 */     // (strict_fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 632279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_e64),
     /* 632282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632323 */     GIR_RootConstrainSelectedInstOperands,
     /* 632324 */     // GIR_Coverage, 1007,
     /* 632324 */     GIR_EraseRootFromParent_Done,
     /* 632325 */   // Label 8021: @632325
     /* 632325 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(632404), // Rule ID 1009 //
     /* 632330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 632333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 632337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632358 */     // (strict_fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 632358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_t16_e64),
     /* 632361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632402 */     GIR_RootConstrainSelectedInstOperands,
     /* 632403 */     // GIR_Coverage, 1009,
     /* 632403 */     GIR_EraseRootFromParent_Done,
     /* 632404 */   // Label 8022: @632404
     /* 632404 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(632483), // Rule ID 1011 //
     /* 632409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 632412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632437 */     // (strict_fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 632437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_fake16_e64),
     /* 632440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632481 */     GIR_RootConstrainSelectedInstOperands,
     /* 632482 */     // GIR_Coverage, 1011,
     /* 632482 */     GIR_EraseRootFromParent_Done,
     /* 632483 */   // Label 8023: @632483
     /* 632483 */   GIM_Reject,
     /* 632484 */ // Label 8017: @632484
     /* 632484 */ GIM_Reject,
     /* 632485 */ // Label 8012: @632485
     /* 632485 */ GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(632693),
     /* 632490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 632493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 632496 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 632499 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(632538), // Rule ID 110 //
     /* 632504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 632507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632523 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13803),
     /* 632527 */     // (strict_fma:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)<<P:Predicate_anonymous_13803>>  =>  (S_FMAC_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)
     /* 632527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F32),
     /* 632532 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 632536 */     GIR_RootConstrainSelectedInstOperands,
     /* 632537 */     // GIR_Coverage, 110,
     /* 632537 */     GIR_Done,
     /* 632538 */   // Label 8025: @632538
     /* 632538 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(632615), // Rule ID 925 //
     /* 632543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632568 */     // (strict_fma:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
     /* 632571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 632608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 632613 */     GIR_RootConstrainSelectedInstOperands,
     /* 632614 */     // GIR_Coverage, 925,
     /* 632614 */     GIR_EraseRootFromParent_Done,
     /* 632615 */   // Label 8026: @632615
     /* 632615 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(632692), // Rule ID 8447 //
     /* 632620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632645 */     // (strict_fma:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
     /* 632648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 632655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 632660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 632665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 632670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 632685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 632690 */     GIR_RootConstrainSelectedInstOperands,
     /* 632691 */     // GIR_Coverage, 8447,
     /* 632691 */     GIR_EraseRootFromParent_Done,
     /* 632692 */   // Label 8027: @632692
     /* 632692 */   GIM_Reject,
     /* 632693 */ // Label 8024: @632693
     /* 632693 */ GIM_Reject,
     /* 632694 */ // Label 8013: @632694
     /* 632694 */ GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(632859),
     /* 632699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 632702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 632705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 632708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632712 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(632785), // Rule ID 928 //
     /* 632717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632738 */     // (strict_fma:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
     /* 632741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 632778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 632783 */     GIR_RootConstrainSelectedInstOperands,
     /* 632784 */     // GIR_Coverage, 928,
     /* 632784 */     GIR_EraseRootFromParent_Done,
     /* 632785 */   // Label 8029: @632785
     /* 632785 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(632858), // Rule ID 8449 //
     /* 632790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 632811 */     // (strict_fma:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
     /* 632814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 632821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 632826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 632831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 632836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 632851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 632856 */     GIR_RootConstrainSelectedInstOperands,
     /* 632857 */     // GIR_Coverage, 8449,
     /* 632857 */     GIR_EraseRootFromParent_Done,
     /* 632858 */   // Label 8030: @632858
     /* 632858 */   GIM_Reject,
     /* 632859 */ // Label 8028: @632859
     /* 632859 */ GIM_Reject,
     /* 632860 */ // Label 8014: @632860
     /* 632860 */ GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(632951), // Rule ID 1088 //
     /* 632865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 632868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 632871 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 632874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632878 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 632885 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 632892 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 632899 */   // (strict_fma:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f16:{ *:[v2f16] }:$src2)
     /* 632899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F16),
     /* 632902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632909 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 632919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 632924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 632929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 632934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632949 */   GIR_RootConstrainSelectedInstOperands,
     /* 632950 */   // GIR_Coverage, 1088,
     /* 632950 */   GIR_EraseRootFromParent_Done,
     /* 632951 */ // Label 8031: @632951
     /* 632951 */ GIM_Reject,
     /* 632952 */ // Label 8015: @632952
     /* 632952 */ GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(633046), // Rule ID 1307 //
     /* 632957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 632960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 632963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 632966 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 632969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632973 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 632980 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 632987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 632994 */   // (strict_fma:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f32:{ *:[v2f32] }:$src2)
     /* 632994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F32),
     /* 632997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 633024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 633029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633044 */   GIR_RootConstrainSelectedInstOperands,
     /* 633045 */   // GIR_Coverage, 1307,
     /* 633045 */   GIR_EraseRootFromParent_Done,
     /* 633046 */ // Label 8032: @633046
     /* 633046 */ GIM_Reject,
     /* 633047 */ // Label 8016: @633047
     /* 633047 */ GIM_Reject,
     /* 633048 */ // Label 106: @633048
     /* 633048 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 8036*/ GIMT_Encode4(633410),
     /* 633059 */ /*GILLT_s16*//*Label 8033*/ GIMT_Encode4(633071),
     /* 633063 */ /*GILLT_s32*//*Label 8034*/ GIMT_Encode4(633276),
     /* 633067 */ /*GILLT_s64*//*Label 8035*/ GIMT_Encode4(633343),
     /* 633071 */ // Label 8033: @633071
     /* 633071 */ GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(633275),
     /* 633076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 633079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 633082 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(633145), // Rule ID 2505 //
     /* 633087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 633090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633108 */     // (strict_fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
     /* 633108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_e64),
     /* 633111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633143 */     GIR_RootConstrainSelectedInstOperands,
     /* 633144 */     // GIR_Coverage, 2505,
     /* 633144 */     GIR_EraseRootFromParent_Done,
     /* 633145 */   // Label 8038: @633145
     /* 633145 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(633211), // Rule ID 2507 //
     /* 633150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 633153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 633157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633171 */     // (strict_fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod, 0:{ *:[i32] })
     /* 633171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_t16_e64),
     /* 633174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633209 */     GIR_RootConstrainSelectedInstOperands,
     /* 633210 */     // GIR_Coverage, 2507,
     /* 633210 */     GIR_EraseRootFromParent_Done,
     /* 633211 */   // Label 8039: @633211
     /* 633211 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(633274), // Rule ID 2509 //
     /* 633216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 633219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633237 */     // (strict_fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
     /* 633237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_fake16_e64),
     /* 633240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633272 */     GIR_RootConstrainSelectedInstOperands,
     /* 633273 */     // GIR_Coverage, 2509,
     /* 633273 */     GIR_EraseRootFromParent_Done,
     /* 633274 */   // Label 8040: @633274
     /* 633274 */   GIM_Reject,
     /* 633275 */ // Label 8037: @633275
     /* 633275 */ GIM_Reject,
     /* 633276 */ // Label 8034: @633276
     /* 633276 */ GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(633342), // Rule ID 820 //
     /* 633281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 633284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 633287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633291 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633298 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 633305 */   // (strict_fldexp:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F32_e64),
     /* 633308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633310 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633315 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633340 */   GIR_RootConstrainSelectedInstOperands,
     /* 633341 */   // GIR_Coverage, 820,
     /* 633341 */   GIR_EraseRootFromParent_Done,
     /* 633342 */ // Label 8041: @633342
     /* 633342 */ GIM_Reject,
     /* 633343 */ // Label 8035: @633343
     /* 633343 */ GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(633409), // Rule ID 980 //
     /* 633348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 633351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 633354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 633358 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633365 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 633372 */   // (strict_fldexp:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 633375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633387 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633392 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633407 */   GIR_RootConstrainSelectedInstOperands,
     /* 633408 */   // GIR_Coverage, 980,
     /* 633408 */   GIR_EraseRootFromParent_Done,
     /* 633409 */ // Label 8042: @633409
     /* 633409 */ GIM_Reject,
     /* 633410 */ // Label 8036: @633410
     /* 633410 */ GIM_Reject,
     /* 633411 */ // Label 107: @633411
     /* 633411 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8045*/ GIMT_Encode4(635714),
     /* 633422 */ /*GILLT_s32*//*Label 8043*/ GIMT_Encode4(633430),
     /* 633426 */ /*GILLT_s64*//*Label 8044*/ GIMT_Encode4(634572),
     /* 633430 */ // Label 8043: @633430
     /* 633430 */ GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(634571),
     /* 633435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 633438 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(633500), // Rule ID 5799 //
     /* 633443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 633446 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 633453 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 633455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 633459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 633466 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_ADDR64 VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 633466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_ADDR64),
     /* 633469 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 633471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 633476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 633481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 633486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 633491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 633498 */     GIR_RootConstrainSelectedInstOperands,
     /* 633499 */     // GIR_Coverage, 5799,
     /* 633499 */     GIR_EraseRootFromParent_Done,
     /* 633500 */   // Label 8047: @633500
     /* 633500 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(633559), // Rule ID 5803 //
     /* 633505 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 633512 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 633514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 633518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 633525 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64 VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 633525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64),
     /* 633528 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 633530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 633535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 633540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 633545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 633550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 633557 */     GIR_RootConstrainSelectedInstOperands,
     /* 633558 */     // GIR_Coverage, 5803,
     /* 633558 */     GIR_EraseRootFromParent_Done,
     /* 633559 */   // Label 8048: @633559
     /* 633559 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(633677), // Rule ID 5575 //
     /* 633564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 633567 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 633574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 633582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 633589 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_ADDR64_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 633589 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 633592 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_ADDR64_RTN),
     /* 633596 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633601 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 633605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 633610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 633615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 633620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 633625 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 633628 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 633632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 633634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 633637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 633641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633646 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 633649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 633654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 633657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 633659 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 633666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 633676 */     // GIR_Coverage, 5575,
     /* 633676 */     GIR_EraseRootFromParent_Done,
     /* 633677 */   // Label 8049: @633677
     /* 633677 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(633792), // Rule ID 5801 //
     /* 633682 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 633689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 633697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 633704 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 633704 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 633707 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64_RTN),
     /* 633711 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633716 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 633720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 633725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 633730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 633735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 633740 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 633743 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 633747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 633749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 633752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 633756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633761 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 633764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 633769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 633772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 633774 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 633781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 633791 */     // GIR_Coverage, 5801,
     /* 633791 */     GIR_EraseRootFromParent_Done,
     /* 633792 */   // Label 8050: @633792
     /* 633792 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(633849), // Rule ID 5798 //
     /* 633797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 633800 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 633807 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 633809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 633813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 633820 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_OFFSET VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 633820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET),
     /* 633823 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 633825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 633830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 633835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 633840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 633847 */     GIR_RootConstrainSelectedInstOperands,
     /* 633848 */     // GIR_Coverage, 5798,
     /* 633848 */     GIR_EraseRootFromParent_Done,
     /* 633849 */   // Label 8051: @633849
     /* 633849 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(633903), // Rule ID 5802 //
     /* 633854 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 633861 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 633863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 633867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 633874 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 633874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET),
     /* 633877 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 633879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 633884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 633889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 633894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 633901 */     GIR_RootConstrainSelectedInstOperands,
     /* 633902 */     // GIR_Coverage, 5802,
     /* 633902 */     GIR_EraseRootFromParent_Done,
     /* 633903 */   // Label 8052: @633903
     /* 633903 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(634016), // Rule ID 5574 //
     /* 633908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 633911 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 633918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 633926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 633933 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 633933 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 633936 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN),
     /* 633940 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633945 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 633949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 633954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 633959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 633964 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 633967 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 633971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 633973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 633976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 633980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633985 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 633988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 633993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 633996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 633998 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 634005 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634015 */     // GIR_Coverage, 5574,
     /* 634015 */     GIR_EraseRootFromParent_Done,
     /* 634016 */   // Label 8053: @634016
     /* 634016 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(634126), // Rule ID 5800 //
     /* 634021 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 634043 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 634043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 634046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN),
     /* 634050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 634055 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 634059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 634064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 634069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 634074 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 634077 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 634083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 634086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 634090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 634095 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 634098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 634106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 634108 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 634115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634125 */     // GIR_Coverage, 5800,
     /* 634125 */     GIR_EraseRootFromParent_Done,
     /* 634126 */   // Label 8054: @634126
     /* 634126 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(634183), // Rule ID 4050 //
     /* 634131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 634134 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634141 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 634154 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP_SADDR ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 634154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_SADDR),
     /* 634157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 634162 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 634169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 634174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634181 */     GIR_RootConstrainSelectedInstOperands,
     /* 634182 */     // GIR_Coverage, 4050,
     /* 634182 */     GIR_EraseRootFromParent_Done,
     /* 634183 */   // Label 8055: @634183
     /* 634183 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(634244), // Rule ID 4052 //
     /* 634188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 634191 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 634202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 634213 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 634213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_SADDR_RTN),
     /* 634216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 634223 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 634230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 634235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 634238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634242 */     GIR_RootConstrainSelectedInstOperands,
     /* 634243 */     // GIR_Coverage, 4052,
     /* 634243 */     GIR_EraseRootFromParent_Done,
     /* 634244 */   // Label 8056: @634244
     /* 634244 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(634296), // Rule ID 4049 //
     /* 634249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 634252 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634259 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 634272 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 634272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP),
     /* 634275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 634280 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 634287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634294 */     GIR_RootConstrainSelectedInstOperands,
     /* 634295 */     // GIR_Coverage, 4049,
     /* 634295 */     GIR_EraseRootFromParent_Done,
     /* 634296 */   // Label 8057: @634296
     /* 634296 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(634352), // Rule ID 4051 //
     /* 634301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 634304 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 634315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 634326 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 634326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_RTN),
     /* 634329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 634336 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 634343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 634346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634350 */     GIR_RootConstrainSelectedInstOperands,
     /* 634351 */     // GIR_Coverage, 4051,
     /* 634351 */     GIR_EraseRootFromParent_Done,
     /* 634352 */   // Label 8058: @634352
     /* 634352 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(634405), // Rule ID 3686 //
     /* 634357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 634360 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634368 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 634381 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_noret_i32>>  =>  (FLAT_ATOMIC_CMPSWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 634381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP),
     /* 634384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 634389 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 634396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634403 */     GIR_RootConstrainSelectedInstOperands,
     /* 634404 */     // GIR_Coverage, 3686,
     /* 634404 */     GIR_EraseRootFromParent_Done,
     /* 634405 */   // Label 8059: @634405
     /* 634405 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(634457), // Rule ID 3746 //
     /* 634410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 634413 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634420 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 634433 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (FLAT_ATOMIC_CMPSWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 634433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP),
     /* 634436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 634441 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 634448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634455 */     GIR_RootConstrainSelectedInstOperands,
     /* 634456 */     // GIR_Coverage, 3746,
     /* 634456 */     GIR_EraseRootFromParent_Done,
     /* 634457 */   // Label 8060: @634457
     /* 634457 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(634514), // Rule ID 3685 //
     /* 634462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 634465 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 634477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 634488 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_i32>>  =>  (FLAT_ATOMIC_CMPSWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 634488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_RTN),
     /* 634491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 634498 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 634505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 634508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634512 */     GIR_RootConstrainSelectedInstOperands,
     /* 634513 */     // GIR_Coverage, 3685,
     /* 634513 */     GIR_EraseRootFromParent_Done,
     /* 634514 */   // Label 8061: @634514
     /* 634514 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(634570), // Rule ID 3745 //
     /* 634519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 634522 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 634533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 634544 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (FLAT_ATOMIC_CMPSWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9819:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 634544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_RTN),
     /* 634547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 634554 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 634556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 634561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 634564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634568 */     GIR_RootConstrainSelectedInstOperands,
     /* 634569 */     // GIR_Coverage, 3745,
     /* 634569 */     GIR_EraseRootFromParent_Done,
     /* 634570 */   // Label 8062: @634570
     /* 634570 */   GIM_Reject,
     /* 634571 */ // Label 8046: @634571
     /* 634571 */ GIM_Reject,
     /* 634572 */ // Label 8044: @634572
     /* 634572 */ GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(635713),
     /* 634577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 634580 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(634642), // Rule ID 5807 //
     /* 634585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 634588 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634595 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 634608 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_ADDR64 VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 634608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_ADDR64),
     /* 634611 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 634613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 634618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 634623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 634628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 634633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634640 */     GIR_RootConstrainSelectedInstOperands,
     /* 634641 */     // GIR_Coverage, 5807,
     /* 634641 */     GIR_EraseRootFromParent_Done,
     /* 634642 */   // Label 8064: @634642
     /* 634642 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(634701), // Rule ID 5811 //
     /* 634647 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634654 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 634667 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64 VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 634667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64),
     /* 634670 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 634672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 634677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 634682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 634687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 634692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634699 */     GIR_RootConstrainSelectedInstOperands,
     /* 634700 */     // GIR_Coverage, 5811,
     /* 634700 */     GIR_EraseRootFromParent_Done,
     /* 634701 */   // Label 8065: @634701
     /* 634701 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(634819), // Rule ID 5805 //
     /* 634706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 634709 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 634731 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_ADDR64_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
     /* 634731 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 634734 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_ADDR64_RTN),
     /* 634738 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 634743 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 634747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 634752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 634757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 634762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 634767 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 634770 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 634776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 634779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 634783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 634788 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 634791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 634796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 634799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 634801 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 634808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 634818 */     // GIR_Coverage, 5805,
     /* 634818 */     GIR_EraseRootFromParent_Done,
     /* 634819 */   // Label 8066: @634819
     /* 634819 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(634934), // Rule ID 5809 //
     /* 634824 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 634846 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
     /* 634846 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 634849 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64_RTN),
     /* 634853 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 634858 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 634862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 634867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 634872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 634877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 634882 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 634885 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 634891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 634894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 634898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 634903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 634906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 634911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 634914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 634916 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 634923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 634933 */     // GIR_Coverage, 5809,
     /* 634933 */     GIR_EraseRootFromParent_Done,
     /* 634934 */   // Label 8067: @634934
     /* 634934 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(634991), // Rule ID 5806 //
     /* 634939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 634942 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 634949 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 634951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 634955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 634962 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 634962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET),
     /* 634965 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 634967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 634972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 634977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 634982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 634989 */     GIR_RootConstrainSelectedInstOperands,
     /* 634990 */     // GIR_Coverage, 5806,
     /* 634990 */     GIR_EraseRootFromParent_Done,
     /* 634991 */   // Label 8068: @634991
     /* 634991 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(635045), // Rule ID 5810 //
     /* 634996 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635003 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 635005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 635016 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 635016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET),
     /* 635019 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 635021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 635026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 635031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 635036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635043 */     GIR_RootConstrainSelectedInstOperands,
     /* 635044 */     // GIR_Coverage, 5810,
     /* 635044 */     GIR_EraseRootFromParent_Done,
     /* 635045 */   // Label 8069: @635045
     /* 635045 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(635158), // Rule ID 5804 //
     /* 635050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 635053 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 635064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 635075 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
     /* 635075 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 635078 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN),
     /* 635082 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 635091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 635096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 635101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 635106 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 635109 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 635115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 635118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 635122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 635130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 635135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 635138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 635140 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 635147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 635152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 635157 */     // GIR_Coverage, 5804,
     /* 635157 */     GIR_EraseRootFromParent_Done,
     /* 635158 */   // Label 8070: @635158
     /* 635158 */   GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(635268), // Rule ID 5808 //
     /* 635163 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 635174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 635185 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
     /* 635185 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 635188 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN),
     /* 635192 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635197 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 635201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 635206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 635211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 635216 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 635219 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 635225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 635228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 635232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635237 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 635240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 635245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 635248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 635250 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 635257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 635262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 635267 */     // GIR_Coverage, 5808,
     /* 635267 */     GIR_EraseRootFromParent_Done,
     /* 635268 */   // Label 8071: @635268
     /* 635268 */   GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(635325), // Rule ID 4106 //
     /* 635273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 635276 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635283 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 635285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 635296 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 635296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2_SADDR),
     /* 635299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 635304 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 635311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 635316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635323 */     GIR_RootConstrainSelectedInstOperands,
     /* 635324 */     // GIR_Coverage, 4106,
     /* 635324 */     GIR_EraseRootFromParent_Done,
     /* 635325 */   // Label 8072: @635325
     /* 635325 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(635386), // Rule ID 4108 //
     /* 635330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 635333 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 635344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 635355 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 635355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2_SADDR_RTN),
     /* 635358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 635365 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 635372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 635377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 635380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635384 */     GIR_RootConstrainSelectedInstOperands,
     /* 635385 */     // GIR_Coverage, 4108,
     /* 635385 */     GIR_EraseRootFromParent_Done,
     /* 635386 */   // Label 8073: @635386
     /* 635386 */   GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(635438), // Rule ID 4105 //
     /* 635391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 635394 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635401 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 635403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 635414 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 635414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2),
     /* 635417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 635422 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 635429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635436 */     GIR_RootConstrainSelectedInstOperands,
     /* 635437 */     // GIR_Coverage, 4105,
     /* 635437 */     GIR_EraseRootFromParent_Done,
     /* 635438 */   // Label 8074: @635438
     /* 635438 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(635494), // Rule ID 4107 //
     /* 635443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 635446 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 635457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 635468 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 635468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2_RTN),
     /* 635471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 635478 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 635485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 635488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635492 */     GIR_RootConstrainSelectedInstOperands,
     /* 635493 */     // GIR_Coverage, 4107,
     /* 635493 */     GIR_EraseRootFromParent_Done,
     /* 635494 */   // Label 8075: @635494
     /* 635494 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(635547), // Rule ID 3712 //
     /* 635499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 635502 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635510 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 635512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 635523 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_noret_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 635523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2),
     /* 635526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 635531 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 635538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635545 */     GIR_RootConstrainSelectedInstOperands,
     /* 635546 */     // GIR_Coverage, 3712,
     /* 635546 */     GIR_EraseRootFromParent_Done,
     /* 635547 */   // Label 8076: @635547
     /* 635547 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(635599), // Rule ID 3772 //
     /* 635552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 635555 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635562 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 635564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 635575 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 635575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2),
     /* 635578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 635583 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 635590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635597 */     GIR_RootConstrainSelectedInstOperands,
     /* 635598 */     // GIR_Coverage, 3772,
     /* 635598 */     GIR_EraseRootFromParent_Done,
     /* 635599 */   // Label 8077: @635599
     /* 635599 */   GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(635656), // Rule ID 3711 //
     /* 635604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 635607 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 635619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 635630 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 635630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2_RTN),
     /* 635633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 635640 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 635647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 635650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635654 */     GIR_RootConstrainSelectedInstOperands,
     /* 635655 */     // GIR_Coverage, 3711,
     /* 635655 */     GIR_EraseRootFromParent_Done,
     /* 635656 */   // Label 8078: @635656
     /* 635656 */   GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(635712), // Rule ID 3771 //
     /* 635661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 635664 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 635671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 635675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 635679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 635686 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9817:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 635686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2_RTN),
     /* 635689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 635696 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 635698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 635703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 635706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635710 */     GIR_RootConstrainSelectedInstOperands,
     /* 635711 */     // GIR_Coverage, 3771,
     /* 635711 */     GIR_EraseRootFromParent_Done,
     /* 635712 */   // Label 8079: @635712
     /* 635712 */   GIM_Reject,
     /* 635713 */ // Label 8063: @635713
     /* 635713 */ GIM_Reject,
     /* 635714 */ // Label 8045: @635714
     /* 635714 */ GIM_Reject,
     /* 635715 */ // Label 108: @635715
     /* 635715 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8082*/ GIMT_Encode4(638098),
     /* 635726 */ /*GILLT_s32*//*Label 8080*/ GIMT_Encode4(635734),
     /* 635730 */ /*GILLT_s64*//*Label 8081*/ GIMT_Encode4(636916),
     /* 635734 */ // Label 8080: @635734
     /* 635734 */ GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(636915),
     /* 635739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 635742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 635745 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 635748 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 635751 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 635754 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(635822), // Rule ID 5848 //
     /* 635759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 635762 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 635764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 635768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 635772 */     // MIs[0] offset
     /* 635772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 635775 */     // MIs[0] auxiliary
     /* 635775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 635778 */     // MIs[0] Operand 8
     /* 635778 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 635789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 635796 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 635796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET),
     /* 635799 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 635801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 635803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 635808 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 635810 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 635816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635820 */     GIR_RootConstrainSelectedInstOperands,
     /* 635821 */     // GIR_Coverage, 5848,
     /* 635821 */     GIR_EraseRootFromParent_Done,
     /* 635822 */   // Label 8084: @635822
     /* 635822 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(635887), // Rule ID 5856 //
     /* 635827 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 635829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 635833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 635837 */     // MIs[0] offset
     /* 635837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 635840 */     // MIs[0] auxiliary
     /* 635840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 635843 */     // MIs[0] Operand 8
     /* 635843 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 635854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 635861 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 635861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET),
     /* 635864 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 635866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 635868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 635873 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 635875 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 635881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635885 */     GIR_RootConstrainSelectedInstOperands,
     /* 635886 */     // GIR_Coverage, 5856,
     /* 635886 */     GIR_EraseRootFromParent_Done,
     /* 635887 */   // Label 8085: @635887
     /* 635887 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(635959), // Rule ID 5844 //
     /* 635892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 635895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 635899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 635903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 635907 */     // MIs[0] offset
     /* 635907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 635910 */     // MIs[0] auxiliary
     /* 635910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 635913 */     // MIs[0] Operand 8
     /* 635913 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 635924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 635931 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 635931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET_RTN),
     /* 635934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 635936 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 635938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 635940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 635945 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 635947 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 635953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 635957 */     GIR_RootConstrainSelectedInstOperands,
     /* 635958 */     // GIR_Coverage, 5844,
     /* 635958 */     GIR_EraseRootFromParent_Done,
     /* 635959 */   // Label 8086: @635959
     /* 635959 */   GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(636028), // Rule ID 5852 //
     /* 635964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 635968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 635972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 635976 */     // MIs[0] offset
     /* 635976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 635979 */     // MIs[0] auxiliary
     /* 635979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 635982 */     // MIs[0] Operand 8
     /* 635982 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 635993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636000 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN),
     /* 636003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 636005 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636014 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636016 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 636022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636026 */     GIR_RootConstrainSelectedInstOperands,
     /* 636027 */     // GIR_Coverage, 5852,
     /* 636027 */     GIR_EraseRootFromParent_Done,
     /* 636028 */   // Label 8087: @636028
     /* 636028 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(636094), // Rule ID 5850 //
     /* 636033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636036 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 636042 */     // MIs[0] offset
     /* 636042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636045 */     // MIs[0] auxiliary
     /* 636045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636048 */     // MIs[0] Operand 8
     /* 636048 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 636059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636066 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFEN),
     /* 636069 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636071 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 636073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636080 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636092 */     GIR_RootConstrainSelectedInstOperands,
     /* 636093 */     // GIR_Coverage, 5850,
     /* 636093 */     GIR_EraseRootFromParent_Done,
     /* 636094 */   // Label 8088: @636094
     /* 636094 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(636157), // Rule ID 5858 //
     /* 636099 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 636105 */     // MIs[0] offset
     /* 636105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636108 */     // MIs[0] auxiliary
     /* 636108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636111 */     // MIs[0] Operand 8
     /* 636111 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 636122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636129 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFEN),
     /* 636132 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636134 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 636136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636143 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636145 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636155 */     GIR_RootConstrainSelectedInstOperands,
     /* 636156 */     // GIR_Coverage, 5858,
     /* 636156 */     GIR_EraseRootFromParent_Done,
     /* 636157 */   // Label 8089: @636157
     /* 636157 */   GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(636227), // Rule ID 5846 //
     /* 636162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 636169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 636173 */     // MIs[0] offset
     /* 636173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636176 */     // MIs[0] auxiliary
     /* 636176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636179 */     // MIs[0] Operand 8
     /* 636179 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 636190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636197 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFEN_RTN),
     /* 636200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 636202 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636204 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 636206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636213 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 636221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636225 */     GIR_RootConstrainSelectedInstOperands,
     /* 636226 */     // GIR_Coverage, 5846,
     /* 636226 */     GIR_EraseRootFromParent_Done,
     /* 636227 */   // Label 8090: @636227
     /* 636227 */   GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(636294), // Rule ID 5854 //
     /* 636232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 636236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 636240 */     // MIs[0] offset
     /* 636240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636243 */     // MIs[0] auxiliary
     /* 636243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636246 */     // MIs[0] Operand 8
     /* 636246 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 636257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636264 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFEN_RTN),
     /* 636267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 636269 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636271 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 636273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636280 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636282 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 636288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636292 */     GIR_RootConstrainSelectedInstOperands,
     /* 636293 */     // GIR_Coverage, 5854,
     /* 636293 */     GIR_EraseRootFromParent_Done,
     /* 636294 */   // Label 8091: @636294
     /* 636294 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(636352), // Rule ID 5849 //
     /* 636299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636302 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 636308 */     // MIs[0] offset
     /* 636308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636311 */     // MIs[0] auxiliary
     /* 636311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636314 */     // MIs[0] Operand 8
     /* 636314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636324 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_IDXEN),
     /* 636327 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636329 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 636331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636338 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636340 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636350 */     GIR_RootConstrainSelectedInstOperands,
     /* 636351 */     // GIR_Coverage, 5849,
     /* 636351 */     GIR_EraseRootFromParent_Done,
     /* 636352 */   // Label 8092: @636352
     /* 636352 */   GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(636407), // Rule ID 5857 //
     /* 636357 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 636363 */     // MIs[0] offset
     /* 636363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636366 */     // MIs[0] auxiliary
     /* 636366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636369 */     // MIs[0] Operand 8
     /* 636369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636379 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_IDXEN),
     /* 636382 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636384 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 636386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636393 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636395 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636405 */     GIR_RootConstrainSelectedInstOperands,
     /* 636406 */     // GIR_Coverage, 5857,
     /* 636406 */     GIR_EraseRootFromParent_Done,
     /* 636407 */   // Label 8093: @636407
     /* 636407 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(636469), // Rule ID 5845 //
     /* 636412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 636419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 636423 */     // MIs[0] offset
     /* 636423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636426 */     // MIs[0] auxiliary
     /* 636426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636429 */     // MIs[0] Operand 8
     /* 636429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636439 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_IDXEN_RTN),
     /* 636442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 636444 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636446 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 636448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636455 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636457 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 636463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636467 */     GIR_RootConstrainSelectedInstOperands,
     /* 636468 */     // GIR_Coverage, 5845,
     /* 636468 */     GIR_EraseRootFromParent_Done,
     /* 636469 */   // Label 8094: @636469
     /* 636469 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(636528), // Rule ID 5853 //
     /* 636474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 636478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 636482 */     // MIs[0] offset
     /* 636482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636485 */     // MIs[0] auxiliary
     /* 636485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636488 */     // MIs[0] Operand 8
     /* 636488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636498 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_IDXEN_RTN),
     /* 636501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 636503 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636505 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 636507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636514 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636516 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 636522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636526 */     GIR_RootConstrainSelectedInstOperands,
     /* 636527 */     // GIR_Coverage, 5853,
     /* 636527 */     GIR_EraseRootFromParent_Done,
     /* 636528 */   // Label 8095: @636528
     /* 636528 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(636624), // Rule ID 5851 //
     /* 636533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636536 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636538 */     // MIs[0] offset
     /* 636538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636541 */     // MIs[0] auxiliary
     /* 636541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636544 */     // MIs[0] Operand 8
     /* 636544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636554 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 636557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 636561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 636566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 636570 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 636573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 636577 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 636580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 636585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_BOTHEN),
     /* 636598 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 636603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636610 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636622 */     GIR_RootConstrainSelectedInstOperands,
     /* 636623 */     // GIR_Coverage, 5851,
     /* 636623 */     GIR_EraseRootFromParent_Done,
     /* 636624 */   // Label 8096: @636624
     /* 636624 */   GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(636717), // Rule ID 5859 //
     /* 636629 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636631 */     // MIs[0] offset
     /* 636631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636634 */     // MIs[0] auxiliary
     /* 636634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636637 */     // MIs[0] Operand 8
     /* 636637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636647 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 636650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 636654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 636659 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 636663 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 636666 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 636670 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 636673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 636678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN),
     /* 636691 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 636696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636703 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636705 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636715 */     GIR_RootConstrainSelectedInstOperands,
     /* 636716 */     // GIR_Coverage, 5859,
     /* 636716 */     GIR_EraseRootFromParent_Done,
     /* 636717 */   // Label 8097: @636717
     /* 636717 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(636817), // Rule ID 5847 //
     /* 636722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 636729 */     // MIs[0] offset
     /* 636729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636732 */     // MIs[0] auxiliary
     /* 636732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636735 */     // MIs[0] Operand 8
     /* 636735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636745 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 636748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 636752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 636757 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 636761 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 636764 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 636768 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 636771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 636776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_BOTHEN_RTN),
     /* 636789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 636791 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 636796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636803 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636805 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 636811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636815 */     GIR_RootConstrainSelectedInstOperands,
     /* 636816 */     // GIR_Coverage, 5847,
     /* 636816 */     GIR_EraseRootFromParent_Done,
     /* 636817 */   // Label 8098: @636817
     /* 636817 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(636914), // Rule ID 5855 //
     /* 636822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 636826 */     // MIs[0] offset
     /* 636826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636829 */     // MIs[0] auxiliary
     /* 636829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636832 */     // MIs[0] Operand 8
     /* 636832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 636835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636842 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 636845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 636849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 636854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 636858 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 636861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 636865 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 636868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 636873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN_RTN),
     /* 636886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 636888 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 636893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636900 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636902 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 636908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 636912 */     GIR_RootConstrainSelectedInstOperands,
     /* 636913 */     // GIR_Coverage, 5855,
     /* 636913 */     GIR_EraseRootFromParent_Done,
     /* 636914 */   // Label 8099: @636914
     /* 636914 */   GIM_Reject,
     /* 636915 */ // Label 8083: @636915
     /* 636915 */ GIM_Reject,
     /* 636916 */ // Label 8081: @636916
     /* 636916 */ GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(638097),
     /* 636921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 636924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 636927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 636930 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 636933 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 636936 */   GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(637004), // Rule ID 6048 //
     /* 636941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 636944 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 636946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 636950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 636954 */     // MIs[0] offset
     /* 636954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 636957 */     // MIs[0] auxiliary
     /* 636957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 636960 */     // MIs[0] Operand 8
     /* 636960 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 636971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 636978 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 636978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET),
     /* 636981 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 636983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 636985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 636990 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 636992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 636998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637002 */     GIR_RootConstrainSelectedInstOperands,
     /* 637003 */     // GIR_Coverage, 6048,
     /* 637003 */     GIR_EraseRootFromParent_Done,
     /* 637004 */   // Label 8101: @637004
     /* 637004 */   GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(637069), // Rule ID 6056 //
     /* 637009 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637019 */     // MIs[0] offset
     /* 637019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637022 */     // MIs[0] auxiliary
     /* 637022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637025 */     // MIs[0] Operand 8
     /* 637025 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637043 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET),
     /* 637046 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637055 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637057 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637067 */     GIR_RootConstrainSelectedInstOperands,
     /* 637068 */     // GIR_Coverage, 6056,
     /* 637068 */     GIR_EraseRootFromParent_Done,
     /* 637069 */   // Label 8102: @637069
     /* 637069 */   GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(637141), // Rule ID 6044 //
     /* 637074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 637081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637089 */     // MIs[0] offset
     /* 637089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637092 */     // MIs[0] auxiliary
     /* 637092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637095 */     // MIs[0] Operand 8
     /* 637095 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637113 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET_RTN),
     /* 637116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637118 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637127 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637129 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637139 */     GIR_RootConstrainSelectedInstOperands,
     /* 637140 */     // GIR_Coverage, 6044,
     /* 637140 */     GIR_EraseRootFromParent_Done,
     /* 637141 */   // Label 8103: @637141
     /* 637141 */   GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(637210), // Rule ID 6052 //
     /* 637146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 637150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637158 */     // MIs[0] offset
     /* 637158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637161 */     // MIs[0] auxiliary
     /* 637161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637164 */     // MIs[0] Operand 8
     /* 637164 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637182 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN),
     /* 637185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637187 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637196 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637198 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637208 */     GIR_RootConstrainSelectedInstOperands,
     /* 637209 */     // GIR_Coverage, 6052,
     /* 637209 */     GIR_EraseRootFromParent_Done,
     /* 637210 */   // Label 8104: @637210
     /* 637210 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(637276), // Rule ID 6050 //
     /* 637215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637218 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637224 */     // MIs[0] offset
     /* 637224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637227 */     // MIs[0] auxiliary
     /* 637227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637230 */     // MIs[0] Operand 8
     /* 637230 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637248 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFEN),
     /* 637251 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637253 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 637255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637262 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637264 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637274 */     GIR_RootConstrainSelectedInstOperands,
     /* 637275 */     // GIR_Coverage, 6050,
     /* 637275 */     GIR_EraseRootFromParent_Done,
     /* 637276 */   // Label 8105: @637276
     /* 637276 */   GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(637339), // Rule ID 6058 //
     /* 637281 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637283 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637287 */     // MIs[0] offset
     /* 637287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637290 */     // MIs[0] auxiliary
     /* 637290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637293 */     // MIs[0] Operand 8
     /* 637293 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637311 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN),
     /* 637314 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637316 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 637318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637325 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637327 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637337 */     GIR_RootConstrainSelectedInstOperands,
     /* 637338 */     // GIR_Coverage, 6058,
     /* 637338 */     GIR_EraseRootFromParent_Done,
     /* 637339 */   // Label 8106: @637339
     /* 637339 */   GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(637409), // Rule ID 6046 //
     /* 637344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 637351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637355 */     // MIs[0] offset
     /* 637355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637358 */     // MIs[0] auxiliary
     /* 637358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637361 */     // MIs[0] Operand 8
     /* 637361 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637379 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFEN_RTN),
     /* 637382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637384 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637386 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 637388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637395 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637397 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637407 */     GIR_RootConstrainSelectedInstOperands,
     /* 637408 */     // GIR_Coverage, 6046,
     /* 637408 */     GIR_EraseRootFromParent_Done,
     /* 637409 */   // Label 8107: @637409
     /* 637409 */   GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(637476), // Rule ID 6054 //
     /* 637414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 637418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 637422 */     // MIs[0] offset
     /* 637422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637425 */     // MIs[0] auxiliary
     /* 637425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637428 */     // MIs[0] Operand 8
     /* 637428 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 637439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637446 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN_RTN),
     /* 637449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637451 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637453 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 637455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637462 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637464 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637474 */     GIR_RootConstrainSelectedInstOperands,
     /* 637475 */     // GIR_Coverage, 6054,
     /* 637475 */     GIR_EraseRootFromParent_Done,
     /* 637476 */   // Label 8108: @637476
     /* 637476 */   GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(637534), // Rule ID 6049 //
     /* 637481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637484 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637490 */     // MIs[0] offset
     /* 637490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637493 */     // MIs[0] auxiliary
     /* 637493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637496 */     // MIs[0] Operand 8
     /* 637496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 637499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637506 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_IDXEN),
     /* 637509 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637511 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 637513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637520 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637522 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637532 */     GIR_RootConstrainSelectedInstOperands,
     /* 637533 */     // GIR_Coverage, 6049,
     /* 637533 */     GIR_EraseRootFromParent_Done,
     /* 637534 */   // Label 8109: @637534
     /* 637534 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(637589), // Rule ID 6057 //
     /* 637539 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637545 */     // MIs[0] offset
     /* 637545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637548 */     // MIs[0] auxiliary
     /* 637548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637551 */     // MIs[0] Operand 8
     /* 637551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 637554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637561 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN),
     /* 637564 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637566 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 637568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637575 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637587 */     GIR_RootConstrainSelectedInstOperands,
     /* 637588 */     // GIR_Coverage, 6057,
     /* 637588 */     GIR_EraseRootFromParent_Done,
     /* 637589 */   // Label 8110: @637589
     /* 637589 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(637651), // Rule ID 6045 //
     /* 637594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 637601 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637605 */     // MIs[0] offset
     /* 637605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637608 */     // MIs[0] auxiliary
     /* 637608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637611 */     // MIs[0] Operand 8
     /* 637611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 637614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637621 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_IDXEN_RTN),
     /* 637624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637626 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637628 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 637630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637637 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637639 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637649 */     GIR_RootConstrainSelectedInstOperands,
     /* 637650 */     // GIR_Coverage, 6045,
     /* 637650 */     GIR_EraseRootFromParent_Done,
     /* 637651 */   // Label 8111: @637651
     /* 637651 */   GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(637710), // Rule ID 6053 //
     /* 637656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 637660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 637664 */     // MIs[0] offset
     /* 637664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637667 */     // MIs[0] auxiliary
     /* 637667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637670 */     // MIs[0] Operand 8
     /* 637670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 637673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637680 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN_RTN),
     /* 637683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637685 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637687 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 637689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637696 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637698 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637708 */     GIR_RootConstrainSelectedInstOperands,
     /* 637709 */     // GIR_Coverage, 6053,
     /* 637709 */     GIR_EraseRootFromParent_Done,
     /* 637710 */   // Label 8112: @637710
     /* 637710 */   GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(637806), // Rule ID 6051 //
     /* 637715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637718 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637720 */     // MIs[0] offset
     /* 637720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637723 */     // MIs[0] auxiliary
     /* 637723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637726 */     // MIs[0] Operand 8
     /* 637726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 637729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637736 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 637739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 637743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 637748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 637752 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 637755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 637759 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 637762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 637767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_BOTHEN),
     /* 637780 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 637785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637792 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637794 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637804 */     GIR_RootConstrainSelectedInstOperands,
     /* 637805 */     // GIR_Coverage, 6051,
     /* 637805 */     GIR_EraseRootFromParent_Done,
     /* 637806 */   // Label 8113: @637806
     /* 637806 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(637899), // Rule ID 6059 //
     /* 637811 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637813 */     // MIs[0] offset
     /* 637813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637816 */     // MIs[0] auxiliary
     /* 637816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637819 */     // MIs[0] Operand 8
     /* 637819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 637822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637829 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 637832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 637836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 637841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 637845 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 637848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 637852 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 637855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 637860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN),
     /* 637873 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 637878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637885 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637887 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 637893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637897 */     GIR_RootConstrainSelectedInstOperands,
     /* 637898 */     // GIR_Coverage, 6059,
     /* 637898 */     GIR_EraseRootFromParent_Done,
     /* 637899 */   // Label 8114: @637899
     /* 637899 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(637999), // Rule ID 6047 //
     /* 637904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 637911 */     // MIs[0] offset
     /* 637911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 637914 */     // MIs[0] auxiliary
     /* 637914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 637917 */     // MIs[0] Operand 8
     /* 637917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 637920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 637927 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 637927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 637930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 637934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 637939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 637943 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 637946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 637950 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 637953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 637958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_BOTHEN_RTN),
     /* 637971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 637973 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 637975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 637978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 637980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 637985 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 637987 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 637993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637997 */     GIR_RootConstrainSelectedInstOperands,
     /* 637998 */     // GIR_Coverage, 6047,
     /* 637998 */     GIR_EraseRootFromParent_Done,
     /* 637999 */   // Label 8115: @637999
     /* 637999 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(638096), // Rule ID 6055 //
     /* 638004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 638008 */     // MIs[0] offset
     /* 638008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638011 */     // MIs[0] auxiliary
     /* 638011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638014 */     // MIs[0] Operand 8
     /* 638014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 638017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638024 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 638027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 638031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 638036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 638040 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 638043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 638047 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 638050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN_RTN),
     /* 638068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 638070 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 638075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638082 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 638090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638094 */     GIR_RootConstrainSelectedInstOperands,
     /* 638095 */     // GIR_Coverage, 6055,
     /* 638095 */     GIR_EraseRootFromParent_Done,
     /* 638096 */   // Label 8116: @638096
     /* 638096 */   GIM_Reject,
     /* 638097 */ // Label 8100: @638097
     /* 638097 */ GIM_Reject,
     /* 638098 */ // Label 8082: @638098
     /* 638098 */ GIM_Reject,
     /* 638099 */ // Label 109: @638099
     /* 638099 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8119*/ GIMT_Encode4(640482),
     /* 638110 */ /*GILLT_s32*//*Label 8117*/ GIMT_Encode4(638118),
     /* 638114 */ /*GILLT_s64*//*Label 8118*/ GIMT_Encode4(639300),
     /* 638118 */ // Label 8117: @638118
     /* 638118 */ GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(639299),
     /* 638123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 638126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 638129 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 638132 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 638135 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 638138 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(638206), // Rule ID 5944 //
     /* 638143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638146 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 638156 */     // MIs[0] offset
     /* 638156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638159 */     // MIs[0] auxiliary
     /* 638159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638162 */     // MIs[0] Operand 8
     /* 638162 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638180 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET),
     /* 638183 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638192 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638194 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 638200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638204 */     GIR_RootConstrainSelectedInstOperands,
     /* 638205 */     // GIR_Coverage, 5944,
     /* 638205 */     GIR_EraseRootFromParent_Done,
     /* 638206 */   // Label 8121: @638206
     /* 638206 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(638271), // Rule ID 5952 //
     /* 638211 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 638221 */     // MIs[0] offset
     /* 638221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638224 */     // MIs[0] auxiliary
     /* 638224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638227 */     // MIs[0] Operand 8
     /* 638227 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638245 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET),
     /* 638248 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638257 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638259 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 638265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638269 */     GIR_RootConstrainSelectedInstOperands,
     /* 638270 */     // GIR_Coverage, 5952,
     /* 638270 */     GIR_EraseRootFromParent_Done,
     /* 638271 */   // Label 8122: @638271
     /* 638271 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(638343), // Rule ID 5940 //
     /* 638276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638283 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 638291 */     // MIs[0] offset
     /* 638291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638294 */     // MIs[0] auxiliary
     /* 638294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638297 */     // MIs[0] Operand 8
     /* 638297 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638315 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET_RTN),
     /* 638318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 638320 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638329 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638331 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 638337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638341 */     GIR_RootConstrainSelectedInstOperands,
     /* 638342 */     // GIR_Coverage, 5940,
     /* 638342 */     GIR_EraseRootFromParent_Done,
     /* 638343 */   // Label 8123: @638343
     /* 638343 */   GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(638412), // Rule ID 5948 //
     /* 638348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 638360 */     // MIs[0] offset
     /* 638360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638363 */     // MIs[0] auxiliary
     /* 638363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638366 */     // MIs[0] Operand 8
     /* 638366 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638384 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN),
     /* 638387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 638389 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638398 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638400 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 638406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638410 */     GIR_RootConstrainSelectedInstOperands,
     /* 638411 */     // GIR_Coverage, 5948,
     /* 638411 */     GIR_EraseRootFromParent_Done,
     /* 638412 */   // Label 8124: @638412
     /* 638412 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(638478), // Rule ID 5946 //
     /* 638417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638420 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638426 */     // MIs[0] offset
     /* 638426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638429 */     // MIs[0] auxiliary
     /* 638429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638432 */     // MIs[0] Operand 8
     /* 638432 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638450 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFEN),
     /* 638453 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638455 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 638457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638464 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638466 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 638472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638476 */     GIR_RootConstrainSelectedInstOperands,
     /* 638477 */     // GIR_Coverage, 5946,
     /* 638477 */     GIR_EraseRootFromParent_Done,
     /* 638478 */   // Label 8125: @638478
     /* 638478 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(638541), // Rule ID 5954 //
     /* 638483 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638489 */     // MIs[0] offset
     /* 638489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638492 */     // MIs[0] auxiliary
     /* 638492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638495 */     // MIs[0] Operand 8
     /* 638495 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638513 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFEN),
     /* 638516 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638518 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 638520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638527 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638529 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 638535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638539 */     GIR_RootConstrainSelectedInstOperands,
     /* 638540 */     // GIR_Coverage, 5954,
     /* 638540 */     GIR_EraseRootFromParent_Done,
     /* 638541 */   // Label 8126: @638541
     /* 638541 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(638611), // Rule ID 5942 //
     /* 638546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638557 */     // MIs[0] offset
     /* 638557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638560 */     // MIs[0] auxiliary
     /* 638560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638563 */     // MIs[0] Operand 8
     /* 638563 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638581 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFEN_RTN),
     /* 638584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 638586 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638588 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 638590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638597 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 638605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638609 */     GIR_RootConstrainSelectedInstOperands,
     /* 638610 */     // GIR_Coverage, 5942,
     /* 638610 */     GIR_EraseRootFromParent_Done,
     /* 638611 */   // Label 8127: @638611
     /* 638611 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(638678), // Rule ID 5950 //
     /* 638616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 638624 */     // MIs[0] offset
     /* 638624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638627 */     // MIs[0] auxiliary
     /* 638627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638630 */     // MIs[0] Operand 8
     /* 638630 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 638641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638648 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFEN_RTN),
     /* 638651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 638653 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638655 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 638657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638664 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638666 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 638672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638676 */     GIR_RootConstrainSelectedInstOperands,
     /* 638677 */     // GIR_Coverage, 5950,
     /* 638677 */     GIR_EraseRootFromParent_Done,
     /* 638678 */   // Label 8128: @638678
     /* 638678 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(638736), // Rule ID 5945 //
     /* 638683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638686 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 638692 */     // MIs[0] offset
     /* 638692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638695 */     // MIs[0] auxiliary
     /* 638695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638698 */     // MIs[0] Operand 8
     /* 638698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 638701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638708 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_IDXEN),
     /* 638711 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638713 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 638715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638722 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 638730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638734 */     GIR_RootConstrainSelectedInstOperands,
     /* 638735 */     // GIR_Coverage, 5945,
     /* 638735 */     GIR_EraseRootFromParent_Done,
     /* 638736 */   // Label 8129: @638736
     /* 638736 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(638791), // Rule ID 5953 //
     /* 638741 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 638747 */     // MIs[0] offset
     /* 638747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638750 */     // MIs[0] auxiliary
     /* 638750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638753 */     // MIs[0] Operand 8
     /* 638753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 638756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638763 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_IDXEN),
     /* 638766 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638768 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 638770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638777 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 638785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638789 */     GIR_RootConstrainSelectedInstOperands,
     /* 638790 */     // GIR_Coverage, 5953,
     /* 638790 */     GIR_EraseRootFromParent_Done,
     /* 638791 */   // Label 8130: @638791
     /* 638791 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(638853), // Rule ID 5941 //
     /* 638796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 638807 */     // MIs[0] offset
     /* 638807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638810 */     // MIs[0] auxiliary
     /* 638810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638813 */     // MIs[0] Operand 8
     /* 638813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 638816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638823 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_IDXEN_RTN),
     /* 638826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 638828 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638830 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 638832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638839 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638841 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 638847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638851 */     GIR_RootConstrainSelectedInstOperands,
     /* 638852 */     // GIR_Coverage, 5941,
     /* 638852 */     GIR_EraseRootFromParent_Done,
     /* 638853 */   // Label 8131: @638853
     /* 638853 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(638912), // Rule ID 5949 //
     /* 638858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 638866 */     // MIs[0] offset
     /* 638866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638869 */     // MIs[0] auxiliary
     /* 638869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638872 */     // MIs[0] Operand 8
     /* 638872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 638875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638882 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_IDXEN_RTN),
     /* 638885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 638887 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638889 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 638891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638898 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638900 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 638906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638910 */     GIR_RootConstrainSelectedInstOperands,
     /* 638911 */     // GIR_Coverage, 5949,
     /* 638911 */     GIR_EraseRootFromParent_Done,
     /* 638912 */   // Label 8132: @638912
     /* 638912 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(639008), // Rule ID 5947 //
     /* 638917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638920 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638922 */     // MIs[0] offset
     /* 638922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 638925 */     // MIs[0] auxiliary
     /* 638925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 638928 */     // MIs[0] Operand 8
     /* 638928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 638931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 638938 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 638938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 638941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 638945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 638950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 638954 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 638957 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 638961 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 638964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_BOTHEN),
     /* 638982 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 638984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 638987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 638989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 638994 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 638996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639006 */     GIR_RootConstrainSelectedInstOperands,
     /* 639007 */     // GIR_Coverage, 5947,
     /* 639007 */     GIR_EraseRootFromParent_Done,
     /* 639008 */   // Label 8133: @639008
     /* 639008 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(639101), // Rule ID 5955 //
     /* 639013 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639015 */     // MIs[0] offset
     /* 639015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639018 */     // MIs[0] auxiliary
     /* 639018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639021 */     // MIs[0] Operand 8
     /* 639021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 639024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639031 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 639034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 639038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 639047 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 639050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 639054 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 639057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_BOTHEN),
     /* 639075 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 639080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639087 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639089 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639099 */     GIR_RootConstrainSelectedInstOperands,
     /* 639100 */     // GIR_Coverage, 5955,
     /* 639100 */     GIR_EraseRootFromParent_Done,
     /* 639101 */   // Label 8134: @639101
     /* 639101 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(639201), // Rule ID 5943 //
     /* 639106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 639113 */     // MIs[0] offset
     /* 639113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639116 */     // MIs[0] auxiliary
     /* 639116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639119 */     // MIs[0] Operand 8
     /* 639119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 639122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639129 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 639132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 639136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639141 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 639145 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 639148 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 639152 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 639155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_BOTHEN_RTN),
     /* 639173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 639175 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 639180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639187 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639189 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 639195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639199 */     GIR_RootConstrainSelectedInstOperands,
     /* 639200 */     // GIR_Coverage, 5943,
     /* 639200 */     GIR_EraseRootFromParent_Done,
     /* 639201 */   // Label 8135: @639201
     /* 639201 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(639298), // Rule ID 5951 //
     /* 639206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 639210 */     // MIs[0] offset
     /* 639210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639213 */     // MIs[0] auxiliary
     /* 639213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639216 */     // MIs[0] Operand 8
     /* 639216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 639219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639226 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 639229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 639233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 639242 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 639245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 639249 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 639252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 639267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_BOTHEN_RTN),
     /* 639270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 639272 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 639277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639284 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639286 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 639292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639296 */     GIR_RootConstrainSelectedInstOperands,
     /* 639297 */     // GIR_Coverage, 5951,
     /* 639297 */     GIR_EraseRootFromParent_Done,
     /* 639298 */   // Label 8136: @639298
     /* 639298 */   GIM_Reject,
     /* 639299 */ // Label 8120: @639299
     /* 639299 */ GIM_Reject,
     /* 639300 */ // Label 8118: @639300
     /* 639300 */ GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(640481),
     /* 639305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 639308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 639311 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 639314 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 639317 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 639320 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(639388), // Rule ID 6144 //
     /* 639325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639328 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639338 */     // MIs[0] offset
     /* 639338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639341 */     // MIs[0] auxiliary
     /* 639341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639344 */     // MIs[0] Operand 8
     /* 639344 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639362 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET),
     /* 639365 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639374 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639376 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639386 */     GIR_RootConstrainSelectedInstOperands,
     /* 639387 */     // GIR_Coverage, 6144,
     /* 639387 */     GIR_EraseRootFromParent_Done,
     /* 639388 */   // Label 8138: @639388
     /* 639388 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(639453), // Rule ID 6152 //
     /* 639393 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639403 */     // MIs[0] offset
     /* 639403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639406 */     // MIs[0] auxiliary
     /* 639406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639409 */     // MIs[0] Operand 8
     /* 639409 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639427 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET),
     /* 639430 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639439 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639441 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639451 */     GIR_RootConstrainSelectedInstOperands,
     /* 639452 */     // GIR_Coverage, 6152,
     /* 639452 */     GIR_EraseRootFromParent_Done,
     /* 639453 */   // Label 8139: @639453
     /* 639453 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(639525), // Rule ID 6140 //
     /* 639458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 639465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639473 */     // MIs[0] offset
     /* 639473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639476 */     // MIs[0] auxiliary
     /* 639476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639479 */     // MIs[0] Operand 8
     /* 639479 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639497 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET_RTN),
     /* 639500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 639502 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639511 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639513 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 639519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639523 */     GIR_RootConstrainSelectedInstOperands,
     /* 639524 */     // GIR_Coverage, 6140,
     /* 639524 */     GIR_EraseRootFromParent_Done,
     /* 639525 */   // Label 8140: @639525
     /* 639525 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(639594), // Rule ID 6148 //
     /* 639530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 639534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639542 */     // MIs[0] offset
     /* 639542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639545 */     // MIs[0] auxiliary
     /* 639545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639548 */     // MIs[0] Operand 8
     /* 639548 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639566 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN),
     /* 639569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 639571 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639580 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639582 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 639588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639592 */     GIR_RootConstrainSelectedInstOperands,
     /* 639593 */     // GIR_Coverage, 6148,
     /* 639593 */     GIR_EraseRootFromParent_Done,
     /* 639594 */   // Label 8141: @639594
     /* 639594 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(639660), // Rule ID 6146 //
     /* 639599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639602 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639608 */     // MIs[0] offset
     /* 639608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639611 */     // MIs[0] auxiliary
     /* 639611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639614 */     // MIs[0] Operand 8
     /* 639614 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639632 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFEN),
     /* 639635 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639637 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 639639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639646 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639658 */     GIR_RootConstrainSelectedInstOperands,
     /* 639659 */     // GIR_Coverage, 6146,
     /* 639659 */     GIR_EraseRootFromParent_Done,
     /* 639660 */   // Label 8142: @639660
     /* 639660 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(639723), // Rule ID 6154 //
     /* 639665 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639671 */     // MIs[0] offset
     /* 639671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639674 */     // MIs[0] auxiliary
     /* 639674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639677 */     // MIs[0] Operand 8
     /* 639677 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639695 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN),
     /* 639698 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639700 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 639702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639709 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639711 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639721 */     GIR_RootConstrainSelectedInstOperands,
     /* 639722 */     // GIR_Coverage, 6154,
     /* 639722 */     GIR_EraseRootFromParent_Done,
     /* 639723 */   // Label 8143: @639723
     /* 639723 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(639793), // Rule ID 6142 //
     /* 639728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 639735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639739 */     // MIs[0] offset
     /* 639739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639742 */     // MIs[0] auxiliary
     /* 639742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639745 */     // MIs[0] Operand 8
     /* 639745 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639763 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFEN_RTN),
     /* 639766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 639768 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639770 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 639772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639779 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639781 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 639787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639791 */     GIR_RootConstrainSelectedInstOperands,
     /* 639792 */     // GIR_Coverage, 6142,
     /* 639792 */     GIR_EraseRootFromParent_Done,
     /* 639793 */   // Label 8144: @639793
     /* 639793 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(639860), // Rule ID 6150 //
     /* 639798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 639802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 639806 */     // MIs[0] offset
     /* 639806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639809 */     // MIs[0] auxiliary
     /* 639809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639812 */     // MIs[0] Operand 8
     /* 639812 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 639823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639830 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN_RTN),
     /* 639833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 639835 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639837 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 639839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639846 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639848 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 639854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639858 */     GIR_RootConstrainSelectedInstOperands,
     /* 639859 */     // GIR_Coverage, 6150,
     /* 639859 */     GIR_EraseRootFromParent_Done,
     /* 639860 */   // Label 8145: @639860
     /* 639860 */   GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(639918), // Rule ID 6145 //
     /* 639865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639868 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639874 */     // MIs[0] offset
     /* 639874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639877 */     // MIs[0] auxiliary
     /* 639877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639880 */     // MIs[0] Operand 8
     /* 639880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 639883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639890 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_IDXEN),
     /* 639893 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639895 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 639897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639904 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639906 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639916 */     GIR_RootConstrainSelectedInstOperands,
     /* 639917 */     // GIR_Coverage, 6145,
     /* 639917 */     GIR_EraseRootFromParent_Done,
     /* 639918 */   // Label 8146: @639918
     /* 639918 */   GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(639973), // Rule ID 6153 //
     /* 639923 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639929 */     // MIs[0] offset
     /* 639929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639932 */     // MIs[0] auxiliary
     /* 639932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639935 */     // MIs[0] Operand 8
     /* 639935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 639938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 639945 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 639945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN),
     /* 639948 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 639950 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 639952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 639954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 639959 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 639961 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 639967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639971 */     GIR_RootConstrainSelectedInstOperands,
     /* 639972 */     // GIR_Coverage, 6153,
     /* 639972 */     GIR_EraseRootFromParent_Done,
     /* 639973 */   // Label 8147: @639973
     /* 639973 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(640035), // Rule ID 6141 //
     /* 639978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 639985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 639989 */     // MIs[0] offset
     /* 639989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 639992 */     // MIs[0] auxiliary
     /* 639992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 639995 */     // MIs[0] Operand 8
     /* 639995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 639998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640005 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_IDXEN_RTN),
     /* 640008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640010 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640012 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 640014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640021 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640023 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640033 */     GIR_RootConstrainSelectedInstOperands,
     /* 640034 */     // GIR_Coverage, 6141,
     /* 640034 */     GIR_EraseRootFromParent_Done,
     /* 640035 */   // Label 8148: @640035
     /* 640035 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(640094), // Rule ID 6149 //
     /* 640040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 640044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640048 */     // MIs[0] offset
     /* 640048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640051 */     // MIs[0] auxiliary
     /* 640051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640054 */     // MIs[0] Operand 8
     /* 640054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640064 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN_RTN),
     /* 640067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640069 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640071 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 640073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640080 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640092 */     GIR_RootConstrainSelectedInstOperands,
     /* 640093 */     // GIR_Coverage, 6149,
     /* 640093 */     GIR_EraseRootFromParent_Done,
     /* 640094 */   // Label 8149: @640094
     /* 640094 */   GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(640190), // Rule ID 6147 //
     /* 640099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640102 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640104 */     // MIs[0] offset
     /* 640104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640107 */     // MIs[0] auxiliary
     /* 640107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640110 */     // MIs[0] Operand 8
     /* 640110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640120 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640132 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 640136 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 640139 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 640143 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 640146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_BOTHEN),
     /* 640164 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 640169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640176 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640178 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640188 */     GIR_RootConstrainSelectedInstOperands,
     /* 640189 */     // GIR_Coverage, 6147,
     /* 640189 */     GIR_EraseRootFromParent_Done,
     /* 640190 */   // Label 8150: @640190
     /* 640190 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(640283), // Rule ID 6155 //
     /* 640195 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640197 */     // MIs[0] offset
     /* 640197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640200 */     // MIs[0] auxiliary
     /* 640200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640203 */     // MIs[0] Operand 8
     /* 640203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640213 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 640229 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 640232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 640236 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 640239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN),
     /* 640257 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 640262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640269 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640281 */     GIR_RootConstrainSelectedInstOperands,
     /* 640282 */     // GIR_Coverage, 6155,
     /* 640282 */     GIR_EraseRootFromParent_Done,
     /* 640283 */   // Label 8151: @640283
     /* 640283 */   GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(640383), // Rule ID 6143 //
     /* 640288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 640295 */     // MIs[0] offset
     /* 640295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640298 */     // MIs[0] auxiliary
     /* 640298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640301 */     // MIs[0] Operand 8
     /* 640301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640311 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640323 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 640327 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 640330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 640334 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 640337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_BOTHEN_RTN),
     /* 640355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640357 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 640362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640369 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640371 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640381 */     GIR_RootConstrainSelectedInstOperands,
     /* 640382 */     // GIR_Coverage, 6143,
     /* 640382 */     GIR_EraseRootFromParent_Done,
     /* 640383 */   // Label 8152: @640383
     /* 640383 */   GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(640480), // Rule ID 6151 //
     /* 640388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 640392 */     // MIs[0] offset
     /* 640392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640395 */     // MIs[0] auxiliary
     /* 640395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640398 */     // MIs[0] Operand 8
     /* 640398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640408 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640420 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 640424 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 640427 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 640431 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 640434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN_RTN),
     /* 640452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640454 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 640459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640466 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640478 */     GIR_RootConstrainSelectedInstOperands,
     /* 640479 */     // GIR_Coverage, 6151,
     /* 640479 */     GIR_EraseRootFromParent_Done,
     /* 640480 */   // Label 8153: @640480
     /* 640480 */   GIM_Reject,
     /* 640481 */ // Label 8137: @640481
     /* 640481 */ GIM_Reject,
     /* 640482 */ // Label 8119: @640482
     /* 640482 */ GIM_Reject,
     /* 640483 */ // Label 110: @640483
     /* 640483 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8156*/ GIMT_Encode4(644776),
     /* 640494 */ /*GILLT_s32*//*Label 8154*/ GIMT_Encode4(640502),
     /* 640498 */ /*GILLT_s64*//*Label 8155*/ GIMT_Encode4(642639),
     /* 640502 */ // Label 8154: @640502
     /* 640502 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(642638),
     /* 640507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 640510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 640513 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 640516 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 640519 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 640522 */   GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 640525 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(640635), // Rule ID 6384 //
     /* 640530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640533 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640535 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 640543 */     // MIs[0] offset
     /* 640543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640546 */     // MIs[0] auxiliary
     /* 640546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640549 */     // MIs[0] Operand 9
     /* 640549 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 640560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640567 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_OFFSET (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640579 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 640583 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 640586 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 640590 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 640593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET),
     /* 640611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 640614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 640616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640621 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 640623 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640633 */     GIR_RootConstrainSelectedInstOperands,
     /* 640634 */     // GIR_Coverage, 6384,
     /* 640634 */     GIR_EraseRootFromParent_Done,
     /* 640635 */   // Label 8158: @640635
     /* 640635 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(640742), // Rule ID 6392 //
     /* 640640 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 640650 */     // MIs[0] offset
     /* 640650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640653 */     // MIs[0] auxiliary
     /* 640653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640656 */     // MIs[0] Operand 9
     /* 640656 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 640667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640674 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 640690 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 640693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 640697 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 640700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET),
     /* 640718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 640721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 640723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640728 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 640730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640740 */     GIR_RootConstrainSelectedInstOperands,
     /* 640741 */     // GIR_Coverage, 6392,
     /* 640741 */     GIR_EraseRootFromParent_Done,
     /* 640742 */   // Label 8159: @640742
     /* 640742 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(640890), // Rule ID 6380 //
     /* 640747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 640754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 640762 */     // MIs[0] offset
     /* 640762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640765 */     // MIs[0] auxiliary
     /* 640765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640768 */     // MIs[0] Operand 9
     /* 640768 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 640779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640786 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 640786 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 640789 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640793 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640798 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 640802 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 640805 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 640809 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 640812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640822 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN),
     /* 640834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640839 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 640842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 640846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640851 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 640855 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640861 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 640867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 640870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 640872 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 640879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 640884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 640889 */     // GIR_Coverage, 6380,
     /* 640889 */     GIR_EraseRootFromParent_Done,
     /* 640890 */   // Label 8160: @640890
     /* 640890 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(641035), // Rule ID 6388 //
     /* 640895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 640899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 640907 */     // MIs[0] offset
     /* 640907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640910 */     // MIs[0] auxiliary
     /* 640910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640913 */     // MIs[0] Operand 9
     /* 640913 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 640924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640931 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 640931 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 640934 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640938 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640943 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 640947 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 640950 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 640954 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 640957 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN),
     /* 640979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640984 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 640987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 640991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 641000 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641006 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 641012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 641015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 641017 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 641024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 641034 */     // GIR_Coverage, 6388,
     /* 641034 */     GIR_EraseRootFromParent_Done,
     /* 641035 */   // Label 8161: @641035
     /* 641035 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(641143), // Rule ID 6386 //
     /* 641040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641043 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641049 */     // MIs[0] offset
     /* 641049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641052 */     // MIs[0] auxiliary
     /* 641052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641055 */     // MIs[0] Operand 9
     /* 641055 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 641066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641073 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_OFFEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641089 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 641092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641096 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 641099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFEN),
     /* 641117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 641120 */     GIR_RootToRootCopy, /*OpIdx*/5, // voffset
     /* 641122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 641124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641129 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 641131 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641141 */     GIR_RootConstrainSelectedInstOperands,
     /* 641142 */     // GIR_Coverage, 6386,
     /* 641142 */     GIR_EraseRootFromParent_Done,
     /* 641143 */   // Label 8162: @641143
     /* 641143 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(641248), // Rule ID 6394 //
     /* 641148 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641154 */     // MIs[0] offset
     /* 641154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641157 */     // MIs[0] auxiliary
     /* 641157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641160 */     // MIs[0] Operand 9
     /* 641160 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 641171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641178 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641194 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 641197 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641201 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 641204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN),
     /* 641222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 641225 */     GIR_RootToRootCopy, /*OpIdx*/5, // voffset
     /* 641227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 641229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641234 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 641236 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641246 */     GIR_RootConstrainSelectedInstOperands,
     /* 641247 */     // GIR_Coverage, 6394,
     /* 641247 */     GIR_EraseRootFromParent_Done,
     /* 641248 */   // Label 8163: @641248
     /* 641248 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(641396), // Rule ID 6382 //
     /* 641253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641264 */     // MIs[0] offset
     /* 641264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641267 */     // MIs[0] auxiliary
     /* 641267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641270 */     // MIs[0] Operand 9
     /* 641270 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 641281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641288 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_OFFEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 641288 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 641291 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641295 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641300 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641304 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 641307 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641311 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 641314 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641319 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641324 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFEN_RTN),
     /* 641336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641341 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 641344 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 641348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 641352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 641361 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641367 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 641373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 641376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 641378 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 641385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 641395 */     // GIR_Coverage, 6382,
     /* 641395 */     GIR_EraseRootFromParent_Done,
     /* 641396 */   // Label 8164: @641396
     /* 641396 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(641541), // Rule ID 6390 //
     /* 641401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641409 */     // MIs[0] offset
     /* 641409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641412 */     // MIs[0] auxiliary
     /* 641412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641415 */     // MIs[0] Operand 9
     /* 641415 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 641426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641433 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 641433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 641436 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641440 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641445 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641449 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 641452 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641456 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 641459 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641464 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641469 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN_RTN),
     /* 641481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641486 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 641489 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 641493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 641497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 641506 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641512 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 641518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 641521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 641523 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 641530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 641540 */     // GIR_Coverage, 6390,
     /* 641540 */     GIR_EraseRootFromParent_Done,
     /* 641541 */   // Label 8165: @641541
     /* 641541 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(641641), // Rule ID 6385 //
     /* 641546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641549 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 641555 */     // MIs[0] offset
     /* 641555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641558 */     // MIs[0] auxiliary
     /* 641558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641561 */     // MIs[0] Operand 9
     /* 641561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 641564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641571 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_IDXEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641587 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 641590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641594 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 641597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_IDXEN),
     /* 641615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 641618 */     GIR_RootToRootCopy, /*OpIdx*/4, // vindex
     /* 641620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 641622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641627 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 641629 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641639 */     GIR_RootConstrainSelectedInstOperands,
     /* 641640 */     // GIR_Coverage, 6385,
     /* 641640 */     GIR_EraseRootFromParent_Done,
     /* 641641 */   // Label 8166: @641641
     /* 641641 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(641738), // Rule ID 6393 //
     /* 641646 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 641652 */     // MIs[0] offset
     /* 641652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641655 */     // MIs[0] auxiliary
     /* 641655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641658 */     // MIs[0] Operand 9
     /* 641658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 641661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641668 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641684 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 641687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641691 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 641694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN),
     /* 641712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 641715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vindex
     /* 641717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 641719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641724 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 641726 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641736 */     GIR_RootConstrainSelectedInstOperands,
     /* 641737 */     // GIR_Coverage, 6393,
     /* 641737 */     GIR_EraseRootFromParent_Done,
     /* 641738 */   // Label 8167: @641738
     /* 641738 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(641878), // Rule ID 6381 //
     /* 641743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 641754 */     // MIs[0] offset
     /* 641754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641757 */     // MIs[0] auxiliary
     /* 641757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641760 */     // MIs[0] Operand 9
     /* 641760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 641763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641770 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_IDXEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 641770 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 641773 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641777 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641782 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641786 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 641789 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641793 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 641796 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641801 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641806 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_IDXEN_RTN),
     /* 641818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641823 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 641826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 641830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 641834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641839 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 641843 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641849 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 641855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 641858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 641860 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 641867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 641877 */     // GIR_Coverage, 6381,
     /* 641877 */     GIR_EraseRootFromParent_Done,
     /* 641878 */   // Label 8168: @641878
     /* 641878 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(642015), // Rule ID 6389 //
     /* 641883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 641891 */     // MIs[0] offset
     /* 641891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641894 */     // MIs[0] auxiliary
     /* 641894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641897 */     // MIs[0] Operand 9
     /* 641897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 641900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641907 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 641907 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 641910 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641914 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641919 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 641923 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 641926 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 641930 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 641933 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641938 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN_RTN),
     /* 641955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641960 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 641963 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 641967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 641971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 641980 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641986 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 641992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 641995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 641997 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 642004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 642014 */     // GIR_Coverage, 6389,
     /* 642014 */     GIR_EraseRootFromParent_Done,
     /* 642015 */   // Label 8169: @642015
     /* 642015 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(642153), // Rule ID 6387 //
     /* 642020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642023 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 642025 */     // MIs[0] offset
     /* 642025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642028 */     // MIs[0] auxiliary
     /* 642028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642031 */     // MIs[0] Operand 9
     /* 642031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 642034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642041 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_BOTHEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642041 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 642044 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642048 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642053 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 642057 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 642060 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 642064 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 642067 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642072 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642077 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 642098 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 642101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 642105 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 642108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_BOTHEN),
     /* 642126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 642129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 642132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 642134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642139 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 642141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 642147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642151 */     GIR_RootConstrainSelectedInstOperands,
     /* 642152 */     // GIR_Coverage, 6387,
     /* 642152 */     GIR_EraseRootFromParent_Done,
     /* 642153 */   // Label 8170: @642153
     /* 642153 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(642288), // Rule ID 6395 //
     /* 642158 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 642160 */     // MIs[0] offset
     /* 642160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642163 */     // MIs[0] auxiliary
     /* 642163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642166 */     // MIs[0] Operand 9
     /* 642166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 642169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642176 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 642179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642188 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 642192 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 642195 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 642199 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 642202 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642207 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642212 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642229 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 642233 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 642236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 642240 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 642243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN),
     /* 642261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 642264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 642267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 642269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642274 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 642276 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 642282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642286 */     GIR_RootConstrainSelectedInstOperands,
     /* 642287 */     // GIR_Coverage, 6395,
     /* 642287 */     GIR_EraseRootFromParent_Done,
     /* 642288 */   // Label 8171: @642288
     /* 642288 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(642464), // Rule ID 6383 //
     /* 642293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642300 */     // MIs[0] offset
     /* 642300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642303 */     // MIs[0] auxiliary
     /* 642303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642306 */     // MIs[0] Operand 9
     /* 642306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 642309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642316 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_BOTHEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 642316 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 642319 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642323 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642328 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 642332 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
     /* 642335 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 642339 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
     /* 642342 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642347 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642352 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 642360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642369 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 642373 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 642376 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 642380 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 642383 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642388 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642393 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_BOTHEN_RTN),
     /* 642405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642410 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 642413 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 642416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 642420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 642429 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 642435 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 642441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 642444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 642446 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 642453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 642463 */     // GIR_Coverage, 6383,
     /* 642463 */     GIR_EraseRootFromParent_Done,
     /* 642464 */   // Label 8172: @642464
     /* 642464 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(642637), // Rule ID 6391 //
     /* 642469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642473 */     // MIs[0] offset
     /* 642473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642476 */     // MIs[0] auxiliary
     /* 642476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642479 */     // MIs[0] Operand 9
     /* 642479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 642482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642489 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9820:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 642489 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 642492 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642496 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642501 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 642505 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
     /* 642508 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 642512 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
     /* 642515 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642520 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642525 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642530 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 642533 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642537 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642542 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 642546 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 642549 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 642553 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 642556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642561 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642566 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN_RTN),
     /* 642578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642583 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 642586 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 642589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 642593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642598 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 642602 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 642608 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 642614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 642617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 642619 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 642626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 642636 */     // GIR_Coverage, 6391,
     /* 642636 */     GIR_EraseRootFromParent_Done,
     /* 642637 */   // Label 8173: @642637
     /* 642637 */   GIM_Reject,
     /* 642638 */ // Label 8157: @642638
     /* 642638 */ GIM_Reject,
     /* 642639 */ // Label 8155: @642639
     /* 642639 */ GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(644775),
     /* 642644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 642647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 642650 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 642653 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 642656 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 642659 */   GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 642662 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(642772), // Rule ID 6400 //
     /* 642667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642670 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 642672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 642676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 642680 */     // MIs[0] offset
     /* 642680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642683 */     // MIs[0] auxiliary
     /* 642683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642686 */     // MIs[0] Operand 9
     /* 642686 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 642697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642704 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 642707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 642720 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 642723 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 642727 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 642730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 642735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET),
     /* 642748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 642751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 642753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642758 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 642760 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 642766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642770 */     GIR_RootConstrainSelectedInstOperands,
     /* 642771 */     // GIR_Coverage, 6400,
     /* 642771 */     GIR_EraseRootFromParent_Done,
     /* 642772 */   // Label 8175: @642772
     /* 642772 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(642879), // Rule ID 6408 //
     /* 642777 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 642779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 642783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 642787 */     // MIs[0] offset
     /* 642787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642790 */     // MIs[0] auxiliary
     /* 642790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642793 */     // MIs[0] Operand 9
     /* 642793 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 642804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642811 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 642814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642823 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 642827 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 642830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 642834 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 642837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 642842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET),
     /* 642855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 642858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 642860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642865 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 642867 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 642873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642877 */     GIR_RootConstrainSelectedInstOperands,
     /* 642878 */     // GIR_Coverage, 6408,
     /* 642878 */     GIR_EraseRootFromParent_Done,
     /* 642879 */   // Label 8176: @642879
     /* 642879 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(643027), // Rule ID 6396 //
     /* 642884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 642891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 642895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 642899 */     // MIs[0] offset
     /* 642899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642902 */     // MIs[0] auxiliary
     /* 642902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642905 */     // MIs[0] Operand 9
     /* 642905 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 642916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642923 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 642923 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 642926 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642930 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642935 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 642939 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 642942 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 642946 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 642949 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 642954 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 642967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN),
     /* 642971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642976 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 642979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 642983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 642992 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 642998 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 643004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 643007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 643009 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 643016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 643026 */     // GIR_Coverage, 6396,
     /* 643026 */     GIR_EraseRootFromParent_Done,
     /* 643027 */   // Label 8177: @643027
     /* 643027 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(643172), // Rule ID 6404 //
     /* 643032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 643044 */     // MIs[0] offset
     /* 643044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643047 */     // MIs[0] auxiliary
     /* 643047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643050 */     // MIs[0] Operand 9
     /* 643050 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 643061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643068 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 643068 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 643071 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643075 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643080 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643084 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 643087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643091 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 643094 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN),
     /* 643116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643121 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 643124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 643128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643133 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 643137 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643143 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 643149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 643152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 643154 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 643161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 643171 */     // GIR_Coverage, 6404,
     /* 643171 */     GIR_EraseRootFromParent_Done,
     /* 643172 */   // Label 8178: @643172
     /* 643172 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(643280), // Rule ID 6402 //
     /* 643177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643180 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643186 */     // MIs[0] offset
     /* 643186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643189 */     // MIs[0] auxiliary
     /* 643189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643192 */     // MIs[0] Operand 9
     /* 643192 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 643203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643210 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_OFFEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643226 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 643229 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643233 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 643236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFEN),
     /* 643254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 643257 */     GIR_RootToRootCopy, /*OpIdx*/5, // voffset
     /* 643259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 643261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643266 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 643268 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643278 */     GIR_RootConstrainSelectedInstOperands,
     /* 643279 */     // GIR_Coverage, 6402,
     /* 643279 */     GIR_EraseRootFromParent_Done,
     /* 643280 */   // Label 8179: @643280
     /* 643280 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(643385), // Rule ID 6410 //
     /* 643285 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643291 */     // MIs[0] offset
     /* 643291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643294 */     // MIs[0] auxiliary
     /* 643294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643297 */     // MIs[0] Operand 9
     /* 643297 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 643308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643315 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643327 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643331 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 643334 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643338 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 643341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN),
     /* 643359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 643362 */     GIR_RootToRootCopy, /*OpIdx*/5, // voffset
     /* 643364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 643366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643371 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 643373 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643383 */     GIR_RootConstrainSelectedInstOperands,
     /* 643384 */     // GIR_Coverage, 6410,
     /* 643384 */     GIR_EraseRootFromParent_Done,
     /* 643385 */   // Label 8180: @643385
     /* 643385 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(643533), // Rule ID 6398 //
     /* 643390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643401 */     // MIs[0] offset
     /* 643401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643404 */     // MIs[0] auxiliary
     /* 643404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643407 */     // MIs[0] Operand 9
     /* 643407 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 643418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643425 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_OFFEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 643425 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 643428 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643432 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643437 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643441 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 643444 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643448 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 643451 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643456 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643461 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFEN_RTN),
     /* 643473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643478 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 643481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 643485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 643489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 643498 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643504 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 643510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 643513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 643515 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 643522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 643532 */     // GIR_Coverage, 6398,
     /* 643532 */     GIR_EraseRootFromParent_Done,
     /* 643533 */   // Label 8181: @643533
     /* 643533 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(643678), // Rule ID 6406 //
     /* 643538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643546 */     // MIs[0] offset
     /* 643546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643549 */     // MIs[0] auxiliary
     /* 643549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643552 */     // MIs[0] Operand 9
     /* 643552 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 643563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643570 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 643570 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 643573 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643577 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643582 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643586 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 643589 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643593 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 643596 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643601 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643606 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN_RTN),
     /* 643618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643623 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 643626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 643630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 643634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643639 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 643643 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643649 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 643655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 643658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 643660 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 643667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 643677 */     // GIR_Coverage, 6406,
     /* 643677 */     GIR_EraseRootFromParent_Done,
     /* 643678 */   // Label 8182: @643678
     /* 643678 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(643778), // Rule ID 6401 //
     /* 643683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643686 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 643692 */     // MIs[0] offset
     /* 643692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643695 */     // MIs[0] auxiliary
     /* 643695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643698 */     // MIs[0] Operand 9
     /* 643698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 643701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643708 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_IDXEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643724 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 643727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643731 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 643734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_IDXEN),
     /* 643752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 643755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vindex
     /* 643757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 643759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643764 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 643766 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643776 */     GIR_RootConstrainSelectedInstOperands,
     /* 643777 */     // GIR_Coverage, 6401,
     /* 643777 */     GIR_EraseRootFromParent_Done,
     /* 643778 */   // Label 8183: @643778
     /* 643778 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(643875), // Rule ID 6409 //
     /* 643783 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 643789 */     // MIs[0] offset
     /* 643789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643792 */     // MIs[0] auxiliary
     /* 643792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643795 */     // MIs[0] Operand 9
     /* 643795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 643798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643805 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643821 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 643824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643828 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 643831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN),
     /* 643849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 643852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vindex
     /* 643854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 643856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643861 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 643863 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643873 */     GIR_RootConstrainSelectedInstOperands,
     /* 643874 */     // GIR_Coverage, 6409,
     /* 643874 */     GIR_EraseRootFromParent_Done,
     /* 643875 */   // Label 8184: @643875
     /* 643875 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(644015), // Rule ID 6397 //
     /* 643880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 643891 */     // MIs[0] offset
     /* 643891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643894 */     // MIs[0] auxiliary
     /* 643894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643897 */     // MIs[0] Operand 9
     /* 643897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 643900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643907 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_IDXEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 643907 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 643910 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643914 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643919 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 643923 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 643926 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 643930 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 643933 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 643938 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 643951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_IDXEN_RTN),
     /* 643955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643960 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 643963 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 643967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 643971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 643980 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643986 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 643992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 643995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 643997 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 644004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 644014 */     // GIR_Coverage, 6397,
     /* 644014 */     GIR_EraseRootFromParent_Done,
     /* 644015 */   // Label 8185: @644015
     /* 644015 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(644152), // Rule ID 6405 //
     /* 644020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 644028 */     // MIs[0] offset
     /* 644028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644031 */     // MIs[0] auxiliary
     /* 644031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644034 */     // MIs[0] Operand 9
     /* 644034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 644037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644044 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 644044 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 644047 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644051 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644056 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644060 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 644063 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644067 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 644070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 644075 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644080 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 644088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN_RTN),
     /* 644092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644097 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 644100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 644104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 644108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 644117 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 644123 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 644129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 644132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 644134 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 644141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 644151 */     // GIR_Coverage, 6405,
     /* 644151 */     GIR_EraseRootFromParent_Done,
     /* 644152 */   // Label 8186: @644152
     /* 644152 */   GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(644290), // Rule ID 6403 //
     /* 644157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 644160 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644162 */     // MIs[0] offset
     /* 644162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644165 */     // MIs[0] auxiliary
     /* 644165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644168 */     // MIs[0] Operand 9
     /* 644168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 644171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644178 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644178 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 644181 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644185 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644190 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 644194 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 644197 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 644201 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 644204 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 644222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644231 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644235 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 644238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644242 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 644245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 644250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN),
     /* 644263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 644266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 644269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 644271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644276 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 644278 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 644284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644288 */     GIR_RootConstrainSelectedInstOperands,
     /* 644289 */     // GIR_Coverage, 6403,
     /* 644289 */     GIR_EraseRootFromParent_Done,
     /* 644290 */   // Label 8187: @644290
     /* 644290 */   GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(644425), // Rule ID 6411 //
     /* 644295 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644297 */     // MIs[0] offset
     /* 644297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644300 */     // MIs[0] auxiliary
     /* 644300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644303 */     // MIs[0] Operand 9
     /* 644303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 644306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644313 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644313 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 644316 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644320 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644325 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 644329 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 644332 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 644336 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 644339 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644349 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 644357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644370 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 644373 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644377 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 644380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 644385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN),
     /* 644398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 644401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 644404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 644406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644411 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 644413 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 644419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644423 */     GIR_RootConstrainSelectedInstOperands,
     /* 644424 */     // GIR_Coverage, 6411,
     /* 644424 */     GIR_EraseRootFromParent_Done,
     /* 644425 */   // Label 8188: @644425
     /* 644425 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(644601), // Rule ID 6399 //
     /* 644430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 644433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644437 */     // MIs[0] offset
     /* 644437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644440 */     // MIs[0] auxiliary
     /* 644440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644443 */     // MIs[0] Operand 9
     /* 644443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 644446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644453 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 644453 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 644456 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644460 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644465 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 644469 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
     /* 644472 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 644476 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
     /* 644479 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644484 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644489 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644494 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 644497 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644501 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644506 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644510 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 644513 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644517 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 644520 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 644525 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644530 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 644538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN_RTN),
     /* 644542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644547 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 644550 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 644553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 644557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 644566 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 644572 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 644578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 644581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 644583 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 644590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 644600 */     // GIR_Coverage, 6399,
     /* 644600 */     GIR_EraseRootFromParent_Done,
     /* 644601 */   // Label 8189: @644601
     /* 644601 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(644774), // Rule ID 6407 //
     /* 644606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644610 */     // MIs[0] offset
     /* 644610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644613 */     // MIs[0] auxiliary
     /* 644613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644616 */     // MIs[0] Operand 9
     /* 644616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 644619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644626 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9819:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 644626 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 644629 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644633 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644638 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 644642 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
     /* 644645 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 644649 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
     /* 644652 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644657 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644662 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644667 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 644670 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644674 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644683 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 644686 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644690 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 644693 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 644698 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 644711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN_RTN),
     /* 644715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644720 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 644723 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 644726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 644730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644735 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 644739 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 644745 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 644751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 644754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 644756 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 644763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 644773 */     // GIR_Coverage, 6407,
     /* 644773 */     GIR_EraseRootFromParent_Done,
     /* 644774 */   // Label 8190: @644774
     /* 644774 */   GIM_Reject,
     /* 644775 */ // Label 8174: @644775
     /* 644775 */ GIM_Reject,
     /* 644776 */ // Label 8156: @644776
     /* 644776 */ GIM_Reject,
     /* 644777 */ // Label 111: @644777
     /* 644777 */ GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(645393),
     /* 644782 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 644785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 644788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 644791 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 644794 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 644797 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 644800 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(644868), // Rule ID 6232 //
     /* 644805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 644808 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 644814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 644818 */     // MIs[0] offset
     /* 644818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644821 */     // MIs[0] auxiliary
     /* 644821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644824 */     // MIs[0] Operand 8
     /* 644824 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 644835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644842 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET),
     /* 644845 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644854 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644856 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 644862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644866 */     GIR_RootConstrainSelectedInstOperands,
     /* 644867 */     // GIR_Coverage, 6232,
     /* 644867 */     GIR_EraseRootFromParent_Done,
     /* 644868 */   // Label 8192: @644868
     /* 644868 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(644940), // Rule ID 6228 //
     /* 644873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 644876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 644880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 644884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 644888 */     // MIs[0] offset
     /* 644888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644891 */     // MIs[0] auxiliary
     /* 644891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644894 */     // MIs[0] Operand 8
     /* 644894 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 644905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644912 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET_RTN),
     /* 644915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 644917 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644926 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644928 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 644934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644938 */     GIR_RootConstrainSelectedInstOperands,
     /* 644939 */     // GIR_Coverage, 6228,
     /* 644939 */     GIR_EraseRootFromParent_Done,
     /* 644940 */   // Label 8193: @644940
     /* 644940 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(645006), // Rule ID 6234 //
     /* 644945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 644948 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 644954 */     // MIs[0] offset
     /* 644954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644957 */     // MIs[0] auxiliary
     /* 644957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644960 */     // MIs[0] Operand 8
     /* 644960 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 644971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644978 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN),
     /* 644981 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644983 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 644985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644992 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645004 */     GIR_RootConstrainSelectedInstOperands,
     /* 645005 */     // GIR_Coverage, 6234,
     /* 645005 */     GIR_EraseRootFromParent_Done,
     /* 645006 */   // Label 8194: @645006
     /* 645006 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(645076), // Rule ID 6230 //
     /* 645011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 645014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645022 */     // MIs[0] offset
     /* 645022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645025 */     // MIs[0] auxiliary
     /* 645025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645028 */     // MIs[0] Operand 8
     /* 645028 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645046 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN_RTN),
     /* 645049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 645051 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645053 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 645055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645062 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645074 */     GIR_RootConstrainSelectedInstOperands,
     /* 645075 */     // GIR_Coverage, 6230,
     /* 645075 */     GIR_EraseRootFromParent_Done,
     /* 645076 */   // Label 8195: @645076
     /* 645076 */   GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(645134), // Rule ID 6233 //
     /* 645081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 645084 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645090 */     // MIs[0] offset
     /* 645090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645093 */     // MIs[0] auxiliary
     /* 645093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645096 */     // MIs[0] Operand 8
     /* 645096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645106 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN),
     /* 645109 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645111 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 645113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645120 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645122 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645132 */     GIR_RootConstrainSelectedInstOperands,
     /* 645133 */     // GIR_Coverage, 6233,
     /* 645133 */     GIR_EraseRootFromParent_Done,
     /* 645134 */   // Label 8196: @645134
     /* 645134 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(645196), // Rule ID 6229 //
     /* 645139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 645142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645150 */     // MIs[0] offset
     /* 645150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645153 */     // MIs[0] auxiliary
     /* 645153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645156 */     // MIs[0] Operand 8
     /* 645156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645166 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN_RTN),
     /* 645169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 645171 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645173 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 645175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645182 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645184 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645194 */     GIR_RootConstrainSelectedInstOperands,
     /* 645195 */     // GIR_Coverage, 6229,
     /* 645195 */     GIR_EraseRootFromParent_Done,
     /* 645196 */   // Label 8197: @645196
     /* 645196 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(645292), // Rule ID 6235 //
     /* 645201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 645204 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645206 */     // MIs[0] offset
     /* 645206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645209 */     // MIs[0] auxiliary
     /* 645209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645212 */     // MIs[0] Operand 8
     /* 645212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645222 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 645225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 645229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 645238 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 645241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 645245 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 645248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 645253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN),
     /* 645266 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 645271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645278 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645280 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645290 */     GIR_RootConstrainSelectedInstOperands,
     /* 645291 */     // GIR_Coverage, 6235,
     /* 645291 */     GIR_EraseRootFromParent_Done,
     /* 645292 */   // Label 8198: @645292
     /* 645292 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(645392), // Rule ID 6231 //
     /* 645297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 645300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645304 */     // MIs[0] offset
     /* 645304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645307 */     // MIs[0] auxiliary
     /* 645307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645310 */     // MIs[0] Operand 8
     /* 645310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645320 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 645323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 645327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 645336 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 645339 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 645343 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 645346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 645351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN_RTN),
     /* 645364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 645366 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 645371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645378 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645380 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645390 */     GIR_RootConstrainSelectedInstOperands,
     /* 645391 */     // GIR_Coverage, 6231,
     /* 645391 */     GIR_EraseRootFromParent_Done,
     /* 645392 */   // Label 8199: @645392
     /* 645392 */   GIM_Reject,
     /* 645393 */ // Label 8191: @645393
     /* 645393 */ GIM_Reject,
     /* 645394 */ // Label 112: @645394
     /* 645394 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8202*/ GIMT_Encode4(647777),
     /* 645405 */ /*GILLT_s32*//*Label 8200*/ GIMT_Encode4(645413),
     /* 645409 */ /*GILLT_s64*//*Label 8201*/ GIMT_Encode4(646595),
     /* 645413 */ // Label 8200: @645413
     /* 645413 */ GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(646594),
     /* 645418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 645421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 645424 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 645427 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 645430 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 645433 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(645501), // Rule ID 6008 //
     /* 645438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 645441 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645451 */     // MIs[0] offset
     /* 645451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645454 */     // MIs[0] auxiliary
     /* 645454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645457 */     // MIs[0] Operand 8
     /* 645457 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645475 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET),
     /* 645478 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645487 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645499 */     GIR_RootConstrainSelectedInstOperands,
     /* 645500 */     // GIR_Coverage, 6008,
     /* 645500 */     GIR_EraseRootFromParent_Done,
     /* 645501 */   // Label 8204: @645501
     /* 645501 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(645566), // Rule ID 6016 //
     /* 645506 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645516 */     // MIs[0] offset
     /* 645516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645519 */     // MIs[0] auxiliary
     /* 645519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645522 */     // MIs[0] Operand 8
     /* 645522 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645540 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET),
     /* 645543 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645552 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645554 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645564 */     GIR_RootConstrainSelectedInstOperands,
     /* 645565 */     // GIR_Coverage, 6016,
     /* 645565 */     GIR_EraseRootFromParent_Done,
     /* 645566 */   // Label 8205: @645566
     /* 645566 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(645638), // Rule ID 6004 //
     /* 645571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 645574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645586 */     // MIs[0] offset
     /* 645586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645589 */     // MIs[0] auxiliary
     /* 645589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645592 */     // MIs[0] Operand 8
     /* 645592 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645610 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET_RTN),
     /* 645613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 645615 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645624 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645626 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645636 */     GIR_RootConstrainSelectedInstOperands,
     /* 645637 */     // GIR_Coverage, 6004,
     /* 645637 */     GIR_EraseRootFromParent_Done,
     /* 645638 */   // Label 8206: @645638
     /* 645638 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(645707), // Rule ID 6012 //
     /* 645643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645655 */     // MIs[0] offset
     /* 645655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645658 */     // MIs[0] auxiliary
     /* 645658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645661 */     // MIs[0] Operand 8
     /* 645661 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645679 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN),
     /* 645682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 645684 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645693 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645695 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645705 */     GIR_RootConstrainSelectedInstOperands,
     /* 645706 */     // GIR_Coverage, 6012,
     /* 645706 */     GIR_EraseRootFromParent_Done,
     /* 645707 */   // Label 8207: @645707
     /* 645707 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(645773), // Rule ID 6010 //
     /* 645712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 645715 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645721 */     // MIs[0] offset
     /* 645721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645724 */     // MIs[0] auxiliary
     /* 645724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645727 */     // MIs[0] Operand 8
     /* 645727 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645745 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFEN),
     /* 645748 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645750 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 645752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645759 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645761 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645771 */     GIR_RootConstrainSelectedInstOperands,
     /* 645772 */     // GIR_Coverage, 6010,
     /* 645772 */     GIR_EraseRootFromParent_Done,
     /* 645773 */   // Label 8208: @645773
     /* 645773 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(645836), // Rule ID 6018 //
     /* 645778 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645784 */     // MIs[0] offset
     /* 645784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645787 */     // MIs[0] auxiliary
     /* 645787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645790 */     // MIs[0] Operand 8
     /* 645790 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645808 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFEN),
     /* 645811 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645813 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 645815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645822 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645824 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645834 */     GIR_RootConstrainSelectedInstOperands,
     /* 645835 */     // GIR_Coverage, 6018,
     /* 645835 */     GIR_EraseRootFromParent_Done,
     /* 645836 */   // Label 8209: @645836
     /* 645836 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(645906), // Rule ID 6006 //
     /* 645841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 645844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645852 */     // MIs[0] offset
     /* 645852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645855 */     // MIs[0] auxiliary
     /* 645855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645858 */     // MIs[0] Operand 8
     /* 645858 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645876 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFEN_RTN),
     /* 645879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 645881 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645883 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 645885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645892 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645894 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645904 */     GIR_RootConstrainSelectedInstOperands,
     /* 645905 */     // GIR_Coverage, 6006,
     /* 645905 */     GIR_EraseRootFromParent_Done,
     /* 645906 */   // Label 8210: @645906
     /* 645906 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(645973), // Rule ID 6014 //
     /* 645911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 645919 */     // MIs[0] offset
     /* 645919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645922 */     // MIs[0] auxiliary
     /* 645922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645925 */     // MIs[0] Operand 8
     /* 645925 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 645936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645943 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFEN_RTN),
     /* 645946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 645948 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 645950 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 645952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 645954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645959 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 645961 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645971 */     GIR_RootConstrainSelectedInstOperands,
     /* 645972 */     // GIR_Coverage, 6014,
     /* 645972 */     GIR_EraseRootFromParent_Done,
     /* 645973 */   // Label 8211: @645973
     /* 645973 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(646031), // Rule ID 6009 //
     /* 645978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 645981 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645987 */     // MIs[0] offset
     /* 645987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 645990 */     // MIs[0] auxiliary
     /* 645990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645993 */     // MIs[0] Operand 8
     /* 645993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646003 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_IDXEN),
     /* 646006 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646008 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 646010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646017 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646019 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646029 */     GIR_RootConstrainSelectedInstOperands,
     /* 646030 */     // GIR_Coverage, 6009,
     /* 646030 */     GIR_EraseRootFromParent_Done,
     /* 646031 */   // Label 8212: @646031
     /* 646031 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(646086), // Rule ID 6017 //
     /* 646036 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 646042 */     // MIs[0] offset
     /* 646042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646045 */     // MIs[0] auxiliary
     /* 646045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646048 */     // MIs[0] Operand 8
     /* 646048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646058 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_IDXEN),
     /* 646061 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646063 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 646065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646072 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646074 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646084 */     GIR_RootConstrainSelectedInstOperands,
     /* 646085 */     // GIR_Coverage, 6017,
     /* 646085 */     GIR_EraseRootFromParent_Done,
     /* 646086 */   // Label 8213: @646086
     /* 646086 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(646148), // Rule ID 6005 //
     /* 646091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 646102 */     // MIs[0] offset
     /* 646102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646105 */     // MIs[0] auxiliary
     /* 646105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646108 */     // MIs[0] Operand 8
     /* 646108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646118 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_IDXEN_RTN),
     /* 646121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 646123 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646125 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 646127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646134 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646136 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646146 */     GIR_RootConstrainSelectedInstOperands,
     /* 646147 */     // GIR_Coverage, 6005,
     /* 646147 */     GIR_EraseRootFromParent_Done,
     /* 646148 */   // Label 8214: @646148
     /* 646148 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(646207), // Rule ID 6013 //
     /* 646153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 646161 */     // MIs[0] offset
     /* 646161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646164 */     // MIs[0] auxiliary
     /* 646164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646167 */     // MIs[0] Operand 8
     /* 646167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646177 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_IDXEN_RTN),
     /* 646180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 646182 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646184 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 646186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646193 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646195 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646205 */     GIR_RootConstrainSelectedInstOperands,
     /* 646206 */     // GIR_Coverage, 6013,
     /* 646206 */     GIR_EraseRootFromParent_Done,
     /* 646207 */   // Label 8215: @646207
     /* 646207 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(646303), // Rule ID 6011 //
     /* 646212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646215 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646217 */     // MIs[0] offset
     /* 646217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646220 */     // MIs[0] auxiliary
     /* 646220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646223 */     // MIs[0] Operand 8
     /* 646223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646233 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 646249 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 646252 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 646256 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 646259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_BOTHEN),
     /* 646277 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 646282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646289 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646291 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646301 */     GIR_RootConstrainSelectedInstOperands,
     /* 646302 */     // GIR_Coverage, 6011,
     /* 646302 */     GIR_EraseRootFromParent_Done,
     /* 646303 */   // Label 8216: @646303
     /* 646303 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(646396), // Rule ID 6019 //
     /* 646308 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646310 */     // MIs[0] offset
     /* 646310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646313 */     // MIs[0] auxiliary
     /* 646313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646316 */     // MIs[0] Operand 8
     /* 646316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646326 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 646342 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 646345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 646349 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 646352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN),
     /* 646370 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 646375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646382 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646384 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646394 */     GIR_RootConstrainSelectedInstOperands,
     /* 646395 */     // GIR_Coverage, 6019,
     /* 646395 */     GIR_EraseRootFromParent_Done,
     /* 646396 */   // Label 8217: @646396
     /* 646396 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(646496), // Rule ID 6007 //
     /* 646401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646408 */     // MIs[0] offset
     /* 646408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646411 */     // MIs[0] auxiliary
     /* 646411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646414 */     // MIs[0] Operand 8
     /* 646414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646424 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 646440 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 646443 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 646447 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 646450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_BOTHEN_RTN),
     /* 646468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 646470 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 646475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646482 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646484 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646494 */     GIR_RootConstrainSelectedInstOperands,
     /* 646495 */     // GIR_Coverage, 6007,
     /* 646495 */     GIR_EraseRootFromParent_Done,
     /* 646496 */   // Label 8218: @646496
     /* 646496 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(646593), // Rule ID 6015 //
     /* 646501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646505 */     // MIs[0] offset
     /* 646505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646508 */     // MIs[0] auxiliary
     /* 646508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646511 */     // MIs[0] Operand 8
     /* 646511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646521 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 646537 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 646540 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 646544 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 646547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN_RTN),
     /* 646565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 646567 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 646572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646579 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646581 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646591 */     GIR_RootConstrainSelectedInstOperands,
     /* 646592 */     // GIR_Coverage, 6015,
     /* 646592 */     GIR_EraseRootFromParent_Done,
     /* 646593 */   // Label 8219: @646593
     /* 646593 */   GIM_Reject,
     /* 646594 */ // Label 8203: @646594
     /* 646594 */ GIM_Reject,
     /* 646595 */ // Label 8201: @646595
     /* 646595 */ GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(647776),
     /* 646600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 646603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 646606 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 646609 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 646612 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 646615 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(646683), // Rule ID 6208 //
     /* 646620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646623 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 646629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 646633 */     // MIs[0] offset
     /* 646633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646636 */     // MIs[0] auxiliary
     /* 646636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646639 */     // MIs[0] Operand 8
     /* 646639 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 646650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646657 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET),
     /* 646660 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646669 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646671 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646681 */     GIR_RootConstrainSelectedInstOperands,
     /* 646682 */     // GIR_Coverage, 6208,
     /* 646682 */     GIR_EraseRootFromParent_Done,
     /* 646683 */   // Label 8221: @646683
     /* 646683 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(646748), // Rule ID 6216 //
     /* 646688 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 646694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 646698 */     // MIs[0] offset
     /* 646698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646701 */     // MIs[0] auxiliary
     /* 646701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646704 */     // MIs[0] Operand 8
     /* 646704 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 646715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646722 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET),
     /* 646725 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646734 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646746 */     GIR_RootConstrainSelectedInstOperands,
     /* 646747 */     // GIR_Coverage, 6216,
     /* 646747 */     GIR_EraseRootFromParent_Done,
     /* 646748 */   // Label 8222: @646748
     /* 646748 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(646820), // Rule ID 6204 //
     /* 646753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 646760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 646764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 646768 */     // MIs[0] offset
     /* 646768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646771 */     // MIs[0] auxiliary
     /* 646771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646774 */     // MIs[0] Operand 8
     /* 646774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 646785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646792 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET_RTN),
     /* 646795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 646797 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646806 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646818 */     GIR_RootConstrainSelectedInstOperands,
     /* 646819 */     // GIR_Coverage, 6204,
     /* 646819 */     GIR_EraseRootFromParent_Done,
     /* 646820 */   // Label 8223: @646820
     /* 646820 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(646889), // Rule ID 6212 //
     /* 646825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 646829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 646833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 646837 */     // MIs[0] offset
     /* 646837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646840 */     // MIs[0] auxiliary
     /* 646840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646843 */     // MIs[0] Operand 8
     /* 646843 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 646854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646861 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN),
     /* 646864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 646866 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646875 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646887 */     GIR_RootConstrainSelectedInstOperands,
     /* 646888 */     // GIR_Coverage, 6212,
     /* 646888 */     GIR_EraseRootFromParent_Done,
     /* 646889 */   // Label 8224: @646889
     /* 646889 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(646955), // Rule ID 6210 //
     /* 646894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646897 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 646903 */     // MIs[0] offset
     /* 646903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646906 */     // MIs[0] auxiliary
     /* 646906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646909 */     // MIs[0] Operand 8
     /* 646909 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 646920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646927 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFEN),
     /* 646930 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646932 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 646934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646941 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 646943 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646953 */     GIR_RootConstrainSelectedInstOperands,
     /* 646954 */     // GIR_Coverage, 6210,
     /* 646954 */     GIR_EraseRootFromParent_Done,
     /* 646955 */   // Label 8225: @646955
     /* 646955 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(647018), // Rule ID 6218 //
     /* 646960 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 646966 */     // MIs[0] offset
     /* 646966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 646969 */     // MIs[0] auxiliary
     /* 646969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646972 */     // MIs[0] Operand 8
     /* 646972 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 646983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646990 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN),
     /* 646993 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 646995 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 646997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 646999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647004 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647006 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647016 */     GIR_RootConstrainSelectedInstOperands,
     /* 647017 */     // GIR_Coverage, 6218,
     /* 647017 */     GIR_EraseRootFromParent_Done,
     /* 647018 */   // Label 8226: @647018
     /* 647018 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(647088), // Rule ID 6206 //
     /* 647023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 647034 */     // MIs[0] offset
     /* 647034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647037 */     // MIs[0] auxiliary
     /* 647037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647040 */     // MIs[0] Operand 8
     /* 647040 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 647051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647058 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFEN_RTN),
     /* 647061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 647063 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647065 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 647067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647074 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647076 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647086 */     GIR_RootConstrainSelectedInstOperands,
     /* 647087 */     // GIR_Coverage, 6206,
     /* 647087 */     GIR_EraseRootFromParent_Done,
     /* 647088 */   // Label 8227: @647088
     /* 647088 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(647155), // Rule ID 6214 //
     /* 647093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 647101 */     // MIs[0] offset
     /* 647101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647104 */     // MIs[0] auxiliary
     /* 647104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647107 */     // MIs[0] Operand 8
     /* 647107 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 647118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647125 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN_RTN),
     /* 647128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 647130 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647132 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 647134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647141 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647143 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647153 */     GIR_RootConstrainSelectedInstOperands,
     /* 647154 */     // GIR_Coverage, 6214,
     /* 647154 */     GIR_EraseRootFromParent_Done,
     /* 647155 */   // Label 8228: @647155
     /* 647155 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(647213), // Rule ID 6209 //
     /* 647160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647163 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647169 */     // MIs[0] offset
     /* 647169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647172 */     // MIs[0] auxiliary
     /* 647172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647175 */     // MIs[0] Operand 8
     /* 647175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647185 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_IDXEN),
     /* 647188 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647190 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 647192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647199 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647201 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647211 */     GIR_RootConstrainSelectedInstOperands,
     /* 647212 */     // GIR_Coverage, 6209,
     /* 647212 */     GIR_EraseRootFromParent_Done,
     /* 647213 */   // Label 8229: @647213
     /* 647213 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(647268), // Rule ID 6217 //
     /* 647218 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647224 */     // MIs[0] offset
     /* 647224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647227 */     // MIs[0] auxiliary
     /* 647227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647230 */     // MIs[0] Operand 8
     /* 647230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647240 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN),
     /* 647243 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647245 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 647247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647254 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647256 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647266 */     GIR_RootConstrainSelectedInstOperands,
     /* 647267 */     // GIR_Coverage, 6217,
     /* 647267 */     GIR_EraseRootFromParent_Done,
     /* 647268 */   // Label 8230: @647268
     /* 647268 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(647330), // Rule ID 6205 //
     /* 647273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647284 */     // MIs[0] offset
     /* 647284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647287 */     // MIs[0] auxiliary
     /* 647287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647290 */     // MIs[0] Operand 8
     /* 647290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647300 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_IDXEN_RTN),
     /* 647303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 647305 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647307 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 647309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647316 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647318 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647328 */     GIR_RootConstrainSelectedInstOperands,
     /* 647329 */     // GIR_Coverage, 6205,
     /* 647329 */     GIR_EraseRootFromParent_Done,
     /* 647330 */   // Label 8231: @647330
     /* 647330 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(647389), // Rule ID 6213 //
     /* 647335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647343 */     // MIs[0] offset
     /* 647343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647346 */     // MIs[0] auxiliary
     /* 647346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647349 */     // MIs[0] Operand 8
     /* 647349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647359 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN_RTN),
     /* 647362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 647364 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647366 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 647368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647375 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647377 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647387 */     GIR_RootConstrainSelectedInstOperands,
     /* 647388 */     // GIR_Coverage, 6213,
     /* 647388 */     GIR_EraseRootFromParent_Done,
     /* 647389 */   // Label 8232: @647389
     /* 647389 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(647485), // Rule ID 6211 //
     /* 647394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647397 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647399 */     // MIs[0] offset
     /* 647399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647402 */     // MIs[0] auxiliary
     /* 647402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647405 */     // MIs[0] Operand 8
     /* 647405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647415 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 647418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647427 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 647431 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 647434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 647438 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 647441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_BOTHEN),
     /* 647459 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 647464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647471 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647473 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647483 */     GIR_RootConstrainSelectedInstOperands,
     /* 647484 */     // GIR_Coverage, 6211,
     /* 647484 */     GIR_EraseRootFromParent_Done,
     /* 647485 */   // Label 8233: @647485
     /* 647485 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(647578), // Rule ID 6219 //
     /* 647490 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647492 */     // MIs[0] offset
     /* 647492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647495 */     // MIs[0] auxiliary
     /* 647495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647498 */     // MIs[0] Operand 8
     /* 647498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647508 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 647511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647520 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 647524 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 647527 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 647531 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 647534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN),
     /* 647552 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 647557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647564 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647566 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647576 */     GIR_RootConstrainSelectedInstOperands,
     /* 647577 */     // GIR_Coverage, 6219,
     /* 647577 */     GIR_EraseRootFromParent_Done,
     /* 647578 */   // Label 8234: @647578
     /* 647578 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(647678), // Rule ID 6207 //
     /* 647583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647590 */     // MIs[0] offset
     /* 647590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647593 */     // MIs[0] auxiliary
     /* 647593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647596 */     // MIs[0] Operand 8
     /* 647596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647606 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 647609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 647622 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 647625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 647629 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 647632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_BOTHEN_RTN),
     /* 647650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 647652 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 647657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647664 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647666 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647676 */     GIR_RootConstrainSelectedInstOperands,
     /* 647677 */     // GIR_Coverage, 6207,
     /* 647677 */     GIR_EraseRootFromParent_Done,
     /* 647678 */   // Label 8235: @647678
     /* 647678 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(647775), // Rule ID 6215 //
     /* 647683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647687 */     // MIs[0] offset
     /* 647687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647690 */     // MIs[0] auxiliary
     /* 647690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647693 */     // MIs[0] Operand 8
     /* 647693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647703 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 647706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 647719 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 647722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 647726 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 647729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 647744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN_RTN),
     /* 647747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 647749 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 647754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647761 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647763 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647773 */     GIR_RootConstrainSelectedInstOperands,
     /* 647774 */     // GIR_Coverage, 6215,
     /* 647774 */     GIR_EraseRootFromParent_Done,
     /* 647775 */   // Label 8236: @647775
     /* 647775 */   GIM_Reject,
     /* 647776 */ // Label 8220: @647776
     /* 647776 */ GIM_Reject,
     /* 647777 */ // Label 8202: @647777
     /* 647777 */ GIM_Reject,
     /* 647778 */ // Label 113: @647778
     /* 647778 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8240*/ GIMT_Encode4(651419),
     /* 647789 */ /*GILLT_s32*//*Label 8237*/ GIMT_Encode4(647801),
     /* 647793 */ /*GILLT_s64*//*Label 8238*/ GIMT_Encode4(649007),
     /* 647797 */ /*GILLT_v2s16*//*Label 8239*/ GIMT_Encode4(650213),
     /* 647801 */ // Label 8237: @647801
     /* 647801 */ GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(649006),
     /* 647806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 647809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 647812 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 647815 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 647818 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 647821 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(647889), // Rule ID 6300 //
     /* 647826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
     /* 647829 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 647835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647839 */     // MIs[0] offset
     /* 647839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647842 */     // MIs[0] auxiliary
     /* 647842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647845 */     // MIs[0] Operand 8
     /* 647845 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 647856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647863 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_OFFSET anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFSET),
     /* 647866 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647875 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647887 */     GIR_RootConstrainSelectedInstOperands,
     /* 647888 */     // GIR_Coverage, 6300,
     /* 647888 */     GIR_EraseRootFromParent_Done,
     /* 647889 */   // Label 8242: @647889
     /* 647889 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(647957), // Rule ID 6304 //
     /* 647894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 647897 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 647903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647907 */     // MIs[0] offset
     /* 647907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647910 */     // MIs[0] auxiliary
     /* 647910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647913 */     // MIs[0] Operand 8
     /* 647913 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 647924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647931 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET),
     /* 647934 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 647936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 647938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647943 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 647945 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647955 */     GIR_RootConstrainSelectedInstOperands,
     /* 647956 */     // GIR_Coverage, 6304,
     /* 647956 */     GIR_EraseRootFromParent_Done,
     /* 647957 */   // Label 8243: @647957
     /* 647957 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(648029), // Rule ID 6316 //
     /* 647962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
     /* 647965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 647969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 647973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647977 */     // MIs[0] offset
     /* 647977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 647980 */     // MIs[0] auxiliary
     /* 647980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647983 */     // MIs[0] Operand 8
     /* 647983 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 647994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648001 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_OFFSET_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFSET_RTN),
     /* 648004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648006 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648015 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648017 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648027 */     GIR_RootConstrainSelectedInstOperands,
     /* 648028 */     // GIR_Coverage, 6316,
     /* 648028 */     GIR_EraseRootFromParent_Done,
     /* 648029 */   // Label 8244: @648029
     /* 648029 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(648101), // Rule ID 6320 //
     /* 648034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 648037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 648041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 648045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 648049 */     // MIs[0] offset
     /* 648049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648052 */     // MIs[0] auxiliary
     /* 648052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648055 */     // MIs[0] Operand 8
     /* 648055 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 648066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648073 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET_RTN),
     /* 648076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648078 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648087 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648089 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648099 */     GIR_RootConstrainSelectedInstOperands,
     /* 648100 */     // GIR_Coverage, 6320,
     /* 648100 */     GIR_EraseRootFromParent_Done,
     /* 648101 */   // Label 8245: @648101
     /* 648101 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(648167), // Rule ID 6302 //
     /* 648106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
     /* 648109 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 648115 */     // MIs[0] offset
     /* 648115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648118 */     // MIs[0] auxiliary
     /* 648118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648121 */     // MIs[0] Operand 8
     /* 648121 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 648132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648139 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_OFFEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFEN),
     /* 648142 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648144 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 648146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648153 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648155 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648165 */     GIR_RootConstrainSelectedInstOperands,
     /* 648166 */     // GIR_Coverage, 6302,
     /* 648166 */     GIR_EraseRootFromParent_Done,
     /* 648167 */   // Label 8246: @648167
     /* 648167 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(648233), // Rule ID 6306 //
     /* 648172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 648175 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 648181 */     // MIs[0] offset
     /* 648181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648184 */     // MIs[0] auxiliary
     /* 648184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648187 */     // MIs[0] Operand 8
     /* 648187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 648198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648205 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN),
     /* 648208 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648210 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 648212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648219 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648231 */     GIR_RootConstrainSelectedInstOperands,
     /* 648232 */     // GIR_Coverage, 6306,
     /* 648232 */     GIR_EraseRootFromParent_Done,
     /* 648233 */   // Label 8247: @648233
     /* 648233 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(648303), // Rule ID 6318 //
     /* 648238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
     /* 648241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 648245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 648249 */     // MIs[0] offset
     /* 648249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648252 */     // MIs[0] auxiliary
     /* 648252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648255 */     // MIs[0] Operand 8
     /* 648255 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 648266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648273 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_OFFEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFEN_RTN),
     /* 648276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648278 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648280 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 648282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648289 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648291 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648301 */     GIR_RootConstrainSelectedInstOperands,
     /* 648302 */     // GIR_Coverage, 6318,
     /* 648302 */     GIR_EraseRootFromParent_Done,
     /* 648303 */   // Label 8248: @648303
     /* 648303 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(648373), // Rule ID 6322 //
     /* 648308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 648311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 648315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 648319 */     // MIs[0] offset
     /* 648319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648322 */     // MIs[0] auxiliary
     /* 648322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648325 */     // MIs[0] Operand 8
     /* 648325 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 648336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648343 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN_RTN),
     /* 648346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648348 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648350 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 648352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648359 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648361 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648371 */     GIR_RootConstrainSelectedInstOperands,
     /* 648372 */     // GIR_Coverage, 6322,
     /* 648372 */     GIR_EraseRootFromParent_Done,
     /* 648373 */   // Label 8249: @648373
     /* 648373 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(648431), // Rule ID 6301 //
     /* 648378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
     /* 648381 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 648387 */     // MIs[0] offset
     /* 648387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648390 */     // MIs[0] auxiliary
     /* 648390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648393 */     // MIs[0] Operand 8
     /* 648393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648403 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_IDXEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_IDXEN),
     /* 648406 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648408 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 648410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648417 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648429 */     GIR_RootConstrainSelectedInstOperands,
     /* 648430 */     // GIR_Coverage, 6301,
     /* 648430 */     GIR_EraseRootFromParent_Done,
     /* 648431 */   // Label 8250: @648431
     /* 648431 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(648489), // Rule ID 6305 //
     /* 648436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 648439 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 648445 */     // MIs[0] offset
     /* 648445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648448 */     // MIs[0] auxiliary
     /* 648448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648451 */     // MIs[0] Operand 8
     /* 648451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648461 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN),
     /* 648464 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648466 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 648468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648475 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648477 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648487 */     GIR_RootConstrainSelectedInstOperands,
     /* 648488 */     // GIR_Coverage, 6305,
     /* 648488 */     GIR_EraseRootFromParent_Done,
     /* 648489 */   // Label 8251: @648489
     /* 648489 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(648551), // Rule ID 6317 //
     /* 648494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
     /* 648497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 648501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 648505 */     // MIs[0] offset
     /* 648505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648508 */     // MIs[0] auxiliary
     /* 648508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648511 */     // MIs[0] Operand 8
     /* 648511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648521 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_IDXEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_IDXEN_RTN),
     /* 648524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648526 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648528 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 648530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648537 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648539 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648549 */     GIR_RootConstrainSelectedInstOperands,
     /* 648550 */     // GIR_Coverage, 6317,
     /* 648550 */     GIR_EraseRootFromParent_Done,
     /* 648551 */   // Label 8252: @648551
     /* 648551 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(648613), // Rule ID 6321 //
     /* 648556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 648559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 648563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 648567 */     // MIs[0] offset
     /* 648567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648570 */     // MIs[0] auxiliary
     /* 648570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648573 */     // MIs[0] Operand 8
     /* 648573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648583 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN_RTN),
     /* 648586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648588 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648590 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 648592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648599 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648601 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648611 */     GIR_RootConstrainSelectedInstOperands,
     /* 648612 */     // GIR_Coverage, 6321,
     /* 648612 */     GIR_EraseRootFromParent_Done,
     /* 648613 */   // Label 8253: @648613
     /* 648613 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(648709), // Rule ID 6303 //
     /* 648618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
     /* 648621 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648623 */     // MIs[0] offset
     /* 648623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648626 */     // MIs[0] auxiliary
     /* 648626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648629 */     // MIs[0] Operand 8
     /* 648629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648639 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_BOTHEN anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 648642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648651 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 648655 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 648658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 648662 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 648665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_BOTHEN),
     /* 648683 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 648688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648695 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648697 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648707 */     GIR_RootConstrainSelectedInstOperands,
     /* 648708 */     // GIR_Coverage, 6303,
     /* 648708 */     GIR_EraseRootFromParent_Done,
     /* 648709 */   // Label 8254: @648709
     /* 648709 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(648805), // Rule ID 6307 //
     /* 648714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 648717 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648719 */     // MIs[0] offset
     /* 648719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648722 */     // MIs[0] auxiliary
     /* 648722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648725 */     // MIs[0] Operand 8
     /* 648725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648735 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 648738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 648751 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 648754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 648758 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 648761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN),
     /* 648779 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 648784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648791 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648793 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648803 */     GIR_RootConstrainSelectedInstOperands,
     /* 648804 */     // GIR_Coverage, 6307,
     /* 648804 */     GIR_EraseRootFromParent_Done,
     /* 648805 */   // Label 8255: @648805
     /* 648805 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(648905), // Rule ID 6319 //
     /* 648810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
     /* 648813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 648817 */     // MIs[0] offset
     /* 648817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648820 */     // MIs[0] auxiliary
     /* 648820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648823 */     // MIs[0] Operand 8
     /* 648823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648833 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_BOTHEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 648836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 648849 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 648852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 648856 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 648859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_BOTHEN_RTN),
     /* 648877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648879 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 648884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648891 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648893 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648903 */     GIR_RootConstrainSelectedInstOperands,
     /* 648904 */     // GIR_Coverage, 6319,
     /* 648904 */     GIR_EraseRootFromParent_Done,
     /* 648905 */   // Label 8256: @648905
     /* 648905 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(649005), // Rule ID 6323 //
     /* 648910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 648913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 648917 */     // MIs[0] offset
     /* 648917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 648920 */     // MIs[0] auxiliary
     /* 648920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648923 */     // MIs[0] Operand 8
     /* 648923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648933 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 648936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648945 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 648949 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 648952 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 648956 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 648959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN_RTN),
     /* 648977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 648979 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 648981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 648984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 648986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648991 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 648993 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649003 */     GIR_RootConstrainSelectedInstOperands,
     /* 649004 */     // GIR_Coverage, 6323,
     /* 649004 */     GIR_EraseRootFromParent_Done,
     /* 649005 */   // Label 8257: @649005
     /* 649005 */   GIM_Reject,
     /* 649006 */ // Label 8241: @649006
     /* 649006 */ GIM_Reject,
     /* 649007 */ // Label 8238: @649007
     /* 649007 */ GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(650212),
     /* 649012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 649015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 649018 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 649021 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 649024 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 649027 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(649095), // Rule ID 6336 //
     /* 649032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 649035 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649045 */     // MIs[0] offset
     /* 649045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649048 */     // MIs[0] auxiliary
     /* 649048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649051 */     // MIs[0] Operand 8
     /* 649051 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649069 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFSET),
     /* 649072 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649081 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649083 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649093 */     GIR_RootConstrainSelectedInstOperands,
     /* 649094 */     // GIR_Coverage, 6336,
     /* 649094 */     GIR_EraseRootFromParent_Done,
     /* 649095 */   // Label 8259: @649095
     /* 649095 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(649163), // Rule ID 6344 //
     /* 649100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 649103 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649113 */     // MIs[0] offset
     /* 649113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649116 */     // MIs[0] auxiliary
     /* 649116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649119 */     // MIs[0] Operand 8
     /* 649119 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649137 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET),
     /* 649140 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649149 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649151 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649161 */     GIR_RootConstrainSelectedInstOperands,
     /* 649162 */     // GIR_Coverage, 6344,
     /* 649162 */     GIR_EraseRootFromParent_Done,
     /* 649163 */   // Label 8260: @649163
     /* 649163 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(649235), // Rule ID 6332 //
     /* 649168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 649171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 649175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649183 */     // MIs[0] offset
     /* 649183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649186 */     // MIs[0] auxiliary
     /* 649186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649189 */     // MIs[0] Operand 8
     /* 649189 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649207 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFSET_RTN),
     /* 649210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649212 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649221 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649223 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649233 */     GIR_RootConstrainSelectedInstOperands,
     /* 649234 */     // GIR_Coverage, 6332,
     /* 649234 */     GIR_EraseRootFromParent_Done,
     /* 649235 */   // Label 8261: @649235
     /* 649235 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(649307), // Rule ID 6340 //
     /* 649240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 649243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 649247 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649251 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649255 */     // MIs[0] offset
     /* 649255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649258 */     // MIs[0] auxiliary
     /* 649258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649261 */     // MIs[0] Operand 8
     /* 649261 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649279 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET_RTN),
     /* 649282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649284 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649293 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649295 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649305 */     GIR_RootConstrainSelectedInstOperands,
     /* 649306 */     // GIR_Coverage, 6340,
     /* 649306 */     GIR_EraseRootFromParent_Done,
     /* 649307 */   // Label 8262: @649307
     /* 649307 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(649373), // Rule ID 6338 //
     /* 649312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 649315 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649321 */     // MIs[0] offset
     /* 649321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649324 */     // MIs[0] auxiliary
     /* 649324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649327 */     // MIs[0] Operand 8
     /* 649327 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649345 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_OFFEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFEN),
     /* 649348 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649350 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 649352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649359 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649361 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649371 */     GIR_RootConstrainSelectedInstOperands,
     /* 649372 */     // GIR_Coverage, 6338,
     /* 649372 */     GIR_EraseRootFromParent_Done,
     /* 649373 */   // Label 8263: @649373
     /* 649373 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(649439), // Rule ID 6346 //
     /* 649378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 649381 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649387 */     // MIs[0] offset
     /* 649387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649390 */     // MIs[0] auxiliary
     /* 649390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649393 */     // MIs[0] Operand 8
     /* 649393 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649411 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN),
     /* 649414 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649416 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 649418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649425 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649427 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649437 */     GIR_RootConstrainSelectedInstOperands,
     /* 649438 */     // GIR_Coverage, 6346,
     /* 649438 */     GIR_EraseRootFromParent_Done,
     /* 649439 */   // Label 8264: @649439
     /* 649439 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(649509), // Rule ID 6334 //
     /* 649444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 649447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 649451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649455 */     // MIs[0] offset
     /* 649455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649458 */     // MIs[0] auxiliary
     /* 649458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649461 */     // MIs[0] Operand 8
     /* 649461 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649479 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_OFFEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFEN_RTN),
     /* 649482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649484 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649486 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 649488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649495 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649497 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649507 */     GIR_RootConstrainSelectedInstOperands,
     /* 649508 */     // GIR_Coverage, 6334,
     /* 649508 */     GIR_EraseRootFromParent_Done,
     /* 649509 */   // Label 8265: @649509
     /* 649509 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(649579), // Rule ID 6342 //
     /* 649514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 649517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 649521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649525 */     // MIs[0] offset
     /* 649525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649528 */     // MIs[0] auxiliary
     /* 649528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649531 */     // MIs[0] Operand 8
     /* 649531 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649549 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN_RTN),
     /* 649552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649554 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649556 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 649558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649565 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649567 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649577 */     GIR_RootConstrainSelectedInstOperands,
     /* 649578 */     // GIR_Coverage, 6342,
     /* 649578 */     GIR_EraseRootFromParent_Done,
     /* 649579 */   // Label 8266: @649579
     /* 649579 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(649637), // Rule ID 6337 //
     /* 649584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 649587 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649593 */     // MIs[0] offset
     /* 649593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649596 */     // MIs[0] auxiliary
     /* 649596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649599 */     // MIs[0] Operand 8
     /* 649599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649609 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_IDXEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_IDXEN),
     /* 649612 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649614 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 649616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649623 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649625 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649635 */     GIR_RootConstrainSelectedInstOperands,
     /* 649636 */     // GIR_Coverage, 6337,
     /* 649636 */     GIR_EraseRootFromParent_Done,
     /* 649637 */   // Label 8267: @649637
     /* 649637 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(649695), // Rule ID 6345 //
     /* 649642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 649645 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649651 */     // MIs[0] offset
     /* 649651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649654 */     // MIs[0] auxiliary
     /* 649654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649657 */     // MIs[0] Operand 8
     /* 649657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649667 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN),
     /* 649670 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649672 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 649674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649681 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649683 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649693 */     GIR_RootConstrainSelectedInstOperands,
     /* 649694 */     // GIR_Coverage, 6345,
     /* 649694 */     GIR_EraseRootFromParent_Done,
     /* 649695 */   // Label 8268: @649695
     /* 649695 */   GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(649757), // Rule ID 6333 //
     /* 649700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 649703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 649707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649711 */     // MIs[0] offset
     /* 649711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649714 */     // MIs[0] auxiliary
     /* 649714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649717 */     // MIs[0] Operand 8
     /* 649717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649727 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_IDXEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_IDXEN_RTN),
     /* 649730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649732 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649734 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 649736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649743 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649745 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649755 */     GIR_RootConstrainSelectedInstOperands,
     /* 649756 */     // GIR_Coverage, 6333,
     /* 649756 */     GIR_EraseRootFromParent_Done,
     /* 649757 */   // Label 8269: @649757
     /* 649757 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(649819), // Rule ID 6341 //
     /* 649762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 649765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 649769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649773 */     // MIs[0] offset
     /* 649773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649776 */     // MIs[0] auxiliary
     /* 649776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649779 */     // MIs[0] Operand 8
     /* 649779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649789 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN_RTN),
     /* 649792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649794 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649796 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 649798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649805 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649807 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649817 */     GIR_RootConstrainSelectedInstOperands,
     /* 649818 */     // GIR_Coverage, 6341,
     /* 649818 */     GIR_EraseRootFromParent_Done,
     /* 649819 */   // Label 8270: @649819
     /* 649819 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(649915), // Rule ID 6339 //
     /* 649824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 649827 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649829 */     // MIs[0] offset
     /* 649829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649832 */     // MIs[0] auxiliary
     /* 649832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649835 */     // MIs[0] Operand 8
     /* 649835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649845 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_BOTHEN anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 649848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 649852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 649857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 649861 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 649864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 649868 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 649871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 649876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_BOTHEN),
     /* 649889 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 649894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649901 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649903 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649913 */     GIR_RootConstrainSelectedInstOperands,
     /* 649914 */     // GIR_Coverage, 6339,
     /* 649914 */     GIR_EraseRootFromParent_Done,
     /* 649915 */   // Label 8271: @649915
     /* 649915 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(650011), // Rule ID 6347 //
     /* 649920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 649923 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649925 */     // MIs[0] offset
     /* 649925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649928 */     // MIs[0] auxiliary
     /* 649928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649931 */     // MIs[0] Operand 8
     /* 649931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649941 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 649944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 649948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 649953 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 649957 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 649960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 649964 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 649967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 649972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN),
     /* 649985 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 649990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649997 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649999 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650009 */     GIR_RootConstrainSelectedInstOperands,
     /* 650010 */     // GIR_Coverage, 6347,
     /* 650010 */     GIR_EraseRootFromParent_Done,
     /* 650011 */   // Label 8272: @650011
     /* 650011 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(650111), // Rule ID 6335 //
     /* 650016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 650019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 650023 */     // MIs[0] offset
     /* 650023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650026 */     // MIs[0] auxiliary
     /* 650026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650029 */     // MIs[0] Operand 8
     /* 650029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650039 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 650042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 650046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 650051 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 650055 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 650058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 650062 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 650065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 650070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_BOTHEN_RTN),
     /* 650083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650085 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 650090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650097 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650099 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650109 */     GIR_RootConstrainSelectedInstOperands,
     /* 650110 */     // GIR_Coverage, 6335,
     /* 650110 */     GIR_EraseRootFromParent_Done,
     /* 650111 */   // Label 8273: @650111
     /* 650111 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(650211), // Rule ID 6343 //
     /* 650116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 650119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 650123 */     // MIs[0] offset
     /* 650123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650126 */     // MIs[0] auxiliary
     /* 650126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650129 */     // MIs[0] Operand 8
     /* 650129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650139 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 650142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 650146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 650151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 650155 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 650158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 650162 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 650165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 650170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN_RTN),
     /* 650183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650185 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 650190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650197 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650199 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650209 */     GIR_RootConstrainSelectedInstOperands,
     /* 650210 */     // GIR_Coverage, 6343,
     /* 650210 */     GIR_EraseRootFromParent_Done,
     /* 650211 */   // Label 8274: @650211
     /* 650211 */   GIM_Reject,
     /* 650212 */ // Label 8258: @650212
     /* 650212 */ GIM_Reject,
     /* 650213 */ // Label 8239: @650213
     /* 650213 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(651418),
     /* 650218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 650221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 650224 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 650227 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 650230 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 650233 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(650301), // Rule ID 6308 //
     /* 650238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
     /* 650241 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650247 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650251 */     // MIs[0] offset
     /* 650251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650254 */     // MIs[0] auxiliary
     /* 650254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650257 */     // MIs[0] Operand 8
     /* 650257 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650275 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFSET anonymous_9820:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFSET),
     /* 650278 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650287 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650289 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650299 */     GIR_RootConstrainSelectedInstOperands,
     /* 650300 */     // GIR_Coverage, 6308,
     /* 650300 */     GIR_EraseRootFromParent_Done,
     /* 650301 */   // Label 8276: @650301
     /* 650301 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(650369), // Rule ID 6312 //
     /* 650306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 650309 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650319 */     // MIs[0] offset
     /* 650319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650322 */     // MIs[0] auxiliary
     /* 650322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650325 */     // MIs[0] Operand 8
     /* 650325 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650343 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET anonymous_9820:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET),
     /* 650346 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650355 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650367 */     GIR_RootConstrainSelectedInstOperands,
     /* 650368 */     // GIR_Coverage, 6312,
     /* 650368 */     GIR_EraseRootFromParent_Done,
     /* 650369 */   // Label 8277: @650369
     /* 650369 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(650441), // Rule ID 6324 //
     /* 650374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
     /* 650377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650389 */     // MIs[0] offset
     /* 650389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650392 */     // MIs[0] auxiliary
     /* 650392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650395 */     // MIs[0] Operand 8
     /* 650395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650413 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFSET_RTN:{ *:[v2f16] } anonymous_9820:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFSET_RTN),
     /* 650416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650418 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650427 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650429 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650439 */     GIR_RootConstrainSelectedInstOperands,
     /* 650440 */     // GIR_Coverage, 6324,
     /* 650440 */     GIR_EraseRootFromParent_Done,
     /* 650441 */   // Label 8278: @650441
     /* 650441 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(650513), // Rule ID 6328 //
     /* 650446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 650449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650461 */     // MIs[0] offset
     /* 650461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650464 */     // MIs[0] auxiliary
     /* 650464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650467 */     // MIs[0] Operand 8
     /* 650467 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650485 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET_RTN:{ *:[v2f16] } anonymous_9820:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET_RTN),
     /* 650488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650490 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650499 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650501 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650511 */     GIR_RootConstrainSelectedInstOperands,
     /* 650512 */     // GIR_Coverage, 6328,
     /* 650512 */     GIR_EraseRootFromParent_Done,
     /* 650513 */   // Label 8279: @650513
     /* 650513 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(650579), // Rule ID 6310 //
     /* 650518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
     /* 650521 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650527 */     // MIs[0] offset
     /* 650527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650530 */     // MIs[0] auxiliary
     /* 650530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650533 */     // MIs[0] Operand 8
     /* 650533 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650551 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFEN anonymous_9820:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFEN),
     /* 650554 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650556 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 650558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650565 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650567 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650577 */     GIR_RootConstrainSelectedInstOperands,
     /* 650578 */     // GIR_Coverage, 6310,
     /* 650578 */     GIR_EraseRootFromParent_Done,
     /* 650579 */   // Label 8280: @650579
     /* 650579 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(650645), // Rule ID 6314 //
     /* 650584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 650587 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650593 */     // MIs[0] offset
     /* 650593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650596 */     // MIs[0] auxiliary
     /* 650596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650599 */     // MIs[0] Operand 8
     /* 650599 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650617 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN anonymous_9820:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN),
     /* 650620 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650622 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 650624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650631 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650643 */     GIR_RootConstrainSelectedInstOperands,
     /* 650644 */     // GIR_Coverage, 6314,
     /* 650644 */     GIR_EraseRootFromParent_Done,
     /* 650645 */   // Label 8281: @650645
     /* 650645 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(650715), // Rule ID 6326 //
     /* 650650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
     /* 650653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650661 */     // MIs[0] offset
     /* 650661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650664 */     // MIs[0] auxiliary
     /* 650664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650667 */     // MIs[0] Operand 8
     /* 650667 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650685 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFEN_RTN:{ *:[v2f16] } anonymous_9820:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFEN_RTN),
     /* 650688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650690 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650692 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 650694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650701 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650713 */     GIR_RootConstrainSelectedInstOperands,
     /* 650714 */     // GIR_Coverage, 6326,
     /* 650714 */     GIR_EraseRootFromParent_Done,
     /* 650715 */   // Label 8282: @650715
     /* 650715 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(650785), // Rule ID 6330 //
     /* 650720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 650723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650731 */     // MIs[0] offset
     /* 650731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650734 */     // MIs[0] auxiliary
     /* 650734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650737 */     // MIs[0] Operand 8
     /* 650737 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650755 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN_RTN:{ *:[v2f16] } anonymous_9820:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN_RTN),
     /* 650758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650760 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650762 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 650764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650771 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650773 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650783 */     GIR_RootConstrainSelectedInstOperands,
     /* 650784 */     // GIR_Coverage, 6330,
     /* 650784 */     GIR_EraseRootFromParent_Done,
     /* 650785 */   // Label 8283: @650785
     /* 650785 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(650843), // Rule ID 6309 //
     /* 650790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
     /* 650793 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650799 */     // MIs[0] offset
     /* 650799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650802 */     // MIs[0] auxiliary
     /* 650802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650805 */     // MIs[0] Operand 8
     /* 650805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650815 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_IDXEN anonymous_9820:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_IDXEN),
     /* 650818 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650820 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 650822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650829 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650831 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650841 */     GIR_RootConstrainSelectedInstOperands,
     /* 650842 */     // GIR_Coverage, 6309,
     /* 650842 */     GIR_EraseRootFromParent_Done,
     /* 650843 */   // Label 8284: @650843
     /* 650843 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(650901), // Rule ID 6313 //
     /* 650848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 650851 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650857 */     // MIs[0] offset
     /* 650857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650860 */     // MIs[0] auxiliary
     /* 650860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650863 */     // MIs[0] Operand 8
     /* 650863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650873 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN anonymous_9820:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN),
     /* 650876 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650878 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 650880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650887 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650889 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650899 */     GIR_RootConstrainSelectedInstOperands,
     /* 650900 */     // GIR_Coverage, 6313,
     /* 650900 */     GIR_EraseRootFromParent_Done,
     /* 650901 */   // Label 8285: @650901
     /* 650901 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(650963), // Rule ID 6325 //
     /* 650906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
     /* 650909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650917 */     // MIs[0] offset
     /* 650917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650920 */     // MIs[0] auxiliary
     /* 650920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650923 */     // MIs[0] Operand 8
     /* 650923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650933 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_IDXEN_RTN:{ *:[v2f16] } anonymous_9820:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_IDXEN_RTN),
     /* 650936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650938 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650940 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 650942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650949 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650961 */     GIR_RootConstrainSelectedInstOperands,
     /* 650962 */     // GIR_Coverage, 6325,
     /* 650962 */     GIR_EraseRootFromParent_Done,
     /* 650963 */   // Label 8286: @650963
     /* 650963 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(651025), // Rule ID 6329 //
     /* 650968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 650971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650979 */     // MIs[0] offset
     /* 650979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650982 */     // MIs[0] auxiliary
     /* 650982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650985 */     // MIs[0] Operand 8
     /* 650985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650995 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN_RTN:{ *:[v2f16] } anonymous_9820:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN_RTN),
     /* 650998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651000 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651002 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 651004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651011 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651013 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651023 */     GIR_RootConstrainSelectedInstOperands,
     /* 651024 */     // GIR_Coverage, 6329,
     /* 651024 */     GIR_EraseRootFromParent_Done,
     /* 651025 */   // Label 8287: @651025
     /* 651025 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(651121), // Rule ID 6311 //
     /* 651030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
     /* 651033 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651035 */     // MIs[0] offset
     /* 651035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651038 */     // MIs[0] auxiliary
     /* 651038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651041 */     // MIs[0] Operand 8
     /* 651041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651051 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_BOTHEN anonymous_9820:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 651054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 651058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 651063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 651067 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 651070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 651074 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 651077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 651082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_BOTHEN),
     /* 651095 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 651100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651107 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651109 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651119 */     GIR_RootConstrainSelectedInstOperands,
     /* 651120 */     // GIR_Coverage, 6311,
     /* 651120 */     GIR_EraseRootFromParent_Done,
     /* 651121 */   // Label 8288: @651121
     /* 651121 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(651217), // Rule ID 6315 //
     /* 651126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 651129 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651131 */     // MIs[0] offset
     /* 651131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651134 */     // MIs[0] auxiliary
     /* 651134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651137 */     // MIs[0] Operand 8
     /* 651137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651147 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN anonymous_9820:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 651150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 651154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 651159 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 651163 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 651166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 651170 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 651173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 651178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN),
     /* 651191 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 651196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651203 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651205 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651215 */     GIR_RootConstrainSelectedInstOperands,
     /* 651216 */     // GIR_Coverage, 6315,
     /* 651216 */     GIR_EraseRootFromParent_Done,
     /* 651217 */   // Label 8289: @651217
     /* 651217 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(651317), // Rule ID 6327 //
     /* 651222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
     /* 651225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 651229 */     // MIs[0] offset
     /* 651229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651232 */     // MIs[0] auxiliary
     /* 651232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651235 */     // MIs[0] Operand 8
     /* 651235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651245 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_BOTHEN_RTN:{ *:[v2f16] } anonymous_9820:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 651248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 651252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 651257 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 651261 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 651264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 651268 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 651271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 651276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_BOTHEN_RTN),
     /* 651289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651291 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 651296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651303 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651305 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651315 */     GIR_RootConstrainSelectedInstOperands,
     /* 651316 */     // GIR_Coverage, 6327,
     /* 651316 */     GIR_EraseRootFromParent_Done,
     /* 651317 */   // Label 8290: @651317
     /* 651317 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(651417), // Rule ID 6331 //
     /* 651322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 651325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 651329 */     // MIs[0] offset
     /* 651329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651332 */     // MIs[0] auxiliary
     /* 651332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651335 */     // MIs[0] Operand 8
     /* 651335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651345 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN_RTN:{ *:[v2f16] } anonymous_9820:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 651348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 651352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 651357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 651361 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 651364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 651368 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 651371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 651376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN_RTN),
     /* 651389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651391 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 651396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651403 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651405 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651415 */     GIR_RootConstrainSelectedInstOperands,
     /* 651416 */     // GIR_Coverage, 6331,
     /* 651416 */     GIR_EraseRootFromParent_Done,
     /* 651417 */   // Label 8291: @651417
     /* 651417 */   GIM_Reject,
     /* 651418 */ // Label 8275: @651418
     /* 651418 */ GIM_Reject,
     /* 651419 */ // Label 8240: @651419
     /* 651419 */ GIM_Reject,
     /* 651420 */ // Label 114: @651420
     /* 651420 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8294*/ GIMT_Encode4(655035),
     /* 651431 */ /*GILLT_s32*//*Label 8292*/ GIMT_Encode4(651439),
     /* 651435 */ /*GILLT_s64*//*Label 8293*/ GIMT_Encode4(652645),
     /* 651439 */ // Label 8292: @651439
     /* 651439 */ GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(652644),
     /* 651444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 651447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 651450 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 651453 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 651456 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 651459 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(651527), // Rule ID 6256 //
     /* 651464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 651467 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651477 */     // MIs[0] offset
     /* 651477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651480 */     // MIs[0] auxiliary
     /* 651480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651483 */     // MIs[0] Operand 8
     /* 651483 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651501 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_OFFSET anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET),
     /* 651504 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651513 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651515 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651525 */     GIR_RootConstrainSelectedInstOperands,
     /* 651526 */     // GIR_Coverage, 6256,
     /* 651526 */     GIR_EraseRootFromParent_Done,
     /* 651527 */   // Label 8296: @651527
     /* 651527 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(651595), // Rule ID 6264 //
     /* 651532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 651535 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651545 */     // MIs[0] offset
     /* 651545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651548 */     // MIs[0] auxiliary
     /* 651548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651551 */     // MIs[0] Operand 8
     /* 651551 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651569 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET),
     /* 651572 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651581 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651583 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651593 */     GIR_RootConstrainSelectedInstOperands,
     /* 651594 */     // GIR_Coverage, 6264,
     /* 651594 */     GIR_EraseRootFromParent_Done,
     /* 651595 */   // Label 8297: @651595
     /* 651595 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(651667), // Rule ID 6252 //
     /* 651600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 651603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 651607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651615 */     // MIs[0] offset
     /* 651615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651618 */     // MIs[0] auxiliary
     /* 651618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651621 */     // MIs[0] Operand 8
     /* 651621 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651639 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_OFFSET_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET_RTN),
     /* 651642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651644 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651653 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651655 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651665 */     GIR_RootConstrainSelectedInstOperands,
     /* 651666 */     // GIR_Coverage, 6252,
     /* 651666 */     GIR_EraseRootFromParent_Done,
     /* 651667 */   // Label 8298: @651667
     /* 651667 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(651739), // Rule ID 6260 //
     /* 651672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 651675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 651679 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651687 */     // MIs[0] offset
     /* 651687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651690 */     // MIs[0] auxiliary
     /* 651690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651693 */     // MIs[0] Operand 8
     /* 651693 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651711 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN),
     /* 651714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651716 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651725 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651727 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651737 */     GIR_RootConstrainSelectedInstOperands,
     /* 651738 */     // GIR_Coverage, 6260,
     /* 651738 */     GIR_EraseRootFromParent_Done,
     /* 651739 */   // Label 8299: @651739
     /* 651739 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(651805), // Rule ID 6258 //
     /* 651744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 651747 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651749 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651753 */     // MIs[0] offset
     /* 651753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651756 */     // MIs[0] auxiliary
     /* 651756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651759 */     // MIs[0] Operand 8
     /* 651759 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651777 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_OFFEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFEN),
     /* 651780 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651782 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 651784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651791 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651793 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651803 */     GIR_RootConstrainSelectedInstOperands,
     /* 651804 */     // GIR_Coverage, 6258,
     /* 651804 */     GIR_EraseRootFromParent_Done,
     /* 651805 */   // Label 8300: @651805
     /* 651805 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(651871), // Rule ID 6266 //
     /* 651810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 651813 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651819 */     // MIs[0] offset
     /* 651819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651822 */     // MIs[0] auxiliary
     /* 651822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651825 */     // MIs[0] Operand 8
     /* 651825 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651843 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN),
     /* 651846 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651848 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 651850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651857 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651859 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651869 */     GIR_RootConstrainSelectedInstOperands,
     /* 651870 */     // GIR_Coverage, 6266,
     /* 651870 */     GIR_EraseRootFromParent_Done,
     /* 651871 */   // Label 8301: @651871
     /* 651871 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(651941), // Rule ID 6254 //
     /* 651876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 651879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 651883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651887 */     // MIs[0] offset
     /* 651887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651890 */     // MIs[0] auxiliary
     /* 651890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651893 */     // MIs[0] Operand 8
     /* 651893 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651911 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_OFFEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFEN_RTN),
     /* 651914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651916 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651918 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 651920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651927 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651929 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651939 */     GIR_RootConstrainSelectedInstOperands,
     /* 651940 */     // GIR_Coverage, 6254,
     /* 651940 */     GIR_EraseRootFromParent_Done,
     /* 651941 */   // Label 8302: @651941
     /* 651941 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(652011), // Rule ID 6262 //
     /* 651946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 651949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 651953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651957 */     // MIs[0] offset
     /* 651957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651960 */     // MIs[0] auxiliary
     /* 651960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651963 */     // MIs[0] Operand 8
     /* 651963 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651981 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN_RTN),
     /* 651984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651986 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651988 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 651990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651997 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651999 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652009 */     GIR_RootConstrainSelectedInstOperands,
     /* 652010 */     // GIR_Coverage, 6262,
     /* 652010 */     GIR_EraseRootFromParent_Done,
     /* 652011 */   // Label 8303: @652011
     /* 652011 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(652069), // Rule ID 6257 //
     /* 652016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 652019 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652025 */     // MIs[0] offset
     /* 652025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652028 */     // MIs[0] auxiliary
     /* 652028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652031 */     // MIs[0] Operand 8
     /* 652031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652041 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_IDXEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_IDXEN),
     /* 652044 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652046 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 652048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652055 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652057 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652067 */     GIR_RootConstrainSelectedInstOperands,
     /* 652068 */     // GIR_Coverage, 6257,
     /* 652068 */     GIR_EraseRootFromParent_Done,
     /* 652069 */   // Label 8304: @652069
     /* 652069 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(652127), // Rule ID 6265 //
     /* 652074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 652077 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652083 */     // MIs[0] offset
     /* 652083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652086 */     // MIs[0] auxiliary
     /* 652086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652089 */     // MIs[0] Operand 8
     /* 652089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652099 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN),
     /* 652102 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652104 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 652106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652113 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652125 */     GIR_RootConstrainSelectedInstOperands,
     /* 652126 */     // GIR_Coverage, 6265,
     /* 652126 */     GIR_EraseRootFromParent_Done,
     /* 652127 */   // Label 8305: @652127
     /* 652127 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(652189), // Rule ID 6253 //
     /* 652132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 652135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652139 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652143 */     // MIs[0] offset
     /* 652143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652146 */     // MIs[0] auxiliary
     /* 652146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652149 */     // MIs[0] Operand 8
     /* 652149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652159 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_IDXEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_IDXEN_RTN),
     /* 652162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652164 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652166 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 652168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652175 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652177 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652187 */     GIR_RootConstrainSelectedInstOperands,
     /* 652188 */     // GIR_Coverage, 6253,
     /* 652188 */     GIR_EraseRootFromParent_Done,
     /* 652189 */   // Label 8306: @652189
     /* 652189 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(652251), // Rule ID 6261 //
     /* 652194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 652197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652201 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652205 */     // MIs[0] offset
     /* 652205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652208 */     // MIs[0] auxiliary
     /* 652208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652211 */     // MIs[0] Operand 8
     /* 652211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652221 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN_RTN),
     /* 652224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652226 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652228 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 652230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652237 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652239 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652249 */     GIR_RootConstrainSelectedInstOperands,
     /* 652250 */     // GIR_Coverage, 6261,
     /* 652250 */     GIR_EraseRootFromParent_Done,
     /* 652251 */   // Label 8307: @652251
     /* 652251 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(652347), // Rule ID 6259 //
     /* 652256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 652259 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652261 */     // MIs[0] offset
     /* 652261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652264 */     // MIs[0] auxiliary
     /* 652264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652267 */     // MIs[0] Operand 8
     /* 652267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652277 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_BOTHEN anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 652280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 652284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 652289 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 652293 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 652296 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 652300 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 652303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 652308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_BOTHEN),
     /* 652321 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 652326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652333 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652335 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652345 */     GIR_RootConstrainSelectedInstOperands,
     /* 652346 */     // GIR_Coverage, 6259,
     /* 652346 */     GIR_EraseRootFromParent_Done,
     /* 652347 */   // Label 8308: @652347
     /* 652347 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(652443), // Rule ID 6267 //
     /* 652352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 652355 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652357 */     // MIs[0] offset
     /* 652357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652360 */     // MIs[0] auxiliary
     /* 652360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652363 */     // MIs[0] Operand 8
     /* 652363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652373 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 652376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 652380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 652385 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 652389 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 652392 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 652396 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 652399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 652404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN),
     /* 652417 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 652422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652429 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652431 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652441 */     GIR_RootConstrainSelectedInstOperands,
     /* 652442 */     // GIR_Coverage, 6267,
     /* 652442 */     GIR_EraseRootFromParent_Done,
     /* 652443 */   // Label 8309: @652443
     /* 652443 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(652543), // Rule ID 6255 //
     /* 652448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 652451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652455 */     // MIs[0] offset
     /* 652455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652458 */     // MIs[0] auxiliary
     /* 652458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652461 */     // MIs[0] Operand 8
     /* 652461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652471 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_BOTHEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 652474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 652478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 652483 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 652487 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 652490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 652494 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 652497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 652502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_BOTHEN_RTN),
     /* 652515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652517 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 652522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652529 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652531 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652541 */     GIR_RootConstrainSelectedInstOperands,
     /* 652542 */     // GIR_Coverage, 6255,
     /* 652542 */     GIR_EraseRootFromParent_Done,
     /* 652543 */   // Label 8310: @652543
     /* 652543 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(652643), // Rule ID 6263 //
     /* 652548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 652551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652555 */     // MIs[0] offset
     /* 652555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652558 */     // MIs[0] auxiliary
     /* 652558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652561 */     // MIs[0] Operand 8
     /* 652561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652571 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 652574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 652578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 652583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 652587 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 652590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 652594 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 652597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 652602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN_RTN),
     /* 652615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652617 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 652622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652629 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652631 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652641 */     GIR_RootConstrainSelectedInstOperands,
     /* 652642 */     // GIR_Coverage, 6263,
     /* 652642 */     GIR_EraseRootFromParent_Done,
     /* 652643 */   // Label 8311: @652643
     /* 652643 */   GIM_Reject,
     /* 652644 */ // Label 8295: @652644
     /* 652644 */ GIM_Reject,
     /* 652645 */ // Label 8293: @652645
     /* 652645 */ GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(655034),
     /* 652650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 652653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 652656 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 652659 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 652662 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 652665 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(652733), // Rule ID 6288 //
     /* 652670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 652673 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652679 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652683 */     // MIs[0] offset
     /* 652683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652686 */     // MIs[0] auxiliary
     /* 652686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652689 */     // MIs[0] Operand 8
     /* 652689 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652707 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET),
     /* 652710 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652719 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652721 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652731 */     GIR_RootConstrainSelectedInstOperands,
     /* 652732 */     // GIR_Coverage, 6288,
     /* 652732 */     GIR_EraseRootFromParent_Done,
     /* 652733 */   // Label 8313: @652733
     /* 652733 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(652801), // Rule ID 6296 //
     /* 652738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 652741 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652751 */     // MIs[0] offset
     /* 652751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652754 */     // MIs[0] auxiliary
     /* 652754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652757 */     // MIs[0] Operand 8
     /* 652757 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652775 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET),
     /* 652778 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652787 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652789 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652799 */     GIR_RootConstrainSelectedInstOperands,
     /* 652800 */     // GIR_Coverage, 6296,
     /* 652800 */     GIR_EraseRootFromParent_Done,
     /* 652801 */   // Label 8314: @652801
     /* 652801 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(652869), // Rule ID 6368 //
     /* 652806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 652809 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652819 */     // MIs[0] offset
     /* 652819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652822 */     // MIs[0] auxiliary
     /* 652822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652825 */     // MIs[0] Operand 8
     /* 652825 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652843 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET),
     /* 652846 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652855 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652867 */     GIR_RootConstrainSelectedInstOperands,
     /* 652868 */     // GIR_Coverage, 6368,
     /* 652868 */     GIR_EraseRootFromParent_Done,
     /* 652869 */   // Label 8315: @652869
     /* 652869 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(652937), // Rule ID 6376 //
     /* 652874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 652877 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652887 */     // MIs[0] offset
     /* 652887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652890 */     // MIs[0] auxiliary
     /* 652890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652893 */     // MIs[0] Operand 8
     /* 652893 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652911 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET),
     /* 652914 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652923 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652935 */     GIR_RootConstrainSelectedInstOperands,
     /* 652936 */     // GIR_Coverage, 6376,
     /* 652936 */     GIR_EraseRootFromParent_Done,
     /* 652937 */   // Label 8316: @652937
     /* 652937 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(653009), // Rule ID 6284 //
     /* 652942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 652945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 652949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652957 */     // MIs[0] offset
     /* 652957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652960 */     // MIs[0] auxiliary
     /* 652960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652963 */     // MIs[0] Operand 8
     /* 652963 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652981 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET_RTN),
     /* 652984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652986 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652995 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652997 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653007 */     GIR_RootConstrainSelectedInstOperands,
     /* 653008 */     // GIR_Coverage, 6284,
     /* 653008 */     GIR_EraseRootFromParent_Done,
     /* 653009 */   // Label 8317: @653009
     /* 653009 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(653081), // Rule ID 6292 //
     /* 653014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653029 */     // MIs[0] offset
     /* 653029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653032 */     // MIs[0] auxiliary
     /* 653032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653035 */     // MIs[0] Operand 8
     /* 653035 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653053 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN),
     /* 653056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653058 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653067 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653069 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653079 */     GIR_RootConstrainSelectedInstOperands,
     /* 653080 */     // GIR_Coverage, 6292,
     /* 653080 */     GIR_EraseRootFromParent_Done,
     /* 653081 */   // Label 8318: @653081
     /* 653081 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(653153), // Rule ID 6364 //
     /* 653086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653101 */     // MIs[0] offset
     /* 653101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653104 */     // MIs[0] auxiliary
     /* 653104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653107 */     // MIs[0] Operand 8
     /* 653107 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653125 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET_RTN),
     /* 653128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653130 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653139 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653151 */     GIR_RootConstrainSelectedInstOperands,
     /* 653152 */     // GIR_Coverage, 6364,
     /* 653152 */     GIR_EraseRootFromParent_Done,
     /* 653153 */   // Label 8319: @653153
     /* 653153 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(653225), // Rule ID 6372 //
     /* 653158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653173 */     // MIs[0] offset
     /* 653173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653176 */     // MIs[0] auxiliary
     /* 653176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653179 */     // MIs[0] Operand 8
     /* 653179 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653197 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN),
     /* 653200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653202 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653211 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653213 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653223 */     GIR_RootConstrainSelectedInstOperands,
     /* 653224 */     // GIR_Coverage, 6372,
     /* 653224 */     GIR_EraseRootFromParent_Done,
     /* 653225 */   // Label 8320: @653225
     /* 653225 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(653291), // Rule ID 6290 //
     /* 653230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653233 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653239 */     // MIs[0] offset
     /* 653239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653242 */     // MIs[0] auxiliary
     /* 653242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653245 */     // MIs[0] Operand 8
     /* 653245 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653263 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN),
     /* 653266 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653268 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653277 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653279 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653289 */     GIR_RootConstrainSelectedInstOperands,
     /* 653290 */     // GIR_Coverage, 6290,
     /* 653290 */     GIR_EraseRootFromParent_Done,
     /* 653291 */   // Label 8321: @653291
     /* 653291 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(653357), // Rule ID 6298 //
     /* 653296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653299 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653305 */     // MIs[0] offset
     /* 653305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653308 */     // MIs[0] auxiliary
     /* 653308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653311 */     // MIs[0] Operand 8
     /* 653311 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653329 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN),
     /* 653332 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653334 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653343 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653345 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653355 */     GIR_RootConstrainSelectedInstOperands,
     /* 653356 */     // GIR_Coverage, 6298,
     /* 653356 */     GIR_EraseRootFromParent_Done,
     /* 653357 */   // Label 8322: @653357
     /* 653357 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(653423), // Rule ID 6370 //
     /* 653362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653365 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653371 */     // MIs[0] offset
     /* 653371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653374 */     // MIs[0] auxiliary
     /* 653374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653377 */     // MIs[0] Operand 8
     /* 653377 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653395 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN),
     /* 653398 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653400 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653409 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653411 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653421 */     GIR_RootConstrainSelectedInstOperands,
     /* 653422 */     // GIR_Coverage, 6370,
     /* 653422 */     GIR_EraseRootFromParent_Done,
     /* 653423 */   // Label 8323: @653423
     /* 653423 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(653489), // Rule ID 6378 //
     /* 653428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653431 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653437 */     // MIs[0] offset
     /* 653437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653440 */     // MIs[0] auxiliary
     /* 653440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653443 */     // MIs[0] Operand 8
     /* 653443 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653461 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN),
     /* 653464 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653466 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653475 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653477 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653487 */     GIR_RootConstrainSelectedInstOperands,
     /* 653488 */     // GIR_Coverage, 6378,
     /* 653488 */     GIR_EraseRootFromParent_Done,
     /* 653489 */   // Label 8324: @653489
     /* 653489 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(653559), // Rule ID 6286 //
     /* 653494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653505 */     // MIs[0] offset
     /* 653505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653508 */     // MIs[0] auxiliary
     /* 653508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653511 */     // MIs[0] Operand 8
     /* 653511 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653529 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN_RTN),
     /* 653532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653534 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653536 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653545 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653547 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653557 */     GIR_RootConstrainSelectedInstOperands,
     /* 653558 */     // GIR_Coverage, 6286,
     /* 653558 */     GIR_EraseRootFromParent_Done,
     /* 653559 */   // Label 8325: @653559
     /* 653559 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(653629), // Rule ID 6294 //
     /* 653564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653575 */     // MIs[0] offset
     /* 653575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653578 */     // MIs[0] auxiliary
     /* 653578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653581 */     // MIs[0] Operand 8
     /* 653581 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653599 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN),
     /* 653602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653604 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653606 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653615 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653617 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653627 */     GIR_RootConstrainSelectedInstOperands,
     /* 653628 */     // GIR_Coverage, 6294,
     /* 653628 */     GIR_EraseRootFromParent_Done,
     /* 653629 */   // Label 8326: @653629
     /* 653629 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(653699), // Rule ID 6366 //
     /* 653634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653645 */     // MIs[0] offset
     /* 653645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653648 */     // MIs[0] auxiliary
     /* 653648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653651 */     // MIs[0] Operand 8
     /* 653651 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653669 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN_RTN),
     /* 653672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653674 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653676 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653685 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653687 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653697 */     GIR_RootConstrainSelectedInstOperands,
     /* 653698 */     // GIR_Coverage, 6366,
     /* 653698 */     GIR_EraseRootFromParent_Done,
     /* 653699 */   // Label 8327: @653699
     /* 653699 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(653769), // Rule ID 6374 //
     /* 653704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653715 */     // MIs[0] offset
     /* 653715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653718 */     // MIs[0] auxiliary
     /* 653718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653721 */     // MIs[0] Operand 8
     /* 653721 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653739 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN),
     /* 653742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653744 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653746 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653755 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653757 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653767 */     GIR_RootConstrainSelectedInstOperands,
     /* 653768 */     // GIR_Coverage, 6374,
     /* 653768 */     GIR_EraseRootFromParent_Done,
     /* 653769 */   // Label 8328: @653769
     /* 653769 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(653827), // Rule ID 6289 //
     /* 653774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653777 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653783 */     // MIs[0] offset
     /* 653783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653786 */     // MIs[0] auxiliary
     /* 653786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653789 */     // MIs[0] Operand 8
     /* 653789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 653792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653799 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN),
     /* 653802 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653804 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 653806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653813 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653815 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653825 */     GIR_RootConstrainSelectedInstOperands,
     /* 653826 */     // GIR_Coverage, 6289,
     /* 653826 */     GIR_EraseRootFromParent_Done,
     /* 653827 */   // Label 8329: @653827
     /* 653827 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(653885), // Rule ID 6297 //
     /* 653832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653835 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653841 */     // MIs[0] offset
     /* 653841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653844 */     // MIs[0] auxiliary
     /* 653844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653847 */     // MIs[0] Operand 8
     /* 653847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 653850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653857 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN),
     /* 653860 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653862 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 653864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653871 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653883 */     GIR_RootConstrainSelectedInstOperands,
     /* 653884 */     // GIR_Coverage, 6297,
     /* 653884 */     GIR_EraseRootFromParent_Done,
     /* 653885 */   // Label 8330: @653885
     /* 653885 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(653943), // Rule ID 6369 //
     /* 653890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 653893 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653899 */     // MIs[0] offset
     /* 653899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653902 */     // MIs[0] auxiliary
     /* 653902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653905 */     // MIs[0] Operand 8
     /* 653905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 653908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653915 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN),
     /* 653918 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653920 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 653922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653929 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653931 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653941 */     GIR_RootConstrainSelectedInstOperands,
     /* 653942 */     // GIR_Coverage, 6369,
     /* 653942 */     GIR_EraseRootFromParent_Done,
     /* 653943 */   // Label 8331: @653943
     /* 653943 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(654001), // Rule ID 6377 //
     /* 653948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 653951 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653957 */     // MIs[0] offset
     /* 653957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653960 */     // MIs[0] auxiliary
     /* 653960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653963 */     // MIs[0] Operand 8
     /* 653963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 653966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653973 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN),
     /* 653976 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653978 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 653980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653987 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653989 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653999 */     GIR_RootConstrainSelectedInstOperands,
     /* 654000 */     // GIR_Coverage, 6377,
     /* 654000 */     GIR_EraseRootFromParent_Done,
     /* 654001 */   // Label 8332: @654001
     /* 654001 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(654063), // Rule ID 6285 //
     /* 654006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 654009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654017 */     // MIs[0] offset
     /* 654017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654020 */     // MIs[0] auxiliary
     /* 654020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654023 */     // MIs[0] Operand 8
     /* 654023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654033 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN_RTN),
     /* 654036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654038 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654040 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654049 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654051 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654061 */     GIR_RootConstrainSelectedInstOperands,
     /* 654062 */     // GIR_Coverage, 6285,
     /* 654062 */     GIR_EraseRootFromParent_Done,
     /* 654063 */   // Label 8333: @654063
     /* 654063 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(654125), // Rule ID 6293 //
     /* 654068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 654071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654079 */     // MIs[0] offset
     /* 654079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654082 */     // MIs[0] auxiliary
     /* 654082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654085 */     // MIs[0] Operand 8
     /* 654085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654095 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN),
     /* 654098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654100 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654102 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654111 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654113 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654123 */     GIR_RootConstrainSelectedInstOperands,
     /* 654124 */     // GIR_Coverage, 6293,
     /* 654124 */     GIR_EraseRootFromParent_Done,
     /* 654125 */   // Label 8334: @654125
     /* 654125 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(654187), // Rule ID 6365 //
     /* 654130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 654133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654141 */     // MIs[0] offset
     /* 654141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654144 */     // MIs[0] auxiliary
     /* 654144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654147 */     // MIs[0] Operand 8
     /* 654147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654157 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN_RTN),
     /* 654160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654162 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654164 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654173 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654175 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654185 */     GIR_RootConstrainSelectedInstOperands,
     /* 654186 */     // GIR_Coverage, 6365,
     /* 654186 */     GIR_EraseRootFromParent_Done,
     /* 654187 */   // Label 8335: @654187
     /* 654187 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(654249), // Rule ID 6373 //
     /* 654192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 654195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654203 */     // MIs[0] offset
     /* 654203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654206 */     // MIs[0] auxiliary
     /* 654206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654209 */     // MIs[0] Operand 8
     /* 654209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654219 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN),
     /* 654222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654224 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654226 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654235 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654237 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654247 */     GIR_RootConstrainSelectedInstOperands,
     /* 654248 */     // GIR_Coverage, 6373,
     /* 654248 */     GIR_EraseRootFromParent_Done,
     /* 654249 */   // Label 8336: @654249
     /* 654249 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(654345), // Rule ID 6291 //
     /* 654254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 654257 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654259 */     // MIs[0] offset
     /* 654259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654262 */     // MIs[0] auxiliary
     /* 654262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654265 */     // MIs[0] Operand 8
     /* 654265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654275 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654291 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654298 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN),
     /* 654319 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654331 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654333 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654343 */     GIR_RootConstrainSelectedInstOperands,
     /* 654344 */     // GIR_Coverage, 6291,
     /* 654344 */     GIR_EraseRootFromParent_Done,
     /* 654345 */   // Label 8337: @654345
     /* 654345 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(654441), // Rule ID 6299 //
     /* 654350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 654353 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654355 */     // MIs[0] offset
     /* 654355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654358 */     // MIs[0] auxiliary
     /* 654358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654361 */     // MIs[0] Operand 8
     /* 654361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654371 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654383 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654387 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654394 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN),
     /* 654415 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654427 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654429 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654439 */     GIR_RootConstrainSelectedInstOperands,
     /* 654440 */     // GIR_Coverage, 6299,
     /* 654440 */     GIR_EraseRootFromParent_Done,
     /* 654441 */   // Label 8338: @654441
     /* 654441 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(654537), // Rule ID 6371 //
     /* 654446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 654449 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654451 */     // MIs[0] offset
     /* 654451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654454 */     // MIs[0] auxiliary
     /* 654454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654457 */     // MIs[0] Operand 8
     /* 654457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654467 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654479 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654483 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654490 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN),
     /* 654511 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654523 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654525 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654535 */     GIR_RootConstrainSelectedInstOperands,
     /* 654536 */     // GIR_Coverage, 6371,
     /* 654536 */     GIR_EraseRootFromParent_Done,
     /* 654537 */   // Label 8339: @654537
     /* 654537 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(654633), // Rule ID 6379 //
     /* 654542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 654545 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654547 */     // MIs[0] offset
     /* 654547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654550 */     // MIs[0] auxiliary
     /* 654550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654553 */     // MIs[0] Operand 8
     /* 654553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654563 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654575 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654579 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654586 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN),
     /* 654607 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654619 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654621 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654631 */     GIR_RootConstrainSelectedInstOperands,
     /* 654632 */     // GIR_Coverage, 6379,
     /* 654632 */     GIR_EraseRootFromParent_Done,
     /* 654633 */   // Label 8340: @654633
     /* 654633 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(654733), // Rule ID 6287 //
     /* 654638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 654641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654645 */     // MIs[0] offset
     /* 654645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654648 */     // MIs[0] auxiliary
     /* 654648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654651 */     // MIs[0] Operand 8
     /* 654651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654661 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654677 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654684 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN),
     /* 654705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654707 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654719 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654721 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654731 */     GIR_RootConstrainSelectedInstOperands,
     /* 654732 */     // GIR_Coverage, 6287,
     /* 654732 */     GIR_EraseRootFromParent_Done,
     /* 654733 */   // Label 8341: @654733
     /* 654733 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(654833), // Rule ID 6295 //
     /* 654738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 654741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654745 */     // MIs[0] offset
     /* 654745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654748 */     // MIs[0] auxiliary
     /* 654748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654751 */     // MIs[0] Operand 8
     /* 654751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654761 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654773 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654777 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654780 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654784 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN),
     /* 654805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654807 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654819 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654831 */     GIR_RootConstrainSelectedInstOperands,
     /* 654832 */     // GIR_Coverage, 6295,
     /* 654832 */     GIR_EraseRootFromParent_Done,
     /* 654833 */   // Label 8342: @654833
     /* 654833 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(654933), // Rule ID 6367 //
     /* 654838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 654841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654845 */     // MIs[0] offset
     /* 654845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654848 */     // MIs[0] auxiliary
     /* 654848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654851 */     // MIs[0] Operand 8
     /* 654851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654861 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654873 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654877 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654884 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN),
     /* 654905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654907 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654919 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654921 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654931 */     GIR_RootConstrainSelectedInstOperands,
     /* 654932 */     // GIR_Coverage, 6367,
     /* 654932 */     GIR_EraseRootFromParent_Done,
     /* 654933 */   // Label 8343: @654933
     /* 654933 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(655033), // Rule ID 6375 //
     /* 654938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 654941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654945 */     // MIs[0] offset
     /* 654945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654948 */     // MIs[0] auxiliary
     /* 654948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654951 */     // MIs[0] Operand 8
     /* 654951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654961 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654977 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654984 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN),
     /* 655005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655007 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 655012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655019 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655021 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655031 */     GIR_RootConstrainSelectedInstOperands,
     /* 655032 */     // GIR_Coverage, 6375,
     /* 655032 */     GIR_EraseRootFromParent_Done,
     /* 655033 */   // Label 8344: @655033
     /* 655033 */   GIM_Reject,
     /* 655034 */ // Label 8312: @655034
     /* 655034 */ GIM_Reject,
     /* 655035 */ // Label 8294: @655035
     /* 655035 */ GIM_Reject,
     /* 655036 */ // Label 115: @655036
     /* 655036 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8347*/ GIMT_Encode4(658651),
     /* 655047 */ /*GILLT_s32*//*Label 8345*/ GIMT_Encode4(655055),
     /* 655051 */ /*GILLT_s64*//*Label 8346*/ GIMT_Encode4(656261),
     /* 655055 */ // Label 8345: @655055
     /* 655055 */ GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(656260),
     /* 655060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 655063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 655066 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 655069 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 655072 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 655075 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(655143), // Rule ID 6240 //
     /* 655080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 655083 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655093 */     // MIs[0] offset
     /* 655093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655096 */     // MIs[0] auxiliary
     /* 655096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655099 */     // MIs[0] Operand 8
     /* 655099 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655117 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_OFFSET anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET),
     /* 655120 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655129 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655131 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655141 */     GIR_RootConstrainSelectedInstOperands,
     /* 655142 */     // GIR_Coverage, 6240,
     /* 655142 */     GIR_EraseRootFromParent_Done,
     /* 655143 */   // Label 8349: @655143
     /* 655143 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(655211), // Rule ID 6248 //
     /* 655148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 655151 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655161 */     // MIs[0] offset
     /* 655161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655164 */     // MIs[0] auxiliary
     /* 655164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655167 */     // MIs[0] Operand 8
     /* 655167 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655185 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET),
     /* 655188 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655197 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655199 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655209 */     GIR_RootConstrainSelectedInstOperands,
     /* 655210 */     // GIR_Coverage, 6248,
     /* 655210 */     GIR_EraseRootFromParent_Done,
     /* 655211 */   // Label 8350: @655211
     /* 655211 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(655283), // Rule ID 6236 //
     /* 655216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 655219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655231 */     // MIs[0] offset
     /* 655231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655234 */     // MIs[0] auxiliary
     /* 655234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655237 */     // MIs[0] Operand 8
     /* 655237 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655255 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_OFFSET_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET_RTN),
     /* 655258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655260 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655269 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655281 */     GIR_RootConstrainSelectedInstOperands,
     /* 655282 */     // GIR_Coverage, 6236,
     /* 655282 */     GIR_EraseRootFromParent_Done,
     /* 655283 */   // Label 8351: @655283
     /* 655283 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(655355), // Rule ID 6244 //
     /* 655288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 655291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655303 */     // MIs[0] offset
     /* 655303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655306 */     // MIs[0] auxiliary
     /* 655306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655309 */     // MIs[0] Operand 8
     /* 655309 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655327 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN),
     /* 655330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655332 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655341 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655343 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655353 */     GIR_RootConstrainSelectedInstOperands,
     /* 655354 */     // GIR_Coverage, 6244,
     /* 655354 */     GIR_EraseRootFromParent_Done,
     /* 655355 */   // Label 8352: @655355
     /* 655355 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(655421), // Rule ID 6242 //
     /* 655360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 655363 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655369 */     // MIs[0] offset
     /* 655369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655372 */     // MIs[0] auxiliary
     /* 655372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655375 */     // MIs[0] Operand 8
     /* 655375 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655393 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_OFFEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFEN),
     /* 655396 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655398 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 655400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655407 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655409 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655419 */     GIR_RootConstrainSelectedInstOperands,
     /* 655420 */     // GIR_Coverage, 6242,
     /* 655420 */     GIR_EraseRootFromParent_Done,
     /* 655421 */   // Label 8353: @655421
     /* 655421 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(655487), // Rule ID 6250 //
     /* 655426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 655429 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655435 */     // MIs[0] offset
     /* 655435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655438 */     // MIs[0] auxiliary
     /* 655438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655441 */     // MIs[0] Operand 8
     /* 655441 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655459 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN),
     /* 655462 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655464 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 655466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655473 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655475 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655485 */     GIR_RootConstrainSelectedInstOperands,
     /* 655486 */     // GIR_Coverage, 6250,
     /* 655486 */     GIR_EraseRootFromParent_Done,
     /* 655487 */   // Label 8354: @655487
     /* 655487 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(655557), // Rule ID 6238 //
     /* 655492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 655495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655503 */     // MIs[0] offset
     /* 655503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655506 */     // MIs[0] auxiliary
     /* 655506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655509 */     // MIs[0] Operand 8
     /* 655509 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655527 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_OFFEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFEN_RTN),
     /* 655530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655532 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655534 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 655536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655543 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655545 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655555 */     GIR_RootConstrainSelectedInstOperands,
     /* 655556 */     // GIR_Coverage, 6238,
     /* 655556 */     GIR_EraseRootFromParent_Done,
     /* 655557 */   // Label 8355: @655557
     /* 655557 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(655627), // Rule ID 6246 //
     /* 655562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 655565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655573 */     // MIs[0] offset
     /* 655573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655576 */     // MIs[0] auxiliary
     /* 655576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655579 */     // MIs[0] Operand 8
     /* 655579 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655597 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN_RTN),
     /* 655600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655602 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655604 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 655606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655613 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655615 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655625 */     GIR_RootConstrainSelectedInstOperands,
     /* 655626 */     // GIR_Coverage, 6246,
     /* 655626 */     GIR_EraseRootFromParent_Done,
     /* 655627 */   // Label 8356: @655627
     /* 655627 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(655685), // Rule ID 6241 //
     /* 655632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 655635 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655641 */     // MIs[0] offset
     /* 655641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655644 */     // MIs[0] auxiliary
     /* 655644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655647 */     // MIs[0] Operand 8
     /* 655647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655657 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_IDXEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_IDXEN),
     /* 655660 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655662 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 655664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655671 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655673 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655683 */     GIR_RootConstrainSelectedInstOperands,
     /* 655684 */     // GIR_Coverage, 6241,
     /* 655684 */     GIR_EraseRootFromParent_Done,
     /* 655685 */   // Label 8357: @655685
     /* 655685 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(655743), // Rule ID 6249 //
     /* 655690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 655693 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655699 */     // MIs[0] offset
     /* 655699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655702 */     // MIs[0] auxiliary
     /* 655702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655705 */     // MIs[0] Operand 8
     /* 655705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655715 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN),
     /* 655718 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655720 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 655722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655729 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655731 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655741 */     GIR_RootConstrainSelectedInstOperands,
     /* 655742 */     // GIR_Coverage, 6249,
     /* 655742 */     GIR_EraseRootFromParent_Done,
     /* 655743 */   // Label 8358: @655743
     /* 655743 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(655805), // Rule ID 6237 //
     /* 655748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 655751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655759 */     // MIs[0] offset
     /* 655759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655762 */     // MIs[0] auxiliary
     /* 655762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655765 */     // MIs[0] Operand 8
     /* 655765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655775 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_IDXEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_IDXEN_RTN),
     /* 655778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655780 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655782 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 655784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655791 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655793 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655803 */     GIR_RootConstrainSelectedInstOperands,
     /* 655804 */     // GIR_Coverage, 6237,
     /* 655804 */     GIR_EraseRootFromParent_Done,
     /* 655805 */   // Label 8359: @655805
     /* 655805 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(655867), // Rule ID 6245 //
     /* 655810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 655813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655817 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655821 */     // MIs[0] offset
     /* 655821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655824 */     // MIs[0] auxiliary
     /* 655824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655827 */     // MIs[0] Operand 8
     /* 655827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655837 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN_RTN),
     /* 655840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655842 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655844 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 655846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655853 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655855 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655865 */     GIR_RootConstrainSelectedInstOperands,
     /* 655866 */     // GIR_Coverage, 6245,
     /* 655866 */     GIR_EraseRootFromParent_Done,
     /* 655867 */   // Label 8360: @655867
     /* 655867 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(655963), // Rule ID 6243 //
     /* 655872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 655875 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655877 */     // MIs[0] offset
     /* 655877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655880 */     // MIs[0] auxiliary
     /* 655880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655883 */     // MIs[0] Operand 8
     /* 655883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655893 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_BOTHEN anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 655896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 655900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 655905 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 655909 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 655912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 655916 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 655919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 655924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_BOTHEN),
     /* 655937 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 655942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655949 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655961 */     GIR_RootConstrainSelectedInstOperands,
     /* 655962 */     // GIR_Coverage, 6243,
     /* 655962 */     GIR_EraseRootFromParent_Done,
     /* 655963 */   // Label 8361: @655963
     /* 655963 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(656059), // Rule ID 6251 //
     /* 655968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 655971 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655973 */     // MIs[0] offset
     /* 655973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655976 */     // MIs[0] auxiliary
     /* 655976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655979 */     // MIs[0] Operand 8
     /* 655979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655989 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 655992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 655996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 656001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 656005 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 656008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 656012 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 656015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 656020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN),
     /* 656033 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 656038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656045 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656047 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656057 */     GIR_RootConstrainSelectedInstOperands,
     /* 656058 */     // GIR_Coverage, 6251,
     /* 656058 */     GIR_EraseRootFromParent_Done,
     /* 656059 */   // Label 8362: @656059
     /* 656059 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(656159), // Rule ID 6239 //
     /* 656064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 656067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656071 */     // MIs[0] offset
     /* 656071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656074 */     // MIs[0] auxiliary
     /* 656074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656077 */     // MIs[0] Operand 8
     /* 656077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656087 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_BOTHEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 656090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 656094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 656099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 656103 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 656106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 656110 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 656113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 656118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_BOTHEN_RTN),
     /* 656131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656133 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 656138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656145 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656147 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656157 */     GIR_RootConstrainSelectedInstOperands,
     /* 656158 */     // GIR_Coverage, 6239,
     /* 656158 */     GIR_EraseRootFromParent_Done,
     /* 656159 */   // Label 8363: @656159
     /* 656159 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(656259), // Rule ID 6247 //
     /* 656164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 656167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656171 */     // MIs[0] offset
     /* 656171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656174 */     // MIs[0] auxiliary
     /* 656174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656177 */     // MIs[0] Operand 8
     /* 656177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656187 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 656190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 656194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 656199 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 656203 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 656206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 656210 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 656213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 656218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN_RTN),
     /* 656231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656233 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 656238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656245 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656247 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656257 */     GIR_RootConstrainSelectedInstOperands,
     /* 656258 */     // GIR_Coverage, 6247,
     /* 656258 */     GIR_EraseRootFromParent_Done,
     /* 656259 */   // Label 8364: @656259
     /* 656259 */   GIM_Reject,
     /* 656260 */ // Label 8348: @656260
     /* 656260 */ GIM_Reject,
     /* 656261 */ // Label 8346: @656261
     /* 656261 */ GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(658650),
     /* 656266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 656269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 656272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 656275 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 656278 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 656281 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(656349), // Rule ID 6272 //
     /* 656286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 656289 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656299 */     // MIs[0] offset
     /* 656299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656302 */     // MIs[0] auxiliary
     /* 656302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656305 */     // MIs[0] Operand 8
     /* 656305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656323 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET),
     /* 656326 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656335 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656337 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656347 */     GIR_RootConstrainSelectedInstOperands,
     /* 656348 */     // GIR_Coverage, 6272,
     /* 656348 */     GIR_EraseRootFromParent_Done,
     /* 656349 */   // Label 8366: @656349
     /* 656349 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(656417), // Rule ID 6280 //
     /* 656354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 656357 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656367 */     // MIs[0] offset
     /* 656367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656370 */     // MIs[0] auxiliary
     /* 656370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656373 */     // MIs[0] Operand 8
     /* 656373 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656391 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET),
     /* 656394 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656403 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656405 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656415 */     GIR_RootConstrainSelectedInstOperands,
     /* 656416 */     // GIR_Coverage, 6280,
     /* 656416 */     GIR_EraseRootFromParent_Done,
     /* 656417 */   // Label 8367: @656417
     /* 656417 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(656485), // Rule ID 6352 //
     /* 656422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 656425 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656427 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656435 */     // MIs[0] offset
     /* 656435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656438 */     // MIs[0] auxiliary
     /* 656438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656441 */     // MIs[0] Operand 8
     /* 656441 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656459 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET),
     /* 656462 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656471 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656473 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656483 */     GIR_RootConstrainSelectedInstOperands,
     /* 656484 */     // GIR_Coverage, 6352,
     /* 656484 */     GIR_EraseRootFromParent_Done,
     /* 656485 */   // Label 8368: @656485
     /* 656485 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(656553), // Rule ID 6360 //
     /* 656490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 656493 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656503 */     // MIs[0] offset
     /* 656503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656506 */     // MIs[0] auxiliary
     /* 656506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656509 */     // MIs[0] Operand 8
     /* 656509 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656527 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET),
     /* 656530 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656539 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656541 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656551 */     GIR_RootConstrainSelectedInstOperands,
     /* 656552 */     // GIR_Coverage, 6360,
     /* 656552 */     GIR_EraseRootFromParent_Done,
     /* 656553 */   // Label 8369: @656553
     /* 656553 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(656625), // Rule ID 6268 //
     /* 656558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 656561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 656565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656573 */     // MIs[0] offset
     /* 656573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656576 */     // MIs[0] auxiliary
     /* 656576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656579 */     // MIs[0] Operand 8
     /* 656579 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656597 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET_RTN),
     /* 656600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656602 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656611 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656613 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656623 */     GIR_RootConstrainSelectedInstOperands,
     /* 656624 */     // GIR_Coverage, 6268,
     /* 656624 */     GIR_EraseRootFromParent_Done,
     /* 656625 */   // Label 8370: @656625
     /* 656625 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(656697), // Rule ID 6276 //
     /* 656630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 656633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 656637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656645 */     // MIs[0] offset
     /* 656645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656648 */     // MIs[0] auxiliary
     /* 656648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656651 */     // MIs[0] Operand 8
     /* 656651 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656669 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN),
     /* 656672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656674 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656683 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656685 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656695 */     GIR_RootConstrainSelectedInstOperands,
     /* 656696 */     // GIR_Coverage, 6276,
     /* 656696 */     GIR_EraseRootFromParent_Done,
     /* 656697 */   // Label 8371: @656697
     /* 656697 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(656769), // Rule ID 6348 //
     /* 656702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 656705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 656709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656713 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656717 */     // MIs[0] offset
     /* 656717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656720 */     // MIs[0] auxiliary
     /* 656720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656723 */     // MIs[0] Operand 8
     /* 656723 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656741 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET_RTN),
     /* 656744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656746 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656755 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656757 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656767 */     GIR_RootConstrainSelectedInstOperands,
     /* 656768 */     // GIR_Coverage, 6348,
     /* 656768 */     GIR_EraseRootFromParent_Done,
     /* 656769 */   // Label 8372: @656769
     /* 656769 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(656841), // Rule ID 6356 //
     /* 656774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 656777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 656781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656789 */     // MIs[0] offset
     /* 656789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656792 */     // MIs[0] auxiliary
     /* 656792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656795 */     // MIs[0] Operand 8
     /* 656795 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656813 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN),
     /* 656816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656818 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656827 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656829 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656839 */     GIR_RootConstrainSelectedInstOperands,
     /* 656840 */     // GIR_Coverage, 6356,
     /* 656840 */     GIR_EraseRootFromParent_Done,
     /* 656841 */   // Label 8373: @656841
     /* 656841 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(656907), // Rule ID 6274 //
     /* 656846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 656849 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656855 */     // MIs[0] offset
     /* 656855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656858 */     // MIs[0] auxiliary
     /* 656858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656861 */     // MIs[0] Operand 8
     /* 656861 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656879 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN),
     /* 656882 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656884 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 656886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656893 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656895 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656905 */     GIR_RootConstrainSelectedInstOperands,
     /* 656906 */     // GIR_Coverage, 6274,
     /* 656906 */     GIR_EraseRootFromParent_Done,
     /* 656907 */   // Label 8374: @656907
     /* 656907 */   GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(656973), // Rule ID 6282 //
     /* 656912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 656915 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656921 */     // MIs[0] offset
     /* 656921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656924 */     // MIs[0] auxiliary
     /* 656924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656927 */     // MIs[0] Operand 8
     /* 656927 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656945 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN),
     /* 656948 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656950 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 656952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656959 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656961 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656971 */     GIR_RootConstrainSelectedInstOperands,
     /* 656972 */     // GIR_Coverage, 6282,
     /* 656972 */     GIR_EraseRootFromParent_Done,
     /* 656973 */   // Label 8375: @656973
     /* 656973 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(657039), // Rule ID 6354 //
     /* 656978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 656981 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656987 */     // MIs[0] offset
     /* 656987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656990 */     // MIs[0] auxiliary
     /* 656990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656993 */     // MIs[0] Operand 8
     /* 656993 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657011 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN),
     /* 657014 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657016 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657025 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657027 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657037 */     GIR_RootConstrainSelectedInstOperands,
     /* 657038 */     // GIR_Coverage, 6354,
     /* 657038 */     GIR_EraseRootFromParent_Done,
     /* 657039 */   // Label 8376: @657039
     /* 657039 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(657105), // Rule ID 6362 //
     /* 657044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657047 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657053 */     // MIs[0] offset
     /* 657053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657056 */     // MIs[0] auxiliary
     /* 657056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657059 */     // MIs[0] Operand 8
     /* 657059 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657077 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN),
     /* 657080 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657082 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657091 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657093 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657103 */     GIR_RootConstrainSelectedInstOperands,
     /* 657104 */     // GIR_Coverage, 6362,
     /* 657104 */     GIR_EraseRootFromParent_Done,
     /* 657105 */   // Label 8377: @657105
     /* 657105 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(657175), // Rule ID 6270 //
     /* 657110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657121 */     // MIs[0] offset
     /* 657121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657124 */     // MIs[0] auxiliary
     /* 657124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657127 */     // MIs[0] Operand 8
     /* 657127 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657145 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN_RTN),
     /* 657148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657150 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657152 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657161 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657163 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657173 */     GIR_RootConstrainSelectedInstOperands,
     /* 657174 */     // GIR_Coverage, 6270,
     /* 657174 */     GIR_EraseRootFromParent_Done,
     /* 657175 */   // Label 8378: @657175
     /* 657175 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(657245), // Rule ID 6278 //
     /* 657180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657191 */     // MIs[0] offset
     /* 657191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657194 */     // MIs[0] auxiliary
     /* 657194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657197 */     // MIs[0] Operand 8
     /* 657197 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657215 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN),
     /* 657218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657220 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657222 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657231 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657233 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657243 */     GIR_RootConstrainSelectedInstOperands,
     /* 657244 */     // GIR_Coverage, 6278,
     /* 657244 */     GIR_EraseRootFromParent_Done,
     /* 657245 */   // Label 8379: @657245
     /* 657245 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(657315), // Rule ID 6350 //
     /* 657250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657261 */     // MIs[0] offset
     /* 657261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657264 */     // MIs[0] auxiliary
     /* 657264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657267 */     // MIs[0] Operand 8
     /* 657267 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657285 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN_RTN),
     /* 657288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657290 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657292 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657301 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657303 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657313 */     GIR_RootConstrainSelectedInstOperands,
     /* 657314 */     // GIR_Coverage, 6350,
     /* 657314 */     GIR_EraseRootFromParent_Done,
     /* 657315 */   // Label 8380: @657315
     /* 657315 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(657385), // Rule ID 6358 //
     /* 657320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657331 */     // MIs[0] offset
     /* 657331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657334 */     // MIs[0] auxiliary
     /* 657334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657337 */     // MIs[0] Operand 8
     /* 657337 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657355 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN),
     /* 657358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657360 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657362 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657371 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657373 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657383 */     GIR_RootConstrainSelectedInstOperands,
     /* 657384 */     // GIR_Coverage, 6358,
     /* 657384 */     GIR_EraseRootFromParent_Done,
     /* 657385 */   // Label 8381: @657385
     /* 657385 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(657443), // Rule ID 6273 //
     /* 657390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657393 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657399 */     // MIs[0] offset
     /* 657399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657402 */     // MIs[0] auxiliary
     /* 657402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657405 */     // MIs[0] Operand 8
     /* 657405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657415 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN),
     /* 657418 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657420 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 657422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657429 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657431 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657441 */     GIR_RootConstrainSelectedInstOperands,
     /* 657442 */     // GIR_Coverage, 6273,
     /* 657442 */     GIR_EraseRootFromParent_Done,
     /* 657443 */   // Label 8382: @657443
     /* 657443 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(657501), // Rule ID 6281 //
     /* 657448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657451 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657457 */     // MIs[0] offset
     /* 657457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657460 */     // MIs[0] auxiliary
     /* 657460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657463 */     // MIs[0] Operand 8
     /* 657463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657473 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN),
     /* 657476 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657478 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 657480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657487 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657499 */     GIR_RootConstrainSelectedInstOperands,
     /* 657500 */     // GIR_Coverage, 6281,
     /* 657500 */     GIR_EraseRootFromParent_Done,
     /* 657501 */   // Label 8383: @657501
     /* 657501 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(657559), // Rule ID 6353 //
     /* 657506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657509 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657515 */     // MIs[0] offset
     /* 657515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657518 */     // MIs[0] auxiliary
     /* 657518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657521 */     // MIs[0] Operand 8
     /* 657521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657531 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN),
     /* 657534 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657536 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 657538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657545 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657547 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657557 */     GIR_RootConstrainSelectedInstOperands,
     /* 657558 */     // GIR_Coverage, 6353,
     /* 657558 */     GIR_EraseRootFromParent_Done,
     /* 657559 */   // Label 8384: @657559
     /* 657559 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(657617), // Rule ID 6361 //
     /* 657564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657567 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657573 */     // MIs[0] offset
     /* 657573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657576 */     // MIs[0] auxiliary
     /* 657576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657579 */     // MIs[0] Operand 8
     /* 657579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657589 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN),
     /* 657592 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657594 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 657596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657603 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657605 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657615 */     GIR_RootConstrainSelectedInstOperands,
     /* 657616 */     // GIR_Coverage, 6361,
     /* 657616 */     GIR_EraseRootFromParent_Done,
     /* 657617 */   // Label 8385: @657617
     /* 657617 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(657679), // Rule ID 6269 //
     /* 657622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657633 */     // MIs[0] offset
     /* 657633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657636 */     // MIs[0] auxiliary
     /* 657636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657639 */     // MIs[0] Operand 8
     /* 657639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657649 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN_RTN),
     /* 657652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657654 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657656 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 657658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657665 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657667 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657677 */     GIR_RootConstrainSelectedInstOperands,
     /* 657678 */     // GIR_Coverage, 6269,
     /* 657678 */     GIR_EraseRootFromParent_Done,
     /* 657679 */   // Label 8386: @657679
     /* 657679 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(657741), // Rule ID 6277 //
     /* 657684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657695 */     // MIs[0] offset
     /* 657695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657698 */     // MIs[0] auxiliary
     /* 657698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657701 */     // MIs[0] Operand 8
     /* 657701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657711 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN),
     /* 657714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657716 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657718 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 657720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657727 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657729 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657739 */     GIR_RootConstrainSelectedInstOperands,
     /* 657740 */     // GIR_Coverage, 6277,
     /* 657740 */     GIR_EraseRootFromParent_Done,
     /* 657741 */   // Label 8387: @657741
     /* 657741 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(657803), // Rule ID 6349 //
     /* 657746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657757 */     // MIs[0] offset
     /* 657757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657760 */     // MIs[0] auxiliary
     /* 657760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657763 */     // MIs[0] Operand 8
     /* 657763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657773 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN_RTN),
     /* 657776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657778 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657780 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 657782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657789 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657791 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657801 */     GIR_RootConstrainSelectedInstOperands,
     /* 657802 */     // GIR_Coverage, 6349,
     /* 657802 */     GIR_EraseRootFromParent_Done,
     /* 657803 */   // Label 8388: @657803
     /* 657803 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(657865), // Rule ID 6357 //
     /* 657808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657819 */     // MIs[0] offset
     /* 657819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657822 */     // MIs[0] auxiliary
     /* 657822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657825 */     // MIs[0] Operand 8
     /* 657825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657835 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN),
     /* 657838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657840 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657842 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 657844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657851 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657853 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657863 */     GIR_RootConstrainSelectedInstOperands,
     /* 657864 */     // GIR_Coverage, 6357,
     /* 657864 */     GIR_EraseRootFromParent_Done,
     /* 657865 */   // Label 8389: @657865
     /* 657865 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(657961), // Rule ID 6275 //
     /* 657870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657873 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657875 */     // MIs[0] offset
     /* 657875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657878 */     // MIs[0] auxiliary
     /* 657878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657881 */     // MIs[0] Operand 8
     /* 657881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657891 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 657894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 657898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 657903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 657907 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 657910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 657914 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 657917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 657922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 657927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 657932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN),
     /* 657935 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 657940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657947 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657949 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657959 */     GIR_RootConstrainSelectedInstOperands,
     /* 657960 */     // GIR_Coverage, 6275,
     /* 657960 */     GIR_EraseRootFromParent_Done,
     /* 657961 */   // Label 8390: @657961
     /* 657961 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(658057), // Rule ID 6283 //
     /* 657966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657969 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657971 */     // MIs[0] offset
     /* 657971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657974 */     // MIs[0] auxiliary
     /* 657974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657977 */     // MIs[0] Operand 8
     /* 657977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 657980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657987 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 657990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 657994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 657999 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658003 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658010 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN),
     /* 658031 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658043 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658055 */     GIR_RootConstrainSelectedInstOperands,
     /* 658056 */     // GIR_Coverage, 6283,
     /* 658056 */     GIR_EraseRootFromParent_Done,
     /* 658057 */   // Label 8391: @658057
     /* 658057 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(658153), // Rule ID 6355 //
     /* 658062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658065 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658067 */     // MIs[0] offset
     /* 658067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658070 */     // MIs[0] auxiliary
     /* 658070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658073 */     // MIs[0] Operand 8
     /* 658073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658083 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658099 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658102 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658106 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN),
     /* 658127 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658139 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658151 */     GIR_RootConstrainSelectedInstOperands,
     /* 658152 */     // GIR_Coverage, 6355,
     /* 658152 */     GIR_EraseRootFromParent_Done,
     /* 658153 */   // Label 8392: @658153
     /* 658153 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(658249), // Rule ID 6363 //
     /* 658158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658161 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658163 */     // MIs[0] offset
     /* 658163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658166 */     // MIs[0] auxiliary
     /* 658166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658169 */     // MIs[0] Operand 8
     /* 658169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658179 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658195 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658198 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658202 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN),
     /* 658223 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658235 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658237 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658247 */     GIR_RootConstrainSelectedInstOperands,
     /* 658248 */     // GIR_Coverage, 6363,
     /* 658248 */     GIR_EraseRootFromParent_Done,
     /* 658249 */   // Label 8393: @658249
     /* 658249 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(658349), // Rule ID 6271 //
     /* 658254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658261 */     // MIs[0] offset
     /* 658261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658264 */     // MIs[0] auxiliary
     /* 658264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658267 */     // MIs[0] Operand 8
     /* 658267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658277 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658289 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658293 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658296 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658300 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN),
     /* 658321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658323 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658335 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658337 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658347 */     GIR_RootConstrainSelectedInstOperands,
     /* 658348 */     // GIR_Coverage, 6271,
     /* 658348 */     GIR_EraseRootFromParent_Done,
     /* 658349 */   // Label 8394: @658349
     /* 658349 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(658449), // Rule ID 6279 //
     /* 658354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658361 */     // MIs[0] offset
     /* 658361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658364 */     // MIs[0] auxiliary
     /* 658364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658367 */     // MIs[0] Operand 8
     /* 658367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658377 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658389 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658393 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658400 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN),
     /* 658421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658423 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658435 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658437 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658447 */     GIR_RootConstrainSelectedInstOperands,
     /* 658448 */     // GIR_Coverage, 6279,
     /* 658448 */     GIR_EraseRootFromParent_Done,
     /* 658449 */   // Label 8395: @658449
     /* 658449 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(658549), // Rule ID 6351 //
     /* 658454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658461 */     // MIs[0] offset
     /* 658461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658464 */     // MIs[0] auxiliary
     /* 658464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658467 */     // MIs[0] Operand 8
     /* 658467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658477 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658489 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658493 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658496 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658500 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN),
     /* 658521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658523 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658535 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658537 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658547 */     GIR_RootConstrainSelectedInstOperands,
     /* 658548 */     // GIR_Coverage, 6351,
     /* 658548 */     GIR_EraseRootFromParent_Done,
     /* 658549 */   // Label 8396: @658549
     /* 658549 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(658649), // Rule ID 6359 //
     /* 658554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658561 */     // MIs[0] offset
     /* 658561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658564 */     // MIs[0] auxiliary
     /* 658564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658567 */     // MIs[0] Operand 8
     /* 658567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658577 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9819:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658593 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658600 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN),
     /* 658621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658623 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658635 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658637 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658647 */     GIR_RootConstrainSelectedInstOperands,
     /* 658648 */     // GIR_Coverage, 6359,
     /* 658648 */     GIR_EraseRootFromParent_Done,
     /* 658649 */   // Label 8397: @658649
     /* 658649 */   GIM_Reject,
     /* 658650 */ // Label 8365: @658650
     /* 658650 */ GIM_Reject,
     /* 658651 */ // Label 8347: @658651
     /* 658651 */ GIM_Reject,
     /* 658652 */ // Label 116: @658652
     /* 658652 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8400*/ GIMT_Encode4(661035),
     /* 658663 */ /*GILLT_s32*//*Label 8398*/ GIMT_Encode4(658671),
     /* 658667 */ /*GILLT_s64*//*Label 8399*/ GIMT_Encode4(659853),
     /* 658671 */ // Label 8398: @658671
     /* 658671 */ GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(659852),
     /* 658676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 658679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 658682 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 658685 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 658688 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 658691 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(658759), // Rule ID 5992 //
     /* 658696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 658699 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 658705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658709 */     // MIs[0] offset
     /* 658709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658712 */     // MIs[0] auxiliary
     /* 658712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658715 */     // MIs[0] Operand 8
     /* 658715 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 658726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658733 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET),
     /* 658736 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658745 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658747 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658757 */     GIR_RootConstrainSelectedInstOperands,
     /* 658758 */     // GIR_Coverage, 5992,
     /* 658758 */     GIR_EraseRootFromParent_Done,
     /* 658759 */   // Label 8402: @658759
     /* 658759 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(658824), // Rule ID 6000 //
     /* 658764 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 658770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658774 */     // MIs[0] offset
     /* 658774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658777 */     // MIs[0] auxiliary
     /* 658777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658780 */     // MIs[0] Operand 8
     /* 658780 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 658791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658798 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET),
     /* 658801 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658810 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658812 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658822 */     GIR_RootConstrainSelectedInstOperands,
     /* 658823 */     // GIR_Coverage, 6000,
     /* 658823 */     GIR_EraseRootFromParent_Done,
     /* 658824 */   // Label 8403: @658824
     /* 658824 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(658896), // Rule ID 5988 //
     /* 658829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 658832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 658836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 658840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658844 */     // MIs[0] offset
     /* 658844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658847 */     // MIs[0] auxiliary
     /* 658847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658850 */     // MIs[0] Operand 8
     /* 658850 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 658861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658868 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET_RTN),
     /* 658871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658873 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658882 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658884 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658894 */     GIR_RootConstrainSelectedInstOperands,
     /* 658895 */     // GIR_Coverage, 5988,
     /* 658895 */     GIR_EraseRootFromParent_Done,
     /* 658896 */   // Label 8404: @658896
     /* 658896 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(658965), // Rule ID 5996 //
     /* 658901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 658905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 658909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658913 */     // MIs[0] offset
     /* 658913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658916 */     // MIs[0] auxiliary
     /* 658916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658919 */     // MIs[0] Operand 8
     /* 658919 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 658930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658937 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN),
     /* 658940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658942 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658951 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658963 */     GIR_RootConstrainSelectedInstOperands,
     /* 658964 */     // GIR_Coverage, 5996,
     /* 658964 */     GIR_EraseRootFromParent_Done,
     /* 658965 */   // Label 8405: @658965
     /* 658965 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(659031), // Rule ID 5994 //
     /* 658970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 658973 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 658979 */     // MIs[0] offset
     /* 658979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658982 */     // MIs[0] auxiliary
     /* 658982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658985 */     // MIs[0] Operand 8
     /* 658985 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 658996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659003 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFEN),
     /* 659006 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659008 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 659010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659017 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659019 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659029 */     GIR_RootConstrainSelectedInstOperands,
     /* 659030 */     // GIR_Coverage, 5994,
     /* 659030 */     GIR_EraseRootFromParent_Done,
     /* 659031 */   // Label 8406: @659031
     /* 659031 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(659094), // Rule ID 6002 //
     /* 659036 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659042 */     // MIs[0] offset
     /* 659042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659045 */     // MIs[0] auxiliary
     /* 659045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659048 */     // MIs[0] Operand 8
     /* 659048 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659066 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFEN),
     /* 659069 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659071 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 659073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659080 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659092 */     GIR_RootConstrainSelectedInstOperands,
     /* 659093 */     // GIR_Coverage, 6002,
     /* 659093 */     GIR_EraseRootFromParent_Done,
     /* 659094 */   // Label 8407: @659094
     /* 659094 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(659164), // Rule ID 5990 //
     /* 659099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 659102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659106 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659110 */     // MIs[0] offset
     /* 659110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659113 */     // MIs[0] auxiliary
     /* 659113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659116 */     // MIs[0] Operand 8
     /* 659116 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659134 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFEN_RTN),
     /* 659137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659139 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659141 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 659143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659150 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659162 */     GIR_RootConstrainSelectedInstOperands,
     /* 659163 */     // GIR_Coverage, 5990,
     /* 659163 */     GIR_EraseRootFromParent_Done,
     /* 659164 */   // Label 8408: @659164
     /* 659164 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(659231), // Rule ID 5998 //
     /* 659169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659177 */     // MIs[0] offset
     /* 659177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659180 */     // MIs[0] auxiliary
     /* 659180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659183 */     // MIs[0] Operand 8
     /* 659183 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659201 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFEN_RTN),
     /* 659204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659206 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659208 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 659210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659217 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659219 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659229 */     GIR_RootConstrainSelectedInstOperands,
     /* 659230 */     // GIR_Coverage, 5998,
     /* 659230 */     GIR_EraseRootFromParent_Done,
     /* 659231 */   // Label 8409: @659231
     /* 659231 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(659289), // Rule ID 5993 //
     /* 659236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 659239 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659245 */     // MIs[0] offset
     /* 659245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659248 */     // MIs[0] auxiliary
     /* 659248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659251 */     // MIs[0] Operand 8
     /* 659251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659261 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_IDXEN),
     /* 659264 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659266 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 659268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659275 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659277 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659287 */     GIR_RootConstrainSelectedInstOperands,
     /* 659288 */     // GIR_Coverage, 5993,
     /* 659288 */     GIR_EraseRootFromParent_Done,
     /* 659289 */   // Label 8410: @659289
     /* 659289 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(659344), // Rule ID 6001 //
     /* 659294 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659300 */     // MIs[0] offset
     /* 659300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659303 */     // MIs[0] auxiliary
     /* 659303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659306 */     // MIs[0] Operand 8
     /* 659306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659316 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_IDXEN),
     /* 659319 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659321 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 659323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659330 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659342 */     GIR_RootConstrainSelectedInstOperands,
     /* 659343 */     // GIR_Coverage, 6001,
     /* 659343 */     GIR_EraseRootFromParent_Done,
     /* 659344 */   // Label 8411: @659344
     /* 659344 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(659406), // Rule ID 5989 //
     /* 659349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 659352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659360 */     // MIs[0] offset
     /* 659360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659363 */     // MIs[0] auxiliary
     /* 659363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659366 */     // MIs[0] Operand 8
     /* 659366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659376 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_IDXEN_RTN),
     /* 659379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659381 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659383 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 659385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659392 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659394 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659404 */     GIR_RootConstrainSelectedInstOperands,
     /* 659405 */     // GIR_Coverage, 5989,
     /* 659405 */     GIR_EraseRootFromParent_Done,
     /* 659406 */   // Label 8412: @659406
     /* 659406 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(659465), // Rule ID 5997 //
     /* 659411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659419 */     // MIs[0] offset
     /* 659419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659422 */     // MIs[0] auxiliary
     /* 659422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659425 */     // MIs[0] Operand 8
     /* 659425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659435 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_IDXEN_RTN),
     /* 659438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659440 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659442 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 659444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659451 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659453 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659463 */     GIR_RootConstrainSelectedInstOperands,
     /* 659464 */     // GIR_Coverage, 5997,
     /* 659464 */     GIR_EraseRootFromParent_Done,
     /* 659465 */   // Label 8413: @659465
     /* 659465 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(659561), // Rule ID 5995 //
     /* 659470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 659473 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659475 */     // MIs[0] offset
     /* 659475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659478 */     // MIs[0] auxiliary
     /* 659478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659481 */     // MIs[0] Operand 8
     /* 659481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659491 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 659494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 659498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 659503 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 659507 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 659510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 659514 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 659517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 659522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_BOTHEN),
     /* 659535 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 659540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659547 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659549 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659559 */     GIR_RootConstrainSelectedInstOperands,
     /* 659560 */     // GIR_Coverage, 5995,
     /* 659560 */     GIR_EraseRootFromParent_Done,
     /* 659561 */   // Label 8414: @659561
     /* 659561 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(659654), // Rule ID 6003 //
     /* 659566 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659568 */     // MIs[0] offset
     /* 659568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659571 */     // MIs[0] auxiliary
     /* 659571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659574 */     // MIs[0] Operand 8
     /* 659574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659584 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 659587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 659591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 659596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 659600 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 659603 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 659607 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 659610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 659615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_BOTHEN),
     /* 659628 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 659633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659640 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659642 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659652 */     GIR_RootConstrainSelectedInstOperands,
     /* 659653 */     // GIR_Coverage, 6003,
     /* 659653 */     GIR_EraseRootFromParent_Done,
     /* 659654 */   // Label 8415: @659654
     /* 659654 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(659754), // Rule ID 5991 //
     /* 659659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 659662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659666 */     // MIs[0] offset
     /* 659666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659669 */     // MIs[0] auxiliary
     /* 659669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659672 */     // MIs[0] Operand 8
     /* 659672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659682 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 659685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 659689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 659694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 659698 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 659701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 659705 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 659708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 659713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_BOTHEN_RTN),
     /* 659726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659728 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 659733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659740 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659742 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659752 */     GIR_RootConstrainSelectedInstOperands,
     /* 659753 */     // GIR_Coverage, 5991,
     /* 659753 */     GIR_EraseRootFromParent_Done,
     /* 659754 */   // Label 8416: @659754
     /* 659754 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(659851), // Rule ID 5999 //
     /* 659759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659763 */     // MIs[0] offset
     /* 659763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659766 */     // MIs[0] auxiliary
     /* 659766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659769 */     // MIs[0] Operand 8
     /* 659769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659779 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 659782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 659786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 659791 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 659795 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 659798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 659802 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 659805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 659810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_BOTHEN_RTN),
     /* 659823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659825 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 659830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659837 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659839 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659849 */     GIR_RootConstrainSelectedInstOperands,
     /* 659850 */     // GIR_Coverage, 5999,
     /* 659850 */     GIR_EraseRootFromParent_Done,
     /* 659851 */   // Label 8417: @659851
     /* 659851 */   GIM_Reject,
     /* 659852 */ // Label 8401: @659852
     /* 659852 */ GIM_Reject,
     /* 659853 */ // Label 8399: @659853
     /* 659853 */ GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(661034),
     /* 659858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 659861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 659864 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 659867 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 659870 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 659873 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(659941), // Rule ID 6192 //
     /* 659878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 659881 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659891 */     // MIs[0] offset
     /* 659891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659894 */     // MIs[0] auxiliary
     /* 659894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659897 */     // MIs[0] Operand 8
     /* 659897 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659915 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET),
     /* 659918 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659927 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659929 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659939 */     GIR_RootConstrainSelectedInstOperands,
     /* 659940 */     // GIR_Coverage, 6192,
     /* 659940 */     GIR_EraseRootFromParent_Done,
     /* 659941 */   // Label 8419: @659941
     /* 659941 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(660006), // Rule ID 6200 //
     /* 659946 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659956 */     // MIs[0] offset
     /* 659956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659959 */     // MIs[0] auxiliary
     /* 659959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659962 */     // MIs[0] Operand 8
     /* 659962 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659980 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET),
     /* 659983 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659992 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660004 */     GIR_RootConstrainSelectedInstOperands,
     /* 660005 */     // GIR_Coverage, 6200,
     /* 660005 */     GIR_EraseRootFromParent_Done,
     /* 660006 */   // Label 8420: @660006
     /* 660006 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(660078), // Rule ID 6188 //
     /* 660011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660026 */     // MIs[0] offset
     /* 660026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660029 */     // MIs[0] auxiliary
     /* 660029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660032 */     // MIs[0] Operand 8
     /* 660032 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660050 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET_RTN),
     /* 660053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660055 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660064 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660066 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660076 */     GIR_RootConstrainSelectedInstOperands,
     /* 660077 */     // GIR_Coverage, 6188,
     /* 660077 */     GIR_EraseRootFromParent_Done,
     /* 660078 */   // Label 8421: @660078
     /* 660078 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(660147), // Rule ID 6196 //
     /* 660083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660095 */     // MIs[0] offset
     /* 660095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660098 */     // MIs[0] auxiliary
     /* 660098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660101 */     // MIs[0] Operand 8
     /* 660101 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660119 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN),
     /* 660122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660124 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660133 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660145 */     GIR_RootConstrainSelectedInstOperands,
     /* 660146 */     // GIR_Coverage, 6196,
     /* 660146 */     GIR_EraseRootFromParent_Done,
     /* 660147 */   // Label 8422: @660147
     /* 660147 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(660213), // Rule ID 6194 //
     /* 660152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660155 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660161 */     // MIs[0] offset
     /* 660161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660164 */     // MIs[0] auxiliary
     /* 660164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660167 */     // MIs[0] Operand 8
     /* 660167 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660185 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFEN),
     /* 660188 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660190 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 660192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660199 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660201 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660211 */     GIR_RootConstrainSelectedInstOperands,
     /* 660212 */     // GIR_Coverage, 6194,
     /* 660212 */     GIR_EraseRootFromParent_Done,
     /* 660213 */   // Label 8423: @660213
     /* 660213 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(660276), // Rule ID 6202 //
     /* 660218 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660224 */     // MIs[0] offset
     /* 660224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660227 */     // MIs[0] auxiliary
     /* 660227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660230 */     // MIs[0] Operand 8
     /* 660230 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660248 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN),
     /* 660251 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660253 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 660255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660262 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660264 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660274 */     GIR_RootConstrainSelectedInstOperands,
     /* 660275 */     // GIR_Coverage, 6202,
     /* 660275 */     GIR_EraseRootFromParent_Done,
     /* 660276 */   // Label 8424: @660276
     /* 660276 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(660346), // Rule ID 6190 //
     /* 660281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660292 */     // MIs[0] offset
     /* 660292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660295 */     // MIs[0] auxiliary
     /* 660295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660298 */     // MIs[0] Operand 8
     /* 660298 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660316 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFEN_RTN),
     /* 660319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660321 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660323 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 660325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660332 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660334 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660344 */     GIR_RootConstrainSelectedInstOperands,
     /* 660345 */     // GIR_Coverage, 6190,
     /* 660345 */     GIR_EraseRootFromParent_Done,
     /* 660346 */   // Label 8425: @660346
     /* 660346 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(660413), // Rule ID 6198 //
     /* 660351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660355 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660359 */     // MIs[0] offset
     /* 660359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660362 */     // MIs[0] auxiliary
     /* 660362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660365 */     // MIs[0] Operand 8
     /* 660365 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660383 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN_RTN),
     /* 660386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660388 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660390 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 660392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660399 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660401 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660411 */     GIR_RootConstrainSelectedInstOperands,
     /* 660412 */     // GIR_Coverage, 6198,
     /* 660412 */     GIR_EraseRootFromParent_Done,
     /* 660413 */   // Label 8426: @660413
     /* 660413 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(660471), // Rule ID 6193 //
     /* 660418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660421 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660427 */     // MIs[0] offset
     /* 660427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660430 */     // MIs[0] auxiliary
     /* 660430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660433 */     // MIs[0] Operand 8
     /* 660433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660443 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_IDXEN),
     /* 660446 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660448 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 660450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660457 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660459 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660469 */     GIR_RootConstrainSelectedInstOperands,
     /* 660470 */     // GIR_Coverage, 6193,
     /* 660470 */     GIR_EraseRootFromParent_Done,
     /* 660471 */   // Label 8427: @660471
     /* 660471 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(660526), // Rule ID 6201 //
     /* 660476 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660482 */     // MIs[0] offset
     /* 660482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660485 */     // MIs[0] auxiliary
     /* 660485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660488 */     // MIs[0] Operand 8
     /* 660488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660498 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN),
     /* 660501 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660503 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 660505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660512 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660514 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660524 */     GIR_RootConstrainSelectedInstOperands,
     /* 660525 */     // GIR_Coverage, 6201,
     /* 660525 */     GIR_EraseRootFromParent_Done,
     /* 660526 */   // Label 8428: @660526
     /* 660526 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(660588), // Rule ID 6189 //
     /* 660531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660542 */     // MIs[0] offset
     /* 660542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660545 */     // MIs[0] auxiliary
     /* 660545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660548 */     // MIs[0] Operand 8
     /* 660548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660558 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_IDXEN_RTN),
     /* 660561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660563 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660565 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 660567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660574 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660576 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660586 */     GIR_RootConstrainSelectedInstOperands,
     /* 660587 */     // GIR_Coverage, 6189,
     /* 660587 */     GIR_EraseRootFromParent_Done,
     /* 660588 */   // Label 8429: @660588
     /* 660588 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(660647), // Rule ID 6197 //
     /* 660593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660601 */     // MIs[0] offset
     /* 660601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660604 */     // MIs[0] auxiliary
     /* 660604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660607 */     // MIs[0] Operand 8
     /* 660607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660617 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN_RTN),
     /* 660620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660622 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660624 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 660626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660633 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660635 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660645 */     GIR_RootConstrainSelectedInstOperands,
     /* 660646 */     // GIR_Coverage, 6197,
     /* 660646 */     GIR_EraseRootFromParent_Done,
     /* 660647 */   // Label 8430: @660647
     /* 660647 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(660743), // Rule ID 6195 //
     /* 660652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660655 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660657 */     // MIs[0] offset
     /* 660657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660660 */     // MIs[0] auxiliary
     /* 660660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660663 */     // MIs[0] Operand 8
     /* 660663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660673 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 660676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 660680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 660685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 660689 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 660692 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 660696 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 660699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 660704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_BOTHEN),
     /* 660717 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 660722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660729 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660731 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660741 */     GIR_RootConstrainSelectedInstOperands,
     /* 660742 */     // GIR_Coverage, 6195,
     /* 660742 */     GIR_EraseRootFromParent_Done,
     /* 660743 */   // Label 8431: @660743
     /* 660743 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(660836), // Rule ID 6203 //
     /* 660748 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660750 */     // MIs[0] offset
     /* 660750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660753 */     // MIs[0] auxiliary
     /* 660753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660756 */     // MIs[0] Operand 8
     /* 660756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660766 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 660769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 660773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 660778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 660782 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 660785 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 660789 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 660792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 660797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN),
     /* 660810 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 660815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660822 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660824 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660834 */     GIR_RootConstrainSelectedInstOperands,
     /* 660835 */     // GIR_Coverage, 6203,
     /* 660835 */     GIR_EraseRootFromParent_Done,
     /* 660836 */   // Label 8432: @660836
     /* 660836 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(660936), // Rule ID 6191 //
     /* 660841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 660844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660848 */     // MIs[0] offset
     /* 660848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660851 */     // MIs[0] auxiliary
     /* 660851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660854 */     // MIs[0] Operand 8
     /* 660854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660864 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 660867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 660871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 660876 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 660880 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 660883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 660887 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 660890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 660895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_BOTHEN_RTN),
     /* 660908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660910 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 660915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660922 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660924 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660934 */     GIR_RootConstrainSelectedInstOperands,
     /* 660935 */     // GIR_Coverage, 6191,
     /* 660935 */     GIR_EraseRootFromParent_Done,
     /* 660936 */   // Label 8433: @660936
     /* 660936 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(661033), // Rule ID 6199 //
     /* 660941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660945 */     // MIs[0] offset
     /* 660945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660948 */     // MIs[0] auxiliary
     /* 660948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660951 */     // MIs[0] Operand 8
     /* 660951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660961 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 660964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 660968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 660973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 660977 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 660980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 660984 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 660987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 660992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 661002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN_RTN),
     /* 661005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661007 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 661012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661019 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661021 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661031 */     GIR_RootConstrainSelectedInstOperands,
     /* 661032 */     // GIR_Coverage, 6199,
     /* 661032 */     GIR_EraseRootFromParent_Done,
     /* 661033 */   // Label 8434: @661033
     /* 661033 */   GIM_Reject,
     /* 661034 */ // Label 8418: @661034
     /* 661034 */ GIM_Reject,
     /* 661035 */ // Label 8400: @661035
     /* 661035 */ GIM_Reject,
     /* 661036 */ // Label 117: @661036
     /* 661036 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8437*/ GIMT_Encode4(663419),
     /* 661047 */ /*GILLT_s32*//*Label 8435*/ GIMT_Encode4(661055),
     /* 661051 */ /*GILLT_s64*//*Label 8436*/ GIMT_Encode4(662237),
     /* 661055 */ // Label 8435: @661055
     /* 661055 */ GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(662236),
     /* 661060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 661063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 661066 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 661069 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 661072 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 661075 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(661143), // Rule ID 5960 //
     /* 661080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 661083 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661093 */     // MIs[0] offset
     /* 661093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661096 */     // MIs[0] auxiliary
     /* 661096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661099 */     // MIs[0] Operand 8
     /* 661099 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661117 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET),
     /* 661120 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661129 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661131 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661141 */     GIR_RootConstrainSelectedInstOperands,
     /* 661142 */     // GIR_Coverage, 5960,
     /* 661142 */     GIR_EraseRootFromParent_Done,
     /* 661143 */   // Label 8439: @661143
     /* 661143 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(661208), // Rule ID 5968 //
     /* 661148 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661158 */     // MIs[0] offset
     /* 661158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661161 */     // MIs[0] auxiliary
     /* 661161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661164 */     // MIs[0] Operand 8
     /* 661164 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661182 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET),
     /* 661185 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661194 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661196 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661206 */     GIR_RootConstrainSelectedInstOperands,
     /* 661207 */     // GIR_Coverage, 5968,
     /* 661207 */     GIR_EraseRootFromParent_Done,
     /* 661208 */   // Label 8440: @661208
     /* 661208 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(661280), // Rule ID 5956 //
     /* 661213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 661216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 661220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661228 */     // MIs[0] offset
     /* 661228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661231 */     // MIs[0] auxiliary
     /* 661231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661234 */     // MIs[0] Operand 8
     /* 661234 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661252 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET_RTN),
     /* 661255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661257 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661266 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661268 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661278 */     GIR_RootConstrainSelectedInstOperands,
     /* 661279 */     // GIR_Coverage, 5956,
     /* 661279 */     GIR_EraseRootFromParent_Done,
     /* 661280 */   // Label 8441: @661280
     /* 661280 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(661349), // Rule ID 5964 //
     /* 661285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 661289 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661297 */     // MIs[0] offset
     /* 661297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661300 */     // MIs[0] auxiliary
     /* 661300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661303 */     // MIs[0] Operand 8
     /* 661303 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661321 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN),
     /* 661324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661326 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661335 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661337 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661347 */     GIR_RootConstrainSelectedInstOperands,
     /* 661348 */     // GIR_Coverage, 5964,
     /* 661348 */     GIR_EraseRootFromParent_Done,
     /* 661349 */   // Label 8442: @661349
     /* 661349 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(661415), // Rule ID 5962 //
     /* 661354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 661357 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661363 */     // MIs[0] offset
     /* 661363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661366 */     // MIs[0] auxiliary
     /* 661366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661369 */     // MIs[0] Operand 8
     /* 661369 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661387 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFEN),
     /* 661390 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661392 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661401 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661413 */     GIR_RootConstrainSelectedInstOperands,
     /* 661414 */     // GIR_Coverage, 5962,
     /* 661414 */     GIR_EraseRootFromParent_Done,
     /* 661415 */   // Label 8443: @661415
     /* 661415 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(661478), // Rule ID 5970 //
     /* 661420 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661426 */     // MIs[0] offset
     /* 661426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661429 */     // MIs[0] auxiliary
     /* 661429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661432 */     // MIs[0] Operand 8
     /* 661432 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661450 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFEN),
     /* 661453 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661455 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661464 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661466 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661476 */     GIR_RootConstrainSelectedInstOperands,
     /* 661477 */     // GIR_Coverage, 5970,
     /* 661477 */     GIR_EraseRootFromParent_Done,
     /* 661478 */   // Label 8444: @661478
     /* 661478 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(661548), // Rule ID 5958 //
     /* 661483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 661486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 661490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661494 */     // MIs[0] offset
     /* 661494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661497 */     // MIs[0] auxiliary
     /* 661497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661500 */     // MIs[0] Operand 8
     /* 661500 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661518 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFEN_RTN),
     /* 661521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661523 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661525 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661534 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661536 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661546 */     GIR_RootConstrainSelectedInstOperands,
     /* 661547 */     // GIR_Coverage, 5958,
     /* 661547 */     GIR_EraseRootFromParent_Done,
     /* 661548 */   // Label 8445: @661548
     /* 661548 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(661615), // Rule ID 5966 //
     /* 661553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 661557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661561 */     // MIs[0] offset
     /* 661561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661564 */     // MIs[0] auxiliary
     /* 661564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661567 */     // MIs[0] Operand 8
     /* 661567 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661585 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFEN_RTN),
     /* 661588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661590 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661592 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661601 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661603 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661613 */     GIR_RootConstrainSelectedInstOperands,
     /* 661614 */     // GIR_Coverage, 5966,
     /* 661614 */     GIR_EraseRootFromParent_Done,
     /* 661615 */   // Label 8446: @661615
     /* 661615 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(661673), // Rule ID 5961 //
     /* 661620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 661623 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661629 */     // MIs[0] offset
     /* 661629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661632 */     // MIs[0] auxiliary
     /* 661632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661635 */     // MIs[0] Operand 8
     /* 661635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661645 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_IDXEN),
     /* 661648 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661650 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 661652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661659 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661661 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661671 */     GIR_RootConstrainSelectedInstOperands,
     /* 661672 */     // GIR_Coverage, 5961,
     /* 661672 */     GIR_EraseRootFromParent_Done,
     /* 661673 */   // Label 8447: @661673
     /* 661673 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(661728), // Rule ID 5969 //
     /* 661678 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661684 */     // MIs[0] offset
     /* 661684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661687 */     // MIs[0] auxiliary
     /* 661687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661690 */     // MIs[0] Operand 8
     /* 661690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661700 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_IDXEN),
     /* 661703 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661705 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 661707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661714 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661716 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661726 */     GIR_RootConstrainSelectedInstOperands,
     /* 661727 */     // GIR_Coverage, 5969,
     /* 661727 */     GIR_EraseRootFromParent_Done,
     /* 661728 */   // Label 8448: @661728
     /* 661728 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(661790), // Rule ID 5957 //
     /* 661733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 661736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 661740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661744 */     // MIs[0] offset
     /* 661744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661747 */     // MIs[0] auxiliary
     /* 661747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661750 */     // MIs[0] Operand 8
     /* 661750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661760 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_IDXEN_RTN),
     /* 661763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661765 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661767 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 661769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661776 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661778 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661788 */     GIR_RootConstrainSelectedInstOperands,
     /* 661789 */     // GIR_Coverage, 5957,
     /* 661789 */     GIR_EraseRootFromParent_Done,
     /* 661790 */   // Label 8449: @661790
     /* 661790 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(661849), // Rule ID 5965 //
     /* 661795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 661799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661803 */     // MIs[0] offset
     /* 661803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661806 */     // MIs[0] auxiliary
     /* 661806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661809 */     // MIs[0] Operand 8
     /* 661809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661819 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_IDXEN_RTN),
     /* 661822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661824 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661826 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 661828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661835 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661837 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661847 */     GIR_RootConstrainSelectedInstOperands,
     /* 661848 */     // GIR_Coverage, 5965,
     /* 661848 */     GIR_EraseRootFromParent_Done,
     /* 661849 */   // Label 8450: @661849
     /* 661849 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(661945), // Rule ID 5963 //
     /* 661854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 661857 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661859 */     // MIs[0] offset
     /* 661859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661862 */     // MIs[0] auxiliary
     /* 661862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661865 */     // MIs[0] Operand 8
     /* 661865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661875 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 661878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 661882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 661887 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 661891 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 661894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 661898 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 661901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 661906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 661911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 661916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_BOTHEN),
     /* 661919 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 661924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661931 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661933 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661943 */     GIR_RootConstrainSelectedInstOperands,
     /* 661944 */     // GIR_Coverage, 5963,
     /* 661944 */     GIR_EraseRootFromParent_Done,
     /* 661945 */   // Label 8451: @661945
     /* 661945 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(662038), // Rule ID 5971 //
     /* 661950 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661952 */     // MIs[0] offset
     /* 661952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661955 */     // MIs[0] auxiliary
     /* 661955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661958 */     // MIs[0] Operand 8
     /* 661958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661968 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 661971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 661975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 661980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 661984 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 661987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 661991 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 661994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 661999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_BOTHEN),
     /* 662012 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662024 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662026 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662036 */     GIR_RootConstrainSelectedInstOperands,
     /* 662037 */     // GIR_Coverage, 5971,
     /* 662037 */     GIR_EraseRootFromParent_Done,
     /* 662038 */   // Label 8452: @662038
     /* 662038 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(662138), // Rule ID 5959 //
     /* 662043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 662050 */     // MIs[0] offset
     /* 662050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662053 */     // MIs[0] auxiliary
     /* 662053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662056 */     // MIs[0] Operand 8
     /* 662056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662066 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662082 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662085 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662089 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 662092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 662097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_BOTHEN_RTN),
     /* 662110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662112 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662124 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662126 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662136 */     GIR_RootConstrainSelectedInstOperands,
     /* 662137 */     // GIR_Coverage, 5959,
     /* 662137 */     GIR_EraseRootFromParent_Done,
     /* 662138 */   // Label 8453: @662138
     /* 662138 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(662235), // Rule ID 5967 //
     /* 662143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 662147 */     // MIs[0] offset
     /* 662147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662150 */     // MIs[0] auxiliary
     /* 662150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662153 */     // MIs[0] Operand 8
     /* 662153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662163 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662175 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662179 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662186 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 662189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 662194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_BOTHEN_RTN),
     /* 662207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662209 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662221 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662223 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662233 */     GIR_RootConstrainSelectedInstOperands,
     /* 662234 */     // GIR_Coverage, 5967,
     /* 662234 */     GIR_EraseRootFromParent_Done,
     /* 662235 */   // Label 8454: @662235
     /* 662235 */   GIM_Reject,
     /* 662236 */ // Label 8438: @662236
     /* 662236 */ GIM_Reject,
     /* 662237 */ // Label 8436: @662237
     /* 662237 */ GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(663418),
     /* 662242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 662245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 662248 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 662251 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 662254 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 662257 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(662325), // Rule ID 6160 //
     /* 662262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662265 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662267 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662275 */     // MIs[0] offset
     /* 662275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662278 */     // MIs[0] auxiliary
     /* 662278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662281 */     // MIs[0] Operand 8
     /* 662281 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662299 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET),
     /* 662302 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662311 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662313 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662323 */     GIR_RootConstrainSelectedInstOperands,
     /* 662324 */     // GIR_Coverage, 6160,
     /* 662324 */     GIR_EraseRootFromParent_Done,
     /* 662325 */   // Label 8456: @662325
     /* 662325 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(662390), // Rule ID 6168 //
     /* 662330 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662340 */     // MIs[0] offset
     /* 662340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662343 */     // MIs[0] auxiliary
     /* 662343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662346 */     // MIs[0] Operand 8
     /* 662346 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662364 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET),
     /* 662367 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662376 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662378 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662388 */     GIR_RootConstrainSelectedInstOperands,
     /* 662389 */     // GIR_Coverage, 6168,
     /* 662389 */     GIR_EraseRootFromParent_Done,
     /* 662390 */   // Label 8457: @662390
     /* 662390 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(662462), // Rule ID 6156 //
     /* 662395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662410 */     // MIs[0] offset
     /* 662410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662413 */     // MIs[0] auxiliary
     /* 662413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662416 */     // MIs[0] Operand 8
     /* 662416 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662434 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET_RTN),
     /* 662437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662439 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662448 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662450 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662460 */     GIR_RootConstrainSelectedInstOperands,
     /* 662461 */     // GIR_Coverage, 6156,
     /* 662461 */     GIR_EraseRootFromParent_Done,
     /* 662462 */   // Label 8458: @662462
     /* 662462 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(662531), // Rule ID 6164 //
     /* 662467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662479 */     // MIs[0] offset
     /* 662479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662482 */     // MIs[0] auxiliary
     /* 662482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662485 */     // MIs[0] Operand 8
     /* 662485 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662503 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN),
     /* 662506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662508 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662517 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662519 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662529 */     GIR_RootConstrainSelectedInstOperands,
     /* 662530 */     // GIR_Coverage, 6164,
     /* 662530 */     GIR_EraseRootFromParent_Done,
     /* 662531 */   // Label 8459: @662531
     /* 662531 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(662597), // Rule ID 6162 //
     /* 662536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662539 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662545 */     // MIs[0] offset
     /* 662545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662548 */     // MIs[0] auxiliary
     /* 662548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662551 */     // MIs[0] Operand 8
     /* 662551 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662569 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFEN),
     /* 662572 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662574 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 662576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662583 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662595 */     GIR_RootConstrainSelectedInstOperands,
     /* 662596 */     // GIR_Coverage, 6162,
     /* 662596 */     GIR_EraseRootFromParent_Done,
     /* 662597 */   // Label 8460: @662597
     /* 662597 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(662660), // Rule ID 6170 //
     /* 662602 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662608 */     // MIs[0] offset
     /* 662608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662611 */     // MIs[0] auxiliary
     /* 662611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662614 */     // MIs[0] Operand 8
     /* 662614 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662632 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN),
     /* 662635 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662637 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 662639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662646 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662658 */     GIR_RootConstrainSelectedInstOperands,
     /* 662659 */     // GIR_Coverage, 6170,
     /* 662659 */     GIR_EraseRootFromParent_Done,
     /* 662660 */   // Label 8461: @662660
     /* 662660 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(662730), // Rule ID 6158 //
     /* 662665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662676 */     // MIs[0] offset
     /* 662676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662679 */     // MIs[0] auxiliary
     /* 662679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662682 */     // MIs[0] Operand 8
     /* 662682 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662700 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFEN_RTN),
     /* 662703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662705 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662707 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 662709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662716 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662728 */     GIR_RootConstrainSelectedInstOperands,
     /* 662729 */     // GIR_Coverage, 6158,
     /* 662729 */     GIR_EraseRootFromParent_Done,
     /* 662730 */   // Label 8462: @662730
     /* 662730 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(662797), // Rule ID 6166 //
     /* 662735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 662743 */     // MIs[0] offset
     /* 662743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662746 */     // MIs[0] auxiliary
     /* 662746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662749 */     // MIs[0] Operand 8
     /* 662749 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 662760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662767 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN_RTN),
     /* 662770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662772 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662774 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 662776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662783 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662795 */     GIR_RootConstrainSelectedInstOperands,
     /* 662796 */     // GIR_Coverage, 6166,
     /* 662796 */     GIR_EraseRootFromParent_Done,
     /* 662797 */   // Label 8463: @662797
     /* 662797 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(662855), // Rule ID 6161 //
     /* 662802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662805 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662811 */     // MIs[0] offset
     /* 662811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662814 */     // MIs[0] auxiliary
     /* 662814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662817 */     // MIs[0] Operand 8
     /* 662817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662827 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_IDXEN),
     /* 662830 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662832 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 662834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662841 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662843 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662853 */     GIR_RootConstrainSelectedInstOperands,
     /* 662854 */     // GIR_Coverage, 6161,
     /* 662854 */     GIR_EraseRootFromParent_Done,
     /* 662855 */   // Label 8464: @662855
     /* 662855 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(662910), // Rule ID 6169 //
     /* 662860 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662866 */     // MIs[0] offset
     /* 662866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662869 */     // MIs[0] auxiliary
     /* 662869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662872 */     // MIs[0] Operand 8
     /* 662872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662882 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN),
     /* 662885 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662887 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 662889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662896 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662898 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662908 */     GIR_RootConstrainSelectedInstOperands,
     /* 662909 */     // GIR_Coverage, 6169,
     /* 662909 */     GIR_EraseRootFromParent_Done,
     /* 662910 */   // Label 8465: @662910
     /* 662910 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(662972), // Rule ID 6157 //
     /* 662915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 662918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662926 */     // MIs[0] offset
     /* 662926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662929 */     // MIs[0] auxiliary
     /* 662929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662932 */     // MIs[0] Operand 8
     /* 662932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662942 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_IDXEN_RTN),
     /* 662945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662947 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662949 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 662951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662958 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662960 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662970 */     GIR_RootConstrainSelectedInstOperands,
     /* 662971 */     // GIR_Coverage, 6157,
     /* 662971 */     GIR_EraseRootFromParent_Done,
     /* 662972 */   // Label 8466: @662972
     /* 662972 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(663031), // Rule ID 6165 //
     /* 662977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662985 */     // MIs[0] offset
     /* 662985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662988 */     // MIs[0] auxiliary
     /* 662988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662991 */     // MIs[0] Operand 8
     /* 662991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663001 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN_RTN),
     /* 663004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663006 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663008 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 663010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663017 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663019 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663029 */     GIR_RootConstrainSelectedInstOperands,
     /* 663030 */     // GIR_Coverage, 6165,
     /* 663030 */     GIR_EraseRootFromParent_Done,
     /* 663031 */   // Label 8467: @663031
     /* 663031 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(663127), // Rule ID 6163 //
     /* 663036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663039 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663041 */     // MIs[0] offset
     /* 663041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663044 */     // MIs[0] auxiliary
     /* 663044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663047 */     // MIs[0] Operand 8
     /* 663047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663057 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 663060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 663064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 663069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 663073 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 663076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 663080 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 663083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 663088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_BOTHEN),
     /* 663101 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 663106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663113 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663125 */     GIR_RootConstrainSelectedInstOperands,
     /* 663126 */     // GIR_Coverage, 6163,
     /* 663126 */     GIR_EraseRootFromParent_Done,
     /* 663127 */   // Label 8468: @663127
     /* 663127 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(663220), // Rule ID 6171 //
     /* 663132 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663134 */     // MIs[0] offset
     /* 663134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663137 */     // MIs[0] auxiliary
     /* 663137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663140 */     // MIs[0] Operand 8
     /* 663140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663150 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 663153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 663157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 663162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 663166 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 663169 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 663173 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 663176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 663181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN),
     /* 663194 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 663199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663206 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663208 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663218 */     GIR_RootConstrainSelectedInstOperands,
     /* 663219 */     // GIR_Coverage, 6171,
     /* 663219 */     GIR_EraseRootFromParent_Done,
     /* 663220 */   // Label 8469: @663220
     /* 663220 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(663320), // Rule ID 6159 //
     /* 663225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 663232 */     // MIs[0] offset
     /* 663232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663235 */     // MIs[0] auxiliary
     /* 663235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663238 */     // MIs[0] Operand 8
     /* 663238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663248 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 663251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 663255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 663260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 663264 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 663267 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 663271 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 663274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 663279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_BOTHEN_RTN),
     /* 663292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663294 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 663299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663306 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663308 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663318 */     GIR_RootConstrainSelectedInstOperands,
     /* 663319 */     // GIR_Coverage, 6159,
     /* 663319 */     GIR_EraseRootFromParent_Done,
     /* 663320 */   // Label 8470: @663320
     /* 663320 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(663417), // Rule ID 6167 //
     /* 663325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 663329 */     // MIs[0] offset
     /* 663329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663332 */     // MIs[0] auxiliary
     /* 663332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663335 */     // MIs[0] Operand 8
     /* 663335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663345 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 663348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 663352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 663357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 663361 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 663364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 663368 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 663371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 663376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN_RTN),
     /* 663389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663391 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 663396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663403 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663405 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663415 */     GIR_RootConstrainSelectedInstOperands,
     /* 663416 */     // GIR_Coverage, 6167,
     /* 663416 */     GIR_EraseRootFromParent_Done,
     /* 663417 */   // Label 8471: @663417
     /* 663417 */   GIM_Reject,
     /* 663418 */ // Label 8455: @663418
     /* 663418 */ GIM_Reject,
     /* 663419 */ // Label 8437: @663419
     /* 663419 */ GIM_Reject,
     /* 663420 */ // Label 118: @663420
     /* 663420 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8474*/ GIMT_Encode4(665803),
     /* 663431 */ /*GILLT_s32*//*Label 8472*/ GIMT_Encode4(663439),
     /* 663435 */ /*GILLT_s64*//*Label 8473*/ GIMT_Encode4(664621),
     /* 663439 */ // Label 8472: @663439
     /* 663439 */ GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(664620),
     /* 663444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 663447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 663450 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 663453 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 663456 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 663459 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(663527), // Rule ID 5912 //
     /* 663464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663467 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663477 */     // MIs[0] offset
     /* 663477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663480 */     // MIs[0] auxiliary
     /* 663480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663483 */     // MIs[0] Operand 8
     /* 663483 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663501 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET),
     /* 663504 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663513 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663515 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663525 */     GIR_RootConstrainSelectedInstOperands,
     /* 663526 */     // GIR_Coverage, 5912,
     /* 663526 */     GIR_EraseRootFromParent_Done,
     /* 663527 */   // Label 8476: @663527
     /* 663527 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(663592), // Rule ID 5920 //
     /* 663532 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663542 */     // MIs[0] offset
     /* 663542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663545 */     // MIs[0] auxiliary
     /* 663545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663548 */     // MIs[0] Operand 8
     /* 663548 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663566 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET),
     /* 663569 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663578 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663580 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663590 */     GIR_RootConstrainSelectedInstOperands,
     /* 663591 */     // GIR_Coverage, 5920,
     /* 663591 */     GIR_EraseRootFromParent_Done,
     /* 663592 */   // Label 8477: @663592
     /* 663592 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(663664), // Rule ID 5908 //
     /* 663597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 663604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663612 */     // MIs[0] offset
     /* 663612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663615 */     // MIs[0] auxiliary
     /* 663615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663618 */     // MIs[0] Operand 8
     /* 663618 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663636 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET_RTN),
     /* 663639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663641 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663650 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663652 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663662 */     GIR_RootConstrainSelectedInstOperands,
     /* 663663 */     // GIR_Coverage, 5908,
     /* 663663 */     GIR_EraseRootFromParent_Done,
     /* 663664 */   // Label 8478: @663664
     /* 663664 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(663733), // Rule ID 5916 //
     /* 663669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 663673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663681 */     // MIs[0] offset
     /* 663681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663684 */     // MIs[0] auxiliary
     /* 663684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663687 */     // MIs[0] Operand 8
     /* 663687 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663705 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN),
     /* 663708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663710 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663719 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663721 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663731 */     GIR_RootConstrainSelectedInstOperands,
     /* 663732 */     // GIR_Coverage, 5916,
     /* 663732 */     GIR_EraseRootFromParent_Done,
     /* 663733 */   // Label 8479: @663733
     /* 663733 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(663799), // Rule ID 5914 //
     /* 663738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663741 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663747 */     // MIs[0] offset
     /* 663747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663750 */     // MIs[0] auxiliary
     /* 663750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663753 */     // MIs[0] Operand 8
     /* 663753 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663771 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFEN),
     /* 663774 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663776 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 663778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663785 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663787 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663797 */     GIR_RootConstrainSelectedInstOperands,
     /* 663798 */     // GIR_Coverage, 5914,
     /* 663798 */     GIR_EraseRootFromParent_Done,
     /* 663799 */   // Label 8480: @663799
     /* 663799 */   GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(663862), // Rule ID 5922 //
     /* 663804 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663810 */     // MIs[0] offset
     /* 663810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663813 */     // MIs[0] auxiliary
     /* 663813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663816 */     // MIs[0] Operand 8
     /* 663816 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663834 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN),
     /* 663837 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663839 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 663841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663848 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663850 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663860 */     GIR_RootConstrainSelectedInstOperands,
     /* 663861 */     // GIR_Coverage, 5922,
     /* 663861 */     GIR_EraseRootFromParent_Done,
     /* 663862 */   // Label 8481: @663862
     /* 663862 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(663932), // Rule ID 5910 //
     /* 663867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 663874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663878 */     // MIs[0] offset
     /* 663878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663881 */     // MIs[0] auxiliary
     /* 663881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663884 */     // MIs[0] Operand 8
     /* 663884 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663902 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFEN_RTN),
     /* 663905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663907 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663909 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 663911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663918 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663920 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663930 */     GIR_RootConstrainSelectedInstOperands,
     /* 663931 */     // GIR_Coverage, 5910,
     /* 663931 */     GIR_EraseRootFromParent_Done,
     /* 663932 */   // Label 8482: @663932
     /* 663932 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(663999), // Rule ID 5918 //
     /* 663937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 663941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663945 */     // MIs[0] offset
     /* 663945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663948 */     // MIs[0] auxiliary
     /* 663948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663951 */     // MIs[0] Operand 8
     /* 663951 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663969 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN_RTN),
     /* 663972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663974 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663976 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 663978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663985 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663987 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663997 */     GIR_RootConstrainSelectedInstOperands,
     /* 663998 */     // GIR_Coverage, 5918,
     /* 663998 */     GIR_EraseRootFromParent_Done,
     /* 663999 */   // Label 8483: @663999
     /* 663999 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(664057), // Rule ID 5913 //
     /* 664004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664007 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664013 */     // MIs[0] offset
     /* 664013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664016 */     // MIs[0] auxiliary
     /* 664016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664019 */     // MIs[0] Operand 8
     /* 664019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664029 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_IDXEN),
     /* 664032 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664034 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 664036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664043 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664055 */     GIR_RootConstrainSelectedInstOperands,
     /* 664056 */     // GIR_Coverage, 5913,
     /* 664056 */     GIR_EraseRootFromParent_Done,
     /* 664057 */   // Label 8484: @664057
     /* 664057 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(664112), // Rule ID 5921 //
     /* 664062 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664068 */     // MIs[0] offset
     /* 664068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664071 */     // MIs[0] auxiliary
     /* 664071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664074 */     // MIs[0] Operand 8
     /* 664074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664084 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN),
     /* 664087 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664089 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 664091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664098 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664100 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664110 */     GIR_RootConstrainSelectedInstOperands,
     /* 664111 */     // GIR_Coverage, 5921,
     /* 664111 */     GIR_EraseRootFromParent_Done,
     /* 664112 */   // Label 8485: @664112
     /* 664112 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(664174), // Rule ID 5909 //
     /* 664117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 664124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664128 */     // MIs[0] offset
     /* 664128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664131 */     // MIs[0] auxiliary
     /* 664131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664134 */     // MIs[0] Operand 8
     /* 664134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664144 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_IDXEN_RTN),
     /* 664147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664149 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664151 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 664153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664160 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664162 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664172 */     GIR_RootConstrainSelectedInstOperands,
     /* 664173 */     // GIR_Coverage, 5909,
     /* 664173 */     GIR_EraseRootFromParent_Done,
     /* 664174 */   // Label 8486: @664174
     /* 664174 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(664233), // Rule ID 5917 //
     /* 664179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 664183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664187 */     // MIs[0] offset
     /* 664187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664190 */     // MIs[0] auxiliary
     /* 664190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664193 */     // MIs[0] Operand 8
     /* 664193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664203 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN_RTN),
     /* 664206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664208 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664210 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 664212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664219 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664231 */     GIR_RootConstrainSelectedInstOperands,
     /* 664232 */     // GIR_Coverage, 5917,
     /* 664232 */     GIR_EraseRootFromParent_Done,
     /* 664233 */   // Label 8487: @664233
     /* 664233 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(664329), // Rule ID 5915 //
     /* 664238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664241 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664243 */     // MIs[0] offset
     /* 664243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664246 */     // MIs[0] auxiliary
     /* 664246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664249 */     // MIs[0] Operand 8
     /* 664249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664259 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 664262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 664266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 664271 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 664275 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 664278 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 664282 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 664285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 664290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_BOTHEN),
     /* 664303 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 664308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664315 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664317 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664327 */     GIR_RootConstrainSelectedInstOperands,
     /* 664328 */     // GIR_Coverage, 5915,
     /* 664328 */     GIR_EraseRootFromParent_Done,
     /* 664329 */   // Label 8488: @664329
     /* 664329 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(664422), // Rule ID 5923 //
     /* 664334 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664336 */     // MIs[0] offset
     /* 664336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664339 */     // MIs[0] auxiliary
     /* 664339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664342 */     // MIs[0] Operand 8
     /* 664342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664352 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 664355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 664359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 664364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 664368 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 664371 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 664375 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 664378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 664383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN),
     /* 664396 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 664401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664408 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664420 */     GIR_RootConstrainSelectedInstOperands,
     /* 664421 */     // GIR_Coverage, 5923,
     /* 664421 */     GIR_EraseRootFromParent_Done,
     /* 664422 */   // Label 8489: @664422
     /* 664422 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(664522), // Rule ID 5911 //
     /* 664427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 664434 */     // MIs[0] offset
     /* 664434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664437 */     // MIs[0] auxiliary
     /* 664437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664440 */     // MIs[0] Operand 8
     /* 664440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664450 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 664453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 664457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 664462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 664466 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 664469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 664473 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 664476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 664481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_BOTHEN_RTN),
     /* 664494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664496 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 664501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664508 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664510 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664520 */     GIR_RootConstrainSelectedInstOperands,
     /* 664521 */     // GIR_Coverage, 5911,
     /* 664521 */     GIR_EraseRootFromParent_Done,
     /* 664522 */   // Label 8490: @664522
     /* 664522 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(664619), // Rule ID 5919 //
     /* 664527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 664531 */     // MIs[0] offset
     /* 664531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664534 */     // MIs[0] auxiliary
     /* 664534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664537 */     // MIs[0] Operand 8
     /* 664537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664547 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 664550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 664554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 664559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 664563 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 664566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 664570 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 664573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 664578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN_RTN),
     /* 664591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664593 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 664598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664605 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664607 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664617 */     GIR_RootConstrainSelectedInstOperands,
     /* 664618 */     // GIR_Coverage, 5919,
     /* 664618 */     GIR_EraseRootFromParent_Done,
     /* 664619 */   // Label 8491: @664619
     /* 664619 */   GIM_Reject,
     /* 664620 */ // Label 8475: @664620
     /* 664620 */ GIM_Reject,
     /* 664621 */ // Label 8473: @664621
     /* 664621 */ GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(665802),
     /* 664626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 664629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 664632 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 664635 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 664638 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 664641 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(664709), // Rule ID 6112 //
     /* 664646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664649 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664659 */     // MIs[0] offset
     /* 664659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664662 */     // MIs[0] auxiliary
     /* 664662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664665 */     // MIs[0] Operand 8
     /* 664665 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664683 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET),
     /* 664686 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664695 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664697 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664707 */     GIR_RootConstrainSelectedInstOperands,
     /* 664708 */     // GIR_Coverage, 6112,
     /* 664708 */     GIR_EraseRootFromParent_Done,
     /* 664709 */   // Label 8493: @664709
     /* 664709 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(664774), // Rule ID 6120 //
     /* 664714 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664724 */     // MIs[0] offset
     /* 664724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664727 */     // MIs[0] auxiliary
     /* 664727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664730 */     // MIs[0] Operand 8
     /* 664730 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664748 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET),
     /* 664751 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664760 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664762 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664772 */     GIR_RootConstrainSelectedInstOperands,
     /* 664773 */     // GIR_Coverage, 6120,
     /* 664773 */     GIR_EraseRootFromParent_Done,
     /* 664774 */   // Label 8494: @664774
     /* 664774 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(664846), // Rule ID 6108 //
     /* 664779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 664786 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664794 */     // MIs[0] offset
     /* 664794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664797 */     // MIs[0] auxiliary
     /* 664797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664800 */     // MIs[0] Operand 8
     /* 664800 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664818 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN),
     /* 664821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664823 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664832 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664834 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664844 */     GIR_RootConstrainSelectedInstOperands,
     /* 664845 */     // GIR_Coverage, 6108,
     /* 664845 */     GIR_EraseRootFromParent_Done,
     /* 664846 */   // Label 8495: @664846
     /* 664846 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(664915), // Rule ID 6116 //
     /* 664851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 664855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664863 */     // MIs[0] offset
     /* 664863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664866 */     // MIs[0] auxiliary
     /* 664866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664869 */     // MIs[0] Operand 8
     /* 664869 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664887 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN),
     /* 664890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664892 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664901 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664903 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664913 */     GIR_RootConstrainSelectedInstOperands,
     /* 664914 */     // GIR_Coverage, 6116,
     /* 664914 */     GIR_EraseRootFromParent_Done,
     /* 664915 */   // Label 8496: @664915
     /* 664915 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(664981), // Rule ID 6114 //
     /* 664920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664923 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664929 */     // MIs[0] offset
     /* 664929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664932 */     // MIs[0] auxiliary
     /* 664932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664935 */     // MIs[0] Operand 8
     /* 664935 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664953 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFEN),
     /* 664956 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664958 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 664960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664967 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664969 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664979 */     GIR_RootConstrainSelectedInstOperands,
     /* 664980 */     // GIR_Coverage, 6114,
     /* 664980 */     GIR_EraseRootFromParent_Done,
     /* 664981 */   // Label 8497: @664981
     /* 664981 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(665044), // Rule ID 6122 //
     /* 664986 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664992 */     // MIs[0] offset
     /* 664992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664995 */     // MIs[0] auxiliary
     /* 664995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664998 */     // MIs[0] Operand 8
     /* 664998 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665016 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN),
     /* 665019 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665021 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 665023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665030 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665032 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665042 */     GIR_RootConstrainSelectedInstOperands,
     /* 665043 */     // GIR_Coverage, 6122,
     /* 665043 */     GIR_EraseRootFromParent_Done,
     /* 665044 */   // Label 8498: @665044
     /* 665044 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(665114), // Rule ID 6110 //
     /* 665049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665060 */     // MIs[0] offset
     /* 665060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665063 */     // MIs[0] auxiliary
     /* 665063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665066 */     // MIs[0] Operand 8
     /* 665066 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665084 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFEN_RTN),
     /* 665087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665089 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665091 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 665093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665100 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665102 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665112 */     GIR_RootConstrainSelectedInstOperands,
     /* 665113 */     // GIR_Coverage, 6110,
     /* 665113 */     GIR_EraseRootFromParent_Done,
     /* 665114 */   // Label 8499: @665114
     /* 665114 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(665181), // Rule ID 6118 //
     /* 665119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665127 */     // MIs[0] offset
     /* 665127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665130 */     // MIs[0] auxiliary
     /* 665130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665133 */     // MIs[0] Operand 8
     /* 665133 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665151 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN_RTN),
     /* 665154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665156 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665158 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 665160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665167 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665169 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665179 */     GIR_RootConstrainSelectedInstOperands,
     /* 665180 */     // GIR_Coverage, 6118,
     /* 665180 */     GIR_EraseRootFromParent_Done,
     /* 665181 */   // Label 8500: @665181
     /* 665181 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(665239), // Rule ID 6113 //
     /* 665186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665189 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665195 */     // MIs[0] offset
     /* 665195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665198 */     // MIs[0] auxiliary
     /* 665198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665201 */     // MIs[0] Operand 8
     /* 665201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665211 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_IDXEN),
     /* 665214 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665216 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 665218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665225 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665227 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665237 */     GIR_RootConstrainSelectedInstOperands,
     /* 665238 */     // GIR_Coverage, 6113,
     /* 665238 */     GIR_EraseRootFromParent_Done,
     /* 665239 */   // Label 8501: @665239
     /* 665239 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(665294), // Rule ID 6121 //
     /* 665244 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665250 */     // MIs[0] offset
     /* 665250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665253 */     // MIs[0] auxiliary
     /* 665253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665256 */     // MIs[0] Operand 8
     /* 665256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665266 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN),
     /* 665269 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665271 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 665273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665280 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665282 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665292 */     GIR_RootConstrainSelectedInstOperands,
     /* 665293 */     // GIR_Coverage, 6121,
     /* 665293 */     GIR_EraseRootFromParent_Done,
     /* 665294 */   // Label 8502: @665294
     /* 665294 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(665356), // Rule ID 6109 //
     /* 665299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665310 */     // MIs[0] offset
     /* 665310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665313 */     // MIs[0] auxiliary
     /* 665313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665316 */     // MIs[0] Operand 8
     /* 665316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665326 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_IDXEN_RTN),
     /* 665329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665331 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665333 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 665335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665342 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665344 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665354 */     GIR_RootConstrainSelectedInstOperands,
     /* 665355 */     // GIR_Coverage, 6109,
     /* 665355 */     GIR_EraseRootFromParent_Done,
     /* 665356 */   // Label 8503: @665356
     /* 665356 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(665415), // Rule ID 6117 //
     /* 665361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665369 */     // MIs[0] offset
     /* 665369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665372 */     // MIs[0] auxiliary
     /* 665372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665375 */     // MIs[0] Operand 8
     /* 665375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665385 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN_RTN),
     /* 665388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665390 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665392 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 665394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665401 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665413 */     GIR_RootConstrainSelectedInstOperands,
     /* 665414 */     // GIR_Coverage, 6117,
     /* 665414 */     GIR_EraseRootFromParent_Done,
     /* 665415 */   // Label 8504: @665415
     /* 665415 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(665511), // Rule ID 6115 //
     /* 665420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665423 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665425 */     // MIs[0] offset
     /* 665425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665428 */     // MIs[0] auxiliary
     /* 665428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665431 */     // MIs[0] Operand 8
     /* 665431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665441 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 665444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 665448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 665453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 665457 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 665460 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 665464 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 665467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 665472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_BOTHEN),
     /* 665485 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 665490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665497 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665509 */     GIR_RootConstrainSelectedInstOperands,
     /* 665510 */     // GIR_Coverage, 6115,
     /* 665510 */     GIR_EraseRootFromParent_Done,
     /* 665511 */   // Label 8505: @665511
     /* 665511 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(665604), // Rule ID 6123 //
     /* 665516 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665518 */     // MIs[0] offset
     /* 665518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665521 */     // MIs[0] auxiliary
     /* 665521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665524 */     // MIs[0] Operand 8
     /* 665524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665534 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 665537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 665541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 665546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 665550 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 665553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 665557 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 665560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 665565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN),
     /* 665578 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 665583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665590 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665592 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665602 */     GIR_RootConstrainSelectedInstOperands,
     /* 665603 */     // GIR_Coverage, 6123,
     /* 665603 */     GIR_EraseRootFromParent_Done,
     /* 665604 */   // Label 8506: @665604
     /* 665604 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(665704), // Rule ID 6111 //
     /* 665609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665616 */     // MIs[0] offset
     /* 665616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665619 */     // MIs[0] auxiliary
     /* 665619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665622 */     // MIs[0] Operand 8
     /* 665622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665632 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 665635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 665639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 665644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 665648 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 665651 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 665655 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 665658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 665663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_BOTHEN_RTN),
     /* 665676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665678 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 665683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665690 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665692 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665702 */     GIR_RootConstrainSelectedInstOperands,
     /* 665703 */     // GIR_Coverage, 6111,
     /* 665703 */     GIR_EraseRootFromParent_Done,
     /* 665704 */   // Label 8507: @665704
     /* 665704 */   GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(665801), // Rule ID 6119 //
     /* 665709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665713 */     // MIs[0] offset
     /* 665713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665716 */     // MIs[0] auxiliary
     /* 665716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665719 */     // MIs[0] Operand 8
     /* 665719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665729 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 665732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 665736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 665741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 665745 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 665748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 665752 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 665755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 665760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN_RTN),
     /* 665773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665775 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 665780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665787 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665789 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665799 */     GIR_RootConstrainSelectedInstOperands,
     /* 665800 */     // GIR_Coverage, 6119,
     /* 665800 */     GIR_EraseRootFromParent_Done,
     /* 665801 */   // Label 8508: @665801
     /* 665801 */   GIM_Reject,
     /* 665802 */ // Label 8492: @665802
     /* 665802 */ GIM_Reject,
     /* 665803 */ // Label 8474: @665803
     /* 665803 */ GIM_Reject,
     /* 665804 */ // Label 119: @665804
     /* 665804 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8511*/ GIMT_Encode4(668187),
     /* 665815 */ /*GILLT_s32*//*Label 8509*/ GIMT_Encode4(665823),
     /* 665819 */ /*GILLT_s64*//*Label 8510*/ GIMT_Encode4(667005),
     /* 665823 */ // Label 8509: @665823
     /* 665823 */ GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(667004),
     /* 665828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 665831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 665834 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 665837 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 665840 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 665843 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(665911), // Rule ID 5880 //
     /* 665848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665851 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665861 */     // MIs[0] offset
     /* 665861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665864 */     // MIs[0] auxiliary
     /* 665864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665867 */     // MIs[0] Operand 8
     /* 665867 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665885 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET),
     /* 665888 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665897 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665899 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665909 */     GIR_RootConstrainSelectedInstOperands,
     /* 665910 */     // GIR_Coverage, 5880,
     /* 665910 */     GIR_EraseRootFromParent_Done,
     /* 665911 */   // Label 8513: @665911
     /* 665911 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(665976), // Rule ID 5888 //
     /* 665916 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665926 */     // MIs[0] offset
     /* 665926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665929 */     // MIs[0] auxiliary
     /* 665929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665932 */     // MIs[0] Operand 8
     /* 665932 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665950 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET),
     /* 665953 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665962 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665964 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665974 */     GIR_RootConstrainSelectedInstOperands,
     /* 665975 */     // GIR_Coverage, 5888,
     /* 665975 */     GIR_EraseRootFromParent_Done,
     /* 665976 */   // Label 8514: @665976
     /* 665976 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(666048), // Rule ID 5876 //
     /* 665981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 665988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665996 */     // MIs[0] offset
     /* 665996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665999 */     // MIs[0] auxiliary
     /* 665999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666002 */     // MIs[0] Operand 8
     /* 666002 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666020 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET_RTN),
     /* 666023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666025 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666034 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666036 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666046 */     GIR_RootConstrainSelectedInstOperands,
     /* 666047 */     // GIR_Coverage, 5876,
     /* 666047 */     GIR_EraseRootFromParent_Done,
     /* 666048 */   // Label 8515: @666048
     /* 666048 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(666117), // Rule ID 5884 //
     /* 666053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666065 */     // MIs[0] offset
     /* 666065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666068 */     // MIs[0] auxiliary
     /* 666068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666071 */     // MIs[0] Operand 8
     /* 666071 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666089 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN),
     /* 666092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666094 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666103 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666115 */     GIR_RootConstrainSelectedInstOperands,
     /* 666116 */     // GIR_Coverage, 5884,
     /* 666116 */     GIR_EraseRootFromParent_Done,
     /* 666117 */   // Label 8516: @666117
     /* 666117 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(666183), // Rule ID 5882 //
     /* 666122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666125 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666131 */     // MIs[0] offset
     /* 666131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666134 */     // MIs[0] auxiliary
     /* 666134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666137 */     // MIs[0] Operand 8
     /* 666137 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666155 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFEN),
     /* 666158 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666160 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 666162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666169 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666171 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666181 */     GIR_RootConstrainSelectedInstOperands,
     /* 666182 */     // GIR_Coverage, 5882,
     /* 666182 */     GIR_EraseRootFromParent_Done,
     /* 666183 */   // Label 8517: @666183
     /* 666183 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(666246), // Rule ID 5890 //
     /* 666188 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666190 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666194 */     // MIs[0] offset
     /* 666194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666197 */     // MIs[0] auxiliary
     /* 666197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666200 */     // MIs[0] Operand 8
     /* 666200 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666218 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN),
     /* 666221 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666223 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 666225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666232 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666234 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666244 */     GIR_RootConstrainSelectedInstOperands,
     /* 666245 */     // GIR_Coverage, 5890,
     /* 666245 */     GIR_EraseRootFromParent_Done,
     /* 666246 */   // Label 8518: @666246
     /* 666246 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(666316), // Rule ID 5878 //
     /* 666251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666262 */     // MIs[0] offset
     /* 666262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666265 */     // MIs[0] auxiliary
     /* 666265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666268 */     // MIs[0] Operand 8
     /* 666268 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666286 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFEN_RTN),
     /* 666289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666291 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666293 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 666295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666302 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666304 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666314 */     GIR_RootConstrainSelectedInstOperands,
     /* 666315 */     // GIR_Coverage, 5878,
     /* 666315 */     GIR_EraseRootFromParent_Done,
     /* 666316 */   // Label 8519: @666316
     /* 666316 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(666383), // Rule ID 5886 //
     /* 666321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666329 */     // MIs[0] offset
     /* 666329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666332 */     // MIs[0] auxiliary
     /* 666332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666335 */     // MIs[0] Operand 8
     /* 666335 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666353 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN_RTN),
     /* 666356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666358 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666360 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 666362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666369 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666371 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666381 */     GIR_RootConstrainSelectedInstOperands,
     /* 666382 */     // GIR_Coverage, 5886,
     /* 666382 */     GIR_EraseRootFromParent_Done,
     /* 666383 */   // Label 8520: @666383
     /* 666383 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(666441), // Rule ID 5881 //
     /* 666388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666391 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666397 */     // MIs[0] offset
     /* 666397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666400 */     // MIs[0] auxiliary
     /* 666400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666403 */     // MIs[0] Operand 8
     /* 666403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666413 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_IDXEN),
     /* 666416 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666418 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 666420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666427 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666429 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666439 */     GIR_RootConstrainSelectedInstOperands,
     /* 666440 */     // GIR_Coverage, 5881,
     /* 666440 */     GIR_EraseRootFromParent_Done,
     /* 666441 */   // Label 8521: @666441
     /* 666441 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(666496), // Rule ID 5889 //
     /* 666446 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666452 */     // MIs[0] offset
     /* 666452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666455 */     // MIs[0] auxiliary
     /* 666455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666458 */     // MIs[0] Operand 8
     /* 666458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666468 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN),
     /* 666471 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666473 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 666475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666482 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666484 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666494 */     GIR_RootConstrainSelectedInstOperands,
     /* 666495 */     // GIR_Coverage, 5889,
     /* 666495 */     GIR_EraseRootFromParent_Done,
     /* 666496 */   // Label 8522: @666496
     /* 666496 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(666558), // Rule ID 5877 //
     /* 666501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666512 */     // MIs[0] offset
     /* 666512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666515 */     // MIs[0] auxiliary
     /* 666515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666518 */     // MIs[0] Operand 8
     /* 666518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666528 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_IDXEN_RTN),
     /* 666531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666533 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666535 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 666537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666544 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666546 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666556 */     GIR_RootConstrainSelectedInstOperands,
     /* 666557 */     // GIR_Coverage, 5877,
     /* 666557 */     GIR_EraseRootFromParent_Done,
     /* 666558 */   // Label 8523: @666558
     /* 666558 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(666617), // Rule ID 5885 //
     /* 666563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666571 */     // MIs[0] offset
     /* 666571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666574 */     // MIs[0] auxiliary
     /* 666574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666577 */     // MIs[0] Operand 8
     /* 666577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666587 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN_RTN),
     /* 666590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666592 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666594 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 666596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666603 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666605 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666615 */     GIR_RootConstrainSelectedInstOperands,
     /* 666616 */     // GIR_Coverage, 5885,
     /* 666616 */     GIR_EraseRootFromParent_Done,
     /* 666617 */   // Label 8524: @666617
     /* 666617 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(666713), // Rule ID 5883 //
     /* 666622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666625 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666627 */     // MIs[0] offset
     /* 666627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666630 */     // MIs[0] auxiliary
     /* 666630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666633 */     // MIs[0] Operand 8
     /* 666633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666643 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 666646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 666650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 666655 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 666659 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 666662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 666666 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 666669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 666674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_BOTHEN),
     /* 666687 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 666692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666699 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666701 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666711 */     GIR_RootConstrainSelectedInstOperands,
     /* 666712 */     // GIR_Coverage, 5883,
     /* 666712 */     GIR_EraseRootFromParent_Done,
     /* 666713 */   // Label 8525: @666713
     /* 666713 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(666806), // Rule ID 5891 //
     /* 666718 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666720 */     // MIs[0] offset
     /* 666720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666723 */     // MIs[0] auxiliary
     /* 666723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666726 */     // MIs[0] Operand 8
     /* 666726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666736 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 666739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 666743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 666748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 666752 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 666755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 666759 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 666762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 666767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN),
     /* 666780 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 666785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666792 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666794 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666804 */     GIR_RootConstrainSelectedInstOperands,
     /* 666805 */     // GIR_Coverage, 5891,
     /* 666805 */     GIR_EraseRootFromParent_Done,
     /* 666806 */   // Label 8526: @666806
     /* 666806 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(666906), // Rule ID 5879 //
     /* 666811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666818 */     // MIs[0] offset
     /* 666818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666821 */     // MIs[0] auxiliary
     /* 666821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666824 */     // MIs[0] Operand 8
     /* 666824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666834 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 666837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 666841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 666846 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 666850 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 666853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 666857 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 666860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 666865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_BOTHEN_RTN),
     /* 666878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666880 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 666885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666892 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666894 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666904 */     GIR_RootConstrainSelectedInstOperands,
     /* 666905 */     // GIR_Coverage, 5879,
     /* 666905 */     GIR_EraseRootFromParent_Done,
     /* 666906 */   // Label 8527: @666906
     /* 666906 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(667003), // Rule ID 5887 //
     /* 666911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666915 */     // MIs[0] offset
     /* 666915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666918 */     // MIs[0] auxiliary
     /* 666918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666921 */     // MIs[0] Operand 8
     /* 666921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666931 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 666934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 666938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 666943 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 666947 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 666950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 666954 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 666957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 666962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN_RTN),
     /* 666975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666977 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 666982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666989 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666991 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667001 */     GIR_RootConstrainSelectedInstOperands,
     /* 667002 */     // GIR_Coverage, 5887,
     /* 667002 */     GIR_EraseRootFromParent_Done,
     /* 667003 */   // Label 8528: @667003
     /* 667003 */   GIM_Reject,
     /* 667004 */ // Label 8512: @667004
     /* 667004 */ GIM_Reject,
     /* 667005 */ // Label 8510: @667005
     /* 667005 */ GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(668186),
     /* 667010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 667013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 667016 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 667019 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 667022 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 667025 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(667093), // Rule ID 6080 //
     /* 667030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667033 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667043 */     // MIs[0] offset
     /* 667043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667046 */     // MIs[0] auxiliary
     /* 667046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667049 */     // MIs[0] Operand 8
     /* 667049 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667067 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET),
     /* 667070 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667079 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667081 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667091 */     GIR_RootConstrainSelectedInstOperands,
     /* 667092 */     // GIR_Coverage, 6080,
     /* 667092 */     GIR_EraseRootFromParent_Done,
     /* 667093 */   // Label 8530: @667093
     /* 667093 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(667158), // Rule ID 6088 //
     /* 667098 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667108 */     // MIs[0] offset
     /* 667108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667111 */     // MIs[0] auxiliary
     /* 667111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667114 */     // MIs[0] Operand 8
     /* 667114 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667132 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET),
     /* 667135 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667144 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667146 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667156 */     GIR_RootConstrainSelectedInstOperands,
     /* 667157 */     // GIR_Coverage, 6088,
     /* 667157 */     GIR_EraseRootFromParent_Done,
     /* 667158 */   // Label 8531: @667158
     /* 667158 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(667230), // Rule ID 6076 //
     /* 667163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667178 */     // MIs[0] offset
     /* 667178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667181 */     // MIs[0] auxiliary
     /* 667181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667184 */     // MIs[0] Operand 8
     /* 667184 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667202 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN),
     /* 667205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667207 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667216 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667218 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667228 */     GIR_RootConstrainSelectedInstOperands,
     /* 667229 */     // GIR_Coverage, 6076,
     /* 667229 */     GIR_EraseRootFromParent_Done,
     /* 667230 */   // Label 8532: @667230
     /* 667230 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(667299), // Rule ID 6084 //
     /* 667235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667247 */     // MIs[0] offset
     /* 667247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667250 */     // MIs[0] auxiliary
     /* 667250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667253 */     // MIs[0] Operand 8
     /* 667253 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667271 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN),
     /* 667274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667276 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667285 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667297 */     GIR_RootConstrainSelectedInstOperands,
     /* 667298 */     // GIR_Coverage, 6084,
     /* 667298 */     GIR_EraseRootFromParent_Done,
     /* 667299 */   // Label 8533: @667299
     /* 667299 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(667365), // Rule ID 6082 //
     /* 667304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667307 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667313 */     // MIs[0] offset
     /* 667313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667316 */     // MIs[0] auxiliary
     /* 667316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667319 */     // MIs[0] Operand 8
     /* 667319 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667337 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFEN),
     /* 667340 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667342 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 667344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667351 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667353 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667363 */     GIR_RootConstrainSelectedInstOperands,
     /* 667364 */     // GIR_Coverage, 6082,
     /* 667364 */     GIR_EraseRootFromParent_Done,
     /* 667365 */   // Label 8534: @667365
     /* 667365 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(667428), // Rule ID 6090 //
     /* 667370 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667376 */     // MIs[0] offset
     /* 667376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667379 */     // MIs[0] auxiliary
     /* 667379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667382 */     // MIs[0] Operand 8
     /* 667382 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667400 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN),
     /* 667403 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667405 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 667407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667414 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667426 */     GIR_RootConstrainSelectedInstOperands,
     /* 667427 */     // GIR_Coverage, 6090,
     /* 667427 */     GIR_EraseRootFromParent_Done,
     /* 667428 */   // Label 8535: @667428
     /* 667428 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(667498), // Rule ID 6078 //
     /* 667433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667444 */     // MIs[0] offset
     /* 667444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667447 */     // MIs[0] auxiliary
     /* 667447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667450 */     // MIs[0] Operand 8
     /* 667450 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667468 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFEN_RTN),
     /* 667471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667473 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667475 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 667477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667484 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667496 */     GIR_RootConstrainSelectedInstOperands,
     /* 667497 */     // GIR_Coverage, 6078,
     /* 667497 */     GIR_EraseRootFromParent_Done,
     /* 667498 */   // Label 8536: @667498
     /* 667498 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(667565), // Rule ID 6086 //
     /* 667503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667511 */     // MIs[0] offset
     /* 667511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667514 */     // MIs[0] auxiliary
     /* 667514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667517 */     // MIs[0] Operand 8
     /* 667517 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667535 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN_RTN),
     /* 667538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667540 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667542 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 667544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667551 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667553 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667563 */     GIR_RootConstrainSelectedInstOperands,
     /* 667564 */     // GIR_Coverage, 6086,
     /* 667564 */     GIR_EraseRootFromParent_Done,
     /* 667565 */   // Label 8537: @667565
     /* 667565 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(667623), // Rule ID 6081 //
     /* 667570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667573 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667579 */     // MIs[0] offset
     /* 667579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667582 */     // MIs[0] auxiliary
     /* 667582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667585 */     // MIs[0] Operand 8
     /* 667585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667595 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_IDXEN),
     /* 667598 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667600 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 667602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667609 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667611 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667621 */     GIR_RootConstrainSelectedInstOperands,
     /* 667622 */     // GIR_Coverage, 6081,
     /* 667622 */     GIR_EraseRootFromParent_Done,
     /* 667623 */   // Label 8538: @667623
     /* 667623 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(667678), // Rule ID 6089 //
     /* 667628 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667634 */     // MIs[0] offset
     /* 667634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667637 */     // MIs[0] auxiliary
     /* 667637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667640 */     // MIs[0] Operand 8
     /* 667640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667650 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN),
     /* 667653 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667655 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 667657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667664 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667666 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667676 */     GIR_RootConstrainSelectedInstOperands,
     /* 667677 */     // GIR_Coverage, 6089,
     /* 667677 */     GIR_EraseRootFromParent_Done,
     /* 667678 */   // Label 8539: @667678
     /* 667678 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(667740), // Rule ID 6077 //
     /* 667683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667694 */     // MIs[0] offset
     /* 667694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667697 */     // MIs[0] auxiliary
     /* 667697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667700 */     // MIs[0] Operand 8
     /* 667700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667710 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_IDXEN_RTN),
     /* 667713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667715 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667717 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 667719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667726 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667728 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667738 */     GIR_RootConstrainSelectedInstOperands,
     /* 667739 */     // GIR_Coverage, 6077,
     /* 667739 */     GIR_EraseRootFromParent_Done,
     /* 667740 */   // Label 8540: @667740
     /* 667740 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(667799), // Rule ID 6085 //
     /* 667745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667749 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667753 */     // MIs[0] offset
     /* 667753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667756 */     // MIs[0] auxiliary
     /* 667756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667759 */     // MIs[0] Operand 8
     /* 667759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667769 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN_RTN),
     /* 667772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667774 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667776 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 667778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667785 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667787 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667797 */     GIR_RootConstrainSelectedInstOperands,
     /* 667798 */     // GIR_Coverage, 6085,
     /* 667798 */     GIR_EraseRootFromParent_Done,
     /* 667799 */   // Label 8541: @667799
     /* 667799 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(667895), // Rule ID 6083 //
     /* 667804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667807 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667809 */     // MIs[0] offset
     /* 667809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667812 */     // MIs[0] auxiliary
     /* 667812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667815 */     // MIs[0] Operand 8
     /* 667815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667825 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 667828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 667832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 667837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 667841 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 667844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 667848 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 667851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 667856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_BOTHEN),
     /* 667869 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 667874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667881 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667893 */     GIR_RootConstrainSelectedInstOperands,
     /* 667894 */     // GIR_Coverage, 6083,
     /* 667894 */     GIR_EraseRootFromParent_Done,
     /* 667895 */   // Label 8542: @667895
     /* 667895 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(667988), // Rule ID 6091 //
     /* 667900 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667902 */     // MIs[0] offset
     /* 667902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667905 */     // MIs[0] auxiliary
     /* 667905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667908 */     // MIs[0] Operand 8
     /* 667908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667918 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 667921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 667925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 667930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 667934 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 667937 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 667941 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 667944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 667949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN),
     /* 667962 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 667967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667974 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667986 */     GIR_RootConstrainSelectedInstOperands,
     /* 667987 */     // GIR_Coverage, 6091,
     /* 667987 */     GIR_EraseRootFromParent_Done,
     /* 667988 */   // Label 8543: @667988
     /* 667988 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(668088), // Rule ID 6079 //
     /* 667993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 668000 */     // MIs[0] offset
     /* 668000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668003 */     // MIs[0] auxiliary
     /* 668003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668006 */     // MIs[0] Operand 8
     /* 668006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668016 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 668019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 668023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 668028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 668032 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 668035 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 668039 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 668042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 668047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_BOTHEN_RTN),
     /* 668060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668062 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 668067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668074 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668076 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668086 */     GIR_RootConstrainSelectedInstOperands,
     /* 668087 */     // GIR_Coverage, 6079,
     /* 668087 */     GIR_EraseRootFromParent_Done,
     /* 668088 */   // Label 8544: @668088
     /* 668088 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(668185), // Rule ID 6087 //
     /* 668093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 668097 */     // MIs[0] offset
     /* 668097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668100 */     // MIs[0] auxiliary
     /* 668100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668103 */     // MIs[0] Operand 8
     /* 668103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668113 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 668116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 668120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 668125 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 668129 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 668132 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 668136 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 668139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 668144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN_RTN),
     /* 668157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668159 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 668164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668171 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668173 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668183 */     GIR_RootConstrainSelectedInstOperands,
     /* 668184 */     // GIR_Coverage, 6087,
     /* 668184 */     GIR_EraseRootFromParent_Done,
     /* 668185 */   // Label 8545: @668185
     /* 668185 */   GIM_Reject,
     /* 668186 */ // Label 8529: @668186
     /* 668186 */ GIM_Reject,
     /* 668187 */ // Label 8511: @668187
     /* 668187 */ GIM_Reject,
     /* 668188 */ // Label 120: @668188
     /* 668188 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8548*/ GIMT_Encode4(670571),
     /* 668199 */ /*GILLT_s32*//*Label 8546*/ GIMT_Encode4(668207),
     /* 668203 */ /*GILLT_s64*//*Label 8547*/ GIMT_Encode4(669389),
     /* 668207 */ // Label 8546: @668207
     /* 668207 */ GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(669388),
     /* 668212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 668215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 668218 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 668221 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 668224 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 668227 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(668295), // Rule ID 5864 //
     /* 668232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668235 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668245 */     // MIs[0] offset
     /* 668245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668248 */     // MIs[0] auxiliary
     /* 668248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668251 */     // MIs[0] Operand 8
     /* 668251 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668269 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET),
     /* 668272 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668281 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668283 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668293 */     GIR_RootConstrainSelectedInstOperands,
     /* 668294 */     // GIR_Coverage, 5864,
     /* 668294 */     GIR_EraseRootFromParent_Done,
     /* 668295 */   // Label 8550: @668295
     /* 668295 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(668360), // Rule ID 5872 //
     /* 668300 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668310 */     // MIs[0] offset
     /* 668310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668313 */     // MIs[0] auxiliary
     /* 668313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668316 */     // MIs[0] Operand 8
     /* 668316 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668334 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET),
     /* 668337 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668346 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668348 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668358 */     GIR_RootConstrainSelectedInstOperands,
     /* 668359 */     // GIR_Coverage, 5872,
     /* 668359 */     GIR_EraseRootFromParent_Done,
     /* 668360 */   // Label 8551: @668360
     /* 668360 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(668432), // Rule ID 5860 //
     /* 668365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668380 */     // MIs[0] offset
     /* 668380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668383 */     // MIs[0] auxiliary
     /* 668383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668386 */     // MIs[0] Operand 8
     /* 668386 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668404 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET_RTN),
     /* 668407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668409 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668418 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668420 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668430 */     GIR_RootConstrainSelectedInstOperands,
     /* 668431 */     // GIR_Coverage, 5860,
     /* 668431 */     GIR_EraseRootFromParent_Done,
     /* 668432 */   // Label 8552: @668432
     /* 668432 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(668501), // Rule ID 5868 //
     /* 668437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668449 */     // MIs[0] offset
     /* 668449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668452 */     // MIs[0] auxiliary
     /* 668452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668455 */     // MIs[0] Operand 8
     /* 668455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668473 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN),
     /* 668476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668478 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668487 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668499 */     GIR_RootConstrainSelectedInstOperands,
     /* 668500 */     // GIR_Coverage, 5868,
     /* 668500 */     GIR_EraseRootFromParent_Done,
     /* 668501 */   // Label 8553: @668501
     /* 668501 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(668567), // Rule ID 5866 //
     /* 668506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668509 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668515 */     // MIs[0] offset
     /* 668515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668518 */     // MIs[0] auxiliary
     /* 668518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668521 */     // MIs[0] Operand 8
     /* 668521 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668539 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFEN),
     /* 668542 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668544 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 668546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668553 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668555 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668565 */     GIR_RootConstrainSelectedInstOperands,
     /* 668566 */     // GIR_Coverage, 5866,
     /* 668566 */     GIR_EraseRootFromParent_Done,
     /* 668567 */   // Label 8554: @668567
     /* 668567 */   GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(668630), // Rule ID 5874 //
     /* 668572 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668578 */     // MIs[0] offset
     /* 668578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668581 */     // MIs[0] auxiliary
     /* 668581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668584 */     // MIs[0] Operand 8
     /* 668584 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668602 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFEN),
     /* 668605 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668607 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 668609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668616 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668628 */     GIR_RootConstrainSelectedInstOperands,
     /* 668629 */     // GIR_Coverage, 5874,
     /* 668629 */     GIR_EraseRootFromParent_Done,
     /* 668630 */   // Label 8555: @668630
     /* 668630 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(668700), // Rule ID 5862 //
     /* 668635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668646 */     // MIs[0] offset
     /* 668646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668649 */     // MIs[0] auxiliary
     /* 668649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668652 */     // MIs[0] Operand 8
     /* 668652 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668670 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFEN_RTN),
     /* 668673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668675 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668677 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 668679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668686 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668688 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668698 */     GIR_RootConstrainSelectedInstOperands,
     /* 668699 */     // GIR_Coverage, 5862,
     /* 668699 */     GIR_EraseRootFromParent_Done,
     /* 668700 */   // Label 8556: @668700
     /* 668700 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(668767), // Rule ID 5870 //
     /* 668705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668713 */     // MIs[0] offset
     /* 668713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668716 */     // MIs[0] auxiliary
     /* 668716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668719 */     // MIs[0] Operand 8
     /* 668719 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668737 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFEN_RTN),
     /* 668740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668742 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668744 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 668746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668753 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668755 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668765 */     GIR_RootConstrainSelectedInstOperands,
     /* 668766 */     // GIR_Coverage, 5870,
     /* 668766 */     GIR_EraseRootFromParent_Done,
     /* 668767 */   // Label 8557: @668767
     /* 668767 */   GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(668825), // Rule ID 5865 //
     /* 668772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668775 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668781 */     // MIs[0] offset
     /* 668781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668784 */     // MIs[0] auxiliary
     /* 668784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668787 */     // MIs[0] Operand 8
     /* 668787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668797 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_IDXEN),
     /* 668800 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668802 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 668804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668811 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668813 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668823 */     GIR_RootConstrainSelectedInstOperands,
     /* 668824 */     // GIR_Coverage, 5865,
     /* 668824 */     GIR_EraseRootFromParent_Done,
     /* 668825 */   // Label 8558: @668825
     /* 668825 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(668880), // Rule ID 5873 //
     /* 668830 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668836 */     // MIs[0] offset
     /* 668836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668839 */     // MIs[0] auxiliary
     /* 668839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668842 */     // MIs[0] Operand 8
     /* 668842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668852 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_IDXEN),
     /* 668855 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668857 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 668859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668866 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668868 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668878 */     GIR_RootConstrainSelectedInstOperands,
     /* 668879 */     // GIR_Coverage, 5873,
     /* 668879 */     GIR_EraseRootFromParent_Done,
     /* 668880 */   // Label 8559: @668880
     /* 668880 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(668942), // Rule ID 5861 //
     /* 668885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668896 */     // MIs[0] offset
     /* 668896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668899 */     // MIs[0] auxiliary
     /* 668899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668902 */     // MIs[0] Operand 8
     /* 668902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668912 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_IDXEN_RTN),
     /* 668915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668917 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668919 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 668921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668928 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668930 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668940 */     GIR_RootConstrainSelectedInstOperands,
     /* 668941 */     // GIR_Coverage, 5861,
     /* 668941 */     GIR_EraseRootFromParent_Done,
     /* 668942 */   // Label 8560: @668942
     /* 668942 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(669001), // Rule ID 5869 //
     /* 668947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668955 */     // MIs[0] offset
     /* 668955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668958 */     // MIs[0] auxiliary
     /* 668958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668961 */     // MIs[0] Operand 8
     /* 668961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668971 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_IDXEN_RTN),
     /* 668974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668976 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668978 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 668980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668987 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668989 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668999 */     GIR_RootConstrainSelectedInstOperands,
     /* 669000 */     // GIR_Coverage, 5869,
     /* 669000 */     GIR_EraseRootFromParent_Done,
     /* 669001 */   // Label 8561: @669001
     /* 669001 */   GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(669097), // Rule ID 5867 //
     /* 669006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669009 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669011 */     // MIs[0] offset
     /* 669011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669014 */     // MIs[0] auxiliary
     /* 669014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669017 */     // MIs[0] Operand 8
     /* 669017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669027 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 669030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 669034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 669039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 669043 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 669046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 669050 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 669053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 669058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_BOTHEN),
     /* 669071 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 669076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669083 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669085 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669095 */     GIR_RootConstrainSelectedInstOperands,
     /* 669096 */     // GIR_Coverage, 5867,
     /* 669096 */     GIR_EraseRootFromParent_Done,
     /* 669097 */   // Label 8562: @669097
     /* 669097 */   GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(669190), // Rule ID 5875 //
     /* 669102 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669104 */     // MIs[0] offset
     /* 669104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669107 */     // MIs[0] auxiliary
     /* 669107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669110 */     // MIs[0] Operand 8
     /* 669110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669120 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 669123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 669127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 669132 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 669136 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 669139 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 669143 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 669146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 669151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN),
     /* 669164 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 669169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669176 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669178 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669188 */     GIR_RootConstrainSelectedInstOperands,
     /* 669189 */     // GIR_Coverage, 5875,
     /* 669189 */     GIR_EraseRootFromParent_Done,
     /* 669190 */   // Label 8563: @669190
     /* 669190 */   GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(669290), // Rule ID 5863 //
     /* 669195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 669202 */     // MIs[0] offset
     /* 669202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669205 */     // MIs[0] auxiliary
     /* 669205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669208 */     // MIs[0] Operand 8
     /* 669208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669218 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 669221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 669225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 669230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 669234 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 669237 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 669241 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 669244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 669249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_BOTHEN_RTN),
     /* 669262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669264 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 669269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669276 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669278 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669288 */     GIR_RootConstrainSelectedInstOperands,
     /* 669289 */     // GIR_Coverage, 5863,
     /* 669289 */     GIR_EraseRootFromParent_Done,
     /* 669290 */   // Label 8564: @669290
     /* 669290 */   GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(669387), // Rule ID 5871 //
     /* 669295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 669299 */     // MIs[0] offset
     /* 669299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669302 */     // MIs[0] auxiliary
     /* 669302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669305 */     // MIs[0] Operand 8
     /* 669305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669315 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 669318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 669322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 669327 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 669331 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 669334 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 669338 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 669341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 669346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN_RTN),
     /* 669359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669361 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 669366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669373 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669385 */     GIR_RootConstrainSelectedInstOperands,
     /* 669386 */     // GIR_Coverage, 5871,
     /* 669386 */     GIR_EraseRootFromParent_Done,
     /* 669387 */   // Label 8565: @669387
     /* 669387 */   GIM_Reject,
     /* 669388 */ // Label 8549: @669388
     /* 669388 */ GIM_Reject,
     /* 669389 */ // Label 8547: @669389
     /* 669389 */ GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(670570),
     /* 669394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 669397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 669400 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 669403 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 669406 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 669409 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(669477), // Rule ID 6064 //
     /* 669414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669417 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669427 */     // MIs[0] offset
     /* 669427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669430 */     // MIs[0] auxiliary
     /* 669430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669433 */     // MIs[0] Operand 8
     /* 669433 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669451 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET),
     /* 669454 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669463 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669465 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669475 */     GIR_RootConstrainSelectedInstOperands,
     /* 669476 */     // GIR_Coverage, 6064,
     /* 669476 */     GIR_EraseRootFromParent_Done,
     /* 669477 */   // Label 8567: @669477
     /* 669477 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(669542), // Rule ID 6072 //
     /* 669482 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669492 */     // MIs[0] offset
     /* 669492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669495 */     // MIs[0] auxiliary
     /* 669495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669498 */     // MIs[0] Operand 8
     /* 669498 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669516 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET),
     /* 669519 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669528 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669530 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669540 */     GIR_RootConstrainSelectedInstOperands,
     /* 669541 */     // GIR_Coverage, 6072,
     /* 669541 */     GIR_EraseRootFromParent_Done,
     /* 669542 */   // Label 8568: @669542
     /* 669542 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(669614), // Rule ID 6060 //
     /* 669547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 669554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669562 */     // MIs[0] offset
     /* 669562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669565 */     // MIs[0] auxiliary
     /* 669565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669568 */     // MIs[0] Operand 8
     /* 669568 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669586 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET_RTN),
     /* 669589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669591 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669600 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669602 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669612 */     GIR_RootConstrainSelectedInstOperands,
     /* 669613 */     // GIR_Coverage, 6060,
     /* 669613 */     GIR_EraseRootFromParent_Done,
     /* 669614 */   // Label 8569: @669614
     /* 669614 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(669683), // Rule ID 6068 //
     /* 669619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 669623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669631 */     // MIs[0] offset
     /* 669631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669634 */     // MIs[0] auxiliary
     /* 669634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669637 */     // MIs[0] Operand 8
     /* 669637 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669655 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN),
     /* 669658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669660 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669669 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669671 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669681 */     GIR_RootConstrainSelectedInstOperands,
     /* 669682 */     // GIR_Coverage, 6068,
     /* 669682 */     GIR_EraseRootFromParent_Done,
     /* 669683 */   // Label 8570: @669683
     /* 669683 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(669749), // Rule ID 6066 //
     /* 669688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669691 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669697 */     // MIs[0] offset
     /* 669697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669700 */     // MIs[0] auxiliary
     /* 669700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669703 */     // MIs[0] Operand 8
     /* 669703 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669721 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFEN),
     /* 669724 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669726 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 669728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669735 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669737 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669747 */     GIR_RootConstrainSelectedInstOperands,
     /* 669748 */     // GIR_Coverage, 6066,
     /* 669748 */     GIR_EraseRootFromParent_Done,
     /* 669749 */   // Label 8571: @669749
     /* 669749 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(669812), // Rule ID 6074 //
     /* 669754 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669760 */     // MIs[0] offset
     /* 669760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669763 */     // MIs[0] auxiliary
     /* 669763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669766 */     // MIs[0] Operand 8
     /* 669766 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669784 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN),
     /* 669787 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669789 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 669791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669798 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669800 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669810 */     GIR_RootConstrainSelectedInstOperands,
     /* 669811 */     // GIR_Coverage, 6074,
     /* 669811 */     GIR_EraseRootFromParent_Done,
     /* 669812 */   // Label 8572: @669812
     /* 669812 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(669882), // Rule ID 6062 //
     /* 669817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 669824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669828 */     // MIs[0] offset
     /* 669828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669831 */     // MIs[0] auxiliary
     /* 669831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669834 */     // MIs[0] Operand 8
     /* 669834 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669852 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFEN_RTN),
     /* 669855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669857 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669859 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 669861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669868 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669870 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669880 */     GIR_RootConstrainSelectedInstOperands,
     /* 669881 */     // GIR_Coverage, 6062,
     /* 669881 */     GIR_EraseRootFromParent_Done,
     /* 669882 */   // Label 8573: @669882
     /* 669882 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(669949), // Rule ID 6070 //
     /* 669887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 669891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669895 */     // MIs[0] offset
     /* 669895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669898 */     // MIs[0] auxiliary
     /* 669898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669901 */     // MIs[0] Operand 8
     /* 669901 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669919 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN_RTN),
     /* 669922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669924 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669926 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 669928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669935 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669937 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669947 */     GIR_RootConstrainSelectedInstOperands,
     /* 669948 */     // GIR_Coverage, 6070,
     /* 669948 */     GIR_EraseRootFromParent_Done,
     /* 669949 */   // Label 8574: @669949
     /* 669949 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(670007), // Rule ID 6065 //
     /* 669954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669957 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669963 */     // MIs[0] offset
     /* 669963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669966 */     // MIs[0] auxiliary
     /* 669966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669969 */     // MIs[0] Operand 8
     /* 669969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669979 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_IDXEN),
     /* 669982 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669984 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 669986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669993 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669995 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670005 */     GIR_RootConstrainSelectedInstOperands,
     /* 670006 */     // GIR_Coverage, 6065,
     /* 670006 */     GIR_EraseRootFromParent_Done,
     /* 670007 */   // Label 8575: @670007
     /* 670007 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(670062), // Rule ID 6073 //
     /* 670012 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670018 */     // MIs[0] offset
     /* 670018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670021 */     // MIs[0] auxiliary
     /* 670021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670024 */     // MIs[0] Operand 8
     /* 670024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670034 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN),
     /* 670037 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670039 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 670041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670048 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670050 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670060 */     GIR_RootConstrainSelectedInstOperands,
     /* 670061 */     // GIR_Coverage, 6073,
     /* 670061 */     GIR_EraseRootFromParent_Done,
     /* 670062 */   // Label 8576: @670062
     /* 670062 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(670124), // Rule ID 6061 //
     /* 670067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 670074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670078 */     // MIs[0] offset
     /* 670078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670081 */     // MIs[0] auxiliary
     /* 670081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670084 */     // MIs[0] Operand 8
     /* 670084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670094 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_IDXEN_RTN),
     /* 670097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670099 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670101 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 670103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670110 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670112 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670122 */     GIR_RootConstrainSelectedInstOperands,
     /* 670123 */     // GIR_Coverage, 6061,
     /* 670123 */     GIR_EraseRootFromParent_Done,
     /* 670124 */   // Label 8577: @670124
     /* 670124 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(670183), // Rule ID 6069 //
     /* 670129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 670133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670137 */     // MIs[0] offset
     /* 670137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670140 */     // MIs[0] auxiliary
     /* 670140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670143 */     // MIs[0] Operand 8
     /* 670143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670153 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN_RTN),
     /* 670156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670158 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670160 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 670162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670169 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670171 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670181 */     GIR_RootConstrainSelectedInstOperands,
     /* 670182 */     // GIR_Coverage, 6069,
     /* 670182 */     GIR_EraseRootFromParent_Done,
     /* 670183 */   // Label 8578: @670183
     /* 670183 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(670279), // Rule ID 6067 //
     /* 670188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670191 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670193 */     // MIs[0] offset
     /* 670193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670196 */     // MIs[0] auxiliary
     /* 670196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670199 */     // MIs[0] Operand 8
     /* 670199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670209 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 670212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 670216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 670221 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 670225 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 670228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 670232 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 670235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 670240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_BOTHEN),
     /* 670253 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 670258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670265 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670277 */     GIR_RootConstrainSelectedInstOperands,
     /* 670278 */     // GIR_Coverage, 6067,
     /* 670278 */     GIR_EraseRootFromParent_Done,
     /* 670279 */   // Label 8579: @670279
     /* 670279 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(670372), // Rule ID 6075 //
     /* 670284 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670286 */     // MIs[0] offset
     /* 670286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670289 */     // MIs[0] auxiliary
     /* 670289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670292 */     // MIs[0] Operand 8
     /* 670292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670302 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 670305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 670309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 670314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 670318 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 670321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 670325 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 670328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 670333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN),
     /* 670346 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 670351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670358 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670360 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670370 */     GIR_RootConstrainSelectedInstOperands,
     /* 670371 */     // GIR_Coverage, 6075,
     /* 670371 */     GIR_EraseRootFromParent_Done,
     /* 670372 */   // Label 8580: @670372
     /* 670372 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(670472), // Rule ID 6063 //
     /* 670377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 670384 */     // MIs[0] offset
     /* 670384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670387 */     // MIs[0] auxiliary
     /* 670387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670390 */     // MIs[0] Operand 8
     /* 670390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670400 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 670403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 670407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 670412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 670416 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 670419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 670423 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 670426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 670431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_BOTHEN_RTN),
     /* 670444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670446 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 670451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670458 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670460 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670470 */     GIR_RootConstrainSelectedInstOperands,
     /* 670471 */     // GIR_Coverage, 6063,
     /* 670471 */     GIR_EraseRootFromParent_Done,
     /* 670472 */   // Label 8581: @670472
     /* 670472 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(670569), // Rule ID 6071 //
     /* 670477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 670481 */     // MIs[0] offset
     /* 670481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670484 */     // MIs[0] auxiliary
     /* 670484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670487 */     // MIs[0] Operand 8
     /* 670487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670497 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 670500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 670504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 670509 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 670513 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 670516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 670520 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 670523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 670528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN_RTN),
     /* 670541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670543 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 670548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670555 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670557 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670567 */     GIR_RootConstrainSelectedInstOperands,
     /* 670568 */     // GIR_Coverage, 6071,
     /* 670568 */     GIR_EraseRootFromParent_Done,
     /* 670569 */   // Label 8582: @670569
     /* 670569 */   GIM_Reject,
     /* 670570 */ // Label 8566: @670570
     /* 670570 */ GIM_Reject,
     /* 670571 */ // Label 8548: @670571
     /* 670571 */ GIM_Reject,
     /* 670572 */ // Label 121: @670572
     /* 670572 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8585*/ GIMT_Encode4(674115),
     /* 670583 */ /*GILLT_s32*//*Label 8583*/ GIMT_Encode4(670591),
     /* 670587 */ /*GILLT_s64*//*Label 8584*/ GIMT_Encode4(672933),
     /* 670591 */ // Label 8583: @670591
     /* 670591 */ GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(672932),
     /* 670596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 670599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 670602 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 670605 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 670608 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 670611 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(670679), // Rule ID 5816 //
     /* 670616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670619 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670629 */     // MIs[0] offset
     /* 670629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670632 */     // MIs[0] auxiliary
     /* 670632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670635 */     // MIs[0] Operand 8
     /* 670635 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670653 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET),
     /* 670656 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670665 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670667 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670677 */     GIR_RootConstrainSelectedInstOperands,
     /* 670678 */     // GIR_Coverage, 5816,
     /* 670678 */     GIR_EraseRootFromParent_Done,
     /* 670679 */   // Label 8587: @670679
     /* 670679 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(670744), // Rule ID 5824 //
     /* 670684 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670694 */     // MIs[0] offset
     /* 670694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670697 */     // MIs[0] auxiliary
     /* 670697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670700 */     // MIs[0] Operand 8
     /* 670700 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670718 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET),
     /* 670721 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670730 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670732 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670742 */     GIR_RootConstrainSelectedInstOperands,
     /* 670743 */     // GIR_Coverage, 5824,
     /* 670743 */     GIR_EraseRootFromParent_Done,
     /* 670744 */   // Label 8588: @670744
     /* 670744 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(670812), // Rule ID 5832 //
     /* 670749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670752 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670762 */     // MIs[0] offset
     /* 670762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670765 */     // MIs[0] auxiliary
     /* 670765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670768 */     // MIs[0] Operand 8
     /* 670768 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670786 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET),
     /* 670789 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670798 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670800 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670810 */     GIR_RootConstrainSelectedInstOperands,
     /* 670811 */     // GIR_Coverage, 5832,
     /* 670811 */     GIR_EraseRootFromParent_Done,
     /* 670812 */   // Label 8589: @670812
     /* 670812 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(670877), // Rule ID 5840 //
     /* 670817 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670827 */     // MIs[0] offset
     /* 670827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670830 */     // MIs[0] auxiliary
     /* 670830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670833 */     // MIs[0] Operand 8
     /* 670833 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670851 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET),
     /* 670854 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670863 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670865 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670875 */     GIR_RootConstrainSelectedInstOperands,
     /* 670876 */     // GIR_Coverage, 5840,
     /* 670876 */     GIR_EraseRootFromParent_Done,
     /* 670877 */   // Label 8590: @670877
     /* 670877 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(670949), // Rule ID 5812 //
     /* 670882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 670889 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670897 */     // MIs[0] offset
     /* 670897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670900 */     // MIs[0] auxiliary
     /* 670900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670903 */     // MIs[0] Operand 8
     /* 670903 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670921 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET_RTN),
     /* 670924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670926 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670935 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670937 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670947 */     GIR_RootConstrainSelectedInstOperands,
     /* 670948 */     // GIR_Coverage, 5812,
     /* 670948 */     GIR_EraseRootFromParent_Done,
     /* 670949 */   // Label 8591: @670949
     /* 670949 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(671018), // Rule ID 5820 //
     /* 670954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 670958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670966 */     // MIs[0] offset
     /* 670966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670969 */     // MIs[0] auxiliary
     /* 670969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670972 */     // MIs[0] Operand 8
     /* 670972 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670990 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN),
     /* 670993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670995 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671004 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671006 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671016 */     GIR_RootConstrainSelectedInstOperands,
     /* 671017 */     // GIR_Coverage, 5820,
     /* 671017 */     GIR_EraseRootFromParent_Done,
     /* 671018 */   // Label 8592: @671018
     /* 671018 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(671090), // Rule ID 5828 //
     /* 671023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671038 */     // MIs[0] offset
     /* 671038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671041 */     // MIs[0] auxiliary
     /* 671041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671044 */     // MIs[0] Operand 8
     /* 671044 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671062 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFSET_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET_RTN),
     /* 671065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671067 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671076 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671078 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671088 */     GIR_RootConstrainSelectedInstOperands,
     /* 671089 */     // GIR_Coverage, 5828,
     /* 671089 */     GIR_EraseRootFromParent_Done,
     /* 671090 */   // Label 8593: @671090
     /* 671090 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(671159), // Rule ID 5836 //
     /* 671095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671107 */     // MIs[0] offset
     /* 671107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671110 */     // MIs[0] auxiliary
     /* 671110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671113 */     // MIs[0] Operand 8
     /* 671113 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671131 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN),
     /* 671134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671136 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671145 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671147 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671157 */     GIR_RootConstrainSelectedInstOperands,
     /* 671158 */     // GIR_Coverage, 5836,
     /* 671158 */     GIR_EraseRootFromParent_Done,
     /* 671159 */   // Label 8594: @671159
     /* 671159 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(671225), // Rule ID 5818 //
     /* 671164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671167 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671173 */     // MIs[0] offset
     /* 671173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671176 */     // MIs[0] auxiliary
     /* 671176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671179 */     // MIs[0] Operand 8
     /* 671179 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671197 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN),
     /* 671200 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671202 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671211 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671213 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671223 */     GIR_RootConstrainSelectedInstOperands,
     /* 671224 */     // GIR_Coverage, 5818,
     /* 671224 */     GIR_EraseRootFromParent_Done,
     /* 671225 */   // Label 8595: @671225
     /* 671225 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(671288), // Rule ID 5826 //
     /* 671230 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671236 */     // MIs[0] offset
     /* 671236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671239 */     // MIs[0] auxiliary
     /* 671239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671242 */     // MIs[0] Operand 8
     /* 671242 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671260 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN),
     /* 671263 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671265 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671274 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671276 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671286 */     GIR_RootConstrainSelectedInstOperands,
     /* 671287 */     // GIR_Coverage, 5826,
     /* 671287 */     GIR_EraseRootFromParent_Done,
     /* 671288 */   // Label 8596: @671288
     /* 671288 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(671354), // Rule ID 5834 //
     /* 671293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671296 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671302 */     // MIs[0] offset
     /* 671302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671305 */     // MIs[0] auxiliary
     /* 671305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671308 */     // MIs[0] Operand 8
     /* 671308 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671326 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN),
     /* 671329 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671331 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671340 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671342 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671352 */     GIR_RootConstrainSelectedInstOperands,
     /* 671353 */     // GIR_Coverage, 5834,
     /* 671353 */     GIR_EraseRootFromParent_Done,
     /* 671354 */   // Label 8597: @671354
     /* 671354 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(671417), // Rule ID 5842 //
     /* 671359 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671365 */     // MIs[0] offset
     /* 671365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671368 */     // MIs[0] auxiliary
     /* 671368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671371 */     // MIs[0] Operand 8
     /* 671371 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671389 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN),
     /* 671392 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671394 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671403 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671405 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671415 */     GIR_RootConstrainSelectedInstOperands,
     /* 671416 */     // GIR_Coverage, 5842,
     /* 671416 */     GIR_EraseRootFromParent_Done,
     /* 671417 */   // Label 8598: @671417
     /* 671417 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(671487), // Rule ID 5814 //
     /* 671422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671433 */     // MIs[0] offset
     /* 671433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671436 */     // MIs[0] auxiliary
     /* 671436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671439 */     // MIs[0] Operand 8
     /* 671439 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671457 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN_RTN),
     /* 671460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671462 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671464 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671473 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671475 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671485 */     GIR_RootConstrainSelectedInstOperands,
     /* 671486 */     // GIR_Coverage, 5814,
     /* 671486 */     GIR_EraseRootFromParent_Done,
     /* 671487 */   // Label 8599: @671487
     /* 671487 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(671554), // Rule ID 5822 //
     /* 671492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671500 */     // MIs[0] offset
     /* 671500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671503 */     // MIs[0] auxiliary
     /* 671503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671506 */     // MIs[0] Operand 8
     /* 671506 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671524 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN),
     /* 671527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671529 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671531 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671540 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671542 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671552 */     GIR_RootConstrainSelectedInstOperands,
     /* 671553 */     // GIR_Coverage, 5822,
     /* 671553 */     GIR_EraseRootFromParent_Done,
     /* 671554 */   // Label 8600: @671554
     /* 671554 */   GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(671624), // Rule ID 5830 //
     /* 671559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671570 */     // MIs[0] offset
     /* 671570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671573 */     // MIs[0] auxiliary
     /* 671573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671576 */     // MIs[0] Operand 8
     /* 671576 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671594 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN_RTN),
     /* 671597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671599 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671601 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671610 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671622 */     GIR_RootConstrainSelectedInstOperands,
     /* 671623 */     // GIR_Coverage, 5830,
     /* 671623 */     GIR_EraseRootFromParent_Done,
     /* 671624 */   // Label 8601: @671624
     /* 671624 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(671691), // Rule ID 5838 //
     /* 671629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671637 */     // MIs[0] offset
     /* 671637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671640 */     // MIs[0] auxiliary
     /* 671640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671643 */     // MIs[0] Operand 8
     /* 671643 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671661 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN),
     /* 671664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671666 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671668 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671677 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671679 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671689 */     GIR_RootConstrainSelectedInstOperands,
     /* 671690 */     // GIR_Coverage, 5838,
     /* 671690 */     GIR_EraseRootFromParent_Done,
     /* 671691 */   // Label 8602: @671691
     /* 671691 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(671749), // Rule ID 5817 //
     /* 671696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671699 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671705 */     // MIs[0] offset
     /* 671705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671708 */     // MIs[0] auxiliary
     /* 671708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671711 */     // MIs[0] Operand 8
     /* 671711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 671714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671721 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN),
     /* 671724 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671726 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 671728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671735 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671737 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671747 */     GIR_RootConstrainSelectedInstOperands,
     /* 671748 */     // GIR_Coverage, 5817,
     /* 671748 */     GIR_EraseRootFromParent_Done,
     /* 671749 */   // Label 8603: @671749
     /* 671749 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(671804), // Rule ID 5825 //
     /* 671754 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671760 */     // MIs[0] offset
     /* 671760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671763 */     // MIs[0] auxiliary
     /* 671763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671766 */     // MIs[0] Operand 8
     /* 671766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 671769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671776 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN),
     /* 671779 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671781 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 671783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671790 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671792 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671802 */     GIR_RootConstrainSelectedInstOperands,
     /* 671803 */     // GIR_Coverage, 5825,
     /* 671803 */     GIR_EraseRootFromParent_Done,
     /* 671804 */   // Label 8604: @671804
     /* 671804 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(671862), // Rule ID 5833 //
     /* 671809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671812 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671818 */     // MIs[0] offset
     /* 671818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671821 */     // MIs[0] auxiliary
     /* 671821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671824 */     // MIs[0] Operand 8
     /* 671824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 671827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671834 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_IDXEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN),
     /* 671837 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671839 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 671841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671848 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671850 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671860 */     GIR_RootConstrainSelectedInstOperands,
     /* 671861 */     // GIR_Coverage, 5833,
     /* 671861 */     GIR_EraseRootFromParent_Done,
     /* 671862 */   // Label 8605: @671862
     /* 671862 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(671917), // Rule ID 5841 //
     /* 671867 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671873 */     // MIs[0] offset
     /* 671873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671876 */     // MIs[0] auxiliary
     /* 671876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671879 */     // MIs[0] Operand 8
     /* 671879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 671882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671889 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN),
     /* 671892 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671894 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 671896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671903 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671905 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671915 */     GIR_RootConstrainSelectedInstOperands,
     /* 671916 */     // GIR_Coverage, 5841,
     /* 671916 */     GIR_EraseRootFromParent_Done,
     /* 671917 */   // Label 8606: @671917
     /* 671917 */   GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(671979), // Rule ID 5813 //
     /* 671922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671933 */     // MIs[0] offset
     /* 671933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671936 */     // MIs[0] auxiliary
     /* 671936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671939 */     // MIs[0] Operand 8
     /* 671939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 671942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671949 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN_RTN),
     /* 671952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671954 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671956 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 671958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671965 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671967 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671977 */     GIR_RootConstrainSelectedInstOperands,
     /* 671978 */     // GIR_Coverage, 5813,
     /* 671978 */     GIR_EraseRootFromParent_Done,
     /* 671979 */   // Label 8607: @671979
     /* 671979 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(672038), // Rule ID 5821 //
     /* 671984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671992 */     // MIs[0] offset
     /* 671992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671995 */     // MIs[0] auxiliary
     /* 671995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671998 */     // MIs[0] Operand 8
     /* 671998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672008 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN),
     /* 672011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672013 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672015 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672024 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672026 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672036 */     GIR_RootConstrainSelectedInstOperands,
     /* 672037 */     // GIR_Coverage, 5821,
     /* 672037 */     GIR_EraseRootFromParent_Done,
     /* 672038 */   // Label 8608: @672038
     /* 672038 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(672100), // Rule ID 5829 //
     /* 672043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672054 */     // MIs[0] offset
     /* 672054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672057 */     // MIs[0] auxiliary
     /* 672057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672060 */     // MIs[0] Operand 8
     /* 672060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672070 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_IDXEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN_RTN),
     /* 672073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672075 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672077 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672086 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672088 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672098 */     GIR_RootConstrainSelectedInstOperands,
     /* 672099 */     // GIR_Coverage, 5829,
     /* 672099 */     GIR_EraseRootFromParent_Done,
     /* 672100 */   // Label 8609: @672100
     /* 672100 */   GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(672159), // Rule ID 5837 //
     /* 672105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672113 */     // MIs[0] offset
     /* 672113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672116 */     // MIs[0] auxiliary
     /* 672116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672119 */     // MIs[0] Operand 8
     /* 672119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672129 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN),
     /* 672132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672134 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672136 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672145 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672147 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672157 */     GIR_RootConstrainSelectedInstOperands,
     /* 672158 */     // GIR_Coverage, 5837,
     /* 672158 */     GIR_EraseRootFromParent_Done,
     /* 672159 */   // Label 8610: @672159
     /* 672159 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(672255), // Rule ID 5819 //
     /* 672164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672167 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672169 */     // MIs[0] offset
     /* 672169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672172 */     // MIs[0] auxiliary
     /* 672172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672175 */     // MIs[0] Operand 8
     /* 672175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672185 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672197 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672201 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672204 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672208 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN),
     /* 672229 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672241 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672243 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672253 */     GIR_RootConstrainSelectedInstOperands,
     /* 672254 */     // GIR_Coverage, 5819,
     /* 672254 */     GIR_EraseRootFromParent_Done,
     /* 672255 */   // Label 8611: @672255
     /* 672255 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(672348), // Rule ID 5827 //
     /* 672260 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672262 */     // MIs[0] offset
     /* 672262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672265 */     // MIs[0] auxiliary
     /* 672265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672268 */     // MIs[0] Operand 8
     /* 672268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672278 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672294 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672301 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN),
     /* 672322 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672334 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672336 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672346 */     GIR_RootConstrainSelectedInstOperands,
     /* 672347 */     // GIR_Coverage, 5827,
     /* 672347 */     GIR_EraseRootFromParent_Done,
     /* 672348 */   // Label 8612: @672348
     /* 672348 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(672444), // Rule ID 5835 //
     /* 672353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672356 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672358 */     // MIs[0] offset
     /* 672358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672361 */     // MIs[0] auxiliary
     /* 672361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672364 */     // MIs[0] Operand 8
     /* 672364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672374 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_BOTHEN anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672390 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672397 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN),
     /* 672418 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672430 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672432 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672442 */     GIR_RootConstrainSelectedInstOperands,
     /* 672443 */     // GIR_Coverage, 5835,
     /* 672443 */     GIR_EraseRootFromParent_Done,
     /* 672444 */   // Label 8613: @672444
     /* 672444 */   GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(672537), // Rule ID 5843 //
     /* 672449 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672451 */     // MIs[0] offset
     /* 672451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672454 */     // MIs[0] auxiliary
     /* 672454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672457 */     // MIs[0] Operand 8
     /* 672457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672467 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672479 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672483 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672490 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN),
     /* 672511 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672523 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672525 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672535 */     GIR_RootConstrainSelectedInstOperands,
     /* 672536 */     // GIR_Coverage, 5843,
     /* 672536 */     GIR_EraseRootFromParent_Done,
     /* 672537 */   // Label 8614: @672537
     /* 672537 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(672637), // Rule ID 5815 //
     /* 672542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672549 */     // MIs[0] offset
     /* 672549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672552 */     // MIs[0] auxiliary
     /* 672552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672555 */     // MIs[0] Operand 8
     /* 672555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672565 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672581 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672588 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN_RTN),
     /* 672609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672611 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672623 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672625 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672635 */     GIR_RootConstrainSelectedInstOperands,
     /* 672636 */     // GIR_Coverage, 5815,
     /* 672636 */     GIR_EraseRootFromParent_Done,
     /* 672637 */   // Label 8615: @672637
     /* 672637 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(672734), // Rule ID 5823 //
     /* 672642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672646 */     // MIs[0] offset
     /* 672646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672649 */     // MIs[0] auxiliary
     /* 672649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672652 */     // MIs[0] Operand 8
     /* 672652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672662 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672678 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672685 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN),
     /* 672706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672708 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672720 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672722 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672732 */     GIR_RootConstrainSelectedInstOperands,
     /* 672733 */     // GIR_Coverage, 5823,
     /* 672733 */     GIR_EraseRootFromParent_Done,
     /* 672734 */   // Label 8616: @672734
     /* 672734 */   GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(672834), // Rule ID 5831 //
     /* 672739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672746 */     // MIs[0] offset
     /* 672746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672749 */     // MIs[0] auxiliary
     /* 672749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672752 */     // MIs[0] Operand 8
     /* 672752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672762 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_BOTHEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672778 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672785 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN_RTN),
     /* 672806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672808 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672820 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672822 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672832 */     GIR_RootConstrainSelectedInstOperands,
     /* 672833 */     // GIR_Coverage, 5831,
     /* 672833 */     GIR_EraseRootFromParent_Done,
     /* 672834 */   // Label 8617: @672834
     /* 672834 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(672931), // Rule ID 5839 //
     /* 672839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672843 */     // MIs[0] offset
     /* 672843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672846 */     // MIs[0] auxiliary
     /* 672846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672849 */     // MIs[0] Operand 8
     /* 672849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672859 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9820:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672875 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672882 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN),
     /* 672903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672905 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672917 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672919 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672929 */     GIR_RootConstrainSelectedInstOperands,
     /* 672930 */     // GIR_Coverage, 5839,
     /* 672930 */     GIR_EraseRootFromParent_Done,
     /* 672931 */   // Label 8618: @672931
     /* 672931 */   GIM_Reject,
     /* 672932 */ // Label 8586: @672932
     /* 672932 */ GIM_Reject,
     /* 672933 */ // Label 8584: @672933
     /* 672933 */ GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(674114),
     /* 672938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 672941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 672944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 672947 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 672950 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 672953 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(673021), // Rule ID 6032 //
     /* 672958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672961 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672963 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 672967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672971 */     // MIs[0] offset
     /* 672971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672974 */     // MIs[0] auxiliary
     /* 672974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672977 */     // MIs[0] Operand 8
     /* 672977 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 672988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672995 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET),
     /* 672998 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673007 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673009 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673019 */     GIR_RootConstrainSelectedInstOperands,
     /* 673020 */     // GIR_Coverage, 6032,
     /* 673020 */     GIR_EraseRootFromParent_Done,
     /* 673021 */   // Label 8620: @673021
     /* 673021 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(673086), // Rule ID 6040 //
     /* 673026 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673036 */     // MIs[0] offset
     /* 673036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673039 */     // MIs[0] auxiliary
     /* 673039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673042 */     // MIs[0] Operand 8
     /* 673042 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673060 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET),
     /* 673063 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673072 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673074 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673084 */     GIR_RootConstrainSelectedInstOperands,
     /* 673085 */     // GIR_Coverage, 6040,
     /* 673085 */     GIR_EraseRootFromParent_Done,
     /* 673086 */   // Label 8621: @673086
     /* 673086 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(673158), // Rule ID 6028 //
     /* 673091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673106 */     // MIs[0] offset
     /* 673106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673109 */     // MIs[0] auxiliary
     /* 673109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673112 */     // MIs[0] Operand 8
     /* 673112 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673130 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN),
     /* 673133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673135 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673144 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673146 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673156 */     GIR_RootConstrainSelectedInstOperands,
     /* 673157 */     // GIR_Coverage, 6028,
     /* 673157 */     GIR_EraseRootFromParent_Done,
     /* 673158 */   // Label 8622: @673158
     /* 673158 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(673227), // Rule ID 6036 //
     /* 673163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673175 */     // MIs[0] offset
     /* 673175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673178 */     // MIs[0] auxiliary
     /* 673178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673181 */     // MIs[0] Operand 8
     /* 673181 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673199 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN),
     /* 673202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673204 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673213 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673225 */     GIR_RootConstrainSelectedInstOperands,
     /* 673226 */     // GIR_Coverage, 6036,
     /* 673226 */     GIR_EraseRootFromParent_Done,
     /* 673227 */   // Label 8623: @673227
     /* 673227 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(673293), // Rule ID 6034 //
     /* 673232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673235 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673241 */     // MIs[0] offset
     /* 673241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673244 */     // MIs[0] auxiliary
     /* 673244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673247 */     // MIs[0] Operand 8
     /* 673247 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673265 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFEN),
     /* 673268 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673270 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 673272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673279 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673281 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673291 */     GIR_RootConstrainSelectedInstOperands,
     /* 673292 */     // GIR_Coverage, 6034,
     /* 673292 */     GIR_EraseRootFromParent_Done,
     /* 673293 */   // Label 8624: @673293
     /* 673293 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(673356), // Rule ID 6042 //
     /* 673298 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673304 */     // MIs[0] offset
     /* 673304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673307 */     // MIs[0] auxiliary
     /* 673307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673310 */     // MIs[0] Operand 8
     /* 673310 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673328 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN),
     /* 673331 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673333 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 673335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673342 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673344 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673354 */     GIR_RootConstrainSelectedInstOperands,
     /* 673355 */     // GIR_Coverage, 6042,
     /* 673355 */     GIR_EraseRootFromParent_Done,
     /* 673356 */   // Label 8625: @673356
     /* 673356 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(673426), // Rule ID 6030 //
     /* 673361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673372 */     // MIs[0] offset
     /* 673372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673375 */     // MIs[0] auxiliary
     /* 673375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673378 */     // MIs[0] Operand 8
     /* 673378 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673396 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFEN_RTN),
     /* 673399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673401 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673403 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 673405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673412 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673414 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673424 */     GIR_RootConstrainSelectedInstOperands,
     /* 673425 */     // GIR_Coverage, 6030,
     /* 673425 */     GIR_EraseRootFromParent_Done,
     /* 673426 */   // Label 8626: @673426
     /* 673426 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(673493), // Rule ID 6038 //
     /* 673431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673439 */     // MIs[0] offset
     /* 673439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673442 */     // MIs[0] auxiliary
     /* 673442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673445 */     // MIs[0] Operand 8
     /* 673445 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673463 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN_RTN),
     /* 673466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673468 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673470 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 673472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673479 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673481 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673491 */     GIR_RootConstrainSelectedInstOperands,
     /* 673492 */     // GIR_Coverage, 6038,
     /* 673492 */     GIR_EraseRootFromParent_Done,
     /* 673493 */   // Label 8627: @673493
     /* 673493 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(673551), // Rule ID 6033 //
     /* 673498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673501 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673507 */     // MIs[0] offset
     /* 673507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673510 */     // MIs[0] auxiliary
     /* 673510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673513 */     // MIs[0] Operand 8
     /* 673513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673523 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_IDXEN),
     /* 673526 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673528 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 673530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673537 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673539 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673549 */     GIR_RootConstrainSelectedInstOperands,
     /* 673550 */     // GIR_Coverage, 6033,
     /* 673550 */     GIR_EraseRootFromParent_Done,
     /* 673551 */   // Label 8628: @673551
     /* 673551 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(673606), // Rule ID 6041 //
     /* 673556 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673562 */     // MIs[0] offset
     /* 673562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673565 */     // MIs[0] auxiliary
     /* 673565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673568 */     // MIs[0] Operand 8
     /* 673568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673578 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN),
     /* 673581 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673583 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 673585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673592 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673594 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673604 */     GIR_RootConstrainSelectedInstOperands,
     /* 673605 */     // GIR_Coverage, 6041,
     /* 673605 */     GIR_EraseRootFromParent_Done,
     /* 673606 */   // Label 8629: @673606
     /* 673606 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(673668), // Rule ID 6029 //
     /* 673611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673622 */     // MIs[0] offset
     /* 673622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673625 */     // MIs[0] auxiliary
     /* 673625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673628 */     // MIs[0] Operand 8
     /* 673628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673638 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_IDXEN_RTN),
     /* 673641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673643 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673645 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 673647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673654 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673656 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673666 */     GIR_RootConstrainSelectedInstOperands,
     /* 673667 */     // GIR_Coverage, 6029,
     /* 673667 */     GIR_EraseRootFromParent_Done,
     /* 673668 */   // Label 8630: @673668
     /* 673668 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(673727), // Rule ID 6037 //
     /* 673673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673681 */     // MIs[0] offset
     /* 673681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673684 */     // MIs[0] auxiliary
     /* 673684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673687 */     // MIs[0] Operand 8
     /* 673687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673697 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN_RTN),
     /* 673700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673702 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673704 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 673706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673713 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673715 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673725 */     GIR_RootConstrainSelectedInstOperands,
     /* 673726 */     // GIR_Coverage, 6037,
     /* 673726 */     GIR_EraseRootFromParent_Done,
     /* 673727 */   // Label 8631: @673727
     /* 673727 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(673823), // Rule ID 6035 //
     /* 673732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673735 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673737 */     // MIs[0] offset
     /* 673737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673740 */     // MIs[0] auxiliary
     /* 673740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673743 */     // MIs[0] Operand 8
     /* 673743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673753 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 673756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 673760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 673765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 673769 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 673772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 673776 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 673779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 673784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_BOTHEN),
     /* 673797 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 673802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673809 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673811 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673821 */     GIR_RootConstrainSelectedInstOperands,
     /* 673822 */     // GIR_Coverage, 6035,
     /* 673822 */     GIR_EraseRootFromParent_Done,
     /* 673823 */   // Label 8632: @673823
     /* 673823 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(673916), // Rule ID 6043 //
     /* 673828 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673830 */     // MIs[0] offset
     /* 673830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673833 */     // MIs[0] auxiliary
     /* 673833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673836 */     // MIs[0] Operand 8
     /* 673836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673846 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 673849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 673853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 673858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 673862 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 673865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 673869 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 673872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 673877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN),
     /* 673890 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 673895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673902 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673904 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673914 */     GIR_RootConstrainSelectedInstOperands,
     /* 673915 */     // GIR_Coverage, 6043,
     /* 673915 */     GIR_EraseRootFromParent_Done,
     /* 673916 */   // Label 8633: @673916
     /* 673916 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(674016), // Rule ID 6031 //
     /* 673921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673928 */     // MIs[0] offset
     /* 673928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673931 */     // MIs[0] auxiliary
     /* 673931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673934 */     // MIs[0] Operand 8
     /* 673934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673944 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 673947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 673951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 673956 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 673960 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 673963 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 673967 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 673970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 673975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_BOTHEN_RTN),
     /* 673988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673990 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 673995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674002 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674004 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674014 */     GIR_RootConstrainSelectedInstOperands,
     /* 674015 */     // GIR_Coverage, 6031,
     /* 674015 */     GIR_EraseRootFromParent_Done,
     /* 674016 */   // Label 8634: @674016
     /* 674016 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(674113), // Rule ID 6039 //
     /* 674021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 674025 */     // MIs[0] offset
     /* 674025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674028 */     // MIs[0] auxiliary
     /* 674028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674031 */     // MIs[0] Operand 8
     /* 674031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674041 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 674044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 674048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 674053 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 674057 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 674060 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 674064 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 674067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 674072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN_RTN),
     /* 674085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674087 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 674092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674099 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674111 */     GIR_RootConstrainSelectedInstOperands,
     /* 674112 */     // GIR_Coverage, 6039,
     /* 674112 */     GIR_EraseRootFromParent_Done,
     /* 674113 */   // Label 8635: @674113
     /* 674113 */   GIM_Reject,
     /* 674114 */ // Label 8619: @674114
     /* 674114 */ GIM_Reject,
     /* 674115 */ // Label 8585: @674115
     /* 674115 */ GIM_Reject,
     /* 674116 */ // Label 122: @674116
     /* 674116 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8638*/ GIMT_Encode4(676499),
     /* 674127 */ /*GILLT_s32*//*Label 8636*/ GIMT_Encode4(674135),
     /* 674131 */ /*GILLT_s64*//*Label 8637*/ GIMT_Encode4(675317),
     /* 674135 */ // Label 8636: @674135
     /* 674135 */ GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(675316),
     /* 674140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 674143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 674146 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 674149 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 674152 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 674155 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(674223), // Rule ID 5928 //
     /* 674160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674163 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674173 */     // MIs[0] offset
     /* 674173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674176 */     // MIs[0] auxiliary
     /* 674176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674179 */     // MIs[0] Operand 8
     /* 674179 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674197 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET),
     /* 674200 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674209 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674211 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674221 */     GIR_RootConstrainSelectedInstOperands,
     /* 674222 */     // GIR_Coverage, 5928,
     /* 674222 */     GIR_EraseRootFromParent_Done,
     /* 674223 */   // Label 8640: @674223
     /* 674223 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(674288), // Rule ID 5936 //
     /* 674228 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674238 */     // MIs[0] offset
     /* 674238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674241 */     // MIs[0] auxiliary
     /* 674241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674244 */     // MIs[0] Operand 8
     /* 674244 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674262 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET),
     /* 674265 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674274 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674276 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674286 */     GIR_RootConstrainSelectedInstOperands,
     /* 674287 */     // GIR_Coverage, 5936,
     /* 674287 */     GIR_EraseRootFromParent_Done,
     /* 674288 */   // Label 8641: @674288
     /* 674288 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(674360), // Rule ID 5924 //
     /* 674293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 674300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674308 */     // MIs[0] offset
     /* 674308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674311 */     // MIs[0] auxiliary
     /* 674311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674314 */     // MIs[0] Operand 8
     /* 674314 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674332 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET_RTN),
     /* 674335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674337 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674346 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674348 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674358 */     GIR_RootConstrainSelectedInstOperands,
     /* 674359 */     // GIR_Coverage, 5924,
     /* 674359 */     GIR_EraseRootFromParent_Done,
     /* 674360 */   // Label 8642: @674360
     /* 674360 */   GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(674429), // Rule ID 5932 //
     /* 674365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 674369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674377 */     // MIs[0] offset
     /* 674377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674380 */     // MIs[0] auxiliary
     /* 674380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674383 */     // MIs[0] Operand 8
     /* 674383 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674401 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN),
     /* 674404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674406 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674415 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674427 */     GIR_RootConstrainSelectedInstOperands,
     /* 674428 */     // GIR_Coverage, 5932,
     /* 674428 */     GIR_EraseRootFromParent_Done,
     /* 674429 */   // Label 8643: @674429
     /* 674429 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(674495), // Rule ID 5930 //
     /* 674434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674437 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674443 */     // MIs[0] offset
     /* 674443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674446 */     // MIs[0] auxiliary
     /* 674446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674449 */     // MIs[0] Operand 8
     /* 674449 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674467 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFEN),
     /* 674470 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674472 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 674474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674481 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674483 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674493 */     GIR_RootConstrainSelectedInstOperands,
     /* 674494 */     // GIR_Coverage, 5930,
     /* 674494 */     GIR_EraseRootFromParent_Done,
     /* 674495 */   // Label 8644: @674495
     /* 674495 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(674558), // Rule ID 5938 //
     /* 674500 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674506 */     // MIs[0] offset
     /* 674506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674509 */     // MIs[0] auxiliary
     /* 674509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674512 */     // MIs[0] Operand 8
     /* 674512 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674530 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN),
     /* 674533 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674535 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 674537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674544 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674546 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674556 */     GIR_RootConstrainSelectedInstOperands,
     /* 674557 */     // GIR_Coverage, 5938,
     /* 674557 */     GIR_EraseRootFromParent_Done,
     /* 674558 */   // Label 8645: @674558
     /* 674558 */   GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(674628), // Rule ID 5926 //
     /* 674563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 674570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674574 */     // MIs[0] offset
     /* 674574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674577 */     // MIs[0] auxiliary
     /* 674577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674580 */     // MIs[0] Operand 8
     /* 674580 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674598 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFEN_RTN),
     /* 674601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674603 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674605 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 674607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674614 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674616 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674626 */     GIR_RootConstrainSelectedInstOperands,
     /* 674627 */     // GIR_Coverage, 5926,
     /* 674627 */     GIR_EraseRootFromParent_Done,
     /* 674628 */   // Label 8646: @674628
     /* 674628 */   GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(674695), // Rule ID 5934 //
     /* 674633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 674637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674641 */     // MIs[0] offset
     /* 674641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674644 */     // MIs[0] auxiliary
     /* 674644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674647 */     // MIs[0] Operand 8
     /* 674647 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674665 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN_RTN),
     /* 674668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674670 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674672 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 674674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674681 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674683 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674693 */     GIR_RootConstrainSelectedInstOperands,
     /* 674694 */     // GIR_Coverage, 5934,
     /* 674694 */     GIR_EraseRootFromParent_Done,
     /* 674695 */   // Label 8647: @674695
     /* 674695 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(674753), // Rule ID 5929 //
     /* 674700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674703 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674709 */     // MIs[0] offset
     /* 674709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674712 */     // MIs[0] auxiliary
     /* 674712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674715 */     // MIs[0] Operand 8
     /* 674715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674725 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_IDXEN),
     /* 674728 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674730 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 674732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674739 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674741 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674751 */     GIR_RootConstrainSelectedInstOperands,
     /* 674752 */     // GIR_Coverage, 5929,
     /* 674752 */     GIR_EraseRootFromParent_Done,
     /* 674753 */   // Label 8648: @674753
     /* 674753 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(674808), // Rule ID 5937 //
     /* 674758 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674764 */     // MIs[0] offset
     /* 674764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674767 */     // MIs[0] auxiliary
     /* 674767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674770 */     // MIs[0] Operand 8
     /* 674770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674780 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN),
     /* 674783 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674785 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 674787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674794 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674796 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674806 */     GIR_RootConstrainSelectedInstOperands,
     /* 674807 */     // GIR_Coverage, 5937,
     /* 674807 */     GIR_EraseRootFromParent_Done,
     /* 674808 */   // Label 8649: @674808
     /* 674808 */   GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(674870), // Rule ID 5925 //
     /* 674813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 674820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674824 */     // MIs[0] offset
     /* 674824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674827 */     // MIs[0] auxiliary
     /* 674827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674830 */     // MIs[0] Operand 8
     /* 674830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674840 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_IDXEN_RTN),
     /* 674843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674845 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674847 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 674849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674856 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674858 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674868 */     GIR_RootConstrainSelectedInstOperands,
     /* 674869 */     // GIR_Coverage, 5925,
     /* 674869 */     GIR_EraseRootFromParent_Done,
     /* 674870 */   // Label 8650: @674870
     /* 674870 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(674929), // Rule ID 5933 //
     /* 674875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 674879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674883 */     // MIs[0] offset
     /* 674883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674886 */     // MIs[0] auxiliary
     /* 674886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674889 */     // MIs[0] Operand 8
     /* 674889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674899 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN_RTN),
     /* 674902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674904 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674906 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 674908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674915 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674917 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674927 */     GIR_RootConstrainSelectedInstOperands,
     /* 674928 */     // GIR_Coverage, 5933,
     /* 674928 */     GIR_EraseRootFromParent_Done,
     /* 674929 */   // Label 8651: @674929
     /* 674929 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(675025), // Rule ID 5931 //
     /* 674934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674937 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674939 */     // MIs[0] offset
     /* 674939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674942 */     // MIs[0] auxiliary
     /* 674942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674945 */     // MIs[0] Operand 8
     /* 674945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674955 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 674958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 674962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 674967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 674971 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 674974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 674978 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 674981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 674986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_BOTHEN),
     /* 674999 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 675004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675011 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675013 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675023 */     GIR_RootConstrainSelectedInstOperands,
     /* 675024 */     // GIR_Coverage, 5931,
     /* 675024 */     GIR_EraseRootFromParent_Done,
     /* 675025 */   // Label 8652: @675025
     /* 675025 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(675118), // Rule ID 5939 //
     /* 675030 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675032 */     // MIs[0] offset
     /* 675032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675035 */     // MIs[0] auxiliary
     /* 675035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675038 */     // MIs[0] Operand 8
     /* 675038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 675041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675048 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 675051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 675055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 675060 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 675064 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 675067 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 675071 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 675074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 675079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN),
     /* 675092 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 675097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675104 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675106 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675116 */     GIR_RootConstrainSelectedInstOperands,
     /* 675117 */     // GIR_Coverage, 5939,
     /* 675117 */     GIR_EraseRootFromParent_Done,
     /* 675118 */   // Label 8653: @675118
     /* 675118 */   GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(675218), // Rule ID 5927 //
     /* 675123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 675130 */     // MIs[0] offset
     /* 675130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675133 */     // MIs[0] auxiliary
     /* 675133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675136 */     // MIs[0] Operand 8
     /* 675136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 675139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675146 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 675149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 675153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 675158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 675162 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 675165 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 675169 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 675172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 675177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_BOTHEN_RTN),
     /* 675190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675192 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 675197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675204 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675216 */     GIR_RootConstrainSelectedInstOperands,
     /* 675217 */     // GIR_Coverage, 5927,
     /* 675217 */     GIR_EraseRootFromParent_Done,
     /* 675218 */   // Label 8654: @675218
     /* 675218 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(675315), // Rule ID 5935 //
     /* 675223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 675227 */     // MIs[0] offset
     /* 675227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675230 */     // MIs[0] auxiliary
     /* 675230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675233 */     // MIs[0] Operand 8
     /* 675233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 675236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675243 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 675246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 675250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 675255 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 675259 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 675262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 675266 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 675269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 675274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 675284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN_RTN),
     /* 675287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675289 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 675294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675301 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675303 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675313 */     GIR_RootConstrainSelectedInstOperands,
     /* 675314 */     // GIR_Coverage, 5935,
     /* 675314 */     GIR_EraseRootFromParent_Done,
     /* 675315 */   // Label 8655: @675315
     /* 675315 */   GIM_Reject,
     /* 675316 */ // Label 8639: @675316
     /* 675316 */ GIM_Reject,
     /* 675317 */ // Label 8637: @675317
     /* 675317 */ GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(676498),
     /* 675322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 675325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 675328 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 675331 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 675334 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 675337 */   GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(675405), // Rule ID 6128 //
     /* 675342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675345 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675355 */     // MIs[0] offset
     /* 675355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675358 */     // MIs[0] auxiliary
     /* 675358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675361 */     // MIs[0] Operand 8
     /* 675361 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675379 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET),
     /* 675382 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675391 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675393 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675403 */     GIR_RootConstrainSelectedInstOperands,
     /* 675404 */     // GIR_Coverage, 6128,
     /* 675404 */     GIR_EraseRootFromParent_Done,
     /* 675405 */   // Label 8657: @675405
     /* 675405 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(675470), // Rule ID 6136 //
     /* 675410 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675420 */     // MIs[0] offset
     /* 675420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675423 */     // MIs[0] auxiliary
     /* 675423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675426 */     // MIs[0] Operand 8
     /* 675426 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675444 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET),
     /* 675447 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675456 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675458 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675468 */     GIR_RootConstrainSelectedInstOperands,
     /* 675469 */     // GIR_Coverage, 6136,
     /* 675469 */     GIR_EraseRootFromParent_Done,
     /* 675470 */   // Label 8658: @675470
     /* 675470 */   GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(675542), // Rule ID 6124 //
     /* 675475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 675482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675490 */     // MIs[0] offset
     /* 675490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675493 */     // MIs[0] auxiliary
     /* 675493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675496 */     // MIs[0] Operand 8
     /* 675496 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675514 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN),
     /* 675517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675519 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675528 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675530 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675540 */     GIR_RootConstrainSelectedInstOperands,
     /* 675541 */     // GIR_Coverage, 6124,
     /* 675541 */     GIR_EraseRootFromParent_Done,
     /* 675542 */   // Label 8659: @675542
     /* 675542 */   GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(675611), // Rule ID 6132 //
     /* 675547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 675551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675559 */     // MIs[0] offset
     /* 675559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675562 */     // MIs[0] auxiliary
     /* 675562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675565 */     // MIs[0] Operand 8
     /* 675565 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675583 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN),
     /* 675586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675588 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675597 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675609 */     GIR_RootConstrainSelectedInstOperands,
     /* 675610 */     // GIR_Coverage, 6132,
     /* 675610 */     GIR_EraseRootFromParent_Done,
     /* 675611 */   // Label 8660: @675611
     /* 675611 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(675677), // Rule ID 6130 //
     /* 675616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675619 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675625 */     // MIs[0] offset
     /* 675625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675628 */     // MIs[0] auxiliary
     /* 675628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675631 */     // MIs[0] Operand 8
     /* 675631 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675649 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFEN),
     /* 675652 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675654 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 675656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675663 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675665 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675675 */     GIR_RootConstrainSelectedInstOperands,
     /* 675676 */     // GIR_Coverage, 6130,
     /* 675676 */     GIR_EraseRootFromParent_Done,
     /* 675677 */   // Label 8661: @675677
     /* 675677 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(675740), // Rule ID 6138 //
     /* 675682 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675688 */     // MIs[0] offset
     /* 675688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675691 */     // MIs[0] auxiliary
     /* 675691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675694 */     // MIs[0] Operand 8
     /* 675694 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675712 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN),
     /* 675715 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675717 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 675719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675726 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675728 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675738 */     GIR_RootConstrainSelectedInstOperands,
     /* 675739 */     // GIR_Coverage, 6138,
     /* 675739 */     GIR_EraseRootFromParent_Done,
     /* 675740 */   // Label 8662: @675740
     /* 675740 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(675810), // Rule ID 6126 //
     /* 675745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 675752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675756 */     // MIs[0] offset
     /* 675756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675759 */     // MIs[0] auxiliary
     /* 675759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675762 */     // MIs[0] Operand 8
     /* 675762 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675780 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFEN_RTN),
     /* 675783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675785 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675787 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 675789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675796 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675798 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675808 */     GIR_RootConstrainSelectedInstOperands,
     /* 675809 */     // GIR_Coverage, 6126,
     /* 675809 */     GIR_EraseRootFromParent_Done,
     /* 675810 */   // Label 8663: @675810
     /* 675810 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(675877), // Rule ID 6134 //
     /* 675815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 675819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675823 */     // MIs[0] offset
     /* 675823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675826 */     // MIs[0] auxiliary
     /* 675826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675829 */     // MIs[0] Operand 8
     /* 675829 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675847 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN_RTN),
     /* 675850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675852 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675854 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 675856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675863 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675865 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675875 */     GIR_RootConstrainSelectedInstOperands,
     /* 675876 */     // GIR_Coverage, 6134,
     /* 675876 */     GIR_EraseRootFromParent_Done,
     /* 675877 */   // Label 8664: @675877
     /* 675877 */   GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(675935), // Rule ID 6129 //
     /* 675882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675885 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675891 */     // MIs[0] offset
     /* 675891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675894 */     // MIs[0] auxiliary
     /* 675894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675897 */     // MIs[0] Operand 8
     /* 675897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 675900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675907 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_IDXEN),
     /* 675910 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675912 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 675914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675921 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675923 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675933 */     GIR_RootConstrainSelectedInstOperands,
     /* 675934 */     // GIR_Coverage, 6129,
     /* 675934 */     GIR_EraseRootFromParent_Done,
     /* 675935 */   // Label 8665: @675935
     /* 675935 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(675990), // Rule ID 6137 //
     /* 675940 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675946 */     // MIs[0] offset
     /* 675946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675949 */     // MIs[0] auxiliary
     /* 675949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675952 */     // MIs[0] Operand 8
     /* 675952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 675955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675962 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN),
     /* 675965 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675967 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 675969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675976 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675978 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675988 */     GIR_RootConstrainSelectedInstOperands,
     /* 675989 */     // GIR_Coverage, 6137,
     /* 675989 */     GIR_EraseRootFromParent_Done,
     /* 675990 */   // Label 8666: @675990
     /* 675990 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(676052), // Rule ID 6125 //
     /* 675995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 676002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676006 */     // MIs[0] offset
     /* 676006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676009 */     // MIs[0] auxiliary
     /* 676009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676012 */     // MIs[0] Operand 8
     /* 676012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676022 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_IDXEN_RTN),
     /* 676025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676027 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676029 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676038 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676040 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676050 */     GIR_RootConstrainSelectedInstOperands,
     /* 676051 */     // GIR_Coverage, 6125,
     /* 676051 */     GIR_EraseRootFromParent_Done,
     /* 676052 */   // Label 8667: @676052
     /* 676052 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(676111), // Rule ID 6133 //
     /* 676057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 676061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676065 */     // MIs[0] offset
     /* 676065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676068 */     // MIs[0] auxiliary
     /* 676068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676071 */     // MIs[0] Operand 8
     /* 676071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676081 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN_RTN),
     /* 676084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676086 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676088 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676097 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676099 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676109 */     GIR_RootConstrainSelectedInstOperands,
     /* 676110 */     // GIR_Coverage, 6133,
     /* 676110 */     GIR_EraseRootFromParent_Done,
     /* 676111 */   // Label 8668: @676111
     /* 676111 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(676207), // Rule ID 6131 //
     /* 676116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676119 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676121 */     // MIs[0] offset
     /* 676121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676124 */     // MIs[0] auxiliary
     /* 676124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676127 */     // MIs[0] Operand 8
     /* 676127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676137 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 676140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 676144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 676149 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 676153 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 676156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 676160 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 676163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 676168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_BOTHEN),
     /* 676181 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 676186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676193 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676195 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676205 */     GIR_RootConstrainSelectedInstOperands,
     /* 676206 */     // GIR_Coverage, 6131,
     /* 676206 */     GIR_EraseRootFromParent_Done,
     /* 676207 */   // Label 8669: @676207
     /* 676207 */   GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(676300), // Rule ID 6139 //
     /* 676212 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676214 */     // MIs[0] offset
     /* 676214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676217 */     // MIs[0] auxiliary
     /* 676217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676220 */     // MIs[0] Operand 8
     /* 676220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676230 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 676233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 676237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 676242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 676246 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 676249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 676253 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 676256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 676261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN),
     /* 676274 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 676279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676286 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676288 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676298 */     GIR_RootConstrainSelectedInstOperands,
     /* 676299 */     // GIR_Coverage, 6139,
     /* 676299 */     GIR_EraseRootFromParent_Done,
     /* 676300 */   // Label 8670: @676300
     /* 676300 */   GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(676400), // Rule ID 6127 //
     /* 676305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 676312 */     // MIs[0] offset
     /* 676312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676315 */     // MIs[0] auxiliary
     /* 676315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676318 */     // MIs[0] Operand 8
     /* 676318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676328 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 676331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 676335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 676340 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 676344 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 676347 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 676351 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 676354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 676359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_BOTHEN_RTN),
     /* 676372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676374 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 676379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676386 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676388 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676398 */     GIR_RootConstrainSelectedInstOperands,
     /* 676399 */     // GIR_Coverage, 6127,
     /* 676399 */     GIR_EraseRootFromParent_Done,
     /* 676400 */   // Label 8671: @676400
     /* 676400 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(676497), // Rule ID 6135 //
     /* 676405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 676409 */     // MIs[0] offset
     /* 676409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676412 */     // MIs[0] auxiliary
     /* 676412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676415 */     // MIs[0] Operand 8
     /* 676415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676425 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 676428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 676432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 676437 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 676441 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 676444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 676448 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 676451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 676456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN_RTN),
     /* 676469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676471 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 676476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676483 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676485 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676495 */     GIR_RootConstrainSelectedInstOperands,
     /* 676496 */     // GIR_Coverage, 6135,
     /* 676496 */     GIR_EraseRootFromParent_Done,
     /* 676497 */   // Label 8672: @676497
     /* 676497 */   GIM_Reject,
     /* 676498 */ // Label 8656: @676498
     /* 676498 */ GIM_Reject,
     /* 676499 */ // Label 8638: @676499
     /* 676499 */ GIM_Reject,
     /* 676500 */ // Label 123: @676500
     /* 676500 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8675*/ GIMT_Encode4(678883),
     /* 676511 */ /*GILLT_s32*//*Label 8673*/ GIMT_Encode4(676519),
     /* 676515 */ /*GILLT_s64*//*Label 8674*/ GIMT_Encode4(677701),
     /* 676519 */ // Label 8673: @676519
     /* 676519 */ GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(677700),
     /* 676524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 676527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 676530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 676533 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 676536 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 676539 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(676607), // Rule ID 5896 //
     /* 676544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676547 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 676553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676557 */     // MIs[0] offset
     /* 676557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676560 */     // MIs[0] auxiliary
     /* 676560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676563 */     // MIs[0] Operand 8
     /* 676563 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 676574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676581 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET),
     /* 676584 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676593 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676595 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676605 */     GIR_RootConstrainSelectedInstOperands,
     /* 676606 */     // GIR_Coverage, 5896,
     /* 676606 */     GIR_EraseRootFromParent_Done,
     /* 676607 */   // Label 8677: @676607
     /* 676607 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(676672), // Rule ID 5904 //
     /* 676612 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 676618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676622 */     // MIs[0] offset
     /* 676622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676625 */     // MIs[0] auxiliary
     /* 676625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676628 */     // MIs[0] Operand 8
     /* 676628 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 676639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676646 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET),
     /* 676649 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676658 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676660 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676670 */     GIR_RootConstrainSelectedInstOperands,
     /* 676671 */     // GIR_Coverage, 5904,
     /* 676671 */     GIR_EraseRootFromParent_Done,
     /* 676672 */   // Label 8678: @676672
     /* 676672 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(676744), // Rule ID 5892 //
     /* 676677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 676684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 676688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676692 */     // MIs[0] offset
     /* 676692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676695 */     // MIs[0] auxiliary
     /* 676695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676698 */     // MIs[0] Operand 8
     /* 676698 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 676709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676716 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET_RTN),
     /* 676719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676721 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676730 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676732 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676742 */     GIR_RootConstrainSelectedInstOperands,
     /* 676743 */     // GIR_Coverage, 5892,
     /* 676743 */     GIR_EraseRootFromParent_Done,
     /* 676744 */   // Label 8679: @676744
     /* 676744 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(676813), // Rule ID 5900 //
     /* 676749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 676753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 676757 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676761 */     // MIs[0] offset
     /* 676761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676764 */     // MIs[0] auxiliary
     /* 676764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676767 */     // MIs[0] Operand 8
     /* 676767 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 676778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676785 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN),
     /* 676788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676790 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676799 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676801 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676811 */     GIR_RootConstrainSelectedInstOperands,
     /* 676812 */     // GIR_Coverage, 5900,
     /* 676812 */     GIR_EraseRootFromParent_Done,
     /* 676813 */   // Label 8680: @676813
     /* 676813 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(676879), // Rule ID 5898 //
     /* 676818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676821 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 676827 */     // MIs[0] offset
     /* 676827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676830 */     // MIs[0] auxiliary
     /* 676830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676833 */     // MIs[0] Operand 8
     /* 676833 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 676844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676851 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFEN),
     /* 676854 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676856 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 676858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676865 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676867 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676877 */     GIR_RootConstrainSelectedInstOperands,
     /* 676878 */     // GIR_Coverage, 5898,
     /* 676878 */     GIR_EraseRootFromParent_Done,
     /* 676879 */   // Label 8681: @676879
     /* 676879 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(676942), // Rule ID 5906 //
     /* 676884 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 676890 */     // MIs[0] offset
     /* 676890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676893 */     // MIs[0] auxiliary
     /* 676893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676896 */     // MIs[0] Operand 8
     /* 676896 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 676907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676914 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN),
     /* 676917 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676919 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 676921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676928 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676930 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676940 */     GIR_RootConstrainSelectedInstOperands,
     /* 676941 */     // GIR_Coverage, 5906,
     /* 676941 */     GIR_EraseRootFromParent_Done,
     /* 676942 */   // Label 8682: @676942
     /* 676942 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(677012), // Rule ID 5894 //
     /* 676947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 676954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 676958 */     // MIs[0] offset
     /* 676958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676961 */     // MIs[0] auxiliary
     /* 676961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676964 */     // MIs[0] Operand 8
     /* 676964 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 676975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676982 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFEN_RTN),
     /* 676985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676987 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676989 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 676991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676998 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677000 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677010 */     GIR_RootConstrainSelectedInstOperands,
     /* 677011 */     // GIR_Coverage, 5894,
     /* 677011 */     GIR_EraseRootFromParent_Done,
     /* 677012 */   // Label 8683: @677012
     /* 677012 */   GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(677079), // Rule ID 5902 //
     /* 677017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677025 */     // MIs[0] offset
     /* 677025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677028 */     // MIs[0] auxiliary
     /* 677028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677031 */     // MIs[0] Operand 8
     /* 677031 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677049 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN_RTN),
     /* 677052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677054 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677056 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 677058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677065 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677067 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677077 */     GIR_RootConstrainSelectedInstOperands,
     /* 677078 */     // GIR_Coverage, 5902,
     /* 677078 */     GIR_EraseRootFromParent_Done,
     /* 677079 */   // Label 8684: @677079
     /* 677079 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(677137), // Rule ID 5897 //
     /* 677084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677087 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677093 */     // MIs[0] offset
     /* 677093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677096 */     // MIs[0] auxiliary
     /* 677096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677099 */     // MIs[0] Operand 8
     /* 677099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677109 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_IDXEN),
     /* 677112 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677114 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 677116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677123 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677125 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677135 */     GIR_RootConstrainSelectedInstOperands,
     /* 677136 */     // GIR_Coverage, 5897,
     /* 677136 */     GIR_EraseRootFromParent_Done,
     /* 677137 */   // Label 8685: @677137
     /* 677137 */   GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(677192), // Rule ID 5905 //
     /* 677142 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677148 */     // MIs[0] offset
     /* 677148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677151 */     // MIs[0] auxiliary
     /* 677151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677154 */     // MIs[0] Operand 8
     /* 677154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677164 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN),
     /* 677167 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677169 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 677171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677178 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677180 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677190 */     GIR_RootConstrainSelectedInstOperands,
     /* 677191 */     // GIR_Coverage, 5905,
     /* 677191 */     GIR_EraseRootFromParent_Done,
     /* 677192 */   // Label 8686: @677192
     /* 677192 */   GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(677254), // Rule ID 5893 //
     /* 677197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677208 */     // MIs[0] offset
     /* 677208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677211 */     // MIs[0] auxiliary
     /* 677211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677214 */     // MIs[0] Operand 8
     /* 677214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677224 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_IDXEN_RTN),
     /* 677227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677229 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677231 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 677233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677240 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677242 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677252 */     GIR_RootConstrainSelectedInstOperands,
     /* 677253 */     // GIR_Coverage, 5893,
     /* 677253 */     GIR_EraseRootFromParent_Done,
     /* 677254 */   // Label 8687: @677254
     /* 677254 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(677313), // Rule ID 5901 //
     /* 677259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677267 */     // MIs[0] offset
     /* 677267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677270 */     // MIs[0] auxiliary
     /* 677270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677273 */     // MIs[0] Operand 8
     /* 677273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677283 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN_RTN),
     /* 677286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677288 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677290 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 677292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677299 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677301 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677311 */     GIR_RootConstrainSelectedInstOperands,
     /* 677312 */     // GIR_Coverage, 5901,
     /* 677312 */     GIR_EraseRootFromParent_Done,
     /* 677313 */   // Label 8688: @677313
     /* 677313 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(677409), // Rule ID 5899 //
     /* 677318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677321 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677323 */     // MIs[0] offset
     /* 677323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677326 */     // MIs[0] auxiliary
     /* 677326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677329 */     // MIs[0] Operand 8
     /* 677329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677339 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 677342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 677346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 677351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 677355 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 677358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 677362 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 677365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 677370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_BOTHEN),
     /* 677383 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 677388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677395 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677397 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677407 */     GIR_RootConstrainSelectedInstOperands,
     /* 677408 */     // GIR_Coverage, 5899,
     /* 677408 */     GIR_EraseRootFromParent_Done,
     /* 677409 */   // Label 8689: @677409
     /* 677409 */   GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(677502), // Rule ID 5907 //
     /* 677414 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677416 */     // MIs[0] offset
     /* 677416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677419 */     // MIs[0] auxiliary
     /* 677419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677422 */     // MIs[0] Operand 8
     /* 677422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677432 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 677435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 677439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 677444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 677448 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 677451 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 677455 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 677458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 677463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN),
     /* 677476 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 677481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677488 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677490 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677500 */     GIR_RootConstrainSelectedInstOperands,
     /* 677501 */     // GIR_Coverage, 5907,
     /* 677501 */     GIR_EraseRootFromParent_Done,
     /* 677502 */   // Label 8690: @677502
     /* 677502 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(677602), // Rule ID 5895 //
     /* 677507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677514 */     // MIs[0] offset
     /* 677514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677517 */     // MIs[0] auxiliary
     /* 677517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677520 */     // MIs[0] Operand 8
     /* 677520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677530 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 677533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 677537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 677542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 677546 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 677549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 677553 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 677556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 677561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_BOTHEN_RTN),
     /* 677574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677576 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 677581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677588 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677590 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677600 */     GIR_RootConstrainSelectedInstOperands,
     /* 677601 */     // GIR_Coverage, 5895,
     /* 677601 */     GIR_EraseRootFromParent_Done,
     /* 677602 */   // Label 8691: @677602
     /* 677602 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(677699), // Rule ID 5903 //
     /* 677607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677611 */     // MIs[0] offset
     /* 677611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677614 */     // MIs[0] auxiliary
     /* 677614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677617 */     // MIs[0] Operand 8
     /* 677617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677627 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 677630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 677634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 677639 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 677643 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 677646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 677650 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 677653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 677658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN_RTN),
     /* 677671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677673 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 677678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677685 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677687 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677697 */     GIR_RootConstrainSelectedInstOperands,
     /* 677698 */     // GIR_Coverage, 5903,
     /* 677698 */     GIR_EraseRootFromParent_Done,
     /* 677699 */   // Label 8692: @677699
     /* 677699 */   GIM_Reject,
     /* 677700 */ // Label 8676: @677700
     /* 677700 */ GIM_Reject,
     /* 677701 */ // Label 8674: @677701
     /* 677701 */ GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(678882),
     /* 677706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 677709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 677712 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 677715 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 677718 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 677721 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(677789), // Rule ID 6096 //
     /* 677726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677729 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677739 */     // MIs[0] offset
     /* 677739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677742 */     // MIs[0] auxiliary
     /* 677742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677745 */     // MIs[0] Operand 8
     /* 677745 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677763 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET),
     /* 677766 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677775 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677787 */     GIR_RootConstrainSelectedInstOperands,
     /* 677788 */     // GIR_Coverage, 6096,
     /* 677788 */     GIR_EraseRootFromParent_Done,
     /* 677789 */   // Label 8694: @677789
     /* 677789 */   GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(677854), // Rule ID 6104 //
     /* 677794 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677804 */     // MIs[0] offset
     /* 677804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677807 */     // MIs[0] auxiliary
     /* 677807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677810 */     // MIs[0] Operand 8
     /* 677810 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677828 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET),
     /* 677831 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677840 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677842 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677852 */     GIR_RootConstrainSelectedInstOperands,
     /* 677853 */     // GIR_Coverage, 6104,
     /* 677853 */     GIR_EraseRootFromParent_Done,
     /* 677854 */   // Label 8695: @677854
     /* 677854 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(677926), // Rule ID 6092 //
     /* 677859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 677866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677874 */     // MIs[0] offset
     /* 677874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677877 */     // MIs[0] auxiliary
     /* 677877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677880 */     // MIs[0] Operand 8
     /* 677880 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677898 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN),
     /* 677901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677903 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677912 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677914 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677924 */     GIR_RootConstrainSelectedInstOperands,
     /* 677925 */     // GIR_Coverage, 6092,
     /* 677925 */     GIR_EraseRootFromParent_Done,
     /* 677926 */   // Label 8696: @677926
     /* 677926 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(677995), // Rule ID 6100 //
     /* 677931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 677935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677943 */     // MIs[0] offset
     /* 677943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677946 */     // MIs[0] auxiliary
     /* 677946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677949 */     // MIs[0] Operand 8
     /* 677949 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677967 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN),
     /* 677970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677972 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677981 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677983 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677993 */     GIR_RootConstrainSelectedInstOperands,
     /* 677994 */     // GIR_Coverage, 6100,
     /* 677994 */     GIR_EraseRootFromParent_Done,
     /* 677995 */   // Label 8697: @677995
     /* 677995 */   GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(678061), // Rule ID 6098 //
     /* 678000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678003 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678009 */     // MIs[0] offset
     /* 678009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678012 */     // MIs[0] auxiliary
     /* 678012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678015 */     // MIs[0] Operand 8
     /* 678015 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678033 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFEN),
     /* 678036 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678038 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 678040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678047 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678049 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678059 */     GIR_RootConstrainSelectedInstOperands,
     /* 678060 */     // GIR_Coverage, 6098,
     /* 678060 */     GIR_EraseRootFromParent_Done,
     /* 678061 */   // Label 8698: @678061
     /* 678061 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(678124), // Rule ID 6106 //
     /* 678066 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678072 */     // MIs[0] offset
     /* 678072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678075 */     // MIs[0] auxiliary
     /* 678075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678078 */     // MIs[0] Operand 8
     /* 678078 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678096 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN),
     /* 678099 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678101 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 678103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678110 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678112 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678122 */     GIR_RootConstrainSelectedInstOperands,
     /* 678123 */     // GIR_Coverage, 6106,
     /* 678123 */     GIR_EraseRootFromParent_Done,
     /* 678124 */   // Label 8699: @678124
     /* 678124 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(678194), // Rule ID 6094 //
     /* 678129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678140 */     // MIs[0] offset
     /* 678140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678143 */     // MIs[0] auxiliary
     /* 678143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678146 */     // MIs[0] Operand 8
     /* 678146 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678164 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFEN_RTN),
     /* 678167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678169 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678171 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 678173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678180 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678182 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678192 */     GIR_RootConstrainSelectedInstOperands,
     /* 678193 */     // GIR_Coverage, 6094,
     /* 678193 */     GIR_EraseRootFromParent_Done,
     /* 678194 */   // Label 8700: @678194
     /* 678194 */   GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(678261), // Rule ID 6102 //
     /* 678199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678207 */     // MIs[0] offset
     /* 678207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678210 */     // MIs[0] auxiliary
     /* 678210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678213 */     // MIs[0] Operand 8
     /* 678213 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678231 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN_RTN),
     /* 678234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678236 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678238 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 678240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678247 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678249 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678259 */     GIR_RootConstrainSelectedInstOperands,
     /* 678260 */     // GIR_Coverage, 6102,
     /* 678260 */     GIR_EraseRootFromParent_Done,
     /* 678261 */   // Label 8701: @678261
     /* 678261 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(678319), // Rule ID 6097 //
     /* 678266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678269 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678275 */     // MIs[0] offset
     /* 678275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678278 */     // MIs[0] auxiliary
     /* 678278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678281 */     // MIs[0] Operand 8
     /* 678281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678291 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_IDXEN),
     /* 678294 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678296 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 678298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678305 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678307 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678317 */     GIR_RootConstrainSelectedInstOperands,
     /* 678318 */     // GIR_Coverage, 6097,
     /* 678318 */     GIR_EraseRootFromParent_Done,
     /* 678319 */   // Label 8702: @678319
     /* 678319 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(678374), // Rule ID 6105 //
     /* 678324 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678330 */     // MIs[0] offset
     /* 678330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678333 */     // MIs[0] auxiliary
     /* 678333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678336 */     // MIs[0] Operand 8
     /* 678336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678346 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN),
     /* 678349 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678351 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 678353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678360 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678372 */     GIR_RootConstrainSelectedInstOperands,
     /* 678373 */     // GIR_Coverage, 6105,
     /* 678373 */     GIR_EraseRootFromParent_Done,
     /* 678374 */   // Label 8703: @678374
     /* 678374 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(678436), // Rule ID 6093 //
     /* 678379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678390 */     // MIs[0] offset
     /* 678390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678393 */     // MIs[0] auxiliary
     /* 678393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678396 */     // MIs[0] Operand 8
     /* 678396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678406 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_IDXEN_RTN),
     /* 678409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678411 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678413 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 678415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678422 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678434 */     GIR_RootConstrainSelectedInstOperands,
     /* 678435 */     // GIR_Coverage, 6093,
     /* 678435 */     GIR_EraseRootFromParent_Done,
     /* 678436 */   // Label 8704: @678436
     /* 678436 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(678495), // Rule ID 6101 //
     /* 678441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678449 */     // MIs[0] offset
     /* 678449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678452 */     // MIs[0] auxiliary
     /* 678452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678455 */     // MIs[0] Operand 8
     /* 678455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678465 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN_RTN),
     /* 678468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678470 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678472 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 678474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678481 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678483 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678493 */     GIR_RootConstrainSelectedInstOperands,
     /* 678494 */     // GIR_Coverage, 6101,
     /* 678494 */     GIR_EraseRootFromParent_Done,
     /* 678495 */   // Label 8705: @678495
     /* 678495 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(678591), // Rule ID 6099 //
     /* 678500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678503 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678505 */     // MIs[0] offset
     /* 678505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678508 */     // MIs[0] auxiliary
     /* 678508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678511 */     // MIs[0] Operand 8
     /* 678511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678521 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 678524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 678528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 678533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 678537 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 678540 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 678544 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 678547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 678552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_BOTHEN),
     /* 678565 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 678570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678577 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678579 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678589 */     GIR_RootConstrainSelectedInstOperands,
     /* 678590 */     // GIR_Coverage, 6099,
     /* 678590 */     GIR_EraseRootFromParent_Done,
     /* 678591 */   // Label 8706: @678591
     /* 678591 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(678684), // Rule ID 6107 //
     /* 678596 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678598 */     // MIs[0] offset
     /* 678598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678601 */     // MIs[0] auxiliary
     /* 678601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678604 */     // MIs[0] Operand 8
     /* 678604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678614 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 678617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 678621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 678626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 678630 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 678633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 678637 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 678640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 678645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN),
     /* 678658 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 678663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678670 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678672 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678682 */     GIR_RootConstrainSelectedInstOperands,
     /* 678683 */     // GIR_Coverage, 6107,
     /* 678683 */     GIR_EraseRootFromParent_Done,
     /* 678684 */   // Label 8707: @678684
     /* 678684 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(678784), // Rule ID 6095 //
     /* 678689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678696 */     // MIs[0] offset
     /* 678696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678699 */     // MIs[0] auxiliary
     /* 678699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678702 */     // MIs[0] Operand 8
     /* 678702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678712 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 678715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 678719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 678724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 678728 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 678731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 678735 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 678738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 678743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_BOTHEN_RTN),
     /* 678756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678758 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 678763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678770 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678772 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678782 */     GIR_RootConstrainSelectedInstOperands,
     /* 678783 */     // GIR_Coverage, 6095,
     /* 678783 */     GIR_EraseRootFromParent_Done,
     /* 678784 */   // Label 8708: @678784
     /* 678784 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(678881), // Rule ID 6103 //
     /* 678789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678793 */     // MIs[0] offset
     /* 678793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678796 */     // MIs[0] auxiliary
     /* 678796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678799 */     // MIs[0] Operand 8
     /* 678799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678809 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 678812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 678816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 678821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 678825 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 678828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 678832 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 678835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 678840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN_RTN),
     /* 678853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678855 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 678860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678867 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678869 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678879 */     GIR_RootConstrainSelectedInstOperands,
     /* 678880 */     // GIR_Coverage, 6103,
     /* 678880 */     GIR_EraseRootFromParent_Done,
     /* 678881 */   // Label 8709: @678881
     /* 678881 */   GIM_Reject,
     /* 678882 */ // Label 8693: @678882
     /* 678882 */ GIM_Reject,
     /* 678883 */ // Label 8675: @678883
     /* 678883 */ GIM_Reject,
     /* 678884 */ // Label 124: @678884
     /* 678884 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8712*/ GIMT_Encode4(681267),
     /* 678895 */ /*GILLT_s32*//*Label 8710*/ GIMT_Encode4(678903),
     /* 678899 */ /*GILLT_s64*//*Label 8711*/ GIMT_Encode4(680085),
     /* 678903 */ // Label 8710: @678903
     /* 678903 */ GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(680084),
     /* 678908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 678911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 678914 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 678917 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 678920 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 678923 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(678991), // Rule ID 5976 //
     /* 678928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678931 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678941 */     // MIs[0] offset
     /* 678941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678944 */     // MIs[0] auxiliary
     /* 678944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678947 */     // MIs[0] Operand 8
     /* 678947 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678965 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET),
     /* 678968 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678977 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678979 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678989 */     GIR_RootConstrainSelectedInstOperands,
     /* 678990 */     // GIR_Coverage, 5976,
     /* 678990 */     GIR_EraseRootFromParent_Done,
     /* 678991 */   // Label 8714: @678991
     /* 678991 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(679056), // Rule ID 5984 //
     /* 678996 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679006 */     // MIs[0] offset
     /* 679006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679009 */     // MIs[0] auxiliary
     /* 679009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679012 */     // MIs[0] Operand 8
     /* 679012 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679030 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET),
     /* 679033 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679042 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679044 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679054 */     GIR_RootConstrainSelectedInstOperands,
     /* 679055 */     // GIR_Coverage, 5984,
     /* 679055 */     GIR_EraseRootFromParent_Done,
     /* 679056 */   // Label 8715: @679056
     /* 679056 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(679128), // Rule ID 5972 //
     /* 679061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679076 */     // MIs[0] offset
     /* 679076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679079 */     // MIs[0] auxiliary
     /* 679079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679082 */     // MIs[0] Operand 8
     /* 679082 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679100 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET_RTN),
     /* 679103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679105 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679114 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679116 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679126 */     GIR_RootConstrainSelectedInstOperands,
     /* 679127 */     // GIR_Coverage, 5972,
     /* 679127 */     GIR_EraseRootFromParent_Done,
     /* 679128 */   // Label 8716: @679128
     /* 679128 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(679197), // Rule ID 5980 //
     /* 679133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679145 */     // MIs[0] offset
     /* 679145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679148 */     // MIs[0] auxiliary
     /* 679148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679151 */     // MIs[0] Operand 8
     /* 679151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679169 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN),
     /* 679172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679174 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679183 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679185 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679195 */     GIR_RootConstrainSelectedInstOperands,
     /* 679196 */     // GIR_Coverage, 5980,
     /* 679196 */     GIR_EraseRootFromParent_Done,
     /* 679197 */   // Label 8717: @679197
     /* 679197 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(679263), // Rule ID 5978 //
     /* 679202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679205 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679211 */     // MIs[0] offset
     /* 679211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679214 */     // MIs[0] auxiliary
     /* 679214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679217 */     // MIs[0] Operand 8
     /* 679217 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679235 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFEN),
     /* 679238 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679240 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 679242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679249 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679251 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679261 */     GIR_RootConstrainSelectedInstOperands,
     /* 679262 */     // GIR_Coverage, 5978,
     /* 679262 */     GIR_EraseRootFromParent_Done,
     /* 679263 */   // Label 8718: @679263
     /* 679263 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(679326), // Rule ID 5986 //
     /* 679268 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679274 */     // MIs[0] offset
     /* 679274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679277 */     // MIs[0] auxiliary
     /* 679277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679280 */     // MIs[0] Operand 8
     /* 679280 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679298 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFEN),
     /* 679301 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679303 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 679305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679312 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679314 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679324 */     GIR_RootConstrainSelectedInstOperands,
     /* 679325 */     // GIR_Coverage, 5986,
     /* 679325 */     GIR_EraseRootFromParent_Done,
     /* 679326 */   // Label 8719: @679326
     /* 679326 */   GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(679396), // Rule ID 5974 //
     /* 679331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679342 */     // MIs[0] offset
     /* 679342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679345 */     // MIs[0] auxiliary
     /* 679345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679348 */     // MIs[0] Operand 8
     /* 679348 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679366 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFEN_RTN),
     /* 679369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679371 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679373 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 679375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679382 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679384 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679394 */     GIR_RootConstrainSelectedInstOperands,
     /* 679395 */     // GIR_Coverage, 5974,
     /* 679395 */     GIR_EraseRootFromParent_Done,
     /* 679396 */   // Label 8720: @679396
     /* 679396 */   GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(679463), // Rule ID 5982 //
     /* 679401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679409 */     // MIs[0] offset
     /* 679409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679412 */     // MIs[0] auxiliary
     /* 679412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679415 */     // MIs[0] Operand 8
     /* 679415 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679433 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFEN_RTN),
     /* 679436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679438 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679440 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 679442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679449 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679451 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679461 */     GIR_RootConstrainSelectedInstOperands,
     /* 679462 */     // GIR_Coverage, 5982,
     /* 679462 */     GIR_EraseRootFromParent_Done,
     /* 679463 */   // Label 8721: @679463
     /* 679463 */   GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(679521), // Rule ID 5977 //
     /* 679468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679471 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679477 */     // MIs[0] offset
     /* 679477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679480 */     // MIs[0] auxiliary
     /* 679480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679483 */     // MIs[0] Operand 8
     /* 679483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679493 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_IDXEN),
     /* 679496 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679498 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 679500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679507 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679509 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679519 */     GIR_RootConstrainSelectedInstOperands,
     /* 679520 */     // GIR_Coverage, 5977,
     /* 679520 */     GIR_EraseRootFromParent_Done,
     /* 679521 */   // Label 8722: @679521
     /* 679521 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(679576), // Rule ID 5985 //
     /* 679526 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679532 */     // MIs[0] offset
     /* 679532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679535 */     // MIs[0] auxiliary
     /* 679535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679538 */     // MIs[0] Operand 8
     /* 679538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679548 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_IDXEN anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_IDXEN),
     /* 679551 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679553 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 679555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679562 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679574 */     GIR_RootConstrainSelectedInstOperands,
     /* 679575 */     // GIR_Coverage, 5985,
     /* 679575 */     GIR_EraseRootFromParent_Done,
     /* 679576 */   // Label 8723: @679576
     /* 679576 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(679638), // Rule ID 5973 //
     /* 679581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679592 */     // MIs[0] offset
     /* 679592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679595 */     // MIs[0] auxiliary
     /* 679595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679598 */     // MIs[0] Operand 8
     /* 679598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679608 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_IDXEN_RTN),
     /* 679611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679613 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679615 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 679617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679624 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679626 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679636 */     GIR_RootConstrainSelectedInstOperands,
     /* 679637 */     // GIR_Coverage, 5973,
     /* 679637 */     GIR_EraseRootFromParent_Done,
     /* 679638 */   // Label 8724: @679638
     /* 679638 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(679697), // Rule ID 5981 //
     /* 679643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679651 */     // MIs[0] offset
     /* 679651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679654 */     // MIs[0] auxiliary
     /* 679654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679657 */     // MIs[0] Operand 8
     /* 679657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679667 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_IDXEN_RTN),
     /* 679670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679672 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679674 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 679676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679683 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679685 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679695 */     GIR_RootConstrainSelectedInstOperands,
     /* 679696 */     // GIR_Coverage, 5981,
     /* 679696 */     GIR_EraseRootFromParent_Done,
     /* 679697 */   // Label 8725: @679697
     /* 679697 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(679793), // Rule ID 5979 //
     /* 679702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679705 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679707 */     // MIs[0] offset
     /* 679707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679710 */     // MIs[0] auxiliary
     /* 679710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679713 */     // MIs[0] Operand 8
     /* 679713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679723 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 679726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 679730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 679735 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 679739 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 679742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 679746 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 679749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 679754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_BOTHEN),
     /* 679767 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 679772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679779 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679781 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679791 */     GIR_RootConstrainSelectedInstOperands,
     /* 679792 */     // GIR_Coverage, 5979,
     /* 679792 */     GIR_EraseRootFromParent_Done,
     /* 679793 */   // Label 8726: @679793
     /* 679793 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(679886), // Rule ID 5987 //
     /* 679798 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679800 */     // MIs[0] offset
     /* 679800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679803 */     // MIs[0] auxiliary
     /* 679803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679806 */     // MIs[0] Operand 8
     /* 679806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679816 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 679819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 679823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 679828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 679832 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 679835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 679839 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 679842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 679847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN),
     /* 679860 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 679865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679872 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679874 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679884 */     GIR_RootConstrainSelectedInstOperands,
     /* 679885 */     // GIR_Coverage, 5987,
     /* 679885 */     GIR_EraseRootFromParent_Done,
     /* 679886 */   // Label 8727: @679886
     /* 679886 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(679986), // Rule ID 5975 //
     /* 679891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679898 */     // MIs[0] offset
     /* 679898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679901 */     // MIs[0] auxiliary
     /* 679901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679904 */     // MIs[0] Operand 8
     /* 679904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679914 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 679917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 679921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 679926 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 679930 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 679933 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 679937 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 679940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 679945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_BOTHEN_RTN),
     /* 679958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679960 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 679965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679972 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679974 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679984 */     GIR_RootConstrainSelectedInstOperands,
     /* 679985 */     // GIR_Coverage, 5975,
     /* 679985 */     GIR_EraseRootFromParent_Done,
     /* 679986 */   // Label 8728: @679986
     /* 679986 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(680083), // Rule ID 5983 //
     /* 679991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679995 */     // MIs[0] offset
     /* 679995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679998 */     // MIs[0] auxiliary
     /* 679998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680001 */     // MIs[0] Operand 8
     /* 680001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680011 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9820:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 680014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 680018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 680023 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 680027 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 680030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 680034 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 680037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 680042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN_RTN),
     /* 680055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680057 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 680062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680069 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680071 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680081 */     GIR_RootConstrainSelectedInstOperands,
     /* 680082 */     // GIR_Coverage, 5983,
     /* 680082 */     GIR_EraseRootFromParent_Done,
     /* 680083 */   // Label 8729: @680083
     /* 680083 */   GIM_Reject,
     /* 680084 */ // Label 8713: @680084
     /* 680084 */ GIM_Reject,
     /* 680085 */ // Label 8711: @680085
     /* 680085 */ GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(681266),
     /* 680090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 680093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 680096 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 680099 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 680102 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 680105 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(680173), // Rule ID 6176 //
     /* 680110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680113 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680115 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680123 */     // MIs[0] offset
     /* 680123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680126 */     // MIs[0] auxiliary
     /* 680126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680129 */     // MIs[0] Operand 8
     /* 680129 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680147 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET),
     /* 680150 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680159 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680161 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680171 */     GIR_RootConstrainSelectedInstOperands,
     /* 680172 */     // GIR_Coverage, 6176,
     /* 680172 */     GIR_EraseRootFromParent_Done,
     /* 680173 */   // Label 8731: @680173
     /* 680173 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(680238), // Rule ID 6184 //
     /* 680178 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680188 */     // MIs[0] offset
     /* 680188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680191 */     // MIs[0] auxiliary
     /* 680191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680194 */     // MIs[0] Operand 8
     /* 680194 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680212 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET),
     /* 680215 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680224 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680226 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680236 */     GIR_RootConstrainSelectedInstOperands,
     /* 680237 */     // GIR_Coverage, 6184,
     /* 680237 */     GIR_EraseRootFromParent_Done,
     /* 680238 */   // Label 8732: @680238
     /* 680238 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(680310), // Rule ID 6172 //
     /* 680243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680258 */     // MIs[0] offset
     /* 680258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680261 */     // MIs[0] auxiliary
     /* 680261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680264 */     // MIs[0] Operand 8
     /* 680264 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680282 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET_RTN),
     /* 680285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680287 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680296 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680298 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680308 */     GIR_RootConstrainSelectedInstOperands,
     /* 680309 */     // GIR_Coverage, 6172,
     /* 680309 */     GIR_EraseRootFromParent_Done,
     /* 680310 */   // Label 8733: @680310
     /* 680310 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(680379), // Rule ID 6180 //
     /* 680315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680327 */     // MIs[0] offset
     /* 680327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680330 */     // MIs[0] auxiliary
     /* 680330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680333 */     // MIs[0] Operand 8
     /* 680333 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680351 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN),
     /* 680354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680356 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680365 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680367 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680377 */     GIR_RootConstrainSelectedInstOperands,
     /* 680378 */     // GIR_Coverage, 6180,
     /* 680378 */     GIR_EraseRootFromParent_Done,
     /* 680379 */   // Label 8734: @680379
     /* 680379 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(680445), // Rule ID 6178 //
     /* 680384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680387 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680393 */     // MIs[0] offset
     /* 680393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680396 */     // MIs[0] auxiliary
     /* 680396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680399 */     // MIs[0] Operand 8
     /* 680399 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680417 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFEN),
     /* 680420 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680422 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 680424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680431 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680433 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680443 */     GIR_RootConstrainSelectedInstOperands,
     /* 680444 */     // GIR_Coverage, 6178,
     /* 680444 */     GIR_EraseRootFromParent_Done,
     /* 680445 */   // Label 8735: @680445
     /* 680445 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(680508), // Rule ID 6186 //
     /* 680450 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680456 */     // MIs[0] offset
     /* 680456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680459 */     // MIs[0] auxiliary
     /* 680459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680462 */     // MIs[0] Operand 8
     /* 680462 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680480 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN),
     /* 680483 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680485 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 680487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680494 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680496 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680506 */     GIR_RootConstrainSelectedInstOperands,
     /* 680507 */     // GIR_Coverage, 6186,
     /* 680507 */     GIR_EraseRootFromParent_Done,
     /* 680508 */   // Label 8736: @680508
     /* 680508 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(680578), // Rule ID 6174 //
     /* 680513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680524 */     // MIs[0] offset
     /* 680524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680527 */     // MIs[0] auxiliary
     /* 680527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680530 */     // MIs[0] Operand 8
     /* 680530 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680548 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFEN_RTN),
     /* 680551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680553 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680555 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 680557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680564 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680566 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680576 */     GIR_RootConstrainSelectedInstOperands,
     /* 680577 */     // GIR_Coverage, 6174,
     /* 680577 */     GIR_EraseRootFromParent_Done,
     /* 680578 */   // Label 8737: @680578
     /* 680578 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(680645), // Rule ID 6182 //
     /* 680583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680591 */     // MIs[0] offset
     /* 680591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680594 */     // MIs[0] auxiliary
     /* 680594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680597 */     // MIs[0] Operand 8
     /* 680597 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680615 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN_RTN),
     /* 680618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680620 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680622 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 680624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680631 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680643 */     GIR_RootConstrainSelectedInstOperands,
     /* 680644 */     // GIR_Coverage, 6182,
     /* 680644 */     GIR_EraseRootFromParent_Done,
     /* 680645 */   // Label 8738: @680645
     /* 680645 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(680703), // Rule ID 6177 //
     /* 680650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680653 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680659 */     // MIs[0] offset
     /* 680659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680662 */     // MIs[0] auxiliary
     /* 680662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680665 */     // MIs[0] Operand 8
     /* 680665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680675 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_IDXEN),
     /* 680678 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680680 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 680682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680689 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680691 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680701 */     GIR_RootConstrainSelectedInstOperands,
     /* 680702 */     // GIR_Coverage, 6177,
     /* 680702 */     GIR_EraseRootFromParent_Done,
     /* 680703 */   // Label 8739: @680703
     /* 680703 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(680758), // Rule ID 6185 //
     /* 680708 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680714 */     // MIs[0] offset
     /* 680714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680717 */     // MIs[0] auxiliary
     /* 680717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680720 */     // MIs[0] Operand 8
     /* 680720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680730 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN),
     /* 680733 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680735 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 680737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680744 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680746 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680756 */     GIR_RootConstrainSelectedInstOperands,
     /* 680757 */     // GIR_Coverage, 6185,
     /* 680757 */     GIR_EraseRootFromParent_Done,
     /* 680758 */   // Label 8740: @680758
     /* 680758 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(680820), // Rule ID 6173 //
     /* 680763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680774 */     // MIs[0] offset
     /* 680774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680777 */     // MIs[0] auxiliary
     /* 680777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680780 */     // MIs[0] Operand 8
     /* 680780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680790 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_IDXEN_RTN),
     /* 680793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680795 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680797 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 680799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680806 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680818 */     GIR_RootConstrainSelectedInstOperands,
     /* 680819 */     // GIR_Coverage, 6173,
     /* 680819 */     GIR_EraseRootFromParent_Done,
     /* 680820 */   // Label 8741: @680820
     /* 680820 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(680879), // Rule ID 6181 //
     /* 680825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680833 */     // MIs[0] offset
     /* 680833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680836 */     // MIs[0] auxiliary
     /* 680836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680839 */     // MIs[0] Operand 8
     /* 680839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680849 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN_RTN),
     /* 680852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680854 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680856 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 680858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680865 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680867 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680877 */     GIR_RootConstrainSelectedInstOperands,
     /* 680878 */     // GIR_Coverage, 6181,
     /* 680878 */     GIR_EraseRootFromParent_Done,
     /* 680879 */   // Label 8742: @680879
     /* 680879 */   GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(680975), // Rule ID 6179 //
     /* 680884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680887 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680889 */     // MIs[0] offset
     /* 680889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680892 */     // MIs[0] auxiliary
     /* 680892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680895 */     // MIs[0] Operand 8
     /* 680895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680905 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 680908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 680912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 680917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 680921 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 680924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 680928 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 680931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 680936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_BOTHEN),
     /* 680949 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 680954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680961 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680963 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680973 */     GIR_RootConstrainSelectedInstOperands,
     /* 680974 */     // GIR_Coverage, 6179,
     /* 680974 */     GIR_EraseRootFromParent_Done,
     /* 680975 */   // Label 8743: @680975
     /* 680975 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(681068), // Rule ID 6187 //
     /* 680980 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680982 */     // MIs[0] offset
     /* 680982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680985 */     // MIs[0] auxiliary
     /* 680985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680988 */     // MIs[0] Operand 8
     /* 680988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680998 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 681001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 681005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 681010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 681014 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 681017 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 681021 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 681024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 681029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN),
     /* 681042 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 681047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681054 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681056 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681066 */     GIR_RootConstrainSelectedInstOperands,
     /* 681067 */     // GIR_Coverage, 6187,
     /* 681067 */     GIR_EraseRootFromParent_Done,
     /* 681068 */   // Label 8744: @681068
     /* 681068 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(681168), // Rule ID 6175 //
     /* 681073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 681080 */     // MIs[0] offset
     /* 681080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681083 */     // MIs[0] auxiliary
     /* 681083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681086 */     // MIs[0] Operand 8
     /* 681086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681096 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 681099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 681103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 681108 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 681112 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 681115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 681119 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 681122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 681127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_BOTHEN_RTN),
     /* 681140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681142 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 681147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681154 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681156 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 681162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681166 */     GIR_RootConstrainSelectedInstOperands,
     /* 681167 */     // GIR_Coverage, 6175,
     /* 681167 */     GIR_EraseRootFromParent_Done,
     /* 681168 */   // Label 8745: @681168
     /* 681168 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(681265), // Rule ID 6183 //
     /* 681173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 681177 */     // MIs[0] offset
     /* 681177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681180 */     // MIs[0] auxiliary
     /* 681180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681183 */     // MIs[0] Operand 8
     /* 681183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681193 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9819:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 681196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 681200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 681205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 681209 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 681212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 681216 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 681219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 681224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN_RTN),
     /* 681237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681239 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 681244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681251 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681253 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 681259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681263 */     GIR_RootConstrainSelectedInstOperands,
     /* 681264 */     // GIR_Coverage, 6183,
     /* 681264 */     GIR_EraseRootFromParent_Done,
     /* 681265 */   // Label 8746: @681265
     /* 681265 */   GIM_Reject,
     /* 681266 */ // Label 8730: @681266
     /* 681266 */ GIM_Reject,
     /* 681267 */ // Label 8712: @681267
     /* 681267 */ GIM_Reject,
     /* 681268 */ // Label 125: @681268
     /* 681268 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(23), /*)*//*default:*//*Label 8763*/ GIMT_Encode4(696639),
     /* 681279 */ /*GILLT_p0s64*//*Label 8747*/ GIMT_Encode4(681371),
     /* 681283 */ /*GILLT_p1s64*//*Label 8748*/ GIMT_Encode4(681990),
     /* 681287 */ /*GILLT_p2s32*//*Label 8749*/ GIMT_Encode4(682609),
     /* 681291 */ /*GILLT_p3s32*//*Label 8750*/ GIMT_Encode4(683228),
     /* 681295 */ /*GILLT_p4s64*//*Label 8751*/ GIMT_Encode4(683847),
     /* 681299 */ /*GILLT_p5s32*//*Label 8752*/ GIMT_Encode4(684466),
     /* 681303 */ /*GILLT_p6s32*//*Label 8753*/ GIMT_Encode4(685085), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 681315 */ /*GILLT_s32*//*Label 8754*/ GIMT_Encode4(685704),
     /* 681319 */ /*GILLT_s64*//*Label 8755*/ GIMT_Encode4(686919),
     /* 681323 */ /*GILLT_v2s16*//*Label 8756*/ GIMT_Encode4(688134),
     /* 681327 */ /*GILLT_v2s32*//*Label 8757*/ GIMT_Encode4(689349),
     /* 681331 */ /*GILLT_v2s64*//*Label 8758*/ GIMT_Encode4(690564),
     /* 681335 */ /*GILLT_v3s32*//*Label 8759*/ GIMT_Encode4(691779), GIMT_Encode4(0),
     /* 681343 */ /*GILLT_v4s16*//*Label 8760*/ GIMT_Encode4(692994),
     /* 681347 */ /*GILLT_v4s32*//*Label 8761*/ GIMT_Encode4(694209), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 681367 */ /*GILLT_v8s16*//*Label 8762*/ GIMT_Encode4(695424),
     /* 681371 */ // Label 8747: @681371
     /* 681371 */ GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(681989),
     /* 681376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 681379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 681382 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 681385 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 681388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 681392 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(681464), // Rule ID 4988 //
     /* 681397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 681404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681408 */     // MIs[0] offset
     /* 681408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 681411 */     // MIs[0] auxiliary
     /* 681411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681414 */     // MIs[0] Operand 7
     /* 681414 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 681425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681432 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 681432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 681435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 681439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681444 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 681446 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681452 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 681458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681462 */     GIR_RootConstrainSelectedInstOperands,
     /* 681463 */     // GIR_Coverage, 4988,
     /* 681463 */     GIR_EraseRootFromParent_Done,
     /* 681464 */   // Label 8765: @681464
     /* 681464 */   GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(681533), // Rule ID 4992 //
     /* 681469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 681473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681477 */     // MIs[0] offset
     /* 681477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 681480 */     // MIs[0] auxiliary
     /* 681480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681483 */     // MIs[0] Operand 7
     /* 681483 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 681494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681501 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 681501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 681504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 681508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681513 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 681515 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681521 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 681527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681531 */     GIR_RootConstrainSelectedInstOperands,
     /* 681532 */     // GIR_Coverage, 4992,
     /* 681532 */     GIR_EraseRootFromParent_Done,
     /* 681533 */   // Label 8766: @681533
     /* 681533 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(681603), // Rule ID 4989 //
     /* 681538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 681545 */     // MIs[0] offset
     /* 681545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 681548 */     // MIs[0] auxiliary
     /* 681548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681551 */     // MIs[0] Operand 7
     /* 681551 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 681562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681569 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 681569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 681572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681574 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 681576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 681578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681583 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 681585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681591 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 681597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681601 */     GIR_RootConstrainSelectedInstOperands,
     /* 681602 */     // GIR_Coverage, 4989,
     /* 681602 */     GIR_EraseRootFromParent_Done,
     /* 681603 */   // Label 8767: @681603
     /* 681603 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(681670), // Rule ID 4993 //
     /* 681608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 681612 */     // MIs[0] offset
     /* 681612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 681615 */     // MIs[0] auxiliary
     /* 681615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681618 */     // MIs[0] Operand 7
     /* 681618 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 681629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681636 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 681636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 681639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681641 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 681643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 681645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681650 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 681652 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681658 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 681664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681668 */     GIR_RootConstrainSelectedInstOperands,
     /* 681669 */     // GIR_Coverage, 4993,
     /* 681669 */     GIR_EraseRootFromParent_Done,
     /* 681670 */   // Label 8768: @681670
     /* 681670 */   GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(681732), // Rule ID 4990 //
     /* 681675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681682 */     // MIs[0] offset
     /* 681682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 681685 */     // MIs[0] auxiliary
     /* 681685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681688 */     // MIs[0] Operand 7
     /* 681688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681698 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 681698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 681701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681703 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 681705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 681707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681712 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 681714 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681720 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 681726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681730 */     GIR_RootConstrainSelectedInstOperands,
     /* 681731 */     // GIR_Coverage, 4990,
     /* 681731 */     GIR_EraseRootFromParent_Done,
     /* 681732 */   // Label 8769: @681732
     /* 681732 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(681791), // Rule ID 4994 //
     /* 681737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681741 */     // MIs[0] offset
     /* 681741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 681744 */     // MIs[0] auxiliary
     /* 681744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681747 */     // MIs[0] Operand 7
     /* 681747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681757 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 681757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 681760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681762 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 681764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 681766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681771 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 681773 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 681785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681789 */     GIR_RootConstrainSelectedInstOperands,
     /* 681790 */     // GIR_Coverage, 4994,
     /* 681790 */     GIR_EraseRootFromParent_Done,
     /* 681791 */   // Label 8770: @681791
     /* 681791 */   GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(681891), // Rule ID 4991 //
     /* 681796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681799 */     // MIs[0] offset
     /* 681799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 681802 */     // MIs[0] auxiliary
     /* 681802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681805 */     // MIs[0] Operand 7
     /* 681805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681815 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 681815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 681818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 681822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 681827 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 681831 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 681834 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 681838 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 681841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 681846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 681859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 681864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 681866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681871 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 681873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681879 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 681885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681889 */     GIR_RootConstrainSelectedInstOperands,
     /* 681890 */     // GIR_Coverage, 4991,
     /* 681890 */     GIR_EraseRootFromParent_Done,
     /* 681891 */   // Label 8771: @681891
     /* 681891 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(681988), // Rule ID 4995 //
     /* 681896 */     // MIs[0] offset
     /* 681896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 681899 */     // MIs[0] auxiliary
     /* 681899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681902 */     // MIs[0] Operand 7
     /* 681902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681912 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 681912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 681915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 681919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 681924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 681928 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 681931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 681935 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 681938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 681943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 681956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 681961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 681963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681968 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 681970 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 681982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681986 */     GIR_RootConstrainSelectedInstOperands,
     /* 681987 */     // GIR_Coverage, 4995,
     /* 681987 */     GIR_EraseRootFromParent_Done,
     /* 681988 */   // Label 8772: @681988
     /* 681988 */   GIM_Reject,
     /* 681989 */ // Label 8764: @681989
     /* 681989 */ GIM_Reject,
     /* 681990 */ // Label 8748: @681990
     /* 681990 */ GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(682608),
     /* 681995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 681998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 682001 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 682004 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 682007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 682011 */   GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(682083), // Rule ID 4996 //
     /* 682016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 682023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682027 */     // MIs[0] offset
     /* 682027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682030 */     // MIs[0] auxiliary
     /* 682030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682033 */     // MIs[0] Operand 7
     /* 682033 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 682044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682051 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 682054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682063 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682065 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682071 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682081 */     GIR_RootConstrainSelectedInstOperands,
     /* 682082 */     // GIR_Coverage, 4996,
     /* 682082 */     GIR_EraseRootFromParent_Done,
     /* 682083 */   // Label 8774: @682083
     /* 682083 */   GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(682152), // Rule ID 5000 //
     /* 682088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 682092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682096 */     // MIs[0] offset
     /* 682096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682099 */     // MIs[0] auxiliary
     /* 682099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682102 */     // MIs[0] Operand 7
     /* 682102 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 682113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682120 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 682123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682132 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682134 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682140 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682150 */     GIR_RootConstrainSelectedInstOperands,
     /* 682151 */     // GIR_Coverage, 5000,
     /* 682151 */     GIR_EraseRootFromParent_Done,
     /* 682152 */   // Label 8775: @682152
     /* 682152 */   GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(682222), // Rule ID 4997 //
     /* 682157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 682164 */     // MIs[0] offset
     /* 682164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682167 */     // MIs[0] auxiliary
     /* 682167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682170 */     // MIs[0] Operand 7
     /* 682170 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 682181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682188 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 682191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682193 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 682195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682202 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682204 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682220 */     GIR_RootConstrainSelectedInstOperands,
     /* 682221 */     // GIR_Coverage, 4997,
     /* 682221 */     GIR_EraseRootFromParent_Done,
     /* 682222 */   // Label 8776: @682222
     /* 682222 */   GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(682289), // Rule ID 5001 //
     /* 682227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 682231 */     // MIs[0] offset
     /* 682231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682234 */     // MIs[0] auxiliary
     /* 682234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682237 */     // MIs[0] Operand 7
     /* 682237 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 682248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682255 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 682258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682260 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 682262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682269 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682277 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682287 */     GIR_RootConstrainSelectedInstOperands,
     /* 682288 */     // GIR_Coverage, 5001,
     /* 682288 */     GIR_EraseRootFromParent_Done,
     /* 682289 */   // Label 8777: @682289
     /* 682289 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(682351), // Rule ID 4998 //
     /* 682294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682301 */     // MIs[0] offset
     /* 682301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682304 */     // MIs[0] auxiliary
     /* 682304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682307 */     // MIs[0] Operand 7
     /* 682307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682317 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 682320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682322 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 682324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682331 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682333 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682339 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682349 */     GIR_RootConstrainSelectedInstOperands,
     /* 682350 */     // GIR_Coverage, 4998,
     /* 682350 */     GIR_EraseRootFromParent_Done,
     /* 682351 */   // Label 8778: @682351
     /* 682351 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(682410), // Rule ID 5002 //
     /* 682356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682360 */     // MIs[0] offset
     /* 682360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682363 */     // MIs[0] auxiliary
     /* 682363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682366 */     // MIs[0] Operand 7
     /* 682366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682376 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 682379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682381 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 682383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682390 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682392 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682398 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682408 */     GIR_RootConstrainSelectedInstOperands,
     /* 682409 */     // GIR_Coverage, 5002,
     /* 682409 */     GIR_EraseRootFromParent_Done,
     /* 682410 */   // Label 8779: @682410
     /* 682410 */   GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(682510), // Rule ID 4999 //
     /* 682415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682418 */     // MIs[0] offset
     /* 682418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682421 */     // MIs[0] auxiliary
     /* 682421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682424 */     // MIs[0] Operand 7
     /* 682424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682434 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 682437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 682441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 682446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 682450 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 682453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 682457 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 682460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 682465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 682478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 682483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682490 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682492 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682498 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682508 */     GIR_RootConstrainSelectedInstOperands,
     /* 682509 */     // GIR_Coverage, 4999,
     /* 682509 */     GIR_EraseRootFromParent_Done,
     /* 682510 */   // Label 8780: @682510
     /* 682510 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(682607), // Rule ID 5003 //
     /* 682515 */     // MIs[0] offset
     /* 682515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682518 */     // MIs[0] auxiliary
     /* 682518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682521 */     // MIs[0] Operand 7
     /* 682521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682531 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 682534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 682538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 682543 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 682547 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 682550 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 682554 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 682557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 682562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 682575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 682580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682587 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682589 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682595 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682605 */     GIR_RootConstrainSelectedInstOperands,
     /* 682606 */     // GIR_Coverage, 5003,
     /* 682606 */     GIR_EraseRootFromParent_Done,
     /* 682607 */   // Label 8781: @682607
     /* 682607 */   GIM_Reject,
     /* 682608 */ // Label 8773: @682608
     /* 682608 */ GIM_Reject,
     /* 682609 */ // Label 8749: @682609
     /* 682609 */ GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(683227),
     /* 682614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 682617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 682620 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 682623 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 682626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 682630 */   GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(682702), // Rule ID 4924 //
     /* 682635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 682642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682646 */     // MIs[0] offset
     /* 682646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682649 */     // MIs[0] auxiliary
     /* 682649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682652 */     // MIs[0] Operand 7
     /* 682652 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 682663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682670 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 682673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682682 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682684 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682690 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682700 */     GIR_RootConstrainSelectedInstOperands,
     /* 682701 */     // GIR_Coverage, 4924,
     /* 682701 */     GIR_EraseRootFromParent_Done,
     /* 682702 */   // Label 8783: @682702
     /* 682702 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(682771), // Rule ID 4928 //
     /* 682707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 682711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682715 */     // MIs[0] offset
     /* 682715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682718 */     // MIs[0] auxiliary
     /* 682718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682721 */     // MIs[0] Operand 7
     /* 682721 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 682732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682739 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 682742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682751 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682753 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682759 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682769 */     GIR_RootConstrainSelectedInstOperands,
     /* 682770 */     // GIR_Coverage, 4928,
     /* 682770 */     GIR_EraseRootFromParent_Done,
     /* 682771 */   // Label 8784: @682771
     /* 682771 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(682841), // Rule ID 4925 //
     /* 682776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 682783 */     // MIs[0] offset
     /* 682783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682786 */     // MIs[0] auxiliary
     /* 682786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682789 */     // MIs[0] Operand 7
     /* 682789 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 682800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682807 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 682810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682812 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 682814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682821 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682823 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682829 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682839 */     GIR_RootConstrainSelectedInstOperands,
     /* 682840 */     // GIR_Coverage, 4925,
     /* 682840 */     GIR_EraseRootFromParent_Done,
     /* 682841 */   // Label 8785: @682841
     /* 682841 */   GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(682908), // Rule ID 4929 //
     /* 682846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 682850 */     // MIs[0] offset
     /* 682850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682853 */     // MIs[0] auxiliary
     /* 682853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682856 */     // MIs[0] Operand 7
     /* 682856 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 682867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682874 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 682877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682879 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 682881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682888 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682890 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682906 */     GIR_RootConstrainSelectedInstOperands,
     /* 682907 */     // GIR_Coverage, 4929,
     /* 682907 */     GIR_EraseRootFromParent_Done,
     /* 682908 */   // Label 8786: @682908
     /* 682908 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(682970), // Rule ID 4926 //
     /* 682913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682920 */     // MIs[0] offset
     /* 682920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682923 */     // MIs[0] auxiliary
     /* 682923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682926 */     // MIs[0] Operand 7
     /* 682926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682936 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 682939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682941 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 682943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 682945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682950 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 682952 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682958 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 682964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682968 */     GIR_RootConstrainSelectedInstOperands,
     /* 682969 */     // GIR_Coverage, 4926,
     /* 682969 */     GIR_EraseRootFromParent_Done,
     /* 682970 */   // Label 8787: @682970
     /* 682970 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(683029), // Rule ID 4930 //
     /* 682975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682979 */     // MIs[0] offset
     /* 682979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 682982 */     // MIs[0] auxiliary
     /* 682982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682985 */     // MIs[0] Operand 7
     /* 682985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682995 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 682995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 682998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683000 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 683002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683009 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683011 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683017 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683027 */     GIR_RootConstrainSelectedInstOperands,
     /* 683028 */     // GIR_Coverage, 4930,
     /* 683028 */     GIR_EraseRootFromParent_Done,
     /* 683029 */   // Label 8788: @683029
     /* 683029 */   GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(683129), // Rule ID 4927 //
     /* 683034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683037 */     // MIs[0] offset
     /* 683037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683040 */     // MIs[0] auxiliary
     /* 683040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683043 */     // MIs[0] Operand 7
     /* 683043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683053 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 683056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 683060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 683065 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 683069 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 683072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 683076 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 683079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 683084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 683097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 683102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683109 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683111 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683117 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683127 */     GIR_RootConstrainSelectedInstOperands,
     /* 683128 */     // GIR_Coverage, 4927,
     /* 683128 */     GIR_EraseRootFromParent_Done,
     /* 683129 */   // Label 8789: @683129
     /* 683129 */   GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(683226), // Rule ID 4931 //
     /* 683134 */     // MIs[0] offset
     /* 683134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683137 */     // MIs[0] auxiliary
     /* 683137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683140 */     // MIs[0] Operand 7
     /* 683140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683150 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 683153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 683157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 683162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 683166 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 683169 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 683173 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 683176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 683181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 683194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 683199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683206 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683208 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683214 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683224 */     GIR_RootConstrainSelectedInstOperands,
     /* 683225 */     // GIR_Coverage, 4931,
     /* 683225 */     GIR_EraseRootFromParent_Done,
     /* 683226 */   // Label 8790: @683226
     /* 683226 */   GIM_Reject,
     /* 683227 */ // Label 8782: @683227
     /* 683227 */ GIM_Reject,
     /* 683228 */ // Label 8750: @683228
     /* 683228 */ GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(683846),
     /* 683233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 683236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 683239 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 683242 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 683245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 683249 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(683321), // Rule ID 4932 //
     /* 683254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 683261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683265 */     // MIs[0] offset
     /* 683265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683268 */     // MIs[0] auxiliary
     /* 683268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683271 */     // MIs[0] Operand 7
     /* 683271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 683282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683289 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 683292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683301 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683303 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683309 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683319 */     GIR_RootConstrainSelectedInstOperands,
     /* 683320 */     // GIR_Coverage, 4932,
     /* 683320 */     GIR_EraseRootFromParent_Done,
     /* 683321 */   // Label 8792: @683321
     /* 683321 */   GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(683390), // Rule ID 4936 //
     /* 683326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 683330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683334 */     // MIs[0] offset
     /* 683334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683337 */     // MIs[0] auxiliary
     /* 683337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683340 */     // MIs[0] Operand 7
     /* 683340 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 683351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683358 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 683361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683370 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683372 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683378 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683388 */     GIR_RootConstrainSelectedInstOperands,
     /* 683389 */     // GIR_Coverage, 4936,
     /* 683389 */     GIR_EraseRootFromParent_Done,
     /* 683390 */   // Label 8793: @683390
     /* 683390 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(683460), // Rule ID 4933 //
     /* 683395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 683402 */     // MIs[0] offset
     /* 683402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683405 */     // MIs[0] auxiliary
     /* 683405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683408 */     // MIs[0] Operand 7
     /* 683408 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 683419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683426 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 683429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683431 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 683433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683440 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683448 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683458 */     GIR_RootConstrainSelectedInstOperands,
     /* 683459 */     // GIR_Coverage, 4933,
     /* 683459 */     GIR_EraseRootFromParent_Done,
     /* 683460 */   // Label 8794: @683460
     /* 683460 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(683527), // Rule ID 4937 //
     /* 683465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 683469 */     // MIs[0] offset
     /* 683469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683472 */     // MIs[0] auxiliary
     /* 683472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683475 */     // MIs[0] Operand 7
     /* 683475 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 683486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683493 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 683496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683498 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 683500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683507 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683509 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683515 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683525 */     GIR_RootConstrainSelectedInstOperands,
     /* 683526 */     // GIR_Coverage, 4937,
     /* 683526 */     GIR_EraseRootFromParent_Done,
     /* 683527 */   // Label 8795: @683527
     /* 683527 */   GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(683589), // Rule ID 4934 //
     /* 683532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683535 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683539 */     // MIs[0] offset
     /* 683539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683542 */     // MIs[0] auxiliary
     /* 683542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683545 */     // MIs[0] Operand 7
     /* 683545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683555 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 683558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683560 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 683562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683569 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683587 */     GIR_RootConstrainSelectedInstOperands,
     /* 683588 */     // GIR_Coverage, 4934,
     /* 683588 */     GIR_EraseRootFromParent_Done,
     /* 683589 */   // Label 8796: @683589
     /* 683589 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(683648), // Rule ID 4938 //
     /* 683594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683598 */     // MIs[0] offset
     /* 683598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683601 */     // MIs[0] auxiliary
     /* 683601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683604 */     // MIs[0] Operand 7
     /* 683604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683614 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 683617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683619 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 683621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683628 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683636 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683646 */     GIR_RootConstrainSelectedInstOperands,
     /* 683647 */     // GIR_Coverage, 4938,
     /* 683647 */     GIR_EraseRootFromParent_Done,
     /* 683648 */   // Label 8797: @683648
     /* 683648 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(683748), // Rule ID 4935 //
     /* 683653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683656 */     // MIs[0] offset
     /* 683656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683659 */     // MIs[0] auxiliary
     /* 683659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683662 */     // MIs[0] Operand 7
     /* 683662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683672 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 683675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 683679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 683684 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 683688 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 683691 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 683695 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 683698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 683703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 683716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 683721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683728 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683746 */     GIR_RootConstrainSelectedInstOperands,
     /* 683747 */     // GIR_Coverage, 4935,
     /* 683747 */     GIR_EraseRootFromParent_Done,
     /* 683748 */   // Label 8798: @683748
     /* 683748 */   GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(683845), // Rule ID 4939 //
     /* 683753 */     // MIs[0] offset
     /* 683753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683756 */     // MIs[0] auxiliary
     /* 683756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683759 */     // MIs[0] Operand 7
     /* 683759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683769 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 683772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 683776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 683781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 683785 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 683788 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 683792 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 683795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 683800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 683813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 683818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683825 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683827 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683833 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683843 */     GIR_RootConstrainSelectedInstOperands,
     /* 683844 */     // GIR_Coverage, 4939,
     /* 683844 */     GIR_EraseRootFromParent_Done,
     /* 683845 */   // Label 8799: @683845
     /* 683845 */   GIM_Reject,
     /* 683846 */ // Label 8791: @683846
     /* 683846 */ GIM_Reject,
     /* 683847 */ // Label 8751: @683847
     /* 683847 */ GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(684465),
     /* 683852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 683855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 683858 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 683861 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 683864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 683868 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(683940), // Rule ID 5004 //
     /* 683873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 683880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683884 */     // MIs[0] offset
     /* 683884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683887 */     // MIs[0] auxiliary
     /* 683887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683890 */     // MIs[0] Operand 7
     /* 683890 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 683901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683908 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 683911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683920 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683928 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 683934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683938 */     GIR_RootConstrainSelectedInstOperands,
     /* 683939 */     // GIR_Coverage, 5004,
     /* 683939 */     GIR_EraseRootFromParent_Done,
     /* 683940 */   // Label 8801: @683940
     /* 683940 */   GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(684009), // Rule ID 5008 //
     /* 683945 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 683949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683953 */     // MIs[0] offset
     /* 683953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 683956 */     // MIs[0] auxiliary
     /* 683956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683959 */     // MIs[0] Operand 7
     /* 683959 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 683970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683977 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 683977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 683980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 683984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683989 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 683991 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683997 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684007 */     GIR_RootConstrainSelectedInstOperands,
     /* 684008 */     // GIR_Coverage, 5008,
     /* 684008 */     GIR_EraseRootFromParent_Done,
     /* 684009 */   // Label 8802: @684009
     /* 684009 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(684079), // Rule ID 5005 //
     /* 684014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 684021 */     // MIs[0] offset
     /* 684021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684024 */     // MIs[0] auxiliary
     /* 684024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684027 */     // MIs[0] Operand 7
     /* 684027 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 684038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684045 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 684048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684050 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 684052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684059 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684061 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684067 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684077 */     GIR_RootConstrainSelectedInstOperands,
     /* 684078 */     // GIR_Coverage, 5005,
     /* 684078 */     GIR_EraseRootFromParent_Done,
     /* 684079 */   // Label 8803: @684079
     /* 684079 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(684146), // Rule ID 5009 //
     /* 684084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 684088 */     // MIs[0] offset
     /* 684088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684091 */     // MIs[0] auxiliary
     /* 684091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684094 */     // MIs[0] Operand 7
     /* 684094 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 684105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684112 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 684115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684117 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 684119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684126 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684128 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684134 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684144 */     GIR_RootConstrainSelectedInstOperands,
     /* 684145 */     // GIR_Coverage, 5009,
     /* 684145 */     GIR_EraseRootFromParent_Done,
     /* 684146 */   // Label 8804: @684146
     /* 684146 */   GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(684208), // Rule ID 5006 //
     /* 684151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684158 */     // MIs[0] offset
     /* 684158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684161 */     // MIs[0] auxiliary
     /* 684161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684164 */     // MIs[0] Operand 7
     /* 684164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684174 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 684177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684179 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 684181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684188 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684190 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684196 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684206 */     GIR_RootConstrainSelectedInstOperands,
     /* 684207 */     // GIR_Coverage, 5006,
     /* 684207 */     GIR_EraseRootFromParent_Done,
     /* 684208 */   // Label 8805: @684208
     /* 684208 */   GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(684267), // Rule ID 5010 //
     /* 684213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684217 */     // MIs[0] offset
     /* 684217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684220 */     // MIs[0] auxiliary
     /* 684220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684223 */     // MIs[0] Operand 7
     /* 684223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684233 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 684236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684238 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 684240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684247 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684249 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684255 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684265 */     GIR_RootConstrainSelectedInstOperands,
     /* 684266 */     // GIR_Coverage, 5010,
     /* 684266 */     GIR_EraseRootFromParent_Done,
     /* 684267 */   // Label 8806: @684267
     /* 684267 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(684367), // Rule ID 5007 //
     /* 684272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684275 */     // MIs[0] offset
     /* 684275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684278 */     // MIs[0] auxiliary
     /* 684278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684281 */     // MIs[0] Operand 7
     /* 684281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684291 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 684294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 684298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 684303 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 684307 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 684310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 684314 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 684317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 684322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 684335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 684340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684347 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684349 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684355 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684365 */     GIR_RootConstrainSelectedInstOperands,
     /* 684366 */     // GIR_Coverage, 5007,
     /* 684366 */     GIR_EraseRootFromParent_Done,
     /* 684367 */   // Label 8807: @684367
     /* 684367 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(684464), // Rule ID 5011 //
     /* 684372 */     // MIs[0] offset
     /* 684372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684375 */     // MIs[0] auxiliary
     /* 684375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684378 */     // MIs[0] Operand 7
     /* 684378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684388 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 684391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 684395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 684400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 684404 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 684407 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 684411 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 684414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 684419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 684432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 684437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684444 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684446 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684452 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684462 */     GIR_RootConstrainSelectedInstOperands,
     /* 684463 */     // GIR_Coverage, 5011,
     /* 684463 */     GIR_EraseRootFromParent_Done,
     /* 684464 */   // Label 8808: @684464
     /* 684464 */   GIM_Reject,
     /* 684465 */ // Label 8800: @684465
     /* 684465 */ GIM_Reject,
     /* 684466 */ // Label 8752: @684466
     /* 684466 */ GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(685084),
     /* 684471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 684474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 684477 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 684480 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 684483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 684487 */   GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(684559), // Rule ID 4940 //
     /* 684492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 684499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684503 */     // MIs[0] offset
     /* 684503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684506 */     // MIs[0] auxiliary
     /* 684506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684509 */     // MIs[0] Operand 7
     /* 684509 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 684520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684527 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 684530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684539 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684541 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684547 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684557 */     GIR_RootConstrainSelectedInstOperands,
     /* 684558 */     // GIR_Coverage, 4940,
     /* 684558 */     GIR_EraseRootFromParent_Done,
     /* 684559 */   // Label 8810: @684559
     /* 684559 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(684628), // Rule ID 4944 //
     /* 684564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 684568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684572 */     // MIs[0] offset
     /* 684572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684575 */     // MIs[0] auxiliary
     /* 684575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684578 */     // MIs[0] Operand 7
     /* 684578 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 684589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684596 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 684599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684608 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684610 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684616 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684626 */     GIR_RootConstrainSelectedInstOperands,
     /* 684627 */     // GIR_Coverage, 4944,
     /* 684627 */     GIR_EraseRootFromParent_Done,
     /* 684628 */   // Label 8811: @684628
     /* 684628 */   GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(684698), // Rule ID 4941 //
     /* 684633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 684640 */     // MIs[0] offset
     /* 684640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684643 */     // MIs[0] auxiliary
     /* 684643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684646 */     // MIs[0] Operand 7
     /* 684646 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 684657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684664 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 684667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684669 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 684671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684678 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684680 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684686 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684696 */     GIR_RootConstrainSelectedInstOperands,
     /* 684697 */     // GIR_Coverage, 4941,
     /* 684697 */     GIR_EraseRootFromParent_Done,
     /* 684698 */   // Label 8812: @684698
     /* 684698 */   GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(684765), // Rule ID 4945 //
     /* 684703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 684707 */     // MIs[0] offset
     /* 684707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684710 */     // MIs[0] auxiliary
     /* 684710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684713 */     // MIs[0] Operand 7
     /* 684713 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 684724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684731 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 684734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684736 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 684738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684745 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684747 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684753 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684763 */     GIR_RootConstrainSelectedInstOperands,
     /* 684764 */     // GIR_Coverage, 4945,
     /* 684764 */     GIR_EraseRootFromParent_Done,
     /* 684765 */   // Label 8813: @684765
     /* 684765 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(684827), // Rule ID 4942 //
     /* 684770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684777 */     // MIs[0] offset
     /* 684777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684780 */     // MIs[0] auxiliary
     /* 684780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684783 */     // MIs[0] Operand 7
     /* 684783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684793 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 684796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684798 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 684800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684807 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684809 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684815 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684825 */     GIR_RootConstrainSelectedInstOperands,
     /* 684826 */     // GIR_Coverage, 4942,
     /* 684826 */     GIR_EraseRootFromParent_Done,
     /* 684827 */   // Label 8814: @684827
     /* 684827 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(684886), // Rule ID 4946 //
     /* 684832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684836 */     // MIs[0] offset
     /* 684836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684839 */     // MIs[0] auxiliary
     /* 684839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684842 */     // MIs[0] Operand 7
     /* 684842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684852 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 684855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684857 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 684859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684866 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684868 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684874 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684884 */     GIR_RootConstrainSelectedInstOperands,
     /* 684885 */     // GIR_Coverage, 4946,
     /* 684885 */     GIR_EraseRootFromParent_Done,
     /* 684886 */   // Label 8815: @684886
     /* 684886 */   GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(684986), // Rule ID 4943 //
     /* 684891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684894 */     // MIs[0] offset
     /* 684894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684897 */     // MIs[0] auxiliary
     /* 684897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684900 */     // MIs[0] Operand 7
     /* 684900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684910 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 684910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 684913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 684917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 684922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 684926 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 684929 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 684933 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 684936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 684941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 684954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 684959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 684961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684966 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 684968 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684974 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 684980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684984 */     GIR_RootConstrainSelectedInstOperands,
     /* 684985 */     // GIR_Coverage, 4943,
     /* 684985 */     GIR_EraseRootFromParent_Done,
     /* 684986 */   // Label 8816: @684986
     /* 684986 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(685083), // Rule ID 4947 //
     /* 684991 */     // MIs[0] offset
     /* 684991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 684994 */     // MIs[0] auxiliary
     /* 684994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684997 */     // MIs[0] Operand 7
     /* 684997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685007 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 685010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 685014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 685019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 685023 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 685026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 685030 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 685033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 685038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 685051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 685056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685063 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685065 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685071 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685081 */     GIR_RootConstrainSelectedInstOperands,
     /* 685082 */     // GIR_Coverage, 4947,
     /* 685082 */     GIR_EraseRootFromParent_Done,
     /* 685083 */   // Label 8817: @685083
     /* 685083 */   GIM_Reject,
     /* 685084 */ // Label 8809: @685084
     /* 685084 */ GIM_Reject,
     /* 685085 */ // Label 8753: @685085
     /* 685085 */ GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(685703),
     /* 685090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 685093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 685096 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 685099 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 685102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 685106 */   GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(685178), // Rule ID 4948 //
     /* 685111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685122 */     // MIs[0] offset
     /* 685122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685125 */     // MIs[0] auxiliary
     /* 685125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685128 */     // MIs[0] Operand 7
     /* 685128 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685146 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 685149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685158 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685160 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685166 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685176 */     GIR_RootConstrainSelectedInstOperands,
     /* 685177 */     // GIR_Coverage, 4948,
     /* 685177 */     GIR_EraseRootFromParent_Done,
     /* 685178 */   // Label 8819: @685178
     /* 685178 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(685247), // Rule ID 4952 //
     /* 685183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685191 */     // MIs[0] offset
     /* 685191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685194 */     // MIs[0] auxiliary
     /* 685194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685197 */     // MIs[0] Operand 7
     /* 685197 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685215 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 685218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685227 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685229 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685235 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685245 */     GIR_RootConstrainSelectedInstOperands,
     /* 685246 */     // GIR_Coverage, 4952,
     /* 685246 */     GIR_EraseRootFromParent_Done,
     /* 685247 */   // Label 8820: @685247
     /* 685247 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(685317), // Rule ID 4949 //
     /* 685252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685259 */     // MIs[0] offset
     /* 685259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685262 */     // MIs[0] auxiliary
     /* 685262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685265 */     // MIs[0] Operand 7
     /* 685265 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685283 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 685286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685288 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 685290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685297 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685299 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685305 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685315 */     GIR_RootConstrainSelectedInstOperands,
     /* 685316 */     // GIR_Coverage, 4949,
     /* 685316 */     GIR_EraseRootFromParent_Done,
     /* 685317 */   // Label 8821: @685317
     /* 685317 */   GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(685384), // Rule ID 4953 //
     /* 685322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685326 */     // MIs[0] offset
     /* 685326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685329 */     // MIs[0] auxiliary
     /* 685329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685332 */     // MIs[0] Operand 7
     /* 685332 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685350 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 685353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685355 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 685357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685364 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685366 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685372 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685382 */     GIR_RootConstrainSelectedInstOperands,
     /* 685383 */     // GIR_Coverage, 4953,
     /* 685383 */     GIR_EraseRootFromParent_Done,
     /* 685384 */   // Label 8822: @685384
     /* 685384 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(685446), // Rule ID 4950 //
     /* 685389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685396 */     // MIs[0] offset
     /* 685396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685399 */     // MIs[0] auxiliary
     /* 685399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685402 */     // MIs[0] Operand 7
     /* 685402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685412 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 685415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685417 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 685419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685426 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685428 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685434 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685444 */     GIR_RootConstrainSelectedInstOperands,
     /* 685445 */     // GIR_Coverage, 4950,
     /* 685445 */     GIR_EraseRootFromParent_Done,
     /* 685446 */   // Label 8823: @685446
     /* 685446 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(685505), // Rule ID 4954 //
     /* 685451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685455 */     // MIs[0] offset
     /* 685455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685458 */     // MIs[0] auxiliary
     /* 685458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685461 */     // MIs[0] Operand 7
     /* 685461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685471 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 685474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685476 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 685478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685485 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685487 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685493 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685503 */     GIR_RootConstrainSelectedInstOperands,
     /* 685504 */     // GIR_Coverage, 4954,
     /* 685504 */     GIR_EraseRootFromParent_Done,
     /* 685505 */   // Label 8824: @685505
     /* 685505 */   GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(685605), // Rule ID 4951 //
     /* 685510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685513 */     // MIs[0] offset
     /* 685513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685516 */     // MIs[0] auxiliary
     /* 685516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685519 */     // MIs[0] Operand 7
     /* 685519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685529 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 685532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 685536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 685541 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 685545 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 685548 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 685552 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 685555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 685560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 685573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 685578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685585 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685587 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685593 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685603 */     GIR_RootConstrainSelectedInstOperands,
     /* 685604 */     // GIR_Coverage, 4951,
     /* 685604 */     GIR_EraseRootFromParent_Done,
     /* 685605 */   // Label 8825: @685605
     /* 685605 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(685702), // Rule ID 4955 //
     /* 685610 */     // MIs[0] offset
     /* 685610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685613 */     // MIs[0] auxiliary
     /* 685613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685616 */     // MIs[0] Operand 7
     /* 685616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685626 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 685629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 685633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 685638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 685642 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 685645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 685649 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 685652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 685657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 685670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 685675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685682 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685684 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685690 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685700 */     GIR_RootConstrainSelectedInstOperands,
     /* 685701 */     // GIR_Coverage, 4955,
     /* 685701 */     GIR_EraseRootFromParent_Done,
     /* 685702 */   // Label 8826: @685702
     /* 685702 */   GIM_Reject,
     /* 685703 */ // Label 8818: @685703
     /* 685703 */ GIM_Reject,
     /* 685704 */ // Label 8754: @685704
     /* 685704 */ GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(686918),
     /* 685709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 685712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 685715 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 685718 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 685721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 685725 */   GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(685797), // Rule ID 4892 //
     /* 685730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685741 */     // MIs[0] offset
     /* 685741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685744 */     // MIs[0] auxiliary
     /* 685744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685747 */     // MIs[0] Operand 7
     /* 685747 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685765 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 685768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685777 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685795 */     GIR_RootConstrainSelectedInstOperands,
     /* 685796 */     // GIR_Coverage, 4892,
     /* 685796 */     GIR_EraseRootFromParent_Done,
     /* 685797 */   // Label 8828: @685797
     /* 685797 */   GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(685866), // Rule ID 4896 //
     /* 685802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685810 */     // MIs[0] offset
     /* 685810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685813 */     // MIs[0] auxiliary
     /* 685813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685816 */     // MIs[0] Operand 7
     /* 685816 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685834 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 685837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685846 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685848 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685854 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685864 */     GIR_RootConstrainSelectedInstOperands,
     /* 685865 */     // GIR_Coverage, 4896,
     /* 685865 */     GIR_EraseRootFromParent_Done,
     /* 685866 */   // Label 8829: @685866
     /* 685866 */   GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(685938), // Rule ID 4900 //
     /* 685871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685882 */     // MIs[0] offset
     /* 685882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685885 */     // MIs[0] auxiliary
     /* 685885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685888 */     // MIs[0] Operand 7
     /* 685888 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685906 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 685909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685918 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685920 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685936 */     GIR_RootConstrainSelectedInstOperands,
     /* 685937 */     // GIR_Coverage, 4900,
     /* 685937 */     GIR_EraseRootFromParent_Done,
     /* 685938 */   // Label 8830: @685938
     /* 685938 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(686007), // Rule ID 4904 //
     /* 685943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685951 */     // MIs[0] offset
     /* 685951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685954 */     // MIs[0] auxiliary
     /* 685954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685957 */     // MIs[0] Operand 7
     /* 685957 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685975 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 685978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685987 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685989 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685995 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686005 */     GIR_RootConstrainSelectedInstOperands,
     /* 686006 */     // GIR_Coverage, 4904,
     /* 686006 */     GIR_EraseRootFromParent_Done,
     /* 686007 */   // Label 8831: @686007
     /* 686007 */   GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(686077), // Rule ID 4893 //
     /* 686012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686019 */     // MIs[0] offset
     /* 686019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686022 */     // MIs[0] auxiliary
     /* 686022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686025 */     // MIs[0] Operand 7
     /* 686025 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686043 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 686046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686048 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 686050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686057 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686059 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686065 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686075 */     GIR_RootConstrainSelectedInstOperands,
     /* 686076 */     // GIR_Coverage, 4893,
     /* 686076 */     GIR_EraseRootFromParent_Done,
     /* 686077 */   // Label 8832: @686077
     /* 686077 */   GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(686144), // Rule ID 4897 //
     /* 686082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686086 */     // MIs[0] offset
     /* 686086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686089 */     // MIs[0] auxiliary
     /* 686089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686092 */     // MIs[0] Operand 7
     /* 686092 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686110 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 686113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686115 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 686117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686124 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686126 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686132 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686142 */     GIR_RootConstrainSelectedInstOperands,
     /* 686143 */     // GIR_Coverage, 4897,
     /* 686143 */     GIR_EraseRootFromParent_Done,
     /* 686144 */   // Label 8833: @686144
     /* 686144 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(686214), // Rule ID 4901 //
     /* 686149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686156 */     // MIs[0] offset
     /* 686156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686159 */     // MIs[0] auxiliary
     /* 686159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686162 */     // MIs[0] Operand 7
     /* 686162 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686180 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 686183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686185 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 686187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686194 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686196 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686202 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686212 */     GIR_RootConstrainSelectedInstOperands,
     /* 686213 */     // GIR_Coverage, 4901,
     /* 686213 */     GIR_EraseRootFromParent_Done,
     /* 686214 */   // Label 8834: @686214
     /* 686214 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(686281), // Rule ID 4905 //
     /* 686219 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686223 */     // MIs[0] offset
     /* 686223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686226 */     // MIs[0] auxiliary
     /* 686226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686229 */     // MIs[0] Operand 7
     /* 686229 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686247 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 686250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686252 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 686254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686261 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686263 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686269 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686279 */     GIR_RootConstrainSelectedInstOperands,
     /* 686280 */     // GIR_Coverage, 4905,
     /* 686280 */     GIR_EraseRootFromParent_Done,
     /* 686281 */   // Label 8835: @686281
     /* 686281 */   GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(686343), // Rule ID 4894 //
     /* 686286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686289 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686293 */     // MIs[0] offset
     /* 686293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686296 */     // MIs[0] auxiliary
     /* 686296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686299 */     // MIs[0] Operand 7
     /* 686299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686309 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 686312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686314 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 686316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686323 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686325 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686331 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686341 */     GIR_RootConstrainSelectedInstOperands,
     /* 686342 */     // GIR_Coverage, 4894,
     /* 686342 */     GIR_EraseRootFromParent_Done,
     /* 686343 */   // Label 8836: @686343
     /* 686343 */   GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(686402), // Rule ID 4898 //
     /* 686348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686352 */     // MIs[0] offset
     /* 686352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686355 */     // MIs[0] auxiliary
     /* 686355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686358 */     // MIs[0] Operand 7
     /* 686358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686368 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 686371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686373 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 686375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686382 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686384 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686390 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686400 */     GIR_RootConstrainSelectedInstOperands,
     /* 686401 */     // GIR_Coverage, 4898,
     /* 686401 */     GIR_EraseRootFromParent_Done,
     /* 686402 */   // Label 8837: @686402
     /* 686402 */   GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(686464), // Rule ID 4902 //
     /* 686407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686414 */     // MIs[0] offset
     /* 686414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686417 */     // MIs[0] auxiliary
     /* 686417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686420 */     // MIs[0] Operand 7
     /* 686420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686430 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 686433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686435 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 686437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686444 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686446 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686452 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686462 */     GIR_RootConstrainSelectedInstOperands,
     /* 686463 */     // GIR_Coverage, 4902,
     /* 686463 */     GIR_EraseRootFromParent_Done,
     /* 686464 */   // Label 8838: @686464
     /* 686464 */   GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(686523), // Rule ID 4906 //
     /* 686469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686473 */     // MIs[0] offset
     /* 686473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686476 */     // MIs[0] auxiliary
     /* 686476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686479 */     // MIs[0] Operand 7
     /* 686479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686489 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 686492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686494 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 686496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686503 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686505 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686511 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686521 */     GIR_RootConstrainSelectedInstOperands,
     /* 686522 */     // GIR_Coverage, 4906,
     /* 686522 */     GIR_EraseRootFromParent_Done,
     /* 686523 */   // Label 8839: @686523
     /* 686523 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(686623), // Rule ID 4895 //
     /* 686528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686531 */     // MIs[0] offset
     /* 686531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686534 */     // MIs[0] auxiliary
     /* 686534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686537 */     // MIs[0] Operand 7
     /* 686537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686547 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 686550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 686554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 686559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 686563 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 686566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 686570 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 686573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 686578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 686591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 686596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686603 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686605 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686611 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686621 */     GIR_RootConstrainSelectedInstOperands,
     /* 686622 */     // GIR_Coverage, 4895,
     /* 686622 */     GIR_EraseRootFromParent_Done,
     /* 686623 */   // Label 8840: @686623
     /* 686623 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(686720), // Rule ID 4899 //
     /* 686628 */     // MIs[0] offset
     /* 686628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686631 */     // MIs[0] auxiliary
     /* 686631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686634 */     // MIs[0] Operand 7
     /* 686634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686644 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 686647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 686651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 686656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 686660 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 686663 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 686667 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 686670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 686675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 686688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 686693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686700 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686702 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686708 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686718 */     GIR_RootConstrainSelectedInstOperands,
     /* 686719 */     // GIR_Coverage, 4899,
     /* 686719 */     GIR_EraseRootFromParent_Done,
     /* 686720 */   // Label 8841: @686720
     /* 686720 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(686820), // Rule ID 4903 //
     /* 686725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686728 */     // MIs[0] offset
     /* 686728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686731 */     // MIs[0] auxiliary
     /* 686731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686734 */     // MIs[0] Operand 7
     /* 686734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686744 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 686747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 686751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 686756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 686760 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 686763 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 686767 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 686770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 686775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 686788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 686793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686800 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686818 */     GIR_RootConstrainSelectedInstOperands,
     /* 686819 */     // GIR_Coverage, 4903,
     /* 686819 */     GIR_EraseRootFromParent_Done,
     /* 686820 */   // Label 8842: @686820
     /* 686820 */   GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(686917), // Rule ID 4907 //
     /* 686825 */     // MIs[0] offset
     /* 686825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686828 */     // MIs[0] auxiliary
     /* 686828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686831 */     // MIs[0] Operand 7
     /* 686831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686841 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 686844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 686848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 686853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 686857 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 686860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 686864 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 686867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 686872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 686885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 686890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686897 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686899 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686905 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686915 */     GIR_RootConstrainSelectedInstOperands,
     /* 686916 */     // GIR_Coverage, 4907,
     /* 686916 */     GIR_EraseRootFromParent_Done,
     /* 686917 */   // Label 8843: @686917
     /* 686917 */   GIM_Reject,
     /* 686918 */ // Label 8827: @686918
     /* 686918 */ GIM_Reject,
     /* 686919 */ // Label 8755: @686919
     /* 686919 */ GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(688133),
     /* 686924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 686927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 686930 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 686933 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 686936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 686940 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(687012), // Rule ID 4956 //
     /* 686945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686956 */     // MIs[0] offset
     /* 686956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686959 */     // MIs[0] auxiliary
     /* 686959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686962 */     // MIs[0] Operand 7
     /* 686962 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686980 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 686983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686992 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687000 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687010 */     GIR_RootConstrainSelectedInstOperands,
     /* 687011 */     // GIR_Coverage, 4956,
     /* 687011 */     GIR_EraseRootFromParent_Done,
     /* 687012 */   // Label 8845: @687012
     /* 687012 */   GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(687081), // Rule ID 4960 //
     /* 687017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687025 */     // MIs[0] offset
     /* 687025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687028 */     // MIs[0] auxiliary
     /* 687028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687031 */     // MIs[0] Operand 7
     /* 687031 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687049 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 687052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687061 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687063 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687069 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687079 */     GIR_RootConstrainSelectedInstOperands,
     /* 687080 */     // GIR_Coverage, 4960,
     /* 687080 */     GIR_EraseRootFromParent_Done,
     /* 687081 */   // Label 8846: @687081
     /* 687081 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(687153), // Rule ID 4964 //
     /* 687086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687097 */     // MIs[0] offset
     /* 687097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687100 */     // MIs[0] auxiliary
     /* 687100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687103 */     // MIs[0] Operand 7
     /* 687103 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687121 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 687124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687133 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687151 */     GIR_RootConstrainSelectedInstOperands,
     /* 687152 */     // GIR_Coverage, 4964,
     /* 687152 */     GIR_EraseRootFromParent_Done,
     /* 687153 */   // Label 8847: @687153
     /* 687153 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(687222), // Rule ID 4968 //
     /* 687158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687166 */     // MIs[0] offset
     /* 687166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687169 */     // MIs[0] auxiliary
     /* 687169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687172 */     // MIs[0] Operand 7
     /* 687172 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687190 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 687193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687202 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687204 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687220 */     GIR_RootConstrainSelectedInstOperands,
     /* 687221 */     // GIR_Coverage, 4968,
     /* 687221 */     GIR_EraseRootFromParent_Done,
     /* 687222 */   // Label 8848: @687222
     /* 687222 */   GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(687292), // Rule ID 4957 //
     /* 687227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687234 */     // MIs[0] offset
     /* 687234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687237 */     // MIs[0] auxiliary
     /* 687237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687240 */     // MIs[0] Operand 7
     /* 687240 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687258 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 687261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687263 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 687265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687272 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687274 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687280 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687290 */     GIR_RootConstrainSelectedInstOperands,
     /* 687291 */     // GIR_Coverage, 4957,
     /* 687291 */     GIR_EraseRootFromParent_Done,
     /* 687292 */   // Label 8849: @687292
     /* 687292 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(687359), // Rule ID 4961 //
     /* 687297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687301 */     // MIs[0] offset
     /* 687301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687304 */     // MIs[0] auxiliary
     /* 687304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687307 */     // MIs[0] Operand 7
     /* 687307 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687325 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 687328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687330 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 687332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687339 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687341 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687347 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687357 */     GIR_RootConstrainSelectedInstOperands,
     /* 687358 */     // GIR_Coverage, 4961,
     /* 687358 */     GIR_EraseRootFromParent_Done,
     /* 687359 */   // Label 8850: @687359
     /* 687359 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(687429), // Rule ID 4965 //
     /* 687364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687371 */     // MIs[0] offset
     /* 687371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687374 */     // MIs[0] auxiliary
     /* 687374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687377 */     // MIs[0] Operand 7
     /* 687377 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687395 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 687398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687400 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 687402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687409 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687411 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687427 */     GIR_RootConstrainSelectedInstOperands,
     /* 687428 */     // GIR_Coverage, 4965,
     /* 687428 */     GIR_EraseRootFromParent_Done,
     /* 687429 */   // Label 8851: @687429
     /* 687429 */   GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(687496), // Rule ID 4969 //
     /* 687434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687438 */     // MIs[0] offset
     /* 687438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687441 */     // MIs[0] auxiliary
     /* 687441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687444 */     // MIs[0] Operand 7
     /* 687444 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687462 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 687465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687467 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 687469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687476 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687478 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687484 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687494 */     GIR_RootConstrainSelectedInstOperands,
     /* 687495 */     // GIR_Coverage, 4969,
     /* 687495 */     GIR_EraseRootFromParent_Done,
     /* 687496 */   // Label 8852: @687496
     /* 687496 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(687558), // Rule ID 4958 //
     /* 687501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687508 */     // MIs[0] offset
     /* 687508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687511 */     // MIs[0] auxiliary
     /* 687511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687514 */     // MIs[0] Operand 7
     /* 687514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687524 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 687527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687529 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 687531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687538 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687540 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687546 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687556 */     GIR_RootConstrainSelectedInstOperands,
     /* 687557 */     // GIR_Coverage, 4958,
     /* 687557 */     GIR_EraseRootFromParent_Done,
     /* 687558 */   // Label 8853: @687558
     /* 687558 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(687617), // Rule ID 4962 //
     /* 687563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687567 */     // MIs[0] offset
     /* 687567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687570 */     // MIs[0] auxiliary
     /* 687570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687573 */     // MIs[0] Operand 7
     /* 687573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687583 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 687586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687588 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 687590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687597 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687605 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687615 */     GIR_RootConstrainSelectedInstOperands,
     /* 687616 */     // GIR_Coverage, 4962,
     /* 687616 */     GIR_EraseRootFromParent_Done,
     /* 687617 */   // Label 8854: @687617
     /* 687617 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(687679), // Rule ID 4966 //
     /* 687622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687629 */     // MIs[0] offset
     /* 687629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687632 */     // MIs[0] auxiliary
     /* 687632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687635 */     // MIs[0] Operand 7
     /* 687635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687645 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 687648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687650 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 687652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687659 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687661 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687667 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687677 */     GIR_RootConstrainSelectedInstOperands,
     /* 687678 */     // GIR_Coverage, 4966,
     /* 687678 */     GIR_EraseRootFromParent_Done,
     /* 687679 */   // Label 8855: @687679
     /* 687679 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(687738), // Rule ID 4970 //
     /* 687684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687688 */     // MIs[0] offset
     /* 687688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687691 */     // MIs[0] auxiliary
     /* 687691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687694 */     // MIs[0] Operand 7
     /* 687694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687704 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 687707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687709 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 687711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687718 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687720 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687726 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687736 */     GIR_RootConstrainSelectedInstOperands,
     /* 687737 */     // GIR_Coverage, 4970,
     /* 687737 */     GIR_EraseRootFromParent_Done,
     /* 687738 */   // Label 8856: @687738
     /* 687738 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(687838), // Rule ID 4959 //
     /* 687743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687746 */     // MIs[0] offset
     /* 687746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687749 */     // MIs[0] auxiliary
     /* 687749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687752 */     // MIs[0] Operand 7
     /* 687752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687762 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 687765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 687769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 687774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 687778 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 687781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 687785 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 687788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 687793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 687798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 687803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 687806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 687811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687818 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687820 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687826 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687836 */     GIR_RootConstrainSelectedInstOperands,
     /* 687837 */     // GIR_Coverage, 4959,
     /* 687837 */     GIR_EraseRootFromParent_Done,
     /* 687838 */   // Label 8857: @687838
     /* 687838 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(687935), // Rule ID 4963 //
     /* 687843 */     // MIs[0] offset
     /* 687843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687846 */     // MIs[0] auxiliary
     /* 687846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687849 */     // MIs[0] Operand 7
     /* 687849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687859 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 687862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 687866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 687871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 687875 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 687878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 687882 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 687885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 687890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 687895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 687900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 687903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 687908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687915 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687917 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687923 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687933 */     GIR_RootConstrainSelectedInstOperands,
     /* 687934 */     // GIR_Coverage, 4963,
     /* 687934 */     GIR_EraseRootFromParent_Done,
     /* 687935 */   // Label 8858: @687935
     /* 687935 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(688035), // Rule ID 4967 //
     /* 687940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687943 */     // MIs[0] offset
     /* 687943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687946 */     // MIs[0] auxiliary
     /* 687946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687949 */     // MIs[0] Operand 7
     /* 687949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687959 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 687962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 687966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 687971 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 687975 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 687978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 687982 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 687985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 687990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 687995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 688003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 688008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688015 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688017 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688023 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688033 */     GIR_RootConstrainSelectedInstOperands,
     /* 688034 */     // GIR_Coverage, 4967,
     /* 688034 */     GIR_EraseRootFromParent_Done,
     /* 688035 */   // Label 8859: @688035
     /* 688035 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(688132), // Rule ID 4971 //
     /* 688040 */     // MIs[0] offset
     /* 688040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688043 */     // MIs[0] auxiliary
     /* 688043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688046 */     // MIs[0] Operand 7
     /* 688046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688056 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 688059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 688063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 688068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 688072 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 688075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 688079 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 688082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 688087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 688100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 688105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688112 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688114 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688120 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688130 */     GIR_RootConstrainSelectedInstOperands,
     /* 688131 */     // GIR_Coverage, 4971,
     /* 688131 */     GIR_EraseRootFromParent_Done,
     /* 688132 */   // Label 8860: @688132
     /* 688132 */   GIM_Reject,
     /* 688133 */ // Label 8844: @688133
     /* 688133 */ GIM_Reject,
     /* 688134 */ // Label 8756: @688134
     /* 688134 */ GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(689348),
     /* 688139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 688142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 688145 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 688148 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 688151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 688155 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(688227), // Rule ID 4908 //
     /* 688160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688171 */     // MIs[0] offset
     /* 688171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688174 */     // MIs[0] auxiliary
     /* 688174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688177 */     // MIs[0] Operand 7
     /* 688177 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688195 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 688198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688207 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688209 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688225 */     GIR_RootConstrainSelectedInstOperands,
     /* 688226 */     // GIR_Coverage, 4908,
     /* 688226 */     GIR_EraseRootFromParent_Done,
     /* 688227 */   // Label 8862: @688227
     /* 688227 */   GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(688296), // Rule ID 4912 //
     /* 688232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688240 */     // MIs[0] offset
     /* 688240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688243 */     // MIs[0] auxiliary
     /* 688243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688246 */     // MIs[0] Operand 7
     /* 688246 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688264 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 688267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688276 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688278 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688284 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688294 */     GIR_RootConstrainSelectedInstOperands,
     /* 688295 */     // GIR_Coverage, 4912,
     /* 688295 */     GIR_EraseRootFromParent_Done,
     /* 688296 */   // Label 8863: @688296
     /* 688296 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(688368), // Rule ID 4916 //
     /* 688301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688312 */     // MIs[0] offset
     /* 688312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688315 */     // MIs[0] auxiliary
     /* 688315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688318 */     // MIs[0] Operand 7
     /* 688318 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688336 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 688339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688348 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688350 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688366 */     GIR_RootConstrainSelectedInstOperands,
     /* 688367 */     // GIR_Coverage, 4916,
     /* 688367 */     GIR_EraseRootFromParent_Done,
     /* 688368 */   // Label 8864: @688368
     /* 688368 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(688437), // Rule ID 4920 //
     /* 688373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688381 */     // MIs[0] offset
     /* 688381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688384 */     // MIs[0] auxiliary
     /* 688384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688387 */     // MIs[0] Operand 7
     /* 688387 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688405 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 688408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688417 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688435 */     GIR_RootConstrainSelectedInstOperands,
     /* 688436 */     // GIR_Coverage, 4920,
     /* 688436 */     GIR_EraseRootFromParent_Done,
     /* 688437 */   // Label 8865: @688437
     /* 688437 */   GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(688507), // Rule ID 4909 //
     /* 688442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688449 */     // MIs[0] offset
     /* 688449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688452 */     // MIs[0] auxiliary
     /* 688452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688455 */     // MIs[0] Operand 7
     /* 688455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688473 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 688476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688478 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 688480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688487 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688495 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688505 */     GIR_RootConstrainSelectedInstOperands,
     /* 688506 */     // GIR_Coverage, 4909,
     /* 688506 */     GIR_EraseRootFromParent_Done,
     /* 688507 */   // Label 8866: @688507
     /* 688507 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(688574), // Rule ID 4913 //
     /* 688512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688516 */     // MIs[0] offset
     /* 688516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688519 */     // MIs[0] auxiliary
     /* 688519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688522 */     // MIs[0] Operand 7
     /* 688522 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688540 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 688543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688545 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 688547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688554 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688556 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688562 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688572 */     GIR_RootConstrainSelectedInstOperands,
     /* 688573 */     // GIR_Coverage, 4913,
     /* 688573 */     GIR_EraseRootFromParent_Done,
     /* 688574 */   // Label 8867: @688574
     /* 688574 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(688644), // Rule ID 4917 //
     /* 688579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688586 */     // MIs[0] offset
     /* 688586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688589 */     // MIs[0] auxiliary
     /* 688589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688592 */     // MIs[0] Operand 7
     /* 688592 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688610 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 688613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688615 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 688617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688624 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688626 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688632 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688642 */     GIR_RootConstrainSelectedInstOperands,
     /* 688643 */     // GIR_Coverage, 4917,
     /* 688643 */     GIR_EraseRootFromParent_Done,
     /* 688644 */   // Label 8868: @688644
     /* 688644 */   GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(688711), // Rule ID 4921 //
     /* 688649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688653 */     // MIs[0] offset
     /* 688653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688656 */     // MIs[0] auxiliary
     /* 688656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688659 */     // MIs[0] Operand 7
     /* 688659 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688677 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 688680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688682 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 688684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688691 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688709 */     GIR_RootConstrainSelectedInstOperands,
     /* 688710 */     // GIR_Coverage, 4921,
     /* 688710 */     GIR_EraseRootFromParent_Done,
     /* 688711 */   // Label 8869: @688711
     /* 688711 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(688773), // Rule ID 4910 //
     /* 688716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688723 */     // MIs[0] offset
     /* 688723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688726 */     // MIs[0] auxiliary
     /* 688726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688729 */     // MIs[0] Operand 7
     /* 688729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688739 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 688742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688744 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 688746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688753 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688755 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688761 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688771 */     GIR_RootConstrainSelectedInstOperands,
     /* 688772 */     // GIR_Coverage, 4910,
     /* 688772 */     GIR_EraseRootFromParent_Done,
     /* 688773 */   // Label 8870: @688773
     /* 688773 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(688832), // Rule ID 4914 //
     /* 688778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688782 */     // MIs[0] offset
     /* 688782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688785 */     // MIs[0] auxiliary
     /* 688785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688788 */     // MIs[0] Operand 7
     /* 688788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688798 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 688801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688803 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 688805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688812 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688820 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688830 */     GIR_RootConstrainSelectedInstOperands,
     /* 688831 */     // GIR_Coverage, 4914,
     /* 688831 */     GIR_EraseRootFromParent_Done,
     /* 688832 */   // Label 8871: @688832
     /* 688832 */   GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(688894), // Rule ID 4918 //
     /* 688837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688844 */     // MIs[0] offset
     /* 688844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688847 */     // MIs[0] auxiliary
     /* 688847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688850 */     // MIs[0] Operand 7
     /* 688850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688860 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 688863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688865 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 688867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688874 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688876 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688882 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688892 */     GIR_RootConstrainSelectedInstOperands,
     /* 688893 */     // GIR_Coverage, 4918,
     /* 688893 */     GIR_EraseRootFromParent_Done,
     /* 688894 */   // Label 8872: @688894
     /* 688894 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(688953), // Rule ID 4922 //
     /* 688899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688903 */     // MIs[0] offset
     /* 688903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688906 */     // MIs[0] auxiliary
     /* 688906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688909 */     // MIs[0] Operand 7
     /* 688909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688919 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 688922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688924 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 688926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688933 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688935 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688941 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688951 */     GIR_RootConstrainSelectedInstOperands,
     /* 688952 */     // GIR_Coverage, 4922,
     /* 688952 */     GIR_EraseRootFromParent_Done,
     /* 688953 */   // Label 8873: @688953
     /* 688953 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(689053), // Rule ID 4911 //
     /* 688958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688961 */     // MIs[0] offset
     /* 688961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688964 */     // MIs[0] auxiliary
     /* 688964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688967 */     // MIs[0] Operand 7
     /* 688967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688977 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 688980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 688984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 688989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 688993 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 688996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 689000 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 689003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 689008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 689021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 689026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689033 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689035 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689041 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689051 */     GIR_RootConstrainSelectedInstOperands,
     /* 689052 */     // GIR_Coverage, 4911,
     /* 689052 */     GIR_EraseRootFromParent_Done,
     /* 689053 */   // Label 8874: @689053
     /* 689053 */   GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(689150), // Rule ID 4915 //
     /* 689058 */     // MIs[0] offset
     /* 689058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689061 */     // MIs[0] auxiliary
     /* 689061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689064 */     // MIs[0] Operand 7
     /* 689064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689074 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 689077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 689081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 689086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 689090 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 689093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 689097 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 689100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 689105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 689118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 689123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689130 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689132 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689138 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689148 */     GIR_RootConstrainSelectedInstOperands,
     /* 689149 */     // GIR_Coverage, 4915,
     /* 689149 */     GIR_EraseRootFromParent_Done,
     /* 689150 */   // Label 8875: @689150
     /* 689150 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(689250), // Rule ID 4919 //
     /* 689155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689158 */     // MIs[0] offset
     /* 689158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689161 */     // MIs[0] auxiliary
     /* 689161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689164 */     // MIs[0] Operand 7
     /* 689164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689174 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 689177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 689181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 689186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 689190 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 689193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 689197 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 689200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 689205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 689218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 689223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689230 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689232 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689248 */     GIR_RootConstrainSelectedInstOperands,
     /* 689249 */     // GIR_Coverage, 4919,
     /* 689249 */     GIR_EraseRootFromParent_Done,
     /* 689250 */   // Label 8876: @689250
     /* 689250 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(689347), // Rule ID 4923 //
     /* 689255 */     // MIs[0] offset
     /* 689255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689258 */     // MIs[0] auxiliary
     /* 689258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689261 */     // MIs[0] Operand 7
     /* 689261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689271 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 689274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 689278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 689283 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 689287 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 689290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 689294 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 689297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 689302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 689315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 689320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689327 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689329 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689335 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689345 */     GIR_RootConstrainSelectedInstOperands,
     /* 689346 */     // GIR_Coverage, 4923,
     /* 689346 */     GIR_EraseRootFromParent_Done,
     /* 689347 */   // Label 8877: @689347
     /* 689347 */   GIM_Reject,
     /* 689348 */ // Label 8861: @689348
     /* 689348 */ GIM_Reject,
     /* 689349 */ // Label 8757: @689349
     /* 689349 */ GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(690563),
     /* 689354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 689357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 689360 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 689363 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 689366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 689370 */   GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(689442), // Rule ID 4972 //
     /* 689375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689386 */     // MIs[0] offset
     /* 689386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689389 */     // MIs[0] auxiliary
     /* 689389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689392 */     // MIs[0] Operand 7
     /* 689392 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689410 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 689413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689422 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689440 */     GIR_RootConstrainSelectedInstOperands,
     /* 689441 */     // GIR_Coverage, 4972,
     /* 689441 */     GIR_EraseRootFromParent_Done,
     /* 689442 */   // Label 8879: @689442
     /* 689442 */   GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(689511), // Rule ID 4976 //
     /* 689447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689455 */     // MIs[0] offset
     /* 689455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689458 */     // MIs[0] auxiliary
     /* 689458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689461 */     // MIs[0] Operand 7
     /* 689461 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689479 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 689482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689491 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689493 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689509 */     GIR_RootConstrainSelectedInstOperands,
     /* 689510 */     // GIR_Coverage, 4976,
     /* 689510 */     GIR_EraseRootFromParent_Done,
     /* 689511 */   // Label 8880: @689511
     /* 689511 */   GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(689583), // Rule ID 4980 //
     /* 689516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689527 */     // MIs[0] offset
     /* 689527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689530 */     // MIs[0] auxiliary
     /* 689530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689533 */     // MIs[0] Operand 7
     /* 689533 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689551 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 689554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689563 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689565 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689581 */     GIR_RootConstrainSelectedInstOperands,
     /* 689582 */     // GIR_Coverage, 4980,
     /* 689582 */     GIR_EraseRootFromParent_Done,
     /* 689583 */   // Label 8881: @689583
     /* 689583 */   GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(689652), // Rule ID 4984 //
     /* 689588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689596 */     // MIs[0] offset
     /* 689596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689599 */     // MIs[0] auxiliary
     /* 689599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689602 */     // MIs[0] Operand 7
     /* 689602 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689620 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 689623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689632 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689634 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689650 */     GIR_RootConstrainSelectedInstOperands,
     /* 689651 */     // GIR_Coverage, 4984,
     /* 689651 */     GIR_EraseRootFromParent_Done,
     /* 689652 */   // Label 8882: @689652
     /* 689652 */   GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(689722), // Rule ID 4973 //
     /* 689657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689664 */     // MIs[0] offset
     /* 689664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689667 */     // MIs[0] auxiliary
     /* 689667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689670 */     // MIs[0] Operand 7
     /* 689670 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689688 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 689691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689693 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 689695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689702 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689720 */     GIR_RootConstrainSelectedInstOperands,
     /* 689721 */     // GIR_Coverage, 4973,
     /* 689721 */     GIR_EraseRootFromParent_Done,
     /* 689722 */   // Label 8883: @689722
     /* 689722 */   GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(689789), // Rule ID 4977 //
     /* 689727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689731 */     // MIs[0] offset
     /* 689731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689734 */     // MIs[0] auxiliary
     /* 689734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689737 */     // MIs[0] Operand 7
     /* 689737 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689755 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 689758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689760 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 689762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689769 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689771 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689787 */     GIR_RootConstrainSelectedInstOperands,
     /* 689788 */     // GIR_Coverage, 4977,
     /* 689788 */     GIR_EraseRootFromParent_Done,
     /* 689789 */   // Label 8884: @689789
     /* 689789 */   GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(689859), // Rule ID 4981 //
     /* 689794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689801 */     // MIs[0] offset
     /* 689801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689804 */     // MIs[0] auxiliary
     /* 689804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689807 */     // MIs[0] Operand 7
     /* 689807 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689825 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 689828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689830 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 689832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689839 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689841 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689847 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689857 */     GIR_RootConstrainSelectedInstOperands,
     /* 689858 */     // GIR_Coverage, 4981,
     /* 689858 */     GIR_EraseRootFromParent_Done,
     /* 689859 */   // Label 8885: @689859
     /* 689859 */   GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(689926), // Rule ID 4985 //
     /* 689864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689868 */     // MIs[0] offset
     /* 689868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689871 */     // MIs[0] auxiliary
     /* 689871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689874 */     // MIs[0] Operand 7
     /* 689874 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689892 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 689895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689897 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 689899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689906 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689908 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689914 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689924 */     GIR_RootConstrainSelectedInstOperands,
     /* 689925 */     // GIR_Coverage, 4985,
     /* 689925 */     GIR_EraseRootFromParent_Done,
     /* 689926 */   // Label 8886: @689926
     /* 689926 */   GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(689988), // Rule ID 4974 //
     /* 689931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689938 */     // MIs[0] offset
     /* 689938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689941 */     // MIs[0] auxiliary
     /* 689941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689944 */     // MIs[0] Operand 7
     /* 689944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689954 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 689957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689959 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 689961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689968 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689970 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689986 */     GIR_RootConstrainSelectedInstOperands,
     /* 689987 */     // GIR_Coverage, 4974,
     /* 689987 */     GIR_EraseRootFromParent_Done,
     /* 689988 */   // Label 8887: @689988
     /* 689988 */   GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(690047), // Rule ID 4978 //
     /* 689993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689997 */     // MIs[0] offset
     /* 689997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690000 */     // MIs[0] auxiliary
     /* 690000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690003 */     // MIs[0] Operand 7
     /* 690003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690013 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 690016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690018 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 690020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690027 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690029 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690035 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690045 */     GIR_RootConstrainSelectedInstOperands,
     /* 690046 */     // GIR_Coverage, 4978,
     /* 690046 */     GIR_EraseRootFromParent_Done,
     /* 690047 */   // Label 8888: @690047
     /* 690047 */   GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(690109), // Rule ID 4982 //
     /* 690052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690059 */     // MIs[0] offset
     /* 690059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690062 */     // MIs[0] auxiliary
     /* 690062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690065 */     // MIs[0] Operand 7
     /* 690065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690075 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 690078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690080 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 690082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690089 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690091 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690097 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690107 */     GIR_RootConstrainSelectedInstOperands,
     /* 690108 */     // GIR_Coverage, 4982,
     /* 690108 */     GIR_EraseRootFromParent_Done,
     /* 690109 */   // Label 8889: @690109
     /* 690109 */   GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(690168), // Rule ID 4986 //
     /* 690114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690118 */     // MIs[0] offset
     /* 690118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690121 */     // MIs[0] auxiliary
     /* 690121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690124 */     // MIs[0] Operand 7
     /* 690124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690134 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 690137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690139 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 690141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690148 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690150 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690156 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690166 */     GIR_RootConstrainSelectedInstOperands,
     /* 690167 */     // GIR_Coverage, 4986,
     /* 690167 */     GIR_EraseRootFromParent_Done,
     /* 690168 */   // Label 8890: @690168
     /* 690168 */   GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(690268), // Rule ID 4975 //
     /* 690173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690176 */     // MIs[0] offset
     /* 690176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690179 */     // MIs[0] auxiliary
     /* 690179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690182 */     // MIs[0] Operand 7
     /* 690182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690192 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 690195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 690199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 690204 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 690208 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 690211 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 690215 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 690218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 690223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 690236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 690241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690248 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690250 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690256 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690266 */     GIR_RootConstrainSelectedInstOperands,
     /* 690267 */     // GIR_Coverage, 4975,
     /* 690267 */     GIR_EraseRootFromParent_Done,
     /* 690268 */   // Label 8891: @690268
     /* 690268 */   GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(690365), // Rule ID 4979 //
     /* 690273 */     // MIs[0] offset
     /* 690273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690276 */     // MIs[0] auxiliary
     /* 690276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690279 */     // MIs[0] Operand 7
     /* 690279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690289 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 690292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 690296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 690301 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 690305 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 690308 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 690312 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 690315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 690320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 690333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 690338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690345 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690347 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690353 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690363 */     GIR_RootConstrainSelectedInstOperands,
     /* 690364 */     // GIR_Coverage, 4979,
     /* 690364 */     GIR_EraseRootFromParent_Done,
     /* 690365 */   // Label 8892: @690365
     /* 690365 */   GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(690465), // Rule ID 4983 //
     /* 690370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690373 */     // MIs[0] offset
     /* 690373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690376 */     // MIs[0] auxiliary
     /* 690376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690379 */     // MIs[0] Operand 7
     /* 690379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690389 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 690392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 690396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 690401 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 690405 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 690408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 690412 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 690415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 690420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 690433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 690438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690445 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690447 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690453 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690463 */     GIR_RootConstrainSelectedInstOperands,
     /* 690464 */     // GIR_Coverage, 4983,
     /* 690464 */     GIR_EraseRootFromParent_Done,
     /* 690465 */   // Label 8893: @690465
     /* 690465 */   GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(690562), // Rule ID 4987 //
     /* 690470 */     // MIs[0] offset
     /* 690470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690473 */     // MIs[0] auxiliary
     /* 690473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690476 */     // MIs[0] Operand 7
     /* 690476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690486 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 690489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 690493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 690498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 690502 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 690505 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 690509 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 690512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 690517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 690530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 690535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690542 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690544 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690550 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690560 */     GIR_RootConstrainSelectedInstOperands,
     /* 690561 */     // GIR_Coverage, 4987,
     /* 690561 */     GIR_EraseRootFromParent_Done,
     /* 690562 */   // Label 8894: @690562
     /* 690562 */   GIM_Reject,
     /* 690563 */ // Label 8878: @690563
     /* 690563 */ GIM_Reject,
     /* 690564 */ // Label 8758: @690564
     /* 690564 */ GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(691778),
     /* 690569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 690572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 690575 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 690578 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 690581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 690585 */   GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(690657), // Rule ID 5060 //
     /* 690590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690601 */     // MIs[0] offset
     /* 690601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690604 */     // MIs[0] auxiliary
     /* 690604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690607 */     // MIs[0] Operand 7
     /* 690607 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690625 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 690628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690637 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690639 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690645 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690655 */     GIR_RootConstrainSelectedInstOperands,
     /* 690656 */     // GIR_Coverage, 5060,
     /* 690656 */     GIR_EraseRootFromParent_Done,
     /* 690657 */   // Label 8896: @690657
     /* 690657 */   GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(690726), // Rule ID 5064 //
     /* 690662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690670 */     // MIs[0] offset
     /* 690670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690673 */     // MIs[0] auxiliary
     /* 690673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690676 */     // MIs[0] Operand 7
     /* 690676 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690694 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 690697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690706 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690708 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690714 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690724 */     GIR_RootConstrainSelectedInstOperands,
     /* 690725 */     // GIR_Coverage, 5064,
     /* 690725 */     GIR_EraseRootFromParent_Done,
     /* 690726 */   // Label 8897: @690726
     /* 690726 */   GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(690798), // Rule ID 5068 //
     /* 690731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690742 */     // MIs[0] offset
     /* 690742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690745 */     // MIs[0] auxiliary
     /* 690745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690748 */     // MIs[0] Operand 7
     /* 690748 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690766 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 690769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690778 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690786 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690796 */     GIR_RootConstrainSelectedInstOperands,
     /* 690797 */     // GIR_Coverage, 5068,
     /* 690797 */     GIR_EraseRootFromParent_Done,
     /* 690798 */   // Label 8898: @690798
     /* 690798 */   GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(690867), // Rule ID 5072 //
     /* 690803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690811 */     // MIs[0] offset
     /* 690811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690814 */     // MIs[0] auxiliary
     /* 690814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690817 */     // MIs[0] Operand 7
     /* 690817 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690835 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 690838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690847 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690849 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690855 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690865 */     GIR_RootConstrainSelectedInstOperands,
     /* 690866 */     // GIR_Coverage, 5072,
     /* 690866 */     GIR_EraseRootFromParent_Done,
     /* 690867 */   // Label 8899: @690867
     /* 690867 */   GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(690937), // Rule ID 5061 //
     /* 690872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690879 */     // MIs[0] offset
     /* 690879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690882 */     // MIs[0] auxiliary
     /* 690882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690885 */     // MIs[0] Operand 7
     /* 690885 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690903 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 690906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690908 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 690910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690917 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690919 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690935 */     GIR_RootConstrainSelectedInstOperands,
     /* 690936 */     // GIR_Coverage, 5061,
     /* 690936 */     GIR_EraseRootFromParent_Done,
     /* 690937 */   // Label 8900: @690937
     /* 690937 */   GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(691004), // Rule ID 5065 //
     /* 690942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690946 */     // MIs[0] offset
     /* 690946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690949 */     // MIs[0] auxiliary
     /* 690949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690952 */     // MIs[0] Operand 7
     /* 690952 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690970 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 690973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690975 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 690977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690984 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690986 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691002 */     GIR_RootConstrainSelectedInstOperands,
     /* 691003 */     // GIR_Coverage, 5065,
     /* 691003 */     GIR_EraseRootFromParent_Done,
     /* 691004 */   // Label 8901: @691004
     /* 691004 */   GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(691074), // Rule ID 5069 //
     /* 691009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691016 */     // MIs[0] offset
     /* 691016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691019 */     // MIs[0] auxiliary
     /* 691019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691022 */     // MIs[0] Operand 7
     /* 691022 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691040 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 691043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691045 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 691047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691054 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691056 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691062 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691072 */     GIR_RootConstrainSelectedInstOperands,
     /* 691073 */     // GIR_Coverage, 5069,
     /* 691073 */     GIR_EraseRootFromParent_Done,
     /* 691074 */   // Label 8902: @691074
     /* 691074 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(691141), // Rule ID 5073 //
     /* 691079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691083 */     // MIs[0] offset
     /* 691083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691086 */     // MIs[0] auxiliary
     /* 691086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691089 */     // MIs[0] Operand 7
     /* 691089 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691107 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 691110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691112 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 691114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691121 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691123 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691129 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691139 */     GIR_RootConstrainSelectedInstOperands,
     /* 691140 */     // GIR_Coverage, 5073,
     /* 691140 */     GIR_EraseRootFromParent_Done,
     /* 691141 */   // Label 8903: @691141
     /* 691141 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(691203), // Rule ID 5062 //
     /* 691146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691153 */     // MIs[0] offset
     /* 691153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691156 */     // MIs[0] auxiliary
     /* 691156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691159 */     // MIs[0] Operand 7
     /* 691159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691169 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 691172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691174 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 691176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691183 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691185 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691191 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691201 */     GIR_RootConstrainSelectedInstOperands,
     /* 691202 */     // GIR_Coverage, 5062,
     /* 691202 */     GIR_EraseRootFromParent_Done,
     /* 691203 */   // Label 8904: @691203
     /* 691203 */   GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(691262), // Rule ID 5066 //
     /* 691208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691212 */     // MIs[0] offset
     /* 691212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691215 */     // MIs[0] auxiliary
     /* 691215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691218 */     // MIs[0] Operand 7
     /* 691218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691228 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 691231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691233 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 691235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691242 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691250 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691260 */     GIR_RootConstrainSelectedInstOperands,
     /* 691261 */     // GIR_Coverage, 5066,
     /* 691261 */     GIR_EraseRootFromParent_Done,
     /* 691262 */   // Label 8905: @691262
     /* 691262 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(691324), // Rule ID 5070 //
     /* 691267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691274 */     // MIs[0] offset
     /* 691274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691277 */     // MIs[0] auxiliary
     /* 691277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691280 */     // MIs[0] Operand 7
     /* 691280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691290 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 691293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691295 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 691297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691304 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691306 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691312 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691322 */     GIR_RootConstrainSelectedInstOperands,
     /* 691323 */     // GIR_Coverage, 5070,
     /* 691323 */     GIR_EraseRootFromParent_Done,
     /* 691324 */   // Label 8906: @691324
     /* 691324 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(691383), // Rule ID 5074 //
     /* 691329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691333 */     // MIs[0] offset
     /* 691333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691336 */     // MIs[0] auxiliary
     /* 691336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691339 */     // MIs[0] Operand 7
     /* 691339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691349 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 691352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691354 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 691356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691363 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691365 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691371 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691381 */     GIR_RootConstrainSelectedInstOperands,
     /* 691382 */     // GIR_Coverage, 5074,
     /* 691382 */     GIR_EraseRootFromParent_Done,
     /* 691383 */   // Label 8907: @691383
     /* 691383 */   GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(691483), // Rule ID 5063 //
     /* 691388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691391 */     // MIs[0] offset
     /* 691391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691394 */     // MIs[0] auxiliary
     /* 691394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691397 */     // MIs[0] Operand 7
     /* 691397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691407 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v2i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 691410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 691414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 691419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 691423 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 691426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 691430 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 691433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 691438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 691451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 691456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691463 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691465 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691471 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691481 */     GIR_RootConstrainSelectedInstOperands,
     /* 691482 */     // GIR_Coverage, 5063,
     /* 691482 */     GIR_EraseRootFromParent_Done,
     /* 691483 */   // Label 8908: @691483
     /* 691483 */   GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(691580), // Rule ID 5067 //
     /* 691488 */     // MIs[0] offset
     /* 691488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691491 */     // MIs[0] auxiliary
     /* 691491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691494 */     // MIs[0] Operand 7
     /* 691494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691504 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v2i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 691507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 691511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 691516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 691520 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 691523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 691527 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 691530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 691535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 691548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 691553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691560 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691562 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691568 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691578 */     GIR_RootConstrainSelectedInstOperands,
     /* 691579 */     // GIR_Coverage, 5067,
     /* 691579 */     GIR_EraseRootFromParent_Done,
     /* 691580 */   // Label 8909: @691580
     /* 691580 */   GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(691680), // Rule ID 5071 //
     /* 691585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691588 */     // MIs[0] offset
     /* 691588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691591 */     // MIs[0] auxiliary
     /* 691591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691594 */     // MIs[0] Operand 7
     /* 691594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691604 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v2f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 691607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 691611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 691616 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 691620 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 691623 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 691627 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 691630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 691635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 691648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 691653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691660 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691662 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691678 */     GIR_RootConstrainSelectedInstOperands,
     /* 691679 */     // GIR_Coverage, 5071,
     /* 691679 */     GIR_EraseRootFromParent_Done,
     /* 691680 */   // Label 8910: @691680
     /* 691680 */   GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(691777), // Rule ID 5075 //
     /* 691685 */     // MIs[0] offset
     /* 691685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691688 */     // MIs[0] auxiliary
     /* 691688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691691 */     // MIs[0] Operand 7
     /* 691691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691701 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v2f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 691704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 691708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 691713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 691717 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 691720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 691724 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 691727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 691732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 691745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 691750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691757 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691759 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691765 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691775 */     GIR_RootConstrainSelectedInstOperands,
     /* 691776 */     // GIR_Coverage, 5075,
     /* 691776 */     GIR_EraseRootFromParent_Done,
     /* 691777 */   // Label 8911: @691777
     /* 691777 */   GIM_Reject,
     /* 691778 */ // Label 8895: @691778
     /* 691778 */ GIM_Reject,
     /* 691779 */ // Label 8759: @691779
     /* 691779 */ GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(692993),
     /* 691784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 691787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 691790 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 691793 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 691796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 691800 */   GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(691872), // Rule ID 5028 //
     /* 691805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691816 */     // MIs[0] offset
     /* 691816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691819 */     // MIs[0] auxiliary
     /* 691819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691822 */     // MIs[0] Operand 7
     /* 691822 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691840 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 691843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691852 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691854 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691860 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691870 */     GIR_RootConstrainSelectedInstOperands,
     /* 691871 */     // GIR_Coverage, 5028,
     /* 691871 */     GIR_EraseRootFromParent_Done,
     /* 691872 */   // Label 8913: @691872
     /* 691872 */   GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(691941), // Rule ID 5032 //
     /* 691877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691885 */     // MIs[0] offset
     /* 691885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691888 */     // MIs[0] auxiliary
     /* 691888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691891 */     // MIs[0] Operand 7
     /* 691891 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691909 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 691912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691921 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691923 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691929 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691939 */     GIR_RootConstrainSelectedInstOperands,
     /* 691940 */     // GIR_Coverage, 5032,
     /* 691940 */     GIR_EraseRootFromParent_Done,
     /* 691941 */   // Label 8914: @691941
     /* 691941 */   GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(692013), // Rule ID 5036 //
     /* 691946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691957 */     // MIs[0] offset
     /* 691957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691960 */     // MIs[0] auxiliary
     /* 691960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691963 */     // MIs[0] Operand 7
     /* 691963 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691981 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 691984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691993 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691995 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692001 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692011 */     GIR_RootConstrainSelectedInstOperands,
     /* 692012 */     // GIR_Coverage, 5036,
     /* 692012 */     GIR_EraseRootFromParent_Done,
     /* 692013 */   // Label 8915: @692013
     /* 692013 */   GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(692082), // Rule ID 5040 //
     /* 692018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692026 */     // MIs[0] offset
     /* 692026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692029 */     // MIs[0] auxiliary
     /* 692029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692032 */     // MIs[0] Operand 7
     /* 692032 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692050 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 692053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692062 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692070 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692080 */     GIR_RootConstrainSelectedInstOperands,
     /* 692081 */     // GIR_Coverage, 5040,
     /* 692081 */     GIR_EraseRootFromParent_Done,
     /* 692082 */   // Label 8916: @692082
     /* 692082 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(692152), // Rule ID 5029 //
     /* 692087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692094 */     // MIs[0] offset
     /* 692094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692097 */     // MIs[0] auxiliary
     /* 692097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692100 */     // MIs[0] Operand 7
     /* 692100 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692118 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFEN),
     /* 692121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692123 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 692125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692132 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692134 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692140 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692150 */     GIR_RootConstrainSelectedInstOperands,
     /* 692151 */     // GIR_Coverage, 5029,
     /* 692151 */     GIR_EraseRootFromParent_Done,
     /* 692152 */   // Label 8917: @692152
     /* 692152 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(692219), // Rule ID 5033 //
     /* 692157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692161 */     // MIs[0] offset
     /* 692161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692164 */     // MIs[0] auxiliary
     /* 692164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692167 */     // MIs[0] Operand 7
     /* 692167 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692185 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN),
     /* 692188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692190 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 692192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692199 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692201 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692207 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692217 */     GIR_RootConstrainSelectedInstOperands,
     /* 692218 */     // GIR_Coverage, 5033,
     /* 692218 */     GIR_EraseRootFromParent_Done,
     /* 692219 */   // Label 8918: @692219
     /* 692219 */   GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(692289), // Rule ID 5037 //
     /* 692224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692231 */     // MIs[0] offset
     /* 692231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692234 */     // MIs[0] auxiliary
     /* 692234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692237 */     // MIs[0] Operand 7
     /* 692237 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692255 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFEN),
     /* 692258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692260 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 692262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692269 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692277 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692287 */     GIR_RootConstrainSelectedInstOperands,
     /* 692288 */     // GIR_Coverage, 5037,
     /* 692288 */     GIR_EraseRootFromParent_Done,
     /* 692289 */   // Label 8919: @692289
     /* 692289 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(692356), // Rule ID 5041 //
     /* 692294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692298 */     // MIs[0] offset
     /* 692298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692301 */     // MIs[0] auxiliary
     /* 692301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692304 */     // MIs[0] Operand 7
     /* 692304 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692322 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN),
     /* 692325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692327 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 692329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692336 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692344 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692354 */     GIR_RootConstrainSelectedInstOperands,
     /* 692355 */     // GIR_Coverage, 5041,
     /* 692355 */     GIR_EraseRootFromParent_Done,
     /* 692356 */   // Label 8920: @692356
     /* 692356 */   GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(692418), // Rule ID 5030 //
     /* 692361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692368 */     // MIs[0] offset
     /* 692368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692371 */     // MIs[0] auxiliary
     /* 692371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692374 */     // MIs[0] Operand 7
     /* 692374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692384 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_IDXEN),
     /* 692387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692389 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 692391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692398 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692400 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692406 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692416 */     GIR_RootConstrainSelectedInstOperands,
     /* 692417 */     // GIR_Coverage, 5030,
     /* 692417 */     GIR_EraseRootFromParent_Done,
     /* 692418 */   // Label 8921: @692418
     /* 692418 */   GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(692477), // Rule ID 5034 //
     /* 692423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692427 */     // MIs[0] offset
     /* 692427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692430 */     // MIs[0] auxiliary
     /* 692430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692433 */     // MIs[0] Operand 7
     /* 692433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692443 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN),
     /* 692446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692448 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 692450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692457 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692459 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692465 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692475 */     GIR_RootConstrainSelectedInstOperands,
     /* 692476 */     // GIR_Coverage, 5034,
     /* 692476 */     GIR_EraseRootFromParent_Done,
     /* 692477 */   // Label 8922: @692477
     /* 692477 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(692539), // Rule ID 5038 //
     /* 692482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692489 */     // MIs[0] offset
     /* 692489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692492 */     // MIs[0] auxiliary
     /* 692492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692495 */     // MIs[0] Operand 7
     /* 692495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692505 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_IDXEN),
     /* 692508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692510 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 692512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692519 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692521 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692527 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692537 */     GIR_RootConstrainSelectedInstOperands,
     /* 692538 */     // GIR_Coverage, 5038,
     /* 692538 */     GIR_EraseRootFromParent_Done,
     /* 692539 */   // Label 8923: @692539
     /* 692539 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(692598), // Rule ID 5042 //
     /* 692544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692548 */     // MIs[0] offset
     /* 692548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692551 */     // MIs[0] auxiliary
     /* 692551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692554 */     // MIs[0] Operand 7
     /* 692554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692564 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN),
     /* 692567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692569 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 692571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692578 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692580 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692586 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692596 */     GIR_RootConstrainSelectedInstOperands,
     /* 692597 */     // GIR_Coverage, 5042,
     /* 692597 */     GIR_EraseRootFromParent_Done,
     /* 692598 */   // Label 8924: @692598
     /* 692598 */   GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(692698), // Rule ID 5031 //
     /* 692603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692606 */     // MIs[0] offset
     /* 692606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692609 */     // MIs[0] auxiliary
     /* 692609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692612 */     // MIs[0] Operand 7
     /* 692612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692622 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 692625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 692629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 692634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 692638 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 692641 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 692645 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 692648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 692653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_BOTHEN),
     /* 692666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 692671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692678 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692680 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692686 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692696 */     GIR_RootConstrainSelectedInstOperands,
     /* 692697 */     // GIR_Coverage, 5031,
     /* 692697 */     GIR_EraseRootFromParent_Done,
     /* 692698 */   // Label 8925: @692698
     /* 692698 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(692795), // Rule ID 5035 //
     /* 692703 */     // MIs[0] offset
     /* 692703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692706 */     // MIs[0] auxiliary
     /* 692706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692709 */     // MIs[0] Operand 7
     /* 692709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692719 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 692722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 692726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 692731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 692735 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 692738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 692742 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 692745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 692750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN),
     /* 692763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 692768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692775 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692783 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692793 */     GIR_RootConstrainSelectedInstOperands,
     /* 692794 */     // GIR_Coverage, 5035,
     /* 692794 */     GIR_EraseRootFromParent_Done,
     /* 692795 */   // Label 8926: @692795
     /* 692795 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(692895), // Rule ID 5039 //
     /* 692800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692803 */     // MIs[0] offset
     /* 692803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692806 */     // MIs[0] auxiliary
     /* 692806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692809 */     // MIs[0] Operand 7
     /* 692809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692819 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 692822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 692826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 692831 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 692835 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 692838 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 692842 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 692845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 692850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_BOTHEN),
     /* 692863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 692868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692875 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692893 */     GIR_RootConstrainSelectedInstOperands,
     /* 692894 */     // GIR_Coverage, 5039,
     /* 692894 */     GIR_EraseRootFromParent_Done,
     /* 692895 */   // Label 8927: @692895
     /* 692895 */   GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(692992), // Rule ID 5043 //
     /* 692900 */     // MIs[0] offset
     /* 692900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692903 */     // MIs[0] auxiliary
     /* 692903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692906 */     // MIs[0] Operand 7
     /* 692906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692916 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 692919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 692923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 692928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 692932 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 692935 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 692939 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 692942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 692947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692952 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN),
     /* 692960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 692965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692972 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692974 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692980 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692990 */     GIR_RootConstrainSelectedInstOperands,
     /* 692991 */     // GIR_Coverage, 5043,
     /* 692991 */     GIR_EraseRootFromParent_Done,
     /* 692992 */   // Label 8928: @692992
     /* 692992 */   GIM_Reject,
     /* 692993 */ // Label 8912: @692993
     /* 692993 */ GIM_Reject,
     /* 692994 */ // Label 8760: @692994
     /* 692994 */ GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(694208),
     /* 692999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 693002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 693005 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 693008 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 693011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 693015 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(693087), // Rule ID 5012 //
     /* 693020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693031 */     // MIs[0] offset
     /* 693031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693034 */     // MIs[0] auxiliary
     /* 693034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693037 */     // MIs[0] Operand 7
     /* 693037 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693055 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 693058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693067 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693069 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693075 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693085 */     GIR_RootConstrainSelectedInstOperands,
     /* 693086 */     // GIR_Coverage, 5012,
     /* 693086 */     GIR_EraseRootFromParent_Done,
     /* 693087 */   // Label 8930: @693087
     /* 693087 */   GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(693156), // Rule ID 5016 //
     /* 693092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693100 */     // MIs[0] offset
     /* 693100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693103 */     // MIs[0] auxiliary
     /* 693103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693106 */     // MIs[0] Operand 7
     /* 693106 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693124 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 693127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693136 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693138 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693144 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693154 */     GIR_RootConstrainSelectedInstOperands,
     /* 693155 */     // GIR_Coverage, 5016,
     /* 693155 */     GIR_EraseRootFromParent_Done,
     /* 693156 */   // Label 8931: @693156
     /* 693156 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(693228), // Rule ID 5020 //
     /* 693161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693172 */     // MIs[0] offset
     /* 693172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693175 */     // MIs[0] auxiliary
     /* 693175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693178 */     // MIs[0] Operand 7
     /* 693178 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693196 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 693199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693208 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693216 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693226 */     GIR_RootConstrainSelectedInstOperands,
     /* 693227 */     // GIR_Coverage, 5020,
     /* 693227 */     GIR_EraseRootFromParent_Done,
     /* 693228 */   // Label 8932: @693228
     /* 693228 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(693297), // Rule ID 5024 //
     /* 693233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693241 */     // MIs[0] offset
     /* 693241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693244 */     // MIs[0] auxiliary
     /* 693244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693247 */     // MIs[0] Operand 7
     /* 693247 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693265 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 693268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693277 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693279 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693285 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693295 */     GIR_RootConstrainSelectedInstOperands,
     /* 693296 */     // GIR_Coverage, 5024,
     /* 693296 */     GIR_EraseRootFromParent_Done,
     /* 693297 */   // Label 8933: @693297
     /* 693297 */   GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(693367), // Rule ID 5013 //
     /* 693302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693309 */     // MIs[0] offset
     /* 693309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693312 */     // MIs[0] auxiliary
     /* 693312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693315 */     // MIs[0] Operand 7
     /* 693315 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693333 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 693336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693338 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 693340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693347 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693349 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693355 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693365 */     GIR_RootConstrainSelectedInstOperands,
     /* 693366 */     // GIR_Coverage, 5013,
     /* 693366 */     GIR_EraseRootFromParent_Done,
     /* 693367 */   // Label 8934: @693367
     /* 693367 */   GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(693434), // Rule ID 5017 //
     /* 693372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693376 */     // MIs[0] offset
     /* 693376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693379 */     // MIs[0] auxiliary
     /* 693379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693382 */     // MIs[0] Operand 7
     /* 693382 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693400 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 693403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693405 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 693407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693414 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693422 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693432 */     GIR_RootConstrainSelectedInstOperands,
     /* 693433 */     // GIR_Coverage, 5017,
     /* 693433 */     GIR_EraseRootFromParent_Done,
     /* 693434 */   // Label 8935: @693434
     /* 693434 */   GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(693504), // Rule ID 5021 //
     /* 693439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693446 */     // MIs[0] offset
     /* 693446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693449 */     // MIs[0] auxiliary
     /* 693449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693452 */     // MIs[0] Operand 7
     /* 693452 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693470 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 693473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693475 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 693477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693484 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693492 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693502 */     GIR_RootConstrainSelectedInstOperands,
     /* 693503 */     // GIR_Coverage, 5021,
     /* 693503 */     GIR_EraseRootFromParent_Done,
     /* 693504 */   // Label 8936: @693504
     /* 693504 */   GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(693571), // Rule ID 5025 //
     /* 693509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693513 */     // MIs[0] offset
     /* 693513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693516 */     // MIs[0] auxiliary
     /* 693516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693519 */     // MIs[0] Operand 7
     /* 693519 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693537 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 693540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693542 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 693544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693551 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693553 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693559 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693569 */     GIR_RootConstrainSelectedInstOperands,
     /* 693570 */     // GIR_Coverage, 5025,
     /* 693570 */     GIR_EraseRootFromParent_Done,
     /* 693571 */   // Label 8937: @693571
     /* 693571 */   GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(693633), // Rule ID 5014 //
     /* 693576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693583 */     // MIs[0] offset
     /* 693583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693586 */     // MIs[0] auxiliary
     /* 693586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693589 */     // MIs[0] Operand 7
     /* 693589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693599 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 693602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693604 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 693606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693613 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693615 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693621 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693631 */     GIR_RootConstrainSelectedInstOperands,
     /* 693632 */     // GIR_Coverage, 5014,
     /* 693632 */     GIR_EraseRootFromParent_Done,
     /* 693633 */   // Label 8938: @693633
     /* 693633 */   GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(693692), // Rule ID 5018 //
     /* 693638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693642 */     // MIs[0] offset
     /* 693642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693645 */     // MIs[0] auxiliary
     /* 693645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693648 */     // MIs[0] Operand 7
     /* 693648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693658 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 693661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693663 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 693665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693672 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693674 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693680 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693690 */     GIR_RootConstrainSelectedInstOperands,
     /* 693691 */     // GIR_Coverage, 5018,
     /* 693691 */     GIR_EraseRootFromParent_Done,
     /* 693692 */   // Label 8939: @693692
     /* 693692 */   GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(693754), // Rule ID 5022 //
     /* 693697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693704 */     // MIs[0] offset
     /* 693704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693707 */     // MIs[0] auxiliary
     /* 693707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693710 */     // MIs[0] Operand 7
     /* 693710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693720 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 693723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693725 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 693727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693734 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693742 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693752 */     GIR_RootConstrainSelectedInstOperands,
     /* 693753 */     // GIR_Coverage, 5022,
     /* 693753 */     GIR_EraseRootFromParent_Done,
     /* 693754 */   // Label 8940: @693754
     /* 693754 */   GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(693813), // Rule ID 5026 //
     /* 693759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693763 */     // MIs[0] offset
     /* 693763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693766 */     // MIs[0] auxiliary
     /* 693766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693769 */     // MIs[0] Operand 7
     /* 693769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693779 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 693782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693784 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 693786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693793 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693795 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693801 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693811 */     GIR_RootConstrainSelectedInstOperands,
     /* 693812 */     // GIR_Coverage, 5026,
     /* 693812 */     GIR_EraseRootFromParent_Done,
     /* 693813 */   // Label 8941: @693813
     /* 693813 */   GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(693913), // Rule ID 5015 //
     /* 693818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693821 */     // MIs[0] offset
     /* 693821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693824 */     // MIs[0] auxiliary
     /* 693824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693827 */     // MIs[0] Operand 7
     /* 693827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693837 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 693840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 693844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 693849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 693853 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 693856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 693860 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 693863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 693868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 693881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 693886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693893 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693895 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693901 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693911 */     GIR_RootConstrainSelectedInstOperands,
     /* 693912 */     // GIR_Coverage, 5015,
     /* 693912 */     GIR_EraseRootFromParent_Done,
     /* 693913 */   // Label 8942: @693913
     /* 693913 */   GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(694010), // Rule ID 5019 //
     /* 693918 */     // MIs[0] offset
     /* 693918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693921 */     // MIs[0] auxiliary
     /* 693921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693924 */     // MIs[0] Operand 7
     /* 693924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693934 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 693937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 693941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 693946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 693950 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 693953 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 693957 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 693960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 693965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 693978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 693983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693990 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693998 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694008 */     GIR_RootConstrainSelectedInstOperands,
     /* 694009 */     // GIR_Coverage, 5019,
     /* 694009 */     GIR_EraseRootFromParent_Done,
     /* 694010 */   // Label 8943: @694010
     /* 694010 */   GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(694110), // Rule ID 5023 //
     /* 694015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694018 */     // MIs[0] offset
     /* 694018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694021 */     // MIs[0] auxiliary
     /* 694021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694024 */     // MIs[0] Operand 7
     /* 694024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694034 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 694037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 694041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 694046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 694050 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 694053 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 694057 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 694060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 694065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 694078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 694083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694090 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694092 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694098 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694108 */     GIR_RootConstrainSelectedInstOperands,
     /* 694109 */     // GIR_Coverage, 5023,
     /* 694109 */     GIR_EraseRootFromParent_Done,
     /* 694110 */   // Label 8944: @694110
     /* 694110 */   GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(694207), // Rule ID 5027 //
     /* 694115 */     // MIs[0] offset
     /* 694115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694118 */     // MIs[0] auxiliary
     /* 694118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694121 */     // MIs[0] Operand 7
     /* 694121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694131 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 694134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 694138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 694143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 694147 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 694150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 694154 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 694157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 694162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 694175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 694180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694187 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694189 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694195 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694205 */     GIR_RootConstrainSelectedInstOperands,
     /* 694206 */     // GIR_Coverage, 5027,
     /* 694206 */     GIR_EraseRootFromParent_Done,
     /* 694207 */   // Label 8945: @694207
     /* 694207 */   GIM_Reject,
     /* 694208 */ // Label 8929: @694208
     /* 694208 */ GIM_Reject,
     /* 694209 */ // Label 8761: @694209
     /* 694209 */ GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(695423),
     /* 694214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 694217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 694220 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 694223 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 694226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 694230 */   GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(694302), // Rule ID 5044 //
     /* 694235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694246 */     // MIs[0] offset
     /* 694246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694249 */     // MIs[0] auxiliary
     /* 694249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694252 */     // MIs[0] Operand 7
     /* 694252 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694270 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 694273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694282 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694284 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694290 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694300 */     GIR_RootConstrainSelectedInstOperands,
     /* 694301 */     // GIR_Coverage, 5044,
     /* 694301 */     GIR_EraseRootFromParent_Done,
     /* 694302 */   // Label 8947: @694302
     /* 694302 */   GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(694371), // Rule ID 5048 //
     /* 694307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694315 */     // MIs[0] offset
     /* 694315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694318 */     // MIs[0] auxiliary
     /* 694318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694321 */     // MIs[0] Operand 7
     /* 694321 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694339 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 694342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694351 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694353 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694359 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694369 */     GIR_RootConstrainSelectedInstOperands,
     /* 694370 */     // GIR_Coverage, 5048,
     /* 694370 */     GIR_EraseRootFromParent_Done,
     /* 694371 */   // Label 8948: @694371
     /* 694371 */   GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(694443), // Rule ID 5052 //
     /* 694376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694387 */     // MIs[0] offset
     /* 694387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694390 */     // MIs[0] auxiliary
     /* 694390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694393 */     // MIs[0] Operand 7
     /* 694393 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694411 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 694414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694423 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694431 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694441 */     GIR_RootConstrainSelectedInstOperands,
     /* 694442 */     // GIR_Coverage, 5052,
     /* 694442 */     GIR_EraseRootFromParent_Done,
     /* 694443 */   // Label 8949: @694443
     /* 694443 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(694512), // Rule ID 5056 //
     /* 694448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694456 */     // MIs[0] offset
     /* 694456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694459 */     // MIs[0] auxiliary
     /* 694459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694462 */     // MIs[0] Operand 7
     /* 694462 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694480 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 694483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694492 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694494 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694500 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694510 */     GIR_RootConstrainSelectedInstOperands,
     /* 694511 */     // GIR_Coverage, 5056,
     /* 694511 */     GIR_EraseRootFromParent_Done,
     /* 694512 */   // Label 8950: @694512
     /* 694512 */   GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(694582), // Rule ID 5045 //
     /* 694517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694524 */     // MIs[0] offset
     /* 694524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694527 */     // MIs[0] auxiliary
     /* 694527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694530 */     // MIs[0] Operand 7
     /* 694530 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694548 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 694551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694553 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 694555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694562 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694570 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694580 */     GIR_RootConstrainSelectedInstOperands,
     /* 694581 */     // GIR_Coverage, 5045,
     /* 694581 */     GIR_EraseRootFromParent_Done,
     /* 694582 */   // Label 8951: @694582
     /* 694582 */   GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(694649), // Rule ID 5049 //
     /* 694587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694591 */     // MIs[0] offset
     /* 694591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694594 */     // MIs[0] auxiliary
     /* 694594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694597 */     // MIs[0] Operand 7
     /* 694597 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694615 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 694618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694620 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 694622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694629 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694631 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694637 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694647 */     GIR_RootConstrainSelectedInstOperands,
     /* 694648 */     // GIR_Coverage, 5049,
     /* 694648 */     GIR_EraseRootFromParent_Done,
     /* 694649 */   // Label 8952: @694649
     /* 694649 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(694719), // Rule ID 5053 //
     /* 694654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694661 */     // MIs[0] offset
     /* 694661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694664 */     // MIs[0] auxiliary
     /* 694664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694667 */     // MIs[0] Operand 7
     /* 694667 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694685 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 694688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694690 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 694692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694699 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694701 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694707 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694717 */     GIR_RootConstrainSelectedInstOperands,
     /* 694718 */     // GIR_Coverage, 5053,
     /* 694718 */     GIR_EraseRootFromParent_Done,
     /* 694719 */   // Label 8953: @694719
     /* 694719 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(694786), // Rule ID 5057 //
     /* 694724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694728 */     // MIs[0] offset
     /* 694728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694731 */     // MIs[0] auxiliary
     /* 694731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694734 */     // MIs[0] Operand 7
     /* 694734 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694752 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 694755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694757 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 694759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694766 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694774 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694784 */     GIR_RootConstrainSelectedInstOperands,
     /* 694785 */     // GIR_Coverage, 5057,
     /* 694785 */     GIR_EraseRootFromParent_Done,
     /* 694786 */   // Label 8954: @694786
     /* 694786 */   GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(694848), // Rule ID 5046 //
     /* 694791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694798 */     // MIs[0] offset
     /* 694798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694801 */     // MIs[0] auxiliary
     /* 694801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694804 */     // MIs[0] Operand 7
     /* 694804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694814 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 694817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694819 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 694821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694828 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694830 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694836 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694846 */     GIR_RootConstrainSelectedInstOperands,
     /* 694847 */     // GIR_Coverage, 5046,
     /* 694847 */     GIR_EraseRootFromParent_Done,
     /* 694848 */   // Label 8955: @694848
     /* 694848 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(694907), // Rule ID 5050 //
     /* 694853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694857 */     // MIs[0] offset
     /* 694857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694860 */     // MIs[0] auxiliary
     /* 694860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694863 */     // MIs[0] Operand 7
     /* 694863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694873 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 694876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694878 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 694880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694887 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694889 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694895 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694905 */     GIR_RootConstrainSelectedInstOperands,
     /* 694906 */     // GIR_Coverage, 5050,
     /* 694906 */     GIR_EraseRootFromParent_Done,
     /* 694907 */   // Label 8956: @694907
     /* 694907 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(694969), // Rule ID 5054 //
     /* 694912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694919 */     // MIs[0] offset
     /* 694919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694922 */     // MIs[0] auxiliary
     /* 694922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694925 */     // MIs[0] Operand 7
     /* 694925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694935 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 694938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694940 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 694942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694949 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694957 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694967 */     GIR_RootConstrainSelectedInstOperands,
     /* 694968 */     // GIR_Coverage, 5054,
     /* 694968 */     GIR_EraseRootFromParent_Done,
     /* 694969 */   // Label 8957: @694969
     /* 694969 */   GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(695028), // Rule ID 5058 //
     /* 694974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694978 */     // MIs[0] offset
     /* 694978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694981 */     // MIs[0] auxiliary
     /* 694981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694984 */     // MIs[0] Operand 7
     /* 694984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694994 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 694997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694999 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 695001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695008 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695010 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695016 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695026 */     GIR_RootConstrainSelectedInstOperands,
     /* 695027 */     // GIR_Coverage, 5058,
     /* 695027 */     GIR_EraseRootFromParent_Done,
     /* 695028 */   // Label 8958: @695028
     /* 695028 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(695128), // Rule ID 5047 //
     /* 695033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695036 */     // MIs[0] offset
     /* 695036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695039 */     // MIs[0] auxiliary
     /* 695039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695042 */     // MIs[0] Operand 7
     /* 695042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695052 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 695055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 695059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 695064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 695068 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 695071 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 695075 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 695078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 695083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 695096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 695101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695108 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695110 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695116 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695126 */     GIR_RootConstrainSelectedInstOperands,
     /* 695127 */     // GIR_Coverage, 5047,
     /* 695127 */     GIR_EraseRootFromParent_Done,
     /* 695128 */   // Label 8959: @695128
     /* 695128 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(695225), // Rule ID 5051 //
     /* 695133 */     // MIs[0] offset
     /* 695133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695136 */     // MIs[0] auxiliary
     /* 695136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695139 */     // MIs[0] Operand 7
     /* 695139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695149 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 695152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 695156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 695161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 695165 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 695168 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 695172 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 695175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 695180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 695193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 695198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695205 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695207 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695213 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695223 */     GIR_RootConstrainSelectedInstOperands,
     /* 695224 */     // GIR_Coverage, 5051,
     /* 695224 */     GIR_EraseRootFromParent_Done,
     /* 695225 */   // Label 8960: @695225
     /* 695225 */   GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(695325), // Rule ID 5055 //
     /* 695230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695233 */     // MIs[0] offset
     /* 695233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695236 */     // MIs[0] auxiliary
     /* 695236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695239 */     // MIs[0] Operand 7
     /* 695239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695249 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 695252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 695256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 695261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 695265 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 695268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 695272 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 695275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 695280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 695293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 695298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695305 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695307 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695313 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695323 */     GIR_RootConstrainSelectedInstOperands,
     /* 695324 */     // GIR_Coverage, 5055,
     /* 695324 */     GIR_EraseRootFromParent_Done,
     /* 695325 */   // Label 8961: @695325
     /* 695325 */   GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(695422), // Rule ID 5059 //
     /* 695330 */     // MIs[0] offset
     /* 695330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695333 */     // MIs[0] auxiliary
     /* 695333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695336 */     // MIs[0] Operand 7
     /* 695336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695346 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 695349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 695353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 695358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 695362 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 695365 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 695369 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 695372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 695377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 695390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 695395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695402 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695404 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695420 */     GIR_RootConstrainSelectedInstOperands,
     /* 695421 */     // GIR_Coverage, 5059,
     /* 695421 */     GIR_EraseRootFromParent_Done,
     /* 695422 */   // Label 8962: @695422
     /* 695422 */   GIM_Reject,
     /* 695423 */ // Label 8946: @695423
     /* 695423 */ GIM_Reject,
     /* 695424 */ // Label 8762: @695424
     /* 695424 */ GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(696638),
     /* 695429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 695432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 695435 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 695438 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 695441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 695445 */   GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(695517), // Rule ID 5076 //
     /* 695450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695461 */     // MIs[0] offset
     /* 695461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695464 */     // MIs[0] auxiliary
     /* 695464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695467 */     // MIs[0] Operand 7
     /* 695467 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695485 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 695488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695497 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695505 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695515 */     GIR_RootConstrainSelectedInstOperands,
     /* 695516 */     // GIR_Coverage, 5076,
     /* 695516 */     GIR_EraseRootFromParent_Done,
     /* 695517 */   // Label 8964: @695517
     /* 695517 */   GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(695586), // Rule ID 5080 //
     /* 695522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695530 */     // MIs[0] offset
     /* 695530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695533 */     // MIs[0] auxiliary
     /* 695533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695536 */     // MIs[0] Operand 7
     /* 695536 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695554 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 695557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695566 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695568 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695574 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695584 */     GIR_RootConstrainSelectedInstOperands,
     /* 695585 */     // GIR_Coverage, 5080,
     /* 695585 */     GIR_EraseRootFromParent_Done,
     /* 695586 */   // Label 8965: @695586
     /* 695586 */   GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(695658), // Rule ID 5084 //
     /* 695591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695602 */     // MIs[0] offset
     /* 695602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695605 */     // MIs[0] auxiliary
     /* 695605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695608 */     // MIs[0] Operand 7
     /* 695608 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695626 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 695629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695638 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695656 */     GIR_RootConstrainSelectedInstOperands,
     /* 695657 */     // GIR_Coverage, 5084,
     /* 695657 */     GIR_EraseRootFromParent_Done,
     /* 695658 */   // Label 8966: @695658
     /* 695658 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(695727), // Rule ID 5088 //
     /* 695663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695671 */     // MIs[0] offset
     /* 695671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695674 */     // MIs[0] auxiliary
     /* 695674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695677 */     // MIs[0] Operand 7
     /* 695677 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695695 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 695698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695707 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695709 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695715 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695725 */     GIR_RootConstrainSelectedInstOperands,
     /* 695726 */     // GIR_Coverage, 5088,
     /* 695726 */     GIR_EraseRootFromParent_Done,
     /* 695727 */   // Label 8967: @695727
     /* 695727 */   GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(695797), // Rule ID 5077 //
     /* 695732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695739 */     // MIs[0] offset
     /* 695739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695742 */     // MIs[0] auxiliary
     /* 695742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695745 */     // MIs[0] Operand 7
     /* 695745 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695763 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 695766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695768 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 695770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695777 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695795 */     GIR_RootConstrainSelectedInstOperands,
     /* 695796 */     // GIR_Coverage, 5077,
     /* 695796 */     GIR_EraseRootFromParent_Done,
     /* 695797 */   // Label 8968: @695797
     /* 695797 */   GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(695864), // Rule ID 5081 //
     /* 695802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695806 */     // MIs[0] offset
     /* 695806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695809 */     // MIs[0] auxiliary
     /* 695809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695812 */     // MIs[0] Operand 7
     /* 695812 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695830 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 695833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695835 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 695837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695844 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695846 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695852 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695862 */     GIR_RootConstrainSelectedInstOperands,
     /* 695863 */     // GIR_Coverage, 5081,
     /* 695863 */     GIR_EraseRootFromParent_Done,
     /* 695864 */   // Label 8969: @695864
     /* 695864 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(695934), // Rule ID 5085 //
     /* 695869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695876 */     // MIs[0] offset
     /* 695876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695879 */     // MIs[0] auxiliary
     /* 695879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695882 */     // MIs[0] Operand 7
     /* 695882 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695900 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 695903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695905 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 695907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695914 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695916 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695932 */     GIR_RootConstrainSelectedInstOperands,
     /* 695933 */     // GIR_Coverage, 5085,
     /* 695933 */     GIR_EraseRootFromParent_Done,
     /* 695934 */   // Label 8970: @695934
     /* 695934 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(696001), // Rule ID 5089 //
     /* 695939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695943 */     // MIs[0] offset
     /* 695943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695946 */     // MIs[0] auxiliary
     /* 695946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695949 */     // MIs[0] Operand 7
     /* 695949 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695967 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 695970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695972 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 695974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695981 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695983 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695989 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695999 */     GIR_RootConstrainSelectedInstOperands,
     /* 696000 */     // GIR_Coverage, 5089,
     /* 696000 */     GIR_EraseRootFromParent_Done,
     /* 696001 */   // Label 8971: @696001
     /* 696001 */   GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(696063), // Rule ID 5078 //
     /* 696006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696013 */     // MIs[0] offset
     /* 696013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696016 */     // MIs[0] auxiliary
     /* 696016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696019 */     // MIs[0] Operand 7
     /* 696019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696029 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 696032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696034 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 696036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696043 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696051 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696061 */     GIR_RootConstrainSelectedInstOperands,
     /* 696062 */     // GIR_Coverage, 5078,
     /* 696062 */     GIR_EraseRootFromParent_Done,
     /* 696063 */   // Label 8972: @696063
     /* 696063 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(696122), // Rule ID 5082 //
     /* 696068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696072 */     // MIs[0] offset
     /* 696072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696075 */     // MIs[0] auxiliary
     /* 696075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696078 */     // MIs[0] Operand 7
     /* 696078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696088 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 696091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696093 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 696095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696102 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696104 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696110 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696120 */     GIR_RootConstrainSelectedInstOperands,
     /* 696121 */     // GIR_Coverage, 5082,
     /* 696121 */     GIR_EraseRootFromParent_Done,
     /* 696122 */   // Label 8973: @696122
     /* 696122 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(696184), // Rule ID 5086 //
     /* 696127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696134 */     // MIs[0] offset
     /* 696134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696137 */     // MIs[0] auxiliary
     /* 696137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696140 */     // MIs[0] Operand 7
     /* 696140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696150 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 696153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696155 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 696157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696164 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696166 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696172 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696182 */     GIR_RootConstrainSelectedInstOperands,
     /* 696183 */     // GIR_Coverage, 5086,
     /* 696183 */     GIR_EraseRootFromParent_Done,
     /* 696184 */   // Label 8974: @696184
     /* 696184 */   GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(696243), // Rule ID 5090 //
     /* 696189 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696193 */     // MIs[0] offset
     /* 696193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696196 */     // MIs[0] auxiliary
     /* 696196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696199 */     // MIs[0] Operand 7
     /* 696199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696209 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 696212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696214 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 696216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696223 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696225 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696231 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696241 */     GIR_RootConstrainSelectedInstOperands,
     /* 696242 */     // GIR_Coverage, 5090,
     /* 696242 */     GIR_EraseRootFromParent_Done,
     /* 696243 */   // Label 8975: @696243
     /* 696243 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(696343), // Rule ID 5079 //
     /* 696248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696251 */     // MIs[0] offset
     /* 696251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696254 */     // MIs[0] auxiliary
     /* 696254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696257 */     // MIs[0] Operand 7
     /* 696257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696267 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 696270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 696274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 696279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 696283 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 696286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 696290 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 696293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 696298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 696311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 696316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696323 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696325 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696331 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696341 */     GIR_RootConstrainSelectedInstOperands,
     /* 696342 */     // GIR_Coverage, 5079,
     /* 696342 */     GIR_EraseRootFromParent_Done,
     /* 696343 */   // Label 8976: @696343
     /* 696343 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(696440), // Rule ID 5083 //
     /* 696348 */     // MIs[0] offset
     /* 696348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696351 */     // MIs[0] auxiliary
     /* 696351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696354 */     // MIs[0] Operand 7
     /* 696354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696364 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 696367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 696371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 696376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 696380 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 696383 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 696387 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 696390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 696395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 696408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 696413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696420 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696422 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696428 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696438 */     GIR_RootConstrainSelectedInstOperands,
     /* 696439 */     // GIR_Coverage, 5083,
     /* 696439 */     GIR_EraseRootFromParent_Done,
     /* 696440 */   // Label 8977: @696440
     /* 696440 */   GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(696540), // Rule ID 5087 //
     /* 696445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696448 */     // MIs[0] offset
     /* 696448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696451 */     // MIs[0] auxiliary
     /* 696451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696454 */     // MIs[0] Operand 7
     /* 696454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696464 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v8f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 696467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 696471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 696476 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 696480 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 696483 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 696487 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 696490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 696495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 696508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 696513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696520 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696522 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696528 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696538 */     GIR_RootConstrainSelectedInstOperands,
     /* 696539 */     // GIR_Coverage, 5087,
     /* 696539 */     GIR_EraseRootFromParent_Done,
     /* 696540 */   // Label 8978: @696540
     /* 696540 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(696637), // Rule ID 5091 //
     /* 696545 */     // MIs[0] offset
     /* 696545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696548 */     // MIs[0] auxiliary
     /* 696548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696551 */     // MIs[0] Operand 7
     /* 696551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696561 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v8f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 696564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 696568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 696573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 696577 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 696580 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 696584 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 696587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 696592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 696605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 696610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696617 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696619 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696625 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696635 */     GIR_RootConstrainSelectedInstOperands,
     /* 696636 */     // GIR_Coverage, 5091,
     /* 696636 */     GIR_EraseRootFromParent_Done,
     /* 696637 */   // Label 8979: @696637
     /* 696637 */   GIM_Reject,
     /* 696638 */ // Label 8963: @696638
     /* 696638 */ GIM_Reject,
     /* 696639 */ // Label 8763: @696639
     /* 696639 */ GIM_Reject,
     /* 696640 */ // Label 126: @696640
     /* 696640 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 8984*/ GIMT_Encode4(701547),
     /* 696651 */ /*GILLT_s32*//*Label 8980*/ GIMT_Encode4(696687), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 696663 */ /*GILLT_v2s32*//*Label 8981*/ GIMT_Encode4(697902), GIMT_Encode4(0),
     /* 696671 */ /*GILLT_v3s32*//*Label 8982*/ GIMT_Encode4(699117), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 696683 */ /*GILLT_v4s32*//*Label 8983*/ GIMT_Encode4(700332),
     /* 696687 */ // Label 8980: @696687
     /* 696687 */ GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(697901),
     /* 696692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 696695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 696698 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 696701 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 696704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 696708 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(696780), // Rule ID 4700 //
     /* 696713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696724 */     // MIs[0] offset
     /* 696724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696727 */     // MIs[0] auxiliary
     /* 696727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696730 */     // MIs[0] Operand 7
     /* 696730 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696748 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFSET),
     /* 696751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696760 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696762 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696778 */     GIR_RootConstrainSelectedInstOperands,
     /* 696779 */     // GIR_Coverage, 4700,
     /* 696779 */     GIR_EraseRootFromParent_Done,
     /* 696780 */   // Label 8986: @696780
     /* 696780 */   GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(696849), // Rule ID 4704 //
     /* 696785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696793 */     // MIs[0] offset
     /* 696793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696796 */     // MIs[0] auxiliary
     /* 696796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696799 */     // MIs[0] Operand 7
     /* 696799 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696817 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
     /* 696820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696829 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696831 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696837 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696847 */     GIR_RootConstrainSelectedInstOperands,
     /* 696848 */     // GIR_Coverage, 4704,
     /* 696848 */     GIR_EraseRootFromParent_Done,
     /* 696849 */   // Label 8987: @696849
     /* 696849 */   GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(696921), // Rule ID 4708 //
     /* 696854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696865 */     // MIs[0] offset
     /* 696865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696868 */     // MIs[0] auxiliary
     /* 696868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696871 */     // MIs[0] Operand 7
     /* 696871 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696889 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFSET),
     /* 696892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696901 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696903 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696909 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696919 */     GIR_RootConstrainSelectedInstOperands,
     /* 696920 */     // GIR_Coverage, 4708,
     /* 696920 */     GIR_EraseRootFromParent_Done,
     /* 696921 */   // Label 8988: @696921
     /* 696921 */   GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(696990), // Rule ID 4712 //
     /* 696926 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696934 */     // MIs[0] offset
     /* 696934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696937 */     // MIs[0] auxiliary
     /* 696937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696940 */     // MIs[0] Operand 7
     /* 696940 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696958 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
     /* 696961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696970 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696972 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696978 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696988 */     GIR_RootConstrainSelectedInstOperands,
     /* 696989 */     // GIR_Coverage, 4712,
     /* 696989 */     GIR_EraseRootFromParent_Done,
     /* 696990 */   // Label 8989: @696990
     /* 696990 */   GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(697060), // Rule ID 4701 //
     /* 696995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697002 */     // MIs[0] offset
     /* 697002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697005 */     // MIs[0] auxiliary
     /* 697005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697008 */     // MIs[0] Operand 7
     /* 697008 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697026 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFEN),
     /* 697029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697031 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 697033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697040 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697042 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697048 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697058 */     GIR_RootConstrainSelectedInstOperands,
     /* 697059 */     // GIR_Coverage, 4701,
     /* 697059 */     GIR_EraseRootFromParent_Done,
     /* 697060 */   // Label 8990: @697060
     /* 697060 */   GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(697127), // Rule ID 4705 //
     /* 697065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697069 */     // MIs[0] offset
     /* 697069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697072 */     // MIs[0] auxiliary
     /* 697072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697075 */     // MIs[0] Operand 7
     /* 697075 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697093 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
     /* 697096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697098 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 697100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697107 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697109 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697125 */     GIR_RootConstrainSelectedInstOperands,
     /* 697126 */     // GIR_Coverage, 4705,
     /* 697126 */     GIR_EraseRootFromParent_Done,
     /* 697127 */   // Label 8991: @697127
     /* 697127 */   GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(697197), // Rule ID 4709 //
     /* 697132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697139 */     // MIs[0] offset
     /* 697139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697142 */     // MIs[0] auxiliary
     /* 697142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697145 */     // MIs[0] Operand 7
     /* 697145 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697163 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFEN),
     /* 697166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697168 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 697170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697177 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697179 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697185 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697195 */     GIR_RootConstrainSelectedInstOperands,
     /* 697196 */     // GIR_Coverage, 4709,
     /* 697196 */     GIR_EraseRootFromParent_Done,
     /* 697197 */   // Label 8992: @697197
     /* 697197 */   GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(697264), // Rule ID 4713 //
     /* 697202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697206 */     // MIs[0] offset
     /* 697206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697209 */     // MIs[0] auxiliary
     /* 697209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697212 */     // MIs[0] Operand 7
     /* 697212 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697230 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
     /* 697233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697235 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 697237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697244 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697246 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697262 */     GIR_RootConstrainSelectedInstOperands,
     /* 697263 */     // GIR_Coverage, 4713,
     /* 697263 */     GIR_EraseRootFromParent_Done,
     /* 697264 */   // Label 8993: @697264
     /* 697264 */   GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(697326), // Rule ID 4702 //
     /* 697269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697276 */     // MIs[0] offset
     /* 697276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697279 */     // MIs[0] auxiliary
     /* 697279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697282 */     // MIs[0] Operand 7
     /* 697282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697292 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_IDXEN),
     /* 697295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697297 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 697299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697306 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697308 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697314 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697324 */     GIR_RootConstrainSelectedInstOperands,
     /* 697325 */     // GIR_Coverage, 4702,
     /* 697325 */     GIR_EraseRootFromParent_Done,
     /* 697326 */   // Label 8994: @697326
     /* 697326 */   GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(697385), // Rule ID 4706 //
     /* 697331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697335 */     // MIs[0] offset
     /* 697335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697338 */     // MIs[0] auxiliary
     /* 697338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697341 */     // MIs[0] Operand 7
     /* 697341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697351 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
     /* 697354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697356 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 697358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697365 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697367 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697373 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697383 */     GIR_RootConstrainSelectedInstOperands,
     /* 697384 */     // GIR_Coverage, 4706,
     /* 697384 */     GIR_EraseRootFromParent_Done,
     /* 697385 */   // Label 8995: @697385
     /* 697385 */   GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(697447), // Rule ID 4710 //
     /* 697390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697397 */     // MIs[0] offset
     /* 697397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697400 */     // MIs[0] auxiliary
     /* 697400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697403 */     // MIs[0] Operand 7
     /* 697403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697413 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_IDXEN),
     /* 697416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697418 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 697420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697427 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697429 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697435 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697445 */     GIR_RootConstrainSelectedInstOperands,
     /* 697446 */     // GIR_Coverage, 4710,
     /* 697446 */     GIR_EraseRootFromParent_Done,
     /* 697447 */   // Label 8996: @697447
     /* 697447 */   GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(697506), // Rule ID 4714 //
     /* 697452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697456 */     // MIs[0] offset
     /* 697456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697459 */     // MIs[0] auxiliary
     /* 697459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697462 */     // MIs[0] Operand 7
     /* 697462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697472 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
     /* 697475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697477 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 697479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697486 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697488 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697494 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697504 */     GIR_RootConstrainSelectedInstOperands,
     /* 697505 */     // GIR_Coverage, 4714,
     /* 697505 */     GIR_EraseRootFromParent_Done,
     /* 697506 */   // Label 8997: @697506
     /* 697506 */   GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(697606), // Rule ID 4703 //
     /* 697511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697514 */     // MIs[0] offset
     /* 697514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697517 */     // MIs[0] auxiliary
     /* 697517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697520 */     // MIs[0] Operand 7
     /* 697520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697530 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 697533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 697537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 697542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 697546 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 697549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 697553 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 697556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 697561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_BOTHEN),
     /* 697574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 697579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697586 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697588 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697594 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697604 */     GIR_RootConstrainSelectedInstOperands,
     /* 697605 */     // GIR_Coverage, 4703,
     /* 697605 */     GIR_EraseRootFromParent_Done,
     /* 697606 */   // Label 8998: @697606
     /* 697606 */   GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(697703), // Rule ID 4707 //
     /* 697611 */     // MIs[0] offset
     /* 697611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697614 */     // MIs[0] auxiliary
     /* 697614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697617 */     // MIs[0] Operand 7
     /* 697617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697627 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 697630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 697634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 697639 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 697643 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 697646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 697650 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 697653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 697658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
     /* 697671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 697676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697683 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697685 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697691 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697701 */     GIR_RootConstrainSelectedInstOperands,
     /* 697702 */     // GIR_Coverage, 4707,
     /* 697702 */     GIR_EraseRootFromParent_Done,
     /* 697703 */   // Label 8999: @697703
     /* 697703 */   GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(697803), // Rule ID 4711 //
     /* 697708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697711 */     // MIs[0] offset
     /* 697711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697714 */     // MIs[0] auxiliary
     /* 697714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697717 */     // MIs[0] Operand 7
     /* 697717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697727 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 697730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 697734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 697739 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 697743 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 697746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 697750 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 697753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 697758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_BOTHEN),
     /* 697771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 697776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697783 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697791 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697801 */     GIR_RootConstrainSelectedInstOperands,
     /* 697802 */     // GIR_Coverage, 4711,
     /* 697802 */     GIR_EraseRootFromParent_Done,
     /* 697803 */   // Label 9000: @697803
     /* 697803 */   GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(697900), // Rule ID 4715 //
     /* 697808 */     // MIs[0] offset
     /* 697808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697811 */     // MIs[0] auxiliary
     /* 697811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697814 */     // MIs[0] Operand 7
     /* 697814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697824 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 697827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 697831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 697836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 697840 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 697843 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 697847 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 697850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 697855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
     /* 697868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 697873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697880 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697882 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697888 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697898 */     GIR_RootConstrainSelectedInstOperands,
     /* 697899 */     // GIR_Coverage, 4715,
     /* 697899 */     GIR_EraseRootFromParent_Done,
     /* 697900 */   // Label 9001: @697900
     /* 697900 */   GIM_Reject,
     /* 697901 */ // Label 8985: @697901
     /* 697901 */ GIM_Reject,
     /* 697902 */ // Label 8981: @697902
     /* 697902 */ GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(699116),
     /* 697907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 697910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 697913 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 697916 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 697919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 697923 */   GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(697995), // Rule ID 4716 //
     /* 697928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697939 */     // MIs[0] offset
     /* 697939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697942 */     // MIs[0] auxiliary
     /* 697942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697945 */     // MIs[0] Operand 7
     /* 697945 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697963 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFSET),
     /* 697966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697975 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697977 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697983 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697993 */     GIR_RootConstrainSelectedInstOperands,
     /* 697994 */     // GIR_Coverage, 4716,
     /* 697994 */     GIR_EraseRootFromParent_Done,
     /* 697995 */   // Label 9003: @697995
     /* 697995 */   GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(698064), // Rule ID 4720 //
     /* 698000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698008 */     // MIs[0] offset
     /* 698008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698011 */     // MIs[0] auxiliary
     /* 698011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698014 */     // MIs[0] Operand 7
     /* 698014 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698032 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
     /* 698035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698044 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698046 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698052 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698062 */     GIR_RootConstrainSelectedInstOperands,
     /* 698063 */     // GIR_Coverage, 4720,
     /* 698063 */     GIR_EraseRootFromParent_Done,
     /* 698064 */   // Label 9004: @698064
     /* 698064 */   GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(698136), // Rule ID 4724 //
     /* 698069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698080 */     // MIs[0] offset
     /* 698080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698083 */     // MIs[0] auxiliary
     /* 698083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698086 */     // MIs[0] Operand 7
     /* 698086 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698104 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFSET),
     /* 698107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698116 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698118 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698124 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698134 */     GIR_RootConstrainSelectedInstOperands,
     /* 698135 */     // GIR_Coverage, 4724,
     /* 698135 */     GIR_EraseRootFromParent_Done,
     /* 698136 */   // Label 9005: @698136
     /* 698136 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(698205), // Rule ID 4728 //
     /* 698141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698149 */     // MIs[0] offset
     /* 698149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698152 */     // MIs[0] auxiliary
     /* 698152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698155 */     // MIs[0] Operand 7
     /* 698155 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698173 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
     /* 698176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698185 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698187 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698193 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698203 */     GIR_RootConstrainSelectedInstOperands,
     /* 698204 */     // GIR_Coverage, 4728,
     /* 698204 */     GIR_EraseRootFromParent_Done,
     /* 698205 */   // Label 9006: @698205
     /* 698205 */   GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(698275), // Rule ID 4717 //
     /* 698210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698217 */     // MIs[0] offset
     /* 698217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698220 */     // MIs[0] auxiliary
     /* 698220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698223 */     // MIs[0] Operand 7
     /* 698223 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698241 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFEN),
     /* 698244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698246 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 698248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698255 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698257 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698263 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698273 */     GIR_RootConstrainSelectedInstOperands,
     /* 698274 */     // GIR_Coverage, 4717,
     /* 698274 */     GIR_EraseRootFromParent_Done,
     /* 698275 */   // Label 9007: @698275
     /* 698275 */   GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(698342), // Rule ID 4721 //
     /* 698280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698284 */     // MIs[0] offset
     /* 698284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698287 */     // MIs[0] auxiliary
     /* 698287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698290 */     // MIs[0] Operand 7
     /* 698290 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698308 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
     /* 698311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698313 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 698315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698322 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698324 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698330 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698340 */     GIR_RootConstrainSelectedInstOperands,
     /* 698341 */     // GIR_Coverage, 4721,
     /* 698341 */     GIR_EraseRootFromParent_Done,
     /* 698342 */   // Label 9008: @698342
     /* 698342 */   GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(698412), // Rule ID 4725 //
     /* 698347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698354 */     // MIs[0] offset
     /* 698354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698357 */     // MIs[0] auxiliary
     /* 698357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698360 */     // MIs[0] Operand 7
     /* 698360 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698378 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFEN),
     /* 698381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698383 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 698385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698392 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698394 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698400 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698410 */     GIR_RootConstrainSelectedInstOperands,
     /* 698411 */     // GIR_Coverage, 4725,
     /* 698411 */     GIR_EraseRootFromParent_Done,
     /* 698412 */   // Label 9009: @698412
     /* 698412 */   GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(698479), // Rule ID 4729 //
     /* 698417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698421 */     // MIs[0] offset
     /* 698421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698424 */     // MIs[0] auxiliary
     /* 698424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698427 */     // MIs[0] Operand 7
     /* 698427 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698445 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
     /* 698448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698450 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 698452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698459 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698461 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698467 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698477 */     GIR_RootConstrainSelectedInstOperands,
     /* 698478 */     // GIR_Coverage, 4729,
     /* 698478 */     GIR_EraseRootFromParent_Done,
     /* 698479 */   // Label 9010: @698479
     /* 698479 */   GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(698541), // Rule ID 4718 //
     /* 698484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698491 */     // MIs[0] offset
     /* 698491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698494 */     // MIs[0] auxiliary
     /* 698494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698497 */     // MIs[0] Operand 7
     /* 698497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698507 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_IDXEN),
     /* 698510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698512 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 698514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698521 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698523 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698529 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698539 */     GIR_RootConstrainSelectedInstOperands,
     /* 698540 */     // GIR_Coverage, 4718,
     /* 698540 */     GIR_EraseRootFromParent_Done,
     /* 698541 */   // Label 9011: @698541
     /* 698541 */   GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(698600), // Rule ID 4722 //
     /* 698546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698550 */     // MIs[0] offset
     /* 698550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698553 */     // MIs[0] auxiliary
     /* 698553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698556 */     // MIs[0] Operand 7
     /* 698556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698566 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
     /* 698569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698571 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 698573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698580 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698582 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698588 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698598 */     GIR_RootConstrainSelectedInstOperands,
     /* 698599 */     // GIR_Coverage, 4722,
     /* 698599 */     GIR_EraseRootFromParent_Done,
     /* 698600 */   // Label 9012: @698600
     /* 698600 */   GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(698662), // Rule ID 4726 //
     /* 698605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698612 */     // MIs[0] offset
     /* 698612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698615 */     // MIs[0] auxiliary
     /* 698615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698618 */     // MIs[0] Operand 7
     /* 698618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698628 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_IDXEN),
     /* 698631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698633 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 698635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698642 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698644 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698650 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698660 */     GIR_RootConstrainSelectedInstOperands,
     /* 698661 */     // GIR_Coverage, 4726,
     /* 698661 */     GIR_EraseRootFromParent_Done,
     /* 698662 */   // Label 9013: @698662
     /* 698662 */   GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(698721), // Rule ID 4730 //
     /* 698667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698671 */     // MIs[0] offset
     /* 698671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698674 */     // MIs[0] auxiliary
     /* 698674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698677 */     // MIs[0] Operand 7
     /* 698677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698687 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
     /* 698690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698692 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 698694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698701 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698709 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698719 */     GIR_RootConstrainSelectedInstOperands,
     /* 698720 */     // GIR_Coverage, 4730,
     /* 698720 */     GIR_EraseRootFromParent_Done,
     /* 698721 */   // Label 9014: @698721
     /* 698721 */   GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(698821), // Rule ID 4719 //
     /* 698726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698729 */     // MIs[0] offset
     /* 698729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698732 */     // MIs[0] auxiliary
     /* 698732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698735 */     // MIs[0] Operand 7
     /* 698735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698745 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 698748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 698752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 698757 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 698761 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 698764 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 698768 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 698771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 698776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_BOTHEN),
     /* 698789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 698794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698801 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698803 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698809 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698819 */     GIR_RootConstrainSelectedInstOperands,
     /* 698820 */     // GIR_Coverage, 4719,
     /* 698820 */     GIR_EraseRootFromParent_Done,
     /* 698821 */   // Label 9015: @698821
     /* 698821 */   GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(698918), // Rule ID 4723 //
     /* 698826 */     // MIs[0] offset
     /* 698826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698829 */     // MIs[0] auxiliary
     /* 698829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698832 */     // MIs[0] Operand 7
     /* 698832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698842 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 698845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 698849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 698854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 698858 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 698861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 698865 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 698868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 698873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
     /* 698886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 698891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698898 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698900 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698906 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698916 */     GIR_RootConstrainSelectedInstOperands,
     /* 698917 */     // GIR_Coverage, 4723,
     /* 698917 */     GIR_EraseRootFromParent_Done,
     /* 698918 */   // Label 9016: @698918
     /* 698918 */   GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(699018), // Rule ID 4727 //
     /* 698923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698926 */     // MIs[0] offset
     /* 698926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698929 */     // MIs[0] auxiliary
     /* 698929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698932 */     // MIs[0] Operand 7
     /* 698932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698942 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 698945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 698949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 698954 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 698958 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 698961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 698965 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 698968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 698973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_BOTHEN),
     /* 698986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 698991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698998 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699000 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699006 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699016 */     GIR_RootConstrainSelectedInstOperands,
     /* 699017 */     // GIR_Coverage, 4727,
     /* 699017 */     GIR_EraseRootFromParent_Done,
     /* 699018 */   // Label 9017: @699018
     /* 699018 */   GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(699115), // Rule ID 4731 //
     /* 699023 */     // MIs[0] offset
     /* 699023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699026 */     // MIs[0] auxiliary
     /* 699026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699029 */     // MIs[0] Operand 7
     /* 699029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699039 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 699042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 699046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 699051 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 699055 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 699058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 699062 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 699065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 699070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
     /* 699083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 699088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699095 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699097 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699103 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699113 */     GIR_RootConstrainSelectedInstOperands,
     /* 699114 */     // GIR_Coverage, 4731,
     /* 699114 */     GIR_EraseRootFromParent_Done,
     /* 699115 */   // Label 9018: @699115
     /* 699115 */   GIM_Reject,
     /* 699116 */ // Label 9002: @699116
     /* 699116 */ GIM_Reject,
     /* 699117 */ // Label 8982: @699117
     /* 699117 */ GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(700331),
     /* 699122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 699125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 699128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 699131 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 699134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 699138 */   GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(699210), // Rule ID 4732 //
     /* 699143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699154 */     // MIs[0] offset
     /* 699154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699157 */     // MIs[0] auxiliary
     /* 699157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699160 */     // MIs[0] Operand 7
     /* 699160 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699178 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFSET),
     /* 699181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699190 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699192 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699198 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699208 */     GIR_RootConstrainSelectedInstOperands,
     /* 699209 */     // GIR_Coverage, 4732,
     /* 699209 */     GIR_EraseRootFromParent_Done,
     /* 699210 */   // Label 9020: @699210
     /* 699210 */   GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(699279), // Rule ID 4736 //
     /* 699215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699219 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699223 */     // MIs[0] offset
     /* 699223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699226 */     // MIs[0] auxiliary
     /* 699226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699229 */     // MIs[0] Operand 7
     /* 699229 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699247 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
     /* 699250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699259 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699261 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699277 */     GIR_RootConstrainSelectedInstOperands,
     /* 699278 */     // GIR_Coverage, 4736,
     /* 699278 */     GIR_EraseRootFromParent_Done,
     /* 699279 */   // Label 9021: @699279
     /* 699279 */   GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(699351), // Rule ID 4740 //
     /* 699284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699295 */     // MIs[0] offset
     /* 699295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699298 */     // MIs[0] auxiliary
     /* 699298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699301 */     // MIs[0] Operand 7
     /* 699301 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699319 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFSET),
     /* 699322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699331 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699333 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699339 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699349 */     GIR_RootConstrainSelectedInstOperands,
     /* 699350 */     // GIR_Coverage, 4740,
     /* 699350 */     GIR_EraseRootFromParent_Done,
     /* 699351 */   // Label 9022: @699351
     /* 699351 */   GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(699420), // Rule ID 4744 //
     /* 699356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699364 */     // MIs[0] offset
     /* 699364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699367 */     // MIs[0] auxiliary
     /* 699367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699370 */     // MIs[0] Operand 7
     /* 699370 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699388 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
     /* 699391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699400 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699418 */     GIR_RootConstrainSelectedInstOperands,
     /* 699419 */     // GIR_Coverage, 4744,
     /* 699419 */     GIR_EraseRootFromParent_Done,
     /* 699420 */   // Label 9023: @699420
     /* 699420 */   GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(699490), // Rule ID 4733 //
     /* 699425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699432 */     // MIs[0] offset
     /* 699432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699435 */     // MIs[0] auxiliary
     /* 699435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699438 */     // MIs[0] Operand 7
     /* 699438 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699456 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFEN),
     /* 699459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699461 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 699463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699470 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699472 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699478 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699488 */     GIR_RootConstrainSelectedInstOperands,
     /* 699489 */     // GIR_Coverage, 4733,
     /* 699489 */     GIR_EraseRootFromParent_Done,
     /* 699490 */   // Label 9024: @699490
     /* 699490 */   GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(699557), // Rule ID 4737 //
     /* 699495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699499 */     // MIs[0] offset
     /* 699499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699502 */     // MIs[0] auxiliary
     /* 699502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699505 */     // MIs[0] Operand 7
     /* 699505 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699523 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
     /* 699526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699528 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 699530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699537 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699539 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699545 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699555 */     GIR_RootConstrainSelectedInstOperands,
     /* 699556 */     // GIR_Coverage, 4737,
     /* 699556 */     GIR_EraseRootFromParent_Done,
     /* 699557 */   // Label 9025: @699557
     /* 699557 */   GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(699627), // Rule ID 4741 //
     /* 699562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699569 */     // MIs[0] offset
     /* 699569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699572 */     // MIs[0] auxiliary
     /* 699572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699575 */     // MIs[0] Operand 7
     /* 699575 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699593 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFEN),
     /* 699596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699598 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 699600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699607 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699609 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699615 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699625 */     GIR_RootConstrainSelectedInstOperands,
     /* 699626 */     // GIR_Coverage, 4741,
     /* 699626 */     GIR_EraseRootFromParent_Done,
     /* 699627 */   // Label 9026: @699627
     /* 699627 */   GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(699694), // Rule ID 4745 //
     /* 699632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699636 */     // MIs[0] offset
     /* 699636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699639 */     // MIs[0] auxiliary
     /* 699639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699642 */     // MIs[0] Operand 7
     /* 699642 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699660 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
     /* 699663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699665 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 699667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699674 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699676 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699682 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699692 */     GIR_RootConstrainSelectedInstOperands,
     /* 699693 */     // GIR_Coverage, 4745,
     /* 699693 */     GIR_EraseRootFromParent_Done,
     /* 699694 */   // Label 9027: @699694
     /* 699694 */   GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(699756), // Rule ID 4734 //
     /* 699699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699706 */     // MIs[0] offset
     /* 699706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699709 */     // MIs[0] auxiliary
     /* 699709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699712 */     // MIs[0] Operand 7
     /* 699712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699722 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_IDXEN),
     /* 699725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699727 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 699729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699736 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699738 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699754 */     GIR_RootConstrainSelectedInstOperands,
     /* 699755 */     // GIR_Coverage, 4734,
     /* 699755 */     GIR_EraseRootFromParent_Done,
     /* 699756 */   // Label 9028: @699756
     /* 699756 */   GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(699815), // Rule ID 4738 //
     /* 699761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699765 */     // MIs[0] offset
     /* 699765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699768 */     // MIs[0] auxiliary
     /* 699768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699771 */     // MIs[0] Operand 7
     /* 699771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699781 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
     /* 699784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699786 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 699788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699795 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699803 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699813 */     GIR_RootConstrainSelectedInstOperands,
     /* 699814 */     // GIR_Coverage, 4738,
     /* 699814 */     GIR_EraseRootFromParent_Done,
     /* 699815 */   // Label 9029: @699815
     /* 699815 */   GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(699877), // Rule ID 4742 //
     /* 699820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699827 */     // MIs[0] offset
     /* 699827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699830 */     // MIs[0] auxiliary
     /* 699830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699833 */     // MIs[0] Operand 7
     /* 699833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699843 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_IDXEN),
     /* 699846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699848 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 699850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699857 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699859 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699865 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699875 */     GIR_RootConstrainSelectedInstOperands,
     /* 699876 */     // GIR_Coverage, 4742,
     /* 699876 */     GIR_EraseRootFromParent_Done,
     /* 699877 */   // Label 9030: @699877
     /* 699877 */   GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(699936), // Rule ID 4746 //
     /* 699882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699886 */     // MIs[0] offset
     /* 699886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699889 */     // MIs[0] auxiliary
     /* 699889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699892 */     // MIs[0] Operand 7
     /* 699892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699902 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
     /* 699905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699907 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 699909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699916 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699918 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699924 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699934 */     GIR_RootConstrainSelectedInstOperands,
     /* 699935 */     // GIR_Coverage, 4746,
     /* 699935 */     GIR_EraseRootFromParent_Done,
     /* 699936 */   // Label 9031: @699936
     /* 699936 */   GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(700036), // Rule ID 4735 //
     /* 699941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699944 */     // MIs[0] offset
     /* 699944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699947 */     // MIs[0] auxiliary
     /* 699947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699950 */     // MIs[0] Operand 7
     /* 699950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699960 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 699963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 699967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 699972 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 699976 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 699979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 699983 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 699986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 699991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_BOTHEN),
     /* 700004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 700009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700016 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700018 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700024 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700034 */     GIR_RootConstrainSelectedInstOperands,
     /* 700035 */     // GIR_Coverage, 4735,
     /* 700035 */     GIR_EraseRootFromParent_Done,
     /* 700036 */   // Label 9032: @700036
     /* 700036 */   GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(700133), // Rule ID 4739 //
     /* 700041 */     // MIs[0] offset
     /* 700041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700044 */     // MIs[0] auxiliary
     /* 700044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700047 */     // MIs[0] Operand 7
     /* 700047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700057 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 700060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 700064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 700069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 700073 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 700076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 700080 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 700083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 700088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
     /* 700101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 700106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700113 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700131 */     GIR_RootConstrainSelectedInstOperands,
     /* 700132 */     // GIR_Coverage, 4739,
     /* 700132 */     GIR_EraseRootFromParent_Done,
     /* 700133 */   // Label 9033: @700133
     /* 700133 */   GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(700233), // Rule ID 4743 //
     /* 700138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700141 */     // MIs[0] offset
     /* 700141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700144 */     // MIs[0] auxiliary
     /* 700144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700147 */     // MIs[0] Operand 7
     /* 700147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700157 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 700160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 700164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 700169 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 700173 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 700176 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 700180 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 700183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 700188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_BOTHEN),
     /* 700201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 700206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700213 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700231 */     GIR_RootConstrainSelectedInstOperands,
     /* 700232 */     // GIR_Coverage, 4743,
     /* 700232 */     GIR_EraseRootFromParent_Done,
     /* 700233 */   // Label 9034: @700233
     /* 700233 */   GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(700330), // Rule ID 4747 //
     /* 700238 */     // MIs[0] offset
     /* 700238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700241 */     // MIs[0] auxiliary
     /* 700241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700244 */     // MIs[0] Operand 7
     /* 700244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700254 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 700257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 700261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 700266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 700270 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 700273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 700277 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 700280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 700285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
     /* 700298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 700303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700310 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700312 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700318 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700328 */     GIR_RootConstrainSelectedInstOperands,
     /* 700329 */     // GIR_Coverage, 4747,
     /* 700329 */     GIR_EraseRootFromParent_Done,
     /* 700330 */   // Label 9035: @700330
     /* 700330 */   GIM_Reject,
     /* 700331 */ // Label 9019: @700331
     /* 700331 */ GIM_Reject,
     /* 700332 */ // Label 8983: @700332
     /* 700332 */ GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(701546),
     /* 700337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 700340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 700343 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 700346 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 700349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 700353 */   GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(700425), // Rule ID 4748 //
     /* 700358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700369 */     // MIs[0] offset
     /* 700369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700372 */     // MIs[0] auxiliary
     /* 700372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700375 */     // MIs[0] Operand 7
     /* 700375 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700393 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFSET),
     /* 700396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700405 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700407 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700413 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700423 */     GIR_RootConstrainSelectedInstOperands,
     /* 700424 */     // GIR_Coverage, 4748,
     /* 700424 */     GIR_EraseRootFromParent_Done,
     /* 700425 */   // Label 9037: @700425
     /* 700425 */   GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(700494), // Rule ID 4752 //
     /* 700430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700438 */     // MIs[0] offset
     /* 700438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700441 */     // MIs[0] auxiliary
     /* 700441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700444 */     // MIs[0] Operand 7
     /* 700444 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700462 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
     /* 700465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700474 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700476 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700482 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700492 */     GIR_RootConstrainSelectedInstOperands,
     /* 700493 */     // GIR_Coverage, 4752,
     /* 700493 */     GIR_EraseRootFromParent_Done,
     /* 700494 */   // Label 9038: @700494
     /* 700494 */   GIM_Try, /*On fail goto*//*Label 9039*/ GIMT_Encode4(700566), // Rule ID 4756 //
     /* 700499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700510 */     // MIs[0] offset
     /* 700510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700513 */     // MIs[0] auxiliary
     /* 700513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700516 */     // MIs[0] Operand 7
     /* 700516 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700534 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFSET),
     /* 700537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700546 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700548 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700554 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700564 */     GIR_RootConstrainSelectedInstOperands,
     /* 700565 */     // GIR_Coverage, 4756,
     /* 700565 */     GIR_EraseRootFromParent_Done,
     /* 700566 */   // Label 9039: @700566
     /* 700566 */   GIM_Try, /*On fail goto*//*Label 9040*/ GIMT_Encode4(700635), // Rule ID 4760 //
     /* 700571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700579 */     // MIs[0] offset
     /* 700579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700582 */     // MIs[0] auxiliary
     /* 700582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700585 */     // MIs[0] Operand 7
     /* 700585 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700603 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
     /* 700606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700615 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700617 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700623 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700633 */     GIR_RootConstrainSelectedInstOperands,
     /* 700634 */     // GIR_Coverage, 4760,
     /* 700634 */     GIR_EraseRootFromParent_Done,
     /* 700635 */   // Label 9040: @700635
     /* 700635 */   GIM_Try, /*On fail goto*//*Label 9041*/ GIMT_Encode4(700705), // Rule ID 4749 //
     /* 700640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700647 */     // MIs[0] offset
     /* 700647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700650 */     // MIs[0] auxiliary
     /* 700650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700653 */     // MIs[0] Operand 7
     /* 700653 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700671 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFEN),
     /* 700674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700676 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 700678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700685 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700687 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700703 */     GIR_RootConstrainSelectedInstOperands,
     /* 700704 */     // GIR_Coverage, 4749,
     /* 700704 */     GIR_EraseRootFromParent_Done,
     /* 700705 */   // Label 9041: @700705
     /* 700705 */   GIM_Try, /*On fail goto*//*Label 9042*/ GIMT_Encode4(700772), // Rule ID 4753 //
     /* 700710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700714 */     // MIs[0] offset
     /* 700714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700717 */     // MIs[0] auxiliary
     /* 700717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700720 */     // MIs[0] Operand 7
     /* 700720 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700738 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
     /* 700741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700743 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 700745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700752 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700754 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700760 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700770 */     GIR_RootConstrainSelectedInstOperands,
     /* 700771 */     // GIR_Coverage, 4753,
     /* 700771 */     GIR_EraseRootFromParent_Done,
     /* 700772 */   // Label 9042: @700772
     /* 700772 */   GIM_Try, /*On fail goto*//*Label 9043*/ GIMT_Encode4(700842), // Rule ID 4757 //
     /* 700777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700784 */     // MIs[0] offset
     /* 700784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700787 */     // MIs[0] auxiliary
     /* 700787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700790 */     // MIs[0] Operand 7
     /* 700790 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700808 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFEN),
     /* 700811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700813 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 700815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700822 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700824 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700830 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700840 */     GIR_RootConstrainSelectedInstOperands,
     /* 700841 */     // GIR_Coverage, 4757,
     /* 700841 */     GIR_EraseRootFromParent_Done,
     /* 700842 */   // Label 9043: @700842
     /* 700842 */   GIM_Try, /*On fail goto*//*Label 9044*/ GIMT_Encode4(700909), // Rule ID 4761 //
     /* 700847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700851 */     // MIs[0] offset
     /* 700851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700854 */     // MIs[0] auxiliary
     /* 700854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700857 */     // MIs[0] Operand 7
     /* 700857 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700875 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
     /* 700878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700880 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 700882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700889 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700891 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700897 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700907 */     GIR_RootConstrainSelectedInstOperands,
     /* 700908 */     // GIR_Coverage, 4761,
     /* 700908 */     GIR_EraseRootFromParent_Done,
     /* 700909 */   // Label 9044: @700909
     /* 700909 */   GIM_Try, /*On fail goto*//*Label 9045*/ GIMT_Encode4(700971), // Rule ID 4750 //
     /* 700914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700921 */     // MIs[0] offset
     /* 700921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700924 */     // MIs[0] auxiliary
     /* 700924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700927 */     // MIs[0] Operand 7
     /* 700927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700937 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_IDXEN),
     /* 700940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700942 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 700944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700951 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700969 */     GIR_RootConstrainSelectedInstOperands,
     /* 700970 */     // GIR_Coverage, 4750,
     /* 700970 */     GIR_EraseRootFromParent_Done,
     /* 700971 */   // Label 9045: @700971
     /* 700971 */   GIM_Try, /*On fail goto*//*Label 9046*/ GIMT_Encode4(701030), // Rule ID 4754 //
     /* 700976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700980 */     // MIs[0] offset
     /* 700980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700983 */     // MIs[0] auxiliary
     /* 700983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700986 */     // MIs[0] Operand 7
     /* 700986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700996 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
     /* 700999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701001 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 701003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701010 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701012 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701018 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701028 */     GIR_RootConstrainSelectedInstOperands,
     /* 701029 */     // GIR_Coverage, 4754,
     /* 701029 */     GIR_EraseRootFromParent_Done,
     /* 701030 */   // Label 9046: @701030
     /* 701030 */   GIM_Try, /*On fail goto*//*Label 9047*/ GIMT_Encode4(701092), // Rule ID 4758 //
     /* 701035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701042 */     // MIs[0] offset
     /* 701042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701045 */     // MIs[0] auxiliary
     /* 701045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701048 */     // MIs[0] Operand 7
     /* 701048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701058 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_IDXEN),
     /* 701061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701063 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 701065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701072 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701074 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701080 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701090 */     GIR_RootConstrainSelectedInstOperands,
     /* 701091 */     // GIR_Coverage, 4758,
     /* 701091 */     GIR_EraseRootFromParent_Done,
     /* 701092 */   // Label 9047: @701092
     /* 701092 */   GIM_Try, /*On fail goto*//*Label 9048*/ GIMT_Encode4(701151), // Rule ID 4762 //
     /* 701097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701101 */     // MIs[0] offset
     /* 701101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701104 */     // MIs[0] auxiliary
     /* 701104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701107 */     // MIs[0] Operand 7
     /* 701107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701117 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
     /* 701120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701122 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 701124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701131 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701133 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701139 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701149 */     GIR_RootConstrainSelectedInstOperands,
     /* 701150 */     // GIR_Coverage, 4762,
     /* 701150 */     GIR_EraseRootFromParent_Done,
     /* 701151 */   // Label 9048: @701151
     /* 701151 */   GIM_Try, /*On fail goto*//*Label 9049*/ GIMT_Encode4(701251), // Rule ID 4751 //
     /* 701156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701159 */     // MIs[0] offset
     /* 701159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701162 */     // MIs[0] auxiliary
     /* 701162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701165 */     // MIs[0] Operand 7
     /* 701165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701175 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 701178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 701182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 701187 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 701191 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 701194 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 701198 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 701201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 701206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_BOTHEN),
     /* 701219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 701224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701231 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701233 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701239 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701249 */     GIR_RootConstrainSelectedInstOperands,
     /* 701250 */     // GIR_Coverage, 4751,
     /* 701250 */     GIR_EraseRootFromParent_Done,
     /* 701251 */   // Label 9049: @701251
     /* 701251 */   GIM_Try, /*On fail goto*//*Label 9050*/ GIMT_Encode4(701348), // Rule ID 4755 //
     /* 701256 */     // MIs[0] offset
     /* 701256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701259 */     // MIs[0] auxiliary
     /* 701259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701262 */     // MIs[0] Operand 7
     /* 701262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701272 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 701275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 701279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 701284 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 701288 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 701291 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 701295 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 701298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 701303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
     /* 701316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 701321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701328 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701330 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701336 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701346 */     GIR_RootConstrainSelectedInstOperands,
     /* 701347 */     // GIR_Coverage, 4755,
     /* 701347 */     GIR_EraseRootFromParent_Done,
     /* 701348 */   // Label 9050: @701348
     /* 701348 */   GIM_Try, /*On fail goto*//*Label 9051*/ GIMT_Encode4(701448), // Rule ID 4759 //
     /* 701353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701356 */     // MIs[0] offset
     /* 701356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701359 */     // MIs[0] auxiliary
     /* 701359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701362 */     // MIs[0] Operand 7
     /* 701362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701372 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 701375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 701379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 701384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 701388 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 701391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 701395 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 701398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 701403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_BOTHEN),
     /* 701416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 701421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701428 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701446 */     GIR_RootConstrainSelectedInstOperands,
     /* 701447 */     // GIR_Coverage, 4759,
     /* 701447 */     GIR_EraseRootFromParent_Done,
     /* 701448 */   // Label 9051: @701448
     /* 701448 */   GIM_Try, /*On fail goto*//*Label 9052*/ GIMT_Encode4(701545), // Rule ID 4763 //
     /* 701453 */     // MIs[0] offset
     /* 701453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701456 */     // MIs[0] auxiliary
     /* 701456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701459 */     // MIs[0] Operand 7
     /* 701459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701469 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 701472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 701476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 701481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 701485 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 701488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 701492 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 701495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 701500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
     /* 701513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 701518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701525 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701527 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701543 */     GIR_RootConstrainSelectedInstOperands,
     /* 701544 */     // GIR_Coverage, 4763,
     /* 701544 */     GIR_EraseRootFromParent_Done,
     /* 701545 */   // Label 9052: @701545
     /* 701545 */   GIM_Reject,
     /* 701546 */ // Label 9036: @701546
     /* 701546 */ GIM_Reject,
     /* 701547 */ // Label 8984: @701547
     /* 701547 */ GIM_Reject,
     /* 701548 */ // Label 127: @701548
     /* 701548 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 9060*/ GIMT_Encode4(709292),
     /* 701559 */ /*GILLT_s16*//*Label 9053*/ GIMT_Encode4(701599),
     /* 701563 */ /*GILLT_s32*//*Label 9054*/ GIMT_Encode4(703446), GIMT_Encode4(0),
     /* 701571 */ /*GILLT_v2s16*//*Label 9055*/ GIMT_Encode4(704381),
     /* 701575 */ /*GILLT_v2s32*//*Label 9056*/ GIMT_Encode4(705620), GIMT_Encode4(0),
     /* 701583 */ /*GILLT_v3s32*//*Label 9057*/ GIMT_Encode4(705947), GIMT_Encode4(0),
     /* 701591 */ /*GILLT_v4s16*//*Label 9058*/ GIMT_Encode4(706274),
     /* 701595 */ /*GILLT_v4s32*//*Label 9059*/ GIMT_Encode4(708965),
     /* 701599 */ // Label 9053: @701599
     /* 701599 */ GIM_Try, /*On fail goto*//*Label 9061*/ GIMT_Encode4(703445),
     /* 701604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 701607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 701610 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 701613 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 701616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 701620 */   GIM_Try, /*On fail goto*//*Label 9062*/ GIMT_Encode4(701692), // Rule ID 4796 //
     /* 701625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 701628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701636 */     // MIs[0] offset
     /* 701636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701639 */     // MIs[0] auxiliary
     /* 701639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701642 */     // MIs[0] Operand 7
     /* 701642 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701660 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 701663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701672 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701674 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701680 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701690 */     GIR_RootConstrainSelectedInstOperands,
     /* 701691 */     // GIR_Coverage, 4796,
     /* 701691 */     GIR_EraseRootFromParent_Done,
     /* 701692 */   // Label 9062: @701692
     /* 701692 */   GIM_Try, /*On fail goto*//*Label 9063*/ GIMT_Encode4(701764), // Rule ID 4800 //
     /* 701697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 701700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701708 */     // MIs[0] offset
     /* 701708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701711 */     // MIs[0] auxiliary
     /* 701711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701714 */     // MIs[0] Operand 7
     /* 701714 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701732 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 701735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701744 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701746 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701752 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701762 */     GIR_RootConstrainSelectedInstOperands,
     /* 701763 */     // GIR_Coverage, 4800,
     /* 701763 */     GIR_EraseRootFromParent_Done,
     /* 701764 */   // Label 9063: @701764
     /* 701764 */   GIM_Try, /*On fail goto*//*Label 9064*/ GIMT_Encode4(701836), // Rule ID 4820 //
     /* 701769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 701772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701780 */     // MIs[0] offset
     /* 701780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701783 */     // MIs[0] auxiliary
     /* 701783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701786 */     // MIs[0] Operand 7
     /* 701786 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701804 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 701807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701816 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701818 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701824 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701834 */     GIR_RootConstrainSelectedInstOperands,
     /* 701835 */     // GIR_Coverage, 4820,
     /* 701835 */     GIR_EraseRootFromParent_Done,
     /* 701836 */   // Label 9064: @701836
     /* 701836 */   GIM_Try, /*On fail goto*//*Label 9065*/ GIMT_Encode4(701908), // Rule ID 4824 //
     /* 701841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 701844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701852 */     // MIs[0] offset
     /* 701852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701855 */     // MIs[0] auxiliary
     /* 701855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701858 */     // MIs[0] Operand 7
     /* 701858 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701876 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 701879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701888 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701890 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701906 */     GIR_RootConstrainSelectedInstOperands,
     /* 701907 */     // GIR_Coverage, 4824,
     /* 701907 */     GIR_EraseRootFromParent_Done,
     /* 701908 */   // Label 9065: @701908
     /* 701908 */   GIM_Try, /*On fail goto*//*Label 9066*/ GIMT_Encode4(701980), // Rule ID 4828 //
     /* 701913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 701916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701924 */     // MIs[0] offset
     /* 701924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701927 */     // MIs[0] auxiliary
     /* 701927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701930 */     // MIs[0] Operand 7
     /* 701930 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701948 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 701951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701960 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701962 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701968 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701978 */     GIR_RootConstrainSelectedInstOperands,
     /* 701979 */     // GIR_Coverage, 4828,
     /* 701979 */     GIR_EraseRootFromParent_Done,
     /* 701980 */   // Label 9066: @701980
     /* 701980 */   GIM_Try, /*On fail goto*//*Label 9067*/ GIMT_Encode4(702052), // Rule ID 4832 //
     /* 701985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 701988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701996 */     // MIs[0] offset
     /* 701996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701999 */     // MIs[0] auxiliary
     /* 701999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702002 */     // MIs[0] Operand 7
     /* 702002 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702020 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 702023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702032 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702034 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702040 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702050 */     GIR_RootConstrainSelectedInstOperands,
     /* 702051 */     // GIR_Coverage, 4832,
     /* 702051 */     GIR_EraseRootFromParent_Done,
     /* 702052 */   // Label 9067: @702052
     /* 702052 */   GIM_Try, /*On fail goto*//*Label 9068*/ GIMT_Encode4(702122), // Rule ID 4797 //
     /* 702057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 702060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702064 */     // MIs[0] offset
     /* 702064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702067 */     // MIs[0] auxiliary
     /* 702067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702070 */     // MIs[0] Operand 7
     /* 702070 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702088 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 702091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702093 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702102 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702104 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702110 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702120 */     GIR_RootConstrainSelectedInstOperands,
     /* 702121 */     // GIR_Coverage, 4797,
     /* 702121 */     GIR_EraseRootFromParent_Done,
     /* 702122 */   // Label 9068: @702122
     /* 702122 */   GIM_Try, /*On fail goto*//*Label 9069*/ GIMT_Encode4(702192), // Rule ID 4801 //
     /* 702127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 702130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702134 */     // MIs[0] offset
     /* 702134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702137 */     // MIs[0] auxiliary
     /* 702137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702140 */     // MIs[0] Operand 7
     /* 702140 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702158 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 702161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702163 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702172 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702174 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702180 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702190 */     GIR_RootConstrainSelectedInstOperands,
     /* 702191 */     // GIR_Coverage, 4801,
     /* 702191 */     GIR_EraseRootFromParent_Done,
     /* 702192 */   // Label 9069: @702192
     /* 702192 */   GIM_Try, /*On fail goto*//*Label 9070*/ GIMT_Encode4(702262), // Rule ID 4821 //
     /* 702197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 702200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702204 */     // MIs[0] offset
     /* 702204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702207 */     // MIs[0] auxiliary
     /* 702207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702210 */     // MIs[0] Operand 7
     /* 702210 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702228 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 702231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702233 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702242 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702250 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702260 */     GIR_RootConstrainSelectedInstOperands,
     /* 702261 */     // GIR_Coverage, 4821,
     /* 702261 */     GIR_EraseRootFromParent_Done,
     /* 702262 */   // Label 9070: @702262
     /* 702262 */   GIM_Try, /*On fail goto*//*Label 9071*/ GIMT_Encode4(702332), // Rule ID 4825 //
     /* 702267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 702270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702274 */     // MIs[0] offset
     /* 702274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702277 */     // MIs[0] auxiliary
     /* 702277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702280 */     // MIs[0] Operand 7
     /* 702280 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702298 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 702301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702303 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702312 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702314 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702320 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702330 */     GIR_RootConstrainSelectedInstOperands,
     /* 702331 */     // GIR_Coverage, 4825,
     /* 702331 */     GIR_EraseRootFromParent_Done,
     /* 702332 */   // Label 9071: @702332
     /* 702332 */   GIM_Try, /*On fail goto*//*Label 9072*/ GIMT_Encode4(702402), // Rule ID 4829 //
     /* 702337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 702340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702344 */     // MIs[0] offset
     /* 702344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702347 */     // MIs[0] auxiliary
     /* 702347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702350 */     // MIs[0] Operand 7
     /* 702350 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702368 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 702371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702373 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702382 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702384 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702390 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702400 */     GIR_RootConstrainSelectedInstOperands,
     /* 702401 */     // GIR_Coverage, 4829,
     /* 702401 */     GIR_EraseRootFromParent_Done,
     /* 702402 */   // Label 9072: @702402
     /* 702402 */   GIM_Try, /*On fail goto*//*Label 9073*/ GIMT_Encode4(702472), // Rule ID 4833 //
     /* 702407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 702410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702414 */     // MIs[0] offset
     /* 702414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702417 */     // MIs[0] auxiliary
     /* 702417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702420 */     // MIs[0] Operand 7
     /* 702420 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702438 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 702441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702443 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702452 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702454 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702460 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702470 */     GIR_RootConstrainSelectedInstOperands,
     /* 702471 */     // GIR_Coverage, 4833,
     /* 702471 */     GIR_EraseRootFromParent_Done,
     /* 702472 */   // Label 9073: @702472
     /* 702472 */   GIM_Try, /*On fail goto*//*Label 9074*/ GIMT_Encode4(702534), // Rule ID 4798 //
     /* 702477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 702480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702484 */     // MIs[0] offset
     /* 702484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702487 */     // MIs[0] auxiliary
     /* 702487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702490 */     // MIs[0] Operand 7
     /* 702490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702500 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 702503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702505 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 702507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702514 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702516 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702522 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702532 */     GIR_RootConstrainSelectedInstOperands,
     /* 702533 */     // GIR_Coverage, 4798,
     /* 702533 */     GIR_EraseRootFromParent_Done,
     /* 702534 */   // Label 9074: @702534
     /* 702534 */   GIM_Try, /*On fail goto*//*Label 9075*/ GIMT_Encode4(702596), // Rule ID 4802 //
     /* 702539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 702542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702546 */     // MIs[0] offset
     /* 702546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702549 */     // MIs[0] auxiliary
     /* 702549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702552 */     // MIs[0] Operand 7
     /* 702552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702562 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 702565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702567 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 702569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702576 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702578 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702594 */     GIR_RootConstrainSelectedInstOperands,
     /* 702595 */     // GIR_Coverage, 4802,
     /* 702595 */     GIR_EraseRootFromParent_Done,
     /* 702596 */   // Label 9075: @702596
     /* 702596 */   GIM_Try, /*On fail goto*//*Label 9076*/ GIMT_Encode4(702658), // Rule ID 4822 //
     /* 702601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 702604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702608 */     // MIs[0] offset
     /* 702608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702611 */     // MIs[0] auxiliary
     /* 702611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702614 */     // MIs[0] Operand 7
     /* 702614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702624 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 702627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702629 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 702631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702638 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702656 */     GIR_RootConstrainSelectedInstOperands,
     /* 702657 */     // GIR_Coverage, 4822,
     /* 702657 */     GIR_EraseRootFromParent_Done,
     /* 702658 */   // Label 9076: @702658
     /* 702658 */   GIM_Try, /*On fail goto*//*Label 9077*/ GIMT_Encode4(702720), // Rule ID 4826 //
     /* 702663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 702666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702670 */     // MIs[0] offset
     /* 702670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702673 */     // MIs[0] auxiliary
     /* 702673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702676 */     // MIs[0] Operand 7
     /* 702676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702686 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 702689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702691 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 702693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702700 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702702 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702708 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702718 */     GIR_RootConstrainSelectedInstOperands,
     /* 702719 */     // GIR_Coverage, 4826,
     /* 702719 */     GIR_EraseRootFromParent_Done,
     /* 702720 */   // Label 9077: @702720
     /* 702720 */   GIM_Try, /*On fail goto*//*Label 9078*/ GIMT_Encode4(702782), // Rule ID 4830 //
     /* 702725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 702728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702732 */     // MIs[0] offset
     /* 702732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702735 */     // MIs[0] auxiliary
     /* 702735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702738 */     // MIs[0] Operand 7
     /* 702738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702748 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 702751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702753 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 702755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702762 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702764 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702770 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702780 */     GIR_RootConstrainSelectedInstOperands,
     /* 702781 */     // GIR_Coverage, 4830,
     /* 702781 */     GIR_EraseRootFromParent_Done,
     /* 702782 */   // Label 9078: @702782
     /* 702782 */   GIM_Try, /*On fail goto*//*Label 9079*/ GIMT_Encode4(702844), // Rule ID 4834 //
     /* 702787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 702790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702794 */     // MIs[0] offset
     /* 702794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702797 */     // MIs[0] auxiliary
     /* 702797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702800 */     // MIs[0] Operand 7
     /* 702800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702810 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 702813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702815 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 702817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702824 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702826 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702832 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702842 */     GIR_RootConstrainSelectedInstOperands,
     /* 702843 */     // GIR_Coverage, 4834,
     /* 702843 */     GIR_EraseRootFromParent_Done,
     /* 702844 */   // Label 9079: @702844
     /* 702844 */   GIM_Try, /*On fail goto*//*Label 9080*/ GIMT_Encode4(702944), // Rule ID 4799 //
     /* 702849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 702852 */     // MIs[0] offset
     /* 702852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702855 */     // MIs[0] auxiliary
     /* 702855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702858 */     // MIs[0] Operand 7
     /* 702858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702868 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 702871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 702875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 702880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 702884 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 702887 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 702891 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 702894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 702899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 702904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 702909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 702912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 702917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702924 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702932 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702942 */     GIR_RootConstrainSelectedInstOperands,
     /* 702943 */     // GIR_Coverage, 4799,
     /* 702943 */     GIR_EraseRootFromParent_Done,
     /* 702944 */   // Label 9080: @702944
     /* 702944 */   GIM_Try, /*On fail goto*//*Label 9081*/ GIMT_Encode4(703044), // Rule ID 4803 //
     /* 702949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 702952 */     // MIs[0] offset
     /* 702952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702955 */     // MIs[0] auxiliary
     /* 702955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702958 */     // MIs[0] Operand 7
     /* 702958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702968 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 702971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 702975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 702980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 702984 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 702987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 702991 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 702994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 702999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 703012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703024 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703026 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703032 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703042 */     GIR_RootConstrainSelectedInstOperands,
     /* 703043 */     // GIR_Coverage, 4803,
     /* 703043 */     GIR_EraseRootFromParent_Done,
     /* 703044 */   // Label 9081: @703044
     /* 703044 */   GIM_Try, /*On fail goto*//*Label 9082*/ GIMT_Encode4(703144), // Rule ID 4823 //
     /* 703049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 703052 */     // MIs[0] offset
     /* 703052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703055 */     // MIs[0] auxiliary
     /* 703055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703058 */     // MIs[0] Operand 7
     /* 703058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703068 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703080 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703084 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703087 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703091 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 703112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703124 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703126 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703132 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703142 */     GIR_RootConstrainSelectedInstOperands,
     /* 703143 */     // GIR_Coverage, 4823,
     /* 703143 */     GIR_EraseRootFromParent_Done,
     /* 703144 */   // Label 9082: @703144
     /* 703144 */   GIM_Try, /*On fail goto*//*Label 9083*/ GIMT_Encode4(703244), // Rule ID 4827 //
     /* 703149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 703152 */     // MIs[0] offset
     /* 703152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703155 */     // MIs[0] auxiliary
     /* 703155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703158 */     // MIs[0] Operand 7
     /* 703158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703168 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703180 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703184 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703187 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703191 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 703212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703224 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703226 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703232 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703242 */     GIR_RootConstrainSelectedInstOperands,
     /* 703243 */     // GIR_Coverage, 4827,
     /* 703243 */     GIR_EraseRootFromParent_Done,
     /* 703244 */   // Label 9083: @703244
     /* 703244 */   GIM_Try, /*On fail goto*//*Label 9084*/ GIMT_Encode4(703344), // Rule ID 4831 //
     /* 703249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 703252 */     // MIs[0] offset
     /* 703252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703255 */     // MIs[0] auxiliary
     /* 703255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703258 */     // MIs[0] Operand 7
     /* 703258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703268 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703284 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703291 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 703312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703324 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703326 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703342 */     GIR_RootConstrainSelectedInstOperands,
     /* 703343 */     // GIR_Coverage, 4831,
     /* 703343 */     GIR_EraseRootFromParent_Done,
     /* 703344 */   // Label 9084: @703344
     /* 703344 */   GIM_Try, /*On fail goto*//*Label 9085*/ GIMT_Encode4(703444), // Rule ID 4835 //
     /* 703349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 703352 */     // MIs[0] offset
     /* 703352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703355 */     // MIs[0] auxiliary
     /* 703355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703358 */     // MIs[0] Operand 7
     /* 703358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703368 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703384 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703387 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703391 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 703412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703424 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703426 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703432 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703442 */     GIR_RootConstrainSelectedInstOperands,
     /* 703443 */     // GIR_Coverage, 4835,
     /* 703443 */     GIR_EraseRootFromParent_Done,
     /* 703444 */   // Label 9085: @703444
     /* 703444 */   GIM_Reject,
     /* 703445 */ // Label 9061: @703445
     /* 703445 */ GIM_Reject,
     /* 703446 */ // Label 9054: @703446
     /* 703446 */ GIM_Try, /*On fail goto*//*Label 9086*/ GIMT_Encode4(704380),
     /* 703451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 703454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 703457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 703460 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 703463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 703467 */   GIM_Try, /*On fail goto*//*Label 9087*/ GIMT_Encode4(703539), // Rule ID 4804 //
     /* 703472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 703475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703483 */     // MIs[0] offset
     /* 703483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703486 */     // MIs[0] auxiliary
     /* 703486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703489 */     // MIs[0] Operand 7
     /* 703489 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703507 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 703510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703519 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703521 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703527 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703537 */     GIR_RootConstrainSelectedInstOperands,
     /* 703538 */     // GIR_Coverage, 4804,
     /* 703538 */     GIR_EraseRootFromParent_Done,
     /* 703539 */   // Label 9087: @703539
     /* 703539 */   GIM_Try, /*On fail goto*//*Label 9088*/ GIMT_Encode4(703611), // Rule ID 4836 //
     /* 703544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 703547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703555 */     // MIs[0] offset
     /* 703555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703558 */     // MIs[0] auxiliary
     /* 703558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703561 */     // MIs[0] Operand 7
     /* 703561 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703579 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 703582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703591 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703593 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703609 */     GIR_RootConstrainSelectedInstOperands,
     /* 703610 */     // GIR_Coverage, 4836,
     /* 703610 */     GIR_EraseRootFromParent_Done,
     /* 703611 */   // Label 9088: @703611
     /* 703611 */   GIM_Try, /*On fail goto*//*Label 9089*/ GIMT_Encode4(703683), // Rule ID 4840 //
     /* 703616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 703619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703627 */     // MIs[0] offset
     /* 703627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703630 */     // MIs[0] auxiliary
     /* 703630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703633 */     // MIs[0] Operand 7
     /* 703633 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703651 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 703654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703663 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703665 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703671 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703681 */     GIR_RootConstrainSelectedInstOperands,
     /* 703682 */     // GIR_Coverage, 4840,
     /* 703682 */     GIR_EraseRootFromParent_Done,
     /* 703683 */   // Label 9089: @703683
     /* 703683 */   GIM_Try, /*On fail goto*//*Label 9090*/ GIMT_Encode4(703753), // Rule ID 4805 //
     /* 703688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 703691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703695 */     // MIs[0] offset
     /* 703695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703698 */     // MIs[0] auxiliary
     /* 703698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703701 */     // MIs[0] Operand 7
     /* 703701 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703719 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 703722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703724 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 703726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703733 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703735 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703741 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703751 */     GIR_RootConstrainSelectedInstOperands,
     /* 703752 */     // GIR_Coverage, 4805,
     /* 703752 */     GIR_EraseRootFromParent_Done,
     /* 703753 */   // Label 9090: @703753
     /* 703753 */   GIM_Try, /*On fail goto*//*Label 9091*/ GIMT_Encode4(703823), // Rule ID 4837 //
     /* 703758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 703761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703765 */     // MIs[0] offset
     /* 703765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703768 */     // MIs[0] auxiliary
     /* 703768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703771 */     // MIs[0] Operand 7
     /* 703771 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703789 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 703792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703794 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 703796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703803 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703805 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703811 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703821 */     GIR_RootConstrainSelectedInstOperands,
     /* 703822 */     // GIR_Coverage, 4837,
     /* 703822 */     GIR_EraseRootFromParent_Done,
     /* 703823 */   // Label 9091: @703823
     /* 703823 */   GIM_Try, /*On fail goto*//*Label 9092*/ GIMT_Encode4(703893), // Rule ID 4841 //
     /* 703828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 703831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703835 */     // MIs[0] offset
     /* 703835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703838 */     // MIs[0] auxiliary
     /* 703838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703841 */     // MIs[0] Operand 7
     /* 703841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703859 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 703862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703864 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 703866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703873 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703875 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703881 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703891 */     GIR_RootConstrainSelectedInstOperands,
     /* 703892 */     // GIR_Coverage, 4841,
     /* 703892 */     GIR_EraseRootFromParent_Done,
     /* 703893 */   // Label 9092: @703893
     /* 703893 */   GIM_Try, /*On fail goto*//*Label 9093*/ GIMT_Encode4(703955), // Rule ID 4806 //
     /* 703898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 703901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703905 */     // MIs[0] offset
     /* 703905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703908 */     // MIs[0] auxiliary
     /* 703908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703911 */     // MIs[0] Operand 7
     /* 703911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703921 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 703924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703926 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 703928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703935 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703937 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703943 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703953 */     GIR_RootConstrainSelectedInstOperands,
     /* 703954 */     // GIR_Coverage, 4806,
     /* 703954 */     GIR_EraseRootFromParent_Done,
     /* 703955 */   // Label 9093: @703955
     /* 703955 */   GIM_Try, /*On fail goto*//*Label 9094*/ GIMT_Encode4(704017), // Rule ID 4838 //
     /* 703960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 703963 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703967 */     // MIs[0] offset
     /* 703967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703970 */     // MIs[0] auxiliary
     /* 703970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703973 */     // MIs[0] Operand 7
     /* 703973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703983 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 703986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703988 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 703990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703997 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703999 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704005 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704015 */     GIR_RootConstrainSelectedInstOperands,
     /* 704016 */     // GIR_Coverage, 4838,
     /* 704016 */     GIR_EraseRootFromParent_Done,
     /* 704017 */   // Label 9094: @704017
     /* 704017 */   GIM_Try, /*On fail goto*//*Label 9095*/ GIMT_Encode4(704079), // Rule ID 4842 //
     /* 704022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 704025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704029 */     // MIs[0] offset
     /* 704029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704032 */     // MIs[0] auxiliary
     /* 704032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704035 */     // MIs[0] Operand 7
     /* 704035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704045 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 704048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704050 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 704052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704059 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704061 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704067 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704077 */     GIR_RootConstrainSelectedInstOperands,
     /* 704078 */     // GIR_Coverage, 4842,
     /* 704078 */     GIR_EraseRootFromParent_Done,
     /* 704079 */   // Label 9095: @704079
     /* 704079 */   GIM_Try, /*On fail goto*//*Label 9096*/ GIMT_Encode4(704179), // Rule ID 4807 //
     /* 704084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 704087 */     // MIs[0] offset
     /* 704087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704090 */     // MIs[0] auxiliary
     /* 704090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704093 */     // MIs[0] Operand 7
     /* 704093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704103 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 704106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 704110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 704115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 704119 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 704122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 704126 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 704129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 704134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 704147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 704152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704159 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704161 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704167 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704177 */     GIR_RootConstrainSelectedInstOperands,
     /* 704178 */     // GIR_Coverage, 4807,
     /* 704178 */     GIR_EraseRootFromParent_Done,
     /* 704179 */   // Label 9096: @704179
     /* 704179 */   GIM_Try, /*On fail goto*//*Label 9097*/ GIMT_Encode4(704279), // Rule ID 4839 //
     /* 704184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 704187 */     // MIs[0] offset
     /* 704187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704190 */     // MIs[0] auxiliary
     /* 704190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704193 */     // MIs[0] Operand 7
     /* 704193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704203 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 704206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 704210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 704215 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 704219 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 704222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 704226 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 704229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 704234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 704247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 704252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704259 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704261 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704277 */     GIR_RootConstrainSelectedInstOperands,
     /* 704278 */     // GIR_Coverage, 4839,
     /* 704278 */     GIR_EraseRootFromParent_Done,
     /* 704279 */   // Label 9097: @704279
     /* 704279 */   GIM_Try, /*On fail goto*//*Label 9098*/ GIMT_Encode4(704379), // Rule ID 4843 //
     /* 704284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 704287 */     // MIs[0] offset
     /* 704287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704290 */     // MIs[0] auxiliary
     /* 704290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704293 */     // MIs[0] Operand 7
     /* 704293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704303 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 704306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 704310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 704315 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 704319 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 704322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 704326 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 704329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 704334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 704347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 704352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704359 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704361 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704367 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704377 */     GIR_RootConstrainSelectedInstOperands,
     /* 704378 */     // GIR_Coverage, 4843,
     /* 704378 */     GIR_EraseRootFromParent_Done,
     /* 704379 */   // Label 9098: @704379
     /* 704379 */   GIM_Reject,
     /* 704380 */ // Label 9086: @704380
     /* 704380 */ GIM_Reject,
     /* 704381 */ // Label 9055: @704381
     /* 704381 */ GIM_Try, /*On fail goto*//*Label 9099*/ GIMT_Encode4(705619),
     /* 704386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 704389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 704392 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 704395 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 704398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 704402 */   GIM_Try, /*On fail goto*//*Label 9100*/ GIMT_Encode4(704474), // Rule ID 4844 //
     /* 704407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 704410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704418 */     // MIs[0] offset
     /* 704418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704421 */     // MIs[0] auxiliary
     /* 704421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704424 */     // MIs[0] Operand 7
     /* 704424 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704442 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFSET),
     /* 704445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704454 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704456 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704462 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704472 */     GIR_RootConstrainSelectedInstOperands,
     /* 704473 */     // GIR_Coverage, 4844,
     /* 704473 */     GIR_EraseRootFromParent_Done,
     /* 704474 */   // Label 9100: @704474
     /* 704474 */   GIM_Try, /*On fail goto*//*Label 9101*/ GIMT_Encode4(704546), // Rule ID 4848 //
     /* 704479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 704482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704490 */     // MIs[0] offset
     /* 704490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704493 */     // MIs[0] auxiliary
     /* 704493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704496 */     // MIs[0] Operand 7
     /* 704496 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704514 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET),
     /* 704517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704526 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704528 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704534 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704544 */     GIR_RootConstrainSelectedInstOperands,
     /* 704545 */     // GIR_Coverage, 4848,
     /* 704545 */     GIR_EraseRootFromParent_Done,
     /* 704546 */   // Label 9101: @704546
     /* 704546 */   GIM_Try, /*On fail goto*//*Label 9102*/ GIMT_Encode4(704618), // Rule ID 4852 //
     /* 704551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 704554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704562 */     // MIs[0] offset
     /* 704562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704565 */     // MIs[0] auxiliary
     /* 704565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704568 */     // MIs[0] Operand 7
     /* 704568 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704586 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFSET),
     /* 704589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704598 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704600 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704606 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704616 */     GIR_RootConstrainSelectedInstOperands,
     /* 704617 */     // GIR_Coverage, 4852,
     /* 704617 */     GIR_EraseRootFromParent_Done,
     /* 704618 */   // Label 9102: @704618
     /* 704618 */   GIM_Try, /*On fail goto*//*Label 9103*/ GIMT_Encode4(704690), // Rule ID 4856 //
     /* 704623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 704626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704634 */     // MIs[0] offset
     /* 704634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704637 */     // MIs[0] auxiliary
     /* 704637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704640 */     // MIs[0] Operand 7
     /* 704640 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704658 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET),
     /* 704661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704670 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704672 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704678 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704688 */     GIR_RootConstrainSelectedInstOperands,
     /* 704689 */     // GIR_Coverage, 4856,
     /* 704689 */     GIR_EraseRootFromParent_Done,
     /* 704690 */   // Label 9103: @704690
     /* 704690 */   GIM_Try, /*On fail goto*//*Label 9104*/ GIMT_Encode4(704760), // Rule ID 4845 //
     /* 704695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 704698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704702 */     // MIs[0] offset
     /* 704702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704705 */     // MIs[0] auxiliary
     /* 704705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704708 */     // MIs[0] Operand 7
     /* 704708 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704726 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFEN),
     /* 704729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704731 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 704733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704740 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704742 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704748 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704758 */     GIR_RootConstrainSelectedInstOperands,
     /* 704759 */     // GIR_Coverage, 4845,
     /* 704759 */     GIR_EraseRootFromParent_Done,
     /* 704760 */   // Label 9104: @704760
     /* 704760 */   GIM_Try, /*On fail goto*//*Label 9105*/ GIMT_Encode4(704830), // Rule ID 4849 //
     /* 704765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 704768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704772 */     // MIs[0] offset
     /* 704772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704775 */     // MIs[0] auxiliary
     /* 704775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704778 */     // MIs[0] Operand 7
     /* 704778 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704796 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN),
     /* 704799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704801 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 704803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704810 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704812 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704818 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704828 */     GIR_RootConstrainSelectedInstOperands,
     /* 704829 */     // GIR_Coverage, 4849,
     /* 704829 */     GIR_EraseRootFromParent_Done,
     /* 704830 */   // Label 9105: @704830
     /* 704830 */   GIM_Try, /*On fail goto*//*Label 9106*/ GIMT_Encode4(704900), // Rule ID 4853 //
     /* 704835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 704838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704842 */     // MIs[0] offset
     /* 704842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704845 */     // MIs[0] auxiliary
     /* 704845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704848 */     // MIs[0] Operand 7
     /* 704848 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704866 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFEN),
     /* 704869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704871 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 704873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704880 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704882 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704888 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704898 */     GIR_RootConstrainSelectedInstOperands,
     /* 704899 */     // GIR_Coverage, 4853,
     /* 704899 */     GIR_EraseRootFromParent_Done,
     /* 704900 */   // Label 9106: @704900
     /* 704900 */   GIM_Try, /*On fail goto*//*Label 9107*/ GIMT_Encode4(704970), // Rule ID 4857 //
     /* 704905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 704908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704912 */     // MIs[0] offset
     /* 704912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704915 */     // MIs[0] auxiliary
     /* 704915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704918 */     // MIs[0] Operand 7
     /* 704918 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704936 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN),
     /* 704939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704941 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 704943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704950 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704952 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704958 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704968 */     GIR_RootConstrainSelectedInstOperands,
     /* 704969 */     // GIR_Coverage, 4857,
     /* 704969 */     GIR_EraseRootFromParent_Done,
     /* 704970 */   // Label 9107: @704970
     /* 704970 */   GIM_Try, /*On fail goto*//*Label 9108*/ GIMT_Encode4(705032), // Rule ID 4846 //
     /* 704975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 704978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704982 */     // MIs[0] offset
     /* 704982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704985 */     // MIs[0] auxiliary
     /* 704985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704988 */     // MIs[0] Operand 7
     /* 704988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704998 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_IDXEN),
     /* 705001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705003 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 705005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705012 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705014 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705020 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705030 */     GIR_RootConstrainSelectedInstOperands,
     /* 705031 */     // GIR_Coverage, 4846,
     /* 705031 */     GIR_EraseRootFromParent_Done,
     /* 705032 */   // Label 9108: @705032
     /* 705032 */   GIM_Try, /*On fail goto*//*Label 9109*/ GIMT_Encode4(705094), // Rule ID 4850 //
     /* 705037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 705040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705044 */     // MIs[0] offset
     /* 705044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705047 */     // MIs[0] auxiliary
     /* 705047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705050 */     // MIs[0] Operand 7
     /* 705050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705060 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN),
     /* 705063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705065 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 705067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705074 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705076 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705092 */     GIR_RootConstrainSelectedInstOperands,
     /* 705093 */     // GIR_Coverage, 4850,
     /* 705093 */     GIR_EraseRootFromParent_Done,
     /* 705094 */   // Label 9109: @705094
     /* 705094 */   GIM_Try, /*On fail goto*//*Label 9110*/ GIMT_Encode4(705156), // Rule ID 4854 //
     /* 705099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 705102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705106 */     // MIs[0] offset
     /* 705106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705109 */     // MIs[0] auxiliary
     /* 705109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705112 */     // MIs[0] Operand 7
     /* 705112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705122 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_IDXEN),
     /* 705125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705127 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 705129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705136 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705138 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705144 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705154 */     GIR_RootConstrainSelectedInstOperands,
     /* 705155 */     // GIR_Coverage, 4854,
     /* 705155 */     GIR_EraseRootFromParent_Done,
     /* 705156 */   // Label 9110: @705156
     /* 705156 */   GIM_Try, /*On fail goto*//*Label 9111*/ GIMT_Encode4(705218), // Rule ID 4858 //
     /* 705161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 705164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705168 */     // MIs[0] offset
     /* 705168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705171 */     // MIs[0] auxiliary
     /* 705171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705174 */     // MIs[0] Operand 7
     /* 705174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705184 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN),
     /* 705187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705189 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 705191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705198 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705200 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705216 */     GIR_RootConstrainSelectedInstOperands,
     /* 705217 */     // GIR_Coverage, 4858,
     /* 705217 */     GIR_EraseRootFromParent_Done,
     /* 705218 */   // Label 9111: @705218
     /* 705218 */   GIM_Try, /*On fail goto*//*Label 9112*/ GIMT_Encode4(705318), // Rule ID 4847 //
     /* 705223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 705226 */     // MIs[0] offset
     /* 705226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705229 */     // MIs[0] auxiliary
     /* 705229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705232 */     // MIs[0] Operand 7
     /* 705232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705242 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 705245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 705249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 705254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 705258 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 705261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 705265 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 705268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 705273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_BOTHEN),
     /* 705286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 705291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705298 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705300 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705306 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705316 */     GIR_RootConstrainSelectedInstOperands,
     /* 705317 */     // GIR_Coverage, 4847,
     /* 705317 */     GIR_EraseRootFromParent_Done,
     /* 705318 */   // Label 9112: @705318
     /* 705318 */   GIM_Try, /*On fail goto*//*Label 9113*/ GIMT_Encode4(705418), // Rule ID 4851 //
     /* 705323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 705326 */     // MIs[0] offset
     /* 705326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705329 */     // MIs[0] auxiliary
     /* 705329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705332 */     // MIs[0] Operand 7
     /* 705332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705342 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 705345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 705349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 705354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 705358 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 705361 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 705365 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 705368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 705373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN),
     /* 705386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 705391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705398 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705400 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705406 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705416 */     GIR_RootConstrainSelectedInstOperands,
     /* 705417 */     // GIR_Coverage, 4851,
     /* 705417 */     GIR_EraseRootFromParent_Done,
     /* 705418 */   // Label 9113: @705418
     /* 705418 */   GIM_Try, /*On fail goto*//*Label 9114*/ GIMT_Encode4(705518), // Rule ID 4855 //
     /* 705423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 705426 */     // MIs[0] offset
     /* 705426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705429 */     // MIs[0] auxiliary
     /* 705429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705432 */     // MIs[0] Operand 7
     /* 705432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705442 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 705445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 705449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 705454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 705458 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 705461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 705465 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 705468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 705473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_BOTHEN),
     /* 705486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 705491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705498 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705500 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705506 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705516 */     GIR_RootConstrainSelectedInstOperands,
     /* 705517 */     // GIR_Coverage, 4855,
     /* 705517 */     GIR_EraseRootFromParent_Done,
     /* 705518 */   // Label 9114: @705518
     /* 705518 */   GIM_Try, /*On fail goto*//*Label 9115*/ GIMT_Encode4(705618), // Rule ID 4859 //
     /* 705523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 705526 */     // MIs[0] offset
     /* 705526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705529 */     // MIs[0] auxiliary
     /* 705529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705532 */     // MIs[0] Operand 7
     /* 705532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705542 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 705545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 705549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 705554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 705558 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 705561 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 705565 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 705568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 705573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN),
     /* 705586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 705591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705598 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705600 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705606 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705616 */     GIR_RootConstrainSelectedInstOperands,
     /* 705617 */     // GIR_Coverage, 4859,
     /* 705617 */     GIR_EraseRootFromParent_Done,
     /* 705618 */   // Label 9115: @705618
     /* 705618 */   GIM_Reject,
     /* 705619 */ // Label 9099: @705619
     /* 705619 */ GIM_Reject,
     /* 705620 */ // Label 9056: @705620
     /* 705620 */ GIM_Try, /*On fail goto*//*Label 9116*/ GIMT_Encode4(705946),
     /* 705625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 705628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 705631 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 705634 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 705637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 705641 */   GIM_Try, /*On fail goto*//*Label 9117*/ GIMT_Encode4(705713), // Rule ID 4808 //
     /* 705646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 705649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 705653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705657 */     // MIs[0] offset
     /* 705657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705660 */     // MIs[0] auxiliary
     /* 705660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705663 */     // MIs[0] Operand 7
     /* 705663 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 705674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705681 */     // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET),
     /* 705684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705693 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705695 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705701 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705711 */     GIR_RootConstrainSelectedInstOperands,
     /* 705712 */     // GIR_Coverage, 4808,
     /* 705712 */     GIR_EraseRootFromParent_Done,
     /* 705713 */   // Label 9117: @705713
     /* 705713 */   GIM_Try, /*On fail goto*//*Label 9118*/ GIMT_Encode4(705783), // Rule ID 4809 //
     /* 705718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 705721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 705725 */     // MIs[0] offset
     /* 705725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705728 */     // MIs[0] auxiliary
     /* 705728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705731 */     // MIs[0] Operand 7
     /* 705731 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 705742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705749 */     // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN),
     /* 705752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705754 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 705756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705763 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705765 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705771 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705781 */     GIR_RootConstrainSelectedInstOperands,
     /* 705782 */     // GIR_Coverage, 4809,
     /* 705782 */     GIR_EraseRootFromParent_Done,
     /* 705783 */   // Label 9118: @705783
     /* 705783 */   GIM_Try, /*On fail goto*//*Label 9119*/ GIMT_Encode4(705845), // Rule ID 4810 //
     /* 705788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 705791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705795 */     // MIs[0] offset
     /* 705795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705798 */     // MIs[0] auxiliary
     /* 705798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705801 */     // MIs[0] Operand 7
     /* 705801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705811 */     // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN),
     /* 705814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705816 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 705818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705825 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705827 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705833 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705843 */     GIR_RootConstrainSelectedInstOperands,
     /* 705844 */     // GIR_Coverage, 4810,
     /* 705844 */     GIR_EraseRootFromParent_Done,
     /* 705845 */   // Label 9119: @705845
     /* 705845 */   GIM_Try, /*On fail goto*//*Label 9120*/ GIMT_Encode4(705945), // Rule ID 4811 //
     /* 705850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 705853 */     // MIs[0] offset
     /* 705853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705856 */     // MIs[0] auxiliary
     /* 705856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705859 */     // MIs[0] Operand 7
     /* 705859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705869 */     // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 705872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 705876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 705881 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 705885 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 705888 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 705892 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 705895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 705900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN),
     /* 705913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 705918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705925 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705927 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705933 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705943 */     GIR_RootConstrainSelectedInstOperands,
     /* 705944 */     // GIR_Coverage, 4811,
     /* 705944 */     GIR_EraseRootFromParent_Done,
     /* 705945 */   // Label 9120: @705945
     /* 705945 */   GIM_Reject,
     /* 705946 */ // Label 9116: @705946
     /* 705946 */ GIM_Reject,
     /* 705947 */ // Label 9057: @705947
     /* 705947 */ GIM_Try, /*On fail goto*//*Label 9121*/ GIMT_Encode4(706273),
     /* 705952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 705955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 705958 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 705961 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 705964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 705968 */   GIM_Try, /*On fail goto*//*Label 9122*/ GIMT_Encode4(706040), // Rule ID 4812 //
     /* 705973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 705976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 705980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705984 */     // MIs[0] offset
     /* 705984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705987 */     // MIs[0] auxiliary
     /* 705987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705990 */     // MIs[0] Operand 7
     /* 705990 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706008 */     // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET),
     /* 706011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706020 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706028 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706038 */     GIR_RootConstrainSelectedInstOperands,
     /* 706039 */     // GIR_Coverage, 4812,
     /* 706039 */     GIR_EraseRootFromParent_Done,
     /* 706040 */   // Label 9122: @706040
     /* 706040 */   GIM_Try, /*On fail goto*//*Label 9123*/ GIMT_Encode4(706110), // Rule ID 4813 //
     /* 706045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706052 */     // MIs[0] offset
     /* 706052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706055 */     // MIs[0] auxiliary
     /* 706055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706058 */     // MIs[0] Operand 7
     /* 706058 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706076 */     // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN),
     /* 706079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706081 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 706083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706090 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706092 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706098 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706108 */     GIR_RootConstrainSelectedInstOperands,
     /* 706109 */     // GIR_Coverage, 4813,
     /* 706109 */     GIR_EraseRootFromParent_Done,
     /* 706110 */   // Label 9123: @706110
     /* 706110 */   GIM_Try, /*On fail goto*//*Label 9124*/ GIMT_Encode4(706172), // Rule ID 4814 //
     /* 706115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706122 */     // MIs[0] offset
     /* 706122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706125 */     // MIs[0] auxiliary
     /* 706125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706128 */     // MIs[0] Operand 7
     /* 706128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 706131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706138 */     // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN),
     /* 706141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706143 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 706145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706152 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706154 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706160 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706170 */     GIR_RootConstrainSelectedInstOperands,
     /* 706171 */     // GIR_Coverage, 4814,
     /* 706171 */     GIR_EraseRootFromParent_Done,
     /* 706172 */   // Label 9124: @706172
     /* 706172 */   GIM_Try, /*On fail goto*//*Label 9125*/ GIMT_Encode4(706272), // Rule ID 4815 //
     /* 706177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706180 */     // MIs[0] offset
     /* 706180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706183 */     // MIs[0] auxiliary
     /* 706183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706186 */     // MIs[0] Operand 7
     /* 706186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 706189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706196 */     // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 706199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 706203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 706208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 706212 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 706215 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 706219 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 706222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 706227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 706232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 706237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN),
     /* 706240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 706245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706252 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706254 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706260 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706270 */     GIR_RootConstrainSelectedInstOperands,
     /* 706271 */     // GIR_Coverage, 4815,
     /* 706271 */     GIR_EraseRootFromParent_Done,
     /* 706272 */   // Label 9125: @706272
     /* 706272 */   GIM_Reject,
     /* 706273 */ // Label 9121: @706273
     /* 706273 */ GIM_Reject,
     /* 706274 */ // Label 9058: @706274
     /* 706274 */ GIM_Try, /*On fail goto*//*Label 9126*/ GIMT_Encode4(708964),
     /* 706279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 706282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 706285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 706288 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 706291 */   GIM_Try, /*On fail goto*//*Label 9127*/ GIMT_Encode4(706374), // Rule ID 4860 //
     /* 706296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 706299 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 706306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706318 */     // MIs[0] offset
     /* 706318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706321 */     // MIs[0] auxiliary
     /* 706321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706324 */     // MIs[0] Operand 7
     /* 706324 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706342 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31427>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET),
     /* 706345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706354 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706372 */     GIR_RootConstrainSelectedInstOperands,
     /* 706373 */     // GIR_Coverage, 4860,
     /* 706373 */     GIR_EraseRootFromParent_Done,
     /* 706374 */   // Label 9127: @706374
     /* 706374 */   GIM_Try, /*On fail goto*//*Label 9128*/ GIMT_Encode4(706457), // Rule ID 4864 //
     /* 706379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 706382 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 706389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706401 */     // MIs[0] offset
     /* 706401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706404 */     // MIs[0] auxiliary
     /* 706404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706407 */     // MIs[0] Operand 7
     /* 706407 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706425 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31427>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET),
     /* 706428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706437 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706439 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706445 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706455 */     GIR_RootConstrainSelectedInstOperands,
     /* 706456 */     // GIR_Coverage, 4864,
     /* 706456 */     GIR_EraseRootFromParent_Done,
     /* 706457 */   // Label 9128: @706457
     /* 706457 */   GIM_Try, /*On fail goto*//*Label 9129*/ GIMT_Encode4(706540), // Rule ID 4868 //
     /* 706462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 706465 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 706472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706484 */     // MIs[0] offset
     /* 706484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706487 */     // MIs[0] auxiliary
     /* 706487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706490 */     // MIs[0] Operand 7
     /* 706490 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706508 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31437>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET),
     /* 706511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706520 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706522 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706528 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706538 */     GIR_RootConstrainSelectedInstOperands,
     /* 706539 */     // GIR_Coverage, 4868,
     /* 706539 */     GIR_EraseRootFromParent_Done,
     /* 706540 */   // Label 9129: @706540
     /* 706540 */   GIM_Try, /*On fail goto*//*Label 9130*/ GIMT_Encode4(706623), // Rule ID 4872 //
     /* 706545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 706548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 706555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706567 */     // MIs[0] offset
     /* 706567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706570 */     // MIs[0] auxiliary
     /* 706570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706573 */     // MIs[0] Operand 7
     /* 706573 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706591 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31437>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET),
     /* 706594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706603 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706605 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706611 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706621 */     GIR_RootConstrainSelectedInstOperands,
     /* 706622 */     // GIR_Coverage, 4872,
     /* 706622 */     GIR_EraseRootFromParent_Done,
     /* 706623 */   // Label 9130: @706623
     /* 706623 */   GIM_Try, /*On fail goto*//*Label 9131*/ GIMT_Encode4(706699), // Rule ID 4876 //
     /* 706628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 706631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706635 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706643 */     // MIs[0] offset
     /* 706643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706646 */     // MIs[0] auxiliary
     /* 706646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706649 */     // MIs[0] Operand 7
     /* 706649 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706667 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET),
     /* 706670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706679 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706681 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706687 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706697 */     GIR_RootConstrainSelectedInstOperands,
     /* 706698 */     // GIR_Coverage, 4876,
     /* 706698 */     GIR_EraseRootFromParent_Done,
     /* 706699 */   // Label 9131: @706699
     /* 706699 */   GIM_Try, /*On fail goto*//*Label 9132*/ GIMT_Encode4(706775), // Rule ID 4880 //
     /* 706704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 706707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706719 */     // MIs[0] offset
     /* 706719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706722 */     // MIs[0] auxiliary
     /* 706722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706725 */     // MIs[0] Operand 7
     /* 706725 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706743 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET),
     /* 706746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706755 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706757 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706763 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706773 */     GIR_RootConstrainSelectedInstOperands,
     /* 706774 */     // GIR_Coverage, 4880,
     /* 706774 */     GIR_EraseRootFromParent_Done,
     /* 706775 */   // Label 9132: @706775
     /* 706775 */   GIM_Try, /*On fail goto*//*Label 9133*/ GIMT_Encode4(706851), // Rule ID 4884 //
     /* 706780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 706783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706795 */     // MIs[0] offset
     /* 706795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706798 */     // MIs[0] auxiliary
     /* 706798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706801 */     // MIs[0] Operand 7
     /* 706801 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706819 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET),
     /* 706822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706831 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706833 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706839 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706849 */     GIR_RootConstrainSelectedInstOperands,
     /* 706850 */     // GIR_Coverage, 4884,
     /* 706850 */     GIR_EraseRootFromParent_Done,
     /* 706851 */   // Label 9133: @706851
     /* 706851 */   GIM_Try, /*On fail goto*//*Label 9134*/ GIMT_Encode4(706927), // Rule ID 4888 //
     /* 706856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 706859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706871 */     // MIs[0] offset
     /* 706871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706874 */     // MIs[0] auxiliary
     /* 706874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706877 */     // MIs[0] Operand 7
     /* 706877 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706895 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET),
     /* 706898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706907 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706909 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706915 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706925 */     GIR_RootConstrainSelectedInstOperands,
     /* 706926 */     // GIR_Coverage, 4888,
     /* 706926 */     GIR_EraseRootFromParent_Done,
     /* 706927 */   // Label 9134: @706927
     /* 706927 */   GIM_Try, /*On fail goto*//*Label 9135*/ GIMT_Encode4(707008), // Rule ID 4861 //
     /* 706932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 706935 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 706942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 706946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706950 */     // MIs[0] offset
     /* 706950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706953 */     // MIs[0] auxiliary
     /* 706953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706956 */     // MIs[0] Operand 7
     /* 706956 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706974 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31427>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN),
     /* 706977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706979 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 706981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706988 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706990 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707006 */     GIR_RootConstrainSelectedInstOperands,
     /* 707007 */     // GIR_Coverage, 4861,
     /* 707007 */     GIR_EraseRootFromParent_Done,
     /* 707008 */   // Label 9135: @707008
     /* 707008 */   GIM_Try, /*On fail goto*//*Label 9136*/ GIMT_Encode4(707089), // Rule ID 4865 //
     /* 707013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707016 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 707023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707031 */     // MIs[0] offset
     /* 707031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707034 */     // MIs[0] auxiliary
     /* 707034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707037 */     // MIs[0] Operand 7
     /* 707037 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707055 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31427>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN),
     /* 707058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707060 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707069 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707071 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707087 */     GIR_RootConstrainSelectedInstOperands,
     /* 707088 */     // GIR_Coverage, 4865,
     /* 707088 */     GIR_EraseRootFromParent_Done,
     /* 707089 */   // Label 9136: @707089
     /* 707089 */   GIM_Try, /*On fail goto*//*Label 9137*/ GIMT_Encode4(707170), // Rule ID 4869 //
     /* 707094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 707104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707112 */     // MIs[0] offset
     /* 707112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707115 */     // MIs[0] auxiliary
     /* 707115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707118 */     // MIs[0] Operand 7
     /* 707118 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707136 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31437>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN),
     /* 707139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707141 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707150 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707158 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707168 */     GIR_RootConstrainSelectedInstOperands,
     /* 707169 */     // GIR_Coverage, 4869,
     /* 707169 */     GIR_EraseRootFromParent_Done,
     /* 707170 */   // Label 9137: @707170
     /* 707170 */   GIM_Try, /*On fail goto*//*Label 9138*/ GIMT_Encode4(707251), // Rule ID 4873 //
     /* 707175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707178 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 707185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707189 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707193 */     // MIs[0] offset
     /* 707193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707196 */     // MIs[0] auxiliary
     /* 707196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707199 */     // MIs[0] Operand 7
     /* 707199 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707217 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31437>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN),
     /* 707220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707222 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707231 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707233 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707239 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707249 */     GIR_RootConstrainSelectedInstOperands,
     /* 707250 */     // GIR_Coverage, 4873,
     /* 707250 */     GIR_EraseRootFromParent_Done,
     /* 707251 */   // Label 9138: @707251
     /* 707251 */   GIM_Try, /*On fail goto*//*Label 9139*/ GIMT_Encode4(707325), // Rule ID 4877 //
     /* 707256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707267 */     // MIs[0] offset
     /* 707267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707270 */     // MIs[0] auxiliary
     /* 707270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707273 */     // MIs[0] Operand 7
     /* 707273 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707291 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN),
     /* 707294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707296 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707305 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707307 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707313 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707323 */     GIR_RootConstrainSelectedInstOperands,
     /* 707324 */     // GIR_Coverage, 4877,
     /* 707324 */     GIR_EraseRootFromParent_Done,
     /* 707325 */   // Label 9139: @707325
     /* 707325 */   GIM_Try, /*On fail goto*//*Label 9140*/ GIMT_Encode4(707399), // Rule ID 4881 //
     /* 707330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707341 */     // MIs[0] offset
     /* 707341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707344 */     // MIs[0] auxiliary
     /* 707344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707347 */     // MIs[0] Operand 7
     /* 707347 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707365 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN),
     /* 707368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707370 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707379 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707381 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707387 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707397 */     GIR_RootConstrainSelectedInstOperands,
     /* 707398 */     // GIR_Coverage, 4881,
     /* 707398 */     GIR_EraseRootFromParent_Done,
     /* 707399 */   // Label 9140: @707399
     /* 707399 */   GIM_Try, /*On fail goto*//*Label 9141*/ GIMT_Encode4(707473), // Rule ID 4885 //
     /* 707404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707415 */     // MIs[0] offset
     /* 707415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707418 */     // MIs[0] auxiliary
     /* 707418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707421 */     // MIs[0] Operand 7
     /* 707421 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707439 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN),
     /* 707442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707444 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707453 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707455 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707461 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707471 */     GIR_RootConstrainSelectedInstOperands,
     /* 707472 */     // GIR_Coverage, 4885,
     /* 707472 */     GIR_EraseRootFromParent_Done,
     /* 707473 */   // Label 9141: @707473
     /* 707473 */   GIM_Try, /*On fail goto*//*Label 9142*/ GIMT_Encode4(707547), // Rule ID 4889 //
     /* 707478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707489 */     // MIs[0] offset
     /* 707489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707492 */     // MIs[0] auxiliary
     /* 707492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707495 */     // MIs[0] Operand 7
     /* 707495 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707513 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN),
     /* 707516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707518 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 707520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707527 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707529 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707535 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707545 */     GIR_RootConstrainSelectedInstOperands,
     /* 707546 */     // GIR_Coverage, 4889,
     /* 707546 */     GIR_EraseRootFromParent_Done,
     /* 707547 */   // Label 9142: @707547
     /* 707547 */   GIM_Try, /*On fail goto*//*Label 9143*/ GIMT_Encode4(707620), // Rule ID 4862 //
     /* 707552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 707562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707570 */     // MIs[0] offset
     /* 707570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707573 */     // MIs[0] auxiliary
     /* 707573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707576 */     // MIs[0] Operand 7
     /* 707576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707586 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31427>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN),
     /* 707589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707591 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 707593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707600 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707602 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707608 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707618 */     GIR_RootConstrainSelectedInstOperands,
     /* 707619 */     // GIR_Coverage, 4862,
     /* 707619 */     GIR_EraseRootFromParent_Done,
     /* 707620 */   // Label 9143: @707620
     /* 707620 */   GIM_Try, /*On fail goto*//*Label 9144*/ GIMT_Encode4(707693), // Rule ID 4866 //
     /* 707625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707628 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 707635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707643 */     // MIs[0] offset
     /* 707643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707646 */     // MIs[0] auxiliary
     /* 707646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707649 */     // MIs[0] Operand 7
     /* 707649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707659 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31427>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN),
     /* 707662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707664 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 707666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707673 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707675 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707681 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707691 */     GIR_RootConstrainSelectedInstOperands,
     /* 707692 */     // GIR_Coverage, 4866,
     /* 707692 */     GIR_EraseRootFromParent_Done,
     /* 707693 */   // Label 9144: @707693
     /* 707693 */   GIM_Try, /*On fail goto*//*Label 9145*/ GIMT_Encode4(707766), // Rule ID 4870 //
     /* 707698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707701 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 707708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707716 */     // MIs[0] offset
     /* 707716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707719 */     // MIs[0] auxiliary
     /* 707719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707722 */     // MIs[0] Operand 7
     /* 707722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707732 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31437>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN),
     /* 707735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707737 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 707739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707746 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707748 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707754 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707764 */     GIR_RootConstrainSelectedInstOperands,
     /* 707765 */     // GIR_Coverage, 4870,
     /* 707765 */     GIR_EraseRootFromParent_Done,
     /* 707766 */   // Label 9145: @707766
     /* 707766 */   GIM_Try, /*On fail goto*//*Label 9146*/ GIMT_Encode4(707839), // Rule ID 4874 //
     /* 707771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707774 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 707781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707789 */     // MIs[0] offset
     /* 707789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707792 */     // MIs[0] auxiliary
     /* 707792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707795 */     // MIs[0] Operand 7
     /* 707795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707805 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31437>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN),
     /* 707808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707810 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 707812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707819 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707827 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707837 */     GIR_RootConstrainSelectedInstOperands,
     /* 707838 */     // GIR_Coverage, 4874,
     /* 707838 */     GIR_EraseRootFromParent_Done,
     /* 707839 */   // Label 9146: @707839
     /* 707839 */   GIM_Try, /*On fail goto*//*Label 9147*/ GIMT_Encode4(707905), // Rule ID 4878 //
     /* 707844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707855 */     // MIs[0] offset
     /* 707855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707858 */     // MIs[0] auxiliary
     /* 707858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707861 */     // MIs[0] Operand 7
     /* 707861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707871 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN),
     /* 707874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707876 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 707878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707885 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707887 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707893 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707903 */     GIR_RootConstrainSelectedInstOperands,
     /* 707904 */     // GIR_Coverage, 4878,
     /* 707904 */     GIR_EraseRootFromParent_Done,
     /* 707905 */   // Label 9147: @707905
     /* 707905 */   GIM_Try, /*On fail goto*//*Label 9148*/ GIMT_Encode4(707971), // Rule ID 4882 //
     /* 707910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707921 */     // MIs[0] offset
     /* 707921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707924 */     // MIs[0] auxiliary
     /* 707924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707927 */     // MIs[0] Operand 7
     /* 707927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707937 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN),
     /* 707940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707942 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 707944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707951 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707969 */     GIR_RootConstrainSelectedInstOperands,
     /* 707970 */     // GIR_Coverage, 4882,
     /* 707970 */     GIR_EraseRootFromParent_Done,
     /* 707971 */   // Label 9148: @707971
     /* 707971 */   GIM_Try, /*On fail goto*//*Label 9149*/ GIMT_Encode4(708037), // Rule ID 4886 //
     /* 707976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 707983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707987 */     // MIs[0] offset
     /* 707987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707990 */     // MIs[0] auxiliary
     /* 707990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707993 */     // MIs[0] Operand 7
     /* 707993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708003 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN),
     /* 708006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708008 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 708010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708017 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708019 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708025 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708035 */     GIR_RootConstrainSelectedInstOperands,
     /* 708036 */     // GIR_Coverage, 4886,
     /* 708036 */     GIR_EraseRootFromParent_Done,
     /* 708037 */   // Label 9149: @708037
     /* 708037 */   GIM_Try, /*On fail goto*//*Label 9150*/ GIMT_Encode4(708103), // Rule ID 4890 //
     /* 708042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708053 */     // MIs[0] offset
     /* 708053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708056 */     // MIs[0] auxiliary
     /* 708056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708059 */     // MIs[0] Operand 7
     /* 708059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708069 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN),
     /* 708072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708074 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 708076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708083 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708085 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708091 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708101 */     GIR_RootConstrainSelectedInstOperands,
     /* 708102 */     // GIR_Coverage, 4890,
     /* 708102 */     GIR_EraseRootFromParent_Done,
     /* 708103 */   // Label 9150: @708103
     /* 708103 */   GIM_Try, /*On fail goto*//*Label 9151*/ GIMT_Encode4(708214), // Rule ID 4863 //
     /* 708108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708111 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 708118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708122 */     // MIs[0] offset
     /* 708122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708125 */     // MIs[0] auxiliary
     /* 708125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708128 */     // MIs[0] Operand 7
     /* 708128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708138 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31427>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708154 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708157 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708161 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN),
     /* 708182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708194 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708196 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708202 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708212 */     GIR_RootConstrainSelectedInstOperands,
     /* 708213 */     // GIR_Coverage, 4863,
     /* 708213 */     GIR_EraseRootFromParent_Done,
     /* 708214 */   // Label 9151: @708214
     /* 708214 */   GIM_Try, /*On fail goto*//*Label 9152*/ GIMT_Encode4(708325), // Rule ID 4867 //
     /* 708219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708222 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 708229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708233 */     // MIs[0] offset
     /* 708233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708236 */     // MIs[0] auxiliary
     /* 708236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708239 */     // MIs[0] Operand 7
     /* 708239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708249 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31427>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708265 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708272 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN),
     /* 708293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708305 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708307 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708313 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708323 */     GIR_RootConstrainSelectedInstOperands,
     /* 708324 */     // GIR_Coverage, 4867,
     /* 708324 */     GIR_EraseRootFromParent_Done,
     /* 708325 */   // Label 9152: @708325
     /* 708325 */   GIM_Try, /*On fail goto*//*Label 9153*/ GIMT_Encode4(708436), // Rule ID 4871 //
     /* 708330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708333 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 708340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708344 */     // MIs[0] offset
     /* 708344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708347 */     // MIs[0] auxiliary
     /* 708347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708350 */     // MIs[0] Operand 7
     /* 708350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708360 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31437>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708376 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708379 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708383 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN),
     /* 708404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708416 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708418 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708434 */     GIR_RootConstrainSelectedInstOperands,
     /* 708435 */     // GIR_Coverage, 4871,
     /* 708435 */     GIR_EraseRootFromParent_Done,
     /* 708436 */   // Label 9153: @708436
     /* 708436 */   GIM_Try, /*On fail goto*//*Label 9154*/ GIMT_Encode4(708547), // Rule ID 4875 //
     /* 708441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 708451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708455 */     // MIs[0] offset
     /* 708455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708458 */     // MIs[0] auxiliary
     /* 708458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708461 */     // MIs[0] Operand 7
     /* 708461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708471 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31437>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708483 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708487 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708494 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN),
     /* 708515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708527 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708529 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708535 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708545 */     GIR_RootConstrainSelectedInstOperands,
     /* 708546 */     // GIR_Coverage, 4875,
     /* 708546 */     GIR_EraseRootFromParent_Done,
     /* 708547 */   // Label 9154: @708547
     /* 708547 */   GIM_Try, /*On fail goto*//*Label 9155*/ GIMT_Encode4(708651), // Rule ID 4879 //
     /* 708552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708559 */     // MIs[0] offset
     /* 708559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708562 */     // MIs[0] auxiliary
     /* 708562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708565 */     // MIs[0] Operand 7
     /* 708565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708575 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708591 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708598 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN),
     /* 708619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708631 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708639 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708649 */     GIR_RootConstrainSelectedInstOperands,
     /* 708650 */     // GIR_Coverage, 4879,
     /* 708650 */     GIR_EraseRootFromParent_Done,
     /* 708651 */   // Label 9155: @708651
     /* 708651 */   GIM_Try, /*On fail goto*//*Label 9156*/ GIMT_Encode4(708755), // Rule ID 4883 //
     /* 708656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708663 */     // MIs[0] offset
     /* 708663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708666 */     // MIs[0] auxiliary
     /* 708666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708669 */     // MIs[0] Operand 7
     /* 708669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708679 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708691 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708695 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708698 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708702 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN),
     /* 708723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708735 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708737 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708743 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708753 */     GIR_RootConstrainSelectedInstOperands,
     /* 708754 */     // GIR_Coverage, 4883,
     /* 708754 */     GIR_EraseRootFromParent_Done,
     /* 708755 */   // Label 9156: @708755
     /* 708755 */   GIM_Try, /*On fail goto*//*Label 9157*/ GIMT_Encode4(708859), // Rule ID 4887 //
     /* 708760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708767 */     // MIs[0] offset
     /* 708767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708770 */     // MIs[0] auxiliary
     /* 708770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708773 */     // MIs[0] Operand 7
     /* 708773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708783 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708795 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708799 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708806 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN),
     /* 708827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708839 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708841 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708847 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708857 */     GIR_RootConstrainSelectedInstOperands,
     /* 708858 */     // GIR_Coverage, 4887,
     /* 708858 */     GIR_EraseRootFromParent_Done,
     /* 708859 */   // Label 9157: @708859
     /* 708859 */   GIM_Try, /*On fail goto*//*Label 9158*/ GIMT_Encode4(708963), // Rule ID 4891 //
     /* 708864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 708871 */     // MIs[0] offset
     /* 708871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708874 */     // MIs[0] auxiliary
     /* 708874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708877 */     // MIs[0] Operand 7
     /* 708877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708887 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708903 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708910 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN),
     /* 708931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708943 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708945 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708961 */     GIR_RootConstrainSelectedInstOperands,
     /* 708962 */     // GIR_Coverage, 4891,
     /* 708962 */     GIR_EraseRootFromParent_Done,
     /* 708963 */   // Label 9158: @708963
     /* 708963 */   GIM_Reject,
     /* 708964 */ // Label 9126: @708964
     /* 708964 */ GIM_Reject,
     /* 708965 */ // Label 9059: @708965
     /* 708965 */ GIM_Try, /*On fail goto*//*Label 9159*/ GIMT_Encode4(709291),
     /* 708970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 708973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 708976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 708979 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 708982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 708986 */   GIM_Try, /*On fail goto*//*Label 9160*/ GIMT_Encode4(709058), // Rule ID 4816 //
     /* 708991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 708994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 708998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709002 */     // MIs[0] offset
     /* 709002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709005 */     // MIs[0] auxiliary
     /* 709005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709008 */     // MIs[0] Operand 7
     /* 709008 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709026 */     // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET),
     /* 709029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709038 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709040 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709046 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709056 */     GIR_RootConstrainSelectedInstOperands,
     /* 709057 */     // GIR_Coverage, 4816,
     /* 709057 */     GIR_EraseRootFromParent_Done,
     /* 709058 */   // Label 9160: @709058
     /* 709058 */   GIM_Try, /*On fail goto*//*Label 9161*/ GIMT_Encode4(709128), // Rule ID 4817 //
     /* 709063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 709066 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709070 */     // MIs[0] offset
     /* 709070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709073 */     // MIs[0] auxiliary
     /* 709073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709076 */     // MIs[0] Operand 7
     /* 709076 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709094 */     // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN),
     /* 709097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709099 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 709101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709108 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709110 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709116 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709126 */     GIR_RootConstrainSelectedInstOperands,
     /* 709127 */     // GIR_Coverage, 4817,
     /* 709127 */     GIR_EraseRootFromParent_Done,
     /* 709128 */   // Label 9161: @709128
     /* 709128 */   GIM_Try, /*On fail goto*//*Label 9162*/ GIMT_Encode4(709190), // Rule ID 4818 //
     /* 709133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 709136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709140 */     // MIs[0] offset
     /* 709140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709143 */     // MIs[0] auxiliary
     /* 709143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709146 */     // MIs[0] Operand 7
     /* 709146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709156 */     // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN),
     /* 709159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709161 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 709163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709170 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709172 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709178 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709188 */     GIR_RootConstrainSelectedInstOperands,
     /* 709189 */     // GIR_Coverage, 4818,
     /* 709189 */     GIR_EraseRootFromParent_Done,
     /* 709190 */   // Label 9162: @709190
     /* 709190 */   GIM_Try, /*On fail goto*//*Label 9163*/ GIMT_Encode4(709290), // Rule ID 4819 //
     /* 709195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 709198 */     // MIs[0] offset
     /* 709198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709201 */     // MIs[0] auxiliary
     /* 709201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709204 */     // MIs[0] Operand 7
     /* 709204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709214 */     // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 709217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 709221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 709226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 709230 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 709233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 709237 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 709240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 709245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN),
     /* 709258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 709263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709270 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709272 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709278 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709288 */     GIR_RootConstrainSelectedInstOperands,
     /* 709289 */     // GIR_Coverage, 4819,
     /* 709289 */     GIR_EraseRootFromParent_Done,
     /* 709290 */   // Label 9163: @709290
     /* 709290 */   GIM_Reject,
     /* 709291 */ // Label 9159: @709291
     /* 709291 */ GIM_Reject,
     /* 709292 */ // Label 9060: @709292
     /* 709292 */ GIM_Reject,
     /* 709293 */ // Label 128: @709293
     /* 709293 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(20), /*)*//*default:*//*Label 9168*/ GIMT_Encode4(711812),
     /* 709304 */ /*GILLT_v2s32*//*Label 9164*/ GIMT_Encode4(709336), GIMT_Encode4(0),
     /* 709312 */ /*GILLT_v3s32*//*Label 9165*/ GIMT_Encode4(709955), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 709324 */ /*GILLT_v4s32*//*Label 9166*/ GIMT_Encode4(710574), GIMT_Encode4(0),
     /* 709332 */ /*GILLT_v5s32*//*Label 9167*/ GIMT_Encode4(711193),
     /* 709336 */ // Label 9164: @709336
     /* 709336 */ GIM_Try, /*On fail goto*//*Label 9169*/ GIMT_Encode4(709954),
     /* 709341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 709344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 709347 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 709350 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 709353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 709357 */   GIM_Try, /*On fail goto*//*Label 9170*/ GIMT_Encode4(709429), // Rule ID 4764 //
     /* 709362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 709365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709373 */     // MIs[0] offset
     /* 709373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709376 */     // MIs[0] auxiliary
     /* 709376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709379 */     // MIs[0] Operand 7
     /* 709379 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709397 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_OFFSET),
     /* 709400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709409 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709411 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709427 */     GIR_RootConstrainSelectedInstOperands,
     /* 709428 */     // GIR_Coverage, 4764,
     /* 709428 */     GIR_EraseRootFromParent_Done,
     /* 709429 */   // Label 9170: @709429
     /* 709429 */   GIM_Try, /*On fail goto*//*Label 9171*/ GIMT_Encode4(709498), // Rule ID 4768 //
     /* 709434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709442 */     // MIs[0] offset
     /* 709442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709445 */     // MIs[0] auxiliary
     /* 709445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709448 */     // MIs[0] Operand 7
     /* 709448 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709466 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFSET),
     /* 709469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709478 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709480 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709496 */     GIR_RootConstrainSelectedInstOperands,
     /* 709497 */     // GIR_Coverage, 4768,
     /* 709497 */     GIR_EraseRootFromParent_Done,
     /* 709498 */   // Label 9171: @709498
     /* 709498 */   GIM_Try, /*On fail goto*//*Label 9172*/ GIMT_Encode4(709568), // Rule ID 4765 //
     /* 709503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 709506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709510 */     // MIs[0] offset
     /* 709510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709513 */     // MIs[0] auxiliary
     /* 709513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709516 */     // MIs[0] Operand 7
     /* 709516 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709534 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_OFFEN),
     /* 709537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709539 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 709541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709548 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709550 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709556 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709566 */     GIR_RootConstrainSelectedInstOperands,
     /* 709567 */     // GIR_Coverage, 4765,
     /* 709567 */     GIR_EraseRootFromParent_Done,
     /* 709568 */   // Label 9172: @709568
     /* 709568 */   GIM_Try, /*On fail goto*//*Label 9173*/ GIMT_Encode4(709635), // Rule ID 4769 //
     /* 709573 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709577 */     // MIs[0] offset
     /* 709577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709580 */     // MIs[0] auxiliary
     /* 709580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709583 */     // MIs[0] Operand 7
     /* 709583 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709601 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFEN),
     /* 709604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709606 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 709608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709615 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709617 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709623 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709633 */     GIR_RootConstrainSelectedInstOperands,
     /* 709634 */     // GIR_Coverage, 4769,
     /* 709634 */     GIR_EraseRootFromParent_Done,
     /* 709635 */   // Label 9173: @709635
     /* 709635 */   GIM_Try, /*On fail goto*//*Label 9174*/ GIMT_Encode4(709697), // Rule ID 4766 //
     /* 709640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 709643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709647 */     // MIs[0] offset
     /* 709647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709650 */     // MIs[0] auxiliary
     /* 709650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709653 */     // MIs[0] Operand 7
     /* 709653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709663 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_IDXEN),
     /* 709666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709668 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 709670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709677 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709679 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709685 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709695 */     GIR_RootConstrainSelectedInstOperands,
     /* 709696 */     // GIR_Coverage, 4766,
     /* 709696 */     GIR_EraseRootFromParent_Done,
     /* 709697 */   // Label 9174: @709697
     /* 709697 */   GIM_Try, /*On fail goto*//*Label 9175*/ GIMT_Encode4(709756), // Rule ID 4770 //
     /* 709702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709706 */     // MIs[0] offset
     /* 709706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709709 */     // MIs[0] auxiliary
     /* 709709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709712 */     // MIs[0] Operand 7
     /* 709712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709722 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_IDXEN),
     /* 709725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709727 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 709729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709736 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709738 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709754 */     GIR_RootConstrainSelectedInstOperands,
     /* 709755 */     // GIR_Coverage, 4770,
     /* 709755 */     GIR_EraseRootFromParent_Done,
     /* 709756 */   // Label 9175: @709756
     /* 709756 */   GIM_Try, /*On fail goto*//*Label 9176*/ GIMT_Encode4(709856), // Rule ID 4767 //
     /* 709761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 709764 */     // MIs[0] offset
     /* 709764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709767 */     // MIs[0] auxiliary
     /* 709767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709770 */     // MIs[0] Operand 7
     /* 709770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709780 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 709783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 709787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 709792 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 709796 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 709799 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 709803 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 709806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 709811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_BOTHEN),
     /* 709824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 709829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709836 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709838 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709844 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709854 */     GIR_RootConstrainSelectedInstOperands,
     /* 709855 */     // GIR_Coverage, 4767,
     /* 709855 */     GIR_EraseRootFromParent_Done,
     /* 709856 */   // Label 9176: @709856
     /* 709856 */   GIM_Try, /*On fail goto*//*Label 9177*/ GIMT_Encode4(709953), // Rule ID 4771 //
     /* 709861 */     // MIs[0] offset
     /* 709861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709864 */     // MIs[0] auxiliary
     /* 709864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709867 */     // MIs[0] Operand 7
     /* 709867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709877 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 709880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 709884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 709889 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 709893 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 709896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 709900 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 709903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 709908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_BOTHEN),
     /* 709921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 709926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709933 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709935 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709941 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709951 */     GIR_RootConstrainSelectedInstOperands,
     /* 709952 */     // GIR_Coverage, 4771,
     /* 709952 */     GIR_EraseRootFromParent_Done,
     /* 709953 */   // Label 9177: @709953
     /* 709953 */   GIM_Reject,
     /* 709954 */ // Label 9169: @709954
     /* 709954 */ GIM_Reject,
     /* 709955 */ // Label 9165: @709955
     /* 709955 */ GIM_Try, /*On fail goto*//*Label 9178*/ GIMT_Encode4(710573),
     /* 709960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 709963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 709966 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 709969 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 709972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 709976 */   GIM_Try, /*On fail goto*//*Label 9179*/ GIMT_Encode4(710048), // Rule ID 4772 //
     /* 709981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 709984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709992 */     // MIs[0] offset
     /* 709992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709995 */     // MIs[0] auxiliary
     /* 709995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709998 */     // MIs[0] Operand 7
     /* 709998 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710016 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_OFFSET),
     /* 710019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710028 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710030 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710036 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710046 */     GIR_RootConstrainSelectedInstOperands,
     /* 710047 */     // GIR_Coverage, 4772,
     /* 710047 */     GIR_EraseRootFromParent_Done,
     /* 710048 */   // Label 9179: @710048
     /* 710048 */   GIM_Try, /*On fail goto*//*Label 9180*/ GIMT_Encode4(710117), // Rule ID 4776 //
     /* 710053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710061 */     // MIs[0] offset
     /* 710061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710064 */     // MIs[0] auxiliary
     /* 710064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710067 */     // MIs[0] Operand 7
     /* 710067 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710085 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFSET),
     /* 710088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710097 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710099 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710115 */     GIR_RootConstrainSelectedInstOperands,
     /* 710116 */     // GIR_Coverage, 4776,
     /* 710116 */     GIR_EraseRootFromParent_Done,
     /* 710117 */   // Label 9180: @710117
     /* 710117 */   GIM_Try, /*On fail goto*//*Label 9181*/ GIMT_Encode4(710187), // Rule ID 4773 //
     /* 710122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 710125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710129 */     // MIs[0] offset
     /* 710129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710132 */     // MIs[0] auxiliary
     /* 710132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710135 */     // MIs[0] Operand 7
     /* 710135 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710153 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_OFFEN),
     /* 710156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710158 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 710160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710167 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710169 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710175 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710185 */     GIR_RootConstrainSelectedInstOperands,
     /* 710186 */     // GIR_Coverage, 4773,
     /* 710186 */     GIR_EraseRootFromParent_Done,
     /* 710187 */   // Label 9181: @710187
     /* 710187 */   GIM_Try, /*On fail goto*//*Label 9182*/ GIMT_Encode4(710254), // Rule ID 4777 //
     /* 710192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710196 */     // MIs[0] offset
     /* 710196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710199 */     // MIs[0] auxiliary
     /* 710199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710202 */     // MIs[0] Operand 7
     /* 710202 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710220 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFEN),
     /* 710223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710225 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 710227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710234 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710236 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710242 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710252 */     GIR_RootConstrainSelectedInstOperands,
     /* 710253 */     // GIR_Coverage, 4777,
     /* 710253 */     GIR_EraseRootFromParent_Done,
     /* 710254 */   // Label 9182: @710254
     /* 710254 */   GIM_Try, /*On fail goto*//*Label 9183*/ GIMT_Encode4(710316), // Rule ID 4774 //
     /* 710259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 710262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710266 */     // MIs[0] offset
     /* 710266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710269 */     // MIs[0] auxiliary
     /* 710269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710272 */     // MIs[0] Operand 7
     /* 710272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710282 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_IDXEN),
     /* 710285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710287 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 710289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710296 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710298 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710304 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710314 */     GIR_RootConstrainSelectedInstOperands,
     /* 710315 */     // GIR_Coverage, 4774,
     /* 710315 */     GIR_EraseRootFromParent_Done,
     /* 710316 */   // Label 9183: @710316
     /* 710316 */   GIM_Try, /*On fail goto*//*Label 9184*/ GIMT_Encode4(710375), // Rule ID 4778 //
     /* 710321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710325 */     // MIs[0] offset
     /* 710325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710328 */     // MIs[0] auxiliary
     /* 710328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710331 */     // MIs[0] Operand 7
     /* 710331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710341 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_IDXEN),
     /* 710344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710346 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 710348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710355 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710363 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710373 */     GIR_RootConstrainSelectedInstOperands,
     /* 710374 */     // GIR_Coverage, 4778,
     /* 710374 */     GIR_EraseRootFromParent_Done,
     /* 710375 */   // Label 9184: @710375
     /* 710375 */   GIM_Try, /*On fail goto*//*Label 9185*/ GIMT_Encode4(710475), // Rule ID 4775 //
     /* 710380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 710383 */     // MIs[0] offset
     /* 710383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710386 */     // MIs[0] auxiliary
     /* 710386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710389 */     // MIs[0] Operand 7
     /* 710389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710399 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 710402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 710406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 710411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 710415 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 710418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 710422 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 710425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 710430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_BOTHEN),
     /* 710443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 710448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710455 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710457 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710463 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710473 */     GIR_RootConstrainSelectedInstOperands,
     /* 710474 */     // GIR_Coverage, 4775,
     /* 710474 */     GIR_EraseRootFromParent_Done,
     /* 710475 */   // Label 9185: @710475
     /* 710475 */   GIM_Try, /*On fail goto*//*Label 9186*/ GIMT_Encode4(710572), // Rule ID 4779 //
     /* 710480 */     // MIs[0] offset
     /* 710480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710483 */     // MIs[0] auxiliary
     /* 710483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710486 */     // MIs[0] Operand 7
     /* 710486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710496 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 710499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 710503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 710508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 710512 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 710515 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 710519 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 710522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 710527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_BOTHEN),
     /* 710540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 710545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710552 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710554 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710560 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710570 */     GIR_RootConstrainSelectedInstOperands,
     /* 710571 */     // GIR_Coverage, 4779,
     /* 710571 */     GIR_EraseRootFromParent_Done,
     /* 710572 */   // Label 9186: @710572
     /* 710572 */   GIM_Reject,
     /* 710573 */ // Label 9178: @710573
     /* 710573 */ GIM_Reject,
     /* 710574 */ // Label 9166: @710574
     /* 710574 */ GIM_Try, /*On fail goto*//*Label 9187*/ GIMT_Encode4(711192),
     /* 710579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 710582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 710585 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 710588 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 710591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 710595 */   GIM_Try, /*On fail goto*//*Label 9188*/ GIMT_Encode4(710667), // Rule ID 4780 //
     /* 710600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 710603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710611 */     // MIs[0] offset
     /* 710611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710614 */     // MIs[0] auxiliary
     /* 710614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710617 */     // MIs[0] Operand 7
     /* 710617 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710635 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_OFFSET),
     /* 710638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710647 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710649 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710655 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710665 */     GIR_RootConstrainSelectedInstOperands,
     /* 710666 */     // GIR_Coverage, 4780,
     /* 710666 */     GIR_EraseRootFromParent_Done,
     /* 710667 */   // Label 9188: @710667
     /* 710667 */   GIM_Try, /*On fail goto*//*Label 9189*/ GIMT_Encode4(710736), // Rule ID 4784 //
     /* 710672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710680 */     // MIs[0] offset
     /* 710680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710683 */     // MIs[0] auxiliary
     /* 710683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710686 */     // MIs[0] Operand 7
     /* 710686 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710704 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFSET),
     /* 710707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710716 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710734 */     GIR_RootConstrainSelectedInstOperands,
     /* 710735 */     // GIR_Coverage, 4784,
     /* 710735 */     GIR_EraseRootFromParent_Done,
     /* 710736 */   // Label 9189: @710736
     /* 710736 */   GIM_Try, /*On fail goto*//*Label 9190*/ GIMT_Encode4(710806), // Rule ID 4781 //
     /* 710741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 710744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710748 */     // MIs[0] offset
     /* 710748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710751 */     // MIs[0] auxiliary
     /* 710751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710754 */     // MIs[0] Operand 7
     /* 710754 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710772 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_OFFEN),
     /* 710775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710777 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 710779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710786 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710788 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710794 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710804 */     GIR_RootConstrainSelectedInstOperands,
     /* 710805 */     // GIR_Coverage, 4781,
     /* 710805 */     GIR_EraseRootFromParent_Done,
     /* 710806 */   // Label 9190: @710806
     /* 710806 */   GIM_Try, /*On fail goto*//*Label 9191*/ GIMT_Encode4(710873), // Rule ID 4785 //
     /* 710811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710815 */     // MIs[0] offset
     /* 710815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710818 */     // MIs[0] auxiliary
     /* 710818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710821 */     // MIs[0] Operand 7
     /* 710821 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710839 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFEN),
     /* 710842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710844 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 710846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710853 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710855 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710861 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710871 */     GIR_RootConstrainSelectedInstOperands,
     /* 710872 */     // GIR_Coverage, 4785,
     /* 710872 */     GIR_EraseRootFromParent_Done,
     /* 710873 */   // Label 9191: @710873
     /* 710873 */   GIM_Try, /*On fail goto*//*Label 9192*/ GIMT_Encode4(710935), // Rule ID 4782 //
     /* 710878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 710881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710885 */     // MIs[0] offset
     /* 710885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710888 */     // MIs[0] auxiliary
     /* 710888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710891 */     // MIs[0] Operand 7
     /* 710891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710901 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_IDXEN),
     /* 710904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710906 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 710908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710915 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710917 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710923 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710933 */     GIR_RootConstrainSelectedInstOperands,
     /* 710934 */     // GIR_Coverage, 4782,
     /* 710934 */     GIR_EraseRootFromParent_Done,
     /* 710935 */   // Label 9192: @710935
     /* 710935 */   GIM_Try, /*On fail goto*//*Label 9193*/ GIMT_Encode4(710994), // Rule ID 4786 //
     /* 710940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710944 */     // MIs[0] offset
     /* 710944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710947 */     // MIs[0] auxiliary
     /* 710947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710950 */     // MIs[0] Operand 7
     /* 710950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710960 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_IDXEN),
     /* 710963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710965 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 710967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710974 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710982 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710992 */     GIR_RootConstrainSelectedInstOperands,
     /* 710993 */     // GIR_Coverage, 4786,
     /* 710993 */     GIR_EraseRootFromParent_Done,
     /* 710994 */   // Label 9193: @710994
     /* 710994 */   GIM_Try, /*On fail goto*//*Label 9194*/ GIMT_Encode4(711094), // Rule ID 4783 //
     /* 710999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711002 */     // MIs[0] offset
     /* 711002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711005 */     // MIs[0] auxiliary
     /* 711005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711008 */     // MIs[0] Operand 7
     /* 711008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711018 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 711021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 711025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 711030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 711034 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 711037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 711041 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 711044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 711049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_BOTHEN),
     /* 711062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 711067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711074 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711076 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711092 */     GIR_RootConstrainSelectedInstOperands,
     /* 711093 */     // GIR_Coverage, 4783,
     /* 711093 */     GIR_EraseRootFromParent_Done,
     /* 711094 */   // Label 9194: @711094
     /* 711094 */   GIM_Try, /*On fail goto*//*Label 9195*/ GIMT_Encode4(711191), // Rule ID 4787 //
     /* 711099 */     // MIs[0] offset
     /* 711099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711102 */     // MIs[0] auxiliary
     /* 711102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711105 */     // MIs[0] Operand 7
     /* 711105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711115 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 711118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 711122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 711127 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 711131 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 711134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 711138 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 711141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 711146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_BOTHEN),
     /* 711159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 711164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711171 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711173 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711179 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711189 */     GIR_RootConstrainSelectedInstOperands,
     /* 711190 */     // GIR_Coverage, 4787,
     /* 711190 */     GIR_EraseRootFromParent_Done,
     /* 711191 */   // Label 9195: @711191
     /* 711191 */   GIM_Reject,
     /* 711192 */ // Label 9187: @711192
     /* 711192 */ GIM_Reject,
     /* 711193 */ // Label 9167: @711193
     /* 711193 */ GIM_Try, /*On fail goto*//*Label 9196*/ GIMT_Encode4(711811),
     /* 711198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 711201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 711204 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 711207 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 711210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_160RegClassID),
     /* 711214 */   GIM_Try, /*On fail goto*//*Label 9197*/ GIMT_Encode4(711286), // Rule ID 4788 //
     /* 711219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711230 */     // MIs[0] offset
     /* 711230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711233 */     // MIs[0] auxiliary
     /* 711233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711236 */     // MIs[0] Operand 7
     /* 711236 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711254 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_OFFSET),
     /* 711257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711266 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711268 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711274 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711284 */     GIR_RootConstrainSelectedInstOperands,
     /* 711285 */     // GIR_Coverage, 4788,
     /* 711285 */     GIR_EraseRootFromParent_Done,
     /* 711286 */   // Label 9197: @711286
     /* 711286 */   GIM_Try, /*On fail goto*//*Label 9198*/ GIMT_Encode4(711355), // Rule ID 4792 //
     /* 711291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711299 */     // MIs[0] offset
     /* 711299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711302 */     // MIs[0] auxiliary
     /* 711302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711305 */     // MIs[0] Operand 7
     /* 711305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711323 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFSET),
     /* 711326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711335 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711337 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711343 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711353 */     GIR_RootConstrainSelectedInstOperands,
     /* 711354 */     // GIR_Coverage, 4792,
     /* 711354 */     GIR_EraseRootFromParent_Done,
     /* 711355 */   // Label 9198: @711355
     /* 711355 */   GIM_Try, /*On fail goto*//*Label 9199*/ GIMT_Encode4(711425), // Rule ID 4789 //
     /* 711360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711367 */     // MIs[0] offset
     /* 711367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711370 */     // MIs[0] auxiliary
     /* 711370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711373 */     // MIs[0] Operand 7
     /* 711373 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711391 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_OFFEN),
     /* 711394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711396 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711405 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711407 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711413 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711423 */     GIR_RootConstrainSelectedInstOperands,
     /* 711424 */     // GIR_Coverage, 4789,
     /* 711424 */     GIR_EraseRootFromParent_Done,
     /* 711425 */   // Label 9199: @711425
     /* 711425 */   GIM_Try, /*On fail goto*//*Label 9200*/ GIMT_Encode4(711492), // Rule ID 4793 //
     /* 711430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711434 */     // MIs[0] offset
     /* 711434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711437 */     // MIs[0] auxiliary
     /* 711437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711440 */     // MIs[0] Operand 7
     /* 711440 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711458 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFEN),
     /* 711461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711463 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711472 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711474 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711480 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711490 */     GIR_RootConstrainSelectedInstOperands,
     /* 711491 */     // GIR_Coverage, 4793,
     /* 711491 */     GIR_EraseRootFromParent_Done,
     /* 711492 */   // Label 9200: @711492
     /* 711492 */   GIM_Try, /*On fail goto*//*Label 9201*/ GIMT_Encode4(711554), // Rule ID 4790 //
     /* 711497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711504 */     // MIs[0] offset
     /* 711504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711507 */     // MIs[0] auxiliary
     /* 711507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711510 */     // MIs[0] Operand 7
     /* 711510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711520 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_IDXEN),
     /* 711523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711525 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 711527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711534 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711536 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711542 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711552 */     GIR_RootConstrainSelectedInstOperands,
     /* 711553 */     // GIR_Coverage, 4790,
     /* 711553 */     GIR_EraseRootFromParent_Done,
     /* 711554 */   // Label 9201: @711554
     /* 711554 */   GIM_Try, /*On fail goto*//*Label 9202*/ GIMT_Encode4(711613), // Rule ID 4794 //
     /* 711559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711563 */     // MIs[0] offset
     /* 711563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711566 */     // MIs[0] auxiliary
     /* 711566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711569 */     // MIs[0] Operand 7
     /* 711569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711579 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_IDXEN),
     /* 711582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711584 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 711586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711593 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711595 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711601 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711611 */     GIR_RootConstrainSelectedInstOperands,
     /* 711612 */     // GIR_Coverage, 4794,
     /* 711612 */     GIR_EraseRootFromParent_Done,
     /* 711613 */   // Label 9202: @711613
     /* 711613 */   GIM_Try, /*On fail goto*//*Label 9203*/ GIMT_Encode4(711713), // Rule ID 4791 //
     /* 711618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711621 */     // MIs[0] offset
     /* 711621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711624 */     // MIs[0] auxiliary
     /* 711624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711627 */     // MIs[0] Operand 7
     /* 711627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711637 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 711640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 711644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 711649 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 711653 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 711656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 711660 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 711663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 711668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_BOTHEN),
     /* 711681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 711686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711693 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711695 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711701 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711711 */     GIR_RootConstrainSelectedInstOperands,
     /* 711712 */     // GIR_Coverage, 4791,
     /* 711712 */     GIR_EraseRootFromParent_Done,
     /* 711713 */   // Label 9203: @711713
     /* 711713 */   GIM_Try, /*On fail goto*//*Label 9204*/ GIMT_Encode4(711810), // Rule ID 4795 //
     /* 711718 */     // MIs[0] offset
     /* 711718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711721 */     // MIs[0] auxiliary
     /* 711721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711724 */     // MIs[0] Operand 7
     /* 711724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711734 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 711737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 711741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 711746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 711750 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 711753 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 711757 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 711760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 711765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 711775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_BOTHEN),
     /* 711778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 711783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711790 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711792 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711798 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711808 */     GIR_RootConstrainSelectedInstOperands,
     /* 711809 */     // GIR_Coverage, 4795,
     /* 711809 */     GIR_EraseRootFromParent_Done,
     /* 711810 */   // Label 9204: @711810
     /* 711810 */   GIM_Reject,
     /* 711811 */ // Label 9196: @711811
     /* 711811 */ GIM_Reject,
     /* 711812 */ // Label 9168: @711812
     /* 711812 */ GIM_Reject,
     /* 711813 */ // Label 129: @711813
     /* 711813 */ GIM_Try, /*On fail goto*//*Label 9205*/ GIMT_Encode4(712418),
     /* 711818 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 711821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 711824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 711827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 711830 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 711833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 711837 */   GIM_Try, /*On fail goto*//*Label 9206*/ GIMT_Encode4(712109),
     /* 711842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711846 */     GIM_Try, /*On fail goto*//*Label 9207*/ GIMT_Encode4(711914), // Rule ID 5092 //
     /* 711851 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711854 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711858 */       // MIs[0] offset
     /* 711858 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711861 */       // MIs[0] auxiliary
     /* 711861 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711864 */       // MIs[0] Operand 7
     /* 711864 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711875 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711882 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711882 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 711885 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711887 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711889 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711894 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711896 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711902 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711908 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711912 */       GIR_RootConstrainSelectedInstOperands,
     /* 711913 */       // GIR_Coverage, 5092,
     /* 711913 */       GIR_EraseRootFromParent_Done,
     /* 711914 */     // Label 9207: @711914
     /* 711914 */     GIM_Try, /*On fail goto*//*Label 9208*/ GIMT_Encode4(711979), // Rule ID 5096 //
     /* 711919 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711923 */       // MIs[0] offset
     /* 711923 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711926 */       // MIs[0] auxiliary
     /* 711926 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711929 */       // MIs[0] Operand 7
     /* 711929 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711940 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711947 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711947 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 711950 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711952 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711954 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711959 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711961 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711967 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711973 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711977 */       GIR_RootConstrainSelectedInstOperands,
     /* 711978 */       // GIR_Coverage, 5096,
     /* 711978 */       GIR_EraseRootFromParent_Done,
     /* 711979 */     // Label 9208: @711979
     /* 711979 */     GIM_Try, /*On fail goto*//*Label 9209*/ GIMT_Encode4(712045), // Rule ID 5093 //
     /* 711984 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 711987 */       // MIs[0] offset
     /* 711987 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711990 */       // MIs[0] auxiliary
     /* 711990 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711993 */       // MIs[0] Operand 7
     /* 711993 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712004 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712011 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712011 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFEN),
     /* 712014 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712016 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 712018 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712020 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712025 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712027 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712033 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712039 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712043 */       GIR_RootConstrainSelectedInstOperands,
     /* 712044 */       // GIR_Coverage, 5093,
     /* 712044 */       GIR_EraseRootFromParent_Done,
     /* 712045 */     // Label 9209: @712045
     /* 712045 */     GIM_Try, /*On fail goto*//*Label 9210*/ GIMT_Encode4(712108), // Rule ID 5097 //
     /* 712050 */       // MIs[0] offset
     /* 712050 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712053 */       // MIs[0] auxiliary
     /* 712053 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712056 */       // MIs[0] Operand 7
     /* 712056 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712067 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712074 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712074 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFEN),
     /* 712077 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712079 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 712081 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712083 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712088 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712090 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712096 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712102 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712106 */       GIR_RootConstrainSelectedInstOperands,
     /* 712107 */       // GIR_Coverage, 5097,
     /* 712107 */       GIR_EraseRootFromParent_Done,
     /* 712108 */     // Label 9210: @712108
     /* 712108 */     GIM_Reject,
     /* 712109 */   // Label 9206: @712109
     /* 712109 */   GIM_Try, /*On fail goto*//*Label 9211*/ GIMT_Encode4(712223),
     /* 712114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712127 */     GIM_Try, /*On fail goto*//*Label 9212*/ GIMT_Encode4(712176), // Rule ID 5094 //
     /* 712132 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 712135 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712142 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712142 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_IDXEN),
     /* 712145 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712147 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 712149 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712151 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712156 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712158 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712164 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712170 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712174 */       GIR_RootConstrainSelectedInstOperands,
     /* 712175 */       // GIR_Coverage, 5094,
     /* 712175 */       GIR_EraseRootFromParent_Done,
     /* 712176 */     // Label 9212: @712176
     /* 712176 */     GIM_Try, /*On fail goto*//*Label 9213*/ GIMT_Encode4(712222), // Rule ID 5098 //
     /* 712181 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712188 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712188 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_IDXEN),
     /* 712191 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712193 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 712195 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712197 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712202 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712204 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712210 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712216 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712220 */       GIR_RootConstrainSelectedInstOperands,
     /* 712221 */       // GIR_Coverage, 5098,
     /* 712221 */       GIR_EraseRootFromParent_Done,
     /* 712222 */     // Label 9213: @712222
     /* 712222 */     GIM_Reject,
     /* 712223 */   // Label 9211: @712223
     /* 712223 */   GIM_Try, /*On fail goto*//*Label 9214*/ GIMT_Encode4(712417),
     /* 712228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712237 */     GIM_Try, /*On fail goto*//*Label 9215*/ GIMT_Encode4(712328), // Rule ID 5095 //
     /* 712242 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 712245 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712252 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712252 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 712255 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 712259 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 712264 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 712268 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 712271 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 712275 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 712278 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 712283 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712288 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712293 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_BOTHEN),
     /* 712296 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 712301 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712303 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712308 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712310 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712316 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712322 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712326 */       GIR_RootConstrainSelectedInstOperands,
     /* 712327 */       // GIR_Coverage, 5095,
     /* 712327 */       GIR_EraseRootFromParent_Done,
     /* 712328 */     // Label 9215: @712328
     /* 712328 */     GIM_Try, /*On fail goto*//*Label 9216*/ GIMT_Encode4(712416), // Rule ID 5099 //
     /* 712333 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712340 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712340 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 712343 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 712347 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 712352 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 712356 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 712359 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 712363 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 712366 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 712371 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712376 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712381 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_BOTHEN),
     /* 712384 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712386 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 712389 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712391 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712396 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712398 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712404 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712410 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712414 */       GIR_RootConstrainSelectedInstOperands,
     /* 712415 */       // GIR_Coverage, 5099,
     /* 712415 */       GIR_EraseRootFromParent_Done,
     /* 712416 */     // Label 9216: @712416
     /* 712416 */     GIM_Reject,
     /* 712417 */   // Label 9214: @712417
     /* 712417 */   GIM_Reject,
     /* 712418 */ // Label 9205: @712418
     /* 712418 */ GIM_Reject,
     /* 712419 */ // Label 130: @712419
     /* 712419 */ GIM_Try, /*On fail goto*//*Label 9217*/ GIMT_Encode4(713024),
     /* 712424 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 712427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 712430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 712433 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 712436 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 712439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712443 */   GIM_Try, /*On fail goto*//*Label 9218*/ GIMT_Encode4(712715),
     /* 712448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 712452 */     GIM_Try, /*On fail goto*//*Label 9219*/ GIMT_Encode4(712520), // Rule ID 5156 //
     /* 712457 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 712460 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712464 */       // MIs[0] offset
     /* 712464 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712467 */       // MIs[0] auxiliary
     /* 712467 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712470 */       // MIs[0] Operand 7
     /* 712470 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712481 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712488 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712488 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_OFFSET),
     /* 712491 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712493 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712495 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712500 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712502 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712508 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712514 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712518 */       GIR_RootConstrainSelectedInstOperands,
     /* 712519 */       // GIR_Coverage, 5156,
     /* 712519 */       GIR_EraseRootFromParent_Done,
     /* 712520 */     // Label 9219: @712520
     /* 712520 */     GIM_Try, /*On fail goto*//*Label 9220*/ GIMT_Encode4(712585), // Rule ID 5160 //
     /* 712525 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712529 */       // MIs[0] offset
     /* 712529 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712532 */       // MIs[0] auxiliary
     /* 712532 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712535 */       // MIs[0] Operand 7
     /* 712535 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712546 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712553 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712553 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFSET),
     /* 712556 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712558 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712560 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712565 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712567 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712573 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712579 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712583 */       GIR_RootConstrainSelectedInstOperands,
     /* 712584 */       // GIR_Coverage, 5160,
     /* 712584 */       GIR_EraseRootFromParent_Done,
     /* 712585 */     // Label 9220: @712585
     /* 712585 */     GIM_Try, /*On fail goto*//*Label 9221*/ GIMT_Encode4(712651), // Rule ID 5157 //
     /* 712590 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 712593 */       // MIs[0] offset
     /* 712593 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712596 */       // MIs[0] auxiliary
     /* 712596 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712599 */       // MIs[0] Operand 7
     /* 712599 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712610 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712617 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712617 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_OFFEN),
     /* 712620 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712622 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 712624 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712626 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712631 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712633 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712639 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712645 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712649 */       GIR_RootConstrainSelectedInstOperands,
     /* 712650 */       // GIR_Coverage, 5157,
     /* 712650 */       GIR_EraseRootFromParent_Done,
     /* 712651 */     // Label 9221: @712651
     /* 712651 */     GIM_Try, /*On fail goto*//*Label 9222*/ GIMT_Encode4(712714), // Rule ID 5161 //
     /* 712656 */       // MIs[0] offset
     /* 712656 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712659 */       // MIs[0] auxiliary
     /* 712659 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712662 */       // MIs[0] Operand 7
     /* 712662 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 712673 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712680 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712680 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFEN),
     /* 712683 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712685 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 712687 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712689 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712694 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712696 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712702 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712708 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712712 */       GIR_RootConstrainSelectedInstOperands,
     /* 712713 */       // GIR_Coverage, 5161,
     /* 712713 */       GIR_EraseRootFromParent_Done,
     /* 712714 */     // Label 9222: @712714
     /* 712714 */     GIM_Reject,
     /* 712715 */   // Label 9218: @712715
     /* 712715 */   GIM_Try, /*On fail goto*//*Label 9223*/ GIMT_Encode4(712829),
     /* 712720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712733 */     GIM_Try, /*On fail goto*//*Label 9224*/ GIMT_Encode4(712782), // Rule ID 5158 //
     /* 712738 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 712741 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712748 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712748 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_IDXEN),
     /* 712751 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712753 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 712755 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712757 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712762 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712764 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712770 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712776 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712780 */       GIR_RootConstrainSelectedInstOperands,
     /* 712781 */       // GIR_Coverage, 5158,
     /* 712781 */       GIR_EraseRootFromParent_Done,
     /* 712782 */     // Label 9224: @712782
     /* 712782 */     GIM_Try, /*On fail goto*//*Label 9225*/ GIMT_Encode4(712828), // Rule ID 5162 //
     /* 712787 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712794 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712794 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_IDXEN),
     /* 712797 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712799 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 712801 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712803 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712808 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712810 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712816 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712822 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712826 */       GIR_RootConstrainSelectedInstOperands,
     /* 712827 */       // GIR_Coverage, 5162,
     /* 712827 */       GIR_EraseRootFromParent_Done,
     /* 712828 */     // Label 9225: @712828
     /* 712828 */     GIM_Reject,
     /* 712829 */   // Label 9223: @712829
     /* 712829 */   GIM_Try, /*On fail goto*//*Label 9226*/ GIMT_Encode4(713023),
     /* 712834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712843 */     GIM_Try, /*On fail goto*//*Label 9227*/ GIMT_Encode4(712934), // Rule ID 5159 //
     /* 712848 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 712851 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712858 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712858 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 712861 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 712865 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 712870 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 712874 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 712877 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 712881 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 712884 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 712889 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712894 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712899 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_BOTHEN),
     /* 712902 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712904 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 712907 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712909 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712914 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712916 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712922 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712928 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712932 */       GIR_RootConstrainSelectedInstOperands,
     /* 712933 */       // GIR_Coverage, 5159,
     /* 712933 */       GIR_EraseRootFromParent_Done,
     /* 712934 */     // Label 9227: @712934
     /* 712934 */     GIM_Try, /*On fail goto*//*Label 9228*/ GIMT_Encode4(713022), // Rule ID 5163 //
     /* 712939 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712946 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712946 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 712949 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 712953 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 712958 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 712962 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 712965 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 712969 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 712972 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 712977 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712982 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712987 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_BOTHEN),
     /* 712990 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712992 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 712995 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712997 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713002 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713004 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713010 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713016 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713020 */       GIR_RootConstrainSelectedInstOperands,
     /* 713021 */       // GIR_Coverage, 5163,
     /* 713021 */       GIR_EraseRootFromParent_Done,
     /* 713022 */     // Label 9228: @713022
     /* 713022 */     GIM_Reject,
     /* 713023 */   // Label 9226: @713023
     /* 713023 */   GIM_Reject,
     /* 713024 */ // Label 9217: @713024
     /* 713024 */ GIM_Reject,
     /* 713025 */ // Label 131: @713025
     /* 713025 */ GIM_Try, /*On fail goto*//*Label 9229*/ GIMT_Encode4(713630),
     /* 713030 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 713033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 713036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 713039 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 713042 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 713045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 713049 */   GIM_Try, /*On fail goto*//*Label 9230*/ GIMT_Encode4(713321),
     /* 713054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 713058 */     GIM_Try, /*On fail goto*//*Label 9231*/ GIMT_Encode4(713126), // Rule ID 5100 //
     /* 713063 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713066 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713070 */       // MIs[0] offset
     /* 713070 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713073 */       // MIs[0] auxiliary
     /* 713073 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713076 */       // MIs[0] Operand 7
     /* 713076 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713087 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713094 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713094 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
     /* 713097 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713099 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713101 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713106 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713108 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713114 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713120 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713124 */       GIR_RootConstrainSelectedInstOperands,
     /* 713125 */       // GIR_Coverage, 5100,
     /* 713125 */       GIR_EraseRootFromParent_Done,
     /* 713126 */     // Label 9231: @713126
     /* 713126 */     GIM_Try, /*On fail goto*//*Label 9232*/ GIMT_Encode4(713191), // Rule ID 5104 //
     /* 713131 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713135 */       // MIs[0] offset
     /* 713135 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713138 */       // MIs[0] auxiliary
     /* 713138 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713141 */       // MIs[0] Operand 7
     /* 713141 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713152 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713159 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713159 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
     /* 713162 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713164 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713166 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713171 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713173 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713179 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713185 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713189 */       GIR_RootConstrainSelectedInstOperands,
     /* 713190 */       // GIR_Coverage, 5104,
     /* 713190 */       GIR_EraseRootFromParent_Done,
     /* 713191 */     // Label 9232: @713191
     /* 713191 */     GIM_Try, /*On fail goto*//*Label 9233*/ GIMT_Encode4(713257), // Rule ID 5101 //
     /* 713196 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713199 */       // MIs[0] offset
     /* 713199 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713202 */       // MIs[0] auxiliary
     /* 713202 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713205 */       // MIs[0] Operand 7
     /* 713205 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713216 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713223 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713223 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFEN),
     /* 713226 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713228 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 713230 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713232 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713237 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713239 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713245 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713251 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713255 */       GIR_RootConstrainSelectedInstOperands,
     /* 713256 */       // GIR_Coverage, 5101,
     /* 713256 */       GIR_EraseRootFromParent_Done,
     /* 713257 */     // Label 9233: @713257
     /* 713257 */     GIM_Try, /*On fail goto*//*Label 9234*/ GIMT_Encode4(713320), // Rule ID 5105 //
     /* 713262 */       // MIs[0] offset
     /* 713262 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713265 */       // MIs[0] auxiliary
     /* 713265 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713268 */       // MIs[0] Operand 7
     /* 713268 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713279 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713286 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713286 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFEN),
     /* 713289 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713291 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 713293 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713295 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713300 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713302 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713308 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713314 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713318 */       GIR_RootConstrainSelectedInstOperands,
     /* 713319 */       // GIR_Coverage, 5105,
     /* 713319 */       GIR_EraseRootFromParent_Done,
     /* 713320 */     // Label 9234: @713320
     /* 713320 */     GIM_Reject,
     /* 713321 */   // Label 9230: @713321
     /* 713321 */   GIM_Try, /*On fail goto*//*Label 9235*/ GIMT_Encode4(713435),
     /* 713326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 713339 */     GIM_Try, /*On fail goto*//*Label 9236*/ GIMT_Encode4(713388), // Rule ID 5102 //
     /* 713344 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713347 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713354 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713354 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_IDXEN),
     /* 713357 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713359 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 713361 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713363 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713368 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713370 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713376 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713382 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713386 */       GIR_RootConstrainSelectedInstOperands,
     /* 713387 */       // GIR_Coverage, 5102,
     /* 713387 */       GIR_EraseRootFromParent_Done,
     /* 713388 */     // Label 9236: @713388
     /* 713388 */     GIM_Try, /*On fail goto*//*Label 9237*/ GIMT_Encode4(713434), // Rule ID 5106 //
     /* 713393 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713400 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713400 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_IDXEN),
     /* 713403 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713405 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 713407 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713409 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713414 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713416 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713422 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713428 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713432 */       GIR_RootConstrainSelectedInstOperands,
     /* 713433 */       // GIR_Coverage, 5106,
     /* 713433 */       GIR_EraseRootFromParent_Done,
     /* 713434 */     // Label 9237: @713434
     /* 713434 */     GIM_Reject,
     /* 713435 */   // Label 9235: @713435
     /* 713435 */   GIM_Try, /*On fail goto*//*Label 9238*/ GIMT_Encode4(713629),
     /* 713440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 713449 */     GIM_Try, /*On fail goto*//*Label 9239*/ GIMT_Encode4(713540), // Rule ID 5103 //
     /* 713454 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713457 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713464 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713464 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 713467 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 713471 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 713476 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 713480 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 713483 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 713487 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 713490 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 713495 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713500 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713505 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_BOTHEN),
     /* 713508 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713510 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 713513 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713515 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713520 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713522 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713528 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713534 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713538 */       GIR_RootConstrainSelectedInstOperands,
     /* 713539 */       // GIR_Coverage, 5103,
     /* 713539 */       GIR_EraseRootFromParent_Done,
     /* 713540 */     // Label 9239: @713540
     /* 713540 */     GIM_Try, /*On fail goto*//*Label 9240*/ GIMT_Encode4(713628), // Rule ID 5107 //
     /* 713545 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713552 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713552 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 713555 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 713559 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 713564 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 713568 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 713571 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 713575 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 713578 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 713583 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713588 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713593 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_BOTHEN),
     /* 713596 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713598 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 713601 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713603 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713608 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713610 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713616 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713622 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713626 */       GIR_RootConstrainSelectedInstOperands,
     /* 713627 */       // GIR_Coverage, 5107,
     /* 713627 */       GIR_EraseRootFromParent_Done,
     /* 713628 */     // Label 9240: @713628
     /* 713628 */     GIM_Reject,
     /* 713629 */   // Label 9238: @713629
     /* 713629 */   GIM_Reject,
     /* 713630 */ // Label 9229: @713630
     /* 713630 */ GIM_Reject,
     /* 713631 */ // Label 132: @713631
     /* 713631 */ GIM_Try, /*On fail goto*//*Label 9241*/ GIMT_Encode4(714236),
     /* 713636 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 713639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 713642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 713645 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 713648 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 713651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 713655 */   GIM_Try, /*On fail goto*//*Label 9242*/ GIMT_Encode4(713927),
     /* 713660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 713664 */     GIM_Try, /*On fail goto*//*Label 9243*/ GIMT_Encode4(713732), // Rule ID 5164 //
     /* 713669 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713672 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713676 */       // MIs[0] offset
     /* 713676 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713679 */       // MIs[0] auxiliary
     /* 713679 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713682 */       // MIs[0] Operand 7
     /* 713682 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713693 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713700 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713700 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_OFFSET),
     /* 713703 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713705 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713707 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713712 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713714 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713720 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713726 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713730 */       GIR_RootConstrainSelectedInstOperands,
     /* 713731 */       // GIR_Coverage, 5164,
     /* 713731 */       GIR_EraseRootFromParent_Done,
     /* 713732 */     // Label 9243: @713732
     /* 713732 */     GIM_Try, /*On fail goto*//*Label 9244*/ GIMT_Encode4(713797), // Rule ID 5168 //
     /* 713737 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713741 */       // MIs[0] offset
     /* 713741 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713744 */       // MIs[0] auxiliary
     /* 713744 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713747 */       // MIs[0] Operand 7
     /* 713747 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713758 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713765 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713765 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFSET),
     /* 713768 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713770 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713772 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713777 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713779 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713785 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713791 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713795 */       GIR_RootConstrainSelectedInstOperands,
     /* 713796 */       // GIR_Coverage, 5168,
     /* 713796 */       GIR_EraseRootFromParent_Done,
     /* 713797 */     // Label 9244: @713797
     /* 713797 */     GIM_Try, /*On fail goto*//*Label 9245*/ GIMT_Encode4(713863), // Rule ID 5165 //
     /* 713802 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713805 */       // MIs[0] offset
     /* 713805 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713808 */       // MIs[0] auxiliary
     /* 713808 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713811 */       // MIs[0] Operand 7
     /* 713811 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713822 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713829 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713829 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_OFFEN),
     /* 713832 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713834 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 713836 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713838 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713843 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713845 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713851 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713857 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713861 */       GIR_RootConstrainSelectedInstOperands,
     /* 713862 */       // GIR_Coverage, 5165,
     /* 713862 */       GIR_EraseRootFromParent_Done,
     /* 713863 */     // Label 9245: @713863
     /* 713863 */     GIM_Try, /*On fail goto*//*Label 9246*/ GIMT_Encode4(713926), // Rule ID 5169 //
     /* 713868 */       // MIs[0] offset
     /* 713868 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713871 */       // MIs[0] auxiliary
     /* 713871 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713874 */       // MIs[0] Operand 7
     /* 713874 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713885 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713892 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713892 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFEN),
     /* 713895 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713897 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 713899 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713901 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713906 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713908 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713914 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713920 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713924 */       GIR_RootConstrainSelectedInstOperands,
     /* 713925 */       // GIR_Coverage, 5169,
     /* 713925 */       GIR_EraseRootFromParent_Done,
     /* 713926 */     // Label 9246: @713926
     /* 713926 */     GIM_Reject,
     /* 713927 */   // Label 9242: @713927
     /* 713927 */   GIM_Try, /*On fail goto*//*Label 9247*/ GIMT_Encode4(714041),
     /* 713932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 713945 */     GIM_Try, /*On fail goto*//*Label 9248*/ GIMT_Encode4(713994), // Rule ID 5166 //
     /* 713950 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713953 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713960 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713960 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_IDXEN),
     /* 713963 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713965 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 713967 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713969 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713974 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713976 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713982 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713988 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713992 */       GIR_RootConstrainSelectedInstOperands,
     /* 713993 */       // GIR_Coverage, 5166,
     /* 713993 */       GIR_EraseRootFromParent_Done,
     /* 713994 */     // Label 9248: @713994
     /* 713994 */     GIM_Try, /*On fail goto*//*Label 9249*/ GIMT_Encode4(714040), // Rule ID 5170 //
     /* 713999 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714006 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714006 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_IDXEN),
     /* 714009 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714011 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 714013 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714015 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714020 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714022 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714028 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714034 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714038 */       GIR_RootConstrainSelectedInstOperands,
     /* 714039 */       // GIR_Coverage, 5170,
     /* 714039 */       GIR_EraseRootFromParent_Done,
     /* 714040 */     // Label 9249: @714040
     /* 714040 */     GIM_Reject,
     /* 714041 */   // Label 9247: @714041
     /* 714041 */   GIM_Try, /*On fail goto*//*Label 9250*/ GIMT_Encode4(714235),
     /* 714046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714055 */     GIM_Try, /*On fail goto*//*Label 9251*/ GIMT_Encode4(714146), // Rule ID 5167 //
     /* 714060 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714063 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714070 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714070 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 714073 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 714077 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 714082 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 714086 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 714089 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 714093 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 714096 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 714101 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714106 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714111 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_BOTHEN),
     /* 714114 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714116 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 714119 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714121 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714126 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714128 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714134 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714140 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714144 */       GIR_RootConstrainSelectedInstOperands,
     /* 714145 */       // GIR_Coverage, 5167,
     /* 714145 */       GIR_EraseRootFromParent_Done,
     /* 714146 */     // Label 9251: @714146
     /* 714146 */     GIM_Try, /*On fail goto*//*Label 9252*/ GIMT_Encode4(714234), // Rule ID 5171 //
     /* 714151 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714158 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714158 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 714161 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 714165 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 714170 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 714174 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 714177 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 714181 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 714184 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 714189 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714194 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714199 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_BOTHEN),
     /* 714202 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714204 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 714207 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714209 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714214 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714216 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714222 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714228 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714232 */       GIR_RootConstrainSelectedInstOperands,
     /* 714233 */       // GIR_Coverage, 5171,
     /* 714233 */       GIR_EraseRootFromParent_Done,
     /* 714234 */     // Label 9252: @714234
     /* 714234 */     GIM_Reject,
     /* 714235 */   // Label 9250: @714235
     /* 714235 */   GIM_Reject,
     /* 714236 */ // Label 9241: @714236
     /* 714236 */ GIM_Reject,
     /* 714237 */ // Label 133: @714237
     /* 714237 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(20), /*)*//*default:*//*Label 9257*/ GIMT_Encode4(716756),
     /* 714248 */ /*GILLT_v2s32*//*Label 9253*/ GIMT_Encode4(714280), GIMT_Encode4(0),
     /* 714256 */ /*GILLT_v3s32*//*Label 9254*/ GIMT_Encode4(714899), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 714268 */ /*GILLT_v4s32*//*Label 9255*/ GIMT_Encode4(715518), GIMT_Encode4(0),
     /* 714276 */ /*GILLT_v5s32*//*Label 9256*/ GIMT_Encode4(716137),
     /* 714280 */ // Label 9253: @714280
     /* 714280 */ GIM_Try, /*On fail goto*//*Label 9258*/ GIMT_Encode4(714898),
     /* 714285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 714288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 714291 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 714294 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 714297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 714301 */   GIM_Try, /*On fail goto*//*Label 9259*/ GIMT_Encode4(714373), // Rule ID 5124 //
     /* 714306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 714313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714317 */     // MIs[0] offset
     /* 714317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714320 */     // MIs[0] auxiliary
     /* 714320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714323 */     // MIs[0] Operand 7
     /* 714323 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714341 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_OFFSET),
     /* 714344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714353 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714355 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714361 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714371 */     GIR_RootConstrainSelectedInstOperands,
     /* 714372 */     // GIR_Coverage, 5124,
     /* 714372 */     GIR_EraseRootFromParent_Done,
     /* 714373 */   // Label 9259: @714373
     /* 714373 */   GIM_Try, /*On fail goto*//*Label 9260*/ GIMT_Encode4(714442), // Rule ID 5128 //
     /* 714378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 714382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714386 */     // MIs[0] offset
     /* 714386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714389 */     // MIs[0] auxiliary
     /* 714389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714392 */     // MIs[0] Operand 7
     /* 714392 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714410 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFSET),
     /* 714413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714422 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714440 */     GIR_RootConstrainSelectedInstOperands,
     /* 714441 */     // GIR_Coverage, 5128,
     /* 714441 */     GIR_EraseRootFromParent_Done,
     /* 714442 */   // Label 9260: @714442
     /* 714442 */   GIM_Try, /*On fail goto*//*Label 9261*/ GIMT_Encode4(714512), // Rule ID 5125 //
     /* 714447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 714454 */     // MIs[0] offset
     /* 714454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714457 */     // MIs[0] auxiliary
     /* 714457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714460 */     // MIs[0] Operand 7
     /* 714460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714478 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_OFFEN),
     /* 714481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714483 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 714485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714492 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714494 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714500 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714510 */     GIR_RootConstrainSelectedInstOperands,
     /* 714511 */     // GIR_Coverage, 5125,
     /* 714511 */     GIR_EraseRootFromParent_Done,
     /* 714512 */   // Label 9261: @714512
     /* 714512 */   GIM_Try, /*On fail goto*//*Label 9262*/ GIMT_Encode4(714579), // Rule ID 5129 //
     /* 714517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 714521 */     // MIs[0] offset
     /* 714521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714524 */     // MIs[0] auxiliary
     /* 714524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714527 */     // MIs[0] Operand 7
     /* 714527 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714545 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFEN),
     /* 714548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714550 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 714552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714559 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714561 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714567 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714577 */     GIR_RootConstrainSelectedInstOperands,
     /* 714578 */     // GIR_Coverage, 5129,
     /* 714578 */     GIR_EraseRootFromParent_Done,
     /* 714579 */   // Label 9262: @714579
     /* 714579 */   GIM_Try, /*On fail goto*//*Label 9263*/ GIMT_Encode4(714641), // Rule ID 5126 //
     /* 714584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714591 */     // MIs[0] offset
     /* 714591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714594 */     // MIs[0] auxiliary
     /* 714594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714597 */     // MIs[0] Operand 7
     /* 714597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714607 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_IDXEN),
     /* 714610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714612 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 714614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714621 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714623 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714629 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714639 */     GIR_RootConstrainSelectedInstOperands,
     /* 714640 */     // GIR_Coverage, 5126,
     /* 714640 */     GIR_EraseRootFromParent_Done,
     /* 714641 */   // Label 9263: @714641
     /* 714641 */   GIM_Try, /*On fail goto*//*Label 9264*/ GIMT_Encode4(714700), // Rule ID 5130 //
     /* 714646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714650 */     // MIs[0] offset
     /* 714650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714653 */     // MIs[0] auxiliary
     /* 714653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714656 */     // MIs[0] Operand 7
     /* 714656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714666 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_IDXEN),
     /* 714669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714671 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 714673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714680 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714682 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714688 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714698 */     GIR_RootConstrainSelectedInstOperands,
     /* 714699 */     // GIR_Coverage, 5130,
     /* 714699 */     GIR_EraseRootFromParent_Done,
     /* 714700 */   // Label 9264: @714700
     /* 714700 */   GIM_Try, /*On fail goto*//*Label 9265*/ GIMT_Encode4(714800), // Rule ID 5127 //
     /* 714705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714708 */     // MIs[0] offset
     /* 714708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714711 */     // MIs[0] auxiliary
     /* 714711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714714 */     // MIs[0] Operand 7
     /* 714714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714724 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 714727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 714731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 714736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 714740 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 714743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 714747 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 714750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 714755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_BOTHEN),
     /* 714768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 714773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714780 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714782 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714788 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714798 */     GIR_RootConstrainSelectedInstOperands,
     /* 714799 */     // GIR_Coverage, 5127,
     /* 714799 */     GIR_EraseRootFromParent_Done,
     /* 714800 */   // Label 9265: @714800
     /* 714800 */   GIM_Try, /*On fail goto*//*Label 9266*/ GIMT_Encode4(714897), // Rule ID 5131 //
     /* 714805 */     // MIs[0] offset
     /* 714805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714808 */     // MIs[0] auxiliary
     /* 714808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714811 */     // MIs[0] Operand 7
     /* 714811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714821 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 714824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 714828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 714833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 714837 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 714840 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 714844 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 714847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 714852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_BOTHEN),
     /* 714865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 714870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714877 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714879 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714885 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714895 */     GIR_RootConstrainSelectedInstOperands,
     /* 714896 */     // GIR_Coverage, 5131,
     /* 714896 */     GIR_EraseRootFromParent_Done,
     /* 714897 */   // Label 9266: @714897
     /* 714897 */   GIM_Reject,
     /* 714898 */ // Label 9258: @714898
     /* 714898 */ GIM_Reject,
     /* 714899 */ // Label 9254: @714899
     /* 714899 */ GIM_Try, /*On fail goto*//*Label 9267*/ GIMT_Encode4(715517),
     /* 714904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 714907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 714910 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 714913 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 714916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 714920 */   GIM_Try, /*On fail goto*//*Label 9268*/ GIMT_Encode4(714992), // Rule ID 5132 //
     /* 714925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 714932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714936 */     // MIs[0] offset
     /* 714936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714939 */     // MIs[0] auxiliary
     /* 714939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714942 */     // MIs[0] Operand 7
     /* 714942 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714960 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_OFFSET),
     /* 714963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714972 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714974 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714980 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714990 */     GIR_RootConstrainSelectedInstOperands,
     /* 714991 */     // GIR_Coverage, 5132,
     /* 714991 */     GIR_EraseRootFromParent_Done,
     /* 714992 */   // Label 9268: @714992
     /* 714992 */   GIM_Try, /*On fail goto*//*Label 9269*/ GIMT_Encode4(715061), // Rule ID 5136 //
     /* 714997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715005 */     // MIs[0] offset
     /* 715005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715008 */     // MIs[0] auxiliary
     /* 715008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715011 */     // MIs[0] Operand 7
     /* 715011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715029 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFSET),
     /* 715032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715041 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715043 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715049 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715059 */     GIR_RootConstrainSelectedInstOperands,
     /* 715060 */     // GIR_Coverage, 5136,
     /* 715060 */     GIR_EraseRootFromParent_Done,
     /* 715061 */   // Label 9269: @715061
     /* 715061 */   GIM_Try, /*On fail goto*//*Label 9270*/ GIMT_Encode4(715131), // Rule ID 5133 //
     /* 715066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715073 */     // MIs[0] offset
     /* 715073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715076 */     // MIs[0] auxiliary
     /* 715076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715079 */     // MIs[0] Operand 7
     /* 715079 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715097 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_OFFEN),
     /* 715100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715102 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 715104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715111 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715113 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715119 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715129 */     GIR_RootConstrainSelectedInstOperands,
     /* 715130 */     // GIR_Coverage, 5133,
     /* 715130 */     GIR_EraseRootFromParent_Done,
     /* 715131 */   // Label 9270: @715131
     /* 715131 */   GIM_Try, /*On fail goto*//*Label 9271*/ GIMT_Encode4(715198), // Rule ID 5137 //
     /* 715136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715140 */     // MIs[0] offset
     /* 715140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715143 */     // MIs[0] auxiliary
     /* 715143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715146 */     // MIs[0] Operand 7
     /* 715146 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715164 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFEN),
     /* 715167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715169 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 715171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715178 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715180 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715186 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715196 */     GIR_RootConstrainSelectedInstOperands,
     /* 715197 */     // GIR_Coverage, 5137,
     /* 715197 */     GIR_EraseRootFromParent_Done,
     /* 715198 */   // Label 9271: @715198
     /* 715198 */   GIM_Try, /*On fail goto*//*Label 9272*/ GIMT_Encode4(715260), // Rule ID 5134 //
     /* 715203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715210 */     // MIs[0] offset
     /* 715210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715213 */     // MIs[0] auxiliary
     /* 715213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715216 */     // MIs[0] Operand 7
     /* 715216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715226 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_IDXEN),
     /* 715229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715231 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 715233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715240 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715242 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715248 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715258 */     GIR_RootConstrainSelectedInstOperands,
     /* 715259 */     // GIR_Coverage, 5134,
     /* 715259 */     GIR_EraseRootFromParent_Done,
     /* 715260 */   // Label 9272: @715260
     /* 715260 */   GIM_Try, /*On fail goto*//*Label 9273*/ GIMT_Encode4(715319), // Rule ID 5138 //
     /* 715265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715269 */     // MIs[0] offset
     /* 715269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715272 */     // MIs[0] auxiliary
     /* 715272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715275 */     // MIs[0] Operand 7
     /* 715275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715285 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_IDXEN),
     /* 715288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715290 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 715292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715299 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715301 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715307 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715317 */     GIR_RootConstrainSelectedInstOperands,
     /* 715318 */     // GIR_Coverage, 5138,
     /* 715318 */     GIR_EraseRootFromParent_Done,
     /* 715319 */   // Label 9273: @715319
     /* 715319 */   GIM_Try, /*On fail goto*//*Label 9274*/ GIMT_Encode4(715419), // Rule ID 5135 //
     /* 715324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715327 */     // MIs[0] offset
     /* 715327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715330 */     // MIs[0] auxiliary
     /* 715330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715333 */     // MIs[0] Operand 7
     /* 715333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715343 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 715346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 715350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 715355 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 715359 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 715362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 715366 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 715369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 715374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_BOTHEN),
     /* 715387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 715392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715399 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715401 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715407 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715417 */     GIR_RootConstrainSelectedInstOperands,
     /* 715418 */     // GIR_Coverage, 5135,
     /* 715418 */     GIR_EraseRootFromParent_Done,
     /* 715419 */   // Label 9274: @715419
     /* 715419 */   GIM_Try, /*On fail goto*//*Label 9275*/ GIMT_Encode4(715516), // Rule ID 5139 //
     /* 715424 */     // MIs[0] offset
     /* 715424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715427 */     // MIs[0] auxiliary
     /* 715427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715430 */     // MIs[0] Operand 7
     /* 715430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715440 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 715443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 715447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 715452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 715456 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 715459 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 715463 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 715466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 715471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_BOTHEN),
     /* 715484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 715489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715496 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715498 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715504 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715514 */     GIR_RootConstrainSelectedInstOperands,
     /* 715515 */     // GIR_Coverage, 5139,
     /* 715515 */     GIR_EraseRootFromParent_Done,
     /* 715516 */   // Label 9275: @715516
     /* 715516 */   GIM_Reject,
     /* 715517 */ // Label 9267: @715517
     /* 715517 */ GIM_Reject,
     /* 715518 */ // Label 9255: @715518
     /* 715518 */ GIM_Try, /*On fail goto*//*Label 9276*/ GIMT_Encode4(716136),
     /* 715523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 715526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 715529 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 715532 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 715535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 715539 */   GIM_Try, /*On fail goto*//*Label 9277*/ GIMT_Encode4(715611), // Rule ID 5140 //
     /* 715544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715555 */     // MIs[0] offset
     /* 715555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715558 */     // MIs[0] auxiliary
     /* 715558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715561 */     // MIs[0] Operand 7
     /* 715561 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715579 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_OFFSET),
     /* 715582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715591 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715593 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715609 */     GIR_RootConstrainSelectedInstOperands,
     /* 715610 */     // GIR_Coverage, 5140,
     /* 715610 */     GIR_EraseRootFromParent_Done,
     /* 715611 */   // Label 9277: @715611
     /* 715611 */   GIM_Try, /*On fail goto*//*Label 9278*/ GIMT_Encode4(715680), // Rule ID 5144 //
     /* 715616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715624 */     // MIs[0] offset
     /* 715624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715627 */     // MIs[0] auxiliary
     /* 715627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715630 */     // MIs[0] Operand 7
     /* 715630 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715648 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFSET),
     /* 715651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715660 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715662 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715678 */     GIR_RootConstrainSelectedInstOperands,
     /* 715679 */     // GIR_Coverage, 5144,
     /* 715679 */     GIR_EraseRootFromParent_Done,
     /* 715680 */   // Label 9278: @715680
     /* 715680 */   GIM_Try, /*On fail goto*//*Label 9279*/ GIMT_Encode4(715750), // Rule ID 5141 //
     /* 715685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715692 */     // MIs[0] offset
     /* 715692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715695 */     // MIs[0] auxiliary
     /* 715695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715698 */     // MIs[0] Operand 7
     /* 715698 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715716 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_OFFEN),
     /* 715719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715721 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 715723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715730 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715732 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715738 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715748 */     GIR_RootConstrainSelectedInstOperands,
     /* 715749 */     // GIR_Coverage, 5141,
     /* 715749 */     GIR_EraseRootFromParent_Done,
     /* 715750 */   // Label 9279: @715750
     /* 715750 */   GIM_Try, /*On fail goto*//*Label 9280*/ GIMT_Encode4(715817), // Rule ID 5145 //
     /* 715755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715759 */     // MIs[0] offset
     /* 715759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715762 */     // MIs[0] auxiliary
     /* 715762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715765 */     // MIs[0] Operand 7
     /* 715765 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715783 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFEN),
     /* 715786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715788 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 715790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715797 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715799 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715805 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715815 */     GIR_RootConstrainSelectedInstOperands,
     /* 715816 */     // GIR_Coverage, 5145,
     /* 715816 */     GIR_EraseRootFromParent_Done,
     /* 715817 */   // Label 9280: @715817
     /* 715817 */   GIM_Try, /*On fail goto*//*Label 9281*/ GIMT_Encode4(715879), // Rule ID 5142 //
     /* 715822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715829 */     // MIs[0] offset
     /* 715829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715832 */     // MIs[0] auxiliary
     /* 715832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715835 */     // MIs[0] Operand 7
     /* 715835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715845 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_IDXEN),
     /* 715848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715850 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 715852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715859 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715861 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715867 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715877 */     GIR_RootConstrainSelectedInstOperands,
     /* 715878 */     // GIR_Coverage, 5142,
     /* 715878 */     GIR_EraseRootFromParent_Done,
     /* 715879 */   // Label 9281: @715879
     /* 715879 */   GIM_Try, /*On fail goto*//*Label 9282*/ GIMT_Encode4(715938), // Rule ID 5146 //
     /* 715884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715888 */     // MIs[0] offset
     /* 715888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715891 */     // MIs[0] auxiliary
     /* 715891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715894 */     // MIs[0] Operand 7
     /* 715894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715904 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_IDXEN),
     /* 715907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715909 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 715911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715918 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715920 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715936 */     GIR_RootConstrainSelectedInstOperands,
     /* 715937 */     // GIR_Coverage, 5146,
     /* 715937 */     GIR_EraseRootFromParent_Done,
     /* 715938 */   // Label 9282: @715938
     /* 715938 */   GIM_Try, /*On fail goto*//*Label 9283*/ GIMT_Encode4(716038), // Rule ID 5143 //
     /* 715943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715946 */     // MIs[0] offset
     /* 715946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715949 */     // MIs[0] auxiliary
     /* 715949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715952 */     // MIs[0] Operand 7
     /* 715952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715962 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 715965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 715969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 715974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 715978 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 715981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 715985 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 715988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 715993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_BOTHEN),
     /* 716006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 716011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716018 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716020 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716026 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716036 */     GIR_RootConstrainSelectedInstOperands,
     /* 716037 */     // GIR_Coverage, 5143,
     /* 716037 */     GIR_EraseRootFromParent_Done,
     /* 716038 */   // Label 9283: @716038
     /* 716038 */   GIM_Try, /*On fail goto*//*Label 9284*/ GIMT_Encode4(716135), // Rule ID 5147 //
     /* 716043 */     // MIs[0] offset
     /* 716043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716046 */     // MIs[0] auxiliary
     /* 716046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716049 */     // MIs[0] Operand 7
     /* 716049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716059 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 716062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 716066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 716071 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 716075 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 716078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 716082 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 716085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 716090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_BOTHEN),
     /* 716103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 716108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716115 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716117 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716123 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716133 */     GIR_RootConstrainSelectedInstOperands,
     /* 716134 */     // GIR_Coverage, 5147,
     /* 716134 */     GIR_EraseRootFromParent_Done,
     /* 716135 */   // Label 9284: @716135
     /* 716135 */   GIM_Reject,
     /* 716136 */ // Label 9276: @716136
     /* 716136 */ GIM_Reject,
     /* 716137 */ // Label 9256: @716137
     /* 716137 */ GIM_Try, /*On fail goto*//*Label 9285*/ GIMT_Encode4(716755),
     /* 716142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 716145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 716148 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 716151 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 716154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_160RegClassID),
     /* 716158 */   GIM_Try, /*On fail goto*//*Label 9286*/ GIMT_Encode4(716230), // Rule ID 5148 //
     /* 716163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 716170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716174 */     // MIs[0] offset
     /* 716174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716177 */     // MIs[0] auxiliary
     /* 716177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716180 */     // MIs[0] Operand 7
     /* 716180 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716198 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_OFFSET),
     /* 716201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716210 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716212 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716218 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716228 */     GIR_RootConstrainSelectedInstOperands,
     /* 716229 */     // GIR_Coverage, 5148,
     /* 716229 */     GIR_EraseRootFromParent_Done,
     /* 716230 */   // Label 9286: @716230
     /* 716230 */   GIM_Try, /*On fail goto*//*Label 9287*/ GIMT_Encode4(716299), // Rule ID 5152 //
     /* 716235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 716239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716243 */     // MIs[0] offset
     /* 716243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716246 */     // MIs[0] auxiliary
     /* 716246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716249 */     // MIs[0] Operand 7
     /* 716249 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716267 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFSET),
     /* 716270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716279 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716281 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716297 */     GIR_RootConstrainSelectedInstOperands,
     /* 716298 */     // GIR_Coverage, 5152,
     /* 716298 */     GIR_EraseRootFromParent_Done,
     /* 716299 */   // Label 9287: @716299
     /* 716299 */   GIM_Try, /*On fail goto*//*Label 9288*/ GIMT_Encode4(716369), // Rule ID 5149 //
     /* 716304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 716311 */     // MIs[0] offset
     /* 716311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716314 */     // MIs[0] auxiliary
     /* 716314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716317 */     // MIs[0] Operand 7
     /* 716317 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716335 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_OFFEN),
     /* 716338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716340 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 716342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716349 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716351 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716367 */     GIR_RootConstrainSelectedInstOperands,
     /* 716368 */     // GIR_Coverage, 5149,
     /* 716368 */     GIR_EraseRootFromParent_Done,
     /* 716369 */   // Label 9288: @716369
     /* 716369 */   GIM_Try, /*On fail goto*//*Label 9289*/ GIMT_Encode4(716436), // Rule ID 5153 //
     /* 716374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 716378 */     // MIs[0] offset
     /* 716378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716381 */     // MIs[0] auxiliary
     /* 716381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716384 */     // MIs[0] Operand 7
     /* 716384 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716402 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFEN),
     /* 716405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716407 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 716409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716416 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716418 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716434 */     GIR_RootConstrainSelectedInstOperands,
     /* 716435 */     // GIR_Coverage, 5153,
     /* 716435 */     GIR_EraseRootFromParent_Done,
     /* 716436 */   // Label 9289: @716436
     /* 716436 */   GIM_Try, /*On fail goto*//*Label 9290*/ GIMT_Encode4(716498), // Rule ID 5150 //
     /* 716441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716448 */     // MIs[0] offset
     /* 716448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716451 */     // MIs[0] auxiliary
     /* 716451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716454 */     // MIs[0] Operand 7
     /* 716454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716464 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_IDXEN),
     /* 716467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716469 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 716471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716478 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716480 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716496 */     GIR_RootConstrainSelectedInstOperands,
     /* 716497 */     // GIR_Coverage, 5150,
     /* 716497 */     GIR_EraseRootFromParent_Done,
     /* 716498 */   // Label 9290: @716498
     /* 716498 */   GIM_Try, /*On fail goto*//*Label 9291*/ GIMT_Encode4(716557), // Rule ID 5154 //
     /* 716503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716507 */     // MIs[0] offset
     /* 716507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716510 */     // MIs[0] auxiliary
     /* 716510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716513 */     // MIs[0] Operand 7
     /* 716513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716523 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_IDXEN),
     /* 716526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716528 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 716530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716537 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716539 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716545 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716555 */     GIR_RootConstrainSelectedInstOperands,
     /* 716556 */     // GIR_Coverage, 5154,
     /* 716556 */     GIR_EraseRootFromParent_Done,
     /* 716557 */   // Label 9291: @716557
     /* 716557 */   GIM_Try, /*On fail goto*//*Label 9292*/ GIMT_Encode4(716657), // Rule ID 5151 //
     /* 716562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716565 */     // MIs[0] offset
     /* 716565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716568 */     // MIs[0] auxiliary
     /* 716568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716571 */     // MIs[0] Operand 7
     /* 716571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716581 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 716584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 716588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 716593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 716597 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 716600 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 716604 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 716607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 716612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_BOTHEN),
     /* 716625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 716630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716637 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716639 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716645 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716655 */     GIR_RootConstrainSelectedInstOperands,
     /* 716656 */     // GIR_Coverage, 5151,
     /* 716656 */     GIR_EraseRootFromParent_Done,
     /* 716657 */   // Label 9292: @716657
     /* 716657 */   GIM_Try, /*On fail goto*//*Label 9293*/ GIMT_Encode4(716754), // Rule ID 5155 //
     /* 716662 */     // MIs[0] offset
     /* 716662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716665 */     // MIs[0] auxiliary
     /* 716665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716668 */     // MIs[0] Operand 7
     /* 716668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716678 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 716681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 716685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 716690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 716694 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 716697 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 716701 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 716704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 716709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_BOTHEN),
     /* 716722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 716727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716734 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716742 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716752 */     GIR_RootConstrainSelectedInstOperands,
     /* 716753 */     // GIR_Coverage, 5155,
     /* 716753 */     GIR_EraseRootFromParent_Done,
     /* 716754 */   // Label 9293: @716754
     /* 716754 */   GIM_Reject,
     /* 716755 */ // Label 9285: @716755
     /* 716755 */ GIM_Reject,
     /* 716756 */ // Label 9257: @716756
     /* 716756 */ GIM_Reject,
     /* 716757 */ // Label 134: @716757
     /* 716757 */ GIM_Try, /*On fail goto*//*Label 9294*/ GIMT_Encode4(717362),
     /* 716762 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 716765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 716768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 716771 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 716774 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 716777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 716781 */   GIM_Try, /*On fail goto*//*Label 9295*/ GIMT_Encode4(717053),
     /* 716786 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 716790 */     GIM_Try, /*On fail goto*//*Label 9296*/ GIMT_Encode4(716858), // Rule ID 5108 //
     /* 716795 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716798 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716802 */       // MIs[0] offset
     /* 716802 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716805 */       // MIs[0] auxiliary
     /* 716805 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716808 */       // MIs[0] Operand 7
     /* 716808 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716819 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716826 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716826 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 716829 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716831 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716833 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716838 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716840 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716846 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716852 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716856 */       GIR_RootConstrainSelectedInstOperands,
     /* 716857 */       // GIR_Coverage, 5108,
     /* 716857 */       GIR_EraseRootFromParent_Done,
     /* 716858 */     // Label 9296: @716858
     /* 716858 */     GIM_Try, /*On fail goto*//*Label 9297*/ GIMT_Encode4(716923), // Rule ID 5112 //
     /* 716863 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716867 */       // MIs[0] offset
     /* 716867 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716870 */       // MIs[0] auxiliary
     /* 716870 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716873 */       // MIs[0] Operand 7
     /* 716873 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716884 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716891 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716891 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 716894 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716896 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716898 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716903 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716905 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716911 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716917 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716921 */       GIR_RootConstrainSelectedInstOperands,
     /* 716922 */       // GIR_Coverage, 5112,
     /* 716922 */       GIR_EraseRootFromParent_Done,
     /* 716923 */     // Label 9297: @716923
     /* 716923 */     GIM_Try, /*On fail goto*//*Label 9298*/ GIMT_Encode4(716989), // Rule ID 5109 //
     /* 716928 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716931 */       // MIs[0] offset
     /* 716931 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716934 */       // MIs[0] auxiliary
     /* 716934 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716937 */       // MIs[0] Operand 7
     /* 716937 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716948 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716955 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716955 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /* 716958 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716960 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 716962 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716964 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716969 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716971 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716977 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716983 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716987 */       GIR_RootConstrainSelectedInstOperands,
     /* 716988 */       // GIR_Coverage, 5109,
     /* 716988 */       GIR_EraseRootFromParent_Done,
     /* 716989 */     // Label 9298: @716989
     /* 716989 */     GIM_Try, /*On fail goto*//*Label 9299*/ GIMT_Encode4(717052), // Rule ID 5113 //
     /* 716994 */       // MIs[0] offset
     /* 716994 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716997 */       // MIs[0] auxiliary
     /* 716997 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717000 */       // MIs[0] Operand 7
     /* 717000 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717011 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717018 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717018 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /* 717021 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717023 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 717025 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717027 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717032 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717034 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717040 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717046 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717050 */       GIR_RootConstrainSelectedInstOperands,
     /* 717051 */       // GIR_Coverage, 5113,
     /* 717051 */       GIR_EraseRootFromParent_Done,
     /* 717052 */     // Label 9299: @717052
     /* 717052 */     GIM_Reject,
     /* 717053 */   // Label 9295: @717053
     /* 717053 */   GIM_Try, /*On fail goto*//*Label 9300*/ GIMT_Encode4(717167),
     /* 717058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 717071 */     GIM_Try, /*On fail goto*//*Label 9301*/ GIMT_Encode4(717120), // Rule ID 5110 //
     /* 717076 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717079 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717086 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717086 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_IDXEN),
     /* 717089 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717091 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 717093 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717095 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717100 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717102 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717108 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717114 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717118 */       GIR_RootConstrainSelectedInstOperands,
     /* 717119 */       // GIR_Coverage, 5110,
     /* 717119 */       GIR_EraseRootFromParent_Done,
     /* 717120 */     // Label 9301: @717120
     /* 717120 */     GIM_Try, /*On fail goto*//*Label 9302*/ GIMT_Encode4(717166), // Rule ID 5114 //
     /* 717125 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717132 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717132 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_IDXEN),
     /* 717135 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717137 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 717139 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717141 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717146 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717148 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717154 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717160 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717164 */       GIR_RootConstrainSelectedInstOperands,
     /* 717165 */       // GIR_Coverage, 5114,
     /* 717165 */       GIR_EraseRootFromParent_Done,
     /* 717166 */     // Label 9302: @717166
     /* 717166 */     GIM_Reject,
     /* 717167 */   // Label 9300: @717167
     /* 717167 */   GIM_Try, /*On fail goto*//*Label 9303*/ GIMT_Encode4(717361),
     /* 717172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 717181 */     GIM_Try, /*On fail goto*//*Label 9304*/ GIMT_Encode4(717272), // Rule ID 5111 //
     /* 717186 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717189 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717196 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717196 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 717199 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 717203 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 717208 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 717212 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 717215 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 717219 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 717222 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 717227 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717232 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717237 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_BOTHEN),
     /* 717240 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717242 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 717245 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717247 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717252 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717254 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717260 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717266 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717270 */       GIR_RootConstrainSelectedInstOperands,
     /* 717271 */       // GIR_Coverage, 5111,
     /* 717271 */       GIR_EraseRootFromParent_Done,
     /* 717272 */     // Label 9304: @717272
     /* 717272 */     GIM_Try, /*On fail goto*//*Label 9305*/ GIMT_Encode4(717360), // Rule ID 5115 //
     /* 717277 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717284 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717284 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 717287 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 717291 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 717296 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 717300 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 717303 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 717307 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 717310 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 717315 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717320 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717325 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_BOTHEN),
     /* 717328 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717330 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 717333 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717335 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717340 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717342 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717348 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717354 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717358 */       GIR_RootConstrainSelectedInstOperands,
     /* 717359 */       // GIR_Coverage, 5115,
     /* 717359 */       GIR_EraseRootFromParent_Done,
     /* 717360 */     // Label 9305: @717360
     /* 717360 */     GIM_Reject,
     /* 717361 */   // Label 9303: @717361
     /* 717361 */   GIM_Reject,
     /* 717362 */ // Label 9294: @717362
     /* 717362 */ GIM_Reject,
     /* 717363 */ // Label 135: @717363
     /* 717363 */ GIM_Try, /*On fail goto*//*Label 9306*/ GIMT_Encode4(717968),
     /* 717368 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 717371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 717374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 717377 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 717380 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 717383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 717387 */   GIM_Try, /*On fail goto*//*Label 9307*/ GIMT_Encode4(717659),
     /* 717392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 717396 */     GIM_Try, /*On fail goto*//*Label 9308*/ GIMT_Encode4(717464), // Rule ID 5172 //
     /* 717401 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717404 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717408 */       // MIs[0] offset
     /* 717408 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717411 */       // MIs[0] auxiliary
     /* 717411 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717414 */       // MIs[0] Operand 7
     /* 717414 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717425 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717432 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717432 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_OFFSET),
     /* 717435 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717437 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717439 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717444 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717446 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717452 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717458 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717462 */       GIR_RootConstrainSelectedInstOperands,
     /* 717463 */       // GIR_Coverage, 5172,
     /* 717463 */       GIR_EraseRootFromParent_Done,
     /* 717464 */     // Label 9308: @717464
     /* 717464 */     GIM_Try, /*On fail goto*//*Label 9309*/ GIMT_Encode4(717529), // Rule ID 5176 //
     /* 717469 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717473 */       // MIs[0] offset
     /* 717473 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717476 */       // MIs[0] auxiliary
     /* 717476 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717479 */       // MIs[0] Operand 7
     /* 717479 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717490 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717497 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717497 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFSET),
     /* 717500 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717502 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717504 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717509 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717511 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717517 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717523 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717527 */       GIR_RootConstrainSelectedInstOperands,
     /* 717528 */       // GIR_Coverage, 5176,
     /* 717528 */       GIR_EraseRootFromParent_Done,
     /* 717529 */     // Label 9309: @717529
     /* 717529 */     GIM_Try, /*On fail goto*//*Label 9310*/ GIMT_Encode4(717595), // Rule ID 5173 //
     /* 717534 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717537 */       // MIs[0] offset
     /* 717537 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717540 */       // MIs[0] auxiliary
     /* 717540 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717543 */       // MIs[0] Operand 7
     /* 717543 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717554 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717561 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717561 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_OFFEN),
     /* 717564 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717566 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 717568 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717570 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717575 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717577 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717583 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717589 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717593 */       GIR_RootConstrainSelectedInstOperands,
     /* 717594 */       // GIR_Coverage, 5173,
     /* 717594 */       GIR_EraseRootFromParent_Done,
     /* 717595 */     // Label 9310: @717595
     /* 717595 */     GIM_Try, /*On fail goto*//*Label 9311*/ GIMT_Encode4(717658), // Rule ID 5177 //
     /* 717600 */       // MIs[0] offset
     /* 717600 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717603 */       // MIs[0] auxiliary
     /* 717603 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717606 */       // MIs[0] Operand 7
     /* 717606 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717617 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717624 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717624 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFEN),
     /* 717627 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717629 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 717631 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717633 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717638 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717640 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717646 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717652 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717656 */       GIR_RootConstrainSelectedInstOperands,
     /* 717657 */       // GIR_Coverage, 5177,
     /* 717657 */       GIR_EraseRootFromParent_Done,
     /* 717658 */     // Label 9311: @717658
     /* 717658 */     GIM_Reject,
     /* 717659 */   // Label 9307: @717659
     /* 717659 */   GIM_Try, /*On fail goto*//*Label 9312*/ GIMT_Encode4(717773),
     /* 717664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 717677 */     GIM_Try, /*On fail goto*//*Label 9313*/ GIMT_Encode4(717726), // Rule ID 5174 //
     /* 717682 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717685 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717692 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717692 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_IDXEN),
     /* 717695 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717697 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 717699 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717701 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717706 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717708 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717714 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717720 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717724 */       GIR_RootConstrainSelectedInstOperands,
     /* 717725 */       // GIR_Coverage, 5174,
     /* 717725 */       GIR_EraseRootFromParent_Done,
     /* 717726 */     // Label 9313: @717726
     /* 717726 */     GIM_Try, /*On fail goto*//*Label 9314*/ GIMT_Encode4(717772), // Rule ID 5178 //
     /* 717731 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717738 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717738 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_IDXEN),
     /* 717741 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717743 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 717745 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717747 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717752 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717754 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717760 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717766 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717770 */       GIR_RootConstrainSelectedInstOperands,
     /* 717771 */       // GIR_Coverage, 5178,
     /* 717771 */       GIR_EraseRootFromParent_Done,
     /* 717772 */     // Label 9314: @717772
     /* 717772 */     GIM_Reject,
     /* 717773 */   // Label 9312: @717773
     /* 717773 */   GIM_Try, /*On fail goto*//*Label 9315*/ GIMT_Encode4(717967),
     /* 717778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 717787 */     GIM_Try, /*On fail goto*//*Label 9316*/ GIMT_Encode4(717878), // Rule ID 5175 //
     /* 717792 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717795 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717802 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717802 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 717805 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 717809 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 717814 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 717818 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 717821 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 717825 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 717828 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 717833 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717838 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717843 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_BOTHEN),
     /* 717846 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717848 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 717851 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717853 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717858 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717860 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717866 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717872 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717876 */       GIR_RootConstrainSelectedInstOperands,
     /* 717877 */       // GIR_Coverage, 5175,
     /* 717877 */       GIR_EraseRootFromParent_Done,
     /* 717878 */     // Label 9316: @717878
     /* 717878 */     GIM_Try, /*On fail goto*//*Label 9317*/ GIMT_Encode4(717966), // Rule ID 5179 //
     /* 717883 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717890 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717890 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 717893 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 717897 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 717902 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 717906 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 717909 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 717913 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 717916 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 717921 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717926 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717931 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_BOTHEN),
     /* 717934 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717936 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 717939 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717941 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717946 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717948 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717954 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717960 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717964 */       GIR_RootConstrainSelectedInstOperands,
     /* 717965 */       // GIR_Coverage, 5179,
     /* 717965 */       GIR_EraseRootFromParent_Done,
     /* 717966 */     // Label 9317: @717966
     /* 717966 */     GIM_Reject,
     /* 717967 */   // Label 9315: @717967
     /* 717967 */   GIM_Reject,
     /* 717968 */ // Label 9306: @717968
     /* 717968 */ GIM_Reject,
     /* 717969 */ // Label 136: @717969
     /* 717969 */ GIM_Try, /*On fail goto*//*Label 9318*/ GIMT_Encode4(718574),
     /* 717974 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 717977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 717980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 717983 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 717986 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 717989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 717993 */   GIM_Try, /*On fail goto*//*Label 9319*/ GIMT_Encode4(718265),
     /* 717998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 718002 */     GIM_Try, /*On fail goto*//*Label 9320*/ GIMT_Encode4(718070), // Rule ID 5116 //
     /* 718007 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718010 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718014 */       // MIs[0] offset
     /* 718014 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718017 */       // MIs[0] auxiliary
     /* 718017 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718020 */       // MIs[0] Operand 7
     /* 718020 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718031 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718038 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718038 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /* 718041 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718043 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718045 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718050 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718052 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718058 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718064 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718068 */       GIR_RootConstrainSelectedInstOperands,
     /* 718069 */       // GIR_Coverage, 5116,
     /* 718069 */       GIR_EraseRootFromParent_Done,
     /* 718070 */     // Label 9320: @718070
     /* 718070 */     GIM_Try, /*On fail goto*//*Label 9321*/ GIMT_Encode4(718135), // Rule ID 5120 //
     /* 718075 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718079 */       // MIs[0] offset
     /* 718079 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718082 */       // MIs[0] auxiliary
     /* 718082 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718085 */       // MIs[0] Operand 7
     /* 718085 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718096 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718103 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718103 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /* 718106 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718108 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718110 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718115 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718117 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718123 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718129 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718133 */       GIR_RootConstrainSelectedInstOperands,
     /* 718134 */       // GIR_Coverage, 5120,
     /* 718134 */       GIR_EraseRootFromParent_Done,
     /* 718135 */     // Label 9321: @718135
     /* 718135 */     GIM_Try, /*On fail goto*//*Label 9322*/ GIMT_Encode4(718201), // Rule ID 5117 //
     /* 718140 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718143 */       // MIs[0] offset
     /* 718143 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718146 */       // MIs[0] auxiliary
     /* 718146 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718149 */       // MIs[0] Operand 7
     /* 718149 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718160 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718167 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718167 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
     /* 718170 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718172 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 718174 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718176 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718181 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718183 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718189 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718195 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718199 */       GIR_RootConstrainSelectedInstOperands,
     /* 718200 */       // GIR_Coverage, 5117,
     /* 718200 */       GIR_EraseRootFromParent_Done,
     /* 718201 */     // Label 9322: @718201
     /* 718201 */     GIM_Try, /*On fail goto*//*Label 9323*/ GIMT_Encode4(718264), // Rule ID 5121 //
     /* 718206 */       // MIs[0] offset
     /* 718206 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718209 */       // MIs[0] auxiliary
     /* 718209 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718212 */       // MIs[0] Operand 7
     /* 718212 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718223 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718230 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718230 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
     /* 718233 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718235 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 718237 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718239 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718244 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718246 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718252 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718258 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718262 */       GIR_RootConstrainSelectedInstOperands,
     /* 718263 */       // GIR_Coverage, 5121,
     /* 718263 */       GIR_EraseRootFromParent_Done,
     /* 718264 */     // Label 9323: @718264
     /* 718264 */     GIM_Reject,
     /* 718265 */   // Label 9319: @718265
     /* 718265 */   GIM_Try, /*On fail goto*//*Label 9324*/ GIMT_Encode4(718379),
     /* 718270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 718283 */     GIM_Try, /*On fail goto*//*Label 9325*/ GIMT_Encode4(718332), // Rule ID 5118 //
     /* 718288 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718291 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718298 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718298 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_IDXEN),
     /* 718301 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718303 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 718305 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718307 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718312 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718314 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718320 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718326 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718330 */       GIR_RootConstrainSelectedInstOperands,
     /* 718331 */       // GIR_Coverage, 5118,
     /* 718331 */       GIR_EraseRootFromParent_Done,
     /* 718332 */     // Label 9325: @718332
     /* 718332 */     GIM_Try, /*On fail goto*//*Label 9326*/ GIMT_Encode4(718378), // Rule ID 5122 //
     /* 718337 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718344 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718344 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_IDXEN),
     /* 718347 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718349 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 718351 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718353 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718358 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718360 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718366 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718372 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718376 */       GIR_RootConstrainSelectedInstOperands,
     /* 718377 */       // GIR_Coverage, 5122,
     /* 718377 */       GIR_EraseRootFromParent_Done,
     /* 718378 */     // Label 9326: @718378
     /* 718378 */     GIM_Reject,
     /* 718379 */   // Label 9324: @718379
     /* 718379 */   GIM_Try, /*On fail goto*//*Label 9327*/ GIMT_Encode4(718573),
     /* 718384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 718393 */     GIM_Try, /*On fail goto*//*Label 9328*/ GIMT_Encode4(718484), // Rule ID 5119 //
     /* 718398 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718401 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718408 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718408 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 718411 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 718415 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 718420 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 718424 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 718427 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 718431 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 718434 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 718439 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718444 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718449 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_BOTHEN),
     /* 718452 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718454 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 718457 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718459 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718464 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718466 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718472 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718478 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718482 */       GIR_RootConstrainSelectedInstOperands,
     /* 718483 */       // GIR_Coverage, 5119,
     /* 718483 */       GIR_EraseRootFromParent_Done,
     /* 718484 */     // Label 9328: @718484
     /* 718484 */     GIM_Try, /*On fail goto*//*Label 9329*/ GIMT_Encode4(718572), // Rule ID 5123 //
     /* 718489 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718496 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718496 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 718499 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 718503 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 718508 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 718512 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 718515 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 718519 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 718522 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 718527 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718532 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718537 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_BOTHEN),
     /* 718540 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718542 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 718545 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718547 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718552 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718554 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718560 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718566 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718570 */       GIR_RootConstrainSelectedInstOperands,
     /* 718571 */       // GIR_Coverage, 5123,
     /* 718571 */       GIR_EraseRootFromParent_Done,
     /* 718572 */     // Label 9329: @718572
     /* 718572 */     GIM_Reject,
     /* 718573 */   // Label 9327: @718573
     /* 718573 */   GIM_Reject,
     /* 718574 */ // Label 9318: @718574
     /* 718574 */ GIM_Reject,
     /* 718575 */ // Label 137: @718575
     /* 718575 */ GIM_Try, /*On fail goto*//*Label 9330*/ GIMT_Encode4(719180),
     /* 718580 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 718583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 718586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 718589 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 718592 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 718595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 718599 */   GIM_Try, /*On fail goto*//*Label 9331*/ GIMT_Encode4(718871),
     /* 718604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 718608 */     GIM_Try, /*On fail goto*//*Label 9332*/ GIMT_Encode4(718676), // Rule ID 5180 //
     /* 718613 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718616 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718620 */       // MIs[0] offset
     /* 718620 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718623 */       // MIs[0] auxiliary
     /* 718623 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718626 */       // MIs[0] Operand 7
     /* 718626 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718637 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718644 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718644 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_OFFSET),
     /* 718647 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718649 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718651 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718656 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718658 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718664 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718670 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718674 */       GIR_RootConstrainSelectedInstOperands,
     /* 718675 */       // GIR_Coverage, 5180,
     /* 718675 */       GIR_EraseRootFromParent_Done,
     /* 718676 */     // Label 9332: @718676
     /* 718676 */     GIM_Try, /*On fail goto*//*Label 9333*/ GIMT_Encode4(718741), // Rule ID 5184 //
     /* 718681 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718685 */       // MIs[0] offset
     /* 718685 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718688 */       // MIs[0] auxiliary
     /* 718688 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718691 */       // MIs[0] Operand 7
     /* 718691 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718702 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718709 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718709 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFSET),
     /* 718712 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718714 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718716 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718721 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718723 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718729 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718735 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718739 */       GIR_RootConstrainSelectedInstOperands,
     /* 718740 */       // GIR_Coverage, 5184,
     /* 718740 */       GIR_EraseRootFromParent_Done,
     /* 718741 */     // Label 9333: @718741
     /* 718741 */     GIM_Try, /*On fail goto*//*Label 9334*/ GIMT_Encode4(718807), // Rule ID 5181 //
     /* 718746 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718749 */       // MIs[0] offset
     /* 718749 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718752 */       // MIs[0] auxiliary
     /* 718752 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718755 */       // MIs[0] Operand 7
     /* 718755 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718766 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718773 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718773 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_OFFEN),
     /* 718776 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718778 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 718780 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718782 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718787 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718789 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718795 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718801 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718805 */       GIR_RootConstrainSelectedInstOperands,
     /* 718806 */       // GIR_Coverage, 5181,
     /* 718806 */       GIR_EraseRootFromParent_Done,
     /* 718807 */     // Label 9334: @718807
     /* 718807 */     GIM_Try, /*On fail goto*//*Label 9335*/ GIMT_Encode4(718870), // Rule ID 5185 //
     /* 718812 */       // MIs[0] offset
     /* 718812 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718815 */       // MIs[0] auxiliary
     /* 718815 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718818 */       // MIs[0] Operand 7
     /* 718818 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718829 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718836 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718836 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFEN),
     /* 718839 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718841 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 718843 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718845 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718850 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718852 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718858 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718864 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718868 */       GIR_RootConstrainSelectedInstOperands,
     /* 718869 */       // GIR_Coverage, 5185,
     /* 718869 */       GIR_EraseRootFromParent_Done,
     /* 718870 */     // Label 9335: @718870
     /* 718870 */     GIM_Reject,
     /* 718871 */   // Label 9331: @718871
     /* 718871 */   GIM_Try, /*On fail goto*//*Label 9336*/ GIMT_Encode4(718985),
     /* 718876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 718889 */     GIM_Try, /*On fail goto*//*Label 9337*/ GIMT_Encode4(718938), // Rule ID 5182 //
     /* 718894 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718897 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718904 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718904 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_IDXEN),
     /* 718907 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718909 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 718911 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718913 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718918 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718920 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718926 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718932 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718936 */       GIR_RootConstrainSelectedInstOperands,
     /* 718937 */       // GIR_Coverage, 5182,
     /* 718937 */       GIR_EraseRootFromParent_Done,
     /* 718938 */     // Label 9337: @718938
     /* 718938 */     GIM_Try, /*On fail goto*//*Label 9338*/ GIMT_Encode4(718984), // Rule ID 5186 //
     /* 718943 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718950 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718950 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_IDXEN),
     /* 718953 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718955 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 718957 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718959 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718964 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718966 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718972 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718978 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718982 */       GIR_RootConstrainSelectedInstOperands,
     /* 718983 */       // GIR_Coverage, 5186,
     /* 718983 */       GIR_EraseRootFromParent_Done,
     /* 718984 */     // Label 9338: @718984
     /* 718984 */     GIM_Reject,
     /* 718985 */   // Label 9336: @718985
     /* 718985 */   GIM_Try, /*On fail goto*//*Label 9339*/ GIMT_Encode4(719179),
     /* 718990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 718999 */     GIM_Try, /*On fail goto*//*Label 9340*/ GIMT_Encode4(719090), // Rule ID 5183 //
     /* 719004 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719007 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719014 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719014 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 719017 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 719021 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 719026 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 719030 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 719033 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 719037 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 719040 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 719045 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719050 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719055 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_BOTHEN),
     /* 719058 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719060 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 719063 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719065 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719070 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719072 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719078 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719084 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719088 */       GIR_RootConstrainSelectedInstOperands,
     /* 719089 */       // GIR_Coverage, 5183,
     /* 719089 */       GIR_EraseRootFromParent_Done,
     /* 719090 */     // Label 9340: @719090
     /* 719090 */     GIM_Try, /*On fail goto*//*Label 9341*/ GIMT_Encode4(719178), // Rule ID 5187 //
     /* 719095 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719102 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719102 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 719105 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 719109 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 719114 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 719118 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 719121 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 719125 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 719128 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 719133 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719138 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719143 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_BOTHEN),
     /* 719146 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719148 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 719151 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719153 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719158 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719160 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719166 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719172 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719176 */       GIR_RootConstrainSelectedInstOperands,
     /* 719177 */       // GIR_Coverage, 5187,
     /* 719177 */       GIR_EraseRootFromParent_Done,
     /* 719178 */     // Label 9341: @719178
     /* 719178 */     GIM_Reject,
     /* 719179 */   // Label 9339: @719179
     /* 719179 */   GIM_Reject,
     /* 719180 */ // Label 9330: @719180
     /* 719180 */ GIM_Reject,
     /* 719181 */ // Label 138: @719181
     /* 719181 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(23), /*)*//*default:*//*Label 9358*/ GIMT_Encode4(734488),
     /* 719192 */ /*GILLT_p0s64*//*Label 9342*/ GIMT_Encode4(719284),
     /* 719196 */ /*GILLT_p1s64*//*Label 9343*/ GIMT_Encode4(719899),
     /* 719200 */ /*GILLT_p2s32*//*Label 9344*/ GIMT_Encode4(720514),
     /* 719204 */ /*GILLT_p3s32*//*Label 9345*/ GIMT_Encode4(721129),
     /* 719208 */ /*GILLT_p4s64*//*Label 9346*/ GIMT_Encode4(721744),
     /* 719212 */ /*GILLT_p5s32*//*Label 9347*/ GIMT_Encode4(722359),
     /* 719216 */ /*GILLT_p6s32*//*Label 9348*/ GIMT_Encode4(722974), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 719228 */ /*GILLT_s32*//*Label 9349*/ GIMT_Encode4(723589),
     /* 719232 */ /*GILLT_s64*//*Label 9350*/ GIMT_Encode4(724800),
     /* 719236 */ /*GILLT_v2s16*//*Label 9351*/ GIMT_Encode4(726011),
     /* 719240 */ /*GILLT_v2s32*//*Label 9352*/ GIMT_Encode4(727222),
     /* 719244 */ /*GILLT_v2s64*//*Label 9353*/ GIMT_Encode4(728433),
     /* 719248 */ /*GILLT_v3s32*//*Label 9354*/ GIMT_Encode4(729644), GIMT_Encode4(0),
     /* 719256 */ /*GILLT_v4s16*//*Label 9355*/ GIMT_Encode4(730855),
     /* 719260 */ /*GILLT_v4s32*//*Label 9356*/ GIMT_Encode4(732066), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 719280 */ /*GILLT_v8s16*//*Label 9357*/ GIMT_Encode4(733277),
     /* 719284 */ // Label 9342: @719284
     /* 719284 */ GIM_Try, /*On fail goto*//*Label 9359*/ GIMT_Encode4(719898),
     /* 719289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 719292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 719295 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 719298 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 719301 */   GIM_Try, /*On fail goto*//*Label 9360*/ GIMT_Encode4(719373), // Rule ID 5452 //
     /* 719306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719317 */     // MIs[0] offset
     /* 719317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719320 */     // MIs[0] auxiliary
     /* 719320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719323 */     // MIs[0] Operand 7
     /* 719323 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719341 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9819:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 719344 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719353 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719355 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719361 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719371 */     GIR_RootConstrainSelectedInstOperands,
     /* 719372 */     // GIR_Coverage, 5452,
     /* 719372 */     GIR_EraseRootFromParent_Done,
     /* 719373 */   // Label 9360: @719373
     /* 719373 */   GIM_Try, /*On fail goto*//*Label 9361*/ GIMT_Encode4(719442), // Rule ID 5456 //
     /* 719378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719386 */     // MIs[0] offset
     /* 719386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719389 */     // MIs[0] auxiliary
     /* 719389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719392 */     // MIs[0] Operand 7
     /* 719392 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719410 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9819:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 719413 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719422 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719440 */     GIR_RootConstrainSelectedInstOperands,
     /* 719441 */     // GIR_Coverage, 5456,
     /* 719441 */     GIR_EraseRootFromParent_Done,
     /* 719442 */   // Label 9361: @719442
     /* 719442 */   GIM_Try, /*On fail goto*//*Label 9362*/ GIMT_Encode4(719512), // Rule ID 5453 //
     /* 719447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719454 */     // MIs[0] offset
     /* 719454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719457 */     // MIs[0] auxiliary
     /* 719457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719460 */     // MIs[0] Operand 7
     /* 719460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719478 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 719481 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719483 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 719485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719492 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719494 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719500 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719510 */     GIR_RootConstrainSelectedInstOperands,
     /* 719511 */     // GIR_Coverage, 5453,
     /* 719511 */     GIR_EraseRootFromParent_Done,
     /* 719512 */   // Label 9362: @719512
     /* 719512 */   GIM_Try, /*On fail goto*//*Label 9363*/ GIMT_Encode4(719579), // Rule ID 5457 //
     /* 719517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719521 */     // MIs[0] offset
     /* 719521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719524 */     // MIs[0] auxiliary
     /* 719524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719527 */     // MIs[0] Operand 7
     /* 719527 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719545 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 719548 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719550 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 719552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719559 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719561 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719567 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719577 */     GIR_RootConstrainSelectedInstOperands,
     /* 719578 */     // GIR_Coverage, 5457,
     /* 719578 */     GIR_EraseRootFromParent_Done,
     /* 719579 */   // Label 9363: @719579
     /* 719579 */   GIM_Try, /*On fail goto*//*Label 9364*/ GIMT_Encode4(719641), // Rule ID 5454 //
     /* 719584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719591 */     // MIs[0] offset
     /* 719591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719594 */     // MIs[0] auxiliary
     /* 719594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719597 */     // MIs[0] Operand 7
     /* 719597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719607 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 719610 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719612 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 719614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719621 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719623 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719629 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719639 */     GIR_RootConstrainSelectedInstOperands,
     /* 719640 */     // GIR_Coverage, 5454,
     /* 719640 */     GIR_EraseRootFromParent_Done,
     /* 719641 */   // Label 9364: @719641
     /* 719641 */   GIM_Try, /*On fail goto*//*Label 9365*/ GIMT_Encode4(719700), // Rule ID 5458 //
     /* 719646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719650 */     // MIs[0] offset
     /* 719650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719653 */     // MIs[0] auxiliary
     /* 719653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719656 */     // MIs[0] Operand 7
     /* 719656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719666 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 719669 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719671 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 719673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719680 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719682 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719688 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719698 */     GIR_RootConstrainSelectedInstOperands,
     /* 719699 */     // GIR_Coverage, 5458,
     /* 719699 */     GIR_EraseRootFromParent_Done,
     /* 719700 */   // Label 9365: @719700
     /* 719700 */   GIM_Try, /*On fail goto*//*Label 9366*/ GIMT_Encode4(719800), // Rule ID 5455 //
     /* 719705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719708 */     // MIs[0] offset
     /* 719708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719711 */     // MIs[0] auxiliary
     /* 719711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719714 */     // MIs[0] Operand 7
     /* 719714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719724 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9819:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 719727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 719731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 719736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 719740 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 719743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 719747 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 719750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 719755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 719768 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 719773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719780 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719782 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719788 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719798 */     GIR_RootConstrainSelectedInstOperands,
     /* 719799 */     // GIR_Coverage, 5455,
     /* 719799 */     GIR_EraseRootFromParent_Done,
     /* 719800 */   // Label 9366: @719800
     /* 719800 */   GIM_Try, /*On fail goto*//*Label 9367*/ GIMT_Encode4(719897), // Rule ID 5459 //
     /* 719805 */     // MIs[0] offset
     /* 719805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719808 */     // MIs[0] auxiliary
     /* 719808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719811 */     // MIs[0] Operand 7
     /* 719811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719821 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 719824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 719828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 719833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 719837 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 719840 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 719844 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 719847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 719852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 719865 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 719870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719877 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719879 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719885 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719895 */     GIR_RootConstrainSelectedInstOperands,
     /* 719896 */     // GIR_Coverage, 5459,
     /* 719896 */     GIR_EraseRootFromParent_Done,
     /* 719897 */   // Label 9367: @719897
     /* 719897 */   GIM_Reject,
     /* 719898 */ // Label 9359: @719898
     /* 719898 */ GIM_Reject,
     /* 719899 */ // Label 9343: @719899
     /* 719899 */ GIM_Try, /*On fail goto*//*Label 9368*/ GIMT_Encode4(720513),
     /* 719904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 719907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 719910 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 719913 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 719916 */   GIM_Try, /*On fail goto*//*Label 9369*/ GIMT_Encode4(719988), // Rule ID 5460 //
     /* 719921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719932 */     // MIs[0] offset
     /* 719932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719935 */     // MIs[0] auxiliary
     /* 719935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719938 */     // MIs[0] Operand 7
     /* 719938 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719956 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9819:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 719959 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 719961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719968 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719970 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719986 */     GIR_RootConstrainSelectedInstOperands,
     /* 719987 */     // GIR_Coverage, 5460,
     /* 719987 */     GIR_EraseRootFromParent_Done,
     /* 719988 */   // Label 9369: @719988
     /* 719988 */   GIM_Try, /*On fail goto*//*Label 9370*/ GIMT_Encode4(720057), // Rule ID 5464 //
     /* 719993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720001 */     // MIs[0] offset
     /* 720001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720004 */     // MIs[0] auxiliary
     /* 720004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720007 */     // MIs[0] Operand 7
     /* 720007 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720025 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9819:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 720028 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720037 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720039 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720055 */     GIR_RootConstrainSelectedInstOperands,
     /* 720056 */     // GIR_Coverage, 5464,
     /* 720056 */     GIR_EraseRootFromParent_Done,
     /* 720057 */   // Label 9370: @720057
     /* 720057 */   GIM_Try, /*On fail goto*//*Label 9371*/ GIMT_Encode4(720127), // Rule ID 5461 //
     /* 720062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720069 */     // MIs[0] offset
     /* 720069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720072 */     // MIs[0] auxiliary
     /* 720072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720075 */     // MIs[0] Operand 7
     /* 720075 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720093 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 720096 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720098 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 720100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720107 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720109 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720125 */     GIR_RootConstrainSelectedInstOperands,
     /* 720126 */     // GIR_Coverage, 5461,
     /* 720126 */     GIR_EraseRootFromParent_Done,
     /* 720127 */   // Label 9371: @720127
     /* 720127 */   GIM_Try, /*On fail goto*//*Label 9372*/ GIMT_Encode4(720194), // Rule ID 5465 //
     /* 720132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720136 */     // MIs[0] offset
     /* 720136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720139 */     // MIs[0] auxiliary
     /* 720139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720142 */     // MIs[0] Operand 7
     /* 720142 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720160 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 720163 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720165 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 720167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720174 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720182 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720192 */     GIR_RootConstrainSelectedInstOperands,
     /* 720193 */     // GIR_Coverage, 5465,
     /* 720193 */     GIR_EraseRootFromParent_Done,
     /* 720194 */   // Label 9372: @720194
     /* 720194 */   GIM_Try, /*On fail goto*//*Label 9373*/ GIMT_Encode4(720256), // Rule ID 5462 //
     /* 720199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720206 */     // MIs[0] offset
     /* 720206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720209 */     // MIs[0] auxiliary
     /* 720209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720212 */     // MIs[0] Operand 7
     /* 720212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720222 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 720225 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720227 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 720229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720236 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720254 */     GIR_RootConstrainSelectedInstOperands,
     /* 720255 */     // GIR_Coverage, 5462,
     /* 720255 */     GIR_EraseRootFromParent_Done,
     /* 720256 */   // Label 9373: @720256
     /* 720256 */   GIM_Try, /*On fail goto*//*Label 9374*/ GIMT_Encode4(720315), // Rule ID 5466 //
     /* 720261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720265 */     // MIs[0] offset
     /* 720265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720268 */     // MIs[0] auxiliary
     /* 720268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720271 */     // MIs[0] Operand 7
     /* 720271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720281 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 720284 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720286 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 720288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720295 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720297 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720303 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720313 */     GIR_RootConstrainSelectedInstOperands,
     /* 720314 */     // GIR_Coverage, 5466,
     /* 720314 */     GIR_EraseRootFromParent_Done,
     /* 720315 */   // Label 9374: @720315
     /* 720315 */   GIM_Try, /*On fail goto*//*Label 9375*/ GIMT_Encode4(720415), // Rule ID 5463 //
     /* 720320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720323 */     // MIs[0] offset
     /* 720323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720326 */     // MIs[0] auxiliary
     /* 720326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720329 */     // MIs[0] Operand 7
     /* 720329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720339 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9819:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 720342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 720346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 720351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 720355 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 720358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 720362 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 720365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 720370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 720383 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 720388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720395 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720397 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720413 */     GIR_RootConstrainSelectedInstOperands,
     /* 720414 */     // GIR_Coverage, 5463,
     /* 720414 */     GIR_EraseRootFromParent_Done,
     /* 720415 */   // Label 9375: @720415
     /* 720415 */   GIM_Try, /*On fail goto*//*Label 9376*/ GIMT_Encode4(720512), // Rule ID 5467 //
     /* 720420 */     // MIs[0] offset
     /* 720420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720423 */     // MIs[0] auxiliary
     /* 720423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720426 */     // MIs[0] Operand 7
     /* 720426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720436 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 720439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 720443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 720448 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 720452 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 720455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 720459 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 720462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 720467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 720480 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 720485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720492 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720494 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720500 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720510 */     GIR_RootConstrainSelectedInstOperands,
     /* 720511 */     // GIR_Coverage, 5467,
     /* 720511 */     GIR_EraseRootFromParent_Done,
     /* 720512 */   // Label 9376: @720512
     /* 720512 */   GIM_Reject,
     /* 720513 */ // Label 9368: @720513
     /* 720513 */ GIM_Reject,
     /* 720514 */ // Label 9344: @720514
     /* 720514 */ GIM_Try, /*On fail goto*//*Label 9377*/ GIMT_Encode4(721128),
     /* 720519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 720522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 720525 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 720528 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 720531 */   GIM_Try, /*On fail goto*//*Label 9378*/ GIMT_Encode4(720603), // Rule ID 5388 //
     /* 720536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720547 */     // MIs[0] offset
     /* 720547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720550 */     // MIs[0] auxiliary
     /* 720550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720553 */     // MIs[0] Operand 7
     /* 720553 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720571 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 720574 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720583 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720591 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720601 */     GIR_RootConstrainSelectedInstOperands,
     /* 720602 */     // GIR_Coverage, 5388,
     /* 720602 */     GIR_EraseRootFromParent_Done,
     /* 720603 */   // Label 9378: @720603
     /* 720603 */   GIM_Try, /*On fail goto*//*Label 9379*/ GIMT_Encode4(720672), // Rule ID 5392 //
     /* 720608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720616 */     // MIs[0] offset
     /* 720616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720619 */     // MIs[0] auxiliary
     /* 720619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720622 */     // MIs[0] Operand 7
     /* 720622 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720640 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 720643 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720652 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720660 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720670 */     GIR_RootConstrainSelectedInstOperands,
     /* 720671 */     // GIR_Coverage, 5392,
     /* 720671 */     GIR_EraseRootFromParent_Done,
     /* 720672 */   // Label 9379: @720672
     /* 720672 */   GIM_Try, /*On fail goto*//*Label 9380*/ GIMT_Encode4(720742), // Rule ID 5389 //
     /* 720677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720684 */     // MIs[0] offset
     /* 720684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720687 */     // MIs[0] auxiliary
     /* 720687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720690 */     // MIs[0] Operand 7
     /* 720690 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720708 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 720711 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720713 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 720715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720722 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720740 */     GIR_RootConstrainSelectedInstOperands,
     /* 720741 */     // GIR_Coverage, 5389,
     /* 720741 */     GIR_EraseRootFromParent_Done,
     /* 720742 */   // Label 9380: @720742
     /* 720742 */   GIM_Try, /*On fail goto*//*Label 9381*/ GIMT_Encode4(720809), // Rule ID 5393 //
     /* 720747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720751 */     // MIs[0] offset
     /* 720751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720754 */     // MIs[0] auxiliary
     /* 720754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720757 */     // MIs[0] Operand 7
     /* 720757 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720775 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 720778 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720780 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 720782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720789 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720791 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720807 */     GIR_RootConstrainSelectedInstOperands,
     /* 720808 */     // GIR_Coverage, 5393,
     /* 720808 */     GIR_EraseRootFromParent_Done,
     /* 720809 */   // Label 9381: @720809
     /* 720809 */   GIM_Try, /*On fail goto*//*Label 9382*/ GIMT_Encode4(720871), // Rule ID 5390 //
     /* 720814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720817 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720821 */     // MIs[0] offset
     /* 720821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720824 */     // MIs[0] auxiliary
     /* 720824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720827 */     // MIs[0] Operand 7
     /* 720827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720837 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 720840 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720842 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 720844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720851 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720853 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720859 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720869 */     GIR_RootConstrainSelectedInstOperands,
     /* 720870 */     // GIR_Coverage, 5390,
     /* 720870 */     GIR_EraseRootFromParent_Done,
     /* 720871 */   // Label 9382: @720871
     /* 720871 */   GIM_Try, /*On fail goto*//*Label 9383*/ GIMT_Encode4(720930), // Rule ID 5394 //
     /* 720876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720880 */     // MIs[0] offset
     /* 720880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720883 */     // MIs[0] auxiliary
     /* 720883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720886 */     // MIs[0] Operand 7
     /* 720886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720896 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 720899 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 720901 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 720903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720910 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720912 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720918 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720928 */     GIR_RootConstrainSelectedInstOperands,
     /* 720929 */     // GIR_Coverage, 5394,
     /* 720929 */     GIR_EraseRootFromParent_Done,
     /* 720930 */   // Label 9383: @720930
     /* 720930 */   GIM_Try, /*On fail goto*//*Label 9384*/ GIMT_Encode4(721030), // Rule ID 5391 //
     /* 720935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720938 */     // MIs[0] offset
     /* 720938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720941 */     // MIs[0] auxiliary
     /* 720941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720944 */     // MIs[0] Operand 7
     /* 720944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720954 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 720957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 720961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 720966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 720970 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 720973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 720977 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 720980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 720985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 720998 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 721003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721010 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721012 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721018 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721028 */     GIR_RootConstrainSelectedInstOperands,
     /* 721029 */     // GIR_Coverage, 5391,
     /* 721029 */     GIR_EraseRootFromParent_Done,
     /* 721030 */   // Label 9384: @721030
     /* 721030 */   GIM_Try, /*On fail goto*//*Label 9385*/ GIMT_Encode4(721127), // Rule ID 5395 //
     /* 721035 */     // MIs[0] offset
     /* 721035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721038 */     // MIs[0] auxiliary
     /* 721038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721041 */     // MIs[0] Operand 7
     /* 721041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721051 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 721054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 721058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 721063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 721067 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 721070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 721074 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 721077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 721082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 721095 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 721100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721107 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721109 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721125 */     GIR_RootConstrainSelectedInstOperands,
     /* 721126 */     // GIR_Coverage, 5395,
     /* 721126 */     GIR_EraseRootFromParent_Done,
     /* 721127 */   // Label 9385: @721127
     /* 721127 */   GIM_Reject,
     /* 721128 */ // Label 9377: @721128
     /* 721128 */ GIM_Reject,
     /* 721129 */ // Label 9345: @721129
     /* 721129 */ GIM_Try, /*On fail goto*//*Label 9386*/ GIMT_Encode4(721743),
     /* 721134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 721137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 721140 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 721143 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 721146 */   GIM_Try, /*On fail goto*//*Label 9387*/ GIMT_Encode4(721218), // Rule ID 5396 //
     /* 721151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721162 */     // MIs[0] offset
     /* 721162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721165 */     // MIs[0] auxiliary
     /* 721165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721168 */     // MIs[0] Operand 7
     /* 721168 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721186 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 721189 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721198 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721200 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721216 */     GIR_RootConstrainSelectedInstOperands,
     /* 721217 */     // GIR_Coverage, 5396,
     /* 721217 */     GIR_EraseRootFromParent_Done,
     /* 721218 */   // Label 9387: @721218
     /* 721218 */   GIM_Try, /*On fail goto*//*Label 9388*/ GIMT_Encode4(721287), // Rule ID 5400 //
     /* 721223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721231 */     // MIs[0] offset
     /* 721231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721234 */     // MIs[0] auxiliary
     /* 721234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721237 */     // MIs[0] Operand 7
     /* 721237 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721255 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 721258 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721267 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721269 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721275 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721285 */     GIR_RootConstrainSelectedInstOperands,
     /* 721286 */     // GIR_Coverage, 5400,
     /* 721286 */     GIR_EraseRootFromParent_Done,
     /* 721287 */   // Label 9388: @721287
     /* 721287 */   GIM_Try, /*On fail goto*//*Label 9389*/ GIMT_Encode4(721357), // Rule ID 5397 //
     /* 721292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721299 */     // MIs[0] offset
     /* 721299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721302 */     // MIs[0] auxiliary
     /* 721302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721305 */     // MIs[0] Operand 7
     /* 721305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721323 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 721326 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721328 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 721330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721337 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721339 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721345 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721355 */     GIR_RootConstrainSelectedInstOperands,
     /* 721356 */     // GIR_Coverage, 5397,
     /* 721356 */     GIR_EraseRootFromParent_Done,
     /* 721357 */   // Label 9389: @721357
     /* 721357 */   GIM_Try, /*On fail goto*//*Label 9390*/ GIMT_Encode4(721424), // Rule ID 5401 //
     /* 721362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721366 */     // MIs[0] offset
     /* 721366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721369 */     // MIs[0] auxiliary
     /* 721369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721372 */     // MIs[0] Operand 7
     /* 721372 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721390 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 721393 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721395 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 721397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721404 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721406 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721412 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721422 */     GIR_RootConstrainSelectedInstOperands,
     /* 721423 */     // GIR_Coverage, 5401,
     /* 721423 */     GIR_EraseRootFromParent_Done,
     /* 721424 */   // Label 9390: @721424
     /* 721424 */   GIM_Try, /*On fail goto*//*Label 9391*/ GIMT_Encode4(721486), // Rule ID 5398 //
     /* 721429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721436 */     // MIs[0] offset
     /* 721436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721439 */     // MIs[0] auxiliary
     /* 721439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721442 */     // MIs[0] Operand 7
     /* 721442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721452 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 721455 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721457 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 721459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721466 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721474 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721484 */     GIR_RootConstrainSelectedInstOperands,
     /* 721485 */     // GIR_Coverage, 5398,
     /* 721485 */     GIR_EraseRootFromParent_Done,
     /* 721486 */   // Label 9391: @721486
     /* 721486 */   GIM_Try, /*On fail goto*//*Label 9392*/ GIMT_Encode4(721545), // Rule ID 5402 //
     /* 721491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721495 */     // MIs[0] offset
     /* 721495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721498 */     // MIs[0] auxiliary
     /* 721498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721501 */     // MIs[0] Operand 7
     /* 721501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721511 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 721514 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721516 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 721518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721525 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721527 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721543 */     GIR_RootConstrainSelectedInstOperands,
     /* 721544 */     // GIR_Coverage, 5402,
     /* 721544 */     GIR_EraseRootFromParent_Done,
     /* 721545 */   // Label 9392: @721545
     /* 721545 */   GIM_Try, /*On fail goto*//*Label 9393*/ GIMT_Encode4(721645), // Rule ID 5399 //
     /* 721550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721553 */     // MIs[0] offset
     /* 721553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721556 */     // MIs[0] auxiliary
     /* 721556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721559 */     // MIs[0] Operand 7
     /* 721559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721569 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 721572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 721576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 721581 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 721585 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 721588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 721592 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 721595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 721600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 721613 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 721618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721625 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721627 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721643 */     GIR_RootConstrainSelectedInstOperands,
     /* 721644 */     // GIR_Coverage, 5399,
     /* 721644 */     GIR_EraseRootFromParent_Done,
     /* 721645 */   // Label 9393: @721645
     /* 721645 */   GIM_Try, /*On fail goto*//*Label 9394*/ GIMT_Encode4(721742), // Rule ID 5403 //
     /* 721650 */     // MIs[0] offset
     /* 721650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721653 */     // MIs[0] auxiliary
     /* 721653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721656 */     // MIs[0] Operand 7
     /* 721656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721666 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 721669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 721673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 721678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 721682 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 721685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 721689 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 721692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 721697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 721710 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 721715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721722 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721740 */     GIR_RootConstrainSelectedInstOperands,
     /* 721741 */     // GIR_Coverage, 5403,
     /* 721741 */     GIR_EraseRootFromParent_Done,
     /* 721742 */   // Label 9394: @721742
     /* 721742 */   GIM_Reject,
     /* 721743 */ // Label 9386: @721743
     /* 721743 */ GIM_Reject,
     /* 721744 */ // Label 9346: @721744
     /* 721744 */ GIM_Try, /*On fail goto*//*Label 9395*/ GIMT_Encode4(722358),
     /* 721749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 721752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 721755 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 721758 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 721761 */   GIM_Try, /*On fail goto*//*Label 9396*/ GIMT_Encode4(721833), // Rule ID 5468 //
     /* 721766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721777 */     // MIs[0] offset
     /* 721777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721780 */     // MIs[0] auxiliary
     /* 721780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721783 */     // MIs[0] Operand 7
     /* 721783 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721801 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9819:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 721804 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721813 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721815 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721831 */     GIR_RootConstrainSelectedInstOperands,
     /* 721832 */     // GIR_Coverage, 5468,
     /* 721832 */     GIR_EraseRootFromParent_Done,
     /* 721833 */   // Label 9396: @721833
     /* 721833 */   GIM_Try, /*On fail goto*//*Label 9397*/ GIMT_Encode4(721902), // Rule ID 5472 //
     /* 721838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721846 */     // MIs[0] offset
     /* 721846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721849 */     // MIs[0] auxiliary
     /* 721849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721852 */     // MIs[0] Operand 7
     /* 721852 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721870 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9819:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 721873 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721882 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721884 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721890 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721900 */     GIR_RootConstrainSelectedInstOperands,
     /* 721901 */     // GIR_Coverage, 5472,
     /* 721901 */     GIR_EraseRootFromParent_Done,
     /* 721902 */   // Label 9397: @721902
     /* 721902 */   GIM_Try, /*On fail goto*//*Label 9398*/ GIMT_Encode4(721972), // Rule ID 5469 //
     /* 721907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721914 */     // MIs[0] offset
     /* 721914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721917 */     // MIs[0] auxiliary
     /* 721917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721920 */     // MIs[0] Operand 7
     /* 721920 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721938 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 721941 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 721943 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 721945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721952 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721954 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721960 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721970 */     GIR_RootConstrainSelectedInstOperands,
     /* 721971 */     // GIR_Coverage, 5469,
     /* 721971 */     GIR_EraseRootFromParent_Done,
     /* 721972 */   // Label 9398: @721972
     /* 721972 */   GIM_Try, /*On fail goto*//*Label 9399*/ GIMT_Encode4(722039), // Rule ID 5473 //
     /* 721977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721981 */     // MIs[0] offset
     /* 721981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721984 */     // MIs[0] auxiliary
     /* 721984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721987 */     // MIs[0] Operand 7
     /* 721987 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722005 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 722008 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722010 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 722012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722019 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722021 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722027 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722037 */     GIR_RootConstrainSelectedInstOperands,
     /* 722038 */     // GIR_Coverage, 5473,
     /* 722038 */     GIR_EraseRootFromParent_Done,
     /* 722039 */   // Label 9399: @722039
     /* 722039 */   GIM_Try, /*On fail goto*//*Label 9400*/ GIMT_Encode4(722101), // Rule ID 5470 //
     /* 722044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722051 */     // MIs[0] offset
     /* 722051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722054 */     // MIs[0] auxiliary
     /* 722054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722057 */     // MIs[0] Operand 7
     /* 722057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722067 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 722070 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722072 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 722074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722081 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722083 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722089 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722099 */     GIR_RootConstrainSelectedInstOperands,
     /* 722100 */     // GIR_Coverage, 5470,
     /* 722100 */     GIR_EraseRootFromParent_Done,
     /* 722101 */   // Label 9400: @722101
     /* 722101 */   GIM_Try, /*On fail goto*//*Label 9401*/ GIMT_Encode4(722160), // Rule ID 5474 //
     /* 722106 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722110 */     // MIs[0] offset
     /* 722110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722113 */     // MIs[0] auxiliary
     /* 722113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722116 */     // MIs[0] Operand 7
     /* 722116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722126 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 722129 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722131 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 722133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722140 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722142 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722148 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722158 */     GIR_RootConstrainSelectedInstOperands,
     /* 722159 */     // GIR_Coverage, 5474,
     /* 722159 */     GIR_EraseRootFromParent_Done,
     /* 722160 */   // Label 9401: @722160
     /* 722160 */   GIM_Try, /*On fail goto*//*Label 9402*/ GIMT_Encode4(722260), // Rule ID 5471 //
     /* 722165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722168 */     // MIs[0] offset
     /* 722168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722171 */     // MIs[0] auxiliary
     /* 722171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722174 */     // MIs[0] Operand 7
     /* 722174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722184 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9819:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 722187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 722191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 722196 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 722200 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 722203 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 722207 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 722210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 722215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 722228 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 722233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722240 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722242 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722248 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722258 */     GIR_RootConstrainSelectedInstOperands,
     /* 722259 */     // GIR_Coverage, 5471,
     /* 722259 */     GIR_EraseRootFromParent_Done,
     /* 722260 */   // Label 9402: @722260
     /* 722260 */   GIM_Try, /*On fail goto*//*Label 9403*/ GIMT_Encode4(722357), // Rule ID 5475 //
     /* 722265 */     // MIs[0] offset
     /* 722265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722268 */     // MIs[0] auxiliary
     /* 722268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722271 */     // MIs[0] Operand 7
     /* 722271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722281 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 722284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 722288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 722293 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 722297 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 722300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 722304 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 722307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 722312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 722325 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 722330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722337 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722339 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722345 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722355 */     GIR_RootConstrainSelectedInstOperands,
     /* 722356 */     // GIR_Coverage, 5475,
     /* 722356 */     GIR_EraseRootFromParent_Done,
     /* 722357 */   // Label 9403: @722357
     /* 722357 */   GIM_Reject,
     /* 722358 */ // Label 9395: @722358
     /* 722358 */ GIM_Reject,
     /* 722359 */ // Label 9347: @722359
     /* 722359 */ GIM_Try, /*On fail goto*//*Label 9404*/ GIMT_Encode4(722973),
     /* 722364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 722367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 722370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 722373 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 722376 */   GIM_Try, /*On fail goto*//*Label 9405*/ GIMT_Encode4(722448), // Rule ID 5404 //
     /* 722381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 722388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722392 */     // MIs[0] offset
     /* 722392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722395 */     // MIs[0] auxiliary
     /* 722395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722398 */     // MIs[0] Operand 7
     /* 722398 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722416 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 722419 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722428 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722446 */     GIR_RootConstrainSelectedInstOperands,
     /* 722447 */     // GIR_Coverage, 5404,
     /* 722447 */     GIR_EraseRootFromParent_Done,
     /* 722448 */   // Label 9405: @722448
     /* 722448 */   GIM_Try, /*On fail goto*//*Label 9406*/ GIMT_Encode4(722517), // Rule ID 5408 //
     /* 722453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 722457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722461 */     // MIs[0] offset
     /* 722461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722464 */     // MIs[0] auxiliary
     /* 722464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722467 */     // MIs[0] Operand 7
     /* 722467 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722485 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 722488 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722497 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722505 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722515 */     GIR_RootConstrainSelectedInstOperands,
     /* 722516 */     // GIR_Coverage, 5408,
     /* 722516 */     GIR_EraseRootFromParent_Done,
     /* 722517 */   // Label 9406: @722517
     /* 722517 */   GIM_Try, /*On fail goto*//*Label 9407*/ GIMT_Encode4(722587), // Rule ID 5405 //
     /* 722522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 722529 */     // MIs[0] offset
     /* 722529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722532 */     // MIs[0] auxiliary
     /* 722532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722535 */     // MIs[0] Operand 7
     /* 722535 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722553 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 722556 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722558 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 722560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722567 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722569 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722575 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722585 */     GIR_RootConstrainSelectedInstOperands,
     /* 722586 */     // GIR_Coverage, 5405,
     /* 722586 */     GIR_EraseRootFromParent_Done,
     /* 722587 */   // Label 9407: @722587
     /* 722587 */   GIM_Try, /*On fail goto*//*Label 9408*/ GIMT_Encode4(722654), // Rule ID 5409 //
     /* 722592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 722596 */     // MIs[0] offset
     /* 722596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722599 */     // MIs[0] auxiliary
     /* 722599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722602 */     // MIs[0] Operand 7
     /* 722602 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722620 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 722623 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722625 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 722627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722634 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722636 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722642 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722652 */     GIR_RootConstrainSelectedInstOperands,
     /* 722653 */     // GIR_Coverage, 5409,
     /* 722653 */     GIR_EraseRootFromParent_Done,
     /* 722654 */   // Label 9408: @722654
     /* 722654 */   GIM_Try, /*On fail goto*//*Label 9409*/ GIMT_Encode4(722716), // Rule ID 5406 //
     /* 722659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722666 */     // MIs[0] offset
     /* 722666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722669 */     // MIs[0] auxiliary
     /* 722669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722672 */     // MIs[0] Operand 7
     /* 722672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722682 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 722685 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722687 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 722689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722696 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722698 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722714 */     GIR_RootConstrainSelectedInstOperands,
     /* 722715 */     // GIR_Coverage, 5406,
     /* 722715 */     GIR_EraseRootFromParent_Done,
     /* 722716 */   // Label 9409: @722716
     /* 722716 */   GIM_Try, /*On fail goto*//*Label 9410*/ GIMT_Encode4(722775), // Rule ID 5410 //
     /* 722721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722725 */     // MIs[0] offset
     /* 722725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722728 */     // MIs[0] auxiliary
     /* 722728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722731 */     // MIs[0] Operand 7
     /* 722731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722741 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 722744 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722746 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 722748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722755 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722757 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722763 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722773 */     GIR_RootConstrainSelectedInstOperands,
     /* 722774 */     // GIR_Coverage, 5410,
     /* 722774 */     GIR_EraseRootFromParent_Done,
     /* 722775 */   // Label 9410: @722775
     /* 722775 */   GIM_Try, /*On fail goto*//*Label 9411*/ GIMT_Encode4(722875), // Rule ID 5407 //
     /* 722780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722783 */     // MIs[0] offset
     /* 722783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722786 */     // MIs[0] auxiliary
     /* 722786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722789 */     // MIs[0] Operand 7
     /* 722789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722799 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 722802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 722806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 722811 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 722815 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 722818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 722822 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 722825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 722830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 722843 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 722848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722855 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722863 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722873 */     GIR_RootConstrainSelectedInstOperands,
     /* 722874 */     // GIR_Coverage, 5407,
     /* 722874 */     GIR_EraseRootFromParent_Done,
     /* 722875 */   // Label 9411: @722875
     /* 722875 */   GIM_Try, /*On fail goto*//*Label 9412*/ GIMT_Encode4(722972), // Rule ID 5411 //
     /* 722880 */     // MIs[0] offset
     /* 722880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722883 */     // MIs[0] auxiliary
     /* 722883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722886 */     // MIs[0] Operand 7
     /* 722886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722896 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 722899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 722903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 722908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 722912 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 722915 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 722919 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 722922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 722927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 722940 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 722942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 722945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722952 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722954 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722960 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722970 */     GIR_RootConstrainSelectedInstOperands,
     /* 722971 */     // GIR_Coverage, 5411,
     /* 722971 */     GIR_EraseRootFromParent_Done,
     /* 722972 */   // Label 9412: @722972
     /* 722972 */   GIM_Reject,
     /* 722973 */ // Label 9404: @722973
     /* 722973 */ GIM_Reject,
     /* 722974 */ // Label 9348: @722974
     /* 722974 */ GIM_Try, /*On fail goto*//*Label 9413*/ GIMT_Encode4(723588),
     /* 722979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 722982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 722985 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 722988 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 722991 */   GIM_Try, /*On fail goto*//*Label 9414*/ GIMT_Encode4(723063), // Rule ID 5412 //
     /* 722996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723003 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723007 */     // MIs[0] offset
     /* 723007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723010 */     // MIs[0] auxiliary
     /* 723010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723013 */     // MIs[0] Operand 7
     /* 723013 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723031 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 723034 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723043 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723051 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723061 */     GIR_RootConstrainSelectedInstOperands,
     /* 723062 */     // GIR_Coverage, 5412,
     /* 723062 */     GIR_EraseRootFromParent_Done,
     /* 723063 */   // Label 9414: @723063
     /* 723063 */   GIM_Try, /*On fail goto*//*Label 9415*/ GIMT_Encode4(723132), // Rule ID 5416 //
     /* 723068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723076 */     // MIs[0] offset
     /* 723076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723079 */     // MIs[0] auxiliary
     /* 723079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723082 */     // MIs[0] Operand 7
     /* 723082 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723100 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 723103 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723112 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723114 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723120 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723130 */     GIR_RootConstrainSelectedInstOperands,
     /* 723131 */     // GIR_Coverage, 5416,
     /* 723131 */     GIR_EraseRootFromParent_Done,
     /* 723132 */   // Label 9415: @723132
     /* 723132 */   GIM_Try, /*On fail goto*//*Label 9416*/ GIMT_Encode4(723202), // Rule ID 5413 //
     /* 723137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723144 */     // MIs[0] offset
     /* 723144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723147 */     // MIs[0] auxiliary
     /* 723147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723150 */     // MIs[0] Operand 7
     /* 723150 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723168 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 723171 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723173 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 723175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723182 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723184 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723190 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723200 */     GIR_RootConstrainSelectedInstOperands,
     /* 723201 */     // GIR_Coverage, 5413,
     /* 723201 */     GIR_EraseRootFromParent_Done,
     /* 723202 */   // Label 9416: @723202
     /* 723202 */   GIM_Try, /*On fail goto*//*Label 9417*/ GIMT_Encode4(723269), // Rule ID 5417 //
     /* 723207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723211 */     // MIs[0] offset
     /* 723211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723214 */     // MIs[0] auxiliary
     /* 723214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723217 */     // MIs[0] Operand 7
     /* 723217 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723235 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 723238 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723240 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 723242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723249 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723251 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723257 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723267 */     GIR_RootConstrainSelectedInstOperands,
     /* 723268 */     // GIR_Coverage, 5417,
     /* 723268 */     GIR_EraseRootFromParent_Done,
     /* 723269 */   // Label 9417: @723269
     /* 723269 */   GIM_Try, /*On fail goto*//*Label 9418*/ GIMT_Encode4(723331), // Rule ID 5414 //
     /* 723274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723281 */     // MIs[0] offset
     /* 723281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723284 */     // MIs[0] auxiliary
     /* 723284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723287 */     // MIs[0] Operand 7
     /* 723287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723297 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 723300 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723302 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 723304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723311 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723313 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723319 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723329 */     GIR_RootConstrainSelectedInstOperands,
     /* 723330 */     // GIR_Coverage, 5414,
     /* 723330 */     GIR_EraseRootFromParent_Done,
     /* 723331 */   // Label 9418: @723331
     /* 723331 */   GIM_Try, /*On fail goto*//*Label 9419*/ GIMT_Encode4(723390), // Rule ID 5418 //
     /* 723336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723340 */     // MIs[0] offset
     /* 723340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723343 */     // MIs[0] auxiliary
     /* 723343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723346 */     // MIs[0] Operand 7
     /* 723346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723356 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 723359 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723361 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 723363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723370 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723372 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723378 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723388 */     GIR_RootConstrainSelectedInstOperands,
     /* 723389 */     // GIR_Coverage, 5418,
     /* 723389 */     GIR_EraseRootFromParent_Done,
     /* 723390 */   // Label 9419: @723390
     /* 723390 */   GIM_Try, /*On fail goto*//*Label 9420*/ GIMT_Encode4(723490), // Rule ID 5415 //
     /* 723395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723398 */     // MIs[0] offset
     /* 723398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723401 */     // MIs[0] auxiliary
     /* 723401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723404 */     // MIs[0] Operand 7
     /* 723404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723414 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 723417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 723421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 723426 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 723430 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 723433 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 723437 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 723440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 723445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 723458 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 723463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723470 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723472 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723478 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723488 */     GIR_RootConstrainSelectedInstOperands,
     /* 723489 */     // GIR_Coverage, 5415,
     /* 723489 */     GIR_EraseRootFromParent_Done,
     /* 723490 */   // Label 9420: @723490
     /* 723490 */   GIM_Try, /*On fail goto*//*Label 9421*/ GIMT_Encode4(723587), // Rule ID 5419 //
     /* 723495 */     // MIs[0] offset
     /* 723495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723498 */     // MIs[0] auxiliary
     /* 723498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723501 */     // MIs[0] Operand 7
     /* 723501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723511 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 723514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 723518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 723523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 723527 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 723530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 723534 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 723537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 723542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 723555 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 723560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723567 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723569 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723575 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723585 */     GIR_RootConstrainSelectedInstOperands,
     /* 723586 */     // GIR_Coverage, 5419,
     /* 723586 */     GIR_EraseRootFromParent_Done,
     /* 723587 */   // Label 9421: @723587
     /* 723587 */   GIM_Reject,
     /* 723588 */ // Label 9413: @723588
     /* 723588 */ GIM_Reject,
     /* 723589 */ // Label 9349: @723589
     /* 723589 */ GIM_Try, /*On fail goto*//*Label 9422*/ GIMT_Encode4(724799),
     /* 723594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 723597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 723600 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 723603 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 723606 */   GIM_Try, /*On fail goto*//*Label 9423*/ GIMT_Encode4(723678), // Rule ID 5356 //
     /* 723611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723622 */     // MIs[0] offset
     /* 723622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723625 */     // MIs[0] auxiliary
     /* 723625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723628 */     // MIs[0] Operand 7
     /* 723628 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723646 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 723649 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723658 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723660 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723666 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723676 */     GIR_RootConstrainSelectedInstOperands,
     /* 723677 */     // GIR_Coverage, 5356,
     /* 723677 */     GIR_EraseRootFromParent_Done,
     /* 723678 */   // Label 9423: @723678
     /* 723678 */   GIM_Try, /*On fail goto*//*Label 9424*/ GIMT_Encode4(723747), // Rule ID 5360 //
     /* 723683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723691 */     // MIs[0] offset
     /* 723691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723694 */     // MIs[0] auxiliary
     /* 723694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723697 */     // MIs[0] Operand 7
     /* 723697 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723715 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 723718 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723727 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723729 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723735 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723745 */     GIR_RootConstrainSelectedInstOperands,
     /* 723746 */     // GIR_Coverage, 5360,
     /* 723746 */     GIR_EraseRootFromParent_Done,
     /* 723747 */   // Label 9424: @723747
     /* 723747 */   GIM_Try, /*On fail goto*//*Label 9425*/ GIMT_Encode4(723819), // Rule ID 5364 //
     /* 723752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723763 */     // MIs[0] offset
     /* 723763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723766 */     // MIs[0] auxiliary
     /* 723766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723769 */     // MIs[0] Operand 7
     /* 723769 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723787 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9820:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 723790 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723799 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723801 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723807 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723817 */     GIR_RootConstrainSelectedInstOperands,
     /* 723818 */     // GIR_Coverage, 5364,
     /* 723818 */     GIR_EraseRootFromParent_Done,
     /* 723819 */   // Label 9425: @723819
     /* 723819 */   GIM_Try, /*On fail goto*//*Label 9426*/ GIMT_Encode4(723888), // Rule ID 5368 //
     /* 723824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723832 */     // MIs[0] offset
     /* 723832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723835 */     // MIs[0] auxiliary
     /* 723835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723838 */     // MIs[0] Operand 7
     /* 723838 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723856 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9820:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 723859 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723868 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723870 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723876 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723886 */     GIR_RootConstrainSelectedInstOperands,
     /* 723887 */     // GIR_Coverage, 5368,
     /* 723887 */     GIR_EraseRootFromParent_Done,
     /* 723888 */   // Label 9426: @723888
     /* 723888 */   GIM_Try, /*On fail goto*//*Label 9427*/ GIMT_Encode4(723958), // Rule ID 5357 //
     /* 723893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723900 */     // MIs[0] offset
     /* 723900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723903 */     // MIs[0] auxiliary
     /* 723903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723906 */     // MIs[0] Operand 7
     /* 723906 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723924 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 723927 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723929 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 723931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723938 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723940 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723946 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723956 */     GIR_RootConstrainSelectedInstOperands,
     /* 723957 */     // GIR_Coverage, 5357,
     /* 723957 */     GIR_EraseRootFromParent_Done,
     /* 723958 */   // Label 9427: @723958
     /* 723958 */   GIM_Try, /*On fail goto*//*Label 9428*/ GIMT_Encode4(724025), // Rule ID 5361 //
     /* 723963 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723967 */     // MIs[0] offset
     /* 723967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723970 */     // MIs[0] auxiliary
     /* 723970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723973 */     // MIs[0] Operand 7
     /* 723973 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723991 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 723994 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723996 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 723998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724005 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724007 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724013 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724023 */     GIR_RootConstrainSelectedInstOperands,
     /* 724024 */     // GIR_Coverage, 5361,
     /* 724024 */     GIR_EraseRootFromParent_Done,
     /* 724025 */   // Label 9428: @724025
     /* 724025 */   GIM_Try, /*On fail goto*//*Label 9429*/ GIMT_Encode4(724095), // Rule ID 5365 //
     /* 724030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724037 */     // MIs[0] offset
     /* 724037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724040 */     // MIs[0] auxiliary
     /* 724040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724043 */     // MIs[0] Operand 7
     /* 724043 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724061 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9820:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 724064 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724066 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 724068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724075 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724083 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724093 */     GIR_RootConstrainSelectedInstOperands,
     /* 724094 */     // GIR_Coverage, 5365,
     /* 724094 */     GIR_EraseRootFromParent_Done,
     /* 724095 */   // Label 9429: @724095
     /* 724095 */   GIM_Try, /*On fail goto*//*Label 9430*/ GIMT_Encode4(724162), // Rule ID 5369 //
     /* 724100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724104 */     // MIs[0] offset
     /* 724104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724107 */     // MIs[0] auxiliary
     /* 724107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724110 */     // MIs[0] Operand 7
     /* 724110 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724128 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9820:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 724131 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724133 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 724135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724142 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724144 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724150 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724160 */     GIR_RootConstrainSelectedInstOperands,
     /* 724161 */     // GIR_Coverage, 5369,
     /* 724161 */     GIR_EraseRootFromParent_Done,
     /* 724162 */   // Label 9430: @724162
     /* 724162 */   GIM_Try, /*On fail goto*//*Label 9431*/ GIMT_Encode4(724224), // Rule ID 5358 //
     /* 724167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724174 */     // MIs[0] offset
     /* 724174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724177 */     // MIs[0] auxiliary
     /* 724177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724180 */     // MIs[0] Operand 7
     /* 724180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724190 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 724193 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724195 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 724197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724204 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724212 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724222 */     GIR_RootConstrainSelectedInstOperands,
     /* 724223 */     // GIR_Coverage, 5358,
     /* 724223 */     GIR_EraseRootFromParent_Done,
     /* 724224 */   // Label 9431: @724224
     /* 724224 */   GIM_Try, /*On fail goto*//*Label 9432*/ GIMT_Encode4(724283), // Rule ID 5362 //
     /* 724229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724233 */     // MIs[0] offset
     /* 724233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724236 */     // MIs[0] auxiliary
     /* 724236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724239 */     // MIs[0] Operand 7
     /* 724239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724249 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 724252 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724254 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 724256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724263 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724265 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724281 */     GIR_RootConstrainSelectedInstOperands,
     /* 724282 */     // GIR_Coverage, 5362,
     /* 724282 */     GIR_EraseRootFromParent_Done,
     /* 724283 */   // Label 9432: @724283
     /* 724283 */   GIM_Try, /*On fail goto*//*Label 9433*/ GIMT_Encode4(724345), // Rule ID 5366 //
     /* 724288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724295 */     // MIs[0] offset
     /* 724295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724298 */     // MIs[0] auxiliary
     /* 724298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724301 */     // MIs[0] Operand 7
     /* 724301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724311 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9820:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 724314 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724316 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 724318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724325 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724327 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724333 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724343 */     GIR_RootConstrainSelectedInstOperands,
     /* 724344 */     // GIR_Coverage, 5366,
     /* 724344 */     GIR_EraseRootFromParent_Done,
     /* 724345 */   // Label 9433: @724345
     /* 724345 */   GIM_Try, /*On fail goto*//*Label 9434*/ GIMT_Encode4(724404), // Rule ID 5370 //
     /* 724350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724354 */     // MIs[0] offset
     /* 724354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724357 */     // MIs[0] auxiliary
     /* 724357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724360 */     // MIs[0] Operand 7
     /* 724360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724370 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9820:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 724373 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724375 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 724377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724384 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724386 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724392 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724402 */     GIR_RootConstrainSelectedInstOperands,
     /* 724403 */     // GIR_Coverage, 5370,
     /* 724403 */     GIR_EraseRootFromParent_Done,
     /* 724404 */   // Label 9434: @724404
     /* 724404 */   GIM_Try, /*On fail goto*//*Label 9435*/ GIMT_Encode4(724504), // Rule ID 5359 //
     /* 724409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724412 */     // MIs[0] offset
     /* 724412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724415 */     // MIs[0] auxiliary
     /* 724415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724418 */     // MIs[0] Operand 7
     /* 724418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724428 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 724431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 724435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 724440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 724444 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 724447 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 724451 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 724454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 724459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 724472 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 724477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724484 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724492 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724502 */     GIR_RootConstrainSelectedInstOperands,
     /* 724503 */     // GIR_Coverage, 5359,
     /* 724503 */     GIR_EraseRootFromParent_Done,
     /* 724504 */   // Label 9435: @724504
     /* 724504 */   GIM_Try, /*On fail goto*//*Label 9436*/ GIMT_Encode4(724601), // Rule ID 5363 //
     /* 724509 */     // MIs[0] offset
     /* 724509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724512 */     // MIs[0] auxiliary
     /* 724512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724515 */     // MIs[0] Operand 7
     /* 724515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724525 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 724528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 724532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 724537 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 724541 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 724544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 724548 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 724551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 724556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 724569 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 724574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724581 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724583 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724589 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724599 */     GIR_RootConstrainSelectedInstOperands,
     /* 724600 */     // GIR_Coverage, 5363,
     /* 724600 */     GIR_EraseRootFromParent_Done,
     /* 724601 */   // Label 9436: @724601
     /* 724601 */   GIM_Try, /*On fail goto*//*Label 9437*/ GIMT_Encode4(724701), // Rule ID 5367 //
     /* 724606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724609 */     // MIs[0] offset
     /* 724609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724612 */     // MIs[0] auxiliary
     /* 724612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724615 */     // MIs[0] Operand 7
     /* 724615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724625 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9820:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 724628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 724632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 724637 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 724641 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 724644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 724648 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 724651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 724656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 724669 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 724674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724681 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724683 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724689 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724699 */     GIR_RootConstrainSelectedInstOperands,
     /* 724700 */     // GIR_Coverage, 5367,
     /* 724700 */     GIR_EraseRootFromParent_Done,
     /* 724701 */   // Label 9437: @724701
     /* 724701 */   GIM_Try, /*On fail goto*//*Label 9438*/ GIMT_Encode4(724798), // Rule ID 5371 //
     /* 724706 */     // MIs[0] offset
     /* 724706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724709 */     // MIs[0] auxiliary
     /* 724709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724712 */     // MIs[0] Operand 7
     /* 724712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724722 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 724725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 724729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 724734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 724738 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 724741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 724745 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 724748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 724753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 724766 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 724771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724778 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724786 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724796 */     GIR_RootConstrainSelectedInstOperands,
     /* 724797 */     // GIR_Coverage, 5371,
     /* 724797 */     GIR_EraseRootFromParent_Done,
     /* 724798 */   // Label 9438: @724798
     /* 724798 */   GIM_Reject,
     /* 724799 */ // Label 9422: @724799
     /* 724799 */ GIM_Reject,
     /* 724800 */ // Label 9350: @724800
     /* 724800 */ GIM_Try, /*On fail goto*//*Label 9439*/ GIMT_Encode4(726010),
     /* 724805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 724808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 724811 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 724814 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 724817 */   GIM_Try, /*On fail goto*//*Label 9440*/ GIMT_Encode4(724889), // Rule ID 5420 //
     /* 724822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724833 */     // MIs[0] offset
     /* 724833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724836 */     // MIs[0] auxiliary
     /* 724836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724839 */     // MIs[0] Operand 7
     /* 724839 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724857 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9819:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 724860 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724869 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724871 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724887 */     GIR_RootConstrainSelectedInstOperands,
     /* 724888 */     // GIR_Coverage, 5420,
     /* 724888 */     GIR_EraseRootFromParent_Done,
     /* 724889 */   // Label 9440: @724889
     /* 724889 */   GIM_Try, /*On fail goto*//*Label 9441*/ GIMT_Encode4(724958), // Rule ID 5424 //
     /* 724894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724902 */     // MIs[0] offset
     /* 724902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724905 */     // MIs[0] auxiliary
     /* 724905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724908 */     // MIs[0] Operand 7
     /* 724908 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724926 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9819:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 724929 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724938 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724940 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724946 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724956 */     GIR_RootConstrainSelectedInstOperands,
     /* 724957 */     // GIR_Coverage, 5424,
     /* 724957 */     GIR_EraseRootFromParent_Done,
     /* 724958 */   // Label 9441: @724958
     /* 724958 */   GIM_Try, /*On fail goto*//*Label 9442*/ GIMT_Encode4(725030), // Rule ID 5428 //
     /* 724963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724974 */     // MIs[0] offset
     /* 724974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724977 */     // MIs[0] auxiliary
     /* 724977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724980 */     // MIs[0] Operand 7
     /* 724980 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724998 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9819:{ *:[f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 725001 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725010 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725012 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725018 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725028 */     GIR_RootConstrainSelectedInstOperands,
     /* 725029 */     // GIR_Coverage, 5428,
     /* 725029 */     GIR_EraseRootFromParent_Done,
     /* 725030 */   // Label 9442: @725030
     /* 725030 */   GIM_Try, /*On fail goto*//*Label 9443*/ GIMT_Encode4(725099), // Rule ID 5432 //
     /* 725035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725043 */     // MIs[0] offset
     /* 725043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725046 */     // MIs[0] auxiliary
     /* 725046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725049 */     // MIs[0] Operand 7
     /* 725049 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725067 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9819:{ *:[f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 725070 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725079 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725081 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725087 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725097 */     GIR_RootConstrainSelectedInstOperands,
     /* 725098 */     // GIR_Coverage, 5432,
     /* 725098 */     GIR_EraseRootFromParent_Done,
     /* 725099 */   // Label 9443: @725099
     /* 725099 */   GIM_Try, /*On fail goto*//*Label 9444*/ GIMT_Encode4(725169), // Rule ID 5421 //
     /* 725104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725111 */     // MIs[0] offset
     /* 725111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725114 */     // MIs[0] auxiliary
     /* 725114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725117 */     // MIs[0] Operand 7
     /* 725117 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725135 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 725138 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725140 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 725142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725149 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725151 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725157 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725167 */     GIR_RootConstrainSelectedInstOperands,
     /* 725168 */     // GIR_Coverage, 5421,
     /* 725168 */     GIR_EraseRootFromParent_Done,
     /* 725169 */   // Label 9444: @725169
     /* 725169 */   GIM_Try, /*On fail goto*//*Label 9445*/ GIMT_Encode4(725236), // Rule ID 5425 //
     /* 725174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725178 */     // MIs[0] offset
     /* 725178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725181 */     // MIs[0] auxiliary
     /* 725181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725184 */     // MIs[0] Operand 7
     /* 725184 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725202 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 725205 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725207 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 725209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725216 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725218 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725224 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725234 */     GIR_RootConstrainSelectedInstOperands,
     /* 725235 */     // GIR_Coverage, 5425,
     /* 725235 */     GIR_EraseRootFromParent_Done,
     /* 725236 */   // Label 9445: @725236
     /* 725236 */   GIM_Try, /*On fail goto*//*Label 9446*/ GIMT_Encode4(725306), // Rule ID 5429 //
     /* 725241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725248 */     // MIs[0] offset
     /* 725248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725251 */     // MIs[0] auxiliary
     /* 725251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725254 */     // MIs[0] Operand 7
     /* 725254 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725272 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9819:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 725275 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725277 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 725279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725286 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725288 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725294 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725304 */     GIR_RootConstrainSelectedInstOperands,
     /* 725305 */     // GIR_Coverage, 5429,
     /* 725305 */     GIR_EraseRootFromParent_Done,
     /* 725306 */   // Label 9446: @725306
     /* 725306 */   GIM_Try, /*On fail goto*//*Label 9447*/ GIMT_Encode4(725373), // Rule ID 5433 //
     /* 725311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725315 */     // MIs[0] offset
     /* 725315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725318 */     // MIs[0] auxiliary
     /* 725318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725321 */     // MIs[0] Operand 7
     /* 725321 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725339 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9819:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 725342 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725344 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 725346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725353 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725355 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725361 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725371 */     GIR_RootConstrainSelectedInstOperands,
     /* 725372 */     // GIR_Coverage, 5433,
     /* 725372 */     GIR_EraseRootFromParent_Done,
     /* 725373 */   // Label 9447: @725373
     /* 725373 */   GIM_Try, /*On fail goto*//*Label 9448*/ GIMT_Encode4(725435), // Rule ID 5422 //
     /* 725378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725385 */     // MIs[0] offset
     /* 725385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725388 */     // MIs[0] auxiliary
     /* 725388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725391 */     // MIs[0] Operand 7
     /* 725391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725401 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 725404 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725406 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 725408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725415 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725423 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725433 */     GIR_RootConstrainSelectedInstOperands,
     /* 725434 */     // GIR_Coverage, 5422,
     /* 725434 */     GIR_EraseRootFromParent_Done,
     /* 725435 */   // Label 9448: @725435
     /* 725435 */   GIM_Try, /*On fail goto*//*Label 9449*/ GIMT_Encode4(725494), // Rule ID 5426 //
     /* 725440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725444 */     // MIs[0] offset
     /* 725444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725447 */     // MIs[0] auxiliary
     /* 725447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725450 */     // MIs[0] Operand 7
     /* 725450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725460 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9819:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 725463 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725465 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 725467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725474 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725476 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725482 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725492 */     GIR_RootConstrainSelectedInstOperands,
     /* 725493 */     // GIR_Coverage, 5426,
     /* 725493 */     GIR_EraseRootFromParent_Done,
     /* 725494 */   // Label 9449: @725494
     /* 725494 */   GIM_Try, /*On fail goto*//*Label 9450*/ GIMT_Encode4(725556), // Rule ID 5430 //
     /* 725499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725506 */     // MIs[0] offset
     /* 725506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725509 */     // MIs[0] auxiliary
     /* 725509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725512 */     // MIs[0] Operand 7
     /* 725512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725522 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9819:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 725525 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725527 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 725529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725536 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725538 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725544 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725554 */     GIR_RootConstrainSelectedInstOperands,
     /* 725555 */     // GIR_Coverage, 5430,
     /* 725555 */     GIR_EraseRootFromParent_Done,
     /* 725556 */   // Label 9450: @725556
     /* 725556 */   GIM_Try, /*On fail goto*//*Label 9451*/ GIMT_Encode4(725615), // Rule ID 5434 //
     /* 725561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725565 */     // MIs[0] offset
     /* 725565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725568 */     // MIs[0] auxiliary
     /* 725568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725571 */     // MIs[0] Operand 7
     /* 725571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725581 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9819:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 725584 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725586 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 725588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725595 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725597 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725603 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725613 */     GIR_RootConstrainSelectedInstOperands,
     /* 725614 */     // GIR_Coverage, 5434,
     /* 725614 */     GIR_EraseRootFromParent_Done,
     /* 725615 */   // Label 9451: @725615
     /* 725615 */   GIM_Try, /*On fail goto*//*Label 9452*/ GIMT_Encode4(725715), // Rule ID 5423 //
     /* 725620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725623 */     // MIs[0] offset
     /* 725623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725626 */     // MIs[0] auxiliary
     /* 725626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725629 */     // MIs[0] Operand 7
     /* 725629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725639 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9819:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 725642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 725646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 725651 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 725655 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 725658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 725662 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 725665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 725670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 725683 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 725688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725695 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725697 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725713 */     GIR_RootConstrainSelectedInstOperands,
     /* 725714 */     // GIR_Coverage, 5423,
     /* 725714 */     GIR_EraseRootFromParent_Done,
     /* 725715 */   // Label 9452: @725715
     /* 725715 */   GIM_Try, /*On fail goto*//*Label 9453*/ GIMT_Encode4(725812), // Rule ID 5427 //
     /* 725720 */     // MIs[0] offset
     /* 725720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725723 */     // MIs[0] auxiliary
     /* 725723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725726 */     // MIs[0] Operand 7
     /* 725726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725736 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 725739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 725743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 725748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 725752 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 725755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 725759 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 725762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 725767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 725780 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 725785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725792 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725794 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725800 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725810 */     GIR_RootConstrainSelectedInstOperands,
     /* 725811 */     // GIR_Coverage, 5427,
     /* 725811 */     GIR_EraseRootFromParent_Done,
     /* 725812 */   // Label 9453: @725812
     /* 725812 */   GIM_Try, /*On fail goto*//*Label 9454*/ GIMT_Encode4(725912), // Rule ID 5431 //
     /* 725817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725820 */     // MIs[0] offset
     /* 725820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725823 */     // MIs[0] auxiliary
     /* 725823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725826 */     // MIs[0] Operand 7
     /* 725826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725836 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9819:{ *:[f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 725839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 725843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 725848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 725852 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 725855 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 725859 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 725862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 725867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 725880 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 725885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725892 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725894 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725900 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725910 */     GIR_RootConstrainSelectedInstOperands,
     /* 725911 */     // GIR_Coverage, 5431,
     /* 725911 */     GIR_EraseRootFromParent_Done,
     /* 725912 */   // Label 9454: @725912
     /* 725912 */   GIM_Try, /*On fail goto*//*Label 9455*/ GIMT_Encode4(726009), // Rule ID 5435 //
     /* 725917 */     // MIs[0] offset
     /* 725917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725920 */     // MIs[0] auxiliary
     /* 725920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725923 */     // MIs[0] Operand 7
     /* 725923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725933 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 725936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 725940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 725945 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 725949 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 725952 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 725956 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 725959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 725964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 725977 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 725982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725989 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725991 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725997 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726007 */     GIR_RootConstrainSelectedInstOperands,
     /* 726008 */     // GIR_Coverage, 5435,
     /* 726008 */     GIR_EraseRootFromParent_Done,
     /* 726009 */   // Label 9455: @726009
     /* 726009 */   GIM_Reject,
     /* 726010 */ // Label 9439: @726010
     /* 726010 */ GIM_Reject,
     /* 726011 */ // Label 9351: @726011
     /* 726011 */ GIM_Try, /*On fail goto*//*Label 9456*/ GIMT_Encode4(727221),
     /* 726016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 726019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 726022 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 726025 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 726028 */   GIM_Try, /*On fail goto*//*Label 9457*/ GIMT_Encode4(726100), // Rule ID 5372 //
     /* 726033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726044 */     // MIs[0] offset
     /* 726044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726047 */     // MIs[0] auxiliary
     /* 726047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726050 */     // MIs[0] Operand 7
     /* 726050 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726068 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9820:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 726071 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726080 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726088 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726098 */     GIR_RootConstrainSelectedInstOperands,
     /* 726099 */     // GIR_Coverage, 5372,
     /* 726099 */     GIR_EraseRootFromParent_Done,
     /* 726100 */   // Label 9457: @726100
     /* 726100 */   GIM_Try, /*On fail goto*//*Label 9458*/ GIMT_Encode4(726169), // Rule ID 5376 //
     /* 726105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726113 */     // MIs[0] offset
     /* 726113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726116 */     // MIs[0] auxiliary
     /* 726116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726119 */     // MIs[0] Operand 7
     /* 726119 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726137 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9820:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 726140 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726149 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726151 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726157 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726167 */     GIR_RootConstrainSelectedInstOperands,
     /* 726168 */     // GIR_Coverage, 5376,
     /* 726168 */     GIR_EraseRootFromParent_Done,
     /* 726169 */   // Label 9458: @726169
     /* 726169 */   GIM_Try, /*On fail goto*//*Label 9459*/ GIMT_Encode4(726241), // Rule ID 5380 //
     /* 726174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726185 */     // MIs[0] offset
     /* 726185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726188 */     // MIs[0] auxiliary
     /* 726188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726191 */     // MIs[0] Operand 7
     /* 726191 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726209 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9820:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 726212 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726221 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726223 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726229 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726239 */     GIR_RootConstrainSelectedInstOperands,
     /* 726240 */     // GIR_Coverage, 5380,
     /* 726240 */     GIR_EraseRootFromParent_Done,
     /* 726241 */   // Label 9459: @726241
     /* 726241 */   GIM_Try, /*On fail goto*//*Label 9460*/ GIMT_Encode4(726310), // Rule ID 5384 //
     /* 726246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726254 */     // MIs[0] offset
     /* 726254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726257 */     // MIs[0] auxiliary
     /* 726257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726260 */     // MIs[0] Operand 7
     /* 726260 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726278 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9820:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 726281 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726290 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726292 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726298 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726308 */     GIR_RootConstrainSelectedInstOperands,
     /* 726309 */     // GIR_Coverage, 5384,
     /* 726309 */     GIR_EraseRootFromParent_Done,
     /* 726310 */   // Label 9460: @726310
     /* 726310 */   GIM_Try, /*On fail goto*//*Label 9461*/ GIMT_Encode4(726380), // Rule ID 5373 //
     /* 726315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726322 */     // MIs[0] offset
     /* 726322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726325 */     // MIs[0] auxiliary
     /* 726325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726328 */     // MIs[0] Operand 7
     /* 726328 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726346 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9820:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 726349 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726351 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 726353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726360 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726368 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726378 */     GIR_RootConstrainSelectedInstOperands,
     /* 726379 */     // GIR_Coverage, 5373,
     /* 726379 */     GIR_EraseRootFromParent_Done,
     /* 726380 */   // Label 9461: @726380
     /* 726380 */   GIM_Try, /*On fail goto*//*Label 9462*/ GIMT_Encode4(726447), // Rule ID 5377 //
     /* 726385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726389 */     // MIs[0] offset
     /* 726389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726392 */     // MIs[0] auxiliary
     /* 726392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726395 */     // MIs[0] Operand 7
     /* 726395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726413 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9820:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 726416 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726418 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 726420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726427 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726429 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726435 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726445 */     GIR_RootConstrainSelectedInstOperands,
     /* 726446 */     // GIR_Coverage, 5377,
     /* 726446 */     GIR_EraseRootFromParent_Done,
     /* 726447 */   // Label 9462: @726447
     /* 726447 */   GIM_Try, /*On fail goto*//*Label 9463*/ GIMT_Encode4(726517), // Rule ID 5381 //
     /* 726452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726459 */     // MIs[0] offset
     /* 726459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726462 */     // MIs[0] auxiliary
     /* 726462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726465 */     // MIs[0] Operand 7
     /* 726465 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726483 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 726486 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726488 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 726490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726497 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726505 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726515 */     GIR_RootConstrainSelectedInstOperands,
     /* 726516 */     // GIR_Coverage, 5381,
     /* 726516 */     GIR_EraseRootFromParent_Done,
     /* 726517 */   // Label 9463: @726517
     /* 726517 */   GIM_Try, /*On fail goto*//*Label 9464*/ GIMT_Encode4(726584), // Rule ID 5385 //
     /* 726522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726526 */     // MIs[0] offset
     /* 726526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726529 */     // MIs[0] auxiliary
     /* 726529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726532 */     // MIs[0] Operand 7
     /* 726532 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726550 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 726553 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726555 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 726557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726564 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726566 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726572 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726582 */     GIR_RootConstrainSelectedInstOperands,
     /* 726583 */     // GIR_Coverage, 5385,
     /* 726583 */     GIR_EraseRootFromParent_Done,
     /* 726584 */   // Label 9464: @726584
     /* 726584 */   GIM_Try, /*On fail goto*//*Label 9465*/ GIMT_Encode4(726646), // Rule ID 5374 //
     /* 726589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726596 */     // MIs[0] offset
     /* 726596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726599 */     // MIs[0] auxiliary
     /* 726599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726602 */     // MIs[0] Operand 7
     /* 726602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726612 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9820:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 726615 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726617 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 726619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726626 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726628 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726634 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726644 */     GIR_RootConstrainSelectedInstOperands,
     /* 726645 */     // GIR_Coverage, 5374,
     /* 726645 */     GIR_EraseRootFromParent_Done,
     /* 726646 */   // Label 9465: @726646
     /* 726646 */   GIM_Try, /*On fail goto*//*Label 9466*/ GIMT_Encode4(726705), // Rule ID 5378 //
     /* 726651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726655 */     // MIs[0] offset
     /* 726655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726658 */     // MIs[0] auxiliary
     /* 726658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726661 */     // MIs[0] Operand 7
     /* 726661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726671 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9820:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 726674 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726676 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 726678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726685 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726687 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726703 */     GIR_RootConstrainSelectedInstOperands,
     /* 726704 */     // GIR_Coverage, 5378,
     /* 726704 */     GIR_EraseRootFromParent_Done,
     /* 726705 */   // Label 9466: @726705
     /* 726705 */   GIM_Try, /*On fail goto*//*Label 9467*/ GIMT_Encode4(726767), // Rule ID 5382 //
     /* 726710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726713 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726717 */     // MIs[0] offset
     /* 726717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726720 */     // MIs[0] auxiliary
     /* 726720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726723 */     // MIs[0] Operand 7
     /* 726723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726733 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 726736 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726738 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 726740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726747 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726749 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726755 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726765 */     GIR_RootConstrainSelectedInstOperands,
     /* 726766 */     // GIR_Coverage, 5382,
     /* 726766 */     GIR_EraseRootFromParent_Done,
     /* 726767 */   // Label 9467: @726767
     /* 726767 */   GIM_Try, /*On fail goto*//*Label 9468*/ GIMT_Encode4(726826), // Rule ID 5386 //
     /* 726772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726776 */     // MIs[0] offset
     /* 726776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726779 */     // MIs[0] auxiliary
     /* 726779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726782 */     // MIs[0] Operand 7
     /* 726782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726792 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 726795 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726797 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 726799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726806 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726824 */     GIR_RootConstrainSelectedInstOperands,
     /* 726825 */     // GIR_Coverage, 5386,
     /* 726825 */     GIR_EraseRootFromParent_Done,
     /* 726826 */   // Label 9468: @726826
     /* 726826 */   GIM_Try, /*On fail goto*//*Label 9469*/ GIMT_Encode4(726926), // Rule ID 5375 //
     /* 726831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726834 */     // MIs[0] offset
     /* 726834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726837 */     // MIs[0] auxiliary
     /* 726837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726840 */     // MIs[0] Operand 7
     /* 726840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726850 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9820:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 726853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 726857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 726862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 726866 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 726869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 726873 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 726876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 726881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 726894 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 726899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726906 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726908 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726914 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726924 */     GIR_RootConstrainSelectedInstOperands,
     /* 726925 */     // GIR_Coverage, 5375,
     /* 726925 */     GIR_EraseRootFromParent_Done,
     /* 726926 */   // Label 9469: @726926
     /* 726926 */   GIM_Try, /*On fail goto*//*Label 9470*/ GIMT_Encode4(727023), // Rule ID 5379 //
     /* 726931 */     // MIs[0] offset
     /* 726931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726934 */     // MIs[0] auxiliary
     /* 726934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726937 */     // MIs[0] Operand 7
     /* 726937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726947 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 726950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 726954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 726959 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 726963 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 726966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 726970 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 726973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 726978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 726991 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 726996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727003 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727005 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727011 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727021 */     GIR_RootConstrainSelectedInstOperands,
     /* 727022 */     // GIR_Coverage, 5379,
     /* 727022 */     GIR_EraseRootFromParent_Done,
     /* 727023 */   // Label 9470: @727023
     /* 727023 */   GIM_Try, /*On fail goto*//*Label 9471*/ GIMT_Encode4(727123), // Rule ID 5383 //
     /* 727028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727031 */     // MIs[0] offset
     /* 727031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727034 */     // MIs[0] auxiliary
     /* 727034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727037 */     // MIs[0] Operand 7
     /* 727037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727047 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 727050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 727054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 727059 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 727063 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 727066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 727070 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 727073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 727078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 727091 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 727096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727103 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727111 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727121 */     GIR_RootConstrainSelectedInstOperands,
     /* 727122 */     // GIR_Coverage, 5383,
     /* 727122 */     GIR_EraseRootFromParent_Done,
     /* 727123 */   // Label 9471: @727123
     /* 727123 */   GIM_Try, /*On fail goto*//*Label 9472*/ GIMT_Encode4(727220), // Rule ID 5387 //
     /* 727128 */     // MIs[0] offset
     /* 727128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727131 */     // MIs[0] auxiliary
     /* 727131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727134 */     // MIs[0] Operand 7
     /* 727134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727144 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 727147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 727151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 727156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 727160 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 727163 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 727167 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 727170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 727175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 727188 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 727193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727200 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727202 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727208 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727218 */     GIR_RootConstrainSelectedInstOperands,
     /* 727219 */     // GIR_Coverage, 5387,
     /* 727219 */     GIR_EraseRootFromParent_Done,
     /* 727220 */   // Label 9472: @727220
     /* 727220 */   GIM_Reject,
     /* 727221 */ // Label 9456: @727221
     /* 727221 */ GIM_Reject,
     /* 727222 */ // Label 9352: @727222
     /* 727222 */ GIM_Try, /*On fail goto*//*Label 9473*/ GIMT_Encode4(728432),
     /* 727227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 727230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 727233 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 727236 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 727239 */   GIM_Try, /*On fail goto*//*Label 9474*/ GIMT_Encode4(727311), // Rule ID 5436 //
     /* 727244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727247 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727251 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727255 */     // MIs[0] offset
     /* 727255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727258 */     // MIs[0] auxiliary
     /* 727258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727261 */     // MIs[0] Operand 7
     /* 727261 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727279 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9819:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 727282 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727291 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727293 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727299 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727309 */     GIR_RootConstrainSelectedInstOperands,
     /* 727310 */     // GIR_Coverage, 5436,
     /* 727310 */     GIR_EraseRootFromParent_Done,
     /* 727311 */   // Label 9474: @727311
     /* 727311 */   GIM_Try, /*On fail goto*//*Label 9475*/ GIMT_Encode4(727380), // Rule ID 5440 //
     /* 727316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727324 */     // MIs[0] offset
     /* 727324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727327 */     // MIs[0] auxiliary
     /* 727327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727330 */     // MIs[0] Operand 7
     /* 727330 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727348 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9819:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 727351 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727360 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727368 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727378 */     GIR_RootConstrainSelectedInstOperands,
     /* 727379 */     // GIR_Coverage, 5440,
     /* 727379 */     GIR_EraseRootFromParent_Done,
     /* 727380 */   // Label 9475: @727380
     /* 727380 */   GIM_Try, /*On fail goto*//*Label 9476*/ GIMT_Encode4(727452), // Rule ID 5444 //
     /* 727385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727396 */     // MIs[0] offset
     /* 727396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727399 */     // MIs[0] auxiliary
     /* 727399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727402 */     // MIs[0] Operand 7
     /* 727402 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727420 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9819:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 727423 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727432 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727434 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727440 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727450 */     GIR_RootConstrainSelectedInstOperands,
     /* 727451 */     // GIR_Coverage, 5444,
     /* 727451 */     GIR_EraseRootFromParent_Done,
     /* 727452 */   // Label 9476: @727452
     /* 727452 */   GIM_Try, /*On fail goto*//*Label 9477*/ GIMT_Encode4(727521), // Rule ID 5448 //
     /* 727457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727465 */     // MIs[0] offset
     /* 727465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727468 */     // MIs[0] auxiliary
     /* 727468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727471 */     // MIs[0] Operand 7
     /* 727471 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727489 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9819:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 727492 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727501 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727503 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727509 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727519 */     GIR_RootConstrainSelectedInstOperands,
     /* 727520 */     // GIR_Coverage, 5448,
     /* 727520 */     GIR_EraseRootFromParent_Done,
     /* 727521 */   // Label 9477: @727521
     /* 727521 */   GIM_Try, /*On fail goto*//*Label 9478*/ GIMT_Encode4(727591), // Rule ID 5437 //
     /* 727526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727533 */     // MIs[0] offset
     /* 727533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727536 */     // MIs[0] auxiliary
     /* 727536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727539 */     // MIs[0] Operand 7
     /* 727539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727557 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 727560 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727562 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 727564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727571 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727573 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727579 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727589 */     GIR_RootConstrainSelectedInstOperands,
     /* 727590 */     // GIR_Coverage, 5437,
     /* 727590 */     GIR_EraseRootFromParent_Done,
     /* 727591 */   // Label 9478: @727591
     /* 727591 */   GIM_Try, /*On fail goto*//*Label 9479*/ GIMT_Encode4(727658), // Rule ID 5441 //
     /* 727596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727600 */     // MIs[0] offset
     /* 727600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727603 */     // MIs[0] auxiliary
     /* 727603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727606 */     // MIs[0] Operand 7
     /* 727606 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727624 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 727627 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727629 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 727631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727638 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727656 */     GIR_RootConstrainSelectedInstOperands,
     /* 727657 */     // GIR_Coverage, 5441,
     /* 727657 */     GIR_EraseRootFromParent_Done,
     /* 727658 */   // Label 9479: @727658
     /* 727658 */   GIM_Try, /*On fail goto*//*Label 9480*/ GIMT_Encode4(727728), // Rule ID 5445 //
     /* 727663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727670 */     // MIs[0] offset
     /* 727670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727673 */     // MIs[0] auxiliary
     /* 727673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727676 */     // MIs[0] Operand 7
     /* 727676 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727694 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 727697 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727699 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 727701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727708 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727716 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727726 */     GIR_RootConstrainSelectedInstOperands,
     /* 727727 */     // GIR_Coverage, 5445,
     /* 727727 */     GIR_EraseRootFromParent_Done,
     /* 727728 */   // Label 9480: @727728
     /* 727728 */   GIM_Try, /*On fail goto*//*Label 9481*/ GIMT_Encode4(727795), // Rule ID 5449 //
     /* 727733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727737 */     // MIs[0] offset
     /* 727737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727740 */     // MIs[0] auxiliary
     /* 727740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727743 */     // MIs[0] Operand 7
     /* 727743 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727761 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 727764 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727766 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 727768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727775 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727783 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727793 */     GIR_RootConstrainSelectedInstOperands,
     /* 727794 */     // GIR_Coverage, 5449,
     /* 727794 */     GIR_EraseRootFromParent_Done,
     /* 727795 */   // Label 9481: @727795
     /* 727795 */   GIM_Try, /*On fail goto*//*Label 9482*/ GIMT_Encode4(727857), // Rule ID 5438 //
     /* 727800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727807 */     // MIs[0] offset
     /* 727807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727810 */     // MIs[0] auxiliary
     /* 727810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727813 */     // MIs[0] Operand 7
     /* 727813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727823 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 727826 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727828 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 727830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727837 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727839 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727845 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727855 */     GIR_RootConstrainSelectedInstOperands,
     /* 727856 */     // GIR_Coverage, 5438,
     /* 727856 */     GIR_EraseRootFromParent_Done,
     /* 727857 */   // Label 9482: @727857
     /* 727857 */   GIM_Try, /*On fail goto*//*Label 9483*/ GIMT_Encode4(727916), // Rule ID 5442 //
     /* 727862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727866 */     // MIs[0] offset
     /* 727866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727869 */     // MIs[0] auxiliary
     /* 727869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727872 */     // MIs[0] Operand 7
     /* 727872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727882 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 727885 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727887 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 727889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727896 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727898 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727904 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727914 */     GIR_RootConstrainSelectedInstOperands,
     /* 727915 */     // GIR_Coverage, 5442,
     /* 727915 */     GIR_EraseRootFromParent_Done,
     /* 727916 */   // Label 9483: @727916
     /* 727916 */   GIM_Try, /*On fail goto*//*Label 9484*/ GIMT_Encode4(727978), // Rule ID 5446 //
     /* 727921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727928 */     // MIs[0] offset
     /* 727928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727931 */     // MIs[0] auxiliary
     /* 727931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727934 */     // MIs[0] Operand 7
     /* 727934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727944 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 727947 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727949 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 727951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727958 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727960 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727966 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727976 */     GIR_RootConstrainSelectedInstOperands,
     /* 727977 */     // GIR_Coverage, 5446,
     /* 727977 */     GIR_EraseRootFromParent_Done,
     /* 727978 */   // Label 9484: @727978
     /* 727978 */   GIM_Try, /*On fail goto*//*Label 9485*/ GIMT_Encode4(728037), // Rule ID 5450 //
     /* 727983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727987 */     // MIs[0] offset
     /* 727987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727990 */     // MIs[0] auxiliary
     /* 727990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727993 */     // MIs[0] Operand 7
     /* 727993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728003 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 728006 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728008 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 728010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728017 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728019 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728025 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728035 */     GIR_RootConstrainSelectedInstOperands,
     /* 728036 */     // GIR_Coverage, 5450,
     /* 728036 */     GIR_EraseRootFromParent_Done,
     /* 728037 */   // Label 9485: @728037
     /* 728037 */   GIM_Try, /*On fail goto*//*Label 9486*/ GIMT_Encode4(728137), // Rule ID 5439 //
     /* 728042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728045 */     // MIs[0] offset
     /* 728045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728048 */     // MIs[0] auxiliary
     /* 728048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728051 */     // MIs[0] Operand 7
     /* 728051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728061 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 728064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 728068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 728073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 728077 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 728080 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 728084 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 728087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 728092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 728105 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 728110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728117 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728119 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728125 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728135 */     GIR_RootConstrainSelectedInstOperands,
     /* 728136 */     // GIR_Coverage, 5439,
     /* 728136 */     GIR_EraseRootFromParent_Done,
     /* 728137 */   // Label 9486: @728137
     /* 728137 */   GIM_Try, /*On fail goto*//*Label 9487*/ GIMT_Encode4(728234), // Rule ID 5443 //
     /* 728142 */     // MIs[0] offset
     /* 728142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728145 */     // MIs[0] auxiliary
     /* 728145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728148 */     // MIs[0] Operand 7
     /* 728148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728158 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 728161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 728165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 728170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 728174 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 728177 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 728181 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 728184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 728189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 728202 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 728207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728214 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728216 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728222 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728232 */     GIR_RootConstrainSelectedInstOperands,
     /* 728233 */     // GIR_Coverage, 5443,
     /* 728233 */     GIR_EraseRootFromParent_Done,
     /* 728234 */   // Label 9487: @728234
     /* 728234 */   GIM_Try, /*On fail goto*//*Label 9488*/ GIMT_Encode4(728334), // Rule ID 5447 //
     /* 728239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728242 */     // MIs[0] offset
     /* 728242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728245 */     // MIs[0] auxiliary
     /* 728245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728248 */     // MIs[0] Operand 7
     /* 728248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728258 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 728261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 728265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 728270 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 728274 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 728277 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 728281 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 728284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 728289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 728302 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 728307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728314 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728316 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728322 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728332 */     GIR_RootConstrainSelectedInstOperands,
     /* 728333 */     // GIR_Coverage, 5447,
     /* 728333 */     GIR_EraseRootFromParent_Done,
     /* 728334 */   // Label 9488: @728334
     /* 728334 */   GIM_Try, /*On fail goto*//*Label 9489*/ GIMT_Encode4(728431), // Rule ID 5451 //
     /* 728339 */     // MIs[0] offset
     /* 728339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728342 */     // MIs[0] auxiliary
     /* 728342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728345 */     // MIs[0] Operand 7
     /* 728345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728355 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 728358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 728362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 728367 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 728371 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 728374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 728378 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 728381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 728386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 728399 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 728404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728411 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728413 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728429 */     GIR_RootConstrainSelectedInstOperands,
     /* 728430 */     // GIR_Coverage, 5451,
     /* 728430 */     GIR_EraseRootFromParent_Done,
     /* 728431 */   // Label 9489: @728431
     /* 728431 */   GIM_Reject,
     /* 728432 */ // Label 9473: @728432
     /* 728432 */ GIM_Reject,
     /* 728433 */ // Label 9353: @728433
     /* 728433 */ GIM_Try, /*On fail goto*//*Label 9490*/ GIMT_Encode4(729643),
     /* 728438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 728441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 728444 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 728447 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 728450 */   GIM_Try, /*On fail goto*//*Label 9491*/ GIMT_Encode4(728522), // Rule ID 5524 //
     /* 728455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728466 */     // MIs[0] offset
     /* 728466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728469 */     // MIs[0] auxiliary
     /* 728469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728472 */     // MIs[0] Operand 7
     /* 728472 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728490 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9817:{ *:[v2i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 728493 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728502 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728504 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728510 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728520 */     GIR_RootConstrainSelectedInstOperands,
     /* 728521 */     // GIR_Coverage, 5524,
     /* 728521 */     GIR_EraseRootFromParent_Done,
     /* 728522 */   // Label 9491: @728522
     /* 728522 */   GIM_Try, /*On fail goto*//*Label 9492*/ GIMT_Encode4(728591), // Rule ID 5528 //
     /* 728527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728535 */     // MIs[0] offset
     /* 728535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728538 */     // MIs[0] auxiliary
     /* 728538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728541 */     // MIs[0] Operand 7
     /* 728541 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728559 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9817:{ *:[v2i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 728562 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728571 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728573 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728579 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728589 */     GIR_RootConstrainSelectedInstOperands,
     /* 728590 */     // GIR_Coverage, 5528,
     /* 728590 */     GIR_EraseRootFromParent_Done,
     /* 728591 */   // Label 9492: @728591
     /* 728591 */   GIM_Try, /*On fail goto*//*Label 9493*/ GIMT_Encode4(728663), // Rule ID 5532 //
     /* 728596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728607 */     // MIs[0] offset
     /* 728607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728610 */     // MIs[0] auxiliary
     /* 728610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728613 */     // MIs[0] Operand 7
     /* 728613 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728631 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9817:{ *:[v2f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 728634 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728643 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728645 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728651 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728661 */     GIR_RootConstrainSelectedInstOperands,
     /* 728662 */     // GIR_Coverage, 5532,
     /* 728662 */     GIR_EraseRootFromParent_Done,
     /* 728663 */   // Label 9493: @728663
     /* 728663 */   GIM_Try, /*On fail goto*//*Label 9494*/ GIMT_Encode4(728732), // Rule ID 5536 //
     /* 728668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728676 */     // MIs[0] offset
     /* 728676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728679 */     // MIs[0] auxiliary
     /* 728679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728682 */     // MIs[0] Operand 7
     /* 728682 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728700 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9817:{ *:[v2f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 728703 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728712 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728714 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728720 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728730 */     GIR_RootConstrainSelectedInstOperands,
     /* 728731 */     // GIR_Coverage, 5536,
     /* 728731 */     GIR_EraseRootFromParent_Done,
     /* 728732 */   // Label 9494: @728732
     /* 728732 */   GIM_Try, /*On fail goto*//*Label 9495*/ GIMT_Encode4(728802), // Rule ID 5525 //
     /* 728737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728744 */     // MIs[0] offset
     /* 728744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728747 */     // MIs[0] auxiliary
     /* 728747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728750 */     // MIs[0] Operand 7
     /* 728750 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728768 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9817:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 728771 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728773 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 728775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728782 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728784 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728790 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728800 */     GIR_RootConstrainSelectedInstOperands,
     /* 728801 */     // GIR_Coverage, 5525,
     /* 728801 */     GIR_EraseRootFromParent_Done,
     /* 728802 */   // Label 9495: @728802
     /* 728802 */   GIM_Try, /*On fail goto*//*Label 9496*/ GIMT_Encode4(728869), // Rule ID 5529 //
     /* 728807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728811 */     // MIs[0] offset
     /* 728811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728814 */     // MIs[0] auxiliary
     /* 728814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728817 */     // MIs[0] Operand 7
     /* 728817 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728835 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9817:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 728838 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728840 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 728842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728849 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728851 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728867 */     GIR_RootConstrainSelectedInstOperands,
     /* 728868 */     // GIR_Coverage, 5529,
     /* 728868 */     GIR_EraseRootFromParent_Done,
     /* 728869 */   // Label 9496: @728869
     /* 728869 */   GIM_Try, /*On fail goto*//*Label 9497*/ GIMT_Encode4(728939), // Rule ID 5533 //
     /* 728874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728881 */     // MIs[0] offset
     /* 728881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728884 */     // MIs[0] auxiliary
     /* 728884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728887 */     // MIs[0] Operand 7
     /* 728887 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728905 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9817:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 728908 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728910 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 728912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728919 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728921 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728927 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728937 */     GIR_RootConstrainSelectedInstOperands,
     /* 728938 */     // GIR_Coverage, 5533,
     /* 728938 */     GIR_EraseRootFromParent_Done,
     /* 728939 */   // Label 9497: @728939
     /* 728939 */   GIM_Try, /*On fail goto*//*Label 9498*/ GIMT_Encode4(729006), // Rule ID 5537 //
     /* 728944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728948 */     // MIs[0] offset
     /* 728948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728951 */     // MIs[0] auxiliary
     /* 728951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728954 */     // MIs[0] Operand 7
     /* 728954 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728972 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9817:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 728975 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728977 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 728979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728986 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728988 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729004 */     GIR_RootConstrainSelectedInstOperands,
     /* 729005 */     // GIR_Coverage, 5537,
     /* 729005 */     GIR_EraseRootFromParent_Done,
     /* 729006 */   // Label 9498: @729006
     /* 729006 */   GIM_Try, /*On fail goto*//*Label 9499*/ GIMT_Encode4(729068), // Rule ID 5526 //
     /* 729011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729018 */     // MIs[0] offset
     /* 729018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729021 */     // MIs[0] auxiliary
     /* 729021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729024 */     // MIs[0] Operand 7
     /* 729024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729034 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9817:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 729037 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729039 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 729041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729048 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729050 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729056 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729066 */     GIR_RootConstrainSelectedInstOperands,
     /* 729067 */     // GIR_Coverage, 5526,
     /* 729067 */     GIR_EraseRootFromParent_Done,
     /* 729068 */   // Label 9499: @729068
     /* 729068 */   GIM_Try, /*On fail goto*//*Label 9500*/ GIMT_Encode4(729127), // Rule ID 5530 //
     /* 729073 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729077 */     // MIs[0] offset
     /* 729077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729080 */     // MIs[0] auxiliary
     /* 729080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729083 */     // MIs[0] Operand 7
     /* 729083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729093 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9817:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 729096 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729098 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 729100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729107 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729109 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729125 */     GIR_RootConstrainSelectedInstOperands,
     /* 729126 */     // GIR_Coverage, 5530,
     /* 729126 */     GIR_EraseRootFromParent_Done,
     /* 729127 */   // Label 9500: @729127
     /* 729127 */   GIM_Try, /*On fail goto*//*Label 9501*/ GIMT_Encode4(729189), // Rule ID 5534 //
     /* 729132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729139 */     // MIs[0] offset
     /* 729139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729142 */     // MIs[0] auxiliary
     /* 729142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729145 */     // MIs[0] Operand 7
     /* 729145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729155 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9817:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 729158 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729160 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 729162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729169 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729171 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729177 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729187 */     GIR_RootConstrainSelectedInstOperands,
     /* 729188 */     // GIR_Coverage, 5534,
     /* 729188 */     GIR_EraseRootFromParent_Done,
     /* 729189 */   // Label 9501: @729189
     /* 729189 */   GIM_Try, /*On fail goto*//*Label 9502*/ GIMT_Encode4(729248), // Rule ID 5538 //
     /* 729194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729198 */     // MIs[0] offset
     /* 729198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729201 */     // MIs[0] auxiliary
     /* 729201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729204 */     // MIs[0] Operand 7
     /* 729204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729214 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9817:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 729217 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729219 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 729221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729228 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729230 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729236 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729246 */     GIR_RootConstrainSelectedInstOperands,
     /* 729247 */     // GIR_Coverage, 5538,
     /* 729247 */     GIR_EraseRootFromParent_Done,
     /* 729248 */   // Label 9502: @729248
     /* 729248 */   GIM_Try, /*On fail goto*//*Label 9503*/ GIMT_Encode4(729348), // Rule ID 5527 //
     /* 729253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729256 */     // MIs[0] offset
     /* 729256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729259 */     // MIs[0] auxiliary
     /* 729259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729262 */     // MIs[0] Operand 7
     /* 729262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729272 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9817:{ *:[v2i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 729275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 729279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 729284 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 729288 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 729291 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 729295 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 729298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 729303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 729316 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 729321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729328 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729330 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729336 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729346 */     GIR_RootConstrainSelectedInstOperands,
     /* 729347 */     // GIR_Coverage, 5527,
     /* 729347 */     GIR_EraseRootFromParent_Done,
     /* 729348 */   // Label 9503: @729348
     /* 729348 */   GIM_Try, /*On fail goto*//*Label 9504*/ GIMT_Encode4(729445), // Rule ID 5531 //
     /* 729353 */     // MIs[0] offset
     /* 729353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729356 */     // MIs[0] auxiliary
     /* 729356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729359 */     // MIs[0] Operand 7
     /* 729359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729369 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9817:{ *:[v2i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 729372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 729376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 729381 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 729385 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 729388 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 729392 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 729395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 729400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 729413 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 729418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729425 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729427 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729433 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729443 */     GIR_RootConstrainSelectedInstOperands,
     /* 729444 */     // GIR_Coverage, 5531,
     /* 729444 */     GIR_EraseRootFromParent_Done,
     /* 729445 */   // Label 9504: @729445
     /* 729445 */   GIM_Try, /*On fail goto*//*Label 9505*/ GIMT_Encode4(729545), // Rule ID 5535 //
     /* 729450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729453 */     // MIs[0] offset
     /* 729453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729456 */     // MIs[0] auxiliary
     /* 729456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729459 */     // MIs[0] Operand 7
     /* 729459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729469 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9817:{ *:[v2f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 729472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 729476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 729481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 729485 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 729488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 729492 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 729495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 729500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 729513 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 729518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729525 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729527 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729543 */     GIR_RootConstrainSelectedInstOperands,
     /* 729544 */     // GIR_Coverage, 5535,
     /* 729544 */     GIR_EraseRootFromParent_Done,
     /* 729545 */   // Label 9505: @729545
     /* 729545 */   GIM_Try, /*On fail goto*//*Label 9506*/ GIMT_Encode4(729642), // Rule ID 5539 //
     /* 729550 */     // MIs[0] offset
     /* 729550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729553 */     // MIs[0] auxiliary
     /* 729553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729556 */     // MIs[0] Operand 7
     /* 729556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729566 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9817:{ *:[v2f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 729569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 729573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 729578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 729582 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 729585 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 729589 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 729592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 729597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 729610 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 729615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729622 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729624 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729640 */     GIR_RootConstrainSelectedInstOperands,
     /* 729641 */     // GIR_Coverage, 5539,
     /* 729641 */     GIR_EraseRootFromParent_Done,
     /* 729642 */   // Label 9506: @729642
     /* 729642 */   GIM_Reject,
     /* 729643 */ // Label 9490: @729643
     /* 729643 */ GIM_Reject,
     /* 729644 */ // Label 9354: @729644
     /* 729644 */ GIM_Try, /*On fail goto*//*Label 9507*/ GIMT_Encode4(730854),
     /* 729649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 729652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 729655 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 729658 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 729661 */   GIM_Try, /*On fail goto*//*Label 9508*/ GIMT_Encode4(729733), // Rule ID 5492 //
     /* 729666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729677 */     // MIs[0] offset
     /* 729677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729680 */     // MIs[0] auxiliary
     /* 729680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729683 */     // MIs[0] Operand 7
     /* 729683 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729701 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFSET_exact anonymous_9818:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET_exact),
     /* 729704 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729713 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729715 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729721 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729731 */     GIR_RootConstrainSelectedInstOperands,
     /* 729732 */     // GIR_Coverage, 5492,
     /* 729732 */     GIR_EraseRootFromParent_Done,
     /* 729733 */   // Label 9508: @729733
     /* 729733 */   GIM_Try, /*On fail goto*//*Label 9509*/ GIMT_Encode4(729802), // Rule ID 5496 //
     /* 729738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729746 */     // MIs[0] offset
     /* 729746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729749 */     // MIs[0] auxiliary
     /* 729749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729752 */     // MIs[0] Operand 7
     /* 729752 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729770 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact anonymous_9818:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact),
     /* 729773 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729782 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729784 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729790 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729800 */     GIR_RootConstrainSelectedInstOperands,
     /* 729801 */     // GIR_Coverage, 5496,
     /* 729801 */     GIR_EraseRootFromParent_Done,
     /* 729802 */   // Label 9509: @729802
     /* 729802 */   GIM_Try, /*On fail goto*//*Label 9510*/ GIMT_Encode4(729874), // Rule ID 5500 //
     /* 729807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729818 */     // MIs[0] offset
     /* 729818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729821 */     // MIs[0] auxiliary
     /* 729821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729824 */     // MIs[0] Operand 7
     /* 729824 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729842 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFSET_exact anonymous_9818:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET_exact),
     /* 729845 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729854 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729856 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729862 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729872 */     GIR_RootConstrainSelectedInstOperands,
     /* 729873 */     // GIR_Coverage, 5500,
     /* 729873 */     GIR_EraseRootFromParent_Done,
     /* 729874 */   // Label 9510: @729874
     /* 729874 */   GIM_Try, /*On fail goto*//*Label 9511*/ GIMT_Encode4(729943), // Rule ID 5504 //
     /* 729879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729887 */     // MIs[0] offset
     /* 729887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729890 */     // MIs[0] auxiliary
     /* 729890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729893 */     // MIs[0] Operand 7
     /* 729893 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729911 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact anonymous_9818:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact),
     /* 729914 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729923 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729931 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729941 */     GIR_RootConstrainSelectedInstOperands,
     /* 729942 */     // GIR_Coverage, 5504,
     /* 729942 */     GIR_EraseRootFromParent_Done,
     /* 729943 */   // Label 9511: @729943
     /* 729943 */   GIM_Try, /*On fail goto*//*Label 9512*/ GIMT_Encode4(730013), // Rule ID 5493 //
     /* 729948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729955 */     // MIs[0] offset
     /* 729955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729958 */     // MIs[0] auxiliary
     /* 729958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729961 */     // MIs[0] Operand 7
     /* 729961 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729979 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFEN_exact),
     /* 729982 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729984 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 729986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729993 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729995 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730001 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730011 */     GIR_RootConstrainSelectedInstOperands,
     /* 730012 */     // GIR_Coverage, 5493,
     /* 730012 */     GIR_EraseRootFromParent_Done,
     /* 730013 */   // Label 9512: @730013
     /* 730013 */   GIM_Try, /*On fail goto*//*Label 9513*/ GIMT_Encode4(730080), // Rule ID 5497 //
     /* 730018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730022 */     // MIs[0] offset
     /* 730022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730025 */     // MIs[0] auxiliary
     /* 730025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730028 */     // MIs[0] Operand 7
     /* 730028 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730046 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact),
     /* 730049 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730051 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 730053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730060 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730062 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730068 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730078 */     GIR_RootConstrainSelectedInstOperands,
     /* 730079 */     // GIR_Coverage, 5497,
     /* 730079 */     GIR_EraseRootFromParent_Done,
     /* 730080 */   // Label 9513: @730080
     /* 730080 */   GIM_Try, /*On fail goto*//*Label 9514*/ GIMT_Encode4(730150), // Rule ID 5501 //
     /* 730085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730092 */     // MIs[0] offset
     /* 730092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730095 */     // MIs[0] auxiliary
     /* 730095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730098 */     // MIs[0] Operand 7
     /* 730098 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730116 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFEN_exact),
     /* 730119 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730121 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 730123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730130 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730132 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730138 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730148 */     GIR_RootConstrainSelectedInstOperands,
     /* 730149 */     // GIR_Coverage, 5501,
     /* 730149 */     GIR_EraseRootFromParent_Done,
     /* 730150 */   // Label 9514: @730150
     /* 730150 */   GIM_Try, /*On fail goto*//*Label 9515*/ GIMT_Encode4(730217), // Rule ID 5505 //
     /* 730155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730159 */     // MIs[0] offset
     /* 730159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730162 */     // MIs[0] auxiliary
     /* 730162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730165 */     // MIs[0] Operand 7
     /* 730165 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730183 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact),
     /* 730186 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730188 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 730190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730197 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730199 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730205 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730215 */     GIR_RootConstrainSelectedInstOperands,
     /* 730216 */     // GIR_Coverage, 5505,
     /* 730216 */     GIR_EraseRootFromParent_Done,
     /* 730217 */   // Label 9515: @730217
     /* 730217 */   GIM_Try, /*On fail goto*//*Label 9516*/ GIMT_Encode4(730279), // Rule ID 5494 //
     /* 730222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730229 */     // MIs[0] offset
     /* 730229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730232 */     // MIs[0] auxiliary
     /* 730232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730235 */     // MIs[0] Operand 7
     /* 730235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730245 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_IDXEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_IDXEN_exact),
     /* 730248 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730250 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 730252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730259 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730261 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730277 */     GIR_RootConstrainSelectedInstOperands,
     /* 730278 */     // GIR_Coverage, 5494,
     /* 730278 */     GIR_EraseRootFromParent_Done,
     /* 730279 */   // Label 9516: @730279
     /* 730279 */   GIM_Try, /*On fail goto*//*Label 9517*/ GIMT_Encode4(730338), // Rule ID 5498 //
     /* 730284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730288 */     // MIs[0] offset
     /* 730288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730291 */     // MIs[0] auxiliary
     /* 730291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730294 */     // MIs[0] Operand 7
     /* 730294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730304 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact),
     /* 730307 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730309 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 730311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730318 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730320 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730326 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730336 */     GIR_RootConstrainSelectedInstOperands,
     /* 730337 */     // GIR_Coverage, 5498,
     /* 730337 */     GIR_EraseRootFromParent_Done,
     /* 730338 */   // Label 9517: @730338
     /* 730338 */   GIM_Try, /*On fail goto*//*Label 9518*/ GIMT_Encode4(730400), // Rule ID 5502 //
     /* 730343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730350 */     // MIs[0] offset
     /* 730350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730353 */     // MIs[0] auxiliary
     /* 730353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730356 */     // MIs[0] Operand 7
     /* 730356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730366 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_IDXEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_IDXEN_exact),
     /* 730369 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730371 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 730373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730380 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730382 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730388 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730398 */     GIR_RootConstrainSelectedInstOperands,
     /* 730399 */     // GIR_Coverage, 5502,
     /* 730399 */     GIR_EraseRootFromParent_Done,
     /* 730400 */   // Label 9518: @730400
     /* 730400 */   GIM_Try, /*On fail goto*//*Label 9519*/ GIMT_Encode4(730459), // Rule ID 5506 //
     /* 730405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730409 */     // MIs[0] offset
     /* 730409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730412 */     // MIs[0] auxiliary
     /* 730412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730415 */     // MIs[0] Operand 7
     /* 730415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730425 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact),
     /* 730428 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730430 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 730432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730439 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730441 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730447 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730457 */     GIR_RootConstrainSelectedInstOperands,
     /* 730458 */     // GIR_Coverage, 5506,
     /* 730458 */     GIR_EraseRootFromParent_Done,
     /* 730459 */   // Label 9519: @730459
     /* 730459 */   GIM_Try, /*On fail goto*//*Label 9520*/ GIMT_Encode4(730559), // Rule ID 5495 //
     /* 730464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730467 */     // MIs[0] offset
     /* 730467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730470 */     // MIs[0] auxiliary
     /* 730470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730473 */     // MIs[0] Operand 7
     /* 730473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730483 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_BOTHEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 730486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 730490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 730495 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 730499 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 730502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 730506 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 730509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 730514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_BOTHEN_exact),
     /* 730527 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 730532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730539 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730541 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730547 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730557 */     GIR_RootConstrainSelectedInstOperands,
     /* 730558 */     // GIR_Coverage, 5495,
     /* 730558 */     GIR_EraseRootFromParent_Done,
     /* 730559 */   // Label 9520: @730559
     /* 730559 */   GIM_Try, /*On fail goto*//*Label 9521*/ GIMT_Encode4(730656), // Rule ID 5499 //
     /* 730564 */     // MIs[0] offset
     /* 730564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730567 */     // MIs[0] auxiliary
     /* 730567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730570 */     // MIs[0] Operand 7
     /* 730570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730580 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 730583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 730587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 730592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 730596 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 730599 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 730603 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 730606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 730611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact),
     /* 730624 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 730629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730636 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730638 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730644 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730654 */     GIR_RootConstrainSelectedInstOperands,
     /* 730655 */     // GIR_Coverage, 5499,
     /* 730655 */     GIR_EraseRootFromParent_Done,
     /* 730656 */   // Label 9521: @730656
     /* 730656 */   GIM_Try, /*On fail goto*//*Label 9522*/ GIMT_Encode4(730756), // Rule ID 5503 //
     /* 730661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730664 */     // MIs[0] offset
     /* 730664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730667 */     // MIs[0] auxiliary
     /* 730667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730670 */     // MIs[0] Operand 7
     /* 730670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730680 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_BOTHEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 730683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 730687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 730692 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 730696 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 730699 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 730703 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 730706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 730711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_BOTHEN_exact),
     /* 730724 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 730729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730736 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730738 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730754 */     GIR_RootConstrainSelectedInstOperands,
     /* 730755 */     // GIR_Coverage, 5503,
     /* 730755 */     GIR_EraseRootFromParent_Done,
     /* 730756 */   // Label 9522: @730756
     /* 730756 */   GIM_Try, /*On fail goto*//*Label 9523*/ GIMT_Encode4(730853), // Rule ID 5507 //
     /* 730761 */     // MIs[0] offset
     /* 730761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730764 */     // MIs[0] auxiliary
     /* 730764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730767 */     // MIs[0] Operand 7
     /* 730767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730777 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 730780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 730784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 730789 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 730793 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 730796 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 730800 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 730803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 730808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact),
     /* 730821 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 730826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730833 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730835 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730841 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730851 */     GIR_RootConstrainSelectedInstOperands,
     /* 730852 */     // GIR_Coverage, 5507,
     /* 730852 */     GIR_EraseRootFromParent_Done,
     /* 730853 */   // Label 9523: @730853
     /* 730853 */   GIM_Reject,
     /* 730854 */ // Label 9507: @730854
     /* 730854 */ GIM_Reject,
     /* 730855 */ // Label 9355: @730855
     /* 730855 */ GIM_Try, /*On fail goto*//*Label 9524*/ GIMT_Encode4(732065),
     /* 730860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 730863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 730866 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 730869 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 730872 */   GIM_Try, /*On fail goto*//*Label 9525*/ GIMT_Encode4(730944), // Rule ID 5476 //
     /* 730877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730888 */     // MIs[0] offset
     /* 730888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730891 */     // MIs[0] auxiliary
     /* 730891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730894 */     // MIs[0] Operand 7
     /* 730894 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730912 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9819:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 730915 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730924 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730932 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730942 */     GIR_RootConstrainSelectedInstOperands,
     /* 730943 */     // GIR_Coverage, 5476,
     /* 730943 */     GIR_EraseRootFromParent_Done,
     /* 730944 */   // Label 9525: @730944
     /* 730944 */   GIM_Try, /*On fail goto*//*Label 9526*/ GIMT_Encode4(731013), // Rule ID 5480 //
     /* 730949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730957 */     // MIs[0] offset
     /* 730957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730960 */     // MIs[0] auxiliary
     /* 730960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730963 */     // MIs[0] Operand 7
     /* 730963 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730981 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9819:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 730984 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730993 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730995 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731001 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731011 */     GIR_RootConstrainSelectedInstOperands,
     /* 731012 */     // GIR_Coverage, 5480,
     /* 731012 */     GIR_EraseRootFromParent_Done,
     /* 731013 */   // Label 9526: @731013
     /* 731013 */   GIM_Try, /*On fail goto*//*Label 9527*/ GIMT_Encode4(731085), // Rule ID 5484 //
     /* 731018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731029 */     // MIs[0] offset
     /* 731029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731032 */     // MIs[0] auxiliary
     /* 731032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731035 */     // MIs[0] Operand 7
     /* 731035 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731053 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9819:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 731056 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731065 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731067 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731073 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731083 */     GIR_RootConstrainSelectedInstOperands,
     /* 731084 */     // GIR_Coverage, 5484,
     /* 731084 */     GIR_EraseRootFromParent_Done,
     /* 731085 */   // Label 9527: @731085
     /* 731085 */   GIM_Try, /*On fail goto*//*Label 9528*/ GIMT_Encode4(731154), // Rule ID 5488 //
     /* 731090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731098 */     // MIs[0] offset
     /* 731098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731101 */     // MIs[0] auxiliary
     /* 731101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731104 */     // MIs[0] Operand 7
     /* 731104 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731122 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9819:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 731125 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731134 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731136 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731142 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731152 */     GIR_RootConstrainSelectedInstOperands,
     /* 731153 */     // GIR_Coverage, 5488,
     /* 731153 */     GIR_EraseRootFromParent_Done,
     /* 731154 */   // Label 9528: @731154
     /* 731154 */   GIM_Try, /*On fail goto*//*Label 9529*/ GIMT_Encode4(731224), // Rule ID 5477 //
     /* 731159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731166 */     // MIs[0] offset
     /* 731166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731169 */     // MIs[0] auxiliary
     /* 731169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731172 */     // MIs[0] Operand 7
     /* 731172 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731190 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9819:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 731193 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731195 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 731197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731204 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731212 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731222 */     GIR_RootConstrainSelectedInstOperands,
     /* 731223 */     // GIR_Coverage, 5477,
     /* 731223 */     GIR_EraseRootFromParent_Done,
     /* 731224 */   // Label 9529: @731224
     /* 731224 */   GIM_Try, /*On fail goto*//*Label 9530*/ GIMT_Encode4(731291), // Rule ID 5481 //
     /* 731229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731233 */     // MIs[0] offset
     /* 731233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731236 */     // MIs[0] auxiliary
     /* 731236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731239 */     // MIs[0] Operand 7
     /* 731239 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731257 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9819:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 731260 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731262 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 731264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731271 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731273 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731279 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731289 */     GIR_RootConstrainSelectedInstOperands,
     /* 731290 */     // GIR_Coverage, 5481,
     /* 731290 */     GIR_EraseRootFromParent_Done,
     /* 731291 */   // Label 9530: @731291
     /* 731291 */   GIM_Try, /*On fail goto*//*Label 9531*/ GIMT_Encode4(731361), // Rule ID 5485 //
     /* 731296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731303 */     // MIs[0] offset
     /* 731303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731306 */     // MIs[0] auxiliary
     /* 731306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731309 */     // MIs[0] Operand 7
     /* 731309 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731327 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 731330 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731332 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 731334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731341 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731343 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731349 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731359 */     GIR_RootConstrainSelectedInstOperands,
     /* 731360 */     // GIR_Coverage, 5485,
     /* 731360 */     GIR_EraseRootFromParent_Done,
     /* 731361 */   // Label 9531: @731361
     /* 731361 */   GIM_Try, /*On fail goto*//*Label 9532*/ GIMT_Encode4(731428), // Rule ID 5489 //
     /* 731366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731370 */     // MIs[0] offset
     /* 731370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731373 */     // MIs[0] auxiliary
     /* 731373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731376 */     // MIs[0] Operand 7
     /* 731376 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731394 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 731397 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731399 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 731401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731408 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731426 */     GIR_RootConstrainSelectedInstOperands,
     /* 731427 */     // GIR_Coverage, 5489,
     /* 731427 */     GIR_EraseRootFromParent_Done,
     /* 731428 */   // Label 9532: @731428
     /* 731428 */   GIM_Try, /*On fail goto*//*Label 9533*/ GIMT_Encode4(731490), // Rule ID 5478 //
     /* 731433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731440 */     // MIs[0] offset
     /* 731440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731443 */     // MIs[0] auxiliary
     /* 731443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731446 */     // MIs[0] Operand 7
     /* 731446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731456 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9819:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 731459 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731461 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 731463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731470 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731472 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731478 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731488 */     GIR_RootConstrainSelectedInstOperands,
     /* 731489 */     // GIR_Coverage, 5478,
     /* 731489 */     GIR_EraseRootFromParent_Done,
     /* 731490 */   // Label 9533: @731490
     /* 731490 */   GIM_Try, /*On fail goto*//*Label 9534*/ GIMT_Encode4(731549), // Rule ID 5482 //
     /* 731495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731499 */     // MIs[0] offset
     /* 731499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731502 */     // MIs[0] auxiliary
     /* 731502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731505 */     // MIs[0] Operand 7
     /* 731505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731515 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9819:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 731518 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731520 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 731522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731529 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731531 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731537 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731547 */     GIR_RootConstrainSelectedInstOperands,
     /* 731548 */     // GIR_Coverage, 5482,
     /* 731548 */     GIR_EraseRootFromParent_Done,
     /* 731549 */   // Label 9534: @731549
     /* 731549 */   GIM_Try, /*On fail goto*//*Label 9535*/ GIMT_Encode4(731611), // Rule ID 5486 //
     /* 731554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731561 */     // MIs[0] offset
     /* 731561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731564 */     // MIs[0] auxiliary
     /* 731564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731567 */     // MIs[0] Operand 7
     /* 731567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731577 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 731580 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731582 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 731584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731591 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731593 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731609 */     GIR_RootConstrainSelectedInstOperands,
     /* 731610 */     // GIR_Coverage, 5486,
     /* 731610 */     GIR_EraseRootFromParent_Done,
     /* 731611 */   // Label 9535: @731611
     /* 731611 */   GIM_Try, /*On fail goto*//*Label 9536*/ GIMT_Encode4(731670), // Rule ID 5490 //
     /* 731616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731620 */     // MIs[0] offset
     /* 731620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731623 */     // MIs[0] auxiliary
     /* 731623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731626 */     // MIs[0] Operand 7
     /* 731626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731636 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 731639 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731641 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 731643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731650 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731652 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731658 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731668 */     GIR_RootConstrainSelectedInstOperands,
     /* 731669 */     // GIR_Coverage, 5490,
     /* 731669 */     GIR_EraseRootFromParent_Done,
     /* 731670 */   // Label 9536: @731670
     /* 731670 */   GIM_Try, /*On fail goto*//*Label 9537*/ GIMT_Encode4(731770), // Rule ID 5479 //
     /* 731675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731678 */     // MIs[0] offset
     /* 731678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731681 */     // MIs[0] auxiliary
     /* 731681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731684 */     // MIs[0] Operand 7
     /* 731684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731694 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9819:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 731697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 731701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 731706 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 731710 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 731713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 731717 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 731720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 731725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 731738 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 731743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731750 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731752 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731768 */     GIR_RootConstrainSelectedInstOperands,
     /* 731769 */     // GIR_Coverage, 5479,
     /* 731769 */     GIR_EraseRootFromParent_Done,
     /* 731770 */   // Label 9537: @731770
     /* 731770 */   GIM_Try, /*On fail goto*//*Label 9538*/ GIMT_Encode4(731867), // Rule ID 5483 //
     /* 731775 */     // MIs[0] offset
     /* 731775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731778 */     // MIs[0] auxiliary
     /* 731778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731781 */     // MIs[0] Operand 7
     /* 731781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731791 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 731794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 731798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 731803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 731807 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 731810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 731814 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 731817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 731822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 731835 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 731840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731847 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731849 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731855 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731865 */     GIR_RootConstrainSelectedInstOperands,
     /* 731866 */     // GIR_Coverage, 5483,
     /* 731866 */     GIR_EraseRootFromParent_Done,
     /* 731867 */   // Label 9538: @731867
     /* 731867 */   GIM_Try, /*On fail goto*//*Label 9539*/ GIMT_Encode4(731967), // Rule ID 5487 //
     /* 731872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731875 */     // MIs[0] offset
     /* 731875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731878 */     // MIs[0] auxiliary
     /* 731878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731881 */     // MIs[0] Operand 7
     /* 731881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731891 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 731894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 731898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 731903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 731907 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 731910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 731914 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 731917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 731922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 731935 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 731940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731947 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731949 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731955 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731965 */     GIR_RootConstrainSelectedInstOperands,
     /* 731966 */     // GIR_Coverage, 5487,
     /* 731966 */     GIR_EraseRootFromParent_Done,
     /* 731967 */   // Label 9539: @731967
     /* 731967 */   GIM_Try, /*On fail goto*//*Label 9540*/ GIMT_Encode4(732064), // Rule ID 5491 //
     /* 731972 */     // MIs[0] offset
     /* 731972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731975 */     // MIs[0] auxiliary
     /* 731975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731978 */     // MIs[0] Operand 7
     /* 731978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731988 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 731991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 731995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 732000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 732004 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 732007 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 732011 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 732014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 732019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 732032 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 732037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732044 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732046 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732052 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732062 */     GIR_RootConstrainSelectedInstOperands,
     /* 732063 */     // GIR_Coverage, 5491,
     /* 732063 */     GIR_EraseRootFromParent_Done,
     /* 732064 */   // Label 9540: @732064
     /* 732064 */   GIM_Reject,
     /* 732065 */ // Label 9524: @732065
     /* 732065 */ GIM_Reject,
     /* 732066 */ // Label 9356: @732066
     /* 732066 */ GIM_Try, /*On fail goto*//*Label 9541*/ GIMT_Encode4(733276),
     /* 732071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 732074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 732077 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 732080 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 732083 */   GIM_Try, /*On fail goto*//*Label 9542*/ GIMT_Encode4(732155), // Rule ID 5508 //
     /* 732088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732099 */     // MIs[0] offset
     /* 732099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732102 */     // MIs[0] auxiliary
     /* 732102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732105 */     // MIs[0] Operand 7
     /* 732105 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732123 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9817:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 732126 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732135 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732137 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732143 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732153 */     GIR_RootConstrainSelectedInstOperands,
     /* 732154 */     // GIR_Coverage, 5508,
     /* 732154 */     GIR_EraseRootFromParent_Done,
     /* 732155 */   // Label 9542: @732155
     /* 732155 */   GIM_Try, /*On fail goto*//*Label 9543*/ GIMT_Encode4(732224), // Rule ID 5512 //
     /* 732160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732168 */     // MIs[0] offset
     /* 732168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732171 */     // MIs[0] auxiliary
     /* 732171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732174 */     // MIs[0] Operand 7
     /* 732174 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732192 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9817:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 732195 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732204 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732212 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732222 */     GIR_RootConstrainSelectedInstOperands,
     /* 732223 */     // GIR_Coverage, 5512,
     /* 732223 */     GIR_EraseRootFromParent_Done,
     /* 732224 */   // Label 9543: @732224
     /* 732224 */   GIM_Try, /*On fail goto*//*Label 9544*/ GIMT_Encode4(732296), // Rule ID 5516 //
     /* 732229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732240 */     // MIs[0] offset
     /* 732240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732243 */     // MIs[0] auxiliary
     /* 732243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732246 */     // MIs[0] Operand 7
     /* 732246 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732264 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9817:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 732267 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732276 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732278 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732284 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732294 */     GIR_RootConstrainSelectedInstOperands,
     /* 732295 */     // GIR_Coverage, 5516,
     /* 732295 */     GIR_EraseRootFromParent_Done,
     /* 732296 */   // Label 9544: @732296
     /* 732296 */   GIM_Try, /*On fail goto*//*Label 9545*/ GIMT_Encode4(732365), // Rule ID 5520 //
     /* 732301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732309 */     // MIs[0] offset
     /* 732309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732312 */     // MIs[0] auxiliary
     /* 732312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732315 */     // MIs[0] Operand 7
     /* 732315 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732333 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9817:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 732336 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732345 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732347 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732353 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732363 */     GIR_RootConstrainSelectedInstOperands,
     /* 732364 */     // GIR_Coverage, 5520,
     /* 732364 */     GIR_EraseRootFromParent_Done,
     /* 732365 */   // Label 9545: @732365
     /* 732365 */   GIM_Try, /*On fail goto*//*Label 9546*/ GIMT_Encode4(732435), // Rule ID 5509 //
     /* 732370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732377 */     // MIs[0] offset
     /* 732377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732380 */     // MIs[0] auxiliary
     /* 732380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732383 */     // MIs[0] Operand 7
     /* 732383 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732401 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 732404 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732406 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 732408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732415 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732423 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732433 */     GIR_RootConstrainSelectedInstOperands,
     /* 732434 */     // GIR_Coverage, 5509,
     /* 732434 */     GIR_EraseRootFromParent_Done,
     /* 732435 */   // Label 9546: @732435
     /* 732435 */   GIM_Try, /*On fail goto*//*Label 9547*/ GIMT_Encode4(732502), // Rule ID 5513 //
     /* 732440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732444 */     // MIs[0] offset
     /* 732444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732447 */     // MIs[0] auxiliary
     /* 732447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732450 */     // MIs[0] Operand 7
     /* 732450 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732468 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 732471 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732473 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 732475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732482 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732484 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732490 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732500 */     GIR_RootConstrainSelectedInstOperands,
     /* 732501 */     // GIR_Coverage, 5513,
     /* 732501 */     GIR_EraseRootFromParent_Done,
     /* 732502 */   // Label 9547: @732502
     /* 732502 */   GIM_Try, /*On fail goto*//*Label 9548*/ GIMT_Encode4(732572), // Rule ID 5517 //
     /* 732507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732514 */     // MIs[0] offset
     /* 732514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732517 */     // MIs[0] auxiliary
     /* 732517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732520 */     // MIs[0] Operand 7
     /* 732520 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732538 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 732541 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732543 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 732545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732552 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732554 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732560 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732570 */     GIR_RootConstrainSelectedInstOperands,
     /* 732571 */     // GIR_Coverage, 5517,
     /* 732571 */     GIR_EraseRootFromParent_Done,
     /* 732572 */   // Label 9548: @732572
     /* 732572 */   GIM_Try, /*On fail goto*//*Label 9549*/ GIMT_Encode4(732639), // Rule ID 5521 //
     /* 732577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732581 */     // MIs[0] offset
     /* 732581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732584 */     // MIs[0] auxiliary
     /* 732584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732587 */     // MIs[0] Operand 7
     /* 732587 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732605 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 732608 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732610 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 732612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732619 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732621 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732627 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732637 */     GIR_RootConstrainSelectedInstOperands,
     /* 732638 */     // GIR_Coverage, 5521,
     /* 732638 */     GIR_EraseRootFromParent_Done,
     /* 732639 */   // Label 9549: @732639
     /* 732639 */   GIM_Try, /*On fail goto*//*Label 9550*/ GIMT_Encode4(732701), // Rule ID 5510 //
     /* 732644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732651 */     // MIs[0] offset
     /* 732651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732654 */     // MIs[0] auxiliary
     /* 732654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732657 */     // MIs[0] Operand 7
     /* 732657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732667 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 732670 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732672 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 732674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732681 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732683 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732689 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732699 */     GIR_RootConstrainSelectedInstOperands,
     /* 732700 */     // GIR_Coverage, 5510,
     /* 732700 */     GIR_EraseRootFromParent_Done,
     /* 732701 */   // Label 9550: @732701
     /* 732701 */   GIM_Try, /*On fail goto*//*Label 9551*/ GIMT_Encode4(732760), // Rule ID 5514 //
     /* 732706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732710 */     // MIs[0] offset
     /* 732710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732713 */     // MIs[0] auxiliary
     /* 732713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732716 */     // MIs[0] Operand 7
     /* 732716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732726 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 732729 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732731 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 732733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732740 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732742 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732748 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732758 */     GIR_RootConstrainSelectedInstOperands,
     /* 732759 */     // GIR_Coverage, 5514,
     /* 732759 */     GIR_EraseRootFromParent_Done,
     /* 732760 */   // Label 9551: @732760
     /* 732760 */   GIM_Try, /*On fail goto*//*Label 9552*/ GIMT_Encode4(732822), // Rule ID 5518 //
     /* 732765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732772 */     // MIs[0] offset
     /* 732772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732775 */     // MIs[0] auxiliary
     /* 732775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732778 */     // MIs[0] Operand 7
     /* 732778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732788 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 732791 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732793 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 732795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732802 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732804 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732810 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732820 */     GIR_RootConstrainSelectedInstOperands,
     /* 732821 */     // GIR_Coverage, 5518,
     /* 732821 */     GIR_EraseRootFromParent_Done,
     /* 732822 */   // Label 9552: @732822
     /* 732822 */   GIM_Try, /*On fail goto*//*Label 9553*/ GIMT_Encode4(732881), // Rule ID 5522 //
     /* 732827 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732831 */     // MIs[0] offset
     /* 732831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732834 */     // MIs[0] auxiliary
     /* 732834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732837 */     // MIs[0] Operand 7
     /* 732837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732847 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 732850 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732852 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 732854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732861 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732863 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732869 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732879 */     GIR_RootConstrainSelectedInstOperands,
     /* 732880 */     // GIR_Coverage, 5522,
     /* 732880 */     GIR_EraseRootFromParent_Done,
     /* 732881 */   // Label 9553: @732881
     /* 732881 */   GIM_Try, /*On fail goto*//*Label 9554*/ GIMT_Encode4(732981), // Rule ID 5511 //
     /* 732886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732889 */     // MIs[0] offset
     /* 732889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732892 */     // MIs[0] auxiliary
     /* 732892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732895 */     // MIs[0] Operand 7
     /* 732895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732905 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 732908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 732912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 732917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 732921 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 732924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 732928 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 732931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 732936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 732949 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 732954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732961 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732963 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732969 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732979 */     GIR_RootConstrainSelectedInstOperands,
     /* 732980 */     // GIR_Coverage, 5511,
     /* 732980 */     GIR_EraseRootFromParent_Done,
     /* 732981 */   // Label 9554: @732981
     /* 732981 */   GIM_Try, /*On fail goto*//*Label 9555*/ GIMT_Encode4(733078), // Rule ID 5515 //
     /* 732986 */     // MIs[0] offset
     /* 732986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732989 */     // MIs[0] auxiliary
     /* 732989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732992 */     // MIs[0] Operand 7
     /* 732992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733002 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 733005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 733009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 733014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 733018 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 733021 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 733025 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 733028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 733033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 733046 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 733051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733058 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733060 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733066 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733076 */     GIR_RootConstrainSelectedInstOperands,
     /* 733077 */     // GIR_Coverage, 5515,
     /* 733077 */     GIR_EraseRootFromParent_Done,
     /* 733078 */   // Label 9555: @733078
     /* 733078 */   GIM_Try, /*On fail goto*//*Label 9556*/ GIMT_Encode4(733178), // Rule ID 5519 //
     /* 733083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733086 */     // MIs[0] offset
     /* 733086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733089 */     // MIs[0] auxiliary
     /* 733089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733092 */     // MIs[0] Operand 7
     /* 733092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733102 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 733105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 733109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 733114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 733118 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 733121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 733125 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 733128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 733133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 733146 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 733151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733158 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733160 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733166 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733176 */     GIR_RootConstrainSelectedInstOperands,
     /* 733177 */     // GIR_Coverage, 5519,
     /* 733177 */     GIR_EraseRootFromParent_Done,
     /* 733178 */   // Label 9556: @733178
     /* 733178 */   GIM_Try, /*On fail goto*//*Label 9557*/ GIMT_Encode4(733275), // Rule ID 5523 //
     /* 733183 */     // MIs[0] offset
     /* 733183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733186 */     // MIs[0] auxiliary
     /* 733186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733189 */     // MIs[0] Operand 7
     /* 733189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733199 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 733202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 733206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 733211 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 733215 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 733218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 733222 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 733225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 733230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 733243 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 733248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733255 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733257 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733263 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733273 */     GIR_RootConstrainSelectedInstOperands,
     /* 733274 */     // GIR_Coverage, 5523,
     /* 733274 */     GIR_EraseRootFromParent_Done,
     /* 733275 */   // Label 9557: @733275
     /* 733275 */   GIM_Reject,
     /* 733276 */ // Label 9541: @733276
     /* 733276 */ GIM_Reject,
     /* 733277 */ // Label 9357: @733277
     /* 733277 */ GIM_Try, /*On fail goto*//*Label 9558*/ GIMT_Encode4(734487),
     /* 733282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 733285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 733288 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 733291 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 733294 */   GIM_Try, /*On fail goto*//*Label 9559*/ GIMT_Encode4(733366), // Rule ID 5540 //
     /* 733299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733310 */     // MIs[0] offset
     /* 733310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733313 */     // MIs[0] auxiliary
     /* 733313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733316 */     // MIs[0] Operand 7
     /* 733316 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733334 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9817:{ *:[v8i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 733337 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733346 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733348 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733354 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733364 */     GIR_RootConstrainSelectedInstOperands,
     /* 733365 */     // GIR_Coverage, 5540,
     /* 733365 */     GIR_EraseRootFromParent_Done,
     /* 733366 */   // Label 9559: @733366
     /* 733366 */   GIM_Try, /*On fail goto*//*Label 9560*/ GIMT_Encode4(733435), // Rule ID 5544 //
     /* 733371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733379 */     // MIs[0] offset
     /* 733379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733382 */     // MIs[0] auxiliary
     /* 733382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733385 */     // MIs[0] Operand 7
     /* 733385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733403 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9817:{ *:[v8i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 733406 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733415 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733423 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733433 */     GIR_RootConstrainSelectedInstOperands,
     /* 733434 */     // GIR_Coverage, 5544,
     /* 733434 */     GIR_EraseRootFromParent_Done,
     /* 733435 */   // Label 9560: @733435
     /* 733435 */   GIM_Try, /*On fail goto*//*Label 9561*/ GIMT_Encode4(733507), // Rule ID 5548 //
     /* 733440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733451 */     // MIs[0] offset
     /* 733451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733454 */     // MIs[0] auxiliary
     /* 733454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733457 */     // MIs[0] Operand 7
     /* 733457 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733475 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9817:{ *:[v8f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 733478 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733487 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733495 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733505 */     GIR_RootConstrainSelectedInstOperands,
     /* 733506 */     // GIR_Coverage, 5548,
     /* 733506 */     GIR_EraseRootFromParent_Done,
     /* 733507 */   // Label 9561: @733507
     /* 733507 */   GIM_Try, /*On fail goto*//*Label 9562*/ GIMT_Encode4(733576), // Rule ID 5552 //
     /* 733512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733520 */     // MIs[0] offset
     /* 733520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733523 */     // MIs[0] auxiliary
     /* 733523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733526 */     // MIs[0] Operand 7
     /* 733526 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733544 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9817:{ *:[v8f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 733547 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733556 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733558 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733574 */     GIR_RootConstrainSelectedInstOperands,
     /* 733575 */     // GIR_Coverage, 5552,
     /* 733575 */     GIR_EraseRootFromParent_Done,
     /* 733576 */   // Label 9562: @733576
     /* 733576 */   GIM_Try, /*On fail goto*//*Label 9563*/ GIMT_Encode4(733646), // Rule ID 5541 //
     /* 733581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733588 */     // MIs[0] offset
     /* 733588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733591 */     // MIs[0] auxiliary
     /* 733591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733594 */     // MIs[0] Operand 7
     /* 733594 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733612 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9817:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 733615 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733617 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 733619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733626 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733628 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733634 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733644 */     GIR_RootConstrainSelectedInstOperands,
     /* 733645 */     // GIR_Coverage, 5541,
     /* 733645 */     GIR_EraseRootFromParent_Done,
     /* 733646 */   // Label 9563: @733646
     /* 733646 */   GIM_Try, /*On fail goto*//*Label 9564*/ GIMT_Encode4(733713), // Rule ID 5545 //
     /* 733651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733655 */     // MIs[0] offset
     /* 733655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733658 */     // MIs[0] auxiliary
     /* 733658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733661 */     // MIs[0] Operand 7
     /* 733661 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733679 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9817:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 733682 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733684 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 733686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733693 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733695 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733701 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733711 */     GIR_RootConstrainSelectedInstOperands,
     /* 733712 */     // GIR_Coverage, 5545,
     /* 733712 */     GIR_EraseRootFromParent_Done,
     /* 733713 */   // Label 9564: @733713
     /* 733713 */   GIM_Try, /*On fail goto*//*Label 9565*/ GIMT_Encode4(733783), // Rule ID 5549 //
     /* 733718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733725 */     // MIs[0] offset
     /* 733725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733728 */     // MIs[0] auxiliary
     /* 733728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733731 */     // MIs[0] Operand 7
     /* 733731 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733749 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9817:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 733752 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733754 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 733756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733763 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733765 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733771 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733781 */     GIR_RootConstrainSelectedInstOperands,
     /* 733782 */     // GIR_Coverage, 5549,
     /* 733782 */     GIR_EraseRootFromParent_Done,
     /* 733783 */   // Label 9565: @733783
     /* 733783 */   GIM_Try, /*On fail goto*//*Label 9566*/ GIMT_Encode4(733850), // Rule ID 5553 //
     /* 733788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733792 */     // MIs[0] offset
     /* 733792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733795 */     // MIs[0] auxiliary
     /* 733795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733798 */     // MIs[0] Operand 7
     /* 733798 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733816 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9817:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 733819 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733821 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 733823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733830 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733832 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733838 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733848 */     GIR_RootConstrainSelectedInstOperands,
     /* 733849 */     // GIR_Coverage, 5553,
     /* 733849 */     GIR_EraseRootFromParent_Done,
     /* 733850 */   // Label 9566: @733850
     /* 733850 */   GIM_Try, /*On fail goto*//*Label 9567*/ GIMT_Encode4(733912), // Rule ID 5542 //
     /* 733855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733862 */     // MIs[0] offset
     /* 733862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733865 */     // MIs[0] auxiliary
     /* 733865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733868 */     // MIs[0] Operand 7
     /* 733868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733878 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9817:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 733881 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733883 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 733885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733892 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733894 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733900 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733910 */     GIR_RootConstrainSelectedInstOperands,
     /* 733911 */     // GIR_Coverage, 5542,
     /* 733911 */     GIR_EraseRootFromParent_Done,
     /* 733912 */   // Label 9567: @733912
     /* 733912 */   GIM_Try, /*On fail goto*//*Label 9568*/ GIMT_Encode4(733971), // Rule ID 5546 //
     /* 733917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733921 */     // MIs[0] offset
     /* 733921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733924 */     // MIs[0] auxiliary
     /* 733924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733927 */     // MIs[0] Operand 7
     /* 733927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733937 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9817:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 733940 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733942 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 733944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733951 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733969 */     GIR_RootConstrainSelectedInstOperands,
     /* 733970 */     // GIR_Coverage, 5546,
     /* 733970 */     GIR_EraseRootFromParent_Done,
     /* 733971 */   // Label 9568: @733971
     /* 733971 */   GIM_Try, /*On fail goto*//*Label 9569*/ GIMT_Encode4(734033), // Rule ID 5550 //
     /* 733976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733983 */     // MIs[0] offset
     /* 733983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733986 */     // MIs[0] auxiliary
     /* 733986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733989 */     // MIs[0] Operand 7
     /* 733989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733999 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9817:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 734002 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734004 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 734006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734013 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734015 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734021 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734031 */     GIR_RootConstrainSelectedInstOperands,
     /* 734032 */     // GIR_Coverage, 5550,
     /* 734032 */     GIR_EraseRootFromParent_Done,
     /* 734033 */   // Label 9569: @734033
     /* 734033 */   GIM_Try, /*On fail goto*//*Label 9570*/ GIMT_Encode4(734092), // Rule ID 5554 //
     /* 734038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734042 */     // MIs[0] offset
     /* 734042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734045 */     // MIs[0] auxiliary
     /* 734045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734048 */     // MIs[0] Operand 7
     /* 734048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734058 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9817:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 734061 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734063 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 734065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734072 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734074 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734080 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734090 */     GIR_RootConstrainSelectedInstOperands,
     /* 734091 */     // GIR_Coverage, 5554,
     /* 734091 */     GIR_EraseRootFromParent_Done,
     /* 734092 */   // Label 9570: @734092
     /* 734092 */   GIM_Try, /*On fail goto*//*Label 9571*/ GIMT_Encode4(734192), // Rule ID 5543 //
     /* 734097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734100 */     // MIs[0] offset
     /* 734100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734103 */     // MIs[0] auxiliary
     /* 734103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734106 */     // MIs[0] Operand 7
     /* 734106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734116 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9817:{ *:[v8i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 734119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 734123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 734128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 734132 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 734135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 734139 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 734142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 734147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 734160 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 734165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734172 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734174 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734180 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734190 */     GIR_RootConstrainSelectedInstOperands,
     /* 734191 */     // GIR_Coverage, 5543,
     /* 734191 */     GIR_EraseRootFromParent_Done,
     /* 734192 */   // Label 9571: @734192
     /* 734192 */   GIM_Try, /*On fail goto*//*Label 9572*/ GIMT_Encode4(734289), // Rule ID 5547 //
     /* 734197 */     // MIs[0] offset
     /* 734197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734200 */     // MIs[0] auxiliary
     /* 734200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734203 */     // MIs[0] Operand 7
     /* 734203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734213 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9817:{ *:[v8i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 734216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 734220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 734225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 734229 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 734232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 734236 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 734239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 734244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 734257 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 734262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734269 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734277 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734287 */     GIR_RootConstrainSelectedInstOperands,
     /* 734288 */     // GIR_Coverage, 5547,
     /* 734288 */     GIR_EraseRootFromParent_Done,
     /* 734289 */   // Label 9572: @734289
     /* 734289 */   GIM_Try, /*On fail goto*//*Label 9573*/ GIMT_Encode4(734389), // Rule ID 5551 //
     /* 734294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734297 */     // MIs[0] offset
     /* 734297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734300 */     // MIs[0] auxiliary
     /* 734300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734303 */     // MIs[0] Operand 7
     /* 734303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734313 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9817:{ *:[v8f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 734316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 734320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 734325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 734329 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 734332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 734336 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 734339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 734344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 734357 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 734362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734369 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734371 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734377 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734387 */     GIR_RootConstrainSelectedInstOperands,
     /* 734388 */     // GIR_Coverage, 5551,
     /* 734388 */     GIR_EraseRootFromParent_Done,
     /* 734389 */   // Label 9573: @734389
     /* 734389 */   GIM_Try, /*On fail goto*//*Label 9574*/ GIMT_Encode4(734486), // Rule ID 5555 //
     /* 734394 */     // MIs[0] offset
     /* 734394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734397 */     // MIs[0] auxiliary
     /* 734397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734400 */     // MIs[0] Operand 7
     /* 734400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734410 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9817:{ *:[v8f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 734413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 734417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 734422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 734426 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 734429 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 734433 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 734436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 734441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 734454 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 734459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734466 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734474 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734484 */     GIR_RootConstrainSelectedInstOperands,
     /* 734485 */     // GIR_Coverage, 5555,
     /* 734485 */     GIR_EraseRootFromParent_Done,
     /* 734486 */   // Label 9574: @734486
     /* 734486 */   GIM_Reject,
     /* 734487 */ // Label 9558: @734487
     /* 734487 */ GIM_Reject,
     /* 734488 */ // Label 9358: @734488
     /* 734488 */ GIM_Reject,
     /* 734489 */ // Label 139: @734489
     /* 734489 */ GIM_Try, /*On fail goto*//*Label 9575*/ GIMT_Encode4(735090),
     /* 734494 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 734497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 734500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 734503 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 734506 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 734509 */   GIM_Try, /*On fail goto*//*Label 9576*/ GIMT_Encode4(734781),
     /* 734514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 734518 */     GIM_Try, /*On fail goto*//*Label 9577*/ GIMT_Encode4(734586), // Rule ID 5556 //
     /* 734523 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734526 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734530 */       // MIs[0] offset
     /* 734530 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734533 */       // MIs[0] auxiliary
     /* 734533 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734536 */       // MIs[0] Operand 7
     /* 734536 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734547 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734554 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734554 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET_exact),
     /* 734557 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734559 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734561 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734566 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734568 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734574 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734580 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734584 */       GIR_RootConstrainSelectedInstOperands,
     /* 734585 */       // GIR_Coverage, 5556,
     /* 734585 */       GIR_EraseRootFromParent_Done,
     /* 734586 */     // Label 9577: @734586
     /* 734586 */     GIM_Try, /*On fail goto*//*Label 9578*/ GIMT_Encode4(734651), // Rule ID 5560 //
     /* 734591 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734595 */       // MIs[0] offset
     /* 734595 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734598 */       // MIs[0] auxiliary
     /* 734598 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734601 */       // MIs[0] Operand 7
     /* 734601 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734612 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734619 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734619 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET_exact),
     /* 734622 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734624 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734626 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734631 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734633 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734639 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734645 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734649 */       GIR_RootConstrainSelectedInstOperands,
     /* 734650 */       // GIR_Coverage, 5560,
     /* 734650 */       GIR_EraseRootFromParent_Done,
     /* 734651 */     // Label 9578: @734651
     /* 734651 */     GIM_Try, /*On fail goto*//*Label 9579*/ GIMT_Encode4(734717), // Rule ID 5557 //
     /* 734656 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734659 */       // MIs[0] offset
     /* 734659 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734662 */       // MIs[0] auxiliary
     /* 734662 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734665 */       // MIs[0] Operand 7
     /* 734665 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734676 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734683 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734683 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFEN_exact),
     /* 734686 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734688 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 734690 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734692 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734697 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734699 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734705 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734711 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734715 */       GIR_RootConstrainSelectedInstOperands,
     /* 734716 */       // GIR_Coverage, 5557,
     /* 734716 */       GIR_EraseRootFromParent_Done,
     /* 734717 */     // Label 9579: @734717
     /* 734717 */     GIM_Try, /*On fail goto*//*Label 9580*/ GIMT_Encode4(734780), // Rule ID 5561 //
     /* 734722 */       // MIs[0] offset
     /* 734722 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734725 */       // MIs[0] auxiliary
     /* 734725 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734728 */       // MIs[0] Operand 7
     /* 734728 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734739 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734746 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734746 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFEN_exact),
     /* 734749 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734751 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 734753 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734755 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734760 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734762 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734768 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734774 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734778 */       GIR_RootConstrainSelectedInstOperands,
     /* 734779 */       // GIR_Coverage, 5561,
     /* 734779 */       GIR_EraseRootFromParent_Done,
     /* 734780 */     // Label 9580: @734780
     /* 734780 */     GIM_Reject,
     /* 734781 */   // Label 9576: @734781
     /* 734781 */   GIM_Try, /*On fail goto*//*Label 9581*/ GIMT_Encode4(734895),
     /* 734786 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734799 */     GIM_Try, /*On fail goto*//*Label 9582*/ GIMT_Encode4(734848), // Rule ID 5558 //
     /* 734804 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734807 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734814 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734814 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_IDXEN_exact),
     /* 734817 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734819 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 734821 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734823 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734828 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734830 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734836 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734842 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734846 */       GIR_RootConstrainSelectedInstOperands,
     /* 734847 */       // GIR_Coverage, 5558,
     /* 734847 */       GIR_EraseRootFromParent_Done,
     /* 734848 */     // Label 9582: @734848
     /* 734848 */     GIM_Try, /*On fail goto*//*Label 9583*/ GIMT_Encode4(734894), // Rule ID 5562 //
     /* 734853 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734860 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_VBUFFER_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734860 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_IDXEN_exact),
     /* 734863 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734865 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 734867 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734869 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734874 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734876 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734882 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734888 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734892 */       GIR_RootConstrainSelectedInstOperands,
     /* 734893 */       // GIR_Coverage, 5562,
     /* 734893 */       GIR_EraseRootFromParent_Done,
     /* 734894 */     // Label 9583: @734894
     /* 734894 */     GIM_Reject,
     /* 734895 */   // Label 9581: @734895
     /* 734895 */   GIM_Try, /*On fail goto*//*Label 9584*/ GIMT_Encode4(735089),
     /* 734900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734909 */     GIM_Try, /*On fail goto*//*Label 9585*/ GIMT_Encode4(735000), // Rule ID 5559 //
     /* 734914 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734917 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734924 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734924 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 734927 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 734931 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 734936 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 734940 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 734943 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 734947 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 734950 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 734955 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734960 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734965 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_BOTHEN_exact),
     /* 734968 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734970 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 734973 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734975 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734980 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734982 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734988 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734994 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734998 */       GIR_RootConstrainSelectedInstOperands,
     /* 734999 */       // GIR_Coverage, 5559,
     /* 734999 */       GIR_EraseRootFromParent_Done,
     /* 735000 */     // Label 9585: @735000
     /* 735000 */     GIM_Try, /*On fail goto*//*Label 9586*/ GIMT_Encode4(735088), // Rule ID 5563 //
     /* 735005 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735012 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735012 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 735015 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 735019 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 735024 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 735028 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 735031 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 735035 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 735038 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 735043 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 735048 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 735053 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_BOTHEN_exact),
     /* 735056 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735058 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 735061 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735063 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735068 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735070 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735076 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735082 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735086 */       GIR_RootConstrainSelectedInstOperands,
     /* 735087 */       // GIR_Coverage, 5563,
     /* 735087 */       GIR_EraseRootFromParent_Done,
     /* 735088 */     // Label 9586: @735088
     /* 735088 */     GIM_Reject,
     /* 735089 */   // Label 9584: @735089
     /* 735089 */   GIM_Reject,
     /* 735090 */ // Label 9575: @735090
     /* 735090 */ GIM_Reject,
     /* 735091 */ // Label 140: @735091
     /* 735091 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 9591*/ GIMT_Encode4(740578),
     /* 735102 */ /*GILLT_s32*//*Label 9587*/ GIMT_Encode4(735138), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 735114 */ /*GILLT_v2s32*//*Label 9588*/ GIMT_Encode4(736349), GIMT_Encode4(0),
     /* 735122 */ /*GILLT_v3s32*//*Label 9589*/ GIMT_Encode4(738156), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 735134 */ /*GILLT_v4s32*//*Label 9590*/ GIMT_Encode4(739367),
     /* 735138 */ // Label 9587: @735138
     /* 735138 */ GIM_Try, /*On fail goto*//*Label 9592*/ GIMT_Encode4(736348),
     /* 735143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 735146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 735149 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 735152 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 735155 */   GIM_Try, /*On fail goto*//*Label 9593*/ GIMT_Encode4(735227), // Rule ID 5188 //
     /* 735160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735171 */     // MIs[0] offset
     /* 735171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735174 */     // MIs[0] auxiliary
     /* 735174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735177 */     // MIs[0] Operand 7
     /* 735177 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735195 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9820:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFSET_exact),
     /* 735198 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735207 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735209 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735225 */     GIR_RootConstrainSelectedInstOperands,
     /* 735226 */     // GIR_Coverage, 5188,
     /* 735226 */     GIR_EraseRootFromParent_Done,
     /* 735227 */   // Label 9593: @735227
     /* 735227 */   GIM_Try, /*On fail goto*//*Label 9594*/ GIMT_Encode4(735296), // Rule ID 5192 //
     /* 735232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735240 */     // MIs[0] offset
     /* 735240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735243 */     // MIs[0] auxiliary
     /* 735243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735246 */     // MIs[0] Operand 7
     /* 735246 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735264 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9820:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
     /* 735267 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735276 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735278 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735284 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735294 */     GIR_RootConstrainSelectedInstOperands,
     /* 735295 */     // GIR_Coverage, 5192,
     /* 735295 */     GIR_EraseRootFromParent_Done,
     /* 735296 */   // Label 9594: @735296
     /* 735296 */   GIM_Try, /*On fail goto*//*Label 9595*/ GIMT_Encode4(735368), // Rule ID 5196 //
     /* 735301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735312 */     // MIs[0] offset
     /* 735312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735315 */     // MIs[0] auxiliary
     /* 735315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735318 */     // MIs[0] Operand 7
     /* 735318 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735336 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFSET_exact),
     /* 735339 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735348 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735350 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735366 */     GIR_RootConstrainSelectedInstOperands,
     /* 735367 */     // GIR_Coverage, 5196,
     /* 735367 */     GIR_EraseRootFromParent_Done,
     /* 735368 */   // Label 9595: @735368
     /* 735368 */   GIM_Try, /*On fail goto*//*Label 9596*/ GIMT_Encode4(735437), // Rule ID 5200 //
     /* 735373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735381 */     // MIs[0] offset
     /* 735381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735384 */     // MIs[0] auxiliary
     /* 735384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735387 */     // MIs[0] Operand 7
     /* 735387 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735405 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
     /* 735408 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735417 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735435 */     GIR_RootConstrainSelectedInstOperands,
     /* 735436 */     // GIR_Coverage, 5200,
     /* 735436 */     GIR_EraseRootFromParent_Done,
     /* 735437 */   // Label 9596: @735437
     /* 735437 */   GIM_Try, /*On fail goto*//*Label 9597*/ GIMT_Encode4(735507), // Rule ID 5189 //
     /* 735442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735449 */     // MIs[0] offset
     /* 735449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735452 */     // MIs[0] auxiliary
     /* 735452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735455 */     // MIs[0] Operand 7
     /* 735455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735473 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9820:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFEN_exact),
     /* 735476 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735478 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 735480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735487 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735495 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735505 */     GIR_RootConstrainSelectedInstOperands,
     /* 735506 */     // GIR_Coverage, 5189,
     /* 735506 */     GIR_EraseRootFromParent_Done,
     /* 735507 */   // Label 9597: @735507
     /* 735507 */   GIM_Try, /*On fail goto*//*Label 9598*/ GIMT_Encode4(735574), // Rule ID 5193 //
     /* 735512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735516 */     // MIs[0] offset
     /* 735516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735519 */     // MIs[0] auxiliary
     /* 735519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735522 */     // MIs[0] Operand 7
     /* 735522 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735540 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9820:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
     /* 735543 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735545 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 735547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735554 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735556 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735562 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735572 */     GIR_RootConstrainSelectedInstOperands,
     /* 735573 */     // GIR_Coverage, 5193,
     /* 735573 */     GIR_EraseRootFromParent_Done,
     /* 735574 */   // Label 9598: @735574
     /* 735574 */   GIM_Try, /*On fail goto*//*Label 9599*/ GIMT_Encode4(735644), // Rule ID 5197 //
     /* 735579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735586 */     // MIs[0] offset
     /* 735586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735589 */     // MIs[0] auxiliary
     /* 735589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735592 */     // MIs[0] Operand 7
     /* 735592 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735610 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFEN_exact),
     /* 735613 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735615 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 735617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735624 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735626 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735632 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735642 */     GIR_RootConstrainSelectedInstOperands,
     /* 735643 */     // GIR_Coverage, 5197,
     /* 735643 */     GIR_EraseRootFromParent_Done,
     /* 735644 */   // Label 9599: @735644
     /* 735644 */   GIM_Try, /*On fail goto*//*Label 9600*/ GIMT_Encode4(735711), // Rule ID 5201 //
     /* 735649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735653 */     // MIs[0] offset
     /* 735653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735656 */     // MIs[0] auxiliary
     /* 735656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735659 */     // MIs[0] Operand 7
     /* 735659 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735677 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
     /* 735680 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735682 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 735684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735691 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735709 */     GIR_RootConstrainSelectedInstOperands,
     /* 735710 */     // GIR_Coverage, 5201,
     /* 735710 */     GIR_EraseRootFromParent_Done,
     /* 735711 */   // Label 9600: @735711
     /* 735711 */   GIM_Try, /*On fail goto*//*Label 9601*/ GIMT_Encode4(735773), // Rule ID 5190 //
     /* 735716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735723 */     // MIs[0] offset
     /* 735723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735726 */     // MIs[0] auxiliary
     /* 735726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735729 */     // MIs[0] Operand 7
     /* 735729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 735732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735739 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9820:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_IDXEN_exact),
     /* 735742 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735744 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 735746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735753 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735755 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735761 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735771 */     GIR_RootConstrainSelectedInstOperands,
     /* 735772 */     // GIR_Coverage, 5190,
     /* 735772 */     GIR_EraseRootFromParent_Done,
     /* 735773 */   // Label 9601: @735773
     /* 735773 */   GIM_Try, /*On fail goto*//*Label 9602*/ GIMT_Encode4(735832), // Rule ID 5194 //
     /* 735778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735782 */     // MIs[0] offset
     /* 735782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735785 */     // MIs[0] auxiliary
     /* 735785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735788 */     // MIs[0] Operand 7
     /* 735788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 735791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735798 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9820:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
     /* 735801 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735803 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 735805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735812 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735820 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735830 */     GIR_RootConstrainSelectedInstOperands,
     /* 735831 */     // GIR_Coverage, 5194,
     /* 735831 */     GIR_EraseRootFromParent_Done,
     /* 735832 */   // Label 9602: @735832
     /* 735832 */   GIM_Try, /*On fail goto*//*Label 9603*/ GIMT_Encode4(735894), // Rule ID 5198 //
     /* 735837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735844 */     // MIs[0] offset
     /* 735844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735847 */     // MIs[0] auxiliary
     /* 735847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735850 */     // MIs[0] Operand 7
     /* 735850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 735853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735860 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_IDXEN_exact),
     /* 735863 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735865 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 735867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735874 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735876 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735882 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735892 */     GIR_RootConstrainSelectedInstOperands,
     /* 735893 */     // GIR_Coverage, 5198,
     /* 735893 */     GIR_EraseRootFromParent_Done,
     /* 735894 */   // Label 9603: @735894
     /* 735894 */   GIM_Try, /*On fail goto*//*Label 9604*/ GIMT_Encode4(735953), // Rule ID 5202 //
     /* 735899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735903 */     // MIs[0] offset
     /* 735903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735906 */     // MIs[0] auxiliary
     /* 735906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735909 */     // MIs[0] Operand 7
     /* 735909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 735912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735919 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
     /* 735922 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735924 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 735926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735933 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735935 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735941 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735951 */     GIR_RootConstrainSelectedInstOperands,
     /* 735952 */     // GIR_Coverage, 5202,
     /* 735952 */     GIR_EraseRootFromParent_Done,
     /* 735953 */   // Label 9604: @735953
     /* 735953 */   GIM_Try, /*On fail goto*//*Label 9605*/ GIMT_Encode4(736053), // Rule ID 5191 //
     /* 735958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735961 */     // MIs[0] offset
     /* 735961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735964 */     // MIs[0] auxiliary
     /* 735964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735967 */     // MIs[0] Operand 7
     /* 735967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 735970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735977 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9820:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 735980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 735984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 735989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 735993 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 735996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 736000 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 736003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 736008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_BOTHEN_exact),
     /* 736021 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 736026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736033 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736035 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736041 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736051 */     GIR_RootConstrainSelectedInstOperands,
     /* 736052 */     // GIR_Coverage, 5191,
     /* 736052 */     GIR_EraseRootFromParent_Done,
     /* 736053 */   // Label 9605: @736053
     /* 736053 */   GIM_Try, /*On fail goto*//*Label 9606*/ GIMT_Encode4(736150), // Rule ID 5195 //
     /* 736058 */     // MIs[0] offset
     /* 736058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736061 */     // MIs[0] auxiliary
     /* 736061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736064 */     // MIs[0] Operand 7
     /* 736064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736074 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 736077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 736081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 736086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 736090 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 736093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 736097 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 736100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 736105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
     /* 736118 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 736123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736130 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736132 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736138 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736148 */     GIR_RootConstrainSelectedInstOperands,
     /* 736149 */     // GIR_Coverage, 5195,
     /* 736149 */     GIR_EraseRootFromParent_Done,
     /* 736150 */   // Label 9606: @736150
     /* 736150 */   GIM_Try, /*On fail goto*//*Label 9607*/ GIMT_Encode4(736250), // Rule ID 5199 //
     /* 736155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736158 */     // MIs[0] offset
     /* 736158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736161 */     // MIs[0] auxiliary
     /* 736161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736164 */     // MIs[0] Operand 7
     /* 736164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736174 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 736177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 736181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 736186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 736190 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 736193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 736197 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 736200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 736205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_BOTHEN_exact),
     /* 736218 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 736223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736230 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736232 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736248 */     GIR_RootConstrainSelectedInstOperands,
     /* 736249 */     // GIR_Coverage, 5199,
     /* 736249 */     GIR_EraseRootFromParent_Done,
     /* 736250 */   // Label 9607: @736250
     /* 736250 */   GIM_Try, /*On fail goto*//*Label 9608*/ GIMT_Encode4(736347), // Rule ID 5203 //
     /* 736255 */     // MIs[0] offset
     /* 736255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736258 */     // MIs[0] auxiliary
     /* 736258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736261 */     // MIs[0] Operand 7
     /* 736261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736271 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 736274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 736278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 736283 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 736287 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 736290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 736294 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 736297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 736302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
     /* 736315 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 736320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736327 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736329 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736335 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736345 */     GIR_RootConstrainSelectedInstOperands,
     /* 736346 */     // GIR_Coverage, 5203,
     /* 736346 */     GIR_EraseRootFromParent_Done,
     /* 736347 */   // Label 9608: @736347
     /* 736347 */   GIM_Reject,
     /* 736348 */ // Label 9592: @736348
     /* 736348 */ GIM_Reject,
     /* 736349 */ // Label 9588: @736349
     /* 736349 */ GIM_Try, /*On fail goto*//*Label 9609*/ GIMT_Encode4(738155),
     /* 736354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 736357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 736360 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 736363 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 736366 */   GIM_Try, /*On fail goto*//*Label 9610*/ GIMT_Encode4(736438), // Rule ID 5204 //
     /* 736371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736382 */     // MIs[0] offset
     /* 736382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736385 */     // MIs[0] auxiliary
     /* 736385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736388 */     // MIs[0] Operand 7
     /* 736388 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736406 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9819:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 736409 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736418 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736420 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736426 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736436 */     GIR_RootConstrainSelectedInstOperands,
     /* 736437 */     // GIR_Coverage, 5204,
     /* 736437 */     GIR_EraseRootFromParent_Done,
     /* 736438 */   // Label 9610: @736438
     /* 736438 */   GIM_Try, /*On fail goto*//*Label 9611*/ GIMT_Encode4(736507), // Rule ID 5208 //
     /* 736443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736451 */     // MIs[0] offset
     /* 736451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736454 */     // MIs[0] auxiliary
     /* 736454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736457 */     // MIs[0] Operand 7
     /* 736457 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736475 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9819:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 736478 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736487 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736495 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736505 */     GIR_RootConstrainSelectedInstOperands,
     /* 736506 */     // GIR_Coverage, 5208,
     /* 736506 */     GIR_EraseRootFromParent_Done,
     /* 736507 */   // Label 9611: @736507
     /* 736507 */   GIM_Try, /*On fail goto*//*Label 9612*/ GIMT_Encode4(736579), // Rule ID 5212 //
     /* 736512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736523 */     // MIs[0] offset
     /* 736523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736526 */     // MIs[0] auxiliary
     /* 736526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736529 */     // MIs[0] Operand 7
     /* 736529 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736547 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9819:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 736550 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736559 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736561 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736567 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736577 */     GIR_RootConstrainSelectedInstOperands,
     /* 736578 */     // GIR_Coverage, 5212,
     /* 736578 */     GIR_EraseRootFromParent_Done,
     /* 736579 */   // Label 9612: @736579
     /* 736579 */   GIM_Try, /*On fail goto*//*Label 9613*/ GIMT_Encode4(736648), // Rule ID 5216 //
     /* 736584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736592 */     // MIs[0] offset
     /* 736592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736595 */     // MIs[0] auxiliary
     /* 736595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736598 */     // MIs[0] Operand 7
     /* 736598 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736616 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9819:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 736619 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736628 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736636 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736646 */     GIR_RootConstrainSelectedInstOperands,
     /* 736647 */     // GIR_Coverage, 5216,
     /* 736647 */     GIR_EraseRootFromParent_Done,
     /* 736648 */   // Label 9613: @736648
     /* 736648 */   GIM_Try, /*On fail goto*//*Label 9614*/ GIMT_Encode4(736720), // Rule ID 5220 //
     /* 736653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736664 */     // MIs[0] offset
     /* 736664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736667 */     // MIs[0] auxiliary
     /* 736667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736670 */     // MIs[0] Operand 7
     /* 736670 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736688 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9819:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 736691 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736700 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736702 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736708 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736718 */     GIR_RootConstrainSelectedInstOperands,
     /* 736719 */     // GIR_Coverage, 5220,
     /* 736719 */     GIR_EraseRootFromParent_Done,
     /* 736720 */   // Label 9614: @736720
     /* 736720 */   GIM_Try, /*On fail goto*//*Label 9615*/ GIMT_Encode4(736789), // Rule ID 5224 //
     /* 736725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736733 */     // MIs[0] offset
     /* 736733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736736 */     // MIs[0] auxiliary
     /* 736736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736739 */     // MIs[0] Operand 7
     /* 736739 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736757 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9819:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 736760 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736769 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736771 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736787 */     GIR_RootConstrainSelectedInstOperands,
     /* 736788 */     // GIR_Coverage, 5224,
     /* 736788 */     GIR_EraseRootFromParent_Done,
     /* 736789 */   // Label 9615: @736789
     /* 736789 */   GIM_Try, /*On fail goto*//*Label 9616*/ GIMT_Encode4(736859), // Rule ID 5205 //
     /* 736794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736801 */     // MIs[0] offset
     /* 736801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736804 */     // MIs[0] auxiliary
     /* 736804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736807 */     // MIs[0] Operand 7
     /* 736807 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736825 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 736828 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736830 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 736832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736839 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736841 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736847 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736857 */     GIR_RootConstrainSelectedInstOperands,
     /* 736858 */     // GIR_Coverage, 5205,
     /* 736858 */     GIR_EraseRootFromParent_Done,
     /* 736859 */   // Label 9616: @736859
     /* 736859 */   GIM_Try, /*On fail goto*//*Label 9617*/ GIMT_Encode4(736926), // Rule ID 5209 //
     /* 736864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736868 */     // MIs[0] offset
     /* 736868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736871 */     // MIs[0] auxiliary
     /* 736871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736874 */     // MIs[0] Operand 7
     /* 736874 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736892 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 736895 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736897 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 736899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736906 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736908 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736914 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736924 */     GIR_RootConstrainSelectedInstOperands,
     /* 736925 */     // GIR_Coverage, 5209,
     /* 736925 */     GIR_EraseRootFromParent_Done,
     /* 736926 */   // Label 9617: @736926
     /* 736926 */   GIM_Try, /*On fail goto*//*Label 9618*/ GIMT_Encode4(736996), // Rule ID 5213 //
     /* 736931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736938 */     // MIs[0] offset
     /* 736938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736941 */     // MIs[0] auxiliary
     /* 736941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736944 */     // MIs[0] Operand 7
     /* 736944 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736962 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 736965 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736967 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 736969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736976 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736978 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736984 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736994 */     GIR_RootConstrainSelectedInstOperands,
     /* 736995 */     // GIR_Coverage, 5213,
     /* 736995 */     GIR_EraseRootFromParent_Done,
     /* 736996 */   // Label 9618: @736996
     /* 736996 */   GIM_Try, /*On fail goto*//*Label 9619*/ GIMT_Encode4(737063), // Rule ID 5217 //
     /* 737001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737005 */     // MIs[0] offset
     /* 737005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737008 */     // MIs[0] auxiliary
     /* 737008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737011 */     // MIs[0] Operand 7
     /* 737011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737029 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 737032 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737034 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 737036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737043 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737051 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737061 */     GIR_RootConstrainSelectedInstOperands,
     /* 737062 */     // GIR_Coverage, 5217,
     /* 737062 */     GIR_EraseRootFromParent_Done,
     /* 737063 */   // Label 9619: @737063
     /* 737063 */   GIM_Try, /*On fail goto*//*Label 9620*/ GIMT_Encode4(737133), // Rule ID 5221 //
     /* 737068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737071 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737075 */     // MIs[0] offset
     /* 737075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737078 */     // MIs[0] auxiliary
     /* 737078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737081 */     // MIs[0] Operand 7
     /* 737081 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737099 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 737102 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737104 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 737106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737113 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737131 */     GIR_RootConstrainSelectedInstOperands,
     /* 737132 */     // GIR_Coverage, 5221,
     /* 737132 */     GIR_EraseRootFromParent_Done,
     /* 737133 */   // Label 9620: @737133
     /* 737133 */   GIM_Try, /*On fail goto*//*Label 9621*/ GIMT_Encode4(737200), // Rule ID 5225 //
     /* 737138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737142 */     // MIs[0] offset
     /* 737142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737145 */     // MIs[0] auxiliary
     /* 737145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737148 */     // MIs[0] Operand 7
     /* 737148 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737166 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 737169 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737171 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 737173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737180 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737182 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737188 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737198 */     GIR_RootConstrainSelectedInstOperands,
     /* 737199 */     // GIR_Coverage, 5225,
     /* 737199 */     GIR_EraseRootFromParent_Done,
     /* 737200 */   // Label 9621: @737200
     /* 737200 */   GIM_Try, /*On fail goto*//*Label 9622*/ GIMT_Encode4(737262), // Rule ID 5206 //
     /* 737205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737212 */     // MIs[0] offset
     /* 737212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737215 */     // MIs[0] auxiliary
     /* 737215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737218 */     // MIs[0] Operand 7
     /* 737218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737228 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 737231 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737233 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737242 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737250 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737260 */     GIR_RootConstrainSelectedInstOperands,
     /* 737261 */     // GIR_Coverage, 5206,
     /* 737261 */     GIR_EraseRootFromParent_Done,
     /* 737262 */   // Label 9622: @737262
     /* 737262 */   GIM_Try, /*On fail goto*//*Label 9623*/ GIMT_Encode4(737321), // Rule ID 5210 //
     /* 737267 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737271 */     // MIs[0] offset
     /* 737271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737274 */     // MIs[0] auxiliary
     /* 737274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737277 */     // MIs[0] Operand 7
     /* 737277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737287 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 737290 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737292 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737301 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737303 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737309 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737319 */     GIR_RootConstrainSelectedInstOperands,
     /* 737320 */     // GIR_Coverage, 5210,
     /* 737320 */     GIR_EraseRootFromParent_Done,
     /* 737321 */   // Label 9623: @737321
     /* 737321 */   GIM_Try, /*On fail goto*//*Label 9624*/ GIMT_Encode4(737383), // Rule ID 5214 //
     /* 737326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737333 */     // MIs[0] offset
     /* 737333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737336 */     // MIs[0] auxiliary
     /* 737336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737339 */     // MIs[0] Operand 7
     /* 737339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737349 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 737352 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737354 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737363 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737365 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737371 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737381 */     GIR_RootConstrainSelectedInstOperands,
     /* 737382 */     // GIR_Coverage, 5214,
     /* 737382 */     GIR_EraseRootFromParent_Done,
     /* 737383 */   // Label 9624: @737383
     /* 737383 */   GIM_Try, /*On fail goto*//*Label 9625*/ GIMT_Encode4(737442), // Rule ID 5218 //
     /* 737388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737392 */     // MIs[0] offset
     /* 737392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737395 */     // MIs[0] auxiliary
     /* 737395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737398 */     // MIs[0] Operand 7
     /* 737398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737408 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 737411 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737413 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737422 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737440 */     GIR_RootConstrainSelectedInstOperands,
     /* 737441 */     // GIR_Coverage, 5218,
     /* 737441 */     GIR_EraseRootFromParent_Done,
     /* 737442 */   // Label 9625: @737442
     /* 737442 */   GIM_Try, /*On fail goto*//*Label 9626*/ GIMT_Encode4(737504), // Rule ID 5222 //
     /* 737447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737454 */     // MIs[0] offset
     /* 737454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737457 */     // MIs[0] auxiliary
     /* 737457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737460 */     // MIs[0] Operand 7
     /* 737460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737470 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 737473 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737475 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737484 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737492 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737502 */     GIR_RootConstrainSelectedInstOperands,
     /* 737503 */     // GIR_Coverage, 5222,
     /* 737503 */     GIR_EraseRootFromParent_Done,
     /* 737504 */   // Label 9626: @737504
     /* 737504 */   GIM_Try, /*On fail goto*//*Label 9627*/ GIMT_Encode4(737563), // Rule ID 5226 //
     /* 737509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737513 */     // MIs[0] offset
     /* 737513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737516 */     // MIs[0] auxiliary
     /* 737516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737519 */     // MIs[0] Operand 7
     /* 737519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737529 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 737532 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737534 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737543 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737545 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737551 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737561 */     GIR_RootConstrainSelectedInstOperands,
     /* 737562 */     // GIR_Coverage, 5226,
     /* 737562 */     GIR_EraseRootFromParent_Done,
     /* 737563 */   // Label 9627: @737563
     /* 737563 */   GIM_Try, /*On fail goto*//*Label 9628*/ GIMT_Encode4(737663), // Rule ID 5207 //
     /* 737568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737571 */     // MIs[0] offset
     /* 737571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737574 */     // MIs[0] auxiliary
     /* 737574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737577 */     // MIs[0] Operand 7
     /* 737577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737587 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 737590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 737594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 737599 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 737603 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 737606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 737610 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 737613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 737618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 737631 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 737636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737643 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737645 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737651 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737661 */     GIR_RootConstrainSelectedInstOperands,
     /* 737662 */     // GIR_Coverage, 5207,
     /* 737662 */     GIR_EraseRootFromParent_Done,
     /* 737663 */   // Label 9628: @737663
     /* 737663 */   GIM_Try, /*On fail goto*//*Label 9629*/ GIMT_Encode4(737760), // Rule ID 5211 //
     /* 737668 */     // MIs[0] offset
     /* 737668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737671 */     // MIs[0] auxiliary
     /* 737671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737674 */     // MIs[0] Operand 7
     /* 737674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737684 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 737687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 737691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 737696 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 737700 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 737703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 737707 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 737710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 737715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 737728 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 737733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737740 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737742 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737748 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737758 */     GIR_RootConstrainSelectedInstOperands,
     /* 737759 */     // GIR_Coverage, 5211,
     /* 737759 */     GIR_EraseRootFromParent_Done,
     /* 737760 */   // Label 9629: @737760
     /* 737760 */   GIM_Try, /*On fail goto*//*Label 9630*/ GIMT_Encode4(737860), // Rule ID 5215 //
     /* 737765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737768 */     // MIs[0] offset
     /* 737768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737771 */     // MIs[0] auxiliary
     /* 737771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737774 */     // MIs[0] Operand 7
     /* 737774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737784 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 737787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 737791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 737796 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 737800 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 737803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 737807 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 737810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 737815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 737828 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 737833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737840 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737842 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737848 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737858 */     GIR_RootConstrainSelectedInstOperands,
     /* 737859 */     // GIR_Coverage, 5215,
     /* 737859 */     GIR_EraseRootFromParent_Done,
     /* 737860 */   // Label 9630: @737860
     /* 737860 */   GIM_Try, /*On fail goto*//*Label 9631*/ GIMT_Encode4(737957), // Rule ID 5219 //
     /* 737865 */     // MIs[0] offset
     /* 737865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737868 */     // MIs[0] auxiliary
     /* 737868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737871 */     // MIs[0] Operand 7
     /* 737871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737881 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 737884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 737888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 737893 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 737897 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 737900 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 737904 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 737907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 737912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 737925 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 737930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737937 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737939 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737945 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737955 */     GIR_RootConstrainSelectedInstOperands,
     /* 737956 */     // GIR_Coverage, 5219,
     /* 737956 */     GIR_EraseRootFromParent_Done,
     /* 737957 */   // Label 9631: @737957
     /* 737957 */   GIM_Try, /*On fail goto*//*Label 9632*/ GIMT_Encode4(738057), // Rule ID 5223 //
     /* 737962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737965 */     // MIs[0] offset
     /* 737965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737968 */     // MIs[0] auxiliary
     /* 737968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737971 */     // MIs[0] Operand 7
     /* 737971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737981 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 737984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 737988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 737993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 737997 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 738000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 738004 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 738007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 738012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 738025 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 738030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738037 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738039 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738055 */     GIR_RootConstrainSelectedInstOperands,
     /* 738056 */     // GIR_Coverage, 5223,
     /* 738056 */     GIR_EraseRootFromParent_Done,
     /* 738057 */   // Label 9632: @738057
     /* 738057 */   GIM_Try, /*On fail goto*//*Label 9633*/ GIMT_Encode4(738154), // Rule ID 5227 //
     /* 738062 */     // MIs[0] offset
     /* 738062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738065 */     // MIs[0] auxiliary
     /* 738065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738068 */     // MIs[0] Operand 7
     /* 738068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738078 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 738081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 738085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 738090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 738094 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 738097 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 738101 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 738104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 738109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 738122 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 738127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738134 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738136 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738142 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738152 */     GIR_RootConstrainSelectedInstOperands,
     /* 738153 */     // GIR_Coverage, 5227,
     /* 738153 */     GIR_EraseRootFromParent_Done,
     /* 738154 */   // Label 9633: @738154
     /* 738154 */   GIM_Reject,
     /* 738155 */ // Label 9609: @738155
     /* 738155 */ GIM_Reject,
     /* 738156 */ // Label 9589: @738156
     /* 738156 */ GIM_Try, /*On fail goto*//*Label 9634*/ GIMT_Encode4(739366),
     /* 738161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 738164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 738167 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 738170 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 738173 */   GIM_Try, /*On fail goto*//*Label 9635*/ GIMT_Encode4(738245), // Rule ID 5228 //
     /* 738178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738189 */     // MIs[0] offset
     /* 738189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738192 */     // MIs[0] auxiliary
     /* 738192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738195 */     // MIs[0] Operand 7
     /* 738195 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738213 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9818:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
     /* 738216 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738225 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738227 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738233 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738243 */     GIR_RootConstrainSelectedInstOperands,
     /* 738244 */     // GIR_Coverage, 5228,
     /* 738244 */     GIR_EraseRootFromParent_Done,
     /* 738245 */   // Label 9635: @738245
     /* 738245 */   GIM_Try, /*On fail goto*//*Label 9636*/ GIMT_Encode4(738314), // Rule ID 5232 //
     /* 738250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738258 */     // MIs[0] offset
     /* 738258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738261 */     // MIs[0] auxiliary
     /* 738261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738264 */     // MIs[0] Operand 7
     /* 738264 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738282 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9818:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
     /* 738285 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738294 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738296 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738302 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738312 */     GIR_RootConstrainSelectedInstOperands,
     /* 738313 */     // GIR_Coverage, 5232,
     /* 738313 */     GIR_EraseRootFromParent_Done,
     /* 738314 */   // Label 9636: @738314
     /* 738314 */   GIM_Try, /*On fail goto*//*Label 9637*/ GIMT_Encode4(738386), // Rule ID 5236 //
     /* 738319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738330 */     // MIs[0] offset
     /* 738330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738333 */     // MIs[0] auxiliary
     /* 738333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738336 */     // MIs[0] Operand 7
     /* 738336 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738354 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9818:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
     /* 738357 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738366 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738368 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738374 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738384 */     GIR_RootConstrainSelectedInstOperands,
     /* 738385 */     // GIR_Coverage, 5236,
     /* 738385 */     GIR_EraseRootFromParent_Done,
     /* 738386 */   // Label 9637: @738386
     /* 738386 */   GIM_Try, /*On fail goto*//*Label 9638*/ GIMT_Encode4(738455), // Rule ID 5240 //
     /* 738391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738399 */     // MIs[0] offset
     /* 738399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738402 */     // MIs[0] auxiliary
     /* 738402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738405 */     // MIs[0] Operand 7
     /* 738405 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738423 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9818:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
     /* 738426 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738435 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738437 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738443 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738453 */     GIR_RootConstrainSelectedInstOperands,
     /* 738454 */     // GIR_Coverage, 5240,
     /* 738454 */     GIR_EraseRootFromParent_Done,
     /* 738455 */   // Label 9638: @738455
     /* 738455 */   GIM_Try, /*On fail goto*//*Label 9639*/ GIMT_Encode4(738525), // Rule ID 5229 //
     /* 738460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738467 */     // MIs[0] offset
     /* 738467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738470 */     // MIs[0] auxiliary
     /* 738470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738473 */     // MIs[0] Operand 7
     /* 738473 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738491 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
     /* 738494 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738496 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 738498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738505 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738513 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738523 */     GIR_RootConstrainSelectedInstOperands,
     /* 738524 */     // GIR_Coverage, 5229,
     /* 738524 */     GIR_EraseRootFromParent_Done,
     /* 738525 */   // Label 9639: @738525
     /* 738525 */   GIM_Try, /*On fail goto*//*Label 9640*/ GIMT_Encode4(738592), // Rule ID 5233 //
     /* 738530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738534 */     // MIs[0] offset
     /* 738534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738537 */     // MIs[0] auxiliary
     /* 738537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738540 */     // MIs[0] Operand 7
     /* 738540 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738558 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
     /* 738561 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738563 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 738565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738572 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738574 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738580 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738590 */     GIR_RootConstrainSelectedInstOperands,
     /* 738591 */     // GIR_Coverage, 5233,
     /* 738591 */     GIR_EraseRootFromParent_Done,
     /* 738592 */   // Label 9640: @738592
     /* 738592 */   GIM_Try, /*On fail goto*//*Label 9641*/ GIMT_Encode4(738662), // Rule ID 5237 //
     /* 738597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738604 */     // MIs[0] offset
     /* 738604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738607 */     // MIs[0] auxiliary
     /* 738607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738610 */     // MIs[0] Operand 7
     /* 738610 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738628 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
     /* 738631 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738633 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 738635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738642 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738644 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738650 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738660 */     GIR_RootConstrainSelectedInstOperands,
     /* 738661 */     // GIR_Coverage, 5237,
     /* 738661 */     GIR_EraseRootFromParent_Done,
     /* 738662 */   // Label 9641: @738662
     /* 738662 */   GIM_Try, /*On fail goto*//*Label 9642*/ GIMT_Encode4(738729), // Rule ID 5241 //
     /* 738667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738671 */     // MIs[0] offset
     /* 738671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738674 */     // MIs[0] auxiliary
     /* 738674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738677 */     // MIs[0] Operand 7
     /* 738677 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738695 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
     /* 738698 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738700 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 738702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738709 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738711 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738727 */     GIR_RootConstrainSelectedInstOperands,
     /* 738728 */     // GIR_Coverage, 5241,
     /* 738728 */     GIR_EraseRootFromParent_Done,
     /* 738729 */   // Label 9642: @738729
     /* 738729 */   GIM_Try, /*On fail goto*//*Label 9643*/ GIMT_Encode4(738791), // Rule ID 5230 //
     /* 738734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738741 */     // MIs[0] offset
     /* 738741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738744 */     // MIs[0] auxiliary
     /* 738744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738747 */     // MIs[0] Operand 7
     /* 738747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738757 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
     /* 738760 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738762 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 738764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738771 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738773 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738789 */     GIR_RootConstrainSelectedInstOperands,
     /* 738790 */     // GIR_Coverage, 5230,
     /* 738790 */     GIR_EraseRootFromParent_Done,
     /* 738791 */   // Label 9643: @738791
     /* 738791 */   GIM_Try, /*On fail goto*//*Label 9644*/ GIMT_Encode4(738850), // Rule ID 5234 //
     /* 738796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738800 */     // MIs[0] offset
     /* 738800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738803 */     // MIs[0] auxiliary
     /* 738803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738806 */     // MIs[0] Operand 7
     /* 738806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738816 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
     /* 738819 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738821 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 738823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738830 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738832 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738838 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738848 */     GIR_RootConstrainSelectedInstOperands,
     /* 738849 */     // GIR_Coverage, 5234,
     /* 738849 */     GIR_EraseRootFromParent_Done,
     /* 738850 */   // Label 9644: @738850
     /* 738850 */   GIM_Try, /*On fail goto*//*Label 9645*/ GIMT_Encode4(738912), // Rule ID 5238 //
     /* 738855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738862 */     // MIs[0] offset
     /* 738862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738865 */     // MIs[0] auxiliary
     /* 738865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738868 */     // MIs[0] Operand 7
     /* 738868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738878 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
     /* 738881 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738883 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 738885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738892 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738894 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738900 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738910 */     GIR_RootConstrainSelectedInstOperands,
     /* 738911 */     // GIR_Coverage, 5238,
     /* 738911 */     GIR_EraseRootFromParent_Done,
     /* 738912 */   // Label 9645: @738912
     /* 738912 */   GIM_Try, /*On fail goto*//*Label 9646*/ GIMT_Encode4(738971), // Rule ID 5242 //
     /* 738917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738921 */     // MIs[0] offset
     /* 738921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738924 */     // MIs[0] auxiliary
     /* 738924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738927 */     // MIs[0] Operand 7
     /* 738927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738937 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
     /* 738940 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738942 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 738944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738951 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738969 */     GIR_RootConstrainSelectedInstOperands,
     /* 738970 */     // GIR_Coverage, 5242,
     /* 738970 */     GIR_EraseRootFromParent_Done,
     /* 738971 */   // Label 9646: @738971
     /* 738971 */   GIM_Try, /*On fail goto*//*Label 9647*/ GIMT_Encode4(739071), // Rule ID 5231 //
     /* 738976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738979 */     // MIs[0] offset
     /* 738979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738982 */     // MIs[0] auxiliary
     /* 738982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738985 */     // MIs[0] Operand 7
     /* 738985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738995 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 738998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 739002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 739007 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 739011 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 739014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 739018 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 739021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 739026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
     /* 739039 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 739044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739051 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739053 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739059 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739069 */     GIR_RootConstrainSelectedInstOperands,
     /* 739070 */     // GIR_Coverage, 5231,
     /* 739070 */     GIR_EraseRootFromParent_Done,
     /* 739071 */   // Label 9647: @739071
     /* 739071 */   GIM_Try, /*On fail goto*//*Label 9648*/ GIMT_Encode4(739168), // Rule ID 5235 //
     /* 739076 */     // MIs[0] offset
     /* 739076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739079 */     // MIs[0] auxiliary
     /* 739079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739082 */     // MIs[0] Operand 7
     /* 739082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739092 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 739095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 739099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 739104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 739108 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 739111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 739115 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 739118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 739123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
     /* 739136 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 739141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739148 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739150 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739156 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739166 */     GIR_RootConstrainSelectedInstOperands,
     /* 739167 */     // GIR_Coverage, 5235,
     /* 739167 */     GIR_EraseRootFromParent_Done,
     /* 739168 */   // Label 9648: @739168
     /* 739168 */   GIM_Try, /*On fail goto*//*Label 9649*/ GIMT_Encode4(739268), // Rule ID 5239 //
     /* 739173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739176 */     // MIs[0] offset
     /* 739176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739179 */     // MIs[0] auxiliary
     /* 739179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739182 */     // MIs[0] Operand 7
     /* 739182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739192 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 739195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 739199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 739204 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 739208 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 739211 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 739215 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 739218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 739223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
     /* 739236 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 739241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739248 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739250 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739256 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739266 */     GIR_RootConstrainSelectedInstOperands,
     /* 739267 */     // GIR_Coverage, 5239,
     /* 739267 */     GIR_EraseRootFromParent_Done,
     /* 739268 */   // Label 9649: @739268
     /* 739268 */   GIM_Try, /*On fail goto*//*Label 9650*/ GIMT_Encode4(739365), // Rule ID 5243 //
     /* 739273 */     // MIs[0] offset
     /* 739273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739276 */     // MIs[0] auxiliary
     /* 739276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739279 */     // MIs[0] Operand 7
     /* 739279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739289 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 739292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 739296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 739301 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 739305 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 739308 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 739312 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 739315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 739320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
     /* 739333 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 739338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739345 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739347 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739353 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739363 */     GIR_RootConstrainSelectedInstOperands,
     /* 739364 */     // GIR_Coverage, 5243,
     /* 739364 */     GIR_EraseRootFromParent_Done,
     /* 739365 */   // Label 9650: @739365
     /* 739365 */   GIM_Reject,
     /* 739366 */ // Label 9634: @739366
     /* 739366 */ GIM_Reject,
     /* 739367 */ // Label 9590: @739367
     /* 739367 */ GIM_Try, /*On fail goto*//*Label 9651*/ GIMT_Encode4(740577),
     /* 739372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 739375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 739378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 739381 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 739384 */   GIM_Try, /*On fail goto*//*Label 9652*/ GIMT_Encode4(739456), // Rule ID 5244 //
     /* 739389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739400 */     // MIs[0] offset
     /* 739400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739403 */     // MIs[0] auxiliary
     /* 739403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739406 */     // MIs[0] Operand 7
     /* 739406 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739424 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9817:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
     /* 739427 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739436 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739438 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739444 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739454 */     GIR_RootConstrainSelectedInstOperands,
     /* 739455 */     // GIR_Coverage, 5244,
     /* 739455 */     GIR_EraseRootFromParent_Done,
     /* 739456 */   // Label 9652: @739456
     /* 739456 */   GIM_Try, /*On fail goto*//*Label 9653*/ GIMT_Encode4(739525), // Rule ID 5248 //
     /* 739461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739469 */     // MIs[0] offset
     /* 739469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739472 */     // MIs[0] auxiliary
     /* 739472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739475 */     // MIs[0] Operand 7
     /* 739475 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739493 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9817:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
     /* 739496 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739505 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739513 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739523 */     GIR_RootConstrainSelectedInstOperands,
     /* 739524 */     // GIR_Coverage, 5248,
     /* 739524 */     GIR_EraseRootFromParent_Done,
     /* 739525 */   // Label 9653: @739525
     /* 739525 */   GIM_Try, /*On fail goto*//*Label 9654*/ GIMT_Encode4(739597), // Rule ID 5252 //
     /* 739530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739541 */     // MIs[0] offset
     /* 739541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739544 */     // MIs[0] auxiliary
     /* 739544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739547 */     // MIs[0] Operand 7
     /* 739547 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739565 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9817:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
     /* 739568 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739577 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739579 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739595 */     GIR_RootConstrainSelectedInstOperands,
     /* 739596 */     // GIR_Coverage, 5252,
     /* 739596 */     GIR_EraseRootFromParent_Done,
     /* 739597 */   // Label 9654: @739597
     /* 739597 */   GIM_Try, /*On fail goto*//*Label 9655*/ GIMT_Encode4(739666), // Rule ID 5256 //
     /* 739602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739610 */     // MIs[0] offset
     /* 739610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739613 */     // MIs[0] auxiliary
     /* 739613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739616 */     // MIs[0] Operand 7
     /* 739616 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739634 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9817:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
     /* 739637 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739646 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739664 */     GIR_RootConstrainSelectedInstOperands,
     /* 739665 */     // GIR_Coverage, 5256,
     /* 739665 */     GIR_EraseRootFromParent_Done,
     /* 739666 */   // Label 9655: @739666
     /* 739666 */   GIM_Try, /*On fail goto*//*Label 9656*/ GIMT_Encode4(739736), // Rule ID 5245 //
     /* 739671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739678 */     // MIs[0] offset
     /* 739678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739681 */     // MIs[0] auxiliary
     /* 739681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739684 */     // MIs[0] Operand 7
     /* 739684 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739702 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
     /* 739705 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739707 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 739709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739716 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739734 */     GIR_RootConstrainSelectedInstOperands,
     /* 739735 */     // GIR_Coverage, 5245,
     /* 739735 */     GIR_EraseRootFromParent_Done,
     /* 739736 */   // Label 9656: @739736
     /* 739736 */   GIM_Try, /*On fail goto*//*Label 9657*/ GIMT_Encode4(739803), // Rule ID 5249 //
     /* 739741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739745 */     // MIs[0] offset
     /* 739745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739748 */     // MIs[0] auxiliary
     /* 739748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739751 */     // MIs[0] Operand 7
     /* 739751 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739769 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
     /* 739772 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739774 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 739776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739783 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739791 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739801 */     GIR_RootConstrainSelectedInstOperands,
     /* 739802 */     // GIR_Coverage, 5249,
     /* 739802 */     GIR_EraseRootFromParent_Done,
     /* 739803 */   // Label 9657: @739803
     /* 739803 */   GIM_Try, /*On fail goto*//*Label 9658*/ GIMT_Encode4(739873), // Rule ID 5253 //
     /* 739808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739815 */     // MIs[0] offset
     /* 739815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739818 */     // MIs[0] auxiliary
     /* 739818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739821 */     // MIs[0] Operand 7
     /* 739821 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739839 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
     /* 739842 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739844 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 739846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739853 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739855 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739861 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739871 */     GIR_RootConstrainSelectedInstOperands,
     /* 739872 */     // GIR_Coverage, 5253,
     /* 739872 */     GIR_EraseRootFromParent_Done,
     /* 739873 */   // Label 9658: @739873
     /* 739873 */   GIM_Try, /*On fail goto*//*Label 9659*/ GIMT_Encode4(739940), // Rule ID 5257 //
     /* 739878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739882 */     // MIs[0] offset
     /* 739882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739885 */     // MIs[0] auxiliary
     /* 739885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739888 */     // MIs[0] Operand 7
     /* 739888 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739906 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
     /* 739909 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739911 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 739913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739920 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739928 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739938 */     GIR_RootConstrainSelectedInstOperands,
     /* 739939 */     // GIR_Coverage, 5257,
     /* 739939 */     GIR_EraseRootFromParent_Done,
     /* 739940 */   // Label 9659: @739940
     /* 739940 */   GIM_Try, /*On fail goto*//*Label 9660*/ GIMT_Encode4(740002), // Rule ID 5246 //
     /* 739945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739952 */     // MIs[0] offset
     /* 739952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739955 */     // MIs[0] auxiliary
     /* 739955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739958 */     // MIs[0] Operand 7
     /* 739958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739968 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
     /* 739971 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739973 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 739975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739982 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739984 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739990 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740000 */     GIR_RootConstrainSelectedInstOperands,
     /* 740001 */     // GIR_Coverage, 5246,
     /* 740001 */     GIR_EraseRootFromParent_Done,
     /* 740002 */   // Label 9660: @740002
     /* 740002 */   GIM_Try, /*On fail goto*//*Label 9661*/ GIMT_Encode4(740061), // Rule ID 5250 //
     /* 740007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740011 */     // MIs[0] offset
     /* 740011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740014 */     // MIs[0] auxiliary
     /* 740014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740017 */     // MIs[0] Operand 7
     /* 740017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740027 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
     /* 740030 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740032 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 740034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740041 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740043 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740049 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740059 */     GIR_RootConstrainSelectedInstOperands,
     /* 740060 */     // GIR_Coverage, 5250,
     /* 740060 */     GIR_EraseRootFromParent_Done,
     /* 740061 */   // Label 9661: @740061
     /* 740061 */   GIM_Try, /*On fail goto*//*Label 9662*/ GIMT_Encode4(740123), // Rule ID 5254 //
     /* 740066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740073 */     // MIs[0] offset
     /* 740073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740076 */     // MIs[0] auxiliary
     /* 740076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740079 */     // MIs[0] Operand 7
     /* 740079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740089 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
     /* 740092 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740094 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 740096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740103 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740111 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740121 */     GIR_RootConstrainSelectedInstOperands,
     /* 740122 */     // GIR_Coverage, 5254,
     /* 740122 */     GIR_EraseRootFromParent_Done,
     /* 740123 */   // Label 9662: @740123
     /* 740123 */   GIM_Try, /*On fail goto*//*Label 9663*/ GIMT_Encode4(740182), // Rule ID 5258 //
     /* 740128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740132 */     // MIs[0] offset
     /* 740132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740135 */     // MIs[0] auxiliary
     /* 740135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740138 */     // MIs[0] Operand 7
     /* 740138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740148 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
     /* 740151 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740153 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 740155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740162 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740164 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740170 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740180 */     GIR_RootConstrainSelectedInstOperands,
     /* 740181 */     // GIR_Coverage, 5258,
     /* 740181 */     GIR_EraseRootFromParent_Done,
     /* 740182 */   // Label 9663: @740182
     /* 740182 */   GIM_Try, /*On fail goto*//*Label 9664*/ GIMT_Encode4(740282), // Rule ID 5247 //
     /* 740187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740190 */     // MIs[0] offset
     /* 740190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740193 */     // MIs[0] auxiliary
     /* 740193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740196 */     // MIs[0] Operand 7
     /* 740196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740206 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 740209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 740213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 740218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 740222 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 740225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 740229 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 740232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 740237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
     /* 740250 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 740255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740262 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740264 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740270 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740280 */     GIR_RootConstrainSelectedInstOperands,
     /* 740281 */     // GIR_Coverage, 5247,
     /* 740281 */     GIR_EraseRootFromParent_Done,
     /* 740282 */   // Label 9664: @740282
     /* 740282 */   GIM_Try, /*On fail goto*//*Label 9665*/ GIMT_Encode4(740379), // Rule ID 5251 //
     /* 740287 */     // MIs[0] offset
     /* 740287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740290 */     // MIs[0] auxiliary
     /* 740290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740293 */     // MIs[0] Operand 7
     /* 740293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740303 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 740306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 740310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 740315 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 740319 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 740322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 740326 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 740329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 740334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
     /* 740347 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 740352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740359 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740361 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740367 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740377 */     GIR_RootConstrainSelectedInstOperands,
     /* 740378 */     // GIR_Coverage, 5251,
     /* 740378 */     GIR_EraseRootFromParent_Done,
     /* 740379 */   // Label 9665: @740379
     /* 740379 */   GIM_Try, /*On fail goto*//*Label 9666*/ GIMT_Encode4(740479), // Rule ID 5255 //
     /* 740384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740387 */     // MIs[0] offset
     /* 740387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740390 */     // MIs[0] auxiliary
     /* 740390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740393 */     // MIs[0] Operand 7
     /* 740393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740403 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 740406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 740410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 740415 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 740419 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 740422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 740426 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 740429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 740434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
     /* 740447 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 740452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740459 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740461 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740467 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740477 */     GIR_RootConstrainSelectedInstOperands,
     /* 740478 */     // GIR_Coverage, 5255,
     /* 740478 */     GIR_EraseRootFromParent_Done,
     /* 740479 */   // Label 9666: @740479
     /* 740479 */   GIM_Try, /*On fail goto*//*Label 9667*/ GIMT_Encode4(740576), // Rule ID 5259 //
     /* 740484 */     // MIs[0] offset
     /* 740484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740487 */     // MIs[0] auxiliary
     /* 740487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740490 */     // MIs[0] Operand 7
     /* 740490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740500 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 740503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 740507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 740512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 740516 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 740519 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 740523 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 740526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 740531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
     /* 740544 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 740549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740556 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740558 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740574 */     GIR_RootConstrainSelectedInstOperands,
     /* 740575 */     // GIR_Coverage, 5259,
     /* 740575 */     GIR_EraseRootFromParent_Done,
     /* 740576 */   // Label 9667: @740576
     /* 740576 */   GIM_Reject,
     /* 740577 */ // Label 9651: @740577
     /* 740577 */ GIM_Reject,
     /* 740578 */ // Label 9591: @740578
     /* 740578 */ GIM_Reject,
     /* 740579 */ // Label 141: @740579
     /* 740579 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 9675*/ GIMT_Encode4(746843),
     /* 740590 */ /*GILLT_s16*//*Label 9668*/ GIMT_Encode4(740630),
     /* 740594 */ /*GILLT_s32*//*Label 9669*/ GIMT_Encode4(742473), GIMT_Encode4(0),
     /* 740602 */ /*GILLT_v2s16*//*Label 9670*/ GIMT_Encode4(743404),
     /* 740606 */ /*GILLT_v2s32*//*Label 9671*/ GIMT_Encode4(744639), GIMT_Encode4(0),
     /* 740614 */ /*GILLT_v3s32*//*Label 9672*/ GIMT_Encode4(744962), GIMT_Encode4(0),
     /* 740622 */ /*GILLT_v4s16*//*Label 9673*/ GIMT_Encode4(745285),
     /* 740626 */ /*GILLT_v4s32*//*Label 9674*/ GIMT_Encode4(746520),
     /* 740630 */ // Label 9668: @740630
     /* 740630 */ GIM_Try, /*On fail goto*//*Label 9676*/ GIMT_Encode4(742472),
     /* 740635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 740638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 740641 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 740644 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 740647 */   GIM_Try, /*On fail goto*//*Label 9677*/ GIMT_Encode4(740719), // Rule ID 5260 //
     /* 740652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 740655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740663 */     // MIs[0] offset
     /* 740663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740666 */     // MIs[0] auxiliary
     /* 740666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740669 */     // MIs[0] Operand 7
     /* 740669 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740687 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9820:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 740690 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740699 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740701 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740707 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740717 */     GIR_RootConstrainSelectedInstOperands,
     /* 740718 */     // GIR_Coverage, 5260,
     /* 740718 */     GIR_EraseRootFromParent_Done,
     /* 740719 */   // Label 9677: @740719
     /* 740719 */   GIM_Try, /*On fail goto*//*Label 9678*/ GIMT_Encode4(740791), // Rule ID 5264 //
     /* 740724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 740727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740735 */     // MIs[0] offset
     /* 740735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740738 */     // MIs[0] auxiliary
     /* 740738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740741 */     // MIs[0] Operand 7
     /* 740741 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740759 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9820:{ *:[i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 740762 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740771 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740773 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740789 */     GIR_RootConstrainSelectedInstOperands,
     /* 740790 */     // GIR_Coverage, 5264,
     /* 740790 */     GIR_EraseRootFromParent_Done,
     /* 740791 */   // Label 9678: @740791
     /* 740791 */   GIM_Try, /*On fail goto*//*Label 9679*/ GIMT_Encode4(740863), // Rule ID 5284 //
     /* 740796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 740799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740807 */     // MIs[0] offset
     /* 740807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740810 */     // MIs[0] auxiliary
     /* 740810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740813 */     // MIs[0] Operand 7
     /* 740813 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740831 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9820:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 740834 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740843 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740845 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740851 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740861 */     GIR_RootConstrainSelectedInstOperands,
     /* 740862 */     // GIR_Coverage, 5284,
     /* 740862 */     GIR_EraseRootFromParent_Done,
     /* 740863 */   // Label 9679: @740863
     /* 740863 */   GIM_Try, /*On fail goto*//*Label 9680*/ GIMT_Encode4(740935), // Rule ID 5288 //
     /* 740868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 740871 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740879 */     // MIs[0] offset
     /* 740879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740882 */     // MIs[0] auxiliary
     /* 740882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740885 */     // MIs[0] Operand 7
     /* 740885 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740903 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9820:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 740906 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740915 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740917 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740923 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740933 */     GIR_RootConstrainSelectedInstOperands,
     /* 740934 */     // GIR_Coverage, 5288,
     /* 740934 */     GIR_EraseRootFromParent_Done,
     /* 740935 */   // Label 9680: @740935
     /* 740935 */   GIM_Try, /*On fail goto*//*Label 9681*/ GIMT_Encode4(741007), // Rule ID 5292 //
     /* 740940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 740943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740951 */     // MIs[0] offset
     /* 740951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740954 */     // MIs[0] auxiliary
     /* 740954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740957 */     // MIs[0] Operand 7
     /* 740957 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740975 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9820:{ *:[i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 740978 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740987 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740989 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740995 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741005 */     GIR_RootConstrainSelectedInstOperands,
     /* 741006 */     // GIR_Coverage, 5292,
     /* 741006 */     GIR_EraseRootFromParent_Done,
     /* 741007 */   // Label 9681: @741007
     /* 741007 */   GIM_Try, /*On fail goto*//*Label 9682*/ GIMT_Encode4(741079), // Rule ID 5296 //
     /* 741012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 741015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741023 */     // MIs[0] offset
     /* 741023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741026 */     // MIs[0] auxiliary
     /* 741026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741029 */     // MIs[0] Operand 7
     /* 741029 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741047 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9820:{ *:[i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 741050 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741059 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741061 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741067 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741077 */     GIR_RootConstrainSelectedInstOperands,
     /* 741078 */     // GIR_Coverage, 5296,
     /* 741078 */     GIR_EraseRootFromParent_Done,
     /* 741079 */   // Label 9682: @741079
     /* 741079 */   GIM_Try, /*On fail goto*//*Label 9683*/ GIMT_Encode4(741149), // Rule ID 5261 //
     /* 741084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 741087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741091 */     // MIs[0] offset
     /* 741091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741094 */     // MIs[0] auxiliary
     /* 741094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741097 */     // MIs[0] Operand 7
     /* 741097 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741115 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9820:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 741118 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741120 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741129 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741131 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741137 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741147 */     GIR_RootConstrainSelectedInstOperands,
     /* 741148 */     // GIR_Coverage, 5261,
     /* 741148 */     GIR_EraseRootFromParent_Done,
     /* 741149 */   // Label 9683: @741149
     /* 741149 */   GIM_Try, /*On fail goto*//*Label 9684*/ GIMT_Encode4(741219), // Rule ID 5265 //
     /* 741154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 741157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741161 */     // MIs[0] offset
     /* 741161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741164 */     // MIs[0] auxiliary
     /* 741164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741167 */     // MIs[0] Operand 7
     /* 741167 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741185 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9820:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 741188 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741190 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741199 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741201 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741207 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741217 */     GIR_RootConstrainSelectedInstOperands,
     /* 741218 */     // GIR_Coverage, 5265,
     /* 741218 */     GIR_EraseRootFromParent_Done,
     /* 741219 */   // Label 9684: @741219
     /* 741219 */   GIM_Try, /*On fail goto*//*Label 9685*/ GIMT_Encode4(741289), // Rule ID 5285 //
     /* 741224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 741227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741231 */     // MIs[0] offset
     /* 741231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741234 */     // MIs[0] auxiliary
     /* 741234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741237 */     // MIs[0] Operand 7
     /* 741237 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741255 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9820:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 741258 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741260 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741269 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741277 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741287 */     GIR_RootConstrainSelectedInstOperands,
     /* 741288 */     // GIR_Coverage, 5285,
     /* 741288 */     GIR_EraseRootFromParent_Done,
     /* 741289 */   // Label 9685: @741289
     /* 741289 */   GIM_Try, /*On fail goto*//*Label 9686*/ GIMT_Encode4(741359), // Rule ID 5289 //
     /* 741294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 741297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741301 */     // MIs[0] offset
     /* 741301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741304 */     // MIs[0] auxiliary
     /* 741304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741307 */     // MIs[0] Operand 7
     /* 741307 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741325 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9820:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 741328 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741330 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741339 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741341 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741347 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741357 */     GIR_RootConstrainSelectedInstOperands,
     /* 741358 */     // GIR_Coverage, 5289,
     /* 741358 */     GIR_EraseRootFromParent_Done,
     /* 741359 */   // Label 9686: @741359
     /* 741359 */   GIM_Try, /*On fail goto*//*Label 9687*/ GIMT_Encode4(741429), // Rule ID 5293 //
     /* 741364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 741367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741371 */     // MIs[0] offset
     /* 741371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741374 */     // MIs[0] auxiliary
     /* 741374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741377 */     // MIs[0] Operand 7
     /* 741377 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741395 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9820:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 741398 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741400 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741409 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741411 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741427 */     GIR_RootConstrainSelectedInstOperands,
     /* 741428 */     // GIR_Coverage, 5293,
     /* 741428 */     GIR_EraseRootFromParent_Done,
     /* 741429 */   // Label 9687: @741429
     /* 741429 */   GIM_Try, /*On fail goto*//*Label 9688*/ GIMT_Encode4(741499), // Rule ID 5297 //
     /* 741434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 741437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741441 */     // MIs[0] offset
     /* 741441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741444 */     // MIs[0] auxiliary
     /* 741444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741447 */     // MIs[0] Operand 7
     /* 741447 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741465 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9820:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 741468 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741470 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741479 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741481 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741487 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741497 */     GIR_RootConstrainSelectedInstOperands,
     /* 741498 */     // GIR_Coverage, 5297,
     /* 741498 */     GIR_EraseRootFromParent_Done,
     /* 741499 */   // Label 9688: @741499
     /* 741499 */   GIM_Try, /*On fail goto*//*Label 9689*/ GIMT_Encode4(741561), // Rule ID 5262 //
     /* 741504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 741507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741511 */     // MIs[0] offset
     /* 741511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741514 */     // MIs[0] auxiliary
     /* 741514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741517 */     // MIs[0] Operand 7
     /* 741517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741527 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9820:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 741530 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741532 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741541 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741543 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741549 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741559 */     GIR_RootConstrainSelectedInstOperands,
     /* 741560 */     // GIR_Coverage, 5262,
     /* 741560 */     GIR_EraseRootFromParent_Done,
     /* 741561 */   // Label 9689: @741561
     /* 741561 */   GIM_Try, /*On fail goto*//*Label 9690*/ GIMT_Encode4(741623), // Rule ID 5266 //
     /* 741566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 741569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741573 */     // MIs[0] offset
     /* 741573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741576 */     // MIs[0] auxiliary
     /* 741576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741579 */     // MIs[0] Operand 7
     /* 741579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741589 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9820:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 741592 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741594 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741603 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741605 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741611 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741621 */     GIR_RootConstrainSelectedInstOperands,
     /* 741622 */     // GIR_Coverage, 5266,
     /* 741622 */     GIR_EraseRootFromParent_Done,
     /* 741623 */   // Label 9690: @741623
     /* 741623 */   GIM_Try, /*On fail goto*//*Label 9691*/ GIMT_Encode4(741685), // Rule ID 5286 //
     /* 741628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 741631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741635 */     // MIs[0] offset
     /* 741635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741638 */     // MIs[0] auxiliary
     /* 741638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741641 */     // MIs[0] Operand 7
     /* 741641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741651 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9820:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 741654 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741656 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741665 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741667 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741673 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741683 */     GIR_RootConstrainSelectedInstOperands,
     /* 741684 */     // GIR_Coverage, 5286,
     /* 741684 */     GIR_EraseRootFromParent_Done,
     /* 741685 */   // Label 9691: @741685
     /* 741685 */   GIM_Try, /*On fail goto*//*Label 9692*/ GIMT_Encode4(741747), // Rule ID 5290 //
     /* 741690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 741693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741697 */     // MIs[0] offset
     /* 741697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741700 */     // MIs[0] auxiliary
     /* 741700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741703 */     // MIs[0] Operand 7
     /* 741703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741713 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9820:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 741716 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741718 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741727 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741729 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741735 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741745 */     GIR_RootConstrainSelectedInstOperands,
     /* 741746 */     // GIR_Coverage, 5290,
     /* 741746 */     GIR_EraseRootFromParent_Done,
     /* 741747 */   // Label 9692: @741747
     /* 741747 */   GIM_Try, /*On fail goto*//*Label 9693*/ GIMT_Encode4(741809), // Rule ID 5294 //
     /* 741752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 741755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741759 */     // MIs[0] offset
     /* 741759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741762 */     // MIs[0] auxiliary
     /* 741762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741765 */     // MIs[0] Operand 7
     /* 741765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741775 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9820:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 741778 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741780 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741789 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741791 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741807 */     GIR_RootConstrainSelectedInstOperands,
     /* 741808 */     // GIR_Coverage, 5294,
     /* 741808 */     GIR_EraseRootFromParent_Done,
     /* 741809 */   // Label 9693: @741809
     /* 741809 */   GIM_Try, /*On fail goto*//*Label 9694*/ GIMT_Encode4(741871), // Rule ID 5298 //
     /* 741814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 741817 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741821 */     // MIs[0] offset
     /* 741821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741824 */     // MIs[0] auxiliary
     /* 741824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741827 */     // MIs[0] Operand 7
     /* 741827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741837 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9820:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 741840 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741842 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741851 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741853 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741859 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741869 */     GIR_RootConstrainSelectedInstOperands,
     /* 741870 */     // GIR_Coverage, 5298,
     /* 741870 */     GIR_EraseRootFromParent_Done,
     /* 741871 */   // Label 9694: @741871
     /* 741871 */   GIM_Try, /*On fail goto*//*Label 9695*/ GIMT_Encode4(741971), // Rule ID 5263 //
     /* 741876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 741879 */     // MIs[0] offset
     /* 741879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741882 */     // MIs[0] auxiliary
     /* 741882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741885 */     // MIs[0] Operand 7
     /* 741885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741895 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9820:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 741898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 741902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 741907 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 741911 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 741914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 741918 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 741921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 741926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 741931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 741936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 741939 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 741944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741951 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741969 */     GIR_RootConstrainSelectedInstOperands,
     /* 741970 */     // GIR_Coverage, 5263,
     /* 741970 */     GIR_EraseRootFromParent_Done,
     /* 741971 */   // Label 9695: @741971
     /* 741971 */   GIM_Try, /*On fail goto*//*Label 9696*/ GIMT_Encode4(742071), // Rule ID 5267 //
     /* 741976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 741979 */     // MIs[0] offset
     /* 741979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741982 */     // MIs[0] auxiliary
     /* 741982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741985 */     // MIs[0] Operand 7
     /* 741985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741995 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9820:{ *:[i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 741998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742007 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742011 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742018 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 742039 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742051 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742053 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742059 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742069 */     GIR_RootConstrainSelectedInstOperands,
     /* 742070 */     // GIR_Coverage, 5267,
     /* 742070 */     GIR_EraseRootFromParent_Done,
     /* 742071 */   // Label 9696: @742071
     /* 742071 */   GIM_Try, /*On fail goto*//*Label 9697*/ GIMT_Encode4(742171), // Rule ID 5287 //
     /* 742076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 742079 */     // MIs[0] offset
     /* 742079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742082 */     // MIs[0] auxiliary
     /* 742082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742085 */     // MIs[0] Operand 7
     /* 742085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742095 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9820:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742107 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742111 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742118 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 742139 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742151 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742153 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742159 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742169 */     GIR_RootConstrainSelectedInstOperands,
     /* 742170 */     // GIR_Coverage, 5287,
     /* 742170 */     GIR_EraseRootFromParent_Done,
     /* 742171 */   // Label 9697: @742171
     /* 742171 */   GIM_Try, /*On fail goto*//*Label 9698*/ GIMT_Encode4(742271), // Rule ID 5291 //
     /* 742176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 742179 */     // MIs[0] offset
     /* 742179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742182 */     // MIs[0] auxiliary
     /* 742182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742185 */     // MIs[0] Operand 7
     /* 742185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742195 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742207 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742211 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742218 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 742239 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742251 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742253 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742259 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742269 */     GIR_RootConstrainSelectedInstOperands,
     /* 742270 */     // GIR_Coverage, 5291,
     /* 742270 */     GIR_EraseRootFromParent_Done,
     /* 742271 */   // Label 9698: @742271
     /* 742271 */   GIM_Try, /*On fail goto*//*Label 9699*/ GIMT_Encode4(742371), // Rule ID 5295 //
     /* 742276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 742279 */     // MIs[0] offset
     /* 742279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742282 */     // MIs[0] auxiliary
     /* 742282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742285 */     // MIs[0] Operand 7
     /* 742285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742295 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9820:{ *:[i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742311 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742318 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 742339 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742351 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742353 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742359 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742369 */     GIR_RootConstrainSelectedInstOperands,
     /* 742370 */     // GIR_Coverage, 5295,
     /* 742370 */     GIR_EraseRootFromParent_Done,
     /* 742371 */   // Label 9699: @742371
     /* 742371 */   GIM_Try, /*On fail goto*//*Label 9700*/ GIMT_Encode4(742471), // Rule ID 5299 //
     /* 742376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 742379 */     // MIs[0] offset
     /* 742379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742382 */     // MIs[0] auxiliary
     /* 742382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742385 */     // MIs[0] Operand 7
     /* 742385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742395 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742407 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742411 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742418 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 742439 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742451 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742453 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742459 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742469 */     GIR_RootConstrainSelectedInstOperands,
     /* 742470 */     // GIR_Coverage, 5299,
     /* 742470 */     GIR_EraseRootFromParent_Done,
     /* 742471 */   // Label 9700: @742471
     /* 742471 */   GIM_Reject,
     /* 742472 */ // Label 9676: @742472
     /* 742472 */ GIM_Reject,
     /* 742473 */ // Label 9669: @742473
     /* 742473 */ GIM_Try, /*On fail goto*//*Label 9701*/ GIMT_Encode4(743403),
     /* 742478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 742481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 742484 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 742487 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 742490 */   GIM_Try, /*On fail goto*//*Label 9702*/ GIMT_Encode4(742562), // Rule ID 5268 //
     /* 742495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 742498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742506 */     // MIs[0] offset
     /* 742506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742509 */     // MIs[0] auxiliary
     /* 742509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742512 */     // MIs[0] Operand 7
     /* 742512 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742530 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 742533 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742542 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742544 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742550 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742560 */     GIR_RootConstrainSelectedInstOperands,
     /* 742561 */     // GIR_Coverage, 5268,
     /* 742561 */     GIR_EraseRootFromParent_Done,
     /* 742562 */   // Label 9702: @742562
     /* 742562 */   GIM_Try, /*On fail goto*//*Label 9703*/ GIMT_Encode4(742634), // Rule ID 5300 //
     /* 742567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 742570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742578 */     // MIs[0] offset
     /* 742578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742581 */     // MIs[0] auxiliary
     /* 742581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742584 */     // MIs[0] Operand 7
     /* 742584 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742602 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 742605 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742614 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742616 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742622 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742632 */     GIR_RootConstrainSelectedInstOperands,
     /* 742633 */     // GIR_Coverage, 5300,
     /* 742633 */     GIR_EraseRootFromParent_Done,
     /* 742634 */   // Label 9703: @742634
     /* 742634 */   GIM_Try, /*On fail goto*//*Label 9704*/ GIMT_Encode4(742706), // Rule ID 5304 //
     /* 742639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 742642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742650 */     // MIs[0] offset
     /* 742650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742653 */     // MIs[0] auxiliary
     /* 742653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742656 */     // MIs[0] Operand 7
     /* 742656 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742674 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 742677 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742686 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742688 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742694 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742704 */     GIR_RootConstrainSelectedInstOperands,
     /* 742705 */     // GIR_Coverage, 5304,
     /* 742705 */     GIR_EraseRootFromParent_Done,
     /* 742706 */   // Label 9704: @742706
     /* 742706 */   GIM_Try, /*On fail goto*//*Label 9705*/ GIMT_Encode4(742776), // Rule ID 5269 //
     /* 742711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 742714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742718 */     // MIs[0] offset
     /* 742718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742721 */     // MIs[0] auxiliary
     /* 742721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742724 */     // MIs[0] Operand 7
     /* 742724 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742742 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 742745 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742747 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 742749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742756 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742764 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742774 */     GIR_RootConstrainSelectedInstOperands,
     /* 742775 */     // GIR_Coverage, 5269,
     /* 742775 */     GIR_EraseRootFromParent_Done,
     /* 742776 */   // Label 9705: @742776
     /* 742776 */   GIM_Try, /*On fail goto*//*Label 9706*/ GIMT_Encode4(742846), // Rule ID 5301 //
     /* 742781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 742784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742788 */     // MIs[0] offset
     /* 742788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742791 */     // MIs[0] auxiliary
     /* 742791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742794 */     // MIs[0] Operand 7
     /* 742794 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742812 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 742815 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742817 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 742819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742826 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742828 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742834 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742844 */     GIR_RootConstrainSelectedInstOperands,
     /* 742845 */     // GIR_Coverage, 5301,
     /* 742845 */     GIR_EraseRootFromParent_Done,
     /* 742846 */   // Label 9706: @742846
     /* 742846 */   GIM_Try, /*On fail goto*//*Label 9707*/ GIMT_Encode4(742916), // Rule ID 5305 //
     /* 742851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 742854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742858 */     // MIs[0] offset
     /* 742858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742861 */     // MIs[0] auxiliary
     /* 742861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742864 */     // MIs[0] Operand 7
     /* 742864 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742882 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 742885 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742887 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 742889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742896 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742898 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742904 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742914 */     GIR_RootConstrainSelectedInstOperands,
     /* 742915 */     // GIR_Coverage, 5305,
     /* 742915 */     GIR_EraseRootFromParent_Done,
     /* 742916 */   // Label 9707: @742916
     /* 742916 */   GIM_Try, /*On fail goto*//*Label 9708*/ GIMT_Encode4(742978), // Rule ID 5270 //
     /* 742921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 742924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742928 */     // MIs[0] offset
     /* 742928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742931 */     // MIs[0] auxiliary
     /* 742931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742934 */     // MIs[0] Operand 7
     /* 742934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742944 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 742947 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742949 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 742951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742958 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742960 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742966 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742976 */     GIR_RootConstrainSelectedInstOperands,
     /* 742977 */     // GIR_Coverage, 5270,
     /* 742977 */     GIR_EraseRootFromParent_Done,
     /* 742978 */   // Label 9708: @742978
     /* 742978 */   GIM_Try, /*On fail goto*//*Label 9709*/ GIMT_Encode4(743040), // Rule ID 5302 //
     /* 742983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 742986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742990 */     // MIs[0] offset
     /* 742990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742993 */     // MIs[0] auxiliary
     /* 742993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742996 */     // MIs[0] Operand 7
     /* 742996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743006 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 743009 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743011 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 743013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743020 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743028 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743038 */     GIR_RootConstrainSelectedInstOperands,
     /* 743039 */     // GIR_Coverage, 5302,
     /* 743039 */     GIR_EraseRootFromParent_Done,
     /* 743040 */   // Label 9709: @743040
     /* 743040 */   GIM_Try, /*On fail goto*//*Label 9710*/ GIMT_Encode4(743102), // Rule ID 5306 //
     /* 743045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 743048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743052 */     // MIs[0] offset
     /* 743052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743055 */     // MIs[0] auxiliary
     /* 743055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743058 */     // MIs[0] Operand 7
     /* 743058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743068 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 743071 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743073 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 743075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743082 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743090 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743100 */     GIR_RootConstrainSelectedInstOperands,
     /* 743101 */     // GIR_Coverage, 5306,
     /* 743101 */     GIR_EraseRootFromParent_Done,
     /* 743102 */   // Label 9710: @743102
     /* 743102 */   GIM_Try, /*On fail goto*//*Label 9711*/ GIMT_Encode4(743202), // Rule ID 5271 //
     /* 743107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 743110 */     // MIs[0] offset
     /* 743110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743113 */     // MIs[0] auxiliary
     /* 743113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743116 */     // MIs[0] Operand 7
     /* 743116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743126 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 743129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 743133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 743138 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 743142 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 743145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 743149 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 743152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 743157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 743170 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 743175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743182 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743184 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743190 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743200 */     GIR_RootConstrainSelectedInstOperands,
     /* 743201 */     // GIR_Coverage, 5271,
     /* 743201 */     GIR_EraseRootFromParent_Done,
     /* 743202 */   // Label 9711: @743202
     /* 743202 */   GIM_Try, /*On fail goto*//*Label 9712*/ GIMT_Encode4(743302), // Rule ID 5303 //
     /* 743207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 743210 */     // MIs[0] offset
     /* 743210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743213 */     // MIs[0] auxiliary
     /* 743213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743216 */     // MIs[0] Operand 7
     /* 743216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743226 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 743229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 743233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 743238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 743242 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 743245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 743249 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 743252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 743257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 743270 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 743275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743282 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743284 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743290 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743300 */     GIR_RootConstrainSelectedInstOperands,
     /* 743301 */     // GIR_Coverage, 5303,
     /* 743301 */     GIR_EraseRootFromParent_Done,
     /* 743302 */   // Label 9712: @743302
     /* 743302 */   GIM_Try, /*On fail goto*//*Label 9713*/ GIMT_Encode4(743402), // Rule ID 5307 //
     /* 743307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 743310 */     // MIs[0] offset
     /* 743310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743313 */     // MIs[0] auxiliary
     /* 743313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743316 */     // MIs[0] Operand 7
     /* 743316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743326 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 743329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 743333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 743338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 743342 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 743345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 743349 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 743352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 743357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 743370 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 743375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743382 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743384 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743390 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743400 */     GIR_RootConstrainSelectedInstOperands,
     /* 743401 */     // GIR_Coverage, 5307,
     /* 743401 */     GIR_EraseRootFromParent_Done,
     /* 743402 */   // Label 9713: @743402
     /* 743402 */   GIM_Reject,
     /* 743403 */ // Label 9701: @743403
     /* 743403 */ GIM_Reject,
     /* 743404 */ // Label 9670: @743404
     /* 743404 */ GIM_Try, /*On fail goto*//*Label 9714*/ GIMT_Encode4(744638),
     /* 743409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 743412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 743415 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 743418 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 743421 */   GIM_Try, /*On fail goto*//*Label 9715*/ GIMT_Encode4(743493), // Rule ID 5308 //
     /* 743426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 743429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743437 */     // MIs[0] offset
     /* 743437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743440 */     // MIs[0] auxiliary
     /* 743440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743443 */     // MIs[0] Operand 7
     /* 743443 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743461 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact anonymous_9820:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact),
     /* 743464 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743473 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743475 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743481 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743491 */     GIR_RootConstrainSelectedInstOperands,
     /* 743492 */     // GIR_Coverage, 5308,
     /* 743492 */     GIR_EraseRootFromParent_Done,
     /* 743493 */   // Label 9715: @743493
     /* 743493 */   GIM_Try, /*On fail goto*//*Label 9716*/ GIMT_Encode4(743565), // Rule ID 5312 //
     /* 743498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 743501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743509 */     // MIs[0] offset
     /* 743509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743512 */     // MIs[0] auxiliary
     /* 743512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743515 */     // MIs[0] Operand 7
     /* 743515 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743533 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact anonymous_9820:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact),
     /* 743536 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743545 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743547 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743553 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743563 */     GIR_RootConstrainSelectedInstOperands,
     /* 743564 */     // GIR_Coverage, 5312,
     /* 743564 */     GIR_EraseRootFromParent_Done,
     /* 743565 */   // Label 9716: @743565
     /* 743565 */   GIM_Try, /*On fail goto*//*Label 9717*/ GIMT_Encode4(743637), // Rule ID 5316 //
     /* 743570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 743573 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743581 */     // MIs[0] offset
     /* 743581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743584 */     // MIs[0] auxiliary
     /* 743584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743587 */     // MIs[0] Operand 7
     /* 743587 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743605 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact anonymous_9820:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact),
     /* 743608 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743617 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743619 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743625 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743635 */     GIR_RootConstrainSelectedInstOperands,
     /* 743636 */     // GIR_Coverage, 5316,
     /* 743636 */     GIR_EraseRootFromParent_Done,
     /* 743637 */   // Label 9717: @743637
     /* 743637 */   GIM_Try, /*On fail goto*//*Label 9718*/ GIMT_Encode4(743709), // Rule ID 5320 //
     /* 743642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 743645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743653 */     // MIs[0] offset
     /* 743653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743656 */     // MIs[0] auxiliary
     /* 743656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743659 */     // MIs[0] Operand 7
     /* 743659 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743677 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact anonymous_9820:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact),
     /* 743680 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743689 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743691 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743697 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743707 */     GIR_RootConstrainSelectedInstOperands,
     /* 743708 */     // GIR_Coverage, 5320,
     /* 743708 */     GIR_EraseRootFromParent_Done,
     /* 743709 */   // Label 9718: @743709
     /* 743709 */   GIM_Try, /*On fail goto*//*Label 9719*/ GIMT_Encode4(743779), // Rule ID 5309 //
     /* 743714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 743717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743721 */     // MIs[0] offset
     /* 743721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743724 */     // MIs[0] auxiliary
     /* 743724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743727 */     // MIs[0] Operand 7
     /* 743727 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743745 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact),
     /* 743748 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743750 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 743752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743759 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743761 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743767 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743777 */     GIR_RootConstrainSelectedInstOperands,
     /* 743778 */     // GIR_Coverage, 5309,
     /* 743778 */     GIR_EraseRootFromParent_Done,
     /* 743779 */   // Label 9719: @743779
     /* 743779 */   GIM_Try, /*On fail goto*//*Label 9720*/ GIMT_Encode4(743849), // Rule ID 5313 //
     /* 743784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 743787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743791 */     // MIs[0] offset
     /* 743791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743794 */     // MIs[0] auxiliary
     /* 743794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743797 */     // MIs[0] Operand 7
     /* 743797 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743815 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact),
     /* 743818 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743820 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 743822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743829 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743831 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743837 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743847 */     GIR_RootConstrainSelectedInstOperands,
     /* 743848 */     // GIR_Coverage, 5313,
     /* 743848 */     GIR_EraseRootFromParent_Done,
     /* 743849 */   // Label 9720: @743849
     /* 743849 */   GIM_Try, /*On fail goto*//*Label 9721*/ GIMT_Encode4(743919), // Rule ID 5317 //
     /* 743854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 743857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743861 */     // MIs[0] offset
     /* 743861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743864 */     // MIs[0] auxiliary
     /* 743864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743867 */     // MIs[0] Operand 7
     /* 743867 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743885 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact anonymous_9820:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact),
     /* 743888 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743890 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 743892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743899 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743901 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743907 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743917 */     GIR_RootConstrainSelectedInstOperands,
     /* 743918 */     // GIR_Coverage, 5317,
     /* 743918 */     GIR_EraseRootFromParent_Done,
     /* 743919 */   // Label 9721: @743919
     /* 743919 */   GIM_Try, /*On fail goto*//*Label 9722*/ GIMT_Encode4(743989), // Rule ID 5321 //
     /* 743924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 743927 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743931 */     // MIs[0] offset
     /* 743931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743934 */     // MIs[0] auxiliary
     /* 743934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743937 */     // MIs[0] Operand 7
     /* 743937 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743955 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact anonymous_9820:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact),
     /* 743958 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743960 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 743962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743969 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743971 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743977 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743987 */     GIR_RootConstrainSelectedInstOperands,
     /* 743988 */     // GIR_Coverage, 5321,
     /* 743988 */     GIR_EraseRootFromParent_Done,
     /* 743989 */   // Label 9722: @743989
     /* 743989 */   GIM_Try, /*On fail goto*//*Label 9723*/ GIMT_Encode4(744051), // Rule ID 5310 //
     /* 743994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 743997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744001 */     // MIs[0] offset
     /* 744001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744004 */     // MIs[0] auxiliary
     /* 744004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744007 */     // MIs[0] Operand 7
     /* 744007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744017 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact),
     /* 744020 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744022 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 744024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744031 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744033 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744039 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744049 */     GIR_RootConstrainSelectedInstOperands,
     /* 744050 */     // GIR_Coverage, 5310,
     /* 744050 */     GIR_EraseRootFromParent_Done,
     /* 744051 */   // Label 9723: @744051
     /* 744051 */   GIM_Try, /*On fail goto*//*Label 9724*/ GIMT_Encode4(744113), // Rule ID 5314 //
     /* 744056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 744059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744063 */     // MIs[0] offset
     /* 744063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744066 */     // MIs[0] auxiliary
     /* 744066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744069 */     // MIs[0] Operand 7
     /* 744069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744079 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact),
     /* 744082 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744084 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 744086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744093 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744095 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744111 */     GIR_RootConstrainSelectedInstOperands,
     /* 744112 */     // GIR_Coverage, 5314,
     /* 744112 */     GIR_EraseRootFromParent_Done,
     /* 744113 */   // Label 9724: @744113
     /* 744113 */   GIM_Try, /*On fail goto*//*Label 9725*/ GIMT_Encode4(744175), // Rule ID 5318 //
     /* 744118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 744121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744125 */     // MIs[0] offset
     /* 744125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744128 */     // MIs[0] auxiliary
     /* 744128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744131 */     // MIs[0] Operand 7
     /* 744131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744141 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact anonymous_9820:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact),
     /* 744144 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744146 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 744148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744155 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744157 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744163 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744173 */     GIR_RootConstrainSelectedInstOperands,
     /* 744174 */     // GIR_Coverage, 5318,
     /* 744174 */     GIR_EraseRootFromParent_Done,
     /* 744175 */   // Label 9725: @744175
     /* 744175 */   GIM_Try, /*On fail goto*//*Label 9726*/ GIMT_Encode4(744237), // Rule ID 5322 //
     /* 744180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 744183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744187 */     // MIs[0] offset
     /* 744187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744190 */     // MIs[0] auxiliary
     /* 744190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744193 */     // MIs[0] Operand 7
     /* 744193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744203 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact anonymous_9820:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact),
     /* 744206 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744208 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 744210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744217 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744219 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744225 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744235 */     GIR_RootConstrainSelectedInstOperands,
     /* 744236 */     // GIR_Coverage, 5322,
     /* 744236 */     GIR_EraseRootFromParent_Done,
     /* 744237 */   // Label 9726: @744237
     /* 744237 */   GIM_Try, /*On fail goto*//*Label 9727*/ GIMT_Encode4(744337), // Rule ID 5311 //
     /* 744242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 744245 */     // MIs[0] offset
     /* 744245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744248 */     // MIs[0] auxiliary
     /* 744248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744251 */     // MIs[0] Operand 7
     /* 744251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744261 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 744264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 744268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 744273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 744277 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 744280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 744284 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 744287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 744292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact),
     /* 744305 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 744310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744317 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744319 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744325 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744335 */     GIR_RootConstrainSelectedInstOperands,
     /* 744336 */     // GIR_Coverage, 5311,
     /* 744336 */     GIR_EraseRootFromParent_Done,
     /* 744337 */   // Label 9727: @744337
     /* 744337 */   GIM_Try, /*On fail goto*//*Label 9728*/ GIMT_Encode4(744437), // Rule ID 5315 //
     /* 744342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 744345 */     // MIs[0] offset
     /* 744345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744348 */     // MIs[0] auxiliary
     /* 744348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744351 */     // MIs[0] Operand 7
     /* 744351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744361 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 744364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 744368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 744373 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 744377 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 744380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 744384 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 744387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 744392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact),
     /* 744405 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 744410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744417 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744435 */     GIR_RootConstrainSelectedInstOperands,
     /* 744436 */     // GIR_Coverage, 5315,
     /* 744436 */     GIR_EraseRootFromParent_Done,
     /* 744437 */   // Label 9728: @744437
     /* 744437 */   GIM_Try, /*On fail goto*//*Label 9729*/ GIMT_Encode4(744537), // Rule ID 5319 //
     /* 744442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 744445 */     // MIs[0] offset
     /* 744445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744448 */     // MIs[0] auxiliary
     /* 744448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744451 */     // MIs[0] Operand 7
     /* 744451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744461 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact anonymous_9820:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 744464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 744468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 744473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 744477 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 744480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 744484 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 744487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 744492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact),
     /* 744505 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 744510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744517 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744519 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744525 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744535 */     GIR_RootConstrainSelectedInstOperands,
     /* 744536 */     // GIR_Coverage, 5319,
     /* 744536 */     GIR_EraseRootFromParent_Done,
     /* 744537 */   // Label 9729: @744537
     /* 744537 */   GIM_Try, /*On fail goto*//*Label 9730*/ GIMT_Encode4(744637), // Rule ID 5323 //
     /* 744542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 744545 */     // MIs[0] offset
     /* 744545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744548 */     // MIs[0] auxiliary
     /* 744548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744551 */     // MIs[0] Operand 7
     /* 744551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744561 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 744564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 744568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 744573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 744577 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 744580 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 744584 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 744587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 744592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact),
     /* 744605 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 744610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744617 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744619 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744625 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744635 */     GIR_RootConstrainSelectedInstOperands,
     /* 744636 */     // GIR_Coverage, 5323,
     /* 744636 */     GIR_EraseRootFromParent_Done,
     /* 744637 */   // Label 9730: @744637
     /* 744637 */   GIM_Reject,
     /* 744638 */ // Label 9714: @744638
     /* 744638 */ GIM_Reject,
     /* 744639 */ // Label 9671: @744639
     /* 744639 */ GIM_Try, /*On fail goto*//*Label 9731*/ GIMT_Encode4(744961),
     /* 744644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 744647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 744650 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 744653 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 744656 */   GIM_Try, /*On fail goto*//*Label 9732*/ GIMT_Encode4(744728), // Rule ID 5272 //
     /* 744661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 744664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 744668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744672 */     // MIs[0] offset
     /* 744672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744675 */     // MIs[0] auxiliary
     /* 744675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744678 */     // MIs[0] Operand 7
     /* 744678 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 744689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744696 */     // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact anonymous_9819:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact),
     /* 744699 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744708 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744716 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744726 */     GIR_RootConstrainSelectedInstOperands,
     /* 744727 */     // GIR_Coverage, 5272,
     /* 744727 */     GIR_EraseRootFromParent_Done,
     /* 744728 */   // Label 9732: @744728
     /* 744728 */   GIM_Try, /*On fail goto*//*Label 9733*/ GIMT_Encode4(744798), // Rule ID 5273 //
     /* 744733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 744736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 744740 */     // MIs[0] offset
     /* 744740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744743 */     // MIs[0] auxiliary
     /* 744743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744746 */     // MIs[0] Operand 7
     /* 744746 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 744757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744764 */     // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact),
     /* 744767 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744769 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 744771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744778 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744786 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744796 */     GIR_RootConstrainSelectedInstOperands,
     /* 744797 */     // GIR_Coverage, 5273,
     /* 744797 */     GIR_EraseRootFromParent_Done,
     /* 744798 */   // Label 9733: @744798
     /* 744798 */   GIM_Try, /*On fail goto*//*Label 9734*/ GIMT_Encode4(744860), // Rule ID 5274 //
     /* 744803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 744806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744810 */     // MIs[0] offset
     /* 744810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744813 */     // MIs[0] auxiliary
     /* 744813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744816 */     // MIs[0] Operand 7
     /* 744816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744826 */     // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact),
     /* 744829 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744831 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 744833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744840 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744842 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744848 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744858 */     GIR_RootConstrainSelectedInstOperands,
     /* 744859 */     // GIR_Coverage, 5274,
     /* 744859 */     GIR_EraseRootFromParent_Done,
     /* 744860 */   // Label 9734: @744860
     /* 744860 */   GIM_Try, /*On fail goto*//*Label 9735*/ GIMT_Encode4(744960), // Rule ID 5275 //
     /* 744865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 744868 */     // MIs[0] offset
     /* 744868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744871 */     // MIs[0] auxiliary
     /* 744871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744874 */     // MIs[0] Operand 7
     /* 744874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744884 */     // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 744887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 744891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 744896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 744900 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 744903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 744907 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 744910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 744915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact),
     /* 744928 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 744933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744940 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744942 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744948 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744958 */     GIR_RootConstrainSelectedInstOperands,
     /* 744959 */     // GIR_Coverage, 5275,
     /* 744959 */     GIR_EraseRootFromParent_Done,
     /* 744960 */   // Label 9735: @744960
     /* 744960 */   GIM_Reject,
     /* 744961 */ // Label 9731: @744961
     /* 744961 */ GIM_Reject,
     /* 744962 */ // Label 9672: @744962
     /* 744962 */ GIM_Try, /*On fail goto*//*Label 9736*/ GIMT_Encode4(745284),
     /* 744967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 744970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 744973 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 744976 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 744979 */   GIM_Try, /*On fail goto*//*Label 9737*/ GIMT_Encode4(745051), // Rule ID 5276 //
     /* 744984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 744987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 744991 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744995 */     // MIs[0] offset
     /* 744995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744998 */     // MIs[0] auxiliary
     /* 744998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745001 */     // MIs[0] Operand 7
     /* 745001 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745019 */     // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact anonymous_9818:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact),
     /* 745022 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745031 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745033 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745039 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745049 */     GIR_RootConstrainSelectedInstOperands,
     /* 745050 */     // GIR_Coverage, 5276,
     /* 745050 */     GIR_EraseRootFromParent_Done,
     /* 745051 */   // Label 9737: @745051
     /* 745051 */   GIM_Try, /*On fail goto*//*Label 9738*/ GIMT_Encode4(745121), // Rule ID 5277 //
     /* 745056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745063 */     // MIs[0] offset
     /* 745063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745066 */     // MIs[0] auxiliary
     /* 745066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745069 */     // MIs[0] Operand 7
     /* 745069 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745087 */     // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact),
     /* 745090 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745092 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745101 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745103 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745109 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745119 */     GIR_RootConstrainSelectedInstOperands,
     /* 745120 */     // GIR_Coverage, 5277,
     /* 745120 */     GIR_EraseRootFromParent_Done,
     /* 745121 */   // Label 9738: @745121
     /* 745121 */   GIM_Try, /*On fail goto*//*Label 9739*/ GIMT_Encode4(745183), // Rule ID 5278 //
     /* 745126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745133 */     // MIs[0] offset
     /* 745133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745136 */     // MIs[0] auxiliary
     /* 745136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745139 */     // MIs[0] Operand 7
     /* 745139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 745142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745149 */     // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact),
     /* 745152 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745154 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 745156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745163 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745165 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745171 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745181 */     GIR_RootConstrainSelectedInstOperands,
     /* 745182 */     // GIR_Coverage, 5278,
     /* 745182 */     GIR_EraseRootFromParent_Done,
     /* 745183 */   // Label 9739: @745183
     /* 745183 */   GIM_Try, /*On fail goto*//*Label 9740*/ GIMT_Encode4(745283), // Rule ID 5279 //
     /* 745188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745191 */     // MIs[0] offset
     /* 745191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745194 */     // MIs[0] auxiliary
     /* 745194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745197 */     // MIs[0] Operand 7
     /* 745197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 745200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745207 */     // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 745210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 745214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 745219 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 745223 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 745226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 745230 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 745233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 745238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 745243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 745248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact),
     /* 745251 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 745256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745263 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745265 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745281 */     GIR_RootConstrainSelectedInstOperands,
     /* 745282 */     // GIR_Coverage, 5279,
     /* 745282 */     GIR_EraseRootFromParent_Done,
     /* 745283 */   // Label 9740: @745283
     /* 745283 */   GIM_Reject,
     /* 745284 */ // Label 9736: @745284
     /* 745284 */ GIM_Reject,
     /* 745285 */ // Label 9673: @745285
     /* 745285 */ GIM_Try, /*On fail goto*//*Label 9741*/ GIMT_Encode4(746519),
     /* 745290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 745293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 745296 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 745299 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 745302 */   GIM_Try, /*On fail goto*//*Label 9742*/ GIMT_Encode4(745374), // Rule ID 5340 //
     /* 745307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 745310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745318 */     // MIs[0] offset
     /* 745318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745321 */     // MIs[0] auxiliary
     /* 745321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745324 */     // MIs[0] Operand 7
     /* 745324 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745342 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact anonymous_9819:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact),
     /* 745345 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745354 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745372 */     GIR_RootConstrainSelectedInstOperands,
     /* 745373 */     // GIR_Coverage, 5340,
     /* 745373 */     GIR_EraseRootFromParent_Done,
     /* 745374 */   // Label 9742: @745374
     /* 745374 */   GIM_Try, /*On fail goto*//*Label 9743*/ GIMT_Encode4(745446), // Rule ID 5344 //
     /* 745379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 745382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745390 */     // MIs[0] offset
     /* 745390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745393 */     // MIs[0] auxiliary
     /* 745393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745396 */     // MIs[0] Operand 7
     /* 745396 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745414 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact anonymous_9819:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact),
     /* 745417 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745426 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745428 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745434 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745444 */     GIR_RootConstrainSelectedInstOperands,
     /* 745445 */     // GIR_Coverage, 5344,
     /* 745445 */     GIR_EraseRootFromParent_Done,
     /* 745446 */   // Label 9743: @745446
     /* 745446 */   GIM_Try, /*On fail goto*//*Label 9744*/ GIMT_Encode4(745518), // Rule ID 5348 //
     /* 745451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 745454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745462 */     // MIs[0] offset
     /* 745462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745465 */     // MIs[0] auxiliary
     /* 745465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745468 */     // MIs[0] Operand 7
     /* 745468 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745486 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact anonymous_9819:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact),
     /* 745489 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745498 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745500 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745506 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745516 */     GIR_RootConstrainSelectedInstOperands,
     /* 745517 */     // GIR_Coverage, 5348,
     /* 745517 */     GIR_EraseRootFromParent_Done,
     /* 745518 */   // Label 9744: @745518
     /* 745518 */   GIM_Try, /*On fail goto*//*Label 9745*/ GIMT_Encode4(745590), // Rule ID 5352 //
     /* 745523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 745526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745534 */     // MIs[0] offset
     /* 745534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745537 */     // MIs[0] auxiliary
     /* 745537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745540 */     // MIs[0] Operand 7
     /* 745540 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745558 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact anonymous_9819:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact),
     /* 745561 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745570 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745572 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745578 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745588 */     GIR_RootConstrainSelectedInstOperands,
     /* 745589 */     // GIR_Coverage, 5352,
     /* 745589 */     GIR_EraseRootFromParent_Done,
     /* 745590 */   // Label 9745: @745590
     /* 745590 */   GIM_Try, /*On fail goto*//*Label 9746*/ GIMT_Encode4(745660), // Rule ID 5341 //
     /* 745595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 745598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745602 */     // MIs[0] offset
     /* 745602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745605 */     // MIs[0] auxiliary
     /* 745605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745608 */     // MIs[0] Operand 7
     /* 745608 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745626 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact),
     /* 745629 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745631 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745640 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745642 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745658 */     GIR_RootConstrainSelectedInstOperands,
     /* 745659 */     // GIR_Coverage, 5341,
     /* 745659 */     GIR_EraseRootFromParent_Done,
     /* 745660 */   // Label 9746: @745660
     /* 745660 */   GIM_Try, /*On fail goto*//*Label 9747*/ GIMT_Encode4(745730), // Rule ID 5345 //
     /* 745665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 745668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745672 */     // MIs[0] offset
     /* 745672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745675 */     // MIs[0] auxiliary
     /* 745675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745678 */     // MIs[0] Operand 7
     /* 745678 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745696 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact),
     /* 745699 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745701 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745710 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745712 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745728 */     GIR_RootConstrainSelectedInstOperands,
     /* 745729 */     // GIR_Coverage, 5345,
     /* 745729 */     GIR_EraseRootFromParent_Done,
     /* 745730 */   // Label 9747: @745730
     /* 745730 */   GIM_Try, /*On fail goto*//*Label 9748*/ GIMT_Encode4(745800), // Rule ID 5349 //
     /* 745735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 745738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745742 */     // MIs[0] offset
     /* 745742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745745 */     // MIs[0] auxiliary
     /* 745745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745748 */     // MIs[0] Operand 7
     /* 745748 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745766 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact anonymous_9819:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact),
     /* 745769 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745771 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745780 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745782 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745788 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745798 */     GIR_RootConstrainSelectedInstOperands,
     /* 745799 */     // GIR_Coverage, 5349,
     /* 745799 */     GIR_EraseRootFromParent_Done,
     /* 745800 */   // Label 9748: @745800
     /* 745800 */   GIM_Try, /*On fail goto*//*Label 9749*/ GIMT_Encode4(745870), // Rule ID 5353 //
     /* 745805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 745808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745812 */     // MIs[0] offset
     /* 745812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745815 */     // MIs[0] auxiliary
     /* 745815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745818 */     // MIs[0] Operand 7
     /* 745818 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745836 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact anonymous_9819:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact),
     /* 745839 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745841 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745850 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745852 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745858 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745868 */     GIR_RootConstrainSelectedInstOperands,
     /* 745869 */     // GIR_Coverage, 5353,
     /* 745869 */     GIR_EraseRootFromParent_Done,
     /* 745870 */   // Label 9749: @745870
     /* 745870 */   GIM_Try, /*On fail goto*//*Label 9750*/ GIMT_Encode4(745932), // Rule ID 5342 //
     /* 745875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 745878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745882 */     // MIs[0] offset
     /* 745882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745885 */     // MIs[0] auxiliary
     /* 745885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745888 */     // MIs[0] Operand 7
     /* 745888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 745891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745898 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact),
     /* 745901 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745903 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 745905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745912 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745914 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745920 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745930 */     GIR_RootConstrainSelectedInstOperands,
     /* 745931 */     // GIR_Coverage, 5342,
     /* 745931 */     GIR_EraseRootFromParent_Done,
     /* 745932 */   // Label 9750: @745932
     /* 745932 */   GIM_Try, /*On fail goto*//*Label 9751*/ GIMT_Encode4(745994), // Rule ID 5346 //
     /* 745937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 745940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745944 */     // MIs[0] offset
     /* 745944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745947 */     // MIs[0] auxiliary
     /* 745947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745950 */     // MIs[0] Operand 7
     /* 745950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 745953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745960 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact),
     /* 745963 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745965 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 745967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745974 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745982 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745992 */     GIR_RootConstrainSelectedInstOperands,
     /* 745993 */     // GIR_Coverage, 5346,
     /* 745993 */     GIR_EraseRootFromParent_Done,
     /* 745994 */   // Label 9751: @745994
     /* 745994 */   GIM_Try, /*On fail goto*//*Label 9752*/ GIMT_Encode4(746056), // Rule ID 5350 //
     /* 745999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 746002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746006 */     // MIs[0] offset
     /* 746006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746009 */     // MIs[0] auxiliary
     /* 746009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746012 */     // MIs[0] Operand 7
     /* 746012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746022 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact anonymous_9819:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact),
     /* 746025 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746027 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 746029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746036 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746038 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746044 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746054 */     GIR_RootConstrainSelectedInstOperands,
     /* 746055 */     // GIR_Coverage, 5350,
     /* 746055 */     GIR_EraseRootFromParent_Done,
     /* 746056 */   // Label 9752: @746056
     /* 746056 */   GIM_Try, /*On fail goto*//*Label 9753*/ GIMT_Encode4(746118), // Rule ID 5354 //
     /* 746061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 746064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746068 */     // MIs[0] offset
     /* 746068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746071 */     // MIs[0] auxiliary
     /* 746071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746074 */     // MIs[0] Operand 7
     /* 746074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746084 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact anonymous_9819:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact),
     /* 746087 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746089 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 746091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746098 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746100 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746106 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746116 */     GIR_RootConstrainSelectedInstOperands,
     /* 746117 */     // GIR_Coverage, 5354,
     /* 746117 */     GIR_EraseRootFromParent_Done,
     /* 746118 */   // Label 9753: @746118
     /* 746118 */   GIM_Try, /*On fail goto*//*Label 9754*/ GIMT_Encode4(746218), // Rule ID 5343 //
     /* 746123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 746126 */     // MIs[0] offset
     /* 746126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746129 */     // MIs[0] auxiliary
     /* 746129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746132 */     // MIs[0] Operand 7
     /* 746132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746142 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746154 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746158 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746165 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact),
     /* 746186 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746198 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746200 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746216 */     GIR_RootConstrainSelectedInstOperands,
     /* 746217 */     // GIR_Coverage, 5343,
     /* 746217 */     GIR_EraseRootFromParent_Done,
     /* 746218 */   // Label 9754: @746218
     /* 746218 */   GIM_Try, /*On fail goto*//*Label 9755*/ GIMT_Encode4(746318), // Rule ID 5347 //
     /* 746223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 746226 */     // MIs[0] offset
     /* 746226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746229 */     // MIs[0] auxiliary
     /* 746229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746232 */     // MIs[0] Operand 7
     /* 746232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746242 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746258 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746265 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact),
     /* 746286 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746298 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746300 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746306 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746316 */     GIR_RootConstrainSelectedInstOperands,
     /* 746317 */     // GIR_Coverage, 5347,
     /* 746317 */     GIR_EraseRootFromParent_Done,
     /* 746318 */   // Label 9755: @746318
     /* 746318 */   GIM_Try, /*On fail goto*//*Label 9756*/ GIMT_Encode4(746418), // Rule ID 5351 //
     /* 746323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 746326 */     // MIs[0] offset
     /* 746326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746329 */     // MIs[0] auxiliary
     /* 746329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746332 */     // MIs[0] Operand 7
     /* 746332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746342 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact anonymous_9819:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746358 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746361 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746365 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact),
     /* 746386 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746398 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746400 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746406 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746416 */     GIR_RootConstrainSelectedInstOperands,
     /* 746417 */     // GIR_Coverage, 5351,
     /* 746417 */     GIR_EraseRootFromParent_Done,
     /* 746418 */   // Label 9756: @746418
     /* 746418 */   GIM_Try, /*On fail goto*//*Label 9757*/ GIMT_Encode4(746518), // Rule ID 5355 //
     /* 746423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 746426 */     // MIs[0] offset
     /* 746426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746429 */     // MIs[0] auxiliary
     /* 746429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746432 */     // MIs[0] Operand 7
     /* 746432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746442 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746458 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746465 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact),
     /* 746486 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746498 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746500 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746506 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746516 */     GIR_RootConstrainSelectedInstOperands,
     /* 746517 */     // GIR_Coverage, 5355,
     /* 746517 */     GIR_EraseRootFromParent_Done,
     /* 746518 */   // Label 9757: @746518
     /* 746518 */   GIM_Reject,
     /* 746519 */ // Label 9741: @746519
     /* 746519 */ GIM_Reject,
     /* 746520 */ // Label 9674: @746520
     /* 746520 */ GIM_Try, /*On fail goto*//*Label 9758*/ GIMT_Encode4(746842),
     /* 746525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 746528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 746531 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 746534 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 746537 */   GIM_Try, /*On fail goto*//*Label 9759*/ GIMT_Encode4(746609), // Rule ID 5280 //
     /* 746542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 746545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 746549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746553 */     // MIs[0] offset
     /* 746553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746556 */     // MIs[0] auxiliary
     /* 746556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746559 */     // MIs[0] Operand 7
     /* 746559 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 746570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746577 */     // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact anonymous_9817:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact),
     /* 746580 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746589 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746591 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746597 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746607 */     GIR_RootConstrainSelectedInstOperands,
     /* 746608 */     // GIR_Coverage, 5280,
     /* 746608 */     GIR_EraseRootFromParent_Done,
     /* 746609 */   // Label 9759: @746609
     /* 746609 */   GIM_Try, /*On fail goto*//*Label 9760*/ GIMT_Encode4(746679), // Rule ID 5281 //
     /* 746614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 746617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 746621 */     // MIs[0] offset
     /* 746621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746624 */     // MIs[0] auxiliary
     /* 746624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746627 */     // MIs[0] Operand 7
     /* 746627 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 746638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746645 */     // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact),
     /* 746648 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746650 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 746652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746659 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746661 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746667 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746677 */     GIR_RootConstrainSelectedInstOperands,
     /* 746678 */     // GIR_Coverage, 5281,
     /* 746678 */     GIR_EraseRootFromParent_Done,
     /* 746679 */   // Label 9760: @746679
     /* 746679 */   GIM_Try, /*On fail goto*//*Label 9761*/ GIMT_Encode4(746741), // Rule ID 5282 //
     /* 746684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 746687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746691 */     // MIs[0] offset
     /* 746691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746694 */     // MIs[0] auxiliary
     /* 746694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746697 */     // MIs[0] Operand 7
     /* 746697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746707 */     // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact),
     /* 746710 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746712 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 746714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746721 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746723 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746729 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746739 */     GIR_RootConstrainSelectedInstOperands,
     /* 746740 */     // GIR_Coverage, 5282,
     /* 746740 */     GIR_EraseRootFromParent_Done,
     /* 746741 */   // Label 9761: @746741
     /* 746741 */   GIM_Try, /*On fail goto*//*Label 9762*/ GIMT_Encode4(746841), // Rule ID 5283 //
     /* 746746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 746749 */     // MIs[0] offset
     /* 746749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746752 */     // MIs[0] auxiliary
     /* 746752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746755 */     // MIs[0] Operand 7
     /* 746755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746765 */     // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746777 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746781 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746788 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact),
     /* 746809 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746821 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746823 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746829 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746839 */     GIR_RootConstrainSelectedInstOperands,
     /* 746840 */     // GIR_Coverage, 5283,
     /* 746840 */     GIR_EraseRootFromParent_Done,
     /* 746841 */   // Label 9762: @746841
     /* 746841 */   GIM_Reject,
     /* 746842 */ // Label 9758: @746842
     /* 746842 */ GIM_Reject,
     /* 746843 */ // Label 9675: @746843
     /* 746843 */ GIM_Reject,
     /* 746844 */ // Label 142: @746844
     /* 746844 */ GIM_Try, /*On fail goto*//*Label 9763*/ GIMT_Encode4(747445),
     /* 746849 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 746852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 746855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 746858 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 746861 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 746864 */   GIM_Try, /*On fail goto*//*Label 9764*/ GIMT_Encode4(747136),
     /* 746869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 746873 */     GIM_Try, /*On fail goto*//*Label 9765*/ GIMT_Encode4(746941), // Rule ID 5564 //
     /* 746878 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 746881 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746885 */       // MIs[0] offset
     /* 746885 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746888 */       // MIs[0] auxiliary
     /* 746888 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746891 */       // MIs[0] Operand 7
     /* 746891 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 746902 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746909 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746909 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET_exact),
     /* 746912 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746914 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746916 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746921 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746923 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746929 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746935 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746939 */       GIR_RootConstrainSelectedInstOperands,
     /* 746940 */       // GIR_Coverage, 5564,
     /* 746940 */       GIR_EraseRootFromParent_Done,
     /* 746941 */     // Label 9765: @746941
     /* 746941 */     GIM_Try, /*On fail goto*//*Label 9766*/ GIMT_Encode4(747006), // Rule ID 5568 //
     /* 746946 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746950 */       // MIs[0] offset
     /* 746950 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746953 */       // MIs[0] auxiliary
     /* 746953 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746956 */       // MIs[0] Operand 7
     /* 746956 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 746967 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746974 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746974 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET_exact),
     /* 746977 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746979 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746981 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746986 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746988 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746994 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747000 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747004 */       GIR_RootConstrainSelectedInstOperands,
     /* 747005 */       // GIR_Coverage, 5568,
     /* 747005 */       GIR_EraseRootFromParent_Done,
     /* 747006 */     // Label 9766: @747006
     /* 747006 */     GIM_Try, /*On fail goto*//*Label 9767*/ GIMT_Encode4(747072), // Rule ID 5565 //
     /* 747011 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 747014 */       // MIs[0] offset
     /* 747014 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747017 */       // MIs[0] auxiliary
     /* 747017 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747020 */       // MIs[0] Operand 7
     /* 747020 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 747031 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747038 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747038 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFEN_exact),
     /* 747041 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747043 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 747045 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747047 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747052 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747054 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747060 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747066 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747070 */       GIR_RootConstrainSelectedInstOperands,
     /* 747071 */       // GIR_Coverage, 5565,
     /* 747071 */       GIR_EraseRootFromParent_Done,
     /* 747072 */     // Label 9767: @747072
     /* 747072 */     GIM_Try, /*On fail goto*//*Label 9768*/ GIMT_Encode4(747135), // Rule ID 5569 //
     /* 747077 */       // MIs[0] offset
     /* 747077 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747080 */       // MIs[0] auxiliary
     /* 747080 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747083 */       // MIs[0] Operand 7
     /* 747083 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 747094 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747101 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747101 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFEN_exact),
     /* 747104 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747106 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 747108 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747110 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747115 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747117 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747123 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747129 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747133 */       GIR_RootConstrainSelectedInstOperands,
     /* 747134 */       // GIR_Coverage, 5569,
     /* 747134 */       GIR_EraseRootFromParent_Done,
     /* 747135 */     // Label 9768: @747135
     /* 747135 */     GIM_Reject,
     /* 747136 */   // Label 9764: @747136
     /* 747136 */   GIM_Try, /*On fail goto*//*Label 9769*/ GIMT_Encode4(747250),
     /* 747141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 747145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 747154 */     GIM_Try, /*On fail goto*//*Label 9770*/ GIMT_Encode4(747203), // Rule ID 5566 //
     /* 747159 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 747162 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747169 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747169 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_IDXEN_exact),
     /* 747172 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747174 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 747176 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747178 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747183 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747185 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747191 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747197 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747201 */       GIR_RootConstrainSelectedInstOperands,
     /* 747202 */       // GIR_Coverage, 5566,
     /* 747202 */       GIR_EraseRootFromParent_Done,
     /* 747203 */     // Label 9770: @747203
     /* 747203 */     GIM_Try, /*On fail goto*//*Label 9771*/ GIMT_Encode4(747249), // Rule ID 5570 //
     /* 747208 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747215 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_VBUFFER_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747215 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_IDXEN_exact),
     /* 747218 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747220 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 747222 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747224 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747229 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747231 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747237 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747243 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747247 */       GIR_RootConstrainSelectedInstOperands,
     /* 747248 */       // GIR_Coverage, 5570,
     /* 747248 */       GIR_EraseRootFromParent_Done,
     /* 747249 */     // Label 9771: @747249
     /* 747249 */     GIM_Reject,
     /* 747250 */   // Label 9769: @747250
     /* 747250 */   GIM_Try, /*On fail goto*//*Label 9772*/ GIMT_Encode4(747444),
     /* 747255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 747264 */     GIM_Try, /*On fail goto*//*Label 9773*/ GIMT_Encode4(747355), // Rule ID 5567 //
     /* 747269 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 747272 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747279 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747279 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 747282 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 747286 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 747291 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 747295 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 747298 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 747302 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 747305 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 747310 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747315 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747320 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_BOTHEN_exact),
     /* 747323 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747325 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 747328 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747330 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747335 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747337 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747343 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747349 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747353 */       GIR_RootConstrainSelectedInstOperands,
     /* 747354 */       // GIR_Coverage, 5567,
     /* 747354 */       GIR_EraseRootFromParent_Done,
     /* 747355 */     // Label 9773: @747355
     /* 747355 */     GIM_Try, /*On fail goto*//*Label 9774*/ GIMT_Encode4(747443), // Rule ID 5571 //
     /* 747360 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747367 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747367 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 747370 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 747374 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 747379 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 747383 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 747386 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 747390 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 747393 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 747398 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747403 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747408 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_BOTHEN_exact),
     /* 747411 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747413 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 747416 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747418 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747423 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747425 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747431 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747437 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747441 */       GIR_RootConstrainSelectedInstOperands,
     /* 747442 */       // GIR_Coverage, 5571,
     /* 747442 */       GIR_EraseRootFromParent_Done,
     /* 747443 */     // Label 9774: @747443
     /* 747443 */     GIM_Reject,
     /* 747444 */   // Label 9772: @747444
     /* 747444 */   GIM_Reject,
     /* 747445 */ // Label 9763: @747445
     /* 747445 */ GIM_Reject,
     /* 747446 */ // Label 143: @747446
     /* 747446 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 9779*/ GIMT_Encode4(748384),
     /* 747457 */ /*GILLT_s16*//*Label 9775*/ GIMT_Encode4(747473),
     /* 747461 */ /*GILLT_s32*//*Label 9776*/ GIMT_Encode4(747642),
     /* 747465 */ /*GILLT_s64*//*Label 9777*/ GIMT_Encode4(747695),
     /* 747469 */ /*GILLT_v2s16*//*Label 9778*/ GIMT_Encode4(747805),
     /* 747473 */ // Label 9775: @747473
     /* 747473 */ GIM_Try, /*On fail goto*//*Label 9780*/ GIMT_Encode4(747641),
     /* 747478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 747481 */   GIM_Try, /*On fail goto*//*Label 9781*/ GIMT_Encode4(747533), // Rule ID 7219 //
     /* 747486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 747489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 747500 */     // (AMDGPUclamp:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 747500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 747503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 747505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 747528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 747531 */     GIR_RootConstrainSelectedInstOperands,
     /* 747532 */     // GIR_Coverage, 7219,
     /* 747532 */     GIR_EraseRootFromParent_Done,
     /* 747533 */   // Label 9781: @747533
     /* 747533 */   GIM_Try, /*On fail goto*//*Label 9782*/ GIMT_Encode4(747588), // Rule ID 7220 //
     /* 747538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 747541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 747545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 747552 */     // (AMDGPUclamp:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 747552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 747555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 747557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 747580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 747583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 747586 */     GIR_RootConstrainSelectedInstOperands,
     /* 747587 */     // GIR_Coverage, 7220,
     /* 747587 */     GIR_EraseRootFromParent_Done,
     /* 747588 */   // Label 9782: @747588
     /* 747588 */   GIM_Try, /*On fail goto*//*Label 9783*/ GIMT_Encode4(747640), // Rule ID 7221 //
     /* 747593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 747596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 747607 */     // (AMDGPUclamp:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 747607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 747610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 747612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 747635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 747638 */     GIR_RootConstrainSelectedInstOperands,
     /* 747639 */     // GIR_Coverage, 7221,
     /* 747639 */     GIR_EraseRootFromParent_Done,
     /* 747640 */   // Label 9783: @747640
     /* 747640 */   GIM_Reject,
     /* 747641 */ // Label 9780: @747641
     /* 747641 */ GIM_Reject,
     /* 747642 */ // Label 9776: @747642
     /* 747642 */ GIM_Try, /*On fail goto*//*Label 9784*/ GIMT_Encode4(747694), // Rule ID 7216 //
     /* 747647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 747650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747654 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 747661 */   // (AMDGPUclamp:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 747661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 747664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 747666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 747689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 747692 */   GIR_RootConstrainSelectedInstOperands,
     /* 747693 */   // GIR_Coverage, 7216,
     /* 747693 */   GIR_EraseRootFromParent_Done,
     /* 747694 */ // Label 9784: @747694
     /* 747694 */ GIM_Reject,
     /* 747695 */ // Label 9777: @747695
     /* 747695 */ GIM_Try, /*On fail goto*//*Label 9785*/ GIMT_Encode4(747804),
     /* 747700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 747703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 747707 */   GIM_Try, /*On fail goto*//*Label 9786*/ GIMT_Encode4(747755), // Rule ID 7217 //
     /* 747712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 747715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 747722 */     // (AMDGPUclamp:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 747722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 747725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 747727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 747750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 747753 */     GIR_RootConstrainSelectedInstOperands,
     /* 747754 */     // GIR_Coverage, 7217,
     /* 747754 */     GIR_EraseRootFromParent_Done,
     /* 747755 */   // Label 9786: @747755
     /* 747755 */   GIM_Try, /*On fail goto*//*Label 9787*/ GIMT_Encode4(747803), // Rule ID 7218 //
     /* 747760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 747763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 747770 */     // (AMDGPUclamp:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 747770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 747773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 747775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 747790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 747795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 747798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 747801 */     GIR_RootConstrainSelectedInstOperands,
     /* 747802 */     // GIR_Coverage, 7218,
     /* 747802 */     GIR_EraseRootFromParent_Done,
     /* 747803 */   // Label 9787: @747803
     /* 747803 */   GIM_Reject,
     /* 747804 */ // Label 9785: @747804
     /* 747804 */ GIM_Reject,
     /* 747805 */ // Label 9778: @747805
     /* 747805 */ GIM_Try, /*On fail goto*//*Label 9788*/ GIMT_Encode4(748383),
     /* 747810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 747813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747817 */   GIM_Try, /*On fail goto*//*Label 9789*/ GIMT_Encode4(748071), // Rule ID 2735 //
     /* 747822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 747825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 747829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 747833 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 747836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 747840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 747844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 747848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 747852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 747856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 747860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 747864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 747868 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 747872 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /* 747876 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /* 747880 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 747884 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 747888 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /* 747892 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 747896 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /* 747900 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /* 747904 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /* 747908 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 747910 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 747917 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 747924 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 747931 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 747938 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/2, /*Renderer*/GIMT_Encode2(4), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 747945 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/3, /*Renderer*/GIMT_Encode2(5), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 747952 */     // (AMDGPUclamp:{ *:[v2f16] } (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src0, i32:{ *:[i32] }:$lo_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src1, i32:{ *:[i32] }:$lo_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src2, i32:{ *:[i32] }:$lo_src2_modifiers))), (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src0, i32:{ *:[i32] }:$hi_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src1, i32:{ *:[i32] }:$hi_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src2, i32:{ *:[i32] }:$hi_src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$hi_src0_modifiers, ?:{ *:[f16] }:$hi_src0, ?:{ *:[i32] }:$hi_src1_modifiers, ?:{ *:[f16] }:$hi_src1, ?:{ *:[i32] }:$hi_src2_modifiers, ?:{ *:[f16] }:$hi_src2, 1:{ *:[i1] }, (V_FMA_MIXLO_F16:{ *:[i16] } ?:{ *:[i32] }:$lo_src0_modifiers, ?:{ *:[f16] }:$lo_src0, ?:{ *:[i32] }:$lo_src1_modifiers, ?:{ *:[f16] }:$lo_src1, ?:{ *:[i32] }:$lo_src2_modifiers, ?:{ *:[f16] }:$lo_src2, 1:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] })))
     /* 747952 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 747955 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 747959 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 747964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 747966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 747969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
     /* 747973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 747978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // lo_src0_modifiers
     /* 747983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // lo_src0
     /* 747988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // lo_src1_modifiers
     /* 747993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // lo_src1
     /* 747998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // lo_src2_modifiers
     /* 748003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // lo_src2
     /* 748008 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 748011 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 748014 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 748017 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 748020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 748022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /* 748025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/1, // hi_src0_modifiers
     /* 748032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // hi_src0
     /* 748037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/1, // hi_src1_modifiers
     /* 748042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/0, // hi_src1
     /* 748047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/1, // hi_src2_modifiers
     /* 748052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/0, // hi_src2
     /* 748057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 748060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 748063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748069 */     GIR_RootConstrainSelectedInstOperands,
     /* 748070 */     // GIR_Coverage, 2735,
     /* 748070 */     GIR_EraseRootFromParent_Done,
     /* 748071 */   // Label 9789: @748071
     /* 748071 */   GIM_Try, /*On fail goto*//*Label 9790*/ GIMT_Encode4(748325), // Rule ID 2719 //
     /* 748076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 748079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 748083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 748087 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 748090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 748094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 748098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 748102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 748106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 748110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 748114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
     /* 748118 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 748122 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 748126 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /* 748130 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /* 748134 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 748138 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 748142 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /* 748146 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_FMAD),
     /* 748150 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /* 748154 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /* 748158 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /* 748162 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 748164 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748171 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748178 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748185 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748192 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/2, /*Renderer*/GIMT_Encode2(4), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748199 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/3, /*Renderer*/GIMT_Encode2(5), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 748206 */     // (AMDGPUclamp:{ *:[v2f16] } (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src0, i32:{ *:[i32] }:$lo_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src1, i32:{ *:[i32] }:$lo_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src2, i32:{ *:[i32] }:$lo_src2_modifiers))), (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src0, i32:{ *:[i32] }:$hi_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src1, i32:{ *:[i32] }:$hi_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src2, i32:{ *:[i32] }:$hi_src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$hi_src0_modifiers, ?:{ *:[f16] }:$hi_src0, ?:{ *:[i32] }:$hi_src1_modifiers, ?:{ *:[f16] }:$hi_src1, ?:{ *:[i32] }:$hi_src2_modifiers, ?:{ *:[f16] }:$hi_src2, 1:{ *:[i1] }, (V_MAD_MIXLO_F16:{ *:[i16] } ?:{ *:[i32] }:$lo_src0_modifiers, ?:{ *:[f16] }:$lo_src0, ?:{ *:[i32] }:$lo_src1_modifiers, ?:{ *:[f16] }:$lo_src1, ?:{ *:[i32] }:$lo_src2_modifiers, ?:{ *:[f16] }:$lo_src2, 1:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] })))
     /* 748206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 748209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 748213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 748218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 748220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 748223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
     /* 748227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 748232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // lo_src0_modifiers
     /* 748237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // lo_src0
     /* 748242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // lo_src1_modifiers
     /* 748247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // lo_src1
     /* 748252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // lo_src2_modifiers
     /* 748257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // lo_src2
     /* 748262 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 748265 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 748268 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 748271 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 748274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 748276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /* 748279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/1, // hi_src0_modifiers
     /* 748286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // hi_src0
     /* 748291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/1, // hi_src1_modifiers
     /* 748296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/0, // hi_src1
     /* 748301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/1, // hi_src2_modifiers
     /* 748306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/0, // hi_src2
     /* 748311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 748314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 748317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748323 */     GIR_RootConstrainSelectedInstOperands,
     /* 748324 */     // GIR_Coverage, 2719,
     /* 748324 */     GIR_EraseRootFromParent_Done,
     /* 748325 */   // Label 9790: @748325
     /* 748325 */   GIM_Try, /*On fail goto*//*Label 9791*/ GIMT_Encode4(748382), // Rule ID 7222 //
     /* 748330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 748333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 748340 */     // (AMDGPUclamp:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_MAX_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2f16] }:$src0, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2f16] }:$src0, 1:{ *:[i1] })
     /* 748340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 748343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 748350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 748360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 748368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748380 */     GIR_RootConstrainSelectedInstOperands,
     /* 748381 */     // GIR_Coverage, 7222,
     /* 748381 */     GIR_EraseRootFromParent_Done,
     /* 748382 */   // Label 9791: @748382
     /* 748382 */   GIM_Reject,
     /* 748383 */ // Label 9788: @748383
     /* 748383 */ GIM_Reject,
     /* 748384 */ // Label 9779: @748384
     /* 748384 */ GIM_Reject,
     /* 748385 */ // Label 144: @748385
     /* 748385 */ GIM_Try, /*On fail goto*//*Label 9792*/ GIMT_Encode4(748429), // Rule ID 651 //
     /* 748390 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 748393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 748396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748400 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 748407 */   // (AMDGPUcvt_f32_ubyte0:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE0_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 748407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE0_e64),
     /* 748410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 748422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 748427 */   GIR_RootConstrainSelectedInstOperands,
     /* 748428 */   // GIR_Coverage, 651,
     /* 748428 */   GIR_EraseRootFromParent_Done,
     /* 748429 */ // Label 9792: @748429
     /* 748429 */ GIM_Reject,
     /* 748430 */ // Label 145: @748430
     /* 748430 */ GIM_Try, /*On fail goto*//*Label 9793*/ GIMT_Encode4(748474), // Rule ID 652 //
     /* 748435 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 748438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 748441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748445 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 748452 */   // (AMDGPUcvt_f32_ubyte1:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE1_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 748452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE1_e64),
     /* 748455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 748467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 748472 */   GIR_RootConstrainSelectedInstOperands,
     /* 748473 */   // GIR_Coverage, 652,
     /* 748473 */   GIR_EraseRootFromParent_Done,
     /* 748474 */ // Label 9793: @748474
     /* 748474 */ GIM_Reject,
     /* 748475 */ // Label 146: @748475
     /* 748475 */ GIM_Try, /*On fail goto*//*Label 9794*/ GIMT_Encode4(748519), // Rule ID 653 //
     /* 748480 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 748483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 748486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 748497 */   // (AMDGPUcvt_f32_ubyte2:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE2_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 748497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE2_e64),
     /* 748500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 748512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 748517 */   GIR_RootConstrainSelectedInstOperands,
     /* 748518 */   // GIR_Coverage, 653,
     /* 748518 */   GIR_EraseRootFromParent_Done,
     /* 748519 */ // Label 9794: @748519
     /* 748519 */ GIM_Reject,
     /* 748520 */ // Label 147: @748520
     /* 748520 */ GIM_Try, /*On fail goto*//*Label 9795*/ GIMT_Encode4(748564), // Rule ID 654 //
     /* 748525 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 748528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 748531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748535 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 748542 */   // (AMDGPUcvt_f32_ubyte3:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE3_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 748542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE3_e64),
     /* 748545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 748557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 748562 */   GIR_RootConstrainSelectedInstOperands,
     /* 748563 */   // GIR_Coverage, 654,
     /* 748563 */   GIR_EraseRootFromParent_Done,
     /* 748564 */ // Label 9795: @748564
     /* 748564 */ GIM_Reject,
     /* 748565 */ // Label 148: @748565
     /* 748565 */ GIM_Try, /*On fail goto*//*Label 9796*/ GIMT_Encode4(748594), // Rule ID 831 //
     /* 748570 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 748573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 748576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 748579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748583 */   // (AMDGPUpk_i16_i32_impl:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_CVT_PK_I16_I32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 748583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_I16_I32_e64),
     /* 748588 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 748592 */   GIR_RootConstrainSelectedInstOperands,
     /* 748593 */   // GIR_Coverage, 831,
     /* 748593 */   GIR_Done,
     /* 748594 */ // Label 9796: @748594
     /* 748594 */ GIM_Reject,
     /* 748595 */ // Label 149: @748595
     /* 748595 */ GIM_Try, /*On fail goto*//*Label 9797*/ GIMT_Encode4(748696),
     /* 748600 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 748603 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 9800*/ GIMT_Encode4(748664),
     /* 748614 */   /*GILLT_s32*//*Label 9798*/ GIMT_Encode4(748622),
     /* 748618 */   /*GILLT_s64*//*Label 9799*/ GIMT_Encode4(748643),
     /* 748622 */   // Label 9798: @748622
     /* 748622 */   GIM_Try, /*On fail goto*//*Label 9801*/ GIMT_Encode4(748642), // Rule ID 13 //
     /* 748627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 748631 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13761),
     /* 748635 */     // (AMDGPUffbh_u32_impl:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13761>>  =>  (S_FLBIT_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 748635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B32),
     /* 748640 */     GIR_RootConstrainSelectedInstOperands,
     /* 748641 */     // GIR_Coverage, 13,
     /* 748641 */     GIR_Done,
     /* 748642 */   // Label 9801: @748642
     /* 748642 */   GIM_Reject,
     /* 748643 */   // Label 9799: @748643
     /* 748643 */   GIM_Try, /*On fail goto*//*Label 9802*/ GIMT_Encode4(748663), // Rule ID 15 //
     /* 748648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 748652 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13761),
     /* 748656 */     // (AMDGPUffbh_u32_impl:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13761>>  =>  (S_FLBIT_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
     /* 748656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B64),
     /* 748661 */     GIR_RootConstrainSelectedInstOperands,
     /* 748662 */     // GIR_Coverage, 15,
     /* 748662 */     GIR_Done,
     /* 748663 */   // Label 9802: @748663
     /* 748663 */   GIM_Reject,
     /* 748664 */   // Label 9800: @748664
     /* 748664 */   GIM_Try, /*On fail goto*//*Label 9803*/ GIMT_Encode4(748695), // Rule ID 682 //
     /* 748669 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 748672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 748683 */     // (AMDGPUffbh_u32_impl:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBH_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 748683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBH_U32_e64),
     /* 748686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748693 */     GIR_RootConstrainSelectedInstOperands,
     /* 748694 */     // GIR_Coverage, 682,
     /* 748694 */     GIR_EraseRootFromParent_Done,
     /* 748695 */   // Label 9803: @748695
     /* 748695 */   GIM_Reject,
     /* 748696 */ // Label 9797: @748696
     /* 748696 */ GIM_Reject,
     /* 748697 */ // Label 150: @748697
     /* 748697 */ GIM_Try, /*On fail goto*//*Label 9804*/ GIMT_Encode4(748795),
     /* 748702 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 748705 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 9807*/ GIMT_Encode4(748794),
     /* 748716 */   /*GILLT_s32*//*Label 9805*/ GIMT_Encode4(748724),
     /* 748720 */   /*GILLT_s64*//*Label 9806*/ GIMT_Encode4(748773),
     /* 748724 */   // Label 9805: @748724
     /* 748724 */   GIM_Try, /*On fail goto*//*Label 9808*/ GIMT_Encode4(748744), // Rule ID 11 //
     /* 748729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 748733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13760),
     /* 748737 */     // (AMDGPUffbl_b32_impl:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13760>>  =>  (S_FF1_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 748737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B32),
     /* 748742 */     GIR_RootConstrainSelectedInstOperands,
     /* 748743 */     // GIR_Coverage, 11,
     /* 748743 */     GIR_Done,
     /* 748744 */   // Label 9808: @748744
     /* 748744 */   GIM_Try, /*On fail goto*//*Label 9809*/ GIMT_Encode4(748772), // Rule ID 684 //
     /* 748749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 748760 */     // (AMDGPUffbl_b32_impl:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 748760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBL_B32_e64),
     /* 748763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748770 */     GIR_RootConstrainSelectedInstOperands,
     /* 748771 */     // GIR_Coverage, 684,
     /* 748771 */     GIR_EraseRootFromParent_Done,
     /* 748772 */   // Label 9809: @748772
     /* 748772 */   GIM_Reject,
     /* 748773 */   // Label 9806: @748773
     /* 748773 */   GIM_Try, /*On fail goto*//*Label 9810*/ GIMT_Encode4(748793), // Rule ID 9 //
     /* 748778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 748782 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13760),
     /* 748786 */     // (AMDGPUffbl_b32_impl:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13760>>  =>  (S_FF1_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
     /* 748786 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B64),
     /* 748791 */     GIR_RootConstrainSelectedInstOperands,
     /* 748792 */     // GIR_Coverage, 9,
     /* 748792 */     GIR_Done,
     /* 748793 */   // Label 9810: @748793
     /* 748793 */   GIM_Reject,
     /* 748794 */   // Label 9807: @748794
     /* 748794 */   GIM_Reject,
     /* 748795 */ // Label 9804: @748795
     /* 748795 */ GIM_Reject,
     /* 748796 */ // Label 151: @748796
     /* 748796 */ GIM_Try, /*On fail goto*//*Label 9811*/ GIMT_Encode4(748868), // Rule ID 833 //
     /* 748801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 748804 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 748807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 748810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 748813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748817 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 748824 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 748831 */   // (AMDGPUfmax_legacy:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 748831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_LEGACY_F32_e64),
     /* 748834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 748841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 748851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 748856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 748861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 748866 */   GIR_RootConstrainSelectedInstOperands,
     /* 748867 */   // GIR_Coverage, 833,
     /* 748867 */   GIR_EraseRootFromParent_Done,
     /* 748868 */ // Label 9811: @748868
     /* 748868 */ GIM_Reject,
     /* 748869 */ // Label 152: @748869
     /* 748869 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 9814*/ GIMT_Encode4(749228),
     /* 748880 */ /*GILLT_s16*//*Label 9812*/ GIMT_Encode4(748888),
     /* 748884 */ /*GILLT_s32*//*Label 9813*/ GIMT_Encode4(749141),
     /* 748888 */ // Label 9812: @748888
     /* 748888 */ GIM_Try, /*On fail goto*//*Label 9815*/ GIMT_Encode4(749140),
     /* 748893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 748896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 748899 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 748902 */   GIM_Try, /*On fail goto*//*Label 9816*/ GIMT_Encode4(748981), // Rule ID 1019 //
     /* 748907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 748910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 748921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 748928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 748935 */     // (AMDGPUfmed3_impl:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 748935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 748938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 748940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 748945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 748950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 748955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 748960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 748965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 748970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 748979 */     GIR_RootConstrainSelectedInstOperands,
     /* 748980 */     // GIR_Coverage, 1019,
     /* 748980 */     GIR_EraseRootFromParent_Done,
     /* 748981 */   // Label 9816: @748981
     /* 748981 */   GIM_Try, /*On fail goto*//*Label 9817*/ GIMT_Encode4(749060), // Rule ID 1021 //
     /* 748986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 748989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 748993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749014 */     // (AMDGPUfmed3_impl:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 749014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 749017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 749044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 749049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749058 */     GIR_RootConstrainSelectedInstOperands,
     /* 749059 */     // GIR_Coverage, 1021,
     /* 749059 */     GIR_EraseRootFromParent_Done,
     /* 749060 */   // Label 9817: @749060
     /* 749060 */   GIM_Try, /*On fail goto*//*Label 9818*/ GIMT_Encode4(749139), // Rule ID 1023 //
     /* 749065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 749068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749093 */     // (AMDGPUfmed3_impl:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 749093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 749096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 749123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 749128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749137 */     GIR_RootConstrainSelectedInstOperands,
     /* 749138 */     // GIR_Coverage, 1023,
     /* 749138 */     GIR_EraseRootFromParent_Done,
     /* 749139 */   // Label 9818: @749139
     /* 749139 */   GIM_Reject,
     /* 749140 */ // Label 9815: @749140
     /* 749140 */ GIM_Reject,
     /* 749141 */ // Label 9813: @749141
     /* 749141 */ GIM_Try, /*On fail goto*//*Label 9819*/ GIMT_Encode4(749227), // Rule ID 972 //
     /* 749146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 749149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 749152 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 749155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749159 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 749166 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 749173 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 749180 */   // (AMDGPUfmed3_impl:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 749180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 749183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 749210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 749215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 749220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 749225 */   GIR_RootConstrainSelectedInstOperands,
     /* 749226 */   // GIR_Coverage, 972,
     /* 749226 */   GIR_EraseRootFromParent_Done,
     /* 749227 */ // Label 9819: @749227
     /* 749227 */ GIM_Reject,
     /* 749228 */ // Label 9814: @749228
     /* 749228 */ GIM_Reject,
     /* 749229 */ // Label 153: @749229
     /* 749229 */ GIM_Try, /*On fail goto*//*Label 9820*/ GIMT_Encode4(749301), // Rule ID 832 //
     /* 749234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 749237 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 749240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 749243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 749246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749250 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 749257 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 749264 */   // (AMDGPUfmin_legacy:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 749264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_LEGACY_F32_e64),
     /* 749267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749269 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 749294 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 749299 */   GIR_RootConstrainSelectedInstOperands,
     /* 749300 */   // GIR_Coverage, 832,
     /* 749300 */   GIR_EraseRootFromParent_Done,
     /* 749301 */ // Label 9820: @749301
     /* 749301 */ GIM_Reject,
     /* 749302 */ // Label 154: @749302
     /* 749302 */ GIM_Try, /*On fail goto*//*Label 9821*/ GIMT_Encode4(749351), // Rule ID 667 //
     /* 749307 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 749310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 749313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749317 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 749324 */   // (AMDGPUrcp_iflag:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_IFLAG_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 749324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_IFLAG_F32_e64),
     /* 749327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 749344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 749349 */   GIR_RootConstrainSelectedInstOperands,
     /* 749350 */   // GIR_Coverage, 667,
     /* 749350 */   GIR_EraseRootFromParent_Done,
     /* 749351 */ // Label 9821: @749351
     /* 749351 */ GIM_Reject,
     /* 749352 */ // Label 155: @749352
     /* 749352 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 9824*/ GIMT_Encode4(749657),
     /* 749363 */ /*GILLT_s16*//*Label 9822*/ GIMT_Encode4(749371),
     /* 749367 */ /*GILLT_s32*//*Label 9823*/ GIMT_Encode4(749615),
     /* 749371 */ // Label 9822: @749371
     /* 749371 */ GIM_Try, /*On fail goto*//*Label 9825*/ GIMT_Encode4(749614),
     /* 749376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 749379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 749382 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 749385 */   GIM_Try, /*On fail goto*//*Label 9826*/ GIMT_Encode4(749461), // Rule ID 1024 //
     /* 749390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 749393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749418 */     // (AMDGPUsmed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_I16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 749418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 749421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 749448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 749453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749459 */     GIR_RootConstrainSelectedInstOperands,
     /* 749460 */     // GIR_Coverage, 1024,
     /* 749460 */     GIR_EraseRootFromParent_Done,
     /* 749461 */   // Label 9826: @749461
     /* 749461 */   GIM_Try, /*On fail goto*//*Label 9827*/ GIMT_Encode4(749537), // Rule ID 1025 //
     /* 749466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 749469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 749473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749494 */     // (AMDGPUsmed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 749494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 749497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 749524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 749529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749535 */     GIR_RootConstrainSelectedInstOperands,
     /* 749536 */     // GIR_Coverage, 1025,
     /* 749536 */     GIR_EraseRootFromParent_Done,
     /* 749537 */   // Label 9827: @749537
     /* 749537 */   GIM_Try, /*On fail goto*//*Label 9828*/ GIMT_Encode4(749613), // Rule ID 1026 //
     /* 749542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 749545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 749570 */     // (AMDGPUsmed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 749570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 749573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 749580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 749590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 749595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 749600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 749605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 749611 */     GIR_RootConstrainSelectedInstOperands,
     /* 749612 */     // GIR_Coverage, 1026,
     /* 749612 */     GIR_EraseRootFromParent_Done,
     /* 749613 */   // Label 9828: @749613
     /* 749613 */   GIM_Reject,
     /* 749614 */ // Label 9825: @749614
     /* 749614 */ GIM_Reject,
     /* 749615 */ // Label 9823: @749615
     /* 749615 */ GIM_Try, /*On fail goto*//*Label 9829*/ GIMT_Encode4(749656), // Rule ID 967 //
     /* 749620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 749623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 749626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 749629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749633 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 749640 */   // (AMDGPUsmed3:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_MED3_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 749640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 749643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 749645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 749650 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 749652 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 749654 */   GIR_RootConstrainSelectedInstOperands,
     /* 749655 */   // GIR_Coverage, 967,
     /* 749655 */   GIR_EraseRootFromParent_Done,
     /* 749656 */ // Label 9829: @749656
     /* 749656 */ GIM_Reject,
     /* 749657 */ // Label 9824: @749657
     /* 749657 */ GIM_Reject,
     /* 749658 */ // Label 156: @749658
     /* 749658 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(31), /*)*//*default:*//*Label 9836*/ GIMT_Encode4(751959),
     /* 749669 */ /*GILLT_s32*//*Label 9830*/ GIMT_Encode4(749757), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 749681 */ /*GILLT_v2s32*//*Label 9831*/ GIMT_Encode4(750137), GIMT_Encode4(0),
     /* 749689 */ /*GILLT_v3s32*//*Label 9832*/ GIMT_Encode4(750517), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 749701 */ /*GILLT_v4s32*//*Label 9833*/ GIMT_Encode4(750819), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 749725 */ /*GILLT_v8s32*//*Label 9834*/ GIMT_Encode4(751199), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 749753 */ /*GILLT_v16s32*//*Label 9835*/ GIMT_Encode4(751579),
     /* 749757 */ // Label 9830: @749757
     /* 749757 */ GIM_Try, /*On fail goto*//*Label 9837*/ GIMT_Encode4(750136),
     /* 749762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 749765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 749768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 749772 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 749775 */   GIM_Try, /*On fail goto*//*Label 9838*/ GIMT_Encode4(749819), // Rule ID 2895 //
     /* 749780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 749783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 749790 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 749790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
     /* 749793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 749795 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 749797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 749807 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 749813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749817 */     GIR_RootConstrainSelectedInstOperands,
     /* 749818 */     // GIR_Coverage, 2895,
     /* 749818 */     GIR_EraseRootFromParent_Done,
     /* 749819 */   // Label 9838: @749819
     /* 749819 */   GIM_Try, /*On fail goto*//*Label 9839*/ GIMT_Encode4(749863), // Rule ID 3500 //
     /* 749824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 749827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 749834 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 749834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
     /* 749837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 749839 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 749841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 749851 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 749857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749861 */     GIR_RootConstrainSelectedInstOperands,
     /* 749862 */     // GIR_Coverage, 3500,
     /* 749862 */     GIR_EraseRootFromParent_Done,
     /* 749863 */   // Label 9839: @749863
     /* 749863 */   GIM_Try, /*On fail goto*//*Label 9840*/ GIMT_Encode4(749899), // Rule ID 2891 //
     /* 749868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 749875 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 749875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM),
     /* 749878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 749880 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 749882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 749887 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 749893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749897 */     GIR_RootConstrainSelectedInstOperands,
     /* 749898 */     // GIR_Coverage, 2891,
     /* 749898 */     GIR_EraseRootFromParent_Done,
     /* 749899 */   // Label 9840: @749899
     /* 749899 */   GIM_Try, /*On fail goto*//*Label 9841*/ GIMT_Encode4(749935), // Rule ID 3496 //
     /* 749904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 749911 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 749911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM),
     /* 749914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 749916 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 749918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 749923 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 749929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749933 */     GIR_RootConstrainSelectedInstOperands,
     /* 749934 */     // GIR_Coverage, 3496,
     /* 749934 */     GIR_EraseRootFromParent_Done,
     /* 749935 */   // Label 9841: @749935
     /* 749935 */   GIM_Try, /*On fail goto*//*Label 9842*/ GIMT_Encode4(749974), // Rule ID 2892 //
     /* 749940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 749943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 749950 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM_ci:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 749950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM_ci),
     /* 749953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 749955 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 749957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 749962 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 749968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749972 */     GIR_RootConstrainSelectedInstOperands,
     /* 749973 */     // GIR_Coverage, 2892,
     /* 749973 */     GIR_EraseRootFromParent_Done,
     /* 749974 */   // Label 9842: @749974
     /* 749974 */   GIM_Try, /*On fail goto*//*Label 9843*/ GIMT_Encode4(750013), // Rule ID 3497 //
     /* 749979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 749982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 749989 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM_ci:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 749989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM_ci),
     /* 749992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 749994 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 749996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750001 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750011 */     GIR_RootConstrainSelectedInstOperands,
     /* 750012 */     // GIR_Coverage, 3497,
     /* 750012 */     GIR_EraseRootFromParent_Done,
     /* 750013 */   // Label 9843: @750013
     /* 750013 */   GIM_Try, /*On fail goto*//*Label 9844*/ GIMT_Encode4(750042), // Rule ID 2893 //
     /* 750018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 750021 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR),
     /* 750024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750026 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750028 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750030 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750040 */     GIR_RootConstrainSelectedInstOperands,
     /* 750041 */     // GIR_Coverage, 2893,
     /* 750041 */     GIR_EraseRootFromParent_Done,
     /* 750042 */   // Label 9844: @750042
     /* 750042 */   GIM_Try, /*On fail goto*//*Label 9845*/ GIMT_Encode4(750074), // Rule ID 2894 //
     /* 750047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750050 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
     /* 750053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750055 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750057 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 750062 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750072 */     GIR_RootConstrainSelectedInstOperands,
     /* 750073 */     // GIR_Coverage, 2894,
     /* 750073 */     GIR_EraseRootFromParent_Done,
     /* 750074 */   // Label 9845: @750074
     /* 750074 */   GIM_Try, /*On fail goto*//*Label 9846*/ GIMT_Encode4(750103), // Rule ID 3498 //
     /* 750079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 750082 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR),
     /* 750085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750087 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750089 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750091 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750101 */     GIR_RootConstrainSelectedInstOperands,
     /* 750102 */     // GIR_Coverage, 3498,
     /* 750102 */     GIR_EraseRootFromParent_Done,
     /* 750103 */   // Label 9846: @750103
     /* 750103 */   GIM_Try, /*On fail goto*//*Label 9847*/ GIMT_Encode4(750135), // Rule ID 3499 //
     /* 750108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750111 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
     /* 750114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750116 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750118 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 750123 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750133 */     GIR_RootConstrainSelectedInstOperands,
     /* 750134 */     // GIR_Coverage, 3499,
     /* 750134 */     GIR_EraseRootFromParent_Done,
     /* 750135 */   // Label 9847: @750135
     /* 750135 */   GIM_Reject,
     /* 750136 */ // Label 9837: @750136
     /* 750136 */ GIM_Reject,
     /* 750137 */ // Label 9831: @750137
     /* 750137 */ GIM_Try, /*On fail goto*//*Label 9848*/ GIMT_Encode4(750516),
     /* 750142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 750145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 750148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 750152 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 750155 */   GIM_Try, /*On fail goto*//*Label 9849*/ GIMT_Encode4(750199), // Rule ID 3476 //
     /* 750160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 750170 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
     /* 750173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750175 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 750187 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750197 */     GIR_RootConstrainSelectedInstOperands,
     /* 750198 */     // GIR_Coverage, 3476,
     /* 750198 */     GIR_EraseRootFromParent_Done,
     /* 750199 */   // Label 9849: @750199
     /* 750199 */   GIM_Try, /*On fail goto*//*Label 9850*/ GIMT_Encode4(750243), // Rule ID 3505 //
     /* 750204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 750214 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
     /* 750217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750219 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 750231 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750241 */     GIR_RootConstrainSelectedInstOperands,
     /* 750242 */     // GIR_Coverage, 3505,
     /* 750242 */     GIR_EraseRootFromParent_Done,
     /* 750243 */   // Label 9850: @750243
     /* 750243 */   GIM_Try, /*On fail goto*//*Label 9851*/ GIMT_Encode4(750279), // Rule ID 3472 //
     /* 750248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 750255 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM),
     /* 750258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750260 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750277 */     GIR_RootConstrainSelectedInstOperands,
     /* 750278 */     // GIR_Coverage, 3472,
     /* 750278 */     GIR_EraseRootFromParent_Done,
     /* 750279 */   // Label 9851: @750279
     /* 750279 */   GIM_Try, /*On fail goto*//*Label 9852*/ GIMT_Encode4(750315), // Rule ID 3501 //
     /* 750284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 750291 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM),
     /* 750294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750296 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750303 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750313 */     GIR_RootConstrainSelectedInstOperands,
     /* 750314 */     // GIR_Coverage, 3501,
     /* 750314 */     GIR_EraseRootFromParent_Done,
     /* 750315 */   // Label 9852: @750315
     /* 750315 */   GIM_Try, /*On fail goto*//*Label 9853*/ GIMT_Encode4(750354), // Rule ID 3473 //
     /* 750320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 750323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 750330 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM_ci:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM_ci),
     /* 750333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750335 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750342 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750352 */     GIR_RootConstrainSelectedInstOperands,
     /* 750353 */     // GIR_Coverage, 3473,
     /* 750353 */     GIR_EraseRootFromParent_Done,
     /* 750354 */   // Label 9853: @750354
     /* 750354 */   GIM_Try, /*On fail goto*//*Label 9854*/ GIMT_Encode4(750393), // Rule ID 3502 //
     /* 750359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 750362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 750369 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM_ci:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM_ci),
     /* 750372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750374 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750381 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750391 */     GIR_RootConstrainSelectedInstOperands,
     /* 750392 */     // GIR_Coverage, 3502,
     /* 750392 */     GIR_EraseRootFromParent_Done,
     /* 750393 */   // Label 9854: @750393
     /* 750393 */   GIM_Try, /*On fail goto*//*Label 9855*/ GIMT_Encode4(750422), // Rule ID 3474 //
     /* 750398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 750401 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR),
     /* 750404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750406 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750408 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750420 */     GIR_RootConstrainSelectedInstOperands,
     /* 750421 */     // GIR_Coverage, 3474,
     /* 750421 */     GIR_EraseRootFromParent_Done,
     /* 750422 */   // Label 9855: @750422
     /* 750422 */   GIM_Try, /*On fail goto*//*Label 9856*/ GIMT_Encode4(750454), // Rule ID 3475 //
     /* 750427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750430 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
     /* 750433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750435 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750437 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 750442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750452 */     GIR_RootConstrainSelectedInstOperands,
     /* 750453 */     // GIR_Coverage, 3475,
     /* 750453 */     GIR_EraseRootFromParent_Done,
     /* 750454 */   // Label 9856: @750454
     /* 750454 */   GIM_Try, /*On fail goto*//*Label 9857*/ GIMT_Encode4(750483), // Rule ID 3503 //
     /* 750459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 750462 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR),
     /* 750465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750467 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750469 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750471 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750481 */     GIR_RootConstrainSelectedInstOperands,
     /* 750482 */     // GIR_Coverage, 3503,
     /* 750482 */     GIR_EraseRootFromParent_Done,
     /* 750483 */   // Label 9857: @750483
     /* 750483 */   GIM_Try, /*On fail goto*//*Label 9858*/ GIMT_Encode4(750515), // Rule ID 3504 //
     /* 750488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750491 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
     /* 750494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750496 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750498 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 750503 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750513 */     GIR_RootConstrainSelectedInstOperands,
     /* 750514 */     // GIR_Coverage, 3504,
     /* 750514 */     GIR_EraseRootFromParent_Done,
     /* 750515 */   // Label 9858: @750515
     /* 750515 */   GIM_Reject,
     /* 750516 */ // Label 9848: @750516
     /* 750516 */ GIM_Reject,
     /* 750517 */ // Label 9832: @750517
     /* 750517 */ GIM_Try, /*On fail goto*//*Label 9859*/ GIMT_Encode4(750818),
     /* 750522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 750525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 750528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 750532 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 750535 */   GIM_Try, /*On fail goto*//*Label 9860*/ GIMT_Encode4(750579), // Rule ID 3480 //
     /* 750540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 750550 */     // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
     /* 750553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750555 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 750567 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750577 */     GIR_RootConstrainSelectedInstOperands,
     /* 750578 */     // GIR_Coverage, 3480,
     /* 750578 */     GIR_EraseRootFromParent_Done,
     /* 750579 */   // Label 9860: @750579
     /* 750579 */   GIM_Try, /*On fail goto*//*Label 9861*/ GIMT_Encode4(750623), // Rule ID 3509 //
     /* 750584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 750594 */     // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
     /* 750597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750599 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 750611 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750621 */     GIR_RootConstrainSelectedInstOperands,
     /* 750622 */     // GIR_Coverage, 3509,
     /* 750622 */     GIR_EraseRootFromParent_Done,
     /* 750623 */   // Label 9861: @750623
     /* 750623 */   GIM_Try, /*On fail goto*//*Label 9862*/ GIMT_Encode4(750659), // Rule ID 3477 //
     /* 750628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 750635 */     // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_IMM:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_IMM),
     /* 750638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750640 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750647 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750657 */     GIR_RootConstrainSelectedInstOperands,
     /* 750658 */     // GIR_Coverage, 3477,
     /* 750658 */     GIR_EraseRootFromParent_Done,
     /* 750659 */   // Label 9862: @750659
     /* 750659 */   GIM_Try, /*On fail goto*//*Label 9863*/ GIMT_Encode4(750695), // Rule ID 3506 //
     /* 750664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 750671 */     // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_IMM:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_IMM),
     /* 750674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750676 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750683 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750693 */     GIR_RootConstrainSelectedInstOperands,
     /* 750694 */     // GIR_Coverage, 3506,
     /* 750694 */     GIR_EraseRootFromParent_Done,
     /* 750695 */   // Label 9863: @750695
     /* 750695 */   GIM_Try, /*On fail goto*//*Label 9864*/ GIMT_Encode4(750724), // Rule ID 3478 //
     /* 750700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 750703 */     // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR),
     /* 750706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750708 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750710 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750712 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750722 */     GIR_RootConstrainSelectedInstOperands,
     /* 750723 */     // GIR_Coverage, 3478,
     /* 750723 */     GIR_EraseRootFromParent_Done,
     /* 750724 */   // Label 9864: @750724
     /* 750724 */   GIM_Try, /*On fail goto*//*Label 9865*/ GIMT_Encode4(750756), // Rule ID 3479 //
     /* 750729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750732 */     // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
     /* 750735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750737 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750739 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 750744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750754 */     GIR_RootConstrainSelectedInstOperands,
     /* 750755 */     // GIR_Coverage, 3479,
     /* 750755 */     GIR_EraseRootFromParent_Done,
     /* 750756 */   // Label 9865: @750756
     /* 750756 */   GIM_Try, /*On fail goto*//*Label 9866*/ GIMT_Encode4(750785), // Rule ID 3507 //
     /* 750761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 750764 */     // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR),
     /* 750767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750769 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750771 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750773 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750783 */     GIR_RootConstrainSelectedInstOperands,
     /* 750784 */     // GIR_Coverage, 3507,
     /* 750784 */     GIR_EraseRootFromParent_Done,
     /* 750785 */   // Label 9866: @750785
     /* 750785 */   GIM_Try, /*On fail goto*//*Label 9867*/ GIMT_Encode4(750817), // Rule ID 3508 //
     /* 750790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750793 */     // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
     /* 750796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750798 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750800 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 750802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 750805 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750815 */     GIR_RootConstrainSelectedInstOperands,
     /* 750816 */     // GIR_Coverage, 3508,
     /* 750816 */     GIR_EraseRootFromParent_Done,
     /* 750817 */   // Label 9867: @750817
     /* 750817 */   GIM_Reject,
     /* 750818 */ // Label 9859: @750818
     /* 750818 */ GIM_Reject,
     /* 750819 */ // Label 9833: @750819
     /* 750819 */ GIM_Try, /*On fail goto*//*Label 9868*/ GIMT_Encode4(751198),
     /* 750824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 750827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 750830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 750834 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 750837 */   GIM_Try, /*On fail goto*//*Label 9869*/ GIMT_Encode4(750881), // Rule ID 3485 //
     /* 750842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 750852 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
     /* 750855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750857 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 750869 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750879 */     GIR_RootConstrainSelectedInstOperands,
     /* 750880 */     // GIR_Coverage, 3485,
     /* 750880 */     GIR_EraseRootFromParent_Done,
     /* 750881 */   // Label 9869: @750881
     /* 750881 */   GIM_Try, /*On fail goto*//*Label 9870*/ GIMT_Encode4(750925), // Rule ID 3514 //
     /* 750886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 750889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 750896 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
     /* 750899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750901 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 750913 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750923 */     GIR_RootConstrainSelectedInstOperands,
     /* 750924 */     // GIR_Coverage, 3514,
     /* 750924 */     GIR_EraseRootFromParent_Done,
     /* 750925 */   // Label 9870: @750925
     /* 750925 */   GIM_Try, /*On fail goto*//*Label 9871*/ GIMT_Encode4(750961), // Rule ID 3481 //
     /* 750930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 750937 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM),
     /* 750940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750942 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750949 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750959 */     GIR_RootConstrainSelectedInstOperands,
     /* 750960 */     // GIR_Coverage, 3481,
     /* 750960 */     GIR_EraseRootFromParent_Done,
     /* 750961 */   // Label 9871: @750961
     /* 750961 */   GIM_Try, /*On fail goto*//*Label 9872*/ GIMT_Encode4(750997), // Rule ID 3510 //
     /* 750966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 750973 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 750973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM),
     /* 750976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 750978 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 750980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 750985 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 750991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750995 */     GIR_RootConstrainSelectedInstOperands,
     /* 750996 */     // GIR_Coverage, 3510,
     /* 750996 */     GIR_EraseRootFromParent_Done,
     /* 750997 */   // Label 9872: @750997
     /* 750997 */   GIM_Try, /*On fail goto*//*Label 9873*/ GIMT_Encode4(751036), // Rule ID 3482 //
     /* 751002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 751005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 751012 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM_ci:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM_ci),
     /* 751015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751017 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751024 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751034 */     GIR_RootConstrainSelectedInstOperands,
     /* 751035 */     // GIR_Coverage, 3482,
     /* 751035 */     GIR_EraseRootFromParent_Done,
     /* 751036 */   // Label 9873: @751036
     /* 751036 */   GIM_Try, /*On fail goto*//*Label 9874*/ GIMT_Encode4(751075), // Rule ID 3511 //
     /* 751041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 751044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 751051 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM_ci:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM_ci),
     /* 751054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751056 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751063 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751073 */     GIR_RootConstrainSelectedInstOperands,
     /* 751074 */     // GIR_Coverage, 3511,
     /* 751074 */     GIR_EraseRootFromParent_Done,
     /* 751075 */   // Label 9874: @751075
     /* 751075 */   GIM_Try, /*On fail goto*//*Label 9875*/ GIMT_Encode4(751104), // Rule ID 3483 //
     /* 751080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 751083 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR),
     /* 751086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751088 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751090 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751092 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751102 */     GIR_RootConstrainSelectedInstOperands,
     /* 751103 */     // GIR_Coverage, 3483,
     /* 751103 */     GIR_EraseRootFromParent_Done,
     /* 751104 */   // Label 9875: @751104
     /* 751104 */   GIM_Try, /*On fail goto*//*Label 9876*/ GIMT_Encode4(751136), // Rule ID 3484 //
     /* 751109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751112 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
     /* 751115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751117 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751119 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 751124 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751134 */     GIR_RootConstrainSelectedInstOperands,
     /* 751135 */     // GIR_Coverage, 3484,
     /* 751135 */     GIR_EraseRootFromParent_Done,
     /* 751136 */   // Label 9876: @751136
     /* 751136 */   GIM_Try, /*On fail goto*//*Label 9877*/ GIMT_Encode4(751165), // Rule ID 3512 //
     /* 751141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 751144 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR),
     /* 751147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751149 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751151 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751153 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751163 */     GIR_RootConstrainSelectedInstOperands,
     /* 751164 */     // GIR_Coverage, 3512,
     /* 751164 */     GIR_EraseRootFromParent_Done,
     /* 751165 */   // Label 9877: @751165
     /* 751165 */   GIM_Try, /*On fail goto*//*Label 9878*/ GIMT_Encode4(751197), // Rule ID 3513 //
     /* 751170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751173 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
     /* 751176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751178 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751180 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 751185 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751195 */     GIR_RootConstrainSelectedInstOperands,
     /* 751196 */     // GIR_Coverage, 3513,
     /* 751196 */     GIR_EraseRootFromParent_Done,
     /* 751197 */   // Label 9878: @751197
     /* 751197 */   GIM_Reject,
     /* 751198 */ // Label 9868: @751198
     /* 751198 */ GIM_Reject,
     /* 751199 */ // Label 9834: @751199
     /* 751199 */ GIM_Try, /*On fail goto*//*Label 9879*/ GIMT_Encode4(751578),
     /* 751204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 751207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 751210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 751214 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 751217 */   GIM_Try, /*On fail goto*//*Label 9880*/ GIMT_Encode4(751261), // Rule ID 3490 //
     /* 751222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 751232 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
     /* 751235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751237 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 751249 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751259 */     GIR_RootConstrainSelectedInstOperands,
     /* 751260 */     // GIR_Coverage, 3490,
     /* 751260 */     GIR_EraseRootFromParent_Done,
     /* 751261 */   // Label 9880: @751261
     /* 751261 */   GIM_Try, /*On fail goto*//*Label 9881*/ GIMT_Encode4(751305), // Rule ID 3519 //
     /* 751266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 751276 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
     /* 751279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751281 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 751293 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751303 */     GIR_RootConstrainSelectedInstOperands,
     /* 751304 */     // GIR_Coverage, 3519,
     /* 751304 */     GIR_EraseRootFromParent_Done,
     /* 751305 */   // Label 9881: @751305
     /* 751305 */   GIM_Try, /*On fail goto*//*Label 9882*/ GIMT_Encode4(751341), // Rule ID 3486 //
     /* 751310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 751317 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM),
     /* 751320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751322 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751329 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751339 */     GIR_RootConstrainSelectedInstOperands,
     /* 751340 */     // GIR_Coverage, 3486,
     /* 751340 */     GIR_EraseRootFromParent_Done,
     /* 751341 */   // Label 9882: @751341
     /* 751341 */   GIM_Try, /*On fail goto*//*Label 9883*/ GIMT_Encode4(751377), // Rule ID 3515 //
     /* 751346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 751353 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM),
     /* 751356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751358 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751365 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751375 */     GIR_RootConstrainSelectedInstOperands,
     /* 751376 */     // GIR_Coverage, 3515,
     /* 751376 */     GIR_EraseRootFromParent_Done,
     /* 751377 */   // Label 9883: @751377
     /* 751377 */   GIM_Try, /*On fail goto*//*Label 9884*/ GIMT_Encode4(751416), // Rule ID 3487 //
     /* 751382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 751385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 751392 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM_ci:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM_ci),
     /* 751395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751397 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751404 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751414 */     GIR_RootConstrainSelectedInstOperands,
     /* 751415 */     // GIR_Coverage, 3487,
     /* 751415 */     GIR_EraseRootFromParent_Done,
     /* 751416 */   // Label 9884: @751416
     /* 751416 */   GIM_Try, /*On fail goto*//*Label 9885*/ GIMT_Encode4(751455), // Rule ID 3516 //
     /* 751421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 751424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 751431 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM_ci:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM_ci),
     /* 751434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751436 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751443 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751453 */     GIR_RootConstrainSelectedInstOperands,
     /* 751454 */     // GIR_Coverage, 3516,
     /* 751454 */     GIR_EraseRootFromParent_Done,
     /* 751455 */   // Label 9885: @751455
     /* 751455 */   GIM_Try, /*On fail goto*//*Label 9886*/ GIMT_Encode4(751484), // Rule ID 3488 //
     /* 751460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 751463 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR),
     /* 751466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751468 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751470 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751472 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751482 */     GIR_RootConstrainSelectedInstOperands,
     /* 751483 */     // GIR_Coverage, 3488,
     /* 751483 */     GIR_EraseRootFromParent_Done,
     /* 751484 */   // Label 9886: @751484
     /* 751484 */   GIM_Try, /*On fail goto*//*Label 9887*/ GIMT_Encode4(751516), // Rule ID 3489 //
     /* 751489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751492 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
     /* 751495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751497 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751499 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 751504 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751514 */     GIR_RootConstrainSelectedInstOperands,
     /* 751515 */     // GIR_Coverage, 3489,
     /* 751515 */     GIR_EraseRootFromParent_Done,
     /* 751516 */   // Label 9887: @751516
     /* 751516 */   GIM_Try, /*On fail goto*//*Label 9888*/ GIMT_Encode4(751545), // Rule ID 3517 //
     /* 751521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 751524 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR),
     /* 751527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751529 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751531 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751543 */     GIR_RootConstrainSelectedInstOperands,
     /* 751544 */     // GIR_Coverage, 3517,
     /* 751544 */     GIR_EraseRootFromParent_Done,
     /* 751545 */   // Label 9888: @751545
     /* 751545 */   GIM_Try, /*On fail goto*//*Label 9889*/ GIMT_Encode4(751577), // Rule ID 3518 //
     /* 751550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751553 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
     /* 751556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751558 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751560 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 751565 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751575 */     GIR_RootConstrainSelectedInstOperands,
     /* 751576 */     // GIR_Coverage, 3518,
     /* 751576 */     GIR_EraseRootFromParent_Done,
     /* 751577 */   // Label 9889: @751577
     /* 751577 */   GIM_Reject,
     /* 751578 */ // Label 9879: @751578
     /* 751578 */ GIM_Reject,
     /* 751579 */ // Label 9835: @751579
     /* 751579 */ GIM_Try, /*On fail goto*//*Label 9890*/ GIMT_Encode4(751958),
     /* 751584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 751587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 751590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 751594 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 751597 */   GIM_Try, /*On fail goto*//*Label 9891*/ GIMT_Encode4(751641), // Rule ID 3495 //
     /* 751602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 751612 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
     /* 751615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751617 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 751629 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751639 */     GIR_RootConstrainSelectedInstOperands,
     /* 751640 */     // GIR_Coverage, 3495,
     /* 751640 */     GIR_EraseRootFromParent_Done,
     /* 751641 */   // Label 9891: @751641
     /* 751641 */   GIM_Try, /*On fail goto*//*Label 9892*/ GIMT_Encode4(751685), // Rule ID 3524 //
     /* 751646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 751656 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
     /* 751659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751661 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 751673 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751683 */     GIR_RootConstrainSelectedInstOperands,
     /* 751684 */     // GIR_Coverage, 3524,
     /* 751684 */     GIR_EraseRootFromParent_Done,
     /* 751685 */   // Label 9892: @751685
     /* 751685 */   GIM_Try, /*On fail goto*//*Label 9893*/ GIMT_Encode4(751721), // Rule ID 3491 //
     /* 751690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 751697 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM),
     /* 751700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751702 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751709 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751719 */     GIR_RootConstrainSelectedInstOperands,
     /* 751720 */     // GIR_Coverage, 3491,
     /* 751720 */     GIR_EraseRootFromParent_Done,
     /* 751721 */   // Label 9893: @751721
     /* 751721 */   GIM_Try, /*On fail goto*//*Label 9894*/ GIMT_Encode4(751757), // Rule ID 3520 //
     /* 751726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 751733 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM),
     /* 751736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751738 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751745 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751755 */     GIR_RootConstrainSelectedInstOperands,
     /* 751756 */     // GIR_Coverage, 3520,
     /* 751756 */     GIR_EraseRootFromParent_Done,
     /* 751757 */   // Label 9894: @751757
     /* 751757 */   GIM_Try, /*On fail goto*//*Label 9895*/ GIMT_Encode4(751796), // Rule ID 3492 //
     /* 751762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 751765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 751772 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM_ci:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM_ci),
     /* 751775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751777 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751784 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751794 */     GIR_RootConstrainSelectedInstOperands,
     /* 751795 */     // GIR_Coverage, 3492,
     /* 751795 */     GIR_EraseRootFromParent_Done,
     /* 751796 */   // Label 9895: @751796
     /* 751796 */   GIM_Try, /*On fail goto*//*Label 9896*/ GIMT_Encode4(751835), // Rule ID 3521 //
     /* 751801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 751804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 751811 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM_ci:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM_ci),
     /* 751814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751816 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 751823 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751833 */     GIR_RootConstrainSelectedInstOperands,
     /* 751834 */     // GIR_Coverage, 3521,
     /* 751834 */     GIR_EraseRootFromParent_Done,
     /* 751835 */   // Label 9896: @751835
     /* 751835 */   GIM_Try, /*On fail goto*//*Label 9897*/ GIMT_Encode4(751864), // Rule ID 3493 //
     /* 751840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 751843 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR),
     /* 751846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751848 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751850 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751852 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751862 */     GIR_RootConstrainSelectedInstOperands,
     /* 751863 */     // GIR_Coverage, 3493,
     /* 751863 */     GIR_EraseRootFromParent_Done,
     /* 751864 */   // Label 9897: @751864
     /* 751864 */   GIM_Try, /*On fail goto*//*Label 9898*/ GIMT_Encode4(751896), // Rule ID 3494 //
     /* 751869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751872 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
     /* 751875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751877 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751879 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 751884 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751894 */     GIR_RootConstrainSelectedInstOperands,
     /* 751895 */     // GIR_Coverage, 3494,
     /* 751895 */     GIR_EraseRootFromParent_Done,
     /* 751896 */   // Label 9898: @751896
     /* 751896 */   GIM_Try, /*On fail goto*//*Label 9899*/ GIMT_Encode4(751925), // Rule ID 3522 //
     /* 751901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 751904 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR),
     /* 751907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751909 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751911 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751913 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751923 */     GIR_RootConstrainSelectedInstOperands,
     /* 751924 */     // GIR_Coverage, 3522,
     /* 751924 */     GIR_EraseRootFromParent_Done,
     /* 751925 */   // Label 9899: @751925
     /* 751925 */   GIM_Try, /*On fail goto*//*Label 9900*/ GIMT_Encode4(751957), // Rule ID 3523 //
     /* 751930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 751933 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
     /* 751936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 751938 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 751940 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 751942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 751945 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 751951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751955 */     GIR_RootConstrainSelectedInstOperands,
     /* 751956 */     // GIR_Coverage, 3523,
     /* 751956 */     GIR_EraseRootFromParent_Done,
     /* 751957 */   // Label 9900: @751957
     /* 751957 */   GIM_Reject,
     /* 751958 */ // Label 9890: @751958
     /* 751958 */ GIM_Reject,
     /* 751959 */ // Label 9836: @751959
     /* 751959 */ GIM_Reject,
     /* 751960 */ // Label 157: @751960
     /* 751960 */ GIM_Try, /*On fail goto*//*Label 9901*/ GIMT_Encode4(752097),
     /* 751965 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 751968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 751971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 751974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 751978 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 751981 */   GIM_Try, /*On fail goto*//*Label 9902*/ GIMT_Encode4(752025), // Rule ID 2902 //
     /* 751986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 751989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 751996 */     // (SIsbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 751996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I8_SGPR_IMM),
     /* 751999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752001 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 752013 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752023 */     GIR_RootConstrainSelectedInstOperands,
     /* 752024 */     // GIR_Coverage, 2902,
     /* 752024 */     GIR_EraseRootFromParent_Done,
     /* 752025 */   // Label 9902: @752025
     /* 752025 */   GIM_Try, /*On fail goto*//*Label 9903*/ GIMT_Encode4(752064), // Rule ID 2900 //
     /* 752030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 752040 */     // (SIsbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I8_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I8_IMM),
     /* 752043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752045 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752052 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752062 */     GIR_RootConstrainSelectedInstOperands,
     /* 752063 */     // GIR_Coverage, 2900,
     /* 752063 */     GIR_EraseRootFromParent_Done,
     /* 752064 */   // Label 9903: @752064
     /* 752064 */   GIM_Try, /*On fail goto*//*Label 9904*/ GIMT_Encode4(752096), // Rule ID 2901 //
     /* 752069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752072 */     // (SIsbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I8_SGPR_IMM),
     /* 752075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752077 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752079 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 752081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 752084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752094 */     GIR_RootConstrainSelectedInstOperands,
     /* 752095 */     // GIR_Coverage, 2901,
     /* 752095 */     GIR_EraseRootFromParent_Done,
     /* 752096 */   // Label 9904: @752096
     /* 752096 */   GIM_Reject,
     /* 752097 */ // Label 9901: @752097
     /* 752097 */ GIM_Reject,
     /* 752098 */ // Label 158: @752098
     /* 752098 */ GIM_Try, /*On fail goto*//*Label 9905*/ GIMT_Encode4(752235),
     /* 752103 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 752106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 752109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 752112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 752116 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 752119 */   GIM_Try, /*On fail goto*//*Label 9906*/ GIMT_Encode4(752163), // Rule ID 2928 //
     /* 752124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 752134 */     // (SIsbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I16_SGPR_IMM),
     /* 752137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752139 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 752151 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752161 */     GIR_RootConstrainSelectedInstOperands,
     /* 752162 */     // GIR_Coverage, 2928,
     /* 752162 */     GIR_EraseRootFromParent_Done,
     /* 752163 */   // Label 9906: @752163
     /* 752163 */   GIM_Try, /*On fail goto*//*Label 9907*/ GIMT_Encode4(752202), // Rule ID 2926 //
     /* 752168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 752178 */     // (SIsbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I16_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I16_IMM),
     /* 752181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752183 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752190 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752200 */     GIR_RootConstrainSelectedInstOperands,
     /* 752201 */     // GIR_Coverage, 2926,
     /* 752201 */     GIR_EraseRootFromParent_Done,
     /* 752202 */   // Label 9907: @752202
     /* 752202 */   GIM_Try, /*On fail goto*//*Label 9908*/ GIMT_Encode4(752234), // Rule ID 2927 //
     /* 752207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752210 */     // (SIsbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I16_SGPR_IMM),
     /* 752213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752215 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752217 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 752219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 752222 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752232 */     GIR_RootConstrainSelectedInstOperands,
     /* 752233 */     // GIR_Coverage, 2927,
     /* 752233 */     GIR_EraseRootFromParent_Done,
     /* 752234 */   // Label 9908: @752234
     /* 752234 */   GIM_Reject,
     /* 752235 */ // Label 9905: @752235
     /* 752235 */ GIM_Reject,
     /* 752236 */ // Label 159: @752236
     /* 752236 */ GIM_Try, /*On fail goto*//*Label 9909*/ GIMT_Encode4(752373),
     /* 752241 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 752244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 752247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 752250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 752254 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 752257 */   GIM_Try, /*On fail goto*//*Label 9910*/ GIMT_Encode4(752301), // Rule ID 2925 //
     /* 752262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 752272 */     // (SIsbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U8_SGPR_IMM),
     /* 752275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752277 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 752289 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752299 */     GIR_RootConstrainSelectedInstOperands,
     /* 752300 */     // GIR_Coverage, 2925,
     /* 752300 */     GIR_EraseRootFromParent_Done,
     /* 752301 */   // Label 9910: @752301
     /* 752301 */   GIM_Try, /*On fail goto*//*Label 9911*/ GIMT_Encode4(752340), // Rule ID 2923 //
     /* 752306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 752316 */     // (SIsbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U8_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U8_IMM),
     /* 752319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752321 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752328 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752338 */     GIR_RootConstrainSelectedInstOperands,
     /* 752339 */     // GIR_Coverage, 2923,
     /* 752339 */     GIR_EraseRootFromParent_Done,
     /* 752340 */   // Label 9911: @752340
     /* 752340 */   GIM_Try, /*On fail goto*//*Label 9912*/ GIMT_Encode4(752372), // Rule ID 2924 //
     /* 752345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752348 */     // (SIsbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U8_SGPR_IMM),
     /* 752351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752353 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752355 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 752357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 752360 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752370 */     GIR_RootConstrainSelectedInstOperands,
     /* 752371 */     // GIR_Coverage, 2924,
     /* 752371 */     GIR_EraseRootFromParent_Done,
     /* 752372 */   // Label 9912: @752372
     /* 752372 */   GIM_Reject,
     /* 752373 */ // Label 9909: @752373
     /* 752373 */ GIM_Reject,
     /* 752374 */ // Label 160: @752374
     /* 752374 */ GIM_Try, /*On fail goto*//*Label 9913*/ GIMT_Encode4(752511),
     /* 752379 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 752382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 752385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 752388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 752392 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 752395 */   GIM_Try, /*On fail goto*//*Label 9914*/ GIMT_Encode4(752439), // Rule ID 2931 //
     /* 752400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 752410 */     // (SIsbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U16_SGPR_IMM),
     /* 752413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752415 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 752427 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752437 */     GIR_RootConstrainSelectedInstOperands,
     /* 752438 */     // GIR_Coverage, 2931,
     /* 752438 */     GIR_EraseRootFromParent_Done,
     /* 752439 */   // Label 9914: @752439
     /* 752439 */   GIM_Try, /*On fail goto*//*Label 9915*/ GIMT_Encode4(752478), // Rule ID 2929 //
     /* 752444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 752454 */     // (SIsbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U16_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U16_IMM),
     /* 752457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752459 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752466 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752476 */     GIR_RootConstrainSelectedInstOperands,
     /* 752477 */     // GIR_Coverage, 2929,
     /* 752477 */     GIR_EraseRootFromParent_Done,
     /* 752478 */   // Label 9915: @752478
     /* 752478 */   GIM_Try, /*On fail goto*//*Label 9916*/ GIMT_Encode4(752510), // Rule ID 2930 //
     /* 752483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752486 */     // (SIsbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 752486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U16_SGPR_IMM),
     /* 752489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 752491 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 752493 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 752495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 752498 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 752504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752508 */     GIR_RootConstrainSelectedInstOperands,
     /* 752509 */     // GIR_Coverage, 2930,
     /* 752509 */     GIR_EraseRootFromParent_Done,
     /* 752510 */   // Label 9916: @752510
     /* 752510 */   GIM_Reject,
     /* 752511 */ // Label 9913: @752511
     /* 752511 */ GIM_Reject,
     /* 752512 */ // Label 161: @752512
     /* 752512 */ GIM_Try, /*On fail goto*//*Label 9917*/ GIMT_Encode4(752618),
     /* 752517 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 752520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 752523 */   GIM_Try, /*On fail goto*//*Label 9918*/ GIMT_Encode4(752577), // Rule ID 3540 //
     /* 752528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 752535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 752539 */     // MIs[1] Operand 1
     /* 752539 */     // No operand predicates
     /* 752539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 752541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 752548 */     // (SIsbuffer_prefetch v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (imm:{ *:[i32] }):$len)  =>  (S_BUFFER_PREFETCH_DATA SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$len))
     /* 752548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_PREFETCH_DATA),
     /* 752551 */     GIR_RootToRootCopy, /*OpIdx*/0, // sbase
     /* 752553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 752564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // len
     /* 752570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 752575 */     GIR_RootConstrainSelectedInstOperands,
     /* 752576 */     // GIR_Coverage, 3540,
     /* 752576 */     GIR_EraseRootFromParent_Done,
     /* 752577 */   // Label 9918: @752577
     /* 752577 */   GIM_Try, /*On fail goto*//*Label 9919*/ GIMT_Encode4(752617), // Rule ID 3539 //
     /* 752582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 752585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 752589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 752596 */     // (SIsbuffer_prefetch v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), SReg_32:{ *:[i32] }:$len)  =>  (S_BUFFER_PREFETCH_DATA SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, ?:{ *:[i32] }:$len, 0:{ *:[i8] })
     /* 752596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_PREFETCH_DATA),
     /* 752599 */     GIR_RootToRootCopy, /*OpIdx*/0, // sbase
     /* 752601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 752606 */     GIR_RootToRootCopy, /*OpIdx*/2, // len
     /* 752608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 752611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752615 */     GIR_RootConstrainSelectedInstOperands,
     /* 752616 */     // GIR_Coverage, 3539,
     /* 752616 */     GIR_EraseRootFromParent_Done,
     /* 752617 */   // Label 9919: @752617
     /* 752617 */   GIM_Reject,
     /* 752618 */ // Label 9917: @752618
     /* 752618 */ GIM_Reject,
     /* 752619 */ // Label 162: @752619
     /* 752619 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 9924*/ GIMT_Encode4(758102),
     /* 752630 */ /*GILLT_s32*//*Label 9920*/ GIMT_Encode4(752666), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 752642 */ /*GILLT_v2s32*//*Label 9921*/ GIMT_Encode4(754025), GIMT_Encode4(0),
     /* 752650 */ /*GILLT_v3s32*//*Label 9922*/ GIMT_Encode4(755384), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 752662 */ /*GILLT_v4s32*//*Label 9923*/ GIMT_Encode4(756743),
     /* 752666 */ // Label 9920: @752666
     /* 752666 */ GIM_Try, /*On fail goto*//*Label 9925*/ GIMT_Encode4(754024),
     /* 752671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 752674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 752677 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 752680 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 752683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 752687 */   GIM_Try, /*On fail goto*//*Label 9926*/ GIMT_Encode4(752768), // Rule ID 6652 //
     /* 752692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 752695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 752699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 752703 */     // MIs[0] offset
     /* 752703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752706 */     // MIs[0] format
     /* 752706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752709 */     // MIs[0] auxiliary
     /* 752709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 752712 */     // MIs[0] Operand 8
     /* 752712 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 752723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752730 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFSET),
     /* 752733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 752735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752742 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 752750 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752756 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752766 */     GIR_RootConstrainSelectedInstOperands,
     /* 752767 */     // GIR_Coverage, 6652,
     /* 752767 */     GIR_EraseRootFromParent_Done,
     /* 752768 */   // Label 9926: @752768
     /* 752768 */   GIM_Try, /*On fail goto*//*Label 9927*/ GIMT_Encode4(752846), // Rule ID 6656 //
     /* 752773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 752777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 752781 */     // MIs[0] offset
     /* 752781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752784 */     // MIs[0] format
     /* 752784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752787 */     // MIs[0] auxiliary
     /* 752787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 752790 */     // MIs[0] Operand 8
     /* 752790 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 752801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752808 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
     /* 752811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 752813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752820 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752822 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 752828 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752834 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752844 */     GIR_RootConstrainSelectedInstOperands,
     /* 752845 */     // GIR_Coverage, 6656,
     /* 752845 */     GIR_EraseRootFromParent_Done,
     /* 752846 */   // Label 9927: @752846
     /* 752846 */   GIM_Try, /*On fail goto*//*Label 9928*/ GIMT_Encode4(752927), // Rule ID 6684 //
     /* 752851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 752854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 752858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 752862 */     // MIs[0] offset
     /* 752862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752865 */     // MIs[0] format
     /* 752865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752868 */     // MIs[0] auxiliary
     /* 752868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 752871 */     // MIs[0] Operand 8
     /* 752871 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 752882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752889 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFSET),
     /* 752892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 752894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752901 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752903 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 752909 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752915 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752925 */     GIR_RootConstrainSelectedInstOperands,
     /* 752926 */     // GIR_Coverage, 6684,
     /* 752926 */     GIR_EraseRootFromParent_Done,
     /* 752927 */   // Label 9928: @752927
     /* 752927 */   GIM_Try, /*On fail goto*//*Label 9929*/ GIMT_Encode4(753005), // Rule ID 6688 //
     /* 752932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 752936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 752940 */     // MIs[0] offset
     /* 752940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752943 */     // MIs[0] format
     /* 752943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752946 */     // MIs[0] auxiliary
     /* 752946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 752949 */     // MIs[0] Operand 8
     /* 752949 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 752960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752967 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
     /* 752970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 752972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752979 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752981 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 752987 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752993 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753003 */     GIR_RootConstrainSelectedInstOperands,
     /* 753004 */     // GIR_Coverage, 6688,
     /* 753004 */     GIR_EraseRootFromParent_Done,
     /* 753005 */   // Label 9929: @753005
     /* 753005 */   GIM_Try, /*On fail goto*//*Label 9930*/ GIMT_Encode4(753084), // Rule ID 6654 //
     /* 753010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 753013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 753017 */     // MIs[0] offset
     /* 753017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753020 */     // MIs[0] format
     /* 753020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753023 */     // MIs[0] auxiliary
     /* 753023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753026 */     // MIs[0] Operand 8
     /* 753026 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 753037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753044 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFEN),
     /* 753047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753049 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 753051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753058 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753060 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753066 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753072 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753082 */     GIR_RootConstrainSelectedInstOperands,
     /* 753083 */     // GIR_Coverage, 6654,
     /* 753083 */     GIR_EraseRootFromParent_Done,
     /* 753084 */   // Label 9930: @753084
     /* 753084 */   GIM_Try, /*On fail goto*//*Label 9931*/ GIMT_Encode4(753160), // Rule ID 6658 //
     /* 753089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 753093 */     // MIs[0] offset
     /* 753093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753096 */     // MIs[0] format
     /* 753096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753099 */     // MIs[0] auxiliary
     /* 753099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753102 */     // MIs[0] Operand 8
     /* 753102 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 753113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753120 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
     /* 753123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753125 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 753127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753134 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753136 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753142 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753148 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753158 */     GIR_RootConstrainSelectedInstOperands,
     /* 753159 */     // GIR_Coverage, 6658,
     /* 753159 */     GIR_EraseRootFromParent_Done,
     /* 753160 */   // Label 9931: @753160
     /* 753160 */   GIM_Try, /*On fail goto*//*Label 9932*/ GIMT_Encode4(753239), // Rule ID 6686 //
     /* 753165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 753168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 753172 */     // MIs[0] offset
     /* 753172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753175 */     // MIs[0] format
     /* 753175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753178 */     // MIs[0] auxiliary
     /* 753178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753181 */     // MIs[0] Operand 8
     /* 753181 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 753192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753199 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFEN),
     /* 753202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753204 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 753206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753213 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753227 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753237 */     GIR_RootConstrainSelectedInstOperands,
     /* 753238 */     // GIR_Coverage, 6686,
     /* 753238 */     GIR_EraseRootFromParent_Done,
     /* 753239 */   // Label 9932: @753239
     /* 753239 */   GIM_Try, /*On fail goto*//*Label 9933*/ GIMT_Encode4(753315), // Rule ID 6690 //
     /* 753244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 753248 */     // MIs[0] offset
     /* 753248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753251 */     // MIs[0] format
     /* 753251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753254 */     // MIs[0] auxiliary
     /* 753254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753257 */     // MIs[0] Operand 8
     /* 753257 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 753268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753275 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
     /* 753278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753280 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 753282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753289 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753291 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753297 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753303 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753313 */     GIR_RootConstrainSelectedInstOperands,
     /* 753314 */     // GIR_Coverage, 6690,
     /* 753314 */     GIR_EraseRootFromParent_Done,
     /* 753315 */   // Label 9933: @753315
     /* 753315 */   GIM_Try, /*On fail goto*//*Label 9934*/ GIMT_Encode4(753386), // Rule ID 6653 //
     /* 753320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 753323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 753327 */     // MIs[0] offset
     /* 753327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753330 */     // MIs[0] format
     /* 753330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753333 */     // MIs[0] auxiliary
     /* 753333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753336 */     // MIs[0] Operand 8
     /* 753336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 753339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753346 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_IDXEN),
     /* 753349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753351 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 753353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753360 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753368 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753374 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753384 */     GIR_RootConstrainSelectedInstOperands,
     /* 753385 */     // GIR_Coverage, 6653,
     /* 753385 */     GIR_EraseRootFromParent_Done,
     /* 753386 */   // Label 9934: @753386
     /* 753386 */   GIM_Try, /*On fail goto*//*Label 9935*/ GIMT_Encode4(753454), // Rule ID 6657 //
     /* 753391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 753395 */     // MIs[0] offset
     /* 753395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753398 */     // MIs[0] format
     /* 753398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753401 */     // MIs[0] auxiliary
     /* 753401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753404 */     // MIs[0] Operand 8
     /* 753404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 753407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753414 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
     /* 753417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753419 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 753421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753428 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753452 */     GIR_RootConstrainSelectedInstOperands,
     /* 753453 */     // GIR_Coverage, 6657,
     /* 753453 */     GIR_EraseRootFromParent_Done,
     /* 753454 */   // Label 9935: @753454
     /* 753454 */   GIM_Try, /*On fail goto*//*Label 9936*/ GIMT_Encode4(753525), // Rule ID 6685 //
     /* 753459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 753462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 753466 */     // MIs[0] offset
     /* 753466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753469 */     // MIs[0] format
     /* 753469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753472 */     // MIs[0] auxiliary
     /* 753472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753475 */     // MIs[0] Operand 8
     /* 753475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 753478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753485 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_IDXEN),
     /* 753488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753490 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 753492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753499 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753501 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753513 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753523 */     GIR_RootConstrainSelectedInstOperands,
     /* 753524 */     // GIR_Coverage, 6685,
     /* 753524 */     GIR_EraseRootFromParent_Done,
     /* 753525 */   // Label 9936: @753525
     /* 753525 */   GIM_Try, /*On fail goto*//*Label 9937*/ GIMT_Encode4(753593), // Rule ID 6689 //
     /* 753530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 753534 */     // MIs[0] offset
     /* 753534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753537 */     // MIs[0] format
     /* 753537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753540 */     // MIs[0] auxiliary
     /* 753540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753543 */     // MIs[0] Operand 8
     /* 753543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 753546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753553 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
     /* 753556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753558 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 753560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753567 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753569 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753575 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753581 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753591 */     GIR_RootConstrainSelectedInstOperands,
     /* 753592 */     // GIR_Coverage, 6689,
     /* 753592 */     GIR_EraseRootFromParent_Done,
     /* 753593 */   // Label 9937: @753593
     /* 753593 */   GIM_Try, /*On fail goto*//*Label 9938*/ GIMT_Encode4(753702), // Rule ID 6655 //
     /* 753598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 753601 */     // MIs[0] offset
     /* 753601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753604 */     // MIs[0] format
     /* 753604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753607 */     // MIs[0] auxiliary
     /* 753607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753610 */     // MIs[0] Operand 8
     /* 753610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 753613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753620 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 753623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 753627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 753632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 753636 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 753639 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 753643 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 753646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 753651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_BOTHEN),
     /* 753664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 753669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753676 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753678 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753684 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753690 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753700 */     GIR_RootConstrainSelectedInstOperands,
     /* 753701 */     // GIR_Coverage, 6655,
     /* 753701 */     GIR_EraseRootFromParent_Done,
     /* 753702 */   // Label 9938: @753702
     /* 753702 */   GIM_Try, /*On fail goto*//*Label 9939*/ GIMT_Encode4(753808), // Rule ID 6659 //
     /* 753707 */     // MIs[0] offset
     /* 753707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753710 */     // MIs[0] format
     /* 753710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753713 */     // MIs[0] auxiliary
     /* 753713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753716 */     // MIs[0] Operand 8
     /* 753716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 753719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753726 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 753729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 753733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 753738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 753742 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 753745 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 753749 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 753752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 753757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
     /* 753770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 753775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753782 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753784 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753790 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753796 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753806 */     GIR_RootConstrainSelectedInstOperands,
     /* 753807 */     // GIR_Coverage, 6659,
     /* 753807 */     GIR_EraseRootFromParent_Done,
     /* 753808 */   // Label 9939: @753808
     /* 753808 */   GIM_Try, /*On fail goto*//*Label 9940*/ GIMT_Encode4(753917), // Rule ID 6687 //
     /* 753813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 753816 */     // MIs[0] offset
     /* 753816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753819 */     // MIs[0] format
     /* 753819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753822 */     // MIs[0] auxiliary
     /* 753822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753825 */     // MIs[0] Operand 8
     /* 753825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 753828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753835 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 753838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 753842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 753847 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 753851 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 753854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 753858 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 753861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 753866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_BOTHEN),
     /* 753879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 753884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753891 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753893 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 753899 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753905 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753915 */     GIR_RootConstrainSelectedInstOperands,
     /* 753916 */     // GIR_Coverage, 6687,
     /* 753916 */     GIR_EraseRootFromParent_Done,
     /* 753917 */   // Label 9940: @753917
     /* 753917 */   GIM_Try, /*On fail goto*//*Label 9941*/ GIMT_Encode4(754023), // Rule ID 6691 //
     /* 753922 */     // MIs[0] offset
     /* 753922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 753925 */     // MIs[0] format
     /* 753925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 753928 */     // MIs[0] auxiliary
     /* 753928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 753931 */     // MIs[0] Operand 8
     /* 753931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 753934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753941 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 753944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 753948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 753953 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 753957 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 753960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 753964 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 753967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 753972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
     /* 753985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 753987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 753990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753997 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753999 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754005 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754011 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754021 */     GIR_RootConstrainSelectedInstOperands,
     /* 754022 */     // GIR_Coverage, 6691,
     /* 754022 */     GIR_EraseRootFromParent_Done,
     /* 754023 */   // Label 9941: @754023
     /* 754023 */   GIM_Reject,
     /* 754024 */ // Label 9925: @754024
     /* 754024 */ GIM_Reject,
     /* 754025 */ // Label 9921: @754025
     /* 754025 */ GIM_Try, /*On fail goto*//*Label 9942*/ GIMT_Encode4(755383),
     /* 754030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 754033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 754036 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 754039 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 754042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 754046 */   GIM_Try, /*On fail goto*//*Label 9943*/ GIMT_Encode4(754127), // Rule ID 6660 //
     /* 754051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 754054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 754062 */     // MIs[0] offset
     /* 754062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754065 */     // MIs[0] format
     /* 754065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754068 */     // MIs[0] auxiliary
     /* 754068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754071 */     // MIs[0] Operand 8
     /* 754071 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754089 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFSET),
     /* 754092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754101 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754103 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754109 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754125 */     GIR_RootConstrainSelectedInstOperands,
     /* 754126 */     // GIR_Coverage, 6660,
     /* 754126 */     GIR_EraseRootFromParent_Done,
     /* 754127 */   // Label 9943: @754127
     /* 754127 */   GIM_Try, /*On fail goto*//*Label 9944*/ GIMT_Encode4(754205), // Rule ID 6664 //
     /* 754132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 754140 */     // MIs[0] offset
     /* 754140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754143 */     // MIs[0] format
     /* 754143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754146 */     // MIs[0] auxiliary
     /* 754146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754149 */     // MIs[0] Operand 8
     /* 754149 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754167 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
     /* 754170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754179 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754181 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754187 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754193 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754203 */     GIR_RootConstrainSelectedInstOperands,
     /* 754204 */     // GIR_Coverage, 6664,
     /* 754204 */     GIR_EraseRootFromParent_Done,
     /* 754205 */   // Label 9944: @754205
     /* 754205 */   GIM_Try, /*On fail goto*//*Label 9945*/ GIMT_Encode4(754286), // Rule ID 6692 //
     /* 754210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 754213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 754221 */     // MIs[0] offset
     /* 754221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754224 */     // MIs[0] format
     /* 754224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754227 */     // MIs[0] auxiliary
     /* 754227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754230 */     // MIs[0] Operand 8
     /* 754230 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754248 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFSET),
     /* 754251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754260 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754262 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754268 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754274 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754284 */     GIR_RootConstrainSelectedInstOperands,
     /* 754285 */     // GIR_Coverage, 6692,
     /* 754285 */     GIR_EraseRootFromParent_Done,
     /* 754286 */   // Label 9945: @754286
     /* 754286 */   GIM_Try, /*On fail goto*//*Label 9946*/ GIMT_Encode4(754364), // Rule ID 6696 //
     /* 754291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 754299 */     // MIs[0] offset
     /* 754299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754302 */     // MIs[0] format
     /* 754302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754305 */     // MIs[0] auxiliary
     /* 754305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754308 */     // MIs[0] Operand 8
     /* 754308 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754326 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
     /* 754329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754338 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754340 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754346 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754352 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754362 */     GIR_RootConstrainSelectedInstOperands,
     /* 754363 */     // GIR_Coverage, 6696,
     /* 754363 */     GIR_EraseRootFromParent_Done,
     /* 754364 */   // Label 9946: @754364
     /* 754364 */   GIM_Try, /*On fail goto*//*Label 9947*/ GIMT_Encode4(754443), // Rule ID 6662 //
     /* 754369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 754372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754376 */     // MIs[0] offset
     /* 754376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754379 */     // MIs[0] format
     /* 754379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754382 */     // MIs[0] auxiliary
     /* 754382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754385 */     // MIs[0] Operand 8
     /* 754385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754403 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFEN),
     /* 754406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754408 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 754410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754417 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754431 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754441 */     GIR_RootConstrainSelectedInstOperands,
     /* 754442 */     // GIR_Coverage, 6662,
     /* 754442 */     GIR_EraseRootFromParent_Done,
     /* 754443 */   // Label 9947: @754443
     /* 754443 */   GIM_Try, /*On fail goto*//*Label 9948*/ GIMT_Encode4(754519), // Rule ID 6666 //
     /* 754448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754452 */     // MIs[0] offset
     /* 754452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754455 */     // MIs[0] format
     /* 754455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754458 */     // MIs[0] auxiliary
     /* 754458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754461 */     // MIs[0] Operand 8
     /* 754461 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754479 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
     /* 754482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754484 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 754486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754493 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754495 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754501 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754517 */     GIR_RootConstrainSelectedInstOperands,
     /* 754518 */     // GIR_Coverage, 6666,
     /* 754518 */     GIR_EraseRootFromParent_Done,
     /* 754519 */   // Label 9948: @754519
     /* 754519 */   GIM_Try, /*On fail goto*//*Label 9949*/ GIMT_Encode4(754598), // Rule ID 6694 //
     /* 754524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 754527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754531 */     // MIs[0] offset
     /* 754531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754534 */     // MIs[0] format
     /* 754534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754537 */     // MIs[0] auxiliary
     /* 754537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754540 */     // MIs[0] Operand 8
     /* 754540 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754558 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFEN),
     /* 754561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754563 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 754565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754572 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754574 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754580 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754586 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754596 */     GIR_RootConstrainSelectedInstOperands,
     /* 754597 */     // GIR_Coverage, 6694,
     /* 754597 */     GIR_EraseRootFromParent_Done,
     /* 754598 */   // Label 9949: @754598
     /* 754598 */   GIM_Try, /*On fail goto*//*Label 9950*/ GIMT_Encode4(754674), // Rule ID 6698 //
     /* 754603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 754607 */     // MIs[0] offset
     /* 754607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754610 */     // MIs[0] format
     /* 754610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754613 */     // MIs[0] auxiliary
     /* 754613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754616 */     // MIs[0] Operand 8
     /* 754616 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 754627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754634 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
     /* 754637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754639 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 754641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754648 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754650 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754656 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754662 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754672 */     GIR_RootConstrainSelectedInstOperands,
     /* 754673 */     // GIR_Coverage, 6698,
     /* 754673 */     GIR_EraseRootFromParent_Done,
     /* 754674 */   // Label 9950: @754674
     /* 754674 */   GIM_Try, /*On fail goto*//*Label 9951*/ GIMT_Encode4(754745), // Rule ID 6661 //
     /* 754679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 754682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 754686 */     // MIs[0] offset
     /* 754686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754689 */     // MIs[0] format
     /* 754689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754692 */     // MIs[0] auxiliary
     /* 754692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754695 */     // MIs[0] Operand 8
     /* 754695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 754698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754705 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_IDXEN),
     /* 754708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754710 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 754712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754719 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754721 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754727 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754733 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754743 */     GIR_RootConstrainSelectedInstOperands,
     /* 754744 */     // GIR_Coverage, 6661,
     /* 754744 */     GIR_EraseRootFromParent_Done,
     /* 754745 */   // Label 9951: @754745
     /* 754745 */   GIM_Try, /*On fail goto*//*Label 9952*/ GIMT_Encode4(754813), // Rule ID 6665 //
     /* 754750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 754754 */     // MIs[0] offset
     /* 754754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754757 */     // MIs[0] format
     /* 754757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754760 */     // MIs[0] auxiliary
     /* 754760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754763 */     // MIs[0] Operand 8
     /* 754763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 754766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754773 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
     /* 754776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754778 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 754780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754787 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754789 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754795 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754801 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754811 */     GIR_RootConstrainSelectedInstOperands,
     /* 754812 */     // GIR_Coverage, 6665,
     /* 754812 */     GIR_EraseRootFromParent_Done,
     /* 754813 */   // Label 9952: @754813
     /* 754813 */   GIM_Try, /*On fail goto*//*Label 9953*/ GIMT_Encode4(754884), // Rule ID 6693 //
     /* 754818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 754821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 754825 */     // MIs[0] offset
     /* 754825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754828 */     // MIs[0] format
     /* 754828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754831 */     // MIs[0] auxiliary
     /* 754831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754834 */     // MIs[0] Operand 8
     /* 754834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 754837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754844 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_IDXEN),
     /* 754847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754849 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 754851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754858 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754860 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754866 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754872 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754882 */     GIR_RootConstrainSelectedInstOperands,
     /* 754883 */     // GIR_Coverage, 6693,
     /* 754883 */     GIR_EraseRootFromParent_Done,
     /* 754884 */   // Label 9953: @754884
     /* 754884 */   GIM_Try, /*On fail goto*//*Label 9954*/ GIMT_Encode4(754952), // Rule ID 6697 //
     /* 754889 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 754893 */     // MIs[0] offset
     /* 754893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754896 */     // MIs[0] format
     /* 754896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754899 */     // MIs[0] auxiliary
     /* 754899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754902 */     // MIs[0] Operand 8
     /* 754902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 754905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754912 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
     /* 754915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 754917 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 754919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 754921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 754926 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 754928 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 754934 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 754940 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 754946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 754950 */     GIR_RootConstrainSelectedInstOperands,
     /* 754951 */     // GIR_Coverage, 6697,
     /* 754951 */     GIR_EraseRootFromParent_Done,
     /* 754952 */   // Label 9954: @754952
     /* 754952 */   GIM_Try, /*On fail goto*//*Label 9955*/ GIMT_Encode4(755061), // Rule ID 6663 //
     /* 754957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 754960 */     // MIs[0] offset
     /* 754960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 754963 */     // MIs[0] format
     /* 754963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 754966 */     // MIs[0] auxiliary
     /* 754966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 754969 */     // MIs[0] Operand 8
     /* 754969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 754972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 754979 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 754979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 754982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 754986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 754991 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 754995 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 754998 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 755002 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 755005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 755010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_BOTHEN),
     /* 755023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 755028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755035 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755037 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755043 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755049 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755059 */     GIR_RootConstrainSelectedInstOperands,
     /* 755060 */     // GIR_Coverage, 6663,
     /* 755060 */     GIR_EraseRootFromParent_Done,
     /* 755061 */   // Label 9955: @755061
     /* 755061 */   GIM_Try, /*On fail goto*//*Label 9956*/ GIMT_Encode4(755167), // Rule ID 6667 //
     /* 755066 */     // MIs[0] offset
     /* 755066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755069 */     // MIs[0] format
     /* 755069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755072 */     // MIs[0] auxiliary
     /* 755072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755075 */     // MIs[0] Operand 8
     /* 755075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 755078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755085 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 755088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 755092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 755097 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 755101 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 755104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 755108 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 755111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 755116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
     /* 755129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 755134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755141 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755143 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755149 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755155 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755165 */     GIR_RootConstrainSelectedInstOperands,
     /* 755166 */     // GIR_Coverage, 6667,
     /* 755166 */     GIR_EraseRootFromParent_Done,
     /* 755167 */   // Label 9956: @755167
     /* 755167 */   GIM_Try, /*On fail goto*//*Label 9957*/ GIMT_Encode4(755276), // Rule ID 6695 //
     /* 755172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 755175 */     // MIs[0] offset
     /* 755175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755178 */     // MIs[0] format
     /* 755178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755181 */     // MIs[0] auxiliary
     /* 755181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755184 */     // MIs[0] Operand 8
     /* 755184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 755187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755194 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 755197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 755201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 755206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 755210 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 755213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 755217 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 755220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 755225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_BOTHEN),
     /* 755238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 755243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755250 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755258 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755264 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755274 */     GIR_RootConstrainSelectedInstOperands,
     /* 755275 */     // GIR_Coverage, 6695,
     /* 755275 */     GIR_EraseRootFromParent_Done,
     /* 755276 */   // Label 9957: @755276
     /* 755276 */   GIM_Try, /*On fail goto*//*Label 9958*/ GIMT_Encode4(755382), // Rule ID 6699 //
     /* 755281 */     // MIs[0] offset
     /* 755281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755284 */     // MIs[0] format
     /* 755284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755287 */     // MIs[0] auxiliary
     /* 755287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755290 */     // MIs[0] Operand 8
     /* 755290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 755293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755300 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 755303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 755307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 755312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 755316 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 755319 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 755323 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 755326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 755331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
     /* 755344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 755349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755356 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755358 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755364 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755370 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755380 */     GIR_RootConstrainSelectedInstOperands,
     /* 755381 */     // GIR_Coverage, 6699,
     /* 755381 */     GIR_EraseRootFromParent_Done,
     /* 755382 */   // Label 9958: @755382
     /* 755382 */   GIM_Reject,
     /* 755383 */ // Label 9942: @755383
     /* 755383 */ GIM_Reject,
     /* 755384 */ // Label 9922: @755384
     /* 755384 */ GIM_Try, /*On fail goto*//*Label 9959*/ GIMT_Encode4(756742),
     /* 755389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 755392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 755395 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 755398 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 755401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 755405 */   GIM_Try, /*On fail goto*//*Label 9960*/ GIMT_Encode4(755486), // Rule ID 6668 //
     /* 755410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 755413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 755417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 755421 */     // MIs[0] offset
     /* 755421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755424 */     // MIs[0] format
     /* 755424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755427 */     // MIs[0] auxiliary
     /* 755427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755430 */     // MIs[0] Operand 8
     /* 755430 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 755441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755448 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFSET),
     /* 755451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755460 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755462 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755474 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755484 */     GIR_RootConstrainSelectedInstOperands,
     /* 755485 */     // GIR_Coverage, 6668,
     /* 755485 */     GIR_EraseRootFromParent_Done,
     /* 755486 */   // Label 9960: @755486
     /* 755486 */   GIM_Try, /*On fail goto*//*Label 9961*/ GIMT_Encode4(755564), // Rule ID 6672 //
     /* 755491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 755495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 755499 */     // MIs[0] offset
     /* 755499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755502 */     // MIs[0] format
     /* 755502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755505 */     // MIs[0] auxiliary
     /* 755505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755508 */     // MIs[0] Operand 8
     /* 755508 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 755519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755526 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
     /* 755529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755538 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755540 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755546 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755552 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755562 */     GIR_RootConstrainSelectedInstOperands,
     /* 755563 */     // GIR_Coverage, 6672,
     /* 755563 */     GIR_EraseRootFromParent_Done,
     /* 755564 */   // Label 9961: @755564
     /* 755564 */   GIM_Try, /*On fail goto*//*Label 9962*/ GIMT_Encode4(755645), // Rule ID 6700 //
     /* 755569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 755572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 755576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 755580 */     // MIs[0] offset
     /* 755580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755583 */     // MIs[0] format
     /* 755583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755586 */     // MIs[0] auxiliary
     /* 755586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755589 */     // MIs[0] Operand 8
     /* 755589 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 755600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755607 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFSET),
     /* 755610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755619 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755621 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755627 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755643 */     GIR_RootConstrainSelectedInstOperands,
     /* 755644 */     // GIR_Coverage, 6700,
     /* 755644 */     GIR_EraseRootFromParent_Done,
     /* 755645 */   // Label 9962: @755645
     /* 755645 */   GIM_Try, /*On fail goto*//*Label 9963*/ GIMT_Encode4(755723), // Rule ID 6704 //
     /* 755650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 755654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 755658 */     // MIs[0] offset
     /* 755658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755661 */     // MIs[0] format
     /* 755661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755664 */     // MIs[0] auxiliary
     /* 755664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755667 */     // MIs[0] Operand 8
     /* 755667 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 755678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755685 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
     /* 755688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755697 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755705 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755711 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755721 */     GIR_RootConstrainSelectedInstOperands,
     /* 755722 */     // GIR_Coverage, 6704,
     /* 755722 */     GIR_EraseRootFromParent_Done,
     /* 755723 */   // Label 9963: @755723
     /* 755723 */   GIM_Try, /*On fail goto*//*Label 9964*/ GIMT_Encode4(755802), // Rule ID 6670 //
     /* 755728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 755731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 755735 */     // MIs[0] offset
     /* 755735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755738 */     // MIs[0] format
     /* 755738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755741 */     // MIs[0] auxiliary
     /* 755741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755744 */     // MIs[0] Operand 8
     /* 755744 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 755755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755762 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFEN),
     /* 755765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755767 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 755769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755776 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755778 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755784 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755790 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755800 */     GIR_RootConstrainSelectedInstOperands,
     /* 755801 */     // GIR_Coverage, 6670,
     /* 755801 */     GIR_EraseRootFromParent_Done,
     /* 755802 */   // Label 9964: @755802
     /* 755802 */   GIM_Try, /*On fail goto*//*Label 9965*/ GIMT_Encode4(755878), // Rule ID 6674 //
     /* 755807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 755811 */     // MIs[0] offset
     /* 755811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755814 */     // MIs[0] format
     /* 755814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755817 */     // MIs[0] auxiliary
     /* 755817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755820 */     // MIs[0] Operand 8
     /* 755820 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 755831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755838 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
     /* 755841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755843 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 755845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755852 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755854 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755860 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755866 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755876 */     GIR_RootConstrainSelectedInstOperands,
     /* 755877 */     // GIR_Coverage, 6674,
     /* 755877 */     GIR_EraseRootFromParent_Done,
     /* 755878 */   // Label 9965: @755878
     /* 755878 */   GIM_Try, /*On fail goto*//*Label 9966*/ GIMT_Encode4(755957), // Rule ID 6702 //
     /* 755883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 755886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 755890 */     // MIs[0] offset
     /* 755890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755893 */     // MIs[0] format
     /* 755893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755896 */     // MIs[0] auxiliary
     /* 755896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755899 */     // MIs[0] Operand 8
     /* 755899 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 755910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755917 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFEN),
     /* 755920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755922 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 755924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 755926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755931 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 755933 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 755939 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 755945 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 755951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755955 */     GIR_RootConstrainSelectedInstOperands,
     /* 755956 */     // GIR_Coverage, 6702,
     /* 755956 */     GIR_EraseRootFromParent_Done,
     /* 755957 */   // Label 9966: @755957
     /* 755957 */   GIM_Try, /*On fail goto*//*Label 9967*/ GIMT_Encode4(756033), // Rule ID 6706 //
     /* 755962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 755966 */     // MIs[0] offset
     /* 755966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 755969 */     // MIs[0] format
     /* 755969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 755972 */     // MIs[0] auxiliary
     /* 755972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 755975 */     // MIs[0] Operand 8
     /* 755975 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 755986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 755993 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 755993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
     /* 755996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 755998 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 756000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756007 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756009 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756015 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756021 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756031 */     GIR_RootConstrainSelectedInstOperands,
     /* 756032 */     // GIR_Coverage, 6706,
     /* 756032 */     GIR_EraseRootFromParent_Done,
     /* 756033 */   // Label 9967: @756033
     /* 756033 */   GIM_Try, /*On fail goto*//*Label 9968*/ GIMT_Encode4(756104), // Rule ID 6669 //
     /* 756038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 756041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 756045 */     // MIs[0] offset
     /* 756045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756048 */     // MIs[0] format
     /* 756048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756051 */     // MIs[0] auxiliary
     /* 756051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756054 */     // MIs[0] Operand 8
     /* 756054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756064 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_IDXEN),
     /* 756067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756069 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 756071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756078 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756080 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756086 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756092 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756102 */     GIR_RootConstrainSelectedInstOperands,
     /* 756103 */     // GIR_Coverage, 6669,
     /* 756103 */     GIR_EraseRootFromParent_Done,
     /* 756104 */   // Label 9968: @756104
     /* 756104 */   GIM_Try, /*On fail goto*//*Label 9969*/ GIMT_Encode4(756172), // Rule ID 6673 //
     /* 756109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 756113 */     // MIs[0] offset
     /* 756113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756116 */     // MIs[0] format
     /* 756116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756119 */     // MIs[0] auxiliary
     /* 756119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756122 */     // MIs[0] Operand 8
     /* 756122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756132 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
     /* 756135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756137 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 756139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756146 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756148 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756154 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756160 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756170 */     GIR_RootConstrainSelectedInstOperands,
     /* 756171 */     // GIR_Coverage, 6673,
     /* 756171 */     GIR_EraseRootFromParent_Done,
     /* 756172 */   // Label 9969: @756172
     /* 756172 */   GIM_Try, /*On fail goto*//*Label 9970*/ GIMT_Encode4(756243), // Rule ID 6701 //
     /* 756177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 756180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 756184 */     // MIs[0] offset
     /* 756184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756187 */     // MIs[0] format
     /* 756187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756190 */     // MIs[0] auxiliary
     /* 756190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756193 */     // MIs[0] Operand 8
     /* 756193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756203 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_IDXEN),
     /* 756206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756208 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 756210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756217 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756219 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756225 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756231 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756241 */     GIR_RootConstrainSelectedInstOperands,
     /* 756242 */     // GIR_Coverage, 6701,
     /* 756242 */     GIR_EraseRootFromParent_Done,
     /* 756243 */   // Label 9970: @756243
     /* 756243 */   GIM_Try, /*On fail goto*//*Label 9971*/ GIMT_Encode4(756311), // Rule ID 6705 //
     /* 756248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 756252 */     // MIs[0] offset
     /* 756252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756255 */     // MIs[0] format
     /* 756255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756258 */     // MIs[0] auxiliary
     /* 756258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756261 */     // MIs[0] Operand 8
     /* 756261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756271 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
     /* 756274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756276 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 756278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756285 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756293 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756299 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756309 */     GIR_RootConstrainSelectedInstOperands,
     /* 756310 */     // GIR_Coverage, 6705,
     /* 756310 */     GIR_EraseRootFromParent_Done,
     /* 756311 */   // Label 9971: @756311
     /* 756311 */   GIM_Try, /*On fail goto*//*Label 9972*/ GIMT_Encode4(756420), // Rule ID 6671 //
     /* 756316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 756319 */     // MIs[0] offset
     /* 756319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756322 */     // MIs[0] format
     /* 756322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756325 */     // MIs[0] auxiliary
     /* 756325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756328 */     // MIs[0] Operand 8
     /* 756328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756338 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 756341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 756345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 756350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 756354 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 756357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 756361 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 756364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 756369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_BOTHEN),
     /* 756382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 756387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756394 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756396 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756418 */     GIR_RootConstrainSelectedInstOperands,
     /* 756419 */     // GIR_Coverage, 6671,
     /* 756419 */     GIR_EraseRootFromParent_Done,
     /* 756420 */   // Label 9972: @756420
     /* 756420 */   GIM_Try, /*On fail goto*//*Label 9973*/ GIMT_Encode4(756526), // Rule ID 6675 //
     /* 756425 */     // MIs[0] offset
     /* 756425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756428 */     // MIs[0] format
     /* 756428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756431 */     // MIs[0] auxiliary
     /* 756431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756434 */     // MIs[0] Operand 8
     /* 756434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756444 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 756447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 756451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 756456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 756460 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 756463 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 756467 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 756470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 756475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
     /* 756488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 756493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756500 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756502 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756508 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756514 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756524 */     GIR_RootConstrainSelectedInstOperands,
     /* 756525 */     // GIR_Coverage, 6675,
     /* 756525 */     GIR_EraseRootFromParent_Done,
     /* 756526 */   // Label 9973: @756526
     /* 756526 */   GIM_Try, /*On fail goto*//*Label 9974*/ GIMT_Encode4(756635), // Rule ID 6703 //
     /* 756531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 756534 */     // MIs[0] offset
     /* 756534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756537 */     // MIs[0] format
     /* 756537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756540 */     // MIs[0] auxiliary
     /* 756540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756543 */     // MIs[0] Operand 8
     /* 756543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756553 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 756556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 756560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 756565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 756569 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 756572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 756576 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 756579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 756584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_BOTHEN),
     /* 756597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 756602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756609 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756611 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756617 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756623 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756633 */     GIR_RootConstrainSelectedInstOperands,
     /* 756634 */     // GIR_Coverage, 6703,
     /* 756634 */     GIR_EraseRootFromParent_Done,
     /* 756635 */   // Label 9974: @756635
     /* 756635 */   GIM_Try, /*On fail goto*//*Label 9975*/ GIMT_Encode4(756741), // Rule ID 6707 //
     /* 756640 */     // MIs[0] offset
     /* 756640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756643 */     // MIs[0] format
     /* 756643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756646 */     // MIs[0] auxiliary
     /* 756646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756649 */     // MIs[0] Operand 8
     /* 756649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 756652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756659 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 756662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 756666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 756671 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 756675 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 756678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 756682 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 756685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 756690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 756700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
     /* 756703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 756708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756715 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756723 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756729 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756739 */     GIR_RootConstrainSelectedInstOperands,
     /* 756740 */     // GIR_Coverage, 6707,
     /* 756740 */     GIR_EraseRootFromParent_Done,
     /* 756741 */   // Label 9975: @756741
     /* 756741 */   GIM_Reject,
     /* 756742 */ // Label 9959: @756742
     /* 756742 */ GIM_Reject,
     /* 756743 */ // Label 9923: @756743
     /* 756743 */ GIM_Try, /*On fail goto*//*Label 9976*/ GIMT_Encode4(758101),
     /* 756748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 756751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 756754 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 756757 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 756760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 756764 */   GIM_Try, /*On fail goto*//*Label 9977*/ GIMT_Encode4(756845), // Rule ID 6676 //
     /* 756769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 756772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 756776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 756780 */     // MIs[0] offset
     /* 756780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756783 */     // MIs[0] format
     /* 756783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756786 */     // MIs[0] auxiliary
     /* 756786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756789 */     // MIs[0] Operand 8
     /* 756789 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 756800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756807 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFSET),
     /* 756810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756819 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756827 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756833 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756843 */     GIR_RootConstrainSelectedInstOperands,
     /* 756844 */     // GIR_Coverage, 6676,
     /* 756844 */     GIR_EraseRootFromParent_Done,
     /* 756845 */   // Label 9977: @756845
     /* 756845 */   GIM_Try, /*On fail goto*//*Label 9978*/ GIMT_Encode4(756923), // Rule ID 6680 //
     /* 756850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 756854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 756858 */     // MIs[0] offset
     /* 756858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756861 */     // MIs[0] format
     /* 756861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756864 */     // MIs[0] auxiliary
     /* 756864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756867 */     // MIs[0] Operand 8
     /* 756867 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 756878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756885 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
     /* 756888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756897 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756899 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756905 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756911 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756921 */     GIR_RootConstrainSelectedInstOperands,
     /* 756922 */     // GIR_Coverage, 6680,
     /* 756922 */     GIR_EraseRootFromParent_Done,
     /* 756923 */   // Label 9978: @756923
     /* 756923 */   GIM_Try, /*On fail goto*//*Label 9979*/ GIMT_Encode4(757004), // Rule ID 6708 //
     /* 756928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 756931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 756935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 756939 */     // MIs[0] offset
     /* 756939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 756942 */     // MIs[0] format
     /* 756942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 756945 */     // MIs[0] auxiliary
     /* 756945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 756948 */     // MIs[0] Operand 8
     /* 756948 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 756959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 756966 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 756966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFSET),
     /* 756969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 756971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 756973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756978 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 756980 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 756986 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 756992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 756998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757002 */     GIR_RootConstrainSelectedInstOperands,
     /* 757003 */     // GIR_Coverage, 6708,
     /* 757003 */     GIR_EraseRootFromParent_Done,
     /* 757004 */   // Label 9979: @757004
     /* 757004 */   GIM_Try, /*On fail goto*//*Label 9980*/ GIMT_Encode4(757082), // Rule ID 6712 //
     /* 757009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 757013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 757017 */     // MIs[0] offset
     /* 757017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757020 */     // MIs[0] format
     /* 757020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757023 */     // MIs[0] auxiliary
     /* 757023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757026 */     // MIs[0] Operand 8
     /* 757026 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 757037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757044 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
     /* 757047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757056 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757058 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757070 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757080 */     GIR_RootConstrainSelectedInstOperands,
     /* 757081 */     // GIR_Coverage, 6712,
     /* 757081 */     GIR_EraseRootFromParent_Done,
     /* 757082 */   // Label 9980: @757082
     /* 757082 */   GIM_Try, /*On fail goto*//*Label 9981*/ GIMT_Encode4(757161), // Rule ID 6678 //
     /* 757087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 757090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 757094 */     // MIs[0] offset
     /* 757094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757097 */     // MIs[0] format
     /* 757097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757100 */     // MIs[0] auxiliary
     /* 757100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757103 */     // MIs[0] Operand 8
     /* 757103 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 757114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757121 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFEN),
     /* 757124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757126 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 757128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757135 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757137 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757143 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757149 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757159 */     GIR_RootConstrainSelectedInstOperands,
     /* 757160 */     // GIR_Coverage, 6678,
     /* 757160 */     GIR_EraseRootFromParent_Done,
     /* 757161 */   // Label 9981: @757161
     /* 757161 */   GIM_Try, /*On fail goto*//*Label 9982*/ GIMT_Encode4(757237), // Rule ID 6682 //
     /* 757166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 757170 */     // MIs[0] offset
     /* 757170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757173 */     // MIs[0] format
     /* 757173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757176 */     // MIs[0] auxiliary
     /* 757176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757179 */     // MIs[0] Operand 8
     /* 757179 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 757190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757197 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
     /* 757200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757202 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 757204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757211 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757213 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757219 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757225 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757235 */     GIR_RootConstrainSelectedInstOperands,
     /* 757236 */     // GIR_Coverage, 6682,
     /* 757236 */     GIR_EraseRootFromParent_Done,
     /* 757237 */   // Label 9982: @757237
     /* 757237 */   GIM_Try, /*On fail goto*//*Label 9983*/ GIMT_Encode4(757316), // Rule ID 6710 //
     /* 757242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 757245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 757249 */     // MIs[0] offset
     /* 757249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757252 */     // MIs[0] format
     /* 757252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757255 */     // MIs[0] auxiliary
     /* 757255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757258 */     // MIs[0] Operand 8
     /* 757258 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 757269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757276 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFEN),
     /* 757279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757281 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 757283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757290 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757292 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757298 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757304 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757314 */     GIR_RootConstrainSelectedInstOperands,
     /* 757315 */     // GIR_Coverage, 6710,
     /* 757315 */     GIR_EraseRootFromParent_Done,
     /* 757316 */   // Label 9983: @757316
     /* 757316 */   GIM_Try, /*On fail goto*//*Label 9984*/ GIMT_Encode4(757392), // Rule ID 6714 //
     /* 757321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 757325 */     // MIs[0] offset
     /* 757325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757328 */     // MIs[0] format
     /* 757328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757331 */     // MIs[0] auxiliary
     /* 757331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757334 */     // MIs[0] Operand 8
     /* 757334 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 757345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757352 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
     /* 757355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757357 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 757359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757366 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757368 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757374 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757380 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757390 */     GIR_RootConstrainSelectedInstOperands,
     /* 757391 */     // GIR_Coverage, 6714,
     /* 757391 */     GIR_EraseRootFromParent_Done,
     /* 757392 */   // Label 9984: @757392
     /* 757392 */   GIM_Try, /*On fail goto*//*Label 9985*/ GIMT_Encode4(757463), // Rule ID 6677 //
     /* 757397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 757400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 757404 */     // MIs[0] offset
     /* 757404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757407 */     // MIs[0] format
     /* 757407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757410 */     // MIs[0] auxiliary
     /* 757410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757413 */     // MIs[0] Operand 8
     /* 757413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 757416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757423 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_IDXEN),
     /* 757426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757428 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 757430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757437 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757439 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757445 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757451 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757461 */     GIR_RootConstrainSelectedInstOperands,
     /* 757462 */     // GIR_Coverage, 6677,
     /* 757462 */     GIR_EraseRootFromParent_Done,
     /* 757463 */   // Label 9985: @757463
     /* 757463 */   GIM_Try, /*On fail goto*//*Label 9986*/ GIMT_Encode4(757531), // Rule ID 6681 //
     /* 757468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 757472 */     // MIs[0] offset
     /* 757472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757475 */     // MIs[0] format
     /* 757475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757478 */     // MIs[0] auxiliary
     /* 757478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757481 */     // MIs[0] Operand 8
     /* 757481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 757484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757491 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
     /* 757494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757496 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 757498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757505 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757513 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757519 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757529 */     GIR_RootConstrainSelectedInstOperands,
     /* 757530 */     // GIR_Coverage, 6681,
     /* 757530 */     GIR_EraseRootFromParent_Done,
     /* 757531 */   // Label 9986: @757531
     /* 757531 */   GIM_Try, /*On fail goto*//*Label 9987*/ GIMT_Encode4(757602), // Rule ID 6709 //
     /* 757536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 757539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 757543 */     // MIs[0] offset
     /* 757543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757546 */     // MIs[0] format
     /* 757546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757549 */     // MIs[0] auxiliary
     /* 757549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757552 */     // MIs[0] Operand 8
     /* 757552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 757555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757562 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_IDXEN),
     /* 757565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757567 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 757569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757576 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757578 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757590 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757600 */     GIR_RootConstrainSelectedInstOperands,
     /* 757601 */     // GIR_Coverage, 6709,
     /* 757601 */     GIR_EraseRootFromParent_Done,
     /* 757602 */   // Label 9987: @757602
     /* 757602 */   GIM_Try, /*On fail goto*//*Label 9988*/ GIMT_Encode4(757670), // Rule ID 6713 //
     /* 757607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 757611 */     // MIs[0] offset
     /* 757611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757614 */     // MIs[0] format
     /* 757614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757617 */     // MIs[0] auxiliary
     /* 757617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757620 */     // MIs[0] Operand 8
     /* 757620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 757623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757630 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
     /* 757633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757635 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 757637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757644 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757652 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757658 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757668 */     GIR_RootConstrainSelectedInstOperands,
     /* 757669 */     // GIR_Coverage, 6713,
     /* 757669 */     GIR_EraseRootFromParent_Done,
     /* 757670 */   // Label 9988: @757670
     /* 757670 */   GIM_Try, /*On fail goto*//*Label 9989*/ GIMT_Encode4(757779), // Rule ID 6679 //
     /* 757675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 757678 */     // MIs[0] offset
     /* 757678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757681 */     // MIs[0] format
     /* 757681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757684 */     // MIs[0] auxiliary
     /* 757684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757687 */     // MIs[0] Operand 8
     /* 757687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 757690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757697 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 757700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 757704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 757709 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 757713 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 757716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 757720 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 757723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 757728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 757733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 757738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_BOTHEN),
     /* 757741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 757746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757753 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757755 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757761 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757767 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757777 */     GIR_RootConstrainSelectedInstOperands,
     /* 757778 */     // GIR_Coverage, 6679,
     /* 757778 */     GIR_EraseRootFromParent_Done,
     /* 757779 */   // Label 9989: @757779
     /* 757779 */   GIM_Try, /*On fail goto*//*Label 9990*/ GIMT_Encode4(757885), // Rule ID 6683 //
     /* 757784 */     // MIs[0] offset
     /* 757784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757787 */     // MIs[0] format
     /* 757787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757790 */     // MIs[0] auxiliary
     /* 757790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757793 */     // MIs[0] Operand 8
     /* 757793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 757796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757803 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 757806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 757810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 757815 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 757819 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 757822 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 757826 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 757829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 757834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 757839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 757844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
     /* 757847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 757852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757859 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757861 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757867 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757883 */     GIR_RootConstrainSelectedInstOperands,
     /* 757884 */     // GIR_Coverage, 6683,
     /* 757884 */     GIR_EraseRootFromParent_Done,
     /* 757885 */   // Label 9990: @757885
     /* 757885 */   GIM_Try, /*On fail goto*//*Label 9991*/ GIMT_Encode4(757994), // Rule ID 6711 //
     /* 757890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 757893 */     // MIs[0] offset
     /* 757893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 757896 */     // MIs[0] format
     /* 757896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 757899 */     // MIs[0] auxiliary
     /* 757899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 757902 */     // MIs[0] Operand 8
     /* 757902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 757905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 757912 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 757912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 757915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 757919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 757924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 757928 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 757931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 757935 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 757938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 757943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 757948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 757953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_BOTHEN),
     /* 757956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 757958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 757961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 757963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757968 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 757970 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 757976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 757982 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 757988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757992 */     GIR_RootConstrainSelectedInstOperands,
     /* 757993 */     // GIR_Coverage, 6711,
     /* 757993 */     GIR_EraseRootFromParent_Done,
     /* 757994 */   // Label 9991: @757994
     /* 757994 */   GIM_Try, /*On fail goto*//*Label 9992*/ GIMT_Encode4(758100), // Rule ID 6715 //
     /* 757999 */     // MIs[0] offset
     /* 757999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758002 */     // MIs[0] format
     /* 758002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758005 */     // MIs[0] auxiliary
     /* 758005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758008 */     // MIs[0] Operand 8
     /* 758008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 758011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758018 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 758021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 758025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 758030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 758034 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 758037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 758041 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 758044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 758049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 758054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 758059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
     /* 758062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 758067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758074 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758076 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758088 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758098 */     GIR_RootConstrainSelectedInstOperands,
     /* 758099 */     // GIR_Coverage, 6715,
     /* 758099 */     GIR_EraseRootFromParent_Done,
     /* 758100 */   // Label 9992: @758100
     /* 758100 */   GIM_Reject,
     /* 758101 */ // Label 9976: @758101
     /* 758101 */ GIM_Reject,
     /* 758102 */ // Label 9924: @758102
     /* 758102 */ GIM_Reject,
     /* 758103 */ // Label 163: @758103
     /* 758103 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 10000*/ GIMT_Encode4(763531),
     /* 758114 */ /*GILLT_s16*//*Label 9993*/ GIMT_Encode4(758154),
     /* 758118 */ /*GILLT_s32*//*Label 9994*/ GIMT_Encode4(759197), GIMT_Encode4(0),
     /* 758126 */ /*GILLT_v2s16*//*Label 9995*/ GIMT_Encode4(760240),
     /* 758130 */ /*GILLT_v2s32*//*Label 9996*/ GIMT_Encode4(760943), GIMT_Encode4(0),
     /* 758138 */ /*GILLT_v3s32*//*Label 9997*/ GIMT_Encode4(761306), GIMT_Encode4(0),
     /* 758146 */ /*GILLT_v4s16*//*Label 9998*/ GIMT_Encode4(761669),
     /* 758150 */ /*GILLT_v4s32*//*Label 9999*/ GIMT_Encode4(763168),
     /* 758154 */ // Label 9993: @758154
     /* 758154 */ GIM_Try, /*On fail goto*//*Label 10001*/ GIMT_Encode4(759196),
     /* 758159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 758162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 758165 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 758168 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 758171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 758175 */   GIM_Try, /*On fail goto*//*Label 10002*/ GIMT_Encode4(758256), // Rule ID 6716 //
     /* 758180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 758183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758191 */     // MIs[0] offset
     /* 758191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758194 */     // MIs[0] format
     /* 758194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758197 */     // MIs[0] auxiliary
     /* 758197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758200 */     // MIs[0] Operand 8
     /* 758200 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758218 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 758221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758230 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758232 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758254 */     GIR_RootConstrainSelectedInstOperands,
     /* 758255 */     // GIR_Coverage, 6716,
     /* 758255 */     GIR_EraseRootFromParent_Done,
     /* 758256 */   // Label 10002: @758256
     /* 758256 */   GIM_Try, /*On fail goto*//*Label 10003*/ GIMT_Encode4(758337), // Rule ID 6736 //
     /* 758261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 758264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758272 */     // MIs[0] offset
     /* 758272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758275 */     // MIs[0] format
     /* 758275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758278 */     // MIs[0] auxiliary
     /* 758278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758281 */     // MIs[0] Operand 8
     /* 758281 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758299 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 758302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758311 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758313 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758319 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758325 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758335 */     GIR_RootConstrainSelectedInstOperands,
     /* 758336 */     // GIR_Coverage, 6736,
     /* 758336 */     GIR_EraseRootFromParent_Done,
     /* 758337 */   // Label 10003: @758337
     /* 758337 */   GIM_Try, /*On fail goto*//*Label 10004*/ GIMT_Encode4(758418), // Rule ID 6740 //
     /* 758342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 758345 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758353 */     // MIs[0] offset
     /* 758353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758356 */     // MIs[0] format
     /* 758356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758359 */     // MIs[0] auxiliary
     /* 758359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758362 */     // MIs[0] Operand 8
     /* 758362 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758380 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 758383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758392 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758394 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758400 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758406 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758416 */     GIR_RootConstrainSelectedInstOperands,
     /* 758417 */     // GIR_Coverage, 6740,
     /* 758417 */     GIR_EraseRootFromParent_Done,
     /* 758418 */   // Label 10004: @758418
     /* 758418 */   GIM_Try, /*On fail goto*//*Label 10005*/ GIMT_Encode4(758497), // Rule ID 6718 //
     /* 758423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 758426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758430 */     // MIs[0] offset
     /* 758430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758433 */     // MIs[0] format
     /* 758433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758436 */     // MIs[0] auxiliary
     /* 758436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758439 */     // MIs[0] Operand 8
     /* 758439 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758457 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 758460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758462 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 758464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758471 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758473 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758479 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758485 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758495 */     GIR_RootConstrainSelectedInstOperands,
     /* 758496 */     // GIR_Coverage, 6718,
     /* 758496 */     GIR_EraseRootFromParent_Done,
     /* 758497 */   // Label 10005: @758497
     /* 758497 */   GIM_Try, /*On fail goto*//*Label 10006*/ GIMT_Encode4(758576), // Rule ID 6738 //
     /* 758502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 758505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758509 */     // MIs[0] offset
     /* 758509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758512 */     // MIs[0] format
     /* 758512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758515 */     // MIs[0] auxiliary
     /* 758515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758518 */     // MIs[0] Operand 8
     /* 758518 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758536 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 758539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758541 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 758543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758550 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758552 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758558 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758574 */     GIR_RootConstrainSelectedInstOperands,
     /* 758575 */     // GIR_Coverage, 6738,
     /* 758575 */     GIR_EraseRootFromParent_Done,
     /* 758576 */   // Label 10006: @758576
     /* 758576 */   GIM_Try, /*On fail goto*//*Label 10007*/ GIMT_Encode4(758655), // Rule ID 6742 //
     /* 758581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 758584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758588 */     // MIs[0] offset
     /* 758588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758591 */     // MIs[0] format
     /* 758591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758594 */     // MIs[0] auxiliary
     /* 758594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758597 */     // MIs[0] Operand 8
     /* 758597 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758615 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 758618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758620 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 758622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758629 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758631 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758637 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758643 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758653 */     GIR_RootConstrainSelectedInstOperands,
     /* 758654 */     // GIR_Coverage, 6742,
     /* 758654 */     GIR_EraseRootFromParent_Done,
     /* 758655 */   // Label 10007: @758655
     /* 758655 */   GIM_Try, /*On fail goto*//*Label 10008*/ GIMT_Encode4(758726), // Rule ID 6717 //
     /* 758660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 758663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758667 */     // MIs[0] offset
     /* 758667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758670 */     // MIs[0] format
     /* 758670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758673 */     // MIs[0] auxiliary
     /* 758673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758676 */     // MIs[0] Operand 8
     /* 758676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 758679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758686 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 758689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758691 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 758693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758700 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758702 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758708 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758714 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758724 */     GIR_RootConstrainSelectedInstOperands,
     /* 758725 */     // GIR_Coverage, 6717,
     /* 758725 */     GIR_EraseRootFromParent_Done,
     /* 758726 */   // Label 10008: @758726
     /* 758726 */   GIM_Try, /*On fail goto*//*Label 10009*/ GIMT_Encode4(758797), // Rule ID 6737 //
     /* 758731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 758734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758738 */     // MIs[0] offset
     /* 758738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758741 */     // MIs[0] format
     /* 758741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758744 */     // MIs[0] auxiliary
     /* 758744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758747 */     // MIs[0] Operand 8
     /* 758747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 758750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758757 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 758760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758762 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 758764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758771 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758773 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758795 */     GIR_RootConstrainSelectedInstOperands,
     /* 758796 */     // GIR_Coverage, 6737,
     /* 758796 */     GIR_EraseRootFromParent_Done,
     /* 758797 */   // Label 10009: @758797
     /* 758797 */   GIM_Try, /*On fail goto*//*Label 10010*/ GIMT_Encode4(758868), // Rule ID 6741 //
     /* 758802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 758805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758809 */     // MIs[0] offset
     /* 758809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758812 */     // MIs[0] format
     /* 758812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758815 */     // MIs[0] auxiliary
     /* 758815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758818 */     // MIs[0] Operand 8
     /* 758818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 758821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758828 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 758831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758833 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 758835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758842 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758844 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758850 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758856 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758866 */     GIR_RootConstrainSelectedInstOperands,
     /* 758867 */     // GIR_Coverage, 6741,
     /* 758867 */     GIR_EraseRootFromParent_Done,
     /* 758868 */   // Label 10010: @758868
     /* 758868 */   GIM_Try, /*On fail goto*//*Label 10011*/ GIMT_Encode4(758977), // Rule ID 6719 //
     /* 758873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 758876 */     // MIs[0] offset
     /* 758876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758879 */     // MIs[0] format
     /* 758879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758882 */     // MIs[0] auxiliary
     /* 758882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758885 */     // MIs[0] Operand 8
     /* 758885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 758888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758895 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 758898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 758902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 758907 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 758911 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 758914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 758918 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 758921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 758926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 758931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 758936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 758939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 758944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758951 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758965 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758975 */     GIR_RootConstrainSelectedInstOperands,
     /* 758976 */     // GIR_Coverage, 6719,
     /* 758976 */     GIR_EraseRootFromParent_Done,
     /* 758977 */   // Label 10011: @758977
     /* 758977 */   GIM_Try, /*On fail goto*//*Label 10012*/ GIMT_Encode4(759086), // Rule ID 6739 //
     /* 758982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 758985 */     // MIs[0] offset
     /* 758985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758988 */     // MIs[0] format
     /* 758988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758991 */     // MIs[0] auxiliary
     /* 758991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758994 */     // MIs[0] Operand 8
     /* 758994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 758997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759004 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 759007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 759011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 759016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 759020 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 759023 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 759027 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 759030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 759035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 759048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 759053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759060 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759062 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759068 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759074 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759084 */     GIR_RootConstrainSelectedInstOperands,
     /* 759085 */     // GIR_Coverage, 6739,
     /* 759085 */     GIR_EraseRootFromParent_Done,
     /* 759086 */   // Label 10012: @759086
     /* 759086 */   GIM_Try, /*On fail goto*//*Label 10013*/ GIMT_Encode4(759195), // Rule ID 6743 //
     /* 759091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 759094 */     // MIs[0] offset
     /* 759094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759097 */     // MIs[0] format
     /* 759097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759100 */     // MIs[0] auxiliary
     /* 759100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759103 */     // MIs[0] Operand 8
     /* 759103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759113 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 759116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 759120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 759125 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 759129 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 759132 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 759136 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 759139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 759144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 759157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 759162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759169 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759171 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759177 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759183 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759193 */     GIR_RootConstrainSelectedInstOperands,
     /* 759194 */     // GIR_Coverage, 6743,
     /* 759194 */     GIR_EraseRootFromParent_Done,
     /* 759195 */   // Label 10013: @759195
     /* 759195 */   GIM_Reject,
     /* 759196 */ // Label 10001: @759196
     /* 759196 */ GIM_Reject,
     /* 759197 */ // Label 9994: @759197
     /* 759197 */ GIM_Try, /*On fail goto*//*Label 10014*/ GIMT_Encode4(760239),
     /* 759202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 759205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 759208 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 759211 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 759214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 759218 */   GIM_Try, /*On fail goto*//*Label 10015*/ GIMT_Encode4(759299), // Rule ID 6720 //
     /* 759223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 759226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759234 */     // MIs[0] offset
     /* 759234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759237 */     // MIs[0] format
     /* 759237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759240 */     // MIs[0] auxiliary
     /* 759240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759243 */     // MIs[0] Operand 8
     /* 759243 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759261 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 759264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759273 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759275 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759281 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759297 */     GIR_RootConstrainSelectedInstOperands,
     /* 759298 */     // GIR_Coverage, 6720,
     /* 759298 */     GIR_EraseRootFromParent_Done,
     /* 759299 */   // Label 10015: @759299
     /* 759299 */   GIM_Try, /*On fail goto*//*Label 10016*/ GIMT_Encode4(759380), // Rule ID 6744 //
     /* 759304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 759307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759315 */     // MIs[0] offset
     /* 759315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759318 */     // MIs[0] format
     /* 759318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759321 */     // MIs[0] auxiliary
     /* 759321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759324 */     // MIs[0] Operand 8
     /* 759324 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759342 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 759345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759354 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759368 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759378 */     GIR_RootConstrainSelectedInstOperands,
     /* 759379 */     // GIR_Coverage, 6744,
     /* 759379 */     GIR_EraseRootFromParent_Done,
     /* 759380 */   // Label 10016: @759380
     /* 759380 */   GIM_Try, /*On fail goto*//*Label 10017*/ GIMT_Encode4(759461), // Rule ID 6748 //
     /* 759385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 759388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759396 */     // MIs[0] offset
     /* 759396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759399 */     // MIs[0] format
     /* 759399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759402 */     // MIs[0] auxiliary
     /* 759402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759405 */     // MIs[0] Operand 8
     /* 759405 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759423 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 759426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759435 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759437 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759443 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759449 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759459 */     GIR_RootConstrainSelectedInstOperands,
     /* 759460 */     // GIR_Coverage, 6748,
     /* 759460 */     GIR_EraseRootFromParent_Done,
     /* 759461 */   // Label 10017: @759461
     /* 759461 */   GIM_Try, /*On fail goto*//*Label 10018*/ GIMT_Encode4(759540), // Rule ID 6722 //
     /* 759466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 759469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759473 */     // MIs[0] offset
     /* 759473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759476 */     // MIs[0] format
     /* 759476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759479 */     // MIs[0] auxiliary
     /* 759479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759482 */     // MIs[0] Operand 8
     /* 759482 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759500 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 759503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759505 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 759507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759514 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759516 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759522 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759528 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759538 */     GIR_RootConstrainSelectedInstOperands,
     /* 759539 */     // GIR_Coverage, 6722,
     /* 759539 */     GIR_EraseRootFromParent_Done,
     /* 759540 */   // Label 10018: @759540
     /* 759540 */   GIM_Try, /*On fail goto*//*Label 10019*/ GIMT_Encode4(759619), // Rule ID 6746 //
     /* 759545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 759548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759552 */     // MIs[0] offset
     /* 759552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759555 */     // MIs[0] format
     /* 759555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759558 */     // MIs[0] auxiliary
     /* 759558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759561 */     // MIs[0] Operand 8
     /* 759561 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759579 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 759582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759584 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 759586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759593 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759595 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759601 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759607 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759617 */     GIR_RootConstrainSelectedInstOperands,
     /* 759618 */     // GIR_Coverage, 6746,
     /* 759618 */     GIR_EraseRootFromParent_Done,
     /* 759619 */   // Label 10019: @759619
     /* 759619 */   GIM_Try, /*On fail goto*//*Label 10020*/ GIMT_Encode4(759698), // Rule ID 6750 //
     /* 759624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 759627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759631 */     // MIs[0] offset
     /* 759631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759634 */     // MIs[0] format
     /* 759634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759637 */     // MIs[0] auxiliary
     /* 759637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759640 */     // MIs[0] Operand 8
     /* 759640 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759658 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 759661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759663 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 759665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759672 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759674 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759680 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759686 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759696 */     GIR_RootConstrainSelectedInstOperands,
     /* 759697 */     // GIR_Coverage, 6750,
     /* 759697 */     GIR_EraseRootFromParent_Done,
     /* 759698 */   // Label 10020: @759698
     /* 759698 */   GIM_Try, /*On fail goto*//*Label 10021*/ GIMT_Encode4(759769), // Rule ID 6721 //
     /* 759703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 759706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759710 */     // MIs[0] offset
     /* 759710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759713 */     // MIs[0] format
     /* 759713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759716 */     // MIs[0] auxiliary
     /* 759716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759719 */     // MIs[0] Operand 8
     /* 759719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759729 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 759732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759734 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 759736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759743 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759745 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759751 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759757 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759767 */     GIR_RootConstrainSelectedInstOperands,
     /* 759768 */     // GIR_Coverage, 6721,
     /* 759768 */     GIR_EraseRootFromParent_Done,
     /* 759769 */   // Label 10021: @759769
     /* 759769 */   GIM_Try, /*On fail goto*//*Label 10022*/ GIMT_Encode4(759840), // Rule ID 6745 //
     /* 759774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 759777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759781 */     // MIs[0] offset
     /* 759781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759784 */     // MIs[0] format
     /* 759784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759787 */     // MIs[0] auxiliary
     /* 759787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759790 */     // MIs[0] Operand 8
     /* 759790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759800 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 759803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759805 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 759807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759814 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759816 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759822 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759828 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759838 */     GIR_RootConstrainSelectedInstOperands,
     /* 759839 */     // GIR_Coverage, 6745,
     /* 759839 */     GIR_EraseRootFromParent_Done,
     /* 759840 */   // Label 10022: @759840
     /* 759840 */   GIM_Try, /*On fail goto*//*Label 10023*/ GIMT_Encode4(759911), // Rule ID 6749 //
     /* 759845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 759848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759852 */     // MIs[0] offset
     /* 759852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759855 */     // MIs[0] format
     /* 759855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759858 */     // MIs[0] auxiliary
     /* 759858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759861 */     // MIs[0] Operand 8
     /* 759861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759871 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 759874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759876 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 759878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759885 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759887 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759893 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759899 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759909 */     GIR_RootConstrainSelectedInstOperands,
     /* 759910 */     // GIR_Coverage, 6749,
     /* 759910 */     GIR_EraseRootFromParent_Done,
     /* 759911 */   // Label 10023: @759911
     /* 759911 */   GIM_Try, /*On fail goto*//*Label 10024*/ GIMT_Encode4(760020), // Rule ID 6723 //
     /* 759916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 759919 */     // MIs[0] offset
     /* 759919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759922 */     // MIs[0] format
     /* 759922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759925 */     // MIs[0] auxiliary
     /* 759925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759928 */     // MIs[0] Operand 8
     /* 759928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759938 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 759941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 759945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 759950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 759954 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 759957 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 759961 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 759964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 759969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 759982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 759987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759994 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760008 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760018 */     GIR_RootConstrainSelectedInstOperands,
     /* 760019 */     // GIR_Coverage, 6723,
     /* 760019 */     GIR_EraseRootFromParent_Done,
     /* 760020 */   // Label 10024: @760020
     /* 760020 */   GIM_Try, /*On fail goto*//*Label 10025*/ GIMT_Encode4(760129), // Rule ID 6747 //
     /* 760025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 760028 */     // MIs[0] offset
     /* 760028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760031 */     // MIs[0] format
     /* 760031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760034 */     // MIs[0] auxiliary
     /* 760034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760037 */     // MIs[0] Operand 8
     /* 760037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760047 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 760050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 760054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 760059 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 760063 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 760066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 760070 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 760073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 760078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 760091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 760096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760103 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760111 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760117 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760127 */     GIR_RootConstrainSelectedInstOperands,
     /* 760128 */     // GIR_Coverage, 6747,
     /* 760128 */     GIR_EraseRootFromParent_Done,
     /* 760129 */   // Label 10025: @760129
     /* 760129 */   GIM_Try, /*On fail goto*//*Label 10026*/ GIMT_Encode4(760238), // Rule ID 6751 //
     /* 760134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 760137 */     // MIs[0] offset
     /* 760137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760140 */     // MIs[0] format
     /* 760140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760143 */     // MIs[0] auxiliary
     /* 760143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760146 */     // MIs[0] Operand 8
     /* 760146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760156 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 760159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 760163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 760168 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 760172 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 760175 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 760179 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 760182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 760187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 760200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 760205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760212 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760214 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760220 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760226 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760236 */     GIR_RootConstrainSelectedInstOperands,
     /* 760237 */     // GIR_Coverage, 6751,
     /* 760237 */     GIR_EraseRootFromParent_Done,
     /* 760238 */   // Label 10026: @760238
     /* 760238 */   GIM_Reject,
     /* 760239 */ // Label 10014: @760239
     /* 760239 */ GIM_Reject,
     /* 760240 */ // Label 9995: @760240
     /* 760240 */ GIM_Try, /*On fail goto*//*Label 10027*/ GIMT_Encode4(760942),
     /* 760245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 760248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 760251 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 760254 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 760257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 760261 */   GIM_Try, /*On fail goto*//*Label 10028*/ GIMT_Encode4(760342), // Rule ID 6752 //
     /* 760266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 760269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760277 */     // MIs[0] offset
     /* 760277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760280 */     // MIs[0] format
     /* 760280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760283 */     // MIs[0] auxiliary
     /* 760283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760286 */     // MIs[0] Operand 8
     /* 760286 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 760297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760304 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_OFFSET),
     /* 760307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760316 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760318 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760324 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760330 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760340 */     GIR_RootConstrainSelectedInstOperands,
     /* 760341 */     // GIR_Coverage, 6752,
     /* 760341 */     GIR_EraseRootFromParent_Done,
     /* 760342 */   // Label 10028: @760342
     /* 760342 */   GIM_Try, /*On fail goto*//*Label 10029*/ GIMT_Encode4(760423), // Rule ID 6756 //
     /* 760347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 760350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760358 */     // MIs[0] offset
     /* 760358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760361 */     // MIs[0] format
     /* 760361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760364 */     // MIs[0] auxiliary
     /* 760364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760367 */     // MIs[0] Operand 8
     /* 760367 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 760378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760385 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET),
     /* 760388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760397 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760399 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760405 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760411 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760421 */     GIR_RootConstrainSelectedInstOperands,
     /* 760422 */     // GIR_Coverage, 6756,
     /* 760422 */     GIR_EraseRootFromParent_Done,
     /* 760423 */   // Label 10029: @760423
     /* 760423 */   GIM_Try, /*On fail goto*//*Label 10030*/ GIMT_Encode4(760502), // Rule ID 6754 //
     /* 760428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 760431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760435 */     // MIs[0] offset
     /* 760435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760438 */     // MIs[0] format
     /* 760438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760441 */     // MIs[0] auxiliary
     /* 760441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760444 */     // MIs[0] Operand 8
     /* 760444 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 760455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760462 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_OFFEN),
     /* 760465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760467 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 760469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760476 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760478 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760484 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760490 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760500 */     GIR_RootConstrainSelectedInstOperands,
     /* 760501 */     // GIR_Coverage, 6754,
     /* 760501 */     GIR_EraseRootFromParent_Done,
     /* 760502 */   // Label 10030: @760502
     /* 760502 */   GIM_Try, /*On fail goto*//*Label 10031*/ GIMT_Encode4(760581), // Rule ID 6758 //
     /* 760507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 760510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760514 */     // MIs[0] offset
     /* 760514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760517 */     // MIs[0] format
     /* 760517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760520 */     // MIs[0] auxiliary
     /* 760520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760523 */     // MIs[0] Operand 8
     /* 760523 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 760534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760541 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN),
     /* 760544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760546 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 760548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760555 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760557 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760563 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760569 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760579 */     GIR_RootConstrainSelectedInstOperands,
     /* 760580 */     // GIR_Coverage, 6758,
     /* 760580 */     GIR_EraseRootFromParent_Done,
     /* 760581 */   // Label 10031: @760581
     /* 760581 */   GIM_Try, /*On fail goto*//*Label 10032*/ GIMT_Encode4(760652), // Rule ID 6753 //
     /* 760586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 760589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760593 */     // MIs[0] offset
     /* 760593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760596 */     // MIs[0] format
     /* 760596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760599 */     // MIs[0] auxiliary
     /* 760599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760602 */     // MIs[0] Operand 8
     /* 760602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760612 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_IDXEN),
     /* 760615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760617 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 760619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760626 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760628 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760634 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760650 */     GIR_RootConstrainSelectedInstOperands,
     /* 760651 */     // GIR_Coverage, 6753,
     /* 760651 */     GIR_EraseRootFromParent_Done,
     /* 760652 */   // Label 10032: @760652
     /* 760652 */   GIM_Try, /*On fail goto*//*Label 10033*/ GIMT_Encode4(760723), // Rule ID 6757 //
     /* 760657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 760660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760664 */     // MIs[0] offset
     /* 760664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760667 */     // MIs[0] format
     /* 760667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760670 */     // MIs[0] auxiliary
     /* 760670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760673 */     // MIs[0] Operand 8
     /* 760673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760683 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN),
     /* 760686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760688 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 760690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760697 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760705 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760711 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760721 */     GIR_RootConstrainSelectedInstOperands,
     /* 760722 */     // GIR_Coverage, 6757,
     /* 760722 */     GIR_EraseRootFromParent_Done,
     /* 760723 */   // Label 10033: @760723
     /* 760723 */   GIM_Try, /*On fail goto*//*Label 10034*/ GIMT_Encode4(760832), // Rule ID 6755 //
     /* 760728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 760731 */     // MIs[0] offset
     /* 760731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760734 */     // MIs[0] format
     /* 760734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760737 */     // MIs[0] auxiliary
     /* 760737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760740 */     // MIs[0] Operand 8
     /* 760740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760750 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 760753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 760757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 760762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 760766 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 760769 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 760773 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 760776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 760781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_BOTHEN),
     /* 760794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 760799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760806 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760820 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760830 */     GIR_RootConstrainSelectedInstOperands,
     /* 760831 */     // GIR_Coverage, 6755,
     /* 760831 */     GIR_EraseRootFromParent_Done,
     /* 760832 */   // Label 10034: @760832
     /* 760832 */   GIM_Try, /*On fail goto*//*Label 10035*/ GIMT_Encode4(760941), // Rule ID 6759 //
     /* 760837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 760840 */     // MIs[0] offset
     /* 760840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760843 */     // MIs[0] format
     /* 760843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760846 */     // MIs[0] auxiliary
     /* 760846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760849 */     // MIs[0] Operand 8
     /* 760849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760859 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 760862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 760866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 760871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 760875 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 760878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 760882 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 760885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 760890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN),
     /* 760903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 760908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760915 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760917 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760923 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760929 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760939 */     GIR_RootConstrainSelectedInstOperands,
     /* 760940 */     // GIR_Coverage, 6759,
     /* 760940 */     GIR_EraseRootFromParent_Done,
     /* 760941 */   // Label 10035: @760941
     /* 760941 */   GIM_Reject,
     /* 760942 */ // Label 10027: @760942
     /* 760942 */ GIM_Reject,
     /* 760943 */ // Label 9996: @760943
     /* 760943 */ GIM_Try, /*On fail goto*//*Label 10036*/ GIMT_Encode4(761305),
     /* 760948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 760951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 760954 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 760957 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 760960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 760964 */   GIM_Try, /*On fail goto*//*Label 10037*/ GIMT_Encode4(761045), // Rule ID 6724 //
     /* 760969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 760972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760980 */     // MIs[0] offset
     /* 760980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760983 */     // MIs[0] format
     /* 760983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760986 */     // MIs[0] auxiliary
     /* 760986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760989 */     // MIs[0] Operand 8
     /* 760989 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761007 */     // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET),
     /* 761010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761019 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761021 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761027 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761033 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761043 */     GIR_RootConstrainSelectedInstOperands,
     /* 761044 */     // GIR_Coverage, 6724,
     /* 761044 */     GIR_EraseRootFromParent_Done,
     /* 761045 */   // Label 10037: @761045
     /* 761045 */   GIM_Try, /*On fail goto*//*Label 10038*/ GIMT_Encode4(761124), // Rule ID 6726 //
     /* 761050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761057 */     // MIs[0] offset
     /* 761057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761060 */     // MIs[0] format
     /* 761060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761063 */     // MIs[0] auxiliary
     /* 761063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761066 */     // MIs[0] Operand 8
     /* 761066 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761084 */     // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN),
     /* 761087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761089 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 761091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761098 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761100 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761106 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761112 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761122 */     GIR_RootConstrainSelectedInstOperands,
     /* 761123 */     // GIR_Coverage, 6726,
     /* 761123 */     GIR_EraseRootFromParent_Done,
     /* 761124 */   // Label 10038: @761124
     /* 761124 */   GIM_Try, /*On fail goto*//*Label 10039*/ GIMT_Encode4(761195), // Rule ID 6725 //
     /* 761129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761136 */     // MIs[0] offset
     /* 761136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761139 */     // MIs[0] format
     /* 761139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761142 */     // MIs[0] auxiliary
     /* 761142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761145 */     // MIs[0] Operand 8
     /* 761145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761155 */     // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN),
     /* 761158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761160 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 761162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761169 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761171 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761177 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761183 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761193 */     GIR_RootConstrainSelectedInstOperands,
     /* 761194 */     // GIR_Coverage, 6725,
     /* 761194 */     GIR_EraseRootFromParent_Done,
     /* 761195 */   // Label 10039: @761195
     /* 761195 */   GIM_Try, /*On fail goto*//*Label 10040*/ GIMT_Encode4(761304), // Rule ID 6727 //
     /* 761200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761203 */     // MIs[0] offset
     /* 761203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761206 */     // MIs[0] format
     /* 761206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761209 */     // MIs[0] auxiliary
     /* 761209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761212 */     // MIs[0] Operand 8
     /* 761212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761222 */     // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 761225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 761229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 761234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 761238 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 761241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 761245 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 761248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 761253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN),
     /* 761266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 761271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761278 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761280 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761286 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761292 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761302 */     GIR_RootConstrainSelectedInstOperands,
     /* 761303 */     // GIR_Coverage, 6727,
     /* 761303 */     GIR_EraseRootFromParent_Done,
     /* 761304 */   // Label 10040: @761304
     /* 761304 */   GIM_Reject,
     /* 761305 */ // Label 10036: @761305
     /* 761305 */ GIM_Reject,
     /* 761306 */ // Label 9997: @761306
     /* 761306 */ GIM_Try, /*On fail goto*//*Label 10041*/ GIMT_Encode4(761668),
     /* 761311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 761314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 761317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 761320 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 761323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 761327 */   GIM_Try, /*On fail goto*//*Label 10042*/ GIMT_Encode4(761408), // Rule ID 6728 //
     /* 761332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761343 */     // MIs[0] offset
     /* 761343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761346 */     // MIs[0] format
     /* 761346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761349 */     // MIs[0] auxiliary
     /* 761349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761352 */     // MIs[0] Operand 8
     /* 761352 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761370 */     // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET),
     /* 761373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761382 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761384 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761390 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761396 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761406 */     GIR_RootConstrainSelectedInstOperands,
     /* 761407 */     // GIR_Coverage, 6728,
     /* 761407 */     GIR_EraseRootFromParent_Done,
     /* 761408 */   // Label 10042: @761408
     /* 761408 */   GIM_Try, /*On fail goto*//*Label 10043*/ GIMT_Encode4(761487), // Rule ID 6730 //
     /* 761413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761420 */     // MIs[0] offset
     /* 761420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761423 */     // MIs[0] format
     /* 761423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761426 */     // MIs[0] auxiliary
     /* 761426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761429 */     // MIs[0] Operand 8
     /* 761429 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761447 */     // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN),
     /* 761450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761452 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 761454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761461 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761463 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761469 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761475 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761485 */     GIR_RootConstrainSelectedInstOperands,
     /* 761486 */     // GIR_Coverage, 6730,
     /* 761486 */     GIR_EraseRootFromParent_Done,
     /* 761487 */   // Label 10043: @761487
     /* 761487 */   GIM_Try, /*On fail goto*//*Label 10044*/ GIMT_Encode4(761558), // Rule ID 6729 //
     /* 761492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761499 */     // MIs[0] offset
     /* 761499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761502 */     // MIs[0] format
     /* 761502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761505 */     // MIs[0] auxiliary
     /* 761505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761508 */     // MIs[0] Operand 8
     /* 761508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761518 */     // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN),
     /* 761521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761523 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 761525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761532 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761534 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761540 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761546 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761556 */     GIR_RootConstrainSelectedInstOperands,
     /* 761557 */     // GIR_Coverage, 6729,
     /* 761557 */     GIR_EraseRootFromParent_Done,
     /* 761558 */   // Label 10044: @761558
     /* 761558 */   GIM_Try, /*On fail goto*//*Label 10045*/ GIMT_Encode4(761667), // Rule ID 6731 //
     /* 761563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 761566 */     // MIs[0] offset
     /* 761566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761569 */     // MIs[0] format
     /* 761569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761572 */     // MIs[0] auxiliary
     /* 761572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761575 */     // MIs[0] Operand 8
     /* 761575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761585 */     // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 761588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 761592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 761597 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 761601 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 761604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 761608 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 761611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 761616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN),
     /* 761629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 761634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761641 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761643 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761649 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761655 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761665 */     GIR_RootConstrainSelectedInstOperands,
     /* 761666 */     // GIR_Coverage, 6731,
     /* 761666 */     GIR_EraseRootFromParent_Done,
     /* 761667 */   // Label 10045: @761667
     /* 761667 */   GIM_Reject,
     /* 761668 */ // Label 10041: @761668
     /* 761668 */ GIM_Reject,
     /* 761669 */ // Label 9998: @761669
     /* 761669 */ GIM_Try, /*On fail goto*//*Label 10046*/ GIMT_Encode4(763167),
     /* 761674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 761677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 761680 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 761683 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 761686 */   GIM_Try, /*On fail goto*//*Label 10047*/ GIMT_Encode4(761778), // Rule ID 6760 //
     /* 761691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 761694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 761701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 761705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761713 */     // MIs[0] offset
     /* 761713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761716 */     // MIs[0] format
     /* 761716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761719 */     // MIs[0] auxiliary
     /* 761719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761722 */     // MIs[0] Operand 8
     /* 761722 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761740 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33611>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_OFFSET),
     /* 761743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761752 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761754 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761760 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761766 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761776 */     GIR_RootConstrainSelectedInstOperands,
     /* 761777 */     // GIR_Coverage, 6760,
     /* 761777 */     GIR_EraseRootFromParent_Done,
     /* 761778 */   // Label 10047: @761778
     /* 761778 */   GIM_Try, /*On fail goto*//*Label 10048*/ GIMT_Encode4(761870), // Rule ID 6764 //
     /* 761783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 761786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 761793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 761797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761805 */     // MIs[0] offset
     /* 761805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761808 */     // MIs[0] format
     /* 761808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761811 */     // MIs[0] auxiliary
     /* 761811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761814 */     // MIs[0] Operand 8
     /* 761814 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761832 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33611>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET),
     /* 761835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761844 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761846 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761852 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761858 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761868 */     GIR_RootConstrainSelectedInstOperands,
     /* 761869 */     // GIR_Coverage, 6764,
     /* 761869 */     GIR_EraseRootFromParent_Done,
     /* 761870 */   // Label 10048: @761870
     /* 761870 */   GIM_Try, /*On fail goto*//*Label 10049*/ GIMT_Encode4(761955), // Rule ID 6768 //
     /* 761875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 761878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 761882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761890 */     // MIs[0] offset
     /* 761890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761893 */     // MIs[0] format
     /* 761893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761896 */     // MIs[0] auxiliary
     /* 761896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761899 */     // MIs[0] Operand 8
     /* 761899 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761917 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_OFFSET),
     /* 761920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761929 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761931 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761937 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761943 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761953 */     GIR_RootConstrainSelectedInstOperands,
     /* 761954 */     // GIR_Coverage, 6768,
     /* 761954 */     GIR_EraseRootFromParent_Done,
     /* 761955 */   // Label 10049: @761955
     /* 761955 */   GIM_Try, /*On fail goto*//*Label 10050*/ GIMT_Encode4(762040), // Rule ID 6772 //
     /* 761960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 761963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 761967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761975 */     // MIs[0] offset
     /* 761975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761978 */     // MIs[0] format
     /* 761978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761981 */     // MIs[0] auxiliary
     /* 761981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761984 */     // MIs[0] Operand 8
     /* 761984 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762002 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET),
     /* 762005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762014 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762016 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762028 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762038 */     GIR_RootConstrainSelectedInstOperands,
     /* 762039 */     // GIR_Coverage, 6772,
     /* 762039 */     GIR_EraseRootFromParent_Done,
     /* 762040 */   // Label 10050: @762040
     /* 762040 */   GIM_Try, /*On fail goto*//*Label 10051*/ GIMT_Encode4(762130), // Rule ID 6762 //
     /* 762045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 762048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 762055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762063 */     // MIs[0] offset
     /* 762063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762066 */     // MIs[0] format
     /* 762066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762069 */     // MIs[0] auxiliary
     /* 762069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762072 */     // MIs[0] Operand 8
     /* 762072 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762090 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33611>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_OFFEN),
     /* 762093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762095 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 762097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762104 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762106 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762112 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762118 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762128 */     GIR_RootConstrainSelectedInstOperands,
     /* 762129 */     // GIR_Coverage, 6762,
     /* 762129 */     GIR_EraseRootFromParent_Done,
     /* 762130 */   // Label 10051: @762130
     /* 762130 */   GIM_Try, /*On fail goto*//*Label 10052*/ GIMT_Encode4(762220), // Rule ID 6766 //
     /* 762135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 762138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 762145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762153 */     // MIs[0] offset
     /* 762153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762156 */     // MIs[0] format
     /* 762156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762159 */     // MIs[0] auxiliary
     /* 762159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762162 */     // MIs[0] Operand 8
     /* 762162 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762180 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33611>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN),
     /* 762183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762185 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 762187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762194 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762196 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762202 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762208 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762218 */     GIR_RootConstrainSelectedInstOperands,
     /* 762219 */     // GIR_Coverage, 6766,
     /* 762219 */     GIR_EraseRootFromParent_Done,
     /* 762220 */   // Label 10052: @762220
     /* 762220 */   GIM_Try, /*On fail goto*//*Label 10053*/ GIMT_Encode4(762303), // Rule ID 6770 //
     /* 762225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 762228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762236 */     // MIs[0] offset
     /* 762236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762239 */     // MIs[0] format
     /* 762239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762242 */     // MIs[0] auxiliary
     /* 762242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762245 */     // MIs[0] Operand 8
     /* 762245 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762263 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_OFFEN),
     /* 762266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762268 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 762270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762277 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762279 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762285 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762291 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762301 */     GIR_RootConstrainSelectedInstOperands,
     /* 762302 */     // GIR_Coverage, 6770,
     /* 762302 */     GIR_EraseRootFromParent_Done,
     /* 762303 */   // Label 10053: @762303
     /* 762303 */   GIM_Try, /*On fail goto*//*Label 10054*/ GIMT_Encode4(762386), // Rule ID 6774 //
     /* 762308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 762311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762319 */     // MIs[0] offset
     /* 762319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762322 */     // MIs[0] format
     /* 762322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762325 */     // MIs[0] auxiliary
     /* 762325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762328 */     // MIs[0] Operand 8
     /* 762328 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762346 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN),
     /* 762349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762351 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 762353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762360 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762368 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762374 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762384 */     GIR_RootConstrainSelectedInstOperands,
     /* 762385 */     // GIR_Coverage, 6774,
     /* 762385 */     GIR_EraseRootFromParent_Done,
     /* 762386 */   // Label 10054: @762386
     /* 762386 */   GIM_Try, /*On fail goto*//*Label 10055*/ GIMT_Encode4(762468), // Rule ID 6761 //
     /* 762391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 762394 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 762401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762409 */     // MIs[0] offset
     /* 762409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762412 */     // MIs[0] format
     /* 762412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762415 */     // MIs[0] auxiliary
     /* 762415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762418 */     // MIs[0] Operand 8
     /* 762418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762428 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33611>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_IDXEN),
     /* 762431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762433 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 762435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762442 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762444 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762450 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762456 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762466 */     GIR_RootConstrainSelectedInstOperands,
     /* 762467 */     // GIR_Coverage, 6761,
     /* 762467 */     GIR_EraseRootFromParent_Done,
     /* 762468 */   // Label 10055: @762468
     /* 762468 */   GIM_Try, /*On fail goto*//*Label 10056*/ GIMT_Encode4(762550), // Rule ID 6765 //
     /* 762473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 762476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 762483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762491 */     // MIs[0] offset
     /* 762491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762494 */     // MIs[0] format
     /* 762494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762497 */     // MIs[0] auxiliary
     /* 762497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762500 */     // MIs[0] Operand 8
     /* 762500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762510 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33611>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN),
     /* 762513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762515 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 762517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762524 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762526 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762532 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762538 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762548 */     GIR_RootConstrainSelectedInstOperands,
     /* 762549 */     // GIR_Coverage, 6765,
     /* 762549 */     GIR_EraseRootFromParent_Done,
     /* 762550 */   // Label 10056: @762550
     /* 762550 */   GIM_Try, /*On fail goto*//*Label 10057*/ GIMT_Encode4(762625), // Rule ID 6769 //
     /* 762555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 762558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762566 */     // MIs[0] offset
     /* 762566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762569 */     // MIs[0] format
     /* 762569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762572 */     // MIs[0] auxiliary
     /* 762572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762575 */     // MIs[0] Operand 8
     /* 762575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762585 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_IDXEN),
     /* 762588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762590 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 762592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762599 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762601 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762607 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762613 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762623 */     GIR_RootConstrainSelectedInstOperands,
     /* 762624 */     // GIR_Coverage, 6769,
     /* 762624 */     GIR_EraseRootFromParent_Done,
     /* 762625 */   // Label 10057: @762625
     /* 762625 */   GIM_Try, /*On fail goto*//*Label 10058*/ GIMT_Encode4(762700), // Rule ID 6773 //
     /* 762630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 762633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762641 */     // MIs[0] offset
     /* 762641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762644 */     // MIs[0] format
     /* 762644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762647 */     // MIs[0] auxiliary
     /* 762647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762650 */     // MIs[0] Operand 8
     /* 762650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762660 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN),
     /* 762663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762665 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 762667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762674 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762676 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762682 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762688 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762698 */     GIR_RootConstrainSelectedInstOperands,
     /* 762699 */     // GIR_Coverage, 6773,
     /* 762699 */     GIR_EraseRootFromParent_Done,
     /* 762700 */   // Label 10058: @762700
     /* 762700 */   GIM_Try, /*On fail goto*//*Label 10059*/ GIMT_Encode4(762820), // Rule ID 6763 //
     /* 762705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 762708 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 762715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762719 */     // MIs[0] offset
     /* 762719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762722 */     // MIs[0] format
     /* 762722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762725 */     // MIs[0] auxiliary
     /* 762725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762728 */     // MIs[0] Operand 8
     /* 762728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762738 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33611>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 762741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 762745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 762750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 762754 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 762757 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 762761 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 762764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 762769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 762774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 762779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN),
     /* 762782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 762787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762794 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762796 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762818 */     GIR_RootConstrainSelectedInstOperands,
     /* 762819 */     // GIR_Coverage, 6763,
     /* 762819 */     GIR_EraseRootFromParent_Done,
     /* 762820 */   // Label 10059: @762820
     /* 762820 */   GIM_Try, /*On fail goto*//*Label 10060*/ GIMT_Encode4(762940), // Rule ID 6767 //
     /* 762825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 762828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 762835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762839 */     // MIs[0] offset
     /* 762839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762842 */     // MIs[0] format
     /* 762842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762845 */     // MIs[0] auxiliary
     /* 762845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762848 */     // MIs[0] Operand 8
     /* 762848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762858 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33611>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 762861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 762865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 762870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 762874 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 762877 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 762881 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 762884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 762889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 762894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 762899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN),
     /* 762902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 762907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762914 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762916 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762928 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762938 */     GIR_RootConstrainSelectedInstOperands,
     /* 762939 */     // GIR_Coverage, 6767,
     /* 762939 */     GIR_EraseRootFromParent_Done,
     /* 762940 */   // Label 10060: @762940
     /* 762940 */   GIM_Try, /*On fail goto*//*Label 10061*/ GIMT_Encode4(763053), // Rule ID 6771 //
     /* 762945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 762948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 762952 */     // MIs[0] offset
     /* 762952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762955 */     // MIs[0] format
     /* 762955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762958 */     // MIs[0] auxiliary
     /* 762958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762961 */     // MIs[0] Operand 8
     /* 762961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762971 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 762974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 762978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 762983 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 762987 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 762990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 762994 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 762997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 763002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN),
     /* 763015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 763020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763027 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763029 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763035 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763041 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763051 */     GIR_RootConstrainSelectedInstOperands,
     /* 763052 */     // GIR_Coverage, 6771,
     /* 763052 */     GIR_EraseRootFromParent_Done,
     /* 763053 */   // Label 10061: @763053
     /* 763053 */   GIM_Try, /*On fail goto*//*Label 10062*/ GIMT_Encode4(763166), // Rule ID 6775 //
     /* 763058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 763061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 763065 */     // MIs[0] offset
     /* 763065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763068 */     // MIs[0] format
     /* 763068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763071 */     // MIs[0] auxiliary
     /* 763071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763074 */     // MIs[0] Operand 8
     /* 763074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763084 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 763087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 763091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 763096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 763100 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 763103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 763107 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 763110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 763115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN),
     /* 763128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 763133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763140 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763142 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763148 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763154 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763164 */     GIR_RootConstrainSelectedInstOperands,
     /* 763165 */     // GIR_Coverage, 6775,
     /* 763165 */     GIR_EraseRootFromParent_Done,
     /* 763166 */   // Label 10062: @763166
     /* 763166 */   GIM_Reject,
     /* 763167 */ // Label 10046: @763167
     /* 763167 */ GIM_Reject,
     /* 763168 */ // Label 9999: @763168
     /* 763168 */ GIM_Try, /*On fail goto*//*Label 10063*/ GIMT_Encode4(763530),
     /* 763173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 763176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 763179 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 763182 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 763185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 763189 */   GIM_Try, /*On fail goto*//*Label 10064*/ GIMT_Encode4(763270), // Rule ID 6732 //
     /* 763194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 763197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763201 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763205 */     // MIs[0] offset
     /* 763205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763208 */     // MIs[0] format
     /* 763208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763211 */     // MIs[0] auxiliary
     /* 763211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763214 */     // MIs[0] Operand 8
     /* 763214 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 763225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763232 */     // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET),
     /* 763235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763244 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763246 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763258 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763268 */     GIR_RootConstrainSelectedInstOperands,
     /* 763269 */     // GIR_Coverage, 6732,
     /* 763269 */     GIR_EraseRootFromParent_Done,
     /* 763270 */   // Label 10064: @763270
     /* 763270 */   GIM_Try, /*On fail goto*//*Label 10065*/ GIMT_Encode4(763349), // Rule ID 6734 //
     /* 763275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 763278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763282 */     // MIs[0] offset
     /* 763282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763285 */     // MIs[0] format
     /* 763285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763288 */     // MIs[0] auxiliary
     /* 763288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763291 */     // MIs[0] Operand 8
     /* 763291 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 763302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763309 */     // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN),
     /* 763312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763314 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 763316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763323 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763325 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763331 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763337 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763347 */     GIR_RootConstrainSelectedInstOperands,
     /* 763348 */     // GIR_Coverage, 6734,
     /* 763348 */     GIR_EraseRootFromParent_Done,
     /* 763349 */   // Label 10065: @763349
     /* 763349 */   GIM_Try, /*On fail goto*//*Label 10066*/ GIMT_Encode4(763420), // Rule ID 6733 //
     /* 763354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 763357 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763361 */     // MIs[0] offset
     /* 763361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763364 */     // MIs[0] format
     /* 763364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763367 */     // MIs[0] auxiliary
     /* 763367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763370 */     // MIs[0] Operand 8
     /* 763370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763380 */     // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN),
     /* 763383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763385 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 763387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763394 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763396 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763418 */     GIR_RootConstrainSelectedInstOperands,
     /* 763419 */     // GIR_Coverage, 6733,
     /* 763419 */     GIR_EraseRootFromParent_Done,
     /* 763420 */   // Label 10066: @763420
     /* 763420 */   GIM_Try, /*On fail goto*//*Label 10067*/ GIMT_Encode4(763529), // Rule ID 6735 //
     /* 763425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 763428 */     // MIs[0] offset
     /* 763428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763431 */     // MIs[0] format
     /* 763431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763434 */     // MIs[0] auxiliary
     /* 763434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763437 */     // MIs[0] Operand 8
     /* 763437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763447 */     // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 763450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 763454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 763459 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 763463 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 763466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 763470 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 763473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 763478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN),
     /* 763491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 763496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763503 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763505 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763511 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763517 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763527 */     GIR_RootConstrainSelectedInstOperands,
     /* 763528 */     // GIR_Coverage, 6735,
     /* 763528 */     GIR_EraseRootFromParent_Done,
     /* 763529 */   // Label 10067: @763529
     /* 763529 */   GIM_Reject,
     /* 763530 */ // Label 10063: @763530
     /* 763530 */ GIM_Reject,
     /* 763531 */ // Label 10000: @763531
     /* 763531 */ GIM_Reject,
     /* 763532 */ // Label 164: @763532
     /* 763532 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 10072*/ GIMT_Encode4(768999),
     /* 763543 */ /*GILLT_s32*//*Label 10068*/ GIMT_Encode4(763579), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 763555 */ /*GILLT_v2s32*//*Label 10069*/ GIMT_Encode4(764934), GIMT_Encode4(0),
     /* 763563 */ /*GILLT_v3s32*//*Label 10070*/ GIMT_Encode4(766289), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 763575 */ /*GILLT_v4s32*//*Label 10071*/ GIMT_Encode4(767644),
     /* 763579 */ // Label 10068: @763579
     /* 763579 */ GIM_Try, /*On fail goto*//*Label 10073*/ GIMT_Encode4(764933),
     /* 763584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 763587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 763590 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 763593 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 763596 */   GIM_Try, /*On fail goto*//*Label 10074*/ GIMT_Encode4(763677), // Rule ID 6776 //
     /* 763601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 763604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763612 */     // MIs[0] offset
     /* 763612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763615 */     // MIs[0] format
     /* 763615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763618 */     // MIs[0] auxiliary
     /* 763618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763621 */     // MIs[0] Operand 8
     /* 763621 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 763632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763639 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFSET_exact),
     /* 763642 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 763644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763651 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763653 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763659 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763665 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763675 */     GIR_RootConstrainSelectedInstOperands,
     /* 763676 */     // GIR_Coverage, 6776,
     /* 763676 */     GIR_EraseRootFromParent_Done,
     /* 763677 */   // Label 10074: @763677
     /* 763677 */   GIM_Try, /*On fail goto*//*Label 10075*/ GIMT_Encode4(763755), // Rule ID 6780 //
     /* 763682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763690 */     // MIs[0] offset
     /* 763690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763693 */     // MIs[0] format
     /* 763693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763696 */     // MIs[0] auxiliary
     /* 763696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763699 */     // MIs[0] Operand 8
     /* 763699 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 763710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763717 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
     /* 763720 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 763722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763729 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763731 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763737 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763743 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763753 */     GIR_RootConstrainSelectedInstOperands,
     /* 763754 */     // GIR_Coverage, 6780,
     /* 763754 */     GIR_EraseRootFromParent_Done,
     /* 763755 */   // Label 10075: @763755
     /* 763755 */   GIM_Try, /*On fail goto*//*Label 10076*/ GIMT_Encode4(763836), // Rule ID 6808 //
     /* 763760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 763763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763771 */     // MIs[0] offset
     /* 763771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763774 */     // MIs[0] format
     /* 763774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763777 */     // MIs[0] auxiliary
     /* 763777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763780 */     // MIs[0] Operand 8
     /* 763780 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 763791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763798 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9820:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFSET_exact),
     /* 763801 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 763803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763810 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763812 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763818 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763824 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763834 */     GIR_RootConstrainSelectedInstOperands,
     /* 763835 */     // GIR_Coverage, 6808,
     /* 763835 */     GIR_EraseRootFromParent_Done,
     /* 763836 */   // Label 10076: @763836
     /* 763836 */   GIM_Try, /*On fail goto*//*Label 10077*/ GIMT_Encode4(763914), // Rule ID 6812 //
     /* 763841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763849 */     // MIs[0] offset
     /* 763849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763852 */     // MIs[0] format
     /* 763852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763855 */     // MIs[0] auxiliary
     /* 763855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763858 */     // MIs[0] Operand 8
     /* 763858 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 763869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763876 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9820:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
     /* 763879 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 763881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763888 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763890 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763902 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763912 */     GIR_RootConstrainSelectedInstOperands,
     /* 763913 */     // GIR_Coverage, 6812,
     /* 763913 */     GIR_EraseRootFromParent_Done,
     /* 763914 */   // Label 10077: @763914
     /* 763914 */   GIM_Try, /*On fail goto*//*Label 10078*/ GIMT_Encode4(763993), // Rule ID 6778 //
     /* 763919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 763922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763926 */     // MIs[0] offset
     /* 763926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763929 */     // MIs[0] format
     /* 763929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763932 */     // MIs[0] auxiliary
     /* 763932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763935 */     // MIs[0] Operand 8
     /* 763935 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 763946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763953 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFEN_exact),
     /* 763956 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 763958 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 763960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763967 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763969 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763975 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763981 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763991 */     GIR_RootConstrainSelectedInstOperands,
     /* 763992 */     // GIR_Coverage, 6778,
     /* 763992 */     GIR_EraseRootFromParent_Done,
     /* 763993 */   // Label 10078: @763993
     /* 763993 */   GIM_Try, /*On fail goto*//*Label 10079*/ GIMT_Encode4(764069), // Rule ID 6782 //
     /* 763998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764002 */     // MIs[0] offset
     /* 764002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764005 */     // MIs[0] format
     /* 764005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764008 */     // MIs[0] auxiliary
     /* 764008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764011 */     // MIs[0] Operand 8
     /* 764011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764029 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
     /* 764032 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764034 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 764036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764043 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764051 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764057 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764067 */     GIR_RootConstrainSelectedInstOperands,
     /* 764068 */     // GIR_Coverage, 6782,
     /* 764068 */     GIR_EraseRootFromParent_Done,
     /* 764069 */   // Label 10079: @764069
     /* 764069 */   GIM_Try, /*On fail goto*//*Label 10080*/ GIMT_Encode4(764148), // Rule ID 6810 //
     /* 764074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 764077 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764081 */     // MIs[0] offset
     /* 764081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764084 */     // MIs[0] format
     /* 764084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764087 */     // MIs[0] auxiliary
     /* 764087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764090 */     // MIs[0] Operand 8
     /* 764090 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764108 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9820:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFEN_exact),
     /* 764111 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764113 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 764115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764122 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764124 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764130 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764136 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764146 */     GIR_RootConstrainSelectedInstOperands,
     /* 764147 */     // GIR_Coverage, 6810,
     /* 764147 */     GIR_EraseRootFromParent_Done,
     /* 764148 */   // Label 10080: @764148
     /* 764148 */   GIM_Try, /*On fail goto*//*Label 10081*/ GIMT_Encode4(764224), // Rule ID 6814 //
     /* 764153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764157 */     // MIs[0] offset
     /* 764157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764160 */     // MIs[0] format
     /* 764160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764163 */     // MIs[0] auxiliary
     /* 764163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764166 */     // MIs[0] Operand 8
     /* 764166 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764184 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9820:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
     /* 764187 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764189 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 764191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764198 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764200 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764212 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764222 */     GIR_RootConstrainSelectedInstOperands,
     /* 764223 */     // GIR_Coverage, 6814,
     /* 764223 */     GIR_EraseRootFromParent_Done,
     /* 764224 */   // Label 10081: @764224
     /* 764224 */   GIM_Try, /*On fail goto*//*Label 10082*/ GIMT_Encode4(764295), // Rule ID 6777 //
     /* 764229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 764232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764236 */     // MIs[0] offset
     /* 764236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764239 */     // MIs[0] format
     /* 764239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764242 */     // MIs[0] auxiliary
     /* 764242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764245 */     // MIs[0] Operand 8
     /* 764245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764255 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_IDXEN_exact),
     /* 764258 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764260 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 764262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764269 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764277 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764283 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764293 */     GIR_RootConstrainSelectedInstOperands,
     /* 764294 */     // GIR_Coverage, 6777,
     /* 764294 */     GIR_EraseRootFromParent_Done,
     /* 764295 */   // Label 10082: @764295
     /* 764295 */   GIM_Try, /*On fail goto*//*Label 10083*/ GIMT_Encode4(764363), // Rule ID 6781 //
     /* 764300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764304 */     // MIs[0] offset
     /* 764304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764307 */     // MIs[0] format
     /* 764307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764310 */     // MIs[0] auxiliary
     /* 764310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764313 */     // MIs[0] Operand 8
     /* 764313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764323 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
     /* 764326 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764328 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 764330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764337 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764339 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764345 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764351 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764361 */     GIR_RootConstrainSelectedInstOperands,
     /* 764362 */     // GIR_Coverage, 6781,
     /* 764362 */     GIR_EraseRootFromParent_Done,
     /* 764363 */   // Label 10083: @764363
     /* 764363 */   GIM_Try, /*On fail goto*//*Label 10084*/ GIMT_Encode4(764434), // Rule ID 6809 //
     /* 764368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 764371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764375 */     // MIs[0] offset
     /* 764375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764378 */     // MIs[0] format
     /* 764378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764381 */     // MIs[0] auxiliary
     /* 764381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764384 */     // MIs[0] Operand 8
     /* 764384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764394 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9820:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_IDXEN_exact),
     /* 764397 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764399 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 764401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764408 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764422 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764432 */     GIR_RootConstrainSelectedInstOperands,
     /* 764433 */     // GIR_Coverage, 6809,
     /* 764433 */     GIR_EraseRootFromParent_Done,
     /* 764434 */   // Label 10084: @764434
     /* 764434 */   GIM_Try, /*On fail goto*//*Label 10085*/ GIMT_Encode4(764502), // Rule ID 6813 //
     /* 764439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764443 */     // MIs[0] offset
     /* 764443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764446 */     // MIs[0] format
     /* 764446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764449 */     // MIs[0] auxiliary
     /* 764449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764452 */     // MIs[0] Operand 8
     /* 764452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764462 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9820:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
     /* 764465 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764467 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 764469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764476 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764478 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764484 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764490 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764500 */     GIR_RootConstrainSelectedInstOperands,
     /* 764501 */     // GIR_Coverage, 6813,
     /* 764501 */     GIR_EraseRootFromParent_Done,
     /* 764502 */   // Label 10085: @764502
     /* 764502 */   GIM_Try, /*On fail goto*//*Label 10086*/ GIMT_Encode4(764611), // Rule ID 6779 //
     /* 764507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 764510 */     // MIs[0] offset
     /* 764510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764513 */     // MIs[0] format
     /* 764513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764516 */     // MIs[0] auxiliary
     /* 764516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764519 */     // MIs[0] Operand 8
     /* 764519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764529 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 764532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 764536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 764541 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 764545 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 764548 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 764552 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 764555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 764560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_BOTHEN_exact),
     /* 764573 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 764578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764585 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764587 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764593 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764609 */     GIR_RootConstrainSelectedInstOperands,
     /* 764610 */     // GIR_Coverage, 6779,
     /* 764610 */     GIR_EraseRootFromParent_Done,
     /* 764611 */   // Label 10086: @764611
     /* 764611 */   GIM_Try, /*On fail goto*//*Label 10087*/ GIMT_Encode4(764717), // Rule ID 6783 //
     /* 764616 */     // MIs[0] offset
     /* 764616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764619 */     // MIs[0] format
     /* 764619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764622 */     // MIs[0] auxiliary
     /* 764622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764625 */     // MIs[0] Operand 8
     /* 764625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764635 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 764638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 764642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 764647 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 764651 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 764654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 764658 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 764661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 764666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
     /* 764679 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 764684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764691 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764705 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764715 */     GIR_RootConstrainSelectedInstOperands,
     /* 764716 */     // GIR_Coverage, 6783,
     /* 764716 */     GIR_EraseRootFromParent_Done,
     /* 764717 */   // Label 10087: @764717
     /* 764717 */   GIM_Try, /*On fail goto*//*Label 10088*/ GIMT_Encode4(764826), // Rule ID 6811 //
     /* 764722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 764725 */     // MIs[0] offset
     /* 764725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764728 */     // MIs[0] format
     /* 764728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764731 */     // MIs[0] auxiliary
     /* 764731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764734 */     // MIs[0] Operand 8
     /* 764734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764744 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9820:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 764747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 764751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 764756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 764760 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 764763 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 764767 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 764770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 764775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_BOTHEN_exact),
     /* 764788 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 764793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764800 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764824 */     GIR_RootConstrainSelectedInstOperands,
     /* 764825 */     // GIR_Coverage, 6811,
     /* 764825 */     GIR_EraseRootFromParent_Done,
     /* 764826 */   // Label 10088: @764826
     /* 764826 */   GIM_Try, /*On fail goto*//*Label 10089*/ GIMT_Encode4(764932), // Rule ID 6815 //
     /* 764831 */     // MIs[0] offset
     /* 764831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764834 */     // MIs[0] format
     /* 764834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764837 */     // MIs[0] auxiliary
     /* 764837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764840 */     // MIs[0] Operand 8
     /* 764840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764850 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 764853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 764857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 764862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 764866 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 764869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 764873 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 764876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 764881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
     /* 764894 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 764899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764906 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764908 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764914 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764920 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764930 */     GIR_RootConstrainSelectedInstOperands,
     /* 764931 */     // GIR_Coverage, 6815,
     /* 764931 */     GIR_EraseRootFromParent_Done,
     /* 764932 */   // Label 10089: @764932
     /* 764932 */   GIM_Reject,
     /* 764933 */ // Label 10073: @764933
     /* 764933 */ GIM_Reject,
     /* 764934 */ // Label 10069: @764934
     /* 764934 */ GIM_Try, /*On fail goto*//*Label 10090*/ GIMT_Encode4(766288),
     /* 764939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 764942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 764945 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 764948 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 764951 */   GIM_Try, /*On fail goto*//*Label 10091*/ GIMT_Encode4(765032), // Rule ID 6784 //
     /* 764956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 764959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764963 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764967 */     // MIs[0] offset
     /* 764967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764970 */     // MIs[0] format
     /* 764970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764973 */     // MIs[0] auxiliary
     /* 764973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764976 */     // MIs[0] Operand 8
     /* 764976 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764994 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9819:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 764997 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 764999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765006 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765008 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765014 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765020 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765030 */     GIR_RootConstrainSelectedInstOperands,
     /* 765031 */     // GIR_Coverage, 6784,
     /* 765031 */     GIR_EraseRootFromParent_Done,
     /* 765032 */   // Label 10091: @765032
     /* 765032 */   GIM_Try, /*On fail goto*//*Label 10092*/ GIMT_Encode4(765110), // Rule ID 6788 //
     /* 765037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765045 */     // MIs[0] offset
     /* 765045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765048 */     // MIs[0] format
     /* 765048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765051 */     // MIs[0] auxiliary
     /* 765051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765054 */     // MIs[0] Operand 8
     /* 765054 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765072 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9819:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 765075 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765084 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765086 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765092 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765098 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765108 */     GIR_RootConstrainSelectedInstOperands,
     /* 765109 */     // GIR_Coverage, 6788,
     /* 765109 */     GIR_EraseRootFromParent_Done,
     /* 765110 */   // Label 10092: @765110
     /* 765110 */   GIM_Try, /*On fail goto*//*Label 10093*/ GIMT_Encode4(765191), // Rule ID 6816 //
     /* 765115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 765118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765126 */     // MIs[0] offset
     /* 765126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765129 */     // MIs[0] format
     /* 765129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765132 */     // MIs[0] auxiliary
     /* 765132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765135 */     // MIs[0] Operand 8
     /* 765135 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765153 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9819:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 765156 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765165 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765167 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765173 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765179 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765189 */     GIR_RootConstrainSelectedInstOperands,
     /* 765190 */     // GIR_Coverage, 6816,
     /* 765190 */     GIR_EraseRootFromParent_Done,
     /* 765191 */   // Label 10093: @765191
     /* 765191 */   GIM_Try, /*On fail goto*//*Label 10094*/ GIMT_Encode4(765269), // Rule ID 6820 //
     /* 765196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765204 */     // MIs[0] offset
     /* 765204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765207 */     // MIs[0] format
     /* 765207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765210 */     // MIs[0] auxiliary
     /* 765210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765213 */     // MIs[0] Operand 8
     /* 765213 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765231 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9819:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 765234 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765243 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765245 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765251 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765257 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765267 */     GIR_RootConstrainSelectedInstOperands,
     /* 765268 */     // GIR_Coverage, 6820,
     /* 765268 */     GIR_EraseRootFromParent_Done,
     /* 765269 */   // Label 10094: @765269
     /* 765269 */   GIM_Try, /*On fail goto*//*Label 10095*/ GIMT_Encode4(765348), // Rule ID 6786 //
     /* 765274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 765277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765281 */     // MIs[0] offset
     /* 765281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765284 */     // MIs[0] format
     /* 765284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765287 */     // MIs[0] auxiliary
     /* 765287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765290 */     // MIs[0] Operand 8
     /* 765290 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765308 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 765311 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765313 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 765315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765322 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765324 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765330 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765336 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765346 */     GIR_RootConstrainSelectedInstOperands,
     /* 765347 */     // GIR_Coverage, 6786,
     /* 765347 */     GIR_EraseRootFromParent_Done,
     /* 765348 */   // Label 10095: @765348
     /* 765348 */   GIM_Try, /*On fail goto*//*Label 10096*/ GIMT_Encode4(765424), // Rule ID 6790 //
     /* 765353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765357 */     // MIs[0] offset
     /* 765357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765360 */     // MIs[0] format
     /* 765360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765363 */     // MIs[0] auxiliary
     /* 765363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765366 */     // MIs[0] Operand 8
     /* 765366 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765384 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 765387 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765389 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 765391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765398 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765400 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765406 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765412 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765422 */     GIR_RootConstrainSelectedInstOperands,
     /* 765423 */     // GIR_Coverage, 6790,
     /* 765423 */     GIR_EraseRootFromParent_Done,
     /* 765424 */   // Label 10096: @765424
     /* 765424 */   GIM_Try, /*On fail goto*//*Label 10097*/ GIMT_Encode4(765503), // Rule ID 6818 //
     /* 765429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 765432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765436 */     // MIs[0] offset
     /* 765436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765439 */     // MIs[0] format
     /* 765439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765442 */     // MIs[0] auxiliary
     /* 765442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765445 */     // MIs[0] Operand 8
     /* 765445 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765463 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 765466 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765468 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 765470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765477 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765479 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765485 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765491 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765501 */     GIR_RootConstrainSelectedInstOperands,
     /* 765502 */     // GIR_Coverage, 6818,
     /* 765502 */     GIR_EraseRootFromParent_Done,
     /* 765503 */   // Label 10097: @765503
     /* 765503 */   GIM_Try, /*On fail goto*//*Label 10098*/ GIMT_Encode4(765579), // Rule ID 6822 //
     /* 765508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765512 */     // MIs[0] offset
     /* 765512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765515 */     // MIs[0] format
     /* 765515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765518 */     // MIs[0] auxiliary
     /* 765518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765521 */     // MIs[0] Operand 8
     /* 765521 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765539 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 765542 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765544 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 765546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765553 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765555 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765561 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765567 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765577 */     GIR_RootConstrainSelectedInstOperands,
     /* 765578 */     // GIR_Coverage, 6822,
     /* 765578 */     GIR_EraseRootFromParent_Done,
     /* 765579 */   // Label 10098: @765579
     /* 765579 */   GIM_Try, /*On fail goto*//*Label 10099*/ GIMT_Encode4(765650), // Rule ID 6785 //
     /* 765584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 765587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765591 */     // MIs[0] offset
     /* 765591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765594 */     // MIs[0] format
     /* 765594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765597 */     // MIs[0] auxiliary
     /* 765597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765600 */     // MIs[0] Operand 8
     /* 765600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765610 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 765613 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765615 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 765617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765624 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765626 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765632 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765638 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765648 */     GIR_RootConstrainSelectedInstOperands,
     /* 765649 */     // GIR_Coverage, 6785,
     /* 765649 */     GIR_EraseRootFromParent_Done,
     /* 765650 */   // Label 10099: @765650
     /* 765650 */   GIM_Try, /*On fail goto*//*Label 10100*/ GIMT_Encode4(765718), // Rule ID 6789 //
     /* 765655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765659 */     // MIs[0] offset
     /* 765659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765662 */     // MIs[0] format
     /* 765662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765665 */     // MIs[0] auxiliary
     /* 765665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765668 */     // MIs[0] Operand 8
     /* 765668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765678 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 765681 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765683 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 765685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765692 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765694 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765700 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765706 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765716 */     GIR_RootConstrainSelectedInstOperands,
     /* 765717 */     // GIR_Coverage, 6789,
     /* 765717 */     GIR_EraseRootFromParent_Done,
     /* 765718 */   // Label 10100: @765718
     /* 765718 */   GIM_Try, /*On fail goto*//*Label 10101*/ GIMT_Encode4(765789), // Rule ID 6817 //
     /* 765723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 765726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765730 */     // MIs[0] offset
     /* 765730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765733 */     // MIs[0] format
     /* 765733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765736 */     // MIs[0] auxiliary
     /* 765736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765739 */     // MIs[0] Operand 8
     /* 765739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765749 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 765752 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765754 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 765756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765763 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765765 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765771 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765787 */     GIR_RootConstrainSelectedInstOperands,
     /* 765788 */     // GIR_Coverage, 6817,
     /* 765788 */     GIR_EraseRootFromParent_Done,
     /* 765789 */   // Label 10101: @765789
     /* 765789 */   GIM_Try, /*On fail goto*//*Label 10102*/ GIMT_Encode4(765857), // Rule ID 6821 //
     /* 765794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765798 */     // MIs[0] offset
     /* 765798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765801 */     // MIs[0] format
     /* 765801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765804 */     // MIs[0] auxiliary
     /* 765804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765807 */     // MIs[0] Operand 8
     /* 765807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765817 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 765820 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765822 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 765824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765831 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765833 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765839 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765845 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765855 */     GIR_RootConstrainSelectedInstOperands,
     /* 765856 */     // GIR_Coverage, 6821,
     /* 765856 */     GIR_EraseRootFromParent_Done,
     /* 765857 */   // Label 10102: @765857
     /* 765857 */   GIM_Try, /*On fail goto*//*Label 10103*/ GIMT_Encode4(765966), // Rule ID 6787 //
     /* 765862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 765865 */     // MIs[0] offset
     /* 765865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765868 */     // MIs[0] format
     /* 765868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765871 */     // MIs[0] auxiliary
     /* 765871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765874 */     // MIs[0] Operand 8
     /* 765874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765884 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 765887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 765891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 765896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 765900 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 765903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 765907 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 765910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 765915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 765920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 765925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 765928 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 765930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 765933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765940 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765942 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765948 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765954 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765964 */     GIR_RootConstrainSelectedInstOperands,
     /* 765965 */     // GIR_Coverage, 6787,
     /* 765965 */     GIR_EraseRootFromParent_Done,
     /* 765966 */   // Label 10103: @765966
     /* 765966 */   GIM_Try, /*On fail goto*//*Label 10104*/ GIMT_Encode4(766072), // Rule ID 6791 //
     /* 765971 */     // MIs[0] offset
     /* 765971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765974 */     // MIs[0] format
     /* 765974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765977 */     // MIs[0] auxiliary
     /* 765977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765980 */     // MIs[0] Operand 8
     /* 765980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765990 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 765993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 765997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 766002 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 766006 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 766009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 766013 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 766016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 766021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 766034 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 766039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766046 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766048 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766054 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766060 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766070 */     GIR_RootConstrainSelectedInstOperands,
     /* 766071 */     // GIR_Coverage, 6791,
     /* 766071 */     GIR_EraseRootFromParent_Done,
     /* 766072 */   // Label 10104: @766072
     /* 766072 */   GIM_Try, /*On fail goto*//*Label 10105*/ GIMT_Encode4(766181), // Rule ID 6819 //
     /* 766077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 766080 */     // MIs[0] offset
     /* 766080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766083 */     // MIs[0] format
     /* 766083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766086 */     // MIs[0] auxiliary
     /* 766086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766089 */     // MIs[0] Operand 8
     /* 766089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766099 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 766102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 766106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 766111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 766115 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 766118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 766122 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 766125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 766130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 766143 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 766148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766155 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766157 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766163 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766169 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766179 */     GIR_RootConstrainSelectedInstOperands,
     /* 766180 */     // GIR_Coverage, 6819,
     /* 766180 */     GIR_EraseRootFromParent_Done,
     /* 766181 */   // Label 10105: @766181
     /* 766181 */   GIM_Try, /*On fail goto*//*Label 10106*/ GIMT_Encode4(766287), // Rule ID 6823 //
     /* 766186 */     // MIs[0] offset
     /* 766186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766189 */     // MIs[0] format
     /* 766189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766192 */     // MIs[0] auxiliary
     /* 766192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766195 */     // MIs[0] Operand 8
     /* 766195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766205 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 766208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 766212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 766217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 766221 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 766224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 766228 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 766231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 766236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 766249 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 766254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766261 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766263 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766269 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766275 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766285 */     GIR_RootConstrainSelectedInstOperands,
     /* 766286 */     // GIR_Coverage, 6823,
     /* 766286 */     GIR_EraseRootFromParent_Done,
     /* 766287 */   // Label 10106: @766287
     /* 766287 */   GIM_Reject,
     /* 766288 */ // Label 10090: @766288
     /* 766288 */ GIM_Reject,
     /* 766289 */ // Label 10070: @766289
     /* 766289 */ GIM_Try, /*On fail goto*//*Label 10107*/ GIMT_Encode4(767643),
     /* 766294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 766297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 766300 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 766303 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 766306 */   GIM_Try, /*On fail goto*//*Label 10108*/ GIMT_Encode4(766387), // Rule ID 6792 //
     /* 766311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 766314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766322 */     // MIs[0] offset
     /* 766322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766325 */     // MIs[0] format
     /* 766325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766328 */     // MIs[0] auxiliary
     /* 766328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766331 */     // MIs[0] Operand 8
     /* 766331 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766349 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9818:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
     /* 766352 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766361 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766363 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766369 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766385 */     GIR_RootConstrainSelectedInstOperands,
     /* 766386 */     // GIR_Coverage, 6792,
     /* 766386 */     GIR_EraseRootFromParent_Done,
     /* 766387 */   // Label 10108: @766387
     /* 766387 */   GIM_Try, /*On fail goto*//*Label 10109*/ GIMT_Encode4(766465), // Rule ID 6796 //
     /* 766392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766400 */     // MIs[0] offset
     /* 766400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766403 */     // MIs[0] format
     /* 766403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766406 */     // MIs[0] auxiliary
     /* 766406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766409 */     // MIs[0] Operand 8
     /* 766409 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766427 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9818:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
     /* 766430 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766439 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766441 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766447 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766453 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766463 */     GIR_RootConstrainSelectedInstOperands,
     /* 766464 */     // GIR_Coverage, 6796,
     /* 766464 */     GIR_EraseRootFromParent_Done,
     /* 766465 */   // Label 10109: @766465
     /* 766465 */   GIM_Try, /*On fail goto*//*Label 10110*/ GIMT_Encode4(766546), // Rule ID 6824 //
     /* 766470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 766473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766481 */     // MIs[0] offset
     /* 766481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766484 */     // MIs[0] format
     /* 766484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766487 */     // MIs[0] auxiliary
     /* 766487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766490 */     // MIs[0] Operand 8
     /* 766490 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766508 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9818:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
     /* 766511 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766520 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766522 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766528 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766534 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766544 */     GIR_RootConstrainSelectedInstOperands,
     /* 766545 */     // GIR_Coverage, 6824,
     /* 766545 */     GIR_EraseRootFromParent_Done,
     /* 766546 */   // Label 10110: @766546
     /* 766546 */   GIM_Try, /*On fail goto*//*Label 10111*/ GIMT_Encode4(766624), // Rule ID 6828 //
     /* 766551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766559 */     // MIs[0] offset
     /* 766559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766562 */     // MIs[0] format
     /* 766562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766565 */     // MIs[0] auxiliary
     /* 766565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766568 */     // MIs[0] Operand 8
     /* 766568 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766586 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9818:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
     /* 766589 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766598 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766600 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766606 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766622 */     GIR_RootConstrainSelectedInstOperands,
     /* 766623 */     // GIR_Coverage, 6828,
     /* 766623 */     GIR_EraseRootFromParent_Done,
     /* 766624 */   // Label 10111: @766624
     /* 766624 */   GIM_Try, /*On fail goto*//*Label 10112*/ GIMT_Encode4(766703), // Rule ID 6794 //
     /* 766629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 766632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766636 */     // MIs[0] offset
     /* 766636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766639 */     // MIs[0] format
     /* 766639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766642 */     // MIs[0] auxiliary
     /* 766642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766645 */     // MIs[0] Operand 8
     /* 766645 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766663 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
     /* 766666 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766668 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 766670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766677 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766679 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766685 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766691 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766701 */     GIR_RootConstrainSelectedInstOperands,
     /* 766702 */     // GIR_Coverage, 6794,
     /* 766702 */     GIR_EraseRootFromParent_Done,
     /* 766703 */   // Label 10112: @766703
     /* 766703 */   GIM_Try, /*On fail goto*//*Label 10113*/ GIMT_Encode4(766779), // Rule ID 6798 //
     /* 766708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766712 */     // MIs[0] offset
     /* 766712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766715 */     // MIs[0] format
     /* 766715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766718 */     // MIs[0] auxiliary
     /* 766718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766721 */     // MIs[0] Operand 8
     /* 766721 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766739 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
     /* 766742 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766744 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 766746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766753 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766755 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766761 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766767 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766777 */     GIR_RootConstrainSelectedInstOperands,
     /* 766778 */     // GIR_Coverage, 6798,
     /* 766778 */     GIR_EraseRootFromParent_Done,
     /* 766779 */   // Label 10113: @766779
     /* 766779 */   GIM_Try, /*On fail goto*//*Label 10114*/ GIMT_Encode4(766858), // Rule ID 6826 //
     /* 766784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 766787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766791 */     // MIs[0] offset
     /* 766791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766794 */     // MIs[0] format
     /* 766794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766797 */     // MIs[0] auxiliary
     /* 766797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766800 */     // MIs[0] Operand 8
     /* 766800 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766818 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
     /* 766821 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766823 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 766825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766832 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766834 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766840 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766846 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766856 */     GIR_RootConstrainSelectedInstOperands,
     /* 766857 */     // GIR_Coverage, 6826,
     /* 766857 */     GIR_EraseRootFromParent_Done,
     /* 766858 */   // Label 10114: @766858
     /* 766858 */   GIM_Try, /*On fail goto*//*Label 10115*/ GIMT_Encode4(766934), // Rule ID 6830 //
     /* 766863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766867 */     // MIs[0] offset
     /* 766867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766870 */     // MIs[0] format
     /* 766870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766873 */     // MIs[0] auxiliary
     /* 766873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766876 */     // MIs[0] Operand 8
     /* 766876 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766894 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
     /* 766897 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766899 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 766901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766908 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766910 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766916 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766932 */     GIR_RootConstrainSelectedInstOperands,
     /* 766933 */     // GIR_Coverage, 6830,
     /* 766933 */     GIR_EraseRootFromParent_Done,
     /* 766934 */   // Label 10115: @766934
     /* 766934 */   GIM_Try, /*On fail goto*//*Label 10116*/ GIMT_Encode4(767005), // Rule ID 6793 //
     /* 766939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 766942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766946 */     // MIs[0] offset
     /* 766946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766949 */     // MIs[0] format
     /* 766949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766952 */     // MIs[0] auxiliary
     /* 766952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766955 */     // MIs[0] Operand 8
     /* 766955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766965 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
     /* 766968 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 766970 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 766972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766979 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766981 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766987 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766993 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767003 */     GIR_RootConstrainSelectedInstOperands,
     /* 767004 */     // GIR_Coverage, 6793,
     /* 767004 */     GIR_EraseRootFromParent_Done,
     /* 767005 */   // Label 10116: @767005
     /* 767005 */   GIM_Try, /*On fail goto*//*Label 10117*/ GIMT_Encode4(767073), // Rule ID 6797 //
     /* 767010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767014 */     // MIs[0] offset
     /* 767014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767017 */     // MIs[0] format
     /* 767017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767020 */     // MIs[0] auxiliary
     /* 767020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767023 */     // MIs[0] Operand 8
     /* 767023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767033 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
     /* 767036 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767038 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 767040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767047 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767049 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767055 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767061 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767071 */     GIR_RootConstrainSelectedInstOperands,
     /* 767072 */     // GIR_Coverage, 6797,
     /* 767072 */     GIR_EraseRootFromParent_Done,
     /* 767073 */   // Label 10117: @767073
     /* 767073 */   GIM_Try, /*On fail goto*//*Label 10118*/ GIMT_Encode4(767144), // Rule ID 6825 //
     /* 767078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 767081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767085 */     // MIs[0] offset
     /* 767085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767088 */     // MIs[0] format
     /* 767088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767091 */     // MIs[0] auxiliary
     /* 767091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767094 */     // MIs[0] Operand 8
     /* 767094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767104 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
     /* 767107 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767109 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 767111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767118 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767120 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767126 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767132 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767142 */     GIR_RootConstrainSelectedInstOperands,
     /* 767143 */     // GIR_Coverage, 6825,
     /* 767143 */     GIR_EraseRootFromParent_Done,
     /* 767144 */   // Label 10118: @767144
     /* 767144 */   GIM_Try, /*On fail goto*//*Label 10119*/ GIMT_Encode4(767212), // Rule ID 6829 //
     /* 767149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767153 */     // MIs[0] offset
     /* 767153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767156 */     // MIs[0] format
     /* 767156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767159 */     // MIs[0] auxiliary
     /* 767159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767162 */     // MIs[0] Operand 8
     /* 767162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767172 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
     /* 767175 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767177 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 767179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767186 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767188 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767194 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767200 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767210 */     GIR_RootConstrainSelectedInstOperands,
     /* 767211 */     // GIR_Coverage, 6829,
     /* 767211 */     GIR_EraseRootFromParent_Done,
     /* 767212 */   // Label 10119: @767212
     /* 767212 */   GIM_Try, /*On fail goto*//*Label 10120*/ GIMT_Encode4(767321), // Rule ID 6795 //
     /* 767217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 767220 */     // MIs[0] offset
     /* 767220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767223 */     // MIs[0] format
     /* 767223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767226 */     // MIs[0] auxiliary
     /* 767226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767229 */     // MIs[0] Operand 8
     /* 767229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767239 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 767242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 767246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 767251 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 767255 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 767258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 767262 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 767265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 767270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
     /* 767283 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 767288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767295 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767297 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767303 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767309 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767319 */     GIR_RootConstrainSelectedInstOperands,
     /* 767320 */     // GIR_Coverage, 6795,
     /* 767320 */     GIR_EraseRootFromParent_Done,
     /* 767321 */   // Label 10120: @767321
     /* 767321 */   GIM_Try, /*On fail goto*//*Label 10121*/ GIMT_Encode4(767427), // Rule ID 6799 //
     /* 767326 */     // MIs[0] offset
     /* 767326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767329 */     // MIs[0] format
     /* 767329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767332 */     // MIs[0] auxiliary
     /* 767332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767335 */     // MIs[0] Operand 8
     /* 767335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767345 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 767348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 767352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 767357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 767361 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 767364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 767368 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 767371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 767376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
     /* 767389 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 767394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767401 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767409 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767415 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767425 */     GIR_RootConstrainSelectedInstOperands,
     /* 767426 */     // GIR_Coverage, 6799,
     /* 767426 */     GIR_EraseRootFromParent_Done,
     /* 767427 */   // Label 10121: @767427
     /* 767427 */   GIM_Try, /*On fail goto*//*Label 10122*/ GIMT_Encode4(767536), // Rule ID 6827 //
     /* 767432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 767435 */     // MIs[0] offset
     /* 767435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767438 */     // MIs[0] format
     /* 767438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767441 */     // MIs[0] auxiliary
     /* 767441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767444 */     // MIs[0] Operand 8
     /* 767444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767454 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 767457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 767461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 767466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 767470 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 767473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 767477 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 767480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 767485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
     /* 767498 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 767503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767510 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767518 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767524 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767534 */     GIR_RootConstrainSelectedInstOperands,
     /* 767535 */     // GIR_Coverage, 6827,
     /* 767535 */     GIR_EraseRootFromParent_Done,
     /* 767536 */   // Label 10122: @767536
     /* 767536 */   GIM_Try, /*On fail goto*//*Label 10123*/ GIMT_Encode4(767642), // Rule ID 6831 //
     /* 767541 */     // MIs[0] offset
     /* 767541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767544 */     // MIs[0] format
     /* 767544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767547 */     // MIs[0] auxiliary
     /* 767547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767550 */     // MIs[0] Operand 8
     /* 767550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767560 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9818:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 767563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 767567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 767572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 767576 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 767579 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 767583 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 767586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 767591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
     /* 767604 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 767609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767616 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767624 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767640 */     GIR_RootConstrainSelectedInstOperands,
     /* 767641 */     // GIR_Coverage, 6831,
     /* 767641 */     GIR_EraseRootFromParent_Done,
     /* 767642 */   // Label 10123: @767642
     /* 767642 */   GIM_Reject,
     /* 767643 */ // Label 10107: @767643
     /* 767643 */ GIM_Reject,
     /* 767644 */ // Label 10071: @767644
     /* 767644 */ GIM_Try, /*On fail goto*//*Label 10124*/ GIMT_Encode4(768998),
     /* 767649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 767652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 767655 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 767658 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 767661 */   GIM_Try, /*On fail goto*//*Label 10125*/ GIMT_Encode4(767742), // Rule ID 6800 //
     /* 767666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 767669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767677 */     // MIs[0] offset
     /* 767677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767680 */     // MIs[0] format
     /* 767680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767683 */     // MIs[0] auxiliary
     /* 767683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767686 */     // MIs[0] Operand 8
     /* 767686 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767704 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9817:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
     /* 767707 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767716 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767740 */     GIR_RootConstrainSelectedInstOperands,
     /* 767741 */     // GIR_Coverage, 6800,
     /* 767741 */     GIR_EraseRootFromParent_Done,
     /* 767742 */   // Label 10125: @767742
     /* 767742 */   GIM_Try, /*On fail goto*//*Label 10126*/ GIMT_Encode4(767820), // Rule ID 6804 //
     /* 767747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767755 */     // MIs[0] offset
     /* 767755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767758 */     // MIs[0] format
     /* 767758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767761 */     // MIs[0] auxiliary
     /* 767761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767764 */     // MIs[0] Operand 8
     /* 767764 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767782 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9817:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
     /* 767785 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767794 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767796 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767818 */     GIR_RootConstrainSelectedInstOperands,
     /* 767819 */     // GIR_Coverage, 6804,
     /* 767819 */     GIR_EraseRootFromParent_Done,
     /* 767820 */   // Label 10126: @767820
     /* 767820 */   GIM_Try, /*On fail goto*//*Label 10127*/ GIMT_Encode4(767901), // Rule ID 6832 //
     /* 767825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 767828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767836 */     // MIs[0] offset
     /* 767836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767839 */     // MIs[0] format
     /* 767839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767842 */     // MIs[0] auxiliary
     /* 767842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767845 */     // MIs[0] Operand 8
     /* 767845 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767863 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9817:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
     /* 767866 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767875 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767889 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767899 */     GIR_RootConstrainSelectedInstOperands,
     /* 767900 */     // GIR_Coverage, 6832,
     /* 767900 */     GIR_EraseRootFromParent_Done,
     /* 767901 */   // Label 10127: @767901
     /* 767901 */   GIM_Try, /*On fail goto*//*Label 10128*/ GIMT_Encode4(767979), // Rule ID 6836 //
     /* 767906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767914 */     // MIs[0] offset
     /* 767914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767917 */     // MIs[0] format
     /* 767917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767920 */     // MIs[0] auxiliary
     /* 767920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767923 */     // MIs[0] Operand 8
     /* 767923 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767941 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9817:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
     /* 767944 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 767946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767953 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767955 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767961 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767967 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767977 */     GIR_RootConstrainSelectedInstOperands,
     /* 767978 */     // GIR_Coverage, 6836,
     /* 767978 */     GIR_EraseRootFromParent_Done,
     /* 767979 */   // Label 10128: @767979
     /* 767979 */   GIM_Try, /*On fail goto*//*Label 10129*/ GIMT_Encode4(768058), // Rule ID 6802 //
     /* 767984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 767987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767991 */     // MIs[0] offset
     /* 767991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767994 */     // MIs[0] format
     /* 767994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767997 */     // MIs[0] auxiliary
     /* 767997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768000 */     // MIs[0] Operand 8
     /* 768000 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 768011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768018 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
     /* 768021 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768023 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 768025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768032 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768034 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768040 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768046 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768056 */     GIR_RootConstrainSelectedInstOperands,
     /* 768057 */     // GIR_Coverage, 6802,
     /* 768057 */     GIR_EraseRootFromParent_Done,
     /* 768058 */   // Label 10129: @768058
     /* 768058 */   GIM_Try, /*On fail goto*//*Label 10130*/ GIMT_Encode4(768134), // Rule ID 6806 //
     /* 768063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 768067 */     // MIs[0] offset
     /* 768067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768070 */     // MIs[0] format
     /* 768070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768073 */     // MIs[0] auxiliary
     /* 768073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768076 */     // MIs[0] Operand 8
     /* 768076 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 768087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768094 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
     /* 768097 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768099 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 768101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768108 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768110 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768116 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768122 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768132 */     GIR_RootConstrainSelectedInstOperands,
     /* 768133 */     // GIR_Coverage, 6806,
     /* 768133 */     GIR_EraseRootFromParent_Done,
     /* 768134 */   // Label 10130: @768134
     /* 768134 */   GIM_Try, /*On fail goto*//*Label 10131*/ GIMT_Encode4(768213), // Rule ID 6834 //
     /* 768139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 768142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 768146 */     // MIs[0] offset
     /* 768146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768149 */     // MIs[0] format
     /* 768149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768152 */     // MIs[0] auxiliary
     /* 768152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768155 */     // MIs[0] Operand 8
     /* 768155 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 768166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768173 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
     /* 768176 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768178 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 768180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768187 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768189 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768195 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768201 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768211 */     GIR_RootConstrainSelectedInstOperands,
     /* 768212 */     // GIR_Coverage, 6834,
     /* 768212 */     GIR_EraseRootFromParent_Done,
     /* 768213 */   // Label 10131: @768213
     /* 768213 */   GIM_Try, /*On fail goto*//*Label 10132*/ GIMT_Encode4(768289), // Rule ID 6838 //
     /* 768218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 768222 */     // MIs[0] offset
     /* 768222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768225 */     // MIs[0] format
     /* 768225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768228 */     // MIs[0] auxiliary
     /* 768228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768231 */     // MIs[0] Operand 8
     /* 768231 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 768242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768249 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
     /* 768252 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768254 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 768256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768263 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768265 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768277 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768287 */     GIR_RootConstrainSelectedInstOperands,
     /* 768288 */     // GIR_Coverage, 6838,
     /* 768288 */     GIR_EraseRootFromParent_Done,
     /* 768289 */   // Label 10132: @768289
     /* 768289 */   GIM_Try, /*On fail goto*//*Label 10133*/ GIMT_Encode4(768360), // Rule ID 6801 //
     /* 768294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 768297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768301 */     // MIs[0] offset
     /* 768301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768304 */     // MIs[0] format
     /* 768304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768307 */     // MIs[0] auxiliary
     /* 768307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768310 */     // MIs[0] Operand 8
     /* 768310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768320 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
     /* 768323 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768325 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 768327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768334 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768336 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768342 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768348 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768358 */     GIR_RootConstrainSelectedInstOperands,
     /* 768359 */     // GIR_Coverage, 6801,
     /* 768359 */     GIR_EraseRootFromParent_Done,
     /* 768360 */   // Label 10133: @768360
     /* 768360 */   GIM_Try, /*On fail goto*//*Label 10134*/ GIMT_Encode4(768428), // Rule ID 6805 //
     /* 768365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768369 */     // MIs[0] offset
     /* 768369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768372 */     // MIs[0] format
     /* 768372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768375 */     // MIs[0] auxiliary
     /* 768375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768378 */     // MIs[0] Operand 8
     /* 768378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768388 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
     /* 768391 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768393 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 768395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768402 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768404 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768426 */     GIR_RootConstrainSelectedInstOperands,
     /* 768427 */     // GIR_Coverage, 6805,
     /* 768427 */     GIR_EraseRootFromParent_Done,
     /* 768428 */   // Label 10134: @768428
     /* 768428 */   GIM_Try, /*On fail goto*//*Label 10135*/ GIMT_Encode4(768499), // Rule ID 6833 //
     /* 768433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 768436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768440 */     // MIs[0] offset
     /* 768440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768443 */     // MIs[0] format
     /* 768443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768446 */     // MIs[0] auxiliary
     /* 768446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768449 */     // MIs[0] Operand 8
     /* 768449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768459 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
     /* 768462 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768464 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 768466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768473 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768475 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768481 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768487 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768497 */     GIR_RootConstrainSelectedInstOperands,
     /* 768498 */     // GIR_Coverage, 6833,
     /* 768498 */     GIR_EraseRootFromParent_Done,
     /* 768499 */   // Label 10135: @768499
     /* 768499 */   GIM_Try, /*On fail goto*//*Label 10136*/ GIMT_Encode4(768567), // Rule ID 6837 //
     /* 768504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768508 */     // MIs[0] offset
     /* 768508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768511 */     // MIs[0] format
     /* 768511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768514 */     // MIs[0] auxiliary
     /* 768514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768517 */     // MIs[0] Operand 8
     /* 768517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768527 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
     /* 768530 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768532 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 768534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768541 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768543 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768549 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768555 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768565 */     GIR_RootConstrainSelectedInstOperands,
     /* 768566 */     // GIR_Coverage, 6837,
     /* 768566 */     GIR_EraseRootFromParent_Done,
     /* 768567 */   // Label 10136: @768567
     /* 768567 */   GIM_Try, /*On fail goto*//*Label 10137*/ GIMT_Encode4(768676), // Rule ID 6803 //
     /* 768572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 768575 */     // MIs[0] offset
     /* 768575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768578 */     // MIs[0] format
     /* 768578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768581 */     // MIs[0] auxiliary
     /* 768581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768584 */     // MIs[0] Operand 8
     /* 768584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768594 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 768597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 768601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 768606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 768610 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 768613 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 768617 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 768620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 768625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
     /* 768638 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 768643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768650 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768652 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768658 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768664 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768674 */     GIR_RootConstrainSelectedInstOperands,
     /* 768675 */     // GIR_Coverage, 6803,
     /* 768675 */     GIR_EraseRootFromParent_Done,
     /* 768676 */   // Label 10137: @768676
     /* 768676 */   GIM_Try, /*On fail goto*//*Label 10138*/ GIMT_Encode4(768782), // Rule ID 6807 //
     /* 768681 */     // MIs[0] offset
     /* 768681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768684 */     // MIs[0] format
     /* 768684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768687 */     // MIs[0] auxiliary
     /* 768687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768690 */     // MIs[0] Operand 8
     /* 768690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768700 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 768703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 768707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 768712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 768716 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 768719 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 768723 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 768726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 768731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
     /* 768744 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 768749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768756 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768764 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768770 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768780 */     GIR_RootConstrainSelectedInstOperands,
     /* 768781 */     // GIR_Coverage, 6807,
     /* 768781 */     GIR_EraseRootFromParent_Done,
     /* 768782 */   // Label 10138: @768782
     /* 768782 */   GIM_Try, /*On fail goto*//*Label 10139*/ GIMT_Encode4(768891), // Rule ID 6835 //
     /* 768787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 768790 */     // MIs[0] offset
     /* 768790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768793 */     // MIs[0] format
     /* 768793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768796 */     // MIs[0] auxiliary
     /* 768796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768799 */     // MIs[0] Operand 8
     /* 768799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768809 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 768812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 768816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 768821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 768825 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 768828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 768832 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 768835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 768840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
     /* 768853 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 768858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768865 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768867 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768879 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768889 */     GIR_RootConstrainSelectedInstOperands,
     /* 768890 */     // GIR_Coverage, 6835,
     /* 768890 */     GIR_EraseRootFromParent_Done,
     /* 768891 */   // Label 10139: @768891
     /* 768891 */   GIM_Try, /*On fail goto*//*Label 10140*/ GIMT_Encode4(768997), // Rule ID 6839 //
     /* 768896 */     // MIs[0] offset
     /* 768896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768899 */     // MIs[0] format
     /* 768899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768902 */     // MIs[0] auxiliary
     /* 768902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768905 */     // MIs[0] Operand 8
     /* 768905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768915 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9817:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 768918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 768922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 768927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 768931 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 768934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 768938 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 768941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 768946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
     /* 768959 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 768961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 768964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768971 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768973 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768979 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768985 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768995 */     GIR_RootConstrainSelectedInstOperands,
     /* 768996 */     // GIR_Coverage, 6839,
     /* 768996 */     GIR_EraseRootFromParent_Done,
     /* 768997 */   // Label 10140: @768997
     /* 768997 */   GIM_Reject,
     /* 768998 */ // Label 10124: @768998
     /* 768998 */ GIM_Reject,
     /* 768999 */ // Label 10072: @768999
     /* 768999 */ GIM_Reject,
     /* 769000 */ // Label 165: @769000
     /* 769000 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 10148*/ GIMT_Encode4(773604),
     /* 769011 */ /*GILLT_s16*//*Label 10141*/ GIMT_Encode4(769051),
     /* 769015 */ /*GILLT_s32*//*Label 10142*/ GIMT_Encode4(770090), GIMT_Encode4(0),
     /* 769023 */ /*GILLT_v2s16*//*Label 10143*/ GIMT_Encode4(771129),
     /* 769027 */ /*GILLT_v2s32*//*Label 10144*/ GIMT_Encode4(771828), GIMT_Encode4(0),
     /* 769035 */ /*GILLT_v3s32*//*Label 10145*/ GIMT_Encode4(772187), GIMT_Encode4(0),
     /* 769043 */ /*GILLT_v4s16*//*Label 10146*/ GIMT_Encode4(772546),
     /* 769047 */ /*GILLT_v4s32*//*Label 10147*/ GIMT_Encode4(773245),
     /* 769051 */ // Label 10141: @769051
     /* 769051 */ GIM_Try, /*On fail goto*//*Label 10149*/ GIMT_Encode4(770089),
     /* 769056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 769059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 769062 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 769065 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 769068 */   GIM_Try, /*On fail goto*//*Label 10150*/ GIMT_Encode4(769149), // Rule ID 6840 //
     /* 769073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 769076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769084 */     // MIs[0] offset
     /* 769084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769087 */     // MIs[0] format
     /* 769087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769090 */     // MIs[0] auxiliary
     /* 769090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769093 */     // MIs[0] Operand 8
     /* 769093 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769111 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9820:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 769114 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769123 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769125 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769131 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769137 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769147 */     GIR_RootConstrainSelectedInstOperands,
     /* 769148 */     // GIR_Coverage, 6840,
     /* 769148 */     GIR_EraseRootFromParent_Done,
     /* 769149 */   // Label 10150: @769149
     /* 769149 */   GIM_Try, /*On fail goto*//*Label 10151*/ GIMT_Encode4(769230), // Rule ID 6860 //
     /* 769154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 769157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769165 */     // MIs[0] offset
     /* 769165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769168 */     // MIs[0] format
     /* 769168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769171 */     // MIs[0] auxiliary
     /* 769171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769174 */     // MIs[0] Operand 8
     /* 769174 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769192 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9820:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 769195 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769204 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769212 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769218 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769228 */     GIR_RootConstrainSelectedInstOperands,
     /* 769229 */     // GIR_Coverage, 6860,
     /* 769229 */     GIR_EraseRootFromParent_Done,
     /* 769230 */   // Label 10151: @769230
     /* 769230 */   GIM_Try, /*On fail goto*//*Label 10152*/ GIMT_Encode4(769311), // Rule ID 6864 //
     /* 769235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 769238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769246 */     // MIs[0] offset
     /* 769246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769249 */     // MIs[0] format
     /* 769249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769252 */     // MIs[0] auxiliary
     /* 769252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769255 */     // MIs[0] Operand 8
     /* 769255 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769273 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9820:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 769276 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769285 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769293 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769299 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769309 */     GIR_RootConstrainSelectedInstOperands,
     /* 769310 */     // GIR_Coverage, 6864,
     /* 769310 */     GIR_EraseRootFromParent_Done,
     /* 769311 */   // Label 10152: @769311
     /* 769311 */   GIM_Try, /*On fail goto*//*Label 10153*/ GIMT_Encode4(769390), // Rule ID 6842 //
     /* 769316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 769319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769323 */     // MIs[0] offset
     /* 769323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769326 */     // MIs[0] format
     /* 769326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769329 */     // MIs[0] auxiliary
     /* 769329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769332 */     // MIs[0] Operand 8
     /* 769332 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769350 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9820:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 769353 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769355 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 769357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769364 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769366 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769372 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769378 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769388 */     GIR_RootConstrainSelectedInstOperands,
     /* 769389 */     // GIR_Coverage, 6842,
     /* 769389 */     GIR_EraseRootFromParent_Done,
     /* 769390 */   // Label 10153: @769390
     /* 769390 */   GIM_Try, /*On fail goto*//*Label 10154*/ GIMT_Encode4(769469), // Rule ID 6862 //
     /* 769395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 769398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769402 */     // MIs[0] offset
     /* 769402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769405 */     // MIs[0] format
     /* 769405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769408 */     // MIs[0] auxiliary
     /* 769408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769411 */     // MIs[0] Operand 8
     /* 769411 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769429 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9820:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 769432 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769434 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 769436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769443 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769445 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769451 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769457 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769467 */     GIR_RootConstrainSelectedInstOperands,
     /* 769468 */     // GIR_Coverage, 6862,
     /* 769468 */     GIR_EraseRootFromParent_Done,
     /* 769469 */   // Label 10154: @769469
     /* 769469 */   GIM_Try, /*On fail goto*//*Label 10155*/ GIMT_Encode4(769548), // Rule ID 6866 //
     /* 769474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 769477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769481 */     // MIs[0] offset
     /* 769481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769484 */     // MIs[0] format
     /* 769484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769487 */     // MIs[0] auxiliary
     /* 769487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769490 */     // MIs[0] Operand 8
     /* 769490 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769508 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9820:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 769511 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769513 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 769515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769522 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769524 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769530 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769536 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769546 */     GIR_RootConstrainSelectedInstOperands,
     /* 769547 */     // GIR_Coverage, 6866,
     /* 769547 */     GIR_EraseRootFromParent_Done,
     /* 769548 */   // Label 10155: @769548
     /* 769548 */   GIM_Try, /*On fail goto*//*Label 10156*/ GIMT_Encode4(769619), // Rule ID 6841 //
     /* 769553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 769556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769560 */     // MIs[0] offset
     /* 769560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769563 */     // MIs[0] format
     /* 769563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769566 */     // MIs[0] auxiliary
     /* 769566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769569 */     // MIs[0] Operand 8
     /* 769569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 769572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769579 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9820:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 769582 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769584 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 769586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769593 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769595 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769601 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769607 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769617 */     GIR_RootConstrainSelectedInstOperands,
     /* 769618 */     // GIR_Coverage, 6841,
     /* 769618 */     GIR_EraseRootFromParent_Done,
     /* 769619 */   // Label 10156: @769619
     /* 769619 */   GIM_Try, /*On fail goto*//*Label 10157*/ GIMT_Encode4(769690), // Rule ID 6861 //
     /* 769624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 769627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769631 */     // MIs[0] offset
     /* 769631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769634 */     // MIs[0] format
     /* 769634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769637 */     // MIs[0] auxiliary
     /* 769637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769640 */     // MIs[0] Operand 8
     /* 769640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 769643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769650 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9820:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 769653 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769655 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 769657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769664 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769666 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769672 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769678 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769688 */     GIR_RootConstrainSelectedInstOperands,
     /* 769689 */     // GIR_Coverage, 6861,
     /* 769689 */     GIR_EraseRootFromParent_Done,
     /* 769690 */   // Label 10157: @769690
     /* 769690 */   GIM_Try, /*On fail goto*//*Label 10158*/ GIMT_Encode4(769761), // Rule ID 6865 //
     /* 769695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 769698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769702 */     // MIs[0] offset
     /* 769702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769705 */     // MIs[0] format
     /* 769705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769708 */     // MIs[0] auxiliary
     /* 769708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769711 */     // MIs[0] Operand 8
     /* 769711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 769714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769721 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9820:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 769724 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769726 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 769728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769735 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769737 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769743 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769749 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769759 */     GIR_RootConstrainSelectedInstOperands,
     /* 769760 */     // GIR_Coverage, 6865,
     /* 769760 */     GIR_EraseRootFromParent_Done,
     /* 769761 */   // Label 10158: @769761
     /* 769761 */   GIM_Try, /*On fail goto*//*Label 10159*/ GIMT_Encode4(769870), // Rule ID 6843 //
     /* 769766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 769769 */     // MIs[0] offset
     /* 769769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769772 */     // MIs[0] format
     /* 769772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769775 */     // MIs[0] auxiliary
     /* 769775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769778 */     // MIs[0] Operand 8
     /* 769778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 769781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769788 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9820:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 769791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 769795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 769800 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 769804 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 769807 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 769811 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 769814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 769819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 769824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 769829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 769832 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 769837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769844 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769846 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769852 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769858 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769868 */     GIR_RootConstrainSelectedInstOperands,
     /* 769869 */     // GIR_Coverage, 6843,
     /* 769869 */     GIR_EraseRootFromParent_Done,
     /* 769870 */   // Label 10159: @769870
     /* 769870 */   GIM_Try, /*On fail goto*//*Label 10160*/ GIMT_Encode4(769979), // Rule ID 6863 //
     /* 769875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 769878 */     // MIs[0] offset
     /* 769878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769881 */     // MIs[0] format
     /* 769881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769884 */     // MIs[0] auxiliary
     /* 769884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769887 */     // MIs[0] Operand 8
     /* 769887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 769890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769897 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9820:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 769900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 769904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 769909 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 769913 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 769916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 769920 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 769923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 769928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 769933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 769938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 769941 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 769946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769953 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769955 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769961 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769967 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769977 */     GIR_RootConstrainSelectedInstOperands,
     /* 769978 */     // GIR_Coverage, 6863,
     /* 769978 */     GIR_EraseRootFromParent_Done,
     /* 769979 */   // Label 10160: @769979
     /* 769979 */   GIM_Try, /*On fail goto*//*Label 10161*/ GIMT_Encode4(770088), // Rule ID 6867 //
     /* 769984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 769987 */     // MIs[0] offset
     /* 769987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769990 */     // MIs[0] format
     /* 769990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769993 */     // MIs[0] auxiliary
     /* 769993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769996 */     // MIs[0] Operand 8
     /* 769996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 769999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770006 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 770009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 770013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 770018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 770022 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 770025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 770029 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 770032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 770037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 770050 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 770055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770062 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770070 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770076 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770086 */     GIR_RootConstrainSelectedInstOperands,
     /* 770087 */     // GIR_Coverage, 6867,
     /* 770087 */     GIR_EraseRootFromParent_Done,
     /* 770088 */   // Label 10161: @770088
     /* 770088 */   GIM_Reject,
     /* 770089 */ // Label 10149: @770089
     /* 770089 */ GIM_Reject,
     /* 770090 */ // Label 10142: @770090
     /* 770090 */ GIM_Try, /*On fail goto*//*Label 10162*/ GIMT_Encode4(771128),
     /* 770095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 770098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 770101 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 770104 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 770107 */   GIM_Try, /*On fail goto*//*Label 10163*/ GIMT_Encode4(770188), // Rule ID 6844 //
     /* 770112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 770115 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770123 */     // MIs[0] offset
     /* 770123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770126 */     // MIs[0] format
     /* 770126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770129 */     // MIs[0] auxiliary
     /* 770129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770132 */     // MIs[0] Operand 8
     /* 770132 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770150 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 770153 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770162 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770164 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770170 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770186 */     GIR_RootConstrainSelectedInstOperands,
     /* 770187 */     // GIR_Coverage, 6844,
     /* 770187 */     GIR_EraseRootFromParent_Done,
     /* 770188 */   // Label 10163: @770188
     /* 770188 */   GIM_Try, /*On fail goto*//*Label 10164*/ GIMT_Encode4(770269), // Rule ID 6868 //
     /* 770193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 770196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770204 */     // MIs[0] offset
     /* 770204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770207 */     // MIs[0] format
     /* 770207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770210 */     // MIs[0] auxiliary
     /* 770210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770213 */     // MIs[0] Operand 8
     /* 770213 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770231 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 770234 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770243 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770245 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770251 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770257 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770267 */     GIR_RootConstrainSelectedInstOperands,
     /* 770268 */     // GIR_Coverage, 6868,
     /* 770268 */     GIR_EraseRootFromParent_Done,
     /* 770269 */   // Label 10164: @770269
     /* 770269 */   GIM_Try, /*On fail goto*//*Label 10165*/ GIMT_Encode4(770350), // Rule ID 6872 //
     /* 770274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 770277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770285 */     // MIs[0] offset
     /* 770285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770288 */     // MIs[0] format
     /* 770288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770291 */     // MIs[0] auxiliary
     /* 770291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770294 */     // MIs[0] Operand 8
     /* 770294 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770312 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9820:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 770315 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770324 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770326 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770348 */     GIR_RootConstrainSelectedInstOperands,
     /* 770349 */     // GIR_Coverage, 6872,
     /* 770349 */     GIR_EraseRootFromParent_Done,
     /* 770350 */   // Label 10165: @770350
     /* 770350 */   GIM_Try, /*On fail goto*//*Label 10166*/ GIMT_Encode4(770429), // Rule ID 6846 //
     /* 770355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 770358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770362 */     // MIs[0] offset
     /* 770362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770365 */     // MIs[0] format
     /* 770365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770368 */     // MIs[0] auxiliary
     /* 770368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770371 */     // MIs[0] Operand 8
     /* 770371 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770389 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 770392 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770394 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 770396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770403 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770405 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770411 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770427 */     GIR_RootConstrainSelectedInstOperands,
     /* 770428 */     // GIR_Coverage, 6846,
     /* 770428 */     GIR_EraseRootFromParent_Done,
     /* 770429 */   // Label 10166: @770429
     /* 770429 */   GIM_Try, /*On fail goto*//*Label 10167*/ GIMT_Encode4(770508), // Rule ID 6870 //
     /* 770434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 770437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770441 */     // MIs[0] offset
     /* 770441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770444 */     // MIs[0] format
     /* 770444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770447 */     // MIs[0] auxiliary
     /* 770447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770450 */     // MIs[0] Operand 8
     /* 770450 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770468 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 770471 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770473 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 770475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770482 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770484 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770490 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770496 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770506 */     GIR_RootConstrainSelectedInstOperands,
     /* 770507 */     // GIR_Coverage, 6870,
     /* 770507 */     GIR_EraseRootFromParent_Done,
     /* 770508 */   // Label 10167: @770508
     /* 770508 */   GIM_Try, /*On fail goto*//*Label 10168*/ GIMT_Encode4(770587), // Rule ID 6874 //
     /* 770513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 770516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770520 */     // MIs[0] offset
     /* 770520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770523 */     // MIs[0] format
     /* 770523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770526 */     // MIs[0] auxiliary
     /* 770526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770529 */     // MIs[0] Operand 8
     /* 770529 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770547 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 770550 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770552 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 770554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770561 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770563 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770569 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770575 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770585 */     GIR_RootConstrainSelectedInstOperands,
     /* 770586 */     // GIR_Coverage, 6874,
     /* 770586 */     GIR_EraseRootFromParent_Done,
     /* 770587 */   // Label 10168: @770587
     /* 770587 */   GIM_Try, /*On fail goto*//*Label 10169*/ GIMT_Encode4(770658), // Rule ID 6845 //
     /* 770592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 770595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770599 */     // MIs[0] offset
     /* 770599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770602 */     // MIs[0] format
     /* 770602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770605 */     // MIs[0] auxiliary
     /* 770605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770608 */     // MIs[0] Operand 8
     /* 770608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770618 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 770621 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770623 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 770625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770632 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770634 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770656 */     GIR_RootConstrainSelectedInstOperands,
     /* 770657 */     // GIR_Coverage, 6845,
     /* 770657 */     GIR_EraseRootFromParent_Done,
     /* 770658 */   // Label 10169: @770658
     /* 770658 */   GIM_Try, /*On fail goto*//*Label 10170*/ GIMT_Encode4(770729), // Rule ID 6869 //
     /* 770663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 770666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770670 */     // MIs[0] offset
     /* 770670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770673 */     // MIs[0] format
     /* 770673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770676 */     // MIs[0] auxiliary
     /* 770676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770679 */     // MIs[0] Operand 8
     /* 770679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770689 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 770692 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770694 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 770696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770703 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770705 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770711 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770727 */     GIR_RootConstrainSelectedInstOperands,
     /* 770728 */     // GIR_Coverage, 6869,
     /* 770728 */     GIR_EraseRootFromParent_Done,
     /* 770729 */   // Label 10170: @770729
     /* 770729 */   GIM_Try, /*On fail goto*//*Label 10171*/ GIMT_Encode4(770800), // Rule ID 6873 //
     /* 770734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 770737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770741 */     // MIs[0] offset
     /* 770741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770744 */     // MIs[0] format
     /* 770744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770747 */     // MIs[0] auxiliary
     /* 770747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770750 */     // MIs[0] Operand 8
     /* 770750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770760 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9820:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 770763 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770765 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 770767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770774 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770776 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770782 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770788 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770798 */     GIR_RootConstrainSelectedInstOperands,
     /* 770799 */     // GIR_Coverage, 6873,
     /* 770799 */     GIR_EraseRootFromParent_Done,
     /* 770800 */   // Label 10171: @770800
     /* 770800 */   GIM_Try, /*On fail goto*//*Label 10172*/ GIMT_Encode4(770909), // Rule ID 6847 //
     /* 770805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 770808 */     // MIs[0] offset
     /* 770808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770811 */     // MIs[0] format
     /* 770811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770814 */     // MIs[0] auxiliary
     /* 770814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770817 */     // MIs[0] Operand 8
     /* 770817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770827 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 770830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 770834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 770839 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 770843 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 770846 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 770850 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 770853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 770858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 770871 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 770876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770883 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770885 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770891 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770897 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770907 */     GIR_RootConstrainSelectedInstOperands,
     /* 770908 */     // GIR_Coverage, 6847,
     /* 770908 */     GIR_EraseRootFromParent_Done,
     /* 770909 */   // Label 10172: @770909
     /* 770909 */   GIM_Try, /*On fail goto*//*Label 10173*/ GIMT_Encode4(771018), // Rule ID 6871 //
     /* 770914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 770917 */     // MIs[0] offset
     /* 770917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770920 */     // MIs[0] format
     /* 770920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770923 */     // MIs[0] auxiliary
     /* 770923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770926 */     // MIs[0] Operand 8
     /* 770926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770936 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 770939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 770943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 770948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 770952 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 770955 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 770959 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 770962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 770967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 770980 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 770985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770992 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771000 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771006 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771016 */     GIR_RootConstrainSelectedInstOperands,
     /* 771017 */     // GIR_Coverage, 6871,
     /* 771017 */     GIR_EraseRootFromParent_Done,
     /* 771018 */   // Label 10173: @771018
     /* 771018 */   GIM_Try, /*On fail goto*//*Label 10174*/ GIMT_Encode4(771127), // Rule ID 6875 //
     /* 771023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 771026 */     // MIs[0] offset
     /* 771026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771029 */     // MIs[0] format
     /* 771029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771032 */     // MIs[0] auxiliary
     /* 771032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771035 */     // MIs[0] Operand 8
     /* 771035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771045 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 771048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 771052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 771057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 771061 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 771064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 771068 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 771071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 771076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 771089 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 771094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771101 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771103 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771109 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771125 */     GIR_RootConstrainSelectedInstOperands,
     /* 771126 */     // GIR_Coverage, 6875,
     /* 771126 */     GIR_EraseRootFromParent_Done,
     /* 771127 */   // Label 10174: @771127
     /* 771127 */   GIM_Reject,
     /* 771128 */ // Label 10162: @771128
     /* 771128 */ GIM_Reject,
     /* 771129 */ // Label 10143: @771129
     /* 771129 */ GIM_Try, /*On fail goto*//*Label 10175*/ GIMT_Encode4(771827),
     /* 771134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 771137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 771140 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 771143 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 771146 */   GIM_Try, /*On fail goto*//*Label 10176*/ GIMT_Encode4(771227), // Rule ID 6876 //
     /* 771151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 771154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771162 */     // MIs[0] offset
     /* 771162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771165 */     // MIs[0] format
     /* 771165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771168 */     // MIs[0] auxiliary
     /* 771168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771171 */     // MIs[0] Operand 8
     /* 771171 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771189 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_OFFSET_exact anonymous_9820:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_OFFSET_exact),
     /* 771192 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771201 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771203 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771209 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771225 */     GIR_RootConstrainSelectedInstOperands,
     /* 771226 */     // GIR_Coverage, 6876,
     /* 771226 */     GIR_EraseRootFromParent_Done,
     /* 771227 */   // Label 10176: @771227
     /* 771227 */   GIM_Try, /*On fail goto*//*Label 10177*/ GIMT_Encode4(771308), // Rule ID 6880 //
     /* 771232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 771235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771243 */     // MIs[0] offset
     /* 771243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771246 */     // MIs[0] format
     /* 771246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771249 */     // MIs[0] auxiliary
     /* 771249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771252 */     // MIs[0] Operand 8
     /* 771252 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771270 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact anonymous_9820:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact),
     /* 771273 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771282 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771284 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771290 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771296 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771306 */     GIR_RootConstrainSelectedInstOperands,
     /* 771307 */     // GIR_Coverage, 6880,
     /* 771307 */     GIR_EraseRootFromParent_Done,
     /* 771308 */   // Label 10177: @771308
     /* 771308 */   GIM_Try, /*On fail goto*//*Label 10178*/ GIMT_Encode4(771387), // Rule ID 6878 //
     /* 771313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 771316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771320 */     // MIs[0] offset
     /* 771320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771323 */     // MIs[0] format
     /* 771323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771326 */     // MIs[0] auxiliary
     /* 771326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771329 */     // MIs[0] Operand 8
     /* 771329 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771347 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_OFFEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_OFFEN_exact),
     /* 771350 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771352 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 771354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771361 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771363 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771369 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771385 */     GIR_RootConstrainSelectedInstOperands,
     /* 771386 */     // GIR_Coverage, 6878,
     /* 771386 */     GIR_EraseRootFromParent_Done,
     /* 771387 */   // Label 10178: @771387
     /* 771387 */   GIM_Try, /*On fail goto*//*Label 10179*/ GIMT_Encode4(771466), // Rule ID 6882 //
     /* 771392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 771395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771399 */     // MIs[0] offset
     /* 771399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771402 */     // MIs[0] format
     /* 771402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771405 */     // MIs[0] auxiliary
     /* 771405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771408 */     // MIs[0] Operand 8
     /* 771408 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771426 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact),
     /* 771429 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771431 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 771433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771440 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771448 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771454 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771464 */     GIR_RootConstrainSelectedInstOperands,
     /* 771465 */     // GIR_Coverage, 6882,
     /* 771465 */     GIR_EraseRootFromParent_Done,
     /* 771466 */   // Label 10179: @771466
     /* 771466 */   GIM_Try, /*On fail goto*//*Label 10180*/ GIMT_Encode4(771537), // Rule ID 6877 //
     /* 771471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 771474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771478 */     // MIs[0] offset
     /* 771478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771481 */     // MIs[0] format
     /* 771481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771484 */     // MIs[0] auxiliary
     /* 771484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771487 */     // MIs[0] Operand 8
     /* 771487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771497 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_IDXEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_IDXEN_exact),
     /* 771500 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771502 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 771504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771511 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771513 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771519 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771525 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771535 */     GIR_RootConstrainSelectedInstOperands,
     /* 771536 */     // GIR_Coverage, 6877,
     /* 771536 */     GIR_EraseRootFromParent_Done,
     /* 771537 */   // Label 10180: @771537
     /* 771537 */   GIM_Try, /*On fail goto*//*Label 10181*/ GIMT_Encode4(771608), // Rule ID 6881 //
     /* 771542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 771545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771549 */     // MIs[0] offset
     /* 771549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771552 */     // MIs[0] format
     /* 771552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771555 */     // MIs[0] auxiliary
     /* 771555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771558 */     // MIs[0] Operand 8
     /* 771558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771568 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact),
     /* 771571 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771573 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 771575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771582 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771590 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771606 */     GIR_RootConstrainSelectedInstOperands,
     /* 771607 */     // GIR_Coverage, 6881,
     /* 771607 */     GIR_EraseRootFromParent_Done,
     /* 771608 */   // Label 10181: @771608
     /* 771608 */   GIM_Try, /*On fail goto*//*Label 10182*/ GIMT_Encode4(771717), // Rule ID 6879 //
     /* 771613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 771616 */     // MIs[0] offset
     /* 771616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771619 */     // MIs[0] format
     /* 771619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771622 */     // MIs[0] auxiliary
     /* 771622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771625 */     // MIs[0] Operand 8
     /* 771625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771635 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 771638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 771642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 771647 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 771651 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 771654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 771658 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 771661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 771666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact),
     /* 771679 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 771684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771691 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771705 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771715 */     GIR_RootConstrainSelectedInstOperands,
     /* 771716 */     // GIR_Coverage, 6879,
     /* 771716 */     GIR_EraseRootFromParent_Done,
     /* 771717 */   // Label 10182: @771717
     /* 771717 */   GIM_Try, /*On fail goto*//*Label 10183*/ GIMT_Encode4(771826), // Rule ID 6883 //
     /* 771722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 771725 */     // MIs[0] offset
     /* 771725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771728 */     // MIs[0] format
     /* 771728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771731 */     // MIs[0] auxiliary
     /* 771731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771734 */     // MIs[0] Operand 8
     /* 771734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771744 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact anonymous_9820:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 771747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 771751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 771756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 771760 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 771763 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 771767 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 771770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 771775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact),
     /* 771788 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 771793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771800 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771824 */     GIR_RootConstrainSelectedInstOperands,
     /* 771825 */     // GIR_Coverage, 6883,
     /* 771825 */     GIR_EraseRootFromParent_Done,
     /* 771826 */   // Label 10183: @771826
     /* 771826 */   GIM_Reject,
     /* 771827 */ // Label 10175: @771827
     /* 771827 */ GIM_Reject,
     /* 771828 */ // Label 10144: @771828
     /* 771828 */ GIM_Try, /*On fail goto*//*Label 10184*/ GIMT_Encode4(772186),
     /* 771833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 771836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 771839 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 771842 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 771845 */   GIM_Try, /*On fail goto*//*Label 10185*/ GIMT_Encode4(771926), // Rule ID 6848 //
     /* 771850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 771853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771861 */     // MIs[0] offset
     /* 771861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771864 */     // MIs[0] format
     /* 771864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771867 */     // MIs[0] auxiliary
     /* 771867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771870 */     // MIs[0] Operand 8
     /* 771870 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771888 */     // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact anonymous_9819:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact),
     /* 771891 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771900 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771902 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771908 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771914 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771924 */     GIR_RootConstrainSelectedInstOperands,
     /* 771925 */     // GIR_Coverage, 6848,
     /* 771925 */     GIR_EraseRootFromParent_Done,
     /* 771926 */   // Label 10185: @771926
     /* 771926 */   GIM_Try, /*On fail goto*//*Label 10186*/ GIMT_Encode4(772005), // Rule ID 6850 //
     /* 771931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 771934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771938 */     // MIs[0] offset
     /* 771938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771941 */     // MIs[0] format
     /* 771941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771944 */     // MIs[0] auxiliary
     /* 771944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771947 */     // MIs[0] Operand 8
     /* 771947 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771965 */     // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact),
     /* 771968 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771970 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 771972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771979 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771981 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771987 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771993 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772003 */     GIR_RootConstrainSelectedInstOperands,
     /* 772004 */     // GIR_Coverage, 6850,
     /* 772004 */     GIR_EraseRootFromParent_Done,
     /* 772005 */   // Label 10186: @772005
     /* 772005 */   GIM_Try, /*On fail goto*//*Label 10187*/ GIMT_Encode4(772076), // Rule ID 6849 //
     /* 772010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772017 */     // MIs[0] offset
     /* 772017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772020 */     // MIs[0] format
     /* 772020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772023 */     // MIs[0] auxiliary
     /* 772023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772026 */     // MIs[0] Operand 8
     /* 772026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772036 */     // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact),
     /* 772039 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772041 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 772043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772050 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772052 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772058 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772074 */     GIR_RootConstrainSelectedInstOperands,
     /* 772075 */     // GIR_Coverage, 6849,
     /* 772075 */     GIR_EraseRootFromParent_Done,
     /* 772076 */   // Label 10187: @772076
     /* 772076 */   GIM_Try, /*On fail goto*//*Label 10188*/ GIMT_Encode4(772185), // Rule ID 6851 //
     /* 772081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772084 */     // MIs[0] offset
     /* 772084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772087 */     // MIs[0] format
     /* 772087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772090 */     // MIs[0] auxiliary
     /* 772090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772093 */     // MIs[0] Operand 8
     /* 772093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772103 */     // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact anonymous_9819:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 772106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 772110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 772115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 772119 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 772122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 772126 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 772129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 772134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 772139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 772144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact),
     /* 772147 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 772152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772159 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772161 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772167 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772173 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772183 */     GIR_RootConstrainSelectedInstOperands,
     /* 772184 */     // GIR_Coverage, 6851,
     /* 772184 */     GIR_EraseRootFromParent_Done,
     /* 772185 */   // Label 10188: @772185
     /* 772185 */   GIM_Reject,
     /* 772186 */ // Label 10184: @772186
     /* 772186 */ GIM_Reject,
     /* 772187 */ // Label 10145: @772187
     /* 772187 */ GIM_Try, /*On fail goto*//*Label 10189*/ GIMT_Encode4(772545),
     /* 772192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 772195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 772198 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 772201 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 772204 */   GIM_Try, /*On fail goto*//*Label 10190*/ GIMT_Encode4(772285), // Rule ID 6852 //
     /* 772209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772220 */     // MIs[0] offset
     /* 772220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772223 */     // MIs[0] format
     /* 772223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772226 */     // MIs[0] auxiliary
     /* 772226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772229 */     // MIs[0] Operand 8
     /* 772229 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772247 */     // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact anonymous_9818:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact),
     /* 772250 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772259 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772261 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772273 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772283 */     GIR_RootConstrainSelectedInstOperands,
     /* 772284 */     // GIR_Coverage, 6852,
     /* 772284 */     GIR_EraseRootFromParent_Done,
     /* 772285 */   // Label 10190: @772285
     /* 772285 */   GIM_Try, /*On fail goto*//*Label 10191*/ GIMT_Encode4(772364), // Rule ID 6854 //
     /* 772290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772297 */     // MIs[0] offset
     /* 772297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772300 */     // MIs[0] format
     /* 772300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772303 */     // MIs[0] auxiliary
     /* 772303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772306 */     // MIs[0] Operand 8
     /* 772306 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772324 */     // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact),
     /* 772327 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772329 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 772331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772338 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772340 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772346 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772352 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772362 */     GIR_RootConstrainSelectedInstOperands,
     /* 772363 */     // GIR_Coverage, 6854,
     /* 772363 */     GIR_EraseRootFromParent_Done,
     /* 772364 */   // Label 10191: @772364
     /* 772364 */   GIM_Try, /*On fail goto*//*Label 10192*/ GIMT_Encode4(772435), // Rule ID 6853 //
     /* 772369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772376 */     // MIs[0] offset
     /* 772376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772379 */     // MIs[0] format
     /* 772379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772382 */     // MIs[0] auxiliary
     /* 772382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772385 */     // MIs[0] Operand 8
     /* 772385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772395 */     // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact),
     /* 772398 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772400 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 772402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772409 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772411 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772423 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772433 */     GIR_RootConstrainSelectedInstOperands,
     /* 772434 */     // GIR_Coverage, 6853,
     /* 772434 */     GIR_EraseRootFromParent_Done,
     /* 772435 */   // Label 10192: @772435
     /* 772435 */   GIM_Try, /*On fail goto*//*Label 10193*/ GIMT_Encode4(772544), // Rule ID 6855 //
     /* 772440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 772443 */     // MIs[0] offset
     /* 772443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772446 */     // MIs[0] format
     /* 772446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772449 */     // MIs[0] auxiliary
     /* 772449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772452 */     // MIs[0] Operand 8
     /* 772452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772462 */     // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact anonymous_9818:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 772465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 772469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 772474 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 772478 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 772481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 772485 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 772488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 772493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 772498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 772503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact),
     /* 772506 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 772511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772518 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772520 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772526 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772532 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772542 */     GIR_RootConstrainSelectedInstOperands,
     /* 772543 */     // GIR_Coverage, 6855,
     /* 772543 */     GIR_EraseRootFromParent_Done,
     /* 772544 */   // Label 10193: @772544
     /* 772544 */   GIM_Reject,
     /* 772545 */ // Label 10189: @772545
     /* 772545 */ GIM_Reject,
     /* 772546 */ // Label 10146: @772546
     /* 772546 */ GIM_Try, /*On fail goto*//*Label 10194*/ GIMT_Encode4(773244),
     /* 772551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 772554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 772557 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 772560 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 772563 */   GIM_Try, /*On fail goto*//*Label 10195*/ GIMT_Encode4(772644), // Rule ID 6892 //
     /* 772568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 772571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772579 */     // MIs[0] offset
     /* 772579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772582 */     // MIs[0] format
     /* 772582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772585 */     // MIs[0] auxiliary
     /* 772585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772588 */     // MIs[0] Operand 8
     /* 772588 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772606 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact anonymous_9819:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact),
     /* 772609 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772618 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772620 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772626 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772632 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772642 */     GIR_RootConstrainSelectedInstOperands,
     /* 772643 */     // GIR_Coverage, 6892,
     /* 772643 */     GIR_EraseRootFromParent_Done,
     /* 772644 */   // Label 10195: @772644
     /* 772644 */   GIM_Try, /*On fail goto*//*Label 10196*/ GIMT_Encode4(772725), // Rule ID 6896 //
     /* 772649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 772652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772660 */     // MIs[0] offset
     /* 772660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772663 */     // MIs[0] format
     /* 772663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772666 */     // MIs[0] auxiliary
     /* 772666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772669 */     // MIs[0] Operand 8
     /* 772669 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772687 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact anonymous_9819:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact),
     /* 772690 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772699 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772701 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772707 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772713 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772723 */     GIR_RootConstrainSelectedInstOperands,
     /* 772724 */     // GIR_Coverage, 6896,
     /* 772724 */     GIR_EraseRootFromParent_Done,
     /* 772725 */   // Label 10196: @772725
     /* 772725 */   GIM_Try, /*On fail goto*//*Label 10197*/ GIMT_Encode4(772804), // Rule ID 6894 //
     /* 772730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 772733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772737 */     // MIs[0] offset
     /* 772737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772740 */     // MIs[0] format
     /* 772740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772743 */     // MIs[0] auxiliary
     /* 772743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772746 */     // MIs[0] Operand 8
     /* 772746 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772764 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact),
     /* 772767 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772769 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 772771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772778 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772786 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772792 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772802 */     GIR_RootConstrainSelectedInstOperands,
     /* 772803 */     // GIR_Coverage, 6894,
     /* 772803 */     GIR_EraseRootFromParent_Done,
     /* 772804 */   // Label 10197: @772804
     /* 772804 */   GIM_Try, /*On fail goto*//*Label 10198*/ GIMT_Encode4(772883), // Rule ID 6898 //
     /* 772809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 772812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772816 */     // MIs[0] offset
     /* 772816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772819 */     // MIs[0] format
     /* 772819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772822 */     // MIs[0] auxiliary
     /* 772822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772825 */     // MIs[0] Operand 8
     /* 772825 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772843 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact),
     /* 772846 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772848 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 772850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772857 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772859 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772865 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772871 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772881 */     GIR_RootConstrainSelectedInstOperands,
     /* 772882 */     // GIR_Coverage, 6898,
     /* 772882 */     GIR_EraseRootFromParent_Done,
     /* 772883 */   // Label 10198: @772883
     /* 772883 */   GIM_Try, /*On fail goto*//*Label 10199*/ GIMT_Encode4(772954), // Rule ID 6893 //
     /* 772888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 772891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772895 */     // MIs[0] offset
     /* 772895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772898 */     // MIs[0] format
     /* 772898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772901 */     // MIs[0] auxiliary
     /* 772901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772904 */     // MIs[0] Operand 8
     /* 772904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772914 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact),
     /* 772917 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772919 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 772921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772928 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772930 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772936 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772942 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772952 */     GIR_RootConstrainSelectedInstOperands,
     /* 772953 */     // GIR_Coverage, 6893,
     /* 772953 */     GIR_EraseRootFromParent_Done,
     /* 772954 */   // Label 10199: @772954
     /* 772954 */   GIM_Try, /*On fail goto*//*Label 10200*/ GIMT_Encode4(773025), // Rule ID 6897 //
     /* 772959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 772962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772966 */     // MIs[0] offset
     /* 772966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772969 */     // MIs[0] format
     /* 772969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772972 */     // MIs[0] auxiliary
     /* 772972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772975 */     // MIs[0] Operand 8
     /* 772975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772985 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact),
     /* 772988 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772990 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 772992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772999 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773001 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773007 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773013 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773023 */     GIR_RootConstrainSelectedInstOperands,
     /* 773024 */     // GIR_Coverage, 6897,
     /* 773024 */     GIR_EraseRootFromParent_Done,
     /* 773025 */   // Label 10200: @773025
     /* 773025 */   GIM_Try, /*On fail goto*//*Label 10201*/ GIMT_Encode4(773134), // Rule ID 6895 //
     /* 773030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 773033 */     // MIs[0] offset
     /* 773033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773036 */     // MIs[0] format
     /* 773036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773039 */     // MIs[0] auxiliary
     /* 773039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773042 */     // MIs[0] Operand 8
     /* 773042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 773045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773052 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 773055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 773059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 773064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 773068 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 773071 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 773075 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 773078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 773083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact),
     /* 773096 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 773101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773108 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773110 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773116 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773122 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773132 */     GIR_RootConstrainSelectedInstOperands,
     /* 773133 */     // GIR_Coverage, 6895,
     /* 773133 */     GIR_EraseRootFromParent_Done,
     /* 773134 */   // Label 10201: @773134
     /* 773134 */   GIM_Try, /*On fail goto*//*Label 10202*/ GIMT_Encode4(773243), // Rule ID 6899 //
     /* 773139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 773142 */     // MIs[0] offset
     /* 773142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773145 */     // MIs[0] format
     /* 773145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773148 */     // MIs[0] auxiliary
     /* 773148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773151 */     // MIs[0] Operand 8
     /* 773151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 773154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773161 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact anonymous_9819:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 773164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 773168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 773173 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 773177 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 773180 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 773184 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 773187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 773192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact),
     /* 773205 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 773210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773217 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773219 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773225 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773231 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773241 */     GIR_RootConstrainSelectedInstOperands,
     /* 773242 */     // GIR_Coverage, 6899,
     /* 773242 */     GIR_EraseRootFromParent_Done,
     /* 773243 */   // Label 10202: @773243
     /* 773243 */   GIM_Reject,
     /* 773244 */ // Label 10194: @773244
     /* 773244 */ GIM_Reject,
     /* 773245 */ // Label 10147: @773245
     /* 773245 */ GIM_Try, /*On fail goto*//*Label 10203*/ GIMT_Encode4(773603),
     /* 773250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 773253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 773256 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 773259 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 773262 */   GIM_Try, /*On fail goto*//*Label 10204*/ GIMT_Encode4(773343), // Rule ID 6856 //
     /* 773267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 773270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 773278 */     // MIs[0] offset
     /* 773278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773281 */     // MIs[0] format
     /* 773281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773284 */     // MIs[0] auxiliary
     /* 773284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773287 */     // MIs[0] Operand 8
     /* 773287 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773305 */     // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact anonymous_9817:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact),
     /* 773308 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773317 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773319 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773325 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773331 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773341 */     GIR_RootConstrainSelectedInstOperands,
     /* 773342 */     // GIR_Coverage, 6856,
     /* 773342 */     GIR_EraseRootFromParent_Done,
     /* 773343 */   // Label 10204: @773343
     /* 773343 */   GIM_Try, /*On fail goto*//*Label 10205*/ GIMT_Encode4(773422), // Rule ID 6858 //
     /* 773348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 773351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773355 */     // MIs[0] offset
     /* 773355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773358 */     // MIs[0] format
     /* 773358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773361 */     // MIs[0] auxiliary
     /* 773361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773364 */     // MIs[0] Operand 8
     /* 773364 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773382 */     // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact),
     /* 773385 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773387 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 773389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773396 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773398 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773404 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773420 */     GIR_RootConstrainSelectedInstOperands,
     /* 773421 */     // GIR_Coverage, 6858,
     /* 773421 */     GIR_EraseRootFromParent_Done,
     /* 773422 */   // Label 10205: @773422
     /* 773422 */   GIM_Try, /*On fail goto*//*Label 10206*/ GIMT_Encode4(773493), // Rule ID 6857 //
     /* 773427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 773430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 773434 */     // MIs[0] offset
     /* 773434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773437 */     // MIs[0] format
     /* 773437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773440 */     // MIs[0] auxiliary
     /* 773440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773443 */     // MIs[0] Operand 8
     /* 773443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 773446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773453 */     // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact),
     /* 773456 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773458 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 773460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773467 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773469 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773475 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773481 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773491 */     GIR_RootConstrainSelectedInstOperands,
     /* 773492 */     // GIR_Coverage, 6857,
     /* 773492 */     GIR_EraseRootFromParent_Done,
     /* 773493 */   // Label 10206: @773493
     /* 773493 */   GIM_Try, /*On fail goto*//*Label 10207*/ GIMT_Encode4(773602), // Rule ID 6859 //
     /* 773498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 773501 */     // MIs[0] offset
     /* 773501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773504 */     // MIs[0] format
     /* 773504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773507 */     // MIs[0] auxiliary
     /* 773507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773510 */     // MIs[0] Operand 8
     /* 773510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 773513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773520 */     // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact anonymous_9817:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 773523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 773527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 773532 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 773536 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 773539 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 773543 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 773546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 773551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact),
     /* 773564 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 773569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773576 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773578 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773590 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773600 */     GIR_RootConstrainSelectedInstOperands,
     /* 773601 */     // GIR_Coverage, 6859,
     /* 773601 */     GIR_EraseRootFromParent_Done,
     /* 773602 */   // Label 10207: @773602
     /* 773602 */   GIM_Reject,
     /* 773603 */ // Label 10203: @773603
     /* 773603 */ GIM_Reject,
     /* 773604 */ // Label 10148: @773604
     /* 773604 */ GIM_Reject,
     /* 773605 */ // Label 166: @773605
     /* 773605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 10210*/ GIMT_Encode4(773910),
     /* 773616 */ /*GILLT_s16*//*Label 10208*/ GIMT_Encode4(773624),
     /* 773620 */ /*GILLT_s32*//*Label 10209*/ GIMT_Encode4(773868),
     /* 773624 */ // Label 10208: @773624
     /* 773624 */ GIM_Try, /*On fail goto*//*Label 10211*/ GIMT_Encode4(773867),
     /* 773629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 773632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 773635 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 773638 */   GIM_Try, /*On fail goto*//*Label 10212*/ GIMT_Encode4(773714), // Rule ID 1027 //
     /* 773643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 773646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 773657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 773664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 773671 */     // (AMDGPUumed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_U16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 773671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 773674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 773676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 773681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 773686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 773691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 773696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 773701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 773706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 773709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 773712 */     GIR_RootConstrainSelectedInstOperands,
     /* 773713 */     // GIR_Coverage, 1027,
     /* 773713 */     GIR_EraseRootFromParent_Done,
     /* 773714 */   // Label 10212: @773714
     /* 773714 */   GIM_Try, /*On fail goto*//*Label 10213*/ GIMT_Encode4(773790), // Rule ID 1028 //
     /* 773719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 773722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 773726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 773733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 773740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 773747 */     // (AMDGPUumed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 773747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 773750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 773752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 773757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 773762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 773767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 773772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 773777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 773782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 773785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 773788 */     GIR_RootConstrainSelectedInstOperands,
     /* 773789 */     // GIR_Coverage, 1028,
     /* 773789 */     GIR_EraseRootFromParent_Done,
     /* 773790 */   // Label 10213: @773790
     /* 773790 */   GIM_Try, /*On fail goto*//*Label 10214*/ GIMT_Encode4(773866), // Rule ID 1029 //
     /* 773795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 773798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 773809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 773816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 773823 */     // (AMDGPUumed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 773823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 773826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 773828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 773833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 773838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 773843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 773848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 773853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 773858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 773861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 773864 */     GIR_RootConstrainSelectedInstOperands,
     /* 773865 */     // GIR_Coverage, 1029,
     /* 773865 */     GIR_EraseRootFromParent_Done,
     /* 773866 */   // Label 10214: @773866
     /* 773866 */   GIM_Reject,
     /* 773867 */ // Label 10211: @773867
     /* 773867 */ GIM_Reject,
     /* 773868 */ // Label 10209: @773868
     /* 773868 */ GIM_Try, /*On fail goto*//*Label 10215*/ GIMT_Encode4(773909), // Rule ID 968 //
     /* 773873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 773876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 773879 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 773882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773886 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 773893 */   // (AMDGPUumed3:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_MED3_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 773893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 773896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 773898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 773903 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 773905 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 773907 */   GIR_RootConstrainSelectedInstOperands,
     /* 773908 */   // GIR_Coverage, 968,
     /* 773908 */   GIR_EraseRootFromParent_Done,
     /* 773909 */ // Label 10215: @773909
     /* 773909 */ GIM_Reject,
     /* 773910 */ // Label 10210: @773910
     /* 773910 */ GIM_Reject,
     /* 773911 */ // Label 167: @773911
     /* 773911 */ GIM_Reject,
     /* 773912 */ }; // Size: 773912 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
